prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4903
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4903 - Oracle APEX Websheets
--
-- Application Export:
--   Application:     4903
--   Name:            Oracle APEX Websheets
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                    109
--       Items:                  517
--       Computations:            59
--       Validations:            101
--       Processes:              131
--       Regions:                496
--       Buttons:                224
--       Dynamic Actions:         47
--     Shared Components:
--       Logic:
--         Items:                 29
--         Processes:             13
--         Computations:           5
--         Build Options:          1
--       Navigation:
--         Lists:                 23
--         Breadcrumbs:            1
--           Entries:             78
--         NavBar Entries:         5
--       Security:
--         Authentication:         1
--         Authorization:         11
--       User Interface:
--         Templates:
--           Page:                11
--           Region:              22
--           Label:                5
--           List:                14
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:              20
--           Report:               4
--         LOVs:                 118
--         Shortcuts:              8
--         Plug-ins:               6
--       Globalization:
--         Messages:              30
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Websheets')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110312508068375193')
,p_page_view_logging=>'YES'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110922'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'de'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'DS'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_publish_yn=>'Y'
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(709672827800503408.4903)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'T'
,p_logo_text=>'Application Express'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'S'
,p_deep_linking=>'Y'
,p_vpd=>'wwv_flow_ws_auth.init_schema;'
,p_security_scheme=>wwv_flow_api.id(612254693942923247)
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_friendly_url=>'N'
,p_substitution_string_01=>'MSG_LANGUAGE'
,p_substitution_value_01=>'Sprache'
,p_substitution_string_02=>'MSG_USER'
,p_substitution_value_02=>'Benutzer'
,p_substitution_string_03=>'DELETE_MSG'
,p_substitution_value_03=>unistr('Soll dieser L\00F6schvorgang ausgef\00FChrt werden?')
,p_substitution_string_04=>'PRODUCT_NAME'
,p_substitution_value_04=>'Oracle APEX'
,p_substitution_string_05=>'VIEW'
,p_substitution_value_05=>'Ansicht'
,p_substitution_string_06=>'MSG_JSCRIPT'
,p_substitution_value_06=>unistr('Wenn Sie dieses Produkt ausf\00FChren, muss JavaScript aktiviert sein.')
,p_substitution_string_07=>'CLOSE_MESSAGE'
,p_substitution_value_07=>unistr('Meldung schlie\00DFen')
,p_substitution_string_08=>'GO_TO_TOP'
,p_substitution_value_08=>'Zum Anfang gehen'
,p_substitution_string_09=>'COLLAPSE'
,p_substitution_value_09=>'Ausblenden'
,p_substitution_string_10=>'EDIT'
,p_substitution_value_10=>'Bearbeiten'
,p_substitution_string_11=>'EXPANDED'
,p_substitution_value_11=>'Eingeblendet'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112907'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/edit_sections
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(15661014418081294.4903)
,p_name=>'Edit Sections'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 as level_value',
'	, c001 label_value',
'	, ''f?p=''||:APP_ID||'':''||:APP_PAGE_ID||'':''||:APP_SESSION target',
'	, null is_current_list_entry',
'	, null image',
'	, null image_attribute',
'	, null image_alt_attribute',
'	, lower(c002)||''Icon'' attribute1',
'	, wwv_flow_item.text_from_lov(c002,''SECTION TYPES'') attribute2',
'	, lower(decode(c005,null,c004,c005)) attribute3',
'	, htmldb_util.get_since(decode(d001,null,d002,d001)) attribute4',
'	, case when c002 = ''TEXT'' and :APP_PAGE_ID = 930 and n003 = :P930_SECTION_ID then ''active''',
'	       when c002 = ''NAV_PAGE'' and :APP_PAGE_ID = 931 and n003 = :P931_SECTION_ID then ''active''',
'	       when c002 = ''NAV_SECTION'' and :APP_PAGE_ID = 932 and n003 = :P932_SECTION_ID then ''active''',
'	       when c002 = ''CHART'' and :APP_PAGE_ID = 760 and n003 = :P760_SECTION_ID then ''active''',
'	       when c002 = ''DATA'' and :APP_PAGE_ID = 934 and n003 = :P934_SECTION_ID then ''active''',
'	       when c002 = ''PLSQL'' and :APP_PAGE_ID = 23 and n003 = :P23_SECTION_ID then ''active''',
'	       when :APP_PAGE_ID = 991 and n003 = :SECTION_ID then ''active''',
'               when :APP_PAGE_ID = 990 and n003 = :SECTION_ID then ''active''	  ',
'	  end attribute5        ',
'    , c006 attribute6 -- next page id',
'    , c007 attribute7 -- next section page item name to hold section id',
'    , n003 attribute8 -- next section id',
'    , n002 display_sequence',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_PAGE_SECTIONS''',
'order by n002'))
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/sections_settings_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(17135113310000767.4903)
,p_name=>'Sections Settings Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18785810240539012.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Abschnitt in andere Seite verschieben'
,p_list_item_link_target=>'f?p=&APP_ID.:990:&SESSION.::&DEBUG.::P990_SECTION_ID,P990_PAGE_ID:&SECTION_ID.,&P900_ID.:'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18786123053542660.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Abschnitt in neue Seite verschieben'
,p_list_item_link_target=>'f?p=&APP_ID.:991:&SESSION.::&DEBUG.:991:P991_SECTION_ID,P991_PAGE_ID:&SECTION_ID.,&P900_ID.:'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18786329979544670.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Abschnittshistorie anzeigen'
,p_list_item_link_target=>'f?p=&APP_ID.:950:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(17154020760040710.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Mehrere Abschnitt bearbeiten'
,p_list_item_link_target=>'f?p=&APP_ID.:940:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'NEVER'
);
end;
/
prompt --application/shared_components/navigation/lists/edit_pages
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(18529824151546479.4903)
,p_name=>'Edit Pages'
,p_list_type=>'FUNCTION_RETURNING_SQL_QUERY'
,p_list_language=>'PLSQL'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q               varchar2(32767) := null;',
'    l_parent_page_id number := null;',
'begin      ',
'    for c1 in (select parent_page_id',
'               from wwv_flow_ws_webpages',
'               where ws_app_id = :ws_app_id',
'               and security_group_id = :flow_security_group_id',
'               and id =:P53_ID)',
'    loop',
'        l_parent_page_id := c1.parent_page_id;',
'    end loop;    ',
'    ',
'    q := ''select level ''||',
'         ''	, name label ''||',
'         ''  , ''''javascript:applyAndGoToNextPage(''''''''''''||id||'''''''''''')'''' target ''||         ',
'         ''	, null is_current_list_entry ''||',
'         ''	, null image ''||',
'         ''	, null image_attribute ''||',
'         ''	, null image_alt_attribute ''||',
'         ''	, lower(decode(updated_by,null,created_by,updated_by)) attribute1 ''||',
'         ''	, htmldb_util.get_since(decode(updated_on,null,created_on,updated_on)) attribute2 ''||',
'         ''	, case when id = :P53_ID then ''''active'''' end attribute3 ''||',
'         ''from wwv_flow_ws_webpages ''||',
'         ''where security_group_id = :FLOW_SECURITY_GROUP_ID ''||',
'         ''and ws_app_id = :WS_APP_ID '';',
'         --''and level    <= 2 '';',
'    ',
'    if l_parent_page_id is null then',
'        q:=q||''start with parent_page_id is null '';',
'    else',
'        q:=q||''start with id = ''||l_parent_page_id;        ',
'    end if; ',
'',
'    q:=q||''connect by prior id = parent_page_id '';',
'    q:=q||''order siblings by name'';        ',
'    ',
'    return q;',
'end;'))
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/shared_components/navigation/lists/pages_settings_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(18583325957802446.4903)
,p_name=>'Pages Settings Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18583829450802448.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Neue Seite'
,p_list_item_link_target=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:200:P200_PARENT_PAGE,WS_APP_ID:&P900_ID.,&WS_APP_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(18584127738802448.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Neue Seite als Kopie'
,p_list_item_link_target=>'f?p=&APP_ID.:908:&SESSION.::&DEBUG.:908:WS_APP_ID,P908_COPY_PAGE_FROM,P900_ID:&WS_APP_ID.,&P900_ID.,&P900_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity_tab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(23689225706066046.4903)
,p_name=>'Monitor Activity Tab'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23689400293066047.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Seitenansichten'
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'18'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23689719692066048.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Topseiten'
,p_list_item_link_target=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'24'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23690031914066048.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Topdaten-Grids'
,p_list_item_link_target=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.::::	'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'141'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23690308632066049.4903)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Topberichte'
,p_list_item_link_target=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'142'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23690603303066049.4903)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Topbenutzer'
,p_list_item_link_target=>'f?p=&APP_ID.:146:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'146'
);
end;
/
prompt --application/shared_components/navigation/lists/admin_annotations_tab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(23775330395531080.4903)
,p_name=>'Admin Annotations Tab'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23775513281531081.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Topdateien'
,p_list_item_link_target=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'143'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23775818182531082.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Tophinweise'
,p_list_item_link_target=>'f?p=&APP_ID.:144:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'144'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(23776108748531082.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Top-Tags'
,p_list_item_link_target=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'145'
);
end;
/
prompt --application/shared_components/navigation/lists/create_page_progress_bar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(29874807106517169.4903)
,p_name=>'create page progress bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(173227427841861244.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Komponententyp'
,p_list_item_link_target=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'131'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(29885520930644174.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Erstellmethode'
,p_list_item_link_target=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'205'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(29885725086645395.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Eigenschaften'
,p_list_item_link_target=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:201:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'201,206'
);
end;
/
prompt --application/shared_components/navigation/lists/create_section_progress_bar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(174369523339947712.4903)
,p_name=>'create section progress bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(174370314120954487.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Abschnittstyp ausw\00E4hlen')
,p_list_item_link_target=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'920'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(178563610566182386.4903)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Navigationstyp'
,p_list_item_link_target=>'f?p=&APP_ID.:926:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'921,926,927'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'926'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(178522522266580262.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Datenquelle'
,p_list_item_link_target=>'f?p=&APP_ID.:922:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'922,925'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'922'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(174370522431956915.4903)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Abschnitt definieren'
,p_list_item_link_target=>'f?p=&APP_ID.:910:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'910,921,927,925'
);
end;
/
prompt --application/shared_components/navigation/lists/annotation_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(178837028298310188.4903)
,p_name=>'annotation tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(187173101861909018.4903)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Alle'
,p_list_item_link_target=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'906'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(178837317622310200.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dateien'
,p_list_item_link_target=>'f?p=&APP_ID.:903:&SESSION.::&DEBUG.:APEX$_WS_FILES:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'903'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(178838019750310282.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Hinweise'
,p_list_item_link_target=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'905'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(473073917597603316.4903)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Links'
,p_list_item_link_target=>'f?p=&APP_ID.:915:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'915'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(178837724276310282.4903)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Tags'
,p_list_item_link_target=>'f?p=&APP_ID.:904:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'904'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(458964205010652503.4903)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Tag-Cloud'
,p_list_item_link_target=>'f?p=&APP_ID.:928:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'928'
);
end;
/
prompt --application/shared_components/navigation/lists/create_report_progress_bar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(181250307256073810.4903)
,p_name=>'create report progress bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(181310223288910949.4903)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Komponententyp'
,p_list_item_link_target=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'131'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(181259832284137754.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Berichtsattribute'
,p_list_item_link_target=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1310'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(181272207059234540.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('Best\00E4tigen')
,p_list_item_link_target=>'f?p=&APP_ID.:1320:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1320'
);
end;
/
prompt --application/shared_components/navigation/lists/p_902_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(187087619151586620.4903)
,p_name=>'p 902 tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(187087931306586621.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Alle'
,p_list_item_link_target=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.::P902_SHOW:ALL:'
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_list_item_current_type=>'EXISTS'
,p_list_item_current_for_pages=>'select 1 from dual where nvl(:P902_SHOW,''ALL'') = ''ALL'''
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(187088302932586621.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Daten-Grids'
,p_list_item_link_target=>'f?p=4900:902:&SESSION.::::P902_SHOW:DATAGRID'
,p_list_item_current_type=>'EXISTS'
,p_list_item_current_for_pages=>'select 1 from dual where :P902_SHOW = ''DATAGRID'''
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(187088713953586622.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Berichte'
,p_list_item_link_target=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.::P902_SHOW:REPORT:'
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_list_item_current_type=>'EXISTS'
,p_list_item_current_for_pages=>'select 1 from dual where :P902_SHOW = ''REPORT'''
);
end;
/
prompt --application/shared_components/navigation/lists/admin_toolbar_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(202684424744514793.4903)
,p_name=>'Admin Toolbar Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202686125516514795.4903)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Administration'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:APP_USER,''nobody'') not in (''APEX_PUBLIC_USER'',''HTMLDB_PUBLIC_USER'',''ANONYMOUS'',''nobody'',''PUBLIC_USER'') then',
'  if wwv_flow_ws_security.current_user_is_admin or wwv_flow_ws_api.show_reset_password(p_ws_app_id => :ws_app_id) then',
'      return true;',
'  else',
'      return false;',
'  end if;',
'else',
'  return false;',
'end if;'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202688803947514796.4903)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4903)
,p_list_text_01=>'ws-admin-dashboard'
,p_list_text_05=>'Alt+B'
,p_security_scheme=>wwv_flow_api.id(456220816180174638)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202692116934514798.4903)
,p_list_item_display_sequence=>280
,p_list_item_link_text=>unistr('Aktivit\00E4t \00FCberwachen')
,p_list_item_link_target=>'f?p=&APP_ID.:140:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4903)
,p_list_text_01=>'ws-admin-monitor'
,p_list_text_05=>'Alt+M'
,p_security_scheme=>wwv_flow_api.id(456220816180174638)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202692413363514798.4903)
,p_list_item_display_sequence=>290
,p_list_item_link_text=>'Websheet-Eigenschaften'
,p_list_item_link_target=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.:1250:P1250_ID:&WS_APP_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4903)
,p_list_text_01=>'ws-admin-properties'
,p_list_text_05=>'Alt+P'
,p_security_scheme=>wwv_flow_api.id(456220816180174638)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202692709697514798.4903)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'Zugriffskontrolle'
,p_list_item_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4903)
,p_list_text_01=>'ws-admin-acl'
,p_list_text_05=>'Alt+X'
,p_security_scheme=>wwv_flow_api.id(456220816180174638)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(212953623410993837.4903)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'--'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4903)
,p_list_text_01=>'wsMenuSep'
,p_security_scheme=>wwv_flow_api.id(506060600392166972)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(202693609322514799.4903)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>unistr('Mein Kennwort \00E4ndern')
,p_list_item_link_target=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:5:::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(202686125516514795.4903)
,p_security_scheme=>wwv_flow_api.id(506060600392166972)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_chart_section_progress_bar
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(261469429368022853.4903)
,p_name=>'create chart section progress bar'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(261470512876027512.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Abschnittstyp'
,p_list_item_link_target=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'920'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(261470821880030114.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Diagrammtyp'
,p_list_item_link_target=>'f?p=&APP_ID.:710:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'710'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(261471504481044080.4903)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Diagrammquelle'
,p_list_item_link_target=>'f?p=&APP_ID.:740:&SESSION.::&DEBUG.::::'
,p_list_item_disp_condition2=>'DATA_GRID'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'740:745'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(261471828030050875.4903)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Diagrammdefinition'
,p_list_item_link_target=>'f?p=&APP_ID.:742:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'742'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(261472414655056417.4903)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Erstellen'
,p_list_item_link_target=>'f?p=&APP_ID.:750:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'750'
);
end;
/
prompt --application/shared_components/navigation/lists/help_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(456471813385447055.4903)
,p_name=>'Help Tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(472810017189623092.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Info'
,p_list_item_link_target=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'16'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(456472503328447058.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('\00DCberblick')
,p_list_item_link_target=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'15'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(619280916964076011.4903)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Zugriffskontrolle'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'6'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(456472932226447059.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Markup-Syntax'
,p_list_item_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'17'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(6247915223597961.4903)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Daten-Grid'
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491253712635289676.4903)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'Anwendungsinhalt'
,p_list_item_link_target=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'25,27,28,29,30,12'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(487175029602607075.4903)
,p_list_item_display_sequence=>999
,p_list_item_link_text=>unistr('H\00E4ufig gestellte Fragen (FAQ)')
,p_list_item_link_target=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'19'
);
end;
/
prompt --application/shared_components/navigation/lists/administration_menu_options
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(457230629124432618.4903)
,p_name=>'administration menu options'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457230905908432621.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'ws/ws-dashboard.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457231305495432622.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Aktivit\00E4t \00FCberwachen')
,p_list_item_link_target=>'f?p=&APP_ID.:140:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'ws/ws-chart.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'140'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457232713110446916.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Websheet-Eigenschaften'
,p_list_item_link_target=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.:1250:P1250_ID:&WS_APP_ID.:'
,p_list_item_icon=>'ws/ws-properties.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457321625061188359.4903)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Zugriffskontrolle'
,p_list_item_link_target=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'ws/ws-access-control.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_menu_options
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(457456818808085338.4903)
,p_name=>'Page Menu Options'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457458705480119260.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Homepage'
,p_list_item_link_target=>'ws?p=&WS_APP_ID.:home:&SESSION.'
,p_list_item_icon=>'apex/builder/menu-home-128.gif'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457457112971085339.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Seitenverzeichnis'
,p_list_item_link_target=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex/builder/menu-page-dir-128.gif'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457468208784233794.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Historie anzeigen'
,p_list_item_link_target=>'f?p=&APP_ID.:950:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex/builder/menu-change-log-128.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(457482932080297318.4903)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Neue Seite erstellen'
,p_list_item_link_target=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:200:::'
,p_list_item_icon=>'apex/builder/menu-add-page-128.png'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/monitor_activity
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(459634320543429042.4903)
,p_name=>'Monitor Activity'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(459634600866429048.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Seitenansichten'
,p_list_item_link_target=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'18'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471679808716623953.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Topseiten'
,p_list_item_link_target=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'18'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471680625685628854.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Topdaten-Grids'
,p_list_item_link_target=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.::::	'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'141'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471681413003634676.4903)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Topberichte'
,p_list_item_link_target=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'142'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471917315656277818.4903)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Topbenutzer'
,p_list_item_link_target=>'f?p=&APP_ID.:146:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_icon_attributes=>'width="20" height="20" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'142'
);
end;
/
prompt --application/shared_components/navigation/lists/annotations
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(461178801985335895.4903)
,p_name=>'Annotations'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(461179122466335896.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Topdateien'
,p_list_item_link_target=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'140'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(461179526172335897.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Tophinweise'
,p_list_item_link_target=>'f?p=&APP_ID.:144:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'140'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(461179925451335897.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Top-Tags'
,p_list_item_link_target=>'f?p=&APP_ID.:145:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_build_options.png'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'140'
);
end;
/
prompt --application/shared_components/navigation/lists/page_directory
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(461346705230446581.4903)
,p_name=>'Page Directory'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(461347024629446628.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Seitenverzeichnis'
,p_list_item_link_target=>'f?p=&APP_ID.:1000:&SESSION.:'
,p_list_item_current_for_pages=>'1000'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(461347428128446630.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Websheet-Verzeichnis'
,p_list_item_link_target=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/history_tab
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(471880222274882374.4903)
,p_name=>'History Tab'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471880504499882381.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Bericht'
,p_list_item_link_target=>'f?p=&APP_ID.:950:&SESSION.:'
,p_list_item_current_for_pages=>'950'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(471880901168882390.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Kalender'
,p_list_item_link_target=>'f?p=&APP_ID.:951:&SESSION.:'
,p_list_item_current_for_pages=>'951'
);
end;
/
prompt --application/shared_components/navigation/lists/help_application_content_tabs
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(491255024672312078.4903)
,p_name=>'Help application content tabs'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491256117021312081.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Seiten'
,p_list_item_link_target=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'25'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(492152905074851834.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Abschnitte'
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'28'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491256416740312081.4903)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Dateien/Bilder'
,p_list_item_link_target=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'27'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491257030941312082.4903)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Daten-Grids'
,p_list_item_link_target=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT 1',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''DATA'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'29'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491257320723312082.4903)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Berichte'
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT 1',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''REPORT'''))
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'30'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491257610094312082.4903)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Vorgeschlagene SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_ws_applications',
' where id = :WS_APP_ID',
'   and security_group_id = :flow_security_group_id',
'   and allow_sql_yn = ''Y''',
'   and exists (select 1 from wwv_flow_ws_app_sug_objects',
'                where ws_app_id = :WS_APP_ID',
'                and security_group_id = :flow_security_group_id)'))
,p_security_scheme=>wwv_flow_api.id(495860932509802714)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'12'
);
end;
/
prompt --application/shared_components/navigation/lists/edit_report_view_mode
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(491741626522063565.4903)
,p_name=>'edit report view mode'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491742324922072587.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Berichtsattribute'
,p_list_item_link_target=>'javascript:doSubmit(''SAVE_REPORT_ATTR'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3010:3020'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(491761112810144768.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Berichtsabfrage'
,p_list_item_link_target=>'javascript:doSubmit(''SAVE_QUERY'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3030:3060'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_0_toolbar_menu
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(929134615131186819.4903)
,p_name=>'APEX 5.0 - Toolbar Menu'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929134801726186821.4903)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Ansicht'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929138403023186825.4903)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Home'
,p_list_item_link_target=>'ws?p=&WS_APP_ID.:home:&APP_SESSION.'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4903)
,p_list_text_01=>'ws-view-home'
,p_list_text_05=>'Alt+H'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929138706106186825.4903)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>unistr('Pr\00E4sentationsmodus')
,p_list_item_link_target=>'f?p=&APP_ID.:901:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_list_item_disp_condition=>'900'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4903)
,p_list_text_01=>'ws-view-presentation-mode'
,p_list_text_05=>'Alt+Q'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929139001784186826.4903)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Seitenverzeichnis'
,p_list_item_link_target=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4903)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929140888830186828.4903)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Berichte'
,p_list_item_link_target=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.::P902_SHOW:REPORT:'
,p_list_item_disp_cond_type=>'NEVER'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4903)
,p_list_text_01=>'ws-view-reports'
,p_list_text_05=>'Alt+R'
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929141179837186828.4903)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'Seitenhistorie'
,p_list_item_link_target=>'f?p=&APP_ID.:950:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4903)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929141414305186828.4903)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'Websheet-Verzeichnis'
,p_list_item_link_target=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4903)
,p_list_text_01=>'ws-view-ws-directory'
,p_list_text_05=>'Alt+Shift+D'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(930987028365270703.4903)
,p_list_item_display_sequence=>270
,p_list_item_link_text=>'Annotationen'
,p_parent_list_item_id=>wwv_flow_api.id(929134801726186821.4903)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929139607423186826.4903)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Dateien'
,p_list_item_link_target=>'f?p=&APP_ID.:903:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4903)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929139919238186826.4903)
,p_list_item_display_sequence=>180
,p_list_item_link_text=>'Tags'
,p_list_item_link_target=>'f?p=&APP_ID.:928:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4903)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929140243536186826.4903)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Hinweise'
,p_list_item_link_target=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4903)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929140500508186828.4903)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'Links'
,p_list_item_link_target=>'f?p=&APP_ID.:915:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4903)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(931217661486553673.4903)
,p_list_item_display_sequence=>203
,p_list_item_link_text=>'--'
,p_list_item_link_target=>'separator'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'7,8,32'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4903)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929139371751186826.4903)
,p_list_item_display_sequence=>205
,p_list_item_link_text=>'Alle anzeigen'
,p_list_item_link_target=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_api.id(930987028365270703.4903)
,p_list_text_01=>'ws-view-all-annotations'
,p_list_text_05=>'Alt+A'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929135108865186823.4903)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Erstellen'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929136360244186823.4903)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Neue Seite'
,p_list_item_link_target=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:200:P200_PARENT_PAGE,WS_APP_ID:&P900_ID.,&WS_APP_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4903)
,p_list_text_01=>'ws-create-page'
,p_list_text_05=>'Alt+N'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929136628803186823.4903)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Neue Seite als Kopie'
,p_list_item_link_target=>'f?p=&APP_ID.:908:&SESSION.::&DEBUG.:908:WS_APP_ID,P908_COPY_PAGE_FROM,P900_ID:&WS_APP_ID.,&P900_ID.,&P900_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4903)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929136959895186825.4903)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Neuer Abschnitt'
,p_list_item_link_target=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:920,921:WS_APP_ID,P921_STARTING_PAGE:&WS_APP_ID.,&P900_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4903)
,p_list_text_01=>'ws-create-section'
,p_list_text_05=>'Alt+Shift+N'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929137293514186825.4903)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Neues Daten-Grid'
,p_list_item_link_target=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:205,1310,1320:WS_APP_ID:&WS_APP_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4903)
,p_list_text_01=>'ws-create-datagrid'
,p_list_text_05=>'Alt+Shift+D'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929137547826186825.4903)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Neuer Bericht'
,p_list_item_link_target=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.:1310,1320:WS_APP_ID:&WS_APP_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4903)
,p_list_text_01=>'ws-create-report'
,p_list_text_05=>'Alt+Shift+R'
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929137898140186825.4903)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'--'
,p_list_item_link_target=>'separator'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'7,8,32'
,p_parent_list_item_id=>wwv_flow_api.id(929135108865186823.4903)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929135423776186823.4903)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Erstellen'
,p_list_text_02=>'true'
,p_security_scheme=>'!'||wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929135709186186823.4903)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Bearbeiten'
,p_list_text_03=>'Ctrl+N'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929141723344186828.4903)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Seite bearbeiten'
,p_list_item_link_target=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.:53:P53_ID,WS_APP_ID:&P900_ID.,&WS_APP_ID.:'
,p_parent_list_item_id=>wwv_flow_api.id(929135709186186823.4903)
,p_list_text_01=>'ws-edit-page'
,p_list_text_05=>'Alt+E'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929142003161186828.4903)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>unistr('Seite l\00F6schen')
,p_list_item_link_target=>'f?p=&APP_ID.:960:&SESSION.::&DEBUG.:53:P53_ID:&P900_ID.:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'not wwv_flow_ws_api.is_app_home_page(p_ws_app_id => :ws_app_id, p_webpage_id => :p900_id)'
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_api.id(929135709186186823.4903)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929142397543186828.4903)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'Abschnitte bearbeiten'
,p_list_item_link_target=>'f?p=&APP_ID.:940:&SESSION.::&DEBUG.:940:::'
,p_parent_list_item_id=>wwv_flow_api.id(929135709186186823.4903)
,p_list_text_01=>'ws-edit-sections'
,p_list_text_05=>'Alt+Shift+E'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(929136059659186823.4903)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Bearbeiten'
,p_list_text_02=>'true'
,p_security_scheme=>'!'||wwv_flow_api.id(456220226828170850)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1081398599474545.4903)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2015719452410064.4903)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14849102226940934.4903)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(92009116035572450.4903)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99821629609888928.4903)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176118490436506807.4903)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592209067420709428.4903)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765073485610712056.4903)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831723025707993879.4903)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917633175675939889.4903)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_app_builder_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178942513630772437.4903)
,p_name=>'APEX 5.0 App Builder Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>unistr('Keine Berechtigung f\00FCr versuchten Vorgang')
,p_reference_id=>786516029127697713.4903
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_sql_workshop_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178942909534772438.4903)
,p_name=>'APEX 5.0 SQL Workshop Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>'Sie sind nicht berechtigt, SQL Workshop zu verwenden.'
,p_reference_id=>786516265251697717.4903
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_team_development_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178943426646772439.4903)
,p_name=>'APEX 5.0 Team development enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, ',
'        wwv_flow_fnd_user u',
'where nvl(w.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'''))
,p_error_message=>unistr('Team Development ist f\00FCr diesen Workspace nicht aktiviert')
,p_reference_id=>786516861027697723.4903
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_websheets_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(178943900647772439.4903)
,p_name=>'APEX 5.0 Websheets Enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, wwv_flow_fnd_user u',
'where nvl(w.ALLOW_WEBSHEET_DEV_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_WEBSHEET_DEV_YN,''Y'') = ''Y'''))
,p_error_message=>unistr('Keine Berechtigung f\00FCr versuchten Vorgang')
,p_reference_id=>786517166823697723.4903
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/current_user_is_at_least_contributor
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(456220226828170850.4903)
,p_name=>'Current user is at least contributor'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_ws_security.current_user_is_not_reader;'
,p_error_message=>'Sie sind nicht berechtigt, auf diese Funktion zuzugreifen.'
,p_reference_id=>786952716254317846.4903
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/current_user_is_admin
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(456220816180174638.4903)
,p_name=>'Current user is admin'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_ws_security.current_user_is_admin;'
,p_error_message=>'Sie sind nicht berechtigt, auf diese Funktion zuzugreifen.'
,p_reference_id=>786954200597322276.4903
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/user_is_apex_developer
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(487678607690660963.4903)
,p_name=>'User is APEX Developer'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for c1 in (select 1 ',
'             from wwv_flow_developer_workspaces ',
'             where workspace_id = :flow_security_group_id',
'             and developer_name= :app_user)',
'  loop',
'    -- if websheet logged in user is developer then, return true',
'    return true;',
'  end loop;  ',
'  return false;',
'end;'))
,p_error_message=>unistr('Sie m\00FCssen Application Express-Entwickler sein, um auf diese Funktion zugreifen zu k\00F6nnen.')
,p_reference_id=>786953667141317846.4903
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/sql_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(492214905335570870.4903)
,p_name=>'SQL_ENABLED'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_ws_security.sql_enabled(:WS_APP_ID) and wwv_flow_ws_security.sql_enabled_inst;'
,p_error_message=>'SQL-Zugriff ist nicht aktiviert.'
,p_reference_id=>786953304778317846.4903
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/current_user_is_at_least_contributor_and_sql_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(495860932509802714.4903)
,p_name=>'Current user is at least contributor and SQL enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_ws_security.current_user_is_not_reader and wwv_flow_ws_security.sql_enabled(:WS_APP_ID) and wwv_flow_ws_security.sql_enabled_inst;'
,p_error_message=>'Sie sind nicht berechtigt, auf diese Funktion zuzugreifen.'
,p_reference_id=>786953038199317846.4903
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/show_reset_password
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(506060600392166972.4903)
,p_name=>'show reset password'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_ws_api.show_reset_password(p_ws_app_id => :ws_app_id);'
,p_error_message=>unistr('"Kennwort zur\00FCcksetzen" ist nicht aktiviert.')
,p_reference_id=>786953911558317846.4903
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/f4900_websheet_create_enabled
begin
wwv_flow_api.create_security_scheme(
 p_id=>wwv_flow_api.id(612254693942923247.4903)
,p_name=>'f4900 Websheet Create Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce( wwv_flow_platform.get_preference(''WEBSHEET_CREATE_ENABLED''), ''N'' ) = ''Y'' OR :APP_PAGE_ID = 9 then',
'    return TRUE;',
'else',
'    htmldb_util.redirect_url(''f?p=4900:9:'' || :APP_SESSION );',
'    return FALSE;',
'end if;'))
,p_error_message=>unistr('F\00FCr den Zugriff auf diese Seite muss die Websheet-Anwendung aktiviert sein.')
,p_reference_id=>.4903
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(2221120362249577.4903)
,p_icon_sequence=>10
,p_icon_subtext=>'Willkommen &APP_USER.'
,p_icon_target=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.::::'
,p_icon_image_alt=>'Willkommen &APP_USER.'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(617028331038386115.4903)
,p_icon_sequence=>20
,p_icon_subtext=>'( <span style="text-decoration:underline;">Login</span> )'
,p_icon_target=>'f?p=&APP_ID.:79:&SESSION.:LOGIN:&DEBUG.::WS_APP_ID:&WS_APP_ID.:'
,p_icon_image_alt=>'Anmelden'
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond_type=>'USER_IS_PUBLIC_USER'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(620001721380496329.4903)
,p_icon_sequence=>30
,p_icon_subtext=>'Sprache'
,p_icon_target=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:::'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(2290404332055831.4903)
,p_icon_sequence=>40
,p_icon_subtext=>'( <span style="text-decoration:underline;">Abmelden</span> )'
,p_icon_target=>'f?p=&APP_ID.:79:&SESSION.::&DEBUG.::::'
,p_icon_image_alt=>'Abmelden'
,p_nav_entry_is_feedback_yn=>'N'
,p_icon_bar_disp_cond_type=>'USER_IS_NOT_PUBLIC_USER'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_api.create_icon_bar_item(
 p_id=>wwv_flow_api.id(203498613231050603.4903)
,p_icon_sequence=>50
,p_icon_subtext=>'Feedback'
,p_icon_target=>'javascript:popupURL(''f?p=4900:102:&SESSION.:::102:P102_APPLICATION_ID,P102_PAGE_ID:&APP_ID.,&APP_PAGE_ID.'');'
,p_nav_entry_is_feedback_yn=>'Y'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
end;
/
prompt --application/shared_components/logic/application_processes/set_websheet_application_date_format_for_session
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(467798605271386699.4903)
,p_process_sequence=>5
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Websheet Application Date Format for Session'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_worksheet_standard.set_ws_app_date_format( ',
'    p_ws_app_id => :WS_APP_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler beim Festlegen des Datumsformats der Websheet-Anwendung'
,p_process_when=>'WS_APP_ID'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
end;
/
prompt --application/shared_components/logic/application_processes/maintain_g_running_worksheets_app
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(185099800820727550.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'maintain g_running_worksheets_app'
,p_process_sql_clob=>'wwv_flow_log.g_websheet_id := :WS_APP_ID;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Kann nicht global eingestellt werden'
);
end;
/
prompt --application/shared_components/logic/application_processes/check_user_is_at_least_reader
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(456113631939841224.4903)
,p_process_sequence=>15
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check user is at least reader'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_ws_security.get_current_user_role,''0'') = ''0'' then',
'  sys.htp.init;',
'  wwv_flow.g_unrecoverable_error := true;',
'                 sys.owa_util.redirect_url(''f?p=&APP_ID.:99:&SESSION.'');',
'',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler beim Bestimmen der Autorisierung.'
,p_process_when=>':APP_PAGE_ID not in (''79'',''99'',''101'') and nvl(wwv_flow_security.g_user,''nobody'') != ''nobody'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/shared_components/logic/application_processes/user_is_at_least_a_contributor
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(456277312414876323.4903)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'User is at least a contributor'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_ws_security.get_current_user_role,''0'') not in (''C'',''A'') then',
'  sys.htp.init;',
'  wwv_flow.g_unrecoverable_error := true;',
'  sys.owa_util.redirect_url(''f?p=&APP_ID.:99:&SESSION.'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Sie sind nicht berechtigt, auf diese Funktion zuzugreifen.'
,p_process_when=>'20,53,90,131,200,201,205,206,710,760,908,910,920,921,922,926,927,930,931,932,934,1310,1320,4020,4030,4040,940,960,3010,3030'
,p_process_when_type=>'CURRENT_PAGE_IN_CONDITION'
);
end;
/
prompt --application/shared_components/logic/application_processes/check_user_is_admin
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(456253831789380446.4903)
,p_process_sequence=>25
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check user is admin'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_ws_security.current_user_is_admin then',
'',
'  sys.htp.init;',
'  wwv_flow.g_unrecoverable_error := true;',
'                 sys.owa_util.redirect_url(''f?p=4900:99:''||:APP_SESSION);',
'',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Sie sind nicht berechtigt, auf diese Funktion zuzugreifen.'
,p_process_when=>'1,3,11,13,18,24,140,141,142,143,144,145,146,1250'
,p_process_when_type=>'CURRENT_PAGE_IN_CONDITION'
);
end;
/
prompt --application/shared_components/logic/application_processes/websheet
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(1367007177305239.4903)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'websheet'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_widget_action     varchar2(32767) := wwv_flow.g_widget_action;',
'  l_validation_error  varchar2(32767) := null;',
'  l_opt               varchar2(4000) := null;',
'begin',
'  if l_widget_action = ''websheet_properties_save'' then',
'    wwv_flow_ws_api.save_websheet_properties (',
'        p_ws_app_id        => :WS_APP_ID,',
'        p_worksheet_id     => :P2_ID,        ',
'        p_name             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NAME''),',
'        p_alias            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ALIAS''),',
'        p_description      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DESCRIPTION''),        ',
'        p_row_pk1          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROW_PK1''),',
'        p_row_pk2          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROW_PK2''),',
'        p_row_pk3          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROW_PK3''),',
'        p_publish          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_PUBLISH''),',
'        p_validation_error => l_validation_error',
'        );',
'  elsif l_widget_action = ''column_properties_save'' then',
'     wwv_flow_ws_api.save_column_properties (',
'        p_worksheet_id      => :P2_ID,',
'        p_websheet_id       => :P2_WEBSHEET_ID,',
'        p_app_user          => :APP_USER,',
'        p_db_column_name    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'        p_display_order     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_SEQUENCE''),',
'        p_group_id          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID''),       ',
'        p_display_as        => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_AS''),        ',
'        p_label             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_LABEL''),',
'        p_format_mask       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_FORMAT_MASK''),        ',
'        p_value_required    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REQUIRED''),        ',
'        p_heading_alignment => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_HEADING_ALIGNMENT''),',
'        p_column_alignment  => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_ALIGNMENT''),        ',
'        p_lov_id            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV''),',
'        p_lov_name          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'        p_lov_entries       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),        ',
'        p_default_type      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TYPE''),',
'        p_default_text      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TEXT''),        ',
'        p_width             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_WIDTH''),',
'        p_max_width         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_MAX_LENGTH''),',
'        p_height            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_HEIGHT''),',
'        p_help_text         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_HELP_TEXT''),',
'        p_validation_error  => l_validation_error',
'        );',
'  elsif l_widget_action = ''column_add'' then',
'     wwv_flow_ws_api.add_column (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_report_id        => :RPT_ID,',
'         p_app_user         => :APP_USER,',
'         p_column_name      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_NAME''),',
'         p_column_type      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_TYPE''),',
'         p_display_as       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_AS''),',
'         p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV''),',
'         p_value_required   => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REQUIRED''),',
'         p_default_type     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TYPE''),',
'         p_default_text     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TEXT''),',
'         p_lov_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'         p_lov_entries      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),',
'         p_validation_error => l_validation_error',
'         ); ',
'  elsif l_widget_action = ''column_remove'' then',
'',
'',
'',
'     wwv_flow_ws_api.remove_column (',
'         p_worksheet_id     => :P2_ID,',
'         p_columns          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'         p_confirm          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_CONFIRM''),      ',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''lov_save'' then',
'     wwv_flow_ws_api.save_lov (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ID''),',
'         p_lov_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'         p_lov_entries      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),  ',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''column_groups_save'' then',
'     wwv_flow_ws_api.save_column_group (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_group_id         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID''),',
'         p_seq              => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_SEQUENCE''),',
'         p_group_name       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NAME''),',
'         p_description      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DESCRIPTION''),         ',
'         p_columns          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_SHUTTLE_RIGHT''),',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''column_groups_delete'' then',
'     wwv_flow_ws_api.delete_column_group (',
'         p_worksheet_id     => :P2_ID,',
'         p_group_id         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID'')',
'         );',
'  elsif l_widget_action = ''copy'' then',
'    wwv_flow_ws_api.copy_websheet (',
'         p_ws_app_id        => :WS_APP_ID,',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_new_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NEW_WORKSHEET_NAME''),',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''delete_websheet'' then    ',
'    wwv_flow_ws_api.delete_websheet (',
'        p_worksheet_id     => :P2_ID,',
'        p_websheet_id      => :P2_WEBSHEET_ID,               ',
'        p_confirm          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_CONFIRM''),',
'        p_validation_error => l_validation_error);       ',
'  elsif l_widget_action = ''delete_rows'' then',
'    wwv_flow_ws_api.delete_rows (',
'        p_websheet_id      => :P2_WEBSHEET_ID,',
'        p_rows             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROWS''),',
'        p_selected_rows    => wwv_flow.g_x01,',
'        p_confirm          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_CONFIRM''),',
'        p_validation_error => l_validation_error);',
'  elsif l_widget_action = ''set_column_value'' then',
'    wwv_flow_ws_api.set_column_value (',
'        p_websheet_id      => :P2_WEBSHEET_ID, ',
'        p_db_column_name   => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'        p_new_value        => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NEW_COLUMN_VALUE''),',
'        p_rows             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROWS''),',
'        p_selected_rows    => wwv_flow.g_x01,',
'        p_validation_error => l_validation_error);',
'  elsif l_widget_action = ''replace_column_value'' then',
'    wwv_flow_ws_api.replace_column_value (',
'        p_websheet_id      => :P2_WEBSHEET_ID,',
'        p_rows              => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ROWS''),',
'        p_db_column_names   => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMS''),',
'        p_find_what         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REPLACE''),',
'        p_replace_with      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REPLACE_WITH''),',
'        p_selected_rows     => wwv_flow.g_x01,',
'        p_validation_error  => l_validation_error);',
'  elsif l_widget_action = ''fill_column_value'' then',
'    wwv_flow_ws_api.fill_column_value (',
'        p_websheet_id      => :P2_WEBSHEET_ID,',
'        p_db_column_name     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),    ',
'        p_validation_error   => l_validation_error);',
'  elsif l_widget_action = ''lov_delete'' then',
'    wwv_flow_ws_api.delete_lov (',
'        p_worksheet_id     => :P2_ID,',
'        p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ID''),  ',
'        p_validation_error => l_validation_error',
'        );     ',
'  elsif l_widget_action = ''toggle_checkboxes'' then',
'        if nvl(v(''P2_SHOW_CHECKBOX''),''N'') = ''Y'' then',
'            wwv_flow.update_cache_with_write(p_name => ''P2_SHOW_CHECKBOX'', p_value => ''N'');            ',
'        elsif nvl(v(''P2_SHOW_CHECKBOX''),''N'') = ''N'' then',
'            wwv_flow.update_cache_with_write(p_name => ''P2_SHOW_CHECKBOX'', p_value => ''Y'');',
'        end if;',
'  elsif l_widget_action = ''export'' then',
'    if wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_EXPORT_FORMAT'') = ''DATABASE'' then',
'        sys.owa_util.redirect_url(''f?p=''||:APP_ID||'':2:''||:APP_SESSION||'':HTMLD'');',
'    end if;',
'  elsif l_widget_action = ''set_geocode'' then',
'    wwv_flow_ws_geocode.save_geocodes(',
'        p_worksheet_id => :P2_ID,',
'        p_columns      => wwv_flow.g_x01 );',
'  elsif l_widget_action = ''refresh_geocode'' then',
'    wwv_flow_ws_geocode.reset_geocodes(',
'        p_worksheet_id => :P2_ID);',
'  elsif l_widget_action = ''VALIDATION_SAVE'' then',
'     wwv_flow_ws_api.save_column_validation (',
'         p_ws_app_id        => :WS_APP_ID,',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_validation_id    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_ID''),',
'         p_validation_level => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_LEVEL''),',
'         p_name             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_NAME''),',
'         p_seq              => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_SEQUENCE''),',
'         p_type             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_TYPE''),',
'         p_expr1            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'         p_expr2            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION''),',
'         p_error_message    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ERROR_MESSAGE''),',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''VALIDATION_DELETE'' then',
'     wwv_flow_ws_api.delete_column_validation (',
'         p_worksheet_id     => :P2_ID,',
'         p_validation_id    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_ID'')         ',
'         );       ',
'  end if;  ',
'',
'  if l_validation_error is null then',
'      sys.htp.prn(''true'');      ',
'  else',
'      sys.htp.prn(l_validation_error);      ',
'  end if;',
'exception when others then',
'  sys.htp.prn(''error ''||wwv_flow_escape.html(sqlerrm));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'websheet process error'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_process_comment=>'WebSheet dialog saving.'
);
end;
/
prompt --application/shared_components/logic/application_processes/item_row
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(2693010773842087.4903)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ITEM_ROW'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_goto_ws_row       varchar2(32767);',
'    l_validation_error	varchar2(32767) := null;',
'    l_validation_count  number          := 0;',
'    l_validation_title  varchar2(4000)  := null;',
'    l_action            varchar2(4000)  := wwv_flow.g_x01;',
'begin',
'    -- Don''t process the row, if we''re removing a column.',
'    if l_action != ''column_remove'' then ',
'        wwv_flow_ws_api.process_row (',
'            p_ws_app_id     => :WS_APP_ID,',
'            p_worksheet_id  => :P2_ID,',
'            p_websheet_id   => :P2_WEBSHEET_ID,',
'            p_row_id        => :CURRENT_WORKSHEET_ROW,',
'            f01             => wwv_flow.g_f01,',
'            f02             => wwv_flow.g_f02,       ',
'            p_validation_error => l_validation_error,',
'            p_validation_count => l_validation_count,',
'            p_ajax_mode => true );',
'    end if;',
'    ',
'    if l_validation_count = 0 then',
'        htmldb_util.set_session_state(''CURRENT_WORKSHEET_ROW'', v(''GOTO_WORKSHEET_ROW''));',
'        htmldb_util.set_session_state(''P20_ROW_ID'', v(''GOTO_WORKSHEET_ROW''));',
'        --htmldb_util.set_session_state(''P20_IR_ID'', :P2_ID);',
'        --htmldb_util.set_session_state(''P20_DATA_GRID_ID'', :P2_WEBSHEET_ID);',
'        --:CURRENT_WORKSHEET_ROW := :GOTO_WORKSHEET_ROW;',
'        --:P20_ROW_ID := :GOTO_WORKSHEET_ROW;',
'        --:P20_IR_ID := :P2_ID;',
'        --:P20_DATA_GRID_ID := :P2_WEBSHEET_ID; ',
'        -- Redraw the form, with the new row''s details.',
'        sys.htp.prn(''<div id="apexir_WORKSHEET_REGION" class="apex_worksheet">'');',
'        sys.htp.prn(''<div id="apexir_DETAIL" class="detail">'');        ',
'        wwv_flow_ws_form.show (',
'            p_ws_app_id            => :WS_APP_ID,',
'        	p_worksheet_id         => :P2_ID,',
'        	p_data_grid_id         => :P2_WEBSHEET_ID,',
'        	p_session              => :APP_SESSION,',
'        	p_app_user             => :APP_USER,',
'        	p_row_id               => v(''CURRENT_WORKSHEET_ROW''),         ',
'        	p_base_report_id       => :RPT_ID,',
'            p_partial_page_refresh => true,',
'            p_last_page_id         => :P20_LAST_PAGE_ID,',
'            p_last_section_id      => :P20_LAST_SECTION_ID);',
'        sys.htp.prn(''</div></div>'');',
'    else',
'        if l_validation_count = 1 then',
'            l_validation_title := wwv_flow_lang.system_message(''FLOW.SINGLE_VALIDATION_ERROR'');',
'        else',
'            l_validation_title := wwv_flow_lang.system_message(''FLOW.VALIDATION_ERROR'', l_validation_count);',
'        end if;',
'        l_validation_error := l_validation_title || ''<ul class="htmldbUlErr">'' || l_validation_error || ''</ul>'';',
'        sys.htp.prn(''error|'' || l_validation_error);',
'    end if;',
'      ',
'exception',
'    when others then',
'        sys.htp.prn(''error|'' || wwv_flow_escape.html(sqlerrm));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
,p_process_comment=>'This application process is used to re-load single row detail view data with validation message from page 20.'
);
end;
/
prompt --application/shared_components/logic/application_processes/websheet_detail
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(2776923488356345.4903)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'websheet_detail'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_widget_action           varchar2(32767) := upper(wwv_flow.g_widget_action);',
'  l_widget_action_mod       varchar2(32767) := wwv_flow.g_widget_action_mod;',
'  l_validation_error        varchar2(32767) := null;',
'begin  ',
'  if l_widget_action = ''NOTE_SAVE'' then      ',
'      wwv_flow_ws_api.add_note (',
'        p_ws_app_id         => :WS_APP_ID,',
'        p_websheet_id       => :P2_WEBSHEET_ID,',
'        p_row_id            => :CURRENT_WORKSHEET_ROW,',
'        p_note_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NOTE_ID''),',
'        p_component_level   => ''ROW'',',
'        p_content           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NOTES''),',
'        p_validation_error  => l_validation_error',
'        );',
'  elsif l_widget_action = ''NOTE_DELETE'' then',
'      wwv_flow_ws_api.delete_note ( ',
'        p_note_id   => l_widget_action_mod);',
'  elsif l_widget_action = ''COLUMN_PROPERTIES_SAVE'' then      ',
'      wwv_flow_ws_api.save_column_properties (',
'        p_worksheet_id      => :P2_ID,',
'        p_websheet_id       => :P2_WEBSHEET_ID,',
'        p_app_user          => :APP_USER,',
'        p_db_column_name    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'        p_display_order     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_SEQUENCE''),',
'        p_group_id          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID''),       ',
'        p_display_as        => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_AS''),',
'        p_label             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_LABEL''),',
'        p_format_mask       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_FORMAT_MASK''),        ',
'        p_value_required    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REQUIRED''),        ',
'        p_heading_alignment => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_HEADING_ALIGNMENT''),',
'        p_column_alignment  => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_ALIGNMENT''),        ',
'        p_lov_id            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV''),',
'        p_lov_name          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'        p_lov_entries       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),        ',
'        p_default_type      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TYPE''),',
'        p_default_text      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TEXT''),        ',
'        p_width             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_WIDTH''),',
'        p_max_width         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_MAX_LENGTH''),',
'        p_height            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_HEIGHT''),',
'        p_help_text         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_HELP_TEXT''),',
'        p_validation_error  => l_validation_error',
'        );',
'  elsif l_widget_action = ''LINK_SAVE'' then',
'      wwv_flow_ws_api.add_link (',
'        p_ws_app_id         => :WS_APP_ID,',
'        p_websheet_id       => :P2_WEBSHEET_ID,          ',
'        p_row_id            => :CURRENT_WORKSHEET_ROW,',
'        p_component_level   => ''ROW'',',
'        p_link_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LINK_ID''),',
'        p_link_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LINK_NAME''), ',
'        p_url               => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_URL''),',
'        p_validation_error  => l_validation_error',
'        );',
'  elsif l_widget_action = ''LINK_DELETE'' then',
'        wwv_flow_ws_api.delete_link ( ',
'            p_link_id   => l_widget_action_mod);',
'',
'  elsif l_widget_action = ''TAG_SAVE'' then',
'    wwv_flow_ws_api.add_tags (    ',
'        p_ws_app_id       => :WS_APP_ID,            ',
'        p_websheet_id     => :P2_WEBSHEET_ID,',
'        p_row_id          => :CURRENT_WORKSHEET_ROW,',
'        p_component_level => ''ROW'',',
'        p_tag             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_TAGS'')); ',
'  elsif l_widget_action = ''TAG_DELETE'' then',
'        wwv_flow_ws_api.delete_tag (',
'            p_websheet_id  => :P2_WEBSHEET_ID,',
'            p_row_id       => :CURRENT_WORKSHEET_ROW,',
'            p_tag_id       => l_widget_action_mod);',
'  elsif l_widget_action = ''ATTACHMENT_DELETE'' then',
'        wwv_flow_ws_attachment.delete_doc ( ',
'            p_doc_id   => l_widget_action_mod);',
'  elsif l_widget_action = ''LOV_DELETE'' then',
'    wwv_flow_ws_api.delete_lov (',
'        p_worksheet_id     => :P2_ID,',
'        p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ID''),  ',
'        p_validation_error => l_validation_error',
'        );',
'  elsif l_widget_action = ''LOV_SAVE'' then',
'     wwv_flow_ws_api.save_lov (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ID''),',
'         p_lov_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'         p_lov_entries      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),  ',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''VALIDATION_SAVE'' then',
'     wwv_flow_ws_api.save_column_validation (',
'         p_ws_app_id        => :WS_APP_ID,',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_validation_id    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_ID''),',
'         p_validation_level => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_LEVEL''),',
'         p_name             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_NAME''),',
'         p_seq              => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_SEQUENCE''),',
'         p_type             => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_TYPE''),',
'         p_expr1            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'         p_expr2            => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION''),',
'         p_error_message    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_ERROR_MESSAGE''),',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''VALIDATION_DELETE'' then',
'     wwv_flow_ws_api.delete_column_validation (',
'         p_worksheet_id     => :P2_ID,',
'         p_validation_id    => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_VALIDATION_ID'')         ',
'         );',
'  elsif l_widget_action = ''COLUMN_GROUPS_SAVE'' then',
'     wwv_flow_ws_api.save_column_group (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_group_id         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID''),',
'         p_seq              => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_SEQUENCE''),',
'         p_group_name       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_NAME''),',
'         p_description      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DESCRIPTION''),         ',
'         p_columns          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_SHUTTLE_RIGHT''),',
'         p_validation_error => l_validation_error',
'         );',
'  elsif l_widget_action = ''COLUMN_GROUPS_DELETE'' then',
'     wwv_flow_ws_api.delete_column_group (',
'         p_worksheet_id     => :P2_ID,',
'         p_group_id         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID'')',
'         );',
'  -- cbcho',
'  elsif l_widget_action = ''COLUMN_ADD'' then',
'     wwv_flow_ws_api.add_column (',
'         p_worksheet_id     => :P2_ID,',
'         p_websheet_id      => :P2_WEBSHEET_ID,',
'         p_report_id        => :RPT_ID,',
'         p_app_user         => :APP_USER,',
'         p_column_name      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_NAME''),',
'         p_group_id         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_GROUP_ID''),',
'         p_column_type      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN_TYPE''),',
'         p_display_as       => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DISPLAY_AS''),',
'         p_lov_id           => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV''),',
'         p_value_required   => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_REQUIRED''),',
'         p_default_type     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TYPE''),',
'         p_default_text     => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_DEFAULT_TEXT''),',
'         p_lov_name         => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_NAME''),',
'         p_lov_entries      => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_LOV_ENTRIES''),',
'         p_validation_error => l_validation_error',
'         ); ',
'  elsif l_widget_action = ''COLUMN_REMOVE'' then',
'     wwv_flow_ws_api.remove_column (',
'         p_worksheet_id     => :P2_ID,',
'         p_columns          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_COLUMN''),',
'         p_confirm          => wwv_flow_ws_api.get_item_value(p_item_name => ''apexir_CONFIRM''),      ',
'         p_validation_error => l_validation_error',
'         );',
'  end if;',
'',
'  if l_validation_error is null then',
'      sys.htp.prn(''true'');      ',
'  else',
'      sys.htp.prn(l_validation_error);      ',
'  end if;',
'exception when others then',
'  sys.htp.prn(''error ''||wwv_flow_escape.html(sqlerrm));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/shared_components/logic/application_processes/dialog
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(3291701954237236.4903)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'DIALOG'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_dialog.ondemand_dialog (',
'    p_websheet_id    => :P2_WEBSHEET_IT,',
'    p_worksheet_id   => :P2_ID,',
'    p_base_report_id => :RPT_ID,',
'    p_row_id         => :CURRENT_WORKSHEET_ROW );'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/shared_components/logic/application_processes/cell
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(37132405811210809.4903)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CELL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_ACTION			varchar2(32767);',
'    l_ROW				varchar2(32767);',
'    l_COLUMN			varchar2(32767);',
'    l_VALUE				varchar2(32767);',
'    l_CHANGE			varchar2(32767);',
'    l_validation_error	varchar2(32767) := null;',
'begin',
'    l_ROW       := wwv_flow_ws_api.get_item_value(p_item_name => ''ROW'');',
'    l_COLUMN    := wwv_flow_ws_api.get_item_value(p_item_name => ''COLUMN'');',
'    l_VALUE     := wwv_flow_ws_api.get_item_value(p_item_name => ''VALUE'');',
'    l_CHANGE    := wwv_flow_ws_api.get_item_value(p_item_name => ''CHANGE'');',
'    l_ACTION    := wwv_flow_ws_api.get_item_value(p_item_name => ''ACTION'');    ',
'    if l_ACTION = ''SAVE'' then                       ',
'    	wwv_flow_ws_api.update_cell( ',
'            p_worksheet_id     => :P2_ID,',
'    	   p_websheet_id      => :P2_WEBSHEET_ID, ',
'    	   p_row_id           => l_ROW , ',
'    	   p_column_name      => l_COLUMN, ',
'    	   p_new_value        => l_VALUE,',
'    	   p_change_count     => l_CHANGE,',
'    	   p_validation_error => l_validation_error);',
'     else ',
'    	null;',
'     end if;',
'    if l_validation_error is null then    ',
'        sys.htp.prn(''true'');',
'    else',
'        sys.htp.prn(l_validation_error);',
'    end if;',
'exception when others then',
'    sys.htp.prn(wwv_flow_escape.html(substr(sqlerrm,instr(sqlerrm,''ORA-'',-1))));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/shared_components/logic/application_processes/get_item_help
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(452245511492078992.4903)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GET_ITEM_HELP'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_form.show_column_popup (',
'    p_db_column_name => wwv_flow_ws_api.get_item_value(p_item_name => ''COLUMN_NAME''),',
'    p_workspace_id   => to_number(:WORKSPACE_ID),',
'    p_worksheet_id   => to_number(:P2_ID));'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/shared_components/logic/application_processes/get_dtfmt
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(460600501716774062.4903)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get_dtFmt'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_COLUMN			varchar2(32767);',
'    l_DATE                      varchar2(32767);',
'    l_app_date_format   varchar2(4000);',
'    l_format_mask       varchar2(4000);',
'    l_json_return           varchar2(32767);',
'begin',
'    l_COLUMN    := wwv_flow_ws_api.get_item_value(p_item_name => ''COLUMN'');',
'    l_DATE      := wwv_flow_ws_api.get_item_value(p_item_name => ''DATE'');',
'',
'    l_json_return := wwv_flow_ws_api.inline_date_picker_options(',
'        p_worksheet_id => :P2_ID,',
'        p_date         => l_DATE,',
'        p_column       => l_COLUMN );',
'',
'',
'    sys.htp.prn(l_json_return);',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/shared_components/logic/application_processes/get_lov_json
begin
wwv_flow_api.create_flow_process(
 p_id=>wwv_flow_api.id(615062144451949851.4903)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'GET_LOV_JSON'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_worksheet_id varchar2(32767) := wwv_flow.g_x01;  ',
'    l_single_id    varchar2(32767) := wwv_flow_worksheet_ajax.clean_column_name(wwv_flow.g_x02);',
'begin',
'    wwv_flow_ws_api.get_lov_json(',
'        p_worksheet_id   => l_worksheet_id,',
'        p_db_column_name => l_single_id );',
'end;        '))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_ws_action
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(24477906500589587.4903)
,p_name=>'AJAX_WS_ACTION'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'FILTER,SEARCH,SORT'
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_ws_column
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(24506014409837883.4903)
,p_name=>'AJAX_WS_COLUMN'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_ws_filter
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(24505231939833457.4903)
,p_name=>'AJAX_WS_FILTER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_ws_filter_type
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(24503818779829694.4903)
,p_name=>'AJAX_WS_FILTER_TYPE'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_ws_num
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(25407924412215582.4903)
,p_name=>'AJAX_WS_NUM'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/app_name
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(187889401560281661.4903)
,p_name=>'APP_NAME'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/builder_session_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(406291700131840546.4903)
,p_name=>'BUILDER_SESSION_ID'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/current_worksheet_row
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(179652013865859868.4903)
,p_name=>'CURRENT_WORKSHEET_ROW'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4900_last_view
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(161139305537061829.4903)
,p_name=>'F4900_LAST_VIEW'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4900_login_url
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(617034601471718123.4903)
,p_name=>'F4900_LOGIN_URL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/f4900_logo
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(471216109613872357.4903)
,p_name=>'F4900_LOGO'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/fsp_after_login_url
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(154784210014091542.4903)
,p_name=>'FSP_AFTER_LOGIN_URL'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/goto_worksheet_row
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(461331700195331599.4903)
,p_name=>'GOTO_WORKSHEET_ROW'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/home_page_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(458560827333195349.4903)
,p_name=>'HOME_PAGE_ID'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ir_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(185115316114835976.4903)
,p_name=>'IR_ID'
,p_data_type=>'NUMBER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This application item is used to run Websheet reports and Data Grid on page 3010.'
);
end;
/
prompt --application/shared_components/logic/application_items/item_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(7934826114498652.4903)
,p_name=>'ITEM_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/owner_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(176645422859500226.4903)
,p_name=>'OWNER_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/rpt_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(179806310494315818.4903)
,p_name=>'RPT_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/run_link
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(185298032482647725.4903)
,p_name=>'RUN_LINK'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/section_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(20015114768535427.4903)
,p_name=>'SECTION_ID'
,p_data_type=>'NUMBER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/shownav
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(172130707665449025.4903)
,p_name=>'SHOWNAV'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/temporary_action
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(7965920927622901.4903)
,p_name=>'TEMPORARY_ACTION'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This is used to run a action using Ajax it should not be used on anything else and not be expected to save it''s value between requests.'
);
end;
/
prompt --application/shared_components/logic/application_items/temporary_filter
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(23088531657485941.4903)
,p_name=>'TEMPORARY_FILTER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/temporary_item
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(7939330981651397.4903)
,p_name=>'TEMPORARY_ITEM'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This is used to run a action using AJAX it should not be used on anything else and not be expected to save it''s value between requests.'
);
end;
/
prompt --application/shared_components/logic/application_items/worksheet_filter_type
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(23801903782632819.4903)
,p_name=>'WORKSHEET_FILTER_TYPE'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/worksheet_name
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(78919021160643130.4903)
,p_name=>'WORKSHEET_NAME'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_items/ws_app_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(185116129620839895.4903)
,p_name=>'WS_APP_ID'
,p_data_type=>'NUMBER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Websheet application ID'
);
end;
/
prompt --application/shared_components/logic/application_items/ws_id
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(185115622347837829.4903)
,p_name=>'WS_ID'
,p_data_type=>'NUMBER'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'This application item is used to run Websheet reports and Data Grid on page 3010.'
);
end;
/
prompt --application/shared_components/logic/application_items/ws_setup_valid
begin
wwv_flow_api.create_flow_item(
 p_id=>wwv_flow_api.id(451945309573247981.4903)
,p_name=>'WS_SETUP_VALID'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
);
end;
/
prompt --application/shared_components/logic/application_computations/f4900_logo
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(471216708359881476.4903)
,p_computation_sequence=>100
,p_computation_item=>'F4900_LOGO'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'return wwv_flow_ws_api.get_logo(p_ws_app_id=>:WS_APP_ID,p_security_group_id=>:flow_security_group_id);'
);
end;
/
prompt --application/shared_components/logic/application_computations/home_page_id
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(458561209110199522.4903)
,p_computation_sequence=>10
,p_computation_item=>'HOME_PAGE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select HOME_PAGE_ID',
'  from WWV_FLOW_WS_APPLICATIONS',
' where id = :WS_APP_ID',
'and security_group_id = :WORKSPACE_ID'))
);
end;
/
prompt --application/shared_components/logic/application_computations/f4900_login_url
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(617038105476908535.4903)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LOGIN_URL'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'return wwv_flow_ws_webpage.get_login_url(:WS_APP_ID);'
);
end;
/
prompt --application/shared_components/logic/application_computations/shownav
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(172131313205450686.4903)
,p_computation_sequence=>10
,p_computation_item=>'SHOWNAV'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'Y'
);
end;
/
prompt --application/shared_components/logic/application_computations/builder_session_id
begin
wwv_flow_api.create_flow_computation(
 p_id=>wwv_flow_api.id(406460806842851924.4903)
,p_computation_sequence=>10
,p_computation_item=>'BUILDER_SESSION_ID'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'return wwv_flow_security.get_builder_session_id;'
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/accessibility_mode
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(680996401756072029.4903)
,p_lov_name=>'ACCESSIBILITY_MODE'
,p_lov_query=>'.'||wwv_flow_api.id(680996401756072029.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(680996730973072031.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Bildschirmsprachausgabe'
,p_lov_return_value=>'SCREEN_READER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(680996901097072032.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Hoher Kontrast'
,p_lov_return_value=>'HIGH_CONTRAST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/acl_priv
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4183515898494342.4903)
,p_lov_name=>'ACL_PRIV'
,p_lov_query=>'.'||wwv_flow_api.id(4183515898494342.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4183804118494346.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Anzeigen und bearbeiten'
,p_lov_return_value=>'EDIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4184010247494348.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nur anzeigen'
,p_lov_return_value=>'VIEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/alignment_l_c_r
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(187517603302080409.4903)
,p_lov_name=>'ALIGNMENT_L_C_R'
,p_lov_query=>'.'||wwv_flow_api.id(187517603302080409.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187517811651080411.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Links'
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187518005825080412.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Mitte'
,p_lov_return_value=>'CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187518229295080412.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Rechts'
,p_lov_return_value=>'RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/all_or_selected_or_null_row_domain
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6200201590860952.4903)
,p_lov_name=>'ALL OR SELECTED OR NULL (ROW DOMAIN)'
,p_lov_query=>'.'||wwv_flow_api.id(6200201590860952.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6200409579860953.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Alle Zeilen'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6200608372860954.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Ausgew\00E4hlte Zeilen')
,p_lov_return_value=>'SELECTED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(20082523608431635.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Null Zeilen'
,p_lov_return_value=>'NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/annotation_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(251379008493597083.4903)
,p_lov_name=>'ANNOTATION TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(251379008493597083.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251379209365597089.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dateien'
,p_lov_return_value=>'ATTACHMENT'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:4020:&SESSION.:::4020:P4020_ANNOTATION_TYPE:ATTACHMENT"><img src="#IMAGE_PREFIX#menu/wiz_multiple_140x90.gif" height="90" widt'
||'h="140" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251379423628597095.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Hinweise'
,p_lov_return_value=>'NOTE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:4020:&SESSION.:::4020:P4020_ANNOTATION_TYPE:NOTE"><img src="#IMAGE_PREFIX#menu/wiz_interactive_report_140x90.gif" height="90" '
||'width="140" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(251379620302597095.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Tag'
,p_lov_return_value=>'TAG'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:4020:&SESSION.:::4020:P4020_ANNOTATION_TYPE"><img src="#IMAGE_PREFIX#menu/wiz_interactive_report_140x90.gif" height="90" width'
||'="140" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(631189019655476474.4903)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Links'
,p_lov_return_value=>'LINK'
,p_lov_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_lov_disp_cond=>'906'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_name_returning_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(172965416124494830.4903)
,p_lov_name=>'APPLICATION NAME RETURNING ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'from   wwv_flows f',
'where  ',
'       security_group_id = :flow_security_group_id and',
'       not exists (',
'       select null from wwv_flow_language_map',
'       where translation_flow_id = f.id and ',
'         security_group_id = :flow_security_group_id) and',
'       (',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :app_user and ',
'             flow_id is null and ',
'             security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :app_user and ',
'             flow_id = f.id and ',
'             security_group_id = :flow_security_group_id ))'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/attachment_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(177785329944899135.4903)
,p_lov_name=>'ATTACHMENT OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(177785329944899135.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177785525202899136.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'In Bericht mit Symbol und Name anzeigen'
,p_lov_return_value=>'BOTH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177785716327899136.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'In Bericht nur mit Name anzeigen'
,p_lov_return_value=>'NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177785901379899136.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Nur mit Symbol anzeigen'
,p_lov_return_value=>'ICON'
);
end;
/
prompt --application/shared_components/user_interface/lovs/blob_content_disposition
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(382939512009208407.4903)
,p_lov_name=>'BLOB_CONTENT_DISPOSITION'
,p_lov_query=>'.'||wwv_flow_api.id(382939512009208407.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(382939815594208407.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Inline'
,p_lov_return_value=>'inline'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(382940022425208407.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Anhang'
,p_lov_return_value=>'attachment'
);
end;
/
prompt --application/shared_components/user_interface/lovs/blob_format_mask
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(382915819151201016.4903)
,p_lov_name=>'BLOB_FORMAT_MASK'
,p_lov_query=>'.'||wwv_flow_api.id(382915819151201016.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(382916131553201016.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'DOWNLOAD'
,p_lov_return_value=>'DOWNLOAD'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(382916305818201016.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'IMAGE'
,p_lov_return_value=>'IMAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/break_on
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(22967915270872919.4903)
,p_lov_name=>'BREAK ON'
,p_lov_query=>'.'||wwv_flow_api.id(22967915270872919.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24136313336017502.4903)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'Keine Gruppenwechsel'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22968117650872920.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spalte 1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22968313303872920.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Spalten 1 und 2'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22968508747872920.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Spalten 1, 2 und 3'
,p_lov_return_value=>'3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_functions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(261396928274568408.4903)
,p_lov_name=>'CHART FUNCTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(261396928274568408.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261397126573568409.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Summe'
,p_lov_return_value=>'SUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261397325621568409.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Durchschnitt'
,p_lov_return_value=>'AVG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261397511265568409.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Minimum'
,p_lov_return_value=>'MIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261397717213568409.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Maximum'
,p_lov_return_value=>'MAX'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261397932564568409.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Anzahl'
,p_lov_return_value=>'COUNT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_sort
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(261446703779618102.4903)
,p_lov_name=>'CHART SORT'
,p_lov_query=>'.'||wwv_flow_api.id(261446703779618102.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261446917693618102.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standardwert'
,p_lov_return_value=>'DEFAULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261447112282618103.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Wert - Aufsteigend'
,p_lov_return_value=>'VALUE_ASC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261447310262618103.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Wert - Absteigend'
,p_lov_return_value=>'VALUE_DESC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261447525538618103.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Label - Aufsteigend'
,p_lov_return_value=>'LABEL_ASC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261447704881618103.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Label - Absteigend'
,p_lov_return_value=>'LABEL_DESC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_3d
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(430988702419464894.4903)
,p_lov_name=>'CHART_3D'
,p_lov_query=>'.'||wwv_flow_api.id(430988702419464894.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(430988921586464895.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'3D aktivieren'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_orientation
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(107038275478210797.4903)
,p_lov_name=>'CHART_ORIENTATION'
,p_lov_query=>'.'||wwv_flow_api.id(107038275478210797.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(107038518670210798.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vertikal'
,p_lov_return_value=>'vertical'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(107038941666210804.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Horizontal'
,p_lov_return_value=>'horizontal'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(259453605523899856.4903)
,p_lov_name=>'CHART_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(259453605523899856.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(259453813697899860.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Balken'
,p_lov_return_value=>'bar'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=4900:740:&SESSION.:::740:P710_CHART_TYPE:bar"><img src="#IMAGE_PREFIX#ws/ws-column-chart.png" alt="#DISPLAY_VALUE#" width="128" height='
||'"128" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(259454024992899863.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Linien/Fl\00E4chen')
,p_lov_return_value=>'lineWithArea'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=4900:740:&SESSION.:::740:P710_CHART_TYPE:lineWithArea"><img src="#IMAGE_PREFIX#ws/ws-line-area-chart.png" alt="#DISPLAY_VALUE#" width="'
||'128" height="128" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(259454217060899863.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Kreis'
,p_lov_return_value=>'pie'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=4900:740:&SESSION.:::740:P710_CHART_TYPE:pie"><img src="#IMAGE_PREFIX#ws/ws-pie-chart.png" alt="#DISPLAY_VALUE#" width="128" height="12'
||'8" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(259454601928899863.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Zeile'
,p_lov_return_value=>'line'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=4900:740:&SESSION.:::740:P710_CHART_TYPE:line"><img src="#IMAGE_PREFIX#ws/ws-line-chart.png" alt="#DISPLAY_VALUE#" width="128" height="'
||'128" /></a></td><td>&nbsp;</td></tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_groups
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(169740222151305876.4903)
,p_lov_name=>'COLUMN GROUPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME display_value, ID return_value ',
'from WWV_FLOW_WORKSHEET_COL_GROUPS',
'where worksheet_id = :p2_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_label_returning_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(157556708734983770.4903)
,p_lov_name=>'COLUMN LABEL RETURNING ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select COLUMN_LABEL display_value, ID return_value ',
'from WWV_FLOW_WORKSHEET_COLUMNS',
'where worksheet_id = :p2_id',
'order by DISPLAY_ORDER, upper(column_label)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_filter_operators
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(178773405987392681.4903)
,p_lov_name=>'COLUMN_FILTER_OPERATORS'
,p_lov_query=>'.'||wwv_flow_api.id(178773405987392681.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178773624786392683.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'='
,p_lov_return_value=>'='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178773816619392689.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'!='
,p_lov_return_value=>'!='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178774029915392689.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'>'
,p_lov_return_value=>'>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178774203147392689.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'>='
,p_lov_return_value=>'>='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178774404844392689.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'<'
,p_lov_return_value=>'<'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178774611401392689.4903)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'<='
,p_lov_return_value=>'<='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178774803359392690.4903)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'ist null'
,p_lov_return_value=>'is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178775031923392690.4903)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'ist nicht null'
,p_lov_return_value=>'is not null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178775213763392690.4903)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'wie'
,p_lov_return_value=>'like'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178775414742392690.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'nicht wie'
,p_lov_return_value=>'not like'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178775626341392690.4903)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'in'
,p_lov_return_value=>'in'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178775816853392690.4903)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'nicht in'
,p_lov_return_value=>'not in'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178776030779392690.4903)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>unistr('enth\00E4lt')
,p_lov_return_value=>'contains'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178776226760392690.4903)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>unistr('enth\00E4lt nicht')
,p_lov_return_value=>'does not contain'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178776415143392690.4903)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'regexp_like'
,p_lov_return_value=>'regexp_like'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178778229882399595.4903)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'zwischen'
,p_lov_return_value=>'between'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178779911313403739.4903)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'ist in den letzten'
,p_lov_return_value=>'is in the last'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178780215815404960.4903)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'ist nicht in den letzten'
,p_lov_return_value=>'is not in the last'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178780518932405861.4903)
,p_lov_disp_sequence=>28
,p_lov_disp_value=>unistr('ist in den n\00E4chsten')
,p_lov_return_value=>'is in the next'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178780722741406996.4903)
,p_lov_disp_sequence=>38
,p_lov_disp_value=>unistr('ist nicht in den n\00E4chsten')
,p_lov_return_value=>'is not in the next'
);
end;
/
prompt --application/shared_components/user_interface/lovs/comparison_expressions
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(157548605355963845.4903)
,p_lov_name=>'COMPARISON EXPRESSIONS'
,p_lov_query=>'.'||wwv_flow_api.id(157548605355963845.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157548815917963845.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'='
,p_lov_return_value=>'='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157549008133963845.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'>'
,p_lov_return_value=>'>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177923106066093754.4903)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'>='
,p_lov_return_value=>'>='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157549227534963845.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'<'
,p_lov_return_value=>'<'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177923812646095626.4903)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'<='
,p_lov_return_value=>'<='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157549604153963845.4903)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'wie'
,p_lov_return_value=>'LIKE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(179793328389112795.4903)
,p_lov_disp_sequence=>51
,p_lov_disp_value=>'Nicht wie'
,p_lov_return_value=>'not like '
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(157549823989963846.4903)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'!='
,p_lov_return_value=>'!='
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6035512141000243.4903)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'ist null'
,p_lov_return_value=>'is null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6035915258001184.4903)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'ist nicht null'
,p_lov_return_value=>'is not null'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24709324557666429.4903)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'in'
,p_lov_return_value=>'in'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(24709626635667023.4903)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'nicht in'
,p_lov_return_value=>'not in'
);
end;
/
prompt --application/shared_components/user_interface/lovs/component_level
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(455012825948829772.4903)
,p_lov_name=>'COMPONENT_LEVEL'
,p_lov_query=>'.'||wwv_flow_api.id(455012825948829772.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(455013000682829776.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Seite'
,p_lov_return_value=>'WEBPAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(455013212503829779.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Zeile'
,p_lov_return_value=>'ROW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/control_break_groups
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(22978927746952171.4903)
,p_lov_name=>'CONTROL BREAK GROUPS'
,p_lov_query=>'.'||wwv_flow_api.id(22978927746952171.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22979110471952172.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Alle Kontrollgruppenwechsel'
,p_lov_return_value=>'ALL_GROUPS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22979300855952172.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Einen Kontrollgruppenwechsel'
,p_lov_return_value=>'ONE_GROUP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_data_or_report
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(173236520362944199.4903)
,p_lov_name=>'CREATE DATA OR REPORT'
,p_lov_query=>'.'||wwv_flow_api.id(173236520362944199.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(173236715134944199.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Daten-Grid'
,p_lov_return_value=>'DATA'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:205:&SESSION.:::205"><img src="#IMAGE_PREFIX#menu/wiz_interactive_report_140x90.gif" height="90" width="140" alt="#DISPLAY_VAL'
||'UE#" class="htmldbGreenIcons" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(181301630402676517.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Bericht'
,p_lov_return_value=>'REPORT'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:1310:&SESSION.:::1310,1320"><img src="#IMAGE_PREFIX#menu/wiz_interactive_report_140x90.gif" height="90" width="140" alt="#DISP'
||'LAY_VALUE#" class="htmldbGreenIcons" /></a></td><td>&nbsp;</td></tr></table>'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_security.current_user_is_not_reader',
'and wwv_flow_ws_security.sql_enabled(:WS_APP_ID)',
'and wwv_flow_ws_security.sql_enabled_inst()'))
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_text_section_method
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(18725515716010637.4903)
,p_lov_name=>'CREATE TEXT SECTION METHOD'
,p_lov_query=>'.'||wwv_flow_api.id(18725515716010637.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(18725807766010639.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Einzelnen Textabschnitt erstellen'
,p_lov_return_value=>'NORMAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(18726004246010640.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Mehrere Textabschnitte aus Arbeitsblatt erstellen'
,p_lov_return_value=>'SPREADSHEET'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_worksheet_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(2960208403984068.4903)
,p_lov_name=>'CREATE WORKSHEET OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(2960208403984068.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2960523083984070.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('V\00F6llig neu')
,p_lov_return_value=>'SCRATCH'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:201:&SESSION.:::201,WS_WIZ_COLUMNS"><img src="#IMAGE_PREFIX#ws/ws-from-scratch.png" height="128" width="128" alt="#DISPLAY_VAL'
||'UE#" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(2960708902984070.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Kopieren und einf\00FCgen')
,p_lov_return_value=>'CUTANDPASTE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:206:&SESSION.:::206,CLOB_CONTENT,RP"><img src="#IMAGE_PREFIX#ws/ws-copy-paste.png" height="128" width="128" alt="#DISPLAY_VALU'
||'E#" /></a></td><td>&nbsp;</td></tr></table>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_ws_auth_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174618728240220381.4903)
,p_lov_name=>'CREATE_WS_AUTH_OPTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, v from (',
'select ',
'  :product_name||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/admin_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d ,''HTML DB'' v from dual',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.NO_AUTH'')||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/opendoor_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d,''DATABASE'' v from dual',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.DBACCOUNT'')||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/dbauth_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d,''DBACCOUNT'' v from dual)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_grid
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(179694201378826303.4903)
,p_lov_name=>'DATA GRID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_section_style
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(746262913082105905.4903)
,p_lov_name=>'DATA SECTION STYLE'
,p_lov_query=>'.'||wwv_flow_api.id(746262913082105905.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(746263201593105907.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Formatvorlage 1'
,p_lov_return_value=>'1'
,p_lov_template=>'<img src="#IMAGE_PREFIX#ws/report_style_1.gif" height="48" width="128" alt="#DISPLAY_VALUE#" class="radioGroupImage"/>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(746263432526105909.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Formatvorlage 2'
,p_lov_return_value=>'2'
,p_lov_template=>'<img src="#IMAGE_PREFIX#ws/report_style_2.gif" height="48" width="128" alt="#DISPLAY_VALUE#" class="radioGroupImage"/>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(746263605381105909.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Formatvorlage 3'
,p_lov_return_value=>'3'
,p_lov_template=>'<img src="#IMAGE_PREFIX#ws/report_style_3.gif" height="48" width="128" alt="#DISPLAY_VALUE#" class="radioGroupImage"/>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_grid_returning_worksheet_id
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(745648018052041064.4903)
,p_lov_name=>'DATA_GRID_RETURNING_WORKSHEET_ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.websheet_name d, w.id r',
'from wwv_flow_ws_websheet_attr a, wwv_flow_worksheets w',
'where a.worksheet_id = w.id',
'and a.ws_app_id = :ws_app_id',
'and a.security_group_id = :flow_security_group_id',
'and a.websheet_type = ''DATA'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_with_user_saved_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(497241820310060978.4903)
,p_lov_name=>'DATA_WITH_USER_SAVED_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ws.websheet_name d, ws.websheet_name r',
'from wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'wwv_flow_ws_applications a,',
'wwv_flow_ws_websheet_attr ws',
'where a.id = ws.ws_app_id',
'and ws.worksheet_id = i.id',
'and r.worksheet_id = i.id',
'and r.websheet_id is not null',
'and r.security_group_id = :flow_security_group_id',
'and a.id = :ws_app_id',
'and r.application_user = :app_user',
'and r.session_id is null',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/date_format_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(460140315153255042.4903)
,p_lov_name=>'DATE_FORMAT_LOV'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from wwv_flow_format_masks',
' where t=''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_rows
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(161072331491917913.4903)
,p_lov_name=>'DISPLAY ROWS'
,p_lov_query=>'.'||wwv_flow_api.id(161072331491917913.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161075705996920049.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161076108073920614.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161072510215917914.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161072713820917914.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161072930490917914.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161073118910917914.4903)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161073314283917914.4903)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161073520539917914.4903)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161073726945917914.4903)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161073905737917914.4903)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'200'
,p_lov_return_value=>'200'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161074106700917914.4903)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161074329336917914.4903)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161074529716917914.4903)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177272802329654940.4903)
,p_lov_disp_sequence=>9999
,p_lov_disp_value=>'Alle'
,p_lov_return_value=>'100000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/expression_types_column_value
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(175787711198660520.4903)
,p_lov_name=>'EXPRESSION TYPES (COLUMN/VALUE)'
,p_lov_query=>'.'||wwv_flow_api.id(175787711198660520.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(175788023327660521.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Wert'
,p_lov_return_value=>'VALUE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(175788232491660521.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Spalte'
,p_lov_return_value=>'COLUMN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/feedback_component
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(945870019196474793.4903)
,p_lov_name=>'FEEDBACK_COMPONENT'
,p_lov_query=>'.'||wwv_flow_api.id(945870019196474793.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945870326932474795.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Daten-Grid'
,p_lov_return_value=>'Datagrid'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945870517003474796.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Seite'
,p_lov_return_value=>'Page'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945870730487474797.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Zugriffskontrolle'
,p_lov_return_value=>'Access Control'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945870930916474797.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Bericht'
,p_lov_return_value=>'Report'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945871101913474797.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Markup-Syntax'
,p_lov_return_value=>'Markup Syntax'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(945871316354474797.4903)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Weitere'
,p_lov_return_value=>'Other'
);
end;
/
prompt --application/shared_components/user_interface/lovs/first_row_contains_column_headings
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(799517811838484369.4903)
,p_lov_name=>'FIRST_ROW_CONTAINS_COLUMN_HEADINGS'
,p_lov_query=>'.'||wwv_flow_api.id(799517811838484369.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(799518019833484371.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Erste Zeile enth\00E4lt Spalten\00FCberschriften')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(187514328189059218.4903)
,p_lov_name=>'FORMAT MASK DYNAMIC'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'from wwv_flow_format_masks'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/hr_column_names
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(162817307492916433.4903)
,p_lov_name=>'HR COLUMN NAMES'
,p_lov_query=>'.'||wwv_flow_api.id(162817307492916433.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162817620426916433.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vorname'
,p_lov_return_value=>'FIRST_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162817815634916433.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nachname'
,p_lov_return_value=>'LAST_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162818030292916433.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Vollst\00E4ndiger Name')
,p_lov_return_value=>'FULL_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(162818210247916433.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'E-Mail-Adresse'
,p_lov_return_value=>'EMAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/hr_column_names_for_seeding
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(166804518636616614.4903)
,p_lov_name=>'HR COLUMN NAMES (FOR SEEDING)'
,p_lov_query=>'.'||wwv_flow_api.id(166804518636616614.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166804814185616615.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vorname'
,p_lov_return_value=>'FIRST_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166805014333616615.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nachname'
,p_lov_return_value=>'LAST_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166805200851616615.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'E-Mail-Adresse'
,p_lov_return_value=>'EMAIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166805429286616615.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Name weiterleiten'
,p_lov_return_value=>'FORWARD_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166807720152626504.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Name r\00FCckg\00E4ngig machen')
,p_lov_return_value=>'REVERSE_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166808026385628340.4903)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'GUID'
,p_lov_return_value=>'USERID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166808400544630345.4903)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Beliebig bestimmbarer Name'
,p_lov_return_value=>'TITLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166808808855632713.4903)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Kostenstelle'
,p_lov_return_value=>'COST_CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166809111972633632.4903)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Organisation'
,p_lov_return_value=>'ORGANIZATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166809515781634745.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Telefon (gesch\00E4ftlich)')
,p_lov_return_value=>'WORK_PHONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166809820629636090.4903)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('Gesch\00E4ftsadresse (Geb\00E4ude)')
,p_lov_return_value=>'WORK_BUILDING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166810125131637429.4903)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('Gesch\00E4ftsadresse (Stockwerk)')
,p_lov_return_value=>'WORK_FLOOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166810430672639004.4903)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>unistr('Telefonnummer gesch\00E4ftlich')
,p_lov_return_value=>'WORK_OFFICE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166810803099640515.4903)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>unistr('B\00FCroadresse')
,p_lov_return_value=>'WORK_ADDR1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166811408293641989.4903)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>unistr('Gesch\00E4ftsadresse (Stadt)')
,p_lov_return_value=>'WORK_CITY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166812011410642946.4903)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>unistr('Gesch\00E4ftsadresse (Bundesland)')
,p_lov_return_value=>'WORK_STATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166812416605644416.4903)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>unistr('Gesch\00E4ftsadresse (Postleitzahl)')
,p_lov_return_value=>'WORK_ZIP'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166812722492646170.4903)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>unistr('Gesch\00E4ftsadresse (Land)')
,p_lov_return_value=>'WORK_COUNTRY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166813328033647779.4903)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Mitarbeiter'
,p_lov_return_value=>'DIRECTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166813732188648908.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Berichte insgesamt'
,p_lov_return_value=>'TOTAL_REPORTS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(166814003230649994.4903)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Ist Manager?'
,p_lov_return_value=>'IS_MANAGER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_languages_locales
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(502587106305037128.4903)
,p_lov_name=>'I18N_LANGUAGES_LOCALES'
,p_reference_id=>107899321117195063.4903
,p_lov_query=>'.'||wwv_flow_api.id(502587106305037128.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699077671048180068.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Aserbaidschanisch (az)'
,p_lov_return_value=>'az'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699078037978180068.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Afrikaans (af)'
,p_lov_return_value=>'af'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699078405074180068.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (ar)'
,p_lov_return_value=>'ar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699078828289180068.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Algerien) (ar-dz)'
,p_lov_return_value=>'ar-dz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699079234537180069.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Bahrain) (ar-bh)'
,p_lov_return_value=>'ar-bh'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699079606258180069.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Arabisch (\00C4gypten) (ar-eg)')
,p_lov_return_value=>'ar-eg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699080050912180069.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Irak) (ar-iq)'
,p_lov_return_value=>'ar-iq'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699080454215180069.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Jordanien) (ar-jo)'
,p_lov_return_value=>'ar-jo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699080864791180070.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Kuwait) (ar-kw)'
,p_lov_return_value=>'ar-kw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699081255911180070.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Libanon) (ar-lb)'
,p_lov_return_value=>'ar-lb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699081603517180070.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Libyen) (ar-ly)'
,p_lov_return_value=>'ar-ly'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699082008415180070.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Marokko) (ar-ma)'
,p_lov_return_value=>'ar-ma'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699082459066180070.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Oman) (ar-om)'
,p_lov_return_value=>'ar-om'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699082811282180071.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Katar) (ar-qa)'
,p_lov_return_value=>'ar-qa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699083231940180071.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Saudi-Arabien) (ar-sa)'
,p_lov_return_value=>'ar-sa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699083518057180071.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Syrien) (ar-sy)'
,p_lov_return_value=>'ar-sy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699083935661180071.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Tunesien) (ar-tn)'
,p_lov_return_value=>'ar-tn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699084301028180072.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Vereinigte Arabische Emirate) (ar-ae)'
,p_lov_return_value=>'ar-ae'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699084726592180072.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabisch (Jemen) (ar-ye)'
,p_lov_return_value=>'ar-ye'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699085149541180072.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Assamisch (as)'
,p_lov_return_value=>'as'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699085551541180073.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Baskisch (eu)'
,p_lov_return_value=>'eu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699085941439180073.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Wei\00DFrussisch (be)')
,p_lov_return_value=>'be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699086317208180073.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bengalisch (bn)'
,p_lov_return_value=>'bn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699086722772180073.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgarisch (bg)'
,p_lov_return_value=>'bg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699087134419180073.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Katalanisch (ca)'
,p_lov_return_value=>'ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699087520210180074.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinesisch (zh)'
,p_lov_return_value=>'zh'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699087954139180074.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinesisch (China) (zh-cn)'
,p_lov_return_value=>'zh-cn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699088321602180074.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinesisch (Hongkong SAR) (zh-hk)'
,p_lov_return_value=>'zh-hk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699088718989180074.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinesisch (Macau SAR) (zh-mo)'
,p_lov_return_value=>'zh-mo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699089197590180075.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinesisch (Singapur) (zh-sg)'
,p_lov_return_value=>'zh-sg'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699089584303180075.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinesisch (Taiwan) (zh-tw)'
,p_lov_return_value=>'zh-tw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699089965064180075.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kroatisch (hr)'
,p_lov_return_value=>'hr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699090330404180075.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tschechisch (cs)'
,p_lov_return_value=>'cs'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699090719346180076.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('D\00E4nisch (da)')
,p_lov_return_value=>'da'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699091122669180076.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Niederl\00E4ndisch (Belgien) (nl-be)')
,p_lov_return_value=>'nl-be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699091589403180076.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Niederl\00E4ndisch (Niederlande) (nl)')
,p_lov_return_value=>'nl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699091971660180076.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch (en)'
,p_lov_return_value=>'en'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699092358936180076.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch (Australien) (en-au)'
,p_lov_return_value=>'en-au'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699092773809180077.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch (Belize) (en-bz)'
,p_lov_return_value=>'en-bz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699093124993180077.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch (Kanada) (en-ca)'
,p_lov_return_value=>'en-ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699093521574180077.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch (Irland) (en-ie)'
,p_lov_return_value=>'en-ie'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699093981695180077.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch (Jamaika) (en-jm)'
,p_lov_return_value=>'en-jm'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699094398450180078.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch (Neuseeland) (en-nz)'
,p_lov_return_value=>'en-nz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699094718902180078.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch (Philippinen) (en-ph)'
,p_lov_return_value=>'en-ph'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699095171931180078.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Englisch (S\00FCdafrika) (en-za)')
,p_lov_return_value=>'en-za'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699095556248180078.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch (Trinidad) (en-tt)'
,p_lov_return_value=>'en-tt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699095900882180078.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Englisch (Gro\00DFbritannien) (en-gb)')
,p_lov_return_value=>'en-gb'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699096397022180079.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch (USA) (en-us)'
,p_lov_return_value=>'en-us'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699096756533180079.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch (Simbabwe) (en-zw)'
,p_lov_return_value=>'en-zw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699097111707180079.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estnisch (et)'
,p_lov_return_value=>'et'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699097569130180079.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'FYRO Mazedonisch (mk)'
,p_lov_return_value=>'mk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699097901194180080.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('F\00E4r\00F6isch (fo)')
,p_lov_return_value=>'fo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699098392128180080.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Farsi (fa)'
,p_lov_return_value=>'fa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699098761314180080.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franz\00F6sisch (Schweiz) [fr-ch]')
,p_lov_return_value=>'fr-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699099157140180080.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finnisch (fi)'
,p_lov_return_value=>'fi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699099528056180081.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franz\00F6sisch (Belgien) (fr-be)')
,p_lov_return_value=>'fr-be'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699099985670180081.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franz\00F6sisch (Kanada) (fr-ca)')
,p_lov_return_value=>'fr-ca'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699100362011180081.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franz\00F6sisch (Frankreich) (fr)')
,p_lov_return_value=>'fr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699100749619180081.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franz\00F6sisch (Luxemburg) (fr-lu)')
,p_lov_return_value=>'fr-lu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699101188548180082.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franz\00F6sisch (Monaco) (fr-mc)')
,p_lov_return_value=>'fr-mc'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699101509999180082.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('G\00E4lisch (gd)')
,p_lov_return_value=>'gd'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699101965546180082.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Galizisch (gl)'
,p_lov_return_value=>'gl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699102367955180082.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Deutsch (\00D6sterreich) (de-at)')
,p_lov_return_value=>'de-at'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699102767340180083.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Deutsch (Deutschland) (de)'
,p_lov_return_value=>'de'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699103114120180083.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Deutsch (Liechtenstein) (de-li)'
,p_lov_return_value=>'de-li'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699103543063180083.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Deutsch (Luxemburg) (de-lu)'
,p_lov_return_value=>'de-lu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699103949411180083.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Deutsch (Schweiz) (de-ch)'
,p_lov_return_value=>'de-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699104368944180083.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Griechisch (el)'
,p_lov_return_value=>'el'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699104710217180084.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gudschrati (gu)'
,p_lov_return_value=>'gu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699105112508180084.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Hebr\00E4isch (he)')
,p_lov_return_value=>'he'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699105550789180084.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hindi (hi)'
,p_lov_return_value=>'hi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699105901185180085.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ungarisch (hu)'
,p_lov_return_value=>'hu'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699106301886180085.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Isl\00E4ndisch (is)')
,p_lov_return_value=>'is'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699106757512180085.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indonesisch (id)'
,p_lov_return_value=>'id'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699107115109180085.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italienisch (Italien) (it)'
,p_lov_return_value=>'it'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699107521210180086.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italienisch (Schweiz) (it-ch)'
,p_lov_return_value=>'it-ch'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699107936215180086.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japanisch (ja)'
,p_lov_return_value=>'ja'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699108362538180086.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kannada (kn)'
,p_lov_return_value=>'kn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699108709201180086.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kasachisch (kk)'
,p_lov_return_value=>'kk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699109156123180086.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Konkani (kok)'
,p_lov_return_value=>'kok'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699109579709180087.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Koreanisch (ko)'
,p_lov_return_value=>'ko'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699109999363180087.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kirgisisch (kz)'
,p_lov_return_value=>'kz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699110323574180087.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lettisch (lv)'
,p_lov_return_value=>'lv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699110750109180087.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Litauisch (lt)'
,p_lov_return_value=>'lt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699111197428180088.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malaiisch (Malaysia) (ms)'
,p_lov_return_value=>'ms'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699111558985180088.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malajalam (ml)'
,p_lov_return_value=>'ml'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699111988302180088.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Maltesisch (mt)'
,p_lov_return_value=>'mt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699112318794180088.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Marathi (mr)'
,p_lov_return_value=>'mr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699112751141180088.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nepalesisch (Indien) (ne)'
,p_lov_return_value=>'ne'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699113167827180089.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegisch (Bokmal) (nb-no)'
,p_lov_return_value=>'nb-no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699113521452180089.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegisch (Bokmal) (no)'
,p_lov_return_value=>'no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699113935508180089.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegisch (Nynorsk) (nn-no)'
,p_lov_return_value=>'nn-no'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699114353177180089.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oriya (or)'
,p_lov_return_value=>'or'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699114731122180089.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Polnisch (pl)'
,p_lov_return_value=>'pl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699115176842180090.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portugiesisch (Brasilien) (pt-br)'
,p_lov_return_value=>'pt-br'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699115528210180090.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portugiesisch (Portugal) (pt)'
,p_lov_return_value=>'pt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699115900344180090.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Punjabi (pa)'
,p_lov_return_value=>'pa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699116347937180090.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Rum\00E4nisch (ro)')
,p_lov_return_value=>'ro'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699116720955180091.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russisch (ru)'
,p_lov_return_value=>'ru'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699117177554180091.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russisch (Moldawien) (ru-md)'
,p_lov_return_value=>'ru-md'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699117577240180091.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbisch (sr)'
,p_lov_return_value=>'sr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699117988910180091.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slowakisch (sk)'
,p_lov_return_value=>'sk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699118314040180091.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slowenisch (sl)'
,p_lov_return_value=>'sl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699118753922180092.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Argentinien) (es-ar)'
,p_lov_return_value=>'es-ar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699119188393180092.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Bolivien) (es-bo)'
,p_lov_return_value=>'es-bo'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699119581631180092.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Chile) (es-cl)'
,p_lov_return_value=>'es-cl'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699119997191180092.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Kolumbien) (es-co)'
,p_lov_return_value=>'es-co'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699120318838180092.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Costa Rica) (es-cr)'
,p_lov_return_value=>'es-cr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699120709109180093.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Dominikanische Republik) (es-do)'
,p_lov_return_value=>'es-do'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699121134727180093.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Ecuador) (es-ec)'
,p_lov_return_value=>'es-ec'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699121568485180093.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (El Salvador) (es-sv)'
,p_lov_return_value=>'es-sv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699121921139180093.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Guatemala) (es-gt)'
,p_lov_return_value=>'es-gt'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699122338312180094.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Honduras) (es-hn)'
,p_lov_return_value=>'es-hn'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699122706175180094.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Mexiko) (es-mx)'
,p_lov_return_value=>'es-mx'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699123193173180094.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Nicaragua) (es-ni)'
,p_lov_return_value=>'es-ni'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699123576249180094.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Panama) (es-pa)'
,p_lov_return_value=>'es-pa'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699123952759180094.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Paraguay) (es-py)'
,p_lov_return_value=>'es-py'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699124377656180095.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Peru) (es-pe)'
,p_lov_return_value=>'es-pe'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699124748226180095.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Puerto Rico) (es-pr)'
,p_lov_return_value=>'es-pr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699125127369180095.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Traditionell) (es)'
,p_lov_return_value=>'es'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699125511532180095.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (USA) (es-us)'
,p_lov_return_value=>'es-us'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699125971306180096.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Uruguay) (es-uy)'
,p_lov_return_value=>'es-uy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699126309761180096.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch (Venezuela) (es-ve)'
,p_lov_return_value=>'es-ve'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699126741047180096.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Schwedisch (sv)'
,p_lov_return_value=>'sv'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699127176377180096.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Schwedisch (Finnland) (sv-fi)'
,p_lov_return_value=>'sv-fi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699127597883180096.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tamilisch (ta)'
,p_lov_return_value=>'ta'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699127927061180097.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Telugu (te)'
,p_lov_return_value=>'te'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699128382178180097.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Thail\00E4ndisch (th)')
,p_lov_return_value=>'th'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699128731024180097.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('T\00FCrkisch (tr)')
,p_lov_return_value=>'tr'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699129157411180097.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukrainisch (uk)'
,p_lov_return_value=>'uk'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699129585255180098.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Urdu (ur)'
,p_lov_return_value=>'ur'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699129971575180098.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Usbekisch (uz)'
,p_lov_return_value=>'uz'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699130356540180098.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnamesisch (vi)'
,p_lov_return_value=>'vi'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699130787098180098.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irisch (ga)'
,p_lov_return_value=>'ga'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699131129792180100.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Walisisch (cy)'
,p_lov_return_value=>'cy'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699131522308180101.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Suaheli (sw)'
,p_lov_return_value=>'sw'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699131990424180101.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Albanisch'
,p_lov_return_value=>'sq'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(699132366271180101.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Armenisch'
,p_lov_return_value=>'hy'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_territories
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(634728210841234369.4903)
,p_lov_name=>'I18N_TERRITORIES'
,p_reference_id=>634612723768159258.4903
,p_lov_query=>'.'||wwv_flow_api.id(634728210841234369.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62768512046442477.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Aserbaidschan'
,p_lov_return_value=>'AZERBAIJAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62768930505442477.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Algerien'
,p_lov_return_value=>'ALGERIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62769309199442477.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Amerika'
,p_lov_return_value=>'AMERICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62769770701442478.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Argentinien'
,p_lov_return_value=>'ARGENTINA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62770125083442478.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Australien'
,p_lov_return_value=>'AUSTRALIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62770576591442478.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00D6sterreich')
,p_lov_return_value=>'AUSTRIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62770950179442478.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bahrain'
,p_lov_return_value=>'BAHRAIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62771329653442479.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bangladesch'
,p_lov_return_value=>'BANGLADESH'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62771751169442479.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Belgien'
,p_lov_return_value=>'BELGIUM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62772126105442479.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Brasilien'
,p_lov_return_value=>'BRAZIL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62772555136442479.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgarien'
,p_lov_return_value=>'BULGARIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62772924789442480.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kanada'
,p_lov_return_value=>'CANADA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62773397498442480.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Katalonien'
,p_lov_return_value=>'CATALONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62773715833442480.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chile'
,p_lov_return_value=>'CHILE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62774123927442480.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'China'
,p_lov_return_value=>'CHINA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62774562332442481.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kolumbien'
,p_lov_return_value=>'COLOMBIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62774972634442481.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Costa Rica'
,p_lov_return_value=>'COSTA RICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62775351297442481.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kroatien'
,p_lov_return_value=>'CROATIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62775747407442481.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tschechische Republik'
,p_lov_return_value=>'CZECH REPUBLIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62776195701442481.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('D\00E4nemark')
,p_lov_return_value=>'DENMARK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62776502463442482.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ecuador'
,p_lov_return_value=>'ECUADOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62776904673442482.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('\00C4gypten')
,p_lov_return_value=>'EGYPT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62777371218442482.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'El Salvador'
,p_lov_return_value=>'EL SALVADOR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62777721576442482.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estland'
,p_lov_return_value=>'ESTONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62778182718442483.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finnland'
,p_lov_return_value=>'FINLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62778552942442483.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Frankreich'
,p_lov_return_value=>'FRANCE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62778904538442483.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mazedonien'
,p_lov_return_value=>'FYR MACEDONIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62779355380442483.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Deutschland'
,p_lov_return_value=>'GERMANY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62779707068442484.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Griechenland'
,p_lov_return_value=>'GREECE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62780191281442484.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Guatemala'
,p_lov_return_value=>'GUATEMALA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62780570482442484.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hongkong'
,p_lov_return_value=>'HONG KONG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62780972409442484.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ungarn'
,p_lov_return_value=>'HUNGARY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62781310225442485.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Island'
,p_lov_return_value=>'ICELAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62781759163442485.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indien'
,p_lov_return_value=>'INDIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62782151355442485.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indonesien'
,p_lov_return_value=>'INDONESIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62782519713442486.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irak'
,p_lov_return_value=>'IRAQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62782982144442486.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irland'
,p_lov_return_value=>'IRELAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62783350927442486.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Israel'
,p_lov_return_value=>'ISRAEL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62783797822442486.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italien'
,p_lov_return_value=>'ITALY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62784141001442486.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japan'
,p_lov_return_value=>'JAPAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62784519265442487.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Jordanien'
,p_lov_return_value=>'JORDAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62784913226442487.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kasachstan'
,p_lov_return_value=>'KAZAKHSTAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62785308333442487.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Korea'
,p_lov_return_value=>'KOREA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62785717099442487.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kuwait'
,p_lov_return_value=>'KUWAIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62786101932442488.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lettland'
,p_lov_return_value=>'LATVIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62786558628442488.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Libanon'
,p_lov_return_value=>'LEBANON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62786952129442488.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Libyen'
,p_lov_return_value=>'LIBYA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62787323890442488.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Litauen'
,p_lov_return_value=>'LITHUANIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62787782538442489.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Luxemburg'
,p_lov_return_value=>'LUXEMBOURG'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62788182614442489.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malaysia'
,p_lov_return_value=>'MALAYSIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62788528479442489.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mexiko'
,p_lov_return_value=>'MEXICO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62788997279442490.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Marokko'
,p_lov_return_value=>'MOROCCO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62789325661442490.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Neuseeland'
,p_lov_return_value=>'NEW ZEALAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62789782549442490.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nicaragua'
,p_lov_return_value=>'NICARAGUA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62790133238442490.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegen'
,p_lov_return_value=>'NORWAY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62790562008442491.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oman'
,p_lov_return_value=>'OMAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62790923765442491.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Panama'
,p_lov_return_value=>'PANAMA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62791326115442491.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Peru'
,p_lov_return_value=>'PERU'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62791722352442491.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Philippinen'
,p_lov_return_value=>'PHILIPPINES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62792127389442492.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Polen'
,p_lov_return_value=>'POLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62792532827442492.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portugal'
,p_lov_return_value=>'PORTUGAL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62792943133442492.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Puerto Rico'
,p_lov_return_value=>'PUERTO RICO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62793345569442492.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Katar'
,p_lov_return_value=>'QATAR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62793726564442493.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Rum\00E4nien')
,p_lov_return_value=>'ROMANIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62794173620442493.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russland'
,p_lov_return_value=>'RUSSIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62794528506442493.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Saudi-Arabien'
,p_lov_return_value=>'SAUDI ARABIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62794957133442493.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbien und Montenegro'
,p_lov_return_value=>'SERBIA AND MONTENEGRO'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62795307781442494.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Singapur'
,p_lov_return_value=>'SINGAPORE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62795777034442494.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slowakei'
,p_lov_return_value=>'SLOVAKIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62796162893442494.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slowenien'
,p_lov_return_value=>'SLOVENIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62796548292442494.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('S\00FCdafrika')
,p_lov_return_value=>'SOUTH AFRICA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62796908133442495.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanien'
,p_lov_return_value=>'SPAIN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62797382995442495.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Schweden'
,p_lov_return_value=>'SWEDEN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62797757964442495.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Schweiz'
,p_lov_return_value=>'SWITZERLAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62798128335442495.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Syrien'
,p_lov_return_value=>'SYRIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62798526167442495.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Taiwan'
,p_lov_return_value=>'TAIWAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62798964210442496.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Thailand'
,p_lov_return_value=>'THAILAND'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62799338177442496.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Niederlande'
,p_lov_return_value=>'THE NETHERLANDS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62799783102442496.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tunesien'
,p_lov_return_value=>'TUNISIA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62800138392442496.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('T\00FCrkei')
,p_lov_return_value=>'TURKEY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62800521279442497.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukraine'
,p_lov_return_value=>'UKRAINE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62800975328442497.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vereinigte Arabische Emirate'
,p_lov_return_value=>'UNITED ARAB EMIRATES'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62801343830442497.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Gro\00DFbritannien')
,p_lov_return_value=>'UNITED KINGDOM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62801707976442497.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Usbekistan'
,p_lov_return_value=>'UZBEKISTAN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62802182931442498.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Venezuela'
,p_lov_return_value=>'VENEZUELA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62802531981442498.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnam'
,p_lov_return_value=>'VIETNAM'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(62802931670442498.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Jemen'
,p_lov_return_value=>'YEMEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_clear_settings
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184141723318598286.4903)
,p_lov_name=>'IR_CLEAR_SETTINGS'
,p_lov_query=>'.'||wwv_flow_api.id(184141723318598286.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184141903129598286.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Berichteinstellungen l\00F6schen')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_column_filter_lov
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(187536631811296748.4903)
,p_lov_name=>'IR_COLUMN_FILTER_LOV'
,p_lov_query=>'.'||wwv_flow_api.id(187536631811296748.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187536803714296749.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Keine'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187537027390296749.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Standard basierend auf Spaltentyp'
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187537221036296749.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Zum Filtern nach genauer \00DCbereinstimmung definierte Werteliste verwenden')
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187537420494296749.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Zum Filtern nach Wortinhalt definierte Werteliste verwenden'
,p_lov_return_value=>'C'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_column_functionality
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(187521603695108878.4903)
,p_lov_name=>'IR_COLUMN_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_api.id(187521603695108878.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(261252015294852290.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Ausblenden'
,p_lov_return_value=>'HIDE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187521815724108878.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Sortieren'
,p_lov_return_value=>'SORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187522018417108878.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Filtern'
,p_lov_return_value=>'FILTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187522228192108878.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Markieren'
,p_lov_return_value=>'HIGHLIGHT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187522424754108878.4903)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Kontrollgruppenwechsel'
,p_lov_return_value=>'BREAK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187522603425108878.4903)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Aggregieren'
,p_lov_return_value=>'AGGREGATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187522808972108878.4903)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Berechnen'
,p_lov_return_value=>'COMPUTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187523010729108878.4903)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Diagramm'
,p_lov_return_value=>'CHART'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187523228523108878.4903)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Gruppieren nach'
,p_lov_return_value=>'GROUP_BY'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(3701401105670.4903)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Pivot'
,p_lov_return_value=>'PIVOT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_detail_page_functionality
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184015632435758855.4903)
,p_lov_name=>'IR_DETAIL_PAGE_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_api.id(184015632435758855.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184015811357758856.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Ausschlie\00DFen von Nullwerten zulassen')
,p_lov_return_value=>'EXCLUDE_NULL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184016009426758856.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Angezeigte Spalten zulassen'
,p_lov_return_value=>'HIDE_EXTR_COL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_display_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(183810312847513834.4903)
,p_lov_name=>'IR_DISPLAY_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(183810312847513834.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183810509783513835.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Standardberichtspalte'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183810717133513835.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Als Text anzeigen (Sonderzeichen escapen)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(450527627281054238.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'HTML entfernen und Sonderzeichen escapen'
,p_lov_return_value=>'STRIP_HTML_ESCAPE_SC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183810915056513835.4903)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Ausgeblendet'
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_link_column
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184013026632738314.4903)
,p_lov_name=>'IR_LINK_COLUMN'
,p_lov_query=>'.'||wwv_flow_api.id(184013026632738314.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184013223015738314.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Link zu Single Row-Ansicht'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184013402164738315.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Link zu benutzerdefiniertem Ziel'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184013623895738315.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Linkspalte ausschlie\00DFen')
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_link_operator
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184114411019556922.4903)
,p_lov_name=>'IR_LINK_OPERATOR'
,p_lov_query=>'.'||wwv_flow_api.id(184114411019556922.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184114626877556922.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ist gleich'
,p_lov_return_value=>'EQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184114812403556922.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Ist nicht gleich'
,p_lov_return_value=>'NEQ'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184115009808556923.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Kleiner als'
,p_lov_return_value=>'LT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184115216118556923.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Kleiner als oder gleich'
,p_lov_return_value=>'LTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184115410372556923.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>unistr('Gr\00F6\00DFer als')
,p_lov_return_value=>'GT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184115603175556923.4903)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>unistr('Gr\00F6\00DFer als oder gleich')
,p_lov_return_value=>'GTE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184115811804556923.4903)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'SQL Like-Operator'
,p_lov_return_value=>'LIKE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184116014545556923.4903)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Null'
,p_lov_return_value=>'N'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184116211240556923.4903)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Nicht Null'
,p_lov_return_value=>'NN'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184116429729556923.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Enth\00E4lt')
,p_lov_return_value=>'C '
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184116600682556923.4903)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>unistr('Enth\00E4lt nicht')
,p_lov_return_value=>'NC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184116820056556923.4903)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>unistr('Zeile enth\00E4lt')
,p_lov_return_value=>'IR_ROWFILTER '
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_interval
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(497258407132255912.4903)
,p_lov_name=>'IR_NOTIFY_INTERVAL'
,p_lov_query=>'.'||wwv_flow_api.id(497258407132255912.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(497258621830255914.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('T\00E4glich')
,p_lov_return_value=>'D'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(497258807889255918.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('W\00F6chentlich')
,p_lov_return_value=>'W'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(497259008562255918.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Monatlich'
,p_lov_return_value=>'M'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_pagination_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(183988226651539622.4903)
,p_lov_name=>'IR_PAGINATION_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(183988226651539622.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183988425548539651.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Zeilenbereiche X bis Y von Z'
,p_lov_return_value=>'ROWS_X_TO_Y_OF_Z'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(183988600836539651.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Zeilenbereiche X bis Y'
,p_lov_return_value=>'ROWS_X_TO_Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_reports_in_current_app
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184030311010131156.4903)
,p_lov_name=>'IR_REPORTS_IN_CURRENT_APP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT''',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_reset
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184090310224424164.4903)
,p_lov_name=>'IR_RESET'
,p_lov_query=>'.'||wwv_flow_api.id(184090310224424164.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184090518146424166.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Bericht zur\00FCcksetzen')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_rowid_or_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184017715035772751.4903)
,p_lov_name=>'IR_ROWID_OR_COLS'
,p_lov_query=>'.'||wwv_flow_api.id(184017715035772751.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184017914148772751.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'ROWID'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184018110509772751.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Eindeutige Spalte'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_same_label_for_detail_view
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(187510818230037360.4903)
,p_lov_name=>'IR_SAME_LABEL_FOR_DETAIL_VIEW'
,p_lov_query=>'.'||wwv_flow_api.id(187510818230037360.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(187511006081037360.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Gleichen Text f\00FCr Single Row-Ansicht verwenden')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/languages_installed
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(631691002719703351.4903)
,p_lov_name=>'LANGUAGES_INSTALLED'
,p_reference_id=>631619712812572565.4903
,p_lov_query=>'.'||wwv_flow_api.id(631691002719703351.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797110708703121637.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Deutsch'
,p_lov_return_value=>'de'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''de'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797110905024121637.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Englisch'
,p_lov_return_value=>'en'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = (select v(''APP_ID'') from dual)',
'       and translation_flow_language_code = ''zh-cn'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797111115323121638.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanisch'
,p_lov_return_value=>'es'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''es'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797111316804121638.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Franz\00F6sisch')
,p_lov_return_value=>'fr'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''fr'')'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797111505126121638.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italienisch'
,p_lov_return_value=>'it'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''it'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797111712120121638.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japanisch'
,p_lov_return_value=>'ja'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''ja'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797111918483121638.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Koreanisch'
,p_lov_return_value=>'ko'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''ko'')'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797112116588121638.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portugiesisch (Brasilien)'
,p_lov_return_value=>'pt-br'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''pt-br'')         '))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797112313424121638.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinesisch (China)'
,p_lov_return_value=>'zh-cn'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''zh-cn'')'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(797112528313121640.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinesisch (Taiwan)'
,p_lov_return_value=>'zh-tw'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''zh-tw'')         '))
);
end;
/
prompt --application/shared_components/user_interface/lovs/language_derived_from
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(502656918406037207.4903)
,p_lov_name=>'LANGUAGE_DERIVED_FROM'
,p_lov_query=>'.'||wwv_flow_api.id(502656918406037207.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(502657718966037208.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Prim\00E4rsprache f\00FCr die Anwendung')
,p_lov_return_value=>'FLOW_PRIMARY_LANGUAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(502657317052037208.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Sprachspezifische Einstellungen des Browsers'
,p_lov_return_value=>'BROWSER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_application_pages
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(461381027000774471.4903)
,p_lov_name=>'LIST APPLICATION PAGES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(name,1,30) name , id',
'from wwv_flow_ws_webpages p',
'where  p.ws_app_id = :ws_app_id and security_group_id = :flow_security_group_id',
'order by name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/logo_attributes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(461438607298231622.4903)
,p_lov_name=>'LOGO ATTRIBUTES'
,p_reference_id=>461376702019738964.4903
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLACK_TEXT'') d, ''style="font-family:Arial; color:#000000; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''BLUE_TEXT'') d, ''style="font-family:Arial; color:#004C66; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''WHITE_TEXT'') d, ''style="font-family:Arial; color:#FFFFFF; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual',
'union all',
'select wwv_flow_lang.system_message(''GRAY_TEXT'') d, ''style="font-family:Arial; color:#303030; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''image_attributes'') d, ''alt="Application" title="Application"'' r from dual '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_from
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(88891506202224413.4903)
,p_lov_name=>'LOV_FROM'
,p_lov_query=>'.'||wwv_flow_api.id(88891506202224413.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88892002310224415.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gemeinsam verwendete Werteliste'
,p_lov_return_value=>'SHARED'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88891803220224415.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Eindeutige Spaltenwerte'
,p_lov_return_value=>'DISTINCT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(88938810600443285.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Neu erstellen'
,p_lov_return_value=>'CREATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/nav_section_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(178562403162170735.4903)
,p_lov_name=>'NAV_SECTION_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(178562403162170735.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178562620987170738.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Seitennavigation'
,p_lov_return_value=>'NAV_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(178562830738170741.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Abschnittsnavigation'
,p_lov_return_value=>'NAV_SECTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/order_by_direction
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(606013026952235682.4903)
,p_lov_name=>'ORDER_BY_DIRECTION'
,p_lov_query=>'.'||wwv_flow_api.id(606013026952235682.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(606013300020235684.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Aufsteigend'
,p_lov_return_value=>'ASC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(606013531554235685.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Absteigend'
,p_lov_return_value=>'DESC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p740_saved_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(429632313107701908.4903)
,p_lov_name=>'P740_SAVED_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p742_data_grid_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(261395425456539191.4903)
,p_lov_name=>'P742_DATA_GRID_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p742_data_grid_num_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(261459220009944453.4903)
,p_lov_name=>'P742_DATA_GRID_NUM_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and c.column_type = ''NUMBER''',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and column_type = ''NUMBER''',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p750_chart_source
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(428899916079615170.4903)
,p_lov_name=>'P750_CHART_SOURCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name||',
'       case when websheet_type=''DATA'' then '' (''||wwv_flow_lang.system_message(''DATA_GRID'')||'')''',
'            when websheet_type=''REPORT'' then '' (''||wwv_flow_lang.system_message(''REPORT'')||'')''',
'       end d,',
'       id r',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p760_chart_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(444797819996488091.4903)
,p_lov_name=>'P760_CHART_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(444797819996488091.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444798026947488095.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Balken'
,p_lov_return_value=>'bar'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444798216267488096.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Linien/Fl\00E4chen')
,p_lov_return_value=>'lineWithArea'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444798632016488096.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Kreis'
,p_lov_return_value=>'pie'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444798420560488096.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Zeile'
,p_lov_return_value=>'line'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p760_data_grid_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(293396605682831178.4903)
,p_lov_name=>'P760_DATA_GRID_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P760_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P760_SAVED_REPORT_ID',
'and websheet_id = :P760_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p760_data_grid_num_cols
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(424623105999868608.4903)
,p_lov_name=>'P760_DATA_GRID_NUM_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P760_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'and c.column_type = ''NUMBER''',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P760_SAVED_REPORT_ID',
'and websheet_id = :P760_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id',
'and column_type = ''NUMBER'')',
'where instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p760_saved_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(429677014294033232.4903)
,p_lov_name=>'P760_SAVED_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P760_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P760_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p922_datagrid_show_opt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(244084119358061944.4903)
,p_lov_name=>'P922_DATAGRID_SHOW_OPT'
,p_lov_query=>'.'||wwv_flow_api.id(244084119358061944.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244084422806061944.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Zeile hinzuf\00FCgen')
,p_lov_return_value=>'ADD_ROW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244084730829061948.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Zeile bearbeiten'
,p_lov_return_value=>'EDIT_ROW'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244085024367061948.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Suchfeld'
,p_lov_return_value=>'SEARCH'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p922_data_grid_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(178772114682347881.4903)
,p_lov_name=>'P922_DATA_GRID_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P922_DATA_GRID_ID',
'and d.security_group_id = :flow_security_group_id',
'order by display_order'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p922_report_show_opt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(244090113649098118.4903)
,p_lov_name=>'P922_REPORT_SHOW_OPT'
,p_lov_query=>'.'||wwv_flow_api.id(244090113649098118.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244091002759098119.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Suchfeld'
,p_lov_return_value=>'SEARCH'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p922_saved_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(430293730079245893.4903)
,p_lov_name=>'P922_SAVED_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION''',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION'') x',
'order by x.seq, x.r'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p925_data_section_style
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(244105603016227532.4903)
,p_lov_name=>'P925_DATA_SECTION_STYLE'
,p_lov_query=>'.'||wwv_flow_api.id(244105603016227532.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244105926056227533.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Formatvorlage 1'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244106215253227534.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Formatvorlage 2'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(244106500467227534.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Formatvorlage 3'
,p_lov_return_value=>'3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p934_data_section_show_opt
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(239269013341119720.4903)
,p_lov_name=>'P934_DATA_SECTION_SHOW_OPT'
,p_lov_query=>'.'||wwv_flow_api.id(239269013341119720.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(239269323845119720.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Zeile hinzuf\00FCgen')
,p_lov_return_value=>'ADD_ROW'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P934_WEBSHEET_TYPE'
,p_lov_disp_cond2=>'DATA_GRID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(239269606033119720.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Zeile bearbeiten'
,p_lov_return_value=>'EDIT_ROW'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P934_WEBSHEET_TYPE'
,p_lov_disp_cond2=>'DATA_GRID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(239269902232119720.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Suchfeld'
,p_lov_return_value=>'SEARCH'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p934_saved_reports
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(431037130827466603.4903)
,p_lov_name=>'P934_SAVED_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P934_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P934_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_email_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(473383419441178851.4903)
,p_lov_name=>'PAGE EMAIL OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(473383419441178851.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(473383631984178859.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'E-Mail-Link zu Seite'
,p_lov_return_value=>'LINK'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(473383814758178865.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'E-Mail-Seiteninhalt'
,p_lov_return_value=>'PAGE'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_navigation_order
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(381950720171699749.4903)
,p_lov_name=>'PAGE NAVIGATION ORDER'
,p_lov_query=>'.'||wwv_flow_api.id(381950720171699749.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(381951031098699751.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Seitenname'
,p_lov_return_value=>'PAGE_NAME'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(381951211109699752.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Erstellungsdatum'
,p_lov_return_value=>'CREATED_ON'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(381951400366699752.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Aktualisiertes Datum'
,p_lov_return_value=>'UPDATED_ON'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_position
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174603521097074779.4903)
,p_lov_name=>'PAGE POSITION'
,p_lov_query=>'.'||wwv_flow_api.id(174603521097074779.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174603926494074780.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Links'
,p_lov_return_value=>'LEFT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174604103608074780.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Zentriert'
,p_lov_return_value=>'CENTER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174604316948074780.4903)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Rechts'
,p_lov_return_value=>'RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pages
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(454994331134405615.4903)
,p_lov_name=>'PAGES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_parent_page_for_page_53
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(177413911605744887.4903)
,p_lov_name=>'PICK PARENT PAGE (FOR PAGE 53)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_ws_webpages',
' where security_group_id = :flow_security_group_id',
'   and ws_app_id = :WS_APP_ID',
'minus',
'select name d, id r',
'  from wwv_flow_ws_webpages',
' where security_group_id = :flow_security_group_id ',
'   and ws_app_id = :WS_APP_ID ',
'connect by prior id = parent_page_id',
'start with id = :P53_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/popup_data_grid_view_options
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(6245305086538240.4903)
,p_lov_name=>'POPUP_DATA_GRID_VIEW_OPTIONS'
,p_lov_query=>'.'||wwv_flow_api.id(6245305086538240.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6245604034538241.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Daten-Grids'
,p_lov_return_value=>'DATA_GRIDS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6245803688538242.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>unistr('Gew\00E4hlte Data Grid-Spalten')
,p_lov_return_value=>'COLUMNS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(6246002516538242.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>unistr('Abfrage auf ausgew\00E4hltem Data Grid')
,p_lov_return_value=>'QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/remember_username
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(263997216503587205.4903)
,p_lov_name=>'REMEMBER_USERNAME'
,p_lov_query=>'.'||wwv_flow_api.id(263997216503587205.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(263997505048587206.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Benutzernamen speichern'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(428697210472793191.4903)
,p_lov_name=>'REPORT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_label_returning_column_alias
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(157608702042123701.4903)
,p_lov_name=>'REPORT LABEL RETURNING COLUMN ALIAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_label, db_column_name',
'from wwv_flow_worksheet_columns',
'where worksheet_id = :P2_ID',
'and security_group_id = :WORKSPACE_ID',
'order by display_order'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_source_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(181139517862367299.4903)
,p_lov_name=>'REPORT_SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(181139517862367299.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(181139731760367303.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tabelle'
,p_lov_return_value=>'TABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(181139914754367305.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SQL-Abfrage'
,p_lov_return_value=>'QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_security_restrict_by
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4200913969354730.4903)
,p_lov_name=>'ROW_SECURITY_RESTRICT_BY'
,p_lov_query=>'.'||wwv_flow_api.id(4200913969354730.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4201216137354731.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Spaltenausdruck'
,p_lov_return_value=>'COLUMN_EXPR'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4201401816354731.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Benutzername in Spalten'
,p_lov_return_value=>'USERNAME_IN_COLUMNS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4201616338354731.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Benutzername in Hierarchie'
,p_lov_return_value=>'USERNAME_IN_HIERARCHY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/searchable_components
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(468375932547106712.4903)
,p_lov_name=>'SEARCHABLE COMPONENTS'
,p_lov_query=>'.'||wwv_flow_api.id(468375932547106712.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468388406715184404.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Seitenname'
,p_lov_return_value=>'Page name'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(471083025269088996.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Seitenalias'
,p_lov_return_value=>'Page alias'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(471083730810090673.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Seitenbeschreibung'
,p_lov_return_value=>'Page description'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468376931120106721.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Abschnittstitel'
,p_lov_return_value=>'Section title'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468376724828106721.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Abschnittsinhalt'
,p_lov_return_value=>'Section content'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468376107670106719.4903)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Dateiname, Aliasname, Beschreibung'
,p_lov_return_value=>'File'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468377117690106722.4903)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Tags'
,p_lov_return_value=>'Tags'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468376332154106721.4903)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Hinweise'
,p_lov_return_value=>'Notes'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(468763112243277596.4903)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Daten-Grid-Daten'
,p_lov_return_value=>'Data grid'
);
end;
/
prompt --application/shared_components/user_interface/lovs/section_type_selector
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174363201295924966.4903)
,p_lov_name=>'SECTION TYPE SELECTOR'
,p_lov_query=>'.'||wwv_flow_api.id(174363201295924966.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174363729720924971.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'TEXT'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:910:&SESSION.:::910,P910_CONTENT,P910_SPREADSHEET:P920_SECTION_TYPE:TEXT"><img src="#IMAGE_PREFIX#ws/ws-text.png" height="128"'
||' width="128" alt="#DISPLAY_VALUE#" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174366523901938416.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Navigation'
,p_lov_return_value=>'NAV'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:926:&SESSION.:::926:P920_SECTION_TYPE:NAV"><img src="#IMAGE_PREFIX#ws/ws-navigation.png" height="128" width="128" alt="#DISPLA'
||'Y_VALUE#" /></a></td><td>&nbsp;</td></tr></table>'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174363503996924969.4903)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Daten'
,p_lov_return_value=>'DATA'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:922:&SESSION.:::922,925:P920_SECTION_TYPE:DATA"><img src="#IMAGE_PREFIX#ws/ws-from-scratch.png" height="128" width="128" alt="'
||'#DISPLAY_VALUE#" /></a></td><td>&nbsp;</td></tr></table>'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(257305806305291010.4903)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Diagramm'
,p_lov_return_value=>'CHART'
,p_lov_template=>'#DISPLAY_VALUE#<br /><table role="presentation" cellspacing="10" cellpadding="0"><tr><td valign="top"><a href="f?p=&APP_ID.:710:&SESSION.:::710,740,742,750:P920_SECTION_TYPE:CHART"><img src="#IMAGE_PREFIX#ws/ws-chart.png" height="128" width="128" alt'
||'="#DISPLAY_VALUE#" /></a></td><td>&nbsp;</td></tr></table>'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id'))
);
end;
/
prompt --application/shared_components/user_interface/lovs/section_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(492203630195322675.4903)
,p_lov_name=>'SECTION TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(492203630195322675.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492203816689322675.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492204004458322675.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Diagramm'
,p_lov_return_value=>'CHART'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492204222124322676.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Abschnittsnavigation'
,p_lov_return_value=>'NAV_SECTION'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492204407452322676.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Seitennavigation'
,p_lov_return_value=>'NAV_PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(492204623758322676.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Daten'
,p_lov_return_value=>'DATA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(15734501398512875.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'PL/SQL'
,p_lov_return_value=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/section_source
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(428681322228645128.4903)
,p_lov_name=>'SECTION_SOURCE'
,p_lov_query=>'.'||wwv_flow_api.id(428681322228645128.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(428681516422645131.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Daten-Grid'
,p_lov_return_value=>'DATA_GRID'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(428681722703645131.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bericht'
,p_lov_return_value=>'REPORT'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>'return wwv_flow_ws_security.current_user_is_not_reader and wwv_flow_ws_security.sql_enabled(:WS_APP_ID) and wwv_flow_ws_security.sql_enabled_inst;'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sharing_standard_codes
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(161342315175360665.4903)
,p_lov_name=>'SHARING - STANDARD CODES'
,p_lov_query=>'.'||wwv_flow_api.id(161342315175360665.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161342511198360666.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mit allen gemeinsam verwenden'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(22963820418845971.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Gemeinsam verwendet mit Access Control-Liste'
,p_lov_return_value=>'ACL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(161342929843360666.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Privat'
,p_lov_return_value=>'AVAILABLE_FOR_OWNER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_all_websheets_or_my_websheets
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(83901725439965785.4903)
,p_lov_name=>'SHOW ALL WEBSHEETS OR MY WEBSHEETS'
,p_lov_query=>'.'||wwv_flow_api.id(83901725439965785.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(83901929137965786.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Alle Websheets'
,p_lov_return_value=>'ALL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(83902128718965786.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Meine Websheets'
,p_lov_return_value=>'MINE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/suggested_sql_table_type_p90
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(17231024016826986.4903)
,p_lov_name=>'SUGGESTED SQL TABLE TYPE (P90)'
,p_lov_query=>'.'||wwv_flow_api.id(17231024016826986.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17231212381826990.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vorgeschlagene Objekte'
,p_lov_return_value=>'S'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(17231413694826994.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>unistr('Alle zug\00E4nglichen Objekte')
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/text_websheets
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174421329189713558.4903)
,p_lov_name=>'TEXT WEBSHEETS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from   wwv_flow_ws_webpages',
'where security_group_id = :flow_security_group_id and',
'      ws_app_id = :WS_APP_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/timeframe
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(185584826211920495.4903)
,p_lov_name=>'TIMEFRAME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/url_or_report
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(184024419940878266.4903)
,p_lov_name=>'URL_OR_REPORT'
,p_lov_query=>'.'||wwv_flow_api.id(184024419940878266.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184024616003878266.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Bericht in dieser Anwendung'
,p_lov_return_value=>'REPORT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(184024823203878266.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/use_primary_default
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(428734704772905075.4903)
,p_lov_name=>'USE_PRIMARY_DEFAULT'
,p_lov_query=>'.'||wwv_flow_api.id(428734704772905075.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(428734912977905076.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>unistr('Prim\00E4re Standardberichteinstellungen verwenden')
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/validate_plsql
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(12497031296679964.4903)
,p_lov_name=>'VALIDATE_PLSQL'
,p_lov_query=>'.'||wwv_flow_api.id(12497031296679964.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(12497306721679972.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Validieren Sie den PL/SQL-Code nicht (parsen Sie den PL/SQL-Code nur zur Laufzeit).'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_as_icons_or_details
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(83845910791829052.4903)
,p_lov_name=>'VIEW AS ICONS OR DETAILS'
,p_lov_query=>'.'||wwv_flow_api.id(83845910791829052.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(83846129033829055.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Symbole'
,p_lov_return_value=>'ICONS'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(83846305343829058.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Details'
,p_lov_return_value=>'DETAILS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_application_status
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(471867429070174759.4903)
,p_lov_name=>'WEBSHEET APPLICATION STATUS'
,p_lov_query=>'.'||wwv_flow_api.id(471867429070174759.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(471867623399174772.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Verf\00FCgbar')
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(471868003921176945.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>unistr('Nicht verf\00FCgbar')
,p_lov_return_value=>'UNAVAILABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_authentication
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(444727703759035884.4903)
,p_lov_name=>'WEBSHEET AUTHENTICATION'
,p_lov_query=>'.'||wwv_flow_api.id(444727703759035884.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444728117740035894.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Application Express-Account'
,p_lov_return_value=>'1'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444728300760035894.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Single Sign-On'
,p_lov_return_value=>'2'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444728526805035894.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'LDAP'
,p_lov_return_value=>'3'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(1959643209188118620.4903)
,p_lov_disp_sequence=>4.5
,p_lov_disp_value=>'Oracle Cloud Identity Management'
,p_lov_return_value=>'5'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(444728724858035894.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Benutzerdefiniert'
,p_lov_return_value=>'4'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_home_page_selector_p_1250
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(177463924416148776.4903)
,p_lov_name=>'WEBSHEET HOME PAGE SELECTOR (P 1250)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from WWV_FLOW_WS_WEBPAGES ',
'where WS_APP_ID = :P1250_ID and',
'      security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_page_style
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(478186020350840371.4903)
,p_lov_name=>'WEBSHEET PAGE STYLE'
,p_lov_query=>'.'||wwv_flow_api.id(478186020350840371.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(478186224261840375.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Standardformatvorlage'
,p_lov_return_value=>'0'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(478186402878840381.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Alternative Formatvorlage 1'
,p_lov_return_value=>'1'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(478187212720840384.4903)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Benutzerdefinierte Formatvorlage'
,p_lov_return_value=>'99'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_page_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(177459420645100351.4903)
,p_lov_name=>'WEBSHEET PAGE TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(177459420645100351.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177459613519100354.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Seite'
,p_lov_return_value=>'PAGE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(177459807231100356.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Daten-Grid'
,p_lov_return_value=>'DATA'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheets_pick_parent_show_all_pages
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(477788102822094591.4903)
,p_lov_name=>'WEBSHEETS - PICK PARENT -- SHOW ALL PAGES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from   wwv_flow_ws_webpages',
'where security_group_id = :flow_security_group_id and',
'      ws_app_id = :WS_APP_ID ',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_priv
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4272307523349785.4903)
,p_lov_name=>'WEBSHEET_PRIV'
,p_lov_query=>'.'||wwv_flow_api.id(4272307523349785.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4272616503349799.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Anzeigen und bearbeiten'
,p_lov_return_value=>'EDIT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4272800274349801.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nur anzeigen'
,p_lov_return_value=>'VIEW_ONLY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/websheet_share_with
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4270305567216064.4903)
,p_lov_name=>'WEBSHEET_SHARE_WITH'
,p_lov_query=>'.'||wwv_flow_api.id(4270305567216064.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4271211380216070.4903)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Privat, nicht gemeinsam verwendet'
,p_lov_return_value=>'PRIVATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_column_lov_from
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(7088909602608513.4903)
,p_lov_name=>'WORKSHEET COLUMN LOV FROM'
,p_lov_query=>'.'||wwv_flow_api.id(7088909602608513.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7089115009608515.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Eindeutige Spaltenwerte'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(7089311442608516.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Statische Domain mit Werten'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_lovs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(20284128708076403.4903)
,p_lov_name=>'WORKSHEET LOVS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME display_value, ID return_value ',
'from WWV_FLOW_WORKSHEET_LOVS',
'where worksheet_id = :p2_id',
'and security_group_id = :WORKSPACE_ID',
'order by upper(name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_reports_with_worksheet
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(1097408377479572.4903)
,p_lov_name=>'WORKSHEET REPORTS WITH WORKSHEET'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(name, ''- Worksheet -'') name, id ',
'  from wwv_flow_worksheet_rpts',
' where worksheet_id = :P2_ID',
'   and application_user = :APP_USER',
'   and name is not null',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_columns
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4196722056290886.4903)
,p_lov_name=>'WORKSHEET_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select report_label, db_column_name',
'from wwv_flow_worksheet_columns',
'where worksheet_id = :p2_id',
'and security_group_id = :WORKSPACE_ID',
'order by display_order'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_column_types
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159512305334979648.4903)
,p_lov_name=>'WORKSHEET_COLUMN_TYPES'
,p_lov_query=>'.'||wwv_flow_api.id(159512305334979648.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159512611310979649.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Zeichenfolge'
,p_lov_return_value=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159512810815979649.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nummer'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159513008482979649.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Datum'
,p_lov_return_value=>'DATE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159513210897979649.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Dokument'
,p_lov_return_value=>'DOCUMENT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(11517807514880595.4903)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Berechnet'
,p_lov_return_value=>'COMPUTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/worksheet_column_types2
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(38353412581019585.4903)
,p_lov_name=>'WORKSHEET_COLUMN_TYPES2'
,p_lov_query=>'.'||wwv_flow_api.id(38353412581019585.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38353715513019587.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Zeichenfolge'
,p_lov_return_value=>'STRING'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38353907530019587.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nummer'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(38354113803019587.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Datum'
,p_lov_return_value=>'DATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_acl_privs
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(451333930142995878.4903)
,p_lov_name=>'WS_ACL_PRIVS'
,p_lov_query=>'.'||wwv_flow_api.id(451333930142995878.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(451334128711995879.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Leseberechtigter'
,p_lov_return_value=>'R'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(451334314312995960.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Beitragender'
,p_lov_return_value=>'C'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(451334509043995960.4903)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Administrator'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_app_acl_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(450940100671567605.4903)
,p_lov_name=>'WS_APP_ACL_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(450940100671567605.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(450940311282567606.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Standardwert'
,p_lov_return_value=>'DEFAULT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(450940510709567608.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Benutzerdefiniert'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_logo_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(461278502171499627.4903)
,p_lov_name=>'WS_LOGO_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(461278502171499627.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461278702764499627.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Keine'
,p_lov_return_value=>'NONE'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461278910485499644.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'TEXT'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461279109274499644.4903)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Hochgeladenes Bild'
,p_lov_return_value=>'IMAGE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(461279326169499644.4903)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Dateipfad'
,p_lov_return_value=>'FILEPATH'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_page_type
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(174627223457398766.4903)
,p_lov_name=>'WS_PAGE_TYPE'
,p_lov_query=>'.'||wwv_flow_api.id(174627223457398766.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174627515804398767.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Daten-Grid'
,p_lov_return_value=>'DATA'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(174627719694398770.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returning_y_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(159003224636178271.4903)
,p_lov_name=>'YES NO RETURNING Y N'
,p_lov_query=>'.'||wwv_flow_api.id(159003224636178271.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159003530237178272.4903)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ja'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(159003719271178272.4903)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Nein'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_y_n
begin
wwv_flow_api.create_list_of_values(
 p_id=>wwv_flow_api.id(4091010662546975.4903)
,p_lov_name=>'YES NO RETURNS Y N'
,p_lov_query=>'.'||wwv_flow_api.id(4091010662546975.4903)||'.'
,p_location=>'STATIC'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4091213313546978.4903)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ja'
,p_lov_return_value=>'Y'
);
wwv_flow_api.create_static_lov_data(
 p_id=>wwv_flow_api.id(4091420742546980.4903)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Nein'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/worksheet_standard
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(78897017520604216.4903)
,p_name=>'worksheet standard'
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(2670021526029217.4903)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4903)
,p_short_name=>unistr('\00C4nderungshistorie anzeigen')
,p_link=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_page_id=>14
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4230728579343205.4903)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4903)
,p_short_name=>unistr('Spaltentyp \00E4ndern')
,p_link=>'f?p=&FLOW_ID.:89:&SESSION.'
,p_page_id=>89
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(4233729491405795.4903)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4903)
,p_short_name=>unistr('Spaltentyp \00E4ndern')
,p_link=>'f?p=&FLOW_ID.:91:&SESSION.'
,p_page_id=>91
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(5510514461754522.4903)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4903)
,p_short_name=>'Dashboard'
,p_link=>'f?p=&FLOW_ID.:400:&SESSION.'
,p_page_id=>400
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(78897520983605269.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Seitenverzeichnis'
,p_link=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:::'
,p_page_id=>1000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(78901107456613285.4903)
,p_parent_id=>wwv_flow_api.id(78897520983605269.4903)
,p_short_name=>'Seite erstellen'
,p_link=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:::'
,p_page_id=>200
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(78917815626639965.4903)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4903)
,p_short_name=>'&WORKSHEET_NAME.'
,p_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::P2_ID:&P2_ID.'
,p_page_id=>2
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(81681714437489706.4903)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4903)
,p_short_name=>unistr('Zeile hinzuf\00FCgen/bearbeiten')
,p_link=>'f?p=&FLOW_ID.:20:&SESSION.'
,p_page_id=>20
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(81687303832540185.4903)
,p_parent_id=>wwv_flow_api.id(78917815626639965.4903)
,p_short_name=>unistr('Anhang hinzuf\00FCgen')
,p_link=>'f?p=&FLOW_ID.:50:&SESSION.'
,p_page_id=>50
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(85198520867592463.4903)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4903)
,p_short_name=>'Daten-Grid erstellen'
,p_link=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:::'
,p_page_id=>205
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(85200708143598339.4903)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4903)
,p_short_name=>'Daten-Grid erstellen'
,p_link=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:::'
,p_page_id=>201
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(87067930193889011.4903)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4903)
,p_short_name=>'Daten-Grid erstellen'
,p_link=>'f?p=&APP_ID.:206:&SESSION.::&DEBUG.:::'
,p_page_id=>206
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171300231813414293.4903)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4903)
,p_short_name=>'&P3000_REPORT_NAME!RAW.'
,p_link=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::'
,p_page_id=>3000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(171582602179856081.4903)
,p_parent_id=>wwv_flow_api.id(171300231813414293.4903)
,p_short_name=>'Bericht bearbeiten'
,p_link=>'f?p=&APP_ID.:3010:&SESSION.::&DEBUG.:::'
,p_page_id=>3010
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(172959905219473555.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Suchen'
,p_link=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:::'
,p_page_id=>8000
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(173221216721622592.4903)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4903)
,p_short_name=>'Erstellen'
,p_link=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
,p_page_id=>131
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174460015452180827.4903)
,p_parent_id=>wwv_flow_api.id(.4903)
,p_short_name=>'Home'
,p_link=>'ws?p=&WS_APP_ID.:home:&SESSION.'
,p_page_id=>900
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174536419956209170.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Neuer Abschnitt'
,p_link=>'f?p=&APP_ID.:910:&SESSION.::&DEBUG.:::'
,p_page_id=>910
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174537325551221738.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Neuer Abschnitt'
,p_link=>'f?p=&FLOW_ID.:920:&SESSION.'
,p_page_id=>920
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174562103281566299.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Abschnitt bearbeiten'
,p_link=>'f?p=&FLOW_ID.:930:&SESSION.'
,p_page_id=>930
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(174587421741748355.4903)
,p_parent_id=>wwv_flow_api.id(456716629226062947.4903)
,p_short_name=>'Dashboard'
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_page_id=>1
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(176493330002233411.4903)
,p_parent_id=>wwv_flow_api.id(456716629226062947.4903)
,p_short_name=>'Websheet-Eigenschaften'
,p_link=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.:::'
,p_page_id=>1250
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(177132319189562341.4903)
,p_parent_id=>wwv_flow_api.id(174587421741748355.4903)
,p_short_name=>'Authentifizierungsschemas verwalten'
,p_link=>'f?p=&FLOW_ID.:51:&SESSION.'
,p_page_id=>51
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(177425500872951637.4903)
,p_parent_id=>wwv_flow_api.id(.4903)
,p_short_name=>'Seite bearbeiten'
,p_link=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.:::'
,p_page_id=>53
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(177505624887294566.4903)
,p_parent_id=>wwv_flow_api.id(174587421741748355.4903)
,p_short_name=>'Abschnitt erstellen'
,p_link=>'f?p=&FLOW_ID.:921:&SESSION.'
,p_page_id=>921
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(177969610547759155.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>unistr('Seite l\00F6schen')
,p_link=>'f?p=&FLOW_ID.:960:&SESSION.'
,p_page_id=>960
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178435411977260701.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Abschnitt bearbeiten'
,p_link=>'f?p=&FLOW_ID.:931:&SESSION.'
,p_page_id=>931
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178515920668406977.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Datenabschnitt erstellen'
,p_link=>'f?p=&APP_ID.:922:&SESSION.::&DEBUG.:::'
,p_page_id=>922
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178567213402219839.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Abschnitt erstellen'
,p_link=>'f?p=&FLOW_ID.:926:&SESSION.'
,p_page_id=>926
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178572623297245626.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Abschnitt erstellen'
,p_link=>'f?p=&FLOW_ID.:927:&SESSION.'
,p_page_id=>927
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178735000980446641.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Abschnitt bearbeiten'
,p_link=>'f?p=&FLOW_ID.:932:&SESSION.'
,p_page_id=>932
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178832411836267350.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Daten'
,p_link=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.:::'
,p_page_id=>902
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178833326920275511.4903)
,p_parent_id=>wwv_flow_api.id(187171813556872743.4903)
,p_short_name=>'Dateien'
,p_link=>'f?p=&APP_ID.:903:&SESSION.::&DEBUG.:::'
,p_page_id=>903
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178833723901276942.4903)
,p_parent_id=>wwv_flow_api.id(187171813556872743.4903)
,p_short_name=>'Tags'
,p_link=>'f?p=&APP_ID.:904:&SESSION.::&DEBUG.:::'
,p_page_id=>904
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178834117647279840.4903)
,p_parent_id=>wwv_flow_api.id(187171813556872743.4903)
,p_short_name=>'Hinweise'
,p_link=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.:::'
,p_page_id=>905
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(178856318730488076.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Seite kopieren'
,p_link=>'f?p=&FLOW_ID.:908:&SESSION.'
,p_page_id=>908
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(179692514107778690.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Datenabschnitt erstellen'
,p_link=>'f?p=&APP_ID.:925:&SESSION.::&DEBUG.:::'
,p_page_id=>925
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(180470222886094847.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Abschnitt bearbeiten'
,p_link=>'f?p=&FLOW_ID.:934:&SESSION.'
,p_page_id=>934
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(181263431536172556.4903)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4903)
,p_short_name=>'Bericht erstellen'
,p_link=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.:::'
,p_page_id=>1310
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(181299229440629329.4903)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4903)
,p_short_name=>'Bericht erstellen'
,p_link=>'f?p=&APP_ID.:1320:&SESSION.::&DEBUG.:::'
,p_page_id=>1320
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(184267525052006599.4903)
,p_parent_id=>wwv_flow_api.id(171582602179856081.4903)
,p_short_name=>'Berichtspalte bearbeiten'
,p_link=>'f?p=&APP_ID.:3020:&SESSION.::&DEBUG.:::'
,p_page_id=>3020
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(185430107950682414.4903)
,p_parent_id=>wwv_flow_api.id(171300231813414293.4903)
,p_short_name=>'Bericht bearbeiten'
,p_link=>'f?p=&APP_ID.:3030:&SESSION.::&DEBUG.:::'
,p_page_id=>3030
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(187171813556872743.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Annotationen'
,p_link=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.:::'
,p_page_id=>906
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(187174620703946459.4903)
,p_parent_id=>wwv_flow_api.id(456716629226062947.4903)
,p_short_name=>unistr('Aktivit\00E4t \00FCberwachen')
,p_link=>'f?p=&APP_ID.:140:&SESSION.::&DEBUG.:::'
,p_page_id=>140
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(188056521384504797.4903)
,p_parent_id=>wwv_flow_api.id(171300231813414293.4903)
,p_short_name=>'Bericht bearbeiten'
,p_link=>'f?p=&APP_ID.:3060:&SESSION.::&DEBUG.:::'
,p_page_id=>3060
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(301532509548629032.4903)
,p_parent_id=>wwv_flow_api.id(176493330002233411.4903)
,p_short_name=>unistr('Anwendung l\00F6schen')
,p_link=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:::'
,p_page_id=>4
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(431020021350285368.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Diagrammabschnitt erstellen'
,p_link=>'f?p=&FLOW_ID.:710:&SESSION.'
,p_page_id=>710
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(451312903217376859.4903)
,p_parent_id=>wwv_flow_api.id(456716629226062947.4903)
,p_short_name=>'Zugriffskontrolle'
,p_link=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_page_id=>11
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(451316327052485988.4903)
,p_parent_id=>wwv_flow_api.id(451312903217376859.4903)
,p_short_name=>'Eintragsdetails'
,p_link=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
,p_page_id=>13
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(454926007401991139.4903)
,p_parent_id=>wwv_flow_api.id(178833326920275511.4903)
,p_short_name=>'Details'
,p_link=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
,p_page_id=>912
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(455078007098014547.4903)
,p_parent_id=>wwv_flow_api.id(178833723901276942.4903)
,p_short_name=>'Details'
,p_link=>'f?p=&APP_ID.:913:&SESSION.::&DEBUG.:::'
,p_page_id=>913
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(455084307504044741.4903)
,p_parent_id=>wwv_flow_api.id(178834117647279840.4903)
,p_short_name=>'Details'
,p_link=>'f?p=&APP_ID.:914:&SESSION.::&DEBUG.:::'
,p_page_id=>914
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(455867027556226619.4903)
,p_parent_id=>wwv_flow_api.id(456715709817052851.4903)
,p_short_name=>unistr('Websheet-\00DCbersicht')
,p_link=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.:::'
,p_page_id=>15
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(456716629226062947.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Administration'
,p_link=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::'
,p_page_id=>3
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(456723414173263488.4903)
,p_parent_id=>wwv_flow_api.id(456715709817052851.4903)
,p_short_name=>'Markup-Syntax'
,p_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:::'
,p_page_id=>17
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(457141423716390388.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>unistr('Datei hinzuf\00FCgen')
,p_link=>'f?p=&APP_ID.:4020:&SESSION.::&DEBUG.:::'
,p_page_id=>4020
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(457151729837534039.4903)
,p_parent_id=>wwv_flow_api.id(.4903)
,p_short_name=>unistr('Hinweis hinzuf\00FCgen')
,p_link=>'f?p=&APP_ID.:4030:&SESSION.::&DEBUG.:::'
,p_page_id=>4030
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(457152105511545952.4903)
,p_parent_id=>wwv_flow_api.id(.4903)
,p_short_name=>unistr('Tag hinzuf\00FCgen')
,p_link=>'f?p=&APP_ID.:4040:&SESSION.::&DEBUG.:::'
,p_page_id=>4040
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(457468026650230855.4903)
,p_parent_id=>wwv_flow_api.id(.4903)
,p_short_name=>'Historie des Seitenabschnitts'
,p_link=>'f?p=&APP_ID.:950:&SESSION.::&DEBUG.:::'
,p_page_id=>950
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(459182006892056281.4903)
,p_parent_id=>wwv_flow_api.id(187171813556872743.4903)
,p_short_name=>'Tag-Cloud'
,p_link=>'f?p=&FLOW_ID.:928:&SESSION.'
,p_page_id=>928
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(459633626075416367.4903)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4903)
,p_short_name=>'Seitenansichten'
,p_link=>'f?p=&FLOW_ID.:18:&SESSION.'
,p_page_id=>18
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(459662412537763358.4903)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4903)
,p_short_name=>'Topseiten'
,p_link=>'f?p=&FLOW_ID.:24:&SESSION.'
,p_page_id=>24
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(461238603047810834.4903)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4903)
,p_short_name=>'Topdaten-Grids'
,p_link=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:::'
,p_page_id=>141
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(461331422787325871.4903)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4903)
,p_short_name=>'Topberichte'
,p_link=>'f?p=&FLOW_ID.:142:&SESSION.'
,p_page_id=>142
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(461348622392450101.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>'Websheet-Verzeichnis'
,p_link=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.:::'
,p_page_id=>1001
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(471882914071890170.4903)
,p_parent_id=>wwv_flow_api.id(.4903)
,p_short_name=>unistr('Kalender f\00FCr Seitenerstellung')
,p_link=>'f?p=&FLOW_ID.:951:&SESSION.'
,p_page_id=>951
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(471901627876065162.4903)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4903)
,p_short_name=>'Topdateien'
,p_link=>'f?p=&FLOW_ID.:143:&SESSION.'
,p_page_id=>143
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(471903119311084491.4903)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4903)
,p_short_name=>'Tophinweise'
,p_link=>'f?p=&APP_ID.:144:&SESSION.::&DEBUG.:::'
,p_page_id=>144
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(471904206990093888.4903)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4903)
,p_short_name=>'Top-Tags'
,p_link=>'f?p=&FLOW_ID.:145:&SESSION.'
,p_page_id=>145
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(471917025140272524.4903)
,p_parent_id=>wwv_flow_api.id(187174620703946459.4903)
,p_short_name=>'Topbenutzer'
,p_link=>'f?p=&APP_ID.:146:&SESSION.::&DEBUG.:::'
,p_page_id=>146
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(472197018359897527.4903)
,p_parent_id=>wwv_flow_api.id(174562103281566299.4903)
,p_short_name=>'Abschnitt in vorhandene Seite verschieben'
,p_link=>'f?p=&APP_ID.:990:&SESSION.::&DEBUG.:::'
,p_page_id=>990
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(472200003119943726.4903)
,p_parent_id=>wwv_flow_api.id(174562103281566299.4903)
,p_short_name=>'Abschnitt in neue Seite verschieben'
,p_link=>'f?p=&FLOW_ID.:991:&SESSION.'
,p_page_id=>991
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(472804624985588482.4903)
,p_parent_id=>wwv_flow_api.id(456715709817052851.4903)
,p_short_name=>'Info zur Anwendung'
,p_link=>'f?p=&FLOW_ID.:16:&SESSION.'
,p_page_id=>16
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(473082318328043502.4903)
,p_parent_id=>wwv_flow_api.id(187171813556872743.4903)
,p_short_name=>'Links'
,p_link=>'f?p=&FLOW_ID.:915:&SESSION.'
,p_page_id=>915
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(497240808682988557.4903)
,p_parent_id=>wwv_flow_api.id(178832411836267350.4903)
,p_short_name=>'Meine gespeicherten Berichte'
,p_link=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:::'
,p_page_id=>42
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(619997132010437333.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>unistr('Sprache ausw\00E4hlen')
,p_link=>'f?p=&FLOW_ID.:37:&SESSION.'
,p_page_id=>37
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(626920713710448375.4903)
,p_parent_id=>wwv_flow_api.id(473082318328043502.4903)
,p_short_name=>'Linkdetails'
,p_link=>'f?p=&FLOW_ID.:916:&SESSION.'
,p_page_id=>916
);
wwv_flow_api.create_menu_option(
 p_id=>wwv_flow_api.id(733378208922655612.4903)
,p_parent_id=>wwv_flow_api.id(174460015452180827.4903)
,p_short_name=>unistr('Kennwort \00E4ndern')
,p_link=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::'
,p_page_id=>5
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_ws_three_columns
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(3700422714748.4903)
,p_theme_id=>3
,p_name=>'[EBA] WS Three Columns.de'
,p_internal_name=>'[EBA]_WS_THREE_COLUMNS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'		',
'	<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'			<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame">',
'<div class="ebaFrameHeader">',
'	<div class="wsToolbar">',
'		<div class="wsToolbarLeft">',
'#REGION_POSITION_02#',
'		</div>',
'		<div class="wsToolbarRight">',
'#REGION_POSITION_08#',
'		</div>',
'	</div>',
'	<div class="clear"></div>',
'</div> <!-- End .wsToolbar -->',
'<div class="ebaContentContainer">',
'#REGION_POSITION_04#',
'	<div class="ebaContent ebaOneCol">',
'#REGION_POSITION_03#',
'		<div class="ebaMainCol">',
'#BODY#',
'		</div>',
'		<div class="ebaSideCol">',
'#REGION_POSITION_05#',
'		</div>',
'	</div> <!-- End .ebaContent -->',
'</div> <!-- End .ebaContentContainer -->',
'#REGION_POSITION_07#',
'</div> <!-- End .ebaFrame -->',
'#REGION_POSITION_06#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097489730349429.4903)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4903)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097527296349429.4903)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4903)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097600963349429.4903)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4903)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097722755349429.4903)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4903)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097810938349428.4903)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4903)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140097924373349428.4903)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4903)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140098011356349428.4903)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4903)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140098179919349428.4903)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4903)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140098224504349428.4903)
,p_page_template_id=>wwv_flow_api.id(3700422714748.4903)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/iframe_load_required_for_data_grid_file_upload
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(3152608674388513.4903)
,p_theme_id=>3
,p_name=>'iframe load - Required for Data Grid File Upload.de'
,p_internal_name=>'IFRAME_LOAD_REQUIRED_FOR_DATA_GRID_FILE_UPLOAD'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns="http://www.w3.org/1999/xhtml" xmlns:htmldb="http://htmldb.oracle.com" xmlns:apex="http://apex.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body #ONLOAD# style="margin:5px;"><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>',
''))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'#REGION_POSITION_04#',
'#REGION_POSITION_05#',
'#BODY#',
'</div>',
'<div style="text-align:middle;">#REGION_POSITION_08#</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbSuccessMessage">#SUCCESS_MESSAGE#</div>',
''))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbNotification">#MESSAGE#</div>',
''))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058492776349479.4903)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4903)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058518143349479.4903)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4903)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058684597349479.4903)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4903)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058776517349479.4903)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4903)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058837902349479.4903)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4903)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140058938460349478.4903)
,p_page_template_id=>wwv_flow_api.id(3152608674388513.4903)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_ws_two_columns
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(9297021464956579.4903)
,p_theme_id=>3
,p_name=>'[EBA] WS Two Columns.de'
,p_internal_name=>'[EBA]_WS_TWO_COLUMNS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame">',
'<div class="ebaFrameHeader">',
'	<div class="wsToolbar">',
'		<div class="wsToolbarLeft">',
'#REGION_POSITION_02#',
'		</div>',
'		<div class="wsToolbarRight">',
'#REGION_POSITION_08#',
'		</div>',
'	</div>',
'	<div class="clear"></div>',
'</div> <!-- End .wsToolbar -->',
'<div class="ebaContentContainer">',
'#REGION_POSITION_04#',
'	<div class="ebaContent ebaOneCol">',
'#REGION_POSITION_03#',
'		<div class="ebaMainCol">',
'#BODY#',
'		</div>',
'		<div class="ebaSideCol">',
'#REGION_POSITION_05#',
'		</div>',
'	</div> <!-- End .ebaContent -->',
'</div> <!-- End .ebaContentContainer -->',
'#REGION_POSITION_07#',
'</div> <!-- End .ebaFrame -->',
'#REGION_POSITION_06#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061732411349475.4903)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4903)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061811144349475.4903)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4903)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140061965981349475.4903)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4903)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062088282349475.4903)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4903)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062175058349475.4903)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4903)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062264599349475.4903)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4903)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062395038349475.4903)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4903)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062491818349474.4903)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4903)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140062514072349474.4903)
,p_page_template_id=>wwv_flow_api.id(9297021464956579.4903)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_ws_one_column
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(10606007362285088.4903)
,p_theme_id=>3
,p_name=>'[EBA] WS One Column.de'
,p_internal_name=>'[EBA]_WS_ONE_COLUMN'
,p_is_popup=>false
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/widget.stickyWidget.js',
'#IMAGE_PREFIX#libraries/apex/widget.stickyTableHeader.js'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// $(''.a-IRR-reportView'').setTableHeadersAsFixed();',
'//$(".js-stickyTableHeader").stickyWidget({',
'//   toggleWidth: true',
'//});'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame">',
'<div class="ebaFrameHeader">',
'	<div class="wsToolbar">',
'		<div class="wsToolbarLeft">',
'#REGION_POSITION_02#',
'		</div>',
'		<div class="wsToolbarRight">',
'#REGION_POSITION_08#',
'		</div>',
'	</div>',
'	<div class="clear"></div>',
'</div> <!-- End .wsToolbar -->',
'<div class="ebaContentContainer">',
'#REGION_POSITION_04#',
'	<div class="ebaContent ebaOneCol">',
'#REGION_POSITION_03#',
'		<div class="wsPaddedContentContainer">',
'#BODY#',
'#REGION_POSITION_05#',
'		</div>',
'	</div> <!-- End .ebaContent -->',
'</div> <!-- End .ebaContentContainer -->',
'#REGION_POSITION_07#',
'</div> <!-- End .ebaFrame -->',
'#REGION_POSITION_06#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067387257349464.4903)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4903)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067421727349464.4903)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4903)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067591886349464.4903)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4903)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067696428349464.4903)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4903)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067759500349464.4903)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4903)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067810848349463.4903)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4903)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140067963315349463.4903)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4903)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140068013224349463.4903)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4903)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140068132565349463.4903)
,p_page_template_id=>wwv_flow_api.id(10606007362285088.4903)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_help_pop_up
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(11249921373943607.4903)
,p_theme_id=>3
,p_name=>'[EBA] Help Pop Up.de'
,p_internal_name=>'[EBA]_HELP_POP_UP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="wsPopup ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE." class="wsPopup"> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body #ONLOAD# class="wsPopup">',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'	#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="wsPopUpHeader">',
'#REGION_POSITION_02#',
'</div>',
'<div class="wsPopUpContent">',
'  <div class="wsSideCol">',
'#REGION_POSITION_03#',
'  </div>',
'  <div class="wsMainCol">',
'#BODY#',
'  </div>',
'<div class="clear"></div>',
'</div>',
'#REGION_POSITION_04#',
'#REGION_POSITION_05#',
'#REGION_POSITION_06#',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069408377349461.4903)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4903)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069537000349461.4903)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4903)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069623747349461.4903)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4903)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069739050349461.4903)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4903)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069814885349461.4903)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4903)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140069965422349461.4903)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4903)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140070082284349460.4903)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4903)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140070101506349460.4903)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4903)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140070203419349460.4903)
,p_page_template_id=>wwv_flow_api.id(11249921373943607.4903)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_ws_two_panel_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(15627530893704526.4903)
,p_theme_id=>3
,p_name=>'[EBA] WS Two Panel Page.de'
,p_internal_name=>'[EBA]_WS_TWO_PANEL_PAGE'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame">',
'<div class="ebaFrameHeader">',
'	<div class="wsToolbar">',
'		<div class="wsToolbarLeft">',
'#REGION_POSITION_02#',
'		</div>',
'		<div class="wsToolbarRight">',
'#REGION_POSITION_08#',
'		</div>',
'	</div>',
'	<div class="clear"></div>',
'</div> <!-- End .wsToolbar -->',
'<div class="ebaContentContainer">',
'#REGION_POSITION_03#',
'	<div class="ebaTwoColPane">',
'		<div class="ebaSideCol contentSection" id="wsSideCol">',
'					<h2 class="leftButtons">',
'			#REGION_POSITION_05#',
'					</h2>',
'			#REGION_POSITION_06#',
'		</div>',
'		<div class="ebaMainCol contentSection">',
'			#REGION_POSITION_04#',
'			<div class="ebaMainColContentContainer">',
'				<div class="ebaContent ebaOneCol">',
'					#BODY#',
'				</div> <!-- End .ebaContent .ebaOneCol -->',
'			</div> <!-- End .wsMainColContentContainer -->',
'		</div> <!-- End .ebaMainCol contentSection -->',
'	</div> <!-- End .ebaTwoColPane -->',
'</div> <!-- End .ebaContentContainer -->',
'#REGION_POSITION_07#',
'</div> <!-- End .ebaFrame -->'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140072642082349458.4903)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4903)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140072720824349458.4903)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4903)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140072848929349457.4903)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4903)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140072973381349457.4903)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4903)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140073054438349457.4903)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4903)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140073197487349457.4903)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4903)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140073250010349457.4903)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4903)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140073374370349457.4903)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4903)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140073485997349457.4903)
,p_page_template_id=>wwv_flow_api.id(15627530893704526.4903)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_login_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(53193408981633671.4903)
,p_theme_id=>3
,p_name=>'[EBA] Login Page.de'
,p_internal_name=>'[EBA]_LOGIN_PAGE'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'	',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame ebaWizardFrame ebaLoginWizard">',
'<div class="ebaFrameHeader">',
'		<h1 class="oracleLogo">',
'			#LOGO#',
'		</h1>',
'		<div class="ebaProgressBar">',
'#REGION_POSITION_02#',
'		</div>',
'</div> <!-- End .ebaFrameHeader -->',
'<div class="ebaContentContainer">',
'	<div class="ebaContent">',
'<div class="websheetsIcon">',
'#REGION_POSITION_03#',
'</div>',
'<div class="loginFormFields">',
'#BODY#',
'</div>',
'	</div> <!-- End .ebaContent -->',
'</div> <!-- End .ebaContentContainer -->',
'	<div class="ebaFrameFooter">',
'#REGION_POSITION_04#',
'<span>',
'#REGION_POSITION_05#',
'</span>',
'	</div>',
'</div> <!-- End .ebaFrame -->',
'#REGION_POSITION_06#',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>6
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140075690213349454.4903)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4903)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140075738281349454.4903)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4903)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140075886172349454.4903)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4903)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140075921828349454.4903)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4903)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076012829349454.4903)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4903)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076100068349454.4903)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4903)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076221955349454.4903)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4903)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076340391349454.4903)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4903)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140076408102349453.4903)
,p_page_template_id=>wwv_flow_api.id(53193408981633671.4903)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_presentation_view
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(75962824844186301.4903)
,p_theme_id=>3
,p_name=>'[EBA] Presentation View.de'
,p_internal_name=>'[EBA]_PRESENTATION_VIEW'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_presentation.css" type="text/css" />',
'	<script src="#IMAGE_PREFIX#ws/js/ws_presentation.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div id="wspToolbar">',
'	#REGION_POSITION_01#',
'</div>',
'<div class="wspSectionContainer" aria-live="polite">',
'#BODY#',
'</div>',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'#REGION_POSITION_04#',
'#REGION_POSITION_05#',
'#REGION_POSITION_06#',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140077826786349452.4903)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4903)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140077944690349452.4903)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4903)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078059697349452.4903)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4903)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078199669349452.4903)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4903)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078280955349451.4903)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4903)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078344799349451.4903)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4903)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078411771349451.4903)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4903)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078570489349451.4903)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4903)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140078698538349451.4903)
,p_page_template_id=>wwv_flow_api.id(75962824844186301.4903)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/eba_pop_up
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(134255203486851095.4903)
,p_theme_id=>3
,p_name=>'[EBA] Pop Up.de'
,p_internal_name=>'[EBA]_POP_UP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="wsPopup ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="wsPopup ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE." class="wsPopup"> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body #ONLOAD# class="wsPopup">',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'	#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="wsPopUpHeader">',
'#REGION_POSITION_02#',
'</div>',
'<div class="wsPopUpContent simplePopUp paddedPopUp">',
'  <div class="wsMainCol">',
'#BODY#',
'  </div>',
'<div class="clear"></div>',
'</div>',
'#REGION_POSITION_04#',
'#REGION_POSITION_05#',
'#REGION_POSITION_06#',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage is-success" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#SUCCESS_MESSAGE_HEADING#</h2>',
'#SUCCESS_MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="wsPageMessage" role="alert">',
'<h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'#MESSAGE#',
'<a href="javascript:void()" onclick="$x_Remove(''wsPageMessage'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#"/></a>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<div class="navbar-entry"><a href="#LINK#" class="t1NavigationBar">#TEXT#</a></div>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_02'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>3
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140079702460349450.4903)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4903)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140079819848349450.4903)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4903)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140079971938349450.4903)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4903)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140080026400349450.4903)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4903)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140080183799349449.4903)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4903)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140080201984349449.4903)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4903)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140080389350349449.4903)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4903)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140080442532349449.4903)
,p_page_template_id=>wwv_flow_api.id(134255203486851095.4903)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_0_websheets_printer_friendly
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(636311004626147097.4903)
,p_theme_id=>3
,p_name=>'APEX 4.0 - WEBSHEETS (printer friendly).de'
,p_internal_name=>'APEX_4.0_WEBSHEETS_PRINTER_FRIENDLY'
,p_is_popup=>false
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'div.wsSection h2 span,',
'div.wsFooter ul.wsViewModes,',
'span.wsBreadcrumbBarLinks,',
'div.wsSection h2 a.wsSectionControl,',
'.ebaHeader ul,',
'.ebaFrameHeader,',
'.wsSideSection {',
'    display: none !important;',
'}',
'body .ebaHeader h1 a {',
'    color: #000;',
'    text-shadow: none;',
'}',
'body .ebaHeader {',
'    background: none #F8FBFF;',
'}',
'body div.wsBreadcrumb>ul>li>a {',
'    border: none;',
'}'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html lang="&BROWSER_LANGUAGE." class="ie6 no-css3"> <![endif]-->',
'<!--[if IE 7 ]>    <html lang="&BROWSER_LANGUAGE." class="ie7 no-css3"> <![endif]-->',
'<!--[if IE 8 ]>    <html lang="&BROWSER_LANGUAGE." class="ie8 no-css3"> <![endif]-->',
'<!--[if IE 9 ]>    <html lang="&BROWSER_LANGUAGE." class="ie9"> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'	<title>#TITLE#</title>',
'	<link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'	',
'	#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'	<!--[if IE 7]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'	<![endif]-->',
'	<!--[if IE 8]>',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'	<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'	<![endif]-->',
'	<script src="#IMAGE_PREFIX#libraries/apex/actions.js" type="text/javascript" charset="utf-8"></script>',
'	<script src="#IMAGE_PREFIX#ws/js/ws.js" type="text/javascript" charset="utf-8"></script> ',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'	<!--[if lte IE 8]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'	',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_01#',
'<div class="ebaFrame">',
'<div class="ebaFrameHeader">',
'	<div class="wsToolbar">',
'		<div class="wsToolbarLeft">',
'#REGION_POSITION_02#',
'		</div>',
'		<div class="wsToolbarRight">',
'#REGION_POSITION_08#',
'		</div>',
'	</div>',
'	<div class="clear"></div>',
'</div> <!-- End .wsToolbar -->',
'<div class="ebaContentContainer">',
'#REGION_POSITION_04#',
'	<div class="ebaContent ebaOneCol">',
'#REGION_POSITION_03#',
'		<div class="wsPaddedContentContainer">',
'#BODY#',
'#REGION_POSITION_05#',
'		</div>',
'	</div> <!-- End .ebaContent -->',
'</div> <!-- End .ebaContentContainer -->',
'#REGION_POSITION_07#',
'</div> <!-- End .ebaFrame -->',
'#REGION_POSITION_06#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="htmldbSuccessMessage" id="MESSAGE"><img src="#IMAGE_PREFIX#delete.gif" onclick="$x_Remove(''MESSAGE'')"  style="float:right;" class="pb" alt="" />#SUCCESS_MESSAGE#</div>'
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbNotification" id="MESSAGE"><img src="#IMAGE_PREFIX#delete.gif" onclick="$x_Remove(''MESSAGE'')"  style="float:right;" class="pb" alt="" />#MESSAGE#</div>',
''))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083405483349446.4903)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4903)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083557895349446.4903)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4903)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083692637349445.4903)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4903)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083726401349445.4903)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4903)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083898536349445.4903)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4903)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140083959853349445.4903)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4903)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140084028487349445.4903)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4903)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140084167036349445.4903)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4903)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140084221141349445.4903)
,p_page_template_id=>wwv_flow_api.id(636311004626147097.4903)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_websheets_sign_in_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(1418140425267007336.4903)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Websheets Sign In Page.de'
,p_internal_name=>'APEX_5.0_WEBSHEETS_SIGN_IN_PAGE'
,p_is_popup=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$(function() {',
'  $(''a[href*="#"]:not([href="#"])'').click(function() {',
'    if (location.pathname.replace(/^\//,'''') == this.pathname.replace(/^\//,'''') && location.hostname == this.hostname) {',
'      var target = $(this.hash);',
'      target = target.length ? target : $(''[name="'' + this.hash.slice(1) +''"]'');',
'      if (target.length) {',
'        $(''html,body'').animate({',
'          scrollTop: target.offset().top',
'        }, 500);',
'        return false;',
'      }',
'    }',
'  });',
'});'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!--[if HTML5]><![endif]-->',
'<!doctype html>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<!--[if lt IE 7 ]> <html class="no-js lt-ie9 lt-ie8 lt-ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 7 ]>    <html class="no-js lt-ie9 lt-ie8 ie7" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 8 ]>    <html class="no-js lt-ie9 ie8" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if IE 9 ]>    <html class="no-js ie9" lang="&BROWSER_LANGUAGE."> <![endif]-->',
'<!--[if (gt IE 9)|!(IE)]><!--> <html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE."> <!--<![endif]-->',
'<head>',
'  <meta charset="UTF-8" />',
'  <title>#TITLE#</title>',
'  <link rel="shortcut icon" href="#IMAGE_PREFIX#ws/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#ws/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#ws/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#ws/favicon-180x180.png">',
'  ',
'  #APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--login #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'<div class="u-Layout u-Layout--centerVertically a-Login-slide" id="top">',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="a-Login-container">',
'  #BODY#',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140086138940349443.4903)
,p_page_template_id=>wwv_flow_api.id(1418140425267007336.4903)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140086287346349443.4903)
,p_page_template_id=>wwv_flow_api.id(1418140425267007336.4903)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140086320010349442.4903)
,p_page_template_id=>wwv_flow_api.id(1418140425267007336.4903)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140086441817349442.4903)
,p_page_template_id=>wwv_flow_api.id(1418140425267007336.4903)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_image_legacy_apex_5_migration
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(3791820543327.4903)
,p_template_name=>'HTML image (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_IMAGE_LEGACY_APEX_5_MIGRATION'
,p_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_hot_template=>'<a href="#LINK#" id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#BUTTON_CSS_CLASSES#" alt="#LABEL!ATTR#" border="#" #BUTTON_ATTRIBUTES# /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_template_comment=>'5.0 upgrade'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_title_add_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(9301120013126533.4903)
,p_template_name=>'[EBA] Title - Add Button'
,p_internal_name=>'[EBA]_TITLE_ADD_BUTTON'
,p_template=>'<a href="#LINK#" class="ebaTitleButton" role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="addIcon" #BUTTON_ATTRIBUTES# id="#BUTTON_ID" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_title_view_all_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(9301209409132905.4903)
,p_template_name=>'[EBA] Title - View All Button'
,p_internal_name=>'[EBA]_TITLE_VIEW_ALL_BUTTON'
,p_template=>'<a href="#LINK#" class="ebaTitleButton" role="button"><img src="#IMAGE_PREFIX#f_spacer.gif" class="viewAllIcon" #BUTTON_ATTRIBUTES# id="#BUTTON_ID" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_hot_button_next
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(10604003722246228.4903)
,p_template_name=>'[EBA] Hot Button (Next)'
,p_internal_name=>'[EBA]_HOT_BUTTON_NEXT'
,p_template=>'<a href="#LINK#" class="ebaHotButton ebaNextButton" role="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15106902867837483.4903)
,p_template_name=>'[EBA] Button'
,p_internal_name=>'[EBA]_BUTTON'
,p_template=>'<a href="#LINK#" class="ebaButton" id="#BUTTON_ID#" role="button" #BUTTON_ATTRIBUTES#>#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_hot_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15108012910840408.4903)
,p_template_name=>'[EBA] Hot Button'
,p_internal_name=>'[EBA]_HOT_BUTTON'
,p_template=>'<a href="#LINK#" class="ebaHotButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_button_delete
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15160928947568323.4903)
,p_template_name=>'[EBA] Button (Delete)'
,p_internal_name=>'[EBA]_BUTTON_DELETE'
,p_template=>'<a href="#LINK#" class="ebaButton ebaDeleteButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_title_options_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15650119453846225.4903)
,p_template_name=>'[EBA] Title - Options Button'
,p_internal_name=>'[EBA]_TITLE_OPTIONS_BUTTON'
,p_template=>'<a href="#LINK#" class="ebaTitleButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><img src="#IMAGE_PREFIX#f_spacer.gif" class="addIcon" #BUTTON_ATTRIBUTES# id="#BUTTON_ID" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_title_back_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(15650219931855856.4903)
,p_template_name=>'[EBA] Title - Back Button '
,p_internal_name=>'[EBA]_TITLE_BACK_BUTTON_'
,p_template=>'<a href="#LINK#" class="ebaTitleButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><img src="#IMAGE_PREFIX#f_spacer.gif" class="backIcon"/></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_title_expand_collapse_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(16714408571357214.4903)
,p_template_name=>'[EBA] Title - Expand/Collapse Button '
,p_internal_name=>'[EBA]_TITLE_EXPAND/COLLAPSE_BUTTON_'
,p_template=>'<a href="#LINK#" class="ebaTitleButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#" title="#LABEL!ATTR#"><img src="#IMAGE_PREFIX#f_spacer.gif" class="hideIcon" alt="#LABEL!ATTR#" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>6
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_small_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(20457218105321816.4903)
,p_template_name=>'[EBA] Small Button'
,p_internal_name=>'[EBA]_SMALL_BUTTON'
,p_template=>'<a href="#LINK#" class="wsSmallButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_small_hot_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(20480423759330923.4903)
,p_template_name=>'[EBA] Small Hot Button'
,p_internal_name=>'[EBA]_SMALL_HOT_BUTTON'
,p_template=>'<a href="#LINK#" class="wsSmallButton wsHotButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>4
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_small_button_previous
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(20890400835826116.4903)
,p_template_name=>'[EBA] Small Button (Previous)'
,p_internal_name=>'[EBA]_SMALL_BUTTON_PREVIOUS'
,p_template=>'<a href="#LINK#" class="wsSmallButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="smallPrevIcon" /> #LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_small_hot_button_next
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(20890726723852448.4903)
,p_template_name=>'[EBA] Small Hot Button (Next) '
,p_internal_name=>'[EBA]_SMALL_HOT_BUTTON_NEXT_'
,p_template=>'<a href="#LINK#" class="wsSmallButton wsHotButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML# <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="smallNextIcon" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_small_button_next
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(20905523503069232.4903)
,p_template_name=>'[EBA] Small Button (Next) '
,p_internal_name=>'[EBA]_SMALL_BUTTON_NEXT_'
,p_template=>'<a href="#LINK#" class="wsSmallButton" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML# <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="smallNextIcon" /></a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/eba_button_previous
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(61282809984809202.4903)
,p_template_name=>'[EBA] Button (Previous)'
,p_internal_name=>'[EBA]_BUTTON_PREVIOUS'
,p_template=>'<a href="#LINK#" class="ebaButton ebaPrevButton" role="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />#LABEL!HTML#</a>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/html_button_legacy_apex_5_migration
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(629231036412957099.4903)
,p_template_name=>'HTML button (legacy - APEX 5 migration)'
,p_internal_name=>'HTML_BUTTON_LEGACY_APEX_5_MIGRATION'
,p_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_hot_template=>'<input type="button" value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" id="#BUTTON_ID#" class="#BUTTON_CSS_CLASSES#" #BUTTON_ATTRIBUTES#/>'
,p_translate_this_template=>'N'
,p_theme_class_id=>13
,p_template_comment=>'5.0 upgrade'
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(798473351219404350.4903)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4903
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(936712837989177653.4903)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4903
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(936746267011392790.4903)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4903
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/div_with_id
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(3700433754276.4903)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'Div with ID'
,p_internal_name=>'DIV_WITH_ID'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>7
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140660576405344345.4903)
,p_plug_template_id=>wwv_flow_api.id(3700433754276.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140660636395344345.4903)
,p_plug_template_id=>wwv_flow_api.id(3700433754276.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_ws_side_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(9299916504097072.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsSideSection">',
'	<h3>#TITLE#',
'		<span>',
'		#CLOSE##PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##CREATE2##EXPAND##COPY##HELP#',
'		</span>',
'	</h3>',
'	#BODY#',
'</div>'))
,p_page_plug_template_name=>'[EBA] WS Side Region'
,p_internal_name=>'[EBA]_WS_SIDE_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140660777960344345.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140660876152344345.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140660929497344345.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661032838344345.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661131645344345.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661271245344344.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661307299344344.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661425547344344.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661541149344344.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661644344344344.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661736711344344.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661837734344344.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140661901606344344.4903)
,p_plug_template_id=>wwv_flow_api.id(9299916504097072.4903)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(10604720260269861.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsButtonBar">',
'#BODY##CLOSE##EDIT##DELETE##PREVIOUS##CREATE##CHANGE##CREATE2##EXPAND##HELP##COPY##NEXT#</div>'))
,p_page_plug_template_name=>'[EBA] Button Region'
,p_internal_name=>'[EBA]_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662067814344344.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662179042344344.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662203670344343.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662330662344343.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662421926344343.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662533883344343.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662678374344343.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662773089344343.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662868714344343.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140662920203344343.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663094640344343.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663168558344343.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663280101344342.4903)
,p_plug_template_id=>wwv_flow_api.id(10604720260269861.4903)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_collapsable_text_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(11269620137104105.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsSection" id="#REGION_STATIC_ID#"> <!-- Begin .wsSection -->',
'	<h2><a href="javascript:void(0)" class="wsSectionControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&COLLAPSE." /></a>',
'		#TITLE#',
'		<span>',
'			<a href="#" class="wsSectionLink wsTopLink" title="&GO_TO_TOP."><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&GO_TO_TOP." class="topIcon" /></a>',
'		</span>',
'	</h2>',
'	<div class="wsSectionContent">',
'		<div class="wsTextSection #REGION_ATTRIBUTES#">',
'			#BODY#',
'		</div>',
'	</div>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Collapsable Text Region'
,p_internal_name=>'[EBA]_COLLAPSABLE_TEXT_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663350302344342.4903)
,p_plug_template_id=>wwv_flow_api.id(11269620137104105.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663464125344342.4903)
,p_plug_template_id=>wwv_flow_api.id(11269620137104105.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_two_col_pane_heading_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(15634208564734334.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h2 #REGION_ATTRIBUTES#>',
'	<span class="leftButtons">',
'		#PREVIOUS#',
'	</span>',
'	#TITLE#',
'	<span>',
'		#EDIT##CLOSE##DELETE##CREATE##CREATE2##EXPAND##HELP##COPY##NEXT#',
'	</span>',
'</h2>',
'#BODY#'))
,p_page_plug_template_name=>'[EBA] Two Col Pane Heading Region'
,p_internal_name=>'[EBA]_TWO_COL_PANE_HEADING_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663524386344342.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663645596344342.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663719191344342.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663897217344342.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140663926000344342.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664061522344342.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664135877344341.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664249439344341.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664317041344341.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664423144344341.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664596270344341.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664667096344341.4903)
,p_plug_template_id=>wwv_flow_api.id(15634208564734334.4903)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_two_col_pane_heading_left_col_with_control_menu
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(17121518626936007.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span class="leftButtons" #REGION_ATTRIBUTES#>#PREVIOUS##EXPAND##EDIT##CLOSE##DELETE##CREATE##CREATE2##HELP##COPY##NEXT# </span>',
'#TITLE#<span class="rightButtons" #REGION_ATTRIBUTES#>#CHANGE#</span>'))
,p_page_plug_template_name=>'[EBA] Two Col Pane Heading (Left Col with Control Menu)'
,p_internal_name=>'[EBA]_TWO_COL_PANE_HEADING_LEFT_COL_WITH_CONTROL_MENU'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664796937344341.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664883032344341.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140664908404344341.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665020135344341.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665174796344340.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665214830344340.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665333045344340.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665489411344340.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665508792344340.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665638491344340.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665769247344340.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665841617344340.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140665930824344340.4903)
,p_plug_template_id=>wwv_flow_api.id(17121518626936007.4903)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_form_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(20185117556737935.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsFormRegion">',
'#BODY#',
'</div>'))
,p_page_plug_template_name=>'[EBA] Form Region'
,p_internal_name=>'[EBA]_FORM_REGION'
,p_theme_id=>3
,p_theme_class_id=>8
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666013798344340.4903)
,p_plug_template_id=>wwv_flow_api.id(20185117556737935.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666146968344339.4903)
,p_plug_template_id=>wwv_flow_api.id(20185117556737935.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_action_bar_top
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(20454830409304572.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsActionBar">',
'#PREVIOUS#',
'#BODY#',
'<span class="wsActionBarRight">',
'#CLOSE##EDIT##DELETE##CREATE##CREATE2##EXPAND##HELP##COPY##NEXT#',
'</span>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Action Bar Top'
,p_internal_name=>'[EBA]_ACTION_BAR_TOP'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666211998344339.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666384600344339.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666409296344339.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666584763344339.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666615182344339.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666759434344339.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666820101344339.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140666930577344339.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667024732344338.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667180277344338.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667270512344338.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667378561344338.4903)
,p_plug_template_id=>wwv_flow_api.id(20454830409304572.4903)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_action_bar_bottom
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(20910304550120452.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsActionBar wsActionBarBottom">',
'<div class="wsActionBarInside">',
'#PREVIOUS#',
'#BODY#',
'<span class="wsActionBarRight">',
'#CLOSE##EDIT##DELETE##CREATE##CREATE2##EXPAND##HELP##COPY##NEXT#',
'</span>',
'</div>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Action Bar Bottom'
,p_internal_name=>'[EBA]_ACTION_BAR_BOTTOM'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667486569344338.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667532706344338.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667607480344338.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667769925344338.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667827978344338.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140667981395344338.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668079020344337.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668110637344337.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668240256344337.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668341428344337.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668424534344337.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668593167344337.4903)
,p_plug_template_id=>wwv_flow_api.id(20910304550120452.4903)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_interactive_report_with_no_action_bar
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(20956911766368602.4903)
,p_layout=>'TABLE'
,p_template=>'<div class="wsInteractiveReportOnly" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[EBA] Interactive Report with No Action Bar'
,p_internal_name=>'[EBA]_INTERACTIVE_REPORT_WITH_NO_ACTION_BAR'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668696993344337.4903)
,p_plug_template_id=>wwv_flow_api.id(20956911766368602.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668794309344337.4903)
,p_plug_template_id=>wwv_flow_api.id(20956911766368602.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_action_bar_only
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(25109627701530900.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsActionBar wsActionBarOnly" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'#PREVIOUS#',
'#BODY#',
'<span class="wsActionBarRight">',
'#CLOSE##EDIT##DELETE##CREATE##CREATE2##EXPAND##HELP##COPY##NEXT#',
'</span>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Action Bar Only'
,p_internal_name=>'[EBA]_ACTION_BAR_ONLY'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668860748344337.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140668961693344337.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669026948344336.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669187621344336.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669228015344336.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669320922344336.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669466993344336.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669541021344336.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669680053344336.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669794439344336.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669891725344336.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140669919080344336.4903)
,p_plug_template_id=>wwv_flow_api.id(25109627701530900.4903)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_collapsable_form_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(27071223638280295.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsSection"> <!-- Begin .wsSection -->',
'	<h2><a href="javascript:void(0)" class="wsSectionControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&COLLAPSE." /></a>',
'		#TITLE#',
'		<span>',
'			<a href="#" class="wsSectionLink wsTopLink" title="&GO_TO_TOP."><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&GO_TO_TOP." class="topIcon" /></a>',
'		</span>',
'	</h2>',
'	<div class="wsSectionContent">',
'		<div class="wsFormRegion">',
'			#BODY#',
'		</div>',
'	</div>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Collapsable Form Region '
,p_internal_name=>'[EBA]_COLLAPSABLE_FORM_REGION_'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670021608344335.4903)
,p_plug_template_id=>wwv_flow_api.id(27071223638280295.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670194534344335.4903)
,p_plug_template_id=>wwv_flow_api.id(27071223638280295.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_collapsable_form_region_collapsed
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(47316730240795884.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsSection"> <!-- Begin .wsSection -->',
'	<h2><a href="javascript:void(0)" class="wsSectionControl wsSectionCollapsed"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&COLLAPSE." /></a>',
'		#TITLE#',
'		<span>',
'			<a href="#" class="wsSectionLink wsTopLink" title="&GO_TO_TOP."><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&GO_TO_TOP." class="topIcon" /></a>',
'		</span>',
'	</h2>',
'	<div class="wsSectionContent" style="display: none">',
'		<div class="wsFormRegion">',
'			#BODY#',
'		</div>',
'	</div>',
'</div>'))
,p_page_plug_template_name=>'[EBA] Collapsable Form Region (Collapsed) '
,p_internal_name=>'[EBA]_COLLAPSABLE_FORM_REGION_COLLAPSED_'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670297051344335.4903)
,p_plug_template_id=>wwv_flow_api.id(47316730240795884.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670358018344335.4903)
,p_plug_template_id=>wwv_flow_api.id(47316730240795884.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_small_form_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(82536903857665765.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsFormRegion wsSmallFormRegion">',
'#BODY#',
'</div>'))
,p_page_plug_template_name=>'[EBA] Small Form Region'
,p_internal_name=>'[EBA]_SMALL_FORM_REGION'
,p_theme_id=>3
,p_theme_class_id=>8
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670483707344335.4903)
,p_plug_template_id=>wwv_flow_api.id(82536903857665765.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670542632344335.4903)
,p_plug_template_id=>wwv_flow_api.id(82536903857665765.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_small_form_component_left
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(108051114664442909.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsSmallFormComponent wsSmallFormComponentLeft" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'#PREVIOUS#',
'#BODY#',
'#CLOSE##EDIT##DELETE##CREATE##CREATE2##EXPAND##HELP##COPY##NEXT#',
'</div>'))
,p_page_plug_template_name=>'[EBA] Small Form Component Left'
,p_internal_name=>'[EBA]_SMALL_FORM_COMPONENT_LEFT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670697553344335.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670799977344335.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670885644344335.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140670978891344334.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671065910344334.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671183490344334.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671217047344334.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671393937344334.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671453455344334.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671537352344334.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671690409344334.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671712619344334.4903)
,p_plug_template_id=>wwv_flow_api.id(108051114664442909.4903)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/dhtml_hidden_with_id_required_for_data_grid_file_upload
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(173336062654423126.4903)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_ID#" style="display:none;">#BODY#</div>'
,p_page_plug_template_name=>'(DHTML) Hidden with ID (Required for Data Grid File Upload)'
,p_internal_name=>'DHTML_HIDDEN_WITH_ID_REQUIRED_FOR_DATA_GRID_FILE_UPLOAD'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671830212344334.4903)
,p_plug_template_id=>wwv_flow_api.id(173336062654423126.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140671926891344333.4903)
,p_plug_template_id=>wwv_flow_api.id(173336062654423126.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_toolbar_container
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(202707431395573866.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsMenu" id="#REGION_STATIC_ID#">',
'#BODY#',
'</div>'))
,p_page_plug_template_name=>'[EBA] Toolbar Container'
,p_internal_name=>'[EBA]_TOOLBAR_CONTAINER'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672009613344333.4903)
,p_plug_template_id=>wwv_flow_api.id(202707431395573866.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672185006344333.4903)
,p_plug_template_id=>wwv_flow_api.id(202707431395573866.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/div_with_id_required_for_edit_report_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(400020739576925060.4903)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'Div  with ID ( Required for Edit Report Attributes)'
,p_internal_name=>'DIV_WITH_ID_REQUIRED_FOR_EDIT_REPORT_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>7
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672263295344333.4903)
,p_plug_template_id=>wwv_flow_api.id(400020739576925060.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672305141344333.4903)
,p_plug_template_id=>wwv_flow_api.id(400020739576925060.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(931543191007401308.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4903
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672438243344333.4903)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672591963344333.4903)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672657652344333.4903)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672736479344333.4903)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672851686344332.4903)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140672912580344332.4903)
,p_plug_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/eba_no_template
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1071999318750156264.4903)
,p_layout=>'TABLE'
,p_template=>'#BODY#'
,p_page_plug_template_name=>'[EBA] No Template'
,p_internal_name=>'[EBA]_NO_TEMPLATE'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673041572344332.4903)
,p_plug_template_id=>wwv_flow_api.id(1071999318750156264.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673138725344332.4903)
,p_plug_template_id=>wwv_flow_api.id(1071999318750156264.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1332151043262185426.4903)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4903
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673254334344332.4903)
,p_plug_template_id=>wwv_flow_api.id(1332151043262185426.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673332934344332.4903)
,p_plug_template_id=>wwv_flow_api.id(1332151043262185426.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673403677344332.4903)
,p_plug_template_id=>wwv_flow_api.id(1332151043262185426.4903)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673575133344332.4903)
,p_plug_template_id=>wwv_flow_api.id(1332151043262185426.4903)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_workspace_login_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1418149362592020763.4903)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Login-body">',
'  #BODY#',
'</div>',
'<div class="a-Login-buttons">',
'  #NEXT#',
'</div>',
'<div class="a-Login-links">',
'  #EDIT##CREATE#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Workspace Login Region'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>781637364422290692.4903
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673684257344332.4903)
,p_plug_template_id=>wwv_flow_api.id(1418149362592020763.4903)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673767486344332.4903)
,p_plug_template_id=>wwv_flow_api.id(1418149362592020763.4903)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673824307344331.4903)
,p_plug_template_id=>wwv_flow_api.id(1418149362592020763.4903)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140673998844344331.4903)
,p_plug_template_id=>wwv_flow_api.id(1418149362592020763.4903)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140674022473344331.4903)
,p_plug_template_id=>wwv_flow_api.id(1418149362592020763.4903)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_toolbar_menu
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(9301809587170761.4903)
,p_list_template_current=>'<li class="#A01#"><a href="javascript:void(0)" id="#A03#">#TEXT#<img src="#IMAGE_PREFIX#ws/img/spacer.gif" alt="" /></a></li>'
,p_list_template_noncurrent=>'<li class="#A01#"><a href="javascript:void(0)" id="#A03#">#TEXT#<img src="#IMAGE_PREFIX#ws/img/spacer.gif" alt="" /></a></li>'
,p_list_template_name=>'[EBA] Toolbar Menu '
,p_internal_name=>'[EBA]_TOOLBAR_MENU_'
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>' '
,p_list_template_after_rows=>' '
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_noncurrent=>'<li class="#A01#"><a href="#LINK#" class="wsMenuItem #A04#">#TEXT#<span>#A02#</span></a></li>'
,p_item_templ_curr_w_child=>'<li class="#A01#"><a href="javascript:void(0)" id="#A03#">#TEXT#<img src="#IMAGE_PREFIX#ws/img/spacer.gif" alt="" /></a>#SUB_LISTS#</li>'
,p_item_templ_noncurr_w_child=>'<li class="#A01#"><a href="javascript:void(0)" id="#A03#">#TEXT#<img src="#IMAGE_PREFIX#ws/img/spacer.gif" alt="" /></a>#SUB_LISTS#</li>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_pop_up_tabs
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(11252405836967523.4903)
,p_list_template_current=>'--><li class="active"><a href="#LINK#">#TEXT#</a></li><!--'
,p_list_template_noncurrent=>'--><li><a href="#LINK#">#TEXT#</a></li><!--'
,p_list_template_name=>'[EBA] Pop Up Tabs'
,p_internal_name=>'[EBA]_POP_UP_TABS'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsTabs">',
'  <ul><!-- '))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--><li class="searchBox">',
'    <div class="wsSearch" style="display: none;">',
'      <input type="text" id="wsSearchBar"/>',
'      <span></span>',
'    </div>',
'  </li>',
'</ul>',
'</div>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_pop_up_side_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(11270206893119252.4903)
,p_list_template_current=>'<li><a href="#LINK#" class="active">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'[EBA] Pop Up Side Navigation'
,p_internal_name=>'[EBA]_POP_UP_SIDE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_left_pane_sections_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(15654631677982271.4903)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="javascript:applyAndGoToNextSection(''&APP_PAGE_ID.'',''#A06#'',''#A07#'',''#A08#'');" class="#A05#" title="#A02#">',
'		<span><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" alt="#A02#" /></span>',
'		<h3>#TEXT_ESC_SC#',
'			<em>#A03# &mdash; #A04#</em></h3>',
'	</a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="#LINK#">',
'		<span><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" alt="#A02#" /></span>',
'		<h3>#TEXT_ESC_SC#',
'			<em>#A03# &mdash; #A04#</em></h3>',
'	</a>',
'</li>'))
,p_list_template_name=>'[EBA] Left Pane Sections List'
,p_internal_name=>'[EBA]_LEFT_PANE_SECTIONS_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<ul class="sectionList">'
,p_list_template_after_rows=>' </ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_heading_control_menu
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(17118702088912337.4903)
,p_list_template_current=>'<a href="#LINK#" class="ebaTitleButton"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" alt="#TEXT#" title="#TEXT#"/></a>'
,p_list_template_noncurrent=>'<a href="#LINK#" class="ebaTitleButton"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#"  alt="#TEXT#" title="#TEXT#"/></a>'
,p_list_template_name=>'[EBA] Heading Control Menu'
,p_internal_name=>'[EBA]_HEADING_CONTROL_MENU'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<span class="controlMenus">'
,p_list_template_after_rows=>' </span>'
,p_before_sub_list=>'<div class="panelMenuContainer"><div class="panelMenu"><ul>'
,p_after_sub_list=>'</ul></div></div>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>'<a href="#LINK#" class="ebaTitleButton controlMenu"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" alt="#TEXT#" title="#TEXT#"/></a>'
,p_item_templ_noncurr_w_child=>'<a href="#LINK#" class="ebaTitleButton controlMenu"><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" alt="#TEXT#" title="#TEXT#"/></a>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_horizontal_progress_bar_train
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(17197023652325418.4903)
,p_list_template_current=>'<li class="currentStep"><span></span></li>'
,p_list_template_noncurrent=>'<li><span></span></li>'
,p_list_template_name=>'[EBA] Horizontal Progress Bar Train'
,p_internal_name=>'[EBA]_HORIZONTAL_PROGRESS_BAR_TRAIN'
,p_theme_id=>3
,p_theme_class_id=>17
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="ebaProgressWizard">',
''))
,p_list_template_after_rows=>' </ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_left_pane_pages_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(18574125863745642.4903)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="#LINK#" class="#A04#">',
'		<span><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" /></span>',
'		<h3>#TEXT#',
'			<em>#A02# &mdash; #A03#</em></h3>',
'	</a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="#LINK#">',
'		<span><img src="#IMAGE_PREFIX#f_spacer.gif" class="#A01#" /></span>',
'		<h3>#TEXT#',
'			<em>#A02# &mdash; #A03#</em></h3>',
'	</a>',
'</li>'))
,p_list_template_name=>'[EBA] Left Pane Pages List '
,p_internal_name=>'[EBA]_LEFT_PANE_PAGES_LIST_'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<ul class="sectionList">'
,p_list_template_after_rows=>' </ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_unformatted_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(20455926267312733.4903)
,p_list_template_current=>'<li><a href="#LINK#" class="active">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'[EBA] Unformatted List'
,p_internal_name=>'[EBA]_UNFORMATTED_LIST'
,p_theme_id=>3
,p_theme_class_id=>3
,p_list_template_before_rows=>' <ul>'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_large_icons_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(138239722779443444.4903)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="" alt="" /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
,p_list_template_name=>'[EBA] Large Icons List'
,p_internal_name=>'[EBA]_LARGE_ICONS_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table class="ebaLargeIcons" width="100%" cellspacing="0" cellpadding="0" border="0" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/dhtml_list_image_with_sublist_from_4999
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(156210646767386810.4903)
,p_list_template_current=>'<div class="dhtmlMenuItem"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></a><img src="#IMAGE_PREFIX#ws/dropdown_32x24.gif" width="32" height="24" class="dhtmlMenu" onclick="app_AppMenuMultiOpenBottom(this,''#L'
||'IST_ITEM_ID#'',false)" alt=""/><a href="#LINK#" class="dhtmlBottom" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_noncurrent=>'<div class="dhtmlMenuItem"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></a><a href="#LINK#" class="dhtmlBottom" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_list_template_name=>'DHTML List (Image) with Sublist from 4999'
,p_internal_name=>'DHTML_LIST_IMAGE_WITH_SUBLIST_FROM_4999'
,p_theme_id=>3
,p_theme_class_id=>4
,p_list_template_before_rows=>'<div class="dhtmlMenuLG">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">',
'<li class="dhtmlSubMenuP" onmouseover="dhtml_CloseAllSubMenusL(this)">#PARENT_TEXT#</li>'))
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#1px_trans.gif"  width="1" height="1" alt=""  class="dhtmlMenuSep" />#TEXT#</li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></li>'
,p_item_templ_noncurr_w_child=>'<div class="dhtmlMenuItem"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="dhtmlMenu" onclick="ws_Pd(this,''#LIST_ITEM_ID#'',false)" alt=""/><a href="#LINK#" class="dhtmlBottom" title="#TEXT_ESC_SC#">#TEXT#</a></div>'
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /><span>#TEXT#</span><img class="htmldbMIMG" alt="" s'
||'rc="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>'
,p_sub_templ_noncurr_w_child=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#" style="background-image:url(#IMAGE_PREFIX#menu_open_right2.gif);background-repeat:no-repeat;background-position:95% cente'
||'r;"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</a></li>'
,p_list_template_comment=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')" title="#TEXT_ESC_SC#"><span><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />#TEXT#</span><img class="htmldbMIMG" alt="" s'
||'rc="#IMAGE_PREFIX#menu_open_right2.gif" /></a></li>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/eba_left_pane_pages_list_new
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(158861503239501998.4903)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03#">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="-" /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03#">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="-" /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_list_template_name=>'[EBA] Left Pane Pages List [NEW]'
,p_internal_name=>'[EBA]_LEFT_PANE_PAGES_LIST_[NEW]'
,p_theme_id=>3
,p_theme_class_id=>19
,p_list_template_before_rows=>' <ul class="pageList" id="pageList">'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03#">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="-" /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03#">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="-" /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03# containsSubList">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl expanded"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&EXPANDED." /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03# containsSubList">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl expanded"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&EXPANDED." /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03# containsSubList">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl expanded"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&EXPANDED." /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="#A03# containsSubList">',
'	<div class="pageListOut"><div class="pageListIn">',
'		<a href="javascript:void(0)" class="listControl expanded"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="&EXPANDED." /></a>',
'		<a href="#LINK#">',
'			#TEXT_ESC_SC#',
'				<em>#A01# &mdash; #A02#</em>',
'		</a>',
'	</div></div>',
'</li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_websheets_menu
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(929122129315135247.4903)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Websheets Menu'
,p_internal_name=>'APEX_5.0_WEBSHEETS_MENU'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>' '
,p_list_template_after_rows=>' '
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>926415475390827132.4903
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(936708315591140469.4903)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4903
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(1338174060370978758.4903)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4903
);
end;
/
prompt --application/shared_components/user_interface/templates/report/eba_report_sortable
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(46784125242633572.4903)
,p_row_template_name=>'[EBA] Report (Sortable)'
,p_internal_name=>'[EBA]_REPORT_SORTABLE'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>'<table class="wsStandardReport wsTable" summary="" cellspacing="0" cellpadding="0" id="r#REGION_ID#"><tbody>'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>',
'<script>',
'var g_#REGION_ID#;',
'function f_#REGION_ID#(){',
'		g_#REGION_ID# =  new apex.tabular.sort(''r#REGION_ID#'');',
'		}',
'addLoadEvent(f_#REGION_ID#)',
'</script>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#EEE'
,p_row_style_checked=>'#EEE'
,p_theme_id=>3
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/eba_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(129228711620465473.4903)
,p_row_template_name=>'[EBA] Report'
,p_internal_name=>'[EBA]_REPORT'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>'<table class="wsStandardReport wsTable" summary="" cellspacing="0" cellpadding="0" id="r#REGION_ID#"><tbody>'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_next_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_page_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_next_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-left:5px;"><img src="#IMAGE_PREFIX#jtfunexe.gif" alt="" /></a>'
,p_previous_set_template=>'<a href="javascript:html_PPR_Report_Page(this,''#REGION_ID#'',''#LINK#'')" style="margin-right:5px;"><img src="#IMAGE_PREFIX#jtfupree.gif" alt=""/></a>'
,p_row_style_mouse_over=>'#EEE'
,p_row_style_checked=>'#EEE'
,p_theme_id=>3
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/eba_portlet_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(171646109232237656.4903)
,p_row_template_name=>'[EBA] Portlet Column'
,p_internal_name=>'[EBA]_PORTLET_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4903
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/eba_portlet_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(171646521495237685.4903)
,p_row_template_name=>'[EBA] Portlet Row'
,p_internal_name=>'[EBA]_PORTLET_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr>',
'<th><label>#1#</label></th>',
'<td>#2#</td>',
'</tr>'))
,p_row_template_before_rows=>'<table class="wsTable wsPortlet" #REPORT_ATTRIBUTES# id="#REGION_ID#">'
,p_row_template_after_rows=>'</table>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(5556614497310460.4903)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4903
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/eba_optional_w_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(11461002620401386.4903)
,p_template_name=>'[EBA] Optional w/ Help'
,p_internal_name=>'[EBA]_OPTIONAL_W/_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="wsOptional">'
,p_template_body2=>'</label>'
,p_after_element=>'#HELP_TEMPLATE#'
,p_help_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button">',
'    <span class="a-Icon icon-help"></span>',
'    <span class="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span>',
'</button>'))
,p_on_error_after_label=>'<span class="wsLabelError">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/eba_required_w_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(11461206197401386.4903)
,p_template_name=>'[EBA] Required w/ Help'
,p_internal_name=>'[EBA]_REQUIRED_W/_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="wsRequired">'
,p_template_body2=>' <img src="#IMAGE_PREFIX#f_spacer.gif" alt="#VALUE_REQUIRED#" class="wsAsterisk" /></label>'
,p_after_element=>'#HELP_TEMPLATE#'
,p_help_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button">',
'    <span class="a-Icon icon-help"></span>',
'    <span class="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span>',
'</button>'))
,p_on_error_after_label=>'<span class="wsLabelError">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_workspace_login_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(264000229814622656.4903)
,p_template_name=>'Login Hidden Label'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_HIDDEN_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Icon a-Login-iconLabel a-Login-hiddenLabel u-VisuallyHidden">'
,p_template_body2=>'</label>'
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--hiddenLabel #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#"><div class="a-Form-inputContainer">'
,p_after_item=>'#HELP_TEMPLATE#</div></div>'
,p_after_element=>'#ERROR_TEMPLATE#'
,p_help_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button">',
'    <span class="a-Icon icon-help"></span>',
'    <span class="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span>',
'</button>'))
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_workspace_login_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1418153120551046350.4903)
,p_template_name=>'APEX 5.0 - Workspace Login Label'
,p_internal_name=>'APEX_5.0_WORKSPACE_LOGIN_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Icon a-Login-iconLabel">'
,p_template_body2=>'</label>'
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#"><div class="a-Form-inputContainer">'
,p_after_item=>'</div></div>'
,p_after_element=>'<span class="a-Login-iconValidation a-Icon icon-check"></span>#ERROR_TEMPLATE#'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span class="u-VisuallyHidden">#CURRENT_ITE'
||'M_HELP_LABEL#</span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>781637020106265852.4903
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/eba_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(20175617163709368.4903)
,p_name=>'[EBA] Breadcrumbs'
,p_internal_name=>'[EBA]_BREADCRUMBS'
,p_before_first=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsBreadcrumb wsBreadcrumbSubPage" id="wsBreadcrumb">',
'<ul class="ws-Breadcrumb">',
''))
,p_current_page_option=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="#LINK#">#NAME# <span class="a-Icon icon-right-chevron"></span></a>',
'</li>',
''))
,p_non_current_page_option=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li>',
'	<a href="#LINK#">#NAME# <span class="a-Icon icon-right-chevron"></span></a>',
'</li>',
''))
,p_after_last=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</ul>',
'</div>'))
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(165003451930708292.4903)
,p_popup_icon=>'#IMAGE_PREFIX#htmldb/icons/view_small.gif'
,p_popup_icon_attr=>'width="18" height="18" alt="#LIST_OF_VALUES#" title="#LIST_OF_VALUES#"'
,p_page_name=>'winlov'
,p_page_title=>'Suchen'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<!--[if IE]><meta http-equiv="X-UA-Compatible" content="IE=edge" /><![endif]-->',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe.css" type="text/css" />',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws.css" type="text/css" />',
'<!--[if IE 7]>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie7.css" type="text/css" />',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie7.css" type="text/css" />',
'<![endif]-->',
'<!--[if IE 8]>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/eba_uniframe_ie8.css" type="text/css" />',
'<link rel="stylesheet" href="#IMAGE_PREFIX#ws/css/ws_ie8.css" type="text/css" />',
'<![endif]-->',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'class="wsPopUpLOV"'
,p_before_field_text=>'<div class="wsActionBar wsActionBarOnly">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="searchField"'
,p_find_button_text=>'Suchen'
,p_find_button_attr=>'class="smallButton"'
,p_close_button_text=>unistr('Schlie\00DFen')
,p_close_button_attr=>'class="smallButton hotButton"'
,p_next_button_text=>'Weiter >'
,p_next_button_attr=>'class="smallButton"'
,p_prev_button_text=>unistr('< Zur\00FCck')
,p_prev_button_attr=>'class="smallButton"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'500'
,p_result_row_x_of_y=>'<div class="lovPagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="lovLinks">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/eba_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(20940421004163137.4903)
,p_cal_template_name=>'[EBA] Calendar'
,p_internal_name=>'[EBA]_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="CalendarHolder"> ',
' <tr>',
'   <td class="MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="WeekCalendarHolder">',
'<tr>',
'<td class="MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="Today">'
,p_daily_time_open_format=>'<th scope="row" class="Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(931574038306409142.4903)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(931574723130409146.4903)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(936751341799414713.4903)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931573772023409139.4903)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931573860104409140.4903)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931574184140409145.4903)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(931574038306409142)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931574386836409146.4903)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(931574038306409142)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931574519466409146.4903)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(931574038306409142)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931574894275409146.4903)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(931574723130409146)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931575094854409146.4903)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(931574723130409146)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931575149476409146.4903)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(931575333122409146.4903)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(931543191007401308.4903)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(931574038306409142)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(936709001085140492.4903)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4903)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(936709194813140492.4903)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4903)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1338174721014978766.4903)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554832103532526804.4903)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(1332151043262185426.4903)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554832278061526804.4903)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1332151043262185426.4903)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1554832317693526804.4903)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1332151043262185426.4903)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_api.create_build_option(
 p_id=>wwv_flow_api.id(239986615251259134.4903)
,p_build_option_name=>'Do Not Include in APEX 4.2 EA1'
,p_build_option_status=>'EXCLUDE'
,p_default_on_export=>'EXCLUDE'
);
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110269208235321630)
,p_name=>'ADD'
,p_message_language=>'de'
,p_message_text=>unistr('Hinzuf\00FCgen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110267309850321629)
,p_name=>'ADD_COLUMN'
,p_message_language=>'de'
,p_message_text=>unistr('Spalte hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110268529509321630)
,p_name=>'ADD_FILE'
,p_message_language=>'de'
,p_message_text=>unistr('Datei hinzuf\00FCgen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110268743750321630)
,p_name=>'ADD_LINK'
,p_message_language=>'de'
,p_message_text=>unistr('Link hinzuf\00FCgen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110268665444321630)
,p_name=>'ADD_NOTE'
,p_message_language=>'de'
,p_message_text=>unistr('Hinweis hinzuf\00FCgen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110269493862321630)
,p_name=>'ADD_ROW'
,p_message_language=>'de'
,p_message_text=>unistr('Zeile hinzuf\00FCgen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110268833527321630)
,p_name=>'ADD_TAGS'
,p_message_language=>'de'
,p_message_text=>unistr('Tags hinzuf\00FCgen')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110267008998321628)
,p_name=>'APPLY'
,p_message_language=>'de'
,p_message_text=>'Anwenden'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110266824180321628)
,p_name=>'CANCEL'
,p_message_language=>'de'
,p_message_text=>'Abbrechen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110269193455321630)
,p_name=>'COLUMNS'
,p_message_language=>'de'
,p_message_text=>'Spalten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110267637014321629)
,p_name=>'COLUMN_GROUPS'
,p_message_language=>'de'
,p_message_text=>'Spaltengruppen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110267475056321629)
,p_name=>'COLUMN_PROPERTIES'
,p_message_language=>'de'
,p_message_text=>'Spalteneigenschaften'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110267176295321629)
,p_name=>'COPY'
,p_message_language=>'de'
,p_message_text=>'Kopieren'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110268383427321629)
,p_name=>'COPY_DATA_GRID'
,p_message_language=>'de'
,p_message_text=>'Daten-Grid kopieren'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110267266379321629)
,p_name=>'DATA_GRID_PROPERTIES'
,p_message_language=>'de'
,p_message_text=>'Daten-Grid-Eigenschaften'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110266919115321628)
,p_name=>'DELETE'
,p_message_language=>'de'
,p_message_text=>unistr('L\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110267858107321629)
,p_name=>'DELETE_COLUMNS'
,p_message_language=>'de'
,p_message_text=>unistr('Spalten l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110268422348321630)
,p_name=>'DELETE_DATA_GRID'
,p_message_language=>'de'
,p_message_text=>unistr('Daten-Grid l\00F6schen')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110268268697321629)
,p_name=>'DELETE_ROWS'
,p_message_language=>'de'
,p_message_text=>unistr('Zeilen l\00F6schen')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110269688147321630)
,p_name=>'EDIT_ATTRIBUTES'
,p_message_language=>'de'
,p_message_text=>'Attribute bearbeiten'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110269737636321631)
,p_name=>'EDIT_QUERY'
,p_message_language=>'de'
,p_message_text=>'Abfrage bearbeiten'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110268166915321629)
,p_name=>'FILL'
,p_message_language=>'de'
,p_message_text=>unistr('F\00FCllen')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110269549574321630)
,p_name=>'HISTORY'
,p_message_language=>'de'
,p_message_text=>'Historie'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110267525716321629)
,p_name=>'LIST_OF_VALUES'
,p_message_language=>'de'
,p_message_text=>'Werteliste'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110268975275321630)
,p_name=>'PROPERTIES'
,p_message_language=>'de'
,p_message_text=>'Eigenschaften'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110268054586321629)
,p_name=>'REPLACE'
,p_message_language=>'de'
,p_message_text=>'Ersetzen'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110269381872321630)
,p_name=>'ROWS'
,p_message_language=>'de'
,p_message_text=>'Zeilen'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110267917233321629)
,p_name=>'SET_COLUMN_VALUES'
,p_message_language=>'de'
,p_message_text=>'Spaltenwerte festlegen'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110269000950321630)
,p_name=>'TOGGLE_CHECKBOXES'
,p_message_language=>'de'
,p_message_text=>unistr('Kontrollk\00E4stchen umschalten')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(110267752021321629)
,p_name=>'VALIDATION'
,p_message_language=>'de'
,p_message_text=>'Validierung'
,p_is_js_message=>true
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/ok_to_get_next_prev_pk_value
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(7176806101815144.4903)
,p_shortcut_name=>'OK_TO_GET_NEXT_PREV_PK_VALUE'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>unistr('M\00F6chten Sie diese Seite wirklich verlassen, ohne die \00C4nderungen zu speichern?')
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(155157613934985128.4903)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_shortcut=>unistr('Soll dieser L\00F6schvorgang ausgef\00FChrt werden?')
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/pick_ws_rpt_col_name
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(184021228934805221.4903)
,p_shortcut_name=>'PICK_WS_RPT_COL_NAME'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3050:&SESSION.::::P3050_CALLING_ITEM,P3050_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3010_LB_WS_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" border="0" w'
||'idth="18" height="18" alt="flashlight" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/pick_ws_rpt_col_value
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(185539627466561397.4903)
,p_shortcut_name=>'PICK_WS_RPT_COL_VALUE'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3040:&SESSION.::::P3040_CALLING_ITEM,P3040_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3010_WEBSHEET_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" border="0'
||'" width="18" height="18" alt="flashlight" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/pick_curr_ws_rpt_col
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(185548307614697562.4903)
,p_shortcut_name=>'PICK_CURR_WS_RPT_COL'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3040:&SESSION.::::P3040_CALLING_ITEM,P3040_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3010_WEBSHEET_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" border="0'
||'" width="18" height="18" alt="flashlight" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/p3020_pick_curr_ws_rpt_col
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(187888728094279874.4903)
,p_shortcut_name=>'P3020_PICK_CURR_WS_RPT_COL'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3040:&SESSION.::::P3040_CALLING_ITEM,P3040_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3020_WEBSHEET_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" border="0'
||'" width="18" height="18" alt="flashlight" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/p3020_pick_ws_rpt_col_name
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(187889809179283856.4903)
,p_shortcut_name=>'P3020_PICK_WS_RPT_COL_NAME'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3050:&SESSION.::::P3050_CALLING_ITEM,P3050_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3020_LB_WS_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" border="0" w'
||'idth="18" height="18" alt="flashlight" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/p3020_pick_ws_rpt_col_value
begin
wwv_flow_api.create_shortcut(
 p_id=>wwv_flow_api.id(187890114027285273.4903)
,p_shortcut_name=>'P3020_PICK_WS_RPT_COL_VALUE'
,p_shortcut_type=>'HTML_TEXT'
,p_shortcut=>'<a href="javascript:popUp2(''f?p=&APP_ID.:3040:&SESSION.:::3040:P3040_CALLING_ITEM,P3040_WEBSHEET_ID:#CURRENT_ITEM_NAME#,''+$v(''P3020_WEBSHEET_ID''),320,400);" tabindex="999" title="" class="itemlink"><img src="#IMAGE_PREFIX#flashlight2_trans.gif" borde'
||'r="0" width="18" height="18" alt="flashlight" /></a>'
);
end;
/
prompt --application/shared_components/security/authentications/internal_websheet_authentication
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(709672827800503408.4903)
,p_name=>'Internal Websheet Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.AUTHENTICATION.WEBSHEET'
,p_invalid_session_type=>'URL'
,p_invalid_session_url=>'f?p=4900:101:&APP_SESSION.'
,p_cookie_name=>'-NO_COOKIE-'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_searchbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(65218046382244660.4903)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.SEARCHBOX'
,p_display_name=>'Suchfeld'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.SEARCHBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_searchbox'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT'
,p_substitute_attributes=>true
,p_reference_id=>42609120788689442.4903
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513167447444230024.4903)
,p_plugin_id=>wwv_flow_api.id(65218046382244660.4903)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redirect URL'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_default_value=>'f?p=&APP_ID.:<target page>:&SESSION.::&DEBUG.::<target item>:'
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513167803753230024.4903)
,p_plugin_id=>wwv_flow_api.id(65218046382244660.4903)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Search Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Search'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
''))
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_clob_textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(377419101248577827.4903)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_display_name=>'CLOB-Textbereich'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CLOB_TEXTAREA'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_clob_textarea'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_clob_textarea'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:ELEMENT:WIDTH:HEIGHT'
,p_substitute_attributes=>false
,p_reference_id=>200125518386793215.4903
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513356480445479112.4903)
,p_plugin_id=>wwv_flow_api.id(377419101248577827.4903)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'SQL or PL/SQL to get CLOB value'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_display_length=>80
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This item supports sql statements, like',
'<pre>',
'select big_data',
'from my_table',
'where id=:P4711_ID',
'</pre>',
'and function results, like',
'<pre>',
'return wwv_flow_xxx.get_big_data(p_id => :P4711_ID);',
'</pre>',
'to get a clob value for rendering.',
'',
'To write the data back, the CLOB Textarea makes an AJAX call before the actual page submit, which stores the clob value in wwv_flow_collections.clob001, with a collection name that equals the item name.',
'Developers can then define a page process that stores the clob value where it belongs, either directly',
'<pre>',
'update my_table',
'   set big_data = (select clob001',
'                     from wwv_flow_collections',
'                    where collection_name=''P4711_BIG_DATA'')',
' where id = :P4711_ID;',
'</pre>',
'or via the built-in function wwv_flow_f4000_plugins.get_clob_textarea_value:',
'',
'<pre>',
'update my_table',
'   set agreement_text = wwv_flow_f4000_plugins.get_clob_textarea_value(''P4711_BIG_DATA'')',
' where id = :P4711_ID;',
'</pre>',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1513356893048479113.4903)
,p_plugin_id=>wwv_flow_api.id(377419101248577827.4903)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Textarea Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513357286353479114.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(1513356893048479113.4903)
,p_display_sequence=>10
,p_display_value=>'HTML Textarea'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1513357742751479114.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(1513356893048479113.4903)
,p_display_sequence=>20
,p_display_value=>'Rich Text Editor'
,p_return_value=>'CKEDITOR-Full'
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_data_grid
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(596503234954274806.4903)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.DATA_GRID'
,p_display_name=>'Daten-Grid'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.DATA_GRID'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_data_grid'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_data_grid'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Zeigt ein "Daten-Grid"-Widget von Application Express an.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(615743690109519472.4903)
,p_plugin_id=>wwv_flow_api.id(596503234954274806.4903)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Worksheet ID Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(615744471837526561.4903)
,p_plugin_id=>wwv_flow_api.id(596503234954274806.4903)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Show Checkbox Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(632128835511089827.4903)
,p_plugin_id=>wwv_flow_api.id(596503234954274806.4903)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Checks SQL Enabled'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_authentication_websheet
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(709653022821492509.4903)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.AUTHENTICATION.WEBSHEET'
,p_display_name=>'Interne Websheet-Authentifizierung'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.AUTHENTICATION.WEBSHEET'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_f4900.callback'
,p_session_sentry_function=>'wwv_flow_authentication_f4900.session_sentry'
,p_invalid_session_function=>'wwv_flow_authentication_f4900.invalid_session'
,p_post_logout_function=>'wwv_flow_authentication_f4900.post_logout'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1129000224849873155.4903)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>'Entwicklerautorisierung'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494.4903
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(651583615809363815.4903)
,p_plugin_id=>wwv_flow_api.id(1129000224849873155.4903)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651584047608363815.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651584589168363816.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651585023708363816.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651585536003363816.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651586043667363816.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651586548273363817.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651587007958363817.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651587521302363817.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651588015914363817.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651588581137363818.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651589076996363818.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(651589515126363818.4903)
,p_plugin_attribute_id=>wwv_flow_api.id(651583615809363815.4903)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2564397076686507738.4903)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>unistr('Kontrollk\00E4stchen "Alle pr\00FCfen" hinzuf\00FCgen')
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512.4903
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Die dynamische Aktion "Kontrollk\00E4stchen Alle pr\00FCfen hinzuf\00FCgen" macht eine Spalten\00FCberschrift, die die Zeichenfolge #CHECK_ALL_CHECKBOX# enth\00E4lt, zu einem zug\00E4nglichen Kontrollk\00E4stchen "Alle pr\00FCfen", das alle Kontrollk\00E4stchen in der entsprechenden')
||unistr(' Spalte w\00E4hlt bzw. deren Auswahl aufhebt.<p>'),
'<p>',
unistr('Zur Verwendung dieses Plug-ins m\00FCssen die folgenden Attribute festgelegt sein:'),
'<ol>',
unistr('<li>In der Berichtsspalte ist ''#CHECK_ALL_CHECKBOX#'' als \00DCberschriftenwert definiert.</li>'),
unistr('<li>F\00FCr das When-Attribut der dynamischen Aktion muss die Berichtsregion ausgew\00E4hlt sein, die die Spalte enth\00E4lt.</li>'),
unistr('<li>Die dynamische Aktion zur Ausl\00F6sung von "Nach Refresh" und die Aktion "Bei Laden von Seite ausl\00F6sen" m\00FCssen definiert sein. (Beide sind entsprechend als Standardwert definiert, wenn die dynamische Aktion durch Auswahl der Region im Abschnitt "Ren')
||'dering" des Page Designers erstellt wird und die dynamische Aktion von dort erstellt wird.</li>',
unistr('<li>Dadurch wird die Zug\00E4nglichkeit der Kontrollk\00E4stchen nicht festgelegt, die auf jeder Zeile wiedergegeben werden, dies muss separat in der Regionsquelle erfolgen. (Ein Beispiel finden Sie unter 4000:656 "Region").</li>'),
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4968616267302342.4903)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1000:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>.4903
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_api.create_page(
 p_id=>.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'0'
,p_step_title=>'0'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11470321135602393.4903)
,p_plug_name=>'Application Header [EBA]'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.page_header (',
'   p_app_id => :app_id,',
'   p_session => :app_session,',
'   p_app_user => :app_user,',
'   p_ws_app_id => :ws_app_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'9,90,102,605,3040,3050,92,101,888,999,6,12,15,16,17,19,22,25,27,28,29,30,901,50,33'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_comment=>'900,908,200,53,930,760,934,932,931,23,920,940,991,20,902,2,1000,9,950,906,903,904,905,915,928,1001,3,1,140,1250,11,951,910,990,31,960,205,201,206,4020,1310,1320,131,912,4040,4030,3000,21,926,921,927,922,923,925,710,740,745,742,750,37,13,18,24,141,800'
||'0,142,146,143,144,145,42,3010,3020,3030,3060,914,91,89'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22912720326182943.4903)
,p_plug_name=>'Search'
,p_region_css_classes=>'wsSearch'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3700433754276.4903)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'9,33,90,92,101,102,888,901,999,6,12,15,16,17,19,22,25,27,28,29,30,3040,3050,8000'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23000306359277138.4903)
,p_plug_name=>'widget for ws'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BEFORE_FOOTER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="rollover" style="position:absolute;display:none;">',
'  <table cellpadding="1" cellspacing="0" border="0" width="100%">',
'    <tr>',
'      <td><input type="text" onkeyup="html_Find(''rollover_content'',this.value);" style="width:150px;" id="search" /><img onclick="ws_SearchApply()" src="#IMAGE_PREFIX#ws/find_20x.gif" /></td>',
'    </tr>',
'    <tr>',
'      <td>',
'        <span id="sortup"><img src="#IMAGE_PREFIX#ws/dup.gif" alt="Sort Ascending" title="Sort Ascending" onclick="gReport.column.order(''ASC'')" /></span>',
'        <span id="sortdown"><img src="#IMAGE_PREFIX#ws/ddown.gif" alt="Sort Descending" title="Sort Descending" onclick="gReport.column.order(''DESC'')" /></span>',
'        <span id="removefilter"><img src="#IMAGE_PREFIX#ws/no_filter.gif" alt="Remove Filter" title="Remove Filter" onclick="gReport.column.filter_delete()" /></span>',
'        <span id="hide"><img src="#IMAGE_PREFIX#ws/trash.gif" alt="Hide Column" title="Hide Column" onclick="gReport.column.hide()" /></span>',
'        <span id="break"><img src="#IMAGE_PREFIX#ws/break_col.gif" alt="Break Column" title="Break Column" onclick="gReport.column.break_on()" /></span>',
'      </td>',
'    </tr>',
'  </table>',
'  <div id="rollover_content"></div>',
'</div>',
''))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_IN_CONDITION'
,p_plug_display_when_condition=>'2,16'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(111070233758155201.4903)
,p_plug_name=>'Websheets sind veraltet.'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_api.id(931543191007401308.4903)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Websheets sind nicht mehr lange verf\00FCgbar. Wenden Sie sich an den Administrator, wenn Sie die Daten in diesem Websheet migrieren m\00F6chten.</p>'),
'<p>',
unistr('<strong>Ben\00F6tigen Sie Hilfe bei der Migration?</strong>'),
unistr('Weitere Informationen finden Sie im <a href="https://einstein.oracle.com/q/are-you-still-using-websheets-on-apex-oraclecorp-com-2453" target="_blank">Einstein-Post</a> \00FCber das Webinar zur Websheets-Migration.'),
'</p>'))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_plug_display_when_condition=>'101'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'.a-Alert--horizontal .a-Alert-title { font-weight: 700; }',
'.a-Alert--horizontal .a-Alert-body { font-weight: 400; font-size: 14px; line-height: 1.5; color: rgba(0, 0, 0, .65); }',
'</style>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202667427121487089.4903)
,p_plug_name=>'Toolbar Menu Container'
,p_region_name=>'wsMenu'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(202707431395573866.4903)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_02'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'9,33,90,92,101,102,888,901,999,6,12,15,16,17,19,22,25,27,28,29,30,3040,3050'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'900,902,1,1000,906,903,904,928,905,915,2,3000,950,951,140,1250,11,3,18,24,141,8000,142,146,143,144,145,42'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202668901410498676.4903)
,p_plug_name=>'Data Grid Menu'
,p_parent_plug_id=>wwv_flow_api.id(202667427121487089.4903)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_data_grid_menu (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_app_session => :APP_SESSION);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(202703416002531181.4903)
,p_plug_name=>'Admin Menu'
,p_parent_plug_id=>wwv_flow_api.id(202667427121487089.4903)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(202684424744514793.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(929122129315135247.4903)
,p_translate_title=>'N'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'</ul></div>'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(246646208489080880.4903)
,p_plug_name=>'Report Menu'
,p_parent_plug_id=>wwv_flow_api.id(202667427121487089.4903)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_report_menu (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_app_session => :APP_SESSION);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_security.sql_enabled(:WS_APP_ID) and',
'   wwv_flow_ws_security.sql_enabled_inst then',
'  return true;',
'end if;',
'return false;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(929118964340126057.4903)
,p_plug_name=>'APEX 5.0 - Toolbar Menu'
,p_parent_plug_id=>wwv_flow_api.id(202667427121487089.4903)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(929134615131186819.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(929122129315135247.4903)
,p_translate_title=>'N'
,p_plug_header=>'<div id="websheets_menubar" class=""><ul style="display: none">'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(353259602905391710.4903)
,p_plug_name=>'print app custom css'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.print_custom_css (',
'    p_ws_app_id  => :WS_APP_ID',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'9,90,102,605,3040,3050,92,101,888,999,6,12,15,16,17,19,22,25,27,28,29,30,901,50,33'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(978301830711571982.4903)
,p_plug_name=>'high contrast mode CSS'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'AFTER_HEADER'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if htmldb_util.is_high_contrast_session then',
'  sys.htp.p(''<link rel="stylesheet" href="''||wwv_flow.g_image_prefix||''ws/css/ws_hc.css" type="text/css" />'');',
'end if;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(978405910887585124.4903)
,p_plug_name=>'high contrast mode .js'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'BEFORE_FOOTER'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if htmldb_util.is_high_contrast_session then',
'  sys.htp.p(''<script type="text/javascript">'');',
'  sys.htp.p(''initHighContrastMode()'');',
'  sys.htp.p(''</script>'');',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(29174927846182851.4903)
,p_name=>'P0_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22912720326182943.4903)
,p_prompt=>'Websheet suchen'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.SEARCHBOX'
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'f?p=&APP_ID.:8000:&SESSION.:::RIR:P8000_SEARCH:'
,p_attribute_02=>'Websheet suchen'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Dashboard'
,p_step_title=>'Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174589600742777269.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Auf dieser Seite werden Informationen zu dieser Anwendung angezeigt.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181148802605561554.4903)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108117930940447534.4903)
,p_plug_name=>'Zeitrahmen'
,p_parent_plug_id=>wwv_flow_api.id(181148802605561554.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(108051114664442909.4903)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185579501876856681.4903)
,p_name=>'Anwendungsdetails'
,p_template=>wwv_flow_api.id(27071223638280295.4903)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:33%; float:left;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'(',
'select name co',
'from wwv_flow_ws_applications',
'where id = :ws_app_id and',
'      security_group_id = :flow_security_group_id',
') application_name,',
'(',
'select apex_util.get_since(created_on) co',
'from wwv_flow_ws_applications',
'where id = :ws_app_id and',
'      security_group_id = :flow_security_group_id',
') application_created,',
'(',
'select created_by co',
'from wwv_flow_ws_applications',
'where id = :ws_app_id and',
'      security_group_id = :flow_security_group_id',
') created_by,',
'(',
'select count(*) websheet_pages',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a',
'where p.security_group_id = :flow_security_group_id ',
'and p.ws_app_id = :ws_app_id',
'and a.id = p.ws_app_id',
') websheet_pages,',
'(',
'select count(*) websheet_datagrids',
'from wwv_flow_worksheets w, ',
'                  wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id and',
'             w.security_group_id = :flow_security_group_id and             ',
'             a.ws_app_id = :ws_app_id and',
'             nvl(a.websheet_type,''DATA'') = ''DATA''',
') websheet_datagrids,',
'(',
'select count(*) websheet_reports',
'from wwv_flow_worksheets w, ',
'                  wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id and',
'             w.security_group_id = :flow_security_group_id and             ',
'             a.ws_app_id = :ws_app_id and',
'             nvl(a.websheet_type,''DATA'') = ''REPORT'' ',
') websheet_reports',
'from dual'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(171646109232237656.4903)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185791324487395890.4903)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185791420618395890.4903)
,p_query_column_id=>2
,p_column_alias=>'APPLICATION_CREATED'
,p_column_display_sequence=>3
,p_column_heading=>'Erstellt'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185793209343448296.4903)
,p_query_column_id=>3
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>2
,p_column_heading=>'Erstellt von'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185579730924856683.4903)
,p_query_column_id=>4
,p_column_alias=>'WEBSHEET_PAGES'
,p_column_display_sequence=>4
,p_column_heading=>'Websheet-Seiten'
,p_column_format=>'999G999G999G999G999G999G990'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185582712789897769.4903)
,p_query_column_id=>5
,p_column_alias=>'WEBSHEET_DATAGRIDS'
,p_column_display_sequence=>5
,p_column_heading=>'Websheet-Daten-Grids'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185583313959907472.4903)
,p_query_column_id=>6
,p_column_alias=>'WEBSHEET_REPORTS'
,p_column_display_sequence=>6
,p_column_heading=>'Websheet-Berichte'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185592226389958372.4903)
,p_name=>'Topbenutzer'
,p_template=>wwv_flow_api.id(27071223638280295.4903)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:33%; float:left;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select userid user_name, count(*) page_events',
'from wwv_flow_activity_log',
'where websheet_id = :ws_app_id and',
'      security_group_id = :flow_security_group_id and',
'      time_stamp >= (sysdate - nvl(:P1_TIMEFRAME,7))',
'group by userid',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(171646521495237685.4903)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185597127736006112.4903)
,p_query_column_id=>1
,p_column_alias=>'USER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Benutzername'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185597203639006112.4903)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>2
,p_column_heading=>'Seitenereignisse'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185694921184931340.4903)
,p_name=>'Topseiten'
,p_template=>wwv_flow_api.id(27071223638280295.4903)
,p_display_sequence=>50
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:66%; float:left;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'          (select max(name)',
'          from wwv_flow_ws_webpages p',
'          where p.ws_app_id = :ws_app_id',
'            and p.id = v.webpage_id',
'            and p.security_group_id = :flow_security_group_id) page_name,',
'       page_events',
'from (',
'select webpage_id, count(*) page_events',
'from wwv_flow_activity_log',
'where websheet_id = :ws_app_id and',
'      security_group_id = :flow_security_group_id and',
'      time_stamp >= (sysdate - nvl(:P1_TIMEFRAME,7)) and',
'      webpage_id is not null and',
'      webpage_id in (select id from wwv_flow_ws_webpages where ws_app_id = :ws_app_id)',
'group by  webpage_id',
'order by count(*) desc',
') v',
'where rownum < 8',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(171646521495237685.4903)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(459664827478856710.4903)
,p_query_column_id=>1
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Seitenname'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185695219132931341.4903)
,p_query_column_id=>2
,p_column_alias=>'PAGE_EVENTS'
,p_column_display_sequence=>1
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(185788025254301476.4903)
,p_name=>unistr('Aktuelle \00C4nderungen')
,p_template=>wwv_flow_api.id(27071223638280295.4903)
,p_display_sequence=>30
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:66%; float:left;"'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(updated_by,created_by)||'' ''||wwv_flow_lang.system_message(''DATA_GRID'')||'': ''||websheet_name n,',
'       nvl(updated_on,created_on) the_date',
'from wwv_flow_ws_websheet_attr a',
'where a.ws_app_id = :ws_app_id and',
'      a.security_group_id = :workspace_id and',
'      nvl(a.websheet_type,''DATA'') = ''DATA''',
'union all',
'select nvl(updated_by,created_by)||'' ''||wwv_flow_lang.system_message(''F4000.PAGE'')||'': ''||name n,',
'       nvl(updated_on,created_on) the_date',
'from wwv_flow_ws_webpages p',
'where p.ws_app_id = :ws_app_id and',
'      p.security_group_id = :workspace_id',
'union all',
'select nvl(updated_by,created_by)||'' ''||wwv_flow_lang.system_message(''REPORT'')||'': ''||websheet_name n, nvl(updated_on,created_on) the_date',
'from  wwv_flow_ws_websheet_attr a',
'where  a.ws_app_id = :ws_app_id and',
'       a.security_group_id = :workspace_id and',
'       nvl(a.websheet_type,''DATA'') = ''REPORT'' ',
'order by 2 desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(171646521495237685.4903)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Bericht enth\00E4lt keine Daten')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>7
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185789009633344267.4903)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(185789100826344267.4903)
,p_query_column_id=>2
,p_column_alias=>'THE_DATE'
,p_column_display_sequence=>2
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(431071714612124037.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185591206649952695.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(108117930940447534.4903)
,p_button_name=>'P1_SET'
,p_button_static_id=>'P1_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'Festlegen'
,p_button_alignment=>'LEFT'
,p_button_condition_type=>'NEVER'
,p_request_source=>'refresh'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(467407418236734151.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(181148802605561554.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:1,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185586311236935113.4903)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185585314221926524.4903)
,p_name=>'P1_TIMEFRAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(108117930940447534.4903)
,p_item_default=>'7'
,p_prompt=>'Zeitrahmen'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie den Zeitraum f\00FCr diesen Bericht.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(185297526463636542.4903)
,p_computation_sequence=>10
,p_computation_item=>'RUN_LINK'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''f?p=''||:app_id||'':900:''||:app_session||''::::WS_APP_ID,P900_ID:''||',
'          :WS_APP_ID||'',''||home_page_id',
'  from WWV_FLOW_WS_APPLICATIONS',
' where SECURITY_GROUP_ID = :flow_security_group_id ',
'   and id = :WS_APP_ID '))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(174635511046499211.4903)
,p_computation_sequence=>20
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_api.create_page(
 p_id=>2.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Daten-Grid'
,p_step_title=>'Daten-Grid'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18847410435428482.4903)
,p_plug_name=>unistr('Rechte Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20889528970815297.4903)
,p_plug_name=>'Hidden Region'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32890424941372009.4903)
,p_plug_name=>'Layout 1'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'<table border="0" cellpadding="0" cellspacing="0" width="100%" ><tr><td valign="top">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32890625221372009.4903)
,p_plug_name=>'Layout 2'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'</td><td width="100%" valign="top" style="padding:0 0 0 15px;">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(32890824632372010.4903)
,p_plug_name=>'Layout 3'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'</td></tr></table>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(78917510079639965.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(155020820894822892.4903)
,p_plug_name=>'name'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(394039573177873943.4903)
,p_plug_name=>'Daten-Grid'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DATA_GRID'
,p_attribute_01=>'P2_ID'
,p_attribute_02=>'P2_SHOW_CHECKBOX'
,p_attribute_03=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460549006734687548.4903)
,p_plug_name=>'Ajax Notification Holder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wsPageMessage" id="ajaxMESSAGE" style="display:none;"><div id="theMESSAGE"></div>',
'<a href="javascript:void()" onclick="$x_Remove(''ajaxMESSAGE'')" class="wsCloseMessage"><img src="#IMAGE_PREFIX#f_spacer.gif" alt=""/></a>',
'</div>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(154946714578185788.4903)
,p_branch_action=>'f?p=&FLOW_ID.:2:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2631325119551194.4903)
,p_name=>'P2_SHOW_CHECKBOX'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20889528970815297.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(159405412148423457.4903)
,p_name=>'P2_SHOW_TOOLBAR'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20889528970815297.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185166302121096890.4903)
,p_name=>'P2_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20889528970815297.4903)
,p_prompt=>'Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185166510779099358.4903)
,p_name=>'P2_WEBSHEET_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20889528970815297.4903)
,p_prompt=>'Websheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(161140617657065325.4903)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'2'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(5115909074633266.4903)
,p_computation_sequence=>20
,p_computation_item=>'RPT_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'null'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_worksheet_rpts',
'where worksheet_id = :P2_ID',
'and id = :RPT_ID'))
,p_compute_when_type=>'NOT_EXISTS'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(471737810971362548.4903)
,p_computation_sequence=>30
,p_computation_item=>'WORKSHEET_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_ws_api.get_websheet_name(p_worksheet_id => :p2_id);'
,p_computation_error_message=>'Daten-Grid-Name kann nicht abgerufen werden.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(5886702465031774.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Collection'
,p_process_sql_clob=>'wwv_flow_ws_api.save_checked(p_worksheet_id => :P2_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'NEVER'
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_api.create_page(
 p_id=>3.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Administration'
,p_step_title=>'Administration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456716416117062946.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(457231706098432622.4903)
,p_plug_name=>'administration menu options'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(457230629124432618.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(138239722779443444.4903)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(457236625109516658.4903)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'3'
);
end;
/
prompt --application/pages/page_00004
begin
wwv_flow_api.create_page(
 p_id=>4.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Anwendung l\00F6schen')
,p_step_title=>unistr('Anwendung l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(456220816180174638)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(301529030296629019.4903)
,p_plug_name=>unistr('L\00F6schen best\00E4tigen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>wwv_flow_api.id(487678607690660963)
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Durch das L\00F6schen einer Anwendung wird die Anwendung mit allen zugeh\00F6rigen Komponenten gel\00F6scht.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(301532105496629025.4903)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(301601412384641231.4903)
,p_plug_name=>'Toolbar Right Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-bottom: 10px"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_footer=>'<div class="clear"></div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(318042708957711067.4903)
,p_plug_name=>unistr('Anwendung kann nicht gel\00F6scht werden')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>41
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_required_role=>'!'||wwv_flow_api.id(487678607690660963)
,p_plug_header=>unistr('<div class="wsErrorMessageSQL">Sie k\00F6nnen nur als &PRODUCT_NAME.-Entwickler auf diese Funktion zugreifen.</div>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(301529230900629020.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(301601412384641231.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1250:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(319787302199021438.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(301601412384641231.4903)
,p_button_name=>'BUILDER_LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Bei Development anmelden'
,p_button_position=>'CREATE'
,p_security_scheme=>'!'||wwv_flow_api.id(487678607690660963)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(301529418920629020.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(301601412384641231.4903)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Jetzt dauerhaft l\00F6schen')
,p_button_position=>'DELETE'
,p_security_scheme=>wwv_flow_api.id(487678607690660963)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(302848719197785179.4903)
,p_branch_action=>'f?p=4000:1500:&BUILDER_SESSION_ID.::NO:RP:P1500_SHOW:WEBSHEET'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_ws_applications',
'where security_group_id = :flow_security_group_id'))
,p_security_scheme=>wwv_flow_api.id(487678607690660963)
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(301529629185629020.4903)
,p_name=>'P4_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(301529030296629019.4903)
,p_prompt=>'Anwendung'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Die ausgew\00E4hlte Anwendung.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(301530122954629023.4903)
,p_name=>'P4_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(301529030296629019.4903)
,p_prompt=>'Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name from wwv_flow_ws_applications ',
' where id = :P4_ID',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Der Name der ausgew\00E4hlten Anwendung.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(301530606969629023.4903)
,p_name=>'P4_PAGES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(301529030296629019.4903)
,p_prompt=>'Seiten'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) ',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a',
'where p.security_group_id = :flow_security_group_id ',
'and p.ws_app_id = :P4_ID',
'and a.id = p.ws_app_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Die Anzahl von Seiten innerhalb der Anwendung.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(301531114457629024.4903)
,p_name=>'P4_DATAGRIDS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(301529030296629019.4903)
,p_prompt=>'Daten-Grids'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) ',
' from wwv_flow_worksheets w, ',
'       wwv_flow_ws_websheet_attr a',
' where w.id = a.worksheet_id and',
'       w.security_group_id = :flow_security_group_id and            ',
'       a.websheet_type = ''DATA'' and',
'       a.ws_app_id = :P4_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Die Anzahl der Daten-Grids innerhalb der Anwendung.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(301531601072629024.4903)
,p_name=>'P4_REPORTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(301529030296629019.4903)
,p_prompt=>'Berichte'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) ',
' from wwv_flow_worksheets w, ',
'       wwv_flow_ws_websheet_attr a',
' where w.id = a.worksheet_id and',
'       w.security_group_id = :flow_security_group_id and            ',
'       a.websheet_type = ''REPORT'' and',
'       a.ws_app_id = :P4_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Die Anzahl der Berichte innerhalb der Anwendung.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(317199623052582715.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete websheet application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_ws_app (',
'    p_ws_app_id   => :P4_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Die Anwendung konnte nicht gel\00F6scht werden.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(301529418920629020.4903)
,p_process_success_message=>unistr('Anwendung gel\00F6scht.')
,p_security_scheme=>wwv_flow_api.id(487678607690660963)
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_api.create_page(
 p_id=>5.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Kennwort \00E4ndern')
,p_step_title=>unistr('Kennwort \00E4ndern')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(506060600392166972)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(733375232512655603.4903)
,p_plug_name=>unistr('Kennwort \00E4ndern')
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_ws_applications ',
'where id = :WS_APP_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(733377515496655611.4903)
,p_plug_name=>'Toobar Right Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(733377932388655611.4903)
,p_plug_name=>'Change Password'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(733377104075655609.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(733377515496655611.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(733377316895655611.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(733377515496655611.4903)
,p_button_name=>'RESET_PASSWORD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('Kennwort \00E4ndern')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(733378822544655614.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(733375407229655605.4903)
,p_name=>'P5_CURRENT_PASSWORD'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(733375232512655603.4903)
,p_prompt=>'Aktuelles Kennwort eingeben'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Geben Sie das aktuelle Kennwort ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(733376401898655607.4903)
,p_name=>'P5_USERNAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(733375232512655603.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Benutzername'
,p_source=>'APP_USER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Der Name des Benutzers, dessen Kennwort ge\00E4ndert werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(739791012792509692.4903)
,p_name=>'P5_NEW_PASSWORD'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(733375232512655603.4903)
,p_prompt=>'Neues Kennwort eingeben'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Neues Kennwort eingeben.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(739973506690517391.4903)
,p_name=>'P5_CONFIRM_PASSWORD'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(733375232512655603.4903)
,p_prompt=>unistr('Neues Kennwort best\00E4tigen')
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Neues Kennwort erneut eingeben.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(740169510284527901.4903)
,p_validation_name=>'APP_USER not null'
,p_validation_sequence=>10
,p_validation=>'APP_USER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Der Benutzername wurde nicht korrekt festgelegt. Schlie\00DFen Sie den Browser, und versuchen Sie erneut, das Kennwort zu \00E4ndern.')
,p_associated_item=>wwv_flow_api.id(733376401898655607.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(740337923575541125.4903)
,p_validation_name=>'new passwd = confirm passwd'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P5_NEW_PASSWORD != :P5_CONFIRM_PASSWORD then',
'  :P5_NEW_PASSWORD := null;',
'  :P5_CONFIRM_PASSWORD := null;',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Kennwort zur Best\00E4tigung stimmt nicht mit dem neuen Kennwort \00FCberein.')
,p_validation_condition=>':P5_NEW_PASSWORD is not null and :P5_CONFIRM_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(740556219204549371.4903)
,p_validation_name=>'Validate Current Password'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_api.is_login_password_valid(',
'  p_username => :APP_USER,',
'  p_password => :P5_CURRENT_PASSWORD);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ung\00FCltiges Kennwort')
,p_validation_condition=>'P5_CURRENT_PASSWORD'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(740770724529560332.4903)
,p_validation_name=>'strong password'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.strong_password_validation(',
'      p_username              => :APP_USER,',
'      p_password              => :P5_NEW_PASSWORD,',
'      p_old_password          => :P5_CURRENT_PASSWORD,',
'      p_workspace_name        => wwv_flow_security.find_company_name(:flow_security_group_id));'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_validation_condition=>':P5_NEW_PASSWORD is not null and :P5_CONFIRM_PASSWORD is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(733378319666655613.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'change password'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_api.g_fnd_user_password_action := true;',
'update wwv_flow_fnd_user ',
'  set web_password = :P5_NEW_PASSWORD',
'where security_group_id = :flow_security_group_id ',
'  and user_id = (select user_id ',
'                  from wwv_flow_fnd_user ',
'                 where security_group_id = :flow_security_group_id ',
'                   and user_name = :app_user);',
'wwv_flow_api.g_fnd_user_password_action := false;',
'',
':P5_NEW_PASSWORD := null;',
':P5_CONFIRM_PASSWORD := null;',
':P5_CURRENT_PASSWORD := null;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim \00C4ndern von Kennwort.')
,p_process_when=>':P5_NEW_PASSWORD = :P5_CONFIRM_PASSWORD'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>unistr('Kennwort ge\00E4ndert.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(741456721937597439.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'5'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_api.create_page(
 p_id=>6.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Zugriffskontrolle'
,p_step_title=>'Zugriffskontrolle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css" media="screen">',
'	/* Hide left col */',
'	div.wsSideCol {',
'		 display: none !important;',
'	}',
'	div.wsMainCol {',
'		 padding: 5px;',
'	}',
'</style>'))
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619279823495072045.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619385132669714338.4903)
,p_plug_name=>'Zugriffskontrolle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(628484022950304722.4903)
,p_plug_name=>'intro text'
,p_parent_plug_id=>wwv_flow_api.id(619385132669714338.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(''<p>''||wwv_flow_lang.system_message(''ACL_TABLE.INTRO_TEXT'')||''</p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(628484309576310290.4903)
,p_plug_name=>'acl table'
,p_parent_plug_id=>wwv_flow_api.id(619385132669714338.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(wwv_flow_ws_api.get_acl_table);'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(619280212586072050.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Window'
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_api.create_page(
 p_id=>9.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Websheets nicht unterst\00FCtzt')
,p_alias=>'WEBSHEET-NOT-SUPPORTED'
,p_step_title=>unistr('Websheets nicht unterst\00FCtzt')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(607707103506483809.4903)
,p_plug_name=>unistr('Websheets nicht unterst\00FCtzt')
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(931543191007401308.4903)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>unistr('Websheets werden in dieser Version von &PRODUCT_NAME. nicht mehr unterst\00FCtzt. Wenden Sie sich an den Administrator.')
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00011
begin
wwv_flow_api.create_page(
 p_id=>11.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Zugriffskontrolle'
,p_step_title=>'Zugriffskontrolle'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451311515410376846.4903)
,p_plug_name=>'Access Control List Entries'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select n001 id,',
'       c001 username,',
'       c002 priv,',
'       wwv_flow_lang.system_message(''EDIT_LINK_TEXT'', c001) link_text',
'from wwv_flow_collections',
'where collection_name = ''APEX$_ACL'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(451311719920376851.4903)
,p_name=>'Change History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>unistr('In der Access Control-Liste sind keine Eintr\00E4ge vorhanden.')
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451333131265977320.4903)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>' '
,p_column_link=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:13:P13_ID:#ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="#LINK_TEXT#">'
,p_column_link_attr=>'Edit'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451314505039414398.4903)
,p_db_column_name=>'USERNAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Benutzername'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(451314610985414398.4903)
,p_db_column_name=>'PRIV'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Berechtigung'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(451333930142995878)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(247045499759377619.4903)
,p_db_column_name=>'LINK_TEXT'
,p_display_order=>14
,p_column_identifier=>'E'
,p_column_label=>'Link-Text'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451312628829376856.4903)
,p_plug_name=>'Manage Access Control List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458561726210213950.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Falls die Anwendung benutzerdefinierte Autorisierungen verwendet, verwaltet die Access Control-Liste die Berechtigungen der Anwendungsbenutzer.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458945107668445108.4903)
,p_plug_name=>'Authentifizierungsschema'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_auth_type varchar2(255);',
'begin',
'  l_auth_type := wwv_flow_item.text_from_lov(wwv_flow_ws_security.ws_auth_type(:WS_APP_ID),''WEBSHEET AUTHENTICATION'');',
'',
'  sys.htp.prn(''<p>''||',
'      wwv_flow_lang.system_message(''F4900_P11_AUTH_TYPE_MESSAGE'',l_auth_type)||''</p>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466701412926181295.4903)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(466702532319186899.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(466701412926181295.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:11,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451340528822175261.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(451311515410376846.4903)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>'Eintrag erstellen >'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:13::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(451313319291376861.4903)
,p_branch_action=>'f?p=&FLOW_ID.:11:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(451313108133376860.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create ACL collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_acl_collection (',
'    p_ws_app_id => :WS_APP_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'ACL-Collection konnte nicht erstellt werden.'
);
end;
/
prompt --application/pages/page_00012
begin
wwv_flow_api.create_page(
 p_id=>12.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Vorgeschlagene SQL'
,p_step_title=>'Vorgeschlagene SQL'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_required_role=>wwv_flow_api.id(495860932509802714)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488396212380125306.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>SQL kann in Berichten und SQL-Tags verwendet werden. Dies ist eine Liste vorgeschlagener Objekte, die f\00FCr Ihre Anwendung interessant sein k\00F6nnten. W\00E4hlen Sie ein Objekt aus; die entsprechende SQL-SELECT-Anweisung, die Sie verwenden k\00F6nnen, wird an')
||'gezeigt.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488403717840125334.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488408215444168022.4903)
,p_plug_name=>'Vorgeschlagene Objekte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4903)
,p_plug_display_sequence=>15
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name,',
'       object_comment',
'  from wwv_flow_ws_app_sug_objects',
' where ws_app_id = :WS_APP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(488408303926168022.4903)
,p_name=>'Available Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(488408529626168027.4903)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Objektname'
,p_column_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:12:P12_TABLE_NAME:#OBJECT_NAME#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492616214470258718.4903)
,p_db_column_name=>'OBJECT_COMMENT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Kommentar'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488409211280188810.4903)
,p_plug_name=>'&P12_TABLE_NAME.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(27071223638280295.4903)
,p_plug_display_sequence=>25
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare q varchar2(32767);',
'begin',
'q := ''select'';',
'for c1 in (',
'select column_name',
'  from sys.dba_tab_columns',
' where table_name = :P12_TABLE_NAME and',
'       owner = wwv_flow_security.g_apex$_schema',
' order by column_id) loop',
'q := q||''<br />'';',
'q := q||''&nbsp;&nbsp;&nbsp;&nbsp;''||wwv_flow_escape.html(c1.column_name)||'','';',
'end loop;',
'q := rtrim(q,'','')||''<br />from ''||wwv_flow_escape.html(:P12_TABLE_NAME);',
'sys.htp.p(q);',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P12_TABLE_NAME'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488415531993365037.4903)
,p_plug_name=>'Beispiele'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>35
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[[SQL: select ename "Mitarbeitername", sal "Gehalt" from emp order by sal desc | limit=10]]',
'[[SQLVALUE: select count(*) from emp ]]',
'</pre>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491315127198795285.4903)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488411205618253386.4903)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_api.id(488408215444168022.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:12,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488409426171193110.4903)
,p_name=>'P12_TABLE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(488396212380125306.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00013
begin
wwv_flow_api.create_page(
 p_id=>13.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Eintrag in Access Control-Liste erstellen/bearbeiten'
,p_step_title=>'Eintrag in Access Control-Liste erstellen/bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22693023416256513.4903)
,p_plug_name=>'Top Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22695808618308969.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451316114910485987.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(451316527354493693.4903)
,p_plug_name=>'Eintrag'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455753022786260831.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Wenn die Anwendung benutzerdefinierte Autorisierung verwendet, verwaltet die Access Control-Liste die Berechtigungen der Anwendungsbenutzer.</p>',
'',
'<ul>',
'<li><b>Leser</b> - darf den Inhalt anzeigen, aber nicht bearbeiten</li>',
'<li><b>Beitragender</b> - darf den Inhalt anzeigen und bearbeiten</li>',
'<li><b>Administrator</b> - darf den Inhalt anzeigen und bearbeiten, Anwendungseigenschaften bearbeiten und die Access Control-Liste verwalten</li>',
'</ul>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451317504937543969.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(22693023416256513.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451317707492554199.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(22693023416256513.4903)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Erstellen'
,p_button_position=>'CREATE'
,p_button_condition=>'P13_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488046828362984858.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(22693023416256513.4903)
,p_button_name=>'CREATE_AND_CREATE_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Erstellen und weitere erstellen'
,p_button_position=>'CREATE'
,p_button_condition=>'P13_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451326723076908671.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(22693023416256513.4903)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE2'
,p_button_condition=>'P13_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(451334810665009173.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(22693023416256513.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_button_condition=>'P13_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(488047325507002977.4903)
,p_branch_action=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:13::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(488046828362984858.4903)
,p_branch_sequence=>2
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(451317931226554200.4903)
,p_branch_action=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451316709130497825.4903)
,p_name=>'P13_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(22695808618308969.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451316912509517726.4903)
,p_name=>'P13_USERNAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(451316527354493693.4903)
,p_prompt=>'Benutzername'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Geben Sie den Benutzernamen ein, f\00FCr den der Zugriff kontrolliert werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(451317328917531994.4903)
,p_name=>'P13_PRIV'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(451316527354493693.4903)
,p_item_default=>'R'
,p_prompt=>'Berechtigung'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_ACL_PRIVS'
,p_lov=>'.'||wwv_flow_api.id(451333930142995878.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Geben Sie die Berechtigungsebene f\00FCr den Benutzer an. Wenn die Anwendung die benutzerdefinierte Autorisierung verwendet, verwaltet die Access Control-Liste die Berechtigungen der Anwendungsbenutzer.</p>'),
'',
'<ul>',
'<li><strong>Leser</strong> - Kann den Content anzeigen, aber nicht bearbeiten</li>',
'<li><strong>Beitragender</strong> - Kann den Content anzeigen und bearbeiten</li>',
'<li><strong>Administrator</strong> - Kann den Content anzeigen und bearbeiten, Anwendungseigenschaften bearbeiten und die Access Control-Liste verwalten</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(22573104501037740.4903)
,p_computation_sequence=>10
,p_computation_item=>'P13_USERNAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'trim(:P13_USERNAME)'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(456322608585423890.4903)
,p_validation_name=>'Cannot Delete or lesser privilege yourself'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001',
'             from wwv_flow_collections',
'            where collection_name = ''APEX$_ACL''',
'              and n001 = :P13_ID ) loop',
'  if :REQUEST = ''DELETE'' and c1.c001 = upper(:APP_USER) then',
'    return false;',
'  elsif :REQUEST = ''APPLY_CHANGES'' and c1.c001 = upper(:APP_USER) and :P13_PRIV != ''A'' then',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end loop;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Sie k\00F6nnen sich keine Administratorrechte entziehen.')
,p_validation_condition=>':REQUEST in (''DELETE'',''APPLY_CHANGES'') and wwv_flow_ws_security.ws_acl_type(:WS_APP_ID) = ''CUSTOM'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(451316912509517726.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(799469025785845096.4903)
,p_validation_name=>'P13_USERNAME already exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''APEX$_ACL''',
'   and c001 = upper(:P13_USERNAME)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Benutzer steht bereits in der Access Control-Liste.'
,p_validation_condition=>'CREATE,CREATE_AND_CREATE_ANOTHER'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(451316912509517726.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(819882220390557560.4903)
,p_validation_name=>'P13_USERNAME not null'
,p_validation_sequence=>30
,p_validation=>'P13_USERNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Benutzername muss angegeben werden.'
,p_validation_condition=>'CREATE,CREATE_AND_CREATE_ANOTHER,APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(451316912509517726.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(451339402456139272.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add/update ACL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.add_acl_entry(',
'    p_ws_app_id  => :WS_APP_ID,',
'    p_acl_id          => :P13_ID,',
'    p_username   => :P13_USERNAME,',
'    p_priv             => :P13_PRIV );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler beim Erstellen des Access Control-Listeneintrags.'
,p_process_when=>'CREATE,APPLY_CHANGES,CREATE_AND_CREATE_ANOTHER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>unistr('Access Control-Listeneintrag erstellt bzw. ge\00E4ndert.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(833790620596523418.4903)
,p_process_sequence=>15
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create ACL collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_acl_collection (',
'    p_ws_app_id => :WS_APP_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'ACL-Collection konnte nicht erstellt werden.'
,p_process_when_button_id=>wwv_flow_api.id(488046828362984858.4903)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(451340317956162700.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete acl entry'
,p_process_sql_clob=>'wwv_flow_ws_api.delete_acl_entry(:P13_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim L\00F6schen des Access Control-Listeneintrags.')
,p_process_when_button_id=>wwv_flow_api.id(451334810665009173.4903)
,p_process_success_message=>unistr('Access Control-Listeneintrag gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(451338731714109921.4903)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'pop items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001 username, c002 priv',
'             from wwv_flow_collections',
'            where collection_name = ''APEX$_ACL''',
'              and n001 = :P13_ID ) loop',
'    :P13_USERNAME := c1.username;',
'    :P13_PRIV := c1.priv;',
'    exit;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P13_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00014
begin
wwv_flow_api.create_page(
 p_id=>14.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('\00C4nderungshistorie anzeigen')
,p_step_title=>unistr('\00C4nderungshistorie anzeigen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2669725667029212.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29080824628705464.4903)
,p_plug_name=>unistr('\00C4nderungshistorie anzeigen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4903)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 row_key,',
'       c002 column_name,',
'       c003 old_value,',
'       c004 new_value,',
'       c005 application_user_id,',
'       d001 date_of_change,',
'       c006 history_rowid',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_HISTORY'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(29080913600705464.4903)
,p_name=>'Change History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_base_pk1=>'ROW_KEY'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_rows_per_page=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#ws/small_page.gif" alt="&VIEW." />'
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1524146599951611412.4903)
,p_db_column_name=>'ROW_KEY'
,p_display_order=>10
,p_column_identifier=>'G'
,p_column_label=>unistr('Zeilenschl\00FCssel')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29081219740705468.4903)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Spaltenname'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29081302162705468.4903)
,p_db_column_name=>'OLD_VALUE'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Alter Wert'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29081429809705469.4903)
,p_db_column_name=>'NEW_VALUE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Neuer Wert'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29081503189705469.4903)
,p_db_column_name=>'APPLICATION_USER_ID'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Anwendungsbenutzer-ID'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(29085729935792011.4903)
,p_db_column_name=>'DATE_OF_CHANGE'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>unistr('Ge\00E4ndert')
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(246124596661890750.4903)
,p_db_column_name=>'HISTORY_ROWID'
,p_display_order=>70
,p_column_identifier=>'I'
,p_column_label=>'Historien-Rowid'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(906866216721570277.4903)
,p_plug_name=>unistr('Rechte Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(907020707979586718.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(29080824628705464.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(2647813413278526.4903)
,p_branch_action=>'f?p=&FLOW_ID.:14:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(29080030787678754.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create history collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_history_collection (',
'    p_worksheet_id => :p2_id,',
'    p_websheet_id  => :p2_websheet_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Historien-Collection konnte nicht erstellt werden.'
);
end;
/
prompt --application/pages/page_00015
begin
wwv_flow_api.create_page(
 p_id=>15.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('\00DCberblick')
,p_step_title=>unistr('\00DCberblick')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455867416484229688.4903)
,p_plug_name=>'Websheet-Anwendungen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit Websheet-Anwendungen k\00F6nnen Endbenutzer strukturierte und nicht strukturierte Daten ohne Unterst\00FCtzung durch den Entwickler verwalten. Mit Websheets k\00F6nnen Benutzer:</p> '),
'',
'<ul>',
unistr('<li>Content \00FCber das Web mit einem Webbrowser erstellen und gemeinsam verwenden</li>'),
unistr('<li>Seiten in einer Hierarchie organisieren und Seiten verkn\00FCpfen (mithilfe der [[ Seitenname ]]-Syntax).</li>'),
'',
'<li>Tabellarische Daten mithilfe eingebetteter Features, den sogenannten Daten-Grids, erstellen und verwalten</li>',
'<li>Interaktive Berichte mit SQL auf vorhandenen Datenstrukturen in der Datenbank erstellen.</li>',
unistr('<li>Daten-Grid- und Berichtsdaten in Seiten als Diagramm oder Bericht ver\00F6ffentlichen.</li>'),
unistr('<li>Seiten mit Anmerkungen in Form von Dateien, Tags und Hinweisen versehen. Zugeh\00F6rige Images k\00F6nnen inline im Seitencontent angezeigt werden (mithilfe der [[Image: Dateiname]]-Syntax).</li>'),
'<li>Seitencontent durchsuchen (mit der integrierten Suchfunktion).</li>',
'<li>Verwalten, wer sich anmelden darf, und nach der Anmeldung kontrollieren, wer in der Anwendung lesen, schreiben oder sie verwalten darf (Authentifizierung und Autorisierung).</li>',
'</ul> '))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455869309520274904.4903)
,p_plug_name=>'Seiten'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Der Seitencontent ist in Abschnitte aufgeteilt. Websheets unterst\00FCtzen die folgenden Abschnittstypen:</p>'),
'<ul>',
unistr('<li>Text - Zeigt eingegebenen Text, Inline-Images und Inline-Berichte sowie Links zu Berichten, Daten-Grids, anderen Seiten, Dateien, externen URLs usw. an. Sie k\00F6nnen Textabschnitte mit einem intuitiven WYSIWIG-Editor verwalten.</li>'),
unistr('<li>Navigation - F\00FCgt dynamisch generierte Navigation untergeordneten Seiten oder Seitenabschnitten hinzu.</li>'),
'<li>Daten - Erstellt Inline-Berichte basierend auf einem Daten-Grid oder Bericht.</li>',
'<li>Diagramm - Erstellt Inline-Diagramme basierend auf einem Daten-Grid oder Bericht.</li>',
'</ul>',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455869514368276321.4903)
,p_plug_name=>'Annotationen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>In Seiten oder Zeilen eines Daten-Grids k\00F6nnen Sie folgende Anmerkungen einf\00FCgen:</p>'),
'<ul>',
unistr('<li>Dateien - Dateien f\00FCr einen Download hochladen oder als Inline-Image in einem Abschnitt anzeigen</li>'),
unistr('<li>Hinweise - F\00FCr den Content spezifische Hinweise einbeziehen'),
unistr('<li>Tags - Tags hinzuf\00FCgen, die die integrierte Suchfunktion verbessern'),
'</ul>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455869719909277967.4903)
,p_plug_name=>'Zugriffskontrolle'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Ein Administrator kontrolliert, wer sich bei einer Websheet-Anwendung anmelden kann, indem er eines der folgenden Authentifizierungsverfahren festlegt:</p>',
'<ul>',
unistr('<li>\00D6ffentlicher Zugriff (keine Authentifizierung)</li>'),
'<li>Oracle Application Express-Account</li>',
'<li>Oracle Single Sign-On</li>',
'<li>LDAP-Zugangsdatenverifizierung</li>',
'<li>Benutzerdefiniert',
'</ul>',
'',
unistr('<p>Sobald sich ein Benutzer bei der Anwendung angemeldet hat, wird sein Zugriff \00FCber die ihm zugewiesene Rolle geregelt. Zu den unterst\00FCtzten Rollen geh\00F6ren:</p>'),
'<ul>',
'<li>Administrator</li>',
'<li>Beitragender</li>',
'<li>Leser</li>',
'</ul>',
'',
'',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455870812899294887.4903)
,p_plug_name=>'Daten-Grids'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Daten-Grids sind vom Beitragenden definierte tabellarische Datensets - im Wesentlichen handelt es sich um ein webbasiertes Arbeitsblatt. Sie k\00F6nnen den Aufbau des Daten-Grids mit Spaltennamen, Datentypen und Basisvalidierungen festlegen oder k\00F6nne')
||unistr('n ein Daten-Grid erstellen, indem Sie Arbeitsblattdaten einf\00FCgen. Sobald das Grid erstellt ist, kann der Aufbau nach Bedarf ge\00E4ndert werden.</p>'),
'',
unistr('<p>Zus\00E4tzlich zu den festgelegten Spalten ist in jedem Daten-Grid ein Set von Standardspalten enthalten. Sie stehen f\00FCr Eigent\00FCmer, Erstellt von, Erstellt am, Aktualisiert von, Aktualisiert am, Zeilenreihenfolge und Anmerkungen (Dateien, Hinweise, Li')
||'nks und Tags).</p>',
'',
unistr('<p>Bei Daten-Grids handelt es sich um bearbeitbare Berichte, die beliebig angepasst werden k\00F6nnen. Der Benutzer kann das Layout der Berichtsdaten \00E4ndern, indem er die entsprechenden Spalten ausw\00E4hlt und Filter, Markierungen und Sortierungen darauf an')
||unistr('wendet. Er kann auch Umbr\00FCche, Zusammenf\00FCgungen, Gruppierungen, Berechnungen und unterschiedliche Diagramme festlegen. Des Weiteren kann der Benutzer mehrere Varianten des Daten-Grids erstellen und diese als benannte Berichte zur privaten oder \00F6ffent')
||'lichen Anzeige speichern.</p>',
'',
unistr('<p>Die Daten des Daten-Grids sind nicht nur \00FCber das Men\00FC "Ansicht" verf\00FCgbar, sondern k\00F6nnen auch als Diagramm oder Bericht in eine Seite eingef\00FCgt werden.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455871123288297886.4903)
,p_plug_name=>'Berichte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'noTableFormatting'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Berichte sind Abfragen von Datenbankobjekten, auf die Sie zugreifen k\00F6nnen. Um einen Bericht festzulegen, k\00F6nnen Sie entweder einfach eine Tabelle oder View in einem verf\00FCgbaren Schema w\00E4hlen oder ein komplexeres Konstrukt mit dem Industriestandar')
||'d SQL erstellen.</p>',
'',
unistr('<p>Genau wie bei Daten-Grids k\00F6nnen Berichte stark angepasst werden. Der Benutzer kann das Layout der Berichtsdaten ver\00E4ndern, indem er die entsprechenden Spalten markiert und Filter, Hervorhebungen und Sortierungen darauf anwendet. Er kann weiterhin')
||unistr(' Umbr\00FCche, Zusammenf\00FChrungen, Gruppierungen, Berechnungen und verschiedenen Diagramme festlegen. \00DCber eine Subscription kann er den Bericht per E-Mail in bestimmten Intervallen erhalten. Der Benutzer kann unterschiedliche Variationen des Berichts ers')
||unistr('tellen und diese als benannte Berichte entweder zur privaten oder zur \00F6ffentlichen Anzeige speichern.</p>'),
'',
unistr('<p>Die Daten eines Berichts sind nicht nur \00FCber die Schaltfl\00E4che "Daten" verf\00FCgbar, sondern k\00F6nnen auch als Diagramm oder Bericht von einer beliebigen anderen Seite eingef\00FCgt werden.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>wwv_flow_api.id(492214905335570870)
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466849110862832553.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(468686130956258389.4903)
,p_plug_name=>'anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>5
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_list_template_id=>wwv_flow_api.id(171596314926127907.4903)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
end;
/
prompt --application/pages/page_00016
begin
wwv_flow_api.create_page(
 p_id=>16.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Info zur Anwendung'
,p_step_title=>'Info zur Anwendung'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css" media="screen">',
'	/* Hide left col */',
'	div.wsSideCol {',
'		 display: none !important;',
'	}',
'	div.wsMainCol {',
'		 padding: 5px;',
'	}',
'</style>'))
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472804823833588483.4903)
,p_plug_name=>'Info zur Anwendung'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(82536903857665765.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472809806454619957.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472810527578626072.4903)
,p_name=>'P16_APPLICATION_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Anwendungsname'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt den Namen dieser Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472817823619814197.4903)
,p_name=>'P16_CREATED_BY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Erstellt von'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt an, wer die Anwendung erstellt hat.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472818029160815789.4903)
,p_name=>'P16_CREATED_ON'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Erstellt'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt an, wann die Anwendung erstellt wurde.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472818901717826724.4903)
,p_name=>'P16_RUN_LINK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>unistr('Link ausf\00FChren')
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Gibt die URL an, mit dem diese Anwendung ausgef\00FChrt wird.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472819621719851449.4903)
,p_name=>'P16_WEB_PAGES'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Seiten'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Anzahl der Seiten in dieser Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472823322804880132.4903)
,p_name=>'P16_DATA_GRIDS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Daten-Grids'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Anzahl der Daten-Grid in dieser Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472824025144899716.4903)
,p_name=>'P16_REPORTS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Berichte'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_security_scheme=>wwv_flow_api.id(492214905335570870)
,p_help_text=>'Gibt die Anzahl der Berichte in dieser Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472827429534042915.4903)
,p_name=>'P16_FILES'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Dateien'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Anzahl der Dateien in dieser Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472829909495065498.4903)
,p_name=>'P16_FILE_STORAGE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Dateispeicher'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Gibt die Gesamtdateigr\00F6\00DFe aller Dateien in dieser Anwendung an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472835720408106552.4903)
,p_name=>'P16_PAGE_SECTIONS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Seitenabschnitte'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Anzahl der Berichte in dieser Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472849515269209062.4903)
,p_name=>'P16_NOTES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Hinweise'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Anzahl der Hinweise in dieser Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472849720118210471.4903)
,p_name=>'P16_TAGS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Tags'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Anzahl der Tags in dieser Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472850124966211939.4903)
,p_name=>'P16_DATAGRID_ROWS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Daten-Grid-Zeilen'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Anzahl der Zeilen aller Daten-Grid in dieser Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484478622627455477.4903)
,p_name=>'P16_DESCRIPTION'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(472804823833588483.4903)
,p_prompt=>'Beschreibung'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P16_DESCRIPTION'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Beschreibung der Anwendung.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(472810926324635162.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set item values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select name, created_by, created_on, id, description',
'    from WWV_FLOW_WS_APPLICATIONS ',
'    where id = :WS_APP_ID and security_group_id = :flow_security_group_id) loop',
'  :P16_APPLICATION_NAME := c1.name;',
'  :P16_CREATED_BY := c1.created_by;',
'  :P16_CREATED_ON := htmldb_util.get_since(c1.created_on);',
'  :P16_RUN_LINK := wwv_flow_utilities.host_url(''SCRIPT'')||''ws?p=''||c1.id||'':home'';',
'  :P16_DESCRIPTION := c1.description;',
'   for c2 in (select count(*) c from WWV_FLOW_WS_WEBPAGES where ws_app_id = c1.id) loop',
'      :P16_WEB_PAGES := to_char(c2.c,''999G999G999G990'');',
'   end loop;',
'   for c2 in (',
'     select count(*) c',
'     from wwv_flow_worksheets w, ',
'             wwv_flow_ws_websheet_attr a',
'     where w.id = a.worksheet_id and',
'         w.security_group_id = :flow_security_group_id and                  ',
'         a.ws_app_id = :ws_app_id and',
'         nvl(a.websheet_type,''DATA'') = ''DATA'') loop',
'    :P16_DATA_GRIDS := to_char(c2.c,''999G999G999G990'');',
'    end loop;',
'    for c2 in (',
'       select count(*) c',
'       from wwv_flow_worksheets w, ',
'              wwv_flow_ws_websheet_attr a',
'       where w.id = a.worksheet_id and',
'                w.security_group_id = :flow_security_group_id and                  ',
'               a.ws_app_id = :ws_app_id and',
'               nvl(a.websheet_type,''DATA'') = ''REPORT'') loop',
'         :P16_REPORTS := c2.c;',
'     end loop;',
'     :P16_files := trim(to_char(wwv_flow_ws_api.get_file_count(p_ws_app_id=>:WS_APP_ID),''999G999G999G990''));',
'     :P16_FILE_STORAGE :=trim(htmldb_util.filesize_mask(wwv_flow_ws_api.get_file_size(p_ws_app_id=>:WS_APP_ID)));',
'     :P16_PAGE_SECTIONS := trim(to_char(wwv_flow_ws_api.get_section_count(p_ws_app_id=>:WS_APP_ID),''999G999G999G990''));',
'     :P16_TAGS := trim(to_char(wwv_flow_ws_api.get_tag_count(p_ws_app_id=>:WS_APP_ID),''999G999G999G990''));',
'     :P16_NOTES := trim(to_char(wwv_flow_ws_api.get_note_count(p_ws_app_id=>:WS_APP_ID),''999G999G999G990''));',
'     :P16_DATAGRID_ROWS := trim(to_char(wwv_flow_ws_api.get_datagrid_row_count(',
'         p_ws_app_id=>:WS_APP_ID),''999G999G999G990''));',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00017
begin
wwv_flow_api.create_page(
 p_id=>17.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Markup-Syntax'
,p_step_title=>'Markup-Syntax'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456375908174931142.4903)
,p_plug_name=>'Externe URL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit der nachstehenden Syntax k\00F6nnen Sie Links zu externen URLs einf\00FCgen. Die Verwendung der ID <code>''url:''</code> ist optional. Verwenden Sie das Popup-Pr\00E4fix, um den Link in einem neuen Browserfenster zu \00F6ffnen.</p>'),
'',
'<p><b>Syntax:</b></p>',
'<pre>',
'[[ url: &lt;url> | &lt;link name> ]]',
'[[ popupurl: &lt;url> | &lt;link name> ]]',
'[[ &lt;url> | &lt;link name> ]]',
'</pre>',
'',
'<p><b>Syntaxbeispiele:</b></p>',
'<pre>',
'[[url: http://www.oracle.com/store | oraclestore]] ',
'[[popupurl: http://www.oracle.com/store | oraclestore]]',
'[[http://www.example.com | example]] ',
'[[http://www.example.com ]] ',
'</pre>',
'',
'<p><b>Kontextbezogenes Beispiel:</b></p>',
'<pre>',
unistr('Sie k\00F6nnen Oracle-Software auf der [[http://www.oracle.com/store | Oracle Store]]-Website erwerben.'),
'</pre>',
'',
''))
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456378202762952007.4903)
,p_plug_name=>'Bilder'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Nach dem Hochladen eines Images k\00F6nnen Sie dieses in einem Seitenabschnitt einer Anwendung anzeigen, indem Sie einen heruntergeladenen Link mit der folgenden Syntax einbetten. Sie k\00F6nnen hochgeladene Images mit dem Imagenamen oder dem Imagealias r')
||unistr('eferenzieren. Images, die f\00FCr die aktuelle Seite definiert sind, werden vor den Images verwendet, die mit anderen Seiten verkn\00FCpft sind. Wenn Imagenamen nicht eindeutig sind, wird das zuletzt erstellte Image angezeigt. Imageeigenschaften k\00F6nnen f\00FCr d')
||unistr('ie Datei oder inline definiert werden. Wenn Sie Attribute inline definieren, haben die Inline-Attribute Vorrang vor den Attributen, die f\00FCr die Datei definiert wurden.</p>'),
'',
'<p><b>Syntax:</b></p>',
'<pre>',
'[[ Image: &lt; Dateiname > | &lt; Eigenschaften > ]]',
'[[ Image: &lt; Dateialias > | &lt; Eigenschaften > ]]',
'</pre>',
'',
'<p><b>Syntaxbeispiele:</b></p>',
'<pre>',
'[[Image: meinimage ]]',
'[[Image: derimagename.jpg ]]',
'[[Image: meinimage | width="600" alt="my image" ]]',
'</pre>',
'',
'<p><b>Kontextbezogenes Beispiel:</b></p>',
'<pre>',
'Im Diagramm [[Image: Diagramm1]] wird der Workflow dargestellt. ',
'</pre>',
'',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456378508650953757.4903)
,p_plug_name=>unistr('Seitenverkn\00FCpfung')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit der nachstehenden Syntax k\00F6nnen Sie Links in Seitenabschnitten in anderen Seiten in einem Websheet einf\00FCgen. Die Verwendung der ID <code>''page:''</code> ist optional. Wenn die Seite vorhanden ist, wird ein Link angezeigt. Wenn die Seite nicht v')
||'orhanden ist, wird ein Link zur Erstellung der Seite angezeigt.</p>',
'',
'<p><b>Syntax:</b></p>',
'<pre>',
'[[ page: &lt;page alias> | &lt;link name> ]]',
'[[ &lt;page alias> | &lt;link name> ]]',
'</pre>',
'',
'<p><b>Syntaxbeispiele:</b></p>',
'<pre>',
'[[page: home]] ',
'[[mypage | Meine Seite]] ',
'</pre>',
'',
'<p><b>Kontextbezogenes Beispiel:</b></p>',
'<pre>',
'Einer der buntesten Fische ist der [[ clownfish | Clownfisch]].',
'</pre>',
'',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456378714883955473.4903)
,p_plug_name=>unistr('Daten-Grid-Verkn\00FCpfung')
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit der nachstehenden Syntax k\00F6nnen Sie Links zu Daten-Grids in Seitenabschnitte einf\00FCgen. Mit diesen Links k\00F6nnen Daten-Grids angezeigt oder neue Daten erstellt werden. Das Daten-Grid kann aus ein oder zwei W\00F6rtern bestehen.</p>'),
'',
'<p><b>Syntax:</b></p>',
'<pre>',
'[[ data grid: &lt;datagrid alias | &lt;link name> ]] ',
'[[ datagrid: &lt;datagrid alias | &lt;link name> ]] ',
'[[ datagrid: &lt;datagrid alias . &lt;gespeicherter Berichtsname (muss nicht privat sein)> | &lt;link name> ]] ',
'</pre>',
'',
'<p><b>Syntaxbeispiele:</b></p>',
'<pre>',
'[[ data grid: todo list | To-do-Liste ]] ',
'[[ datagrid: todo list | To-do-Liste]] ',
'[[ data grid: todo list . open todo items | To-do-Liste]] ',
'</pre>',
'',
'<p><b>Kontextbezogenes Beispiel:</b></p>',
'<pre>',
'Sehen Sie sich die [[ data grid: todo list | To-do-Liste ]] an, und stellen Sie sicher,',
unistr(' dass Ihre Aufgaben bis Freitag erledigt werden k\00F6nnen.'),
'</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456463415491324659.4903)
,p_plug_name=>unistr('Abschnittsverkn\00FCpfung')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit der nachstehenden Syntax k\00F6nnen Sie eine Verkn\00FCpfung zu einem Seitenabschnitt herstellen. Wenn der Abschnitt vorhanden ist, wird ein Link angezeigt. Wenn der Abschnitt nicht vorhanden ist, wird ein Link zur Erstellung des Abschnitts angezeigt.')
||' Wenn dem Abschnitt keine Seite vorangeht, wird davon ausgegangen, dass sich der Abschnitt auf der aktuellen Seite befindet.</p>',
'',
'<p><b>Syntax:</b></p>',
'<pre>',
'[[ section: &lt;page alias> . &lt;page section> | &lt;link name> ]]',
'[[ section: &lt;page section> | &lt;link name> ]]',
'</pre>',
'',
unistr('<p><b>Syntaxbeispiel mit Verkn\00FCpfung zur aktuellen Seite:</b></p>'),
'<pre>',
'[[section: clownfish | Clownfisch]] ',
'</pre>',
'',
unistr('<p><b>Syntaxbeispiel mit Verkn\00FCpfung zu einer anderen Seite:</b></p>'),
'<pre>',
'[[section: fish.clownfish | Clownfisch]] ',
'</pre>',
'',
'<p><b>Kontextbezogene Beispiele:</b></p>',
'<pre>',
'Einer der buntesten Fische ist der [[ section: clownfish | Clownfisch]].',
'Besuchen Sie unsere Fischseite, um den [[ section: fish . clownfish | Clownfisch]] (auch als Nemo bekannt) anzusehen.',
'</pre>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456475006515549140.4903)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_list_template_id=>wwv_flow_api.id(171596314926127907.4903)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'STANDARD'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456475623830554083.4903)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(506319619645513438.4903)
,p_plug_name=>'SQL Introduction'
,p_parent_plug_id=>wwv_flow_api.id(456475623830554083.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit der Syntax <code>SQL</code> oder <code>SQLVALUE</code> k\00F6nnen Sie Einzelwert- und tabellarische Ergebnisse von Abfragen f\00FCr Daten-Grids oder Tabellen und Views in den Abschnitten einer Seite einbeziehen. Das Tag <code>SQLVALUE</code> zeigt die')
||unistr(' erste Spalte der ersten Zeile an, die von der SQL-Abfrage zur\00FCckgegeben wird. Auf diese Weise k\00F6nnen Sie Daten in einem Satz einbetten (Beispiel: Es gibt 5 Arten von Kategorien). Bei tabellarischen Ergebnissen verwenden Sie das Tag <code>SQL</code>.')
||unistr(' Ergebnisse von <code>SQL</code>-Tag werden in einem Bericht angezeigt, der durchsucht werden kann. Standardm\00E4\00DFig kann die Suchoption jedoch mit der <code>NOSEARCH</code>-Syntax deaktiviert werden.</p>'),
'',
'<p>Bei Daten-Grids gibt es einige weitere Optionen, die unter "Syntax" angezeigt werden, und einige weitere Regeln. Basisregeln beim Schreiben einer Daten-Grid-Abfrage umfassen:</p>',
'<p>',
'<ul>',
'<li>Der Daten-Grid-Name oder -alias muss in geschweiften Klammern stehen. Beispiel:',
'<pre>{Cat Facts}</pre></li>',
unistr('<li>Die Daten-Grid-Spaltennamen m\00FCssen in doppelten Anf\00FChrungszeichen stehen. Beispiel:'),
'<pre>"Type of Cat"</pre></li>',
'</ul>',
unistr('Die erweiterten Regeln werden im letzten Abschnitt aufgef\00FChrt.'),
'</p>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(506320009733520103.4903)
,p_plug_name=>'SQL Syntax'
,p_parent_plug_id=>wwv_flow_api.id(456475623830554083.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><b>Syntax bei Abfragen von Tabellen und Views:</b></p>',
'<pre>',
'[[sql: &lt;select statement> ]]',
'[[sql: &lt;select statement | limit="&lt;maximum rows>" nosearch style="&lt;style number>" ]]',
'[[sqlvalue: &lt;select statement> ]]',
'</pre>',
'',
'<p><b>Syntax bei Daten-Grid-Abfragen:</b></p>',
'<pre>',
'[[sql: &lt;select statement> ]]',
'[[sql: &lt;select statement | limit="&lt;maximum rows>" nosearch style="&lt;style number>" edit_row add_row show_sql ]]',
'[[sqlvalue: &lt;select statement> ]]',
'[[sqlvalue: &lt;select statement> | show_sql ]]',
'</pre>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(506320222200523729.4903)
,p_plug_name=>'SQL Examples'
,p_parent_plug_id=>wwv_flow_api.id(456475623830554083.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><b>Beispiele f\00FCr SQL-Tag-Syntax im Kontext:</b></p>'),
'<pre>',
'Dies ist ein Bericht von maximal 10 Mitarbeitern, die in Abteilung 10 arbeiten: ',
'[[sql: select ename "Employee Name", sal "Salary" from emp order by sal desc | limit="10" style="2"]].',
'[[sql: select "Type of Cat",',
'              "Estimated Population",',
'              "Largest Threats",',
'              "Top Speed",',
'              "Scientific Name",',
'              "IUCN Status",',
'              "Weight",',
'              "Study Date"',
'       from {Cat Facts} | add_row edit_row ]]',
'</pre>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(506321126618543925.4903)
,p_plug_name=>'SQLVALUE Tag Example'
,p_parent_plug_id=>wwv_flow_api.id(456475623830554083.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><b>Beispiele f\00FCr SQLVALUE-Tag-Syntax im Kontext:</b></p>'),
'<pre>',
'Wir haben [[sqlvalue: select count(*) from emp]] Mitarbeiter in unserer Datenbank, ',
'[[sqlvalue: select count(*) from emp where deptno=10 ]] arbeiten in Abteilung 10.',
unistr('Wir \00FCberwachen derzeit [[sqlvalue: select count(*) from {Cat Facts} ]] Typen von Kategorien.'),
'</pre>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456684602920305675.4903)
,p_plug_name=>unistr('Berichtsverkn\00FCpfung')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit der nachstehenden Syntax k\00F6nnen Sie Links in Berichte in Ihrem Seitenabschnitt einbinden.</p>'),
'',
'<p><b>Syntax:</b></p>',
'<pre>',
'[[ report: &lt;report alias> | &lt;link name> ]]',
'[[ report: &lt;report alias> . &lt;gespeicherter Berichtsname (muss nicht privat sein)> | &lt;link name> ]] ',
'</pre>',
'',
'<p><b>Syntaxbeispiele:</b></p>',
'<pre>',
'[[ report: fish | Salzwasserfisch ]]',
'[[ report: fish . my favorite | Salzwasserfisch ]] ',
'',
'</pre>',
'',
'<p><b>Kontextbezogenes Beispiel:</b></p>',
'<pre>',
unistr('Pr\00FCfen Sie den [[ report: fish | perfect temperature ]] auf den ausgew\00E4hlten Salzwasserfisch.'),
'</pre>'))
,p_plug_required_role=>wwv_flow_api.id(492214905335570870)
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456722229827231075.4903)
,p_plug_name=>'Dateien'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit der nachstehenden Syntax k\00F6nnen Sie Downloadlinks zu hochgeladenen Dateien in Seitenabschnitten einbetten.<p/>'),
'',
'<p><b>Syntax:</b></p>',
'<pre>',
'[[ file: &lt; file name > | &lt; link name > ]]',
'[[ file: &lt; file alias > | &lt; link name > ]]',
'</pre>',
'',
'<p><b>Syntaxbeispiele:</b></p>',
'<pre>',
'[[file: myfile ]]',
'[[file: myfile.xls ]]',
'[[file: myfile | Meine Datei ]]',
'</pre>',
'',
'<p><b>Kontextbezogenes Beispiel:</b></p>',
'<pre>',
'Dieses [[file: parts01.xls | spreadsheet ]] dokumentiert unsere Teilenummern.',
'</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466849412509851927.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752825018135722319.4903)
,p_plug_name=>'Erweiterte Daten-Grid-Abfragen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>105
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Die erweiterten Abfrageregeln von Daten-Grids umfassen:</p>',
'<p>',
'<ul>',
unistr('<li>Die Abfrage muss das Daten-Grid nur einmal referenzieren, um einen Link zum Bearbeiten oder Einf\00FCgen von Zeilen aufzunehmen (d.h. Sie k\00F6nnen das Daten-Grid innerhalb der Abfrage nicht mit sich selbst verkn\00FCpfen).</li>'),
unistr('<li>Die erste Spalte muss der Prim\00E4rschl\00FCssel (d.h. die Spalte, die die Datenzeile eindeutig referenziert) des Daten-Grids sein, um einen Link f\00FCr das Bearbeiten von Zeilen aufzunehmen. Wenn die Option "edit_row" enthalten ist und die Abfrage eine ei')
||unistr('nzelne Select-Anweisung enth\00E4lt, wird die Prim\00E4rschl\00FCsselspalte automatisch einbezogen. Wenn die Abfrage mehrere Select-Anweisungen enth\00E4lt, k\00F6nnen Sie die <code>"APXWS_DATA_GRID_PK"</code>-Ersetzung (immer in doppelten Anf\00FChrungszeichen) als erste S')
||unistr('palte in der Select-Anweisung verwenden, um die Prim\00E4rspalte einzubeziehen, damit ein Link f\00FCr das Erstellen von Zeilen aufgenommen wird.</li>'),
unistr('<li>Berichtsspaltennamen entsprechen den Spaltennamen aus dem Daten-Grid, k\00F6nnen jedoch mit der Standardsyntax f\00FCr das Erstellen von Standard-SQL-Aliasnamen ge\00E4ndert werden. Beispiel: Mit folgender Anweisung werden die Daten aus der Spalte "Mindestan')
||unistr('zahl" angezeigt, die \00DCberschrift ist jedoch "Min.":'),
'<pre>select "Minimum Number" "Min" from ...</pre></li>',
unistr('<li>Wenn ein Spaltenname l\00E4nger ist als 30 Zeichen, nehmen Sie nur die ersten 30 Zeichen als Name auf. Beispiel: Verwenden Sie: '),
unistr('<pre>"% von gesch\00E4tzten L\00F6wen pro R"</pre> '),
'anstelle von:',
unistr('<pre>"% von gesch\00E4tzten L\00F6wen pro Region"</pre>'),
unistr('<li>Um die Abfrage anzuzeigen, die ausgef\00FChrt wird, nehmen Sie die Option "show_sql" auf. Dadurch wird die Abfrage \00FCber dem aufgenommenen Bericht angezeigt. Obwohl dies eine gute L\00F6sung f\00FCr das Debugging ist, empfiehlt Oracle die Verwendung der Optio')
||'n "show_sql" in einer Produktionsanwendung nicht.</li>',
'</ul>',
'</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00018
begin
wwv_flow_api.create_page(
 p_id=>18.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Seitenansichten'
,p_step_title=>'Seitenansichten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23684126174999945.4903)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23684522796999946.4903)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(23684126174999945.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>200
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23691322028074401.4903)
,p_plug_name=>'Monitor Activity Tab'
,p_parent_plug_id=>wwv_flow_api.id(23684126174999945.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23689225706066046.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459633427711416362.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459640000854444211.4903)
,p_plug_name=>'Page Views'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    time_stamp,',
'    (select name from wwv_flow_steps p where p.id = l.step_id and p.flow_id = 4900) component_name,',
'    webpage_id,',
'    decode(webpage_id,null,null,(',
'       select max(name)',
'       from wwv_flow_ws_webpages p',
'       where p.ws_app_id = :ws_app_id',
'       and p.security_group_id = :flow_security_group_id',
'       and p.id = l.webpage_id)) page_name,',
'    elap,',
'    num_rows,',
'    lower(userid) userid,',
'    session_id,',
'    substr(user_agent,1,100) user_agent,',
'    sqlerrm,',
'   websheet_id,',
'   worksheet_id,',
'   ir_search,',
'   CONTENT_LENGTH',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - nvl(:P18_TIME,1)) and',
'    ( flow_id = 4900 ) and',
'    websheet_id = :ws_app_id and',
'    webpage_id in (select id from wwv_flow_ws_webpages where ws_app_id = :ws_app_id and security_group_id = :flow_security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(459640129876444211.4903)
,p_name=>'Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459640328679444227.4903)
,p_db_column_name=>'TIME_STAMP'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Datum'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459640430971444230.4903)
,p_db_column_name=>'ELAP'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Wiedergabezeit'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459640528870444230.4903)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Zeilen'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459640631431444230.4903)
,p_db_column_name=>'USERID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Benutzer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459641100631444231.4903)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Session'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459641220629444231.4903)
,p_db_column_name=>'USER_AGENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'User Agent'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459641414761444232.4903)
,p_db_column_name=>'SQLERRM'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Fehlermeldung'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459642022665444233.4903)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Websheet'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459642106997444233.4903)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Arbeitsblatt'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459642211221444233.4903)
,p_db_column_name=>'IR_SEARCH'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Zu suchender Text'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459642314321444233.4903)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>unistr('Inhaltsl\00E4nge')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459654731381564614.4903)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Seiten-ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459654904510641947.4903)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Seitenname'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459656813953701510.4903)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Komponentenname'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(459653504454537879.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(459640000854444211.4903)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:18,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459652428040497404.4903)
,p_name=>'P18_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23684522796999946.4903)
,p_item_default=>'1'
,p_prompt=>'Zeitrahmen'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Berichtdaten innerhalb des ausgew\00E4hlten Berichtzeitrahmens anzeigen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
end;
/
prompt --application/pages/page_00019
begin
wwv_flow_api.create_page(
 p_id=>19.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('H\00E4ufig gestellte Fragen')
,p_step_title=>unistr('H\00E4ufig gestellte Fragen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css" media="screen">',
'	/* Hide left col */',
'	div.wsSideCol {',
'		 display: none !important;',
'	}',
'	div.wsMainCol {',
'		 padding: 5px;',
'	}',
'</style>'))
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(487174720945604524.4903)
,p_plug_name=>unistr('H\00E4ufig gestellte Fragen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p><ol>'');',
'for i in 1..6 loop',
'    sys.htp.p(''<li>'');',
'    sys.htp.p(''<b>''||wwv_flow_lang.system_message(''WEBSHEETS_FAQ_Q''||i)||''</b>'');',
'    sys.htp.p(''<p>''||wwv_flow_lang.system_message(''WEBSHEETS_FAQ_A''||i)||''</p>'');',
'    sys.htp.p(''</li>'');',
'end loop;',
'sys.htp.p(''</ol></p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(487175204107609089.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
,p_translate_title=>'N'
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_api.create_page(
 p_id=>20.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Zeile hinzuf\00FCgen/bearbeiten')
,p_step_title=>unistr('Zeile hinzuf\00FCgen/bearbeiten')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'.ie7 table.wsTable,',
'.ie9 table.wsTable { width: 100%;}',
'</style>'))
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(456220226828170850)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_comment=>'onload="wsPageInit(); $x_Hide(''R177113009695013686'');"'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3156111248550044.4903)
,p_plug_name=>'HIDDEN FORM ELEMENTS'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(173336062654423126.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18840420076327189.4903)
,p_plug_name=>'Toolbar Right Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(60003614641461883.4903)
,p_plug_name=>'edit row'
,p_region_name=>'row'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_validation_passed varchar2(1) := null;  ',
'begin',
'  if :P20_VALIDATION_CNT > 0 then',
'    l_validation_passed := ''N'';',
'  else',
'    l_validation_passed := ''Y'';',
'  end if;',
'',
'  wwv_flow_ws_form.show (',
'    p_ws_app_id            => :WS_APP_ID,',
'    p_worksheet_id         => :P2_ID,',
'    p_data_grid_id         => :P2_WEBSHEET_ID,',
'    p_session              => :APP_SESSION,',
'    p_app_user             => :APP_USER,',
'    p_row_id               => :CURRENT_WORKSHEET_ROW,         ',
'    p_base_report_id       => :RPT_ID,',
'    p_partial_page_refresh => false,    ',
'    p_validation_passed    => l_validation_passed,',
'    p_last_page_id         => :P20_LAST_PAGE_ID,',
'    p_last_section_id      => :P20_LAST_SECTION_ID',
'    );',
'',
'  sys.htp.prn(''<span id="apexir_LOADER" style="display:none;" role="alert">'');',
'  sys.htp.prn(''<img alt="''||wwv_flow_lang.system_message(''WAITING.GENERIC'')||''" src="''||wwv_flow.g_image_prefix||''ws/ajax-loader.gif" />'');',
'  sys.htp.prn(''</span>'');    ',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(81681415007489705.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466744416033456525.4903)
,p_plug_name=>'Ajax Notification Holder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>'<div class="htmldbNotification" id="ajaxMESSAGE" style="display:none;"><img src="#IMAGE_PREFIX#delete.gif" onclick="apex.jQuery(''#ajaxMESSAGE'').hide();"  style="float:right;" class="pb" alt="" /><div id="theMESSAGE"></div></div>'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(617574631447733199.4903)
,p_plug_name=>'Aktionen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_form.show_actions (',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_ir_id           => :P2_ID,',
'    p_data_grid_id    => :P2_WEBSHEET_ID,',
'    p_row_id          => :CURRENT_WORKSHEET_ROW',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'CURRENT_WORKSHEET_ROW'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18840704623332140.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(18840420076327189.4903)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(157417700068555483.4903)
,p_branch_action=>'&P20_RETURN_URL.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''CREATE'',''APPLY_CHANGES'',''DELETE'') and :P20_RETURN_URL is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(3142429378139099.4903)
,p_branch_action=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'ATTACHMENT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(157307002240912816.4903)
,p_branch_action=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3040322372230697.4903)
,p_name=>'P20_DESC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4903)
,p_prompt=>'Beschreibung'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3142702413159613.4903)
,p_name=>'P20_X'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4903)
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(10603912332220266.4903)
,p_name=>'P20_LAST_SECTION_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253264503612911225.4903)
,p_name=>'P20_LAST_PAGE_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(254176711273952957.4903)
,p_name=>'P20_RETURN_URL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(636400801424215275.4903)
,p_name=>'P20_VALIDATION_CNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2495429001405484202.4903)
,p_name=>'P20_IR_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2495429311101487046.4903)
,p_name=>'P20_DATA_GRID_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2495988315189126716.4903)
,p_name=>'P20_ROW_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(3156111248550044.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2495429625300491103.4903)
,p_computation_sequence=>10
,p_computation_item=>'P2_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P20_IR_ID'
,p_compute_when=>'P20_IR_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(2495430601190493614.4903)
,p_computation_sequence=>20
,p_computation_item=>'P2_WEBSHEET_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P20_DATA_GRID_ID'
,p_compute_when=>'P20_DATA_GRID_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(254184217200086883.4903)
,p_computation_sequence=>40
,p_computation_item=>'P20_RETURN_URL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_url             varchar2(4000);',
'    l_page_alias      varchar2(255);',
'    l_data_grid_alias varchar2(255);',
'begin               ',
'    if :P20_LAST_PAGE_ID is not null then',
'        l_page_alias := wwv_flow_ws_api.get_page_alias(p_ws_app_id => :WS_APP_ID,p_page_id=> :P20_LAST_PAGE_ID);',
'        l_url := wwv_flow_ws_webpage.get_url (',
'                    p_ws_app_id   => :WS_APP_ID,',
'                    p_session     => :APP_SESSION,',
'                    p_alias       => l_page_alias,',
'                    p_url_postfix => ''#SECTION_''||:P20_LAST_SECTION_ID);',
'    else',
'        l_data_grid_alias := wwv_flow_ws_api.get_data_grid_alias(p_ws_app_id => :WS_APP_ID,p_data_grid_id=> :P20_DATA_GRID_ID);',
'        l_url := wwv_flow_ws_webpage.get_url (',
'                    p_ws_app_id   => :WS_APP_ID,',
'                    p_session     => :APP_SESSION,',
'                    p_alias       => ''DG_''||l_data_grid_alias);',
'    end if;',
'    return l_url;',
'end;'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(471737310147352854.4903)
,p_computation_sequence=>20
,p_computation_item=>'WORKSHEET_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_ws_api.get_websheet_name(p_worksheet_id => :p2_id);'
,p_computation_error_message=>'Daten-Grid-Name kann nicht abgerufen werden.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(162010510295416465.4903)
,p_computation_sequence=>30
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'20'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(458952427548535993.4903)
,p_validation_name=>'process row'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_validation_error varchar2(32767);',
'  l_validation_count number;',
'begin',
'',
'wwv_flow_ws_api.process_row (',
'    p_ws_app_id     => :WS_APP_ID,',
'    p_worksheet_id  => :P2_ID,',
'    p_websheet_id   => :P2_WEBSHEET_ID,',
'    p_row_id        => :CURRENT_WORKSHEET_ROW,',
'    f01             => wwv_flow.g_f01,',
'    f02             => wwv_flow.g_f02,   ',
'    p_validation_error => l_validation_error,',
'    p_validation_count => l_validation_count,',
'    p_ajax_mode     => false );',
'',
'  :P20_VALIDATION_CNT :=  l_validation_count;',
'',
'  return '''';',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Validierungsfehler.'
,p_validation_condition=>'CREATE_AND_CREATE_ANOTHER,CREATE,APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(157440521988694296.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Row'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_row(',
'    p_websheet_id   => :P2_WEBSHEET_ID,',
'    p_row_id        => :CURRENT_WORKSHEET_ROW);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Anforderung kann nicht verarbeitet werden.'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00022
begin
wwv_flow_api.create_page(
 p_id=>22.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Daten-Grid-SQL-Syntax'
,p_step_title=>'Daten-Grid-SQL-Syntax'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(456220226828170850)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6247329636592604.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6498131507796437.4903)
,p_plug_name=>'Data Grids'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.p22_data_grid_list (',
'    p_app_id       => :app_id,',
'    p_app_session  => :app_session,',
'    p_ws_app_id    => :ws_app_id,',
'    p_data_grid_id => :P22_DATA_GRID_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6674628032470220.4903)
,p_plug_name=>'Spalten innerhalb von &P22_DATA_GRID_NAME.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.p22_data_grid_columns (',
'    p_data_grid_id   => :P22_DATA_GRID_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P22_DATA_GRID_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(6707429061744964.4903)
,p_plug_name=>'Abfragen basierend auf &P22_DATA_GRID_NAME.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.p22_data_grid_query (',
'    p_data_grid_id   => :P22_DATA_GRID_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P22_DATA_GRID_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>W\00E4hlen Sie ein Daten-Grid auf der linken Seite, um SQL- und SQLVALUE-Abfragen zu generieren, die Sie innerhalb der Anwendung verwenden k\00F6nnen.</p>')
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11359532303186287.4903)
,p_plug_name=>'Keine Daten-Grids'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(1071999318750156264.4903)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P22_DATA_GRID_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div class="wsPageMessage">Die Anwendung hat keine Daten-Grids.</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(133788708672776881.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(248081616517731203.4903)
,p_plug_name=>'Lesezeichenlink zu &P22_DATA_GRID_NAME.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>75
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''ws?p=''||:WS_APP_ID||'':DG_''||:P22_DATA_GRID_ALIAS);',
'sys.htp.p(''<br />'');',
'sys.htp.p(''ws?p=''||:WS_APP_ID||'':DG_''||:P22_DATA_GRID_ALIAS||''::ROW_ID:[DATA_GRID_ROW_ID]'');',
'sys.htp.p(''<br /><br />'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P22_DATA_GRID_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Um ein Lesezeichen direkt zu einem Daten-Grid oder einer Zeile zu erstellen, verwenden Sie die folgende Syntax:</p>'
,p_plug_footer=>unistr('<p>Hinweis: Die DATA_GRID_ROW_ID ist der ID-Spaltenwert der APEX$_WS_ROWS-Tabelle. Sie erhalten einen Link zu einer bestimmten Daten-Grid-Zeile, indem Sie ein Daten-Grid ausf\00FChren, auf das Zeilenbearbeitungssymbol klicken und die URL aus dem Browser ')
||'abrufen.</p>'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(268418006320837162.4903)
,p_plug_name=>'Link zu &P22_DATA_GRID_NAME. (Markup-Syntax)'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>85
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit der nachstehenden Syntax k\00F6nnen Sie Links zu Daten-Grids in Seitenabschnitte einf\00FCgen. Mit diesen Links k\00F6nnen Daten-Grids angezeigt oder neue Daten erstellt werden. Das Daten-Grid kann aus ein oder zwei W\00F6rtern bestehen.</p>'),
'',
'<p><b>Syntax:</b></p>',
'<pre>',
'[[ data grid: &lt;datagrid alias | &lt;link name> ]] ',
'[[ datagrid: &lt;datagrid alias | &lt;link name> ]] ',
'[[ datagrid: &lt;datagrid alias . &lt;gespeicherter Berichtsname (muss nicht privat sein)> | &lt;link name> ]] ',
'</pre>',
'',
'<p><b>Syntaxbeispiele:</b></p>',
'<pre>',
'[[ data grid: todo list | To-do-Liste ]] ',
'[[ data grid: todo list . open todo items | To-do-Liste]] ',
'[[ datagrid: todo list | To-do-Liste]] ',
'</pre>',
'',
'<p><b>Kontextbezogenes Beispiel:</b></p>',
'<pre>',
'Sehen Sie sich die [[ data grid: todo list | To-do-Liste ]] an, und stellen Sie sicher,',
unistr(' dass Ihre Aufgaben bis Freitag erledigt werden k\00F6nnen.'),
'</pre>',
''))
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P22_DATA_GRID_ID'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(6706611868673736.4903)
,p_name=>'P22_DATA_GRID_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(133788708672776881.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(248170113574405575.4903)
,p_name=>'P22_DATA_GRID_ALIAS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(133788708672776881.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(605139824509083611.4903)
,p_name=>'P22_DATA_GRID_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(133788708672776881.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(8467419570074984.4903)
,p_computation_sequence=>10
,p_computation_item=>'P22_DATA_GRID_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'from wwv_flow_ws_websheet_attr',
'where security_group_id = :flow_security_group_id',
'and ws_app_id = :ws_app_id',
'and rownum = 1',
'order by websheet_name',
''))
,p_compute_when=>'P22_DATA_GRID_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(248170305595409210.4903)
,p_computation_sequence=>10
,p_computation_item=>'P22_DATA_GRID_ALIAS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_alias',
'from wwv_flow_ws_websheet_attr',
'where security_group_id = :flow_security_group_id',
'and ws_app_id = :ws_app_id',
'and id = :P22_DATA_GRID_ID'))
,p_compute_when=>'P22_DATA_GRID_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(605211826718093751.4903)
,p_computation_sequence=>10
,p_computation_item=>'P22_DATA_GRID_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name',
'from wwv_flow_ws_websheet_attr',
'where security_group_id = :flow_security_group_id',
'and ws_app_id = :ws_app_id',
'and id = :P22_DATA_GRID_ID',
''))
,p_compute_when=>'P22_DATA_GRID_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00024
begin
wwv_flow_api.create_page(
 p_id=>24.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Topseiten'
,p_step_title=>'Topseiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459659409774763317.4903)
,p_plug_name=>'Page Views'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    webpage_id,',
'    decode(webpage_id,null,null,(',
'       select max(name)',
'       from wwv_flow_ws_webpages p',
'       where p.ws_app_id = :ws_app_id',
'       and p.id = l.webpage_id)) page_name,',
'    count(*) page_views,',
'    avg(elap) elap,',
'    avg(num_rows) num_rows,',
'    count(distinct userid) userid,',
'    avg(content_length) CONTENT_LENGTH,',
'  sum(CONTENT_LENGTH) content_served,',
'   sum(elap) page_generation_time,',
'   max(time_stamp) last_view',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - nvl(:P24_TIME,1)) and',
'    ( flow_id = 4900 ) and',
'    websheet_id = :ws_app_id and',
'    webpage_id is not null  and',
'    webpage_id in (select id from wwv_flow_ws_webpages where ws_app_id = :ws_app_id and security_group_id = :flow_security_group_id)',
'group by     webpage_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(459659605981763318.4903)
,p_name=>'Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459659820880763321.4903)
,p_db_column_name=>'ELAP'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Durchschnittliche Wiedergabezeit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459659905607763326.4903)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Durchschnittliche Zeilen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459660912570763334.4903)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Durchschnittlicher Textinhalt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459661125550763335.4903)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Seitenname'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::WS_APP_ID,P900_ID:&WS_APP_ID.,#WEBPAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459663826561790231.4903)
,p_db_column_name=>'USERID'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Eindeutige Benutzer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(459664004874793441.4903)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471969020072698244.4903)
,p_db_column_name=>'CONTENT_SERVED'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'Bearbeiteter Inhalt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471969215286698247.4903)
,p_db_column_name=>'PAGE_GENERATION_TIME'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>unistr('Zeit f\00FCr Seitenerstellung')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479550923423223017.4903)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Webseite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479557502570311662.4903)
,p_db_column_name=>'LAST_VIEW'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Letzte Ansicht'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459661531662763337.4903)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23692317442092071.4903)
,p_plug_name=>'Monitor Activity Tab'
,p_parent_plug_id=>wwv_flow_api.id(459661531662763337.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23689225706066046.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23692521944093325.4903)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(459661531662763337.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459662911407766995.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(459661713093763338.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(459659409774763317.4903)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:24,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459661926271763339.4903)
,p_name=>'P24_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23692521944093325.4903)
,p_item_default=>'1'
,p_prompt=>'Zeitrahmen'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Berichtdaten innerhalb des ausgew\00E4hlten Berichtzeitrahmens anzeigen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
end;
/
prompt --application/pages/page_00025
begin
wwv_flow_api.create_page(
 p_id=>25.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Seiten- und Abschnittslinks'
,p_step_title=>'Seiten- und Abschnittslinks'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488510805876131179.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491313913908782031.4903)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491318015433867606.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Kopieren Sie den Seiten- oder Abschnittslink, und f\00FCgen Sie ihn in den Abschnittstext ein, um einen Link auf einer Seite zu erstellen.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491577932536354374.4903)
,p_plug_name=>'Seitenlinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.name page_name, ',
'       decode(a.home_page_id, p.id, ''[[ page: ''||p.name||'' ]]'', ',
'          ''[[ page: ''||p.page_alias||'' | ''||p.name||'' ]]'') page_link',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a',
'where p.security_group_id = :flow_security_group_id ',
'  and p.ws_app_id = :ws_app_id',
'  and p.ws_app_id = a.id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(491578027851354374.4903)
,p_name=>'Page and Section Links'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491578208150354381.4903)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Seite'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491578311606354385.4903)
,p_db_column_name=>'PAGE_LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Seitenlink'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488510218502131175.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491577932536354374.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:25:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(491599426242893169.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_section_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id         => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Collection konnte nicht erstellt werden.'
);
end;
/
prompt --application/pages/page_00026
begin
wwv_flow_api.create_page(
 p_id=>26.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Spreadsheet hochladen (Ajax-Endpunkt)'
,p_step_title=>'Spreadsheet hochladen (Ajax-Endpunkt)'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(157592926751064610)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(157427219470636840.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SPREADSHEET_SAVE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code clob := empty_clob;',
'begin',
'   sys.dbms_lob.createtemporary( l_code, false, sys.dbms_lob.SESSION );',
'   for i in 1..wwv_flow.g_f02.count loop',
'        sys.dbms_lob.writeappend(l_code,length(wwv_flow.g_f02(i)),wwv_flow.g_f02(i));',
'    end loop;',
'apex_collection.create_or_truncate_collection(p_collection_name=>''SPREADSHEET_CONTENT'');',
'apex_collection.add_member(p_collection_name=>''SPREADSHEET_CONTENT'',p_c001=>wwv_flow.g_f01(1),p_clob001=>l_code);',
'sys.htp.prn(''success'');',
'htmldb_application.g_unrecoverable_error := TRUE;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00027
begin
wwv_flow_api.create_page(
 p_id=>27.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Dateien'
,p_step_title=>'Dateien'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488523103160992637.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491316430100805612.4903)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491454229828060959.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Erstellen Sie einen Link f\00FCr den Download von Dateien. Verwenden Sie dazu die [[FILE: ]]-Syntax, oder zeigen Sie Bilder inline mithilfe der [[IMAGE: ]]-Syntax an.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491582707308395779.4903)
,p_plug_name=>'Dateien'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select (select name from wwv_flow_ws_webpages ',
'         where id = n003 and ws_app_id = n002 ',
'           and security_group_id=:flow_security_group_id) page_name,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws ',
'         where w.id=ws.worksheet_id and ws.id = n004 ',
'           and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr ',
'         where id = n004 and ws_app_id = n002 ',
'           and security_group_id=:flow_security_group_id) data_grid_name,',
'       c001 component_level,',
'       c002 file_name,',
'       c003 image_alias,',
'       c008 description,',
'       c009 created_by,',
'       to_number(c011) doc_size,',
'       ''[[ file: ''||c003||'' | ''||c002||'' ]]'' file_link,',
'       ''[[ image: ''||c003||'' | title="''||c002||''" ]]'' image_link,',
'       d001 created_on',
'  from wwv_flow_collections',
' where collection_name = ''APEX$_WS_FILES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(491582908789395824.4903)
,p_name=>'Attachments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_link_column=>'ICON_LINK'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'ICON_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491584227347395830.4903)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Seite'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491584331848395830.4903)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Daten-Grid'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491584421517395830.4903)
,p_db_column_name=>'COMPONENT_LEVEL'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Ebene'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491584708827395830.4903)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Beschreibung'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491585006345395831.4903)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Worksheet-ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491585118316395831.4903)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Dateiname'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491583420164395827.4903)
,p_db_column_name=>'IMAGE_ALIAS'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491591904650603108.4903)
,p_db_column_name=>'FILE_LINK'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>'Dateilink'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491592915647625219.4903)
,p_db_column_name=>'IMAGE_LINK'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'Bildlink'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(495846530207735868.4903)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(495848524451743667.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>35
,p_column_identifier=>'AI'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(495860525237800639.4903)
,p_db_column_name=>'DOC_SIZE'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>'Schriftgrad'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488522502529992636.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491582707308395779.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(491585815273398010.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create file collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_attachment_collection (',
'    p_ws_app_id    => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Collection konnte nicht erstellt werden.'
);
end;
/
prompt --application/pages/page_00028
begin
wwv_flow_api.create_page(
 p_id=>28.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Abschnittslinks'
,p_step_title=>'Abschnittslinks'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492133721971626990.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492133918103626991.4903)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492134119027626992.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Kopieren Sie den Seiten- oder Abschnittslink, und f\00FCgen Sie ihn in den Abschnittstext ein, um einen Link auf einer Seite zu erstellen.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492134510311626995.4903)
,p_plug_name=>'Abschnittslinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.name page_name, ',
'       s.c001 section_name,',
'       s.c002 section_type,',
'       decode(s.n001, NULL, NULL, ''[[ section: ''||p.page_alias||''.''||s.c001||',
'              '' |  ''||s.c001||'' ]]'') section_link,',
'       s.n003 section_seq',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a,',
'     wwv_flow_collections s',
'where p.security_group_id = :flow_security_group_id ',
'  and p.ws_app_id = :ws_app_id',
'  and p.ws_app_id = a.id',
'  and p.id = s.n002 (+)',
'  and s.collection_name (+) = ''APEX$_WS_SECTIONS''',
'  and s.c002 != ''PLSQL'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(492134718217626996.4903)
,p_name=>'Page and Section Links'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492134831239626996.4903)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Seite'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492135023564626998.4903)
,p_db_column_name=>'SECTION_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Abschnitt'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492135204191626998.4903)
,p_db_column_name=>'SECTION_SEQ'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>'Sequenz auf Seite'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492135323582626998.4903)
,p_db_column_name=>'SECTION_TYPE'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Abschnittstyp'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(492203630195322675)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492135114156626998.4903)
,p_db_column_name=>'SECTION_LINK'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492134320826626994.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(492134510311626995.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(492135623803626999.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_section_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id         => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Collection konnte nicht erstellt werden.'
);
end;
/
prompt --application/pages/page_00029
begin
wwv_flow_api.create_page(
 p_id=>29.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Daten-Grid-Links'
,p_step_title=>'Daten-Grid-Links'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488528711832072509.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>300
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Kopieren Sie den Daten-Grid-Link, und f\00FCgen Sie ihn in den Abschnittstext ein, um einen Link auf einer Seite zu erstellen.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488529907857072513.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491316014516801049.4903)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>25
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491746024610087200.4903)
,p_plug_name=>'Daten-Grid-Links'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select w.name name, ',
'       ''[[ data grid: ''||lower(a.websheet_alias)||'' | ''|| w.name ||'' ]]'' data_grid_link',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''DATA'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(491746111378087200.4903)
,p_name=>'Data Grid Links'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491746317155087207.4903)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491746428175087207.4903)
,p_db_column_name=>'DATA_GRID_LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Daten-Grid-Link'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488529313077072512.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491746024610087200.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:29:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00030
begin
wwv_flow_api.create_page(
 p_id=>30.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Berichtslinks'
,p_step_title=>'Berichtslinks'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(11249921373943607.4903)
,p_required_role=>wwv_flow_api.id(492214905335570870)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488531706310080311.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>unistr('<p>Kopieren Sie den Berichtslink, und f\00FCgen Sie ihn in den Abschnittstext ein, um einen Link auf einer Seite zu erstellen.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(488532919512080318.4903)
,p_plug_name=>'Help Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(456471813385447055.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11252405836967523.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491315807244799034.4903)
,p_plug_name=>'sub tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(491255024672312078.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(11270206893119252.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491748021852099994.4903)
,p_plug_name=>'Berichtslinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select w.name name, ',
'       ''[[ report: ''||lower(a.websheet_alias)||'' | ''|| w.name ||'' ]]'' report_link',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      a.websheet_type = ''REPORT'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(491748229774099997.4903)
,p_name=>'Data Grid Links'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491748324162100000.4903)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(491751223153119333.4903)
,p_db_column_name=>'REPORT_LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Berichtslink'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(491750704452113945.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(491748021852099994.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.:RIR::'
);
end;
/
prompt --application/pages/page_00031
begin
wwv_flow_api.create_page(
 p_id=>31.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Seite kopieren'
,p_step_title=>'Seite kopieren'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(456220226828170850)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20320615327276649.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_COPY_PAGE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(929190133057280555.4903)
,p_plug_name=>'Erfolg'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_plug_template=>wwv_flow_api.id(931543191007401308.4903)
,p_plug_display_sequence=>10
,p_plug_query_num_rows=>15
,p_plug_header=>'<p>Die Seite wurde erfolgreich kopiert.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(929190488644282428.4903)
,p_plug_name=>unistr('Schaltfl\00E4chenleiste')
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'TEXT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(929190621583287226.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(929190488644282428.4903)
,p_button_name=>'VIEW_CURRENT_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Aktuelle Seite anzeigen'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:P900_ID:&P900_ID.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(929190863882290386.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(929190488644282428.4903)
,p_button_name=>'VIEW_NEW_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Neue Seite anzeigen'
,p_button_position=>'CREATE2'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:P900_ID:&P908_NEW_PAGE_ID.'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
end;
/
prompt --application/pages/page_00033
begin
wwv_flow_api.create_page(
 p_id=>33.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'BLOB-Formatmaske'
,p_step_title=>'BLOB-Formatmaske'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
'  function apex_p33_download_format_set(){',
'    var l_Array = [$v(''P33_TYPE''),$v(''P33_BLOB_TABLE''),$v(''P33_BLOB_COLUMN''),$v(''P33_PK1''),$v(''P33_PK2''),$v(''P33_MIMETYPE''),$v(''P33_FILENAME''),$v(''P33_UPDATED''),$v(''P33_CHARSET''),$v(''P33_CONTENT_DISPOSITION''),$v(''P33_LINK_TEXT'')];',
'    var lItem = ''P3020_FORMAT_MASK'';',
'    var l_Value = $u_ArrayToString(l_Array,'':'');',
'    opener.$s(lItem,l_Value);',
'    window.close();',
'    opener.$x(lItem).focus();',
'  }',
'',
'//-->',
'</script>  '))
,p_step_template=>wwv_flow_api.id(134255203486851095.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(456220226828170850)
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(382871122829192382.4903)
,p_plug_name=>'BLOB-Formatmaske'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(82536903857665765.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid=>true
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(383167816689247554.4903)
,p_plug_name=>'Top Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(383212323961249647.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(383167816689247554.4903)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>'Anwenden'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex_p33_download_format_set();'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(382974024476212019.4903)
,p_name=>'P33_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4903)
,p_prompt=>'Formatmaske'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BLOB_FORMAT_MASK'
,p_lov=>'.'||wwv_flow_api.id(382915819151201016.4903)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(383000402790215206.4903)
,p_name=>'P33_BLOB_TABLE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4903)
,p_prompt=>'BLOB-Tabelle'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(383045518374219662.4903)
,p_name=>'P33_BLOB_COLUMN'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4903)
,p_prompt=>'BLOB-Spalte'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(402663623371449753.4903)
,p_name=>'P33_PK1'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4903)
,p_prompt=>unistr('Prim\00E4rschl\00FCsselspalte 1')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(402992609350483622.4903)
,p_name=>'P33_PK2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4903)
,p_prompt=>unistr('Prim\00E4rschl\00FCsselspalte 2')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403109000131490412.4903)
,p_name=>'P33_MIMETYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4903)
,p_prompt=>unistr('Spalte f\00FCr MIME-Typ')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403280800609499987.4903)
,p_name=>'P33_FILENAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4903)
,p_prompt=>unistr('Spalte f\00FCr Dateinamen')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403382322426506264.4903)
,p_name=>'P33_UPDATED'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4903)
,p_prompt=>'BLOB Zuletzt aktualisierte Spalte'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403460500740509547.4903)
,p_name=>'P33_CHARSET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4903)
,p_prompt=>unistr('Spalte f\00FCr Zeichensatz')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403561421518515499.4903)
,p_name=>'P33_CONTENT_DISPOSITION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4903)
,p_prompt=>'Contentdisposition'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BLOB_CONTENT_DISPOSITION'
,p_lov=>'.'||wwv_flow_api.id(382939512009208407.4903)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(403683725112525989.4903)
,p_name=>'P33_LINK_TEXT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(382871122829192382.4903)
,p_prompt=>unistr('Link-Text f\00FCr Download')
,p_source=>'wwv_flow_lang.system_message(''DOWNLOAD'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(992326827720799292.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch blob format mask info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.p33_fetch_blob_format (',
'    p_format_mask         => :P3020_FORMAT_MASK,    ',
'    --',
'    p_type                => :P33_TYPE,',
'    p_blob_table          => :P33_BLOB_TABLE,',
'    p_blob_column         => :P33_BLOB_COLUMN,',
'    p_pk1_column          => :P33_PK1,',
'    p_pk2_column          => :P33_PK2,',
'    p_mimetype_column     => :P33_MIMETYPE,',
'    p_filename_column     => :P33_FILENAME,',
'    p_last_upd_column     => :P33_UPDATED,',
'    p_charset_column      => :P33_CHARSET,',
'    p_content_disposition => :P33_CONTENT_DISPOSITION,',
'    p_download_text       => :P33_LINK_TEXT',
'    );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00037
begin
wwv_flow_api.create_page(
 p_id=>37.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Sprache ausw\00E4hlen')
,p_step_title=>unistr('Sprache ausw\00E4hlen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>'MUST_NOT_BE_PUBLIC_USER'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22687832673202415.4903)
,p_plug_name=>'Top Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(619996914922437329.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(633817727195790601.4903)
,p_plug_name=>unistr('Sprache und Gebiet ausw\00E4hlen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(620002529476508161.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(22687832673202415.4903)
,p_button_name=>'RETURN'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(633832411704842867.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(22687832673202415.4903)
,p_button_name=>'SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Festlegen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(636473024858464198.4903)
,p_branch_action=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(633832411704842867.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(633818130920810528.4903)
,p_name=>'P37_LANGUAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(633817727195790601.4903)
,p_item_default=>'wwv_flow_lang.get_g_session_lang'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Sprache'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LANGUAGES_INSTALLED'
,p_lov=>'.'||wwv_flow_api.id(631691002719703351.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Sprache, die beim Ausf\00FChren dieser Anwendung verwendet werden soll. Wenn in Ihrem Webbrowser Cookies aktiviert sind, wird diese Sprachvoreinstellung in einem Cookie gespeichert und bei allen Websheet-Anwendungen dieser Instanz verwende')
||unistr('t. Die Sprachenliste ist von den \00FCbersetzten Versionen von &PRODUCT_NAME. abh\00E4ngig, die installiert sind.'),
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(633818321354817301.4903)
,p_name=>'P37_TERRITORY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(633817727195790601.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.get_g_session_territory'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Gebiet'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_TERRITORIES'
,p_lov=>'.'||wwv_flow_api.id(634728210841234369.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie die Gebietsvoreinstellung, die beim Ausf\00FChren dieser Anwendung verwendet werden soll. Damit wird die standardm\00E4\00DFige Anzeige von Datum, Zahlen und Kalendern bestimmt. Wenn in Ihrem Browser Cookies aktiviert sind, wird diese Gebietsvoreinste')
||'llung in einem Cookie gespeichert und bei allen Websheet-Anwendungen dieser Instanz verwendet.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(636322931994230689.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set language and territory'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.set_session_lang( p_lang => :P37_LANGUAGE );',
'wwv_flow.g_browser_language := :P37_LANGUAGE;',
'wwv_flow_lang.set_session_territory( p_territory => :P37_TERRITORY );',
'',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Fehler beim Verarbeiten von Aktualisierung.'
,p_process_when_button_id=>wwv_flow_api.id(633832411704842867.4903)
,p_process_success_message=>'Aktion wurde verarbeitet.'
);
end;
/
prompt --application/pages/page_00042
begin
wwv_flow_api.create_page(
 p_id=>42.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Meine gespeicherten Berichte'
,p_step_title=>'Meine gespeicherten Berichte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>'MUST_NOT_BE_PUBLIC_USER'
,p_nav_list_template_options=>'#DEFAULT#'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(496647113913986363.4903)
,p_plug_name=>'Meine gespeicherten Berichte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'case when r.is_default!=''Y'' or r.application_user!=''APXWS_DEFAULT'' then',
'    wwv_flow_item.checkbox(',
'        1,',
'        r.id,null,null,'':'',',
'       ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'        wwv_flow_lang.system_message(''REPORT_LABEL'',',
'                            case',
'                              when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'                                wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'                              else',
'                                wwv_flow_escape.html(r.name)',
'                            end) )',
'end id,',
'a.id napp_id,',
'case when ws.websheet_type = ''DATA'' then',
'       ''<a href="f?p=''||:app_id||'':2:''||:app_session||''::::WS_APP_ID,P2_ID,P2_WEBSHEET_ID:''||:ws_app_id||'',''||i.id||'',''||ws.id||''">''||wwv_flow_escape.html(ws.websheet_name)||''</a>''',
'     when ws.websheet_type = ''REPORT'' then',
'       ''<a href="f?p=''||:app_id||'':3000:''||:app_session||''::::WS_APP_ID,IR_ID,WS_ID:''||:ws_app_id||'',''||i.id||'',''||ws.id||''">''||wwv_flow_escape.html(ws.websheet_name)||''</a>''',
'end websheet_name,',
'case when ws.websheet_type = ''DATA'' then',
'       sm.data_grid',
'     when ws.websheet_type = ''REPORT'' then',
'       sm.report',
'end websheet_type,',
'case when r.is_default = ''Y''then ',
'     decode(r.application_user,',
'            ''APXWS_DEFAULT'',sm.primary_def, ',
'            ''APXWS_ALTERNATIVE'',sm.alt_def)',
'     when r.is_default = ''N'' and r.status = ''PUBLIC'' then',
'         sm.spublic',
'     when r.is_default = ''N'' and r.status = ''PRIVATE'' then',
'         sm.private',
'end report_type, ',
'case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'    wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'')',
'else',
'    r.name',
'end name,',
'decode(r.application_user,',
'       ''APXWS_DEFAULT'',null,',
'       ''APXWS_ALTERNATIVE'',null,',
'       lower(r.application_user)) owner,',
'substr(r.description,1,50) description,        ',
'r.report_alias report_alias,',
'r.created_on',
'from wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'wwv_flow_ws_applications a,',
'wwv_flow_ws_websheet_attr ws,',
'(select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary_def,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alt_def,               ',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIVATE'') private,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') spublic,',
'      wwv_flow_lang.system_message(''DATA_GRID'') data_grid,',
'      wwv_flow_lang.system_message(''REPORT'') report',
' from dual) sm',
'where a.id = ws.ws_app_id',
'and ws.worksheet_id = i.id',
'and r.worksheet_id = i.id',
'and r.websheet_id is not null',
'and r.security_group_id = :flow_security_group_id',
'and a.id = :ws_app_id',
'and r.application_user = :app_user',
'and r.session_id is null'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(496647211081986363.4903)
,p_name=>'Saved Reports'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647413912986368.4903)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647505239986368.4903)
,p_db_column_name=>'NAPP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647610315986368.4903)
,p_db_column_name=>'WEBSHEET_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Daten'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(497241820310060978)
,p_rpt_show_filter_lov=>'2'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647729642986369.4903)
,p_db_column_name=>'WEBSHEET_TYPE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Typ'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647830164986369.4903)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Berichtstyp'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496647931210986369.4903)
,p_db_column_name=>'NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496648005718986369.4903)
,p_db_column_name=>'OWNER'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Eigent\00FCmer')
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496648117100986369.4903)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Beschreibung'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(496648221465986369.4903)
,p_db_column_name=>'REPORT_ALIAS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Berichtsalias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(737065808338186629.4903)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(497240631383988555.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(497261218307315877.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Auf dieser Seite k\00F6nnen Sie die gespeicherten Berichte verwalten. Sie k\00F6nnen gespeicherte Berichte mit dem Men\00FC "Aktionen" erstellen, wenn Sie Berichte und Daten-Grids anzeigen. Die Berichtseinstellungen f\00FCr einen gespeicherten Bericht werden beim')
||' Erstellen eines Abschnitts basierend auf einem Bericht oder Daten-Grid referenziert. Sie werden auch zur Anpassung der Daten verwendet, die in diesem Abschnitt dargestellt werden.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(497767325222992406.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(496647113913986363.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:42,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(497233530597931570.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(496647113913986363.4903)
,p_button_name=>'DELETE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('Markierte Elemente l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(497233703023933067.4903)
,p_branch_action=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(497241020778994879.4903)
,p_validation_name=>'must select report to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Bericht muss zum L\00F6schen ausgew\00E4hlt werden.')
,p_when_button_pressed=>wwv_flow_api.id(497233530597931570.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045581531252367912.4903)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(496647113913986363.4903)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045581649091367913.4903)
,p_event_id=>wwv_flow_api.id(2045581531252367912.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(497237425533939526.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    for c1 in (select id report_id, worksheet_id, application_user, is_default, report_type',
'               from wwv_flow_worksheet_rpts',
'               where id = wwv_flow.g_f01(i)',
'               and security_group_id=:flow_security_group_id',
'               and application_user = :app_user)',
'    loop                ',
'        wwv_flow_worksheet_api.delete_saved_report (            ',
'            p_worksheet_id      => c1.worksheet_id,               ',
'            p_report_id         => c1.report_id,',
'            p_is_default        => c1.is_default);        ',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Bericht konnte nicht entfernt werden.'
,p_process_when_button_id=>wwv_flow_api.id(497233530597931570.4903)
,p_process_success_message=>'Berichte entfernt.'
);
end;
/
prompt --application/pages/page_00050
begin
wwv_flow_api.create_page(
 p_id=>50.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Anhang hinzuf\00FCgen')
,p_step_title=>unistr('Anhang hinzuf\00FCgen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(3152608674388513.4903)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_page_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This page needed for Ajax in Data Grid Single Row View (page 20).',
'onload="window.parent.closeupload();"'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3144901000282263.4903)
,p_plug_name=>'Upload'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_error_msg varchar2(4000);',
'begin',
'    wwv_flow_ws_attachment.add_doc (',
'        p_ws_app_id       => :WS_APP_ID,',
'        p_websheet_id     => :P2_WEBSHEET_ID,',
'        p_row_id          => :CURRENT_WORKSHEET_ROW,',
'        p_component_level => ''ROW'',',
'        p_file_name       => :P20_X,',
'        p_desc            => :P20_DESC',
'    );',
'    sys.htp.p(''<script type="text/javascript" charset="utf-8">'');',
'    sys.htp.p(''  window.parent.apex.websheet.closeUpload();'');',
'    sys.htp.p(''</script>'');',
'exception when others then',
'    if sqlcode = -1691 then',
'        l_error_msg := wwv_flow_lang.system_message(''WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'');',
'    else',
'        l_error_msg := sqlerrm;',
'    end if;',
'    sys.htp.p(''<script type="text/javascript" charset="utf-8">'');',
'    sys.htp.p(''  window.parent.apex.websheet.spinner$.remove();'');',
'    sys.htp.p(''  $("#apexir_DIALOG_MESSAGE", window.parent.document).html("''||wwv_flow_escape.html(l_error_msg)||''");'');',
'    sys.htp.p(''</script>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177392830105668569.4903)
,p_branch_name=>'Go To Page 20'
,p_branch_action=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00051
begin
wwv_flow_api.create_page(
 p_id=>51.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Authentifizierungsschemas verwalten'
,p_step_title=>'Authentifizierungsschemas verwalten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177132113855562337.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
end;
/
prompt --application/pages/page_00053
begin
wwv_flow_api.create_page(
 p_id=>53.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Seite bearbeiten'
,p_step_title=>'Seite bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>',
'<style>',
'/* There is no collapse left col functionality on this page, so adding additional padding to Left Col heading */',
'div.ebaTwoColPane > div h2.leftButtons {padding-left: 10px !important;}',
'</style>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4903)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18534419096630219.4903)
,p_plug_name=>'List of Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18529824151546479.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(158861503239501998.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18534800527634294.4903)
,p_plug_name=>'&P53_NAME.-Details'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4903)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18557529579690008.4903)
,p_plug_name=>'Seiten'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4903)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18585811889807838.4903)
,p_plug_name=>'Page Settings List'
,p_region_name=>'page_control'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(18583325957802446.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(162991400186731236.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177409809869723629.4903)
,p_plug_name=>'Seite'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177422928892872875.4903)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(2061383146528710242.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(18557529579690008.4903)
,p_button_name=>'CREATE_PAGE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936712837989177653.4903)
,p_button_image_alt=>'Seite erstellen'
,p_button_position=>'CHANGE'
,p_icon_css_classes=>'icon-plus'
,p_button_cattributes=>'data-menu="page_control_menu"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177410225400723635.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(177422928892872875.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(18562324993707537.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(18557529579690008.4903)
,p_button_name=>'Hide/Show'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4903)
,p_button_image_alt=>'Ausblenden/Anzeigen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_condition_type=>'NEVER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177410026421723634.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(177422928892872875.4903)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
,p_button_condition=>'P53_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177410112058723634.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(177422928892872875.4903)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_condition=>'(:P53_ID is not null) and (not wwv_flow_ws_api.is_app_home_page(p_ws_app_id => :ws_app_id, p_webpage_id => :p53_id))'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(163262329454777553.4903)
,p_branch_action=>'f?p=&APP_ID.:53:&SESSION.::&DEBUG.:53:P53_ID:&P53_NEXT_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'GET_NEXT_PAGE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177410910657723644.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(467021002093988715.4903)
,p_branch_action=>'f?p=&APP_ID.:960:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(177410112058723634.4903)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(163040114731735379.4903)
,p_name=>'P53_NEXT_PAGE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(162991400186731236.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177411102679723645.4903)
,p_name=>'P53_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(162991400186731236.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177411303356723657.4903)
,p_name=>'P53_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt den Seitennamen an. Der Seitenname wird im Fenstertitel und im Navigationspfad angezeigt.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177411518259723658.4903)
,p_name=>'P53_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Eigent\00FCmer')
,p_source=>'OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Gibt den Eigent\00FCmer der Seite an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177411701386723658.4903)
,p_name=>'P53_STATUS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Status'
,p_source=>'STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt den Status der Seite an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177411912672723659.4903)
,p_name=>'P53_DESCRIPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Seitenbeschreibung'
,p_source=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Beschreibender Text f\00FCr die Seite.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177412115882723659.4903)
,p_name=>'P53_PARENT_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00DCbergeordnete Seite')
,p_source=>'PARENT_PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK PARENT PAGE (FOR PAGE 53)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_ws_webpages',
' where security_group_id = :flow_security_group_id',
'   and ws_app_id = :WS_APP_ID',
'minus',
'select name d, id r',
'  from wwv_flow_ws_webpages',
' where security_group_id = :flow_security_group_id ',
'   and ws_app_id = :WS_APP_ID ',
'connect by prior id = parent_page_id',
'start with id = :P53_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Kein \00FCbergeordnetes Element -')
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Identifiziert die \00FCbergeordnete Seite. Die definierte \00FCbergeordnete Seite wird f\00FCr das Erstellen von Navigationspfaden und f\00FCr die Navigation zwischen Seiten verwendet.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(457384308073732200.4903)
,p_name=>'P53_PAGE_ALIAS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(177409809869723629.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alias'
,p_source=>'PAGE_ALIAS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Geben Sie einen alphanumerischen Alias f\00FCr diese Seite ein. Mit einem Seitenalias k\00F6nnen Sie Links in Seitenabschnitten zu anderen Seiten erstellen. Ein Seitenalias muss innerhalb einer Anwendung eindeutig sein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(457472018265246008.4903)
,p_validation_name=>'P53_PAGE_ALIAS must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P53_PAGE_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists(',
'     p_ws_app_id=>:WS_APP_ID,',
'     p_alias=>:P53_PAGE_ALIAS,',
'     p_alias_type=>''PAGE'',',
'     p_page_id=>:P53_ID) then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Seitenalias bereits vorhanden. Geben Sie einen anderen Alias ein..'
,p_validation_condition=>'SAVE,GET_NEXT_PAGE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(457384308073732200.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(467021405256017928.4903)
,p_validation_name=>'cannot delete home page'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_home_page_id  number;',
'begin',
'   for c1 in (',
'      select home_page_id',
'        from wwv_flow_ws_applications',
'       where id = :WS_APP_ID',
'         and security_group_id = :flow_security_group_id )',
'   loop',
'      l_home_page_id := c1.home_page_id;',
'   end loop;',
'',
'   if :P53_ID = l_home_page_id then',
'      return false;',
'   else',
'      return true;',
'   end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Homepage kann nicht gel\00F6scht werden. Bearbeiten Sie die Anwendungseigenschaften, und w\00E4hlen Sie eine neue Homepage.')
,p_when_button_pressed=>wwv_flow_api.id(177410112058723634.4903)
,p_associated_item=>wwv_flow_api.id(177411303356723657.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(467022317985040552.4903)
,p_validation_name=>'cannot delete only page'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_page_count  number;',
'begin',
'   for c1 in (',
'      select count(*) cnt',
'        from wwv_flow_ws_webpages',
'       where ws_app_id = :WS_APP_ID',
'         and security_group_id = :flow_security_group_id )',
'   loop',
'      l_page_count := c1.cnt;',
'   end loop;',
'',
'   if l_page_count = 1 then',
'      return false;',
'   else',
'      return true;',
'   end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Jede Anwendung muss aus mindestens einer Seite bestehen. Sie k\00F6nnen nicht die einzig vorhandene Seite l\00F6schen.')
,p_when_button_pressed=>wwv_flow_api.id(177410112058723634.4903)
,p_associated_item=>wwv_flow_api.id(177411303356723657.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6140313816861525.4903)
,p_validation_name=>'P53_PAGE_ALIAS is valid'
,p_validation_sequence=>40
,p_validation=>'P53_PAGE_ALIAS'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'Alias muss alphanumerisch sein.'
,p_validation_condition=>':P53_PAGE_ALIAS is not null and :REQUEST in (''SAVE'',''GET_NEXT_PAGE'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_api.id(457384308073732200.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177412315870723660.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_WS_WEBPAGES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_WEBPAGES'
,p_attribute_03=>'P53_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID',
'and ws_app_id = :WS_APP_ID'))
,p_process_error_message=>'Zeile kann nicht abgerufen werden.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177412503075723662.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_WS_WEBPAGES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_WEBPAGES'
,p_attribute_03=>'P53_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID',
'and ws_app_id = :WS_APP_ID'))
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_process_error_message=>'Zeile der Tabelle WWV_FLOW_WS_WEBPAGES konnte nicht verarbeitet werden.'
,p_process_when=>'SAVE,GET_NEXT_PAGE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Aktion wurde verarbeitet.'
);
end;
/
prompt --application/pages/page_00079
begin
wwv_flow_api.create_page(
 p_id=>79.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Administration'
,p_step_title=>'Administration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(4881207741750467)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4098511924636618.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(198343320048239476.4903)
,p_plug_name=>'perform logout'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_ws_app_id number := v(''WS_APP_ID'');',
'begin',
'    for c1 in (select auth_id authentication ',
'              from wwv_flow_ws_applications',
'              where id = l_ws_app_id',
'              and security_group_id = :flow_security_group_id)',
'    loop',
'        if c1.authentication is null then',
'            null;',
'        else',
'            for c2 in (select page_sentry_function,logout_url from wwv_flow_ws_custom_auth_setups where id = c1.authentication) loop',
'                if c2.page_sentry_function = ''-DATABASE-'' then',
'                    null;',
'                else',
'                    sys.htp.init;',
'                    sys.owa_util.redirect_url(replace(replace(replace(c2.logout_url,''&''||''WS_APP_ID.'',l_ws_app_id),''&''||''APP_SESSION.'',''&''||''SESSION.''),''&''||''SESSION.'',v(''APP_SESSION'')));',
'                    wwv_flow.stop_apex_engine;',
'                end if;',
'            end loop;                    ',
'        end if;',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(811176724741077278.4903)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'redirect if login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_found boolean := false;',
'  l_territory      varchar2(255);',
'begin',
'for c1 in (select auth_id, language, territory, home_page_id',
'             from wwv_flow_ws_applications',
'            where id = :WS_APP_ID) loop',
'  for c2 in (select auth_function, invalid_session_url',
'               from wwv_flow_ws_custom_auth_setups',
'              where id = c1.auth_id ) loop',
'               if c1.territory is null then',
'                   for c3 in (select nls_territory from wwv_flow_languages where lang_id = c1.language) loop',
'                       l_territory := c3.nls_territory;',
'                       exit;',
'                   end loop;',
'               else',
'                   l_territory := c1.territory;',
'               end if;',
'    if c2.invalid_session_url = ''-PORTAL_SSO-'' then',
'            wwv_flow.g_user := ''nobody'';',
'            wwv_flow_security.g_user := wwv_flow.g_user;',
'            wwv_flow_custom_auth.remember_deep_link(',
'                p_url=>''f?p=''||:app_id||'':900:::::WS_APP_ID,P900_ID:''||:WS_APP_ID||'',''||c1.home_page_id);',
'            begin',
'            wwv_flow_security.g_context := ''WWV_FLOW_CUSTOM_AUTH_SSO'';',
'            wwv_flow_dynamic_exec.run_block (',
'                p_sql=>''begin wwv_flow_custom_auth_sso.portal_sso_redirect; end;'',',
'                p_user=>wwv_flow.g_flow_schema_owner);',
'            wwv_flow_security.g_context := ''NULL'';',
'            exception when others then',
'               wwv_flow_security.g_context := ''NULL'';',
'               l_found := false;',
'               for c1 in (select /* APEXad5ea5 */  1 from sys.dba_objects',
'                   where object_name=''WWSEC_SSO_ENABLER_PRIVATE'' and',
'                   object_type = ''PACKAGE''',
'                   and status = ''VALID'') loop',
'                   l_found := true;',
'               end loop;',
'               if not l_found then',
'                    wwv_flow_error.raise_internal_error (',
'                        p_error_message =>',
'                            wwv_flow_lang.system_message(',
'                                p_name=>''WWV_FLOW_SECURITY.SSO_PKG_MISSING1'')||',
'                                ''<br>&nbsp;''||',
'                            wwv_flow_lang.system_message(',
'                                p_name=>''WWV_FLOW_SECURITY.SSO_PKG_MISSING2'',',
'                                p0=>''&PRODUCT_NAME.'') );',
'               else',
'                   wwv_flow_error.raise_internal_error (',
'                       p_error_code => ''WWV_FLOW_SECURITY.SSO_PKG_ERR'' );',
'               end if;',
'               return;',
'            end;',
'    elsif c2.invalid_session_url = ''-SAML-'' then',
'      wwv_flow_authentication_f4900.trigger_login;',
'    else',
'      sys.htp.init;',
'      sys.owa_util.redirect_url(wwv_flow_ws_webpage.get_login_url(:WS_APP_ID));',
'      wwv_flow.stop_apex_engine;',
'    end if;',
'  end loop;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'LOGIN'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
);
end;
/
prompt --application/pages/page_00089
begin
wwv_flow_api.create_page(
 p_id=>89.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Spaltentyp \00E4ndern')
,p_step_title=>unistr('Spaltentyp \00E4ndern')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4230411616343203.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4231008955350266.4903)
,p_plug_name=>unistr('Spaltentyp\00E4nderung best\00E4tigen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Sie haben die \00C4nderung des Daten-Grid-Spaltentyps angefordert. Wenn Sie den Spaltentyp \00E4ndern, werden vorhandene Filter, Markierungsregeln und andere Berichtseinstellungen f\00FCr diese Spalten deaktiviert. Best\00E4tigen Sie die Anforderung.<p />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(128720011527408660.4903)
,p_plug_name=>unistr('Rechte Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4231507009359228.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(128720011527408660.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4231818090362334.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(128720011527408660.4903)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('Best\00E4tigen')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4236313729446260.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(128720011527408660.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4232110828362335.4903)
,p_branch_action=>'f?p=&FLOW_ID.:2:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4231818090362334.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4236626497446261.4903)
,p_branch_action=>'f?p=&APP_ID.:91:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4236313729446260.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4239107514595863.4903)
,p_name=>'P89_COLUMN_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4231008955350266.4903)
,p_prompt=>'Spaltenname'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_label',
'from wwv_flow_worksheet_columns',
'where db_column_name = :p91_db_column_name',
'and worksheet_id = :p2_id',
'and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Der ausgew\00E4hlte Spaltenname zur \00C4nderung des Spaltentyps.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4239902235613223.4903)
,p_name=>'P89_OLD_COLUMN_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4231008955350266.4903)
,p_prompt=>'Alter Spaltentyp'
,p_source=>'wwv_flow_item.text_from_lov (:p91_column_type,''WORKSHEET_COLUMN_TYPES2'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Der alte Spaltentyp.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4240110892615736.4903)
,p_name=>'P89_NEW_COLUMN_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4231008955350266.4903)
,p_prompt=>'Neuer Spaltentyp'
,p_source=>'wwv_flow_item.text_from_lov (:p91_new_column_type,''WORKSHEET_COLUMN_TYPES2'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Der neue Spaltentyp.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4242814626061519.4903)
,p_name=>'P89_FORMAT_MASK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(4231008955350266.4903)
,p_prompt=>unistr('Formatmaske zur Verwendung bei Spaltentyp\00E4nderungen')
,p_source=>'P91_FORMAT_MASK'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Die Formatmaske, die bei der \00C4nderung des Spaltentyps verwendet werden muss.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(4243626448093240.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'change column type'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.change_column_type (',
'    p_worksheet_id         => :p2_id,',
'    p_websheet_id          => :p2_websheet_id,',
'    p_old_db_column_name   => :p91_db_column_name,    ',
'    p_new_column_type      => :P91_NEW_COLUMN_TYPE,',
'    p_format_mask_to_use   => :P91_FORMAT_MASK);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Spaltentyp konnte nicht ge\00E4ndert werden.')
,p_process_when_button_id=>wwv_flow_api.id(4231818090362334.4903)
,p_process_success_message=>unistr('Spaltentyp ge\00E4ndert.')
);
end;
/
prompt --application/pages/page_00090
begin
wwv_flow_api.create_page(
 p_id=>90.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Verf\00FCgbare Objekte')
,p_step_title=>unistr('Verf\00FCgbare Objekte')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript">',
'   function passBack(passVal1)',
'   {',
'   opener.document.getElementById("P1310_TABLE_NAME").value = passVal1;',
'   opener.document.getElementById("P1310_TABLE_NAME").focus();',
'   close();',
'   }',
'</script>',
''))
,p_step_template=>wwv_flow_api.id(134255203486851095.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(134428823965885392.4903)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(492080122343937551.4903)
,p_plug_name=>'Objects'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, ',
'       null t,',
'       object_name v,',
'       object_comment c',
'  from wwv_flow_ws_app_sug_objects',
' where ws_app_id = :WS_APP_ID',
'   and security_group_id = :workspace_id',
'   and nvl(:P90_TABLE_TYPE,''S'') = ''S''',
'union all',
'select table_name d,',
'       wwv_flow_lang.system_message(''TABLE'') t, ',
'       table_name v,',
'       null c',
'  from sys.dba_tables',
' where owner = :P90_SCHEMA',
'   and table_name not like ''BIN$%''',
'   and table_name not like ''APEX$_%''',
'   and :P90_TABLE_TYPE = ''A''',
'union all',
'select view_name d,',
'       wwv_flow_lang.system_message(''VIEW'') t, ',
'       view_name v,',
'       null c',
'  from sys.dba_views',
' where owner = :P90_SCHEMA',
'   and :P90_TABLE_TYPE = ''A''',
'union all',
'select synonym_name d,',
'       wwv_flow_lang.system_message(''SYNONYM'') t, ',
'       synonym_name v,',
'       null c',
'  from sys.dba_synonyms',
' where owner = :P90_SCHEMA',
'   and :P90_TABLE_TYPE = ''A''',
' order by 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(492080213042937551.4903)
,p_name=>'Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_download_formats=>'CSV'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492080416858937588.4903)
,p_db_column_name=>'D'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Objektname'
,p_column_link=>'javascript:passBack(''#V#'');'
,p_column_linktext=>'#D#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492103930374310439.4903)
,p_db_column_name=>'T'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Objekttyp'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_condition=>'P90_TABLE_TYPE'
,p_display_condition2=>'A'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492623505769353937.4903)
,p_db_column_name=>'C'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Kommentar'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_condition=>'P90_TABLE_TYPE'
,p_display_condition2=>'S'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(492080514008937588.4903)
,p_db_column_name=>'V'
,p_display_order=>5
,p_column_identifier=>'B'
,p_column_label=>'V'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492053301677732661.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(134428823965885392.4903)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('Schlie\00DFen')
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:window.close();'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(492102203653198613.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(492080122343937551.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:90,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492067824637769509.4903)
,p_name=>'P90_TABLE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(134428823965885392.4903)
,p_prompt=>'Anzeigen'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SUGGESTED SQL TABLE TYPE (P90)'
,p_lov=>'.'||wwv_flow_api.id(17231024016826986.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492697000185414926.4903)
,p_name=>'P90_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(492080122343937551.4903)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_ws_setup.get_apex$_schema (p_workspace_id=>:flow_security_group_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(495865912227957737.4903)
,p_computation_sequence=>10
,p_computation_item=>'P90_TABLE_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select count(*) cnt ',
'  from wwv_flow_ws_app_sug_objects',
' where security_group_id = :flow_security_group_id',
'   and ws_app_id = :WS_APP_ID )',
'loop',
'   if c1.cnt = 0 then',
'      return ''A'';',
'   else',
'      return ''S'';',
'   end if;',
'end loop;'))
,p_compute_when=>'P90_TABLE_TYPE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(495717104974056773.4903)
,p_name=>'when no sug obj'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_bind_event_type=>'ready'
,p_display_when_type=>'NOT_EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_ws_app_sug_objects',
' where security_group_id = :flow_security_group_id',
'   and ws_app_id = :WS_APP_ID'))
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(495717422657056775.4903)
,p_event_id=>wwv_flow_api.id(495717104974056773.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P90_TABLE_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(432751509152951102.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check priv'
,p_process_sql_clob=>'wwv_flow_sw_api.check_priv(p_schema => :P90_SCHEMA);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P90_SCHEMA'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_00091
begin
wwv_flow_api.create_page(
 p_id=>91.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Spaltentyp \00E4ndern')
,p_step_title=>unistr('Spaltentyp \00E4ndern')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4233421912405794.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(4233920131410265.4903)
,p_plug_name=>unistr('Spaltentyp \00E4ndern')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(127798813633286291.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(128015931556310368.4903)
,p_plug_name=>unistr('Rechte Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4234716106418588.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(128015931556310368.4903)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CHANGE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(4234126710412218.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(128015931556310368.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(4235020699418588.4903)
,p_branch_action=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(4234716106418588.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4235200653423582.4903)
,p_name=>'P91_COLUMN_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(4233920131410265.4903)
,p_prompt=>'Spaltenname'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_label',
'from wwv_flow_worksheet_columns',
'where db_column_name = :P91_DB_COLUMN_NAME',
'and worksheet_id = :p2_id',
'and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Der ausgew\00E4hlte Spaltenname zur \00C4nderung des Spaltentyps.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4235408965425946.4903)
,p_name=>'P91_COLUMN_TYPE_DISPLAY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(4233920131410265.4903)
,p_prompt=>'Spaltentyp'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.text_from_lov (column_type,''WORKSHEET_COLUMN_TYPES2'')',
'from wwv_flow_worksheet_columns',
'where db_column_name = :P91_DB_COLUMN_NAME',
'and worksheet_id = :p2_id',
'and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_lov_display_extra=>'NO'
,p_help_text=>'Der aktuelle Spaltentyp.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4235631474432520.4903)
,p_name=>'P91_NEW_COLUMN_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(4233920131410265.4903)
,p_prompt=>'Neuer Spaltentyp'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WORKSHEET_COLUMN_TYPES2'
,p_lov=>'.'||wwv_flow_api.id(38353412581019585.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Spaltentyp ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie den neuen Spaltentyp.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4235917061437778.4903)
,p_name=>'P91_DB_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(127798813633286291.4903)
,p_prompt=>'Db Column Name'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4238507121567312.4903)
,p_name=>'P91_COLUMN_TYPE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(127798813633286291.4903)
,p_prompt=>'Column Type'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_type',
'from wwv_flow_worksheet_columns',
'where db_column_name = :P91_DB_COLUMN_NAME',
'and worksheet_id = :p2_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(4241105389916880.4903)
,p_name=>'P91_FORMAT_MASK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(4233920131410265.4903)
,p_prompt=>unistr('Formatmaske zur Verwendung bei Spaltentyp\00E4nderungen')
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT MASK DYNAMIC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'from wwv_flow_format_masks'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie eine Formatmaske ein, die bei der \00C4nderung des Spaltentyps verwendet werden soll. Wenn Sie den Spaltentyp in Datum oder Zahl \00E4ndern, ist es wichtig, die Formatmaske einzugeben.  Andernfalls k\00F6nnte die \00C4nderung des Spaltentyps nicht erfolgre')
||'ich verlaufen.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4237821488533664.4903)
,p_validation_name=>'P91_NEW_COLUMN_TYPE not null'
,p_validation_sequence=>10
,p_validation=>'P91_NEW_COLUMN_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Der neue Spaltentyp muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(4234716106418588.4903)
,p_associated_item=>wwv_flow_api.id(4235631474432520.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(4238113438550220.4903)
,p_validation_name=>'old type not equal new type'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P91_COLUMN_TYPE = :P91_NEW_COLUMN_TYPE then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Der neue Spaltentyp muss sich vom alten Spaltentyp unterscheiden.'
,p_validation_condition=>'P91_NEW_COLUMN_TYPE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(4234716106418588.4903)
,p_associated_item=>wwv_flow_api.id(4235631474432520.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(186914619522722819.4903)
,p_validation_name=>'P91_NEW_COLUMN_TYPE max reached'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_api.max_col_limit_reached (',
'    p_worksheet_id   => :p2_id,',
'    p_column_type    => :P91_NEW_COLUMN_TYPE) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Die H\00F6chstanzahl der f\00FCr den Spaltentyp verf\00FCgbaren Spalten wurde erreicht. W\00E4hlen Sie einen anderen Spaltentyp.')
,p_validation_condition=>'replace(:P91_NEW_COLUMN_TYPE,''%''||''null%'') is not null and :P91_COLUMN_TYPE != :P91_NEW_COLUMN_TYPE'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(4234716106418588.4903)
,p_associated_item=>wwv_flow_api.id(4235631474432520.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00092
begin
wwv_flow_api.create_page(
 p_id=>92.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Kennwort zur\00FCcksetzen')
,p_step_title=>unistr('Kennwort zur\00FCcksetzen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-AppCards--slim .a-AppCards-icon {',
'    margin: 16px auto;',
'}',
'',
'h1.a-Login-title {',
'    font-size: 20px;',
'    margin: 24px 0;',
'}'))
,p_step_template=>wwv_flow_api.id(1418140425267007336.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(506060600392166972)
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(8557512241276654.4903)
,p_plug_name=>'Reset password Container'
,p_region_css_classes=>'a-Login-region a-Form--stretchInputs a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3700433754276.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_ws_applications ',
'where id = :WS_APP_ID'))
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1284871394951082007.4903)
,p_plug_name=>'Reset assword Header'
,p_parent_plug_id=>wwv_flow_api.id(8557512241276654.4903)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select',
'               wwv_flow_4000_ui.get_app_initials( name, id ) as app_initials,',
'               ''u-ColorBG--'' || to_char( ora_hash( name, 29 ) + 1 ) as app_color,',
'               name ws_name',
'           from  wwv_flow_ws_applications a',
'           where a.security_group_id = :flow_security_group_id',
'           and a.id = :ws_app_id)',
'loop',
'    sys.htp.p(''<div class="a-Login-header a-AppCards--slim">'');',
'    sys.htp.p(''  <span class="a-AppCards-icon a-AppCards-icon--initials ''||',
'              wwv_flow_escape.html(c1.app_color)||',
'              ''" role="presentation" aria-hidden="true">''||',
'              wwv_flow_escape.html(c1.app_initials)||',
'              ''</span>'');',
'    sys.htp.p(''  <h1 class="a-Login-title">''||wwv_flow_escape.html(c1.ws_name)||''</h1>'');',
'    sys.htp.p(''</div>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1418413115140401416.4903)
,p_plug_name=>'Reset password items'
,p_parent_plug_id=>wwv_flow_api.id(8557512241276654.4903)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1418149362592020763.4903)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(692442804709370101.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(1418413115140401416.4903)
,p_button_name=>'RESET_PASSWORD'
,p_button_action=>'SUBMIT'
,p_button_template_id=>wwv_flow_api.id(798473351219404350.4903)
,p_button_is_hot=>'Y'
,p_button_image_alt=>unistr('Kennwort zur\00FCcksetzen')
,p_button_position=>'NEXT'
,p_button_css_classes=>' a-Button--large'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(692442518084364512.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(1418413115140401416.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(798473351219404350.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(692443304148379348.4903)
,p_branch_action=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(692442804709370101.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(692437908116266949.4903)
,p_name=>'P92_EMAIL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1418413115140401416.4903)
,p_prompt=>'Die E-Mail-Adresse in unserer Datenbank'
,p_placeholder=>'E-Mail-Adresse'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(1418153120551046350.4903)
,p_item_css_classes=>'icon-login-email'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(692438611018277308.4903)
,p_name=>'P92_WORKSPACE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(1418413115140401416.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Geben Sie Ihren Workspace ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(693704031500021583.4903)
,p_name=>'P92_USERNAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1418413115140401416.4903)
,p_prompt=>'Benutzername'
,p_placeholder=>'Benutzername'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_api.id(1418153120551046350.4903)
,p_item_css_classes=>'icon-login-username'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(7293128029885669.4903)
,p_validation_name=>'is valid email and username'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_fnd_user u, wwv_flow_ws_applications w',
'where upper(u.email_address) = upper(:P92_EMAIL) and',
'      upper(u.user_name) = upper(:P92_USERNAME) and',
'      u.security_group_id != 10 and',
'      u.security_group_id = w.security_group_id and',
'      w.id = :WS_APP_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Sie haben einen falschen Benutzernamen oder eine falsche E-Mail-Adresse eingegeben.'
,p_when_button_pressed=>wwv_flow_api.id(692442804709370101.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(692443023410375451.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset Password'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_fnd_developer_api.f4900_reset_password (',
'  p_ws_app_id => :WS_APP_ID,',
'  p_user_name => :P92_USERNAME,',
'  p_email_address=> :P92_EMAIL,',
'  p_workspace_name=> null );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Zur\00FCcksetzen von Kennwort nicht m\00F6glich.')
,p_process_when_button_id=>wwv_flow_api.id(692442804709370101.4903)
,p_process_success_message=>unistr('Anforderung auf Zur\00FCcksetzen des Kennworts wurde zur Verarbeitung gesendet.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(693689731931002813.4903)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Determine Workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select security_group_id from wwv_flow_ws_applications where id = :WS_APP_ID) loop',
'    :P92_WORKSPACE := c1.security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00099
begin
wwv_flow_api.create_page(
 p_id=>99.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Nicht berechtigt'
,p_step_title=>'Nicht berechtigt'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456110204457776640.4903)
,p_plug_name=>'Not Authorized'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'<p>Sie sind nicht berechtigt, auf diese Anwendung oder Funktion zuzugreifen.</p>'
,p_translate_title=>'N'
,p_region_image=>'#IMAGE_PREFIX#menu/alarm_bell_wbg_64x64.png'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00101
begin
wwv_flow_api.create_page(
 p_id=>101.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Anmelden'
,p_alias=>'LOGIN'
,p_step_title=>'Websheets-Anmeldung'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-AppCards--slim .a-AppCards-icon { margin: 16px auto; }',
'h1.a-Login-title { font-size: 20px; margin: 24px 0; }',
'.a-Login-wsMsg { font-size: 14px; margin: 16px 8px; color: #707070; }',
'.a-Form-fieldContainer--hiddenLabel .apex-item-option {height: 16px;}'))
,p_step_template=>wwv_flow_api.id(1418140425267007336.4903)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1410890655888668019.4903)
,p_plug_name=>'Regionscontainer anmelden'
,p_region_css_classes=>'a-Login-region a-Form--stretchInputs a-Form--labelsAbove'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3700433754276.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(154773620917091162.4903)
,p_plug_name=>'Sign In items'
,p_parent_plug_id=>wwv_flow_api.id(1410890655888668019.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left; clear:both;"'
,p_plug_template=>wwv_flow_api.id(1418149362592020763.4903)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459631111530350735.4903)
,p_plug_name=>'Language Selector'
,p_parent_plug_id=>wwv_flow_api.id(1410890655888668019.4903)
,p_region_css_classes=>'a-Login-links a-Login-links--languages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(3700433754276.4903)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p( wwv_flow_lang.get_language_selector_list );'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_4000_ui.is_translation_installed( p_flow_id => 4000 )'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1410890754992668020.4903)
,p_plug_name=>'Sign In Region Header'
,p_parent_plug_id=>wwv_flow_api.id(1410890655888668019.4903)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select',
'               wwv_flow_4000_ui.get_app_initials( name, id ) as app_initials,',
'               ''u-ColorBG--'' || to_char( ora_hash( name, 29 ) + 1 ) as app_color,',
'               name ws_name',
'           from  wwv_flow_ws_applications a',
'           where a.security_group_id = :flow_security_group_id',
'           and a.id = :ws_app_id)',
'loop',
'    sys.htp.p(''<div class="a-Login-header a-AppCards--slim">'');',
'    sys.htp.p(''  <span class="a-AppCards-icon a-AppCards-icon--initials ''||',
'              wwv_flow_escape.html(c1.app_color)||',
'              ''" role="presentation" aria-hidden="true">''||',
'              wwv_flow_escape.html(c1.app_initials)||',
'              ''</span>'');',
'    sys.htp.p(''  <h1 class="a-Login-title">''||wwv_flow_escape.html(c1.ws_name)||''</h1>'');',
'    for l_msg in (select login_page_message ',
'                  from WWV_FLOW_WS_APPLICATIONS ',
'                  where id = :WS_APP_ID',
'                  and login_page_message is not null )',
'    loop',
'        sys.htp.p(''<p class="a-Login-wsMsg">''||wwv_flow_escape.html(l_msg.login_page_message)||''</p>'');',
'    end loop;',
'    sys.htp.p(''</div>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(61034832101787205.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(154773620917091162.4903)
,p_button_name=>'RESET_PASSWORD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>unistr('Kennwort zur\00FCcksetzen')
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:::'
,p_button_condition=>'return wwv_flow_ws_api.show_reset_password (p_ws_app_id=>:WS_APP_ID);'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(5698501044727837.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(154773620917091162.4903)
,p_button_name=>'LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(798473351219404350.4903)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Anmelden'
,p_button_position=>'NEXT'
,p_button_css_classes=>'a-Button--large'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154773716538091162.4903)
,p_name=>'P101_USERNAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(154773620917091162.4903)
,p_prompt=>'Benutzername'
,p_placeholder=>'Benutzername'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>128
,p_field_template=>wwv_flow_api.id(1418153120551046350.4903)
,p_item_css_classes=>'icon-login-username'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154773815685091162.4903)
,p_name=>'P101_PASSWORD'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(154773620917091162.4903)
,p_prompt=>'Kennwort'
,p_placeholder=>'Kennwort'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>40
,p_cMaxlength=>100
,p_field_template=>wwv_flow_api.id(1418153120551046350.4903)
,p_item_css_classes=>'icon-login-password'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(216990508511910211.4903)
,p_name=>'P101_REMEMBER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(154773620917091162.4903)
,p_prompt=>'Benutzername speichern'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REMEMBER_USERNAME'
,p_lov=>'.'||wwv_flow_api.id(263997216503587205.4903)||'.'
,p_field_template=>wwv_flow_api.id(264000229814622656.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Wenn Sie dieses Kontrollk\00E4stchen aktivieren, speichert das Websheet Ihren Benutzernamen in einem dauerhaften Browsercookie namens "LOGIN_USERNAME_COOKIE".'),
unistr('Beim n\00E4chsten Aufruf der Anmeldeseite'),
unistr('wird das Benutzernamenfeld automatisch mit diesem Wert gef\00FCllt.'),
'</p>',
'<p>',
unistr('Wenn Sie dieses Kontrollk\00E4stchen deaktivieren und Ihr Benutzername bereits im Cookie gespeichert wurde,'),
unistr('\00FCberschreibt das Websheet ihn mit einem leeren Wert.'),
unistr('Sie k\00F6nnen auch die Entwicklertools des Browsers verwenden, um das Cookie komplett zu entfernen.'),
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(388700621118310671.4903)
,p_name=>'P101_BUILDER_SESSION_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(154773620917091162.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_security.get_builder_session_id'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_source=>'wwv_flow_security.get_builder_session_id'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(10356803620488362.4903)
,p_validation_name=>'P101_USERNAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P101_USERNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Wert muss angegeben werden.'
,p_associated_item=>wwv_flow_api.id(154773716538091162.4903)
,p_error_display_location=>'INLINE_WITH_FIELD'
,p_validation_comment=>'generated 09-OCT-2008 14:47'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(10357031948488372.4903)
,p_validation_name=>'P101_PASSWORD Not Null'
,p_validation_sequence=>20
,p_validation=>'P101_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Wert muss angegeben werden.'
,p_associated_item=>wwv_flow_api.id(154773815685091162.4903)
,p_error_display_location=>'INLINE_WITH_FIELD'
,p_validation_comment=>'generated 09-OCT-2008 14:47'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154774114072091162.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_authentication.send_login_username_cookie (',
'    p_username => :P101_USERNAME,',
'    p_consent  => :P101_REMEMBER = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154774006644091162.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_custom_auth_std.ws_login(',
'    P_UNAME            => :P101_USERNAME,',
'    P_PASSWORD         => :P101_PASSWORD,',
'    P_SESSION_ID       => v(''APP_SESSION''),',
'    P_WEBSHEET_APP_ID  => :WS_APP_ID,',
'    p_websheet_page_id => :P900_ID );'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154774302570091162.4903)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Page(s) Cache'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'101'
,p_process_when=>'P101_REGION'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(154774210215091162.4903)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Username Cookie'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P101_USERNAME := apex_authentication.get_login_username_cookie;',
':P101_REMEMBER := case when :P101_USERNAME is not null then ''Y'' end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P101_USERNAME is null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
end;
/
prompt --application/pages/page_00102
begin
wwv_flow_api.create_page(
 p_id=>102.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Feedback'
,p_alias=>'FEEDBACK'
,p_step_title=>'Feedback'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(134255203486851095.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_page_comment=>'This page was generated by the feedback wizard'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(203493217304049113.4903)
,p_plug_name=>'Feedback'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(82536903857665765.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(752334827869677901.4903)
,p_plug_name=>unistr('Schaltfl\00E4chenregion')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203497828051049124.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(752334827869677901.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(203497606057049122.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(752334827869677901.4903)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>'Feedback weiterleiten'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203493400295049114.4903)
,p_name=>'P102_APPLICATION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4903)
,p_prompt=>'Anwendung'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>60
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203494014853049116.4903)
,p_name=>'P102_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4903)
,p_prompt=>'Seite'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>60
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Seite innerhalb der Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203494614905049117.4903)
,p_name=>'P102_A'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4903)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203494830875049118.4903)
,p_name=>'P102_FEEDBACK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4903)
,p_prompt=>'Feedback'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Geben Sie Ihr Feedback ein, und klicken Sie auf die Schaltfl\00E4che "Feedback senden".')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203495425757049118.4903)
,p_name=>'P102_X'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4903)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203495625923049119.4903)
,p_name=>'P102_FEEDBACK_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4903)
,p_prompt=>'Feedbacktyp'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select the_name, id from WWV_FLOW_FEEDBACK_TYPES order by id'
,p_cSize=>20
,p_cMaxlength=>100
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie an, um welche Art von Feedback es sich handelt.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203496204433049120.4903)
,p_name=>'P102_Y'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4903)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_item_comment=>'workspace 10'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203496432737049121.4903)
,p_name=>'P102_ATTRIBUTE1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4903)
,p_prompt=>'Komponente:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'FEEDBACK_COMPONENT'
,p_lov=>'.'||wwv_flow_api.id(945870019196474793.4903)||'.'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Geben Sie die folgenden Informationen an, die als Feedback protokolliert werden.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(203497005770049121.4903)
,p_name=>'P102_ATTRIBUTE2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(203493217304049113.4903)
,p_prompt=>'Attribut 2'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Geben Sie die folgenden Informationen an, die als Feedback protokolliert werden.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(203498000886049124.4903)
,p_validation_name=>'Feedback not null'
,p_validation_sequence=>10
,p_validation=>'P102_FEEDBACK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Wert muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(203497606057049122.4903)
,p_associated_item=>wwv_flow_api.id(203494830875049118.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(203498223414049125.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Submit Feedback'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex_util.submit_feedback (',
'    p_comment         => :P102_FEEDBACK,',
'    p_type            => :P102_FEEDBACK_TYPE,',
'    p_application_id     => :P102_APPLICATION_ID,',
'    p_page_id         => :P102_PAGE_ID,',
'    p_label_01        => ''Component'',',
'    p_label_02        => ''Contact me via email'',',
'    p_attribute_01   => :P102_ATTRIBUTE1,',
'    p_attribute_02   => :P102_ATTRIBUTE2);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(203497606057049122.4903)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(203498403008049126.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Window'
);
end;
/
prompt --application/pages/page_00131
begin
wwv_flow_api.create_page(
 p_id=>131.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Seite erstellen'
,p_step_title=>'Seite erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20820515633073398.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173220910407622558.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173221309115622593.4903)
,p_plug_name=>'Erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173227111911856634.4903)
,p_plug_name=>'create page progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(29874807106517169.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(173233928842908830.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20820515633073398.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(173234125942908830.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20820515633073398.4903)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4903)
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(173234507156912066.4903)
,p_branch_action=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:205::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P131_PAGE_TYPE'
,p_branch_condition_text=>'DATA'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(181302519582692237.4903)
,p_branch_action=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.:1310,1320::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(173234125942908830.4903)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P131_PAGE_TYPE'
,p_branch_condition_text=>'REPORT'
,p_save_state_before_branch_yn=>'Y'
,p_security_scheme=>wwv_flow_api.id(495860932509802714)
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173236415514942802.4903)
,p_name=>'P131_PAGE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(173221309115622593.4903)
,p_item_default=>'TEXT'
,p_prompt=>unistr('Welchen Datenkomponententyp m\00F6chten Sie erstellen?')
,p_source=>'DATA'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE DATA OR REPORT'
,p_lov=>'.'||wwv_flow_api.id(173236520362944199.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('W\00E4hlen Sie den zu erstellenden Datenkomponententyp.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00140
begin
wwv_flow_api.create_page(
 p_id=>140.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Aktivit\00E4t \00FCberwachen')
,p_step_title=>unistr('Aktivit\00E4t \00FCberwachen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187174414157946457.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459635018791429050.4903)
,p_plug_name=>unistr('Aktivit\00E4t')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:49%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(459634320543429042.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460619812376871783.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Verwenden Sie diese Seiten, um die Verwendung, Performance und Beliebtheit von Seiten und Inhalten zu analysieren.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461180329066335897.4903)
,p_plug_name=>'Annotationen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:49%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(11269620137104105.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(461178801985335895.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
);
end;
/
prompt --application/pages/page_00141
begin
wwv_flow_api.create_page(
 p_id=>141.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Topdaten-Grids'
,p_step_title=>'Topdaten-Grids'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23764728224473605.4903)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23764905998473606.4903)
,p_plug_name=>'Monitor Activity Tab'
,p_parent_plug_id=>wwv_flow_api.id(23764728224473605.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23689225706066046.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23765115127473607.4903)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(23764728224473605.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>210
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461236028506810793.4903)
,p_plug_name=>'Page Views'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   (select max(WEBSHEET_NAME)',
'       from WWV_FLOW_WS_WEBSHEET_ATTR p',
'       where p.ws_app_id = :ws_app_id',
'       and p.id = l.DATAGRID_ID) data_grid_name,',
'    count(*) page_views,',
'    avg(elap) elap,',
'    avg(num_rows) num_rows,',
'    count(distinct userid) userid,',
'    avg(content_length) CONTENT_LENGTH',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - nvl(:P141_TIME,1)) and',
'    ( flow_id = 4900 ) and',
'    websheet_id = :ws_app_id and',
'    DATAGRID_ID is not null and',
'    datagrid_id in (select id from WWV_FLOW_WS_WEBSHEET_ATTR where ws_app_id = :ws_app_id and WEBSHEET_TYPE = ''DATA'')',
'group by     l.DATAGRID_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(461236228917810797.4903)
,p_name=>'Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461236316065810801.4903)
,p_db_column_name=>'ELAP'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Durchschnittliche Wiedergabezeit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461236430570810802.4903)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Durchschnittliche Zeilen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461236514063810802.4903)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>unistr('Durchschnittliche Inhaltsl\00E4nge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461236710411810802.4903)
,p_db_column_name=>'USERID'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Eindeutige Benutzer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461236829739810802.4903)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461242409753848980.4903)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'Daten-Grid-Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461330100756322323.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(461237306673810811.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(461236028506810793.4903)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:141:&SESSION.::&DEBUG.:141,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461237501740810812.4903)
,p_name=>'P141_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23765115127473607.4903)
,p_item_default=>'1'
,p_prompt=>'Zeitrahmen'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Berichtdaten innerhalb des ausgew\00E4hlten Berichtzeitrahmens anzeigen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
end;
/
prompt --application/pages/page_00142
begin
wwv_flow_api.create_page(
 p_id=>142.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Topberichte'
,p_step_title=>'Topberichte'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23768425584482295.4903)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23768620004482297.4903)
,p_plug_name=>'Monitor Activity Tab'
,p_parent_plug_id=>wwv_flow_api.id(23768425584482295.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23689225706066046.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23768808968482297.4903)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(23768425584482295.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>210
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461244005589858615.4903)
,p_plug_name=>'Page Views'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   (select max(WEBSHEET_NAME)',
'       from WWV_FLOW_WS_WEBSHEET_ATTR p',
'       where p.ws_app_id = :ws_app_id',
'       and p.id = l.DATAGRID_ID) data_grid_name,',
'    count(*) page_views,',
'    avg(elap) elap,',
'    avg(num_rows) num_rows,',
'    count(distinct userid) userid,',
'    avg(content_length) CONTENT_LENGTH',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - nvl(:P142_TIME,1)) and',
'    ( flow_id = 4900 ) and',
'    websheet_id = :ws_app_id and',
'    DATAGRID_ID is not null and',
'    datagrid_id in (select id from WWV_FLOW_WS_WEBSHEET_ATTR where ws_app_id = :ws_app_id and WEBSHEET_TYPE = ''REPORT'')',
'group by     l.DATAGRID_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(461244219249858616.4903)
,p_name=>'Page Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244423593858617.4903)
,p_db_column_name=>'ELAP'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Durchschnittliche Wiedergabezeit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244509013858617.4903)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Durchschnittliche Zeilen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244618067858617.4903)
,p_db_column_name=>'CONTENT_LENGTH'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>unistr('Durchschnittliche Inhaltsl\00E4nge')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244716297858617.4903)
,p_db_column_name=>'USERID'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Eindeutige Benutzer'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244806456858617.4903)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461244320248858616.4903)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'Daten-Grid-Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461331213223325868.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(461245330336858618.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(461244005589858615.4903)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:142:&SESSION.::&DEBUG.:142,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461245523336858619.4903)
,p_name=>'P142_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23768808968482297.4903)
,p_item_default=>'1'
,p_prompt=>'Zeitrahmen'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Berichtdaten innerhalb des ausgew\00E4hlten Berichtzeitrahmens anzeigen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
end;
/
prompt --application/pages/page_00143
begin
wwv_flow_api.create_page(
 p_id=>143.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Topdateien'
,p_step_title=>'Topdateien'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471901413752065160.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471907103870125733.4903)
,p_plug_name=>'Top Files by User'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       c009 created_by,',
'       count(*) c,',
'       sum(decode(greatest(d002,sysdate-1),sysdate-1,0,1)) last_day,',
'       sum(decode(greatest(d002,sysdate-7),sysdate-7,0,1)) created_last_7_days,',
'       sum(decode(greatest(d002,add_months(sysdate,-1)),add_months(sysdate,-1),0,1)) last_month,',
'       apex_util.get_since(max(d002)) most_recent',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_FILES''',
'group by c009'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(471907203619125733.4903)
,p_name=>'Top Files by User'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471907430015125742.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Benutzername'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471907510799125744.4903)
,p_db_column_name=>'C'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anzahl Dateien'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471909222611156826.4903)
,p_db_column_name=>'CREATED_LAST_7_DAYS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Letzte Woche'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471909706596171166.4903)
,p_db_column_name=>'LAST_MONTH'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Letzter Monat'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471910003957179869.4903)
,p_db_column_name=>'LAST_DAY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Letzter Tag'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471914803012236331.4903)
,p_db_column_name=>'MOST_RECENT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Letzte'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473412104980505809.4903)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23795705639561731.4903)
,p_plug_name=>'Admin Annotation Tab'
,p_parent_plug_id=>wwv_flow_api.id(473412104980505809.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23775330395531080.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(473412314903505852.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(471907103870125733.4903)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:143:&SESSION.::&DEBUG.:143,RIR::'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471901910350068155.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>'wwv_flow_ws_api.create_attachment_collection (p_ws_app_id    => :ws_app_id);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00144
begin
wwv_flow_api.create_page(
 p_id=>144.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Tophinweise'
,p_step_title=>'Tophinweise'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471902911012084490.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471912413500212406.4903)
,p_plug_name=>'Top Notes by Username'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   c003 created_by,',
'   count(*) new_notes,',
'   sum(decode(greatest(d001,sysdate-1),sysdate-1,0,1)) last_day,',
'   sum(decode(greatest(d001,sysdate-7),sysdate-7,0,1)) created_last_7_days,',
'   sum(decode(greatest(d001,add_months(sysdate,-1)),add_months(sysdate,-1),0,1)) last_month,',
'   apex_util.get_since(max(d001)) most_recent',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_NOTES''',
'group by c003'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(471912507778212406.4903)
,p_name=>'Top Notes by Username'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471912706310212408.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Benutzername'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471912829080212409.4903)
,p_db_column_name=>'NEW_NOTES'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Anzahl Hinweise'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471913913139220374.4903)
,p_db_column_name=>'LAST_DAY'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Letzter Tag'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471914029231220374.4903)
,p_db_column_name=>'CREATED_LAST_7_DAYS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Letzte Woche'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471914113108220376.4903)
,p_db_column_name=>'LAST_MONTH'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Letzter Monat'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471914307729228250.4903)
,p_db_column_name=>'MOST_RECENT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Letzte'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473415025889521297.4903)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>3
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23814902438579759.4903)
,p_plug_name=>'Admin Annotation Tab'
,p_parent_plug_id=>wwv_flow_api.id(473415025889521297.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23775330395531080.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(473416325674530692.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(471912413500212406.4903)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:144:&SESSION.::&DEBUG.:144,RIR::'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471912009760200442.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_note_collection (',
'    p_ws_app_id => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00145
begin
wwv_flow_api.create_page(
 p_id=>145.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Top-Tags'
,p_step_title=>'Top-Tags'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23816101530588971.4903)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23816319486588973.4903)
,p_plug_name=>'Admin Annotation Tab'
,p_parent_plug_id=>wwv_flow_api.id(23816101530588971.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23775330395531080.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471904015280093887.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471905601524103473.4903)
,p_plug_name=>'Tag Cloud'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_webpage.show_tag_clouds (',
'    p_ws_app_id             => :ws_app_id,    ',
'    p_session_id            => :app_session);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
end;
/
prompt --application/pages/page_00146
begin
wwv_flow_api.create_page(
 p_id=>146.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Topbenutzer'
,p_step_title=>'Topbenutzer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23771705892505054.4903)
,p_plug_name=>'Action Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23771903817505055.4903)
,p_plug_name=>'Monitor Activity Tab'
,p_parent_plug_id=>wwv_flow_api.id(23771705892505054.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(23689225706066046.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(23772114743505056.4903)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(23771705892505054.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>210
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471916808921272522.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471919230020311098.4903)
,p_plug_name=>'Top Users'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    userid,',
'    count(*) page_views,',
'    count(distinct webpage_id) distinct_pages,',
'   sum(CONTENT_LENGTH) content_served,',
'   sum(num_rows) rows_served,',
'   sum(elap) page_generation_time',
'from WWV_FLOW_ACTIVITY_LOG l',
'where security_group_id = :flow_security_group_id and',
'    (time_stamp > sysdate - :P146_TIME) and',
'    ( flow_id = 4900 ) and',
'    websheet_id = :ws_app_id',
'group by userid'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(471919303440311098.4903)
,p_name=>'Top Users'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471919508010311100.4903)
,p_db_column_name=>'USERID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Benutzer'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471919604537311100.4903)
,p_db_column_name=>'PAGE_VIEWS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Seitenansichten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471919731265311100.4903)
,p_db_column_name=>'DISTINCT_PAGES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Eindeutige Seiten'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471919900949311100.4903)
,p_db_column_name=>'CONTENT_SERVED'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Bearbeiteter Inhalt'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471920018399311101.4903)
,p_db_column_name=>'ROWS_SERVED'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Bearbeitete Zeilen'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(471920105353311101.4903)
,p_db_column_name=>'PAGE_GENERATION_TIME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>unistr('Zeit f\00FCr Seitenerstellung')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990D99'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472158913824081267.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(471919230020311098.4903)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:146:&SESSION.::&DEBUG.:146,RIR::'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472159121381081270.4903)
,p_name=>'P146_TIME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(23772114743505056.4903)
,p_item_default=>'1'
,p_prompt=>'Zeitrahmen'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TIMEFRAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,  trim(rtrim(to_char(t,''9999D999999'',''NLS_NUMERIC_CHARACTERS=''''.,''''''),''0.'')) t',
'from (',
'select ''10 ''||wwv_flow_lang.system_message(''SECONDS'') d, 10/(24*60*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''MINUTE'') d, 1/(24*60) t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''MINUTES'') d, 5/(24*60) t from dual union all',
'select ''15 ''||wwv_flow_lang.system_message(''MINUTES'') d, 15/(24*60) t from dual union all',
'select ''30 ''||wwv_flow_lang.system_message(''MINUTES'') d, 30/(24*60) t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''HOUR'') d, 1/24 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''HOURS'') d, 1/12  t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''HOURS'') d, 3/24  t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''HOURS'') d, 4/24  t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''HOURS'') d, 6/24 t from dual union all',
'select ''8 ''||wwv_flow_lang.system_message(''HOURS'') d, 8/24 t from dual union all',
'select ''12 ''||wwv_flow_lang.system_message(''HOURS'') d, 12/24 t from dual union all',
'select ''18 ''||wwv_flow_lang.system_message(''HOURS'') d, 18/24 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''DAY'') d, 1 t from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''DAYS'') d, 2 t from dual union all',
'select ''3 ''||wwv_flow_lang.system_message(''DAYS'') d, 3 t from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''DAYS'') d, 4 t from dual union all',
'select ''5 ''||wwv_flow_lang.system_message(''DAYS'') d, 5 t from dual union all',
'select ''6 ''||wwv_flow_lang.system_message(''DAYS'') d, 6 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''WEEK'') d, 7 t  from dual union all',
'select ''2 ''||wwv_flow_lang.system_message(''WEEKS'') d, 14 t  from dual union all',
'select ''4 ''||wwv_flow_lang.system_message(''WEEKS'') d, 28 t from dual union all',
'select ''1 ''||wwv_flow_lang.system_message(''YEAR'') d, 365 t from dual order by 2',
') q'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Berichtdaten innerhalb des ausgew\00E4hlten Berichtzeitrahmens anzeigen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
end;
/
prompt --application/pages/page_00200
begin
wwv_flow_api.create_page(
 p_id=>200.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Seite erstellen'
,p_step_title=>'Seite erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(1198430386542478.4903)
,p_plug_name=>'Seite erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(11464130252463090.4903)
,p_plug_name=>unistr('Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436570726052138706.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_PAGE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154880404371674336.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(11464130252463090.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154880603784674338.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(11464130252463090.4903)
,p_button_name=>'create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Seite erstellen'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(155398607371684404.4903)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173712624517222880.4903)
,p_name=>'P200_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(1198430386542478.4903)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie einen Seitennamen an. Der Seitenname wird im Fenstertitel und im Navigationspfad angezeigt.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174369210872944115.4903)
,p_name=>'P200_PARENT_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(1198430386542478.4903)
,p_prompt=>unistr('\00DCbergeordnete Seite')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEXT WEBSHEETS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from   wwv_flow_ws_webpages',
'where security_group_id = :flow_security_group_id and',
'      ws_app_id = :WS_APP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- \00DCbergeordnete Seite ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Wenn diese Seite Teil einer Seitenhierarchie ist, w\00E4hlen Sie die \00FCbergeordnete Seite.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458468714942046990.4903)
,p_name=>'P200_PAGE_ALIAS'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(1198430386542478.4903)
,p_prompt=>'Seitenalias'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Geben Sie den Seitenalias an. Mit diesem Seitenalias k\00F6nnen Sie eine Verkn\00FCpfung zu dieser Seite vornehmen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(458480527802429176.4903)
,p_validation_name=>'P200_PAGE_ALIAS must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P200_PAGE_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_alias        => :P200_PAGE_ALIAS,',
'    p_alias_type   => ''PAGE'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Seitenalias bereits vorhanden. Geben Sie einen anderen Alias ein.'
,p_when_button_pressed=>wwv_flow_api.id(154880603784674338.4903)
,p_associated_item=>wwv_flow_api.id(458468714942046990.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(513405225400857985.4903)
,p_validation_name=>'P200_PAGE_ALIAS is valid'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P200_PAGE_ALIAS is not null and not wwv_flow_ws_api.is_alphanumeric (p_str => :P200_PAGE_ALIAS) then',
'    return wwv_flow_lang.system_message(''WS_ALIAS_NOT_VALID'');',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_when_button_pressed=>wwv_flow_api.id(154880603784674338.4903)
,p_associated_item=>wwv_flow_api.id(458468714942046990.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(173742624666383777.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ceate page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_webpage_id number := null;',
'begin',
'    l_webpage_id := wwv_flow_id.next_val;',
'    ',
'    wwv_flow_ws_api.create_webpage (',
'        p_webpage_id      => l_webpage_id,',
'        p_ws_app_id       => :WS_APP_ID,',
'        p_name            => :P200_NAME,',
'        p_page_alias      => :P200_PAGE_ALIAS,',
'        p_description     => null,',
'        p_parent_page_id  => replace(:P200_PARENT_PAGE,''%''||''null%'')',
'        );',
'        ',
'    :P900_ID := l_webpage_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Seite kann nicht erstellt werden.'
,p_process_success_message=>'Seite erstellt.'
);
end;
/
prompt --application/pages/page_00201
begin
wwv_flow_api.create_page(
 p_id=>201.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Daten-Grid erstellen'
,p_step_title=>'Daten-Grid erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function addTableRow2(pThis,pThat,pNum){',
'    //console.log(pThat);',
'    var tt = html_GetElement(pThat);',
'        tt = tt.getElementsByTagName("tbody")[0];',
'    var l_newRows = new Array();',
'    for(i=0;i<pNum;i++){',
'      var ogTR = tt.rows[tt.rows.length -1];',
'      var trClone = ogTR.cloneNode(true);',
'      if(document.all){',
'        myNewRow = tt.insertRow(tt.rows.length);',
'        oReplace = myNewRow.replaceNode(trClone);',
'      }else{',
'        tt.appendChild(trClone);',
'      }',
'      l_newRows[l_newRows.length] = trClone;',
'      ',
'      var tSelects = trClone.getElementsByTagName(''select'');',
'      for(var iSelects=0;iSelects<tSelects.length;iSelects++){',
'          tSelects[iSelects].selectedIndex = 0;',
'          tSelects[iSelects].disabled="";',
'       }',
'      var tInputs = trClone.getElementsByTagName(''input'');',
'      for(var iInputs=0;iInputs<tInputs.length;iInputs++){',
'        if(tInputs[iInputs].type=="text"){',
'        tInputs[iInputs].value="";',
'        tInputs[iInputs].disabled="";',
'        }',
'      }',
'    }',
'    return l_newRows;',
'}',
'',
'/*Add table row for add column*/',
'function ob_TableAddColumn(pThis,pThat,pNum){     ',
'  var newRows = addTableRow2(pThis,pThat,pNum);',
'  for (var i = 0;i<newRows.length;i++){',
'    var l_Inputs = newRows[i].getElementsByTagName(''input'');',
'    html_HiddenElement(l_Inputs[1]);',
'    html_HiddenElement(l_Inputs[2]);',
'  }',
'}',
'',
'var gLastRowMovedColor = ''#FFF'';'))
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20777514043457891.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21434717060303392.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29893532414751568.4903)
,p_plug_name=>'create page progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(29874807106517169.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(85200421058598337.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(161567019228946315.4903)
,p_plug_name=>'Daten-Grid erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'wwv_flow_ws_ui.p201_define_data_grid_columns;'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(161624313556285232.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(161567019228946315.4903)
,p_button_name=>'ADD_COLUMN'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('Spalte hinzuf\00FCgen')
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'javascript:ob_TableAddColumn(this,''htmldbNewTable'',1);'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154889406934794672.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20777514043457891.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(154889228692794671.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20777514043457891.4903)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Daten-Grid erstellen'
,p_button_position=>'CREATE'
,p_button_condition=>'P201_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3021502937237873.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20777514043457891.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(459284513339156315.4903)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:201:WS_APP_ID,P2_ID,P2_WEBSHEET_ID:&WS_APP_ID.,&P201_WORKSHEET_ID.,&P201_WEBSHEET_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(154889228692794671.4903)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2691129726790817.4903)
,p_name=>'P201_PAGE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'2'
,p_prompt=>'Page ID'
,p_source=>'PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154889802826794677.4903)
,p_name=>'P201_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154890025030794679.4903)
,p_name=>'P201_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4903)
,p_source=>'APP_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(154890421381794680.4903)
,p_name=>'P201_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(161567019228946315.4903)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie einen Daten-Grid-Namen ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161620030694252400.4903)
,p_name=>'P201_COL_ORDER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161745022194836488.4903)
,p_name=>'P201_NEW_WORKSHEET_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458477720127322928.4903)
,p_name=>'P201_ALIAS'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(161567019228946315.4903)
,p_prompt=>'Alias'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Geben Sie einen Daten-Grid-Alias an. Mit diesem Alias k\00F6nnen Sie einen Link zu diesem Daten-Grid innerhalb von Seitenabschnitten erstellen. Ein Daten-Grid-Alias muss innerhalb einer Anwendung eindeutig sein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459283706282144844.4903)
,p_name=>'P201_WORKSHEET_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459283912425144845.4903)
,p_name=>'P201_WEBSHEET_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(21434717060303392.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154890305337794680.4903)
,p_validation_name=>'P201_FLOW_ID not null'
,p_validation_sequence=>10
,p_validation=>'P201_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Flow-ID muss einen Wert haben.'
,p_associated_item=>wwv_flow_api.id(154890025030794679.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(154890725984794680.4903)
,p_validation_name=>'P201_NAME not null'
,p_validation_sequence=>20
,p_validation=>'P201_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name muss angegeben werden.'
,p_associated_item=>wwv_flow_api.id(154890421381794680.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(8647014897469438.4903)
,p_validation_name=>'column must be defined'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  if wwv_flow.g_f01(i) is null then',
'    if i = 1 then',
'      return false;',
'    end if;',
'  end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Es m\00FCssen Websheet-Spalten definiert werden.')
,p_when_button_pressed=>wwv_flow_api.id(154889228692794671.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(458488820108521527.4903)
,p_validation_name=>'P201_ALIAS must be unique'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P201_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_alias        => :P201_ALIAS,',
'    p_alias_type   => ''DATA_GRID'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Alias bereits vorhanden. Geben Sie einen anderen Alias ein.'
,p_associated_item=>wwv_flow_api.id(458477720127322928.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(660056428068767360.4903)
,p_validation_name=>'P201_NAME must be unique'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P201_NAME is not null then',
'  if wwv_flow_ws_api.websheet_name_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_name         => :P201_NAME,',
'    p_type         => ''DATA'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Der Daten-Grid-Name ist bereits vorhanden. Geben Sie einen anderen Namen ein.'
,p_associated_item=>wwv_flow_api.id(154890421381794680.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(865527713121965593.4903)
,p_validation_name=>'duplicate column name found'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_api.duplicate_found_in_array (    ',
'    p_array => wwv_flow.g_f01) then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Doppelte Spaltennamen ermittelt. Spaltenname muss eindeutig sein.'
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(506158920514422820.4903)
,p_validation_name=>'P201_ALIAS is valid'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P201_ALIAS is not null and not wwv_flow_ws_api.is_alphanumeric (p_str => :P201_ALIAS) then',
'    return wwv_flow_lang.system_message(''WS_ALIAS_NOT_VALID'');',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_associated_item=>wwv_flow_api.id(458477720127322928.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(169327811698892928.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  r varchar2(255) := null;',
'  c pls_integer;',
'begin',
'for i in 1..12 loop',
'select  count(*) into c',
'from  wwv_flow_ws_websheet_attr w',
'where security_group_id = :flow_security_group_id and',
'websheet_name = upper(:app_user)||'' 0''||i;',
'if c = 0 then',
'   r := upper(:app_user)||'' 0''||i;',
'   exit;',
'end if;',
'end loop;',
':P201_NAME := r;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P201_NAME'
,p_process_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(161740023102827299.4903)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Data Grid'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_data_grid_from_scratch (',
'    p_ws_app_id     => :WS_APP_ID,',
'    p_name          => :P201_NAME,',
'    p_alias         => :P201_ALIAS,',
'    p_column_order  => :P201_COL_ORDER,',
'    p_worksheet_id  => :P201_WORKSHEET_ID,',
'    p_websheet_id   => :P201_WEBSHEET_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Daten-Grid konnte nicht erstellt werden.'
,p_process_when_button_id=>wwv_flow_api.id(154889228692794671.4903)
,p_process_success_message=>'Daten-Grid erstellt.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(23550931764462326.4903)
,p_process_sequence=>50
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save user input in collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(p_collection_name => ''WS_WIZ_COLUMNS'');',
'    ',
'wwv_flow_collection.add_members (',
'   p_collection_name => ''WS_WIZ_COLUMNS'',',
'   p_c001            => wwv_flow.g_f01,',
'   p_c002            => wwv_flow.g_f02);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Benutzereingabe kann nicht gespeichert werden'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(154889228692794671.4903)
);
end;
/
prompt --application/pages/page_00205
begin
wwv_flow_api.create_page(
 p_id=>205.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Daten-Grid erstellen'
,p_step_title=>'Daten-Grid erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(2981808413059759.4903)
,p_plug_name=>'Daten-Grid erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Mit Daten-Grids werden die von Ihrer Anwendung verwendeten Daten verwaltet. W\00E4hlen Sie aus, wie Sie Ihr Daten-Grid erstellen m\00F6chten.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20775629580434005.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29886309287650228.4903)
,p_plug_name=>'create page progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(29874807106517169.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(85198200626592456.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157356222063249657.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20775629580434005.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157356622290249657.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20775629580434005.4903)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4903)
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157356416282249657.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20775629580434005.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(157369302417300714.4903)
,p_branch_action=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:201,WS_WIZ_COLUMNS::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P205_CREATE'
,p_branch_condition_text=>'SCRATCH'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(157374926444317137.4903)
,p_branch_action=>'f?p=&APP_ID.:206:&SESSION.::&DEBUG.:206,CLOB_CONTENT::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P205_CREATE'
,p_branch_condition_text=>'CUTANDPASTE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(2962827104989463.4903)
,p_name=>'P205_CREATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(2981808413059759.4903)
,p_item_default=>'SCRATCH'
,p_source=>'SCRATCH'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE WORKSHEET OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(2960208403984068.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00206
begin
wwv_flow_api.create_page(
 p_id=>206.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Daten-Grid erstellen'
,p_step_title=>'Daten-Grid erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(157592926751064610)
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20782013444514508.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21432216236293657.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(29895108135791796.4903)
,p_plug_name=>'create websheet progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(29874807106517169.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(87067600442889007.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(157402130664498141.4903)
,p_plug_name=>'Arbeitsblatt hochladen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>unistr('<p>Arbeitsblatt oder durch Tabulator getrennte Daten unten einf\00FCgen.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157412930927517115.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20782013444514508.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(157412021923514509.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20782013444514508.4903)
,p_button_name=>'UPLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Hochladen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(3019823238234313.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20782013444514508.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(188356618124649439.4903)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::WS_APP_ID,P2_ID,P2_WEBSHEET_ID:&WS_APP_ID.,&P206_WORKSHEET_ID.,&P206_WEBSHEET_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(157415007986529400.4903)
,p_name=>'P206_WORKSHEET_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(157402130664498141.4903)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_cattributes_element=>'width="100%"'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Daten-Grid-Namen ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(161542600584694900.4903)
,p_name=>'P206_COLUMN_HEADINGS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(157402130664498141.4903)
,p_item_default=>'Y'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'FIRST_ROW_CONTAINS_COLUMN_HEADINGS'
,p_lov=>'.'||wwv_flow_api.id(799517811838484369.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(162619632484627537.4903)
,p_name=>'P206_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(21432216236293657.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(399301229989054252.4903)
,p_name=>'P206_SPREADSHEET'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(157402130664498141.4903)
,p_prompt=>unistr('Arbeitsblattdaten einf\00FCgen')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>15
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'spellcheck="false"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Kopieren Sie die gew\00FCnschten Daten aus einem Tabellenkalkulationsprogramm, und f\00FCgen Sie sie ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458479616018350127.4903)
,p_name=>'P206_WORKSHEET_ALIAS'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(157402130664498141.4903)
,p_prompt=>'Alias'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Geben Sie einen Daten-Grid-Alias an. Mit diesem Alias k\00F6nnen Sie einen Link zu diesem Daten-Grid innerhalb von Seitenabschnitten erstellen. Ein Daten-Grid-Alias muss innerhalb einer Anwendung eindeutig sein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459294712047212712.4903)
,p_name=>'P206_WORKSHEET_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(21432216236293657.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459294929831212712.4903)
,p_name=>'P206_WEBSHEET_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(21432216236293657.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(458491521409540890.4903)
,p_validation_name=>'P206_WORKSHEET_ALIAS must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P206_WORKSHEET_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_alias        => :P206_WORKSHEET_ALIAS,',
'    p_alias_type   => ''DATA_GRID'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Alias bereits vorhanden. Geben Sie einen anderen Alias ein.'
,p_associated_item=>wwv_flow_api.id(458479616018350127.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(459413421772442554.4903)
,p_validation_name=>'P206_SPREADSHEET not null'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clob clob;',
'begin',
'  l_clob := wwv_flow_utilities.get_clob_textarea_value(p_item_name => ''P206_SPREADSHEET'');',
'',
'  if (nvl(sys.dbms_lob.getlength(l_clob),0) = 0) then',
'      return false;',
'  end if;',
'',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Es m\00FCssen Daten angegeben werden.')
,p_associated_item=>wwv_flow_api.id(399301229989054252.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(660376512709829107.4903)
,p_validation_name=>'P206_WORKSHEET_NAME must be unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P206_WORKSHEET_NAME is not null then',
'  if wwv_flow_ws_api.websheet_name_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_name         => :P206_WORKSHEET_NAME,',
'    p_type         => ''DATA'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Der Daten-Grid-Name ist bereits vorhanden. Geben Sie einen anderen Namen ein.'
,p_associated_item=>wwv_flow_api.id(157415007986529400.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(506662505047599536.4903)
,p_validation_name=>'P206_WORKSHEET_ALIAS is valid'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P206_WORKSHEET_ALIAS is not null and not wwv_flow_ws_api.is_alphanumeric (p_str => :P206_WORKSHEET_ALIAS) then',
'    return wwv_flow_lang.system_message(''WS_ALIAS_NOT_VALID'');',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_associated_item=>wwv_flow_api.id(458479616018350127.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(159446328406626838.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create data grid'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_data_grid_from_cp_paste (',
'    p_app_id            => :APP_ID,',
'    p_ws_app_id         => :WS_APP_ID,',
'    p_name              => :P206_WORKSHEET_NAME,',
'    p_alias             => :P206_WORKSHEET_ALIAS,',
'    p_headings_included => :P206_COLUMN_HEADINGS,',
'    p_collection_name   => ''P206_SPREADSHEET'',',
'    p_worksheet_id      => :P206_WORKSHEET_ID,',
'    p_websheet_id       => :P206_WEBSHEET_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Daten-Grid konnte nicht erstellt werden.'
,p_process_when_button_id=>wwv_flow_api.id(157412021923514509.4903)
,p_process_success_message=>'Daten-Grid erstellt.'
);
end;
/
prompt --application/pages/page_00400
begin
wwv_flow_api.create_page(
 p_id=>400.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Dashboard'
,p_step_title=>'Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(5510207856754518.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
end;
/
prompt --application/pages/page_00710
begin
wwv_flow_api.create_page(
 p_id=>710.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Diagrammabschnitt erstellen'
,p_step_title=>'Diagrammabschnitt erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21404623275153782.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(259451015474899829.4903)
,p_plug_name=>'Diagrammabschnitt erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261473724838144583.4903)
,p_plug_name=>'create chart section progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(261469429368022853.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436560332736922985.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_CHART_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(259451227871899835.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(21404623275153782.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(259451615967899838.4903)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(21404623275153782.4903)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4903)
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(259451427400899837.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(21404623275153782.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(259453009785899851.4903)
,p_branch_action=>'f?p=&APP_ID.:740:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(259451615967899838.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(259453212836899853.4903)
,p_branch_action=>'f?p=&APP_ID.:710:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(259451800210899839.4903)
,p_name=>'P710_CHART_TYPE'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(259451015474899829.4903)
,p_item_default=>'COLUMN'
,p_prompt=>unistr('Diagrammtyp ausw\00E4hlen')
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CHART_TYPE'
,p_lov=>'.'||wwv_flow_api.id(259453605523899856.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('W\00E4hlen Sie den Diagrammtyp.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
end;
/
prompt --application/pages/page_00740
begin
wwv_flow_api.create_page(
 p_id=>740.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Diagrammabschnitt erstellen'
,p_step_title=>'Diagrammabschnitt erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21406523537172813.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21407114664179699.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261363204569258801.4903)
,p_plug_name=>'Diagrammabschnitt erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261474625315154102.4903)
,p_plug_name=>'create chart section progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(261469429368022853.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436560900576942084.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_CHART_SECTION''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261363407957258804.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21406523537172813.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261363832524258807.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21406523537172813.4903)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4903)
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261363630146258806.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21406523537172813.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:710:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(261364204030258811.4903)
,p_branch_action=>'f?p=&APP_ID.:742:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(261363832524258807.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261364014478258808.4903)
,p_name=>'P740_DATA_GRID_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4903)
,p_item_default=>'DATA_GRID'
,p_prompt=>'Daten-Grid'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Daten-Grid ausw\00E4hlen -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie das Daten-Grid, das zum Auff\00FCllen des Diagramms verwendet werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261376900027371013.4903)
,p_name=>'P740_DISPLAY_SEQ'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4903)
,p_prompt=>'Anzeigereihenfolge'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie die Anzeigereihenfolge des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261377609293392684.4903)
,p_name=>'P740_TITLE'
,p_is_required=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4903)
,p_prompt=>'Abschnittstitel'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Titel des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262124824705602180.4903)
,p_name=>'P740_CHART_TYPE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4903)
,p_prompt=>'Diagrammtyp'
,p_source=>'return wwv_flow_item.text_from_lov(:p710_chart_type,''CHART_TYPE'');'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Der ausgew\00E4hlte Diagrammtyp.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(428683227947684649.4903)
,p_name=>'P740_CHART_SOURCE'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4903)
,p_item_default=>'DATA_GRID'
,p_prompt=>'Diagrammquelle'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SECTION_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(428681322228645128.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('W\00E4hlen Sie den Diagrammquelltyp.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(428698306448801460.4903)
,p_name=>'P740_REPORT_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4903)
,p_prompt=>'Bericht'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Bericht ausw\00E4hlen -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie den Bericht, der zum Auff\00FCllen des Diagramms verwendet werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(428737702957923433.4903)
,p_name=>'P740_WEBSHEET_ID'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(21407114664179699.4903)
,p_prompt=>'Websheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(428752405961066251.4903)
,p_name=>'P740_WORKSHEET_ID'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(21407114664179699.4903)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(769439022514908016.4903)
,p_name=>'P740_SAVED_REPORT_ID'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(261363204569258801.4903)
,p_prompt=>'Zu verwendende Berichtseinstellungen'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id r',
'from wwv_flow_worksheet_rpts',
'where worksheet_id = :P740_WORKSHEET_ID',
'and application_user = ''APXWS_DEFAULT''',
'and is_default = ''Y''                    ',
'and (security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and session_id is null'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P740_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Bericht ausw\00E4hlen -')
,p_lov_cascade_parent_items=>'P740_WORKSHEET_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die gew\00FCnschten Berichtseinstellungen f\00FCr das ausgew\00E4hlte Daten-Grid oder den ausgew\00E4hlten Bericht. Auf diese Weise k\00F6nnen Sie die Zeilen und Spalten filtern, die angezeigt werden sollen. Wenn Sie den Bericht mit den ben\00F6tigten Einstellung')
||unistr('en nicht gespeichert haben, erstellen Sie ihn jetzt, bevor Sie den Abschnitt hinzuf\00FCgen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(770955330628071177.4903)
,p_name=>'P740_REPORT_COLUMNS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(21407114664179699.4903)
,p_prompt=>'Report Columns'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(428745016378946272.4903)
,p_computation_sequence=>10
,p_computation_item=>'P740_WEBSHEET_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P740_CHART_SOURCE = ''DATA_GRID'' then',
'  return :P740_DATA_GRID_ID;',
'elsif :P740_CHART_SOURCE = ''REPORT'' then',
'  return :P740_REPORT_ID;',
'end if;',
'  '))
,p_compute_when=>'replace(:P740_DATA_GRID_ID,''%''||''null%'') is not null or replace(:P740_REPORT_ID,''%''||''null%'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(428753515573087899.4903)
,p_computation_sequence=>20
,p_computation_item=>'P740_WORKSHEET_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P740_CHART_SOURCE = ''DATA_GRID'' then',
'  for c1 in (select w.id',
'             from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id',
'             and w.security_group_id = :flow_security_group_id',
'             and a.id = :P740_DATA_GRID_ID)',
'  loop',
'    return c1.id;',
'  end loop;',
'elsif :P740_CHART_SOURCE = ''REPORT'' then',
'  for c1 in (select w.id',
'             from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id',
'             and w.security_group_id = :flow_security_group_id',
'             and a.id = :P740_REPORT_ID)',
'  loop',
'    return c1.id;',
'  end loop;',
'end if;'))
,p_compute_when=>'replace(:P740_DATA_GRID_ID,''%''||''null%'') is not null or replace(:P740_REPORT_ID,''%''||''null%'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(770974802016072332.4903)
,p_computation_sequence=>20
,p_computation_item=>'P740_REPORT_COLUMNS'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select report_columns',
'           from wwv_flow_worksheet_rpts',
'           where worksheet_id = :p740_worksheet_id',
'           and security_group_id = :flow_security_group_id',
'           and id = :p740_saved_report_id',
'           and session_id is null)',
'loop',
'  return c1.report_columns;',
'end loop;'))
,p_compute_when=>'P740_SAVED_REPORT_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(428748111839992173.4903)
,p_validation_name=>'P740_DATA_GRID_ID not null'
,p_validation_sequence=>10
,p_validation=>'P740_DATA_GRID_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_validation_condition=>'P740_CHART_SOURCE'
,p_validation_condition2=>'DATA_GRID'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(261363832524258807.4903)
,p_associated_item=>wwv_flow_api.id(261364014478258808.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(428748522574995338.4903)
,p_validation_name=>'P740_REPORT_ID not null'
,p_validation_sequence=>20
,p_validation=>'P740_REPORT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_validation_condition=>'P740_CHART_SOURCE'
,p_validation_condition2=>'REPORT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(261363832524258807.4903)
,p_associated_item=>wwv_flow_api.id(428698306448801460.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(261382623585453517.4903)
,p_name=>'get data grid title'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_DATA_GRID_ID'
,p_condition_element=>'P740_DATA_GRID_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
,p_display_when_cond=>'P740_DATA_GRID_ID'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(261382912222453521.4903)
,p_event_id=>wwv_flow_api.id(261382623585453517.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_TITLE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name',
'from wwv_flow_ws_websheet_attr',
'where id = :P740_DATA_GRID_ID',
'and security_group_id = :flow_security_group_id'))
,p_attribute_07=>'P740_DATA_GRID_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(428701929781817609.4903)
,p_name=>'show hide data grid'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_CHART_SOURCE'
,p_condition_element=>'P740_CHART_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DATA_GRID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(428702204856817609.4903)
,p_event_id=>wwv_flow_api.id(428701929781817609.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_DATA_GRID_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(428702431656817610.4903)
,p_event_id=>wwv_flow_api.id(428701929781817609.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_DATA_GRID_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(428711509527849597.4903)
,p_name=>'show hide report'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_CHART_SOURCE'
,p_condition_element=>'P740_CHART_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPORT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(428711801380849598.4903)
,p_event_id=>wwv_flow_api.id(428711509527849597.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_REPORT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(428712030847849598.4903)
,p_event_id=>wwv_flow_api.id(428711509527849597.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_REPORT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(428715908189877604.4903)
,p_name=>'get report title'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_REPORT_ID'
,p_condition_element=>'P740_REPORT_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(428716206531877605.4903)
,p_event_id=>wwv_flow_api.id(428715908189877604.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_TITLE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name',
'from wwv_flow_ws_websheet_attr',
'where id = :P740_REPORT_ID',
'and security_group_id = :flow_security_group_id'))
,p_attribute_07=>'P740_REPORT_ID'
,p_attribute_08=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(769744919097935359.4903)
,p_name=>'reset data grid, report id, saved report id to null if source changes'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_CHART_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(769745208133935360.4903)
,p_event_id=>wwv_flow_api.id(769744919097935359.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_REPORT_ID,P740_DATA_GRID_ID,P740_SAVED_REPORT_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(769836400313948837.4903)
,p_name=>'set data grid worksheet and websheet id'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_DATA_GRID_ID'
,p_condition_element=>'P740_DATA_GRID_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(769836711787948837.4903)
,p_event_id=>wwv_flow_api.id(769836400313948837.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_WORKSHEET_ID'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select w.id',
'from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id',
'and w.security_group_id = :flow_security_group_id',
'and a.id = :P740_DATA_GRID_ID'))
,p_attribute_07=>'P740_DATA_GRID_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(770006016720963068.4903)
,p_event_id=>wwv_flow_api.id(769836400313948837.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_WEBSHEET_ID'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id',
'from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id',
'and w.security_group_id = :flow_security_group_id',
'and a.id = :P740_DATA_GRID_ID'))
,p_attribute_07=>'P740_DATA_GRID_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(770182331742976872.4903)
,p_name=>'set report worksheet and websheet id'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P740_REPORT_ID'
,p_condition_element=>'P740_REPORT_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(770182616938976872.4903)
,p_event_id=>wwv_flow_api.id(770182331742976872.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_WORKSHEET_ID'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select w.id',
'from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id',
'and w.security_group_id = :flow_security_group_id',
'and a.id = :P740_REPORT_ID'))
,p_attribute_07=>'P740_REPORT_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(770266430488985958.4903)
,p_event_id=>wwv_flow_api.id(770182331742976872.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P740_WEBSHEET_ID'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id',
'from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id',
'and w.security_group_id = :flow_security_group_id',
'and a.id = :P740_REPORT_ID'))
,p_attribute_07=>'P740_REPORT_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00742
begin
wwv_flow_api.create_page(
 p_id=>742.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Diagrammabschnitt erstellen'
,p_step_title=>'Diagrammabschnitt erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21413916573218059.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261388504493521133.4903)
,p_plug_name=>'Diagrammabschnitt erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261474829471155310.4903)
,p_plug_name=>'create chart section progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(261469429368022853.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436561331051950914.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_CHART_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261388704242521195.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21413916573218059.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261389116845521196.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21413916573218059.4903)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4903)
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261388900323521196.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21413916573218059.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:740:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(261390303188521203.4903)
,p_branch_action=>'f?p=&APP_ID.:750:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(261389116845521196.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261393406410533693.4903)
,p_name=>'P742_CHART_LABEL'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4903)
,p_prompt=>'Diagramm-Label'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P742_DATA_GRID_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Spalte ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die als Label verwendet werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261396115891545900.4903)
,p_name=>'P742_LABEL_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4903)
,p_prompt=>unistr('Achsenbeschriftung f\00FCr Label')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Geben Sie den Titel an, der an der Achse angezeigt werden soll, die zu der als Label ausgew\00E4hlten Spalte geh\00F6rt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261396329051549767.4903)
,p_name=>'P742_CHART_VALUE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4903)
,p_prompt=>'Diagrammwert'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P742_DATA_GRID_NUM_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and c.column_type = ''NUMBER''',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and column_type = ''NUMBER''',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Spalte ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Spalte aus, die als Wert verwendet werden soll. Wenn Ihre Funktion eine COUNT-Funktion ist, muss kein Wert ausgew\00E4hlt werden.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261396504940552265.4903)
,p_name=>'P742_VALUE_TITLE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4903)
,p_prompt=>unistr('Achsenbeschriftung f\00FCr Wert')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Geben Sie den Titel an, der an der Achse angezeigt werden soll, die zu der als Wert ausgew\00E4hlten Spalte geh\00F6rt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261398411089572910.4903)
,p_name=>'P742_CHART_FUNCTION'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4903)
,p_prompt=>'Funktion'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART FUNCTIONS'
,p_lov=>'.'||wwv_flow_api.id(261396928274568408.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Funktion ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie eine Funktion, die in der Spalte, die als Wert ausgew\00E4hlt wurde, ausgef\00FChrt werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261398613860573732.4903)
,p_name=>'P742_X'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4903)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261448315339630888.4903)
,p_name=>'P742_CHART_SORT'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4903)
,p_item_default=>'DEFAULT'
,p_prompt=>'Sortierung'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART SORT'
,p_lov=>'.'||wwv_flow_api.id(261446703779618102.4903)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Diagrammsortierrichtung.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621666736107538434.4903)
,p_name=>'P742_CHART_ORIENTATION'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(261388504493521133.4903)
,p_item_default=>'DEFAULT'
,p_prompt=>'Ausrichtung'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART_ORIENTATION'
,p_lov=>'.'||wwv_flow_api.id(107038275478210797.4903)||'.'
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Diagrammsortierrichtung.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(622866606496034906.4903)
,p_validation_name=>'P742_CHART_VALUE not null'
,p_validation_sequence=>10
,p_validation=>'P742_CHART_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_validation_condition=>'P742_CHART_FUNCTION'
,p_validation_condition2=>'COUNT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(261396329051549767.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00750
begin
wwv_flow_api.create_page(
 p_id=>750.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Diagrammabschnitt erstellen'
,p_step_title=>'Diagrammabschnitt erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21418604499242965.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>61
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261476811573205292.4903)
,p_plug_name=>unistr('Erstellen des Diagrammabschnitts best\00E4tigen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Sie haben das Erstellen eines Diagrammabschnitts mit folgenden Attributen angefordert. Best\00E4tigen Sie Ihre Auswahl.<p />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(261479831296212615.4903)
,p_plug_name=>'create chart section progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>41
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(261469429368022853.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436561528065959454.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>51
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_CHART_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261477013637205299.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21418604499242965.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261477420203205302.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21418604499242965.4903)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Abschnitt erstellen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(261477215920205300.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21418604499242965.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:742:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(261479201138205320.4903)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(261477420203205302.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261477801442205304.4903)
,p_name=>'P750_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Abschnittstitel'
,p_source=>'P740_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261478225076205307.4903)
,p_name=>'P750_CHART_LABEL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Diagramm-Label'
,p_source=>'P742_CHART_LABEL'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P742_DATA_GRID_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261478403806205307.4903)
,p_name=>'P750_CHART_SOURCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Diagrammquelle'
,p_source=>'P740_WEBSHEET_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P750_CHART_SOURCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name||',
'       case when websheet_type=''DATA'' then '' (''||wwv_flow_lang.system_message(''DATA_GRID'')||'')''',
'            when websheet_type=''REPORT'' then '' (''||wwv_flow_lang.system_message(''REPORT'')||'')''',
'       end d,',
'       id r',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261481523247229241.4903)
,p_name=>'P750_CHART_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_prompt=>'Diagrammtyp'
,p_source=>'return wwv_flow_item.text_from_lov(:P710_CHART_TYPE,''CHART_TYPE'')'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262132610281881794.4903)
,p_name=>'P750_LABEL_TITLE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_prompt=>unistr('Achsenbeschriftung f\00FCr Label')
,p_source=>'P742_LABEL_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262133012144891796.4903)
,p_name=>'P750_CHART_VALUE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_prompt=>'Diagrammwert'
,p_source=>'P742_CHART_VALUE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P742_DATA_GRID_NUM_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P740_WEBSHEET_ID',
'and c.column_type = ''NUMBER''',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P740_SAVED_REPORT_ID',
'and worksheet_id = :P740_WORKSHEET_ID',
'and websheet_id = :P740_WEBSHEET_ID',
'and column_type = ''NUMBER''',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P740_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262137723357904563.4903)
,p_name=>'P750_VALUE_TITLE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_prompt=>unistr('Achsenbeschriftung f\00FCr Wert')
,p_source=>'P742_VALUE_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262138724180914209.4903)
,p_name=>'P750_SORT'
,p_item_sequence=>155
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_prompt=>'Sortieren'
,p_source=>'P742_CHART_SORT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CHART SORT'
,p_lov=>'.'||wwv_flow_api.id(261446703779618102.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(262139209766919560.4903)
,p_name=>'P750_CHART_FUNCTION'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_prompt=>'Funktion'
,p_source=>'P742_CHART_FUNCTION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CHART FUNCTIONS'
,p_lov=>'.'||wwv_flow_api.id(261396928274568408.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(429658830581943501.4903)
,p_name=>'P750_SAVED_REPORT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Zu verwendende Berichtseinstellungen'
,p_source=>'P740_SAVED_REPORT_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P740_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P740_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431069802828044934.4903)
,p_name=>'P750_DISPLAY_SEQ'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Anzeigereihenfolge'
,p_source=>'P740_DISPLAY_SEQ'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(621666683956538433.4903)
,p_name=>'P750_CHART_ORIENTATION'
,p_item_sequence=>165
,p_item_plug_id=>wwv_flow_api.id(261476811573205292.4903)
,p_prompt=>'Ausrichtung'
,p_source=>'P742_CHART_ORIENTATION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CHART_ORIENTATION'
,p_lov=>'.'||wwv_flow_api.id(107038275478210797.4903)||'.'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P710_CHART_TYPE'
,p_display_when2=>'pie'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(261479020815205310.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create chart section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (    ',
'    p_ws_app_id             => :ws_app_id,',
'    p_webpage_id            => :P900_ID,',
'    p_section_type          => ''CHART'',',
'    p_display_seq           => :P740_DISPLAY_SEQ,',
'    p_title                 => :P740_TITLE,    ',
'    --',
'    p_data_grid_id          => :P740_WEBSHEET_ID,',
'    p_report_id             => :P740_SAVED_REPORT_ID,',
'    --    ',
'    p_chart_type             => :P710_CHART_TYPE,',
'    p_chart_label            => replace(:P742_CHART_LABEL,''%''||''null%''),',
'    p_label_axis_title       => :P742_LABEL_TITLE,',
'    p_chart_value            => replace(:P742_CHART_VALUE,''%''||''null%''),',
'    p_value_axis_title       => :P742_VALUE_TITLE,',
'    p_chart_aggregate        => replace(:P742_CHART_FUNCTION,''%''||''null%''),',
'    p_chart_sorting          => replace(:P742_CHART_SORT,''%''||''null%''),',
'    p_chart_orientation      => :P742_CHART_ORIENTATION',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Diagrammabschnitt konnte nicht erstellt werden.'
,p_process_when_button_id=>wwv_flow_api.id(261477420203205302.4903)
,p_process_success_message=>'Diagrammabschnitt erstellt.'
);
end;
/
prompt --application/pages/page_00760
begin
wwv_flow_api.create_page(
 p_id=>760.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Diagrammabschnitt bearbeiten'
,p_step_title=>'Diagrammabschnitt bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16850611110835501.4903)
,p_plug_name=>'Abschnitt bearbeiten'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16851016651837010.4903)
,p_plug_name=>'Abschnitte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16851420114838049.4903)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16852127040840026.4903)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18673205084790014.4903)
,p_plug_name=>'Sections Controls Menu'
,p_region_name=>'section_control'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(293373002605789454.4903)
,p_plug_name=>'Attribute des Diagrammabschnitts'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(293377205444789470.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936769878944729563.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(16851016651837010.4903)
,p_button_name=>'SETTINGS_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936712837989177653.4903)
,p_button_image_alt=>unistr('Men\00FC "Einstellungen"')
,p_button_position=>'CHANGE'
,p_icon_css_classes=>'icon-gear'
,p_button_cattributes=>'data-menu="section_control_menu"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936770026675730926.4903)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(16851016651837010.4903)
,p_button_name=>'CREATE_SECTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936746267011392790.4903)
,p_button_image_alt=>'Abschnitt erstellen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:920,921:WS_APP_ID,P921_STARTING_PAGE:&WS_APP_ID.,&P900_ID.:'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(293377611010789479.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(293377205444789470.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(293377811025789479.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(293377205444789470.4903)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(293377430562789471.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(293377205444789470.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16851219419837010.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16851016651837010.4903)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4903)
,p_button_image_alt=>'Ausblenden/Anzeigen'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16858602499861356.4903)
,p_branch_action=>'f?p=&APP_ID.:&P760_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P760_NEXT_SECTION_PAGE_ID.:&P760_NEXT_SECTION_ITEM_NAME.:&P760_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(293383022622789505.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16853000696840028.4903)
,p_name=>'P760_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16853219047840028.4903)
,p_name=>'P760_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16853413690840028.4903)
,p_name=>'P760_NEXT_SECTION_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20226306961820031.4903)
,p_name=>'P760_PAGE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Seite'
,p_source=>'P900_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(121268678889561216.4903)
,p_name=>'P760_CHART_ORIENTATION'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>'Ausrichtung'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART_ORIENTATION'
,p_lov=>'.'||wwv_flow_api.id(107038275478210797.4903)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Diagrammausrichtung. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293373231959789455.4903)
,p_name=>'P760_SECTION_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4903)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293373420373789458.4903)
,p_name=>'P760_TITLE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>'Titel'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Titel des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293373619157789459.4903)
,p_name=>'P760_DISPLAY_SEQ'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>'Sequenz'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie die Anzeigereihenfolge des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293373829530789459.4903)
,p_name=>'P760_WEBSHEET_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4903)
,p_prompt=>'Data Grid:'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293374010377789460.4903)
,p_name=>'P760_WEBSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4903)
,p_prompt=>'Websheet ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293388714347819418.4903)
,p_name=>'P760_CHART_TYPE'
,p_is_required=>true
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>'Diagrammtyp'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P760_CHART_TYPE'
,p_lov=>'.'||wwv_flow_api.id(444797819996488091.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie den Diagrammtyp.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293402730193842903.4903)
,p_name=>'P760_CHART_LABEL'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>'Diagramm-Label'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P760_DATA_GRID_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P760_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P760_SAVED_REPORT_ID',
'and websheet_id = :P760_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id)',
'where instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die als Label verwendet werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293402915087847946.4903)
,p_name=>'P760_CHART_VALUE'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>'Diagrammwert'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P760_DATA_GRID_NUM_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'from (',
'select c.column_label d, c.db_column_name r',
'from wwv_flow_worksheet_columns c, wwv_flow_ws_websheet_attr d',
'where c.worksheet_id = d.worksheet_id',
'and d.ws_app_id = :WS_APP_ID',
'and d.id = :P760_WEBSHEET_ID',
'and d.security_group_id = :flow_security_group_id',
'and c.column_type = ''NUMBER''',
'union',
'select ''**''||column_label d, db_column_name r',
'from wwv_flow_worksheet_computation',
'where report_id = :P760_SAVED_REPORT_ID',
'and websheet_id = :P760_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id',
'and column_type = ''NUMBER'')',
'where instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'') > 0',
'order by instr('':''||:P760_REPORT_COLUMNS||'':'', '':''||r||'':'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Spalte ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Spalte, die als Wert verwendet werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293403432056852908.4903)
,p_name=>'P760_LABEL_AXIS_TITLE'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>unistr('Achsenbeschriftung f\00FCr Label')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie den Titel an, der an der Achse angezeigt werden soll, die zu der als Label ausgew\00E4hlten Spalte geh\00F6rt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293403607945855380.4903)
,p_name=>'P760_VALUE_AXIS_TITLE'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>unistr('Achsenbeschriftung f\00FCr Wert')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie den Titel an, der an der Achse angezeigt werden soll, die zu der als Wert ausgew\00E4hlten Spalte geh\00F6rt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293403826299860683.4903)
,p_name=>'P760_FUNCTION'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>'Funktion'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART FUNCTIONS'
,p_lov=>'.'||wwv_flow_api.id(261396928274568408.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Funktion ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie eine Funktion, die in der Spalte, die als Wert ausgew\00E4hlt wurde, ausgef\00FChrt werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(293404005998864316.4903)
,p_name=>'P760_SORT'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>'Sortieren'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CHART SORT'
,p_lov=>'.'||wwv_flow_api.id(261446703779618102.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Diagrammsortierrichtung.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(429669330028028427.4903)
,p_name=>'P760_SAVED_REPORT_ID'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>'Zu verwendende Berichtseinstellungen'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P760_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P760_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P760_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Gibt die Berichtseinstellungen f\00FCr das ausgew\00E4hlte Daten-Grid oder den Bericht an. Wenn Sie andere Berichtseinstellungen verwenden m\00F6chten, m\00FCssen Sie den Abschnitt l\00F6schen und neu erstellen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430264430653526530.4903)
,p_name=>'P760_REPORT_COLUMNS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4903)
,p_prompt=>'Report Columns'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430733221841580527.4903)
,p_name=>'P760_WORKSHEET_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4903)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430965306584191770.4903)
,p_name=>'P760_WEBSHEET_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_prompt=>'Quelltyp'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SECTION_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(428681322228645128.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den Diagrammquelltyp an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430967428532207560.4903)
,p_name=>'P760_DATA_GRID_NAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Daten-Grid-Name'
,p_source=>'''<span class="display_bold">''||wwv_flow_escape.html(:P760_WEBSHEET_NAME)||''</span><a href="f?p=''||:APP_ID||'':2:''||:APP_SESSION||''::::WS_APP_ID,P2_ID,P2_WEBSHEET_ID:''||:WS_APP_ID||'',''||:P760_WORKSHEET_ID||'',''||:P760_WEBSHEET_ID||''" class="goToLink">''|'
||'|wwv_flow_lang.system_message(''WS_VIEW_DATA_GRID'')||''<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class=""'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P760_WEBSHEET_TYPE'
,p_display_when2=>'DATA_GRID'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>unistr('Gibt das Daten-Grid an, das zum Auff\00FCllen des Diagramms verwendet wird.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430969527194235556.4903)
,p_name=>'P760_REPORT_NAME'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(293373002605789454.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Berichtsname'
,p_source=>'''<span class="display_bold">''||wwv_flow_escape.html(:P760_WEBSHEET_NAME)||''</span><a href="f?p=''||:APP_ID||'':3000:''||:APP_SESSION||''::::WS_APP_ID,IR_ID,WS_ID:''||:WS_APP_ID||'',''||:P760_WORKSHEET_ID||'',''||:P760_WEBSHEET_ID||''" class="goToLink">''||wwv_f'
||'low_lang.system_message(''APEXIR_VIEW_REPORT'')||''<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class=""'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P760_WEBSHEET_TYPE'
,p_display_when2=>'REPORT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Gibt den Bericht an, der zum Auff\00FCllen des Diagramms verwendet wird.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(813762811200738734.4903)
,p_name=>'P760_CHANGE_COUNT'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(16852127040840026.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20021111567553355.4903)
,p_computation_sequence=>10
,p_computation_item=>'SECTION_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P760_SECTION_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(9495409627921389.4903)
,p_validation_name=>'P760_CHART_LABEL not null'
,p_validation_sequence=>10
,p_validation=>'P760_CHART_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(293402730193842903.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(813847224753771090.4903)
,p_validation_name=>'check section lost update'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.check_section_lost_update (',
'    p_ws_app_id             => :WS_APP_ID,',
'    p_page_id               => :P900_ID,',
'    p_section_id            => :P760_SECTION_ID,',
'    p_change_count          => :P760_CHANGE_COUNT,',
'    --',
'    p_display_seq           => :P760_DISPLAY_SEQ,',
'    p_title                 => :P760_TITLE,   ',
'    --',
'    p_data_grid_id          => :P760_WEBSHEET_ID,',
'    p_report_id             => :P760_SAVED_REPORT_ID,',
'    --    ',
'    p_chart_type            => :P760_CHART_TYPE,',
'    p_chart_label           => :P760_CHART_LABEL,',
'    p_label_axis_title      => :P760_LABEL_AXIS_TITLE,',
'    p_chart_value           => replace(:P760_CHART_VALUE,''%''||''null%''),',
'    p_value_axis_title      => :P760_VALUE_AXIS_TITLE,',
'    p_chart_aggregate       => replace(:P760_FUNCTION,''%''||''null%''),',
'    p_chart_sorting         => :P760_SORT,',
'    p_chart_orientation     => :P760_CHART_ORIENTATION',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(121268775059561217.4903)
,p_name=>'Visibility of Pie Options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P760_CHART_TYPE'
,p_condition_element=>'P760_CHART_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'pie'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(121268856702561218.4903)
,p_event_id=>wwv_flow_api.id(121268775059561217.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P760_LABEL_AXIS_TITLE,P760_VALUE_AXIS_TITLE,P760_CHART_ORIENTATION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(121268934556561219.4903)
,p_event_id=>wwv_flow_api.id(121268775059561217.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P760_LABEL_AXIS_TITLE,P760_VALUE_AXIS_TITLE,P760_CHART_ORIENTATION'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(293382827985789499.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save chart section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (   ',
'    p_ws_app_id             => :ws_app_id,     ',
'    p_webpage_id            => :P900_ID,',
'    p_section_id            => :P760_SECTION_ID,',
'    p_section_type          => ''CHART'',',
'    p_display_seq           => :P760_DISPLAY_SEQ,',
'    p_title                 => :P760_TITLE,   ',
'    --',
'    p_data_grid_id          => :P760_WEBSHEET_ID,',
'    p_report_id             => :P760_SAVED_REPORT_ID,',
'    --    ',
'    p_chart_type            => :P760_CHART_TYPE,',
'    p_chart_label           => :P760_CHART_LABEL,',
'    p_label_axis_title      => :P760_LABEL_AXIS_TITLE,',
'    p_chart_value           => replace(:P760_CHART_VALUE,''%''||''null%''),',
'    p_value_axis_title      => :P760_VALUE_AXIS_TITLE,',
'    p_chart_aggregate       => replace(:P760_FUNCTION,''%''||''null%''),',
'    p_chart_sorting         => :P760_SORT,',
'    p_chart_orientation     => :P760_CHART_ORIENTATION',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Datenabschnitt konnte nicht gespeichert werden.'
,p_process_when=>'SAVE,SAVEANDGOTONEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Datenabschnitt gespeichert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(293382410880789495.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage_section (',
'    p_section_id       => :P760_SECTION_ID,',
'    p_section_type     => ''CHART'',',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_webpage_id       => :P900_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Abschnitt konnte nicht gel\00F6scht werden.')
,p_process_when_button_id=>wwv_flow_api.id(293377430562789471.4903)
,p_process_success_message=>unistr('Abschnitt gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(293382606613789497.4903)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch chart section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_chart_section (',
'  p_section_id           => :P760_SECTION_ID,',
'  p_section_type         => ''CHART'',',
'  -- out  ',
'  p_display_seq          => :P760_DISPLAY_SEQ,     ',
'  p_title                => :P760_TITLE,',
'  p_worksheet_id         => :P760_WORKSHEET_ID,',
'  p_websheet_type        => :P760_WEBSHEET_TYPE,',
'  p_websheet_id          => :P760_WEBSHEET_ID,',
'  p_websheet_name        => :P760_WEBSHEET_NAME,  ',
'  p_report_id            => :P760_SAVED_REPORT_ID,',
'  p_report_columns       => :P760_REPORT_COLUMNS,',
'  --',
'  p_chart_type           => :P760_CHART_TYPE,',
'  p_chart_label          => :P760_CHART_LABEL,',
'  p_label_axis_title     => :P760_LABEL_AXIS_TITLE,',
'  p_chart_value          => :P760_CHART_VALUE,',
'  p_value_axis_title     => :P760_VALUE_AXIS_TITLE,',
'  p_chart_aggregate      => :P760_FUNCTION,',
'  p_chart_sorting        => :P760_SORT,',
'  p_chart_orientation    => :P760_CHART_ORIENTATION,',
'  p_change_count         => :P760_CHANGE_COUNT',
'  );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Datenabschnitt konnte nicht abgerufen werden.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471215106441767363.4903)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection for dynamic list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' wwv_flow_ws_api.create_pg_sec_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id=> :WS_APP_ID,',
'    p_page_id => :P900_ID,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed for dynamic list.'
);
end;
/
prompt --application/pages/page_00888
begin
wwv_flow_api.create_page(
 p_id=>888.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Sie sind jetzt abgemeldet.'
,p_step_title=>'Sie sind jetzt abgemeldet.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(53193408981633671.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(823024031730159043.4903)
,p_plug_name=>'Sie sind jetzt abgemeldet.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'Sie haben sich erfolgreich abgemeldet. '
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_00900
begin
wwv_flow_api.create_page(
 p_id=>900.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Seite'
,p_step_title=>'&P900_PAGE_NAME.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.ebaLeftColumn {',
'  padding: 10px 0 10px 10px;',
'  display: table-cell;',
'  width: 220px;',
'}',
'body .tree-default li a,',
'body .tree-default li a:hover, body .tree-default li a.hover, body .tree-default li span {',
'padding: 4px 8px !important;',
'}'))
,p_step_template=>wwv_flow_api.id(3700422714748.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(3700425732560.4903)
,p_plug_name=>'Linke Spalte'
,p_region_css_classes=>'ebaLeftColumn'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(3700433754276.4903)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'null;',
'--wwv_flow_ws_webpage.show_navigation_only (',
'--    p_ws_app_id         => :WS_APP_ID,',
'--    p_webpage_id        => :p900_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(14135027279837704.4903)
,p_plug_name=>'Control Panel'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.control_panel (',
'    p_app_id      => :app_id,',
'    p_session     => :app_session,',
'    p_ws_app_id   => :ws_app_id,',
'    p_ws_page_id  => :P900_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_required_role=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173530904554100763.4903)
,p_plug_name=>'Dateien'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_attachments (',
'    p_ws_app_id   => :ws_app_id,',
'    p_webpage_id  => :p900_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.page_annotation_exists (',
'    p_ws_app_id       => :ws_app_id,',
'    p_webpage_id      => :p900_id,',
'    p_annotation_type => ''ATTACHMENT'');'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(173993913692886038.4903)
,p_plug_name=>'Web Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_include_nav_section varchar2(1);',
'begin',
'  /*if wwv_flow_ws_webpage.nav_section_exists (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :P900_ID) then',
'    l_include_nav_section := ''Y'';',
'  else',
'    l_include_nav_section := ''N'';',
'  end if;*/',
'',
'  wwv_flow_ws_webpage.show (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :p900_id,    ',
'    p_request     => :REQUEST);',
'    --p_include_nav_section => l_include_nav_section',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185291823656333041.4903)
,p_plug_name=>'Hierarchical Page List with Child Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id       => :WS_APP_ID,   ',
'    p_app_session     => :app_session,',
'    p_page_id         => :P900_ID,',
'    p_image_prefix    => ''#IMAGE_PREFIX#'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251648912659488984.4903)
,p_plug_name=>'Hinweise'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="apex-ws-annotations"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_notes (',
'    p_session        => :app_session,',
'    p_ws_app_id    => :ws_app_id,',
'    p_webpage_id  => :p900_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.page_annotation_exists (',
'    p_ws_app_id       => :ws_app_id,',
'    p_webpage_id      => :p900_id,',
'    p_annotation_type => ''NOTE'');'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251655526830616039.4903)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(253850701461144946.4903)
,p_plug_name=>'Tags'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_tags (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :P900_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.page_annotation_exists (',
'    p_ws_app_id       => :ws_app_id,',
'    p_webpage_id      => :p900_id,',
'    p_annotation_type => ''TAG'');'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(290400321962259604.4903)
,p_plug_name=>'Footer Region'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_07'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.p900_footer (',
'    p_app_id          => :app_id,',
'    p_ws_app_id       => :ws_app_id,',
'    p_page_id         => :p900_id,',
'    p_app_session     => :app_session',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsFooter">'
,p_plug_footer=>'</div>'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9303319377230427.4903)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_api.id(173530904554100763.4903)
,p_button_name=>'ADD_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4903)
,p_button_image_alt=>unistr('Datei hinzuf\00FCgen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4020:&SESSION.::&DEBUG.:4020::'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="addIcon"'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9305107481293173.4903)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_api.id(251648912659488984.4903)
,p_button_name=>'ADD_NOTE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4903)
,p_button_image_alt=>unistr('Hinweis hinzuf\00FCgen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4030:&SESSION.::&DEBUG.:4030::'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="addIcon"'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9304109989274947.4903)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_api.id(253850701461144946.4903)
,p_button_name=>'ADD_TAG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4903)
,p_button_image_alt=>unistr('Tag hinzuf\00FCgen')
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4040:&SESSION.::&DEBUG.:4040::'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="addIcon"'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9303010111208753.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(173530904554100763.4903)
,p_button_name=>'VIEW_FILES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4903)
,p_button_image_alt=>'Dateien anzeigen'
,p_button_position=>'EXPAND'
,p_button_redirect_url=>'f?p=&APP_ID.:903:&SESSION.::&DEBUG.:RIR:IRC_PAGE_NAME:&P900_PAGE_NAME.'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="viewAllIcon"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9305415446295478.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(251648912659488984.4903)
,p_button_name=>'VIEW_NOTES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4903)
,p_button_image_alt=>'Hinweise anzeigen'
,p_button_position=>'EXPAND'
,p_button_redirect_url=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.:RIR:IRC_PAGE_NAME:&P900_PAGE_NAME.'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="viewAllIcon"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(9304316569276885.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(253850701461144946.4903)
,p_button_name=>'VIEW_TAGS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(3791820543327.4903)
,p_button_image_alt=>'Tags anzeigen'
,p_button_position=>'EXPAND'
,p_button_redirect_url=>'f?p=&APP_ID.:904:&SESSION.::&DEBUG.:RIR:IRC_PAGE_NAME:&P900_PAGE_NAME.'
,p_button_css_classes=>'#IMAGE_PREFIX#ws/img/spacer.gif'
,p_button_cattributes=>'class="viewAllIcon"'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178548705774056302.4903)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(173532304470119605.4903)
,p_name=>'P900_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(251655526830616039.4903)
,p_prompt=>'Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471970208476732743.4903)
,p_name=>'P900_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(251655526830616039.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(795545130800771079.4903)
,p_name=>'P900_SELECTED_NODE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(251655526830616039.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(257126318389641735.4903)
,p_computation_sequence=>10
,p_computation_item=>'WS_APP_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ws_app_id from wwv_flow_ws_webpages where id = :P900_ID;',
''))
,p_compute_when=>'WS_APP_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187891606886292635.4903)
,p_computation_sequence=>30
,p_computation_item=>'APP_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) n',
'from wwv_flow_ws_applications ',
'where id = :WS_APP_ID and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(174066317868558402.4903)
,p_computation_sequence=>40
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'900'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(471970417133735260.4903)
,p_computation_sequence=>50
,p_computation_item=>'P900_PAGE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n',
'from WWV_FLOW_WS_WEBPAGES ',
'where ws_app_id = :WS_APP_ID and security_group_id = :flow_security_group_id and id = :P900_ID'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253745513836041604.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete attachment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_doc_id number := null;',
'begin',
'  l_doc_id := replace(:REQUEST,''DELETE_ATTACHMENT_'');',
'  wwv_flow_ws_attachment.delete_doc (',
'    p_doc_id   => l_doc_id',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Anhang konnte nicht gel\00F6scht werden.')
,p_process_when=>':REQUEST like ''DELETE_ATTACHMENT_%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253745924356054016.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_note_id number := null;',
'begin',
'  l_note_id := replace(:REQUEST,''DELETE_NOTE_'');',
'  wwv_flow_ws_api.delete_note (',
'    p_note_id   => l_note_id',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Der Hinweis konnte nicht gel\00F6scht werden.')
,p_process_when=>':REQUEST like ''DELETE_NOTE_%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253750008361219755.4903)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete tag'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_tag_id number := null;',
'begin',
'  l_tag_id := replace(:REQUEST,''DELETE_TAG_'');',
'  wwv_flow_ws_api.delete_tag (',
'    p_tag_id   => l_tag_id',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Tag konnte nicht gel\00F6scht werden.')
,p_process_when=>':REQUEST like ''DELETE_TAG_%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(1003383025772157176.4903)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SET ACCESSIBILITY MODE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :REQUEST = ''SET_ACCESSIBILITY_OFF'' then',
'  htmldb_util.set_session_screen_reader_off;',
'  htmldb_util.set_session_high_contrast_off;',
'elsif :REQUEST = ''SET_SESSION_SCREEN_READER_ON'' then',
'  htmldb_util.set_session_screen_reader_on;',
'  htmldb_util.set_session_high_contrast_off;',
'elsif :REQUEST = ''SET_SESSION_HIGH_CONTRAST_ON'' then',
'  htmldb_util.set_session_high_contrast_on;',
'  htmldb_util.set_session_screen_reader_off;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'''SET_ACCESSIBILITY_OFF'',''SET_SESSION_SCREEN_READER_ON'',''SET_SESSION_HIGH_CONTRAST_ON'''
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
prompt --application/pages/page_00901
begin
wwv_flow_api.create_page(
 p_id=>901.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Pr\00E4sentationsansicht')
,p_step_title=>'&P900_PAGE_NAME.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(75962824844186301.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(75856500380178545.4903)
,p_plug_name=>'Web Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_webpage.show (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :p900_id,    ',
'    p_request     => :REQUEST,    ',
'    p_presentation_mode => ''Y'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(75856709579178547.4903)
,p_plug_name=>'Breadcrumbs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_slide_breadcrumbs (',
'    p_ws_app_id       => :WS_APP_ID,   ',
'    p_app_session     => :app_session,',
'    p_page_id         => :P900_ID,',
'    p_image_prefix    => ''#IMAGE_PREFIX#'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(800674711428354357.4903)
,p_plug_name=>'Presentation Controls'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="wspSlideOptions">'');',
'sys.htp.p(''  <a href="javascript:void(0);" id="prevSectionButton"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="''||wwv_flow_lang.system_message(''LAYOUT.PREVIOUS_BUTTON'')||''" /></a>'');',
'sys.htp.p(''    <input type="text" id="slideJump" title="''||wwv_flow_lang.system_message(''SECTIONS'')||''"/>'');',
'sys.htp.p(''    <span class="totalSlides"><em>/</em><span id="totalSlides"></span></span>'');',
'sys.htp.p(''  <a href="javascript:void(0);" id="nextSectionButton"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="''||wwv_flow_lang.system_message(''LAYOUT.NEXT_BUTTON'')||''" /></a>'');',
'sys.htp.p(''  <a href="#" id="togglePosition" style="display: none">Toggle</a>'');',
'sys.htp.p(''  <a href="f?p=&APP_ID.:900:&APP_SESSION." class="closeButton"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="''||wwv_flow_lang.system_message(''LAYOUT.CLOSE_BUTTON'')||''" /></a>'');',
'sys.htp.p(''</div>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(75857709288178548.4903)
,p_name=>'P901_ID'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00902
begin
wwv_flow_api.create_page(
 p_id=>902.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Daten'
,p_step_title=>'Daten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20482400388361999.4903)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1000
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178727025146420288.4903)
,p_plug_name=>'Data'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear:both;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select type, name, alias, the_link, status, websheet_id, worksheet_id, ',
'       created_on, created_by, updated_on, updated_by, img, embed_tag',
'  from',
'(select ',
'   wwv_flow_lang.system_message(''DATA_GRID'') type,',
'   a.websheet_name name, ',
'   a.websheet_alias alias,',
'   ''ws?p=''||:WS_APP_ID||'':DG_''||a.websheet_alias||'':''||:APP_SESSION the_link,     ',
'   a.STATUS,',
'   a.id websheet_id,',
'   w.id worksheet_id,',
'   a.updated_on,',
'   lower(a.updated_by) updated_by,',
'   a.created_on,',
'   lower(a.created_by) created_by,',
'   ''#IMAGE_PREFIX#ws/img/icons/icon-ws-data-grid.png'' img,',
'   ''[[ datagrid: ''||lower(a.websheet_alias)||'' ]]'' embed_tag, ''1'' show',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''DATA'' and',
'      (nvl(:P902_SHOW,''ALL'') = ''ALL'' or :P902_SHOW = ''DATAGRID'')',
'union all',
'select ',
'   wwv_flow_lang.system_message(''REPORT'') type,',
'   a.websheet_name name, ',
'   a.websheet_alias alias,',
'   ''f?p=''||:APP_ID||'':3000:''||',
'      :APP_SESSION||''::::WS_APP_ID,IR_ID,WS_ID:''||a.ws_app_id||'',''||w.id||',
'      '',''||a.id the_link,     ',
'   a.STATUS,',
'   a.id websheet_id,',
'   w.id worksheet_id,',
'   a.updated_on,',
'   lower(a.updated_by) updated_by,',
'   a.created_on,',
'   lower(a.created_by) created_by,',
'   ''#IMAGE_PREFIX#ws/img/icons/icon-ws-report.png'' img,',
'   ''[[ report: ''||lower(a.websheet_alias)||'' ]]'' embed_tag, ',
'   case when (wwv_flow_ws_security.sql_enabled_inst_yn = ''Y'' ',
'    and wwv_flow_ws_security.sql_enabled_yn(775) = ''Y'') ',
'    then ''1'' else ''0'' end show',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''REPORT'' and',
'      (nvl(:P902_SHOW,''ALL'') = ''ALL'' or :P902_SHOW = ''REPORT''))'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P902_SHOW'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<div class="clear"></div>'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   wwv_flow_lang.system_message(''DATA_GRID'') type,',
'   w.name name, ',
'   a.websheet_alias alias,',
'   ''f?p=''||:APP_ID||'':2:''||',
'      :APP_SESSION||''::::WS_APP_ID,P2_ID,P2_WEBSHEET_ID:''||',
'      a.ws_app_id||'',''||w.id||',
'      '',''||a.id the_link,     ',
'   a.STATUS,',
'   a.id websheet_id,',
'   w.id worksheet_id,',
'   a.created_on,',
'   a.created_by,',
'   ''#IMAGE_PREFIX#menu/interactive_page_64.gif'' img,',
'   ''[[ datagrid: ''||lower(a.websheet_alias)||'' ]]'' embed_tag',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''DATA'' and',
'      (nvl(:P902_SHOW,''ALL'') = ''ALL'' or :P902_SHOW = ''DATAGRID'')',
'union all',
'select ',
'   wwv_flow_lang.system_message(''REPORT'') type,',
'   w.name name, ',
'   a.websheet_alias alias,',
'   ''f?p=''||:APP_ID||'':3000:''||',
'      :APP_SESSION||''::::WS_APP_ID,IR_ID,WS_ID:''||a.ws_app_id||'',''||w.id||',
'      '',''||a.id the_link,     ',
'   a.STATUS,',
'   a.id websheet_id,',
'   w.id worksheet_id,',
'   a.created_on,',
'   a.created_by,',
'   ''#IMAGE_PREFIX#menu/report_64.gif'' img,',
'   ''[[ report: ''||lower(a.websheet_alias)||'' ]]'' embed_tag',
'from wwv_flow_worksheets w, ',
'     wwv_flow_ws_websheet_attr a',
'where w.id = a.worksheet_id and',
'      w.security_group_id = :flow_security_group_id and                  ',
'      a.ws_app_id = :ws_app_id and',
'      nvl(a.websheet_type,''DATA'') = ''REPORT'' and',
'      (nvl(:P902_SHOW,''ALL'') = ''ALL'' or :P902_SHOW = ''REPORT'')'))
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(178727117027420288.4903)
,p_name=>'Data'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Nichts definiert.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'THE_LINK'
,p_icon_view_img_src_column=>'IMG'
,p_icon_view_label_column=>'NAME'
,p_icon_view_columns_per_row=>7
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(178727330296420308.4903)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_link=>'#THE_LINK#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(178727400573420314.4903)
,p_db_column_name=>'THE_LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Der Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(178727513130420314.4903)
,p_db_column_name=>'STATUS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(178742525016546760.4903)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(178742614480546761.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(185808623998060900.4903)
,p_db_column_name=>'IMG'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(186433400249098947.4903)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Websheet'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(186433532151098949.4903)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(458514110355764730.4903)
,p_db_column_name=>'TYPE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Typ'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_display_condition=>'P902_SHOW'
,p_display_condition2=>'REPORT:DATAGRID'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(458520110027916055.4903)
,p_db_column_name=>'ALIAS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468143130998993657.4903)
,p_db_column_name=>'EMBED_TAG'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Tag einbetten'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(204656304904400586.4903)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(204656415860400592.4903)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178832210805267347.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187089104016586622.4903)
,p_plug_name=>'Datenansichtsliste'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(187087619151586620.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458503124760683707.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf dieser Seiten k\00F6nnen Sie ein Daten-Grid oder einen Bericht zur Ausf\00FChrung ausw\00E4hlen. Klicken Sie auf die Registerkarte <b>Daten-Grids</b>, um nur Daten-Grids anzuzeigen. Klicken Sie auf die Registerkarte <b>Berichte</b>, um nur Berichte anzuze')
||'igen.</p>',
'',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>wwv_flow_api.id(492214905335570870)
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458937708651341308.4903)
,p_plug_name=>'Daten-Grids'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mit Daten-Grids k\00F6nnen Sie tabellarische Daten verwalten. Sie k\00F6nnen Zeilen und Spalten nach Bedarf hinzuf\00FCgen. Daten-Grid-Daten k\00F6nnen in Seitenabschnitten als Berichte oder Diagramme angezeigt werden.</p>'),
'',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P902_SHOW = ''DATAGRID'' or nvl(:P902_SHOW,''ALL'') = ''ALL'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458937914192342938.4903)
,p_plug_name=>'Berichte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Ein Bericht basiert auf einer SQL-Abfrage und ist schreibgesch\00FCtzt. Sie k\00F6nnen die Spaltenanzeige, Filterung und Sortierung kontrollieren und k\00F6nnen Diagramme basierend auf den Daten erstellen. Berichtsdaten k\00F6nnen in Seitenabschnitten als Bericht')
||'e oder Diagramme angezeigt werden.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>wwv_flow_api.id(492214905335570870)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P902_SHOW = ''REPORT'' or nvl(:P902_SHOW,''ALL'') = ''ALL'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(468144604594005049.4903)
,p_plug_name=>'Tags einbetten'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Das Embed-Tag zeigt die Syntax, die zum Einbinden eines Links in einen Bericht oder ein Daten-Grid aus einem Abschnitt einer Seite heraus verwendet wird.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(459950222043604207.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(178727025146420288.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.:902,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(292572704374860078.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(178727025146420288.4903)
,p_button_name=>'VIEW_SAVED_RPTS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'Gespeicherte Berichte anzeigen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:RP::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(461369508843608456.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(178727025146420288.4903)
,p_button_name=>'CREATE_DATA_GRID'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890726723852448.4903)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Daten-Grid erstellen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:205:&SESSION.::&DEBUG.:205,1310,1320::'
,p_button_condition=>'P902_SHOW'
,p_button_condition2=>'DATAGRID'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(461370003086616244.4903)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(178727025146420288.4903)
,p_button_name=>'CREATE_DATA_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890726723852448.4903)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Bericht erstellen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.:205,1310,1320::'
,p_button_condition=>'P902_SHOW'
,p_button_condition2=>'REPORT'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_security_scheme=>wwv_flow_api.id(495860932509802714)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178840308390342342.4903)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(178727025146420288.4903)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890726723852448.4903)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Erstellen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:1310,1320::'
,p_button_condition=>'nvl(:P902_SHOW,''x'') not in (''DATAGRID'',''REPORT'')'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(186437031117136227.4903)
,p_branch_action=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186434908130120083.4903)
,p_name=>'P902_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20482400388361999.4903)
,p_item_default=>'ALL'
,p_prompt=>'Show:'
,p_source=>'ALL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie den Berichtstyp aus, der angezeigt werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(178840523974346853.4903)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'902'
);
end;
/
prompt --application/pages/page_00903
begin
wwv_flow_api.create_page(
 p_id=>903.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Dateien'
,p_step_title=>'Dateien'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178833106434275510.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178838607304313668.4903)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178842714109381854.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Daten-Grids und Seiten k\00F6nnen Dateien hinzugef\00FCgt werden.  Auf dieser Seite k\00F6nnen Sie alle Dateien f\00FCr diese Anwendung anzeigen.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(253998509295980827.4903)
,p_plug_name=>'Attachments'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1, n001,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''FILE_LABEL'',c007)) delete_ck,',
'       n001 id,',
'       n002 ws_app_id,',
'       (select name from wwv_flow_ws_applications where id = n002 and security_group_id=:flow_security_group_id) app_name,',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id = n003 and ws_app_id = n002 and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id = n004 and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id = n004 and ws_app_id = n002 and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       ''<a class="attachment_link" href="''||wwv_flow_ws_attachment.get_ws_file_src(n001)||''" title="''||wwv_flow_escape.html_attribute(c008)||''">''||c002||''</a>'' file_name,',
'       c003 image_alias,',
'       c004 image_attributes,      ',
'       null content,',
'       d001 content_last_update,',
'       c012 mime_type,',
'       c006 content_charset,',
'       c007 content_filename,',
'       c008 description,',
'       d002 created_on,',
'       lower(c009) created_by,',
'       d003 updated_on,',
'       lower(c010) updated_by,',
'       to_number(nvl(c011,''0'')) content_size,',
'       c007 icon_name,',
'       ''f?p=4900:912:''||:app_session||''::::WS_APP_ID,P912_ID:''||:WS_APP_ID||'',''||n001 icon_link,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-file.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_FILES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(253998604086980827.4903)
,p_name=>'Attachments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:912:WS_APP_ID,P912_ID:&WS_APP_ID.,#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'ICON_LINK'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'ICON_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(215460110811270128.4903)
,p_db_column_name=>'DELETE_CK'
,p_display_order=>1
,p_column_identifier=>'AM'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253999020619980835.4903)
,p_db_column_name=>'APP_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Anwendung'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253999204012980836.4903)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>'Seite'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::p900_id,ws_app_id:#WEBPAGE_ID#,#WS_APP_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253999430469980836.4903)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>4
,p_column_identifier=>'G'
,p_column_label=>'Daten-Grid'
,p_column_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:2:WS_APP_ID,P2_WEBSHEET_ID,P2_ID:&WS_APP_ID.,#WEBSHEET_ID#,#WORKSHEET_ID#'
,p_column_linktext=>'#DATA_GRID_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(253999619710980838.4903)
,p_db_column_name=>'COMPONENT_LEVEL'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Ebene'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254000024473980838.4903)
,p_db_column_name=>'MIME_TYPE'
,p_display_order=>6
,p_column_identifier=>'M'
,p_column_label=>'MIME-Typ'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254000105627980838.4903)
,p_db_column_name=>'CONTENT_CHARSET'
,p_display_order=>7
,p_column_identifier=>'N'
,p_column_label=>'Contentzeichensatz'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254000309479980839.4903)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>8
,p_column_identifier=>'P'
,p_column_label=>'Beschreibung'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254000432139980839.4903)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>9
,p_column_identifier=>'Q'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254000523034980839.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>10
,p_column_identifier=>'R'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254115025775224528.4903)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>11
,p_column_identifier=>'U'
,p_column_label=>unistr('Gew\00E4hltes Daten-Grid')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254123507785370672.4903)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>12
,p_column_identifier=>'V'
,p_column_label=>'Dateiname'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254123625843370672.4903)
,p_db_column_name=>'ICON_NAME'
,p_display_order=>13
,p_column_identifier=>'W'
,p_column_label=>'Symbolname'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254123702955370672.4903)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>14
,p_column_identifier=>'X'
,p_column_label=>'Symbol-Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254123821404370673.4903)
,p_db_column_name=>'ICON_LINK'
,p_display_order=>15
,p_column_identifier=>'Y'
,p_column_label=>'Symbollink'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255836316153477235.4903)
,p_db_column_name=>'CONTENT'
,p_display_order=>16
,p_column_identifier=>'Z'
,p_column_label=>'Inhalt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255836425540477236.4903)
,p_db_column_name=>'CONTENT_LAST_UPDATE'
,p_display_order=>17
,p_column_identifier=>'AA'
,p_column_label=>'Letzte Inhaltsaktualisierung'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255836525864477236.4903)
,p_db_column_name=>'CONTENT_FILENAME'
,p_display_order=>18
,p_column_identifier=>'AB'
,p_column_label=>'Inhaltsdateiname'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255836605211477236.4903)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>19
,p_column_identifier=>'AC'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255836720825477237.4903)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>20
,p_column_identifier=>'AD'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(455844323794484348.4903)
,p_db_column_name=>'IMAGE_ALIAS'
,p_display_order=>21
,p_column_identifier=>'AE'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(455844408787484351.4903)
,p_db_column_name=>'IMAGE_ATTRIBUTES'
,p_display_order=>22
,p_column_identifier=>'AF'
,p_column_label=>'Attribute'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468266321739448004.4903)
,p_db_column_name=>'ID'
,p_display_order=>23
,p_column_identifier=>'AG'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468266413762448008.4903)
,p_db_column_name=>'WS_APP_ID'
,p_display_order=>24
,p_column_identifier=>'AH'
,p_column_label=>unistr('Gew\00E4hlte Anwendung')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468266526969448008.4903)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>25
,p_column_identifier=>'AI'
,p_column_label=>unistr('Gew\00E4hlte Seite')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468266631391448008.4903)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>26
,p_column_identifier=>'AJ'
,p_column_label=>unistr('Gew\00E4hltes Daten-Grid')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468266714150448009.4903)
,p_db_column_name=>'ROW_ID'
,p_display_order=>27
,p_column_identifier=>'AK'
,p_column_label=>'Zeilen-ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(506407832739687549.4903)
,p_db_column_name=>'CONTENT_SIZE'
,p_display_order=>28
,p_column_identifier=>'AL'
,p_column_label=>unistr('Dateigr\00F6\00DFe')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455860417850078707.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(253998509295980827.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:903:&SESSION.::&DEBUG.:903,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(215736217437300382.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(253998509295980827.4903)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('Markierte Elemente l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(455075728117987482.4903)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'903'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(216398515770829833.4903)
,p_validation_name=>'must select files to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Die zu l\00F6schenden Dateien m\00FCssen angegeben werden.')
,p_when_button_pressed=>wwv_flow_api.id(215736217437300382.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045581730769367914.4903)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(253998509295980827.4903)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045581854494367915.4903)
,p_event_id=>wwv_flow_api.id(2045581730769367914.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(216337302480816498.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_ws_attachment.delete_doc (',
'    p_doc_id    => wwv_flow.g_f01(i)',
'    );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Dateien k\00F6nnen nicht gel\00F6scht werden.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(215736217437300382.4903)
,p_process_success_message=>unistr('Datei(en) wurde(n) gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253865428595436595.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create attachment collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_attachment_collection (',
'    p_ws_app_id    => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Collection konnte nicht erstellt werden.'
);
end;
/
prompt --application/pages/page_00904
begin
wwv_flow_api.create_page(
 p_id=>904.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Tags'
,p_step_title=>'Tags'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178833511282276941.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178841427914357467.4903)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(254015026794200479.4903)
,p_plug_name=>'Tags'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,n001,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''TAG_LABEL'',wwv_flow_escape.html(c002) ))||wwv_flow_item.hidden(2,n004)||wwv_flow_item.hidden(3,n005) delete_ck,',
'       n001 id,',
'       n002 ws_app_id,',
'       (select name from wwv_flow_ws_applications where id=to_number(n002) and security_group_id=:flow_security_group_id) app_name,',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id=to_number(n003) and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id=to_number(n004) and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n004 and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       c002 tag,',
'       d001 created_on,',
'       lower(c003) created_by,',
'       d002 updated_on,',
'       lower(c004) updated_by,           ''f?p=4900:913:''||:app_session||''::::WS_APP_ID,P913_ID:''||:ws_app_id||'',''||n001 icon_link,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-tag.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_TAGS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(254015101399200479.4903)
,p_name=>'Tags'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:913:&SESSION.::&DEBUG.:913:WS_APP_ID,P913_ID:&WS_APP_ID.,#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'ICON_LINK'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'TAG'
,p_icon_view_title_text=>'#PAGE_NAME#'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(217062512550046490.4903)
,p_db_column_name=>'DELETE_CK'
,p_display_order=>1
,p_column_identifier=>'W'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254015505263200486.4903)
,p_db_column_name=>'APP_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Anwendung'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254015705868200486.4903)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>'Seite'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:WS_APP_ID,P900_ID:&WS_APP_ID.,#WEBPAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254015915131200486.4903)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>4
,p_column_identifier=>'G'
,p_column_label=>'Daten-Grid'
,p_column_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:2:WS_APP_ID,P2_ID,P2_WEBSHEET_ID:&WS_APP_ID.,#WORKSHEET_ID#,#WEBSHEET_ID#'
,p_column_linktext=>'#DATA_GRID_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016105535200487.4903)
,p_db_column_name=>'COMPONENT_LEVEL'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Ebene'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016224943200487.4903)
,p_db_column_name=>'TAG'
,p_display_order=>6
,p_column_identifier=>'J'
,p_column_label=>'Tag'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016320667200487.4903)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>7
,p_column_identifier=>'K'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016412897200487.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>8
,p_column_identifier=>'L'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016519720200487.4903)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>9
,p_column_identifier=>'M'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(254016631211200488.4903)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255837324689545892.4903)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>11
,p_column_identifier=>'O'
,p_column_label=>'Worksheet-ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255837408454545892.4903)
,p_db_column_name=>'ICON_LINK'
,p_display_order=>12
,p_column_identifier=>'P'
,p_column_label=>'Symbollink'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255837509997545892.4903)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>13
,p_column_identifier=>'Q'
,p_column_label=>'Symbol-Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468318722581959111.4903)
,p_db_column_name=>'ID'
,p_display_order=>14
,p_column_identifier=>'R'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468318825419959112.4903)
,p_db_column_name=>'WS_APP_ID'
,p_display_order=>15
,p_column_identifier=>'S'
,p_column_label=>unistr('Gew\00E4hlte Anwendung')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468318925521959112.4903)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>16
,p_column_identifier=>'T'
,p_column_label=>unistr('Gew\00E4hlte Seite')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468319025753959113.4903)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>17
,p_column_identifier=>'U'
,p_column_label=>unistr('Gew\00E4hltes Websheet')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468319124883959113.4903)
,p_db_column_name=>'ROW_ID'
,p_display_order=>18
,p_column_identifier=>'V'
,p_column_label=>unistr('Gew\00E4hlte Zeile')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459069409427022751.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Tags k\00F6nnen verwendet werden, um die Suche und das Organisieren von Inhalten zu erleichtern. Tags k\00F6nnen f\00FCr Seiten und Daten-Grid-Zeilen verwendet werden.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(457294104555926987.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(254015026794200479.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:904:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(217107102639053085.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(254015026794200479.4903)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('Markierte Elemente l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(455076111625992229.4903)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'904'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(217122108179054722.4903)
,p_validation_name=>'must select tags to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Die zu l\00F6schenden Tags m\00FCssen angegeben werden.')
,p_when_button_pressed=>wwv_flow_api.id(217107102639053085.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045581906703367916.4903)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(254015026794200479.4903)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045582057080367917.4903)
,p_event_id=>wwv_flow_api.id(2045581906703367916.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(217137013720056285.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_ws_api.delete_tag (',
'    p_tag_id         => wwv_flow.g_f01(i),',
'    p_websheet_id    => wwv_flow.g_f02(i),',
'    p_row_id         => wwv_flow.g_f03(i)',
'    );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Tags k\00F6nnen nicht gel\00F6scht werden.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(217107102639053085.4903)
,p_process_success_message=>unistr('Tags gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(254013515649190350.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create tag collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_tag_collection (',
'    p_ws_app_id    => :WS_APP_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Collection konnte nicht erstellt werden.'
);
end;
/
prompt --application/pages/page_00905
begin
wwv_flow_api.create_page(
 p_id=>905.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Hinweise'
,p_step_title=>'Hinweise'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178833921325279839.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178841631031358270.4903)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178845117141401629.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Datenspaltenzeilen und Seiten k\00F6nnen Hinweise hinzugef\00FCgt werden.  Mit Hinweisen k\00F6nnen Sie Inhalte kommentieren.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(255846828818688350.4903)
,p_plug_name=>'Notes'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,n001,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'    wwv_flow_lang.system_message(''NOTE_LABEL'',wwv_flow_escape.html(c002))',
') delete_ck,',
'       n001 id,',
'       n002 ws_app_id,',
'       (select name from wwv_flow_ws_applications where id = n002 and security_group_id=:flow_security_group_id) app_name,',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id = n003 and ws_app_id = n002 and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id = n004 and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n004 and ws_app_id = n002 and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       substr(c002,1,255) content,',
'       substr(c002,1,25) short_content_str,',
'       d001 created_on,',
'       lower(c003) created_by,',
'       d002 updated_on,',
'       lower(c004) updated_by,    ',
'       ''f?p=4900:914:''||:app_session||'':::914:WS_APP_ID,P914_ID:''||:WS_APP_ID||'',''||n001 icon_link,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-note.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_NOTES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(255846907421688350.4903)
,p_name=>'Notes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:914:&SESSION.::&DEBUG.:914:WS_APP_ID,P914_ID:&WS_APP_ID.,#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'ICON_LINK'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'SHORT_CONTENT_STR'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(216493801619854176.4903)
,p_db_column_name=>'DELETE_CK'
,p_display_order=>1
,p_column_identifier=>'X'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255847327303688360.4903)
,p_db_column_name=>'APP_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Anwendung'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255847528785688360.4903)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>'Seite'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:WS_APP_ID,P900_ID:&WS_APP_ID.,#WEBPAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255847705165688361.4903)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>4
,p_column_identifier=>'G'
,p_column_label=>unistr('Gew\00E4hltes Daten-Grid')
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255847815498688361.4903)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>5
,p_column_identifier=>'H'
,p_column_label=>'Daten-Grid'
,p_column_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:2:WS_APP_ID,P2_ID,P2_WEBSHEET_ID:&WS_APP_ID.,#WORKSHEET_ID#,#WEBSHEET_ID#'
,p_column_linktext=>'#DATA_GRID_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848000730688361.4903)
,p_db_column_name=>'COMPONENT_LEVEL'
,p_display_order=>6
,p_column_identifier=>'J'
,p_column_label=>'Ebene'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848106005688361.4903)
,p_db_column_name=>'CONTENT'
,p_display_order=>7
,p_column_identifier=>'K'
,p_column_label=>'Hinweis'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848230986688361.4903)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>8
,p_column_identifier=>'L'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848319906688362.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>9
,p_column_identifier=>'M'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848431948688362.4903)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848520550688362.4903)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'O'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848601377688362.4903)
,p_db_column_name=>'ICON_LINK'
,p_display_order=>12
,p_column_identifier=>'P'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255848724775688362.4903)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>13
,p_column_identifier=>'Q'
,p_column_label=>'Bild'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255849126439697754.4903)
,p_db_column_name=>'SHORT_CONTENT_STR'
,p_display_order=>14
,p_column_identifier=>'R'
,p_column_label=>'Kurzer Inhalts-Str'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468284710769652942.4903)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'S'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468284830411652942.4903)
,p_db_column_name=>'WS_APP_ID'
,p_display_order=>16
,p_column_identifier=>'T'
,p_column_label=>unistr('Gew\00E4hlte Anwendung')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468284923837652942.4903)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>17
,p_column_identifier=>'U'
,p_column_label=>unistr('Gew\00E4hlte Seite')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468285003913652943.4903)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>18
,p_column_identifier=>'V'
,p_column_label=>unistr('Gew\00E4hltes Daten-Grid')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468285114403652943.4903)
,p_db_column_name=>'ROW_ID'
,p_display_order=>19
,p_column_identifier=>'W'
,p_column_label=>unistr('Gew\00E4hlte Zeile')
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(457292318276921480.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(255846828818688350.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(216585325298870404.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(255846828818688350.4903)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('Markierte Elemente l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(455076625477996183.4903)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'905'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(216615403612873638.4903)
,p_validation_name=>'must select notes to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Die zu l\00F6schenden Hinweise m\00FCssen angegeben werden.')
,p_when_button_pressed=>wwv_flow_api.id(216585325298870404.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045582148887367918.4903)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(255846828818688350.4903)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045582210366367919.4903)
,p_event_id=>wwv_flow_api.id(2045582148887367918.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(216600231186872101.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked notes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_ws_api.delete_note (',
'    p_note_id        => wwv_flow.g_f01(i));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Hinweise k\00F6nnen nicht gel\00F6scht werden.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(216585325298870404.4903)
,p_process_success_message=>unistr('Hinweise gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(255845516826676042.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create note collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_note_collection (',
'    p_ws_app_id => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Collection konnte nicht erstellt werden.'
);
end;
/
prompt --application/pages/page_00906
begin
wwv_flow_api.create_page(
 p_id=>906.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Annotationen'
,p_step_title=>'Annotationen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187171600866872737.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(187172721816905251.4903)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(255851308915773521.4903)
,p_plug_name=>'Annotations'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select n001 id,',
'       wwv_flow_item.text_from_lov(''ATTACHMENT'',''ANNOTATION TYPE'') annotation_type,       ',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id=to_number(n003) and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id=to_number(n004) and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n004 and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       c002 annotation_name,',
'       ''f?p=4900:912:''||:app_session||'':::912:WS_APP_ID,P912_ID:''||',
'          :WS_APP_ID||'',''||n001 edit_url,       ',
'       d002 created_on,',
'       lower(c009) created_by,',
'       d003 updated_on,',
'       lower(c010) updated_by,',
'       c007 icon_name,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-file.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_FILES''',
'union all',
'select n001 id,',
'       wwv_flow_item.text_from_lov(''TAG'',''ANNOTATION TYPE'') annotation_type,',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id=to_number(n003) and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id=to_number(n004) and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n004 and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       substr(c002,1,255) annotation_name,',
'       ''f?p=4900:913:''||:app_session||'':::913:WS_APP_ID,P913_ID:''||',
'          :ws_app_id||'',''||n001 edit_url,',
'       d001 created_on,',
'       lower(c003) created_by,',
'       d002 updated_on,',
'       lower(c004) updated_by,',
'       c002 icon_name,    ',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-tag.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_TAGS''',
'union all',
'select n001 id,',
'       wwv_flow_item.text_from_lov(''NOTE'',''ANNOTATION TYPE'') annotation_type,',
'       n003 webpage_id,',
'       (select name from wwv_flow_ws_webpages where id=to_number(n003) and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) page_name,',
'       n004 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id=to_number(n004) and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n004 and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) data_grid_name,',
'       n005 row_id,',
'       c001 component_level,',
'       substr(c002,1,255) annotation_name,',
'       ''f?p=4900:914:''||:app_session||'':::914:WS_APP_ID,P914_ID:''||',
'          :ws_app_id||'',''||n001 edit_url,        ',
'       d001 created_on,',
'       lower(c003) created_by,',
'       d002 updated_on,',
'       lower(c004) updated_by,',
'       substr(c002,1,25) icon_name,    ',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-note.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_NOTES''',
'union all',
'select n003 id,',
'       wwv_flow_item.text_from_lov(''LINK'',''ANNOTATION TYPE'') annotation_type,',
'       null webpage_id,',
'       null page_name,',
'       n001 websheet_id,',
'       (select w.id from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr ws where w.id=ws.worksheet_id and ws.id=to_number(n001) and w.security_group_id=:flow_security_group_id) worksheet_id,',
'       (select websheet_name from wwv_flow_ws_websheet_attr where id=n001 and ws_app_id=to_number(n002) and security_group_id=:flow_security_group_id) data_grid_name,',
'       to_number(c003) row_id,',
'       ''ROW'' component_level,',
'       substr(c001,1,255) annotation_name,',
'       ''f?p=4900:916:''||:app_session||'':::916:WS_APP_ID,P916_ID:''||',
'          :ws_app_id||'',''||n003 edit_url,        ',
'       d001 created_on,',
'       lower(c005) created_by,',
'       d002 updated_on,',
'       lower(c006) updated_by,',
'       substr(c001,1,25) icon_name,    ',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-link.png'' icon_img',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_LINKS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(255851412641773521.4903)
,p_name=>'Annotations'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'#EDIT_URL#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'EDIT_URL'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'ICON_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852005950773543.4903)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Seite'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:WS_APP_ID,P900_ID:&WS_APP_ID.,#WEBPAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852225637773544.4903)
,p_db_column_name=>'WORKSHEET_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Worksheet-ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852309332773544.4903)
,p_db_column_name=>'DATA_GRID_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Daten-Grid'
,p_column_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:2:WS_APP_ID,P2_ID,P2_WEBSHEET_ID:&WS_APP_ID.,#WORKSHEET_ID#,#WEBSHEET_ID#'
,p_column_linktext=>'#DATA_GRID_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852511097773544.4903)
,p_db_column_name=>'COMPONENT_LEVEL'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Ebene'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_api.id(455012825948829772)
,p_rpt_show_filter_lov=>'1'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852728494773546.4903)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852805571773546.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255852910617773546.4903)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255853021972773546.4903)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255853110913773547.4903)
,p_db_column_name=>'ICON_NAME'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Symbolname'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255853322750773547.4903)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Symbol-Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(255854313681798109.4903)
,p_db_column_name=>'ANNOTATION_TYPE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Annotationstyp'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(457286624070866412.4903)
,p_db_column_name=>'ANNOTATION_NAME'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Annotation'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(457286720645866413.4903)
,p_db_column_name=>'EDIT_URL'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'URL'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468758308584087246.4903)
,p_db_column_name=>'ID'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468758413655087251.4903)
,p_db_column_name=>'WEBPAGE_ID'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Webseite'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468758505213087251.4903)
,p_db_column_name=>'WEBSHEET_ID'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Websheet'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468758628616087252.4903)
,p_db_column_name=>'ROW_ID'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'Zeile'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458959507555586977.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Sie k\00F6nnen Seiten und Daten in Daten-Grids mit Anmerkungen in Form von Dateien, Hinweisen und Tags versehen.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458962423532620027.4903)
,p_plug_name=>'Dateien'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Dateien und Bilder k\00F6nnen den Seiten und Daten-Grid-Zeilen angeh\00E4ngt werden.  </p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458962906956643565.4903)
,p_plug_name=>'Tags'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Seiten und Daten-Grid-Zeilen k\00F6nnen mit Tags versehen werden.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(458963413883645600.4903)
,p_plug_name=>'Hinweise'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Seiten und Daten-Grid-Zeilen k\00F6nnen mit Hinweisen versehen werden.  Hinweise sind f\00FCr jeden sichtbar.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(636365309755668891.4903)
,p_plug_name=>'Links'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Links k\00F6nnen nur Daten-Grid-Zeilen hinzugef\00FCgt werden.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455858606984066110.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(255851308915773521.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.:906,RIR::'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(455075113226983193.4903)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'906'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(454878913193530039.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create annotations collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_attachment_collection (',
'    p_ws_app_id    => :ws_app_id',
'    );',
'wwv_flow_ws_api.create_tag_collection (',
'    p_ws_app_id    => :WS_APP_ID',
'    );',
'wwv_flow_ws_api.create_note_collection (',
'    p_ws_app_id => :ws_app_id',
'    );',
'wwv_flow_ws_api.create_link_collection (',
'    p_ws_app_id => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00908
begin
wwv_flow_api.create_page(
 p_id=>908.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Seite kopieren'
,p_step_title=>'Seite kopieren'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(10604302945264867.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188038326108736234.4903)
,p_plug_name=>'Seite kopieren'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436571609692152874.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_COPY_PAGE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486257504103048552.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(10604302945264867.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(486257708807048555.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(10604302945264867.4903)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Seite kopieren'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(486258017609052488.4903)
,p_branch_action=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(486257708807048555.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20335603319481351.4903)
,p_name=>'P908_NEW_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(188038326108736234.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471671317758579229.4903)
,p_name=>'P908_COPY_PAGE_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(188038326108736234.4903)
,p_prompt=>'Seite kopieren aus'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die zu kopierende Seite an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471671528839582487.4903)
,p_name=>'P908_COPY_TO_PAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(188038326108736234.4903)
,p_prompt=>'Neuer Seitenname'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_from_page_name varchar2(4000) := null;',
'begin',
'  for c1 in (select name',
'             from wwv_flow_ws_webpages',
'             where ws_app_id = :WS_APP_ID',
'             and security_group_id = :flow_security_group_id',
'             and id = :P908_COPY_PAGE_FROM)',
'  loop',
'      l_from_page_name := c1.name;',
'  end loop;',
'  return wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',l_from_page_name);',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt den Namen der neuen Seite an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(486259417871071420.4903)
,p_validation_name=>'P908_COPY_TO_PAGE_NAME'
,p_validation_sequence=>10
,p_validation=>'P908_COPY_TO_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Wert erforderlich'
,p_when_button_pressed=>wwv_flow_api.id(486257708807048555.4903)
,p_associated_item=>wwv_flow_api.id(471671528839582487.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(486257219210043510.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.copy_page (',
'    p_ws_app_id        => :ws_app_id,',
'    p_webpage_id       => :p900_id,',
'    p_new_name         => :P908_COPY_TO_PAGE_NAME,',
'    --',
'    p_new_page_id      => :P908_NEW_PAGE_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>'Seite kopiert.'
);
end;
/
prompt --application/pages/page_00910
begin
wwv_flow_api.create_page(
 p_id=>910.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Neuer Abschnitt'
,p_step_title=>'Neuer Abschnitt'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174268512533615218.4903)
,p_plug_name=>'Text Section'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174271304004645983.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(217644509082961167.4903)
,p_plug_name=>'Daten-Grid-SQL-Syntax'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.data_grid_sql_help (',
'    p_app_id       => :app_id,',
'    p_app_session  => :app_session,',
'    p_ws_app_id    => :ws_app_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_header=>'Um die Daten-Grid-SQL-Syntax anzuzeigen, klicken Sie auf einen Daten-Grid-Namen:'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436563711798030455.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_TEXT_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174271912792658011.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(174271304004645983.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174272226645661950.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(174271304004645983.4903)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Abschnitt erstellen'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174374610834991383.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(174271304004645983.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(174272529571661951.4903)
,p_branch_action=>'f?p=&FLOW_ID.:900:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(174272226645661950.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18723303895978880.4903)
,p_name=>'P910_METHOD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4903)
,p_item_default=>'NORMAL'
,p_prompt=>'Methode'
,p_source=>'NORMAL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE TEXT SECTION METHOD'
,p_lov=>'.'||wwv_flow_api.id(18725515716010637.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(18730825582055709.4903)
,p_name=>'P910_COLUMN_HEADINGS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4903)
,p_item_default=>'Y'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'FIRST_ROW_CONTAINS_COLUMN_HEADINGS'
,p_lov=>'.'||wwv_flow_api.id(799517811838484369.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174269508244628245.4903)
,p_name=>'P910_SECTION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4903)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174270318633631244.4903)
,p_name=>'P910_TITLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4903)
,p_prompt=>unistr('\00DCberschrift')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Titel des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174425118771833503.4903)
,p_name=>'P910_DISPLAY_SEQ'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4903)
,p_prompt=>'Sequenz'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie die Anzeigereihenfolge des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(379982713574846288.4903)
,p_name=>'P910_CONTENT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4903)
,p_prompt=>'Inhalt'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>15
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Geben Sie den Content des Seitenabschnitts ein. Um die Formatierung zu \00E4ndern, klicken Sie auf das Symbol "Symbolleiste einblenden" oben rechts. Weitere Informationen \00FCber die Markup-Syntax finden Sie in der Online-Hilfe.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_section_clob ( ',
'    p_item_name        => ''P910_CONTENT'',',
'    p_section_id       => :P910_SECTION_ID);'))
,p_attribute_02=>'CKEDITOR-Full'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(380327123317877450.4903)
,p_name=>'P910_SPREADSHEET'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(174268512533615218.4903)
,p_prompt=>unistr('Arbeitsblattdaten einf\00FCgen')
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>15
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P910_METHOD'
,p_display_when2=>'SPREADSHEET'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('F\00FCgen Sie ein Arbeitsblatt mit zwei Spalten oder andere durch Tabulator getrennte Daten unten ein. Die erste Spalte muss den Abschnittstitel und die zweite Spalte den Abschnittscontent enthalten.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(174458707081161234.4903)
,p_computation_sequence=>10
,p_computation_item=>'P910_DISPLAY_SEQ'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(174540423282260522.4903)
,p_validation_name=>'P910_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P910_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Die Anzeigereihenfolge muss angegeben werden.'
,p_validation_condition=>'P910_METHOD'
,p_validation_condition2=>'NORMAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(174272226645661950.4903)
,p_associated_item=>wwv_flow_api.id(174425118771833503.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(174540832286263166.4903)
,p_validation_name=>'P910_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P910_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Titel muss angegeben werden.'
,p_validation_condition=>'P910_METHOD'
,p_validation_condition2=>'NORMAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(174272226645661950.4903)
,p_associated_item=>wwv_flow_api.id(174270318633631244.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(487999914043996835.4903)
,p_validation_name=>'P910_CONTENT contains valid sql'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_content clob;',
'begin',
'  l_content := wwv_flow_utilities.get_clob_textarea_value(p_item_name => ''P910_CONTENT'');  ',
'  ',
'  return wwv_flow_ws_security.str_contains_valid_sql (',
'    p_ws_app_id    => :WS_APP_ID,',
'    p_page_id      => :P900_ID,',
'    p_section_id   => :P910_SECTION_ID,',
'    p_string       => l_content);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_validation_condition=>'P910_METHOD'
,p_validation_condition2=>'NORMAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(174272226645661950.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(397544527893902326.4903)
,p_validation_name=>'P910_SPREADSHEET not null'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_spreadsheet clob;',
'begin',
'  l_spreadsheet := wwv_flow_utilities.get_clob_textarea_value(p_item_name => ''P910_SPREADSHEET'');',
'  ',
'  if (nvl(sys.dbms_lob.getlength(l_spreadsheet),0) = 0) then',
'    return false;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Sie m\00FCssen Arbeitsblattdaten einf\00FCgen, um Abschnitte zu erstellen.')
,p_validation_condition=>'P910_METHOD'
,p_validation_condition2=>'SPREADSHEET'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(174272226645661950.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(18756032619185846.4903)
,p_name=>'show hide upload spreadsheet item'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P910_METHOD'
,p_condition_element=>'P910_METHOD'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NORMAL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(18756323145185847.4903)
,p_event_id=>wwv_flow_api.id(18756032619185846.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P910_COLUMN_HEADINGS,P910_SPREADSHEET'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(18756511288185847.4903)
,p_event_id=>wwv_flow_api.id(18756032619185846.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P910_COLUMN_HEADINGS,P910_SPREADSHEET'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(18757120629191891.4903)
,p_name=>'show hide seq, title, content'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P910_METHOD'
,p_condition_element=>'P910_METHOD'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPREADSHEET'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(18757410206191891.4903)
,p_event_id=>wwv_flow_api.id(18757120629191891.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P910_DISPLAY_SEQ,P910_TITLE,P910_CONTENT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(18757607040191891.4903)
,p_event_id=>wwv_flow_api.id(18757120629191891.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P910_DISPLAY_SEQ,P910_TITLE,P910_CONTENT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(174539227999252468.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create new section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (',
'    p_section_id       => :P910_SECTION_ID,   ',
'    p_ws_app_id        => :WS_APP_ID, ',
'    p_webpage_id       => :P900_ID,',
'    p_section_type     => ''TEXT'',',
'    p_display_seq      => :P910_DISPLAY_SEQ,',
'    p_title            => :P910_TITLE,',
'    --',
'    p_clob_item_name   => ''P910_CONTENT'');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Abschnitt konnte nicht erstellt werden.'
,p_process_when_button_id=>wwv_flow_api.id(174272226645661950.4903)
,p_process_when=>'P910_METHOD'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NORMAL'
,p_process_success_message=>'Neuer Abschnitt erstellt.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(18729515201048337.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create multiple section from spreadsheet'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_import.import_text_sections (    ',
'    p_ws_app_id           => :WS_APP_ID,        ',
'    p_webpage_id          => :P900_ID,',
'    p_collection_name     => ''P910_SPREADSHEET'',',
'    p_headings_included   => :P910_COLUMN_HEADINGS',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Textabschnitte konnten nicht erstellt werden.'
,p_process_when_button_id=>wwv_flow_api.id(174272226645661950.4903)
,p_process_when=>'P910_METHOD'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SPREADSHEET'
,p_process_success_message=>'Textabschnitte erstellt.'
);
end;
/
prompt --application/pages/page_00912
begin
wwv_flow_api.create_page(
 p_id=>912.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Dateidetails'
,p_step_title=>'Dateidetails'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20825624122113669.4903)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454921121386829978.4903)
,p_plug_name=>'Dateidetails'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454925804722991135.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(454996211966466267.4903)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456339419601597354.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Sie k\00F6nnen den Dateinamen und Alias bearbeiten. Mit der Bild- oder Dateisyntax (siehe Hilfe > Markup-Syntax) k\00F6nnen Sie diese Datei auf einer beliebigen Seite referenzieren.')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_required_role=>wwv_flow_api.id(456220226828170850)
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(454996400668472429.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(454996211966466267.4903)
,p_button_name=>'VIEW_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Seite anzeigen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::WS_APP_ID,P900_ID:&WS_APP_ID.,&P912_PAGE_ID.'
,p_button_condition=>'P912_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(454997519977496975.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(454996211966466267.4903)
,p_button_name=>'VIEW_ROW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Zeile anzeigen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:20:WS_APP_ID,P2_ID,P2_WEBSHEET_ID,CURRENT_WORKSHEET_ROW:&WS_APP_ID.,&P912_WORKSHEET_ID.,&P912_DATA_GRID_ID.,&P912_ROW_ID.'
,p_button_condition=>'P912_DATA_GRID_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455024118479988502.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(454996211966466267.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(456296125835249091.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(454996211966466267.4903)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE2'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(456293003971214419.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(454996211966466267.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(456293413667217260.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454927807155067573.4903)
,p_name=>'P912_FILENAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dateiname'
,p_source=>'''<a href="''||wwv_flow_ws_attachment.get_ws_file_src(to_number(:P912_ID))||''">''||wwv_flow_escape.html(:P912_FILENAME)||''</a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_protection_level=>'I'
,p_help_text=>'Gibt den Namen der Datei an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454928020661071393.4903)
,p_name=>'P912_DESCRIPTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4903)
,p_prompt=>'Beschreibung'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Beschreibender Text der Datei.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454928813866078946.4903)
,p_name=>'P912_DATA_GRID_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4903)
,p_prompt=>'Daten-Grid'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P912_DATA_GRID_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt das Daten-Grid an, dem die Datei zugeordnet ist.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454929223216081604.4903)
,p_name=>'P912_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4903)
,p_prompt=>'Seite'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P912_PAGE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Gibt die Seite an, der die Datei angeh\00E4ngt ist.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454929614343088547.4903)
,p_name=>'P912_CREATED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4903)
,p_prompt=>'Erstellt'
,p_format_mask=>'SINCE'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Zeigt das Datum an, an dem die Datei hochgeladen wurde.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454929929927093047.4903)
,p_name=>'P912_CREATED_BY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4903)
,p_prompt=>'Erstellt von'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifiziert den Benutzer, der die Datei hochgeladen hat.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454930108241096224.4903)
,p_name=>'P912_UPDATED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4903)
,p_prompt=>'Aktualisiert'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifiziert das Datum, an dem die Dateidefinition zuletzt aktualisiert wurde.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454930705732114408.4903)
,p_name=>'P912_UPDATED_BY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4903)
,p_prompt=>'Aktualisiert von'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifiziert den Benutzer, der die Datei zuletzt aktualisiert hat.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454995621615440707.4903)
,p_name=>'P912_ROW_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(20825624122113669.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454996028803461699.4903)
,p_name=>'P912_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20825624122113669.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(454999414399542710.4903)
,p_name=>'P912_WORKSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(20825624122113669.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455012320969818934.4903)
,p_name=>'P912_COMPONENT_LEVEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4903)
,p_prompt=>'Annotationsebene'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COMPONENT_LEVEL'
,p_lov=>'.'||wwv_flow_api.id(455012825948829772.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Annotationsebene an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455846709212527413.4903)
,p_name=>'P912_IMAGE_ALIAS'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4903)
,p_prompt=>'Alias'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('F\00FCr die Einbettung von Links oder Bildlinks in Seitenabschnitten wird ein Dateialiasname verwendet. Ein Dateialiasname muss in der Anwendung eindeutig sein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455846927220532619.4903)
,p_name=>'P912_IMAGE_ATTRIBUTES'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(454921121386829978.4903)
,p_prompt=>'Bildattribute'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie zus\00E4tzliche Dateiattribute ein, die im Imagelink eingeschlossen werden sollen, wie H\00F6he, Breite, Alt oder Titel. '),
'',
'<p>width="36"</p>',
'<p>title="Mein Image"</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(6730817016243915.4903)
,p_validation_name=>'P912_IMAGE_ALIAS is valid'
,p_validation_sequence=>10
,p_validation=>'P912_IMAGE_ALIAS'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'Alias muss alphanumerisch sein.'
,p_validation_condition=>'P912_IMAGE_ALIAS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(456296125835249091.4903)
,p_associated_item=>wwv_flow_api.id(455846709212527413.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2077294070799630404.4903)
,p_validation_name=>'P912_IMAGE_ALIAS must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_id           => :P912_ID,',
'    p_alias        => :P912_IMAGE_ALIAS,',
'    p_alias_type   => ''FILE'') then',
'    return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Alias bereits vorhanden. Geben Sie einen anderen Alias ein.'
,p_validation_condition=>'P912_IMAGE_ALIAS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(455846709212527413.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(456295425358239503.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete attachment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_attachment.delete_doc (',
'    p_doc_id    => :P912_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Datei kann nicht gel\00F6scht werden.')
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('Datei gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(456306916194350402.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'change img attr'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_attachment.change_image_attr (',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_file_id          => :P912_ID,',
'    p_page_id          => :P912_PAGE_ID, ',
'    p_image_alias      => :P912_IMAGE_ALIAS,',
'    p_image_attributes => :P912_IMAGE_ATTRIBUTES,',
'    p_description      => :P912_DESCRIPTION',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Dateiupdates konnten nicht gespeichert werden.'
,p_process_when_button_id=>wwv_flow_api.id(456296125835249091.4903)
,p_process_success_message=>'Dateiupdates gespeichert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(454995411919437874.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get attachment info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_attachment_info (    ',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_id              => :P912_ID,',
'    p_component_level => :P912_COMPONENT_LEVEL,',
'    p_webpage_id      => :P912_PAGE_ID,',
'    p_worksheet_id    => :P912_WORKSHEET_ID,',
'    p_websheet_id     => :P912_DATA_GRID_ID,',
'    p_row_id          => :P912_ROW_ID,    ',
'    p_name            => :P912_FILENAME,',
'    p_image_alias     => :P912_IMAGE_ALIAS,',
'    p_image_attributes => :P912_IMAGE_ATTRIBUTES,',
'    p_description     => :P912_DESCRIPTION,',
'    p_created_on      => :P912_CREATED,',
'    p_created_by      => :P912_CREATED_BY,',
'    p_updated_on      => :P912_UPDATED,',
'    p_updated_by      => :P912_UPDATED_BY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Anhanginformationen konnten nicht abgerufen werden.'
);
end;
/
prompt --application/pages/page_00913
begin
wwv_flow_api.create_page(
 p_id=>913.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Tag-Details'
,p_step_title=>'Tag-Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(132335222168705130.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455028903657058336.4903)
,p_plug_name=>'Tag-Details'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455031730948058349.4903)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455077823315014545.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455031921901058350.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(455031730948058349.4903)
,p_button_name=>'VIEW_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Seite anzeigen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::WS_APP_ID,P900_ID:&WS_APP_ID.,&P913_PAGE_ID.'
,p_button_condition=>'P913_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455032120704058351.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(455031730948058349.4903)
,p_button_name=>'VIEW_ROW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Zeile anzeigen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:20:WS_APP_ID,P2_ID,P2_WEBSHEET_ID,CURRENT_WORKSHEET_ROW:&WS_APP_ID.,&P913_WORKSHEET_ID.,&P913_DATA_GRID_ID.,&P913_ROW_ID.'
,p_button_condition=>'P913_DATA_GRID_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455032319023058352.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(455031730948058349.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626877529699552002.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(455031730948058349.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(626877321041549461.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455029112237058339.4903)
,p_name=>'P913_ROW_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(132335222168705130.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455029331137058341.4903)
,p_name=>'P913_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(132335222168705130.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455029520826058341.4903)
,p_name=>'P913_WORKSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(132335222168705130.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455029706994058342.4903)
,p_name=>'P913_COMPONENT_LEVEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4903)
,p_prompt=>'Annotationsebene'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COMPONENT_LEVEL'
,p_lov=>'.'||wwv_flow_api.id(455012825948829772.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Annotationsebene an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455030314177058344.4903)
,p_name=>'P913_DATA_GRID_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4903)
,p_prompt=>'Daten-Grid'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P913_DATA_GRID_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Gibt das Daten-Grid an, dem das Tag hinzugef\00FCgt wird.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455030505077058345.4903)
,p_name=>'P913_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4903)
,p_prompt=>'Seite'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P913_PAGE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Gibt die Seite an, der das Tag hinzugef\00FCgt wird.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455030709396058345.4903)
,p_name=>'P913_CREATED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4903)
,p_prompt=>'Erstellt'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Das Datum, an dem das Tag erstellt wurde.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455030925696058346.4903)
,p_name=>'P913_CREATED_BY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4903)
,p_prompt=>'Erstellt von'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Der Benutzer, der das Tag erstellt hat.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455031115888058346.4903)
,p_name=>'P913_UPDATED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4903)
,p_prompt=>'Aktualisiert'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Das Datum, an dem die Tagdefinition zuletzt aktualisiert wurde.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455031329370058347.4903)
,p_name=>'P913_UPDATED_BY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4903)
,p_prompt=>'Aktualisiert von'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Der Benutzer, der das Tag zuletzt aktualisiert hat.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455072104690914526.4903)
,p_name=>'P913_TAG'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(455028903657058336.4903)
,p_prompt=>'Tag'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt das definierte Tag an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(626877030260542686.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete tag'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_tag (',
'    p_tag_id         => :P913_ID,',
'    p_websheet_id    => :P913_DATA_GRID_ID,',
'    p_row_id         => :P913_ROW_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Tag konnte nicht gel\00F6scht werden.')
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('Das Tag wurde gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(455032518299058353.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get tag info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_tag_info (    ',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_id              => :P913_ID,',
'    p_component_level => :P913_COMPONENT_LEVEL,',
'    p_webpage_id      => :P913_PAGE_ID,',
'    p_worksheet_id    => :P913_WORKSHEET_ID,',
'    p_websheet_id     => :P913_DATA_GRID_ID,',
'    p_row_id          => :P913_ROW_ID,    ',
'    p_tag             => :P913_TAG,   ',
'    p_created_on      => :P913_CREATED,',
'    p_created_by      => :P913_CREATED_BY,',
'    p_updated_on      => :P913_UPDATED,',
'    p_updated_by      => :P913_UPDATED_BY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Tag-Informationen konnten nicht abgerufen werden.'
);
end;
/
prompt --application/pages/page_00914
begin
wwv_flow_api.create_page(
 p_id=>914.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Hinweisdetails'
,p_step_title=>'Hinweisdetails'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(126670928141987745.4903)
,p_plug_name=>'Toolbar Right Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(139891328812587007.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455080213732034100.4903)
,p_plug_name=>'Note Details'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455084129596044740.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455082826806034113.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(126670928141987745.4903)
,p_button_name=>'VIEW_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Seite anzeigen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::WS_APP_ID,P900_ID:&WS_APP_ID.,&P914_PAGE_ID.'
,p_button_condition=>'P914_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455083012275034115.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(126670928141987745.4903)
,p_button_name=>'VIEW_ROW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Zeile anzeigen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:20:WS_APP_ID,P2_ID,P2_WEBSHEET_ID,CURRENT_WORKSHEET_ROW:&WS_APP_ID.,&P914_WORKSHEET_ID.,&P914_DATA_GRID_ID.,&P914_ROW_ID.'
,p_button_condition=>'P914_DATA_GRID_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(458497018601587323.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(126670928141987745.4903)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CHANGE'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(455083231583034115.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(126670928141987745.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(458497605573593064.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(126670928141987745.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(458497817136593066.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455080402345034106.4903)
,p_name=>'P914_ROW_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(139891328812587007.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455080624318034107.4903)
,p_name=>'P914_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(139891328812587007.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455080810711034107.4903)
,p_name=>'P914_WORKSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(139891328812587007.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455081000524034108.4903)
,p_name=>'P914_COMPONENT_LEVEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4903)
,p_prompt=>'Annotationsebene'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COMPONENT_LEVEL'
,p_lov=>'.'||wwv_flow_api.id(455012825948829772.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Annotationsebene an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455081210912034108.4903)
,p_name=>'P914_NOTE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4903)
,p_prompt=>'Hinweis'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>10
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Geben Sie den Inhalt des Hinweises ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455081401089034109.4903)
,p_name=>'P914_DATA_GRID_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4903)
,p_prompt=>'Daten-Grid'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P914_DATA_GRID_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Gibt das Daten-Grid an, dem der Hinweis hinzugef\00FCgt wurde.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455081632086034109.4903)
,p_name=>'P914_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4903)
,p_prompt=>'Seite'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P914_PAGE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Gibt die Seite an, der der Hinweis hinzugef\00FCgt wurde.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455081814247034110.4903)
,p_name=>'P914_CREATED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4903)
,p_prompt=>'Erstellt'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Das Datum, an dem der Hinweis erstellt wurde.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455082027328034110.4903)
,p_name=>'P914_CREATED_BY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4903)
,p_prompt=>'Erstellt von'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Der Benutzer, der den Hinweis erstellt hat.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455082224099034111.4903)
,p_name=>'P914_UPDATED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4903)
,p_prompt=>'Aktualisiert'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Das Datum, an dem die Hinweisdefinition zuletzt aktualisiert wurde.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(455082418097034111.4903)
,p_name=>'P914_UPDATED_BY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(455080213732034100.4903)
,p_prompt=>'Aktualisiert von'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Der Benutzer, der den Hinweis zuletzt aktualisiert hat.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(458498722935626413.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_note (',
'    p_note_id        => :P914_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Hinweis konnte nicht gel\00F6scht werden.')
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('Hinweis gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(458499128738647021.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.add_note (',
'    p_ws_app_id        => :ws_app_id,        ',
'    p_webpage_id       => :p900_id,',
'    p_note_id          => :P914_ID,',
'    p_component_level  => :P914_COMPONENT_LEVEL,',
'    p_content          => :P914_NOTE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Hinweis konnte nicht aktualisiert werden.'
,p_process_when_button_id=>wwv_flow_api.id(458497018601587323.4903)
,p_process_success_message=>'Hinweis aktualisiert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(455083627741034117.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get note info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_note_info (    ',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_id              => :P914_ID,',
'    p_component_level => :P914_COMPONENT_LEVEL,',
'    p_webpage_id      => :P914_PAGE_ID,',
'    p_worksheet_id    => :P914_WORKSHEET_ID,',
'    p_websheet_id     => :P914_DATA_GRID_ID,',
'    p_row_id          => :P914_ROW_ID,    ',
'    p_note            => :P914_NOTE,   ',
'    p_created_on      => :P914_CREATED,',
'    p_created_by      => :P914_CREATED_BY,',
'    p_updated_on      => :P914_UPDATED,',
'    p_updated_by      => :P914_UPDATED_BY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Hinweisinformationen konnten nicht abgerufen werden.'
);
end;
/
prompt --application/pages/page_00915
begin
wwv_flow_api.create_page(
 p_id=>915.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Links'
,p_step_title=>'Links'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473082104205043499.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473082812327046503.4903)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473373204887098955.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Links k\00F6nnen zu Daten-Grid-Zeilen hinzugef\00FCgt werden. Zeigen Sie mit diesem Bericht alle Links in allen Daten-Grids an.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(479800700877656094.4903)
,p_plug_name=>'Links'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select   wwv_flow_item.checkbox(1,n003,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''LINK_LABEL'',wwv_flow_escape.html(c001) )) delete_ck,',
'         n003 id,',
'         n001 data_grid_id,',
'         n002 ws_app_id,',
'         d001 created_on,',
'         d002 updated_on,',
'         c001 link_name,',
'         c002 url,',
'         c003 row_id,',
'         c004 tags,',
'         c005 created_by,',
'         c006 updated_by,',
'       ''f?p=4900:916:''||:app_session||'':::916:WS_APP_ID,P916_ID:''||:WS_APP_ID||'',''||n003 icon_link,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-link.png'' icon_img,',
'              ''f?p=4900:20:''||:app_session||''::::''||',
'           ''WS_APP_ID,P2_ID,P2_WEBSHEET_ID,CURRENT_WORKSHEET_ROW:''||',
'           :WS_APP_ID||'',''||(select worksheet_id from wwv_flow_ws_websheet_attr where id   = n001)||'',''||n001||'',''||c003 view_row',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_LINKS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(479800812105656094.4903)
,p_name=>'Links'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_detail_link=>'f?p=&APP_ID.:916:&SESSION.::&DEBUG.:916:P916_ID:#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'ICON_LINK'
,p_icon_view_img_src_column=>'ICON_IMG'
,p_icon_view_label_column=>'LINK_NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(216816623052907614.4903)
,p_db_column_name=>'DELETE_CK'
,p_display_order=>1
,p_column_identifier=>'O'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801000325656111.4903)
,p_db_column_name=>'DATA_GRID_ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Daten-Grid'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801128596656111.4903)
,p_db_column_name=>'WS_APP_ID'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Anwendung'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801231613656111.4903)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801330084656111.4903)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801428974656112.4903)
,p_db_column_name=>'LINK_NAME'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Linkname'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801530840656112.4903)
,p_db_column_name=>'URL'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'URL-Ziel'
,p_column_link=>'#URL#'
,p_column_linktext=>'#URL#'
,p_column_link_attr=>'target="_blank"'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801606667656112.4903)
,p_db_column_name=>'ROW_ID'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Zeile'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801730173656112.4903)
,p_db_column_name=>'TAGS'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Tags'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801813339656112.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479801900811656112.4903)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(479802025414656113.4903)
,p_db_column_name=>'ICON_IMG'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Bild'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480517403932027960.4903)
,p_db_column_name=>'ICON_LINK'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(480549407245218078.4903)
,p_db_column_name=>'VIEW_ROW'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Zeile anzeigen'
,p_column_link=>'#VIEW_ROW#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="">'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(626918628236396345.4903)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'N'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(481106817753672204.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(479800700877656094.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:915:&SESSION.::&DEBUG.:915,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(216880524915917657.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(479800700877656094.4903)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('Markierte Elemente l\00F6schen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(479782522981566331.4903)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'915'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(216895501151920223.4903)
,p_validation_name=>'must select links to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Die zu l\00F6schenden Links m\00FCssen angegeben werden.')
,p_when_button_pressed=>wwv_flow_api.id(216880524915917657.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(2045582355681367920.4903)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_api.id(479800700877656094.4903)
,p_bind_type=>'bind'
,p_bind_event_type=>'apexafterrefresh'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(2045582445103367921.4903)
,p_event_id=>wwv_flow_api.id(2045582355681367920.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(216910409116922484.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked links'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_ws_api.delete_link (',
'    p_link_id        => wwv_flow.g_f01(i));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Links k\00F6nnen nicht gel\00F6scht werden.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(216880524915917657.4903)
,p_process_success_message=>unistr('Links gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(479782313285563541.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_link_collection (',
'    p_ws_app_id => :ws_app_id',
'    );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00916
begin
wwv_flow_api.create_page(
 p_id=>916.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Linkdetails'
,p_step_title=>'Linkdetails'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(133321202391746654.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(626909330617315176.4903)
,p_plug_name=>'Linkdetails'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(626914105678315194.4903)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(626920511707448372.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626914701991315196.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(626914105678315194.4903)
,p_button_name=>'VIEW_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Seite anzeigen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.::WS_APP_ID,P900_ID:&WS_APP_ID.,&P916_PAGE_ID.'
,p_button_condition=>'P916_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626914932512315196.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(626914105678315194.4903)
,p_button_name=>'VIEW_ROW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Zeile anzeigen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:20:WS_APP_ID,P2_ID,P2_WEBSHEET_ID,CURRENT_WORKSHEET_ROW:&WS_APP_ID.,&P916_WORKSHEET_ID.,&P916_DATA_GRID_ID.,&P916_ROW_ID.'
,p_button_condition=>'P916_DATA_GRID_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626914515453315195.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(626914105678315194.4903)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CHANGE'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626915131935315197.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(626914105678315194.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(626914311761315194.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(626914105678315194.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(626916104629315205.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626909516329315180.4903)
,p_name=>'P916_ROW_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(133321202391746654.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626909728940315182.4903)
,p_name=>'P916_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(133321202391746654.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626909911465315183.4903)
,p_name=>'P916_WORKSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(133321202391746654.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626910101419315183.4903)
,p_name=>'P916_COMPONENT_LEVEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4903)
,p_prompt=>'Annotationsebene'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COMPONENT_LEVEL'
,p_lov=>'.'||wwv_flow_api.id(455012825948829772.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt die Annotationsebene an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626910600476315185.4903)
,p_name=>'P916_LINK_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4903)
,p_prompt=>'Linkname'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>7
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Geben Sie den Namen des Links ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626911106974315188.4903)
,p_name=>'P916_DATA_GRID_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4903)
,p_prompt=>'Daten-Grid'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P916_DATA_GRID_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Gibt das Daten-Grid an, dem der Link hinzugef\00FCgt wird.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626911610186315190.4903)
,p_name=>'P916_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4903)
,p_prompt=>'Seite'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P916_PAGE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Gibt die Seite an, der der Link hinzugef\00FCgt wird.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626912109851315191.4903)
,p_name=>'P916_CREATED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4903)
,p_prompt=>'Erstellt'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Das Datum, an dem der Link erstellt wurde.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626912625729315192.4903)
,p_name=>'P916_CREATED_BY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4903)
,p_prompt=>'Erstellt von'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Der Benutzer, der den Link erstellt hat.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626913118602315192.4903)
,p_name=>'P916_UPDATED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4903)
,p_prompt=>'Aktualisiert'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Das Datum, an dem die Linkdefinition zuletzt aktualisiert wurde.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626913628428315193.4903)
,p_name=>'P916_UPDATED_BY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4903)
,p_prompt=>'Aktualisiert von'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Der Benutzer, der den Link zuletzt aktualisiert hat.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(626916815507373749.4903)
,p_name=>'P916_URL'
,p_is_required=>true
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_api.id(626909330617315176.4903)
,p_prompt=>'URL-Ziel'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_read_only_when=>'return wwv_flow_ws_security.current_user_is_reader;'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Geben Sie die Link-URL ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(626915516363315203.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete link'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_link (',
'    p_link_id        => :P916_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Der Link konnte nicht gel\00F6scht werden.')
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>unistr('Link wurde gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(626915707310315203.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update link'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_validation_error varchar2(4000) := null;',
'begin',
'  wwv_flow_ws_api.add_link (    ',
'    p_ws_app_id        => :ws_app_id,            ',
'    p_link_id          => :P916_ID,',
'    p_link_name        => :P916_LINK_NAME,',
'    p_url              => :P916_URL,',
'    p_validation_error => l_validation_error);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Der Link konnte nicht aktualisiert werden.'
,p_process_when_button_id=>wwv_flow_api.id(626914515453315195.4903)
,p_process_success_message=>'Link wurde aktualisiert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(626915926570315204.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get link info'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_link_info (    ',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_id              => :P916_ID,',
'    p_component_level => :P916_COMPONENT_LEVEL,',
'    p_webpage_id      => :P916_PAGE_ID,',
'    p_worksheet_id    => :P916_WORKSHEET_ID,',
'    p_websheet_id     => :P916_DATA_GRID_ID,',
'    p_row_id          => :P916_ROW_ID,    ',
'    p_link_name       => :P916_LINK_NAME,',
'    p_url             => :P916_URL,',
'    p_created_on      => :P916_CREATED,',
'    p_created_by      => :P916_CREATED_BY,',
'    p_updated_on      => :P916_UPDATED,',
'    p_updated_by      => :P916_UPDATED_BY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Hinweisinformationen konnten nicht abgerufen werden.'
);
end;
/
prompt --application/pages/page_00920
begin
wwv_flow_api.create_page(
 p_id=>920.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Abschnitt erstellen'
,p_step_title=>'Abschnitt erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17202921536372154.4903)
,p_plug_name=>unistr('Rechte Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174354720645915002.4903)
,p_plug_name=>'Abschnitt erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<div class="formNoHighlight">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436556632146705231.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id       => :WS_APP_ID,    ',
'    p_app_session     => :APP_SESSION,',
'    p_page_id         => :P900_ID,',
'    p_image_prefix    => ''#IMAGE_PREFIX#'',',
'    p_current_entry   => wwv_flow_lang.system_message(''WS_CREATE_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455838102606248329.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Ein Seitenabschnitt ist eine Komponente einer Seite. Sie k\00F6nnen auf einer Seite eine beliebige Anzahl von Abschnitten erstellen. Auf dieser Seite k\00F6nnen Sie den Abschnittstyp ausw\00E4hlen, den Sie der aktuellen Seite hinzuf\00FCgen m\00F6chten.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174354910736915005.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(17202921536372154.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174355130239915005.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(17202921536372154.4903)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4903)
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(174356013015915007.4903)
,p_branch_action=>'f?p=&APP_ID.:910:&SESSION.::&DEBUG.:910,P910_CONTENT,P910_SPREADSHEET::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P920_SECTION_TYPE'
,p_branch_condition_text=>'TEXT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177507111836337182.4903)
,p_branch_action=>'f?p=&APP_ID.:926:&SESSION.::&DEBUG.:926,921::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(174355130239915005.4903)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P920_SECTION_TYPE'
,p_branch_condition_text=>'NAV'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178763608028090504.4903)
,p_branch_name=>'Go To Page 922'
,p_branch_action=>'f?p=&APP_ID.:922:&SESSION.::&DEBUG.:922,925::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(174355130239915005.4903)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P920_SECTION_TYPE'
,p_branch_condition_text=>'DATA'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(261473424707135006.4903)
,p_branch_name=>'Go To Page 710'
,p_branch_action=>'f?p=&APP_ID.:710:&SESSION.::&DEBUG.:710,740,742,750::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P920_SECTION_TYPE'
,p_branch_condition_text=>'CHART'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174355315313915005.4903)
,p_name=>'P920_SECTION_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(174354720645915002.4903)
,p_item_default=>'TEXT'
,p_prompt=>unistr('Welchen Seitenabschnittstyp m\00F6chten Sie erstellen?')
,p_source=>'TEXT'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SECTION TYPE SELECTOR'
,p_lov=>'.'||wwv_flow_api.id(174363201295924966.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00921
begin
wwv_flow_api.create_page(
 p_id=>921.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Abschnitt erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21386114982952726.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177506032470294572.4903)
,p_plug_name=>'Navigationsabschnitt'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177507500885343531.4903)
,p_plug_name=>'create websheet progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(174369523339947712.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436568617432088844.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_NAV_SECTION''));',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177604932373442179.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21386114982952726.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177605313591442181.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21386114982952726.4903)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Abschnitt erstellen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177605109363442180.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21386114982952726.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177605817613447363.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177606906100462949.4903)
,p_branch_action=>'f?p=&APP_ID.:926:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(177605109363442180.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177606323285458505.4903)
,p_name=>'P921_STARTING_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4903)
,p_prompt=>'Startseite'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from WWV_FLOW_WS_WEBPAGES ',
'where WS_APP_ID = :WS_APP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Startseite ausw\00E4hlen -')
,p_cSize=>50
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Startseite zur Anzeige der hierarchischen Navigation.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177606506978458508.4903)
,p_name=>'P921_MAXIMUM_LEVELS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4903)
,p_item_default=>'12'
,p_prompt=>'Maximale Ebenen'
,p_source=>'12'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:1;1,2;2,3;3,4;4,5;5,6;6,7;7,8;8,9;9,10;10,11;11,12;12'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die H\00F6chstanzahl der Ebenen (oder Baumstrukturtiefe), die angezeigt werden sollen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177606712975458508.4903)
,p_name=>'P921_INCLUDE_SECTION_LINKS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4903)
,p_item_default=>'Y'
,p_prompt=>'Include Section Links'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178094008603712314.4903)
,p_name=>'P921_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4903)
,p_prompt=>unistr('\00DCberschrift')
,p_source=>'wwv_flow_lang.system_message(''WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Titel des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178094215529714335.4903)
,p_name=>'P921_DISPLAY_SEQ'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4903)
,p_prompt=>'Sequenz'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie die Anzeigereihenfolge des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178573103303255986.4903)
,p_name=>'P921_NAV_TYPE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4903)
,p_prompt=>'Navigationstyp'
,p_source=>'P926_NAV_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'NAV_SECTION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(178562403162170735.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den zu erstellenden Navigationstyp an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(381985629999712041.4903)
,p_name=>'P921_ORDER_BY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4903)
,p_prompt=>'Gleichrangige Objekte sortieren nach'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE NAVIGATION ORDER'
,p_lov=>'.'||wwv_flow_api.id(381950720171699749.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ausw\00E4hlen -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('W\00E4hlen Sie die Reihenfolge der gleichrangigen Objekte nach Spalte. Wenn keine Definition vorgenommen wird, werden die gleichrangigen Objekte nach Seitenname sortiert.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(607148518453469821.4903)
,p_name=>'P921_ORDER_BY_DIRECTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4903)
,p_prompt=>'Nach Richtung sortieren'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ORDER_BY_DIRECTION'
,p_lov=>'.'||wwv_flow_api.id(606013026952235682.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(607211403347474951.4903)
,p_name=>'P921_X'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(177506032470294572.4903)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178095228473727498.4903)
,p_validation_name=>'P921_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P921_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Die Anzeigereihenfolge muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(177605313591442181.4903)
,p_associated_item=>wwv_flow_api.id(178094215529714335.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178095404709730099.4903)
,p_validation_name=>'P921_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P921_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Titel muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(177605313591442181.4903)
,p_associated_item=>wwv_flow_api.id(178094008603712314.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(607317121832489778.4903)
,p_name=>'show or hide order by direction'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P921_ORDER_BY'
,p_condition_element=>'P921_ORDER_BY'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(607317409299489779.4903)
,p_event_id=>wwv_flow_api.id(607317121832489778.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P921_ORDER_BY_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(607317604656489780.4903)
,p_event_id=>wwv_flow_api.id(607317121832489778.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P921_ORDER_BY_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178092407601664683.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create navigation section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (    ',
'    p_ws_app_id        => :WS_APP_ID,   ',
'    p_webpage_id       => :P900_ID,',
'    p_section_type     => :P926_NAV_TYPE,',
'    p_title            => :P921_TITLE,',
'    p_display_seq      => :P921_DISPLAY_SEQ, ',
'    p_nav_start_webpage_id  => :P921_STARTING_PAGE,',
'    p_nav_max_level         => nvl(:P921_MAXIMUM_LEVELS,''12''),',
'    p_nav_order_by          => :P921_ORDER_BY,',
'    p_nav_order_by_dir      => :P921_ORDER_BY_DIRECTION,',
'    p_nav_include_link      => :P921_INCLUDE_SECTION_LINKS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Navigationsabschnitt konnte nicht erstellt werden.'
,p_process_when_button_id=>wwv_flow_api.id(177605313591442181.4903)
,p_process_success_message=>'Navigationsabschnitt erstellt.'
);
end;
/
prompt --application/pages/page_00922
begin
wwv_flow_api.create_page(
 p_id=>922.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Datenabschnitt erstellen'
,p_step_title=>'Datenabschnitt erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21394627412003604.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21395215076009516.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178517415930445925.4903)
,p_plug_name=>'Datenabschnitt erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436561728327978462.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_DATA_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(455837601735210222.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Sie k\00F6nnen Daten aus einem Daten-Grid oder aus einem Bericht als Abschnitt auf Ihrer Seite angeben. Durch das Angeben von Daten k\00F6nnen Sie Textdaten visualisieren, die Teilmengen der Daten bilden k\00F6nnen, die im Daten-Grid oder Bericht enthalten si')
||'nd.</p>',
unistr('<p>Einen Datenabschnitt kann man sich \00E4hnlich vorstellen wie das Ver\00F6ffentlichen von Daten auf einer Seite.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178517615368455281.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21394627412003604.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178519308451528993.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21394627412003604.4903)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4903)
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178517832684460267.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21394627412003604.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178519529054528994.4903)
,p_branch_action=>'f?p=&APP_ID.:925:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(178519308451528993.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178519128752525369.4903)
,p_name=>'P922_DATA_GRID_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4903)
,p_prompt=>'Daten-Grid'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA GRID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''DATA'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Daten-Grid ausw\00E4hlen -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie das Daten-Grid, das zur Anzeige des Datenabschnitts verwendet werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180221817184364203.4903)
,p_name=>'P922_DISPLAY_SEQ'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4903)
,p_prompt=>'Anzeigereihenfolge'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie die Anzeigereihenfolge des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180222224110366187.4903)
,p_name=>'P922_TITLE'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4903)
,p_prompt=>unistr('\00DCberschrift')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Titel des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244080827354978984.4903)
,p_name=>'P922_REPORT_SHOW_OPT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4903)
,p_item_default=>'SEARCH'
,p_prompt=>'Einbeziehen'
,p_source=>'SEARCH'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P922_REPORT_SHOW_OPT'
,p_lov=>'.'||wwv_flow_api.id(244090113649098118.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sie k\00F6nnen die Funktionen anpassen, die Sie im Datenabschnitt anzeigen m\00F6chten.'),
'<ul>',
unistr('<li>Zeile hinzuf\00FCgen - Wenn der Quelltyp "Daten-Grid" ist, k\00F6nnen Sie die Schaltfl\00E4che "Zeile hinzuf\00FCgen" anzeigen, damit privilegierte Benutzer einen Datensatz im Daten-Grid hinzuf\00FCgen k\00F6nnen.</li>'),
unistr('<li>Zeile bearbeiten - Wenn der Quelltyp "Datenr-Grid" ist, k\00F6nnen Sie den Link "Zeile bearbeiten" anzeigen, damit privilegierte Benutzer einen Datensatz im Daten-Grid bearbeiten k\00F6nnen.</li>'),
unistr('<li>Suchfeld - Zeigt ein Textfeld in der Suchleiste an, in das Suchkriterien eingegeben werden k\00F6nnen.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244081321747981663.4903)
,p_name=>'P922_MAX_ROW_CNT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4903)
,p_prompt=>'Maximale Zeilenanzahl'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>7
,p_cMaxlength=>10
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Definiert die maximale Anzahl von Zeilen f\00FCr die Abfrage. Beachten Sie, dass sich dieses Attribut auf die Performance auswirkt. Wenn weniger Zeilen zur\00FCckgegeben werden, kann dies die Performance verbessern. Die R\00FCckgabe von Tausenden von Zeilen beei')
||unistr('ntr\00E4chtigt unter Umst\00E4nden die Performance.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244089415406090919.4903)
,p_name=>'P922_DATAGRID_SHOW_OPT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4903)
,p_item_default=>'SEARCH'
,p_prompt=>'Einbeziehen'
,p_source=>'SEARCH'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P922_DATAGRID_SHOW_OPT'
,p_lov=>'.'||wwv_flow_api.id(244084119358061944.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sie k\00F6nnen die Funktionen anpassen, die Sie im Datenabschnitt anzeigen m\00F6chten.'),
'<ul>',
unistr('<li>Zeile hinzuf\00FCgen - Wenn der Quelltyp "Daten-Grid" ist, k\00F6nnen Sie die Schaltfl\00E4che "Zeile hinzuf\00FCgen" anzeigen, damit privilegierte Benutzer einen Datensatz im Daten-Grid hinzuf\00FCgen k\00F6nnen.</li>'),
unistr('<li>Zeile bearbeiten - Wenn der Quelltyp "Datenr-Grid" ist, k\00F6nnen Sie den Link "Zeile bearbeiten" anzeigen, damit privilegierte Benutzer einen Datensatz im Daten-Grid bearbeiten k\00F6nnen.</li>'),
unistr('<li>Suchfeld - Zeigt ein Textfeld in der Suchleiste an, in das Suchkriterien eingegeben werden k\00F6nnen.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244100400932128024.4903)
,p_name=>'P922_SHOW_OPT'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(21395215076009516.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430267602106707516.4903)
,p_name=>'P922_DATA_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4903)
,p_item_default=>'DATA_GRID'
,p_prompt=>'Datenabschnittsquelle'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SECTION_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(428681322228645128.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('W\00E4hlen Sie den Quelltyp des Datenabschnitts.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430268828210724512.4903)
,p_name=>'P922_REPORT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4903)
,p_prompt=>'Bericht'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Bericht ausw\00E4hlen -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_security_scheme=>wwv_flow_api.id(495860932509802714)
,p_help_text=>unistr('W\00E4hlen Sie den Bericht, der zur Anzeige des Datenabschnitts verwendet werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430269312757729488.4903)
,p_name=>'P922_WEBSHEET_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(21395215076009516.4903)
,p_prompt=>'Websheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(430269625917733292.4903)
,p_name=>'P922_WORKSHEET_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(21395215076009516.4903)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(506337317277616860.4903)
,p_name=>'P922_STYLE'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4903)
,p_item_default=>'1'
,p_prompt=>'Stil'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA SECTION STYLE'
,p_lov=>'.'||wwv_flow_api.id(746262913082105905.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('W\00E4hlen Sie verschiedene Stile f\00FCr die Benutzeroberfl\00E4che.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(744638613924916860.4903)
,p_name=>'P922_SAVED_REPORT_ID'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(178517415930445925.4903)
,p_prompt=>'Zu verwendende Berichtseinstellungen'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id r',
'from wwv_flow_worksheet_rpts',
'where worksheet_id = :P922_WORKSHEET_ID',
'and application_user = ''APXWS_DEFAULT''',
'and is_default = ''Y''                    ',
'and (security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and session_id is null',
'and nvl(report_type,''REPORT'')!=''NOTIFICATION'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P922_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION''',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION'') x',
'order by x.seq, x.r'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Bericht ausw\00E4hlen -')
,p_lov_cascade_parent_items=>'P922_WORKSHEET_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die gew\00FCnschten Berichtseinstellungen f\00FCr das ausgew\00E4hlte Daten-Grid oder den ausgew\00E4hlten Bericht. Auf diese Weise k\00F6nnen Sie die Zeilen und Spalten filtern, die angezeigt werden sollen, und die anzuzeigenden Spalten festlegen. Wenn Sie d')
||unistr('en Bericht mit den ben\00F6tigten Einstellungen nicht gespeichert haben, erstellen Sie ihn jetzt, bevor Sie den Abschnitt hinzuf\00FCgen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(430283328041112368.4903)
,p_computation_sequence=>10
,p_computation_item=>'P922_WEBSHEET_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P922_DATA_SOURCE = ''DATA_GRID'' then',
'  return :P922_DATA_GRID_ID;',
'elsif :P922_DATA_SOURCE = ''REPORT'' then',
'  return :P922_REPORT_ID;',
'end if;'))
,p_compute_when=>'replace(:P922_DATA_GRID_ID,''%''||''null%'') is not null or replace(:P922_REPORT_ID,''%''||''null%'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(430283627479121662.4903)
,p_computation_sequence=>20
,p_computation_item=>'P922_WORKSHEET_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P922_DATA_SOURCE = ''DATA_GRID'' then',
'  for c1 in (select w.id',
'             from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id',
'             and w.security_group_id = :flow_security_group_id',
'             and a.id = :P922_DATA_GRID_ID)',
'  loop',
'    return c1.id;',
'  end loop;',
'elsif :P922_DATA_SOURCE = ''REPORT'' then',
'  for c1 in (select w.id',
'             from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'             where w.id = a.worksheet_id',
'             and w.security_group_id = :flow_security_group_id',
'             and a.id = :P922_REPORT_ID)',
'  loop',
'    return c1.id;',
'  end loop;',
'end if;'))
,p_compute_when=>'replace(:P922_DATA_GRID_ID,''%''||''null%'') is not null or replace(:P922_REPORT_ID,''%''||''null%'') is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(244100616879135860.4903)
,p_computation_sequence=>30
,p_computation_item=>'P922_SHOW_OPT'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P922_DATA_SOURCE = ''DATA_GRID'' then',
'  return :P922_DATAGRID_SHOW_OPT;',
'elsif :P922_DATA_SOURCE = ''REPORT'' then',
'  return :P922_REPORT_SHOW_OPT;',
'end if;'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178526011577605519.4903)
,p_validation_name=>'P922_DATA_GRID_ID not null'
,p_validation_sequence=>10
,p_validation=>'P922_DATA_GRID_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_validation_condition=>'P922_DATA_SOURCE'
,p_validation_condition2=>'DATA_GRID'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(178519308451528993.4903)
,p_associated_item=>wwv_flow_api.id(178519128752525369.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(430284814497155703.4903)
,p_validation_name=>'P922_REPORT_ID not null'
,p_validation_sequence=>20
,p_validation=>'P922_REPORT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_validation_condition=>'P922_DATA_SOURCE'
,p_validation_condition2=>'REPORT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(178519308451528993.4903)
,p_associated_item=>wwv_flow_api.id(430268828210724512.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(261386108094505816.4903)
,p_name=>'get data grid title'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_DATA_GRID_ID'
,p_condition_element=>'P922_DATA_GRID_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(261386430504505817.4903)
,p_event_id=>wwv_flow_api.id(261386108094505816.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_TITLE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name',
'from wwv_flow_ws_websheet_attr',
'where id = :P922_DATA_GRID_ID',
'and security_group_id = :flow_security_group_id'))
,p_attribute_07=>'P922_DATA_GRID_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(430274030989800961.4903)
,p_name=>'get report title'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_REPORT_ID'
,p_condition_element=>'P922_REPORT_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430274324034800964.4903)
,p_event_id=>wwv_flow_api.id(430274030989800961.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_TITLE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name',
'from wwv_flow_ws_websheet_attr',
'where id = :P922_REPORT_ID',
'and security_group_id = :flow_security_group_id'))
,p_attribute_07=>'P922_REPORT_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(430274815668815504.4903)
,p_name=>'show hide data grid'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_DATA_SOURCE'
,p_condition_element=>'P922_DATA_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DATA_GRID'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430275125531815505.4903)
,p_event_id=>wwv_flow_api.id(430274815668815504.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_DATA_GRID_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(244096214315106571.4903)
,p_event_id=>wwv_flow_api.id(430274815668815504.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_DATAGRID_SHOW_OPT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430275311073815506.4903)
,p_event_id=>wwv_flow_api.id(430274815668815504.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_DATA_GRID_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(244096410002108585.4903)
,p_event_id=>wwv_flow_api.id(430274815668815504.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_DATAGRID_SHOW_OPT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(430275708526822857.4903)
,p_name=>'show hide report'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_DATA_SOURCE'
,p_condition_element=>'P922_DATA_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPORT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430276009572822857.4903)
,p_event_id=>wwv_flow_api.id(430275708526822857.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_REPORT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(244097500513112975.4903)
,p_event_id=>wwv_flow_api.id(430275708526822857.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_REPORT_SHOW_OPT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430276227680822858.4903)
,p_event_id=>wwv_flow_api.id(430275708526822857.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_REPORT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(244098628105115423.4903)
,p_event_id=>wwv_flow_api.id(430275708526822857.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_REPORT_SHOW_OPT'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(747829913447257392.4903)
,p_name=>'reset data grid, report id, saved report id to null if source changes'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_DATA_SOURCE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(747830202548257393.4903)
,p_event_id=>wwv_flow_api.id(747829913447257392.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_DATA_GRID_ID,P922_REPORT_ID,P922_SAVED_REPORT_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(745902210134067132.4903)
,p_name=>'set data grid worksheet and websheet id'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_DATA_GRID_ID'
,p_condition_element=>'P922_DATA_GRID_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(745902519517067133.4903)
,p_event_id=>wwv_flow_api.id(745902210134067132.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_WORKSHEET_ID'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select w.id',
'           from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'           where w.id = a.worksheet_id',
'           and w.security_group_id = :flow_security_group_id',
'           and a.id = :P922_DATA_GRID_ID)',
'loop',
'  return c1.id;',
'end loop;'))
,p_attribute_07=>'P922_DATA_GRID_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(748723328778318541.4903)
,p_event_id=>wwv_flow_api.id(745902210134067132.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_WEBSHEET_ID'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select a.id',
'           from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'           where w.id = a.worksheet_id',
'           and w.security_group_id = :flow_security_group_id',
'           and a.id = :P922_DATA_GRID_ID)',
'loop',
'  return c1.id;',
'end loop;'))
,p_attribute_07=>'P922_DATA_GRID_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(747479308205227472.4903)
,p_name=>'set report worksheet and websheet id'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P922_REPORT_ID'
,p_condition_element=>'P922_REPORT_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
end;
/
begin
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(747479601494227473.4903)
,p_event_id=>wwv_flow_api.id(747479308205227472.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_WORKSHEET_ID'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select w.id',
'           from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'           where w.id = a.worksheet_id',
'           and w.security_group_id = :flow_security_group_id',
'           and a.id = :P922_REPORT_ID)',
'loop',
'  return c1.id;',
'end loop;'))
,p_attribute_07=>'P922_REPORT_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(748927908954331757.4903)
,p_event_id=>wwv_flow_api.id(747479308205227472.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P922_WEBSHEET_ID'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select a.id',
'           from wwv_flow_worksheets w, wwv_flow_ws_websheet_attr a',
'           where w.id = a.worksheet_id',
'           and w.security_group_id = :flow_security_group_id',
'           and a.id = :P922_REPORT_ID)',
'loop',
'  return c1.id;',
'end loop;'))
,p_attribute_07=>'P922_REPORT_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00925
begin
wwv_flow_api.create_page(
 p_id=>925.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Datenabschnitt erstellen'
,p_step_title=>'Datenabschnitt erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21401305913120374.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>51
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(179690718468764994.4903)
,p_plug_name=>unistr('Datenabschnitt erstellen best\00E4tigen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Sie haben das Erstellen eines Datenabschnitts mit folgenden Attributen angefordert. Best\00E4tigen Sie Ihre Auswahl.<p />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436562600323998761.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>41
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_DATA_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(179685611450754334.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21401305913120374.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(179686030494754336.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21401305913120374.4903)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Abschnitt erstellen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(179685830220754336.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21401305913120374.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:922:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(179688414608754348.4903)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(179686030494754336.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187342720245457992.4903)
,p_name=>'P925_TITLE'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Abschnittstitel'
,p_source=>'P922_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244103023515193541.4903)
,p_name=>'P925_MAX_ROW_COUNT'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximale Zeilenanzahl'
,p_source=>'P922_MAX_ROW_CNT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244104301733203623.4903)
,p_name=>'P925_SHOW_OPT'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Einbeziehen'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_option  varchar2(4000);',
'begin',
'  if instr(:P922_SHOW_OPT,''ADD_ROW'',1) > 0 then',
'    l_option := wwv_flow_lang.system_message(''WS_ADD_ROW'');',
'  end if;',
'  if instr(:P922_SHOW_OPT,''EDIT_ROW'',1) > 0 then',
'    if l_option is not null then',
'        l_option := l_option||'', '';',
'    end if;',
'    l_option := l_option||wwv_flow_lang.system_message(''APEX_WS_EDIT_ROW'');',
'  end if;',
'  if instr(:P922_SHOW_OPT,''SEARCH'',1) > 0 then',
'    if l_option is not null then',
'        l_option := l_option||'', '';',
'    end if;',
'    l_option := l_option||wwv_flow_lang.system_message(''SEARCH_FIELD'');',
'  end if;',
'  return l_option;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(244105113366213468.4903)
,p_name=>'P925_STYLE'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Stil'
,p_source=>'P922_STYLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P925_DATA_SECTION_STYLE'
,p_lov=>'.'||wwv_flow_api.id(244105603016227532.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431015615315149759.4903)
,p_name=>'P925_DATA_SOURCE'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Datenquelle'
,p_source=>'P922_WEBSHEET_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P750_CHART_SOURCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name||',
'       case when websheet_type=''DATA'' then '' (''||wwv_flow_lang.system_message(''DATA_GRID'')||'')''',
'            when websheet_type=''REPORT'' then '' (''||wwv_flow_lang.system_message(''REPORT'')||'')''',
'       end d,',
'       id r',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :ws_app_id',
'and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431016706058203930.4903)
,p_name=>'P925_SAVED_REPORT_ID'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Zu verwendende Berichtseinstellungen'
,p_source=>'P922_SAVED_REPORT_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P922_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION''',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P922_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') != ''NOTIFICATION'') x',
'order by x.seq, x.r'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431018209568233295.4903)
,p_name=>'P925_DISPLAY_SEQ'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(179690718468764994.4903)
,p_prompt=>'Anzeigereihenfolge'
,p_source=>'P922_DISPLAY_SEQ'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(179696201555864179.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create data section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (     ',
'    p_ws_app_id             => :ws_app_id,   ',
'    p_webpage_id            => :P900_ID,',
'    p_section_type          => ''DATA'',',
'    p_display_seq           => :P922_DISPLAY_SEQ,',
'    p_title                 => :P922_TITLE,   ',
'    --',
'    p_data_grid_id          => :P922_WEBSHEET_ID,',
'    p_report_id             => :P922_SAVED_REPORT_ID,',
'    p_data_section_style    => :P922_STYLE,',
'    p_max_row_count         => :P922_MAX_ROW_CNT,',
'    p_show_option           => :P922_SHOW_OPT',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Datenabschnitt konnte nicht erstellt werden.'
,p_process_when_button_id=>wwv_flow_api.id(179686030494754336.4903)
,p_process_success_message=>'Datenabschnitt erstellt.'
);
end;
/
prompt --application/pages/page_00926
begin
wwv_flow_api.create_page(
 p_id=>926.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Abschnitt erstellen'
,p_step_title=>'Abschnitt erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21382806755931399.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178560813494164239.4903)
,p_plug_name=>'Navigationsabschnitt'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178561614851164242.4903)
,p_plug_name=>'create section progress bar'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(174369523339947712.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436567608166067266.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_NAV_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178561008148164240.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21382806755931399.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178561228601164240.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(21382806755931399.4903)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4903)
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178573823173271094.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21382806755931399.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178562216428164244.4903)
,p_branch_action=>'f?p=&APP_ID.:927:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P926_NAV_TYPE'
,p_branch_condition_text=>'NAV_SECTION'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178562026311164244.4903)
,p_branch_action=>'f?p=&APP_ID.:921:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(178561228601164240.4903)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P926_NAV_TYPE'
,p_branch_condition_text=>'NAV_PAGE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178561412725164241.4903)
,p_name=>'P926_NAV_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178560813494164239.4903)
,p_item_default=>'NAV_PAGE'
,p_prompt=>'Navigationstyp'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'NAV_SECTION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(178562403162170735.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('W\00E4hlen Sie den Typ des zu erstellenden Navigationsabschnitts.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00927
begin
wwv_flow_api.create_page(
 p_id=>927.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Abschnitt erstellen'
,p_step_title=>'Abschnitt erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(21390504640978088.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178569110362240726.4903)
,p_plug_name=>'Navigationsabschnitt'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178570913178240731.4903)
,p_plug_name=>'create websheet progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(174369523339947712.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436568901418103134.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,   ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',',
'    p_parent_entry         => wwv_flow_lang.system_message(''WS_CREATE_SECTION''),',
'    p_parent_entry_page_id => 920,',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_CREATE_NAV_SECTION''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178569317746240726.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(21390504640978088.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178569702314240727.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(21390504640978088.4903)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Abschnitt erstellen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178569513761240727.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(21390504640978088.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178571905755240735.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178571727907240734.4903)
,p_branch_action=>'f?p=&APP_ID.:926:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(178569513761240727.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178569929692240727.4903)
,p_name=>'P927_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(178569110362240726.4903)
,p_prompt=>'Name'
,p_source=>'wwv_flow_lang.system_message(''WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Titel des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178570125928240728.4903)
,p_name=>'P927_DISPLAY_SEQ'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178569110362240726.4903)
,p_prompt=>'Sequenz'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie die Anzeigereihenfolge des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178573503434265425.4903)
,p_name=>'P927_NAV_TYPE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(178569110362240726.4903)
,p_prompt=>'Navigationstyp'
,p_source=>'P926_NAV_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'NAV_SECTION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(178562403162170735.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den zu erstellenden Navigationstyp an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178571301607240733.4903)
,p_validation_name=>'P927_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P927_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Die Anzeigereihenfolge muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(178569702314240727.4903)
,p_associated_item=>wwv_flow_api.id(178570125928240728.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178571117220240732.4903)
,p_validation_name=>'P927_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P927_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Titel muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(178569702314240727.4903)
,p_associated_item=>wwv_flow_api.id(178569929692240727.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178571520097240733.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create navigation section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (    ',
'    p_ws_app_id        => :ws_app_id,   ',
'    p_webpage_id       => :P900_ID,',
'    p_section_type     => :P926_NAV_TYPE,',
'    p_title            => :P927_TITLE,',
'    p_display_seq      => :P927_DISPLAY_SEQ);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Navigationsabschnitt konnte nicht erstellt werden.'
,p_process_when_button_id=>wwv_flow_api.id(178569702314240727.4903)
,p_process_success_message=>'Navigationsabschnitt erstellt.'
);
end;
/
prompt --application/pages/page_00928
begin
wwv_flow_api.create_page(
 p_id=>928.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Tag-Cloud'
,p_step_title=>'Tag-Cloud'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459067726134008686.4903)
,p_plug_name=>'Tag Cloud'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear: both"'
,p_plug_display_sequence=>30
,p_plug_new_grid=>true
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_webpage.show_tag_clouds (',
'    p_ws_app_id             => :ws_app_id,    ',
'    p_session_id            => :app_session);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459068100292010685.4903)
,p_plug_name=>'Annotation Navigation Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid=>true
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(178837028298310188.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459178609343041600.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid=>true
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Eine Tag-Cloud zeigt Tags in einer Cloud-Ansicht, bei der die am h\00E4ufigsten referenzierten Tags in gr\00F6\00DFerer Schrift angezeigt werden.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(459181827135056279.4903)
,p_plug_name=>'Breadcrumb'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_new_grid=>true
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
end;
/
prompt --application/pages/page_00930
begin
wwv_flow_api.create_page(
 p_id=>930.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Textabschnitt bearbeiten'
,p_step_title=>'Textabschnitt bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
,p_page_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'apex.jQuery(document).ready(function(){',
' apex.jQuery("#P930_CONTENT").rte();',
'});',
'',
'function p930editSection(pSubmit){',
'  if ( apex.jQuery(''textarea[id=P930_CONTENT]'').is('':hidden'') ) { ',
'  	var content = apex.jQuery(''iframe.rte-iframe'').contents().find("body").html();',
'  	apex.jQuery(''textarea[id=P930_CONTENT]'').val(content);',
'  	apex.jQuery(''textarea[id=P930_CONTENT]'').css(''visibility'',''hidden'').css(''width'',''1px'').css(''height'',''1px'');',
'  	apex.jQuery(''textarea[id=P930_CONTENT]'').show();',
'  }',
'  doSubmit(pSubmit);',
'}',
'</script>'))
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15648226117829185.4903)
,p_plug_name=>'Abschnitte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4903)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15648605124832619.4903)
,p_plug_name=>'Abschnitt bearbeiten'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4903)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
,p_plug_comment=>'&P930_TITLE. Details'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15661211477081423.4903)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(15732828494501720.4903)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18669929540787618.4903)
,p_plug_name=>'Sections Controls Menu'
,p_region_name=>'section_control'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>160
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174552913634401874.4903)
,p_plug_name=>'Textabschnittsattribute'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(174554312455401879.4903)
,p_plug_name=>unistr('Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(248172125472455867.4903)
,p_plug_name=>'Daten-Grid-SQL-Syntax'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.data_grid_sql_help (',
'    p_app_id       => :app_id,',
'    p_app_session  => :app_session,',
'    p_ws_app_id    => :ws_app_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_header=>'Um die Daten-Grid-SQL-Syntax anzuzeigen, klicken Sie auf einen Daten-Grid-Namen:'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936719456397213387.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(15648226117829185.4903)
,p_button_name=>'SETTINGS_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_id=>wwv_flow_api.id(936712837989177653.4903)
,p_button_image_alt=>unistr('Men\00FC "Einstellungen"')
,p_button_position=>'CHANGE'
,p_icon_css_classes=>'icon-gear'
,p_button_cattributes=>'data-menu="section_control_menu"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(858631107838067914.4903)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(15648226117829185.4903)
,p_button_name=>'CREATE_SECTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936746267011392790.4903)
,p_button_image_alt=>'Abschnitt erstellen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:920,921:WS_APP_ID,P921_STARTING_PAGE:&WS_APP_ID.,&P900_ID.:'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174554723530401880.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(174554312455401879.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177611930061649618.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(174554312455401879.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(174554515748401879.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(174554312455401879.4903)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(15650427680867507.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(15648226117829185.4903)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4903)
,p_button_image_alt=>'Ausblenden/Anzeigen'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16271123804804753.4903)
,p_branch_action=>'f?p=&APP_ID.:&P930_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:P930_CONTENT,&P930_NEXT_SECTION_PAGE_ID.:&P930_NEXT_SECTION_ITEM_NAME.:&P930_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P930_NEXT_SECTION_PAGE_ID is not null and :P930_NEXT_SECTION_ITEM_NAME is not null and :P930_NEXT_SECTION_ID is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(174556007850401885.4903)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16205311085507758.4903)
,p_name=>'P930_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(15732828494501720.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16205517665509666.4903)
,p_name=>'P930_NEXT_SECTION_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(15732828494501720.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16328930402958073.4903)
,p_name=>'P930_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(15732828494501720.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20127109376394929.4903)
,p_name=>'P930_PAGE_NAME'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_api.id(174552913634401874.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Seite'
,p_source=>'P900_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22693907402270854.4903)
,p_name=>'P930_X'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_api.id(174552913634401874.4903)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174553132113401875.4903)
,p_name=>'P930_TITLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(174552913634401874.4903)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den Abschnittstitel an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174553520816401877.4903)
,p_name=>'P930_DISPLAY_SEQ'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(174552913634401874.4903)
,p_prompt=>'Sequenz'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt die Anzeigereihenfolge des Abschnitts innerhalb der Seite an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174553712988401877.4903)
,p_name=>'P930_SECTION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(15732828494501720.4903)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(378535409662712632.4903)
,p_name=>'P930_CONTENT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(174552913634401874.4903)
,p_prompt=>'Inhalt'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CLOB_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>15
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Gibt den Inhalt des Seitenabschnitts an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_section_clob ( ',
'    p_item_name        => ''P930_CONTENT'',',
'    p_section_id       => :P930_SECTION_ID);'))
,p_attribute_02=>'CKEDITOR-Full'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(790634718795645245.4903)
,p_name=>'P930_CHANGE_COUNT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(15732828494501720.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20015500008540614.4903)
,p_computation_sequence=>10
,p_computation_item=>'SECTION_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P930_SECTION_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(174555426069401882.4903)
,p_validation_name=>'P930_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P930_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Die Anzeigereihenfolge muss angegeben werden.'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(174553520816401877.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(174555618686401882.4903)
,p_validation_name=>'P930_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P930_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Titel muss angegeben werden.'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(174553132113401875.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(488007911029128399.4903)
,p_validation_name=>'P930_CONTENT contains valid sql'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_content clob;',
'begin  ',
'  l_content := wwv_flow_utilities.get_clob_textarea_value(p_item_name => ''P930_CONTENT'');  ',
'  ',
'  return wwv_flow_ws_security.str_contains_valid_sql (',
'    p_ws_app_id    => :WS_APP_ID,',
'    p_page_id      => :P900_ID,',
'    p_section_id   => :P930_SECTION_ID,',
'    p_string       => l_content);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(808665215002613839.4903)
,p_validation_name=>'check section lost update'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.check_section_lost_update (',
'    p_ws_app_id      => :WS_APP_ID,',
'    p_page_id        => :P900_ID,',
'    p_section_id     => :P930_SECTION_ID,',
'    p_change_count   => :P930_CHANGE_COUNT,',
'    --',
'    p_section_type   => ''TEXT'',',
'    p_display_seq    => :P930_DISPLAY_SEQ,',
'    p_title          => :P930_TITLE,   ',
'    p_clob_item_name => ''P930_CONTENT''',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(174555702178401882.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'edit section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_section_id       => :P930_SECTION_ID,',
'    p_section_type     => ''TEXT'',',
'    p_webpage_id       => :P900_ID,',
'    p_display_seq      => :P930_DISPLAY_SEQ,',
'    p_title            => :P930_TITLE,',
'    p_clob_item_name   => ''P930_CONTENT'');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Abschnitt konnte nicht gespeichert werden.'
,p_process_when=>'SAVE,SAVEANDGOTONEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Abschnitt gespeichert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177616917172740533.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage_section (',
'    p_section_id       => :P930_SECTION_ID,',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_webpage_id       => :P900_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Der Abschnitt konnte nicht gel\00F6scht werden.')
,p_process_when_button_id=>wwv_flow_api.id(177611930061649618.4903)
,p_process_success_message=>unistr('Abschnitt gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(174557016253476142.4903)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_section_info (',
'    p_section_id       => :P930_SECTION_ID,    ',
'    -- out',
'    p_display_seq      => :P930_DISPLAY_SEQ,    ',
'    p_title            => :P930_TITLE,',
'    p_change_count     => :P930_CHANGE_COUNT',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Daten konnten nicht abgerufen werden.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471208613320740995.4903)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection for dynamic list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' wwv_flow_ws_api.create_pg_sec_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id=> :WS_APP_ID,',
'    p_page_id => :P900_ID,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed for dynamic list.'
);
end;
/
prompt --application/pages/page_00931
begin
wwv_flow_api.create_page(
 p_id=>931.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Abschnitt bearbeiten'
,p_step_title=>'Abschnitt bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16731128856471529.4903)
,p_plug_name=>unistr('Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16731805916483837.4903)
,p_plug_name=>'Abschnitte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4903)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16732211457485413.4903)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16732730157490822.4903)
,p_plug_name=>'Abschnitt bearbeiten'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4903)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16733121284497803.4903)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(17135819160000800.4903)
,p_plug_name=>'Sections Controls Menu'
,p_region_name=>'section_control'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178368408637765960.4903)
,p_plug_name=>'Seitennavigationsattribute'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936765510087700308.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(16731805916483837.4903)
,p_button_name=>'SETTINGS_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936712837989177653.4903)
,p_button_image_alt=>unistr('Men\00FC "Einstellungen"')
,p_button_position=>'CHANGE'
,p_icon_css_classes=>'icon-gear'
,p_button_cattributes=>'data-menu="section_control_menu"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936765768571701620.4903)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(16731805916483837.4903)
,p_button_name=>'CREATE_SECTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936746267011392790.4903)
,p_button_image_alt=>'Abschnitt erstellen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:920,921:WS_APP_ID,P921_STARTING_PAGE:&WS_APP_ID.,&P900_ID.:'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178368614342765962.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(16731128856471529.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178369011126765966.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(16731128856471529.4903)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178368802810765966.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(16731128856471529.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16732027467483838.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16731805916483837.4903)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4903)
,p_button_image_alt=>'Ausblenden/Anzeigen'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16759320638525941.4903)
,p_branch_action=>'f?p=&APP_ID.:&P931_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P931_NEXT_SECTION_PAGE_ID.:&P931_NEXT_SECTION_ITEM_NAME.:&P931_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178371409970765994.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16759919730535123.4903)
,p_name=>'P931_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16760125618536865.4903)
,p_name=>'P931_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16761131851538693.4903)
,p_name=>'P931_NEXT_SECTION_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20206108430801477.4903)
,p_name=>'P931_PAGE_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Seite'
,p_source=>'P900_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178369204192765967.4903)
,p_name=>'P931_TITLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4903)
,p_prompt=>unistr('\00DCberschrift')
,p_source=>'wwv_flow_lang.system_message(''WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Titel des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178369430310765971.4903)
,p_name=>'P931_DISPLAY_SEQ'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4903)
,p_prompt=>'Sequenz'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt die Anzeigereihenfolge des Abschnitts innerhalb der Seite an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178369610358765972.4903)
,p_name=>'P931_STARTING_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4903)
,p_prompt=>'Startseite'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from WWV_FLOW_WS_WEBPAGES ',
'where WS_APP_ID = :WS_APP_ID',
'and security_group_id = :WORKSPACE_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Startseite ausw\00E4hlen -')
,p_cSize=>50
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Startseite, um die hierarchische Navigation anzuzeigen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178369805638765973.4903)
,p_name=>'P931_MAXIMUM_LEVELS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4903)
,p_item_default=>'3'
,p_prompt=>'Maximale Ebenen'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:1;1,2;2,3;3,4;4,5;5,6;6,7;7,8;8,9;9,10;10,11;11,12;12'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie die H\00F6chstanzahl der Ebenen oder die anzuzeigende Baumstrukturtiefe an.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178370015853765973.4903)
,p_name=>'P931_INCLUDE_SECTION_LINKS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4903)
,p_item_default=>'Y'
,p_prompt=>'Include Section Links'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Nemen Sie zus\00E4tzlich zu Links zur Seite auch Seitenabschnittslinks auf.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178379310204930611.4903)
,p_name=>'P931_SECTION_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4903)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178739115966515701.4903)
,p_name=>'P931_NAV_TYPE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4903)
,p_item_default=>'NAV_PAGE'
,p_prompt=>'Navigationstyp'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'NAV_SECTION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(178562403162170735.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den Typ des Navigationsabschnitts an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(382185121781766501.4903)
,p_name=>'P931_ORDER_BY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4903)
,p_prompt=>'Gleichrangige Objekte sortieren nach'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE NAVIGATION ORDER'
,p_lov=>'.'||wwv_flow_api.id(381950720171699749.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Ausw\00E4hlen -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('W\00E4hlen Sie die Reihenfolge der gleichrangigen Objekte nach Spalte. Wenn keine Definition vorgenommen wird, werden die gleichrangigen Objekte nach Seitenname sortiert.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(606070214401251046.4903)
,p_name=>'P931_ORDER_BY_DIRECTION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4903)
,p_prompt=>'Nach Richtung sortieren'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ORDER_BY_DIRECTION'
,p_lov=>'.'||wwv_flow_api.id(606013026952235682.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(606114931716256027.4903)
,p_name=>'P931_X'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_api.id(178368408637765960.4903)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(811975427842194759.4903)
,p_name=>'P931_CHANGE_COUNT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(16733121284497803.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20015324811538337.4903)
,p_computation_sequence=>10
,p_computation_item=>'SECTION_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P931_SECTION_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178370604774765981.4903)
,p_validation_name=>'P931_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P931_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Die Anzeigereihenfolge muss angegeben werden.'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(178369430310765971.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178370417599765978.4903)
,p_validation_name=>'P931_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P931_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Titel muss angegeben werden.'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(178369204192765967.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(812301814645238215.4903)
,p_validation_name=>'check section lost update'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.check_section_lost_update (',
'    p_ws_app_id    => :WS_APP_ID,',
'    p_page_id      => :P900_ID,',
'    p_section_id   => :P931_SECTION_ID,',
'    p_change_count => :P931_CHANGE_COUNT,',
'    --',
'    p_title            => :P931_TITLE,',
'    p_display_seq      => :P931_DISPLAY_SEQ, ',
'    p_nav_start_webpage_id  => replace(:P931_STARTING_PAGE,''undefined'',null),',
'    p_nav_max_level         => :P931_MAXIMUM_LEVELS,',
'    p_nav_order_by          => :P931_ORDER_BY,',
'    p_nav_order_by_dir      => :P931_ORDER_BY_DIRECTION,',
'    p_nav_include_link      => :P931_INCLUDE_SECTION_LINKS',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(607393113998496884.4903)
,p_name=>'show or hide order by direction'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P931_ORDER_BY'
,p_condition_element=>'P931_ORDER_BY'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(607393426539496885.4903)
,p_event_id=>wwv_flow_api.id(607393113998496884.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P931_ORDER_BY_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(607393632327496885.4903)
,p_event_id=>wwv_flow_api.id(607393113998496884.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P931_ORDER_BY_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178370809965765982.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save navigation section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_section_id       => :P931_SECTION_ID,      ',
'    p_webpage_id       => :P900_ID,',
'    --p_section_type     => :P920_SECTION_TYPE,',
'    p_title            => :P931_TITLE,',
'    p_display_seq      => :P931_DISPLAY_SEQ, ',
'    p_nav_start_webpage_id  => replace(:P931_STARTING_PAGE,''undefined'',null),',
'    p_nav_max_level         => :P931_MAXIMUM_LEVELS,',
'    p_nav_order_by          => :P931_ORDER_BY,',
'    p_nav_order_by_dir      => :P931_ORDER_BY_DIRECTION,',
'    p_nav_include_link      => :P931_INCLUDE_SECTION_LINKS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Navigationsabschnitt konnte nicht gespeichert werden.'
,p_process_when=>'SAVE,SAVEANDGOTONEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Navigationsabschnitt gespeichert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178428631010163685.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage_section (',
'    p_section_id       => :P931_SECTION_ID,',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_webpage_id       => :P900_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Abschnitt konnte nicht gel\00F6scht werden.')
,p_process_when_button_id=>wwv_flow_api.id(178368802810765966.4903)
,p_process_success_message=>unistr('Abschnitt gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178428304344155910.4903)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch page navigation section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_nav_section (',
'    p_section_id           => :P931_SECTION_ID,',
'    p_section_type         => ''NAV_PAGE'',',
'    -- out                 ',
'    p_display_seq          => :P931_DISPLAY_SEQ,        ',
'    p_title                => :P931_TITLE,    ',
'    p_nav_start_webpage_id => :P931_STARTING_PAGE,',
'    p_nav_max_level        => :P931_MAXIMUM_LEVELS,',
'    p_nav_order_by         => :P931_ORDER_BY,',
'    p_nav_order_by_dir     => :P931_ORDER_BY_DIRECTION,',
'    p_nav_include_link     => :P931_INCLUDE_SECTION_LINKS,',
'    p_change_count         => :P931_CHANGE_COUNT',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Navigationsabschnitt konnte nicht abgerufen werden.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471211203885757178.4903)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection for dynamic list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' wwv_flow_ws_api.create_pg_sec_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id=> :WS_APP_ID,',
'    p_page_id => :P900_ID,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed for dynamic list.'
);
end;
/
prompt --application/pages/page_00932
begin
wwv_flow_api.create_page(
 p_id=>932.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Abschnitt bearbeiten'
,p_step_title=>'Abschnitt bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16821113132731976.4903)
,p_plug_name=>unistr('Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16821602873738438.4903)
,p_plug_name=>'Abschnitt bearbeiten'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16821808414740080.4903)
,p_plug_name=>'Abschnitte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16822018804743033.4903)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16822228500745826.4903)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18667921575785243.4903)
,p_plug_name=>'Sections Controls Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(17118702088912337.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178731016198436890.4903)
,p_plug_name=>'Abschnitt "Navigationsattribute"'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178731226665436892.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(16821113132731976.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178731613312436894.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(16821113132731976.4903)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178731417793436894.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(16821113132731976.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16823808892749633.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16821808414740080.4903)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4903)
,p_button_image_alt=>'Ausblenden/Anzeigen'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16837912664798080.4903)
,p_branch_action=>'f?p=&APP_ID.:&P932_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P932_NEXT_SECTION_PAGE_ID.:&P932_NEXT_SECTION_ITEM_NAME.:&P932_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178733618463436914.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16823109180745829.4903)
,p_name=>'P932_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16822228500745826.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16823302223745830.4903)
,p_name=>'P932_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(16822228500745826.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16823506641745830.4903)
,p_name=>'P932_NEXT_SECTION_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16822228500745826.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20215308215810865.4903)
,p_name=>'P932_PAGE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178731016198436890.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Seite'
,p_source=>'P900_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178731814095436895.4903)
,p_name=>'P932_TITLE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(178731016198436890.4903)
,p_prompt=>'Name'
,p_source=>'wwv_flow_lang.system_message(''WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Titel des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178732029900436897.4903)
,p_name=>'P932_DISPLAY_SEQ'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(178731016198436890.4903)
,p_prompt=>'Sequenz'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie die Anzeigereihenfolge des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178732212508436897.4903)
,p_name=>'P932_NAV_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(178731016198436890.4903)
,p_prompt=>'Navigationstyp'
,p_source=>'NAV_SECTION'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'NAV_SECTION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(178562403162170735.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den Typ des Navigationsabschnitts an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178735221282451014.4903)
,p_name=>'P932_SECTION_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(16822228500745826.4903)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(812229531483233669.4903)
,p_name=>'P932_CHANGE_COUNT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(16822228500745826.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20018930829549545.4903)
,p_computation_sequence=>10
,p_computation_item=>'SECTION_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P932_SECTION_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178733002360436908.4903)
,p_validation_name=>'P932_DISPLAY_SEQ not null'
,p_validation_sequence=>10
,p_validation=>'P932_DISPLAY_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Die Anzeigereihenfolge muss angegeben werden.'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(178732029900436897.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(178732811663436903.4903)
,p_validation_name=>'P932_TITLE not null'
,p_validation_sequence=>20
,p_validation=>'P932_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Titel muss angegeben werden.'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(178731814095436895.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(812385231960243289.4903)
,p_validation_name=>'check section lost update'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.check_section_lost_update (',
'    p_section_id            => :P932_SECTION_ID,',
'    p_ws_app_id             => :WS_APP_ID,',
'    p_page_id               => :P900_ID,    ',
'    p_change_count          => :P932_CHANGE_COUNT,    ',
'    p_display_seq           => :P932_DISPLAY_SEQ,',
'    p_title                 => :P932_TITLE  ',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178733224857436909.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'edit section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (',
'    p_ws_app_id        => :ws_app_id,',
'    p_section_id       => :P932_SECTION_ID,',
'    p_webpage_id       => :P900_ID,',
'    p_display_seq      => :P932_DISPLAY_SEQ,',
'    p_title            => :P932_TITLE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Abschnitt konnte nicht gespeichert werden.'
,p_process_when=>'SAVE,SAVEANDGOTONEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Abschnitt gespeichert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178736815095477670.4903)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage_section (',
'    p_section_id       => :P932_SECTION_ID,',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_webpage_id       => :P900_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Der Abschnitt konnte nicht gel\00F6scht werden.')
,p_process_when_button_id=>wwv_flow_api.id(178731417793436894.4903)
,p_process_success_message=>unistr('Abschnitt gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471212514275760167.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection for dynamic list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' wwv_flow_ws_api.create_pg_sec_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id=> :WS_APP_ID,',
'    p_page_id => :P900_ID,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed for dynamic list.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(178735427862452947.4903)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare        ',
'    l_nav_start_webpage_id  number := null;',
'    l_nav_max_level         number := null;',
'    l_nav_order_by          varchar2(255) := null;',
'    l_nav_order_by_dir      varchar2(255) := null;',
'    l_nav_include_link      varchar2(1) := null;',
'begin',
'    wwv_flow_ws_api.fetch_nav_section (',
'        p_section_id           => :P932_SECTION_ID,',
'        p_section_type         => ''NAV_SECTION'',',
'        -- out                 ',
'        p_display_seq          => :P932_DISPLAY_SEQ,        ',
'        p_title                => :P932_TITLE,        ',
'        p_nav_start_webpage_id => l_nav_start_webpage_id,',
'        p_nav_max_level        => l_nav_max_level,',
'        p_nav_order_by         => l_nav_order_by,',
'        p_nav_order_by_dir     => l_nav_order_by_dir,',
'        p_nav_include_link     => l_nav_include_link,',
'        p_change_count         => :P932_CHANGE_COUNT',
'        );',
'end;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00934
begin
wwv_flow_api.create_page(
 p_id=>934.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Datenabschnitt bearbeiten'
,p_step_title=>'Datenabschnitt bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(15627530893704526.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16874326226906060.4903)
,p_plug_name=>'Abschnitt bearbeiten'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16874531766907700.4903)
,p_plug_name=>'Abschnitte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4903)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16874903500908924.4903)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(16875108349910367.4903)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18675312702792138.4903)
,p_plug_name=>'Sections Controls Menu'
,p_region_name=>'section_control'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(936708315591140469.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(180790812190845034.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(431020504392383148.4903)
,p_plug_name=>'Datenabschnittsattribute'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>25
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936771449913741390.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(16874531766907700.4903)
,p_button_name=>'SETTINGS_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936712837989177653.4903)
,p_button_image_alt=>unistr('Men\00FC "Einstellungen"')
,p_button_position=>'CHANGE'
,p_icon_css_classes=>'icon-gear'
,p_button_cattributes=>'data-menu="section_control_menu"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(936771635134742936.4903)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(16874531766907700.4903)
,p_button_name=>'CREATE_SECTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(936746267011392790.4903)
,p_button_image_alt=>'Abschnitt erstellen'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:920,921:WS_APP_ID,P921_STARTING_PAGE:&WS_APP_ID.,&P900_ID.:'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180465828305085279.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(180790812190845034.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180466228327085287.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(180790812190845034.4903)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(180466021313085287.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(180790812190845034.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(16874731003907700.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(16874531766907700.4903)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4903)
,p_button_image_alt=>'Ausblenden/Anzeigen'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(16879425580934285.4903)
,p_branch_action=>'f?p=&APP_ID.:&P934_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P934_NEXT_SECTION_PAGE_ID.:&P934_NEXT_SECTION_ITEM_NAME.:&P934_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(180469013145085360.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16876022889910369.4903)
,p_name=>'P934_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16876206592910369.4903)
,p_name=>'P934_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(16876406880910369.4903)
,p_name=>'P934_NEXT_SECTION_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20235124061834380.4903)
,p_name=>'P934_PAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Seite'
,p_source=>'P900_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180466427184085287.4903)
,p_name=>'P934_SECTION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4903)
,p_prompt=>'Section Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180466615812085313.4903)
,p_name=>'P934_TITLE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4903)
,p_prompt=>unistr('\00DCberschrift')
,p_source=>'wwv_flow_lang.system_message(''WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Titel des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180466803263085314.4903)
,p_name=>'P934_DISPLAY_SEQ'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4903)
,p_prompt=>'Sequenz'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.get_next_webpg_section_seq (    ',
'    p_webpage_id  => :P900_ID);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>6
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie die Anzeigereihenfolge des Abschnitts ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180603407157329829.4903)
,p_name=>'P934_WEBSHEET_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4903)
,p_prompt=>'Websheet Name:'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(180803211675882755.4903)
,p_name=>'P934_WEBSHEET_ID'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4903)
,p_prompt=>'Websheet ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(239265214706074225.4903)
,p_name=>'P934_MAX_ROW_CNT'
,p_item_sequence=>415
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4903)
,p_prompt=>'Maximale Zeilenanzahl'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>7
,p_cMaxlength=>10
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Definiert die maximale Anzahl von Zeilen f\00FCr die Abfrage. Beachten Sie, dass sich dieses Attribut auf die Performance auswirkt. Wenn weniger Zeilen zur\00FCckgegeben werden, kann dies die Performance verbessern. Die R\00FCckgabe von Tausenden von Zeilen beei')
||unistr('ntr\00E4chtigt unter Umst\00E4nden die Performance.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(239270404317124679.4903)
,p_name=>'P934_SHOW_OPT'
,p_item_sequence=>417
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4903)
,p_prompt=>'Einbeziehen'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P934_DATA_SECTION_SHOW_OPT'
,p_lov=>'.'||wwv_flow_api.id(239269013341119720.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sie k\00F6nnen die Funktionen anpassen, die Sie im Datenabschnitt anzeigen m\00F6chten.'),
'<ul>',
unistr('<li>Zeile hinzuf\00FCgen - Wenn der Quelltyp "Daten-Grid" ist, k\00F6nnen Sie die Schaltfl\00E4che "Zeile hinzuf\00FCgen" anzeigen, damit privilegierte Benutzer einen Datensatz im Daten-Grid hinzuf\00FCgen k\00F6nnen.</li>'),
unistr('<li>Zeile bearbeiten - Wenn der Quelltyp "Datenr-Grid" ist, k\00F6nnen Sie den Link "Zeile bearbeiten" anzeigen, damit privilegierte Benutzer einen Datensatz im Daten-Grid bearbeiten k\00F6nnen.</li>'),
unistr('<li>Suchfeld - Zeigt ein Textfeld in der Suchleiste an, in das Suchkriterien eingegeben werden k\00F6nnen.</li>'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431025005693402485.4903)
,p_name=>'P934_WORKSHEET_ID'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4903)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431027200976410589.4903)
,p_name=>'P934_WEBSHEET_TYPE'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4903)
,p_prompt=>'Quelltyp'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SECTION_SOURCE'
,p_lov=>'.'||wwv_flow_api.id(428681322228645128.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den Quelltyp des Datenabschnitts an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431027810457422741.4903)
,p_name=>'P934_DATA_GRID_NAME'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Daten-Grid-Name'
,p_source=>'''<span class="display_bold">''||wwv_flow_escape.html(:P934_WEBSHEET_NAME)||''</span><a href="f?p=''||:APP_ID||'':2:''||:APP_SESSION||''::::WS_APP_ID,P2_ID,P2_WEBSHEET_ID:''||:WS_APP_ID||'',''||:P934_WORKSHEET_ID||'',''||:P934_WEBSHEET_ID||''" class="goToLink">''|'
||'|wwv_flow_lang.system_message(''WS_VIEW_DATA_GRID'')||''<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class=""'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P934_WEBSHEET_TYPE'
,p_display_when2=>'DATA_GRID'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Gibt das Daten-Grid an, das zur Anzeige des Datenabschnitts verwendet wird.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431028416475433950.4903)
,p_name=>'P934_REPORT_NAME'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Berichtsname'
,p_source=>'''<span class="display_bold">''||wwv_flow_escape.html(:P934_WEBSHEET_NAME)||''</span><a href="f?p=''||:APP_ID||'':3000:''||:APP_SESSION||''::::WS_APP_ID,IR_ID,WS_ID:''||:WS_APP_ID||'',''||:P934_WORKSHEET_ID||'',''||:P934_WEBSHEET_ID||''" class="goToLink">''||wwv_f'
||'low_lang.system_message(''APEXIR_VIEW_REPORT'')||''<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class=""'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P934_WEBSHEET_TYPE'
,p_display_when2=>'REPORT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Gibt den Bericht an, der zur Anzeige des Datenabschnitts verwendet werden soll.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(431028803447439614.4903)
,p_name=>'P934_SAVED_REPORT_ID'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4903)
,p_prompt=>'Zu verwendende Berichtseinstellungen'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P934_SAVED_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.d, x.r',
'from (select case when r.application_user = ''APXWS_DEFAULT'' then',
'            m.primary_rpt||'' (''||m.primary||'')''',
'        when r.application_user = ''APXWS_ALTERNATIVE'' then',
'            r.name||'' (''||m.alternative||'')''',
'        end d,',
'        r.id r,',
'        case when r.application_user = ''APXWS_DEFAULT'' then 1',
'            when r.application_user = ''APXWS_ALTERNATIVE'' then 2',
'        end seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alternative',
'      from dual) m       ',
'where r.worksheet_id = :P934_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.application_user in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.is_default = ''Y''                    ',
'and (r.security_group_id = :flow_security_group_id or :flow_security_group_id = 10)',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')',
'union all',
'select r.name||'' (''||m.pub||'')'' d, r.id r, 3 seq',
'from wwv_flow_worksheet_rpts r,',
'     (select wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') pub from dual) m',
'where r.worksheet_id = :P934_WORKSHEET_ID',
'and security_group_id = :WORKSPACE_ID',
'and r.status = ''PUBLIC''',
'and r.application_user not in (''APXWS_DEFAULT'',''APXWS_ALTERNATIVE'')',
'and r.security_group_id = :flow_security_group_id',
'and r.session_id is null',
'and nvl(r.report_type,''REPORT'') not in (''NOTIFICATION'',''APX_WS_DATA'')) x',
'order by x.seq, x.r'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Gibt die Berichtseinstellungen f\00FCr das ausgew\00E4hlte Daten-Grid oder den Bericht an. Wenn Sie andere Berichtseinstellungen verwenden m\00F6chten, m\00FCssen Sie den Abschnitt l\00F6schen und neu erstellen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(619991221839354556.4903)
,p_name=>'P934_STYLE'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(431020504392383148.4903)
,p_item_default=>'1'
,p_prompt=>'Stil'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA SECTION STYLE'
,p_lov=>'.'||wwv_flow_api.id(746262913082105905.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('W\00E4hlen Sie verschiedene Stile f\00FCr die Benutzeroberfl\00E4che.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(814201812810805440.4903)
,p_name=>'P934_CHANGE_COUNT'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(16875108349910367.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(20022318840555508.4903)
,p_computation_sequence=>10
,p_computation_item=>'SECTION_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P934_SECTION_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(814243608224823057.4903)
,p_validation_name=>'check section lost update'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.check_section_lost_update (',
'    p_ws_app_id             => :WS_APP_ID,',
'    p_page_id               => :P900_ID,',
'    p_section_id            => :P934_SECTION_ID,',
'    p_change_count          => :P934_CHANGE_COUNT,',
'    p_section_type          => ''DATA'',',
'    p_display_seq           => :P934_DISPLAY_SEQ,',
'    p_title                 => :P934_TITLE,   ',
'    --',
'    p_data_grid_id          => :P934_WEBSHEET_ID,',
'    p_report_id             => :P934_SAVED_REPORT_ID,',
'    p_data_section_style    => :P934_STYLE',
'    );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_validation_condition=>'SAVE,SAVEANDGOTONEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(180468800256085348.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save data section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_webpage_section (     ',
'    p_ws_app_id             => :ws_app_id,   ',
'    p_webpage_id            => :P900_ID,',
'    p_section_id            => :P934_SECTION_ID,',
'    p_section_type          => ''DATA'',',
'    p_display_seq           => :P934_DISPLAY_SEQ,',
'    p_title                 => :P934_TITLE,   ',
'    --',
'    p_data_grid_id          => :P934_WEBSHEET_ID,',
'    p_report_id             => :P934_SAVED_REPORT_ID,',
'    p_data_section_style    => :P934_STYLE,',
'    p_max_row_count         => :P934_MAX_ROW_CNT,',
'    p_show_option           => :P934_SHOW_OPT',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Datenabschnitt konnte nicht gespeichert werden.'
,p_process_when=>'SAVE,SAVEANDGOTONEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Datenabschnitt gespeichert.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(180468432009085336.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage_section (',
'    p_section_id       => :P934_SECTION_ID,',
'    p_section_type     => ''DATA'',',
'    p_ws_app_id        => :WS_APP_ID,',
'    p_webpage_id       => :P900_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Abschnitt konnte nicht gel\00F6scht werden.')
,p_process_when_button_id=>wwv_flow_api.id(180466021313085287.4903)
,p_process_success_message=>unistr('Abschnitt gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(180468626102085347.4903)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch data section'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_data_section (',
'  p_section_id           => :P934_SECTION_ID,',
'  p_section_type         => ''DATA'',',
'  -- out',
'  p_display_seq          => :P934_DISPLAY_SEQ,     ',
'  p_title                => :P934_TITLE,',
'  p_worksheet_id         => :P934_WORKSHEET_ID,',
'  p_websheet_type        => :P934_WEBSHEET_TYPE,',
'  p_websheet_id          => :P934_WEBSHEET_ID,',
'  p_websheet_name        => :P934_WEBSHEET_NAME,',
'  p_report_id            => :P934_SAVED_REPORT_ID,',
'  p_data_section_style   => :P934_STYLE,',
'  p_change_count         => :P934_CHANGE_COUNT,',
'  p_max_row_count        => :P934_MAX_ROW_CNT,',
'  p_show_option          => :P934_SHOW_OPT',
'  );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Datenabschnitt konnte nicht abgerufen werden.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471213828127764148.4903)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create section collection for dynamic list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
' wwv_flow_ws_api.create_pg_sec_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id=> :WS_APP_ID,',
'    p_page_id => :P900_ID,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed for dynamic list.'
);
end;
/
prompt --application/pages/page_00940
begin
wwv_flow_api.create_page(
 p_id=>940.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Abschnitte bearbeiten'
,p_step_title=>'Abschnitte bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18810709996021492.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_EDIT_SECTIONS''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(495911823374140640.4903)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(495963309025325720.4903)
,p_name=>'Edit Sections'
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.hidden(1,s.n001)||wwv_flow_item.text(2,s.n003, 16, 255, ''class="orderby" style="display:none;"'')||wwv_flow_item.text(3,s.c001,60,4000) section_name,',
'       s.c002 section_type',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a,',
'     wwv_flow_collections s',
'where p.security_group_id = :flow_security_group_id ',
'  and p.ws_app_id = :ws_app_id',
'  and p.id = :p900_id',
'  and p.ws_app_id = a.id  ',
'  and p.id = s.n002 (+)',
'  and s.collection_name (+) = ''APEX$_WS_SECTIONS''',
'order by n003'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46784125242633572.4903)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Daten gefunden'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(495963605456325727.4903)
,p_query_column_id=>1
,p_column_alias=>'SECTION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Abschnittstitel'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_column_width=>60
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(495963731919325805.4903)
,p_query_column_id=>2
,p_column_alias=>'SECTION_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Typ'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_api.id(492203630195322675)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(495972224131670688.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(495911823374140640.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(495972401406673565.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(495911823374140640.4903)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(495973102922683439.4903)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(495972401406673565.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(495974021454726671.4903)
,p_name=>'P940_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(495911823374140640.4903)
,p_prompt=>'Seite:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(495974419161735489.4903)
,p_computation_sequence=>10
,p_computation_item=>'P940_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'and id = :p900_id',
'order by 1'))
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(496323222231058051.4903)
,p_validation_name=>'sequence cannot be null'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f03.count',
'loop',
'    if wwv_flow.g_f01(i) is null then',
'        return false;',
'    end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Sequenz muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(495972401406673565.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(496327106085062791.4903)
,p_validation_name=>'section title cannot be null'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f03.count',
'loop',
'    if wwv_flow.g_f02(i) is null then',
'        return false;',
'    end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Abschnittstitel muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(495972401406673565.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(496328429419079069.4903)
,p_validation_name=>'Sequence must be numeric'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f03.count',
'loop',
'    if wwv_flow.g_f01(i) is not null then',
'        if not wwv_flow_utilities.is_numeric(p_str=>wwv_flow.g_f01(i)) then',
'          return false;',
'        end if;',
'    end if;',
'end loop;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Sequenz muss numerisch sein.'
,p_when_button_pressed=>wwv_flow_api.id(495972401406673565.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(495977229429804648.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save sections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_ws_api.save_section_seq_title (',
'    p_section_id    => wwv_flow.g_f01(i), ',
'    p_ws_app_id     => :ws_app_id,',
'    p_webpage_id    => :p900_id,    ',
'    p_display_seq   => i*10,',
'    p_title         => wwv_flow.g_f03(i)    ',
'    );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Abschnitte konnten nicht aktualisiert werden.'
,p_process_when_button_id=>wwv_flow_api.id(495972401406673565.4903)
,p_process_success_message=>'Aktualisierte Abschnitte.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(495964502492352222.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection for sections report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_section_collection (',
'    p_security_group_id => :flow_security_group_id,',
'    p_ws_app_id         => :ws_app_id,',
'    p_page_id           => :p900_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_comment=>'This process needed to populate collection data to report all sections.'
);
end;
/
prompt --application/pages/page_00950
begin
wwv_flow_api.create_page(
 p_id=>950.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Historie'
,p_step_title=>'Historie'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20894908640941912.4903)
,p_plug_name=>'Aktionsleiste'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20895900114948899.4903)
,p_plug_name=>'Set Page'
,p_parent_plug_id=>wwv_flow_api.id(20894908640941912.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_header=>'<div class="wsSmallFormComponent">'
,p_plug_footer=>'</div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471881322072882391.4903)
,p_plug_name=>'History Tab'
,p_parent_plug_id=>wwv_flow_api.id(20894908640941912.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_api.id(471880222274882374.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22641410173571436.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(456375318299928143.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>In diesem Bericht werden \00C4nderungen an den Seitenabschnitten angezeigt.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(457467831509230851.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(460146921197349250.4903)
,p_plug_name=>'Change History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'-- section content chages',
'       (select max(p.name) from WWV_FLOW_WS_WEBPAGES p where p.id = n003) page_name,',
'       n003 page_id,',
'       d001 change_date,',
'       c001 section_title,        ',
'       c004 old_content, ',
'       c005 new_content, ',
'       lower(c006) application_user_id',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_SEC_HISTORY'' and',
'     (nvl(:P950_PAGE,0) = 0 or n003 = :P950_PAGE) and',
'     (c004 is not null or c005 is not null)',
'union all',
'-- section title changes',
'select ',
'       (select max(p.name) from WWV_FLOW_WS_WEBPAGES p where p.id = n003) page_name,',
'       n003 page_id,',
'       d001 change_date,',
'       c001 section_title, ',
'       c002 old_content, ',
'       c003 new_content,        ',
'       lower(c006) application_user_id',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_SEC_HISTORY'' and',
'     (nvl(:P950_PAGE,0) = 0 or n003 = :P950_PAGE) and',
'     c002 is not null',
'union all',
'-- new pages',
'select ',
'       name page_name,',
'       id page_id,',
'       CREATED_ON change_date,',
'       null section_title, ',
'       null old_content, ',
'       :P950_PAGE_CREATED_TEXT new_content,       ',
'       lower(created_by) application_user_id',
'from WWV_FLOW_WS_WEBPAGES',
'where ',
'     (nvl(:P950_PAGE,0) = 0 or id = :P950_PAGE) and',
'     security_group_id = :flow_security_group_id and',
'     WS_APP_ID = :WS_APP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(460147017782349250.4903)
,p_name=>'Change History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'JOEL'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(460147624830349263.4903)
,p_db_column_name=>'CHANGE_DATE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>unistr('Ge\00E4ndert')
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(460147911265349264.4903)
,p_db_column_name=>'OLD_CONTENT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Alter Inhalt'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(460148024030349264.4903)
,p_db_column_name=>'NEW_CONTENT'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Neuer Inhalt'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(460148126679349264.4903)
,p_db_column_name=>'APPLICATION_USER_ID'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Benutzer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(460154224569437501.4903)
,p_db_column_name=>'SECTION_TITLE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Abschnitt'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22562305671219986.4903)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Seite'
,p_column_link=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:900:P900_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(22564822687253328.4903)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Seite'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460245323566439989.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20895900114948899.4903)
,p_button_name=>'P950_SET'
,p_button_static_id=>'P950_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>'Festlegen'
,p_button_alignment=>'LEFT'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(460243531961423515.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(460146921197349250.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:950:&SESSION.::&DEBUG.:950,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(460245527855439992.4903)
,p_branch_action=>'f?p=&FLOW_ID.:950:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(22646627881604899.4903)
,p_name=>'P950_PAGE_CREATED_TEXT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(22641410173571436.4903)
,p_use_cache_before_default=>'NO'
,p_source=>'wwv_flow_lang.system_message(''WS_PAGE_CREATED'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460244810406436230.4903)
,p_name=>'P950_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20895900114948899.4903)
,p_prompt=>'Seite'
,p_source=>'P900_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST APPLICATION PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(name,1,30) name , id',
'from wwv_flow_ws_webpages p',
'where  p.ws_app_id = :ws_app_id and security_group_id = :flow_security_group_id',
'order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Alle Seiten anzeigen -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(460143514077302021.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Section History collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_sec_history_collection (',
'    p_ws_app_id => :WS_APP_ID,',
'    p_max_row_count => 500,',
'    p_webpage_id => nvl(:P950_PAGE, :P900_ID)',
'    );'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_00951
begin
wwv_flow_api.create_page(
 p_id=>951.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Kalender f\00FCr Seitenerstellung')
,p_step_title=>unistr('Kalender f\00FCr Seitenerstellung')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20860907265317014.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20911307798130897.4903)
,p_plug_name=>'Kalendernavigationsleiste'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-bottom: 10px;min-height:40px;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>25
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471882717562890165.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_calendar(
 p_id=>wwv_flow_api.id(471883431194903918.4903)
,p_plug_name=>unistr('Kalender f\00FCr Seitenerstellung')
,p_region_attributes=>'style="width:100%;clear:both;"'
,p_plug_source_type=>'NATIVE_CALENDAR'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       sys.htf.escape_sc(p.name) name, ',
'       ''ws?p=''||p.ws_app_id||'':''||p.PAGE_ALIAS||'':''||:APP_SESSION run_link,     ',
'       p.created_on,',
'       p.created_by',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a',
'where p.security_group_id = :flow_security_group_id ',
'and p.ws_app_id = :ws_app_id',
'and a.id = p.ws_app_id'))
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'ABOVE'
,p_cal_id=>wwv_flow_api.id(471883623668903925.4903)
,p_begin_at_start_of_interval=>'Y'
,p_date_item=>'P951_CALENDAR_DATE'
,p_display_as=>'M'
,p_display_item=>'P951_CALENDAR_DISPLAY'
,p_display_type=>'COL'
,p_date_column=>'CREATED_ON'
,p_display_column=>'NAME'
,p_start_of_week=>19721105
,p_item_link=>'#RUN_LINK#'
,p_start_time=>0
,p_end_time=>23
,p_time_format=>'24HOUR'
,p_week_start_day=>19721105
,p_week_end_day=>19721111
,p_date_type_column=>'P951_CALENDAR_TYPE'
,p_custom_cal_days=>3
,p_item_link_open_in=>'W'
,p_include_time_with_date=>'N'
,p_agenda_cal_days_type=>'MONTH'
,p_agenda_cal_days=>30
,p_template_id=>wwv_flow_api.id(20940421004163137.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471888129940913000.4903)
,p_plug_name=>'History Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(471880222274882374.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(471892218436004296.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(471888129940913000.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:951:&SESSION.::&DEBUG.:951::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(471885701426903947.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20911307798130897.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890400835826116.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(471886127121903947.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20911307798130897.4903)
,p_button_name=>'TODAY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>'Heute'
,p_button_position=>'EDIT'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(471886503849903950.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20911307798130897.4903)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20905523503069232.4903)
,p_button_image_alt=>'Weiter'
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(471886900141903951.4903)
,p_branch_action=>'f?p=&FLOW_ID.:951:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471883907793903929.4903)
,p_name=>'P951_CALENDAR_DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20860907265317014.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'return to_char(localtimestamp,''YYYYMMDD'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'P951_CALENDAR_DATE'
,p_source=>'P951_CALENDAR_DATE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated by Calendar wizard on 22-FEB-10'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471884125264903938.4903)
,p_name=>'P951_CALENDAR_END_DATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20860907265317014.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'return to_char(localtimestamp+7,''YYYYMMDD'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'P951_CALENDAR_END_DATE'
,p_source=>'P951_CALENDAR_END_DATE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated by Calendar wizard on 22-FEB-10'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471884327165903939.4903)
,p_name=>'P951_CALENDAR_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20860907265317014.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'P951_CALENDAR_DISPLAY'
,p_source=>'P951_CALENDAR_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated by Calendar wizard on 22-FEB-10'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471886732408903950.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Next'
,p_process_sql_clob=>' apex_util.increment_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim \00C4ndern von Kalenderdatum.')
,p_process_when_button_id=>wwv_flow_api.id(471886503849903950.4903)
,p_process_comment=>'Generated 22-FEB-10'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471885925459903947.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Previous'
,p_process_sql_clob=>' apex_util.decrement_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim \00C4ndern von Kalenderdatum.')
,p_process_when_button_id=>wwv_flow_api.id(471885701426903947.4903)
,p_process_comment=>'Generated 22-FEB-10'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471886330644903949.4903)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Today'
,p_process_sql_clob=>' apex_util.today_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Fehler beim \00C4ndern von Kalenderdatum.')
,p_process_when_button_id=>wwv_flow_api.id(471886127121903947.4903)
,p_process_comment=>'Generated 22-FEB-10'
);
end;
/
prompt --application/pages/page_00960
begin
wwv_flow_api.create_page(
 p_id=>960.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Seite l\00F6schen')
,p_step_title=>unistr('Seite l\00F6schen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177964015580736665.4903)
,p_plug_name=>unistr('Seite l\00F6schen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Wenn eine Seite gel\00F6scht wird, werden die Seite und alle untergeordneten Seiten sowie der verkn\00FCpfte Seitencontent gel\00F6scht.')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177971004253771606.4903)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(437163100711661598.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :app_session, ',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',    ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_EDIT_PAGE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(636290328503002581.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>L\00F6schen Sie diese Seite und alle zugeh\00F6rigen Seiteninhalte.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177971415335774767.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(177971004253771606.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(177972408886782347.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(177971004253771606.4903)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('Seite l\00F6schen')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(177971609672774769.4903)
,p_branch_action=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177980232004158002.4903)
,p_name=>'P960_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(177964015580736665.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Seitenname'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_ws_webpages',
'where id = :p53_id',
'and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177980515990172377.4903)
,p_name=>'P960_CHILD_PAGES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(177964015580736665.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Untergeordnete Seiten'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_child_page  varchar2(32767) := null;',
'  l_cnt         pls_integer := 0;',
'begin',
'  for c1 in (select name',
'             from wwv_flow_ws_webpages',
'             where parent_page_id = :p53_id',
'             and security_group_id = :flow_security_group_id)',
'  loop',
'    l_cnt := l_cnt + 1;',
'    if l_cnt > 1 then',
'        l_child_page := l_child_page||'', '';',
'    end if;',
'    l_child_page := l_child_page||c1.name;',
'  end loop;',
'  return l_child_page;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_ws_webpages',
'where parent_page_id = :p53_id',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177973310749792376.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page 900'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'900'
,p_process_when_button_id=>wwv_flow_api.id(177972408886782347.4903)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(177973023431786563.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_webpage (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :P53_ID);',
'',
'-- set the page id to home page id which never gets deleted',
'-- otherwise, page specific menu will error out',
':P900_ID := wwv_flow_ws_api.get_home_page_id (p_ws_app_id => :WS_APP_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Die Seite konnte nicht gel\00F6scht werden.')
,p_process_when_button_id=>wwv_flow_api.id(177972408886782347.4903)
,p_process_success_message=>unistr('Seite gel\00F6scht.')
);
end;
/
prompt --application/pages/page_00977
begin
wwv_flow_api.create_page(
 p_id=>977.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Seite per E-Mail senden'
,p_step_title=>'Seite per E-Mail senden'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22859824023975817.4903)
,p_plug_name=>unistr('Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(22860628872977239.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_EMAIL_PAGE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(473381600132154324.4903)
,p_plug_name=>'E-Mail'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(473384100872182900.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(22859824023975817.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.::WS_APP_ID:&WS_APP_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(473387723213227278.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(22859824023975817.4903)
,p_button_name=>'SEND'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Senden'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(473384500656192340.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473381910521157342.4903)
,p_name=>'P977_TO'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(473381600132154324.4903)
,p_prompt=>'An'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Geben Sie die gew\00FCnschte E-Mail-Adresse ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473382416755159202.4903)
,p_name=>'P977_SUBJECT'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(473381600132154324.4903)
,p_prompt=>'Betreff'
,p_source=>'select name from wwv_flow_ws_webpages where id = :P900_ID and security_group_id = :flow_security_group_id and ws_app_id = :ws_app_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Geben Sie den E-Mail-Betreff ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473382626105161894.4903)
,p_name=>'P977_BODY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(473381600132154324.4903)
,p_prompt=>'Body'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Geben Sie den Inhalt der E-Mail zusammen mit dem Websheet-Seitenlink ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(473383214939177539.4903)
,p_name=>'P977_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(473381600132154324.4903)
,p_item_default=>'LINK'
,p_prompt=>'Format'
,p_source=>'LINK'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGE EMAIL OPTIONS'
,p_lov=>'.'||wwv_flow_api.id(473383419441178851.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Die E-Mail sendet den Websheet-Seitenlink.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(473384813470196064.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'email report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.send_page_email (',
'    p_ws_app_id   => :WS_APP_ID,',
'    p_webpage_id  => :P900_ID,',
'    p_to          => :P977_TO,',
'    p_subject     => :P977_SUBJECT,',
'    p_body        => :P977_BODY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>'Aktion verarbeitet'
);
end;
/
prompt --application/pages/page_00990
begin
wwv_flow_api.create_page(
 p_id=>990.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Abschnitt in andere Seite verschieben'
,p_step_title=>'Abschnitt in andere Seite verschieben'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(15627530893704526.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20058000092871776.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20076302338184738.4903)
,p_plug_name=>'Abschnitt in andere Seite verschieben'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20076832466193411.4903)
,p_plug_name=>'Abschnitte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20077203161194445.4903)
,p_plug_name=>'Sections Controls Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(17118702088912337.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20077412512197151.4903)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20077720477199411.4903)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472197228960897529.4903)
,p_plug_name=>'Move Section to Another Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472616914577492023.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20058000092871776.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472617129806492026.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20058000092871776.4903)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Abschnitt verschieben'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20077006258193411.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(20076832466193411.4903)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4903)
,p_button_image_alt=>'Ausblenden/Anzeigen'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(20079116106207624.4903)
,p_branch_action=>'f?p=&APP_ID.:&P990_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P990_NEXT_SECTION_PAGE_ID.:&P990_NEXT_SECTION_ITEM_NAME.:&P990_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(472662514305747409.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20078323818199413.4903)
,p_name=>'P990_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(20077720477199411.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20078518731199413.4903)
,p_name=>'P990_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(20077720477199411.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20078701839199413.4903)
,p_name=>'P990_NEXT_SECTION_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(20077720477199411.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472618531677506427.4903)
,p_name=>'P990_NEW_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(472197228960897529.4903)
,p_prompt=>'Neue Seite'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_ws_webpages',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Neue Seite ausw\00E4hlen -')
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472618731519506431.4903)
,p_name=>'P990_NEW_SECTION_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(472197228960897529.4903)
,p_item_default=>'10'
,p_prompt=>'Neue Abschnittssequenz'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>12
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472629822383607872.4903)
,p_name=>'P990_CURRENT_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(472197228960897529.4903)
,p_prompt=>'Aktuelle Seite'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472637000004610810.4903)
,p_name=>'P990_SECTION_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(472197228960897529.4903)
,p_prompt=>'Abschnittsname'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472637709354613527.4903)
,p_name=>'P990_SECTION_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(20077720477199411.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472638716626615588.4903)
,p_name=>'P990_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(20077720477199411.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(472654616505681784.4903)
,p_computation_sequence=>10
,p_computation_item=>'P990_SECTION_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_ws_api.get_section_name(p_section_id=>:P990_SECTION_ID);'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(472658613219718662.4903)
,p_computation_sequence=>20
,p_computation_item=>'P990_CURRENT_PAGE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select name from WWV_FLOW_WS_WEBPAGES where id = :P990_PAGE_ID and security_group_id = :flow_security_group_id and ws_app_id = :WS_APP_ID'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20100408365271591.4903)
,p_validation_name=>'P990_NEW_PAGE not null'
,p_validation_sequence=>10
,p_validation=>'P990_NEW_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_when_button_pressed=>wwv_flow_api.id(472617129806492026.4903)
,p_associated_item=>wwv_flow_api.id(472618531677506427.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20100715291273609.4903)
,p_validation_name=>'P990_NEW_SECTION_SEQUENCE not null'
,p_validation_sequence=>20
,p_validation=>'P990_NEW_SECTION_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_when_button_pressed=>wwv_flow_api.id(472617129806492026.4903)
,p_associated_item=>wwv_flow_api.id(472618731519506431.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(472661824909740980.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'move section to new page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.move_section_to_existing_page (',
'  p_ws_app_id => :ws_app_id,',
'  p_section_id  => :P990_SECTION_ID,',
'  p_old_page_id => :P990_PAGE_ID,',
'  p_new_page_id => :P990_NEW_PAGE,',
'  p_new_section_sequence=>:P990_NEW_SECTION_SEQUENCE);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(472617129806492026.4903)
,p_process_success_message=>'Abschnitt verschoben'
);
end;
/
prompt --application/pages/page_00991
begin
wwv_flow_api.create_page(
 p_id=>991.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Abschnitt in neue Seite verschieben'
,p_step_title=>'Abschnitt in neue Seite verschieben'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(15627530893704526.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(18815809050077970.4903)
,p_plug_name=>unistr('Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20031126421605017.4903)
,p_plug_name=>'Abschnitt in neue Seite verschieben'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(15634208564734334.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20031301964607440.4903)
,p_plug_name=>'Abschnitte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'class="leftButtons"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(17121518626936007.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20031706120608594.4903)
,p_plug_name=>'Sections Controls Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(17135113310000767.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(17118702088912337.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20031915470611275.4903)
,p_plug_name=>'Page Sections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(15661014418081294.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(15654631677982271.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20032228976615200.4903)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472663102924772522.4903)
,p_plug_name=>'Abschnitt in neue Seite verschieben'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472663410196774634.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(18815809050077970.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(472663610174774635.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(18815809050077970.4903)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Abschnitt verschieben'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(20031524843607443.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(20031301964607440.4903)
,p_button_name=>'HIDESHOW_SIDECOL'
,p_button_static_id=>'sideColControl'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(16714408571357214.4903)
,p_button_image_alt=>'Ausblenden/Anzeigen'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:void(0)'
,p_button_execute_validations=>'N'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(20041810500676093.4903)
,p_branch_action=>'f?p=&APP_ID.:&P991_NEXT_SECTION_PAGE_ID.:&SESSION.::&DEBUG.:&P991_NEXT_SECTION_PAGE_ID.:&P991_NEXT_SECTION_ITEM_NAME.:&P991_NEXT_SECTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVEANDGOTONEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(472666825134807286.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20041322143670008.4903)
,p_name=>'P991_NEXT_SECTION_PAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(20032228976615200.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20041528723671915.4903)
,p_name=>'P991_NEXT_SECTION_ITEM_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(20032228976615200.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(20041701496673521.4903)
,p_name=>'P991_NEXT_SECTION_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(20032228976615200.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472663908942783653.4903)
,p_name=>'P991_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(20032228976615200.4903)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472664123317783654.4903)
,p_name=>'P991_SECTION_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(20032228976615200.4903)
,p_prompt=>'Section'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472664332264783654.4903)
,p_name=>'P991_NEW_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(472663102924772522.4903)
,p_prompt=>'Neuer Seitenname'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472664523251783655.4903)
,p_name=>'P991_NEW_PAGE_PARENT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(472663102924772522.4903)
,p_prompt=>unistr('Neues \00FCbergeordnetes Seitenobjekt')
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEBSHEETS - PICK PARENT -- SHOW ALL PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from   wwv_flow_ws_webpages',
'where security_group_id = :flow_security_group_id and',
'      ws_app_id = :WS_APP_ID ',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- \00DCbergeordnete Seite ausw\00E4hlen -')
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472664716950783655.4903)
,p_name=>'P991_SECTION_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(472663102924772522.4903)
,p_prompt=>'Zu verschiebender Abschnitt'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472664903271783656.4903)
,p_name=>'P991_PAGE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(472663102924772522.4903)
,p_prompt=>'Aktuelle Seite'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(472665119121783656.4903)
,p_name=>'P991_NEW_PAGE_ALIAS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(472663102924772522.4903)
,p_prompt=>'Neuer Seitenaliasname'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(472668229767818084.4903)
,p_computation_sequence=>10
,p_computation_item=>'P991_PAGE_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select name from WWV_FLOW_WS_WEBPAGES where id = :P990_PAGE_ID and security_group_id = :flow_security_group_id and ws_app_id = :WS_APP_ID'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(472668025611816879.4903)
,p_computation_sequence=>20
,p_computation_item=>'P991_SECTION_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_ws_api.get_section_name(p_section_id=>:P991_SECTION_ID);'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(20038415086658550.4903)
,p_validation_name=>'P991_NEW_PAGE_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P991_NEW_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_when_button_pressed=>wwv_flow_api.id(472663610174774635.4903)
,p_associated_item=>wwv_flow_api.id(472664332264783654.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(472666620286805919.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'move section to new page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_parent number := null;',
'begin',
'  if nvl(:P991_NEW_PAGE_PARENT,0) != 0 then',
'     l_parent := :P991_NEW_PAGE_PARENT;',
'   end if;',
'wwv_flow_ws_api.move_section_to_new_page (',
'  p_ws_app_id => :WS_APP_ID,',
'  p_section_id => :P991_SECTION_ID,',
'  p_old_page_id => :P991_PAGE_ID,',
'  p_new_page_name => :P991_NEW_PAGE_NAME,',
'  p_new_page_alias => :P991_NEW_PAGE_ALIAS,',
'  p_new_parent_page_id => l_parent);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(472663610174774635.4903)
,p_process_success_message=>'Abschnitt in neue Seite verschoben'
);
end;
/
prompt --application/pages/page_00999
begin
wwv_flow_api.create_page(
 p_id=>999.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Seite nicht gefunden'
,p_step_title=>'Seite nicht gefunden'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(53193408981633671.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(466990113840764981.4903)
,p_plug_name=>'Seite nicht gefunden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'Die von Ihnen angeforderte Seite wurde nicht gefunden.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
end;
/
prompt --application/pages/page_01000
begin
wwv_flow_api.create_page(
 p_id=>1000.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Seitenverzeichnis'
,p_step_title=>'Seitenverzeichnis'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="pg1000_init()"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_api.id(4881207741750467)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script>',
'function pg1000_init(){',
'removeMessageTimeout()',
'}',
'</script>'))
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(9947808697145849.4903)
,p_plug_name=>'Page Directory'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;"'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(a.home_page_id,p.id,',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-home.png'',',
'       ''#IMAGE_PREFIX#ws/img/icons/icon-ws-page.png'') icon,',
'       ''Text Websheet'' doc_type,',
'       p.name, ',
'       ''ws?p=''||p.ws_app_id||'':''||p.PAGE_ALIAS||'':''||:APP_SESSION id, ',
'       p.name name_alt,       ',
'       p.status,',
'       ''No'' shared_with_project,',
'       ''No'' is_private,       ',
'       lower(p.owner) owner,             ',
'       p.created_on,',
'       p.created_by,',
'       nvl(p.updated_on,p.created_on) updated_on,',
'       p.updated_by,',
'       decode(PARENT_PAGE_ID ,null,null,(select pp.name from wwv_flow_ws_webpages pp where p.PARENT_PAGE_ID  = pp.id)) parent_page,',
'       decode(PARENT_PAGE_ID ,null,null,(select ppp.name from wwv_flow_ws_webpages ppp where ppp.id = (select pp.parent_page_id from wwv_flow_ws_webpages pp where p.PARENT_PAGE_ID  = pp.id))) grandparent_page',
'from wwv_flow_ws_webpages p,',
'     wwv_flow_ws_applications a',
'where p.security_group_id = :flow_security_group_id ',
'and p.ws_app_id = :ws_app_id',
'and a.id = p.ws_app_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(9947931622145849.4903)
,p_name=>'Icon View'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'NONE'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'ID'
,p_icon_view_img_src_column=>'ICON'
,p_icon_view_label_column=>'NAME'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9948518906145865.4903)
,p_db_column_name=>'OWNER'
,p_display_order=>2
,p_column_identifier=>'E'
,p_column_label=>unistr('Eigent\00FCmer')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9948118097145863.4903)
,p_db_column_name=>'ICON'
,p_display_order=>3
,p_column_identifier=>'A'
,p_column_label=>'Symbol'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9948428296145865.4903)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_link=>'#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9948328798145865.4903)
,p_db_column_name=>'ID'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'ID'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9951205657193026.4903)
,p_db_column_name=>'NAME_ALT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Name mit Eigent\00FCmer')
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9951305209193027.4903)
,p_db_column_name=>'STATUS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Status'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9958821858292308.4903)
,p_db_column_name=>'SHARED_WITH_PROJECT'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Gemeinsam verwendet'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(9960022336301949.4903)
,p_db_column_name=>'IS_PRIVATE'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Ist privat'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(25599908155176976.4903)
,p_db_column_name=>'DOC_TYPE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Dokumenttyp'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46955630831990613.4903)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46955704257990615.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46955801169990615.4903)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Aktualisiert am'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(46955923796990615.4903)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(636282405544863583.4903)
,p_db_column_name=>'PARENT_PAGE'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>unistr('\00DCbergeordnete Seite')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(636283427623888880.4903)
,p_db_column_name=>'GRANDPARENT_PAGE'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>unistr('Seite auf h\00F6chster Ebene')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(48530111301258073.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Verwenden Sie das Seitenverzeichnis, um alle Seiten in dem aktuellen Websheet anzuzeigen. Jedes Websheet kann aus einer beliebigen Anzahl von Seiten bestehen. Eine Seite wird als Homepage bezeichnet. Die Homepage ist die Startseite, die bei der Au'
||unistr('sf\00FChrung des Websheets angezeigt wird.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176569810015341629.4903)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(457462212977187649.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461347808155446630.4903)
,p_plug_name=>'Page Directory Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(461346705230446581.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(445328818813619998.4903)
,p_button_sequence=>8
,p_button_plug_id=>wwv_flow_api.id(9947808697145849.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:1000,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(78354923758038667.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(9947808697145849.4903)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890726723852448.4903)
,p_button_image_alt=>'Seite erstellen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:200::'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(78292528897585996.4903)
,p_branch_action=>'f?p=&APP_ID.:1000:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(32787425522167701.4903)
,p_branch_action=>'f?p=4350:1000:&SESSION.'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'FUNCTION_BODY'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if not wwv_flow_ws_setup.setup_exists then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(174672826985929595.4903)
,p_name=>'P1000_WS_APP_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(176569810015341629.4903)
,p_prompt=>'Ws App Name'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176569602397339451.4903)
,p_name=>'P1000_RUN_LINK'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(176569810015341629.4903)
,p_prompt=>'Run Link'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(176576007348473330.4903)
,p_computation_sequence=>10
,p_computation_item=>'P1000_RUN_LINK'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''f?p=4900:900:''||:app_session||''::::WS_APP_ID,P900_ID:''||',
'          :WS_APP_ID||'',''||home_page_id',
'  from WWV_FLOW_WS_APPLICATIONS',
' where SECURITY_GROUP_ID = :flow_security_group_id and',
'       id = :WS_APP_ID'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(177428717099068169.4903)
,p_computation_sequence=>20
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1000'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(174673313956935306.4903)
,p_computation_sequence=>30
,p_computation_item=>'P1000_WS_APP_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_ws_applications',
'where id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(176531710830925561.4903)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'log websheet activity'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_webdb_logging = ''YES'' then',
'    wwv_flow_log.g_websheet_id := :WS_APP_ID; ',
'end if;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_01001
begin
wwv_flow_api.create_page(
 p_id=>1001.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Websheet-Verzeichnis'
,p_step_title=>'Websheet-Verzeichnis'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/core/AppCards.css',
'#IMAGE_PREFIX#apex_ui/css/core/AppBlock.css',
'#IMAGE_PREFIX#apex_ui/css/util/u-Color.css'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.app-websheet-any-co { background-image: url(''data:image/svg+xml;charset=US-ASCII,%3C%3Fxml%20version%3D%221.0%22%20encoding%3D%22utf-8%22%3F%3E%3C!DOCTYPE%20svg%20PUBLIC%20%22-%2F%2FW3C%2F%2FDTD%20SVG%201.1%2F%2FEN%22%20%22http%3A%2F%2Fwww.w3.org%2F'
||'Graphics%2FSVG%2F1.1%2FDTD%2Fsvg11.dtd%22%3E%3Csvg%20version%3D%221.1%22%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%20xmlns%3Axlink%3D%22http%3A%2F%2Fwww.w3.org%2F1999%2Fxlink%22%20x%3D%220px%22%20y%3D%220px%22%20%20viewBox%3D%220%200%2064%'
||'2064%22%20enable-background%3D%22new%200%200%2064%2064%22%20xml%3Aspace%3D%22preserve%22%3E%3Csymbol%20%20id%3D%22gauge-blank%22%20viewBox%3D%22-28%20-28%2056%2056%22%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23CCCCCC%22%20d%3D%22M0-28c15.464%2C0%2C28%2'
||'C12.536%2C28%2C28S15.464%2C28%2C0%2C28S-28%2C15.464-28%2C0S-15.464-28%2C0-28z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M0-24c13.255%2C0%2C24%2C10.745%2C24%2C24S13.255%2C24%2C0%2C24S-24%2C13.255-24%2C0S-13.255-24%'
||'2C0-24z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M14.107%2C19.416c-10.723%2C7.791-25.732%2C5.414-33.523-5.31s-5.414-25.732%2C5.31-33.523%20%20%20s25.732-5.414%2C33.523%2C5.31S24.83%2C11.625%2C14.107%2C19.416z%22%'
||'2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23F3F3F3%22%20d%3D%22M0%2C22c12.919%2C0%2C23.45-10.209%2C23.975-23C23.988-0.668%2C24-0.335%2C24%2C0c0%2C13.255-10.745%2C24-24%2C24%20%20%20S-24%2C13.255-24%2C0c0-0.335%2C0.012-0.668%2C0.025-1C-23'
||'.45%2C11.791-12.919%2C22%2C0%2C22z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FAAB67%22%20d%3D%22M-13.326%2C8.849C-10.634%2C12.896-6.146%2C15.631-1%2C15.95v4c-6.625-0.328-12.396-3.863-15.788-9.102%20%20%20%20L-13.326%'
||'2C8.849z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%2324CB7F%22%20d%3D%22M-16%2C0c0%2C1.376%2C0.192%2C2.704%2C0.519%2C3.979l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20c0-6.293%2C2.912-11.'
||'899%2C7.455-15.565l2.35%2C3.235C-13.74-9.396-16-4.962-16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-19.289%2C4.216l3.597-1.169c0.062%2C0.313%2C0.132%2C0.624%2C0.211%2C0.931l-3.808%2'
||'C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20%20c0-0.186%2C0.011-0.368%2C0.016-0.553C-19.945%2C1.094-19.701%2C2.689-19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-16-1c0-4.749%2C2.084-8.999%2C5.37-11.9'
||'29l0.435%2C0.599c-3.454%2C2.859-5.671%2C7.146-5.784%2C11.953%20%20%20%20%20C-15.987-0.584-16-0.791-16-1z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FFBE2A%22%20d%3D%22M-14.869%2C5.883C-12.641%2C11.509-7.32'
||'1%2C15.558-1%2C15.95v4c-8.097-0.401-14.914-5.603-17.672-12.831%20%20%20%20L-14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M-18.672%2C7.118l0.372-0.121C-15.339%2C13.762-8.763%2C18.565-1%2C18.95v1'
||'C-9.097%2C19.548-15.914%2C14.347-18.672%2C7.118z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23ED1E24%22%20d%3D%22M16%2C0c0%2C1.376-0.192%2C2.704-0.519%2C3.979l3.808%2C1.237C19.738%2C3.55%2C20%2C1.808%2C2'
||'0%2C0%20%20%20%20c0-6.293-2.912-11.899-7.455-15.565l-2.35%2C3.235C13.74-9.396%2C16-4.962%2C16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M19.289%2C4.216c0.412-1.527%2C0.656-3.121%2C0.'
||'695-4.769C19.989-0.368%2C20-0.186%2C20%2C0c0%2C1.808-0.262%2C3.55-0.711%2C5.216%20%20%20%20%20l-3.808-1.237c0.079-0.307%2C0.149-0.618%2C0.211-0.931L19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M16-1c0%2C0.20'
||'9-0.013%2C0.416-0.021%2C0.623c-0.113-4.807-2.329-9.094-5.784-11.953l0.435-0.599C13.916-9.999%2C16-5.749%2C16-1z%20%20%20%20%20%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23F47721%22%20d%3D%22M14.869%2C5.883C'
||'12.641%2C11.509%2C7.321%2C15.558%2C1%2C15.95v4c8.097-0.401%2C14.914-5.603%2C17.672-12.831%20%20%20%20L14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M18.3%2C6.997l0.372%2C0.121C15.914%2C14.347%2C'
||'9.097%2C19.548%2C1%2C19.95v-1C8.763%2C18.565%2C15.339%2C13.762%2C18.3%2C6.997z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cpath%20fill%3D%22%23807F7F%22%20d%3D%22M0%2C13.254%22%2F%3E%20%3Cpath%20fill%3D%22%23D9D9D8%22%20d%3D%22M5-18c0-1.1-0.9-2-2-2h-6'
||'c-1.1%2C0-2%2C0.9-2%2C2v1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2V-18z%22%2F%3E%20%3Cpath%20opacity%3D%220.05%22%20d%3D%22M3-15h-6c-1.1%2C0-2-0.9-2-2v-1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2v1C5-15.9%2C4.1-15%2C3-15z%22%2F%3E%3C'
||'%2Fsymbol%3E%3Csymbol%20%20id%3D%22gauge-blank_2%22%20viewBox%3D%22-28%20-28%2056%2056%22%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23CCCCCC%22%20d%3D%22M0-28c15.464%2C0%2C28%2C12.536%2C28%2C28S15.464%2C28%2C0%2C28S-28%2C15.464-28%2C0S-15.464-28%2C0-28z'
||'%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M0-24c13.255%2C0%2C24%2C10.745%2C24%2C24S13.255%2C24%2C0%2C24S-24%2C13.255-24%2C0S-13.255-24%2C0-24z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22'
||'%20d%3D%22M14.107%2C19.416c-10.723%2C7.791-25.732%2C5.414-33.523-5.31s-5.414-25.732%2C5.31-33.523%20%20%20s25.732-5.414%2C33.523%2C5.31S24.83%2C11.625%2C14.107%2C19.416z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23F3F3F3%22%20d%3D%22M'
||'0%2C22c12.919%2C0%2C23.45-10.209%2C23.975-23C23.988-0.668%2C24-0.335%2C24%2C0c0%2C13.255-10.745%2C24-24%2C24%20%20%20S-24%2C13.255-24%2C0c0-0.335%2C0.012-0.668%2C0.025-1C-23.45%2C11.791-12.919%2C22%2C0%2C22z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%'
||'3E%20%20%20%3Cpath%20fill%3D%22%23FAAB67%22%20d%3D%22M-13.326%2C8.849C-10.634%2C12.896-6.146%2C15.631-1%2C15.95v4c-6.625-0.328-12.396-3.863-15.788-9.102%20%20%20%20L-13.326%2C8.849z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%2'
||'0%3Cpath%20fill%3D%22%2324CB7F%22%20d%3D%22M-16%2C0c0%2C1.376%2C0.192%2C2.704%2C0.519%2C3.979l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20c0-6.293%2C2.912-11.899%2C7.455-15.565l2.35%2C3.235C-13.74-9.396-16-4.962-16%2C0z%22%2F%3E%20%20%'
||'3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-19.289%2C4.216l3.597-1.169c0.062%2C0.313%2C0.132%2C0.624%2C0.211%2C0.931l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20%20c0-0.186%2C0.011-0.368%'
||'2C0.016-0.553C-19.945%2C1.094-19.701%2C2.689-19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-16-1c0-4.749%2C2.084-8.999%2C5.37-11.929l0.435%2C0.599c-3.454%2C2.859-5.671%2C7.146-5.784%2C11.953%20%20%20%20%20C-'
||'15.987-0.584-16-0.791-16-1z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FFBE2A%22%20d%3D%22M-14.869%2C5.883C-12.641%2C11.509-7.321%2C15.558-1%2C15.95v4c-8.097-0.401-14.914-5.603-17.672-12.831%20%20%20%20L-1'
||'4.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M-18.672%2C7.118l0.372-0.121C-15.339%2C13.762-8.763%2C18.565-1%2C18.95v1C-9.097%2C19.548-15.914%2C14.347-18.672%2C7.118z%22%2F%3E%20%20%3C%2Fg%3E%20%'
||'3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23ED1E24%22%20d%3D%22M16%2C0c0%2C1.376-0.192%2C2.704-0.519%2C3.979l3.808%2C1.237C19.738%2C3.55%2C20%2C1.808%2C20%2C0%20%20%20%20c0-6.293-2.912-11.899-7.455-15.565l-2.35%2C3.235C13.74-9.396'
||'%2C16-4.962%2C16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M19.289%2C4.216c0.412-1.527%2C0.656-3.121%2C0.695-4.769C19.989-0.368%2C20-0.186%2C20%2C0c0%2C1.808-0.262%2C3.55-0.711%2C5.2'
||'16%20%20%20%20%20l-3.808-1.237c0.079-0.307%2C0.149-0.618%2C0.211-0.931L19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M16-1c0%2C0.209-0.013%2C0.416-0.021%2C0.623c-0.113-4.807-2.329-9.094-5.784-11.953l0.435-0.5'
||'99C13.916-9.999%2C16-5.749%2C16-1z%20%20%20%20%20%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23F47721%22%20d%3D%22M14.869%2C5.883C12.641%2C11.509%2C7.321%2C15.558%2C1%2C15.95v4c8.097-0.401%2C14.914-5.603%2C1'
||'7.672-12.831%20%20%20%20L14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M18.3%2C6.997l0.372%2C0.121C15.914%2C14.347%2C9.097%2C19.548%2C1%2C19.95v-1C8.763%2C18.565%2C15.339%2C13.762%2C18.3%2C6.997'
||'z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cpath%20fill%3D%22%23807F7F%22%20d%3D%22M0%2C13.254%22%2F%3E%20%3Cpath%20fill%3D%22%23D9D9D8%22%20d%3D%22M5-18c0-1.1-0.9-2-2-2h-6c-1.1%2C0-2%2C0.9-2%2C2v1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2V-'
||'18z%22%2F%3E%20%3Cpath%20opacity%3D%220.05%22%20d%3D%22M3-15h-6c-1.1%2C0-2-0.9-2-2v-1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2v1C5-15.9%2C4.1-15%2C3-15z%22%2F%3E%3C%2Fsymbol%3E%3Cg%20id%3D%22bkgd%22%20display%3D%22none%22%3E%20%3Crect%20disp'
||'lay%3D%22inline%22%20fill%3D%22%234AA4EC%22%20width%3D%2264%22%20height%3D%2264%22%2F%3E%3C%2Fg%3E%3Cg%20id%3D%22icons%22%3E%20%3Cg%20opacity%3D%220.1%22%3E%20%20%3Cpath%20d%3D%22M48%2C52H16v-8c0-1.105%2C0.895-2%2C2-2h28c1.105%2C0%2C2%2C0.895%2C2%2C2'
||'V52z%22%2F%3E%20%20%3Cpath%20d%3D%22M44%2C52H20V24c0-1.105%2C0.895-2%2C2-2h20c1.105%2C0%2C2%2C0.895%2C2%2C2V52z%22%2F%3E%20%20%3Cpath%20d%3D%22M40%2C39.294H24V19.061c0-0.912%2C0.466-1.76%2C1.235-2.25l5.333-3.394c0.874-0.556%2C1.99-0.556%2C2.863%2C0l5'
||'.333%2C3.394%20%20%20C39.534%2C17.3%2C40%2C18.149%2C40%2C19.061V39.294z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M48%2C51H16v-8c0-1.105%2C0.895-2%2C2-2h28c1.105%2C0%2C2%2C0.895%2C2%2C2V51z%22%2F%3E%20%20%3Cpath%2'
||'0fill%3D%22%23FFFFFF%22%20d%3D%22M44%2C51H20V23c0-1.105%2C0.895-2%2C2-2h20c1.105%2C0%2C2%2C0.895%2C2%2C2V51z%22%2F%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M40%2C38.294H24V18.061c0-0.912%2C0.466-1.76%2C1.235-2.25l5.333-3.394c0.874-0.556%2C1.'
||'99-0.556%2C2.863%2C0%20%20%20l5.333%2C3.394C39.534%2C16.3%2C40%2C17.149%2C40%2C18.061V38.294z%22%2F%3E%20%3C%2Fg%3E%20%3Crect%20x%3D%2224%22%20y%3D%2225%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2236%22%2'
||'0y%3D%2225%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2230%22%20y%3D%2225%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2224%22%20y%3D%2231%22%20fill%3D%22%23CACFD'
||'2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2236%22%20y%3D%2231%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2230%22%20y%3D%2231%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D'
||'%224%22%2F%3E%20%3Crect%20x%3D%2224%22%20y%3D%2237%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2236%22%20y%3D%2237%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%223'
||'0%22%20y%3D%2237%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2224%22%20y%3D%2243%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2236%22%20y%3D%2243%22%20fill%3D%22%2'
||'3CACFD2%22%20width%3D%224%22%20height%3D%224%22%2F%3E%20%3Crect%20x%3D%2230%22%20y%3D%2243%22%20fill%3D%22%23CACFD2%22%20width%3D%224%22%20height%3D%228%22%2F%3E%20%3Cpath%20fill%3D%22%23CACFD2%22%20d%3D%22M28%2C21c0-2.209%2C1.791-4%2C4-4s4%2C1.791%2'
||'C4%2C4H28z%22%2F%3E%3C%2Fg%3E%3C%2Fsvg%3E''); background-repeat: no-repeat; }',
'',
'.app-websheet-big-cats { background-image: url(''data:image/svg+xml;charset=US-ASCII,%3C%3Fxml%20version%3D%221.0%22%20encoding%3D%22utf-8%22%3F%3E%3C!DOCTYPE%20svg%20PUBLIC%20%22-%2F%2FW3C%2F%2FDTD%20SVG%201.1%2F%2FEN%22%20%22http%3A%2F%2Fwww.w3.org%'
||'2FGraphics%2FSVG%2F1.1%2FDTD%2Fsvg11.dtd%22%3E%3Csvg%20version%3D%221.1%22%20xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22%20xmlns%3Axlink%3D%22http%3A%2F%2Fwww.w3.org%2F1999%2Fxlink%22%20x%3D%220px%22%20y%3D%220px%22%20%20viewBox%3D%220%200%206'
||'4%2064%22%20enable-background%3D%22new%200%200%2064%2064%22%20xml%3Aspace%3D%22preserve%22%3E%3Csymbol%20%20id%3D%22gauge-blank%22%20viewBox%3D%22-28%20-28%2056%2056%22%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23CCCCCC%22%20d%3D%22M0-28c15.464%2C0%2C28'
||'%2C12.536%2C28%2C28S15.464%2C28%2C0%2C28S-28%2C15.464-28%2C0S-15.464-28%2C0-28z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M0-24c13.255%2C0%2C24%2C10.745%2C24%2C24S13.255%2C24%2C0%2C24S-24%2C13.255-24%2C0S-13.255-2'
||'4%2C0-24z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M14.107%2C19.416c-10.723%2C7.791-25.732%2C5.414-33.523-5.31s-5.414-25.732%2C5.31-33.523%20%20%20s25.732-5.414%2C33.523%2C5.31S24.83%2C11.625%2C14.107%2C19.416z%2'
||'2%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23F3F3F3%22%20d%3D%22M0%2C22c12.919%2C0%2C23.45-10.209%2C23.975-23C23.988-0.668%2C24-0.335%2C24%2C0c0%2C13.255-10.745%2C24-24%2C24%20%20%20S-24%2C13.255-24%2C0c0-0.335%2C0.012-0.668%2C0.025-1C-'
||'23.45%2C11.791-12.919%2C22%2C0%2C22z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FAAB67%22%20d%3D%22M-13.326%2C8.849C-10.634%2C12.896-6.146%2C15.631-1%2C15.95v4c-6.625-0.328-12.396-3.863-15.788-9.102%20%20%20%20L-13.32'
||'6%2C8.849z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%2324CB7F%22%20d%3D%22M-16%2C0c0%2C1.376%2C0.192%2C2.704%2C0.519%2C3.979l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20c0-6.293%2C2.912-1'
||'1.899%2C7.455-15.565l2.35%2C3.235C-13.74-9.396-16-4.962-16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-19.289%2C4.216l3.597-1.169c0.062%2C0.313%2C0.132%2C0.624%2C0.211%2C0.931l-3.808'
||'%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20%20c0-0.186%2C0.011-0.368%2C0.016-0.553C-19.945%2C1.094-19.701%2C2.689-19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-16-1c0-4.749%2C2.084-8.999%2C5.37-11'
||'.929l0.435%2C0.599c-3.454%2C2.859-5.671%2C7.146-5.784%2C11.953%20%20%20%20%20C-15.987-0.584-16-0.791-16-1z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FFBE2A%22%20d%3D%22M-14.869%2C5.883C-12.641%2C11.509-7.'
||'321%2C15.558-1%2C15.95v4c-8.097-0.401-14.914-5.603-17.672-12.831%20%20%20%20L-14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M-18.672%2C7.118l0.372-0.121C-15.339%2C13.762-8.763%2C18.565-1%2C18.95'
||'v1C-9.097%2C19.548-15.914%2C14.347-18.672%2C7.118z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23ED1E24%22%20d%3D%22M16%2C0c0%2C1.376-0.192%2C2.704-0.519%2C3.979l3.808%2C1.237C19.738%2C3.55%2C20%2C1.808%2'
||'C20%2C0%20%20%20%20c0-6.293-2.912-11.899-7.455-15.565l-2.35%2C3.235C13.74-9.396%2C16-4.962%2C16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M19.289%2C4.216c0.412-1.527%2C0.656-3.121%2C'
||'0.695-4.769C19.989-0.368%2C20-0.186%2C20%2C0c0%2C1.808-0.262%2C3.55-0.711%2C5.216%20%20%20%20%20l-3.808-1.237c0.079-0.307%2C0.149-0.618%2C0.211-0.931L19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M16-1c0%2C0.'
||'209-0.013%2C0.416-0.021%2C0.623c-0.113-4.807-2.329-9.094-5.784-11.953l0.435-0.599C13.916-9.999%2C16-5.749%2C16-1z%20%20%20%20%20%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23F47721%22%20d%3D%22M14.869%2C5.88'
||'3C12.641%2C11.509%2C7.321%2C15.558%2C1%2C15.95v4c8.097-0.401%2C14.914-5.603%2C17.672-12.831%20%20%20%20L14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M18.3%2C6.997l0.372%2C0.121C15.914%2C14.347%'
||'2C9.097%2C19.548%2C1%2C19.95v-1C8.763%2C18.565%2C15.339%2C13.762%2C18.3%2C6.997z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cpath%20fill%3D%22%23807F7F%22%20d%3D%22M0%2C13.254%22%2F%3E%20%3Cpath%20fill%3D%22%23D9D9D8%22%20d%3D%22M5-18c0-1.1-0.9-2-2-2h'
||'-6c-1.1%2C0-2%2C0.9-2%2C2v1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2V-18z%22%2F%3E%20%3Cpath%20opacity%3D%220.05%22%20d%3D%22M3-15h-6c-1.1%2C0-2-0.9-2-2v-1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2v1C5-15.9%2C4.1-15%2C3-15z%22%2F%3E%'
||'3C%2Fsymbol%3E%3Csymbol%20%20id%3D%22gauge-blank_2%22%20viewBox%3D%22-28%20-28%2056%2056%22%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23CCCCCC%22%20d%3D%22M0-28c15.464%2C0%2C28%2C12.536%2C28%2C28S15.464%2C28%2C0%2C28S-28%2C15.464-28%2C0S-15.464-28%2C0-2'
||'8z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M0-24c13.255%2C0%2C24%2C10.745%2C24%2C24S13.255%2C24%2C0%2C24S-24%2C13.255-24%2C0S-13.255-24%2C0-24z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%'
||'22%20d%3D%22M14.107%2C19.416c-10.723%2C7.791-25.732%2C5.414-33.523-5.31s-5.414-25.732%2C5.31-33.523%20%20%20s25.732-5.414%2C33.523%2C5.31S24.83%2C11.625%2C14.107%2C19.416z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23F3F3F3%22%20d%3D%2'
||'2M0%2C22c12.919%2C0%2C23.45-10.209%2C23.975-23C23.988-0.668%2C24-0.335%2C24%2C0c0%2C13.255-10.745%2C24-24%2C24%20%20%20S-24%2C13.255-24%2C0c0-0.335%2C0.012-0.668%2C0.025-1C-23.45%2C11.791-12.919%2C22%2C0%2C22z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3C'
||'g%3E%20%20%20%3Cpath%20fill%3D%22%23FAAB67%22%20d%3D%22M-13.326%2C8.849C-10.634%2C12.896-6.146%2C15.631-1%2C15.95v4c-6.625-0.328-12.396-3.863-15.788-9.102%20%20%20%20L-13.326%2C8.849z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20'
||'%20%3Cpath%20fill%3D%22%2324CB7F%22%20d%3D%22M-16%2C0c0%2C1.376%2C0.192%2C2.704%2C0.519%2C3.979l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20c0-6.293%2C2.912-11.899%2C7.455-15.565l2.35%2C3.235C-13.74-9.396-16-4.962-16%2C0z%22%2F%3E%20%2'
||'0%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-19.289%2C4.216l3.597-1.169c0.062%2C0.313%2C0.132%2C0.624%2C0.211%2C0.931l-3.808%2C1.237C-19.738%2C3.55-20%2C1.808-20%2C0%20%20%20%20%20c0-0.186%2C0.011-0.36'
||'8%2C0.016-0.553C-19.945%2C1.094-19.701%2C2.689-19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M-16-1c0-4.749%2C2.084-8.999%2C5.37-11.929l0.435%2C0.599c-3.454%2C2.859-5.671%2C7.146-5.784%2C11.953%20%20%20%20%20'
||'C-15.987-0.584-16-0.791-16-1z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23FFBE2A%22%20d%3D%22M-14.869%2C5.883C-12.641%2C11.509-7.321%2C15.558-1%2C15.95v4c-8.097-0.401-14.914-5.603-17.672-12.831%20%20%20%20L'
||'-14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M-18.672%2C7.118l0.372-0.121C-15.339%2C13.762-8.763%2C18.565-1%2C18.95v1C-9.097%2C19.548-15.914%2C14.347-18.672%2C7.118z%22%2F%3E%20%20%3C%2Fg%3E%2'
||'0%3C%2Fg%3E%20%3Cg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23ED1E24%22%20d%3D%22M16%2C0c0%2C1.376-0.192%2C2.704-0.519%2C3.979l3.808%2C1.237C19.738%2C3.55%2C20%2C1.808%2C20%2C0%20%20%20%20c0-6.293-2.912-11.899-7.455-15.565l-2.35%2C3.235C13.74-9.3'
||'96%2C16-4.962%2C16%2C0z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M19.289%2C4.216c0.412-1.527%2C0.656-3.121%2C0.695-4.769C19.989-0.368%2C20-0.186%2C20%2C0c0%2C1.808-0.262%2C3.55-0.711%2C5'
||'.216%20%20%20%20%20l-3.808-1.237c0.079-0.307%2C0.149-0.618%2C0.211-0.931L19.289%2C4.216z%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%20%3Cg%3E%20%20%20%20%3Cpath%20d%3D%22M16-1c0%2C0.209-0.013%2C0.416-0.021%2C0.623c-0.113-4.807-2.329-9.094-5.784-11.953l0.435-0'
||'.599C13.916-9.999%2C16-5.749%2C16-1z%20%20%20%20%20%22%2F%3E%20%20%20%3C%2Fg%3E%20%20%3C%2Fg%3E%20%20%3Cg%3E%20%20%20%3Cpath%20fill%3D%22%23F47721%22%20d%3D%22M14.869%2C5.883C12.641%2C11.509%2C7.321%2C15.558%2C1%2C15.95v4c8.097-0.401%2C14.914-5.603%2'
||'C17.672-12.831%20%20%20%20L14.869%2C5.883z%22%2F%3E%20%20%3C%2Fg%3E%20%20%3Cg%20opacity%3D%220.05%22%3E%20%20%20%3Cpath%20d%3D%22M18.3%2C6.997l0.372%2C0.121C15.914%2C14.347%2C9.097%2C19.548%2C1%2C19.95v-1C8.763%2C18.565%2C15.339%2C13.762%2C18.3%2C6.9'
||'97z%22%2F%3E%20%20%3C%2Fg%3E%20%3C%2Fg%3E%20%3Cpath%20fill%3D%22%23807F7F%22%20d%3D%22M0%2C13.254%22%2F%3E%20%3Cpath%20fill%3D%22%23D9D9D8%22%20d%3D%22M5-18c0-1.1-0.9-2-2-2h-6c-1.1%2C0-2%2C0.9-2%2C2v1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2'
||'V-18z%22%2F%3E%20%3Cpath%20opacity%3D%220.05%22%20d%3D%22M3-15h-6c-1.1%2C0-2-0.9-2-2v-1c0%2C1.1%2C0.9%2C2%2C2%2C2h6c1.1%2C0%2C2-0.9%2C2-2v1C5-15.9%2C4.1-15%2C3-15z%22%2F%3E%3C%2Fsymbol%3E%3Cg%20id%3D%22bkgd%22%20display%3D%22none%22%3E%20%3Crect%20di'
||'splay%3D%22inline%22%20fill%3D%22%23F9422A%22%20width%3D%2264%22%20height%3D%2264%22%2F%3E%3C%2Fg%3E%3Cg%20id%3D%22icons%22%3E%20%3Cg%20opacity%3D%220.1%22%3E%20%20%3Cpath%20d%3D%22M32%2C29.723c2.881%2C0%2C5.308%2C1.931%2C6.072%2C4.566c0.605%2C2.055%'
||'2C2.223%2C3.671%2C4.278%2C4.276c2.709%2C0.716%2C4.71%2C3.174%2C4.71%2C6.108%20%20%20c0%2C3.494-2.833%2C6.327-6.327%2C6.327c-1.404%2C0-2.702-0.456-3.751-1.23c-1.428-0.977-3.141-1.546-4.982-1.546%20%20%20c-1.841%2C0-3.554%2C0.568-4.982%2C1.546c-1.05%2C'
||'0.774-2.347%2C1.23-3.751%2C1.23c-3.494%2C0-6.327-2.833-6.327-6.327%20%20%20c0-2.934%2C2-5.392%2C4.71-6.108c2.055-0.605%2C3.673-2.221%2C4.278-4.276C26.692%2C31.654%2C29.119%2C29.723%2C32%2C29.723z%22%2F%3E%20%20%3Cpath%20d%3D%22M21.924%2C29.018c1.116%'
||'2C2.924%2C0.109%2C5.959-2.251%2C6.777c-2.36%2C0.819-5.178-0.888-6.294-3.813s-0.109-5.959%2C2.251-6.777%20%20%20S20.808%2C26.093%2C21.924%2C29.018z%22%2F%3E%20%20%3Cpath%20d%3D%22M30.818%2C20.597c0.306%2C3.306-1.629%2C6.167-4.323%2C6.389c-2.694%2C0.22'
||'2-5.126-2.277-5.433-5.583%20%20%20c-0.306-3.306%2C1.629-6.167%2C4.323-6.389C28.079%2C14.791%2C30.512%2C17.291%2C30.818%2C20.597z%22%2F%3E%20%20%3Cpath%20d%3D%22M42.076%2C29.018c-1.116%2C2.924-0.109%2C5.959%2C2.251%2C6.777c2.36%2C0.819%2C5.178-0.888%2'
||'C6.294-3.813%20%20%20c1.116-2.924%2C0.109-5.959-2.251-6.777S43.192%2C26.093%2C42.076%2C29.018z%22%2F%3E%20%20%3Cpath%20d%3D%22M33.182%2C20.597c-0.306%2C3.306%2C1.629%2C6.167%2C4.323%2C6.389c2.694%2C0.222%2C5.126-2.277%2C5.433-5.583s-1.629-6.167-4.323'
||'-6.389%20%20%20C35.921%2C14.791%2C33.488%2C17.291%2C33.182%2C20.597z%22%2F%3E%20%3C%2Fg%3E%20%3Cg%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M32%2C28.723c2.881%2C0%2C5.308%2C1.931%2C6.072%2C4.566c0.605%2C2.055%2C2.223%2C3.671%2C4.278%2C4.276%2'
||'0%20%20c2.709%2C0.716%2C4.71%2C3.174%2C4.71%2C6.108c0%2C3.494-2.833%2C6.327-6.327%2C6.327c-1.404%2C0-2.702-0.456-3.751-1.23%20%20%20c-1.428-0.977-3.141-1.546-4.982-1.546c-1.841%2C0-3.554%2C0.568-4.982%2C1.546c-1.05%2C0.774-2.347%2C1.23-3.751%2C1.23%2'
||'0%20%20c-3.494%2C0-6.327-2.833-6.327-6.327c0-2.934%2C2-5.392%2C4.71-6.108c2.055-0.605%2C3.673-2.221%2C4.278-4.276%20%20%20C26.692%2C30.654%2C29.119%2C28.723%2C32%2C28.723z%22%2F%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M21.924%2C28.018c1.116'
||'%2C2.924%2C0.109%2C5.959-2.251%2C6.777c-2.36%2C0.819-5.178-0.888-6.294-3.813%20%20%20s-0.109-5.959%2C2.251-6.777S20.808%2C25.093%2C21.924%2C28.018z%22%2F%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M30.818%2C19.597c0.306%2C3.306-1.629%2C6.167-4'
||'.323%2C6.389c-2.694%2C0.222-5.126-2.277-5.433-5.583%20%20%20c-0.306-3.306%2C1.629-6.167%2C4.323-6.389C28.079%2C13.791%2C30.512%2C16.291%2C30.818%2C19.597z%22%2F%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M42.076%2C28.018c-1.116%2C2.924-0.109%2'
||'C5.959%2C2.251%2C6.777c2.36%2C0.819%2C5.178-0.888%2C6.294-3.813%20%20%20c1.116-2.924%2C0.109-5.959-2.251-6.777S43.192%2C25.093%2C42.076%2C28.018z%22%2F%3E%20%20%3Cpath%20fill%3D%22%23FFFFFF%22%20d%3D%22M33.182%2C19.597c-0.306%2C3.306%2C1.629%2C6.167%'
||'2C4.323%2C6.389c2.694%2C0.222%2C5.126-2.277%2C5.433-5.583%20%20%20s-1.629-6.167-4.323-6.389C35.921%2C13.791%2C33.488%2C16.291%2C33.182%2C19.597z%22%2F%3E%20%3C%2Fg%3E%3C%2Fg%3E%3C%2Fsvg%3E''); background-repeat: no-repeat; }',
'',
'body .a-IRR-iconViewTable td {',
'  display: block;',
'  float: left;',
'  padding: 0;',
'  width: 25%;',
'  text-align: left; ',
'}',
'body .a-IRR-iconViewTable td:hover {',
'  background-color: transparent;;',
'  border-radius: 0; ',
'}',
''))
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(407513514732948752.4903)
,p_plug_name=>'DEL ME'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461348414728450100.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461351914627477627.4903)
,p_plug_name=>'Websheet Directory Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20454830409304572.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(461346705230446581.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461357027599505945.4903)
,p_plug_name=>'Websheet-Verzeichnis'
,p_region_css_classes=>'a-IRR-region--responsiveIconViewWide a-IRR-region--showTopBorder a-AppCards a-AppCards--slim a-AppCards--irr'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(1332151043262185426.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    id,',
'    wwv_flow_4000_ui.get_app_initials( name, id ) as app_initials,',
'    ''u-ColorBG--'' || to_char( ora_hash( name, 29 ) + 1 ) as app_color,',
'    name name,',
'    name app_name,',
'    owner,',
'    status build_status,',
'    (select count(*) from wwv_flow_ws_webpages where ws_app_id = f.id) page_count,',
'    updated_on updated,',
'    lower(updated_by) last_updated_by,',
'    created_on created,',
'    lower(created_by) created_by,',
'    ''<a  href="ws?p=''||f.id||'':home:''||:app_session||''" class="a-button"><span class="a-icon  icon-run-page" title="''||wwv_flow_lang.system_message(''run_application_id'', f.id)||''"></span></a>'' actions,',
'    ''f?p=4900:900:''||:app_session||''::::ws_app_id,p900_id:''||f.id||'',''||f.home_page_id home_link,',
'    description application_comments',
'from  wwv_flow_ws_applications f',
'where f.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(461357118845505945.4903)
,p_name=>'Application Directory'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461357330691505949.4903)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Websheet'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461357621686505950.4903)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461357701542505950.4903)
,p_db_column_name=>'APP_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461357820513505950.4903)
,p_db_column_name=>'OWNER'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>unistr('Eigent\00FCmer')
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461357930815505950.4903)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Build-Status'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358011949505950.4903)
,p_db_column_name=>'PAGE_COUNT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Seitenanzahl'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358110612505951.4903)
,p_db_column_name=>'UPDATED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358212071505951.4903)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358402276505951.4903)
,p_db_column_name=>'CREATED'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358531407505951.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358629185505951.4903)
,p_db_column_name=>'ACTIONS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>unistr('Ausf\00FChren')
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
);
end;
/
begin
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358701197505952.4903)
,p_db_column_name=>'HOME_LINK'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Home-Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(461358804759505952.4903)
,p_db_column_name=>'APPLICATION_COMMENTS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Anwendungskommentare'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1284870871845082002.4903)
,p_db_column_name=>'APP_INITIALS'
,p_display_order=>26
,p_column_identifier=>'Q'
,p_column_label=>'App-Initialen'
,p_column_type=>'STRING'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(1284870943158082003.4903)
,p_db_column_name=>'APP_COLOR'
,p_display_order=>36
,p_column_identifier=>'R'
,p_column_label=>'App-Farbe'
,p_column_type=>'STRING'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461367500138577575.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Mit dem Websheet-Verzeichnis k\00F6nnen Sie zu einem anderen Websheet im Workspace navigieren.</p>')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(461362925802537651.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(461357027599505945.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1001:&SESSION.::&DEBUG.:1001,RIR::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(292888520005892928.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(461357027599505945.4903)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20890726723852448.4903)
,p_button_image_alt=>'Websheet erstellen'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:7:&SESSION.::&DEBUG.:7,8,32::'
,p_security_scheme=>wwv_flow_api.id(456220226828170850)
);
end;
/
prompt --application/pages/page_01250
begin
wwv_flow_api.create_page(
 p_id=>1250.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Websheet-Eigenschaften'
,p_step_title=>'Websheet-Eigenschaften'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176487503903203838.4903)
,p_plug_name=>'Websheet'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(27071223638280295.4903)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid=>true
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176493105421233409.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176594331242830295.4903)
,p_plug_name=>'Top Bar'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="margin-bottom: 10px;min-height:40px;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid=>true
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_translate_title=>'N'
,p_plug_footer=>'<div class="clear"></div>'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(176595526871838481.4903)
,p_plug_name=>'Authentifizierung'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_condition_type=>'NEVER'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177429502470082830.4903)
,p_plug_name=>'Details'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(177457130856065502.4903)
,p_plug_name=>'Info'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Auf dieser Seite k\00F6nnen Sie die Websheet-Anwendungseigenschaften verwalten. Die Homepage gibt die Seite, das Daten-Grid oder den Bericht an, der dem Benutzer standardm\00E4\00DFig angezeigt wird. Der Name der Anwendung wird im Navigationspfad angezeigt.</')
||'p>',
unistr('<p>Um diese Anwendung zu l\00F6schen, \00E4ndern Sie das Authentifizierungsschema oder die verf\00FCgbaren Objekte. Die Eigenschaften \00E4ndern Sie aus der Entwicklerumgebung heraus.</p>')))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(450939102309511257.4903)
,p_plug_name=>'Autorisierung'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(461458711650262011.4903)
,p_plug_name=>'Logo'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(471188429983598197.4903)
,p_plug_name=>'Voreinstellungen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(472166009883150979.4903)
,p_plug_name=>'Stil'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(487243419558654247.4903)
,p_plug_name=>'Authentifizierung'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491767807981294755.4903)
,p_plug_name=>'SQL'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(487244921683683240.4903)
,p_name=>'Vorgeschlagene Objekte'
,p_parent_plug_id=>wwv_flow_api.id(491767807981294755.4903)
,p_template=>wwv_flow_api.id(47316730240795884.4903)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name, object_comment',
'  from wwv_flow_ws_app_sug_objects',
' where security_group_id = :flow_security_group_id and ',
'       ws_app_id = :P1250_ID',
' order by 1'))
,p_header=>unistr('<p>SQL kann in Berichten und SQL-Tags verwendet werden. Dies ist eine Liste der vorgeschlagenen Objekte, die f\00FCr Ihre Anwendung interessant sein k\00F6nnten.</p>')
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(129228711620465473.4903)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>unistr('Kein Tabellenzugriff gew\00E4hrt.')
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(487245230514683283.4903)
,p_query_column_id=>1
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Objektname'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(492622021349323665.4903)
,p_query_column_id=>2
,p_column_alias=>'OBJECT_COMMENT'
,p_column_display_sequence=>2
,p_column_heading=>'Kommentar'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(487247100221752781.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(487243419558654247.4903)
,p_button_name=>'EDIT_AUTH'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'Authentifizierung bearbeiten'
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'f?p=4000:933:&BUILDER_SESSION_ID.::::P933_ID:&P1250_ID.#AUTH'
,p_button_execute_validations=>'N'
,p_button_cattributes=>'style="float: right;"'
,p_security_scheme=>wwv_flow_api.id(487678607690660963)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488229223702763799.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(450939102309511257.4903)
,p_button_name=>'EDIT_ACL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'Access Control-Liste bearbeiten'
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'f?p=&APP_ID.:11:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'style="float: right;"'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(488035229167843216.4903)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_api.id(491767807981294755.4903)
,p_button_name=>'EDIT_AVAIL_OBJ'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'SQL-Zugriff und vorgeschlagene Objekte bearbeiten'
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'f?p=4000:933:&BUILDER_SESSION_ID.::::P933_ID:&P1250_ID.#SQL'
,p_button_execute_validations=>'N'
,p_button_cattributes=>'style="float: right;"'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_security_scheme=>wwv_flow_api.id(487678607690660963)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(176488014475203914.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(176594331242830295.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(302930804915799942.4903)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_api.id(176594331242830295.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:4:&SESSION.::&DEBUG.:4:P4_ID:&WS_APP_ID.'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(176487811236203914.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(176594331242830295.4903)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'NEXT'
,p_button_condition=>'P1250_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(176488823089203918.4903)
,p_branch_action=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(27512507876659750.4903)
,p_name=>'P1250_EMAIL_FROM'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Websheet-Absender-E-Mail-Adresse'
,p_source=>'EMAIL_FROM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Bestimmt die E-Mail-Adresse, die als Absender im Websheet verwendet wird. Diese Absender-E-Mail-Adresse wird verwendet, wenn Sie E-Mails vom Daten-Grid- oder Berichts-E-Mail-Download im Websheet senden.</p>',
'Beispiel:',
'<ul>',
'<li><code>john.doe@example.com</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176489018827203924.4903)
,p_name=>'P1250_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Websheet:'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Eindeutige ID f\00FCr diese Anwendung.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176489225311203942.4903)
,p_name=>'P1250_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifiziert den Namen der Anwendung. Dieser Name wird im Navigationspfad angezeigt.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176489614428203951.4903)
,p_name=>'P1250_OWNER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(177429502470082830.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Eigent\00FCmer')
,p_source=>'OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Gibt den Benutzer an, der Eigent\00FCmer der Anwendung ist.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176490009162203952.4903)
,p_name=>'P1250_DESCRIPTION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(177429502470082830.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Beschreibung'
,p_source=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Eine optionale Beschreibung der Anwendung.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176490204285203953.4903)
,p_name=>'P1250_STATUS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Status'
,p_source=>'STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEBSHEET APPLICATION STATUS'
,p_lov=>'.'||wwv_flow_api.id(471867429070174759.4903)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den Status der Anwendung an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(176490605195203957.4903)
,p_name=>'P1250_AUTHENTICATION'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(487243419558654247.4903)
,p_item_default=>'0'
,p_prompt=>'Authentifizierung'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'WEBSHEET AUTHENTICATION'
,p_lov=>'.'||wwv_flow_api.id(444727703759035884.4903)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'class="display_bold"'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Gibt die Methode an, mit der Benutzer der Anwendung authentifiziert werden.',
'<p>',
'<ul>',
'<li>',
'Application Express-Accounts - Authentifizierung mit Benutzername und Kennwort des Entwickleraccounts.',
'<li>',
unistr('Single Sign-On - Authentifizierung mit Oracle AS Single Sign-On. Dies muss f\00FCr die Instanz &PRODUCT_NAME. konfiguriert werden.'),
'<li>',
unistr('LDAP - Authentifizierung mit einem LDAP-Directory. Geben Sie zur Konfiguration zus\00E4tzliche Parameter auf dieser Seite an.'),
'<li>',
unistr('Benutzerdefiniert - Geben Sie eigenen Code f\00FCr die Authentifizierung und bestimmte Sessionverwaltungsaufgaben an.'),
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(177428201730054272.4903)
,p_name=>'P1250_HOME_PAGE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Homepage'
,p_source=>'HOME_PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEBSHEET HOME PAGE SELECTOR (P 1250)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from WWV_FLOW_WS_WEBPAGES ',
'where WS_APP_ID = :P1250_ID and',
'      security_group_id = :flow_security_group_id',
'order by 1'))
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt die Homepage der Anwendung an. Die Homepage ist die Standardstartseite.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(325631522619352012.4903)
,p_name=>'P1250_SHOW_RESET_PASSWD_YN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Zur\00FCckgesetztes Kennwort anzeigen')
,p_source=>'SHOW_RESET_PASSWD_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES NO RETURNS Y N'
,p_lov=>'.'||wwv_flow_api.id(4091010662546975.4903)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'wwv_flow_ws_security.ws_auth_type(p_websheet_application_id=>:WS_APP_ID) = ''1'' '
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Kontrolliert die Anzeige des Links "Kennwort zur\00FCcksetzen" auf der Anmeldeseite. Mit diesem Link k\00F6nnen Benutzer ihr Kennwort zur\00FCcksetzen. Diese Option kann nur verwendet werden, wenn die Anwendung die &PRODUCT_NAME.-Accountauthentifizierung verwend')
||'et.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450484206252704730.4903)
,p_name=>'P1250_LDAP_HOST'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_prompt=>'LDAP-Host'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'3'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Der Hostname Ihres LDAP-Verzeichnisservers.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450484413608704731.4903)
,p_name=>'P1250_LDAP_PORT'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_prompt=>'LDAP-Port'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'3'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Die Portnummer Ihres LDAP-Verzeichnishosts.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450484630785704732.4903)
,p_name=>'P1250_LDAP_STRING'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_prompt=>'LDAP-Zeichenfolge'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'3'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Das Muster zum Erstellen des DN-Arguments f\00FCr DBMS_LDAP.SIMPLE_BIND_S.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450484825274704732.4903)
,p_name=>'P1250_PAGE_SENTRY_FUNCTION'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_prompt=>'Seiten-Sentry-Funktion'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Diese Funktion wird von der &PRODUCT_NAME.-Engine ausgef\00FChrt, bevor die Seiten angezeigt oder verarbeitet werden. Wenn diese Funktion FALSE zur\00FCckgibt (was darauf hinweist, dass der Benutzer m\00F6glicherweise nicht angemeldet ist), leitet die Engine den')
||' Benutzer auf eine Anmeldeseite um.',
'<br>',
unistr('Wenn der Wert f\00FCr dieses Feld auf "-DATABASE-" gesetzt ist, wird keine Funktion ausgewertet. Stattdessen wird die Session als g\00FCltig angesehen und der Benutzername wird aus dem in der Datenbanksession angemeldeten Benutzernamen entsprechend der DAD-K')
||'onfiguration abgerufen.',
'<p>',
'Geben Sie einen PL/SQL-Funktionsbody in einem der folgenden Formate an:',
'<ul>',
'<li>',
'return function-name;',
'<li>',
'return package.function-name;',
'<li>',
'return schema.package.function-name;',
'<li>',
unistr('return true; /* Es wird zu Testzwecken immer TRUE zur\00FCckgegeben */'),
'<li>',
unistr('return false; /* Es wird zu Testzwecken immer FALSE zur\00FCckgegeben */'),
'<li>',
'begin',
'&nbsp;&nbsp;if condition then return true;',
'&nbsp;&nbsp;else return false;',
'&nbsp;&nbsp;end if;',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450485008671704733.4903)
,p_name=>'P1250_SESS_VERIFY_FUNCTION'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_prompt=>unistr('Funktion f\00FCr die Sessionverifizierung')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Diese Funktion bestimmt, ob eine g\00FCltige Session vorhanden ist oder nicht.'),
'<p>',
'Geben Sie einen PL/SQL-Funktionsbody in einem der folgenden Formate an:',
'<ul>',
'<li>',
'return function-name;',
'<li>',
'return package.function-name;',
'<li>',
'return schema.package.function-name;',
'<li>',
unistr('return true; /* Es wird zu Testzwecken immer TRUE zur\00FCckgegeben */'),
'<li>',
unistr('return false; /* Es wird zu Testzwecken immer FALSE zur\00FCckgegeben */'),
'<li>',
'begin',
'&nbsp;&nbsp;if condition then return true;',
'&nbsp;&nbsp;else return false;',
'&nbsp;&nbsp;end if;',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450485225599704733.4903)
,p_name=>'P1250_PRE_AUTH_PROCESS'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_prompt=>'Prozess vor der Authentifizierung'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Geben Sie einen PL/SQL-Block an, der nach der Weiterleitung der Anmeldeseite und unmittelbar vor der \00DCberpr\00FCfung der Zugangsdaten ausgef\00FChrt werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450485420073704733.4903)
,p_name=>'P1250_AUTH_FUNCTION'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_prompt=>'Authentifizierungsfunktion'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie die Funktion an, die die Anmeldedaten des Benutzers \00FCberpr\00FCft.'),
'<p>',
unistr('Rufen Sie eine PL/SQL-Funktion auf, die Benutzernamen/Kennwort \00FCberpr\00FCft und einen booleschen Wert zur\00FCckgibt. '),
unistr('Geben Sie einen Funktionsnamen folgenderma\00DFen ein: return fn, wobei gilt: fn ist der Name der Funktion, gegebenenfalls qualifiziert durch einen Schemanamen und Packagenamen.'),
unistr('Diese Funktion muss die Signatur (p_username in varchar2, p_password in varchar2) haben und einen booleschen Wert zur\00FCckgeben.'),
unistr('Die auf der Anmeldeseite eingegebenen Werte f\00FCr Benutzernamen und Kennwort werden an die Funktion \00FCbergeben.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450485608358704734.4903)
,p_name=>'P1250_POST_AUTH_PROCESS'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_prompt=>'Prozess nach der Authentifizierung'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Geben Sie einen PL/SQL-Block an, der nach dem Authentifizierungsschritt (\00DCberpr\00FCfung der Anmeldedaten) ausgef\00FChrt werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450485815622704734.4903)
,p_name=>'P1250_LOGOUT_URL'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_prompt=>'Abmelde-URL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'0'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie eine URL an, der das LOGOUT URL-Attribut f\00FCr diese Anwendung werden soll. '),
'Dieses Attribut wird in Abmeldelinks als &amp;LOGOUT_URL. referenziert.',
unistr('<br>Wenn diese Anwendung eine integrierte Sessionverifizierung verwendet, k\00F6nnen Sie \00FCber "wwv_flow_custom_auth_std.ws_logout?p_websheet_app_id=&amp;WS_APP_ID.&amp;p_next_url=ws?p=&amp;WS_APP_ID.:home" eine integrierte Abmeldeprozedur aufrufen.')))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450487210595819510.4903)
,p_name=>'P1250_EDIT_FUNCTION'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_prompt=>unistr('Bearbeitungsfunktion f\00FCr den LDAP-Benutzernamen')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'3'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Sie k\00F6nnen zus\00E4tzlichen Code hinzuf\00FCgen, der zur Umwandlung des Benutzernamens in ein Format ausgef\00FChrt wird, das f\00FCr einen LDAP-Verzeichniseintrag oder LDAP-Benutzernamen geeignet ist. Beispiel: Der folgende Code ruft eine Funktion auf, die alle "."')
||''' in der DN-Zeichenfolge durch "_"'' ersetzt:<br /><br />',
'return apex_custom_auth.ldap_dnprep;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450537626101318811.4903)
,p_name=>'P1250_INVALID_SESSION_URL'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_prompt=>unistr('Ung\00FCltige Session-URL')
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>150
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_display_when=>'P1250_AUTHENTICATION'
,p_display_when2=>'4'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Geben Sie eine URL &PRODUCT_NAME. an, an den umgeleitet wird, wenn keine g\00FCltige Session vorhanden ist.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(450939413784542940.4903)
,p_name=>'P1250_ACL_TYPE'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(450939102309511257.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Access Control-Listentyp'
,p_source=>'ACL_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_APP_ACL_TYPE'
,p_lov=>'.'||wwv_flow_api.id(450940100671567605.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Wenn Sie mithilfe von &PRODUCT_NAME.-Accounts authentifizieren m\00F6chten, k\00F6nnen Sie w\00E4hlen, ob die Autorisierung durch die Rolle im &PRODUCT_NAME.-Workspace oder durch die Access Control-Liste bestimmt wird. Bei allen Authentifizierungstypen au\00DFer &PR')
||'ODUCT_NAME.-Accounts wird die Autorisierung stets durch die Access Control-Liste bestimmt.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460137926534229858.4903)
,p_name=>'P1250_DATE_FORMAT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Anwendungsdatumsformat'
,p_source=>'DATE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATE_FORMAT_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from wwv_flow_format_masks',
' where t=''D'''))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bestimmt das Datumsformat f\00FCr die Anwendung.</p>'),
unistr('<p>Dieses Datumsformat wird verwendet, um die <code>NLS_DATE_FORMAT</code>-Einstellung f\00FCr die Datenbanksession zu \00E4ndern, bevor eine Seite in der Anwendung angezeigt oder weitergeleitet wird. Dieser Wert kann eine literale Zeichenfolge mit einer g\00FCl')
||'tigen Oracle-Datumsformatmaske sein, oder eine Elementreferenz mit einer Ersetzungssyntax. Fehlt dieser Wert, so wird das Standarddatumsformat zur Laufzeit von der Datenbanksession abgeleitet.</p>',
'Beispiele:',
'<ul>',
'<li><code>Month DD, YYYY</code></li>',
'<li><code>&amp;MY_DATE_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(460224522939269560.4903)
,p_name=>'P1250_ORIG_AUTHENTICATION'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(176595526871838481.4903)
,p_use_cache_before_default=>'NO'
,p_source=>'P1250_AUTHENTICATION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461458902408262014.4903)
,p_name=>'P1250_LOGO_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logo-Typ'
,p_source=>'LOGO_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_LOGO_TYPE'
,p_lov=>'.'||wwv_flow_api.id(461278502171499627.4903)||'.'
,p_cSize=>60
,p_cMaxlength=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Gibt den Logotyp an, der f\00FCr die Anwendung verwendet wird.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461459505800262016.4903)
,p_name=>'P1250_LOGO_TEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logo'
,p_source=>'LOGO_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>500
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Geben Sie eine Volltextzeichenfolge ein, die als Anwendungslogo verwendet wird.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461460131393262018.4903)
,p_name=>'P1250_LOGO_TEXT_ATTRIBUTES'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logo-Attribute'
,p_source=>'LOGO_TEXT_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LOGO ATTRIBUTES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLACK_TEXT'') d, ''style="font-family:Arial; color:#000000; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''BLUE_TEXT'') d, ''style="font-family:Arial; color:#004C66; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''WHITE_TEXT'') d, ''style="font-family:Arial; color:#FFFFFF; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual',
'union all',
'select wwv_flow_lang.system_message(''GRAY_TEXT'') d, ''style="font-family:Arial; color:#303030; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''image_attributes'') d, ''alt="Application" title="Application"'' r from dual '))
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Attribute f\00FCr das Logo. Beispiel:'),
'<pre>style="font-family:Arial; color:#000000; font-size:18; white-space:nowrap; font-weight:bold;"</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461460730859262020.4903)
,p_name=>'P1250_LOGO_IMAGE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logo'
,p_source=>'LOGO_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Laden Sie ein Bild hoch, das als Anwendungslogo verwendet wird.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DB_COLUMN'
,p_attribute_02=>'LOGO_IMAGE_MIMETYPE'
,p_attribute_03=>'LOGO_IMAGE_FILENAME'
,p_attribute_04=>'LOGO_IMAGE_CHARSET'
,p_attribute_05=>'LOGO_IMAGE_LAST_UPDATE'
,p_attribute_06=>'Y'
,p_attribute_07=>'Herunterladen'
,p_attribute_08=>'inline'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461461303598262021.4903)
,p_name=>'P1250_LOGO_IMAGE_ATTRIBUTES'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logo-Attribute'
,p_source=>'LOGO_IMAGE_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Attribute f\00FCr das Logo. Beispiel:'),
'<pre>width="100" height="20" alt="Firmenlogo"</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461461903438262023.4903)
,p_name=>'P1250_LOGO_FILEPATH'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logo'
,p_source=>'LOGO_FILEPATH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie den vollst\00E4ndigen Bildnamen ein, einschlie\00DFlich Dateinamenserweiterung. Beispiel:'),
'<pre>/i/oracle.gif</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(461462532105262026.4903)
,p_name=>'P1250_LOGO_FILEPATH_ATTRIBUTES'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(461458711650262011.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Logo-Attribute'
,p_source=>'LOGO_FILEPATH_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Attribute f\00FCr das Logo. Beispiel:'),
'<pre>width="100" height="20" alt="Firmenlogo"</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471188815054641201.4903)
,p_name=>'P1250_SHOW_PEER_NAVIGATION_YN'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(471188429983598197.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Peer-Navigation anzeigen'
,p_source=>'SHOW_PEER_NAVIGATION_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES NO RETURNS Y N'
,p_lov=>'.'||wwv_flow_api.id(4091010662546975.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Steuert die Anzeige eines Navigationssteuerelements f\00FCr die Navigation auf Peer-Seiten.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(471189024928641209.4903)
,p_name=>'P1250_SHOW_CHILD_NAVIGATION_YN'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(471188429983598197.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Untergeordnete Navigation anzeigen'
,p_source=>'SHOW_CHILD_NAVIGATION_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES NO RETURNS Y N'
,p_lov=>'.'||wwv_flow_api.id(4091010662546975.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Steuert die Anzeige eines Navigationssteuerelements f\00FCr untergeordnete Seiten')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(477856118555259924.4903)
,p_name=>'P1250_PAGE_STYLE'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(472166009883150979.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Anwendungsstil'
,p_source=>'PAGE_STYLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEBSHEET PAGE STYLE'
,p_lov=>'.'||wwv_flow_api.id(478186020350840371.4903)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Verwenden Sie diese Option, um den Standardanwendungsstil au\00DFer Kraft zu setzen und benutzerdefinierte CSS zu verwenden.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(477856305873265712.4903)
,p_name=>'P1250_CUSTOM_CSS'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(472166009883150979.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Benutzerdefiniertes CSS'
,p_source=>'CUSTOM_CSS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>unistr('Geben Sie eine benutzerdefinierte CSS f\00FCr den Anwendungsstil ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(478235906953144957.4903)
,p_name=>'P1250_SHOW_ANNOTATIONS_CONTROL_YN'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(471188429983598197.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Anmerkungssteuerelement anzeigen'
,p_source=>'SHOW_ANNOTATIONS_CONTROL_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES NO RETURNS Y N'
,p_lov=>'.'||wwv_flow_api.id(4091010662546975.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Kontrolliert die M\00F6glichkeit. Annotationen zu einer Seite hinzuzuf\00FCgen (Annotationen umfassen Dateien, Tags und Hinweise).')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(484542908371747530.4903)
,p_name=>'P1250_ALLOW_PUBLIC_ACCESS_YN'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(450939102309511257.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00D6ffentlichen Zugriff zulassen')
,p_source=>'ALLOW_PUBLIC_ACCESS_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES NO RETURNS Y N'
,p_lov=>'.'||wwv_flow_api.id(4091010662546975.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Wenn Sie "Ja" ausw\00E4hlen, k\00F6nnen Benutzer die Anwendung im schreibgesch\00FCtzten Modus ohne Benutzeranmeldung ausf\00FChren. Bei "Nein" m\00FCssen sich alle Benutzer anmelden, um die Anwendung ausf\00FChren zu k\00F6nnen.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488052808977755011.4903)
,p_name=>'P1250_LOGIN_PAGE_MESSAGE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(177429502470082830.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Anmeldenachricht'
,p_source=>'LOGIN_PAGE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Zeigen Sie diese Meldung auf der Anmeldeseite an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(491768318155307093.4903)
,p_name=>'P1250_ALLOW_SQL_YN'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(491767807981294755.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'SQL zulassen'
,p_source=>'ALLOW_SQL_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES NO RETURNING Y N'
,p_lov=>'.'||wwv_flow_api.id(159003224636178271.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Lassen Sie die Verwendung von SQL-Tags und SQL-Berichten in dieser Anwendung zu.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502779631210331431.4903)
,p_name=>'P1250_LANGUAGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.get_g_session_lang'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Standardanwendungssprache'
,p_source=>'LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LANGUAGES_INSTALLED'
,p_lov=>'.'||wwv_flow_api.id(631691002719703351.4903)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Gibt die Standardsprache der Anwendung an. Benutzer k\00F6nnen ihre Sprachvoreinstellung in der Anwendung \00E4ndern. Die Sprachenliste ist von den \00FCbersetzten Versionen von &PRODUCT_NAME. abh\00E4ngig, die installiert sind.'),
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(502984816637800262.4903)
,p_name=>'P1250_TERRITORY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(176487503903203838.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_territory varchar2(255);',
'begin',
'    l_territory := wwv_flow_lang.get_g_session_territory;',
'    if l_territory is null then',
'        for c1 in (select nls_territory',
'                     from wwv_flow_languages',
'                    where lang_id = nvl(wwv_flow_lang.get_g_session_lang,''en'')) loop',
'            l_territory := c1.nls_territory;',
'            exit;',
'        end loop;',
'    end if;',
'    if l_territory is null then',
'        l_territory := ''AMERICA'';',
'    end if;',
'    return l_territory;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Standardanwendungsgebiet'
,p_source=>'TERRITORY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_TERRITORIES'
,p_lov=>'.'||wwv_flow_api.id(634728210841234369.4903)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('Gibt das Standardgebiet der Anwendung an, welches Attribute wie Datumssprache und numerische Zeichen steuert. Benutzer k\00F6nnen ihre Gebietseinstellung innerhalb der Anwendung \00E4ndern.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(450490025504975234.4903)
,p_computation_sequence=>10
,p_computation_item=>'P1250_AUTHENTICATION'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_security.ws_auth_type(',
'  p_websheet_application_id => :P1250_ID);'))
,p_computation_error_message=>'Authentifizierungstyp kann nicht abgerufen werden.'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(450943619689696013.4903)
,p_computation_sequence=>20
,p_computation_item=>'P1250_ACL_TYPE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'CUSTOM'
,p_compute_when=>'P1250_ACL_TYPE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(487242203095536025.4903)
,p_computation_sequence=>30
,p_computation_item=>'P1250_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'ltrim(rtrim(:P1250_NAME))'
,p_compute_when=>'SAVE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(176489402369203945.4903)
,p_validation_name=>'P1250_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P1250_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('F\00FCr den Namen muss ein Wert angegeben werden.')
,p_associated_item=>wwv_flow_api.id(176489225311203942.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(176489804897203952.4903)
,p_validation_name=>'P1250_OWNER not null'
,p_validation_sequence=>20
,p_validation=>'P1250_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>unistr('Dem Eigent\00FCmer muss ein Wert zugewiesen sein.')
,p_associated_item=>wwv_flow_api.id(176489614428203951.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(456286403615138645.4903)
,p_validation_name=>'Must be admin in ACL'
,p_validation_sequence=>30
,p_validation=>'return wwv_flow_ws_security.admin_exists(p_username=>:APP_USER,p_websheet_app_id=>:P1250_ID);'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Sie k\00F6nnen nur zu einer benutzerdefinierten Access Control-Liste wechseln, wenn Sie Administrator in der Access Control-Liste sind.')
,p_validation_condition=>'P1250_ACL_TYPE'
,p_validation_condition2=>'CUSTOM'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(176487811236203914.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(27519532463666832.4903)
,p_validation_name=>'P1250_EMAIL_FROM is valid'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_at   number;',
'  l_dot  number;',
'begin',
'  l_at := instr(:P1250_EMAIL_FROM,''@'');',
'  l_dot := instr(:P1250_EMAIL_FROM,''.'',l_at);',
'  if l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1 then',
'      return true;',
'  end if;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('Ung\00FCltige E-Mail-Adresse')
,p_validation_condition=>'P1250_EMAIL_FROM'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(27512507876659750.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(450941414963628450.4903)
,p_name=>'Set ACL Type to Custom'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_AUTHENTICATION'
,p_condition_element=>'P1250_AUTHENTICATION'
,p_triggering_condition_type=>'NOT_IN_LIST'
,p_triggering_expression=>'1,5'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(450941711017628453.4903)
,p_event_id=>wwv_flow_api.id(450941414963628450.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_ACL_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'CUSTOM'
,p_wait_for_result=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(450943524968678675.4903)
,p_event_id=>wwv_flow_api.id(450941414963628450.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_ACL_TYPE'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(450943310077674328.4903)
,p_event_id=>wwv_flow_api.id(450941414963628450.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_ACL_TYPE'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461466701962334929.4903)
,p_name=>'HIDE ALL LOGO'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_LOGO_TYPE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461467009032334931.4903)
,p_event_id=>wwv_flow_api.id(461466701962334929.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_LOGO_TEXT,P1250_LOGO_TEXT_ATTRIBUTES,P1250_LOGO_IMAGE,P1250_LOGO_IMAGE_ATTRIBUTES,P1250_LOGO_FILEPATH,P1250_LOGO_FILEPATH_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461467322394340801.4903)
,p_name=>'SHOW LOGO TEXT'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_LOGO_TYPE'
,p_condition_element=>'P1250_LOGO_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TEXT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461467629076340802.4903)
,p_event_id=>wwv_flow_api.id(461467322394340801.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_LOGO_TEXT,P1250_LOGO_TEXT_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461467702786344625.4903)
,p_name=>'SHOW LOGO IMAGE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_LOGO_TYPE'
,p_condition_element=>'P1250_LOGO_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'IMAGE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461468020881344625.4903)
,p_event_id=>wwv_flow_api.id(461467702786344625.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_LOGO_IMAGE,P1250_LOGO_IMAGE_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(461468216984348770.4903)
,p_name=>'SHOW LOGO FILEPATH'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_LOGO_TYPE'
,p_condition_element=>'P1250_LOGO_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILEPATH'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(461468512039348770.4903)
,p_event_id=>wwv_flow_api.id(461468216984348770.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_LOGO_FILEPATH,P1250_LOGO_FILEPATH_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(477892828691319686.4903)
,p_name=>'show hide Custom CSS'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_PAGE_STYLE'
,p_condition_element=>'P1250_PAGE_STYLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'99'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(477893127654319689.4903)
,p_event_id=>wwv_flow_api.id(477892828691319686.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_CUSTOM_CSS'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(477893331070319692.4903)
,p_event_id=>wwv_flow_api.id(477892828691319686.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1250_CUSTOM_CSS'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(491770901494349628.4903)
,p_name=>'Hide Suggested Objects'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1250_ALLOW_SQL_YN'
,p_condition_element=>'P1250_ALLOW_SQL_YN'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'Yes'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(491778019175506114.4903)
,p_event_id=>wwv_flow_api.id(491770901494349628.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(487244921683683240.4903)
,p_attribute_01=>'N'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(176490818593203958.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_WS_APPLICATIONS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_APPLICATIONS'
,p_attribute_03=>'P1250_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID',
'and id = :WS_APP_ID'))
,p_process_error_message=>'Zeile kann nicht abgerufen werden.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(176491030602203966.4903)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_WS_APPLICATIONS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WS_APPLICATIONS'
,p_attribute_03=>'P1250_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID',
'and id = :WS_APP_ID'))
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Zeile der Tabelle WWV_FLOW_WS_APPLICATIONS konnte nicht verarbeitet werden.'
,p_process_success_message=>'Aktion wurde verarbeitet.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(458562012835219617.4903)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update HOME_PAGE_ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select HOME_PAGE_ID',
'     from WWV_FLOW_WS_APPLICATIONS',
'    where id = :WS_APP_ID',
'    and security_group_id = :WORKSPACE_ID )',
'loop',
'   :HOME_PAGE_ID := c1.home_page_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(176487811236203914.4903)
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(471231206393089068.4903)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set logo'
,p_process_sql_clob=>':F4900_LOGO := wwv_flow_ws_api.get_logo( p_ws_app_id=>:ws_app_id, p_security_group_id=>:flow_security_group_id);'
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_01310
begin
wwv_flow_api.create_page(
 p_id=>1310.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Bericht erstellen'
,p_step_title=>'Bericht erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20806403503994187.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181186531071637307.4903)
,p_plug_name=>'Bericht erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181261824581154451.4903)
,p_plug_name=>'create report progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(181250307256073810.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181263221726172554.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181262107050158898.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20806403503994187.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181271124244230065.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20806403503994187.4903)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(10604003722246228.4903)
,p_button_image_alt=>'Weiter'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181262427136164696.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20806403503994187.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(181271305836230066.4903)
,p_branch_action=>'f?p=&FLOW_ID.:1320:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(181271124244230065.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181186714571637309.4903)
,p_name=>'P1310_REPORT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4903)
,p_prompt=>'Berichtsname'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Namen des Berichts an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181186914960637313.4903)
,p_name=>'P1310_REPORT_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4903)
,p_item_default=>'TABLE'
,p_prompt=>'Berichtsquelle'
,p_source=>'TABLE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REPORT_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(181139517862367299.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie an, wie Ihre Abfrage entwickelt werden soll: entweder durch Angabe einer Tabelle oder durch SQL-Eingabe.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181266012291188798.4903)
,p_name=>'P1310_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4903)
,p_prompt=>'Tabellen- oder View-Name'
,p_post_element_text=>'<a href="javascript:popupURL(''f?p=4900:90:&SESSION.:::90,RIR:P90_SCHEMA:&P1310_SCHEMA.'');"><img src="#IMAGE_PREFIX#htmldb/icons/view_small.gif" width="18" height="18" valign="middle"/></a>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Geben Sie den Namen der Tabelle an, auf der der Bericht basieren soll.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181266401687195146.4903)
,p_name=>'P1310_QUERY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4903)
,p_prompt=>'Abfrage'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>10
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie die SQL-Abfrage an, die den Bericht definiert.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(458479923768361791.4903)
,p_name=>'P1310_REPORT_ALIAS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4903)
,p_prompt=>'Berichtsalias'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('F\00FCr die Verkn\00FCpfung mit dem Bericht in Seitenabschnitten wird ein Berichtaliasname verwendet. Ein Berichtaliasname muss in der Anwendung eindeutig sein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(492930302074769112.4903)
,p_name=>'P1310_SCHEMA'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(181186531071637307.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'wwv_flow_ws_setup.get_apex$_schema(p_workspace_id=>:flow_security_group_id);'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Gibt das Websheet-Schema an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(181273103727243002.4903)
,p_validation_name=>'P1310_TABLE_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P1310_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Der Tabellenname muss angegeben werden.'
,p_validation_condition=>'P1310_REPORT_SOURCE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4903)
,p_associated_item=>wwv_flow_api.id(181266012291188798.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(181273619311247515.4903)
,p_validation_name=>'P1310_QUERY not null'
,p_validation_sequence=>20
,p_validation=>'P1310_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Die Abfrage muss angegeben werden.'
,p_validation_condition=>'P1310_REPORT_SOURCE'
,p_validation_condition2=>'QUERY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4903)
,p_associated_item=>wwv_flow_api.id(181266401687195146.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(181296117710606612.4903)
,p_validation_name=>'P1310_TABLE_NAME valid'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_match varchar2(30);',
'begin',
'    if :P1310_TABLE_NAME is not null then',
'        l_match := wwv_flow_builder.is_valid_table_or_view',
'          (:P1310_SCHEMA, :P1310_TABLE_NAME);',
'        if l_match = ''E'' then',
'          return true;',
'        elsif l_match = ''U'' then',
'          :P1310_TABLE_NAME := upper(:P1310_TABLE_NAME);',
'          return true;',
'        else    ',
'          return false;',
'        end if;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>unistr('&P1310_TABLE_NAME. ist kein g\00FCltiger Name f\00FCr eine Tabelle.')
,p_validation_condition=>':P1310_TABLE_NAME is not null and :P1310_REPORT_SOURCE = ''TABLE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4903)
,p_associated_item=>wwv_flow_api.id(181266012291188798.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(181296300657620562.4903)
,p_validation_name=>'P1310_QUERY valid'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.is_valid_report_query (',
'  p_plug_source      => :P1310_QUERY,',
'  p_plug_source_type => ''SQL_QUERY'',',
'  p_owner            => :P1310_SCHEMA',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition_type=>'NEVER'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4903)
,p_associated_item=>wwv_flow_api.id(181266401687195146.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(188187709408926344.4903)
,p_validation_name=>'P1310_REPORT_NAME not null'
,p_validation_sequence=>50
,p_validation=>'P1310_REPORT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Der Berichtsname muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4903)
,p_associated_item=>wwv_flow_api.id(181186714571637309.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(458504504243696704.4903)
,p_validation_name=>'P1310_REPORT_ALIAS must be unique'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1310_REPORT_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_alias        => :P1310_REPORT_ALIAS,',
'    p_alias_type   => ''REPORT'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Berichtalias bereits vorhanden. Geben Sie einen anderen Alias ein.'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4903)
,p_associated_item=>wwv_flow_api.id(458479923768361791.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(488324302680240232.4903)
,p_validation_name=>'is valid sql'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_security.is_valid_sql (',
'    p_ws_app_id  => :WS_APP_ID,',
'    p_type       => :P1310_REPORT_SOURCE, ',
'    p_sql        => :P1310_QUERY,',
'    p_schema     => :P1310_SCHEMA,',
'    p_table_name => :P1310_TABLE_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1310_QUERY is not null or ',
':P1310_TABLE_NAME is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4903)
,p_associated_item=>wwv_flow_api.id(.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(689014210768200618.4903)
,p_validation_name=>'P1310_REPORT_NAME must be unique'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1310_REPORT_NAME is not null then',
'  if wwv_flow_ws_api.websheet_name_exists  (',
'    p_ws_app_id    => :ws_app_id,',
'    p_name         => :P1310_REPORT_NAME,',
'    p_type         => ''REPORT'') then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Berichtsname ist bereits vorhanden. Geben Sie einen anderen Namen ein.'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4903)
,p_associated_item=>wwv_flow_api.id(181186714571637309.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(513750411309137615.4903)
,p_validation_name=>'P1310_REPORT_ALIAS is valid'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1310_REPORT_ALIAS is not null and not wwv_flow_ws_api.is_alphanumeric (p_str => :P1310_REPORT_ALIAS) then',
'    return wwv_flow_lang.system_message(''WS_ALIAS_NOT_VALID'');',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_when_button_pressed=>wwv_flow_api.id(181271124244230065.4903)
,p_associated_item=>wwv_flow_api.id(458479923768361791.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(181266700087204166.4903)
,p_name=>'display query'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_REPORT_SOURCE'
,p_condition_element=>'P1310_REPORT_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(181267028924204168.4903)
,p_event_id=>wwv_flow_api.id(181266700087204166.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_QUERY'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(181267212037204170.4903)
,p_event_id=>wwv_flow_api.id(181266700087204166.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_QUERY'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(181268910260216555.4903)
,p_name=>'display table'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_REPORT_SOURCE'
,p_condition_element=>'P1310_REPORT_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(181269202182216557.4903)
,p_event_id=>wwv_flow_api.id(181268910260216555.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TABLE_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(181269414181216558.4903)
,p_event_id=>wwv_flow_api.id(181268910260216555.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TABLE_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(430278609659879937.4903)
,p_name=>'set report name'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_TABLE_NAME'
,p_condition_element=>'P1310_TABLE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_bind_event_type=>'focusin'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(430278917502879938.4903)
,p_event_id=>wwv_flow_api.id(430278609659879937.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_REPORT_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P1310_TABLE_NAME'')'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_01320
begin
wwv_flow_api.create_page(
 p_id=>1320.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Bericht erstellen'
,p_step_title=>'Bericht erstellen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20812329177030021.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20815714679054203.4903)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181297307705626802.4903)
,p_plug_name=>'Bericht erstellen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>unistr('Sie haben das Erstellen eines Berichts mit folgenden Attributen angefordert. Best\00E4tigen Sie Ihre Auswahl.<br /><br />')
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181298124906626804.4903)
,p_plug_name=>'create report progress bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_api.id(181250307256073810.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(1338174060370978758.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(181299030786629328.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181297503760626803.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20812329177030021.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181297711481626803.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20812329177030021.4903)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>'Bericht erstellen'
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(181300227716656783.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20812329177030021.4903)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(61282809984809202.4903)
,p_button_image_alt=>unistr('Zur\00FCck')
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1310:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(181298718190626810.4903)
,p_branch_action=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.::WS_APP_ID,IR_ID,WS_ID:&WS_APP_ID.,&P1320_WORKSHEET_ID.,&P1320_WEBSHEET_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(181297711481626803.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181297919436626804.4903)
,p_name=>'P1320_REPORT_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(181297307705626802.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Schema'
,p_source=>'P1310_SCHEMA'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181303817766710711.4903)
,p_name=>'P1320_REPORT_SOURCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(181297307705626802.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Berichtsquelle'
,p_source=>'P1310_REPORT_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REPORT_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_api.id(181139517862367299.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181304108547717462.4903)
,p_name=>'P1320_TABLE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(181297307705626802.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tabellenname'
,p_source=>'P1310_TABLE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P1310_REPORT_SOURCE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181305506946726463.4903)
,p_name=>'P1320_QUERY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(181297307705626802.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Abfrage'
,p_source=>'P1310_QUERY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P1310_REPORT_SOURCE'
,p_display_when2=>'QUERY'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(181530212990431902.4903)
,p_name=>'P1320_REPORT_NAME'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_api.id(181297307705626802.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Berichtsname'
,p_source=>'P1310_REPORT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459472219918508284.4903)
,p_name=>'P1320_WORKSHEET_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(20815714679054203.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(459472414932508288.4903)
,p_name=>'P1320_WEBSHEET_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(20815714679054203.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(181500204595098271.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create websheet report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_ws_report (',
'    p_ws_app_id      => :WS_APP_ID,        ',
'    p_flow_id        => :APP_ID,',
'    p_schema         => :P1310_SCHEMA,',
'    p_source_type    => :P1310_REPORT_SOURCE,',
'    p_report_name    => :P1310_REPORT_NAME,',
'    p_report_alias   => :P1310_REPORT_ALIAS,',
'    p_table_name     => :P1310_TABLE_NAME,',
'    p_query          => :P1310_QUERY,',
'    p_worksheet_id   => :P1320_WORKSHEET_ID,',
'    p_websheet_id    => :P1320_WEBSHEET_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Bericht konnte nicht erstellt werden.'
,p_process_when_button_id=>wwv_flow_api.id(181297711481626803.4903)
,p_process_success_message=>'Bericht erstellt.'
);
end;
/
prompt --application/pages/page_03000
begin
wwv_flow_api.create_page(
 p_id=>3000.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Bericht'
,p_step_title=>'Bericht'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(492214905335570870)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20912104119139293.4903)
,p_plug_name=>unistr('Rechte Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20912629053146493.4903)
,p_plug_name=>'Hidden Region'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183279128488493601.4903)
,p_plug_name=>'Layout 1'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'<table border="0" cellpadding="0" cellspacing="0" width="100%" ><tr><td valign="top">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183279310594493602.4903)
,p_plug_name=>'Layout 2'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'</td><td width="100%" valign="top" style="padding:0 0 0 15px;">'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183279512150493603.4903)
,p_plug_name=>'Layout 3'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>'</td></tr></table>'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183279910830493605.4903)
,p_plug_name=>'name'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183285705297524279.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(631044792201195017.4903)
,p_plug_name=>'Bericht anzeigen'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(20956911766368602.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.DATA_GRID'
,p_attribute_01=>'IR_ID'
,p_attribute_03=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(183283719060493621.4903)
,p_branch_action=>'f?p=&FLOW_ID.:3000:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183280332465493606.4903)
,p_name=>'P3000_SHOW_CHECKBOX'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(20912629053146493.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183281906745493610.4903)
,p_name=>'P3000_SHOW_TOOLBAR'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20912629053146493.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184278725572053777.4903)
,p_name=>'P3000_REPORT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(20912629053146493.4903)
,p_prompt=>'Report Name'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(183282303574493611.4903)
,p_computation_sequence=>10
,p_computation_item=>'F4900_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'2'
,p_compute_when_type=>'%null%'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(184279327435063745.4903)
,p_computation_sequence=>20
,p_computation_item=>'P3000_REPORT_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_ws_api.get_websheet_name(p_worksheet_id => :IR_ID);'
,p_computation_error_message=>'Berichtsname kann nicht abgerufen werden.'
);
end;
/
prompt --application/pages/page_03010
begin
wwv_flow_api.create_page(
 p_id=>3010.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Bericht bearbeiten'
,p_step_title=>'Bericht bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"''; ',
' ',
' function apex_p3010_showImage(img_id){',
'  var lImg = $x(''edit_image'');',
'	var lSrc =''''',
'	switch(img_id){',
'    case 0:lSrc="#IMAGE_PREFIX#ws/small_page.gif";break;',
'	case 1:lSrc="#IMAGE_PREFIX#magnifying_glass_white_bg.gif";break;',
'	case 2:lSrc="#IMAGE_PREFIX#edit_big.gif";break;',
'	case 3:lSrc="#IMAGE_PREFIX#edit.gif";break;',
'	case 4:lSrc="#IMAGE_PREFIX#e2.gif";break;',
'	default:lSrc="#IMAGE_PREFIX#1px_white.gif";break',
'	}',
'	lImg.src = lSrc;',
'    return true;',
'  }',
'',
'  function apex_p3010_hideImage(){',
'    var lImg = $x(''edit_image'').src = "#IMAGE_PREFIX#1px_white.gif";',
'    return true;',
'  }',
'  ',
'  function apex_p3010_setColumnIDandSubmit(columnID){',
'    $x(''P3010_COLUMN_ID'').value=columnID;  ',
'    doSubmit(''SAVE_COLUMN'');',
'  }',
'  ',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(495860932509802714)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183771819334108915.4903)
,p_plug_name=>'Linkspalte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186338205876681460.4903)
,p_plug_name=>'Single-Row-Unteransicht'
,p_parent_plug_id=>wwv_flow_api.id(183771819334108915.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4903)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186338516958684607.4903)
,p_plug_name=>'Sublinkspalte'
,p_parent_plug_id=>wwv_flow_api.id(183771819334108915.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4903)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186338828386687900.4903)
,p_plug_name=>'Sub-URL'
,p_parent_plug_id=>wwv_flow_api.id(183771819334108915.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4903)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186339511679702056.4903)
,p_plug_name=>'Sublinksymbol'
,p_parent_plug_id=>wwv_flow_api.id(183771819334108915.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4903)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186352431129811698.4903)
,p_plug_name=>'Subbericht oder URL'
,p_parent_plug_id=>wwv_flow_api.id(183771819334108915.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4903)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_report_region(
 p_id=>wwv_flow_api.id(183789730499443251.4903)
,p_name=>'Spaltenattribute'
,p_template=>wwv_flow_api.id(27071223638280295.4903)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'db_column_name,',
'wwv_flow_item.hidden(1,id)||',
'wwv_flow_item.text(2,display_order, 16, 255, ''class="orderby" style="display:none;" '')||',
'wwv_flow_item.text(5,report_label,16,255) report_label,',
'decode(nvl(column_link,''NOLINK''),',
'    ''NOLINK'',''&nbsp;'',',
'    ''<img src="#IMAGE_PREFIX#check_small_black.gif" width="15" height="15" alt="''||wwv_flow_lang.system_message(''F4000.LINK_COLUMN'')||''" />'') column_link,',
'column_type,',
'wwv_flow_item.select_list_from_lov(6,display_text_as,''IR_DISPLAY_TYPES'',null,''NO'') display_text_as',
'from wwv_flow_worksheet_columns c',
'where worksheet_id = :P3010_WORKSHEET_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by display_order'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_api.id(46784125242633572.4903)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Keine Spaltenattribute gefunden.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790030967443254.4903)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_column_link=>'javascript:apex_p3010_setColumnIDandSubmit(''#ID#'');'
,p_column_linktext=>unistr('<img src="#IMAGE_PREFIX#e2.gif" border="0" height="18" width="18" alt="Sie k\00F6nnen zus\00E4tzliche Spaltenattribute bearbeiten und Spaltenlinks hinzuf\00FCgen.">')
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790123422443254.4903)
,p_query_column_id=>2
,p_column_alias=>'DB_COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790219053443254.4903)
,p_query_column_id=>3
,p_column_alias=>'REPORT_LABEL'
,p_column_display_sequence=>3
,p_column_heading=>unistr('\00DCberschrift')
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790312249443254.4903)
,p_query_column_id=>4
,p_column_alias=>'COLUMN_LINK'
,p_column_display_sequence=>5
,p_column_heading=>'Link'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790416608443254.4903)
,p_query_column_id=>5
,p_column_alias=>'COLUMN_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Typ'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_report_columns(
 p_id=>wwv_flow_api.id(183790521735443254.4903)
,p_query_column_id=>6
,p_column_alias=>'DISPLAY_TEXT_AS'
,p_column_display_sequence=>6
,p_column_heading=>'Text anzeigen als'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(183860828861849647.4903)
,p_plug_name=>'Seitenumbruch'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(436574504853227182.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(457388232071871567.4903)
,p_plug_name=>'Berichtsattribute'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(27071223638280295.4903)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491742014533069516.4903)
,p_plug_name=>'Registerkartennavigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(491741626522063565.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(183777904236189775.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491742014533069516.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(183778330556197286.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(491742014533069516.4903)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(183778121205194643.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(491742014533069516.4903)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(187542503123392563.4903)
,p_branch_action=>'f?p=&APP_ID.:3020:&SESSION.::&DEBUG.:3020:P3020_COLUMN_ID,P3020_WORKSHEET_ID,P3020_WEBSHEET_ID:&P3010_COLUMN_ID.,&P3010_WORKSHEET_ID.,&P3010_WEBSHEET_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVE_COLUMN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(491763709741172242.4903)
,p_branch_action=>'f?p=&APP_ID.:3030:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>15
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVE_QUERY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(183778505753199625.4903)
,p_branch_action=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(183778330556197286.4903)
,p_branch_sequence=>20
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(188346821700508574.4903)
,p_branch_action=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.::P902_SHOW:REPORT&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(183778121205194643.4903)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183782818613231757.4903)
,p_name=>'P3010_WEBSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(183789730499443251.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'WS_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183784714560363003.4903)
,p_name=>'P3010_WORKSHEET_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(183789730499443251.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Worksheet Id'
,p_source=>'IR_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(183987530329531247.4903)
,p_name=>'P3010_PAGINATION_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(183860828861849647.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Seitennummerierungstyp'
,p_source=>'PAGINATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_PAGINATION_TYPE'
,p_lov=>'.'||wwv_flow_api.id(183988226651539622.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Keine Seitennummerierung ausgew\00E4hlt -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Oft wird nur eine bestimmte Anzahl von Berichtszeilen auf einer Seite angezeigt. Um weitere Zeilen einzubeziehen, muss der Anwendungsbenutzer zur n\00E4chsten Seite des Berichts navigieren.<p /> '),
'Die Seitennummerierung liefert dem Benutzer Informationen zur Anzahl der Zeilen und zur aktuellen Position innerhalb der Ergebnismenge.<p /> ',
unistr('Die Seitennummerierung kann \00FCber oder unter dem Bericht angezeigt werden (oder an beiden Stellen). Sie l\00E4sst sich auch links oder rechts positionieren. Folgende Seitennummerierungsoptionen sind verf\00FCgbar: '),
'<ul> ',
'<li>Zeilenbereiche X bis Y</li>  ',
'<li>Zeilenbereiche X bis Y von Z</li></ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184005701211645859.4903)
,p_name=>'P3010_SHOW_NULLS_AS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(183860828861849647.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Null anzeigen als'
,p_source=>'SHOW_NULLS_AS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>16
,p_cMaxlength=>255
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie den Text an, der f\00FCr Nullspalten angezeigt werden soll.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184006916973688202.4903)
,p_name=>'P3010_MAX_ROW_COUNT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(183860828861849647.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximale Zeilenanzahl'
,p_source=>'MAX_ROW_COUNT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>7
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Definiert die maximale Anzahl von Zeilen f\00FCr die Abfrage. Beachten Sie, dass sich dieses Attribut auf die Performance auswirkt. Wenn weniger Zeilen zur\00FCckgegeben werden, kann dies die Performance verbessern. Die R\00FCckgabe von Tausenden von Zeilen beei')
||unistr('ntr\00E4chtigt unter Umst\00E4nden die Performance.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184008821737708516.4903)
,p_name=>'P3010_MAX_ROW_COUNT_MESSAGE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(183860828861849647.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Benutzerdefinierte Meldung "Maximale Zeilenanzahl"'
,p_source=>'MAX_ROW_COUNT_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>3
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Definiert die Textmeldung, die angezeigt wird, wenn mehr als die maximale Anzahl Zeilen vorhanden ist. Wenn keine Angabe gemacht wird, wird eine vom System generierte Meldung angezeigt.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184009529833720278.4903)
,p_name=>'P3010_NO_DATA_FOUND_MSG'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(183860828861849647.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Benutzerdefinierte Meldung bei nicht gefundenen Daten'
,p_source=>'NO_DATA_FOUND_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>32767
,p_cHeight=>3
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Definiert die Textmeldung, die angezeigt wird, wenn die Abfrage keine Zeilen zur\00FCckgibt. Wenn keine Angabe gemacht wird, wird eine vom System generierte Meldung angezeigt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184013922261746508.4903)
,p_name=>'P3010_SHOW_DETAIL_LINK'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(183771819334108915.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Linkspalte'
,p_source=>'SHOW_DETAIL_LINK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_COLUMN'
,p_lov=>'.'||wwv_flow_api.id(184013026632738314.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Die Link-Spalte wird als erste Spalte im Bericht aufgenommen und kann vom Benutzer nicht ausgeblendet werden. Mit der Link-Spalte kann zu einer Single Row-Detailansicht der ausgew\00E4hlten Zeile, zu einer Seite in der Anwendung oder der angegebenen URL ')
||'navigiert werden.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184016323908765912.4903)
,p_name=>'P3010_DETAIL_F'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(186338205876681460.4903)
,p_prompt=>'Single Row-Ansicht'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_DETAIL_PAGE_FUNCTIONALITY'
,p_lov=>'.'||wwv_flow_api.id(184015632435758855.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Die folgenden Optionen werden in der Single Row-Ansicht eines Berichts angezeigt. W\00E4hlen Sie die Optionen, die Sie anzeigen m\00F6chten.'),
'<ul>',
unistr('<li>Ausschlie\00DFen von Nullwerten zulassen - Mit dem Kontrollk\00E4stchen "Nullwerte ausschlie\00DFen" werden Spalten mit Nullwerten ausgeschlossen.</li>'),
'<li>Angezeigte Spalten - Zeigt nur die Spalten an, die im Bericht dargestellt werden.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184019207548780090.4903)
,p_name=>'P3010_USE_PK'
,p_is_required=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(186338205876681460.4903)
,p_prompt=>'Zeilen eindeutig identifizieren durch'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_ROWID_OR_COLS'
,p_lov=>'.'||wwv_flow_api.id(184017715035772751.4903)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Standardm\00E4\00DFig wird ROWID zur eindeutigen Identifizierung von Zeilen in einem Bericht verwendet. Alternativ k\00F6nnen Sie zu diesem Zweck eine Spalte eingeben.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184020125902785352.4903)
,p_name=>'P3010_PK1'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(186338205876681460.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Eindeutige Spalte'
,p_source=>'BASE_PK1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie eine Spalte ein, mit der Zeilen im Bericht eindeutig identifiziert werden.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184020902961797735.4903)
,p_name=>'P3010_DETAIL_LINK_TEXT'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(186339511679702056.4903)
,p_use_cache_before_default=>'NO'
,p_item_default=>'return ''<img src="#''||''IMAGE_PREFIX''||''#ws/small_page.gif" alt="" />'';'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Linksymbol'
,p_post_element_text=>'"PICK_CURR_WS_RPT_COL"'
,p_source=>'DETAIL_LINK_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie den HTML-Code ein, der f\00FCr den Link verwendet werden soll. Verwenden Sie ein Bildtag, um Bilder anzuzeigen, oder w\00E4hlen Sie ein Bild aus der Liste mit Standardbildern. Wenn keine Definition vorhanden ist, wird <strong>#IMAGE_PREFIX#ws/small')
||'_page.gif</strong> verwendet.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184021505301817255.4903)
,p_name=>'P3010_PREVIEW'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(186339511679702056.4903)
,p_source=>'<div style="height:30px;width:60px;font-size:small;border:1px #cccccc solid;background:#ffffff"><img src="#IMAGE_PREFIX#1px_white.gif" id="edit_image" alt="" name="edit_image" /></div>'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184021731274824760.4903)
,p_name=>'P3010_DETAIL_LINK_IMAGE'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(186339511679702056.4903)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_itemlink varchar2(32767) := null;',
'begin  ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3010_DETAIL_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''ws/small_page.gif" alt="">'')||'''''');" onmouseover="apex_p'
||'3010_showImage(0)" onmouseout="apex_p3010_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',1)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3010_DETAIL_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''magnifying_glass_white_bg.gif" alt="">'')||'''''');" onmouse'
||'over="apex_p3010_showImage(1)" onmouseout="apex_p3010_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',2)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3010_DETAIL_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''edit_big.gif" alt="">'')||'''''');"onmouseover="apex_p3010_s'
||'howImage(2)" onmouseout="apex_p3010_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',3)||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3010_DETAIL_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''edit.gif" alt="">'')||'''''');" onmouseover="apex_p3010_show'
||'Image(3)" onmouseout="apex_p3010_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',4)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3010_DETAIL_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''e2.gif" alt="">'')||'''''');" onmouseover="apex_p3010_showIm'
||'age(4)" onmouseout="apex_p3010_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',5)||'']</a>''; ',
'  return l_itemlink;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184022826473851811.4903)
,p_name=>'P3010_DETAIL_LINK_ATTR'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(186339511679702056.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Linkattribute'
,p_source=>'DETAIL_LINK_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>62
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie zus\00E4tzliche Detaillinkattribute an, die in das &lt;a href=...&gt;-Tag ber\00FCcksichtigt werden sollen. Hierzu geh\00F6ren Linkziele, Klassen oder Stile. '),
'',
'<p>target="_blank"</p>',
'<p>title="Klicken Sie zur Bearbeitung hier"</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184025109682884777.4903)
,p_name=>'P3010_URL_OR_REPORT'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(186352431129811698.4903)
,p_item_default=>'REPORT'
,p_prompt=>'Ziel'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_REPORT'
,p_lov=>'.'||wwv_flow_api.id(184024419940878266.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie das URL-Ziel an. Sie k\00F6nnen einen Link zu einem Bericht in der aktuellen Anwendung oder zu einer URL erstellen, der auf andere Anwendungen oder externe Sites verweist.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184029505900110722.4903)
,p_name=>'P3010_LB_WS_ID'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_prompt=>'Berichtsname'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_REPORTS_IN_CURRENT_APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Bericht ausw\00E4hlen -')
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Gibt den Berichtsnamen f\00FCr einen Link an. ')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184090023945418730.4903)
,p_name=>'P3010_LB_RESET_IR'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_RESET'
,p_lov=>'.'||wwv_flow_api.id(184090310224424164.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184097928016438807.4903)
,p_name=>'P3010_LB_COL1'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_prompt=>'Spalte'
,p_post_element_text=>'"PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Legen Sie einen Filter f\00FCr die angegebene Spalte fest.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184098110617452740.4903)
,p_name=>'P3010_LB_OPR1'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_prompt=>'Operator'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Operator ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie einen Operator f\00FCr den Spaltenfilter.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184098301398459459.4903)
,p_name=>'P3010_LB_VALUE1'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_prompt=>'Ausdruck'
,p_post_element_text=>'"PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie den Filterausdruck ein.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184113301014506673.4903)
,p_name=>'P3010_X4'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184142204402602240.4903)
,p_name=>'P3010_LB_CLEAR_IR'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_CLEAR_SETTINGS'
,p_lov=>'.'||wwv_flow_api.id(184141723318598286.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184150705703621532.4903)
,p_name=>'P3010_LB_COL2'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_prompt=>'Spalte'
,p_post_element_text=>'"PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184151011936623336.4903)
,p_name=>'P3010_LB_OPR2'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_prompt=>'Operator'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Operator ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184151218170625182.4903)
,p_name=>'P3010_LB_VALUE2'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_prompt=>'Wert'
,p_post_element_text=>'"PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184151423711626784.4903)
,p_name=>'P3010_LB_COL3'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_prompt=>'Spalte'
,p_post_element_text=>'"PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184151730290628632.4903)
,p_name=>'P3010_LB_OPR3'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_prompt=>'Operator'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Operator ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184151903756630505.4903)
,p_name=>'P3010_LB_VALUE3'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(186338516958684607.4903)
,p_prompt=>'Wert'
,p_post_element_text=>'"PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(184152315315643256.4903)
,p_name=>'P3010_LB_URL'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_api.id(186338828386687900.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'DETAIL_LINK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>92
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie die URL ein, der auf andere Anwendungen oder externe Sites verweist.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185506411845254149.4903)
,p_name=>'P3010_ALLOW_EXCLUDE_NULL'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(186338205876681460.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Exclude Null Values'
,p_source=>'ALLOW_EXCLUDE_NULL_VALUES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185506621541256939.4903)
,p_name=>'P3010_ALLOW_HIDE_EXTRA_COLS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(186338205876681460.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Hide Extra Columns'
,p_source=>'ALLOW_HIDE_EXTRA_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187542007448355954.4903)
,p_name=>'P3010_COLUMN_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(183789730499443251.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(457389308784883762.4903)
,p_name=>'P3010_REPORT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(457388232071871567.4903)
,p_prompt=>'Berichtsname'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Geben Sie den Namen des Berichts an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(457389632118899915.4903)
,p_name=>'P3010_REPORT_ALIAS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(457388232071871567.4903)
,p_prompt=>'Berichtsalias'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('F\00FCr die Verkn\00FCpfung mit dem Bericht in Seitenabschnitten wird ein Berichtaliasname verwendet. Ein Berichtaliasname muss in der Anwendung eindeutig sein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(185285814372809981.4903)
,p_computation_sequence=>10
,p_computation_item=>'P3010_LB_URL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.build_ws_rpt_link_url (  ',
'    p_ws_app_id         => :ws_app_id,  ',
'    p_websheet_id       => :P3010_LB_WS_ID,',
'    p_reset_ir          => :P3010_LB_RESET_IR,',
'    p_clear_ir          => :P3010_LB_CLEAR_IR,',
'    p_column1           => :P3010_LB_COL1,',
'    p_operator1         => :P3010_LB_OPR1,',
'    p_value1            => :P3010_LB_VALUE1,    ',
'    p_column2           => :P3010_LB_COL2,',
'    p_operator2         => :P3010_LB_OPR2,',
'    p_value2            => :P3010_LB_VALUE2,    ',
'    p_column3           => :P3010_LB_COL3,',
'    p_operator3         => :P3010_LB_OPR3,',
'    p_value3            => :P3010_LB_VALUE3',
'    );'))
,p_compute_when=>'P3010_URL_OR_REPORT'
,p_compute_when_text=>'REPORT'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(617311407479937225.4903)
,p_computation_sequence=>20
,p_computation_item=>'P3010_PK1'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P3010_USE_PK'
,p_compute_when_text=>'Y'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187844217876488819.4903)
,p_computation_sequence=>20
,p_computation_item=>'P3010_WEBSHEET_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'from wwv_flow_ws_websheet_attr',
'where worksheet_id = :P3010_WORKSHEET_ID',
'and security_group_id = :flow_security_group_id'))
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(617311372674937224.4903)
,p_computation_sequence=>30
,p_computation_item=>'P3010_USE_PK'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_grid in (select null',
'               from wwv_flow_worksheets',
'               where id = :P3010_WORKSHEET_ID',
'               and security_group_id = :flow_security_group_id',
'               and base_pk1 is not null)',
'loop',
'    -- if based pk defined, it''s not using ROWID',
'    return ''N'';',
'end loop;',
'return ''Y'';'))
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185286425238822581.4903)
,p_validation_name=>'P3010_MAX_ROW_COUNT must be number'
,p_validation_sequence=>10
,p_validation=>'P3010_MAX_ROW_COUNT'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Die maximale Zeilenanzahl muss numerisch sein.'
,p_validation_condition=>'P3010_MAX_ROW_COUNT'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4903)
,p_associated_item=>wwv_flow_api.id(184006916973688202.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185286614288828883.4903)
,p_validation_name=>'P3010_PK1not null'
,p_validation_sequence=>20
,p_validation=>'P3010_PK1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'"Eindeutige Spalte" muss angegeben werden.'
,p_validation_condition=>'(:P3010_SHOW_DETAIL_LINK = ''Y'') and (:P3010_USE_PK = ''N'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4903)
,p_associated_item=>wwv_flow_api.id(184020125902785352.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(185286806800836129.4903)
,p_validation_name=>'P3010_DETAIL_LINK_TEXT not null'
,p_validation_sequence=>30
,p_validation=>'P3010_DETAIL_LINK_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Das Linksymbol muss angegeben werden.'
,p_validation_condition=>'P3010_SHOW_DETAIL_LINK'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4903)
,p_associated_item=>wwv_flow_api.id(184020902961797735.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(457454703093071343.4903)
,p_validation_name=>'P3010_REPORT_NAME not null'
,p_validation_sequence=>40
,p_validation=>'P3010_REPORT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4903)
,p_associated_item=>wwv_flow_api.id(457389308784883762.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(457455920408076283.4903)
,p_validation_name=>'P3010_REPORT_ALIAS not null'
,p_validation_sequence=>50
,p_validation=>'P3010_REPORT_ALIAS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# muss einen Wert haben.'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4903)
,p_associated_item=>wwv_flow_api.id(457389632118899915.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(457462725444191308.4903)
,p_validation_name=>'P3010_REPORT_ALIAS must be unique'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3010_REPORT_ALIAS is not null then',
'  if wwv_flow_ws_api.alias_exists(',
'     p_ws_app_id=>:WS_APP_ID,',
'     p_alias=>:P3010_REPORT_ALIAS,',
'     p_alias_type=>''REPORT'',',
'     p_worksheet_id=>:P3010_WORKSHEET_ID) then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Berichtalias bereits vorhanden. Geben Sie einen anderen Alias ein.'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4903)
,p_associated_item=>wwv_flow_api.id(457389632118899915.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(711664422399287229.4903)
,p_validation_name=>'P3010_REPORT_NAME must be unique'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3010_REPORT_NAME is not null then',
'  if wwv_flow_ws_api.websheet_name_exists  (',
'    p_ws_app_id    => :ws_app_id,',
'    p_name         => :P3010_REPORT_NAME,',
'    p_type         => ''REPORT'',',
'    p_worksheet_id => :P3010_WORKSHEET_ID) then',
'    return false;',
'  end if;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Berichtsname ist bereits vorhanden. Geben Sie einen anderen Namen ein.'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4903)
,p_associated_item=>wwv_flow_api.id(457389308784883762.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(513767814649272788.4903)
,p_validation_name=>'P3010_REPORT_ALIAS is valid'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3010_REPORT_ALIAS is not null and not wwv_flow_ws_api.is_alphanumeric (p_str => :P3010_REPORT_ALIAS) then',
'    return wwv_flow_lang.system_message(''WS_ALIAS_NOT_VALID'');',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_when_button_pressed=>wwv_flow_api.id(183778330556197286.4903)
,p_associated_item=>wwv_flow_api.id(457389632118899915.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(186342221292723689.4903)
,p_name=>'hide all'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186342516454723689.4903)
,p_event_id=>wwv_flow_api.id(186342221292723689.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338205876681460.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186342809648729836.4903)
,p_event_id=>wwv_flow_api.id(186342221292723689.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186339511679702056.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186343016228731695.4903)
,p_event_id=>wwv_flow_api.id(186342221292723689.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338516958684607.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186343220037732813.4903)
,p_event_id=>wwv_flow_api.id(186342221292723689.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338828386687900.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186353531044830587.4903)
,p_event_id=>wwv_flow_api.id(186342221292723689.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186352431129811698.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(184768518625717500.4903)
,p_name=>'link column = Y'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK'
,p_condition_element=>'P3010_SHOW_DETAIL_LINK'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186343609087739123.4903)
,p_event_id=>wwv_flow_api.id(184768518625717500.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338205876681460.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186351709396786481.4903)
,p_event_id=>wwv_flow_api.id(184768518625717500.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186339511679702056.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(186366918633931095.4903)
,p_name=>'link column = C'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK'
,p_condition_element=>'P3010_SHOW_DETAIL_LINK'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'C'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186367227927931096.4903)
,p_event_id=>wwv_flow_api.id(186366918633931095.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186339511679702056.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186367400756935337.4903)
,p_event_id=>wwv_flow_api.id(186366918633931095.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186352431129811698.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(184770806121761252.4903)
,p_name=>'link column = N'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK'
,p_condition_element=>'P3010_SHOW_DETAIL_LINK'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(184771126910761253.4903)
,p_event_id=>wwv_flow_api.id(184770806121761252.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338205876681460.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186345318222751244.4903)
,p_event_id=>wwv_flow_api.id(184770806121761252.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186339511679702056.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186345522377752412.4903)
,p_event_id=>wwv_flow_api.id(184770806121761252.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338516958684607.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186345827918754056.4903)
,p_event_id=>wwv_flow_api.id(184770806121761252.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338828386687900.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(184774706822837085.4903)
,p_name=>'hide unique column'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK,P3010_USE_PK'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$v(''P3010_SHOW_DETAIL_LINK'')===''Y'' &&',
'$v(''P3010_USE_PK'')===''N'''))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(184775027064837086.4903)
,p_event_id=>wwv_flow_api.id(184774706822837085.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3010_PK1'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(184775212671837086.4903)
,p_event_id=>wwv_flow_api.id(184774706822837085.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3010_PK1'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(184364122641216529.4903)
,p_name=>'link column = C and REPORT'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK,P3010_URL_OR_REPORT'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$v(''P3010_SHOW_DETAIL_LINK'')===''C'' &&',
'$v(''P3010_URL_OR_REPORT'')===''REPORT'''))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186366010406909809.4903)
,p_event_id=>wwv_flow_api.id(184364122641216529.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338516958684607.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186371311679052039.4903)
,p_event_id=>wwv_flow_api.id(184364122641216529.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338828386687900.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(185690710345795759.4903)
,p_name=>'link column = C and URL'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3010_SHOW_DETAIL_LINK,P3010_URL_OR_REPORT'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$v(''P3010_SHOW_DETAIL_LINK'')===''C'' &&',
'$v(''P3010_URL_OR_REPORT'')===''URL'''))
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186366709845919130.4903)
,p_event_id=>wwv_flow_api.id(185690710345795759.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338828386687900.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186371103021049577.4903)
,p_event_id=>wwv_flow_api.id(185690710345795759.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186338516958684607.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185507407951271929.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set detail view option item value'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_detail_f varchar2(32767) := null;',
'begin',
'  l_detail_f := '':''||:P3010_DETAIL_F||'':'';  ',
' ',
'  if instr(l_detail_f,'':EXCLUDE_NULL:'',1) > 0 then',
'    :P3010_ALLOW_EXCLUDE_NULL := ''Y'';',
'  else',
'    :P3010_ALLOW_EXCLUDE_NULL := ''N'';',
'  end if;',
'  if instr(l_detail_f,'':HIDE_EXTR_COL:'',1) > 0 then',
'    :P3010_ALLOW_HIDE_EXTRA_COLS := ''Y'';',
'  else',
'    :P3010_ALLOW_HIDE_EXTRA_COLS := ''N'';',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Funktionalit\00E4tswerte f\00FCr Single-Row-Ansicht konnten nicht festgelegt werden.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185287112472847246.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update column attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  n number;',
'  r number;',
'  g number;  ',
'begin',
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  n := wwv_flow.g_f01(i);',
'  r := wwv_flow.g_f02(i);',
'  ',
'  -- update report label, display text as',
'  update wwv_flow_worksheet_columns',
'  set report_label = wwv_flow.g_f05(i),',
'      display_text_as = wwv_flow.g_f06(i)',
'  where id = n and',
'     flow_id = :app_id and',
'     security_group_id = :flow_security_group_id;',
'  ',
'  -- update column seq',
'  update wwv_flow_worksheet_columns',
'  set display_order = r',
'  where id = n and',
'     flow_id = :app_id and',
'     display_order != r and',
'     security_group_id = :flow_security_group_id;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Spaltenattribute k\00F6nnen nicht ge\00E4ndert werden.')
,p_process_when=>'APPLY_CHANGES,SAVE_COLUMN,SAVE_QUERY'
,p_process_when_type=>'REQUEST_IN_CONDITION'
);
end;
/
begin
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185287907408855274.4903)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update ir'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.edit_ws_report_attr (',
'    p_worksheet_id              => :P3010_WORKSHEET_ID,',
'    p_websheet_id               => :P3010_WEBSHEET_ID,',
'    p_websheet_name             => :P3010_REPORT_NAME,',
'    p_websheet_alias            => :P3010_REPORT_ALIAS,',
'    p_max_row_count             => :P3010_MAX_ROW_COUNT,',
'    p_max_row_count_message     => :P3010_MAX_ROW_COUNT_MESSAGE,',
'    p_no_data_found_message     => :P3010_NO_DATA_FOUND_MSG,    ',
'    p_base_pk1                  => :P3010_PK1,',
'    p_show_nulls_as             => :P3010_SHOW_NULLS_AS,',
'    p_pagination_type           => :P3010_PAGINATION_TYPE,',
'    p_show_detail_link          => :P3010_SHOW_DETAIL_LINK,',
'    p_detail_link               => :P3010_LB_URL,',
'    p_detail_link_text          => :P3010_DETAIL_LINK_TEXT,',
'    p_detail_link_attr          => :P3010_DETAIL_LINK_ATTR,',
'    p_allow_exclude_null_values => :P3010_ALLOW_EXCLUDE_NULL,',
'    p_allow_hide_extra_columns  => :P3010_ALLOW_HIDE_EXTRA_COLS',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Bericht konnte nicht bearbeitet werden.'
,p_process_when=>'APPLY_CHANGES,SAVE_COLUMN,SAVE_QUERY'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Aktion wurde verarbeitet.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185288529618890083.4903)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete ir '
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_validation_error varchar2(4000) := null;',
'begin',
'    wwv_flow_ws_api.delete_websheet (',
'        p_worksheet_id     => :P3010_WORKSHEET_ID,',
'        p_websheet_id      => :P3010_WEBSHEET_ID,',
'        p_websheet_type    => ''REPORT'',',
'        p_confirm          => ''Y'',',
'        p_validation_error => l_validation_error);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Bericht konnte nicht gel\00F6scht werden.')
,p_process_when_button_id=>wwv_flow_api.id(183778121205194643.4903)
,p_process_success_message=>unistr('Bericht gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185037826832987670.4903)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'fetch row from wwv_flow_worksheets'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WORKSHEETS'
,p_attribute_03=>'P3010_WORKSHEET_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Zeile kann nicht abgerufen werden.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185534723853399474.4903)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set detail view functionaltiy options'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_detail_f varchar2(32767) := null;  ',
'begin  ',
'  if :P3010_ALLOW_EXCLUDE_NULL = ''Y'' then',
'    l_detail_f := ''EXCLUDE_NULL'';',
'  end if;',
'  if :P3010_ALLOW_HIDE_EXTRA_COLS = ''Y'' then',
'    l_detail_f := l_detail_f||wwv_flow_utilities.ite(l_detail_f is not null,'':HIDE_EXTR_COL'',''HIDE_EXTR_COL'');',
'  end if;',
'',
'  :P3010_DETAIL_F := l_detail_f;  ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Funktionalit\00E4tsoptionen f\00FCr Single-Row-Ansicht konnten nicht festgelegt werden.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(457454022655039086.4903)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get ws report attr'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.get_ws_report_attr (',
'    p_websheet_id  => :P3010_WEBSHEET_ID,',
'    p_name         => :P3010_REPORT_NAME,',
'    p_alias        => :P3010_REPORT_ALIAS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Berichtattribute konnten nicht abgerufen werden.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(185283314353658618.4903)
,p_process_sequence=>80
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'split url'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select detail_link',
'           from   wwv_flow_worksheets',
'           where  id = :P3010_WORKSHEET_ID',
'           and    security_group_id = :flow_security_group_id)',
'loop         ',
'  wwv_flow_ws_api.split_ws_rpt_link_url (',
'    p_url               => c1.detail_link,',
'    --',
'    p_websheet_id       => :P3010_LB_WS_ID,',
'    p_reset_ir          => :P3010_LB_RESET_IR,',
'    p_clear_ir          => :P3010_LB_CLEAR_IR,',
'    p_column1           => :P3010_LB_COL1,',
'    p_operator1         => :P3010_LB_OPR1,',
'    p_value1            => :P3010_LB_VALUE1,    ',
'    p_column2           => :P3010_LB_COL2,',
'    p_operator2         => :P3010_LB_OPR2,',
'    p_value2            => :P3010_LB_VALUE2,    ',
'    p_column3           => :P3010_LB_COL3,',
'    p_operator3         => :P3010_LB_OPR3,',
'    p_value3            => :P3010_LB_VALUE3',
'    );',
'    ',
'  ',
'  if :P3010_LB_WS_ID is not null then',
'    :P3010_URL_OR_REPORT := ''REPORT'';',
'  end if;',
'  if c1.detail_link is null then',
'    :P3010_URL_OR_REPORT := ''REPORT'';',
'  end if;   ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'URL kann nicht geteilt werden.'
);
end;
/
prompt --application/pages/page_03020
begin
wwv_flow_api.create_page(
 p_id=>3020.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Berichtspalte bearbeiten'
,p_step_title=>'Berichtspalte bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
' function apex_p3020_showImage(img_id){',
'  var lImg = $x(''edit_image'');',
'	var lSrc =''''',
'	switch(img_id){',
'        case 0:lSrc="#IMAGE_PREFIX#ws/small_page.gif";break;',
'	case 1:lSrc="#IMAGE_PREFIX#magnifying_glass_white_bg.gif";break;',
'	case 2:lSrc="#IMAGE_PREFIX#edit_big.gif";break;',
'	case 3:lSrc="#IMAGE_PREFIX#edit.gif";break;',
'	case 4:lSrc="#IMAGE_PREFIX#e2.gif";break;',
'	default:lSrc="#IMAGE_PREFIX#1px_white.gif";break',
'	}',
'	lImg.src = lSrc;',
'    return true;',
'  }',
'',
' function apex_p3020_popUpBlobFormat(){      ',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=dummy'', $v(''pFlowStepId''));',
'    get.add(''P3020_FORMAT_MASK'',$v(''P3020_FORMAT_MASK''));    ',
'    gReturn = get.get();',
'    get = null;',
'             ',
'    popUp2(''f?p=''+$v(''pFlowId'')+'':33:''+$v(''pInstance'')+'':::33'',600,550); ',
'  }',
'//-->',
'</script>  '))
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(495860932509802714)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(108407904321468301.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184267326302006596.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184268917430013579.4903)
,p_plug_name=>'Spaltendefinition'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(27071223638280295.4903)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(184269528511016767.4903)
,p_plug_name=>'Werteliste'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186213200242556131.4903)
,p_plug_name=>'Linkspalte'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(47316730240795884.4903)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186236905427831971.4903)
,p_plug_name=>'Spaltenlink'
,p_parent_plug_id=>wwv_flow_api.id(186213200242556131.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4903)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(186237113739834405.4903)
,p_plug_name=>'Link-URL'
,p_parent_plug_id=>wwv_flow_api.id(186213200242556131.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(400020739576925060.4903)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491765700914207563.4903)
,p_plug_name=>'Registerkartennavigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(491741626522063565.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184261124819995612.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491765700914207563.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:3010:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(184261314395995613.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(491765700914207563.4903)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(491766130004215935.4903)
,p_branch_action=>'f?p=&APP_ID.:3030:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVE_QUERY'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(491766304855218074.4903)
,p_branch_action=>'f?p=&APP_ID.:3010:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVE_REPORT_ATTR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(187437909753856015.4903)
,p_branch_action=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(3701399101377.4903)
,p_name=>'P3020_ALLOW_PIVOT'
,p_item_sequence=>520
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Pivot'
,p_source=>'ALLOW_PIVOT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185532815972378290.4903)
,p_name=>'P3020_REPORT_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Berichtsname'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name from wwv_flow_ws_websheet_attr',
'where id = :P3010_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186201028331516947.4903)
,p_name=>'P3020_COLUMN_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_prompt=>'Column Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186201305605519802.4903)
,p_name=>'P3020_WORKSHEET_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186214032729556135.4903)
,p_name=>'P3020_LINK_TEXT'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Linksymbol'
,p_post_element_text=>'"P3020_PICK_CURR_WS_RPT_COL"'
,p_source=>'COLUMN_LINKTEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186214226510556136.4903)
,p_name=>'P3020_X3'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4903)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186214407327556137.4903)
,p_name=>'P3020_LB_RESET_IR'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_RESET'
,p_lov=>'.'||wwv_flow_api.id(184090310224424164.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186214604669556137.4903)
,p_name=>'P3020_LB_VALUE1'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_prompt=>'Wert'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186214832124556138.4903)
,p_name=>'P3020_LB_OPR2'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_prompt=>'Operator'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Operator ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186215011346556139.4903)
,p_name=>'P3020_LB_OPR3'
,p_item_sequence=>490
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_prompt=>'Operator'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Operator ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186215416542556140.4903)
,p_name=>'P3020_LINK_ATTR'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Linkattribute'
,p_source=>'COLUMN_LINK_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>62
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Geben Sie zus\00E4tzliche Detaillinkattribute an, die in das &lt;a href=...&gt;-Tag ber\00FCcksichtigt werden sollen. Hierzu geh\00F6ren Linkziele, Klassen oder Stile. '),
'',
'<p>target="_blank"</p>',
'<p>title="Klicken Sie zur Bearbeitung hier"</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186216019958556141.4903)
,p_name=>'P3020_LB_COL1'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_prompt=>'Spalte'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186216214026556142.4903)
,p_name=>'P3020_LB_CLEAR_IR'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_CLEAR_SETTINGS'
,p_lov=>'.'||wwv_flow_api.id(184141723318598286.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186216528181556142.4903)
,p_name=>'P3020_LB_COL2'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_prompt=>'Spalte'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186216720198556143.4903)
,p_name=>'P3020_LB_VALUE3'
,p_item_sequence=>500
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_prompt=>'Wert'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186216912689556143.4903)
,p_name=>'P3020_LINK_IMAGE'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4903)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_itemlink varchar2(32767) := null;',
'begin  ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3020_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''ws/small_page.gif" alt="">'')||'''''');" onmouseover="apex_p3020_sh'
||'owImage(0)" onmouseout="apex_p3020_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',1)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3020_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''magnifying_glass_white_bg.gif" alt="">'')||'''''');" onmouseover="a'
||'pex_p3020_showImage(1)" onmouseout="apex_p3020_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',2)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3020_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''edit_big.gif" alt="">'')||'''''');"onmouseover="apex_p3020_showImag'
||'e(2)" onmouseout="apex_p3020_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',3)||'']</a>'';',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3020_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''edit.gif" alt="">'')||'''''');" onmouseover="apex_p3020_showImage(3'
||')" onmouseout="apex_p3020_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',4)||'']</a>''; ',
'  l_itemlink:=l_itemlink||''<a class="itemlink" style="margin-right:15px;" href="javascript:$x_Value(''''P3020_LINK_TEXT'''',''''''||wwv_flow_escape.html(''<img src="''||''#''||''IMAGE_PREFIX''||''#''||''e2.gif" alt="">'')||'''''');" onmouseover="apex_p3020_showImage(4)"'
||' onmouseout="apex_p3020_hideImage()">[''||wwv_flow_lang.system_message(''ICON'',5)||'']</a>''; ',
'  return l_itemlink;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186217126218556144.4903)
,p_name=>'P3020_URL_OR_REPORT'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4903)
,p_item_default=>'REPORT'
,p_prompt=>'Ziel'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_REPORT'
,p_lov=>'.'||wwv_flow_api.id(184024419940878266.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186217301834556144.4903)
,p_name=>'P3020_LB_WS_ID'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_prompt=>'Berichtsname'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_REPORTS_IN_CURRENT_APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name, id',
'from wwv_flow_ws_websheet_attr',
'where ws_app_id = :WS_APP_ID',
'and security_group_id = :flow_security_group_id',
'and websheet_type = ''REPORT''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Bericht ausw\00E4hlen -')
,p_lov_null_value=>'0'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186217510592556145.4903)
,p_name=>'P3020_LB_OPR1'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_prompt=>'Operator'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_LINK_OPERATOR'
,p_lov=>'.'||wwv_flow_api.id(184114411019556922.4903)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>unistr('- Operator ausw\00E4hlen -')
,p_lov_null_value=>'%null%'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186218132124556146.4903)
,p_name=>'P3020_PREVIEW'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_api.id(186213200242556131.4903)
,p_source=>'<div style="height:30px;width:60px;font-size:small;border:1px #cccccc solid;background:#ffffff"><img src="#IMAGE_PREFIX#1px_white.gif" id="edit_image" alt="" name="edit_image" /></div>'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186218307991556147.4903)
,p_name=>'P3020_LB_COL3'
,p_item_sequence=>480
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_prompt=>'Spalte'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_NAME"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186218526547556147.4903)
,p_name=>'P3020_LB_URL'
,p_item_sequence=>510
,p_item_plug_id=>wwv_flow_api.id(186237113739834405.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'COLUMN_LINK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>92
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186218724545556148.4903)
,p_name=>'P3020_X4'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186219322440556149.4903)
,p_name=>'P3020_LB_VALUE2'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_api.id(186236905427831971.4903)
,p_prompt=>'Wert'
,p_post_element_text=>'"P3020_PICK_WS_RPT_COL_VALUE"'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187438930475856034.4903)
,p_name=>'P3020_DB_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Spaltenname'
,p_source=>'DB_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>60
,p_cMaxlength=>128
,p_cHeight=>1
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den Spaltennamen der Abfragespalte an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187440305826856038.4903)
,p_name=>'P3020_COLUMN_LABEL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Single Row-Ansicht-Label'
,p_source=>'COLUMN_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie das Spalten-Label ein, das in der Single Row-Ansicht verwendet werden soll.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187440723465856039.4903)
,p_name=>'P3020_REPORT_LABEL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Spalten\00FCberschrift')
,p_source=>'REPORT_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie den Text f\00FCr die \00DCberschrift der Berichtsspalte ein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187441102743856040.4903)
,p_name=>'P3020_SYNC_FORM_LABEL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Gleichen Text f\00FCr Single Row-Ansicht verwenden')
,p_source=>'SYNC_FORM_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_SAME_LABEL_FOR_DETAIL_VIEW'
,p_lov=>'.'||wwv_flow_api.id(187510818230037360.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>unistr('Aktivieren Sie dieses Element, wenn Sie den Text der Spalten\00FCberschrift als Label in der Detailansicht verwenden m\00F6chten.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187441706603856041.4903)
,p_name=>'P3020_ALLOW_SORTING'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Sorting'
,p_source=>'ALLOW_SORTING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187442128281856042.4903)
,p_name=>'P3020_ALLOW_FILTERING'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Filtering'
,p_source=>'ALLOW_FILTERING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187442528157856043.4903)
,p_name=>'P3020_ALLOW_CTRL_BREAKS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Ctrl Breaks'
,p_source=>'ALLOW_CTRL_BREAKS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187442923839856044.4903)
,p_name=>'P3020_ALLOW_AGGREGATIONS'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Aggregations'
,p_source=>'ALLOW_AGGREGATIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187443317324856045.4903)
,p_name=>'P3020_ALLOW_COMPUTATIONS'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Computations'
,p_source=>'ALLOW_COMPUTATIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
begin
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187443720910856046.4903)
,p_name=>'P3020_ALLOW_CHARTING'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Charting'
,p_source=>'ALLOW_CHARTING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187444129680856047.4903)
,p_name=>'P3020_ALLOW_GROUP_BY'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Group By'
,p_source=>'ALLOW_GROUP_BY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187445122268856049.4903)
,p_name=>'P3020_ALLOW_FILTERS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Filters'
,p_source=>'ALLOW_FILTERS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187445703344856051.4903)
,p_name=>'P3020_COLUMN_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Spaltentyp'
,p_source=>'COLUMN_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'class="display_bold"'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den Typ der Abfragespalte an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187446512466856053.4903)
,p_name=>'P3020_DISPLAY_TEXT_AS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Text anzeigen als'
,p_source=>'DISPLAY_TEXT_AS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_DISPLAY_TYPES'
,p_lov=>'.'||wwv_flow_api.id(183810312847513834.4903)||'.'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Mit dieser Option definieren Sie die Anzeige von Spaltenwerten.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187446916751856054.4903)
,p_name=>'P3020_HEADING_ALIGNMENT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('\00DCberschriftenausrichtung')
,p_source=>'HEADING_ALIGNMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ALIGNMENT_L_C_R'
,p_lov=>'.'||wwv_flow_api.id(187517603302080409.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Steuert die \00DCberschriftenausrichtung. Beachten Sie, dass Ihre diesbez\00FCgliche Auswahl vom ausgew\00E4hlten Berichtstemplate unterst\00FCtzt werden muss.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187447308656856055.4903)
,p_name=>'P3020_COLUMN_ALIGNMENT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Spaltenausrichtung'
,p_source=>'COLUMN_ALIGNMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ALIGNMENT_L_C_R'
,p_lov=>'.'||wwv_flow_api.id(187517603302080409.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('W\00E4hlen Sie die Spaltenausrichtung. Beachten Sie, dass Ihre Auswahl vom ausgew\00E4hlten Berichtstemplate unterst\00FCtzt werden muss.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187448529502856058.4903)
,p_name=>'P3020_FORMAT_MASK'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Zahlenformat/Datumsformat'
,p_source=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT MASK DYNAMIC'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'from wwv_flow_format_masks'))
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Wendet Zahlenformatmasken auf Zahlenspalten und Datumsformatmasken auf Datumsspalten an. Um einen vordefinierten Typ zu w\00E4hlen und Beispiele anzuzeigen, w\00E4hlen Sie einen Eintrag aus der Liste.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187449106912856059.4903)
,p_name=>'P3020_RPT_LOV'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_api.id(184269528511016767.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>unistr('Wertelistendefinition (geben Sie eine SQL-Abfrage ein, die eine Spalte zur\00FCckgibt)')
,p_source=>'RPT_LOV'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_label_alignment=>'LEFT-TOP'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie eine SQL-Abfrage ein, die anstelle einer automatisch generierten Abfrage verwendet wird, die eindeutige Spaltenwerte w\00E4hlt. Durch Eingabe einer SQL-Abfrage kann die Performance in einigen Berichten verbessert werden. Die Werteliste wird ang')
||'ezeigt, wenn ein Benutzer auf einen Spaltenheader klickt.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187449532432856060.4903)
,p_name=>'P3020_RPT_SHOW_FILTER_LOV'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_api.id(184269528511016767.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Spalte "Werteliste filtern"'
,p_source=>'RPT_SHOW_FILTER_LOV'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IR_COLUMN_FILTER_LOV'
,p_lov=>'.'||wwv_flow_api.id(187536631811296748.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('W\00E4hlen Sie, wie die Werteliste als Filter in der Dropdown-Liste mit Berichtsspalten abgeleitet werden soll.'),
'<ul>',
'<li>Kein - Filter auf der Werteliste wird deaktiviert.</li>',
'<li>Standard basierend auf Spaltentyp - STRING- und NUMBER-Spalten leiten die Werteliste aus eindeutigen Spaltenwerten ab. DATE-Spalten leiten die Werteliste aus vordefinierten Datumsbereichen ab.</li>',
'<li>Definierte Werteliste verwenden - Werteliste wird aus definierter Liste mit Werten der SQL-Abfrage abgeleitet.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187451707339856066.4903)
,p_name=>'P3020_ALLOW_HIGHLIGHTING'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Highlighting'
,p_source=>'ALLOW_HIGHLIGHTING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>1
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187512930828050488.4903)
,p_name=>'P3020_X2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187515801785070450.4903)
,p_name=>'P3020_X5'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187523430014116498.4903)
,p_name=>'P3020_COLUMN_F'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_prompt=>unistr('Benutzer k\00F6nnen')
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'IR_COLUMN_FUNCTIONALITY'
,p_lov=>'.'||wwv_flow_api.id(187521603695108878.4903)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('F\00FCr dieses Spalte k\00F6nnen folgende Vorg\00E4nge ausgef\00FChrt werden.  W\00E4hlen Sie die Vorg\00E4nge aus, die den Benutzern angezeigt werden sollen.'),
'<ul>',
'<li>Sortieren - Sortiert die Spalte.</li>',
unistr('<li>Filtern - Erstellt Filter f\00FCr die Spalte.</li>'),
unistr('<li>Markieren - Erstellt Markierungen f\00FCr die Spalte.</li>'),
unistr('<li>Kontrollgruppenwechsel - Erstellt einen Kontrollgruppenwechsel f\00FCr die Spalte.</li>'),
unistr('<li>Aggregieren - F\00FCgt aggregierte Berechnungen f\00FCr die Spalte hinzu.</li>'),
unistr('<li>Berechnen - F\00FCgt auf der Spalte basierende Berechnungen hinzu.</li>'),
unistr('<li>Diagramm - F\00FCgt ein auf den Spaltendaten basierendes Diagramm hinzu.</li>'),
'<li>Gruppieren nach - Erstellt eine Gruppe nach Ansicht auf Basis der Spaltendaten.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'10'
,p_attribute_02=>'VERTICAL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187527415862140834.4903)
,p_name=>'P3020_X6'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187539908870309033.4903)
,p_name=>'P3020_X7'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_api.id(184269528511016767.4903)
,p_display_as=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(187887632681262198.4903)
,p_name=>'P3020_WEBSHEET_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_prompt=>'Websheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(261251003866848945.4903)
,p_name=>'P3020_ALLOW_HIDE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_api.id(108407904321468301.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Hide'
,p_source=>'ALLOW_HIDE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(382707909604008992.4903)
,p_name=>'P3020_DOWNLOAD_FORMAT_MASK'
,p_item_sequence=>115
,p_item_plug_id=>wwv_flow_api.id(184268917430013579.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Popup-Feld "BLOB-Formatmaske"'
,p_source=>'''<a href="javascript:apex_p3020_popUpBlobFormat();"><span class="tiny">''||wwv_flow_lang.system_message(''BLOB_FORMAT_MASK'')||''</span></a>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(5556614497310460.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187880521141700728.4903)
,p_computation_sequence=>10
,p_computation_item=>'P3020_LB_URL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.build_ws_rpt_link_url (',
'    p_ws_app_id         => :ws_app_id,    ',
'    p_websheet_id       => :P3020_LB_WS_ID,',
'    p_reset_ir          => :P3020_LB_RESET_IR,',
'    p_clear_ir          => :P3020_LB_CLEAR_IR,',
'    p_column1           => :P3020_LB_COL1,',
'    p_operator1         => :P3020_LB_OPR1,',
'    p_value1            => :P3020_LB_VALUE1,    ',
'    p_column2           => :P3020_LB_COL2,',
'    p_operator2         => :P3020_LB_OPR2,',
'    p_value2            => :P3020_LB_VALUE2,    ',
'    p_column3           => :P3020_LB_COL3,',
'    p_operator3         => :P3020_LB_OPR3,',
'    p_value3            => :P3020_LB_VALUE3',
'    );'))
,p_compute_when=>'P3020_URL_OR_REPORT'
,p_compute_when_text=>'REPORT'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187880704088714745.4903)
,p_computation_sequence=>20
,p_computation_item=>'P3020_SYNC_FORM_LABEL'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P3020_SYNC_FORM_LABEL'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187888117228267229.4903)
,p_computation_sequence=>30
,p_computation_item=>'P3020_WORKSHEET_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P3010_WORKSHEET_ID'
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_computation(
 p_id=>wwv_flow_api.id(187888427617270233.4903)
,p_computation_sequence=>40
,p_computation_item=>'P3020_WEBSHEET_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'from wwv_flow_ws_websheet_attr',
'where worksheet_id = :P3010_WORKSHEET_ID',
'and security_group_id = :flow_security_group_id'))
,p_compute_when_type=>'NEVER'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(187440922214856039.4903)
,p_validation_name=>'P3020_REPORT_LABEL not null'
,p_validation_sequence=>10
,p_validation=>'P3020_REPORT_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Das Berichts-Label muss einen Wert aufweisen.'
,p_associated_item=>wwv_flow_api.id(187440723465856039.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(187446724043856054.4903)
,p_validation_name=>'P3020_DISPLAY_TEXT_AS not null'
,p_validation_sequence=>20
,p_validation=>'P3020_DISPLAY_TEXT_AS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'"Text anzeigen als" muss einen Wert aufweisen.'
,p_associated_item=>wwv_flow_api.id(187446512466856053.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(187880908159734780.4903)
,p_validation_name=>'P3020_COLUMN_LABEL not null'
,p_validation_sequence=>30
,p_validation=>'P3020_COLUMN_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Single Row-Ansicht-Label muss einen Wert aufweisen.'
,p_validation_condition=>'P3020_SYNC_FORM_LABEL'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_api.id(187440305826856038.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(187881107036753454.4903)
,p_validation_name=>'P3020_RPT_LOV not null'
,p_validation_sequence=>40
,p_validation=>'P3020_RPT_LOV'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Die Wertelistendefinition muss angegeben werden.'
,p_validation_condition=>'P3020_RPT_SHOW_FILTER_LOV'
,p_validation_condition2=>'S:C'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_api.id(187449106912856059.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(186335828424640602.4903)
,p_name=>'hide all'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3020_URL_OR_REPORT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186336131828640604.4903)
,p_event_id=>wwv_flow_api.id(186335828424640602.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186236905427831971.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186336309508644645.4903)
,p_event_id=>wwv_flow_api.id(186335828424640602.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186237113739834405.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(186238626468856985.4903)
,p_name=>'display column link'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3020_URL_OR_REPORT'
,p_condition_element=>'P3020_URL_OR_REPORT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPORT'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186238905948856986.4903)
,p_event_id=>wwv_flow_api.id(186238626468856985.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186236905427831971.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(186337022452657792.4903)
,p_name=>'display url'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3020_URL_OR_REPORT'
,p_condition_element=>'P3020_URL_OR_REPORT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'URL'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(186337327503657793.4903)
,p_event_id=>wwv_flow_api.id(186337022452657792.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_api.id(186237113739834405.4903)
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(187540218352321302.4903)
,p_name=>'diable single row view label'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3020_SYNC_FORM_LABEL'
,p_condition_element=>'P3020_SYNC_FORM_LABEL'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(187540516413321302.4903)
,p_event_id=>wwv_flow_api.id(187540218352321302.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3020_COLUMN_LABEL'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(187540731891321303.4903)
,p_event_id=>wwv_flow_api.id(187540218352321302.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3020_COLUMN_LABEL'
);
wwv_flow_api.create_page_da_event(
 p_id=>wwv_flow_api.id(187541007878337176.4903)
,p_name=>'disable lov'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3020_RPT_SHOW_FILTER_LOV'
,p_condition_element=>'P3020_RPT_SHOW_FILTER_LOV'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'N,D'
,p_bind_type=>'bind'
,p_bind_event_type=>'change'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(187541314891337177.4903)
,p_event_id=>wwv_flow_api.id(187541007878337176.4903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3020_RPT_LOV'
);
wwv_flow_api.create_page_da_action(
 p_id=>wwv_flow_api.id(187541520635337177.4903)
,p_event_id=>wwv_flow_api.id(187541007878337176.4903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3020_RPT_LOV'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(187452102590856076.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_WORKSHEET_COLUMNS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_WORKSHEET_COLUMNS'
,p_attribute_03=>'P3020_COLUMN_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Zeile kann nicht abgerufen werden.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(187877614936575937.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set functionality options'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_column_f    varchar2(32767) := null;',
'begin',
'  -- search bar functionality',
'  if :P3020_ALLOW_HIDE = ''Y'' then',
'    l_column_f := ''HIDE'';',
'  end if;',
'  if :P3020_ALLOW_SORTING = ''Y'' then',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':SORT'',''SORT'');',
'  end if;',
'  if :P3020_ALLOW_FILTERING = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':FILTER'',''FILTER'');',
'  end if;',
'  if :P3020_ALLOW_HIGHLIGHTING = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':HIGHLIGHT'',''HIGHLIGHT'');',
'  end if;',
'  if :P3020_ALLOW_CTRL_BREAKS = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':BREAK'',''BREAK'');',
'  end if;',
'  if :P3020_ALLOW_AGGREGATIONS = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':AGGREGATE'',''AGGREGATE'');',
'  end if;',
'  if :P3020_ALLOW_COMPUTATIONS = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':COMPUTE'',''COMPUTE'');',
'  end if;',
'  if :P3020_ALLOW_CHARTING = ''Y'' then  	',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':CHART'',''CHART'');',
'  end if;',
'  if :P3020_ALLOW_GROUP_BY = ''Y'' then',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':GROUP_BY'',''GROUP_BY'');',
'  end if;',
'  if :P3020_ALLOW_PIVOT = ''Y'' then',
'    l_column_f :=l_column_f||wwv_flow_utilities.ite(l_column_f is not null,'':PIVOT'',''PIVOT'');',
'  end if;',
'',
'  :P3020_COLUMN_F := l_column_f;',
'end;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(187878605071610930.4903)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'split URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'  select column_link',
'  from wwv_flow_worksheet_columns',
'  where id = :P3020_COLUMN_ID',
'  and security_group_id = :flow_security_group_id)',
'loop        ',
'  wwv_flow_ws_api.split_ws_rpt_link_url (',
'    p_url               => c1.column_link,',
'    --',
'    p_websheet_id       => :P3020_LB_WS_ID,',
'    p_reset_ir          => :P3020_LB_RESET_IR,',
'    p_clear_ir          => :P3020_LB_CLEAR_IR,',
'    p_column1           => :P3020_LB_COL1,',
'    p_operator1         => :P3020_LB_OPR1,',
'    p_value1            => :P3020_LB_VALUE1,    ',
'    p_column2           => :P3020_LB_COL2,',
'    p_operator2         => :P3020_LB_OPR2,',
'    p_value2            => :P3020_LB_VALUE2,    ',
'    p_column3           => :P3020_LB_COL3,',
'    p_operator3         => :P3020_LB_OPR3,',
'    p_value3            => :P3020_LB_VALUE3',
'    );',
'    ',
'  ',
'  if :P3020_LB_WS_ID is not null then',
'    :P3020_URL_OR_REPORT := ''REPORT'';',
'  end if;',
'  if c1.column_link is null then',
'    :P3020_URL_OR_REPORT := ''REPORT'';',
'  end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(187882301869979000.4903)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set functionality option item value'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_column_f    varchar2(32767) := null; ',
'begin',
'  l_column_f := '':''||:P3020_COLUMN_F||'':'';',
'  ',
'  if instr(l_column_f,'':HIDE:'',1) > 0 then',
'	  :P3020_ALLOW_HIDE := ''Y'';',
'  else',
'	  :P3020_ALLOW_HIDE := ''N'';',
'  end if;  ',
'  if instr(l_column_f,'':SORT:'',1) > 0 then',
'	  :P3020_ALLOW_SORTING := ''Y'';',
'  else',
'	  :P3020_ALLOW_SORTING := ''N'';',
'  end if;',
'  if instr(l_column_f,'':FILTER:'',1) > 0 then',
'	  :P3020_ALLOW_FILTERING := ''Y'';',
'  else',
'	  :P3020_ALLOW_FILTERING := ''N'';',
'  end if;  ',
'  if instr(l_column_f,'':HIGHLIGHT:'',1) > 0 then',
'	  :P3020_ALLOW_HIGHLIGHTING := ''Y'';',
'  else',
'	  :P3020_ALLOW_HIGHLIGHTING := ''N'';',
'  end if;  ',
'  if instr(l_column_f,'':BREAK:'',1) > 0 then',
'	  :P3020_ALLOW_CTRL_BREAKS := ''Y'';',
'  else',
'	  :P3020_ALLOW_CTRL_BREAKS := ''N'';',
'  end if;',
'  if instr(l_column_f,'':AGGREGATE:'',1) > 0 then',
'	  :P3020_ALLOW_AGGREGATIONS := ''Y'';',
'  else',
'	  :P3020_ALLOW_AGGREGATIONS := ''N'';',
'  end if;',
'  if instr(l_column_f,'':COMPUTE:'',1) > 0 then',
'	  :P3020_ALLOW_COMPUTATIONS := ''Y'';',
'  else',
'	  :P3020_ALLOW_COMPUTATIONS := ''N'';',
'  end if;',
'  if instr(l_column_f,'':CHART:'',1) > 0 then',
'	  :P3020_ALLOW_CHARTING := ''Y'';',
'  else',
'	  :P3020_ALLOW_CHARTING := ''N'';',
'  end if;',
'  if instr(l_column_f,'':GROUP_BY:'',1) > 0 then',
'      :P3020_ALLOW_GROUP_BY := ''Y'';',
'  else',
'      :P3020_ALLOW_GROUP_BY := ''N'';',
'  end if;',
'  if instr(l_column_f,'':PIVOT:'',1) > 0 then',
'      :P3020_ALLOW_PIVOT := ''Y'';',
'  else',
'      :P3020_ALLOW_PIVOT := ''N'';',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Funktionalit\00E4tswerte konnten nicht festgelegt werden.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(187884007644122543.4903)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save column attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.edit_ws_rpt_column_attr (',
'    p_worksheet_id           => :P3010_WORKSHEET_ID,',
'    p_column_id              => :P3020_COLUMN_ID,',
'    p_display_text_as        => :P3020_DISPLAY_TEXT_AS, ',
'    p_column_label           => :P3020_COLUMN_LABEL,',
'    p_report_label           => :P3020_REPORT_LABEL,',
'    p_sync_form_label        => :P3020_SYNC_FORM_LABEL,',
'    p_format_mask            => :P3020_FORMAT_MASK,    ',
'    p_heading_alignment      => :P3020_HEADING_ALIGNMENT,',
'    p_column_alignment       => :P3020_COLUMN_ALIGNMENT,',
'    p_allow_hide             => :P3020_ALLOW_HIDE,',
'    p_allow_sorting          => :P3020_ALLOW_SORTING,',
'    p_allow_filtering        => :P3020_ALLOW_FILTERING,',
'    p_allow_ctrl_breaks      => :P3020_ALLOW_CTRL_BREAKS,',
'    p_allow_aggregations     => :P3020_ALLOW_AGGREGATIONS,',
'    p_allow_computations     => :P3020_ALLOW_COMPUTATIONS,',
'    p_allow_charting         => :P3020_ALLOW_CHARTING,',
'    p_allow_group_by         => :P3020_ALLOW_GROUP_BY,',
'    p_allow_pivot            => :P3020_ALLOW_PIVOT,',
'    p_allow_filters          => :P3020_ALLOW_FILTERS,',
'    p_allow_highlighting     => :P3020_ALLOW_HIGHLIGHTING,       ',
'    p_rpt_show_filter_lov    => :P3020_RPT_SHOW_FILTER_LOV,',
'    p_rpt_lov                => :P3020_RPT_LOV,',
'    p_column_link            => :P3020_LB_URL,',
'    p_column_linktext        => :P3020_LINK_TEXT,',
'    p_column_link_attr       => :P3020_LINK_ATTR);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Spaltenattribute konnten nicht gespeichert werden.'
,p_process_success_message=>'Aktion wurde verarbeitet.'
);
end;
/
prompt --application/pages/page_03030
begin
wwv_flow_api.create_page(
 p_id=>3030.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Berichtsabfrage bearbeiten'
,p_step_title=>'Berichtsabfrage bearbeiten'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_api.id(495860932509802714)
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185415003750542184.4903)
,p_plug_name=>'Berichtsabfrage'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185429930518682413.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(491760717181136541.4903)
,p_plug_name=>'Registerkartennavigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>5
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(491741626522063565.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185410831167532672.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(491760717181136541.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(185411030124532674.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(491760717181136541.4903)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(491761918136155704.4903)
,p_branch_action=>'f?p=&APP_ID.:3010:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SAVE_REPORT_ATTR'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(185411408957532677.4903)
,p_branch_action=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(188059413528574599.4903)
,p_branch_action=>'f?p=&APP_ID.:3060:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'FUNCTION_BODY'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_api.ws_rpt_src_changed (',
'    p_worksheet_id    => :P3030_WORKSHEET_ID,',
'    p_websheet_id     => :P3030_WEBSHEET_ID,',
'    p_new_owner       => :P3030_REPORT_OWNER,',
'    p_new_source      => :P3030_REPORT_QUERY',
'    );'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185415320372547002.4903)
,p_name=>'P3030_REPORT_QUERY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(185415003750542184.4903)
,p_prompt=>'Berichtsabfrage'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>20
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="codeTextarea"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie die SQL-Abfrage an, die den Bericht definiert.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185533329824382303.4903)
,p_name=>'P3030_REPORT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(185415003750542184.4903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Berichtsname'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select websheet_name from wwv_flow_ws_websheet_attr',
'where id = :P3030_WEBSHEET_ID',
'and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="display_bold"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den Namen des Berichts an.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186188208919359914.4903)
,p_name=>'P3030_WEBSHEET_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_api.id(185415003750542184.4903)
,p_prompt=>'Websheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(186188516191362067.4903)
,p_name=>'P3030_WORKSHEET_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_api.id(185415003750542184.4903)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(488424611149529319.4903)
,p_name=>'P3030_REPORT_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_api.id(185415003750542184.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(186192317492381358.4903)
,p_validation_name=>'P3030_REPORT_QUERY not null'
,p_validation_sequence=>10
,p_validation=>'P3030_REPORT_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Die Berichtsabfrage muss angegeben werden.'
,p_when_button_pressed=>wwv_flow_api.id(185411030124532674.4903)
,p_associated_item=>wwv_flow_api.id(185415320372547002.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(488433109829708717.4903)
,p_validation_name=>'P3030_REPORT_QUERY valid'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_ws_security.is_valid_sql (',
'    p_ws_app_id  => :WS_APP_ID,',
'    p_type       => ''QUERY'', ',
'    p_sql        => :P3030_REPORT_QUERY);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Fehler'
,p_validation_condition=>'P3030_REPORT_QUERY'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_api.id(185411030124532674.4903)
,p_associated_item=>wwv_flow_api.id(185415320372547002.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488417406806414517.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save report query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_ws_rpt_query (',
'    p_flow_id        => :app_id,',
'    p_worksheet_id   => :P3030_WORKSHEET_ID,',
'    p_websheet_id    => :P3030_WEBSHEET_ID,',
'    p_owner          => :P3030_REPORT_OWNER,',
'    p_query          => :P3030_REPORT_QUERY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_api.id(185411030124532674.4903)
,p_process_when=>'SAVE_QUERY'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(488425920068550834.4903)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get report attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select sql_query',
'from wwv_flow_worksheets',
'where id = :p3030_worksheet_id',
'and security_group_id = :flow_security_group_id)',
'loop',
'    :P3030_REPORT_QUERY := c1.sql_query;',
'end loop;',
'',
'for c1 in (select id, ws_report_owner, websheet_name',
'           from wwv_flow_ws_websheet_attr',
'           where worksheet_id = :P3030_WORKSHEET_ID',
'           and security_group_id = :flow_security_group_id)',
'loop',
'    :P3030_WEBSHEET_ID := c1.id;',
'    :P3030_REPORT_OWNER := c1.ws_report_owner;',
'    :P3030_REPORT_NAME := c1.websheet_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/pages/page_03040
begin
wwv_flow_api.create_page(
 p_id=>3040.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Berichtsspalten ausw\00E4hlen')
,p_step_title=>unistr('Berichtsspalten ausw\00E4hlen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function apex_p3040_passBack(x){$v_PopupReturn(x,$v(''P3040_CALLING_ITEM''));}',
'</script>'))
,p_step_template=>wwv_flow_api.id(134255203486851095.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185537424894504064.4903)
,p_plug_name=>unistr('Spaltenwert ausw\00E4hlen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(82536903857665765.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3040_WEBSHEET_ID != ''0'' then',
'  sys.htp.p(''<table>'');',
'  for c1 in (select c.db_column_name',
'            from wwv_flow_worksheet_columns c,',
'                 wwv_flow_worksheets ir,',
'                 wwv_flow_ws_websheet_attr ws',
'            where c.worksheet_id = ir.id',
'            and ir.id = ws.worksheet_id ',
'            and ws.id = :P3040_WEBSHEET_ID           ',
'            and c.security_group_id = :flow_security_group_id)',
'  loop',
'   sys.htp.prn(''<tr><td>'');',
'   sys.htp.prn(''<a href="javascript:apex_p3040_passBack(''||wwv_flow_escape.js_literal(''#''||c1.db_column_name||''#'')||',
'               '');">#''||',
'               wwv_flow_escape.html(c1.db_column_name)||',
'               ''#</a>'');',
'   sys.htp.prn(''</td></tr>'');',
'  end loop;',
'  sys.htp.p(''</table>'');',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185538127157514025.4903)
,p_name=>'P3040_CALLING_ITEM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(185537424894504064.4903)
,p_prompt=>'Calling Item'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185541005003583271.4903)
,p_name=>'P3040_WEBSHEET_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(185537424894504064.4903)
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_03050
begin
wwv_flow_api.create_page(
 p_id=>3050.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Name der Berichtspalte ausw\00E4hlen')
,p_step_title=>unistr('Name der Berichtspalte ausw\00E4hlen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function apex_p3050_passBack(x){$v_PopupReturn(x,$v(''P3050_CALLING_ITEM''));}',
'</script>'))
,p_step_template=>wwv_flow_api.id(134255203486851095.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(185594710007975364.4903)
,p_plug_name=>'Pick Column Name'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3050_WEBSHEET_ID != ''0'' then',
'  sys.htp.p(''<table>'');',
'  for c1 in (select c.db_column_name',
'            from wwv_flow_worksheet_columns c,',
'                 wwv_flow_worksheets ir,',
'                 wwv_flow_ws_websheet_attr ws',
'            where c.worksheet_id = ir.id',
'            and ir.id = ws.worksheet_id ',
'            and ws.id = :P3050_WEBSHEET_ID           ',
'            and c.security_group_id = :flow_security_group_id)',
'  loop',
'   sys.htp.prn(''<tr><td>'');',
'   sys.htp.prn(''<a href="javascript:apex_p3050_passBack(''||wwv_flow_escape.js_literal(c1.db_column_name)||'');">''||',
'               wwv_flow_escape.html(c1.db_column_name)||''</a>'');',
'   sys.htp.prn(''</td></tr>'');',
'  end loop;',
'  sys.htp.p(''</table>'');',
'else',
'  sys.htp.p(wwv_flow_lang.system_message(''WS_SELECT_RPT_NAME''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185594125688975362.4903)
,p_name=>'P3050_CALLING_ITEM'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'Calling Item'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(185594321763975362.4903)
,p_name=>'P3050_WEBSHEET_ID'
,p_item_sequence=>30
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'Worksheet Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_03060
begin
wwv_flow_api.create_page(
 p_id=>3060.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('\00C4nderung der Berichtsabfrage best\00E4tigen')
,p_step_title=>unistr('\00C4nderung der Berichtsabfrage best\00E4tigen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(110987702383902978.4903)
,p_plug_name=>'Registerkartennavigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>5
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_api.id(491741626522063565.4903)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_api.id(20455926267312733.4903)
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188054305544420912.4903)
,p_plug_name=>unistr('\00C4nderung der Berichtsabfrage best\00E4tigen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.change_ws_rpt_query (',
'    p_worksheet_id    => :P3030_WORKSHEET_ID,',
'    p_websheet_id     => :P3030_WEBSHEET_ID,',
'    p_new_owner       => :P3030_REPORT_OWNER,',
'    p_new_source      => :P3030_REPORT_QUERY',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(188056301183504793.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188055415681480642.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(110987702383902978.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:3030:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(188055631264485071.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(110987702383902978.4903)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(188055831101485071.4903)
,p_branch_action=>'f?p=&FLOW_ID.:3000:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(188055631264485071.4903)
,p_branch_sequence=>10
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(188057931143551345.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process query change'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.save_ws_rpt_query (',
'    p_flow_id        => :app_id,',
'    p_worksheet_id   => :P3030_WORKSHEET_ID,',
'    p_websheet_id    => :P3030_WEBSHEET_ID,',
'    p_owner          => :P3030_REPORT_OWNER,',
'    p_query          => :P3030_REPORT_QUERY',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Berichtsabfrage konnte nicht ge\00E4ndert werden.')
,p_process_success_message=>unistr('Berichtsabfrage erfolgreich ge\00E4ndert.')
);
end;
/
prompt --application/pages/page_04020
begin
wwv_flow_api.create_page(
 p_id=>4020.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Anhang hinzuf\00FCgen')
,p_step_title=>unistr('Anhang hinzuf\00FCgen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_error_handling_function=>'wwv_flow_ws_api.ws_error_handling'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20790717309619678.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20878803839618770.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_ADD_FILE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251393723239865407.4903)
,p_plug_name=>unistr('Datei hinzuf\00FCgen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251393904618865407.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20790717309619678.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(473453311118850995.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20790717309619678.4903)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>unistr('Datei hinzuf\00FCgen und erneut hinzuf\00FCgen')
,p_button_position=>'CREATE'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251394102592865409.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20790717309619678.4903)
,p_button_name=>'APPLY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('Datei hinzuf\00FCgen')
,p_button_position=>'NEXT'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(473453720468853665.4903)
,p_branch_action=>'f?p=&APP_ID.:4020:&SESSION.::&DEBUG.:4020::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_api.id(473453311118850995.4903)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(251395308079865414.4903)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(251395932504876897.4903)
,p_name=>'P4020_FILE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(251393723239865407.4903)
,p_prompt=>'Datei'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Klicken Sie auf "Durchsuchen", um die hochzuladende Datei zu suchen. Nachdem sie hochgeladen wurde, wird die Datei mit der aktuellen Seite verkn\00FCpft. Sie k\00F6nnen diese Datei auf einer beliebigen Seite mit dem Image oder der Dateisyntax referenzieren. ')
||'Weitere Informationen finden Sie unter "Hilfe, Markup-Syntax".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(251396113242880805.4903)
,p_name=>'P4020_DESCRIPTION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(251393723239865407.4903)
,p_prompt=>'Beschreibung'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_colspan=>2
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Beschreibender Text der Datei.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(456475900674575808.4903)
,p_name=>'P4020_ALIAS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(251393723239865407.4903)
,p_prompt=>'Alias'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>unistr('F\00FCr das Einbetten von Links oder Imagelinks in Seitenabschnitte kann ein Dateialiasname verwendet werden. Ein Dateialiasname muss in der Anwendung eindeutig sein.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2076978944040014529.4903)
,p_validation_name=>'P4020_ALIAS is valid'
,p_validation_sequence=>10
,p_validation=>'P4020_ALIAS'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'Alias muss alphanumerisch sein.'
,p_validation_condition=>'P4020_ALIAS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(456475900674575808.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_validation(
 p_id=>wwv_flow_api.id(2077293492808609127.4903)
,p_validation_name=>'P4020_ALIAS must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_ws_api.alias_exists (',
'    p_ws_app_id    => :ws_app_id,',
'    p_alias        => :P4020_ALIAS,',
'    p_alias_type   => ''FILE'') then',
'    return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Alias bereits vorhanden. Geben Sie einen anderen Alias ein.'
,p_validation_condition=>'P4020_ALIAS'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_api.id(456475900674575808.4903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(251395126307865413.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add attachment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_attachment.add_doc (',
'    p_ws_app_id       => :WS_APP_ID,',
'    p_webpage_id      => :p900_id,   ',
'    p_image_alias     => :P4020_ALIAS,',
'    p_component_level => ''WEBPAGE'',',
'    p_file_name       => :P4020_FILE,',
'    p_desc            => :P4020_DESCRIPTION',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>unistr('Datei hinzugef\00FCgt.')
);
end;
/
prompt --application/pages/page_04030
begin
wwv_flow_api.create_page(
 p_id=>4030.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Hinweis hinzuf\00FCgen')
,p_step_title=>unistr('Hinweis hinzuf\00FCgen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20882615492688428.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_ADD_NOTE''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20883724281700421.4903)
,p_plug_name=>'Toolbar Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20884309521705583.4903)
,p_plug_name=>'hidden items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251516429483720502.4903)
,p_plug_name=>unistr('Hinweis hinzuf\00FCgen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251516617287720504.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20883724281700421.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251516819982720505.4903)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_api.id(20883724281700421.4903)
,p_button_name=>'ADD_NOTE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('Hinweis hinzuf\00FCgen')
,p_button_position=>'CREATE'
,p_button_condition=>'P4030_NOTE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(214982205129183371.4903)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_api.id(20883724281700421.4903)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'CREATE'
,p_button_condition=>'P4030_NOTE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(214904430494171722.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20883724281700421.4903)
,p_button_name=>'DELETE_NOTE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15160928947568323.4903)
,p_button_image_alt=>unistr('L\00F6schen')
,p_button_position=>'DELETE'
,p_button_condition=>'P4030_NOTE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(251518406893720511.4903)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(251517232428720506.4903)
,p_name=>'P4030_NOTE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_api.id(251516429483720502.4903)
,p_prompt=>'Hinweis'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>7
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461206197401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>unistr('Geben Sie f\00FCr diese Seite einen Hinweis ein. Hinweise werden auf der Seite rechts angezeigt.')
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(253723108268462838.4903)
,p_name=>'P4030_NOTE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(20884309521705583.4903)
,p_prompt=>'Note Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(251518217690720510.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.add_note (',
'    p_ws_app_id        => :ws_app_id,        ',
'    p_webpage_id       => :p900_id,',
'    p_note_id          => :P4030_NOTE_ID,',
'    p_component_level  => ''WEBPAGE'',',
'    p_content          => :P4030_NOTE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Hinweis konnte nicht hinzugef\00FCgt werden.')
,p_process_when=>'ADD_NOTE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Aktion wurde verarbeitet.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(215084317035196189.4903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.delete_note (',
'    p_note_id   => :P4030_NOTE_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Hinweis kann nicht gel\00F6scht werden.')
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_api.id(214904430494171722.4903)
,p_process_success_message=>unistr('Hinweis gel\00F6scht.')
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253737509634661968.4903)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch note'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_note (',
'    p_note_id     => :P4030_NOTE_ID,',
'    p_content     => :P4030_NOTE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Hinweis konnte nicht abgerufen werden.'
,p_process_when=>'P4030_NOTE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
);
end;
/
prompt --application/pages/page_04040
begin
wwv_flow_api.create_page(
 p_id=>4040.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>unistr('Tag hinzuf\00FCgen')
,p_step_title=>unistr('Tag hinzuf\00FCgen')
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_api.id(10606007362285088.4903)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20868614519517826.4903)
,p_plug_name=>unistr('Symbolleistenschaltfl\00E4chen')
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(10604720260269861.4903)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(20877305655600370.4903)
,p_plug_name=>'Custom Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_ui.show_breadcrumbs (',
'    p_ws_app_id            => :WS_APP_ID,    ',
'    p_app_session          => :APP_SESSION,',
'    p_page_id              => :P900_ID,',
'    p_image_prefix         => ''#IMAGE_PREFIX#'',   ',
'    p_current_entry        => wwv_flow_lang.system_message(''WS_ADD_TAGS''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(251519704381725094.4903)
,p_plug_name=>'Tags'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(20185117556737935.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251519921019725094.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(20868614519517826.4903)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15106902867837483.4903)
,p_button_image_alt=>'Abbrechen'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4900_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(6745321058737106.4903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_api.id(20868614519517826.4903)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('\00C4nderungen anwenden')
,p_button_position=>'EDIT'
,p_button_condition=>'P4040_TAGS'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(251520114489725096.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(20868614519517826.4903)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(15108012910840408.4903)
,p_button_image_alt=>unistr('Tags hinzuf\00FCgen')
,p_button_position=>'NEXT'
,p_button_condition=>'P4040_TAGS'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(251521725759725101.4903)
,p_branch_action=>'f?p=&APP_ID.:900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(251520522894725097.4903)
,p_name=>'P4040_TAGS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(251519704381725094.4903)
,p_prompt=>'Tags'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'LEFT-TOP'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Geben Sie eine durch Komma getrennte Liste der Tags ein, um den Content der Seite zu beschreiben.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(251521511042725100.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add tags'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.add_tags (   ',
'    p_ws_app_id       => :ws_app_id,',
'    p_webpage_id       => :p900_id,    ',
'    p_component_level => ''WEBPAGE'',',
'    p_tag             => :P4040_TAGS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>unistr('Tags konnten nicht hinzugef\00FCgt werden.')
,p_process_success_message=>'Aktion wurde verarbeitet.'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(253748202165170647.4903)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch tags'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.fetch_tag (',
'    p_webpage_id  => :p900_id,',
'    --',
'    p_tags        => :P4040_TAGS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Die Tags konnten nicht abgerufen werden.'
);
end;
/
prompt --application/pages/page_08000
begin
wwv_flow_api.create_page(
 p_id=>8000.4903
,p_user_interface_id=>wwv_flow_api.id(4968616267302342.4903)
,p_name=>'Suche'
,p_step_title=>'Suchen'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function loadSearchResultsField () {',
'    searchVal = apex.item( "P8000_SEARCH" ).getValue() ;',
'    apex.item( "searchResultField" ).setValue( searchVal );',
'	}',
'',
'function setSearchField () {',
'    searchVal = apex.item( "searchResultField" ).getValue();',
'    apex.item( "P8000_SEARCH" ).setValue( searchVal );',
'    apex.submit();',
'}'))
,p_javascript_code_onload=>'loadSearchResultsField();'
,p_step_template=>wwv_flow_api.id(9297021464956579.4903)
,p_page_template_options=>'#DEFAULT#'
,p_page_is_public_y_n=>'Y'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178724809760390978.4903)
,p_plug_name=>'Action Bar'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_api.id(25109627701530900.4903)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="searchField">',
'	<span class="searchIcon">',
'		<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'	</span>',
'	<input type="text" id="searchResultField" style="width: 320px" />',
'	<a href="javascript:setSearchField()" class="wsSmallButton">Suchen</a>',
'</div>'))
,p_translate_title=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178725914740401832.4903)
,p_plug_name=>'Suchen'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(9299916504097072.4903)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>unistr('<p>Durchsuchen des Anwendungsinhalts ohne Beachtung der Gro\00DF-/Kleinschreibung.</p>')
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(82394800610655307.4903)
,p_plug_name=>unistr('Container f\00FCr Such-Formularregion')
,p_parent_plug_id=>wwv_flow_api.id(178725914740401832.4903)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_api.id(82536903857665765.4903)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attribute_01=>'N'
,p_attribute_02=>'HTML'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(178835419032288635.4903)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_menu_id=>wwv_flow_api.id(78897017520604216.4903)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_api.id(20175617163709368.4903)
,p_translate_title=>'N'
);
wwv_flow_api.create_page_plug(
 p_id=>wwv_flow_api.id(468391404114503393.4903)
,p_plug_name=>'Search Results'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_plug_new_grid=>true
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       d001 updated_on,',
'       d002 created_on,',
'       c001 foundin, ',
'       c002 page_title, ',
'       c003 section, ',
'       c004 context, ',
'       c005 view_link,',
'       lower(c006) updated_by,',
'       lower(c007) created_by',
'from wwv_flow_collections',
'where collection_name = ''APEX$_WS_SEARCH'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_api.create_worksheet(
 p_id=>wwv_flow_api.id(468391524383503393.4903)
,p_name=>'Search Results'
,p_max_row_count=>'10000'
,p_max_row_count_message=>unistr('Diese Abfrage gibt mehr als 10.000 Zeilen zur\00FCck. Filtern Sie die Daten, um vollst\00E4ndige Ergebnisse zu gew\00E4hrleisten.')
,p_no_data_found_message=>'Keine Daten gefunden.'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_search_bar=>'N'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468391711981503406.4903)
,p_db_column_name=>'UPDATED_ON'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Aktualisiert'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468391829105503408.4903)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Erstellt'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468392001076503409.4903)
,p_db_column_name=>'PAGE_TITLE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Name des Inhalts'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468392131811503409.4903)
,p_db_column_name=>'SECTION'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Abschnitt'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468392202634503409.4903)
,p_db_column_name=>'CONTEXT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Kontext'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468392314796503410.4903)
,p_db_column_name=>'VIEW_LINK'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Link anzeigen'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468397610140582784.4903)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Aktualisiert von'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(468397729488582785.4903)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Erstellt von'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_worksheet_column(
 p_id=>wwv_flow_api.id(472218111753286824.4903)
,p_db_column_name=>'FOUNDIN'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Gefunden in'
,p_column_link=>'#VIEW_LINK#'
,p_column_linktext=>'#FOUNDIN#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(178725326383395767.4903)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_api.id(178724809760390978.4903)
,p_button_name=>'P8000_GO'
,p_button_static_id=>'P8000_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20480423759330923.4903)
,p_button_image_alt=>'Suchen'
,p_button_alignment=>'LEFT'
,p_button_condition_type=>'NEVER'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_api.create_page_button(
 p_id=>wwv_flow_api.id(468398002091599375.4903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_api.id(178724809760390978.4903)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_api.id(20457218105321816.4903)
,p_button_image_alt=>unistr('Zur\00FCcksetzen')
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:8000:&SESSION.::&DEBUG.:8000,RIR::'
);
wwv_flow_api.create_page_branch(
 p_id=>wwv_flow_api.id(178725512447395769.4903)
,p_branch_action=>'f?p=&FLOW_ID.:8000:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(178725118764393563.4903)
,p_name=>'P8000_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_api.id(178724809760390978.4903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_api.create_page_item(
 p_id=>wwv_flow_api.id(468377826791114568.4903)
,p_name=>'P8000_SEARCHABLE_COMPONENTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_api.id(82394800610655307.4903)
,p_item_default=>'Page name:Page alias:Page description:Section title:Section content:File:Tags:Notes:Data grid'
,p_prompt=>'Durchsuchbarer Content'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'SEARCHABLE COMPONENTS'
,p_lov=>'.'||wwv_flow_api.id(468375932547106712.4903)||'.'
,p_label_alignment=>'ABOVE'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_api.id(11461002620401386.4903)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Gibt den Inhalt an, der durchsucht werden soll'
,p_attribute_01=>'1'
);
wwv_flow_api.create_page_process(
 p_id=>wwv_flow_api.id(468388807388383301.4903)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create search result collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ws_api.create_search_collection (',
'    p_search  => :P8000_SEARCH,',
'    p_security_group_id=>:flow_security_group_id,',
'    p_ws_app_id=>:WS_APP_ID,',
'    p_max_row_count=>1000,',
'    p_searchable_components=>:P8000_SEARCHABLE_COMPONENTS,',
'    p_app_session => :app_session);'))
,p_process_clob_language=>'PLSQL'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
