prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4491
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4491 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4491
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116101653276403497')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'el'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4491)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113350'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4491)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4491)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4491)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4491)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4491)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4491)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4491)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4491)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4491)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4491)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4491)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4491)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4491)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.el'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4491
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4491)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4491)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4491)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4491)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4491)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4491)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4491)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.el'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4491
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4491)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4491)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4491)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4491)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4491)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4491)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4491)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.el'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4491
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4491)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4491)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4491)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4491)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4491)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4491)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4491)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4491)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4491)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4491)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4491)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4491)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4491)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4491)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4491)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4491)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4491)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.el'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4491
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4491)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4491)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4491)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4491)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4491)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4491)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4491)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4491)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4491)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4491)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4491)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4491)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4491)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4491)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4491)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.el'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4491
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4491)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4491)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4491)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4491)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4491)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4491)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4491)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4491)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4491)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4491)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4491)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4491)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4491)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4491)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4491)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.el'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4491
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4491)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4491)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4491)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4491)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4491)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4491)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4491)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4491)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4491)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4491)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4491)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4491)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4491)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4491)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4491)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.el'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4491
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4491)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4491)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4491)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4491)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4491)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4491)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4491)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4491)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4491)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4491)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4491)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4491)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4491)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4491)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4491)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4491
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4491)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4491
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4491)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4491
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4491)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4491
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4491)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4491
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4491)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4491
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4491)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4491
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4491)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4491)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4491
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4491)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4491)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4491)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4491)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4491)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4491)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4491)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4491)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4491)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4491
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4491)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4491)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4491)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4491
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4491)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4491)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4491)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4491)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4491)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4491)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4491)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4491)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4491)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4491)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4491
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4491)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4491)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4491)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4491)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4491)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4491
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4491)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4491)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4491)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4491)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4491)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4491)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4491)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4491
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4491)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4491)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4491)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4491)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4491)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4491
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4491)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4491)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4491)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4491)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4491)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4491
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4491)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4491)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4491)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4491)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4491)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4491)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4491)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4491)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4491)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4491
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4491)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4491)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4491
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4491)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4491)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4491)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4491)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4491)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4491
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4491)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4491
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4491)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4491
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4491)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4491
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4491)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4491
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4491)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4491
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4491)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4491)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4491)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4491)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4491)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4491)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4491)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4491)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4491)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4491
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4491)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4491)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4491)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4491)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4491)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4491)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4491)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4491
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4491)
,p_page_name=>'winlov'
,p_page_title=>unistr('\03A0\03BB\03B1\03AF\03C3\03B9\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7')
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>unistr('\039A\03BB\03B5\03AF\03C3\03B9\03BC\03BF')
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF &gt;')
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>unistr('&lt; \03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF')
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>unistr('<div class="a-PopupLOV-pagination">\03A3\03B5\03B9\03C1\03AC(-\03AD\03C2) #FIRST_ROW# - #LAST_ROW#</div>')
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4491
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4491)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4491
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4491)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4491)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4491)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4491)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4491)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4491)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4491)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4491)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4491)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4491)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4491)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4491)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4491)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4491)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4491)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4491)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4491)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4491)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4491)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4491)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4491)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4491)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4491)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4491)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4491)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4491)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4491)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4491)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4491)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4491)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4491)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4491)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4491)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4491)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4491)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4491)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4491)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4491)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4491)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4491)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4491)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4491)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4491)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4491)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4491)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4491)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4491)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4491)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4491)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4491)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4491)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4491)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4491)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4491)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4491)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4491)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4491)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4491)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4491)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4491)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4491)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4491)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4491)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4491)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4491)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4491)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4491)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4491)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4491)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4491)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4491)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4491)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4491)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4491)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4491)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4491)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4491)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4491)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4491)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4491)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4491)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4491)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4491)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4491)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4491)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4491)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4491)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4491)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4491)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4491)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4491)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4491)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4491)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4491)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4491)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4491)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4491)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4491)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4491)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4491)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4491)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4491)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4491)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4491)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4491)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4491)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4491)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4491)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4491)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4491)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4491)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4491)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4491)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4491)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4491)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4491)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4491)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4491)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4491)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4491)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4491)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4491)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4491)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4491)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4491)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4491)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4491)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4491)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4491)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4491)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4491)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4491)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4491)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4491)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4491)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4491)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4491)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4491)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4491)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4491)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4491)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4491)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4491)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4491)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4491)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4491)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4491)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4491)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4491)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4491)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4491)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4491)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4491)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4491)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4491)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4491)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4491)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4491)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4491)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4491)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4491)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4491)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4491)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4491)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4491)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4491)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4491)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4491)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4491)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4491)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4491)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4491)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4491)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4491)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4491)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4491)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4491)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4491)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4491)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4491)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4491)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4491)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4491)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4491)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4491)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4491)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4491)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4491)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4491)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4491)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4491)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4491)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4491)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4491)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4491)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111273661973399261)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B7 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111260737864399251)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111260600095399251)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BD\03BF\03BC\03B1 \03C7\03C1\03AE\03C3\03C4\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111317987746399293)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03C4\03B1\03B9 \03B7 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111277617890399264)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BB\03BF\03B3\03B1\03C1\03B9\03B1\03C3\03BC\03CC\03C2 \03C3\03B1\03C2 %0 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03B8\03B7\03BA\03B5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111263258272399253)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BB\03BF\03B3\03B1\03C1\03B9\03B1\03C3\03BC\03CC\03C2 \03B5\03AF\03BD\03B1\03B9 \03BA\03BB\03B5\03B9\03B4\03C9\03BC\03AD\03BD\03BF\03C2.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111253127772399246)
,p_name=>'AM_PM'
,p_message_language=>'el'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111387588043399343)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B1\03BB\03BB\03B1\03B3\03AE %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111395650838399350)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'el'
,p_message_text=>unistr('(\0395\03BD\03B5\03C1\03B3\03CC)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111365120552399327)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BA\03BB\03AE\03C3\03B7 Ajax \03B5\03C0\03AD\03C3\03C4\03C1\03B5\03C8\03B5 \03C4\03BF \03C3\03C6\03AC\03BB\03BC\03B1 server %0 \03B3\03B9\03B1 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111295958049399277)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03BF \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 "%0" \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03BC\03B5\03C4\03B1\03C4\03C1\03B1\03C0\03B5\03AF \03C3\03B5 \03BC\03BF\03BD\03B1\03B4\03B9\03BA\03CC \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111296068447399277)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03BC\03B5 \03C4\03BF \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03BF "%0" \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111285652098399269)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-1816 \03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03BC\03B7 \03B1\03BD\03B1\03BC\03B5\03BD\03CC\03BC\03B5\03BD\03BF \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7 \03BC\03B5\03C4\03B1\03C4\03C1\03BF\03C0\03AE \03C4\03BF\03C5 \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03BF\03C5 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111378542743399337)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03C0\03B1\03C1\03AD\03C7\03B5\03B9 \03AD\03BD\03B1\03BD \03B5\03CD\03BA\03BF\03BB\03BF \03C4\03C1\03CC\03C0\03BF \03B3\03B9\03B1 \03BD\03B1 \03C0\03C1\03BF\03C3\03B4\03B9\03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03B1\03BD \03B7 \03AF\03B4\03B9\03B1 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03AD\03C7\03B5\03B9 \03B1\03BD\03B1\03C0\03C4\03C5\03C7\03B8\03B5\03AF \03C3\03B5 \03C7\03CE\03C1\03BF\03C5\03C2 \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2. \039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03C3\03C5\03B3\03BA\03C1\03AF\03BD\03B5\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03B3\03B9\03B1 \03BD\03B1 \03B4\03B5\03AF\03C4\03B5 \03B1\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03B1\03BD\03C4\03B9\03C3\03C4\03BF\03AF\03C7\03B9\03C3\03B7. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111271456702399259)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C4\03B1\03C5\03C4\03CC\03C4\03B7\03C4\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111256885499399249)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C4\03B1\03C5\03C4\03CC\03C4\03B7\03C4\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111420378911399368)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03CC\03BD\03BF\03BC\03B1 \03BC\03B9\03C3\03B8\03C9\03C4\03AE %0 \03C0\03BF\03C5 \03B5\03C0\03B9\03C3\03C4\03C1\03AC\03C6\03B7\03BA\03B5 \03B1\03C0\03CC \03C4\03BF Oracle Cloud Identity Management \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B5\03BE\03BF\03C5\03C3\03B9\03BF\03B4\03BF\03C4\03B7\03BC\03AD\03BD\03BF \03B3\03B9\03B1 \03C4\03BF\03BD \03C4\03BF\03BC\03AD\03B1 %1!<br/><a href="&LOGOUT_URL.">\03A3\03C5\03BD\03B4\03B5\03B8\03B5\03AF\03C4\03B5 \03BE\03B1\03BD\03AC</a> \03BA\03B1\03B9 \03BA\03B1\03B8\03BF\03C1\03AF\03C3\03C4\03B5 \03AD\03BD\03B1 \03B5\03BE\03BF\03C5\03C3\03B9\03BF\03B4\03BF\03C4\03B7\03BC\03AD\03BD\03BF \03CC\03BD\03BF\03BC\03B1 \03BC\03B9\03C3\03B8\03C9\03C4\03AE \03AE \03B1\03BB\03BB\03AC\03BE\03C4\03B5 \03C4\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111254587879399247)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BB\03BF\03B3\03B1\03C1\03B9\03B1\03C3\03BC\03CC\03C2 \03C3\03B1\03C2 "%0" \03B4\03B5\03BD \03B4\03B9\03B1\03B8\03AD\03C4\03B5\03B9 \03C4\03B1 \03B1\03C0\03B1\03C1\03B1\03AF\03C4\03B7\03C4\03B1 \03B4\03B9\03BA\03B1\03B9\03CE\03BC\03B1\03C4\03B1 \03B1\03BD\03AC\03C0\03C4\03C5\03BE\03B7\03C2 (DB_DEVELOPER \03AE DB_ADMINISTRATOR)<br/>\03B3\03B9\03B1 \03C4\03BF\03BD \03C7\03CE\03C1\03BF \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 "%1"! <a href="&LOGOUT_URL.">\03A3\03C5\03BD\03B4\03B5\03B8\03B5\03AF\03C4\03B5 \03BE\03B1\03BD\03AC</a> \03BC\03B5\03C4\03AC \03C4\03B7\03BD \03B5\03BA\03C7\03CE\03C1\03B7\03C3\03B7 \03C4\03C9\03BD \03B4\03B9\03BA\03B1\03B9\03C9\03BC\03AC\03C4\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111253664067399246)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03CC\03BD\03BF\03BC\03B1 \03BC\03B9\03C3\03B8\03C9\03C4\03AE \03C0\03BF\03C5 \03B5\03C0\03B9\03C3\03C4\03C1\03AC\03C6\03B7\03BA\03B5 \03B1\03C0\03CC \03C4\03BF Oracle Cloud Identity Management \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B5\03BE\03BF\03C5\03C3\03B9\03BF\03B4\03BF\03C4\03B7\03BC\03AD\03BD\03BF \03B3\03B9\03B1 \03C4\03BF\03BD \03C4\03C1\03AD\03C7\03BF\03BD\03C4\03B1 \03C7\03CE\03C1\03BF \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2!<br/><a href="&LOGOUT_URL.">\03A3\03C5\03BD\03B4\03B5\03B8\03B5\03AF\03C4\03B5 \03BE\03B1\03BD\03AC</a> \03BA\03B1\03B9 \03BA\03B1\03B8\03BF\03C1\03AF\03C3\03C4\03B5 \03AD\03BD\03B1 \03B5\03BE\03BF\03C5\03C3\03B9\03BF\03B4\03BF\03C4\03B7\03BC\03AD\03BD\03BF \03CC\03BD\03BF\03BC\03B1 \03BC\03B9\03C3\03B8\03C9\03C4\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111254698560399247)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03B9\03B1 \03BB\03CC\03B3\03BF\03C5\03C2 \03B1\03C3\03C6\03AC\03BB\03B5\03B9\03B1\03C2, \03B4\03B5\03BD \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03C4\03B1\03B9 \03B7 \03B5\03BA\03C4\03AD\03BB\03B5\03C3\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03B1\03C5\03C4\03BF\03CD \03C4\03BF\03C5 \03C7\03CE\03C1\03BF\03C5 \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 \03BC\03AD\03C3\03C9 \03C4\03BF\03C5 \03C4\03BF\03BC\03AD\03B1 \03C3\03C4\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111271164674399259)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'el'
,p_message_text=>unistr('\0396\03B7\03C4\03AE\03C3\03C4\03B5 \03B1\03C0\03CC \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE \03B2\03AC\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C3\03B1\03C2 \03BD\03B1 \03B5\03BA\03C4\03B5\03BB\03AD\03C3\03B5\03B9 \03C4\03BF $OH/rdbms/admin/catldap.sql.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111271038993399259)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C0\03B1\03BA\03AD\03C4\03BF SYS.DBMS_LDAP \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03AE \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03BF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111270997922399259)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7\03C2 \03C7\03C1\03AE\03C3\03C4\03B7 LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111271279889399259)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03BF\03C5 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C4\03B1\03C5\03C4\03CC\03C4\03B7\03C4\03B1\03C2 LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111272055703399260)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03C3\03C4\03BF \03CC\03C1\03B9\03C3\03BC\03B1 p_flow_page \03C3\03C4\03B7 \03B4\03B9\03B1\03B4\03B9\03BA\03B1\03C3\03AF\03B1 login_page.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111271622898399259)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03BF p_session in wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111319522914399294)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03C1\03B9\03C3\03BC\03B1 \03BC\03B5 \03B5\03C3\03C6\03B1\03BB\03BC\03AD\03BD\03B7 \03BC\03BF\03C1\03C6\03AE \03C3\03C4\03BF wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111271720406399259)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03B2\03B9\03B2\03AC\03C3\03C4\03B7\03BA\03B5 \03CC\03BD\03BF\03BC\03B1 \03C7\03C1\03AE\03C3\03C4\03B7 \03BC\03B5 \03C4\03B9\03BC\03AE null \03C3\03C4\03B7 \03B4\03B9\03B1\03B4\03B9\03BA\03B1\03C3\03AF\03B1 \03C3\03CD\03BD\03B4\03B5\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111260587075399251)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03BC\03AD\03BD\03B5\03C4\03B5 <span id="apex_login_throttle_sec">%0</span> \03B4\03B5\03C5\03C4\03B5\03C1\03CC\03BB\03B5\03C0\03C4\03B1 \03B3\03B9\03B1 \03BD\03B1 \03C3\03C5\03BD\03B4\03B5\03B8\03B5\03AF\03C4\03B5 \03BE\03B1\03BD\03AC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111261807071399252)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03C1\03BF\03C3\03C0\03AC\03B8\03B5\03B9\03B1 \03C3\03CD\03BD\03B4\03B5\03C3\03B7\03C2 \03B1\03C0\03BF\03BA\03BB\03B5\03AF\03C3\03C4\03B7\03BA\03B5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111317381819399292)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03AD\03BB\03B5\03B3\03C7\03BF\03C2 \03C4\03B1\03C5\03C4\03CC\03C4\03B7\03C4\03B1\03C2 "%0" \03B4\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111262150191399252)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C4\03B7\03C2 \03BF\03BC\03AC\03B4\03B1\03C2 \03B1\03C3\03C6\03AC\03BB\03B5\03B9\03B1\03C2 \03B5\03AF\03BD\03B1\03B9 null.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111271567040399259)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03BA\03C4\03AD\03BB\03B5\03C3\03B7 \03C4\03B7\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03BC\03B5\03C4\03AD\03C0\03B5\03B9\03C4\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C4\03B1\03C5\03C4\03CC\03C4\03B7\03C4\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111271335205399259)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03C0\03C1\03BF\03BA\03B1\03C4\03B1\03C1\03BA\03C4\03B9\03BA\03BF\03CD \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C4\03B1\03C5\03C4\03CC\03C4\03B7\03C4\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111272532689399260)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0391\03BD\03BF\03AF\03BE\03C4\03B5 \03C4\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2 \03C3\03C4\03BF \03AF\03B4\03B9\03BF \03C0\03C1\03CC\03B3\03C1\03B1\03BC\03BC\03B1 \03C0\03B5\03C1\03B9\03AE\03B3\03B7\03C3\03B7\03C2 \03C3\03C4\03BF \03BF\03C0\03BF\03AF\03BF \03BE\03B5\03BA\03B9\03BD\03AE\03C3\03B1\03C4\03B5 \03C4\03B7\03BD \03B1\03AF\03C4\03B7\03C3\03B7 \03B5\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BA\03C9\03B4\03B9\03BA\03BF\03CD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2. \0391\03BD \03BA\03AC\03BD\03B5\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\0394\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2 \03B5\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BA\03C9\03B4\03B9\03BA\03BF\03CD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2" \03BA\03B1\03B9 \03B1\03BD\03B1\03BA\03B1\03C4\03B5\03C5\03B8\03C5\03BD\03B8\03B5\03AF\03C4\03B5 \03C3\03C4\03B7'),
unistr('\03C3\03B5\03BB\03AF\03B4\03B1 \03C3\03CD\03BD\03B4\03B5\03C3\03B7\03C2, \03BE\03B5\03BA\03B9\03BD\03AE\03C3\03C4\03B5 \03BE\03B1\03BD\03AC \03C4\03B7 \03B4\03B9\03B1\03B4\03B9\03BA\03B1\03C3\03AF\03B1 \03B5\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BA\03C9\03B4\03B9\03BA\03BF\03CD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03BA\03B1\03B9 \03B1\03C6\03AE\03C3\03C4\03B5'),
unistr('\03B1\03BD\03BF\03B9\03C7\03C4\03CC \03C4\03BF \03C0\03C1\03CC\03B3\03C1\03B1\03BC\03BC\03B1 \03C0\03B5\03C1\03B9\03AE\03B3\03B7\03C3\03B7\03C2.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111417852525399366)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2 \03B5\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BA\03C9\03B4\03B9\03BA\03BF\03CD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111254882205399247)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BF\03BC\03AC\03B4\03B1 \03B4\03B9\03B5\03C1\03B3\03B1\03C3\03B9\03CE\03BD \03BA\03B1\03C4\03B1\03BD\03AC\03BB\03C9\03C3\03B7\03C2 %0 \03C4\03B7\03C2 \03B4\03B9\03B1\03C7\03B5\03AF\03C1\03B9\03C3\03B7\03C2 \03C0\03CC\03C1\03C9\03BD \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03B5\03BA\03C7\03C9\03C1\03B7\03B8\03B5\03AF \03C3\03C4\03BF %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111254990939399247)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03BF DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP \03B3\03B9\03B1 \03BD\03B1 \03B5\03BA\03C7\03C9\03C1\03AE\03C3\03B5\03C4\03B5 \03C4\03BF \03B4\03B9\03BA\03B1\03AF\03C9\03BC\03B1 \03C0\03BF\03C5 \03BB\03B5\03AF\03C0\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111282934341399268)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 sentry \03C0\03B5\03C1\03B9\03CC\03B4\03BF\03C5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111283088303399268)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B5\03C0\03B1\03BB\03AE\03B8\03B5\03C5\03C3\03B7\03C2 \03C0\03B5\03C1\03B9\03CC\03B4\03BF\03C5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111283274284399268)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'el'
,p_message_text=>unistr('\0396\03B7\03C4\03AE\03C3\03C4\03B5 \03B1\03C0\03CC \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE %0 \03C3\03B1\03C2 \03BD\03B1 \03B4\03B9\03B1\03BC\03BF\03C1\03C6\03CE\03C3\03B5\03B9 \03C4\03BF\03BD \03BC\03B7\03C7\03B1\03BD\03B9\03C3\03BC\03CC \03B3\03B9\03B1 \03C4\03B7\03BD \03BA\03B1\03B8\03BF\03BB\03B9\03BA\03AE \03C3\03CD\03BD\03B4\03B5\03C3\03B7 \03C4\03BF\03C5 Oracle Application Server.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111292769528399275)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03C3\03C4\03C1\03AC\03C6\03B7\03BA\03B5 \03BC\03B7 \03B1\03C0\03BF\03B4\03B5\03BA\03C4\03CC %0 \03C3\03C4\03BF \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03B9\03BA\03CC %1 \03B1\03C0\03CC \03C4\03BF sso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111271955737399260)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03C4\03B5\03AF\03C4\03B5 \03C4\03BF \03C3\03C7\03AE\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C4\03B1\03C5\03C4\03CC\03C4\03B7\03C4\03B1\03C2 \03BA\03B1\03B9 \03C0\03C1\03BF\03C3\03B8\03AD\03C3\03C4\03B5 \03C4\03BF \03CC\03BD\03BF\03BC\03B1 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111292428452399274)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03B1\03C0\03BF\03B4\03B5\03BA\03C4\03AE \03BA\03BB\03AE\03C3\03B7 \03C4\03B7\03C2 \03B4\03B9\03B1\03B4\03B9\03BA\03B1\03C3\03AF\03B1\03C2 %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111292640641399275)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C0\03B5\03C1\03AF\03BF\03B4\03BF\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03C3\03C4\03BF \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03B9\03BA\03CC urlc: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111292257835399274)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03C3\03C4\03BF portal_sso_redirect: \03BB\03B5\03AF\03C0\03BF\03C5\03BD \03C0\03BB\03B7\03C1\03BF\03C6\03BF\03C1\03AF\03B5\03C2 \03B5\03B3\03B3\03C1\03B1\03C6\03AE\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111283125613399268)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C0\03B1\03BA\03AD\03C4\03BF WWSEC_SSO_ENABLER_PRIVATE \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03AE \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03BF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111271874552399260)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03CD\03C1\03B5\03C3\03B7 \03C4\03BF\03C5 \03B5\03B3\03B3\03B5\03B3\03C1\03B1\03BC\03BC\03AD\03BD\03BF\03C5 \03BF\03BD\03CC\03BC\03B1\03C4\03BF\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03C3\03C5\03BD\03B5\03C1\03B3\03AC\03C4\03B7 \03C3\03C4\03BF \03C3\03C7\03AE\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C4\03B1\03C5\03C4\03CC\03C4\03B7\03C4\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111292391059399274)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03B1\03C7\03C9\03C1\03AF\03C3\03C4\03B5 \03B1\03C5\03C4\03AE\03BD \03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03CC\03C0\03C9\03C2 \03C0\03B5\03C1\03B9\03B3\03C1\03AC\03C6\03B5\03C4\03B1\03B9 \03C3\03C4\03BF\03BD \03BF\03B4\03B7\03B3\03CC \03B5\03B3\03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111283318955399268)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03BF\03C5 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C4\03B1\03C5\03C4\03CC\03C4\03B7\03C4\03B1\03C2 SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111392778883399347)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03B5\03BE\03BF\03C5\03C3\03B9\03BF\03B4\03BF\03C4\03B7\03BC\03AD\03BD\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2:  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111282776984399267)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03BF\03C5 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C4\03B1\03C5\03C4\03CC\03C4\03B7\03C4\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111254701498399247)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C7\03CE\03C1\03BF\03C2 \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 "%0" \03B5\03AF\03BD\03B1\03B9 \03B1\03BD\03B5\03BD\03B5\03C1\03B3\03CC\03C2. \0395\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE \03C3\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111255193326399247)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'el'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111261566507399252)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03B4\03B5\03BD \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03C4\03B1\03B9 \03B1\03C0\03CC \03C4\03BF\03BD \03AD\03BB\03B5\03B3\03C7\03BF \03B1\03C3\03C6\03AC\03BB\03B5\03B9\03B1\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111261686150399252)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03B4\03B5\03BD \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03C4\03B1\03B9 \03B1\03C0\03CC \03C4\03BF\03BD \03AD\03BB\03B5\03B3\03C7\03BF \03B1\03C3\03C6\03AC\03BB\03B5\03B9\03B1\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111261715961399252)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03BE\03BF\03C5\03C3\03B9\03BF\03B4\03CC\03C4\03B7\03C3\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111325198722399298)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03B8\03B7\03BA\03B5 \03BC\03B5 %0 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03CE\03BD\03C4\03B1\03C2 \03C4\03BF %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111325233925399298)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'el'
,p_message_text=>'love'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111383022338399340)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03B3\03C1\03B1\03C6\03AE \03C3\03C5\03BC\03B2\03AC\03BD\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111382807561399340)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1 \03BB\03AE\03BE\03B7\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111383105378399340)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C3\03C5\03BC\03B2\03AC\03BD\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111382729417399340)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1 \03AD\03BD\03B1\03C1\03BE\03B7\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111382955360399340)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03AF\03C4\03BB\03BF\03C2 \03C3\03C5\03BC\03B2\03AC\03BD\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111273584721399261)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C6\03AC\03BB\03BC\03B1 \03C0\03B5\03C1\03B9\03B5\03C7\03BF\03BC\03AD\03BD\03BF\03C5 \03B1\03B8\03C1\03BF\03AF\03C3\03BC\03B1\03C4\03BF\03C2 \03B5\03BB\03AD\03B3\03C7\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111273469651399261)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C6\03AC\03BB\03BC\03B1 \03BC\03BF\03C1\03C6\03AE\03C2 \03B1\03B8\03C1\03BF\03AF\03C3\03BC\03B1\03C4\03BF\03C2 \03B5\03BB\03AD\03B3\03C7\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111337446670399307)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03C4\03B9\03B3\03C1\03AC\03C6\03C4\03B7\03BA\03B5 \03C3\03C4\03BF \03C0\03C1\03CC\03C7\03B5\03B9\03C1\03BF.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111337187755399307)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03CC \03C4\03BF \03C0\03C1\03CC\03B3\03C1\03B1\03BC\03BC\03B1 \03C0\03B5\03C1\03B9\03AE\03B3\03B7\03C3\03B7\03C2 \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03B9 \03C4\03B7\03BD \03B1\03BD\03C4\03B9\03B3\03C1\03B1\03C6\03AE \03B1\03C0\03CC \03BA\03BF\03C5\03BC\03C0\03AF \03AE \03BC\03B5\03BD\03BF\03CD. \0394\03BF\03BA\03B9\03BC\03AC\03C3\03C4\03B5 \03C4\03BF\03BD \03C3\03C5\03BD\03B4\03C5\03B1\03C3\03BC\03CC \03C0\03BB\03AE\03BA\03C4\03C1\03C9\03BD Ctrl+C \03AE Command+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111325611380399299)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03BB\03B5\03AF\03C3\03B9\03BC\03BF \03B5\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111381609479399339)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03C4\03AF\03B8\03B5\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111376146538399335)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03C1\03AD\03C7\03BF\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111376052499399335)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C1\03C7\03B9\03BA\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111380289947399338)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B9\03BC\03AE \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03AD\03BD\03B1 \03AD\03B3\03BA\03C5\03C1\03BF \03C7\03C1\03CE\03BC\03B1 (\03C0.\03C7. %0).')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111375976153399335)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C7\03C1\03CE\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111376208357399335)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BB\03BB\03B1\03B3\03AE \03BC\03BF\03C1\03C6\03AE\03C2 \03C7\03C1\03CE\03BC\03B1\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111415408384399364)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AF\03C3\03C4\03B1 \03C4\03B9\03BC\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111415533364399364)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03BD\03BF\03B9\03B3\03BC\03B1 \03BB\03AF\03C3\03C4\03B1\03C2 \03B3\03B9\03B1: %0')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111395729985399350)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'el'
,p_message_text=>unistr('(\039F\03BB\03BF\03BA\03BB\03B7\03C1\03CE\03B8\03B7\03BA\03B5)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111288082277399271)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE \03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03C3\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111302489583399282)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0395\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE \03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03C3\03B1\03C2.'),
unistr('\039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B4\03B5\03AF\03C4\03B5 \03BB\03B5\03C0\03C4\03BF\03BC\03AD\03C1\03B5\03B9\03B5\03C2 \03B3\03B9\03B1 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03B5\03C1\03B9\03C3\03C4\03B1\03C4\03B9\03BA\03CC \03BC\03AD\03C3\03C9 \03C4\03BF\03C5 \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03BF\03CD \03B1\03C0\03BF\03C3\03C6\03B1\03BB\03BC\03AC\03C4\03C9\03C3\03B7\03C2 "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111380592676399338)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03BF\03C1\03B8\03CE\03C3\03C4\03B5 \03C4\03B1 \03C3\03C6\03AC\03BB\03BC\03B1\03C4\03B1 \03C0\03C1\03B9\03BD \03B1\03C0\03CC \03C4\03B7\03BD \03B1\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111326545433399299)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03C1\03AD\03B8\03B7\03BA\03B1\03BD %0 \03B1\03C0\03BF\03C4\03B5\03BB\03AD\03C3\03BC\03B1\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111326403890399299)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD \03B1\03C0\03BF\03C4\03B5\03BB\03AD\03C3\03BC\03B1\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111396240804399350)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03C1\03AD\03C7\03BF\03C5\03C3\03B1 \03C0\03C1\03CC\03BF\03B4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111380992224399339)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03C1\03C7\03B5\03AF\03BF \03C0\03BF\03C5 \03BA\03B1\03B8\03BF\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03C3\03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03C3\03C4\03BF APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111369483889399330)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03C1\03AD\03C7\03BF\03C5\03C3\03B1 \03AD\03BA\03B4\03BF\03C3\03B7 \03C4\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C3\03C4\03B7 \03B2\03AC\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03AD\03C7\03B5\03B9 \03B1\03BB\03BB\03AC\03BE\03B5\03B9 \03BC\03B5\03C4\03AC \03C4\03B7\03BD \03AD\03BD\03B1\03C1\03BE\03B7 \03C4\03B7\03C2 \03B4\03B9\03B1\03B4\03B9\03BA\03B1\03C3\03AF\03B1\03C2 \03B5\03BD\03B7\03BC\03AD\03C1\03C9\03C3\03B7\03C2 \03B1\03C0\03CC \03C4\03BF\03BD \03C7\03C1\03AE\03C3\03C4\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111338511276399308)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03C7\03B9 \03C6\03CC\03C1\03C4\03C9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111385580650399342)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C6\03AC\03BB\03BC\03B1 \03C0\03C1\03BF\03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111385348871399342)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03C3\03B1\03B3\03C9\03B3\03AE \03C3\03B5\03B9\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111399472275399352)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BA\03BF\03BB\03BF\03C5\03B8\03AF\03B1 : \0395\03BD\03AD\03C1\03B3\03B5\03B9\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111385455791399342)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B7\03BC\03AD\03C1\03C9\03C3\03B7 \03C3\03B5\03B9\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111326996812399299)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B4\03C5\03CC\03BC\03B5\03BD\03BF \03B7\03BC\03B5\03C1\03BF\03BB\03CC\03B3\03B9\03BF: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111249501966399243)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111249624556399243)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111385703759399342)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03AD\03C7\03B5\03B9 \03BA\03AC\03C0\03BF\03B9\03B1 \03C4\03B9\03BC\03AE.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111385620170399342)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B9\03BC\03AE \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03BC\03B9\03B1 \03AD\03B3\03BA\03C5\03C1\03B7 \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1 (\03C0.\03C7. %0).')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111253212142399246)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B9\03BC\03AE \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03BC\03B5\03C4\03B1\03BE\03CD %0 \03BA\03B1\03B9 %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111253327107399246)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B9\03BC\03AE \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 %0 \03AE \03BC\03B5\03C4\03B1\03B3\03B5\03BD\03AD\03C3\03C4\03B5\03C1\03B7.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111253477621399246)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B9\03BC\03AE \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 %0 \03AE \03C0\03C1\03BF\03B3\03B5\03BD\03AD\03C3\03C4\03B5\03C1\03B7.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111330486711399302)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF #LABEL# \03B5\03AF\03BD\03B1\03B9 \03BC\03B5\03B3\03B1\03BB\03CD\03C4\03B5\03C1\03BF \03B1\03C0\03CC \03C4\03B7 \03BC\03AD\03B3\03B9\03C3\03C4\03B7 \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1 \03C0\03BF\03C5 \03BA\03B1\03B8\03BF\03C1\03AF\03B6\03B5\03C4\03B1\03B9 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111330880269399302)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF #LABEL# \03B4\03B5\03BD \03C3\03C5\03BC\03C6\03C9\03BD\03B5\03AF \03BC\03B5 \03C4\03B7 \03BC\03BF\03C1\03C6\03AE %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111330374362399302)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF #LABEL# \03B5\03AF\03BD\03B1\03B9 \03BC\03B9\03BA\03C1\03CC\03C4\03B5\03C1\03BF \03B1\03C0\03CC \03C4\03B7\03BD \03B5\03BB\03AC\03C7\03B9\03C3\03C4\03B7 \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1 \03C0\03BF\03C5 \03BA\03B1\03B8\03BF\03C1\03AF\03B6\03B5\03C4\03B1\03B9 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111330577429399302)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF #LABEL# \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B5\03BD\03C4\03CC\03C2 \03C4\03BF\03C5 \03AD\03B3\03BA\03C5\03C1\03BF\03C5 \03B5\03CD\03C1\03BF\03C5\03C2 %0 \03AD\03C9\03C2 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111330785923399302)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF #LABEL# \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B5\03BD\03C4\03CC\03C2 \03C4\03BF\03C5 \03AD\03B3\03BA\03C5\03C1\03BF\03C5 \03B5\03CD\03C1\03BF\03C5\03C2 \03B5\03C4\03CE\03BD %0 \03BA\03B1\03B9 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111380886310399339)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BA\03CD\03C1\03C9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111408065020399359)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03BB\03B5\03AF\03C3\03B9\03BC\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111410030408399360)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111380604075399338)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'el'
,p_message_text=>'OK'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111380728700399339)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111286914821399270)
,p_name=>'APEX.ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C6\03AC\03BB\03BC\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111254333271399247)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C4\03BF \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03BF \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03BA\03C4\03AD\03BB\03B5\03C3\03B7 \03C4\03B7\03C2 \03B5\03C0\03B1\03BD\03AC\03BA\03BB\03B7\03C3\03B7\03C2 \03C7\03B5\03B9\03C1\03B9\03C3\03BC\03BF\03CD \03C3\03C6\03AC\03BB\03BC\03B1\03C4\03BF\03C2: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111263064148399253)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7 \03C3\03C7\03B5\03B4\03AF\03B1\03C3\03B7 \03C4\03B7\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2 \03C3\03C6\03AC\03BB\03BC\03B1\03C4\03BF\03C2: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111255081081399247)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C3\03C9\03C4\03B5\03C1\03B9\03BA\03CC \03C3\03C6\03AC\03BB\03BC\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111394876115399349)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0395\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE \03C3\03B1\03C2.'),
unistr('\039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B4\03B5\03AF\03C4\03B5 \03BB\03B5\03C0\03C4\03BF\03BC\03AD\03C1\03B5\03B9\03B5\03C2 \03B3\03B9\03B1 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03B5\03C1\03B9\03C3\03C4\03B1\03C4\03B9\03BA\03CC \03BC\03AD\03C3\03C9 \03C4\03BF\03C5 \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03BF\03CD \03B1\03C0\03BF\03C3\03C6\03B1\03BB\03BC\03AC\03C4\03C9\03C3\03B7\03C2 "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111389145723399345)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B2\03AC\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03AD\03C7\03B5\03B9 \03B1\03BD\03BF\03B9\03C7\03C4\03B5\03AF \03BC\03B5 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03BC\03CC\03BD\03BF \03B3\03B9\03B1 \03B1\03BD\03AC\03B3\03BD\03C9\03C3\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111419732221399367)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'el'
,p_message_text=>unistr('ORA-28353: \03A4\03BF \03AC\03BD\03BF\03B9\03B3\03BC\03B1 \03C4\03BF\03C5 \03C8\03B7\03C6\03B9\03B1\03BA\03BF\03CD \03C0\03BF\03C1\03C4\03BF\03C6\03BF\03BB\03B9\03BF\03CD \03B1\03C0\03AD\03C4\03C5\03C7\03B5. \0394\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03C3\03C4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03C0\03C1\03BF\03C2 \03C4\03BF \03C0\03B1\03C1\03CC\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111389294471399345)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03C5\03C3\03C4\03C5\03C7\03CE\03C2, \03B1\03C5\03C4\03AE \03B7 \03C3\03B5\03BB\03AF\03B4\03B1 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111256710835399249)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03C7\03BD\03B9\03BA\03AD\03C2 \03C0\03BB\03B7\03C1\03BF\03C6\03BF\03C1\03AF\03B5\03C2 (\039F\03C1\03B1\03C4\03AD\03C2 \03BC\03CC\03BD\03BF \03B3\03B9\03B1 \03C0\03C1\03BF\03B3\03C1\03B1\03BC\03BC\03B1\03C4\03B9\03C3\03C4\03AD\03C2)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111352814723399318)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AE\03BD\03C5\03BC\03B1 \03C3\03C6\03AC\03BB\03BC\03B1\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111366773182399328)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03BC\03B5\03BD\03CC\03BC\03B5\03BD\03B7 \03BC\03BF\03C1\03C6\03AE: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111333413199399304)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C7\03C1\03AE\03C3\03C4\03B7\03C2 \03B5\03AF\03BD\03B1\03B9 \03AE\03B4\03B7 \03C3\03C4\03B7 \03BB\03AF\03C3\03C4\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111333346378399304)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03B2\03B5\03B2\03B1\03B9\03CE\03C3\03C4\03B5 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C4\03C9\03BD \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03C9\03BD %0 \03C7\03C1\03B7\03C3\03C4\03CE\03BD \03C3\03C4\03B7 \03BB\03AF\03C3\03C4\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111333863420399304)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A5\03C0\03AC\03C1\03C7\03B5\03B9 \03B4\03B9\03C0\03BB\03CC\03C4\03C5\03C0\03BF\03C2 \03C7\03C1\03AE\03C3\03C4\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111333596612399304)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03B5\03AF\03C0\03B5\03B9 \03C4\03BF \03C3\03CD\03BC\03B2\03BF\03BB\03BF "@" \03B1\03C0\03CC \03C4\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111333617112399304)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03B5\03AF\03C0\03B5\03B9 \03BF \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B1\03C2 \03C4\03B5\03BB\03B5\03AF\03B1\03C2 (.) \03B1\03C0\03CC \03C4\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111333721388399304)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03CC\03BD\03BF\03BC\03B1 \03C7\03C1\03AE\03C3\03C4\03B7 \03B5\03AF\03BD\03B1\03B9 \03C0\03BF\03BB\03CD \03BC\03B5\03B3\03AC\03BB\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111334074780399305)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03CC\03BD\03BF \03BF\03B9 \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03C0\03BF\03C5 \03BF\03C1\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03C3\03C4\03B7 \03BB\03AF\03C3\03C4\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03AD\03C7\03BF\03C5\03BD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03C3\03B5 \03B1\03C5\03C4\03AE\03BD \03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111334176402399305)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03B1\03BD\03B1\03BC\03B5\03BD\03CC\03BC\03B5\03BD\03B7 \03C4\03B9\03BC\03AE \03C1\03CD\03B8\03BC\03B9\03C3\03B7\03C2 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111333913746399305)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BB\03BF\03B9 \03BF\03B9 \03C4\03B1\03C5\03C4\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03BF\03B9 \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03AD\03C7\03BF\03C5\03BD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03C3\03B5 \03B1\03C5\03C4\03AE\03BD \03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111376723442399336)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03C7\03B5\03B9 \03B1\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111376672390399336)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03C7\03B5\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111376930704399336)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'el'
,p_message_text=>unistr('%0: \0388\03C7\03B5\03B9 \03B1\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111376895139399336)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'el'
,p_message_text=>unistr('%0: \0388\03C7\03B5\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111376523094399336)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B5\03BD \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03AF\03C3\03C4\03B7\03BA\03B5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111369623480399331)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AE\03C8\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111326154521399299)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C6\03B1\03C1\03BC\03BF\03C3\03BC\03AD\03BD\03BF \03C6\03AF\03BB\03C4\03C1\03BF %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111367248014399329)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C6\03B1\03C1\03BC\03BF\03B3\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111252140183399245)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03C1\03AC\03C6\03B7\03BC\03B1 \03C1\03AC\03B2\03B4\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111379972305399338)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03BB\03BB\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111252201742399245)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03C1\03AC\03C6\03B7\03BC\03B1 \03C0\03AF\03C4\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111378683927399337)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03C1\03AC\03C6\03B7\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111251963853399245)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C4\03C1\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111367743142399329)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BA\03BA\03B1\03B8\03AC\03C1\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111367894506399329)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BA\03BA\03B1\03B8\03AC\03C1\03B9\03C3\03B7 \03CC\03BB\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111367981245399329)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BA\03BA\03B1\03B8\03AC\03C1\03B9\03C3\03B7 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111385177969399342)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C3\03C4\03AE\03BB\03B7 %1 \03C3\03C4\03B7\03BD \03BF\03C0\03BF\03AF\03B1 \03B1\03BD\03B1\03C6\03AD\03C1\03B5\03C4\03B1\03B9 \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2 %0 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B7 \03AE \03BC\03B7 \03B5\03BE\03BF\03C5\03C3\03B9\03BF\03B4\03BF\03C4\03B7\03BC\03AD\03BD\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111242367872399238)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03C6\03AF\03BB\03C4\03C1\03C9\03BD \03B3\03B9\03B1 \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111324325052399298)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B1\03C0\03BF\03C4\03B5\03BB\03AD\03C3\03BC\03B1\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111324411098399298)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03C7\03B8\03B7\03BA\03B1\03BD %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111327024473399300)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03C1\03AD\03C7\03BF\03BD\03C4\03B1 \03C6\03AF\03BB\03C4\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111243818932399239)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AF\03C3\03C4\03B1 \03C6\03AF\03BB\03C4\03C1\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111383617451399341)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03B3\03B9\03BD\03B5 \03C5\03C0\03AD\03C1\03B2\03B1\03C3\03B7 \03C4\03BF\03C5 \03BF\03C1\03AF\03BF\03C5 \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03CE\03BD \03C4\03B9\03BC\03CE\03BD (%0) \03B3\03B9\03B1 \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111369203260399330)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2 %0 \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03B3\03B9\03B1 \03C3\03C4\03AE\03BB\03B5\03C2 DATE \03AE TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111367342632399329)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03B9\03BB\03C4\03C1\03AC\03C1\03B9\03C3\03BC\03B1 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111367451145399329)
,p_name=>'APEX.FS.GO'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03AC\03B2\03B1\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111368859141399330)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\03B9\03C3\03BF\03CD\03C4\03B1\03B9 \03BC\03B5 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111252923785399246)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'el'
,p_message_text=>unistr('\03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111252653893399246)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B5\03B3\03B1\03BB\03CD\03C4\03B5\03C1\03BF \03B1\03C0\03CC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111252785921399246)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B5\03B3\03B1\03BB\03CD\03C4\03B5\03C1\03BF \03B1\03C0\03CC \03AE \03AF\03C3\03BF \03BC\03B5 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111252434990399245)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B9\03BA\03C1\03CC\03C4\03B5\03C1\03BF \03B1\03C0\03CC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111252572367399246)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B9\03BA\03C1\03CC\03C4\03B5\03C1\03BF \03B1\03C0\03CC \03AE \03AF\03C3\03BF \03BC\03B5 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111252869097399246)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'el'
,p_message_text=>unistr('\03B1\03C1\03C7\03AF\03B6\03B5\03B9 \03BC\03B5 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111255303369399248)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C4\03CD\03C0\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD %0 (%1) \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2 \03C4\03BF\03C5 \03C0\03B5\03B4\03AF\03BF\03C5 \03B5\03B9\03C3\03B1\03B3\03C9\03B3\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111245587818399240)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03B1 \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03CE\03BD \03C4\03B9\03BC\03CE\03BD \03B1\03C0\03B1\03B9\03C4\03BF\03CD\03BD \03B2\03AC\03C3\03B5\03B9\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03AD\03BA\03B4\03BF\03C3\03B7\03C2 12.2 \03AE \03BD\03B5\03CC\03C4\03B5\03C1\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111369042955399330)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B4\03CC\03B8\03B7\03BA\03B1\03BD \03C3\03C4\03AE\03BB\03B5\03C2 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03B3\03B9\03B1 \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111242417087399238)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B1 \03C6\03AF\03BB\03C4\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111324546578399298)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BD\03B1\03C1\03BE\03B7 \03B5\03CD\03C1\03BF\03C5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111368564308399330)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03AD\03C9\03C2 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111368601162399330)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03AC\03BD\03C9 \03B1\03C0\03CC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111368708156399330)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03AC\03C4\03C9 \03B1\03C0\03CC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111324622947399298)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AE\03BE\03B7 \03B5\03CD\03C1\03BF\03C5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111387490015399343)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF LOV #%2 ("%1") \03B3\03B9\03B1 \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2 \03B5\03CD\03C1\03BF\03C5\03C2 %0 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03BF (\03BB\03B5\03AF\03C0\03B5\03B9 \03C4\03BF \03B4\03B9\03B1\03C7\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC "|").')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111368995958399330)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BC\03B7 \03B1\03C5\03C4\03CC\03BC\03B1\03C4\03B7 \03B5\03B9\03C3\03B1\03B3\03C9\03B3\03AE \03B3\03B9\03B1 \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2 \03B5\03CD\03C1\03BF\03C5\03C2 %0 \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03C0\03C1\03BF\03C2 \03C4\03BF \03C0\03B1\03C1\03CC\03BD, \03B5\03C0\03B5\03B9\03B4\03AE \03B7 \03C3\03C4\03AE\03BB\03B7 \03B5\03AF\03BD\03B1\03B9 DATE \03AE TIMESTAMP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111368274425399329)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\03AD\03C9\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111252008092399245)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111321113334399295)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111367658330399329)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111367528519399329)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111368473949399330)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'el'
,p_message_text=>unistr('- \0395\03C0\03B9\03BB\03BF\03B3\03AE -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111251873295399245)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111368055560399329)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03BB\03B9\03B3\03CC\03C4\03B5\03C1\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111368165602399329)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111368340089399330)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B1\03C3\03C4\03AD\03C1\03B9\03B1 \03BA\03B1\03B9 \03C0\03AC\03BD\03C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111326061236399299)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03B9\03BB\03C4\03C1\03AC\03C1\03B9\03C3\03BC\03B1 \03C0\03C1\03BF\03C4\03AC\03C3\03B5\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111369122922399330)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2 \03C0\03B5\03B4\03AF\03BF\03C5 \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5 %0 \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03C0\03C1\03BF\03C2 \03C4\03BF \03C0\03B1\03C1\03CC\03BD \03BC\03CC\03BD\03BF \03B3\03B9\03B1 \03C3\03C4\03AE\03BB\03B5\03C2 NUMBER.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111242286583399238)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03BF\03BB\03B9\03BA\03CC \03C0\03BB\03AE\03B8\03BF\03C2 \03C3\03B5\03B9\03C1\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111385292286399342)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C4\03CD\03C0\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD %0 (%1) \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03B3\03B9\03B1 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7 \03B2\03AC\03C3\03B5\03B9 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03C9\03BD \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111377103805399336)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03AC\03B2\03B1\03C3\03B7 \03C3\03C4\03BF \03C3\03C6\03AC\03BB\03BC\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111334796991399305)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111342364386399311)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BC\03C0\03C4\03C5\03BE\03B7 \03C4\03BF\03BC\03AE\03C2 \03B5\03BB\03AD\03B3\03C7\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111334888386399305)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF\03BC\03AE \03B5\03BB\03AD\03B3\03C7\03BF\03C5.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111342241421399310)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03AC\03C0\03C4\03C5\03BE\03B7 \03C4\03BF\03BC\03AE\03C2 \03B5\03BB\03AD\03B3\03C7\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111420949065399368)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B7 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111342033289399310)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B3\03C1\03AC\03C6\03B7\03BA\03B1\03BD %0 \03C3\03B5\03B9\03C1\03AD\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111412410733399362)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03C0\03BB\03CC\03C4\03C5\03C0\03BF \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111331753529399303)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03CE\03C4\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111335045329399305)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B5\03C6\03B1\03BB\03AF\03B4\03B1 \03BF\03BC\03AC\03B4\03B1\03C2.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111334949169399305)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B5\03C6\03B1\03BB\03AF\03B4\03B1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111331874170399303)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111351825030399317)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111331572014399303)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111335164550399305)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AD\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111331928707399303)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'el'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111332081372399303)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'el'
,p_message_text=>unistr('%0 - %1 \03B1\03C0\03CC %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111388068334399344)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03B5\03BB\03AF\03B4\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111331657541399303)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111412212343399362)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03C4\03AD\03B8\03B7\03BA\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111412373730399362)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03BB\03BB\03B1\03BE\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111420745008399368)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC %0, \03A3\03C4\03AE\03BB\03B7 %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111420812110399368)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111412175251399362)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B3\03C1\03AC\03C6\03B7\03BA\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111335300075399306)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B5\03C6\03B1\03BB\03AF\03B4\03B1 \03C3\03B5\03B9\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111330942306399302)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03C7\03B8\03B7\03BA\03B1\03BD %0 \03BA\03B5\03BB\03B9\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111332168520399303)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03C7\03B8\03B7\03BA\03B1\03BD %0 \03C3\03B5\03B9\03C1\03AD\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111372481874399333)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03CC\03BB\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111342167106399310)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03BB\03AF\03B4\03B1 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111335213977399305)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03B5\03B9\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111335428490399306)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03B3\03B9\03BD\03B5 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C3\03B5 \03B1\03CD\03BE\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC - %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111335501332399306)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03B3\03B9\03BD\03B5 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C3\03B5 \03C6\03B8\03AF\03BD\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC - %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111331021476399302)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C3\03B5 \03B1\03CD\03BE\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111331333353399303)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C3\03B5 \03B1\03CD\03BE\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC - %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111331116478399303)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C3\03B5 \03C6\03B8\03AF\03BD\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111331416388399303)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C3\03B5 \03C6\03B8\03AF\03BD\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC - %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111331272862399303)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C9\03C1\03AF\03C2 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111341979662399310)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BD\03BF\03BB\03BF %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111268343123399257)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B1\03AF\03C4\03B7\03C3\03B7 HTTP \03C3\03C4\03BF "%0" \03B1\03C0\03AD\03C4\03C5\03C7\03B5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111409609096399360)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AF\03C3\03C4\03B1 \03B5\03C0\03B9\03BB\03BF\03B3\03CE\03BD \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2: %0 \03C3\03C4\03AE\03BB\03B5\03C2, %1 \03C3\03B5\03B9\03C1\03AD\03C2. \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B1 \03C0\03BB\03AE\03BA\03C4\03C1\03B1 \03BC\03B5 \03C4\03B1 \03B2\03AD\03BB\03B7.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111341804884399310)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AF\03C3\03C4\03B1 \03B5\03C0\03B9\03BB\03BF\03B3\03CE\03BD: %0 \03C3\03B5\03B9\03C1\03AD\03C2. \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B1 \03C0\03BB\03AE\03BA\03C4\03C1\03B1 \03BC\03B5 \03C4\03B1 \03B2\03AD\03BB\03B7.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111420511393399368)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03CC \03C0\03BB\03AD\03B3\03BC\03B1 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111328605627399301)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111329624397399301)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111329502355399301)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C3\03B5\03B9\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111414056108399363)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111399559725399352)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111401234590399354)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BB\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111357609463399322)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BB\03B5\03C2 \03BF\03B9 \03C3\03C4\03AE\03BB\03B5\03C2 \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111358891527399323)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111359960146399323)
,p_name=>'APEX.IG.AND'
,p_message_language=>'el'
,p_message_text=>unistr('\03BA\03B1\03B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111379357189399338)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C4\03C1\03B7\03C3\03B7 \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03CE\03BD \03C4\03B9\03BC\03CE\03BD \03BA\03B1\03C4\03AC \03C0\03C1\03BF\03C3\03AD\03B3\03B3\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111415075854399364)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03BF\03BB\03B9\03BA\03AE \03BC\03AD\03C4\03C1\03B7\03C3\03B7 \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03CE\03BD \03C4\03B9\03BC\03CE\03BD \03BA\03B1\03C4\03AC \03C0\03C1\03BF\03C3\03AD\03B3\03B3\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111398187670399351)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03BF\03C7\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111400077634399353)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03CD\03BE\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111358926938399323)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BE\03BF\03C5\03C3\03B9\03BF\03B4\03CC\03C4\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111414179926399363)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03CC\03BC\03B1\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111379780245399338)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C3\03BF\03C2 \03CC\03C1\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111414727948399364)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03BF\03BB\03B9\03BA\03CC\03C2 \03BC\03AD\03C3\03BF\03C2 \03CC\03C1\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111397626820399351)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03AF\03C4\03BB\03BF\03C2 \03AC\03BE\03BF\03BD\03B1 \03B5\03C4\03B9\03BA\03AD\03C4\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111397890118399351)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BA\03B1\03B4\03B9\03BA\03AC \03C8\03B7\03C6\03AF\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111397719868399351)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03AF\03C4\03BB\03BF\03C2 \03AC\03BE\03BF\03BD\03B1 \03C4\03B9\03BC\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111403800702399355)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03CE\03BC\03B1 \03C6\03CC\03BD\03C4\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111398218154399351)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A1\03AC\03B2\03B4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111354212872399319)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B5\03C4\03B1\03BE\03CD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111405005276399356)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03B9 \03C4\03B1 \03B4\03CD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111398351508399352)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03C5\03C3\03B1\03BB\03AF\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111329896226399302)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BA\03CD\03C1\03C9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111359890618399323)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03AC\03BA\03C1\03B9\03C3\03B7 \03C0\03B5\03B6\03CE\03BD/\03BA\03B5\03C6\03B1\03BB\03B1\03AF\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111415691651399364)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'el'
,p_message_text=>unistr('(\0394\03B9\03AC\03BA\03C1\03B9\03C3\03B7 \03C0\03B5\03B6\03CE\03BD/\03BA\03B5\03C6\03B1\03BB\03B1\03AF\03C9\03BD)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111386566672399343)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03B9 \03B1\03BB\03BB\03B1\03B3\03AD\03C2 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C4\03B7\03BA\03B1\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111330226122399302)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BB\03BB\03B1\03B3\03AE \03C0\03C1\03BF\03B2\03BF\03BB\03AE\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111360993340399324)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03C1\03AC\03C6\03B7\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111357457023399322)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03AC \03C3\03B1\03C2 \03C5\03C0\03B5\03C1\03B2\03B1\03AF\03BD\03B5\03B9 \03C4\03BF\03BD \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD %0 \03C3\03B7\03BC\03B5\03AF\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03B1\03BD\03AC \03B3\03C1\03AC\03C6\03B7\03BC\03B1. \0395\03C6\03B1\03C1\03BC\03CC\03C3\03C4\03B5 \03AD\03BD\03B1 \03C6\03AF\03BB\03C4\03C1\03BF \03B3\03B9\03B1 \03BD\03B1 \03BC\03B5\03B9\03CE\03C3\03B5\03C4\03B5 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03B5\03B3\03B3\03C1\03B1\03C6\03CE\03BD \03C3\03C4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03B1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111328500059399301)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111335877151399306)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BA\03BA\03B1\03B8\03AC\03C1\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111397128781399351)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03BB\03B5\03AF\03C3\03B9\03BC\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111404035763399356)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03CE\03BC\03B1\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111380109983399338)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03C0\03B9\03C3\03BA\03CC\03C0\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111359218497399323)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111328764637399301)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111405870986399357)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03BA\03BF\03C0\03CC\03C2 \03C3\03C4\03AE\03BB\03B7\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111359339990399323)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BD\03B8\03B5\03C4\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111328990066399301)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111354865258399320)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'el'
,p_message_text=>unistr('\03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111361134104399324)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF\03BC\03AE \03B5\03BB\03AD\03B3\03C7\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111335675294399306)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03C4\03B9\03B3\03C1\03B1\03C6\03AE \03C3\03C4\03BF \03A0\03C1\03CC\03C7\03B5\03B9\03C1\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111335791510399306)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B7\03BC\03B5\03AF\03C9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111379129328399337)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C4\03C1\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111379232306399337)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C4\03C1\03B7\03C3\03B7 \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111414948713399364)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03BF\03BB\03B9\03BA\03AE \03BC\03AD\03C4\03C1\03B7\03C3\03B7 \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111414830150399364)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03BF\03BB\03B9\03BA\03AE \03BC\03AD\03C4\03C1\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111412520893399362)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111357879748399322)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03B4\03BF\03BC\03AD\03BD\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111405616989399357)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03CD\03C0\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111405208936399357)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111386304867399343)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C4\03B9\03BC\03AE \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111355550534399320)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('\03B7\03BC\03AD\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111358517685399322)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B5\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111358392448399322)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03BF\03C2 \03C4\03CD\03C0\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111329719273399301)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111406825693399358)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03AF\03C3\03C4\03B5 \03B2\03AD\03B2\03B1\03B9\03BF\03B9 \03CC\03C4\03B9 \03B8\03AD\03BB\03B5\03C4\03B5 \03BD\03B1 \03B4\03B9\03B1\03B3\03C1\03AC\03C8\03B5\03C4\03B5 \03B1\03C5\03C4\03AE\03BD \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC;')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111362989421399326)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE \03C3\03B5\03B9\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111361753978399325)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE \03C3\03B5\03B9\03C1\03CE\03BD')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111400126165399353)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03B8\03AF\03BD\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111360603369399324)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03B5\03C0\03C4\03BF\03BC\03AD\03C1\03B5\03B9\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111328242714399300)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03BB\03B5\03C0\03C4\03BF\03BC\03B5\03C1\03B5\03B9\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111388869854399344)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03B5\03CD\03B8\03C5\03BD\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111360388983399324)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03C7\03B5\03B9 \03B1\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111354962488399320)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B5\03BD \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111355113197399320)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B5\03BD \03BE\03B5\03BA\03B9\03BD\03AC \03BC\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111398454406399352)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B1\03BA\03C4\03CD\03BB\03B9\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111361369425399324)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AE\03C8\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111260054638399251)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03CC\03BD\03BF \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111407809943399358)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03BC\03BF\03C1\03C6\03AE\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111272698286399260)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BC\03BF\03C1\03C6\03AE \03BB\03AE\03C8\03B7\03C2 %0 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111400868089399353)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03C0\03BB\03CC\03C4\03C5\03C0\03B7 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111400948729399353)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03C0\03BB\03CC\03C4\03C5\03C0\03B7 \03C4\03BF\03BC\03AE \03B5\03BB\03AD\03B3\03C7\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111362840765399326)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03C0\03BB\03CC\03C4\03C5\03C0\03B7 \03C3\03B5\03B9\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111361696909399325)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03C0\03BB\03CC\03C4\03C5\03C0\03B5\03C2 \03C3\03B5\03B9\03C1\03AD\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111329354488399301)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111399989313399353)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111411434095399361)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03BF\03BC\03AC\03B4\03B1\03C2 \03B1\03C0\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111407403674399358)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03C1\03C5\03C6\03AE \03BA\03BF\03B9\03BD\03BF\03C0\03BF\03AF\03B7\03C3\03B7 (\039A.\039A\03BF\03B9\03BD.)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111407635288399358)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AE\03BD\03C5\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111407391491399358)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03BF\03B9\03BD\03BF\03C0\03BF\03AF\03B7\03C3\03B7 (\039A\03BF\03B9\03BD.)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111407070337399358)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03BC\03AE\03BD\03C5\03BC\03B1 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5 \03C3\03C4\03AC\03BB\03B8\03B7\03BA\03B5.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111407520787399358)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'el'
,p_message_text=>unistr('\0398\03AD\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111407245278399358)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03B1\03BB\03AE\03C0\03C4\03B7\03C2 (\03A0\03C1\03BF\03C2)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111360026825399324)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03C7\03B5\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111353252384399319)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'el'
,p_message_text=>unistr('\03B9\03C3\03BF\03CD\03C4\03B1\03B9 \03BC\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111406435918399357)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03AC\03B4\03B5\03B9\03B3\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111360196504399324)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BA\03C6\03C1\03B1\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111406393399399357)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03CD\03C0\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111372386844399333)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03C1\03BF\03B5\03C4\03BF\03B9\03BC\03B1\03C3\03AF\03B1 \03C4\03BF\03C5 \03B1\03C1\03C7\03B5\03AF\03BF\03C5 \03BF\03BB\03BF\03BA\03BB\03B7\03C1\03CE\03B8\03B7\03BA\03B5. \039E\03B5\03BA\03B9\03BD\03AC \03B7 \03BB\03AE\03C8\03B7.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111335910783399306)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BC\03C0\03BB\03AE\03C1\03C9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111337072513399307)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BC\03C0\03BB\03AE\03C1\03C9\03C3\03B7 \03B5\03C0\03B9\03BB\03BF\03B3\03AE\03C2 \03BC\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111336959681399307)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BC\03C0\03BB\03AE\03C1\03C9\03C3\03B7 \03B5\03C0\03B9\03BB\03BF\03B3\03AE\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111328844871399301)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03B9\03BB\03C4\03C1\03AC\03C1\03B9\03C3\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111359454569399323)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03AF\03BB\03C4\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111414445410399363)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03B9\03BB\03C4\03C1\03AC\03C1\03B9\03C3\03BC\03B1...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111400307799399353)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03CE\03C4\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111329039580399301)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B4\03C1\03BF\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111357993431399322)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03BF\03C1\03C6\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111404927608399356)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AC\03C3\03BA\03B1 \03BC\03BF\03C1\03C6\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111406715828399358)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'el'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111406690966399358)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'el'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111319404378399294)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'el'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111258711665399250)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'el'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111362551917399325)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03AC\03B3\03C9\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111360242882399324)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03B1\03C1\03C4\03AE\03C3\03B5\03B9\03C2 \03BA\03B1\03B9 \03C4\03B5\03BB\03B5\03C3\03C4\03AD\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111398566083399352)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'el'
,p_message_text=>unistr('X\03BF\03AC\03BD\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111379024142399337)
,p_name=>'APEX.IG.GO'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03AC\03B2\03B1\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111353862772399319)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B5\03B3\03B1\03BB\03CD\03C4\03B5\03C1\03BF \03B1\03C0\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111353910874399319)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B5\03B3\03B1\03BB\03CD\03C4\03B5\03C1\03BF \03B1\03C0\03CC \03AE \03AF\03C3\03BF \03BC\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111360569448399324)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BB\03AD\03B3\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111328043071399300)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111401101821399354)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03BC\03AC\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111360793800399324)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BA\03B1\03C4\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111328300861399300)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111405585217399357)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03CD\03C0\03BF\03C2 \03C3\03C5\03BD\03B8\03AE\03BA\03B7\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111404410881399356)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111404629985399356)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C5\03B8\03C5\03B3\03C1\03AC\03BC\03BC\03B9\03C3\03B7 \03B5\03C0\03B9\03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111414347981399363)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111409855455399360)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B5\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5, \03BD\03B1 \03B5\03BD\03B7\03BC\03B5\03C1\03CE\03C3\03B5\03C4\03B5 \03BA\03B1\03B9 \03BD\03B1 \03B4\03B9\03B1\03B3\03C1\03AC\03C8\03B5\03C4\03B5 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03B1\03C0\03B5\03C5\03B8\03B5\03AF\03B1\03C2 \03C3\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03CC \03C0\03BB\03AD\03B3\03BC\03B1.</p>'),
'',
unistr('<p>\0395\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03BC\03B9\03B1 \03BD\03AD\03B1 \03C3\03B5\03B9\03C1\03AC \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03BA\03BF\03C5\03BC\03C0\03AF "\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C3\03B5\03B9\03C1\03AC\03C2".</p>'),
'',
unistr('<p>\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03C4\03B5\03AF\03C4\03B5 \03C4\03B1 \03C5\03C0\03AC\03C1\03C7\03BF\03BD\03C4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03B4\03B9\03C0\03BB\03CC \03BA\03BB\03B9\03BA \03C3\03B5 \03AD\03BD\03B1 \03C3\03C5\03B3\03BA\03B5\03BA\03C1\03B9\03BC\03AD\03BD\03BF \03BA\03B5\03BB\03AF. \0393\03B9\03B1 \03BC\03B5\03B3\03B1\03BB\03CD\03C4\03B5\03C1\03B5\03C2 \03B5\03C1\03B3\03B1\03C3\03AF\03B5\03C2 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2, \03BA\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1" \03B3\03B9\03B1 \03BD\03B1 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5 \03C4\03B7 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2. \03A3\03C4\03B7 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5')
||unistr(' \03BD\03B1 \03BA\03AC\03BD\03B5\03C4\03B5 \03BA\03BB\03B9\03BA \03AE \03BD\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5 \03C4\03BF \03C0\03BB\03B7\03BA\03C4\03C1\03BF\03BB\03CC\03B3\03B9\03BF \03B3\03B9\03B1 \03BD\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03C4\03B5\03AF\03C4\03B5 \03C3\03C5\03B3\03BA\03B5\03BA\03C1\03B9\03BC\03AD\03BD\03B1 \03BA\03B5\03BB\03B9\03AC.</p>'),
'',
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5 \03C4\03BF \03BC\03B5\03BD\03BF\03CD "\0391\03BB\03BB\03B1\03B3\03AE" \03B3\03B9\03B1 \03BD\03B1 \03B1\03BD\03B1\03C0\03B1\03C1\03B1\03B3\03C9\03B3\03AE \03AE \03B4\03B9\03B1\03B3\03C1\03B1\03C6\03AE \03C3\03B5\03B9\03C1\03CE\03BD. \0393\03B9\03B1 \03BD\03B1 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5 \03C4\03BF \03BC\03B5\03BD\03BF\03CD "\0391\03BB\03BB\03B1\03B3\03AE", \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B1 \03C0\03BB\03B1\03AF\03C3\03B9\03B1 \03B5\03C0\03B9\03BB\03BF\03B3\03AE\03C2 \03B3\03B9\03B1 \03BD\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B5\03C2 \03B1\03C0\03CC \03BC\03AF\03B1 \03C3\03B5\03B9\03C1\03AD\03C2.</p>'),
'',
unistr('<p>\0391\03BD\03B1\03C0\03B1\03C1\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03BC\03B9\03B1 \03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7 \03C3\03B5\03B9\03C1\03AC \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03BC\03B5\03BD\03BF\03CD "\0391\03BB\03BB\03B1\03B3\03AE" \03BA\03B1\03B9 \03B5\03C0\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03B1\03C2 "\0391\03BD\03B1\03C0\03B1\03C1\03B1\03B3\03C9\03B3\03AE \03C3\03B5\03B9\03C1\03CE\03BD". \0394\03B9\03B1\03B3\03C1\03AC\03C8\03C4\03B5 \03BC\03B9\03B1 \03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7 \03C3\03B5\03B9\03C1\03AC \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03BC\03B5\03BD\03BF\03CD "\0391\03BB\03BB\03B1\03B3\03AE" \03BA\03B1\03B9 \03B5\03C0\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03B1\03C2 "\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE \03C3\03B5\03B9\03C1\03AC\03C2".</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111411979388399361)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03C5\03BD\03B1\03C4\03CC\03C4\03B7\03C4\03B5\03C2 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111412034923399362)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0388\03BD\03B1 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03CC \03C0\03BB\03AD\03B3\03BC\03B1 \03C0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03B6\03B5\03B9 \03AD\03BD\03B1 \03C3\03CD\03BD\03BF\03BB\03BF \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C3\03B5 \03BC\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03BC\03B5 \03B4\03C5\03BD\03B1\03C4\03CC\03C4\03B7\03C4\03B1 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03BA\03B1\03B9 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE\03C2. \039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03C0\03C1\03B1\03B3\03BC\03B1\03C4\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5 \03C0\03BF\03BB\03BB\03AD\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B3\03B9\03B1 \03BD\03B1 \03C0\03B5\03C1\03B9\03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03B9\03C2 \03B5\03B3\03B3\03C1\03B1\03C6\03AD\03C2 \03C0\03BF\03C5 \03B5\03C0\03B9\03C3\03C4\03C1\03AD\03C6\03BF\03BD\03C4\03B1\03B9 \03BA\03B1\03B9 \03BD\03B1 \03B1\03BB\03BB\03AC\03BE\03B5\03C4\03B5 \03C4\03BF\03BD \03C4\03C1\03CC\03C0\03BF \03C0\03C1\03BF\03B2\03BF\03BB\03AE\03C2 \03C4')
||unistr('\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.</p>'),
'',
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03BF \03C0\03B5\03B4\03AF\03BF \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03B3\03B9\03B1 \03BD\03B1 \03C6\03B9\03BB\03C4\03C1\03AC\03C1\03B5\03C4\03B5 \03C4\03B9\03C2 \03B5\03B3\03B3\03C1\03B1\03C6\03AD\03C2 \03C0\03BF\03C5 \03B5\03C0\03B9\03C3\03C4\03C1\03AD\03C6\03BF\03BD\03C4\03B1\03B9. \039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2" \03B3\03B9\03B1 \03BD\03B1 \03B1\03C0\03BF\03BA\03C4\03AE\03C3\03B5\03C4\03B5 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03C3\03B5 \03C0\03BF\03BB\03BB\03AD\03C2 \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03C2 \03C3\03C7\03B5\03C4\03B9\03BA\03AC \03BC\03B5 \03C4\03B7\03BD \03C4\03C1\03BF\03C0\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03C4\03B7\03C2 \03B4\03B9\03AC\03C4\03B1\03BE\03B7\03C2 \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03AE \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B1 \03BC\03B5\03BD\03BF\03CD \03BA')
||unistr('\03B5\03C6\03B1\03BB\03AF\03B4\03C9\03BD \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03C4\03B9\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03C0\03BF\03C5 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9.</p>'),
'',
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B9\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03CE\03BD \03B3\03B9\03B1 \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C3\03B5\03C4\03B5 \03C4\03B9\03C2 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AD\03C2 \03C3\03B1\03C2 \03C3\03B5 \03BC\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC. \039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03B5\03C0\03AF\03C3\03B7\03C2 \03BD\03B1 \03BA\03AC\03BD\03B5\03C4\03B5 \03BB\03AE\03C8\03B7 \03C4\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C3\03B5 \03AD\03BD\03B1 \03B5\03BE\03C9\03C4\03B5\03C1\03B9\03BA\03CC \03B1\03C1\03C7\03B5\03AF\03BF \03AE \03BD\03B1 \03C3\03C4\03B5\03AF\03BB\03B5\03C4\03B5 \03C4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03C3\03C4\03BF\03BD \03B5\03B1\03C5\03C4\03CC \03C3\03B1\03C2 \03AE \03C3\03B5 \03AC\03BB\03BB\03B1 \03AC\03C4\03BF\03BC\03B1 \03BC\03AD\03C3\03C9 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9')
||unistr('\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5.</p>'),
'',
unistr('<p>\0393\03B9\03B1 \03BD\03B1 \03BC\03AC\03B8\03B5\03C4\03B5 \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B1, \03B1\03BD\03B1\03C4\03C1\03AD\03BE\03C4\03B5 \03C3\03C4\03B7\03BD \03B5\03BD\03CC\03C4\03B7\03C4\03B1 "\03A7\03C1\03AE\03C3\03B7 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03CE\03BD \03C0\03BB\03B5\03B3\03BC\03AC\03C4\03C9\03BD" \03C3\03C4\03BF\03BD <em>\039F\03B4\03B7\03B3\03CC \03C4\03B5\03BB\03B9\03BA\03BF\03CD \03C7\03C1\03AE\03C3\03C4\03B7 \03C4\03BF\03C5 Oracle Application Express</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111411741843399361)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03C3\03BA\03CC\03C0\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111409742637399360)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03CC\03C3\03B5\03C4\03B5 \03C4\03BF \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03CC \03C0\03BB\03AD\03B3\03BC\03B1 \03AD\03C4\03C3\03B9 \03CE\03C3\03C4\03B5 \03BD\03B1 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03B9 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03BC\03B5 \03B4\03B9\03B1\03C6\03BF\03C1\03B5\03C4\03B9\03BA\03BF\03CD\03C2 \03C4\03C1\03CC\03C0\03BF\03C5\03C2 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03CE\03BD\03C4\03B1\03C2 \03C4\03B9\03C2 \03B5\03BD\03C3\03C9\03BC\03B1\03C4\03C9\03BC\03AD\03BD\03B5\03C2 \03B4\03C5\03BD\03B1\03C4\03CC\03C4\03B7\03C4\03B5\03C2.</p>'),
'',
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B1 \03BC\03B5\03BD\03BF\03CD \03BA\03B5\03C6\03B1\03BB\03AF\03B4\03C9\03BD \03C3\03C4\03AE\03BB\03B7\03C2 \03AE \03C4\03BF \03BC\03B5\03BD\03BF\03CD \03B5\03BD\03B5\03C1\03B3\03B5\03B9\03CE\03BD \03B3\03B9\03B1 \03BD\03B1 \03C0\03C1\03BF\03C3\03B4\03B9\03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C0\03BF\03B9\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03B8\03B1 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9, \03C4\03B7 \03C3\03B5\03B9\03C1\03AC \03C4\03BF\03C5\03C2 \03BA\03B1\03B9 \03C4\03B9\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03C0\03BF\03C5 \03B8\03B1 \03C3\03C4\03B1\03B8\03B5\03C1\03BF\03C0\03BF\03B9\03BF\03CD\03BD\03C4\03B1\03B9. \039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03B5\03C0\03AF\03C3\03B7\03C2 \03BD\03B1 \03BA\03B1\03B8\03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03B4\03B9\03AC\03C6\03BF\03C1\03B1 \03C6\03AF\03BB\03C4\03C1\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03BA\03B1\03B9 \03BD\03B1 \03C4\03B1\03BE\03B9\03BD\03BF\03BC\03AE\03C3\03B5\03C4\03B5 \03C4\03B1 \03B4\03B5')
||unistr('\03B4\03BF\03BC\03AD\03BD\03B1 \03C0\03BF\03C5 \03B5\03C0\03B9\03C3\03C4\03C1\03AD\03C6\03BF\03BD\03C4\03B1\03B9.</p>'),
'',
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03BF \03BA\03BF\03C5\03BC\03C0\03AF "\03A0\03C1\03BF\03B2\03BF\03BB\03AE" (\03B4\03AF\03C0\03BB\03B1 \03C3\03C4\03BF \03C0\03B5\03B4\03AF\03BF "\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7") \03B3\03B9\03B1 \03BD\03B1 \03B1\03C0\03BF\03BA\03C4\03AE\03C3\03B5\03C4\03B5 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03C3\03B5 \03AC\03BB\03BB\03B5\03C2 \03C0\03C1\03BF\03B2\03BF\03BB\03AD\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C0\03BF\03C5 \03AF\03C3\03C9\03C2 \03AD\03C7\03BF\03C5\03BD \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03C4\03B5\03AF \03B1\03C0\03CC \03C4\03BF\03BD \03C0\03C1\03BF\03B3\03C1\03B1\03BC\03BC\03B1\03C4\03B9\03C3\03C4\03AE \03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2. \0395\03C0\03AF\03C3\03B7\03C2, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03AD\03BD\03B1 \03B3\03C1\03AC\03C6\03B7\03BC\03B1 \03AE \03BD\03B1 \03C0\03C1\03BF\03B2\03AC\03BB\03B5\03C4\03B5 \03AD\03BD')
||unistr('\03B1 \03C5\03C0\03AC\03C1\03C7\03BF\03BD \03B3\03C1\03AC\03C6\03B7\03BC\03B1.</p>  '),
'',
unistr('<p><em>\03A3\03B7\03BC\03B5\03AF\03C9\03C3\03B7: \039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE <strong>\0392\03BF\03AE\03B8\03B5\03B9\03B1</strong> \03C3\03C4\03B1 \03C0\03B1\03C1\03AC\03B8\03C5\03C1\03B1 \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03C4\03BF\03C5 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03BF\03CD \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03B3\03B9\03B1 \03BD\03B1 \03B4\03B5\03AF\03C4\03B5 \03C0\03B9\03BF \03BB\03B5\03C0\03C4\03BF\03BC\03B5\03C1\03B5\03AF\03C2 \03C0\03BB\03B7\03C1\03BF\03C6\03BF\03C1\03AF\03B5\03C2 \03C3\03C7\03B5\03C4\03B9\03BA\03AC \03BC\03B5 \03C4\03B7\03BD \03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111411810605399361)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03C5\03BD\03B1\03C4\03CC\03C4\03B7\03C4\03B5\03C2 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111361537528399325)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03BF\03CD \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111408685300399359)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03BB\03B1\03AF\03C3\03B9\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03C4\03B7 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7 \03C3\03C4\03B7\03BB\03CE\03BD. \039F\03B9 \03C4\03B9\03BC\03AD\03C2 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03C3\03C4\03BF \03BA\03AC\03C4\03C9 \03BC\03AD\03C1\03BF\03C2 \03C4\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03AE \03C3\03C4\03BF \03BA\03AC\03C4\03C9 \03BC\03AD\03C1\03BF\03C2 \03BA\03AC\03B8\03B5 control break, \03B5\03AC\03BD \03AD\03C7\03BF\03C5\03BD \03BF\03C1\03B9\03C3\03C4\03B5\03AF break.</p>'),
'',
unistr('<p><strong>\039B\03AF\03C3\03C4\03B1 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7\03C2</strong><br>'),
unistr('\0397 \03BB\03AF\03C3\03C4\03B1 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03B9 \03C3\03C5\03BD\03B1\03B8\03C1\03BF\03AF\03C3\03B5\03B9\03C2 \03C0\03BF\03C5 \03AD\03C7\03BF\03C5\03BD \03BF\03C1\03B9\03C3\03C4\03B5\03AF. \0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03BC\03B9\03B1 \03C5\03C0\03AC\03C1\03C7\03BF\03C5\03C3\03B1 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7 \03B1\03C0\03BF\03B5\03C0\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03AC\03C2 \03C4\03B7\03BD.<br>'),
unistr('\039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7" ( &plus; ) \03B3\03B9\03B1 \03BD\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03BA\03B1\03B9\03BD\03BF\03CD\03C1\03B9\03B1 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7 \03AE \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE" ( &minus; ) \03B3\03B9\03B1 \03BD\03B1 \03B1\03C6\03B1\03B9\03C1\03AD\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C5\03C0\03AC\03C1\03C7\03BF\03C5\03C3\03B1 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7.</p>'),
'',
unistr('<p><strong>\03A1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7\03C2</strong><br>'),
unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B7 \03C6\03CC\03C1\03BC\03B1 \03C3\03C4\03B1 \03B4\03B5\03BE\03B9\03AC \03B3\03B9\03B1 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03B7 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7.<br>'),
unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C4\03BF \03CC\03BD\03BF\03BC\03B1 \03C3\03C4\03AE\03BB\03B7\03C2 \03BA\03B1\03B9 \03C4\03BF\03BD \03C4\03CD\03C0\03BF \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7\03C2.<br>'),
unistr('\03A0\03C1\03BF\03B1\03B9\03C1\03B5\03C4\03B9\03BA\03AC, \03BA\03B1\03C4\03B1\03C7\03C9\03C1\03AE\03C3\03C4\03B5 \03BC\03B9\03B1 \03B5\03C0\03B5\03BE\03AE\03B3\03B7\03C3\03B7 \03B3\03B9\03B1 \03C4\03B7 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7.<br>'),
unistr('\0395\03AC\03BD \03AD\03C7\03B5\03C4\03B5 \03BF\03C1\03AF\03C3\03B5\03B9 \03BC\03B9\03B1 \03C4\03BF\03BC\03AE \03B5\03BB\03AD\03B3\03C7\03BF\03C5, \03B5\03C0\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03B1\03C2 <strong>\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03C3\03C5\03BD\03BF\03BB\03B9\03BA\03AE\03C2 \03C4\03B9\03BC\03AE\03C2</strong> \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03BF \03C3\03C5\03BD\03BF\03BB\03B9\03BA\03CC\03C2 \03BC\03AD\03C3\03BF\03C2 \03CC\03C1\03BF\03C2, \03C4\03BF \03C3\03CD\03BD\03BF\03BB\03BF \03AE \03C0\03B1\03C1\03CC\03BC\03BF\03B9\03B1 \03C4\03B9\03BC\03AE \03C3\03C4\03BF \03BA\03AC\03C4\03C9 \03BC\03AD\03C1\03BF\03C2 \03C4\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.</p>'),
'',
unistr('<p><em>\03A3\03B7\03BC\03B5\03AF\03C9\03C3\03B7: \0391\03C0\03BF\03BA\03C4\03AE\03C3\03C4\03B5 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03C3\03C4\03BF \03C0\03BB\03B1\03AF\03C3\03B9\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 "\03A3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7" \03B1\03C0\03CC \03C4\03BF \03BC\03B5\03BD\03BF\03CD "\0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2" \03AE \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1 \03BA\03B1\03B9 \03C3\03C4\03BF \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1 ( &sum; ) \03C4\03B7\03C2 \03C3\03C4\03AE\03BB\03B7\03C2.</em></p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111410813586399361)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111409365895399360)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03BB\03B1\03AF\03C3\03B9\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03AD\03BD\03B1 \03B3\03C1\03AC\03C6\03B7\03BC\03B1 \03C4\03BF \03BF\03C0\03BF\03AF\03BF \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03C9\03C2 \03BE\03B5\03C7\03C9\03C1\03B9\03C3\03C4\03AE \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.<br>'),
unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03AD\03BD\03B1\03BD \03C4\03CD\03C0\03BF \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2 \03BA\03B1\03B9 \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03AC \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2.</p>'),
unistr('<p><strong>\03A7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03AC \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2</strong></br>'),
unistr('\03A4\03B1 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B1 \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03AC \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2 \03C0\03BF\03B9\03BA\03AF\03BB\03BF\03C5\03BD \03B1\03BD\03AC\03BB\03BF\03B3\03B1 \03BC\03B5 \03C4\03BF\03BD \03C4\03CD\03C0\03BF \03C4\03BF\03C5 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2.</p>'),
'<p>',
'<ul>',
unistr('  <li>\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C4\03B7 \03C3\03C4\03AE\03BB\03B7 \03C0\03BF\03C5 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03C4\03B7\03BD \03C4\03B9\03BC\03AE \03B3\03B9\03B1 \03C4\03BF \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03CC:'),
'    <ul>',
unistr('      <li>\0395\03C4\03B9\03BA\03AD\03C4\03B1 - \03A4\03BF \03BA\03B5\03AF\03BC\03B5\03BD\03BF \03B3\03B9\03B1 \03BA\03AC\03B8\03B5 \03C3\03B7\03BC\03B5\03AF\03BF \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.</li>'),
unistr('      <li>\03A4\03B9\03BC\03AE - \03A4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03C0\03C1\03BF\03C2 \03C7\03B1\03C1\03C4\03BF\03B3\03C1\03AC\03C6\03B7\03C3\03B7.</li>'),
unistr('      <li>\03A3\03B5\03B9\03C1\03AC - \0393\03B9\03B1 \03C4\03BF\03BD \03BF\03C1\03B9\03C3\03BC\03CC \03B4\03C5\03BD\03B1\03BC\03B9\03BA\03BF\03CD \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03CE\03BD \03C3\03B5\03B9\03C1\03CE\03BD.</li>'),
unistr('      <li>\0386\03BD\03BF\03B9\03B3\03BC\03B1 - \0397 \03B7\03BC\03B5\03C1\03AE\03C3\03B9\03B1 \03C4\03B9\03BC\03AE \03B1\03BD\03BF\03AF\03B3\03BC\03B1\03C4\03BF\03C2 \03BC\03B5\03C4\03BF\03C7\03AE\03C2 (\039C\03CC\03BD\03BF \03C3\03C9\03C1\03B5\03C5\03C4\03B9\03BA\03CC).</li>'),
unistr('      <li>\039A\03BB\03B5\03AF\03C3\03B9\03BC\03BF - \0397 \03B7\03BC\03B5\03C1\03AE\03C3\03B9\03B1 \03C4\03B9\03BC\03AE \03BA\03BB\03B5\03B9\03C3\03AF\03BC\03B1\03C4\03BF\03C2 \03BC\03B5\03C4\03BF\03C7\03AE\03C2 (\039C\03CC\03BD\03BF \03C3\03C9\03C1\03B5\03C5\03C4\03B9\03BA\03CC).</li>'),
unistr('      <li>\03A5\03C8\03B7\03BB\03AE - \0397 \03C5\03C8\03B7\03BB\03AE \03C4\03B9\03BC\03AE (\039C\03CC\03BD\03BF \03B5\03CD\03C1\03BF\03C2 \03BA\03B1\03B9 \03C3\03C9\03C1\03B5\03C5\03C4\03B9\03BA\03CC).</li>'),
unistr('      <li>\03A7\03B1\03BC\03B7\03BB\03AE - \0397 \03C7\03B1\03BC\03B7\03BB\03AE \03C4\03B9\03BC\03AE (\039C\03CC\03BD\03BF \03B5\03CD\03C1\03BF\03C2 \03BA\03B1\03B9 \03C3\03C9\03C1\03B5\03C5\03C4\03B9\03BA\03CC).</li>'),
unistr('      <li>\038C\03B3\03BA\03BF\03C2 - \039F \03B7\03BC\03B5\03C1\03AE\03C3\03B9\03BF\03C2 \03CC\03B3\03BA\03BF\03C2 \03BC\03B5\03C4\03BF\03C7\03CE\03BD (\039C\03CC\03BD\03BF \03C3\03C9\03C1\03B5\03C5\03C4\03B9\03BA\03CC).</li>'),
unistr('      <li>\03A0\03C1\03BF\03BF\03C1\03B9\03C3\03BC\03CC\03C2 - \0397 \03C4\03B9\03BC\03AE \03C0\03C1\03BF\03BF\03C1\03B9\03C3\03BC\03BF\03CD (\039C\03CC\03BD\03BF \03C7\03BF\03AC\03BD\03B7).</li>'),
unistr('      <li>X - \0397 \03C4\03B9\03BC\03AE \03C4\03BF\03C5 \03AC\03BE\03BF\03BD\03B1 x (\039C\03CC\03BD\03BF \03B3\03B9\03B1 \03C6\03C5\03C3\03B1\03BB\03AF\03B4\03B5\03C2 \03BA\03B1\03B9 \03B4\03B9\03B1\03C3\03C0\03BF\03C1\03AC).</li>'),
unistr('      <li>Y - \0397 \03C4\03B9\03BC\03AE \03C4\03BF\03C5 \03AC\03BE\03BF\03BD\03B1 y (\039C\03CC\03BD\03BF \03B3\03B9\03B1 \03C6\03C5\03C3\03B1\03BB\03AF\03B4\03B5\03C2 \03BA\03B1\03B9 \03B4\03B9\03B1\03C3\03C0\03BF\03C1\03AC).</li>'),
unistr('      <li>Z - \03A4\03BF \03C0\03BB\03AC\03C4\03BF\03C2 \03C1\03AC\03B2\03B4\03BF\03C5 \03AE \03B7 \03B1\03BA\03C4\03AF\03BD\03B1 \03C6\03C5\03C3\03B1\03BB\03AF\03B4\03C9\03BD (\039C\03CC\03BD\03BF \03C1\03AC\03B2\03B4\03BF\03C2, \03C6\03C5\03C3\03B1\03BB\03AF\03B4\03B1 \03BA\03B1\03B9 \03B5\03CD\03C1\03BF\03C2).</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\03A0\03C1\03BF\03C3\03B1\03BD\03B1\03C4\03BF\03BB\03B9\03C3\03BC\03CC\03C2 - \03BA\03B1\03C4\03B1\03BA\03CC\03C1\03C5\03C6\03BF\03C2 \03AE \03BF\03C1\03B9\03B6\03CC\03BD\03C4\03B9\03BF\03C2.</li>'),
unistr('  <li>\03A3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7 - \0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C4\03BF\03BD \03C4\03C1\03CC\03C0\03BF \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7\03C2 \03C4\03C9\03BD \03C4\03B9\03BC\03CE\03BD \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2.</li>'),
unistr('  <li>\03A3\03C9\03C1\03B5\03C5\03C4\03B9\03BA\03CC - \039A\03B1\03B8\03BF\03C1\03AF\03C3\03C4\03B5 \03B1\03BD \03C4\03B1 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C3\03C5\03C3\03C3\03C9\03C1\03B5\03CD\03BF\03BD\03C4\03B1\03B9.</li>'),
unistr('  <li>\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03BA\03B1\03C4\03AC - \03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03B2\03AC\03C3\03B5\03B9 \03C4\03B7\03C2 \03B5\03C4\03B9\03BA\03AD\03C4\03B1\03C2 \03AE \03C4\03C9\03BD \03C4\03B9\03BC\03CE\03BD.'),
'    <ul>',
unistr('      <li>\039A\03B1\03C4\03B5\03CD\03B8\03C5\03BD\03C3\03B7 - \03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03B2\03AC\03C3\03B5\03B9 \03B1\03CD\03BE\03BF\03C5\03C3\03B1\03C2 \03AE \03C6\03B8\03AF\03BD\03BF\03C5\03C3\03B1\03C2 \03C4\03B9\03BC\03AE\03C2.</li>'),
unistr('      <li>Nulls - \039A\03B1\03B8\03BF\03C1\03AF\03B6\03B5\03B9 \03C4\03BF\03BD \03C4\03C1\03CC\03C0\03BF \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2 \03B5\03B3\03B3\03C1\03B1\03C6\03CE\03BD \03BC\03B5 \03C4\03B9\03BC\03AD\03C2 null, \03C3\03B5 \03C3\03C7\03AD\03C3\03B7 \03BC\03B5 \03C4\03B9\03C2 \03B5\03B3\03B3\03C1\03B1\03C6\03AD\03C2 \03C7\03C9\03C1\03AF\03C2 \03C4\03B9\03BC\03AD\03C2 null.</li>'),
'    </ul>',
'  </li>',
unistr('  <li>\0394\03B5\03BA\03B1\03B4\03B9\03BA\03AD\03C2 \03B8\03AD\03C3\03B5\03B9\03C2</li>'),
unistr('  <li>\03A4\03AF\03C4\03BB\03BF\03C2 \03AC\03BE\03BF\03BD\03B1 \03B5\03C4\03B9\03BA\03B5\03C4\03CE\03BD</li>'),
unistr('  <li>\03A4\03AF\03C4\03BB\03BF\03C2 \03AC\03BE\03BF\03BD\03B1 \03C4\03B9\03BC\03CE\03BD</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111411282571399361)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03B3\03C1\03AC\03C6\03B7\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111408305426399359)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03BB\03B1\03AF\03C3\03B9\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03BD\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \03C0\03BF\03B9\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03BA\03B1\03B9 \03BC\03B5 \03C0\03BF\03B9\03B1 \03C3\03B5\03B9\03C1\03AC \03B8\03B1 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9.</p>'),
'',
unistr('<p>\039A\03C1\03CD\03C8\03C4\03B5 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 \03BA\03B1\03C4\03B1\03C1\03B3\03CE\03BD\03C4\03B1\03C2 \03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03C4\03B7\03C2.<br>'),
unistr('\0391\03BB\03BB\03AC\03BE\03C4\03B5 \03C4\03B7 \03C3\03B5\03B9\03C1\03AC \03C4\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03C0\03C1\03BF\03C2 \03C4\03B1 \03C0\03AC\03BD\03C9 ( &uarr; ) \03AE \039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03C0\03C1\03BF\03C2 \03C4\03B1 \03BA\03AC\03C4\03C9 ( &darr; ).<br>'),
unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03BF \03B1\03BD\03B1\03C0\03C4\03C5\03C3\03C3\03CC\03BC\03B5\03BD\03BF \03BC\03B5\03BD\03BF\03CD \03B3\03B9\03B1 \03BD\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \038C\03BB\03B5\03C2 \03BF\03B9 \03C3\03C4\03AE\03BB\03B5\03C2, \0395\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03AE \039C\03B7 \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2.</p>'),
'',
unistr('<p>\03A0\03C1\03BF\03B1\03B9\03C1\03B5\03C4\03B9\03BA\03AC, \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B7 \03C6\03CC\03C1\03BC\03B1 \03B3\03B9\03B1 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03BF \03B5\03BB\03AC\03C7\03B9\03C3\03C4\03BF \03C0\03BB\03AC\03C4\03BF\03C2 \03BC\03B9\03B1\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03B5 pixel.</p>'),
'',
unistr('<p><em>\03A3\03B7\03BC\03B5\03AF\03C9\03C3\03B7: \039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03B5\03C0\03AF\03C3\03B7\03C2 \03BD\03B1 \03B1\03BB\03BB\03AC\03BE\03B5\03C4\03B5 \03C4\03B7 \03C3\03B5\03B9\03C1\03AC \03C4\03C9\03BD \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03B7 \03BB\03B1\03B2\03AE (\03C3\03C4\03B7\03BD \03B1\03C1\03C7\03AE \03C4\03B7\03C2 \03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1\03C2 \03BA\03AC\03B8\03B5 \03C3\03C4\03AE\03BB\03B7\03C2) \03BA\03B1\03B9 \03C3\03CD\03C1\03BF\03BD\03C4\03B1\03C2 \03C4\03B9\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03B1\03C1\03B9\03C3\03C4\03B5\03C1\03AC \03AE \03B4\03B5\03BE\03B9\03AC. \0395\03C0\03B9\03C0\03BB\03AD\03BF\03BD, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B1\03BB\03BB\03AC\03BE\03B5\03C4\03B5 \03C4\03BF \03C0\03BB\03AC\03C4\03BF\03C2 \03C4\03C9\03BD \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD \03B5\03C0')
||unistr('\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03B1\03C2 \03C4\03BF \03B4\03B9\03B1\03C7\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C3\03C4\03AE\03BB\03B7\03C2 \03B1\03BD\03AC\03BC\03B5\03C3\03B1 \03C3\03C4\03B9\03C2 \03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B5\03C2 \03BA\03B1\03B9 \03BC\03B5\03C4\03B1\03BA\03B9\03BD\03CE\03BD\03C4\03B1\03C2 \03C4\03BF \03B1\03C1\03B9\03C3\03C4\03B5\03C1\03AC \03AE \03B4\03B5\03BE\03B9\03AC.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111411132091399361)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03C3\03C4\03AE\03BB\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111408701010399359)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03B1\03C1\03AC\03B8\03C5\03C1\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C0\03C1\03CC\03C3\03B8\03B5\03C4\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03BC\03B5 \03B2\03AC\03C3\03B7 \03C4\03BF\03C5\03C2 \03BC\03B1\03B8\03B7\03BC\03B1\03C4\03B9\03BA\03BF\03CD\03C2 \03AE \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03B9\03BA\03BF\03CD\03C2 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD\03C2 \03C0\03BF\03C5 \03B5\03BA\03C4\03B5\03BB\03BF\03CD\03BD\03C4\03B1\03B9 \03C3\03C4\03B9\03C2 \03C5\03C0\03AC\03C1\03C7\03BF\03C5\03C3\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2.</p>'),
'',
unistr('<p><strong>\039B\03AF\03C3\03C4\03B1 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD</strong><br>'),
unistr('\0397 \03BB\03AF\03C3\03C4\03B1 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03B9 \03C4\03BF\03C5\03C2 \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03BF\03C5\03C2 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD\03C2. \0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03AD\03BD\03B1\03BD \03C5\03C0\03AC\03C1\03C7\03BF\03BD\03C4\03B1 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC \03BA\03B1\03C4\03B1\03C1\03B3\03CE\03BD\03C4\03B1\03C2 \03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03C4\03BF\03C5.<br>'),
unistr('\039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7" ( &plus; ) \03B3\03B9\03B1 \03BD\03B1 \03C0\03C1\03BF\03C3\03B8\03AD\03C3\03B5\03C4\03B5 \03AD\03BD\03B1\03BD \03BD\03AD\03BF \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC \03AE \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE" ( &minus; ) \03B3\03B9\03B1 \03BD\03B1 \03BA\03B1\03C4\03B1\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03AD\03BD\03B1\03BD \03C5\03C0\03AC\03C1\03C7\03BF\03BD\03C4\03B1 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC.</p>'),
'',
unistr('<p><strong>\03A1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD</strong><br>'),
unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B7 \03C6\03CC\03C1\03BC\03B1 \03B3\03B9\03B1 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03AD\03BD\03B1\03BD \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC .<br>'),
unistr('\0395\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03C4\03B9\03C2 \03BB\03B5\03C0\03C4\03BF\03BC\03AD\03C1\03B5\03B9\03B5\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03CC\03C0\03C9\03C2 \03C4\03B7\03BD \03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1, \03C4\03B7\03BD \03B5\03C4\03B9\03BA\03AD\03C4\03B1 \03BA\03B1\03B9 \03B5\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C4\03B9\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03C3\03C4\03BF\03AF\03C7\03B9\03C3\03B7\03C2.<br> '),
unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B7\03BD \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5 "\03A0\03B1\03C1\03AC\03C3\03C4\03B1\03C3\03B7" \03B3\03B9\03B1 \03BD\03B1 \03B5\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03C4\03B9\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03BA\03B1\03B9 \03C4\03B9\03C2 \03C3\03C7\03B5\03C4\03B9\03B6\03CC\03BC\03B5\03BD\03B5\03C2 \03C3\03C5\03BD\03B1\03C1\03C4\03AE\03C3\03B5\03B9\03C2 \03B3\03B9\03B1 \03C4\03BF\03BD \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC.<br>'),
unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C4\03BF\03BD \03BA\03B1\03C4\03AC\03BB\03BB\03B7\03BB\03BF \03C4\03CD\03C0\03BF \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03BA\03B1\03B9, \03C0\03C1\03BF\03B1\03B9\03C1\03B5\03C4\03B9\03BA\03AC, \03BC\03B9\03B1 \03BC\03AC\03C3\03BA\03B1 \03BC\03BF\03C1\03C6\03AE\03C2 \03B3\03B9\03B1 \03C4\03B7 \03BD\03AD\03B1 \03C3\03C4\03AE\03BB\03B7.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111410711696399361)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111409081873399359)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03B1\03C1\03AC\03B8\03C5\03C1\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03AD\03BD\03B1 control break \03C3\03B5 \03BC\03AF\03B1 \03AE \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2.</p>'),
'',
unistr('<p><strong>\039B\03AF\03C3\03C4\03B1 control break</strong><br>'),
unistr('\0397 \03BB\03AF\03C3\03C4\03B1 control break \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03B9 \03C4\03B1 \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03B1 control break. \0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03BC\03B9\03B1 \03C5\03C0\03AC\03C1\03C7\03BF\03C5\03C3\03B1 \03C3\03C4\03AE\03BB\03B7 control break \03BA\03B1\03C4\03B1\03C1\03B3\03CE\03BD\03C4\03B1\03C2 \03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03C4\03B7\03C2.<br>'),
unistr('\039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7" ( &plus; ) \03B3\03B9\03B1 \03BD\03B1 \03C3\03C5\03BC\03C0\03B5\03C1\03B9\03BB\03AC\03B2\03B5\03C4\03B5 \03BC\03B9\03B1 \03BD\03AD\03B1 \03C3\03C4\03AE\03BB\03B7 \03C3\03C4\03BF control break \03AE \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE" ( &minus; ) \03B3\03B9\03B1 \03BD\03B1 \03BA\03B1\03C4\03B1\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C5\03C0\03AC\03C1\03C7\03BF\03C5\03C3\03B1 \03C3\03C4\03AE\03BB\03B7 \03B1\03C0\03CC \03C4\03BF control break.<br>'),
unistr('\0393\03B9\03B1 \03BD\03B1 \03B1\03BB\03BB\03AC\03BE\03B5\03C4\03B5 \03C4\03B7 \03C3\03B5\03B9\03C1\03AC \03C4\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD, \03BA\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03C0\03C1\03BF\03C2 \03C4\03B1 \03C0\03AC\03BD\03C9" ( &uarr; ) \03AE "\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03C0\03C1\03BF\03C2 \03C4\03B1 \03BA\03AC\03C4\03C9" ( &darr; ) \03B3\03B9\03B1 \03BD\03B1 \03BC\03B5\03C4\03B1\03BA\03B9\03BD\03AE\03C3\03B5\03C4\03B5 \03C4\03B7\03BD \03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7 \03C3\03C4\03AE\03BB\03B7 \03C0\03C1\03BF\03C2 \03C4\03B1 \03C0\03AC\03BD\03C9 \03AE \03C0\03C1\03BF\03C2 \03C4\03B1 \03BA\03AC\03C4\03C9 \03C3\03B5 \03C3\03C7\03AD\03C3\03B7 \03BC\03B5 \03C4\03B9\03C2 \03AC\03BB\03BB\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2.</p>'),
'',
unistr('<p><strong>\03A1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 control break</strong><br>'),
unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B7 \03C6\03CC\03C1\03BC\03B1 \03B3\03B9\03B1 \03BD\03B1 \03BA\03B1\03B8\03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03B7 \03C3\03C4\03AE\03BB\03B7 control break.<br>'),
unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 control break, \03C4\03B7\03BD \03BA\03B1\03C4\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03C4\03B7\03C2 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2 \03BA\03B1\03B9 \03C4\03BF\03BD \03C4\03C1\03CC\03C0\03BF \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2 \03C4\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD null (\03C3\03C4\03AE\03BB\03B5\03C2 \03C7\03C9\03C1\03AF\03C2 \03C4\03B9\03BC\03AE).</p>'),
'',
unistr('<p><em>\03A3\03B7\03BC\03B5\03AF\03C9\03C3\03B7: \039A\03B1\03C4\03AC \03C4\03B7\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03C4\03BF\03C5 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03BF\03CD \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03AD\03BD\03B1 control break, \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03B5 \03BC\03B9\03B1 \03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1 \03C3\03C4\03AE\03BB\03B7\03C2 \03BA\03B1\03B9 \03B5\03C0\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03B1\03C2 \03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF control break.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111410487244399360)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03C4\03BF\03BC\03AE \03B5\03BB\03AD\03B3\03C7\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111409263819399359)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03B1\03C1\03AC\03B8\03C5\03C1\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03BD\03B1 \03BA\03AC\03BD\03B5\03C4\03B5 \03BB\03AE\03C8\03B7 \03CC\03BB\03C9\03BD \03C4\03C9\03BD \03C4\03C1\03B5\03C7\03BF\03C5\03C3\03CE\03BD \03C3\03B5\03B9\03C1\03CE\03BD \03C3\03B5 \03AD\03BD\03B1 \03B5\03BE\03C9\03C4\03B5\03C1\03B9\03BA\03CC \03B1\03C1\03C7\03B5\03AF\03BF. \03A4\03BF \03B1\03C1\03C7\03B5\03AF\03BF \03B8\03B1 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03BC\03CC\03BD\03BF \03C4\03B9\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03C0\03BF\03C5 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03C4\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B7 \03C3\03C4\03B9\03B3\03BC\03AE, \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03CE\03BD\03C4\03B1\03C2 \03C4\03C5\03C7\03CC\03BD \03C6\03AF\03BB\03C4\03C1\03B1 \03BA\03B1\03B9 \03C4\03B1\03BE\03B9\03BD\03BF\03BC\03AE\03C3\03B5\03B9\03C2 \03C0\03BF\03C5 \03B5\03C6\03B1\03C1\03BC\03CC\03B6\03BF\03BD\03C4\03B1')
||unistr('\03B9 \03C3\03C4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1.</p>'),
'',
unistr('<p>\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C4\03B7 \03BC\03BF\03C1\03C6\03AE \03B1\03C1\03C7\03B5\03AF\03BF\03C5 \03BA\03B1\03B9 \03BA\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\039B\03AE\03C8\03B7".<br>'),
unistr('\03A3\03B7\03BC\03B5\03AF\03C9\03C3\03B7: \03A4\03BF \03B1\03C1\03C7\03B5\03AF\03BF CSV \03B4\03B5\03BD \03B8\03B1 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BC\03BF\03C1\03C6\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5 \03CC\03C0\03C9\03C2 \03C3\03C5\03BD\03B1\03B8\03C1\03BF\03AF\03C3\03B5\03B9\03C2 \03BA\03B1\03B9 control break.</p>'),
'',
unistr('<p>\0393\03B9\03B1 \03BD\03B1 \03C3\03C4\03B5\03AF\03BB\03B5\03C4\03B5 \03C4\03BF \03B1\03C1\03C7\03B5\03AF\03BF \03BC\03AD\03C3\03C9 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5, \03B5\03C0\03B9\03BB\03AD\03BE\03C4\03B5 "\0391\03C0\03BF\03C3\03C4\03BF\03BB\03AE \03C9\03C2 \03BC\03B7\03BD\03CD\03BC\03B1\03C4\03BF\03C2 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5" \03BA\03B1\03B9 \03B5\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03C4\03B9\03C2 \03BB\03B5\03C0\03C4\03BF\03BC\03AD\03C1\03B5\03B9\03B5\03C2 \03C4\03BF\03C5 \03BC\03B7\03BD\03CD\03BC\03B1\03C4\03BF\03C2 (\0391\03C0\03BF\03C3\03C4\03BF\03BB\03AD\03B1\03C2, \0398\03AD\03BC\03B1 \03BA\03B1\03B9 \039C\03AE\03BD\03C5\03BC\03B1).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111410297654399360)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03BB\03AE\03C8\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111408407463399359)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03B1\03C1\03AC\03B8\03C5\03C1\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03BD\03B1 \03B4\03B9\03B1\03BC\03BF\03C1\03C6\03CE\03C3\03B5\03C4\03B5 \03C4\03B1 \03C6\03AF\03BB\03C4\03C1\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C0\03BF\03C5 \03C0\03B5\03C1\03B9\03BF\03C1\03AF\03B6\03BF\03C5\03BD \03C4\03B9\03C2 \03C3\03B5\03B9\03C1\03AD\03C2 \03C0\03BF\03C5 \03B5\03C0\03B9\03C3\03C4\03C1\03AD\03C6\03BF\03BD\03C4\03B1\03B9.</p>'),
'',
unistr('<p><strong>\039B\03AF\03C3\03C4\03B1 \03C6\03AF\03BB\03C4\03C1\03C9\03BD</strong><br>'),
unistr('\0397 \03BB\03AF\03C3\03C4\03B1 \03C6\03AF\03BB\03C4\03C1\03C9\03BD \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03B9 \03C4\03B1 \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03B1 \03C6\03AF\03BB\03C4\03C1\03B1. \0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03AD\03BD\03B1 \03C5\03C0\03AC\03C1\03C7\03BF\03BD \03C6\03AF\03BB\03C4\03C1\03BF \03BA\03B1\03C4\03B1\03C1\03B3\03CE\03BD\03C4\03B1\03C2 \03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03C4\03BF\03C5.<br>'),
unistr('\039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7" ( &plus; ) \03B3\03B9\03B1 \03BD\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03AD\03BD\03B1 \03BD\03AD\03BF \03C6\03AF\03BB\03C4\03C1\03BF \03AE \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE" ( &minus; ) \03B3\03B9\03B1 \03BD\03B1 \03BA\03B1\03C4\03B1\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03AD\03BD\03B1 \03C6\03AF\03BB\03C4\03C1\03BF.</p>'),
'',
unistr('<p><strong>\03A1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03C6\03AF\03BB\03C4\03C1\03C9\03BD</strong><br>'),
unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B7 \03C6\03CC\03C1\03BC\03B1 \03B3\03B9\03B1 \03BD\03B1 \03BA\03B1\03B8\03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03B9\03C2 \03B9\03B4\03B9\03CC\03C4\03B7\03C4\03B5\03C2 \03C6\03AF\03BB\03C4\03C1\03BF\03C5.<br>'),
unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C4\03BF\03BD \03BA\03B1\03C4\03AC\03BB\03BB\03B7\03BB\03BF \03C4\03CD\03C0\03BF \03C6\03AF\03BB\03C4\03C1\03BF\03C5:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\03A3\03B5\03B9\03C1\03AC - \03C6\03AF\03BB\03C4\03C1\03BF \03B3\03B9\03B1 \03AD\03BD\03B1\03BD \03CC\03C1\03BF \03C3\03B5 \03BF\03C0\03BF\03B9\03B1\03B4\03AE\03C0\03BF\03C4\03B5 \03C3\03C4\03AE\03BB\03B7 \03BC\03B5 \03B4\03C5\03BD\03B1\03C4\03CC\03C4\03B7\03C4\03B1 \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\03A3\03C4\03AE\03BB\03B7 - \03C6\03AF\03BB\03C4\03C1\03BF \03B3\03B9\03B1 \03BC\03B9\03B1 \03C3\03C5\03B3\03BA\03B5\03BA\03C1\03B9\03BC\03AD\03BD\03B7 \03C3\03C4\03AE\03BB\03B7 \03BC\03B5 \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03BF \03C4\03B5\03BB\03B5\03C3\03C4\03AE \03BA\03B1\03B9 \03C4\03B9\03BC\03AE.</p>'),
'',
unistr('<p><em>\03A3\03B7\03BC\03B5\03AF\03C9\03C3\03B7: \039A\03B1\03C4\03AC \03C4\03B7\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03C4\03BF\03C5 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03BF\03CD \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C6\03AF\03BB\03C4\03C1\03B1 \03C3\03B5\03B9\03C1\03CE\03BD, \03C0\03BB\03B7\03BA\03C4\03C1\03BF\03BB\03BF\03B3\03CE\03BD\03C4\03B1\03C2 \03B1\03C0\03B5\03C5\03B8\03B5\03AF\03B1\03C2 \03C3\03C4\03BF \03C0\03B5\03B4\03AF\03BF \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2. \039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD "\0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03C4\03B7\03BB\03CE\03BD \03B3\03B9\03B1 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7", \03B3\03B9\03B1 \03BD\03B1 \03C0\03B5\03C1\03B9\03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03B7\03BD \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7 \03C3\03B5 \03BC\03B9\03B1 \03C3\03C5\03B3\03BA\03B5\03BA\03C1\03B9\03BC\03AD\03BD\03B7 \03C3\03C4\03AE\03BB')
||unistr('\03B7. \0395\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AC, \03B1\03BD\03BF\03AF\03BE\03C4\03B5 \03AD\03BD\03B1 \03BC\03B5\03BD\03BF\03CD \03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03BA\03B1\03B9 \03B5\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03BC\03B9\03B1 \03C4\03B9\03BC\03AE \03B3\03B9\03B1 \03BD\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03AD\03BD\03B1 \03C6\03AF\03BB\03C4\03C1\03BF \03C3\03C4\03AE\03BB\03B7\03C2.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111411076547399361)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03C6\03B9\03BB\03C4\03C1\03AC\03C1\03B9\03C3\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111408857738399359)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03B1\03C1\03AC\03B8\03C5\03C1\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03BD\03B1 \03C0\03C1\03BF\03B2\03AC\03BB\03B5\03C4\03B5 \03C4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03CC\03C0\03C9\03C2 \03C5\03C0\03AE\03C1\03C7\03B1\03BD \03C3\03B5 \03AD\03BD\03B1 \03C0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF \03C7\03C1\03BF\03BD\03B9\03BA\03CC \03C3\03B7\03BC\03B5\03AF\03BF.</p>'),
unistr('<p>\0395\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03BB\03B5\03C0\03C4\03CE\03BD \03C3\03C4\03BF \03C0\03B1\03C1\03B5\03BB\03B8\03CC\03BD \03B3\03B9\03B1 \03BD\03B1 \03B5\03BA\03C4\03B5\03BB\03AD\03C3\03B5\03C4\03B5 \03C4\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03B5\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111410660340399361)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03B1\03BD\03B1\03B4\03C1\03BF\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111411383504399361)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111408933646399359)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03B1\03C1\03AC\03B8\03C5\03C1\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03BD\03B1 \03B5\03C0\03B9\03C3\03B7\03BC\03AC\03BD\03B5\03C4\03B5 \03C3\03B5\03B9\03C1\03AD\03C2 \03AE \03C3\03C4\03AE\03BB\03B5\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03BC\03B5 \03B2\03AC\03C3\03B7 \03C4\03B7 \03C3\03C5\03BD\03B8\03AE\03BA\03B7 \03C0\03BF\03C5 \03B5\03B9\03C3\03AC\03B3\03B5\03C4\03B1\03B9.</p>'),
'',
unistr('<p><strong>\039B\03AF\03C3\03C4\03B1 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2</strong><br>'),
unistr('\0397 \03BB\03AF\03C3\03C4\03B1 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03B9 \03C4\03B9\03C2 \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03B5\03C2 \03B5\03C0\03B9\03C3\03B7\03BC\03AC\03BD\03C3\03B5\03B9\03C2. \0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03BC\03B9\03B1 \03C5\03C0\03AC\03C1\03C7\03BF\03C5\03C3\03B1 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7 \03BA\03B1\03C4\03B1\03C1\03B3\03CE\03BD\03C4\03B1\03C2 \03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03C4\03BF\03C5.<br>'),
unistr('\039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7" ( &plus; ) \03B3\03B9\03B1 \03BD\03B1 \03C0\03C1\03BF\03C3\03B8\03AD\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03BD\03AD\03B1 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7 \03AE \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE" ( &minus; ) \03B3\03B9\03B1 \03BD\03B1 \03BA\03B1\03C4\03B1\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C5\03C0\03AC\03C1\03C7\03BF\03C5\03C3\03B1 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7 .</p>'),
'',
unistr('<p><strong>\03A1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2</strong><br>'),
unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B7 \03C6\03CC\03C1\03BC\03B1 \03B3\03B9\03B1 \03BD\03B1 \03BA\03B1\03B8\03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03B9\03C2 \03B9\03B4\03B9\03CC\03C4\03B7\03C4\03B5\03C2 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2.<br>'),
unistr('\0395\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03C4\03BF \03CC\03BD\03BF\03BC\03B1, \03B5\03C0\03B9\03BB\03AD\03BE\03C4\03B5 "\03A3\03B5\03B9\03C1\03AC" \03AE "\03A3\03C4\03AE\03BB\03B7" \03BA\03B1\03B9 \03AD\03C0\03B5\03B9\03C4\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C4\03BF\03C5\03C2 \03BA\03C9\03B4\03B9\03BA\03BF\03CD\03C2 \03C7\03C1\03C9\03BC\03AC\03C4\03C9\03BD HTML \03B3\03B9\03B1 \03C4\03BF \03C6\03CC\03BD\03C4\03BF \03BA\03B1\03B9 \03C4\03BF \03BA\03B5\03AF\03BC\03B5\03BD\03BF.<br>'),
unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C4\03BF\03BD \03BA\03B1\03C4\03AC\03BB\03BB\03B7\03BB\03BF <strong>\03A4\03CD\03C0\03BF \03C3\03C5\03BD\03B8\03AE\03BA\03B7\03C2</strong> \03B3\03B9\03B1 \03BD\03B1 \03B5\03C0\03B9\03C3\03B7\03BC\03AC\03BD\03B5\03C4\03B5 \03C3\03C5\03B3\03BA\03B5\03BA\03C1\03B9\03BC\03AD\03BD\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1:<br>'),
unistr('&nbsp;&nbsp;&nbsp;\03A3\03B5\03B9\03C1\03AC - \03B5\03C0\03B9\03C3\03B7\03BC\03AC\03BD\03B5\03C4\03B5 \03C4\03BF\03BD \03CC\03C1\03BF \03C3\03B5 \03BF\03C0\03BF\03B9\03B1\03B4\03AE\03C0\03BF\03C4\03B5 \03C3\03C4\03AE\03BB\03B7.<br>'),
unistr('&nbsp;&nbsp;&nbsp;\03A3\03C4\03AE\03BB\03B7 - \03B5\03C0\03B9\03C3\03B7\03BC\03AC\03BD\03B5\03C4\03B5 \03B5\03BD\03C4\03CC\03C2 \03BC\03B9\03B1\03C2 \03C3\03C5\03B3\03BA\03B5\03BA\03C1\03B9\03BC\03AD\03BD\03B7\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03BC\03B5 \03B2\03AC\03C3\03B7 \03C4\03BF\03BD \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03BF \03C4\03B5\03BB\03B5\03C3\03C4\03AE \03BA\03B1\03B9 \03C4\03B7\03BD \03C4\03B9\03BC\03AE.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111410528034399360)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111409179728399359)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03B1\03C1\03AC\03B8\03C5\03C1\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C3\03B5\03C4\03B5 \03C4\03B9\03C2 \03B1\03BB\03BB\03B1\03B3\03AD\03C2 \03C0\03BF\03C5 \03AD\03C7\03B5\03C4\03B5 \03BA\03AC\03BD\03B5\03B9 \03C3\03C4\03B7\03BD \03C4\03C1\03AD\03C7\03BF\03C5\03C3\03B1 \03B4\03B9\03AC\03C4\03B1\03BE\03B7 \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03BA\03B1\03B9 \03C4\03B7 \03B4\03B9\03B1\03BC\03CC\03C1\03C6\03C9\03C3\03B7.<br>'),
unistr('\039F\03B9 \03C0\03C1\03BF\03B3\03C1\03B1\03BC\03BC\03B1\03C4\03B9\03C3\03C4\03AD\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03BF\03C1\03AF\03C3\03BF\03C5\03BD \03C0\03BF\03BB\03BB\03AD\03C2 \03B5\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AD\03C2 \03B4\03B9\03B1\03C4\03AC\03BE\03B5\03B9\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03CE\03BD. \038C\03C4\03B1\03BD \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03C4\03B1\03B9, \03B5\03C3\03B5\03AF\03C2 \03BA\03B1\03B9 \03AC\03BB\03BB\03BF\03B9 \03C4\03B5\03BB\03B9\03BA\03BF\03AF \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C9\03C2 \03B4\03B7\03BC\03CC\03C3\03B9\03B1, \03C4\03BF \03BF\03C0\03BF\03AF\03BF \03C4\03B7\03BD \03BA\03B1\03B8\03B9\03C3\03C4\03AC \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B7 \03C3\03B5 \03CC\03BB\03BF\03C5\03C2 \03C4\03BF\03C5\03C2 \03AC\03BB\03BB\03BF\03C5\03C2 \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03C4\03BF\03C5')
||unistr(' \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2. \039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03B5\03C0\03AF\03C3\03B7\03C2 \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C9\03C2 \03B9\03B4\03B9\03C9\03C4\03B9\03BA\03AE, \03CE\03C3\03C4\03B5 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03BF\03C1\03B1\03C4\03AE \03BC\03CC\03BD\03BF \03C3\03B5 \03B5\03C3\03AC\03C2.</p>'),
unistr('<p>\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03B1\03C0\03CC \03C4\03BF\03C5\03C2 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03BF\03C5\03C2 \03C4\03CD\03C0\03BF\03C5\03C2 \03BA\03B1\03B9 \03B5\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03AD\03BD\03B1 \03CC\03BD\03BF\03BC\03B1 \03B3\03B9\03B1 \03C4\03B7\03BD \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111410387488399360)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111408517513399359)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03BB\03B1\03AF\03C3\03B9\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03B7 \03C3\03B5\03B9\03C1\03AC \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7\03C2.</p>'),
'',
unistr('<p><strong>\039B\03AF\03C3\03C4\03B1 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2</strong><br>'),
unistr('\03A4\03BF \03C0\03BB\03B1\03AF\03C3\03B9\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 "\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7" \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03B9 \03BC\03B9\03B1 \03BB\03AF\03C3\03C4\03B1 \03B4\03B9\03B1\03BC\03BF\03C1\03C6\03C9\03BC\03AD\03BD\03C9\03BD \03BA\03B1\03BD\03CC\03BD\03C9\03BD \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2.<br>'),
unistr('\039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7" ( &plus; ) \03B3\03B9\03B1 \03BD\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2 \03AE \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE" ( &minus; ) \03B3\03B9\03B1 \03BD\03B1 \03B1\03C6\03B1\03B9\03C1\03AD\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2.<br>'),
unistr('\039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B9\03C2 \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03C2 "\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03C0\03C1\03BF\03C2 \03C4\03B1 \03C0\03AC\03BD\03C9" ( &uarr; ) \03BA\03B1\03B9 "\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03C0\03C1\03BF\03C2 \03C4\03B1 \03BA\03AC\03C4\03C9" ( &darr; ) \03B3\03B9\03B1 \03BD\03B1 \03BC\03B5\03C4\03B1\03BA\03B9\03BD\03AE\03C3\03B5\03C4\03B5 \03C4\03B7\03BD \03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7 \03C3\03C4\03AE\03BB\03B7 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2 \03C0\03C1\03BF\03C2 \03C4\03B1 \03C0\03AC\03BD\03C9 \03BA\03B1\03B9 \03C0\03C1\03BF\03C2 \03C4\03B1 \03BA\03AC\03C4\03C9 \03C3\03B5 \03C3\03C7\03AD\03C3\03B7 \03BC\03B5 \03C4\03B9\03C2 \03AC\03BB\03BB\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2.</p>'),
'',
unistr('<p><strong>\03A1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2</strong><br>'),
unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2, \03C4\03B7\03BD \03BA\03B1\03C4\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03C4\03B7\03C2 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2 \03BA\03B1\03B9 \03C4\03BF\03BD \03C4\03C1\03CC\03C0\03BF \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2 \03C4\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD null (\03C3\03C4\03AE\03BB\03B5\03C2 \03C7\03C9\03C1\03AF\03C2 \03C4\03B9\03BC\03AE).</p>'),
'',
unistr('<p><em>\03A3\03B7\03BC\03B5\03AF\03C9\03C3\03B7: \03A4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03C4\03B1\03BE\03B9\03BD\03BF\03BC\03B7\03B8\03BF\03CD\03BD \03BA\03B1\03C4\03AC \03C3\03C4\03AE\03BB\03B5\03C2 \03BF\03B9 \03BF\03C0\03BF\03AF\03B5\03C2 \03B4\03B5\03BD \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9. \03A9\03C3\03C4\03CC\03C3\03BF, \03B5\03BD\03B4\03AD\03C7\03B5\03C4\03B1\03B9 \03BD\03B1 \03BC\03B7\03BD \03AD\03C7\03BF\03C5\03BD \03CC\03BB\03B5\03C2 \03BF\03B9 \03C3\03C4\03AE\03BB\03B5\03C2 \03B4\03C5\03BD\03B1\03C4\03CC\03C4\03B7\03C4\03B1 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2.</em><br>'),
unistr('<em>\039F\03B9 \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03C4\03B1\03BE\03B9\03BD\03BF\03BC\03B7\03B8\03BF\03CD\03BD \03C0\03B1\03C4\03CE\03BD\03C4\03B1\03C2 \03C4\03BF \03C0\03AC\03BD\03C9 \03B2\03AD\03BB\03BF\03C2 (\03B1\03CD\03BE\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC) \03AE \03C4\03BF \03BA\03AC\03C4\03C9 \03B2\03AD\03BB\03BF\03C2 (\03C6\03B8\03AF\03BD\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC) \03C3\03C4\03BF \03C4\03AD\03BB\03BF\03C2 \03C4\03C9\03BD \03BA\03B5\03C6\03B1\03BB\03AF\03B4\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD. \0393\03B9\03B1 \03BD\03B1 \03C0\03C1\03BF\03C3\03B8\03AD\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03B5\03C0\03CC\03BC\03B5\03BD\03B7 \03C3\03C4\03AE\03BB\03B7 \03C3\03B5 \03BC\03B9\03B1 \03C5\03C0\03AC\03C1\03C7\03BF\03C5\03C3\03B1 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7, \03BA\03C1\03B1\03C4\03AE\03C3\03C4\03B5 \03C0\03B1\03C4\03B7\03BC\03AD\03BD\03BF \03C4\03BF \03C0\03BB\03AE\03BA\03C4\03C1\03BF ')
||unistr('Shift \03BA\03B1\03B9 \03BA\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03C0\03AC\03BD\03C9 \03AE \03BA\03AC\03C4\03C9 \03B2\03AD\03BB\03BF\03C2.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111410932101399361)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111410142363399360)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03C3\03C5\03BD\03B4\03C1\03BF\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111362439936399325)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03CC\03BA\03C1\03C5\03C8\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111329251448399301)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111397240332399351)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A5\03C8\03B7\03BB\03CC \03B5\03C0\03AF\03C0\03B5\03B4\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111398004925399351)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03C1\03B9\03B6\03CC\03BD\03C4\03B9\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111355435128399320)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('\03CE\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111360404080399324)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111328138895399300)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03B5\03B9\03BA\03BF\03BD\03B9\03B4\03AF\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111353646405399319)
,p_name=>'APEX.IG.IN'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03BD\03C4\03CC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111362049204399325)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B5\03BD\03B5\03C1\03B3\03AE \03C1\03CD\03B8\03BC\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111362197003399325)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B5\03BD\03B5\03C1\03B3\03AD\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111369761092399331)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03B5\03C3\03C9\03C4\03B5\03C1\03B9\03BA\03CC \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03B1\03AF\03C4\03B7\03C3\03B7\03C2 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03BF\03CD \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111265569949399255)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C4\03CD\03C0\03BF\03C2 \03C6\03AF\03BB\03C4\03C1\03BF\03C5 \03C3\03C4\03AE\03BB\03B7\03C2 "%0" \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03B7 \03C3\03C4\03AE\03BB\03B7 "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111409987415399360)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03BC\03BF\03C1\03C6\03AE \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111384177135399341)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03CC \03C0\03BB\03AD\03B3\03BC\03B1 \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03B9 \03C4\03BF\03BD \03BF\03C1\03B9\03C3\03BC\03CC \03C6\03AF\03BB\03C4\03C1\03BF\03C5 \03C3\03C4\03B7 \03C3\03C4\03AE\03BB\03B7 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111384036195399341)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF %0 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03BF\03C2 \03C4\03CD\03C0\03BF\03C2 \03C6\03AF\03BB\03C4\03C1\03BF\03C5 \03B3\03B9\03B1 \03C4\03BF\03BD \03BF\03C1\03B9\03C3\03BC\03CC \03B5\03BD\03CC\03C2 \03C6\03AF\03BB\03C4\03C1\03BF\03C5 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03BF\03CD \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111270696292399259)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03BC\03BF\03C1\03C6\03AE \03B1\03C1\03B9\03B8\03BC\03BF\03CD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111412638167399362)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111412719703399362)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B5\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111403724724399355)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B5\03C0\03B9\03BB\03BF\03B3\03AE "\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03BC\03B5 \03B2\03AC\03C3\03B7" \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03C3\03B5 %0, \03B1\03BB\03BB\03AC \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03B5\03C0\03B9\03BB\03B5\03B3\03B5\03AF \03BA\03B1\03BC\03AF\03B1 \03C3\03C4\03AE\03BB\03B7 \03B3\03B9\03B1 \03C4\03BF %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111401001927399353)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C4\03B9\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111396132255399350)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111354445360399319)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111354617352399320)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03B5\03C0\03CC\03BC\03B5\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111353522245399319)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03BA\03B5\03BD\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111353466906399319)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03AF\03BD\03B1\03B9 \03BA\03B5\03BD\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111404563409399356)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C4\03B9\03BA\03AD\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111396598965399350)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C4\03B9\03BA\03AD\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111400496264399353)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111343792251399312)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03B7 \03B7\03BC\03AD\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111343979005399312)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 \03CE\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111344498231399312)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF \03BB\03B5\03C0\03C4\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111343430024399311)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF\03C2 \03BC\03AE\03BD\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111343504025399311)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111343622178399311)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %0 \03B7\03BC\03AD\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111343865924399312)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %0 \03CE\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111344514361399312)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 %0 \03BB\03B5\03C0\03C4\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111344311532399312)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF\03B9 %0 \03BC\03AE\03BD\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111344235165399312)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %0 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111343201148399311)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 %0 \03AD\03C4\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111343327630399311)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF \03AD\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111404791298399356)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03BF\03AF\03C7\03B9\03C3\03B7 \03BA\03B5\03BB\03B9\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111404823593399356)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03AE\03C3\03B7 \03BF\03BC\03AC\03B4\03B1\03C2 \03B3\03B9\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111354080011399319)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B9\03BA\03C1\03CC\03C4\03B5\03C1\03BF \03B1\03C0\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111354164466399319)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B9\03BA\03C1\03CC\03C4\03B5\03C1\03BF \03B1\03C0\03CC \03AE \03AF\03C3\03BF \03BC\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111398697140399352)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03C1\03B1\03BC\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111398747377399352)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03C1\03B1\03BC\03BC\03AE \03BC\03B5 \03C0\03B5\03C1\03B9\03BF\03C7\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111405103697399356)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'el'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111397316724399351)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03B1\03BC\03B7\03BB\03CC \03B5\03C0\03AF\03C0\03B5\03B4\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111407709584399358)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03C7\03C9\03C1\03B9\03C3\03BC\03CC\03C2 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03CE\03BD \03B4\03B9\03B5\03C5\03B8\03CD\03BD\03C3\03B5\03C9\03BD \03BC\03B5 \03BA\03CC\03BC\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111355280241399320)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03C5\03BC\03C6\03C9\03BD\03B5\03AF \03BC\03B5 \03BA\03B1\03BD\03BF\03BD\03B9\03BA\03AE \03AD\03BA\03C6\03C1\03B1\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111379622868399338)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03B3\03B9\03C3\03C4\03B7 \03C4\03B9\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111415216605399364)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03BF\03BB\03B9\03BA\03AE \03BC\03AD\03B3\03B9\03C3\03C4\03B7 \03C4\03B9\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111379878259399338)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03AC\03BC\03B5\03C3\03B7 \03C4\03B9\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111415364856399364)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03BF\03BB\03B9\03BA\03AE \03B4\03B9\03AC\03BC\03B5\03C3\03B7 \03C4\03B9\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111379524698399338)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BB\03AC\03C7\03B9\03C3\03C4\03B7 \03C4\03B9\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111355321061399320)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'el'
,p_message_text=>unistr('\03BB\03B5\03C0\03C4\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111380398271399338)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('\03BB\03B5\03C0\03C4\03AC \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111415171654399364)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03BF\03BB\03B9\03BA\03AE \03B5\03BB\03AC\03C7\03B9\03C3\03C4\03B7 \03C4\03B9\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111355742023399320)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03AE\03BD\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111362387468399325)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03C0\03B5\03C1\03B9\03AD\03C7\03BF\03C5\03BD \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B5\03C2 \03B1\03C0\03CC %0 \03C3\03B5\03B9\03C1\03AD\03C2. \039F\03B9 \03C3\03B5\03B9\03C1\03AD\03C2 \03C5\03C0\03B5\03C1\03B2\03B1\03AF\03BD\03BF\03C5\03BD \03C4\03BF\03BD \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03B5\03C0\03B9\03C4\03C1\03B5\03C0\03CC\03BC\03B5\03BD\03BF \03B1\03C1\03B9\03B8\03BC\03CC. \0395\03C6\03B1\03C1\03BC\03CC\03C3\03C4\03B5 \03C0\03C1\03CC\03C3\03B8\03B5\03C4\03B1 \03C6\03AF\03BB\03C4\03C1\03B1 \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03C4\03C9\03BD \03B1\03C0\03BF\03C4\03B5\03BB\03B5\03C3\03BC\03AC\03C4\03C9\03BD.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111389037880399344)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03B1\03C4\03B9\03BA\03CC \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C0\03B5\03C1\03B9\03BF\03C7\03AE\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03C4\03B5\03AF \03B5\03C0\03B5\03B9\03B4\03AE \03B7 \03C3\03B5\03BB\03AF\03B4\03B1 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03C0\03BF\03BB\03BB\03AC \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AC \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111358418242399322)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BD\03BF\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111358699521399323)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CE\03BD\03C5\03BC\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111342634387399311)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B7 \03BC\03AD\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111342474101399311)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B7 \03CE\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111344681235399312)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF \03BB\03B5\03C0\03C4\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111342983024399311)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF\03C2 \03BC\03AE\03BD\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111342864653399311)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B7 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111342736242399311)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B5\03C2 %0 \03B7\03BC\03AD\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111342517734399311)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B5\03C2 %0 \03CE\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111344711012399312)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B1 %0 \03BB\03B5\03C0\03C4\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111344051821399312)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF\03B9 %0 \03BC\03AE\03BD\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111344186883399312)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B5\03C2 %0 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111343188618399311)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B1 %0 \03AD\03C4\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111343065857399311)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF \03AD\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111354396173399319)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'el'
,p_message_text=>unistr('\03CC\03C7\03B9 \03BC\03B5\03C4\03B1\03BE\03CD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111353336548399319)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B5\03BD \03B9\03C3\03BF\03CD\03C4\03B1\03B9 \03BC\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111419539477399367)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03BC\03B5 \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC %0 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03BF\03CD \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03AE \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03C3\03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111353712372399319)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'el'
,p_message_text=>unistr('\03CC\03C7\03B9 \03B5\03BD\03C4\03CC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111354509746399320)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'el'
,p_message_text=>unistr('\03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111354787780399320)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03B5\03C0\03CC\03BC\03B5\03BD\03BF')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111362204136399325)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111400237866399353)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03BF\03B9\03C7\03B5\03AF\03B1 null')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111405399518399357)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C1\03B9\03B8\03BC\03B7\03C4\03B9\03BA\03AE \03C4\03B9\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111400595121399353)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111400657424399353)
,p_name=>'APEX.IG.ON'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111352572738399318)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('1 \03BB\03B5\03C0\03C4\03CC \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111408213006399359)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03BD\03BF\03B9\03B3\03BC\03B1 \03B5\03C1\03B3\03B1\03BB\03B5\03AF\03BF\03C5 \03B5\03C0\03B9\03BB\03BF\03B3\03AE\03C2 \03C7\03C1\03CE\03BC\03B1\03C4\03BF\03C2: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111397015495399351)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03BD\03BF\03B9\03B3\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111359552114399323)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C3\03C4\03AE\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111396421860399350)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B1\03BD\03B1\03C4\03BF\03BB\03B9\03C3\03BC\03CC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111398831263399352)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03AF\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111360801016399324)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03AF\03BD\03B1\03BA\03B1\03C2 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111328497872399301)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111408103496399359)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03C7\03C9\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03B9\03BC\03CE\03BD \03BC\03B5 "%0"')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111398926176399352)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BF\03BB\03B9\03BA\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111404252410399356)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03AD\03BD\03C4\03C1\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111404302351399356)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AE\03BE\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111404151287399356)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BD\03B1\03C1\03BE\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111358706104399323)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03CD\03C1\03B9\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111359053319399323)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03CD\03C1\03B9\03B1 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111375515759399335)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03CD\03C1\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111257780526399249)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BC\03C0\03B5\03C1\03AF\03BB\03B7\03C8\03B7 \03B5\03C4\03B9\03BA\03B5\03C4\03CE\03BD \03C0\03C1\03BF\03C3\03B2\03B1\03C3\03B9\03BC\03CC\03C4\03B7\03C4\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111256436902399248)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03C1\03B9\03B6\03CC\03BD\03C4\03B9\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111256592621399248)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03B1\03BA\03CC\03C1\03C5\03C6\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111256318413399248)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B1\03BD\03B1\03C4\03BF\03BB\03B9\03C3\03BC\03CC\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111256275915399248)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'el'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111256179455399248)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'el'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111257881101399249)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111255959715399248)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'el'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111255827660399248)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'el'
,p_message_text=>'Letter'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111256033022399248)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'el'
,p_message_text=>'Tabloid'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111255707036399248)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03B3\03B5\03B8\03BF\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111245987042399241)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BA\03BA\03B1\03B8\03AC\03C1\03B9\03C3\03B7 \03B5\03BC\03C0\03BB\03BF\03C5\03C4\03B9\03C3\03BC\03AD\03BD\03BF\03C5 \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111399026504399352)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C1\03B1\03C7\03BD\03BF\03B5\03B9\03B4\03AD\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111399109081399352)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03CD\03C1\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111409457762399360)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03BD\03AD\03C9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111363067575399326)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03BD\03AD\03C9\03C3\03B7 \03C3\03B5\03B9\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111361830498399325)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03BD\03AD\03C9\03C3\03B7 \03C3\03B5\03B9\03C1\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111367041055399329)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03BF\03CD \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03C3\03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE %0, \03C3\03B5\03BB\03AF\03B4\03B1 %1 \03BA\03B1\03B9 \03C0\03B5\03C1\03B9\03BF\03C7\03AE %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111329949788399302)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111358116948399322)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03C6\03BF\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111418785464399366)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B4\03B9\03B1\03B3\03C1\03AC\03C6\03B7\03BA\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111418409747399366)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B5\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C4\03B7\03BA\03B5 \03B3\03B9\03B1 \03CC\03BB\03BF\03C5\03C2 \03C4\03BF\03C5\03C2 \03C7\03C1\03AE\03C3\03C4\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111418307256399366)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C4\03B7\03BA\03B5 \03B3\03B9\03B1 \03CC\03BB\03BF\03C5\03C2 \03C4\03BF\03C5\03C2 \03C7\03C1\03AE\03C3\03C4\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111418683649399366)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B9\03B4\03B9\03C9\03C4\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C4\03B7\03BA\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111418562371399366)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B4\03B7\03BC\03CC\03C3\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C4\03B7\03BA\03B5 \03B3\03B9\03B1 \03CC\03BB\03BF\03C5\03C2 \03C4\03BF\03C5\03C2 \03C7\03C1\03AE\03C3\03C4\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111367145212399329)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03BF \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03CC \03C0\03BB\03AD\03B3\03BC\03B1 \03BC\03B5 \03CC\03BD\03BF\03BC\03B1 %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111352406296399318)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C0\03C1\03B9\03BD \03B1\03C0\03CC %0 \03BB\03B5\03C0\03C4\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111352350218399318)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C0\03C1\03B9\03BD \03B1\03C0\03CC 1 \03BB\03B5\03C0\03C4\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111292031650399274)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111411654243399361)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03C6\03BF\03C1\03AC - \0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111366928489399329)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03BF \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03CC \03C0\03BB\03AD\03B3\03BC\03B1 \03BC\03B5 \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111411542209399361)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03C6\03BF\03C1\03AC - \0391\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7 \03C9\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111330092352399302)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111419618655399367)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03BF \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03CC \03C0\03BB\03AD\03B3\03BC\03B1 \03BC\03B5 \03C3\03C4\03B1\03C4\03B9\03BA\03CC \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111414559738399363)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111329125454399301)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111363110644399326)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B1\03BB\03BB\03B1\03B3\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111361970903399325)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C3\03B5\03B9\03C1\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111359115484399323)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111358051029399322)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AD\03C2 \03B1\03BD\03AC \03C3\03B5\03BB\03AF\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111419288626399367)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2 \03C3\03B5\03B9\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111420494064399368)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2 \03B3\03B9\03B1 \03C4\03B7 \03C3\03B5\03B9\03C1\03AC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111329420555399301)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111372171772399332)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'el'
,p_message_text=>unistr('\03AD\03C7\03B5\03B9 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03C4\03B5\03AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111327607648399300)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B5\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AD\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111327789551399300)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03C0\03B9\03BB\03BF\03B3\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111302234783399281)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A5\03C0\03AC\03C1\03C7\03B5\03B9 \03AE\03B4\03B7 \03BC\03B9\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03BC\03B5 \03C4\03BF \03CC\03BD\03BF\03BC\03B1 %0. \0395\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03AD\03BD\03B1 \03BD\03AD\03BF \03CC\03BD\03BF\03BC\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111327809908399300)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0399\03B4\03B9\03C9\03C4\03B9\03BA\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111327934396399300)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B7\03BC\03CC\03C3\03B9\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111414219528399363)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7 \03C9\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111361283730399324)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03C9\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111399255200399352)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03C3\03C0\03BF\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111327546643399300)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111406591502399357)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7: \038C\03BB\03B5\03C2 \03BF\03B9 \03C3\03C4\03AE\03BB\03B5\03C2 \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111327475843399300)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111405778547399357)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7: \03A0\03BB\03AE\03C1\03B5\03C2 \03BA\03B5\03AF\03BC\03B5\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111352221505399318)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7 \03B3\03B9\03B1 ''%0''')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111395814900399350)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'el'
,p_message_text=>unistr('- \0395\03C0\03B9\03BB\03BF\03B3\03AE -')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111336008637399306)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111388755072399344)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 1 \03C3\03B5\03B9\03C1\03AC \03C3\03C4\03B7\03BD \03BA\03CD\03C1\03B9\03B1 \03C0\03B5\03C1\03B9\03BF\03C7\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111327331712399300)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C3\03C4\03AE\03BB\03B5\03C2 \03B3\03B9\03B1 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111418913707399367)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2 \03B5\03C0\03B9\03BB\03BF\03B3\03AE\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111336280335399306)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03BA\03B5\03BB\03B9\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111336142940399306)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03B5\03B9\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111407144982399358)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03C3\03C4\03BF\03BB\03AE \03C9\03C2 \03BC\03AE\03BD\03C5\03BC\03B1 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111399662761399352)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111325395791399298)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111377962422399337)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03C3\03C5\03BD\03BF\03BB\03B9\03BA\03AE\03C2 \03C4\03B9\03BC\03AE\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111362783737399325)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03BC\03B5\03BC\03BF\03BD\03C9\03BC\03AD\03BD\03B7\03C2 \03C3\03B5\03B9\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111361006115399324)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111399741964399353)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03BC\03B5 \03B2\03AC\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111419323058399367)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03BC\03CC\03BD\03BF \03BC\03B9\03B1 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03B1\03BD\03AC \03C3\03C4\03AE\03BB\03B7.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111419143202399367)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BB\03BB\03B1\03B3\03AE \03BC\03B5\03BD\03BF\03CD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111400764381399353)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03BF\03AF\03B2\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111355049685399320)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'el'
,p_message_text=>unistr('\03B1\03C1\03C7\03AF\03B6\03B5\03B9 \03BC\03B5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111399314451399352)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03BF\03C7\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111320374866399295)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03AD\03BA\03C4\03B1\03C3\03B7 \03C0\03BB\03AC\03C4\03BF\03C5\03C2 \03C3\03C4\03B7\03BB\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111361445043399325)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03B4\03C1\03BF\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111379495551399338)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03B8\03C1\03BF\03B9\03C3\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111420681691399368)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03CC \03C0\03BB\03AD\03B3\03BC\03B1. \0391\03BD\03B1\03C6\03BF\03C1\03AC: %0, \03A0\03C1\03BF\03B2\03BF\03BB\03AE: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111414679809399363)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03BF\03BB\03B9\03BA\03CC \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111397586747399351)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03CC\03C7\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111403977971399356)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03CE\03BC\03B1 \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111330185649399302)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B1\03BB\03BB\03B1\03B3\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111377895397399336)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03AE\03B3\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111358288234399322)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03CD\03C0\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111362691471399325)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03AF\03C1\03B5\03C3\03B7 \03C0\03B1\03B3\03CE\03BC\03B1\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111359777753399323)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03BF\03BD\03AC\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111406963553399358)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'el'
,p_message_text=>unistr('\03A5\03C0\03AC\03C1\03C7\03BF\03C5\03BD \03BC\03B7 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B5\03C2 \03B1\03BB\03BB\03B1\03B3\03AD\03C2. \0398\03AD\03BB\03B5\03C4\03B5 \03BD\03B1 \03C3\03C5\03BD\03B5\03C7\03AF\03C3\03B5\03C4\03B5;')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111359632741399323)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B9\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111396693728399350)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B9\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111401561667399354)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BC\03B9\03B1 \03C4\03B9\03BC\03AE.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111386403077399343)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B9\03BC\03AE (\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B1\03BB\03BB\03B1\03B3\03AE \03B6\03CE\03BD\03B7\03C2 \03CE\03C1\03B1\03C2)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111405438441399357)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B5\03AF\03BC\03B5\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111397992735399351)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03B1\03BA\03CC\03C1\03C5\03C6\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111357767472399322)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111395966466399350)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111397495286399351)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03B3\03BA\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111355658062399320)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111396096020399350)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BB\03AC\03C7\03B9\03C3\03C4\03BF \03C0\03BB\03AC\03C4\03BF\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 (\0395\03B9\03BA\03BF\03BD\03BF\03C3\03C4\03BF\03B9\03C7\03B5\03AF\03B1)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111346871237399314)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03B5\03C4\03B1\03BE\03CD %1 \03BA\03B1\03B9 %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111346566921399314)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111346647113399314)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF %0 \03B4\03B5\03BD \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03C4\03BF %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111324750636399298)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF %0 \03B4\03B5\03BD \03B1\03C1\03C7\03AF\03B6\03B5\03B9 \03BC\03B5 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111345327918399313)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03AF\03C3\03BF \03BC\03B5 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111345597995399313)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03B5\03B3\03B1\03BB\03CD\03C4\03B5\03C1\03BF \03B1\03C0\03CC %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111345663328399313)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03B5\03B3\03B1\03BB\03CD\03C4\03B5\03C1\03BF \03B1\03C0\03CC \03AE \03AF\03C3\03BF \03BC\03B5 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111346303834399313)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B5\03BD\03C4\03CC\03C2 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111347578410399314)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %1 \03B7\03BC\03AD\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111347375133399314)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %1 \03CE\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111347119497399314)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B1 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 %1 \03BB\03B5\03C0\03C4\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111347933517399315)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF\03C5\03C2 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF\03C5\03C2 %1 \03BC\03AE\03BD\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111347769302399314)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %1 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111348120711399315)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B1 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 %1 \03AD\03C4\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111347420092399314)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 \03B7\03BC\03AD\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111347203459399314)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 \03CE\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111347040556399314)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF \03BB\03B5\03C0\03C4\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111347864367399314)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF\03BD \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF \03BC\03AE\03BD\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111347667125399314)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111348051149399315)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF \03AD\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111349953903399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03B5\03C0\03CC\03BC\03B5\03BD\03B5\03C2 %1 \03B7\03BC\03AD\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111349723114399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03B5\03C0\03CC\03BC\03B5\03BD\03B5\03C2 %1 \03CE\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111349533244399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B1 \03B5\03C0\03CC\03BC\03B5\03BD\03B1 %1 \03BB\03B5\03C0\03C4\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111350382065399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF\03C5\03C2 \03B5\03C0\03CC\03BC\03B5\03BD\03BF\03C5\03C2 %1 \03BC\03AE\03BD\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111350142943399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03B5\03C0\03CC\03BC\03B5\03BD\03B5\03C2 %1 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111350567805399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B1 \03B5\03C0\03CC\03BC\03B5\03BD\03B1 %1 \03AD\03C4\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111349843243399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03B5\03C0\03CC\03BC\03B5\03BD\03B7 \03B7\03BC\03AD\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111349666102399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03B5\03C0\03CC\03BC\03B5\03BD\03B7 \03CE\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111349402699399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03B5\03C0\03CC\03BC\03B5\03BD\03BF \03BB\03B5\03C0\03C4\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111350270620399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF\03BD \03B5\03C0\03CC\03BC\03B5\03BD\03BF \03BC\03AE\03BD\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111350023952399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03B5\03C0\03CC\03BC\03B5\03BD\03B7 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111350425293399316)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03B5\03C0\03CC\03BC\03B5\03BD\03BF\03C2 \03AD\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111346083298399313)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03BA\03B5\03BD\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111345900755399313)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B5\03AF\03BD\03B1\03B9 \03BA\03B5\03BD\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111345796920399313)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03B9\03BA\03C1\03CC\03C4\03B5\03C1\03BF \03B1\03C0\03CC %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111345876939399313)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03B9\03BA\03C1\03CC\03C4\03B5\03C1\03BF \03B1\03C0\03CC \03AE \03AF\03C3\03BF \03BC\03B5 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111346107334399313)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03C0\03B1\03C1\03CC\03BC\03BF\03B9\03BF \03BC\03B5 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111346760085399314)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03C3\03C5\03BC\03C6\03C9\03BD\03B5\03AF \03BC\03B5 \03C4\03B7\03BD \03BA\03B1\03BD\03BF\03BD\03B9\03BA\03AE \03AD\03BA\03C6\03C1\03B1\03C3\03B7 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111352694859399318)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BB\03B5\03C0\03C4\03AC \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111346973527399314)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03B5\03C4\03B1\03BE\03CD %1 \03BA\03B1\03B9 %2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111345401885399313)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03AF\03C3\03BF \03BC\03B5 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111346472373399313)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03B5\03BD\03C4\03CC\03C2 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111348707502399315)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %1 \03B7\03BC\03AD\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111348534417399315)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %1 \03CE\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111348393292399315)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B1 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 %1 \03BB\03B5\03C0\03C4\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111349196577399315)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF\03C5\03C2 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF\03C5\03C2 %1 \03BC\03AE\03BD\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111348907627399315)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %1 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111349317841399316)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B1 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 %1 \03AD\03C4\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111348684653399315)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 \03B7\03BC\03AD\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111348431658399315)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 \03CE\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111348294021399315)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF \03BB\03B5\03C0\03C4\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111349012890399315)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF\03BD \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF \03BC\03AE\03BD\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111348848466399315)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111349281098399315)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF \03AD\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111351140195399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03B5\03C0\03CC\03BC\03B5\03BD\03B5\03C2 %1 \03B7\03BC\03AD\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111350971627399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03B5\03C0\03CC\03BC\03B5\03BD\03B5\03C2 %1 \03CE\03C1\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111350775574399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B1 \03B5\03C0\03CC\03BC\03B5\03BD\03B1 %1 \03BB\03B5\03C0\03C4\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111351596641399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF\03C5\03C2 \03B5\03C0\03CC\03BC\03B5\03BD\03BF\03C5\03C2 %1 \03BC\03AE\03BD\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111351382451399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B9\03C2 \03B5\03C0\03CC\03BC\03B5\03BD\03B5\03C2 %1 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111351774333399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B1 \03B5\03C0\03CC\03BC\03B5\03BD\03B1 %1 \03AD\03C4\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111351016554399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03B5\03C0\03CC\03BC\03B5\03BD\03B7 \03B7\03BC\03AD\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111350866185399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03B5\03C0\03CC\03BC\03B5\03BD\03B7 \03CE\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111350610508399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03B5\03C0\03CC\03BC\03B5\03BD\03BF \03BB\03B5\03C0\03C4\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111351417134399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF\03BD \03B5\03C0\03CC\03BC\03B5\03BD\03BF \03BC\03AE\03BD\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111351204351399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03B7\03BD \03B5\03C0\03CC\03BC\03B5\03BD\03B7 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111351601983399317)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03B5\03C0\03CC\03BC\03B5\03BD\03BF \03AD\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111346276670399313)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03C0\03B1\03C1\03CC\03BC\03BF\03B9\03BF \03BC\03B5 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111353152552399318)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B1\03C1\03C7\03AF\03B6\03B5\03B9 \03BC\03B5 %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111396739173399350)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111355896033399320)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('\03AD\03C4\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111396893597399350)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'el'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111396997804399351)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'el'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111405977449399357)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03C5\03C4\03AD\03C1\03B1 12 \0399\03B1\03BD\03BF\03C5\03B1\03C1\03AF\03BF\03C5 2016')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111406067182399357)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'el'
,p_message_text=>unistr('\0399\03B1\03BD\03BF\03C5\03AC\03C1\03B9\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111406158749399357)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'el'
,p_message_text=>unistr('16 \03CE\03C1\03B5\03C2 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111406261406399357)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03B5 16 \03CE\03C1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111261232805399252)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03BF\03C2 \03C4\03CD\03C0\03BF\03C2 \03B1\03C1\03C7\03B5\03AF\03BF\03C5. \03A5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03BF\03B9 \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03BF\03B9 \03C4\03CD\03C0\03BF\03B9 \03B1\03C1\03C7\03B5\03AF\03C9\03BD: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111388173868399344)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03AE\03B3\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111387873443399344)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03B1\03C1\03C7\03B5\03AF\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111387977469399344)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03B1\03C1\03C7\03B5\03AF\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111261077083399252)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03C6\03BF\03C1\03AC \03BA\03B1\03B9 \03B1\03C0\03CC\03B8\03B5\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111261491396399252)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03C6\03BF\03C1\03AC \03BA\03B1\03B9 \03B1\03C0\03CC\03B8\03B5\03C3\03B7 \03B1\03C1\03C7\03B5\03AF\03C9\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111262692959399253)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03AD\03BD\03B1 \03B1\03C1\03C7\03B5\03AF\03BF \03AE \03C0\03C1\03B1\03B3\03BC\03B1\03C4\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C0\03CC\03B8\03B5\03C3\03B7 \03B5\03BD\03CC\03C2 \03B1\03C1\03C7\03B5\03AF\03BF\03C5 \03B5\03B4\03CE.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111262767838399253)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03B1\03C1\03C7\03B5\03AF\03B1 \03AE \03C0\03C1\03B1\03B3\03BC\03B1\03C4\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C0\03CC\03B8\03B5\03C3\03B7 \03B1\03C1\03C7\03B5\03AF\03C9\03BD \03B5\03B4\03CE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111262856314399253)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03AD\03BD\03B1 \03B1\03C1\03C7\03B5\03AF\03BF \03AE \03C0\03C1\03B1\03B3\03BC\03B1\03C4\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C0\03CC\03B8\03B5\03C3\03B7 \03B5\03BD\03CC\03C2 \03B1\03C1\03C7\03B5\03AF\03BF\03C5 \03B5\03B4\03CE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111262907250399253)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03B1\03C1\03C7\03B5\03AF\03B1 \03AE \03C0\03C1\03B1\03B3\03BC\03B1\03C4\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C0\03CC\03B8\03B5\03C3\03B7 \03B1\03C1\03C7\03B5\03AF\03C9\03BD \03B5\03B4\03CE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111261395316399252)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B1\03C1\03C7\03B5\03AF\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111261175889399252)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03C1\03C7\03B5\03AF\03BF \03B5\03AF\03BD\03B1\03B9 \03C0\03BF\03BB\03CD \03BC\03B5\03B3\03AC\03BB\03BF. \03A4\03BF \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03BC\03AD\03B3\03B5\03B8\03BF\03C2 \03B1\03C1\03C7\03B5\03AF\03BF\03C5 \03B5\03AF\03BD\03B1\03B9 %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111248932503399243)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111247820114399242)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03CC\03BB\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111248261104399242)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03C9\03B4\03B9\03BA\03CC\03C2 \03C7\03CE\03C1\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111247929590399242)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C1\03B9\03B8\03BC\03CC\03C2 \03C3\03C0\03B9\03C4\03B9\03BF\03CD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111248853362399243)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03B5\03C9\03B3\03C1\03B1\03C6\03B9\03BA\03CC \03C0\03BB\03AC\03C4\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111248730322399243)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03B5\03C9\03B3\03C1\03B1\03C6\03B9\03BA\03CC \03BC\03AE\03BA\03BF\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111248650235399243)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6. \03C3\03C4\03BF \03C7\03AC\03C1\03C4\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111248370438399242)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03B1\03B8\03BC\03BF\03BB\03BF\03B3\03AF\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111248025255399242)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B9\03BA\03CC\03C2 \03BA\03CE\03B4\03B9\03BA\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111248102980399242)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BF\03BB\03B9\03C4\03B5\03AF\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111247793570399242)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03B4\03CC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111247646397399242)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03C4\03B5\03BB\03AD\03C3\03BC\03B1\03C4\03B1 \03B3\03B5\03C9\03B3\03C1\03B1\03C6\03B9\03BA\03AE\03C2 \03BA\03C9\03B4\03B9\03BA\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111260212075399251)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5 \03B3\03B5\03C9\03B3\03C1\03B1\03C6\03B9\03BA\03AE \03BA\03C9\03B4\03B9\03BA\03BF\03C0\03BF\03AF\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111260394596399251)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C9\03C1\03AF\03C2 \03B3\03B5\03C9\03B3\03C1\03B1\03C6\03B9\03BA\03AE \03BA\03C9\03B4\03B9\03BA\03BF\03C0\03BF\03AF\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111248504966399243)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03C4\03B9\03C3\03C4\03BF\03AF\03C7\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111248425229399243)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD \03B4\03B9\03B5\03C5\03B8\03CD\03BD\03C3\03B5\03B9\03C2.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111249075427399243)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF %0 \03B1\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111418837598399366)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B5\03AF\03BC\03B5\03BD\03BF \03B2\03BF\03AE\03B8\03B5\03B9\03B1\03C2: %0')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111312280871399289)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111312325483399289)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111258207255399250)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF #LABEL# \03B4\03B5\03BD \03B2\03C1\03AF\03C3\03BA\03B5\03C4\03B1\03B9 \03B5\03BD\03C4\03CC\03C2 \03C4\03BF\03C5 \03AD\03B3\03BA\03C5\03C1\03BF\03C5 \03B5\03CD\03C1\03BF\03C5\03C2 %0 \03AD\03C9\03C2 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111258311283399250)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF #LABEL# \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03AC\03C3\03B9\03BF \03C4\03BF\03C5 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111257936133399249)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B1\03BD\03C4\03B9\03C3\03C4\03BF\03B9\03C7\03B5\03AF \03C3\03C4\03B9\03C2 \03C4\03B9\03BC\03AD\03C2 %0 \03BA\03B1\03B9 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111258146638399249)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03C7\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111336427424399306)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111336520518399306)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111258029697399249)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\039D\03B1\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111241455356399237)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03BA\03B1\03C4\03B1\03C7\03CE\03C1\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111370626434399331)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111370784030399331)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111241567822399238)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B5\03C2 \03B5\03B3\03B3\03C1\03B1\03C6\03AD\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111374481773399334)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BD\03B8\03B5\03C4\03B5\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111374745772399334)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BA\03CD\03C1\03C9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111374595823399334)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03BF\03B9\03BD\03AD\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111374891614399334)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AD\03C2 \03C0\03C1\03BF\03C4\03CD\03C0\03BF\03C5 \03BA\03B1\03C4\03AC \03C4\03BF\03BD \03C7\03C1\03CC\03BD\03BF \03B5\03BA\03C4\03AD\03BB\03B5\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111375435310399335)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03B9 \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03C2 \03C0\03C1\03BF\03C4\03CD\03C0\03BF\03C5 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B5\03C2, \03B3\03B9\03B1\03C4\03AF \03B1\03C5\03C4\03CC \03C4\03BF \03C3\03C5\03C3\03C4\03B1\03C4\03B9\03BA\03CC \03B4\03B5\03BD \03B1\03C0\03BF\03B4\03AF\03B4\03B5\03C4\03B1\03B9 \03C3\03C4\03B7 \03C3\03B5\03BB\03AF\03B4\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111374363456399334)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03C2 \03C0\03C1\03BF\03C4\03CD\03C0\03BF\03C5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111374684881399334)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111249902050399244)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE \03BA\03CD\03BA\03BB\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111251721184399245)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03C3\03BC\03AD\03BD\03B1 \03C3\03C4\03C5\03BB \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03BF\03C2 \03BA\03CE\03B4\03B9\03BA\03B1\03C2 JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111250246001399244)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C1\03B3\03B1\03BB\03B5\03AF\03BF \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD \03B1\03C0\03CC\03C3\03C4\03B1\03C3\03B7\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111250027589399244)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C7\03B5\03B4\03AF\03B1\03C3\03B7 \03BA\03CD\03BA\03BB\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111242685867399238)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7 \03BC\03B5 \03B5\03C0\03B9\03BC\03AD\03C1\03BF\03C5\03C2 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03B1 \03B1\03C0\03B1\03B9\03C4\03B5\03AF \03BC\03B9\03B1 \03C0\03B7\03B3\03AE \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C3\03B5 \03B5\03C0\03AF\03C0\03B5\03B4\03BF \03C0\03B5\03C1\03B9\03BF\03C7\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111245249038399240)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03C1\03AD\03C7\03BF\03C5\03C3\03B1 \03B8\03AD\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111246315821399241)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03B9 \03C3\03C5\03BD\03C4\03B5\03C4\03B1\03B3\03BC\03AD\03BD\03B5\03C2 \03B1\03C1\03C7\03B9\03BA\03AE\03C2 \03B8\03AD\03C3\03B7\03C2 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03B5\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111243702950399239)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B1\03C1\03C7\03B9\03BA\03AE \03B8\03AD\03C3\03B7 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03B3\03B5\03C9\03BC\03B5\03C4\03C1\03AF\03B1 \03C3\03B7\03BC\03B5\03AF\03BF\03C5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111246129624399241)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'el'
,p_message_text=>unistr('\03C7\03BB\03BC.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111244704522399240)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03AF\03C0\03B5\03B4\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111378055750399337)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03AF\03C0\03B5\03B4\03BF: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111249352584399243)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03C4\03B9\03C3\03C4\03BF\03AF\03C7\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111242512390399238)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7\03BD\03CD\03BC\03B1\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111246255505399241)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03AF\03BB\03B9\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111377076890399336)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03C0\03B5\03C1\03B9\03AD\03C7\03BF\03C5\03BD \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B5\03C2 \03B1\03C0\03CC %0 \03C3\03B5\03B9\03C1\03AD\03C2, \03C4\03BF \03BF\03C0\03BF\03AF\03BF \03C5\03C0\03B5\03C1\03B2\03B1\03AF\03BD\03B5\03B9 \03C4\03BF \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03B5\03C0\03B9\03C4\03C1\03B5\03C0\03CC\03BC\03B5\03BD\03BF \03CC\03C1\03B9\03BF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111244576520399240)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'el'
,p_message_text=>unistr('&copy; 2018 Oracle Corporation &nbsp;&nbsp; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">\038C\03C1\03BF\03B9</a> &nbsp;&nbsp; \0394\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03C7\03AC\03C1\03C4\03B7 &copy; 2017 HERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111243483546399239)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C4\03CD\03C0\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD SDO_GEOMETRY \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03BF\03C2 \03C3\03B5 \03B1\03C5\03C4\03AE \03C4\03B7 \03B2\03AC\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111244639710399240)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'el'
,p_message_text=>unistr('<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; \03A3\03C5\03BD\03C4\03B5\03BB\03B5\03C3\03C4\03AD\03C2 OpenStreetMap </a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111244866517399240)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B7\03BC\03B5\03AF\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111378170619399337)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03C3\03B7\03BC\03B5\03AF\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111250186374399244)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03B1\03BB\03BB\03B7\03BB\03CC\03B3\03C1\03B1\03BC\03BC\03B7 \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03B5\03C3\03C4\03AF\03B1\03C3\03B7\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111249817917399244)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111245177005399240)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC \03BA\03B1\03C4\03B5\03CD\03B8\03C5\03BD\03C3\03B7\03C2 \03C0\03C1\03BF\03C2 \03B2\03BF\03C1\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111325482808399298)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B1\03BB\03BB\03B1\03B3\03AE \03C3\03B5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 2D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111325515030399298)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B1\03BB\03BB\03B1\03B3\03AE \03C3\03B5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 3D')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111249769010399243)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7/\0391\03C0\03CC\03BA\03C1\03C5\03C8\03B7 \03B4\03AE\03BB\03C9\03C3\03B7\03C2 \03C0\03B5\03C1\03AF \03C0\03BD\03B5\03C5\03BC\03B1\03C4\03B9\03BA\03CE\03BD \03B4\03B9\03BA\03B1\03B9\03C9\03BC\03AC\03C4\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111250390712399244)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03BF\03BB\03B9\03BA\03AE \03B1\03C0\03CC\03C3\03C4\03B1\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111244935086399240)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03B3\03AD\03B8\03C5\03BD\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111245085670399240)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03BC\03AF\03BA\03C1\03C5\03BD\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111372578120399333)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BD\03C4\03BF\03BD\03B7 \03B3\03C1\03B1\03C6\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111373469145399333)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03BA\03CC\03BD\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111373030778399333)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03C3\03C9\03BC\03B1\03C4\03C9\03BC\03AD\03BD\03BF\03C2 \03BA\03CE\03B4\03B9\03BA\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111386675409399343)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03C3\03B1\03B3\03C9\03B3\03AE \03B5\03B9\03BA\03CC\03BD\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111386753186399343)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03C3\03B1\03B3\03C9\03B3\03AE \03B4\03B5\03C3\03BC\03BF\03CD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111372682484399333)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BB\03AC\03B3\03B9\03B1 \03B3\03C1\03B1\03C6\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111387343319399343)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03C3\03BC\03CC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111373336989399333)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AF\03C3\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111373254552399333)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03BF\03BC\03B7\03BC\03AD\03BD\03B7 \03BB\03AF\03C3\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111372734088399333)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03C0\03B9\03C3\03BA\03CC\03C0\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111372813441399333)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03C4\03AF\03C0\03BF\03C4\03B1 \03B3\03B9\03B1 \03C0\03C1\03BF\03B5\03C0\03B9\03C3\03BA\03CC\03C0\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111372912428399333)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B3\03C1\03AC\03BC\03BC\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111373126518399333)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03C4\03B1\03BE\03B9\03BD\03BF\03BC\03B7\03BC\03AD\03BD\03B7 \03BB\03AF\03C3\03C4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111352027209399318)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'el'
,p_message_text=>unistr('\03C4\03C1\03AD\03C7\03BF\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111409557638399360)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B1...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111351975594399318)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03CC\03C1\03C4\03C9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111383741031399341)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AE\03BD\03C5\03BC\03B1 \03B5\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111357068968399321)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B9\03BC\03AE \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03AD\03BD\03B1\03C2 \03B1\03C1\03B9\03B8\03BC\03CC\03C2 \03AF\03C3\03BF\03C2 \03BC\03B5 %0 \03AE \03BC\03B9\03BA\03C1\03CC\03C4\03B5\03C1\03BF\03C2.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111357131842399321)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B9\03BC\03AE \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03AD\03BD\03B1\03C2 \03AD\03B3\03BA\03C5\03C1\03BF\03C2 \03B1\03C1\03B9\03B8\03BC\03CC\03C2.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111357274861399321)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF #LABEL# \03B4\03B5\03BD \03B1\03BD\03C4\03B9\03C3\03C4\03BF\03B9\03C7\03B5\03AF \03C3\03C4\03B7 \03BC\03BF\03C1\03C6\03AE \03B1\03C1\03B9\03B8\03BC\03BF\03CD %0 (\03A0\03B1\03C1\03AC\03B4\03B5\03B9\03B3\03BC\03B1: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111356923966399321)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B9\03BC\03AE \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03AD\03BD\03B1\03C2 \03B1\03C1\03B9\03B8\03BC\03CC\03C2 \03AF\03C3\03BF\03C2 \03BC\03B5 %0 \03AE \03BC\03B5\03B3\03B1\03BB\03CD\03C4\03B5\03C1\03BF\03C2.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111356800975399321)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B9\03BC\03AE \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03AD\03BD\03B1\03C2 \03B1\03C1\03B9\03B8\03BC\03CC\03C2 \03BC\03B5\03C4\03B1\03BE\03CD %0 \03BA\03B1\03B9 %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111352176333399318)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'el'
,p_message_text=>unistr('\03B1\03BD\03BF\03AF\03B3\03B5\03B9 \03C3\03B5 \03BD\03AD\03BF \03C0\03B1\03C1\03AC\03B8\03C5\03C1\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111305385644399284)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03AE \03B7 \03C3\03B5\03BB\03AF\03B4\03B1 \03AD\03C7\03B5\03B9 \03AE\03B4\03B7 \03C5\03C0\03BF\03B2\03BB\03B7\03B8\03B5\03AF \03BA\03B1\03B9 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C5\03C0\03BF\03B2\03BB\03B7\03B8\03B5\03AF \03BE\03B1\03BD\03AC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111287927784399271)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE "%0", \03C3\03B5\03BB\03AF\03B4\03B1 "%1" \03B4\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111321717013399296)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF #LABEL# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03AD\03C7\03B5\03B9 \03BA\03AC\03C0\03BF\03B9\03B1 \03C4\03B9\03BC\03AE.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111265066638399255)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111371065683399332)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03BB\03B5\03AF\03C3\03B9\03BC\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111370957177399332)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03CD\03C1\03B5\03C3\03B7%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111371208201399332)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111371130746399332)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111257177313399249)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03AD\03BD\03B1\03BD \03CC\03C1\03BF \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03C0\03BF\03C5 \03B1\03C0\03BF\03C4\03B5\03BB\03B5\03AF\03C4\03B1\03B9 \03C4\03BF\03C5\03BB\03AC\03C7\03B9\03C3\03C4\03BF\03BD \03B1\03C0\03CC %0 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111326651473399299)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03C0\03C4\03C5\03C3\03C3\03CC\03BC\03B5\03BD\03B7 \03BB\03AF\03C3\03C4\03B1 \03C4\03B9\03BC\03CE\03BD: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111257209194399249)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03AD\03BD\03B1\03BD \03CC\03C1\03BF \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111257079133399249)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD \03B1\03C0\03BF\03C4\03B5\03BB\03AD\03C3\03BC\03B1\03C4\03B1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111256938698399249)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111344836207399312)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03C1\03BF\03C2 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111370877001399331)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111381518480399339)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03AF\03BD\03B5\03C4\03B1\03B9 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111255567736399248)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8. \03C3\03C4\03B7\03BD \03B1\03C1\03C7. \03C3\03B5\03BB\03AF\03B4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111251581997399245)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\03A6\03B1\03AF\03BD\03B5\03C4\03B1\03B9 \03CC\03C4\03B9 \03B7 \03C3\03C5\03C3\03BA\03B5\03C5\03AE \03AE \03C4\03BF \03C0\03C1\03CC\03B3\03C1\03B1\03BC\03BC\03B1 \03C0\03B5\03C1\03B9\03AE\03B3\03B7\03C3\03B7\03C2 \03C0\03BF\03C5 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B5 \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03B9 \03C0\03C1\03BF\03C2 \03C4\03BF \03C0\03B1\03C1\03CC\03BD \03C4\03B7\03BD \03B5\03B3\03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7 \03C4\03BF\03C5 Progressive Web Apps.</p>'),
unistr('    <p class="a-pwaDialog-intro">\0391\03BD \03B1\03C5\03C4\03AE \03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03B5\03AF\03BD\03B1\03B9 \03AE\03B4\03B7 \03B5\03B3\03BA\03B1\03C4\03B5\03C3\03C4\03B7\03BC\03AD\03BD\03B7 \03C3\03C4\03B7 \03C3\03C5\03C3\03BA\03B5\03C5\03AE \03C3\03B1\03C2, \03B1\03BD\03BF\03AF\03BE\03C4\03B5 \03C4\03B7\03BD \03B1\03C0\03CC \03C4\03B7\03BD \03B1\03C1\03C7\03B9\03BA\03AE \03BF\03B8\03CC\03BD\03B7.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111251133665399245)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD. \03A0\03C1\03BF\03C3\03B8\03AD\03C3\03C4\03B5 \03C4\03BF\03BD \03C3\03C4\03B7\03BD \03B1\03C1\03C7\03B9\03BA\03AE \03BF\03B8\03CC\03BD\03B7 \03C3\03B1\03C2 \03B3\03B9\03B1 \03BD\03B1 \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03C4\03BF\03BD \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B5 \03C3\03B5 \03C0\03BB\03AE\03C1\03B7 \03BF\03B8\03CC\03BD\03B7.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 \03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF <strong>\039C\03B5\03BD\03BF\03CD</strong> \03C3\03C4\03B7\03BD \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03C0\03BB\03BF\03AE\03B3\03B7\03C3\03B7\03C2 \03C3\03C4\03BF \03BA\03AC\03C4\03C9 \03BC\03AD\03C1\03BF\03C2.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 <strong>\0395\03B3\03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7</strong>.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 <strong>\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7</strong> \03B3\03B9\03B1 \03B5\03C0\03B9\03B2\03B5\03B2\03B1\03AF\03C9\03C3\03B7.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111251241327399245)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03C0\03BF\03C5 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03BF\03CD\03BD\03C4\03B1\03B9 \03BA\03B1\03BB\03CD\03C4\03B5\03C1\03B1 \03C3\03C4\03BF Chrome \03AE \03C4\03BF Edge.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 \03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF <strong>\039C\03B5\03BD\03BF\03CD</strong> \03B4\03AF\03C0\03BB\03B1 \03C3\03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B4\03B9\03B5\03C5\03B8\03CD\03BD\03C3\03B5\03C9\03BD.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 <strong>\0395\03B3\03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7</strong>.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111250859051399244)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03C0\03BF\03C5 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03BF\03CD\03BD\03C4\03B1\03B9 \03BA\03B1\03BB\03CD\03C4\03B5\03C1\03B1 \03C3\03C4\03BF Safari.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 \03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF <strong>\039A\03BF\03B9\03BD\03AE \03C7\03C1\03AE\03C3\03B7</strong> \03C3\03C4\03B7\03BD \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03C0\03BB\03BF\03AE\03B3\03B7\03C3\03B7\03C2 \03C3\03C4\03BF \03BA\03AC\03C4\03C9 \03BC\03AD\03C1\03BF\03C2.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 <strong>\0386\03BD\03BF\03B9\03B3\03BC\03B1 \03C3\03C4\03BF Safari</strong>.</p>'),
'    </div>',
'</div>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111250516995399244)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD. \03A0\03C1\03BF\03C3\03B8\03AD\03C3\03C4\03B5 \03C4\03BF\03BD \03C3\03C4\03B7\03BD \03B1\03C1\03C7\03B9\03BA\03AE \03BF\03B8\03CC\03BD\03B7 \03C3\03B1\03C2 \03B3\03B9\03B1 \03BD\03B1 \03B5\03BE\03B1\03C3\03C6\03B1\03BB\03AF\03C3\03B5\03C4\03B5 \03C4\03B7 \03B2\03AD\03BB\03C4\03B9\03C3\03C4\03B7 \03B5\03BC\03C0\03B5\03B9\03C1\03AF\03B1 \03C7\03C1\03AE\03C3\03B7\03C2.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 \03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF <strong>\039A\03BF\03B9\03BD\03AE \03C7\03C1\03AE\03C3\03B7</strong> \03B4\03AF\03C0\03BB\03B1 \03C3\03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B4\03B9\03B5\03C5\03B8\03CD\03BD\03C3\03B5\03C9\03BD.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 <strong>\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C3\03C4\03B7\03BD \03B1\03C1\03C7\03B9\03BA\03AE \03BF\03B8\03CC\03BD\03B7</strong>.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 <strong style="color:#007AE1;">\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7</strong> \03B3\03B9\03B1 \03B5\03C0\03B9\03B2\03B5\03B2\03B1\03AF\03C9\03C3\03B7.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111250496792399244)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD. \03A0\03C1\03BF\03C3\03B8\03AD\03C3\03C4\03B5 \03C4\03BF\03BD \03C3\03C4\03B7\03BD \03B1\03C1\03C7\03B9\03BA\03AE \03BF\03B8\03CC\03BD\03B7 \03C3\03B1\03C2 \03B3\03B9\03B1 \03BD\03B1 \03B5\03BE\03B1\03C3\03C6\03B1\03BB\03AF\03C3\03B5\03C4\03B5 \03C4\03B7 \03B2\03AD\03BB\03C4\03B9\03C3\03C4\03B7 \03B5\03BC\03C0\03B5\03B9\03C1\03AF\03B1 \03C7\03C1\03AE\03C3\03B7\03C2.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 \03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF <strong>\039A\03BF\03B9\03BD\03AE \03C7\03C1\03AE\03C3\03B7</strong> \03C3\03C4\03B7\03BD \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03C0\03BB\03BF\03AE\03B3\03B7\03C3\03B7\03C2 \03C3\03C4\03BF \03BA\03AC\03C4\03C9 \03BC\03AD\03C1\03BF\03C2.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \039A\03AC\03BD\03C4\03B5 \03BA\03CD\03BB\03B9\03C3\03B7 \03C0\03C1\03BF\03C2 \03C4\03B1 \03BA\03AC\03C4\03C9 \03BA\03B1\03B9 \03C0\03B1\03C4\03AE\03C3\03C4\03B5 <strong>\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C3\03C4\03B7\03BD \03B1\03C1\03C7\03B9\03BA\03AE \03BF\03B8\03CC\03BD\03B7</strong>.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 <strong style="color:#007AE1;">\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7</strong> \03B3\03B9\03B1 \03B5\03C0\03B9\03B2\03B5\03B2\03B1\03AF\03C9\03C3\03B7.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111245416905399240)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD. \03A0\03C1\03BF\03C3\03B8\03AD\03C3\03C4\03B5 \03C4\03BF\03BD \03C3\03C4\03B7\03BD \03B1\03C1\03C7\03B9\03BA\03AE \03BF\03B8\03CC\03BD\03B7 \03C3\03B1\03C2 \03B3\03B9\03B1 \03BD\03B1 \03B5\03BE\03B1\03C3\03C6\03B1\03BB\03AF\03C3\03B5\03C4\03B5 \03C4\03B7 \03B2\03AD\03BB\03C4\03B9\03C3\03C4\03B7 \03B5\03BC\03C0\03B5\03B9\03C1\03AF\03B1 \03C7\03C1\03AE\03C3\03B7\03C2.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 \03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF  <strong>\03A0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B1</strong> \03B4\03AF\03C0\03BB\03B1 \03C3\03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B4\03B9\03B5\03C5\03B8\03CD\03BD\03C3\03B5\03C9\03BD.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 <strong>\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C3\03C4\03B7\03BD \03B1\03C1\03C7\03B9\03BA\03AE \03BF\03B8\03CC\03BD\03B7</strong>.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
unistr('        <p class="a-pwaDialog-stepText">3. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 <strong style="color:#007AE1;">\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7</strong> \03B3\03B9\03B1 \03B5\03C0\03B9\03B2\03B5\03B2\03B1\03AF\03C9\03C3\03B7.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111250751298399244)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD. \03A0\03C1\03BF\03C3\03B8\03AD\03C3\03C4\03B5 \03C4\03BF\03BD \03C3\03C4\03B7\03BD \03B1\03C1\03C7\03B9\03BA\03AE \03BF\03B8\03CC\03BD\03B7 \03C3\03B1\03C2 \03B3\03B9\03B1 \03BD\03B1 \03B5\03BE\03B1\03C3\03C6\03B1\03BB\03AF\03C3\03B5\03C4\03B5 \03C4\03B7 \03B2\03AD\03BB\03C4\03B9\03C3\03C4\03B7 \03B5\03BC\03C0\03B5\03B9\03C1\03AF\03B1 \03C7\03C1\03AE\03C3\03B7\03C2.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\03A0\03B1\03C4\03AE\03C3\03C4\03B5 \03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF <strong>\039A\03BF\03B9\03BD\03AE \03C7\03C1\03AE\03C3\03B7</strong> \03B4\03AF\03C0\03BB\03B1 \03C3\03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B4\03B9\03B5\03C5\03B8\03CD\03BD\03C3\03B5\03C9\03BD.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\03A0\03B1\03C4\03AE\03C3\03C4\03B5 <strong>\0386\03BD\03BF\03B9\03B3\03BC\03B1 \03C3\03C4\03BF Safari</strong>.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111250675068399244)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD. \03A0\03C1\03BF\03C3\03B8\03AD\03C3\03C4\03B5 \03C4\03BF\03BD \03C3\03C4\03B7\03BD \03B1\03C1\03C7\03B9\03BA\03AE \03BF\03B8\03CC\03BD\03B7 \03C3\03B1\03C2 \03B3\03B9\03B1 \03BD\03B1 \03B5\03BE\03B1\03C3\03C6\03B1\03BB\03AF\03C3\03B5\03C4\03B5 \03C4\03B7 \03B2\03AD\03BB\03C4\03B9\03C3\03C4\03B7 \03B5\03BC\03C0\03B5\03B9\03C1\03AF\03B1 \03C7\03C1\03AE\03C3\03B7\03C2.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\03A0\03B1\03C4\03AE\03C3\03C4\03B5 \03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF <strong>\039A\03BF\03B9\03BD\03AE \03C7\03C1\03AE\03C3\03B7</strong> \03C3\03C4\03B7\03BD \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03C0\03BB\03BF\03AE\03B3\03B7\03C3\03B7\03C2 \03C3\03C4\03BF \03BA\03AC\03C4\03C9 \03BC\03AD\03C1\03BF\03C2.</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">\03A0\03B1\03C4\03AE\03C3\03C4\03B5 <strong>\0386\03BD\03BF\03B9\03B3\03BC\03B1 \03C3\03C4\03BF Safari</strong>.</p>'),
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111251479573399245)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03C0\03BF\03C5 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03BF\03CD\03BD\03C4\03B1\03B9 \03BA\03B1\03BB\03CD\03C4\03B5\03C1\03B1 \03C3\03C4\03BF Chrome.</p>'),
unistr('    <p class="a-pwaDialog-intro">\03A4\03BF Firefox \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03B9 \03C0\03C1\03BF\03C2 \03C4\03BF \03C0\03B1\03C1\03CC\03BD \03C4\03B7\03BD \03B5\03B3\03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03B9\03C3\03C4\03BF\03CD.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111250909733399244)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03C0\03BF\03C5 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03BF\03CD\03BD\03C4\03B1\03B9 \03BA\03B1\03BB\03CD\03C4\03B5\03C1\03B1 \03C3\03C4\03BF Chrome \03AE \03C4\03BF Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">\03A4\03BF Firefox \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03B9 \03C0\03C1\03BF\03C2 \03C4\03BF \03C0\03B1\03C1\03CC\03BD \03C4\03B7\03BD \03B5\03B3\03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03B9\03C3\03C4\03BF\03CD \03C3\03B5 macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111251031423399244)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03C0\03BF\03C5 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03BF\03CD\03BD\03C4\03B1\03B9 \03BA\03B1\03BB\03CD\03C4\03B5\03C1\03B1 \03C3\03C4\03BF Chrome \03AE \03C4\03BF Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">\03A4\03BF Safari \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03B9 \03C0\03C1\03BF\03C2 \03C4\03BF \03C0\03B1\03C1\03CC\03BD \03C4\03B7\03BD \03B5\03B3\03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03B9\03C3\03C4\03BF\03CD \03C3\03B5 macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111251364763399245)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">\0391\03C5\03C4\03CC\03C2 \03BF \03B9\03C3\03C4\03CC\03C4\03BF\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03C0\03BF\03C5 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03BF\03CD\03BD\03C4\03B1\03B9 \03BA\03B1\03BB\03CD\03C4\03B5\03C1\03B1 \03C3\03C4\03BF Chrome \03AE \03C4\03BF Edge.</p>'),
unistr('    <p class="a-pwaDialog-intro">\03A4\03BF Firefox \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03B9 \03C0\03C1\03BF\03C2 \03C4\03BF \03C0\03B1\03C1\03CC\03BD \03C4\03B7\03BD \03B5\03B3\03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD \03B9\03C3\03C4\03BF\03CD \03C3\03B5 Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111253891074399246)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
unistr('    <h1>\0391\03B4\03C5\03BD\03B1\03BC\03AF\03B1 \03C3\03CD\03BD\03B4\03B5\03C3\03B7\03C2</h1>'),
unistr('    <p>\03A7\03C1\03B5\03B9\03AC\03B6\03B5\03C3\03C4\03B5 \03BC\03B9\03B1 \03C3\03CD\03BD\03B4\03B5\03C3\03B7 \03C3\03C4\03BF Internet \03B3\03B9\03B1 \03BD\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5 \03B1\03C5\03C4\03AE\03BD \03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE.</p>'),
unistr('    <button type="button">\0395\03C0\03B1\03BD\03AC\03BB\03B7\03C8\03B7 \03C0\03C1\03BF\03C3\03C0\03AC\03B8\03B5\03B9\03B1\03C2</button>'),
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111253789816399246)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03B4\03C5\03BD\03B1\03BC\03AF\03B1 \03C3\03CD\03BD\03B4\03B5\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111393578075399348)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111337979517399307)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BB\03B7 \03BC\03AD\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111416893443399365)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03C3\03C4\03BF\03BB\03AE \03C0\03C1\03CC\03C3\03BA\03BB\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111416650858399365)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AD\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111339751123399309)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BC\03B5\03C1\03AE\03C3\03B9\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03B3\03B9\03B1 \03CC\03BB\03B7 \03C4\03B7\03BD \03B7\03BC\03AD\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111339552216399309)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BC\03B5\03C1\03AE\03C3\03B9\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03B3\03B9\03B1 \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1 \03BC\03B5 \03CE\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111384434540399341)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BC\03AD\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111378852530399337)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03B3\03C1\03B1\03C6\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111269426228399258)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'el'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111269211594399258)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'el'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111269170788399258)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'el'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111269318611399258)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'el'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111268805150399257)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1 \03BB\03AE\03BE\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111269017954399257)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BD\03BF\03BC\03B1 \03C3\03C5\03BC\03B2\03AC\03BD\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111416757887399365)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03CC\03C3\03BA\03BB\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111384584321399341)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AF\03C3\03C4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111384293128399341)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AE\03BD\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111387005202399343)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111401337701399354)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03BF\03C5\03BD \03C3\03C5\03BC\03B2\03AC\03BD\03C4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111417017479399365)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C5\03C0\03AC\03C1\03C7\03BF\03BD\03C4\03BF\03C2 \03C3\03C5\03BC\03B2\03AC\03BD\03C4\03BF\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111416949579399365)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03C3\03C4\03BF\03BB\03AE \03C0\03C1\03CC\03C3\03BA\03BB\03B7\03C3\03B7\03C2 \03BC\03AD\03C3\03C9 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111387193215399343)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111395101956399349)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03C3\03C4\03BF\03BB\03AE \03BC\03B7\03BD\03CD\03BC\03B1\03C4\03BF\03C2 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111394906275399349)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03C3\03C4\03BF\03BB\03AE \03BC\03B7\03BD\03CD\03BC\03B1\03C4\03BF\03C2 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111417741853399366)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BB\03B1 \03C4\03B1 \03C0\03B5\03B4\03AF\03B1 \03B5\03AF\03BD\03B1\03B9 \03C5\03C0\03BF\03C7\03C1\03B5\03C9\03C4\03B9\03BA\03AC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111417624430399366)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03C3\03C4\03BF\03BB\03AE \03C0\03C1\03CC\03C3\03BA\03BB\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111416598829399365)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'el'
,p_message_text=>unistr('\0398\03AD\03BC\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111395071133399349)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111268907280399257)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1 \03AD\03BD\03B1\03C1\03BE\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111392886681399347)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03CC\03C1\03BC\03B1 \03C3\03C4\03BF %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111339343212399308)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'el'
,p_message_text=>unistr('\038F\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111387246692399343)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03AE\03BC\03B5\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111385090540399342)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111384312832399341)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111339643874399309)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B2\03B4\03BF\03BC\03B1\03B4\03B9\03B1\03AF\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03B3\03B9\03B1 \03CC\03BB\03B7 \03C4\03B7\03BD \03B7\03BC\03AD\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111339460090399308)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B2\03B4\03BF\03BC\03B1\03B4\03B9\03B1\03AF\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03B3\03B9\03B1 \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1 \03BC\03B5 \03CE\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111384984707399342)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111384607893399341)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B5\03C2...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111384715283399341)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03CC\03C1\03C4\03C9\03C3\03B7 \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03C9\03BD...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111316826556399292)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03AF\03C3\03C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111263174262399253)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03CC\03C1\03C4\03C9\03C3\03B7 \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03C9\03BD...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111265274484399255)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111384843491399341)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03CC\03C1\03C4\03C9\03C3\03B7 \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03C9\03BD...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111386952512399343)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C0\03B5\03C1\03B9\03BF\03C7\03AE\03C2 %0 \03B4\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111265128782399255)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111289276005399272)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C4\03B7\03C2 \03C3\03B5\03BB\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2 \03C0\03B5\03C1\03B9\03BF\03C7\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111257436359399249)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03C4\03B7\03C2 \03C3\03B5\03BB\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03C0\03B5\03C1\03B9\03BF\03C7\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111378254013399337)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B5\03C2...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111386801779399343)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C4\03CD\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03BF\03C7\03AE\03C2 %0 \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111257359442399249)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B1\03C0\03CC\03B4\03BF\03C3\03B7 \03C4\03B7\03C2 \03C0\03B5\03C1\03B9\03BF\03C7\03AE\03C2 "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111321895299399296)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF #COLUMN_HEADER# \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03AD\03C7\03B5\03B9 \03BA\03AC\03C0\03BF\03B9\03B1 \03C4\03B9\03BC\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111416191308399365)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('%0, \03C0\03C1\03CC\03B3\03C1\03B1\03BC\03BC\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 \03B5\03BC\03C0\03BB\03BF\03C5\03C4\03B9\03C3\03BC\03AD\03BD\03BF\03C5 \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5 ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111323984276399297)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7 \03B5\03BC\03C0\03BB\03BF\03C5\03C4\03B9\03C3\03BC\03AD\03BD\03BF\03C5 \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5 HTML \03C5\03C0\03B5\03C1\03B2\03B1\03AF\03BD\03B5\03B9 \03C4\03BF \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03BC\03AE\03BA\03BF\03C2 \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 (\03C0\03C1\03B1\03B3\03BC\03B1\03C4\03B9\03BA\03CC %0, \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03BF\03BD\03C4\03B1\03B9 %1 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111383887437399341)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111375639593399335)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03B4\03B9\03C0\03BB\03CC\03C4\03C5\03C0\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111373909926399334)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111373830838399334)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BE\03B1\03AF\03C1\03B5\03C3\03B7 \03C4\03B9\03BC\03CE\03BD null')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111383948107399341)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111337509263399307)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03C0\03C1\03BF\03C2 \03C4\03B1 \03BA\03AC\03C4\03C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111337691756399307)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03C0\03C1\03BF\03C2 \03C4\03B1 \03C0\03AC\03BD\03C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111373611759399333)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111374243975399334)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03BB\03BB\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111373776327399334)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111374052485399334)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111374160044399334)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC %0 \03B1\03C0\03CC %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111375740451399335)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03BD\03AD\03C9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111375816477399335)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B1\03BB\03BB\03B1\03B3\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111373518807399333)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03BD\03BF\03CD \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111334568203399305)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03B9\03B1 \03C0\03B1\03C1\03AC\03B4\03B5\03B9\03B3\03BC\03B1, %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111242003074399238)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BD\03B4\03B5\03C3\03B7 \03C0\03AC\03BB\03B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111241929350399238)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03B5\03C1\03AF\03BF\03B4\03BF\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03AD\03C7\03B5\03B9 \03BB\03AE\03BE\03B5\03B9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111242122673399238)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03AC\03C4\03B1\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111241768644399238)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03B5\03C1\03AF\03BF\03B4\03BF\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B8\03B1 \03BB\03AE\03BE\03B5\03B9 \03C3\03C4\03B9\03C2 %0. \0398\03AD\03BB\03B5\03C4\03B5 \03BD\03B1 \03C0\03B1\03C1\03B1\03C4\03B1\03B8\03B5\03AF;')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111241810690399238)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03B5\03C1\03AF\03BF\03B4\03BF\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B8\03B1 \03BB\03AE\03BE\03B5\03B9 \03C3\03C4\03B9\03C2 %0 \03BA\03B1\03B9 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C0\03B1\03C1\03B1\03C4\03B1\03B8\03B5\03AF. \0391\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C3\03C4\03B5 \03C4\03B7\03BD \03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C3\03B1\03C2 \03B3\03B9\03B1 \03C4\03B7\03BD \03B1\03C0\03BF\03C6\03C5\03B3\03AE \03B1\03C0\03CE\03BB\03B5\03B9\03B1\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111394770212399349)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03BF\03C5 \03BA\03CE\03B4\03B9\03BA\03B1 \03B5\03BA\03BA\03B1\03B8\03AC\03C1\03B9\03C3\03B7\03C2 \03C0\03B5\03C1\03B9\03CC\03B4\03BF\03C5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B2\03AC\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111287883622399271)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03BF\03C5 \03BA\03C9\03B4\03B9\03BA\03BF\03CD \03C1\03CD\03B8\03BC\03B9\03C3\03B7\03C2 \03C0\03B5\03C1\03B9\03CC\03B4\03BF\03C5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B2\03AC\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111261915094399252)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03B5\03C1\03AF\03BF\03B4\03BF\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03AD\03C7\03B5\03B9 \03BB\03AE\03BE\03B5\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111393656048399348)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03BB\03B5\03AF\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C0\03B1\03C1\03AC\03B8\03C5\03C1\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03BA\03B1\03B9 \03C0\03B1\03C4\03AE\03C3\03C4\03B5 \03C4\03BF \03BA\03BF\03C5\03BC\03C0\03AF \03B5\03C0\03B1\03BD\03B1\03C6\03CC\03C1\03C4\03C9\03C3\03B7\03C2 \03C4\03BF\03C5 \03C0\03C1\03BF\03B3\03C1\03AC\03BC\03BC\03B1\03C4\03BF\03C2 \03C0\03B5\03C1\03B9\03AE\03B3\03B7\03C3\03B7\03C2 \03B3\03B9\03B1 \03BD\03B1 \03BE\03B5\03BA\03B9\03BD\03AE\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03BD\03AD\03B1 \03C0\03B5\03C1\03AF\03BF\03B4\03BF \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111412939356399362)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA <a href="%0">\03B5\03B4\03CE</a> \03B3\03B9\03B1 \03BD\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03BD\03AD\03B1 \03C0\03B5\03C1\03AF\03BF\03B4\03BF \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111299505818399279)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C0\03B5\03C1\03AF\03BF\03B4\03BF\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111339053873399308)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03AE\03C4\03B1\03BD \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BA\03B1\03BD\03B5\03BD\03CC\03C2 \03B4\03C5\03BD\03B1\03BC\03B9\03BA\03BF\03CD \03C1\03CC\03BB\03BF\03C5 \03C3\03C4\03B7\03BD \03C0\03B5\03C1\03AF\03BF\03B4\03BF \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 Real Application Security \03B3\03B9\03B1 \03C4\03BF\03BD \03C7\03C1\03AE\03C3\03C4\03B7 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111285774237399269)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-99900 \0394\03B5\03BD \03AE\03C4\03B1\03BD \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03C4\03BF\03C5 \03BC\03BF\03BD\03B1\03B4\03B9\03BA\03BF\03CD \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03BF\03CD \03C0\03B5\03C1\03B9\03CC\03B4\03BF\03C5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111302071364399281)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03B1\03B2\03AF\03B1\03C3\03B7 \03C0\03C1\03BF\03C3\03C4\03B1\03C3\03AF\03B1\03C2 \03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7\03C2 \03C0\03B5\03C1\03B9\03CC\03B4\03BF\03C5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2: \0391\03C5\03C4\03CC \03B5\03BD\03B4\03AD\03C7\03B5\03C4\03B1\03B9 \03BD\03B1 \03BF\03C6\03B5\03AF\03BB\03B5\03C4\03B1\03B9 \03C3\03B5 \03BC\03B9\03B1 \03BC\03B7 \03B1\03C5\03C4\03CC\03BC\03B1\03C4\03B7 \03C4\03C1\03BF\03C0\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03C4\03BF\03C5 \03C0\03C1\03BF\03C3\03C4\03B1\03C4\03B5\03C5\03BC\03AD\03BD\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 \03C3\03B5\03BB\03AF\03B4\03B1\03C2 %0. \0391\03BD \03B4\03B5\03BD \03B3\03BD\03C9\03C1\03AF\03B6\03B5\03C4\03B5 \03C4\03B9 \03C0\03C1\03BF\03BA\03AC\03BB\03B5\03C3\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C3\03C6\03AC\03BB\03BC\03B1, \03B5\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE \03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03C3\03B1\03C2')
||unistr(' \03B3\03B9\03B1 \03B2\03BF\03AE\03B8\03B5\03B9\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111421134966399368)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03B1\03B2\03AF\03B1\03C3\03B7 \03C0\03C1\03BF\03C3\03C4\03B1\03C3\03AF\03B1\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2: \0391\03C5\03C4\03CC \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03BF\03C6\03B5\03AF\03BB\03B5\03C4\03B1\03B9 \03C3\03C4\03B7\03BD \03C5\03C0\03BF\03B2\03BF\03BB\03AE \03BC\03B9\03B1\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2 \03C4\03B7\03C2 \03BF\03C0\03BF\03AF\03B1\03C2 \03B7 \03C6\03CC\03C1\03C4\03C9\03C3\03B7 \03B4\03B5\03BD \03B5\03AF\03C7\03B5 \03BF\03BB\03BF\03BA\03BB\03B7\03C1\03C9\03B8\03B5\03AF \03AE \03C3\03C4\03B7 \03BC\03B7 \03B1\03C5\03C4\03CC\03BC\03B1\03C4\03B7 \03C4\03C1\03BF\03C0\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03C0\03C1\03BF\03C3\03C4\03B1\03C4\03B5\03C5\03BC\03AD\03BD\03C9\03BD \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03C9\03BD \03C4\03B7\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2. \0393\03B9\03B1 \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B7 \03B2\03BF\03AE\03B8\03B5\03B9\03B1, \03B5\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE \03C4')
||unistr('\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111420195360399367)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF %0 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03AD\03BD\03B1\03BD \03B1\03C0\03CC \03C4\03BF\03C5\03C2 \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03BF\03C2 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03BF\03C5\03C2 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2 &<>"/;,*|=% \03AE --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111420257008399368)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF %0 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03AD\03BD\03B1\03BD \03B1\03C0\03CC \03C4\03BF\03C5\03C2 \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03BF\03C2 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03BF\03C5\03C2 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2 &<>"/;,*|=% \03AE -- \03AE \03BD\03AD\03B1 \03B3\03C1\03B1\03BC\03BC\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111419903505399367)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF %0 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03B5\03B9\03B4\03B9\03BA\03BF\03CD\03C2 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2. \0395\03C0\03B9\03C4\03C1\03AD\03C0\03BF\03BD\03C4\03B1\03B9 \03BC\03CC\03BD\03BF \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2 a-Z, \03B1\03C1\03B9\03B8\03BC\03BF\03AF 0-9 \03BA\03B1\03B9 \03BA\03B5\03BD\03AC \03B4\03B9\03B1\03C3\03C4\03AE\03BC\03B1\03C4\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111420087839399367)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF %0 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03C3\03CD\03BC\03B2\03BF\03BB\03B1 <, > \03AE " \03C4\03B1 \03BF\03C0\03BF\03AF\03B1 \03B5\03AF\03BD\03B1\03B9 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03BF\03B9 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111264102615399254)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B4\03CC\03B8\03B7\03BA\03B5 \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03B3\03B9\03B1 \03C4\03B7\03BD \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03C4\03B7\03C2 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 \03B3\03B9\03B1 \03BC\03B9\03B1 \03C3\03B5\03BB\03AF\03B4\03B1, \03B7 \03BF\03C0\03BF\03AF\03B1 \03B1\03C0\03B1\03B9\03C4\03B5\03AF \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03CC\03C4\03B1\03BD \03BC\03B5\03C4\03B1\03B2\03B9\03B2\03AC\03B6\03BF\03BD\03C4\03B1\03B9 \03C9\03C2 \03C0\03B1\03C1\03AC\03BC\03B5\03C4\03C1\03BF\03B9 \03BC\03AF\03B1 \03AE \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B5\03C2 \03B1\03B9\03C4\03AE\03C3\03B5\03B9\03C2, \03B5\03BA\03BA\03B1\03B8\03B1\03C1\03AF\03C3\03B5\03B9\03C2 \03B5\03BD\03B4\03B9\03AC\03BC\03B5\03C3\03B7\03C2 \03BC\03BD\03AE\03BC\03B7\03C2 \03AE \03C4\03B9\03BC\03AD\03C2 \03BF\03C1\03B9\03C3\03BC\03AC\03C4\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111296974276399278)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03B1\03B2\03AF\03B1\03C3\03B7 \03C0\03C1\03BF\03C3\03C4\03B1\03C3\03AF\03B1\03C2 \03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7\03C2 \03C0\03B5\03C1\03B9\03CC\03B4\03BF\03C5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2: \0391\03C5\03C4\03CC \03B5\03BD\03B4\03AD\03C7\03B5\03C4\03B1\03B9 \03BD\03B1 \03BF\03C6\03B5\03AF\03BB\03B5\03C4\03B1\03B9 \03C3\03B5 \03BC\03B9\03B1 \03BC\03B7 \03B1\03C5\03C4\03CC\03BC\03B1\03C4\03B7 \03C4\03C1\03BF\03C0\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03C4\03B7\03C2 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7\03C2 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2 \03C0\03BF\03C5 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03AD\03BD\03B1 \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03AE \03C3\03C4\03B7 \03C7\03C1\03AE\03C3\03B7 \03B5\03BD\03CC\03C2 \03B4\03B5\03C3\03BC\03BF\03CD \03BC\03B5 \03AD\03BD\03B1 \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C4\03BF \03BF\03C0\03BF\03AF\03BF \03B5\03AF\03BD\03B1\03B9 \03B5\03C3\03C6\03B1\03BB\03BC\03AD\03BD\03BF \03AE \03BB\03B5')
||unistr('\03AF\03C0\03B5\03B9. \0391\03BD \03B4\03B5\03BD \03B3\03BD\03C9\03C1\03AF\03B6\03B5\03C4\03B5 \03C4\03B9 \03C0\03C1\03BF\03BA\03AC\03BB\03B5\03C3\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C3\03C6\03AC\03BB\03BC\03B1, \03B5\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE \03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03C3\03B1\03C2 \03B3\03B9\03B1 \03B2\03BF\03AE\03B8\03B5\03B9\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111374928915399334)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03C5\03C8\03B7\03BB\03AE\03C2 \03B1\03BD\03C4\03AF\03B8\03B5\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111375073100399334)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03C5\03C8\03B7\03BB\03AE\03C2 \03B1\03BD\03C4\03AF\03B8\03B5\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111293620116399275)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03AD\03BB\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111293815285399275)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03AC\03C4\03C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111293992591399275)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111294083599399276)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03CC\03BB\03C9\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111294173643399276)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111294290999399276)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03CC\03BB\03C9\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111294307253399276)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111293540684399275)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C1\03C7\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111293714149399275)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03AC\03BD\03C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111402619928399355)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'el'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111403383713399355)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03B5 %0 \03B7\03BC.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111402546418399355)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'el'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111403453071399355)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03B5 % \03CE\03C1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111402360377399354)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'el'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111403524479399355)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03B5 %0 \03BB.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111402965397399355)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111403164624399355)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03B5 %0 \03BC.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111402485554399354)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'el'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111403258872399355)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03B5 %0 \03B4\03B5\03C5\03C4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111402719394399355)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'el'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111403692478399355)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03B5 %0 \03B5\03B2\03B4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111402833198399355)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'el'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111403085915399355)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03B5 %0 \03AD\03C4.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111242946054399239)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'el'
,p_message_text=>unistr('[\0393\03C1\03B1\03BC\03BC\03AE]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111243389514399239)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'el'
,p_message_text=>unistr('[\03A0\03BF\03BB\03BB\03B1\03C0\03BB\03AD\03C2 \03B3\03C1\03B1\03BC\03BC\03AD\03C2]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111243120834399239)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'el'
,p_message_text=>unistr('[\03A0\03BF\03BB\03BB\03B1\03C0\03BB\03AC \03C3\03B7\03BC\03B5\03AF\03B1]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111243518868399239)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'el'
,p_message_text=>unistr('[\03A0\03BF\03BB\03BB\03B1\03C0\03BB\03AC \03C0\03BF\03BB\03CD\03B3\03C9\03BD\03B1]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111243638377399239)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'el'
,p_message_text=>unistr('[\0391\03BD\03C4\03B9\03BA\03B5\03AF\03BC\03B5\03BD\03BF \03B3\03B5\03C9\03BC\03B5\03C4\03C1\03AF\03B1\03C2]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111242811323399238)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'el'
,p_message_text=>unistr('[\03A3\03B7\03BC\03B5\03AF\03BF (%0,%1)]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111243012001399239)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'el'
,p_message_text=>unistr('[\03A0\03BF\03BB\03CD\03B3\03C9\03BD\03BF]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111320238333399295)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BC\03C0\03C4\03C5\03BE\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111320138927399295)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111366620469399328)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BA\03BA\03B1\03B8\03AC\03C1\03B9\03C3\03B7 \03B2\03B1\03B8\03BC\03BF\03BB\03BF\03B3\03AF\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111356517615399321)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF %0 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B5\03BD\03C4\03CC\03C2 \03C4\03BF\03C5 \03AD\03B3\03BA\03C5\03C1\03BF\03C5 \03B5\03CD\03C1\03BF\03C5\03C2 \03B2\03B1\03B8\03BC\03BF\03BB\03BF\03B3\03AF\03B1\03C2 1 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111356684542399321)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF %0 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B1\03C1\03B9\03B8\03BC\03B7\03C4\03B9\03BA\03CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111352736017399318)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AE\03BD\03C5\03BC\03B1 \03B5\03C0\03B9\03C4\03C5\03C7\03AF\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111415837016399364)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111415752322399364)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111401480257399354)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03C1\03B1\03BC\03BC\03AE \03B5\03C1\03B3\03B1\03BB\03B5\03AF\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111416214744399365)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03AC\03C0\03C4\03C5\03BE\03B7/\03C3\03CD\03BC\03C0\03C4\03C5\03BE\03B7 \03C0\03B5\03C1\03B9\03AE\03B3\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111416336348399365)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03AC\03C0\03C4\03C5\03BE\03B7/\03C3\03CD\03BC\03C0\03C4\03C5\03BE\03B7 \03C0\03BB\03B5\03C5\03C1\03B9\03BA\03AE\03C2 \03C3\03C4\03AE\03BB\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111325934769399299)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03CD\03C1\03B9\03B1 \03C0\03BB\03BF\03AE\03B3\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111332964625399304)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'el'
,p_message_text=>unistr('1 \03B7\03BC\03AD\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111332736497399304)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'el'
,p_message_text=>unistr('1 \03CE\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111333059782399304)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B7\03BC\03AD\03C1\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111332821934399304)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CE\03C1\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111332624963399304)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BB\03B5\03C0\03C4\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111333286434399304)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111333117494399304)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'el'
,p_message_text=>unistr('1 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111419465838399367)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BD\03B1\03C1\03BE\03B7 \03C3\03B5\03BB\03AF\03B4\03B1\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111281428854399266)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03C7\03B5\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111255266431399247)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03B1\03AF\03C4\03B7\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111334607681399305)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03BA\03B1\03C4\03B1\03C7\03C9\03C1\03B9\03C3\03C4\03B5\03AF \03C4\03B9\03BC\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111417549031399366)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03BC\03AD\03BD\03B5\03C4\03B5 \03BD\03B1 \03BF\03BB\03BF\03BA\03BB\03B7\03C1\03C9\03B8\03B5\03AF \03B7 \03C6\03CC\03C1\03C4\03C9\03C3\03B7 \03C4\03B7\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2 \03BA\03B1\03B9 \03C0\03C1\03BF\03C3\03C0\03B1\03B8\03AE\03C3\03C4\03B5 \03BE\03B1\03BD\03AC.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111377770819399336)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03AE \03B7 \03C3\03B5\03BB\03AF\03B4\03B1 \03AD\03C7\03B5\03B9 \03BC\03B7 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B5\03C2 \03B1\03BB\03BB\03B1\03B3\03AD\03C2.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111258647432399250)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B2\03B9\03B2\03BB\03AF\03BF \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 \03B4\03B5\03BD \03B4\03B9\03B1\03B8\03AD\03C4\03B5\03B9 \03B5\03BD\03B5\03C1\03B3\03CC \03C6\03CD\03BB\03BB\03BF \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111258540210399250)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B2\03B9\03B2\03BB\03AF\03BF \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03B1\03C1\03C7\03B9\03BA\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111258427767399250)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03B5\03C3\03C9\03C4\03B5\03C1\03B9\03BA\03CC \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03C4\03BF\03C5 \03B1\03C1\03C7\03B5\03AF\03BF\03C5 XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111260970516399251)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03CD\03BB\03BB\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111392602536399347)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111310104245399287)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03BD\03BF\03CD \03B5\03BD\03B5\03C1\03B3\03B5\03B9\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111305877523399284)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111305743002399284)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C3\03C4\03AE\03BB\03B7\03C2 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111339977909399309)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111340021395399309)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03B5\03B9\03C1\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111280290579399266)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111316307506399292)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111297434526399278)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C3\03BF\03C2 \03CC\03C1\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111301787398399281)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C4\03C1\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111297565201399278)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03B3\03B9\03C3\03C4\03B7 \03C4\03B9\03BC\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111297766955399278)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03AC\03BC\03B5\03C3\03B7 \03C4\03B9\03BC\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111297635152399278)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BB\03AC\03C7\03B9\03C3\03C4\03B7 \03C4\03B9\03BC\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111297345152399278)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03B8\03C1\03BF\03B9\03C3\03BC\03B1 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111298454646399279)
,p_name=>'APEXIR_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BB\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111279523124399265)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BB\03B5\03C2 \03BF\03B9 \03C3\03C4\03AE\03BB\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111262018929399252)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BB\03B5\03C2 \03BF\03B9 \03C3\03B5\03B9\03C1\03AD\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111389664214399345)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111391223791399346)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AE \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111292176212399274)
,p_name=>'APEXIR_AND'
,p_message_language=>'el'
,p_message_text=>unistr('\03BA\03B1\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111281682996399267)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C6\03B1\03C1\03BC\03BF\03B3\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111275390964399262)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03CD\03BE\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111294942070399276)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03C0\03C9\03C2 \03B5\03AF\03C7\03B5 \03B4\03B9\03B1\03BC\03BF\03C1\03C6\03C9\03B8\03B5\03AF %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111391875893399347)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C3\03BF\03C2 \03CC\03C1\03BF\03C2 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111383229506399340)
,p_name=>'APEXIR_BAR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A1\03AC\03B2\03B4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111281084432399266)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B5\03C4\03B1\03BE\03CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111274162503399261)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03CE\03BC\03B1 \03C6\03CC\03BD\03C4\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111276096246399263)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03C0\03BB\03B5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111307702320399285)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03AD\03BB\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111276682368399263)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BA\03CD\03C1\03C9\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111282570905399267)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03B7\03B3\03BF\03C1\03AF\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111274040662399261)
,p_name=>'APEXIR_CELL'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B5\03BB\03AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111298333722399279)
,p_name=>'APEXIR_CHART'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03C1\03AC\03C6\03B7\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111308638413399286)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03C4\03BF\03B9\03BC\03B1\03C3\03AF\03B1...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111344912959399312)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03B7\03C2 \03B5\03C4\03B9\03BA\03AD\03C4\03B1\03C2 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111357340768399322)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03AC \03C3\03B1\03C2 \03C5\03C0\03B5\03C1\03B2\03B1\03AF\03BD\03B5\03B9 \03C4\03BF\03BD \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD %0 \03C3\03B7\03BC\03B5\03AF\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03B1\03BD\03AC \03B3\03C1\03AC\03C6\03B7\03BC\03B1. \0395\03C6\03B1\03C1\03BC\03CC\03C3\03C4\03B5 \03AD\03BD\03B1 \03C6\03AF\03BB\03C4\03C1\03BF \03B3\03B9\03B1 \03BD\03B1 \03BC\03B5\03B9\03CE\03C3\03B5\03C4\03B5 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03B5\03B3\03B3\03C1\03B1\03C6\03CE\03BD \03C3\03C4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111356234582399321)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\039F \03BC\03AD\03B3\03B9\03C3\03C4\03BF\03C2 \03B1\03C1\03B9\03B8\03BC\03CC\03C2 \03C3\03B5\03B9\03C1\03CE\03BD \03B3\03B9\03B1 \03AD\03BD\03B1 \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2 \03C0\03B5\03C1\03B9\03BF\03C1\03AF\03B6\03B5\03B9 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD \03C3\03C4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03BA\03B1\03B9 \03CC\03C7\03B9 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD.'),
unistr('\03A4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03AC \03C3\03B1\03C2 \03C5\03C0\03B5\03C1\03B2\03B1\03AF\03BD\03B5\03B9 \03C4\03BF\03BD \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD %0 \03C3\03B5\03B9\03C1\03CE\03BD. \0395\03C6\03B1\03C1\03BC\03CC\03C3\03C4\03B5 \03AD\03BD\03B1 \03C6\03AF\03BB\03C4\03C1\03BF \03B3\03B9\03B1 \03BD\03B1 \03BC\03B5\03B9\03CE\03C3\03B5\03C4\03B5 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03B5\03B3\03B3\03C1\03B1\03C6\03CE\03BD \03C3\03C4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03B1.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111279606925399265)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03CD\03C0\03BF\03C2 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111352972830399318)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03CC\03BB\03C9\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111295388901399276)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C4\03B7 \03BC\03BF\03C1\03C6\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111302754619399282)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03BA\03BA\03B1\03B8\03AC\03C1\03B9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111276564585399263)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111313922250399290)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B5\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111386277807399343)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03B9\03BB\03C4\03C1\03AC\03C1\03B9\03C3\03BC\03B1...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111304770787399283)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03BD\03BF\03CD \03B5\03C0\03B9\03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1\03C2 \03C3\03C4\03AE\03BB\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111308439645399286)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BB\03B7\03C1\03BF\03C6\03BF\03C1\03AF\03B5\03C2 \03C3\03C4\03AE\03BB\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111388545631399344)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C4\03B9\03BA\03AD\03C4\03B1 \03C3\03C4\03AE\03BB\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111306159605399284)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B7 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111290210611399273)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'el'
,p_message_text=>unistr('\03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111291193025399273)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B5\03BD \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111275058259399262)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03BD\03C4\03CC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111291303796399274)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111299822824399280)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03B5\03C0\03CC\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111291224653399273)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03AF\03BD\03B1\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111299758677399280)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03AF\03BD\03B1\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03B5\03C0\03CC\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111274914635399262)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111274823483399262)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03AF\03BD\03B1\03B9 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111274610130399262)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'el'
,p_message_text=>unistr('\03C0\03B1\03C1\03CC\03BC\03BF\03B9\03BF \03BC\03B5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111275101722399262)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'el'
,p_message_text=>unistr('\03CC\03C7\03B9 \03B5\03BD\03C4\03CC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111274771835399262)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'el'
,p_message_text=>unistr('\03CC\03C7\03B9 \03C0\03B1\03C1\03CC\03BC\03BF\03B9\03BF \03BC\03B5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111290506060399273)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03C5\03BC\03C6\03C9\03BD\03B5\03AF \03BC\03B5 \03BA\03B1\03BD\03BF\03BD\03B9\03BA\03AE \03AD\03BA\03C6\03C1\03B1\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111295273674399276)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111355935154399321)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BA\03C6\03C1\03B1\03C3\03B7 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111314299079399290)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3\03C4\03B5 \03AD\03BD\03B1\03BD \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03CE\03BD\03C4\03B1\03C2 \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03B1 \03C3\03C4\03B7\03BB\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111314376745399290)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'el'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111314437648399290)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'el'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111314503220399290)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'el'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111260443329399251)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'el'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111299198950399279)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111306736322399285)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF\03BC\03AE \03B5\03BB\03AD\03B3\03C7\03BF\03C5')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111309770811399287)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF\03BC\03AD\03C2 \03B5\03BB\03AD\03B3\03C7\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111394169768399348)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B5\03C2 \03C4\03BF\03BC\03CE\03BD \03B5\03BB\03AD\03B3\03C7\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111257540081399249)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C4\03C1\03B7\03C3\03B7 \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111392350593399347)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C4\03C1\03B7\03C3\03B7 \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111392244999399347)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C4\03C1\03B7\03C3\03B7 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111364375843399327)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03B8\03B7\03BC\03B5\03C1\03B9\03BD\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111419070156399367)
,p_name=>'APEXIR_DATA'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03B4\03BF\03BC\03AD\03BD\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111308516155399286)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C0\03C1\03B9\03BD \03B1\03C0\03CC %0 \03BB\03B5\03C0\03C4\03AC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111382094912399339)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111280319255399266)
,p_name=>'APEXIR_DATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111312411884399289)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03C0\03B9\03BB\03BF\03B3\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111389412202399345)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03CD\03C0\03BF\03C2 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111276721098399263)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111280676116399266)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'el'
,p_message_text=>unistr('\0398\03AD\03BB\03B5\03C4\03B5 \03BD\03B1 \03B4\03B9\03B1\03B3\03C1\03B1\03C6\03BF\03CD\03BD \03B1\03C5\03C4\03AD\03C2 \03BF\03B9 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2;')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111375312237399335)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111306421280399285)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03B3\03C1\03B1\03C6\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111275417035399262)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03B8\03AF\03BD\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111282616000399267)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03B3\03C1\03B1\03C6\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111304629788399283)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03BC\03B5\03BC\03BF\03BD\03C9\03BC\03AD\03BD\03B7\03C2 \03C3\03B5\03B9\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111312980544399289)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03B5\03CD\03B8\03C5\03BD\03C3\03B7 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111313859575399290)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03C7\03B5\03B9 \03B1\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111276254387399263)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111279435057399265)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111312824189399289)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03C3\03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111307633476399285)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03AC\03C4\03C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111299256715399279)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AE\03C8\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111312797389399289)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'el'
,p_message_text=>unistr('\039D\03B1 \03BC\03B7\03BD \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111378791846399337)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'el'
,p_message_text=>unistr('\03A5\03C0\03AC\03C1\03C7\03B5\03B9 \03AE\03B4\03B7 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7 \03BC\03B5 \03C4\03B7\03BD \03AF\03B4\03B9\03B1 \03C3\03C5\03BD\03B8\03AE\03BA\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111394391816399349)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03C0\03BB\03CC\03C4\03C5\03C0\03B7 \03C3\03C4\03AE\03BB\03B7 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD. \0397 \03BB\03AF\03C3\03C4\03B1 \03C3\03C4\03B7\03BB\03CE\03BD \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03BC\03BF\03BD\03B1\03B4\03B9\03BA\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111394557934399349)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111308748629399286)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03C9\03BD \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111315365767399291)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111315736772399291)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C6\03AF\03BB\03C4\03C1\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111370190442399331)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03BF\03BC\03AC\03B4\03B1\03C2 \03B1\03C0\03CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111315673721399291)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111340205418399309)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111389739027399345)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03CC \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111268408529399257)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111390069417399345)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'el'
,p_message_text=>unistr('\039A.\039A\03BF\03B9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111390279120399345)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03CD\03C1\03B9\03BF \03BC\03AD\03C1\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111389975313399345)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03BF\03B9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111390710574399346)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03C7\03BD\03CC\03C4\03B7\03C4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111272114402399260)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03CC \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF \03B3\03B9\03B1 \03B1\03C5\03C4\03AE\03BD \03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03B4\03B9\03B1\03BC\03BF\03C1\03C6\03C9\03B8\03B5\03AF. \0395\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111363651368399326)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03B7\03C2 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7\03C2 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111390369195399346)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03AF\03C4\03B5 \03C4\03BF \03C3\03C5\03BD\03B7\03BC\03BC\03AD\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111390159809399345)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'el'
,p_message_text=>unistr('\0398\03AD\03BC\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111364623156399327)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03BF\03C5 \03B8\03AD\03BC\03B1\03C4\03BF\03C2 \03BC\03B7\03BD\03CD\03BC\03B1\03C4\03BF\03C2 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111389862576399345)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111273891324399261)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03C7\03B5\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111315583487399291)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7/\0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111315054628399291)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C6\03AC\03BB\03BC\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111314617172399290)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03B1\03B4\03B5\03AF\03B3\03BC\03B1\03C4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111315436455399291)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03B1\03B4\03B5\03AF\03B3\03BC\03B1\03C4\03B1:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111279328941399265)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BE\03B1\03AF\03C1\03B5\03C3\03B7 \03C4\03B9\03BC\03CE\03BD null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111316081255399291)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03AC\03C0\03C4\03C5\03BE\03B7/\03A3\03CD\03BC\03C0\03C4\03C5\03BE\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111313611032399290)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BA\03C6\03C1\03B1\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111298780119399279)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03B9\03BB\03C4\03C1\03AC\03C1\03B9\03C3\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111309610047399287)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03AF\03BB\03C4\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111319961529399294)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BA\03C6\03C1\03B1\03C3\03B7 \03C6\03AF\03BB\03C4\03C1\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111416477212399365)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03AD\03BA\03C6\03C1\03B1\03C3\03B7 \03C6\03AF\03BB\03C4\03C1\03BF\03C5 \03B5\03AF\03BD\03B1\03B9 \03C0\03BF\03BB\03CD \03BC\03B5\03B3\03AC\03BB\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111319826310399294)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03CD\03C0\03BF\03C2 \03C6\03AF\03BB\03C4\03C1\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111316215023399292)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C3\03C4\03AE\03BB\03B5\03C2 \03B3\03B9\03B1 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111299081842399279)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B4\03C1\03BF\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111313463423399290)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BD\03B1 \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03B1\03BD\03B1\03B4\03C1\03BF\03BC\03AE\03C2 \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03C4\03B7\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03C4\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03CC\03C0\03C9\03C2 \03B5\03AF\03C7\03B1\03BD \03B4\03B9\03B1\03BC\03BF\03C1\03C6\03C9\03B8\03B5\03AF \03C3\03B5 \03AD\03BD\03B1 \03C3\03C5\03B3\03BA\03B5\03BA\03C1\03B9\03BC\03AD\03BD\03BF \03C7\03C1\03BF\03BD\03B9\03BA\03CC \03C3\03B7\03BC\03B5\03AF\03BF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111364015062399326)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03AC\03C1\03BA\03B5\03B9\03B1 \03B1\03BD\03B1\03B4\03C1\03BF\03BC\03AE\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111365414345399327)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03BF\03C1\03C6\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111295156673399276)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AC\03C3\03BA\03B1 \03BC\03BF\03C1\03C6\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111306321226399284)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111314160266399290)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03B1\03C1\03C4\03AE\03C3\03B5\03B9\03C2 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111389325421399345)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03B1\03C1\03C4\03AE\03C3\03B5\03B9\03C2/\03A4\03B5\03BB\03B5\03C3\03C4\03AD\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111306075647399284)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111298521774399279)
,p_name=>'APEXIR_GO'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03AC\03B2\03B1\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111274313609399261)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'el'
,p_message_text=>unistr('\03C0\03C1\03AC\03C3\03B9\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111257631132399249)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BA\03B1\03C4\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111390413919399346)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B7 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111345021523399313)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03B7\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03B2\03AC\03C3\03B5\03B9 \03C4\03B7\03C2 \03BF\03C0\03BF\03AF\03B1\03C2 \03B8\03B1 \03B3\03AF\03BD\03B5\03B9 \03B7 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111356165753399321)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BC\03AD\03B3\03B9\03C3\03C4\03BF\03C2 \03B1\03C1\03B9\03B8\03BC\03CC\03C2 \03C3\03B5\03B9\03C1\03CE\03BD \03B3\03B9\03B1 \03AD\03BD\03B1 \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2 \03C0\03B5\03C1\03B9\03BF\03C1\03AF\03B6\03B5\03B9 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD \03C3\03C4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03BA\03B1\03B9 \03CC\03C7\03B9 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD. \03A4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03AC \03C3\03B1\03C2 \03C5\03C0\03B5\03C1\03B2\03B1\03AF\03BD\03B5\03B9 \03C4\03BF\03BD \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD %0 \03C3\03B5\03B9\03C1\03CE\03BD. \0395\03C6\03B1\03C1\03BC\03CC\03C3\03C4\03B5 \03AD\03BD\03B1 \03C6\03AF\03BB\03C4\03C1\03BF \03B3\03B9\03B1 \03BD\03B1 \03BC\03B5\03B9')
||unistr('\03CE\03C3\03B5\03C4\03B5 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03B5\03B3\03B3\03C1\03B1\03C6\03CE\03BD \03C3\03C4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111336766699399306)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111394260121399348)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111279772828399265)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03C1\03B9\03B6\03CC\03BD\03C4\03B9\03B1 \03C3\03C4\03AE\03BB\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111311350987399288)
,p_name=>'APEXIR_HELP'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111303187450399282)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\039F\03B9 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AD\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AD\03C2 \03C0\03B1\03C1\03AD\03C7\03BF\03C5\03BD \03C3\03C4\03BF\03C5\03C2 \03C4\03B5\03BB\03B9\03BA\03BF\03CD\03C2 \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03C4\03B7 \03B4\03C5\03BD\03B1\03C4\03CC\03C4\03B7\03C4\03B1 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03C4\03C9\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03CE\03BD. \039F\03B9 \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03C4\03C1\03BF\03C0\03BF\03C0\03BF\03B9\03BF\03CD\03BD \03C4\03B7 \03B4\03BF\03BC\03AE \03C4\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C4\03C9\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03CE\03BD, \03B5\03C0\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03B1\03C2 \03C3\03C4\03AE\03BB\03B5\03C2, \03B5\03C6\03B1\03C1\03BC\03CC\03B6\03BF\03BD\03C4\03B1\03C2 \03C6\03AF\03BB\03C4\03C1\03B1, \03B5\03C0\03B9\03C3\03B7\03BC\03B1\03AF\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03B1\03B9 \03C4\03B1\03BE\03B9\03BD\03BF\03BC\03CE\03BD\03C4\03B1\03C2 \03C4\03B9\03C2 \03C0\03BB\03B7\03C1\03BF\03C6')
||unistr('\03BF\03C1\03AF\03B5\03C2. \039C\03C0\03BF\03C1\03BF\03CD\03BD \03B5\03C0\03AF\03C3\03B7\03C2 \03BD\03B1 \03BF\03C1\03AF\03B6\03BF\03C5\03BD \03C4\03BF\03BC\03AD\03C2, \03C3\03C5\03BD\03B1\03B8\03C1\03BF\03AF\03C3\03B5\03B9\03C2, \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03B1 \03BA\03B1\03B9 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03B9\03C2 \03BA\03B1\03B8\03CE\03C2 \03BA\03B1\03B9 \03BD\03B1 \03C0\03C1\03BF\03C3\03B8\03AD\03C4\03BF\03C5\03BD \03C4\03BF\03C5\03C2 \03B4\03B9\03BA\03BF\03CD\03C2 \03C4\03BF\03C5\03C2 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD\03C2. \039C\03C0\03BF\03C1\03BF\03CD\03BD \03B1\03BA\03CC\03BC\03B1 \03BD\03B1 \03B5\03B3\03B3\03C1\03B1\03C6\03BF\03CD\03BD \03C3\03C5\03BD\03B4\03C1\03BF\03BC\03B7\03C4\03AD\03C2 \03C3\03B5 \03BC\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC, \03CE\03C3\03C4\03B5 \03BD\03B1 \03BB\03B1\03BC\03B2\03AC\03BD\03BF\03C5\03BD \03C4\03B1\03BA\03C4\03B9\03BA\03AC \03BC\03B9\03B1 \03AD\03BA\03B4\03BF\03C3\03B7 HTML \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BC\03AD\03C3')
||unistr('\03C9 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5. \039F\03B9 \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03BF\03CD\03BD \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03AD\03C2 \03C0\03B1\03C1\03B1\03BB\03BB\03B1\03B3\03AD\03C2 \03BC\03B9\03B1\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BA\03B1\03B9 \03BD\03B1 \03C4\03B9\03C2 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03BF\03C5\03BD \03BC\03B5 \03BE\03B5\03C7\03C9\03C1\03B9\03C3\03C4\03CC \03CC\03BD\03BF\03BC\03B1 \03B3\03B9\03B1 \03B4\03B7\03BC\03CC\03C3\03B9\03B1 \03AE \03B9\03B4\03B9\03C9\03C4\03B9\03BA\03AE \03C0\03C1\03BF\03B2\03BF\03BB\03AE. '),
'<p/>',
unistr('\039F\03B9 \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03B5\03C2 \03B5\03BD\03CC\03C4\03B7\03C4\03B5\03C2 \03C3\03C5\03BD\03BF\03C8\03AF\03B6\03BF\03C5\03BD \03C4\03BF\03C5\03C2 \03C4\03C1\03CC\03C0\03BF\03C5\03C2 \03BC\03B5 \03C4\03BF\03C5\03C2 \03BF\03C0\03BF\03AF\03BF\03C5\03C2 \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03CC\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC. \0393\03B9\03B1 \03BD\03B1 \03BC\03AC\03B8\03B5\03C4\03B5 \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B1, \03B1\03BD\03B1\03C4\03C1\03AD\03BE\03C4\03B5 \03C3\03C4\03BF \03C3\03C7\03B5\03C4\03B9\03BA\03CC \03B8\03AD\03BC\03B1 ("Using Interactive Reports") \03C3\03C4\03BF\03BD <i>\039F\03B4\03B7\03B3\03CC \03B3\03B9\03B1 \03C4\03B5\03BB\03B9\03BA\03BF\03CD\03C2 \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03C4\03BF\03C5 Oracle Applicat')
||'ion Express</i></a>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111310270763399287)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03BC\03B5\03BD\03BF\03CD \0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03B4\03B5\03BE\03B9\03AC \03B1\03C0\03CC \03C4\03BF \03BA\03BF\03C5\03BC\03C0\03AF \039C\03B5\03C4\03AC\03B2\03B1\03C3\03B7 \03C3\03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2. \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03BC\03B5\03BD\03BF\03CD \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE \03BC\03B9\03B1\03C2 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111303922454399283)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\039F\03B9 \03C3\03C5\03BD\03B1\03B8\03C1\03BF\03AF\03C3\03B5\03B9\03C2 \03B5\03AF\03BD\03B1\03B9 \03BC\03B1\03B8\03B7\03BC\03B1\03C4\03B9\03BA\03BF\03AF \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03AF \03C0\03BF\03C5 \03B5\03BA\03C4\03B5\03BB\03BF\03CD\03BD\03C4\03B1\03B9 \03C3\03B5 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7. \039F\03B9 \03C3\03C5\03BD\03B1\03B8\03C1\03BF\03AF\03C3\03B5\03B9\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03BC\03B5\03C4\03AC \03B1\03C0\03CC \03BA\03AC\03B8\03B5 \03C4\03BF\03BC\03AE \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03BA\03B1\03B9 \03C3\03C4\03BF \03C4\03AD\03BB\03BF\03C2 \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03B5\03BD\03C4\03CC\03C2 \03C4\03B7\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03C4\03B7\03BD \03BF\03C0\03BF\03AF\03B1 \03BF\03C1\03AF\03B6\03BF\03BD\03C4\03B1\03B9. \03A5\03C0\03AC\03C1\03C7\03BF\03C5\03BD \03BF\03B9 \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03B5\03C2 \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03C2:'),
'<p>',
'</p><ul>',
unistr('<li><strong>\03A3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7</strong> - \03A3\03B1\03C2 \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \03BC\03B9\03B1 \03AE\03B4\03B7 \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03B7 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7 \03B3\03B9\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1.</li>'),
unistr('<li><strong>\03A3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7</strong> - \0395\03AF\03BD\03B1\03B9 \03B7 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 \03C0\03BF\03C5 \03B8\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF (\03C0.\03C7. SUM, MIN).</li>'),
unistr('<li><strong>\03A3\03C4\03AE\03BB\03B7</strong> - \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03C4\03B7\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03C4\03B7\03BD \03BF\03C0\03BF\03AF\03B1 \03B8\03B1 \03B5\03C6\03B1\03C1\03BC\03BF\03C3\03C4\03B5\03AF \03B7 \03BC\03B1\03B8\03B7\03BC\03B1\03C4\03B9\03BA\03AE \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7. \0395\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03BC\03CC\03BD\03BF \03BF\03B9 \03B1\03C1\03B9\03B8\03BC\03B7\03C4\03B9\03BA\03AD\03C2 \03C3\03C4\03AE\03BB\03B5\03C2.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111304012618399283)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03AD\03BD\03B1 \03B3\03C1\03AC\03C6\03B7\03BC\03B1 \03B1\03BD\03AC \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC. \0391\03C6\03BF\03CD'),
unistr('\03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03BF \03B3\03C1\03AC\03C6\03B7\03BC\03B1, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B5\03BD\03B1\03BB\03BB\03AC\03C3\03C3\03B5\03C3\03C4\03B5 \03BC\03B5\03C4\03B1\03BE\03CD \03C4\03C9\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03CE\03BD \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2 \03BA\03B1\03B9 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03CE\03BD\03C4\03B1\03C2 \03C4\03B1 \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE\03C2 \03C3\03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2.'),
unistr('\03A5\03C0\03AC\03C1\03C7\03BF\03C5\03BD \03BF\03B9 \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03B5\03C2 \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03C2:  '),
'<p>',
'</p><ul>',
unistr('<li><strong>\03A4\03CD\03C0\03BF\03C2 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2</strong> - \03A0\03C1\03BF\03C3\03B4\03B9\03BF\03C1\03AF\03B6\03B5\03B9 \03C4\03BF\03BD \03C4\03CD\03C0\03BF \03C4\03BF\03C5 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2 \03C0\03BF\03C5 \03B8\03B1 \03C3\03C5\03BC\03C0\03B5\03C1\03B9\03BB\03B7\03C6\03B8\03B5\03AF.'),
unistr('\039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \03B3\03C1\03AC\03C6\03B7\03BC\03B1 \03BF\03C1\03B9\03B6\03CC\03BD\03C4\03B9\03C9\03BD \03AE \03BA\03B1\03C4\03B1\03BA\03CC\03C1\03C5\03C6\03C9\03BD \03C1\03AC\03B2\03B4\03C9\03BD, \03B3\03C1\03AC\03C6\03B7\03BC\03B1 \03C0\03AF\03C4\03B1\03C2 \03AE \03B3\03C1\03AC\03C6\03B7\03BC\03B1 \03B3\03C1\03B1\03BC\03BC\03CE\03BD.</li>'),
unistr('<li><strong>\0395\03C4\03B9\03BA\03AD\03C4\03B1</strong> - \03A3\03AC\03C2 \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \03C4\03B7 \03C3\03C4\03AE\03BB\03B7 \03C0\03BF\03C5 \03B8\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B1\03B9 \03C9\03C2 \03B5\03C4\03B9\03BA\03AD\03C4\03B1.</li>'),
unistr('<li><strong>\03A4\03AF\03C4\03BB\03BF\03C2 \03AC\03BE\03BF\03BD\03B1 \03B3\03B9\03B1 \03B5\03C4\03B9\03BA\03AD\03C4\03B1</strong> \039F \03C4\03AF\03C4\03BB\03BF\03C2 \03C0\03BF\03C5 \03B8\03B1 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03C3\03C4\03BF\03BD \03AC\03BE\03BF\03BD\03B1 \03C0\03BF\03C5 \03AD\03C7\03B5\03B9 \03C3\03C5\03C3\03C7\03B5\03C4\03B9\03C3\03C4\03B5\03AF \03BC\03B5 \03C4\03B7 \03C3\03C4\03AE\03BB\03B7 \03B7 \03BF\03C0\03BF\03AF\03B1 \03AD\03C7\03B5\03B9 \03B5\03C0\03B9\03BB\03B5\03B3\03B5\03AF \03C9\03C2'),
unistr('\0395\03C4\03B9\03BA\03AD\03C4\03B1. \0391\03C5\03C4\03AE \03B7 \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B7 \03B3\03B9\03B1 \03C4\03BF \03B3\03C1\03AC\03C6\03B7\03BC\03B1 \03C0\03AF\03C4\03B1\03C2.</li>'),
unistr('<li><strong>\03A4\03B9\03BC\03AE</strong> \03A3\03AC\03C2 \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \03C4\03B7 \03C3\03C4\03AE\03BB\03B7 \03C0\03BF\03C5 \03B8\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B1\03B9 \03C9\03C2 \03C4\03B9\03BC\03AE. \0391\03BD \03B7 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7'),
unistr('\03B5\03AF\03BD\03B1\03B9 COUNT, \03B4\03B5\03BD \03B1\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03B7 \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03A4\03B9\03BC\03AE\03C2.</li>'),
unistr('<li><strong>\03A4\03AF\03C4\03BB\03BF\03C2 \03AC\03BE\03BF\03BD\03B1 \03B3\03B9\03B1 \03C4\03B9\03BC\03AE</strong> \039F \03C4\03AF\03C4\03BB\03BF\03C2 \03C0\03BF\03C5 \03B8\03B1 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03C3\03C4\03BF\03BD \03AC\03BE\03BF\03BD\03B1 \03C0\03BF\03C5 \03B5\03AF\03BD\03B1\03B9 \03C3\03C5\03C3\03C7\03B5\03C4\03B9\03C3\03BC\03AD\03BD\03BF\03C2 \03BC\03B5 \03C4\03B7 \03C3\03C4\03AE\03BB\03B7 \03B7 \03BF\03C0\03BF\03AF\03B1 \03AD\03C7\03B5\03B9 \03B5\03C0\03B9\03BB\03B5\03B3\03B5\03AF \03C9\03C2'),
unistr('\03A4\03B9\03BC\03AE. \0391\03C5\03C4\03AE \03B7 \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B7 \03B3\03B9\03B1 \03C4\03BF \03B3\03C1\03AC\03C6\03B7\03BC\03B1 \03C0\03AF\03C4\03B1\03C2.</li>'),
unistr('<li><strong>\03A3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7</strong> - \039C\03B9\03B1 \03C0\03C1\03BF\03B1\03B9\03C1\03B5\03C4\03B9\03BA\03AE \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 \03C0\03BF\03C5 \03B8\03B1 \03B5\03BA\03C4\03B5\03BB\03B5\03AF\03C4\03B1\03B9 \03C3\03C4\03B7 \03C3\03C4\03AE\03BB\03B7 \03C0\03BF\03C5 \03AD\03C7\03B5\03B9 \03B5\03C0\03B9\03BB\03B5\03B3\03B5\03AF \03C9\03C2 \03A4\03B9\03BC\03AE.</li>'),
unistr('<li><strong>\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7</strong> \03A3\03AC\03C2 \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03C4\03B1\03BE\03B9\03BD\03BF\03BC\03AE\03C3\03B5\03C4\03B5 \03C4\03BF \03C3\03CD\03BD\03BF\03BB\03BF \03B1\03C0\03BF\03C4\03B5\03BB\03B5\03C3\03BC\03AC\03C4\03C9\03BD.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111303323747399282)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\039A\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1 \03BF\03C0\03BF\03B9\03B1\03C3\03B4\03AE\03C0\03BF\03C4\03B5 \03C3\03C4\03AE\03BB\03B7\03C2, \03B1\03BD\03BF\03AF\03B3\03B5\03B9 \03AD\03BD\03B1 \03BC\03B5\03BD\03BF\03CD \03B5\03C0\03B9\03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03BC\03B5 \03C4\03B9\03C2 \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03B5\03C2 \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03C2:'),
'<p></p>',
'<ul>',
unistr('<li><strong>\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C3\03B5 \03B1\03CD\03BE\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC</strong> - \03A4\03B1\03BE\03B9\03BD\03BF\03BC\03B5\03AF \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B2\03AC\03C3\03B5\03B9 \03B1\03C5\03C4\03AE\03C2 \03C4\03B7\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03B5 \03B1\03CD\03BE\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC.</li>'),
unistr('<li><strong>\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C3\03B5 \03C6\03B8\03AF\03BD\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC</strong> - \03A4\03B1\03BE\03B9\03BD\03BF\03BC\03B5\03AF \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B2\03AC\03C3\03B5\03B9 \03B1\03C5\03C4\03AE\03C2 \03C4\03B7\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03B5 \03C6\03B8\03AF\03BD\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC.</li>'),
unistr('<li><strong>\0391\03C0\03CC\03BA\03C1\03C5\03C8\03B7 \03C3\03C4\03AE\03BB\03B7\03C2</strong> - \0391\03C0\03BF\03BA\03C1\03CD\03C0\03C4\03B5\03B9 \03C4\03B7 \03C3\03C4\03AE\03BB\03B7. \0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B1\03C0\03CC\03BA\03C1\03C5\03C8\03B7 \03CC\03BB\03C9\03BD \03C4\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD. \038C\03C4\03B1\03BD \03B7 \03B1\03C0\03CC\03BA\03C1\03C5\03C8\03B7 \03BC\03B9\03B1\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE, \03B7 \03B5\03C0\03B9\03BB\03BF\03B3\03AE \0391\03C0\03CC\03BA\03C1\03C5\03C8\03B7 \03C3\03C4\03AE\03BB\03B7\03C2 \03B4\03B5\03BD \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03C3\03C4\03BF \03BC\03B5\03BD\03BF\03CD.</li>'),
unistr('<li><strong>\03A4\03BF\03BC\03AE \03C3\03C4\03AE\03BB\03B7\03C2</strong> - \0394\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03B5\03AF \03BC\03B9\03B1 \03BF\03BC\03AC\03B4\03B1 \03C4\03BF\03BC\03AE\03C2 \03C3\03C4\03B7 \03C3\03C4\03AE\03BB\03B7. \0391\03C5\03C4\03CC \03AD\03C7\03B5\03B9 \03C9\03C2 \03B1\03C0\03BF\03C4\03AD\03BB\03B5\03C3\03BC\03B1 \03C4\03B7\03BD \03B5\03BE\03B1\03B3\03C9\03B3\03AE \03C4\03B7\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03B1\03C0\03CC \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C9\03C2 \03BA\03CD\03C1\03B9\03B1\03C2 \03B5\03B3\03B3\03C1\03B1\03C6\03AE\03C2.</li>'),
unistr('<li><strong>\03A0\03BB\03B7\03C1\03BF\03C6\03BF\03C1\03AF\03B5\03C2 \03C3\03C4\03AE\03BB\03B7\03C2</strong> - \0395\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03B9 \03BA\03B5\03AF\03BC\03B5\03BD\03BF \03B2\03BF\03AE\03B8\03B5\03B9\03B1\03C2 \03B3\03B9\03B1 \03C4\03B7 \03C3\03C4\03AE\03BB\03B7, \03B1\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.</li>'),
unistr('<li><strong>\03A0\03B5\03C1\03B9\03BF\03C7\03AE \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5</strong> - \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03B7\03BD \03B5\03B9\03C3\03B1\03B3\03C9\03B3\03AE \03BA\03C1\03B9\03C4\03B7\03C1\03AF\03C9\03BD \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03C7\03C9\03C1\03AF\03C2 \03B4\03B9\03AC\03BA\03C1\03B9\03C3\03B7 \03C0\03B5\03B6\03CE\03BD/\03BA\03B5\03C6\03B1\03BB\03B1\03AF\03C9\03BD (\03B4\03B5\03BD \03C7\03C1\03B5\03B9\03AC\03B6\03BF\03BD\03C4\03B1\03B9 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2 \03BC\03C0\03B1\03BB\03B1\03BD\03C4\03AD\03C1). \0397 \03B5\03B9\03C3\03B1\03B3\03C9\03B3\03AE \03BC\03B9\03B1\03C2 \03C4\03B9\03BC\03AE\03C2 \03BC\03B5\03B9\03CE\03BD\03B5\03B9 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03C4\03B9\03BC\03CE\03BD \03C3\03C4\03BF \03BA\03AC\03C4\03C9 \03BC\03AD\03C1\03BF\03C2 \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2. \039C\03C0\03BF\03C1\03B5')
||unistr('\03AF\03C4\03B5 \03C3\03C4\03B7 \03C3\03C5\03BD\03AD\03C7\03B5\03B9\03B1 \03BD\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \03BC\03B9\03B1 \03C4\03B9\03BC\03AE \03B1\03C0\03CC \03C4\03BF \03BA\03AC\03C4\03C9 \03BC\03AD\03C1\03BF\03C2 \03BA\03B1\03B9 \03B7 \03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7 \03C4\03B9\03BC\03AE \03B8\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF \03B3\03B9\03B1 \03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03B5\03BD\03CC\03C2 \03C6\03AF\03BB\03C4\03C1\03BF\03C5 \03BC\03B5 \03C7\03C1\03AE\03C3\03B7 \03C4\03BF\03C5 ''='' (\03C0.\03C7. <code>column = ''ABC''</code>). \0395\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AC, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03BA\03AC\03BD\03B5\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF \03C6\03B1\03BA\03BF\03CD \03BA\03B1\03B9 \03BD\03B1 \03B5\03B9\03C3\03B1\03B3')
||unistr('\03AC\03B3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C4\03B9\03BC\03AE \03B3\03B9\03B1 \03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03B5\03BD\03CC\03C2 \03C6\03AF\03BB\03C4\03C1\03BF\03C5 \03BC\03B5 \03C4\03BF ''LIKE'' (\03C0.\03C7. <code>column LIKE ''%ABC%''</code>).</li>'),
unistr('<li><b>\039B\03AF\03C3\03C4\03B1 \03BC\03BF\03BD\03B1\03B4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD</b> - \03A0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03C4\03B9\03C2 \03C0\03C1\03CE\03C4\03B5\03C2 500 \03BC\03BF\03BD\03B1\03B4\03B9\03BA\03AD\03C2 \03C4\03B9\03BC\03AD\03C2 \03C0\03BF\03C5 \03C0\03BB\03B7\03C1\03BF\03CD\03BD \03C4\03B1 \03BA\03C1\03B9\03C4\03AE\03C1\03B9\03B1 \03C6\03AF\03BB\03C4\03C1\03BF\03C5. \0391\03BD \03B7 \03C3\03C4\03AE\03BB\03B7 \03B5\03AF\03BD\03B1\03B9 \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1, \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03BC\03B9\03B1 \03BB\03AF\03C3\03C4\03B1 \03C7\03C1\03BF\03BD\03B9\03BA\03CE\03BD \03C0\03B5\03C1\03B9\03CC\03B4\03C9\03BD. \0391\03BD \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \03BC\03B9\03B1 \03C4\03B9\03BC\03AE, \03B8\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03B7\03B8\03B5\03AF \03AD\03BD\03B1 \03C6\03AF\03BB\03C4\03C1\03BF \03BC\03B5 \03C7\03C1\03AE\03C3\03B7 \03C4\03BF\03C5 ''='' (\03C0.\03C7.')
||' <code>column = ''ABC''</code>).</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111303882249399283)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0395\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03AD\03BD\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD \03C3\03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC. \039C\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C0\03C1\03CC\03BA\03B5\03B9\03C4\03B1\03B9 \03B5\03AF\03C4\03B5 \03B3\03B9\03B1 \03BC\03B1\03B8\03B7\03BC\03B1\03C4\03B9\03BA\03BF\03CD\03C2 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD\03C2 (\03C0.\03C7 <code>NBR_HOURS/24</code>) \03B5\03AF\03C4\03B5 \03B3\03B9\03B1 \03C4\03C5\03C0\03B9\03BA\03AD\03C2 \03C3\03C5\03BD\03B1\03C1\03C4\03AE\03C3\03B5\03B9\03C2 \03C4\03B7\03C2 Oracle'),
unistr('\03C0\03BF\03C5 \03B5\03C6\03B1\03C1\03BC\03CC\03B6\03BF\03BD\03C4\03B1\03B9 \03C3\03C4\03B9\03C2 \03C5\03C0\03AC\03C1\03C7\03BF\03C5\03C3\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2. \039F\03C1\03B9\03C3\03BC\03AD\03BD\03B5\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03C9\03C2 \03C0\03B1\03C1\03B1\03B4\03B5\03AF\03B3\03BC\03B1\03C4\03B1 (\03C0.\03C7. <code>TO_DATE</code>) \03BA\03B1\03B9 \03AC\03BB\03BB\03B5\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03B5\03C0\03AF\03C3\03B7\03C2 \03BD\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03BF\03CD\03BD\03C4\03B1\03B9. \03A5\03C0\03AC\03C1\03C7\03BF\03C5\03BD \03BF\03B9 \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03B5\03C2 \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03C2:'),
'<p></p>',
'<ul>',
unistr('<li><strong>\03A5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC\03C2</strong>  - \03A3\03B1\03C2 \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \03AD\03BD\03B1\03BD \03AE\03B4\03B7 \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03BF \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC \03B3\03B9\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1.</li>'),
unistr('<li><strong>\0395\03C0\03B9\03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1 \03C3\03C4\03AE\03BB\03B7\03C2</strong> - \03A0\03C1\03CC\03BA\03B5\03B9\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03B7\03BD \03B5\03C0\03B9\03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1 \03C4\03B7\03C2 \03BD\03AD\03B1\03C2 \03C3\03C4\03AE\03BB\03B7\03C2.</li>'),
unistr('<li><strong>\039C\03AC\03C3\03BA\03B1 \03BC\03BF\03C1\03C6\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2</strong> - \03A0\03C1\03CC\03BA\03B5\03B9\03C4\03B1\03B9 \03B3\03B9\03B1 \03BC\03B9\03B1 \03BC\03AC\03C3\03BA\03B1 \03BC\03BF\03C1\03C6\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2 \03C4\03B7\03C2 Oracle \03C0\03BF\03C5 \03B8\03B1 \03B5\03C6\03B1\03C1\03BC\03BF\03C3\03C4\03B5\03AF \03C3\03C4\03B7 \03C3\03C4\03AE\03BB\03B7 (\03C0.\03C7. S9999).</li>'),
unistr('<li><strong>\03A5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC\03C2</strong> - \0395\03AF\03BD\03B1\03B9 \03BF \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC\03C2 \03C0\03BF\03C5 \03B8\03B1 \03B5\03BA\03C4\03B5\03BB\03B5\03C3\03C4\03B5\03AF. \03A3\03C4\03BF \03C0\03BB\03B1\03AF\03C3\03B9\03BF \03C4\03BF\03C5 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD, \03BF\03B9 \03C3\03C4\03AE\03BB\03B5\03C2 \03B1\03BD\03B1\03C6\03AD\03C1\03BF\03BD\03C4\03B1\03B9 \03BC\03B5 \03C4\03B1 \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03B1 \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03B1.</li>'),
'</ul>',
unistr('<p>\039A\03AC\03C4\03C9 \03B1\03C0\03CC \03C4\03BF\03BD \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC, \03BF\03B9 \03C3\03C4\03AE\03BB\03B5\03C2 \03C3\03C4\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03AC \03C3\03B1\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03BC\03B5 \03C4\03B1 \03C3\03C5\03C3\03C7\03B5\03C4\03B9\03C3\03BC\03AD\03BD\03B1 \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03AC \03C4\03BF\03C5\03C2. \039A\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03CC\03BD\03BF\03BC\03B1 \03AE \03C3\03C4\03BF \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03BF \03BC\03B9\03B1\03C2 \03C3\03C4\03AE\03BB\03B7\03C2, \03B7 \03C3\03C4\03AE\03BB\03B7 \03C3\03C5\03BC\03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03C4\03B1\03B9 \03C3\03C4\03BF\03BD \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC. \0394\03AF\03C0\03BB\03B1 \03C3\03C4\03B9\03C2 \03C3\03C4\03AE\03BB\03B5\03C2 \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03AD\03BD\03B1 \03C0\03BB\03B7\03BA\03C4\03C1\03BF\03BB\03CC\03B3\03B9\03BF. \0391\03C5\03C4\03CC \03C4\03BF ')
||unistr('\03C0\03BB\03B7\03BA\03C4\03C1\03BF\03BB\03CC\03B3\03B9\03BF \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03B5\03AF \03C9\03C2 \03C3\03C5\03BD\03C4\03CC\03BC\03B5\03C5\03C3\03B7 \03B3\03B9\03B1 \03C4\03B1 \03C0\03BB\03AE\03BA\03C4\03C1\03B1 \03C0\03BF\03C5 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03BF\03CD\03BD\03C4\03B1\03B9 \03C3\03C5\03C7\03BD\03CC\03C4\03B5\03C1\03B1. \03A3\03C4\03B7\03BD \03AC\03BA\03C1\03B7 \03B4\03B5\03BE\03B9\03AC \03B2\03C1\03AF\03C3\03BA\03BF\03BD\03C4\03B1\03B9 \03BF\03B9 \03A3\03C5\03BD\03B1\03C1\03C4\03AE\03C3\03B5\03B9\03C2.</p>'),
unistr('<p>\03A4\03BF \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03BF \03C0\03B1\03C1\03AC\03B4\03B5\03B9\03B3\03BC\03B1 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD \03B4\03B5\03AF\03C7\03BD\03B5\03B9 \03C4\03BF\03BD \03C4\03C1\03CC\03C0\03BF \03B3\03B9\03B1 \03C4\03B7\03BD \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03C4\03B7\03C2 \03C3\03C5\03BD\03BF\03BB\03B9\03BA\03AE\03C2 \03B1\03BC\03BF\03B9\03B2\03AE\03C2:</p>'),
'<pre>CASE WHEN A = ''SALES'' THEN B + C ELSE B END</pre>',
unistr('(\03CC\03C0\03BF\03C5 A \03B5\03AF\03BD\03B1\03B9 ORGANIZATION, B \03B5\03AF\03BD\03B1\03B9 SALARY \03BA\03B1\03B9 C \03B5\03AF\03BD\03B1\03B9 COMMISSION)</p>'),
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111310305776399287)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03BC\03B9\03B1\03C2 \03BF\03BC\03AC\03B4\03B1\03C2 \03C4\03BF\03BC\03AE\03C2 \03C3\03B5 \03BC\03AF\03B1 \03AE \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2. \0391\03C5\03C4\03CC \03AD\03C7\03B5\03B9 \03C9\03C2 \03B1\03C0\03BF\03C4\03AD\03BB\03B5\03C3\03BC\03B1 \03C4\03B7\03BD \03B5\03BE\03B1\03B3\03C9\03B3\03AE \03C4\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD \03B1\03C0\03CC \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03BA\03B1\03B9 \03C4\03B7\03BD \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03AE \03C4\03BF\03C5\03C2 \03C9\03C2 \03BA\03CD\03C1\03B9\03C9\03BD \03B5\03B3\03B3\03C1\03B1\03C6\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111304513568399283)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03C4\03C9\03BD \03BB\03B5\03C0\03C4\03BF\03BC\03B5\03C1\03B5\03B9\03CE\03BD \03BC\03B9\03B1\03C2 \03BC\03B5\03BC\03BF\03BD\03C9\03BC\03AD\03BD\03B7\03C2 \03C3\03B5\03B9\03C1\03AC\03C2, \03BA\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF \03C0\03C1\03BF\03B2\03BF\03BB\03AE\03C2 \03C3\03C4\03B7 \03C3\03B5\03B9\03C1\03AC \03C0\03BF\03C5 \03B8\03AD\03BB\03B5\03C4\03B5 \03BD\03B1 \03B4\03B5\03AF\03C4\03B5. \0391\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B7, \03B7 \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03BC\03B5\03BC\03BF\03BD\03C9\03BC\03AD\03BD\03B7\03C2 \03C3\03B5\03B9\03C1\03AC\03C2 \03B8\03B1 \03B5\03AF\03BD\03B1\03B9 \03C0\03AC\03BD\03C4\03B1 \03B7 \03C0\03C1\03CE\03C4\03B7 \03C3\03C4\03AE\03BB\03B7. \0391\03BD\03AC\03BB\03BF\03B3\03B1 \03BC\03B5 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE \03C4\03B7\03C2 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE\03C2 \03B1\03BD\03B1\03C6\03BF')
||unistr('\03C1\03AC\03C2, \03B7 \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03BC\03B5\03BC\03BF\03BD\03C9\03BC\03AD\03BD\03B7\03C2 \03C3\03B5\03B9\03C1\03AC\03C2 \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03B5\03AF\03C4\03B5 \03B7 \03C4\03C5\03C0\03B9\03BA\03AE \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03B5\03AF\03C4\03B5 \03BC\03B9\03B1 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03C3\03BC\03AD\03BD\03B7 \03C3\03B5\03BB\03AF\03B4\03B1 \03C0\03BF\03C5 \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03B5\03BD\03B7\03BC\03B5\03C1\03CE\03C3\03B5\03B9\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111304488395399283)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03C4\03B7 \03BB\03AE\03C8\03B7 \03C4\03BF\03C5 \03C4\03C1\03AD\03C7\03BF\03BD\03C4\03BF\03C2 \03C3\03C5\03BD\03CC\03BB\03BF\03C5 \03B1\03C0\03BF\03C4\03B5\03BB\03B5\03C3\03BC\03AC\03C4\03C9\03BD. \0397 \03BC\03BF\03C1\03C6\03AE \03BB\03AE\03C8\03B7\03C2 \03B5\03BE\03B1\03C1\03C4\03AC\03C4\03B1\03B9 \03B1\03C0\03CC \03C4\03B7\03BD \03B5\03B3\03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7 \03C3\03C4\03BF \03C0\03B5\03C1\03B9\03B2\03AC\03BB\03BB\03BF\03BD \03C3\03B1\03C2 \03BA\03B1\03B9 \03B1\03C0\03CC \03C4\03BF\03BD \03BF\03C1\03B9\03C3\03BC\03CC \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2, \03B1\03BB\03BB\03AC \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 CSV, HTML, Email, XLS, PDF \03AE RTF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111303581495399282)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0395\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03C4\03B7\03BD \03B5\03C3\03C4\03AF\03B1\03C3\03B7 \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BC\03B5 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03AE \03C4\03B7\03BD \03C4\03C1\03BF\03C0\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03C4\03B7\03C2 \03C3\03C5\03BD\03B8\03AE\03BA\03B7\03C2 <code>WHERE</code> \03C3\03C4\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03B1. \039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03C6\03B9\03BB\03C4\03C1\03AC\03C1\03B5\03C4\03B5 \03BC\03B5 \03B2\03AC\03C3\03B7 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 \03AE \03BC\03B9\03B1 \03C3\03B5\03B9\03C1\03AC.  '),
unistr('<p>\0391\03BD \03C6\03B9\03BB\03C4\03C1\03AC\03C1\03B5\03C4\03B5 \03B2\03AC\03C3\03B5\03B9 \03C3\03C4\03AE\03BB\03B7\03C2, \03B5\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 (\03B4\03B5\03BD \03C7\03C1\03B5\03B9\03AC\03B6\03B5\03C4\03B1\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03BC\03AF\03B1 \03B1\03C0\03CC \03B1\03C5\03C4\03AD\03C2 \03C0\03BF\03C5 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9), \03B5\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03AD\03BD\03B1\03BD \03C4\03C5\03C0\03B9\03BA\03CC \03C4\03B5\03BB\03B5\03C3\03C4\03AE \03C4\03B7\03C2 Oracle (=, !=, \03B4\03B5\03BD \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03C4\03B1\03B9 \03C3\03B5, \03BC\03B5\03C4\03B1\03BE\03CD) \03BA\03B1\03B9 \03BA\03B1\03C4\03B1\03C7\03C9\03C1\03AF\03C3\03C4\03B5 \03BC\03B9\03B1 \03AD\03BA\03C6\03C1\03B1\03C3\03B7 \03B3\03B9\03B1 \03C3\03CD\03B3\03BA\03C1\03B9\03C3\03B7. \03A3\03C4\03B9\03C2 \03B5\03BA\03C6\03C1\03AC\03C3\03B5\03B9\03C2 \03B5\03C6\03B1\03C1\03BC\03CC')
||unistr('\03B6\03B5\03C4\03B1\03B9 \03B4\03B9\03AC\03BA\03C1\03B9\03C3\03B7 \03C0\03B5\03B6\03CE\03BD/\03BA\03B5\03C6\03B1\03BB\03B1\03AF\03C9\03BD. \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03BF \03C3\03CD\03BC\03B2\03BF\03BB\03BF % \03C9\03C2 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B1 \03BC\03C0\03B1\03BB\03B1\03BD\03C4\03AD\03C1 (\03C0.\03C7. <code>STATE_NAME'),
'like A%)</code>.</p>',
unistr('<p>\0391\03BD \03C6\03B9\03BB\03C4\03C1\03AC\03C1\03B5\03C4\03B5 \03B2\03AC\03C3\03B5\03B9 \03C3\03B5\03B9\03C1\03AC\03C2, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03C3\03CD\03BD\03B8\03B5\03C4\03B5\03C2 \03C3\03C5\03BD\03B8\03AE\03BA\03B5\03C2 <code>WHERE</code> \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03CE\03BD\03C4\03B1\03C2 \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03B1 \03C3\03C4\03B7\03BB\03CE\03BD \03BA\03B1\03B9 \03BF\03C0\03BF\03B9\03B1\03B4\03AE\03C0\03BF\03C4\03B5 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 \03AE \03BF\03C0\03BF\03B9\03BF\03BD\03B4\03AE\03C0\03BF\03C4\03B5 \03C4\03B5\03BB\03B5\03C3\03C4\03AE \03C4\03B7\03C2 Oracle (\03C0.\03C7. <code>G = ''VA'' \03AE G = ''CT''</code>, \03CC\03C0\03BF\03C5 <code>G</code> \03B5\03AF\03BD')
||unistr('\03B1\03B9 \03C4\03BF \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03BF \03B3\03B9\03B1 \03C4\03B7 \03C3\03C4\03AE\03BB\03B7 <code>CUSTOMER_STATE</code>).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111304108580399283)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BD\03B1 \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03B1\03BD\03B1\03B4\03C1\03BF\03BC\03AE\03C2 \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03C4\03B7\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03C4\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03CC\03C0\03C9\03C2 \03B5\03AF\03C7\03B1\03BD \03B4\03B9\03B1\03BC\03BF\03C1\03C6\03C9\03B8\03B5\03AF \03C3\03B5 \03AD\03BD\03B1 \03C3\03C5\03B3\03BA\03B5\03BA\03C1\03B9\03BC\03AD\03BD\03BF \03C7\03C1\03BF\03BD\03B9\03BA\03CC \03C3\03B7\03BC\03B5\03AF\03BF. \039F \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03BF\03C2 \03C7\03C1\03CC\03BD\03BF\03C2 \03B1\03BD\03B1\03B4\03C1\03BF\03BC\03AE\03C2 \03B5\03AF\03BD\03B1\03B9 3 \03CE\03C1\03B5\03C2 (180 \03BB\03B5\03C0\03C4\03AC), \03B1\03BB\03BB\03AC \03BF \03C0\03C1\03B1\03B3\03BC\03B1\03C4\03B9\03BA\03CC\03C2 \03C7\03C1\03CC\03BD\03BF\03C2 \03B8\03B1 \03B4\03B9\03B1\03C6\03AD\03C1\03B5\03B9 \03B1\03BD\03AC\03BB\03BF\03B3\03B1 \03BC\03B5 \03C4\03B7 \03B2\03AC\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111365317651399327)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A4\03BF \03BC\03B5\03BD\03BF\03CD \039C\03BF\03C1\03C6\03AE \03C3\03AC\03C2 \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03CC\03C3\03B5\03C4\03B5 \03C4\03B7\03BD \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2.'),
unistr('\03A4\03BF \03BC\03B5\03BD\03BF\03CD \039C\03BF\03C1\03C6\03AE \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03C4\03B1 \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03B1 \03C5\03C0\03BF\03BC\03B5\03BD\03BF\03CD:</p>'),
unistr('<ul><li>\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7</li>'),
unistr('<li>\03A4\03BF\03BC\03AE \03B5\03BB\03AD\03B3\03C7\03BF\03C5</li>'),
unistr('<li>\0395\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7</li>'),
unistr('<li>\03A5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC\03C2</li>'),
unistr('<li>\03A3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7</li>'),
unistr('<li>\0393\03C1\03AC\03C6\03B7\03BC\03B1</li>'),
unistr('<li>\039F\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7</li>'),
unistr('<li>\03A0\03AF\03BD\03B1\03BA\03B1\03C2 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111363523539399326)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2 \03B1\03BD\03AC \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC. \0391\03C6\03BF\03CD \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03B7\03BD \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B5\03BD\03B1\03BB\03BB\03AC\03C3\03C3\03B5\03C3\03C4\03B5 \03BC\03B5\03C4\03B1\03BE\03CD \03C4\03C9\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03CE\03BD \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2 \03BA\03B1\03B9 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03CE\03BD\03C4\03B1\03C2 \03C4\03B1 \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE\03C2 \03C3\03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2. \0393\03B9\03B1 \03BD\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3')
||unistr('\03B5\03C4\03B5 \03BC\03B9\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2, \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \03C4\03B1 \03B5\03BE\03AE\03C2: '),
'<p></p>',
'<ul>',
unistr('<li>\03A3\03C4\03AE\03BB\03B5\03C2 \03B3\03B9\03B1 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7</li>'),
unistr('<li>\03A3\03C4\03AE\03BB\03B5\03C2 \03B3\03B9\03B1 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7 \03BC\03B1\03B6\03AF \03BC\03B5 \03C4\03B7\03BD \03B5\03BA\03C4\03B5\03BB\03BF\03CD\03BC\03B5\03BD\03B7 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 (AVERAGE, SUM, COUNT \03BA.\03AC.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111303781711399283)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\03A3\03B1\03C2 \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03AD\03BD\03B1 \03C6\03AF\03BB\03C4\03C1\03BF. \039F\03B9 \03C3\03B5\03B9\03C1\03AD\03C2 \03C0\03BF\03C5 \03C0\03BB\03B7\03C1\03BF\03CD\03BD \03C4\03B1 \03BA\03C1\03B9\03C4\03AE\03C1\03B9\03B1 \03C6\03B9\03BB\03C4\03C1\03B1\03C1\03AF\03C3\03BC\03B1\03C4\03BF\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03B5\03C0\03B9\03C3\03B7\03BC\03B1\03C3\03BC\03AD\03BD\03B5\03C2 \03C3\03CD\03BC\03C6\03C9\03BD\03B1 \03BC\03B5 \03C4\03B1 \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03AC \03C0\03BF\03C5 \03C3\03C7\03B5\03C4\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03BC\03B5 \03C4\03BF \03C6\03AF\03BB\03C4\03C1\03BF. \03A5\03C0\03AC\03C1\03C7\03BF\03C5\03BD \03BF\03B9 \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03B5\03C2 \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03C2:</p>'),
'<ul>',
unistr('<li><strong>\038C\03BD\03BF\03BC\03B1</strong> - \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B1\03B9 \03BC\03CC\03BD\03BF \03B3\03B9\03B1 \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7.</li>'),
unistr('<li><strong>\0391\03BA\03BF\03BB\03BF\03C5\03B8\03AF\03B1</strong> - \03A0\03C1\03BF\03C3\03B4\03B9\03BF\03C1\03AF\03B6\03B5\03B9 \03C4\03B7\03BD \03B1\03BA\03BF\03BB\03BF\03C5\03B8\03AF\03B1 \03BC\03B5 \03C4\03B7\03BD \03BF\03C0\03BF\03AF\03B1 \03B1\03C0\03BF\03C4\03B9\03BC\03CE\03BD\03C4\03B1\03B9 \03BF\03B9 \03BA\03B1\03BD\03CC\03BD\03B5\03C2.</li>'),
unistr('<li><strong>\0388\03C7\03B5\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF</strong> - \0394\03B7\03BB\03CE\03BD\03B5\03B9 \03B1\03BD \03AD\03BD\03B1\03C2 \03BA\03B1\03BD\03CC\03BD\03B1\03C2 \03B5\03AF\03BD\03B1\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03BF\03C2 \03AE \03B1\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03BF\03C2.</li>'),
unistr('<li><strong>\03A4\03CD\03C0\03BF\03C2 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2</strong> - \03A0\03C1\03BF\03C3\03B4\03B9\03BF\03C1\03AF\03B6\03B5\03B9 \03B1\03BD \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03C0\03B9\03C3\03B7\03BC\03B1\03BD\03B8\03B5\03AF \03B7 \03C3\03B5\03B9\03C1\03AC \03AE \03C4\03BF \03BA\03B5\03BB\03AF. \0391\03BD \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03B7 \03B5\03C0\03B9\03BB\03BF\03B3\03AE \039A\03B5\03BB\03AF, \03B7 \03B1\03BD\03B1\03C6\03B5\03C1\03CC\03BC\03B5\03BD\03B7 \03C3\03C4\03AE\03BB\03B7 \03C3\03C4\03B7 \03C3\03C5\03BD\03B8\03AE\03BA\03B7 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2 \03B8\03B1 \03B5\03C0\03B9\03C3\03B7\03BC\03B1\03BD\03B8\03B5\03AF.</li>'),
unistr('<li><strong>\03A7\03C1\03CE\03BC\03B1 \03C6\03CC\03BD\03C4\03BF\03C5</strong> - \0395\03AF\03BD\03B1\03B9 \03C4\03BF \03BD\03AD\03BF \03C7\03C1\03CE\03BC\03B1 \03B3\03B9\03B1 \03C4\03BF \03C6\03CC\03BD\03C4\03BF \03C4\03B7\03C2 \03B5\03C0\03B9\03C3\03B7\03BC\03B1\03C3\03BC\03AD\03BD\03B7\03C2 \03C0\03B5\03C1\03B9\03BF\03C7\03AE\03C2.</li>'),
unistr('<li><strong>\03A7\03C1\03CE\03BC\03B1 \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5</strong> - \0395\03AF\03BD\03B1\03B9 \03C4\03BF \03BD\03AD\03BF \03C7\03C1\03CE\03BC\03B1 \03B3\03B9\03B1 \03C4\03BF \03BA\03B5\03AF\03BC\03B5\03BD\03BF \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03C3\03B7\03BC\03B1\03C3\03BC\03AD\03BD\03B7 \03C0\03B5\03C1\03B9\03BF\03C7\03AE.</li>'),
unistr('<li><strong>\03A3\03C5\03BD\03B8\03AE\03BA\03B7 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2</strong> - \039F\03C1\03AF\03B6\03B5\03B9 \03C4\03B7 \03C3\03C5\03BD\03B8\03AE\03BA\03B7 \03C6\03AF\03BB\03C4\03C1\03BF\03C5.</li>'),
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111241314864399237)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD \03B1\03BD\03AC \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC. \0391\03C6\03BF\03CD \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03BF\03BD \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B5\03BD\03B1\03BB\03BB\03AC\03C3\03C3\03B5\03C3\03C4\03B5 \03BC\03B5\03C4\03B1\03BE\03CD \03C4\03C9\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03CE\03BD \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD \03BA\03B1\03B9 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03CE\03BD\03C4\03B1\03C2 \03C4\03B1 \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03B1 \03C0\03C1\03BF')
||unistr('\03B2\03BF\03BB\03AE\03C2 \03C3\03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2. \0393\03B9\03B1 \03BD\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD, \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03C0\03B9\03BB\03AD\03BE\03B5\03C4\03B5 \03C4\03B1 \03B5\03BE\03AE\03C2: '),
'<p></p>',
'<ul>',
unistr('<li>\03A3\03C4\03AE\03BB\03B5\03C2 \03B3\03B9\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03AE \03C0\03C1\03BF\03B2\03BF\03BB\03AE</li>'),
unistr('<li>\03A3\03C4\03AE\03BB\03B5\03C2 \03B3\03B9\03B1 \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03C9\03C2 \03C3\03B5\03B9\03C1\03AD\03C2</li>'),
unistr('<li>\03A3\03C4\03AE\03BB\03B5\03C2 \03B3\03B9\03B1 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7 \03BC\03B1\03B6\03AF \03BC\03B5 \03C4\03B7\03BD \03B5\03BA\03C4\03B5\03BB\03BF\03CD\03BC\03B5\03BD\03B7 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 (AVERAGE, SUM, COUNT \03BA.\03AC.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111314801358399291)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\038C\03C4\03B1\03BD \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03CC\03B6\03B5\03C4\03B5 \03BC\03B9\03B1 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC, \03BF\03B9 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03BA\03AC\03C4\03C9 \03B1\03C0\03CC \03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03BA\03B1\03B9 \03C0\03AC\03BD\03C9 \03B1\03C0\03CC \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC. \0391\03C5\03C4\03AE \03B7 \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C3\03C5\03BC\03C0\03C4\03C5\03C7\03B8\03B5\03AF \03BA\03B1\03B9 \03BD\03B1 \03B1\03BD\03B1\03C0\03C4\03C5\03C7\03B8\03B5\03AF \03BC\03B5 \03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF \03C3\03C4\03B1 \03B1\03C1\03B9\03C3\03C4\03B5\03C1\03AC.'),
'<p>',
unistr('\0393\03B9\03B1 \03BA\03AC\03B8\03B5 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03BA\03AC\03BD\03B5\03C4\03B5 \03C4\03B1 \03B5\03BE\03AE\03C2:'),
'</p><ul>',
unistr('<li>\039D\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03C4\03B5\03AF\03C4\03B5 \03C4\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03CC\03BD\03BF\03BC\03AC \03C4\03B7\03C2.</li>'),
unistr('<li>\039D\03B1 \03B1\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5/\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5 \03C4\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03B1\03C0\03BF\03B5\03C0\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03B1\03C2 \03AE \03B5\03C0\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03B1\03C2 \03C4\03BF \03C0\03BB\03B1\03AF\03C3\03B9\03BF \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \0395\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7/\0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7. \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03C9\03C1\03B9\03BD\03AE \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BA\03B1\03B9 \03B1\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BC\03B9\03B1\03C2 \03C1\03CD\03B8\03BC\03B9\03C3\03B7\03C2.</li>'),
unistr('<li>\039D\03B1 \03BA\03B1\03C4\03B1\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03C4\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF \039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7.</li>'),
'</ul>',
unistr('<p>\0391\03BD \03AD\03C7\03B5\03C4\03B5 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3\03B5\03B9 \03AD\03BD\03B1 \03B3\03C1\03AC\03C6\03B7\03BC\03B1, \03BC\03B9\03B1 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03AE \03AD\03BD\03B1\03BD \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B5\03BD\03B1\03BB\03BB\03AC\03C3\03C3\03B5\03C3\03C4\03B5 \03B1\03BD\03AC\03BC\03B5\03C3\03B1 \03C3\03B5 \03B1\03C5\03C4\03AD\03C2 \03C4\03B9\03C2 \03C0\03C1\03BF\03B2\03BF\03BB\03AD\03C2 \03BA\03B1\03B9 \03C4\03B7 \03B2\03B1\03C3\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03CE\03BD\03C4\03B1\03C2 \03C4\03BF\03C5\03C2 \03B4\03B5\03C3\03BC\03BF\03CD\03C2 \03A0\03C1\03BF\03B2\03BF\03BB\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2, \03A0\03C1\03BF\03B2\03BF\03BB\03AE \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2, \03A0\03C1\03BF\03B2\03BF\03BB\03AE \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF')
||unistr('\03B7\03C3\03B7\03C2 \03BA\03B1\03B9 \03A0\03C1\03BF\03B2\03BF\03BB\03AE \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD. \038C\03C4\03B1\03BD \03B2\03BB\03AD\03C0\03B5\03C4\03B5 \03C4\03BF \03B3\03C1\03AC\03C6\03B7\03BC\03B1, \03C4\03B7\03BD \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03AE \03C4\03BF\03BD \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03B5\03C0\03AF\03C3\03B7\03C2 \03BD\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5 \03C4\03BF\03BD \03B4\03B5\03C3\03BC\03CC \0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03B3\03B9\03B1 \03BD\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03C4\03B5\03AF\03C4\03B5 \03C4\03B9\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111304346012399283)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03AD\03C1\03B5\03B9 \03C4\03B9\03C2 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B5\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03C3\03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC, \03BA\03B1\03C4\03B1\03C1\03B3\03CE\03BD\03C4\03B1\03C2 \03BF\03C0\03BF\03B9\03B5\03C3\03B4\03AE\03C0\03BF\03C4\03B5 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AD\03C2 \03AD\03C7\03B5\03C4\03B5 \03BA\03AC\03BD\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111365648699399328)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03C1\03AF\03B6\03B5\03B9 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03B5\03B3\03B3\03C1\03B1\03C6\03CE\03BD \03B1\03BD\03AC \03C3\03B5\03BB\03AF\03B4\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111304215886399283)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0391\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03B5\03B9 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03C3\03BC\03AD\03BD\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B3\03B9\03B1 \03BC\03B5\03BB\03BB\03BF\03BD\03C4\03B9\03BA\03AE \03C7\03C1\03AE\03C3\03B7. \03A0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03AD\03BD\03B1 \03CC\03BD\03BF\03BC\03B1 \03BA\03B1\03B9, \03C0\03C1\03BF\03B1\03B9\03C1\03B5\03C4\03B9\03BA\03AC, \03BC\03B9\03B1 \03C0\03B5\03C1\03B9\03B3\03C1\03B1\03C6\03AE, \03B5\03BD\03CE \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C9\03C2 \03B4\03B7\03BC\03CC\03C3\03B9\03B1 (\03B4\03B7\03BB\03B1\03B4\03AE \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B7 \03C3\03B5 \03CC\03BB\03BF\03C5\03C2 \03C4\03BF\03C5\03C2 \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03C0\03BF\03C5 \03AD\03C7\03BF\03C5\03BD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03C3\03C4\03B7\03BD \03BA\03CD\03C1\03B9\03B1 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC')
||unistr('\03AD\03BD\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC). \039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C3\03B5\03C4\03B5 \03C4\03AD\03C3\03C3\03B5\03C1\03B9\03C2 \03C4\03CD\03C0\03BF\03C5\03C2 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03CE\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03CE\03BD:</p>'),
'<ul>',
unistr('<li><strong>\039A\03CD\03C1\03B9\03B1 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7</strong> (\039C\03CC\03BD\03BF \03C0\03C1\03BF\03B3\03C1\03B1\03BC\03BC\03B1\03C4\03B9\03C3\03C4\03AD\03C2). \03A0\03C1\03CC\03BA\03B5\03B9\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03BF\03BD \03C4\03CD\03C0\03BF \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C0\03BF\03C5 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03B1\03C1\03C7\03B9\03BA\03AC. \0397 \03BC\03B5\03C4\03BF\03BD\03BF\03BC\03B1\03C3\03AF\03B1 \03AE \03B7 \03B4\03B9\03B1\03B3\03C1\03B1\03C6\03AE \03C4\03C9\03BD \03BA\03CD\03C1\03B9\03C9\03BD \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03C9\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03CE\03BD \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE.</li>'),
unistr('<li><strong>\0395\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC</strong> (\039C\03CC\03BD\03BF \03C0\03C1\03BF\03B3\03C1\03B1\03BC\03BC\03B1\03C4\03B9\03C3\03C4\03AD\03C2). \03A0\03B1\03C1\03AD\03C7\03B5\03B9 \03C3\03C4\03BF\03C5\03C2 \03C0\03C1\03BF\03B3\03C1\03B1\03BC\03BC\03B1\03C4\03B9\03C3\03C4\03AD\03C2 \03C4\03B7 \03B4\03C5\03BD\03B1\03C4\03CC\03C4\03B7\03C4\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03CE\03BD \03B4\03B9\03B1\03C4\03AC\03BE\03B5\03C9\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2. \039C\03CC\03BD\03BF \03BF\03B9 \03C0\03C1\03BF\03B3\03C1\03B1\03BC\03BC\03B1\03C4\03B9\03C3\03C4\03AD\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03BF\03C5\03BD, \03BD\03B1 \03BC\03B5\03C4\03BF\03BD\03BF\03BC\03AC\03B6\03BF\03C5\03BD \03AE \03BD\03B1 \03B4\03B9\03B1\03B3\03C1\03AC\03C6\03BF\03C5\03BD \03B5\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AD\03C2 \03B1\03BD\03B1\03C6\03BF\03C1')
||unistr('\03AD\03C2.</li>'),
unistr('<li><strong>\0394\03B7\03BC\03CC\03C3\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC</strong> (\03A4\03B5\03BB\03B9\03BA\03BF\03AF \03C7\03C1\03AE\03C3\03C4\03B5\03C2). \039C\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03C4\03B5\03AF, \03BD\03B1 \03BC\03B5\03C4\03BF\03BD\03BF\03BC\03B1\03C3\03C4\03B5\03AF \03AE \03BD\03B1 \03B4\03B9\03B1\03B3\03C1\03B1\03C6\03B5\03AF \03BC\03CC\03BD\03BF \03B1\03C0\03CC \03C4\03BF\03BD \03C7\03C1\03AE\03C3\03C4\03B7 \03C0\03BF\03C5 \03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03CD\03C1\03B3\03B7\03C3\03B5. \039F\03B9 \03AC\03BB\03BB\03BF\03B9 \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03B2\03BB\03AD\03C0\03BF\03C5\03BD \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03BA\03B1\03B9 \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03BF\03C5\03BD \03C4\03B7 \03B4\03B9\03AC\03C4\03B1\03BE\03B7 \03C9\03C2 \03AC\03BB\03BB\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC.</li>'),
unistr('<li><strong>\0399\03B4\03B9\03C9\03C4\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC</strong> (\03A4\03B5\03BB\03B9\03BA\03BF\03AF \03C7\03C1\03AE\03C3\03C4\03B5\03C2). \0397 \03C0\03C1\03BF\03B2\03BF\03BB\03AE, \03B7 \03B1\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7, \03B7 \03BC\03B5\03C4\03BF\03BD\03BF\03BC\03B1\03C3\03AF\03B1 \03BA\03B1\03B9 \03B7 \03B4\03B9\03B1\03B3\03C1\03B1\03C6\03AE \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03BC\03CC\03BD\03BF \03B1\03C0\03CC \03C4\03BF\03BD \03C4\03B5\03BB\03B9\03BA\03CC \03C7\03C1\03AE\03C3\03C4\03B7 \03C0\03BF\03C5 \03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03CD\03C1\03B3\03B7\03C3\03B5.</li>'),
'</ul>',
unistr('<p>\038C\03C4\03B1\03BD \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03B5\03C4\03B5 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03C3\03BC\03AD\03BD\03B5\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AD\03C2, \03BF \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03B1\03C2 \0391\03BD\03B1\03C6\03BF\03C1\03AD\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03C3\03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03B1\03C1\03B9\03C3\03C4\03B5\03C1\03AC \03B1\03C0\03CC \03C4\03BF\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03B1 \03A3\03B5\03B9\03C1\03AD\03C2 (\03B5\03C6\03CC\03C3\03BF\03BD \03B1\03C5\03C4\03AE \03B7 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 \03B5\03AF\03BD\03B1\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03B7).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111303255494399282)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03BF \03C0\03AC\03BD\03C9 \03BC\03AD\03C1\03BF\03C2 \03BA\03AC\03B8\03B5 \03C3\03B5\03BB\03AF\03B4\03B1\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03BC\03B9\03B1 \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2. \0391\03C5\03C4\03AE \03B7 \03C0\03B5\03C1\03B9\03BF\03C7\03AE (\03AE \03B3\03C1\03B1\03BC\03BC\03AE \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2) \03C0\03B1\03C1\03AD\03C7\03B5\03B9 \03C4\03B9\03C2 \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03B5\03C2 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111366209855399328)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'el'
,p_message_text=>unistr('<li>\03A4\03BF \03BC\03B5\03BD\03BF\03CD <strong>\0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2</strong> \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE \03C4\03C9\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03CE\03BD. \0391\03BD\03B1\03C4\03C1\03AD\03BE\03C4\03B5 \03C3\03C4\03B9\03C2 \03B5\03BD\03CC\03C4\03B7\03C4\03B5\03C2 \03C0\03BF\03C5 \03B1\03BA\03BF\03BB\03BF\03C5\03B8\03BF\03CD\03BD.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111365714075399328)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'el'
,p_message_text=>unistr('<li><strong>\0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03C4\03B7\03BB\03CE\03BD</strong> - \0395\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03C4\03BF\03BD \03C0\03C1\03BF\03C3\03B4\03B9\03BF\03C1\03B9\03C3\03BC\03CC \03C4\03B7\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03B3\03B9\03B1 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7 (\03AE \03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03CC\03BB\03C9\03BD \03C4\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD).</li>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111366092766399328)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'el'
,p_message_text=>unistr('<li><strong>\0391\03BD\03B1\03C6\03BF\03C1\03AD\03C2</strong> - \0395\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03BF\03B9 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B5\03C2, \03BF\03B9 \03B5\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AD\03C2 \03BA\03B1\03B9 \03BF\03B9 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B5\03C2 \03B9\03B4\03B9\03C9\03C4\03B9\03BA\03AD\03C2 \03BA\03B1\03B9 \03B4\03B7\03BC\03CC\03C3\03B9\03B5\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AD\03C2.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111365958128399328)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'el'
,p_message_text=>unistr('<li><strong>\03A3\03B5\03B9\03C1\03AD\03C2</strong> - \039F\03C1\03AF\03B6\03B5\03B9 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03B5\03B3\03B3\03C1\03B1\03C6\03CE\03BD \03B1\03BD\03AC \03C3\03B5\03BB\03AF\03B4\03B1.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111365816723399328)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li><strong>\03A0\03B5\03C1\03B9\03BF\03C7\03AE \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5</strong> - \0395\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03C4\03B7\03BD \03B5\03B9\03C3\03B1\03B3\03C9\03B3\03AE \03BA\03C1\03B9\03C4\03B7\03C1\03AF\03C9\03BD \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03C7\03C9\03C1\03AF\03C2 \03B4\03B9\03AC\03BA\03C1\03B9\03C3\03B7 \03C0\03B5\03B6\03CE\03BD/\03BA\03B5\03C6\03B1\03BB\03B1\03AF\03C9\03BD (\03BF\03B9 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2 \03BC\03C0\03B1\03BB\03B1\03BD\03C4\03AD\03C1 \03C5\03C0\03BF\03BD\03BF\03BF\03CD\03BD\03C4\03B1\03B9).</li>'),
unistr('<li><strong>\039A\03BF\03C5\03BC\03C0\03AF \03BC\03B5\03C4\03AC\03B2\03B1\03C3\03B7\03C2</strong> - \0395\03BA\03C4\03B5\03BB\03B5\03AF \03C4\03B7\03BD \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7. \038C\03C4\03B1\03BD \03BF \03B4\03C1\03BF\03BC\03AD\03B1\03C2 \03B2\03C1\03AF\03C3\03BA\03B5\03C4\03B1\03B9 \03C3\03C4\03B7\03BD \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2, \03B7 \03B5\03BA\03C4\03AD\03BB\03B5\03C3\03B7 \03C4\03B7\03C2 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03BE\03B5\03BA\03B9\03BD\03AE\03C3\03B5\03B9 \03BA\03B1\03B9 \03BC\03B5 \03C4\03BF \03C0\03AC\03C4\03B7\03BC\03B1 \03C4\03BF\03C5 \03C0\03BB\03AE\03BA\03C4\03C1\03BF\03C5 Enter.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111366199805399328)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('<li><strong>\0395\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE\03C2</strong> - \0395\03C0\03B9\03C4\03C1\03AD\03C0\03BF\03C5\03BD \03C4\03B7\03BD \03B5\03BD\03B1\03BB\03BB\03B1\03B3\03AE \03BC\03B5\03C4\03B1\03BE\03CD \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BA\03B1\03B9 \03C4\03C9\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03CE\03BD \03BB\03B5\03C0\03C4\03BF\03BC\03B5\03C1\03B5\03B9\03CE\03BD, \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2, \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2 \03BA\03B1\03B9 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03BF\03CD \03C0\03AF\03BD\03B1\03BA\03B1 \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2, \03B1\03BD \03AD\03C7\03BF\03C5\03BD \03BF\03C1\03B9\03C3\03C4\03B5\03AF.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111382167907399340)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'el'
,p_message_text=>unistr('<li>\03A4\03BF \03BC\03B5\03BD\03BF\03CD <strong>\0394\03B9\03B1\03C7\03B5\03AF\03C1\03B9\03C3\03B7</strong> \03C3\03B1\03C2 \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03AF\03B6\03B5\03C3\03C4\03B5 \03C4\03B9\03C2 \03B9\03B4\03B9\03CC\03C4\03B7\03C4\03B5\03C2, \03C4\03B9\03C2 \03C3\03C4\03AE\03BB\03B5\03C2, \03C4\03B9\03C2 \03C3\03B5\03B9\03C1\03AD\03C2 \03BA\03B1\03B9 \03C4\03BF \03B9\03C3\03C4\03BF\03C1\03B9\03BA\03CC \03C0\03C1\03BF\03B2\03BF\03BB\03AE\03C2 \03B3\03B9\03B1 \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03AE \03C4\03BF \03C0\03BB\03AD\03B3\03BC\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111303470799399282)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03B7\03BD \03C4\03C1\03BF\03C0\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03C4\03C9\03BD \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD. \039F\03B9 \03C3\03C4\03AE\03BB\03B5\03C2 \03C3\03C4\03B1 \03B4\03B5\03BE\03B9\03AC \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9. \039F\03B9 \03C3\03C4\03AE\03BB\03B5\03C2 \03C3\03C4\03B1 \03B1\03C1\03B9\03C3\03C4\03B5\03C1\03AC \03B5\03AF\03BD\03B1\03B9 \03BA\03C1\03C5\03C6\03AD\03C2. \039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B1\03BB\03BB\03AC\03BE\03B5\03C4\03B5 \03C4\03B7 \03C3\03B5\03B9\03C1\03AC \03C4\03C9\03BD \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03CE\03BD\03C4\03B1\03C2 \03C4\03B1 \03B2\03AD\03BB\03B7 \03C3\03C4\03B7\03BD \03AC\03BA\03C1\03B7 \03B4\03B5\03BE\03B9\03AC. \039F\03B9 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03AD\03BD\03B5\03C2 \03C3\03C4\03AE\03BB')
||unistr('\03B5\03C2 \03C6\03AD\03C1\03BF\03C5\03BD \03C4\03BF \03C0\03C1\03CC\03B8\03B7\03BC\03B1 <strong>**</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111303674856399282)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'el'
,p_message_text=>unistr('<p>\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03B7\03BD \03B1\03BB\03BB\03B1\03B3\03AE \03C4\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2 \03BA\03B1\03B9 \03C4\03BF\03BD \03C0\03C1\03BF\03C3\03B4\03B9\03BF\03C1\03B9\03C3\03BC\03CC \03C4\03B7\03C2 \03C3\03B5\03B9\03C1\03AC\03C2 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2 (\03B1\03CD\03BE\03BF\03C5\03C3\03B1 \03AE \03C6\03B8\03AF\03BD\03BF\03C5\03C3\03B1). \039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03B5\03C0\03AF\03C3\03B7\03C2 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03C4\03BF\03BD \03C4\03C1\03CC\03C0\03BF \03BC\03B5 \03C4\03BF\03BD \03BF\03C0\03BF\03AF\03BF \03B8\03B1 \03B3\03AF\03BD\03B5\03C4\03B1\03B9 \03BF \03C7\03B5\03B9\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03C9\03BD <code>NULLs</code>. \03A3\03CD\03BC\03C6\03C9\03BD\03B1 \03BC\03B5 \03C4\03B7\03BD \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7 \03C1')
||unistr('\03CD\03B8\03BC\03B9\03C3\03B7, \03C4\03B1 <code>NULLs</code> \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03C0\03AC\03BD\03C4\03B1 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 \03AE \03C0\03C1\03CE\03C4\03B1. \0397 \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C0\03BF\03C5  \03C0\03C1\03BF\03BA\03CD\03C0\03C4\03B5\03B9 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03B4\03B5\03BE\03B9\03AC \03B1\03C0\03CC \03C4\03B9\03C2 \03B5\03C0\03B9\03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B5\03C2 \03C3\03C4\03B7\03BB\03CE\03BD \03C3\03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111363328831399326)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03C4\03B1\03BD \03C0\03C1\03BF\03C3\03B8\03AD\03C4\03B5\03C4\03B5 \03BC\03B9\03B1 \03C3\03C5\03BD\03B4\03C1\03BF\03BC\03AE, \03C0\03B1\03C1\03AD\03C7\03B5\03C4\03B5 \03BC\03B9\03B1 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5 (\03AE \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03AD\03C2 \03B4\03B9\03B5\03C5\03B8\03CD\03BD\03C3\03B5\03B9\03C2 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5 \03B4\03B9\03B1\03C7\03C9\03C1\03B9\03C3\03BC\03AD\03BD\03B5\03C2 \03BC\03B5 \03BA\03CC\03BC\03BC\03B1), \03AD\03BD\03B1 \03B8\03AD\03BC\03B1 \03BC\03B7\03BD\03CD\03BC\03B1\03C4\03BF\03C2 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5, \03BC\03B9\03B1 \03C3\03C5\03C7\03BD\03CC\03C4\03B7\03C4\03B1 \03BA\03B1\03B9 \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B5\03C2 \03AD\03BD\03B1\03C1\03BE\03B7\03C2 \03BA\03B1\03B9 \03BB\03AE\03BE\03B7\03C2. ')
||unistr('\03A4\03B1 \03B1\03C0\03BF\03C3\03C4\03B5\03BB\03BB\03CC\03BC\03B5\03BD\03B1 \03BC\03B7\03BD\03CD\03BC\03B1\03C4\03B1 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5 \03B8\03B1 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03BF\03C5\03BD \03BC\03B9\03B1 \03AD\03BA\03B4\03BF\03C3\03B7 HTML \03C4\03B7\03C2 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BC\03B5 \03C4\03B1 \03C4\03C1\03AD\03C7\03BF\03BD\03C4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03BA\03B1\03B9 \03C4\03B9\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C0\03BF\03C5 \03AF\03C3\03C7\03C5\03B1\03BD \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C4\03B7\03C2 \03C3\03C5\03BD\03B4\03C1\03BF\03BC\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111381936962399339)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\03A4\03B1 \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03B5\03AF\03BD\03B1\03B9 \03B2\03B1\03C3\03B9\03BA\03AC \03B1\03BD\03B1\03C6\03BF\03C1\03AD\03C2 \03C0\03BF\03C5 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03C5\03C0\03BF\03B2\03BB\03B7\03B8\03BF\03CD\03BD \03C3\03B5 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03BA\03B1\03B9 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE. \039F\03B9 \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03C4\03C1\03BF\03C0\03BF\03C0\03BF\03B9\03BF\03CD\03BD \03C4\03B7 \03B4\03BF\03BC\03AE \03C4\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C4\03C9\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03CE\03BD, \03B5\03C0\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03B1\03C2 \03C3\03C4\03AE\03BB\03B5\03C2, \03B5\03C6\03B1\03C1\03BC\03CC\03B6\03BF\03BD\03C4\03B1\03C2 \03C6\03AF\03BB\03C4\03C1\03B1, \03B5\03C0\03B9\03C3\03B7\03BC\03B1\03AF\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03B1\03B9 \03C4\03B1\03BE\03B9\03BD\03BF\03BC\03CE\03BD\03C4\03B1\03C2 \03C4\03B9\03C2 \03C0\03BB')
||unistr('\03B7\03C1\03BF\03C6\03BF\03C1\03AF\03B5\03C2. \039C\03C0\03BF\03C1\03BF\03CD\03BD \03B5\03C0\03AF\03C3\03B7\03C2 \03BD\03B1 \03BF\03C1\03AF\03B6\03BF\03C5\03BD \03C4\03BF\03BC\03AD\03C2, \03C3\03C5\03BD\03B1\03B8\03C1\03BF\03AF\03C3\03B5\03B9\03C2, \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03B1 \03BA\03B1\03B9 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03B9\03C2 \03BA\03B1\03B8\03CE\03C2 \03BA\03B1\03B9 \03BD\03B1 \03C0\03C1\03BF\03C3\03B8\03AD\03C4\03BF\03C5\03BD \03C4\03BF\03C5\03C2 \03B4\03B9\03BA\03BF\03CD\03C2 \03C4\03BF\03C5\03C2 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD\03C2. \039F\03B9 \03C7\03C1\03AE\03C3\03C4\03B5\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03BF\03CD\03BD \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03AD\03C2 \03C0\03B1\03C1\03B1\03BB\03BB\03B1\03B3\03AD\03C2 \03BC\03B9\03B1\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BA\03B1\03B9 \03BD\03B1 \03C4\03B9\03C2 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03BF\03C5\03BD \03BC\03B5 \03BE\03B5\03C7\03C9\03C1\03B9\03C3\03C4\03CC \03CC\03BD\03BF\03BC')
||unistr('\03B1 \03B3\03B9\03B1 \03B9\03B4\03B9\03C9\03C4\03B9\03BA\03AE \03C0\03C1\03BF\03B2\03BF\03BB\03AE. '),
'<p/>',
unistr('\0397 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE \03B5\03BD\03CC\03C2 \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03B3\03AF\03BD\03B5\03B9 \03BC\03AD\03C3\03C9 \03C4\03B7\03C2 \03B3\03C1\03B1\03BC\03BC\03AE\03C2 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03AE \03C4\03C9\03BD \03BC\03B5\03BD\03BF\03CD \0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2, \0394\03B9\03B1\03C7\03B5\03AF\03C1\03B9\03C3\03B7 \03AE \0395\03C0\03B9\03BA\03B5\03C6\03B1\03BB\03AF\03B4\03B1 \03C3\03C4\03AE\03BB\03B7\03C2.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111393756070399348)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03BC\03B5\03BD\03BF\03CD \0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03B4\03B5\03BE\03B9\03AC \03B1\03C0\03CC \03C4\03BF \03BA\03BF\03C5\03BC\03C0\03AF \039C\03B5\03C4\03AC\03B2\03B1\03C3\03B7 \03C3\03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2. \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03BC\03B5\03BD\03BF\03CD \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE \03BC\03B9\03B1\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111382409654399340)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7/\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C3\03B5\03BB\03AF\03B4\03B1\03C2 \03C3\03B5\03B9\03C1\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111382502096399340)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0393\03B9\03B1 \03BD\03B1 \03C0\03C1\03BF\03C3\03B8\03AD\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C3\03B5\03B9\03C1\03AC \03C3\03C4\03BF \03C0\03BB\03AD\03B3\03BC\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD, \03BA\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C3\03B5\03B9\03C1\03AC\03C2. \0393\03B9\03B1 \03BD\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03C4\03B5\03AF\03C4\03B5 \03C4\03B9\03C2 \03BB\03B5\03C0\03C4\03BF\03BC\03AD\03C1\03B5\03B9\03B5\03C2 \03BC\03B9\03B1\03C2 \03C3\03B5\03B9\03C1\03AC\03C2, \03BA\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 \03C3\03B5\03B9\03C1\03AC\03C2 (\03C0\03C1\03CE\03C4\03B7 \03C3\03C4\03AE\03BB\03B7) \03C3\03C4\03B7 \03C3\03B5\03B9\03C1\03AC \03C0\03BF\03C5 \03B8\03AD\03BB\03B5\03C4\03B5 \03BD\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03C4\03B5\03AF\03C4\03B5. \0398\03B1 \03B1\03BD')
||unistr('\03BF\03AF\03BE\03B5\03B9 \03B7 \03C3\03B5\03BB\03AF\03B4\03B1 \03A0\03C1\03BF\03C3\03B8\03AE\03BA\03B7/\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C3\03B5\03B9\03C1\03AC\03C2 \03C3\03C4\03B7\03BD \03BF\03C0\03BF\03AF\03B1 \03B8\03B1 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03BF\03B9 \03C3\03C4\03AE\03BB\03B5\03C2 \03C4\03BF\03C5 \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD. </p>'),
'',
unistr('<p>\039A\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03BC\03B9\03B1\03C2 \03C3\03B5\03B9\03C1\03AC\03C2, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03BA\03AC\03BD\03B5\03C4\03B5 \03C4\03B1 \03B5\03BE\03AE\03C2:</p>'),
'',
'<p><ul>',
unistr('<li>\039D\03B1 <strong>\03B4\03B9\03B1\03B3\03C1\03AC\03C8\03B5\03C4\03B5</strong> \03C4\03B7 \03C3\03B5\03B9\03C1\03AC.</li>'),
unistr('<li>\039D\03B1 <strong>\03B5\03C6\03B1\03C1\03BC\03CC\03C3\03B5\03C4\03B5 \03C4\03B9\03C2 \03B1\03BB\03BB\03B1\03B3\03AD\03C2</strong> \03B3\03B9\03B1 \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C3\03B5\03C4\03B5 \03C4\03B9\03C2 \03B1\03BB\03BB\03B1\03B3\03AD\03C2 \03C0\03BF\03C5 \03AD\03C7\03BF\03C5\03BD \03B3\03AF\03BD\03B5\03B9 \03C3\03C4\03B7 \03C3\03B5\03B9\03C1\03AC.</li>'),
unistr('<li>\03A3\03C4\03B9\03C2 <strong>\0395\03BD\03AD\03C1\03B3\03B5\03B9\03B5\03C2</strong>, \03BD\03B1 \03C0\03C1\03BF\03C3\03B8\03AD\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C3\03B5\03B9\03C1\03AC, \03BD\03B1 \03C0\03C1\03BF\03C3\03B8\03AD\03C3\03B5\03C4\03B5 \03B1\03C1\03C7\03B5\03AF\03B1, \03C3\03B7\03BC\03B5\03B9\03CE\03C3\03B5\03B9\03C2, \03B4\03B5\03C3\03BC\03BF\03CD\03C2 \03AE \03B5\03C4\03B9\03BA\03AD\03C4\03B5\03C2, \03BA\03B1\03B9 \03BD\03B1 \03B5\03BE\03B5\03C4\03AC\03C3\03B5\03C4\03B5 \03C4\03BF \03B9\03C3\03C4\03BF\03C1\03B9\03BA\03CC.</li>'),
unistr('<li>\039D\03B1 \03BC\03B5\03C4\03B1\03B2\03B5\03AF\03C4\03B5 \03C3\03B5 <strong>\03C0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03B5\03C2 \03AE \03B5\03C0\03CC\03BC\03B5\03BD\03B5\03C2</strong> \03C3\03B5\03B9\03C1\03AD\03C2.</li>'),
unistr('<li>\03A3\03C4\03B7 <strong>\0394\03B9\03B1\03C7\03B5\03AF\03C1\03B9\03C3\03B7</strong>, \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03B9\03B4\03B9\03CC\03C4\03B7\03C4\03B5\03C2 \03C3\03C4\03B7\03BB\03CE\03BD, \03BF\03BC\03AC\03B4\03B5\03C2 \03C3\03C4\03B7\03BB\03CE\03BD, \03B5\03C0\03B9\03BA\03C5\03C1\03CE\03C3\03B5\03B9\03C2 \03BA\03B1\03B9 \03BB\03AF\03C3\03C4\03B5\03C2 \03C4\03B9\03BC\03CE\03BD.</li>'),
'</ul></p>',
'',
unistr('<p>\0397 \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03A3\03B7\03BC\03B5\03B9\03CE\03C3\03B5\03B9\03C2 \03C3\03C4\03BF \03BA\03AC\03C4\03C9 \03BC\03AD\03C1\03BF\03C2 \03C4\03B7\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2 \03B8\03B1 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03B9 \03C4\03B1 \03B1\03C1\03C7\03B5\03AF\03B1, \03C4\03B9\03C2 \03C3\03B7\03BC\03B5\03B9\03CE\03C3\03B5\03B9\03C2, \03C4\03BF\03C5\03C2 \03B4\03B5\03C3\03BC\03BF\03CD\03C2 \03BA\03B1\03B9 \03C4\03B9\03C2 \03B5\03C4\03B9\03BA\03AD\03C4\03B5\03C2 \03C0\03BF\03C5 \03AD\03C7\03BF\03C5\03BD \03C3\03C5\03C3\03C7\03B5\03C4\03B9\03C3\03C4\03B5\03AF \03BC\03B5 \03C4\03B7\03BD \03C4\03C1\03AD\03C7\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111393846696399348)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03BC\03B9\03B1\03C2 \03BF\03BC\03AC\03B4\03B1\03C2 \03C4\03BF\03BC\03AE\03C2 \03C3\03B5 \03BC\03AF\03B1 \03AE \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2. \0391\03C5\03C4\03CC \03AD\03C7\03B5\03B9 \03C9\03C2 \03B1\03C0\03BF\03C4\03AD\03BB\03B5\03C3\03BC\03B1 \03C4\03B7\03BD \03B5\03BE\03B1\03B3\03C9\03B3\03AE \03C4\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD \03B1\03C0\03CC \03C4\03BF \03C0\03BB\03AD\03B3\03BC\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03BA\03B1\03B9 \03C4\03B7\03BD \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03AE \03C4\03BF\03C5\03C2 \03C9\03C2 \03BA\03CD\03C1\03B9\03C9\03BD \03B5\03B3\03B3\03C1\03B1\03C6\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111382309502399340)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03C4\03B7 \03BB\03AE\03C8\03B7 \03C4\03BF\03C5 \03C4\03C1\03AD\03C7\03BF\03BD\03C4\03BF\03C2 \03C3\03C5\03BD\03CC\03BB\03BF\03C5 \03B1\03C0\03BF\03C4\03B5\03BB\03B5\03C3\03BC\03AC\03C4\03C9\03BD. \0397 \03BC\03BF\03C1\03C6\03AE \03BB\03AE\03C8\03B7\03C2 \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 CSV, HTML \03AE Email.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111393900380399348)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\038C\03C4\03B1\03BD \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03CC\03B6\03B5\03C4\03B5 \03BC\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD, \03BF\03B9 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03BA\03AC\03C4\03C9 \03B1\03C0\03CC \03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03BA\03B1\03B9 \03C0\03AC\03BD\03C9 \03B1\03C0\03CC \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC. \0391\03C5\03C4\03AE \03B7 \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C3\03C5\03BC\03C0\03C4\03C5\03C7\03B8\03B5\03AF \03BA\03B1\03B9 \03BD\03B1 \03B1\03BD\03B1\03C0\03C4\03C5\03C7\03B8\03B5\03AF \03BC\03B5 \03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF \03C3\03C4\03B1 \03B1\03C1\03B9\03C3\03C4\03B5\03C1\03AC.'),
'<p>',
unistr('\0393\03B9\03B1 \03BA\03AC\03B8\03B5 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03BA\03AC\03BD\03B5\03C4\03B5 \03C4\03B1 \03B5\03BE\03AE\03C2:'),
'</p><ul>',
unistr('<li>\039D\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03C4\03B5\03AF\03C4\03B5 \03C4\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03CC\03BD\03BF\03BC\03AC \03C4\03B7\03C2.</li>'),
unistr('<li>\039D\03B1 \03B1\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5/\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5 \03C4\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03B1\03C0\03BF\03B5\03C0\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03B1\03C2 \03AE \03B5\03C0\03B9\03BB\03AD\03B3\03BF\03BD\03C4\03B1\03C2 \03C4\03BF \03C0\03BB\03B1\03AF\03C3\03B9\03BF \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \0395\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7/\0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7. \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03C9\03C1\03B9\03BD\03AE \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BA\03B1\03B9 \03B1\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BC\03B9\03B1\03C2 \03C1\03CD\03B8\03BC\03B9\03C3\03B7\03C2.</li>'),
unistr('<li>\039D\03B1 \03BA\03B1\03C4\03B1\03C1\03B3\03AE\03C3\03B5\03C4\03B5 \03C4\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03BA\03AC\03BD\03BF\03BD\03C4\03B1\03C2 \03BA\03BB\03B9\03BA \03C3\03C4\03BF \03B5\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF \039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7.</li>'),
'</ul>',
unistr('<p>\0391\03BD \03AD\03C7\03B5\03C4\03B5 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03C3\03B5\03B9 \03AD\03BD\03B1 \03B3\03C1\03AC\03C6\03B7\03BC\03B1, \03AE \03BC\03B9\03B1 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B5\03BD\03B1\03BB\03BB\03AC\03C3\03C3\03B5\03C3\03C4\03B5 \03B1\03BD\03AC\03BC\03B5\03C3\03B1 \03C3\03B5 \03B1\03C5\03C4\03AD\03C2 \03C4\03B9\03C2 \03C0\03C1\03BF\03B2\03BF\03BB\03AD\03C2 \03BA\03B1\03B9 \03C4\03B7 \03B2\03B1\03C3\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03CE\03BD\03C4\03B1\03C2 \03C4\03BF\03C5\03C2 \03B4\03B5\03C3\03BC\03BF\03CD\03C2 \03A0\03C1\03BF\03B2\03BF\03BB\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2, \03A0\03C1\03BF\03B2\03BF\03BB\03AE \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2 \03BA\03B1\03B9 \03A0\03C1\03BF\03B2\03BF\03BB\03AE \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2. \038C\03C4\03B1\03BD \03B2\03BB\03AD\03C0\03B5\03C4\03B5 \03C4\03BF \03B3\03C1\03AC\03C6\03B7\03BC\03B1 ')
||unistr('\03AE \03C4\03B7\03BD \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7, \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03B5\03C0\03AF\03C3\03B7\03C2 \03BD\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5 \03C4\03BF\03BD \03B4\03B5\03C3\03BC\03CC \0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03B3\03B9\03B1 \03BD\03B1 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03C4\03B5\03AF\03C4\03B5 \03C4\03B9\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111382283241399340)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0391\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03B5\03B9 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03C3\03BC\03AD\03BD\03B7 \03B4\03B9\03AC\03C4\03B1\03BE\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03B3\03B9\03B1 \03BC\03B5\03BB\03BB\03BF\03BD\03C4\03B9\03BA\03AE \03C7\03C1\03AE\03C3\03B7. \03A0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03AD\03BD\03B1 \03CC\03BD\03BF\03BC\03B1 \03BA\03B1\03B9, \03C0\03C1\03BF\03B1\03B9\03C1\03B5\03C4\03B9\03BA\03AC, \03BC\03B9\03B1 \03C0\03B5\03C1\03B9\03B3\03C1\03B1\03C6\03AE. \039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03C3\03B5\03C4\03B5 \03C4\03C1\03B5\03B9\03C2 \03C4\03CD\03C0\03BF\03C5\03C2 \03B4\03B9\03B1\03C4\03AC\03BE\03B5\03C9\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03CE\03BD \03C0\03BB\03AD\03B3\03BC\03B1\03C4\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD:</p>'),
'<ul>',
unistr('<li><strong>\039A\03CD\03C1\03B9\03B1 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7</strong> (\039C\03CC\03BD\03BF \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AD\03C2). \03A0\03C1\03CC\03BA\03B5\03B9\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03BF\03BD \03C4\03CD\03C0\03BF \03C4\03B7\03C2 \03B4\03B9\03AC\03C4\03B1\03BE\03B7\03C2 \03C0\03BF\03C5 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03B1\03C1\03C7\03B9\03BA\03AC. \0397 \03BC\03B5\03C4\03BF\03BD\03BF\03BC\03B1\03C3\03AF\03B1 \03AE \03B7 \03B4\03B9\03B1\03B3\03C1\03B1\03C6\03AE \03C4\03C9\03BD \03BA\03CD\03C1\03B9\03C9\03BD \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03C9\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03CE\03BD \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE.</li>'),
unistr('<li><strong>\0395\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC</strong> (\039C\03CC\03BD\03BF \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AD\03C2). \03A0\03B1\03C1\03AD\03C7\03B5\03B9 \03C3\03C4\03BF\03C5\03C2 \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AD\03C2 \03C4\03B7 \03B4\03C5\03BD\03B1\03C4\03CC\03C4\03B7\03C4\03B1 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03CE\03BD \03B4\03B9\03B1\03C4\03AC\03BE\03B5\03C9\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2. \039C\03CC\03BD\03BF \03BF\03B9 \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AD\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03BF\03C5\03BD, \03BD\03B1 \03BC\03B5\03C4\03BF\03BD\03BF\03BC\03AC\03B6\03BF\03C5\03BD \03AE \03BD\03B1 \03B4\03B9\03B1\03B3\03C1\03AC\03C6\03BF\03C5\03BD \03B5\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AD\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AD\03C2.</li>'),
unistr('<li><strong>\0399\03B4\03B9\03C9\03C4\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC</strong> (\038C\03BB\03BF\03B9 \03BF\03B9 \03C7\03C1\03AE\03C3\03C4\03B5\03C2). \0397 \03C0\03C1\03BF\03B2\03BF\03BB\03AE, \03B7 \03B1\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7, \03B7 \03BC\03B5\03C4\03BF\03BD\03BF\03BC\03B1\03C3\03AF\03B1 \03BA\03B1\03B9 \03B7 \03B4\03B9\03B1\03B3\03C1\03B1\03C6\03AE \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B1\03C0\03CC \03C4\03BF\03BD \03C7\03C1\03AE\03C3\03C4\03B7 \03C0\03BF\03C5 \03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03CD\03C1\03B3\03B7\03C3\03B5.</li>'),
'</ul>',
unistr('<p>\038C\03C4\03B1\03BD \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03CD\03B5\03C4\03B5 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03C3\03BC\03AD\03BD\03B5\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AD\03C2, \03BF \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03B1\03C2 \0391\03BD\03B1\03C6\03BF\03C1\03AD\03C2 \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03B5\03C4\03B1\03B9 \03C3\03C4\03B7 \03B3\03C1\03B1\03BC\03BC\03AE \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2 \03B1\03C1\03B9\03C3\03C4\03B5\03C1\03AC \03B1\03C0\03CC \03C4\03BF\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03B1 \03A3\03B5\03B9\03C1\03AD\03C2 (\03B5\03C6\03CC\03C3\03BF\03BD \03B1\03C5\03C4\03AE \03B7 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 \03B5\03AF\03BD\03B1\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03B7).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111308343662399286)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03CC\03BA\03C1\03C5\03C8\03B7 \03C3\03C4\03AE\03BB\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111298976332399279)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111309802354399287)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03C3\03B7\03BC\03AC\03BD\03C3\03B5\03B9\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111314934168399291)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03B8\03AE\03BA\03B7 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111363960445399326)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03C5\03BB \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111273943651399261)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03CD\03C0\03BF\03C2 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111383454387399341)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03C1\03B9\03B6\03CC\03BD\03C4\03B9\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111413006666399362)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'el'
,p_message_text=>unistr('1 \03B1\03BD\03B5\03BD\03B5\03C1\03B3\03AE \03C1\03CD\03B8\03BC\03B9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111413161136399362)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B1\03BD\03B5\03BD\03B5\03C1\03B3\03AD\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111304934056399283)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111315995068399291)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111309312735399287)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03AD\03BA\03C6\03C1\03B1\03C3\03B7 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111268700920399257)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1 \03BB\03AE\03BE\03B7\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03BC\03B5\03C4\03B1\03B3\03B5\03BD\03AD\03C3\03C4\03B5\03C1\03B7 \03C4\03B7\03C2 \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1\03C2 \03AD\03BD\03B1\03C1\03BE\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111323697181399297)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03AD\03BA\03C6\03C1\03B1\03C3\03B7 \03C6\03AF\03BB\03C4\03C1\03BF\03C5. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111391472935399346)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03C6\03AF\03BB\03C4\03C1\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111413212631399362)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'el'
,p_message_text=>unistr('1 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111413385274399363)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03B5\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111364138994399326)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'el'
,p_message_text=>unistr('(\03C3\03B5 \03BB\03B5\03C0\03C4\03AC)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111381146312399339)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111381332913399339)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03B5\03C0\03CC\03BC\03B5\03BD\03BF %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111381288276399339)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111381440804399339)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CC\03C7\03B9 \03BC\03AD\03C3\03B1 \03C3\03C4\03BF \03B5\03C0\03CC\03BC\03B5\03BD\03BF %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111314023552399290)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BB\03B7\03BA\03C4\03C1\03BF\03BB\03CC\03B3\03B9\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111280148509399266)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C4\03B9\03BA\03AD\03C4\03B1 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111307900881399286)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03AF\03C4\03BB\03BF\03C2 \03AC\03BE\03BF\03BD\03B1 \03B3\03B9\03B1 \03B5\03C4\03B9\03BA\03AD\03C4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111300467028399280)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03B7 \03B7\03BC\03AD\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111300604526399280)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 \03CE\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111300180758399280)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF\03C2 \03BC\03AE\03BD\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111300298758399280)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111300396518399280)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %0 \03B7\03BC\03AD\03C1\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111300556254399280)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %0 \03CE\03C1\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111299903018399280)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B1 %0 \03AD\03C4\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111300082858399280)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF \03AD\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111280006863399265)
,p_name=>'APEXIR_LINE'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03C1\03B1\03BC\03BC\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111276812019399263)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03C1\03B1\03BC\03BC\03AE \03BC\03B5 \03C0\03B5\03C1\03B9\03BF\03C7\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111391338250399346)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03C4\03B9\03C3\03C4\03BF\03AF\03C7\03B9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111308815502399286)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03B1\03BD\03B1\03BC\03AD\03BD\03B5\03C4\03B1\03B9 \03CC\03C4\03B9 \03B8\03B1 \03C5\03C0\03B5\03C1\03B2\03B5\03AF \03C4\03BF\03BD \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03B5\03C0\03B9\03C4\03C1\03B5\03C0\03CC\03BC\03B5\03BD\03BF \03B1\03C1\03B9\03B8\03BC\03CC \03C0\03CC\03C1\03C9\03BD. \03A4\03C1\03BF\03C0\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03B9\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BA\03B1\03B9 \03C0\03C1\03BF\03C3\03C0\03B1\03B8\03AE\03C3\03C4\03B5 \03BE\03B1\03BD\03AC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111291010985399273)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BC\03AD\03B3\03B9\03C3\03C4\03BF\03C2 \03B1\03C1\03B9\03B8\03BC\03CC\03C2 \03C3\03B5\03B9\03C1\03CE\03BD \03B3\03B9\03B1 \03B1\03C5\03C4\03AE \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B5\03AF\03BD\03B1\03B9 %0 \03C3\03B5\03B9\03C1\03AD\03C2. \0395\03C6\03B1\03C1\03BC\03CC\03C3\03C4\03B5 \03AD\03BD\03B1 \03C6\03AF\03BB\03C4\03C1\03BF \03B3\03B9\03B1 \03BD\03B1 \03BC\03B5\03B9\03CE\03C3\03B5\03C4\03B5 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03B5\03B3\03B3\03C1\03B1\03C6\03CE\03BD \03C3\03C4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111391959818399347)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03B3\03B9\03C3\03C4\03B7 \03C4\03B9\03BC\03AE %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111392168157399347)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03AC\03BC\03B5\03C3\03B7 \03C4\03B9\03BC\03AE %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111295071042399276)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BB\03B5\03C0\03C4\03AC \03C0\03C1\03B9\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111392012422399347)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BB\03AC\03C7\03B9\03C3\03C4\03B7 \03C4\03B9\03BC\03AE %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111391086342399346)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AE\03BD\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111364558328399327)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03AC\03B8\03B5 \03BC\03AE\03BD\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111307156861399285)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111307000056399285)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03CC\03BB\03C9\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111418296471399366)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03BF\03C5 \03C3\03C4\03B1\03C4\03B9\03BA\03BF\03CD \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03BF\03CD \03C0\03B5\03C1\03B9\03BF\03C7\03AE\03C2, \03B3\03B9\03B1\03C4\03AF \03B7 \03C3\03B5\03BB\03AF\03B4\03B1 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03AD\03C2 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AD\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AD\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111275508080399262)
,p_name=>'APEXIR_NAME'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BD\03BF\03BC\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111302966231399282)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'el'
,p_message_text=>unistr('\039D\03AD\03B1 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111413919194399363)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\039D\03AD\03B1 \03BA\03B1\03C4\03B7\03B3\03BF\03C1\03AF\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111303089083399282)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'el'
,p_message_text=>unistr('\039D\03AD\03BF\03C2 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111297860729399278)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111300908441399280)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B7 \03BC\03AD\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111300789654399280)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B7 \03CE\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111301260665399281)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF\03C2 \03BC\03AE\03BD\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111301174217399281)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B7 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111301020459399280)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B5\03C2 %0 \03B7\03BC\03AD\03C1\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111300858581399280)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B5\03C2 %0 \03CE\03C1\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111301497597399281)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03B1 %0 \03AD\03C4\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111301353265399281)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF \03AD\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111275898655399262)
,p_name=>'APEXIR_NO'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03C7\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111316160397399292)
,p_name=>'APEXIR_NONE'
,p_message_language=>'el'
,p_message_text=>unistr('- \039A\03B1\03BD\03AD\03BD\03B1 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111363713326399326)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03BC\03B9\03B1 \03AD\03B3\03BA\03C5\03C1\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111312647309399289)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03BF\03B9\03C7\03B5\03AF\03B1 null \03C0\03AC\03BD\03C4\03B1 \03C3\03C4\03B7\03BD \03B1\03C1\03C7\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111312508072399289)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03BF\03B9\03C7\03B5\03AF\03B1 null \03C0\03AC\03BD\03C4\03B1 \03C3\03C4\03BF \03C4\03AD\03BB\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111313017802399289)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03C9\03BD null - %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111309431662399287)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C7\03C1\03CC\03BD\03BF\03C2 \03B1\03BD\03B1\03B4\03C1\03BF\03BC\03AE\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03BC\03B9\03B1 \03B1\03C1\03B9\03B8\03BC\03B7\03C4\03B9\03BA\03AE \03C4\03B9\03BC\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111309015754399286)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B1\03BA\03BF\03BB\03BF\03C5\03B8\03AF\03B1 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03B1\03C1\03B9\03B8\03BC\03B7\03C4\03B9\03BA\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111313583022399290)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B5\03BB\03B5\03C3\03C4\03AE\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111274444770399261)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'el'
,p_message_text=>unistr('\03C0\03BF\03C1\03C4\03BF\03BA\03B1\03BB\03AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111383315141399340)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B1\03BD\03B1\03C4\03BF\03BB\03B9\03C3\03BC\03CC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111276314273399263)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03BB\03BB\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111259131084399250)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B1\03BD\03B1\03C4\03BF\03BB\03B9\03C3\03BC\03CC\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111259836432399251)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03C1\03B9\03B6\03CC\03BD\03C4\03B9\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111259909403399251)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03B1\03BA\03CC\03C1\03C5\03C6\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111259013868399250)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03B3\03B5\03B8\03BF\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111259609384399251)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'el'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111259577181399250)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'el'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111259770404399251)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111259341176399250)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'el'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111259284868399250)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'el'
,p_message_text=>'Letter'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111259456485399250)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'el'
,p_message_text=>'Tabloid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111392471795399347)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BF\03C3\03BF\03C3\03C4\03CC \03C3\03C5\03BD\03BF\03BB\03B9\03BA\03AE\03C2 \03BC\03AD\03C4\03C1\03B7\03C3\03B7\03C2 %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111391685222399347)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BF\03C3\03BF\03C3\03C4\03CC \03C3\03C5\03BD\03BF\03BB\03B9\03BA\03BF\03CD \03B1\03B8\03C1\03BF\03AF\03C3\03BC\03B1\03C4\03BF\03C2 %0 (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111390647872399346)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BF\03C3\03BF\03C3\03C4\03CC \03C3\03C5\03BD\03BF\03BB\03B9\03BA\03AE\03C2 \03BC\03AD\03C4\03C1\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111390598656399346)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BF\03C3\03BF\03C3\03C4\03CC \03C3\03C5\03BD\03BF\03BB\03B9\03BA\03BF\03CD \03B1\03B8\03C1\03BF\03AF\03C3\03BC\03B1\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111279915872399265)
,p_name=>'APEXIR_PIE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03AF\03C4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111339823077399309)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03AF\03BD\03B1\03BA\03B1\03C2 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111341328577399310)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111341575060399310)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7 \03C3\03B5 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 \03C0\03BF\03C5 \03AD\03C7\03B5\03B9 \03B5\03C0\03B9\03BB\03B5\03B3\03B5\03AF \03C9\03C2 \03C3\03C4\03AE\03BB\03B7 \03C3\03B5\03B9\03C1\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111340779012399309)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B5\03C2 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111340584967399309)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B7 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111341182819399310)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03BC\03B9\03B1\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111241222921399237)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BC\03AD\03B3\03B9\03C3\03C4\03BF\03C2 \03B1\03C1\03B9\03B8\03BC\03CC\03C2 \03C3\03B5\03B9\03C1\03CE\03BD \03B3\03B9\03B1 \03AD\03BD\03B1 \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD \03C0\03B5\03C1\03B9\03BF\03C1\03AF\03B6\03B5\03B9 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD \03C3\03C4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03BA\03B1\03B9 \03CC\03C7\03B9 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD. \03A4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03AC \03C3\03B1\03C2 \03C5\03C0\03B5\03C1\03B2\03B1\03AF\03BD\03B5\03B9 \03C4\03BF\03BD \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD %0 \03C3\03B5\03B9\03C1\03CE\03BD. \0395\03C6\03B1\03C1\03BC\03CC\03C3\03C4\03B5 \03AD\03BD\03B1 \03C6\03AF')
||unistr('\03BB\03C4\03C1\03BF \03B3\03B9\03B1 \03BD\03B1 \03BC\03B5\03B9\03CE\03C3\03B5\03C4\03B5 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03B5\03B3\03B3\03C1\03B1\03C6\03CE\03BD \03C3\03C4\03BF \03B2\03B1\03C3\03B9\03BA\03CC \03B5\03C1\03CE\03C4\03B7\03BC\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111341050988399310)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111310476512399287)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C3\03C4\03AE\03BB\03B7 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03C0\03AC\03C1\03B1 \03C0\03BF\03BB\03BB\03AD\03C2 \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03AD\03C2 \03C4\03B9\03BC\03AD\03C2. \0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111363820729399326)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03C0\03B9\03C3\03BA\03CC\03C0\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111297934702399278)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111389577660399345)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03CD\03C1\03B9\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111364868608399327)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03CD\03C1\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111258914372399250)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BC\03C0\03B5\03C1\03AF\03BB\03B7\03C8\03B7 \03B5\03C4\03B9\03BA\03B5\03C4\03CE\03BD \03C0\03C1\03BF\03C3\03B2\03B1\03C3\03B9\03BC\03CC\03C4\03B7\03C4\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111245893817399241)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BA\03BA\03B1\03B8\03AC\03C1\03B9\03C3\03B7 \03B5\03BC\03C0\03BB\03BF\03C5\03C4\03B9\03C3\03BC\03AD\03BD\03BF\03C5 \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111322680379399296)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0399\03B4\03B9\03C9\03C4\03B9\03BA\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111280507354399266)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B7\03BC\03CC\03C3\03B9\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111276133748399263)
,p_name=>'APEXIR_RED'
,p_message_language=>'el'
,p_message_text=>unistr('\03BA\03CC\03BA\03BA\03B9\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111418118079399366)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03B1\03C4\03B9\03BA\03CC \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C0\03B5\03C1\03B9\03BF\03C7\03AE\03C2 %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111307209079399285)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111307384454399285)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03CC\03BB\03C9\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111413408203399363)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111306830046399285)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03C4\03BF\03BC\03AE\03C2 \03B5\03BB\03AD\03B3\03C7\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111306502874399285)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03C6\03AF\03BB\03C4\03C1\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111306639424399285)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03B1\03BD\03B1\03B4\03C1\03BF\03BC\03AE\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111413529124399363)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111306901936399285)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111413667799399363)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111394663420399349)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111375212107399335)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03BF\03BD\03BF\03BC\03B1\03C3\03AF\03B1 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111316452292399292)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03BF\03BD\03BF\03BC\03B1\03C3\03AF\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111298226250399278)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03C6\03BF\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111392565457399347)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03C6\03BF\03C1\03AD\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111272790447399260)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B7 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03BC\03B5 \03C4\03BF \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03BF %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111322996994399297)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B1\03BD\03B1\03C6\03BF\03C1\03AC \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111272893384399260)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC %0 \03C4\03B7\03C2 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B7\03C2 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111314751765399291)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111295520571399277)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111299422662399279)
,p_name=>'APEXIR_RESET'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111280796342399266)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03AD\03C1\03B5\03C4\03B5 \03C4\03B9\03C2 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B5\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03C3\03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111275972003399262)
,p_name=>'APEXIR_ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111388656008399344)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03B5\03C4\03B5 \03C4\03BF ROWID \03C9\03C2 \03C3\03C4\03AE\03BB\03B7 \03C0\03C1\03C9\03C4\03B5\03CD\03BF\03BD\03C4\03BF\03C2 \03BA\03BB\03B5\03B9\03B4\03B9\03BF\03CD \03B3\03B9\03B1 \03BC\03B9\03B1 \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111305925404399284)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AD\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111365522689399328)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AD\03C2 \03B1\03BD\03AC \03C3\03B5\03BB\03AF\03B4\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111340809849399309)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B5\03C2 \03C3\03B5\03B9\03C1\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111340669210399309)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B7 \03C3\03B5\03B9\03C1\03CE\03BD %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111341260238399310)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03BC\03B9\03B1\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03B5\03B9\03C1\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111341437910399310)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C3\03C4\03AE\03BB\03B7 \03C3\03B5\03B9\03C1\03CE\03BD \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03B4\03B9\03B1\03C6\03BF\03C1\03B5\03C4\03B9\03BA\03AE \03B1\03C0\03CC \03C4\03B7 \03C3\03C4\03AE\03BB\03B7 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111320089939399294)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A6\03AF\03BB\03C4\03C1\03BF \03C3\03B5\03B9\03C1\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111295615837399277)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC %0 \03B1\03C0\03CC %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111299610115399279)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C3\03B5\03B9\03C1\03AC \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111275268907399262)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111310093330399287)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111309923226399287)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC = "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111312173885399289)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03B9 \03C4\03C1\03AD\03C7\03BF\03C5\03C3\03B5\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03B8\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03BF\03CD\03BD\03C4\03B1\03B9 \03C9\03C2 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B5\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03B3\03B9\03B1 \03CC\03BB\03BF\03C5\03C2 \03C4\03BF\03C5\03C2 \03C7\03C1\03AE\03C3\03C4\03B5\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111375199853399335)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111299397401399279)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111413852834399363)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 *')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111366512580399328)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111304811257399283)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03C1\03B1\03BC\03BC\03AE \03B1\03BD\03B1\03B6\03AE\03C4.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111413774494399363)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111372040893399332)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111356086242399321)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B5\03C2 \03C3\03C4\03AE\03BB\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111276935443399263)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('- \0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03C4\03AE\03BB\03B7\03C2 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111298630335399279)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03C4\03B7\03BB\03CE\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111280442641399266)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('- \0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7\03C2 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111305692666399284)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('- \0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03C4\03AE\03BB\03B7\03C2 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2 -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111340390299399309)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('- \0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111391570028399346)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03B5\03B9\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111340429490399309)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('- \0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03C4\03AE\03BB\03B7\03C2 \03C3\03B5\03B9\03C1\03CE\03BD -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111249105006399243)
,p_name=>'APEXIR_SEND'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03C3\03C4\03BF\03BB\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111255450204399248)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03C3\03C4\03BF\03BB\03AE \03C9\03C2 \03BC\03AE\03BD\03C5\03BC\03B1 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111275627550399262)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BA\03BF\03BB\03BF\03C5\03B8\03AF\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111298875305399279)
,p_name=>'APEXIR_SORT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111308179600399286)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C3\03B5 \03B1\03CD\03BE\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111308286561399286)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03C3\03B5 \03C6\03B8\03AF\03BD\03BF\03C5\03C3\03B1 \03C3\03B5\03B9\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111394017673399348)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC \03C4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111302616200399282)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'el'
,p_message_text=>unistr('\03BA\03B5\03BD\03CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111313786761399290)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111364226054399326)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03B4\03C1\03BF\03BC\03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111390991844399346)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AE\03BE\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111245328650399240)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03AC\03BB\03B5\03B9\03C8\03B7 \03B5\03AC\03BD \03B4\03B5\03BD \03B2\03C1\03B5\03B8\03BF\03CD\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111390815329399346)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BD\03B1\03C1\03BE\03B7 \03B1\03C0\03CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111391768443399347)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03B8\03C1\03BF\03B9\03C3\03BC\03B1 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111381758600399339)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03BF\03C7\03AE = %0, \0391\03BD\03B1\03C6\03BF\03C1\03AC = %1, \03A0\03C1\03BF\03B2\03BF\03BB\03AE = %2, \0388\03BD\03B1\03C1\03BE\03B7 \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD = %3, \039B\03AE\03BE\03B7 \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD = %4, \03A3\03CD\03BD\03BF\03BB\03BF \03C3\03B5\03B9\03C1\03CE\03BD = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111302398063399281)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03BF\03C7\03AE = %0, \0391\03BD\03B1\03C6\03BF\03C1\03AC = %1, \03A0\03C1\03BF\03B2\03BF\03BB\03AE = %2, \0388\03BD\03B1\03C1\03BE\03B7 \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD = %3, \039B\03AE\03BE\03B7 \03B5\03BC\03C6\03B1\03BD\03B9\03B6\03CC\03BC\03B5\03BD\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111274596056399261)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03CE\03BC\03B1 \03BA\03B5\03B9\03BC\03AD\03BD\03BF\03C5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111291677803399274)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('\03B7\03BC\03AD\03C1\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111291537253399274)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('\03CE\03C1\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111291458987399274)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'el'
,p_message_text=>unistr('\03BB\03B5\03C0\03C4\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111291816908399274)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03AE\03BD\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111291766037399274)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111291922332399274)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('\03AD\03C4\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111394440376399349)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B1\03BB\03BB\03B1\03B3\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111307411224399285)
,p_name=>'APEXIR_TOP'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C1\03C7\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111387673305399344)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03B7 \03C3\03C4\03AE\03BB\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111308957144399286)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03CC\03BD\03BF\03BC\03B1 \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03BC\03BF\03BD\03B1\03B4\03B9\03BA\03CC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111279290561399265)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B7 \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03B9\03B6\03CC\03BC\03B5\03BD\03BF\03C2 \03C4\03CD\03C0\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111307567385399285)
,p_name=>'APEXIR_UP'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03AC\03BD\03C9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111309100809399286)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03AD\03BD\03B1 \03AD\03B3\03BA\03C5\03C1\03BF \03C7\03C1\03CE\03BC\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111309259122399286)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03C3\03B1\03B3\03AC\03B3\03B5\03C4\03B5 \03BC\03B9\03B1 \03AD\03B3\03BA\03C5\03C1\03B7 \03BC\03AC\03C3\03BA\03B1 \03BC\03BF\03C1\03C6\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111276437483399263)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B9\03BC\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111308025876399286)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03AF\03C4\03BB\03BF\03C2 \03AC\03BE\03BF\03BD\03B1 \03B3\03B9\03B1 \03C4\03B9\03BC\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111315897042399291)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03BA\03B1\03C4\03B1\03C7\03C9\03C1\03B9\03C3\03C4\03B5\03AF \03C4\03B9\03BC\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111279867846399265)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03B1\03BA\03CC\03C1\03C5\03C6\03B7 \03C3\03C4\03AE\03BB\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111383524287399341)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C4\03B1\03BA\03CC\03C1\03C5\03C6\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111315136379399291)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111370317550399331)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03BB\03B5\03C0\03C4\03BF\03BC\03B5\03C1\03B5\03B9\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111415999238399364)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03C0\03C1\03BF\03B2\03BF\03BB\03AE %0 \03B3\03B9\03B1 \03C4\03B7\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111370435718399331)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03BF\03BC\03B1\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111370284693399331)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03B1 \03C0\03C1\03BF\03B2\03BF\03BB\03AE\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111340152478399309)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03B3\03BA\03B5\03BD\03C4\03C1\03C9\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111315288562399291)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111364481614399327)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03AC\03B8\03B5 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111298197110399278)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03C6\03BF\03C1\03AC \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111393139211399348)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B7\03BC\03AD\03C1\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111393037624399348)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CE\03C1\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111392949809399347)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BB\03B5\03C0\03C4\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111393344815399348)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AE\03BD\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111393271419399348)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111393424517399348)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03AD\03C4\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111391157776399346)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111274245330399261)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'el'
,p_message_text=>unistr('\03BA\03AF\03C4\03C1\03B9\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111275725375399262)
,p_name=>'APEXIR_YES'
,p_message_language=>'el'
,p_message_text=>unistr('\039D\03B1\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111307868858399286)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF %0 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2 < \03AE > \03C0\03BF\03C5 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03BF\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111330696818399302)
,p_name=>'APEX_REGION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03BF\03C7\03AE')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111258860077399250)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03B1\03B2\03AF\03B1\03C3\03B7 \03C0\03C1\03BF\03CB\03C0\03CC\03B8\03B5\03C3\03B7\03C2 API')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111278368831399264)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B1\03BD\03AC\03BA\03C4\03B7\03C3\03B7 \03C4\03B7\03C2 \03C4\03B9\03BC\03AE\03C2 \03B3\03B9\03B1 \03C4\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 %0, \03B1\03C6\03BF\03CD \03B7 \03C3\03C5\03C3\03C7\03B5\03C4\03B9\03C3\03BC\03AD\03BD\03B7 \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03B4\03CC\03BC\03B7\03C3\03B7\03C2 \03B5\03AF\03BD\03B1\03B9 \03B1\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111278206702399264)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03CC\03C2 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03B7\03C2 \03C4\03B9\03BC\03AE\03C2 \03B3\03B9\03B1 \03C4\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 %0, \03B1\03C6\03BF\03CD \03B7 \03C3\03C5\03C3\03C7\03B5\03C4\03B9\03C3\03BC\03AD\03BD\03B7 \03B5\03C0\03B9\03BB\03BF\03B3\03AE \03B4\03CC\03BC\03B7\03C3\03B7\03C2 \03B5\03AF\03BD\03B1\03B9 \03B1\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111385983364399342)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B9\03BC\03AE \03C4\03B7\03C2 \03C1\03CD\03B8\03BC\03B9\03C3\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 %0 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111385850092399342)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B6\03B7\03C4\03BF\03CD\03BC\03B5\03BD\03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 %0 \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111386001352399342)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 %0 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03BC\03B5 \03BC\03B9\03B1 \03C4\03B9\03BC\03AE null')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111266987599399256)
,p_name=>'BACK'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03AF\03C3\03C9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111253986005399247)
,p_name=>'BUILDER'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 \03B4\03CC\03BC\03B7\03C3\03B7\03C2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111318086931399293)
,p_name=>'BUTTON LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C4\03B9\03BA\03AD\03C4\03B1 \03BA\03BF\03C5\03BC\03C0\03B9\03BF\03CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111253039578399246)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03BB\03AC\03C3\03B5\03B9\03C2 CSS \03BA\03BF\03C5\03BC\03C0\03B9\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111282238672399267)
,p_name=>'BUTTON_ID'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C4\03BF\03C5 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03BF\03CD\03BC\03B5\03BD\03BF\03C5 \03BA\03BF\03C5\03BC\03C0\03B9\03BF\03CD \03B8\03B1 \03B5\03AF\03BD\03B1\03B9 \03C4\03BF \03C3\03C4\03B1\03C4\03B9\03BA\03CC \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C4\03BF\03C5 \03BA\03BF\03C5\03BC\03C0\03B9\03BF\03CD, \03B1\03BD \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF, \03B4\03B9\03B1\03C6\03BF\03C1\03B5\03C4\03B9\03BA\03AC \03B8\03B1 \03B5\03AF\03BD\03B1\03B9 \03AD\03BD\03B1 \03B5\03C3\03C9\03C4\03B5\03C1\03B9\03BA\03AC \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03BF\03CD\03BC\03B5\03BD\03BF \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C4\03B7\03C2 \03BC\03BF\03C1\03C6\03AE\03C2 ''B'' || [\0395\03C3\03C9\03C4\03B5\03C1\03B9\03BA\03CC \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03BA\03BF\03C5\03BC\03C0\03B9\03BF\03CD].')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111245754902399241)
,p_name=>'CANDLESTICK'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B7\03C1\03BF\03C0\03AE\03B3\03B9\03BF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111327258818399300)
,p_name=>'CENTER'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03AD\03BD\03C4\03C1\03BF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111277265428399263)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03AF\03C4\03B7\03BC\03B1 %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111268638645399257)
,p_name=>'CHECK$'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03C0\03B9\03BB\03BF\03B3\03AD\03B1\03C2 \03C3\03B5\03B9\03C1\03CE\03BD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111387785141399344)
,p_name=>'CHECKED'
,p_message_language=>'el'
,p_message_text=>unistr('\03AD\03C7\03B5\03B9 \03B5\03C0\03B9\03BB\03B5\03B3\03B5\03AF')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111363273881399326)
,p_name=>'COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111323792186399297)
,p_name=>'COMMENTS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C7\03CC\03BB\03B9\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111305208836399284)
,p_name=>'CONTINUE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03AD\03C7\03B5\03B9\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111267296395399256)
,p_name=>'COPYRIGHT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BD\03B5\03C5\03BC\03B1\03C4\03B9\03BA\03AC \03B4\03B9\03BA\03B1\03B9\03CE\03BC\03B1\03C4\03B1 &copy; %0. \039C\03B5 \03C4\03B7\03BD \03B5\03C0\03B9\03C6\03CD\03BB\03B1\03BE\03B7 \03BA\03AC\03B8\03B5 \03BD\03CC\03BC\03B9\03BC\03BF\03C5 \03B4\03B9\03BA\03B1\03B9\03CE\03BC\03B1\03C4\03BF\03C2.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111310977076399288)
,p_name=>'COUNT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AD\03C4\03C1\03B7\03C3\03B7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111317669771399293)
,p_name=>'CREATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111369998497399331)
,p_name=>'CREATED'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03B8\03B7\03BA\03B5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111370064005399331)
,p_name=>'CREATED_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03B8\03B7\03BA\03B5 \03B1\03C0\03CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111294837951399276)
,p_name=>'CREATED_ON'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03B8\03B7\03BA\03B5 \03C3\03C4\03B9\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111305416593399284)
,p_name=>'CUSTOM'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111316692023399292)
,p_name=>'CUSTOMIZE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111318253658399293)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03B3\03B9\03BD\03B5 \03B5\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C4\03C9\03BD \03C0\03C1\03BF\03C4\03B9\03BC\03AE\03C3\03B5\03C9\03BD \03C3\03B5\03BB\03AF\03B4\03B1\03C2 \03B3\03B9\03B1 \03C4\03BF\03BD \03C7\03C1\03AE\03C3\03C4\03B7 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111318302661399293)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03B9 \03C0\03C1\03BF\03C4\03B9\03BC\03AE\03C3\03B5\03B9\03C2 \03B3\03B9\03B1 \03C4\03BF\03BD \03C7\03C1\03AE\03C3\03C4\03B7 %0 \03AC\03BB\03BB\03B1\03BE\03B1\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111318114059399293)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03B3\03B9\03BD\03B5 \03B5\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C4\03C9\03BD \03C0\03C1\03BF\03C4\03B9\03BC\03AE\03C3\03B5\03C9\03BD \03C3\03B5\03BB\03AF\03B4\03B1\03C2 \03B3\03B9\03B1 \03C4\03BF\03BD \03C7\03C1\03AE\03C3\03C4\03B7 %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111281931828399267)
,p_name=>'DAILY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03B8\03B7\03BC\03B5\03C1\03B9\03BD\03AC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111253535331399246)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03C0\03B5\03C3\03C4\03B1\03BB\03BC\03AD\03BD\03BF \03B1\03C1\03C7\03B5\03AF\03BF \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03BF \03AE \03AD\03C7\03B5\03B9 \03B5\03C3\03C6\03B1\03BB\03BC\03AD\03BD\03B7 \03B5\03C0\03AD\03BA\03C4\03B1\03C3\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111277470213399264)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03B8\03B7\03BA\03B5 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03BF\03C2 \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03B1\03C2 XML \03AE JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111246798990399241)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C0\03C1\03BF\03C6\03AF\03BB \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03BA\03B1\03B9 \03C4\03BF \03B1\03C0\03B5\03C3\03C4\03B1\03BB\03BC\03AD\03BD\03BF \03B1\03C1\03C7\03B5\03AF\03BF \03B4\03B5\03BD \03C0\03B5\03C1\03B9\03AD\03C7\03BF\03C5\03BD \03BA\03B1\03BC\03AF\03B1 \03C3\03C4\03AE\03BB\03B7 \03C0\03AF\03BD\03B1\03BA\03B1 \03C0\03C1\03BF\03BF\03C1\03B9\03C3\03BC\03BF\03CD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111332445043399303)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03C3\03C4\03BF \03B1\03C0\03B5\03C3\03C4\03B1\03BB\03BC\03AD\03BD\03BF \03B1\03C1\03C7\03B5\03AF\03BF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111332535473399304)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03C3\03C4\03BF \03C6\03CD\03BB\03BB\03BF \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111252368307399245)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03BF \03B1\03C1\03C7\03B5\03AF\03BF \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03BD\03B1 \03B1\03C1\03C7\03B5\03AF\03BF XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111242708149399238)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03BB\03BF\03BA\03BB\03AE\03C1\03C9\03C3\03B7 \03C6\03CC\03C1\03C4\03C9\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD: \0388\03B3\03B9\03BD\03B5 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 %0 \03C3\03B5\03B9\03C1\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111243942687399239)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03BB\03BF\03BA\03BB\03AE\03C1\03C9\03C3\03B7 \03C6\03CC\03C1\03C4\03C9\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD: \0388\03B3\03B9\03BD\03B5 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 %0 \03C3\03B5\03B9\03C1\03CE\03BD \03BC\03B5 1 \03C3\03C6\03AC\03BB\03BC\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111244234671399240)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03BB\03BF\03BA\03BB\03AE\03C1\03C9\03C3\03B7 \03C6\03CC\03C1\03C4\03C9\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD: \0388\03B3\03B9\03BD\03B5 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 %0 \03C3\03B5\03B9\03C1\03CE\03BD \03BC\03B5 %1 \03C3\03C6\03AC\03BB\03BC\03B1\03C4\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111244033482399239)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03BB\03BF\03BA\03BB\03AE\03C1\03C9\03C3\03B7 \03C6\03CC\03C1\03C4\03C9\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD: \0388\03B3\03B9\03BD\03B5 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 1 \03C3\03B5\03B9\03C1\03AC\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111247076869399242)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03BB\03BF\03BA\03BB\03AE\03C1\03C9\03C3\03B7 \03C6\03CC\03C1\03C4\03C9\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD: \0388\03B3\03B9\03BD\03B5 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 1 \03C3\03B5\03B9\03C1\03AC\03C2 \03BC\03B5 \03C3\03C6\03AC\03BB\03BC\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111244127097399239)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03BB\03BF\03BA\03BB\03AE\03C1\03C9\03C3\03B7 \03C6\03CC\03C1\03C4\03C9\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD: \0388\03B3\03B9\03BD\03B5 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 1 \03C3\03B5\03B9\03C1\03AC\03C2 \03C7\03C9\03C1\03AF\03C2 \03C3\03C6\03AC\03BB\03BC\03B1\03C4\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111337734951399307)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B7 \03C0\03C1\03BF\03BF\03C1\03B9\03C3\03BC\03BF\03CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111337870729399307)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03AE\03BB\03B7 \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111338694269399308)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03BF\03C1\03C6\03AE \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1\03C2/\03B1\03C1\03B9\03B8\03BC\03BF\03CD')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111402005569399354)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03AD\03C4\03C5\03C7\03B5 \03B7 \03B1\03BD\03AC\03BA\03C4\03B7\03C3\03B7 \03C4\03B7\03C2 \03C4\03B9\03BC\03AE\03C2 \03B1\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111370589383399331)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03C4\03B9\03C3\03C4\03BF\03AF\03C7\03B9\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD/\03C0\03AF\03BD\03B1\03BA\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111338768949399308)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111334237178399305)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03B1\03BD\03CC\03BD\03B1\03C2 \03BC\03B5\03C4\03B1\03C3\03C7\03B7\03BC\03B1\03C4\03B9\03C3\03BC\03BF\03CD \03B1\03C0\03AD\03C4\03C5\03C7\03B5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111310536316399287)
,p_name=>'DATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111284648109399269)
,p_name=>'DAY'
,p_message_language=>'el'
,p_message_text=>unistr('\03B7\03BC\03AD\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111284706892399269)
,p_name=>'DAYS'
,p_message_language=>'el'
,p_message_text=>unistr('\03B7\03BC\03AD\03C1\03B5\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111323494830399297)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03B5\03BD\03C4\03BF\03C0\03B9\03C3\03BC\03CC\03C2 \03C3\03C6\03B1\03BB\03BC\03AC\03C4\03C9\03BD \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF \03B3\03B9\03B1 \03B1\03C5\03C4\03AE\03BD \03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111372216252399332)
,p_name=>'DEFAULT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03C0\03B9\03BB\03BF\03B3\03AE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111285410462399269)
,p_name=>'DELETE'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B9\03B1\03B3\03C1\03B1\03C6\03AE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111245633616399241)
,p_name=>'DIAL_PCT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03C1\03B7\03C4\03AE\03C2 (\03A0\03BF\03C3\03BF\03C3\03C4\03CC)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111260115127399251)
,p_name=>'DOWNLOAD'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AE\03C8\03B7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111371352979399332)
,p_name=>'DUP_USER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A5\03C0\03AC\03C1\03C7\03B5\03B9 \03B4\03B9\03C0\03BB\03CC\03C4\03C5\03C0\03BF \03CC\03BD\03BF\03BC\03B1 \03C7\03C1\03AE\03C3\03C4\03B7 \03C3\03C4\03B7 \03BB\03AF\03C3\03C4\03B1.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111267785793399257)
,p_name=>'EDIT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111277142494399263)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5 "%0" \03B4\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111262253423399252)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03CC \03C4\03BF \03BC\03AE\03BD\03C5\03BC\03B1 \03AD\03C7\03B5\03B9 \03C3\03C4\03B1\03BB\03B5\03AF \03B1\03C0\03CC %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111371585836399332)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5 \03B5\03AF\03BD\03B1\03B9 \03C0\03BF\03BB\03CD \03BC\03B5\03B3\03AC\03BB\03B7. \03A4\03BF \03CC\03C1\03B9\03BF \03B5\03AF\03BD\03B1\03B9 %0 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111305167702399284)
,p_name=>'ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C6\03AC\03BB\03BC\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111334318221399305)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03CC\03C2 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03B7\03C2 \03C4\03B9\03BC\03AE\03C2 \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7\03C2 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 \03C3\03B5\03BB\03AF\03B4\03B1\03C2 \03B3\03B9\03B1 \03BC\03B9\03B1 \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03BC\03B5\03C1\03B9\03BA\03AE\03C2 \03B1\03BD\03B1\03BD\03AD\03C9\03C3\03B7\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111296633189399277)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03B8\03B7\03BA\03B5 \03B1\03C0\03CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111262557770399253)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03AD\03C7\03B5\03B9 \03BB\03AE\03BE\03B5\03B9')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111256658410399248)
,p_name=>'FILE_EMPTY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03C1\03C7\03B5\03AF\03BF \03B5\03AF\03BD\03B1\03B9 \03BA\03B5\03BD\03CC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111336886558399307)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03BC\03AD\03B3\03B5\03B8\03BF\03C2 \03C4\03BF\03C5 \03B1\03C0\03B5\03C3\03C4\03B1\03BB\03BC\03AD\03BD\03BF\03C5 \03B1\03C1\03C7\03B5\03AF\03BF\03C5 \03C5\03C0\03B5\03C1\03AD\03B2\03B1\03B9\03BD\03B5 \03C4\03B1 %0 MB. \0391\03C0\03BF\03C3\03C4\03B5\03AF\03BB\03B5\03C4\03B5 \03AD\03BD\03B1 \03BC\03B9\03BA\03C1\03CC\03C4\03B5\03C1\03BF \03B1\03C1\03C7\03B5\03AF\03BF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111264699355399254)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03AD\03BB\03B5\03B3\03C7\03BF\03C2 \03C4\03B1\03C5\03C4\03CC\03C4\03B7\03C4\03B1\03C2 \03C7\03C1\03AE\03C3\03C4\03B7 \03B1\03C0\03AD\03C4\03C5\03C7\03B5 \03BA\03B1\03B9 \03AD\03BD\03B1 \03AE \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B1 \03B1\03C1\03C7\03B5\03AF\03B1 \03B4\03B5\03BD \03B5\03C3\03C4\03AC\03BB\03B7\03C3\03B1\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111264704619399254)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03CC \03C4\03BF \03C3\03C4\03B9\03B3\03BC\03B9\03CC\03C4\03C5\03C0\03BF \03B4\03B5\03BD \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03B9 \03C4\03B7\03BD \03B1\03C0\03BF\03C3\03C4\03BF\03BB\03AE \03B1\03C1\03C7\03B5\03AF\03C9\03BD \03B1\03C0\03CC \03BC\03B7 \03C4\03B1\03C5\03C4\03BF\03C0\03BF\03B9\03B7\03BC\03AD\03BD\03BF\03C5\03C2 \03C7\03C1\03AE\03C3\03C4\03B5\03C2.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111317706741399293)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 1 \03C3\03C6\03AC\03BB\03BC\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111316964990399292)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B1\03BD %0 \03C3\03C6\03AC\03BB\03BC\03B1\03C4\03B1')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111267134824399256)
,p_name=>'FORM_OF'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B1\03C0\03CC %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111301819444399281)
,p_name=>'GO'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03AC\03B2\03B1\03C3\03B7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111401635162399354)
,p_name=>'HELP'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03BF\03AE\03B8\03B5\03B9\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111254002236399247)
,p_name=>'HOME'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C1\03C7\03B9\03BA\03AE \03C3\03B5\03BB\03AF\03B4\03B1')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111284469226399269)
,p_name=>'HOUR'
,p_message_language=>'el'
,p_message_text=>unistr('\03CE\03C1\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111284588555399269)
,p_name=>'HOURS'
,p_message_language=>'el'
,p_message_text=>unistr('\03CE\03C1\03B5\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111268555965399257)
,p_name=>'ICON'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03BA\03BF\03BD\03AF\03B4\03B9\03BF %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111318582346399293)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B1 \03B4\03B9\03B1\03C0\03B9\03C3\03C4\03B5\03C5\03C4\03AE\03C1\03B9\03B1 \03C3\03CD\03BD\03B4\03B5\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111418097372399366)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C4\03B9\03BC\03AE \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03B1\03C1\03AC\03BC\03B5\03C4\03C1\03BF: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111313282634399289)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A9\03C2 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B5\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111313381848399290)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A9\03C2 \03B5\03C0\03CE\03BD\03C5\03BC\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111295734652399277)
,p_name=>'IR_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03C3\03C6\03AC\03BB\03BC\03B1. %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111295470978399277)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03CC\03C2 \03BF \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC\03C2 \03C4\03B7\03C2 \03C0\03BB\03BF\03AE\03B3\03B7\03C3\03B7\03C2 \03C3\03C4\03B7 \03C6\03CC\03C1\03BC\03B1. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111273005034399260)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5 \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE \03B1\03BD\03B1\03C6\03BF\03C1\03AC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111272450791399260)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03B5\03C1\03B9\03BF\03C7\03AE \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03C3\03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE %0, \03C3\03B5\03BB\03AF\03B4\03B1 %1 \03BA\03B1\03B9 \03C0\03B5\03C1\03B9\03BF\03C7\03AE %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111313193798399289)
,p_name=>'IR_STAR'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03BC\03CC\03BD\03BF \03B3\03B9\03B1 \03C0\03C1\03BF\03B3\03C1\03B1\03BC\03BC\03B1\03C4\03B9\03C3\03C4\03AD\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111301530693399281)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C7\03C1\03B5\03B9\03AC\03B6\03B5\03C4\03B1\03B9 \03AD\03BD\03B1 \03BC\03BF\03BD\03B1\03B4\03B9\03BA\03CC \03BA\03BB\03B5\03B9\03B4\03AF \03B3\03B9\03B1 \03C4\03B7\03BD \03B1\03BD\03B1\03B3\03BD\03CE\03C1\03B9\03C3\03B7 \03BA\03AC\03B8\03B5 \03C3\03B5\03B9\03C1\03AC\03C2. \03A4\03BF \03C0\03B1\03C1\03B5\03C7\03CC\03BC\03B5\03BD\03BF \03BA\03BB\03B5\03B9\03B4\03AF \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF \03B3\03B9\03B1 \03B1\03C5\03C4\03CC \03C4\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03B1. \039F\03C1\03AF\03C3\03C4\03B5 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 \03BC\03BF\03BD\03B1\03B4\03B9\03BA\03BF\03CD \03BA\03BB\03B5\03B9\03B4\03B9\03BF\03CD. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111301693491399281)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C7\03C1\03B5\03B9\03AC\03B6\03B5\03C4\03B1\03B9 \03AD\03BD\03B1 \03BC\03BF\03BD\03B1\03B4\03B9\03BA\03CC \03BA\03BB\03B5\03B9\03B4\03AF \03B3\03B9\03B1 \03C4\03B7\03BD \03B1\03BD\03B1\03B3\03BD\03CE\03C1\03B9\03C3\03B7 \03BA\03AC\03B8\03B5 \03C3\03B5\03B9\03C1\03AC\03C2. \03A4\03BF \03C0\03B1\03C1\03B5\03C7\03CC\03BC\03B5\03BD\03BF \03BA\03BB\03B5\03B9\03B4\03AF \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF \03B3\03B9\03B1 \03B1\03C5\03C4\03CC \03C4\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03B1. \0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03C4\03B5\03AF\03C4\03B5 \03C4\03B1 \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03AC \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03B3\03B9\03B1 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 \03BC\03BF\03BD\03B1\03B4\03B9\03BA\03BF\03CD \03BA\03BB\03B5\03B9\03B4\03B9\03BF\03CD. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111338953575399308)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03AD\03BD\03B1 \03B1\03C1\03C7\03B5\03AF\03BF')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111338887976399308)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03C6\03AD\03C1\03B5\03C4\03B5 \03BA\03B1\03B9 \03B1\03C0\03BF\03B8\03AD\03C3\03C4\03B5 \03AD\03BD\03B1 \03B1\03C1\03C7\03B5\03AF\03BF \03B5\03B4\03CE \03AE')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111267460641399256)
,p_name=>'ITEMS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03BF\03B9\03C7\03B5\03AF\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111296826036399278)
,p_name=>'ITEM_VALUE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B9\03BC\03AE \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111311249780399288)
,p_name=>'LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C4\03B9\03BA\03AD\03C4\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111323364815399297)
,p_name=>'LANGUAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03BB\03CE\03C3\03C3\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111285199396399269)
,p_name=>'LAST'
,p_message_language=>'el'
,p_message_text=>unistr('\03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03BF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111264542915399254)
,p_name=>'LENGTH'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AE\03BA\03BF\03C2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111317897626399293)
,p_name=>'LOGIN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BD\03B4\03B5\03C3\03B7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111356452121399321)
,p_name=>'MANAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03B1\03C7\03B5\03AF\03C1\03B9\03C3\03B7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111421051816399368)
,p_name=>'MAXIMIZE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03B3\03B9\03C3\03C4\03BF\03C0\03BF\03AF\03B7\03C3\03B7')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111284243930399268)
,p_name=>'MINUTE'
,p_message_language=>'el'
,p_message_text=>unistr('\03BB\03B5\03C0\03C4\03CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111284313510399269)
,p_name=>'MINUTES'
,p_message_language=>'el'
,p_message_text=>unistr('\03BB\03B5\03C0\03C4\03AC')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111371754685399332)
,p_name=>'MISSING_AT'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03B5\03AF\03C0\03B5\03B9 \03BF \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B1\03C2 "@" \03B1\03C0\03CC \03C4\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111371929054399332)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7: \0394\03B5\03BD \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03C0\03C1\03CC\03C4\03C5\03C0\03BF \03C3\03B5\03BB\03AF\03B4\03C9\03BD \03C0\03BB\03B1\03B9\03C3\03AF\03BF\03C5 \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \03B3\03B9\03B1 \03C4\03B7 \03C3\03B5\03BB\03AF\03B4\03B1 \03C0\03BB\03B1\03B9\03C3\03AF\03BF\03C5 \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 %0 \03C3\03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111371643371399332)
,p_name=>'MISSING_DOT'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03B5\03AF\03C0\03B5\03B9 \03BF \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B1\03C2 "." \03B1\03C0\03CC \03C4\03BF\03BD \03C4\03BF\03BC\03AD\03B1 \03C4\03B7\03C2 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7\03C2 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111320889787399295)
,p_name=>'MODULE'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03B9\03BA\03AE \03BC\03BF\03BD\03AC\03B4\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111277952578399264)
,p_name=>'MONTH'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03AE\03BD\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111281715452399267)
,p_name=>'MONTHLY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03AC\03B8\03B5 \03BC\03AE\03BD\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111278004399399264)
,p_name=>'MONTHS'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03AE\03BD\03B5\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111310882667399288)
,p_name=>'MOVE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111378304330399337)
,p_name=>'MOVE_FROM'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03B1\03C0\03CC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111378472029399337)
,p_name=>'MOVE_TO'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B5\03C4\03B1\03BA\03AF\03BD\03B7\03C3\03B7 \03C3\03B5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111298029592399278)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C6\03AC\03BB\03BC\03B1 \03C3\03C4\03B7 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 \03B4\03B9\03B1\03B3\03C1\03B1\03C6\03AE\03C2 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03CE\03BD \03C3\03B5\03B9\03C1\03CE\03BD: \03C3\03B5\03B9\03C1\03AC= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111297001251399278)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03B4\03B7\03BC\03CC\03C3\03B9\03BF\03C2 \03C7\03C1\03AE\03C3\03C4\03B7\03C2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111254232090399247)
,p_name=>'NAME'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BD\03BF\03BC\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111311071305399288)
,p_name=>'NEW'
,p_message_language=>'el'
,p_message_text=>unistr('\039D\03AD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111277709093399264)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03C3\03C5\03BD\03B4\03B5\03B8\03B5\03AF\03C4\03B5 \03C3\03C4\03BF %0 \03BC\03B5\03C4\03B1\03B2\03B1\03AF\03BD\03BF\03BD\03C4\03B1\03C2 \03C3\03C4\03B7\03BD \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111277805271399264)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03B3\03B9\03B1 \03BD\03AD\03BF \03BB\03BF\03B3\03B1\03C1\03B9\03B1\03C3\03BC\03CC %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111401849964399354)
,p_name=>'NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111320777940399295)
,p_name=>'NO'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03C7\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111416066854399364)
,p_name=>'NOBODY'
,p_message_language=>'el'
,p_message_text=>unistr('\03BA\03B1\03BD\03AD\03BD\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111285574438399269)
,p_name=>'NOT'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03C7\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111326398856399299)
,p_name=>'NOT_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03C7\03B9 Null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111297119815399278)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03C7\03B9 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111316744747399292)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B5 \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111325868048399299)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5 \03B5\03BD\03B7\03BC\03B5\03C1\03CE\03C3\03B9\03BC\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC. \039F\03B9 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B5\03C2 \03B5\03BD\03B7\03BC\03AD\03C1\03C9\03C3\03B7\03C2 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03CE\03BD \03C3\03B5\03B9\03C1\03CE\03BD \03BA\03B1\03B9 \03B4\03B9\03B1\03B3\03C1\03B1\03C6\03AE\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03B5\03BA\03C4\03B5\03BB\03B5\03C3\03C4\03BF\03CD\03BD \03BC\03CC\03BD\03BF \03C3\03B5 \03BC\03BF\03C1\03C6\03AD\03C2 \03C0\03AF\03BD\03B1\03BA\03B1 \03C4\03BF\03C5 \03C4\03CD\03C0\03BF\03C5 \0395\03BD\03B7\03BC\03B5\03C1\03CE\03C3\03B9\03BC\03B7 \03B1\03BD\03B1\03C6\03BF\03C1\03AC.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111326726075399299)
,p_name=>'OK'
,p_message_language=>'el'
,p_message_text=>'OK'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111322453671399296)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'el'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111419867573399367)
,p_name=>'ORA_06550'
,p_message_language=>'el'
,p_message_text=>unistr('ORA-06550: \03B3\03C1\03B1\03BC\03BC\03AE %0, \03C3\03C4\03AE\03BB\03B7 %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111369374458399330)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B5\03AF\03C4\03B5 \03BC\03B9\03B1 \03C0\03B1\03BB\03B9\03AC \03AD\03BA\03B4\03BF\03C3\03B7 \03C0\03C1\03BF\03B3\03C1\03AC\03BC\03BC\03B1\03C4\03BF\03C2 \03C0\03B5\03C1\03B9\03AE\03B3\03B7\03C3\03B7\03C2 \03B9\03C3\03C4\03BF\03CD. \0393\03B9\03B1 \03BD\03B1 \03B4\03B5\03AF\03C4\03B5 \03BC\03B9\03B1 \03BB\03AF\03C3\03C4\03B1 \03BC\03B5 \03C4\03B1 \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03B9\03B6\03CC\03BC\03B5\03BD\03B1 \03C0\03C1\03BF\03B3\03C1\03AC\03BC\03BC\03B1\03C4\03B1 \03C0\03B5\03C1\03B9\03AE\03B3\03B7\03C3\03B7\03C2 \03B9\03C3\03C4\03BF\03CD, \03B1\03BD\03B1\03C4\03C1\03AD\03BE\03C4\03B5 \03C3\03C4\03BF\03BD \039F\03B4\03B7\03B3\03CC \03B5\03B3\03BA\03B1\03C4\03AC\03C3\03C4\03B1\03C3\03B7\03C2 \03C4\03BF\03C5 Oracle Application Express.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111270704100399259)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0396\03B7\03C4\03AE\03B8\03B7\03BA\03B5 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03BF \03C3\03CD\03BD\03BF\03BB\03BF \03C3\03B5\03B9\03C1\03CE\03BD. \0397 \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C4\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C4\03C1\03BF\03C0\03BF\03C0\03BF\03B9\03AE\03B8\03B7\03BA\03B5.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111290895243399273)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03AD\03BD\03B1\03C2 \03AD\03B3\03BA\03C5\03C1\03BF\03C2 \03B1\03C1\03B9\03B8\03BC\03CC\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2 (\03C0.\03C7. p?n=1234).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111294421729399276)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111294553240399276)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03CC\03BC\03B5\03BD\03BF \03C3\03CD\03BD\03BF\03BB\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111294627434399276)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111294797606399276)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF \03C3\03CD\03BD\03BF\03BB\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111401728067399354)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03B5\03BB\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111332353703399303)
,p_name=>'PASSWORD'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111277058727399263)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03B3\03B9\03B1 \03C4\03BF %0 \03AD\03C7\03B5\03B9 \03B1\03BB\03BB\03AC\03BE\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111266843828399256)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03B4\03B5\03BD \03C3\03C5\03BC\03BC\03BF\03C1\03C6\03CE\03BD\03B5\03C4\03B1\03B9 \03BC\03B5 \03C4\03BF\03C5\03C2 \03BA\03B1\03BD\03CC\03BD\03B5\03C2 \03C0\03BF\03BB\03C5\03C0\03BB\03BF\03BA\03CC\03C4\03B7\03C4\03B1\03C2 \03BA\03C9\03B4\03B9\03BA\03CE\03BD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C4\03BF\03C5 \03B9\03C3\03C4\03BF\03C4\03CC\03C0\03BF\03C5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111265929709399255)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BD\03AD\03BF\03C2 \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B4\03B9\03B1\03C6\03AD\03C1\03B5\03B9 \03B1\03C0\03CC \03C4\03BF\03BD \03C0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF \03BA\03C9\03B4\03B9\03BA\03CC \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C4\03BF\03C5\03BB\03AC\03C7\03B9\03C3\03C4\03BF\03BD \03BA\03B1\03C4\03AC %0 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111266551521399256)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03B4\03B5\03BD \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03C4\03BF \03CC\03BD\03BF\03BC\03B1 \03C7\03C1\03AE\03C3\03C4\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111266790142399256)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BC\03B9\03B1 \03B1\03C0\03B1\03B3\03BF\03C1\03B5\03C5\03BC\03AD\03BD\03B7 \03B1\03C0\03BB\03AE \03BB\03AD\03BE\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111266628366399256)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03B4\03B5\03BD \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03C4\03BF \03CC\03BD\03BF\03BC\03B1 \03C7\03CE\03C1\03BF\03C5 \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111265870147399255)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03C4\03BF\03C5\03BB\03AC\03C7\03B9\03C3\03C4\03BF\03BD %0 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111266001398399255)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03C4\03BF\03C5\03BB\03AC\03C7\03B9\03C3\03C4\03BF\03BD \03AD\03BD\03B1\03BD \03B1\03BB\03C6\03B1\03B2\03B7\03C4\03B9\03BA\03CC \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B1 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111266410479399256)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03C4\03BF\03C5\03BB\03AC\03C7\03B9\03C3\03C4\03BF\03BD \03AD\03BD\03B1\03BD \03C0\03B5\03B6\03CC \03B1\03BB\03C6\03B1\03B2\03B7\03C4\03B9\03BA\03CC \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111266142785399255)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03C4\03BF\03C5\03BB\03AC\03C7\03B9\03C3\03C4\03BF\03BD \03AD\03BD\03B1\03BD \03B1\03C1\03B9\03B8\03BC\03B7\03C4\03B9\03BA\03CC \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B1 (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111266222465399255)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03C4\03BF\03C5\03BB\03AC\03C7\03B9\03C3\03C4\03BF\03BD \03AD\03BD\03B1\03BD \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B1 \03C3\03C4\03AF\03BE\03B7\03C2 (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111266369077399256)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03C4\03BF\03C5\03BB\03AC\03C7\03B9\03C3\03C4\03BF\03BD \03AD\03BD\03B1\03BD \03BA\03B5\03C6\03B1\03BB\03B1\03AF\03BF \03B1\03BB\03C6\03B1\03B2\03B7\03C4\03B9\03BA\03CC \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111277559630399264)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03B5\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03BA\03C9\03B4\03B9\03BA\03BF\03CD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111264828463399254)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03C7\03C1\03AE\03C3\03B7 \03C4\03BF\03C5 \03BA\03C9\03B4\03B9\03BA\03BF\03CD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2, \03B3\03B9\03B1\03C4\03AF \03AD\03C7\03B5\03B9 \03AE\03B4\03B7 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF \03C4\03B9\03C2 \03C4\03B5\03BB\03B5\03C5\03C4\03B1\03AF\03B5\03C2 %0 \03B7\03BC\03AD\03C1\03B5\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111345195674399313)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03BF\03B9\03C7\03B5\03AF\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111345232206399313)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03BF\03B9\03C7\03B5\03AF\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111322208506399296)
,p_name=>'PERCENT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03BF\03C3\03BF\03C3\03C4\03CC (%)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111292571991399274)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111401935619399354)
,p_name=>'PREVIOUS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B7\03B3\03BF\03CD\03BC\03B5\03BD\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111337321380399307)
,p_name=>'PRINT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BA\03C4\03CD\03C0\03C9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111321091017399295)
,p_name=>'PRIVILEGES'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03BA\03B1\03B9\03CE\03BC\03B1\03C4\03B1')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111290901106399273)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03B1\03C0\03BF\03BC\03C0\03AD\03C2 \03C0\03B5\03C1\03B9\03BF\03C7\03CE\03BD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111311124738399288)
,p_name=>'REPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03C6\03BF\03C1\03AC')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111320962278399295)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03AF\03BF\03B4\03BF\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111402102429399354)
,p_name=>'REPORT_LABEL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03C6\03BF\03C1\03AC: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111321663902399296)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BD\03BF\03BB\03BF \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111270869218399259)
,p_name=>'RESET'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C3\03B5\03BB\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111296769075399277)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC \03C3\03B5\03BB\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111325733804399299)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC \03BA\03C9\03B4\03B9\03BA\03BF\03CD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111302594377399282)
,p_name=>'RESTORE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B1\03BD\03B1\03C6\03BF\03C1\03AC')
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111334452973399305)
,p_name=>'RESULTS'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03C4\03B5\03BB\03AD\03C3\03BC\03B1\03C4\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111326855901399299)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03C3\03C4\03C1\03AD\03C8\03C4\03B5 \03C3\03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111327169409399300)
,p_name=>'RIGHT'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BE\03B9\03AC')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111356728502399321)
,p_name=>'ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03B5\03B9\03C1\03AC %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111310721652399288)
,p_name=>'ROW_COUNT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C1\03B9\03B8\03BC\03CC\03C2 \03C3\03B5\03B9\03C1\03CE\03BD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111326225106399299)
,p_name=>'SAVE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111322811701399297)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B1\03BB\03BB\03B1\03BA\03C4\03B9\03BA\03AE \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111323227761399297)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B5\03C1\03B9\03B3\03C1\03B1\03C6\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111322738669399296)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03CD\03C1\03B9\03B1 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111323513602399297)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B5\03C2 \03C3\03B5\03B9\03C1\03AD\03C2 \03B5\03AF\03BD\03B1\03B9 \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B5\03C2 \03B1\03C0\03CC %0. \0391\03C5\03BE\03AE\03C3\03C4\03B5 \03C4\03BF\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03B1 \03C3\03B5\03B9\03C1\03CE\03BD \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111388938485399344)
,p_name=>'SEARCH'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03B1\03B6\03AE\03C4\03B7\03C3\03B7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111284154776399268)
,p_name=>'SECONDS'
,p_message_language=>'el'
,p_message_text=>unistr('\03B4\03B5\03C5\03C4\03B5\03C1\03CC\03BB\03B5\03C0\03C4\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111322365469399296)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03AF\03C4\03B5 \03C4\03BF \03C3\03C5\03BD\03B7\03BC\03BC\03AD\03BD\03BF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111380072206399338)
,p_name=>'SELECT_ROW'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AE \03C3\03B5\03B9\03C1\03AC\03C2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111322039203399296)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B1\03BD\03AC\03B3\03BD\03C9\03C3\03B7\03C2 \03BF\03B8\03CC\03BD\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111322144741399296)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B1\03BD\03AC\03B3\03BD\03C9\03C3\03B7\03C2 \03BF\03B8\03CC\03BD\03B7\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111318413242399293)
,p_name=>'SHOW'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111381899493399339)
,p_name=>'SHOW_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03CC\03BB\03C9\03BD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111407958653399359)
,p_name=>'SIGN_IN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BD\03B4\03B5\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111357515131399322)
,p_name=>'SIGN_OUT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03BF\03C3\03CD\03BD\03B4\03B5\03C3\03B7')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111311704061399288)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B7\03BC\03AD\03C1\03B5\03C2 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111318956218399294)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B7\03BC\03AD\03C1\03B5\03C2 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111311629060399288)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CE\03C1\03B5\03C2 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111318893789399293)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03CE\03C1\03B5\03C2 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111311564645399288)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BB\03B5\03C0\03C4\03AC \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111318791402399293)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BB\03B5\03C0\03C4\03AC \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111311953416399289)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AE\03BD\03B5\03C2 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111319150057399294)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03BC\03AE\03BD\03B5\03C2 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111319378749399294)
,p_name=>'SINCE_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03CE\03C1\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111311403867399288)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B4\03B5\03C5\03C4\03B5\03C1\03CC\03BB\03B5\03C0\03C4\03B1 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111318660848399293)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B4\03B5\03C5\03C4\03B5\03C1\03CC\03BB\03B5\03C0\03C4\03B1 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111311822941399288)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111319043976399294)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111312057169399289)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03AD\03C4\03B7 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111319298174399294)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'el'
,p_message_text=>unistr('%0 \03AD\03C4\03B7 \03C0\03C1\03B9\03BD')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111305551502399284)
,p_name=>'STANDARD'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03C5\03C0\03B9\03BA\03AE')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111321960211399296)
,p_name=>'START_DATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1 \03AD\03BD\03B1\03C1\03BE\03B7\03C2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111262480425399253)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03B1\03BC\03B2\03AC\03BD\03B5\03C4\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03BC\03AE\03BD\03C5\03BC\03B1 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5 \03B1\03C0\03CC \03C4\03B7 \03C3\03C5\03BD\03B4\03C1\03BF\03BC\03AE \03B4\03B9\03B1\03B4\03C1\03B1\03C3\03C4\03B9\03BA\03AE\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 \03C0\03BF\03C5 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03B8\03B7\03BA\03B5 \03B1\03C0\03CC %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111417133827399365)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C5\03BD\03B4\03C1\03BF\03BC\03AD\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111365278993399327)
,p_name=>'TAB'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03C1\03C4\03AD\03BB\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111284013721399268)
,p_name=>'TITLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03AF\03C4\03BB\03BF\03C2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111267068809399256)
,p_name=>'TODAY'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03AE\03BC\03B5\03C1\03B1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111321572726399296)
,p_name=>'TOTAL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BD\03BF\03BB\03BF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111268064632399257)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03B5\03C0\03B9\03BB\03B5\03B3\03BF\03CD\03BD \03AD\03C9\03C2 %0 \03C3\03C4\03AE\03BB\03B5\03C2.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111246524030399241)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BC\03C0\03C4\03C5\03BE\03B7 \03CC\03BB\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111246897179399241)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03CD\03BC\03C0\03C4\03C5\03BE\03B7 \03CC\03BB\03C9\03BD \03BA\03AC\03C4\03C9 \03B1\03C0\03CC')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111246479992399241)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03AC\03C0\03C4\03C5\03BE\03B7 \03CC\03BB\03C9\03BD')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111246602217399241)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD\03AC\03C0\03C4\03C5\03BE\03B7 \03CC\03BB\03C9\03BD \03C4\03C9\03BD \03C0\03B1\03C1\03B1\03BA\03AC\03C4\03C9')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111246996223399241)
,p_name=>'TREE.REPARENT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BB\03BB\03B1\03B3\03AE \03B3\03BF\03BD\03AD\03B1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111339155602399308)
,p_name=>'TREES'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD\03B4\03C1\03B9\03BA\03AD\03C2 \03B4\03BF\03BC\03AD\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111382658883399340)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111306237786399284)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C9\03C1\03AF\03C2 \03B5\03BE\03BF\03C5\03C3\03B9\03BF\03B4\03CC\03C4\03B7\03C3\03B7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111353095616399318)
,p_name=>'UNAVAILABLE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03BF')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111319711299399294)
,p_name=>'UNKNOWN'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03B3\03BD\03C9\03C3\03C4\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111263317558399253)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03AD\03BD\03B1 \03AC\03B3\03BD\03C9\03C3\03C4\03BF \03C3\03C6\03AC\03BB\03BC\03B1 \03C4\03B1\03C5\03C4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111265373046399255)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD \03B4\03B5\03BD \03B8\03AD\03BB\03B5\03C4\03B5 \03C0\03BB\03AD\03BF\03BD \03BD\03B1 \03BB\03B1\03BC\03B2\03AC\03BD\03B5\03C4\03B5 \03BC\03B7\03BD\03CD\03BC\03B1\03C4\03B1 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5, \03BA\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE <a href="%0">\039A\03B1\03C4\03AC\03C1\03B3\03B7\03C3\03B7 \03C3\03C5\03BD\03B4\03C1\03BF\03BC\03AE\03C2</a> \03B3\03B9\03B1 \03BD\03B1 \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03B5\03AF\03C4\03B5 \03C4\03B7 \03C3\03C5\03BD\03B4\03C1\03BF\03BC\03AE \03C3\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111262341309399253)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03BD \03B4\03B5\03BD \03B8\03AD\03BB\03B5\03C4\03B5 \03C0\03BB\03AD\03BF\03BD \03BD\03B1 \03BB\03B1\03BC\03B2\03AC\03BD\03B5\03C4\03B5 \03BC\03B7\03BD\03CD\03BC\03B1\03C4\03B1 \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5, \03BC\03B5\03C4\03B1\03B2\03B5\03AF\03C4\03B5 \03C3\03C4\03B7\03BD \03B1\03BA\03CC\03BB\03BF\03C5\03B8\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2 \03B3\03B9\03B1 \03BD\03B1 \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03B5\03AF\03C4\03B5 \03C4\03B7 \03C3\03C5\03BD\03B4\03C1\03BF\03BC\03AE \03C3\03B1\03C2:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111297294394399278)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\03BC\03B7 \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03B9\03B6\03CC\03BC\03B5\03BD\03BF\03C2 \03C4\03CD\03C0\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111285367783399269)
,p_name=>'UPDATE'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03BD\03B7\03BC\03AD\03C1\03C9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111283916004399268)
,p_name=>'UPDATED'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03B7\03BC\03B5\03C1\03CE\03B8\03B7\03BA\03B5')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111290607964399273)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B6\03B7\03C4\03BF\03CD\03BC\03B5\03BD\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2 \03B5\03AF\03BD\03B1\03B9 \03B1\03C0\03B1\03B3\03BF\03C1\03B5\03C5\03BC\03AD\03BD\03B7. \0395\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111310660498399287)
,p_name=>'USER'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03AE\03C3\03C4\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111332288541399303)
,p_name=>'USERNAME'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BD\03BF\03BC\03B1 \03C7\03C1\03AE\03C3\03C4\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111371838835399332)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03CC\03BD\03BF\03BC\03B1 \03C7\03C1\03AE\03C3\03C4\03B7 \03B5\03AF\03BD\03B1\03B9 \03C0\03BF\03BB\03CD \03BC\03B5\03B3\03AC\03BB\03BF. \03A4\03BF \03CC\03C1\03B9\03BF \03B5\03AF\03BD\03B1\03B9 %0 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111317477882399292)
,p_name=>'USERS'
,p_message_language=>'el'
,p_message_text=>unistr('\03C7\03C1\03AE\03C3\03C4\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111371413672399332)
,p_name=>'USER_EXISTS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03CC\03BD\03BF\03BC\03B1 \03C7\03C1\03AE\03C3\03C4\03B7 \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03AE\03B4\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111386180067399342)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03B9\03BA\03CC\03BD\03B1 \03C0\03C1\03BF\03C6\03AF\03BB \03B3\03B9\03B1 \03C4\03BF\03BD \03C7\03C1\03AE\03C3\03C4\03B7 %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111273740288399261)
,p_name=>'VALID'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03B3\03BA\03C5\03C1\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111267350442399256)
,p_name=>'VALIDATIONS'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BA\03C5\03C1\03CE\03C3\03B5\03B9\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111323061843399297)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03B9\03BC\03AE\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111366437270399328)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03B9\03BC\03AE\03C2 \03B3\03B9\03B1 \03C4\03BF %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111292928429399275)
,p_name=>'VERTICAL'
,p_message_language=>'el'
,p_message_text=>unistr('\03BA\03B1\03C4\03B1\03BA\03CC\03C1\03C5\03C6\03B7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111285272023399269)
,p_name=>'VIEW'
,p_message_language=>'el'
,p_message_text=>unistr('\03C0\03C1\03BF\03B2\03BF\03BB\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111317576564399293)
,p_name=>'VIEWS'
,p_message_language=>'el'
,p_message_text=>unistr('\03C0\03C1\03BF\03B2\03BF\03BB\03AD\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111323821687399297)
,p_name=>'VIEW_ALL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B2\03BF\03BB\03AE \03CC\03BB\03C9\03BD')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111305021730399283)
,p_name=>'WARNING'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111284827889399269)
,p_name=>'WEEK'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111281804600399267)
,p_name=>'WEEKLY'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03AC\03B8\03B5 \03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111284996725399269)
,p_name=>'WEEKS'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03B2\03B4\03BF\03BC\03AC\03B4\03B5\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111323154746399297)
,p_name=>'WELCOME_USER'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03B1\03BB\03C9\03C3\03BF\03C1\03AF\03C3\03B1\03C4\03B5: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111321355979399295)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03C4\03BF\03C0\03AF\03C3\03C4\03B7\03BA\03B5 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C4\03B9\03BC\03AE. \0395\03C0\03B1\03BB\03B7\03B8\03B5\03CD\03C3\03C4\03B5 \03C4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03C0\03BF\03C5 \03B5\03B9\03C3\03B1\03B3\03AC\03B3\03B1\03C4\03B5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111321406535399295)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03C4\03BF\03C0\03AF\03C3\03C4\03B7\03BA\03B5 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C4\03B9\03BC\03AE. \0395\03C0\03B1\03BB\03B7\03B8\03B5\03CD\03C3\03C4\03B5 \03C4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03C0\03BF\03C5 \03B5\03B9\03C3\03B1\03B3\03AC\03B3\03B1\03C4\03B5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111264487753399254)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03C4\03BF\03C0\03AF\03C3\03C4\03B7\03BA\03B5 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C4\03B9\03BC\03AE \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1\03C2. \0395\03C0\03B1\03BB\03B7\03B8\03B5\03CD\03C3\03C4\03B5 \03C4\03B7 \03BC\03BF\03C1\03C6\03AE \03B7\03BC\03B5\03C1\03BF\03BC\03B7\03BD\03AF\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111321290703399295)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03C4\03BF\03C0\03AF\03C3\03C4\03B7\03BA\03B5 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03B1\03C1\03B9\03B8\03BC\03B7\03C4\03B9\03BA\03AE \03C4\03B9\03BC\03AE. \0395\03C0\03B1\03BB\03B7\03B8\03B5\03CD\03C3\03C4\03B5 \03C4\03B7 \03BC\03BF\03C1\03C6\03AE \03B1\03C1\03B9\03B8\03BC\03B7\03C4\03B9\03BA\03CE\03BD \03C4\03B9\03BC\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111273306404399261)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BD\03C4\03BF\03C0\03AF\03C3\03C4\03B7\03BA\03B5 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C4\03B9\03BC\03AE \03C7\03C1\03BF\03BD\03BF\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2. \0395\03C0\03B1\03BB\03B7\03B8\03B5\03CD\03C3\03C4\03B5 \03C4\03B7 \03BC\03BF\03C1\03C6\03AE \03C7\03C1\03BF\03BD\03BF\03C3\03AE\03BC\03B1\03BD\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111295825103399277)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B4\03AD\03C3\03BC\03B5\03C5\03C3\03B7 \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 "%0". \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03B4\03B9\03C0\03BB\03AC \03B5\03B9\03C3\03B1\03B3\03C9\03B3\03B9\03BA\03AC \03B3\03B9\03B1 \03C4\03B1 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03B1 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03CE\03BD byte, \03B4\03B9\03B1\03C6\03BF\03C1\03B5\03C4\03B9\03BA\03AC \03B2\03B5\03B2\03B1\03B9\03C9\03B8\03B5\03AF\03C4\03B5 \03CC\03C4\03B9 \03C4\03BF \03BC\03AE\03BA\03BF\03C2 \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 \03B5\03AF\03BD\03B1\03B9 30 byte \03AE \03BB\03B9\03B3\03CC\03C4\03B5\03C1\03BF. \03A7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C3\03CD\03BD\03C4\03B1\03BE\03B7 v() \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03B1\03C1\03B1\03C0\03BF\03BC\03C0\03AE \03C3\03B5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03B1 \03C0\03BF\03C5 ')
||unistr('\03C5\03C0\03B5\03C1\03B2\03B1\03AF\03BD\03BF\03C5\03BD \03C4\03B1 30 byte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111286389527399270)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B3\03CC\03C1\03B5\03C5\03C3\03B7 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03B1\03C0\03CC \03C4\03BF\03BD \03AD\03BB\03B5\03B3\03C7\03BF \03B1\03C3\03C6\03AC\03BB\03B5\03B9\03B1\03C2 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111288857556399272)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111287292798399271)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-1014 \0397 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03B4\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111287337251399271)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE=%0  \03C7\03CE\03C1\03BF\03C2 \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111287778239399271)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A5\03C0\03AC\03C1\03C7\03B5\03B9 \03C0\03B5\03C1\03B9\03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C3\03B5 \03B1\03C5\03C4\03AE\03BD \03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE. \03A0\03C1\03BF\03C3\03C0\03B1\03B8\03AE\03C3\03C4\03B5 \03BE\03B1\03BD\03AC \03B1\03C1\03B3\03CC\03C4\03B5\03C1\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111287649615399271)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03C3\03B5 \03B1\03C5\03C4\03AE\03BD \03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03B5\03C0\03B9\03C4\03C1\03AD\03C0\03B5\03C4\03B1\03B9 \03BC\03CC\03BD\03BF \03C3\03C4\03BF\03C5\03C2 \03C0\03C1\03BF\03B3\03C1\03B1\03BC\03BC\03B1\03C4\03B9\03C3\03C4\03AD\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03CE\03BD. \03A0\03C1\03BF\03C3\03C0\03B1\03B8\03AE\03C3\03C4\03B5 \03BE\03B1\03BD\03AC \03B1\03C1\03B3\03CC\03C4\03B5\03C1\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111286864411399270)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-7744 \0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03B5\03C0\03B9\03C3\03C4\03C1\03B5\03C6\03CC\03BC\03B5\03BD\03B7\03C2 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7\03C2 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2 \03B3\03B9\03B1 \03C4\03B7 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 \03B4\03B9\03B1\03BA\03BB\03AC\03B4\03C9\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111286772234399270)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-7744 \0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03B5\03C0\03B9\03C3\03C4\03C1\03B5\03C6\03CC\03BC\03B5\03BD\03B7\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2 \03B3\03B9\03B1 \03C4\03B7 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 \03B4\03B9\03B1\03BA\03BB\03AC\03B4\03C9\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111287002623399270)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-1430 \0397 \03BA\03BB\03AE\03C3\03B7 \03B3\03B9\03B1 \03C4\03B7 \03B4\03B9\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7\03C2 \03B1\03C0\03CC \03C3\03B5\03BB\03AF\03B4\03B1 \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111288184402399271)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-1018 \03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03BA\03BA\03B1\03B8\03AC\03C1\03B9\03C3\03B7 \03C4\03B7\03C2 \03C0\03C1\03BF\03C3\03C9\03C1\03B9\03BD\03AE\03C2 \03BC\03BD\03AE\03BC\03B7\03C2 \03B2\03AE\03BC\03B1\03C4\03BF\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111286528508399270)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-1005 \0386\03B3\03BD\03C9\03C3\03C4\03BF\03C2 \03C4\03CD\03C0\03BF\03C2 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111287444410399271)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-1201 \03A4\03BF \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C0\03B5\03C1\03B9\03CC\03B4\03BF\03C5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03C3\03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03C3\03BC\03AD\03BD\03B7 \03C4\03B1\03C5\03C4\03BF\03C0\03BF\03AF\03B7\03C3\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111287505684399271)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03B5\03BB\03AF\03B4\03B1=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111287188541399270)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-7620 \0394\03B5\03BD \03AE\03C4\03B1\03BD \03B4\03C5\03BD\03B1\03C4\03CC\03C2 \03BF \03C0\03C1\03BF\03C3\03B4\03B9\03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03BF\03C5 \03C7\03CE\03C1\03BF\03C5 \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 \03B3\03B9\03B1 \03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111269500593399258)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111286279014399270)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-1802 \0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03CD\03C1\03B5\03C3\03B7 \03C4\03BF\03C5 \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03BF\03CD \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111285906214399270)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-1002 \0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03CD\03C1\03B5\03C3\03B7 \03C4\03BF\03C5 \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03BF\03CD \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 \03B3\03B9\03B1 \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF "%0" \03C3\03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111286014446399270)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03B1\03BD\03B1\03BC\03B5\03BD\03CC\03BC\03B5\03BD\03BF \03C3\03C6\03AC\03BB\03BC\03B1. \0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03CD\03C1\03B5\03C3\03B7 \03C4\03BF\03C5 \03BF\03BD\03CC\03BC\03B1\03C4\03BF\03C2 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 \03C3\03C4\03BF \03B5\03C0\03AF\03C0\03B5\03B4\03BF \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03AE \03C3\03B5\03BB\03AF\03B4\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111286403393399270)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03C1\03AF\03C3\03BA\03B5\03C3\03C4\03B5 \03AE\03B4\03B7 \03C3\03C4\03B7\03BD \03C0\03C1\03CE\03C4\03B7 \03C3\03B5\03BB\03AF\03B4\03B1 \03C4\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111301929971399281)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 (%0) \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03BD\03B1 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C0\03BF\03C5 \03BF\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03C3\03C4\03B7\03BD \03C4\03C1\03AD\03C7\03BF\03C5\03C3\03B1 \03C3\03B5\03BB\03AF\03B4\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111264094014399254)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03BC\03B7\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03C1\03CD\03B8\03BC\03B9\03C3\03B7 \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 \03BC\03B5 \03C4\03B7 \03B4\03B9\03B1\03B2\03AF\03B2\03B1\03C3\03B7 \03BF\03C1\03B9\03C3\03BC\03AC\03C4\03C9\03BD \03C3\03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111264399703399254)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'el'
,p_message_text=>unistr('(\0394\03B5\03BD \03C0\03B1\03C1\03B1\03C3\03C7\03AD\03B8\03B7\03BA\03B5 \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111263882941399254)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C1\03C5\03B8\03BC\03B9\03C3\03C4\03B5\03AF \03CC\03C4\03B1\03BD \03C3\03C5\03BD\03BF\03B4\03B5\03CD\03B5\03C4\03B1\03B9 \03B1\03C0\03CC \03AD\03BD\03B1 \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C3\03B5\03BB\03B9\03B4\03BF\03B4\03B5\03AF\03BA\03C4\03B7 \03B5\03C0\03B9\03C0\03AD\03B4\03BF\03C5 \03C7\03C1\03AE\03C3\03C4\03B7 ("user-level bookmark").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111263755841399254)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C1\03C5\03B8\03BC\03B9\03C3\03C4\03B5\03AF \03CC\03C4\03B1\03BD \03C3\03C5\03BD\03BF\03B4\03B5\03CD\03B5\03C4\03B1\03B9 \03B1\03C0\03CC \03AD\03BD\03B1 \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C3\03B5\03BB\03B9\03B4\03BF\03B4\03B5\03AF\03BA\03C4\03B7 \03B5\03C0\03B9\03C0\03AD\03B4\03BF\03C5 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 ("application-level bookmark").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111263957180399254)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C1\03C5\03B8\03BC\03B9\03C3\03C4\03B5\03AF \03CC\03C4\03B1\03BD \03C3\03C5\03BD\03BF\03B4\03B5\03CD\03B5\03C4\03B1\03B9 \03B1\03C0\03CC \03AD\03BD\03B1 \03AC\03B8\03C1\03BF\03B9\03C3\03BC\03B1 \03B5\03BB\03AD\03B3\03C7\03BF\03C5 \03C0\03B5\03C1\03B9\03CC\03B4\03BF\03C5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 ("session").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111263650372399254)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03C0\03C1\03BF\03C3\03C4\03B1\03C3\03AF\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111288288771399271)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03B7 \03B2\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03C4\03B7 \03C3\03B5\03BB\03AF\03B4\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111277352259399263)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C7\03CE\03C1\03BF\03C2 \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 %0 \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03C4\03B1 \03BA\03B1\03C4\03AC\03BB\03BB\03B7\03BB\03B1 \03B4\03B9\03BA\03B1\03B9\03CE\03BC\03B1\03C4\03B1 \03B3\03B9\03B1 \03BD\03B1 \03B1\03BD\03B1\03BB\03C5\03B8\03B5\03AF \03C9\03C2 \03C3\03C7\03AE\03BC\03B1 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111286630139399270)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-1010 \0388\03B3\03B9\03BD\03B5 \03C5\03C0\03AD\03C1\03B2\03B1\03C3\03B7 \03C4\03BF\03C5 \03B1\03C0\03BF\03B4\03B5\03BA\03C4\03BF\03CD \03BF\03C1\03AF\03BF\03C5 \03B5\03C0\03B1\03BD\03AC\03BB\03B7\03C8\03B7\03C2 \03B3\03B9\03B1 \0394\03B9\03B1\03BA\03BB\03AC\03B4\03C9\03C3\03B7 \03C3\03B5 \03C3\03B5\03BB\03AF\03B4\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111264242448399254)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03AE \03B7 \03C3\03B5\03BB\03AF\03B4\03B1 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03BA\03BB\03B7\03B8\03B5\03AF \03BC\03B5 \03C4\03B7 \03C7\03C1\03AE\03C3\03B7 \03BC\03B9\03B1\03C2 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7\03C2 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2 \03AE \03BC\03B9\03B1\03C2 \03BC\03B5\03B8\03CC\03B4\03BF\03C5 GET \03AE POST \03B3\03B9\03B1 \03C4\03B7\03BD \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03C4\03B7\03C2 \03B4\03B9\03B1\03B4\03B9\03BA\03B1\03C3\03AF\03B1\03C2. \03A0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03BA\03BB\03B7\03B8\03B5\03AF \03BC\03B5 \03AD\03BD\03B1\03BD \03C4\03CD\03C0\03BF \03BA\03BB\03AC\03B4\03BF\03C5 "\0394\03B9\03B1\03BA\03BB\03AC\03B4\03C9\03C3\03B7 \03C3\03B5 \03C3\03B5\03BB\03AF\03B4\03B1" (Branch to Page).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111340929762399310)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03C0\03AC\03B8\03B5\03B9\03B1 \03B1\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7\03C2 \03BC\03B7 \03B1\03C1\03B9\03B8\03BC\03B7\03C4\03B9\03BA\03AE\03C2 \03C4\03B9\03BC\03AE\03C2 \03C3\03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111279096970399265)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C7\03AE\03BC\03B1 \03B1\03BD\03AC\03BB\03C5\03C3\03B7\03C2 "%0" \03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03C3\03C4\03B7 \03B2\03AC\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111279134411399265)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03B9 \03BB\03BF\03B3\03B1\03C1\03B9\03B1\03C3\03BC\03BF\03AF \03C3\03C4\03BF\03BD \03B5\03C3\03C9\03C4\03B5\03C1\03B9\03BA\03CC (INTERNAL) \03C7\03CE\03C1\03BF \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 \03BC\03C0\03BF\03C1\03BF\03CD\03BD \03BD\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B7\03B8\03BF\03CD\03BD \03BC\03CC\03BD\03BF \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 \03C3\03C4\03B9\03C2 <a href="%0">\03A5\03C0\03B7\03C1\03B5\03C3\03AF\03B5\03C2 \03B4\03B9\03B1\03C7\03B5\03AF\03C1\03B9\03C3\03B7\03C2</a> \03C4\03BF\03C5 &PRODUCT_NAME..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111285883949399270)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-1029 \0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B1\03C0\03BF\03B8\03AE\03BA\03B5\03C5\03C3\03B7 \03C4\03C9\03BD \03C0\03BB\03B7\03C1\03BF\03C6\03BF\03C1\03B9\03CE\03BD \03C0\03B5\03C1\03B9\03CC\03B4\03BF\03C5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2. session=%0 item=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111288976584399272)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B4\03B9\03B1\03BA\03BF\03C0\03AE \03C4\03B7\03C2 \03B9\03C7\03BD\03B7\03BB\03B1\03C3\03AF\03B1\03C2: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111286169110399270)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03B1\03BD\03B1\03BC\03B5\03BD\03CC\03BC\03B5\03BD\03BF \03C3\03C6\03AC\03BB\03BC\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111296101885399277)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03C3\03C4\03BF update_substitution_cache: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111289071935399272)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03BF\03B2\03BF\03BB\03AE \03C4\03B7\03C2 \03B2\03BF\03AE\03B8\03B5\03B9\03B1\03C2, \03B1\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03B7 \03C0\03B1\03C1\03BF\03C7\03AE \03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03BA\03B1\03B9 \03C4\03B7\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111309597645399287)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5 \03B1\03C5\03C4\03BF\03BC\03B1\03C4\03BF\03C0\03BF\03AF\03B7\03C3\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111290188668399273)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03B3\03B9\03BD\03B5 \03B5\03BA\03BA\03B1\03B8\03AC\03C1\03B9\03C3\03B7 %0 \03C0\03B5\03C1\03B9\03CC\03B4\03C9\03BD \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111249495389399243)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03BA\03C4\03AD\03BB\03B5\03C3\03B7 \03C4\03BF\03C5 \03BA\03CE\03B4\03B9\03BA\03B1 %0. \0395\03AF\03C4\03B5 \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03B1\03C0\03CC \03C4\03B7 \03B2\03AC\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD, \03B5\03AF\03C4\03B5 \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03B5\03BD\03B5\03C1\03B3\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF \03B1\03C0\03CC \03C4\03B7\03BD \03C0\03B1\03C1\03AC\03BC\03B5\03C4\03C1\03BF \03C3\03C4\03B9\03B3\03BC\03B9\03BF\03C4\03CD\03C0\03BF\03C5 MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111249210381399243)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF Multi Lingual Engine \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03BF \03C3\03B5 \03B1\03C5\03C4\03AE \03C4\03B7\03BD \03AD\03BA\03B4\03BF\03C3\03B7 \03C4\03B7\03C2 \03B2\03AC\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111270046220399258)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B4\03B9\03AC\03C4\03B1\03BE\03B7 \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C5\03BB\03BB\03BF\03B3\03AE\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03B4\03B5\03BD \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111269876604399258)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03BF\03C2 \03B1\03C1\03B9\03B8\03BC\03CC\03C2 \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03BF\03CD \03BC\03AD\03BB\03BF\03C5\03C2 %0 \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03BF\03C2. \039F \03B1\03C1\03B9\03B8\03BC\03CC\03C2 \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03BF\03CD \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03BC\03B5\03C4\03B1\03BE\03CD 1 \03BA\03B1\03B9 %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111270325597399258)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C3\03C5\03BB\03BB\03BF\03B3\03AE \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03C5\03C0\03AC\03C1\03C7\03B5\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111270179852399258)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03CC\03BD\03BF\03BC\03B1 \03C3\03C5\03BB\03BB\03BF\03B3\03AE\03C2 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 null')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111270272799399258)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03CC\03BD\03BF\03BC\03B1 \03C3\03C5\03BB\03BB\03BF\03B3\03AE\03C2 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C5\03C0\03B5\03C1\03B2\03B1\03AF\03BD\03B5\03B9 \03C4\03BF\03C5\03C2 255 \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B5\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111269680722399258)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C3\03C5\03BB\03BB\03BF\03B3\03AE \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111270464448399258)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03B4\03C1\03BF\03BC\03AD\03B1\03C2 \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03B1\03BD\03BF\03AF\03BE\03B5\03B9 \03B1\03BA\03CC\03BC\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111269735370399258)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0397 \03B1\03BA\03BF\03BB\03BF\03C5\03B8\03AF\03B1 \03BC\03B5\03BB\03CE\03BD %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03C3\03C4\03B7 \03C3\03C5\03BB\03BB\03BF\03B3\03AE \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111269946740399258)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0397 \03B1\03BA\03BF\03BB\03BF\03C5\03B8\03AF\03B1 \03BC\03B5\03BB\03CE\03BD %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03C3\03C4\03B7 \03C3\03C5\03BB\03BB\03BF\03B3\03AE \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 "%1"'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111341718003399310)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 \03BA\03C1\03C5\03C0\03C4\03BF\03B3\03C1\03AC\03C6\03B7\03C3\03B7\03C2 "%0" \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03C3\03B5 \03B1\03C5\03C4\03CC \03C4\03BF \03C3\03CD\03C3\03C4\03B7\03BC\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111395251574399349)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03BF\03BA\03B9\03BC\03AC\03C3\03C4\03B7\03BA\03B5 \03B7 \03C0\03C1\03BF\03C3\03B2\03B1\03C3\03B9\03BC\03CC\03C4\03B7\03C4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111289675880399272)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03BB\03B5\03AF\03C3\03B9\03BC\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111289797058399272)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03BF\03B3\03AD\03C2 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03C3\03B5\03BB\03AF\03B4\03B1\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111289847910399272)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03BF\03B5\03C0\03B9\03BB\03BF\03B3\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111289953604399273)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111290024624399273)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03CC\03BA\03C1\03C5\03C8\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111289491500399272)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03C4\03B9\03C2 \03C0\03B5\03C1\03B9\03BF\03C7\03AD\03C2 \03C0\03BF\03C5 \03B8\03AD\03BB\03B5\03C4\03B5 \03BD\03B1 \03C3\03C5\03BC\03C0\03B5\03C1\03B9\03BB\03B7\03C6\03B8\03BF\03CD\03BD \03C3\03B5 \03B1\03C5\03C4\03AE\03BD \03C4\03B7 \03C3\03B5\03BB\03AF\03B4\03B1. \039F\03B9 \03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B5\03C2 \03C0\03B5\03C1\03B9\03BF\03C7\03AD\03C2 \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03BC\03B7\03BD \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9, \03B5\03AC\03BD \03B4\03B5\03BD \03B2\03C1\03AF\03C3\03BA\03B5\03C3\03C4\03B5 \03C3\03C4\03BF \03BA\03B1\03C4\03AC\03BB\03BB\03B7\03BB\03BF \03C0\03B5\03C1\03B9\03B2\03AC\03BB\03BB\03BF\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03AE \03B4\03B5\03BD \03AD\03C7\03B5\03C4\03B5 \03C4\03B1 \03BA\03B1\03C4\03AC\03BB\03BB\03B7\03BB\03B1 \03B4\03B9\03BA\03B1\03B9\03CE\03BC\03B1\03C4\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111289508485399272)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03AE \03B7 \03C3\03B5\03BB\03AF\03B4\03B1 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C0\03C1\03BF\03C3\03B1\03C1\03BC\03BF\03C3\03C4\03B5\03AF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111395542965399349)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03C0\03BF\03C1\03B5\03AF\03C4\03B5 \03BD\03B1 \03B5\03BE\03B1\03C4\03BF\03BC\03B9\03BA\03B5\03CD\03C3\03B5\03C4\03B5 \03C4\03B7\03BD \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03B1\03C5\03C4\03AE\03C2 \03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2 \03B1\03BB\03BB\03AC\03B6\03BF\03BD\03C4\03B1\03C2 \03C4\03BF \03C3\03C4\03C5\03BB \03B8\03AD\03BC\03B1\03C4\03BF\03C2. \0395\03C0\03B9\03BB\03AD\03BE\03C4\03B5 \03AD\03BD\03B1 \03C3\03C4\03C5\03BB \03B8\03AD\03BC\03B1\03C4\03BF\03C2 \03B1\03C0\03CC \03C4\03B7 \03BB\03AF\03C3\03C4\03B1 \03C0\03B1\03C1\03B1\03BA\03AC\03C4\03C9 \03BA\03B1\03B9 \03BA\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \0395\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03B1\03BB\03BB\03B1\03B3\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111396399141399350)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03C0\03B5\03C1\03B9\03BF\03C7\03AE\03C2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111395497502399349)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A7\03C1\03AE\03C3\03B7 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03BF\03C5 \03C3\03C4\03C5\03BB \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111395376141399349)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BC\03C6\03AC\03BD\03B9\03C3\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111338399557399308)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03B4\03B5\03AF\03BA\03C4\03B7\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03C0\03BF\03C5 \03B1\03BD\03B1\03C6\03AD\03C1\03B5\03C4\03B1\03B9 \03C3\03C4\03B7 \03C3\03C5\03BD\03AC\03B8\03C1\03BF\03B9\03C3\03B7 %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111241601581399238)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03AD\03BE\03BF\03B4\03BF\03C2 CLOB \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03B7 \03BC\03BF\03C1\03C6\03AE %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111338032586399307)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03BF\03BC\03AE \03C3\03C4\03B7\03BB\03CE\03BD \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B2\03C1\03AF\03C3\03BA\03B5\03C4\03B1\03B9 \03C3\03C4\03B7\03BD \03B1\03C1\03C7\03AE \03C4\03B7\03C2 \03B4\03B9\03AC\03C4\03B1\03BE\03B7\03C2 \03C0\03AF\03BD\03B1\03BA\03B1 \03C3\03C4\03B7\03BB\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111338169864399308)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03B4\03B5\03AF\03BA\03C4\03B7\03C2 \03BF\03BC\03AC\03B4\03B1\03C2 \03C3\03C4\03B7\03BB\03CE\03BD \03C0\03BF\03C5 \03B1\03BD\03B1\03C6\03AD\03C1\03B5\03C4\03B1\03B9 \03C3\03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111255634661399248)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'el'
,p_message_text=>unistr('\03B5\03BE\03B1\03B3\03C9\03B3\03AE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111260858993399251)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BC\03BF\03C1\03C6\03AE \03B5\03BE\03B1\03B3\03C9\03B3\03AE\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 XML \03BC\03B5 \03C7\03C1\03AE\03C3\03B7 \03C4\03BF\03C5 ORDS \03C9\03C2 server \03B5\03BA\03C4\03C5\03C0\03CE\03C3\03B5\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111338404965399308)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03B4\03B5\03AF\03BA\03C4\03B7\03C2 \03C3\03C4\03AE\03BB\03B7\03C2 \03C0\03BF\03C5 \03B1\03BD\03B1\03C6\03AD\03C1\03B5\03C4\03B1\03B9 \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03C3\03AE\03BC\03B1\03BD\03C3\03B7 %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111254131327399247)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03BC\03BF\03C1\03C6\03AE \03B5\03BE\03B1\03B3\03C9\03B3\03AE\03C2: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111338294656399308)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03B4\03B5\03AF\03BA\03C4\03B7\03C2 \03B3\03BF\03BD\03B9\03BA\03AE\03C2 \03BF\03BC\03AC\03B4\03B1\03C2 \03C0\03BF\03C5 \03B1\03BD\03B1\03C6\03AD\03C1\03B5\03C4\03B1\03B9 \03C3\03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF %0 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111363410145399326)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C3\03C4\03AE\03BB\03B7 %1 \03C4\03BF\03C5 \03C0\03AF\03BD\03B1\03BA\03B1 %0 \03B5\03AF\03BD\03B1\03B9 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CE\03BD "GENERATED ALWAYS". \0392\03B5\03B2\03B1\03B9\03C9\03B8\03B5\03AF\03C4\03B5 \03CC\03C4\03B9 \03BA\03B1\03BC\03AF\03B1 \03C3\03C4\03AE\03BB\03B7 \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7\03C2 \03B4\03B5\03BD \03B1\03BD\03C4\03B9\03C3\03C4\03BF\03B9\03C7\03AF\03B6\03B5\03C4\03B1\03B9 \03C3\03C4\03B7 \03C3\03C4\03AE\03BB\03B7 %1 \03C3\03C4\03BF \03C0\03BB\03B1\03AF\03C3\03B9\03BF \03B4\03B9\03B1\03BB\03CC\03B3\03BF\03C5 \0394\03B9\03B1\03BC\03CC\03C1\03C6\03C9\03C3\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111280882931399266)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03BF \03B4\03B9\03AC\03C3\03C4\03B7\03BC\03B1 \03B4\03AD\03C3\03BC\03B5\03C5\03C3\03B7\03C2 \03B5\03AF\03BD\03B1\03B9 \03C0\03BF\03BB\03CD \03BC\03B9\03BA\03C1\03CC.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111280940506399266)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03AD\03C7\03BF\03C5\03BD \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03C3\03C4\03AE\03BB\03B5\03C2 \03B3\03B9\03B1 \03C4\03B7 \03C6\03CC\03C1\03C4\03C9\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111282190311399267)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD \03C3\03C4\03AE\03BB\03B5\03C2 \03B3\03B9\03B1 \03C4\03BF\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AD\03B1 \03C3\03C4\03B7\03BB\03CE\03BD "%0". \0394\03BF\03BA\03B9\03BC\03AC\03C3\03C4\03B5 \03C4\03B7\03BD \03B5\03BA\03C4\03AD\03BB\03B5\03C3\03B7 \03B1\03C5\03C4\03CC\03BC\03B1\03C4\03B7\03C2 \03B1\03BD\03AF\03C7\03BD\03B5\03C5\03C3\03B7\03C2 \03AE \03B5\03BE\03B5\03C4\03AC\03C3\03C4\03B5 \03C4\03B7 \03B4\03BF\03BC\03AE JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111290470533399273)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD \03C6\03CD\03BB\03BB\03B1 \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 \03C3\03C4\03BF \03B1\03C1\03C7\03B5\03AF\03BF XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111290322828399273)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03BF \03C6\03CD\03BB\03BB\03BF \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 \03B4\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03C3\03C4\03BF \03B1\03C1\03C7\03B5\03AF\03BF XLSX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111270562078399259)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03C1\03AD\03C7\03BF\03C5\03C3\03B1 \03AD\03BA\03B4\03BF\03C3\03B7 \03C4\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C3\03C4\03B7 \03B2\03AC\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03AD\03C7\03B5\03B9 \03B1\03BB\03BB\03AC\03BE\03B5\03B9 \03BC\03B5\03C4\03AC \03C4\03B7\03BD \03AD\03BD\03B1\03C1\03BE\03B7 \03C4\03B7\03C2 \03B4\03B9\03B1\03B4\03B9\03BA\03B1\03C3\03AF\03B1\03C2 \03B5\03BD\03B7\03BC\03AD\03C1\03C9\03C3\03B7\03C2 \03B1\03C0\03CC \03C4\03BF\03BD \03C7\03C1\03AE\03C3\03C4\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111272921526399260)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03BD\03B7\03BC\03AD\03C1\03C9\03C3\03B7 \03C4\03C9\03BD \03C3\03C4\03B7\03BB\03CE\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111377619893399336)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03BC\03B5\03C4\03B1\03C4\03C1\03BF\03C0\03AE \03C4\03BF\03C5 %0 \03C3\03B5 SDO_GEOMETRY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111317163196399292)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C3\03C4\03AE\03BB\03B7 %0 \03BC\03B5 \03C4\03CD\03C0\03BF \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD %1 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03BC\03B5\03C4\03B1\03C4\03C1\03B1\03C0\03B5\03AF \03C3\03B5 VARCHAR2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111324177806399297)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03B7 \03C3\03C4\03AE\03BB\03B7 "%0" \03B3\03B9\03B1 \03C4\03BF \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03CC "%1" \03B4\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5 \03C3\03C4\03B7\03BD \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111265481616399255)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C4\03CD\03C0\03BF\03C2 \03C6\03AF\03BB\03C4\03C1\03BF\03C5 %0 \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03B3\03B9\03B1 \03C3\03C4\03AE\03BB\03B5\03C2 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03CE\03BD \03C4\03B9\03BC\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111381029323399339)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03BF \03C6\03AF\03BB\03C4\03C1\03BF "\03BC\03B5\03C4\03B1\03BE\03CD".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111247531196399242)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03C1\03AF\03C3\03C4\03B7\03BA\03B5 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03BF\03C2 \03C4\03CD\03C0\03BF\03C2 LOV.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111247405461399242)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03BF\03C2 \03C4\03CD\03C0\03BF\03C2 \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2. \039F \03C4\03CD\03C0\03BF\03C2 \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 \03A0\03AF\03BD\03B1\03BA\03B1\03C2, \0395\03C1\03CE\03C4\03B7\03BC\03B1 SQL \03AE \03A3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 PL/SQL \03C0\03BF\03C5 \03B5\03C0\03B9\03C3\03C4\03C1\03AD\03C6\03B5\03B9 \03B5\03C1\03CE\03C4\03B7\03BC\03B1 SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111317238909399292)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0391\03C0\03AD\03C4\03C5\03C7\03B5 \03B7 \03B1\03BD\03AC\03BB\03C5\03C3\03B7 \03C4\03BF\03C5 \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2 SQL.'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111324220326399298)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03B7 \03B8\03AD\03C3\03B7 \03C3\03C4\03AE\03BB\03B7\03C2 %0 \03B3\03B9\03B1 \03C4\03BF \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03CC "%1" \03B4\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5 \03C3\03C4\03B7\03BD \03C0\03C1\03CC\03C4\03B1\03C3\03B7 SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111246042851399241)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C4\03BF \03C6\03AF\03BB\03C4\03C1\03BF \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03CE\03BD \03C4\03B9\03BC\03CE\03BD \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03BF\03CD\03BD\03C4\03B1\03B9 \03C0\03AC\03C1\03B1 \03C0\03BF\03BB\03BB\03AC \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111324006304399297)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03BA\03B1\03BC\03AF\03B1 \03C3\03C4\03AE\03BB\03B7 \03B3\03B9\03B1 \03C4\03BF \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03CC "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111247362760399242)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03BA\03CD\03C1\03B9\03BF \03BC\03AD\03C1\03BF\03C2 \03C4\03B7\03C2 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7\03C2 PL/SQL \03B4\03B5\03BD \03B5\03C0\03AD\03C3\03C4\03C1\03B5\03C8\03B5 \03BC\03B9\03B1 \03C4\03B9\03BC\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111337206966399307)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD REST \03B4\03B5\03BD \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BC\03B9\03B1 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 \03B3\03B9\03B1 \03C4\03BF\03BD \03C7\03B5\03B9\03C1\03B9\03C3\03BC\03CC \03C4\03B7\03C2 \03B6\03B7\03C4\03BF\03CD\03BC\03B5\03BD\03B7\03C2 \03B5\03BD\03AD\03C1\03B3\03B5\03B9\03B1\03C2 DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111243241958399239)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BC\03B5\03C4\03B1\03C4\03C1\03BF\03C0\03AE \03B1\03C0\03CC GeoJSON \03C3\03B5 SDO_GEOMETRY (\03C3\03C4\03AE\03BB\03B7 %0) \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03C3\03B5 \03B1\03C5\03C4\03AE\03BD \03C4\03B7 \03B2\03AC\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111244326066399240)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BC\03B5\03C4\03B1\03C4\03C1\03BF\03C0\03AE SDO_GEOMETRY (\03C3\03C4\03AE\03BB\03B7 %0) \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03B9\03C2 \03C0\03C1\03BF\03B5\03BB\03B5\03CD\03C3\03B5\03B9\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111251668588399245)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C7\03B1\03C1\03B1\03BA\03C4\03AE\03C1\03B1\03C2 %0 \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03C9\03C2 \03B4\03B9\03B1\03C7\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03CE\03BD \03C4\03B9\03BC\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111378917052399337)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03AE \03B7 \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF \03C3\03B5 \03AD\03BD\03B1 \03C0\03B5\03C1\03B9\03B2\03AC\03BB\03BB\03BF\03BD \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111244427095399240)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C3\03C5\03BC\03C6\03C9\03BD\03AF\03B1 \03C4\03CD\03C0\03BF\03C5 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C3\03C4\03AE\03BB\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111247227889399242)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03B3\03B9\03BD\03B5 \03C5\03C0\03AD\03C1\03B2\03B1\03C3\03B7 \03C4\03C9\03BD \03B5\03C3\03C9\03C4\03B5\03C1\03B9\03BA\03CE\03BD \03BF\03C1\03AF\03C9\03BD \03B4\03AD\03C3\03BC\03B5\03C5\03C3\03B7\03C2 ORDS OUT. \039C\03B5\03B9\03CE\03C3\03C4\03B5 \03C4\03BF\03BD \03B1\03C1\03B9\03B8\03BC\03CC \03C4\03C9\03BD \03C3\03B5\03B9\03C1\03CE\03BD DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111325004697399298)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\0394\03B5\03BD \03AE\03C4\03B1\03BD \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B1\03BD\03AC\03BB\03C5\03C3\03B7 \03C4\03B7\03C2 \03B1\03C0\03CC\03BA\03C1\03B9\03C3\03B7\03C2 JSON \03B1\03C0\03CC \03C4\03BF\03BD \03B1\03C0\03BF\03BC\03B1\03BA\03C1\03C5\03C3\03BC\03AD\03BD\03BF server: '),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111247132586399242)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\0386\03B3\03BD\03C9\03C3\03C4\03BF\03C2 \03AE \03B5\03C3\03C6\03B1\03BB\03BC\03AD\03BD\03BF\03C2 \03C4\03CD\03C0\03BF\03C2 \03C0\03B5\03C1\03B9\03B2\03AC\03BB\03BB\03BF\03BD\03C4\03BF\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111341699148399310)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03CC\03C2 \03BF \03C4\03CD\03C0\03BF\03C2 \03B1\03C1\03C7\03B5\03AF\03BF\03C5 \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03B1\03C0\03CC \03C4\03BF\03BD \03B1\03BD\03B1\03BB\03C5\03C4\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111296224058399277)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03B5\03B3\03BA\03B5\03BA\03C1\03B9\03BC\03AD\03BD\03B7 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7 (\0394\03B5\03BD \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03C4\03BF wwv_flow_api.set_credentials.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111273283468399261)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C7\03CE\03C1\03BF\03C2 \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2 \03B4\03B5\03BD \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03B8\03B7\03BA\03B5 \03B3\03B9\03B1\03C4\03AF \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03AE\03B4\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111273182671399260)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BF\03BC\03AC\03B4\03B1 \03C7\03C1\03B7\03C3\03C4\03CE\03BD \03B4\03B5\03BD \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AE\03B8\03B7\03BA\03B5 \03B3\03B9\03B1\03C4\03AF \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03AE\03B4\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111283443360399268)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'el'
,p_message_text=>unistr('\0392\03C1\03AD\03B8\03B7\03BA\03B5 \03B4\03B9\03C0\03BB\03CC\03C4\03C5\03C0\03BF \03CC\03BD\03BF\03BC\03B1 \03C7\03C1\03AE\03C3\03C4\03B7 \03B3\03B9\03B1 {0}.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111283593848399268)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7 \03C6\03CC\03C1\03C4\03C9\03C3\03B7 \03C4\03C9\03BD \03C7\03C1\03B7\03C3\03C4\03CE\03BD. \0391\03C0\03BF\03C4\03C5\03C7\03AF\03B1 \03BA\03B1\03C4\03AC \03C4\03B7 \03C6\03CC\03C1\03C4\03C9\03C3\03B7 \03C4\03BF\03C5 \03C7\03C1\03AE\03C3\03C4\03B7 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111293402217399275)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0398\03B1 \03B5\03AF\03C7\03B1\03BD \03C6\03BF\03C1\03C4\03C9\03B8\03B5\03AF %0 \03C7\03C1\03AE\03C3\03C4\03B5\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111293227705399275)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'el'
,p_message_text=>unistr('\039A\03C9\03B4\03B9\03BA\03CC\03C2 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111293363542399275)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B9\03BA\03B1\03B9\03CE\03BC\03B1\03C4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111293082120399275)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'el'
,p_message_text=>unistr('\038C\03BD\03BF\03BC\03B1 \03C7\03C1\03AE\03C3\03C4\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111369589468399330)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B1\03C0\03CC\03B4\03BF\03C3\03B7 \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 \03C3\03B5\03BB\03AF\03B4\03B1\03C2 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111289189036399272)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7 \03C4\03BF\03C5 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 \03C3\03B5\03BB\03AF\03B4\03B1\03C2, \03B3\03B9\03B1\03C4\03AF \03B7 \03C6\03CC\03C1\03BC\03B1 HTML \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03B1\03BD\03BF\03AF\03BE\03B5\03B9 \03B1\03BA\03CC\03BC\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111254418566399247)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03BF\03BD \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC \03C4\03B7\03C2 \03C0\03C1\03BF\03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7\03C2 \03C4\03B9\03BC\03AE\03C2 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 \03B3\03B9\03B1 \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C3\03B5\03BB\03AF\03B4\03B1\03C2 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111288455333399271)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7 \03C6\03AC\03C3\03B7 \03BC\03B5\03C4\03AC \03C4\03BF\03BD \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC \03B3\03B9\03B1 \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C3\03B5\03BB\03AF\03B4\03B1\03C2 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111288318955399271)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03BF\03BD \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03CC \03C4\03B7\03C2 \03C4\03B9\03BC\03AE\03C2 \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7\03C2 \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5 \03B3\03B9\03B1 \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF \03C3\03B5\03BB\03AF\03B4\03B1\03C2 #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111268125892399257)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03B5\03BE\03BF\03C5\03C3\03B9\03BF\03B4\03BF\03C4\03B7\03BC\03AD\03BD\03B7 \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111288657275399272)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 JavaScript.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111288752651399272)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'el'
,p_message_text=>unistr('\039B\03AF\03C3\03C4\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111289379663399272)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03C0\03C1\03BF\03B5\03C4\03BF\03B9\03BC\03B1\03C3\03AF\03B1 \03C4\03BF\03C5 \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111296597759399277)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03B7 \03B5\03BD\03B7\03BC\03AD\03C1\03C9\03C3\03B7 \03C4\03BF\03C5 %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111290713862399273)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03BF \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF\03C5: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111317029427399292)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03B2\03BF\03AE\03B8\03B5\03B9\03B1 \03B3\03B9\03B1 \03B1\03C5\03C4\03CC \03C4\03BF \03C3\03C4\03BF\03B9\03C7\03B5\03AF\03BF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111281523198399267)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2 \03B3\03C1\03B1\03C6\03AE\03BC\03B1\03C4\03BF\03C2 \03B1\03C0\03AD\03C4\03C5\03C7\03B5. \0395\03BB\03AD\03B3\03BE\03C4\03B5 \03C4\03B9\03C2 \03C1\03C5\03B8\03BC\03AF\03C3\03B5\03B9\03C2 \03B3\03B9\03B1 \03C4\03B7\03BD \03B1\03BD\03C4\03B9\03C3\03C4\03BF\03AF\03C7\03B9\03C3\03B7 \03C0\03C1\03BF\03B5\03BB\03B5\03CD\03C3\03B5\03C9\03BD \03BA\03B1\03B9 \03C3\03C4\03B7\03BB\03CE\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111376327978399335)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C5\03BD\03B7\03BC\03BC\03AD\03BD\03BF \03BC\03B5 \03BC\03AD\03B3\03B5\03B8\03BF\03C2 %0 MB \03C5\03C0\03B5\03C1\03B2\03B1\03AF\03BD\03B5\03B9 \03C4\03BF \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03BC\03AD\03B3\03B5\03B8\03BF\03C2 \03C3\03C5\03BD\03B7\03BC\03BC\03AD\03BD\03C9\03BD (%1 MB).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111282400128399267)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C4\03B9\03BC\03AE \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03B1\03C1\03AC\03BC\03B5\03C4\03C1\03BF p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111399897762399353)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03C7\03B5\03C4\03B5 \03C5\03C0\03B5\03C1\03B2\03B5\03AF \03C4\03BF\03BD \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03B1\03C1\03B9\03B8\03BC\03CC \03BC\03B7\03BD\03C5\03BC\03AC\03C4\03C9\03BD \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5 \03B1\03BD\03AC \03C7\03CE\03C1\03BF \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2. \0395\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111263480574399253)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03AE \03B7 \03B4\03B9\03B1\03B4\03B9\03BA\03B1\03C3\03AF\03B1 \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03BA\03B1\03BB\03B5\03AF\03C4\03B1\03B9 \03C3\03C4\03BF \03C0\03BB\03B1\03AF\03C3\03B9\03BF \03BC\03B9\03B1\03C2 \03C0\03B5\03C1\03B9\03CC\03B4\03BF\03C5 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111282364941399267)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03B1\03C3\03C7\03AD\03B8\03B7\03BA\03B5 \03C4\03B9\03BC\03AE null \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03B1\03C1\03AC\03BC\03B5\03C4\03C1\03BF %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111336399221399306)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C0\03C1\03CC\03C4\03C5\03C0\03BF \03BC\03B7\03BD\03C5\03BC\03AC\03C4\03C9\03BD \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5 "%0" \03B4\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5 \03C3\03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111412828747399362)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0393\03B9\03B1 \03C4\03B7\03BD \03B1\03C0\03BF\03C3\03C4\03BF\03BB\03AE \03BC\03B7\03BD\03C5\03BC\03AC\03C4\03C9\03BD \03B1\03BB\03BB\03B7\03BB\03BF\03B3\03C1\03B1\03C6\03AF\03B1\03C2, \03B1\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03B7\03C2 \03C0\03B1\03C1\03B1\03BC\03AD\03C4\03C1\03BF\03C5 \03C3\03C4\03B9\03B3\03BC\03B9\03BF\03C4\03CD\03C0\03BF\03C5 SMTP_HOST_ADDRESS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111282025822399267)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03BF\03C1\03AF\03C3\03B5\03C4\03B5 \03AD\03BD\03B1\03BD \03C0\03B1\03C1\03B1\03BB\03AE\03C0\03C4\03B7 \03BC\03B7\03BD\03CD\03BC\03B1\03C4\03BF\03C2 \03B3\03B9\03B1 \03C4\03B7\03BD \03B1\03C0\03BF\03C3\03C4\03BF\03BB\03AE \03B1\03BB\03BB\03B7\03BB\03BF\03B3\03C1\03B1\03C6\03AF\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111402268105399354)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03C0\03C1\03B1\03B3\03BC\03B1\03C4\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03C3\03CD\03BD\03B4\03B5\03C3\03B7\03C2 SMTP \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03BC\03BF\03C1\03C6\03C9\03BC\03AD\03BD\03BF server \03B7\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03BF\03CD \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF\03C5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111376497011399335)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'el'
,p_message_text=>unistr('\039C\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03BA\03BB\03AE\03C3\03B7 Ajax.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111267898680399257)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 Ajax \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03CC\03C3\03B8\03B5\03C4\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111366884844399329)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 \03B5\03BA\03C4\03AD\03BB\03B5\03C3\03B7\03C2 \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03CC\03C3\03B8\03B5\03C4\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111267935491399257)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03C3\03C5\03BD\03AC\03C1\03C4\03B7\03C3\03B7 \03B1\03C0\03CC\03B4\03BF\03C3\03B7\03C2 \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03CC\03C3\03B8\03B5\03C4\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111377333352399336)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03C1\03CC\03C3\03B8\03B5\03C4\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD REST "%0" \03B4\03B5\03BD \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BC\03B9\03B1 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 \0394\03C5\03BD\03B1\03C4\03CC\03C4\03B7\03C4\03B5\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111377261817399336)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03C1\03CC\03C3\03B8\03B5\03C4\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD REST "%0" \03B4\03B5\03BD \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BC\03B9\03B1 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111377484252399336)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03C1\03CC\03C3\03B8\03B5\03C4\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD REST "%0" \03B4\03B5\03BD \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BC\03B9\03B1 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 \03B5\03BA\03C4\03AD\03BB\03B5\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111377567481399336)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03C1\03CC\03C3\03B8\03B5\03C4\03B7 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD REST "%0" \03B4\03B5\03BD \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03BC\03B9\03B1 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 \03B1\03BD\03AC\03BA\03C4\03B7\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111265674444399255)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03C3\03C4\03BF\03BD \03BA\03CE\03B4\03B9\03BA\03B1 PLSQL \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03C0\03C1\03CC\03C3\03B8\03B5\03C4\03B7\03C2 \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111272286987399260)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B9\03BC\03AE \03C0\03C1\03AD\03C0\03B5\03B9 \03BD\03B1 \03BF\03C1\03B9\03C3\03C4\03B5\03AF.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111302882182399282)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C4\03CD\03C0\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD %0 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03BC\03B5\03C4\03B1\03C4\03C1\03B1\03C0\03B5\03AF \03C3\03B5 VARCHAR2!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111388499317399344)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C3\03C4\03AE\03BB\03B7 "%0" \03C0\03BF\03C5 \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03B3\03B9\03B1 \03C4\03BF \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03CC "%1" \03B4\03B5\03BD \03B2\03C1\03AD\03B8\03B7\03BA\03B5 \03C3\03C4\03B7\03BD \03C0\03C1\03CC\03C4\03B1\03C3\03B7 SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111364700789399327)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03B5\03BD\03CC\03C2 \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2 \03BB\03AF\03C3\03C4\03B1\03C2 \03C4\03B9\03BC\03CE\03BD (LOV) \03AE \03BC\03B9\03B1\03C2 \03B5\03C0\03CE\03BD\03C5\03BC\03B7\03C2 \03BB\03AF\03C3\03C4\03B1\03C2 \03C4\03B9\03BC\03CE\03BD \03B3\03B9\03B1 \03C4\03BF %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111366345551399328)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03C0\03B9\03BB\03AD\03C7\03B8\03B7\03BA\03B5 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03BF\03C2 \03B1\03C1\03B9\03B8\03BC\03CC\03C2 \03C3\03C4\03B7\03BB\03CE\03BD \03C3\03C4\03BF \03B5\03C1\03CE\03C4\03B7\03BC\03B1 LOV SQL \03B3\03B9\03B1 \03C4\03BF %0. \0394\03B5\03AF\03C4\03B5 \03C4\03B1 \03C0\03B1\03C1\03B1\03B4\03B5\03AF\03B3\03BC\03B1\03C4\03B1 \03AD\03B3\03BA\03C5\03C1\03C9\03BD \03C0\03C1\03BF\03C4\03AC\03C3\03B5\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111388216277399344)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03AD\03C7\03B5\03B9 \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03C3\03C4\03AE\03BB\03B7 \03B3\03B9\03B1 \03C4\03BF \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03CC "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111417906065399366)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03B7 \03C4\03B9\03BC\03AE %0 \03B3\03B9\03B1 \03C4\03BF \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03CC "%1" \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B1\03C1\03B9\03B8\03BC\03B7\03C4\03B9\03BA\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111369857263399331)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C4\03CD\03C0\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03B3\03B9\03B1 \03C4\03BF %0 \03C3\03C4\03B7\03BD \03C0\03C1\03CC\03C4\03B1\03C3\03B7 SQL \03B5\03AF\03BD\03B1\03B9 \03B5\03C3\03C6\03B1\03BB\03BC\03AD\03BD\03BF\03C2. \0397 \03C3\03C4\03AE\03BB\03B7# %1 \03B5\03AF\03BD\03B1\03B9 %2, \03B1\03BB\03BB\03AC \03B1\03BD\03B1\03BC\03B5\03BD\03CC\03C4\03B1\03BD \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111388344472399344)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03C4\03CD\03C0\03BF\03C2 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03C3\03C4\03B7\03BD \03BA\03B1\03B8\03BF\03C1\03B9\03C3\03BC\03AD\03BD\03B7 \03C3\03C4\03AE\03BB\03B7 "%0" \03B3\03B9\03B1 \03C4\03BF \03C7\03B1\03C1\03B1\03BA\03C4\03B7\03C1\03B9\03C3\03C4\03B9\03BA\03CC "%1" \03B5\03AF\03BD\03B1\03B9 %2 \03B5\03BD\03CE \03B8\03B1 \03AD\03C0\03C1\03B5\03C0\03B5 \03BD\03B1 \03B5\03AF\03BD\03B1\03B9 %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111264972134399254)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03CD\03C1\03B5\03C3\03B7 \03C4\03B7\03C2 \03B4\03B9\03AC\03C4\03B1\03BE\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111324916577399298)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1 \03C5\03C0\03BF\03BB\03BF\03B3\03B9\03C3\03BC\03BF\03CD \03B1\03B8\03C1\03BF\03AF\03C3\03BC\03B1\03C4\03BF\03C2 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF \03B3\03B9\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AD\03C2 \03C0\03BF\03C5 \03B2\03B1\03C3\03AF\03B6\03BF\03BD\03C4\03B1\03B9 \03C3\03B5 \03BC\03B9\03B1 \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111288585901399272)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('ERR-2904 \0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03CC\03C2 \03BF \03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03B7\03C2 \03C4\03B9\03BC\03AE\03C2 \03C3\03C5\03BD\03C4\03CC\03BC\03B5\03C5\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111292831457399275)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C6\03AC\03BB\03BC\03B1: \0386\03B3\03BD\03C9\03C3\03C4\03BF\03C2 \03C4\03CD\03C0\03BF\03C2 \03C3\03C5\03BD\03C4\03CC\03BC\03B5\03C5\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111282865549399267)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B1\03BD\03AC\03BA\03C4\03B7\03C3\03B7 \03C4\03BF\03C5 \03C3\03C7\03AE\03BC\03B1\03C4\03BF\03C2 \03C4\03B1\03C5\03C4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2 (authentication_scheme) \03C3\03C4\03B7\03BD \03B5\03C6\03B1\03C1\03BC\03BF\03B3\03AE %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111356334130399321)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B1\03BD\03B1\03B3\03BD\03C9\03C1\03B9\03C3\03C4\03B9\03BA\03CC \03BC\03B9\03C3\03B8\03C9\03C4\03AE \03C5\03C0\03AC\03C1\03C7\03B5\03B9 \03AE\03B4\03B7 \03B3\03B9\03B1 \03C4\03B7\03BD \03C4\03C1\03AD\03C7\03BF\03C5\03C3\03B1 \03C0\03B5\03C1\03AF\03BF\03B4\03BF \03BB\03B5\03B9\03C4\03BF\03C5\03C1\03B3\03AF\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111293185752399275)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'el'
,p_message_text=>unistr('\0397\03BB\03B5\03BA\03C4\03C1\03BF\03BD\03B9\03BA\03CC \03C4\03B1\03C7\03C5\03B4\03C1\03BF\03BC\03B5\03AF\03BF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111417329618399365)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C4\03B1\03C5\03C4\03BF\03C0\03BF\03AF\03B7\03C3\03B7 \03B1\03C0\03AD\03C4\03C5\03C7\03B5.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111319684867399294)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03BD\03B1 \03AE \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B1 cookie \03C0\03BF\03C5 \03AD\03C7\03BF\03C5\03BD \03BF\03C1\03B9\03C3\03C4\03B5\03AF \03C3\03C4\03BF apex_util.g_request_cookies \03C0\03B5\03C1\03B9\03AD\03C7\03BF\03C5\03BD \03BC\03B9\03B1 \03BC\03B7 \03AD\03B3\03BA\03C5\03C1\03B7 \03C4\03B9\03BC\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111302128209399281)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B1\03C0\03CC\03BA\03C1\03B9\03C3\03B7 \03B1\03C0\03CC \03C4\03BF \03BC\03B7\03C4\03C1\03CE\03BF UDDI \03B4\03B5\03BD \03AE\03C4\03B1\03BD \03AD\03B3\03BA\03C5\03C1\03B7.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111265778682399255)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03C0\03B1\03C1\03B5\03C7\03CC\03BC\03B5\03BD\03B7 \03B4\03B9\03B5\03CD\03B8\03C5\03BD\03C3\03B7 \03C4\03BF\03C0\03BF\03B8\03B5\03C3\03AF\03B1\03C2 \03B4\03B5\03BD \03B5\03C0\03AD\03C3\03C4\03C1\03B5\03C8\03B5 \03AD\03BD\03B1 \03AD\03B3\03BA\03C5\03C1\03BF \03AD\03B3\03B3\03C1\03B1\03C6\03BF WSDL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111268212247399257)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03AD\03B3\03B3\03C1\03B1\03C6\03BF WSDL \03C0\03B5\03C1\03B9\03BB\03B1\03BC\03B2\03AC\03BD\03B5\03B9 \03C0\03BF\03BB\03BB\03B1\03C0\03BB\03AD\03C2 \03B4\03B5\03C3\03BC\03B5\03CD\03C3\03B5\03B9\03C2 SOAP. \03A4\03BF &PRODUCT_NAME. \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03B9 \03BC\03CC\03BD\03BF \03AD\03B3\03B3\03C1\03B1\03C6\03B1 WSDL \03BC\03B5 \03BC\03AF\03B1 \03B4\03AD\03C3\03BC\03B5\03C5\03C3\03B7 SOAP. \039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \039C\03B7 \03B1\03C5\03C4\03CC\03BC\03B1\03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03C0\03B1\03C1\03B1\03C0\03BF\03BC\03C0\03AE\03C2 \03C5\03C0\03B7\03C1\03B5\03C3\03AF\03B1\03C2 \03B9\03C3\03C4\03BF\03CD \03B3\03B9\03B1 \03BD\03B1 \03C3\03C5\03BD\03B5\03C7\03AF\03C3\03B5\03C4\03B5 \03BC\03B5 \03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03BC\03B9\03B1\03C2 \03C0\03B1\03C1\03B1\03C0\03BF\03BC\03C0\03AE\03C2')
||unistr(' \03B3\03B9\03B1 \03C4\03B7\03BD \03C5\03C0\03B7\03C1\03B5\03C3\03AF\03B1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111336601274399306)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03B1\03C0\03CC\03BA\03C1\03B9\03C3\03B7 \03B1\03C0\03CC \03C4\03B7\03BD \03C5\03C0\03B7\03C1\03B5\03C3\03AF\03B1 \03B4\03B5\03BD \03AE\03C4\03B1\03BD XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111417299114399365)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03B9\03BA\03CC \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 OAuth \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03B9\03B1\03B8\03AD\03C3\03B9\03BC\03BF \03AE \03AD\03C7\03B5\03B9 \03BB\03AE\03BE\03B5\03B9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111380478470399338)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'el'
,p_message_text=>unistr('\0388\03C7\03B5\03C4\03B5 \03C5\03C0\03B5\03C1\03B2\03B5\03AF \03C4\03BF\03BD \03BC\03AD\03B3\03B9\03C3\03C4\03BF \03B1\03C1\03B9\03B8\03BC\03CC \03B1\03B9\03C4\03B7\03BC\03AC\03C4\03C9\03BD \03C5\03C0\03B7\03C1\03B5\03C3\03AF\03B1\03C2 \03B9\03C3\03C4\03BF\03CD \03B1\03BD\03AC \03C7\03CE\03C1\03BF \03B5\03C1\03B3\03B1\03C3\03AF\03B1\03C2. \0395\03C0\03B9\03BA\03BF\03B9\03BD\03C9\03BD\03AE\03C3\03C4\03B5 \03BC\03B5 \03C4\03BF\03BD \03B4\03B9\03B1\03C7\03B5\03B9\03C1\03B9\03C3\03C4\03AE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111417414154399365)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'el'
,p_message_text=>unistr('\039F server \03B1\03C0\03BF\03BA\03C1\03AF\03B8\03B7\03BA\03B5 \03BC\03B5 \03AD\03BD\03B1\03BD \03BC\03B7 \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03B9\03B6\03CC\03BC\03B5\03BD\03BF \03C4\03CD\03C0\03BF \03B4\03B9\03B1\03BA\03C1\03B9\03C4\03B9\03BA\03BF\03CD OAuth.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111267693874399256)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03AD\03B3\03B3\03C1\03B1\03C6\03BF WSDL \03B4\03B5\03BD \03C0\03B5\03C1\03B9\03B5\03BB\03AC\03BC\03B2\03B1\03BD\03B5 \03BC\03B9\03B1 \03B4\03AD\03C3\03BC\03B5\03C5\03C3\03B7 \03B3\03B9\03B1 SOAP \03C0\03BF\03C5 \03B1\03C0\03B1\03B9\03C4\03B5\03AF\03C4\03B1\03B9 \03B3\03B9\03B1 \03C4\03B7\03BD \03C0\03C1\03BF\03C3\03B8\03AE\03BA\03B7 \03C4\03B7\03C2 \03C0\03B1\03C1\03B1\03C0\03BF\03BC\03C0\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111263533940399253)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03CC \03C4\03BF WSDL \03B1\03C0\03B1\03B9\03C4\03B5\03AF \03B4\03B9\03B1\03C0\03B9\03C3\03C4\03B5\03C5\03C4\03AE\03C1\03B9\03B1 \03C4\03B1\03C5\03C4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2. \039F\03C1\03AF\03C3\03C4\03B5 \03C4\03BF \03CC\03BD\03BF\03BC\03B1 \03C7\03C1\03AE\03C3\03C4\03B7 \03BA\03B1\03B9 \03C4\03BF\03BD \03BA\03C9\03B4\03B9\03BA\03CC \03C0\03C1\03CC\03C3\03B2\03B1\03C3\03B7\03C2 \03C0\03B1\03C1\03B1\03BA\03AC\03C4\03C9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111272396017399260)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'el'
,p_message_text=>unistr('\039F \03BC\03B7\03C7\03B1\03BD\03B9\03C3\03BC\03CC\03C2 \03B1\03C0\03CC\03B4\03BF\03C3\03B7\03C2 \03B4\03B5\03BD \03BC\03C0\03BF\03C1\03B5\03AF \03BD\03B1 \03BA\03B1\03C4\03B1\03BD\03BF\03AE\03C3\03B5\03B9 \03C4\03BF \03AD\03B3\03B3\03C1\03B1\03C6\03BF WSDL. \039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA \03C3\03C4\03B7\03BD \03B5\03C0\03B9\03BB\03BF\03B3\03AE \039C\03B7 \03B1\03C5\03C4\03CC\03BC\03B1\03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03C0\03B1\03C1\03B1\03C0\03BF\03BC\03C0\03AE\03C2 \03C5\03C0\03B7\03C1\03B5\03C3\03AF\03B1\03C2 \03B9\03C3\03C4\03BF\03CD \03B3\03B9\03B1 \03BD\03B1 \03C3\03C5\03BD\03B5\03C7\03AF\03C3\03B5\03C4\03B5 \03BC\03B5 \03C4\03B7 \03B4\03B7\03BC\03B9\03BF\03C5\03C1\03B3\03AF\03B1 \03BC\03B9\03B1\03C2 \03C0\03B1\03C1\03B1\03C0\03BF\03BC\03C0\03AE\03C2 \03B3\03B9\03B1 \03C4\03B7\03BD \03C5\03C0\03B7\03C1\03B5\03C3\03AF\03B1..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111339267882399308)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'el'
,p_message_text=>unistr('\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B5\03C0\03B5\03BE\03B5\03C1\03B3\03B1\03C3\03AF\03B1 \03C4\03B7\03C2 \03B5\03BD\03B7\03BC\03AD\03C1\03C9\03C3\03B7\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111365088846399327)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'el'
,p_message_text=>unistr('\039F\03B9 \03C3\03C4\03AE\03BB\03B5\03C2 \03B5\03C0\03B9\03C3\03C4\03C1\03BF\03C6\03AE\03C2 \03BA\03B1\03B9 \03B5\03BC\03C6\03AC\03BD\03B9\03C3\03B7\03C2 \03C4\03B7\03C2 \03BB\03AF\03C3\03C4\03B1\03C2 \03C4\03B9\03BC\03CE\03BD \03B5\03AF\03BD\03B1\03B9 \03AF\03B4\03B9\03B5\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111364914854399327)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\0397 \03BB\03AF\03C3\03C4\03B1 \03C4\03B9\03BC\03CE\03BD \03B4\03B5\03BD \03AD\03C7\03B5\03B9 \03BC\03B9\03B1 \03C3\03C4\03AE\03BB\03B7 \03B5\03C0\03B9\03C3\03C4\03C1\03BF\03C6\03AE\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111296442449399277)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'el'
,p_message_text=>unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7\03BD \03B1\03BD\03AC\03BA\03C4\03B7\03C3\03B7 \03C4\03B7\03C2 \03C4\03B9\03BC\03AE\03C2 \03C3\03C4\03AE\03BB\03B7\03C2: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111320439636399295)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1 \03C4\03C1\03AD\03C7\03BF\03BD\03C4\03B1 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03B1 \03C3\03B5 \03BC\03BF\03C1\03C6\03AE \03C0\03AF\03BD\03B1\03BA\03B1 \03B5\03AF\03BD\03B1\03B9 \03C0\03BF\03BB\03CD \03C0\03B1\03BB\03B9\03AC. \0397 \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03AD\03C7\03B5\03B9 \03C4\03C1\03BF\03C0\03BF\03C0\03BF\03B9\03B7\03B8\03B5\03AF.<br/> \039A\03AC\03BD\03C4\03B5 \03BA\03BB\03B9\03BA <strong><a href="%0">\03B5\03B4\03CE</a></strong> \03B3\03B9\03B1 \03C4\03B7\03BD \03B1\03C0\03CC\03C1\03C1\03B9\03C8\03B7 \03C4\03C9\03BD \03B1\03BB\03BB\03B1\03B3\03CE\03BD \03C3\03B1\03C2 \03BA\03B1\03B9 \03C4\03B7\03BD \03B5\03C0\03B1\03BD\03B1\03C6\03CC\03C1\03C4\03C9\03C3\03B7 \03C4\03C9\03BD \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD \03B1\03C0\03CC \03C4\03B7 \03B2\03AC\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111278510858399264)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'el'
,p_message_text=>unistr('\03A3\03C6\03AC\03BB\03BC\03B1 \03C0\03C1\03BF\03C3\03B4\03B9\03BF\03C1\03B9\03C3\03BC\03BF\03CD \03C3\03C5\03BC\03B2\03BF\03BB\03BF\03C3\03B5\03B9\03C1\03AC\03C2 \03C3\03B5\03BB\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111278482751399264)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03CC\03C2 \03BF \03C0\03C1\03BF\03C3\03B4\03B9\03BF\03C1\03B9\03C3\03BC\03CC\03C2 \03C4\03C9\03BD \03BA\03B5\03C6\03B1\03BB\03AF\03B4\03C9\03BD \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111278605523399264)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03C6\03AC\03BB\03BC\03B1 \03B5\03BA\03C4\03AD\03BB\03B5\03C3\03B7\03C2 \03B1\03BD\03C4\03B9\03BA\03B1\03C4\03B1\03C3\03C4\03AC\03C3\03B5\03C9\03BD \03C5\03C0\03BF\03C3\03AD\03BB\03B9\03B4\03C9\03BD \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111278721855399265)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\03B1\03C0\03AD\03C4\03C5\03C7\03B5 \03B7 \03B1\03BD\03AC\03BB\03C5\03C3\03B7 \03C4\03BF\03C5 \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2 SQL:'),
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111283752623399268)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'el'
,p_message_text=>unistr('\0395\03BB\03AC\03C7\03B9\03C3\03C4\03B5\03C2 \03B6\03B7\03C4\03BF\03CD\03BC\03B5\03BD\03B5\03C2 \03C3\03B5\03B9\03C1\03AD\03C2: %0. \03A3\03B5\03B9\03C1\03AD\03C2 \03C0\03BF\03C5 \03B2\03C1\03AD\03B8\03B7\03BA\03B1\03BD, \03B1\03BB\03BB\03AC \03B4\03B5\03BD \03B5\03BC\03C6\03B1\03BD\03AF\03B6\03BF\03BD\03C4\03B1\03B9: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111281223476399266)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'el'
,p_message_text=>unistr('\03B7 \03C3\03C4\03AE\03BB\03B7 \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2 #%0 (%1) \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03B7: \03BF\03B9 \03C3\03C4\03AE\03BB\03B5\03C2 \03C0\03BF\03C5 \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03BF\03CD\03BD HTML \03C7\03C1\03B5\03B9\03AC\03B6\03BF\03BD\03C4\03B1\03B9 \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03B1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111296308881399277)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\03A0\03B1\03C1\03BF\03C5\03C3\03B9\03AC\03C3\03C4\03B7\03BA\03B5 \03C3\03C6\03AC\03BB\03BC\03B1 \03BA\03B1\03C4\03AC \03C4\03B7 \03BB\03AE\03C8\03B7 \03C4\03C9\03BD \03BA\03B5\03C6\03B1\03BB\03AF\03B4\03C9\03BD \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111278825701399265)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('\03C3\03C6\03AC\03BB\03BC\03B1 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111316549004399292)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03B1\03BE\03B9\03BD\03CC\03BC\03B7\03C3\03B7 \03BC\03B5 \03B2\03AC\03C3\03B7 \03B1\03C5\03C4\03AE\03BD \03C4\03B7 \03C3\03C4\03AE\03BB\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111281375624399266)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'el'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>\0394\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03B4\03C5\03BD\03B1\03C4\03AE \03B7 \03B1\03BD\03AC\03BB\03C5\03C3\03B7 \03C4\03BF\03C5 \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2. \0395\03BB\03AD\03B3\03BE\03C4\03B5 \03C4\03B7 \03C3\03CD\03BD\03C4\03B1\03BE\03B7 \03C4\03BF\03C5 \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03CC\03C2 \03C3\03B1\03C2.'),
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111320551642399295)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'el'
,p_message_text=>unistr('\0391\03C5\03C4\03AE \03B7 \03C6\03CC\03C1\03BC\03B1 \03C0\03B5\03C1\03B9\03AD\03C7\03B5\03B9 \03BC\03B7 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03BC\03AD\03BD\03B5\03C2 \03B1\03BB\03BB\03B1\03B3\03AD\03C2. \03A0\03B1\03C4\03AE\03C3\03C4\03B5 OK \03B3\03B9\03B1 \03BD\03B1 \03C3\03C5\03BD\03B5\03C7\03AF\03C3\03B5\03C4\03B5 \03C7\03C9\03C1\03AF\03C2 \03BD\03B1 \03B1\03C0\03BF\03B8\03B7\03BA\03B5\03C5\03C4\03BF\03CD\03BD \03BF\03B9 \03B1\03BB\03BB\03B1\03B3\03AD\03C2 \03C3\03B1\03C2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111324828495399298)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'el'
,p_message_text=>unistr('\03A4\03BF \03C3\03C7\03AE\03BC\03B1 \03C3\03B5\03BB\03B9\03B4\03BF\03C0\03BF\03AF\03B7\03C3\03B7\03C2 \03B1\03BD\03B1\03C6\03BF\03C1\03AC\03C2 (%0) \03B4\03B5\03BD \03C5\03C0\03BF\03C3\03C4\03B7\03C1\03AF\03B6\03B5\03C4\03B1\03B9 \03BC\03B5 \03C4\03B7\03BD \03B5\03C0\03B9\03BB\03B5\03B3\03BC\03AD\03BD\03B7 \03C0\03C1\03BF\03AD\03BB\03B5\03C5\03C3\03B7 \03B4\03B5\03B4\03BF\03BC\03AD\03BD\03C9\03BD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111281102540399266)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'el'
,p_message_text=>unistr('\03B7 \03C3\03C4\03AE\03BB\03B7 \03B5\03C1\03C9\03C4\03AE\03BC\03B1\03C4\03BF\03C2 #%0 (%1) \03B4\03B5\03BD \03B5\03AF\03BD\03B1\03B9 \03AD\03B3\03BA\03C5\03C1\03B7: \03C7\03C1\03B7\03C3\03B9\03BC\03BF\03C0\03BF\03B9\03AE\03C3\03C4\03B5 \03C4\03BF \03C8\03B5\03C5\03B4\03CE\03BD\03C5\03BC\03BF \03C3\03C4\03AE\03BB\03B7\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111283879375399268)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03B5\03B9\03C1\03AC(-\03AD\03C2) %0 - %1 \03B1\03C0\03CC \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B5\03C2 \03B1\03C0\03CC %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111322519452399296)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'el'
,p_message_text=>unistr('%0 - %1 \03B1\03C0\03CC \03C0\03B5\03C1\03B9\03C3\03C3\03CC\03C4\03B5\03C1\03B1 \03B1\03C0\03CC %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111283686842399268)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'el'
,p_message_text=>unistr('\03C3\03B5\03B9\03C1\03AC(-\03AD\03C2) %0 - %1 \03B1\03C0\03CC %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111267519778399256)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'el'
,p_message_text=>unistr('%0 - %1 \03B1\03C0\03CC %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111278955231399265)
,p_name=>'Y'
,p_message_language=>'el'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111285087971399269)
,p_name=>'YEAR'
,p_message_language=>'el'
,p_message_text=>unistr('\03AD\03C4\03BF\03C2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111278133911399264)
,p_name=>'YEARS'
,p_message_language=>'el'
,p_message_text=>unistr('\03AD\03C4\03B7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111320614933399295)
,p_name=>'YES'
,p_message_language=>'el'
,p_message_text=>unistr('\039D\03B1\03B9')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4491)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4491)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Desktop'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4491
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4491)
,p_name=>unistr('\039C\03B7\03BD\03CD\03BC\03B1\03C4\03B1')
,p_alias=>'MESSAGES'
,p_step_title=>unistr('\039C\03B7\03BD\03CD\03BC\03B1\03C4\03B1')
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
