prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4412
,p_default_id_offset=>0
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4412 - Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--
-- Application Export:
--   Application:     4412
--   Name:            Oracle APEX Builder, Wizard Messages and Native Plug-Ins
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Lists:                  3
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 2
--           Region:               1
--           Label:                1
--           List:                 1
--           Popup LOV:            1
--           Calendar:             3
--           Breadcrumb:           2
--           Button:               1
--           Report:               1
--         Plug-ins:             133
--       Globalization:
--         Messages:          13,405
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Builder, Wizard Messages and Native Plug-Ins')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A110305426278363917')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'N'
,p_checksum_salt_last_reset=>'20211020110857'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'es'
,p_flow_language_derived_from=>'SESSION'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(91645213681389498.4412)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'UNAVAILABLE'
,p_flow_unavailable_text=>'This application is currently unavailable.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_deep_linking=>'Y'
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'N'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020112714'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_global
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562090986404402217.4412)
,p_name=>'Spotlight \ Custom Entries - Global'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(48650898565635010.4412)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Cerrar sesi\00F3n')
,p_list_item_link_target=>'&LOGOUT_URL.'
,p_list_text_01=>unistr('Cerrar sesi\00F3n de Application Express')
,p_list_text_09=>'Y'
,p_list_text_10=>'logout exit quit :q'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(281916990329150760.4412)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>unistr('Crear una aplicaci\00F3n en una hoja de c\00E1lculo')
,p_list_item_link_target=>'f?p=4000:56:&APP_SESSION.::NO:56,103,104,106,130,131,35,227,3020,3000,3001'
,p_list_text_01=>unistr('Importe los archivos excel o csv y cree una aplicaci\00F3n')
,p_list_text_09=>'Y'
,p_list_text_10=>'excel csv xsl xslx spreadsheet data paste load import'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(282255839842182292.4412)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>unistr('P\00E1gina inicial de Oracle APEX')
,p_list_item_link_target=>'f?p=4500:1000:&APP_SESSION.'
,p_list_text_10=>unistr('inicio de p\00E1gina inicial ')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(296033420364984683.4412)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Examinar iconos de fuente APEX'
,p_list_item_link_target=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/fontapex'');'
,p_list_text_01=>unistr('Examine los iconos de fuente APEX, a\00F1ada los modificadores y copie el CSS o HTML necesario.')
,p_list_text_09=>'Y'
,p_list_text_10=>unistr('librer\00EDa gr\00E1fica de iconos de fuente apex')
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_app_level
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562091518091404815.4412)
,p_name=>'Spotlight \ Custom Entries - App Level'
,p_list_status=>'PUBLIC'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562091727563404815.4412)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>unistr('Exportar Aplicaci\00F3n')
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::NO:::'
,p_list_text_01=>unistr('Exportar aplicaci\00F3n {APP_ID} como archivo SQL')
,p_list_text_09=>'Y'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_api.create_list_item(
 p_id=>wwv_flow_api.id(562093357853428158.4412)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Listas no Utilizadas'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/spotlight_custom_entries_page_designer
begin
wwv_flow_api.create_list(
 p_id=>wwv_flow_api.id(562092153904409717.4412)
,p_name=>'Spotlight \ Custom Entries - Page Designer'
,p_list_status=>'PUBLIC'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14843831009863117.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(14859012524941040.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(86380554411225400.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_RICH_TEXT_EDITOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(91997339122572414.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(99844881073888905.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(146861159122292557.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176128961688506820.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(176129003012506820.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(183033629816949774.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(460407779408652225.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.STARRATING_MODERN'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(497671453666914719.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_STAR_RATING'
,p_attribute_01=>'fa-star'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(592236161067709447.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(631035363954639049.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082458703597614427.4412)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1082517678315623391.4412)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1765072678475712055.4412)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831649180083980462.4412)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1831780276458994154.4412)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1832884277947217587.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'PLUGIN_COLOR_PICKER'
,p_attribute_01=>'modern'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1840861033969283097.4412)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_DISPLAY_SELECTOR'
,p_attribute_01=>'Y'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1917665913120940054.4412)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1990227023531717243.4412)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_CSS_CALENDAR'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/one_level_tabs
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626406749381989.4412)
,p_theme_id=>1
,p_name=>'One Level Tabs.es'
,p_internal_name=>'ONE_LEVEL_TABS'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td valign="top" class="t1Logo">#LOGO##REGION_POSITION_06#</td>',
'	<td valign="top" width="100%">#REGION_POSITION_07#</td>',
'    <td align="right" valign="top">#NAVIGATION_BAR##REGION_POSITION_08#</td>',
'  </tr>',
'</table>',
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="" height="70%">',
'  <tr>',
'    <td colspan="5" class="t1ParentTabHolder"><table border="0" cellpadding="0" cellspacing="0" summary="" align="right"><tr><td><br /></td>#TAB_CELLS#</tr></table></td>',
'  </tr>',
'  <tr>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_left.png" alt="" /></td>',
'    <td class="t1topbarMiddle" valign="bottom"><table cellpadding="0" cellspacing="0" border="0" summary=""><tr><td height="50%"><br /></td></tr><tr><td height="50%">#REGION_POSITION_01#</td></tr></table></td>',
'    <td valign="top"><img src="#IMAGE_PREFIX#themes/theme_1/top_bar_right.png" alt="" /></td>',
'  </tr>',
'<tr>',
'<td><br /></td>',
'<td class="t1PageCenter" colspan="2" valign="top" height="100%"><table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top" class="t1PageBody"><div class="t1messages">#GLOBAL_NOTIFICATION##SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>#BODY##REGION_POSITION_02##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table width="100%" cellpadding="0" cellspacing="0" border="0" summary="">',
'  <tr>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_left.png" alt="" /></td>',
'    <td class="t1BotbarMiddle"><div id="t1user">&APP_USER.</div></td>',
'    <td class="t1BotbarMiddle"><div id="t1copy"><!-- Copyright Here --><span class="t1Customize">#CUSTOMIZE#</span></div></td>',
'    <td><img src="#IMAGE_PREFIX#themes/theme_1/bot_bar_right.png" alt="" /></td>',
'  </tr>',
'</table>',
'<br />',
'#REGION_POSITION_05#',
'#FORM_CLOSE# ',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>'<div class="t1success">#SUCCESS_MESSAGE#</div>'
,p_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOn">#TAB_LABEL##TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_on_right.png" border="0" alt="" /></td>',
'',
''))
,p_non_current_tab=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_left.png" border="0" alt="" /></td>',
'<td class="t1ParentTabCenterOff"><a href="#TAB_LINK#">#TAB_LABEL#</a>#TAB_INLINE_EDIT#</td>',
'<td><img src="#IMAGE_PREFIX#themes/theme_1/tab_off_right.png" border="0" alt="" /></td>',
''))
,p_notification_message=>'<div class="t1notification">#MESSAGE#</div>'
,p_navigation_bar=>'<div class="t1NavigationBar">#BAR_BODY#</div>'
,p_navbar_entry=>'<a href="#LINK#" class="t1NavigationBar">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_01'
,p_theme_class_id=>1
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'12'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001488931349566.4412)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4412)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001517815349566.4412)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4412)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001699115349566.4412)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4412)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001740672349566.4412)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4412)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001820430349566.4412)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4412)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140001949447349565.4412)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4412)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002088971349565.4412)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4412)
,p_name=>'Page Position 6'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002117005349565.4412)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4412)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002264345349565.4412)
,p_page_template_id=>wwv_flow_api.id(91626406749381989.4412)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/printer_friendly
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(91626529080381989.4412)
,p_theme_id=>1
,p_name=>'Printer Friendly.es'
,p_internal_name=>'PRINTER_FRIENDLY'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<html lang="&BROWSER_LANGUAGE." xmlns:htmldb="http://htmldb.oracle.com">',
'',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'',
'<title>#TITLE#</title>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V3.css" type="text/css" />',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table summary="" cellpadding="0" width="100%" cellspacing="0" border="0">',
'<tr>',
'<td width="100%" valign="top">',
'<div style="border:1px solid black;">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE#</div>',
'#BODY##REGION_POSITION_04#</td>',
'<td valign="top">#REGION_POSITION_03#<br /></td>',
'</tr>',
'</table>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE##DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%"'
,p_theme_class_id=>5
,p_grid_type=>'TABLE'
,p_dialog_browser_frame=>'MODAL'
,p_template_comment=>'3'
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002343913349565.4412)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4412)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002490586349565.4412)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4412)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140002552177349565.4412)
,p_page_template_id=>wwv_flow_api.id(91626529080381989.4412)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(91626823864381990.4412)
,p_template_name=>'Button'
,p_internal_name=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="t1Button" cellspacing="0" cellpadding="0" border="0"  summary="">',
'<tr>',
'<td class="t1L"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_left.gif" alt="" width="4" height="24" /></a></td>',
'<td class="t1C"><a href="#LINK#">#LABEL!HTML#</a></td>',
'<td class="t1R"><a href="#LINK#"><img src="#IMAGE_PREFIX#themes/theme_1/button_right.gif" width="4" height="24" alt="" /></a></td>',
'</tr>',
'</table>'))
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/region/reports_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(91632832228382001.4412)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" border="0" summary="" class="t1ReportsRegion" id="#REGION_ID#">',
'<tr>',
'<td class="t1RegionHeader">#TITLE#</td>',
'<td class="t1ButtonHolder">#CLOSE#&nbsp;&nbsp;&nbsp;#PREVIOUS##NEXT##DELETE##EDIT##CHANGE##CREATE##HELP#</td>',
'</tr>',
'<tr>',
'<td class="t1Body" colspan="2">#BODY#</td>',
'</tr>',
'</table>'))
,p_page_plug_template_name=>'Reports Region'
,p_internal_name=>'REPORTS_REGION'
,p_plug_table_bgcolor=>'#ffffff'
,p_theme_id=>1
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#ffffff'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
,p_template_comment=>'Red Theme'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382691031344638.4412)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4412)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382773788344638.4412)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4412)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382895312344637.4412)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4412)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140382923760344637.4412)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4412)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383001370344637.4412)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4412)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383101590344637.4412)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4412)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383260593344637.4412)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4412)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383343091344637.4412)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4412)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383417298344637.4412)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4412)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(140383590781344637.4412)
,p_plug_template_id=>wwv_flow_api.id(91632832228382001.4412)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/vertical_unordered_list_with_bullets
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(91636711305382010.4412)
,p_list_template_current=>'<li class="t1current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#">#TEXT#</a></li>'
,p_list_template_name=>'Vertical Unordered List with Bullets'
,p_internal_name=>'VERTICAL_UNORDERED_LIST_WITH_BULLETS'
,p_theme_id=>1
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="t1VerticalUnorderedListwithBullets">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/standard
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(91638400927382012.4412)
,p_row_template_name=>'Standard'
,p_internal_name=>'STANDARD'
,p_row_template1=>'<td#ALIGNMENT# headers="#COLUMN_HEADER_NAME#" class="t1data">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" border="0" cellspacing="0" summary="">#TOP_PAGINATION#',
'<tr>',
'<td><table cellpadding="0" border="0" cellspacing="0" summary="" class="t1standard">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table><div class="t1CVS">#EXTERNAL_LINK##CSV_LINK#</div></td>',
'</tr>',
'#PAGINATION#',
'</table>'))
,p_row_template_before_first=>'<tr #HIGHLIGHT_ROW#>'
,p_row_template_after_last=>'</tr>'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#" class="t1header">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_next_page_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_page_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS#</a>'
,p_next_set_template=>'<a href="#LINK#" class="t1pagination">#PAGINATION_NEXT_SET#<img src="#IMAGE_PREFIX#themes/theme_1/paginate_next.gif" alt="Next"></a>'
,p_previous_set_template=>'<a href="#LINK#" class="t1pagination"><img src="#IMAGE_PREFIX#themes/theme_1/paginate_prev.gif" alt="Previous">#PAGINATION_PREVIOUS_SET#</a>'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>1
,p_theme_class_id=>4
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/optional_with_help
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(91641225667382016.4412)
,p_template_name=>'Optional with help'
,p_internal_name=>'OPTIONAL_WITH_HELP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999"><a class="t1OptionalwithHelp" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_before_label=>'<div class="t1InlineError">'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#</div>'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/hierarchical_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641730492382017.4412)
,p_name=>'Hierarchical Menu'
,p_internal_name=>'HIERARCHICAL_MENU'
,p_before_first=>'<ul class="t1HierarchicalMenu">'
,p_current_page_option=>'<li class="t1current">#NAME#</li>'
,p_non_current_page_option=>'<li><a href="#LINK#">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>11
,p_start_with_node=>'CHILD_MENU'
,p_theme_id=>1
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/breadcrumb_menu
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(91641814330382017.4412)
,p_name=>'Breadcrumb Menu'
,p_internal_name=>'BREADCRUMB_MENU'
,p_before_first=>'<div class="t1BreadcrumbMenu">'
,p_current_page_option=>'<span class="t1current">#NAME#</span>'
,p_non_current_page_option=>'<a href="#LINK#">#NAME#</a>'
,p_between_levels=>'&nbsp;&gt;&nbsp;'
,p_after_last=>'</div>'
,p_max_levels=>12
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(91642503902382024.4412)
,p_popup_icon=>'#IMAGE_PREFIX#list_gray.gif'
,p_popup_icon_attr=>'width="13" height="13" alt="Popup Lov"'
,p_page_name=>'winlov'
,p_page_title=>unistr('B\00FAsqueda')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#APEX_JAVASCRIPT#',
'<link rel="stylesheet" href="#IMAGE_PREFIX#themes/theme_1/theme_V2.css" type="text/css">',
'',
'#THEME_CSS#',
'</head>'))
,p_page_body_attr=>'onload="first_field()" style="margin:0;"'
,p_before_field_text=>'<div class="t1PopupHead">'
,p_filter_width=>'20'
,p_filter_max_width=>'100'
,p_find_button_text=>'Buscar'
,p_close_button_text=>'Cerrar'
,p_next_button_text=>'Siguiente >'
,p_prev_button_text=>'< Anterior'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'400'
,p_height=>'450'
,p_result_row_x_of_y=>'<br /><div style="padding:2px; font-size:8pt;">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>500
,p_before_result_set=>'<div class="t1PopupBody">'
,p_theme_id=>1
,p_theme_class_id=>1
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/small_calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91641910982382018.4412)
,p_cal_template_name=>'Small Calendar'
,p_internal_name=>'SMALL_CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#DY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallCalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#" class="t1SmallCalendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>'))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallWeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br />#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1SmallWeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1SmallDayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="1" summary="#CALENDAR_TITLE# #START_DL#" class="t1SmallDayCalendar">'
,p_daily_month_close_format=>'</table></td></tr></table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642102481382020.4412)
,p_cal_template_name=>'Calendar'
,p_internal_name=>'CALENDAR'
,p_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarHolder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="0" class="t1Calendar">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarHolder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendar">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="0" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendar">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>1
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/calendar_alternative_1
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(91642303533382020.4412)
,p_cal_template_name=>'Calendar, Alternative 1'
,p_internal_name=>'CALENDAR,_ALTERNATIVE_1'
,p_day_of_week_format=>'<th scope="col" valign="bottom" class="t1DayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1CalendarAlternative1Holder"> ',
' <tr>',
'   <td class="t1MonthTitle">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'))
,p_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="0" class="t1CalendarAlternative1">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td>',
'</tr>',
'</table>',
''))
,p_day_title_format=>'<div class="t1DayTitle">#DD#</div>'
,p_day_open_format=>'<td class="t1Day" valign="top" height="100" height="100">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td valign="top" class="t1Today">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="t1WeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td valign="top" class="t1WeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="t1NonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="t1NonDay" valign="top">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr> '
,p_daily_title_format=>'<table cellspacing="0" cellpadding="0" border="0" summary="" class="t1DayCalendarHolder"> <tr> <td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td> </tr> <tr> <td>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_weekly_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1WeekCalendarAlternative1Holder">',
'<tr>',
'<td class="t1MonthTitle" id="test">#WTITLE#</td>',
'</tr>',
'<tr>',
'<td>'))
,p_weekly_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY#<br>#MM#/#DD#</th>'
,p_weekly_month_open_format=>'<table border="0" cellpadding="0" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL# - #END_DL#" class="t1WeekCalendarAlternative1">'
,p_weekly_month_close_format=>'</table></td></tr></table>'
,p_weekly_day_open_format=>'<td class="t1Day" valign="top">'
,p_weekly_day_close_format=>'<br /></td>'
,p_weekly_today_open_format=>'<td class="t1Today" valign="top">'
,p_weekly_weekend_open_format=>'<td valign="top" class="t1NonDay">'
,p_weekly_weekend_close_format=>'<br /></td>'
,p_weekly_time_open_format=>'<th scope="row" class="t1Hour">'
,p_weekly_time_close_format=>'<br /></th>'
,p_weekly_time_title_format=>'#TIME#'
,p_weekly_hour_open_format=>'<tr>'
,p_weekly_hour_close_format=>'</tr>'
,p_daily_day_of_week_format=>'<th scope="col" class="t1DayOfWeek">#IDAY# #DD#/#MM#</th>'
,p_daily_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" border="0" summary="" role="presentation" class="t1DayCalendarAlternative1Holder"> <tr><td class="t1MonthTitle">#IMONTH# #DD#, #YYYY#</td></tr><tr><td>',
''))
,p_daily_month_open_format=>'<table border="0" cellpadding="2" cellspacing="2" summary="#CALENDAR_TITLE# #START_DL#" class="t1DayCalendarAlternative1">'
,p_daily_month_close_format=>'</table></td> </tr> </table>'
,p_daily_day_open_format=>'<td valign="top" class="t1Day">'
,p_daily_day_close_format=>'<br /></td>'
,p_daily_today_open_format=>'<td valign="top" class="t1Today">'
,p_daily_time_open_format=>'<th scope="row" class="t1Hour">'
,p_daily_time_close_format=>'<br /></th>'
,p_daily_time_title_format=>'#TIME#'
,p_daily_hour_open_format=>'<tr>'
,p_daily_hour_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>1
,p_theme_class_id=>2
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_options
begin
null;
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99504533783304144)
,p_name=>'2DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 2D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99506679073304146)
,p_name=>'2DCOLUMN_LINE'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea de Columnas 2D')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99504617036304144)
,p_name=>'2DDOUGHNUT'
,p_message_language=>'es'
,p_message_text=>'Donut 2D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99506469576304146)
,p_name=>'2DHSTACKED_PCT'
,p_message_language=>'es'
,p_message_text=>'Columna 2D Horizontal Apilada (Porcentaje)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99504779943304144)
,p_name=>'2DLINE'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea 2D')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99504803458304145)
,p_name=>'2DPIE'
,p_message_language=>'es'
,p_message_text=>'Tarta 2D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99506258108304146)
,p_name=>'2DSTACKED_PCT'
,p_message_language=>'es'
,p_message_text=>'Columna 2D Apilada (Porcentaje)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99504989200304145)
,p_name=>'3DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 3D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99506530613304146)
,p_name=>'3DHSTACKED_PCT'
,p_message_language=>'es'
,p_message_text=>'Columna 3D Horizontal Apilada (Porcentaje)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99505009629304145)
,p_name=>'3DPIE'
,p_message_language=>'es'
,p_message_text=>'Tarta 3D'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99506356189304146)
,p_name=>'3DSTACKED_PCT'
,p_message_language=>'es'
,p_message_text=>'Columna 3D Apilada (Porcentaje)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100274484734304772)
,p_name=>'4000.912.0.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'es'
,p_message_text=>'0 elementos para insertar en el diccionario de atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100274287640304772)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE'
,p_message_language=>'es'
,p_message_text=>unistr('0 elementos para la actualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100274639909304772)
,p_name=>'4000.912.0.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'es'
,p_message_text=>unistr('0 elementos para la actualizaci\00F3n del diccionario de atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100275022722304772)
,p_name=>'4000.912.0.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'es'
,p_message_text=>'0 columnas de informe para insertarlas en el diccionario de atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100275210347304773)
,p_name=>'4000.912.0.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'es'
,p_message_text=>unistr('0 columnas de informe para la actualizaci\00F3n del diccionario de atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100274153136304772)
,p_name=>'4000.912.REVIEW.N.ITEMS.FOR.UPDATE'
,p_message_language=>'es'
,p_message_text=>unistr('Revisar %0 elementos para la actualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100274894954304772)
,p_name=>'4000:912:0.RC.FOR.UPDATE'
,p_message_language=>'es'
,p_message_text=>unistr('0 columnas de informe para la actualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100274344433304772)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'
,p_message_language=>'es'
,p_message_text=>'Revisar %0 elementos para insertar en el diccionario de atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100274569642304772)
,p_name=>'4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'
,p_message_language=>'es'
,p_message_text=>unistr('Revisar %0 elementos para la actualizaci\00F3n del diccionario de atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100274944001304772)
,p_name=>'4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'
,p_message_language=>'es'
,p_message_text=>'Revisar %0 columnas de informe para insertarlas en el diccionario de atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100274730711304772)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE'
,p_message_language=>'es'
,p_message_text=>unistr('Revisar %0 columnas de informe para la actualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100275171523304773)
,p_name=>'4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'
,p_message_language=>'es'
,p_message_text=>unistr('Revisar %0 columnas de informe para la actualizaci\00F3n del diccionario de atributos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100066809165304575)
,p_name=>'4000_424_VALUE_MUST_BE_NUMERIC'
,p_message_language=>'es'
,p_message_text=>unistr('El valor debe ser num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100052025028304564)
,p_name=>'4000_639_SEQ_MESG'
,p_message_language=>'es'
,p_message_text=>unistr('<span class="fielddata">No se puede reordenar porque las secuencias de regi\00F3n no son \00FAnicas.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100052165739304564)
,p_name=>'4000_641_SEQ_MESG'
,p_message_language=>'es'
,p_message_text=>unistr('<span class="fielddata">No se puede reordenar porque las secuencias de bot\00F3n no son \00FAnicas.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100052227668304564)
,p_name=>'4000_646_SEQ_MESG'
,p_message_language=>'es'
,p_message_text=>unistr('<span class="fielddata">No se puede reordenar porque las secuencias de barra de navegaci\00F3n no son \00FAnicas.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100052360844304564)
,p_name=>'4000_749_SEQ_MESG'
,p_message_language=>'es'
,p_message_text=>unistr('<span class="fielddata">No se puede reordenar porque las secuencias de elemento de regi\00F3n no son \00FAnicas.</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100121293965304617)
,p_name=>'4000_APPLICATION_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99635969853304246)
,p_name=>'4000_EDIT_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Aplicaci\00F3n: %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100025537867304544)
,p_name=>'4000_INVALID_DATE_FORMAT'
,p_message_language=>'es'
,p_message_text=>unistr('El formato de fecha especificado no es v\00E1lido. El calendario necesita una fecha en formato YYYYMMDD.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100071501644304579)
,p_name=>'4000_TREE'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100121313958304618)
,p_name=>'4000_WORKSPACE_ID'
,p_message_language=>'es'
,p_message_text=>'Identificador de Espacio de Trabajo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99915909472304460)
,p_name=>'4050_106_ENTER_SCHEMA_NAME'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Introduzca el nombre del nuevo esquema que se va a crear. Seleccione',
unistr('         una contrase\00F1a para el esquema y seleccione el tablespace por defecto'),
'         y el tablespace temporal.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99916040259304460)
,p_name=>'4050_106_EXISTING_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'Introduzca el nombre del esquema existente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99916195534304460)
,p_name=>'4050_106_WHEN_DONE'
,p_message_language=>'es'
,p_message_text=>'Cuando termine, haga clic en <strong>Siguiente</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99786208485304356)
,p_name=>'4050_110_DROP_TABLESPACES'
,p_message_language=>'es'
,p_message_text=>'Borrar tablespaces y archivos de datos asociados: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99786180061304356)
,p_name=>'4050_110_DROP_USERS'
,p_message_language=>'es'
,p_message_text=>'Borrar usuarios de base de datos: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100650067743305052)
,p_name=>'4050_139_WEB_SERVICE_ACTIVITY_LOG'
,p_message_language=>'es'
,p_message_text=>'Entradas de log de actividad por servicio web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99498143877304140)
,p_name=>'4050_162_WEB_SOURCE_SYNC_LOG'
,p_message_language=>'es'
,p_message_text=>unistr('Entradas de log de sincronizaci\00F3n de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99498944738304140)
,p_name=>'4050_182_AUTOMATION_LOG'
,p_message_language=>'es'
,p_message_text=>unistr('Entradas de log de automatizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99909863394304455)
,p_name=>'4050_19_LOG_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas de Log de Actividades del Desarrollador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99548721074304181)
,p_name=>'4050_31_LOG_COUNT'
,p_message_language=>'es'
,p_message_text=>unistr('Entradas del Log de Acceso de Conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99909359566304455)
,p_name=>'4050_3_CHANGE_REQUESTS'
,p_message_language=>'es'
,p_message_text=>'Solicitudes de Cambio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99909453624304455)
,p_name=>'4050_3_RUNTIME_REQUESTS'
,p_message_language=>'es'
,p_message_text=>unistr('Solicitudes de Tiempo de Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99909158323304455)
,p_name=>'4050_3_SERVICE_REQUESTS'
,p_message_language=>'es'
,p_message_text=>'Solicitudes de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99911669370304457)
,p_name=>'4050_46_AD_HOC'
,p_message_language=>'es'
,p_message_text=>'Entradas del historial del procesador de comandos SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99911547753304457)
,p_name=>'4050_46_CONTROL_FILE'
,p_message_language=>'es'
,p_message_text=>unistr('Entradas de Log de Ejecuci\00F3n del Archivo de Control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99911447767304457)
,p_name=>'4050_46_SCRIPT_FILE'
,p_message_language=>'es'
,p_message_text=>unistr('Entradas de Log de Ejecuci\00F3n del Script')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99911743522304457)
,p_name=>'4050_46_SQL_ARCHIVES'
,p_message_language=>'es'
,p_message_text=>'Entradas de Archivados de SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99913431575304458)
,p_name=>'4050_61_ACTIVE_LOG'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n de Log Activo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99913573347304458)
,p_name=>'4050_61_CURRENT_LOG_NO'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Log Actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99913602777304458)
,p_name=>'4050_61_CUR_LOG_TIME'
,p_message_language=>'es'
,p_message_text=>'Registro de Hora de Log Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99914233846304459)
,p_name=>'4050_61_HOURS_UNTIL'
,p_message_language=>'es'
,p_message_text=>'Horas hasta el Siguiente Cambio de Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99913883800304459)
,p_name=>'4050_61_INTERVAL_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('Intervalo en D\00EDas (constante)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99914129507304459)
,p_name=>'4050_61_NEXT_LOG_SWITCH'
,p_message_language=>'es'
,p_message_text=>'Siguiente Cambio de Log Planificado para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99914571362304459)
,p_name=>'4050_70_DEV_ACT'
,p_message_language=>'es'
,p_message_text=>'Entradas de Log de Actividades del Desarrollador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99914744121304459)
,p_name=>'4050_71_CLICK'
,p_message_language=>'es'
,p_message_text=>'Entradas de Log de Clics de Paso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99915502374304460)
,p_name=>'4050_75_AD_HOC'
,p_message_language=>'es'
,p_message_text=>'Entradas del historial del procesador de comandos SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99915441060304460)
,p_name=>'4050_75_CTRL_FILE'
,p_message_language=>'es'
,p_message_text=>unistr('Entradas de Log de Ejecuci\00F3n del Archivo de Control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99915272421304460)
,p_name=>'4050_75_SCRIPT_FILE'
,p_message_language=>'es'
,p_message_text=>unistr('Entradas de Log de Ejecuci\00F3n del Script')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99915647244304460)
,p_name=>'4050_75_SQL_ARCH'
,p_message_language=>'es'
,p_message_text=>'Entradas de Archivados de SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99915703157304460)
,p_name=>'4050_82_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'El espacio de trabajo %1 tiene %2 aplicaciones y %3 usuarios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99915817313304460)
,p_name=>'4050_85_CLICK_COUNT'
,p_message_language=>'es'
,p_message_text=>'Entradas de Log de Recuento de Clics'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100096998544304599)
,p_name=>'4050_PACKAGED_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones de ejemplo y de productividad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100097075327304599)
,p_name=>'4050_PACKAGED_WEBSHEETS'
,p_message_language=>'es'
,p_message_text=>unistr('Hojas de c\00E1lculo web de ejemplo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100096246471304598)
,p_name=>'4050_WORKSPACE_COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento de Espacios de Trabajo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99843323337304402)
,p_name=>'4350_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99843433664304402)
,p_name=>'4350_EDIT_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Aplicaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99563203204304192)
,p_name=>'4500 800 HD DBA'
,p_message_language=>'es'
,p_message_text=>'DBA de Oracle Database Express Edition 2 Day.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99563388745304192)
,p_name=>'4500 800 HD DEV'
,p_message_language=>'es'
,p_message_text=>'Oracle Database Express Edition 2 Day Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99563140412304192)
,p_name=>'4500 800 HD HTMLDB'
,p_message_language=>'es'
,p_message_text=>'Oracle Application Express 2 Day Plus Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99563497983304192)
,p_name=>'4500 800 HD JAVA'
,p_message_language=>'es'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus Java Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99563544976304192)
,p_name=>'4500 800 HD NET'
,p_message_language=>'es'
,p_message_text=>'Oracle Database Express Edition 2 Day Plus .NET Developer Guide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99563626139304192)
,p_name=>'4500 800 HD PHP'
,p_message_language=>'es'
,p_message_text=>'Desarrollador PHP de Oracle Database Express Edition 2 Day Plus.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99563730503304192)
,p_name=>'4500 800 MSG DBA'
,p_message_language=>'es'
,p_message_text=>unistr('Incluye tareas de administraci\00F3n comunes del d\00EDa a d\00EDa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99563813656304192)
,p_name=>'4500 800 MSG DEV'
,p_message_language=>'es'
,p_message_text=>unistr('Explica c\00F3mo aprovechar las ventajas del entorno de desarrollo de Oracle Database Express Edition.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99563981234304192)
,p_name=>'4500 800 MSG HTMLDB'
,p_message_language=>'es'
,p_message_text=>unistr('Proporciona una serie de tutoriales que describen c\00F3mo crear aplicaciones Web basadas en bases de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99564159283304193)
,p_name=>'4500 800 MSG JAVA'
,p_message_language=>'es'
,p_message_text=>unistr('Este documento proporciona un tutorial que le ayudar\00E1 a utilizar Java y JDBC para conectarse a Oracle Database Express Edition. Tambi\00E9n le ense\00F1ar\00E1 a utilizar y desarrollar una sencilla aplicaci\00F3n Java para acceder y modificar los datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99564269311304193)
,p_name=>'4500 800 MSG NET'
,p_message_language=>'es'
,p_message_text=>unistr('Este documento describe las funciones clave de Oracle Data Provider para .NET y Oracle Developer Tools para Visual Studio .NET. Le guiar\00E1 a trav\00E9s de la instalaci\00F3n y configuraci\00F3n y le ense\00F1ar\00E1 a crear aplicaciones b\00E1sicas utilizando Oracle Data Pro')
||unistr('vider para .NET y Oracle Developer Tools para Visual Studio .NET, adem\00E1s le mostrar\00E1 c\00F3mo crear y utilizar procedimientos almacenados de PL/SQL y de .NET.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99564083833304192)
,p_name=>'4500 800 MSG PHP'
,p_message_language=>'es'
,p_message_text=>unistr('Este documento le ense\00F1ar\00E1 a descargar e instalar Apache y los controladores de Zend Core PHP. Tambi\00E9n le ense\00F1ar\00E1 a utilizar PHP para conectarse a Oracle Database Express Edition y realiza una demostraci\00F3n de c\00F3mo utilizar PHP para desarrollar una s')
||unistr('encilla aplicaci\00F3n para acceder y modificar los datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99534715287304167)
,p_name=>'4500_1002_QB_CLONE_ALIAS'
,p_message_language=>'es'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99534644600304167)
,p_name=>'4500_1002_QB_CLONE_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99534968372304167)
,p_name=>'4500_1002_QB_CLONE_CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99966511515304499)
,p_name=>'4500_1002_QB_CLONE_DEL'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99535322796304167)
,p_name=>'4500_1002_QB_CLONE_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99535458262304168)
,p_name=>'4500_1002_QB_CLONE_GROUP'
,p_message_language=>'es'
,p_message_text=>'Agrupar por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99534893210304167)
,p_name=>'4500_1002_QB_CLONE_OBJECT'
,p_message_language=>'es'
,p_message_text=>'Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99535226498304167)
,p_name=>'4500_1002_QB_CLONE_OUTPUT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99535042506304167)
,p_name=>'4500_1002_QB_CLONE_SORT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Orden'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99535188450304167)
,p_name=>'4500_1002_QB_CLONE_SORT_ORDER'
,p_message_language=>'es'
,p_message_text=>unistr('Orden de Clasificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99537983849304169)
,p_name=>'4500_1002_QB_JOIN'
,p_message_language=>'es'
,p_message_text=>unistr('Uni\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99531707727304165)
,p_name=>'4500_1002_QB_JOIN_HINT'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic aqu\00ED para seleccionar la columna que desea unir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99538330635304170)
,p_name=>'4500_1002_QB_MAX_COLS'
,p_message_language=>'es'
,p_message_text=>unistr('Se puede seleccionar un m\00E1ximo de 60 columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99531671775304165)
,p_name=>'4500_1002_QB_REMOVE_TABLE'
,p_message_language=>'es'
,p_message_text=>'Eliminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99531502825304165)
,p_name=>'4500_1002_QB_SHOW_COLS'
,p_message_language=>'es'
,p_message_text=>'Mostrar/Ocultar Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99538033609304169)
,p_name=>'4500_1002_QB_TO'
,p_message_language=>'es'
,p_message_text=>'a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99530505561304164)
,p_name=>'4500_1220_SCRIPT_RESULT'
,p_message_language=>'es'
,p_message_text=>unistr('Resultados de %0, ejecuci\00F3n %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99786833471304356)
,p_name=>'4500_46_RET_TO_QUERY'
,p_message_language=>'es'
,p_message_text=>'Volver a la Consulta Original'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99545737122304178)
,p_name=>'4500_OBJECT_BROWSER_ONLY_N_COLS'
,p_message_language=>'es'
,p_message_text=>'Se muestran las %0 primeras columnas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99994121460304520)
,p_name=>'4500_SESS_EVENT'
,p_message_language=>'es'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99994011440304520)
,p_name=>'4500_SESS_KILOBYTES'
,p_message_language=>'es'
,p_message_text=>'KB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99993947886304520)
,p_name=>'4500_SESS_MEGABYTES'
,p_message_language=>'es'
,p_message_text=>'MB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99566562976304194)
,p_name=>'4500_UI_DEF_HINT_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('El creador de aplicaciones utiliza los valores por defecto de la interfaz de usuario para rellenar con valores iniciales las propiedades de regi\00F3n y elemento, a fin de proporcionar consistencia entre p\00E1ginas de una aplicaci\00F3n o entre varias aplicacio')
||'nes.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99596687384304217)
,p_name=>'4550_COOKIES_ENABLED'
,p_message_language=>'es'
,p_message_text=>unistr('Esta aplicaci\00F3n necesita que las cookies est\00E9n activadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99596575890304217)
,p_name=>'4550_JAVASCRIPT_ENABLED'
,p_message_language=>'es'
,p_message_text=>unistr('Esta aplicaci\00F3n necesita que JavaScript est\00E9 activado.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100023877835304543)
,p_name=>'ABOUT'
,p_message_language=>'es'
,p_message_text=>'Acerca de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100717385440305106)
,p_name=>'ABOUT_TO_CREATE_USERS'
,p_message_language=>'es'
,p_message_text=>unistr('Confirme la adici\00F3n de los siguientes %0 usuarios al espacio de trabajo.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100035390443304551)
,p_name=>'ACCEPTED'
,p_message_language=>'es'
,p_message_text=>'Aceptado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100003445239304527)
,p_name=>'ACCESSIBILITY_ASSIGNEE'
,p_message_language=>'es'
,p_message_text=>'Persona asignada a Accesibilidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100001501947304526)
,p_name=>'ACCESSIBILITY_IMPACT'
,p_message_language=>'es'
,p_message_text=>'Impacto de Accesibilidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100003870407304528)
,p_name=>'ACCESSIBILITY_STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado de Accesibilidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100768263163305144)
,p_name=>'ACCESSIBILITY_TESTED'
,p_message_language=>'es'
,p_message_text=>'Accesibilidad Probada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99677003232304276)
,p_name=>'ACCESS_CONTROL_ADMIN_AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Derechos de administraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99543342569304173)
,p_name=>'ACCESS_CONTROL_ADMIN_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Administraci\00F3n de Control de Acceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99955767947304491)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE'
,p_message_language=>'es'
,p_message_text=>'Administrador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100060631367304570)
,p_name=>'ACCESS_CONTROL_ADMIN_ROLE_DESC'
,p_message_language=>'es'
,p_message_text=>'Rol asignado a los administradores de aplicaciones.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99543507693304174)
,p_name=>'ACCESS_CONTROL_APP_ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n de Aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99544155404304177)
,p_name=>'ACCESS_CONTROL_APP_MODE'
,p_message_language=>'es'
,p_message_text=>unistr('Modo de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99544013838304177)
,p_name=>'ACCESS_CONTROL_APP_MODE_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Identifique c\00F3mo se va a controlar el acceso a esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99545166118304178)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido procesar la solicitud de modo de aplicaci\00F3n definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99545232567304178)
,p_name=>'ACCESS_CONTROL_APP_MODE_SET_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Modo de Aplicaci\00F3n Definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99677493532304276)
,p_name=>'ACCESS_CONTROL_CANNOT_DELETE'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede suprimir a s\00ED mismo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99677595470304276)
,p_name=>'ACCESS_CONTROL_CANNOT_REMOVE_ADMIN'
,p_message_language=>'es'
,p_message_text=>'No puede eliminar su propio privilegio de administrador.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99543424794304174)
,p_name=>'ACCESS_CONTROL_CONFIRM_TABLE'
,p_message_language=>'es'
,p_message_text=>'Crear Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99955670450304491)
,p_name=>'ACCESS_CONTROL_CONTRIB_AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Derechos de contribuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99955850688304491)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE'
,p_message_language=>'es'
,p_message_text=>'Contribuyente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100060770215304570)
,p_name=>'ACCESS_CONTROL_CONTRIB_ROLE_DESC'
,p_message_language=>'es'
,p_message_text=>'Rol asignado a los contribuyentes de aplicaciones.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99996375747304522)
,p_name=>'ACCESS_CONTROL_CREATE_APP_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1n los siguientes valores de aplicaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99955918278304491)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_ROLE'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1n los siguientes roles de acceso a la aplicaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99560704052304190)
,p_name=>'ACCESS_CONTROL_CREATE_AUTH_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1n los siguientes esquemas de autorizaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99616508528304231)
,p_name=>'ACCESS_CONTROL_CREATE_PAGE_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de control de acceso. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99616430862304231)
,p_name=>'ACCESS_CONTROL_CREATE_TABLE_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se han podido crear tablas de control de acceso. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99678810617304277)
,p_name=>'ACCESS_CONTROL_DUP_USERNAME'
,p_message_language=>'es'
,p_message_text=>'No puede introducir un nombre de usuario duplicado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99677155330304276)
,p_name=>'ACCESS_CONTROL_EDIT_AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('control de acceso: edici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99544862428304178)
,p_name=>'ACCESS_CONTROL_FIND_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca criterios de consulta que no sean sensibles a may\00FAsculas/min\00FAsculas y haga clic en el bot\00F3n <strong>Ir</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99544961276304178)
,p_name=>'ACCESS_CONTROL_GET_APP_MODE_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido obtener el modo de administraci\00F3n de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99544762578304178)
,p_name=>'ACCESS_CONTROL_LAST_CHANGED_BY'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimo Cambio de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99544431046304177)
,p_name=>'ACCESS_CONTROL_LIST'
,p_message_language=>'es'
,p_message_text=>'Lista de Control de Acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99543621857304174)
,p_name=>'ACCESS_CONTROL_MODE1'
,p_message_language=>'es'
,p_message_text=>'Acceso completo a todos, no se utiliza la lista de control de acceso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99543708756304177)
,p_name=>'ACCESS_CONTROL_MODE2'
,p_message_language=>'es'
,p_message_text=>unistr('Acceso restringido. S\00F3lo se permite a los usuarios definidos en la lista de control de acceso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99543850578304177)
,p_name=>'ACCESS_CONTROL_MODE3'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo lectura p\00FAblica. Privilegios de edici\00F3n y administraci\00F3n controlados por lista de control de acceso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99543949599304177)
,p_name=>'ACCESS_CONTROL_MODE4'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo acceso administrativo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99545037197304178)
,p_name=>'ACCESS_CONTROL_NO_PRIV'
,p_message_language=>'es'
,p_message_text=>unistr('No tiene privilegios para realizar esta acci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99544678856304178)
,p_name=>'ACCESS_CONTROL_PRIV'
,p_message_language=>'es'
,p_message_text=>'Privilegio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99996213045304522)
,p_name=>'ACCESS_CONTROL_READER_AUTH'
,p_message_language=>'es'
,p_message_text=>'Derechos de lector'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99996153333304522)
,p_name=>'ACCESS_CONTROL_READER_ROLE'
,p_message_language=>'es'
,p_message_text=>'Lector'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100060870949304571)
,p_name=>'ACCESS_CONTROL_READER_ROLE_DESC'
,p_message_language=>'es'
,p_message_text=>'Rol asignado a los lectores de aplicaciones.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99561546220304191)
,p_name=>'ACCESS_CONTROL_RPT_REGION_HEADER'
,p_message_language=>'es'
,p_message_text=>unistr('Identifique nombres de usuario que se corresponden con el esquema de autenticaci\00F3n de esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99544249598304177)
,p_name=>'ACCESS_CONTROL_SET_APP_MODE'
,p_message_language=>'es'
,p_message_text=>unistr('Definir Modo de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99642631968304251)
,p_name=>'ACCESS_CONTROL_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Las p\00E1ginas de control de acceso se han creado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99956083466304491)
,p_name=>'ACCESS_CONTROL_USE_AUTH_ROLE'
,p_message_language=>'es'
,p_message_text=>'Usar el rol de control de acceso existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99561460550304190)
,p_name=>'ACCESS_CONTROL_USE_AUTH_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Usar Esquema de Autorizaci\00F3n Existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99560634686304190)
,p_name=>'ACCESS_CONTROL_USE_TABLE'
,p_message_language=>'es'
,p_message_text=>'Usar Tabla Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99677290805304276)
,p_name=>'ACCESS_CONTROL_VIEW_AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('control de acceso: visualizaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99564457472304193)
,p_name=>'ACCOUNT_CREATED'
,p_message_language=>'es'
,p_message_text=>'Cuenta creada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100250131821304754)
,p_name=>'ACCOUNT_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA Cuenta')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99984081651304512)
,p_name=>'ACKNOWLEDGED'
,p_message_language=>'es'
,p_message_text=>'Confirmado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99984230014304513)
,p_name=>'ACKNOWLEDGED_NO_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Confirmado, sin acci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100044751337304558)
,p_name=>'ACL_ADD_USER'
,p_message_language=>'es'
,p_message_text=>'Agregar Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100653307804305054)
,p_name=>'ACL_TABLE.ACCESS_DASHBOARD'
,p_message_language=>'es'
,p_message_text=>'Acceder a Panel de Control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100653450628305054)
,p_name=>'ACL_TABLE.ACCESS_MONITOR'
,p_message_language=>'es'
,p_message_text=>'Acceder a Control de Actividad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100652945847305054)
,p_name=>'ACL_TABLE.ADD_MODIFY'
,p_message_language=>'es'
,p_message_text=>'Agregar/Modificar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100653294907305054)
,p_name=>'ACL_TABLE.ADMIN_WHEN_RUNNING'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n al Ejecutar Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100652148199305053)
,p_name=>'ACL_TABLE.ADMIN_WITHIN_BUILDER'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n desde Creador de Aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100652828484305054)
,p_name=>'ACL_TABLE.ANNOTATIONS'
,p_message_language=>'es'
,p_message_text=>'Anotaciones (archivos, etiquetas, notas)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100651897938305053)
,p_name=>'ACL_TABLE.APEX_AUTH_WO_ACL'
,p_message_language=>'es'
,p_message_text=>unistr('Autenticaci\00F3n de Cuenta de Application Express sin Lista de Control de Acceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100651714441305053)
,p_name=>'ACL_TABLE.AUTH_WITH_ACL'
,p_message_language=>'es'
,p_message_text=>unistr('Autenticaci\00F3n con Lista de Control de Acceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100652543776305054)
,p_name=>'ACL_TABLE.EDIT_SQL_ACCESS'
,p_message_language=>'es'
,p_message_text=>'Editar Acceso SQL y Objetos Sugeridos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100656568974305057)
,p_name=>'ACL_TABLE.INTRO_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Tras su autenticaci\00F3n en una aplicaci\00F3n, el control de acceso especifica lo que los usuarios pueden hacer dentro de la misma. En la tabla que se muestra a continuaci\00F3n se indican las capacidades que tienen los distintos tipos de usuario en funci\00F3n de')
||unistr(' la autenticaci\00F3n que se utiliza dentro de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100653544129305054)
,p_name=>'ACL_TABLE.MAINTAIN_ACL'
,p_message_language=>'es'
,p_message_text=>'Mantener Lista de Control de Acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100652637868305054)
,p_name=>'ACL_TABLE.RUN_AND_VIEW'
,p_message_language=>'es'
,p_message_text=>'Ejecutar y Ver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100652349683305054)
,p_name=>'ACL_TABLE.UPDATE_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Actualizar Propiedades de la Aplicaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100269673688304769)
,p_name=>'ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Acciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100651218405305053)
,p_name=>'ACTION_MENU_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n del Men\00FA Acci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99572942649304199)
,p_name=>'ACTIVE'
,p_message_language=>'es'
,p_message_text=>'Activo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99963036550304496)
,p_name=>'ACTIVITY'
,p_message_language=>'es'
,p_message_text=>'Actividad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100004717557304528)
,p_name=>'ACTIVITY_SUMMARY'
,p_message_language=>'es'
,p_message_text=>'Resumen de Actividad'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100205334505304719)
,p_name=>'ADDED_BY'
,p_message_language=>'es'
,p_message_text=>'Agregado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100647649998305050)
,p_name=>'ADDED_TO_PURGE_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Agregado a Lista de Depuraci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100262569852304763)
,p_name=>'ADDITIONAL_INFORMATION_REQUESTED'
,p_message_language=>'es'
,p_message_text=>unistr('Se necesita informaci\00F3n adicional')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99922827460304466)
,p_name=>'ADD_ARGUEMENT'
,p_message_language=>'es'
,p_message_text=>'Agregar Argumento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99913239681304458)
,p_name=>'ADD_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Agregar Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100110508497304609)
,p_name=>'ADD_COLUMN_NAME'
,p_message_language=>'es'
,p_message_text=>'Agregar Columna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99752426527304331)
,p_name=>'ADD_CONSTRAINT'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar Restricci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99911374606304457)
,p_name=>'ADD_MORE...'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar M\00E1s...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99977178237304507)
,p_name=>'ADD_ROW'
,p_message_language=>'es'
,p_message_text=>'Agregar Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100115684017304613)
,p_name=>'ADD_USER_INTERFACE'
,p_message_language=>'es'
,p_message_text=>'Agregar Interfaz de Usuario'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100119183402304616)
,p_name=>'ADJUST_PROVISIONED_SPACE'
,p_message_language=>'es'
,p_message_text=>'Ajustar Espacio Proporcionado en %0 MB'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99910012173304456)
,p_name=>'ADMIN'
,p_message_language=>'es'
,p_message_text=>'Administrador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99498833570304140)
,p_name=>'ADMIN.WORKSPACE_BANNER_COLOR'
,p_message_language=>'es'
,p_message_text=>'Color de banner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99498681907304140)
,p_name=>'ADMIN.WORKSPACE_BANNER_ENABLE'
,p_message_language=>'es'
,p_message_text=>'Activar banner de entorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99498706375304140)
,p_name=>'ADMIN.WORKSPACE_BANNER_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de banner'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99918067496304462)
,p_name=>'ADMIN.WORKSPACE_BANNER_POS'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de banner')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99556887876304187)
,p_name=>'ADMINISTRATOR'
,p_message_language=>'es'
,p_message_text=>'Administrador de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100004590924304528)
,p_name=>'ADMINISTRATORS'
,p_message_language=>'es'
,p_message_text=>'Administradores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99916704811304461)
,p_name=>'ADMIN_EMAIL_MUST_BE_PROV'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe proporcionar el correo electr\00F3nico de los administradores')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100069010035304577)
,p_name=>'ADVISOR.CATEGORY.ACCESSIBILITY'
,p_message_language=>'es'
,p_message_text=>'Accesibilidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99579362028304204)
,p_name=>'ADVISOR.CATEGORY.ERROR'
,p_message_language=>'es'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99579613471304204)
,p_name=>'ADVISOR.CATEGORY.PERFORMANCE'
,p_message_language=>'es'
,p_message_text=>'Rendimiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99579752696304204)
,p_name=>'ADVISOR.CATEGORY.QA'
,p_message_language=>'es'
,p_message_text=>'Control de Calidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99579481174304204)
,p_name=>'ADVISOR.CATEGORY.SECURITY'
,p_message_language=>'es'
,p_message_text=>'Seguridad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99579804450304205)
,p_name=>'ADVISOR.CATEGORY.USABILITY'
,p_message_language=>'es'
,p_message_text=>'Uso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99579551682304204)
,p_name=>'ADVISOR.CATEGORY.WARNING'
,p_message_language=>'es'
,p_message_text=>'Advertencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100174049815304696)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.DA'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento "%1" est\00E1 protegido y no se puede definir mediante una llamada de AJAX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100174160244304696)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento "%1" est\00E1 protegido y no se puede definir mediante una llamada de AJAX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100203433227304718)
,p_name=>'ADVISOR.CHECK.AJAX_ITEMS_WITH_SSP.MSG_AJAX_ITEMS_WITH_SSP.REGION'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento "%1" est\00E1 protegido y no se puede definir mediante una llamada de AJAX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99605758854304223)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_MISSING_SYS_PREFIX'
,p_message_language=>'es'
,p_message_text=>'Falta el prefijo de esquema SYS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100309746909304798)
,p_name=>'ADVISOR.CHECK.APEX_CODE_SMELL.MSG_WWV_FLOW'
,p_message_language=>'es'
,p_message_text=>'Sintaxis de las API WWV_FLOW (utilice API de APEX en su lugar)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100260030819304762)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IG_COLUMN_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('La columna %0 no existe en la sentencia SQL de origen de regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99589414091304212)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_IR_FILTER_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'La columna de informe interactivo %0 no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99587169926304210)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'%0 no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99567449335304195)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_REGION_COLUMN_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('La columna %0 no existe en la sentencia SQL de origen de regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100339876451304821)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_TABFORM_COLUMN_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'La columna la pantalla tabular %0 no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99587251454304210)
,p_name=>'ADVISOR.CHECK.APPL_PAGE_ITEM_REF.MSG_WRONG_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede hacer referencia a %0 como nombre del elemento de aplicaci\00F3n o p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100722414775305110)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_APP_PROC_AUTHORIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('El proceso de aplicaci\00F3n de devoluci\00F3n de llamada de AJAX no est\00E1 protegido por un esquema de autorizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100722004963305110)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_PAGE_AUTHORIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina no est\00E1 protegida por un esquema de autorizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99588104534304211)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_NO_TARGET_AUTH_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina de destino %1 (de la aplicaci\00F3n %0) no tiene ning\00FAn esquema de autorizaci\00F3n definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100723701042305111)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_PARENT_PAGE_AUTH_DIFFERENT'
,p_message_language=>'es'
,p_message_text=>unistr('La autorizaci\00F3n de esta p\00E1gina es diferente en la autorizaci\00F3n "%1" de la p\00E1gina principal %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99588210095304211)
,p_name=>'ADVISOR.CHECK.AUTHORIZATION.MSG_TARGET_AUTH_DIFFERENT'
,p_message_language=>'es'
,p_message_text=>unistr('La autorizaci\00F3n "%0" de la p\00E1gina de destino es diferente a "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99586729570304210)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'%0 no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99586675518304210)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_UNKNOWN_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido realizar una comprobaci\00F3n de sintaxis de la variable de enlace. Error: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99586870513304210)
,p_name=>'ADVISOR.CHECK.BIND_VARIABLE_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'es'
,p_message_text=>'No se puede hacer referencia a %0 con la sintaxis de variable de enlace.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99588876264304211)
,p_name=>'ADVISOR.CHECK.BRANCH_SEQUENCE.MSG_FOUND'
,p_message_language=>'es'
,p_message_text=>'Rama incondicional antes que otras ramas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100721882706305110)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_AUTOCOMPLETE'
,p_message_language=>'es'
,p_message_text=>unistr('Terminar Autom\00E1ticamente se ha definido en "Activado" para la p\00E1gina que contiene los elementos de contrase\00F1a.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100721947638305110)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_CACHE'
,p_message_language=>'es'
,p_message_text=>unistr('"Cach\00E9" permite al explorador almacenar la cach\00E9 de los datos importantes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100521586792304957)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_BROWSER_FRAME'
,p_message_language=>'es'
,p_message_text=>unistr('"Embeber en Macros" vuelve a la aplicaci\00F3n vulnerable ante los ataques de clickjacking (secuestro de clics).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100521687972304957)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_HTML_ESCAPING_MODE'
,p_message_language=>'es'
,p_message_text=>unistr('"Modo de Identificaci\00F3n de HTML" solo identifica un juego limitado de caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99510183416304148)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_ITEM_OUTPUT_ESCAPING'
,p_message_language=>'es'
,p_message_text=>'Los elementos deben identificar los caracteres especiales para evitar ataques de scripts de sitios (XSS).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100528656624304962)
,p_name=>'ADVISOR.CHECK.BROWSER_SECURITY.MSG_REFERRER_POLICY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La cabecera de solicitud HTTP "Referer" puede desvelar informaci\00F3n de sesi\00F3n confidencial a terceros.'),
'Las aplicaciones deben definir "Referrer Policy" en "strict-origin".'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99526284576304161)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_ID_FOUND_IN_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Identificador encontrado en los atributos de bot\00F3n, para un bot\00F3n al que se hace referencia en una acci\00F3n din\00E1mica (%0). '),
'',
unistr('Cuando se define un identificador en atributos de bot\00F3n, no funcionan las acciones din\00E1micas que hacen referencia al bot\00F3n. Elimine este identificador, ya que el bot\00F3n generar\00E1 un identificador por defecto.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99526336713304161)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_COMPATIBLE.MSG_TEMPLATE_BUTTON_NO_BUTTON_ID'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La plantilla de bot\00F3n utilizada por un bot\00F3n al que hace referencia una acci\00F3n din\00E1mica (%0) no contiene la cadena de sustituci\00F3n #BUTTON_ID#.'),
'',
'Plantilla:',
'%1',
'',
unistr('Agregue la cadena de sustituci\00F3n #BUTTON_ID# a esta plantilla o cambie la plantilla de bot\00F3n por una que incluya la cadena de sustituci\00F3n #BUTTON_ID#.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99529621811304163)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_ACTION_NOT_DEFINED_BY_DA'
,p_message_language=>'es'
,p_message_text=>unistr('El bot\00F3n ''Acci\00F3n'' no est\00E1 definido por una acci\00F3n din\00E1mica para un bot\00F3n al que se hace referencia en una acci\00F3n din\00E1mica (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99535735665304168)
,p_name=>'ADVISOR.CHECK.BUTTON_DA_INCONSISTENT_REFS.MSG_NO_BUTTON_DEFINED_FOR_DA'
,p_message_language=>'es'
,p_message_text=>unistr('El bot\00F3n (%0) tiene una acci\00F3n definida por acci\00F3n din\00E1mica, pero no hay ninguna acci\00F3n din\00E1mica correspondiente que haga referencia a este bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99587868058304210)
,p_name=>'ADVISOR.CHECK.CLEAR_CACHE_PAGE_NUMBER.MSG_OTHER_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina Borrar Cach\00E9 %0 no es la p\00E1gina actual ni la de destino %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99586543509304209)
,p_name=>'ADVISOR.CHECK.COLUMN_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'%0 no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100695664298305090)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_ATTRIBUTE'
,p_message_language=>'es'
,p_message_text=>unistr('Este valor de atributo est\00E1 en desuso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100698180737305092)
,p_name=>'ADVISOR.CHECK.DEPRECATED_ATTRIBUTES.MSG_COMPONENT_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Este tipo de componente est\00E1 en desuso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100174244387304696)
,p_name=>'ADVISOR.CHECK.DESC_AJAX_ITEMS_WITH_SSP'
,p_message_language=>'es'
,p_message_text=>'Elementos protegidos en llamadas AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99605640510304223)
,p_name=>'ADVISOR.CHECK.DESC_APEX_CODE_SMELL'
,p_message_language=>'es'
,p_message_text=>unistr('Hediondez de c\00F3digo (APEX interno)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99584634823304208)
,p_name=>'ADVISOR.CHECK.DESC_APPL_PAGE_ITEM_REF'
,p_message_language=>'es'
,p_message_text=>unistr('Referencias Declarativas de Elementos de Aplicaci\00F3n, Elementos de P\00E1gina, Columnas o Filtros de Informe Interactivo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100721724910305110)
,p_name=>'ADVISOR.CHECK.DESC_AUTHORIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99584367416304208)
,p_name=>'ADVISOR.CHECK.DESC_BIND_VARIABLE_SYNTAX'
,p_message_language=>'es'
,p_message_text=>'Referencias con Sintaxis de Variable de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99585788418304209)
,p_name=>'ADVISOR.CHECK.DESC_BRANCH_SEQUENCE'
,p_message_language=>'es'
,p_message_text=>'Rama incondicional antes que otras ramas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100722223109305110)
,p_name=>'ADVISOR.CHECK.DESC_BROWSER_SECURITY'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de Seguridad del Explorador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99526148562304160)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_COMPATIBLE'
,p_message_language=>'es'
,p_message_text=>unistr('El bot\00F3n no es compatible con las acciones din\00E1micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99535563834304168)
,p_name=>'ADVISOR.CHECK.DESC_BUTTON_DA_INCONSISTENT_REFS'
,p_message_language=>'es'
,p_message_text=>unistr('Referencias inconsistentes entre las acciones din\00E1micas y los botones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99584978343304208)
,p_name=>'ADVISOR.CHECK.DESC_CLEAR_CACHE_PAGE_NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero de p\00E1gina Borrar Cach\00E9 es igual a la p\00E1gina de destino o actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99584242306304208)
,p_name=>'ADVISOR.CHECK.DESC_COLUMN_SYNTAX'
,p_message_language=>'es'
,p_message_text=>'Referencias con Sintaxis de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100695534595305090)
,p_name=>'ADVISOR.CHECK.DESC_DEPRECATED_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>'Valores de Atributo En desuso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99585282187304209)
,p_name=>'ADVISOR.CHECK.DESC_DML_PROCESSES'
,p_message_language=>'es'
,p_message_text=>unistr('Los procesos Recuperaci\00F3n, DML, MR* son v\00E1lidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99585671038304209)
,p_name=>'ADVISOR.CHECK.DESC_HARDCODED_APPLICATION_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador de Aplicaci\00F3n de C\00F3digo Fuente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99981361221304510)
,p_name=>'ADVISOR.CHECK.DESC_HAS_HELP_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de P\00E1gina con Texto de Ayuda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100068800520304577)
,p_name=>'ADVISOR.CHECK.DESC_HAS_PAGE_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina tiene t\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100093013528304596)
,p_name=>'ADVISOR.CHECK.DESC_IMAGE_ITEM_HAS_ALT'
,p_message_language=>'es'
,p_message_text=>'El elemento Mostrar imagen tiene texto alternativo de imagen definido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100521349418304957)
,p_name=>'ADVISOR.CHECK.DESC_INSECURE_APPLICATION_DEFAULTS'
,p_message_language=>'es'
,p_message_text=>unistr('Atributos de aplicaci\00F3n que se pueden bloquear')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99584483184304208)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento de referencia est\00E1 en la p\00E1gina actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99584542084304208)
,p_name=>'ADVISOR.CHECK.DESC_IS_ITEM_OF_TARGET_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento de referencia es el elemento de p\00E1gina de la p\00E1gina de destino')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100069584645304577)
,p_name=>'ADVISOR.CHECK.DESC_ITEMS_NO_CONTEXT_CHANGE'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento de p\00E1gina no causa ning\00FAn cambio de contexto inesperado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100070241304304578)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_HAS_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento de p\00E1gina tiene etiqueta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99585942818304209)
,p_name=>'ADVISOR.CHECK.DESC_ITEM_NAME_LENGTH'
,p_message_language=>'es'
,p_message_text=>'Longitud de Elemento o Nombre de Columna de Pantalla Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99584791756304208)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_ITEM_REF_AS_STRING'
,p_message_language=>'es'
,p_message_text=>unistr('Referencias de Elemento de P\00E1gina en una Cadena')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99584814831304208)
,p_name=>'ADVISOR.CHECK.DESC_PAGE_NUMBER_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('Existe N\00FAmero de P\00E1gina de Referencia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100069125828304577)
,p_name=>'ADVISOR.CHECK.DESC_REGION_HAS_ROW_HEADER'
,p_message_language=>'es'
,p_message_text=>unistr('La regi\00F3n tiene fila de cabecera')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99586167146304209)
,p_name=>'ADVISOR.CHECK.DESC_REPORT_DEFAULT_ORDER'
,p_message_language=>'es'
,p_message_text=>'El informe tiene un orden por defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100722301318305110)
,p_name=>'ADVISOR.CHECK.DESC_SESSION_STATE_PROTECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99585313809304209)
,p_name=>'ADVISOR.CHECK.DESC_SQL_INJECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Uso incorrecto de sintaxis de sustituci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99584128058304208)
,p_name=>'ADVISOR.CHECK.DESC_SUBSTITUTION_SYNTAX'
,p_message_language=>'es'
,p_message_text=>unistr('Referencias con Sintaxis de Sustituci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99585129558304208)
,p_name=>'ADVISOR.CHECK.DESC_TARGET_PAGE_AUTH_USABILITY'
,p_message_language=>'es'
,p_message_text=>unistr('La autorizaci\00F3n de p\00E1gina de destino est\00E1 definida tambi\00E9n para el componente actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100069344109304577)
,p_name=>'ADVISOR.CHECK.DESC_THEME_STYLE_IS_ACCESSIBLE'
,p_message_language=>'es'
,p_message_text=>'Accesibilidad de estilo de tema probada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100164186380304689)
,p_name=>'ADVISOR.CHECK.DESC_UI_INCLUDES_COMPATIBILITY_JS'
,p_message_language=>'es'
,p_message_text=>'La interfaz de usuario incluye JavaScript de compatibilidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99585890491304209)
,p_name=>'ADVISOR.CHECK.DESC_VALIDATION_ASSOCIATED_ITEM'
,p_message_language=>'es'
,p_message_text=>'Elemento o Columna de Validaciones Asociado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99585073337304208)
,p_name=>'ADVISOR.CHECK.DESC_VALID_SQL_PLSQL_CODE'
,p_message_language=>'es'
,p_message_text=>unistr('Es C\00F3digo SQL o PL/SQL V\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99585540810304209)
,p_name=>'ADVISOR.CHECK.DESC_VERIFY_CLOB_PROPERTY'
,p_message_language=>'es'
,p_message_text=>'Verificar Propiedad Clob'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99585423779304209)
,p_name=>'ADVISOR.CHECK.DESC_V_FUNCTION_IN_SQL'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n V utilizada en sentencias SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99586034094304209)
,p_name=>'ADVISOR.CHECK.DESC_WHEN_BUTTON_PRESSED'
,p_message_language=>'es'
,p_message_text=>unistr('Existe el bot\00F3n al que se hace referencia en Si Se Hace Clic en el Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99588482484304211)
,p_name=>'ADVISOR.CHECK.DML_PROCESSES.MSG_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('Error de compilaci\00F3n: %0 Sentencia: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99588773432304211)
,p_name=>'ADVISOR.CHECK.HARDCODED_APPLICATION_ID.MSG_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('El enlace contiene el identificador de aplicaci\00F3n actual como valor codificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99981288226304510)
,p_name=>'ADVISOR.CHECK.HAS_HELP_TEXT.MSG_NOT_DEFINED'
,p_message_language=>'es'
,p_message_text=>'No se ha definido texto de ayuda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100068922945304577)
,p_name=>'ADVISOR.CHECK.HAS_PAGE_TITLE.MSG_NOT_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina no tiene t\00EDtulo. En aras de la accesibilidad, es importante asignar t\00EDtulos de p\00E1gina relevantes para que los usuarios se hagan una idea del contenido y el objetivo de la p\00E1gina en la que se encuentren.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100093171217304596)
,p_name=>'ADVISOR.CHECK.IMAGE_ITEM_HAS_ALT.MSG_NOT_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento carece del texto alternativo que debe tener la imagen. Para que el texto sea eficaz, debe describir el contenido de la imagen de forma adecuada, y no debe duplicar la informaci\00F3n que aparezca en la p\00E1gina que se muestra en el contexto de ')
||unistr('la imagen (para evitar posibles duplicados). Nota: Si la imagen la proporcionan los usuarios, tambi\00E9n deben proporcionar el texto alternativo de imagen, adem\00E1s de las instrucciones necesarias para que los usuarios creen textos de buena calidad.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100521484118304957)
,p_name=>'ADVISOR.CHECK.INSECURE_APPLICATION_DEFAULTS.MSG_RUNTIME_API_USAGE'
,p_message_language=>'es'
,p_message_text=>unistr('"Sintaxis de la API en Tiempo de Ejecuci\00F3n" permite realizar modificaciones del espacio de trabajo y la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99586964349304210)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_PAGE.MSG_NOT_ITEM_OF_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no es un elemento de la p\00E1gina %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99587010829304210)
,p_name=>'ADVISOR.CHECK.IS_ITEM_OF_TARGET_PAGE.MSG_NOT_ITEM_OF_TARGET_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no es un elemento de la p\00E1gina de destino %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100069672961304577)
,p_name=>'ADVISOR.CHECK.ITEMS_NO_CONTEXT_CHANGE.MSG_CAUSES_CHANGE_OF_CONTEXT'
,p_message_language=>'es'
,p_message_text=>unistr('El valor ''Acci\00F3n de p\00E1gina al seleccionar'' del elemento de esta p\00E1gina puede provocar un cambio de contexto inesperado para el usuario. Puede cambiar a ''Ninguno'' para que no se produzca ning\00FAn cambio de contexto y sustituir la funci\00F3n con acciones di')
||unistr('n\00E1micas o listas de valores en cascada (si debe permanecer en la misma p\00E1gina). De forma alternativa, puede proporcionar informaci\00F3n al usuario para que sepa lo que ocurrir\00E1 (por ejemplo, incluya ''Se abre en una p\00E1gina nueva'' en la etiqueta). ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100092965583304596)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_NO_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe definir una etiqueta para el elemento. Aunque prefiera que no se muestre una etiqueta visible, debe definir la etiqueta y, despu\00E9s, seleccionar la plantilla de etiqueta ''Oculta''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100070332112304578)
,p_name=>'ADVISOR.CHECK.ITEM_HAS_LABEL.MSG_PLACEHOLDER_BUT_NO_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento tiene definido un valor ''Marcador de posici\00F3n de valor'', pero no una etiqueta. El texto de marcador de posici\00F3n no debe usarse solo en la etiqueta de un elemento, puesto que as\00ED se generan problemas de accesibilidad. Para mejorarla realme')
||unistr('nte, las etiquetas de los elementos deben estar definidas. Aunque prefiera que no se muestre una etiqueta visible, debe definir la etiqueta y, despu\00E9s, seleccionar la plantilla de etiqueta ''Oculta''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99589189417304211)
,p_name=>'ADVISOR.CHECK.ITEM_NAME_LENGTH.MSG_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre tiene una longitud de %0 caracteres, pero debe tener como m\00E1ximo 30 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99587357845304210)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'Puede que %0 no exista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99587460087304210)
,p_name=>'ADVISOR.CHECK.PAGE_ITEM_REF_AS_STRING.MSG_WRONG_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Puede que %0 no sea un elemento de aplicaci\00F3n o p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99587753062304210)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_CLEAR_CACHE_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina Borrar Cach\00E9 %1 (de la aplicaci\00F3n %0) no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99587587297304210)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina %0 no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99587640297304210)
,p_name=>'ADVISOR.CHECK.PAGE_NUMBER_EXISTS.MSG_TARGET_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina de destino %1 (de la aplicaci\00F3n %0) no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99996444227304522)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_COL_TOGGLE_NOT_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('Esta regi\00F3n de conmutaci\00F3n de columnas no tiene ninguna columna con "Usar como cabecera de fila" definida en "S\00ED". La columna de cabecera de fila debe ser aquella que mejor represente la fila actual (por ejemplo, el nombre de un cliente en un informe')
||' de datos del cliente).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99996576927304522)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_REFLOW_NOT_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('Esta regi\00F3n de reflujo no tiene ninguna columna con "Usar como cabecera de fila" definida en "S\00ED". La columna de cabecera de fila debe ser aquella que mejor represente la fila actual (por ejemplo, el nombre de un cliente en un informe de detalles del')
||' cliente).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100069236918304577)
,p_name=>'ADVISOR.CHECK.REGION_HAS_ROW_HEADER.MSG_TABFORM_NOT_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('Esta regi\00F3n de pantalla tabular no tiene ninguna columna con "Usar como cabecera de fila" definida en S\00ED. La columna de cabecera de fila debe ser aquella que mejor represente la fila actual (por ejemplo, el nombre de cliente en una tabla de informaci')
||unistr('\00F3n del cliente). Esta informaci\00F3n se usa al representar la pantalla tabular para proporcionar etiquetas \00FAnicas a los campos de cada fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99589311062304211)
,p_name=>'ADVISOR.CHECK.REPORT_DEFAULT_ORDER.MSG_NO_DEFAULT_ORDER'
,p_message_language=>'es'
,p_message_text=>'El informe no tiene un orden por defecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100521751500304957)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_BOOKMARK_CHECKSUM_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('"Funci\00F3n Hash de Marcador" se define en un algoritmo heredado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100521839876304957)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_APP_PROTECTION'
,p_message_language=>'es'
,p_message_text=>unistr('"Protecci\00F3n de Estado de la Sesi\00F3n" est\00E1 desactivada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100722182133305110)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PAGE_PROTECTION'
,p_message_language=>'es'
,p_message_text=>unistr('En una p\00E1gina con un proceso de recuperaci\00F3n, debe usar la protecci\00F3n de acceso a p\00E1gina y activar la protecci\00F3n de los elementos que transfiere mediante la URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99558931787304188)
,p_name=>'ADVISOR.CHECK.SESSION_STATE_PROTECTION.MSG_NO_PREPARE_URL'
,p_message_language=>'es'
,p_message_text=>unistr('La regi\00F3n contiene una URL "f?p" no transferida a APEX_UTIL.PREPARE_URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99588579049304211)
,p_name=>'ADVISOR.CHECK.SQL_INJECTION.MSG_ITEM_SUBSTITUTION'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha detectado una posible inyecci\00F3n SQL. %0 se utiliza con la sintaxis de sustituci\00F3n en el c\00F3digo SQL o PL/SQL o el nombre de la tabla de proceso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99586334860304209)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'%0 no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99586479281304209)
,p_name=>'ADVISOR.CHECK.SUBSTITUTION_SYNTAX.MSG_WRONG_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede hacer referencia a %0 con la sintaxis de sustituci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99588333671304211)
,p_name=>'ADVISOR.CHECK.TARGET_PAGE_AUTH_USABILITY.MSG_NO_AUTH_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina de destino %1 (de la aplicaci\00F3n %0) tiene un esquema de autorizaci\00F3n definido, pero el componente actual no.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100069428126304577)
,p_name=>'ADVISOR.CHECK.THEME_STYLE_IS_ACCESSIBLE.MSG_NOT_ACCESSIBLE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha probado la accesibilidad del estilo de tema actual para la aplicaci\00F3n. Cambie a un estilo de tema en el que Accesibilidad probada est\00E9 definida en S\00ED, o si el estilo de tema actual a\00FAn no se ha probado, defina el atributo Accesibilidad proba')
||unistr('da en S\00ED en la configuraci\00F3n del tema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100164354754304689)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_JQUERY_MIGRATE'
,p_message_language=>'es'
,p_message_text=>unistr('La interfaz de usuario incluye la migraci\00F3n de jQuery. La migraci\00F3n de jQuery facilita la migraci\00F3n a una versi\00F3n m\00E1s reciente de jQuery mediante la restauraci\00F3n de las API eliminadas, y muestra advertencias en la consola del explorador cuando se uti')
||unistr('lizan API en desuso o eliminadas. Esto incluye un archivo JavaScript adicional en cada p\00E1gina de su aplicaci\00F3n. Para eliminarlas, consulte la gu\00EDa de actualizaci\00F3n de la migraci\00F3n de jQuery, en la que obtendr\00E1 informaci\00F3n sobre las API que se deben c')
||unistr('ambiar. Una vez que se haya asegurado de que no desea utilizar ninguna de estas API, defina Incluir migraci\00F3n de jQuery en No.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100164205453304689)
,p_name=>'ADVISOR.CHECK.UI_INCLUDES_COMPATIBILITY_JS.MSG_LEGACY_JS'
,p_message_language=>'es'
,p_message_text=>unistr('La interfaz de usuario utiliza funciones JavaScript en desuso o no soportadas. Esto incluye un archivo JavaScript adicional en cada p\00E1gina de su aplicaci\00F3n. Para eliminarlas, consulte la secci\00F3n ''Funciones anticuadas'' de las notas t\00E9cnicas sobre la v')
||unistr('ersi\00F3n, en la que encontrar\00E1 instrucciones sobre c\00F3mo buscar dependencias con funciones en desuso o no soportadas y su eliminaci\00F3n de la aplicaci\00F3n.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99589080868304211)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento o columna asociados no est\00E1 definido, pero "Ubicaci\00F3n de Visualizaci\00F3n de Mensaje de Error" lo requiere.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99588923579304211)
,p_name=>'ADVISOR.CHECK.VALIDATION_ASSOCIATED_ITEM.MSG_NOT_EQUAL'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento o columna asociados no es igual a "%0" especificado en la expresi\00F3n de validaci\00F3n 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99587943962304210)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('Error de compilaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99588043801304211)
,p_name=>'ADVISOR.CHECK.VALID_SQL_PLSQL_CODE.MSG_NOT_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ning\00FAn c\00F3digo SQL o PL/SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99586269851304209)
,p_name=>'ADVISOR.CHECK.VERIFY_CLOB_PROPERTY.MSG_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>unistr('Tiene m\00E1s de 32767. S\00F3lo se comprueban los primeros 32767. Longitud: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99588667340304211)
,p_name=>'ADVISOR.CHECK.V_FUNCTION_IN_SQL.MSG_CONTAINS_CALL'
,p_message_language=>'es'
,p_message_text=>unistr('Contiene la llamada de funci\00F3n V/NV/DV en la sentencia SQL (puede producir un problema de rendimiento).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99589233881304211)
,p_name=>'ADVISOR.CHECK.WHEN_BUTTON_PRESSED.MSG_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('El bot\00F3n al que se hace referencia ya no existe.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99968968032304501)
,p_name=>'AFTER'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99916281585304460)
,p_name=>'AGREEMENT_MISSING'
,p_message_language=>'es'
,p_message_text=>'Falta el acuerdo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99710302645304300)
,p_name=>'ALIAS'
,p_message_language=>'es'
,p_message_text=>'Alias'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100312598842304801)
,p_name=>'ALLOW_APP_BUILDING'
,p_message_language=>'es'
,p_message_text=>unistr('Permitir Creaci\00F3n de Aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100253918227304757)
,p_name=>'ALLOW_PACKAGED_APP_INS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permita la instalaci\00F3n de aplicaciones de ejemplo y de productividad.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100155750649304682)
,p_name=>'ALLOW_RESTFUL_SERVICES'
,p_message_language=>'es'
,p_message_text=>'Permitir Uso de Servicios RESTful'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100312607873304801)
,p_name=>'ALLOW_SQL_WORKSHOP'
,p_message_language=>'es'
,p_message_text=>'Permitir Uso de Taller SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100312826229304801)
,p_name=>'ALLOW_TEAM_DEVELOPMENT'
,p_message_language=>'es'
,p_message_text=>'Permitir Uso de Desarrollo de Equipos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100312496206304800)
,p_name=>'ALLOW_TO_BE_PURGED_YN'
,p_message_language=>'es'
,p_message_text=>unistr('Permitir Depuraci\00F3n de Espacio de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100312725321304801)
,p_name=>'ALLOW_WEBSHEET_DEV'
,p_message_language=>'es'
,p_message_text=>unistr('Permitir Desarrollo de Hoja de C\00E1lculo Web')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99729552234304315)
,p_name=>'ALL_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'Todas las Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99546715347304179)
,p_name=>'ALL_APPLICATIONS_NULL_DISP'
,p_message_language=>'es'
,p_message_text=>'- Todo -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99546589418304179)
,p_name=>'ALL_CATEGORIES'
,p_message_language=>'es'
,p_message_text=>unistr('Todas las Categor\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99546872136304179)
,p_name=>'ALL_CATEGORIES_NULL_DISP'
,p_message_language=>'es'
,p_message_text=>unistr('- Todas las Categor\00EDas -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100315152585304802)
,p_name=>'ALL_MILESTONES'
,p_message_language=>'es'
,p_message_text=>'todos los hitos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100094569539304597)
,p_name=>'ALL_RELEASES'
,p_message_language=>'es'
,p_message_text=>'Todas las Versiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99733991938304318)
,p_name=>'ALL_STATIC_FILES'
,p_message_language=>'es'
,p_message_text=>unistr('todos los archivos est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99732539997304317)
,p_name=>'ALL_THEMES'
,p_message_language=>'es'
,p_message_text=>'todos los temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100333235204304816)
,p_name=>'ALL_TYPES'
,p_message_language=>'es'
,p_message_text=>'Todos los Tipos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100333627006304816)
,p_name=>'ALL_TYPES_NULL_DISP'
,p_message_language=>'es'
,p_message_text=>'- Todos los Tipos -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99729637778304315)
,p_name=>'ALL_USERS'
,p_message_language=>'es'
,p_message_text=>'Todos los Usuarios'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100717582264305107)
,p_name=>'ALREADY_IN_ACL'
,p_message_language=>'es'
,p_message_text=>'El usuario ya tiene una cuenta de APEX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100707413109305099)
,p_name=>'ALREADY_IN_WS'
,p_message_language=>'es'
,p_message_text=>'El usuario ya existe en el espacio de trabajo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100673837962305070)
,p_name=>'ALWAYS'
,p_message_language=>'es'
,p_message_text=>'Siempre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99983840372304512)
,p_name=>'ANALYSIS'
,p_message_language=>'es'
,p_message_text=>unistr('An\00E1lisis de %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99983942527304512)
,p_name=>'ANALYZE'
,p_message_language=>'es'
,p_message_text=>'Analizar por %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100111578295304610)
,p_name=>'ANALYZE_TABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Analizar con el M\00E9todo %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99731493694304316)
,p_name=>'ANONYMOUS_BLOCK'
,p_message_language=>'es'
,p_message_text=>unistr('bloque an\00F3nimo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99592535509304214)
,p_name=>'ANSWERS'
,p_message_language=>'es'
,p_message_text=>'Respuestas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99558681377304188)
,p_name=>'ANY_DEVELOPER'
,p_message_language=>'es'
,p_message_text=>'(Cualquier Desarrollador)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100759556858305138)
,p_name=>'APEX.ACTIVITY_BY_HOUR.APPCHANGES'
,p_message_language=>'es'
,p_message_text=>unistr('Cambios de Aplicaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100759464508305138)
,p_name=>'APEX.ACTIVITY_BY_HOUR.HOUR'
,p_message_language=>'es'
,p_message_text=>'Hora:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100763563607305141)
,p_name=>'APEX.ACTIVITY_BY_HOUR.K'
,p_message_language=>'es'
,p_message_text=>'%0 K'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100759635036305138)
,p_name=>'APEX.ACTIVITY_BY_HOUR.PAGEVIEWS'
,p_message_language=>'es'
,p_message_text=>unistr('Vistas de P\00E1gina: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100516256656304952)
,p_name=>'APEX.API.RUNTIME_API_USAGE.ERROR'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'La llamada de API de se ha prohibido.',
unistr('P\00F3ngase en contacto con el administrador.'),
unistr('Puede acceder a m\00E1s informaci\00F3n sobre este incidente a trav\00E9s del ID de depuraci\00F3n "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99617876555304232)
,p_name=>'APEX.ASSERT.DESUPPORTED_API'
,p_message_language=>'es'
,p_message_text=>unistr('La llamada de API de "%0" ya no est\00E1 soportada en Application Express versi\00F3n %1. Puede acceder a m\00E1s informaci\00F3n sobre este incidente a trav\00E9s del ID de depuraci\00F3n "%2".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99993743374304520)
,p_name=>'APEX.AUTO_COMPLETE.NOT_IN_LIST'
,p_message_language=>'es'
,p_message_text=>'#LABEL# no existe en la lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100270953348304770)
,p_name=>'APEX.BRANCH.SHOW_ONLY_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('La opci\00F3n Mostrar Solo Bifurcaciones no est\00E1 soportada si el atributo de p\00E1gina "Recargar al Enviar" est\00E1 definido en "Solo para Correcto".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99735612407304319)
,p_name=>'APEX.BRANCH.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la bifurcaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99524940958304160)
,p_name=>'APEX.COMPUTATION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar el c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99715777216304304)
,p_name=>'APEX.CONDITION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99767257204304342)
,p_name=>'APEX.CONDITION.UNKNOWN_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de condici\00F3n desconocido "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99520926483304157)
,p_name=>'APEX.DATA.LOAD.INVALID_FILE_BROWSE_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento de exploraci\00F3n de archivos %0 debe utilizar la tabla APEX_APPLICATION_TEMP_FILES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99498376384304140)
,p_name=>'APEX.DATA.LOAD.MERGE_NOT_ALLOWED_FOR_COLLECTION'
,p_message_language=>'es'
,p_message_text=>unistr('El tipo de carga "Fusionar" no est\00E1 soportado para la carga en recopilaciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100651542140305053)
,p_name=>'APEX.DATA.LOAD.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'es'
,p_message_text=>'El tipo de carga "fusionar" requiere al menos una columna de clave principal en el perfil de datos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100651310775305053)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_ERROR'
,p_message_language=>'es'
,p_message_text=>'La consulta SQL de origen de carga no se puede analizar: %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100651430644305053)
,p_name=>'APEX.DATA.LOAD.SQL_QUERY_RETURNS_WRONG_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>'La consulta SQL de origen de carga debe devolver VARCHAR2, CLOB o BLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99928693299304470)
,p_name=>'APEX.DIALOG.PAGE.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina %1 de cuadro de di\00E1logo de la aplicaci\00F3n %0 no se puede presentar correctamente. Aseg\00FArese de que la plantilla de p\00E1gina que est\00E1 en uso en la p\00E1gina %1 es del tipo de plantilla "P\00E1gina de Cuadro de Di\00E1logo", con el c\00F3digo de cancelaci\00F3n de')
||unistr(' cuadro de di\00E1logo, de cierre de cuadro de di\00E1logo o de inicializaci\00F3n de cuadro de di\00E1logo de JavaScritpt adecuado definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100748558896305130)
,p_name=>'APEX.EMAIL.COPYRIGHT'
,p_message_language=>'es'
,p_message_text=>'Copyright &copy; %0, Todos los derechos reservados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100749359499305130)
,p_name=>'APEX.EMAIL.CREATE_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Crear Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100748418227305130)
,p_name=>'APEX.EMAIL.DISCLAIMER'
,p_message_language=>'es'
,p_message_text=>'Este es un mensaje generado por el sistema. No responda a este mensaje.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100756901490305136)
,p_name=>'APEX.EMAIL.ENVIRONMENT'
,p_message_language=>'es'
,p_message_text=>'Entorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100767524412305144)
,p_name=>'APEX.EMAIL.GENERIC_USER'
,p_message_language=>'es'
,p_message_text=>'Usuario de Oracle Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100749952651305131)
,p_name=>'APEX.EMAIL.GET_STARTED'
,p_message_language=>'es'
,p_message_text=>unistr('Introducci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100748638445305130)
,p_name=>'APEX.EMAIL.GREETING'
,p_message_language=>'es'
,p_message_text=>'Hola %0,'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100749672263305131)
,p_name=>'APEX.EMAIL.PASSWORD'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100757078364305136)
,p_name=>'APEX.EMAIL.PREVENT_PURGE'
,p_message_language=>'es'
,p_message_text=>unistr('Evitar depuraci\00F3n de espacio de trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100749848095305131)
,p_name=>'APEX.EMAIL.PURGE.BODY'
,p_message_language=>'es'
,p_message_text=>unistr('Puede impedir que se depure su espacio de trabajo haciendo clic en el bot\00F3n siguiente y siguiendo las instrucciones que se muestran en pantalla. Si no act\00FAa en %0 d\00EDa(s), el espacio de trabajo se eliminar\00E1 autom\00E1ticamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100756706859305136)
,p_name=>'APEX.EMAIL.PURGE.FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('No es necesaria ninguna acci\00F3n si ya no necesita el espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100757236730305136)
,p_name=>'APEX.EMAIL.PURGE.HEADING'
,p_message_language=>'es'
,p_message_text=>unistr('El espacio de trabajo est\00E1 a punto de depurarse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100756579158305136)
,p_name=>'APEX.EMAIL.PURGE.INTRO'
,p_message_language=>'es'
,p_message_text=>unistr('El espacio de trabajo %0 no ha mostrado ninguna actividad reciente y est\00E1 programado para depurarse pronto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100756480866305136)
,p_name=>'APEX.EMAIL.PURGE.SUBJECT'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: El espacio de trabajo "%0" est\00E1 a punto de depurarse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100756825065305136)
,p_name=>'APEX.EMAIL.PURGE_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de Depuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100757508069305136)
,p_name=>'APEX.EMAIL.REQUEST_ACTION_REQ'
,p_message_language=>'es'
,p_message_text=>'Complete la solicitud de espacio de trabajo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100757321274305136)
,p_name=>'APEX.EMAIL.REQUEST_APPROVED'
,p_message_language=>'es'
,p_message_text=>unistr('El espacio de trabajo "%0" est\00E1 listo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100757620284305136)
,p_name=>'APEX.EMAIL.REQUEST_APPROVE_2'
,p_message_language=>'es'
,p_message_text=>'El espacio de trabajo "%0" ha sido aprobado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100757483840305136)
,p_name=>'APEX.EMAIL.REQUEST_DECLINED'
,p_message_language=>'es'
,p_message_text=>'La solicitud de espacio de trabajo se ha rechazado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100749234415305130)
,p_name=>'APEX.EMAIL.USERNAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100757105122305136)
,p_name=>'APEX.EMAIL.WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('\00A1Advertencia!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100749104287305130)
,p_name=>'APEX.EMAIL.WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100748744818305130)
,p_name=>'APEX.EMAIL.WS_REQ_APPR'
,p_message_language=>'es'
,p_message_text=>'Solicitud de espacio de trabajo aprobada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100749444485305130)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic en el bot\00F3n siguiente para terminar el proceso de aprobaci\00F3n y definir su contrase\00F1a.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100748940648305130)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_INTRO'
,p_message_language=>'es'
,p_message_text=>'Su solicitud de espacio de trabajo ha sido aprobada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100749594196305130)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic en el bot\00F3n siguiente para comenzar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100749743752305131)
,p_name=>'APEX.EMAIL.WS_REQ_APPR_READY_INTRO'
,p_message_language=>'es'
,p_message_text=>unistr('Su espacio de trabajo est\00E1 listo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100748813007305130)
,p_name=>'APEX.EMAIL.WS_REQ_DECL'
,p_message_language=>'es'
,p_message_text=>'Solicitud de espacio de trabajo rechazada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100749039837305130)
,p_name=>'APEX.EMAIL.WS_REQ_DECL_INTRO'
,p_message_language=>'es'
,p_message_text=>'Si solicitud de espacio de trabajo ha sido rechazada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99525362275304160)
,p_name=>'APEX.EXPORT.DOWNLOAD_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('Las descargas no est\00E1n soportadas si el atributo de p\00E1gina "Volver a cargar al ejecutar" est\00E1 definido en "Solo correctos". Cambie el atributo de p\00E1gina "Volver a cargar al ejecutar" a "Siempre" o utilice un proceso de cabecera anterior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100059105555304569)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.QUEUED'
,p_message_language=>'es'
,p_message_text=>'En cola'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100059278374304569)
,p_name=>'APEX.FEATURE.EMAIL_REPORTING.SENT'
,p_message_language=>'es'
,p_message_text=>'Enviados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99555190122304186)
,p_name=>'APEX.FEEDBACK.FEEDBACK_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas de Comentario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99555277743304186)
,p_name=>'APEX.FEEDBACK.OPEN_FEEDBACK_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas de Comentarios Abiertos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99555391921304186)
,p_name=>'APEX.FEEDBACK.USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99894319493304443)
,p_name=>'APEX.GROUP.NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el grupo "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100729323917305115)
,p_name=>'APEX.HELP.VIEW_DOC'
,p_message_language=>'es'
,p_message_text=>unistr('Ver Documentaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99637243485304247)
,p_name=>'APEX.HTTP.HEADER.DUPLICATE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La cabecera HTTP %0 se ha enviado dos veces, podr\00EDa tratarse de un ataque.'),
'<ul>',
'<li>Primer valor: "%1"</li>',
'<li>Segundo valor: "%2"</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99674449627304274)
,p_name=>'APEX.INSTANCE_ADMIN.BIPUB_OPTION'
,p_message_language=>'es'
,p_message_text=>unistr('El soporte de impresi\00F3n debe ser EST\00C1NDAR, ADVANZADO, APEX_LISTENER, AOP o NINGUNO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99674582801304274)
,p_name=>'APEX.INSTANCE_ADMIN.FIRST_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'No se puede eliminar el primer esquema provisionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99577857850304203)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador de aplicaci\00F3n no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100093967369304596)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_EMAIL_ADDRESS'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n de Correo Electr\00F3nico No V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99570169472304197)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_HISTORY_DAYS'
,p_message_language=>'es'
,p_message_text=>'El valor debe ser cero o un entero positivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99674680022304274)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_PORT'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de puerto no v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100121691314304618)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('ID de suscripci\00F3n no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99674775674304274)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WALLET'
,p_message_language=>'es'
,p_message_text=>'La ruta de acceso de la cartera debe estar en el archivo de pantallas: <filesystempath>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99753672800304332)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el espacio de trabajo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99753557584304332)
,p_name=>'APEX.INSTANCE_ADMIN.INVALID_WORKSPACE_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador de espacio de trabajo no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99778972278304350)
,p_name=>'APEX.INSTANCE_ADMIN.LIMIT'
,p_message_language=>'es'
,p_message_text=>'El valor no debe ser mayor que %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99689322957304285)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REGEXP_MISMATCH'
,p_message_language=>'es'
,p_message_text=>unistr('El valor "%1" del par\00E1metro de instancia "%0" no coincide con la expresi\00F3n regular "%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99689249640304285)
,p_name=>'APEX.INSTANCE_ADMIN.PARAMETER_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('El par\00E1metro de instancia "%0" debe tener un valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99674814396304274)
,p_name=>'APEX.INSTANCE_ADMIN.PARM_NOTFOUND'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro de instancia no encontrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100117749500304615)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.APEX-AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99525016709304160)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.CLOUD_IDM-AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a (Para autenticaci\00F3n s\00F3lo en repositorio de cuentas de usuario de espacio de trabajo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100310141828304799)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.HEADER-AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a (Para autenticaci\00F3n s\00F3lo en repositorio de cuentas de usuario de espacio de trabajo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100203345513304718)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.LDAP-AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a (Para autenticaci\00F3n s\00F3lo en repositorio de cuentas de usuario de espacio de trabajo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99609348292304226)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SAML-AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a (Para autenticaci\00F3n s\00F3lo en repositorio de cuentas de usuario de espacio de trabajo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99832591845304389)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SOCIAL-AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a (Para autenticaci\00F3n s\00F3lo en repositorio de cuentas de usuario de espacio de trabajo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100117666185304615)
,p_name=>'APEX.INSTANCE_ADMIN.PASSWORD_REGION_TITLE.SSO-AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a (Para autenticaci\00F3n s\00F3lo en repositorio de cuentas de usuario de espacio de trabajo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99676778001304276)
,p_name=>'APEX.INSTANCE_ADMIN.PRINTSVR_PROTOCOL'
,p_message_language=>'es'
,p_message_text=>unistr('El protocolo del servidor de impresi\00F3n debe ser http o https')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99676813107304276)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>'El esquema no existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99676945893304276)
,p_name=>'APEX.INSTANCE_ADMIN.SCHEMA_RESTRICTED'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema est\00E1 restringido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99550250504304182)
,p_name=>'APEX.ISSUES.APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99550094479304182)
,p_name=>'APEX.ISSUES.APPLICATION_NO_LONGER_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('La Aplicaci\00F3n ya no existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100354967539304832)
,p_name=>'APEX.ISSUES.ASSIGN'
,p_message_language=>'es'
,p_message_text=>'Asignar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99751811414304331)
,p_name=>'APEX.ISSUES.ATTACHMENTS'
,p_message_language=>'es'
,p_message_text=>'Anexos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100681963240305080)
,p_name=>'APEX.ISSUES.CARDS'
,p_message_language=>'es'
,p_message_text=>'Tarjetas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99555642011304186)
,p_name=>'APEX.ISSUES.CLOSED'
,p_message_language=>'es'
,p_message_text=>'Cerrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99552163425304183)
,p_name=>'APEX.ISSUES.COMMENTED'
,p_message_language=>'es'
,p_message_text=>'Comentado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99552032134304183)
,p_name=>'APEX.ISSUES.COMMENTS'
,p_message_language=>'es'
,p_message_text=>'comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99555752724304186)
,p_name=>'APEX.ISSUES.COMPLETE'
,p_message_language=>'es'
,p_message_text=>'Terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99937187910304477)
,p_name=>'APEX.ISSUES.CREATED_THIS_ISSUE'
,p_message_language=>'es'
,p_message_text=>'Se ha creado este problema %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99526719684304161)
,p_name=>'APEX.ISSUES.DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99526536223304161)
,p_name=>'APEX.ISSUES.DELETE_COMMENT_CONFIRM'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFSeguro que desea suprimir este comentario?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100339370824304820)
,p_name=>'APEX.ISSUES.DELETE_ISSUE'
,p_message_language=>'es'
,p_message_text=>'Suprimir problema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99536444994304168)
,p_name=>'APEX.ISSUES.DELETE_ISSUE_CONFIRM'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFSeguro que desea suprimir esta incidencia?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99553716771304185)
,p_name=>'APEX.ISSUES.DOCUMENT'
,p_message_language=>'es'
,p_message_text=>'Documento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99552688054304184)
,p_name=>'APEX.ISSUES.DOCUMENTS'
,p_message_language=>'es'
,p_message_text=>'Documentos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99526689105304161)
,p_name=>'APEX.ISSUES.EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100467491257304916)
,p_name=>'APEX.ISSUES.EDIT_COMMENT'
,p_message_language=>'es'
,p_message_text=>'Editar Comentario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100467579102304916)
,p_name=>'APEX.ISSUES.EDIT_ISSUE'
,p_message_language=>'es'
,p_message_text=>'Editar Problema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99550888534304182)
,p_name=>'APEX.ISSUES.ERR_APP_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n especificada no existe en este espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99551272727304183)
,p_name=>'APEX.ISSUES.ERR_ATTEMPTING_TO_DELETE_COMMENT'
,p_message_language=>'es'
,p_message_text=>'Error al intentar suprimir el comentario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99551194628304183)
,p_name=>'APEX.ISSUES.ERR_COMMENT_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el comentario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99551476637304183)
,p_name=>'APEX.ISSUES.ERR_ISSUE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado la incidencia.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99551531592304183)
,p_name=>'APEX.ISSUES.ERR_MARKING_ISSUE_FOR_DELETE'
,p_message_language=>'es'
,p_message_text=>'Error al intentar marcar la incidencia para suprimir.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99550962792304182)
,p_name=>'APEX.ISSUES.ERR_PAGE_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina especificada no existe en este espacio de trabajo ni en la aplicaci\00F3n indicada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99551311023304183)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_DELETE_COMMENT'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario no est\00E1 autorizado a suprimir el comentario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99551618208304183)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_TO_DELETE_ISSUE'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario no est\00E1 autorizado a suprimir la incidencia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99551072682304182)
,p_name=>'APEX.ISSUES.ERR_USER_NOT_AUTH_VISIBILITY'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario no est\00E1 autorizado para cambiar la visibilidad de este comentario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100560914150304986)
,p_name=>'APEX.ISSUES.FILE_SIZE_CHECK_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha producido un problema al comprobar los tama\00F1os de archivo. P\00F3ngase en contacto con el administrador del sistema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100560879872304986)
,p_name=>'APEX.ISSUES.FILE_SIZE_PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Uno de estos archivos es m\00E1s grande que el tama\00F1o m\00E1ximo de archivo de %0 bytes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100560796489304986)
,p_name=>'APEX.ISSUES.FILE_SIZE_SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Este archivo es m\00E1s grande que el tama\00F1o m\00E1ximo de archivo de %0 bytes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99526847403304161)
,p_name=>'APEX.ISSUES.HIDE'
,p_message_language=>'es'
,p_message_text=>'Ocultar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99553583069304184)
,p_name=>'APEX.ISSUES.IMAGE'
,p_message_language=>'es'
,p_message_text=>'Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99552466076304184)
,p_name=>'APEX.ISSUES.IMAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Im\00E1genes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99549870259304182)
,p_name=>'APEX.ISSUES.ISSUE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'una incidencia que no se ha encontrado en el sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99499202222304140)
,p_name=>'APEX.ISSUES.JS.ADD_NOTIFICATION_PREFS'
,p_message_language=>'es'
,p_message_text=>unistr('A\00F1adir Preferencias para Usuario')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99552222639304183)
,p_name=>'APEX.ISSUES.JS.ATTACH_FILES'
,p_message_language=>'es'
,p_message_text=>'Adjuntar Archivos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99551960875304183)
,p_name=>'APEX.ISSUES.JS.CLOSED'
,p_message_language=>'es'
,p_message_text=>'Cerrado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100685876071305083)
,p_name=>'APEX.ISSUES.JS.HEADING'
,p_message_language=>'es'
,p_message_text=>'Cabecera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99553261851304184)
,p_name=>'APEX.ISSUES.JS.IS_EMPTY'
,p_message_language=>'es'
,p_message_text=>unistr('est\00E1 vac\00EDo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99553016597304184)
,p_name=>'APEX.ISSUES.JS.ONE_OF_THESE_FILES_IS'
,p_message_language=>'es'
,p_message_text=>unistr('Uno de estos archivos est\00E1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99551870793304183)
,p_name=>'APEX.ISSUES.JS.OPEN'
,p_message_language=>'es'
,p_message_text=>'Abrir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99554391243304185)
,p_name=>'APEX.ISSUES.JS.PERMANENTLY_DELETE_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('Suprimir Selecci\00F3n Permanentemente')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100340232164304821)
,p_name=>'APEX.ISSUES.JS.PURGE_ALL'
,p_message_language=>'es'
,p_message_text=>'Depurar Todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99554253129304185)
,p_name=>'APEX.ISSUES.JS.RESINSTATE_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('Restaurar Selecci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99552337046304183)
,p_name=>'APEX.ISSUES.JS.RESPONSE_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Respuestas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99553190219304184)
,p_name=>'APEX.ISSUES.JS.SINGLE_TOO_LARGE'
,p_message_language=>'es'
,p_message_text=>'demasiado grande para cargar. <br>Los archivos deben pesar menos de'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99553416692304184)
,p_name=>'APEX.ISSUES.JS.SUPPORTED_FILE_TYPES_ARE'
,p_message_language=>'es'
,p_message_text=>'Los tipos de archivo soportados son: '
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100535835017304967)
,p_name=>'APEX.ISSUES.JS.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Seleccione una plantilla de respuesta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99552962617304184)
,p_name=>'APEX.ISSUES.JS.THIS_FILE_IS'
,p_message_language=>'es'
,p_message_text=>unistr('Este archivo est\00E1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99553344551304184)
,p_name=>'APEX.ISSUES.JS.UNSUPPORTED_FILE_TYPE'
,p_message_language=>'es'
,p_message_text=>'no es un tipo de archivo soportado.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100282776640304778)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.BUG'
,p_message_language=>'es'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100283367616304779)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.DOCUMENTATIONISSUE'
,p_message_language=>'es'
,p_message_text=>unistr('Problema de documentaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100282809319304779)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.ENHANCEMENTREQUEST'
,p_message_language=>'es'
,p_message_text=>'Solicitud de Mejora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100282939981304779)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.FEATUREREQUEST'
,p_message_language=>'es'
,p_message_text=>unistr('Solicitud de funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100283292159304779)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.INSTALLATIONISSUE'
,p_message_language=>'es'
,p_message_text=>unistr('Problema de instalaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100283177526304779)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.PERFORMANCEISSUE'
,p_message_language=>'es'
,p_message_text=>'Problema de rendimiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100283058319304779)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.SECURITYISSUE'
,p_message_language=>'es'
,p_message_text=>'Problema de seguridad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100283441761304779)
,p_name=>'APEX.ISSUES.LABELS.CATEGORY.TRAININGISSUE'
,p_message_language=>'es'
,p_message_text=>unistr('Problema de formaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100284117466304780)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.ADMINISTRATION'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100283865156304779)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.CSSHTML'
,p_message_language=>'es'
,p_message_text=>'CSS / HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100283945785304779)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DAJAVASCRIPT'
,p_message_language=>'es'
,p_message_text=>unistr('Acciones din\00E1micas / JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100283669808304779)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.DATABASE'
,p_message_language=>'es'
,p_message_text=>'Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100284205065304780)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.EXTINTEGRATION'
,p_message_language=>'es'
,p_message_text=>unistr('Integraci\00F3n de sistema externo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100283772546304779)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.RESTINTEGRATION'
,p_message_language=>'es'
,p_message_text=>unistr('Integraci\00F3n de REST')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100284069553304779)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.SECURITY'
,p_message_language=>'es'
,p_message_text=>'Seguridad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100283556285304779)
,p_name=>'APEX.ISSUES.LABELS.FUNCTIONALAREA.UIUX'
,p_message_language=>'es'
,p_message_text=>'UI / UX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100282641219304778)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Categor\00EDa asignada al problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100281730442304778)
,p_name=>'APEX.ISSUES.LABELS.GROUP.CATEGORY.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Categor\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100282554645304778)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea funcional afectada por el problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100281873196304778)
,p_name=>'APEX.ISSUES.LABELS.GROUP.FUNCTIONALAREA.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea funcional')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100282494336304778)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.DESC'
,p_message_language=>'es'
,p_message_text=>'Nivel de importancia asignado al problema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100281986440304778)
,p_name=>'APEX.ISSUES.LABELS.GROUP.IMPORTANCE.NAME'
,p_message_language=>'es'
,p_message_text=>'Importancia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100282326591304778)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.DESC'
,p_message_language=>'es'
,p_message_text=>'Nivel de esfuerzo para abordar el problema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100282066032304778)
,p_name=>'APEX.ISSUES.LABELS.GROUP.LEVELOFEFFORT.NAME'
,p_message_language=>'es'
,p_message_text=>'Nivel de esfuerzo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100282270822304778)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.DESC'
,p_message_language=>'es'
,p_message_text=>'Progreso frente al problema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100282153501304778)
,p_name=>'APEX.ISSUES.LABELS.GROUP.PROGRESS.NAME'
,p_message_language=>'es'
,p_message_text=>'Progreso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100284696895304780)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.BACKLOG'
,p_message_language=>'es'
,p_message_text=>'Atraso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100284347332304780)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.CRITICAL'
,p_message_language=>'es'
,p_message_text=>unistr('Cr\00EDtico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100284453250304780)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.IMPORTANT'
,p_message_language=>'es'
,p_message_text=>'Importante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100284571786304780)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.NORMAL'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100284744071304780)
,p_name=>'APEX.ISSUES.LABELS.IMPORTANCE.WILLNOTADDRESS'
,p_message_language=>'es'
,p_message_text=>unistr('No se abordar\00E1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100284878287304780)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.EASY'
,p_message_language=>'es'
,p_message_text=>unistr('Soluci\00F3n f\00E1cil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100285021269304780)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.LARGE'
,p_message_language=>'es'
,p_message_text=>'Gran esfuerzo de desarrollo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100284955703304780)
,p_name=>'APEX.ISSUES.LABELS.LEVELOFEFFORT.MODERATE'
,p_message_language=>'es'
,p_message_text=>'Esfuerzo moderado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100285401582304780)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.CANNOTFIX'
,p_message_language=>'es'
,p_message_text=>'No se puede reparar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100285506843304781)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.COMPLETE'
,p_message_language=>'es'
,p_message_text=>'Terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100285240821304780)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.REQUIRESMOREINFO'
,p_message_language=>'es'
,p_message_text=>unistr('Necesita m\00E1s informaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100285320856304780)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WAITINGONTHIRDPARTY'
,p_message_language=>'es'
,p_message_text=>'A la espera de un tercero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100285116076304780)
,p_name=>'APEX.ISSUES.LABELS.PROGRESS.WORKINGONIT'
,p_message_language=>'es'
,p_message_text=>'Trabajando en ello'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100295674181304788)
,p_name=>'APEX.ISSUES.LABEL_GROUP_DELETE_WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('Este grupo de etiquetas no se puede eliminar porque uno o m\00E1s de sus miembros est\00E1n asignados a un problema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99555449570304186)
,p_name=>'APEX.ISSUES.LAST_UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima Actualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99551764785304183)
,p_name=>'APEX.ISSUES.MARKED_DUPLICATE_OF'
,p_message_language=>'es'
,p_message_text=>'Marcado como duplicado de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100339778937304821)
,p_name=>'APEX.ISSUES.MENU.ASSIGNEES'
,p_message_language=>'es'
,p_message_text=>'Personas asignadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100339662905304820)
,p_name=>'APEX.ISSUES.MENU.LABELS'
,p_message_language=>'es'
,p_message_text=>'Etiquetas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100340140143304821)
,p_name=>'APEX.ISSUES.MENU.MILESTONES'
,p_message_language=>'es'
,p_message_text=>'Hitos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100339562077304820)
,p_name=>'APEX.ISSUES.MENU.STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99549688367304181)
,p_name=>'APEX.ISSUES.MILESTONES'
,p_message_language=>'es'
,p_message_text=>'hitos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100285922127304781)
,p_name=>'APEX.ISSUES.MILESTONES.CODEFREEZE'
,p_message_language=>'es'
,p_message_text=>unistr('Congelaci\00F3n del C\00F3digo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100286191171304781)
,p_name=>'APEX.ISSUES.MILESTONES.FINALRELEASE'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n final')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100286075638304781)
,p_name=>'APEX.ISSUES.MILESTONES.UIFREEZE'
,p_message_language=>'es'
,p_message_text=>unistr('Congelaci\00F3n de IU')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99554173828304185)
,p_name=>'APEX.ISSUES.NOTIFY.ADDED_A_COMMENT_TO'
,p_message_language=>'es'
,p_message_text=>'%0 ha agregado un comentario a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99498215880304140)
,p_name=>'APEX.ISSUES.NOTIFY.HAS_CHANGED'
,p_message_language=>'es'
,p_message_text=>'ha cambiado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100303209558304794)
,p_name=>'APEX.ISSUES.NOTIFY.ISSUE_HAS_CHANGED'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero de problema %0 en el espacio de trabajo %1 ha cambiado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100560655471304986)
,p_name=>'APEX.ISSUES.NO_LABLES_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha definido ninguna etiqueta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99555507058304186)
,p_name=>'APEX.ISSUES.OPEN'
,p_message_language=>'es'
,p_message_text=>'Abrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99552891542304184)
,p_name=>'APEX.ISSUES.OTHER'
,p_message_language=>'es'
,p_message_text=>'Otro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99550353693304182)
,p_name=>'APEX.ISSUES.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99550196628304182)
,p_name=>'APEX.ISSUES.PAGE_NO_LONGER_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina ya no existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100679495970305074)
,p_name=>'APEX.ISSUES.PURGE_BUTTON'
,p_message_language=>'es'
,p_message_text=>'Depurar Todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100355064005304832)
,p_name=>'APEX.ISSUES.REMOVE'
,p_message_language=>'es'
,p_message_text=>'Eliminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99549937502304182)
,p_name=>'APEX.ISSUES.REMOVED_ASSOCIATION'
,p_message_language=>'es'
,p_message_text=>unistr('Se han eliminado las asociaciones de P\00E1gina y Aplicaci\00F3n de')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99550615760304182)
,p_name=>'APEX.ISSUES.REMOVED_THE_ATTACHMENT'
,p_message_language=>'es'
,p_message_text=>'Se ha eliminado el adjunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100654171672305055)
,p_name=>'APEX.ISSUES.REPLACE_COMMENT_CONFIRM'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFDesea sustituir su comentario actual por esta plantilla?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100656152665305056)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_BODY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hola: ',
'',
unistr('Esta es su primera incidencia. Puede crear incidencias para hacer un seguimiento de tareas, funciones, errores y comentarios de todos sus proyectos APEX. Puede a\00F1adir etiquetas a las incidencias, agregar personas asignadas, establecer hitos e incluso')
||unistr(' aplicar formato con el m\00E9todo abreviado Markdown.  '),
'',
unistr('A continuaci\00F3n se ofrece una breve muestra de lo que se puede hacer con Markdown:')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100656035850305056)
,p_name=>'APEX.ISSUES.SAMPLE_ISSUE_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('\00A1Bienvenido a Desarrollo de equipos en Oracle APEX!')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100355145338304832)
,p_name=>'APEX.ISSUES.SELECT'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99550718977304182)
,p_name=>'APEX.ISSUES.SET_STATUS_TO'
,p_message_language=>'es'
,p_message_text=>'Definir estado en'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99527026604304161)
,p_name=>'APEX.ISSUES.SHOW_ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Mostrar acciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100655969493305056)
,p_name=>'APEX.ISSUES.SHOW_MORE'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar M\00E1s...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99550436129304182)
,p_name=>'APEX.ISSUES.SUBSCRIBED'
,p_message_language=>'es'
,p_message_text=>'Suscrito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100561072702304986)
,p_name=>'APEX.ISSUES.SUMMARY_LINE'
,p_message_language=>'es'
,p_message_text=>'%0 en el espacio de trabajo %1 tiene %2 notificaciones nuevas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100279266471304776)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.DESC'
,p_message_language=>'es'
,p_message_text=>'Plantilla utilizada para registrar un bug.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100279150425304776)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.NAME'
,p_message_language=>'es'
,p_message_text=>'Plantilla de bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100279013334304776)
,p_name=>'APEX.ISSUES.TEMPLATE.BUG.TEXT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Comportamiento esperado**',
unistr('- D\00EDganos qu\00E9 cree que deber\00EDa suceder.'),
'',
'',
'**Comportamiento actual**',
unistr('- D\00EDganos qu\00E9 sucede.'),
'',
'',
unistr('**A qui\00E9n afecta**'),
unistr('- D\00EDganos qui\00E9n o qu\00E9 est\00E1 afectado. '),
'',
unistr('**Posible soluci\00F3n**'),
unistr('- Si lo sabe, sugiera c\00F3mo corregir este bug.'),
'',
'**Pasos para reproducirlo**',
unistr('- Proporcione un conjunto inequ\00EDvoco de pasos para reproducirlo, incluyendo capturas de pantalla y fragmentos de c\00F3digo, si corresponde.'),
'1.',
'2.',
'3.',
'',
'**Contexto**',
unistr('- \00BFQu\00E9 estaba intentando hacer cuando ocurri\00F3 el bug? \00BFEl bug solo sucede bajo ciertas condiciones, o a ciertas horas del d\00EDa, de forma sucesiva?'),
'',
'**Entorno**',
'',
unistr('- Versi\00F3n: '),
'- Plataforma: ',
'- Subsistema:',
'',
'______',
'',
unistr('_**NOTA:** Para asociar una incidencia con una aplicaci\00F3n y/o p\00E1gina, registre primero la incidencia; a continuaci\00F3n, use el men\00FA desplegable **ACCIONES** para asociar la aplicaci\00F3n y la p\00E1gina._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100280346289304777)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.DESC'
,p_message_language=>'es'
,p_message_text=>'Se ha creado un bug.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100280245701304777)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.NAME'
,p_message_language=>'es'
,p_message_text=>'Bug creado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100280466268304777)
,p_name=>'APEX.ISSUES.TEMPLATE.BUGRAISED.TEXT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se ha archivado un **bug** en el sistema externo adecuado.',
'',
'- Sistema de seguimiento de bugs: ',
'- ID de bug: ',
'- URL al bug: ',
'',
'Comentarios:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100279492154304776)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla utilizada para registrar una solicitud de funci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100279319459304776)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de solicitud de funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100279516229304776)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATURE.TEXT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Resumen de funciones**',
unistr(' - Proporcione un resumen general de un p\00E1rrafo de la solicitud de funci\00F3n.'),
'',
'',
'**Contexto**',
unistr(' - \00BFEst\00E1 relacionada esta solicitud con una situaci\00F3n o proceso espec\00EDfico? Por ejemplo, "Siempre me siento frustrado cuando [...]"'),
'',
'',
unistr(' - Proporcione cualquier informaci\00F3n de apoyo, incluyendo capturas de pantalla, casos de uso, etc.'),
'',
'',
unistr('**Soluci\00F3n preferida**'),
unistr('- Proporcione una descripci\00F3n clara de lo que le gustar\00EDa implantar.'),
'',
'',
'**Soluciones alternativas**',
unistr('- Proporcione una descripci\00F3n de las soluciones o funciones alternativas consideradas, o de las soluciones alternativas empleadas.'),
'',
'',
'______',
unistr('_**NOTA:** Para asociar una incidencia con una aplicaci\00F3n y/o p\00E1gina, registre primero la incidencia; a continuaci\00F3n, use el men\00FA desplegable **ACCIONES** para asociar la aplicaci\00F3n y la p\00E1gina._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100280670270304777)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha archivado una solicitud de funci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100280552488304777)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Solicitud de funci\00F3n archivada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100280760201304777)
,p_name=>'APEX.ISSUES.TEMPLATE.FEATUREFILED.TEXT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se ha archivado una **solicitud de funci\00F3n** en el sistema externo adecuado.'),
'',
'- Sistema de seguimiento de funciones: ',
unistr('- ID de funci\00F3n: '),
unistr('- URL a la definici\00F3n de funci\00F3n: '),
'',
'Comentarios:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100281532006304778)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Se necesita una acci\00F3n de seguimiento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100281477479304777)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Necesita acci\00F3n de seguimiento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100281688660304778)
,p_name=>'APEX.ISSUES.TEMPLATE.FOLLOWUP.TEXT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Realice las siguientes acciones: ',
'',
'1.',
'2.',
'3.',
'4.',
'',
'Comentarios: '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100279775412304776)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.DESC'
,p_message_language=>'es'
,p_message_text=>'Plantilla utilizada para hacer una pregunta de procedimiento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100279600593304776)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3mo puedo ...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100279826253304776)
,p_name=>'APEX.ISSUES.TEMPLATE.HOWDOI.TEXT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'**Pregunta**',
unistr('- Exponga su pregunta o solicitud de la manera m\00E1s concisa posible.'),
'',
'**Contexto general**',
unistr('- \00BFQu\00E9 est\00E1 tratando de hacer? '),
'',
'',
unistr('- \00BFD\00F3nde m\00E1s ha mirado o con qui\00E9n se ha puesto en contacto para encontrar una respuesta? '),
'',
'',
'**Entorno** ',
unistr('\00BFEs esta pregunta espec\00EDfica de un entorno, lenguaje de programaci\00F3n u otra \00E1rea?'),
'',
'______',
unistr('_**NOTA:** Para asociar un problema con una aplicaci\00F3n y/o p\00E1gina, registre primero el problema; a continuaci\00F3n, use el men\00FA desplegable **ACCIONES** para asociar la aplicaci\00F3n y la p\00E1gina._')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100281220218304777)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.DESC'
,p_message_language=>'es'
,p_message_text=>'Referencia a un problema conocido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100281169965304777)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.NAME'
,p_message_language=>'es'
,p_message_text=>'Problema conocido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100281373093304777)
,p_name=>'APEX.ISSUES.TEMPLATE.KNOWNISSUE.TEXT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Despu\00E9s de su revisi\00F3n, se ha determinado que se trata de un problema conocido; consulte los detalles a continuaci\00F3n.'),
'',
'- Sistema de seguimiento de bugs: ',
'- ID de bug: ',
'- URL al bug: ',
'',
'Comentarios: '))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100280990386304777)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Solicitud de m\00E1s informaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100280847905304777)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Necesita m\00E1s informaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100281004142304777)
,p_name=>'APEX.ISSUES.TEMPLATE.MOREINFO.TEXT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('**Se necesita m\00E1s informaci\00F3n sobre este problema:**'),
'',
unistr('Proporcione la informaci\00F3n que se solicita a continuaci\00F3n. Sin ella, ser\00E1 dif\00EDcil clasificar y abordar el problema m\00E1s a fondo.'),
'',
'',
'Comentarios:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100280040331304776)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Este problema no generar\00E1 ninguna acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100279944353304776)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Sin acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100280104717304777)
,p_name=>'APEX.ISSUES.TEMPLATE.WONTACTION.TEXT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Despu\00E9s de una cuidadosa consideraci\00F3n, **no se llevar\00E1n a cabo m\00E1s acciones para este problema**. '),
'',
'Comentarios:'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99553865953304185)
,p_name=>'APEX.ISSUES.TEXT_FILE'
,p_message_language=>'es'
,p_message_text=>'Archivo de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99552704948304184)
,p_name=>'APEX.ISSUES.TEXT_FILES'
,p_message_language=>'es'
,p_message_text=>'Archivos de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99549588687304181)
,p_name=>'APEX.ISSUES.THIS_ISSUE'
,p_message_language=>'es'
,p_message_text=>'esta incidencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100304386456304794)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_ATTACHMENT'
,p_message_language=>'es'
,p_message_text=>'agregado el adjunto %0 a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100303345648304794)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_LABELS'
,p_message_language=>'es'
,p_message_text=>'agregado %0 a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100304977649304795)
,p_name=>'APEX.ISSUES.TIMELINE.ADDED_MILESTONES'
,p_message_language=>'es'
,p_message_text=>'agregado %0 a %1 %2				'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100303558704304794)
,p_name=>'APEX.ISSUES.TIMELINE.ASSIGNED'
,p_message_language=>'es'
,p_message_text=>'asignado %0 a %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100303924898304794)
,p_name=>'APEX.ISSUES.TIMELINE.ASSOCIATED'
,p_message_language=>'es'
,p_message_text=>'asociado %0 con %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99554047447304185)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_A_COMMENT_FOR'
,p_message_language=>'es'
,p_message_text=>'ha editado un comentario para %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99751766649304331)
,p_name=>'APEX.ISSUES.TIMELINE.EDITED_ISSUE'
,p_message_language=>'es'
,p_message_text=>'se ha editado la incidencia %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100304853257304795)
,p_name=>'APEX.ISSUES.TIMELINE.HIDDEN'
,p_message_language=>'es'
,p_message_text=>'Este problema se ha ocultado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100303794251304794)
,p_name=>'APEX.ISSUES.TIMELINE.MARKED_DUP'
,p_message_language=>'es'
,p_message_text=>'marcado %0 como duplicado de %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100304745799304795)
,p_name=>'APEX.ISSUES.TIMELINE.OPENED'
,p_message_language=>'es'
,p_message_text=>'Abierto %0 por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100304464979304795)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_ATTACHMENT'
,p_message_language=>'es'
,p_message_text=>'eliminado el adjunto %0 de %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100303443229304794)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_LABELS'
,p_message_language=>'es'
,p_message_text=>'eliminado %0 de %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100305062124304795)
,p_name=>'APEX.ISSUES.TIMELINE.REMOVED_MILESTONES'
,p_message_language=>'es'
,p_message_text=>'eliminado %0 de %1 %2 			'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100304599055304795)
,p_name=>'APEX.ISSUES.TIMELINE.STATUS'
,p_message_language=>'es'
,p_message_text=>'definido estado para %0 en %1 %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100304157300304794)
,p_name=>'APEX.ISSUES.TIMELINE.SUBSCRIBED'
,p_message_language=>'es'
,p_message_text=>'suscrito a %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100303638028304794)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSIGNED'
,p_message_language=>'es'
,p_message_text=>unistr('anulada la asignaci\00F3n de %0 de %1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100304003953304794)
,p_name=>'APEX.ISSUES.TIMELINE.UNASSOCIATED'
,p_message_language=>'es'
,p_message_text=>unistr('eliminada la asociaci\00F3n de p\00E1gina y aplicaci\00F3n de %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100303881398304794)
,p_name=>'APEX.ISSUES.TIMELINE.UNMARKED_DUP'
,p_message_language=>'es'
,p_message_text=>'anulado el marcado de %0 como duplicado de %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100304254658304794)
,p_name=>'APEX.ISSUES.TIMELINE.UNSUBSCRIBED'
,p_message_language=>'es'
,p_message_text=>unistr('anulada la suscripci\00F3n de %0 %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100304699713304795)
,p_name=>'APEX.ISSUES.TIMELINE_MARKED_DUPLICATE_OF'
,p_message_language=>'es'
,p_message_text=>'marcado duplicado de %0 %1 por %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99549794227304181)
,p_name=>'APEX.ISSUES.UNASSIGNED'
,p_message_language=>'es'
,p_message_text=>'No Asignado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99526986751304161)
,p_name=>'APEX.ISSUES.UNHIDE'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99550573767304182)
,p_name=>'APEX.ISSUES.UNSUBSCRIBED'
,p_message_language=>'es'
,p_message_text=>unistr('Suscripci\00F3n Cancelada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100339476863304820)
,p_name=>'APEX.ISSUES.UPDATE_MENU'
,p_message_language=>'es'
,p_message_text=>'Actualizar...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99553668758304184)
,p_name=>'APEX.ISSUES.ZIP_FILE'
,p_message_language=>'es'
,p_message_text=>'Archivo Zip'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99552590133304184)
,p_name=>'APEX.ISSUES.ZIP_FILES'
,p_message_language=>'es'
,p_message_text=>'Archivos Zip'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99510883380304149)
,p_name=>'APEX.ITEM.GEOCODE.ERROR_DA_AFFECTED_ELEM'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no es un elemento de direcci\00F3n geocodificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100649156573305051)
,p_name=>'APEX.ITEM.NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el elemento %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100539519119304970)
,p_name=>'APEX.PAGE.CHECKSUM.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('El total de control de la p\00E1gina ofrece un m\00E9todo sencillo para saber si la misma p\00E1gina se ha desplegado en otro lugar. Puede comparar la suma de control para detectar si hay alguna coincidencia. Los cambios en Componentes compartidos usados en esta')
||unistr(' p\00E1gina no se reflejar\00E1n en el total de control.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100695115616305090)
,p_name=>'APEX.PAGE_NAME.ABOUT_THIS_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Acerca de esta Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100694989532305090)
,p_name=>'APEX.PAGE_NAME.CONFIGURATION_OPTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Configuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100695039466305090)
,p_name=>'APEX.PAGE_NAME.THEME_STYLE_SELECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Selecci\00F3n de estilo de tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99527580859304162)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_FONTS'
,p_message_language=>'es'
,p_message_text=>'Solo se permiten fuentes del tipo formato de fuente compacto (CFF) con una fuente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99527653798304162)
,p_name=>'APEX.PDF.ERROR.CFF_MULTIPLE_TOP_DICTS'
,p_message_language=>'es'
,p_message_text=>'Solo se permiten fuentes del tipo formato de fuente compacto (CFF) con un DICT superior.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99527751932304162)
,p_name=>'APEX.PDF.ERROR.CFF_NOT_TYPE2_CHARSTRINGS'
,p_message_language=>'es'
,p_message_text=>'Solo se permiten fuentes del tipo formato de fuente compacto (CFF) con formato de cadena de caracteres de tipo 2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99539973392304171)
,p_name=>'APEX.PDF.ERROR.FONT_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado la fuente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99539813283304171)
,p_name=>'APEX.PDF.ERROR.INVALID_CMAP'
,p_message_language=>'es'
,p_message_text=>unistr('Solo est\00E1n soportadas las tablas CMAP de formato 4 y 12.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99540223812304171)
,p_name=>'APEX.PDF.ERROR.INVALID_ORIENTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Orientaci\00F3n de p\00E1gina no v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99540071479304171)
,p_name=>'APEX.PDF.ERROR.NOT_INITIALIZED'
,p_message_language=>'es'
,p_message_text=>'No se ha inicializado el PDF.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99539717316304171)
,p_name=>'APEX.PDF.ERROR.NO_CMAP'
,p_message_language=>'es'
,p_message_text=>unistr('No se han encontrado subtablas CMAP v\00E1lidas en la fuente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99540155218304171)
,p_name=>'APEX.PDF.ERROR.NO_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('El PDF no tiene p\00E1ginas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99975158964304506)
,p_name=>'APEX.PDF.INTERNAL_ERROR'
,p_message_language=>'es'
,p_message_text=>'Se ha producido un error interno al crear el archivo PDF.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99545520816304178)
,p_name=>'APEX.PROCESS.INVALID_EDITABLE_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('El proceso "%0" tiene asignada una regi\00F3n editable (sin varias filas) no v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99533646286304166)
,p_name=>'APEX.PROCESS.NATIVE.GET_NEXT_OR_PREV_PK_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido obtener el valor de clave primaria anterior o siguiente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100203138445304718)
,p_name=>'APEX.PROCESS.NATIVE.WEB_SERVICE.NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el servicio web.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99740989286304323)
,p_name=>'APEX.PROCESS.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al procesar el proceso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99560243495304189)
,p_name=>'APEX.QOS.REQUEST_LIMIT_REACHED'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Application Express no ha podido procesar la solicitud debido a las limitaciones de recursos de sesi\00F3n de la base de datos. Vuelva a intentarlo m\00E1s tarde.'),
'<p/>',
unistr('Puede obtener informaci\00F3n sobre este incidente a trav\00E9s del ID de depuraci\00F3n "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99534466514304167)
,p_name=>'APEX.REMOTEDEPLOY.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha producido el siguiente error al desplegar la aplicaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99537158320304169)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n %0 se ha desplegado correctamente en el servidor remoto.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99540823686304172)
,p_name=>'APEX.REMOTEDEPLOY.SUCCESS2'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n %0 se ha desplegado correctamente como %1 en el servidor remoto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100175372671304697)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('Error de autenticaci\00F3n del servicio de SQL activado para REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99560538746304190)
,p_name=>'APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de autenticaci\00F3n. La lista de valores utiliza un origen de datos de SQL activado para REST que hace referencia a credenciales web no v\00E1lidas, que le impedir\00E1n editar la informaci\00F3n de la columna de esta lista de valores. Compruebe las credencia')
||unistr('les de autenticaci\00F3n. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100681635791305080)
,p_name=>'APEX.REMOTESQL.COMMUNICATION_FAILURE'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de comunicaci\00F3n. Se ha producido un problema al llamar al origen de datos SQL activado para REST por parte de la lista de valores, lo que le impide editar la informaci\00F3n de la columna para la lista de valores. Compruebe que el origen de datos S')
||unistr('QL activado para REST funciona correctamente y que las credenciales de autenticaci\00F3n correspondientes son correctas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100176628547304698)
,p_name=>'APEX.REMOTESQL.REMOTE_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error en el servidor remoto: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100151478526304679)
,p_name=>'APEX.REMOTESQL.SERVER_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado la instancia SQL activada para REST de ORDS especificada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99757264453304335)
,p_name=>'APEX.REMOTESQL.SERVER_SENT_REDIRECT'
,p_message_language=>'es'
,p_message_text=>'El servidor ha enviado un redireccionamiento a: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100051785846304564)
,p_name=>'APEX.REMOTESQL.SQL_STATEMENT_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>unistr('La sentencia SQL tiene m\00E1s de 32.767 bytes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100070458293304578)
,p_name=>'APEX.REMOTESQL.TEST_MESSAGE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hola, Application Express. Se ha conectado como #USER#.',
'El registro de hora de la base de datos local es: #SYSDATE#.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100295555526304788)
,p_name=>'APEX.REST.DEFAULT_SCHEMA_WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1 editando el alias del esquema por defecto del espacio de trabajo. Al ajustarlo, tambi\00E9n cambiar\00E1 el prefijo de la ruta de acceso en el nivel del espacio de trabajo. Esto afectar\00E1 a la URL de cualquier servicio RESTful basado en APEX que haya def')
||'inido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100049490130304562)
,p_name=>'APEX.SC.REFERENCES'
,p_message_language=>'es'
,p_message_text=>'%0 referencias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100286802910304782)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES'
,p_message_language=>'es'
,p_message_text=>'Utilidades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100286921278304782)
,p_name=>'APEX.SEARCH.AU.APPLICATION_UTILITIES_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Utilidades de aplicaci\00F3n \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100294349187304787)
,p_name=>'APEX.SEARCH.GO_TO_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100294278312304787)
,p_name=>'APEX.SEARCH.GO_TO_SHARED_COMPONENTS'
,p_message_language=>'es'
,p_message_text=>'Ir a Componentes compartidos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100287082748304782)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER'
,p_message_language=>'es'
,p_message_text=>'Creador de Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100287104365304782)
,p_name=>'APEX.SEARCH.P1500.APP_BUILDER_TASKS'
,p_message_language=>'es'
,p_message_text=>'Tareas del creador de aplicaciones > '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100287266167304782)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100287344016304782)
,p_name=>'APEX.SEARCH.SC.APP_ITEMS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Componentes compartidos \005C Elementos de aplicaci\00F3n \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100287447180304782)
,p_name=>'APEX.SEARCH.SC.APP_LOGIC'
,p_message_language=>'es'
,p_message_text=>unistr('L\00F3gica de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100287570941304782)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES'
,p_message_language=>'es'
,p_message_text=>unistr('Esquemas de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100287670282304782)
,p_name=>'APEX.SEARCH.SC.AUTHENTICATION_SCHEMES_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Componentes compartidos \005C Esquemas de autenticaci\00F3n de seguridad \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100287732495304782)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES'
,p_message_language=>'es'
,p_message_text=>unistr('Esquemas de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100287818452304782)
,p_name=>'APEX.SEARCH.SC.AUTHORIZATION_SCHEMES_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Componentes compartidos \005C Esquemas de autorizaci\00F3n de seguridad \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100287963008304782)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS'
,p_message_language=>'es'
,p_message_text=>unistr('Rutas de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100288026289304782)
,p_name=>'APEX.SEARCH.SC.BREADCRUMBS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Componentes compartidos \005C Rutas de navegaci\00F3n \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100288155283304783)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100288284858304783)
,p_name=>'APEX.SEARCH.SC.BUILD_OPTIONS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Componentes compartidos \005C Opciones de creaci\00F3n \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100288377026304783)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS'
,p_message_language=>'es'
,p_message_text=>'Valores de Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100288424569304783)
,p_name=>'APEX.SEARCH.SC.COMPONENT_SETTINGS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Navegar a: Componentes compartidos \ Valores de componente \ %LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100288514450304783)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100288600485304783)
,p_name=>'APEX.SEARCH.SC.COMPUTATIONS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Componentes compartidos \005C C\00E1lculos de aplicaci\00F3n \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100288786674304783)
,p_name=>'APEX.SEARCH.SC.CREATE_APPLICATION_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Elemento de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100288842843304783)
,p_name=>'APEX.SEARCH.SC.CREATE_AUTHENTICATION_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Esquema de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100288994102304783)
,p_name=>'APEX.SEARCH.SC.CREATE_BUILD_OPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Opci\00F3n de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100289094458304783)
,p_name=>'APEX.SEARCH.SC.CREATE_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Crear c\00E1lculo de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100289129719304783)
,p_name=>'APEX.SEARCH.SC.CREATE_EMAIL_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Crear plantilla de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100289256457304783)
,p_name=>'APEX.SEARCH.SC.CREATE_PLUG-IN'
,p_message_language=>'es'
,p_message_text=>'Crear Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100289361444304783)
,p_name=>'APEX.SEARCH.SC.CREATE_THEME'
,p_message_language=>'es'
,p_message_text=>'Crear Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100289444116304784)
,p_name=>'APEX.SEARCH.SC.CREATE_WEB_CREDENTIALS'
,p_message_language=>'es'
,p_message_text=>'Crear credenciales web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100289501473304784)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS'
,p_message_language=>'es'
,p_message_text=>'Definiciones de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100289625257304784)
,p_name=>'APEX.SEARCH.SC.DATA_LOAD_DEFINITIONS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Navegar a: Componentes compartidos \ Definiciones de carga de datos \ %LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100289723296304784)
,p_name=>'APEX.SEARCH.SC.DATA_SOURCES'
,p_message_language=>'es'
,p_message_text=>unistr('Or\00EDgenes de datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100289817595304784)
,p_name=>'APEX.SEARCH.SC.DEFINITION_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>unistr('Atributos de definici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100289964239304784)
,p_name=>'APEX.SEARCH.SC.EMAIL_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100290048546304784)
,p_name=>'APEX.SEARCH.SC.LAYOUTS'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1os de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100290196570304784)
,p_name=>'APEX.SEARCH.SC.LAYOUTS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Componentes compartidos \005C Dise\00F1os de informe \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100290238000304784)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES'
,p_message_language=>'es'
,p_message_text=>'Servicios web heredados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100290352038304784)
,p_name=>'APEX.SEARCH.SC.LEGACY_WEB_SERVICES_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Navegar a: Componentes compartidos \ Servicios web heredados \ %LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100290471476304784)
,p_name=>'APEX.SEARCH.SC.LISTS'
,p_message_language=>'es'
,p_message_text=>unistr('Listas de navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100290516027304784)
,p_name=>'APEX.SEARCH.SC.LISTS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Componentes compartidos \005C Listas de navegaci\00F3n cl\00E1sica \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100290639485304784)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100290789742304785)
,p_name=>'APEX.SEARCH.SC.LIST_OF_VALUES_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Navegar a: Componentes compartidos \ Lista de valores \ %LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100290801735304785)
,p_name=>'APEX.SEARCH.SC.NAVIGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100290924868304785)
,p_name=>'APEX.SEARCH.SC.OTHER_COMPONENTS'
,p_message_language=>'es'
,p_message_text=>'Otros Componentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100291086407304785)
,p_name=>'APEX.SEARCH.SC.PLUG-INS'
,p_message_language=>'es'
,p_message_text=>'Plugins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100291106330304785)
,p_name=>'APEX.SEARCH.SC.PLUG-INS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Navegar a: Componentes compartidos \ Plugins \ %LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100291274364304785)
,p_name=>'APEX.SEARCH.SC.PROCESSES'
,p_message_language=>'es'
,p_message_text=>'Procesos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100291367837304785)
,p_name=>'APEX.SEARCH.SC.PROCESSES_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Componentes compartidos \005C Procesos de aplicaci\00F3n \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100291421806304785)
,p_name=>'APEX.SEARCH.SC.QUERIES'
,p_message_language=>'es'
,p_message_text=>'Consultas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100291575460304785)
,p_name=>'APEX.SEARCH.SC.QUERIES_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Navegar a: Componentes compartidos \ Consultas de informe \ %LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100291623050304785)
,p_name=>'APEX.SEARCH.SC.REPORTS'
,p_message_language=>'es'
,p_message_text=>'Informes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100291717865304785)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL'
,p_message_language=>'es'
,p_message_text=>'SQL activado para REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100291889939304785)
,p_name=>'APEX.SEARCH.SC.REST_ENABLED_SQL_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Navegar a: Componentes compartidos \ SQL activado para REST \ %LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100291916480304785)
,p_name=>'APEX.SEARCH.SC.SECURITY'
,p_message_language=>'es'
,p_message_text=>'Seguridad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100292095015304785)
,p_name=>'APEX.SEARCH.SC.SESSION_STATE_PROTECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100292164954304786)
,p_name=>'APEX.SEARCH.SC.SET_APPLICATION_SESSION_STATE_PROTECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Definir protecci\00F3n de estado de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100292342652304786)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS'
,p_message_language=>'es'
,p_message_text=>'Componentes Compartidos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100292498072304786)
,p_name=>'APEX.SEARCH.SC.SHARED_COMPONENTS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Navegar a: Componentes compartidos \ %LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100292504813304786)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todos Abreviados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100292695631304786)
,p_name=>'APEX.SEARCH.SC.SHORTCUTS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Componentes compartidos \005C M\00E9todos abreviados \005C %LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100292771415304786)
,p_name=>'APEX.SEARCH.SC.TABS'
,p_message_language=>'es'
,p_message_text=>'Separadores (heredados)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100292888232304786)
,p_name=>'APEX.SEARCH.SC.TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100292904660304786)
,p_name=>'APEX.SEARCH.SC.TEMPLATES_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Navegar a: Componentes compartidos \ Plantillas de interfaz de usuario \ %LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100293021763304786)
,p_name=>'APEX.SEARCH.SC.THEMES'
,p_message_language=>'es'
,p_message_text=>'Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100293197252304786)
,p_name=>'APEX.SEARCH.SC.THEMES_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Navegar a: Componentes compartidos \ Temas de interfaz de usuario \ %LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100293291261304786)
,p_name=>'APEX.SEARCH.SC.UI'
,p_message_language=>'es'
,p_message_text=>'Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100293310527304786)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS'
,p_message_language=>'es'
,p_message_text=>'Credenciales web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100293465948304787)
,p_name=>'APEX.SEARCH.SC.WEB_CREDENTIALS_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Navegar a: Componentes compartidos \ Credenciales web de seguridad \ %LIST_ITEM_NAME%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100293545931304787)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES'
,p_message_language=>'es'
,p_message_text=>'Origen de Datos de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100293657722304787)
,p_name=>'APEX.SEARCH.SC.WEB_SOURCE_MODULES_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a: Componentes compartidos\005COr\00EDgenes de datos de REST\005C%LIST_ITEM_NAME%')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100293727652304787)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP'
,p_message_language=>'es'
,p_message_text=>'Taller de SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100293842852304787)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT'
,p_message_language=>'es'
,p_message_text=>'Crear Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100293918517304787)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.CREATE_OBJECT_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Crear %LIST_ITEM_NAME% en taller de SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100294007277304787)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.SCRIPT_EDITOR'
,p_message_language=>'es'
,p_message_text=>'Editor de Script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100294176233304787)
,p_name=>'APEX.SEARCH.SQL_WORKSHOP.TASKS'
,p_message_language=>'es'
,p_message_text=>'Tareas del taller de SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100752935563305133)
,p_name=>'APEX.SESSION_STATE.DB_COLUMN_SOURCE_USED'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento de la p\00E1gina %0 se basa en una columna de base de datos, pero el atributo ''Origen Utilizado'' se define en ''Solo cuando el valor de sesi\00F3n actual en el estado de sesi\00F3n sea nulo''. Esta acci\00F3n es muy peligrosa y puede dar como resultado que')
||unistr(' se sobrescriban los datos de forma accidental al visualizar y guardar varios registros. Defina siempre ''Origen Utilizado'' en ''Siempre, sustituyendo cualquier valor existente en el estado de sesi\00F3n''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100690288685305086)
,p_name=>'APEX.SESSION_STATE.DISABLED'
,p_message_language=>'es'
,p_message_text=>unistr('El acceso al estado de la sesi\00F3n est\00E1 desactivado, el intento de lectura/escritura se ha bloqueado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99573621823304200)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha intentado guardar el elemento %0 en el estado de la sesi\00F3n durante el procesamiento de presentaci\00F3n, el elemento tiene protecci\00F3n de tipo S\00F3lo Interno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99566494399304194)
,p_name=>'APEX.SESSION_STATE.INTERNAL_ONLY_VIOLATION2'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha intentado guardar el elemento %0 en el estado de la sesi\00F3n durante el procesamiento de aceptaci\00F3n, el elemento tiene protecci\00F3n de tipo S\00F3lo Interno o no es un elemento de pantalla que se pueda enviar con POST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99566200539304194)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION2_FOR_DEVELOPERS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El total de control calculado a partir de valores de solicitud, borrado de cach\00E9, nombres de argumento y valores de argumento (%0) no ha coincidido con el total de control transferido al procedimiento de presentaci\00F3n (%1).'),
'',
'Nota: los usuarios finales obtienen un mensaje de error diferente.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99565747289304194)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION_FOR_DEVELOPERS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se ha intentado guardar el elemento %0 en el estado de sesi\00F3n durante el procesamiento de presentaci\00F3n. El nivel de protecci\00F3n del elemento indica:'),
'  %1',
'',
unistr('No se ha transferido ning\00FAn total de control o el total de control que se ha transferido ser\00EDa adecuado para un elemento con un nivel de protecci\00F3n "%2".'),
'',
'Nota: los usuarios finales obtienen un mensaje de error diferente.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99740773139304323)
,p_name=>'APEX.SESSION_STATE.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>'ERR-1022: No se han podido guardar los atributos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99510317948304149)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_SDO_GEOMETRY_TO_GEOJSON'
,p_message_language=>'es'
,p_message_text=>'No se puede convertir el valor SDO_GEOMETRY a GeoJSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99507899677304147)
,p_name=>'APEX.SPATIAL.CANNOT_CONVERT_TEXT_TO_SDO_GEOMETRY'
,p_message_language=>'es'
,p_message_text=>'No se puede convertir el texto en un objeto SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99509049690304148)
,p_name=>'APEX.SPATIAL.INVALID_GEOJSON'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no contiene GeoJSON v\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99524653527304159)
,p_name=>'APEX.TABULAR_FORM.COLUMN_DEFAULT_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al calcular el valor por defecto para la columna #COMPONENT_NAME#.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99525598286304160)
,p_name=>'APEX.TABULAR_FORM.MRD.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la supresi\00F3n de varias filas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99767781108304342)
,p_name=>'APEX.TABULAR_FORM.MRU.FCS_MISSING'
,p_message_language=>'es'
,p_message_text=>'Se necesita la columna de total de control ("FCS") y no se ha proporcionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99767938588304342)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_PRIM_KEY_VALS'
,p_message_language=>'es'
,p_message_text=>'No se han proporcionado valores de clave primaria. Para que se produzcan las actualizaciones, se debe proporcionar al menos una fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99768763791304343)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_SEC_KEY_VALS'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha proporcionado ning\00FAn valor secundario para la columna de clave secundaria identificada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99908386442304454)
,p_name=>'APEX.TABULAR_FORM.MRU.NO_VALUES'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn dato en la pantalla tabular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99767611578304342)
,p_name=>'APEX.TABULAR_FORM.MRU.PRIM_KEY_COL_NOT_SPECIFIED'
,p_message_language=>'es'
,p_message_text=>'No se ha especificado la columna de clave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99768623258304343)
,p_name=>'APEX.TABULAR_FORM.MRU.SEC_KEY_COL_NOT_IN_SELECT_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la columna de clave secundaria identificada en la lista de selecci\00F3n de la consulta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99767591503304342)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_NAME_NOT_SPECIFIED'
,p_message_language=>'es'
,p_message_text=>'No se ha especificado el nombre de la tabla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99767470772304342)
,p_name=>'APEX.TABULAR_FORM.MRU.TABLE_OWNER_NOT_SPECIFIED'
,p_message_language=>'es'
,p_message_text=>'No se ha especificado el propietario de la tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99788651135304358)
,p_name=>'APEX.TABULAR_FORM.MRU.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la actualizaci\00F3n de varias filas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99548879613304181)
,p_name=>'APEX.THEMES.COPY_THEME_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede copiar el tema "%0" en la aplicaci\00F3n "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100746490688305128)
,p_name=>'APEX.THEMES.INCOMPATIBLE_THEME'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'El tema importado no es compatible con el tema actual.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100728586787305115)
,p_name=>'APEX.THEMES.INVALID_THEME_NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero de tema no es v\00E1lido o el tema no es un tema de interfaz de usuario actual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100689365653305085)
,p_name=>'APEX.TREE.ID_AND_PARENT_ID_COLUMNS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se necesitan las columnas de clave primaria y clave principal para calcular la jerarqu\00EDa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100689439128305085)
,p_name=>'APEX.TREE.NODE_LEVEL_AND_STATUS_COLUMNS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se necesitan las columnas de estado de nodo y nivel de nodo cuando no se ha calculado la jerarqu\00EDa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100707783214305099)
,p_name=>'APEX.UI.APPEARANCE'
,p_message_language=>'es'
,p_message_text=>'Apariencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100466796374304916)
,p_name=>'APEX.UI.AUTO_MODE'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99681299066304279)
,p_name=>'APEX.UI.DARK_MODE'
,p_message_language=>'es'
,p_message_text=>'Modo oscuro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99681375839304279)
,p_name=>'APEX.UI.DISABLED'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100466643571304916)
,p_name=>'APEX.UI.LIGHT_MODE'
,p_message_language=>'es'
,p_message_text=>'Modo ligero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100110190777304609)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>'Seleccione una interfaz de usuario de la siguiente lista:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100112452605304611)
,p_name=>'APEX.UI_TYPE.CLIENT_DETECTION.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('%0: Selecci\00F3n de Interfaz de Usuario')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99651910091304258)
,p_name=>'APEX.USER.CHECK_SGID'
,p_message_language=>'es'
,p_message_text=>'Acceso no autorizado (no se ha definido la variable del paquete del grupo de seguridad).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99652369745304258)
,p_name=>'APEX.USER.FETCH_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido recuperar la informaci\00F3n de b\00FAsqueda de usuario. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99638138608304247)
,p_name=>'APEX.USER.NOT_ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario %0 necesita el privilegio ADMIN para realizar esta operaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99652254689304258)
,p_name=>'APEX.USER.NO_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario %0 no ha proporcionado ninguna direcci\00F3n de correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99608025919304225)
,p_name=>'APEX.USER.UNAUTHORIZED'
,p_message_language=>'es'
,p_message_text=>'Acceso no autorizado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99652120002304258)
,p_name=>'APEX.USER.USER_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>'El usuario %0 no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99567135115304195)
,p_name=>'APEX.VALIDATION.INVALID_EDITABLE_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('La validaci\00F3n "%0" tiene asignada una regi\00F3n editable (sin varias filas) no v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99740816181304323)
,p_name=>'APEX.VALIDATION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100690681993305086)
,p_name=>'APEX.WEBSRC.CANNOT_PARSE_DATA'
,p_message_language=>'es'
,p_message_text=>'Application Express no puede calcular un perfil de datos a partir de los datos de respuesta del tipo: %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100157325800304684)
,p_name=>'APEX.WEBSRC.DATAPROFILE.MANY'
,p_message_language=>'es'
,p_message_text=>'Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100157243959304683)
,p_name=>'APEX.WEBSRC.DATAPROFILE.ONE'
,p_message_language=>'es'
,p_message_text=>'Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100677214721305073)
,p_name=>'APEX.WEBSRC.FILTER_EXPR_INVALID_JSON'
,p_message_language=>'es'
,p_message_text=>unistr('La expresi\00F3n de filtro no es un valor JSON v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100670487850305068)
,p_name=>'APEX.WEBSRC.FILTER_NOT_SUPPORTED_BY_ORDS'
,p_message_language=>'es'
,p_message_text=>unistr('El filtro no est\00E1 soportado por Oracle REST Data Services.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100049309429304562)
,p_name=>'APEX.WEBSRC.HTTP.PAGINATION_PARAMETER_CONFLICT'
,p_message_language=>'es'
,p_message_text=>unistr('El par\00E1metro de URL de paginaci\00F3n "%0" entra en conflicto con un par\00E1metro de origen de REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100152276001304680)
,p_name=>'APEX.WEBSRC.HTTP200'
,p_message_language=>'es'
,p_message_text=>'HTTP 200: correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100152306220304680)
,p_name=>'APEX.WEBSRC.HTTP201'
,p_message_language=>'es'
,p_message_text=>'HTTP 201: creado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100151720399304679)
,p_name=>'APEX.WEBSRC.HTTP400'
,p_message_language=>'es'
,p_message_text=>unistr('HTTP 400: Solicitud Err\00F3nea')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100151501299304679)
,p_name=>'APEX.WEBSRC.HTTP401'
,p_message_language=>'es'
,p_message_text=>'HTTP 401: no autorizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100151874994304679)
,p_name=>'APEX.WEBSRC.HTTP403'
,p_message_language=>'es'
,p_message_text=>'HTTP 403: prohibido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100151635069304679)
,p_name=>'APEX.WEBSRC.HTTP404'
,p_message_language=>'es'
,p_message_text=>'HTTP 404: No Encontrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100151965981304679)
,p_name=>'APEX.WEBSRC.HTTP405'
,p_message_language=>'es'
,p_message_text=>unistr('HTTP 405: m\00E9todo no permitido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99509698086304148)
,p_name=>'APEX.WEBSRC.HTTP407'
,p_message_language=>'es'
,p_message_text=>unistr('HTTP 407: Autenticaci\00F3n del proxy necesaria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99509905535304148)
,p_name=>'APEX.WEBSRC.HTTP409'
,p_message_language=>'es'
,p_message_text=>'HTTP 409: Conflicto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99509717289304148)
,p_name=>'APEX.WEBSRC.HTTP412'
,p_message_language=>'es'
,p_message_text=>unistr('HTTP 412: Fallo en condici\00F3n previa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99509802327304148)
,p_name=>'APEX.WEBSRC.HTTP428'
,p_message_language=>'es'
,p_message_text=>unistr('HTTP 428: Condici\00F3n previa necesaria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100152086077304680)
,p_name=>'APEX.WEBSRC.HTTP500'
,p_message_language=>'es'
,p_message_text=>'HTTP 500: error interno del servidor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100152136003304680)
,p_name=>'APEX.WEBSRC.HTTP502'
,p_message_language=>'es'
,p_message_text=>unistr('HTTP 502: gateway err\00F3neo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100691092573305087)
,p_name=>'APEX.WEBSRC.HTTP503'
,p_message_language=>'es'
,p_message_text=>'HTTP 503: Servicio no disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100691193628305087)
,p_name=>'APEX.WEBSRC.HTTP504'
,p_message_language=>'es'
,p_message_text=>'HTTP 504: Timeout del gateway'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100533228570304965)
,p_name=>'APEX.WEBSRC.HTTP_ERROR_OCCURRED'
,p_message_language=>'es'
,p_message_text=>'El origen de datos REST ha devuelto un error de HTTP: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100151358743304679)
,p_name=>'APEX.WEBSRC.MODULE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el origen de datos de REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99707129069304298)
,p_name=>'APEX.WEBSRC.NO_ARRAY_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('El selector de filas "%0" no ha seleccionado ninguna matriz de objetos que se considerar\00E1 como una tabla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99707216522304298)
,p_name=>'APEX.WEBSRC.NO_SINGLE_ROW_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('El selector de filas "%0" no ha seleccionado ning\00FAn objeto que se considerar\00E1 como una sola fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99512828508304151)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha excedido el l\00EDmite de ratio de origen de datos de REST (%0 solicitudes en %1 segundos).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99501895281304142)
,p_name=>'APEX.WEBSRC.RATELIMIT_EXCEEDED_CANNOT_WAIT'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha excedido el l\00EDmite de ratio de origen de datos de REST (%0 solicitudes en %1 segundos) y el tiempo de espera necesario es demasiado largo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100533138877304965)
,p_name=>'APEX.WEBSRC.REQUIRED_PARAM_MISSING'
,p_message_language=>'es'
,p_message_text=>unistr('El par\00E1metro IN de origen REST necesario "%0" del tipo "%1" debe tener un valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100451159878304905)
,p_name=>'APEX.WEBSRC.RESPONSE_BODY_TOO_LARGE'
,p_message_language=>'es'
,p_message_text=>'El cuerpo de respuesta es demasiado grande para mostrarse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100116520690304614)
,p_name=>'APEX.WEBSRC.SMALL_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('El servicio heredado ORDS REST utiliza un tama\00F1o fijo de p\00E1gina peque\00F1o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99516465241304153)
,p_name=>'APEX.WEBSRC.SYNC.API_CALL_COMMENT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Esta llamada de API sincroniza la tabla de columnas del perfil de datos ',
unistr('-- del origen de datos de REST de forma din\00E1mica al ejecutar las sentencias ALTER TABLE. '),
unistr('-- Si un tipo de datos de columna no se puede cambiar con ALTER TABLE, se emitir\00E1 '),
'-- un mensaje de error.',
'--'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99515306129304152)
,p_name=>'APEX.WEBSRC.SYNC.CANNOT_SYNC_TABLE_COLUMNS'
,p_message_language=>'es'
,p_message_text=>unistr('Los cambios del perfil de datos no pueden aplicarse autom\00E1ticamente, las columnas de la tabla local deben ajustarse de forma manual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99516588032304153)
,p_name=>'APEX.WEBSRC.SYNC.DDL_CALL_COMMENT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('-- A partir de %0 se ejecutar\00E1:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99514582113304152)
,p_name=>'APEX.WEBSRC.SYNC.MERGE_REQUIRES_PRIMARY_KEY'
,p_message_language=>'es'
,p_message_text=>unistr('El m\00E9todo de sincronizaci\00F3n de fusi\00F3n requiere que se defina una clave principal en el perfil de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99514866590304152)
,p_name=>'APEX.WEBSRC.SYNC.NO_COMMON_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'La tabla local y el perfil de datos no tienen columnas comunes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99501494035304142)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_ABORTED'
,p_message_language=>'es'
,p_message_text=>'Trabajo abortado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99515040979304152)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_FAILURE'
,p_message_language=>'es'
,p_message_text=>'Fallo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99515150544304152)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_INCOMPLETE'
,p_message_language=>'es'
,p_message_text=>unistr('Incompleta (se ha excedido el l\00EDmite de solicitudes)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99515280938304152)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_JOB_ALREADY_RUNNING'
,p_message_language=>'es'
,p_message_text=>unistr('El trabajo ya se est\00E1 ejecutando')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99502386286304143)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_RUNNING'
,p_message_language=>'es'
,p_message_text=>unistr('En ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99502470654304143)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SCHEDULED'
,p_message_language=>'es'
,p_message_text=>'Programado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99514959134304152)
,p_name=>'APEX.WEBSRC.SYNC.STATUS_SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99514615792304152)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Paso de sincronizaci\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99514745057304152)
,p_name=>'APEX.WEBSRC.SYNC.STEP_STATIC_LABEL_COPY'
,p_message_language=>'es'
,p_message_text=>'%0 (nuevo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99999448678304524)
,p_name=>'APEX.WEBSRC.TEST_OPERATION'
,p_message_language=>'es'
,p_message_text=>unistr('Operaci\00F3n de prueba')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100070515488304578)
,p_name=>'APEX.WEBSRC.TIMEOUT_EXCEEDED'
,p_message_language=>'es'
,p_message_text=>'Se ha excedido el timeout al recuperar todos los datos de origen REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100046465377304560)
,p_name=>'APEX.WEBSRC.TOO_MANY_NEXT_PAGE_REQUESTS'
,p_message_language=>'es'
,p_message_text=>unistr('Los filtros de SQL local actuales necesitan demasiadas solicitudes de "P\00E1gina siguiente" para el servicio REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100116419357304614)
,p_name=>'APEX.WEBSRC.UNKNOWN_ORDS2_FIXED_PAGE_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('El tama\00F1o fijo de p\00E1gina del servicio REST de ORDS heredado es desconocido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99822865797304382)
,p_name=>'APEXAPP.BRANCH.ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcar a p\00E1gina de administraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99797304078304364)
,p_name=>'APEXAPP.BREADCRUMB.DEFAULT'
,p_message_language=>'es'
,p_message_text=>unistr('Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99818964287304379)
,p_name=>'APEXAPP.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'es'
,p_message_text=>'Comentado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99803458302304368)
,p_name=>'APEXAPP.BUTTON.ADD'
,p_message_language=>'es'
,p_message_text=>'Agregar Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99803798837304369)
,p_name=>'APEXAPP.BUTTON.ADD_ENTITY'
,p_message_language=>'es'
,p_message_text=>'Agregar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99804187898304369)
,p_name=>'APEXAPP.BUTTON.ADD_MULTIPLE_USERS'
,p_message_language=>'es'
,p_message_text=>'Agregar varios usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99804279008304369)
,p_name=>'APEXAPP.BUTTON.ADD_USER'
,p_message_language=>'es'
,p_message_text=>'Agregar Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99804329161304369)
,p_name=>'APEXAPP.BUTTON.ADD_USERS'
,p_message_language=>'es'
,p_message_text=>'Agregar usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99803148088304368)
,p_name=>'APEXAPP.BUTTON.APPLY'
,p_message_language=>'es'
,p_message_text=>'Aplicar Cambios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99803238785304368)
,p_name=>'APEXAPP.BUTTON.CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99803392865304368)
,p_name=>'APEXAPP.BUTTON.CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99803056603304368)
,p_name=>'APEXAPP.BUTTON.CREATE'
,p_message_language=>'es'
,p_message_text=>'Crear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99792301858304360)
,p_name=>'APEXAPP.BUTTON.DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99803581786304368)
,p_name=>'APEXAPP.BUTTON.DELETE_CHECKED'
,p_message_language=>'es'
,p_message_text=>unistr('Suprimir Selecci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99803628638304368)
,p_name=>'APEXAPP.BUTTON.EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99803854035304369)
,p_name=>'APEXAPP.BUTTON.FINISH'
,p_message_language=>'es'
,p_message_text=>'Terminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99792175424304360)
,p_name=>'APEXAPP.BUTTON.GO'
,p_message_language=>'es'
,p_message_text=>'Ir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99792892187304361)
,p_name=>'APEXAPP.BUTTON.LOAD_DATA'
,p_message_language=>'es'
,p_message_text=>'Cargar Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99803953190304369)
,p_name=>'APEXAPP.BUTTON.LOGIN'
,p_message_language=>'es'
,p_message_text=>'Conectar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99792550545304360)
,p_name=>'APEXAPP.BUTTON.NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99792479103304360)
,p_name=>'APEXAPP.BUTTON.PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99792287415304360)
,p_name=>'APEXAPP.BUTTON.RESET'
,p_message_language=>'es'
,p_message_text=>'Restablecer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99792653594304360)
,p_name=>'APEXAPP.BUTTON.SAVE'
,p_message_language=>'es'
,p_message_text=>'Guardar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99792747260304360)
,p_name=>'APEXAPP.BUTTON.SUBMIT'
,p_message_language=>'es'
,p_message_text=>'Ejecutar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99804464795304369)
,p_name=>'APEXAPP.BUTTON.SUBMIT_FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Enviar Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99804064783304369)
,p_name=>'APEXAPP.BUTTON.VIEW_DETAILS'
,p_message_language=>'es'
,p_message_text=>'Ver Detalles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99797272858304364)
,p_name=>'APEXAPP.CHART.LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99816475626304378)
,p_name=>'APEXAPP.CHART.SERIES'
,p_message_language=>'es'
,p_message_text=>'Series %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99808854131304372)
,p_name=>'APEXAPP.COLUMN.ACL_ROLES'
,p_message_language=>'es'
,p_message_text=>'Roles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99797062435304364)
,p_name=>'APEXAPP.COLUMN.ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Acciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99807862425304371)
,p_name=>'APEXAPP.COLUMN.ACTIVITY_BY_HOUR'
,p_message_language=>'es'
,p_message_text=>'Actividad por Hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99807147238304371)
,p_name=>'APEXAPP.COLUMN.APPLICATION_SESSIONS'
,p_message_language=>'es'
,p_message_text=>'Sesiones de Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99796925152304363)
,p_name=>'APEXAPP.COLUMN.ATTACHMENT'
,p_message_language=>'es'
,p_message_text=>'Adjunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99796145534304363)
,p_name=>'APEXAPP.COLUMN.AUTOMATION'
,p_message_language=>'es'
,p_message_text=>unistr('Automatizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99806706597304371)
,p_name=>'APEXAPP.COLUMN.AVG_ELAPSED'
,p_message_language=>'es'
,p_message_text=>'Tiempo Medio Transcurrido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99806140747304370)
,p_name=>'APEXAPP.COLUMN.COMPONENT_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99807720252304371)
,p_name=>'APEXAPP.COLUMN.CONTEXT'
,p_message_language=>'es'
,p_message_text=>'Contexto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99805043129304369)
,p_name=>'APEXAPP.COLUMN.CURRENT_STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99804790266304369)
,p_name=>'APEXAPP.COLUMN.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99807010575304371)
,p_name=>'APEXAPP.COLUMN.DISTINCT_USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios Distintos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99795921001304363)
,p_name=>'APEXAPP.COLUMN.EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99805844206304370)
,p_name=>'APEXAPP.COLUMN.ELAPSED'
,p_message_language=>'es'
,p_message_text=>'Tiempo transcurrido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99808793835304372)
,p_name=>'APEXAPP.COLUMN.ENDED'
,p_message_language=>'es'
,p_message_text=>'Terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99806446339304370)
,p_name=>'APEXAPP.COLUMN.ERROR'
,p_message_language=>'es'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99796097821304363)
,p_name=>'APEXAPP.COLUMN.ERRORS'
,p_message_language=>'es'
,p_message_text=>'Errores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99808674331304372)
,p_name=>'APEXAPP.COLUMN.ERROR_ROWS'
,p_message_language=>'es'
,p_message_text=>'Filas con errores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99804538452304369)
,p_name=>'APEXAPP.COLUMN.FEATURE'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99796612649304363)
,p_name=>'APEXAPP.COLUMN.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99796462077304363)
,p_name=>'APEXAPP.COLUMN.FILED'
,p_message_language=>'es'
,p_message_text=>'Archivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99809002273304372)
,p_name=>'APEXAPP.COLUMN.FILED_BY'
,p_message_language=>'es'
,p_message_text=>'Archivado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99807504749304371)
,p_name=>'APEXAPP.COLUMN.FULL_PAGE_VIEWS'
,p_message_language=>'es'
,p_message_text=>unistr('Vistas de p\00E1ginas completas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99806345435304370)
,p_name=>'APEXAPP.COLUMN.IR_SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsqueda de IR')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99805124552304369)
,p_name=>'APEXAPP.COLUMN.LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99805413560304370)
,p_name=>'APEXAPP.COLUMN.LAST_ACTIVITY'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima Actividad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99806655066304371)
,p_name=>'APEXAPP.COLUMN.MAX_ELAPSED'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo transcurrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99806868098304371)
,p_name=>'APEXAPP.COLUMN.MEDIAN_ELAPSED'
,p_message_language=>'es'
,p_message_text=>'Mediana Transcurrida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99808289222304372)
,p_name=>'APEXAPP.COLUMN.MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Mensaje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99808336400304372)
,p_name=>'APEXAPP.COLUMN.MESSAGE_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Mensaje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99806504231304370)
,p_name=>'APEXAPP.COLUMN.MIN_ELAPSED'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo transcurrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99808185427304372)
,p_name=>'APEXAPP.COLUMN.MOST_RECENT'
,p_message_language=>'es'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99806235122304370)
,p_name=>'APEXAPP.COLUMN.NUM_ROWS'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Filas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99807629576304371)
,p_name=>'APEXAPP.COLUMN.OCCURRENCE'
,p_message_language=>'es'
,p_message_text=>'Incidencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99805918836304370)
,p_name=>'APEXAPP.COLUMN.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99807925957304372)
,p_name=>'APEXAPP.COLUMN.PAGE_EVENTS'
,p_message_language=>'es'
,p_message_text=>unistr('Eventos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99806061467304370)
,p_name=>'APEXAPP.COLUMN.PAGE_MODE'
,p_message_language=>'es'
,p_message_text=>'Modo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99805510921304370)
,p_name=>'APEXAPP.COLUMN.PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99807276238304371)
,p_name=>'APEXAPP.COLUMN.PAGE_VIEWS'
,p_message_language=>'es'
,p_message_text=>unistr('Vistas de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99807411520304371)
,p_name=>'APEXAPP.COLUMN.PARTIAL_PAGE_VIEWS'
,p_message_language=>'es'
,p_message_text=>unistr('Vistas de p\00E1ginas parciales')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99808458267304372)
,p_name=>'APEXAPP.COLUMN.PK_VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor de Clave Primaria '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99796585276304363)
,p_name=>'APEXAPP.COLUMN.RATING'
,p_message_language=>'es'
,p_message_text=>unistr('Calificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99808991422304372)
,p_name=>'APEXAPP.COLUMN.REASON'
,p_message_language=>'es'
,p_message_text=>'Motivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99796756968304363)
,p_name=>'APEXAPP.COLUMN.RESPONSE'
,p_message_language=>'es'
,p_message_text=>'Respuesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99808001854304372)
,p_name=>'APEXAPP.COLUMN.ROWS_FETCHED'
,p_message_language=>'es'
,p_message_text=>'Filas Recuperadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99796329554304363)
,p_name=>'APEXAPP.COLUMN.SCHEDULED'
,p_message_language=>'es'
,p_message_text=>'Programado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99796286227304363)
,p_name=>'APEXAPP.COLUMN.STARTED'
,p_message_language=>'es'
,p_message_text=>'Iniciado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99804619319304369)
,p_name=>'APEXAPP.COLUMN.STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99808523097304372)
,p_name=>'APEXAPP.COLUMN.SUCCESSFUL_ROWS'
,p_message_language=>'es'
,p_message_text=>'Filas correctas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99805766159304370)
,p_name=>'APEXAPP.COLUMN.TIMESTAMP'
,p_message_language=>'es'
,p_message_text=>'Registro de hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99807300429304371)
,p_name=>'APEXAPP.COLUMN.TOTAL_ROWS'
,p_message_language=>'es'
,p_message_text=>'Total de Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99804985092304369)
,p_name=>'APEXAPP.COLUMN.UPDATED_BY'
,p_message_language=>'es'
,p_message_text=>'Actualizado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99804822447304369)
,p_name=>'APEXAPP.COLUMN.UPDATED_ON'
,p_message_language=>'es'
,p_message_text=>'Actualizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99805681267304370)
,p_name=>'APEXAPP.COLUMN.USER'
,p_message_language=>'es'
,p_message_text=>'Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99805302617304370)
,p_name=>'APEXAPP.COLUMN.USERNAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99796835605304363)
,p_name=>'APEXAPP.COLUMN.USER_AGENT'
,p_message_language=>'es'
,p_message_text=>'Agente de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99805279514304370)
,p_name=>'APEXAPP.COLUMN.VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99806992399304371)
,p_name=>'APEXAPP.COLUMN.WEIGHTED_PERFORMANCE'
,p_message_language=>'es'
,p_message_text=>'Rendimiento Ponderado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99789523899304358)
,p_name=>'APEXAPP.DA.AFTER_CLOSE_DIALOG'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadro de Di\00E1logo Cerrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99802444218304368)
,p_name=>'APEXAPP.DA.CANCEL_BUTTON.DIALOG_CANCEL'
,p_message_language=>'es'
,p_message_text=>unistr('Cancelar Cuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99802981847304368)
,p_name=>'APEXAPP.DA.CHANGE_FILTERS'
,p_message_language=>'es'
,p_message_text=>'Cambiar filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99802577526304368)
,p_name=>'APEXAPP.DA.CREATE_BUTTON.DIALOG_CLOSED'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Bot\00F3n: Cuadro de Di\00E1logo Cerrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99802677729304368)
,p_name=>'APEXAPP.DA.EDIT_REPORT.DIALOG_CLOSED'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Informe: Cuadro de Di\00E1logo Cerrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99802796261304368)
,p_name=>'APEXAPP.DA.PERFORM_SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('Realizar B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99802844458304368)
,p_name=>'APEXAPP.DA.REFRESH_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe de Refrescamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99792006384304360)
,p_name=>'APEXAPP.DATA_LOAD.CHAR_SET_ITEM_HELP'
,p_message_language=>'es'
,p_message_text=>'Juego de Caracteres de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99791604932304360)
,p_name=>'APEXAPP.ITEM.ACL_ROLES'
,p_message_language=>'es'
,p_message_text=>'Roles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99815230411304377)
,p_name=>'APEXAPP.ITEM.ACL_ROLES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cuando el control de acceso est\00E1 activado, los administradores pueden restringir el acceso a determinadas funciones de la aplicaci\00F3n para los usuarios autenticados. Esta aplicaci\00F3n soporta los tres roles siguientes: Lector, Contribuyente y Adminis')
||'trador.</p>',
'<ul>',
unistr('  <li>Los <strong>lectores</strong> tienen acceso de solo lectura a toda la informaci\00F3n y tambi\00E9n pueden ver informes.</li>'),
unistr('  <li>Los <strong>contribuyentes</strong> pueden crear, editar y suprimir informaci\00F3n y ver informes.</li>'),
unistr('  <li>Los <strong>administradores</strong>, adem\00E1s de la capacidad de los contribuyentes, pueden realizar la configuraci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99815002328304377)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Cualquier usuario autenticado puede acceder a esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99815101633304377)
,p_name=>'APEXAPP.ITEM.ANY_USER_HAS_ACCESS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione <strong>No</strong> si se definen todos los usuarios en la lista de control de acceso. Seleccione <strong>S\00ED</strong> si los usuarios autenticados que no est\00E9n en la lista de control de acceso pueden tambi\00E9n utilizar esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99813311917304375)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT'
,p_message_language=>'es'
,p_message_text=>unistr('Formatos de Fecha/N\00FAmero que Usar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99813494807304375)
,p_name=>'APEXAPP.ITEM.APP_DATE_FORMAT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Elija si desea proporcionar m\00E1scaras de formato personalizadas o est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99815891713304377)
,p_name=>'APEXAPP.ITEM.ATTACHMENT'
,p_message_language=>'es'
,p_message_text=>'Adjunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99814815883304376)
,p_name=>'APEXAPP.ITEM.AUTOMATION'
,p_message_language=>'es'
,p_message_text=>unistr('Automatizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99813589233304376)
,p_name=>'APEXAPP.ITEM.CHAR_SET'
,p_message_language=>'es'
,p_message_text=>'Juego de Caracteres de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99812383158304375)
,p_name=>'APEXAPP.ITEM.COPY_PASTE'
,p_message_language=>'es'
,p_message_text=>'Copiar y Pegar Datos Delimitados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99813627729304376)
,p_name=>'APEXAPP.ITEM.CURRENCY'
,p_message_language=>'es'
,p_message_text=>unistr('S\00EDmbolo de Divisa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99813778940304376)
,p_name=>'APEXAPP.ITEM.CURRENCY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Si los datos contienen un s\00EDmbolo de moneda internacional, introd\00FAzcalo aqu\00ED. Por ejemplo, si los datos tienen "1.234,56 &euro;" o "1.234,56 &yen;", introduzca "&euro;" o "&yen;". De lo contrario, los datos no se cargar\00E1n correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99812064704304374)
,p_name=>'APEXAPP.ITEM.DATA_LOAD_IMPORT_FROM'
,p_message_language=>'es'
,p_message_text=>'Importar de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99814025795304376)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Car\00E1cter Decimal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99814172432304376)
,p_name=>'APEXAPP.ITEM.DECIMAL_CHARACTER_HELP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El car\00E1cter decimal separa la parte entera de la decimal de un n\00FAmero.</p>'),
unistr('<p> Cualquier car\00E1cter puede ser el car\00E1cter decimal. El car\00E1cter especificado debe ser de un solo byte y ser diferente del separador de grupo. Puede ser un espacio pero no puede ser un car\00E1cter num\00E9rico ni los siguientes caracteres:</p>'),
'<ul class="noIndent">',
unistr('<li>m\00E1s (+)</li>'),
'<li>menos (-)</li> ',
'<li>menor que (<)</li>',
'<li>mayor que (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99791280455304359)
,p_name=>'APEXAPP.ITEM.DISPLAY'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99815904224304377)
,p_name=>'APEXAPP.ITEM.ENABLE_ATTACHEMENTS'
,p_message_language=>'es'
,p_message_text=>'Activar anexos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99812672185304375)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY'
,p_message_language=>'es'
,p_message_text=>'Delimitado Opcionalmente por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99791519579304360)
,p_name=>'APEXAPP.ITEM.ENCLOSED_BY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca un car\00E1cter delimitador. Puede utilizar este car\00E1cter para definir el l\00EDmite inicial y final de un valor de datos. Si especifica un car\00E1cter delimitador, Taller de Datos ignora el espacio en blanco existente antes del l\00EDmite inicial y fina')
||unistr('l de un valor de datos. Tambi\00E9n puede utilizar esta opci\00F3n para delimitar un valor de datos con el car\00E1cter delimitador especificado.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99815791770304377)
,p_name=>'APEXAPP.ITEM.EXPERIENCE'
,p_message_language=>'es'
,p_message_text=>'Experiencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99813006372304375)
,p_name=>'APEXAPP.ITEM.FAILED_COUNT'
,p_message_language=>'es'
,p_message_text=>'Fila(s) con Fallos:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99791744555304360)
,p_name=>'APEXAPP.ITEM.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99816096532304377)
,p_name=>'APEXAPP.ITEM.FILED'
,p_message_language=>'es'
,p_message_text=>'Archivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99812102890304375)
,p_name=>'APEXAPP.ITEM.FILE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99812203746304375)
,p_name=>'APEXAPP.ITEM.FILE_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Nombre del archivo que desea cargar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99812701130304375)
,p_name=>'APEXAPP.ITEM.FIRST_ROW.HELP'
,p_message_language=>'es'
,p_message_text=>'Active esta casilla si los datos contienen nombres de columna en la primera fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99813851550304376)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR'
,p_message_language=>'es'
,p_message_text=>'Separador de Grupos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99813959830304376)
,p_name=>'APEXAPP.ITEM.GROUP_SEPARATOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un separador de grupos es un car\00E1cter que separa los grupos de enteros, por ejemplo, para mostrar los miles y millones.</p>'),
unistr('<p>Cualquier car\00E1cter puede ser el separador de grupos. El car\00E1cter especificado debe ser de un solo byte y ser diferente del car\00E1cter decimal. Puede ser un espacio pero no puede ser un car\00E1cter num\00E9rico ni los siguientes caracteres:</p>'),
'<ul class="noIndent">',
unistr('<li>m\00E1s (+)</li>'),
'<li>menos (-)</li> ',
'<li>menor que (<)</li>',
'<li>mayor que (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99812867412304375)
,p_name=>'APEXAPP.ITEM.INSERTED_COUNT'
,p_message_language=>'es'
,p_message_text=>'Fila(s) Insertada(s):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99791850483304360)
,p_name=>'APEXAPP.ITEM.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99791463043304360)
,p_name=>'APEXAPP.ITEM.PASSWORD'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99816191634304377)
,p_name=>'APEXAPP.ITEM.RATING'
,p_message_language=>'es'
,p_message_text=>unistr('Calificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99811844160304374)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME'
,p_message_language=>'es'
,p_message_text=>'Recordar nombre de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99811982577304374)
,p_name=>'APEXAPP.ITEM.REMEMBER_USERNAME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si selecciona esta casilla de verificaci\00F3n, la aplicaci\00F3n guardar\00E1 su nombre de usuario en una cookie persistente del navegador denominada "LOGIN_USERNAME_COOKIE".'),
unistr('La pr\00F3xima vez que acceda a la p\00E1gina de conexi\00F3n,'),
unistr('el campo de nombre de usuario se rellenar\00E1 autom\00E1ticamente con este valor.'),
'</p>',
'<p>',
unistr('Si anula la selecci\00F3n de esta casilla de verificaci\00F3n y su nombre de usuario ya se ha guardado en la cookie,'),
unistr('la aplicaci\00F3n lo sobrescribir\00E1 con un valor vac\00EDo.'),
unistr('Tambi\00E9n puede utilizar las herramientas de desarrollador de su explorador para eliminar la cookie por completo.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99816229646304377)
,p_name=>'APEXAPP.ITEM.RESPONSE'
,p_message_language=>'es'
,p_message_text=>'Respuesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99813109515304375)
,p_name=>'APEXAPP.ITEM.REVIEW_COUNT'
,p_message_language=>'es'
,p_message_text=>'Filas para Revisar:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99791045615304359)
,p_name=>'APEXAPP.ITEM.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99791191906304359)
,p_name=>'APEXAPP.ITEM.SEARCH.PLACEHOLDER'
,p_message_language=>'es'
,p_message_text=>'Buscar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99812450416304375)
,p_name=>'APEXAPP.ITEM.SEPARATOR'
,p_message_language=>'es'
,p_message_text=>'Separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99812528758304375)
,p_name=>'APEXAPP.ITEM.SEPARATOR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Identifique un car\00E1cter separador de columnas. Utilice <code>\005Ct</code> como separador de tabulador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99813215059304375)
,p_name=>'APEXAPP.ITEM.SHOW_ADVANCED_SETTINGS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra la configuraci\00F3n avanzada para la carga de datos: S\00EDmbolo de Moneda, Caracteres Decimales, Codificaci\00F3n de Archivo o Formatos de Fecha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99814985565304377)
,p_name=>'APEXAPP.ITEM.STARTED'
,p_message_language=>'es'
,p_message_text=>'Iniciado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99791941538304360)
,p_name=>'APEXAPP.ITEM.STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99814574699304376)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE'
,p_message_language=>'es'
,p_message_text=>'Preferencia de tema de usuario final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99814649585304376)
,p_name=>'APEXAPP.ITEM.THEME_PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>'Si se activa, los usuarios finales pueden seleccionar su propio estilo con el enlace Personalizar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99814309499304376)
,p_name=>'APEXAPP.ITEM.THEME_STYLE'
,p_message_language=>'es'
,p_message_text=>'Estilo de tema de escritorio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99814414392304376)
,p_name=>'APEXAPP.ITEM.THEME_STYLE.HELP'
,p_message_language=>'es'
,p_message_text=>'El estilo de tema por defecto se aplica a todos los usuarios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99814254885304376)
,p_name=>'APEXAPP.ITEM.TIMEFRAME'
,p_message_language=>'es'
,p_message_text=>'Marco temporal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99812946036304375)
,p_name=>'APEXAPP.ITEM.UPDATED_COUNT'
,p_message_language=>'es'
,p_message_text=>'Fila(s) Actualizada(s):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99791390760304359)
,p_name=>'APEXAPP.ITEM.USERNAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99815384901304377)
,p_name=>'APEXAPP.ITEM.USERNAMES'
,p_message_language=>'es'
,p_message_text=>'Nombres de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99815563798304377)
,p_name=>'APEXAPP.ITEM.USERNAMES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca los nombres de usuario separados por comas, puntos y comas o espacios en blanco. Los nombres de usuario duplicados o existentes se ignorar\00E1n autom\00E1ticamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99815457674304377)
,p_name=>'APEXAPP.ITEM.USERNAMES.PLACEHOLDER'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca aqu\00ED el nombre de usuario')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99815602921304377)
,p_name=>'APEXAPP.ITEM.USERNAME_FORMAT'
,p_message_language=>'es'
,p_message_text=>'Formato de nombre de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99816322160304378)
,p_name=>'APEXAPP.ITEM.USER_AGENT'
,p_message_language=>'es'
,p_message_text=>'Agente de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99814729397304376)
,p_name=>'APEXAPP.ITEM.VIEW_AS'
,p_message_language=>'es'
,p_message_text=>'Ver como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99794056602304361)
,p_name=>'APEXAPP.LIST.ACCESS_CONTROL'
,p_message_language=>'es'
,p_message_text=>'Control de Acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99793926093304361)
,p_name=>'APEXAPP.LIST.ACTIVITY_REPORTS'
,p_message_language=>'es'
,p_message_text=>'Informes de Actividades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99818647051304379)
,p_name=>'APEXAPP.LIST.APP_ADMINISTRATION'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n de Aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99793894160304361)
,p_name=>'APEXAPP.LIST.APP_CONFIGURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99794236264304362)
,p_name=>'APEXAPP.LIST.EMAIL_REPORTING'
,p_message_language=>'es'
,p_message_text=>unistr('Informes de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99794168903304361)
,p_name=>'APEXAPP.LIST.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99818505972304379)
,p_name=>'APEXAPP.LIST.HOME_NAVIGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99794367679304362)
,p_name=>'APEXAPP.LIST.JOB_REPORTING'
,p_message_language=>'es'
,p_message_text=>'Informes de trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99818409547304379)
,p_name=>'APEXAPP.LIST.NAVIGATION_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99818765211304379)
,p_name=>'APEXAPP.LIST.NAVIGATION_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99793743263304361)
,p_name=>'APEXAPP.LIST.USER_INTERFACE'
,p_message_language=>'es'
,p_message_text=>'Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99818893377304379)
,p_name=>'APEXAPP.LIST_ENTRY.APP_ADMIN.DESC'
,p_message_language=>'es'
,p_message_text=>'Gestionar componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99794548089304362)
,p_name=>'APEXAPP.LIST_ENTRY.HOME'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99794619651304362)
,p_name=>'APEXAPP.LIST_ENTRY.LOGOUT'
,p_message_language=>'es'
,p_message_text=>'Desconectar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99794422151304362)
,p_name=>'APEXAPP.LIST_ENTRY.STEP'
,p_message_language=>'es'
,p_message_text=>'Paso %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99816601483304378)
,p_name=>'APEXAPP.LOV.RPT_MAX_ROW'
,p_message_language=>'es'
,p_message_text=>unistr('Fila de Informe por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99818142563304379)
,p_name=>'APEXAPP.LOV_ENTRY.ACKNOWLEDGED'
,p_message_language=>'es'
,p_message_text=>'Confirmado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99817571855304378)
,p_name=>'APEXAPP.LOV_ENTRY.CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina de gr\00E1ficos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99818367401304379)
,p_name=>'APEXAPP.LOV_ENTRY.CLOSED'
,p_message_language=>'es'
,p_message_text=>'Cerrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99816849192304378)
,p_name=>'APEXAPP.LOV_ENTRY.COPY_PASTE'
,p_message_language=>'es'
,p_message_text=>'Copiar y Pegar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99817124702304378)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Usar M\00E1scaras de Formato Est\00E1ndar de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99817297450304378)
,p_name=>'APEXAPP.LOV_ENTRY.DATE_FORMAT_CUSTOM'
,p_message_language=>'es'
,p_message_text=>'Proporcionar Formatos Personalizados para Columnas Cargadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99817627344304378)
,p_name=>'APEXAPP.LOV_ENTRY.EMAIL_ADDRESSES'
,p_message_language=>'es'
,p_message_text=>unistr('Direcciones de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99817349854304378)
,p_name=>'APEXAPP.LOV_ENTRY.END_USER_THEME_SELECTION'
,p_message_language=>'es'
,p_message_text=>'Permitir a los usuarios finales seleccionar el estilo de tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99816959548304378)
,p_name=>'APEXAPP.LOV_ENTRY.FIRST_ROW'
,p_message_language=>'es'
,p_message_text=>'La Primera Fila Tiene Nombres de Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99817939784304379)
,p_name=>'APEXAPP.LOV_ENTRY.NEGATIVE'
,p_message_language=>'es'
,p_message_text=>'Negativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99817827661304379)
,p_name=>'APEXAPP.LOV_ENTRY.NEUTRAL'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99818052219304379)
,p_name=>'APEXAPP.LOV_ENTRY.NO_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99818235604304379)
,p_name=>'APEXAPP.LOV_ENTRY.OPEN'
,p_message_language=>'es'
,p_message_text=>'Abrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99817729117304379)
,p_name=>'APEXAPP.LOV_ENTRY.POSITIVE'
,p_message_language=>'es'
,p_message_text=>'Positiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99817415856304378)
,p_name=>'APEXAPP.LOV_ENTRY.REPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina de informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99817085201304378)
,p_name=>'APEXAPP.LOV_ENTRY.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Usar Configuraci\00F3n Avanzada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99816768359304378)
,p_name=>'APEXAPP.LOV_ENTRY.UPLOAD_FILE'
,p_message_language=>'es'
,p_message_text=>'Cargar Archivo, Separado por Comas (*.csv) o Delimitado por Tabuladores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99820764176304381)
,p_name=>'APEXAPP.PAGE.ACTIVITY_DASHBOARD'
,p_message_language=>'es'
,p_message_text=>'Panel de Control de Actividad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99795232119304362)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS'
,p_message_language=>'es'
,p_message_text=>'Agregar varios usuarios: paso %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99795497633304362)
,p_name=>'APEXAPP.PAGE.ADD_MULTIPLE_USERS.TITLE'
,p_message_language=>'es'
,p_message_text=>'Agregar varios usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99820380321304380)
,p_name=>'APEXAPP.PAGE.ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99820455579304380)
,p_name=>'APEXAPP.PAGE.ADMIN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La p\00E1gina de administraci\00F3n permite a los propietarios de aplicaciones (administradores) configurar la aplicaci\00F3n y conservar los datos comunes que se utilizan en toda la aplicaci\00F3n.'),
unistr('Al seleccionar uno de los valores disponibles, los administradores pueden cambiar potencialmente la forma en que se muestra la aplicaci\00F3n y/o las funciones que pueden utilizar los usuarios finales.</p>'),
unistr('<p>El acceso a esta p\00E1gina debe estar restringido solo a los administradores.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99820993214304381)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG'
,p_message_language=>'es'
,p_message_text=>'Log de automatizaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99821007936304381)
,p_name=>'APEXAPP.PAGE.AUTOMATIONS_LOG.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina proporciona un informe interactivo del log de automatizaciones.</p>'),
unistr('<p>Revise la informaci\00F3n registrada sobre las ejecuciones de automatizaci\00F3n anteriores. El log contiene registros de hora de inicio y finalizaci\00F3n, as\00ED como detalles sobre las filas procesadas (de forma correcta y con errores). Aumente el detalle en ')
||unistr('Mensajes para ver mensajes espec\00EDficos de las filas procesadas.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99820650009304381)
,p_name=>'APEXAPP.PAGE.CONFIGURATION_SETTINGS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los valores de configuraci\00F3n permiten hacer que una funcionalidad espec\00EDfica est\00E9 disponible (activada) o no disponible (desactivada) para los usuarios finales.</p>'),
unistr('<p>Si una funci\00F3n concreta no est\00E1 100% lista o se tiene que eliminar temporalmente, haga clic en <strong>Desactivado</strong>.'),
'Para que vuelva a estar disponible, solo tiene que hacer clic en <strong>Activado</strong>.</p>',
unistr('<p><em><strong>Nota:</strong> Los usuarios finales que est\00E9n ejecutando actualmente la aplicaci\00F3n no ver\00E1n reflejados los cambios que se realicen aqu\00ED. La configuraci\00F3n de funciones revisada se mostrar\00E1 una vez que el usuario se haya desconectado y s')
||'e vuelva a conectar.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99822083642304382)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL'
,p_message_language=>'es'
,p_message_text=>'Configurar Control de Acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99822106046304382)
,p_name=>'APEXAPP.PAGE.CONFIG_ACCESS_CONTROL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la opci\00F3n adecuada para cualquier usuario autenticado.<br>'),
unistr('Al seleccionar <strong>No</strong>, la aplicaci\00F3n pasa a ser m\00E1s segura, ya que solo podr\00E1n acceder a ella los usuarios especificados.'),
unistr('Sin embargo, si la aplicaci\00F3n tiene una comunidad de usuarios grande, mantener a tal cantidad de usuarios puede ser una tarea laboriosa y tal vez prefiera seleccionar <strong>S\00ED</strong> y solo implicar a los administradores de la aplicaci\00F3n y puede ')
||'que a los contribuyentes.<br>',
unistr('Si selecciona <strong>S\00ED</strong>, tambi\00E9n debe seleccionar c\00F3mo se considera a los usuarios no incluidos en la lista de usuarios.</p>'),
unistr('<p>Seleccione entre exigir las direcciones de correo electr\00F3nico y cualquier valor alfanum\00E9rico para los nombres de usuario.<br>'),
unistr('Por lo general, debe definir este valor en <strong>Direcci\00F3n de correo electr\00F3nico</strong> si la aplicaci\00F3n utiliza (o se configurar\00E1 para utilizar) un esquema de autenticaci\00F3n centralizado como Oracle Access Manager o SSO.</p>'),
unistr('<p><em><strong>Nota:</strong> Esta aplicaci\00F3n soporta los tres niveles siguientes de acceso: Lector, Contribuyente y Administrador.'),
'<ul>',
unistr('  <li>Los <strong>lectores</strong> tienen acceso de solo lectura a toda la informaci\00F3n y tambi\00E9n pueden ver informes.</li>'),
unistr('  <li>Los <strong>contribuyentes</strong> pueden crear, editar y suprimir informaci\00F3n y ver informes.</li>'),
unistr('  <li>Los <strong>administradores</strong>, adem\00E1s de la capacidad Contribuyentes, tambi\00E9n pueden realizar la configuraci\00F3n de la aplicaci\00F3n mediante el acceso a la secci\00F3n Administraci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99821551977304381)
,p_name=>'APEXAPP.PAGE.ERROR_LOG'
,p_message_language=>'es'
,p_message_text=>unistr('Log de errores de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99821635907304381)
,p_name=>'APEXAPP.PAGE.ERROR_LOG.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En esta p\00E1gina se proporciona un informe interactivo de todos los errores inesperados que haya registrado esta aplicaci\00F3n.</p>'),
unistr('<p>Haga clic en las cabeceras de columna para ordenar y filtrar los datos, o bien haga clic en el bot\00F3n <strong>Acciones</strong> para personalizar la visualizaci\00F3n de columnas y otras muchas funciones avanzadas. Haga clic en el bot\00F3n <strong>Restabl')
||unistr('ecer</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99822386130304382)
,p_name=>'APEXAPP.PAGE.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99822494211304382)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de los comentarios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99822587628304382)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SETTINGS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p><strong>Activar anexos</strong>: si se define esta opci\00F3n, los usuarios podr\00E1n cargar anexos complementarios a sus comentarios.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99795362619304362)
,p_name=>'APEXAPP.PAGE.FEEDBACK_SUBMITTED'
,p_message_language=>'es'
,p_message_text=>'Comentarios enviados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99795027257304362)
,p_name=>'APEXAPP.PAGE.GLOBAL'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99794795721304362)
,p_name=>'APEXAPP.PAGE.HOME'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99819479398304380)
,p_name=>'APEXAPP.PAGE.HOME.HELP.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Haga clic en el icono de comentarios ( <span class="fa fa-comment-o" aria-hidden="true"></span> ) de la barra de navegaci\00F3n, en cualquier p\00E1gina de la aplicaci\00F3n, para dejar un comentario para los administradores de la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99819273994304380)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIDE_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Esta es la p\00E1gina inicial de la aplicaci\00F3n. Haga clic en las tarjetas para acceder a distintas p\00E1ginas de la aplicaci\00F3n o utilice el men\00FA de navegaci\00F3n del lateral de la p\00E1gina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99819807959304380)
,p_name=>'APEXAPP.PAGE.HOME.HELP.SIGNOUT'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Haga clic en la lista desplegable de nombres de la barra de navegaci\00F3n para cerrar sesi\00F3n de la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99819797303304380)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TIMEZONE'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Haga clic en el men\00FA de usuario ( <span class="fa fa-user" aria-hidden="true"></span> ) de la barra de navegaci\00F3n para actualizar su preferencia de zona horaria y cerrar sesi\00F3n de la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99819136310304380)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99819327643304380)
,p_name=>'APEXAPP.PAGE.HOME.HELP.TOP_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Esta es la p\00E1gina inicial de la aplicaci\00F3n. Haga clic en las tarjetas para acceder a distintas p\00E1ginas de la aplicaci\00F3n o utilice el men\00FA de navegaci\00F3n de la parte superior de la p\00E1gina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99819686421304380)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Haga clic en el men\00FA de usuario ( <span class="fa fa-user" aria-hidden="true"></span> ) de la barra de navegaci\00F3n (parte superior derecha de la p\00E1gina) para acceder a su perfil de usuario y cerrar sesi\00F3n de la aplicaci\00F3n.<br>'),
unistr('Si hace clic en <strong>Ver mi perfil</strong>, podr\00E1 a continuaci\00F3n hacer clic en <strong>Actualizar perfil</strong> para introducir sus datos personales y cargar una fotograf\00EDa o un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99819510899304380)
,p_name=>'APEXAPP.PAGE.HOME.HELP.USER_TIMEZONE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Haga clic en el men\00FA de usuario ( <span class="fa fa-user" aria-hidden="true"></span> ) de la barra de navegaci\00F3n para acceder a su perfil de usuario, actualizar su preferencia de zona horaria y cerrar sesi\00F3n de la aplicaci\00F3n.<br>'),
unistr('Si hace clic en <strong>Ver mi perfil</strong>, podr\00E1 a continuaci\00F3n hacer clic en <strong>Actualizar perfil</strong> para introducir sus datos personales y cargar una fotograf\00EDa o un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99820038977304380)
,p_name=>'APEXAPP.PAGE.IG.HELP.EDITABLE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Puede insertar, actualizar y suprimir los datos directamente en esta cuadr\00EDcula interactiva.<br>'),
unistr('  Inserte una fila nueva haciendo clic en el bot\00F3n Agregar fila.<br>'),
unistr('  Haga doble clic en una celda o haga clic en el bot\00F3n <strong>Editar</strong> para actualizar los valores de datos, lo que equivale a editar los datos en una hoja de c\00E1lculo.</p>'),
'',
unistr('<p>Utilice el men\00FA Acciones de fila ( <span class="fa fa-bars" aria-hidden="true"></span> ) en la parte superior del informe para duplicar, suprimir, refrescar o revertir las filas seleccionadas.<br>'),
unistr('  Utilice el men\00FA Acciones de fila en las distintas filas para acceder tambi\00E9n a la vista de una fila o agregar una nueva fila.</p>'),
'',
unistr('<p>Para buscar los datos, introduzca un t\00E9rmino de b\00FAsqueda en el cuadro de di\00E1logo de b\00FAsqueda o haga clic en las cabeceras de columna para limitar los registros devueltos.</p>'),
'',
unistr('<p>Puede realizar varias funciones haciendo clic en el bot\00F3n <strong>Acciones</strong>, entre las que se incluyen el seleccionar las columnas que se muestran u ocultan y su secuencia de visualizaci\00F3n, adem\00E1s de numeras funciones de datos y formato. T')
||unistr('ambi\00E9n puede definir m\00E1s vistas de los datos con la opci\00F3n de gr\00E1fico.</p>'),
'',
'<p>Si desea guardar las personalizaciones, seleccione el informe o haga clic en Descargar para descargar los datos.<p>',
'',
unistr('<p>Para obtener m\00E1s informaci\00F3n, haga clic en Ayuda en la parte inferior del men\00FA Acciones.</p>'),
'',
unistr('<p>Haga clic en el bot\00F3n <strong>Restablecer</strong> para restablecer la configuraci\00F3n por defecto de la cuadr\00EDcula interactiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99820181021304380)
,p_name=>'APEXAPP.PAGE.IG.HELP.READONLY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para buscar los datos, introduzca un t\00E9rmino de b\00FAsqueda en el cuadro de di\00E1logo de b\00FAsqueda o haga clic en las cabeceras de columna para limitar los registros devueltos.</p>'),
'',
unistr('<p>Puede realizar varias funciones haciendo clic en el bot\00F3n <strong>Acciones</strong>, entre las que se incluyen el seleccionar las columnas que se muestran u ocultan y su secuencia de visualizaci\00F3n, adem\00E1s de numeras funciones de datos y formato. T')
||unistr('ambi\00E9n puede definir m\00E1s vistas de los datos con la opci\00F3n de gr\00E1fico.</p>'),
'',
'<p>Si desea guardar las personalizaciones, seleccione el informe o haga clic en Descargar para descargar los datos.<p>',
'<br>',
unistr('<p>Para obtener m\00E1s informaci\00F3n, haga clic en Ayuda en la parte inferior del men\00FA Acciones.</p>'),
'',
unistr('<p>Haga clic en el bot\00F3n <strong>Restablecer</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99819970681304380)
,p_name=>'APEXAPP.PAGE.IR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para buscar los datos, introduzca un t\00E9rmino de b\00FAsqueda en el cuadro de di\00E1logo de b\00FAsqueda o haga clic en las cabeceras de columna para limitar los registros devueltos.</p>'),
'',
unistr('<p>Puede realizar varias funciones haciendo clic en el bot\00F3n <strong>Acciones</strong>, entre las que se incluyen el seleccionar las columnas que se muestran u ocultan y su secuencia de visualizaci\00F3n, adem\00E1s de numerosas funciones de datos y formato.')
||unistr(' Tambi\00E9n puede definir m\00E1s vistas de los datos con las opciones de gr\00E1fico, agrupaci\00F3n por y giro.</p>'),
'',
unistr('<p>Si desea guardar las personalizaciones, seleccione el informe o haga clic en Descargar para descargar los datos. Introduzca la direcci\00F3n de correo electr\00F3nico y el marco temporal de la suscripci\00F3n para el env\00EDo de los datos de forma regular.<p>'),
'',
unistr('<p>Para obtener m\00E1s informaci\00F3n, haga clic en Ayuda en la parte inferior del men\00FA Acciones.</p>'),
'',
unistr('<p>Haga clic en el bot\00F3n <strong>Restablecer</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99794877389304362)
,p_name=>'APEXAPP.PAGE.LOGIN'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99794960837304362)
,p_name=>'APEXAPP.PAGE.LOGIN.TITLE'
,p_message_language=>'es'
,p_message_text=>'%0: Conectar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99821703818304381)
,p_name=>'APEXAPP.PAGE.LOG_MESSAGES'
,p_message_language=>'es'
,p_message_text=>'Mensajes de Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99822607257304382)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Gestionar Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99822776949304382)
,p_name=>'APEXAPP.PAGE.MANAGE_FEEDBACK.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los usuarios finales pueden introducir comentarios en cualquier p\00E1gina normal de la aplicaci\00F3n.</p>'),
'<p>En este informe se muestran los comentarios introducidos, las respuestas que hayan introducido los administradores y el estado de los comentarios.</p>',
unistr('<p>Haga clic en el icono de edici\00F3n (l\00E1piz de color amarillo) para introducir una respuesta o actualizar el estado de los comentarios.</p>'),
unistr('<p><em><strong>Nota:</strong> Si se han definido los destinatarios de los comentarios, tambi\00E9n se mandar\00E1n por correo electr\00F3nico los env\00EDos de comentarios a las direcciones de correo electr\00F3nico de la lista de destinatarios de comentarios.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99821833845304381)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS'
,p_message_language=>'es'
,p_message_text=>'Gestionar acceso de usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99821953772304382)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En esta p\00E1gina se muestra un informe de los usuarios de la aplicaci\00F3n y el nivel de acceso otorgado.</p>'),
unistr('<p>Haga clic en las cabeceras de columna para ordenar y filtrar los datos, o bien haga clic en el bot\00F3n <strong>Acciones</strong> para personalizar la visualizaci\00F3n de columnas y otras muchas funciones avanzadas.<br>'),
unistr('Haga clic en el bot\00F3n <strong>Restablecer</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>'),
unistr('<p>Haga clic en el icono de edici\00F3n (l\00E1piz de color amarillo) para editar los detalles y el nivel de acceso del usuario, o bien para suprimir el usuario.</p>'),
'<p>Haga clic en <strong>Agregar usuario</strong>, en la parte superior del informe, para agregar un nuevo usuario y su nivel de acceso.</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99822298036304382)
,p_name=>'APEXAPP.PAGE.MANAGE_USER_ACCESS_FORM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice esta pantalla para introducir usuarios, sus direcciones de correo electr\00F3nico y definir sus niveles de acceso.'),
unistr('La configuraci\00F3n definida en <em>Configurar control de acceso</em> determinar\00E1 si el nombre de usuario debe ser su direcci\00F3n de correo electr\00F3nico o puede ser cualquier entrada alfanum\00E9rica.</p>'),
unistr('<p>Esta aplicaci\00F3n soporta los tres niveles de acceso siguientes: Lector, Contribuyente y Administrador.</p>'),
'<ul>',
unistr('  <li>Los <strong>lectores</strong> tienen acceso de solo lectura a toda la informaci\00F3n y tambi\00E9n pueden ver informes.</li>'),
unistr('  <li>Los <strong>contribuyentes</strong> pueden crear, editar y suprimir informaci\00F3n y ver informes.</li>'),
unistr('  <li>Los <strong>administradores</strong>, adem\00E1s de la capacidad Contribuyentes, tambi\00E9n pueden realizar la configuraci\00F3n de la aplicaci\00F3n mediante al acceso a la secci\00F3n Administraci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>',
unistr('<p>Al editar un usuario existente, puede bloquear su cuenta, lo que evitar\00E1 que accedan a la aplicaci\00F3n.</p>'),
unistr('<p><em><strong>Nota:</strong> Si utiliza cuentas de Oracle Application Express, el administrador del espacio de trabajo tambi\00E9n debe definir a los usuarios introducidos aqu\00ED como usuarios finales, cuyas contrase\00F1as tambi\00E9n puede definir.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99820275590304380)
,p_name=>'APEXAPP.PAGE.MD.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina de informe muestra los registros principales en un selector en un lateral de la p\00E1gina. '),
'  Seleccione un registro para ver el registro maestro y cualquier registro de detalle definido.<br> ',
unistr('  Haga clic en el icono de edici\00F3n ( <span class="fa fa-pencil-square-o" aria-hidden="true"></span> ) para editar el registro maestro.'),
unistr('  Para los registros detallados, haga clic en el l\00E1piz, al principio de cada fila, para editar ese registro.</p>'),
unistr('<p>Para limitar los datos mostrados en el selector, introduzca un t\00E9rmino de b\00FAsqueda en el cuadro de di\00E1logo de b\00FAsqueda.</p>'),
'',
unistr('<p>Para agregar nuevos registros maestros, haga clic en <strong>Crear</strong> al principio de la p\00E1gina.'),
unistr('  Para los registros detallados, haga clic en el icono de signo m\00E1s ( + ) en la parte superior de la regi\00F3n de detalle para agregar un registro detallado.</p>'),
'',
unistr('<p>Haga clic en <strong>Restablecer</strong> en la parte superior de la p\00E1gina para restablecer la p\00E1gina a la configuraci\00F3n por defecto, eliminando cualquier t\00E9rmino de b\00FAsqueda definido previamente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99821363963304381)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE'
,p_message_language=>'es'
,p_message_text=>unistr('Rendimiento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99821421855304381)
,p_name=>'APEXAPP.PAGE.PAGE_PERFORMANCE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En esta p\00E1gina se proporciona un informe interactivo del rendimiento y la popularidad de la p\00E1gina. El informe se ordena por <strong>Rendimiento ponderado</strong>, que se calcula multiplicando el tiempo de mediana transcurrido y el n\00FAmero de vist')
||unistr('as de p\00E1gina.</p>'),
unistr('<p>Seleccione el marco temporal del informe (valor por defecto = 1 d\00EDa) en la parte superior de la p\00E1gina seg\00FAn sea necesario.<br>'),
unistr('Haga clic en las cabeceras de columna para ordenar y filtrar los datos, o bien haga clic en el bot\00F3n <strong>Acciones</strong> para personalizar la visualizaci\00F3n de columnas y otras muchas funciones avanzadas. Haga clic en el bot\00F3n <strong>Restablece')
||unistr('r</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99821109884304381)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS'
,p_message_language=>'es'
,p_message_text=>unistr('Vistas de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99821268660304381)
,p_name=>'APEXAPP.PAGE.PAGE_VIEWS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En esta p\00E1gina se proporciona un informe interactivo de las vistas de p\00E1gina m\00E1s recientes.</p>'),
unistr('<p>Seleccione el marco temporal del informe (valor por defecto = 1 d\00EDa) en la parte superior de la p\00E1gina seg\00FAn sea necesario.<br>'),
unistr('Haga clic en las cabeceras de columna para ordenar y filtrar los datos, o bien haga clic en el bot\00F3n <strong>Acciones</strong> para personalizar la visualizaci\00F3n de columnas y otras muchas funciones avanzadas. Haga clic en el bot\00F3n <strong>Restablece')
||unistr('r</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99820546112304381)
,p_name=>'APEXAPP.PAGE.THEME_SELECTOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el esquema de color por defecto que se utiliza para mostrar la aplicaci\00F3n.</p>'),
unistr('<p>Si la opci\00F3n <strong>Permitir a los usuarios finales seleccionar el estilo de tema</strong> est\00E1 activada, los usuarios finales podr\00E1n seleccionar uno de los estilos de tema disponibles haciendo clic en el enlace <em>Personalizar</em> de la esquin')
||unistr('a inferior izquierda de la p\00E1gina inicial.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99795137981304362)
,p_name=>'APEXAPP.PAGE.TOP_USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99820823707304381)
,p_name=>'APEXAPP.PAGE.TOP_USERS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este informe y gr\00E1fico para ver qui\00E9nes son los usuarios con m\00E1s vistas de p\00E1gina durante el marco temporal especificado.</p>'),
unistr('<p>Seleccione el marco temporal del informe (Valor por defecto = 1 d\00EDa) y seleccione entre los iconos de informe y gr\00E1fico en la parte superior de la p\00E1gina.</p>'),
unistr('<p>Para el informe interactivo, utilice el campo de b\00FAsqueda o seleccione la cabecera de columna <strong>Usuario</strong> para seleccionar un usuario espec\00EDfico. Puede realizar muchas funciones con el bot\00F3n <strong>Acciones</strong>, como mostrar u o')
||unistr('cultar columnas, especificar las filas por p\00E1gina, filtrar, etc. Haga clic en el bot\00F3n <strong>Restablecer</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99811290796304374)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL'
,p_message_language=>'es'
,p_message_text=>'Agregar usuarios a la lista de control de acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99811303012304374)
,p_name=>'APEXAPP.PROCESS.ADD_USERS_TO_ACL.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Usuarios agregados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99809558265304373)
,p_name=>'APEXAPP.PROCESS.CLEAR_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Borrar Cach\00E9 de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99793118084304361)
,p_name=>'APEXAPP.PROCESS.CLOSE_DIALOG'
,p_message_language=>'es'
,p_message_text=>unistr('Cerrar Recuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99811121093304374)
,p_name=>'APEXAPP.PROCESS.CREATE_COLLECTIONS'
,p_message_language=>'es'
,p_message_text=>'Crear recopilaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99793442596304361)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Suprimir Comentario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99793566468304361)
,p_name=>'APEXAPP.PROCESS.DELETE_FEEDBACK.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Se han suprimido los comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99811058479304374)
,p_name=>'APEXAPP.PROCESS.DML_FORM'
,p_message_language=>'es'
,p_message_text=>'Procesar pantalla %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99811737971304374)
,p_name=>'APEXAPP.PROCESS.GET_FILE_ID'
,p_message_language=>'es'
,p_message_text=>'Obtener ID de archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99810792200304373)
,p_name=>'APEXAPP.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'es'
,p_message_text=>'Obtener detalle de log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99810057618304373)
,p_name=>'APEXAPP.PROCESS.GET_NEXT_PREV_PK'
,p_message_language=>'es'
,p_message_text=>'Obtener Valor de Clave Primaria Anterior o Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99809411124304373)
,p_name=>'APEXAPP.PROCESS.GET_USERNAME_COOKIE'
,p_message_language=>'es'
,p_message_text=>'Obtener Cookie de Nombre de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99809124244304372)
,p_name=>'APEXAPP.PROCESS.IG_DML'
,p_message_language=>'es'
,p_message_text=>unistr('%0: Guardar Datos de Cuadr\00EDcula Interactiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99810910117304374)
,p_name=>'APEXAPP.PROCESS.INIT_FORM'
,p_message_language=>'es'
,p_message_text=>'Inicializar pantalla %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99809968962304373)
,p_name=>'APEXAPP.PROCESS.LEGACY_FORM_DML.SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99793225477304361)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA'
,p_message_language=>'es'
,p_message_text=>'Cargar Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99810170162304373)
,p_name=>'APEXAPP.PROCESS.LOAD_DATA.ERROR'
,p_message_language=>'es'
,p_message_text=>'Fallo de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99793343579304361)
,p_name=>'APEXAPP.PROCESS.REPLY_TO_FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Responder a los comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99792934526304361)
,p_name=>'APEXAPP.PROCESS.RESET_PAGINATION'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer Paginaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99809270824304372)
,p_name=>'APEXAPP.PROCESS.RESET_RPT_SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer B\00FAsqueda de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99793092932304361)
,p_name=>'APEXAPP.PROCESS.SET_ACL'
,p_message_language=>'es'
,p_message_text=>'Definir control de acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99810805870304374)
,p_name=>'APEXAPP.PROCESS.SET_ACL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La configuraci\00F3n de control de acceso se ha guardado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99810583125304373)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS'
,p_message_language=>'es'
,p_message_text=>'Actualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99810665318304373)
,p_name=>'APEXAPP.PROCESS.SET_CONFIG_OPTIONS.SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Las opciones de configuraci\00F3n se han actualizado. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99811642368304374)
,p_name=>'APEXAPP.PROCESS.SET_FEEDBACK_OPTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Guardar configuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99809334488304373)
,p_name=>'APEXAPP.PROCESS.SET_USERNAME_COOKIE'
,p_message_language=>'es'
,p_message_text=>'Definir Cookie de Nombre de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99811425684304374)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Enviar Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99811503020304374)
,p_name=>'APEXAPP.PROCESS.SUBMIT_FEEDBACK.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Comentarios enviados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99809621365304373)
,p_name=>'APEXAPP.PROCESS.TABFORM_DELETE.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'#MRD_COUNT# fila(s) suprimida(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99809701086304373)
,p_name=>'APEXAPP.PROCESS.TABFORM_PLSQL.SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Actualizaci\00F3n aplicada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99809886634304373)
,p_name=>'APEXAPP.PROCESS.TABFORM_UPDATE_INSERT.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'#MRU_COUNT# fila(s) actualizada(s), #MRI_COUNT# fila(s) insertada(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99810494324304373)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE'
,p_message_language=>'es'
,p_message_text=>'Guardar preferencia de estilo de usuario final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99793636621304361)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_PREF_SAVE.SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha guardado la configuraci\00F3n de aspecto de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99810263225304373)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE'
,p_message_language=>'es'
,p_message_text=>'Guardar estilo de tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99810383273304373)
,p_name=>'APEXAPP.PROCESS.THEME_STYLE_SAVE.SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha guardado la configuraci\00F3n de aspecto de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99799960686304366)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL'
,p_message_language=>'es'
,p_message_text=>'Control de Acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99799817544304366)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Acciones de control de acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99801659116304367)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_CONFIG'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de control de acceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99800086185304366)
,p_name=>'APEXAPP.REGION.ACCESS_CONTROL_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n de ACL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99799613524304365)
,p_name=>'APEXAPP.REGION.ACTIVITY_REPORTS'
,p_message_language=>'es'
,p_message_text=>'Informes de Actividades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99790644064304359)
,p_name=>'APEXAPP.REGION.ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n de Aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99799493834304365)
,p_name=>'APEXAPP.REGION.APP_CONFIGURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99801428982304367)
,p_name=>'APEXAPP.REGION.AUTOMATION_EXECUTION'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecuci\00F3n de automatizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99789741904304358)
,p_name=>'APEXAPP.REGION.BREADCRUMB'
,p_message_language=>'es'
,p_message_text=>unistr('Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99798511565304365)
,p_name=>'APEXAPP.REGION.BUTTONS'
,p_message_language=>'es'
,p_message_text=>'Botones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99790538728304359)
,p_name=>'APEXAPP.REGION.COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99799361638304365)
,p_name=>'APEXAPP.REGION.CONFIGURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99799764397304365)
,p_name=>'APEXAPP.REGION.CONFIG_APPEARANCE'
,p_message_language=>'es'
,p_message_text=>'Configurar apariencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99790035417304359)
,p_name=>'APEXAPP.REGION.DASHBOARD_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99798924925304365)
,p_name=>'APEXAPP.REGION.DATA_LOAD_FAILED_RECORDS'
,p_message_language=>'es'
,p_message_text=>'Registros con Fallos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99799094720304365)
,p_name=>'APEXAPP.REGION.DATA_LOAD_JUST_CHANGED_RECORDS'
,p_message_language=>'es'
,p_message_text=>'Registros Cargados por Otro Usuario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99798810742304365)
,p_name=>'APEXAPP.REGION.DATA_LOAD_PROGRESS'
,p_message_language=>'es'
,p_message_text=>'Progreso de Asistente de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99790388917304359)
,p_name=>'APEXAPP.REGION.DEFAULT.MAX_ROWS'
,p_message_language=>'es'
,p_message_text=>unistr('El recuento m\00E1ximo de filas de este informe es %0 filas. Aplique un filtro para reducir el n\00FAmero de registros de la consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99790249926304359)
,p_name=>'APEXAPP.REGION.DEFAULT.NO_DATA'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn dato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99800469619304366)
,p_name=>'APEXAPP.REGION.EMAIL_REPORTING'
,p_message_language=>'es'
,p_message_text=>unistr('Informes de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99801859789304367)
,p_name=>'APEXAPP.REGION.EXCEPTIONS'
,p_message_language=>'es'
,p_message_text=>'Excepciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99800185430304366)
,p_name=>'APEXAPP.REGION.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99790992886304359)
,p_name=>'APEXAPP.REGION.FEEDBACK_SUBMITTED'
,p_message_language=>'es'
,p_message_text=>'Comentarios enviados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99801116270304367)
,p_name=>'APEXAPP.REGION.FILTERS'
,p_message_language=>'es'
,p_message_text=>'Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99802335058304367)
,p_name=>'APEXAPP.REGION.FORM_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n de elementos de pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99790171636304359)
,p_name=>'APEXAPP.REGION.FORM_ON'
,p_message_language=>'es'
,p_message_text=>'Pantalla Basada en %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99802225316304367)
,p_name=>'APEXAPP.REGION.HIDDEN_ITEMS'
,p_message_language=>'es'
,p_message_text=>'Elementos Ocultos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99800657323304366)
,p_name=>'APEXAPP.REGION.HOURLY_PAGE_EVENTS'
,p_message_language=>'es'
,p_message_text=>unistr('Eventos de p\00E1gina por hora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99798724831304365)
,p_name=>'APEXAPP.REGION.INFORMATION'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99800519394304366)
,p_name=>'APEXAPP.REGION.JOB_REPORTING'
,p_message_language=>'es'
,p_message_text=>'Informes de trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99800216373304366)
,p_name=>'APEXAPP.REGION.LANGUAGE_SELECTOR'
,p_message_language=>'es'
,p_message_text=>'Selector de Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99800946589304366)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY'
,p_message_language=>'es'
,p_message_text=>unistr('Actividad m\00E1s reciente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99801021949304366)
,p_name=>'APEXAPP.REGION.LATEST_ACTIVITY.NO_DATA'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna actividad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99799100079304365)
,p_name=>'APEXAPP.REGION.MASTER_RECORDS'
,p_message_language=>'es'
,p_message_text=>'Registros maestros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99801563659304367)
,p_name=>'APEXAPP.REGION.MESSAGES'
,p_message_language=>'es'
,p_message_text=>'Mensajes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99800794379304366)
,p_name=>'APEXAPP.REGION.MOST_ACTIVE_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas con Mayor Actividad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99790493028304359)
,p_name=>'APEXAPP.REGION.NAVIGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99789977085304358)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha seleccionado ning\00FAn registro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99799220989304365)
,p_name=>'APEXAPP.REGION.NO_RECORD_SELECTED.NO_DATA'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha seleccionado ning\00FAn registro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99802084140304367)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('No existen usuarios v\00E1lidos - Informaci\00F3n de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99802135038304367)
,p_name=>'APEXAPP.REGION.NO_VALID_USERS_EXIST.SOURCE'
,p_message_language=>'es'
,p_message_text=>unistr('No se han encontrado usuarios nuevos no v\00E1lidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99800816003304366)
,p_name=>'APEXAPP.REGION.RECENT_ERRORS'
,p_message_language=>'es'
,p_message_text=>'Errores Recientes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99789806215304358)
,p_name=>'APEXAPP.REGION.REGION_DISPLAY_SELECTOR'
,p_message_language=>'es'
,p_message_text=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99790701416304359)
,p_name=>'APEXAPP.REGION.REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99789625052304358)
,p_name=>'APEXAPP.REGION.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99801265590304367)
,p_name=>'APEXAPP.REGION.TOP_USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99801373503304367)
,p_name=>'APEXAPP.REGION.TOP_USERS_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico de usuarios principales')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99790828149304359)
,p_name=>'APEXAPP.REGION.USERS_TO_ADD'
,p_message_language=>'es'
,p_message_text=>'%0 usuarios que agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99800376812304366)
,p_name=>'APEXAPP.REGION.USER_COUNTS_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe de recuentos de usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99799592904304365)
,p_name=>'APEXAPP.REGION.USER_INTERFACE'
,p_message_language=>'es'
,p_message_text=>'Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99801952896304367)
,p_name=>'APEXAPP.REGION.VALID_USERS_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('Existen usuarios v\00E1lidos - Informaci\00F3n de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99801720071304367)
,p_name=>'APEXAPP.REGION.WIZARD_CONTAINER'
,p_message_language=>'es'
,p_message_text=>'Contenedor de asistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99798640500304365)
,p_name=>'APEXAPP.REGION.WIZARD_PROGRESS'
,p_message_language=>'es'
,p_message_text=>'Progreso del Asistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99819059202304379)
,p_name=>'APEXAPP.RELEASE'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99816544917304378)
,p_name=>'APEXAPP.SHORTCUT.GET_NEXT_PREV_PK'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFSeguro que desea salir de esta p\00E1gina sin guardar?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99797172883304364)
,p_name=>'APEXAPP.SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'es'
,p_message_text=>'%0 fila(s) actualizada(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99798340323304364)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Se necesita al menos un comentario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99798428582304365)
,p_name=>'APEXAPP.VALIDATION.AT_LEAST_ONE_REQUIRED.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Env\00EDe comentarios sobre su experiencia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99798128347304364)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede suprimir a s\00ED mismo como administrador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99798218262304364)
,p_name=>'APEXAPP.VALIDATION.CANNOT_REMOVE_YOURSELF_FROM_ADMIN.ERROR'
,p_message_language=>'es'
,p_message_text=>'No puede eliminar su propio rol de administrador.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99797688363304364)
,p_name=>'APEXAPP.VALIDATION.COLUMN.DATE.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('#COLUMN_HEADER# debe ser una fecha v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99797409509304364)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NOT_NULL.ERROR'
,p_message_language=>'es'
,p_message_text=>'#COLUMN_HEADER# debe tener un valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99797503925304364)
,p_name=>'APEXAPP.VALIDATION.COLUMN.NUMERIC.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('#COLUMN_HEADER# debe ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99797723371304364)
,p_name=>'APEXAPP.VALIDATION.COLUMN.TIMESTAMP.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('#COLUMN_HEADER# debe ser un valor de registro de hora v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99795766978304363)
,p_name=>'APEXAPP.VALIDATION.DATE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 debe ser una fecha v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99797906569304364)
,p_name=>'APEXAPP.VALIDATION.ITEM.DATE.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser una fecha v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99797880544304364)
,p_name=>'APEXAPP.VALIDATION.ITEM.NOT_NULL.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe tener alg\00FAn valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99798015731304364)
,p_name=>'APEXAPP.VALIDATION.ITEM.TIMESTAMP.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser un registro de hora v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99795560835304362)
,p_name=>'APEXAPP.VALIDATION.NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'%0 no nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99795659046304363)
,p_name=>'APEXAPP.VALIDATION.NUMERIC'
,p_message_language=>'es'
,p_message_text=>unistr('%0 debe ser num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99795834651304363)
,p_name=>'APEXAPP.VALIDATION.TIMESTAMP'
,p_message_language=>'es'
,p_message_text=>unistr('%0 debe ser un registro de hora v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100713002477305103)
,p_name=>'APEXDEV.IG.COLUMN_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('La columna Cuadr\00EDcula Interactiva ''%0'' especificada para la acci\00F3n din\00E1mica ''#COMPONENT_NAME#'' no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100713239667305103)
,p_name=>'APEXDEV.IG.DML.COMPLEX_VIEW_LOCK'
,p_message_language=>'es'
,p_message_text=>'El proceso ''%0'' ha emitido ''%1'' al realizar el bloqueo de fila. Este error puede producirse cuando el proceso emite una sentencia SELECT FOR UPDATE en una vista compleja con un disparador instead-of para bloquear la fila. Defina el atributo del proce'
||unistr('so ''Lock Row'' en No o C\00F3digo PL/SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100713159849305103)
,p_name=>'APEXDEV.IG.DML.VIRTUAL_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('El proceso ''%0'' ha emitido ''%1'' al ejecutar un comando DML. Este error se puede producir si una columna est\00E1 basada en una agregaci\00F3n o expresi\00F3n SQL. Defina el atributo de columna ''Solo Consulta'' en S\00ED para excluir la columna de la sentencia INSERT ')
||'y UPDATE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100334850757304817)
,p_name=>'APEXDEV.IG.MASTER_DETAIL_COLUMN_NOT_POPULATED'
,p_message_language=>'es'
,p_message_text=>unistr('La columna maestra/de detalles ''%0'' no contiene ning\00FAn valor. Aseg\00FArese de que se ejecuta el proceso ''%1'' despu\00E9s del proceso correspondiente de la regi\00F3n maestra.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100695367956305090)
,p_name=>'APEXDEV.IG.NO_MASTER_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('La cuadr\00EDcula interactiva ''%0'' no tiene definida ninguna columna maestra, lo cual es necesario para la relaci\00F3n maestro/detalle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100109780248304609)
,p_name=>'APEXDEV.IG.NO_PK'
,p_message_language=>'es'
,p_message_text=>unistr('La cuadr\00EDcula interactiva ''%0'' no tiene definida una columna de clave primaria, lo cual es necesario para realizar ediciones o para la relaci\00F3n maestro/detalle.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100672785718305069)
,p_name=>'APEXDEV.IG.RELOAD_ON_SUBMIT_EDITABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Para una cuadr\00EDcula interactiva editable, el atributo de p\00E1gina ''Recargar al Enviar'' se debe definir en ''Solo para Correcto''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100643754176305047)
,p_name=>'APEXDEV.PE.CODE_EDITOR'
,p_message_language=>'es'
,p_message_text=>unistr('Editor de C\00F3digos: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100643871504305047)
,p_name=>'APEXDEV.PE.COLLAPSE'
,p_message_language=>'es'
,p_message_text=>'Reducir %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100643902301305047)
,p_name=>'APEXDEV.PE.COLOR_PICKER'
,p_message_language=>'es'
,p_message_text=>'Selector de Color: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100644082333305047)
,p_name=>'APEXDEV.PE.EDIT_COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Editar Componente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100644111940305047)
,p_name=>'APEXDEV.PE.ERROR_POSTFIX'
,p_message_language=>'es'
,p_message_text=>' (Error)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100644259769305048)
,p_name=>'APEXDEV.PE.EXPAND'
,p_message_language=>'es'
,p_message_text=>'Ampliar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100643640882305047)
,p_name=>'APEXDEV.PE.FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtro'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100644324531305048)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn resultado.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100644475260305048)
,p_name=>'APEXDEV.PE.FILTER_NO_MATCH_COMMON'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn resultado. Pruebe a buscar todas las propiedades haciendo clic en el bot\00F3n "Mostrar todo" anterior.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100644510694305048)
,p_name=>'APEXDEV.PE.FILTER_PROPERTIES'
,p_message_language=>'es'
,p_message_text=>'Propiedades de Filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100644686507305048)
,p_name=>'APEXDEV.PE.INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('%0 (No v\00E1lido)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100644702462305048)
,p_name=>'APEXDEV.PE.LIST_OF_VALUES'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100644856074305048)
,p_name=>'APEXDEV.PE.NO'
,p_message_language=>'es'
,p_message_text=>'No'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100644924090305048)
,p_name=>'APEXDEV.PE.NO_COMMON_PROPERTIES'
,p_message_language=>'es'
,p_message_text=>unistr('Los componentes seleccionados no tienen propiedades en com\00FAn.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100646142337305049)
,p_name=>'APEXDEV.PE.NO_COMPONENTS_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('Actualmente no se ha seleccionado ning\00FAn componente')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100645016163305048)
,p_name=>'APEXDEV.PE.PICK'
,p_message_language=>'es'
,p_message_text=>'Seleccionar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100645112657305048)
,p_name=>'APEXDEV.PE.PIN_FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtro de pin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100645219039305048)
,p_name=>'APEXDEV.PE.QUICK_PICK'
,p_message_language=>'es'
,p_message_text=>'Listas de valores: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100645301866305048)
,p_name=>'APEXDEV.PE.QUICK_PICK.CLEAR'
,p_message_language=>'es'
,p_message_text=>unistr('Borrar Selecci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100645443366305048)
,p_name=>'APEXDEV.PE.REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Necesario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100645519531305048)
,p_name=>'APEXDEV.PE.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100645600017305049)
,p_name=>'APEXDEV.PE.SELECT'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100645750146305049)
,p_name=>'APEXDEV.PE.VALUE_VARIES_POSTFIX'
,p_message_language=>'es'
,p_message_text=>unistr(' (El valor var\00EDa)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100645851104305049)
,p_name=>'APEXDEV.PE.WARNING'
,p_message_language=>'es'
,p_message_text=>'Advertencia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100645918278305049)
,p_name=>'APEXDEV.PE.WARNING_POSTFIX'
,p_message_language=>'es'
,p_message_text=>' (Advertencia)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100646061065305049)
,p_name=>'APEXDEV.PE.YES'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100672817437305070)
,p_name=>'APEXDEV.TABFORM.RELOAD_ON_SUBMIT'
,p_message_language=>'es'
,p_message_text=>unistr('Para un formato tabular, el atributo de p\00E1gina ''Recargar al Enviar'' se debe definir en ''Siempre''.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100452459898304905)
,p_name=>'APEXIG_MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar el ID est\00E1tico de regi\00F3n, ya que la p\00E1gina contiene varias cuadr\00EDculas interactivas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99677680813304276)
,p_name=>'APEXIR_3D'
,p_message_language=>'es'
,p_message_text=>'3D'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99788189318304357)
,p_name=>'APEXIR_ADD'
,p_message_language=>'es'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100270306180304769)
,p_name=>'APEXIR_ADD_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar Suscripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99927185482304469)
,p_name=>'APEXIR_AGGREGATE_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Las agregaciones se muestran detr\00E1s de cada divisi\00F3n de control y al final del informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99843087292304401)
,p_name=>'APEXIR_AGG_COUNT_DISTINCT'
,p_message_language=>'es'
,p_message_text=>'Recuento de los Valores Distintos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99788537940304357)
,p_name=>'APEXIR_AGG_MODE'
,p_message_language=>'es'
,p_message_text=>'Modo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100670546840305068)
,p_name=>'APEXIR_AREA'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100268125055304768)
,p_name=>'APEXIR_BLACK'
,p_message_language=>'es'
,p_message_text=>'Negro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99788834872304358)
,p_name=>'APEXIR_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99894715614304443)
,p_name=>'APEXIR_COLUMN_HEADING'
,p_message_language=>'es'
,p_message_text=>'Cabecera de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100702777585305095)
,p_name=>'APEXIR_DAY'
,p_message_language=>'es'
,p_message_text=>unistr('D\00EDa ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99823049383304382)
,p_name=>'APEXIR_DELETE_CHECKED'
,p_message_language=>'es'
,p_message_text=>unistr('Suprimir Selecci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99927423630304469)
,p_name=>'APEXIR_DELETE_CONFIRM_JS_DIALOG'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFDesea realizar esta acci\00F3n de supresi\00F3n?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99906466581304453)
,p_name=>'APEXIR_DISABLE'
,p_message_language=>'es'
,p_message_text=>'Desactivar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99677844423304276)
,p_name=>'APEXIR_DISPLAY'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99655500177304260)
,p_name=>'APEXIR_DONUT'
,p_message_language=>'es'
,p_message_text=>'Anillo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99527156044304161)
,p_name=>'APEXIR_DOWNLOAD_DATA_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99677775795304276)
,p_name=>'APEXIR_DO_NOT_AGGREGATE'
,p_message_language=>'es'
,p_message_text=>'- No Agregar -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100653720537305055)
,p_name=>'APEXIR_EDIT_ALTERNATIVE_DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Editar Valor por Defecto Alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99906392578304453)
,p_name=>'APEXIR_ENABLE'
,p_message_language=>'es'
,p_message_text=>'Activar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99927245973304469)
,p_name=>'APEXIR_FLASHBACK_ERROR_MSG'
,p_message_language=>'es'
,p_message_text=>'No se ha podido realizar la solicitud de flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100257425610304760)
,p_name=>'APEXIR_FUNCTION_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Funci\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100268288995304768)
,p_name=>'APEXIR_GRAY'
,p_message_language=>'es'
,p_message_text=>'Gris'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99655382581304260)
,p_name=>'APEXIR_HIGHLIGHT_WHEN'
,p_message_language=>'es'
,p_message_text=>'Resaltar Cuando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100203242200304718)
,p_name=>'APEXIR_LABEL_PREFIX'
,p_message_language=>'es'
,p_message_text=>'Prefijo de Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100259215337304761)
,p_name=>'APEXIR_MANAGE_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic <a href=''%0''>aqu\00ED</a> para gestionar la suscripci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99928063626304470)
,p_name=>'APEXIR_MORE_DATA'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99673462879304273)
,p_name=>'APEXIR_NEW_CATEGORY'
,p_message_language=>'es'
,p_message_text=>unistr('- Nueva Categor\00EDa -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99823195698304382)
,p_name=>'APEXIR_NO_AGGREGATION_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna agregaci\00F3n definida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99751238743304330)
,p_name=>'APEXIR_NO_COLUMN_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('No hay informaci\00F3n de columna disponible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99823258046304382)
,p_name=>'APEXIR_NO_COMPUTATION_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn c\00E1lculo definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100702690507305095)
,p_name=>'APEXIR_NO_END_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('- Sin Fecha de Finalizaci\00F3n -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100756384846305135)
,p_name=>'APEXIR_PIVOT_ROW_COLUMN_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione una columna de fila distinta.  La expresi\00F3n o enlace HTML en la columna de fila contiene una columna definida como din\00E1mica o columna de agregado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99788288897304357)
,p_name=>'APEXIR_REMOVE_AGGREGATE'
,p_message_language=>'es'
,p_message_text=>'Eliminar Agregado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100156929986304683)
,p_name=>'APEXIR_REPORT_DISPLAY_COLUMN_LIMIT_REACHED'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero de columnas de visualizaci\00F3n del informe ha alcanzado el l\00EDmite. Haga clic en Seleccionar Columnas en el men\00FA Acciones para minimizar la lista de columnas de visualizaci\00F3n del informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99762468739304338)
,p_name=>'APEXIR_ROW_ORDER'
,p_message_language=>'es'
,p_message_text=>'Orden de Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99526463693304161)
,p_name=>'APEXIR_RPT_DISP_COL_EXCEED'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero de columnas de visualizaci\00F3n del informe ha alcanzado el l\00EDmite. Haga clic en Seleccionar Columnas en el men\00FA Acciones para minimizar la lista de columnas de visualizaci\00F3n del informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99822982054304382)
,p_name=>'APEXIR_SAVE_AS_DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Guardar como Valores por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99655450480304260)
,p_name=>'APEXIR_SELECT_CATEGORY'
,p_message_language=>'es'
,p_message_text=>unistr('- Seleccionar Categor\00EDa -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99928117365304470)
,p_name=>'APEXIR_SELECT_COLUMNS_FOOTER'
,p_message_language=>'es'
,p_message_text=>'Las columnas calculadas tienen el prefijo **.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100702524099305095)
,p_name=>'APEXIR_SELECT_SORT_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('- Seleccionar Columna de Ordenaci\00F3n -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99927942452304469)
,p_name=>'APEXIR_SELECT_VALUE'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100702474038305095)
,p_name=>'APEXIR_SORT_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Ordenaci\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100257374895304759)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING_UNIT'
,p_message_language=>'es'
,p_message_text=>'Unidad Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99927307716304469)
,p_name=>'APEXIR_UNAUTHORIZED'
,p_message_language=>'es'
,p_message_text=>'No Autorizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99904673285304451)
,p_name=>'APEXIR_UNIQUE_COLUMN_HEADING'
,p_message_language=>'es'
,p_message_text=>unistr('La cabecera de columna debe ser \00FAnica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100702834911305096)
,p_name=>'APEXIR_WEEK'
,p_message_language=>'es'
,p_message_text=>'Semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99523730947304159)
,p_name=>'APEX_ADMIN_SERVICES'
,p_message_language=>'es'
,p_message_text=>unistr('Servicios de Administraci\00F3n de Application Express')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100654068468305055)
,p_name=>'APEX_AUTHENTICATION.NOT_CONFIGURED'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ninguna autenticaci\00F3n configurada para esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99966333115304499)
,p_name=>'APEX_SAMPLE_LOAD'
,p_message_language=>'es'
,p_message_text=>'Los siguientes objetos de base de datos se %0 en el esquema seleccionado:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99966485264304499)
,p_name=>'APEX_SAMPLE_LOAD_SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Los siguientes objetos de base de datos se han %0 correctamente:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100341540053304822)
,p_name=>'APEX_SCROLL_DOWN'
,p_message_language=>'es'
,p_message_text=>'Desplazar hacia abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100341605987304822)
,p_name=>'APEX_SCROLL_TO_TOP'
,p_message_language=>'es'
,p_message_text=>'Desplazarse al principio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99529820239304163)
,p_name=>'APEX_WIZARD_FORM'
,p_message_language=>'es'
,p_message_text=>unistr('Pantalla de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100653661629305055)
,p_name=>'APEX_WS_EDIT_ROW'
,p_message_language=>'es'
,p_message_text=>'Editar Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100121428920304618)
,p_name=>'APEX_WS_INVALID_OBJECTS'
,p_message_language=>'es'
,p_message_text=>unistr('Objetos no V\00E1lidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100706890130305098)
,p_name=>'APEX_WS_NO_PEER_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('No hay p\00E1ginas de peers')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100656949382305057)
,p_name=>'APEX_WS_SETUP_CREATE_OBJ'
,p_message_language=>'es'
,p_message_text=>'Objetos para Crear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100657101424305057)
,p_name=>'APEX_WS_SETUP_DELETE_TABLES'
,p_message_language=>'es'
,p_message_text=>'Suprimir de Tablas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100657316618305057)
,p_name=>'APEX_WS_SETUP_DROP_OBJECTS'
,p_message_language=>'es'
,p_message_text=>'Borrar Objetos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100276341125304774)
,p_name=>'APEX_WS_SETUP_DROP_TABLES'
,p_message_language=>'es'
,p_message_text=>'Borrar Tablas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100275649927304773)
,p_name=>'APEX_WS_SETUP_MSG1'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1n estos objetos en el esquema <strong>%0</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100657493408305057)
,p_name=>'APEX_WS_SETUP_MSG10'
,p_message_language=>'es'
,p_message_text=>unistr('Estos objetos ya existen en el esquema <strong>%0</strong> y los utilizan otros espacios de trabajo. Si contin\00FAa, los objetos de hoja de c\00E1lculo web existentes que sean propiedad de <strong>%0</strong> tambi\00E9n se asociar\00E1n a este espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100657552242305058)
,p_name=>'APEX_WS_SETUP_MSG11'
,p_message_language=>'es'
,p_message_text=>'Seleccione el esquema que desea utilizar para estos objetos:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100657659184305058)
,p_name=>'APEX_WS_SETUP_MSG12'
,p_message_language=>'es'
,p_message_text=>'Tablas Existentes para Utilizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100658413374305058)
,p_name=>'APEX_WS_SETUP_MSG13'
,p_message_language=>'es'
,p_message_text=>unistr('Los objetos de base de datos de hojas de c\00E1lculo web se reutilizar\00E1n utilizando la siguiente informaci\00F3n. Confirme la solicitud.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100275795893304773)
,p_name=>'APEX_WS_SETUP_MSG2'
,p_message_language=>'es'
,p_message_text=>unistr('Si prefiere crear los objetos de hoja de c\00E1lculo web en un esquema nuevo, utilice el asistente para <a href=%0>Solicitar Esquema de Base de Datos</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100275862485304773)
,p_name=>'APEX_WS_SETUP_MSG3'
,p_message_language=>'es'
,p_message_text=>unistr('Para ejecutar las hojas de c\00E1lculo web, se necesitan los siguientes objetos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100275995653304773)
,p_name=>'APEX_WS_SETUP_MSG5'
,p_message_language=>'es'
,p_message_text=>unistr('Los objetos de base de datos de hojas de c\00E1lculo web se crear\00E1n utilizando la siguiente informaci\00F3n. Confirme la solicitud.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100276089417304773)
,p_name=>'APEX_WS_SETUP_MSG6'
,p_message_language=>'es'
,p_message_text=>'Tablas para Crear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100276198847304773)
,p_name=>'APEX_WS_SETUP_MSG7'
,p_message_language=>'es'
,p_message_text=>unistr('Va a eliminar los objetos de base de datos de hojas de c\00E1lculo web. Borrar\00E1 los objetos de base de datos de hojas de c\00E1lculo web as\00ED como los datos internos que contienen los componentes de hojas web en su espacio de trabajo. \00BFDesea continuar?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100276438982304774)
,p_name=>'APEX_WS_SETUP_MSG8'
,p_message_language=>'es'
,p_message_text=>unistr('Es necesario corregir los siguientes objetos no v\00E1lidos para ejecutar las hojas web correctamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100657002748305057)
,p_name=>'APEX_WS_SETUP_MSG9'
,p_message_language=>'es'
,p_message_text=>unistr('Va a eliminar las definiciones de hoja de c\00E1lculo web de este espacio de trabajo. Los objetos de base de datos de hoja de c\00E1lculo web los utilizan tambi\00E9n otros espacios de trabajo, por lo que no se borrar\00E1n. Se suprimir\00E1n los registros asociados a e')
||unistr('ste espacio de trabajo. \00BFDesea continuar?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100276523661304774)
,p_name=>'APEX_WS_SETUP_OBJECT_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100276688756304774)
,p_name=>'APEX_WS_SETUP_OBJECT_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100276288216304773)
,p_name=>'APEX_WS_SETUP_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100656828783305057)
,p_name=>'APEX_WS_SETUP_USE_EXISTING_OBJ'
,p_message_language=>'es'
,p_message_text=>'Objetos Existentes para Utilizar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99579105551304204)
,p_name=>'APPLICACTION_COMPUTATIONS'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99579023854304204)
,p_name=>'APPLICACTION_PROCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Procesos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100115233432304613)
,p_name=>'APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100176224664304698)
,p_name=>'APPLICATION BUILDER'
,p_message_language=>'es'
,p_message_text=>'Creador de Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100030904629304548)
,p_name=>'APPLICATION COMPUTATION CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de C\00E1lculo de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100033757050304550)
,p_name=>'APPLICATION IMAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Imagen de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100031025607304548)
,p_name=>'APPLICATION PROCESS CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Proceso de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99962045837304496)
,p_name=>'APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100096579086304598)
,p_name=>'APPLICATIONS_INITCAP'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100005193344304528)
,p_name=>'APPLICATION_ACTIVITY'
,p_message_language=>'es'
,p_message_text=>'Actividad de Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100043153320304557)
,p_name=>'APPLICATION_ALIAS'
,p_message_language=>'es'
,p_message_text=>unistr('Alias de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100041221927304556)
,p_name=>'APPLICATION_DELETED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha suprimido la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99523589006304159)
,p_name=>'APPLICATION_DEVELOPMENT'
,p_message_language=>'es'
,p_message_text=>'Desarrollo de Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100042150389304556)
,p_name=>'APPLICATION_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Identifica la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100001961398304526)
,p_name=>'APPLICATION_ID'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99901861304304449)
,p_name=>'APPLICATION_ID_RESERVED'
,p_message_language=>'es'
,p_message_text=>unistr('El ID de aplicaci\00F3n est\00E1 reservado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99901725644304449)
,p_name=>'APPLICATION_ID_VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('El identificador de aplicaci\00F3n debe ser un n\00FAmero entero y positivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100316517638304804)
,p_name=>'APPLICATION_IMAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Im\00E1genes de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100071291006304579)
,p_name=>'APPLICATION_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99605075929304223)
,p_name=>'APPLICATION_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99573970832304200)
,p_name=>'APPLICATION_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100043014389304557)
,p_name=>'APPLICATION_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100706409838305098)
,p_name=>'APPLICATION_NAMES'
,p_message_language=>'es'
,p_message_text=>unistr('Nombres de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100152958008304680)
,p_name=>'APPLICATION_OVERRIDE_ID'
,p_message_language=>'es'
,p_message_text=>unistr('ID de Sustituci\00F3n de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100040718934304555)
,p_name=>'APPLICATION_OWNER'
,p_message_language=>'es'
,p_message_text=>unistr('Propietario de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100706394179305098)
,p_name=>'APPLICATION_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99680400008304278)
,p_name=>'APPLICATION_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100040961081304555)
,p_name=>'APPLICATION_STATUS'
,p_message_language=>'es'
,p_message_text=>unistr('Estado de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100116815204304614)
,p_name=>'APPLICATION_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99538685725304170)
,p_name=>'APPLICATION_X'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99989558295304517)
,p_name=>'APPROVED'
,p_message_language=>'es'
,p_message_text=>'Aprobado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100047322828304560)
,p_name=>'APP_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n se ha creado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100708954585305100)
,p_name=>'APP_TEMPLATE_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n de Plantilla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99571802928304199)
,p_name=>'APP_TYPE_DATABASE'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n de Base de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99571915758304199)
,p_name=>'APP_TYPE_PACKAGED'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n de ejemplo o de productividad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100068109604304576)
,p_name=>'APP_TYPE_PACKAGED_WS'
,p_message_language=>'es'
,p_message_text=>unistr('Hoja de C\00E1lculo Web de Ejemplo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99571732518304199)
,p_name=>'APP_TYPE_WEBSHEET'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n de Hoja de C\00E1lculo Web')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99989080235304516)
,p_name=>'ARCHIVED'
,p_message_language=>'es'
,p_message_text=>'Archivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99574249805304200)
,p_name=>'ARCHIVELOG'
,p_message_language=>'es'
,p_message_text=>'Archivado de Logs: Activado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99825189551304384)
,p_name=>'ARGUMENTS_MUST_HAVE_CHECKSUM'
,p_message_language=>'es'
,p_message_text=>'Los Argumentos Deben Tener Total de Control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99912725966304458)
,p_name=>'ARGUMENT_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Argumento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99912919215304458)
,p_name=>'ARGUMENT_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Argumento'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99983233097304512)
,p_name=>'ASAP'
,p_message_language=>'es'
,p_message_text=>'Lo antes Posible'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99980542127304510)
,p_name=>'ASSIGNED'
,p_message_language=>'es'
,p_message_text=>'Asignado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99678025578304276)
,p_name=>'ASSIGNEE'
,p_message_language=>'es'
,p_message_text=>'Persona asignada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100728690872305115)
,p_name=>'ASSIGN_LABEL'
,p_message_language=>'es'
,p_message_text=>'Asignar %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99734035110304318)
,p_name=>'ASSOCIATED'
,p_message_language=>'es'
,p_message_text=>'asociado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99679656197304278)
,p_name=>'ASSOCIATED_FEATURES'
,p_message_language=>'es'
,p_message_text=>'Funciones Asociadas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100010345229304532)
,p_name=>'ATTACHMENT'
,p_message_language=>'es'
,p_message_text=>'Adjunto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100736479086305121)
,p_name=>'AT_RISK_LABEL'
,p_message_language=>'es'
,p_message_text=>'En Riesgo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99705515241304297)
,p_name=>'AUTH.CONFIRM_MIGRATE'
,p_message_language=>'es'
,p_message_text=>unistr('Va a migrar las opciones de autenticaci\00F3n personalizadas de esta aplicaci\00F3n a un esquema de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99705007270304296)
,p_name=>'AUTH.CURRENT_AUTH_METHOD'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todo de Autenticaci\00F3n Actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99705465761304297)
,p_name=>'AUTH.CUSTOM_AUTH_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n de Autenticaci\00F3n Personalizada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99705170661304297)
,p_name=>'AUTH.LOGIN_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99705378604304297)
,p_name=>'AUTH.LOGIN_URL'
,p_message_language=>'es'
,p_message_text=>unistr('URL de Conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99705233598304297)
,p_name=>'AUTH.NONE'
,p_message_language=>'es'
,p_message_text=>'ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99710518213304301)
,p_name=>'AUTHENTICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100031912680304549)
,p_name=>'AUTHENTICATION FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100031684817304548)
,p_name=>'AUTHENTICATION SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99725557879304312)
,p_name=>'AUTHENTICATION.CONFIRM_DELETE'
,p_message_language=>'es'
,p_message_text=>unistr('Va a suprimir un esquema de autenticaci\00F3n de la aplicaci\00F3n %0. Si la aplicaci\00F3n no est\00E1 utilizando actualmente la autenticaci\00F3n de esquemas o si el esquema no es el esquema de autenticaci\00F3n actual, su supresi\00F3n no tendr\00E1 efecto en el funcionamiento d')
||unistr('e la aplicaci\00F3n. Si la aplicaci\00F3n est\00E1 utilizando la autenticaci\00F3n de esquemas y es el esquema de autenticaci\00F3n actual, la aplicaci\00F3n continuar\00E1 ejecut\00E1ndose con la autenticaci\00F3n de esquemas, pero con un esquema de autenticaci\00F3n por defecto. Utilizar')
||unistr('\00E1 una p\00E1gina de conexi\00F3n incorporada con la verificaci\00F3n de credenciales de "puertas abiertas" (es decir, todos los usuarios podr\00E1n ejecutar la aplicaci\00F3n). ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99727527006304313)
,p_name=>'AUTHENTICATION.MAKE_CURRENT'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic en el bot\00F3n Actualizar para que la aplicaci\00F3n utilice este esquema de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100203507250304718)
,p_name=>'AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'
,p_message_language=>'es'
,p_message_text=>'Cuentas de Application Express'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99520172835304156)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'es'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100203640708304718)
,p_name=>'AUTHENTICATION_NAME.NATIVE_CUSTOM'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100203973008304718)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DAD'
,p_message_language=>'es'
,p_message_text=>unistr('Sin Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100203792287304718)
,p_name=>'AUTHENTICATION_NAME.NATIVE_DB_ACCOUNTS'
,p_message_language=>'es'
,p_message_text=>'Cuentas de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100465341676304915)
,p_name=>'AUTHENTICATION_NAME.NATIVE_HTTP_HEADER_VARIABLE'
,p_message_language=>'es'
,p_message_text=>'Variable de Cabecera HTTP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100204119165304718)
,p_name=>'AUTHENTICATION_NAME.NATIVE_IAS_SSO'
,p_message_language=>'es'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100203892467304718)
,p_name=>'AUTHENTICATION_NAME.NATIVE_LDAP'
,p_message_language=>'es'
,p_message_text=>'Directorio LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100204060838304718)
,p_name=>'AUTHENTICATION_NAME.NATIVE_OPEN_DOOR'
,p_message_language=>'es'
,p_message_text=>'Credenciales de Puertas Abiertas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99498056108304140)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SAML'
,p_message_language=>'es'
,p_message_text=>unistr('Conexi\00F3n de SAML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99548623193304181)
,p_name=>'AUTHENTICATION_NAME.NATIVE_SOCIAL'
,p_message_language=>'es'
,p_message_text=>unistr('Inicio de sesi\00F3n en medios sociales')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100072244816304579)
,p_name=>'AUTHENTICATION_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100031550479304548)
,p_name=>'AUTHORIZATION SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99520271648304156)
,p_name=>'AUTHORIZATION_NAME.NATIVE_CLOUD_IDM'
,p_message_language=>'es'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99538871407304170)
,p_name=>'AUTHORIZATION_NAME.NATIVE_EXISTS'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL Exists'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99538996652304170)
,p_name=>'AUTHORIZATION_NAME.NATIVE_FUNCTION_BODY'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n PL/SQL que Devuelve Valor Booleano')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99894449996304443)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_IN_GROUP'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1 en rol o en grupo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99894584690304443)
,p_name=>'AUTHORIZATION_NAME.NATIVE_IS_NOT_IN_GROUP'
,p_message_language=>'es'
,p_message_text=>unistr('No est\00E1 en rol ni en grupo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99539060245304170)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_EQUALS_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Elemento en Expresi\00F3n 1 Equivale a Expresi\00F3n 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99539199997304170)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento en Expresi\00F3n 1 No Nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99539292710304170)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_IS_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento en Expresi\00F3n 1 Nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99539322104304170)
,p_name=>'AUTHORIZATION_NAME.NATIVE_ITEM_NOT_EQUALS_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Elemento en Expresi\00F3n 1 No Equivale a Expresi\00F3n 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99539479053304170)
,p_name=>'AUTHORIZATION_NAME.NATIVE_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL NOT Exists'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99539515103304171)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_EQUALS_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Preferencia en Expresi\00F3n 1 Equivale a Expresi\00F3n 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99539664568304171)
,p_name=>'AUTHORIZATION_NAME.NATIVE_PREF_NOT_EQUALS_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Preferencia en Expresi\00F3n 1 No Equivale a Expresi\00F3n 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99590783981304212)
,p_name=>'AUTHZ_CACHE_PER_PAGE_VIEW'
,p_message_language=>'es'
,p_message_text=>unistr('Evaluar para cada vista de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99590847138304213)
,p_name=>'AUTHZ_CACHE_PER_SESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Evaluar una vez por sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99542537803304173)
,p_name=>'AUTH_ACCOUNT_EXPIRED'
,p_message_language=>'es'
,p_message_text=>'Cuenta Vencida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99542429325304173)
,p_name=>'AUTH_ACCOUNT_LOCKED'
,p_message_language=>'es'
,p_message_text=>'Cuenta Bloqueada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99542803949304173)
,p_name=>'AUTH_ATTEMPTS_EXCEEDED'
,p_message_language=>'es'
,p_message_text=>unistr('Se han excedido los intentos de conexi\00F3n m\00E1ximos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99542930624304173)
,p_name=>'AUTH_INTERNAL_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error interno desconocido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99542755302304173)
,p_name=>'AUTH_PASSWORD_FIRST_USE'
,p_message_language=>'es'
,p_message_text=>unistr('Primer Uso de Contrase\00F1a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99542613658304173)
,p_name=>'AUTH_PASSWORD_INCORRECT'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a Incorrecta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99542247806304173)
,p_name=>'AUTH_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Autenticaci\00F3n normal correcta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99542375368304173)
,p_name=>'AUTH_UNKNOWN_USER'
,p_message_language=>'es'
,p_message_text=>'Nombre de Usuario Desconocido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99637194294304246)
,p_name=>'AUTH_UNKNOWN_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Nombre de espacio de trabajo desconocido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99647201271304254)
,p_name=>'AUTH_UNKNOWN_WORKSPACE_COLON'
,p_message_language=>'es'
,p_message_text=>'Nombre de espacio de trabajo desconocido: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99768250742304343)
,p_name=>'AUTOCOMMIT'
,p_message_language=>'es'
,p_message_text=>unistr('La sentencia de confirmaci\00F3n no es aplicable. Todas las sentencias se confirman autom\00E1ticamente.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100466311495304915)
,p_name=>'AUTOMATIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Automatizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100466497724304916)
,p_name=>'AUTOMATION_ACTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n de automatizaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100097113290304599)
,p_name=>'AUTOPROVISION_MODE'
,p_message_language=>'es'
,p_message_text=>'Modo de Provisionamiento'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99517788551304154)
,p_name=>'AUTO_FIRST_ITEM'
,p_message_language=>'es'
,p_message_text=>'Primer Elemento'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100118675007304615)
,p_name=>'AVAILABILITY_INIT_CAP'
,p_message_language=>'es'
,p_message_text=>'Disponibilidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99546929036304179)
,p_name=>'AVAILABLE'
,p_message_language=>'es'
,p_message_text=>'Disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100253589549304757)
,p_name=>'AVAILABLE_TO_DEVELOPERS_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('Disponible S\00F3lo para Desarrolladores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100253439967304756)
,p_name=>'AVAILABLE_WITH_EDIT_LINKS'
,p_message_language=>'es'
,p_message_text=>'Disponible con Barra de Herramientas de Desarrollador'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100005986054304529)
,p_name=>'AVERAGE_RENDER_TIME_SECONDS'
,p_message_language=>'es'
,p_message_text=>unistr('Tiempo Medio de Presentaci\00F3n (segundos)')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99987460231304515)
,p_name=>'BAR_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico de Barras')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100305250466304795)
,p_name=>'BASIC'
,p_message_language=>'es'
,p_message_text=>unistr('B\00E1sico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99560843656304190)
,p_name=>'BASIC_DEVELOPER'
,p_message_language=>'es'
,p_message_text=>unistr('Desarrollador B\00E1sico')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99968840887304501)
,p_name=>'BEFORE'
,p_message_language=>'es'
,p_message_text=>'Antes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100711732118305102)
,p_name=>'BEFORE LIST ENTRY'
,p_message_language=>'es'
,p_message_text=>'Antes de Entrada de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100727702274305114)
,p_name=>'BEFORE_FIRST'
,p_message_language=>'es'
,p_message_text=>'Antes de la Primera'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100034893503304551)
,p_name=>'BIND_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta Ligada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100034275576304550)
,p_name=>'BIND_VARIABLE'
,p_message_language=>'es'
,p_message_text=>'Variable de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100034369540304550)
,p_name=>'BIND_VARIABLE_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de Variable de Enlace'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100048801445304561)
,p_name=>'BLACK_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto Negro'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99524136873304159)
,p_name=>'BLANK'
,p_message_language=>'es'
,p_message_text=>'En Blanco'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100009509533304532)
,p_name=>'BLOB_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100154687625304682)
,p_name=>'BLOB_DOWNLOAD_TEXT'
,p_message_language=>'es'
,p_message_text=>'Descargar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99572880262304199)
,p_name=>'BLOB_FORMAT'
,p_message_language=>'es'
,p_message_text=>'Formato Blob'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100155032825304682)
,p_name=>'BLOB_FORMAT_ATTACHMENT'
,p_message_language=>'es'
,p_message_text=>'Adjunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100154757271304682)
,p_name=>'BLOB_FORMAT_DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>'DOWNLOAD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100154818815304682)
,p_name=>'BLOB_FORMAT_IMAGE'
,p_message_language=>'es'
,p_message_text=>'IMAGE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100154962309304682)
,p_name=>'BLOB_FORMAT_INLINE'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100010518910304532)
,p_name=>'BLOB_FORMAT_MASK'
,p_message_language=>'es'
,p_message_text=>'Formato BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100010030882304532)
,p_name=>'BLOB_LAST_UPDATED_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima Columna BLOB Actualizada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100009410667304532)
,p_name=>'BLOB_TABLE'
,p_message_language=>'es'
,p_message_text=>'Tabla BLOB'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100048704221304561)
,p_name=>'BLUE_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto Azul'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100025901393304544)
,p_name=>'BRANCH CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99594561011304215)
,p_name=>'BRANCHES'
,p_message_language=>'es'
,p_message_text=>'Bifurcaciones'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99789070433304358)
,p_name=>'BREADCRUMB'
,p_message_language=>'es'
,p_message_text=>unistr('Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99969563517304501)
,p_name=>'BREADCRUMB LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99969686524304501)
,p_name=>'BREADCRUMB LONG NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre Completo de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99789182641304358)
,p_name=>'BREADCRUMBS'
,p_message_language=>'es'
,p_message_text=>unistr('Rutas de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100057629771304568)
,p_name=>'BREADCRUMB_ENTRY'
,p_message_language=>'es'
,p_message_text=>unistr('Entrada de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100071410903304579)
,p_name=>'BREADCRUMB_ENTRY_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Entrada de Ruta de Navegaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99902166181304449)
,p_name=>'BREADCRUMB_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99977062180304507)
,p_name=>'BREADCRUMB_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99651159940304257)
,p_name=>'BREADCRUMB_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La ruta de navegaci\00F3n se ha creado correctamente.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99972197819304503)
,p_name=>'BROWSE_ICON'
,p_message_language=>'es'
,p_message_text=>'Icono Examinar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99971963583304503)
,p_name=>'BROWSE_PACKAGE'
,p_message_language=>'es'
,p_message_text=>'Examinar Paquete'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99912524823304458)
,p_name=>'BROWSE_TABLE'
,p_message_language=>'es'
,p_message_text=>'Examinar Tabla'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99503870742304144)
,p_name=>'BU.APPLICATION_ACLS'
,p_message_language=>'es'
,p_message_text=>unistr('ACL de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99500106759304141)
,p_name=>'BU.APPLICATION_COMPUTATIONS'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99548484850304181)
,p_name=>'BU.APPLICATION_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha producido un error al realizar una copia de seguridad de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99500216046304141)
,p_name=>'BU.APPLICATION_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99500465202304141)
,p_name=>'BU.APPLICATION_PROCESSES'
,p_message_language=>'es'
,p_message_text=>unistr('Procesos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99548163313304180)
,p_name=>'BU.APPLICATION_RESTORED'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n %0 se ha restaurado a partir de la revisi\00F3n %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99500098820304141)
,p_name=>'BU.APPLICATION_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100310952859304799)
,p_name=>'BU.APP_PROPS_MODIFIED'
,p_message_language=>'es'
,p_message_text=>unistr('Propiedades de la aplicaci\00F3n: modificadas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100054256194304565)
,p_name=>'BU.AUTHENTICATION_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99501163074304142)
,p_name=>'BU.AUTHENTICATION_SCHEMES'
,p_message_language=>'es'
,p_message_text=>unistr('Esquemas de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99501222081304142)
,p_name=>'BU.AUTHORIZATION_SCHEMES'
,p_message_language=>'es'
,p_message_text=>unistr('Esquemas de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99502845761304143)
,p_name=>'BU.BREADCRUMBS'
,p_message_language=>'es'
,p_message_text=>unistr('Rutas de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99502992408304143)
,p_name=>'BU.BREADCRUMB_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99500359250304141)
,p_name=>'BU.BUILD_OPTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99503182095304143)
,p_name=>'BU.BUTTON_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99503069857304143)
,p_name=>'BU.CALENDAR_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100054050460304565)
,p_name=>'BU.COMPONENTS'
,p_message_language=>'es'
,p_message_text=>'Componentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100465270400304915)
,p_name=>'BU.COMPONENTS_DELETED'
,p_message_language=>'es'
,p_message_text=>'%0 suprimido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100465146979304915)
,p_name=>'BU.COMPONENTS_MODIFIED'
,p_message_language=>'es'
,p_message_text=>'%0 modificado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100465087791304915)
,p_name=>'BU.COMPONENTS_NEW'
,p_message_language=>'es'
,p_message_text=>'%0 nuevo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99501582810304142)
,p_name=>'BU.COMPONENT_SETTINGS'
,p_message_language=>'es'
,p_message_text=>'Valores de Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99508084561304147)
,p_name=>'BU.CREDENTIALS'
,p_message_language=>'es'
,p_message_text=>'Credenciales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99504312739304144)
,p_name=>'BU.DATA_LOADING'
,p_message_language=>'es'
,p_message_text=>'Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99512293853304150)
,p_name=>'BU.DELETED'
,p_message_language=>'es'
,p_message_text=>'%0 suprimido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99512361151304150)
,p_name=>'BU.DEVELOPERS'
,p_message_language=>'es'
,p_message_text=>'Desarrolladores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99501724882304142)
,p_name=>'BU.EMAIL_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99548526943304181)
,p_name=>'BU.IN_PROGRESS'
,p_message_language=>'es'
,p_message_text=>unistr('Copia de seguridad de la aplicaci\00F3n en curso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99503409005304144)
,p_name=>'BU.LABEL_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100054476381304566)
,p_name=>'BU.LAST_BACKUP'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima copia de seguridad: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100053948972304565)
,p_name=>'BU.LAST_UPDATE'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima actualizaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99500534933304141)
,p_name=>'BU.LISTS'
,p_message_language=>'es'
,p_message_text=>'Listas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99503347193304143)
,p_name=>'BU.LIST_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99548296992304180)
,p_name=>'BU.LOCKED'
,p_message_language=>'es'
,p_message_text=>'Bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99500872877304142)
,p_name=>'BU.LOVS'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99503733147304144)
,p_name=>'BU.LOV_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas de lista de valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99507944569304147)
,p_name=>'BU.MESSAGES'
,p_message_language=>'es'
,p_message_text=>'Mensajes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99512158124304150)
,p_name=>'BU.MODIFIED'
,p_message_language=>'es'
,p_message_text=>'%0 modificado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99501087446304142)
,p_name=>'BU.NAVIGATION_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100054146158304565)
,p_name=>'BU.NEW'
,p_message_language=>'es'
,p_message_text=>'%0 nuevo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99502798366304143)
,p_name=>'BU.PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100464906156304914)
,p_name=>'BU.PAGES_DELETED'
,p_message_language=>'es'
,p_message_text=>'%0 suprimido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100464805650304914)
,p_name=>'BU.PAGES_MODIFIED'
,p_message_language=>'es'
,p_message_text=>'%0 modificado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100464788057304914)
,p_name=>'BU.PAGES_NEW'
,p_message_language=>'es'
,p_message_text=>'%0 nuevo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99500947866304142)
,p_name=>'BU.PLUGINS'
,p_message_language=>'es'
,p_message_text=>'Plugins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99503293307304143)
,p_name=>'BU.REGION_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99508293234304147)
,p_name=>'BU.REMOTE_SERVERS'
,p_message_language=>'es'
,p_message_text=>'Eliminar servidores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99504167617304144)
,p_name=>'BU.REPORT_LAYOUTS'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1os de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99503659185304144)
,p_name=>'BU.REPORT_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100009233774304531)
,p_name=>'BU.RESTORED'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n restaurada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99538517346304170)
,p_name=>'BU.RESTORED_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha restaurado la aplicaci\00F3n a partir de la revisi\00F3n de la copia de seguridad %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99502250382304143)
,p_name=>'BU.REST_ENABLED_SQL'
,p_message_language=>'es'
,p_message_text=>'SQL activado para REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99504074360304144)
,p_name=>'BU.SHARED_QUERIES'
,p_message_language=>'es'
,p_message_text=>'Consultas Compartidas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99501670002304142)
,p_name=>'BU.SHORTCUTS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todos Abreviados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99501978940304142)
,p_name=>'BU.STATIC_APPLICATION_FILES'
,p_message_language=>'es'
,p_message_text=>unistr('Archivos de Aplicaci\00F3n Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99502017172304142)
,p_name=>'BU.STATIC_WORKSPACE_FILES'
,p_message_language=>'es'
,p_message_text=>unistr('Archivos de Espacio de Trabajo Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99545484146304178)
,p_name=>'BU.SUMMARY_NOT_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>'Resumen de cambios no disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99503543686304144)
,p_name=>'BU.TABS'
,p_message_language=>'es'
,p_message_text=>'Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99502160657304143)
,p_name=>'BU.TEXT_MESSAGES'
,p_message_language=>'es'
,p_message_text=>'Mensajes de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99500771754304141)
,p_name=>'BU.THEMES'
,p_message_language=>'es'
,p_message_text=>'Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99503902188304144)
,p_name=>'BU.TREES'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rboles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99548330922304180)
,p_name=>'BU.UNLOCKED'
,p_message_language=>'es'
,p_message_text=>'Desbloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99500617589304141)
,p_name=>'BU.USER_INTERFACES'
,p_message_language=>'es'
,p_message_text=>'Atributos de Interfaz de Usuario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99501383261304142)
,p_name=>'BU.WEB_CREDENTIALS'
,p_message_language=>'es'
,p_message_text=>'Credenciales web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99504259942304144)
,p_name=>'BU.WEB_SERVICES'
,p_message_language=>'es'
,p_message_text=>'Servicios Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99508171268304147)
,p_name=>'BU.WEB_SOURCES'
,p_message_language=>'es'
,p_message_text=>unistr('Or\00EDgenes de Datos de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99528063058304162)
,p_name=>'BUFFER CACHE'
,p_message_language=>'es'
,p_message_text=>unistr('Cach\00E9 de Buffers')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99983778719304512)
,p_name=>'BUG'
,p_message_language=>'es'
,p_message_text=>'Bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100007040074304530)
,p_name=>'BUGS'
,p_message_language=>'es'
,p_message_text=>'Bugs'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100028414813304546)
,p_name=>'BUGS_ASSIGNED'
,p_message_language=>'es'
,p_message_text=>'bugs asignados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100065606756304574)
,p_name=>'BUGS_ASSIGNED_COUNT'
,p_message_language=>'es'
,p_message_text=>'Bugs Asignados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99556637149304187)
,p_name=>'BUGS_CLOSED'
,p_message_language=>'es'
,p_message_text=>'Bugs Cerrados (%0 / %1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100334143116304817)
,p_name=>'BUGS_PERCENT_CLOSED'
,p_message_language=>'es'
,p_message_text=>'Porcentaje de bugs cerrados (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100065759623304574)
,p_name=>'BUGS_UNASSIGNED_COUNT'
,p_message_language=>'es'
,p_message_text=>'Bugs No Asignados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100065839082304574)
,p_name=>'BUGS_WITHOUT_FIXBY'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna Correcci\00F3n por Fechas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100334504464304817)
,p_name=>'BUG_FEEDBACK_DASH'
,p_message_language=>'es'
,p_message_text=>'Bugs: %1 de %0 cerrados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100733024069305118)
,p_name=>'BUG_LABEL'
,p_message_language=>'es'
,p_message_text=>'Bug: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100022109108304541)
,p_name=>'BUILD QUERY'
,p_message_language=>'es'
,p_message_text=>'Crear Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99511923593304150)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVA'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99511807763304150)
,p_name=>'BUILDER.CODE_LANGUAGE.JAVASCRIPT'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99511781907304150)
,p_name=>'BUILDER.CODE_LANGUAGE.PLSQL'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99512018289304150)
,p_name=>'BUILDER.CODE_LANGUAGE.PYTHON'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99511695598304150)
,p_name=>'BUILDER.CODE_LANGUAGE.SQL'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100116214414304614)
,p_name=>'BUILDER.PLUGINS'
,p_message_language=>'es'
,p_message_text=>'Plugins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100113673110304612)
,p_name=>'BUILDER.UNSUPPORTED_COMPONENT'
,p_message_language=>'es'
,p_message_text=>'[No Soportado]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100312993493304801)
,p_name=>'BUILDER_NOTIFICATION_MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Mensaje de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99717783220304306)
,p_name=>'BUILD_OPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Opci\00F3n de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100163214121304688)
,p_name=>'BUILD_OPTION_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Opci\00F3n de Creaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100731710594305117)
,p_name=>'BUILD_STATUS_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Estado de Creaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100164051248304689)
,p_name=>'BUILD_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n Interna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100059510128304570)
,p_name=>'BUILT_IN_REPORT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Informe Incorporada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99968157556304500)
,p_name=>'BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100156348360304683)
,p_name=>'BUTTON.ADD'
,p_message_language=>'es'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99536272241304168)
,p_name=>'BUTTON.DA.INVALID.BUTTON_ATTR_CONTAIN_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Los atributos de bot\00F3n del bot\00F3n seleccionado no deben contener un identificador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99536148757304168)
,p_name=>'BUTTON.DA.INVALID.NOT_DEFINED_BY_DA'
,p_message_language=>'es'
,p_message_text=>unistr('El bot\00F3n seleccionado debe ser un bot\00F3n con una acci\00F3n definida por acci\00F3n din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99536368552304168)
,p_name=>'BUTTON.DA.INVALID.TEMPLATE_NO_BUTTON_ID'
,p_message_language=>'es'
,p_message_text=>unistr('El bot\00F3n seleccionado utiliza una plantilla de bot\00F3n que no contiene la cadena de sustituci\00F3n #BUTTON_ID#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100156181739304683)
,p_name=>'BUTTON.DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99594717913304215)
,p_name=>'BUTTON.INVALID.ACTION.REDIRECT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99573426811304200)
,p_name=>'BUTTON.INVALID.ACTION.REPORT_QRY'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar la consulta del informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99571592313304198)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar una solicitud de bot\00F3n para todos los tipos de origen de solicitud de bot\00F3n a menos que Tipo de Origen de Solicitud de Bot\00F3n est\00E9 definido en "Siempre Nulo".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99572281539304199)
,p_name=>'BUTTON.INVALID.ACTION.SOURCE_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar el tipo de origen de solicitud de bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99594870531304215)
,p_name=>'BUTTON.INVALID.ACTION.URL_TARGET'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el destino de URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99538220033304170)
,p_name=>'BUTTON.INVALID.BUTTON_ATTR_HAS_ID_WHEN_DA'
,p_message_language=>'es'
,p_message_text=>unistr('Si la acci\00F3n es ''Definida por Acci\00F3n Din\00E1mica'', los atributos de bot\00F3n no deben contener un identificador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99595981180304216)
,p_name=>'BUTTON.INVALID.STYLE.IMAGE'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar la imagen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99596069689304216)
,p_name=>'BUTTON.INVALID.STYLE.NO_STYLE'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el estilo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99595898421304216)
,p_name=>'BUTTON.INVALID.STYLE.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar la plantilla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99538166873304170)
,p_name=>'BUTTON.INVALID.TEMPLATE_NO_BUTTON_ID_WHEN_DA'
,p_message_language=>'es'
,p_message_text=>unistr('Si el estilo del bot\00F3n es ''Bot\00F3n Basado en Plantilla'' y la acci\00F3n es ''Definida por Acci\00F3n Din\00E1mica'', la plantilla de bot\00F3n seleccionada debe contener la cadena de sustituci\00F3n #BUTTON_ID#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99526054696304160)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_AFFECTED_ELEMENT'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede suprimir el bot\00F3n porque se hace referencia al mismo en una acci\00F3n din\00E1mica (P\00E1gina: %0, Acci\00F3n Din\00E1mica: ''%1'', Acci\00F3n: ''2%'', Atributo: ''Elemento Afectado'').')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99525955972304160)
,p_name=>'BUTTON.INVALID_DELETE.REFERENCED_BY.DA_WHEN'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede suprimir el bot\00F3n porque se hace referencia al mismo en una acci\00F3n din\00E1mica (P\00E1gina: %0, Acci\00F3n Din\00E1mica: ''%1'', Atributo: ''Cuando'').')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100156239807304683)
,p_name=>'BUTTON.SUBMIT'
,p_message_language=>'es'
,p_message_text=>'Ejecutar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100152480299304680)
,p_name=>'BUTTON.TEMPLATE.JAVASCRIPT'
,p_message_language=>'es'
,p_message_text=>'Para utilizar en un atributo "onclick"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100155646981304682)
,p_name=>'BUTTON.TEMPLATE.LINK'
,p_message_language=>'es'
,p_message_text=>'Para utilizar en un atributo "href"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99594663918304215)
,p_name=>'BUTTONS'
,p_message_language=>'es'
,p_message_text=>'Botones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100035294946304551)
,p_name=>'BUTTON_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>unistr('Atributos de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100731588208305117)
,p_name=>'BUTTON_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100039549578304554)
,p_name=>'BUTTON_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Bot\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99591919302304213)
,p_name=>'BYTES'
,p_message_language=>'es'
,p_message_text=>'bytes'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99983382302304512)
,p_name=>'BY_NEXT_PATCH'
,p_message_language=>'es'
,p_message_text=>'Para el Siguiente Parche'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99983471447304512)
,p_name=>'BY_NEXT_RELEASE'
,p_message_language=>'es'
,p_message_text=>unistr('Para la Siguiente Versi\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100806145798305173)
,p_name=>'CA.ABOUT'
,p_message_language=>'es'
,p_message_text=>'Acerca de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100772409852305147)
,p_name=>'CA.ABOUT.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Acerca de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100772323655305147)
,p_name=>'CA.ABOUT.PAGE.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incluya una p\00E1gina Acerca de esta aplicaci\00F3n, que incorpore una descripci\00F3n de la aplicaci\00F3n, la versi\00F3n de la aplicaci\00F3n y un recuento de p\00E1ginas.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99695355102304289)
,p_name=>'CA.ABOUT.PAGE.HELP.CONTENT.CONTAINER'
,p_message_language=>'es'
,p_message_text=>'Contenedor de contenido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100806337306305173)
,p_name=>'CA.ABOUT.THIS.APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Acerca de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100806462064305173)
,p_name=>'CA.ABOUT.THIS.APPLICATION.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('El texto sobre esta aplicaci\00F3n se puede colocar aqu\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100806071349305173)
,p_name=>'CA.ABOUT.THIS.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Acerca de esta p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100817285977305181)
,p_name=>'CA.ABOUT.THIS.PREVIEW.RELEASE'
,p_message_language=>'es'
,p_message_text=>unistr('Acerca de esta versi\00F3n de vista previa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99655211778304260)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede eliminar a s\00ED mismo de administrador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99655151443304260)
,p_name=>'CA.ACCESS.CANNOT_REMOVE_YOURSELF_FROM_ADMIN_MSG'
,p_message_language=>'es'
,p_message_text=>'No puede eliminar su propio rol de administrador.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100772740819305148)
,p_name=>'CA.ACCESS.CONTROL'
,p_message_language=>'es'
,p_message_text=>'Control de Acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100808650339305175)
,p_name=>'CA.ACCESS.CONTROL.ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Acciones de control de acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100798130881305167)
,p_name=>'CA.ACCESS.CONTROL.CONFIGURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de control de acceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100771196231305146)
,p_name=>'CA.ACCESS.CONTROL.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Activar autorizaci\00F3n de usuarios basada en roles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100772890310305148)
,p_name=>'CA.ACCESS.CONTROL.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incorpora la autenticaci\00F3n de usuarios basada en roles en la aplicaci\00F3n.'),
'Los usuarios se pueden definir como administradores, contribuyentes o lectores.',
unistr('A continuaci\00F3n, puede definir f\00E1cilmente un acceso diferente a distintos roles para los distintos componentes de la aplicaci\00F3n, como p\00E1ginas, entradas de men\00FA, regiones, columnas, elementos, botones, etc.</p>'),
'<p>Incluye los siguientes componentes:',
'<ul>',
unistr('<li>Regi\00F3n de p\00E1gina administrativa con enlaces para acceder a las funciones de control</li>'),
'<li>Tabla de usuarios para gestionar el control de acceso</li>',
unistr('<li>P\00E1gina de configuraci\00F3n para definir el nivel de acceso de los usuarios autenticados</li>'),
unistr('<li>P\00E1gina de configuraci\00F3n para especificar si los nombres de usuario son direcciones de correo electr\00F3nico o no</li>'),
unistr('<li>P\00E1gina de gesti\00F3n de acceso de usuarios para generar informes y editar el acceso del usuario</li>'),
unistr('<li>P\00E1gina de adici\00F3n de usuarios con capacidad de agregar un solo usuario</li>'),
unistr('<li>P\00E1gina de adici\00F3n de varios usuarios con capacidad de agregar varios usuarios (solo nombres de usuario de correo electr\00F3nico)</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100797063758305166)
,p_name=>'CA.ACCESS.ROLE'
,p_message_language=>'es'
,p_message_text=>'Rol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100797734922305166)
,p_name=>'CA.ACCESS.ROLE.ID'
,p_message_language=>'es'
,p_message_text=>'ID de rol de acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99626824970304239)
,p_name=>'CA.ACCESS.ROLES'
,p_message_language=>'es'
,p_message_text=>'Roles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100797199547305166)
,p_name=>'CA.ACCOUNT.LOCKED'
,p_message_language=>'es'
,p_message_text=>'Cuenta Bloqueada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99654727283304260)
,p_name=>'CA.ACKNOWLEDGED'
,p_message_language=>'es'
,p_message_text=>'Confirmado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100808417328305174)
,p_name=>'CA.ACL.INFORMATION'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n de ACL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100809178534305175)
,p_name=>'CA.ACL.NOT.ADMIN'
,p_message_language=>'es'
,p_message_text=>'Privilegios insuficientes. El usuario no es administrador.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100809298746305175)
,p_name=>'CA.ACL.NOT.AUTHORIZED'
,p_message_language=>'es'
,p_message_text=>unistr('No tiene autorizaci\00F3n para ver esta aplicaci\00F3n porque no le han otorgado acceso o porque su cuenta se ha bloqueado. P\00F3ngase en contacto con el administrador de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100809375078305175)
,p_name=>'CA.ACL.NOT.CONTRIBUTOR'
,p_message_language=>'es'
,p_message_text=>'Privilegios insuficientes. El usuario no es contribuyente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100798861204305167)
,p_name=>'CA.ACL.SAVED'
,p_message_language=>'es'
,p_message_text=>unistr('La configuraci\00F3n de control de acceso se ha guardado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100803513274305171)
,p_name=>'CA.ACTION.BUTTON.HTML'
,p_message_language=>'es'
,p_message_text=>unistr('HTML de bot\00F3n de acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100802468045305170)
,p_name=>'CA.ACTION.LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100802520631305170)
,p_name=>'CA.ACTION.LINK'
,p_message_language=>'es'
,p_message_text=>unistr('Enlace de Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100805121134305172)
,p_name=>'CA.ACTION.LINK.HTML'
,p_message_language=>'es'
,p_message_text=>unistr('HTML de enlace de acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100790656553305161)
,p_name=>'CA.ACTION.PROCESSED'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100796115989305165)
,p_name=>'CA.ACTIVITY.BY.HOUR'
,p_message_language=>'es'
,p_message_text=>'Actividad por Hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100829365649305190)
,p_name=>'CA.ACTIVITY.DASHBOARD'
,p_message_language=>'es'
,p_message_text=>'Panel de Control de Actividad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100772904932305148)
,p_name=>'CA.ACTIVITY.REPORTING'
,p_message_language=>'es'
,p_message_text=>unistr('Generaci\00F3n de informes de actividades')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100772145337305147)
,p_name=>'CA.ACTIVITY.REPORTING.DESC'
,p_message_language=>'es'
,p_message_text=>'Incluir informes de errores y actividad del usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100773050408305148)
,p_name=>'CA.ACTIVITY.REPORTING.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incluya una gran cantidad de informes sobre la actividad del usuario final para la aplicaci\00F3n. Con el fin de comprender mejor c\00F3mo se est\00E1 utilizando la aplicaci\00F3n y las \00E1reas de mejora, determine los usuarios m\00E1s activos, las p\00E1ginas m\00E1s utilizad')
||unistr('as, el rendimiento de las p\00E1ginas y los errores producidos.</p>'),
'<p>Incluye los siguientes componentes:',
'<ul>',
'<li>Informe de usuarios principales</li>',
unistr('<li>Informe de log de errores de la aplicaci\00F3n</li>'),
unistr('<li>Rendimiento de p\00E1gina, actividad y rendimiento por p\00E1gina</li>'),
unistr('<li>Informe de actividad de la aplicaci\00F3n por p\00E1gina</li>'),
unistr('<li>Informe de detalle de vistas de p\00E1gina</li>'),
'',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100019109151304539)
,p_name=>'CA.ACTUAL.START.DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha de Inicio Real'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100808333098305174)
,p_name=>'CA.ADD'
,p_message_language=>'es'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100803795542305171)
,p_name=>'CA.ADD.EMAIL.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar Plantilla de Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100820271565305183)
,p_name=>'CA.ADD.MULTI.USERS.STEP.2'
,p_message_language=>'es'
,p_message_text=>'Agregar varios usuarios: paso 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100806612295305173)
,p_name=>'CA.ADD.NEW.WIDGET'
,p_message_language=>'es'
,p_message_text=>'Agregar nuevo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100789615643305160)
,p_name=>'CA.ADD.NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100695267796305090)
,p_name=>'CA.ADD.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100797855784305166)
,p_name=>'CA.ADD.USER'
,p_message_language=>'es'
,p_message_text=>'Agregar Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100820649430305183)
,p_name=>'CA.ADD.USERS'
,p_message_language=>'es'
,p_message_text=>'Agregar usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100774558868305149)
,p_name=>'CA.ADDING.PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Adici\00F3n de p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100775058850305149)
,p_name=>'CA.ADDING.PAGES.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Haga clic en <strong>Agregar p\00E1gina</strong> para agregar una p\00E1gina a la aplicaci\00F3n. A continuaci\00F3n, seleccione un tipo de p\00E1gina (como en blanco, gr\00E1fico, formulario, informe, etc.) y defina sus atributos. Tambi\00E9n puede que necesite especificar ')
||unistr('una tabla o vista v\00E1lidas, o utilizar Taller de SQL para preparar los objetos de base de datos en su espacio de trabajo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100804513695305172)
,p_name=>'CA.ADDITIONAL.HTML.TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Avanzada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100018432007304538)
,p_name=>'CA.ADDITIONAL.INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n Adicional')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100797551958305166)
,p_name=>'CA.ADDRESS'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100777795760305151)
,p_name=>'CA.ADMIN.ACCESS.CONTROL'
,p_message_language=>'es'
,p_message_text=>'Control de Acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100778320869305152)
,p_name=>'CA.ADMIN.ACCESS.CONTROL.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Definir nivel de acceso para los usuarios autenticados de esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100776843752305151)
,p_name=>'CA.ADMIN.ACTIVITY.REPORTS'
,p_message_language=>'es'
,p_message_text=>'Informes de Actividades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100777813694305151)
,p_name=>'CA.ADMIN.ADD'
,p_message_language=>'es'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100779569735305153)
,p_name=>'CA.ADMIN.ADMINISTRATION'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100778238647305152)
,p_name=>'CA.ADMIN.ADMINISTRATORS'
,p_message_language=>'es'
,p_message_text=>'Administradores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100051604173304563)
,p_name=>'CA.ADMIN.APP.CONFIGURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100151224728304679)
,p_name=>'CA.ADMIN.APP.USER_INTERFACE'
,p_message_language=>'es'
,p_message_text=>'Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100813135220305178)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n de Aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100813289180305178)
,p_name=>'CA.ADMIN.APPLICATION.ADMINISTRATION.DESC'
,p_message_language=>'es'
,p_message_text=>'Gestionar componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100776481533305150)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE'
,p_message_language=>'es'
,p_message_text=>unistr('Selecci\00F3n de estilo de tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100776559358305150)
,p_name=>'CA.ADMIN.APPLICATION.APPEARANCE.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Definir la interfaz de usuario por defecto de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100776189065305150)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Configuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100776021958305150)
,p_name=>'CA.ADMIN.APPLICATION.CONFIGURATION.OPTIONS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Activar o desactivar funciones de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100777106952305151)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG'
,p_message_language=>'es'
,p_message_text=>unistr('Log de errores de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100777292496305151)
,p_name=>'CA.ADMIN.APPLICATION.ERROR.LOG.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Informe de errores registrados por esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100776675447305151)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100776798645305151)
,p_name=>'CA.ADMIN.APPLICATION.SETTINGS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Definir nombre y descripci\00F3n breve de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100776298556305150)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES'
,p_message_language=>'es'
,p_message_text=>unistr('Actualizaciones de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100776379677305150)
,p_name=>'CA.ADMIN.APPLICATION.UPDATES.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Mantener la lista de actualizaciones de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100775775825305150)
,p_name=>'CA.ADMIN.CONFIGURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100778191343305152)
,p_name=>'CA.ADMIN.CONTRIBUTORS'
,p_message_language=>'es'
,p_message_text=>'Contribuyentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100828143938305189)
,p_name=>'CA.ADMIN.DASHBOARD'
,p_message_language=>'es'
,p_message_text=>'Panel de Control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100828070137305189)
,p_name=>'CA.ADMIN.DASHBOARD.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Ver m\00E9tricas de actividad de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100781209446305154)
,p_name=>'CA.ADMIN.DEFAULT.TZ'
,p_message_language=>'es'
,p_message_text=>'Zona Horaria por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100781318864305154)
,p_name=>'CA.ADMIN.DEFAULT.TZ.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Definir la zona horaria por defecto para esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100779018297305152)
,p_name=>'CA.ADMIN.EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100781473203305154)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100781501213305154)
,p_name=>'CA.ADMIN.EMAIL.SETTINGS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Definir si el correo electr\00F3nico se debe enviar y, en ese caso, cu\00E1l debe ser el destinario de la respuesta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100778573447305152)
,p_name=>'CA.ADMIN.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100778833479305152)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de los comentarios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100778904235305152)
,p_name=>'CA.ADMIN.FEEDBACK.SETTINGS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Permite gestionar la posibilidad de inclusi\00F3n de datos adjuntos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100778643451305152)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Comentarios del usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100778788591305152)
,p_name=>'CA.ADMIN.MANAGE.FEEDBACK.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Informe de todos los comentarios enviados por los usuarios de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100779190596305152)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100779241305305153)
,p_name=>'CA.ADMIN.MANAGE.TEMPLATES.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Gestionar HTML y CSS de plantilla de correo electr\00F3nico utilizados por esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100775848833305150)
,p_name=>'CA.ADMIN.NOTIFICATIONS'
,p_message_language=>'es'
,p_message_text=>'Notificaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100775967125305150)
,p_name=>'CA.ADMIN.NOTIFICATIONS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar notificaciones en la p\00E1gina inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100813834750305178)
,p_name=>'CA.ADMIN.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Administraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100695961034305090)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG'
,p_message_language=>'es'
,p_message_text=>'Log de automatizaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100696055359305090)
,p_name=>'CA.ADMIN.PAGE.AUTOMATIONS.LOG.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Informe de mensajes y ejecuciones de automatizaci\00F3n registrados por esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100777341813305151)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE'
,p_message_language=>'es'
,p_message_text=>unistr('Rendimiento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100777429293305151)
,p_name=>'CA.ADMIN.PAGE.PERFORMANCE.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Informe de actividad y rendimiento por p\00E1gina de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100777552458305151)
,p_name=>'CA.ADMIN.PAGE.VIEWS'
,p_message_language=>'es'
,p_message_text=>unistr('Vistas de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100777682639305151)
,p_name=>'CA.ADMIN.PAGE.VIEWS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Informe de cada vista de p\00E1gina por usuario, incluida la fecha de acceso y el tiempo transcurrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100778067400305152)
,p_name=>'CA.ADMIN.READERS'
,p_message_language=>'es'
,p_message_text=>'Lectores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100821318131305184)
,p_name=>'CA.ADMIN.SEND.EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100821471569305184)
,p_name=>'CA.ADMIN.SEND.EMAIL.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar correo electr\00F3nico basado en plantilla desde esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100776994547305151)
,p_name=>'CA.ADMIN.TOP.USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100777047453305151)
,p_name=>'CA.ADMIN.TOP.USERS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Informe de vistas de p\00E1gina agregadas por usuarios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100777959752305152)
,p_name=>'CA.ADMIN.USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100778480204305152)
,p_name=>'CA.ADMIN.USERS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Cambiar configuraci\00F3n de control de acceso y desactivar control de acceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100779336677305153)
,p_name=>'CA.ADMIN.VIEW.LOG'
,p_message_language=>'es'
,p_message_text=>unistr('Log de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100779469880305153)
,p_name=>'CA.ADMIN.VIEW.LOG.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Ver log de correos electr\00F3nicos enviados por esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99786956511304356)
,p_name=>'CA.ADVANCED'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>Avanzado</strong>: ampl\00EDe para ver las opciones avanzadas.'),
'    <ul>',
unistr('      <li><strong>Definir como p\00E1gina inicial</strong>: convierta esta p\00E1gina en la p\00E1gina inicial de la aplicaci\00F3n.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;Las p\00E1ginas previamente definidas como p\00E1gina inicial se actualizar\00E1n.</li>'),
unistr('      <li><strong>Definir como p\00E1gina de administraci\00F3n</strong>: agregue esta p\00E1gina a Administraci\00F3n en lugar de a una p\00E1gina normal de la aplicaci\00F3n. Acceda haciendo clic en Administraci\00F3n en el men\00FA principal y seleccion\00E1ndola a continuaci\00F3n en l')
||unistr('a lista Administraci\00F3n de aplicaciones.<br>'),
unistr('        <em><strong>Nota:</strong>: Una p\00E1gina no puede actuar al mismo tiempo como p\00E1gina inicial y p\00E1gina de Administraci\00F3n.</em></li>'),
'      &nbsp;<br>',
unistr('      <li><strong>Ayuda de p\00E1gina</strong>: introduzca el texto que se debe agregar al texto de ayuda de la p\00E1gina.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99674084165304274)
,p_name=>'CA.ADVANCED.PAGE_HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>Avanzado</strong>: ampl\00EDe para ver las opciones avanzadas.'),
'    <ul>',
unistr('      <li><strong>Ayuda de p\00E1gina</strong>: introduzca el texto que se agregar\00E1 al texto de ayuda de la p\00E1gina.</li>'),
'    </ul>',
'  </li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100814232324305179)
,p_name=>'CA.ADVANCED.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n avanzada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100814334138305179)
,p_name=>'CA.ADVANCED.SETTINGS.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Defina la definici\00F3n adicional y la configuraci\00F3n de globalizaci\00F3n y seguridad. Esta configuraci\00F3n se puede aplicar al crear la aplicaci\00F3n y tambi\00E9n se puede editar despu\00E9s de crear la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100816218108305180)
,p_name=>'CA.ADVANCED.SETTINGS.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Para obtener m\00E1s informaci\00F3n, consulte el tema de ayuda ( <span class="fa fa-question-circle" aria-hidden="true"></span> ) para cada configuraci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100822030632305185)
,p_name=>'CA.AFTER.ROWS'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Filas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100803457117305171)
,p_name=>'CA.AFTER.ROWS.HTML'
,p_message_language=>'es'
,p_message_text=>unistr('HTML despu\00E9s de filas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100806508647305173)
,p_name=>'CA.ALL.COLS'
,p_message_language=>'es'
,p_message_text=>'Todas las Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100802632865305170)
,p_name=>'CA.ALLOW.OPT.OUT'
,p_message_language=>'es'
,p_message_text=>unistr('Permitir exclusi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100012043911304534)
,p_name=>'CA.ALLOW.RUNS.IN.RESTRICTED.MODE'
,p_message_language=>'es'
,p_message_text=>'Permitir ejecuciones en modo restringido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100796096643305165)
,p_name=>'CA.APP.ERROR.LOG'
,p_message_language=>'es'
,p_message_text=>unistr('Log de errores de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100791903177305162)
,p_name=>'CA.APP.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100062042059304571)
,p_name=>'CA.APP.SETTING.ACL_ENABLED.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E9 o no activado el control de acceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100062100728304572)
,p_name=>'CA.APP.SETTING.ACL_SCOPE.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Nivel de acceso por defecto proporcionado a miembros autenticados que no est\00E1n en la lista de control de acceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100792393519305162)
,p_name=>'CA.APP.SETTINGS.UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('La configuraci\00F3n de la aplicaci\00F3n se ha actualizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100792182144305162)
,p_name=>'CA.APP.SUBTITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n Breve')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100792235998305162)
,p_name=>'CA.APP.SUBTITLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El texto que se introduzca aqu\00ED aparece bajo el nombre de la aplicaci\00F3n en la p\00E1gina inicial de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100781683139305154)
,p_name=>'CA.APPEARANCE'
,p_message_language=>'es'
,p_message_text=>'Apariencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100781791937305154)
,p_name=>'CA.APPEARANCE.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Defina el esquema de color (estilo de tema) de la aplicaci\00F3n por defecto, d\00F3nde se encuentra la navegaci\00F3n y el icono utilizado para la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100801183130305169)
,p_name=>'CA.APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100788200368305159)
,p_name=>'CA.APPLICATION.APPEARANCE'
,p_message_language=>'es'
,p_message_text=>unistr('Apariencia de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100782217961305155)
,p_name=>'CA.APPLICATION.ICON'
,p_message_language=>'es'
,p_message_text=>unistr('Icono de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100782346665305155)
,p_name=>'CA.APPLICATION.ICON.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Haga clic en <strong>Seleccionar icono nuevo</strong> para seleccionar el color del icono y uno de los iconos disponibles. Su selecci\00F3n se muestra en la p\00E1gina inicial de la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100782670998305155)
,p_name=>'CA.APPLICATION.ID'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100782795330305155)
,p_name=>'CA.APPLICATION.ID.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca un identificador num\00E9rico \00FAnico para la aplicaci\00F3n. Este campo contiene un identificador generado autom\00E1ticamente por defecto.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100801777938305169)
,p_name=>'CA.APPLICATION.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100793949735305163)
,p_name=>'CA.APPLICATION.SESSIONS'
,p_message_language=>'es'
,p_message_text=>'Sesiones de Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100772548684305147)
,p_name=>'CA.APPLICATION.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100771476304305147)
,p_name=>'CA.APPLICATION.SETTINGS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Definir nombre y descripci\00F3n breve de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100772613449305148)
,p_name=>'CA.APPLICATION.SETTINGS.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite a los administradores de la aplicaci\00F3n actualizar varios valores, como el nombre y una descripci\00F3n de la aplicaci\00F3n, la zona horaria por defecto, entre otros.</p>'),
'<p>Incluye los siguientes componentes:',
'<ul>',
unistr('<li>Pantalla y entrada de lista de p\00E1ginas administrativas</li>'),
unistr('<li>Capacidad de definir el nombre de la aplicaci\00F3n</li>'),
unistr('<li>Capacidad de definir el subt\00EDtulo de la regi\00F3n h\00E9roe de la p\00E1gina inicial</li>'),
'<li>Capacidad de definir los destinatarios de los comentarios si se usan comentarios</li>',
unistr('<li>Capacidad de definir la zona horaria por defecto de la aplicaci\00F3n</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100827147399305188)
,p_name=>'CA.APPLICATIONITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100828927789305190)
,p_name=>'CA.APPLY'
,p_message_language=>'es'
,p_message_text=>'Aplicar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100830720948305191)
,p_name=>'CA.APPLY.APP.DEFAULTS'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n de valores por defecto de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100787422424305159)
,p_name=>'CA.APPLY.CHANGES'
,p_message_language=>'es'
,p_message_text=>'Aplicar Cambios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100828774921305190)
,p_name=>'CA.APPLY.FILTERS'
,p_message_language=>'es'
,p_message_text=>'Aplicar Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100149331981304678)
,p_name=>'CA.APP_BANNER'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n creada desde el asistente de creaci\00F3n de aplicaciones %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100150659940304678)
,p_name=>'CA.APP_SETTING.SAVE'
,p_message_language=>'es'
,p_message_text=>unistr('Guardar configuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100832945621305193)
,p_name=>'CA.ATTACHMENT'
,p_message_language=>'es'
,p_message_text=>'Adjunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99888836841304439)
,p_name=>'CA.ATTACHMENT.COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento de anexos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100833041691305193)
,p_name=>'CA.ATTACHMENT.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99888726716304438)
,p_name=>'CA.ATTACHMENT.SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de anexo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100829041235305190)
,p_name=>'CA.ATTR.DEFAULT.DUPLICATE'
,p_message_language=>'es'
,p_message_text=>unistr('Los atributos por defecto ya est\00E1n definidos para este %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100798223165305167)
,p_name=>'CA.AUTH.USER.MAY.ACCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Cualquier usuario autenticado puede acceder a esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100783475496305156)
,p_name=>'CA.AUTHENTICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100783565375305156)
,p_name=>'CA.AUTHENTICATION.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Seleccione la forma en la que desea que los usuarios se autentiquen en la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100014787068304536)
,p_name=>'CA.AUTO.DROP'
,p_message_language=>'es'
,p_message_text=>unistr('Borrado Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100696688768305091)
,p_name=>'CA.AUTOMATION_EXECUTION'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecuci\00F3n de automatizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100794604983305164)
,p_name=>'CA.AVG.ELAPSED'
,p_message_language=>'es'
,p_message_text=>'Tiempo Medio Transcurrido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100059321487304569)
,p_name=>'CA.BACK.TO.JOBS.REPORT'
,p_message_language=>'es'
,p_message_text=>'Volver a Informe de trabajos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99889550479304439)
,p_name=>'CA.BCC'
,p_message_language=>'es'
,p_message_text=>'CCO'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100821978576305184)
,p_name=>'CA.BEFORE.ROWS'
,p_message_language=>'es'
,p_message_text=>'Antes de Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100803318528305171)
,p_name=>'CA.BEFORE.ROWS.HTML'
,p_message_language=>'es'
,p_message_text=>'HTML antes de filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100804889170305172)
,p_name=>'CA.BEGIN.ROW.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Contenido antes de filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100780188526305153)
,p_name=>'CA.BLANK'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina en blanco')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100780264414305153)
,p_name=>'CA.BLANK.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cree una p\00E1gina en blanco que act\00FAe como marcador de posici\00F3n. Cuando haya creado la aplicaci\00F3n, podr\00E1 crear regiones en la p\00E1gina desde el Dise\00F1ador de p\00E1ginas f\00E1cilmente.</p>'),
'<p>Introduzca los siguientes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nombre de la p\00E1gina</strong> (obligatorio): introduzca un nombre para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir icono</strong>: seleccione un icono para que se muestre en el men\00FA de navegaci\00F3n de la p\00E1gina.</li>'),
unistr('<!--  <li><strong>Incluir navegaci\00F3n de p\00E1gina</strong>: active esta opci\00F3n para mostrar una lista de tarjetas del resto de p\00E1ginas definidas de su aplicaci\00F3n.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;Normalmente, esta opci\00F3n se utiliza en la p\00E1gina inicial de la aplicaci\00F3n.</li>'),
'-->',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100813541639305178)
,p_name=>'CA.BLUEPRINT'
,p_message_language=>'es'
,p_message_text=>unistr('Plan detallado de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100813696727305178)
,p_name=>'CA.BLUEPRINT.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El plan detallado muestra la definici\00F3n de la aplicaci\00F3n en formato JSON.</p>'),
unistr('<p>Al acceder a esta pantalla por primera vez, la definici\00F3n de la aplicaci\00F3n actual se transforma en un documento JSON. Puede editar el documento para actualizar las propiedades de la aplicaci\00F3n y, a continuaci\00F3n, hacer clic en <strong>Aplicar plan ')
||unistr('detallado</strong> para cambiar los detalles actuales de la aplicaci\00F3n.</p>'),
'<p>&nbsp;</p>',
unistr('<p>Si necesita crear un gran n\00FAmero de p\00E1ginas similares, copiar el c\00F3digo JSON relevante para una p\00E1gina y pegarlo varias veces, adem\00E1s de realizar peque\00F1os ajustes a JSON es significativamente m\00E1s r\00E1pido que utilizar manualmente <strong>Agregar p\00E1g')
||unistr('ina</strong> para cada p\00E1gina.</p>'),
unistr('<p>Haga clic en <strong>Cargar un plan detallado anterior</strong> para sustituir el plan detallado por la definici\00F3n desde una aplicaci\00F3n generada anteriormente. De esta forma puede iterar muy f\00E1cilmente un dise\00F1o de la aplicaci\00F3n agregando p\00E1ginas ')
||unistr('adicionales, cambiando las funciones o modificando la configuraci\00F3n antes de volver a generar la aplicaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100802206348305170)
,p_name=>'CA.BODY1.TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto del cuerpo1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100802320683305170)
,p_name=>'CA.BODY2.TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto del cuerpo2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100822377041305185)
,p_name=>'CA.BOTH'
,p_message_language=>'es'
,p_message_text=>'Ambos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100788617178305160)
,p_name=>'CA.BRANCH.TO.ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcar a p\00E1gina de administraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99785509553304355)
,p_name=>'CA.BUTTON.BAR'
,p_message_language=>'es'
,p_message_text=>'Barra de Botones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100788374732305159)
,p_name=>'CA.BUTTONS'
,p_message_language=>'es'
,p_message_text=>'Botones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100780896451305154)
,p_name=>'CA.CALENDAR'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina de calendario')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100780907590305154)
,p_name=>'CA.CALENDAR.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cree una p\00E1gina que muestre un calendario.</p>'),
'<p>Introduzca los siguientes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nombre de la p\00E1gina</strong> (obligatorio): introduzca un nombre para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir icono</strong>: seleccione un icono para que se muestre en el men\00FA de navegaci\00F3n de la p\00E1gina.</li>'),
'  <li><strong>Tabla o vista</strong> (obligatorio): seleccione el objeto de base de datos para el calendario.</li>',
unistr('  <li><strong>Columna de visualizaci\00F3n</strong> (obligatorio): seleccione la columna de la tabla o vista que se mostrar\00E1 en los eventos de calendario.</li>'),
unistr('  <li><strong>Columna de fecha de inicio</strong> (obligatorio): seleccione la columna de fecha de la tabla o vista que se utilizar\00E1 como fecha de inicio de los eventos de calendario.</li>'),
unistr('  <li><strong>Columna de fecha de finalizaci\00F3n</strong>: seleccione la columna de fecha de la tabla o vista que se utilizar\00E1 como fecha de finalizaci\00F3n de los eventos de calendario.<br>'),
unistr('      &nbsp;&nbsp;&nbsp;Si se especifica la fecha de finalizaci\00F3n, se mostrar\00E1n los eventos basados en la duraci\00F3n. </li>'),
unistr('  <li><strong>Mostrar hora</strong>: seleccione <u>S\00ED</u> para mostrar la parte de hora para los eventos y activar las vistas de calendario Diaria y Semanal. Seleccione <u>No</u> para mostrar solo las fechas de eventos.</li>'),
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100787304074305159)
,p_name=>'CA.CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100789236086305160)
,p_name=>'CA.CANCEL.DIALOG'
,p_message_language=>'es'
,p_message_text=>unistr('Cancelar Cuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99766599671304341)
,p_name=>'CA.CANCEL.MODAL'
,p_message_language=>'es'
,p_message_text=>'Cancelar modal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100799103963305167)
,p_name=>'CA.CANNOT.REMOVE.ADMIN.RIGHTS'
,p_message_language=>'es'
,p_message_text=>unistr('No puede eliminar los derechos de administraci\00F3n de su propio registro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100829991659305190)
,p_name=>'CA.CARD'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina de tarjeta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100829895925305190)
,p_name=>'CA.CARD.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Crea una p\00E1gina que muestra tarjetas.</p>'),
'<p>Introduzca los siguientes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nombre de p\00E1gina</strong> (obligatorio): introduzca un nombre para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir icono</strong>: seleccione un icono para mostrar en el men\00FA de navegaci\00F3n de la p\00E1gina.</li>'),
'  <li><strong>Tabla o vista</strong> (obligatorio): seleccione el objeto de base de datos de la tarjeta.</li>',
unistr('  <li><strong>T\00EDtulo de tarjeta</strong> (obligatorio): seleccione la columna de la tabla o vista que se va a utilizar como descripci\00F3n de la tarjeta.</li>'),
unistr('  <li><strong>Columna Descripci\00F3n</strong> (obligatorio): seleccione la columna de la tabla o vista que se va a utilizar como descripci\00F3n de la tarjeta.</li>'),
unistr('  <li><strong>Columna Texto adicional</strong>: seleccione la columna de la tabla o vista que se va a utilizar como descripci\00F3n secundaria de la tarjeta.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100828402092305189)
,p_name=>'CA.CARDS'
,p_message_language=>'es'
,p_message_text=>'Tarjetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100828584424305189)
,p_name=>'CA.CARDS.VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de tarjetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99889677964304439)
,p_name=>'CA.CC'
,p_message_language=>'es'
,p_message_text=>'CC'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100150051862304678)
,p_name=>'CA.CHANGE_FILTERS'
,p_message_language=>'es'
,p_message_text=>'Cambiar filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100779906299305153)
,p_name=>'CA.CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina de gr\00E1ficos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100780002433305153)
,p_name=>'CA.CHART.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cree una p\00E1gina que muestre un gr\00E1fico de \00E1reas, de barras, de l\00EDneas o circular.</p>'),
'<p>Introduzca los siguientes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nombre de la p\00E1gina</strong> (obligatorio): introduzca un nombre para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir icono</strong>: seleccione un icono para que se muestre en el men\00FA de navegaci\00F3n de la p\00E1gina.</li>'),
unistr('  <li><strong>Tipo de gr\00E1fico</strong>: seleccione el tipo de gr\00E1fico que desea mostrar [<strong>de \00E1reas</strong>, <strong>de barras</strong>, <strong>de l\00EDneas</strong>, <strong>de tarta</strong>].</li>'),
unistr('  <li><strong>Tabla o vista</strong> (obligatorio): seleccione el objeto de base de datos para el gr\00E1fico.</li>'),
unistr('  <li><strong>Columna de etiquetas</strong> (obligatorio): seleccione la columna de la tabla o la vista que desea utilizar como etiqueta para el gr\00E1fico.</li>'),
unistr('  <li><strong>Agregaci\00F3n de valores</strong>: seleccione c\00F3mo se debe mostrar o agregar la columna de valor<br>'),
'      &nbsp;&nbsp;&nbsp;[Valor de columna, Suma, Recuento].</li>',
unistr('  <li><strong>Columna Valor</strong> (obligatorio): seleccione una columna num\00E9rica de la tabla o vista utilizada para calcular los valores del gr\00E1fico mostrados.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100780384397305153)
,p_name=>'CA.CHART.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h3>Ejemplos</h3>',
unistr('<p>Consulte los ejemplos para ver c\00F3mo utilizar los distintos tipos de <strong>Resumen</strong>:</p>'),
unistr('<p><strong>Ejemplo 1:</strong> se muestra un gr\00E1fico de los empleados con el n\00FAmero de empleado del m\00E1nager de cada empleado.'),
'<code><ul>',
'  <li>Table or View - Select EMP.</li>',
'  <li>Label Column - Select ENAME.</li>',
'  <li>Summarization - Select <u><strong>Column Value</strong></u>.</li>',
'  <li>Value Column - Select MGR.</li>',
'</ul></code>',
'</p>',
unistr('<p><strong>Ejemplo 2:</strong> se muestra un gr\00E1fico de los empleados con el salario total de cada trabajo.'),
'<code><ul>',
'  <li>Table or View - Select EMP.</li>',
'  <li>Label Column - Select JOB.</li>',
'  <li>Summarization - Select <u><strong>Sum</strong></u>.</li>',
'  <li>Value Column - Select SAL.</li>',
'</ul></code>',
'</p>',
unistr('<p><strong>Ejemplo 3:</strong> se muestra un gr\00E1fico de los empleados con el n\00FAmero de empleados de cada departamento.'),
'<code><ul>',
'  <li>Table or View - Select EMP.</li>',
'  <li>Label Column - Select DEPTNO.</li>',
'  <li>Summarization - Select <u><strong>Count</strong></u>.</li>',
'  <li>Value Column - Select EMPNO.</li>',
'</ul></code>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100016757308304537)
,p_name=>'CA.CLIENT.ID'
,p_message_language=>'es'
,p_message_text=>'Identificador de Cliente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100833183544305193)
,p_name=>'CA.CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99654632519304260)
,p_name=>'CA.CLOSED'
,p_message_language=>'es'
,p_message_text=>'Cerrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100831193103305191)
,p_name=>'CA.COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100808135140305174)
,p_name=>'CA.COLUMN.1'
,p_message_language=>'es'
,p_message_text=>'Columna 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100808238009305174)
,p_name=>'CA.COLUMN.2'
,p_message_language=>'es'
,p_message_text=>'Columna 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100795505091305165)
,p_name=>'CA.COLUMN.ALIAS'
,p_message_language=>'es'
,p_message_text=>'Alias de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100826912791305188)
,p_name=>'CA.COMMENTS'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100793247043305163)
,p_name=>'CA.COMPONENT.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100798063332305167)
,p_name=>'CA.CONFIG.ACCESS.CONTROL'
,p_message_language=>'es'
,p_message_text=>'Configurar Control de Acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100788453161305159)
,p_name=>'CA.CONFIG.APPEARANCE'
,p_message_language=>'es'
,p_message_text=>'Configurar apariencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100788533660305160)
,p_name=>'CA.CONFIG.APPEARANCE.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('<p>El aspecto de la aplicaci\00F3n viene definida por el estilo del tema.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100791842872305162)
,p_name=>'CA.CONFIG.OPTION.UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('Las opciones de configuraci\00F3n se han actualizado. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100773794165305148)
,p_name=>'CA.CONFIGURATION.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Configuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100772075041305147)
,p_name=>'CA.CONFIGURATION.SETTINGS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Activar o desactivar funciones de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100773811405305148)
,p_name=>'CA.CONFIGURATION.SETTINGS.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite a los administradores de aplicaciones activar o desactivar una funcionalidad espec\00EDfica en la aplicaci\00F3n. Esta funci\00F3n es sumamente \00FAtil si selecciona funciones que necesitan un esfuerzo de desarrollo adicional antes de que las puedan util')
||'izar los usuarios finales.<br>',
unistr('Esta funci\00F3n tambi\00E9n se puede ampliar a funciones espec\00EDficas de la aplicaci\00F3n. Si los desarrolladores definen m\00E1s opciones de creaci\00F3n y las asocian a una funcionalidad espec\00EDfica de la aplicaci\00F3n, se pueden agregan a los valores de configuraci\00F3n pa')
||unistr('ra los administradores. Por ejemplo, en la aplicaci\00F3n empaquetada Sistema de seguimiento de clientes, los administradores pueden activar o desactivar funciones como Contactos, Carga de datos, Geograf\00EDa, etc.'),
'</p>',
'<p>Incluye los siguientes componentes:',
'<ul>',
unistr('<li>Permite activar y desactivar la funcionalidad de la aplicaci\00F3n</li>'),
unistr('<li>Utilice esta funci\00F3n para permitir una funcionalidad selectiva por despliegue</li>'),
unistr('<li>Permite el agrupamiento de la configuraci\00F3n relacionada de la aplicaci\00F3n</li>'),
unistr('<li>Los desarrolladores de aplicaciones controlan los componentes mediante opciones de creaci\00F3n</li>'),
unistr('<li>Disponible en la p\00E1gina Administraci\00F3n</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100011658047304533)
,p_name=>'CA.CONNECT.CREDENTIAL.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de Credencial de Conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100011775484304533)
,p_name=>'CA.CONNECT.CREDENTIAL.OWNER'
,p_message_language=>'es'
,p_message_text=>unistr('Propietario de credenciales de conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100678112716305073)
,p_name=>'CA.CONTEXT'
,p_message_language=>'es'
,p_message_text=>'Contexto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100798522361305167)
,p_name=>'CA.CONTRIBUTOR'
,p_message_language=>'es'
,p_message_text=>'Contribuyente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100018601333304539)
,p_name=>'CA.CPU.USED'
,p_message_language=>'es'
,p_message_text=>'CPU Usada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100807001877305173)
,p_name=>'CA.CREATE'
,p_message_language=>'es'
,p_message_text=>'Crear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100812153087305177)
,p_name=>'CA.CREATE.ADMIN.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de administraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100809758210305175)
,p_name=>'CA.CREATE.APP'
,p_message_language=>'es'
,p_message_text=>unistr('Creando aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100810833231305176)
,p_name=>'CA.CREATE.APP.COMP'
,p_message_language=>'es'
,p_message_text=>unistr('Creando c\00E1lculos de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100810167139305176)
,p_name=>'CA.CREATE.APP.ICON'
,p_message_language=>'es'
,p_message_text=>unistr('Creando icono de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100810756764305176)
,p_name=>'CA.CREATE.APP.ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Creando elementos de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100810957720305176)
,p_name=>'CA.CREATE.APP.PROCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Creando procesos de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100687211196305084)
,p_name=>'CA.CREATE.APP.SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Creando configuraci\00F3n de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100817026079305181)
,p_name=>'CA.CREATE.APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Crear una Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100060544149304570)
,p_name=>'CA.CREATE.APP_ROLES'
,p_message_language=>'es'
,p_message_text=>unistr('Creaci\00F3n de roles de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100810301447305176)
,p_name=>'CA.CREATE.AUTH.SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Creando esquemas de autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100811173565305176)
,p_name=>'CA.CREATE.BLANK.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina en blanco')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100810288668305176)
,p_name=>'CA.CREATE.BUILD.OPT'
,p_message_language=>'es'
,p_message_text=>unistr('Creando opciones de creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100811569773305177)
,p_name=>'CA.CREATE.CALENDAR.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de calendario')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100823335946305185)
,p_name=>'CA.CREATE.CARDS.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creaci\00F3n de p\00E1gina de tarjetas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100811339894305177)
,p_name=>'CA.CREATE.CHART.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100811870007305177)
,p_name=>'CA.CREATE.CR.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de informe cl\00E1sico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100811431397305177)
,p_name=>'CA.CREATE.DASHBOARD.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de panel de control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100809686968305175)
,p_name=>'CA.CREATE.END'
,p_message_language=>'es'
,p_message_text=>unistr('Finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100830679747305191)
,p_name=>'CA.CREATE.FACETED_SEARCH.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creaci\00F3n de una p\00E1gina de b\00FAsqueda por facetas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100812454206305177)
,p_name=>'CA.CREATE.FEATURES'
,p_message_language=>'es'
,p_message_text=>'Creando funciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100827975927305189)
,p_name=>'CA.CREATE.FILTERED.CONTENT.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Creaci\00F3n de contenido filtrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100811216494305176)
,p_name=>'CA.CREATE.FORM.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100809832858305175)
,p_name=>'CA.CREATE.GLOBAL.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100812086962305177)
,p_name=>'CA.CREATE.HOMEPAGE.NAV.LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Creando lista de navegaci\00F3n de p\00E1gina inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100811939681305177)
,p_name=>'CA.CREATE.IG.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de cuadr\00EDcula interactiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100811726479305177)
,p_name=>'CA.CREATE.IR.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de informe interactivo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99521142378304157)
,p_name=>'CA.CREATE.MAP.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de mapa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100816798223305181)
,p_name=>'CA.CREATE.MD.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Crear p\00E1ginas maestro/detalle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100810565046305176)
,p_name=>'CA.CREATE.NAV.BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Creando barras de navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100813712298305178)
,p_name=>'CA.CREATE.PAGE.GROUP'
,p_message_language=>'es'
,p_message_text=>unistr('Creando grupo de p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100812334433305177)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION'
,p_message_language=>'es'
,p_message_text=>unistr('Realizando traducci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100812269648305177)
,p_name=>'CA.CREATE.PERFORM.TRANSLATION.V'
,p_message_language=>'es'
,p_message_text=>unistr('Realizando traducci\00F3n de %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100811693098305177)
,p_name=>'CA.CREATE.REPORT.FORM.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de pantalla e informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100816963150305181)
,p_name=>'CA.CREATE.SAVE_BLUE.PRINT'
,p_message_language=>'es'
,p_message_text=>'Guardar plan detallado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100810635202305176)
,p_name=>'CA.CREATE.SHORT.CUT'
,p_message_language=>'es'
,p_message_text=>'Creando acceso directo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100811019037305176)
,p_name=>'CA.CREATE.SIGN.IN.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99520864879304156)
,p_name=>'CA.CREATE.SMART_FILTERS.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creando p\00E1gina de filtros inteligentes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100809598479305175)
,p_name=>'CA.CREATE.START'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100809914291305176)
,p_name=>'CA.CREATE.SUP.OBJ.SCRIPTS'
,p_message_language=>'es'
,p_message_text=>'Creando scripts de objetos de soporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100810425876305176)
,p_name=>'CA.CREATE.TEXT.MSG'
,p_message_language=>'es'
,p_message_text=>'Creando mensajes de texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100823411883305186)
,p_name=>'CA.CREATE.TIMELINE.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creaci\00F3n de p\00E1gina de cronolog\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100830840076305191)
,p_name=>'CA.CREATE.WIZARD.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Creaci\00F3n de una p\00E1gina del asistente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100791142393305161)
,p_name=>'CA.CREATED'
,p_message_language=>'es'
,p_message_text=>'Creado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100791211948305162)
,p_name=>'CA.CREATED.BY'
,p_message_language=>'es'
,p_message_text=>'Creado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100779638384305153)
,p_name=>'CA.CREATING.APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Creando Aplicaci\00F3n ...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100012336770304534)
,p_name=>'CA.CREDENTIAL.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de la Credencial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100018523420304539)
,p_name=>'CA.CREDENTIAL.OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario de Credencial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100791716400305162)
,p_name=>'CA.CURRENT.STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100812778134305178)
,p_name=>'CA.CUSTOM.QRY'
,p_message_language=>'es'
,p_message_text=>'Consulta Personalizada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100101513517304602)
,p_name=>'CA.CUSTOM.THEME'
,p_message_language=>'es'
,p_message_text=>'Utilizar tema personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100101630527304602)
,p_name=>'CA.CUSTOM.THEME.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Cambie el asistente para que utilice un tema personalizado en lugar de Tema universal.</p>',
'',
unistr('<p>Seleccione un tema de espacio de trabajo para la aplicaci\00F3n. Si el tema soporta temas estilos de tema, tambi\00E9n se puede seleccionar el estilo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99766263465304341)
,p_name=>'CA.CUSTOM_THEME'
,p_message_language=>'es'
,p_message_text=>'Tema personalizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100813362635305178)
,p_name=>'CA.DASHBOARD'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar P\00E1gina de Panel de Control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100677178229305073)
,p_name=>'CA.DASHBOARD.CHART.N'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100813490276305178)
,p_name=>'CA.DASHBOARD.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cree una p\00E1gina de panel de control con varios gr\00E1ficos.</p>'),
'<p>Introduzca los siguientes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nombre de p\00E1gina</strong> (obligatorio): introduzca un nombre para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir icono</strong>: seleccione un icono para mostrar en el men\00FA de navegaci\00F3n de la p\00E1gina.</li>'),
'  </ul>',
'</ul>',
'&nbsp;<br>',
unistr('<p>Cada gr\00E1fico (Gr\00E1fico 1, Gr\00E1fico 2, Gr\00E1fico 3 y Gr\00E1fico 4) se corresponde con un tipo de gr\00E1fico por defecto y se basa en <em>datos de ejemplo</em>. '),
unistr('  De este modo, no tiene que introducir m\00E1s detalles para agregar a la p\00E1gina.'),
unistr('  No obstante, puede personalizar cada gr\00E1fico sustituyendo los valores por defecto por sus propias selecciones.<br>'),
unistr('  Para personalizar un gr\00E1fico, introduzca los siguientes atributos:</p>'),
'<ul>',
unistr('  <li><strong>Nombre de gr\00E1fico</strong> (obligatorio): introduzca el nombre del gr\00E1fico.</li>'),
unistr('  <li><strong>Tipo de gr\00E1fico</strong>: seleccione el tipo de gr\00E1fico que desea mostrar [<strong>\00C1rea</strong>, <strong>Barra</strong>, <strong>L\00EDnea</strong>, <strong>Gr\00E1fico de tarta</strong>].</li>'),
unistr('  <li><strong>Tabla o vista</strong> (obligatorio): seleccione el objeto de base de datos para el gr\00E1fico.</li>'),
unistr('  <li><strong>Columna de etiqueta</strong> (obligatorio): seleccione la columna de la tabla o vista que desee utilizar como etiqueta para el gr\00E1fico.</li>'),
unistr('  <li><strong>Agregaci\00F3n de valores</strong>: seleccione el modo en que se debe mostrar o agregar la columna de valor<br>'),
'      &nbsp;&nbsp;&nbsp;[Columna Valor, Suma, Recuento].</li>',
unistr('  <li><strong>Columna Valor</strong> (obligatorio): seleccione una columna num\00E9rica de la tabla o vista utilizada para calcular los valores del gr\00E1fico mostrados.</li>'),
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100824073571305186)
,p_name=>'CA.DATATYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Dato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100825164559305187)
,p_name=>'CA.DATEFORMATMASK'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara Formato Fecha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100792421403305162)
,p_name=>'CA.DEFAULT.TIME.ZONE'
,p_message_language=>'es'
,p_message_text=>'Zona Horaria por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100792580108305162)
,p_name=>'CA.DEFAULT.TIME.ZONE.UPDATED'
,p_message_language=>'es'
,p_message_text=>'La zona horaria por defecto se ha actualizado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100814133924305179)
,p_name=>'CA.DEFAULTS'
,p_message_language=>'es'
,p_message_text=>unistr('Valores por defecto de atributo de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100814483620305179)
,p_name=>'CA.DEFAULTS.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Este documento de JSON permite un control detallado sobre la generaci\00F3n de nombres de columnas de formulario e informes, m\00E1scaras de formato, etc. Tambi\00E9n puede definir listas de valores y otros componentes compartidos. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100830495764305191)
,p_name=>'CA.DEFAULTS.LOV'
,p_message_language=>'es'
,p_message_text=>'Lista de atributos de valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100830562543305191)
,p_name=>'CA.DEFAULTS.LOV.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Agregue un atributo de lista de valores (LOV). Las listas se pueden utilizar en definiciones de columnas de la tabla. </p>',
'<p>Introduzca los siguientes atributos: ',
'  <ul> ',
'    <li><strong>Nombre</strong> (obligatorio): introduzca el nombre para la lista de valores. </li>',
unistr('    <li><strong>Tipo</strong>: seleccione el tipo de la lista de valores [Estructurado, Din\00E1mico, Est\00E1tico]. <br>'),
'      Para el tipo <u>Estructurado</u> - ',
'      <ul>',
unistr('          <li><strong>Tabla</strong> (obligatorio): seleccione la tabla o la vista en la que se basar\00E1 la lista de valores.</li>'),
unistr('          <li><strong>Columna de visualizaci\00F3n</strong> (obligatorio): seleccione la columna que se le mostrar\00E1 a los usuarios finales.</li>'),
unistr('          <li><strong>Columna de clave</strong> (obligatorio): seleccione el valor de columna que se devolver\00E1. Normalmente, es la clave primaria de la tabla.</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      Para el tipo <u>Din\00E1mico</u> -'),
'      <ul>',
unistr('          <li><strong>Consulta SQL</strong> (obligatorio): introduzca una sentencia SQL v\00E1lida que devuelva dos valores (valor de visualizaci\00F3n y valor de retorno).</li>'),
'      </ul>',
'      &nbsp;<br>',
unistr('      Para el tipo <u>Est\00E1tico</u> -'),
'      <ul>',
unistr('          <li><strong>Lista de valores est\00E1tica</strong> (obligatorio): introduzca una lista est\00E1tica v\00E1lida de la pantalla:'),
'          <ul>',
'            <li><code>STATIC2:Display1;Value1,Display2;Value2,...</code><br>Lista mostrada en el orden introducido</li>',
unistr('            <li><code>STATIC:Display1;Value1,Display2;Value2,...</code><br>Lista ordenada alfab\00E9ticamente</li>'),
unistr('            <li><code>STATIC2|STATIC:Value1,Value2,...</code><br>El valor de visualizaci\00F3n y el valor de retorno coinciden</li>'),
'          </ul>',
'      </ul>',
'    </li>',
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100831690673305192)
,p_name=>'CA.DEFAULTS.REPORT'
,p_message_language=>'es'
,p_message_text=>'Atributos de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100831714549305192)
,p_name=>'CA.DEFAULTS.REPORT.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Edite los atributos de todos los informes.</p>',
'<p>Introduzca los siguientes atributos:',
'  <ul>',
unistr('    <li><strong>Filas por p\00E1gina</strong>: introduzca el n\00FAmero de filas de informe que se mostrar\00E1n por defecto.</li>'),
unistr('    <li><strong>M\00E9todo de paginaci\00F3n</strong>: seleccione el modo en que se mostrar\00E1 la paginaci\00F3n de los informes.</li>'),
unistr('    <li><strong>M\00E1scara de formato num\00E9rico</strong>: introduzca la m\00E1scara de formato que se aplicar\00E1 para numerar columnas y elementos.</li>'),
unistr('    <li><strong>M\00E1scara de formato de fecha</strong>. introduzca la m\00E1scara de formato que se aplicar\00E1 para definir la fecha de columnas y elementos.</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100831472229305192)
,p_name=>'CA.DEFAULTS.TABLE'
,p_message_language=>'es'
,p_message_text=>'Atributos de tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100831207507305191)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN'
,p_message_language=>'es'
,p_message_text=>'Atributos de columnas de tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100831385587305191)
,p_name=>'CA.DEFAULTS.TABLE.COLUMN.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Edite los atributos de la columna de la tabla seleccionada. </p>',
'<p>Introduzca los siguientes atributos:',
'  <ul> ',
unistr('    <li><strong>Tabla</strong> (solo visualizaci\00F3n): tabla asociada. </li>'),
unistr('    <li><strong>Columna</strong> (solo visualizaci\00F3n): columna con la que se han definido los atributos. </li>'),
'    <li><strong>Etiqueta</strong>: introduzca la etiqueta que desea utilizar en las cabeceras de informes y las etiquetas de formularios. </li>',
'    <li><strong>Control de formularios</strong>: seleccione el tipo de elemento que desea utilizar en los formularios. </li>',
unistr('    <li><strong>Lista de valores</strong>: seleccione una lista de valores existente que se utilizar\00E1 para mostrar nombres que le resulten sencillos al usuario seg\00FAn corresponda. </li>'),
unistr('     <li><strong>M\00E1scara de formato</strong>: introduzca una m\00E1scara de formato adecuada seg\00FAn el tipo de columna (texto, n\00FAmero, fecha, etc.).</li>'),
unistr('    <li><strong>Valor est\00E1tico por defecto</strong>: introduzca un valor de texto por defecto para la columna. </li>'),
unistr('    <li><strong>Incluir en formularios</strong>: haga clic en S\00ED si la columna se debe incluir en los formularios. </li>'),
unistr('    <li><strong>Incluir en informes</strong>: haga clic en S\00ED si la columna se debe incluir en los informes. </li>'),
unistr('    <li><strong>Necesario</strong>: haga clic en S\00ED si los datos se deben introducir en esta columna de los formularios. </li>'),
'    <li><strong>Ayuda</strong>: introduzca el texto de ayuda que se agrega al atributo de ayuda de elemento. </li>',
'  </ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100831568058305192)
,p_name=>'CA.DEFAULTS.TABLE.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Edite los atributos de la tabla seleccionada. </p>',
'<p>Introduzca los siguientes atributos: ',
'  <ul>',
unistr('    <li><strong>Tabla</strong> (solo visualizaci\00F3n): tabla asociada.</li>'),
unistr('    <li><strong>Etiqueta, singular</strong> (obligatorio): introduzca la etiqueta que desea utilizar en p\00E1ginas de pantalla.</li>'),
unistr('    <li><strong>Etiqueta, plural</strong> (obligatorio): introduzca la etiqueta que desea utilizar en cabeceras de regiones y nombres de p\00E1ginas.</li>'),
unistr('    <li><strong>Columna de visualizaci\00F3n principal</strong>: seleccione la primera columna que se mostrar\00E1 en regiones de tarjetas, por ejemplo.</li>'),
unistr('    <li><strong>Columna de visualizaci\00F3n secundaria</strong>: seleccione la segunda columna que se mostrar\00E1 en regiones de tarjetas, por ejemplo.</li>'),
unistr('    <li><strong>Columna de clave principal</strong>: seleccione la columna de clave principal \00FAnica para la tabla.</li>'),
unistr('    <li><strong>Descripci\00F3n</strong>: introduzca una descripci\00F3n de la tabla.</li>'),
'  </ul>',
'</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100012190742304534)
,p_name=>'CA.DEFERRED.DROP'
,p_message_language=>'es'
,p_message_text=>'Borrado Diferido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100825727010305187)
,p_name=>'CA.DEFINITION'
,p_message_language=>'es'
,p_message_text=>unistr('Definici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100809444414305175)
,p_name=>'CA.DEINSTALL.COMPLETE'
,p_message_language=>'es'
,p_message_text=>unistr('Desinstalaci\00F3n terminada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100789787013305160)
,p_name=>'CA.DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100809001369305175)
,p_name=>'CA.DELETE.CONFIRM'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFDesea realizar esta acci\00F3n de supresi\00F3n?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100775339293305150)
,p_name=>'CA.DELETE.PAGE.CONFIRM.MSG'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFSeguro que desea suprimir esta p\00E1gina?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100799530017305168)
,p_name=>'CA.DELETE.PHOTO'
,p_message_language=>'es'
,p_message_text=>'Suprimir foto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100790452608305161)
,p_name=>'CA.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100807689269305174)
,p_name=>'CA.DESKTOP.NAVIGATION.BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100807508929305174)
,p_name=>'CA.DESKTOP.NAVIGATION.MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100788734489305160)
,p_name=>'CA.DESKTOP.THEME.STYLE'
,p_message_language=>'es'
,p_message_text=>'Estilo de tema de escritorio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100788827228305160)
,p_name=>'CA.DESKTOP.THEME.STYLE.DESC'
,p_message_language=>'es'
,p_message_text=>'El estilo de tema por defecto se aplica a todos los usuarios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100012539227304534)
,p_name=>'CA.DESTINATION'
,p_message_language=>'es'
,p_message_text=>'Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100012690569304534)
,p_name=>'CA.DESTINATION.OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario del Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99766371650304341)
,p_name=>'CA.DIALOG.BUTTONS'
,p_message_language=>'es'
,p_message_text=>unistr('Botones de cuadro de di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100804021936305171)
,p_name=>'CA.DISPATCH.EMAILS'
,p_message_language=>'es'
,p_message_text=>unistr('Distribuir correos electr\00F3nicos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100822502236305185)
,p_name=>'CA.DISPATCH.EMAILS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Determina si se deben enviar los correos electr\00F3nicos desde el marco de correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100790266494305161)
,p_name=>'CA.DISPLAY.FROM'
,p_message_language=>'es'
,p_message_text=>'Mostrar desde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100790119687305161)
,p_name=>'CA.DISPLAY.SEQUENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Secuencia de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100790380131305161)
,p_name=>'CA.DISPLAY.UNTIL'
,p_message_language=>'es'
,p_message_text=>'Mostrar hasta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100824213268305186)
,p_name=>'CA.DISPLAYCOLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100793859301305163)
,p_name=>'CA.DISTINCT .USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios Distintos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100807126316305173)
,p_name=>'CA.DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>'Descargar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100814015102305179)
,p_name=>'CA.DRAG.TO.REORDER'
,p_message_language=>'es'
,p_message_text=>unistr('Arrastrar para reordenar p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99787018232304356)
,p_name=>'CA.DRILL.DOWN.LINK'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr('  <li><strong>Enlace de detalles</strong>: ampl\00EDe para ver los atributos para la definici\00F3n de un enlace de detalles.'),
'&nbsp;<br>',
unistr('    <em><strong>Nota:</strong> El enlace de detalles solo aparece si la p\00E1gina actual se basa en una tabla o vista y tiene el tipo de informe Informe interactivo, y si ha definido un informe (Informe interactivo) o una p\00E1gina maestro/detalle (Maestro')
||'/detalle).</em>',
'  <ul>',
'    <li><strong>Columna Enlace</strong>: seleccione la columna para cambiar a una columna de enlace en el informe.</li>',
unistr('    <li><strong>Clave de enlace</strong>: seleccione la clave de enlace (clave ajena) utilizada para identificar el registro espec\00EDfico en la p\00E1gina con la que se enlaza.</li>'),
unistr('    <li><strong>Enlazar con p\00E1gina</strong>: seleccione el informe o p\00E1gina de formulario a la que navega el enlace.</li>'),
unistr('    <li><strong>Clave de destino</strong>: seleccione la columna de clave de destino (clave primaria) de la tabla de la p\00E1gina de informe a la que navega y en la que se basa el enlace.'),
'  </ul>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100792978667305163)
,p_name=>'CA.ELAPSED'
,p_message_language=>'es'
,p_message_text=>'Tiempo transcurrido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100775545503305150)
,p_name=>'CA.EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Marco de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100822107549305185)
,p_name=>'CA.EMAIL.ADDRESSES'
,p_message_language=>'es'
,p_message_text=>unistr('Direcciones de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100832185122305192)
,p_name=>'CA.EMAIL.DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100775430713305150)
,p_name=>'CA.EMAIL.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar capacidad para configurar y enviar correos electr\00F3nicos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100775637680305150)
,p_name=>'CA.EMAIL.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incluya la posibilidad de enviar correos electr\00F3nicos desde su aplicaci\00F3n. Env\00EDe correos electr\00F3nicos profesionales a los usuarios con esta plantilla de correo electr\00F3nico de ejemplo. Los correos electr\00F3nicos enviados se registran para que los adm')
||unistr('inistradores puedan realizar un seguimiento de la actividad de correo electr\00F3nico.</p>'),
'<p>Incluye los siguientes componentes:',
'<ul>',
unistr('<li>Sistema de plantillas de correo electr\00F3nico HTML ampliable</li>'),
'<li>Paquete PL/SQL para enviar correo mediante paquetes de APEX</li>',
unistr('<li>Registro del estado y la actividad de correo electr\00F3nico</li>'),
'<li>Interfaz de usuario administrativa para gestionar plantillas</li>',
unistr('<li>Interfaz de usuario administrativa para ver logs de correo electr\00F3nico</li>'),
unistr('<li>Interfaz de usuario administrativa para enviar correos electr\00F3nicos</li>'),
'</ul>',
'</p>',
unistr('<p><em>Nota: Esta funci\00F3n se activar\00E1 al seleccionar Comentarios</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100827830976305189)
,p_name=>'CA.EMAIL.FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Correo Electr\00F3nico De')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100803083327305170)
,p_name=>'CA.EMAIL.LOG'
,p_message_language=>'es'
,p_message_text=>unistr('Log de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100832717243305192)
,p_name=>'CA.EMAIL.P10940.EMAIL.DETAILS.REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se necesitan los detalles de configuraci\00F3n de correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100832271671305192)
,p_name=>'CA.EMAIL.P10940.EMAILS.FROM.INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('La direcci\00F3n de origen no es una direcci\00F3n de correo electr\00F3nico v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100823702196305186)
,p_name=>'CA.EMAIL.P11030.EMAILS.FROM.INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('La direcci\00F3n de origen no es una direcci\00F3n de correo electr\00F3nico v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100822935119305185)
,p_name=>'CA.EMAIL.PROCESSED'
,p_message_language=>'es'
,p_message_text=>unistr('Correo electr\00F3nico procesado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99889933443304439)
,p_name=>'CA.EMAIL.REPORTING'
,p_message_language=>'es'
,p_message_text=>unistr('Informes de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100062205807304572)
,p_name=>'CA.EMAIL.REPORTING.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Informe de todos los correos electr\00F3nicos en cola de env\00EDo y los que ya se han enviado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100803983988305171)
,p_name=>'CA.EMAIL.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100804394751305171)
,p_name=>'CA.EMAIL.SETTINGS.UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha actualizado la configuraci\00F3n de correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100828215633305189)
,p_name=>'CA.EMAIL.STATUS'
,p_message_language=>'es'
,p_message_text=>unistr('Estado de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100804428903305171)
,p_name=>'CA.EMAIL.TEMPLATE.DETAILS'
,p_message_language=>'es'
,p_message_text=>unistr('Detalles de la Plantilla de Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100310648953304799)
,p_name=>'CA.EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'
,p_message_language=>'es'
,p_message_text=>unistr('Interrupci\00F3n programada para #SERVICE_NAME#')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100108994011304608)
,p_name=>'CA.EMAIL2'
,p_message_language=>'es'
,p_message_text=>unistr('Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100802953840305170)
,p_name=>'CA.EMAILS.SENT'
,p_message_language=>'es'
,p_message_text=>unistr('Correos Electr\00F3nicos Enviados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100832360956305192)
,p_name=>'CA.ENABLE.ATTACHMENTS'
,p_message_language=>'es'
,p_message_text=>'Activar anexos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100017658216304538)
,p_name=>'CA.ENABLED'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100014870211304536)
,p_name=>'CA.END.DATE'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de Finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100805062261305172)
,p_name=>'CA.END.ROW.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Contenido despu\00E9s de filas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100696332987305091)
,p_name=>'CA.ENDED'
,p_message_language=>'es'
,p_message_text=>'Terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100820099689305183)
,p_name=>'CA.ENTER.USERNAME'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca aqu\00ED el nombre de usuario')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100793599431305163)
,p_name=>'CA.ERROR'
,p_message_language=>'es'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100795885543305165)
,p_name=>'CA.ERROR.BACKTRACE'
,p_message_language=>'es'
,p_message_text=>'Rastreo inverso de errores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100795761872305165)
,p_name=>'CA.ERROR.CODE'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo de error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100795096113305164)
,p_name=>'CA.ERROR.MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Mensaje de Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100019301361304539)
,p_name=>'CA.ERROR.NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100018348704304538)
,p_name=>'CA.ERRORS'
,p_message_language=>'es'
,p_message_text=>'Errores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100696587422305091)
,p_name=>'CA.ERROR_ROWS'
,p_message_language=>'es'
,p_message_text=>'Filas con errores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100015245120304536)
,p_name=>'CA.EVENT.CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Evento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100015343247304536)
,p_name=>'CA.EVENT.QUEUE.AGENT'
,p_message_language=>'es'
,p_message_text=>'Agente de Cola de Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100015402130304536)
,p_name=>'CA.EVENT.QUEUE.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Cola de Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100015500323304536)
,p_name=>'CA.EVENT.QUEUE.OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario de Cola de Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100015131378304536)
,p_name=>'CA.EVENT.RULE'
,p_message_language=>'es'
,p_message_text=>'Regla de evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100820303713305183)
,p_name=>'CA.EXCEPTIONS'
,p_message_language=>'es'
,p_message_text=>'Excepciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100833207455305193)
,p_name=>'CA.EXPERIENCE'
,p_message_language=>'es'
,p_message_text=>'Experiencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100017383903304538)
,p_name=>'CA.FAILURE.COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento de Fallos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100791530446305162)
,p_name=>'CA.FEATURE'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100466153346304915)
,p_name=>'CA.FEATURE.ABOUT_PAGE.APP_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100466285283304915)
,p_name=>'CA.FEATURE.ABOUT_PAGE.PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100150460547304678)
,p_name=>'CA.FEATURE.ACL.ADD_USERS_TO_ACL'
,p_message_language=>'es'
,p_message_text=>'Agregar usuarios a la lista de control de acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100150269281304678)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.ADD.NEXT'
,p_message_language=>'es'
,p_message_text=>'Ir al paso siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100150300995304678)
,p_name=>'CA.FEATURE.ACL.MULTIPLE_USER.CREATE_COLLECTIONS'
,p_message_language=>'es'
,p_message_text=>'Crear recopilaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100150131166304678)
,p_name=>'CA.FEATURE.ACL.USER.EDIT.CANNOT_CHANGE_LAST_ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede cambiar el \00FAltimo administrador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100465833212304915)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.LAST_ACTIVITY'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima Actividad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100149962149304678)
,p_name=>'CA.FEATURE.ACTIVITY_REPORT.NO_ACTIVITY_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna actividad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100466077398304915)
,p_name=>'CA.FEATURE.EXCEPTION.REASON'
,p_message_language=>'es'
,p_message_text=>'Motivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100150552359304678)
,p_name=>'CA.FEATURE.FEEDBACK.AT_LEAST_ONE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Se necesita al menos un comentario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100150847383304679)
,p_name=>'CA.FEATURE.FEEDBACK.GET_FILE_ID'
,p_message_language=>'es'
,p_message_text=>'Obtener ID de archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100149462686304678)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE'
,p_message_language=>'es'
,p_message_text=>'Guardar estilo de tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100149500634304678)
,p_name=>'CA.FEATURE.THEME_STYLE.SAVE_USER_PREF'
,p_message_language=>'es'
,p_message_text=>'Guardar preferencia de estilo de usuario final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100465931962304915)
,p_name=>'CA.FEATURE.USERNAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100779722886305153)
,p_name=>'CA.FEATURES'
,p_message_language=>'es'
,p_message_text=>'Funciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100779880505305153)
,p_name=>'CA.FEATURES.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Las funciones ofrecen funcionalidades a nivel de aplicaci\00F3n y normalmente se agregan una vez por aplicaci\00F3n. Seleccione las funciones que desea incluir en su aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100773620725305148)
,p_name=>'CA.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100771610960305147)
,p_name=>'CA.FEEDBACK.DESC'
,p_message_language=>'es'
,p_message_text=>'Permitir a los usuarios proporcionar comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100773577097305148)
,p_name=>'CA.FEEDBACK.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Ofrece a los usuarios finales un mecanismo para publicar comentarios generales como respuesta a los administradores y desarrolladores de la aplicaci\00F3n. Las publicaciones incluyen informaci\00F3n \00FAtil sobre el estado de la sesi\00F3n para ayudar a determin')
||unistr('ar el lugar desde el que el usuario final ha enviado los comentarios. Proporcionar ese \00FAtil intercambio de comentarios permite mejorar la comunicaci\00F3n entre la comunidad de usuarios y los propietarios de la aplicaci\00F3n, lo que permite mejorar en gran ')
||unistr('medida la satisfacci\00F3n del usuario final.</p>'),
'<p>Incluye los siguientes componentes:',
'<ul>',
unistr('<li>Capacidad de que los usuarios finales dejen comentarios haciendo clic en un icono de la barra de navegaci\00F3n</li>'),
'<li>Informe administrativo para ver y actualizar los comentarios</li>',
unistr('<li>Los comentarios capturar\00E1n la informaci\00F3n de usuario, fecha y hora y agente de usuario</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100833619857305193)
,p_name=>'CA.FEEDBACK.OR_EXPERIENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Env\00EDe comentarios sobre su experiencia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100832605826305192)
,p_name=>'CA.FEEDBACK.RECIPIENTS'
,p_message_language=>'es'
,p_message_text=>unistr('Destino de env\00EDo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100832083518305192)
,p_name=>'CA.FEEDBACK.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de comentarios')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100801003393305169)
,p_name=>'CA.FEEDBACK.SETTINGS.UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha actualizado la configuraci\00F3n de comentarios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100832827379305193)
,p_name=>'CA.FEEDBACK.SUBMITTED.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Comentarios enviados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100014923523304536)
,p_name=>'CA.FILE.WATCHER.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Observador de Archivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100015012812304536)
,p_name=>'CA.FILE.WATCHER.OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario del observador de archivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99673140459304273)
,p_name=>'CA.FILED'
,p_message_language=>'es'
,p_message_text=>'Archivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99673274917304273)
,p_name=>'CA.FILED.BY'
,p_message_language=>'es'
,p_message_text=>'Archivado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100828337156305189)
,p_name=>'CA.FILTER.REPORT'
,p_message_language=>'es'
,p_message_text=>'Filtrar informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100805483242305172)
,p_name=>'CA.FILTERS'
,p_message_language=>'es'
,p_message_text=>'Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100831014341305191)
,p_name=>'CA.FINISH'
,p_message_language=>'es'
,p_message_text=>'Terminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100799794437305168)
,p_name=>'CA.FIRST.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100011943726304534)
,p_name=>'CA.FLAGS'
,p_message_language=>'es'
,p_message_text=>'Indicadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100781144425305154)
,p_name=>'CA.FORM'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina de pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100781054240305154)
,p_name=>'CA.FORM.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cree una p\00E1gina que muestre una p\00E1gina de pantalla que permita a los usuarios finales mantener los datos.</p>'),
'<p>Introduzca los siguientes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nombre de la p\00E1gina</strong> (obligatorio): introduzca un nombre para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir icono</strong>: seleccione el icono que se mostrar\00E1 en el men\00FA de navegaci\00F3n de esta p\00E1gina.</li>'),
'  <li><strong>Tabla</strong> (obligatorio): seleccione la tabla para la pantalla.</li>',
unistr('<li><strong>Incluir informe</strong> (obligatorio): seleccione esta opci\00F3n para crear un informe y una pantalla La primera p\00E1gina es un informe interactivo. Cada fila proporciona un enlace a una pantalla donde los usuarios pueden actualizar el regist')
||'ro. </li>',
'  &nbsp;<br>',
unistr('<li><strong>Avanzadas</strong>: ampl\00EDe para ver opciones avanzadas.'),
'     <ul>',
unistr('      <li><strong>Ayuda de la p\00E1gina</strong>: introduzca el texto que se agregar\00E1 al Texto de ayuda para la p\00E1gina.</li>'),
'      </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99785654230304355)
,p_name=>'CA.FORM.ITEM.REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n de elementos de pantalla')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100807320107305174)
,p_name=>'CA.FORM.ON'
,p_message_language=>'es'
,p_message_text=>'Pantalla Basada en %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100819814798305183)
,p_name=>'CA.FORM.TYPE.NOT.VALID'
,p_message_language=>'es'
,p_message_text=>unistr('El tipo de formulario no es de un tipo v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100826257140305188)
,p_name=>'CA.FORMATMASK'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara de Formato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100825205329305187)
,p_name=>'CA.FORMCONTROL'
,p_message_language=>'es'
,p_message_text=>'Control de Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100790989675305161)
,p_name=>'CA.FROM'
,p_message_language=>'es'
,p_message_text=>'De'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100804115221305171)
,p_name=>'CA.FROM.ADDRESS'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n remitente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100827760816305189)
,p_name=>'CA.FROM.ADDRESS.EMAIL.SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de correo electr\00F3nico de "Direcci\00F3n de origen"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100823608191305186)
,p_name=>'CA.FROM.EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Correo electr\00F3nico de origen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100823558419305186)
,p_name=>'CA.FROM.WHO'
,p_message_language=>'es'
,p_message_text=>'Remitente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100516565154304953)
,p_name=>'CA.FS.SEARCH.TABLE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsqueda %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100794445830305164)
,p_name=>'CA.FULL.PAGE.VIEWS'
,p_message_language=>'es'
,p_message_text=>unistr('Vistas de p\00E1ginas completas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100803144359305170)
,p_name=>'CA.FULL.TEMPLATE.HTML'
,p_message_language=>'es'
,p_message_text=>'HTML de plantilla completa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100824713848305187)
,p_name=>'CA.FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100774051841305149)
,p_name=>'CA.GLOBAL.SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsqueda global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100771801613305147)
,p_name=>'CA.GLOBAL.SEARCH.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Proporcionar capacidad de b\00FAsqueda en la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100773954781305149)
,p_name=>'CA.GLOBAL.SEARCH.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite a los usuarios finales buscar texto en tablas o vistas clave de la aplicaci\00F3n. La p\00E1gina de b\00FAsqueda avanzada incluye filtros para que los usuarios finales puedan limitar f\00E1cilmente los resultados.<br>'),
unistr('Para utilizar esta funci\00F3n tan potente se deben realizar algunas tareas de desarrollo para definir el SQL (basado en los ejemplos proporcionados).</p>'),
'<p>Incluye los siguientes componentes:',
'<ul>',
unistr('<li>Muestra un icono de b\00FAsqueda en la barra de cabecera</li>'),
unistr('<li>Incluye una p\00E1gina de resultados de b\00FAsqueda de detalle con filtro de barra lateral</li>'),
unistr('<li>Necesita que el desarrollador implante el SQL para definir la b\00FAsqueda en la aplicaci\00F3n</li>'),
'<li>Incluye datos de ejemplo como muestra</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100016649284304537)
,p_name=>'CA.GLOBAL.UID'
,p_message_language=>'es'
,p_message_text=>unistr('ID \00FAnico global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100149015509304677)
,p_name=>'CA.GLOBAL_PAGE.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Global - Escritorio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99766429321304341)
,p_name=>'CA.GO.TO.ADMIN.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a la p\00E1gina de administraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100780607183305154)
,p_name=>'CA.GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina de cuadr\00EDcula interactiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100780776207305154)
,p_name=>'CA.GRID.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cree una p\00E1gina que se muestre como una cuadr\00EDcula interactiva, que es similar a una hoja de c\00E1lculo. Cuando es editable, los usuarios pueden editar varias filas directamente en la p\00E1gina (es decir, cuando la opci\00F3n Permitir edici\00F3n est\00E1 activada)')
||'.</p>',
'<p>Introduzca los siguientes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nombre de la p\00E1gina</strong> (obligatorio): introduzca un nombre para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir icono</strong>: seleccione un icono para que se muestre en el men\00FA de navegaci\00F3n de la p\00E1gina.</li>'),
'  <li><strong>Tipo de consulta</strong>: seleccione el origen del informe [<strong>Tabla o vista<strong> o <strong>Consulta SQL<strong>].<br>',
'    <strong>Tabla o vista</strong>:',
'    <ul>',
unistr('      <li><strong>Tabla o vista</strong> (obligatorio): seleccione el objeto de base de datos de la cuadr\00EDcula.</li>'),
'    </ul>',
'    <strong>Consulta SQL</strong>:',
'    <ul>',
unistr('      <li><strong>Consulta SQL</strong> (obligatorio): introduzca una sentencia SQL v\00E1lida que devuelva columnas distintas.</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>Tipo de cuadr\00EDcula</strong>: seleccione si los usuarios pueden editar las filas de la cuadr\00EDcula [<strong>Permitir edici\00F3n<strong> o <strong>Solo lectura<strong>]. Para activar la edici\00F3n, seleccione<strong>Permitir edici\00F3n</strong>.</l')
||'i>',
'  &nbsp;<br>',
unistr('  <em><strong>Advertencia:</strong>Si selecciona el tipo de consulta <strong>Consulta SQL</strong> y el tipo de cuadr\00EDcula <strong>Permitir edici\00F3n</strong> y su consulta une dos o m\00E1s tablas, la cuadr\00EDcula interactiva generada fallar\00E1 cuando los usu')
||'arios intenten actualizar los registros.',
unistr('Adem\00E1s, si selecciona el tipo de cuadr\00EDcula <strong>Permitir edici\00F3n</strong> y la consulta (o tabla o vista seleccionada) utiliza una vista que no se puede actualizar, la cuadr\00EDcula interactiva generada fallar\00E1 cuando los usuarios intenten actualiza')
||'r los registros.</em><br>',
'  </li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100805921067305173)
,p_name=>'CA.HELP'
,p_message_language=>'es'
,p_message_text=>'Ayuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100696160289305090)
,p_name=>'CA.HELP.ACTIVITY.REPORTING.AUTOMATIONS.LOG'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina proporciona un informe interactivo del log de automatizaciones.</p>'),
unistr('<p>Revise la informaci\00F3n registrada sobre las ejecuciones de automatizaci\00F3n anteriores. El log contiene registros de hora de inicio y finalizaci\00F3n, as\00ED como detalles sobre las filas procesadas (de forma correcta y con errores). Aumente el detalle en ')
||unistr('Mensajes para ver mensajes espec\00EDficos de las filas procesadas.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100798339836305167)
,p_name=>'CA.HELP.ALLOW.OTHER.USERS'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione <strong>No</strong> si se definen todos los usuarios en la lista de control de acceso. Seleccione <strong>S\00ED</strong> si los usuarios autenticados que no est\00E9n en la lista de control de acceso pueden tambi\00E9n utilizar esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100792090120305162)
,p_name=>'CA.HELP.APP.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('El texto que se introduce aqu\00ED se utiliza en toda la aplicaci\00F3n, en especial, en la esquina superior izquierda de las p\00E1ginas. El cambio se aplicar\00E1 de forma inmediata para el administrador que realiza el cambio, pero otros usuarios solo ver\00E1n el cam')
||unistr('bio cuando inicien una nueva sesi\00F3n (es decir, la pr\00F3xima vez que se conecten).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100786651114305158)
,p_name=>'CA.HELP.HOME.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Haga clic en el icono de comentarios ( <span class="fa fa-comment-o" aria-hidden="true"></span> ) de la barra de navegaci\00F3n, en cualquier p\00E1gina de la aplicaci\00F3n, para dejar un comentario para los administradores de la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100786375129305158)
,p_name=>'CA.HELP.HOME.MAIN.SIDE.MENU'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Esta es la p\00E1gina inicial de la aplicaci\00F3n. Haga clic en las tarjetas para acceder a distintas p\00E1ginas de la aplicaci\00F3n o utilice el men\00FA de navegaci\00F3n del lateral de la p\00E1gina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100786593094305158)
,p_name=>'CA.HELP.HOME.MAIN.TOP.MENU'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Esta es la p\00E1gina inicial de la aplicaci\00F3n. Haga clic en las tarjetas para acceder a distintas p\00E1ginas de la aplicaci\00F3n o utilice el men\00FA de navegaci\00F3n de la parte superior de la p\00E1gina.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100786714322305158)
,p_name=>'CA.HELP.HOME.SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca un t\00E9rmino de b\00FAsqueda en el campo <strong>Buscar aplicaci\00F3n</strong> de esta p\00E1gina o haga clic en el icono de b\00FAsqueda ( <span class="fa fa-search" aria-hidden="true"></span> ) de la barra de navegaci\00F3n de cualquier p\00E1gina, para busca')
||unistr('r el t\00E9rmino en la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100787012657305158)
,p_name=>'CA.HELP.HOME.SIGN.OUT'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Haga clic en la lista desplegable de nombres de la barra de navegaci\00F3n para cerrar sesi\00F3n de la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100786945482305158)
,p_name=>'CA.HELP.HOME.TIME'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Haga clic en el men\00FA de usuario ( <span class="fa fa-user" aria-hidden="true"></span> ) de la barra de navegaci\00F3n para actualizar su preferencia de zona horaria y cerrar sesi\00F3n de la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100786418947305158)
,p_name=>'CA.HELP.HOME.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100787185438305159)
,p_name=>'CA.HELP.HOME.USER'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Haga clic en el men\00FA de usuario ( <span class="fa fa-user" aria-hidden="true"></span> ) de la barra de navegaci\00F3n (parte superior derecha de la p\00E1gina) para acceder a su perfil de usuario y cerrar sesi\00F3n de la aplicaci\00F3n.<br>'),
unistr('Si hace clic en <strong>Ver mi perfil</strong>, podr\00E1 a continuaci\00F3n hacer clic en <strong>Actualizar perfil</strong> para introducir sus datos personales y cargar una fotograf\00EDa o un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100786866984305158)
,p_name=>'CA.HELP.HOME.USER.TIME'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Haga clic en el men\00FA de usuario ( <span class="fa fa-user" aria-hidden="true"></span> ) de la barra de navegaci\00F3n para acceder a su perfil de usuario, actualizar su preferencia de zona horaria y cerrar sesi\00F3n de la aplicaci\00F3n.<br>'),
unistr('Si hace clic en <strong>Ver mi perfil</strong>, podr\00E1 a continuaci\00F3n hacer clic en <strong>Actualizar perfil</strong> para introducir sus datos personales y cargar una fotograf\00EDa o un avatar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100812921004305178)
,p_name=>'CA.HELP.IG.PAGE.READONLY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para buscar los datos, introduzca un t\00E9rmino de b\00FAsqueda en el cuadro de di\00E1logo de b\00FAsqueda o haga clic en las cabeceras de columna para limitar los registros devueltos.</p>'),
'',
unistr('<p>Puede realizar varias funciones haciendo clic en el bot\00F3n <strong>Acciones</strong>, entre las que se incluyen el seleccionar las columnas que se muestran u ocultan y su secuencia de visualizaci\00F3n, adem\00E1s de numeras funciones de datos y formato. T')
||unistr('ambi\00E9n puede definir m\00E1s vistas de los datos con la opci\00F3n de gr\00E1fico.</p>'),
'',
'<p>Si desea guardar las personalizaciones, seleccione el informe o haga clic en Descargar para descargar los datos.<p>',
'<br>',
unistr('<p>Para obtener m\00E1s informaci\00F3n, haga clic en Ayuda en la parte inferior del men\00FA Acciones.</p>'),
'',
unistr('<p>Haga clic en el bot\00F3n <strong>Restablecer</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100812861134305178)
,p_name=>'CA.HELP.IG.PAGE.UPDATABLE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Puede insertar, actualizar y suprimir los datos directamente en esta cuadr\00EDcula interactiva.<br>'),
unistr('  Inserte una fila nueva haciendo clic en el bot\00F3n Agregar fila.<br>'),
unistr('  Haga doble clic en una celda o haga clic en el bot\00F3n <strong>Editar</strong> para actualizar los valores de datos, lo que equivale a editar los datos en una hoja de c\00E1lculo.</p>'),
'',
unistr('<p>Utilice el men\00FA Acciones de fila ( <span class="fa fa-bars" aria-hidden="true"></span> ) en la parte superior del informe para duplicar, suprimir, refrescar o revertir las filas seleccionadas.<br>'),
unistr('  Utilice el men\00FA Acciones de fila en las distintas filas para acceder tambi\00E9n a la vista de una fila o agregar una nueva fila.</p>'),
'',
unistr('<p>Para buscar los datos, introduzca un t\00E9rmino de b\00FAsqueda en el cuadro de di\00E1logo de b\00FAsqueda o haga clic en las cabeceras de columna para limitar los registros devueltos.</p>'),
'',
unistr('<p>Puede realizar varias funciones haciendo clic en el bot\00F3n <strong>Acciones</strong>, entre las que se incluyen el seleccionar las columnas que se muestran u ocultan y su secuencia de visualizaci\00F3n, adem\00E1s de numeras funciones de datos y formato. T')
||unistr('ambi\00E9n puede definir m\00E1s vistas de los datos con la opci\00F3n de gr\00E1fico.</p>'),
'',
'<p>Si desea guardar las personalizaciones, seleccione el informe o haga clic en Descargar para descargar los datos.<p>',
'',
unistr('<p>Para obtener m\00E1s informaci\00F3n, haga clic en Ayuda en la parte inferior del men\00FA Acciones.</p>'),
'',
unistr('<p>Haga clic en el bot\00F3n <strong>Restablecer</strong> para restablecer la configuraci\00F3n por defecto de la cuadr\00EDcula interactiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100786239055305158)
,p_name=>'CA.HELP.IR.PAGE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para buscar los datos, introduzca un t\00E9rmino de b\00FAsqueda en el cuadro de di\00E1logo de b\00FAsqueda o haga clic en las cabeceras de columna para limitar los registros devueltos.</p>'),
'',
unistr('<p>Puede realizar varias funciones haciendo clic en el bot\00F3n <strong>Acciones</strong>, entre las que se incluyen el seleccionar las columnas que se muestran u ocultan y su secuencia de visualizaci\00F3n, adem\00E1s de numerosas funciones de datos y formato.')
||unistr(' Tambi\00E9n puede definir m\00E1s vistas de los datos con las opciones de gr\00E1fico, agrupaci\00F3n por y giro.</p>'),
'',
unistr('<p>Si desea guardar las personalizaciones, seleccione el informe o haga clic en Descargar para descargar los datos. Introduzca la direcci\00F3n de correo electr\00F3nico y el marco temporal de la suscripci\00F3n para el env\00EDo de los datos de forma regular.<p>'),
'',
unistr('<p>Para obtener m\00E1s informaci\00F3n, haga clic en Ayuda en la parte inferior del men\00FA Acciones.</p>'),
'',
unistr('<p>Haga clic en el bot\00F3n <strong>Restablecer</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100820812895305184)
,p_name=>'CA.HELP.MD.PAGE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina de informe muestra los registros principales en un selector en un lateral de la p\00E1gina. '),
'  Seleccione un registro para ver el registro maestro y cualquier registro de detalle definido.<br> ',
unistr('  Haga clic en el icono de edici\00F3n ( <span class="fa fa-pencil-square-o" aria-hidden="true"></span> ) para editar el registro maestro.'),
unistr('  Para los registros detallados, haga clic en el l\00E1piz, al principio de cada fila, para editar ese registro.</p>'),
unistr('<p>Para limitar los datos mostrados en el selector, introduzca un t\00E9rmino de b\00FAsqueda en el cuadro de di\00E1logo de b\00FAsqueda.</p>'),
'',
unistr('<p>Para agregar nuevos registros maestros, haga clic en <strong>Crear</strong> al principio de la p\00E1gina.'),
unistr('  Para los registros detallados, haga clic en el icono de signo m\00E1s ( + ) en la parte superior de la regi\00F3n de detalle para agregar un registro detallado.</p>'),
'',
unistr('<p>Haga clic en <strong>Restablecer</strong> en la parte superior de la p\00E1gina para restablecer la p\00E1gina a la configuraci\00F3n por defecto, eliminando cualquier t\00E9rmino de b\00FAsqueda definido previamente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100784218346305156)
,p_name=>'CA.HELP.P10000.ADMINISTRATION.PAGE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La p\00E1gina de administraci\00F3n permite a los propietarios de aplicaciones (administradores) configurar la aplicaci\00F3n y conservar los datos comunes que se utilizan en toda la aplicaci\00F3n.'),
unistr('Al seleccionar uno de los valores disponibles, los administradores pueden cambiar potencialmente la forma en que se muestra la aplicaci\00F3n y/o las funciones que pueden utilizar los usuarios finales.</p>'),
unistr('<p>El acceso a esta p\00E1gina debe estar restringido solo a los administradores.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100785422199305157)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.CONFIGURE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la opci\00F3n adecuada para cualquier usuario autenticado.<br>'),
unistr('Al seleccionar <strong>No</strong>, la aplicaci\00F3n pasa a ser m\00E1s segura, ya que solo podr\00E1n acceder a ella los usuarios especificados.'),
unistr('Sin embargo, si la aplicaci\00F3n tiene una comunidad de usuarios grande, mantener a tal cantidad de usuarios puede ser una tarea laboriosa y tal vez prefiera seleccionar <strong>S\00ED</strong> y solo implicar a los administradores de la aplicaci\00F3n y puede ')
||'que a los contribuyentes.<br>',
unistr('Si selecciona <strong>S\00ED</strong>, tambi\00E9n debe seleccionar c\00F3mo se considera a los usuarios no incluidos en la lista de usuarios.</p>'),
unistr('<p>Seleccione entre exigir las direcciones de correo electr\00F3nico y cualquier valor alfanum\00E9rico para los nombres de usuario.<br>'),
unistr('Por lo general, debe definir este valor en <strong>Direcci\00F3n de correo electr\00F3nico</strong> si la aplicaci\00F3n utiliza (o se configurar\00E1 para utilizar) un esquema de autenticaci\00F3n centralizado como Oracle Access Manager o SSO.</p>'),
unistr('<p><em><strong>Nota:</strong> Esta aplicaci\00F3n soporta los tres niveles siguientes de acceso: Lector, Contribuyente y Administrador.'),
'<ul>',
unistr('  <li>Los <strong>lectores</strong> tienen acceso de solo lectura a toda la informaci\00F3n y tambi\00E9n pueden ver informes.</li>'),
unistr('  <li>Los <strong>contribuyentes</strong> pueden crear, editar y suprimir informaci\00F3n y ver informes.</li>'),
unistr('  <li>Los <strong>administradores</strong>, adem\00E1s de la capacidad Contribuyentes, tambi\00E9n pueden realizar la configuraci\00F3n de la aplicaci\00F3n mediante el acceso a la secci\00F3n Administraci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>',
'</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100785662868305157)
,p_name=>'CA.HELP.P10100.ACCESS.CONTROL.USERS.FORM'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice esta pantalla para introducir usuarios, sus direcciones de correo electr\00F3nico y definir sus niveles de acceso.'),
unistr('La configuraci\00F3n definida en <em>Configurar control de acceso</em> determinar\00E1 si el nombre de usuario debe ser su direcci\00F3n de correo electr\00F3nico o puede ser cualquier entrada alfanum\00E9rica.</p>'),
unistr('<p>Esta aplicaci\00F3n soporta los tres niveles de acceso siguientes: Lector, Contribuyente y Administrador.</p>'),
'<ul>',
unistr('  <li>Los <strong>lectores</strong> tienen acceso de solo lectura a toda la informaci\00F3n y tambi\00E9n pueden ver informes.</li>'),
unistr('  <li>Los <strong>contribuyentes</strong> pueden crear, editar y suprimir informaci\00F3n y ver informes.</li>'),
unistr('  <li>Los <strong>administradores</strong>, adem\00E1s de la capacidad Contribuyentes, tambi\00E9n pueden realizar la configuraci\00F3n de la aplicaci\00F3n mediante al acceso a la secci\00F3n Administraci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>',
unistr('<p>Al editar un usuario existente, puede bloquear su cuenta, lo que evitar\00E1 que accedan a la aplicaci\00F3n.</p>'),
unistr('<p><em><strong>Nota:</strong> Si utiliza cuentas de Oracle Application Express, el administrador del espacio de trabajo tambi\00E9n debe definir a los usuarios introducidos aqu\00ED como usuarios finales, cuyas contrase\00F1as tambi\00E9n puede definir.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100785569581305157)
,p_name=>'CA.HELP.P10110.ACCESS.CONTROL.USERS.REPORT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En esta p\00E1gina se muestra un informe de los usuarios de la aplicaci\00F3n y el nivel de acceso otorgado.</p>'),
unistr('<p>Haga clic en las cabeceras de columna para ordenar y filtrar los datos, o bien haga clic en el bot\00F3n <strong>Acciones</strong> para personalizar la visualizaci\00F3n de columnas y otras muchas funciones avanzadas.<br>'),
unistr('Haga clic en el bot\00F3n <strong>Restablecer</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>'),
unistr('<p>Haga clic en el icono de edici\00F3n (l\00E1piz de color amarillo) para editar los detalles y el nivel de acceso del usuario, o bien para suprimir el usuario.</p>'),
'<p>Haga clic en <strong>Agregar usuario</strong>, en la parte superior del informe, para agregar un nuevo usuario y su nivel de acceso.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100799058880305167)
,p_name=>'CA.HELP.P10120.ACCESS.ROLE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cuando el control de acceso est\00E1 activado, los administradores pueden restringir el acceso a determinadas funciones de la aplicaci\00F3n para los usuarios autenticados. Esta aplicaci\00F3n soporta los tres roles siguientes: Lector, Contribuyente y Adminis')
||'trador.</p>',
'<ul>',
unistr('  <li>Los <strong>lectores</strong> tienen acceso de solo lectura a toda la informaci\00F3n y tambi\00E9n pueden ver informes.</li>'),
unistr('  <li>Los <strong>contribuyentes</strong> pueden crear, editar y suprimir informaci\00F3n y ver informes.</li>'),
unistr('  <li>Los <strong>administradores</strong>, adem\00E1s de la capacidad de los contribuyentes, pueden realizar la configuraci\00F3n de la aplicaci\00F3n.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100819919787305183)
,p_name=>'CA.HELP.P10140_PRELIM_USERS'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca los nombres de usuario separados por comas, puntos y comas o espacios en blanco. Los nombres de usuario duplicados o existentes se ignorar\00E1n autom\00E1ticamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100784406897305156)
,p_name=>'CA.HELP.P10200.CONFIGURATION.SETTINGS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los valores de configuraci\00F3n permiten hacer que una funcionalidad espec\00EDfica est\00E9 disponible (activada) o no disponible (desactivada) para los usuarios finales.</p>'),
unistr('<p>Si una funci\00F3n concreta no est\00E1 100% lista o se tiene que eliminar temporalmente, haga clic en <strong>Desactivado</strong>.'),
'Para que vuelva a estar disponible, solo tiene que hacer clic en <strong>Activado</strong>.</p>',
unistr('<p><em><strong>Nota:</strong> Los usuarios finales que est\00E9n ejecutando actualmente la aplicaci\00F3n no ver\00E1n reflejados los cambios que se realicen aqu\00ED. La configuraci\00F3n de funciones revisada se mostrar\00E1 una vez que el usuario se haya desconectado y s')
||'e vuelva a conectar.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100784545865305157)
,p_name=>'CA.HELP.P10300.THEME.SELECTOR'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el esquema de color por defecto que se utiliza para mostrar la aplicaci\00F3n.</p>'),
unistr('<p>Si la opci\00F3n <strong>Permitir a los usuarios finales seleccionar el estilo de tema</strong> est\00E1 activada, los usuarios finales podr\00E1n seleccionar uno de los estilos de tema disponibles haciendo clic en el enlace <em>Personalizar</em> de la esquin')
||unistr('a inferior izquierda de la p\00E1gina inicial.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100785135689305157)
,p_name=>'CA.HELP.P10400.ACTIVITY.REPORTING.ERROR.LOG'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En esta p\00E1gina se proporciona un informe interactivo de todos los errores inesperados que haya registrado esta aplicaci\00F3n.</p>'),
unistr('<p>Haga clic en las cabeceras de columna para ordenar y filtrar los datos, o bien haga clic en el bot\00F3n <strong>Acciones</strong> para personalizar la visualizaci\00F3n de columnas y otras muchas funciones avanzadas. Haga clic en el bot\00F3n <strong>Restabl')
||unistr('ecer</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100785066057305157)
,p_name=>'CA.HELP.P10500.ACTIVITY.REPORTING.TOP.USERS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este informe y gr\00E1fico para ver qui\00E9nes son los usuarios con m\00E1s vistas de p\00E1gina durante el marco temporal especificado.</p>'),
unistr('<p>Seleccione el marco temporal del informe (Valor por defecto = 1 d\00EDa) y seleccione entre los iconos de informe y gr\00E1fico en la parte superior de la p\00E1gina.</p>'),
unistr('<p>Para el informe interactivo, utilice el campo de b\00FAsqueda o seleccione la cabecera de columna <strong>Usuario</strong> para seleccionar un usuario espec\00EDfico. Puede realizar muchas funciones con el bot\00F3n <strong>Acciones</strong>, como mostrar u o')
||unistr('cultar columnas, especificar las filas por p\00E1gina, filtrar, etc. Haga clic en el bot\00F3n <strong>Restablecer</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100785257160305157)
,p_name=>'CA.HELP.P10510.ACTIVITY.REPORTING.PERFORMANCE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En esta p\00E1gina se proporciona un informe interactivo del rendimiento y la popularidad de la p\00E1gina. El informe se ordena por <strong>Rendimiento ponderado</strong>, que se calcula multiplicando el tiempo de mediana transcurrido y el n\00FAmero de vist')
||unistr('as de p\00E1gina.</p>'),
unistr('<p>Seleccione el marco temporal del informe (valor por defecto = 1 d\00EDa) en la parte superior de la p\00E1gina seg\00FAn sea necesario.<br>'),
unistr('Haga clic en las cabeceras de columna para ordenar y filtrar los datos, o bien haga clic en el bot\00F3n <strong>Acciones</strong> para personalizar la visualizaci\00F3n de columnas y otras muchas funciones avanzadas. Haga clic en el bot\00F3n <strong>Restablece')
||unistr('r</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100785312915305157)
,p_name=>'CA.HELP.P10520.ACTIVITY.REPORTING.VIEWS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En esta p\00E1gina se proporciona un informe interactivo de las vistas de p\00E1gina m\00E1s recientes.</p>'),
unistr('<p>Seleccione el marco temporal del informe (valor por defecto = 1 d\00EDa) en la parte superior de la p\00E1gina seg\00FAn sea necesario.<br>'),
unistr('Haga clic en las cabeceras de columna para ordenar y filtrar los datos, o bien haga clic en el bot\00F3n <strong>Acciones</strong> para personalizar la visualizaci\00F3n de columnas y otras muchas funciones avanzadas. Haga clic en el bot\00F3n <strong>Restablece')
||unistr('r</strong> para restablecer la configuraci\00F3n por defecto del informe interactivo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100784384765305156)
,p_name=>'CA.HELP.P10600.NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las notificaciones se muestran en la p\00E1gina inicial si est\00E1n activas.</p>'),
unistr('<p>En este informe se muestran las notificaciones definidas y el per\00EDodo de tiempo en que se muestran.</p>'),
unistr('<p>Haga clic en el icono de edici\00F3n (l\00E1piz de color amarillo) para editar una notificaci\00F3n existente o haga clic en <strong>Agregar notificaci\00F3n</strong> para insertar una nueva notificaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100784654464305157)
,p_name=>'CA.HELP.P10700.APPLICATION.SETTINGS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la aplicaci\00F3n y una descripci\00F3n breve.</p>'),
unistr('<p>El nombre de la aplicaci\00F3n aparece en la p\00E1gina inicial. La descripci\00F3n breve aparece debajo del nombre de la aplicaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100784807945305157)
,p_name=>'CA.HELP.P10920.FEEDBACK.REPORT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los usuarios finales pueden introducir comentarios en cualquier p\00E1gina normal de la aplicaci\00F3n.</p>'),
'<p>En este informe se muestran los comentarios introducidos, las respuestas que hayan introducido los administradores y el estado de los comentarios.</p>',
unistr('<p>Haga clic en el icono de edici\00F3n (l\00E1piz de color amarillo) para introducir una respuesta o actualizar el estado de los comentarios.</p>'),
unistr('<p><em><strong>Nota:</strong> Si se han definido los destinatarios de los comentarios, tambi\00E9n se mandar\00E1n por correo electr\00F3nico los env\00EDos de comentarios a las direcciones de correo electr\00F3nico de la lista de destinatarios de comentarios.</em></p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100800916859305169)
,p_name=>'CA.HELP.P10940.COMMA.SEP.EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Proporcione una lista separada por comas de las direcciones de correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100784921982305157)
,p_name=>'CA.HELP.P10940.FEEDBACK.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('<p><strong>Activar anexos</strong>: si se define esta opci\00F3n, los usuarios podr\00E1n cargar anexos complementarios a sus comentarios.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100785926568305158)
,p_name=>'CA.HELP.P11000.EMAIL.TEMPLATES.REPORT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta p\00E1gina muestra las plantillas de correo electr\00F3nico definidas y cu\00E1ntas veces se ha hecho referencia a la plantilla en los correos electr\00F3nicos enviados.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100785799392305157)
,p_name=>'CA.HELP.P11010.EMAIL.LOG'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>En esta p\00E1gina se muestran las plantillas de correo electr\00F3nico enviadas.</p>'),
unistr('<p>Haga clic en el icono de lupa para ver m\00E1s detalles en los mensajes enviados.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100785896240305158)
,p_name=>'CA.HELP.P11020.EMAIL.TEMPLATES.FORM.EDIT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca los siguientes campos para definir una plantilla de correo electr\00F3nico:</p>'),
'<ul>',
'  <li><strong>Nombre de plantilla</strong> (obligatorio): introduzca un nombre significativo para la plantilla.</li>',
unistr('  <li><strong>Plantilla HTML</strong> (obligatorio): introduzca el c\00F3digo HTML utilizado para crear el correo electr\00F3nico enviado a los destinatarios que permiten la entrega de correos electr\00F3nicos basados en HTML.'),
unistr('    Los valores de sustituci\00F3n incluyen:'),
'    <ul>',
unistr('        <li><strong>#APP_NAME#</strong>: se sustituir\00E1 por el nombre de la aplicaci\00F3n</li>'),
unistr('        <li><strong>#BODY1#</strong>: se sustituir\00E1 por el valor transferido como p_body1_text</li> '),
unistr('        <li><strong>#TABLE#</strong>: se sustituir\00E1 por el valor transferido como p_table_content, utilizando HTML abierto de tabla, HTML abierto de fila y HTML cerrado de tabla</li> '),
unistr('        <li><strong>#BODY2#</strong>: se sustituir\00E1 por el valor transferido como p_body2_text</li> '),
unistr('        <li><strong>#ACTION#</strong>: se sustituir\00E1 por el valor transferido como p_action_label y p_action_link, utilizando la plantilla Enlace de acci\00F3n</li>'),
'     </ul></li>',
unistr('  <li><strong>Plantilla de texto sin formato</strong> (obligatorio): introduzca el texto sin formato utilizado para crear el correo electr\00F3nico enviado a los destinatarios que no aceptan correos electr\00F3nicos basados en HTML. Utiliza las mismas sustit')
||unistr('uciones que la plantilla HTML, excepto #TABLE# y #ACTION#, que se presentar\00E1n como texto sin formato.</li>'),
'<ul>',
unistr('<p>Las plantillas HTML adicionales permiten correos electr\00F3nicos m\00E1s avanzados. Estos elementos incluyen:</p>'),
'<ul>',
'  <li><strong>Antes de filas</strong>: introduzca HTML para sustituir #TABLE# en la plantilla HTML. Solo se utiliza si se transfiere p_table_content.</li>',
'  <li><strong>Plantilla de fila</strong>: introduzca HTML para presentar cada fila de la tabla. Esto incluye la apertura/cierre de la fila y la apertura/cierre de los datos mediante las sustituciones #LABEL# y #VALUE#.    Solo se utiliza si se transf'
||'iere p_table_content.</li>',
unistr('  <li><strong>Despu\00E9s de filas</strong>: introduzca HTML para cerrar la tabla o divisi\00F3n. Solo se utiliza si se transfiere p_table_content.</li>'),
unistr('  <li><strong>HTML de enlace de acci\00F3n</strong>: introduzca HTML para sustituir #ACTION# en la plantilla HTML. Debe contener #ACTION_LINK# y #ACTION_TEXT#. Solo se utiliza si se transfieren p_action_label y p_action_link.</li>'),
'</ul>',
unistr('<p><em><strong>Nota:</strong> utilice las entradas de la <strong>plantilla por defecto</strong> como un ejemplo para desarrollar su propia plantilla. La plantilla por defecto utiliza todas las variables de sustituci\00F3n que puede o no incluir en su pro')
||unistr('pia plantilla de correo electr\00F3nico.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100786057374305158)
,p_name=>'CA.HELP.P11030.EMAIL.SETTINGS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Active o desactive el env\00EDo de correos electr\00F3nicos seleccionando una de las opciones de <strong>Distribuir correos electr\00F3nicos</strong>.</p>'),
unistr('<p>Introduzca la informaci\00F3n en <strong>Correos electr\00F3nicos enviados desde</strong> utilizando la direcci\00F3n de correo electr\00F3nico del contacto principal para los problemas de la aplicaci\00F3n. Este valor se puede utilizar o sobrescribir al utilizar la ')
||unistr('funci\00F3n de correo electr\00F3nico.</p>'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100804288926305171)
,p_name=>'CA.HELP.P11030.EMAILS.FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n que se utilizar\00E1 para enviar correos electr\00F3nicos. Se puede sobrescribir al utilizar la funci\00F3n de correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100821504049305184)
,p_name=>'CA.HELP.P11060.SEND.EMAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Rellene los siguientes elementos y haga clic en [Enviar correo electr\00F3nico]. Todos los correos electr\00F3nicos enviados se registrar\00E1n en el log de correo electr\00F3nico.'),
'    <ul>',
unistr('        <li><strong>De</strong>: si se define una "Direcci\00F3n de origen" en Configuraci\00F3n de correo electr\00F3nico, esa direcci\00F3n de correo electr\00F3nico ser\00E1 una opci\00F3n desde la que enviar el correo. Si la aplicaci\00F3n utiliza Direcciones de correo electr\00F3n')
||unistr('ico como nombre de usuario, puede enviar correos electr\00F3nicos desde su correo electr\00F3nico.  Por \00FAltimo, Enviar desde y Enviar a pueden ser la misma direcci\00F3n.</li>'),
unistr('        <li><strong>Enviar a</strong>: si la aplicaci\00F3n utiliza Direcciones de correo electr\00F3nico como nombre de usuario, puede enviar correos electr\00F3nicos a Direcciones de correo electr\00F3nico o a Usuarios.</li>'),
unistr('        <li><strong>Direcciones de correo electr\00F3nico</strong>: lista separada por comas de direcciones de correo electr\00F3nico que recibir\00E1n el correo electr\00F3nico. No se incluir\00E1n las direcciones no v\00E1lidas.</li>'),
unistr('        <li><strong>Rol</strong>: enviar correo electr\00F3nico a todos los usuarios de un rol seleccionado o a todos los usuarios definidos. La lista de selecci\00F3n incluye una lista de roles y el recuento de usuarios con ese rol.</li>'),
unistr('        <li><strong>Plantilla</strong>: seleccione la plantilla de correo electr\00F3nico que se va a utilizar para crear el cuerpo del correo electr\00F3nico.</li>'),
unistr('        <li><strong>Asunto</strong>: asunto del correo electr\00F3nico.</li>'),
unistr('        <li><strong>Cuerpo del correo electr\00F3nico</strong>: texto que se va a incluir como el cuerpo del correo electr\00F3nico.</li>'),
unistr('        <li><strong>Permitir exclusi\00F3n</strong>: algunos correos electr\00F3nicos se deben enviar, independientemente del usuario excluido para recibir correos electr\00F3nicos. Se incluyen los mensajes de interrupci\00F3n, entre otros. Este indicador identifica')
||unistr(' si este correo electr\00F3nico se debe excluir o si se debe enviar independientemente de las preferencias del usuario.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100823280587305185)
,p_name=>'CA.HELP.P11060.SEND.EMAIL.NO.ACL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Rellene los siguientes elementos y haga clic en [Enviar correo electr\00F3nico]. Todos los correos electr\00F3nicos enviados se registrar\00E1n en el log de correo electr\00F3nico.'),
'    <ul>',
unistr('        <li><strong>De</strong>: si se define una "Direcci\00F3n de correo electr\00F3nico de origen" en Configuraci\00F3n de correo electr\00F3nico, esa direcci\00F3n de correo electr\00F3nico ser\00E1 una opci\00F3n desde la que enviar el correo. De lo contrario, Enviar de siempr')
||'e puede ser igual a Enviar a.</li>',
unistr('        <li><strong>Direcciones de correo electr\00F3nico</strong>: lista separada por comas de direcciones de correo electr\00F3nico que recibir\00E1n el correo electr\00F3nico. No se incluir\00E1n las direcciones no v\00E1lidas.</li>'),
unistr('        <li><strong>Plantilla</strong>: seleccione la plantilla de correo electr\00F3nico que se va a utilizar para crear el cuerpo del correo electr\00F3nico.</li>'),
unistr('        <li><strong>Asunto</strong>: asunto del correo electr\00F3nico.</li>'),
unistr('        <li><strong>Cuerpo del correo electr\00F3nico</strong>: texto que se va a incluir como el cuerpo del correo electr\00F3nico.</li>'),
unistr('        <li><strong>Permitir exclusi\00F3n</strong>: algunos correos electr\00F3nicos se deben enviar, independientemente del usuario excluido para recibir correos electr\00F3nicos. Se incluyen los mensajes de interrupci\00F3n, etc. Este indicador identifica si este')
||unistr(' correo electr\00F3nico se debe excluir o si se debe enviar independientemente de las preferencias del usuario.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100784787789305157)
,p_name=>'CA.HELP.P12000.TIME.ZONE.SUPPORT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la zona horaria por defecto para todos los usuarios de esta aplicaci\00F3n.</p>'),
unistr('<p>Los distintos usuarios pueden sustituir este valor haciendo clic en su nombre de usuario (parte superior derecha) y seleccionando <strong>Preferencias</strong>. Tambi\00E9n pueden hacer clic en el enlace de zona horaria que aparece en la parte inferio')
||unistr('r de la p\00E1gina inicial.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100800608333305169)
,p_name=>'CA.HELP.P2000.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>unistr('A esta p\00E1gina no se puede acceder directamente mediante la interfaz de usuario. Se utiliza para facilitar la descarga de la fotograf\00EDa de perfil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100800375504305168)
,p_name=>'CA.HELP.P20000.USER.PROFILE'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina Perfil de usuario permite ver la informaci\00F3n relevante sobre un usuario en una pantalla f\00E1cil de utilizar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100800068118305168)
,p_name=>'CA.HELP.P20030.PHOTO.UPLOAD'
,p_message_language=>'es'
,p_message_text=>unistr('Cargue una fotograf\00EDa con un ratio de aspecto de cuadrado ya que, de no ser as\00ED, puede que aparezca distorsionada. El tama\00F1o de imagen recomendado es de 250 x 250 p\00EDxeles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100786154751305158)
,p_name=>'CA.HELP.P20200.USER.PROFILE.MODAL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta pantalla \00A1le permite actualizar su informaci\00F3n personal y cargar una fotograf\00EDa o un avatar.</p>'),
unistr('<p>Para cargar una imagen, haga clic en <strong>Examinar</strong> o arrastre y suelte la imagen sobre el bot\00F3n.<br>'),
unistr('Cargue una fotograf\00EDa con un ratio de aspecto de cuadrado ya que, de no ser as\00ED, puede que aparezca distorsionada. El tama\00F1o de imagen recomendado es de 250 x 250 p\00EDxeles.</p>'),
'<p>Haga clic en <strong>Suprimir foto</strong> para eliminar la imagen.</p>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100806223680305173)
,p_name=>'CA.HELP.P20210.ABOUT'
,p_message_language=>'es'
,p_message_text=>unistr('Desde esta p\00E1gina se puede acceder a todo el texto de ayuda de la aplicaci\00F3n. Los enlaces de la regi\00F3n "Documentaci\00F3n" ofrecen una explicaci\00F3n mucho m\00E1s detallada de las funciones y la funcionalidad de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100787225783305159)
,p_name=>'CA.HELP.P20400.APP.PREF'
,p_message_language=>'es'
,p_message_text=>unistr('Puede definir las preferencias de la aplicaci\00F3n de su cuenta en esta p\00E1gina. Las preferencias pueden afectar a varios aspectos de la aplicaci\00F3n como la zona horaria. Haga clic en los iconos de ayuda de nivel de elemento para saber qu\00E9 funci\00F3n realiza')
||' cada preferencia.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99890034909304440)
,p_name=>'CA.HELP.P20500.EMAIL.REPORTING'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Este informe muestra todos los correos electr\00F3nicos que esperan en cola a ser enviados, as\00ED como los que ya se han enviado.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100011549533304533)
,p_name=>'CA.HELP.P20600.JOB.REPORTING'
,p_message_language=>'es'
,p_message_text=>unistr('<p>En este informe se incluyen todos los trabajos seleccionados que va a supervisar esta aplicaci\00F3n. Para obtener m\00E1s informaci\00F3n sobre cada trabajo, haga clic en el nombre del trabajo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100018150591304538)
,p_name=>'CA.HELP.P20610.JOB.RUN.DETAILS'
,p_message_language=>'es'
,p_message_text=>unistr('<p>En este informe se incluyen los detalles de ejecuci\00F3n sobre los trabajos seleccionados que va a supervisar esta aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100771514798305147)
,p_name=>'CA.HELP.PAGE.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina Acerca de esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100787962980305159)
,p_name=>'CA.HELP.RECEIVE.EMAILS'
,p_message_language=>'es'
,p_message_text=>unistr('Defina esta opci\00F3n en No si no desea recibir mensajes de correo electr\00F3nico de esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100821069797305184)
,p_name=>'CA.HELP.SEARCH.PAGE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un t\00E9rmino de b\00FAsqueda en el cuadro de di\00E1logo de b\00FAsqueda y haga clic en <strong>Buscar</strong>.<br>'),
unistr('Haga clic en cualquiera de las cabeceras de resultados para navegar a ese registro espec\00EDfico.</p>'),
unistr('<p>Para limitar la b\00FAsqueda, desactive uno o m\00E1s or\00EDgenes, eliminando as\00ED ese informe de los resultados de la b\00FAsqueda</p>'),
unistr('<p>Haga clic en <strong>Restablecer</strong> para eliminar el t\00E9rmino de b\00FAsqueda actual y comprobar  todos los or\00EDgenes</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100787742737305159)
,p_name=>'CA.HELP.TIME.ZONE'
,p_message_language=>'es'
,p_message_text=>unistr('Defina la zona horaria que prefiera utilizar en toda la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99785930761304356)
,p_name=>'CA.HIDDEN.ITEMS'
,p_message_language=>'es'
,p_message_text=>'Elementos Ocultos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100807869410305174)
,p_name=>'CA.HOME'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100813969275305178)
,p_name=>'CA.HOME.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100829242434305190)
,p_name=>'CA.HOURLY.PAGE.EVENTS'
,p_message_language=>'es'
,p_message_text=>unistr('Eventos de p\00E1gina por hora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99889102570304439)
,p_name=>'CA.HTML.BODY.SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de cuerpo HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100804680997305172)
,p_name=>'CA.HTML.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100801327501305169)
,p_name=>'CA.IN.PROGRESS'
,p_message_language=>'es'
,p_message_text=>'En Curso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100825498078305187)
,p_name=>'CA.INCLUDEONFORMS'
,p_message_language=>'es'
,p_message_text=>'Incluir en formularios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100825302216305187)
,p_name=>'CA.INCLUDEONREPORTS'
,p_message_language=>'es'
,p_message_text=>'Incluir en informes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100810023128305176)
,p_name=>'CA.INSTALL.SUP.OBJ.SCRIPTS'
,p_message_language=>'es'
,p_message_text=>'Instalando scripts de objetos de soporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100012272092304534)
,p_name=>'CA.INSTANCE.ID'
,p_message_language=>'es'
,p_message_text=>'Identificador de Instancia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100013468683304535)
,p_name=>'CA.INSTANCE.STICKINESS'
,p_message_language=>'es'
,p_message_text=>'Persistencia de Instancia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100783705075305156)
,p_name=>'CA.INTRO.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Bienvenido a esta versi\00F3n preliminar solo para la nube de un nuevo m\00E9todo mejorado que permite crear una aplicaci\00F3n m\00E1s completa. El asistente de creaci\00F3n de aplicaciones est\00E1ndar solo permite seleccionar p\00E1ginas para generar, mientras que este as')
||unistr('istente tambi\00E9n permite cargar previamente una serie de funciones adicionales en la aplicaci\00F3n.</p>'),
unistr('<p>Las aplicaciones generadas con este asistente estar\00E1n totalmente soportadas y tambi\00E9n pueden incluir objetos de soporte para las funciones seleccionadas, como Control de acceso, Marco de correo electr\00F3nico, Comentarios, etc.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100783983586305156)
,p_name=>'CA.INTRO.HOWTO.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para empezar, introduzca un nombre de aplicaci\00F3n. A continuaci\00F3n, agregue una o m\00E1s p\00E1ginas a la misma. Compruebe las funciones que desee incluir. Realice las selecciones del aspecto de la aplicaci\00F3n y, a continuaci\00F3n, revise la configuraci\00F3n.<br>'),
unistr('Eso es todo. Solo tiene que hacer clic en <strong>Crear aplicaci\00F3n</strong>.</p>'),
unistr('<p>Haga clic en <strong>Ver plan detallado</strong> para reutilizar el modelo de una aplicaci\00F3n generada anteriormente o para replicar p\00E1ginas r\00E1pidamente.</p>'),
unistr('<p><em><strong>Nota:</strong> cada secci\00F3n y cada opci\00F3n ''Agregar p\00E1gina'' incluye ayuda detallada que le ayudar\00E1 m\00E1s adelante.</em></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100783828340305156)
,p_name=>'CA.INTRO.HOWTO.TITLE'
,p_message_language=>'es'
,p_message_text=>'Uso de este asistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100817495645305181)
,p_name=>'CA.INTRO.KNOWN.ISSUES.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los problemas significativos de la versi\00F3n en el momento de su lanzamiento son los siguientes:'),
'<ol>',
unistr('  <li>El Asistente de creaci\00F3n de aplicaciones desde el plan detallado no est\00E1 traducido.</li>'),
unistr('  <li>Las aplicaciones traducidas generadas con este asistente solo est\00E1n traducidas parcialmente.</li>'),
'  <li>Aumentar detalle en el informe solo permite una columna de aumento de detalle.</li>',
unistr('  <li>No se pueden generar p\00E1ginas de informe de filtro.</li>'),
unistr('  <li>La funci\00F3n de correo electr\00F3nico proporciona la API de nivel bajo, pero a\00FAn no incluye funciones de correo electr\00F3nico de nivel superior.</li>'),
unistr('  <li>La generaci\00F3n de una aplicaci\00F3n desde un plan detallado que hace referencia a tablas que faltan ser\00E1 incorrecta.</li>'),
unistr('  <li>Configuraci\00F3n avanzada: los formatos de fecha no se aplican a la aplicaci\00F3n generada.</li>'),
'</ol>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100817356000305181)
,p_name=>'CA.INTRO.KNOWN.ISSUES.TITLE'
,p_message_language=>'es'
,p_message_text=>'Problemas conocidos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100784166488305156)
,p_name=>'CA.INTRO.RELEASE.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Publicada %0.</p>',
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100784025662305156)
,p_name=>'CA.INTRO.RELEASE.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Detalles de versi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100783638221305156)
,p_name=>'CA.INTRO.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Creaci\00F3n de aplicaciones desde el Asistente de planes detallados {Vista previa solo de Cloud}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100795274437305165)
,p_name=>'CA.IP.ADDRESS'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n IP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100793400971305163)
,p_name=>'CA.IR.SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsqueda de IR')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100796407071305165)
,p_name=>'CA.IR.SEARCHES'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsquedas de IR')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100823844268305186)
,p_name=>'CA.ITEMNAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100016267976304537)
,p_name=>'CA.JOB.ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n del Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100017725338304538)
,p_name=>'CA.JOB.CLASS'
,p_message_language=>'es'
,p_message_text=>'Clase de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100016810018304537)
,p_name=>'CA.JOB.CREATOR'
,p_message_language=>'es'
,p_message_text=>'Creador del Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100017904901304538)
,p_name=>'CA.JOB.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100014456228304535)
,p_name=>'CA.JOB.PRIORITY'
,p_message_language=>'es'
,p_message_text=>'Prioridad del Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100011469893304533)
,p_name=>'CA.JOB.REPORTING'
,p_message_language=>'es'
,p_message_text=>'Informes de trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100051528400304563)
,p_name=>'CA.JOB.REPORTING.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Ver estado y detalles de ejecuci\00F3n de los trabajos que soportan esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100018047768304538)
,p_name=>'CA.JOB.RUN.DETAILS'
,p_message_language=>'es'
,p_message_text=>unistr('Detalles de Ejecuci\00F3n de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100016918111304537)
,p_name=>'CA.JOB.STYLE'
,p_message_language=>'es'
,p_message_text=>'Estilo del Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100017022680304537)
,p_name=>'CA.JOB.SUBNAME'
,p_message_language=>'es'
,p_message_text=>'Subnombre del Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100016310750304537)
,p_name=>'CA.JOB.TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100013079637304534)
,p_name=>'CA.JOB.WEIGHT'
,p_message_language=>'es'
,p_message_text=>'Peso del Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100824368932305186)
,p_name=>'CA.KEYCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de Claves'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100826154498305188)
,p_name=>'CA.LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100824669701305186)
,p_name=>'CA.LABELCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de etiquetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100826326479305188)
,p_name=>'CA.LABELPLURAL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta: Plural'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100826027851305188)
,p_name=>'CA.LABELSINGULAR'
,p_message_language=>'es'
,p_message_text=>'Etiqueta: Singular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100782875136305155)
,p_name=>'CA.LANGUAGE'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100782936091305155)
,p_name=>'CA.LANGUAGE.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el idioma principal para esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100816829210305181)
,p_name=>'CA.LANGUAGE.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('<p>El idioma principal indica el idioma que se utiliza para mostrar las p\00E1ginas y componentes generados en el Creador de aplicaciones. La selecci\00F3n de varias traducciones proporcionar\00E1 opciones para los usuarios finales como qu\00E9 idioma utiliza la apl')
||unistr('icaci\00F3n que se presenta en tiempo de ejecuci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100149266039304677)
,p_name=>'CA.LANGUAGE_SELECTOR'
,p_message_language=>'es'
,p_message_text=>'Selector de Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100799828092305168)
,p_name=>'CA.LAST.NAME'
,p_message_language=>'es'
,p_message_text=>'Apellido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100017171436304537)
,p_name=>'CA.LAST.RUN.DURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Duraci\00F3n de \00DAltima Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100017260856304538)
,p_name=>'CA.LAST.START.DATE'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima Fecha de Inicio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100829696661305190)
,p_name=>'CA.LATEST.ACTIVITY'
,p_message_language=>'es'
,p_message_text=>unistr('Actividad m\00E1s reciente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100825553504305187)
,p_name=>'CA.LISTOFVALUES'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100820982609305184)
,p_name=>'CA.LOAD.BLUEPRINT'
,p_message_language=>'es'
,p_message_text=>'Cargar plan detallado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100019558564304539)
,p_name=>'CA.LOG.DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha de Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100019675341304539)
,p_name=>'CA.LOG.ID'
,p_message_language=>'es'
,p_message_text=>'Identificador de Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100013795835304535)
,p_name=>'CA.LOGGING.LEVEL'
,p_message_language=>'es'
,p_message_text=>'Nivel de Registro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100696911454305091)
,p_name=>'CA.LOG_MESSAGES'
,p_message_language=>'es'
,p_message_text=>'Mensajes de Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99787191170304356)
,p_name=>'CA.LOOKUP.COLUMNS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&nbsp;<br>',
'<ul>',
unistr(' <li><strong>Columnas de consulta</strong>: ampl\00EDe para ver los atributos para definir una consulta de otra tabla. Utilice las columnas de consulta para sustituir los identificadores por una columna de visualizaci\00F3n (por ejemplo, puede mostrar el nom')
||unistr('bre de departamento en lugar del n\00FAmero de departamento).<br>'),
unistr('<em><strong>Nota:</strong>: Las columnas de consulta solo aparecen si la p\00E1gina actual se basa en una tabla o vista y tiene restricciones de clave ajena en otra tabla.'),
'  <ul>',
unistr('    <li><strong>Clave de consulta</strong>: seleccione la columna que desea modificar para que muestre la columna de visualizaci\00F3n.</li>'),
unistr('    <li><strong>Columna de visualizaci\00F3n</strong>: seleccione la columna (de la tabla de consulta) que desea que se muestre.</li>'),
'    &nbsp;<br>',
'    <em><strong>Nota:</strong>: Seleccione solo las columnas que hagan referencia a otra tabla (con una clave ajena).</em></li>',
'  </ul>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100803809365305171)
,p_name=>'CA.MANAGE.EMAIL.TEMPLATES'
,p_message_language=>'es'
,p_message_text=>unistr('Gestionar plantillas de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100801872146305169)
,p_name=>'CA.MANAGE.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Gestionar Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100797988650305167)
,p_name=>'CA.MANAGE.USER.ACCESS'
,p_message_language=>'es'
,p_message_text=>'Gestionar acceso de usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100830263597305191)
,p_name=>'CA.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina maestro/detalle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100830374129305191)
,p_name=>'CA.MASTER.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cree una p\00E1gina que muestre una p\00E1gina maestro-detalle que permita a los usuarios finales mantener los datos.<br>'),
'&nbsp;</p>',
'<p>Introduzca los siguientes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nombre de la p\00E1gina</strong> (obligatorio): introduzca un nombre para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir icono</strong>: seleccione el icono que se mostrar\00E1 en el men\00FA de navegaci\00F3n de esta p\00E1gina.</li>'),
unistr('  <li><strong>Tipo de p\00E1gina</strong>: seleccione el tipo de p\00E1gina [En paralelo, Apilado].<br>'),
'    <strong>En paralelo</strong>: <br>',
unistr('<em>Una \00FAnica p\00E1gina maestro-detalle que utiliza dise\00F1o en paralelo y regiones de informe con ventanas de edici\00F3n modal.</em>'),
'    <ul>',
unistr('      <li><strong>Tabla</strong> (obligatorio): seleccione la tabla maestra para la p\00E1gina.</li>'),
unistr('      <li><strong>Columna de visualizaci\00F3n primaria</strong> (obligatorio): seleccione la columna que desea mostrar en la lista de registros maestros.</li>'),
unistr('      <li><strong>Columna de visualizaci\00F3n secundaria</strong> (obligatorio): seleccione la columna que desea mostrar en la lista de registros maestros, en Columna de visualizaci\00F3n primaria.</li>.</li>'),
unistr('      <li><strong>Tabla de detalle 1</strong> (obligatorio): seleccione la primera tabla de detalle para la p\00E1gina.</li>'),
unistr('      <li><strong>Tabla de detalle 2</strong>: seleccione la segunda tabla de detalle para la p\00E1gina.</li>'),
unistr('      <li><strong>Tabla de detalle 3</strong>: seleccione la tercera tabla de detalle para la p\00E1gina.</li>'),
unistr('      <li><strong>Tabla de detalle 4</strong>: seleccione la cuarta tabla de detalle para la p\00E1gina.</li>'),
'    </ul>',
'   <strong>Apilado</strong>: <br>',
unistr('<em>Una \00FAnica p\00E1gina maestro-detalle que utiliza cuadr\00EDculas interactivas editables.</em>'),
'    <ul>',
unistr('      <li><strong>Tabla</strong> (obligatorio): seleccione la tabla maestra para la cuadr\00EDcula interactiva editable.</li>'),
unistr('      <li><strong>Tabla de detalles</strong> (obligatorio): seleccione la tabla de detalles para la p\00E1gina.</li>'),
unistr('      <em><strong>Nota:</strong> Solo se puede agregar una tabla de detalles (cuadr\00EDcula interactiva editable) con el asistente. Tras la generaci\00F3n, se pueden agregar m\00E1s tablas de detalles f\00E1cilmente.</em>'),
'    </ul>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100149177181304677)
,p_name=>'CA.MASTER_RECORDS'
,p_message_language=>'es'
,p_message_text=>'Registros maestros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100794180352305164)
,p_name=>'CA.MAX.ELAPSED'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo transcurrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100014283196304535)
,p_name=>'CA.MAX.FAILURES'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo de Fallos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100013850704304535)
,p_name=>'CA.MAX.RUN.DURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Duraci\00F3n m\00E1xima de ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100014364839304535)
,p_name=>'CA.MAX.RUNS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo de Ejecuciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100824531879305186)
,p_name=>'CA.MAXIMUMROWS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo de Filas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100827549400305189)
,p_name=>'CA.MAXIMUMWIDTH'
,p_message_language=>'es'
,p_message_text=>unistr('Ancho M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100818155557305182)
,p_name=>'CA.MD.ADD.FILTER'
,p_message_language=>'es'
,p_message_text=>'Agregar filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100818560468305182)
,p_name=>'CA.MD.ADD.ROW'
,p_message_language=>'es'
,p_message_text=>'Agregar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100818018581305182)
,p_name=>'CA.MD.APPLY.FILTERS'
,p_message_language=>'es'
,p_message_text=>'Aplicar Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100818936892305182)
,p_name=>'CA.MD.DATE.VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor de Fecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100819041215305182)
,p_name=>'CA.MD.DATE.VALUE.2'
,p_message_language=>'es'
,p_message_text=>'Valor de Fecha 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100818269197305182)
,p_name=>'CA.MD.EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100817632567305181)
,p_name=>'CA.MD.FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100817599192305181)
,p_name=>'CA.MD.FILTERS'
,p_message_language=>'es'
,p_message_text=>'Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100818682379305182)
,p_name=>'CA.MD.NO.FILTERS'
,p_message_language=>'es'
,p_message_text=>'Sin filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100817906601305181)
,p_name=>'CA.MD.NO.RECORD.SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha seleccionado ning\00FAn registro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100817862262305181)
,p_name=>'CA.MD.NO.RECORDS.FOUND'
,p_message_language=>'es'
,p_message_text=>'No se han encontrado registros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100818446486305182)
,p_name=>'CA.MD.ROWS.DELETED'
,p_message_language=>'es'
,p_message_text=>'%0 suprimido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100818368947305182)
,p_name=>'CA.MD.ROWS.UPDATED'
,p_message_language=>'es'
,p_message_text=>'%0 actualizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100817729083305181)
,p_name=>'CA.MD.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100818716210305182)
,p_name=>'CA.MD.VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100818807298305182)
,p_name=>'CA.MD.VALUE.2'
,p_message_language=>'es'
,p_message_text=>'Valor 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100793601205305163)
,p_name=>'CA.MEDIAN.ELAPSED'
,p_message_language=>'es'
,p_message_text=>'Mediana Transcurrida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100802722791305170)
,p_name=>'CA.MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Mensaje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100696700771305091)
,p_name=>'CA.MESSAGE_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Mensaje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100827080750305188)
,p_name=>'CA.METRIC'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9trica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100794550889305164)
,p_name=>'CA.MIN.ELAPSED'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo transcurrido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100797366230305166)
,p_name=>'CA.MOBILE.PHONE'
,p_message_language=>'es'
,p_message_text=>unistr('Tel\00E9fono m\00F3vil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100793128309305163)
,p_name=>'CA.MODE'
,p_message_language=>'es'
,p_message_text=>'Modo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100806924922305173)
,p_name=>'CA.MORE'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100796597253305165)
,p_name=>'CA.MOST RECENT'
,p_message_language=>'es'
,p_message_text=>'Most_Recent'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100829452184305190)
,p_name=>'CA.MOST.ACTIVE.PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas con Mayor Actividad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99787216173304356)
,p_name=>'CA.MULTIPLE.REPORTS'
,p_message_language=>'es'
,p_message_text=>'Informes varios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99787351890304357)
,p_name=>'CA.MULTIPLE.REPORTS.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Marque uno o m\00E1s nombres de tabla o vista. Tambi\00E9n puede hacer clic en la casilla de control de la cabecera para seleccionar o anular la selecci\00F3n de todos los objetos de base de datos mostrados.</p>'),
unistr('<p>Se agregar\00E1 una p\00E1gina con un informe interactivo para cada objeto de base de datos marcado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100790536546305161)
,p_name=>'CA.MUST.BE.VALID.TIMESTAMP'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser un registro de hora v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100826812213305188)
,p_name=>'CA.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100782030431305155)
,p_name=>'CA.NAVIGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100782113239305155)
,p_name=>'CA.NAVIGATION.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Seleccione si el men\00FA se muestra en el lateral de la aplicaci\00F3n o en la parte superior de la misma.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100833543640305193)
,p_name=>'CA.NEGATIVE'
,p_message_language=>'es'
,p_message_text=>'Negativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100833403715305193)
,p_name=>'CA.NEUTRAL'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100819513879305183)
,p_name=>'CA.NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100014069584304535)
,p_name=>'CA.NEXT.RUN.DATE'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de la Siguiente Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100012901923304534)
,p_name=>'CA.NLS.ENV'
,p_message_language=>'es'
,p_message_text=>'Entorno NLS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100101919830304603)
,p_name=>'CA.NO'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100801476985305169)
,p_name=>'CA.NO.ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100813024945305178)
,p_name=>'CA.NO.HELP.AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ayuda disponible para esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99786055319304356)
,p_name=>'CA.NO.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'es'
,p_message_text=>unistr('No existen usuarios v\00E1lidos - Informaci\00F3n de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100820565207305183)
,p_name=>'CA.NO.VALID.USER.FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se han encontrado usuarios nuevos no v\00E1lidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100816644908305180)
,p_name=>'CA.NONE'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100797673357305166)
,p_name=>'CA.NOTE'
,p_message_language=>'es'
,p_message_text=>'Nota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100773154722305148)
,p_name=>'CA.NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>'Notificaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100771990507305147)
,p_name=>'CA.NOTIFICATION.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar notificaciones en la p\00E1gina inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100773265403305148)
,p_name=>'CA.NOTIFICATION.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite a los administradores de la aplicaci\00F3n especificar alertas (amarillo) o errores (rojo) que se muestran a todos los usuarios finales en la p\00E1gina inicial de la aplicaci\00F3n. Esta funci\00F3n es \00FAtil para transmitir informaci\00F3n importante a su com')
||'unidad de usuarios finales.</p>',
'<p>Incluye los siguientes componentes:<ul>',
'<li>Capacidad de definir notificaciones</li>',
unistr('<li>Visualizaci\00F3n de notificaci\00F3n en la p\00E1gina inicial de la aplicaci\00F3n</li>'),
unistr('<li>Capacidad de controlar la ventana de tiempo de la visualizaci\00F3n de notificaciones</li>'),
unistr('<li>Soporte de codificaci\00F3n de color de notificaciones por tipo</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100789877008305160)
,p_name=>'CA.NOTIFICATION.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100793372014305163)
,p_name=>'CA.NUM.ROWS'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Filas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100016179536304537)
,p_name=>'CA.NUMBER.OF.ARGUMENTS'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de argumentos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100012716643304534)
,p_name=>'CA.NUMBER.OF.DESTINATIONS'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Destinos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100825009848305187)
,p_name=>'CA.NUMBERFORMATMASK'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara Formato Num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100794837382305164)
,p_name=>'CA.OCCURRENCE'
,p_message_language=>'es'
,p_message_text=>'Incidencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100833751531305193)
,p_name=>'CA.ONE.ADMIN.REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('No puede realizar esta acci\00F3n a menos que haya otro administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100801654114305169)
,p_name=>'CA.OPEN'
,p_message_language=>'es'
,p_message_text=>'Abrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100774639803305149)
,p_name=>'CA.ORGANIZING.PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Organizaci\00F3n de p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100774990937305149)
,p_name=>'CA.ORGANIZING.PAGES.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Organice las p\00E1ginas en el orden en el que desea que aparezcan en la aplicaci\00F3n. <br>'),
unistr('Para reordenar las p\00E1ginas en la lista, haga clic y pulse el icono <em>Arrastrar para reordenar p\00E1gina</em> ( <span class="fa fa-bars" aria-hidden="true"></span> ) al final de cada listado de p\00E1ginas y, a continuaci\00F3n, arrastre y suelte esa p\00E1gina ha')
||'cia arriba o hacia abajo.</p>',
unistr('<p>La p\00E1gina inicial siempre aparece primero y no se puede reordenar.<br>'),
unistr('Las p\00E1ginas administrativas siempre aparecen al final de la lista y el orden indicar\00E1 el orden en el que aparecen en la lista Administraci\00F3n de aplicaciones de la p\00E1gina Administraci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100018236066304538)
,p_name=>'CA.OUTPUT'
,p_message_language=>'es'
,p_message_text=>'Salida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100019400793304539)
,p_name=>'CA.OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100793024255305163)
,p_name=>'CA.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100796205633305165)
,p_name=>'CA.PAGE.EVENTS'
,p_message_language=>'es'
,p_message_text=>unistr('Eventos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100808744743305175)
,p_name=>'CA.PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Ayuda de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100795329116305165)
,p_name=>'CA.PAGE.ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100150992738304679)
,p_name=>'CA.PAGE.MD.EDIT_MASTER'
,p_message_language=>'es'
,p_message_text=>'Editar registro maestro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100151106154304679)
,p_name=>'CA.PAGE.MD.PERFORM_SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('Realizar B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100792628126305163)
,p_name=>'CA.PAGE.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100808015282305174)
,p_name=>'CA.PAGE.NAVIGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100794792632305164)
,p_name=>'CA.PAGE.PERFORMANCE'
,p_message_language=>'es'
,p_message_text=>unistr('Rendimiento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100819645009305183)
,p_name=>'CA.PAGE.TYPE.NOT.VALID'
,p_message_language=>'es'
,p_message_text=>unistr('El tipo de p\00E1gina "%0" no es de un tipo v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100794013942305164)
,p_name=>'CA.PAGE.VIEWS'
,p_message_language=>'es'
,p_message_text=>unistr('Vistas de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100775126012305149)
,p_name=>'CA.PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100775208237305149)
,p_name=>'CA.PAGES.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Defina p\00E1ginas para incluirlas en su aplicaci\00F3n inicial. Debe definir al menos una p\00E1gina para poder crear posteriormente la aplicaci\00F3n.</p>'),
unistr('<p>Puede eliminar la aplicaci\00F3n si crea cualquier cantidad de p\00E1ginas con este asistente. Una vez que haya creado la aplicaci\00F3n, utilice el asistente de creaci\00F3n de p\00E1ginas para agregar m\00E1s p\00E1ginas.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100824943303305187)
,p_name=>'CA.PAGINATIONMETHOD'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todo de paginaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100794375053305164)
,p_name=>'CA.PARTIAL.PAGE.VIEWS'
,p_message_language=>'es'
,p_message_text=>unistr('Vistas de p\00E1ginas parciales')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100800149413305168)
,p_name=>'CA.PHOTO'
,p_message_language=>'es'
,p_message_text=>'Foto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100800743556305169)
,p_name=>'CA.PHOTO.DELETED'
,p_message_language=>'es'
,p_message_text=>unistr('Fotograf\00EDa suprimida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100800232571305168)
,p_name=>'CA.PHOTO.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de fotograf\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100799956886305168)
,p_name=>'CA.PHOTO.UPLOAD'
,p_message_language=>'es'
,p_message_text=>unistr('Carga de fotograf\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100696883942305091)
,p_name=>'CA.PK_VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor de Clave Primaria '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100804788452305172)
,p_name=>'CA.PLAIN.TEXT.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de texto sin formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100833305274305193)
,p_name=>'CA.POSITIVE'
,p_message_language=>'es'
,p_message_text=>'Positiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100787511484305159)
,p_name=>'CA.PREFERENCES'
,p_message_language=>'es'
,p_message_text=>'Preferencias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100830956529305191)
,p_name=>'CA.PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100825650984305187)
,p_name=>'CA.PRIMARYDISPLAYCOLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de visualizaci\00F3n primaria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100826504963305188)
,p_name=>'CA.PRIMARYKEYCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100826698330305188)
,p_name=>'CA.PRIMARYPARENTTABLE'
,p_message_language=>'es'
,p_message_text=>'Tabla principal primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100794918227305164)
,p_name=>'CA.PROCEDURE'
,p_message_language=>'es'
,p_message_text=>'Procedimiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100788175287305159)
,p_name=>'CA.PROCESS.EMAIL.SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La preferencia de correo electr\00F3nico se ha actualizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100150774932304679)
,p_name=>'CA.PROCESS.FETCH_ROW'
,p_message_language=>'es'
,p_message_text=>'Recuperar fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100697017116305091)
,p_name=>'CA.PROCESS.GET_LOG_DETAIL'
,p_message_language=>'es'
,p_message_text=>'Obtener detalle de log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100789329781305160)
,p_name=>'CA.PROCESS.THEME.PREFERENCE.SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha guardado la configuraci\00F3n de aspecto de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100788011443305159)
,p_name=>'CA.PROCESS.TIME.ZONE.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'La preferencia de zona horaria se ha actualizado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100800575835305169)
,p_name=>'CA.PROFILE.PHOTO.DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>unistr('Descarga de fotograf\00EDa de perfil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100016469881304537)
,p_name=>'CA.PROGRAM.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Programa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100016558905304537)
,p_name=>'CA.PROGRAM.OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario del Programa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99529425625304163)
,p_name=>'CA.PWA'
,p_message_language=>'es'
,p_message_text=>unistr('Instalar aplicaci\00F3n web progresiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99529309385304163)
,p_name=>'CA.PWA.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Permita la instalaci\00F3n de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99529551211304163)
,p_name=>'CA.PWA.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las aplicaciones web progresivas son aquellas dise\00F1adas para ser compatibles, fiables e instalables. Una aplicaci\00F3n web progresiva es similar a una aplicaci\00F3n espec\00EDfica de la plataforma.</p>'),
unistr('<p>Al activar esta opci\00F3n:</p>'),
'<ul>',
unistr('<li>Se agregar\00E1 una nueva entrada de la barra de navegaci\00F3n: Instalar aplicaci\00F3n</li>'),
unistr('<li>Se permitir\00E1 a los usuarios instalar esta aplicaci\00F3n APEX en sus dispositivos</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99525455378304160)
,p_name=>'CA.PWA.INSTALL'
,p_message_language=>'es'
,p_message_text=>unistr('Instalar Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100825919131305187)
,p_name=>'CA.QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100013204271304534)
,p_name=>'CA.RAISE.EVENTS'
,p_message_language=>'es'
,p_message_text=>'Iniciar Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99654953952304260)
,p_name=>'CA.RATING'
,p_message_language=>'es'
,p_message_text=>unistr('Calificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100798436162305167)
,p_name=>'CA.READERS'
,p_message_language=>'es'
,p_message_text=>'Lectores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100787865362305159)
,p_name=>'CA.RECEIVE.EMAILS'
,p_message_language=>'es'
,p_message_text=>unistr('Recibir correos electr\00F3nicos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100829578028305190)
,p_name=>'CA.RECENT.ERRORS'
,p_message_language=>'es'
,p_message_text=>'Errores Recientes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100465666946304915)
,p_name=>'CA.RECENT.ERRORS.LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100465734628304915)
,p_name=>'CA.RECENT.ERRORS.VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100790079787305161)
,p_name=>'CA.RED'
,p_message_language=>'es'
,p_message_text=>'Rojo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100803629490305171)
,p_name=>'CA.REFERENCED'
,p_message_language=>'es'
,p_message_text=>'Con Referencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100149802814304678)
,p_name=>'CA.REFRESH.ADMIN_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Refrescar p\00E1gina de administraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99767124498304342)
,p_name=>'CA.REFRESH.ON.DIALOG.CLOSE'
,p_message_language=>'es'
,p_message_text=>unistr('Refrescar al cerrar el cuadro de di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100151021348304679)
,p_name=>'CA.REFRESH_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe de Refrescamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100789550159305160)
,p_name=>'CA.REGION.BUTTONS'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n de botones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100789436502305160)
,p_name=>'CA.REGION.FORM.ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n de elementos de pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100795428400305165)
,p_name=>'CA.REGION.ID'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100807415150305174)
,p_name=>'CA.RELEASE'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100774717579305149)
,p_name=>'CA.REMOVING.PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Eliminaci\00F3n de p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100774854935305149)
,p_name=>'CA.REMOVING.PAGES.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Haga clic en <strong>Editar</strong> para seleccionar la p\00E1gina y, a continuaci\00F3n, en <strong>Suprimir p\00E1gina</strong> para eliminar una p\00E1gina de la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100017862197304538)
,p_name=>'CA.REPEAT.INTERVAL'
,p_message_language=>'es'
,p_message_text=>unistr('Intervalo de Repetici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99889756057304439)
,p_name=>'CA.REPLY.TO'
,p_message_language=>'es'
,p_message_text=>'Responder a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100780539008305154)
,p_name=>'CA.REPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina de informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100780496957305153)
,p_name=>'CA.REPORT.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cree una p\00E1gina que se muestre como informe interactivo o informe cl\00E1sico.</p>'),
'<p>Introduzca los siguientes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nombre de la p\00E1gina</strong> (obligatorio): introduzca un nombre para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir icono</strong>: seleccione el icono que desea mostrar en el men\00FA de navegaci\00F3n de la p\00E1gina.</li>'),
'  <li><strong>Tipo de consulta</strong>: seleccione el origen del informe [<strong>Tabla o vista</strong> o <strong>Consulta SQL</strong>]:<br>',
'    <strong>Tabla o vista</strong>:',
'    <ul>',
'      <li>Tabla o vista (obligatorio): seleccione el objeto de base de datos para el informe.</li>',
unistr('      <li>Incluir pantalla: active esta opci\00F3n si desea que se genere una p\00E1gina de pantalla enlazada que permita a los usuarios mantener los valores de la tabla.</li>'),
'    </ul>',
'    <strong>Consulta SQL</strong>:',
'    <ul>',
unistr('      <li>Consulta SQL (obligatorio): introduzca una sentencia SQL v\00E1lida que devuelva columnas distintas.</li>'),
'    </ul>',
'  </li>',
unistr('  <li><strong>Tipo de informe</strong>: seleccione el tipo de informe (<strong>Informe interactivo</strong> o <strong>Informe cl\00E1sico</strong>).</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100772226638305147)
,p_name=>'CA.REPORT.N.WITH.FORM'
,p_message_language=>'es'
,p_message_text=>'%0 con pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100654847909305056)
,p_name=>'CA.REPORT.TABLE_NAME'
,p_message_language=>'es'
,p_message_text=>'Informe %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100828657816305189)
,p_name=>'CA.REPORT.VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100827276201305188)
,p_name=>'CA.REPORTS'
,p_message_language=>'es'
,p_message_text=>'Informes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100019269426304539)
,p_name=>'CA.REQ.START.DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha de Inicio Solicitada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100827472181305189)
,p_name=>'CA.REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Necesario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100805567408305172)
,p_name=>'CA.RESET'
,p_message_language=>'es'
,p_message_text=>'Restablecer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100801579294305169)
,p_name=>'CA.RESOLVED'
,p_message_language=>'es'
,p_message_text=>'Resuelta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100801254616305169)
,p_name=>'CA.RESPONSE'
,p_message_language=>'es'
,p_message_text=>'Respuesta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100014542278304536)
,p_name=>'CA.RESTART.ON.FAILURE'
,p_message_language=>'es'
,p_message_text=>'Reiniciar si Hay Fallos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100014659089304536)
,p_name=>'CA.RESTART.ON.RECOVERY'
,p_message_language=>'es'
,p_message_text=>'Reiniciar si Hay Recuperaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100011824875304533)
,p_name=>'CA.RESTARTABLE'
,p_message_language=>'es'
,p_message_text=>'Reiniciable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100014123377304535)
,p_name=>'CA.RETRY.COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento de Reintentos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100822433761305185)
,p_name=>'CA.ROLE'
,p_message_language=>'es'
,p_message_text=>'Rol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100795602325305165)
,p_name=>'CA.ROW.NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Fila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100804960784305172)
,p_name=>'CA.ROW.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100821820744305184)
,p_name=>'CA.ROW.TEMPLATE.HTML'
,p_message_language=>'es'
,p_message_text=>'HTML de plantilla de fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100823123292305185)
,p_name=>'CA.ROWS.CONTENT'
,p_message_language=>'es'
,p_message_text=>'Contenido de filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100796376472305165)
,p_name=>'CA.ROWS.FETCHED'
,p_message_language=>'es'
,p_message_text=>'Filas Recuperadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100824867563305187)
,p_name=>'CA.ROWSPERPAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Filas por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100017491264304538)
,p_name=>'CA.RUN.COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento de Ejecuciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100019006758304539)
,p_name=>'CA.RUN.DURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Duraci\00F3n de Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100013937166304535)
,p_name=>'CA.SCHEDULE.LIMIT'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDmite de Programaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100015903004304537)
,p_name=>'CA.SCHEDULE.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de Programaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100016011721304537)
,p_name=>'CA.SCHEDULE.OWNER'
,p_message_language=>'es'
,p_message_text=>unistr('Propietario de Programaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100015877043304536)
,p_name=>'CA.SCHEDULE.TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Programaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100783010242305155)
,p_name=>'CA.SCHEMA'
,p_message_language=>'es'
,p_message_text=>'Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100783156716305155)
,p_name=>'CA.SCHEMA.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Seleccione el esquema de base de datos que almacena los objetos de base de datos que desea utilizar en esta aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100823905045305186)
,p_name=>'CA.SCOPE'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1mbito')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100805692067305172)
,p_name=>'CA.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100805712106305172)
,p_name=>'CA.SEARCH.APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Buscar Aplicaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100805803857305172)
,p_name=>'CA.SEARCH.DIALOG'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100828845031305190)
,p_name=>'CA.SEARCH.FILTERS'
,p_message_language=>'es'
,p_message_text=>unistr('Filtros de B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100812575871305177)
,p_name=>'CA.SEARCH.HIDDEN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esta p\00E1gina se controla desde la lista Componentes compartidos denominada Tablas buscadas.'),
'',
unistr('Cualquier p\00E1gina Informe interactivo inicialmente generada desde el Asistente de creaci\00F3n de aplicaciones se agregar\00E1 autom\00E1ticamente a la lista. '),
unistr('Para agregar sus propias tablas a la lista, vaya a Componentes compartidos, seleccione Listas y, a continuaci\00F3n, haga clic en Tablas buscadas.'),
'  Introduzca los siguientes atributos:',
'    Entrada: Etiqueta de entrada de lista - introduzca el nombre mostrado de la tabla.',
unistr('    Destino: P\00E1gina - seleccione la p\00E1gina adecuada a la que acceder (preferiblemente Informe interactivo)'),
unistr('    Destino: Borrar cach\00E9 - introduzca cualquier p\00E1gina que sea necesario borrar (generalmente el mismo n\00FAmero introducido en P\00E1gina).'),
unistr('       Si accede a la p\00E1gina Informe interactivo, a continuaci\00F3n, agregue CIR,RIR para borrar cualquier filtro existente y as\00ED sucesivamente.'),
unistr('    Destino: Definir estos elementos - seleccione (o introduzca) el elemento de p\00E1gina adecuado que se va a rellenar.'),
unistr('       Si accede a la p\00E1gina Informe interactivo, introduzca IR_[COLUMN_NAME].'),
'    Destino: Con estos valores - introduzca =PK=',
unistr('    Atributos definidos por el usuario: 1 - introduzca el nombre de la tabla que desea buscar en may\00FAsculas.'),
unistr('    Atributos definidos por el usuario: 2 - introduzca el nombre de la columna principal en may\00FAsculas.'),
'    Atributos definidos por el usuario: 3 (opcional) - lista separada por comas de las columnas que se van a buscar.',
unistr('       Si no se especifica ninguna columna, se buscar\00E1 todo el texto (varchar2) y las columnas de objeto grande de caracteres (clob).'),
'',
unistr('Nota: solo aparecer\00E1 para los usuarios una lista de las tablas disponibles para la b\00FAsqueda si aparece m\00E1s de una tabla.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100805388377305172)
,p_name=>'CA.SEARCH.RESULTS'
,p_message_language=>'es'
,p_message_text=>unistr('Resultados de la B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100826460215305188)
,p_name=>'CA.SECONDARYDISPLAYCOLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de visualizaci\00F3n secundaria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100801985864305170)
,p_name=>'CA.SELECTED.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla Seleccionada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99889023697304439)
,p_name=>'CA.SEND.BEGIN'
,p_message_language=>'es'
,p_message_text=>unistr('Inicio de env\00EDo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99889422095304439)
,p_name=>'CA.SEND.COUNT'
,p_message_language=>'es'
,p_message_text=>unistr('Recuento de env\00EDos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99888975030304439)
,p_name=>'CA.SEND.END'
,p_message_language=>'es'
,p_message_text=>unistr('Final de env\00EDo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99889322839304439)
,p_name=>'CA.SEND.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de env\00EDo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100832464094305192)
,p_name=>'CA.SEND.FEEDBACK.EMAILS'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar mensajes de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100832516427305192)
,p_name=>'CA.SEND.FEEDBACK.EMAILS.HELP'
,p_message_language=>'es'
,p_message_text=>'Determina si se deben enviar mensajes si se reciben nuevos comentarios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100829108108305190)
,p_name=>'CA.SEND.FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Origen de env\00EDo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100821688544305184)
,p_name=>'CA.SEND.TO'
,p_message_language=>'es'
,p_message_text=>unistr('Destino de env\00EDo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100807285705305174)
,p_name=>'CA.SERIES'
,p_message_language=>'es'
,p_message_text=>'Series %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100018929186304539)
,p_name=>'CA.SESSION.ID'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador de Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100824199165305186)
,p_name=>'CA.SESSIONSTATEPROTECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100782457930305155)
,p_name=>'CA.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100782501653305155)
,p_name=>'CA.SETTINGS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique la configuraci\00F3n utilizada en la generaci\00F3n de la aplicaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100806818945305173)
,p_name=>'CA.SHOW.ALL'
,p_message_language=>'es'
,p_message_text=>'Mostrar Todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99766636155304342)
,p_name=>'CA.SHOW.HIDE.SCOPE'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar/ocultar \00E1mbito')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100807904578305174)
,p_name=>'CA.SHOW.TIMEZONE'
,p_message_language=>'es'
,p_message_text=>'Mostrar zona horaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100807784942305174)
,p_name=>'CA.SIGN.IN'
,p_message_language=>'es'
,p_message_text=>'Conectar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100808998265305175)
,p_name=>'CA.SIGN.OUT'
,p_message_language=>'es'
,p_message_text=>unistr('Cerrar sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100018834129304539)
,p_name=>'CA.SLAVE.PID'
,p_message_language=>'es'
,p_message_text=>'PID Esclavo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100012851054304534)
,p_name=>'CA.SOURCE'
,p_message_language=>'es'
,p_message_text=>'Origen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100819704858305183)
,p_name=>'CA.SOURCE.TYPE.NOT.VALID'
,p_message_language=>'es'
,p_message_text=>unistr('El tipo de origen no es de un tipo v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100812616889305177)
,p_name=>'CA.SOURCES'
,p_message_language=>'es'
,p_message_text=>unistr('Or\00EDgenes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100015771125304536)
,p_name=>'CA.START.DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha de Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100696290835305091)
,p_name=>'CA.STARTED'
,p_message_language=>'es'
,p_message_text=>'Iniciado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100017504942304538)
,p_name=>'CA.STATE'
,p_message_language=>'es'
,p_message_text=>'Estado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100827342088305189)
,p_name=>'CA.STATICDEFAULT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor est\00E1tico por defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100791616992305162)
,p_name=>'CA.STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100013558513304535)
,p_name=>'CA.STOP.ON.WINDOW.CLOSE'
,p_message_language=>'es'
,p_message_text=>'Parar al Cerrar Ventana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100013630926304535)
,p_name=>'CA.STORE.OUTPUT'
,p_message_language=>'es'
,p_message_text=>'Almacenar salida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100802114115305170)
,p_name=>'CA.SUBJECT'
,p_message_language=>'es'
,p_message_text=>'Asunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100800880887305169)
,p_name=>'CA.SUBMIT.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Enviar Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100696447275305091)
,p_name=>'CA.SUCCESSFUL_ROWS'
,p_message_language=>'es'
,p_message_text=>'Filas correctas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100824451994305186)
,p_name=>'CA.SUGGESTEDVISULIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('Visualizaci\00F3n sugerida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100816333391305180)
,p_name=>'CA.SUPPORTING.OBJECTS'
,p_message_language=>'es'
,p_message_text=>'Objetos de Soporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100816493806305180)
,p_name=>'CA.SUPPORTING.OBJECTS.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca el c\00F3digo en el script de instalaci\00F3n, generalmente para crear o manipular los objetos de base de datos o realizar inserciones / actualizaciones / supresiones en los registros existentes. Introduzca el c\00F3digo en la desinstalaci\00F3n, gener')
||unistr('almente para eliminar (borrar) objetos de base de datos. Estos scripts se incorporar\00E1n a los objetos de compatibilidad para que cuando se exporte la aplicaci\00F3n, se realicen estas mismas actualizaciones en los entornos de prueba y producci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100816526719305180)
,p_name=>'CA.SUPPORTING.OBJECTS.PAGE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca sentencias SQL y/o PL/SQL v\00E1lidas en el script de instalaci\00F3n que se ejecutan al importar la aplicaci\00F3n.</p>'),
unistr('<p>Si desea que estas sentencias tambi\00E9n se ejecuten en el entorno actual y no solo cuando la aplicaci\00F3n se importe a otro entorno, haga clic en <strong>Ejecutar al crear la aplicaci\00F3n</strong>.</p>'),
unistr('<p>Introduzca sentencias SQL y/o PL/SQL v\00E1lidas en el script de desinstalaci\00F3n que se ejecutan cuando la aplicaci\00F3n se suprime del Creador de aplicaciones.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100013148098304534)
,p_name=>'CA.SYSTEM'
,p_message_language=>'es'
,p_message_text=>'Sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100825812676305187)
,p_name=>'CA.TABLE'
,p_message_language=>'es'
,p_message_text=>'Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100783222170305156)
,p_name=>'CA.TABLE.PREFIX'
,p_message_language=>'es'
,p_message_text=>'Prefijo de objeto de marco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100783317481305156)
,p_name=>'CA.TABLE.PREFIX.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el prefijo de objeto que utilizar\00E1 la aplicaci\00F3n. Algunas funciones agregan este prefijo a los objetos de base de datos que crean (incluidos los paquetes y las tablas).</p>'),
unistr('<p>Advertencia: Aseg\00FArese de que introduce un prefijo \00FAnico que no est\00E9n utilizando otras aplicaciones. Si no es \00FAnico, la aplicaci\00F3n puede detectar errores cuando se est\00E9n creando y no funcionar correctamente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100826739406305188)
,p_name=>'CA.TABLECOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100821706336305184)
,p_name=>'CA.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100805283122305172)
,p_name=>'CA.TEMPLATE.EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('Este nombre de plantilla ya est\00E1 en uso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100802072839305170)
,p_name=>'CA.TEMPLATE.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de la Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100790782020305161)
,p_name=>'CA.TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99889263651304439)
,p_name=>'CA.TEXT.BODY.SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de cuerpo de texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100803205710305171)
,p_name=>'CA.TEXT.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100788929675305160)
,p_name=>'CA.THEME.PREFERENCE'
,p_message_language=>'es'
,p_message_text=>'Preferencia de tema de usuario final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100789117973305160)
,p_name=>'CA.THEME.PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>'Si se activa, los usuarios finales pueden seleccionar su propio estilo con el enlace Personalizar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100789003612305160)
,p_name=>'CA.THEME.PREFERENCE.LOV'
,p_message_language=>'es'
,p_message_text=>'Permitir a los usuarios finales seleccionar el estilo de tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100773327971305148)
,p_name=>'CA.THEME.SELECTOR'
,p_message_language=>'es'
,p_message_text=>unistr('Selecci\00F3n de estilo de tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100771705789305147)
,p_name=>'CA.THEME.SELECTOR.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Actualizar interfaz de usuario por defecto de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100773458369305148)
,p_name=>'CA.THEME.SELECTOR.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite a los administradores seleccionar un esquema de color (estilo de tema) por defecto para la aplicaci\00F3n. Los administradores tambi\00E9n pueden elegir si permitir a los usuarios finales seleccionar su propio estilo de tema. Los usuarios finales ')
||unistr('pueden simplemente hacer clic en el bot\00F3n <em>Personalizar</em> de la parte inferior de la p\00E1gina inicial y seleccionar uno de los estilos de tema disponibles. Por ejemplo, los usuarios con discapacidad visual tal vez prefieran utilizar el estilo de ')
||'tema <em>Vista</em> que tiene un contraste de color mucho mayor.</p>',
'<p>Incluye los siguientes componentes:',
'<ul>',
'<li>Permite a los administradores definir el estilo de tema por defecto</li>',
'<li>Permite a los usuarios finales seleccionar varios estilos de tema</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100781808374305155)
,p_name=>'CA.THEME.STYLE'
,p_message_language=>'es'
,p_message_text=>'Estilo de Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100781918667305155)
,p_name=>'CA.THEME.STYLE.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el estilo de tema por defecto utilizado para mostrar la aplicaci\00F3n.</p>'),
unistr('<p>El estilo se puede cambiar f\00E1cilmente por otro estilo predefinido o modificarse tras la generaci\00F3n. Para cambiar el estilo, ejecute la aplicaci\00F3n y, a continuaci\00F3n, haga clic en <strong>Acumulador de tema</strong> en la barra de herramientas del d')
||'esarrollador.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100795907839305165)
,p_name=>'CA.TIME'
,p_message_language=>'es'
,p_message_text=>'Hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100787690370305159)
,p_name=>'CA.TIME.ZONE'
,p_message_language=>'es'
,p_message_text=>'Zona Horaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100774460841305149)
,p_name=>'CA.TIME.ZONE.SUPPORT'
,p_message_language=>'es'
,p_message_text=>'Soporte de Zona Horaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100771337852305147)
,p_name=>'CA.TIME.ZONE.SUPPORT.DESC'
,p_message_language=>'es'
,p_message_text=>'Definir zonas horarias por defecto y del usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100774164965305149)
,p_name=>'CA.TIME.ZONE.SUPPORT.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite a los usuarios finales definir su zona horaria local. Es importante si en las tablas de aplicaci\00F3n se utilizan los tipos de fecha que aplican zona horaria (como Registro de hora con zona horaria local) para que los informes y la entrada de')
||unistr(' datos reflejen d\00F3nde est\00E1n los usuarios finales.</p>'),
'<p>Incluye los siguientes componentes:',
'<ul>',
'<li>Permite a los administradores definir la zona horaria por defecto</li>',
'<li>Permite a los usuarios finales seleccionar su preferencia de zona horaria</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100829722754305190)
,p_name=>'CA.TIMEFRAME'
,p_message_language=>'es'
,p_message_text=>'Marco temporal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100830018698305190)
,p_name=>'CA.TIMELINE'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar p\00E1gina de cronolog\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100830112484305191)
,p_name=>'CA.TIMELINE.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cree una p\00E1gina que muestre una cronolog\00EDa especialmente \00FAtil para mostrar actualizaciones.</p>'),
'<p>Introduzca los siguientes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nombre de p\00E1gina</strong> (obligatorio): introduzca un nombre para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir icono</strong>: seleccione un icono para mostrar en el men\00FA de navegaci\00F3n de la p\00E1gina.</li>'),
unistr('  <li><strong>Tabla o vista</strong> (obligatorio): seleccione el objeto de base de datos para la cronolog\00EDa.</li>'),
unistr('  <li><strong>Nombre de usuario</strong> (obligatorio): seleccione la columna de la tabla o vista que se va a utilizar como usuario mostrado para las entradas de cronolog\00EDa.</li>'),
unistr('  <li><strong>Fecha</strong> (obligatorio): seleccione la columna de la tabla o vista que se va a utilizar como t\00EDtulo de las entradas de cronolog\00EDa.</li>'),
unistr('  <li><strong>Nombre de evento</strong> (obligatorio): seleccione la columna de la tabla o vista que se va a utilizar como t\00EDtulo de las entradas de cronolog\00EDa.</li>'),
unistr('  <li><strong>Descripci\00F3n</strong>: seleccione la columna de la tabla o vista que se va a utilizar como descripci\00F3n de las entradas de cronolog\00EDa.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100792899869305163)
,p_name=>'CA.TIMESTAMP'
,p_message_language=>'es'
,p_message_text=>'Registro de hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100797410931305166)
,p_name=>'CA.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99889882657304439)
,p_name=>'CA.TO'
,p_message_language=>'es'
,p_message_text=>'Para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100796676478305166)
,p_name=>'CA.TOP.USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100796773519305166)
,p_name=>'CA.TOP.USERS.CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico de usuarios principales')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100794298862305164)
,p_name=>'CA.TOTAL.ROWS'
,p_message_language=>'es'
,p_message_text=>'Total de Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100798681118305167)
,p_name=>'CA.TREAT.AUTH.USERS.NO.IN.ACL.AS'
,p_message_language=>'es'
,p_message_text=>unistr('Rol por defecto para los usuarios que no est\00E1n en la lista de control de acceso:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100790862982305161)
,p_name=>'CA.TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100101316315304602)
,p_name=>'CA.UI.DEFAULTS'
,p_message_language=>'es'
,p_message_text=>'Valores por Defecto de Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100101444335304602)
,p_name=>'CA.UI.DEFAULTS.DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Defina valores por defecto para la configuraci\00F3n de la interfaz de usuario (como filas por p\00E1gina) y agregue una lista de definiciones de valores. Esta configuraci\00F3n se utiliza para generar componentes en la aplicaci\00F3n. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100791040225305161)
,p_name=>'CA.UNTIL'
,p_message_language=>'es'
,p_message_text=>'Hasta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100149696584304678)
,p_name=>'CA.UPDATE'
,p_message_language=>'es'
,p_message_text=>'Actualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100800459136305168)
,p_name=>'CA.UPDATE.PROFILE'
,p_message_language=>'es'
,p_message_text=>'Actualizar Perfil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100791383018305162)
,p_name=>'CA.UPDATED'
,p_message_language=>'es'
,p_message_text=>'Actualizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100791410822305162)
,p_name=>'CA.UPDATED.BY'
,p_message_language=>'es'
,p_message_text=>'Actualizado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100792727275305163)
,p_name=>'CA.USER'
,p_message_language=>'es'
,p_message_text=>'Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100819291283305182)
,p_name=>'CA.USER.ADD_MULTIPLE_1'
,p_message_language=>'es'
,p_message_text=>'Agregar varios usuarios: paso 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100819321534305182)
,p_name=>'CA.USER.ADD_MULTIPLE_2'
,p_message_language=>'es'
,p_message_text=>'Agregar varios usuarios: paso 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100819493723305183)
,p_name=>'CA.USER.ADD_MULTIPLE_USERS'
,p_message_language=>'es'
,p_message_text=>'Agregar varios usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100795123199305164)
,p_name=>'CA.USER.AGENT'
,p_message_language=>'es'
,p_message_text=>'Agente de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100808518524305174)
,p_name=>'CA.USER.COUNTS.REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe de recuentos de usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100796941636305166)
,p_name=>'CA.USER.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100799405364305168)
,p_name=>'CA.USER.PROFILE'
,p_message_language=>'es'
,p_message_text=>'Perfil de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100774331423305149)
,p_name=>'CA.USER.PROFILES'
,p_message_language=>'es'
,p_message_text=>'Perfiles de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100771243755305147)
,p_name=>'CA.USER.PROFILES.DESC'
,p_message_language=>'es'
,p_message_text=>'Permitir a los usuarios actualizar sus perfiles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100774264650305149)
,p_name=>'CA.USER.PROFILES.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite a los usuarios finales introducir informaci\00F3n adicional sobre ellos mismos, incluida una imagen o avatar, para personalizar su cuenta.</p>'),
'<p>Incluye los siguientes componentes:',
'<ul>',
unistr('<li>P\00E1gina de configuraci\00F3n para que los usuarios finales puedan definir su perfil</li>'),
'<li>Capacidad de cargar una foto o un avatar</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100799659968305168)
,p_name=>'CA.USERNAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100798727445305167)
,p_name=>'CA.USERNAME.FORMAT'
,p_message_language=>'es'
,p_message_text=>'Formato de nombre de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100820198732305183)
,p_name=>'CA.USERNAMES'
,p_message_language=>'es'
,p_message_text=>'Nombres de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100108858111304608)
,p_name=>'CA.USERNAME_FORMAT'
,p_message_language=>'es'
,p_message_text=>'Formato de nombre de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100820749255305184)
,p_name=>'CA.USERS.ADDED'
,p_message_language=>'es'
,p_message_text=>'Usuarios agregados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100822222246305185)
,p_name=>'CA.USERS.BY.ROLE'
,p_message_language=>'es'
,p_message_text=>'Usuarios por rol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100802880562305170)
,p_name=>'CA.USERS.INCLUDED'
,p_message_language=>'es'
,p_message_text=>'Usuarios incluidos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100820418380305183)
,p_name=>'CA.USERS.TO.ADD'
,p_message_language=>'es'
,p_message_text=>'Usuarios que Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100798970533305167)
,p_name=>'CA.USRENAME.FORMAT.UPDATED'
,p_message_language=>'es'
,p_message_text=>'El formato de nombre de usuario se ha actualizado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99785839153304355)
,p_name=>'CA.VALID.USER.EXIST.PAGEINFO'
,p_message_language=>'es'
,p_message_text=>unistr('Existen usuarios v\00E1lidos - Informaci\00F3n de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100814546265305179)
,p_name=>'CA.VALIDATION.APP.ID'
,p_message_language=>'es'
,p_message_text=>unistr('Ya existe el ID de aplicaci\00F3n o est\00E1 reservado para otra aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100056126634304567)
,p_name=>'CA.VALIDATION.APP.NAME.NOT.NULL'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar el nombre de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100822879067305185)
,p_name=>'CA.VALIDATION.EMAIL.REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Debe proporcionar las direcciones de correo electr\00F3nico a las que enviar el correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100822666072305185)
,p_name=>'CA.VALIDATION.EMAIL.ROLE.REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Debe proporcionar las direcciones de correo electr\00F3nico o seleccionar un juego de usuarios al que enviar el correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100822706510305185)
,p_name=>'CA.VALIDATION.ROLE.REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Debe proporcionar un juego de usuarios al que enviar el correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100814636809305179)
,p_name=>'CA.VALIDATION.TABLE.PREFIX'
,p_message_language=>'es'
,p_message_text=>unistr('El prefijo de tabla no debe tener m\00E1s de seis caracteres, debe empezar por una letra y contener solo letras, n\00FAmeros o guiones bajos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100814784564305179)
,p_name=>'CA.VALIDATION.TABLE.PREFIX.USED'
,p_message_language=>'es'
,p_message_text=>'Introduzca otro prefijo de tabla. Los siguientes objetos de base de datos ya existen: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100799317132305168)
,p_name=>'CA.VERIFY.EMAIL.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de usuario no es un formato de direcci\00F3n de correo electr\00F3nico v\00E1lido. Tenga en cuenta el siguiente formato de nombre de usuario de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100799281553305168)
,p_name=>'CA.VERIFY.EMAIL.FORMAT'
,p_message_language=>'es'
,p_message_text=>unistr('Verificar formato de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100796891130305166)
,p_name=>'CA.VIEW.AS'
,p_message_language=>'es'
,p_message_text=>'Ver como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100817160671305181)
,p_name=>'CA.VIEW.BLUEPRINT'
,p_message_language=>'es'
,p_message_text=>'Ver plan detallado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100806721398305173)
,p_name=>'CA.VIEW.DETAILS'
,p_message_language=>'es'
,p_message_text=>'Ver Detalles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100823057725305185)
,p_name=>'CA.VIEW.EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Ver Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100808881863305175)
,p_name=>'CA.VIEW.MY.PROFILE'
,p_message_language=>'es'
,p_message_text=>'Ver Mi Perfil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100793751649305163)
,p_name=>'CA.WEIGHTED.PERFORMANCE'
,p_message_language=>'es'
,p_message_text=>'Rendimiento Ponderado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100827690065305189)
,p_name=>'CA.WIDTH'
,p_message_language=>'es'
,p_message_text=>'Ancho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100831839114305192)
,p_name=>'CA.WIZARD'
,p_message_language=>'es'
,p_message_text=>unistr('Crear p\00E1ginas del asistente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99785729654304355)
,p_name=>'CA.WIZARD.CONTAINER'
,p_message_language=>'es'
,p_message_text=>'Contenedor de asistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100831929116305192)
,p_name=>'CA.WIZARD.DETAILS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cree una recopilaci\00F3n de p\00E1ginas que se utilice como asistente. Normalmente, los asistentes se utilizan para introducir datos en varios pasos</p>'),
'<p>Introduzca los siguientes atributos:</p>',
'<ul>',
unistr('  <li><strong>Nombre del asistente</strong> (obligatorio): introduzca un nombre para esta p\00E1gina.</li>'),
unistr('  <li><strong>Definir icono</strong>: seleccione un icono para mostrarlo en el men\00FA de navegaci\00F3n de la p\00E1gina.</li>'),
unistr('  <li><strong>Modo de p\00E1gina</strong> (obligatorio): seleccione si los pasos del asistente se deben mostrar como p\00E1ginas modales o normales. Seleccione <strong>P\00E1gina modal</strong> o <strong>P\00E1gina completa</strong>.</li>'),
unistr('  <li><strong>Paso 1 ... 8</strong>: introduzca el nombre de la p\00E1gina para los pasos del asistente.<br><em><strong>Nota:</strong> Los pasos 5 - 8 se muestran al introducir un nombre para cada paso previo.</em></li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100797240779305166)
,p_name=>'CA.WORK.PHONE'
,p_message_language=>'es'
,p_message_text=>unistr('Tel\00E9fono de trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100789965141305161)
,p_name=>'CA.YELLOW'
,p_message_language=>'es'
,p_message_text=>'Amarillo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100101874028304603)
,p_name=>'CA.YES'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99654887163304260)
,p_name=>'CACHED'
,p_message_language=>'es'
,p_message_text=>unistr('Almacenado en Cach\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99558086264304188)
,p_name=>'CACHE_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Cach\00E9 Creada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99545671252304178)
,p_name=>'CALENDAR.CHECK.AJAX_DELETE_NOT_ENABLED'
,p_message_language=>'es'
,p_message_text=>unistr('La funcionalidad de supresi\00F3n de datos est\00E1 desactivada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99530635558304164)
,p_name=>'CALENDAR.CHECK.AJAX_INSERT_NOT_ENABLED'
,p_message_language=>'es'
,p_message_text=>unistr('La funcionalidad de adici\00F3n de datos est\00E1 desactivada.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99530760207304164)
,p_name=>'CALENDAR.CHECK.AJAX_UPDATE_NOT_ENABLED'
,p_message_language=>'es'
,p_message_text=>unistr('La funcionalidad de actualizaci\00F3n de datos est\00E1 desactivada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99683576167304281)
,p_name=>'CALENDAR.NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99683456362304280)
,p_name=>'CALENDAR.PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99569834318304197)
,p_name=>'CALENDAR_EASY_TYPE'
,p_message_language=>'es'
,p_message_text=>'Calendario Sencillo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100587733310305006)
,p_name=>'CALENDAR_ENTRY_EDIT_PAGE'
,p_message_language=>'es'
,p_message_text=>'Editar Entrada de Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99519146797304155)
,p_name=>'CALENDAR_POPUP'
,p_message_language=>'es'
,p_message_text=>'Calendario emergente de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99650551151304257)
,p_name=>'CALENDAR_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'El calendario se ha creado correctamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100040103066304555)
,p_name=>'CALENDAR_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Calendario Heredado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99569722828304197)
,p_name=>'CALENDAR_TYPE'
,p_message_language=>'es'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99903141475304450)
,p_name=>'CAL_TEMPLATE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ninguna plantilla de calendario al intentar copiar desde la aplicaci\00F3n %0 y el identificador de plantilla %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100041524089304556)
,p_name=>'CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99525649801304160)
,p_name=>'CARD_ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Acciones de tarjeta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100273510944304771)
,p_name=>'CASCADING STYLE SHEETS'
,p_message_language=>'es'
,p_message_text=>'Hojas de Estilo en Cascada'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100120955398304617)
,p_name=>'CHANGES'
,p_message_language=>'es'
,p_message_text=>'Cambios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100698079120305092)
,p_name=>'CHANGE_AUTHENTICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Cambiar Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100036816056304552)
,p_name=>'CHANGE_DATABASE_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Cambiar Tama\00F1o de Base de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100036626598304552)
,p_name=>'CHANGE_REQUEST'
,p_message_language=>'es'
,p_message_text=>'Solicitud de Cambio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100250360067304754)
,p_name=>'CHANGE_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Cambiar Espacio de Trabajo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100010112599304532)
,p_name=>'CHARACTER_SET_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de Juego de Caracteres'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99731771865304316)
,p_name=>'CHART'
,p_message_language=>'es'
,p_message_text=>unistr('gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99514450248304152)
,p_name=>'CHART.CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Consulta de gr\00E1fico no v\00E1lida: %0<br><br>'),
'Utilice la siguiente sintaxis:',
'<pre>',
'SELECT LINK, LABEL, VALUE',
'FROM   ...',
'</pre>',
'<table class="instructiontext">',
'<tr><td>LINK</td><td>URL</td></tr>',
'<tr><td>LABEL</td><td>Texto incluido con la barra</td></tr>',
unistr('<tr><td>VALUE</td><td>Columna num\00E9rica que define el tama\00F1o de barra</td></tr>'),
'</table>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99679360256304277)
,p_name=>'CHART.DIAL_CHART_QUERY_SYNTAX_INVALID'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Consulta de gr\00E1fico no v\00E1lida.<br /><br /> Utilice la siguiente sintaxis: <pre> SELECT VALUE, MAX, (LOW), (HIGH) VALUE FROM ... </pre>'),
'<table class="instructiontext">',
'<tr>',
'<td>VALUE</td>',
unistr('<td>Columna num\00E9rica que define el valor de dial.</td>'),
'</tr>',
'<tr>',
'<td>MAX</td>',
unistr('<td>Columna num\00E9rica que define el valor m\00E1ximo de dial.</td>'),
'</tr>',
'<tr>',
'<td>LOW (opcional)</td>',
unistr('<td>Columna num\00E9rica que define el valor m\00EDnimo previo de dial.</td>'),
'</tr>',
'<tr>',
'<td>HIGH (opcional)</td>',
unistr('<td>Columna num\00E9rica que define el valor m\00E1ximo previo de dial.</td>'),
'</tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99746163856304327)
,p_name=>'CHART.INVALID_CHART_TYPE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de gr\00E1fico no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99514345691304152)
,p_name=>'CHART.INVALID_QUERY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Fallo al analizar la consulta SQL.',
'<p>%0</p>',
unistr('Algunas consultas s\00F3lo se pueden realizar si se ejecuta la aplicaci\00F3n, si la consulta es sint\00E1cticamente correcta, se puede guardar sin validaci\00F3n (consulte las opciones a continuaci\00F3n del origen de la consulta).')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100737601727305122)
,p_name=>'CHART_DEGREES'
,p_message_language=>'es'
,p_message_text=>'grados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99987628615304515)
,p_name=>'CHART_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico de %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99546192209304179)
,p_name=>'CHART_SERIES'
,p_message_language=>'es'
,p_message_text=>unistr('Serie de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100033344683304550)
,p_name=>'CHART_SERIES_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de serie de gr\00E1fico %0 para %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99642360350304250)
,p_name=>'CHART_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('El gr\00E1fico se ha creado correctamente.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99991492967304518)
,p_name=>'CHECKSUM_REQUIRED_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Total de Control Necesario: Nivel de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99824540158304383)
,p_name=>'CHECKSUM_REQUIRED_SESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Total de Control Necesario: Nivel de Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99824449554304383)
,p_name=>'CHECKSUM_REQUIRED_USER'
,p_message_language=>'es'
,p_message_text=>'Total de Control Necesario: Nivel de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99824362982304383)
,p_name=>'CHECKSUM_REQUIRED_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('Total de Control Necesario: Nivel de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100738437086305122)
,p_name=>'CHECK_ALL'
,p_message_language=>'es'
,p_message_text=>'Activar Todo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99976979670304507)
,p_name=>'CLASSIC_CALENDAR'
,p_message_language=>'es'
,p_message_text=>unistr('Calendario Cl\00E1sico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99979659519304509)
,p_name=>'CLASSIC_REPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Informe Cl\00E1sico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99678126003304277)
,p_name=>'CLASSIC_REPORT_COLUMNS'
,p_message_language=>'es'
,p_message_text=>unistr('Columnas de informe cl\00E1sico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99977315149304507)
,p_name=>'CLASSIC_TREE'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rbol Cl\00E1sico')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99975255190304506)
,p_name=>'CLEAN_UP'
,p_message_language=>'es'
,p_message_text=>unistr('Limpiar P\00E1gina')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99540975979304172)
,p_name=>'CLEAR_COMMAND'
,p_message_language=>'es'
,p_message_text=>'Borrar Comando'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99984596640304513)
,p_name=>'CLOSED'
,p_message_language=>'es'
,p_message_text=>'Cerrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100030117123304547)
,p_name=>'CLOSED_LAST_7_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('Cerrados en los \00DAltimos 7 D\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99783236519304354)
,p_name=>'CLOSE_WINDOW'
,p_message_language=>'es'
,p_message_text=>'Cerrar Ventana'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100518604157304955)
,p_name=>'CODE_EDITOR.ACCESSIBILITY_MODE'
,p_message_language=>'es'
,p_message_text=>'Modo de Accesibilidad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100814896477305179)
,p_name=>'CODE_EDITOR.CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100815891434305180)
,p_name=>'CODE_EDITOR.FIND'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100815792122305180)
,p_name=>'CODE_EDITOR.HINT'
,p_message_language=>'es'
,p_message_text=>unistr('Terminar Autom\00E1ticamente')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100643481863305047)
,p_name=>'CODE_EDITOR.INDENTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Sangr\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100815144026305179)
,p_name=>'CODE_EDITOR.INDENT_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Sangr\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100815319610305180)
,p_name=>'CODE_EDITOR.INDENT_WITH_TABS'
,p_message_language=>'es'
,p_message_text=>unistr('Espacios Insertados en Tabulaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100518747137304955)
,p_name=>'CODE_EDITOR.ITEM_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>'El elemento %0 no existe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100519848522304956)
,p_name=>'CODE_EDITOR.MINIMAP'
,p_message_language=>'es'
,p_message_text=>'Minimapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100519713905304955)
,p_name=>'CODE_EDITOR.MINIMAP_CONDITIONAL'
,p_message_language=>'es'
,p_message_text=>unistr('Solo cuando >100 l\00EDneas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100819165742305182)
,p_name=>'CODE_EDITOR.QUERY_BUILDER'
,p_message_language=>'es'
,p_message_text=>'Generador de Consultas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100815922407305180)
,p_name=>'CODE_EDITOR.REDO'
,p_message_language=>'es'
,p_message_text=>'Rehacer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100815554206305180)
,p_name=>'CODE_EDITOR.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100815430092305180)
,p_name=>'CODE_EDITOR.SHOW_LINE_NUMBERS'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar N\00FAmeros de L\00EDnea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100814944208305179)
,p_name=>'CODE_EDITOR.SHOW_RULER'
,p_message_language=>'es'
,p_message_text=>'Mostrar Regla'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100519681646304955)
,p_name=>'CODE_EDITOR.SUGGESTIONS'
,p_message_language=>'es'
,p_message_text=>'Mostrar sugerencias'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100815274155305179)
,p_name=>'CODE_EDITOR.TAB_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Tabulaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100815067128305179)
,p_name=>'CODE_EDITOR.THEMES'
,p_message_language=>'es'
,p_message_text=>'Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100519534564304955)
,p_name=>'CODE_EDITOR.THEME_AUTOMATIC'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100519444882304955)
,p_name=>'CODE_EDITOR.THEME_DARK'
,p_message_language=>'es'
,p_message_text=>'Oscuro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100519208306304955)
,p_name=>'CODE_EDITOR.THEME_HIGH_CONTRAST_DARK'
,p_message_language=>'es'
,p_message_text=>'Oscuro de alto contraste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100519348740304955)
,p_name=>'CODE_EDITOR.THEME_LIGHT'
,p_message_language=>'es'
,p_message_text=>'Claro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100519174817304955)
,p_name=>'CODE_EDITOR.TRANSFORM_CODE_CASE'
,p_message_language=>'es'
,p_message_text=>unistr('Transformar c\00F3digo de caso')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100816011127305180)
,p_name=>'CODE_EDITOR.UNDO'
,p_message_language=>'es'
,p_message_text=>'Deshacer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100518968221304955)
,p_name=>'CODE_EDITOR.UTIL_OFF'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100519041507304955)
,p_name=>'CODE_EDITOR.UTIL_ON'
,p_message_language=>'es'
,p_message_text=>'Activado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100815624811305180)
,p_name=>'CODE_EDITOR.VALIDATE'
,p_message_language=>'es'
,p_message_text=>'Validar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100816120142305180)
,p_name=>'CODE_EDITOR.VALIDATION_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n Correcta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100518859016304955)
,p_name=>'CODE_EDITOR.WHITESPACE'
,p_message_language=>'es'
,p_message_text=>'Mostrar Espacio en Blanco'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99922337526304465)
,p_name=>'COLLAPSE'
,p_message_language=>'es'
,p_message_text=>'Reducir '
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99553963854304185)
,p_name=>'COLOR_PALETTE'
,p_message_language=>'es'
,p_message_text=>'Paleta de Colores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99743391970304325)
,p_name=>'COLOR_PALETTE_ANALOGIC'
,p_message_language=>'es'
,p_message_text=>unistr('Anal\00F3gico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99742997605304324)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY'
,p_message_language=>'es'
,p_message_text=>'Complementario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99743535480304325)
,p_name=>'COLOR_PALETTE_COMPLEMENTARY_COLORS'
,p_message_language=>'es'
,p_message_text=>'Colores Complementarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99743428543304325)
,p_name=>'COLOR_PALETTE_MONOTONE'
,p_message_language=>'es'
,p_message_text=>'Monotono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99743042802304324)
,p_name=>'COLOR_PALETTE_SPLIT_COMPLEMENTARY'
,p_message_language=>'es'
,p_message_text=>'Dividir Complementario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99743258759304325)
,p_name=>'COLOR_PALETTE_TETRADE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00E9trada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99743103214304325)
,p_name=>'COLOR_PALETTE_TRIADE'
,p_message_language=>'es'
,p_message_text=>unistr('Tr\00EDada')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100731301494305117)
,p_name=>'COLUMN_DISPLAY_NAME_LABEL'
,p_message_language=>'es'
,p_message_text=>'Nombre Mostrado: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99914883579304459)
,p_name=>'COLUMN_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Columna'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100103006268304603)
,p_name=>'COM.ORACLE.APEX.ACL_ALL_USERS'
,p_message_language=>'es'
,p_message_text=>unistr('Todos los usuarios autenticados pueden acceder a esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100103180335304604)
,p_name=>'COM.ORACLE.APEX.ACL_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('Solo se permite el acceso a la aplicaci\00F3n a los usuarios definidos en la lista de control de acceso de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100103203824304604)
,p_name=>'COM.ORACLE.APEX.ACL_SETTING_VALUE_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de configuraci\00F3n de control de acceso no esperado: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99547010063304179)
,p_name=>'COMING_SOON'
,p_message_language=>'es'
,p_message_text=>unistr('Pr\00F3ximamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99915377529304460)
,p_name=>'COMMENT'
,p_message_language=>'es'
,p_message_text=>'Comentario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99784392793304354)
,p_name=>'COMPILE_FAILURE'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de compilaci\00F3n, l\00EDnea <a href="javascript:goToLine(''%0'')">%0</a> (%2)<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100115512405304613)
,p_name=>'COMPILE_FAILURE_TRIGGER'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de compilaci\00F3n, l\00EDnea %0 (%2). Los n\00FAmeros de l\00EDneas asociados a errores de compilaci\00F3n son relativos a la primera sentencia BEGIN. Esto s\00F3lo afecta a la compilaci\00F3n de disparadores de bases de datos.<br />%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99784246452304354)
,p_name=>'COMPILE_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo PL/SQL compilado correctamente (%0)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99981987649304511)
,p_name=>'COMPLETE'
,p_message_language=>'es'
,p_message_text=>'Terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99988942504304516)
,p_name=>'COMPLETED'
,p_message_language=>'es'
,p_message_text=>'Terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99995874636304521)
,p_name=>'COMPLETE_NO_ISSUES'
,p_message_language=>'es'
,p_message_text=>'Terminado / Sin Problemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100030685553304548)
,p_name=>'COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100158712262304685)
,p_name=>'COMPONENT_NAME_LABEL'
,p_message_language=>'es'
,p_message_text=>'Nombre del Componente: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100349719640304828)
,p_name=>'COMPONENT_NOT_ENABLED'
,p_message_language=>'es'
,p_message_text=>'Componente no activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99645977127304253)
,p_name=>'COMPONENT_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'El componente se ha creado correctamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100729034915305115)
,p_name=>'COMPONENT_SUMMARY'
,p_message_language=>'es'
,p_message_text=>'Resumen del Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99594495207304215)
,p_name=>'COMPUTATIONS'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100052822736304564)
,p_name=>'COMP_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Los componentes de la aplicaci\00F3n se han instalado correctamente.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99784889194304355)
,p_name=>'CONDITIONAL'
,p_message_language=>'es'
,p_message_text=>'Condicional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99900564654304448)
,p_name=>'CONDITIONS_POPUP_LOV'
,p_message_language=>'es'
,p_message_text=>'lista de valores emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99974748995304505)
,p_name=>'CONDITIONS_SHORTCUT_ALWAYS'
,p_message_language=>'es'
,p_message_text=>'siempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99706318031304297)
,p_name=>'CONDITIONS_SHORTCUT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99705784038304297)
,p_name=>'CONDITIONS_SHORTCUT_EXPRESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99705881780304297)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_E_VAL'
,p_message_language=>'es'
,p_message_text=>'elemento / columna=valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99705944250304297)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'elemento / columna no nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100519996109304956)
,p_name=>'CONDITIONS_SHORTCUT_ITEM_NULL'
,p_message_language=>'es'
,p_message_text=>'elemento/columna nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99706497012304298)
,p_name=>'CONDITIONS_SHORTCUT_NEVER'
,p_message_language=>'es'
,p_message_text=>'nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99706522596304298)
,p_name=>'CONDITIONS_SHORTCUT_NONE'
,p_message_language=>'es'
,p_message_text=>'ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99706118533304297)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_IN'
,p_message_language=>'es'
,p_message_text=>unistr('p\00E1gina en')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99706208206304297)
,p_name=>'CONDITIONS_SHORTCUT_PAGE_NOT_IN'
,p_message_language=>'es'
,p_message_text=>unistr('la p\00E1gina no est\00E1 en')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99706059402304297)
,p_name=>'CONDITIONS_SHORTCUT_REQ_E_E1'
,p_message_language=>'es'
,p_message_text=>'solicitar=e1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99717409228304306)
,p_name=>'CONDITION_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Condici\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99937703354304477)
,p_name=>'CONFIRM'
,p_message_language=>'es'
,p_message_text=>'Confirmar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99506829251304146)
,p_name=>'CONFIRM.2_PAGE_MASTER_DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Dos p\00E1ginas maestras/de detalles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99506753089304146)
,p_name=>'CONFIRM.3_PAGE_MASTER_DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Tres p\00E1ginas maestras/de detalles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99692234866304287)
,p_name=>'CONFIRM.ACTUAL_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre Real'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99981745770304511)
,p_name=>'CONFIRM.AGG_COLS'
,p_message_language=>'es'
,p_message_text=>'Agregado por Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99981893320304511)
,p_name=>'CONFIRM.AGG_FUNCTION'
,p_message_language=>'es'
,p_message_text=>'Funciones de agregado a Usar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99689621470304285)
,p_name=>'CONFIRM.APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99703164492304295)
,p_name=>'CONFIRM.APPLICATION_ALIAS'
,p_message_language=>'es'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99703222127304295)
,p_name=>'CONFIRM.APPLICATION_DEFAULT_LANG'
,p_message_language=>'es'
,p_message_text=>'Idioma por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99703038053304295)
,p_name=>'CONFIRM.APPLICATION_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99600096362304219)
,p_name=>'CONFIRM.ARRAY'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rbol de Resultados para Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99600113033304219)
,p_name=>'CONFIRM.ARRAY_PARMS'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de Resultado para Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99703327314304295)
,p_name=>'CONFIRM.AUTHENTICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100156831067304683)
,p_name=>'CONFIRM.BRANCH_TO'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcar a P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99906015090304452)
,p_name=>'CONFIRM.BREAK_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas Divisorias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99692041563304287)
,p_name=>'CONFIRM.BUTTON_BRANCH'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcaci\00F3n de Bot\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99691927241304287)
,p_name=>'CONFIRM.BUTTON_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Visualizaci\00F3n del Bot\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99527316975304161)
,p_name=>'CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'
,p_message_language=>'es'
,p_message_text=>unistr('Activar Adici\00F3n de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99527215836304161)
,p_name=>'CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'
,p_message_language=>'es'
,p_message_text=>'Activar Arrastrar y Soltar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100105300608304605)
,p_name=>'CONFIRM.CANCEL_BRANCH'
,p_message_language=>'es'
,p_message_text=>unistr('Cancelar Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100156605240304683)
,p_name=>'CONFIRM.CANCEL_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de Bot\00F3n Cancelar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100148754761304677)
,p_name=>'CONFIRM.CASE_SENSITIVE'
,p_message_language=>'es'
,p_message_text=>unistr('Sensible a May\00FAsculas/Min\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99782713948304353)
,p_name=>'CONFIRM.CHANGE_INTERACTIVE_RPT_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado cambiar la consulta de informe interactivo. Si ha eliminado alguna columna de la consulta, se desactivar\00E1n los filtros, las reglas para resaltar y otros valores existentes del informe que hacen referencia a esas columnas. Confirme la so')
||'licitud.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99693141852304287)
,p_name=>'CONFIRM.CHART_AXIS'
,p_message_language=>'es'
,p_message_text=>unistr('Eje del Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100041963805304556)
,p_name=>'CONFIRM.CHART_DIAL'
,p_message_language=>'es'
,p_message_text=>'Dial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100042087745304556)
,p_name=>'CONFIRM.CHART_DIALSWEEP'
,p_message_language=>'es'
,p_message_text=>'Dial (con Barrido)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99693807819304288)
,p_name=>'CONFIRM.CHART_HORIZONTAL_BAR'
,p_message_language=>'es'
,p_message_text=>'Barra Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99694085240304288)
,p_name=>'CONFIRM.CHART_LINE'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99693313424304288)
,p_name=>'CONFIRM.CHART_NUMBER_MASK'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara de N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99693975453304288)
,p_name=>'CONFIRM.CHART_PIE'
,p_message_language=>'es'
,p_message_text=>'Tarta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99693009653304287)
,p_name=>'CONFIRM.CHART_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Consulta de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99693285944304288)
,p_name=>'CONFIRM.CHART_SCALE'
,p_message_language=>'es'
,p_message_text=>'Escala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99694120191304288)
,p_name=>'CONFIRM.CHART_SCATTER'
,p_message_language=>'es'
,p_message_text=>unistr('Dispersi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99693650877304288)
,p_name=>'CONFIRM.CHART_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99693567984304288)
,p_name=>'CONFIRM.CHART_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo del Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99693483474304288)
,p_name=>'CONFIRM.CHART_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99693704816304288)
,p_name=>'CONFIRM.CHART_VERTICAL_BAR'
,p_message_language=>'es'
,p_message_text=>'Barra Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99600290374304219)
,p_name=>'CONFIRM.COLLECTION'
,p_message_language=>'es'
,p_message_text=>'Nombre de Juego de Resultados Temporal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99690419888304286)
,p_name=>'CONFIRM.COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99905837124304452)
,p_name=>'CONFIRM.COLUMN_HEADING'
,p_message_language=>'es'
,p_message_text=>'Cabeceras de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100068559944304577)
,p_name=>'CONFIRM.COLUMN_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100105580988304605)
,p_name=>'CONFIRM.COLUMN_NAMES'
,p_message_language=>'es'
,p_message_text=>'Nombres de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99702755693304295)
,p_name=>'CONFIRM.COL_HEAD_SORTING'
,p_message_language=>'es'
,p_message_text=>unistr('Usar Ordenaci\00F3n de Cabecera de Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99826778925304385)
,p_name=>'CONFIRM.COPY_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la copia de una aplicaci\00F3n con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99701357211304294)
,p_name=>'CONFIRM.COPY_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la copia de una p\00E1gina con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99690982437304286)
,p_name=>'CONFIRM.CREATE.NEW.TABSET'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1 el nuevo juego de separadores "%0" y se utilizar\00E1 para esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99702977867304295)
,p_name=>'CONFIRM.CREATE_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una aplicaci\00F3n con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99695483361304289)
,p_name=>'CONFIRM.CREATE_CALENDAR'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina de calendario con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99698679747304292)
,p_name=>'CONFIRM.CREATE_DRILL_DOWN'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina de informe desplegable con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99751565501304331)
,p_name=>'CONFIRM.CREATE_DYNAMIC_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina de informe interactivo con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99701626244304294)
,p_name=>'CONFIRM.CREATE_EASY_REPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina de informe con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100710061562305101)
,p_name=>'CONFIRM.CREATE_FLOW_APP_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado crear una aplicaci\00F3n de base de datos con el mismo identificador que la aplicaci\00F3n de base de datos existente en el espacio de trabajo actual. La aplicaci\00F3n de base de datos existente se suprimir\00E1 y se sustituir\00E1 por la nueva aplicaci\00F3n')
||' de base de datos. Confirme las selecciones. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100065487324304574)
,p_name=>'CONFIRM.CREATE_FORM_AND_LIST_VIEW'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de p\00E1ginas de pantalla y vista de lista con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99981443754304510)
,p_name=>'CONFIRM.CREATE_FORM_AND_REPORT_WITH_ANALYSIS'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una pantalla y una p\00E1gina de informe con p\00E1ginas de an\00E1lisis. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99695024713304289)
,p_name=>'CONFIRM.CREATE_FORM_ON_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una pantalla basada en la consulta SQL con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99694901428304289)
,p_name=>'CONFIRM.CREATE_FORM_ON_SP'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una pantalla basada en el procedimiento almacenado con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99694817759304289)
,p_name=>'CONFIRM.CREATE_FORM_ON_TABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una pantalla en la p\00E1gina de tabla con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99570513356304198)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una pantalla basada en una p\00E1gina de referencia de servicio Web con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99610705154304227)
,p_name=>'CONFIRM.CREATE_FORM_ON_WS_RPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una pantalla y un informe basados en una p\00E1gina de referencia de servicio Web con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100009022162304531)
,p_name=>'CONFIRM.CREATE_MAP'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina de Mapa con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99504476276304144)
,p_name=>'CONFIRM.CREATE_MASTER_DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de p\00E1ginas maestras/de detalles con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99696611608304290)
,p_name=>'CONFIRM.CREATE_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una regi\00F3n de ruta de navegaci\00F3n y una opci\00F3n de ruta de navegaci\00F3n con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99987776909304515)
,p_name=>'CONFIRM.CREATE_MODE'
,p_message_language=>'es'
,p_message_text=>'Crear Modo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99694617685304289)
,p_name=>'CONFIRM.CREATE_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100759042400305137)
,p_name=>'CONFIRM.CREATE_PAGE_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Crear P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100759197681305138)
,p_name=>'CONFIRM.CREATE_PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Nombre de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99697413017304291)
,p_name=>'CONFIRM.CREATE_QUERY_AND_UPDATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de p\00E1ginas de pantalla e informe con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100705954717305098)
,p_name=>'CONFIRM.CREATE_REGION_PLUGIN_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99701415584304294)
,p_name=>'CONFIRM.CREATE_REPORT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina de informe con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99695110986304289)
,p_name=>'CONFIRM.CREATE_SIMPLE_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina de gr\00E1fico de barras HTML con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99701069949304293)
,p_name=>'CONFIRM.CREATE_SUMMARY_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina de resumen con los siguientes atributos. Haga clic en el bot\00F3n "Agregar M\00E1s" para agregar m\00E1s elementos de otras p\00E1ginas y/o regiones. Haga clic en "Terminar" para crear los elementos de resumen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99695219189304289)
,p_name=>'CONFIRM.CREATE_SVG_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina de gr\00E1fico SVG con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99694547741304289)
,p_name=>'CONFIRM.CREATE_TABULAR_FORM'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina de pantalla tabular con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99695736516304289)
,p_name=>'CONFIRM.CREATE_TREE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una p\00E1gina de \00E1rbol con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99694728501304289)
,p_name=>'CONFIRM.CREATE_WIZARD'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de un asistente con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100709925928305101)
,p_name=>'CONFIRM.CREATE_WS_APP_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado crear una aplicaci\00F3n de hoja de c\00E1lculo web con el mismo identificador que la aplicaci\00F3n de hoja de c\00E1lculo web existente en el espacio de trabajo actual. La aplicaci\00F3n de hoja de c\00E1lculo web existente se suprimir\00E1 y se sustituir\00E1 por l')
||unistr('a nueva aplicaci\00F3n de hoja de c\00E1lculo web. Confirme las selecciones. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99902561459304449)
,p_name=>'CONFIRM.CSV_TEXT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100646652155305049)
,p_name=>'CONFIRM.DATA_LOAD_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de Definici\00F3n de Carga de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100717041130305106)
,p_name=>'CONFIRM.DATA_LOAD_NAME_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('Esta definici\00F3n de carga de datos se volver\00E1 a crear con las consultas de tabla existentes y las reglas de transformaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100148895182304677)
,p_name=>'CONFIRM.DATA_LOAD_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99695567250304289)
,p_name=>'CONFIRM.DATE_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de Fecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99987800790304515)
,p_name=>'CONFIRM.DEFAULT_AUTH_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de Autenticaci\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99694442029304289)
,p_name=>'CONFIRM.DELETE_PROCESS'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99699369847304292)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLS'
,p_message_language=>'es'
,p_message_text=>'Detalle %0: Columnas Mostradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99507266099304146)
,p_name=>'CONFIRM.DETAIL_DISPLAY_COLUMNS'
,p_message_language=>'es'
,p_message_text=>unistr('Columnas de Visualizaci\00F3n de Detalles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99700901015304293)
,p_name=>'CONFIRM.DETAIL_MENU_COL'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Ruta de Navegaci\00F3n de Detalle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99700191051304293)
,p_name=>'CONFIRM.DETAIL_ORDER_BY'
,p_message_language=>'es'
,p_message_text=>'Tabla de Detalles %0: Ordenar por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99698879323304292)
,p_name=>'CONFIRM.DETAIL_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Detalles %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99507106756304146)
,p_name=>'CONFIRM.DETAIL_TABLE'
,p_message_language=>'es'
,p_message_text=>'Tabla de Detalles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99699194890304292)
,p_name=>'CONFIRM.DETAIL_TABLE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Tabla de Detalles %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99698959069304292)
,p_name=>'CONFIRM.DETAIL_TAB_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de Separador de Detalle %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100105885881304606)
,p_name=>'CONFIRM.DISPLAY_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Cargar Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99692546720304287)
,p_name=>'CONFIRM.DISPLAY_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas Mostradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100068224824304576)
,p_name=>'CONFIRM.DISPLAY_COLUMN_2'
,p_message_language=>'es'
,p_message_text=>'Cargar Columna 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100068333867304576)
,p_name=>'CONFIRM.DISPLAY_COLUMN_3'
,p_message_language=>'es'
,p_message_text=>'Cargar Columna 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99696888583304290)
,p_name=>'CONFIRM.DISPLAY_POINT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100766691746305143)
,p_name=>'CONFIRM.EDIT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Editar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100766702064305143)
,p_name=>'CONFIRM.EDIT_PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Editar el Nombre de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99892498185304441)
,p_name=>'CONFIRM.ENABLE_CSV_OUTPUT'
,p_message_language=>'es'
,p_message_text=>'Salida de CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99893196711304442)
,p_name=>'CONFIRM.ENABLE_PRINT_OUTPUT'
,p_message_language=>'es'
,p_message_text=>unistr('Salida de Impresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99893792692304442)
,p_name=>'CONFIRM.ENABLE_SORTING'
,p_message_language=>'es'
,p_message_text=>unistr('Activar Ordenaci\00F3n de Cabecera de Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99939629517304478)
,p_name=>'CONFIRM.EXISTING_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se agregar\00E1 una regi\00F3n a la p\00E1gina Administraci\00F3n existente:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100105417395304605)
,p_name=>'CONFIRM.FINISH_BRANCH'
,p_message_language=>'es'
,p_message_text=>unistr('Terminar Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99697963916304291)
,p_name=>'CONFIRM.FORM_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99698017665304291)
,p_name=>'CONFIRM.FORM_PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de P\00E1gina de Pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99698269145304291)
,p_name=>'CONFIRM.FORM_PAGE_TAB_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de Separador de P\00E1gina de Pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99698160946304291)
,p_name=>'CONFIRM.FORM_PAGE_TAB_SET'
,p_message_language=>'es'
,p_message_text=>unistr('Juego de Separadores de P\00E1gina de Pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99987936038304515)
,p_name=>'CONFIRM.IMPORT_SHARED_COMPONENTS_FROM'
,p_message_language=>'es'
,p_message_text=>'Importar Componentes Compartidos de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100334795671304817)
,p_name=>'CONFIRM.INCLUDE_CUSTOM_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Incluir Calendario Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99507478701304146)
,p_name=>'CONFIRM.INCLUDE_MASTER_REPORT'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFIncluir Informe Maestro?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99700638153304293)
,p_name=>'CONFIRM.INC_BREAD_CRUMB'
,p_message_language=>'es'
,p_message_text=>unistr('Incluir Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99691735092304286)
,p_name=>'CONFIRM.INFORMATION_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Informaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99691832956304287)
,p_name=>'CONFIRM.INFORMATION_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Informaci\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99570765435304198)
,p_name=>'CONFIRM.INPUT_ITEMS'
,p_message_language=>'es'
,p_message_text=>'Elementos de Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99600463351304220)
,p_name=>'CONFIRM.INPUT_REGION_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99600301255304219)
,p_name=>'CONFIRM.INPUT_REGION_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de Regi\00F3n de Pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99694217785304288)
,p_name=>'CONFIRM.INSERT_PROCESS'
,p_message_language=>'es'
,p_message_text=>'Insertar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99691593779304286)
,p_name=>'CONFIRM.ITEMS'
,p_message_language=>'es'
,p_message_text=>'Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100105725756304606)
,p_name=>'CONFIRM.KEY_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Devolver Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100104622978304605)
,p_name=>'CONFIRM.KEY_COLUMN_1'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave de Consulta 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100104772322304605)
,p_name=>'CONFIRM.KEY_COLUMN_2'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100104851603304605)
,p_name=>'CONFIRM.KEY_COLUMN_3'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99695670338304289)
,p_name=>'CONFIRM.LABEL_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de etiquetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100068443532304576)
,p_name=>'CONFIRM.LOOKUP_OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario de Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100105644696304606)
,p_name=>'CONFIRM.LOOKUP_TABLE'
,p_message_language=>'es'
,p_message_text=>'Tabla de Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99507578847304147)
,p_name=>'CONFIRM.MASTER_DETAIL_LAYOUT'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1o de Maestro/Detalle')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99507035272304146)
,p_name=>'CONFIRM.MASTER_DISPLAY_COLUMNS'
,p_message_language=>'es'
,p_message_text=>unistr('Columnas de Visualizaci\00F3n Maestras')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99507354455304146)
,p_name=>'CONFIRM.MASTER_SORT'
,p_message_language=>'es'
,p_message_text=>'Navegar a Registro Maestro por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99506984622304146)
,p_name=>'CONFIRM.MASTER_TABLE'
,p_message_language=>'es'
,p_message_text=>'Tabla Maestra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99905929493304452)
,p_name=>'CONFIRM.MAXIMUM_COLUMNS'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero M\00E1ximo de Columnas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99902332116304449)
,p_name=>'CONFIRM.MAX_ROWS'
,p_message_language=>'es'
,p_message_text=>unistr('Filas por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99758654619304336)
,p_name=>'CONFIRM.MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99697104553304290)
,p_name=>'CONFIRM.MENU_LINK'
,p_message_language=>'es'
,p_message_text=>unistr('Enlace de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99700719074304293)
,p_name=>'CONFIRM.MENU_ROOT'
,p_message_language=>'es'
,p_message_text=>unistr('Ra\00EDz de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99696926618304290)
,p_name=>'CONFIRM.MENU_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99697292592304291)
,p_name=>'CONFIRM.MENU_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99573253609304200)
,p_name=>'CONFIRM.MIGRATE_HTML_TO_HTML5'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado actualizar el gr\00E1fico HTML al nuevo gr\00E1fico HTML5. Confirme la solicitud.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100725639645305113)
,p_name=>'CONFIRM.MIGRATE_JSTREE_TO_APEXTREE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado actualizar jsTree al nuevo \00E1rbol. Confirme la solicitud.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99683387003304280)
,p_name=>'CONFIRM.MIGRATE_SVG_RESTRICTION'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El gr\00E1fico SVG se actualizar\00E1 con las siguientes restricciones:  '),
'<ul>',
'<li>',
unistr('S\00F3lo se migrar\00E1n los formatos de n\00FAmero definidos en cadenas de formato de eje. Se ignorar\00E1n los formatos de fecha y hora.'),
'</li>',
'<li>',
unistr('Se migrar\00E1n los elementos de formato de n\00FAmero que contienen:'),
'<br />',
'0,9,D,G,, (coma),. (punto),$,C,L,FM',
'</li>',
'<li>',
unistr('La etiqueta de cada serie del gr\00E1fico flash se derivar\00E1 del alias de columna de cada serie.  '),
unistr('Esto es diferente en los gr\00E1ficos SVG, donde la etiqueta de cada serie se deriva del atributo Nombre de la Serie.'),
'</li>',
'<li>',
unistr('Los gr\00E1ficos de dial flash muestran valores reales en lugar de porcentajes.'),
'</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99647314274304254)
,p_name=>'CONFIRM.MIGRATE_SVG_TO_HTML5'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado actualizar el gr\00E1fico SVG a HTML5. Confirme la solicitud.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100705705135305098)
,p_name=>'CONFIRM.NAVIGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99703649854304295)
,p_name=>'CONFIRM.NAV_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100317014904304804)
,p_name=>'CONFIRM.NAV_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Lista de Men\00FA de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99999221481304524)
,p_name=>'CONFIRM.NEW_ADMIN_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se agregar\00E1 una nueva p\00E1gina Administraci\00F3n. P\00E1gina:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99782962806304353)
,p_name=>'CONFIRM.NEW_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas Nuevas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99692398904304287)
,p_name=>'CONFIRM.NEW_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Nueva Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100156475152304683)
,p_name=>'CONFIRM.NEXT_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de Bot\00F3n Siguiente')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99690802603304286)
,p_name=>'CONFIRM.NO.TABSET.SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha seleccionado ning\00FAn juego de separadores para esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99691473850304286)
,p_name=>'CONFIRM.NO_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Sin Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99570893874304198)
,p_name=>'CONFIRM.OUTPUT_ITEMS'
,p_message_language=>'es'
,p_message_text=>'Elementos de Salida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99692792686304287)
,p_name=>'CONFIRM.OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99689706662304285)
,p_name=>'CONFIRM.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99703457904304295)
,p_name=>'CONFIRM.PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99689814528304285)
,p_name=>'CONFIRM.PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99690731416304286)
,p_name=>'CONFIRM.PAGE_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99699249233304292)
,p_name=>'CONFIRM.PARENT_DISPLAY_COLS'
,p_message_language=>'es'
,p_message_text=>unistr('Columnas de Visualizaci\00F3n Principales')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99697340007304291)
,p_name=>'CONFIRM.PARENT_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Ruta de Navegaci\00F3n Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99700826606304293)
,p_name=>'CONFIRM.PARENT_MENU_COL'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Ruta de Navegaci\00F3n Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99699461811304292)
,p_name=>'CONFIRM.PARENT_ORDER_BY'
,p_message_language=>'es'
,p_message_text=>'Tabla Principal: Ordenar por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99698712075304292)
,p_name=>'CONFIRM.PARENT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99699089402304292)
,p_name=>'CONFIRM.PARENT_TABLE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Tabla Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99691336356304286)
,p_name=>'CONFIRM.PARENT_TAB_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de Separador Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99691245343304286)
,p_name=>'CONFIRM.PARENT_TAB_SET'
,p_message_language=>'es'
,p_message_text=>'Juego de Separadores Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99782678479304353)
,p_name=>'CONFIRM.PARSING_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de An\00E1lisis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99789373543304358)
,p_name=>'CONFIRM.PARTIAL_REFRESH_CALENDAR'
,p_message_language=>'es'
,p_message_text=>unistr('Refrescamiento de P\00E1gina Parcial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100156549017304683)
,p_name=>'CONFIRM.PREVIOUS_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de Bot\00F3n Anterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99690613283304286)
,p_name=>'CONFIRM.PRIMARY_KEY'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99698340246304291)
,p_name=>'CONFIRM.PRIMARY_KEY_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99902625790304449)
,p_name=>'CONFIRM.PRINT_FORMAT'
,p_message_language=>'es'
,p_message_text=>'Formato de Salida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99906159714304452)
,p_name=>'CONFIRM.PRINT_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de Enlace de Impresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99902714181304450)
,p_name=>'CONFIRM.PRINT_OUTPUT'
,p_message_language=>'es'
,p_message_text=>unistr('Impresi\00F3n de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99692658461304287)
,p_name=>'CONFIRM.PROCESS_OPTIONS'
,p_message_language=>'es'
,p_message_text=>'Opciones de Proceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99902427833304449)
,p_name=>'CONFIRM.REGION_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99691626374304286)
,p_name=>'CONFIRM.REGION_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99689927508304285)
,p_name=>'CONFIRM.REGION_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de la Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99696758846304290)
,p_name=>'CONFIRM.REGION_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99782849037304353)
,p_name=>'CONFIRM.REMOVED_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas Eliminadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99698409024304291)
,p_name=>'CONFIRM.REPORT_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99922486604304465)
,p_name=>'CONFIRM.REPORT_IMPLEMENTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Implantaci\00F3n de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99697597102304291)
,p_name=>'CONFIRM.REPORT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99697641282304291)
,p_name=>'CONFIRM.REPORT_PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de P\00E1gina de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99697809268304291)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de Separador de P\00E1gina de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99697750652304291)
,p_name=>'CONFIRM.REPORT_PAGE_TAB_SET'
,p_message_language=>'es'
,p_message_text=>unistr('Juego de Separadores de P\00E1gina de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99600659209304220)
,p_name=>'CONFIRM.REPORT_REGION_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99600539811304220)
,p_name=>'CONFIRM.REPORT_REGION_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de Regi\00F3n de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99701787062304294)
,p_name=>'CONFIRM.REPORT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99603134662304222)
,p_name=>'CONFIRM.ROW_VERSION_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Versi\00F3n de Fila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99701978251304294)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME1'
,p_message_language=>'es'
,p_message_text=>unistr('valor por defecto: HTML (est\00E1ndar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99702232937304294)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME11'
,p_message_language=>'es'
,p_message_text=>'valor por defecto: Aspecto 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99702324233304294)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME12'
,p_message_language=>'es'
,p_message_text=>'valor por defecto: Aspecto 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99782493257304353)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME13'
,p_message_language=>'es'
,p_message_text=>'valor por defecto: Aspecto 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99782585881304353)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME14'
,p_message_language=>'es'
,p_message_text=>'valor por defecto: Aspecto 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99601132999304220)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME15'
,p_message_language=>'es'
,p_message_text=>'valor por defecto: Aspecto 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99702063859304294)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME2'
,p_message_language=>'es'
,p_message_text=>'valor por defecto: informe vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99702441312304294)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME21'
,p_message_language=>'es'
,p_message_text=>'exportar: CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99702569575304295)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME22'
,p_message_language=>'es'
,p_message_text=>'exportar: XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99702188924304294)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME3'
,p_message_language=>'es'
,p_message_text=>'valor por defecto: informe vertical, aspecto 1 (incluir columnas nulas)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99782274799304353)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME4'
,p_message_language=>'es'
,p_message_text=>'valor por defecto: informe vertical, aspecto 2 (excluir columnas nulas)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99782369542304353)
,p_name=>'CONFIRM.RPT_TEMPLATE_NAME5'
,p_message_language=>'es'
,p_message_text=>'valor por defecto: informe vertical, aspecto 2 (incluir columnas nulas)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100105972123304606)
,p_name=>'CONFIRM.RULE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Regla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100106121871304606)
,p_name=>'CONFIRM.RULE_SEQUENCE'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100106237118304606)
,p_name=>'CONFIRM.RULE_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Regla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99545887180304179)
,p_name=>'CONFIRM.RUN_SCRIPT'
,p_message_language=>'es'
,p_message_text=>'Ha solicitado ejecutar el siguiente script. Confirme la solicitud.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99697032698304290)
,p_name=>'CONFIRM.SEQUENCE'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99701822361304294)
,p_name=>'CONFIRM.SORT_OPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Opci\00F3n de Ordenaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99692918635304287)
,p_name=>'CONFIRM.SQL_QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99789279852304358)
,p_name=>'CONFIRM.STANDARD_CALENDAR'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99937368603304477)
,p_name=>'CONFIRM.STARTING_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1n varias p\00E1ginas, empezando por la p\00E1gina:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99692868622304287)
,p_name=>'CONFIRM.STORED_PROCEDURE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Procedimiento Almacenado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99784195800304354)
,p_name=>'CONFIRM.STORED_PROCEDURE_OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario de Procedimiento Almacenado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100156708949304683)
,p_name=>'CONFIRM.SUBMIT_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de Bot\00F3n Terminar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100721039411305109)
,p_name=>'CONFIRM.SUBSCRIBE_THEME'
,p_message_language=>'es'
,p_message_text=>'Suscribirse a Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99692128445304287)
,p_name=>'CONFIRM.SUGGESTED_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre Sugerido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99981540240304511)
,p_name=>'CONFIRM.TABLE'
,p_message_language=>'es'
,p_message_text=>'Tabla/Vista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99981625865304511)
,p_name=>'CONFIRM.TABLE_COLS'
,p_message_language=>'es'
,p_message_text=>'Resumir por Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100167875224304691)
,p_name=>'CONFIRM.TABLE_LOOKUPS'
,p_message_language=>'es'
,p_message_text=>'Consultas de Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99690393744304285)
,p_name=>'CONFIRM.TABLE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de la Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99690247804304285)
,p_name=>'CONFIRM.TABLE_OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario de Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100267991209304767)
,p_name=>'CONFIRM.TABLE_RULE'
,p_message_language=>'es'
,p_message_text=>unistr('Regla de Transformaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100106309892304606)
,p_name=>'CONFIRM.TABLE_RULES'
,p_message_language=>'es'
,p_message_text=>unistr('Reglas de Transformaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99783123787304353)
,p_name=>'CONFIRM.TABLE_VIEW_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Tabla/Vista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99783051550304353)
,p_name=>'CONFIRM.TABLE_VIEW_OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario de Tabla/Vista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99703536636304295)
,p_name=>'CONFIRM.TABS'
,p_message_language=>'es'
,p_message_text=>'Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99691156217304286)
,p_name=>'CONFIRM.TABSET.INCOMPLETE'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: La informaci\00F3n del juego de separadores est\00E1 incompleta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99690175455304285)
,p_name=>'CONFIRM.TAB_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de Separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99701509368304294)
,p_name=>'CONFIRM.TAB_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99690099072304285)
,p_name=>'CONFIRM.TAB_SET'
,p_message_language=>'es'
,p_message_text=>'Juego de Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99702689652304295)
,p_name=>'CONFIRM.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'plantilla:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99696336758304290)
,p_name=>'CONFIRM.TREE_LOV'
,p_message_language=>'es'
,p_message_text=>'Basado en el nuevo elemento con una lista de valores emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99696045854304290)
,p_name=>'CONFIRM.TREE_MAX_LEVEL'
,p_message_language=>'es'
,p_message_text=>unistr('Niveles M\00E1ximos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99695850925304290)
,p_name=>'CONFIRM.TREE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de \00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99696246651304290)
,p_name=>'CONFIRM.TREE_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Consulta de \00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99696435189304290)
,p_name=>'CONFIRM.TREE_SQL'
,p_message_language=>'es'
,p_message_text=>'Basado en Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99696137837304290)
,p_name=>'CONFIRM.TREE_START'
,p_message_language=>'es'
,p_message_text=>unistr('Iniciar \00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99696509135304290)
,p_name=>'CONFIRM.TREE_STATIC'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99695922906304290)
,p_name=>'CONFIRM.TREE_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de \00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99703745570304295)
,p_name=>'CONFIRM.UI_THEME'
,p_message_language=>'es'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99703852731304296)
,p_name=>'CONFIRM.UI_THEME1'
,p_message_language=>'es'
,p_message_text=>unistr('Azul y Marr\00F3n Claro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99703955825304296)
,p_name=>'CONFIRM.UI_THEME2'
,p_message_language=>'es'
,p_message_text=>'Rojo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99704065622304296)
,p_name=>'CONFIRM.UI_THEME4'
,p_message_language=>'es'
,p_message_text=>'Azul Marino y Gris'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99704102237304296)
,p_name=>'CONFIRM.UI_THEME5'
,p_message_language=>'es'
,p_message_text=>'Verde Oliva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99704272160304296)
,p_name=>'CONFIRM.UI_THEME6'
,p_message_language=>'es'
,p_message_text=>'Granate'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99704340717304296)
,p_name=>'CONFIRM.UI_THEME7'
,p_message_language=>'es'
,p_message_text=>unistr('Azul B\00E1sico y Marr\00F3n Claro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99704424426304296)
,p_name=>'CONFIRM.UI_THEME8'
,p_message_language=>'es'
,p_message_text=>'Azul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99704509513304296)
,p_name=>'CONFIRM.UI_THEME_NONE'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99690521639304286)
,p_name=>'CONFIRM.UPDATEABLE_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas Actualizables'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99694352506304288)
,p_name=>'CONFIRM.UPDATE_PROCESS'
,p_message_language=>'es'
,p_message_text=>'Actualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99691052015304286)
,p_name=>'CONFIRM.USE.EXISTING.TABSET'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina utilizar\00E1 el juego de separadores existente "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99570651710304198)
,p_name=>'CONFIRM.WEB_SERVICE_REF'
,p_message_language=>'es'
,p_message_text=>unistr('Referencia de Servicio Web, Operaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99698517890304292)
,p_name=>'CONFIRM.WHERE_CLAUSE'
,p_message_language=>'es'
,p_message_text=>unistr('Cl\00E1usula WHERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99972066964304503)
,p_name=>'CONFIRMATION_ICON'
,p_message_language=>'es'
,p_message_text=>unistr('Icono de Confirmaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99982378319304511)
,p_name=>'CONFIRMED'
,p_message_language=>'es'
,p_message_text=>'Confirmado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99982614343304511)
,p_name=>'CONFIRMED_BY_QA'
,p_message_language=>'es'
,p_message_text=>'Confirmado por Preguntas y Respuestas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99902937008304450)
,p_name=>'CONFIRM_BREAK_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columnas Divisorias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99902835264304450)
,p_name=>'CONFIRM_PRINT_FORMAT'
,p_message_language=>'es'
,p_message_text=>unistr('Formato de Impresi\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100010261900304532)
,p_name=>'CONTENT_DISPOSITION'
,p_message_language=>'es'
,p_message_text=>unistr('Disposici\00F3n del Contenido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100042967150304557)
,p_name=>'CONTENT_SERVED_IN_KBYTES'
,p_message_language=>'es'
,p_message_text=>'Contenido Entregado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100821154011305184)
,p_name=>'CONTRIBUTORS'
,p_message_language=>'es'
,p_message_text=>'Contribuyentes'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100735779650305120)
,p_name=>'COPY.PAGE.NEW_STATIC_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Nuevo Identificador Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99782064449304353)
,p_name=>'COPY_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Copiar acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99647112825304254)
,p_name=>'COPY_APP_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n se ha copiado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99761459005304338)
,p_name=>'COPY_BUTTON.EXECUTION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error durante la ejecuci\00F3n de copy_button: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99827322367304386)
,p_name=>'COPY_DEPLOYMENT'
,p_message_language=>'es'
,p_message_text=>unistr('Copiar Atributos de Definici\00F3n de Objeto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99622278680304236)
,p_name=>'COPY_EXISTING_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Copiar Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100066263808304575)
,p_name=>'COPY_FEATURE'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n de Copia: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99826971053304385)
,p_name=>'COPY_FROM_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Copiar de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100207821024304721)
,p_name=>'COPY_FROM_APP_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Basado en Aplicaci\00F3n de Plantilla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99827017520304385)
,p_name=>'COPY_FROM_NAME'
,p_message_language=>'es'
,p_message_text=>'Copiar de Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99650948259304257)
,p_name=>'COPY_LIST_ENTRY'
,p_message_language=>'es'
,p_message_text=>'Copiar Entrada de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99761831866304338)
,p_name=>'COPY_NAMED_LOV.EXECUTION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error durante la ejecuci\00F3n de copy_named_lov: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99761726197304338)
,p_name=>'COPY_NAMED_LOV.NOT_FOUND_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el identificador de lista de valores "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99761605956304338)
,p_name=>'COPY_NAMED_LOV.NUMERIC_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El identificador de lista de valores "%0" no es num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100047737375304560)
,p_name=>'COPY_PAGE.COPY_FROM_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Copiar de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100047877986304561)
,p_name=>'COPY_PAGE.COPY_TO_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Copiar en P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100046806927304560)
,p_name=>'COPY_PAGE.SELECT_AUTHORIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('- Seleccionar Autorizaci\00F3n-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100046757382304560)
,p_name=>'COPY_PAGE.SELECT_LIST'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar Lista -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100046624573304560)
,p_name=>'COPY_PAGE.SELECT_NAMED_LOV'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar Lista de Valores -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100111025763304610)
,p_name=>'COPY_TABLE'
,p_message_language=>'es'
,p_message_text=>'Copiar %0 en la Tabla %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99827170139304385)
,p_name=>'COPY_TO_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Copiar a Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99827236131304385)
,p_name=>'COPY_TO_NAME'
,p_message_language=>'es'
,p_message_text=>'Copiar a Nombre'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99733825718304318)
,p_name=>'CORE'
,p_message_language=>'es'
,p_message_text=>unistr('n\00FAcleo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100176807348304698)
,p_name=>'CREATE APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100176955191304698)
,p_name=>'CREATE OBJECT'
,p_message_language=>'es'
,p_message_text=>'Crear Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100065966544304575)
,p_name=>'CREATED_LAST_7_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('Creaci\00F3n en los \00DAltimos 7 D\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99622317919304236)
,p_name=>'CREATE_APP_FROM_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('De una plantilla de aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100649499907305051)
,p_name=>'CREATE_APP_WIZ.CANDLE_CHARTS'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1ficos de Vela')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100649269890305051)
,p_name=>'CREATE_APP_WIZ.COL_CHARTS'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1ficos de Barras Apiladas con Columnas 2D y 3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100649946986305052)
,p_name=>'CREATE_APP_WIZ.GAUGE_CHARTS'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1ficos de Dial y Dial (Porcentaje)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100649339685305051)
,p_name=>'CREATE_APP_WIZ.PIE_CHARTS'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1ficos de Tarta y Donut 2D y 3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100649682753305052)
,p_name=>'CREATE_APP_WIZ.PROJECTGANTT_CHARTS'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1ficos de Gantt de Proyecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100649827063305052)
,p_name=>'CREATE_APP_WIZ.RANGE_CHARTS'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1ficos de Rango 2D y 3D')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100649773148305052)
,p_name=>'CREATE_APP_WIZ.RESOURCEGANTT_CHARTS'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1ficos de Gantt de Recursos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100649557874305052)
,p_name=>'CREATE_APP_WIZ.SCATTER_CHARTS'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1ficos de Marcador de Dispersi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99727212071304313)
,p_name=>'CREATE_CONDITION.AND'
,p_message_language=>'es'
,p_message_text=>'AND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99727008659304313)
,p_name=>'CREATE_CONDITION.ARROW_DOWN'
,p_message_language=>'es'
,p_message_text=>'Flecha hacia Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99727154317304313)
,p_name=>'CREATE_CONDITION.ARROW_RIGHT'
,p_message_language=>'es'
,p_message_text=>'Flecha a la Derecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99726856116304313)
,p_name=>'CREATE_CONDITION.COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99726932524304313)
,p_name=>'CREATE_CONDITION.CONDITIONS'
,p_message_language=>'es'
,p_message_text=>'Condiciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99727392769304313)
,p_name=>'CREATE_CONDITION.OR'
,p_message_language=>'es'
,p_message_text=>'OR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99727419277304313)
,p_name=>'CREATE_CONDITION.PREVIEW'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Vista Previa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100066644957304575)
,p_name=>'CREATE_DEMO_APP.GRANT'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic en el bot\00F3n Otorgar Privilegios a continuaci\00F3n para otorg\00E1rselos ahora a %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100066482445304575)
,p_name=>'CREATE_DEMO_APP.NO_CREATE_PRIV'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no tiene los privilegios CREATE TABLE, CREATE VIEW, CREATE TRIGGER, CREATE SEQUENCE o CREATE PROCEDURE y no podr\00E1 instalar la aplicaci\00F3n de demostraci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100066593085304575)
,p_name=>'CREATE_DEMO_APP.NO_EXEC_PRIV'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('%0 no dispone de privilegios de ejecuci\00F3n en CTX_DOC ni CTX_DDL y no podr\00E1 instalar la demostraci\00F3n de Discurso Inaugural del Presidente. Ejecute los siguientes permisos como usuario con privilegios: '),
'<pre>',
'GRANT EXECUTE ON CTXSYS.CTX_DDL TO %0; ',
'GRANT EXECUTE ON CTXSYS.CTX_DOC TO %0;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100310450402304799)
,p_name=>'CREATE_DIALOG_CLOSED_DA'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Bot\00F3n: Cuadro de Di\00E1logo Cerrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99543201225304173)
,p_name=>'CREATE_DYNAMIC_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Lista Din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99783983804304354)
,p_name=>'CREATE_DYNAMIC_LOV'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Lista de Valores Din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99521269198304157)
,p_name=>'CREATE_FLOW.CLOUD_IDM'
,p_message_language=>'es'
,p_message_text=>'Oracle Cloud Identity Management'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99560382058304190)
,p_name=>'CREATE_FLOW.DBACCOUNT'
,p_message_language=>'es'
,p_message_text=>'Cuenta de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100201590444304717)
,p_name=>'CREATE_FLOW.HTMLDB_AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Autenticaci\00F3n de Application Express')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100067074850304575)
,p_name=>'CREATE_FLOW.LDAP'
,p_message_language=>'es'
,p_message_text=>'LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100705887162305098)
,p_name=>'CREATE_FLOW.NAVIGATION_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Lista de Men\00FA de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100201672329304717)
,p_name=>'CREATE_FLOW.NO_AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Sin Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100201280717304716)
,p_name=>'CREATE_FLOW.NO_TABS'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn Separador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100201377551304716)
,p_name=>'CREATE_FLOW.ONE_LEVEL_TABS'
,p_message_language=>'es'
,p_message_text=>'Un Nivel de Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100067100888304575)
,p_name=>'CREATE_FLOW.SSO'
,p_message_language=>'es'
,p_message_text=>'Single Sign-On (SSO)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100201479094304716)
,p_name=>'CREATE_FLOW.TWO_LEVEL_TABS'
,p_message_language=>'es'
,p_message_text=>'Dos Niveles de Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99622195559304235)
,p_name=>'CREATE_FROM_SPREADSHEET'
,p_message_language=>'es'
,p_message_text=>unistr('Desde una Hoja de C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99515854926304153)
,p_name=>'CREATE_GLOBAL_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Los componentes de la p\00E1gina global se muestran en todas las p\00E1ginas si el punto de visualizaci\00F3n de su regi\00F3n est\00E1 incluido dentro de la plantilla de p\00E1gina seleccionada. Los atributos de visualizaci\00F3n condicional se pueden utilizar para suprimir la')
||unistr(' visualizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99752543158304331)
,p_name=>'CREATE_INDEX'
,p_message_language=>'es'
,p_message_text=>unistr('Crear \00CDndice')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99925876421304468)
,p_name=>'CREATE_ITEM_WIZ.NO_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('no hay ninguna regi\00F3n asociada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99733557724304318)
,p_name=>'CREATE_NEW_LOGIN_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Nueva P\00E1gina de Conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99728951302304314)
,p_name=>'CREATE_PACKAGE.BACK'
,p_message_language=>'es'
,p_message_text=>unistr('Volver al Asistente de Creaci\00F3n de Tablas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99728400288304314)
,p_name=>'CREATE_PACKAGE.BROWSE'
,p_message_language=>'es'
,p_message_text=>'Examinar Paquete'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99728382209304314)
,p_name=>'CREATE_PACKAGE.CREATED'
,p_message_language=>'es'
,p_message_text=>'Se ha creado el paquete "%0" en el esquema"%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99729060198304314)
,p_name=>'CREATE_PACKAGE.FAILED'
,p_message_language=>'es'
,p_message_text=>'Fallo al crear la tabla "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99728803332304314)
,p_name=>'CREATE_PACKAGE.HOME'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99728635441304314)
,p_name=>'CREATE_PACKAGE.RETURN_TO'
,p_message_language=>'es'
,p_message_text=>'Volver a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99728762824304314)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP'
,p_message_language=>'es'
,p_message_text=>'Taller&nbsp;de&nbsp;SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99728513562304314)
,p_name=>'CREATE_PACKAGE.SQL_WORKSHOP_HOME'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Inicial de Taller de SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99724163323304311)
,p_name=>'CREATE_PAGE_ITEM.NO_ITEM_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99723740037304310)
,p_name=>'CREATE_PAGE_ITEM.PAGE_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99724068797304311)
,p_name=>'CREATE_PAGE_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Petici\00F3n de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99723804575304310)
,p_name=>'CREATE_PAGE_ITEM.REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99723988079304311)
,p_name=>'CREATE_PAGE_ITEM.SET_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('haga clic para definir la regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99721882159304309)
,p_name=>'CREATE_PROCESS.PAGE_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99721951595304309)
,p_name=>'CREATE_PROCESS.REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99728204783304314)
,p_name=>'CREATE_TABLE.HOME'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99728093823304314)
,p_name=>'CREATE_TABLE.RETURN_TO'
,p_message_language=>'es'
,p_message_text=>'Volver a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99727980213304314)
,p_name=>'CREATE_TABLE.RUN_SCRIPT'
,p_message_language=>'es'
,p_message_text=>'Ejecutar Script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99727621992304313)
,p_name=>'CREATE_TABLE.SCRIPT_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('La creaci\00F3n de archivos de comandos de la tabla %0 se ha realizado en el repositorio de archivos de comandos SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99727758947304313)
,p_name=>'CREATE_TABLE.SCRIPT_REPOSITORY'
,p_message_language=>'es'
,p_message_text=>'Ir a Repositorio de Archivos de Comandos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99728190687304314)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP'
,p_message_language=>'es'
,p_message_text=>'Taller&nbsp;de&nbsp;SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99727832557304313)
,p_name=>'CREATE_TABLE.SQL_WORKSHOP_HOME'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Inicial de Taller de SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100157401288304684)
,p_name=>'CREATE_TABULAR_FORM'
,p_message_language=>'es'
,p_message_text=>'Pantalla Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100723690630305111)
,p_name=>'CREATE_TO_DO'
,p_message_language=>'es'
,p_message_text=>'Crear Tarea'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100111607284304610)
,p_name=>'CREATE_TRIGGER'
,p_message_language=>'es'
,p_message_text=>'Crear Disparador %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100057917920304568)
,p_name=>'CREATE_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Los objetos de base de datos de hoja de c\00E1lculo web se han creado.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100012444667304534)
,p_name=>'CREDENTIAL.OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario de Credencial'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99976854425304507)
,p_name=>'CSS_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99900288076304448)
,p_name=>'CURRENT'
,p_message_language=>'es'
,p_message_text=>'Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99969325646304501)
,p_name=>'CURRENT ENTRY'
,p_message_language=>'es'
,p_message_text=>'Entrada Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99969057842304501)
,p_name=>'CURRENT FORM ELEMENT'
,p_message_language=>'es'
,p_message_text=>'Elemento de Pantalla Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99743609520304325)
,p_name=>'CURRENT ITEM HELP TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto de Ayuda de Elemento Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99969103191304501)
,p_name=>'CURRENT ITEM IDENTIFICATION NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Identificaci\00F3n del Elemento Actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99969225400304501)
,p_name=>'CURRENT ITEM LABEL NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Etiqueta del Elemento Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100024928972304543)
,p_name=>'CURRENT TAB'
,p_message_language=>'es'
,p_message_text=>'Separador Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99710270644304300)
,p_name=>'CURRENT_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n Actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99717080053304306)
,p_name=>'CURRENT_IMAGE'
,p_message_language=>'es'
,p_message_text=>'Imagen Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100250558764304754)
,p_name=>'CURRENT_ITEM_CONTAINER_ID'
,p_message_language=>'es'
,p_message_text=>'ID que se puede utilizar en un elemento de contenedor que encapsula el campo actual, en el atributo Antes de Etiqueta y Elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100728338952305115)
,p_name=>'CURRENT_ITEM_HELP_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de Ayuda de Elemento Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99678762375304277)
,p_name=>'CURRENT_MILESTONE'
,p_message_language=>'es'
,p_message_text=>'Hito Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99716180229304305)
,p_name=>'CURRENT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99993616408304520)
,p_name=>'CURRENT_PAGE_CONTAINS_NO_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual no contiene ning\00FAn elemento.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99964934353304498)
,p_name=>'CUSTOMIZE LINK'
,p_message_language=>'es'
,p_message_text=>'Enlace Personalizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100524513973304959)
,p_name=>'CUSTOM_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones Personalizadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99542125970304173)
,p_name=>'CUSTOM_AUTH_SCHEME_DESC'
,p_message_language=>'es'
,p_message_text=>'Desarrollador Definido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99757366009304335)
,p_name=>'CUSTOM_AUTH_SSO_GENERIC_ERR'
,p_message_language=>'es'
,p_message_text=>'Error en %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99678992412304277)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_1'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una cadena que se utilizar\00E1 como identificador de usuario para esta sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99679058333304277)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_2'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de usuario y la contrase\00F1a de %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99679193918304277)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_3'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de usuario y la contrase\00F1a para su verificaci\00F3n por el host LDAP: %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99679242936304277)
,p_name=>'CUSTOM_AUTH_STD.LOGIN_PAGE_4'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de usuario y la contrase\00F1a del esquema de base de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100335090275304817)
,p_name=>'CUSTOM_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Recargar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100340098259304821)
,p_name=>'CUSTOM_CALENDAR.END_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de Finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100339915434304821)
,p_name=>'CUSTOM_CALENDAR.START_DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha de Inicio'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100112529691304611)
,p_name=>'DA.SET_VALUE.SQL.HELP_MSG'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Cuando Acci\00F3n Verdadera es Definir Valor con Definir Tipo como Sentencia SQL, necesita definir los elementos afectados en el mismo orden que el de la columna de la sentencia SQL. La sentencia SQL que ha definido es:</p>'),
'<pre>%0</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99910142074304456)
,p_name=>'DATA'
,p_message_language=>'es'
,p_message_text=>'Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100176496142304698)
,p_name=>'DATA WORKSHOP'
,p_message_language=>'es'
,p_message_text=>'Taller de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99765246558304340)
,p_name=>'DATA.LOAD.ALL_COL_MAPPED'
,p_message_language=>'es'
,p_message_text=>unistr('Todas las columnas %0 se han asignado autom\00E1ticamente a la tabla %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99766060321304341)
,p_name=>'DATA.LOAD.APPEND_INCOMPLETE'
,p_message_language=>'es'
,p_message_text=>'Los datos de la tabla <code>%0</code> se han agregado a <b id="incompl_success_row_count"></b> nuevas filas. <b class="u-danger-text" id="incompl_fail_row_count"></b> filas rechazadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99765697672304341)
,p_name=>'DATA.LOAD.APPEND_SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Los datos de la tabla <code>%0</code> se han agregado a <b id="success_row_count"></b> nuevas filas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99765843707304341)
,p_name=>'DATA.LOAD.APPEND_WARNING'
,p_message_language=>'es'
,p_message_text=>'Los datos de la tabla <code>%0</code> se han agregado a <b id="err_success_row_count"></b> nuevas filas. <b class="u-danger-text" id="err_fail_row_count"></b> filas rechazadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99518340079304155)
,p_name=>'DATA.LOAD.CHOOSE_FILE'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Archivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99512995939304151)
,p_name=>'DATA.LOAD.COLUMN_MAPPING_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar la asignaci\00F3n de columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99555946799304186)
,p_name=>'DATA.LOAD.CONFIGURATION_SAVED'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n guardada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99517948116304154)
,p_name=>'DATA.LOAD.DATA_PROFILE'
,p_message_language=>'es'
,p_message_text=>'Perfil de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99518071002304154)
,p_name=>'DATA.LOAD.DATA_PROFILE_COLS'
,p_message_language=>'es'
,p_message_text=>'Columnas de perfil de datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99517383453304154)
,p_name=>'DATA.LOAD.DATA_SOURCE'
,p_message_language=>'es'
,p_message_text=>'Origen de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99765361202304341)
,p_name=>'DATA.LOAD.DEFINE_COL_MAPPING'
,p_message_language=>'es'
,p_message_text=>unistr('Defina la asignaci\00F3n de columnas para cargar los datos en la tabla %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99517849425304154)
,p_name=>'DATA.LOAD.DEFINITION'
,p_message_language=>'es'
,p_message_text=>unistr('Definici\00F3n de Carga de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99518244393304155)
,p_name=>'DATA.LOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'es'
,p_message_text=>unistr('Arrastre y suelte un archivo aqu\00ED o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99518110466304154)
,p_name=>'DATA.LOAD.FILE_FORMATS'
,p_message_language=>'es'
,p_message_text=>'Los formatos soportados son CSV, XLSX, TXT, XML, JSON'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100174410442304696)
,p_name=>'DATA.LOAD.JOB_INTERMITTENTLY_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('La ejecuci\00F3n del trabajo de carga de datos se ha detenido de forma inesperada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100117381566304614)
,p_name=>'DATA.LOAD.JOB_NAME'
,p_message_language=>'es'
,p_message_text=>'Trabajo de carga de datos del espacio de trabajo %0: Cargar en la tabla %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99517516760304154)
,p_name=>'DATA.LOAD.LOADED_FILE'
,p_message_language=>'es'
,p_message_text=>'Archivo cargado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99765475071304341)
,p_name=>'DATA.LOAD.MAP_REMAINING_COLS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 de %1 columnas se han asignado autom\00E1ticamente a la tabla %2. Configure las %3 columnas restantes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100155573114304682)
,p_name=>'DATA.LOAD.PASTED_DATA'
,p_message_language=>'es'
,p_message_text=>'Datos pegados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99766136226304341)
,p_name=>'DATA.LOAD.REPLACE_INCOMPLETE'
,p_message_language=>'es'
,p_message_text=>'Los datos de la tabla <code>%0</code> se han reemplazado por <b id="incompl_success_row_count"></b> nuevas filas. <b class="u-danger-text" id="incompl_fail_row_count"></b> filas rechazadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99765731419304341)
,p_name=>'DATA.LOAD.REPLACE_SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Los datos de la tabla <code>%0</code> se han reemplazado por <b id="success_row_count"></b> nuevas filas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99765904697304341)
,p_name=>'DATA.LOAD.REPLACE_WARNING'
,p_message_language=>'es'
,p_message_text=>'Los datos de la tabla <code>%0</code> se han reemplazado por <b id="err_success_row_count"></b> nuevas filas. <b class="u-danger-text" id="err_fail_row_count"></b> filas rechazadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99765567300304341)
,p_name=>'DATA.LOAD.SELECT_COLS'
,p_message_language=>'es'
,p_message_text=>'Seleccione las columnas que se van a cargar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99498449073304140)
,p_name=>'DATA.LOAD.SUPPORTED_FORMATS_N'
,p_message_language=>'es'
,p_message_text=>'Formatos soportados %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99517479511304154)
,p_name=>'DATA.LOAD.UPLOAD_A_FILE'
,p_message_language=>'es'
,p_message_text=>'Cargar Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99517650711304154)
,p_name=>'DATA.LOAD.XLSX_WORKSHEET'
,p_message_language=>'es'
,p_message_text=>'Hoja de trabajo XLSX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100717798995305107)
,p_name=>'DATABASE'
,p_message_language=>'es'
,p_message_text=>'Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100177017997304698)
,p_name=>'DATABASE BROWSER'
,p_message_language=>'es'
,p_message_text=>'Explorador de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100662827545305062)
,p_name=>'DATABASE.DEMO.SAMPLE.APP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n de Base de Datos de Ejemplo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100717858006305107)
,p_name=>'DATABASE_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n de Base de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99561811333304191)
,p_name=>'DATABASE_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99577414811304203)
,p_name=>'DATABASE_APPS'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100052661686304564)
,p_name=>'DATABASE_APP_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n <strong>%0</strong> se ha instalado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99955390154304491)
,p_name=>'DATABASE_LINK'
,p_message_language=>'es'
,p_message_text=>'Enlace de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100004820739304528)
,p_name=>'DATABASE_OBJECT_COUNTS_BY_TYPE'
,p_message_language=>'es'
,p_message_text=>'Recuento de Objetos de Base de Datos por Tipo de Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100008075648304531)
,p_name=>'DATABASE_ROLE_PRIVILEGES'
,p_message_language=>'es'
,p_message_text=>'Privilegios de Rol de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99573173987304200)
,p_name=>'DATABASE_USERS'
,p_message_language=>'es'
,p_message_text=>'Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100106820884304606)
,p_name=>'DATA_GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadr\00EDcula de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100652716763305054)
,p_name=>'DATA_GRIDS'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadr\00EDculas de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100653117708305054)
,p_name=>'DATA_GRID_DATA'
,p_message_language=>'es'
,p_message_text=>unistr('Datos de Cuadr\00EDcula de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100639658699305044)
,p_name=>'DATA_LOAD.ADVANCED_SETTINGS_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n Avanzada de Carga de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99652862978304258)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT'
,p_message_language=>'es'
,p_message_text=>unistr('Formatos de Fecha/N\00FAmero que Usar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99652973835304258)
,p_name=>'DATA_LOAD.APP_DATE_FORMAT_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Elija si desea proporcionar m\00E1scaras de formato personalizadas o est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99573542252304200)
,p_name=>'DATA_LOAD.CHARSET'
,p_message_language=>'es'
,p_message_text=>'Juego de Caracteres de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100166264911304690)
,p_name=>'DATA_LOAD.COLUMN_NAMES'
,p_message_language=>'es'
,p_message_text=>'Nombres de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100050711740304563)
,p_name=>'DATA_LOAD.COLUMN_NAME_ALIASES'
,p_message_language=>'es'
,p_message_text=>'Alias de Nombres de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100305675122304795)
,p_name=>'DATA_LOAD.CONFIRM'
,p_message_language=>'es'
,p_message_text=>'Los datos se han cargado correctamente en la tabla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100311106969304799)
,p_name=>'DATA_LOAD.COPY_PASTE'
,p_message_language=>'es'
,p_message_text=>'Copiar y Pegar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100300004079304791)
,p_name=>'DATA_LOAD.COPY_PASTE_TEXTAREA'
,p_message_language=>'es'
,p_message_text=>'Copiar y Pegar Datos Delimitados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100682158642305080)
,p_name=>'DATA_LOAD.CURRENCY_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('S\00EDmbolo de Divisa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100682224753305080)
,p_name=>'DATA_LOAD.CURRENCY_ITEM_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Si los datos contienen un s\00EDmbolo de moneda internacional, introd\00FAzcalo aqu\00ED. Por ejemplo, si los datos tienen "1.234,56 &euro;" o "1.234,56 &yen;", introduzca "&euro;" o "&yen;". De lo contrario, los datos no se cargar\00E1n correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99578295925304203)
,p_name=>'DATA_LOAD.DATA_LOADING'
,p_message_language=>'es'
,p_message_text=>'Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100639718784305044)
,p_name=>'DATA_LOAD.DATE_FORMAT_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Usar M\00E1scaras de Formato Est\00E1ndar de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100639898947305044)
,p_name=>'DATA_LOAD.DATE_FORMAT_CUSTOM'
,p_message_language=>'es'
,p_message_text=>'Proporcionar Formatos Personalizados para Columnas Cargadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100683403779305081)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El car\00E1cter decimal separa la parte entera de la decimal de un n\00FAmero.</p>'),
unistr('<p> Cualquier car\00E1cter puede ser el car\00E1cter decimal. El car\00E1cter especificado debe ser de un solo byte y ser diferente del separador de grupo. Puede ser un espacio pero no puede ser un car\00E1cter num\00E9rico ni los siguientes caracteres:</p>'),
'<ul class="noIndent">',
unistr('<li>m\00E1s (+)</li>'),
'<li>menos (-)</li> ',
'<li>menor que (<)</li>',
'<li>mayor que (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100682505537305080)
,p_name=>'DATA_LOAD.DECIMAL_CHARACTER_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Car\00E1cter Decimal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99681490461304279)
,p_name=>'DATA_LOAD.DECIMAL_CHAR_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe utilizar un car\00E1cter decimal si el separador de grupo se define para la columna de tabla %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100050926292304563)
,p_name=>'DATA_LOAD.DISPLAY'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100117455823304615)
,p_name=>'DATA_LOAD.DUPLICATE_MAPPING'
,p_message_language=>'es'
,p_message_text=>'Se han asignado varias columnas de origen a la columna de tabla %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100448880182304903)
,p_name=>'DATA_LOAD.FAILED_COUNT'
,p_message_language=>'es'
,p_message_text=>'Fila(s) con Fallos:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100664285421305063)
,p_name=>'DATA_LOAD.FAILED_RECORD'
,p_message_language=>'es'
,p_message_text=>'Registros con Fallos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100681734356305080)
,p_name=>'DATA_LOAD.FILE_NAME_ITEM'
,p_message_language=>'es'
,p_message_text=>'Nombre del archivo que desea cargar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100308247631304797)
,p_name=>'DATA_LOAD.FIRST_ROW'
,p_message_language=>'es'
,p_message_text=>'La Primera Fila Tiene Nombres de Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100681807321305080)
,p_name=>'DATA_LOAD.FIRST_ROW_HELP'
,p_message_language=>'es'
,p_message_text=>'Active esta casilla si los datos contienen nombres de columna en la primera fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100682081097305080)
,p_name=>'DATA_LOAD.GLOBALIZATION_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Globalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100682400031305080)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un separador de grupos es un car\00E1cter que separa los grupos de enteros, por ejemplo, para mostrar los miles y millones.</p>'),
unistr('<p>Cualquier car\00E1cter puede ser el separador de grupos. El car\00E1cter especificado debe ser de un solo byte y ser diferente del car\00E1cter decimal. Puede ser un espacio pero no puede ser un car\00E1cter num\00E9rico ni los siguientes caracteres:</p>'),
'<ul class="noIndent">',
unistr('<li>m\00E1s (+)</li>'),
'<li>menos (-)</li> ',
'<li>menor que (<)</li>',
'<li>mayor que (>)</li> ',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100682330311305080)
,p_name=>'DATA_LOAD.GROUP_SEPARATOR_ITEM'
,p_message_language=>'es'
,p_message_text=>'Separador de Grupos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100448615192304903)
,p_name=>'DATA_LOAD.INSERTED_COUNT'
,p_message_language=>'es'
,p_message_text=>'Fila(s) Insertada(s):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100679239133305074)
,p_name=>'DATA_LOAD.IR_MAX_ROW_COUNT'
,p_message_language=>'es'
,p_message_text=>unistr('Esta consulta devuelve m\00E1s de #MAX_ROW_COUNT# filas; filtre los datos para asegurar resultados completos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100049687343304562)
,p_name=>'DATA_LOAD.JUSTCHANGED_RECORD'
,p_message_language=>'es'
,p_message_text=>'Registros Cargados por Otro Usuario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99672810406304273)
,p_name=>'DATA_LOAD.LABEL_CASE_SENSITIVE'
,p_message_language=>'es'
,p_message_text=>unistr('Sensible a May\00FAsculas/Min\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99672752636304273)
,p_name=>'DATA_LOAD.LABEL_UNIQUE_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna \00DAnica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100271734861304770)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'es'
,p_message_text=>'Fallo de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100271855814304770)
,p_name=>'DATA_LOAD.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n Procesada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100295831788304788)
,p_name=>'DATA_LOAD.LOAD_TO'
,p_message_language=>'es'
,p_message_text=>'Importar de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100105021294304605)
,p_name=>'DATA_LOAD.MAPPING_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Paso 2: Nombre de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100730127763305116)
,p_name=>'DATA_LOAD.NO_PREVIEW'
,p_message_language=>'es'
,p_message_text=>'No hay disponible ninguna vista previa del archivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100680921202305079)
,p_name=>'DATA_LOAD.OPTIONAL_ENCLOSE_ITEM'
,p_message_language=>'es'
,p_message_text=>'Delimitado Opcionalmente por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100643171951305047)
,p_name=>'DATA_LOAD.PROGRESS_TITLE'
,p_message_language=>'es'
,p_message_text=>'Progreso de Asistente de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100105261403304605)
,p_name=>'DATA_LOAD.RESULTS_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Paso 4: Nombre de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100050867437304563)
,p_name=>'DATA_LOAD.RETURN'
,p_message_language=>'es'
,p_message_text=>'Volver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100049178342304561)
,p_name=>'DATA_LOAD.REVIEW_COUNT'
,p_message_language=>'es'
,p_message_text=>'Filas para Revisar:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100163376481304688)
,p_name=>'DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'to_char(sysdate)',
'',
'my_func (',
'    p_1 => :SAL,',
'    p_2 => :COMM)',
'',
'donde SAL y COMM son nombres de columna de los datos cargados',
unistr('y my_func es la funci\00F3n que devuelve el valor que ser\00E1 el nuevo valor'),
unistr('para la columna para la que se ha definido esta regla de transformaci\00F3n.'),
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100163557360304688)
,p_name=>'DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_result number;',
'begin',
'   l_result := :SAL * :COMM',
'   return l_result;',
'end;',
'',
unistr('El resultado devuelto ser\00E1 el nuevo valor de la columna para la que se ha definido esta regla de transformaci\00F3n.'),
'',
'Y :SAL y :COMM hacen referencia a los nombres de columna SAL y COMM de los datos cargados.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100163417257304688)
,p_name=>'DATA_LOAD.RULES_SQL_QUERY_EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select depno',
' from dept',
'donde dname = :DEPTNAME',
'  y  oc = :LOC',
'',
'donde :DEPNAME y :LOC hacen referencia a los nombres de columna DEPNAME y LOC de los datos cargados.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99689537586304285)
,p_name=>'DATA_LOAD.SAME_GROUP_DECIMAL_CHARS'
,p_message_language=>'es'
,p_message_text=>unistr('En la columna de tabla %0, no se puede definir el mismo car\00E1cter como separador de grupo y car\00E1cter decimal. Introduzca caracteres diferentes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100680725117305079)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Identifique un car\00E1cter separador de columnas. Utilice <code>\005Ct</code> como separador de tabulador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100680811710305079)
,p_name=>'DATA_LOAD.SEPARATOR_ITEM_LABEL'
,p_message_language=>'es'
,p_message_text=>'Separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100051023516304563)
,p_name=>'DATA_LOAD.SEQUENCE'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100639427507305044)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Usar Configuraci\00F3n Avanzada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100639525870305044)
,p_name=>'DATA_LOAD.SHOW_ADVANCED_SETTINGS_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra la configuraci\00F3n avanzada para la carga de datos: S\00EDmbolo de Moneda, Caracteres Decimales, Codificaci\00F3n de Archivo o Formatos de Fecha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100315795694304803)
,p_name=>'DATA_LOAD.SOURCE'
,p_message_language=>'es'
,p_message_text=>'Origen de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100104915661304605)
,p_name=>'DATA_LOAD.SOURCE_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Paso 1: Nombre de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100718087050305107)
,p_name=>'DATA_LOAD.TAB_SEPARTOR_NOTE'
,p_message_language=>'es'
,p_message_text=>'(\t para separador)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100679584423305075)
,p_name=>'DATA_LOAD.UNIQUE_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna \00DAnica %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100448726694304903)
,p_name=>'DATA_LOAD.UPDATED_COUNT'
,p_message_language=>'es'
,p_message_text=>'Fila(s) Actualizada(s):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100759350276305138)
,p_name=>'DATA_LOAD.UPLOADED_NULL_VALUE'
,p_message_language=>'es'
,p_message_text=>'Se ha cargado un valor nulo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100311085171304799)
,p_name=>'DATA_LOAD.UPLOAD_FILE'
,p_message_language=>'es'
,p_message_text=>'Cargar Archivo, Separado por Comas (*.csv) o Delimitado por Tabuladores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100315945116304803)
,p_name=>'DATA_LOAD.UPLOAD_RESULTS'
,p_message_language=>'es'
,p_message_text=>'Resultados de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100315826668304803)
,p_name=>'DATA_LOAD.VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100105145376304605)
,p_name=>'DATA_LOAD.VALIDATION_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Paso 3: Nombre de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100109299177304608)
,p_name=>'DATA_LOAD_WIZARD_CREATED_SUCCESSFULLY'
,p_message_language=>'es'
,p_message_text=>unistr('Las p\00E1ginas del asistente de carga de datos se han creado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100271924748304770)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Asignaci\00F3n de Datos/Tabla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100272078582304770)
,p_name=>'DATA_SAVE.LOAD_DATA_PROCESS_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n Procesada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99978049345304508)
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'es'
,p_message_text=>unistr('Carga de Datos: Asignaci\00F3n de Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99702810586304295)
,p_name=>'DATA_WORKSHOP.CONFIGURE.COLUMN_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de columna: Columna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99564680519304193)
,p_name=>'DATA_WORKSHOP.CONFIGURE.DECIMAL_CHARACTER'
,p_message_language=>'es'
,p_message_text=>unistr('Car\00E1cter decimal: columna %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99564854661304193)
,p_name=>'DATA_WORKSHOP.CONFIGURE.FORMAT_MASK'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara de formato: columna %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99564723955304193)
,p_name=>'DATA_WORKSHOP.CONFIGURE.GROUP_SEPARATOR'
,p_message_language=>'es'
,p_message_text=>'Separador de grupos: columna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99565027515304193)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAP_TO_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Asignar a: columna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99751977956304331)
,p_name=>'DATA_WORKSHOP.CONFIGURE.MAX_LENGTH'
,p_message_language=>'es'
,p_message_text=>unistr('Longitud m\00E1xima: Columna %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99564936265304193)
,p_name=>'DATA_WORKSHOP.CONFIGURE.UNMAPPED'
,p_message_language=>'es'
,p_message_text=>'- Columna no asignada -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100098177105304600)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID'
,p_message_language=>'es'
,p_message_text=>'El valor de atributo de fecha resaltado %0 introducido para el elemento %1 no coincide con el formato %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100103335269304604)
,p_name=>'DATEPICKER.DEFAULT_DATE_INVALID_RELATIVE'
,p_message_language=>'es'
,p_message_text=>'El valor de atributo de fecha resaltado %0 introducido para el elemento %1 no es una fecha relativa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100098347291304600)
,p_name=>'DATEPICKER.MAX_DATE_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('El valor de atributo de fecha m\00E1ximo %0 introducido para el elemento %1 no coincide con el formato %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100103598946304604)
,p_name=>'DATEPICKER.MAX_DATE_INVALID_RELATIVE'
,p_message_language=>'es'
,p_message_text=>unistr('El valor de atributo de fecha m\00E1ximo %0 introducido para el elemento %1 no es una fecha relativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99515675945304153)
,p_name=>'DATEPICKER.MAX_STATIC_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('El valor de atributo est\00E1tico m\00E1ximo introducido, %0, para el elemento %1 no coincide con el formato %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100098234166304600)
,p_name=>'DATEPICKER.MIN_DATE_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor de atributo de fecha m\00EDnimo %0 para el elemento %1 que no coincide con el formato %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100103407494304604)
,p_name=>'DATEPICKER.MIN_DATE_INVALID_RELATIVE'
,p_message_language=>'es'
,p_message_text=>unistr('El valor de atributo de fecha m\00EDnimo %0 introducido para el elemento %1 no es una fecha relativa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99515574658304153)
,p_name=>'DATEPICKER.MIN_STATIC_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('El valor de atributo est\00E1tico m\00EDnimo introducido, %0, para el elemento %1 no coincide con el formato %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100205442578304719)
,p_name=>'DATE_ADDED'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de Adici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100650138992305052)
,p_name=>'DATE_OF_LAST_RUN'
,p_message_language=>'es'
,p_message_text=>unistr('Hora de \00FAltima ejecuci\00F3n de trabajos de la base de datos de Oracle APEX')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100027981504304546)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE'
,p_message_language=>'es'
,p_message_text=>'en el hito final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100028093168304546)
,p_name=>'DAYS_BEFORE_FINAL_MILESTONE_OF_RELASE'
,p_message_language=>'es'
,p_message_text=>unistr('en el hito final de la versi\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100102706136304603)
,p_name=>'DA_NAME.NATIVE_ADD_CLASS'
,p_message_language=>'es'
,p_message_text=>'Agregar Clase'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100655546124305056)
,p_name=>'DA_NAME.NATIVE_ALERT'
,p_message_language=>'es'
,p_message_text=>'Alerta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100654342291305055)
,p_name=>'DA_NAME.NATIVE_CANCEL_EVENT'
,p_message_language=>'es'
,p_message_text=>'Cancelar Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100655715488305056)
,p_name=>'DA_NAME.NATIVE_CLEAR'
,p_message_language=>'es'
,p_message_text=>'Borrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100655689764305056)
,p_name=>'DA_NAME.NATIVE_CONFIRM'
,p_message_language=>'es'
,p_message_text=>'Confirmar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99495017258304137)
,p_name=>'DA_NAME.NATIVE_DIALOG_CANCEL'
,p_message_language=>'es'
,p_message_text=>unistr('Cancelar Cuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99495194576304137)
,p_name=>'DA_NAME.NATIVE_DIALOG_CLOSE'
,p_message_language=>'es'
,p_message_text=>unistr('Cerrar Recuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99647041740304254)
,p_name=>'DA_NAME.NATIVE_DISABLE'
,p_message_language=>'es'
,p_message_text=>'Desactivar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99646934834304254)
,p_name=>'DA_NAME.NATIVE_ENABLE'
,p_message_language=>'es'
,p_message_text=>'Activar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100647253207305050)
,p_name=>'DA_NAME.NATIVE_EXECUTE_PLSQL_CODE'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecutar C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99646833611304254)
,p_name=>'DA_NAME.NATIVE_HIDE'
,p_message_language=>'es'
,p_message_text=>'Ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100023233738304542)
,p_name=>'DA_NAME.NATIVE_JAVASCRIPT_CODE'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecutar C\00F3digo JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100277438685304774)
,p_name=>'DA_NAME.NATIVE_REFRESH'
,p_message_language=>'es'
,p_message_text=>'Refrescar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100102823217304603)
,p_name=>'DA_NAME.NATIVE_REMOVE_CLASS'
,p_message_language=>'es'
,p_message_text=>'Eliminar Clase'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100102905693304603)
,p_name=>'DA_NAME.NATIVE_SET_CSS'
,p_message_language=>'es'
,p_message_text=>'Definir Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100260340827304762)
,p_name=>'DA_NAME.NATIVE_SET_FOCUS'
,p_message_language=>'es'
,p_message_text=>'Definir Foco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100023114424304542)
,p_name=>'DA_NAME.NATIVE_SET_VALUE'
,p_message_language=>'es'
,p_message_text=>'Definir Valor'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99646799388304254)
,p_name=>'DA_NAME.NATIVE_SHOW'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100260479019304762)
,p_name=>'DA_NAME.NATIVE_SUBMIT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecutar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100241915168304747)
,p_name=>'DA_NAME.NATIVE_TREE_COLLAPSE'
,p_message_language=>'es'
,p_message_text=>unistr('Reducir \00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100241833663304747)
,p_name=>'DA_NAME.NATIVE_TREE_EXPAND'
,p_message_language=>'es'
,p_message_text=>unistr('Ampliar \00C1rbol')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99544321453304177)
,p_name=>'DBACCOUNT_AUTH_SCHEME_DESC'
,p_message_language=>'es'
,p_message_text=>'Cuenta de Base de Datos'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100019895134304539)
,p_name=>'DB_COLS_CASE_SEN'
,p_message_language=>'es'
,p_message_text=>unistr('Los nombres de columna y tabla de base de datos son sensibles a may\00FAsculas y min\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100119565265304616)
,p_name=>'DB_OBJECT_CREATION_EXCEPTION'
,p_message_language=>'es'
,p_message_text=>unistr('excepci\00F3n de creaci\00F3n de objeto de base de datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99557940455304188)
,p_name=>'DB_PRODUCT_NAME'
,p_message_language=>'es'
,p_message_text=>'Oracle Database'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100708203029305100)
,p_name=>'DB_SERVICES_ALIAS'
,p_message_language=>'es'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100704909148305097)
,p_name=>'DB_SERVICES_ALL_MIMES'
,p_message_language=>'es'
,p_message_text=>'Todos los Tipos MIME'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100707971555305099)
,p_name=>'DB_SERVICES_CREATE_HANDLER'
,p_message_language=>'es'
,p_message_text=>'Crear manejador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100705219696305097)
,p_name=>'DB_SERVICES_CREATE_METHOD'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todo de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100705030823305097)
,p_name=>'DB_SERVICES_CREATE_PARAMETER'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Par\00E1metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100705137949305097)
,p_name=>'DB_SERVICES_CREATE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Crear Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100712115237305102)
,p_name=>'DB_SERVICES_DB_SERVICES_MODULE'
,p_message_language=>'es'
,p_message_text=>unistr('M\00F3dulo de Servicio RESTful')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100707809982305099)
,p_name=>'DB_SERVICES_HANDLER'
,p_message_language=>'es'
,p_message_text=>'Manejador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100712694140305103)
,p_name=>'DB_SERVICES_HANDLER_BIND_VARIABLE'
,p_message_language=>'es'
,p_message_text=>'Variable de Enlace del Manejador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100685084018305082)
,p_name=>'DB_SERVICES_HANDLER_METHOD'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todo de Manejador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100712955042305103)
,p_name=>'DB_SERVICES_HANDLER_SOURCE'
,p_message_language=>'es'
,p_message_text=>'Origen del Manejador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100685148771305082)
,p_name=>'DB_SERVICES_HANDLER_SRC_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Origen de Manejador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100704772935305097)
,p_name=>'DB_SERVICES_METHOD'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100712203514305102)
,p_name=>'DB_SERVICES_MODULE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre del M\00F3dulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100712782210305103)
,p_name=>'DB_SERVICES_MODULE_URI'
,p_message_language=>'es'
,p_message_text=>unistr('Prefijo URI de M\00F3dulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100705350499305097)
,p_name=>'DB_SERVICES_NO_SOURCE'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn Origen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100704639429305097)
,p_name=>'DB_SERVICES_PARAMETER'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100712462020305103)
,p_name=>'DB_SERVICES_RESTFUL_SERVICES'
,p_message_language=>'es'
,p_message_text=>'Servicios RESTful'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100704866572305097)
,p_name=>'DB_SERVICES_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100712839126305103)
,p_name=>'DB_SERVICES_TEMPLATE_URI'
,p_message_language=>'es'
,p_message_text=>'Plantilla de URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100684926016305082)
,p_name=>'DB_SERVICES_URI'
,p_message_language=>'es'
,p_message_text=>'Identificador de Recursos Uniforme (URI)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100711967598305102)
,p_name=>'DB_SERVICES_URI_PRIFIX'
,p_message_language=>'es'
,p_message_text=>'Prefijo de URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100712035180305102)
,p_name=>'DB_SERVICES_URI_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100685220553305082)
,p_name=>'DB_SERVICE_QUERY_ONE_ROW'
,p_message_language=>'es'
,p_message_text=>'Consultar Una Fila'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99929188790304470)
,p_name=>'DEBUG'
,p_message_language=>'es'
,p_message_text=>'Depurar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100035550257304551)
,p_name=>'DECLINED'
,p_message_language=>'es'
,p_message_text=>'Rechazado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100757875040305137)
,p_name=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Bot\00F3n de Cuadro de Di\00E1logo por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100757762356305137)
,p_name=>'DEFAULT_DIALOGR_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Contenido de Cuadro de Di\00E1logo por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100272634775304771)
,p_name=>'DEFAULT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99914919038304459)
,p_name=>'DEFAULT_TABLESPACE'
,p_message_language=>'es'
,p_message_text=>'tablespace por defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99916560875304461)
,p_name=>'DEFAULT_TABLESPACE_INIT'
,p_message_language=>'es'
,p_message_text=>'Tablespace por defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100165077819304689)
,p_name=>'DEFAULT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla por Defecto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99540343041304171)
,p_name=>'DEFINED_BY_DA'
,p_message_language=>'es'
,p_message_text=>unistr('Definida por Acci\00F3n Din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100331373562304815)
,p_name=>'DEFINED_TABS'
,p_message_language=>'es'
,p_message_text=>unistr('Esta aplicaci\00F3n tiene %0 separadores organizados en %1 juegos de separadores y tiene definidos %2 separadores principales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99783893401304354)
,p_name=>'DEFINE_LOV'
,p_message_language=>'es'
,p_message_text=>'Definir Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99965064329304498)
,p_name=>'DEFINITION'
,p_message_language=>'es'
,p_message_text=>unistr('Definici\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100117244306304614)
,p_name=>'DEINSTALLATION_SCRIPT'
,p_message_language=>'es'
,p_message_text=>unistr('Script de Desinstalaci\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99635512561304245)
,p_name=>'DELETED'
,p_message_language=>'es'
,p_message_text=>'Suprimido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100652247342305054)
,p_name=>'DELETE_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Suprimir Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100157518323304684)
,p_name=>'DELETE_LABEL'
,p_message_language=>'es'
,p_message_text=>'Suprimir: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100149744039304678)
,p_name=>'DELETE_LINK_TEXT'
,p_message_language=>'es'
,p_message_text=>'Suprimir %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99567581345304195)
,p_name=>'DELETE_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFDesea realizar esta acci\00F3n de supresi\00F3n?')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99591811416304213)
,p_name=>'DEMO.COLLECT.DESCR'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra de recopilaciones le permite almacenar filas de datos para su uso en una sesi\00F3n de Oracle APEX. Esta aplicaci\00F3n de base de datos muestra c\00F3mo utilizar PL/SQL para crear y gestionar el estado de la sesi\00F3n basada en recopilaciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99591622918304213)
,p_name=>'DEMO.SAMPLE.APP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n de Ejemplo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99591755647304213)
,p_name=>'DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'es'
,p_message_text=>unistr('Product Portal es una aplicaci\00F3n de ejemplo que resalta los conceptos de dise\00F1o comunes. Incluye p\00E1ginas dedicadas para clientes, productos y \00F3rdenes, adem\00E1s de demostrar el uso de los informes, los gr\00E1ficos, el calendario, el mapa y el \00E1rbol.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99985953182304514)
,p_name=>'DEMONSTRABLE'
,p_message_language=>'es'
,p_message_text=>'Demostrable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99712659691304302)
,p_name=>'DEMO_APPLICATION.ABOUT_BUSINESS_LOOK'
,p_message_language=>'es'
,p_message_text=>unistr('Ejemplos de informes robustos y conceptos de paginaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99712393122304302)
,p_name=>'DEMO_APPLICATION.ABOUT_PETSTORE'
,p_message_language=>'es'
,p_message_text=>unistr('Ejemplo del almac\00E9n en l\00EDnea creado mediante %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99713095790304302)
,p_name=>'DEMO_APPLICATION.ABOUT_PRESIDENTIAL'
,p_message_language=>'es'
,p_message_text=>unistr('Aprenda c\00F3mo utilizar Oracle Text con %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99713446981304303)
,p_name=>'DEMO_APPLICATION.ABOUT_PROJ_TRACKING'
,p_message_language=>'es'
,p_message_text=>unistr('Ejemplo de aplicaci\00F3n de seguimiento de estado del proyecto creada con %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99712814319304302)
,p_name=>'DEMO_APPLICATION.ABOUT_WEBSERVICES'
,p_message_language=>'es'
,p_message_text=>'Aprenda a utilizar los servicios Web con %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99711286221304301)
,p_name=>'DEMO_APPLICATION.ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99709166592304300)
,p_name=>'DEMO_APPLICATION.APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99708808560304299)
,p_name=>'DEMO_APPLICATION.BASIC_LEXER'
,p_message_language=>'es'
,p_message_text=>'BASIC_LEXER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99712586103304302)
,p_name=>'DEMO_APPLICATION.BUSINESS_LOOK'
,p_message_language=>'es'
,p_message_text=>'Aspecto de Negocio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99711357838304301)
,p_name=>'DEMO_APPLICATION.COLLECTION_SHOWCASE'
,p_message_language=>'es'
,p_message_text=>'Muestra de Recopilaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99708923008304299)
,p_name=>'DEMO_APPLICATION.CONTEXT_INDEX'
,p_message_language=>'es'
,p_message_text=>unistr('\00CDndice CONTEXT')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99708392804304299)
,p_name=>'DEMO_APPLICATION.CREATE_BASIC'
,p_message_language=>'es'
,p_message_text=>unistr('Va a crear la aplicaci\00F3n de demostraci\00F3n de Ejemplos B\00E1sicos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99706975576304298)
,p_name=>'DEMO_APPLICATION.CREATE_BUSINESS_LOOK'
,p_message_language=>'es'
,p_message_text=>unistr('Va a volver a crear la aplicaci\00F3n de demostraci\00F3n de aspecto de negocio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99708458764304299)
,p_name=>'DEMO_APPLICATION.CREATE_COLLECTION_SHOWCASE'
,p_message_language=>'es'
,p_message_text=>unistr('Va a crear la aplicaci\00F3n de demostraci\00F3n de Muestra de Recopilaciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99708537905304299)
,p_name=>'DEMO_APPLICATION.CREATE_OR_RECREATE'
,p_message_language=>'es'
,p_message_text=>'crear o volver a crear en el esquema %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99706894082304298)
,p_name=>'DEMO_APPLICATION.CREATE_WEB_SERVICES'
,p_message_language=>'es'
,p_message_text=>unistr('Cree una aplicaci\00F3n de ejemplo para mostrar los servicios Web.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99707022821304298)
,p_name=>'DEMO_APPLICATION.CREATE_WORLDCUP_MANIA'
,p_message_language=>'es'
,p_message_text=>unistr('Va a crear la aplicaci\00F3n de demostraci\00F3n Worldcup Mania.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99548002033304180)
,p_name=>'DEMO_APPLICATION.DEINSTALL'
,p_message_language=>'es'
,p_message_text=>'Eliminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99711053055304301)
,p_name=>'DEMO_APPLICATION.DEMO_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n de Demostraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99709470785304300)
,p_name=>'DEMO_APPLICATION.FREE_SPACE'
,p_message_language=>'es'
,p_message_text=>'Tiene aproximadamente %0 MB libres.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99711896104304302)
,p_name=>'DEMO_APPLICATION.INSTALL'
,p_message_language=>'es'
,p_message_text=>'Instalar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99711553282304301)
,p_name=>'DEMO_APPLICATION.INSTALLED'
,p_message_language=>'es'
,p_message_text=>'Instalado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99843576580304402)
,p_name=>'DEMO_APPLICATION.INSTALL_DEMO_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Va a instalar la aplicaci\00F3n de ejemplo que le expondr\00E1 una demostraci\00F3n las funciones clave de %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99712485272304302)
,p_name=>'DEMO_APPLICATION.INSTALL_NOW'
,p_message_language=>'es'
,p_message_text=>'Instalar Ahora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99711474539304301)
,p_name=>'DEMO_APPLICATION.LEARN_ABOUT'
,p_message_language=>'es'
,p_message_text=>'Aprenda los conceptos sobre el carro de la compra de %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100152592934304680)
,p_name=>'DEMO_APPLICATION.LOCKED'
,p_message_language=>'es'
,p_message_text=>'Bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99709253598304300)
,p_name=>'DEMO_APPLICATION.NEED_7M'
,p_message_language=>'es'
,p_message_text=>unistr('La demostraci\00F3n de Discurso Inaugural del Presidente necesita alrededor de 7 MB de espacio libre en disco y puede tardar dos minutos en instalarse en el esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99843228233304402)
,p_name=>'DEMO_APPLICATION.NOT_ENOUGH_SPACE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No hay suficiente espacio para crear esta demostraci\00F3n. Solicite almacenamiento adicional en la p\00E1gina de administraci\00F3n, accediendo a la secci\00F3n de servicios de provisionamiento y haciendo clic en el enlace para solicitar almacenamiento adicional. %')
||'0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99711706859304302)
,p_name=>'DEMO_APPLICATION.NOT_INSTALLED'
,p_message_language=>'es'
,p_message_text=>'No Instalado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99707785047304299)
,p_name=>'DEMO_APPLICATION.OBJECT_EXIST'
,p_message_language=>'es'
,p_message_text=>'Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99706643626304298)
,p_name=>'DEMO_APPLICATION.OBJECT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99707684925304298)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99708735241304299)
,p_name=>'DEMO_APPLICATION.OBJECT_NAME2'
,p_message_language=>'es'
,p_message_text=>'Nombre del Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99706730841304298)
,p_name=>'DEMO_APPLICATION.OBJECT_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'no existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99707314727304298)
,p_name=>'DEMO_APPLICATION.OBJECT_RECREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Se volver\00E1n a crear los siguientes objetos de base de datos si \00E9stos existen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99707507360304298)
,p_name=>'DEMO_APPLICATION.OBJECT_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Objeto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99708244507304299)
,p_name=>'DEMO_APPLICATION.PACKAGE'
,p_message_language=>'es'
,p_message_text=>'Paquete'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99712280257304302)
,p_name=>'DEMO_APPLICATION.PETSTORE'
,p_message_language=>'es'
,p_message_text=>'Tienda de Animales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99712936354304302)
,p_name=>'DEMO_APPLICATION.PRESIDENTIAL'
,p_message_language=>'es'
,p_message_text=>'Discursos Inaugurales del Presidente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99713272624304303)
,p_name=>'DEMO_APPLICATION.PROJECT_TRACKING'
,p_message_language=>'es'
,p_message_text=>'Seguimiento de Proyectos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99920421787304464)
,p_name=>'DEMO_APPLICATION.RE_INSTALL'
,p_message_language=>'es'
,p_message_text=>'Volver a Instalar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99711606379304301)
,p_name=>'DEMO_APPLICATION.RUN'
,p_message_language=>'es'
,p_message_text=>'Ejecutar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99707407492304298)
,p_name=>'DEMO_APPLICATION.SCHEMA'
,p_message_language=>'es'
,p_message_text=>'Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99708002591304299)
,p_name=>'DEMO_APPLICATION.SEQUENCE'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99711199884304301)
,p_name=>'DEMO_APPLICATION.STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99707865408304299)
,p_name=>'DEMO_APPLICATION.TABLE'
,p_message_language=>'es'
,p_message_text=>'Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99710981685304301)
,p_name=>'DEMO_APPLICATION.TABLE_SUMMARY'
,p_message_language=>'es'
,p_message_text=>unistr('Informe de Estado de Instalaci\00F3n de Aplicaci\00F3n de Demostraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99708141453304299)
,p_name=>'DEMO_APPLICATION.TRIGGER'
,p_message_language=>'es'
,p_message_text=>'Disparador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100152632193304680)
,p_name=>'DEMO_APPLICATION.UNLOCKED'
,p_message_language=>'es'
,p_message_text=>'Desbloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99573312576304200)
,p_name=>'DEMO_APPLICATION.UPDATE_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Actualizaci\00F3n Disponible')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100730941662305116)
,p_name=>'DEMO_APPLICATION.WEBSHEET_OBJECT_VALIDATE'
,p_message_language=>'es'
,p_message_text=>unistr('Es necesario corregir los siguientes objetos no v\00E1lidos para ejecutar las hojas web correctamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99712755636304302)
,p_name=>'DEMO_APPLICATION.WEB_SERVICES'
,p_message_language=>'es'
,p_message_text=>'Servicios Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99709563051304300)
,p_name=>'DEMO_APPLICATION.WILL_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Se puede producir un error si no vuelve a crear esta demostraci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99654582771304260)
,p_name=>'DEMO_FLOW.CREATED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No hay suficiente espacio para crear esta demostraci\00F3n. Solicite almacenamiento adicional en la p\00E1gina de administraci\00F3n, haciendo clic en el enlace "Solicitar Cambios en Servicio Actual".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99654482121304259)
,p_name=>'DEMO_FLOW.CREATED_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha creado aplicaci\00F3n de demostraci\00F3n de %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100309891814304798)
,p_name=>'DEPRECATED'
,p_message_language=>'es'
,p_message_text=>'En desuso'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99605514658304223)
,p_name=>'DERIVED$'
,p_message_language=>'es'
,p_message_text=>'columna derivada'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99985802592304514)
,p_name=>'DESIRABLE'
,p_message_language=>'es'
,p_message_text=>'Aconsejable'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100058685614304569)
,p_name=>'DETAIL'
,p_message_language=>'es'
,p_message_text=>'Detalle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100115345939304613)
,p_name=>'DETAILS_FOR_ALT_TAG'
,p_message_language=>'es'
,p_message_text=>'Detalles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100058776341304569)
,p_name=>'DETAIL_2'
,p_message_language=>'es'
,p_message_text=>'Detalle 2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99556999066304187)
,p_name=>'DEVELOPER'
,p_message_language=>'es'
,p_message_text=>'Desarrollador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100120749071304617)
,p_name=>'DEVELOPERS'
,p_message_language=>'es'
,p_message_text=>'Desarrolladores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100005429823304529)
,p_name=>'DEVELOPER_ACTIVITY_SUMMARY'
,p_message_language=>'es'
,p_message_text=>'Resumen de Actividad del Desarrollador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100029230262304547)
,p_name=>'DEVELOPER_SUMMARY'
,p_message_language=>'es'
,p_message_text=>'Resumen de Desarrollador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99513797877304151)
,p_name=>'DEVELOPER_TOOLBAR_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100022507184304542)
,p_name=>'DEVELOPER_TOOLBAR_APP_CUSTOMIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('Personalizaci\00F3n de aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100178691220304700)
,p_name=>'DEVELOPER_TOOLBAR_CLEAR'
,p_message_language=>'es'
,p_message_text=>'Borrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100178565745304700)
,p_name=>'DEVELOPER_TOOLBAR_COPY'
,p_message_language=>'es'
,p_message_text=>'Copiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100526985355304961)
,p_name=>'DEVELOPER_TOOLBAR_CUSTOMIZE'
,p_message_language=>'es'
,p_message_text=>'Personalizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100204800146304719)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LABEL'
,p_message_language=>'es'
,p_message_text=>'Depurar (%0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100204308914304719)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL'
,p_message_language=>'es'
,p_message_text=>unistr('Nivel de Depuraci\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100204500860304719)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL4'
,p_message_language=>'es'
,p_message_text=>'Info (por defecto)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100204677318304719)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL6'
,p_message_language=>'es'
,p_message_text=>'Rastreo de Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100204720950304719)
,p_name=>'DEVELOPER_TOOLBAR_DEBUG_LEVEL9'
,p_message_language=>'es'
,p_message_text=>'Rastreo Completo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99513891571304151)
,p_name=>'DEVELOPER_TOOLBAR_EDIT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100167749648304691)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS'
,p_message_language=>'es'
,p_message_text=>unistr('Se han producido uno o m\00E1s errores desde la carga de la p\00E1gina. Abra la consola de JavaScript del explorador para ver los errores.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100167959697304692)
,p_name=>'DEVELOPER_TOOLBAR_ERRORS_BTN'
,p_message_language=>'es'
,p_message_text=>'Errores de JavaScript'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100527087622304961)
,p_name=>'DEVELOPER_TOOLBAR_LOGO_EDITOR'
,p_message_language=>'es'
,p_message_text=>'Editar logotipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100241594367304747)
,p_name=>'DEVELOPER_TOOLBAR_NO_BUILDER'
,p_message_language=>'es'
,p_message_text=>unistr('Esta funcionalidad requiere que se abra la ventana del creador de aplicaciones de Application Express. \00BFDesea abrir el creador en esta ventana?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100237622436304744)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS'
,p_message_language=>'es'
,p_message_text=>'Opciones de Barra de Herramientas de Desarrollador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100239350577304745)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_AUTO_HIDE'
,p_message_language=>'es'
,p_message_text=>unistr('Ocultar Autom\00E1ticamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100239565122304745)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_DISPLAY'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100239447264304745)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_ICONS_ONLY'
,p_message_language=>'es'
,p_message_text=>'Solo Mostrar Iconos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100239759134304745)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_BOTTOM'
,p_message_language=>'es'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100239655032304745)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_LEFT'
,p_message_language=>'es'
,p_message_text=>'Izquierda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100239846673304745)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_RIGHT'
,p_message_language=>'es'
,p_message_text=>'Derecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100241104817304746)
,p_name=>'DEVELOPER_TOOLBAR_OPTIONS_POS_TOP'
,p_message_language=>'es'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100173690839304696)
,p_name=>'DEVELOPER_TOOLBAR_PAGE_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100173800803304696)
,p_name=>'DEVELOPER_TOOLBAR_PERF_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Temporizaci\00F3n del rendimiento de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100237726247304744)
,p_name=>'DEVELOPER_TOOLBAR_QUICK_EDIT'
,p_message_language=>'es'
,p_message_text=>unistr('Edici\00F3n R\00E1pida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100173793444304696)
,p_name=>'DEVELOPER_TOOLBAR_SHOW_PERF'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar temporizaci\00F3n de la p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100738672068305122)
,p_name=>'DEVELOPER_TOOLBAR_THEME_ROLLER'
,p_message_language=>'es'
,p_message_text=>'Acumulador de Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100239229989304745)
,p_name=>'DEVELOPER_TOOLBAR_TITLE'
,p_message_language=>'es'
,p_message_text=>'Barra de Herramientas de Desarrollador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99980188088304509)
,p_name=>'DEVELOPMENT_TASK'
,p_message_language=>'es'
,p_message_text=>'Tarea de Desarrollo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100148420301304677)
,p_name=>'DIAL_CHART_ALERT_VALUE'
,p_message_language=>'es'
,p_message_text=>'Alerta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100148368540304677)
,p_name=>'DIAL_CHART_HIGH_VALUE'
,p_message_language=>'es'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100148201011304677)
,p_name=>'DIAL_CHART_LOW_VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor Inferior'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99497524585304139)
,p_name=>'DICTIONARY.APEX_APPL_PAGE_ITEM_GROUPS'
,p_message_language=>'es'
,p_message_text=>unistr('Grupos de elementos de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99579979705304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99582329346304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Esquemas de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99582446541304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_AUTHORIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('Esquemas de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99581595630304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BC_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99581450433304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BREADCRUMBS'
,p_message_language=>'es'
,p_message_text=>unistr('Rutas de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100768045330305144)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_BUILD_OPTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99581127631304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_COMPUTATIONS'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99581307164304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99581622919304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LISTS'
,p_message_language=>'es'
,p_message_text=>'Listas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99581782261304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LIST_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99581801440304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOVS'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99531127612304164)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_COLS'
,p_message_language=>'es'
,p_message_text=>'Columnas de Listas de Valores:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99581982115304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_LOV_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99582013492304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_NAV_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barras de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99580050930304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99581033283304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BRANCHES'
,p_message_language=>'es'
,p_message_text=>'Bifurcaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99580401701304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_BUTTONS'
,p_message_language=>'es'
,p_message_text=>'Botones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99954852011304490)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHARTS'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1ficos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99955072834304490)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_A'
,p_message_language=>'es'
,p_message_text=>'Ejes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99954990704304490)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_CHART_S'
,p_message_language=>'es'
,p_message_text=>'Serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99580744186304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_COMP'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99621621663304235)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA'
,p_message_language=>'es'
,p_message_text=>unistr('Acciones Din\00E1micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99621713265304235)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_DA_ACTS'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n Din\00E1mica: Acciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99580554627304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR'
,p_message_language=>'es'
,p_message_text=>'Regiones IR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99580674041304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_IR_COL'
,p_message_language=>'es'
,p_message_text=>'Columnas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99580297865304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99580956513304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_PROC'
,p_message_language=>'es'
,p_message_text=>'Procesos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99580121204304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REGIONS'
,p_message_language=>'es'
,p_message_text=>'Regiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100521161103304956)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_REG_COLS'
,p_message_language=>'es'
,p_message_text=>'Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99580301686304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_RPT_COLS'
,p_message_language=>'es'
,p_message_text=>'Columnas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100703119408305096)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_TREES'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rboles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99580853297304205)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PAGE_VAL'
,p_message_language=>'es'
,p_message_text=>'Validaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99582154846304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PARENT_TABS'
,p_message_language=>'es'
,p_message_text=>'Separadores Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99581215247304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_PROCESSES'
,p_message_language=>'es'
,p_message_text=>unistr('Procesos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100728882511305115)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_LAYOUTS'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1os de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100729186988305115)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QRY_STMTS'
,p_message_language=>'es'
,p_message_text=>'Sentencias SQL de consulta de informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100728727272305115)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_RPT_QUERIES'
,p_message_language=>'es'
,p_message_text=>'Consultas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100677855543305073)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99582508412304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SHORTCUTS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todos Abreviados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99578008179304203)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_STATIC_FILES'
,p_message_language=>'es'
,p_message_text=>unistr('Archivos de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99584090962304208)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUBSTITUTIONS'
,p_message_language=>'es'
,p_message_text=>'Sustituciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100767718937305144)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJECTS'
,p_message_language=>'es'
,p_message_text=>'Objetos de Soporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100767898032305144)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_BOPT'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Creaci\00F3n de Objetos de Soporte')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99583875178304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_CHCK'
,p_message_language=>'es'
,p_message_text=>'Objetos de Soporte: Validaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99583920511304208)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_SUPP_OBJ_SCR'
,p_message_language=>'es'
,p_message_text=>'Objetos de Soporte: Scripts'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99582203850304206)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TABS'
,p_message_language=>'es'
,p_message_text=>'Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99582961546304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BC'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99583018490304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99583186454304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99646403223304254)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de Cuadr\00EDcula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99583289639304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LABEL'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99583340104304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_LIST'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99583469261304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99583579240304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_POPUPLOV'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Lista de Valores Emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99583633499304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99583706581304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TEMP_REPORT'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99582870853304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEMES'
,p_message_language=>'es'
,p_message_text=>'Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99571403814304198)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_FILES'
,p_message_language=>'es'
,p_message_text=>'Archivos de Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99519233640304155)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_THEME_STYLES'
,p_message_language=>'es'
,p_message_text=>'Estilos de Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100010677243304533)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANSLATIONS'
,p_message_language=>'es'
,p_message_text=>'Mensajes de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99565200298304193)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_DYNAMIC'
,p_message_language=>'es'
,p_message_text=>unistr('Traducciones Din\00E1micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99565354408304194)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TRANS_REPOS'
,p_message_language=>'es'
,p_message_text=>'Texto Traducible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99582713416304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_TREES'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rboles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99582669346304207)
,p_name=>'DICTIONARY_VIEW.APEX_APPLICATION_WEB_SERVICES'
,p_message_language=>'es'
,p_message_text=>'Servicios Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100694714747305089)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_ROLES'
,p_message_language=>'es'
,p_message_text=>'Roles de Control de Acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100694836151305089)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios de control de acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100049812742304562)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_ACL_USER_ROLES'
,p_message_language=>'es'
,p_message_text=>unistr('Asignaci\00F3n de rol de usuario de control de acceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99508309302304147)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATIONS'
,p_message_language=>'es'
,p_message_text=>'Automatizaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99508575088304147)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_AUTOMATION_ACTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Automatizaci\00F3n - Acciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100730646721305116)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_CONCATENATED_FILES'
,p_message_language=>'es'
,p_message_text=>'Archivos Concatenados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99535890379304168)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_LOADS'
,p_message_language=>'es'
,p_message_text=>'Cargas de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99962375185304496)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILES'
,p_message_language=>'es'
,p_message_text=>unistr('Perfiles de an\00E1lisis de datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99962420926304496)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DATA_PROFILE_COLS'
,p_message_language=>'es'
,p_message_text=>unistr('Columnas de perfil de an\00E1lisis de datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100746094396305128)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_DEVELOPER_COMMENTS'
,p_message_language=>'es'
,p_message_text=>'Comentarios del Desarrollador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100709741087305101)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_EMAIL_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100267837658304767)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE'
,p_message_language=>'es'
,p_message_text=>'Tabla de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100262183399304763)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLES'
,p_message_language=>'es'
,p_message_text=>'Tablas de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100262276691304763)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_LOOKUPS'
,p_message_language=>'es'
,p_message_text=>'Consultas de Tabla de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100262321106304763)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_LOAD_TABLE_RULES'
,p_message_language=>'es'
,p_message_text=>unistr('Reglas de Transformaci\00F3n de Tabla de Carga de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99525733359304160)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CALENDARS'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas de Calendario')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99524768945304159)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARDS'
,p_message_language=>'es'
,p_message_text=>'Tarjetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99524811576304159)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_CARD_ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Acciones de tarjeta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100238790545304745)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IGS'
,p_message_language=>'es'
,p_message_text=>unistr('Regiones de Cuadr\00EDcula Interactiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100238845547304745)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100238935192304745)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_IG_COL_GROUPS'
,p_message_language=>'es'
,p_message_text=>'Grupos de Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99499741783304141)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAPS'
,p_message_language=>'es'
,p_message_text=>'Mapas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99499801711304141)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PAGE_MAP_LAYERS'
,p_message_language=>'es'
,p_message_text=>'Capas de mapas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99597634909304217)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGINS'
,p_message_language=>'es'
,p_message_text=>'Plugins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99597751395304217)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100009138012304531)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ATTR_VALUES'
,p_message_language=>'es'
,p_message_text=>'Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99652616279304258)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_EVENTS'
,p_message_language=>'es'
,p_message_text=>'Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99599842101304219)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_FILES'
,p_message_language=>'es'
,p_message_text=>'Archivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100058986413304569)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_ITEM_FILTERS'
,p_message_language=>'es'
,p_message_text=>'Operadores de Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100767976284305144)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_SETTINGS'
,p_message_language=>'es'
,p_message_text=>'Valores de Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100708666309305100)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_PLUGIN_STD_ATTRS'
,p_message_language=>'es'
,p_message_text=>unistr('Metadatos de Atributo Est\00E1ndar de Plugin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99962298241304496)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_REMOTE_SQL'
,p_message_language=>'es'
,p_message_text=>'Servidores de SQL activado para REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100521009119304956)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPTIONS'
,p_message_language=>'es'
,p_message_text=>'Opciones de Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100767624609305144)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GROUPS'
,p_message_language=>'es'
,p_message_text=>'Grupos de Opciones de Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100683941204305081)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMPLATE_OPT_GRP'
,p_message_language=>'es'
,p_message_text=>'Grupo de Opciones de Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100737166012305121)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_PAGE_DP'
,p_message_language=>'es'
,p_message_text=>'Posiciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100737204370305121)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_TEMP_REGION_DP'
,p_message_language=>'es'
,p_message_text=>'Posiciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99651076078304257)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_THEME_DISPLAY_POINTS'
,p_message_language=>'es'
,p_message_text=>unistr('Puntos de Visualizaci\00F3n de Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99577954859304203)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_USER_INTERFACES'
,p_message_language=>'es'
,p_message_text=>'Interfaces de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99962938711304496)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_COMP_PARAMS'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de componente de origen de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99962630952304496)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_MODULES'
,p_message_language=>'es'
,p_message_text=>unistr('Or\00EDgenes de Datos de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99962772907304496)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_OPERATIONS'
,p_message_language=>'es'
,p_message_text=>'Operaciones de origen de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99962853557304496)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_PARAMETERS'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de origen de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99962556111304496)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SERVERS'
,p_message_language=>'es'
,p_message_text=>'Servidores remotos de origen de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99508883330304148)
,p_name=>'DICTIONARY_VIEW.APEX_APPL_WEB_SRC_SYNC_STEPS'
,p_message_language=>'es'
,p_message_text=>unistr('Pasos de sincronizaci\00F3n de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99508722664304147)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_LOG'
,p_message_language=>'es'
,p_message_text=>unistr('Log de automatizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99508947629304148)
,p_name=>'DICTIONARY_VIEW.APEX_AUTOMATION_MSG_LOG'
,p_message_language=>'es'
,p_message_text=>unistr('Log de mensajes de automatizaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100711350026305102)
,p_name=>'DISABLED_NEXT_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Siguiente Desactivado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100711232171305102)
,p_name=>'DISABLED_PREVIOUS_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Anterior Desactivado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100111954645304610)
,p_name=>'DISABLE_TRIGGER'
,p_message_language=>'es'
,p_message_text=>'Desactivar Disparador %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99717339356304306)
,p_name=>'DISPLAY_CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99717570777304306)
,p_name=>'DISPLAY_CONDITION_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar Texto de Condici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100157678272304684)
,p_name=>'DISPLAY_ORDER_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Orden de Visualizaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99603813809304222)
,p_name=>'DISPLAY_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100767346081305144)
,p_name=>'DISPLAY_VALUE.N'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Visualizaci\00F3n: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100706675547305098)
,p_name=>'DISTINCT_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas Distintas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100706735827305098)
,p_name=>'DISTINCT_USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios Distintos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99530892872304164)
,p_name=>'DML_FORM'
,p_message_language=>'es'
,p_message_text=>'Pantalla DML'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99825022482304384)
,p_name=>'DO NOT UPDATE PAGE ITEMS'
,p_message_language=>'es'
,p_message_text=>'DO_NOT_UPDATE_PAGE_ITEMS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100001222215304526)
,p_name=>'DOC_IMPACT'
,p_message_language=>'es'
,p_message_text=>unistr('Impacto de Documentaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100002409250304526)
,p_name=>'DOC_STATUS'
,p_message_language=>'es'
,p_message_text=>unistr('Estado de Documentaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100002606132304527)
,p_name=>'DOC_WRITER'
,p_message_language=>'es'
,p_message_text=>unistr('Escritor de Documentaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99890253990304440)
,p_name=>'DOWN'
,p_message_language=>'es'
,p_message_text=>'Descendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100010401924304532)
,p_name=>'DOWNLOAD_LINK_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto de Enlace de Descarga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99824710461304384)
,p_name=>'DO_NOT_UPDATE_APPLICATION_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('No Actualizar Elementos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99824850990304384)
,p_name=>'DO_NOT_UPDATE_DATA_ENTRY_ITEMS'
,p_message_language=>'es'
,p_message_text=>'No Actualizar Elementos de Entrada de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99824977730304384)
,p_name=>'DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('No Actualizar Elementos de S\00F3lo Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99824622951304384)
,p_name=>'DO_NOT_UPDATE_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('No Actualizar P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99825484719304384)
,p_name=>'DO_NOT_UPDATE_PAGE_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('No Actualizar Elementos de P\00E1gina')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99687486017304283)
,p_name=>'DRAG_AND_DROP'
,p_message_language=>'es'
,p_message_text=>'Arrastrar y Soltar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99595243538304216)
,p_name=>'DRILLDOWN'
,p_message_language=>'es'
,p_message_text=>'Aumentar Detalle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99595126713304216)
,p_name=>'DRILLUP'
,p_message_language=>'es'
,p_message_text=>'Reducir Detalle'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99732725492304317)
,p_name=>'DRIVEN'
,p_message_language=>'es'
,p_message_text=>'controlado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100111786066304610)
,p_name=>'DROP TRIGGER'
,p_message_language=>'es'
,p_message_text=>'Borrar Disparador %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100110854886304610)
,p_name=>'DROP_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Borrar Columna %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100258284249304760)
,p_name=>'DS_ACCESS_METHOD'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todo de Acceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100258046253304760)
,p_name=>'DS_BIND_VARIABLE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Variable de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100258490022304760)
,p_name=>'DS_HANDLER'
,p_message_language=>'es'
,p_message_text=>'Manejador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100258875734304761)
,p_name=>'DS_ITEMS_PER_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100258685361304761)
,p_name=>'DS_MIME_TYPES_ALLOWED'
,p_message_language=>'es'
,p_message_text=>'Tipos MIME Permitidos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100258706791304761)
,p_name=>'DS_ORIGINS_ALLOWED'
,p_message_language=>'es'
,p_message_text=>unistr('Or\00EDgenes Permitidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100258306276304760)
,p_name=>'DS_PARAMETER_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Par\00E1metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100258948157304761)
,p_name=>'DS_SECURITY_CONSTRAINT'
,p_message_language=>'es'
,p_message_text=>unistr('Restricci\00F3n de Seguridad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100258169870304760)
,p_name=>'DS_SOURCE'
,p_message_language=>'es'
,p_message_text=>'Origen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100258561424304760)
,p_name=>'DS_SOURCE_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Origen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100259051987304761)
,p_name=>'DS_URI_PREFIX'
,p_message_language=>'es'
,p_message_text=>'Prefijo de URI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100257733554304760)
,p_name=>'DS_URI_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de URI'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100729222323305115)
,p_name=>'DUE'
,p_message_language=>'es'
,p_message_text=>'Pendiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100002208515304526)
,p_name=>'DUE_DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha de Vencimiento'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99982794585304511)
,p_name=>'DUPLICATE'
,p_message_language=>'es'
,p_message_text=>'Duplicado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100707300883305099)
,p_name=>'DUPLICATE_USER'
,p_message_language=>'es'
,p_message_text=>'Usuario Duplicado en la Lista'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99519632026304156)
,p_name=>'DYNAMIC ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n Din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99519566623304156)
,p_name=>'DYNAMIC ACTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Acciones Din\00E1micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99529711595304163)
,p_name=>'DYNAMIC_FORM'
,p_message_language=>'es'
,p_message_text=>unistr('Pantalla Din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99635666296304245)
,p_name=>'DYNAMIC_HTML'
,p_message_language=>'es'
,p_message_text=>unistr('HTML din\00E1mico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99686341212304283)
,p_name=>'DYNAMIC_QUERY'
,p_message_language=>'es'
,p_message_text=>'Informe Interactivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99512771101304150)
,p_name=>'DYNAMIC_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Referencia Din\00E1mica')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99782153119304353)
,p_name=>'EASY_REPORT.INVALID_CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('La condici\00F3n que est\00E1 agregando ha provocado que la consulta sea no v\00E1lida.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99524232556304159)
,p_name=>'EDIT PAGE GROUP'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Grupo de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100042888270304557)
,p_name=>'EDITOR_EXIT'
,p_message_language=>'es'
,p_message_text=>unistr('Si hace clic en Aceptar se perder\00E1n los cambios no guardados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99556214777304186)
,p_name=>'EDIT_ALL'
,p_message_language=>'es'
,p_message_text=>'Editar Todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99783326209304354)
,p_name=>'EDIT_ALL_PAGE_DEFINITION_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Todos los Atributos de Definici\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100037779310304553)
,p_name=>'EDIT_ALL_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Editar todos los elementos de esta regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99968417157304501)
,p_name=>'EDIT_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100057426736304568)
,p_name=>'EDIT_ATTRIBUTE'
,p_message_language=>'es'
,p_message_text=>'Editar Atributo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100652475944305054)
,p_name=>'EDIT_AUTHENTICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100047240687304560)
,p_name=>'EDIT_COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Editar Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100057566980304568)
,p_name=>'EDIT_COMPONENT_DEF'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Definici\00F3n de Componente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100148962477304677)
,p_name=>'EDIT_LINK_TEXT'
,p_message_language=>'es'
,p_message_text=>'Editar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100057336297304568)
,p_name=>'EDIT_LIST_DEV'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Definici\00F3n de Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100721222431305109)
,p_name=>'EDIT_LOCK'
,p_message_language=>'es'
,p_message_text=>'Editar Bloqueo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99928973645304470)
,p_name=>'EDIT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Editar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99785499002304355)
,p_name=>'EDIT_PAGE_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Atributos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100316356184304803)
,p_name=>'EDIT_PROFILE'
,p_message_language=>'es'
,p_message_text=>'Editar Perfil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100333794610304816)
,p_name=>'EDIT_PROFILE.USER_NO_PRIV_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario 0% no tiene privilegios para actualizar la informaci\00F3n de otro usuario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100047054476304560)
,p_name=>'EDIT_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100121588667304618)
,p_name=>'EDIT_REPORTING_TIMEFRAME'
,p_message_language=>'es'
,p_message_text=>'Editar Marco Temporal de Informes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100047188915304560)
,p_name=>'EDIT_REPORT_COLS'
,p_message_language=>'es'
,p_message_text=>'Editar Columnas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100310523821304799)
,p_name=>'EDIT_REPORT_DIALOG_CLOSED_DA'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Informe: Cuadro de Di\00E1logo Cerrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100037099045304552)
,p_name=>'EDIT_SYSTEM_MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Editar Mensaje de Sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100272465972304771)
,p_name=>'EDIT_TAB'
,p_message_language=>'es'
,p_message_text=>'Editar Separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100058801992304569)
,p_name=>'EDIT_THIS_ATTRIBUTE'
,p_message_language=>'es'
,p_message_text=>'Editar este atributo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99911254556304457)
,p_name=>'ELAPSED_TIME'
,p_message_language=>'es'
,p_message_text=>'Tiempo Transcurrido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99989860230304517)
,p_name=>'EMAIL.TEMPLATE.FOOTER_EXAMPLE'
,p_message_language=>'es'
,p_message_text=>unistr('<a href="#MY_APPLICATION_LINK#">Visite Mi aplicaci\00F3n y gestione las preferencias de correo electr\00F3nico</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99996795184304522)
,p_name=>'EMAIL.TEMPLATE.HEADER_EXAMPLE'
,p_message_language=>'es'
,p_message_text=>unistr('<b style="font-size: 24px;">Mi aplicaci\00F3n</b>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100111202510304610)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Hola, #INVITEE#:</strong><br>',
'<br>',
unistr('Esto es el recordatorio de un evento pr\00F3ximo al que se le ha invitado.  A continuaci\00F3n se muestran los detalles del evento:<br>'),
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Organizador</th>',
'    <td>#ORGANIZER#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Fecha del evento</th>',
'    <td>#EVENT_DATE#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Hora de inicio</th>',
'    <td>#START_TIME#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">Duraci\00F3n</th>'),
'    <td>#DURATION#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">Ubicaci\00F3n</th>'),
'    <td>#LOCATION#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">URL</th>',
'    <td><a href="#URL_LINK#">#URL_NAME#</a></td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Notas</th>',
'    <td>#NOTES#</td>',
'  </tr>',
'</table>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99989784018304517)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Hola, #CUSTOMER_NAME#</strong>:<br>',
'<br>',
'Gracias por su orden.<br>',
'<br>',
'<strong>Detalles de la orden</strong><br>',
'<br>',
'<table width="100%">',
'  <tr>',
'    <th align="left">Fecha de la orden</th>',
'    <td>#ORDER_DATE#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left">N\00FAmero del orden</th>'),
'    <td>#ORDER_NUMBER#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Enviar a</th>',
'    <td>#SHIP_TO#</td>',
'  </tr>',
'  <tr>',
unistr('    <th align="left" valign="top">Direcci\00F3n de env\00EDo</th>'),
'    <td>',
'      #SHIPPING_ADDRESS_LINE_1#<br>',
'      #SHIPPING_ADDRESS_LINE_2#',
'    </td>',
'  </tr>',
'  <tr>',
'    <th align="left" valign="top">Productos solicitados</th>',
'    <td>#ITEMS_ORDERED#</td>',
'  </tr>',
'  <tr>',
'    <th align="left">Total de orden</th>',
'    <td>#ORDER_TOTAL#</td>',
'  </tr>',
'</table>',
'<br>',
'<br>',
unistr('\00BFTiene que realizar alg\00FAn cambio en su orden? <a href="#ORDER_URL#">Gestione su orden #ORDER_NUMBER# aqu\00ED.</a>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100310861144304799)
,p_name=>'EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hola, #SERVICE_USER#:<br>',
'<br>',
unistr('Tenga en cuenta que el servicio #SERVICE_NAME# tiene pr\00F3xima una interrupci\00F3n programada.<br>'),
unistr('La interrupci\00F3n est\00E1 programada para empezar a las #OUTAGE_START# y se estima que no estar\00E1 disponible durante #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.<br>'),
'<br>',
unistr('Mientras se ejecuta esta interrupci\00F3n programada, se realizar\00E1 lo siguiente:<br>'),
'#OUTAGE_REASON#<br>',
'<br>',
'<br>',
unistr('Si tiene cualquier problema relacionado con esta interrupci\00F3n, contacte con #OUTAGE_CONTACT#.<br>'),
'<br>',
unistr('Gracias por su comprensi\00F3n.<br>'),
'#SERVICE_TEAM#',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100310291131304799)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'
,p_message_language=>'es'
,p_message_text=>'Recordatorio de evento: #EVENT_NAME#'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100310315729304799)
,p_name=>'EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'
,p_message_language=>'es'
,p_message_text=>'Orden (#ORDER_NUMBER#) confirmada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100111499180304610)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hola, #INVITEE#:',
'',
unistr('Le escribimos para recordarle que pr\00F3ximamente tendr\00E1 lugar un evento al que est\00E1 asociado.'),
'',
'Fecha del evento: #EVENT_DATE#',
'Hora de inicio: #START_TIME#',
unistr('Duraci\00F3n:   #DURATION#'),
'Organizador:  #ORGANIZER#',
unistr('Ubicaci\00F3n:   #LOCATION#'),
'URL:        #URL_NAME# (#URL_LINK#)',
'Notas:      #NOTES#',
'',
unistr('Consulte informaci\00F3n adicional del evento aqu\00ED: #EVENT_LINK#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100111334950304610)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hola, #CUSTOMER_NAME#:',
'',
'Gracias por su orden.',
'',
'Detalles de orden',
'--------------------------------------------------------------------------------',
'  Fecha de orden:       #ORDER_DATE#',
unistr('  N\00FAmero de orden:     #ORDER_NUMBER#'),
'  Enviar a:          #SHIP_TO#',
unistr('  Direcci\00F3n de env\00EDo: #SHIPPING_ADDRESS_LINE_1#'),
'                    #SHIPPING_ADDRESS_LINE_2#',
'  Productos solicitados:    #ITEMS_ORDERED#',
'  Total de orden:      #ORDER_TOTAL#',
'--------------------------------------------------------------------------------',
'',
unistr('\00BFTiene que realizar alg\00FAn cambio en su orden? Gestione su orden #ORDER_NUMBER# aqu\00ED: #ORDER_URL#')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100310703717304799)
,p_name=>'EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Hola, #SERVICE_USER#:',
'',
unistr('Tenga en cuenta que el servicio #SERVICE_NAME# tiene pr\00F3xima una interrupci\00F3n programada.'),
unistr('La interrupci\00F3n est\00E1 programada para empezar a las #OUTAGE_START# y se estima que no estar\00E1 disponible durante #OUTAGE_DURATION# #OUTAGE_TIMEFRAME#.'),
'',
unistr('Mientras se ejecuta esta interrupci\00F3n programada, se realizar\00E1 lo siguiente:'),
'#OUTAGE_REASON#',
'',
unistr('Si tiene cualquier problema relacionado con esta interrupci\00F3n, contacte con #OUTAGE_CONTACT#.'),
'',
unistr('Gracias por su comprensi\00F3n.'),
'#SERVICE_TEAM#',
''))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100041001302304555)
,p_name=>'ENABLE_DEBUGGING'
,p_message_language=>'es'
,p_message_text=>unistr('Activar Depuraci\00F3n (S\00ED o No)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100111858927304610)
,p_name=>'ENABLE_TRIGGER'
,p_message_language=>'es'
,p_message_text=>'Activar Disparador %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99558493520304188)
,p_name=>'ENCRYPTION_INPUT_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>'La longitud del valor que se va a cifrar no puede exceder los 4000 bytes.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99557035652304187)
,p_name=>'END_USER'
,p_message_language=>'es'
,p_message_text=>'Usuario Final'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99979818406304509)
,p_name=>'ENHANCEMENT_REQUEST'
,p_message_language=>'es'
,p_message_text=>'Solicitud de Mejora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100334421820304817)
,p_name=>'ENHANCEMENT_REQUEST_DASH'
,p_message_language=>'es'
,p_message_text=>'Solicitudes de Mejora: %1 de %0 cerradas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99982281437304511)
,p_name=>'ENTERED'
,p_message_language=>'es'
,p_message_text=>'Introducido '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99523451488304158)
,p_name=>'ENTER_WEBSHEETS_CREDENTIALS'
,p_message_language=>'es'
,p_message_text=>'Introduzca las credenciales de las hojas web.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99970055923304502)
,p_name=>'ENTRY LINK'
,p_message_language=>'es'
,p_message_text=>'Enlace de Entrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99969970999304502)
,p_name=>'ENTRY TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto de Entrada'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100025360733304544)
,p_name=>'ERROR PAGE TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de P\00E1gina de Error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99888494385304438)
,p_name=>'ERRORPAGE'
,p_message_language=>'es'
,p_message_text=>unistr('En P\00E1gina de Error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100038084997304553)
,p_name=>'ERRORS'
,p_message_language=>'es'
,p_message_text=>'Errores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99971205635304503)
,p_name=>'ERROR_ICON'
,p_message_language=>'es'
,p_message_text=>'Icono de Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100728219994305115)
,p_name=>'ERROR_MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Mensaje de Error'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99963460772304497)
,p_name=>'ESCAPED_COL_TOO_LARGE'
,p_message_language=>'es'
,p_message_text=>unistr('<br><strong>Los datos de escape exceden el l\00EDmite permitido, los resultados se han recortado a 32 K</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99731905616304316)
,p_name=>'ESCAPE_SC'
,p_message_language=>'es'
,p_message_text=>unistr('caracteres especiales de identificaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100003698284304527)
,p_name=>'ESTIMATED_EFFORT_IN_HOURS'
,p_message_language=>'es'
,p_message_text=>'Esfuerzo Estimado en Horas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100257965643304760)
,p_name=>'ETAG_QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta ETAG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100257849892304760)
,p_name=>'ETAG_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo ETAG'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99980301659304510)
,p_name=>'EVENT'
,p_message_language=>'es'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100314902861304802)
,p_name=>'EVENT.APEX.APEXAFTERREFRESH'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Refrescamiento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100315269496304803)
,p_name=>'EVENT.APEX.APEXBEFOREPAGESUBMIT'
,p_message_language=>'es'
,p_message_text=>unistr('Antes de Ejecuci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100314879885304802)
,p_name=>'EVENT.APEX.APEXBEFOREREFRESH'
,p_message_language=>'es'
,p_message_text=>'Antes de Refrescamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100317428444304804)
,p_name=>'EVENT.BROWSER'
,p_message_language=>'es'
,p_message_text=>'Eventos de Explorador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99778575783304350)
,p_name=>'EVENT.BROWSER.APEXDOUBLETAP'
,p_message_language=>'es'
,p_message_text=>'Tocar dos veces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99778791607304350)
,p_name=>'EVENT.BROWSER.APEXPAN'
,p_message_language=>'es'
,p_message_text=>'Desplazar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99778668839304350)
,p_name=>'EVENT.BROWSER.APEXPRESS'
,p_message_language=>'es'
,p_message_text=>'Pulsar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99778836136304350)
,p_name=>'EVENT.BROWSER.APEXSWIPE'
,p_message_language=>'es'
,p_message_text=>'Deslizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99778470746304350)
,p_name=>'EVENT.BROWSER.APEXTAP'
,p_message_language=>'es'
,p_message_text=>'Pulsar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100314321372304802)
,p_name=>'EVENT.BROWSER.CHANGE'
,p_message_language=>'es'
,p_message_text=>'Cambiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100313671479304801)
,p_name=>'EVENT.BROWSER.CLICK'
,p_message_language=>'es'
,p_message_text=>'Clic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100313736064304801)
,p_name=>'EVENT.BROWSER.DBLCLICK'
,p_message_language=>'es'
,p_message_text=>'Doble Clic'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100313189510304801)
,p_name=>'EVENT.BROWSER.FOCUSIN'
,p_message_language=>'es'
,p_message_text=>'Obtener Enfoque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100313019685304801)
,p_name=>'EVENT.BROWSER.FOCUSOUT'
,p_message_language=>'es'
,p_message_text=>'Perder Enfoque'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100314578441304802)
,p_name=>'EVENT.BROWSER.KEYDOWN'
,p_message_language=>'es'
,p_message_text=>'Tecla Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100314661865304802)
,p_name=>'EVENT.BROWSER.KEYPRESS'
,p_message_language=>'es'
,p_message_text=>unistr('Pulsaci\00F3n de Tecla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100314760501304802)
,p_name=>'EVENT.BROWSER.KEYUP'
,p_message_language=>'es'
,p_message_text=>unistr('Liberaci\00F3n de Tecla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100313213733304801)
,p_name=>'EVENT.BROWSER.LOAD'
,p_message_language=>'es'
,p_message_text=>'Carga de Recurso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100313854511304801)
,p_name=>'EVENT.BROWSER.MOUSEDOWN'
,p_message_language=>'es'
,p_message_text=>unistr('Pulsaci\00F3n del Bot\00F3n del Mouse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100314108342304802)
,p_name=>'EVENT.BROWSER.MOUSEENTER'
,p_message_language=>'es'
,p_message_text=>'Acercamiento del Mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100314249283304802)
,p_name=>'EVENT.BROWSER.MOUSELEAVE'
,p_message_language=>'es'
,p_message_text=>'Alejamiento del Mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100314081709304802)
,p_name=>'EVENT.BROWSER.MOUSEMOVE'
,p_message_language=>'es'
,p_message_text=>'Movimiento de Mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100313976435304802)
,p_name=>'EVENT.BROWSER.MOUSEUP'
,p_message_language=>'es'
,p_message_text=>unistr('Liberaci\00F3n del Bot\00F3n del Mouse')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99522441179304158)
,p_name=>'EVENT.BROWSER.ORIENTATIONCHANGE'
,p_message_language=>'es'
,p_message_text=>unistr('Cambio de Orientaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100320748294304807)
,p_name=>'EVENT.BROWSER.READY'
,p_message_language=>'es'
,p_message_text=>unistr('Carga de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100313388703304801)
,p_name=>'EVENT.BROWSER.RESIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Cambiar Tama\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100313484564304801)
,p_name=>'EVENT.BROWSER.SCROLL'
,p_message_language=>'es'
,p_message_text=>'Desplazar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99522543789304158)
,p_name=>'EVENT.BROWSER.SCROLLSTART'
,p_message_language=>'es'
,p_message_text=>'Desplazar Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99522634530304158)
,p_name=>'EVENT.BROWSER.SCROLLSTOP'
,p_message_language=>'es'
,p_message_text=>'Desplazar Parada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100314459499304802)
,p_name=>'EVENT.BROWSER.SELECT'
,p_message_language=>'es'
,p_message_text=>'Seleccionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99521632095304157)
,p_name=>'EVENT.BROWSER.SWIPE'
,p_message_language=>'es'
,p_message_text=>'Deslizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99521782926304157)
,p_name=>'EVENT.BROWSER.SWIPELEFT'
,p_message_language=>'es'
,p_message_text=>'Deslizar a la Izquierda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99521868715304157)
,p_name=>'EVENT.BROWSER.SWIPERIGHT'
,p_message_language=>'es'
,p_message_text=>'Deslizar a la Derecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99521456198304157)
,p_name=>'EVENT.BROWSER.TAP'
,p_message_language=>'es'
,p_message_text=>'Pulsar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99521511944304157)
,p_name=>'EVENT.BROWSER.TAPHOLD'
,p_message_language=>'es'
,p_message_text=>'Pulsar y Mantener'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100313502523304801)
,p_name=>'EVENT.BROWSER.UNLOAD'
,p_message_language=>'es'
,p_message_text=>unistr('Anulaci\00F3n de Carga de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99522269604304158)
,p_name=>'EVENT.BROWSER.VCLICK'
,p_message_language=>'es'
,p_message_text=>'Clic Virtual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99522319315304158)
,p_name=>'EVENT.BROWSER.VMOUSECANCEL'
,p_message_language=>'es'
,p_message_text=>'Tocar Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99521926717304157)
,p_name=>'EVENT.BROWSER.VMOUSEDOWN'
,p_message_language=>'es'
,p_message_text=>'Tocar Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99522075679304157)
,p_name=>'EVENT.BROWSER.VMOUSEMOVE'
,p_message_language=>'es'
,p_message_text=>'Tocar Mover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99522163099304158)
,p_name=>'EVENT.BROWSER.VMOUSEUP'
,p_message_language=>'es'
,p_message_text=>'Tocar Finalizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100317693520304804)
,p_name=>'EVENT.COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Eventos de Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99518407284304155)
,p_name=>'EVENT.CUSTOM'
,p_message_language=>'es'
,p_message_text=>'Evento Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99518524756304155)
,p_name=>'EVENT.CUSTOM.CUSTOM'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100317585241304804)
,p_name=>'EVENT.FRAMEWORK'
,p_message_language=>'es'
,p_message_text=>'Eventos de Marco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99894820077304443)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSECANCELDIALOG'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadro de di\00E1logo cerrado o cancelado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100046902120304560)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERCLOSEDIALOG'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadro de Di\00E1logo Cerrado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100736161247305120)
,p_name=>'EVENT.FRAMEWORK.APEXAFTERREFRESH'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Refrescamiento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100736290611305120)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREPAGESUBMIT'
,p_message_language=>'es'
,p_message_text=>unistr('Antes de Ejecuci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100736092150305120)
,p_name=>'EVENT.FRAMEWORK.APEXBEFOREREFRESH'
,p_message_language=>'es'
,p_message_text=>'Antes de Refrescamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99965131999304498)
,p_name=>'EVENTS'
,p_message_language=>'es'
,p_message_text=>'Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100002335908304526)
,p_name=>'EVENT_ID'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Hito')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100043234027304557)
,p_name=>'EXACT_SUBS'
,p_message_language=>'es'
,p_message_text=>'Sustituciones Exactas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100157090131304683)
,p_name=>'EXAMPLE_1'
,p_message_language=>'es'
,p_message_text=>'Ejemplo 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100157105911304683)
,p_name=>'EXAMPLE_2'
,p_message_language=>'es'
,p_message_text=>'Ejemplo 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100657247185305057)
,p_name=>'EXAMPLE_OF_XML_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('\00C9ste es un ejemplo de los datos incluidos en una columna de base de datos XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100707275580305099)
,p_name=>'EXAMPLE_URI'
,p_message_language=>'es'
,p_message_text=>'URI de Ejemplo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100112913297304611)
,p_name=>'EXCLUDE'
,p_message_language=>'es'
,p_message_text=>'Excluir'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100092552550304595)
,p_name=>'EXISTING_SCHEMA_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Esquema Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100034568204304551)
,p_name=>'EXISTS'
,p_message_language=>'es'
,p_message_text=>'Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99589827772304212)
,p_name=>'EXISTS_SQL_QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL EXISTS'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100305108119304795)
,p_name=>'EXPANDED'
,p_message_language=>'es'
,p_message_text=>'Ampliado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100703073193305096)
,p_name=>'EXPAND_ALL'
,p_message_language=>'es'
,p_message_text=>'Ampliar Todo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99655023111304260)
,p_name=>'EXPIRED'
,p_message_language=>'es'
,p_message_text=>'Vencido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99968610091304501)
,p_name=>'EXPLAIN PLAN'
,p_message_language=>'es'
,p_message_text=>unistr('Explicaci\00F3n del Plan')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99965442399304498)
,p_name=>'EXPORT'
,p_message_language=>'es'
,p_message_text=>'Exportar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100273723774304772)
,p_name=>'EXPORT REPOSITORY'
,p_message_language=>'es'
,p_message_text=>unistr('Repositorio de Exportaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100047514776304560)
,p_name=>'EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('Exportado de otro espacio de trabajo o aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100047691326304560)
,p_name=>'EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Exportado del espacio de trabajo actual.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100116965150304614)
,p_name=>'EXPORT_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Exportar Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100121180053304617)
,p_name=>'EXPORT_PKG_APP_FOR_DEPLOYMENT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilice estos enlaces para descargar esta aplicaci\00F3n y sus objetos de soporte de base de datos correspondientes para el despliegue en una instalaci\00F3n de Oracle APEX diferente. Los archivos descargados ser\00E1n scripts SQL que se pueden ejecutar desde SQ')
||'L*Plus, SQL Developer o scripts SQL dentro de Oracle APEX.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100117092210304614)
,p_name=>'EXPORT_SUPPORTING_OBJECTS'
,p_message_language=>'es'
,p_message_text=>'Exportar Objetos de Soporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99965736851304498)
,p_name=>'EXPORT_TYPES.APP_EXPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Exportaci\00F3n de Aplicaci\00F3n  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99965953853304499)
,p_name=>'EXPORT_TYPES.CSS_EXPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Exportaci\00F3n de Hojas de Estilo en Cascada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99966116527304499)
,p_name=>'EXPORT_TYPES.FILE_EXPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Exportaci\00F3n de Archivo Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99966087538304499)
,p_name=>'EXPORT_TYPES.IMAGE_EXPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Exportaci\00F3n de Imagen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99965809093304499)
,p_name=>'EXPORT_TYPES.PAGE_EXPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Exportaci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99966279927304499)
,p_name=>'EXPORT_TYPES.SCRIPT_FILE_EXPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Exportaci\00F3n de Script')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99962158043304496)
,p_name=>'EXPORT_TYPES.UI_DEFAULTS'
,p_message_language=>'es'
,p_message_text=>'Valores por Defecto de Interfaz de Usuario'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99893258128304442)
,p_name=>'F4000.APPLICATION_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculo de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99891251900304440)
,p_name=>'F4000.APPLICATION_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99893050675304442)
,p_name=>'F4000.APPLICATION_PROCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Proceso de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99707974127304299)
,p_name=>'F4000.APPLICATION_RESERVED'
,p_message_language=>'es'
,p_message_text=>unistr('Los identificadores de aplicaci\00F3n del 3000 al 8999 est\00E1n reservados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99591049953304213)
,p_name=>'F4000.APP_EXPORT_CURR_WS'
,p_message_language=>'es'
,p_message_text=>unistr('Esta aplicaci\00F3n se ha exportado desde el espacio de trabajo actual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99591141061304213)
,p_name=>'F4000.APP_EXPORT_NON_CURR_WS'
,p_message_language=>'es'
,p_message_text=>unistr('Esta aplicaci\00F3n se ha exportado desde otro espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100524867766304959)
,p_name=>'F4000.APP_PRINT_CREDENTIALS'
,p_message_language=>'es'
,p_message_text=>unistr('Credenciales del servidor de impresi\00F3n remoto %0 de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100524602084304959)
,p_name=>'F4000.APP_REMOTE_PRINT_SERVER'
,p_message_language=>'es'
,p_message_text=>unistr('Servidor de impresi\00F3n remoto %0 de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99892942930304442)
,p_name=>'F4000.BRANCH'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99906892655304453)
,p_name=>'F4000.BRANCH_FROM_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcar desde P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99907038559304453)
,p_name=>'F4000.BRANCH_TO_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcar a P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99892545702304441)
,p_name=>'F4000.BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100033506392304550)
,p_name=>'F4000.BUTTON.ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99646340451304253)
,p_name=>'F4000.CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99768815076304343)
,p_name=>'F4000.CALENDAR_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99907419774304453)
,p_name=>'F4000.COLUMN_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>'Atributos de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100671488666305069)
,p_name=>'F4000.COLUMN_NAME_RESERVED_WORD'
,p_message_language=>'es'
,p_message_text=>'El nombre de columna identificado es una palabra reservada de Oracle. Seleccione otro nombre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100034908315304551)
,p_name=>'F4000.COPY_LIST_ENTRY_X'
,p_message_language=>'es'
,p_message_text=>'Copiar entrada de lista: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99920753532304464)
,p_name=>'F4000.DYNAMIC'
,p_message_language=>'es'
,p_message_text=>unistr('Din\00E1mico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99605227488304223)
,p_name=>'F4000.DYNAMIC ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n Din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99590957385304213)
,p_name=>'F4000.EXPORT'
,p_message_language=>'es'
,p_message_text=>'Exportar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99922931875304466)
,p_name=>'F4000.FIX_ME'
,p_message_language=>'es'
,p_message_text=>'Corregirme'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99920392956304464)
,p_name=>'F4000.FOR_USER'
,p_message_language=>'es'
,p_message_text=>'Para el Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99920296822304464)
,p_name=>'F4000.FOR_USER_SESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Para Sesi\00F3n de Usuario')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99907183986304453)
,p_name=>'F4000.FROM'
,p_message_language=>'es'
,p_message_text=>'de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99709099785304300)
,p_name=>'F4000.HEADER_VALIDATION1'
,p_message_language=>'es'
,p_message_text=>'La cabecera debe incluir las etiquetas <strong> &lt;head&gt;</strong> y <strong>&lt;/head&gt;</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99709362432304300)
,p_name=>'F4000.HEADER_VALIDATION2'
,p_message_language=>'es'
,p_message_text=>unistr('La cadena de sustituci\00F3n <strong>#HEAD#</strong> debe aparecer entre las etiquetas <strong> &lt;head&gt;</strong> y <strong>&lt;/head&gt;</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99977995095304508)
,p_name=>'F4000.INVALID_FILE_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('El archivo "%0" es de tipo no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99892237416304441)
,p_name=>'F4000.ITEM_DISPLAY'
,p_message_language=>'es'
,p_message_text=>unistr('Visualizaci\00F3n de Elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99892382646304441)
,p_name=>'F4000.ITEM_READ_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de S\00F3lo Lectura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99537629498304169)
,p_name=>'F4000.LEGACY_SQL'
,p_message_language=>'es'
,p_message_text=>'SQL heredado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100060904236304571)
,p_name=>'F4000.LINK_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99925446842304468)
,p_name=>'F4000.LIST_INITCAP'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99893639523304442)
,p_name=>'F4000.LIST_ITEM'
,p_message_language=>'es'
,p_message_text=>'Elemento de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99537578059304169)
,p_name=>'F4000.LOCAL'
,p_message_language=>'es'
,p_message_text=>'Local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99893944413304443)
,p_name=>'F4000.LOV_ENTRY'
,p_message_language=>'es'
,p_message_text=>'Entrada de Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99907271607304453)
,p_name=>'F4000.MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99893868435304442)
,p_name=>'F4000.MENU_OPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Entrada de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99937200315304477)
,p_name=>'F4000.MUST_SELECT_AT_LEAST_ONE_TO_COPY'
,p_message_language=>'es'
,p_message_text=>unistr('Debe seleccionar al menos uno para la copia o suscripci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99893309953304442)
,p_name=>'F4000.NAVIGATION_BAR_ENTRY'
,p_message_language=>'es'
,p_message_text=>unistr('Entrada de Barra de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99824042048304383)
,p_name=>'F4000.NAVIGATION_BAR_ICON'
,p_message_language=>'es'
,p_message_text=>unistr('Icono&nbsp;de&nbsp;Barra&nbsp;de&nbsp;Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99891167024304440)
,p_name=>'F4000.NO'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99920878597304464)
,p_name=>'F4000.NOT_REFERENCED'
,p_message_language=>'es'
,p_message_text=>'Sin Referencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99905390083304452)
,p_name=>'F4000.NO_DATA_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn dato.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100730715136305116)
,p_name=>'F4000.P1.APP_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n %0 no existe en el espacio de trabajo actual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100331600504304815)
,p_name=>'F4000.P1000.UPDATE_CHECK_DISABLED'
,p_message_language=>'es'
,p_message_text=>unistr('Comprobaci\00F3n de Actualizaci\00F3n desactivada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99930061540304471)
,p_name=>'F4000.P104.PARENT_TAB_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Separador Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99593728452304215)
,p_name=>'F4000.P111.CANCEL_BUTTON_BRANCH'
,p_message_language=>'es'
,p_message_text=>unistr('Cancelar Bifurcaci\00F3n de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99593343928304214)
,p_name=>'F4000.P111.CANCEL_BUTTON_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Visualizaci\00F3n del Bot\00F3n Cancelar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99593851308304215)
,p_name=>'F4000.P111.FINISH_BUTTON_BRANCH'
,p_message_language=>'es'
,p_message_text=>unistr('Terminar Bifurcaci\00F3n de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99593459545304214)
,p_name=>'F4000.P111.FINISH_BUTTON_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Visualizaci\00F3n del Bot\00F3n Terminar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99593679674304215)
,p_name=>'F4000.P111.NEXT_BUTTON_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Visualizaci\00F3n del Bot\00F3n Siguiente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99593541063304214)
,p_name=>'F4000.P111.PREVIOUS_BUTTON_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Visualizaci\00F3n del Bot\00F3n Anterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99930108680304471)
,p_name=>'F4000.P112.TREE_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de \00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99930228936304471)
,p_name=>'F4000.P119.GO'
,p_message_language=>'es'
,p_message_text=>'Ir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99930398096304471)
,p_name=>'F4000.P130.USING_SAME_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Utiliza las mismas plantillas que la aplicaci\00F3n existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100733255762305118)
,p_name=>'F4000.P135.COPY'
,p_message_language=>'es'
,p_message_text=>'Copiar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100734969399305119)
,p_name=>'F4000.P149.PUBLISH_AUTHORIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 los siguientes esquemas de autorizaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100735226433305120)
,p_name=>'F4000.P149.PUBLISH_BREADCRUMB_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes plantillas de ruta de navegaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100735341469305120)
,p_name=>'F4000.P149.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes plantillas de bot\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100735454119305120)
,p_name=>'F4000.P149.PUBLISH_CALENDAR_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes plantillas de calendario:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99517004713304154)
,p_name=>'F4000.P149.PUBLISH_DATA_LOAD'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes definiciones de carga de datos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100734888908305119)
,p_name=>'F4000.P149.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes plantillas de etiqueta:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100734637514305119)
,p_name=>'F4000.P149.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes plantillas de lista:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100734371857305119)
,p_name=>'F4000.P149.PUBLISH_LOV'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes listas de valores:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100735123159305120)
,p_name=>'F4000.P149.PUBLISH_NAVBAR'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes entradas de la barra de navegaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100734486488305119)
,p_name=>'F4000.P149.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes plantillas de p\00E1gina:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100735506898305120)
,p_name=>'F4000.P149.PUBLISH_PLUGIN'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 los siguientes plugins:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100735618838305120)
,p_name=>'F4000.P149.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes plantillas de lista de valores emergente:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100734501169305119)
,p_name=>'F4000.P149.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes plantillas de regi\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100734711002305119)
,p_name=>'F4000.P149.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 las siguientes plantillas de informe:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100735002178305120)
,p_name=>'F4000.P149.PUBLISH_SHORTCUT'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 los siguientes accesos directos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100093607264304596)
,p_name=>'F4000.P149.PUBLISH_WEB_SRC_MODULE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado publicar <strong>%0</strong>. Esta acci\00F3n refrescar\00E1 los siguientes or\00EDgenes de datos de REST:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99938058413304477)
,p_name=>'F4000.P158.COPY_OF'
,p_message_language=>'es'
,p_message_text=>'Copia de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100733187558305118)
,p_name=>'F4000.P1701.LOOKUP_DEFINITION'
,p_message_language=>'es'
,p_message_text=>unistr('Definici\00F3n de Consulta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100730850423305116)
,p_name=>'F4000.P1704.REGION_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de la Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99708628554304299)
,p_name=>'F4000.P19.VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Debe especificar al menos un elemento para crear una validaci\00F3n no nula.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100643027095305047)
,p_name=>'F4000.P1935.NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Servidor de impresi\00F3n %0 de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100354816494304832)
,p_name=>'F4000.P2.UPDATE_EXPORT_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Actualice la configuraci\00F3n de exportaci\00F3n por defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100466575611304916)
,p_name=>'F4000.P203.ACTION='
,p_message_language=>'es'
,p_message_text=>unistr('acci\00F3n=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99974293249304505)
,p_name=>'F4000.P203.COMMENT='
,p_message_language=>'es'
,p_message_text=>'comentario='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99972308117304504)
,p_name=>'F4000.P203.COMP.MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Utilizado para ejecutar el c\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100739633433305123)
,p_name=>'F4000.P203.CONCATENATED_FILE'
,p_message_language=>'es'
,p_message_text=>'Archivo Concatenado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99972939093304504)
,p_name=>'F4000.P203.DISPVAL='
,p_message_language=>'es'
,p_message_text=>unistr('valor de visualizaci\00F3n=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100739537206305123)
,p_name=>'F4000.P203.FILE='
,p_message_language=>'es'
,p_message_text=>'file='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99972684086304504)
,p_name=>'F4000.P203.ICONBAR'
,p_message_language=>'es'
,p_message_text=>'Barra de Iconos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99973120097304504)
,p_name=>'F4000.P203.LOV='
,p_message_language=>'es'
,p_message_text=>'Lista de Valores='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99972806921304504)
,p_name=>'F4000.P203.LOVDATA'
,p_message_language=>'es'
,p_message_text=>'Datos de Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99972729008304504)
,p_name=>'F4000.P203.NAME='
,p_message_language=>'es'
,p_message_text=>'nombre='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99972287779304503)
,p_name=>'F4000.P203.PAGE.MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Utilizado para mostrar la p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99974117924304505)
,p_name=>'F4000.P203.PAGEBRANCH'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcaci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99973202447304504)
,p_name=>'F4000.P203.PGTEMP'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99972558299304504)
,p_name=>'F4000.P203.PROC.MSG'
,p_message_language=>'es'
,p_message_text=>'Utilizado para ejecutar el proceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99972407176304504)
,p_name=>'F4000.P203.PROCESSING'
,p_message_language=>'es'
,p_message_text=>'Procesamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99973075199304504)
,p_name=>'F4000.P203.RETVAL='
,p_message_language=>'es'
,p_message_text=>'valor de retorno='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100735855222305120)
,p_name=>'F4000.P2222.REPARENT_LIST_ENTRY'
,p_message_language=>'es'
,p_message_text=>'Crear Nuevo Principal de Entrada de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99768464189304343)
,p_name=>'F4000.P254.VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Debe especificar al menos una regi\00F3n para crear.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99890832932304440)
,p_name=>'F4000.P277.WORKSPACE_NOT_CREATED_ALREADY_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('No se crear\00E1 el espacio de trabajo porque ya existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99890912517304440)
,p_name=>'F4000.P277.WORKSPACE_WILL_BE_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1 el espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100736608567305121)
,p_name=>'F4000.P291.VIEW_LOCK'
,p_message_language=>'es'
,p_message_text=>'Ver Bloqueo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99768555067304343)
,p_name=>'F4000.P295.VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Debe especificar al menos una p\00E1gina para crear.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100736739016305121)
,p_name=>'F4000.P337.PAGE_UNLOCKED'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina est\00E1 actualmente desbloqueada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100300198847304791)
,p_name=>'F4000.P371.POPUP_LOV'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores Emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99930715203304472)
,p_name=>'F4000.P374.POS.1'
,p_message_language=>'es'
,p_message_text=>'Pos. 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99930855549304472)
,p_name=>'F4000.P374.POS.2'
,p_message_language=>'es'
,p_message_text=>'Pos. 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99930906261304472)
,p_name=>'F4000.P374.POS.3'
,p_message_language=>'es'
,p_message_text=>'Pos. 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99931013499304472)
,p_name=>'F4000.P374.POS.4'
,p_message_language=>'es'
,p_message_text=>'Pos. 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99528928612304163)
,p_name=>'F4000.P374.POS.5'
,p_message_language=>'es'
,p_message_text=>'Pos. 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100097809286304599)
,p_name=>'F4000.P374.POS.6'
,p_message_language=>'es'
,p_message_text=>'Pos. 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100097932297304600)
,p_name=>'F4000.P374.POS.7'
,p_message_language=>'es'
,p_message_text=>'Pos. 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100098024051304600)
,p_name=>'F4000.P374.POS.8'
,p_message_language=>'es'
,p_message_text=>'Pos. 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99931191341304472)
,p_name=>'F4000.P381_XBUTTON_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los botones de DML y de paginaci\00F3n necesitan nombres de botones espec\00EDficos. Consulte el texto de ayuda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100733383379305118)
,p_name=>'F4000.P386.CLASS_MATCHES'
,p_message_language=>'es'
,p_message_text=>'%0 (Coincidencias de Clase)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99931202771304472)
,p_name=>'F4000.P4001.AUTH_HOME'
,p_message_language=>'es'
,p_message_text=>'gestionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100739915917305123)
,p_name=>'F4000.P4001.ORIGINAL_VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor Original'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99931334633304472)
,p_name=>'F4000.P4001.SUBSTITUTION_STR'
,p_message_language=>'es'
,p_message_text=>unistr('Cadena de Sustituci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99931440571304472)
,p_name=>'F4000.P4001.SUBSTITUTION_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Sustituci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99904720864304451)
,p_name=>'F4000.P4017.HELP_REGION_SOURCE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<font class="instructiontext">Esta regi\00F3n mostrar\00E1 la ayuda de p\00E1gina y de elemento para la p\00E1gina actual al llamarla con la siguiente sintaxis:<br>'),
'<pre><escape sc>f?p=&AMP;APP_ID.:Page:Session:&APP_PAGE_ID.</pre></font>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99931547358304472)
,p_name=>'F4000.P4039.FORM_ON'
,p_message_language=>'es'
,p_message_text=>'Pantalla Basada en %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99931684096304472)
,p_name=>'F4000.P404.VALUES'
,p_message_language=>'es'
,p_message_text=>'Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99655716912304260)
,p_name=>'F4000.P4045.BRANCH='
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcaci\00F3n=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99923853573304466)
,p_name=>'F4000.P4045.BUTTON='
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99546477317304179)
,p_name=>'F4000.P4045.CHART_SERIES='
,p_message_language=>'es'
,p_message_text=>unistr('Serie de Gr\00E1fico=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99924011401304466)
,p_name=>'F4000.P4045.COMPUTATION='
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculo=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99923479033304466)
,p_name=>'F4000.P4045.ICON_SUBTEXT='
,p_message_language=>'es'
,p_message_text=>'Subtexto de Icono='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99923328045304466)
,p_name=>'F4000.P4045.IMAGE='
,p_message_language=>'es'
,p_message_text=>'Imagen='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99923949314304466)
,p_name=>'F4000.P4045.ITEM='
,p_message_language=>'es'
,p_message_text=>'Elemento='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99923534937304466)
,p_name=>'F4000.P4045.LIST='
,p_message_language=>'es'
,p_message_text=>'Lista='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99655808237304261)
,p_name=>'F4000.P4045.MENU_OPTION='
,p_message_language=>'es'
,p_message_text=>unistr('Entrada de Ruta de Navegaci\00F3n=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99923731657304466)
,p_name=>'F4000.P4045.PAGE='
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99924118084304467)
,p_name=>'F4000.P4045.PROCESS='
,p_message_language=>'es'
,p_message_text=>'Proceso='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99546302587304179)
,p_name=>'F4000.P4045.REGION='
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99920945105304464)
,p_name=>'F4000.P4045.REQUIRED_BY_EVERY_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Necesario para todas las p\00E1ginas de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99923058053304466)
,p_name=>'F4000.P4045.REQUIRED_TO_DISPLAY_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99923130671304466)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculo de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99923275130304466)
,p_name=>'F4000.P4045.REQUIRED_TO_RUN_APP_PROCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Proceso de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99924360369304467)
,p_name=>'F4000.P4045.TAB_NAME='
,p_message_language=>'es'
,p_message_text=>'Nombre de Separador='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99924496252304467)
,p_name=>'F4000.P4045.TAB_SET='
,p_message_language=>'es'
,p_message_text=>'Juego de Separadores='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99923600140304466)
,p_name=>'F4000.P4045.TEXT='
,p_message_language=>'es'
,p_message_text=>'Texto='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99924279279304467)
,p_name=>'F4000.P4045.VALIDATION='
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n=')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99933358704304474)
,p_name=>'F4000.P420.CSV_EXPORT'
,p_message_language=>'es'
,p_message_text=>'Descargar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99933996347304474)
,p_name=>'F4000.P420.CVS'
,p_message_language=>'es'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99932979266304473)
,p_name=>'F4000.P420.DEFAULT_LOOK1'
,p_message_language=>'es'
,p_message_text=>'Aspecto por Defecto 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99933003730304473)
,p_name=>'F4000.P420.DEFAULT_LOOK2'
,p_message_language=>'es'
,p_message_text=>'Aspecto por Defecto 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99933112848304473)
,p_name=>'F4000.P420.DEFAULT_LOOK3'
,p_message_language=>'es'
,p_message_text=>'Aspecto por Defecto 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99933237006304474)
,p_name=>'F4000.P420.DEFAULT_LOOK4'
,p_message_language=>'es'
,p_message_text=>'Aspecto por Defecto 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99932032121304473)
,p_name=>'F4000.P420.EXTERNAL_PAGINATION'
,p_message_language=>'es'
,p_message_text=>unistr('Usar Botones de Paginaci\00F3n Creados Externamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99932816048304473)
,p_name=>'F4000.P420.HTML_STD'
,p_message_language=>'es'
,p_message_text=>unistr('Aspecto Est\00E1ndar HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99933521800304474)
,p_name=>'F4000.P420.LOOK1'
,p_message_language=>'es'
,p_message_text=>'Aspecto 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99933646575304474)
,p_name=>'F4000.P420.LOOK2'
,p_message_language=>'es'
,p_message_text=>'Aspecto 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99933713212304474)
,p_name=>'F4000.P420.LOOK3'
,p_message_language=>'es'
,p_message_text=>'Aspecto 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99933847934304474)
,p_name=>'F4000.P420.LOOK4'
,p_message_language=>'es'
,p_message_text=>'Aspecto 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99932506268304473)
,p_name=>'F4000.P420.ROWS_X_TO_Y'
,p_message_language=>'es'
,p_message_text=>'Filas X a Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99932261428304473)
,p_name=>'F4000.P420.ROW_RANGE'
,p_message_language=>'es'
,p_message_text=>unistr('Rangos de Fila 1-15 16-30 en Lista de Selecci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99932708084304473)
,p_name=>'F4000.P420.SEARCH_ENGINE'
,p_message_language=>'es'
,p_message_text=>unistr('Motor de B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99932368174304473)
,p_name=>'F4000.P420.SEARCH_ENGINE_123'
,p_message_language=>'es'
,p_message_text=>unistr('Motor de B\00FAsqueda 1,2,3,4 (paginaci\00F3n basada en juegos)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99932677251304473)
,p_name=>'F4000.P420.SELECT_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Lista de Selecci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99931858629304473)
,p_name=>'F4000.P420.SET_DEFAULTS'
,p_message_language=>'es'
,p_message_text=>'definir valores por defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99931905776304473)
,p_name=>'F4000.P420.TURN_OFF_PAGINATION'
,p_message_language=>'es'
,p_message_text=>unistr('desactivar paginaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99932472592304473)
,p_name=>'F4000.P420.USE_PAGINATION'
,p_message_language=>'es'
,p_message_text=>unistr('Usar botones de paginaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99934017568304474)
,p_name=>'F4000.P420.XML'
,p_message_language=>'es'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99933408170304474)
,p_name=>'F4000.P420.XML_EXPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Exportaci\00F3n de XML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99934168689304474)
,p_name=>'F4000.P422.GEN_LINK'
,p_message_language=>'es'
,p_message_text=>'Generar Enlace'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99932199863304473)
,p_name=>'F4000.P429.ROWS_X_TO_Y'
,p_message_language=>'es'
,p_message_text=>'Rangos de Fila X a Y (con enlaces siguientes y anteriores)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100759212146305138)
,p_name=>'F4000.P4311.P371.ALWAYS_NULL'
,p_message_language=>'es'
,p_message_text=>'Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100058184080304568)
,p_name=>'F4000.P4311.P371.DB_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100058366855304569)
,p_name=>'F4000.P4311.P371.PLSQL_EXP'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100058416778304569)
,p_name=>'F4000.P4311.P371.PLSQL_FUNC_BODY'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100058231380304569)
,p_name=>'F4000.P4311.P371.SQL_QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100058029482304568)
,p_name=>'F4000.P4311.P371.STATIC_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('texto est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99934232014304474)
,p_name=>'F4000.P4314_XBUTTON_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los botones DML necesitan nombres de bot\00F3n concretos y texto de ayuda de referencia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99600850897304220)
,p_name=>'F4000.P4450.ACTION_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1 un nuevo plugin en la aplicaci\00F3n %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99600704429304220)
,p_name=>'F4000.P4450.ACTION_REPLACE'
,p_message_language=>'es'
,p_message_text=>unistr('El plugin existente en la aplicaci\00F3n %0 se sustituir\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99934319513304474)
,p_name=>'F4000.P4651.HTML_W_SHORTCUTS'
,p_message_language=>'es'
,p_message_text=>unistr('HTML con m\00E9todos abreviados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99934526373304475)
,p_name=>'F4000.P4651.PLSQL'
,p_message_language=>'es'
,p_message_text=>'PLSQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99925227203304467)
,p_name=>'F4000.P4656.DEFAULT_BUTTON_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Bot\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99646202356304253)
,p_name=>'F4000.P4656.DEFAULT_CALENDAR_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Calendario por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100755533637305135)
,p_name=>'F4000.P4656.DEFAULT_CHART_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Gr\00E1fico por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99646098190304253)
,p_name=>'F4000.P4656.DEFAULT_DIALOG_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de P\00E1gina de Cuadro de Di\00E1logo por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100755676884305135)
,p_name=>'F4000.P4656.DEFAULT_FORM_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Pantalla por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100756067599305135)
,p_name=>'F4000.P4656.DEFAULT_IRR_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Informe Interactivo por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99925140255304467)
,p_name=>'F4000.P4656.DEFAULT_LABEL_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Etiqueta por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100755750747305135)
,p_name=>'F4000.P4656.DEFAULT_LISTR_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Lista por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99925010762304467)
,p_name=>'F4000.P4656.DEFAULT_LIST_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Lista por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100756209255305135)
,p_name=>'F4000.P4656.DEFAULT_MENUR_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Ruta de Navegaci\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99925373776304467)
,p_name=>'F4000.P4656.DEFAULT_MENU_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Ruta de Navegaci\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100755398195305135)
,p_name=>'F4000.P4656.DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Lista de Barra de Navegaci\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100755073267305135)
,p_name=>'F4000.P4656.DEFAULT_NAV_LIST_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Lista de Men\00FA de Navegaci\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100754838530305134)
,p_name=>'F4000.P4656.DEFAULT_OPTION_LABEL'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Etiqueta Opcional por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99924779176304467)
,p_name=>'F4000.P4656.DEFAULT_PAGE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de P\00E1gina por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99924887232304467)
,p_name=>'F4000.P4656.DEFAULT_REGION_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100755839108305135)
,p_name=>'F4000.P4656.DEFAULT_REPORTR_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Informe por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99924925992304467)
,p_name=>'F4000.P4656.DEFAULT_REPORT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Informe por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100754919463305134)
,p_name=>'F4000.P4656.DEFAULT_REQUIRED_LABEL'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Etiqueta Necesaria por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100755249953305135)
,p_name=>'F4000.P4656.DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Lista de Men\00FA de Navegaci\00F3n Lateral por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100755904264305135)
,p_name=>'F4000.P4656.DEFAULT_TABFORM_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Pantalla Tabular por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100755189924305135)
,p_name=>'F4000.P4656.DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Lista de Men\00FA de Navegaci\00F3n Superior por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100756172933305135)
,p_name=>'F4000.P4656.DEFAULT_WIZARD_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n de Asistente por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99924643066304467)
,p_name=>'F4000.P4656.ERROR_PAGE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de P\00E1gina de Error por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100755423358305135)
,p_name=>'F4000.P4656.LOGIN_PAGE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de P\00E1gina de Conexi\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99924520558304467)
,p_name=>'F4000.P4656.PRINT_MODE_PAGE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de P\00E1gina de Modo de Impresi\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99931777611304472)
,p_name=>'F4000.P4703.REPORT_ON'
,p_message_language=>'es'
,p_message_text=>'Informe sobre %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99928357847304470)
,p_name=>'F4000.P4717.ALERT_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('informaci\00F3n de alerta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99928589148304470)
,p_name=>'F4000.P4717.NEW_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('nueva regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99928261618304470)
,p_name=>'F4000.P4717.REGION_MUST_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('Para crear un elemento de p\00E1gina debe crear al menos una regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99928436682304470)
,p_name=>'F4000.P4717.USE_WIZARD'
,p_message_language=>'es'
,p_message_text=>unistr('Utilice un asistente para crear una nueva regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99929707489304471)
,p_name=>'F4000.P4719.ALPHABETIC_SORT'
,p_message_language=>'es'
,p_message_text=>unistr('se ordenar\00E1 alfab\00E9ticamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99929907271304471)
,p_name=>'F4000.P4719.BIND_VAR_LOV'
,p_message_language=>'es'
,p_message_text=>'Ejemplo 4: Lista de valores con variable de enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99929833130304471)
,p_name=>'F4000.P4719.CREATION_SORT'
,p_message_language=>'es'
,p_message_text=>unistr('ordenado por orden de creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99929400231304471)
,p_name=>'F4000.P4719.D_R_LOV'
,p_message_language=>'es'
,p_message_text=>unistr('Ejemplo 2: Lista de valores con el mismo valor de visualizaci\00F3n y retorno')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100022210749304541)
,p_name=>'F4000.P4719.INLINE'
,p_message_language=>'es'
,p_message_text=>unistr('Ejemplo 5: La consulta contiene una consulta en l\00EDnea; debe asegurarse de que la primera cl\00E1usula FROM de la sentencia SQL no forma parte de la consulta en l\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99929392126304471)
,p_name=>'F4000.P4719.SQL_QUERY_LOV'
,p_message_language=>'es'
,p_message_text=>'Ejemplo 1: Lista de valores basada en consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99929608330304471)
,p_name=>'F4000.P4719.STATIC_LOV'
,p_message_language=>'es'
,p_message_text=>unistr('Ejemplo 3: Ejemplos de lista est\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99929517487304471)
,p_name=>'F4000.P4719.USE_ALIAS'
,p_message_language=>'es'
,p_message_text=>unistr('Si se selecciona la misma columna para los valores de visualizaci\00F3n y de retorno, utilice un alias de columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99599740514304219)
,p_name=>'F4000.P4719.YN'
,p_message_language=>'es'
,p_message_text=>unistr('mostrar S\00ED / No, devolver S y N')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99935180375304475)
,p_name=>'F4000.P4728.AFTER_PROCESSING'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Procesamiento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99934865342304475)
,p_name=>'F4000.P4728.BEFORE_COMPUTATIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Antes de C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99935016069304475)
,p_name=>'F4000.P4728.BEFORE_PROCESSING'
,p_message_language=>'es'
,p_message_text=>'Antes de Procesamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99934910348304475)
,p_name=>'F4000.P4728.BEFORE_VALIDATIONS'
,p_message_language=>'es'
,p_message_text=>'Antes de Validaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99606102611304224)
,p_name=>'F4000.P4731.ADD'
,p_message_language=>'es'
,p_message_text=>'Agregar Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99935240928304475)
,p_name=>'F4000.P4731.APPLY'
,p_message_language=>'es'
,p_message_text=>'Aplicar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99603004365304221)
,p_name=>'F4000.P4731.DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99935493585304475)
,p_name=>'F4000.P4731.FINISH'
,p_message_language=>'es'
,p_message_text=>'Terminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99935326988304475)
,p_name=>'F4000.P4731.SUBMIT'
,p_message_language=>'es'
,p_message_text=>'Ejecutar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99935635092304475)
,p_name=>'F4000.P4735_RP_ALL'
,p_message_language=>'es'
,p_message_text=>unistr('La paginaci\00F3n se restablecer\00E1 para todas las p\00E1ginas de esta aplicaci\00F3n cuando se ejecute este proceso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99947737403304485)
,p_name=>'F4000.P4738.REGEXP_WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('ADVERTENCIA: Ha seleccionado una validaci\00F3n de tipo Expresi\00F3n Regular, pero la versi\00F3n de la base de datos no la soporta. Esta validaci\00F3n siempre devolver\00E1 un valor verdadero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100684647881305082)
,p_name=>'F4000.P4761.TRANSLATIONS_NOT_USED'
,p_message_language=>'es'
,p_message_text=>unistr('Las traducciones de esta aplicaci\00F3n no se est\00E1n activadas. Compruebe la opci\00F3n <em>Idioma de Aplicaci\00F3n Derivado de</em> de <a href="%0"> Atributos de Globalizaci\00F3n</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100746864236305128)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'
,p_message_language=>'es'
,p_message_text=>unistr('Si no se define el tiempo m\00E1ximo de inactividad de sesi\00F3n, se utilizar\00E1 el valor de nivel de espacio de trabajo o de nivel de instancia (actualmente, %0 segundos).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100746953599305129)
,p_name=>'F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_message_language=>'es'
,p_message_text=>unistr('Si no se define la duraci\00F3n m\00E1xima de la sesi\00F3n, se utilizar\00E1 el valor de nivel de espacio de trabajo o de nivel de instancia (actualmente, %0 segundos).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100737397981305121)
,p_name=>'F4000.P593.NEW_BRANCH'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100048415203304561)
,p_name=>'F4000.P598.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('Estos componentes se han exportado de una aplicaci\00F3n diferente o de una aplicaci\00F3n en otro espacio de trabajo. Los componentes no se pueden instalar en esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100052479512304564)
,p_name=>'F4000.P612.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Estos archivos se han exportado de otro espacio de trabajo. No se pueden instalar los archivos en este espacio de trabajo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100737455752305121)
,p_name=>'F4000.P622.TO_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'A Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100738286540305122)
,p_name=>'F4000.P623.COPY_OPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Copiar Opci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100738302155305122)
,p_name=>'F4000.P623.EXISTING_LOV'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores Existentes: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99989396205304516)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina se ha exportado de una aplicaci\00F3n diferente o de una aplicaci\00F3n en otro espacio de trabajo. La p\00E1gina no se puede instalar en esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99890799243304440)
,p_name=>'F4000.P67.EXPORTED_FROM_ANOTHER_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina se ha exportado de una aplicaci\00F3n en otro espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99890639038304440)
,p_name=>'F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina se ha exportado desde una aplicaci\00F3n en el espacio de trabajo actual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100309646305304798)
,p_name=>'F4000.P67.PAGE_LOCKED'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina est\00E1 bloqueada actualmente. No se puede importar en una p\00E1gina bloqueada. Desbloquee la p\00E1gina y, a continuaci\00F3n, realice la instalaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100735999457305120)
,p_name=>'F4000.P712.CLEAR_PARENT_ENTRY'
,p_message_language=>'es'
,p_message_text=>'Borrar Entrada Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100737705497305122)
,p_name=>'F4000.P765.SELECT_PARAM'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccionar Par\00E1metro %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99709631733304300)
,p_name=>'F4000.P818.VALIDATION'
,p_message_language=>'es'
,p_message_text=>'Debe seleccionar al menos un esquema que copiar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100737983203305122)
,p_name=>'F4000.P875.HTTP_HEADER_VAL'
,p_message_language=>'es'
,p_message_text=>'Valor para la Cabecera HTTP %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100737824176305122)
,p_name=>'F4000.P875.INPUT_PARAM_VAL'
,p_message_language=>'es'
,p_message_text=>unistr('Valor para el Par\00E1metro de Entrada %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100738101806305122)
,p_name=>'F4000.P876.DELETE_HEADER'
,p_message_language=>'es'
,p_message_text=>'Suprimir Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100738079812305122)
,p_name=>'F4000.P876.DELETE_PARAM'
,p_message_language=>'es'
,p_message_text=>unistr('Suprimir Par\00E1metro: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99937478259304477)
,p_name=>'F4000.P904.REQUIRED_STYLE_SHEET'
,p_message_language=>'es'
,p_message_text=>'Hoja de Estilo Necesaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99906518268304453)
,p_name=>'F4000.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99921176241304464)
,p_name=>'F4000.PAGE_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99892631245304442)
,p_name=>'F4000.PAGE_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99647465898304254)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n Din\00E1mica de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99508467820304147)
,p_name=>'F4000.PAGE_DYNAMIC_ACTION_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n din\00E1mica de p\00E1gina: acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99891318685304440)
,p_name=>'F4000.PAGE_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99510654372304149)
,p_name=>'F4000.PAGE_ITEM_GROUP'
,p_message_language=>'es'
,p_message_text=>unistr('Grupo de elementos de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99925525842304468)
,p_name=>'F4000.PAGE_MAYBE_PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('p\00E1gina(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99906665983304453)
,p_name=>'F4000.PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99892790940304442)
,p_name=>'F4000.PAGE_PROCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Proceso de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99921060525304464)
,p_name=>'F4000.PAGE_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99921250400304464)
,p_name=>'F4000.PAGE_VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99893587924304442)
,p_name=>'F4000.PARENT_TAB'
,p_message_language=>'es'
,p_message_text=>'Separador Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99907595663304454)
,p_name=>'F4000.POPUP_LOV_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Lista de Valores Emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100524740480304959)
,p_name=>'F4000.PRINT_CREDENTIALS'
,p_message_language=>'es'
,p_message_text=>unistr('Credenciales del servidor de impresi\00F3n remoto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99908147954304454)
,p_name=>'F4000.PUBLISH'
,p_message_language=>'es'
,p_message_text=>'Publicar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99892150941304441)
,p_name=>'F4000.REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100521229632304957)
,p_name=>'F4000.REGION_COLUMNS'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99906738643304453)
,p_name=>'F4000.RELATED_PAGES_AND_COMPONENTS'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas Relacionadas y Componentes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100524901397304959)
,p_name=>'F4000.REMOTE_DATABASE'
,p_message_language=>'es'
,p_message_text=>'SQL activado para REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100022008742304541)
,p_name=>'F4000.REPORT_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99537758686304169)
,p_name=>'F4000.REST_ENABLED_SQL'
,p_message_language=>'es'
,p_message_text=>'SQL activado para REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99908095953304454)
,p_name=>'F4000.SEED'
,p_message_language=>'es'
,p_message_text=>'Extraer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99893456066304442)
,p_name=>'F4000.STANDARD_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('Separador Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99920687477304464)
,p_name=>'F4000.STATIC'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99907335199304453)
,p_name=>'F4000.TAB'
,p_message_language=>'es'
,p_message_text=>'Separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99907649932304454)
,p_name=>'F4000.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99751467183304330)
,p_name=>'F4000.TEMPLATE_NAME_ALREADY_EXISTS'
,p_message_language=>'es'
,p_message_text=>'El nombre de la plantilla %0 ya existe. Introduzca un nuevo nombre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99709736297304300)
,p_name=>'F4000.TEMPLATE_NAME_MAND'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el nombre de la plantilla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99907833026304454)
,p_name=>'F4000.THEME_IMPORT_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1 un nuevo tema en la aplicaci\00F3n %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99907963612304454)
,p_name=>'F4000.THEME_IMPORT_REPLACE'
,p_message_language=>'es'
,p_message_text=>unistr('El tema existente en la aplicaci\00F3n %0 se sustituir\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99906995226304453)
,p_name=>'F4000.TO'
,p_message_language=>'es'
,p_message_text=>'a'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99894056023304443)
,p_name=>'F4000.UNKNOWN_APPLICATION_ELEMENT'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de Aplicaci\00F3n Desconocido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99908211884304454)
,p_name=>'F4000.UPDATEABLE_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna Actualizable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100033463700304550)
,p_name=>'F4000.UTILITIES.INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Las utilidades incluyen las p\00E1ginas de edici\00F3n de cuadr\00EDculas y los informes de todas las p\00E1ginas de la aplicaci\00F3n seleccionada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99892808760304442)
,p_name=>'F4000.VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99537831124304169)
,p_name=>'F4000.WEB_SOURCE'
,p_message_language=>'es'
,p_message_text=>'Origen de Datos de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100525045931304959)
,p_name=>'F4000.WEB_SRC_MODULE'
,p_message_language=>'es'
,p_message_text=>'Origen de Datos de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99891093106304440)
,p_name=>'F4000.YES'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99967182777304499)
,p_name=>'F4000_4738_DATE_MMDDYYY'
,p_message_language=>'es'
,p_message_text=>'Fecha MMDDYYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100120804381304617)
,p_name=>'F4000_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99672933432304273)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Como aplicaci\00F3n en una tabla de base de datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99925948498304468)
,p_name=>'F4000_AS_APP_ON_EXIST_TABLES'
,p_message_language=>'es'
,p_message_text=>unistr('Como aplicaci\00F3n en las tablas de bases de datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99937598781304477)
,p_name=>'F4000_BUTTON_POS_NOT_IN_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Esta posici\00F3n de bot\00F3n no est\00E1 en la plantilla de regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100673532166305070)
,p_name=>'F4000_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99937890238304477)
,p_name=>'F4000_CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99954420347304490)
,p_name=>'F4000_COPY_AND_SUBSCRIBE'
,p_message_language=>'es'
,p_message_text=>'Copiar y Suscribir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99938127515304477)
,p_name=>'F4000_DATE_NOT_REC'
,p_message_language=>'es'
,p_message_text=>'Formato de fecha no reconocido.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99605800312304224)
,p_name=>'F4000_F1500_LOCKED'
,p_message_language=>'es'
,p_message_text=>'Bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100037285366304553)
,p_name=>'F4000_HELP_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto de Ayuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100119947499304616)
,p_name=>'F4000_LOV_NAME_EXISTS'
,p_message_language=>'es'
,p_message_text=>'Los nombres de lista de valores %0 ya existen. Introduzca un nuevo nombre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99961078471304495)
,p_name=>'F4000_NONE_SELECTED'
,p_message_language=>'es'
,p_message_text=>'Ninguno Seleccionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99917322608304461)
,p_name=>'F4000_NO_APP_ASSOC'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna Aplicaci\00F3n Asociada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99549191294304181)
,p_name=>'F4000_OFF'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99549063724304181)
,p_name=>'F4000_ON'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99609402764304226)
,p_name=>'F4000_P122_CAL_TEMPL'
,p_message_language=>'es'
,p_message_text=>'Plantillas de calendario que hacen referencia a esta plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99990209845304517)
,p_name=>'F4000_P128.VIEW_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('ver p\00E1ginas de este tipo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99718788326304307)
,p_name=>'F4000_P173_NO_HELP'
,p_message_language=>'es'
,p_message_text=>'no existe ayuda para este elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99710728939304301)
,p_name=>'F4000_P1_AUTHENTICATION_HOME'
,p_message_language=>'es'
,p_message_text=>unistr('p\00E1gina inicial de autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99710688595304301)
,p_name=>'F4000_P1_EDIT_THIS_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Editar esta Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99726271865304312)
,p_name=>'F4000_P232_RESET_CSS'
,p_message_language=>'es'
,p_message_text=>'Restablecer CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100331775792304815)
,p_name=>'F4000_P295_PAGE_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina ya existe en esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99606246496304224)
,p_name=>'F4000_P295_PAGE_MUST_BE_NUMERIC'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina debe ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99606382812304224)
,p_name=>'F4000_P295_PAGE_MUST_BE_POSITIVE'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina debe ser un n\00FAmero positivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99606470822304224)
,p_name=>'F4000_P295_PAGE_MUST_BE_WHOLE_NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina debe ser un n\00FAmero entero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100038548991304554)
,p_name=>'F4000_P3005.IMPORT_AUTHORIZATION SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Importar Esquemas de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99988032412304515)
,p_name=>'F4000_P3005.IMPORT_AUTH_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Importar Esquemas de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100038649301304554)
,p_name=>'F4000_P3005.IMPORT_NAVBAR'
,p_message_language=>'es'
,p_message_text=>unistr('Importar Barras de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99988187412304515)
,p_name=>'F4000_P3005.IMPORT_THEME'
,p_message_language=>'es'
,p_message_text=>'Importar Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99936078528304476)
,p_name=>'F4000_P33_REGION_TITLE'
,p_message_language=>'es'
,p_message_text=>'Pantalla Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99966851546304499)
,p_name=>'F4000_P3890_AUTHENTICATED'
,p_message_language=>'es'
,p_message_text=>'Autenticado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99966927655304499)
,p_name=>'F4000_P3890_AUTH_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99958778592304493)
,p_name=>'F4000_P395_NO_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Ninguna Columna'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99939330591304478)
,p_name=>'F4000_P4001_UNAVAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Esta aplicaci\00F3n no est\00E1 disponible en este momento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99688200638304284)
,p_name=>'F4000_P430_DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99688355485304284)
,p_name=>'F4000_P430_DATE2'
,p_message_language=>'es'
,p_message_text=>'Fecha, flexible: %0 con cualquier separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99689028446304285)
,p_name=>'F4000_P430_DATE2_ERR'
,p_message_language=>'es'
,p_message_text=>'Formato de fecha no reconocido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99688901242304284)
,p_name=>'F4000_P430_DATE_ERR'
,p_message_language=>'es'
,p_message_text=>'La fecha debe tener el formato %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99687779689304284)
,p_name=>'F4000_P430_IP'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n IP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99688581084304284)
,p_name=>'F4000_P430_IP_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n IP no V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99687842054304284)
,p_name=>'F4000_P430_PHONE'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Tel\00E9fono, EE.UU.: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99687976358304284)
,p_name=>'F4000_P430_PHONE2'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Tel\00E9fono, EE.UU. (flexible): 999.999.9999, (999)-999-9999, 999 999 9999, etc...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99688755510304284)
,p_name=>'F4000_P430_PHONE2_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se reconoce el formato del n\00FAmero de tel\00E9fono.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99688635571304284)
,p_name=>'F4000_P430_PHONE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero de tel\00E9fono debe tener el formato %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99687600574304284)
,p_name=>'F4000_P430_URL'
,p_message_language=>'es'
,p_message_text=>'URL: http(s)://dominio/ruta/doc.(pdf)(html)(etc...)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99688423626304284)
,p_name=>'F4000_P430_URL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n URL no V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99688042017304284)
,p_name=>'F4000_P430_ZIP'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo Postal: 99999')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99688168559304284)
,p_name=>'F4000_P430_ZIP2'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo Postal + 4: 99999-9999')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99688860206304284)
,p_name=>'F4000_P430_ZIP_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El c\00F3digo postal debe tener el formato %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99619173139304233)
,p_name=>'F4000_P4495.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99619225696304233)
,p_name=>'F4000_P4495.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('\00C9sta es la copia "maestra" de este esquema de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99619413565304234)
,p_name=>'F4000_P4495.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ning\00FAn suscriptor para este esquema de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99619335628304233)
,p_name=>'F4000_P4495.REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Esquemas que se suscriben a este esquema de autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99674150988304274)
,p_name=>'F4000_P4495_LOV_NO_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('- ning\00FAn esquema -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99934610833304475)
,p_name=>'F4000_P4701_PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>'Informe 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99939496255304478)
,p_name=>'F4000_P4705_FORM_ON_A_PROC'
,p_message_language=>'es'
,p_message_text=>'Pantalla Basada en Procedimiento Almacenado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99934769989304475)
,p_name=>'F4000_P4710_PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99938727192304478)
,p_name=>'F4000_P4717_DISPLAY'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99938644186304478)
,p_name=>'F4000_P4717_HIDDEN'
,p_message_language=>'es'
,p_message_text=>'Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99938348018304477)
,p_name=>'F4000_P4734_CLEAR_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Borrar Cach\00E9 de Elementos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99938289397304477)
,p_name=>'F4000_P4734_CLEAR_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Borrar Cach\00E9 de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99961325791304495)
,p_name=>'F4000_P4734_RESET_PAG'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer Paginaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99938536492304478)
,p_name=>'F4000_P4734_SET_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Definir Elemento con Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99938488645304478)
,p_name=>'F4000_P4734_STATIC_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Asignaci\00F3n de Elementos Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99935531646304475)
,p_name=>'F4000_P4735_INITIALIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Todos los elementos de p\00E1gina que no est\00E1n almacenados en cach\00E9 en la aplicaci\00F3n actual no se inicializar\00E1n en nulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99939195165304478)
,p_name=>'F4000_P4737_EXISTS'
,p_message_language=>'es'
,p_message_text=>'Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99938800505304478)
,p_name=>'F4000_P4737_ITEM_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'Elemento No Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99938985375304478)
,p_name=>'F4000_P4737_ITEM_NOT_ZERO'
,p_message_language=>'es'
,p_message_text=>'Elemento No Cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99939053416304478)
,p_name=>'F4000_P4737_PLSQL_EXP'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99967367648304500)
,p_name=>'F4000_P4738_DATE_DDMMYYYY'
,p_message_language=>'es'
,p_message_text=>'Fecha DDMMYYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99967291605304500)
,p_name=>'F4000_P4738_PHONE_NUM'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Tel\00E9fono')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100705653167305098)
,p_name=>'F4000_P473_DATABASE_OBJECT'
,p_message_language=>'es'
,p_message_text=>'Objeto de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99935754040304475)
,p_name=>'F4000_P4759_VIEW'
,p_message_language=>'es'
,p_message_text=>'En Explorador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99935815552304476)
,p_name=>'F4000_P4785_REGION_NAME'
,p_message_language=>'es'
,p_message_text=>'Calendario 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99674392423304274)
,p_name=>'F4000_P4790_DATE_TIMESTAMP_NOTE'
,p_message_language=>'es'
,p_message_text=>'(con columna Fecha o Registro de Hora)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100154101190304681)
,p_name=>'F4000_P4790_SYNTAX_HEADING'
,p_message_language=>'es'
,p_message_text=>'Sintaxis: select id, name, date from ...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100154451101304681)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE1'
,p_message_language=>'es'
,p_message_text=>'Ejemplo del uso de pseudo columna ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100154556567304681)
,p_name=>'F4000_P4790_SYNTAX_HELP_EXAMPLE2'
,p_message_language=>'es'
,p_message_text=>'Ejemplo del uso de clave primaria de tabla de origen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100154221766304681)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE1'
,p_message_language=>'es'
,p_message_text=>'1. Debe incluir al menos dos columnas y una de ellas debe ser una columna DATE.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100154322562304681)
,p_name=>'F4000_P4790_SYNTAX_HELP_LINE2'
,p_message_language=>'es'
,p_message_text=>unistr('2. La primera columna debe identificar la columna de clave primaria que se utilizar\00E1 para gestionar la operaci\00F3n de lenguaje de manipulaci\00F3n de datos (DML).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99935910120304476)
,p_name=>'F4000_P4810_PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>'Pantalla 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100049005487304561)
,p_name=>'F4000_P48_MANIFEST'
,p_message_language=>'es'
,p_message_text=>unistr('Manifiesto de Exportaci\00F3n de Componente    ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99990152307304517)
,p_name=>'F4000_P497.VIEW_PAGE_DEF'
,p_message_language=>'es'
,p_message_text=>unistr('Ver Definici\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99936157353304476)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Resumen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99954776429304490)
,p_name=>'F4000_P52_TAB_LINK_TITLE'
,p_message_language=>'es'
,p_message_text=>'haga clic para definir el juego de separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100208815172304722)
,p_name=>'F4000_P643_NO_PARENT'
,p_message_language=>'es'
,p_message_text=>unistr('La plantilla de p\00E1gina soporta dos separadores de nivel, sin embargo, el separador est\00E1ndar no identifica un juego de separadores principales')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100208783421304722)
,p_name=>'F4000_P643_NO_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn separador; esta p\00E1gina no mostrar\00E1 separadores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100208575790304722)
,p_name=>'F4000_P643_ONE_LVL'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina mostrar\00E1 un nivel de separadores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100208980284304722)
,p_name=>'F4000_P643_PAGE_NO_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas sin separadores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100209035085304722)
,p_name=>'F4000_P643_PAGE_NO_TAB_TTL'
,p_message_language=>'es'
,p_message_text=>unistr('Un total de %0 p\00E1ginas no tiene ning\00FAn separador definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100208430125304722)
,p_name=>'F4000_P643_TAB_DISPLAY'
,p_message_language=>'es'
,p_message_text=>unistr('Visualizaci\00F3n de Separadores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100208690486304722)
,p_name=>'F4000_P643_TWO_LVL'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina mostrar\00E1 dos niveles de separadores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100656343868305057)
,p_name=>'F4000_P78_UPGRADE_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>Oracle APEX %0 est\00E1 disponible.</strong> Su instancia se actualizar\00E1 autom\00E1ticamente el <strong>%1</strong>. El administrador de su instancia puede iniciar la actualizaci\00F3n en cualquier momento antes de esta fecha desde los servicios de ad')
||unistr('ministraci\00F3n.</p>'),
unistr('<p>Consulte el <a href="%2" target="_blank" rel="noreferrer">anuncio</a> para obtener m\00E1s informaci\00F3n sobre las nuevas funciones y mejoras de Oracle APEX %0.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100656239755305057)
,p_name=>'F4000_P78_UPGRADING'
,p_message_language=>'es'
,p_message_text=>unistr('<strong>Su instancia %0 se est\00E1 actualizando a una versi\00F3n m\00E1s reciente.</strong> Los cambios en las aplicaciones se desactivar\00E1n durante un periodo de tiempo durante el proceso de actualizaci\00F3n. El acceso a las aplicaciones y al entorno de desarroll')
||unistr('o %0 se ver\00E1 interrumpido durante un m\00E1ximo de %1 minutos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99618052848304233)
,p_name=>'F4000_P801_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99618973758304233)
,p_name=>'F4000_P801_ACTIVATE1'
,p_message_language=>'es'
,p_message_text=>'Convierta este segmento en actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99619056927304233)
,p_name=>'F4000_P801_ACTIVATE2'
,p_message_language=>'es'
,p_message_text=>'Actualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99673955581304274)
,p_name=>'F4000_P801_CURRENT'
,p_message_language=>'es'
,p_message_text=>'actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99618717192304233)
,p_name=>'F4000_P801_DEACTIVATE'
,p_message_language=>'es'
,p_message_text=>'Cambie el estado a inactivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99617560563304232)
,p_name=>'F4000_P801_DETAILS'
,p_message_language=>'es'
,p_message_text=>'Detalles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99617695294304232)
,p_name=>'F4000_P801_DETAILS_BI1'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('L\00F3gica de gesti\00F3n de sesiones incorporadas, una p\00E1gina de conexi\00F3n incorporada y autenticaci\00F3n de usuario en el repositorio de cuentas de "usuario de cookie".'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99617723080304232)
,p_name=>'F4000_P801_DETAILS_OBS1'
,p_message_language=>'es'
,p_message_text=>unistr('Este m\00E9todo se ha sustituido por la autenticaci\00F3n de esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99671958315304272)
,p_name=>'F4000_P801_EDIT_DEPRECATED1'
,p_message_language=>'es'
,p_message_text=>unistr('Editar atributos de autenticaci\00F3n en desuso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99672077526304272)
,p_name=>'F4000_P801_EDIT_DEPRECATED2'
,p_message_language=>'es'
,p_message_text=>'atributos en desuso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99672115821304272)
,p_name=>'F4000_P801_EDIT_DEPRECATED3'
,p_message_language=>'es'
,p_message_text=>unistr('o mant\00E9ngalos en la misma ubicaci\00F3n hasta que est\00E9 preparado para cambiar el m\00E9todo de autenticaci\00F3n a %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99672436306304272)
,p_name=>'F4000_P801_EDIT_DEPRECATED4'
,p_message_language=>'es'
,p_message_text=>unistr('Especifica uno o m\00E1s atributos de autenticaci\00F3n en desuso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99672670551304273)
,p_name=>'F4000_P801_EDIT_DEPRECATED5'
,p_message_language=>'es'
,p_message_text=>unistr('o migrarlos a un esquema de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99671604617304272)
,p_name=>'F4000_P801_FLOW'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99618672805304233)
,p_name=>'F4000_P801_MANAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Gestione los esquemas de autenticaci\00F3n mediante el informe anterior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99617491349304232)
,p_name=>'F4000_P801_METHOD'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99673838841304273)
,p_name=>'F4000_P801_NO_EDIT'
,p_message_language=>'es'
,p_message_text=>'(No Editable)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99618834683304233)
,p_name=>'F4000_P801_PAREN_CURRENT'
,p_message_language=>'es'
,p_message_text=>'(actual)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99671703798304272)
,p_name=>'F4000_P801_PAREN_DEPRECATED'
,p_message_language=>'es'
,p_message_text=>'(en desuso)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99618545445304233)
,p_name=>'F4000_P801_PAREN_NONE'
,p_message_language=>'es'
,p_message_text=>'(ninguno)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99617990416304232)
,p_name=>'F4000_P801_PUBLIC_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas P\00FAblicas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99618165824304233)
,p_name=>'F4000_P801_REVIEW1'
,p_message_language=>'es'
,p_message_text=>'Revisar o editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99618245396304233)
,p_name=>'F4000_P801_REVIEW2'
,p_message_language=>'es'
,p_message_text=>'o editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99618389189304233)
,p_name=>'F4000_P801_REVIEW3'
,p_message_language=>'es'
,p_message_text=>unistr('los atributos de gesti\00F3n de la sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99618495156304233)
,p_name=>'F4000_P801_REVIEW4'
,p_message_language=>'es'
,p_message_text=>unistr('de esta aplicaci\00F3n en la p\00E1gina de atributos de aplicaci\00F3n o utilice el informe anterior para crear y gestionar los esquemas de autenticaci\00F3n que se pueden utilizar al cambiar el m\00E9todo de autenticaci\00F3n a %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99672264760304272)
,p_name=>'F4000_P801_REVIEW5'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Revise o edite los atributos de gesti\00F3n de la sesi\00F3n'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99672569678304273)
,p_name=>'F4000_P801_REVIEW6'
,p_message_language=>'es'
,p_message_text=>'Revisar o editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99671852855304272)
,p_name=>'F4000_P801_SCHEME_CONVERT'
,p_message_language=>'es'
,p_message_text=>unistr('La autenticaci\00F3n %0 es un m\00E9todo en desuso. Se recomienda que haga clic en el enlace "Actualizar" (mostrado anteriormente) en uno de los esquemas de autenticaci\00F3n en esta aplicaci\00F3n o que cree un nuevo esquema de autenticaci\00F3n y lo actualice. El esqu')
||unistr('ema de autenticaci\00F3n INTERNAL-SETUP es el equivalente funcional del m\00E9todo %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99672392565304272)
,p_name=>'F4000_P801_SCHEME_DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Utiliza los esquemas de autenticaci\00F3n para controlar la autenticaci\00F3n de usuario y todos los dem\00E1s aspectos de la gesti\00F3n de sesiones para la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99936447617304476)
,p_name=>'F4000_P805_X'
,p_message_language=>'es'
,p_message_text=>unistr('Ha especificado una funci\00F3n de protecci\00F3n de p\00E1gina en el paso anterior. Esa funci\00F3n ser\00E1 la responsable de la verificaci\00F3n de sesi\00F3n en cada p\00E1gina, por lo que aqu\00ED no puede introducir ninguna funci\00F3n de verificaci\00F3n de sesi\00F3n. Si esto no es lo que ')
||'desea, puede volver a los pasos anteriores del asistente y realizar cambios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99674990861304274)
,p_name=>'F4000_P806_BUILTIN_LOGIN_PG'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n Incorporada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99675313551304275)
,p_name=>'F4000_P806_NONE'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99675000355304274)
,p_name=>'F4000_P806_PAGE_IN_THIS_FLOW'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina en esta Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99675219644304274)
,p_name=>'F4000_P806_SSO_SERVER'
,p_message_language=>'es'
,p_message_text=>'Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99675101758304274)
,p_name=>'F4000_P806_URL'
,p_message_language=>'es'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99675446862304275)
,p_name=>'F4000_P808_AUTH_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Utilice el nombre de usuario y la contrase\00F1a de la cuenta %0 para autenticarse.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99561232209304190)
,p_name=>'F4000_P808_DBAUTH_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Utilice el nombre de usuario y la contrase\00F1a de la base de datos para realizar la autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99675580567304275)
,p_name=>'F4000_P808_NO_VERIFY_CRED'
,p_message_language=>'es'
,p_message_text=>'No verificar las credenciales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99675773695304275)
,p_name=>'F4000_P808_USE_CUSTOM'
,p_message_language=>'es'
,p_message_text=>unistr('Usar mi funci\00F3n personalizada para realizar la autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99675687332304275)
,p_name=>'F4000_P808_USE_LDAP'
,p_message_language=>'es'
,p_message_text=>unistr('Utilizar un servidor de LDAP para realizar la autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99939589186304478)
,p_name=>'F4000_P80_NO_PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('- Ning\00FAn nombre de p\00E1gina -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99620144510304234)
,p_name=>'F4000_P811_AUTH'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Funci\00F3n de Autenticaci\00F3n'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99620919415304235)
,p_name=>'F4000_P811_C_DOMAIN'
,p_message_language=>'es'
,p_message_text=>'Dominio de Cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99620738834304234)
,p_name=>'F4000_P811_C_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99620875490304235)
,p_name=>'F4000_P811_C_PATH'
,p_message_language=>'es'
,p_message_text=>'Ruta de Acceso de Cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99558339367304188)
,p_name=>'F4000_P811_C_SECURE'
,p_message_language=>'es'
,p_message_text=>'Proteger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99619959307304234)
,p_name=>'F4000_P811_INV_SESS_TGT'
,p_message_language=>'es'
,p_message_text=>unistr('Destino de Sesi\00F3n no V\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99620426811304234)
,p_name=>'F4000_P811_LDAP_DN'
,p_message_language=>'es'
,p_message_text=>unistr('Base de B\00FAsqueda LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99620551769304234)
,p_name=>'F4000_P811_LDAP_EDIT'
,p_message_language=>'es'
,p_message_text=>unistr('Edici\00F3n de Nombre de Usuario de LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99620249016304234)
,p_name=>'F4000_P811_LDAP_HOST'
,p_message_language=>'es'
,p_message_text=>'Host LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99620322129304234)
,p_name=>'F4000_P811_LDAP_PORT'
,p_message_language=>'es'
,p_message_text=>'Puerto LDAP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99621039186304235)
,p_name=>'F4000_P811_LOGOUT_URL'
,p_message_language=>'es'
,p_message_text=>unistr('URL de Desconexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99619643070304234)
,p_name=>'F4000_P811_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99619581655304234)
,p_name=>'F4000_P811_PAREN_BUILTIN'
,p_message_language=>'es'
,p_message_text=>'(Incorporado)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99621100393304235)
,p_name=>'F4000_P811_PAREN_DBAUTH'
,p_message_language=>'es'
,p_message_text=>unistr('(Autenticaci\00F3n de Base de Datos)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99619710553304234)
,p_name=>'F4000_P811_PG_SENTRY'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n de Protecci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99620673835304234)
,p_name=>'F4000_P811_POST_AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Proceso Posterior a la Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99620047516304234)
,p_name=>'F4000_P811_PRE_AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Proceso Anterior a la Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99619814625304234)
,p_name=>'F4000_P811_SESS_VERIFY'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n de Verificaci\00F3n de Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99675976405304275)
,p_name=>'F4000_P815_COPY'
,p_message_language=>'es'
,p_message_text=>unistr('Como copia de un esquema de autenticaci\00F3n existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99676057606304275)
,p_name=>'F4000_P815_GALLERY'
,p_message_language=>'es'
,p_message_text=>unistr('Basado en un esquema preconfigurado de la galer\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99675818766304275)
,p_name=>'F4000_P815_SCRATCH'
,p_message_language=>'es'
,p_message_text=>unistr('Basado en un esquema preconfigurado de la galer\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99633774756304244)
,p_name=>'F4000_P817_REFRESH_AUTH_SCHEME_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al refrescar los esquemas de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99621375523304235)
,p_name=>'F4000_P819_AUTH_METHOD'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todo de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99689177676304285)
,p_name=>'F4000_P819_CURR_WARN'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: Va a suprimir el esquema de autenticaci\00F3n actual para esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99621529930304235)
,p_name=>'F4000_P819_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99621273609304235)
,p_name=>'F4000_P819_FLOW_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99621462407304235)
,p_name=>'F4000_P819_SCHEME_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99676554116304275)
,p_name=>'F4000_P820_MY_PARTNER'
,p_message_language=>'es'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (Mi Aplicaci\00F3n como Aplicaci\00F3n Asociada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99676130515304275)
,p_name=>'F4000_P820_SHOW_ACCOUNT_CRED'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar P\00E1gina de Conexi\00F3n y Usar Credenciales de Cuenta %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99676271909304275)
,p_name=>'F4000_P820_SHOW_BUILTIN_PG_OPEN'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar P\00E1gina de Conexi\00F3n Incorporada y Usar Credenciales de Puertas Abiertas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99676315927304275)
,p_name=>'F4000_P820_SHOW_USE_LDAP'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar P\00E1gina de Conexi\00F3n y Usar Credenciales del Directorio LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99676455528304275)
,p_name=>'F4000_P820_SSO_HTMLDB_PARTNER'
,p_message_language=>'es'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (Motor %0 como Aplicaci\00F3n Asociada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99621874160304235)
,p_name=>'F4000_P822_CURR_METHOD'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todo de Autenticaci\00F3n Actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99633833806304244)
,p_name=>'F4000_P826_CREATE1'
,p_message_language=>'es'
,p_message_text=>unistr('Single Sign-On (S\00F3lo Utilizado en Oracle)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99633943939304244)
,p_name=>'F4000_P826_CREATE2'
,p_message_language=>'es'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (%0 como Aplicaci\00F3n Asociada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99634071014304244)
,p_name=>'F4000_P826_CREATE3'
,p_message_language=>'es'
,p_message_text=>unistr('Oracle Application Server Single Sign-On (Mi Aplicaci\00F3n como Aplicaci\00F3n Asociada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99634117243304244)
,p_name=>'F4000_P826_CREATE4'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n Incorporada: Usar Credenciales de Cuenta %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99656607360304261)
,p_name=>'F4000_P826_CREATE4A'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n Reci\00E9n Creada: Usar Credenciales de Cuenta %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99656725945304261)
,p_name=>'F4000_P826_CREATE4B'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n Existente: Usar Credenciales de Cuenta %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99634200180304244)
,p_name=>'F4000_P826_CREATE5'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n Incorporada: Credenciales de Puertas Abiertas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99634309697304244)
,p_name=>'F4000_P826_CREATE6'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n Incorporada: Usar Credenciales de Directorio LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99656499736304261)
,p_name=>'F4000_P826_CREATE6A'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n Reci\00E9n Creada: Usar Credenciales de Directorio LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99656576573304261)
,p_name=>'F4000_P826_CREATE6B'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n Existente: Usar Credenciales de Directorio LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99634489891304244)
,p_name=>'F4000_P826_CREATE7'
,p_message_language=>'es'
,p_message_text=>unistr('Basado en el esquema de autenticaci\00F3n de la galer\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99676686926304275)
,p_name=>'F4000_P826_NEW'
,p_message_language=>'es'
,p_message_text=>'Nuevo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99713318660304303)
,p_name=>'F4000_P88_FLASHBACK_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('La funci\00F3n de deshacer de %0 utiliza una base de datos incorporada denominada "Consulta de Flashback", que le permite realizar consultas en los datos en un momento determinado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99713160520304303)
,p_name=>'F4000_P88_SELECT_TIME'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la hora a la que desea volver y, a continuaci\00F3n, haga clic en "Aplicar" para volver a escribir el origen en la p\00E1gina de edici\00F3n de regi\00F3n y cierre este cuadro de di\00E1logo.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99713548471304303)
,p_name=>'F4000_P88_UNDO_RETENTION'
,p_message_language=>'es'
,p_message_text=>unistr('Seg\00FAn el par\00E1metro de base de datos "UNDO_RETENTION", s\00F3lo puede deshacer los cambios que se han producido en las \00FAltimas %0 horas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99714030330304303)
,p_name=>'F4000_P92_CONFIRM_CREATE_STD_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('Confirmar Creaci\00F3n de Separador Est\00E1ndar en Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99714491774304304)
,p_name=>'F4000_P92_NEW_TABSET_WILL_BE_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1 un nuevo juego de separadores %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99714396412304303)
,p_name=>'F4000_P92_PAGE_WILL_USE_EXISTNG_TABSET'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina %0 utilizar\00E1 el juego de separadores existente "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99714185042304303)
,p_name=>'F4000_P92_TABSET_INFO_INCOMPLETE'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: La informaci\00F3n del juego de separadores est\00E1 incompleta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100155892923304682)
,p_name=>'F4000_P975_VALUE_FOR'
,p_message_language=>'es'
,p_message_text=>'Valor para %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99937944960304477)
,p_name=>'F4000_PREV'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99926272825304468)
,p_name=>'F4000_QUICK_APP_FINISH'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic en <strong>Terminar</strong> para crear o ampliar la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99926045331304468)
,p_name=>'F4000_QUICK_APP_OPT_DISP1'
,p_message_language=>'es'
,p_message_text=>unistr('Incluir ayudas de navegaci\00F3n de ruta de navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99926145029304468)
,p_name=>'F4000_QUICK_APP_OPT_DISP2'
,p_message_language=>'es'
,p_message_text=>unistr('Ocultar clave primaria en p\00E1gina de informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100071717664304579)
,p_name=>'F4000_SHORTCUT'
,p_message_language=>'es'
,p_message_text=>'Acceso Directo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99832321451304389)
,p_name=>'F4000_SVG_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico SVG')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99937640045304477)
,p_name=>'F4000_TOP'
,p_message_language=>'es'
,p_message_text=>'Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100037301424304553)
,p_name=>'F4000_TREE'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100152734602304680)
,p_name=>'F4000_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99589664018304212)
,p_name=>'F4000_WS_ENTIRE_RESPONSE_DOC'
,p_message_language=>'es'
,p_message_text=>'Documento de Respuesta Completo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99599675069304219)
,p_name=>'F400_P107_STEP'
,p_message_language=>'es'
,p_message_text=>'Paso %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99570374892304197)
,p_name=>'F4050.ACCEPTED'
,p_message_language=>'es'
,p_message_text=>'DELETE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100154000521304681)
,p_name=>'F4050.ACCEPTED_MSG'
,p_message_language=>'es'
,p_message_text=>'Aceptado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100024030504304543)
,p_name=>'F4050.ACTION_ASSIGN'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema se asignar\00E1 al espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100024161651304543)
,p_name=>'F4050.ACTION_NO_ASSIGN'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema no se asignar\00E1 al espacio de trabajo por los siguientes motivos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100023672432304542)
,p_name=>'F4050.ADDITIONAL_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'Esquema Adicional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99918884304304463)
,p_name=>'F4050.ADJUST'
,p_message_language=>'es'
,p_message_text=>'Ajustar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99918128575304462)
,p_name=>'F4050.ALL'
,p_message_language=>'es'
,p_message_text=>'Todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100153523185304681)
,p_name=>'F4050.APPROVED'
,p_message_language=>'es'
,p_message_text=>'Aprobado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99574127498304200)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_DISPLAY'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha aprobado la solicitud de un espacio de trabajo y las credenciales enviadas a la direcci\00F3n de correo electr\00F3nico que ha especificado durante el registro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99992227455304519)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'es'
,p_message_text=>'Se ha aprobado su solicitud de cuenta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99992164033304519)
,p_name=>'F4050.APPROVED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'es'
,p_message_text=>'Aprobada: Solicitud de cuenta para %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99992657570304519)
,p_name=>'F4050.APPROVE_ADD_STORAGE_EMAIL'
,p_message_language=>'es'
,p_message_text=>'Se ha aprobado su solicitud de %0 MB adicionales de almacenamiento en el espacio de trabajo %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100153280162304680)
,p_name=>'F4050.ASSIGNED'
,p_message_language=>'es'
,p_message_text=>'Asignado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100664520488305063)
,p_name=>'F4050.AUTOMATIC'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100153164885304680)
,p_name=>'F4050.AVAILABLE'
,p_message_language=>'es'
,p_message_text=>'Disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100744790439305127)
,p_name=>'F4050.BROKEN'
,p_message_language=>'es'
,p_message_text=>'Interrumpido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100745151196305127)
,p_name=>'F4050.CHAIN_STALLED'
,p_message_language=>'es'
,p_message_text=>'Cadena detenida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99993099906304519)
,p_name=>'F4050.CHANGE_APPROVED_EMAIL'
,p_message_language=>'es'
,p_message_text=>'Solicitud de cambio aprobada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99993140890304519)
,p_name=>'F4050.CHANGE_DENIED_EMAIL'
,p_message_language=>'es'
,p_message_text=>'Solicitud de cambio denegada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100744668728305127)
,p_name=>'F4050.COMPLETED'
,p_message_language=>'es'
,p_message_text=>'Terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100023787122304542)
,p_name=>'F4050.CREATE_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1 el esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100153661472304681)
,p_name=>'F4050.DECLINED'
,p_message_language=>'es'
,p_message_text=>'Rechazado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99992573331304519)
,p_name=>'F4050.DECLINED_ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'es'
,p_message_text=>'Rechazada: Solicitud de cuenta para %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99992962710304519)
,p_name=>'F4050.DENY_ADD_STORAGE_EMAIL'
,p_message_language=>'es'
,p_message_text=>'Se ha denegado su solicitud de %0 MB adicionales de almacenamiento en el espacio de trabajo %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99992789246304519)
,p_name=>'F4050.DENY_NEW_SCHEMA_EMAIL'
,p_message_language=>'es'
,p_message_text=>'Se ha denegado su solicitud del esquema de base de datos %0 en el espacio de trabajo %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99992860162304519)
,p_name=>'F4050.DENY_REMOVE_SERVICE_EMAIL'
,p_message_language=>'es'
,p_message_text=>'Se ha denegado su solicitud para terminar el servicio en el espacio de trabajo %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100744364760305127)
,p_name=>'F4050.DISABLED'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99570246484304197)
,p_name=>'F4050.EMAIL_CLICK_ON_LINK'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Haga clic en el enlace siguiente para terminar el proceso de aprobaci\00F3n. Una vez terminado, recibir\00E1 las credenciales de espacio de trabajo en un correo electr\00F3nico de seguimiento.'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99992464807304519)
,p_name=>'F4050.EMAIL_GETSTARTED'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Haga clic en el enlace que aparece a continuaci\00F3n para empezar.'),
'',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100744849644305127)
,p_name=>'F4050.FAILED'
,p_message_language=>'es'
,p_message_text=>'Con Fallos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99597921971304218)
,p_name=>'F4050.HTML_EMAIL_CLICK_ON_LINK'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic <a href=''%0''>aqu\00ED</a> para terminar el proceso de aprobaci\00F3n y recibir las credenciales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99908474207304454)
,p_name=>'F4050.INFORMATION'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99919684420304463)
,p_name=>'F4050.INSTALL'
,p_message_language=>'es'
,p_message_text=>'Instalar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100153740665304681)
,p_name=>'F4050.IN_PROGRESS'
,p_message_language=>'es'
,p_message_text=>'En Curso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99918452873304462)
,p_name=>'F4050.NO_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99936526919304476)
,p_name=>'F4050.P23.USE'
,p_message_language=>'es'
,p_message_text=>'Uso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100747828137305129)
,p_name=>'F4050.P3.UPDATE_CHECK_DISABLED'
,p_message_language=>'es'
,p_message_text=>unistr('Comprobaci\00F3n de Actualizaci\00F3n desactivada para toda la instancia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99936667581304476)
,p_name=>'F4050.P39_OPEN'
,p_message_language=>'es'
,p_message_text=>'Abrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100023518105304542)
,p_name=>'F4050.PRIMARY_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'Esquema Primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99918703497304462)
,p_name=>'F4050.PROVISION'
,p_message_language=>'es'
,p_message_text=>unistr('Provisi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99991969753304518)
,p_name=>'F4050.PROV_CHANGE_REQ_APPROVED'
,p_message_language=>'es'
,p_message_text=>'Solicitud de cambio aprobada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99991841813304518)
,p_name=>'F4050.PROV_SCHEMA_REQ_APPROVED'
,p_message_language=>'es'
,p_message_text=>'Se ha aprobado su solicitud para el esquema de base de datos %0 en el espacio de trabajo %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100744942095305127)
,p_name=>'F4050.REMOTE'
,p_message_language=>'es'
,p_message_text=>'Remoto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100153806400304681)
,p_name=>'F4050.REQUESTED'
,p_message_language=>'es'
,p_message_text=>'Solicitado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99917938922304462)
,p_name=>'F4050.RESET'
,p_message_language=>'es'
,p_message_text=>'Restablecer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99992080136304518)
,p_name=>'F4050.RESTRICTED_ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: El esquema solicitado est\00E1 restringido porque es un esquema por defecto de Oracle o debido a las pol\00EDticas espec\00EDficas de la ubicaci\00F3n. Los esquemas restringidos no se pueden asignar a los espacios de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100744454229305127)
,p_name=>'F4050.RETRY SCHEDULED'
,p_message_language=>'es'
,p_message_text=>'Nuevo intento programado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100023909832304543)
,p_name=>'F4050.REUSE_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('Se volver\00E1 a utilizar el esquema existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100744514129305127)
,p_name=>'F4050.RUNNING'
,p_message_language=>'es'
,p_message_text=>unistr('En ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100744226174305127)
,p_name=>'F4050.SCHEDULED'
,p_message_language=>'es'
,p_message_text=>'Programado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99991677466304518)
,p_name=>'F4050.SCHEMA_ASSIGNED'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: El esquema solicitado ya se ha asignado a uno o m\00E1s espacios de trabajo. Antes de aprobar esta solicitud, aseg\00FArese de que las pol\00EDticas de seguridad de su ubicaci\00F3n permiten proporcionar el acceso a varios espacios de trabajo en el mism')
||'o esquema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99991553753304518)
,p_name=>'F4050.SCHEMA_EXISTS'
,p_message_language=>'es'
,p_message_text=>'Advertencia: El esquema solicitado ya existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100024264762304543)
,p_name=>'F4050.SCHEMA_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>'El esquema no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100024432195304543)
,p_name=>'F4050.SCHEMA_RESERVED_NO_WARN'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema est\00E1 reservado y puede que no se asigne a espacios de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99991702633304518)
,p_name=>'F4050.SCHEMA_RESTRICTED'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: El esquema solicitado est\00E1 restringido porque es un esquema por defecto de Oracle o debido a las pol\00EDticas espec\00EDficas de la ubicaci\00F3n. Si contin\00FAa y asigna este esquema al espacio de trabajo, proporcionar\00E1 a los desarrolladores de dicho')
||unistr(' espacio de trabajo acceso completo al esquema. Antes de aprobar esta solicitud, aseg\00FArese de que esta acci\00F3n es consistente con las pol\00EDticas de seguridad de su ubicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100024350019304543)
,p_name=>'F4050.SCHEMA_RESTRICTED_NO_WARN'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema est\00E1 restringido por las pol\00EDticas de seguridad. Los esquemas restringidos no se pueden asignar a los espacios de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99993282566304519)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL'
,p_message_language=>'es'
,p_message_text=>'Servicio terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99993380401304520)
,p_name=>'F4050.SERVICE_TERMINATED_EMAIL_BODY'
,p_message_language=>'es'
,p_message_text=>'Se ha terminado el servicio de desarrollo "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100745043030305127)
,p_name=>'F4050.SUCCEEDED'
,p_message_language=>'es'
,p_message_text=>'Correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100153311407304681)
,p_name=>'F4050.SUSPENDED'
,p_message_language=>'es'
,p_message_text=>'Suspendido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100153467257304681)
,p_name=>'F4050.TERMINATE'
,p_message_language=>'es'
,p_message_text=>'Terminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100153982510304681)
,p_name=>'F4050.TERMINATED'
,p_message_language=>'es'
,p_message_text=>'Terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100744180759305126)
,p_name=>'F4050.TERMINATION_IN_PROGRESS'
,p_message_language=>'es'
,p_message_text=>unistr('Terminaci\00F3n en Curso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99919082803304463)
,p_name=>'F4050.VIEW_REQUEST'
,p_message_language=>'es'
,p_message_text=>'Ver Solicitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99919431141304463)
,p_name=>'F4050.WORKSPACE_EXPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Exportaci\00F3n de Espacio de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99685414104304282)
,p_name=>'F4050.WORKSPACE_HOME'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Inicial de Espacio de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99685579967304282)
,p_name=>'F4050.WORKSPACE_LOGIN'
,p_message_language=>'es'
,p_message_text=>unistr('Conexi\00F3n al Espacio de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99989217159304516)
,p_name=>'F4050.WSID_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('No se crear\00E1 el espacio de trabajo porque ya existe un espacio de trabajo con el mismo identificador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99989175182304516)
,p_name=>'F4050.WSNAME_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('No se crear\00E1 el espacio de trabajo porque ya existe un espacio de trabajo con el mismo nombre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99762020725304338)
,p_name=>'F4050.WS_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha creado el espacio de trabajo %0 en %1 y se ha enviado una confirmaci\00F3n a la direcci\00F3n de correo electr\00F3nico que ha proporcionado durante el registro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99591214652304213)
,p_name=>'F4050.WS_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('No se crear\00E1 el espacio de trabajo porque ya existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99591350318304213)
,p_name=>'F4050.WS_TOBE_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1 el espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99826496050304385)
,p_name=>'F4050_EMAIL_BODY_NEW_PASSWORD'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a Nueva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99826354922304385)
,p_name=>'F4050_EMAIL_BODY_PASSWORD_CHANGED'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a de la cuenta se ha cambiado para el usuario %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99826224509304385)
,p_name=>'F4050_EMAIL_SUBJECT_PASSWORD_CHANGED'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a se ha cambiado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100709344679305100)
,p_name=>'F4050_P158_INTRO_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina controla si se cambiar\00E1 la versi\00F3n de %0 inmediatamente cuando la pr\00F3xima versi\00F3n est\00E9 disponible o si el cambio de versi\00F3n se diferir\00E1 hasta %1 d\00EDas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100709423410305100)
,p_name=>'F4050_P158_UPGRADE_NOW'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic en Cambiar de versi\00F3n ahora para iniciar el proceso de cambio de versi\00F3n en este momento en lugar del %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100709054313305100)
,p_name=>'F4050_P3_SYSTEM_UP_TO_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('El sistema est\00E1 actualizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100709133247305100)
,p_name=>'F4050_P3_UPGRADE_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 %1 est\00E1 <a href="%2" target="_blank" rel="noreferrer">disponible</a>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100708132553305099)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_N'
,p_message_language=>'es'
,p_message_text=>unistr('Una vez que est\00E9 disponible una nueva versi\00F3n de %0, el cambio de versi\00F3n de la instancia se realizar\00E1 <strong>inmediatamente</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100708881655305100)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_P'
,p_message_language=>'es'
,p_message_text=>unistr('La instancia se cambiar\00E1 de versi\00F3n autom\00E1ticamente el <strong>%0</strong>. Haga clic en el icono de engranaje para realizar el cambio de versi\00F3n ahora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100708021013305099)
,p_name=>'F4050_P3_UPGRADE_DEFERRED_Y'
,p_message_language=>'es'
,p_message_text=>unistr('%0 cambios de versi\00F3n de la instancia est\00E1n <strong>diferidos</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100250061640304754)
,p_name=>'F4050_P3_UPGRADING'
,p_message_language=>'es'
,p_message_text=>unistr('%0 se est\00E1 actualizando actualmente a %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99578168957304203)
,p_name=>'F4050_P74_PROVISION'
,p_message_language=>'es'
,p_message_text=>'El usuario de base de datos %0 se ha creado con el tablespace por defecto %1 con el archivo de datos %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99594907252304215)
,p_name=>'F4050_P74_PROVISION1'
,p_message_language=>'es'
,p_message_text=>'El espacio de trabajo %0 proporcionado con el administrador %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99726736349304313)
,p_name=>'F4050_SHOW_ALL_WORKSPACES'
,p_message_language=>'es'
,p_message_text=>'Mostrar Todos los Espacios de Trabajo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99718078297304306)
,p_name=>'F4300.COL_LENGTH_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'La longitud de columna no puede ser nula.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99717919986304306)
,p_name=>'F4300.COL_LENGTH_NOT_ZERO'
,p_message_language=>'es'
,p_message_text=>'La longitud de columna no puede ser cero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99718230212304306)
,p_name=>'F4300.COL_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'es'
,p_message_text=>unistr('Los nombres de columna no pueden tener m\00E1s de %0 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99718376813304306)
,p_name=>'F4300.COL_NAMES_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'Los nombres de columna no pueden ser nulos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99718881749304307)
,p_name=>'F4300.F4500.NAME_ALREADY_USED'
,p_message_language=>'es'
,p_message_text=>unistr('<strong>%0</strong> ya lo est\00E1 utilizando un objeto existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99719032275304307)
,p_name=>'F4300.F4500.NOT_VALID_SEQ_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('<strong>%0</strong> no es un nombre de secuencia v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99717677733304306)
,p_name=>'F4300.F4500.TABLE_ALREADY_EXISTS'
,p_message_language=>'es'
,p_message_text=>'El nombre de tabla ya existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99718610683304307)
,p_name=>'F4300.NOT_VALID_PK_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('<strong>%0</strong> no es un nombre de clave primaria v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99936731582304476)
,p_name=>'F4300.P180_FILE_FORMAT'
,p_message_language=>'es'
,p_message_text=>'DOS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99907759833304454)
,p_name=>'F4300.SPREADSHEET_IMPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Importaci\00F3n de Hoja de C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99718592661304307)
,p_name=>'F4300.TABLE_NAMES_NOT_LONGER_THAN_30'
,p_message_language=>'es'
,p_message_text=>'Los nombres de tabla deben tener menos de %0 caracteres.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99729294496304314)
,p_name=>'F4300_INSTRUCT_TEXT'
,p_message_language=>'es'
,p_message_text=>'La primera fila contiene nombres de columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100055040491304566)
,p_name=>'F4300_TEXT_IMPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Importaci\00F3n de Texto')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99755056666304333)
,p_name=>'F4350.APPLICATION_OWNER'
,p_message_language=>'es'
,p_message_text=>unistr('Propietario de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99917754404304462)
,p_name=>'F4350.AVAILABLE'
,p_message_language=>'es'
,p_message_text=>'(disponible)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99917547166304461)
,p_name=>'F4350.CHANGE'
,p_message_language=>'es'
,p_message_text=>'Cambiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100092665529304595)
,p_name=>'F4350.CONFIRM_SCHEMA_EXISTING'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1 solicitando asignar el esquema existente %0 a su espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100092762733304596)
,p_name=>'F4350.CONFIRM_SCHEMA_NEW'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1 solicitando crear el esquema %0 y asignarlo a su espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99917251143304461)
,p_name=>'F4350.CREATE'
,p_message_language=>'es'
,p_message_text=>'Crear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99761177980304338)
,p_name=>'F4350.CREATING_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Creando Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99917629319304462)
,p_name=>'F4350.CURRENT'
,p_message_language=>'es'
,p_message_text=>'(actual)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99755556660304333)
,p_name=>'F4350.CURRENT_TIME_ON_SERVER'
,p_message_language=>'es'
,p_message_text=>'Hora Actual (en el servidor)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99755313649304333)
,p_name=>'F4350.CURRENT_USER'
,p_message_language=>'es'
,p_message_text=>'Usuario Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99917493353304461)
,p_name=>'F4350.DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99762256946304338)
,p_name=>'F4350.DISABLE.WORK.PROV'
,p_message_language=>'es'
,p_message_text=>unistr('La creaci\00F3n del espacio de trabajo se ha desactivado temporalmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99754930604304333)
,p_name=>'F4350.HOST_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'Esquema del Host'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99916901558304461)
,p_name=>'F4350.INSERTED'
,p_message_language=>'es'
,p_message_text=>'Insertado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99755473614304333)
,p_name=>'F4350.LANGUAGE_PREFERENCE'
,p_message_language=>'es'
,p_message_text=>'Preferencia de Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99754819330304333)
,p_name=>'F4350.LAST_DDL_TIME'
,p_message_language=>'es'
,p_message_text=>unistr('Hora de \00DAltimo DDL:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100238683282304744)
,p_name=>'F4350.LAST_PATCH_TIME'
,p_message_language=>'es'
,p_message_text=>unistr('Hora del \00FAltimo parche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99561778189304191)
,p_name=>'F4350.MORE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 m\00E1s...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100238572300304744)
,p_name=>'F4350.PATCH_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n del Parche')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99754672276304333)
,p_name=>'F4350.PRODUCT_BUILD'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n Interna del Producto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100286496779304781)
,p_name=>'F4350.RESET'
,p_message_language=>'es'
,p_message_text=>'Restablecer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99754764162304333)
,p_name=>'F4350.SCHEMA_COMPATIBILITY'
,p_message_language=>'es'
,p_message_text=>'Compatibilidad de Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99561679496304191)
,p_name=>'F4350.TRANSLATED_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'(+%0 aplicaciones traducidas)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99917147778304461)
,p_name=>'F4350.UNKNOWN'
,p_message_language=>'es'
,p_message_text=>'Desconocido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99917068857304461)
,p_name=>'F4350.UPDATED'
,p_message_language=>'es'
,p_message_text=>'Actualizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99755116146304333)
,p_name=>'F4350.WORKSPACE_ID'
,p_message_language=>'es'
,p_message_text=>'Identificador de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99755291159304333)
,p_name=>'F4350.WORKSPACE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100463329382304913)
,p_name=>'F4350_AJAX'
,p_message_language=>'es'
,p_message_text=>'AJAX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100463226405304913)
,p_name=>'F4350_AUTHENTICATION_CALLBACK'
,p_message_language=>'es'
,p_message_text=>unistr('Devoluci\00F3n de Llamada de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99918648527304462)
,p_name=>'F4350_CLICKTHRU_LOG_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas de Log de Clics de Paso:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99918598938304462)
,p_name=>'F4350_DEV_LOG_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas de Log de Actividades del Desarrollador:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99919197776304463)
,p_name=>'F4350_DISTINCT_USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios distintos en todas las sesiones = %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99919596525304463)
,p_name=>'F4350_NO_USER_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('no se ha seleccionado ning\00FAn usuario')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99919834922304463)
,p_name=>'F4350_PREFS_EXISTS_FOR'
,p_message_language=>'es'
,p_message_text=>'Existen %0 preferencias para %1 usuarios en el espacio de trabajo "%2"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99536012758304168)
,p_name=>'F4350_PREFS_EXISTS_FOR2'
,p_message_language=>'es'
,p_message_text=>'Existen %0 preferencias para %1 usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99918309427304462)
,p_name=>'F4350_RESET_PREFS'
,p_message_language=>'es'
,p_message_text=>unistr('Restablezca sus preferencias si desea ejecutar la aplicaci\00F3n sin ning\00FAn valor predefinido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99593017456304214)
,p_name=>'F4350_RESET_SESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Restablezca el estado de la sesi\00F3n si desea ejecutar la aplicaci\00F3n sin ning\00FAn valor predefinido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99919973068304463)
,p_name=>'F4350_SELECTED_USER'
,p_message_language=>'es'
,p_message_text=>'Usuario Seleccionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99919277393304463)
,p_name=>'F4350_SESSIONS_OLDER_THAN'
,p_message_language=>'es'
,p_message_text=>unistr('Sesiones anteriores a %0 d\00EDas = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99919376364304463)
,p_name=>'F4350_SESSIONS_OLDER_THAN_MINS'
,p_message_language=>'es'
,p_message_text=>unistr('Sesiones con una duraci\00F3n de m\00E1s de %0 minutos = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99917883983304462)
,p_name=>'F4350_SESSION_STATE'
,p_message_language=>'es'
,p_message_text=>unistr('La sesi\00F3n est\00E1 identificada por %0 y contiene %1 entradas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99920527458304464)
,p_name=>'F4350_SQL'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99919753655304463)
,p_name=>'F4350_SUMMARY'
,p_message_language=>'es'
,p_message_text=>'Resumen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99918930046304463)
,p_name=>'F4350_TOTAL_SESSIONS'
,p_message_language=>'es'
,p_message_text=>'El total de sesiones para el espacio de trabajo "%0" es %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99535983193304168)
,p_name=>'F4350_TOTAL_SESSIONS2'
,p_message_language=>'es'
,p_message_text=>'Sesiones Totales: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99920008747304463)
,p_name=>'F4350_USER_HAS_X_PREFS'
,p_message_language=>'es'
,p_message_text=>'El usuario %0 tiene %1 preferencias.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99918205174304462)
,p_name=>'F4350_USER_PREFS'
,p_message_language=>'es'
,p_message_text=>'El usuario actual %0 tiene definidas %1 preferencias.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99920139284304464)
,p_name=>'F4350_WORKSPACE_SCHEMAS'
,p_message_language=>'es'
,p_message_text=>'Esquemas de Espacio de Trabajo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99922676254304465)
,p_name=>'F4500.DISPLAY_SEQ_IN_FORM_NUMERIC'
,p_message_language=>'es'
,p_message_text=>unistr('La secuencia de visualizaci\00F3n en las pantallas debe ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99922700946304465)
,p_name=>'F4500.DISPLAY_SEQ_IN_REPORT_NUMERIC'
,p_message_language=>'es'
,p_message_text=>unistr('La secuencia de visualizaci\00F3n en los informes debe ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99726171163304312)
,p_name=>'F4500.DUP_ARG_NAMES'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre del argumento <strong>%0</strong> se utiliza m\00E1s de una vez en esta funci\00F3n.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99925735752304468)
,p_name=>'F4500.EXECUTION_ORDER_MAND'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar el orden de ejecuci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99925634159304468)
,p_name=>'F4500.EXECUTION_ORDER_NUMERIC'
,p_message_language=>'es'
,p_message_text=>unistr('El orden de ejecuci\00F3n debe ser num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99908558663304454)
,p_name=>'F4500.FIND'
,p_message_language=>'es'
,p_message_text=>'Buscar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99936956229304476)
,p_name=>'F4500.HIDE_SQL'
,p_message_language=>'es'
,p_message_text=>'Ocultar SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99908933468304455)
,p_name=>'F4500.MAGNIFY'
,p_message_language=>'es'
,p_message_text=>'Ampliar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99908830425304455)
,p_name=>'F4500.MOVE_COLUMN_DOWN'
,p_message_language=>'es'
,p_message_text=>'Mover Columna hacia Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99908790696304455)
,p_name=>'F4500.MOVE_COLUMN_UP'
,p_message_language=>'es'
,p_message_text=>'Mover Columna hacia Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99719844231304308)
,p_name=>'F4500.NEED_UNIQUE_EXECUTION_ORDER'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un n\00FAmero de orden de ejecuci\00F3n \00FAnico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99521049410304157)
,p_name=>'F4500.NEW_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Nuevas Columnas que Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99719409069304307)
,p_name=>'F4500.NOT_VALID_OBJECT_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('<strong>%0</strong> no es un nombre de objeto v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99719299315304307)
,p_name=>'F4500.NOT_VALID_TABLE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('<strong>%0</strong> no es un nombre de tabla v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99908613631304454)
,p_name=>'F4500.NO_IMAGE'
,p_message_language=>'es'
,p_message_text=>'Ninguna Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99909030173304455)
,p_name=>'F4500.NULLABLE'
,p_message_language=>'es'
,p_message_text=>'nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100022342976304541)
,p_name=>'F4500.P40.PREVIOUS.RUNS'
,p_message_language=>'es'
,p_message_text=>'Ejecuciones Anteriores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99725673782304312)
,p_name=>'F4500.P602.DUP_COL_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Los nombres de columna <strong>%0</strong> se utilizan m\00E1s de una vez en esta tabla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99726040371304312)
,p_name=>'F4500.P602.ENTER_AT_LEAST_ONE_COL'
,p_message_language=>'es'
,p_message_text=>'Debe introducir el nombre de al menos una columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99725937998304312)
,p_name=>'F4500.P602.INVALID_COL_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de columna <strong>%0</strong> no es v\00E1lido.<br />')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99725775969304312)
,p_name=>'F4500.P602.INVALID_PRECISION'
,p_message_language=>'es'
,p_message_text=>unistr('La precisi\00F3n para la columna <strong>%0</strong> no es v\00E1lida.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99725811836304312)
,p_name=>'F4500.P602.INVALID_SCALE'
,p_message_language=>'es'
,p_message_text=>unistr('La escala para la columna <strong>%0</strong> no es v\00E1lida.<br/>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99576157742304202)
,p_name=>'F4500.P602.SCALE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Se requiere la escala para la columna <strong>%0</strong>.<br/>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99937095682304476)
,p_name=>'F4500.P99.CREATE_SYNONYM_ON'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Sin\00F3nimo Basado en')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99936899433304476)
,p_name=>'F4500.SHOW_SQL'
,p_message_language=>'es'
,p_message_text=>'Mostrar SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99719530098304307)
,p_name=>'F4500.TABLE_NOT_FOUND_IN_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado la tabla <strong>%0</strong> en el esquema <strong>%1</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99525111402304160)
,p_name=>'F4500.WARNING_STATEMENTS'
,p_message_language=>'es'
,p_message_text=>'Sentencias de Advertencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99921714697304465)
,p_name=>'F4500_BROKEN'
,p_message_language=>'es'
,p_message_text=>'Interrumpido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99922206956304465)
,p_name=>'F4500_BYTES'
,p_message_language=>'es'
,p_message_text=>'Bytes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99922168327304465)
,p_name=>'F4500_CARD'
,p_message_language=>'es'
,p_message_text=>'Tarjeta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99921523398304465)
,p_name=>'F4500_CHECK'
,p_message_language=>'es'
,p_message_text=>'Comprobar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99914061387304459)
,p_name=>'F4500_CLICK_POP_QUERY'
,p_message_language=>'es'
,p_message_text=>'Haga clic para rellenar el campo de consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99922056285304465)
,p_name=>'F4500_COST'
,p_message_language=>'es'
,p_message_text=>'Costo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99913331914304458)
,p_name=>'F4500_CREATE_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La operaci\00F3n de creaci\00F3n se ha realizado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100691448794305087)
,p_name=>'F4500_DICTIONARY_OBJECTS_WO_DEFAULTS'
,p_message_language=>'es'
,p_message_text=>'Objetos sin valores por defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100691345886305087)
,p_name=>'F4500_DICTIONARY_OBJECTS_W_DEFAULTS'
,p_message_language=>'es'
,p_message_text=>'Objetos con valores por defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99912620121304458)
,p_name=>'F4500_DROP_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La operaci\00F3n de borrado se ha realizado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99565172285304193)
,p_name=>'F4500_FOREIGN'
,p_message_language=>'es'
,p_message_text=>'Ajena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99826634197304385)
,p_name=>'F4500_FOREIGN_KEY'
,p_message_language=>'es'
,p_message_text=>'Clave Ajena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99726433097304312)
,p_name=>'F4500_NATIVE'
,p_message_language=>'es'
,p_message_text=>'Formato de archivo nativo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99912366232304457)
,p_name=>'F4500_NOT_AVAIL_EDIT'
,p_message_language=>'es'
,p_message_text=>unistr('no est\00E1 disponible para la edici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99921805301304465)
,p_name=>'F4500_NOT_AVAIL_SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('no disponible para la b\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99921661808304465)
,p_name=>'F4500_OF'
,p_message_language=>'es'
,p_message_text=>'De'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99921996577304465)
,p_name=>'F4500_OPTIMIZER'
,p_message_language=>'es'
,p_message_text=>'Optimizador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99914303106304459)
,p_name=>'F4500_OP_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La operaci\00F3n se ha realizado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99902058598304449)
,p_name=>'F4500_P1000_NO_WS_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ning\00FAn mensaje de espacios de trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100054929928304566)
,p_name=>'F4500_P101_NO_VARCHAR'
,p_message_language=>'es'
,p_message_text=>'Los tipos de columna VARCHAR no existen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99599387699304219)
,p_name=>'F4500_P1023_PARSING'
,p_message_language=>'es'
,p_message_text=>'Analizando script, espere.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99546046412304179)
,p_name=>'F4500_P10_NUM_STMTS'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Sentencias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99787806101304357)
,p_name=>'F4500_P10_ON_BY'
,p_message_language=>'es'
,p_message_text=>'en %0 por %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99909721483304455)
,p_name=>'F4500_P10_PARAMETERS'
,p_message_language=>'es'
,p_message_text=>unistr('Si tiene par\00E1metros en el script, def\00EDnalos antes de realizar la ejecuci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99545996352304179)
,p_name=>'F4500_P10_SCRIPT_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Script'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99787768574304357)
,p_name=>'F4500_P10_SCRIPT_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o del Script en Bytes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99784090547304354)
,p_name=>'F4500_P10_UPDATED_BY'
,p_message_language=>'es'
,p_message_text=>'Actualizado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99909909617304456)
,p_name=>'F4500_P10_VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100068652006304577)
,p_name=>'F4500_P115.CONFIRM'
,p_message_language=>'es'
,p_message_text=>'Ha solicitado importar los siguientes archivos de comandos. Confirme la solicitud.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100068727763304577)
,p_name=>'F4500_P115.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Los archivos de comandos que ha solicitado para importar exceden el almacenamiento m\00E1ximo permitido. P\00F3ngase en contacto con el administrador %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100069701655304578)
,p_name=>'F4500_P115.SCRIPTS_TO_INSTALL'
,p_message_language=>'es'
,p_message_text=>'Script a Importar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99910466991304456)
,p_name=>'F4500_P11_NO_ERROR'
,p_message_language=>'es'
,p_message_text=>'No Hay Errores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99910236438304456)
,p_name=>'F4500_P11_NUM'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99890170139304440)
,p_name=>'F4500_P1224_VIEW_OUTPUT'
,p_message_language=>'es'
,p_message_text=>'Ver Salida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99971017820304502)
,p_name=>'F4500_P129_BROWSE_SEQ'
,p_message_language=>'es'
,p_message_text=>'Examinar Secuencias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99971100381304503)
,p_name=>'F4500_P129_NO_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La operaci\00F3n de creaci\00F3n de secuencia no se ha realizado correctamente por el siguiente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99970972992304502)
,p_name=>'F4500_P129_SEQUENCE_CREATED'
,p_message_language=>'es'
,p_message_text=>'Se ha creado la secuencia "%0" en el esquema "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99910669009304456)
,p_name=>'F4500_P12_STATEMENT'
,p_message_language=>'es'
,p_message_text=>'Sentencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99971493918304503)
,p_name=>'F4500_P130_BROWSE_DB_SYN'
,p_message_language=>'es'
,p_message_text=>unistr('Examinar Sin\00F3nimos de Base de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99971648445304503)
,p_name=>'F4500_P130_CREATE_NOT_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La operaci\00F3n de creaci\00F3n de sin\00F3nimo no se ha realizado correctamente por el siguiente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99971399909304503)
,p_name=>'F4500_P130_SYNONYM_CREATE_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha creado el sin\00F3nimo "%0" en el esquema "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99971766179304503)
,p_name=>'F4500_P132_CREATE_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('La operaci\00F3n de creaci\00F3n de paquete no se ha realizado correctamente por el siguiente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99971884194304503)
,p_name=>'F4500_P132_PACKAGE_CREATED'
,p_message_language=>'es'
,p_message_text=>'Se ha creado el paquete "%0" en el esquema"%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99753465241304332)
,p_name=>'F4500_P24_SAVE_TO_WORKSHEET'
,p_message_language=>'es'
,p_message_text=>'Guardar en Hoja de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99910941411304456)
,p_name=>'F4500_P25_BY'
,p_message_language=>'es'
,p_message_text=>'Por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99910875766304456)
,p_name=>'F4500_P25_CREATED'
,p_message_language=>'es'
,p_message_text=>'Creado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99910738153304456)
,p_name=>'F4500_P25_FILE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99566852632304195)
,p_name=>'F4500_P2610_EXPIRED'
,p_message_language=>'es'
,p_message_text=>'Vencido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99566969562304195)
,p_name=>'F4500_P2610_EXPIRED_AND_LOCKED'
,p_message_language=>'es'
,p_message_text=>'Vencido y Bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99566734875304195)
,p_name=>'F4500_P2610_LOCKED'
,p_message_language=>'es'
,p_message_text=>'Bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99566612251304195)
,p_name=>'F4500_P2610_OPEN'
,p_message_language=>'es'
,p_message_text=>'Abrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99970862427304502)
,p_name=>'F4500_P402_OPERATION_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('La operaci\00F3n no se ha realizado correctamente por el siguiente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99947977816304485)
,p_name=>'F4500_P51_NOT_AVAIL_INSERT'
,p_message_language=>'es'
,p_message_text=>'no disponible para insertar datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99970745042304502)
,p_name=>'F4500_P54_BROWSE_VIEW'
,p_message_language=>'es'
,p_message_text=>'Examinar Vista de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99970438024304502)
,p_name=>'F4500_P54_NOT_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La operaci\00F3n de creaci\00F3n de vista no se ha realizado correctamente por el siguiente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99970578159304502)
,p_name=>'F4500_P54_SQL_WORKSHOP_HOME'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Inicial de Taller de SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99970663686304502)
,p_name=>'F4500_P54_VIEW_CREATED'
,p_message_language=>'es'
,p_message_text=>'Se ha creado la vista "%0" en el esquema "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99939285001304478)
,p_name=>'F4500_P553_GET_COLUMN_COMMENT'
,p_message_language=>'es'
,p_message_text=>'Obtener Comentario de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100096867510304599)
,p_name=>'F4500_P602_IDENTITY'
,p_message_language=>'es'
,p_message_text=>'Identidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99597854707304218)
,p_name=>'F4500_P602_NO_DATATYPE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha especificado ning\00FAn tipo de dato para %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99912421476304457)
,p_name=>'F4500_P68_TABLE_OP_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La operaci\00F3n de tabla se ha realizado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99909528901304455)
,p_name=>'F4500_P6_STATEMENT_CNT'
,p_message_language=>'es'
,p_message_text=>'Este archivo tiene %0 sentencias.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99909623434304455)
,p_name=>'F4500_P6_USER_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario ha definido los siguientes %0 par\00E1metros:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99726657508304312)
,p_name=>'F4500_PARSE'
,p_message_language=>'es'
,p_message_text=>'Analizar este script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99921333447304464)
,p_name=>'F4500_PRIMARY'
,p_message_language=>'es'
,p_message_text=>'Primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99530284002304164)
,p_name=>'F4500_REFERENTIAL'
,p_message_language=>'es'
,p_message_text=>'Referencial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99726509060304312)
,p_name=>'F4500_TEXT_FILE_FORMAT'
,p_message_language=>'es'
,p_message_text=>'Ver documento como texto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99921412080304464)
,p_name=>'F4500_UNIQUE'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAnico')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100770826197305146)
,p_name=>'F4550.STATIC_FILES_NOT_CONFIGURED'
,p_message_language=>'es'
,p_message_text=>unistr('Se han producido algunos problemas con la configuraci\00F3n de los archivos est\00E1ticos en su entorno. Consulte la secci\00F3n "Configuraci\00F3n del Soporte de Archivos Est\00E1ticos" en la Gu\00EDa de instalaci\00F3n de Application Express.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100114236241304612)
,p_name=>'F4550.WELCOME_TO_APEX_ADB'
,p_message_language=>'es'
,p_message_text=>unistr('Le damos la bienvenida a Oracle APEX. Para iniciar sesi\00F3n, utilice la contrase\00F1a de administrador (ADMIN) de la base de datos aut\00F3noma.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100766964744305143)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_BODY'
,p_message_language=>'es'
,p_message_text=>unistr('Ha recibido este correo electr\00F3nico porque ha solicitado un espacio de trabajo de Oracle APEX.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100766834144305143)
,p_name=>'F4700.ACCOUNT_REQ_EMAIL_SUBJ'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n necesaria: solicitud de cuenta para %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99990568236304517)
,p_name=>'F4700.EMAIL_NOTE'
,p_message_language=>'es'
,p_message_text=>unistr('(se utiliza para enviarle las credenciales por correo electr\00F3nico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99990752221304518)
,p_name=>'F4700.EXISTING_SCHEMA_HINT'
,p_message_language=>'es'
,p_message_text=>'Introduzca un esquema de base de datos que ya exista en la base de datos Oracle. Por motivos de seguridad no se proporciona una lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99990642264304517)
,p_name=>'F4700.NEW_SCHEMA_HINT'
,p_message_language=>'es'
,p_message_text=>'Introduzca el nombre del esquema de base de datos Oracle que desea crear para su espacio de trabajo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99989978152304517)
,p_name=>'F4700.P26_JUSTIFY_RESTRICTED_SCHEMA'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('En la siguiente descripci\00F3n, explique por qu\00E9 solicita un esquema restringido.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99990065450304517)
,p_name=>'F4700.P26_JUSTIFY_SHARED_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('En la siguiente descripci\00F3n, explique por qu\00E9 solicita un esquema que ya est\00E1 siendo utilizado por uno o m\00E1s espacios de trabajo diferentes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99990433597304517)
,p_name=>'F4700.P26_WARN_RESTRICTED_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: El esquema que solicita est\00E1 restringido por motivos de seguridad. El administrador de %0 puede denegar la solicitud de asignaci\00F3n de este esquema a su espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99990326022304517)
,p_name=>'F4700.P26_WARN_SHARED_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: Otros espacios de trabajo est\00E1n utilizando ya el esquema que solicita. El administrador de %0 puede denegar la solicitud de asignaci\00F3n de este esquema a su espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99987388902304515)
,p_name=>'F4700.SCHEMA_RESTRICTED'
,p_message_language=>'es'
,p_message_text=>unistr('El nuevo esquema solicitado para el espacio de trabajo es un esquema por defecto de Oracle o se puede limitar de forma espec\00EDfica en la ubicaci\00F3n por motivos de seguridad y puede que no sea apto para su asignaci\00F3n a un espacio de trabajo. El administ')
||unistr('rador de ubicaci\00F3n puede rechazar la solicitud de provisionamiento si \00E9sta viola la pol\00EDtica de seguridad de la ubicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99987232388304515)
,p_name=>'F4700.SCHEMA_USED_BY_WORKSPACES'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema que ha solicitado para el espacio de trabajo ya se ha asignado a los espacios de trabajo %0. El administrador de ubicaci\00F3n puede rechazar la solicitud de provisionamiento si \00E9sta viola la pol\00EDtica de seguridad de la ubicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99562547077304191)
,p_name=>'F4700P1_A'
,p_message_language=>'es'
,p_message_text=>'Oracle APEX proporciona acceso a una base de datos Oracle y a herramientas de desarrollo basadas en el explorador.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99562614009304191)
,p_name=>'F4700P1_B'
,p_message_language=>'es'
,p_message_text=>'Crear aplicaciones web de forma declarativa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99562791785304192)
,p_name=>'F4700P1_C'
,p_message_language=>'es'
,p_message_text=>'Crear y gestionar objetos de base de datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99562831503304192)
,p_name=>'F4700P1_D'
,p_message_language=>'es'
,p_message_text=>'Realizar el seguimiento de hitos, bugs, funciones y tareas<'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100701322269305094)
,p_name=>'F4750.P209.DB_APP_USER_SETUP'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n se ha instalado correctamente. Sin embargo, para ejecutar la aplicaci\00F3n mediante la autenticaci\00F3n de cuenta de Application Express, es necesario configurar una cuenta de usuario de Application Express.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100701436347305095)
,p_name=>'F4750.P209.WEBSHEET_ADMIN_SETUP'
,p_message_language=>'es'
,p_message_text=>unistr('La hoja de c\00E1lculo web se ha instalado correctamente. Sin embargo, para ejecutar la hoja de c\00E1lculo web mediante la autenticaci\00F3n de cuenta de Application Express, es necesario configurar un administrador de la cuenta de Application Express.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100055145692304566)
,p_name=>'F4750.VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100725486855305112)
,p_name=>'F4850.P1.SCHEMA_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>'No se han podido restablecer los datos de los servicios RESTful de ejemplo: el esquema <code>%0</code> no existe.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100300215846304791)
,p_name=>'F4900_P11_AUTH_TYPE_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta aplicaci\00F3n utiliza el esquema de autenticaci\00F3n %0.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100334618922304817)
,p_name=>'FACETED_SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsqueda de faceta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100308079857304797)
,p_name=>'FACETED_SEARCH.INVALID.SOURCE'
,p_message_language=>'es'
,p_message_text=>unistr('El asistente no puede crear una b\00FAsqueda de faceta utilizando el origen del informe. No hay columnas en las que buscar.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100119870525304616)
,p_name=>'FAILURE'
,p_message_language=>'es'
,p_message_text=>'fallo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99911169475304456)
,p_name=>'FAILURES'
,p_message_language=>'es'
,p_message_text=>'Fallos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99985564495304514)
,p_name=>'FDASH1'
,p_message_language=>'es'
,p_message_text=>'%0 Funciones'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100027083589304545)
,p_name=>'FEATURE'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100745856620305128)
,p_name=>'FEATURE OWNERS'
,p_message_language=>'es'
,p_message_text=>unistr('Propietarios de Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99699556688304292)
,p_name=>'FEATURE.ABOUT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Acerca de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99700253191304293)
,p_name=>'FEATURE.ABOUT_PAGE.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Acerca de esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99699646728304292)
,p_name=>'FEATURE.ACCESS_CONTROL'
,p_message_language=>'es'
,p_message_text=>'Control de Acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99700331056304293)
,p_name=>'FEATURE.ACCESS_CONTROL.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Incorpore la autenticaci\00F3n de usuarios basada en roles en la aplicaci\00F3n y gestione las asignaciones de nombres de usuario a roles de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99699793537304292)
,p_name=>'FEATURE.ACTIVITY_REPORTING'
,p_message_language=>'es'
,p_message_text=>unistr('Generaci\00F3n de informes de actividades')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99700419105304293)
,p_name=>'FEATURE.ACTIVITY_REPORTING.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Incluya varios informes y gr\00E1ficos en la actividad del usuario final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99699856790304292)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Configuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99701288829304294)
,p_name=>'FEATURE.CONFIGURATION_OPTIONS.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Permita a los administradores de la aplicaci\00F3n activar o desactivar una funcionalidad espec\00EDfica, asociadas a una opci\00F3n de creaci\00F3n de Application Express, en la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99999355435304524)
,p_name=>'FEATURE.CREATE_BUILD_OPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1n las siguientes opciones de creaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100060095333304570)
,p_name=>'FEATURE.EMAIL_REPORT'
,p_message_language=>'es'
,p_message_text=>unistr('Informes de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100060158022304570)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIOTION'
,p_message_language=>'es'
,p_message_text=>unistr('Incluye un informe en la cola de correo electr\00F3nico APEX_SEND().')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100116738610304614)
,p_name=>'FEATURE.EMAIL_REPORT.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Incluye un informe que muestra el correo electr\00F3nico que se va a enviar junto con el log de correos electr\00F3nicos enviados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99699945489304293)
,p_name=>'FEATURE.FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99700545558304293)
,p_name=>'FEATURE.FEEDBACK.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Proporcione a los usuarios finales un mecanismo para publicar comentarios generales como respuesta a los administradores y desarrolladores de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100060278982304570)
,p_name=>'FEATURE.JOB_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informes de trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100060308496304570)
,p_name=>'FEATURE.JOB_REPORT.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Incluye un informe basado en trabajos de base de datos, con la capacidad de desplegar un trabajo concreto para obtener m\00E1s informaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99700000771304293)
,p_name=>'FEATURE.THEME_STYLE_SELECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Selecci\00F3n de estilo de tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99701164550304294)
,p_name=>'FEATURE.THEME_STYLE_SELECTION.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Permita a los administradores seleccionar un esquema de colores por defecto (estilo de tema) para la aplicaci\00F3n. Los administradores tambi\00E9n pueden permitir a los usuarios finales seleccionar su propio estilo de tema. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100007236351304530)
,p_name=>'FEATURES'
,p_message_language=>'es'
,p_message_text=>'Funciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100315386199304803)
,p_name=>'FEATURES_100_PCT'
,p_message_language=>'es'
,p_message_text=>'Funciones 100%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100064442324304573)
,p_name=>'FEATURES_100_PERCENT'
,p_message_language=>'es'
,p_message_text=>'Funciones 100% (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100029696485304547)
,p_name=>'FEATURES_80_PCT'
,p_message_language=>'es'
,p_message_text=>'Funciones 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99557689698304187)
,p_name=>'FEATURES_AT_LEAST_80'
,p_message_language=>'es'
,p_message_text=>' %0 >= 80%'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99556493346304187)
,p_name=>'FEATURES_COMPLETE'
,p_message_language=>'es'
,p_message_text=>'Funciones Terminadas (%0 / %1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99557516233304187)
,p_name=>'FEATURES_COMPLETED'
,p_message_language=>'es'
,p_message_text=>'%0 Terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100317831982304804)
,p_name=>'FEATURES_FOR_RELEASE'
,p_message_language=>'es'
,p_message_text=>unistr('Funciones para la Versi\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100064675178304574)
,p_name=>'FEATURES_PAST_DUE'
,p_message_language=>'es'
,p_message_text=>'Vencidas (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100333910476304816)
,p_name=>'FEATURES_PERCENT_COMPLETE'
,p_message_language=>'es'
,p_message_text=>unistr('Porcentaje de las funciones que est\00E1n funcionalmente terminadas (%0/%1):')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100064513796304573)
,p_name=>'FEATURES_WITH_DATES'
,p_message_language=>'es'
,p_message_text=>'Con Fechas (%0/%1)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100096728618304599)
,p_name=>'FEATURE_CONFIGURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100002724338304527)
,p_name=>'FEATURE_CONTRIBUTOR'
,p_message_language=>'es'
,p_message_text=>'Contribuyente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100064323359304573)
,p_name=>'FEATURE_COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento de Funciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100311377395304800)
,p_name=>'FEATURE_DASH_01'
,p_message_language=>'es'
,p_message_text=>'%0 funciones, %1 terminadas completamente, en %2 versiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100311494423304800)
,p_name=>'FEATURE_DASH_02'
,p_message_language=>'es'
,p_message_text=>'%0 funciones de nivel superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100311588504304800)
,p_name=>'FEATURE_DASH_03'
,p_message_language=>'es'
,p_message_text=>'%0 sin fecha de vencimiento, %1 vencidas y < 80% terminadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100311604300304800)
,p_name=>'FEATURE_DASH_04'
,p_message_language=>'es'
,p_message_text=>'%0 funciones terminadas funcionalmente, %1 no'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100315089915304802)
,p_name=>'FEATURE_DASH_05'
,p_message_language=>'es'
,p_message_text=>unistr('%0% de las funciones est\00E1n 100% terminadas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100001036559304525)
,p_name=>'FEATURE_DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n de la Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100002029469304526)
,p_name=>'FEATURE_DESIRABILITY'
,p_message_language=>'es'
,p_message_text=>'Conveniencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100732976735305118)
,p_name=>'FEATURE_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100000600594304525)
,p_name=>'FEATURE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de la Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100000760297304525)
,p_name=>'FEATURE_OWNER'
,p_message_language=>'es'
,p_message_text=>unistr('Propietario de la Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100001716652304526)
,p_name=>'FEATURE_PRIORITY'
,p_message_language=>'es'
,p_message_text=>'Prioridad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100001839506304526)
,p_name=>'FEATURE_STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100001631146304526)
,p_name=>'FEATURE_TAGS'
,p_message_language=>'es'
,p_message_text=>'Etiquetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100745907586305128)
,p_name=>'FEATURE_WITHOUT_OWNERS'
,p_message_language=>'es'
,p_message_text=>'No Asignado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100748396614305130)
,p_name=>'FEEBACK.LOGGED.AS'
,p_message_language=>'es'
,p_message_text=>'conectado a %0 y asignado a %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100026982394304545)
,p_name=>'FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100042577028304557)
,p_name=>'FEEDBACK_ATTRIBUTE'
,p_message_language=>'es'
,p_message_text=>unistr('Suministre esta informaci\00F3n para registrarla como comentario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100113066952304611)
,p_name=>'FEEDBACK_DASHBOARD'
,p_message_language=>'es'
,p_message_text=>'Panel de Control de Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100006843665304530)
,p_name=>'FEEDBACK_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas de Comentario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99556792125304187)
,p_name=>'FEEDBACK_ENTRIES_CLOSED'
,p_message_language=>'es'
,p_message_text=>'%2 Entradas de Comentario Abiertas (%0 Cerradas)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100042396189304556)
,p_name=>'FEEDBACK_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el comentario y haga clic en el bot\00F3n de env\00EDo de comentarios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100334205727304817)
,p_name=>'FEEDBACK_PERCENT_CLOSED'
,p_message_language=>'es'
,p_message_text=>'Porcentaje de comentarios cerrados (%0/%1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100037536986304553)
,p_name=>'FEEDBACK_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Comentario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100042473903304557)
,p_name=>'FEEDBACK_TYPE_HELP'
,p_message_language=>'es'
,p_message_text=>'Identifique el tipo de comentario que suministra.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100205286355304719)
,p_name=>'FILENAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100009956464304532)
,p_name=>'FILENAME_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de Nombre de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100252603565304756)
,p_name=>'FILENAME_LABEL'
,p_message_language=>'es'
,p_message_text=>'Nombre de Archivo: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100008414203304531)
,p_name=>'FILES'
,p_message_language=>'es'
,p_message_text=>'Archivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100687940805305084)
,p_name=>'FILES_WITH_COUNT'
,p_message_language=>'es'
,p_message_text=>'%0 archivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100007967783304531)
,p_name=>'FILES_WITH_COUNT_AND_SIZE'
,p_message_language=>'es'
,p_message_text=>'%0 archivos, consumo de %1K'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100732713567305118)
,p_name=>'FILE_LABEL'
,p_message_language=>'es'
,p_message_text=>'Archivo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99535632332304168)
,p_name=>'FILE_TOO_BIG'
,p_message_language=>'es'
,p_message_text=>unistr('Este archivo de texto es demasiado grande para editarlo. Para cambiar el contenido, debe editarlo en la m\00E1quina local y volver a cargarlo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99570013977304197)
,p_name=>'FILE_UPLOAD_NOSESSION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No existe una sesi\00F3n v\00E1lida y se han cargado uno o m\00E1s archivos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99569932831304197)
,p_name=>'FILE_UPLOAD_TOOMANYFILES_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Se han cargado m\00E1s archivos en esta solicitud que el n\00FAmero de tipos de elementos de archivo definido en la p\00E1gina.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100060444949304570)
,p_name=>'FIND_MY_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Buscar mi Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99541044184304172)
,p_name=>'FIND_TABLES'
,p_message_language=>'es'
,p_message_text=>'Buscar Tablas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100768126319305144)
,p_name=>'FINISH'
,p_message_language=>'es'
,p_message_text=>'Terminar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99913053723304458)
,p_name=>'FIRST_ENTRY'
,p_message_language=>'es'
,p_message_text=>'Primera Entrada'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100066129890304575)
,p_name=>'FIXBY_PAST_DUE'
,p_message_language=>'es'
,p_message_text=>unistr('Soluci\00F3n por Fecha de Vencimiento')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99982543033304511)
,p_name=>'FIXED_IN_DEVELOPMENT'
,p_message_language=>'es'
,p_message_text=>'Fijado en Desarrollo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100000877205304525)
,p_name=>'FOCUS_AREA'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea de Enfoque')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99783585209304354)
,p_name=>'FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Pie de P\00E1gina')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99522723329304158)
,p_name=>'FORM'
,p_message_language=>'es'
,p_message_text=>'Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100731426315305117)
,p_name=>'FORMAT_MASK_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara de Formato: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100064796732304574)
,p_name=>'FORM_AND_LIST_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Lista y Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100064823852304574)
,p_name=>'FORM_AND_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe con formulario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99900711217304448)
,p_name=>'FORM_ON'
,p_message_language=>'es'
,p_message_text=>'Pantalla en %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99642272404304250)
,p_name=>'FORM_ON_A_TABLE'
,p_message_language=>'es'
,p_message_text=>'Pantalla Basada en Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100044038747304558)
,p_name=>'FORM_QUERY_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'La pantalla basada en consulta se ha creado correctamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100044353369304558)
,p_name=>'FORM_REPORT_WS_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'La pantalla e informe basados en la referencia de servicio Web se ha creado correctamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100041639555304556)
,p_name=>'FORM_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'La pantalla se ha creado correctamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100044177963304558)
,p_name=>'FORM_SUMMARY_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina de resumen se ha creado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100043753261304557)
,p_name=>'FORM_TABLE_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'La pantalla basada en tabla se ha creado correctamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100044286140304558)
,p_name=>'FORM_WS_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'La pantalla basada en la referencia de servicio Web se ha creado correctamente.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99591420219304213)
,p_name=>'FORWARD'
,p_message_language=>'es'
,p_message_text=>'Adelante'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100101276987304602)
,p_name=>'FROM_ATTRIBUTE_DICTIONARY'
,p_message_language=>'es'
,p_message_text=>'del diccionario de atributos'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99729724686304315)
,p_name=>'FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99991024275304518)
,p_name=>'FUNCTIONALLY_COMPLETE'
,p_message_language=>'es'
,p_message_text=>'Completo funcionalmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99980829585304510)
,p_name=>'FUNCTIONAL_IMPLEMENTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Implantaci\00F3n Funcional')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99785103267304355)
,p_name=>'FUNCTION_BODY'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99731171686304316)
,p_name=>'FUNCTION_BODY_RETURNING_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100041348840304556)
,p_name=>'FUNCTION_RETURNING_REF_CURSOR'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve un cursor de referencia')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100034487408304551)
,p_name=>'FUNC_BODY_RETURNING_BOOLEAN	'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve un valor booleano')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99590259715304212)
,p_name=>'FUNC_RET_BOOLEAN'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n PL/SQL que Devuelve Valor Booleano')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100028133470304546)
,p_name=>'FUTURE_MILESTONES'
,p_message_language=>'es'
,p_message_text=>'Hitos Futuros'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100680600428305079)
,p_name=>'GANTT_BASELINEDATE'
,p_message_language=>'es'
,p_message_text=>'Fecha de base'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100680571673305079)
,p_name=>'GANTT_BASELINEEND'
,p_message_language=>'es'
,p_message_text=>unistr('Finalizaci\00F3n de base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100680423164305079)
,p_name=>'GANTT_BASELINESTART'
,p_message_language=>'es'
,p_message_text=>'Inicio de base'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100034050866304550)
,p_name=>'GANTT_CHART.END_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de Finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100033960612304550)
,p_name=>'GANTT_CHART.START_DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha de Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100268038319304767)
,p_name=>'GANTT_CHART.TASK'
,p_message_language=>'es'
,p_message_text=>'Tarea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100680164049305075)
,p_name=>'GANTT_DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100680045675305075)
,p_name=>'GANTT_END'
,p_message_language=>'es'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100680297811305075)
,p_name=>'GANTT_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100680369802305079)
,p_name=>'GANTT_PROGRESS'
,p_message_language=>'es'
,p_message_text=>'Progreso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100679824428305075)
,p_name=>'GANTT_ROW'
,p_message_language=>'es'
,p_message_text=>'Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100679928870305075)
,p_name=>'GANTT_START'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100465480518304915)
,p_name=>'GATHER_TABLE_STATS'
,p_message_language=>'es'
,p_message_text=>unistr('Recopilar estad\00EDsticas de tabla')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99983680326304512)
,p_name=>'GENERAL_COMMENT'
,p_message_language=>'es'
,p_message_text=>'Comentario General'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100334374236304817)
,p_name=>'GENERAL_COMMENT_DASH'
,p_message_language=>'es'
,p_message_text=>'Comentarios Generales: %1 de %0 cerrados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99595396649304216)
,p_name=>'GENERATED_TABLE'
,p_message_language=>'es'
,p_message_text=>'Esta tabla se ha creado mediante el asistente de tablas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99679757977304278)
,p_name=>'GENERIC.CHANGES_SAVED'
,p_message_language=>'es'
,p_message_text=>'Se han guardado los cambios.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99989657563304517)
,p_name=>'GET_STATIC_LOV'
,p_message_language=>'es'
,p_message_text=>unistr('Cree o edite la lista de valores est\00E1tica')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100002985792304527)
,p_name=>'GLOBALIZATION_ASSIGNEE'
,p_message_language=>'es'
,p_message_text=>unistr('Persona asignada a Globalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100001135699304525)
,p_name=>'GLOBALIZATION_IMPACT'
,p_message_language=>'es'
,p_message_text=>unistr('Impacto de Globalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100003982066304528)
,p_name=>'GLOBALIZATION_STATUS'
,p_message_language=>'es'
,p_message_text=>unistr('Estado de Globalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99523953713304159)
,p_name=>'GLOBAL_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Global')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100048568252304561)
,p_name=>'GRAY_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto Gris'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100023495480304542)
,p_name=>'GRID_DEBUG_OFF'
,p_message_language=>'es'
,p_message_text=>unistr('Ocultar Columnas de Dise\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100023309946304542)
,p_name=>'GRID_DEBUG_ON'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar Columnas de Dise\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99622088674304235)
,p_name=>'GRID_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Cuadr\00EDcula')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99965560812304498)
,p_name=>'GROUPS'
,p_message_language=>'es'
,p_message_text=>'Grupos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100158075727304684)
,p_name=>'GROUP_LABEL'
,p_message_language=>'es'
,p_message_text=>'Grupo: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99783413763304354)
,p_name=>'HEADER'
,p_message_language=>'es'
,p_message_text=>'Texto de Cabecera'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100157817759304684)
,p_name=>'HEADING_LABEL'
,p_message_language=>'es'
,p_message_text=>'Cabecera: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100728404722305115)
,p_name=>'HELP_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Ayuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99731585714304316)
,p_name=>'HELP_TEXT'
,p_message_language=>'es'
,p_message_text=>'texto de ayuda'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99826597655304385)
,p_name=>'HIDDEN_AND_PROTECTED'
,p_message_language=>'es'
,p_message_text=>'Oculto y Protegido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99984775127304513)
,p_name=>'HIGHLY_DESIRABLE'
,p_message_language=>'es'
,p_message_text=>'Altamente Deseable'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100687456810305084)
,p_name=>'HIGH_CONTRAST'
,p_message_language=>'es'
,p_message_text=>'Contraste Alto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100449054656304903)
,p_name=>'HIGH_CONTRAST_TOGGLE'
,p_message_language=>'es'
,p_message_text=>'Conmutar Alto Contraste'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99965335080304498)
,p_name=>'HISTORY'
,p_message_language=>'es'
,p_message_text=>'Historial'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100041101469304556)
,p_name=>'HOME_LINK'
,p_message_language=>'es'
,p_message_text=>unistr('Enlace de P\00E1gina Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99519891462304156)
,p_name=>'HOME_NAV'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina inicial de Oracle APEX')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99572686963304199)
,p_name=>'HOME_PAGE_USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios:'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99758531904304336)
,p_name=>'HORIZONTAL'
,p_message_language=>'es'
,p_message_text=>'horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99505129020304145)
,p_name=>'HORIZONTAL2DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 2D Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99505266022304145)
,p_name=>'HORIZONTAL3DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 3D Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99505382494304145)
,p_name=>'HORIZONTALRANGE2DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 2D de Rango Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99505417861304145)
,p_name=>'HORIZONTALRANGE3DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 3D de Rango Horizontal'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100727827064305114)
,p_name=>'HOT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla Directa'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99563052496304192)
,p_name=>'HR_ACCOUNT_UNLOCKED'
,p_message_language=>'es'
,p_message_text=>'Cuenta de HR desbloqueada.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99732678615304317)
,p_name=>'HTML'
,p_message_language=>'es'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99751607516304331)
,p_name=>'HTMLWITHSHORTCUTS'
,p_message_language=>'es'
,p_message_text=>unistr('HTML con M\00E9todos Abreviados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99751398839304330)
,p_name=>'HTML_BODY'
,p_message_language=>'es'
,p_message_text=>'Cuerpo HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99593936200304215)
,p_name=>'HTML_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99603399392304222)
,p_name=>'HTML_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99783773761304354)
,p_name=>'HTML_HEADER'
,p_message_language=>'es'
,p_message_text=>'Cabecera HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99603425720304222)
,p_name=>'HTML_SLASH_TEXT'
,p_message_language=>'es'
,p_message_text=>'HTML/Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99731278197304316)
,p_name=>'HTML_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99603523913304222)
,p_name=>'HTML_TEXT_WITH_SHORTCUTS'
,p_message_language=>'es'
,p_message_text=>unistr('Texto HTML con m\00E9todos abreviados')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100728006179305114)
,p_name=>'ICON_CSS_CLASSES'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de Icono'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100663730929305062)
,p_name=>'IE6_COMPATIBLE'
,p_message_language=>'es'
,p_message_text=>'Indica que el tema es compatible con IE 6'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100070825463304578)
,p_name=>'IG_ALLOW_EDITING'
,p_message_language=>'es'
,p_message_text=>unistr('Permitir edici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100070991547304578)
,p_name=>'IG_READ_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo Lectura')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99732851652304317)
,p_name=>'IMAGE'
,p_message_language=>'es'
,p_message_text=>'imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100273670967304772)
,p_name=>'IMAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Im\00E1genes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99717244677304306)
,p_name=>'IMAGE_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>'Atributos de Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100040559346304555)
,p_name=>'IMAGE_PREFIX'
,p_message_language=>'es'
,p_message_text=>'Prefijo de Imagen'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99978407653304508)
,p_name=>'IMPORT FROM APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Importar de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100739737395305123)
,p_name=>'IMPORT_APP_NEW_SUBSTRING'
,p_message_language=>'es'
,p_message_text=>unistr('Nuevo Valor para la Cadena de Sustituci\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100208395068304722)
,p_name=>'IMPORT_APP_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('El archivo importado est\00E1 situado en el <a href="%0">repositorio de exportaci\00F3n</a>. A menos que desee repetir la instalaci\00F3n, debe eliminarlo.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99913963221304459)
,p_name=>'IN/OUT'
,p_message_language=>'es'
,p_message_text=>'Entrada/Salida'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99530437418304164)
,p_name=>'INACTIVE'
,p_message_language=>'es'
,p_message_text=>'Inactivo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100112858409304611)
,p_name=>'INCLUDE'
,p_message_language=>'es'
,p_message_text=>'Incluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100732307230305118)
,p_name=>'INCLUDE_LABEL'
,p_message_language=>'es'
,p_message_text=>'Incluir: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99729856814304315)
,p_name=>'INDEX'
,p_message_language=>'es'
,p_message_text=>unistr('\00EDndice')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100110253951304609)
,p_name=>'INDEX_NOUN'
,p_message_language=>'es'
,p_message_text=>unistr('\00CDndice')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99674248576304274)
,p_name=>'INITCAP_REFRESH'
,p_message_language=>'es'
,p_message_text=>'Refrescar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99888217137304438)
,p_name=>'INLINE'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100677729986305073)
,p_name=>'INLINE_HELP_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Ayuda en L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99888153609304438)
,p_name=>'INLINE_NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea y en Notificaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100034181507304550)
,p_name=>'INPUT_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Entrada'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99730590215304315)
,p_name=>'INSERT'
,p_message_language=>'es'
,p_message_text=>'insertar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100119613519304616)
,p_name=>'INSERT_EXCEPTION'
,p_message_language=>'es'
,p_message_text=>unistr('insertar en la excepci\00F3n wwv_flow_companies:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100050244635304562)
,p_name=>'INSTALLER.APPLICATION_CSS'
,p_message_language=>'es'
,p_message_text=>unistr('CSS (Aplicaci\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100050087213304562)
,p_name=>'INSTALLER.APPLICATION_IMAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Imagen (Aplicaci\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100050449456304563)
,p_name=>'INSTALLER.APPLICATION_STATIC'
,p_message_language=>'es'
,p_message_text=>unistr('Archivo Est\00E1tico (Aplicaci\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99559345800304189)
,p_name=>'INSTALLER.BUILD_OPTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99616867308304232)
,p_name=>'INSTALLER.BUILD_OPTIONS_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Puede incluir las siguientes opciones de creaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99559252535304189)
,p_name=>'INSTALLER.CONFIGURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Sustituciones de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99616766887304232)
,p_name=>'INSTALLER.CONFIGURATION_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Puede configurar los siguientes atributos para la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99559501676304189)
,p_name=>'INSTALLER.CONFIRMATION'
,p_message_language=>'es'
,p_message_text=>unistr('Confirmaci\00F3n de Instalaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99617036330304232)
,p_name=>'INSTALLER.CONFIRMATION_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Confirme que desea instalar los objetos de soporte de esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99559943357304189)
,p_name=>'INSTALLER.CONFIRM_DEINSTALL'
,p_message_language=>'es'
,p_message_text=>unistr('Confirmaci\00F3n de Desinstalaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99534502276304167)
,p_name=>'INSTALLER.DEINSTALL'
,p_message_language=>'es'
,p_message_text=>unistr('Script de Desinstalaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99560047197304189)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Desinstalaci\00F3n Correcta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99617317056304232)
,p_name=>'INSTALLER.DEINSTALL_SUCCESS_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Desinstalaci\00F3n terminada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99904271020304451)
,p_name=>'INSTALLER.ERROR.IN_CHECK'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Error al realizar la comprobaci\00F3n de instalaci\00F3n "%0":'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99904352157304451)
,p_name=>'INSTALLER.ERROR.IN_SCRIPT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Error al ejecutar el script de instalaci\00F3n "%0":'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99559191440304189)
,p_name=>'INSTALLER.EXISTENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Comprobaci\00F3n de Existencia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99559740104304189)
,p_name=>'INSTALLER.FAILURE'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Postinstalaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99617204262304232)
,p_name=>'INSTALLER.FAILURE_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Ha fallado la instalaci\00F3n de objetos de base de datos y de datos iniciales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99966608117304499)
,p_name=>'INSTALLER.INSTALL_FAILURE_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('El programa de instalaci\00F3n de la aplicaci\00F3n ha detectado que los objetos de soporte de la aplicaci\00F3n se hab\00EDan instalado previamente. Los objetos se deben eliminar a trav\00E9s del Taller de SQL antes de instalar la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99559869178304189)
,p_name=>'INSTALLER.LICENSE'
,p_message_language=>'es'
,p_message_text=>'Licencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99555039206304186)
,p_name=>'INSTALLER.SCRIPT.FAIL'
,p_message_language=>'es'
,p_message_text=>'Errores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99554984805304185)
,p_name=>'INSTALLER.SCRIPT.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99559646121304189)
,p_name=>'INSTALLER.SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Postinstalaci\00F3n Correcta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99617106046304232)
,p_name=>'INSTALLER.SUCCESS_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se han instalado los objetos de soporte de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99656199463304261)
,p_name=>'INSTALLER.UPGRADE_CONFIRM_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Confirme que desea actualizar los objetos de soporte de esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99656092161304261)
,p_name=>'INSTALLER.UPGRADE_FAILURE_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de actualizaci\00F3n de los objetos de soporte de esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99655601812304260)
,p_name=>'INSTALLER.UPGRADE_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('El programa de instalaci\00F3n de la aplicaci\00F3n ha detectado que los objetos de soporte de la aplicaci\00F3n se han instalado previamente. Este asistente le guiar\00E1 a trav\00E9s del proceso de actualizaci\00F3n de los objetos de soporte.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99655960217304261)
,p_name=>'INSTALLER.UPGRADE_SUCCESS_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se han actualizado los objetos de soporte de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99559459253304189)
,p_name=>'INSTALLER.VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99616981272304232)
,p_name=>'INSTALLER.VALIDATION_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se realizar\00E1n las siguientes validaciones para asegurarse de que el sistema es compatible con esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99559007562304189)
,p_name=>'INSTALLER.WELCOME'
,p_message_language=>'es'
,p_message_text=>'Bienvenido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99616626020304232)
,p_name=>'INSTALLER.WELCOME_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('El programa de instalaci\00F3n de esta aplicaci\00F3n le guiar\00E1 a trav\00E9s del proceso de creaci\00F3n de objetos de base de datos y de datos iniciales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100050163456304562)
,p_name=>'INSTALLER.WORKSPACE_CSS'
,p_message_language=>'es'
,p_message_text=>'CSS (Espacio de Trabajo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100049917588304562)
,p_name=>'INSTALLER.WORKSPACE_IMAGES'
,p_message_language=>'es'
,p_message_text=>'Imagen (Espacio de Trabajo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100050396279304562)
,p_name=>'INSTALLER.WORKSPACE_STATIC'
,p_message_language=>'es'
,p_message_text=>unistr('Archivo Est\00E1tico (Espacio de Trabajo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99547301080304180)
,p_name=>'INSTALL_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Instalar Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100050530680304563)
,p_name=>'INSTALL_SAMPLE_APPS'
,p_message_language=>'es'
,p_message_text=>unistr('Instale una aplicaci\00F3n de ejemplo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100448439570304903)
,p_name=>'INSTANCE_ADMIN_HOME_NAV'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina inicial de los servicios de administraci\00F3n de Oracle APEX')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100097787284304599)
,p_name=>'INSTANCE_SETTINGS'
,p_message_language=>'es'
,p_message_text=>'Valores de Instancia'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99999731969304524)
,p_name=>'INST_RUNNING_IN_MAN_MODE_4050'
,p_message_language=>'es'
,p_message_text=>unistr('Esta instancia se est\00E1 ejecutando en modo de provisionamiento manual, por lo que no aceptar\00E1 solicitudes de servicio')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100092807149304596)
,p_name=>'INSUFFICIENT_INSTALL_SPACE'
,p_message_language=>'es'
,p_message_text=>unistr('No hay suficiente espacio para instalar esta aplicaci\00F3n.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99980976364304510)
,p_name=>'INTEGRATION_COMPLETE'
,p_message_language=>'es'
,p_message_text=>unistr('Integraci\00F3n Terminada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99986153948304514)
,p_name=>'INTEGRATION_SIGNOFF'
,p_message_language=>'es'
,p_message_text=>unistr('Desconexi\00F3n de Integraci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99976654282304507)
,p_name=>'INTERACTIVE_GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadr\00EDcula Interactiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99752338341304331)
,p_name=>'INTERACTIVE_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe Interactivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100006174469304529)
,p_name=>'INTERACTIVE_REPORT_SEARCHES'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsquedas de Informe Interactivo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99571394381304198)
,p_name=>'INTERNAL'
,p_message_language=>'es'
,p_message_text=>'Interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99523653647304159)
,p_name=>'INTERNAL_ADMINISTRATION'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n Interna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99573093562304199)
,p_name=>'INTERNAL_USERS'
,p_message_language=>'es'
,p_message_text=>'Interno'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99900303771304448)
,p_name=>'INVALID_APPLICATION_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe introducir un nombre v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99530303129304164)
,p_name=>'INVALID_APP_ARCHIVE'
,p_message_language=>'es'
,p_message_text=>unistr('El archivo no es un archivo de aplicaci\00F3n v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99900807040304448)
,p_name=>'INVALID_GROUP_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe introducir un nombre de grupo v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99592117687304213)
,p_name=>'INVALID_OBJECT'
,p_message_language=>'es'
,p_message_text=>unistr('El objeto %0 no es v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100254055122304757)
,p_name=>'INVALID_PAGE_GROUP_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe introducir un nombre de grupo de p\00E1ginas v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100768634302305145)
,p_name=>'INVALID_POSITION'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n no V\00E1lida [No Presentada]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100119300942304616)
,p_name=>'INVALID_SCHEMA_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de esquema no v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100033158106304549)
,p_name=>'INVALID_SORT_ORDER'
,p_message_language=>'es'
,p_message_text=>unistr('El valor de entrada no v\00E1lido debe ser un n\00FAmero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100717476703305107)
,p_name=>'INVALID_USERS_NOT_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Tenga en cuenta que hay %0 cadenas que son nombres de usuario no v\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100119215313304616)
,p_name=>'INVALID_WORKSPACE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('nombre de espacio de trabajo no v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100059889533304570)
,p_name=>'INVALID_WS_OBJ'
,p_message_language=>'es'
,p_message_text=>unistr('Objetos de Hoja de C\00E1lculo Web No V\00E1lidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100057716921304568)
,p_name=>'INVALID_WS_OBJ_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Objetos de hoja de c\00E1lculo web no v\00E1lidos corregidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100059948343304570)
,p_name=>'INVALID_WS_OBJ_WARNING_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Los objetos de base de datos necesarios para crear aplicaciones de hoja de c\00E1lculo web no son v\00E1lidos o no existen. P\00F3ngase en contacto con el administrador del espacio de trabajo.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99505521122304145)
,p_name=>'INVERSE2DLINE'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea 2D Inversa')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99982443564304511)
,p_name=>'IN_PROGRESS'
,p_message_language=>'es'
,p_message_text=>'En Curso'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99678279080304277)
,p_name=>'IR_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas de informe interactivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99926661478304468)
,p_name=>'IR_DEVELOPER'
,p_message_language=>'es'
,p_message_text=>'Desarrollador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99926507381304468)
,p_name=>'IR_END_USER'
,p_message_language=>'es'
,p_message_text=>'Usuario Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99926937172304469)
,p_name=>'IR_INTERACTIVE_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe Interactivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99903016657304450)
,p_name=>'IR_ONLY_ONE_PER_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se puede mostrar un informe interactivo en una p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99926750392304469)
,p_name=>'IR_SAVE_ONLY_FOR_DEV'
,p_message_language=>'es'
,p_message_text=>unistr('Este recuadro de dialogo s\00F3lo se muestra a los desarrolladores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99926401616304468)
,p_name=>'IR_SAVE_REPORT_STAR'
,p_message_language=>'es'
,p_message_text=>'Guardar Informe *'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99926871202304469)
,p_name=>'IR_SAVE_STAR'
,p_message_language=>'es'
,p_message_text=>'Guardar *'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100731974213305117)
,p_name=>'IR_SUBSCRIPTION_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n: %0, P\00E1gina: %1, Suscripci\00F3n por: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100045721373304559)
,p_name=>'IR_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina de informe interactivo se ha creado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99927016239304469)
,p_name=>'IR_UNITS'
,p_message_language=>'es'
,p_message_text=>'Unidad Medida'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100467117526304916)
,p_name=>'ISSUES'
,p_message_language=>'es'
,p_message_text=>'Problemas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99914612895304459)
,p_name=>'IS_WRAPPED'
,p_message_language=>'es'
,p_message_text=>unistr('est\00E1 ajustado')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100025874552304544)
,p_name=>'ITEM CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99603700430304222)
,p_name=>'ITEM NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99571012235304198)
,p_name=>'ITEM.BUTTONS'
,p_message_language=>'es'
,p_message_text=>'Botones de Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100752648651305133)
,p_name=>'ITEM_COLUMN_SPAN'
,p_message_language=>'es'
,p_message_text=>unistr('Ampliaci\00F3n de Columna de Elemento Actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99590574333304212)
,p_name=>'ITEM_EXP1_EQ_EXP2'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Elemento en Expresi\00F3n 1 Equivale a Expresi\00F3n 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99590628253304212)
,p_name=>'ITEM_EXP1_NE_EXP2'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Elemento en Expresi\00F3n 1 No Equivale a Expresi\00F3n 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99590113214304212)
,p_name=>'ITEM_IN_EXP1_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento en Expresi\00F3n 1 No Nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99590073997304212)
,p_name=>'ITEM_IN_EXP1_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento en Expresi\00F3n 1 Nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100731125467305117)
,p_name=>'ITEM_LABEL'
,p_message_language=>'es'
,p_message_text=>'Elemento: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99648207595304255)
,p_name=>'ITEM_NAME.DATE_PICKER'
,p_message_language=>'es'
,p_message_text=>'Selector de Fecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99648307238304255)
,p_name=>'ITEM_NAME.HIDDEN'
,p_message_language=>'es'
,p_message_text=>'Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99991102420304518)
,p_name=>'ITEM_NAME.NATIVE_AUTO_COMPLETE'
,p_message_language=>'es'
,p_message_text=>unistr('Campo de Texto con Terminaci\00F3n Autom\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100276807234304774)
,p_name=>'ITEM_NAME.NATIVE_CHECKBOX'
,p_message_language=>'es'
,p_message_text=>'Casilla de Control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100646551903305049)
,p_name=>'ITEM_NAME.NATIVE_COLOR_PICKER'
,p_message_language=>'es'
,p_message_text=>'Selector de Color'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100106459768304606)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER'
,p_message_language=>'es'
,p_message_text=>'Selector de Fecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100269037248304768)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_CLASSIC'
,p_message_language=>'es'
,p_message_text=>unistr('Selector de Fecha (Cl\00E1sico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99515711884304153)
,p_name=>'ITEM_NAME.NATIVE_DATE_PICKER_HTML5'
,p_message_language=>'es'
,p_message_text=>'Selector de Fecha (HTML5)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100311269403304800)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_IMAGE'
,p_message_language=>'es'
,p_message_text=>'Mostrar Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100270553172304769)
,p_name=>'ITEM_NAME.NATIVE_DISPLAY_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100310031392304799)
,p_name=>'ITEM_NAME.NATIVE_FILE'
,p_message_language=>'es'
,p_message_text=>unistr('Exploraci\00F3n de Archivos...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100646398193305049)
,p_name=>'ITEM_NAME.NATIVE_HIDDEN'
,p_message_language=>'es'
,p_message_text=>'Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100316923569304804)
,p_name=>'ITEM_NAME.NATIVE_LIST_MANAGER'
,p_message_language=>'es'
,p_message_text=>'Gestor de Listas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100333159641304816)
,p_name=>'ITEM_NAME.NATIVE_MARKDOWN_EDITOR'
,p_message_language=>'es'
,p_message_text=>'Editor de Markdown'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100260937318304762)
,p_name=>'ITEM_NAME.NATIVE_NUMBER_FIELD'
,p_message_language=>'es'
,p_message_text=>unistr('Campo Num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100262455356304763)
,p_name=>'ITEM_NAME.NATIVE_PASSWORD'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100269768025304769)
,p_name=>'ITEM_NAME.NATIVE_POPUP_LOV'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores Emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100276708508304774)
,p_name=>'ITEM_NAME.NATIVE_RADIOGROUP'
,p_message_language=>'es'
,p_message_text=>'Grupo de Botones de Radio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100022656100304542)
,p_name=>'ITEM_NAME.NATIVE_RICH_TEXT_EDITOR'
,p_message_language=>'es'
,p_message_text=>'Editor de Texto Enriquecido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100269111407304768)
,p_name=>'ITEM_NAME.NATIVE_SELECT_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Lista de Selecci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100271194518304770)
,p_name=>'ITEM_NAME.NATIVE_SHUTTLE'
,p_message_language=>'es'
,p_message_text=>'Selector'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99536840289304169)
,p_name=>'ITEM_NAME.NATIVE_SLIDER'
,p_message_language=>'es'
,p_message_text=>unistr('Gu\00EDa de Desplazamiento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99648477043304255)
,p_name=>'ITEM_NAME.NATIVE_STOP_AND_START_HTML_TABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Parar e Iniciar Dise\00F1o de Cuadr\00EDcula (En desuso)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100024636425304543)
,p_name=>'ITEM_NAME.NATIVE_TEXTAREA'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea de Texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100646456058305049)
,p_name=>'ITEM_NAME.NATIVE_TEXT_FIELD'
,p_message_language=>'es'
,p_message_text=>'Campo de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99536535966304168)
,p_name=>'ITEM_NAME.NATIVE_YES_NO'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED/No')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99598014478304218)
,p_name=>'ITEM_NAME.PLUGIN'
,p_message_language=>'es'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99648562029304255)
,p_name=>'ITEM_NAME.POPUP_LIST_OF_VALUES'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores Emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100285861168304781)
,p_name=>'ITEM_NAME.STAR_RATING'
,p_message_language=>'es'
,p_message_text=>unistr('Calificaci\00F3n con estrellas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99648615605304255)
,p_name=>'ITEM_NAME.TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100686018538305083)
,p_name=>'ITEM_POST_TEXT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Texto Posterior de Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100685926930305083)
,p_name=>'ITEM_PRE_TEXT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Texto Previo de Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100051180706304563)
,p_name=>'ITEM_ROW_2'
,p_message_language=>'es'
,p_message_text=>'Fila 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100051232362304563)
,p_name=>'ITEM_ROW_3'
,p_message_language=>'es'
,p_message_text=>'Fila 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100051359859304563)
,p_name=>'ITEM_ROW_4'
,p_message_language=>'es'
,p_message_text=>'Fila 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100051446305304563)
,p_name=>'ITEM_ROW_5'
,p_message_language=>'es'
,p_message_text=>'Fila 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100260848244304762)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MAX_VALUE_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('El valor m\00E1ximo introducido %0 para el elemento %1 no es num\00E9rico. Si el valor contiene posiciones decimales, especifique un punto como separador de decimales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100260794096304762)
,p_name=>'ITEM_TYPE.ATTRIBUTE.MIN_VALUE_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('El valor m\00EDnimo introducido %0 para el elemento %1 no es num\00E9rico. Si el valor contiene posiciones decimales, especifique un punto como separador de decimales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99536744699304168)
,p_name=>'ITEM_TYPE.ATTRIBUTE.STEP_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('El valor de paso introducido %0 para el elemento %1 no es num\00E9rico. Si el valor contiene posiciones decimales, especifique un punto como separador de decimales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99598475966304218)
,p_name=>'ITEM_TYPE.BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99598574356304218)
,p_name=>'ITEM_TYPE.FILE'
,p_message_language=>'es'
,p_message_text=>unistr('Exploraci\00F3n de Archivos...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99598629171304218)
,p_name=>'ITEM_TYPE.HIDDEN'
,p_message_language=>'es'
,p_message_text=>'Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99598793084304218)
,p_name=>'ITEM_TYPE.HIDDEN_PROTECTED'
,p_message_language=>'es'
,p_message_text=>'Oculto y Protegido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99598834857304218)
,p_name=>'ITEM_TYPE.POPUP_COLOR'
,p_message_language=>'es'
,p_message_text=>'Selector de Color Emergente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99598967343304218)
,p_name=>'ITEM_TYPE.TEXT'
,p_message_language=>'es'
,p_message_text=>'Campo de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99599046680304218)
,p_name=>'ITEM_TYPE.TEXT_DISABLED'
,p_message_language=>'es'
,p_message_text=>'Campo de Texto (Desactivado, no guarda el estado)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99599169310304218)
,p_name=>'ITEM_TYPE.TEXT_DISABLED_AND_SAVE'
,p_message_language=>'es'
,p_message_text=>'Campo de Texto (Desactivado, guarda el estado)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99599260289304219)
,p_name=>'ITEM_TYPE.TEXT_WITH_ENTER_SUBMIT'
,p_message_language=>'es'
,p_message_text=>unistr('Campo de Texto (siempre se ejecuta la p\00E1gina al pulsar Intro)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99976487431304507)
,p_name=>'JET_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico de JET')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99911852818304457)
,p_name=>'JOB'
,p_message_language=>'es'
,p_message_text=>'Trabajo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99977628530304508)
,p_name=>'JQM COLUMN TOGGLE'
,p_message_language=>'es'
,p_message_text=>unistr('Conmutaci\00F3n de columnas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99977554295304507)
,p_name=>'JQM REFLOW'
,p_message_language=>'es'
,p_message_text=>'Informe de Reflujo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100053184647304565)
,p_name=>'JQM_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100053098783304565)
,p_name=>'JQM_HEADER'
,p_message_language=>'es'
,p_message_text=>'Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99979521662304509)
,p_name=>'JQM_LIST_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Lista'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99976722675304507)
,p_name=>'JSTREE'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rbol Javascript')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100002840003304527)
,p_name=>'JUSTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Justificaci\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100467224541304916)
,p_name=>'LABELS'
,p_message_language=>'es'
,p_message_text=>'Etiquetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100752578434305133)
,p_name=>'LABEL_COLUMN_SPAN'
,p_message_language=>'es'
,p_message_text=>unistr('Ampliaci\00F3n de Columna de Etiqueta Actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100746124805305128)
,p_name=>'LABEL_ID'
,p_message_language=>'es'
,p_message_text=>'ID de Etiqueta del Elemento Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100039602008304554)
,p_name=>'LABEL_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99704648420304296)
,p_name=>'LABEL_TEMPLATE.COPIED'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99704715625304296)
,p_name=>'LABEL_TEMPLATE.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('\00C9sta es la copia "maestra" de esta plantilla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99704995590304296)
,p_name=>'LABEL_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>'No hay ninguna plantilla que suscribir a esta plantilla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99704860997304296)
,p_name=>'LABEL_TEMPLATE.REFERENCE'
,p_message_language=>'es'
,p_message_text=>'Plantillas de etiqueta que se suscriben a esta plantilla'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99547867078304180)
,p_name=>'LANGUAGES'
,p_message_language=>'es'
,p_message_text=>'Idiomas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100005694109304529)
,p_name=>'LAST_CHANGE'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimo Cambio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99913186274304458)
,p_name=>'LAST_ENTRY'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima Entrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100008537523304531)
,p_name=>'LAST_LOGIN'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima Conexi\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99525229978304160)
,p_name=>'LAYOUT'
,p_message_language=>'es'
,p_message_text=>unistr('%0: Dise\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99562235497304191)
,p_name=>'LAYOUT.AFTER_BODY'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Cuerpo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99901510225304449)
,p_name=>'LAYOUT.AFTER_ERROR_HEADER'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de cabecera de p\00E1gina error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99901210926304448)
,p_name=>'LAYOUT.AFTER_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99967561903304500)
,p_name=>'LAYOUT.AFTER_HEADER'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Cabecera')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100316153856304803)
,p_name=>'LAYOUT.AFTER_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s del Elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100250706959304754)
,p_name=>'LAYOUT.AFTER_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Etiqueta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100251182684304755)
,p_name=>'LAYOUT.AFTER_LABEL_AND_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Etiqueta y Elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99652502742304258)
,p_name=>'LAYOUT.AFTER_LOGIN'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99892006282304441)
,p_name=>'LAYOUT.AFTER_PROCESSING'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Procesamiento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99901016104304448)
,p_name=>'LAYOUT.AFTER_REGIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Regiones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99901334810304448)
,p_name=>'LAYOUT.AFTER_SUBMIT'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99562142269304191)
,p_name=>'LAYOUT.BEFORE_BODY'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Cuerpo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99891743678304441)
,p_name=>'LAYOUT.BEFORE_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Antes de C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99901671010304449)
,p_name=>'LAYOUT.BEFORE_ERROR_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Antes de Pie de P\00E1gina de Error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99901148133304448)
,p_name=>'LAYOUT.BEFORE_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Antes de Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99891632557304441)
,p_name=>'LAYOUT.BEFORE_HEADER'
,p_message_language=>'es'
,p_message_text=>'Antes de Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100316056175304803)
,p_name=>'LAYOUT.BEFORE_ITEM'
,p_message_language=>'es'
,p_message_text=>'Antes del Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100250683025304754)
,p_name=>'LAYOUT.BEFORE_LABEL'
,p_message_language=>'es'
,p_message_text=>'Antes de Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100251093284304755)
,p_name=>'LAYOUT.BEFORE_LABEL_AND_ITEM'
,p_message_language=>'es'
,p_message_text=>'Antes de Etiqueta y Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99891936798304441)
,p_name=>'LAYOUT.BEFORE_PROCESSING'
,p_message_language=>'es'
,p_message_text=>'Antes de Procesamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99900990777304448)
,p_name=>'LAYOUT.BEFORE_REGIONS'
,p_message_language=>'es'
,p_message_text=>'Antes de Regiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99891886042304441)
,p_name=>'LAYOUT.BEFORE_VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Antes de Validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99961234658304495)
,p_name=>'LAYOUT.BRANCHES'
,p_message_language=>'es'
,p_message_text=>'bifurcaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99643274307304251)
,p_name=>'LAYOUT.BUTTON.ABOVE_BOX'
,p_message_language=>'es'
,p_message_text=>'Encima del Recuadro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99643358350304251)
,p_name=>'LAYOUT.BUTTON.BELOW_BOX'
,p_message_language=>'es'
,p_message_text=>'Debajo del Recuadro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99643466569304251)
,p_name=>'LAYOUT.BUTTON.BOTTOM'
,p_message_language=>'es'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99643566995304251)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CHANGE'
,p_message_language=>'es'
,p_message_text=>'Cambiar Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99643691151304251)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99643709112304251)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_COPY'
,p_message_language=>'es'
,p_message_text=>'Copiar Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99643814244304252)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_CREATE'
,p_message_language=>'es'
,p_message_text=>'Crear Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99643938579304252)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99644067406304252)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99644115276304252)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_EXPAND'
,p_message_language=>'es'
,p_message_text=>'Ampliar Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99644290174304252)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_NEXT'
,p_message_language=>'es'
,p_message_text=>'Plantilla Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99644360604304252)
,p_name=>'LAYOUT.BUTTON.REGION_TEMPLATE_PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Plantilla Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99644409329304252)
,p_name=>'LAYOUT.BUTTON.TOP'
,p_message_language=>'es'
,p_message_text=>'Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99884406537304435)
,p_name=>'LAYOUT.CHANGE_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Cambiar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99955195819304491)
,p_name=>'LAYOUT.CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100103932491304604)
,p_name=>'LAYOUT.CHART_SERIES'
,p_message_language=>'es'
,p_message_text=>'Serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99883611454304434)
,p_name=>'LAYOUT.CLOSE_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Cerrar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99884179424304435)
,p_name=>'LAYOUT.COPY_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Copiar Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99883841756304435)
,p_name=>'LAYOUT.CREATE2_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Create2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99515912439304153)
,p_name=>'LAYOUT.CUSTOM_POSITION'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n personalizada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100103606844304604)
,p_name=>'LAYOUT.DA_EVENT_FALSE'
,p_message_language=>'es'
,p_message_text=>'Falso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100103771329304604)
,p_name=>'LAYOUT.DA_EVENT_TRUE'
,p_message_language=>'es'
,p_message_text=>'Verdadero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99884056375304435)
,p_name=>'LAYOUT.DELETE_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Suprimir')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100320539685304806)
,p_name=>'LAYOUT.EMPTY_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta Vac\00EDa - #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100728131685305114)
,p_name=>'LAYOUT.ERROR_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99883765809304434)
,p_name=>'LAYOUT.EXPAND_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Ampliar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99825769305304384)
,p_name=>'LAYOUT.FUNCTION_RETURNING_SQL_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n que Devuelve una Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100104090185304604)
,p_name=>'LAYOUT.GLOBAL_PAGE_REGION_PREFIX'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Global:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99883908635304435)
,p_name=>'LAYOUT.HELP_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Ayuda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100316295427304803)
,p_name=>'LAYOUT.HELP_LINK'
,p_message_language=>'es'
,p_message_text=>'Enlace de Ayuda del Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100320630278304807)
,p_name=>'LAYOUT.HIDDEN_FIELD'
,p_message_language=>'es'
,p_message_text=>'Oculto - #0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99825664324304384)
,p_name=>'LAYOUT.HTML_TEXT_ESCAPE_SC'
,p_message_language=>'es'
,p_message_text=>unistr('Caracteres Especiales de Identificaci\00F3n del Texto HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100677684887305073)
,p_name=>'LAYOUT.INLINE_HELP_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Ayuda en L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100686238506305083)
,p_name=>'LAYOUT.ITEM_POST_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto Posterior de Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100686162556305083)
,p_name=>'LAYOUT.ITEM_PRE_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto Previo de Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99884280050304435)
,p_name=>'LAYOUT.NEXT_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Siguiente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99961153495304495)
,p_name=>'LAYOUT.NOREGION_AT_DISP_POINT'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna regi\00F3n en el punto de visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100104195698304604)
,p_name=>'LAYOUT.NO_REGION_ASSIGNED'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de P\00E1gina y Botones sin Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99993803718304520)
,p_name=>'LAYOUT.ON_DEMAND'
,p_message_language=>'es'
,p_message_text=>'Devoluciones de Llamada de Ajax'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100250957552304755)
,p_name=>'LAYOUT.ON_ERROR_AFTER_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('En Error Despu\00E9s de Etiqueta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100250810022304754)
,p_name=>'LAYOUT.ON_ERROR_BEFORE_LABEL'
,p_message_language=>'es'
,p_message_text=>'En Error Antes de Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99894143999304443)
,p_name=>'LAYOUT.ON_NEW_INSTANCE'
,p_message_language=>'es'
,p_message_text=>'En Nueva Instancia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99894235679304443)
,p_name=>'LAYOUT.ON_SUBMIT_BEFORE_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('En Ejecuci\00F3n y Antes de C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99884354777304435)
,p_name=>'LAYOUT.PREVIOUS_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Anterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100104351615304604)
,p_name=>'LAYOUT.PROCESSING'
,p_message_language=>'es'
,p_message_text=>'Procesamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99493311927304136)
,p_name=>'LAYOUT.REGION_POS_BODY'
,p_message_language=>'es'
,p_message_text=>'Cuerpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100104487693304605)
,p_name=>'LAYOUT.REGION_POS_BODY_X'
,p_message_language=>'es'
,p_message_text=>'Cuerpo (#0)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100104589170304605)
,p_name=>'LAYOUT.REGION_POS_NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n #0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100103860885304604)
,p_name=>'LAYOUT.REPORT_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100106717386304606)
,p_name=>'LAYOUT.RUN_JAVASCRIPT'
,p_message_language=>'es'
,p_message_text=>'Ejecutar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99825863838304384)
,p_name=>'LAYOUT.SIMPLE_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico Simple')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99826102140304385)
,p_name=>'LAYOUT.STRUCTURED_QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta Estructurada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100106649653304606)
,p_name=>'LAYOUT.SUBMIT_AS'
,p_message_language=>'es'
,p_message_text=>'Ejecutar como "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99978183071304508)
,p_name=>'LAYOUT.SUB_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Subregi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99826001374304385)
,p_name=>'LAYOUT.SVG_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico SVG')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99610851972304227)
,p_name=>'LAYOUT.T_#APEX_CSS#'
,p_message_language=>'es'
,p_message_text=>'Archivos de hoja de estilo en cascada utilizados por &PRODUCT_NAME.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99611291695304228)
,p_name=>'LAYOUT.T_#APEX_JAVASCRIPT#'
,p_message_language=>'es'
,p_message_text=>unistr('Archivos JavaScript y c\00F3digo utilizados por &PRODUCT_NAME.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100730277095305116)
,p_name=>'LAYOUT.T_#APPLICATION_CSS#'
,p_message_language=>'es'
,p_message_text=>'Archivos de hoja de estilo en cascada definidos en el nivel de interfaz de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99611444069304228)
,p_name=>'LAYOUT.T_#APPLICATION_JAVASCRIPT#'
,p_message_language=>'es'
,p_message_text=>'Archivos JavaScript definidos en el nivel de interfaz de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100056922470304568)
,p_name=>'LAYOUT.T_#DIALOG_ATTRIBUTES#'
,p_message_language=>'es'
,p_message_text=>unistr('Atributos de Cuadro de Di\00E1logo, para definir atributos de cuadro de di\00E1logo no soportados de forma declarativa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100679396333305074)
,p_name=>'LAYOUT.T_#DIALOG_CSS_CLASSES#'
,p_message_language=>'es'
,p_message_text=>unistr('Clases CSS de Cuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100056572529304567)
,p_name=>'LAYOUT.T_#DIALOG_HEIGHT#'
,p_message_language=>'es'
,p_message_text=>unistr('Altura del Cuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100056790651304567)
,p_name=>'LAYOUT.T_#DIALOG_MAX_WIDTH#'
,p_message_language=>'es'
,p_message_text=>unistr('Ancho M\00E1ximo de Cuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100056680221304567)
,p_name=>'LAYOUT.T_#DIALOG_WIDTH#'
,p_message_language=>'es'
,p_message_text=>unistr('Ancho del Cuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100751077230305132)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_NAV_LABEL#'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta para ampliar / contraer navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100751153934305132)
,p_name=>'LAYOUT.T_#EXPAND_COLLAPSE_SIDE_COL_LABEL#'
,p_message_language=>'es'
,p_message_text=>'Etiqueta para ampliar / contraer columna lateral'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100720536527305109)
,p_name=>'LAYOUT.T_#FAVICONS#'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo HTML de Favicons')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99611164250304227)
,p_name=>'LAYOUT.T_#GENERATED_CSS#'
,p_message_language=>'es'
,p_message_text=>'Hojas de estilo en cascada creadas por los componentes sobre la marcha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99611500705304228)
,p_name=>'LAYOUT.T_#GENERATED_JAVASCRIPT#'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo JavaScript creado por los componentes sobre la marcha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100056836133304567)
,p_name=>'LAYOUT.T_#IS_MODAL#'
,p_message_language=>'es'
,p_message_text=>unistr('Modo de P\00E1gina de Cuadro de Di\00E1logo (por ejemplo, ''true'' cuando sea modal, y ''false'' cuando no sea modal)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99611039225304227)
,p_name=>'LAYOUT.T_#PAGE_CSS#'
,p_message_language=>'es'
,p_message_text=>unistr('Archivos de hoja de estilo en cascada y estilo en l\00EDnea definidos en el nivel de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99604757906304223)
,p_name=>'LAYOUT.T_#PAGE_CSS_CLASSES#'
,p_message_language=>'es'
,p_message_text=>unistr('Clases CSS de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100260131368304762)
,p_name=>'LAYOUT.T_#PAGE_JAVASCRIPT#'
,p_message_language=>'es'
,p_message_text=>unistr('Archivos y c\00F3digo JavaScript definido en el nivel de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99522924028304158)
,p_name=>'LAYOUT.T_#PAGE_STATIC_ID#'
,p_message_language=>'es'
,p_message_text=>unistr('ID Est\00E1tico de P\00E1gina (por ejemplo ''P100'')')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99519383431304155)
,p_name=>'LAYOUT.T_#PAGE_TRANSITION#'
,p_message_language=>'es'
,p_message_text=>unistr('Transici\00F3n utilizada para navegar a una nueva p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100056457848304567)
,p_name=>'LAYOUT.T_#PAGE_URL#'
,p_message_language=>'es'
,p_message_text=>unistr('URL de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99519494176304155)
,p_name=>'LAYOUT.T_#POPUP_TRANSITION#'
,p_message_language=>'es'
,p_message_text=>unistr('Transici\00F3n utilizada para abrir una ventana emergente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100059678968304570)
,p_name=>'LAYOUT.T_#REQUESTED_URL#'
,p_message_language=>'es'
,p_message_text=>unistr('URL de p\00E1gina solicitada por el explorador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100730406289305116)
,p_name=>'LAYOUT.T_#SIDE_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Navegaci\00F3n (Lateral)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99610942171304227)
,p_name=>'LAYOUT.T_#TEMPLATE_CSS#'
,p_message_language=>'es'
,p_message_text=>unistr('Archivos de hoja de estilo en cascada y estilo en l\00EDnea definido en la plantilla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99611341895304228)
,p_name=>'LAYOUT.T_#TEMPLATE_JAVASCRIPT#'
,p_message_language=>'es'
,p_message_text=>unistr('Archivos JavaScript y c\00F3digo definido en la plantilla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99611621001304228)
,p_name=>'LAYOUT.T_#THEME_CSS#'
,p_message_language=>'es'
,p_message_text=>'Archivos de hoja de estilo en cascada definidos en el nivel de tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100739270296305123)
,p_name=>'LAYOUT.T_#THEME_JAVASCRIPT#'
,p_message_language=>'es'
,p_message_text=>'Archivos JavaScript definidos en el nivel de tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100739381014305123)
,p_name=>'LAYOUT.T_#THEME_STYLE_CSS#'
,p_message_language=>'es'
,p_message_text=>'Archivos de hoja de estilo en cascada definidos en el nivel de estilo de tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100730393572305116)
,p_name=>'LAYOUT.T_#TOP_GLOBAL_NAVIGATION_LIST#'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Navegaci\00F3n (Superior)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100057033542304568)
,p_name=>'LAYOUT.T_#TRIGGERING_ELEMENT#'
,p_message_language=>'es'
,p_message_text=>'Elemento Disparador (por ejemplo, el elemento DOM actual)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99670023820304271)
,p_name=>'LAYOUT.T_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100260200931304762)
,p_name=>'LAYOUT.T_AFFECTED_ELEMENTS'
,p_message_language=>'es'
,p_message_text=>'Elementos Afectados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99667004575304269)
,p_name=>'LAYOUT.T_ALT_APPLICATION_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('Separadores de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99663073793304266)
,p_name=>'LAYOUT.T_ALT_ARROW_DOWN'
,p_message_language=>'es'
,p_message_text=>'inactivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99666681991304268)
,p_name=>'LAYOUT.T_ALT_BODY_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de Cuerpo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99662421721304265)
,p_name=>'LAYOUT.T_ALT_BRANCH'
,p_message_language=>'es'
,p_message_text=>unistr('crear bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99663150899304266)
,p_name=>'LAYOUT.T_ALT_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('crear bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99665794384304268)
,p_name=>'LAYOUT.T_ALT_CHANGE'
,p_message_language=>'es'
,p_message_text=>'Cambiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99664845797304267)
,p_name=>'LAYOUT.T_ALT_CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99667173352304269)
,p_name=>'LAYOUT.T_ALT_COMPANY_IMG'
,p_message_language=>'es'
,p_message_text=>unistr('Im\00E1genes de Espacio de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99662248551304265)
,p_name=>'LAYOUT.T_ALT_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('crear c\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99665471616304267)
,p_name=>'LAYOUT.T_ALT_COPY'
,p_message_language=>'es'
,p_message_text=>'Copiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99664630947304267)
,p_name=>'LAYOUT.T_ALT_CREATE'
,p_message_language=>'es'
,p_message_text=>'Crear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99664737363304267)
,p_name=>'LAYOUT.T_ALT_CREATE2'
,p_message_language=>'es'
,p_message_text=>'Crear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99665353835304267)
,p_name=>'LAYOUT.T_ALT_DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99664486576304267)
,p_name=>'LAYOUT.T_ALT_EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99664566418304267)
,p_name=>'LAYOUT.T_ALT_EXPAND'
,p_message_language=>'es'
,p_message_text=>'Ampliar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99665143798304267)
,p_name=>'LAYOUT.T_ALT_FORM_CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cierre de Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99665042960304267)
,p_name=>'LAYOUT.T_ALT_FORM_OPEN'
,p_message_language=>'es'
,p_message_text=>'Apertura de Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99666275348304268)
,p_name=>'LAYOUT.T_ALT_GLOBAL_NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Notificaci\00F3n Global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99665284693304267)
,p_name=>'LAYOUT.T_ALT_HELP'
,p_message_language=>'es'
,p_message_text=>'Ayuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99663237967304266)
,p_name=>'LAYOUT.T_ALT_ITEM'
,p_message_language=>'es'
,p_message_text=>'crear elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99666006160304268)
,p_name=>'LAYOUT.T_ALT_NAV_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99665536494304267)
,p_name=>'LAYOUT.T_ALT_NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99666117656304268)
,p_name=>'LAYOUT.T_ALT_NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99666954111304268)
,p_name=>'LAYOUT.T_ALT_PARENT_TAB'
,p_message_language=>'es'
,p_message_text=>'Separadores Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99665619956304268)
,p_name=>'LAYOUT.T_ALT_PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99662156383304265)
,p_name=>'LAYOUT.T_ALT_PROCESS'
,p_message_language=>'es'
,p_message_text=>'crear proceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99662061562304265)
,p_name=>'LAYOUT.T_ALT_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('crear regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99664941120304267)
,p_name=>'LAYOUT.T_ALT_REGION_BODY'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99666746891304268)
,p_name=>'LAYOUT.T_ALT_REGION_POSITION'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99664383880304267)
,p_name=>'LAYOUT.T_ALT_REGION_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de la Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99666856658304268)
,p_name=>'LAYOUT.T_ALT_STD_TAB'
,p_message_language=>'es'
,p_message_text=>'Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99666457514304268)
,p_name=>'LAYOUT.T_ALT_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'Mensaje Correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99666381108304268)
,p_name=>'LAYOUT.T_ALT_TEMPLATE_BODY'
,p_message_language=>'es'
,p_message_text=>'Cuerpo de Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99666526509304268)
,p_name=>'LAYOUT.T_ALT_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99662363904304265)
,p_name=>'LAYOUT.T_ALT_VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('crear validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99661952797304265)
,p_name=>'LAYOUT.T_ALT_WARNING'
,p_message_language=>'es'
,p_message_text=>'advertencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100107330611304607)
,p_name=>'LAYOUT.T_AUTHORIZATION_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100727600827305114)
,p_name=>'LAYOUT.T_BC_LABEL_ESC_SC'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de Ruta de Navegaci\00F3n (caracteres HTML de escape)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100317948006304805)
,p_name=>'LAYOUT.T_BIND_EVENT_TYPE'
,p_message_language=>'es'
,p_message_text=>'Evento When'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99667532639304269)
,p_name=>'LAYOUT.T_BODY'
,p_message_language=>'es'
,p_message_text=>'Cuerpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99554882276304185)
,p_name=>'LAYOUT.T_BRANCH2'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99660390783304264)
,p_name=>'LAYOUT.T_BRANCHING'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100108713581304608)
,p_name=>'LAYOUT.T_BRANCH_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n de Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99644868720304252)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcar a Funci\00F3n que Devuelve una P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99644972827304252)
,p_name=>'LAYOUT.T_BRANCH_TO_FUNCTION_RETURNING_URL'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcar a Funci\00F3n que Devuelve una URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99644531745304252)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_ACCEPT'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcar a Aceptaci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99644611061304252)
,p_name=>'LAYOUT.T_BRANCH_TO_PAGE_IDENTIFIED_BY_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcar a P\00E1gina Identificada por Elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99670548587304271)
,p_name=>'LAYOUT.T_BRANCH_TO_PG'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99645021297304252)
,p_name=>'LAYOUT.T_BRANCH_TO_PLSQL'
,p_message_language=>'es'
,p_message_text=>'Bifurcar a Procedimiento PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99644733990304252)
,p_name=>'LAYOUT.T_BRANCH_TO_URL_IDENTIFIED_BY_ITEM'
,p_message_language=>'es'
,p_message_text=>'Bifurcar a URL Identificada por Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100107421234304607)
,p_name=>'LAYOUT.T_BUILD_OPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Opci\00F3n de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99659001973304263)
,p_name=>'LAYOUT.T_BUTTON'
,p_message_language=>'es'
,p_message_text=>'Botones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99670400868304271)
,p_name=>'LAYOUT.T_BUTTON2'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100108110940304607)
,p_name=>'LAYOUT.T_BUTTON_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100286319168304781)
,p_name=>'LAYOUT.T_BUTTON_EXECUTE_VAL'
,p_message_language=>'es'
,p_message_text=>'Ejecutar Validaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99663952083304266)
,p_name=>'LAYOUT.T_BUTTON_W_NO_REGION'
,p_message_language=>'es'
,p_message_text=>'Botones sin regiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100108590377304608)
,p_name=>'LAYOUT.T_CHART_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Consulta de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100108475460304608)
,p_name=>'LAYOUT.T_COLUMN_HEADING'
,p_message_language=>'es'
,p_message_text=>'Cabecera de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100727441155305114)
,p_name=>'LAYOUT.T_COMPONENT_CSS_CLASSES'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de Componente'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99659295348304263)
,p_name=>'LAYOUT.T_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99671158281304272)
,p_name=>'LAYOUT.T_COMPUTATION2'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99659335771304263)
,p_name=>'LAYOUT.T_COMPUTATION_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina 0 no soporta c\00E1lculos. Los c\00E1lculos que se deben realizar en cada p\00E1gina los deben manejar los c\00E1lculos de nivel de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100107864731304607)
,p_name=>'LAYOUT.T_COMPUTATION_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99670150501304271)
,p_name=>'LAYOUT.T_CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('condici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100107164961304607)
,p_name=>'LAYOUT.T_CONDITION_EXPR1'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100107298589304607)
,p_name=>'LAYOUT.T_CONDITION_EXPR2'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100107049902304607)
,p_name=>'LAYOUT.T_CONDITION_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Condici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99657329526304262)
,p_name=>'LAYOUT.T_COPY_BUTTON'
,p_message_language=>'es'
,p_message_text=>'Copiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99657111287304261)
,p_name=>'LAYOUT.T_CREATE_BUTTON'
,p_message_language=>'es'
,p_message_text=>'Crear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100725592170305113)
,p_name=>'LAYOUT.T_CURRENT_PROGRESS'
,p_message_language=>'es'
,p_message_text=>'Texto derivado del mensaje de texto interno <em>APEX.CURRENT_PROGRESS</em> (valores por defecto definidos en <em>Progreso Actual</em>).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99668041522304269)
,p_name=>'LAYOUT.T_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99670394144304271)
,p_name=>'LAYOUT.T_DISPLAY'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100108288192304607)
,p_name=>'LAYOUT.T_DISPLAY_AS'
,p_message_language=>'es'
,p_message_text=>'Mostrar como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99658886040304263)
,p_name=>'LAYOUT.T_DISPLAY_PT'
,p_message_language=>'es'
,p_message_text=>unistr('Punto&nbsp;de:&nbsp;Visualizaci\00F3n:&nbsp;')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100656417272305057)
,p_name=>'LAYOUT.T_DYNAMIC_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acciones Din\00E1micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99657202338304262)
,p_name=>'LAYOUT.T_EDIT_BUTTON'
,p_message_language=>'es'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99554715922304185)
,p_name=>'LAYOUT.T_EDIT_PAGE_IN_BUILDER'
,p_message_language=>'es'
,p_message_text=>unistr('Editar P\00E1gina en Creador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99642436593304250)
,p_name=>'LAYOUT.T_EDIT_REGION_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Atributos de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99643096978304251)
,p_name=>'LAYOUT.T_ERROR_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Errores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99670259947304271)
,p_name=>'LAYOUT.T_EXP'
,p_message_language=>'es'
,p_message_text=>'exp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99661851064304265)
,p_name=>'LAYOUT.T_FLOW_NO_BRANCHING'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99661540110304265)
,p_name=>'LAYOUT.T_FLOW_NO_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn c\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99661331250304265)
,p_name=>'LAYOUT.T_FLOW_NO_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha seleccionado ninguna p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99661697770304265)
,p_name=>'LAYOUT.T_FLOW_NO_PROCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn Proceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99661472962304265)
,p_name=>'LAYOUT.T_FLOW_NO_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99661736522304265)
,p_name=>'LAYOUT.T_FLOW_NO_VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99667675513304269)
,p_name=>'LAYOUT.T_FOOTER_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99668964622304270)
,p_name=>'LAYOUT.T_FORM_CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cierre de Pantalla HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99668477259304270)
,p_name=>'LAYOUT.T_FORM_OPEN'
,p_message_language=>'es'
,p_message_text=>'Apertura de Pantalla HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99667961239304269)
,p_name=>'LAYOUT.T_FROM'
,p_message_language=>'es'
,p_message_text=>'De'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99659839451304263)
,p_name=>'LAYOUT.T_GLOBAL_PAGE_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina global no soporta bifurcaciones, c\00E1lculos, procesos ni validaciones. Los c\00E1lculos y procesos que se producen en cada p\00E1gina deben estar manejados por los c\00E1lculos y procesos de nivel de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100320392792304806)
,p_name=>'LAYOUT.T_GRID_COLUMN_NO'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Cuadr\00EDcula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100039248461304554)
,p_name=>'LAYOUT.T_GRID_COLUMN_SPAN'
,p_message_language=>'es'
,p_message_text=>unistr('Ampliaci\00F3n de Columna de Cuadr\00EDcula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99667424250304269)
,p_name=>'LAYOUT.T_HEADER_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99642805788304251)
,p_name=>'LAYOUT.T_INLINE'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99642720901304251)
,p_name=>'LAYOUT.T_INLINE_PLUS_NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea+Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99658032840304262)
,p_name=>'LAYOUT.T_INVALID_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla no v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99659181641304263)
,p_name=>'LAYOUT.T_ITEM'
,p_message_language=>'es'
,p_message_text=>'Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99991230382304518)
,p_name=>'LAYOUT.T_ITEM2'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99664243548304267)
,p_name=>'LAYOUT.T_ITEM_EXCEEDS_MAX'
,p_message_language=>'es'
,p_message_text=>unistr('El recuento de elementos excede el m\00E1ximo de 200.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100108338693304608)
,p_name=>'LAYOUT.T_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99528502577304162)
,p_name=>'LAYOUT.T_LISTS'
,p_message_language=>'es'
,p_message_text=>'Listas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100711811462305102)
,p_name=>'LAYOUT.T_LIST_ID'
,p_message_language=>'es'
,p_message_text=>unistr('ID de Lista \00DAnico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99643199297304251)
,p_name=>'LAYOUT.T_LOCATION'
,p_message_language=>'es'
,p_message_text=>unistr('Ubicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99687162525304283)
,p_name=>'LAYOUT.T_LOV'
,p_message_language=>'es'
,p_message_text=>'Listas de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99528459728304162)
,p_name=>'LAYOUT.T_MENUS'
,p_message_language=>'es'
,p_message_text=>unistr('Rutas de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100320427797304806)
,p_name=>'LAYOUT.T_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99670798932304271)
,p_name=>'LAYOUT.T_NAVIGATE_TO_PG'
,p_message_language=>'es'
,p_message_text=>unistr('Navega a la p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99661064312304264)
,p_name=>'LAYOUT.T_NAV_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barra&nbsp;de&nbsp;Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99986258084304514)
,p_name=>'LAYOUT.T_NAV_LISTS'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99645422928304253)
,p_name=>'LAYOUT.T_NEVER'
,p_message_language=>'es'
,p_message_text=>'nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100038942397304554)
,p_name=>'LAYOUT.T_NEW_GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Iniciar Nueva Cuadr\00EDcula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100039175611304554)
,p_name=>'LAYOUT.T_NEW_GRID_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Iniciar Nueva Columna de Cuadr\00EDcula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100039055112304554)
,p_name=>'LAYOUT.T_NEW_GRID_ROW'
,p_message_language=>'es'
,p_message_text=>unistr('Iniciar Nueva Fila de Cuadr\00EDcula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99667328682304269)
,p_name=>'LAYOUT.T_NO'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99645166476304253)
,p_name=>'LAYOUT.T_NONE'
,p_message_language=>'es'
,p_message_text=>'ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99642912704304251)
,p_name=>'LAYOUT.T_NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99668509604304270)
,p_name=>'LAYOUT.T_NOTIFICATION_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Mensaje de Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99660479811304264)
,p_name=>'LAYOUT.T_NO_BRANCHING'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina "%0" no tiene ninguna bifurcaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99664079642304266)
,p_name=>'LAYOUT.T_NO_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina "%0" no tiene ning\00FAn bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99664113340304267)
,p_name=>'LAYOUT.T_NO_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina "%0" no tiene ning\00FAn elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99528707859304162)
,p_name=>'LAYOUT.T_NO_LISTS'
,p_message_language=>'es'
,p_message_text=>'No se ha utilizado ninguna lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99687207294304283)
,p_name=>'LAYOUT.T_NO_LOV'
,p_message_language=>'es'
,p_message_text=>'No se han utilizado listas de valores compartidas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99528885762304162)
,p_name=>'LAYOUT.T_NO_MENUS'
,p_message_language=>'es'
,p_message_text=>unistr('No se han utilizado rutas de navegaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99661131881304264)
,p_name=>'LAYOUT.T_NO_NAV_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n "%0" no tiene ninguna barra de navegaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99659558375304263)
,p_name=>'LAYOUT.T_NO_ONLOAD_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina "%0" no tiene ning\00FAn c\00E1lculo de carga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99659724476304263)
,p_name=>'LAYOUT.T_NO_ONLOAD_PROCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina "%0" no tiene ning\00FAn proceso de carga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99659950300304263)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina "%0" no tiene ning\00FAn c\00E1lculo de ejecuci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99660228472304264)
,p_name=>'LAYOUT.T_NO_ONSUBMIT_PROCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina "%0" no tiene ning\00FAn proceso de ejecuci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99656979667304261)
,p_name=>'LAYOUT.T_NO_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha seleccionado ninguna p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99660654621304264)
,p_name=>'LAYOUT.T_NO_PARENT_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn separador de nivel principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99658936657304263)
,p_name=>'LAYOUT.T_NO_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina "%0" no tiene ninguna regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99660937706304264)
,p_name=>'LAYOUT.T_NO_TAB_SET'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina %0 no tiene ning\00FAn juego de separadores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99687318499304283)
,p_name=>'LAYOUT.T_NO_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha utilizado ninguna plantilla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99660171451304264)
,p_name=>'LAYOUT.T_NO_VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina "%0" no tiene ninguna validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99642526888304251)
,p_name=>'LAYOUT.T_NUMBER_OF_ITEMS'
,p_message_language=>'es'
,p_message_text=>'%0 Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99657060467304261)
,p_name=>'LAYOUT.T_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99657839282304262)
,p_name=>'LAYOUT.T_PAGE_ALIAS'
,p_message_language=>'es'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99658481515304262)
,p_name=>'LAYOUT.T_PAGE_AUTHENTICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99658299194304262)
,p_name=>'LAYOUT.T_PAGE_AUTHORIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99668796535304270)
,p_name=>'LAYOUT.T_PAGE_BODY'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99668813209304270)
,p_name=>'LAYOUT.T_PAGE_BODY_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de Cuerpo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99658331471304262)
,p_name=>'LAYOUT.T_PAGE_BUILD_OPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Opci\00F3n de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99668394467304269)
,p_name=>'LAYOUT.T_PAGE_HEAD'
,p_message_language=>'es'
,p_message_text=>unistr('Cabecera de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99657693463304262)
,p_name=>'LAYOUT.T_PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99657508520304262)
,p_name=>'LAYOUT.T_PAGE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99668140971304269)
,p_name=>'LAYOUT.T_PAGE_ONLOAD'
,p_message_language=>'es'
,p_message_text=>unistr('Carga de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99658538945304262)
,p_name=>'LAYOUT.T_PAGE_PUBLIC'
,p_message_language=>'es'
,p_message_text=>unistr('P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99658636391304263)
,p_name=>'LAYOUT.T_PAGE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Necesario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99658102567304262)
,p_name=>'LAYOUT.T_PAGE_TABSET'
,p_message_language=>'es'
,p_message_text=>unistr('J. Separadores Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99657979759304262)
,p_name=>'LAYOUT.T_PAGE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99657743729304262)
,p_name=>'LAYOUT.T_PAGE_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99668231074304269)
,p_name=>'LAYOUT.T_PAGE_TITLE2'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99660524979304264)
,p_name=>'LAYOUT.T_PARENT_TAB'
,p_message_language=>'es'
,p_message_text=>'Separadores Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99659612911304263)
,p_name=>'LAYOUT.T_PROCESS'
,p_message_language=>'es'
,p_message_text=>'Procesos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99671031589304271)
,p_name=>'LAYOUT.T_PROCESS2'
,p_message_language=>'es'
,p_message_text=>'Proceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99659457214304263)
,p_name=>'LAYOUT.T_PROCESS_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina 0 no soporta los procesos. Los procesos de nivel de la aplicaci\00F3n deben manejar los procesos que se deben producir en cada p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100108677429304608)
,p_name=>'LAYOUT.T_PROCESS_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Proceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99670635771304271)
,p_name=>'LAYOUT.T_REDIRECT_TO_PG'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99667853243304269)
,p_name=>'LAYOUT.T_REFERENCED'
,p_message_language=>'es'
,p_message_text=>'Con Referencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100727510803305114)
,p_name=>'LAYOUT.T_REFERENCED_FROM'
,p_message_language=>'es'
,p_message_text=>'Referencia desde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99658772495304263)
,p_name=>'LAYOUT.T_REGION'
,p_message_language=>'es'
,p_message_text=>'Regiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99671494645304272)
,p_name=>'LAYOUT.T_REGION2'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99979777888304509)
,p_name=>'LAYOUT.T_REGION_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>unistr('Atributos de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99518997212304155)
,p_name=>'LAYOUT.T_REGION_CSS_CLASSES'
,p_message_language=>'es'
,p_message_text=>unistr('Clases CSS de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99978519790304508)
,p_name=>'LAYOUT.T_REGION_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador de Regi\00F3n \00DAnico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100037818384304553)
,p_name=>'LAYOUT.T_REGION_POS'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99669040603304270)
,p_name=>'LAYOUT.T_REGION_POS1'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99973415299304504)
,p_name=>'LAYOUT.T_REGION_POS10'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99973597979304504)
,p_name=>'LAYOUT.T_REGION_POS11'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99973635692304504)
,p_name=>'LAYOUT.T_REGION_POS12'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99973770315304505)
,p_name=>'LAYOUT.T_REGION_POS13'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99973826848304505)
,p_name=>'LAYOUT.T_REGION_POS14'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99973949951304505)
,p_name=>'LAYOUT.T_REGION_POS15'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99974063051304505)
,p_name=>'LAYOUT.T_REGION_POS16'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99669160794304270)
,p_name=>'LAYOUT.T_REGION_POS2'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99669259566304270)
,p_name=>'LAYOUT.T_REGION_POS3'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99669390723304270)
,p_name=>'LAYOUT.T_REGION_POS4'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99669470337304270)
,p_name=>'LAYOUT.T_REGION_POS5'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99669532385304270)
,p_name=>'LAYOUT.T_REGION_POS6'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 6')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99669690183304270)
,p_name=>'LAYOUT.T_REGION_POS7'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 7')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99669715606304270)
,p_name=>'LAYOUT.T_REGION_POS8'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 8')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99973309622304504)
,p_name=>'LAYOUT.T_REGION_POS9'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99978670681304508)
,p_name=>'LAYOUT.T_REGION_STATIC_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador Est\00E1tico de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100320249401304806)
,p_name=>'LAYOUT.T_REGION_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99645302996304253)
,p_name=>'LAYOUT.T_STANDARD_CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('condici\00F3n est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99660778795304264)
,p_name=>'LAYOUT.T_STD_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('Separadores&nbsp;Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99667747966304269)
,p_name=>'LAYOUT.T_SUBSTITUTION'
,p_message_language=>'es'
,p_message_text=>unistr('Sustituci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99979301186304509)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Subregiones: Plantilla de Entrada de Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99979455039304509)
,p_name=>'LAYOUT.T_SUB_PLUG_HEADER_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Subregiones: Plantilla de Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99979268950304509)
,p_name=>'LAYOUT.T_SUB_PLUG_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Subregiones: Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99979056619304509)
,p_name=>'LAYOUT.T_SUB_REGIONS'
,p_message_language=>'es'
,p_message_text=>'Subregiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99979182095304509)
,p_name=>'LAYOUT.T_SUB_REGION_HEADERS'
,p_message_language=>'es'
,p_message_text=>unistr('Cabeceras de Subregi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99978945636304509)
,p_name=>'LAYOUT.T_SUB_REGION_HEADER_ENTRIES'
,p_message_language=>'es'
,p_message_text=>unistr('Entradas de Cabecera de Subregi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99978796449304508)
,p_name=>'LAYOUT.T_SUB_REGION_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador Est\00E1tico de Subregi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99978862598304508)
,p_name=>'LAYOUT.T_SUB_REGION_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de Subregi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99668664616304270)
,p_name=>'LAYOUT.T_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'Mensaje Correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99528295033304162)
,p_name=>'LAYOUT.T_TABULAR_FORM'
,p_message_language=>'es'
,p_message_text=>'Pantalla Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99660844916304264)
,p_name=>'LAYOUT.T_TAB_SET'
,p_message_language=>'es'
,p_message_text=>'Juego de Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99665872818304268)
,p_name=>'LAYOUT.T_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99686430065304283)
,p_name=>'LAYOUT.T_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99662935746304266)
,p_name=>'LAYOUT.T_TITLE_CREATE_BRANCH'
,p_message_language=>'es'
,p_message_text=>unistr('crear bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99663457834304266)
,p_name=>'LAYOUT.T_TITLE_CREATE_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('crear bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99662614111304265)
,p_name=>'LAYOUT.T_TITLE_CREATE_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('crear c\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99663616164304266)
,p_name=>'LAYOUT.T_TITLE_CREATE_ITEM'
,p_message_language=>'es'
,p_message_text=>'crear elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99662782693304266)
,p_name=>'LAYOUT.T_TITLE_CREATE_PROCESS'
,p_message_language=>'es'
,p_message_text=>'crear proceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99662589104304265)
,p_name=>'LAYOUT.T_TITLE_CREATE_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('crear regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99662812986304266)
,p_name=>'LAYOUT.T_TITLE_CREATE_VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('crear validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99663590459304266)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('editar bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99663757188304266)
,p_name=>'LAYOUT.T_TITLE_EDIT_BUTTON_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('editar elemento de bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99663801155304266)
,p_name=>'LAYOUT.T_TITLE_EDIT_ITEM'
,p_message_language=>'es'
,p_message_text=>'editar elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99663323853304266)
,p_name=>'LAYOUT.T_TITLE_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('t\00EDtulo de regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100108063073304607)
,p_name=>'LAYOUT.T_TRIGGERING_CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n When')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100107950429304607)
,p_name=>'LAYOUT.T_TRIGGERING_ELEMENT'
,p_message_language=>'es'
,p_message_text=>'Elemento When'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99645228063304253)
,p_name=>'LAYOUT.T_UNCONDITIONAL'
,p_message_language=>'es'
,p_message_text=>'Incondicional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99660027997304264)
,p_name=>'LAYOUT.T_VALIDATION'
,p_message_language=>'es'
,p_message_text=>'Validaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99670901087304271)
,p_name=>'LAYOUT.T_VALIDATION2'
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100286273211304781)
,p_name=>'LAYOUT.T_VALIDATION_ALWAYS_EXEC'
,p_message_language=>'es'
,p_message_text=>'Ejecutar Siempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100107603009304607)
,p_name=>'LAYOUT.T_VALIDATION_EXPR1'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n de Validaci\00F3n 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100107789074304607)
,p_name=>'LAYOUT.T_VALIDATION_EXPR2'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n de Validaci\00F3n 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100107575260304607)
,p_name=>'LAYOUT.T_VALIDATION_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99657459107304262)
,p_name=>'LAYOUT.T_VIEW_BUTTON'
,p_message_language=>'es'
,p_message_text=>'Ver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100106922357304606)
,p_name=>'LAYOUT.T_WHEN_BUTTON_PRESSED'
,p_message_language=>'es'
,p_message_text=>unistr('Si Se Hace Clic en el Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99667213578304269)
,p_name=>'LAYOUT.T_YES'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99825997618304385)
,p_name=>'LAYOUT.UPDATABLE_SQL_QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL Actualizable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99787969273304357)
,p_name=>'LAYOUT.USE_APP_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Valor por Defecto de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100104243654304604)
,p_name=>'LAYOUT.VALIDATING'
,p_message_language=>'es'
,p_message_text=>'Validando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99784905786304355)
,p_name=>'LAYOUT_NEVER'
,p_message_language=>'es'
,p_message_text=>'Nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99827641027304386)
,p_name=>'LAYOUT_RUN'
,p_message_language=>'es'
,p_message_text=>'Ejecutar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100032100338304549)
,p_name=>'LDAP USERNAME EDIT FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n de Edici\00F3n de Nombre de Usuario de LDAP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99544584082304177)
,p_name=>'LDAP_AUTH_SCHEME_DESC'
,p_message_language=>'es'
,p_message_text=>'LDAP'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99562904986304192)
,p_name=>'LEARN MORE'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s Informaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99680889242304278)
,p_name=>'LEARN_MORE_APEX_HOME'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s informaci\00F3n sobre Oracle APEX')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99680629037304278)
,p_name=>'LEARN_MORE_APP_BUILDER'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s informaci\00F3n sobre el creador de aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99689400770304285)
,p_name=>'LEARN_MORE_PAGE_DESIGNER'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s informaci\00F3n sobre el dise\00F1ador de p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99680730824304278)
,p_name=>'LEARN_MORE_PROD_APPS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s informaci\00F3n sobre las aplicaciones de productividad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99680557653304278)
,p_name=>'LEARN_MORE_SQL_WORKSHOP'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s informaci\00F3n sobre el taller de SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100285615931304781)
,p_name=>'LEARN_WEBSHEETS'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic aqu\00ED para obtener informaci\00F3n sobre las hojas web')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100094701272304597)
,p_name=>'LEFT'
,p_message_language=>'es'
,p_message_text=>'Izquierda'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100739161045305123)
,p_name=>'LEGACY_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario Heredado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99569631671304197)
,p_name=>'LINES'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDneas')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100334959080304817)
,p_name=>'LINK'
,p_message_language=>'es'
,p_message_text=>'Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99605460239304223)
,p_name=>'LINK$'
,p_message_language=>'es'
,p_message_text=>'enlace de columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100006683959304530)
,p_name=>'LINKS'
,p_message_language=>'es'
,p_message_text=>'Enlaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100732634608305118)
,p_name=>'LINK_LABEL'
,p_message_language=>'es'
,p_message_text=>'Enlace: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100112266385304611)
,p_name=>'LINK_TO_THIS'
,p_message_language=>'es'
,p_message_text=>'Enlace a este %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99926302881304468)
,p_name=>'LINK_TO_THIS_PAGE_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('enlaza a este elemento de p\00E1gina %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99732438380304317)
,p_name=>'LIST'
,p_message_language=>'es'
,p_message_text=>'lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100031158790304548)
,p_name=>'LIST ITEM CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Elemento de Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100027670391304545)
,p_name=>'LIST OF VALUES'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99600989018304220)
,p_name=>'LISTVIEW'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100064952736304574)
,p_name=>'LISTVIEW_FORM_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'La vista de lista y pantalla se han creado correctamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100071356816304579)
,p_name=>'LIST_ENTRY'
,p_message_language=>'es'
,p_message_text=>'Entrada de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100771099834305146)
,p_name=>'LIST_ENTRY_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de Entrada de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100059410880304569)
,p_name=>'LIST_INITCAP'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100175806485304697)
,p_name=>'LIST_ITEMS'
,p_message_language=>'es'
,p_message_text=>'Elementos de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99976339452304506)
,p_name=>'LIST_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n de Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100039778232304555)
,p_name=>'LIST_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99752193970304331)
,p_name=>'LIST_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99787630259304357)
,p_name=>'LIST_UTILIZATION'
,p_message_language=>'es'
,p_message_text=>'Uso de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100065237070304574)
,p_name=>'LIST_VIEW_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>unistr('Atributos de la P\00E1gina de Vista de Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100065526134304574)
,p_name=>'LIST_VIEW_PAGE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de P\00E1gina de Vista de Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100065116594304574)
,p_name=>'LIST_VIEW_PAGE_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Vista de Lista')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100718194116305107)
,p_name=>'LOAD_DATA'
,p_message_language=>'es'
,p_message_text=>'Cargar Datos'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100114656934304612)
,p_name=>'LOCK'
,p_message_language=>'es'
,p_message_text=>'Bloquear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100202674581304717)
,p_name=>'LOCKED'
,p_message_language=>'es'
,p_message_text=>'Bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99900462992304448)
,p_name=>'LOCKED BY'
,p_message_language=>'es'
,p_message_text=>'Bloqueado por: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100720982911305109)
,p_name=>'LOCKED_DATE_BY_USER'
,p_message_language=>'es'
,p_message_text=>'%0 bloqueado por %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100721132707305109)
,p_name=>'LOCK_SCRIPT'
,p_message_language=>'es'
,p_message_text=>'Bloquear Script'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99912894240304458)
,p_name=>'LOG'
,p_message_language=>'es'
,p_message_text=>'Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100040617978304555)
,p_name=>'LOGGING'
,p_message_language=>'es'
,p_message_text=>'Registro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100109063253304608)
,p_name=>'LOGIN.REMEMBER_USERNAME'
,p_message_language=>'es'
,p_message_text=>'Recordar nombre de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100109144803304608)
,p_name=>'LOGIN.REMEMBER_USERNAME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si selecciona esta casilla de verificaci\00F3n, la aplicaci\00F3n guardar\00E1 su nombre de usuario en una cookie persistente del navegador denominada "LOGIN_USERNAME_COOKIE".'),
unistr('La pr\00F3xima vez que acceda a la p\00E1gina de conexi\00F3n,'),
unistr('el campo de nombre de usuario se rellenar\00E1 autom\00E1ticamente con este valor.'),
'</p>',
'<p>',
unistr('Si anula la selecci\00F3n de esta casilla de verificaci\00F3n y su nombre de usuario ya se ha guardado en la cookie,'),
unistr('la aplicaci\00F3n lo sobrescribir\00E1 con un valor vac\00EDo.'),
unistr('Tambi\00E9n puede utilizar las herramientas de desarrollador de su explorador para eliminar la cookie por completo.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100040400032304555)
,p_name=>'LOGIN_URL'
,p_message_language=>'es'
,p_message_text=>unistr('URL de Conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100040387762304555)
,p_name=>'LOGO'
,p_message_language=>'es'
,p_message_text=>'Logotipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100526771123304960)
,p_name=>'LOGO.DEFAULT.IMAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ning\00FAn juego de im\00E1genes.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100526852762304961)
,p_name=>'LOGO.DEFAULT.TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de logotipo de aplicaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100525220323304959)
,p_name=>'LOGO.EDITOR.APP.GROUP'
,p_message_language=>'es'
,p_message_text=>unistr('Logotipo de Aplicaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100525768398304960)
,p_name=>'LOGO.FILE.SIZE.EXCEEDED'
,p_message_language=>'es'
,p_message_text=>unistr('Este archivo supera el l\00EDmite admitido de %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100526215400304960)
,p_name=>'LOGO.LABEL.CUSTOM'
,p_message_language=>'es'
,p_message_text=>'La marca del logotipo personalizado se puede definir en el creador de aplicaciones.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100526139603304960)
,p_name=>'LOGO.LABEL.DRAG_AND_DROP'
,p_message_language=>'es'
,p_message_text=>'Arrastre y suelte archivos o haga clic para seleccionar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100526023870304960)
,p_name=>'LOGO.LABEL.IMAGE'
,p_message_language=>'es'
,p_message_text=>'Imagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100526399702304960)
,p_name=>'LOGO.LABEL.NONE'
,p_message_language=>'es'
,p_message_text=>unistr('No se mostrar\00E1 ning\00FAn logotipo para esta aplicaci\00F3n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100525970768304960)
,p_name=>'LOGO.LABEL.TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100525842157304960)
,p_name=>'LOGO.LABEL.TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100526599268304960)
,p_name=>'LOGO.MSG.IMAGE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Se necesita una imagen de logotipo para este tipo de logotipo.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100526626664304960)
,p_name=>'LOGO.MSG.SAVE_SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Logotipo guardado correctamente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100526486876304960)
,p_name=>'LOGO.MSG.TEXT_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Se necesita un texto de logotipo para este tipo de logotipo.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100525657688304960)
,p_name=>'LOGO.WRONG.MIME.TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Solo se permiten im\00E1genes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100707085661305099)
,p_name=>'LOG_FEEDBACK_AS_BUG_CONFIRM'
,p_message_language=>'es'
,p_message_text=>'Gracias por los comentarios, se ha creado un bug para este problema. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100708542992305100)
,p_name=>'LOG_FEEDBACK_AS_FEATURE_CONFIRM'
,p_message_language=>'es'
,p_message_text=>unistr('Gracias por los comentarios, se tendr\00E1 en cuenta esta solicitud para una futura versi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100331810912304815)
,p_name=>'LOG_FEEDBACK_AS_ISSUE_CONFIRM'
,p_message_language=>'es'
,p_message_text=>'Gracias por sus comentarios; se ha registrado una incidencia en nuestro sistema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100708747077305100)
,p_name=>'LOG_FEEDBACK_AS_TODO_CONFIRM'
,p_message_language=>'es'
,p_message_text=>'Gracias por los comentarios, se ha creado una tarea para abordar este problema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100736530245305121)
,p_name=>'LOG_IN'
,p_message_language=>'es'
,p_message_text=>'Conectar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99913719355304459)
,p_name=>'LOG_INTERVAL'
,p_message_language=>'es'
,p_message_text=>'Intervalo de Log'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100027538708304545)
,p_name=>'LOV ITEM CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Elemento de Lista de Valores')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99985499676304513)
,p_name=>'LOW_PRIORITY'
,p_message_language=>'es'
,p_message_text=>'Prioridad Baja'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99528605535304162)
,p_name=>'MANAGE PAGE GROUPS'
,p_message_language=>'es'
,p_message_text=>unistr('Gestionar Grupos de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100177342750304699)
,p_name=>'MANAGE SERVICE'
,p_message_language=>'es'
,p_message_text=>'Gestionar Servicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100177186135304698)
,p_name=>'MANAGE USERS'
,p_message_language=>'es'
,p_message_text=>'Gestionar Usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100176539519304698)
,p_name=>'MANAGE WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Gestionar Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100121086901304617)
,p_name=>'MANAGE_APPLICATION'
,p_message_language=>'es'
,p_message_text=>'Gestionar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99742692806304324)
,p_name=>'MANAGE_UNASSIGNED'
,p_message_language=>'es'
,p_message_text=>'Gestionar Elementos no Asignados'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99560111852304189)
,p_name=>'MANUAL'
,p_message_language=>'es'
,p_message_text=>'Manual'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99498582054304140)
,p_name=>'MAP_LAYER='
,p_message_language=>'es'
,p_message_text=>'Nivel='
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99499932961304141)
,p_name=>'MAP_LAYERS'
,p_message_language=>'es'
,p_message_text=>'Capas de mapas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99645844954304253)
,p_name=>'MAP_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'El mapa se ha creado correctamente.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99984674778304513)
,p_name=>'MARQUEE_FEATURE'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n marquee')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100058530628304569)
,p_name=>'MASTER'
,p_message_language=>'es'
,p_message_text=>'Maestro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100043897882304558)
,p_name=>'MASTERDETAIL_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Las p\00E1ginas maestras/de detalles se han creado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99497263091304139)
,p_name=>'MASTER_DETAIL'
,p_message_language=>'es'
,p_message_text=>'Maestro/Detalle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99497452362304139)
,p_name=>'MASTER_DETAIL_DETAIL'
,p_message_language=>'es'
,p_message_text=>'Detalles de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99497379178304139)
,p_name=>'MASTER_DETAIL_EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100110371678304609)
,p_name=>'MATERIALIZED_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista Materializada'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100006073776304529)
,p_name=>'MAXIMUM_RENDER_TIME_SECONDS'
,p_message_language=>'es'
,p_message_text=>unistr('Tiempo M\00E1ximo de Presentaci\00F3n (segundos)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100097297112304599)
,p_name=>'MAXIMUM_SESSION_IDLE_TIME'
,p_message_language=>'es'
,p_message_text=>unistr('Tiempo M\00E1ximo de Inactividad de Sesi\00F3n en Segundos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100097325261304599)
,p_name=>'MAXIMUM_SESSION_LENGTH'
,p_message_language=>'es'
,p_message_text=>unistr('Duraci\00F3n M\00E1xima de la Sesi\00F3n en Segundos')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99680345488304278)
,p_name=>'MAY_NOT_DELETE'
,p_message_language=>'es'
,p_message_text=>unistr('No se permite la supresi\00F3n de hitos con funciones asociadas.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99572588727304199)
,p_name=>'MEMORY'
,p_message_language=>'es'
,p_message_text=>'Memoria:'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99730822572304316)
,p_name=>'MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100031259249304548)
,p_name=>'MENU ITEM CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Elemento de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100040086846304555)
,p_name=>'MENU_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Ruta de Navegaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100273132199304771)
,p_name=>'MIGRATION FILES'
,p_message_language=>'es'
,p_message_text=>unistr('Archivos de Migraci\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100027177176304545)
,p_name=>'MILESTONE'
,p_message_language=>'es'
,p_message_text=>'Hito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100007150080304530)
,p_name=>'MILESTONES'
,p_message_language=>'es'
,p_message_text=>'Hitos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100463493592304913)
,p_name=>'MILLISECONDS_MS'
,p_message_language=>'es'
,p_message_text=>'ms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100009822398304532)
,p_name=>'MIME_TYPE_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de Tipo MIME'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99983117980304512)
,p_name=>'MINIMAL_IMPACT'
,p_message_language=>'es'
,p_message_text=>unistr('Impacto M\00EDnimo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99547659203304180)
,p_name=>'MIN_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n M\00EDnima')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100707623179305099)
,p_name=>'MISSING_AT_SIGN'
,p_message_language=>'es'
,p_message_text=>'Falta el signo @'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99930634979304472)
,p_name=>'MODEL_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99984815600304513)
,p_name=>'MODERATELY_DESIRABLE'
,p_message_language=>'es'
,p_message_text=>'Moderadamente Deseable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99983073480304512)
,p_name=>'MODERATE_IMPACT'
,p_message_language=>'es'
,p_message_text=>'Impacto Moderado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99669855432304271)
,p_name=>'MODIFIED_ATTRIBUTE'
,p_message_language=>'es'
,p_message_text=>'Indica un atributo modificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100110677157304609)
,p_name=>'MODIFY_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Modificar Columna %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99910359050304456)
,p_name=>'MONITOR'
,p_message_language=>'es'
,p_message_text=>'Controlar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100177232180304699)
,p_name=>'MONITOR ACTIVITY'
,p_message_language=>'es'
,p_message_text=>'Controlar Actividad'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100036482784304552)
,p_name=>'MORE_DOT_DOT_DOT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s...')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100005590082304529)
,p_name=>'MOST_ACTIVE_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 Aplicaciones m\00E1s Activas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100000555505304525)
,p_name=>'MOST_RECENT_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error m\00E1s reciente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100301161258304792)
,p_name=>'MOST_RECENT_FILE_UPLOAD'
,p_message_language=>'es'
,p_message_text=>unistr('El archivo m\00E1s reciente es %0 cargado por %1 %2')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99768900854304343)
,p_name=>'MRU.ERROR_IN_MRU'
,p_message_language=>'es'
,p_message_text=>'Error en MRU: Fila= %0, %1, %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99767853954304342)
,p_name=>'MRU.INVALID_PRIM_KEY_COL'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la columna de clave primaria identificada en la lista de selecci\00F3n de la consulta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99769067189304343)
,p_name=>'MRU.LOST_UPDATE'
,p_message_language=>'es'
,p_message_text=>unistr('La versi\00F3n actual de los datos de la base de datos ha cambiado desde que el usuario inici\00F3 el proceso de actualizaci\00F3n. total de control actual = "%0", total de control de elemento = "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99767339437304342)
,p_name=>'MRU.NO_ROWS_TO_PROCESS'
,p_message_language=>'es'
,p_message_text=>'No hay ninguna fila para procesar'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99685229948304282)
,p_name=>'MUST_BE_XSL'
,p_message_language=>'es'
,p_message_text=>unistr('Aseg\00FArese de que el tipo de archivo de dise\00F1o de informe es XSL-FO, utilizando ''.xsl'' como extensi\00F3n del archivo.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99594137509304215)
,p_name=>'MY_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Mi P\00E1gina')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100706581274305098)
,p_name=>'NAMES'
,p_message_language=>'es'
,p_message_text=>'Nombres'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100114536034304612)
,p_name=>'NAVBAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100027331850304545)
,p_name=>'NAVBAR ITEM CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Elemento de Barra de Navegaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100710129024305101)
,p_name=>'NAVIGATE_GO_TO_TOP'
,p_message_language=>'es'
,p_message_text=>'Ir al Principio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100025249708304544)
,p_name=>'NAVIGATION BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100040258078304555)
,p_name=>'NAVIGATION_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99528384582304162)
,p_name=>'NAVIGATION_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Navegaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99519758722304156)
,p_name=>'NAV_APP_BUILDER_HOME'
,p_message_language=>'es'
,p_message_text=>unistr('Navegar a la P\00E1gina Inicial del Creador de Aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100746328476305128)
,p_name=>'NAV_BAR_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Implantaci\00F3n: Lista %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100746215902305128)
,p_name=>'NAV_BAR_TRADITIONAL'
,p_message_language=>'es'
,p_message_text=>unistr('Implantaci\00F3n: Cl\00E1sica')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99995537220304521)
,p_name=>'NEEDS_REVIEW'
,p_message_language=>'es'
,p_message_text=>unistr('Necesita revisi\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99988690850304516)
,p_name=>'NEED_INFORMATION'
,p_message_language=>'es'
,p_message_text=>unistr('Se Necesita Informaci\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100006763333304530)
,p_name=>'NEWS_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas de Noticias'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100740076598305123)
,p_name=>'NEW_BIND_VARIABLE'
,p_message_language=>'es'
,p_message_text=>'Nuevo Valor para la Variable de Enlace %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99749618410304329)
,p_name=>'NEW_EMAIL_ADDRESS'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva direcci\00F3n de correo electr\00F3nico para la cuenta de Application Express.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99984135208304512)
,p_name=>'NEW_FEATURE_REQUEST'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva Solicitud de Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99916354944304461)
,p_name=>'NEW_OR_EXISTING'
,p_message_language=>'es'
,p_message_text=>'Nuevo o Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100092436100304595)
,p_name=>'NEW_SCHEMA_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Nuevo Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99999854601304524)
,p_name=>'NEW_SERVICE'
,p_message_language=>'es'
,p_message_text=>'Nuevo Servicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99730780922304316)
,p_name=>'NEW_TABSET'
,p_message_language=>'es'
,p_message_text=>'Nuevo Juego de Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100725374835305112)
,p_name=>'NEW_TOP_LEVEL'
,p_message_language=>'es'
,p_message_text=>unistr('- No se ha seleccionado ning\00FAn principal - ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100036756096304552)
,p_name=>'NEW_WORKSPACE_REQUEST'
,p_message_language=>'es'
,p_message_text=>'Solicitud de Nuevo Espacio de Trabajo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100044960398304558)
,p_name=>'NO CORRESPONDING REGION'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ninguna regi\00F3n correspondiente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99978299590304508)
,p_name=>'NO PRIMARY KEY'
,p_message_language=>'es'
,p_message_text=>'La tabla no tiene claves primarias definidas. Es necesaria una clave primaria al crear informes con pantallas. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99574303216304200)
,p_name=>'NOARCHIVELOG'
,p_message_language=>'es'
,p_message_text=>'Archivado de Logs: Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99969480582304501)
,p_name=>'NON CURRENT ENTRY'
,p_message_language=>'es'
,p_message_text=>'Entrada no Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100025003592304543)
,p_name=>'NON CURRENT TAB'
,p_message_language=>'es'
,p_message_text=>'Separador no Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100029565734304547)
,p_name=>'NONE_SPECIFIED'
,p_message_language=>'es'
,p_message_text=>'Sin Especificar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99717132532304306)
,p_name=>'NON_CURRENT_IMAGE'
,p_message_language=>'es'
,p_message_text=>'Imagen no Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100094149541304597)
,p_name=>'NON_PACKAGE'
,p_message_language=>'es'
,p_message_text=>unistr('-Aplicaci\00F3n que no es de productividad ni de ejemplo-')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99985389324304513)
,p_name=>'NORMAL_PRIORITY'
,p_message_language=>'es'
,p_message_text=>'Prioridad Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100707116136305099)
,p_name=>'NOT AVAILABLE'
,p_message_language=>'es'
,p_message_text=>'No disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100732596933305118)
,p_name=>'NOTE_LABEL'
,p_message_language=>'es'
,p_message_text=>'Nota: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99888303276304438)
,p_name=>'NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99982094284304511)
,p_name=>'NOT_A_BUG'
,p_message_language=>'es'
,p_message_text=>'No es un bug'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100739073712305123)
,p_name=>'NOT_CURRENT'
,p_message_language=>'es'
,p_message_text=>'No Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99985047467304513)
,p_name=>'NOT_DESIRABLE'
,p_message_language=>'es'
,p_message_text=>'No Deseable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100034670775304551)
,p_name=>'NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'No Existe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99589906458304212)
,p_name=>'NOT_EXISTS_SQL_QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL NOT EXISTS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99982160822304511)
,p_name=>'NOT_FEASIBLE_TO_FIX'
,p_message_language=>'es'
,p_message_text=>unistr('No es factible la correcci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100114332067304612)
,p_name=>'NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'no se ha encontrado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100745728236305128)
,p_name=>'NOT_FUNCTIONALLY_COMPLETE'
,p_message_language=>'es'
,p_message_text=>'80% o menos terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100047484177304560)
,p_name=>'NOT_INSTALLED'
,p_message_language=>'es'
,p_message_text=>'No Instalado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99730684932304315)
,p_name=>'NOT_IN_DATA_DICT'
,p_message_language=>'es'
,p_message_text=>unistr('No Est\00E1 en el Diccionario de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99985798228304514)
,p_name=>'NOT_PRIORITIZED'
,p_message_language=>'es'
,p_message_text=>'No Priorizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99983572772304512)
,p_name=>'NOT_PRORITIZED'
,p_message_language=>'es'
,p_message_text=>'No Priorizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100029711698304547)
,p_name=>'NOT_PROVIDED'
,p_message_language=>'es'
,p_message_text=>'No Proporcionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100305430116304795)
,p_name=>'NOT_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'No Necesario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99988416178304516)
,p_name=>'NOT_STARTED'
,p_message_language=>'es'
,p_message_text=>'No Iniciado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100066933902304575)
,p_name=>'NOT_VALID_VIEW_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('<strong>%0</strong> no es un nombre de vista v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99547186246304180)
,p_name=>'NO_APPLICATIONS_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ninguna aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100050681750304563)
,p_name=>'NO_APPLICATION_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha seleccionado ninguna aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99825206439304384)
,p_name=>'NO_ARGUMENTS_ALLOWED'
,p_message_language=>'es'
,p_message_text=>'No se Permiten Argumentos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99981147226304510)
,p_name=>'NO_ASSIGNED_PRIORITY'
,p_message_language=>'es'
,p_message_text=>'Sin Prioridad Asignada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99592957841304214)
,p_name=>'NO_AUTHORIZATION_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('ning\00FAn esquema de autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100029940986304547)
,p_name=>'NO_AVAIL_JOBS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('No hay ning\00FAn proceso de cola de trabajos de la base de datos disponible. P\00F3ngase en contacto con el<br> administrador para aumentar el par\00E1metro de inicializaci\00F3n JOB_QUEUE_PROCESSES <br>'),
unistr('o espere a que terminen los dem\00E1s trabajos.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99903837415304451)
,p_name=>'NO_BREADCRUMB_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ninguna plantilla de ruta de navegaci\00F3n en el tema. Se necesita al menos una plantilla de ruta de navegaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99903910002304451)
,p_name=>'NO_BUTTON_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ninguna plantilla de bot\00F3n en el tema. Se necesita al menos una plantilla de bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99903453507304450)
,p_name=>'NO_CALENDAR_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna plantilla de calendario en el tema. Se necesita al menos una plantilla de calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99679437193304277)
,p_name=>'NO_DATE_SPECIFIED'
,p_message_language=>'es'
,p_message_text=>'Ninguna fecha especificada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99929200402304471)
,p_name=>'NO_DEBUG'
,p_message_language=>'es'
,p_message_text=>unistr('Sin Depuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99541353936304172)
,p_name=>'NO_DEVELOPER_PRIV'
,p_message_language=>'es'
,p_message_text=>'Sin Privilegio de Desarrollador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99602700747304221)
,p_name=>'NO_DISPLAY_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('- Ninguna Visualizaci\00F3n -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99557883256304188)
,p_name=>'NO_FEATURES_TARGETED'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna funci\00F3n de destino')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99901449347304449)
,p_name=>'NO_HELP_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ayuda disponible para este elemento de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100766424904305143)
,p_name=>'NO_ICON_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn icono')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99651670334304257)
,p_name=>'NO_IMAGES_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99888693287304438)
,p_name=>'NO_IMAGE_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99733009360304317)
,p_name=>'NO_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('ning\00FAn elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100094606262304597)
,p_name=>'NO_JOB_QUEUE_PROCESSES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Los procesos de cola de trabajos de base de datos no est\00E1n activados. P\00F3ngase en contacto con el<br>'),
unistr('administrador para definir el par\00E1metro de inicializaci\00F3n JOB_QUEUE_PROCESSES.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99903554592304450)
,p_name=>'NO_LABEL_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna plantilla de etiqueta en el tema. Se necesita al menos una plantilla de etiqueta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99635271819304245)
,p_name=>'NO_LAYOUT'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn dise\00F1o de informe seleccionado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99903732438304451)
,p_name=>'NO_LIST_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna plantilla de lista en el tema. Se necesita al menos una plantilla de lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99984388089304513)
,p_name=>'NO_LONGER_AN_ISSUE'
,p_message_language=>'es'
,p_message_text=>'Ya no es un problema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99592769406304214)
,p_name=>'NO_LOV'
,p_message_language=>'es'
,p_message_text=>'Ninguna lista de valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100028261942304546)
,p_name=>'NO_MILESTONES_EXIST'
,p_message_language=>'es'
,p_message_text=>'No se han definido hitos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100254912331304758)
,p_name=>'NO_NAVIGATION_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('No Mostrar Lista de Men\00FA de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99635141640304245)
,p_name=>'NO_PAGE_DEV_PRIV'
,p_message_language=>'es'
,p_message_text=>unistr('El desarrollador no tiene privilegios para crear un componente en esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99904144440304451)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha intentado copiar el tema pero no se ha encontrado ninguna plantilla de p\00E1gina en la aplicaci\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99903287947304450)
,p_name=>'NO_PAGE_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ninguna plantilla de p\00E1gina en el tema. Se necesita al menos una plantilla de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99826871305304385)
,p_name=>'NO_PARENT'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna Entrada de Ruta de Navegaci\00F3n Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100275341614304773)
,p_name=>'NO_PARENT_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'es'
,p_message_text=>'No se han definido separadores principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100036389168304552)
,p_name=>'NO_PENDING_REQUESTS'
,p_message_language=>'es'
,p_message_text=>'Ninguna solicitud pendiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99904045007304451)
,p_name=>'NO_POPUP_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna plantilla de lista de valores emergente en el tema. Se necesita al menos una plantilla de lista de valores emergente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99985662691304514)
,p_name=>'NO_PRIORITY'
,p_message_language=>'es'
,p_message_text=>'Sin Prioridad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100072610493304580)
,p_name=>'NO_REGION_POSITION_IN_PAGE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta posici\00F3n de regi\00F3n no est\00E1 en la plantilla de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99903350795304450)
,p_name=>'NO_REGION_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ninguna plantilla de regi\00F3n en el tema. Se necesita al menos una plantilla de regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99903695893304450)
,p_name=>'NO_REPORT_TEMPLATES_FOUND_IN_THEME'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna plantilla de informe en el tema. Se necesita al menos una plantilla de informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99592810852304214)
,p_name=>'NO_SHORTCUT'
,p_message_language=>'es'
,p_message_text=>unistr('ning\00FAn m\00E9todo abreviado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99988353620304516)
,p_name=>'NO_STATUS'
,p_message_language=>'es'
,p_message_text=>'Sin Estado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100036906316304552)
,p_name=>'NO_SYSTEM_MESSAGE_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ning\00FAn mensaje de sistema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100331215984304814)
,p_name=>'NO_TABS_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ning\00FAn separador para esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100275545384304773)
,p_name=>'NO_TABS_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn separador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100272740752304771)
,p_name=>'NO_TABS_HAVE_BEEN_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ning\00FAn separador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100275401335304773)
,p_name=>'NO_TABS_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha seleccionado ning\00FAn separador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100706953787305098)
,p_name=>'NO_TAGS_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99732919664304317)
,p_name=>'NO_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Sin Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99825352224304384)
,p_name=>'NO_URL_ACCESS'
,p_message_language=>'es'
,p_message_text=>'No hay Acceso a URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100317295727304804)
,p_name=>'NO_WHITE_LIST_DEFINED'
,p_message_language=>'es'
,p_message_text=>'Por motivos de seguridad, debe definir una lista de tablas permitidas antes de utilizar etiquetas SQL,'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99982871114304511)
,p_name=>'NO_WORKAROUND_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Soluci\00F3n Alternativa no Disponible')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99729178092304314)
,p_name=>'NULL_IN_PAREN'
,p_message_language=>'es'
,p_message_text=>'(nulo)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100113707677304612)
,p_name=>'NUMBER_OF_FEEDBACK_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100066765114304575)
,p_name=>'NUMBER_OF_USERS_FILING_FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Usuarios'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99557702884304188)
,p_name=>'NUM_TOTAL'
,p_message_language=>'es'
,p_message_text=>'%0 Total'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99965261805304498)
,p_name=>'OBJECTS'
,p_message_language=>'es'
,p_message_text=>'Objetos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100260695321304762)
,p_name=>'OBJECTS_WITHOUT_DEFAULTS'
,p_message_language=>'es'
,p_message_text=>'Objetos sin Valores por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100260509001304762)
,p_name=>'OBJECTS_WITH_DEFAULTS'
,p_message_language=>'es'
,p_message_text=>'Objetos con Valores por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100732145819305117)
,p_name=>'OBJECT_LABEL'
,p_message_language=>'es'
,p_message_text=>'Objeto: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100053537523304565)
,p_name=>'OB_CASCADE_DELETE'
,p_message_language=>'es'
,p_message_text=>'cascada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99994855620304521)
,p_name=>'OB_CHECK_CON_NN'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar la restricci\00F3n de control.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99548995123304181)
,p_name=>'OB_COMPILE_ERRORS'
,p_message_language=>'es'
,p_message_text=>'%0 errores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100054673625304566)
,p_name=>'OB_CONSTRAINT_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de Restricci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100054732188304566)
,p_name=>'OB_CONS_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Columnas/Comprobaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99994653598304520)
,p_name=>'OB_CONS_NAME_NN'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar el nombre de restricci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99995075529304521)
,p_name=>'OB_CONS_NAME_USED'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de restricci\00F3n ya se ha utilizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100053296663304565)
,p_name=>'OB_FK_NAME'
,p_message_language=>'es'
,p_message_text=>'Clave Ajena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99994245844304520)
,p_name=>'OB_FK_NAME_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el nombre de clave ajena.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99994992814304521)
,p_name=>'OB_FK_NAME_USED'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de clave ajena ya est\00E1 siendo utilizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100053314999304565)
,p_name=>'OB_FK_REFERENCED'
,p_message_language=>'es'
,p_message_text=>'Tabla de Referencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100053472480304565)
,p_name=>'OB_FK_REFERENCED_TAB'
,p_message_language=>'es'
,p_message_text=>'Columnas de Referencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99994585823304520)
,p_name=>'OB_FK_REF_COLS'
,p_message_language=>'es'
,p_message_text=>'Se deben seleccionar las columnas de referencia de clave ajena.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99994435395304520)
,p_name=>'OB_FK_REF_TAB'
,p_message_language=>'es'
,p_message_text=>'Se deben seleccionar las referencias de clave ajena.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99994379905304520)
,p_name=>'OB_FK_SEL_COLS'
,p_message_language=>'es'
,p_message_text=>'Se deben seleccionar las columnas de clave ajena.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100115008470304613)
,p_name=>'OB_POSITION'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100054821998304566)
,p_name=>'OB_SELECT_DATATYPE'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar Tipo de Dato -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100053617722304565)
,p_name=>'OB_SET_NULL'
,p_message_language=>'es'
,p_message_text=>'definir nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99994734461304521)
,p_name=>'OB_UK_COLS'
,p_message_language=>'es'
,p_message_text=>unistr('Se deben especificar las columnas para la clave \00FAnica.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100463663351304914)
,p_name=>'ODG.API.START'
,p_message_language=>'es'
,p_message_text=>'%0  START'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100463504496304914)
,p_name=>'ODG.API.UNHANDLED'
,p_message_language=>'es'
,p_message_text=>unistr('%0 excepci\00F3n no tratada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100463779018304914)
,p_name=>'ODG.API.UNHANDLED_BUILTIN'
,p_message_language=>'es'
,p_message_text=>'data_source incorporado no tratado: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100464533922304914)
,p_name=>'ODG.BLUEPRINT.BLUEPRINT_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'El plan detallado no se ha encontrado o no se ha creado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99516126435304153)
,p_name=>'ODG.BLUEPRINT.DATA_SOURCE_NAME_26'
,p_message_language=>'es'
,p_message_text=>'El nombre del origen de datos debe tener 26 caracteres o menos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99516088994304153)
,p_name=>'ODG.BLUEPRINT.ERROR_IMPORTING'
,p_message_language=>'es'
,p_message_text=>'Error al importar: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100464487343304914)
,p_name=>'ODG.BLUEPRINT.ERR_INSERT_SELECT'
,p_message_language=>'es'
,p_message_text=>'Error al crear la sentencia SQL INSERT-SELECT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100463993770304914)
,p_name=>'ODG.BLUEPRINT.ERR_JSON_DATA'
,p_message_language=>'es'
,p_message_text=>'%0 al obtener datos de JSON. URL: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100464650752304914)
,p_name=>'ODG.BLUEPRINT.INSERT_INTO_SCRIPT'
,p_message_language=>'es'
,p_message_text=>'Script INSERT INTO:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99516338688304153)
,p_name=>'ODG.BLUEPRINT.INVALID_BUILTIN'
,p_message_language=>'es'
,p_message_text=>unistr('Origen de datos incorporado no v\00E1lido: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100464330891304914)
,p_name=>'ODG.BLUEPRINT.JSON_NULL'
,p_message_language=>'es'
,p_message_text=>'Error: Los datos de JSON son nulos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100464027121304914)
,p_name=>'ODG.BLUEPRINT.NOT_VALID_OBJECT'
,p_message_language=>'es'
,p_message_text=>unistr('No es un objeto v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100464118552304914)
,p_name=>'ODG.BLUEPRINT.NO_ROWS'
,p_message_language=>'es'
,p_message_text=>'Error: no se ha solicitado ninguna fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100463855278304914)
,p_name=>'ODG.BLUEPRINT.TO_MANY_ROWS'
,p_message_language=>'es'
,p_message_text=>unistr('Se han solicitado demasiadas filas. El n\00FAmero m\00E1ximo de filas permitidas es %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100464204729304914)
,p_name=>'ODG.BLUEPRINT.UNEXPECTED_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error inesperado al cargar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99516235634304153)
,p_name=>'ODG.BLUEPRINT.VALUE_Y_N'
,p_message_language=>'es'
,p_message_text=>'%0 debe ser S o N'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99594006464304215)
,p_name=>'ONE'
,p_message_language=>'es'
,p_message_text=>'Uno'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99546675012304179)
,p_name=>'ONLY_INSTALLED'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo Instalados')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99783603252304354)
,p_name=>'ON_LOAD'
,p_message_language=>'es'
,p_message_text=>'En Carga'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99984446335304513)
,p_name=>'OPEN'
,p_message_language=>'es'
,p_message_text=>'Abrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100030004609304547)
,p_name=>'OPENED_LAST_7_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('Abiertos en los \00DAltimos 7 D\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100029100932304546)
,p_name=>'OPEN_BUGS'
,p_message_language=>'es'
,p_message_text=>'Bugs Abiertos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100028866658304546)
,p_name=>'OPEN_FEATURES'
,p_message_language=>'es'
,p_message_text=>'Funciones Abiertas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100262626964304764)
,p_name=>'OPEN_PROCESSING_FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Abierto, procesando comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100029097162304546)
,p_name=>'OPEN_TO_DOS'
,p_message_language=>'es'
,p_message_text=>'Tareas Abiertas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99636206542304246)
,p_name=>'OPEN_WEBSHEET'
,p_message_language=>'es'
,p_message_text=>'Abrir Hoja Web %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99970236704304502)
,p_name=>'OPTIONAL ATTRIBUTE'
,p_message_language=>'es'
,p_message_text=>'Atributo Opcional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100750487947305131)
,p_name=>'OPTIONAL ICON CSS CLASSES'
,p_message_language=>'es'
,p_message_text=>'Icono Opcional: Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99970146354304502)
,p_name=>'OPTIONAL IMAGE'
,p_message_language=>'es'
,p_message_text=>'Imagen Opcional'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99970304363304502)
,p_name=>'OPTIONAL IMAGE ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>'Atributos de Imagen Opcionales'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100273233253304771)
,p_name=>'ORACLE FORMS'
,p_message_language=>'es'
,p_message_text=>'Oracle Forms'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100678058903305073)
,p_name=>'ORDS_BASED_PRINTING_DESUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('La impresi\00F3n basada en Oracle REST Data Services ha quedado desfasada en Oracle APEX 19.1 y ya no se soporta.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99528117576304162)
,p_name=>'OTHER'
,p_message_language=>'es'
,p_message_text=>'Otro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100273870092304772)
,p_name=>'OTHER WORKSPACE FILES'
,p_message_language=>'es'
,p_message_text=>'Otros Archivos del Espacio de Trabajo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100022745113304542)
,p_name=>'OTN'
,p_message_language=>'es'
,p_message_text=>'Oracle Technology Network'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100022839585304542)
,p_name=>'OTN_FORUM'
,p_message_language=>'es'
,p_message_text=>unistr('Foro de Discusi\00F3n de Oracle Technology Network')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100152812914304680)
,p_name=>'OVERRIDE_ID'
,p_message_language=>'es'
,p_message_text=>unistr('ID de Sustituci\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100728925938305115)
,p_name=>'OVERVIEW'
,p_message_language=>'es'
,p_message_text=>unistr('Visi\00F3n General')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99710408973304301)
,p_name=>'OWNER'
,p_message_language=>'es'
,p_message_text=>'Propietario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99557424740304187)
,p_name=>'OWNERS'
,p_message_language=>'es'
,p_message_text=>'Propietarios'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99934410167304474)
,p_name=>'P4000.P4651.SQL_QUERY.FUNC_BODY'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n de Consulta SQL. Cuerpo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100072063698304579)
,p_name=>'P4001_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99684811225304281)
,p_name=>'P4111_USED_ON_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Esta lista de valores no se puede suprimir, ya que se utiliza en la(s) p\00E1gina(s) %0.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100034762616304551)
,p_name=>'P4316_BIND_ITEM'
,p_message_language=>'es'
,p_message_text=>'Elemento Ligado (introduzca el nombre del elemento)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100683523815305081)
,p_name=>'P473_NEEDS_REFRESH'
,p_message_language=>'es'
,p_message_text=>'Puede que necesite refrescar.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100686355009305083)
,p_name=>'P4905_BUTTON_ALT_LABEL'
,p_message_language=>'es'
,p_message_text=>'Agregar servidor de despliegue'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99960944179304495)
,p_name=>'P58_BROWSE_SEQ'
,p_message_language=>'es'
,p_message_text=>'Examinar Enlaces de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99956920469304492)
,p_name=>'P58_NO_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('La operaci\00F3n Crear Enlace de Base de Datos no se ha realizado correctamente por el siguiente motivo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99957040413304492)
,p_name=>'P58_SEQUENCE_CREATED'
,p_message_language=>'es'
,p_message_text=>'Se ha creado el enlace de base de datos "%0" en el esquema "%1".'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99729975508304315)
,p_name=>'PACKAGE'
,p_message_language=>'es'
,p_message_text=>'paquete'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99904548786304451)
,p_name=>'PACKAGED_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n de ejemplo o de productividad')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99567230098304195)
,p_name=>'PACKAGED_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones de ejemplo y de productividad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100116323826304614)
,p_name=>'PACKAGED_APP_INSTALL_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error durante la instalaci\00F3n de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99947603489304485)
,p_name=>'PACKAGE_BODY'
,p_message_language=>'es'
,p_message_text=>'Cuerpo del Paquete'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100094040354304597)
,p_name=>'PACKAGE_GLOBALS'
,p_message_language=>'es'
,p_message_text=>'-Global-'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99711988973304302)
,p_name=>'PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100032341935304549)
,p_name=>'PAGE COMPUTATION CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de C\00E1lculo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100112638881304611)
,p_name=>'PAGE HEADER'
,p_message_language=>'es'
,p_message_text=>unistr('Cabecera de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100024854665304543)
,p_name=>'PAGE HEADER, BODY, AND FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo, Cabecera y Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100032661659304549)
,p_name=>'PAGE ITEM DEFAULT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor por Defecto de Elemento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100032868438304549)
,p_name=>'PAGE ITEM DISPLAY CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Visualizaci\00F3n de Elemento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100033013239304549)
,p_name=>'PAGE ITEM LOV'
,p_message_language=>'es'
,p_message_text=>unistr('Lista de Valores de Elemento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100032707587304549)
,p_name=>'PAGE ITEM POST COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculo Posterior de Elemento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100032934200304549)
,p_name=>'PAGE ITEM READ-ONLY DISPLAY CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Visualizaci\00F3n de S\00F3lo Lectura de Elemento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100032563393304549)
,p_name=>'PAGE ITEM SOURCE'
,p_message_language=>'es'
,p_message_text=>unistr('Origen de Elemento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99948042228304485)
,p_name=>'PAGE ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100025671414304544)
,p_name=>'PAGE PROCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Proceso de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100025722867304544)
,p_name=>'PAGE PROCESS CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Proceso de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100032473589304549)
,p_name=>'PAGE VALIDATION CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Validaci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99961972461304496)
,p_name=>'PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100176066046304698)
,p_name=>'PAGE_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>unistr('Atributos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100006559601304529)
,p_name=>'PAGE_EVENTS'
,p_message_language=>'es'
,p_message_text=>unistr('Eventos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100042747242304557)
,p_name=>'PAGE_EVENTS_FOR_LAST_X'
,p_message_language=>'es'
,p_message_text=>unistr('Eventos de P\00E1gina: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100758961567305137)
,p_name=>'PAGE_FINDER'
,p_message_language=>'es'
,p_message_text=>unistr('Buscador de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99521371686304157)
,p_name=>'PAGE_GROUP'
,p_message_language=>'es'
,p_message_text=>unistr('Grupo de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100042271056304556)
,p_name=>'PAGE_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Identifica la p\00E1gina de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100207464846304721)
,p_name=>'PAGE_ID_LOCKED'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina %0 bloqueada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100207536377304721)
,p_name=>'PAGE_ID_UNLOCKED'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina %0 desbloqueada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100052770422304564)
,p_name=>'PAGE_INSTALL_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina de la aplicaci\00F3n se ha instalado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99948585416304485)
,p_name=>'PAGE_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('elemento de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100158669210304684)
,p_name=>'PAGE_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99993442473304520)
,p_name=>'PAGE_LOCKED'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Bloqueada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99901906341304449)
,p_name=>'PAGE_LOCKED_BY'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina bloqueada por %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100022462691304542)
,p_name=>'PAGE_NAME_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('se necesita el nombre de la p\00E1gina para todas las p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100006315846304529)
,p_name=>'PAGE_POSTS'
,p_message_language=>'es'
,p_message_text=>unistr('Publicaciones de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100176164681304698)
,p_name=>'PAGE_PROCESSES'
,p_message_language=>'es'
,p_message_text=>unistr('Procesos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99558197720304188)
,p_name=>'PAGE_PROCESSING'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100043574613304557)
,p_name=>'PAGE_PROTECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Protecci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99723474110304310)
,p_name=>'PAGE_REGION.LIST_ITEM_SEQ'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99723610177304310)
,p_name=>'PAGE_REGION.LIST_ITEM_TARGET'
,p_message_language=>'es'
,p_message_text=>'Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99723574057304310)
,p_name=>'PAGE_REGION.LIST_ITEM_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99723201790304310)
,p_name=>'PAGE_REGION.LIST_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99723304546304310)
,p_name=>'PAGE_REGION.LIST_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99723156650304310)
,p_name=>'PAGE_REGION.QUERY_HIDE_SOURCE'
,p_message_language=>'es'
,p_message_text=>'Ocultar Origen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99723029366304310)
,p_name=>'PAGE_REGION.QUERY_SHOW_SOURCE'
,p_message_language=>'es'
,p_message_text=>'Mostrar Origen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99722857665304310)
,p_name=>'PAGE_REGION.TREE_ITEM'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99722624604304310)
,p_name=>'PAGE_REGION.TREE_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de \00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99722907510304310)
,p_name=>'PAGE_REGION.TREE_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Consulta de \00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99722735503304310)
,p_name=>'PAGE_REGION.TREE_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99645661670304253)
,p_name=>'PAGE_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina %0 se ha creado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100024764938304543)
,p_name=>'PAGE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99993544628304520)
,p_name=>'PAGE_UNLOCKED'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Desbloqueada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100006463970304529)
,p_name=>'PAGE_VIEWS'
,p_message_language=>'es'
,p_message_text=>unistr('Vistas de P\00E1gina')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100002120313304526)
,p_name=>'PARENT_FEATURE_ID'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Funci\00F3n Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100112331652304611)
,p_name=>'PARENT_REPORT_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de informe principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100274003953304772)
,p_name=>'PARENT_TAB'
,p_message_language=>'es'
,p_message_text=>'Separador Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100272356718304771)
,p_name=>'PARENT_TABS'
,p_message_language=>'es'
,p_message_text=>'Separadores Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99716683028304305)
,p_name=>'PARENT_TAB_SET'
,p_message_language=>'es'
,p_message_text=>'Juego de Separadores Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99716738236304305)
,p_name=>'PARENT_TAB_SET_NEW'
,p_message_language=>'es'
,p_message_text=>'Nuevo Juego de Separadores Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99716864915304305)
,p_name=>'PARENT_TAB_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto de Separador Principal'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100273008517304771)
,p_name=>'PARRENT_TAB_SET'
,p_message_language=>'es'
,p_message_text=>'Juego de Separadores Principales'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99561380391304190)
,p_name=>'PARSING_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de An\00E1lisis')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99558292397304188)
,p_name=>'PARTIAL_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Parcial')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99541504341304172)
,p_name=>'PASSWORD_EXPIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a Vencida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99529202272304163)
,p_name=>'PASSWORD_MUST_BE_CHANGED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe cambiar la contrase\00F1a para esta cuenta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99541449945304172)
,p_name=>'PASSWORD_VALID'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99549276121304181)
,p_name=>'PASSWORD_WITH_SUBMIT'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a (se ejecuta al pulsar Intro)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100066036846304575)
,p_name=>'PAST_DUE'
,p_message_language=>'es'
,p_message_text=>'Vencido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100155961831304682)
,p_name=>'PATH'
,p_message_language=>'es'
,p_message_text=>'Ruta de Acceso'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100315438032304803)
,p_name=>'PCT_CLOSED'
,p_message_language=>'es'
,p_message_text=>'% Cerradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100311759211304800)
,p_name=>'PCT_GRAPH_FORMAT'
,p_message_language=>'es'
,p_message_text=>unistr('Formato gr\00E1fico para porcentajes, n\00FAmeros enteros entre 0 y 100')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100224580792304733)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100224664111304733)
,p_name=>'PE.COMPONEN.TYPE.APPLICATION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100561193816304986)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100561277272304986)
,p_name=>'PE.COMPONEN.TYPE.APP_COMPUTATION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculo de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100226571127304735)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100226642397304735)
,p_name=>'PE.COMPONEN.TYPE.APP_ITEM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100561370249304986)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Procesos de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100561485258304986)
,p_name=>'PE.COMPONEN.TYPE.APP_PROCESS.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Proceso de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100226908605304735)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Autenticaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100227082096304735)
,p_name=>'PE.COMPONEN.TYPE.AUTHENTICATION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100227138277304735)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Autorizaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100227291350304735)
,p_name=>'PE.COMPONEN.TYPE.AUTHORIZATION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100461734449304912)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Automatizaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100461841514304912)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Automatizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100698450187305092)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Acciones de automatizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100698570515305092)
,p_name=>'PE.COMPONEN.TYPE.AUTOMATION_ACTION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n de automatizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100230765111304738)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Bifurcaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100230876700304738)
,p_name=>'PE.COMPONEN.TYPE.BRANCH.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100227357202304735)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Rutas de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100227495381304736)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100561525082304986)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Entradas de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100561698043304986)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_ENTRY.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Entrada de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100225987440304734)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100226008302304735)
,p_name=>'PE.COMPONEN.TYPE.BREADCRUMB_TEMPLATE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100226775043304735)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100226868345304735)
,p_name=>'PE.COMPONEN.TYPE.BUILD_OPTION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Opci\00F3n de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100229581564304737)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Botones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100229603665304737)
,p_name=>'PE.COMPONEN.TYPE.BUTTON.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100225569927304734)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100225671714304734)
,p_name=>'PE.COMPONEN.TYPE.BUTTON_TEMPLATE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100226161660304735)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Calendario Heredado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100226229492304735)
,p_name=>'PE.COMPONEN.TYPE.CALENDAR_TEMPLATE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Calendario Heredado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100541900181304972)
,p_name=>'PE.COMPONEN.TYPE.CARD.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100542092081304972)
,p_name=>'PE.COMPONEN.TYPE.CARD.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100542111481304972)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Acciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100542270411304972)
,p_name=>'PE.COMPONEN.TYPE.CARD_ACTION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100244189811304749)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100244298044304749)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_CALENDAR.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100232325030304739)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100232410841304739)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100232590569304740)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100232643651304740)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_COLUMN.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100321740288304807)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Imprimiendo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100321805267304807)
,p_name=>'PE.COMPONEN.TYPE.CLASSIC_REPORT_PRINT_ATTR.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Imprimiendo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100528746278304962)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Definiciones de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100528840982304962)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_DEFINITION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Definici\00F3n de Carga de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100228379627304736)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Definiciones de carga de datos heredadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100228430376304736)
,p_name=>'PE.COMPONEN.TYPE.DATA_LOAD_TABLE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Definici\00F3n de carga de datos heredada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100229960403304738)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Acciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100230013903304738)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_ACTION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100229738831304737)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Acciones Din\00E1micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100229859773304737)
,p_name=>'PE.COMPONEN.TYPE.DYNAMIC_ACTION_EVENT.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n Din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99786388332304356)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99786435207304356)
,p_name=>'PE.COMPONEN.TYPE.EMAIL_TEMPLATE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100462061693304912)
,p_name=>'PE.COMPONEN.TYPE.FACET.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Facetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100462130094304913)
,p_name=>'PE.COMPONEN.TYPE.FACET.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Faceta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100533311981304965)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Grupos de facetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100533402700304965)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Grupo de facetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100533594325304965)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Casillas de control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100533682292304965)
,p_name=>'PE.COMPONEN.TYPE.FACET_GROUP_ITEM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Casilla de control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100225360893304734)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Campo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100225444667304734)
,p_name=>'PE.COMPONEN.TYPE.FIELD_TEMPLATE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Campo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100072893133304580)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100072983301304580)
,p_name=>'PE.COMPONEN.TYPE.IG_ATTRIBUTES.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100073248754304580)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100073306547304580)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100073082615304580)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Grupos de Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100073189197304580)
,p_name=>'PE.COMPONEN.TYPE.IG_COLUMN_GROUP.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Grupo de Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100073426892304580)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Imprimiendo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100073591446304580)
,p_name=>'PE.COMPONEN.TYPE.IG_PRINT_ATTR.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Imprimiendo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100540103457304970)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Informes Guardados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100540866164304971)
,p_name=>'PE.COMPONEN.TYPE.IG_SAVED_REPORT.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Informe Guardado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100230997780304738)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100231096628304738)
,p_name=>'PE.COMPONEN.TYPE.IR_ATTRIBUTES.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100231504922304739)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100231645271304739)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100231391899304739)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Grupos de Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100231473310304739)
,p_name=>'PE.COMPONEN.TYPE.IR_COLUMN_GROUP.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Grupo de Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100321516035304807)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Imprimiendo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100321672194304807)
,p_name=>'PE.COMPONEN.TYPE.IR_PRINT_ATTR.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Imprimiendo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100231104178304738)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Informes Guardados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100231203159304739)
,p_name=>'PE.COMPONEN.TYPE.IR_SAVED_REPORT.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Informe Guardado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100120238042304617)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100120387733304617)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100120063624304617)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Ejes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100120143951304617)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_AXES.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Eje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100120482681304617)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100120526273304617)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_SERIES.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100690878381305086)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100690964300305087)
,p_name=>'PE.COMPONEN.TYPE.JET_CHART_WS_PARAM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100227551729304736)
,p_name=>'PE.COMPONEN.TYPE.LIST.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Listas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100227656620304736)
,p_name=>'PE.COMPONEN.TYPE.LIST.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100561708315304986)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Entradas de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100561806170304986)
,p_name=>'PE.COMPONEN.TYPE.LIST_ENTRY.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Entrada de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100225707033304734)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Plantillas de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100225838205304734)
,p_name=>'PE.COMPONEN.TYPE.LIST_TEMPLATE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100227701068304736)
,p_name=>'PE.COMPONEN.TYPE.LOV.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Listas de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100227860283304736)
,p_name=>'PE.COMPONEN.TYPE.LOV.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100561925684304987)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Entradas de Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100562045920304987)
,p_name=>'PE.COMPONEN.TYPE.LOV_ENTRY.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Entrada de Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100467828413304916)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Capas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100467949691304917)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Capa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100468056404304917)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100468118667304917)
,p_name=>'PE.COMPONEN.TYPE.MAP_LAYER_WS_PARAM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100467672929304916)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100467746456304916)
,p_name=>'PE.COMPONEN.TYPE.MAP_REGION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100229126994304737)
,p_name=>'PE.COMPONEN.TYPE.PAGE.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100229200018304737)
,p_name=>'PE.COMPONEN.TYPE.PAGE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100230336326304738)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100230438424304738)
,p_name=>'PE.COMPONEN.TYPE.PAGE_COMPUTATION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100228911819304737)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Grupos de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100229072282304737)
,p_name=>'PE.COMPONEN.TYPE.PAGE_GROUP.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Grupo de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99927549344304469)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99927667130304469)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100230558833304738)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Procesos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100230647177304738)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Proceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100232113141304739)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de Autenticaci\00F3n B\00E1sica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100232203014304739)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_AUTH.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro de Autenticaci\00F3n B\00E1sica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100231761613304739)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de Entrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100231858939304739)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_IN.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro de Entrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100231943585304739)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de Salida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100232047216304739)
,p_name=>'PE.COMPONEN.TYPE.PAGE_PROCESS_WS_PARAM_OUT.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro de Salida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100224903876304734)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100225096625304734)
,p_name=>'PE.COMPONEN.TYPE.PAGE_TEMPLATE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100562513111304987)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Plugins'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100562642248304987)
,p_name=>'PE.COMPONEN.TYPE.PLUGIN.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100229317368304737)
,p_name=>'PE.COMPONEN.TYPE.REGION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Regiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100229406319304737)
,p_name=>'PE.COMPONEN.TYPE.REGION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100520564796304956)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100520610947304956)
,p_name=>'PE.COMPONEN.TYPE.REGION_COLUMN.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100457258362304909)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100457373923304909)
,p_name=>'PE.COMPONEN.TYPE.REGION_PLUGIN_ATTRIBUTES.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100225180379304734)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100225243731304734)
,p_name=>'PE.COMPONEN.TYPE.REGION_TEMPLATE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100168372373304692)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100168491555304692)
,p_name=>'PE.COMPONEN.TYPE.REGION_WS_PARAM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99948944820304486)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Bases de datos remotas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99949066113304486)
,p_name=>'PE.COMPONEN.TYPE.REMOTE_DATABASE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'SQL activado para REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100328792596304813)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1os de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100328847243304813)
,p_name=>'PE.COMPONEN.TYPE.REPORT LAYOUT.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1o de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100226380517304735)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de Informe Cl\00E1sico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100226451196304735)
,p_name=>'PE.COMPONEN.TYPE.REPORT_TEMPLATE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Informe Cl\00E1sico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99894909223304443)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99895096820304443)
,p_name=>'PE.COMPONEN.TYPE.SFILTER.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99895139367304443)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Filtrar grupos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99895240476304444)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Filtrar grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99895398738304444)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Casillas de control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99895470638304444)
,p_name=>'PE.COMPONEN.TYPE.SFILTER_GROUP_ITEM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Casilla de control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100562146068304987)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todos Abreviados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100562224584304987)
,p_name=>'PE.COMPONEN.TYPE.SHORTCUT.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Acceso Directo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100228527954304736)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Juegos de Separadores Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100228664538304736)
,p_name=>'PE.COMPONEN.TYPE.TAB SET.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Juego de Separadores Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100234590666304741)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100234659950304741)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100234788321304741)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100234888579304741)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_COLUMN.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100321999750304807)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Imprimiendo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100322050137304808)
,p_name=>'PE.COMPONEN.TYPE.TABULAR_FORM_PRINT_ATTR.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Imprimiendo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100224730200304734)
,p_name=>'PE.COMPONEN.TYPE.THEME.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100224813839304734)
,p_name=>'PE.COMPONEN.TYPE.THEME.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100562324207304987)
,p_name=>'PE.COMPONEN.TYPE.TREE.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rboles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100562402819304987)
,p_name=>'PE.COMPONEN.TYPE.TREE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100228703295304737)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Interfaces de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100228888070304737)
,p_name=>'PE.COMPONEN.TYPE.USER_INTERFACE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100230198965304738)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Validaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100230274954304738)
,p_name=>'PE.COMPONEN.TYPE.VALIDATION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100227999530304736)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Referencias de Servicio Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100228027565304736)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Referencia de Servicio Web'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100228160577304736)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Operaciones de Servicio Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100228299104304736)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REFERENCE_OPERATION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Operaci\00F3n de Servicio Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100697528871305092)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de Autenticaci\00F3n B\00E1sica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100697626212305092)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_A.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro de Autenticaci\00F3n B\00E1sica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100697797226305092)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de Cabecera HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100697817593305092)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_H.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro de Cabecera HTTP')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100697166117305091)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de Entrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100697269388305091)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_I.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro de Entrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100697396558305091)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de Salida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100697405755305091)
,p_name=>'PE.COMPONEN.TYPE.WEB_SERVICE_REF_OPER_PARAM_O.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro de Salida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100062346157304572)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Or\00EDgenes de Datos de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100062423564304572)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Origen de Datos de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100173020134304695)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de origen de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100173154317304695)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_MODULE_PARAM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro de origen de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100168120185304692)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Operaciones de origen de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100168249309304692)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPERATION.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Operaci\00F3n de origen de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100173280518304695)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de la operaci\00F3n de origen de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100173368218304696)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_OPER_PARAM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro de la operaci\00F3n de origen de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100173418400304696)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.PLURAL'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metros de origen de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100173566184304696)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_PARAM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro de origen de REST')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100062540536304572)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Consulta de origen de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100062693743304572)
,p_name=>'PE.COMPONEN.TYPE.WEB_SRC_QUERY.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Consulta de origen de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100183946560304704)
,p_name=>'PE.DISPLAY_GROUP.ACTIONS_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Acciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100698642384305092)
,p_name=>'PE.DISPLAY_GROUP.ADDITIONAL_CODE'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecuci\00F3n de c\00F3digo adicional')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99845305880304403)
,p_name=>'PE.DISPLAY_GROUP.ADVANCED'
,p_message_language=>'es'
,p_message_text=>'Avanzada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99845629110304403)
,p_name=>'PE.DISPLAY_GROUP.AFFECTED_ELEMENTS'
,p_message_language=>'es'
,p_message_text=>'Elementos Afectados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100122626776304657)
,p_name=>'PE.DISPLAY_GROUP.ANIMATION'
,p_message_language=>'es'
,p_message_text=>unistr('Animaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99846618870304404)
,p_name=>'PE.DISPLAY_GROUP.APPEARANCE'
,p_message_language=>'es'
,p_message_text=>'Apariencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99843803446304402)
,p_name=>'PE.DISPLAY_GROUP.ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99493567000304136)
,p_name=>'PE.DISPLAY_GROUP.AUDIT_INFORMATION'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n de Auditor\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99845447269304403)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100562897834304987)
,p_name=>'PE.DISPLAY_GROUP.AUTHORIZATION_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100241416131304747)
,p_name=>'PE.DISPLAY_GROUP.AUTOMATIC_REFRESH'
,p_message_language=>'es'
,p_message_text=>unistr('Refrescamiento Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99846535116304404)
,p_name=>'PE.DISPLAY_GROUP.BEHAVIOR'
,p_message_language=>'es'
,p_message_text=>'Comportamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100216506466304727)
,p_name=>'PE.DISPLAY_GROUP.BLOB'
,p_message_language=>'es'
,p_message_text=>'Atributos BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100542548175304972)
,p_name=>'PE.DISPLAY_GROUP.BODY'
,p_message_language=>'es'
,p_message_text=>'Cuerpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100218878049304729)
,p_name=>'PE.DISPLAY_GROUP.BREAK_FORMATTING'
,p_message_language=>'es'
,p_message_text=>unistr('Formato de Divisi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100251566168304755)
,p_name=>'PE.DISPLAY_GROUP.CALENDAR_STATE_ITEMS'
,p_message_language=>'es'
,p_message_text=>'Elementos de Estado del Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100542336016304972)
,p_name=>'PE.DISPLAY_GROUP.CARD'
,p_message_language=>'es'
,p_message_text=>'Tarjeta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100208054906304721)
,p_name=>'PE.DISPLAY_GROUP.CASCADING_LOV'
,p_message_language=>'es'
,p_message_text=>'Lista de valores en cascada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100243077561304748)
,p_name=>'PE.DISPLAY_GROUP.CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100713498868305103)
,p_name=>'PE.DISPLAY_GROUP.CLIENT_SIDE_CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Cliente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100698730464305092)
,p_name=>'PE.DISPLAY_GROUP.CODE'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100244760324304749)
,p_name=>'PE.DISPLAY_GROUP.COLORS'
,p_message_language=>'es'
,p_message_text=>'Colores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100322405451304808)
,p_name=>'PE.DISPLAY_GROUP.COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100320839705304807)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtro de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100178716451304700)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_FORMATTING'
,p_message_language=>'es'
,p_message_text=>'Formato de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100322332335304808)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_HEADINGS'
,p_message_language=>'es'
,p_message_text=>'Cabeceras de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100121932458304618)
,p_name=>'PE.DISPLAY_GROUP.COLUMN_MAPPING'
,p_message_language=>'es'
,p_message_text=>unistr('Asignaci\00F3n de Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99843907097304402)
,p_name=>'PE.DISPLAY_GROUP.COMMENTS'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99845285119304403)
,p_name=>'PE.DISPLAY_GROUP.COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99844102758304402)
,p_name=>'PE.DISPLAY_GROUP.CONFIGURATION'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99755670138304334)
,p_name=>'PE.DISPLAY_GROUP.CONFIRMATION'
,p_message_language=>'es'
,p_message_text=>unistr('Confirmaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100254176627304757)
,p_name=>'PE.DISPLAY_GROUP.CONTROLS'
,p_message_language=>'es'
,p_message_text=>'Controles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99844200627304402)
,p_name=>'PE.DISPLAY_GROUP.CSS'
,p_message_language=>'es'
,p_message_text=>'CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99940810333304479)
,p_name=>'PE.DISPLAY_GROUP.CUSTOMIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('Personalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100244514987304749)
,p_name=>'PE.DISPLAY_GROUP.DAILY_WEEKLY_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario Diario y Semanal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100562903289304987)
,p_name=>'PE.DISPLAY_GROUP.DATABASE_SESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Sesi\00F3n de Base de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100243174574304748)
,p_name=>'PE.DISPLAY_GROUP.DATAGRID'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadr\00EDcula de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100121824105304618)
,p_name=>'PE.DISPLAY_GROUP.DATA_CURSOR'
,p_message_language=>'es'
,p_message_text=>'Cursor de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99845755394304404)
,p_name=>'PE.DISPLAY_GROUP.DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100207938611304721)
,p_name=>'PE.DISPLAY_GROUP.DEPENDING_ON'
,p_message_language=>'es'
,p_message_text=>'Depende de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100184079589304704)
,p_name=>'PE.DISPLAY_GROUP.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100184120288304704)
,p_name=>'PE.DISPLAY_GROUP.DETAIL_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Detalles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100252776028304756)
,p_name=>'PE.DISPLAY_GROUP.DIALOG'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100184254216304704)
,p_name=>'PE.DISPLAY_GROUP.DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>'Descargar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100244852844304749)
,p_name=>'PE.DISPLAY_GROUP.DRAG_AND_DROP'
,p_message_language=>'es'
,p_message_text=>'Arrastrar y Soltar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100122503860304657)
,p_name=>'PE.DISPLAY_GROUP.DUAL_Y_AXES'
,p_message_language=>'es'
,p_message_text=>'Dobles Ejes Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100073771310304581)
,p_name=>'PE.DISPLAY_GROUP.EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100206025520304720)
,p_name=>'PE.DISPLAY_GROUP.EDIT_AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99845835455304404)
,p_name=>'PE.DISPLAY_GROUP.ELEMENT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100073677678304581)
,p_name=>'PE.DISPLAY_GROUP.ENABLE_USER_TO'
,p_message_language=>'es'
,p_message_text=>'Permitir a los Usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100251677791304755)
,p_name=>'PE.DISPLAY_GROUP.ENTRY'
,p_message_language=>'es'
,p_message_text=>'Entrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99844014861304402)
,p_name=>'PE.DISPLAY_GROUP.ERROR'
,p_message_language=>'es'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99844356440304402)
,p_name=>'PE.DISPLAY_GROUP.ERROR_HANDLING'
,p_message_language=>'es'
,p_message_text=>'Manejo de Errores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99845154698304403)
,p_name=>'PE.DISPLAY_GROUP.EXECUTION_OPTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100212452387304724)
,p_name=>'PE.DISPLAY_GROUP.EXPORT_PRINTING'
,p_message_language=>'es'
,p_message_text=>unistr('Exportaci\00F3n/Impresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100218904146304729)
,p_name=>'PE.DISPLAY_GROUP.EXTERNAL_PROCESSING'
,p_message_language=>'es'
,p_message_text=>'Procesamiento Externo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100466867906304916)
,p_name=>'PE.DISPLAY_GROUP.GANTT_START_DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha de Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100242947123304748)
,p_name=>'PE.DISPLAY_GROUP.GANTT_TIMELINE'
,p_message_language=>'es'
,p_message_text=>unistr('Cronolog\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100664622299305063)
,p_name=>'PE.DISPLAY_GROUP.GANTT_VIEWPORT'
,p_message_language=>'es'
,p_message_text=>'Ventanilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100242520124304748)
,p_name=>'PE.DISPLAY_GROUP.GAUGE'
,p_message_language=>'es'
,p_message_text=>'Indicador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99844448624304402)
,p_name=>'PE.DISPLAY_GROUP.HEADER_AND_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Cabecera y Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100219106826304729)
,p_name=>'PE.DISPLAY_GROUP.HEADING'
,p_message_language=>'es'
,p_message_text=>'Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99844515660304403)
,p_name=>'PE.DISPLAY_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>'Ayuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99845986182304404)
,p_name=>'PE.DISPLAY_GROUP.HELP_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto de Ayuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99844691312304403)
,p_name=>'PE.DISPLAY_GROUP.HTML_HEADER'
,p_message_language=>'es'
,p_message_text=>'Cabecera HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100542725966304972)
,p_name=>'PE.DISPLAY_GROUP.ICON_AND_BADGE'
,p_message_language=>'es'
,p_message_text=>'Icono y placa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100184371179304704)
,p_name=>'PE.DISPLAY_GROUP.ICON_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99843677778304402)
,p_name=>'PE.DISPLAY_GROUP.IDENTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Identificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99844705866304403)
,p_name=>'PE.DISPLAY_GROUP.JAVASCRIPT'
,p_message_language=>'es'
,p_message_text=>'JavaScript'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99846047391304404)
,p_name=>'PE.DISPLAY_GROUP.LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99846781126304404)
,p_name=>'PE.DISPLAY_GROUP.LAYOUT'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100242083449304747)
,p_name=>'PE.DISPLAY_GROUP.LEGEND'
,p_message_language=>'es'
,p_message_text=>'Leyenda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100122067597304618)
,p_name=>'PE.DISPLAY_GROUP.LINE'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100199126691304715)
,p_name=>'PE.DISPLAY_GROUP.LINK'
,p_message_language=>'es'
,p_message_text=>'Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100306096267304796)
,p_name=>'PE.DISPLAY_GROUP.LIST_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99846195564304404)
,p_name=>'PE.DISPLAY_GROUP.LIST_OF_VALUES'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100244689571304749)
,p_name=>'PE.DISPLAY_GROUP.LIST_VIEW_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario de Vista de Agenda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100674494701305071)
,p_name=>'PE.DISPLAY_GROUP.LOCAL_POST_PROCESSING'
,p_message_language=>'es'
,p_message_text=>'Procesamiento posterior local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99940214031304479)
,p_name=>'PE.DISPLAY_GROUP.LOGIN_PROCESSING'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento de Conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100122200533304657)
,p_name=>'PE.DISPLAY_GROUP.MAJOR_TICKS'
,p_message_language=>'es'
,p_message_text=>'Marcas Principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100468387047304917)
,p_name=>'PE.DISPLAY_GROUP.MAP_LAYER_ZOOM'
,p_message_language=>'es'
,p_message_text=>'Niveles de Zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100468241449304917)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION'
,p_message_language=>'es'
,p_message_text=>'Mapa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100468871874304917)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_FEATURE_INFO_WINDOW'
,p_message_language=>'es'
,p_message_text=>unistr('Ventana de informaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100468475938304917)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_INIT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n inicial y zoom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100468699784304917)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_CLUSTER'
,p_message_language=>'es'
,p_message_text=>unistr('Agrupaci\00F3n en clusters de puntos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100468503688304917)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_POINT_FEATURE_STYLE'
,p_message_language=>'es'
,p_message_text=>'Objetos de puntos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100468780741304917)
,p_name=>'PE.DISPLAY_GROUP.MAP_REGION_ROW_SELECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Asignaci\00F3n de fila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100242194195304747)
,p_name=>'PE.DISPLAY_GROUP.MARGIN'
,p_message_language=>'es'
,p_message_text=>'Margen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100122167358304618)
,p_name=>'PE.DISPLAY_GROUP.MARKER'
,p_message_language=>'es'
,p_message_text=>'Marcador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100267624701304767)
,p_name=>'PE.DISPLAY_GROUP.MASTER_DETAIL'
,p_message_language=>'es'
,p_message_text=>'Maestro/Detalle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100542825140304972)
,p_name=>'PE.DISPLAY_GROUP.MEDIA'
,p_message_language=>'es'
,p_message_text=>'Medio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100219012354304729)
,p_name=>'PE.DISPLAY_GROUP.MESSAGES'
,p_message_language=>'es'
,p_message_text=>'Mensajes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100122335539304657)
,p_name=>'PE.DISPLAY_GROUP.MINOR_TICKS'
,p_message_language=>'es'
,p_message_text=>'Marcas Secundarias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100244315239304749)
,p_name=>'PE.DISPLAY_GROUP.MONTHLY_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario Mensual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99646625732304254)
,p_name=>'PE.DISPLAY_GROUP.MULTIPLE_VALUES'
,p_message_language=>'es'
,p_message_text=>'Varios Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99975991767304506)
,p_name=>'PE.DISPLAY_GROUP.MULTI_SERIES'
,p_message_language=>'es'
,p_message_text=>unistr('Datos de gr\00E1fico de varias series')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100563047416304987)
,p_name=>'PE.DISPLAY_GROUP.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99986573492304514)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100750556552305131)
,p_name=>'PE.DISPLAY_GROUP.NAVIGATION_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100330404278304814)
,p_name=>'PE.DISPLAY_GROUP.OUTPUT'
,p_message_language=>'es'
,p_message_text=>'Salida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100121789160304618)
,p_name=>'PE.DISPLAY_GROUP.OVERVIEW'
,p_message_language=>'es'
,p_message_text=>unistr('Visi\00F3n General')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100322279376304808)
,p_name=>'PE.DISPLAY_GROUP.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100322610009304808)
,p_name=>'PE.DISPLAY_GROUP.PAGE_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100322509726304808)
,p_name=>'PE.DISPLAY_GROUP.PAGE_HEADER'
,p_message_language=>'es'
,p_message_text=>unistr('Cabecera de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100184427366304704)
,p_name=>'PE.DISPLAY_GROUP.PAGINATION'
,p_message_language=>'es'
,p_message_text=>unistr('Paginaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100204431854304719)
,p_name=>'PE.DISPLAY_GROUP.PARAMETER'
,p_message_language=>'es'
,p_message_text=>unistr('Par\00E1metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100073934631304581)
,p_name=>'PE.DISPLAY_GROUP.PERFORMANCE'
,p_message_language=>'es'
,p_message_text=>'Rendimiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99940341964304479)
,p_name=>'PE.DISPLAY_GROUP.POST_LOGOUT_URL'
,p_message_language=>'es'
,p_message_text=>unistr('URL Posterior a la Desconexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100236948712304743)
,p_name=>'PE.DISPLAY_GROUP.PRIMARY_KEY_SOURCE'
,p_message_language=>'es'
,p_message_text=>'Origen de Clave Primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100322108371304808)
,p_name=>'PE.DISPLAY_GROUP.PRINTING'
,p_message_language=>'es'
,p_message_text=>'Imprimiendo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100562795579304987)
,p_name=>'PE.DISPLAY_GROUP.QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99846277967304404)
,p_name=>'PE.DISPLAY_GROUP.QUICK_PICKS'
,p_message_language=>'es'
,p_message_text=>'Listas de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99844877375304403)
,p_name=>'PE.DISPLAY_GROUP.READ_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo Lectura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99940407035304479)
,p_name=>'PE.DISPLAY_GROUP.REAL_APPLICATION_SECURITY'
,p_message_language=>'es'
,p_message_text=>'Real Application Security'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99685613985304282)
,p_name=>'PE.DISPLAY_GROUP.REFERENCE_LINES'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDneas de Referencia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100205505466304719)
,p_name=>'PE.DISPLAY_GROUP.REFRESH'
,p_message_language=>'es'
,p_message_text=>'Refrescar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99949102725304486)
,p_name=>'PE.DISPLAY_GROUP.REMOTE_CACHE'
,p_message_language=>'es'
,p_message_text=>unistr('Cach\00E9 remota')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100164798448304689)
,p_name=>'PE.DISPLAY_GROUP.SEARCH_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100542662363304972)
,p_name=>'PE.DISPLAY_GROUP.SECONDARY_BODY'
,p_message_language=>'es'
,p_message_text=>'Cuerpo secundario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99844912069304403)
,p_name=>'PE.DISPLAY_GROUP.SECURITY'
,p_message_language=>'es'
,p_message_text=>'Seguridad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100242278303304747)
,p_name=>'PE.DISPLAY_GROUP.SERIES_COLOR'
,p_message_language=>'es'
,p_message_text=>'Color de la Serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99845006632304403)
,p_name=>'PE.DISPLAY_GROUP.SERVER_CACHE'
,p_message_language=>'es'
,p_message_text=>unistr('Cach\00E9 de Servidor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100713342474305103)
,p_name=>'PE.DISPLAY_GROUP.SERVER_SIDE_CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Servidor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100563171027304987)
,p_name=>'PE.DISPLAY_GROUP.SESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99940586794304479)
,p_name=>'PE.DISPLAY_GROUP.SESSION_COOKIE_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>unistr('Atributos de Cookie de Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99940621274304479)
,p_name=>'PE.DISPLAY_GROUP.SESSION_NOT_VALID'
,p_message_language=>'es'
,p_message_text=>unistr('Sesi\00F3n no V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99843736878304402)
,p_name=>'PE.DISPLAY_GROUP.SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100184606173304704)
,p_name=>'PE.DISPLAY_GROUP.SINGLE_ROW_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Una Sola Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100184537157304704)
,p_name=>'PE.DISPLAY_GROUP.SORTING'
,p_message_language=>'es'
,p_message_text=>unistr('Ordenaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99846344280304404)
,p_name=>'PE.DISPLAY_GROUP.SOURCE'
,p_message_language=>'es'
,p_message_text=>'Origen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99940729477304479)
,p_name=>'PE.DISPLAY_GROUP.SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Suscripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100542400098304972)
,p_name=>'PE.DISPLAY_GROUP.SUB_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Subt\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100200011172304715)
,p_name=>'PE.DISPLAY_GROUP.SUCCESS_MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Mensaje Correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99895535237304444)
,p_name=>'PE.DISPLAY_GROUP.SUGGESTIONS'
,p_message_language=>'es'
,p_message_text=>'Sugerencias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100750665006305131)
,p_name=>'PE.DISPLAY_GROUP.TABS'
,p_message_language=>'es'
,p_message_text=>'Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99578383465304203)
,p_name=>'PE.DISPLAY_GROUP.THRESHOLDS'
,p_message_language=>'es'
,p_message_text=>'Umbrales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100122411533304657)
,p_name=>'PE.DISPLAY_GROUP.TICK_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de Marca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100456748159304909)
,p_name=>'PE.DISPLAY_GROUP.TIME_SCALE'
,p_message_language=>'es'
,p_message_text=>'Escala Temporal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100242852221304748)
,p_name=>'PE.DISPLAY_GROUP.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100073858521304581)
,p_name=>'PE.DISPLAY_GROUP.TOOLBAR'
,p_message_language=>'es'
,p_message_text=>'Barra de Herramientas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100242757584304748)
,p_name=>'PE.DISPLAY_GROUP.TOOLTIP'
,p_message_language=>'es'
,p_message_text=>'Pista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100235751573304742)
,p_name=>'PE.DISPLAY_GROUP.UI_DEFAULTS_REFERENCE'
,p_message_language=>'es'
,p_message_text=>'Referencia por Defecto de Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99846410950304404)
,p_name=>'PE.DISPLAY_GROUP.VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100242605054304748)
,p_name=>'PE.DISPLAY_GROUP.VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100244468979304749)
,p_name=>'PE.DISPLAY_GROUP.WEEKLY_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario Semanal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99845583671304403)
,p_name=>'PE.DISPLAY_GROUP.WHEN'
,p_message_language=>'es'
,p_message_text=>'Cuando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100242382488304747)
,p_name=>'PE.DISPLAY_GROUP.X_AXIS'
,p_message_language=>'es'
,p_message_text=>'Eje X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100242402879304748)
,p_name=>'PE.DISPLAY_GROUP.Y_AXIS'
,p_message_language=>'es'
,p_message_text=>'Eje Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100168566766304692)
,p_name=>'PE.DISPLAY_GROUP.ZOOM_SCALE'
,p_message_language=>'es'
,p_message_text=>'Escala de Zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100075680512304582)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique un esquema de autorizaci\00F3n para restringir los usuarios que pueden agregar filas.'),
unistr('Para permitir que un usuario final agregue filas, este esquema de autorizaci\00F3n se debe evaluar en TRUE para ese usuario.'),
unistr('Si no se proporciona ning\00FAn esquema de autorizaci\00F3n, cualquier usuario puede agregar filas en esta cuadr\00EDcula interactiva.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100075506932304582)
,p_name=>'PE.PROPERTY.ADD_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100078649241304585)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una etiqueta alternativa para el bot\00F3n Agregar. La etiqueta por defecto es <em>Agregar Fila </em>.</p>'),
unistr('        <p>Por ejemplo, introduzca <em>Agregar Empleado</em> para una cuadr\00EDcula interactiva en la que se mantienen los empleados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100078577483304584)
,p_name=>'PE.PROPERTY.ADD_BUTTON_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de Bot\00F3n Agregar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100076810717304583)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea agregar una nueva fila si la cuadr\00EDcula interactiva no ha devuelto registros actualmente.'),
unistr('        El mensaje <em>No se ha encontrado ning\00FAn dato</em> nunca aparecer\00E1 ya que siempre habr\00E1 un registro.</p>'),
unistr('        <p>Nota: Si no se han realizado actualizaciones en el registro que se ha agregado, no se insertar\00E1 cuando se guarde la regi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100076773421304583)
,p_name=>'PE.PROPERTY.ADD_ROW_IF_EMPTY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar Fila si Est\00E1 Vac\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100560356390304985)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a esta faceta. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100535311758304967)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este grupo de facetas. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100092040822304595)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases que desee agregar a este elemento. Puede agregar varias clases separ\00E1ndolas con espacios.<p/>'),
unistr('        <p>Nota: Esta propiedad puede emplearse para modificar el estilo del elemento correspondiente si la cuadr\00EDcula interactiva es editable.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100537054031304968)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('        <p>Nota: Estas clases de CSS se aplicar\00E1n a la pantalla de HTML de etiqueta de elemento.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99898935613304446)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este filtro. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99899648303304447)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este filtro. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100536494906304967)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Agregue las clases CSS <code>articlenumber</code> y <code>highlight</code> a la etiqueta HTML del componente</dt>',
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100536381674304967)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca las clases adicionales de CSS delimitadas por espacios que se van a incluir en el componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100536289170304967)
,p_name=>'PE.PROPERTY.ADVANCED_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99878739247304430)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el bot\00F3n al que afectar\00E1 esta acci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99878685009304430)
,p_name=>'PE.PROPERTY.AFFECTED_BUTTON.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100714370313305104)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca las columnas a las que afectar\00E1 esta acci\00F3n.'),
'Para obtener varias columnas, separe cada nombre de columna por una coma.',
'<p>Puede escribir el nombre o seleccionarlo de la lista de columnas disponibles.',
'Si lo selecciona de la lista y ya se ha introducido texto, se coloca una coma al final del texto existente, seguido del nombre de columna que se ha devuelto de la lista.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100714254753305104)
,p_name=>'PE.PROPERTY.AFFECTED_COLUMNS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99879145867304430)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un objeto DOM (<code>document</code>, <code>window</code>) o el <em>ID</em> de un objeto DOM (<code>myElementID</code>) como elementos a los que afectar\00E1 esta acci\00F3n.</p>'),
unistr('<p>Nota: el <em>Objeto DOM</em> est\00E1 en desuso y se debe sustituir por <em>Expresi\00F3n JavaScript</em> o <em>Selector de jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99879001188304430)
,p_name=>'PE.PROPERTY.AFFECTED_DOM_OBJECT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Objeto DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99878974662304430)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca uno o varios elementos de p\00E1gina a los que afectar\00E1 esta acci\00F3n.'),
'Para obtener varios elementos, separe cada nombre de elemento por una coma.',
'<p>Puede escribir el nombre o seleccionarlo de la lista de elementos disponibles.',
'Si lo selecciona de la lista y ya hay texto introducido, se coloca una coma al final del texto existente, seguido del nombre de elemento que se ha devuelto de la lista.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99878878439304430)
,p_name=>'PE.PROPERTY.AFFECTED_ITEMS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100710749247305101)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Devuelve una referencia al objeto DOM <code>window</code> del explorador.</dt>',
'<dd><code>window</code></dd>',
'<dt>Devuelve una referencia al objeto DOM <code>document</code> del explorador.</dt>',
'<dd>document</dd>',
unistr('<dt>El selector jQuery selecciona todos los elementos DIV que tienen una clase de ''alerta'' y, a continuaci\00F3n, devuelve un objeto jQuery que contiene todos sus principales.</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100710655208305101)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la expresi\00F3n JavaScript que se va a evaluar para devolver un solo objeto DOM, una matriz de objetos DOM o un objeto jQuery como elementos a los que afectar\00E1 esta acci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100710549973305101)
,p_name=>'PE.PROPERTY.AFFECTED_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100369132619304842)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Para seleccionar un elemento de p\00E1gina con un ID DOM <code>my_id</code></dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>Para seleccionar todos los elementos de p\00E1gina con una clase <code>my_class</code></dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>Para seleccionar todos los elementos de p\00E1gina que son entradas</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99879396786304431)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la sintaxis del selector de jQuery para devolver uno o varios elementos de p\00E1gina a los que afectar\00E1 esta acci\00F3n. La biblioteca jQuery ofrece una sintaxis de selectores muy potente que sirve para acceder con facilidad a uno o varios ele')
||unistr('mentos desde una p\00E1gina.</p>'),
unistr('<p>Consulte la documentaci\00F3n oficial disponible en la <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">p\00E1gina inicial de jQuery</a> para obtener informaci\00F3n adicional acerca de la sintaxis de selectores.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99879240724304430)
,p_name=>'PE.PROPERTY.AFFECTED_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Selector de jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99878565795304430)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la regi\00F3n a la que afectar\00E1 esta acci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99878414104304430)
,p_name=>'PE.PROPERTY.AFFECTED_REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99878349316304430)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la manera de definir los componentes de p\00E1gina a los que afectar\00E1 cuando se ejecute esta acci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100367967805304841)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.D'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100368089987304841)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La acci\00F3n afecta al bot\00F3n que seleccione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100713674066305103)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100713706328305104)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La acci\00F3n afecta a las columnas que introduce.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100368321186304842)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.D'
,p_message_language=>'es'
,p_message_text=>'Objeto DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100368477748304842)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.DOM_OBJECT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La acci\00F3n afecta al elemento de p\00E1gina identificado por el objeto DOM o por el ID DOM que especifique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100368990676304842)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.D'
,p_message_language=>'es'
,p_message_text=>'Origen de Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100369066819304842)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.EVENT_SOURCE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La acci\00F3n afecta al elemento de p\00E1gina donde se origin\00F3 el evento, que en algunos casos puede ser diferente al "Elemento Disparador".'),
unistr('<p>En esta configuraci\00F3n avanzada, el elemento disparador especificado es, por lo general, un elemento contenedor (como una regi\00F3n) que trata los eventos que inician sus subelementos (como los elementos de p\00E1gina de dicha regi\00F3n)'),
unistr('Este tipo de selecci\00F3n puede utilizarse para actuar con respecto a los subelementos que dispararon el evento, en lugar del elemento contenedor.'),
unistr('Por ejemplo, si dispone de una acci\00F3n din\00E1mica que define un evento de <strong>cambio</strong> en una regi\00F3n de la p\00E1gina, la acci\00F3n afectar\00E1 al elemento real de la regi\00F3n que ha cambiado.</p>'),
unistr('<p>El uso de <em>''Origen de Evento''</em> puede ser una forma de definir comportamientos comunes que afectan a varios elementos de p\00E1gina'),
'El tipo de evento es el encargado de determinar la capacidad de los elementos contenedores a la hora de capturar eventos que hayan iniciado los subelementos.',
unistr('Los siguientes tipos de evento est\00E1n soportados:</p>'),
'<ul>',
unistr('  <li><strong>Despu\00E9s de Refrescamiento</strong> (apexafterrefresh)</li>'),
'  <li><strong>Antes de Refrescamiento</strong> (apexbeforerefresh)</li>',
'  <li><strong>Cambiar</strong> (change)</li>',
'  <li><strong>Clic</b> (click)</strong> (click)</li>',
'  <li><strong>Doble Clic</strong> (dblclick)</li>',
'  <li><strong>Obtener Enfoque</strong> (focus)</li>',
'  <li><strong>Tecla Abajo</strong> (keydown)</li>',
unistr('  <li><strong>Pulsaci\00F3n de Tecla</strong> (keypress)</li>'),
unistr('  <li><strong>Liberaci\00F3n de Tecla</strong> (keyup)</li>'),
'  <li><strong>Perder Enfoque</strong> (blur)</li>',
unistr('  <li><strong>Pulsaci\00F3n del Bot\00F3n del Mouse</strong> (mousedown)</li>'),
unistr('  <li><strong>Liberaci\00F3n del Bot\00F3n del Mouse</strong> (mouseup)</li>'),
'  <li><strong>Movimiento de Mouse</strong> (mousemove)</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100367784315304841)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100367802850304841)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La acci\00F3n afecta a uno o varios elementos de p\00E1gina que haya introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100710352777305101)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100710433978305101)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La acci\00F3n afecta a los elementos de p\00E1gina devueltos que utilizan la expresi\00F3n JavaScript que introduzca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100368597562304842)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'es'
,p_message_text=>'Selector de jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100368635350304842)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La acci\00F3n afecta a los elementos de p\00E1gina devueltos que utilizan la sintaxis del selector iQuery que especifique.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100368151286304841)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100368254294304842)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La acci\00F3n afecta a la regi\00F3n que seleccione.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100368755579304842)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.D'
,p_message_language=>'es'
,p_message_text=>'Elemento Disparador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100368801605304842)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.LOV.TRIGGERING_ELEMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La acci\00F3n afecta al elemento de p\00E1gina o al componente que dispar\00F3 la acci\00F3n din\00E1mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99878201436304430)
,p_name=>'PE.PROPERTY.AFFECTED_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Selecci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99990802805304518)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Sin agregaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99990917513304518)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'Devuelve la columna de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100641196920305045)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione c\00F3mo agregar la columna de valores del gr\00E1fico asociados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100642627148305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.D'
,p_message_language=>'es'
,p_message_text=>'Recuento aproximado de valores distintos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100642708586305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.APPROX_COUNT_DISTINCT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Devuelve el n\00FAmero aproximado de valores distintos. Esta agregaci\00F3n es significativamente m\00E1s r\00E1pida que el <em>recuento de los valores distintos</em> al procesar grandes cantidades de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100641660823305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.D'
,p_message_language=>'es'
,p_message_text=>'Media'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100641719041305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.AVG.HELP'
,p_message_language=>'es'
,p_message_text=>'Devuelve la media de la columna de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100641238617305045)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.D'
,p_message_language=>'es'
,p_message_text=>'Recuento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100641381910305045)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Devuelve el n\00FAmero de registros.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100642417027305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.D'
,p_message_language=>'es'
,p_message_text=>'Recuento de los Valores Distintos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100642563196305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.COUNT_DISTINCT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Devuelve el n\00FAmero exacto de valores distintos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100642235517305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.D'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100642331038305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MAX.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Devuelve el valor m\00E1ximo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100641835981305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.D'
,p_message_language=>'es'
,p_message_text=>'Mediana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100641931599305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MEDIAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Devuelve el n\00FAmero medio e ignora los nulos. Esta agregaci\00F3n se ajusta mejor a un modelo de distribuci\00F3n continua, ya que devuelve el n\00FAmero del centro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100642056561305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.D'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100642138357305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.MIN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Devuelve el valor m\00EDnimo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100641419015305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.D'
,p_message_language=>'es'
,p_message_text=>'Suma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100641510644305046)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.LOV.SUM.HELP'
,p_message_language=>'es'
,p_message_text=>'Devuelve el total de la columna de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100641022108305045)
,p_name=>'PE.PROPERTY.AGGREGATE_FUNCTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Agregaci\00F3n de valores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99857672341304413)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione si el usuario final puede ejecutar la misma p\00E1gina m\00E1s de una vez.'),
unistr('Utilice esta funci\00F3n para evitar inserciones duplicadas en la misma tabla.'),
unistr('Esto puede ocurrir cuando un usuario final hace clic en el bot\00F3n Atr\00E1s del explorador y vuelve a ejecutar la p\00E1gina, o bien si el usuario final hace clic en el bot\00F3n Recargar del explorador.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100359248624304835)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>unistr('No: Evitar que Se Vuelva a Enviar la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100359315315304835)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED: Activar Volver a Enviar la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99857519668304413)
,p_name=>'PE.PROPERTY.ALLOW_DUPLICATE_PAGE_SUBMISSIONS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Activar Ejecuciones de P\00E1gina Duplicadas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100187462112304706)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si las columnas nulas se deben ocultar o no en la vista de registro \00FAnico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100187329426304706)
,p_name=>'PE.PROPERTY.ALLOW_EXCLUDE_NULL_VALUES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Excluir Valores Nulos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100187637216304706)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si solo se deben mostrar las columnas mostradas actualmente en la vista de registro \00FAnico. Si especifica <strong>Desactivado</strong>, tambi\00E9n se pueden mostrar en la vista de registro \00FAnico las columnas de informe no visualizadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100187548979304706)
,p_name=>'PE.PROPERTY.ALLOW_HIDE_EXTRA_COLUMNS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Solo Columnas Mostradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100181508493304702)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden agregar o no esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100181480206304702)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_AGGREGATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100181950327304702)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si los usuarios finales pueden utilizar o no esta columna en un gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100181868020304702)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CHART.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100181780833304702)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios pueden o no utilizar esta columna en una columna computacional que definan.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100181664689304702)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_COMPUTE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Calcular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100181394984304702)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si los usuarios finales pueden utilizar o no esta columna en una divisi\00F3n de control.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100181268025304701)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_CONTROL_BREAK.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Divisi\00F3n de Control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100180901581304701)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden filtrar o no esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100180874716304701)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_FILTER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100182112828304702)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden agrupar o no por esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100182080145304702)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_GROUP_BY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Agrupar por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100180547458304701)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden ocultar o no esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100180410769304701)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIDE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100181140837304701)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden resaltar o no esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100181068993304701)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_HIGHLIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Resaltar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99494341744304137)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifica si un usuario final puede definir un desglose din\00E1mico para este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99494255715304137)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_PIVOT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Din\00E1mico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100195429236304712)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si los usuarios finales pueden guardar su definici\00F3n de informe actual como un informe <em>P\00FAblico</em>.</p>'),
unistr('<p>Los informes p\00FAblicos se muestran en una lista de selecci\00F3n de informes disponibles en la barra de b\00FAsqueda y se muestran a todo el mundo.'),
unistr('La opci\00F3n del men\00FA Acciones solo est\00E1 disponible para los usuarios autenticados y se restringe a\00FAn m\00E1s si tambi\00E9n rellena el campo <strong>Guardar Autorizaci\00F3n de Informe P\00FAblico</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100195391738304712)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Guardar Informe P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100195252202304712)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si los usuarios finales pueden guardar su definici\00F3n de informe actual como un informe <em>Privado</em>.</p>'),
unistr('<p>Los informes privados se muestran en una lista de selecci\00F3n de informes disponibles en la barra de b\00FAsqueda y solo se muestran al usuario que ha guardado el informe, siempre y cuando se haya autenticado.'),
unistr('La opci\00F3n del men\00FA Acciones solo est\00E1 disponible para los usuarios autenticados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100195129948304712)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORTS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Guardar Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100195691319304712)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si los usuarios finales pueden guardar categor\00EDas de informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100195593471304712)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SAVE_REPORT_CATEGORIES.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Guardar Categor\00EDas de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100180767375304701)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden ordenar o no esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100180653419304701)
,p_name=>'PE.PROPERTY.ALLOW_USERS_TO_SORT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ordenar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100082393260304587)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la etiqueta alternativa que desee usar en los cuadro de di\00E1logo y en la Vista de Una Sola Fila.'),
'        Utilice una etiqueta alternativa si la cabecera contiene formato adicional, como etiquetas HTML, que no se muestra correctamente.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100082261656304587)
,p_name=>'PE.PROPERTY.ALTERNATIVE_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta Alternativa'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99959154889304494)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si esta validaci\00F3n se ejecutar\00E1 siempre.'),
unistr('Si se define en <strong>Activado</strong>, esta validaci\00F3n se eval\00FAa siempre, con independencia del valor en <em>Ejecutar Validaciones</em> definido en el bot\00F3n que ha ejecutado la p\00E1gina.'),
unistr('Si se define en <strong>Desactivado</strong>, esta validaci\00F3n solo se eval\00FAa si el bot\00F3n de disparador tiene el valor <strong>Activado</strong> en <em>Ejecutar Validaciones</em>.</p>'),
unistr('<p>Nota: esta validaci\00F3n tambi\00E9n debe cumplir con las condiciones especificadas antes de ser evaluada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99959036792304493)
,p_name=>'PE.PROPERTY.ALWAYS_EXECUTE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ejecutar Siempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100125275396304659)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione si la animaci\00F3n se muestra al cambiar los datos en el gr\00E1fico. Se puede producir un cambio de datos si los gr\00E1ficos se refrescan autom\00E1ticamente, si se lleva a cabo un comportamiento para ocultar y mostrar al hacer clic en el elemento d')
||unistr('e leyenda o cuando los datos del gr\00E1fico se actualizan de forma programada mediante alg\00FAn c\00F3digo de JavaScript personalizado o una acci\00F3n din\00E1mica.</p>'),
unistr('        <p>Las opciones <strong>Deslizar a la Izquierda</strong> y <strong>Deslizar a la Derecha</strong> no se aplican a los gr\00E1ficos de dial.</p>.  ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100125301843304659)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100255844506304758)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.AUTO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplique la configuraci\00F3n de animaci\00F3n por defecto definida por Oracle JET para el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100125680364304660)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100265317894304766)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.NONE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('No se aplica animaci\00F3n al gr\00E1fico cuando cambian los datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100125474782304659)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.D'
,p_message_language=>'es'
,p_message_text=>'Deslizar a la Izquierda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100265153845304765)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETOLEFT.HELP'
,p_message_language=>'es'
,p_message_text=>'Los elementos de datos se deslizan a la izquierda cuando cambian los datos. Este valor no se aplica a diagramas de Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100125520836304659)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.D'
,p_message_language=>'es'
,p_message_text=>'Deslizar a la Derecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100265235212304765)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.LOV.SLIDETORIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>'Los elementos de datos se deslizan a la derecha cuando cambian los datos. Este valor no se aplica a diagramas de Gantt.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100125160259304659)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DATA_CHANGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'En Cambio de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100124641233304659)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el tipo de animaci\00F3n que se va utilizar al mostrar inicialmente el gr\00E1fico.</p>'),
unistr('        <p>Las opciones <strong>Difuminado Alfa</strong> y <strong>Zoom</strong> no se aplican a los gr\00E1ficos de dial.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100124867528304659)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.D'
,p_message_language=>'es'
,p_message_text=>'Difuminado Alfa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100255596128304758)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ALPHAFADE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Difuminar el gr\00E1fico cuando se muestre inicialmente. Este valor no se aplica a los gr\00E1ficos de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100124719936304659)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100255427380304758)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.AUTO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplique la configuraci\00F3n de animaci\00F3n por defecto definida por Oracle JET para el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100125073402304659)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100255705049304758)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.NONE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('No se aplica ninguna animaci\00F3n al gr\00E1fico cuando se muestra inicialmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100124958431304659)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.D'
,p_message_language=>'es'
,p_message_text=>'Zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100255610526304758)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.LOV.ZOOM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Acercar el gr\00E1fico cuando se muestre inicialmente. Este valor no se aplica a los gr\00E1ficos de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100124594760304659)
,p_name=>'PE.PROPERTY.ANIMATION_ON_DISPLAY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Al Visualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100537122575304968)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100560229789304985)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100537907487304969)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases CSS adicionales delimitadas por espacios que desee agregar al informe. La plantilla del informe debe incluir la cadena de sustituci\00F3n <code>#COMPONENT_CSS_CLASSES#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100091808206304595)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases que desee agregar a este elemento. Puede agregar varias clases separ\00E1ndolas con espacios.<p/>'),
'',
unistr('        <p>Nota: Las clases CSS se aplicar\00E1n a las celdas de la cuadr\00EDcula interactiva. Para aplicar clases CSS al del elemento correspondiente, consulte la propiedad Clases CSS en el grupo avanzado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100536845426304968)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100536961196304968)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases que desee agregar a este elemento. Puede agregar varias clases separ\00E1ndolas con espacios.<p/>'),
unistr('        <p>Esta propiedad se puede utilizar para crear modificaciones de estilo en el elemento, m\00E1s all\00E1 de las opciones de plantilla, o para proporcionar una forma sencilla de seleccionar este elemento mediante JavaScript.</p>'),
'        <p>Nota: Para aplicar clases CSS a la etiqueta HTML del elemento de pantalla, consulte la propiedad Clases CSS en el grupo avanzado.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100537238604304968)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100538143003304969)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100538046741304969)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases CSS adicionales delimitadas por espacios que desee agregar al informe. La plantilla del informe debe incluir la cadena de sustituci\00F3n <code>#COMPONENT_CSS_CLASSES#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100536733855304968)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Agregar las clases CSS <code>articlenumber</code> y <code>highlight</code> al componente</dt>',
'<dd><pre>articlenumber highlight</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100536683392304968)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100536576227304968)
,p_name=>'PE.PROPERTY.APPEARANCE_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99495840651304138)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el \00E1mbito de este elemento de aplicaci\00F3n. Seleccione <strong>Global</strong> si la sesi\00F3n de &PRODUCT_NAME. se comparte entre m\00E1s de una aplicaci\00F3n y el valor del elemento debe ser el mismo para todas las aplicaciones.'),
unistr('De lo contrario, seleccione <strong>Aplicaci\00F3n<strong>, que es el \00E1mbito por defecto.</p>'),
unistr('<p>Las aplicaciones pueden compartir la misma sesi\00F3n si sus autenticaciones tienen los mismos <em>atributos de cookies de sesi\00F3n</em>.'),
unistr('El atributo de \00E1mbito de los elementos de las aplicaciones debe ser el mismo tambi\00E9n en dichas aplicaciones.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100391070597304859)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.APP.D'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100391179505304859)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.LOV.GLOBAL.D'
,p_message_language=>'es'
,p_message_text=>'Global'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99495774879304138)
,p_name=>'PE.PROPERTY.APP_ITEM_SCOPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1mbito')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100141875052304672)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si la serie actual se asigna al eje Y2 presentado en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100141777767304672)
,p_name=>'PE.PROPERTY.ASSIGNED_TO_Y2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Asignado al Eje Y2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99959752825304494)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna asociada a este componente de procesamiento de p\00E1ginas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99959659184304494)
,p_name=>'PE.PROPERTY.ASSOCIATED_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna Asociada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99959527689304494)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el elemento en el que mostrar este mensaje de error de validaci\00F3n.'),
unistr('Si selecciona un elemento y <em>Ubicaci\00F3n de Visualizaci\00F3n de Mensaje de Error</em> incluye "En L\00EDnea con Campo", el mensaje de error se muestra bajo la etiqueta del elemento especificado.'),
unistr('Si <em>Ubicaci\00F3n de Visualizaci\00F3n de Mensaje de Error</em> no incluye "En L\00EDnea con Campo", este atributo no afectar\00E1 a la visualizaci\00F3n del mensaje.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99959435738304494)
,p_name=>'PE.PROPERTY.ASSOCIATED_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento Asociado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100563274080304987)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.LOV.NATIVE_CUSTOM.D'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99941596563304480)
,p_name=>'PE.PROPERTY.AUTHENTICATION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99887170767304437)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el esquema de autorizaci\00F3n aplicado a la p\00E1gina. Los esquemas de autorizaci\00F3n se definen a nivel de aplicaci\00F3n y se pueden aplicar a varios elementos de la aplicaci\00F3n.</p>'),
unistr('<p>El esquema de autorizaci\00F3n se configura para su evaluaci\00F3n una vez por cada sesi\00F3n de la aplicaci\00F3n (en la creaci\00F3n de la sesi\00F3n) o una vez para cada vista de p\00E1gina. Si el esquema de autorizaci\00F3n seleccionado se eval\00FAa como <strong>TRUE</strong>,')
||unistr(' se muestra la p\00E1gina y est\00E1 sujeta a otras condiciones definidas. Si se eval\00FAa como <strong>FALSE</strong>, no se muestra la p\00E1gina y aparece un mensaje de error.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99856827732304412)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un esquema de autorizaci\00F3n para controlar este componente. La autorizaci\00F3n debe evaluarse como TRUE para que este componente se presente o se ejecute.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99856736775304412)
,p_name=>'PE.PROPERTY.AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99847734526304405)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el esquema de autorizaci\00F3n que se va a aplicar. No est\00E1n soportados los siguientes tipos de autorizaci\00F3n:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Seg\00FAn la configuraci\00F3n de la aplicaci\00F3n, puede tener disponibles aqu\00ED otros plugins de tipo de autorizaci\00F3n diferentes.'),
unistr('\00C9stos se muestran como <em>&lt;Mi Plugin&gt; [Plug-in]</em>.'),
unistr('Se han instalado los siguientes plugins dentro de los componentes compartidos de esta aplicaci\00F3n:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99847644778304405)
,p_name=>'PE.PROPERTY.AUTHORIZATION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100699645268305093)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el lenguaje que se va a utilizar para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100699914573305093)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100699872723305093)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100699737752305093)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100700097366305093)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100699576074305093)
,p_name=>'PE.PROPERTY.AUTO5N_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100700875598305094)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n. Las automatizaciones se pueden basar en tablas, consultas SQL o funciones PL/SQL que devuelvan una consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100700739770305094)
,p_name=>'PE.PROPERTY.AUTO5N_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100700635258305094)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100700552460305094)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n. Las automatizaciones se pueden basar en tablas, consultas SQL o funciones PL/SQL que devuelvan una consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100700483619305094)
,p_name=>'PE.PROPERTY.AUTO5N_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100700379079305094)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100700265180305094)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n. Las automatizaciones se pueden basar en tablas, consultas SQL o funciones PL/SQL que devuelvan una consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100700180464305094)
,p_name=>'PE.PROPERTY.AUTO5N_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100701012950305094)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n. Las automatizaciones se pueden basar en tablas, consultas SQL o funciones PL/SQL que devuelvan una consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100700901998305094)
,p_name=>'PE.PROPERTY.AUTO5N_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100699193037305093)
,p_name=>'PE.PROPERTY.AUTOMATION_ADDL_PLSQL_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100699051083305093)
,p_name=>'PE.PROPERTY.AUTOMATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100698952490305093)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el origen de los datos evaluados durante la ejecuci\00F3n de la automatizaci\00F3n. Las automatizaciones se pueden basar en tablas, consultas SQL o funciones PL/SQL que devuelvan una consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100698808178305092)
,p_name=>'PE.PROPERTY.AUTOMATION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Origen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100699498713305093)
,p_name=>'PE.PROPERTY.AUTO_ACTION_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100699310411305093)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de acci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100699209296305093)
,p_name=>'PE.PROPERTY.AUTO_ACTION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99998102459304523)
,p_name=>'PE.PROPERTY.AUTO_DETECT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si la interfaz de usuario adecuada se debe detectar autom\00E1ticamente.'),
unistr('Si la detecci\00F3n autom\00E1tica est\00E1 <strong>activada</strong>, el usuario se redireccionar\00E1 a la p\00E1gina de conexi\00F3n o p\00E1gina inicial correspondiente seg\00FAn el tama\00F1o del dispositivo en uso.'),
unistr('Las consultas de medios f\00EDsicos se utilizan para determinar la interfaz de usuario correspondiente que mostrar.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99998048245304523)
,p_name=>'PE.PROPERTY.AUTO_DETECT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Detecci\00F3n Autom\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100143877504304673)
,p_name=>'PE.PROPERTY.AXIS_MAX.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor m\00E1ximo del eje. Se define por defecto en nulo para el c\00E1lculo autom\00E1tico basado en los datos.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100143737521304673)
,p_name=>'PE.PROPERTY.AXIS_MAX.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100143649528304673)
,p_name=>'PE.PROPERTY.AXIS_MIN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor m\00EDnimo del eje. Se define por defecto en nulo para el c\00E1lculo autom\00E1tico basado en los datos.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100143559316304673)
,p_name=>'PE.PROPERTY.AXIS_MIN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100144650931304674)
,p_name=>'PE.PROPERTY.AXIS_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la posici\00F3n de las etiquetas que se van a presentar en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100144779863304674)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100145112861304674)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'es'
,p_message_text=>'Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100144980724304674)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.END.D'
,p_message_language=>'es'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100144853516304674)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.START.D'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100145013291304674)
,p_name=>'PE.PROPERTY.AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'es'
,p_message_text=>'Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100144556425304674)
,p_name=>'PE.PROPERTY.AXIS_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100167090882304691)
,p_name=>'PE.PROPERTY.AXIS_SCALING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la escala del eje. Solo se aplica a los ejes num\00E9ricos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100167161131304691)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LINEAR.D'
,p_message_language=>'es'
,p_message_text=>'Lineal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100167214162304691)
,p_name=>'PE.PROPERTY.AXIS_SCALING.LOV.LOG.D'
,p_message_language=>'es'
,p_message_text=>'Log'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100166996287304691)
,p_name=>'PE.PROPERTY.AXIS_SCALING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Escala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100144478049304674)
,p_name=>'PE.PROPERTY.AXIS_STEP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el incremento entre las marcas principales. Se define en nulo para el c\00E1lculo autom\00E1tico basado en los datos. Solo se aplica a los ejes de tiempo y num\00E9ricos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100144314093304674)
,p_name=>'PE.PROPERTY.AXIS_STEP.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Escal\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100551369712304979)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que se utilizar\00E1 como placa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100551285732304978)
,p_name=>'PE.PROPERTY.BADGE_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna Placa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100551581537304979)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100551482425304979)
,p_name=>'PE.PROPERTY.BADGE_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de placa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100551889568304979)
,p_name=>'PE.PROPERTY.BADGE_LABEL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('  <dt>Para mostrar evaluaciones de pel\00EDculas</dt>'),
'    <dd>Puede que la columna Placa sea la columna RATING y que la etiqueta de placa sea "Stars".</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100551721626304979)
,p_name=>'PE.PROPERTY.BADGE_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la etiqueta de placa a fin de describir el valor de placa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100551602333304979)
,p_name=>'PE.PROPERTY.BADGE_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de placa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100246893467304751)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique cu\00E1ndo comienza el calendario. Al seleccionar esta opci\00F3n, se crea un calendario que abarca un intervalo entero (por ejemplo, un mes).</p>'),
'<ul>',
unistr('<li>Si la opci\00F3n Empezar en el Inicio del Intervalo est\00E1<strong>activada</strong>, la fecha es el 15 de junio y la visualizaci\00F3n es mensual, el calendario resultante abarca del 1 al 30 de junio.</li>'),
unistr('<li>Si la opci\00F3n Empezar en el Inicio del Intervalo est\00E1<strong>desactivada</strong>, la fecha es el 15 de junio y la visualizaci\00F3n es mensual, el calendario resultante abarca del 15 al 30 de junio.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100246756786304751)
,p_name=>'PE.PROPERTY.BEGIN_AT_START_OF_INTERVAL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Empezar en el Inicio del Intervalo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100218156934304729)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna del juego de caracteres de la tabla en la que almacena el contenido BLOB que desea mostrar. Es poco probable que la imagen se muestre si selecciona una columna con el tipo de datos incorrecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100218065056304728)
,p_name=>'PE.PROPERTY.BLOB_CHARSET_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Juego de Caracteres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100217188022304728)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna BLOB de la tabla en la que almacena el contenido BLOB que desea mostrar. Es poco probable que la imagen se muestre si selecciona una columna con el tipo de datos incorrecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100217073777304728)
,p_name=>'PE.PROPERTY.BLOB_CONTENT_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100217977085304728)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la columna del nombre de archivo de la tabla en la que almacena el contenido BLOB que desea mostrar. Es poco probable que la imagen se muestre si selecciona una columna con el tipo de datos incorrecto.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100217860113304728)
,p_name=>'PE.PROPERTY.BLOB_FILENAME_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Nombre de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100218356450304729)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la \00FAltima columna actualizada de la tabla en la que se almacena el contenido BLOB que desea mostrar. Si ya tiene una columna <code>UPDATED</code> con un disparador asociado para mantener la fecha, podr\00EDa utilizar esta columna en lugar de d')
||unistr('efinir una nueva columna de manera espec\00EDfica para cuando la imagen se haya actualizado por \00FAltima vez. Sin embargo, si otras columnas, aparte del contenido BLOB, se actualizan regularmente, esto afecta negativamente al almacenamiento en cach\00E9 de im\00E1')
||'genes. Es poco probable que se muestre la imagen si selecciona una columna con el tipo de datos incorrecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100218283625304729)
,p_name=>'PE.PROPERTY.BLOB_LAST_UPDATED_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima Columna Actualizada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100217765882304728)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna de tipo MIME de la tabla en la que almacena el contenido BLOB que desea mostrar. Es poco probable que la imagen se muestre si selecciona una columna con el tipo de datos incorrecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100217689032304728)
,p_name=>'PE.PROPERTY.BLOB_MIME_TYPE_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Tipo MIME'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100217306957304728)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la primera columna de clave primaria de la tabla en la que almacena el contenido BLOB que desea mostrar. Si la clave primaria de esta tabla tiene m\00E1s de dos columnas, debe seleccionar la columna <code>ROWID</code>. Es poco probable que la ')
||'imagen se muestre si selecciona una columna con el tipo de datos incorrecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100217282913304728)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN1.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100217531531304728)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.HELP'
,p_message_language=>'es'
,p_message_text=>'Solo seleccione la segunda columna de clave primaria si la clave primaria de la tabla tiene dos columnas. Si selecciona <code>ROWID</code> para la primera columna de clave primaria, no debe rellenar esta columna. Es poco probable que la imagen se mue'
||'stre si selecciona una columna con el tipo de datos incorrecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100217412318304728)
,p_name=>'PE.PROPERTY.BLOB_PK_COLUMN2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100216951307304728)
,p_name=>'PE.PROPERTY.BLOB_TABLE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Introduzca el nombre de la tabla en la que se almacena el contenido BLOB que desea mostrar.',
'Puede escribir el nombre de la tabla o elegirlo en la lista de tablas disponibles.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100216864771304728)
,p_name=>'PE.PROPERTY.BLOB_TABLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre de la Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100216739988304727)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el esquema propietario de la tabla en la que almacena el contenido BLOB que desea mostrar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100216611251304727)
,p_name=>'PE.PROPERTY.BLOB_TABLE_OWNER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Propietario de Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100546996375304975)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea que se muestre este componente usando un formato avanzado o de columna mediante expresiones HTML y cadenas de sustituci\00F3n soportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100546828772304975)
,p_name=>'PE.PROPERTY.BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formato Avanzado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100547192259304975)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que se utilizar\00E1 como cuerpo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100547061122304975)
,p_name=>'PE.PROPERTY.BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100547632905304976)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100547587193304976)
,p_name=>'PE.PROPERTY.BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99856414759304412)
,p_name=>'PE.PROPERTY.BODY_HEADER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el texto o HTML que desea que aparezca antes de las regiones que se muestran en la p\00E1gina en ejecuci\00F3n.'),
unistr('El texto introducido aqu\00ED aparece antes de la cadena de sustituci\00F3n <code>#BODY#</code> de la plantilla de p\00E1gina.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99856316874304412)
,p_name=>'PE.PROPERTY.BODY_HEADER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Cabecera de Cuerpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100547408477304976)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Cambiar los colores del fondo y del texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Utilizar Cabecera 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utilizar una clase din\00E1mica de la consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Las sustituciones <code>&COLUMN_CLASS.</code> y <code>&EMPLOYEE_STATUS.</code> de este ejemplo son columnas seleccionadas en la consulta SQL de informe.</dd>',
'  <dt>Mostrar una imagen y una pista al pasar el mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100547370823304976)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las expresiones HTML que se mostrar\00E1n en esta columna. Utilice la sintaxis <code>&COLUMN.</code> para mostrar valores de columna en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100547280408304975)
,p_name=>'PE.PROPERTY.BODY_HTML_EXPR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100238002839304744)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la solicitud que se va a incluir en el enlace de la bifurcaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100237908146304744)
,p_name=>'PE.PROPERTY.BRANCH_ACCEPT_REQUEST.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Solicitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100636394195305042)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el lenguaje que se va a utilizar para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100636676354305042)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100636529625305042)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100636415949305042)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100636787353305042)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100636268326305042)
,p_name=>'PE.PROPERTY.BRANCH_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100211725481304724)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene un n\00FAmero de p\00E1gina o URL a la que redirigirse.'),
unistr('Este elemento lo puede definir la p\00E1gina que realiza la llamada o un proceso al cargar la p\00E1gina por primera vez.'),
unistr('La especificaci\00F3n de un elemento constituye una forma sencilla de definir din\00E1micamente las bifurcaciones de las p\00E1ginas que se llaman desde muchas otras p\00E1ginas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100211663786304724)
,p_name=>'PE.PROPERTY.BRANCH_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100637516649305043)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n Java que devuelve un n\00FAmero de p\00E1gina o URL a la que redireccionar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100637413284305043)
,p_name=>'PE.PROPERTY.BRANCH_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100637352639305043)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100637210958305042)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n JavaScript que devuelve un n\00FAmero de p\00E1gina o URL a la que redireccionar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100637115178305042)
,p_name=>'PE.PROPERTY.BRANCH_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99958083505304493)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la p\00E1gina a la que se redireccionar\00E1 esta bifurcaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99957934089304493)
,p_name=>'PE.PROPERTY.BRANCH_PAGE_NUMBER.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99958264098304493)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el c\00F3digo PL/SQL que ha ejecutado la bifurcaci\00F3n. Este procedimiento PL/SQL es responsable de llamar a la URL necesaria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99958197369304493)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100637073160305042)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100636945620305042)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n PL/SQL que devuelve un n\00FAmero de p\00E1gina o URL a la que redireccionar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100636871224305042)
,p_name=>'PE.PROPERTY.BRANCH_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99957687539304492)
,p_name=>'PE.PROPERTY.BRANCH_POINT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el punto del procesamiento o la presentaci\00F3n de p\00E1gina en el que se ejecuta esta bifurcaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100379500238304850)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.D'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Procesamiento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100669132831305067)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.AFTER_PROCESSING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento: realiza bifurcaciones despu\00E9s de realizar el procesamiento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100379218110304850)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100668848188305067)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_COMPUTATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento: realiza bifurcaciones despu\00E9s de enviar la p\00E1gina y antes de ejecutar el c\00E1lculo, las validaciones y los procesos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100379634857304850)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'es'
,p_message_text=>'Antes de Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100669220386305067)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: realiza bifurcaciones antes de presentar la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100379432524304850)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.D'
,p_message_language=>'es'
,p_message_text=>'Procesamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100669053709305067)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_PROCESSING.HELP'
,p_message_language=>'es'
,p_message_text=>'Procesamiento: realiza bifurcaciones antes de realizar el procesamiento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100379307697304850)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.D'
,p_message_language=>'es'
,p_message_text=>'Validando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100668995666305067)
,p_name=>'PE.PROPERTY.BRANCH_POINT.LOV.BEFORE_VALIDATION.HELP'
,p_message_language=>'es'
,p_message_text=>'Procesamiento: realiza bifurcaciones antes de realizar las validaciones.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99957516780304492)
,p_name=>'PE.PROPERTY.BRANCH_POINT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Punto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100637741454305043)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n Python que devuelve un n\00FAmero de p\00E1gina o URL a la que redireccionar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100637601576305043)
,p_name=>'PE.PROPERTY.BRANCH_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99957455233304492)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el tipo de bifurcaci\00F3n de p\00E1gina que desea realizar.</p>'),
'<dl>',
'<dt>Redireccionar bifurcaciones</dt>',
unistr('<dd>&PRODUCT_NAME. devuelve la nueva p\00E1gina o URL al explorador, que emite una nueva solicitud antes de mostrar la p\00E1gina resultante.'),
unistr('La principal ventaja es que el usuario final puede refrescar la p\00E1gina sin perder contexto, ya que la direcci\00F3n del explorador contiene la URL de p\00E1gina completa.'),
unistr('La desventaja es que el explorador emite una solicitud adicional para mostrar la p\00E1gina.</dd>'),
'<dt>Mostrar solo bifurcaciones</dt>',
unistr('<dd>&PRODUCT_NAME. presenta inmediatamente la nueva p\00E1gina como parte del procesamiento de p\00E1ginas actual, sin emitir otra solicitud.'),
unistr('Esta acci\00F3n tiene la ventaja de que el explorador no tiene que emitir una solicitud adicional.'),
unistr('La principal desventaja es que la direcci\00F3n del explorador deber\00E1 ser <code>wwv_flow.accept</code>.'),
unistr('Si los usuarios finales refrescan la p\00E1gina, el explorador pedir\00E1 que se reenv\00EDen los datos, ya que la direcci\00F3n del explorador no es una URL de p\00E1gina completa.</dd>'),
'</dl>',
unistr('<p>Oracle recomienda seleccionar uno de los tipos de bifurcaci\00F3n de redireccionamiento para proporcionar una mejor experiencia del usuario.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100378663948304849)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_PAGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n Que Devuelve una P\00E1gina (Mostrar Solo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100378770255304849)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_FUNCTION_RETURNING_URL.D'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n Que Devuelve una URL (Redirigir)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100379191178304850)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_ACCEPT.D'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento de P\00E1gina {no com\00FAn}')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100378938696304850)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_PAGE_IDENT_BY_ITEM.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Identificada por Elemento (Mostrar Solo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100378556333304849)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_STEP.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina (Mostrar Solo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100379087330304850)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.BRANCH_TO_URL_IDENT_BY_ITEM.D'
,p_message_language=>'es'
,p_message_text=>'URL Identificada por Elemento (Redirigir)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100378823050304850)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'Procedimiento PL/SQL [heredado]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100378497242304849)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina o URL (Redirigir)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99957395665304492)
,p_name=>'PE.PROPERTY.BRANCH_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99495637296304138)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Selecciona la plantilla de ruta de navegaci\00F3n utilizada con esta ruta de navegaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99495578586304138)
,p_name=>'PE.PROPERTY.BREADCRUMB_TEMPLATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100223734269304733)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que se muestra despu\00E9s de las columnas divisorias al visualizar una fila divisoria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100223643270304733)
,p_name=>'PE.PROPERTY.BREAK_AFTER_ROW.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Fila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100223390505304733)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el texto que se muestra antes de las columnas divisorias al visualizar una fila divisoria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100223227625304732)
,p_name=>'PE.PROPERTY.BREAK_BEFORE_ROW.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Antes de Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100234050057304741)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Sin Divisi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100235240688304742)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Sin Divisi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100222528935304732)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el n\00FAmero de columnas del informe que se incorporan en el formato de divisi\00F3n. Las columnas deben ser consecutivas, comenzando a partir de la primera columna que se muestra en el informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100401587255304866)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1.D'
,p_message_language=>'es'
,p_message_text=>'Primera Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100401631304304866)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2.D'
,p_message_language=>'es'
,p_message_text=>'Primera y Segunda Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100401753311304866)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.LOV.1:2:3.D'
,p_message_language=>'es'
,p_message_text=>'Primera, Segunda y Tercera Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100222432506304732)
,p_name=>'PE.PROPERTY.BREAK_COLUMNS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columnas Divisorias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100222798421304732)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la forma en que las divisiones afectan al formato de visualizaci\00F3n del informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100402055140304867)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.D'
,p_message_language=>'es'
,p_message_text=>unistr('Formato de Divisi\00F3n por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100402135770304867)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.DEFAULT_BREAK_FORMATTING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los saltos se muestran en un \00FAnico informe sin repetir las cabeceras para cada salto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100401827016304866)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.D'
,p_message_language=>'es'
,p_message_text=>'Repetir Cabeceras Divisorias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100401965170304866)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.LOV.REPEAT_HEADINGS_ON_BREAK_1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El informe se muestra en forma de varios subinformes con cabeceras de repetici\00F3n para cada salto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100222624736304732)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_STYLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100223190655304732)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el texto que se muestra en las divisiones de informes. Utilice sustituciones de <code>#SUM_COLUMN_HEADER#</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100223004482304732)
,p_name=>'PE.PROPERTY.BREAK_COLUMN_TEXT_FORMAT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Formato de Divisi\00F3n de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100223500071304733)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto para la columna de divisi\00F3n al mostrar una divisi\00F3n de informe. Puede utilizar sustituciones de <code>#COLUMN_VALUE#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100223480136304733)
,p_name=>'PE.PROPERTY.BREAK_GENERIC_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Formato de Divisi\00F3n de Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100222930760304732)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto para las cabeceras de repetici\00F3n que se muestran para las divisiones de informes. Puede utilizar sustituciones de <code>#COLUMN_VALUE#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100222810071304732)
,p_name=>'PE.PROPERTY.BREAK_REPEAT_HEADING_FORMAT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Repetir Formato de Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100233238020304740)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor por Defecto de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100674353075305071)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Utiliza el valor definido en los atributos de seguridad de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99858489320304414)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si se activa la cach\00E9, el explorador puede guardar el contenido de las p\00E1ginas de la aplicaci\00F3n en su cach\00E9, tanto en memoria como en disco.'),
unistr('Si un usuario hace clic en el bot\00F3n Atr\00E1s del explorador, la p\00E1gina se carga normalmente desde la cach\00E9, no desde el servidor.'),
unistr('Si la cach\00E9 est\00E1 desactivada, se indica al explorador que no guarde el contenido de la p\00E1gina y que solicite una nueva del servidor.</p>'),
unistr('<p>Desde el punto de vista de la seguridad, Oracle recomienda que se desactive la cach\00E9 para que el explorador no almacene datos confidenciales y siempre solicite p\00E1ginas si cambia la URL.'),
unistr('De lo contrario, se podr\00EDa incluso volver al historial del explorador despu\00E9s de una desconexi\00F3n y ver el contenido almacenado en cach\00E9 de la sesi\00F3n anterior.'),
unistr('La desactivaci\00F3n de la cach\00E9 del explorador evitar\00E1 peque\00F1os problemas del bot\00F3n Atr\00E1s con las p\00E1ginas que utilizan refrescamientos parciales de p\00E1gina, como los informes interactivos.</p>'),
unistr('<p>Si este atributo se define en <strong>Desactivado</strong>, &PRODUCT_NAME. env\00EDa la cabecera HTTP <em>cache-control: no-store</em>, que indica al explorador que no almacene en cach\00E9 el contenido de la p\00E1gina en disco o en memoria.'),
unistr('Si se define en <strong>Valor por Defecto de la Aplicaci\00F3n</strong>, se utilizar\00E1 el valor en tiempo de ejecuci\00F3n del atributo <em>Cach\00E9 de Explorador</em> de la aplicaci\00F3n.</p>'),
unistr('<p>Nota: esta funci\00F3n necesita exploradores actualizados que soporten la variable de respuesta de cabecera HTTP <code>cache-control</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100361615305304837)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100361572348304837)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99858339194304414)
,p_name=>'PE.PROPERTY.BROWSER_CACHE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cach\00E9 de Explorador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100743257547305126)
,p_name=>'PE.PROPERTY.BUILD_OPTION.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>1. Est\00E1 desarrollando una aplicaci\00F3n que tendr\00E1 varias instalaciones.'),
unistr('                                        Adem\00E1s, cada instalaci\00F3n puede optar por activar o desactivar determinada funcionalidad de la aplicaci\00F3n.'),
unistr('                                        Con las opciones de creaci\00F3n, puede desarrollar una aplicaci\00F3n y, una vez instalada, se pueden configurar las opciones de creaci\00F3n para incluir o excluir la funcionalidad de la aplicaci\00F3n asociada.'),
unistr('                                        Tambi\00E9n puede utilizar la API para exponer esta funci\00F3n dentro de la aplicaci\00F3n.'),
unistr('                                        Esto permite a los usuarios finales con privilegios activar o desactivar de forma selectiva la funcionalidad de la aplicaci\00F3n.</p>'),
unistr('                                      <p>2. Est\00E1 desarrollando una funcionalidad que a\00FAn no se ha completado, por lo que no desea exponerla a los usuarios finales.'),
unistr('									    El uso de las opciones de creaci\00F3n le permite desactivar esta funcionalidad de la aplicaci\00F3n si va incorporada a los entornos de prueba y producci\00F3n.'),
unistr('									    La ventaja de este enfoque es que la aplicaci\00F3n puede seguir despleg\00E1ndose sin incluir la funcionalidad incompleta.</p>'),
unistr('                                      <p>3. Est\00E1 eliminando funcionalidad que considera innecesaria para la aplicaci\00F3n, pero no est\00E1 seguro de si esta operaci\00F3n es segura.'),
unistr('									    En este caso, puede utilizar las opciones de creaci\00F3n para, esencialmente, "introducir un comentario" sobre la funcionalidad espec\00EDfica.'),
'									    Si se considera necesaria la funcionalidad eliminada durante el proceso de despliegue, puede volver a instalarse.',
unistr('									    Si esta funcionalidad se ha considerado innecesaria, puede eliminarse de la aplicaci\00F3n de forma segura.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99858650591304414)
,p_name=>'PE.PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una opci\00F3n de creaci\00F3n para este componente.</p>'),
unistr('                                     <p>Las opciones de creaci\00F3n permiten a los componentes y funcionalidades de la aplicaci\00F3n que se activen o desactiven de forma condicional cuando la aplicaci\00F3n est\00E1 instalada o en tiempo de ejecuci\00F3n mediante API ')
||'(APEX_UTIL.SET_BUILD_OPTION_STATUS).<br>',
unistr('                                       Las opciones de creaci\00F3n pueden definir este componente para que se incluya o excluya en la aplicaci\00F3n en tiempo de ejecuci\00F3n:</p>'),
unistr('									 <p><strong>Incluido</strong>: Componente activado y forma parte de la aplicaci\00F3n.</p>'),
unistr('									 <p><strong>Excluido</strong>: Componente desactivado y no forma parte de la aplicaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99858529673304414)
,p_name=>'PE.PROPERTY.BUILD_OPTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Opci\00F3n de Creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99847121764304405)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique un estado de opci\00F3n de creaci\00F3n para este componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100355573170304832)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.D'
,p_message_language=>'es'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100355661093304832)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.EXCLUDE.HELP'
,p_message_language=>'es'
,p_message_text=>'El motor de &PRODUCT_NAME. considera que este componente no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100355399675304832)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.D'
,p_message_language=>'es'
,p_message_text=>'Incluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100355447369304832)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.LOV.INCLUDE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El motor de &PRODUCT_NAME. considera este componente como parte de la definici\00F3n de aplicaci\00F3n en tiempo de ejecuci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99847079584304405)
,p_name=>'PE.PROPERTY.BUILD_OPTION_STATUS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99960728338304495)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la acci\00F3n que se va a realizar al hacer clic en este bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100381323102304851)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.D'
,p_message_language=>'es'
,p_message_text=>unistr('Definida por Acci\00F3n Din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100381473918304852)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.DEFINED_BY_DA.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('No ejecuta la p\00E1gina ni redirige a otra. En su lugar, el comportamiento del bot\00F3n se define mediante una acci\00F3n din\00E1mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100381708986304852)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Siguiente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100381838652304852)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.NEXT_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Redirige a la siguiente p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100381922894304852)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Anterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100382043989304852)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.PREVIOUS_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Redirige a la p\00E1gina anterior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100380921758304851)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.D'
,p_message_language=>'es'
,p_message_text=>unistr('Redirigir a P\00E1gina en Otra Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100381045866304851)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_APP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Redirija a una p\00E1gina en otra aplicaci\00F3n, con atributos adicionales opcionales para restablecer la paginaci\00F3n, definir el valor de solicitud, borrar la cach\00E9 y definir los valores del elemento en la p\00E1gina de destino.</p>'),
unistr('<p>Nota: La redirecci\00F3n a una p\00E1gina en una aplicaci\00F3n diferente depende de que se active el enlace profundo en la aplicaci\00F3n de destino. Para activar el enlace profundo, vaya a los atributos de <em>seguridad</em> de la aplicaci\00F3n y active <em>Enlace')
||' profundo</em>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100380760605304851)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Redirigir a P\00E1gina en esta Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100380866487304851)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Redirige a una p\00E1gina en la aplicaci\00F3n actual, con atributos adicionales opcionales para restablecer la paginaci\00F3n, definir el valor de solicitud, borrar la cach\00E9 y definir los valores del elemento en la p\00E1gina de destino.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100381129541304851)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.D'
,p_message_language=>'es'
,p_message_text=>'Redirigir a URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100381270388304851)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.REDIRECT_URL.HELP'
,p_message_language=>'es'
,p_message_text=>'Redirige a la URL de destino que especifique.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100381523354304852)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.D'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100381653810304852)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.RESET.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Restablece la p\00E1gina realizando un refrescamiento de p\00E1gina completo, en lugar de un refrescamiento de p\00E1gina parcial (PPR).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100380528892304851)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.D'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecutar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100380622579304851)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.LOV.SUBMIT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecuta la p\00E1gina actual con un valor REQUEST igual al nombre del bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99960634070304495)
,p_name=>'PE.PROPERTY.BUTTON_ACTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99864072680304418)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el tipo de operaci\00F3n SQL que se realizar\00E1 al hacer clic en este bot\00F3n.'),
unistr('Esta selecci\00F3n se utiliza para disparar la acci\00F3n de la base de datos especificada en el procesamiento autom\00E1tico de filas (DML) incorporado.'),
unistr('Si no selecciona un tipo, el procesamiento de la base de datos se ejecuta en funci\00F3n del valor REQUEST, que se define seg\00FAn lo configurado en <strong>Nombre de Bot\00F3n</strong> para este bot\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100375590949304847)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.DELETE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n DELETE de SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100375307595304847)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.INSERT.D'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n INSERT de SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100375433843304847)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.LOV.UPDATE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n UPDATE de SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99863958482304418)
,p_name=>'PE.PROPERTY.BUTTON_DATABASE_ACTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n de Base de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100558704645304984)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un tipo de visualizaci\00F3n de bot\00F3n para definir la apariencia de este bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100559051168304984)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'es'
,p_message_text=>'Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100559188709304984)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'es'
,p_message_text=>'Solo muestra un icono.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100558892734304984)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100558951993304984)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Solo muestra la etiqueta de bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100559226105304985)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.D'
,p_message_language=>'es'
,p_message_text=>'Texto con icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100559304323304985)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.LOV.TEXT_WITH_ICON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra un icono junto a la etiqueta de bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100558622619304984)
,p_name=>'PE.PROPERTY.BUTTON_DISPLAY_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100660588554305060)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca los atributos adicionales que se van a mostrar despu\00E9s de que la celda de tabla HTML que muestra cada una de las opciones de un grupo de botones de radio o de un juego de casillas de control.'),
'Puede incluir HTML, JavaScript y accesos directos.</p>',
unistr('<p>Puede hacer referencia a las siguientes cadenas de sustituci\00F3n:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Obtiene el nombre del elemento de pantalla HTML al que este elemento de p\00E1gina est\00E1 asociado.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Obtiene el nombre del elemento de p\00E1gina actual.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100660443510305060)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Posterior a Texto '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100660356708305060)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca los atributos adicionales mostrados antes de la celda de tabla HTML que muestra cada una de las opciones de un grupo de botones de radio o de un juego de casillas de control.',
'Puede incluir HTML, JavaScript y accesos directos.</p>',
unistr('<p>Puede hacer referencia a las siguientes cadenas de sustituci\00F3n:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Obtiene el nombre del elemento de pantalla HTML al que este elemento de p\00E1gina est\00E1 asociado.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Obtiene el nombre del elemento de p\00E1gina actual.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100660223282305060)
,p_name=>'PE.PROPERTY.BUTTON_ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Anterior a Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99863826140304418)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si se ejecuta la p\00E1gina y este atributo est\00E1 definido en <strong>Activado</strong>, se ejecutan todas las validaciones definidas para la p\00E1gina, as\00ED como las validaciones incorporadas (como las necesarias, el n\00FAmero v\00E1lido o la fecha v\00E1lida) en el')
||' servidor.',
unistr('Adem\00E1s, si la opci\00F3n <em>Modo de Compatibilidad</em> de la aplicaci\00F3n est\00E1 definida en <strong>5.1</strong> o superior, &PRODUCT_NAME. tambi\00E9n realizar\00E1 validaciones del cliente, por ejemplo, las necesarios para elementos. Consulte "Modo de Compatibi')
||unistr('lidad" en las notas t\00E9cnicas sobre la versi\00F3n para obtener m\00E1s detalles.'),
unistr('La p\00E1gina no se ejecutar\00E1 hasta que se solucionen todos los problemas.</p>'),
'<p>Si se ha definido en <strong>Desactivado</strong>, no se ejecuta ninguna de las validaciones definidas ni las incorporadas.',
unistr('Si desea ejecutar una validaci\00F3n espec\00EDfica que sea independiente de este valor, modifique la validaci\00F3n y defina el atributo de validaci\00F3n <strong>Ejecutar Siempre</strong> en <strong>Activado</strong>.</p>'),
unistr('<p>Este atributo resulta especialmente \00FAtil para los botones Suprimir o Cancelar donde la mayor\00EDa de las validaciones no deben ejecutarse.'),
unistr('Los usuarios no deben parar por lo general la ejecuci\00F3n de dichas acciones si un elemento es nulo o de un tipo err\00F3neo.'),
unistr('Sin embargo, si las acciones, como Suprimir, solo deben ejecutarlas los usuarios autorizados, es importante definir el atributo de validaci\00F3n correspondiente <strong>Ejecutar Siempre</strong> en <strong>Activado</strong> o asegurarse de que haya una ')
||unistr('condici\00F3n adecuada definida en el propio bot\00F3n, para que dicho bot\00F3n solo se muestre a los usuarios autorizados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99863711338304418)
,p_name=>'PE.PROPERTY.BUTTON_EXECUTE_VALIDATIONS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ejecutar Validaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100560186298304985)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea utilizar el bot\00F3n <strong>Normal</strong> o <strong>Directo</strong> al representar este bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99863412258304418)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea utilizar o no la plantilla de bot\00F3n <strong>Normal</strong> o <strong>Directa</strong> al presentar este bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99863398384304418)
,p_name=>'PE.PROPERTY.BUTTON_IS_HOT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Directa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100559929051304985)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que se muestra en el bot\00F3n. Si el tipo de visualizaci\00F3n de bot\00F3n es un icono, este texto se convierte en el texto alternativo para la imagen del icono.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99876794256304428)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Si el bot\00F3n es texto, introduzca el texto que se muestra en el bot\00F3n. Si el bot\00F3n es una imagen, este texto se convierte en el texto alternativo para la imagen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99876655677304428)
,p_name=>'PE.PROPERTY.BUTTON_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99887637690304438)
,p_name=>'PE.PROPERTY.BUTTON_NAME.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre utilizado para hacer referencia al bot\00F3n en el que va a hacer clic. Cuando se ejecuta esta p\00E1gina, el valor de REQUEST se define en este nombre de bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99876532201304428)
,p_name=>'PE.PROPERTY.BUTTON_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre utilizado para identificar este bot\00F3n en los siguientes procesamientos de p\00E1ginas.'),
unistr('Cuando se ejecuta la p\00E1gina, al pulsar este bot\00F3n, el valor REQUEST se define en el nombre introducido.</p>'),
unistr('<p>No es necesario que el nombre de bot\00F3n sea \00FAnico para los botones de la misma p\00E1gina o de la misma regi\00F3n.'),
unistr('Puede definir varios botones con el mismo nombre, que al pulsarse, definir\00E1 el mismo valor de REQUEST.'),
unistr('Esto es \00FAtil para definir botones con diferentes valores <strong>Etiquetas de Bot\00F3n</strong> o condiciones, que necesitan ejecutar el mismo procesamiento de p\00E1gina, simplemente evaluando el valor com\00FAn de REQUEST.</p>'),
unistr('<p>Si le asigna un nombre al bot\00F3n <code>FLOW_RESET_BUTTON</code>, dicho bot\00F3n restablece la p\00E1gina actual sin realizar una ejecuci\00F3n de p\00E1gina.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99876463893304428)
,p_name=>'PE.PROPERTY.BUTTON_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre del Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100659937254305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Al hacer clic en este bot\00F3n, se ejecutar\00E1 la p\00E1gina y se definir\00E1 la solicitud de p\00E1gina en funci\00F3n de este valor. Si este valor es nulo y el <em>Tipo de Origen de Solicitud</em> es <em>Valor Est\00E1tico</em>, se utilizar\00E1 el nombre del bot\00F3n como el va')
||'lor de solicitud.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100659865364305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Origen de Solicitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100657856869305058)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Identifica el tipo de expresi\00F3n contenido en el atributo de origen de la solicitud. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100659669632305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'es'
,p_message_text=>'Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100659745334305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>'Definir en Nulo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100658145574305058)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100658249714305058)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de columna introducido en <em>Columna de Base de Datos</em>, obtenido mediante un proceso de recuperaci\00F3n de fila incorporado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100659053987305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100659131030305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor resultante al ejecutar la <em>expresi\00F3n PL/SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100659272794305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100659358105305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde el <em>cuerpo de la funci\00F3n PL/SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100658342610305058)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100658514667305058)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de estado de sesi\00F3n del <em>elemento</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100659455749305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100659594773305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn la <em>preferencia</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100658602617305058)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Consulta SQL (devolver valor \00FAnico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100658787597305058)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el primer valor devuelto desde la <em>consulta SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100658881400305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL (devolver valores separados por dos puntos)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100658965802305059)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor \00FAnico delimitado por dos puntos, que concatena el valor de cada columna, devuelto desde la <em>consulta SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100657952393305058)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100658059503305058)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el texto introducido en <em>Valor Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100657712624305058)
,p_name=>'PE.PROPERTY.BUTTON_REQUEST_SOURCE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Origen de Solicitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99863614352304418)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic en el destino para llamar a un cuadro de di\00E1logo modal. Puede introducir el destino al que se va a llamar cuando se haga clic en este bot\00F3n. Introduzca solo un destino para los botones que no deben llamar al procesamiento de p\00E1ginas al hace')
||unistr('r clic (por ejemplo, un bot\00F3n de cancelaci\00F3n).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99863578163304418)
,p_name=>'PE.PROPERTY.BUTTON_TARGET.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99863244679304417)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione una plantilla de bot\00F3n para definir la apariencia de este bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99863150881304417)
,p_name=>'PE.PROPERTY.BUTTON_TEMPLATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100539416828304970)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor por Defecto de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100560506903304985)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.BUTTON.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Compruebe si hay cambios sin guardar al hacer clic en el bot\00F3n si la comprobaci\00F3n est\00E1 activada a nivel de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100539133568304969)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se advierte al usuario cuando intenta salir de la p\00E1gina haciendo clic en el bot\00F3n y no se han guardado los cambios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100539225436304970)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'es'
,p_message_text=>'No Comprobar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100541881104304972)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La comprobaci\00F3n de cambios sin guardar no se realiza cuando se hace clic en el bot\00F3n. Este valor se debe utilizar para los botones Cancelar, Suprimir y Aplicar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100539076319304969)
,p_name=>'PE.PROPERTY.BUTTON_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Advertencia sobre Cambios sin Guardar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100589787381305007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para evaluar la expresi\00F3n introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100590174632305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100590011287305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100589920325305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100590241235305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100589837962305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100589645565305007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100591739018305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100592022141305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100591900379305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100591890561305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100592107356305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100591694145305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99865251382304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina utilizado en esta condici\00F3n. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99865192972304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM1.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99866695600304420)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina utilizado en esta condici\00F3n. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99866503844304420)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_ITEM2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100591314480305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Java para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100591260701305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100592956555305010)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Java que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100592818940305010)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100591178396305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100591039009305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n JavaScript para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100590932365305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100592769902305010)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'et deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100592617709305010)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n JavaScript que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100592526697305010)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99865487778304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de valores separados por dos puntos (:) para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99865381808304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_LIST.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99865850884304420)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero de p\00E1gina para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99865753850304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99866081045304420)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de n\00FAmeros de p\00E1gina separados por comas para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99865940955304420)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PAGES.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100590872019305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100590713854305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n PL/SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100590634336305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100592444332305010)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100592322638305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n PL/SQL que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100592206110305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99865644996304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una preferencia de usuario que se compare con el valor especificado para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99865576551304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Preferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100591558267305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Python para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100591440899305009)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100593109623305010)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Python que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100593012352305010)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100590598174305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Para volver correctamente cuando el empleado es un gestor y su departamento se encuentra en Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100590443884305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100590323371305008)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100743744163305126)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente porque existen una o m\00E1s filas al comprobar si el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Para volver correctamente porque no existen filas al comprobar si el empleado est\00E1 en el departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99864813520304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una consulta SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99864762242304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99866273311304420)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor de texto para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99866179392304420)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99866838172304420)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor, incluidas las cadenas de sustituci\00F3n <code>&ITEM.</code>, para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99866787831304420)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TEXT2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99947205781304484)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de condici\00F3n que se debe cumplir para que la regi\00F3n se almacene en cach\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99864600415304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique una condici\00F3n. Si la condici\00F3n devuelve <strong>TRUE</strong>, la p\00E1gina se muestra desde cach\00E9. Si la condici\00F3n devuelve <strong>FALSE</strong>, la p\00E1gina se presenta de forma din\00E1mica y no se recupera desde cach\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100429960859304889)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'es'
,p_message_text=>'Siempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100571468800304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El componente siempre se presentar\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100428522027304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es Microsoft Internet Explorer 7.0 o superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100428696261304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es un explorador compatible con XHTML/CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100428400234304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es Mozilla, Netscape 6.x/7x o superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100428720111304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'es'
,p_message_text=>unistr('El explorador del cliente son otros exploradores (o versi\00F3n anterior)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100427159111304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto est\00E1 incluido en el elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100429148404304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'es'
,p_message_text=>'Idioma Actual = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100575063316304996)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 ejecutando la aplicaci\00F3n en el idioma que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100428886146304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'es'
,p_message_text=>unistr('El idioma actual est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100575204439304997)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 ejecutando la aplicaci\00F3n en uno de los idiomas que se introducen en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100429017207304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'es'
,p_message_text=>'Idioma Actual != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100575171388304997)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 ejecutando la aplicaci\00F3n en el idioma que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100428993953304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'es'
,p_message_text=>unistr('El idioma actual no est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100575307671304997)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 ejecutando actualmente la aplicaci\00F3n en uno de los idiomas que se introducen en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100426309438304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual = P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100573856364304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual es igual que el valor que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100426548082304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en una lista delimitada por comas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100574084638304996)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en la lista delimitada por comas que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100426434160304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual != P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100573958955304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual no es igual que el valor que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100426632012304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en una lista no delimitada por comas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100574115392304996)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual no est\00E1 en la lista delimitada por comas que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100429260661304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: DAD_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100429314570304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: DAD_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100428044184304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Errores de Validaci\00F3n en L\00EDnea Mostrados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100574873093304996)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('En la p\00E1gina se muestra un error de validaci\00F3n en l\00EDnea despu\00E9s de una ejecuci\00F3n de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100427425625304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Texto = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100427293948304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100427397078304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto no est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100427522641304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Texto != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100424030190304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Filas Devueltas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100571577693304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta SQL devuelve una o m\00E1s filas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100589429900305007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100589552477305007)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La expresi\00F3n se eval\00FAa en TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100424235586304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100571705574304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El cuerpo de la funci\00F3n devuelve TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100429676197304889)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100429719691304889)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100427763634304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina/Regi\00F3n NO Es de S\00F3lo Lectura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100574586001304996)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Las regiones principal o de p\00E1gina, si son las adecuadas, se muestran con normalidad.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100427631574304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina/Regi\00F3n Es de S\00F3lo Lectura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100574456055304996)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Ya se trate de una regi\00F3n principal o de p\00E1gina, si son las adecuadas, la condici\00F3n "Solo Lectura" se eval\00FAa en TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100425547037304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'es'
,p_message_text=>'El elemento no contiene espacios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100573048845304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>elemento</em> seleccionado no tiene espacios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100425843460304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es alfanum\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100573340334304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es alfanum\00E9rico, es decir, contiene solo letras y n\00FAmeros y ning\00FAn car\00E1cter especial.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100425092657304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es no nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100572562555304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100425751898304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es no num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100573266069304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no es num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100425277480304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento NO es cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100572733573304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100424922471304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'es'
,p_message_text=>'El Elemento es NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100572473301304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100425379590304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es nulo o cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100572817745304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado est\00E1 vac\00EDo o es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100425602079304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100573139527304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100425172507304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100572602487304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100425487419304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es no nulo y no cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100572901330304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 vac\00EDo y no es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100428225750304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'es'
,p_message_text=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Adelante)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100428356761304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Atr\00E1s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100429880787304889)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'es'
,p_message_text=>'Nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100428113645304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Errores de Validaci\00F3n en L\00EDnea No Mostrados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100574948782304996)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El error de validaci\00F3n en l\00EDnea no se muestra en la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100424156207304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Ninguna Fila Devuelta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100571657894304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>'La consulta SQL no devuelve ninguna fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100426971769304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en modo Versi\00F3n para Impresora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100574265537304996)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final ha cambiado la p\00E1gina actual al modo "Versi\00F3n para Impresora".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100427065140304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual no en modo Versi\00F3n para Impresora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100574381058304996)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no ha cambiado la p\00E1gina actual al modo "Versi\00F3n para Impresora".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100424305211304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'Solicitud = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100571832095304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina es igual que el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100424582045304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud est\00E1 incluida en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100572009259304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina se incluye en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100424448931304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'Solicitud != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100571933123304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina no es igual que el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100424675836304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud no est\00E1 incluida en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100572185988304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina no se incluye en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100429496803304888)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100429554132304889)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100427819932304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Usuario Autenticado  (no p\00FAblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100574656854304996)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 conectado a la aplicaci\00F3n.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100427971531304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'es'
,p_message_text=>unistr('El Usuario es el Usuario P\00FAblico (el usuario no se ha autenticado)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100574796152304996)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 conectado a la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100426159144304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia del Usuario = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100573651057304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor de la <em>preferencia</em> introducida es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100426256333304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia del Usuario != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100573724934304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor de la <em>preferencia</em> introducida no es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100425932121304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento est\00E1 en una lista delimitada por dos puntos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100573415912304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado est\00E1 totalmente incluido en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100426090928304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento est\00E1 en una lista no delimitada por dos puntos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100573522214304995)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 totalmente incluido en el texto introducido en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100424725124304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Elemento = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100572218832304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>elemento</em> seleccionado es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100424881627304885)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Elemento != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100572332676304994)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>elemento</em> seleccionado no es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100426807629304887)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual != P\00E1gina Ejecutada (enviada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100426724585304886)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual = P\00E1gina Ejecutada (enviada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99864523793304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99865055722304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor que se va a comparar con la condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99864950917304419)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE1.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99866463446304420)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor, incluidas las cadenas de sustituci\00F3n <code>&ITEM.</code>, para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99866323707304420)
,p_name=>'PE.PROPERTY.CACHE_CONDITION_VALUE2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100684354498305082)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista separada por comas de los elementos de los que depende el contenido en cach\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100684288110305082)
,p_name=>'PE.PROPERTY.CACHE_DEPENDS_ON_ITEMS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Depende de los Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100678308051305074)
,p_name=>'PE.PROPERTY.CACHE_MODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la forma en la que el motor de &PRODUCT_NAME. puede almacenar en cach\00E9 el texto HTML del servidor. Si se puede usar el almacenamiento en cach\00E9, se emiten los resultados almacenados en cach\00E9 en lugar de calcularlos de nuevo. Esto reduce el ')
||unistr('tiempo de c\00E1lculo en el servidor. Esta funci\00F3n no est\00E1 relacionada con las capacidades de almacenamiento en cach\00E9 del explorador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100678612093305074)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.D'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100678705545305074)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.CACHE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El contenido se almacena en cach\00E9 y todos los usuarios lo utilizan.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100678431514305074)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.D'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100678553407305074)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.NOCACHE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El contenido no se almacena en cach\00E9 y se calcula en cada solicitud.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100679000575305074)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cach\00E9 por Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100679152657305074)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.SESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El contenido se almacena en cach\00E9 espec\00EDficamente para cada sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100678884798305074)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cach\00E9 por Usuario')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100678989443305074)
,p_name=>'PE.PROPERTY.CACHE_MODE.LOV.USER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El contenido se almacena en cach\00E9 espec\00EDficamente para cada usuario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100678236933305074)
,p_name=>'PE.PROPERTY.CACHE_MODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cach\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99858298346304414)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tiempo de validez que tendr\00E1 la p\00E1gina almacenada en cach\00E9. Las posteriores solicitudes de dicha p\00E1gina no utilizar\00E1n la p\00E1gina almacenada en cach\00E9 si caduca el timeout.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100359659841304835)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10.D'
,p_message_language=>'es'
,p_message_text=>'10 segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100360205601304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.10800.D'
,p_message_language=>'es'
,p_message_text=>'3 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100361134687304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1209600.D'
,p_message_language=>'es'
,p_message_text=>'2 semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100360346608304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.14400.D'
,p_message_language=>'es'
,p_message_text=>'4 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100360753565304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.172800.D'
,p_message_language=>'es'
,p_message_text=>unistr('2 d\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100359915885304835)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.1800.D'
,p_message_language=>'es'
,p_message_text=>'30 minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100360411977304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.21600.D'
,p_message_language=>'es'
,p_message_text=>'6 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100361204199304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.2419200.D'
,p_message_language=>'es'
,p_message_text=>'4 semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100360841055304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.259200.D'
,p_message_language=>'es'
,p_message_text=>unistr('3 d\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100361499913304837)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.31536000.D'
,p_message_language=>'es'
,p_message_text=>unistr('1 a\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100360946598304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.345600.D'
,p_message_language=>'es'
,p_message_text=>unistr('4 d\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100360018838304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.3600.D'
,p_message_language=>'es'
,p_message_text=>'1 hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100360580834304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.43200.D'
,p_message_language=>'es'
,p_message_text=>'12 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100359770714304835)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.60.D'
,p_message_language=>'es'
,p_message_text=>'1 minuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100359840227304835)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.600.D'
,p_message_language=>'es'
,p_message_text=>'10 minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100361001255304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.604800.D'
,p_message_language=>'es'
,p_message_text=>'1 semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100361371730304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.6048000.D'
,p_message_language=>'es'
,p_message_text=>'10 semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100360135498304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.7200.D'
,p_message_language=>'es'
,p_message_text=>'2 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100360676644304836)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.LOV.86400.D'
,p_message_language=>'es'
,p_message_text=>unistr('1 d\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99858123813304413)
,p_name=>'PE.PROPERTY.CACHE_TIMEOUT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Timeout de Cach\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100405277283304869)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Mostrar valores de columna</dt>',
'<dd><pre>',
'#FIRST_NAME# <strong>#LAST_NAME#</strong>',
'</pre></dd>',
'<dt>Mostrar una imagen en un evento de calendario.</dt>',
'<dd><pre>',
'&lt;img src="#IMAGE_NAME#"&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100251494588304755)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca texto personalizado para que se muestre en las celdas del calendario. Puede introducir expresiones HTML y utilizar la sintaxis <code>#COLUMN_NAME#</code> para mostrar valores de columnas. Este tipo de visualizaci\00F3n le permite introducir va')
||unistr('rias columnas en la visualizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100251363988304755)
,p_name=>'PE.PROPERTY.CALENDAR_CUSTOM_FORMAT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Formato de Visualizaci\00F3n Personalizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100245652153304750)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el elemento de aplicaci\00F3n o p\00E1gina que contiene la fecha de inicio del calendario que se muestra actualmente al usuario final.'),
unistr('El motor de &PRODUCT_NAME. utiliza este elemento cuando el usuario final decide navegar al per\00EDodo anterior o siguiente.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100245540017304750)
,p_name=>'PE.PROPERTY.CALENDAR_DATE_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Fecha de Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100246294019304751)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione los valores que se muestran en el calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100404631742304869)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.D'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100404786164304869)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.COL.HELP'
,p_message_language=>'es'
,p_message_text=>'Utiliza el atributo <strong>Columna Mostrada</strong> para seleccionar la columna que se va a mostrar en la celda de calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100404891530304869)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.D'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100404990598304869)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.CUS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Permite introducir un formato de columna personalizado mediante expresiones HTML y cadenas de sustituci\00F3n soportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100405056302304869)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn Valor de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100405129560304869)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.LOV.NONE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('No se muestra ning\00FAn dato en las celdas de calendario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100246134860304751)
,p_name=>'PE.PROPERTY.CALENDAR_DISPLAY_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100245862303304750)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el elemento de aplicaci\00F3n o p\00E1gina que contiene la fecha de finalizaci\00F3n del calendario que se muestra actualmente al usuario final.'),
unistr('El motor de &PRODUCT_NAME. utiliza este elemento cuando el usuario final decide navegar al per\00EDodo anterior o siguiente.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100245741172304750)
,p_name=>'PE.PROPERTY.CALENDAR_END_DATE_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de Finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100245080540304750)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la plantilla que se va a utilizar cuando se presente el calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100244927890304750)
,p_name=>'PE.PROPERTY.CALENDAR_TEMPLATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100246084973304751)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el elemento de aplicaci\00F3n o p\00E1gina que contiene el tipo de calendario que se muestra actualmente al usuario final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100245984733304750)
,p_name=>'PE.PROPERTY.CALENDAR_TYPE_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100558443318304984)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero de tarjetas que se mostrar\00E1n en cada p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100558303204304984)
,p_name=>'PE.PROPERTY.CARDS_PER_PAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tarjetas por p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100557290924304983)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Determina si el bot\00F3n se posiciona en la tarjeta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100557393381304983)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.PRIMARY.D'
,p_message_language=>'es'
,p_message_text=>'Primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100557446916304983)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.LOV.SECONDARY.D'
,p_message_language=>'es'
,p_message_text=>'Secundario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100557122597304983)
,p_name=>'PE.PROPERTY.CARD_ACTION_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100556049287304982)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el tipo de acci\00F3n que se debe agregar al componente de tarjeta.</p>'),
unistr('<p>Puede definir varias acciones del mismo tipo. Sin embargo, solo las acciones de bot\00F3n se representan varias veces.'),
unistr('Para el resto de tipos de acciones, se representa la primera condici\00F3n de visualizaci\00F3n definida en TRUE, y el resto se ignoran.</p>'),
unistr('<p>Las condiciones de visualizaci\00F3n se pueden definir seg\00FAn los valores de columna si la condici\00F3n de ejecuci\00F3n se define para que se compruebe en cada fila.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100556159205304982)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.D'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100556206913304982)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Agrega un bot\00F3n a la tarjeta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100556340727304982)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.D'
,p_message_language=>'es'
,p_message_text=>'Tarjeta completa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100556414081304982)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.FULL_CARD.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Agrega un enlace a la tarjeta completa. Normalmente, debe definirse una acci\00F3n de este tipo.'),
unistr('Si va a definir varias, agregue una condici\00F3n de visualizaci\00F3n seg\00FAn el valor de columna y defina que se compruebe para cada fila.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100556927694304983)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.D'
,p_message_language=>'es'
,p_message_text=>'Medio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100557072059304983)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.MEDIA.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Agrega un enlace al medio de tarjeta. Normalmente, debe definirse una acci\00F3n de este tipo.'),
unistr('Si va a definir varias, agregue una condici\00F3n de visualizaci\00F3n seg\00FAn el valor de columna de tarjeta y defina que se compruebe para cada fila.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100556748150304983)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Subt\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100556882511304983)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.SUB_TITLE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Agrega un enlace al subt\00EDtulo de tarjeta. Normalmente, debe definirse una acci\00F3n de este tipo.'),
unistr('Si va a definir varias, agregue una condici\00F3n de visualizaci\00F3n seg\00FAn el valor de columna y defina que se compruebe para cada fila.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100556517777304983)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.D'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100556657231304983)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.LOV.TITLE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Agrega un enlace al t\00EDtulo de tarjeta. Normalmente, debe definirse una acci\00F3n de este tipo.'),
unistr('Si va a definir varias, agregue una condici\00F3n de visualizaci\00F3n seg\00FAn el valor de columna y defina que se compruebe para cada fila.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100555946887304982)
,p_name=>'PE.PROPERTY.CARD_ACTION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100544972943304974)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases CSS que desee aplicar a cada tarjeta individual. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100544861125304974)
,p_name=>'PE.PROPERTY.CARD_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100550137114304978)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Mostrar una flecha hacia la derecha</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100550071362304978)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee agregar al componente. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('        <p>Si el tema utiliza la fuente APEX, revise <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de Ejemplo de Tema Universal</a> para ver los iconos y modificadores disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100549989215304977)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100651096750305053)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Mostrar una flecha hacia la derecha</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100650959284305053)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee agregar al componente. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('        <p>Si el tema utiliza la fuente APEX, revise <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de Ejemplo de Tema Universal</a> para ver los iconos y modificadores disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100650877681305052)
,p_name=>'PE.PROPERTY.CARD_ICON_CSS_CLASSES_REQUIRED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100543351062304973)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Esta propiedad determina c\00F3mo se organizan las tarjetas en la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100543652151304973)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.D'
,p_message_language=>'es'
,p_message_text=>'Flotante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100543775469304973)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.FLOAT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Las tarjetas se ajustar\00E1n cuando no quepan de forma horizontal en la pantalla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100543490902304973)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadr\00EDcula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100543500615304973)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.GRID.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Organiza las tarjetas en una cuadr\00EDcula de columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100543895987304973)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.D'
,p_message_language=>'es'
,p_message_text=>'Horizontal (fila)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100543936198304973)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.LOV.ROW.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Las tarjetas se posicionar\00E1n unas sobre otras.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100543215939304973)
,p_name=>'PE.PROPERTY.CARD_LAYOUT_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100557623556304983)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la acci\00F3n que se va a realizar al hacer clic en el tipo de acci\00F3n especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100557995648304984)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'es'
,p_message_text=>unistr('Redirigir a P\00E1gina en Otra Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100558024486304984)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Redirige a una p\00E1gina en otra aplicaci\00F3n, con atributos adicionales opcionales para restablecer la paginaci\00F3n, definir el valor de solicitud, borrar la cach\00E9 y definir los valores del elemento en la p\00E1gina de destino.</p>'),
unistr('<p>Nota: La redirecci\00F3n a una p\00E1gina en una aplicaci\00F3n diferente depende de que se active el enlace profundo en la aplicaci\00F3n de destino. Para activar el enlace profundo, vaya a los atributos de <em>seguridad</em> de la aplicaci\00F3n y active <em>Enlace')
||' profundo</em>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100557764912304983)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Redirigir a P\00E1gina en esta Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100557890012304983)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Redirige a una p\00E1gina en la aplicaci\00F3n actual, con atributos adicionales opcionales para restablecer la paginaci\00F3n, definir el valor de solicitud, borrar la cach\00E9 y definir los valores del elemento en la p\00E1gina de destino.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100558145067304984)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'es'
,p_message_text=>'Redirigir a URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100558200201304984)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'es'
,p_message_text=>'Redirige a la URL de destino que especifique.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100557519795304983)
,p_name=>'PE.PROPERTY.CARD_LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100670767814305068)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la primera columna de clave primaria del origen de regi\00F3n. Si la clave primaria de esta tabla tiene m\00E1s de dos columnas, debe seleccionar la columna <code>ROWID</code>. Si se establece que la regi\00F3n muestre paginaci\00F3n de desplazamiento, se')
||unistr(' utiliza la clave primaria para evitar que aparezcan filas duplicadas.  Si en la regi\00F3n se muestra una imagen de una columna BLOB, se utiliza la clave primaria para obtener la imagen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100670631493305068)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100671173664305068)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la primera columna de clave primaria del origen de regi\00F3n. Si la clave primaria de esta tabla tiene m\00E1s de dos columnas, debe seleccionar la columna <code>ROWID</code>. Si se establece que la regi\00F3n muestre paginaci\00F3n de desplazamiento, se')
||unistr(' utiliza la clave primaria para evitar que aparezcan filas duplicadas.  Si en la regi\00F3n se muestra una imagen de una columna BLOB, se utiliza la clave primaria para obtener la imagen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100671029283305068)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN1_REQUIRED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria 1'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100670954342305068)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Solo seleccione la segunda columna de clave primaria si la clave primaria del origen de regi\00F3n tiene dos columnas. Si selecciona <code>ROWID</code> para la primera columna de clave primaria, no debe rellenar esta columna. Si se establece que la regi\00F3')
||unistr('n muestre paginaci\00F3n de desplazamiento, se utiliza la segunda clave primaria para evitar que aparezcan filas duplicadas.  Si en la regi\00F3n se muestra una imagen de una columna BLOB, se utiliza la segunda clave primaria para obtener la imagen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100670889255305068)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100671327287305068)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Solo seleccione la segunda columna de clave primaria si la clave primaria del origen de regi\00F3n tiene dos columnas. Si selecciona <code>ROWID</code> para la primera columna de clave primaria, no debe rellenar esta columna. Si se establece que la regi\00F3')
||unistr('n muestre paginaci\00F3n de desplazamiento, se utiliza la segunda clave primaria para evitar que aparezcan filas duplicadas.  Si en la regi\00F3n se muestra una imagen de una columna BLOB, se utiliza la segunda clave primaria para obtener la imagen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100671218425305068)
,p_name=>'PE.PROPERTY.CARD_PK_COLUMN2_REQUIRED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100558529338304984)
,p_name=>'PE.PROPERTY.CARD_USES_BLOB_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'La tarjeta usa la columna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100211241716304724)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de columna de base de datos sensible a may\00FAsculas/min\00FAsculas de la lista de valores, que se usa para consultarlo mediante el valor de faceta o filtro principal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100211157063304723)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columnas de lista de valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100748180856305129)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca las columnas que disparan el refrescamiento de esta lista de valores.',
'Si hay varias columnas, separe cada una de ellas por una coma.',
'Puede escribir el nombre o seleccionarlo de la lista de columnas disponibles.',
unistr('Si lo selecciona de la lista y ya se ha introducido texto, se colocar\00E1 una coma al final del texto existente, seguido del nombre de la columna que ha devuelto la lista.</p>'),
unistr('<p>Esta lista de valores se refresca siempre que el valor de cualquiera de las columnas especificadas se cambie en esta p\00E1gina.</p>'),
unistr('<p>Debe utilizar la(s) columna(s) especificadas en este atributo de la <em>cl\00E1usula where</em> de esta consulta SQL de la lista de valores para restringir los valores devueltos.</p>'),
unistr('<p>Por ejemplo, si tiene columnas de p\00E1gina para la marca y modelo del coche, podr\00EDa especificar la marca del coche como la columna principal de lista de valores en cascada en la definici\00F3n de lista de valores para el modelo y utilizar la marca del c')
||unistr('oche en la cl\00E1usula where para esa lista de valores.'),
'De esta manera, siempre que se cambie la marca del coche, se refresca la lista de valores para el modelo y dicha lista solo muestra los valores de la marca del coche seleccionada actualmente.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100748043098305129)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_COLUMNS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columnas principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100211456030304724)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione una faceta que dispare el refrescamiento de esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100211383430304724)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FACET.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Faceta principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99897816475304446)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un filtro que dispare el refrescamiento de esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99897781931304446)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_FILTER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Filtro principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99862956818304417)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca los elementos de aplicaci\00F3n o de p\00E1gina que disparan el refrescamiento de esta lista de valores.'),
'Si hay varios elementos, separe cada uno de ellos por una coma.',
'Puede escribir el nombre o seleccionarlo de la lista de elementos disponibles.',
unistr('Si lo selecciona de la lista y ya se ha introducido texto, se colocar\00E1 una coma al final del texto existente, seguido del nombre de elemento que ha devuelto la lista.</p>'),
unistr('<p>Esta lista de valores se refresca siempre que el valor de cualquiera de los elementos especificados se cambie en esta p\00E1gina.</p>'),
unistr('<p>Debe utilizar los elementos de p\00E1gina especificados en este atributo de la <em>cl\00E1usula WHEN</em> de esta consulta SQL de la lista de valores para restringir los valores devueltos.</p>'),
unistr('<p>Por ejemplo, si tiene elementos de p\00E1gina para la marca y modelo del coche, podr\00EDa especificar la marca del coche como el elemento principal de lista de valores en cascada en la definici\00F3n de lista de valores para el modelo y utilizar la marca del')
||unistr(' coche en la cl\00E1usula WHERE para esa lista de valores.'),
'De esta manera, siempre que se cambie la marca del coche, se refresca la lista de valores para el modelo y dicha lista solo muestra los valores de la marca del coche seleccionada actualmente.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99862816434304417)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_ITEMS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elementos principales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100208241851304721)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique en qu\00E9 condiciones se refrescar\00E1 esta lista de valores.</p>'),
'<p>Si se define en <strong>Activado</strong>, la llamada de refrescamiento para obtener nuevos valores se realiza solo cuando ninguno de los <em>elementos principales de la lista de valores en cascada</em> es nulo.',
'Si uno de los elementos es nulo, se asume que la consulta de la lista de valores no devuelve ninguna fila.',
unistr('En esos casos, las entradas de la lista de selecci\00F3n simplemente se borran del explorador, sin realizar un refrescamiento.</p>'),
'<p>Si se define en <strong>Desactivado</strong>, siempre se realiza el refrescamiento.',
unistr('Esta opci\00F3n solo se utiliza si maneja espec\00EDficamente <em>elementos principales de lista de valores en cascada</em> nulos en la <em>cl\00E1usula where</em> de esta consulta SQL de la lista de valores.'),
unistr('Si los elementos de p\00E1gina nulos no se manejan adecuadamente, se ejecutar\00E1n llamadas de refrescamiento innecesarias que en ning\00FAn caso devolver\00E1n filas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100208169269304721)
,p_name=>'PE.PROPERTY.CASCADING_LOV_PARENT_REQUIRED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Principal necesario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99493708780304136)
,p_name=>'PE.PROPERTY.CHANGED_BY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra las credenciales de usuario del desarrollador que ha actualizado por \00FAltima vez este atributo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99493630278304136)
,p_name=>'PE.PROPERTY.CHANGED_BY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Cambiado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99493984909304136)
,p_name=>'PE.PROPERTY.CHANGED_ON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra cu\00E1ndo se ha actualizado por \00FAltima vez este atributo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99493886468304136)
,p_name=>'PE.PROPERTY.CHANGED_ON.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Cambiado el'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100243787289304749)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la altura del gr\00E1fico en p\00EDxeles. La altura define una altura fija para la regi\00F3n del gr\00E1fico. Como alternativa, para activar el cambio de tama\00F1o autom\00E1tico de la altura del gr\00E1fico, deje vac\00EDo este elemento.'),
unistr('La altura se define luego autom\00E1ticamente en funci\00F3n de la altura del explorador.</p>'),
unistr('<p>Por defecto, un gr\00E1fico creado en una p\00E1gina mediante la interfaz de usuario de jQuery Mobile Smartphone no tiene definido ning\00FAn valor para la altura y cambia el tama\00F1o correctamente para ajustarla al dispositivo en el que se va a presentar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100243681938304748)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100243833248304749)
,p_name=>'PE.PROPERTY.CHART_HEIGHT.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('p\00EDxeles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100267527402304767)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el ancho m\00E1ximo del gr\00E1fico en p\00EDxeles. El ancho m\00E1ximo define un ancho fijo para la regi\00F3n del gr\00E1fico.'),
unistr('Como alternativa, para activar el cambio de tama\00F1o autom\00E1tico del ancho del gr\00E1fico, deje vac\00EDo este elemento. El ancho se define luego autom\00E1ticamente en el 100 % de la regi\00F3n.</p>'),
unistr('<p>Por defecto, un gr\00E1fico creado en una p\00E1gina mediante la interfaz de usuario de jQuery Mobile Smartphone no tiene definido ning\00FAn valor para el ancho y cambia el tama\00F1o correctamente para ajustarlo al dispositivo en el que se va a representar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100261992469304763)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ancho M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100262094866304763)
,p_name=>'PE.PROPERTY.CHART_MAX_WIDTH.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('p\00EDxeles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100240661965304746)
,p_name=>'PE.PROPERTY.CHART_TITLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el t\00EDtulo que aparecer\00E1 en la parte superior del gr\00E1fico. Para los gr\00E1ficos de Gantt, este valor solo se utiliza para definir el t\00EDtulo de gr\00E1fico accesible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100240552888304746)
,p_name=>'PE.PROPERTY.CHART_TITLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100469072679304917)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la ubicaci\00F3n de los datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100469146735304917)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'es'
,p_message_text=>'Base de Datos Local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100469215147304917)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'es'
,p_message_text=>'Los datos se originan en la base de datos local.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100469723343304918)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Origen de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100469881751304918)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REGION_SOURCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos se originan en la ubicaci\00F3n especificada en la definici\00F3n de origen de regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100469325498304918)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'es'
,p_message_text=>'SQL activado para REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100469475019304918)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos se originan en una base de datos remota, donde se define la conexi\00F3n mediante SQL activado para REST. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100469523737304918)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'es'
,p_message_text=>'Origen de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100469630040304918)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos se originan en un servicio web RESTful definido mediante or\00EDgenes de datos de REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100468954501304917)
,p_name=>'PE.PROPERTY.CHILD_SOURCE_LOCATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ubicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100234319013304741)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la base de esta columna de informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100392142278304859)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'es'
,p_message_text=>'* Selector de Fecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100392018470304859)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'es'
,p_message_text=>unistr('* Selector de Fecha (Cl\00E1sico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100391907150304859)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'es'
,p_message_text=>'* Mostrar como Texto (guarda el estado)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100391609189304859)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'es'
,p_message_text=>'Descargar BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100569057129304992)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra la columna como un enlace para descargar el archivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100391805742304859)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna Oculta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100569239042304992)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'No muestra la columna, pero se puede hacer referencia a ella.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100392632021304860)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'es'
,p_message_text=>'* Campo Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100391560886304859)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'es'
,p_message_text=>'Mostrar Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100568994468304992)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra la columna como una imagen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100391484038304859)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'es'
,p_message_text=>'Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100568894977304992)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra la columna como un enlace.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100391762192304859)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico de Porcentaje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100569155646304992)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra la columna como un gr\00E1fico de porcentajes. El valor recuperado debe estar entre 0 y 100.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100391289068304859)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'es'
,p_message_text=>'Texto sin Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100568680190304992)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra el valor de columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100391364704304859)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'es'
,p_message_text=>'Texto sin Formato (Basado en Lista de Valores)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100568727274304992)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra el valor devuelto de la lista de valores especificados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100392777431304860)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'es'
,p_message_text=>'* Lista de Valores Emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100392813460304860)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'es'
,p_message_text=>'* Lista de Valores de Clave Emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100392591728304860)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'es'
,p_message_text=>'* Grupo de Botones de Radio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100640107594305045)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Texto Enriquecido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100640294419305045)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'Representa la columna mediante HTML o Markdown.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100393010226304860)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'es'
,p_message_text=>'* Selector de Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100392436118304860)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('* Lista de Selecci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100392904616304860)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'es'
,p_message_text=>'* Casilla de Control Simple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100392281876304859)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'es'
,p_message_text=>'* Campo de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100392352780304860)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('* \00C1rea de Texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100234223145304741)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_COLUMN_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100233960313304741)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.CLASSIC_REPORT.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('No Hay Paginaci\00F3n (Se Muestran Todas las Filas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100235172548304742)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.COMPONENT_PROPERTY.TABULAR_FORM.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('No Hay Paginaci\00F3n (Se Muestran Todas las Filas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100220361210304730)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el tipo de paginaci\00F3n que se va a utilizar en este informe.'),
'Generalmente, solo se muestra un subjuego de los resultados en el informe.',
unistr('La paginaci\00F3n proporciona al usuario informaci\00F3n sobre el n\00FAmero de filas y la posici\00F3n actual dentro del juego de resultados. Tambi\00E9n define el estilo de los enlaces o botones que se utilizan para navegar a la siguiente p\00E1gina o a la p\00E1gina anterior')
||'.</p>',
unistr('<p>La paginaci\00F3n se puede mostrar encima o debajo del informe (o en ambos lugares) y se puede colocar a la izquierda o a la derecha.</p>'),
unistr(' <p>Tambi\00E9n puede utilizar un estilo de paginaci\00F3n simplificado para mejorar el rendimiento, como <strong>Rangos de Fila X a Y (con enlaces siguientes y anteriores)</strong>.'),
unistr('Para utilizar tipos de paginaci\00F3n del formato "X a Y de Z", es necesario que el motor de &PRODUCT_NAME. realice dos consultas para devolver los resultados.'),
unistr('Una consulta recupera los registros actuales que se van a mostrar y otra obtiene el recuento total de registros que se va a mostrar en el control de paginaci\00F3n.'),
unistr('Para informes basados en juegos de datos enormemente largos o que tienen consultas que utilizan mucho la CPU, como numerosas uniones de tablas no \00F3ptimas o condiciones costosas, esta consulta adicional puede aumentar ligeramente el tiempo de procesam')
||unistr('iento, lo que puede causar que el informe tarde m\00E1s tiempo en presentarse.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100400700688304866)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.COMPUTED_BUT_NOT_DISPLAYED.D'
,p_message_language=>'es'
,p_message_text=>unistr('Usar Botones de Paginaci\00F3n Creados Externamente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100400852544304866)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.NEXT_PREVIOUS_LINKS.D'
,p_message_language=>'es'
,p_message_text=>'Rangos de Fila X a Y (con enlaces siguientes y anteriores)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100400147347304865)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'es'
,p_message_text=>unistr('Rangos de Fila X a Y (sin paginaci\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100400261504304865)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'es'
,p_message_text=>unistr('Rangos de Fila X a Y de Z (sin paginaci\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100400462134304865)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES.D'
,p_message_language=>'es'
,p_message_text=>unistr('Rangos de Fila 1-15 16-30  (con paginaci\00F3n de juego)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100400582638304865)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_IN_SELECT_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('Rangos de Fila 1-15 16-30 en Lista de Selecci\00F3n (con paginaci\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100400371594304865)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.ROW_RANGES_WITH_LINKS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Rangos de Fila X a Y de Z (con paginaci\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100400650343304866)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.LOV.SEARCH_ENGINE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Motor de B\00FAsqueda 1,2,3,4 (paginaci\00F3n basada en juegos)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100220235780304730)
,p_name=>'PE.PROPERTY.CLASSIC_REPORT_PAGINATION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100189845300304708)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el n\00FAmero de iconos que se mostrar\00E1n por fila en la vista de icono. Con un valor de 5 se mostrar\00E1n 5 iconos por fila del informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100388263965304857)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.1.D'
,p_message_language=>'es'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100388359859304857)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.2.D'
,p_message_language=>'es'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100388450465304857)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.3.D'
,p_message_language=>'es'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100388505441304857)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.4.D'
,p_message_language=>'es'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100388684196304857)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.5.D'
,p_message_language=>'es'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100388722249304857)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.6.D'
,p_message_language=>'es'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100388813827304857)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.7.D'
,p_message_language=>'es'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100388991172304857)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.8.D'
,p_message_language=>'es'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100389025567304857)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.LOV.9.D'
,p_message_language=>'es'
,p_message_text=>'9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100189733308304708)
,p_name=>'PE.PROPERTY.COLUMNS_PER_ROW.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columnas Por Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100180343301304701)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la alineaci\00F3n de visualizaci\00F3n de columna. Tenga en cuenta que la selecci\00F3n de alineaci\00F3n debe estar soportada por la plantilla de informe seleccionada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100384303260304854)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'es'
,p_message_text=>'centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100384286478304854)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'es'
,p_message_text=>'inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100384455396304854)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'es'
,p_message_text=>'final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100180298751304701)
,p_name=>'PE.PROPERTY.COLUMN_ALIGNMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Alineaci\00F3n de Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100236613221304743)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un tipo de valor de columna por defecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100404243624304868)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.FUNCTION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100404103479304868)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100236518651304743)
,p_name=>'PE.PROPERTY.COLUMN_DEFAULT_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100091515755304595)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.COMPONENT_PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el texto de cabecera del grupo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100179534714304700)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el texto de cabecera de la columna de informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100179448043304700)
,p_name=>'PE.PROPERTY.COLUMN_HEADING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99609242442304226)
,p_name=>'PE.PROPERTY.COLUMN_IS_SORTABLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Se puede ordenar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100518469256304954)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que contiene la clave \00FAnica para identificar una fila. Utilice esta opci\00F3n para proporcionar el valor de clave principal para el c\00F3digo JavaScript personalizado o los manejadores de eventos del mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100518370881304954)
,p_name=>'PE.PROPERTY.COLUMN_MAPPING_PK_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100178960124304700)
,p_name=>'PE.PROPERTY.COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el nombre de columna para esta columna de informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100178831596304700)
,p_name=>'PE.PROPERTY.COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100234110989304741)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Ascendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100235538684304742)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Ascendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100214651299304726)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si esta columna se ordena en sentido Descendente. Si no se especifica, se ordena en sentido Ascendente (por defecto).'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100397487260304863)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.LOV.DESC.D'
,p_message_language=>'es'
,p_message_text=>'Descendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100214591626304726)
,p_name=>'PE.PROPERTY.COLUMN_SORT_DIRECTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Sentido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100214433481304726)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione la secuencia de ordenaci\00F3n de esta columna.'),
unistr('Cada columna debe tener una secuencia \00FAnica para ordenar correctamente la salida del informe.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100396625604304863)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.1.D'
,p_message_language=>'es'
,p_message_text=>'1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100396787149304863)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.2.D'
,p_message_language=>'es'
,p_message_text=>'2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100396892505304863)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.3.D'
,p_message_language=>'es'
,p_message_text=>'3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100396920345304863)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.4.D'
,p_message_language=>'es'
,p_message_text=>'4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100397003595304863)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.5.D'
,p_message_language=>'es'
,p_message_text=>'5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100397139241304863)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.6.D'
,p_message_language=>'es'
,p_message_text=>'6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100397223282304863)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.7.D'
,p_message_language=>'es'
,p_message_text=>'7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100397355692304863)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.LOV.8.D'
,p_message_language=>'es'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100214396627304726)
,p_name=>'PE.PROPERTY.COLUMN_SORT_SEQUENCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Secuencia por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100179131729304700)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el tipo de dato para la columna de informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100179080699304700)
,p_name=>'PE.PROPERTY.COLUMN_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Dato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100212837456304725)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el ancho de columna en p\00EDxeles.'),
'Utilice este atributo para mostrar informes en un explorador.',
unistr('Tenga en cuenta que la plantilla de informe seleccionada debe soportar la definici\00F3n del ancho de columna.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100212770387304725)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ancho de Celda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100243213653304748)
,p_name=>'PE.PROPERTY.COLUMN_WIDTH.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('p\00EDxeles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99847510112304405)
,p_name=>'PE.PROPERTY.COMMENTS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca los comentarios o las notas del desarrollador aqu\00ED. Estos comentarios solo se muestran en el creador de aplicaciones y no aparecen cuando se est\00E1 ejecutando la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99847449723304405)
,p_name=>'PE.PROPERTY.COMMENTS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100544777826304974)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases CSS que desee aplicar a este componente. Esta clase se aplicar\00E1 al contenedor de tarjetas. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100544617362304973)
,p_name=>'PE.PROPERTY.COMPONENT_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100604758373305019)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para evaluar la expresi\00F3n introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100605146927305019)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100605098291305019)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100604967710305019)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100605279136305019)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100604823477305019)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100604648321305019)
,p_name=>'PE.PROPERTY.COMPUTATION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100606701829305020)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100607064324305020)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100606987267305020)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100606839516305020)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100607182640305020)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100606682977305020)
,p_name=>'PE.PROPERTY.COMPUTATION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99851557338304408)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina rellenado por este c\00E1lculo. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99851414853304408)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre del Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99852381277304409)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento cuyo valor se utilice para rellenar el elemento de c\00E1lculo. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99852286924304409)
,p_name=>'PE.PROPERTY.COMPUTATION_ITEM_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre del Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100606344346305020)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Java que produzca un valor que se vaya a utilizar para rellenar el elemento de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100606261096305020)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100607981734305021)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n Java que devuelva un valor que se vaya a utilizar para rellenar el elemento de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100607816685305021)
,p_name=>'PE.PROPERTY.COMPUTATION_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100606150591305020)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100606096272305020)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n JavaScript que produzca un valor que se vaya a utilizar para rellenar el elemento de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100605962222305019)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100607744663305021)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100607650040305021)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n JavaScript que devuelva un valor que se vaya a utilizar para rellenar el elemento de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100607579325305021)
,p_name=>'PE.PROPERTY.COMPUTATION_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100605819476305019)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100605773205305019)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n PL/SQL que produzca un valor que se vaya a utilizar para rellenar el elemento de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100605697558305019)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100607408542305021)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100607359821305021)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n PL/SQL que devuelva un valor que se vaya a utilizar para rellenar el elemento de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100607269038305020)
,p_name=>'PE.PROPERTY.COMPUTATION_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99852939905304409)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el punto del procesamiento o la presentaci\00F3n de la p\00E1gina en el que se ejecutar\00E1 el c\00E1lculo.'),
unistr('El punto de c\00E1lculo m\00E1s frecuente es <strong>Despu\00E9s de ejecuci\00F3n</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100364965079304839)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Regiones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100666361181305065)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta despu\00E9s de presentar las regiones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100365138472304839)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100666542370305065)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta despu\00E9s de presentar el pie de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100364709617304839)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Cabecera')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100666160842305064)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta despu\00E9s de presentar la cabecera.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100365282226304839)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100666645963305065)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento: se ejecuta despu\00E9s del env\00EDo de la p\00E1gina, pero antes de su procesamiento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100364833184304839)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'es'
,p_message_text=>'Antes de Regiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100666295052305064)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta antes de presentar las regiones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100365031236304839)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Antes de Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100666404214305065)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta antes de presentar el pie de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100364687607304839)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'es'
,p_message_text=>'Antes de Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100666036670305064)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta antes de presentar la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100364542602304839)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100665921258305064)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Se ejecuta cuando se genera una nueva sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99852856344304409)
,p_name=>'PE.PROPERTY.COMPUTATION_POINT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Punto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99852506757304409)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una preferencia de usuario que tenga un valor que se vaya a utilizar para rellenar el elemento de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99852422953304409)
,p_name=>'PE.PROPERTY.COMPUTATION_PREFERENCE_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Preferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100606520274305020)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Python que produzca un valor que se vaya a utilizar para rellenar el elemento de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100606433926305020)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100608120885305021)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n Python que devuelva un valor que se vaya a utilizar para rellenar el elemento de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100608058288305021)
,p_name=>'PE.PROPERTY.COMPUTATION_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100571386306304994)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una consulta SQL que proporcione un valor utilizado para rellenar el elemento de c\00E1lculo. Si el resultado contiene varias filas, el valor de cada fila se forma en un solo valor delimitado por dos puntos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100571235716304994)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_COLON.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100605518922305019)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Para devolver YES cuando el empleado es un gestor y su departamento se encuentra en Chicago:</dt>',
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100605411800305019)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n SQL que produzca un valor que se vaya a utilizar para rellenar el elemento de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100605350176305019)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99852171358304409)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca una consulta SQL que proporcione un valor utilizado para rellenar el elemento computacional. Si el resultado contiene varias filas, solo se devuelve el valor de la primera fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99852013641304409)
,p_name=>'PE.PROPERTY.COMPUTATION_SQL_STATEMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99851903575304409)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que se va a utilizar para rellenar el elemento de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99851814825304409)
,p_name=>'PE.PROPERTY.COMPUTATION_STATIC_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99851777800304408)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un tipo de c\00E1lculo de la siguiente lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100587889510305006)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100587978142305006)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor resultante al ejecutar la <em>expresi\00F3n</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100364040175304838)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100566451788304990)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde el <em>cuerpo de la funci\00F3n</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100364343877304839)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100566168980304990)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.ITEM_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de estado de sesi\00F3n del <em>elemento</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100364126239304838)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Consulta SQL (devolver valor \00FAnico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100566245306304990)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el primer valor devuelto desde la <em>consulta SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100364294886304839)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL (devolver valores separados por dos puntos)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100566399634304990)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor \00FAnico delimitado por dos puntos, que concatena el valor de cada columna, devuelto desde la <em>consulta SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100364480364304839)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100566540240304990)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.SET_ITEM_EQUAL_THIS_PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn la <em>preferencia</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100363973078304838)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100566021990304990)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.LOV.STATIC_ASSIGNMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el texto introducido en <em>Valor Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99851651895304408)
,p_name=>'PE.PROPERTY.COMPUTATION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100212619539304725)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Para esta columna, especifique si la suma se calcula y se muestra al final del informe.',
'Cuando se utiliza con columnas divisorias, se muestra la suma total y la suma en cada salto.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100212567768304724)
,p_name=>'PE.PROPERTY.COMPUTE_SUM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Calcular Suma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100597311958305013)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para evaluar la expresi\00F3n introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100597739312305013)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100597651759305013)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100597576350305013)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100597876672305013)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100597480820305013)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100597226022305013)
,p_name=>'PE.PROPERTY.CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100599331205305015)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100599667618305015)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100599580830305015)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100599483220305015)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100599724240305015)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100599293448305014)
,p_name=>'PE.PROPERTY.CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99885085633304436)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina utilizado en esta condici\00F3n. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99884925454304436)
,p_name=>'PE.PROPERTY.CONDITION_ITEM1.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99886427866304437)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina utilizado en esta condici\00F3n. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99886393913304437)
,p_name=>'PE.PROPERTY.CONDITION_ITEM2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100598910202305014)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Java para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100598864573305014)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100600547860305016)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Java que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100600494266305015)
,p_name=>'PE.PROPERTY.CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100598753501305014)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100598693189305014)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n JavaScript para esta condici\00F3n.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100598535322305014)
,p_name=>'PE.PROPERTY.CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100600306771305015)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100600221371305015)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n JavaScript que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100600182403305015)
,p_name=>'PE.PROPERTY.CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99885293162304436)
,p_name=>'PE.PROPERTY.CONDITION_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de valores separados por dos puntos (:) para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99885137925304436)
,p_name=>'PE.PROPERTY.CONDITION_LIST.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99885643039304436)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero de p\00E1gina para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99885560957304436)
,p_name=>'PE.PROPERTY.CONDITION_PAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99885835504304436)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de n\00FAmeros de p\00E1gina separados por comas para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99885780559304436)
,p_name=>'PE.PROPERTY.CONDITION_PAGES.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100598498608305014)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100598329081305014)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n PL/SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100598218193305014)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100600080186305015)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100599931533305015)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n PL/SQL que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100599816786305015)
,p_name=>'PE.PROPERTY.CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99885411617304436)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una preferencia de usuario que se compare con el valor especificado para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99885340759304436)
,p_name=>'PE.PROPERTY.CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Preferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100599159197305014)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Python para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100599077556305014)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100600740678305016)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Python que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100600665019305016)
,p_name=>'PE.PROPERTY.CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100598185134305014)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Para volver correctamente cuando el empleado es un gestor y su departamento se encuentra en Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100598015826305014)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100597908533305014)
,p_name=>'PE.PROPERTY.CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100743949026305126)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente porque una o m\00E1s filas existen al comprobar si el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Para volver correctamente porque no existen filas al comprobar si el empleado est\00E1 en el departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99884644507304435)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una consulta SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99884585839304435)
,p_name=>'PE.PROPERTY.CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99886027092304436)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor de texto para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99885924870304436)
,p_name=>'PE.PROPERTY.CONDITION_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99886610415304437)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor, incluidas las cadenas de sustituci\00F3n <code>&ITEM.</code>, para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99886530391304437)
,p_name=>'PE.PROPERTY.CONDITION_TEXT2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100259923973304762)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un tipo de condici\00F3n que deba cumplirse para que esta acci\00F3n est\00E9 activa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99887573934304438)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un tipo de condici\00F3n que deba cumplirse para que esta acci\00F3n din\00E1mica est\00E9 activa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99883507185304434)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un tipo de condici\00F3n que se debe cumplir para presentar o procesar este componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100441934324304898)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'es'
,p_message_text=>'Siempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100579595294305000)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El componente siempre se presentar\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100440514003304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es Microsoft Internet Explorer 7.0 o superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100440655385304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es un explorador compatible con XHTML/CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100440461647304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es Mozilla, Netscape 6.x/7x o superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100440753459304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'es'
,p_message_text=>unistr('El explorador del cliente son otros exploradores (o versi\00F3n anterior)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100439117434304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto est\00E1 incluido en el elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100441179758304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'es'
,p_message_text=>'Idioma Actual = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100583158262305003)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 ejecutando la aplicaci\00F3n en el idioma que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100440846497304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'es'
,p_message_text=>unistr('El idioma actual est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100583357402305003)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 ejecutando la aplicaci\00F3n en uno de los idiomas que se introducen en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100441042191304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'es'
,p_message_text=>'Idioma Actual != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100583232091305003)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 ejecutando la aplicaci\00F3n en el idioma que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100440998525304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'es'
,p_message_text=>unistr('El idioma actual no est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100583476745305003)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 ejecutando la aplicaci\00F3n en ninguno de los idiomas que se introducen en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100438369762304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual = P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100581911490305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual es igual que el valor que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100438534463304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en una lista delimitada por comas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100582160340305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en la lista delimitada por comas que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100438445296304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual != P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100582034439305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual no es igual que el valor que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100438695088304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en una lista no delimitada por comas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100582250425305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual no est\00E1 en la lista delimitada por comas que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100441233019304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: DAD_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100441398158304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: DAD_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100440007764304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Errores de Validaci\00F3n en L\00EDnea Mostrados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100582964051305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('En la p\00E1gina se muestra un error de validaci\00F3n en l\00EDnea despu\00E9s de una ejecuci\00F3n de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100439471441304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Texto = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100439296613304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100439386162304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto no est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100439514160304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Texto != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100436006145304893)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Filas Devueltas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100579600774305000)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta SQL devuelve una o m\00E1s filas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100597098019305013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100597146137305013)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La expresi\00F3n se eval\00FAa en TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100436254162304893)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100579880656305000)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El cuerpo de la funci\00F3n devuelve TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100441670431304898)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100441744080304898)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100439760813304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina/Regi\00F3n NO Es de S\00F3lo Lectura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100582696336305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La regi\00F3n principal o de p\00E1gina, si son las adecuadas, se muestran con normalidad.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100439696245304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina/Regi\00F3n Es de S\00F3lo Lectura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100582547114305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Ya se trate de una regi\00F3n principal o de p\00E1gina, si son las adecuadas, la condici\00F3n "Solo Lectura" se eval\00FAa en TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100437586752304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'es'
,p_message_text=>'El elemento no contiene espacios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100581111298305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>elemento</em> seleccionado no tiene espacios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100437851978304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es alfanum\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100581419745305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es alfanum\00E9rico, es decir, contiene solo letras y n\00FAmeros y ning\00FAn car\00E1cter especial.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100437004451304894)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es no nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100580692730305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100437750655304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es no num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100581305264305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no es num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100437265837304894)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento NO es cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100580800272305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100436910639304894)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'es'
,p_message_text=>'El Elemento es NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100580544600305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100437385614304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es nulo o cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100580944913305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado est\00E1 vac\00EDo o es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100437660948304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100581224180305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100437116789304894)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100580796500305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100437443801304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es no nulo y no cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100581083230305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 vac\00EDo y no es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100440244731304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'es'
,p_message_text=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Adelante)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100440375892304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Atr\00E1s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100441891236304898)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'es'
,p_message_text=>'Nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100583548528305003)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>El componente nunca se presenta.</p>',
unistr('<p>Nota: cambiar una condici\00F3n a <strong>Nunca</strong> eliminar\00E1 cualquier condici\00F3n existente. Para desactivar un componente temporalmente, Oracle recomienda utilizar en su lugar el atributo <em>Opci\00F3n de Creaci\00F3n</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100440104691304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Errores de Validaci\00F3n en L\00EDnea No Mostrados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100583078825305003)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El error de validaci\00F3n en l\00EDnea no se muestra en la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100436152793304893)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Ninguna Fila Devuelta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100579785717305000)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>'La consulta SQL no devuelve ninguna fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100438919503304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en modo Versi\00F3n para Impresora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100582335258305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final ha cambiado la p\00E1gina actual al modo "Versi\00F3n para Impresora".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100439093785304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual no en modo Versi\00F3n para Impresora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100582408388305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no ha cambiado la p\00E1gina actual al modo "Versi\00F3n para Impresora".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100436356151304893)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'Solicitud = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100579966322305000)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina es igual que el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100436506746304893)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud est\00E1 incluida en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100580185785305000)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina se incluye en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100436442254304893)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'Solicitud != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100580047036305000)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina no es igual que el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100436628364304893)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud no est\00E1 incluida en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100580240231305000)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina no se incluye en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100441495829304897)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100441569857304898)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100439852906304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Usuario Autenticado  (no p\00FAblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100582786674305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 conectado a la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100439967179304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'es'
,p_message_text=>unistr('El Usuario es el Usuario P\00FAblico (el usuario no se ha autenticado)')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100582854710305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 conectado a la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100438146133304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia del Usuario = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100581771092305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor de la <em>preferencia</em> introducida es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100438279606304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia del Usuario != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100581857247305002)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor de la <em>preferencia</em> introducida no es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100437960618304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento est\00E1 en una lista delimitada por dos puntos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100581548763305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado est\00E1 totalmente incluido en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100438001789304895)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento est\00E1 en una lista no delimitada por dos puntos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100581610922305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 totalmente incluido en el texto introducido en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100436780685304894)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Elemento = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100580306444305000)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>elemento</em> seleccionado es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100436856309304894)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Elemento != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100580402958305001)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>elemento</em> seleccionado no es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100438821299304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual != P\00E1gina Ejecutada (enviada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100438768604304896)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual = P\00E1gina Ejecutada (enviada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99883474128304434)
,p_name=>'PE.PROPERTY.CONDITION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99884886692304435)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor que se va a comparar con la condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99884789855304435)
,p_name=>'PE.PROPERTY.CONDITION_VALUE1.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99886226942304437)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor, incluidas las cadenas de sustituci\00F3n <code>&ITEM.</code>, para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99886121159304436)
,p_name=>'PE.PROPERTY.CONDITION_VALUE2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99755895052304334)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Proteja el comportamiento del bot\00F3n con una petici\00F3n de confirmaci\00F3n. Muestra un di\00E1logo de confirmaci\00F3n despu\00E9s de pulsar el bot\00F3n, donde el usuario debe confirmar antes de que el bot\00F3n realice la acci\00F3n.</p>'),
unistr('<p>Esta funcionalidad se puede utilizar para asegurarse de que el usuario no realiza ninguna acci\00F3n importante por accidente, como eliminar un informe.</p>'),
unistr('<p>Nota: El bot\00F3n de confirmaci\00F3n en el di\00E1logo deriva su etiqueta a partir de la etiqueta del bot\00F3n principal.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99755793717304334)
,p_name=>'PE.PROPERTY.CONFIRM_ENABLED.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Necesita Confirmaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99756135836304334)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>unistr('<pre>&lt;strong&gt;\00BFSeguro que&lt;&#x2F;strong&gt; desea suprimir al empleado &amp;P1_ENAME.?</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99756074823304334)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el mensaje que se va a mostrar en el cuadro de di\00E1logo de confirmaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99755950890304334)
,p_name=>'PE.PROPERTY.CONFIRM_MESSAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mensaje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99756876046304334)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99756324367304334)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el estilo del di\00E1logo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99756694200304334)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.DANGER.D'
,p_message_language=>'es'
,p_message_text=>'Peligro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99756408461304334)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.INFORMATION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99756797308304334)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.SUCCESS.D'
,p_message_language=>'es'
,p_message_text=>'Correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99756538823304334)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.LOV.WARNING.D'
,p_message_language=>'es'
,p_message_text=>'Advertencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99756216363304334)
,p_name=>'PE.PROPERTY.CONFIRM_STYLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100218745117304729)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la disposici\00F3n de contenido en la lista disponible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100397626402304863)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.ATTACHMENT.D'
,p_message_language=>'es'
,p_message_text=>'Adjunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100397771679304863)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.LOV.INLINE.D'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100218677830304729)
,p_name=>'PE.PROPERTY.CONTENT_DISPOSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Disposici\00F3n del Contenido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99943988663304482)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el atributo de dominio de URL para la cookie de sesi\00F3n.'),
unistr('Si la comparaci\00F3n de la cola de la URL de solicitud no coincide con el dominio especificado, la cookie no se env\00EDa al explorador.'),
'El valor por defecto es el nombre de host de la URL de solicitud.</p>',
unistr('<p>Utilice este atributo para especificar un dominio menos restrictivo, si desea compartir cookies de sesi\00F3n entre aplicaciones con dominios comunes.'),
unistr('Por ejemplo, <code>my.yahoo.com</code>, <code>sport.yahoo.com</code> y <code>finance.yahoo.com</code>, todas podr\00EDan acceder a la misma cookie si se introduce el dominio <code>yahoo.com</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99943838716304482)
,p_name=>'PE.PROPERTY.COOKIE_DOMAIN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Dominio de Cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99943568470304481)
,p_name=>'PE.PROPERTY.COOKIE_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la cookie de sesi\00F3n, necesario para identificar una sesi\00F3n de &PRODUCT_NAME., junto con el ID de sesi\00F3n en la URL.'),
unistr('Si no especifica un nombre de cookie de sesi\00F3n, &PRODUCT_NAME. utilizar\00E1 un valor por defecto.</p>'),
unistr('<p>Si introduce el mismo nombre de cookie en varias aplicaciones, cada una de las aplicaciones puede utilizar la misma cookie de sesi\00F3n.'),
unistr('Por lo tanto, en una llamada de URL desde una aplicaci\00F3n de &PRODUCT_NAME. a otra aplicaci\00F3n de &PRODUCT_NAME. con el mismo nombre de cookie, no es necesario que el usuario se vuelva a autenticar porque la nueva aplicaci\00F3n puede utilizar la cookie de')
||unistr(' sesi\00F3n existente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99943432840304481)
,p_name=>'PE.PROPERTY.COOKIE_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre de Cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99943758125304482)
,p_name=>'PE.PROPERTY.COOKIE_PATH.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el atributo de ruta de acceso a URL para la cookie de sesi\00F3n.'),
unistr('Si el principio de la URL de solicitud no coincide con la ruta de acceso especificada, la cookie no se env\00EDa al explorador.'),
'El valor por defecto es la ruta de acceso a la URL de la solicitud.</p>',
unistr('<p>Utilice este atributo para especificar una ruta de acceso menos restrictiva, si desea compartir cookies de sesi\00F3n entre aplicaciones que inicialmente tengan rutas de acceso a URL compatibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99943622848304482)
,p_name=>'PE.PROPERTY.COOKIE_PATH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ruta de Acceso de Cookie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100363748154304838)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt> Referencia de archivo est\00E1ndar</dt>'),
'<dd><pre>/mycss/main.css</pre></dd>',
unistr('<dt>Referencia de archivo est\00E1ndar que carga el archivo minimizado main.min.css de /mycss/minified/ para vistas de p\00E1gina normales y main.css de /mycss/ en el modo de depuraci\00F3n o cuando la aplicaci\00F3n se ejecuta desde el creador de aplicaciones.</dt>'),
'<dd><pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre></dd>',
'<dt>Consulta de medios condicional</dt>',
'<dd><pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre></dd>',
unistr('<dt>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n. Por ejemplo, cuando cambia de versi\00F3n la aplicaci\00F3n (y se incrementa la versi\00F3n), se indicar\00E1 al explorador que siempre cargue e')
||unistr('l nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.</dt>'),
'<dd><pre>/mycss/main.css?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99850364355304407)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las URL de archivo de la hoja de estilo en cascada (CSS) cargadas en esta p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea.'),
unistr('Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#</code> para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para una vista de p\00E1g')
||unistr('ina normal y una cadena vac\00EDa si la p\00E1gina se visualiza en modo de depuraci\00F3n o al ejecutar la aplicaci\00F3n desde el creador de aplicaciones.'),
unistr('Tambi\00E9n tiene acceso a la cadena de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
unistr('<p>Las URL de archivo que introduzca aqu\00ED sustituir\00E1n a la cadena de sustituci\00F3n <code>#PAGE_CSS#</code> en la plantilla de p\00E1gina.</p>'),
'<p>Nota: No es necesario incluir las etiquetas <code>link</code> de apertura o de cierre. Incluya solo la URL de archivo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99850239372304407)
,p_name=>'PE.PROPERTY.CSS_FILE_URLS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'URL de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100396517792304862)
,p_name=>'PE.PROPERTY.CSS_STYLE.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Al definir este atributo en <code>color:#FF0000;</code>, el color del texto de la columna cambia a rojo y se genera el siguiente HTML</dt>',
'<dd><pre>',
'&lt;span style="color:#FF0000"&gt;Datos de Ejemplo&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100214071090304726)
,p_name=>'PE.PROPERTY.CSS_STYLE.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca los estilos de CSS que se aplican a este valor de columna. Puede escribir el estilo CSS o elegirlo en la lista de elementos disponibles.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100213926024304725)
,p_name=>'PE.PROPERTY.CSS_STYLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo de CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100187066332304706)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un car\00E1cter delimitador para definir el l\00EDmite inicial y final de un valor de datos. Las comillas son el delimitador por defecto.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100186975953304706)
,p_name=>'PE.PROPERTY.CSV_ENCLOSED_BY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'CSV Delimitado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100221938859304731)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si los usuarios finales pueden descargar el contenido del informe a un archivo CSV. Para activar <em>Descargas de CSV</em>, debe utilizar una plantilla de informe con una cadena de sustituci\00F3n <code>#CSV_LINK#</code> y definir esta opci\00F3n')
||' en <b>Activado</b>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100221807461304731)
,p_name=>'PE.PROPERTY.CSV_EXPORT_ENABLED.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Exportaci\00F3n de CSV Activada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100186874632304706)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un separador de columnas. Si no se introduce ning\00FAn valor, se utiliza una coma o un punto y coma en funci\00F3n de los valores de NLS actuales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100186714909304706)
,p_name=>'PE.PROPERTY.CSV_SEPARATOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Separador de CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99854852513304411)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el cursor debe enfocarse cuando se entra por primera vez a la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100357321492304834)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.D'
,p_message_language=>'es'
,p_message_text=>unistr('Primer Elemento en la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100357478709304834)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.AUTO_FIRST_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El enfoque de cursor se sit\00FAa en el primer campo de la p\00E1gina mediante JavaScript, que genera el motor de &PRODUCT_NAME..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100357563281304834)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.D'
,p_message_language=>'es'
,p_message_text=>'No Enfocar Cursor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100357615486304834)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.LOV.NO_FIRST_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El cursor no se enfoca y no se genera ning\00FAn JavaScript.<br>'),
unistr('Seleccione esta opci\00F3n si el JavaScript generado entra en conflicto con el JavaScript personalizado.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99849459584304406)
,p_name=>'PE.PROPERTY.CURSOR_FOCUS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Enfoque de Cursor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99947504327304485)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione si el usuario puede personalizar los atributos de visualizaci\00F3n en esta regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100378392372304849)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.0.D'
,p_message_language=>'es'
,p_message_text=>'No Personalizable por Usuarios Finales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100378230370304849)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.1.D'
,p_message_language=>'es'
,p_message_text=>'Personalizable y Mostrado por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100378125154304849)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.LOV.2.D'
,p_message_language=>'es'
,p_message_text=>'Personalizable y No Mostrado por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99947467151304484)
,p_name=>'PE.PROPERTY.CUSTOMIZABLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Personalizable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99946545602304484)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la etiqueta del enlace que aparece en esta regi\00F3n, que proporciona acceso a la p\00E1gina de personalizaci\00F3n de la regi\00F3n.'),
'Esta etiqueta solo se muestra para las regiones que se pueden personalizar.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99946483916304484)
,p_name=>'PE.PROPERTY.CUSTOMIZED_OPTION_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100252001599304755)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el texto HTML que se va a incluir para este bot\00F3n:'),
'<ul>',
unistr('  <li>Para los botones de tipo <strong>Bot\00F3n HTML</strong>, se agregar\00E1 este texto a la definici\00F3n de elemento HTML.</li>'),
unistr('  <li>Para los botones basados en plantillas, su plantilla tendr\00E1 que incluir la cadena de sustituci\00F3n <code>#BUTTON_ATTRIBUTES#</code>.</li>'),
'</ul>',
'Puede utilizar este atributo para controlar las paradas de tabulador</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100252202377304756)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La cadena de sustituci\00F3n de la plantilla de informe <code>#REPORT_ATTRIBUTES#</code> se sustituir\00E1 por este valor. La cadena de sustituci\00F3n <code>#REPORT_ATTRIBUTES#</code> solo se sustituye en el atributo Antes de Filas de la plantilla de informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100092164037304595)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca los atributos adicionales que se incluir\00E1n en la etiqueta HTML del elemento de pantalla. Los atributos HTML <code>size</code> e <code>id</code> se generan y, por lo tanto, no se deben proporcionar. Para el atributo HTML <code>class</code>,')
||' es preferible utilizar en su lugar el atributo <em>Clases CSS</em> dedicado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100251968343304755)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca los atributos adicionales que se incluir\00E1n en la etiqueta HTML del elemento de pantalla. Los atributos HTML <code>size</code> e <code>id</code> se generan y, por lo tanto, no se deben proporcionar. Para el atributo HTML <code>class</code>,')
||' es preferible utilizar en su lugar el atributo <em>Clases CSS</em> dedicado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100252171485304756)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor sustituido en los atributos de regi\00F3n. Las plantillas de regi\00F3n que contienen la cadena de sustituci\00F3n <code>#REGION_ATTRIBUTES#</code> se sustituir\00E1n por este valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100252311011304756)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La cadena de sustituci\00F3n de la plantilla de informe <code>#REPORT_ATTRIBUTES#</code> se sustituir\00E1 por este valor. La cadena de sustituci\00F3n <code>#REPORT_ATTRIBUTES#</code> solo se sustituye en el atributo Antes de Filas de la plantilla de informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100251831527304755)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Introduzca atributos delimitados por espacios adicionales para incluirlos en la etiqueta del elemento.',
'Para el atributo CLASS de HTML, Oracle recomienda utilizar el atributo de clases CSS dedicado.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100251716770304755)
,p_name=>'PE.PROPERTY.CUSTOM_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atributos Personalizados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100163166247304688)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el nombre de columna personalizada, que se puede utilizar para definir una ayuda de burbuja personalizada, o los colores basados en base de datos que se utilizar\00E1n para los elementos del gr\00E1fico. En el caso de un gr\00E1fico de \00E1reas, la colu')
||unistr('mna no debe coincidir con la asignaci\00F3n de la columna Valor seleccionada. La selecci\00F3n de una columna que coincida con la asignaci\00F3n de la columna Valor resultar\00E1 en que no se utilice ninguna columna personalizada para el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100163017898304688)
,p_name=>'PE.PROPERTY.CUSTOM_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna personalizada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99853319492304410)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique un nombre de evento JavaScript personalizado si los eventos declarativos proporcionados no son suficientes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99853217069304410)
,p_name=>'PE.PROPERTY.CUSTOM_EVENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Evento Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100169841011304693)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la operaci\00F3n de base de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100170335061304693)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.DELETE.D'
,p_message_language=>'es'
,p_message_text=>'Suprimir Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100169968831304693)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_COLLECTION.D'
,p_message_language=>'es'
,p_message_text=>'Recuperar filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100170021444304693)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.FETCH_SINGLE_ROW.D'
,p_message_language=>'es'
,p_message_text=>'Recuperar una sola fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100170176541304693)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.INSERT.D'
,p_message_language=>'es'
,p_message_text=>'Insertar Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100170286050304693)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.LOV.UPDATE.D'
,p_message_language=>'es'
,p_message_text=>'Actualizar Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100169735853304693)
,p_name=>'PE.PROPERTY.DATABASE_OPERATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Operaci\00F3n de Base de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100407600777304873)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100248217125304752)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para el fondo de los datos que se muestran en este calendario.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100248110828304752)
,p_name=>'PE.PROPERTY.DATA_BACKGROUND_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Fondo de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99683064812304280)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la columna sensible a may\00FAsculas/min\00FAsculas utilizada como origen de este valor de elemento.</p>'),
unistr('<p>Esta columna debe existir en el origen de datos especificado en la regi\00F3n de pantalla.'),
unistr('Se genera un error en el tiempo de ejecuci\00F3n y la p\00E1gina no se carga si el nombre de la columna no existe en la tabla a la que se hace referencia.'),
unistr('De forma similar, si no hay ning\00FAn proceso de recuperaci\00F3n de fila incorporado definido y hay un elemento con el tipo de origen <strong>Columna de base de datos</strong>, se genera un error y la p\00E1gina no se carga al intentar representar la p\00E1gina.</')
||'p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99682970990304280)
,p_name=>'PE.PROPERTY.DATA_SOURCE_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99682893784304280)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la regi\00F3n de pantalla asociada de este elemento de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99682772360304280)
,p_name=>'PE.PROPERTY.DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n de Pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100448101388304902)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100248405283304753)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para los datos de este calendario.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100248323549304752)
,p_name=>'PE.PROPERTY.DATA_TEXT_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100088021913304592)
,p_name=>'PE.PROPERTY.DATA_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el tipo de dato de la columna de base de datos subyacente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100754424191305134)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BFILE.D'
,p_message_language=>'es'
,p_message_text=>'BFILE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100754296857305134)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.BLOB.D'
,p_message_language=>'es'
,p_message_text=>'BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100754158775305134)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.CLOB.D'
,p_message_language=>'es'
,p_message_text=>'CLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100753566303305133)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.DATE.D'
,p_message_language=>'es'
,p_message_text=>'FECHA'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100754084980305134)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_D2S.D'
,p_message_language=>'es'
,p_message_text=>'INTERVAL DAY TO SECOND'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100753996333305134)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.INTERVAL_Y2M.D'
,p_message_language=>'es'
,p_message_text=>'INTERVAL YEAR TO MONTH'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100753476676305133)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.NUMBER.D'
,p_message_language=>'es'
,p_message_text=>'NUMBER'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100754332602305134)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.ROWID.D'
,p_message_language=>'es'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99753751855304332)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'es'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100753607674305133)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP.D'
,p_message_language=>'es'
,p_message_text=>'TIMESTAMP'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100753833369305134)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_LTZ.D'
,p_message_language=>'es'
,p_message_text=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100753744502305134)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.TIMESTAMP_TZ.D'
,p_message_language=>'es'
,p_message_text=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100753302830305133)
,p_name=>'PE.PROPERTY.DATA_TYPE.LOV.VARCHAR2.D'
,p_message_language=>'es'
,p_message_text=>'VARCHAR2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100087930484304592)
,p_name=>'PE.PROPERTY.DATA_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Dato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100245204670304750)
,p_name=>'PE.PROPERTY.DATE_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna de la tabla o consulta que contiene las fechas que se incluir\00E1n en el calendario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100245119642304750)
,p_name=>'PE.PROPERTY.DATE_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Fecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100245476588304750)
,p_name=>'PE.PROPERTY.DATE_FORMAT.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si desea mostrar la hora o solo los valores de fecha en el calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100245393168304750)
,p_name=>'PE.PROPERTY.DATE_FORMAT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar Hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100213226371304725)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la m\00E1scara de formato que se aplica al selector de fechas de esta columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100393699222304860)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY.D'
,p_message_language=>'es'
,p_message_text=>'DD/MM/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100393411135304860)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DASH.D'
,p_message_language=>'es'
,p_message_text=>'DD-MM-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100393596864304860)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_DOT.D'
,p_message_language=>'es'
,p_message_text=>'DD.MM.YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100394210686304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI.D'
,p_message_language=>'es'
,p_message_text=>'DD/MM/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100394015615304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DASH.D'
,p_message_language=>'es'
,p_message_text=>'DD-MM-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100394188825304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH24_MI_DOT.D'
,p_message_language=>'es'
,p_message_text=>'DD.MM.YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100393958923304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI.D'
,p_message_language=>'es'
,p_message_text=>'DD/MM/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100393703546304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DASH.D'
,p_message_language=>'es'
,p_message_text=>'DD-MM-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100393852255304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MM_YYYY_HH_MI_DOT.D'
,p_message_language=>'es'
,p_message_text=>'DD.MM.YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100394372307304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR.D'
,p_message_language=>'es'
,p_message_text=>'DD-MON-RR'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100394539602304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH24_MI.D'
,p_message_language=>'es'
,p_message_text=>'DD-MON-RR HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100394491078304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_RR_HH_MI.D'
,p_message_language=>'es'
,p_message_text=>'DD-MON-RR HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100394696485304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY.D'
,p_message_language=>'es'
,p_message_text=>'DD-MON-YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100394810183304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH24_MI.D'
,p_message_language=>'es'
,p_message_text=>'DD-MON-YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100394763147304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_DD_MON_YYYY_HH_MI.D'
,p_message_language=>'es'
,p_message_text=>'DD-MON-YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100394937659304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY.D'
,p_message_language=>'es'
,p_message_text=>'MM/DD/YYYY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100395110080304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH24_MI.D'
,p_message_language=>'es'
,p_message_text=>'MM/DD/YYYY HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100395074014304861)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_MM_DD_YYYY_HH_MI.D'
,p_message_language=>'es'
,p_message_text=>'MM/DD/YYYY HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100395240994304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD.D'
,p_message_language=>'es'
,p_message_text=>'RR-MON-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100395456968304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH24_MI.D'
,p_message_language=>'es'
,p_message_text=>'RR-MON-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100395349717304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_RR_MON_DD_HH_MI.D'
,p_message_language=>'es'
,p_message_text=>'RR-MON-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100393161047304860)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_DATE_FORMAT.D'
,p_message_language=>'es'
,p_message_text=>unistr('Usar Formato de Fecha de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100393268171304860)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_APP_FORMAT_MASK.D'
,p_message_language=>'es'
,p_message_text=>unistr('Usar M\00E1scara de Formato de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100393319847304860)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_USING_FORMAT_MASK.D'
,p_message_language=>'es'
,p_message_text=>unistr('Usar M\00E1scara de Formato de Elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100395510020304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_DOT.D'
,p_message_language=>'es'
,p_message_text=>'YYYY.DD.MM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100395789106304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH24_MI_DOT.D'
,p_message_language=>'es'
,p_message_text=>'YYYY.DD.MM HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100395676784304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_DD_MM_HH_MI_DOT.D'
,p_message_language=>'es'
,p_message_text=>'YYYY.DD.MM HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100395829324304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD.D'
,p_message_language=>'es'
,p_message_text=>'YYYY-MM-DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100396283240304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI.D'
,p_message_language=>'es'
,p_message_text=>'YYYY-MM-DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100396397815304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH.D'
,p_message_language=>'es'
,p_message_text=>'YYYY/MM/DD HH24:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100396099660304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI.D'
,p_message_language=>'es'
,p_message_text=>'YYYY-MM-DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100396113102304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_HH_MI_SLASH.D'
,p_message_language=>'es'
,p_message_text=>'YYYY/MM/DD HH:MI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100395977301304862)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.LOV.PICK_DATE_YYYY_MM_DD_SLASH.D'
,p_message_language=>'es'
,p_message_text=>'YYYY/MM/DD'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100213176469304725)
,p_name=>'PE.PROPERTY.DATE_PICKER_FORMAT_MASK.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara de Formato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100249520908304753)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic en el destino para llamar a un cuadro de di\00E1logo modal. Puede introducir el enlace de destino al que llama el calendario al crear un evento haciendo clic en una celda del calendario fuera de un evento existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100249412553304753)
,p_name=>'PE.PROPERTY.DAY_LINK_TARGET.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Crear Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99877722516304429)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique qu\00E9 acci\00F3n desea realizar. Est\00E1n soportadas las siguientes acciones:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Seg\00FAn se haya configurado la aplicaci\00F3n, aqu\00ED tambi\00E9n podr\00E1 tener disponibles plugins de acciones din\00E1micas adicionales.'),
'Se muestran como <em>&lt;Mi Plugin&gt; [Plug-in]</em>.',
unistr('Entre los componentes compartidos de esta aplicaci\00F3n se encuentran instalados los siguientes plugins:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99877649763304429)
,p_name=>'PE.PROPERTY.DA_ACTION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100201108602304716)
,p_name=>'PE.PROPERTY.DA_EVENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el evento de acci\00F3n din\00E1mica adecuado en la lista disponible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100201005123304716)
,p_name=>'PE.PROPERTY.DA_EVENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100564254774304988)
,p_name=>'PE.PROPERTY.DB_SESSION_CLEANUP.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo PL/SQL de Limpieza')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100564141861304988)
,p_name=>'PE.PROPERTY.DB_SESSION_INIT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo PL/SQL de Inicializaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100233103400304740)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor por Defecto de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100674295060305071)
,p_name=>'PE.PROPERTY.DEEP_LINKING.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Utiliza el valor definido en los atributos de seguridad de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99857203790304413)
,p_name=>'PE.PROPERTY.DEEP_LINKING.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione c\00F3mo manejar en esta p\00E1gina las solicitudes de URL externas.'),
unistr('Las solicitudes de p\00E1gina desde esta aplicaci\00F3n a esta p\00E1gina no est\00E1n consideradas enlaces profundos y no est\00E1n regidas por la configuraci\00F3n de este atributo.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100358252223304834)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100358303807304834)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.N.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Si la URL no contiene un ID de sesi\00F3n v\00E1lido, &PRODUCT_NAME. inicia una nueva sesi\00F3n y redirecciona al usuario a la p\00E1gina inicial de la aplicaci\00F3n, en lugar de a esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100358039689304834)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100358140368304834)
,p_name=>'PE.PROPERTY.DEEP_LINKING.LOV.Y.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si esta p\00E1gina se especifica como la p\00E1gina de destino en una direcci\00F3n URL, la redirecciona en \00FAltima instancia a esta p\00E1gina.<br>'),
unistr('Si el usuario a\00FAn no se ha autenticado y la p\00E1gina no es p\00FAblica, el sistema solicita que el usuario se conecte.'),
unistr('Tras la conexi\00F3n correcta a la aplicaci\00F3n, el usuario es redireccionado a esta p\00E1gina.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99857152832304413)
,p_name=>'PE.PROPERTY.DEEP_LINKING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Enlace Profundo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99998304371304523)
,p_name=>'PE.PROPERTY.DEFAULT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si la interfaz de usuario es la interfaz de la aplicaci\00F3n por defecto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99998275514304523)
,p_name=>'PE.PROPERTY.DEFAULT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99847323436304405)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la opci\00F3n de creaci\00F3n por defecto aplicada a este componente al realizar la exportaci\00F3n. Esta opci\00F3n puede sustituirse por opciones de exportaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100355776264304832)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.D'
,p_message_language=>'es'
,p_message_text=>'Excluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100665727427305064)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.EXCLUDE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Desactivado y no forma parte de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100355870801304832)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.D'
,p_message_language=>'es'
,p_message_text=>'Incluir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100665875979305064)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.LOV.INCLUDE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Activado y forma parte de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99847279143304405)
,p_name=>'PE.PROPERTY.DEFAULT_ON_EXPORT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor por Defecto en la Exportaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100088874862304592)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la forma en la que se determina el valor por defecto de esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100588861335305007)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100588975544305007)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde la <em>expresi\00F3n</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100589000695305007)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100589143074305007)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde el <em>cuerpo de la funci\00F3n</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100089125732304593)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100089217863304593)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto del estado de sesi\00F3n del <em>elemento</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100089766074304593)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100089845310304593)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Defina esta opci\00F3n con el valor devuelto a partir de la <em>secuencia</em> introducida. Es un tipo por defecto "especial": se ejecuta como parte del proceso DML Cuadr\00EDcula interactiva y <em>no</em> durante la carga de la p\00E1gina. Utilice este tipo ')
||unistr('para los valores de clave principal generados autom\00E1ticamente, cuando no se pueda usar <strong>Devolver claves principales tras inserci\00F3n</strong>, por ejemplo, al trabajar con vistas y disparadores INSTEAD OF o con enlaces de base de datos. El nombr')
||unistr('e de secuencia es sensible a may\00FAsculas/min\00FAsculas; utilice comillas dobles para indicar un nombre de secuencia con may\00FAsculas/min\00FAsculas ("miSecuencia").</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100089331539304593)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100089421622304593)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde la <em>consulta SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100089542003304593)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL que Devuelve Lista Delimitada por Dos Puntos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100089646393304593)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Def\00EDnalo seg\00FAn la lista de valores delimitada por dos puntos devuelta de la <em>Consulta SQL</em> introducida.</p>'),
'        <p>Nota: Las listas delimitadas por dos puntos son necesarias cuando la columna se muestra como una casilla de control, grupo de botones de radio o selector.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100088966958304593)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100089023089304593)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.LOV.STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor introducido en <em>Valor Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100088768408304592)
,p_name=>'PE.PROPERTY.DEFAULT_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100611918095305024)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para evaluar la expresi\00F3n introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100612320265305024)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100612245728305024)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100612150470305024)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100612473241305024)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100612063546305024)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100611836934305024)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100613934658305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100614293900305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100614148690305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100614037497305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100614360533305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100613861419305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100236837795304743)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el valor por defecto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100236776032304743)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100613571897305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n Java que produzca el valor para este elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100613435205305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100615196963305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n Java que devuelva el valor para este elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100615077081305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100613386489305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100613227662305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n JavaScript que produzca el valor para este elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100613191449305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100614929369305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100614802938305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n JavaScript que devuelva el valor para este elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100614758689305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100613043387305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100612992441305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n PL/SQL que produzca el valor para este elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100612859183305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100614630827305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100614517408305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n PL/SQL que devuelva el valor para este elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100614450607305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100613790984305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n Python que produzca el valor para este elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100613693614305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100615370922305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n Python que devuelva el valor para este elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100615214211305026)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100090405510304594)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el nombre de la secuencia de la base de datos que devuelva el valor por defecto para esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100090396170304594)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SEQUENCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100612763442305025)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Para devolver YES cuando el empleado es un gestor y su departamento se encuentra en Chicago:</dt>',
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100612662200305024)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n SQL que produzca el valor para este elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100612572308305024)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100090043523304593)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la consulta SQL que devuelva el valor por defecto para esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100089902055304593)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100090236744304594)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la consulta SQL que devuelva la lista de valores delimitadas por dos puntos por defecto para esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100090124349304593)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_SQL_QUERY_COLON.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL: Dos Puntos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99870905433304424)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique un valor por defecto para este elemento. El valor por defecto se utiliza cuando el valor del elemento no se deriva del estado de la sesi\00F3n y cuando el valor de origen es nulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99870890431304423)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_STATIC_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99870762145304423)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un tipo de valor por defecto para este elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100588268206305006)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100588323352305006)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde la <em>expresi\00F3n</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100588426946305007)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100588591890305007)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde el <em>cuerpo de la funci\00F3n</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99681634740304279)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99681744594304279)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto del estado de sesi\00F3n del <em>elemento</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99682279866304280)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.D'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99682391017304280)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SEQUENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Defina esta opci\00F3n con el valor devuelto a partir de la <em>secuencia</em> introducida. Se trata de un tipo por defecto "especial": se ejecuta como parte del proceso DML Regi\00F3n de pantalla y <em>no</em> durante la carga de p\00E1gina. Utilice este tip')
||unistr('o para los valores de clave principal generados autom\00E1ticamente, cuando no se pueda usar <strong>Devolver claves principales tras inserci\00F3n</strong>, por ejemplo, al trabajar con vistas y disparadores INSTEAD OF o con enlaces de base de datos. El nom')
||unistr('bre de secuencia es sensible a may\00FAsculas/min\00FAsculas.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99681819504304279)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99681980684304279)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde la <em>consulta SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99682073937304279)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL que Devuelve Lista Delimitada por Dos Puntos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99682141011304279)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.SQL_QUERY_COLON.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Def\00EDnalo seg\00FAn la lista de valores delimitada por dos puntos devuelta de la <em>Consulta SQL</em> introducida.</p>'),
'        <p>Nota: Las listas delimitadas por dos puntos son necesarias cuando la columna se muestra como una casilla de control, grupo de botones de radio o selector.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100373051249304845)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99681557555304279)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.LOV.STATIC_TEXT_WITH_SUBSTITUTIONS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor introducido en <em>Valor Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99870633943304423)
,p_name=>'PE.PROPERTY.DEFAULT_VALUE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100100441844304601)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique si los usuarios finales pueden definir un gr\00E1fico de esta cuadr\00EDcula interactiva.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100100310071304601)
,p_name=>'PE.PROPERTY.DEFINE_CHART_VIEW.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Definir vista de gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100076024244304582)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione un esquema de autorizaci\00F3n para restringir los usuarios que pueden suprimir filas.'),
unistr('		Para permitir que un usuario final suprima filas, este esquema de autorizaci\00F3n se debe evaluar en TRUE para ese usuario.'),
unistr('		Si no se proporciona ning\00FAn esquema de autorizaci\00F3n, cualquier usuario puede suprimir filas en esta cuadr\00EDcula interactiva.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100075999104304582)
,p_name=>'PE.PROPERTY.DELETE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100209469908304722)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique una condici\00F3n que compruebe el valor de otra faceta o filtro para controlar si la faceta o el filtro actual se deben mostrar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100209545973304722)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.D'
,p_message_language=>'es'
,p_message_text=>'igual que'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100209677628304722)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor de la <em>faceta o el filtro</em> de los que depende es igual al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100209948537304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'es'
,p_message_text=>'en lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100210036221304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el valor de la <em>faceta o el filtro</em> de los que depende est\00E1 en la <em>lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100209761260304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'es'
,p_message_text=>'distinto de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100209863736304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor de la <em>faceta o el filtro</em> de los que depende no es igual al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100210184643304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'es'
,p_message_text=>'no en lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100210259172304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el valor de la <em>faceta o el filtro</em> de los que depende no est\00E1 en la <em>lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100210581308304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'es'
,p_message_text=>'no es nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100210676963304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el valor de la <em>faceta o el filtro</em> de los que depende no est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100210322653304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.D'
,p_message_language=>'es'
,p_message_text=>'es nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100210416513304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.LOV.NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el valor de la <em>faceta o el filtro</em> de los que depende est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100209372715304722)
,p_name=>'PE.PROPERTY.DEPENDING_ON_CONDITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100211096299304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de valores separados por comas para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100210928507304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_LIST.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100210872940304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100210709990304723)
,p_name=>'PE.PROPERTY.DEPENDING_ON_COND_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100209254598304722)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la faceta asociada que debe comprobarse para decidir si la faceta actual se debe mostrar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100209199414304722)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Faceta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100534758588304966)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la casilla de control asociada que debe comprobarse para decidir si la casilla de control actual se debe mostrar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100534644367304966)
,p_name=>'PE.PROPERTY.DEPENDING_ON_FACET_GRP_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Casilla de control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99897269548304445)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el filtro asociado que debe comprobarse para decidir si el filtro actual se debe mostrar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99897170673304445)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99897460669304445)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la casilla de control asociada que debe comprobarse para decidir si la casilla de control actual se debe mostrar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99897392327304445)
,p_name=>'PE.PROPERTY.DEPENDING_ON_SFILTER_GRP_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Casilla de control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100449346002304903)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('$$$ DJP est\00E1 actualmente oculto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100240268990304746)
,p_name=>'PE.PROPERTY.DERIVED_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna Derivada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100754764259305134)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una descripci\00F3n para este informe interactivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100183896321304704)
,p_name=>'PE.PROPERTY.DESCRIPTION.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una descripci\00F3n para el grupo de columnas. Esta descripci\00F3n no se mostrar\00E1 nunca a los usuarios finales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99851310312304408)
,p_name=>'PE.PROPERTY.DESCRIPTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una descripci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99851298206304408)
,p_name=>'PE.PROPERTY.DESCRIPTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100389792121304858)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;/table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100192048963304710)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el HTML que se va a mostrar despu\00E9s de las filas de informes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100191971814304710)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_AFTER_ROWS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Filas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100389523965304858)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;table&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100191665457304709)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el HTML que se va a mostrar antes de las filas del informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100191540758304709)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_BEFORE_ROWS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Antes de Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100091384649304594)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se debe activar o no la vista de detalles. Si se selecciona <strong>Activado</strong>, se agrega un icono Ver detalles a la barra de b\00FAsqueda para los informes interactivos o el bot\00F3n Ver a la cuadr\00EDcula interactiva, y permite a los us')
||'uarios acceder a esta vista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100191470278304709)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se debe activar o no la vista de detalles. Si se selecciona <strong>Activado</strong>, se agrega un icono Ver Detalles a la barra de b\00FAsqueda para los informes interactivos o el bot\00F3n Ver a la cuadr\00EDcula interactiva, y permite a los us')
||'uarios acceder a esta vista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100191354917304709)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_ENABLED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100752273015305132)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;&ENAME_LABEL.:&lt;/td&gt;&lt;td&gt;&ENAME.&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;&JOB_LABEL.:&lt;/td&gt;&lt;td&gt;&JOB.&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100752383278305132)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el cuerpo de filas del informe en la vista de detalle.</p>',
unistr('<p>Est\00E1n disponibles las siguientes cadenas de sustituci\00F3n:'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - Cadenas de sustituci\00F3n para nombres de columna.</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - Cadenas de sustituci\00F3n para etiquetas de columna.</li>'),
'<li><code>&APEX$ROW_ID.</code> - Identificador de registro para la fila.</li>',
unistr('<li><code>&APEX$ROW_INDEX.</code> - N\00FAmero de secuencia de visualizaci\00F3n del registro.</li>'),
'<li><code>&APEX$ROW_STATE_CLASSES.</code> - Estado del registro, como <code>insertado</code> o <code>suprimido</code>.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100389627726304858)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;tr&gt;&lt;td align="right"&gt;#ENAME_LABEL#:&lt;/td&gt;&lt;td&gt;#ENAME#&lt;/td&gt;&lt;/tr&gt;',
'&lt;tr&gt;&lt;td align="right"&gt;#JOB_LABEL#:&lt;/td&gt;&lt;td&gt;#JOB#&lt;/td&gt;&lt;/tr&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100191812985304710)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de filas del informe en la vista de detalle. Utilice las cadenas de sustituci\00F3n <code>#COLUMN_NAME#</code> para los nombres de columnas y etiquetas de columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100191778578304709)
,p_name=>'PE.PROPERTY.DETAIL_VIEW_FOR_EACH_ROW.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Para Cada Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99851162677304408)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El soporte de cuadro de di\00E1logo en &PRODUCT_NAME. var\00EDa seg\00FAn la interfaz de usuario de la p\00E1gina.'),
unistr('Hay un subjuego de atributos de cuadro de di\00E1logo soportados de forma declarativa: <em>altura, ancho y ancho m\00E1ximo</em>.'),
unistr('Para definir cualquier atributo adicional para el cuadro de di\00E1logo, introduzca los pares nombre/valor en una lista separada por comas.</p>'),
unistr('<p>La cadena de sustituci\00F3n<code>#DIALOG_ATTRIBUTES#</code> del c\00F3digo de inicializaci\00F3n del cuadro de di\00E1logo definido en el nivel de plantilla de p\00E1gina se sustituye por cualquier valor introducido en este elemento.</p>'),
unistr('<p>Para las p\00E1ginas que utilizan la interfaz de usuario de escritorio, se utiliza el widget del cuadro de di\00E1logo de la interfaz de usuario de jQuery.'),
unistr('Para las p\00E1ginas que utilizan la interfaz de usuario de jQuery Mobile Smartphone, se utiliza el widget de cuadro de di\00E1logo de jQuery Mobile.</p>'),
unistr('<p>Por ejemplo, una p\00E1gina de cuadro de di\00E1logo que utiliza una interfaz de usuario de escritorio podr\00EDa tener definidos los siguientes atributos: <code>resizable:true, draggable:true</code></p>'),
unistr('<p>Para obtener m\00E1s informaci\00F3n sobre los atributos disponibles, consulte la <a rel="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">documentaci\00F3n del widget del cuadro de di\00E1logo de la interfaz de usuario de jQuery</a> y la <a rel')
||unistr('="noreferrer" target="_blank" href="http://api.jqueryui.com/dialog/">documentaci\00F3n del widget del cuadro de di\00E1logo de jQuery Mobile</a>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99851063056304408)
,p_name=>'PE.PROPERTY.DIALOG_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100541664475304971)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione <strong>Activado</strong> si este cuadro de di\00E1logo lo ha abierto otro y deber\00EDa hacerlo en la misma ventana.'),
unistr('Por ejemplo, en caso de que este cuadro de di\00E1logo sea parte de un asistente de cuadro de di\00E1logo de varias p\00E1ginas y desee utilizar la misma ventana de cuadro de di\00E1logo en todos los pasos del asistente.<p><p>'),
unistr('Seleccione <strong>Desactivado</strong> si el cuadro de di\00E1logo que ha abierto este cuadro de di\00E1logo deber\00EDa hacerlo en una ventana nueva. Por ejemplo, cuando este cuadro de di\00E1logo es modal,'),
'y se desea abrirlo dentro de una ventana modal principal.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100541585405304971)
,p_name=>'PE.PROPERTY.DIALOG_CHAINED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Encadenada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100252987832304756)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100252884423304756)
,p_name=>'PE.PROPERTY.DIALOG_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99941483147304480)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la altura del cuadro de di\00E1logo, en p\00EDxeles, por ejemplo <strong><em>500</em></strong>.'),
unistr('La cadena de sustituci\00F3n <code>#DIALOG_HEIGHT#</code> en el c\00F3digo de inicializaci\00F3n de cuadro de di\00E1logo de la plantilla de p\00E1gina se sustituye por el valor introducido.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99941376724304480)
,p_name=>'PE.PROPERTY.DIALOG_HEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99850995002304408)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca al ancho m\00E1ximo del cuadro de di\00E1logo en p\00EDxeles.'),
unistr('La cadena de sustituci\00F3n <code>#DIALOG_MAX_WIDTH#</code> del c\00F3digo de inicializaci\00F3n del cuadro de di\00E1logo de la plantilla de p\00E1gina se sustituye por el valor introducido en este elemento.</p>'),
unistr('<p>Para obtener una p\00E1gina mediante la interfaz de usuario de jQuery Mobile Smartphone, el ancho m\00E1ximo es <strong><em>500</em></strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99850890402304408)
,p_name=>'PE.PROPERTY.DIALOG_MAX_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ancho M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100232892215304740)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto de Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99986407288304514)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una plantilla de cuadro de di\00E1logo para definir la apariencia y el dise\00F1o de esta p\00E1gina.</p>'),
unistr('        <p>Las plantillas de cuadro de di\00E1logo se definen en el tema de la aplicaci\00F3n.'),
unistr('        Al crear una p\00E1gina de cuadro de di\00E1logo, la plantilla se define autom\00E1ticamente en el <em>tema por defecto</em> que presentar\00E1 la p\00E1gina mediante la plantilla de p\00E1gina por defecto definida en el tema actual.'),
unistr('        La selecci\00F3n realizada aqu\00ED sustituir\00E1 a la plantilla de cuadro de di\00E1logo por defecto definida.</p>'),
unistr('        <p>El tema universal proporciona las siguientes plantillas de cuadro de di\00E1logo:'),
'          <dl>',
unistr('            <dt>Cuadro de di\00E1logo modal</dt>'),
unistr('              <dd>Resulta \00FAtil para la mayor\00EDa de casos de uso de cuadros de di\00E1logo.</dd>'),
unistr('            <dt>Cuadro de di\00E1logo modal del asistente</dt>'),
unistr('              <dd>Proporciona una interfaz de usuario optimizada y es adecuado para los asistentes, las alertas, las notificaciones o las pantallas peque\00F1as del cuadro de di\00E1logo modal.</dd>'),
'          </dl>',
unistr('          Consulte tambi\00E9n: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de Ejemplo de Tema Universal</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99986368337304514)
,p_name=>'PE.PROPERTY.DIALOG_TEMPLATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de Cuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99850783390304408)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el ancho del cuadro de di\00E1logo, en p\00EDxeles o en porcentaje.'),
unistr('La cadena de sustituci\00F3n <code>#DIALOG_WIDTH#</code> del c\00F3digo de inicializaci\00F3n del cuadro de di\00E1logo de la plantilla de p\00E1gina se sustituye por el valor introducido en este elemento.</p>'),
unistr('<p>En una p\00E1gina que utiliza una interfaz de usuario de escritorio, el valor se define en p\00EDxeles, como <strong><em>500</em></strong>.'),
unistr('Sin embargo, en una p\00E1gina que utiliza la interfaz de usuario de jQuery Mobile Smartphone, el valor se define en porcentaje, como <strong><em>80%</em></strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99850670245304408)
,p_name=>'PE.PROPERTY.DIALOG_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ancho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100168773297304692)
,p_name=>'PE.PROPERTY.DIRECTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la direcci\00F3n del par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100168832110304692)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN.D'
,p_message_language=>'es'
,p_message_text=>'Entrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100169015150304692)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.IN_OUT.D'
,p_message_language=>'es'
,p_message_text=>'Entrada/Salida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100168952044304692)
,p_name=>'PE.PROPERTY.DIRECTION.LOV.OUT.D'
,p_message_language=>'es'
,p_message_text=>'Salida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100168618903304692)
,p_name=>'PE.PROPERTY.DIRECTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Sentido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100214823928304726)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si el usuario final puede utilizar esta columna para ordenar el informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100214711270304726)
,p_name=>'PE.PROPERTY.DISABLE_SORT_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Se Puede Ordenar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100246493513304751)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la \00FAnica columna que se muestra en las celdas del calendario.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100246345751304751)
,p_name=>'PE.PROPERTY.DISPLAY_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99862197506304417)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Un elemento puede tener un valor de estado de sesi\00F3n que no se produzca en la definici\00F3n de lista de valores especificada.'),
unistr('Seleccione si desea que esta lista de valores muestre este valor de estado de sesi\00F3n adicional.'),
unistr('Si selecciona no visualizar este valor de estado de sesi\00F3n adicional y no hay ning\00FAn valor coincidente en la definici\00F3n de lista de valores, el primer valor de la lista de valores ser\00E1 el seleccionado y el que se muestra.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99862032832304417)
,p_name=>'PE.PROPERTY.DISPLAY_EXTRA_VALUES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar Valores Adicionales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99862332992304417)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si desea que la lista de valores utilizada para este elemento muestre un valor NULL al comienzo de la lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99862228243304417)
,p_name=>'PE.PROPERTY.DISPLAY_NULL_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar Valor Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99904904999304451)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la posici\00F3n que se utiliza para mostrar este componente. Las posiciones derivan de los puntos de visualizaci\00F3n de la plantilla de la p\00E1gina o de la regi\00F3n correspondiente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99904855366304451)
,p_name=>'PE.PROPERTY.DISPLAY_POINT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100560061921304985)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.CARD_ACTION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la secuencia de visualizaci\00F3n de esta acci\00F3n.'),
unistr('Esto se usa para evaluar la condici\00F3n de visualizaci\00F3n y representarla en el orden definido.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100091750726304595)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la secuencia de visualizaci\00F3n para esta columna. El valor de la secuencia determina d\00F3nde aparecer\00E1 esta columna en relaci\00F3n con otras columnas de la regi\00F3n.</p>'),
unistr('<p>Nota: si hay dos columnas en la misma regi\00F3n que tienen el mismo valor de secuencia, deber\00E1n mostrarse en un orden diferente cuando la aplicaci\00F3n se exporte e importe a otros entornos, como el de prueba o de producci\00F3n. Para asegurar consistencia,')
||unistr(' Oracle recomienda que especifique unos n\00FAmeros de secuencia \00FAnicos para cada elemento o, al menos, para aqu\00E9llos que se encuentran en la misma regi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100183725166304703)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la secuencia de visualizaci\00F3n para este grupo de columnas. La secuencia determina el orden en que se muestran los grupos de columnas en la vista de detalles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100517560827304954)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la secuencia de visualizaci\00F3n para esta capa. El valor de la secuencia determina el orden en que se muestran las capas de mapa una encima de otra. Las capas con n\00FAmeros superiores se muestran sobre las capas con n\00FAmeros inferiores.</p>'),
unistr('<p>Nota: Si dos capas de mapa tienen el mismo valor de secuencia, se pueden mostrar en un orden diferente cuando la aplicaci\00F3n se exporte e importe a otros entornos, como el de prueba o de producci\00F3n.'),
unistr('Para asegurar la consistencia, Oracle recomienda que especifique unos n\00FAmeros de secuencia \00FAnicos para cada capa o, al menos, para aqu\00E9llos que se encuentran en la misma regi\00F3n de mapa.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99880594317304432)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la secuencia de visualizaci\00F3n para este elemento. La secuencia y otra configuraci\00F3n de dise\00F1o determina d\00F3nde se muestra este elemento en relaci\00F3n con otros elementos de la regi\00F3n.</p>'),
unistr('<p>Nota: Si hay dos elementos en la misma regi\00F3n que tienen el mismo valor de secuencia, deber\00E1n mostrarse en un orden diferente cuando la aplicaci\00F3n se exporte e importe a otros entornos, como el de prueba o de producci\00F3n. Para asegurar la coherenci')
||unistr('a, Oracle recomienda que especifique unos n\00FAmeros de secuencia \00FAnicos para cada elemento o, al menos, para aqu\00E9llos que se encuentran en la misma regi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99880458300304432)
,p_name=>'PE.PROPERTY.DISPLAY_SEQUENCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100701677436305095)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un esquema de autorizaci\00F3n para restringir los usuarios que puedan realizar descargas.'),
unistr('		Para permitir que un usuario final realice una descarga, este esquema de autorizaci\00F3n se debe evaluar en TRUE para dicho usuario.</p>'),
unistr('		<p>Nota: Si no se proporciona ning\00FAn esquema de autorizaci\00F3n, cualquier usuario puede realizar descargas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100701508964305095)
,p_name=>'PE.PROPERTY.DOWNLOAD_AUTH_SCHEME.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100224246677304733)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.CLASSIC_REPORT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique un nombre para el archivo de descarga de CSV. Si no se especifica ning\00FAn nombre, se utiliza el nombre de regi\00F3n seguido de la extensi\00F3n .csv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100235338440304742)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.COMPONENT_PROPERTY.TABULAR_FORM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique un nombre para el archivo de descarga de CSV. Si no se especifica ning\00FAn nombre, se utiliza el nombre de regi\00F3n seguido de la extensi\00F3n .csv.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100219342578304729)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de archivo del documento cuando se descargue. No especifique la extensi\00F3n de archivo. La extensi\00F3n se agrega autom\00E1ticamente. Si deja este atributo en blanco, se utiliza el nombre de regi\00F3n como nombre de archivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100219257234304729)
,p_name=>'PE.PROPERTY.DOWNLOAD_FILENAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100186626770304706)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Compruebe qu\00E9 formatos de descarga pueden utilizar los usuarios para descargar las columnas mostradas actualmente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100387003901304856)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'es'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100387154205304856)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'es'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100387208586304856)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'es'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100461924716304912)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'es'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100186572289304705)
,p_name=>'PE.PROPERTY.DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formatos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100222119597304732)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto para el enlace que llamar\00E1 a la descarga CSV.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100222095074304731)
,p_name=>'PE.PROPERTY.DOWNLOAD_LINK_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100218539086304729)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que se va a utilizar para el enlace de descarga en la p\00E1gina. Los usuarios finales utilizan este enlace para descargar el contenido BLOB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100218445002304729)
,p_name=>'PE.PROPERTY.DOWNLOAD_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto de Descarga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100249990316304754)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione un esquema de autorizaci\00F3n para limitar qui\00E9n tiene derechos para actualizar los eventos de calendario existentes utilizando la funci\00F3n de arrastrar y soltar.'),
unistr('Si se especifica, este esquema de autorizaci\00F3n se debe evaluar en TRUE para que se procese la funci\00F3n de arrastrar y soltar.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100249872504304754)
,p_name=>'PE.PROPERTY.DRAG_AND_DROP_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100408576088304874)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Proceso personalizado</dt>',
'<dd><pre>',
'declare',
'    l_date_value        varchar2(32767) := apex_application.g_x01;',
'    l_primary_key_value varchar2(32767) := apex_application.g_x02;',
'begin',
'    update emp',
'       set hiredate = to_date(l_date_value, ''YYYYMMDD HH24MISS'')',
'     where rowid    = l_primary_key_value;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100249797101304754)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.HELP'
,p_message_language=>'es'
,p_message_text=>'Defina el proceso que se va a ejecutar cuando se arrastre y suelte una entrada del calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100249683787304753)
,p_name=>'PE.PROPERTY.DRAG_DROP_PROCESS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Proceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100090696759304594)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si la columna se debe definir por defecto en el valor de columna existente al duplicar el registro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100090567321304594)
,p_name=>'PE.PROPERTY.DUPLICATE_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor Existente para Copias Duplicadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99888573591304438)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Compruebe las operaciones de lenguaje de manipulaci\00F3n de datos (DML) que est\00E1n soportadas. Este proceso realizar\00E1 operaciones DML a partir del atributo <strong>Acci\00F3n de base de datos</strong> del bot\00F3n para enviar la p\00E1gina. Si no se define ese a')
||unistr('tributo, la operaci\00F3n ser\00E1 determinada por el bot\00F3n Valores de solicitud, que se define seg\00FAn el nombre del bot\00F3n de la siguiente forma:</p>'),
'<ul>',
'<li><strong>Agregar fila</strong> se activa por los valores de solicitud: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN</li>',
'<li><strong>Actualizar fila</strong> se activa por los valores de solicitud: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%</li>',
'<li><strong>Suprimir fila</strong> se activa por los valores de solicitud: DELETE, REMOVE, DELETE ROW, DROP</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100074910283304582)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Compruebe qu\00E9 operaciones de manipulaci\00F3n de datos se permiten en esta cuadr\00EDcula interactiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100075208583304582)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.D.D'
,p_message_language=>'es'
,p_message_text=>'Suprimir Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100075092676304582)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.I.D'
,p_message_language=>'es'
,p_message_text=>'Agregar Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100075105578304582)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.LOV.U.D'
,p_message_language=>'es'
,p_message_text=>'Actualizar Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100074805121304581)
,p_name=>'PE.PROPERTY.EDIT_OPERATIONS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Operaciones Permitidas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100075488255304582)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione una columna en la que el valor de columna indica si la fila se puede actualizar y/o suprimir. Los valores permitidos son:',
'        <dl>',
'          <dt>U</dt>',
'            <dd>Se puede actualizar la fila</dd>',
'          <dt>D</dt>',
'            <dd>Se puede suprimir la fila</dd>',
'          <dt>UD</dt>',
'            <dd>Se puede actualizar o suprimir la fila</dd>',
'        </dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100075371302304582)
,p_name=>'PE.PROPERTY.EDIT_ROW_OPERATIONS_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Operaciones de Filas Permitidas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99867135863304421)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la alineaci\00F3n del elemento dentro de la celda de tabla HTML alrededor de \00E9ste.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100370715266304843)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'es'
,p_message_text=>'Centro inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100370894890304844)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'es'
,p_message_text=>'Centro centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100370941920304844)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'es'
,p_message_text=>'Centro superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100370698255304843)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'es'
,p_message_text=>'Centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100371198848304844)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'es'
,p_message_text=>'Izquierda inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100371269888304844)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'es'
,p_message_text=>'Izquierda centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100371329912304844)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'es'
,p_message_text=>'Izquierda superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100371073286304844)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'es'
,p_message_text=>'Izquierda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100371561956304844)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'es'
,p_message_text=>'Derecha inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100371678319304844)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'es'
,p_message_text=>'Derecha centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100371739173304844)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'es'
,p_message_text=>'Derecha superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100371452569304844)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'es'
,p_message_text=>'Derecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99863024985304417)
,p_name=>'PE.PROPERTY.ELEMENT_FIELD_ALIGNMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Alineaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99867732480304421)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la altura (n\00FAmero aproximado de filas) para \00E1reas de texto, selectores, listas de selecci\00F3n m\00FAltiple y cualquier tipo de elemento de plugin que soporte el atributo Tiene Atributo de Altura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99867692458304421)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100253216175304756)
,p_name=>'PE.PROPERTY.ELEMENT_HEIGHT.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('l\00EDneas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99867599086304421)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero m\00E1ximo de caracteres que los usuarios pueden introducir en este elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99867471324304421)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Longitud M\00E1xima')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100253323561304756)
,p_name=>'PE.PROPERTY.ELEMENT_MAX_CHARACTERS.UNIT'
,p_message_language=>'es'
,p_message_text=>'caracteres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99868153384304421)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca atributos adicionales delimitados por espacios para la celda de tabla HTML que se utiliza para mostrar cada opci\00F3n individual en un grupo de botones de radio o juego de casillas de control.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99868059632304421)
,p_name=>'PE.PROPERTY.ELEMENT_OPTION_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Atributos HTML de Opci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99868598858304422)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca los atributos adicionales que se van a mostrar despu\00E9s de que la celda de tabla HTML que muestra cada una de las opciones de un grupo de botones de radio o de un juego de casillas de control.'),
'Puede incluir HTML, JavaScript y accesos directos.</p>',
unistr('<p>Puede hacer referencia a las siguientes cadenas de sustituci\00F3n:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Obtiene el nombre del elemento de pantalla HTML al que este elemento de p\00E1gina est\00E1 asociado.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Obtiene el nombre del elemento de p\00E1gina actual.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99868470339304422)
,p_name=>'PE.PROPERTY.ELEMENT_POST_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Posterior a Texto '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99868386768304422)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca los atributos adicionales mostrados antes de la celda de tabla HTML que muestra cada una de las opciones de un grupo de botones de radio o de un juego de casillas de control.',
'Puede incluir HTML, JavaScript y accesos directos.</p>',
unistr('<p>Puede hacer referencia a las siguientes cadenas de sustituci\00F3n:</p>'),
'<dl>',
'  <dt><code>#CURRENT_FORM_ELEMENT#</code></dt>',
unistr('  <dd>Obtiene el nombre del elemento de pantalla HTML al que este elemento de p\00E1gina est\00E1 asociado.</dd>'),
'  <dt><code>#CURRENT_ITEM_NAME#</code></dt>',
unistr('  <dd>Obtiene el nombre del elemento de p\00E1gina actual.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99868295338304421)
,p_name=>'PE.PROPERTY.ELEMENT_PRE_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Anterior a Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99867943419304421)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el texto de indicaci\00F3n que se muestra en este elemento cuando no se introduzca ning\00FAn valor para dicho elemento. Cuando se haya introducido el texto en el elemento, la indicaci\00F3n se elimina.</p>'),
unistr('<p>Este atributo de marcador de posici\00F3n especifica una breve indicaci\00F3n que puede utilizarse para describir el valor esperado de un elemento de p\00E1gina.'),
unistr('Dichas indicaciones resultan \00FAtiles para proporcionar una valor de ejemplo o un ejemplo del formato esperado, o bien unas instrucciones como: buscar en t\00EDtulo, descripci\00F3n y etiqueta.'),
'Por razones de acceso, este atributo no debe utilizarse como alternativa a una etiqueta significativa, bien definida.</p>',
unistr('<p><strong>Atenci\00F3n:</strong> esta caracter\00EDstica HTML5 solo funciona en exploradores actualizados. Los exploradores antiguos no muestran el texto introducido en este atributo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99867896206304421)
,p_name=>'PE.PROPERTY.ELEMENT_VALUE_PLACEHOLDER.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Marcador de Posici\00F3n de Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99867383060304421)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el ancho del elemento de pantalla que se va a utilizar para mostrar este elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99867223577304421)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ancho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100253189418304756)
,p_name=>'PE.PROPERTY.ELEMENT_WIDTH.UNIT'
,p_message_language=>'es'
,p_message_text=>'caracteres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100388137720304856)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@abc.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100189418354304708)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una direcci\00F3n de correo electr\00F3nico v\00E1lida para utilizarla como direcci\00F3n de <em>origen</em> al enviar correo electr\00F3nico desde este informe. Se env\00EDan correos electr\00F3nico desde este informe para descargas del tipo Correo Electr\00F3nico y ')
||'Suscripciones.</p>',
unistr('<p>El valor puede ser una cadena literal que contenga una direcci\00F3n de correo electr\00F3nico v\00E1lida o una referencia de sustituci\00F3n est\00E1tica definida en la aplicaci\00F3n que utiliza la sintaxis de sustituci\00F3n.'),
unistr('NO se recomienda utilizar una sustituci\00F3n de elemento de aplicaci\00F3n o p\00E1gina porque solo funciona en la descarga de correo electr\00F3nico y provoca el fallo de cualquier correo electr\00F3nico de sustituci\00F3n ya que no se puede acceder a estos elementos desd')
||unistr('e fuera de una sesi\00F3n v\00E1lida.'),
unistr('Las suscripciones se env\00EDan desde el motor de &PRODUCT_NAME. y no desde una sesi\00F3n de usuario.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100189322173304708)
,p_name=>'PE.PROPERTY.EMAIL_FROM_ADDRESS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n de Origen de Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100101041093304602)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique si los usuarios finales pueden usar esta columna en divisiones de control y agregados.</p>',
unistr('        <p>Nota: Permitir el uso de estas operaciones puede provocar a problemas de rendimiento, especialmente en grandes juegos de datos o si los \00EDndices de columna apropiados no est\00E1n disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100100902161304602)
,p_name=>'PE.PROPERTY.ENABLE_CONTROL_BREAK.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Divisi\00F3n de control/agregado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100079489440304585)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden descargar el informe en uno de los formatos de descarga especificados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100079367050304585)
,p_name=>'PE.PROPERTY.ENABLE_DOWNLOAD.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Descargar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100083587830304588)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden filtrar o no esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100083455557304588)
,p_name=>'PE.PROPERTY.ENABLE_FILTER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100100221033304601)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si los usuarios finales pueden utilizar consultas de flashback para esta cuadr\00EDcula interactiva.</p>'),
unistr('<p>En las consultas de flashback, se utiliza Oracle Flashback Technology y la recuperaci\00F3n hasta un punto en el tiempo de la base de datos para ver datos que exist\00EDan en un punto del tiempo pasado. Los usuarios solo pueden consultar estos datos, no d')
||unistr('eshacer ning\00FAn cambio. El punto en el tiempo hasta el que se puede realizar una consulta de flashback lo determina la \00FAltima vez que se cambiaron los archivos redo log en la base de datos de Oracle, ya que esta tecnolog\00EDa utiliza la copia de segurida')
||'d RMAN.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100100150476304601)
,p_name=>'PE.PROPERTY.ENABLE_FLASHBACK.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100100853379304602)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden ocultar o no esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100100781910304602)
,p_name=>'PE.PROPERTY.ENABLE_HIDE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100080022437304586)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><p>Especifique si desea que los usuarios finales puedan enviar un correo electr\00F3nico, con la descarga del informe incluida como un anexo.</p>'),
unistr('<p>El correo electr\00F3nico solo est\00E1 disponible para usuarios autenticados y requiere que un administrador de instancias configure SMTP en la aplicaci\00F3n Servicios de administraci\00F3n de &PRODUCT_NAME..</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100079953231304586)
,p_name=>'PE.PROPERTY.ENABLE_MAIL_DOWNLOAD.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar como Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100329024697304813)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione si desea activar la impresi\00F3n del informe. Si selecciona <strong>Activado</strong>, los usuarios podr\00E1n descargar un informe en diferentes formatos, incluidos PDF, Microsoft Word, Microsoft Excel y HTML. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100328952636304813)
,p_name=>'PE.PROPERTY.ENABLE_PRINTING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100078804123304585)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea que los usuarios finales puedan guardar su definici\00F3n de informe actual como un informe <em>P\00FAblico</em>.</p>'),
unistr('		<p>Los informes p\00FAblicos se muestran en una lista de selecci\00F3n de informes disponibles en la barra de herramientas y se muestran a todo el mundo.'),
unistr('		<p>Nota: Esta opci\00F3n solo est\00E1 disponible para los usuarios autenticados y se restringe a\00FAn m\00E1s si tambi\00E9n rellena el campo <strong>Guardar Autorizaci\00F3n de Informe P\00FAblico</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100078721649304585)
,p_name=>'PE.PROPERTY.ENABLE_SAVE_PUBLIC_REPORT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Guardar Informe P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100088694086304592)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique si los usuarios finales pueden usar esta columna en ordenaciones.</p>',
unistr('        <p>Nota: Permitir el uso de la operaci\00F3n de ordenaci\00F3n puede provocar problemas de rendimiento, especialmente en grandes juegos de datos o si los \00EDndices de columna apropiados no est\00E1n disponibles.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100088550160304592)
,p_name=>'PE.PROPERTY.ENABLE_SORT_GROUP.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ordenar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100079217508304585)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si los usuarios finales pueden definir la configuraci\00F3n de suscripci\00F3n para este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100079148576304585)
,p_name=>'PE.PROPERTY.ENABLE_SUBSCRIPTIONS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Suscripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99875928435304428)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea cifrar este elemento cuando se almacene en un estado de la sesi\00F3n.'),
unistr('Si el contenido de un elemento incluye datos confidenciales, debe cifrar el valor cuando se almacene en las tablas de gesti\00F3n de estado de la sesi\00F3n de &PRODUCT_NAME..'),
unistr('De lo contrario, cualquier usuario con derechos para leer tablas de metadatos de &PRODUCT_NAME. podr\00EDa escribir una consulta para extraer estos datos confidenciales.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99875854270304427)
,p_name=>'PE.PROPERTY.ENCRYPT_SESSION_STATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Almacenar Valor Cifrado en Estado de Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100247436521304752)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el \00FAltimo d\00EDa de la semana que se muestra en el calendario semanal.'),
unistr('Puede utilizar este atributo en conjunci\00F3n con <strong>D\00EDa de Inicio</strong> para limitar los d\00EDas de la semana que se muestran, o seleccionar el d\00EDa anterior al valor <strong>D\00EDa de Inicio</strong> para mostrar los siete d\00EDas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100406743636304873)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'es'
,p_message_text=>'Domingo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100406843408304873)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'es'
,p_message_text=>'Lunes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100406968135304873)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'es'
,p_message_text=>'Martes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100407099845304873)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'es'
,p_message_text=>unistr('Mi\00E9rcoles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100407173071304873)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'es'
,p_message_text=>'Jueves'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100407224544304873)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'es'
,p_message_text=>'Viernes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100407316087304873)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'es'
,p_message_text=>unistr('S\00E1bado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100247367800304752)
,p_name=>'PE.PROPERTY.END_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('D\00EDa de Finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100248020055304752)
,p_name=>'PE.PROPERTY.END_TIME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la hora de finalizaci\00F3n para centrar la visualizaci\00F3n del calendario semanal y diario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100247921551304752)
,p_name=>'PE.PROPERTY.END_TIME.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Hora de Finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100249382723304753)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic en el destino para llamar a un cuadro de di\00E1logo modal. Puede introducir el enlace de destino al que llama el calendario para ver los detalles de un evento existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100249264268304753)
,p_name=>'PE.PROPERTY.ENTRY_LINK_TARGET.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Destino de Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99849512016304407)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la funci\00F3n PL/SQL que se llama cuando se produzca un error en la aplicaci\00F3n.'),
unistr('Puede utilizar esta funci\00F3n para actuar sobre varios c\00F3digos de error, incluidos aquellos que se derivan de la base de datos Oracle y registrar dichos errores en una tabla personalizada que defina si es necesario.'),
unistr('La funci\00F3n puede incluir la l\00F3gica para modificar el mensaje de error y mostrar la ubicaci\00F3n, a fin de transformar los errores de la base de datos Oracle en mensajes f\00E1ciles de recordar.'),
unistr('Por ejemplo, puede capturar una violaci\00F3n de clave \00FAnica en <code>DEMO_CUSTOMERS</code> y sustituir el mensaje <code>ORA-00001</code> por este texto: El nombre de cliente debe ser \00FAnico.'),
unistr('Al instalar la aplicaci\00F3n de base de datos de ejemplo, desde Aplicaciones Empaquetadas, se crea el paquete <code>SAMPLE_PKG</code>, que incluye la funci\00F3n <code>demo_error_handling</code>.'),
unistr('Esta funci\00F3n de manejo de errores de ejemplo incluye una gran cantidad de comentarios que facilitan al usuario su utilizaci\00F3n como base para definir su propia funci\00F3n.</p>'),
unistr('<p>El nombre de funci\00F3n introducido puede hacer referencia a una funci\00F3n de paquete o a una funci\00F3n aut\00F3noma en la base de datos. Por ejemplo:'),
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
unistr('<p>Cuando hace referencia a una funci\00F3n aut\00F3noma o de paquete PL/SQL de base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo:'),
'<pre>#OWNER#.log_apex_error</pre>',
'</p>',
unistr('<p>Si se ha especificado una funci\00F3n de manejo de errores en una p\00E1gina, entonces se utilizar\00E1 \00E9sta, en lugar del valor de nivel de aplicaci\00F3n para esa p\00E1gina.</p>'),
'<p>Las funciones de manejo de errores deben implantar la siguiente interfaz:',
'<pre>',
unistr('funci\00F3n &lt;nombre de funci\00F3n> ('),
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
unistr('<p>Consulte el manual de referencia de API para obtener una descripci\00F3n del paquete <code>apex_error</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99859183508304414)
,p_name=>'PE.PROPERTY.ERROR_HANDLING_FUNCTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n de Manejo de Errores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100565739568304989)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.APP_COMPUTATION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un mensaje de error que se muestre cuando falla el c\00E1lculo.'),
unistr('    Utilice <code>#SQLERRM#</code> como una cadena de sustituci\00F3n para el mensaje de error SQL que se obtiene de un c\00E1lculo err\00F3neo.</p>'),
unistr('    <p>Los c\00E1lculos est\00E1n concebidos para que siempre sean correctos y solo fallen debido a errores no anticipados.'),
unistr('    No es aconsejable implantar un c\00E1lculo que falle con frecuencia y se comporte como una pseudovalidaci\00F3n con este mensaje de error.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99887337178304437)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_COMPUTATION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un mensaje de error que se muestre cuando falla el c\00E1lculo.'),
unistr('    Utilice <code>#SQLERRM#</code> como una cadena de sustituci\00F3n para el mensaje de error SQL que se obtiene de un c\00E1lculo err\00F3neo.</p>'),
unistr('    <p>Los c\00E1lculos est\00E1n concebidos para que siempre sean correctos y solo fallen debido a errores no anticipados.'),
unistr('    No es aconsejable implantar un c\00E1lculo que falle con frecuencia y se comporte como una pseudovalidaci\00F3n con este mensaje de error.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100200983780304716)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el mensaje de error de este proceso.',
unistr('Este mensaje aparece si se emite una excepci\00F3n no tratada. Cuando se para cualquier procesamiento de error, se emite un rollback y aparece un mensaje de error.</p>'),
unistr('<p>Nota: el mensaje de error SQL (sqlerrm) aparece por defecto si se define <strong>En P\00E1gina de Error</strong> como ubicaci\00F3n de visualizaci\00F3n del error, ya que no es necesario agregar <code>#SQLERRM#</code> al texto del error.</p>'),
unistr('<p>Los mensajes de error pueden incluir las siguientes cadenas de sustituci\00F3n:</p>'),
'<dl>',
'  <dt><code>#SQLERRM_TEXT#</code></dt>',
unistr('  <dd>Texto del mensaje de error sin el n\00FAmero de error.</dd>'),
'  <dt><code>#SQLERRM#</code></dt>',
'  <dd>Mensaje de error completo.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100760191999305138)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe tener alg\00FAn valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99847917021304405)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el texto que se va a mostrar en caso de que no pase la validaci\00F3n.</p>'),
unistr('<p>Puede utilizar <code>#LABEL#</code> como marcador de posici\00F3n de la etiqueta del elemento de p\00E1gina asociado o <code>#COLUMN_HEADER#</code> para la cabecera de la columna de la regi\00F3n editable asociada. No se soportan los marcadores de posici\00F3n si')
||unistr(' la ubicaci\00F3n de visualizaci\00F3n del error est\00E1 definida en En P\00E1gina de Error.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99847880865304405)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mensaje de Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99959362199304494)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione cu\00E1ndo mostrar el mensaje de error para esta validaci\00F3n.'),
unistr('Los mensajes de error de validaci\00F3n se muestran en una p\00E1gina de error independiente o en l\00EDnea con la p\00E1gina existente.'),
unistr('Los mensajes de error en l\00EDnea se muestran bajo la etiqueta <em>Elemento Asociado</em> y/o en un \00E1rea de notificaci\00F3n, definida como parte de la plantilla de p\00E1gina.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100379931339304850)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea en Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100379868871304850)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD.D'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea con Campo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100379791970304850)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.INLINE_WITH_FIELD_AND_NOTIFICATION.D'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea con Campo y en Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100380094860304850)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('En P\00E1gina de Error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99959237873304494)
,p_name=>'PE.PROPERTY.ERROR_MESSAGE_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ubicaci\00F3n de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99876159120304428)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Para evitar ataques de XSS (Scripts de Sitios), este atributo se deber definir siempre en <strong>Activado</strong>.',
unistr('Si necesita presentar etiquetas HTML almacenadas en el elemento de p\00E1gina o en las entradas de una lista de valores, puede definir este indicador en <strong>Desactivado</strong>.'),
'En tal caso, debe tomar precauciones adicionales para asegurarse de que cualquier entrada de usuario que se haga en dichos campos sea omitida correctamente en el momento de la entrada y antes de guardar.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99876012653304428)
,p_name=>'PE.PROPERTY.ESCAPE_SPECIAL_CHARACTERS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Caracteres especiales de escape'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99848139102304405)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los esquemas de autorizaci\00F3n se eval\00FAan en el primer uso de una sesi\00F3n.'),
unistr('Seleccione el punto de evaluaci\00F3n adecuado para determinar si el posterior uso de la autorizaci\00F3n especificada obtiene el resultado de la memoria o vuelve a evaluar el esquema de autorizaci\00F3n.</p>'),
'#LOV_VALUES#',
unistr('<p>El valor por defecto <em>Una vez por sesi\00F3n</em> es el m\00E1s eficaz.'),
unistr('Debe seleccionar otro valor si la comprobaci\00F3n de autorizaci\00F3n depende del cambio del estado de sesi\00F3n o de otros factores que no son consistentes en una sesi\00F3n completa.'),
unistr('Las opciones <em>Una vez por componente</em> y <em>Siempre (sin almacenamiento en cach\00E9)</em> proporcionan unos par\00E1metros adicionales que pueden definirse para que los utilice el esquema de autorizaci\00F3n.'),
unistr('En los plugins de autorizaci\00F3n, puede utilizar los atributos <em>component.type</em>, <em>component.id</em> y <em>component.name</em> del par\00E1metro <em>t_authorization</em>.'),
unistr('Para los tipos de esquema incorporados <em>Consulta SQL Exists</em> y <em>Cuerpo de la funci\00F3n</em> est\00E1n disponibles las variables de enlace equivalentes <em>:APP_COMPONENT_TYPE</em>, <em>:APP_COMPONENT_ID</em> y <em>:APP_COMPONENT_NAME</em>.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100356324131304833)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.D'
,p_message_language=>'es'
,p_message_text=>'Una Vez por Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100356419217304833)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_COMPONENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Se eval\00FAa una vez por cada componente que hace referencia al esquema de autorizaci\00F3n, pero guarda el resultado en la sesi\00F3n. Otras solicitudes para presentar o procesar el esquema utilizan el resultado en memoria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100356139757304833)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.D'
,p_message_language=>'es'
,p_message_text=>unistr('Una Vez por Vista de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100356229296304833)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_PAGE_VIEW.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Se eval\00FAa una vez por cada una de las solicitudes que se procesan. Utiliza el resultado en la memoria si se hace referencia al esquema de autorizaci\00F3n en m\00E1s de un componente de la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100355976230304833)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Una Vez por Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100356080322304833)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.BY_USER_BY_SESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Se eval\00FAa solo una vez y, a continuaci\00F3n, utiliza el resultado en la memoria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100356574358304833)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Siempre (Sin Almacenamiento en Cach\00E9)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100356697054304833)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.LOV.NOCACHE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema de autorizaci\00F3n siempre se eval\00FAa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99848062073304405)
,p_name=>'PE.PROPERTY.EVALUATION_POINT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Punto de Evaluaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99853155259304410)
,p_name=>'PE.PROPERTY.EVENT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el evento que provoca que se dispare la acci\00F3n din\00E1mica.'),
unistr('Para obtener m\00E1s informaci\00F3n sobre eventos espec\00EDficos, consulte la secci\00F3n pertinente de <em>Application Builder User''s Guide</em>.</p>'),
'Los eventos se clasifican de la siguiente forma:',
'<dl>',
'  <dt>Eventos de Explorador</dt>',
unistr('    <dd>Eventos de explorador est\00E1ndar.</dd>'),
'  <dt>Eventos de Marco</dt>',
'    <dd>Los eventos de marco se disparan desde el marco de Application Express.</dd>',
'  <dt>Eventos de Componente</b>',
unistr('    <dd>Solo disponibles cuando hay un componente disponible para la aplicaci\00F3n que dispara un evento personalizado. Estos eventos se disparan desde componentes nativos o de plugin que ha instalado en la aplicaci\00F3n.</dd>'),
'  <dt>Evento Personalizado</dt>',
unistr('    <dd>Cualquier evento personalizado que se ha disparado desde la aplicaci\00F3n.</dd>'),
'</dl>',
unistr('<p>Nota: Los eventos mostrados ser\00E1n diferentes seg\00FAn el tipo de interfaz de usuario actual de la p\00E1gina.'),
unistr('Si desea seleccionar un evento que se corresponda con un tipo diferente, tendr\00E1 la opci\00F3n de seleccionar <strong>Mostrar No Soportado</strong>,'),
unistr('que mostrar\00E1 todos los eventos, incluidos los que no se corresponden con el tipo actual.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99853065128304409)
,p_name=>'PE.PROPERTY.EVENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99877331644304429)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el \00E1mbito del evento, que determina las veces que dicho evento se va a evaluar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100366966398304841)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.D'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100367020832304841)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.BIND.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Enlaza el manejador de eventos con los elementos disparadores durante la vida \00FAtil de la p\00E1gina actual, pero deja de estar enlazada si se actualizan los elementos disparadores mediante el Refrescamiento de P\00E1gina Parcial (PPR).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100367182530304841)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Din\00E1mico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100367292551304841)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.LIVE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Enlaza el manejador de eventos con los elementos disparadores durante la vida \00FAtil de la p\00E1gina actual, independientemente de que se creen los elementos disparadores mediante el Refrescamiento de P\00E1gina Parcial (PPR).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100367358331304841)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.D'
,p_message_language=>'es'
,p_message_text=>'Una Vez'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100367437750304841)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.LOV.ONE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Enlaza el manejador de eventos con los elementos disparadores solo una vez. La acci\00F3n din\00E1mica no se dispara de nuevo hasta que la p\00E1gina no se haya refrescado por completo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99877277873304429)
,p_name=>'PE.PROPERTY.EVENT_SCOPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1mbito de Evento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100684845784305082)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea excluir este t\00EDtulo de la traducci\00F3n. Este atributo no se aplicar\00E1, excepto si se traduce la aplicaci\00F3n a otro idioma.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100684730021305082)
,p_name=>'PE.PROPERTY.EXCLUDE_TITLE_FROM_TRANSLATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Excluir T\00EDtulo de Traducci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100518045024304954)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione cu\00E1ntas veces se ejecutar\00E1 esta condici\00F3n de capa.'),
unistr('Si se hace referencia a <em>Columnas</em> en la condici\00F3n, debe especificar <strong>Para cada fila</strong> para que la condici\00F3n se eval\00FAe para cada fila de la consulta de capa.'),
unistr('De lo contrario, def\00EDnala en <strong>Una vez</strong> para evaluar las validaciones una vez para la regi\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99960171144304494)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione cu\00E1ntas veces se ejecutar\00E1 esta validaci\00F3n de regi\00F3n editable.'),
unistr('Si se hace referencia a <em>Columnas</em> en la condici\00F3n, debe especificar <strong>Para Cada Fila</strong> para que la condici\00F3n se eval\00FAe para cada fila de la regi\00F3n editable.'),
unistr('De lo contrario, def\00EDnala en <strong>Una Vez</strong> para evaluar las validaciones una vez para la regi\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100380434160304851)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Una Vez'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100380345080304851)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>'Para Cada Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99960020255304494)
,p_name=>'PE.PROPERTY.EXECUTE_CONDITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100090895057304594)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione cu\00E1ndo ejecutar la condici\00F3n de solo lectura.</p>'),
unistr('        <p>Si se hace referencia a <em>Columnas</em> en la condici\00F3n de solo lectura, debe especificar <strong>Para Cada Fila</strong> para que la condici\00F3n se eval\00FAe para cada fila de la cuadr\00EDcula interactiva.'),
unistr('		De lo contrario, def\00EDnala en <strong>Una Vez</strong> para evaluar la condici\00F3n una vez para la regi\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100091090617304594)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Una Vez'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100206821357304720)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.N.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Eval\00FAe la condici\00F3n de solo lectura una sola vez para toda la regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100090939528304594)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>'Para Cada Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100206725921304720)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.LOV.Y.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Eval\00FAe la condici\00F3n de solo lectura de forma independiente para cada fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100090776961304594)
,p_name=>'PE.PROPERTY.EXECUTE_READONLY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99959948745304494)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el \00E1mbito de ejecuci\00F3n de esta validaci\00F3n de regi\00F3n editable.'),
unistr('Seleccione <strong>Para Filas Creadas y Modificadas</strong> si desea que esta validaci\00F3n se eval\00FAe para filas nuevas y actualizadas en la regi\00F3n editable.'),
unistr('Si desea que la validaci\00F3n se eval\00FAe para cada fila ejecutada, seleccione <strong>Todas las Filas Ejecutadas</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100380279318304851)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Todas las Filas Enviadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100380128445304851)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>'Para Filas Creadas y Modificadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99959850551304494)
,p_name=>'PE.PROPERTY.EXECUTION_SCOPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1mbito de Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99852734946304409)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique la secuencia para este componente. La secuencia determina el orden de ejecuci\00F3n.</p>'),
unistr('<p>Nota: si hay dos componentes con el mismo valor de secuencia, tendr\00E1n que ejecutarse en un orden diferente cuando la aplicaci\00F3n se exporte e importe a otro entorno.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99852606834304409)
,p_name=>'PE.PROPERTY.EXECUTION_SEQUENCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100676356302305072)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Para un servicio REST de ORDS, filtre todos los registros con el atributo "sal" en menos de 3000.</dt>',
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100676247062305072)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Proporcione una expresi\00F3n de filtro que se va a transferir al servicio REST externo. La expresi\00F3n se transferir\00E1 al servidor remoto sin modificaciones. La sintaxis depende del tipo de origen de datos de REST. Por ejemplo, Oracle REST Data Services (O')
||'RDS) espera la sintaxis de JSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100676119223305072)
,p_name=>'PE.PROPERTY.EXTERNAL_FILTER_EXPR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Filtro Externo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100676653215305072)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para un servicio REST de ORDS, ordene por el atributo "job" en sentido ascendente y, a continuaci\00F3n, por "ename" en sentido descendente.</dt>'),
'<dd><pre>',
'{"job": "asc", "ename": "desc"}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100676549735305072)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Proporcione una expresi\00F3n order by para transferirla al servicio REST externo. La expresi\00F3n se transferir\00E1 al servidor remoto sin modificaciones. La sintaxis depende del tipo de origen de datos de REST. Por ejemplo, Oracle REST Data Services (ORDS) e')
||'spera la sintaxis de JSON.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100676456141305072)
,p_name=>'PE.PROPERTY.EXTERNAL_ORDER_BY_EXPR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Order by externo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100224449500304733)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el procesamiento posterior externo est\00E1 activado para este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100224367124304733)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_ENABLED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100224173493304733)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto para el enlace en el que har\00E1n clic los usuarios finales para llamar al motor de procesamiento externo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100224084841304733)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_LINK_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100223913558304733)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la direcci\00F3n URL a un servidor para el procesamiento posterior de este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100223811233304733)
,p_name=>'PE.PROPERTY.EXTERNAL_PROCESSING_URL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100533965714304966)
,p_name=>'PE.PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el grupo de facetas al que est\00E1 asociada la casilla de control.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100533839505304966)
,p_name=>'PE.PROPERTY.FACET_GROUP.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Grupo de facetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100462390109304913)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el tipo de lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100463027118304913)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'es'
,p_message_text=>'Valores distintos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100463166098304913)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La lista de valores se basa en una consulta generada autom\00E1ticamente que selecciona los valores de columna distintos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100589230867305007)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100589328817305007)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La lista de valores din\00E1mica se basa en la consulta SQL devuelta por el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100462457547304913)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'es'
,p_message_text=>'Componente Compartido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100462574429304913)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'es'
,p_message_text=>'La lista de valores se basa en una lista de valores predefinida, que se ha definido en Componentes Compartidos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100462677752304913)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100462711283304913)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La lista de valores din\00E1mica se basa en la consulta SQL que introduzca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100462811060304913)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100462937851304913)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La lista de valores est\00E1tica se basa en el valor de texto que introduzca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100462218941304913)
,p_name=>'PE.PROPERTY.FACET_LOV_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100307212975304796)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique si la faceta es reducible. Cuando se define en <strong>Activado</strong>, aparece un bot\00F3n a la izquierda de la faceta para ocultar/mostrar sus entradas en la lista. Cuando se define en <strong>Desactivado</strong>, la faceta y sus ent')
||'radas en la lista son siempre visibles.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100307166762304796)
,p_name=>'PE.PROPERTY.FC_COLLAPSIBLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Reducible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100725985647305113)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique si desea calcular el recuento de las entradas de la lista para la faceta o el filtro. El uso de esta opci\00F3n afecta al rendimiento.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100725837433305113)
,p_name=>'PE.PROPERTY.FC_COMPUTE_COUNTS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Calcular recuentos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100534189164304966)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique c\00F3mo combinar filtros dentro de este grupo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100534414389304966)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.D'
,p_message_language=>'es'
,p_message_text=>unistr('AND (Intersecci\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100534542100304966)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.AND.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los filtros se combinar\00E1n mediante "AND", por lo que el resultado ser\00E1 la intersecci\00F3n de todos los filtros individuales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100534249900304966)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.D'
,p_message_language=>'es'
,p_message_text=>unistr('OR (uni\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100534307652304966)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.LOV.OR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los filtros se combinar\00E1n mediante "OR", por lo que el resultado ser\00E1 el juego de uni\00F3n de filtros individuales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100534031022304966)
,p_name=>'PE.PROPERTY.FC_FILTER_COMBINATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Combinar filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100306617947304796)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique si desea permitir el filtrado del cliente de las entradas de la lista para la faceta o el filtro. Cuando se define en <strong>Activado</strong>, aparece un campo de b\00FAsqueda encima de las entradas de la lista que permite a los usuarios')
||' finales filtrar la lista.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100306560959304796)
,p_name=>'PE.PROPERTY.FC_FILTER_VALUES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Filtrado del cliente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100535172865304966)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique si el gr\00E1fico se muestra inicialmente. Esta propiedad solo se aplica cuando la propiedad Mostrar gr\00E1ficos de la regi\00F3n B\00FAsqueda por facetas tenga el valor Selector. Puede que los cambios en esta propiedad no se vean directamente porque')
||unistr(' el juego de gr\00E1ficos que el usuario ha mostrado se mantiene en la sesi\00F3n del explorador. Para comprobar el efecto de los cambios en esta propiedad, restablezca el informe mediante una opci\00F3n de control de cach\00E9 del enlace Restablecer regiones, como ')
||unistr('con el bot\00F3n Restablecer generado por el asistente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100535062930304966)
,p_name=>'PE.PROPERTY.FC_INITIAL_CHART.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar gr\00E1fico inicialmente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100307467298304797)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique si la faceta se debe representar inicialmente en estado reducido. Puede que los cambios en esta propiedad no se vean directamente porque el estado de ampliaci\00F3n se mantiene en la sesi\00F3n del explorador. Para comprobar el efecto de los c')
||unistr('ambios en esta propiedad, restablezca el informe mediante una opci\00F3n de control de cach\00E9 del enlace Restablecer regiones, como con el bot\00F3n Restablecer generado por el asistente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100307314715304797)
,p_name=>'PE.PROPERTY.FC_INITIAL_COLLAPSED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Reducida inicialmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100540068197304970)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Determina si la faceta se muestra por defecto. Puede que los cambios en esta propiedad no se vean directamente porque el estado de visualizaci\00F3n se mantiene en la sesi\00F3n del explorador. Para comprobar el efecto de los cambios en esta propiedad, re')
||unistr('stablezca el informe mediante una opci\00F3n de control de cach\00E9 del enlace Restablecer regiones, como con el bot\00F3n Restablecer generado por el asistente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100539986328304970)
,p_name=>'PE.PROPERTY.FC_INITIAL_TOGGLED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrado inicialmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100307688488304797)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la altura m\00E1xima de la faceta en p\00EDxeles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100307580357304797)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Altura M\00E1xima')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100307762810304797)
,p_name=>'PE.PROPERTY.FC_MAX_HEIGHT.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('p\00EDxeles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99649988732304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique c\00F3mo combinar valores individuales al filtrar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99650202335304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.D'
,p_message_language=>'es'
,p_message_text=>unistr('AND (Intersecci\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99650325740304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.AND.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los valores se combinar\00E1n mediante "AND". Por lo tanto, el resultado se incluir\00E1 en la intersecci\00F3n de todos los valores individuales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99650042293304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.D'
,p_message_language=>'es'
,p_message_text=>unistr('OR (uni\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99650179245304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.LOV.OR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los valores se combinar\00E1n utilizando "OR", por lo que el resultado ser\00E1 el juego de uni\00F3n de valores individuales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99649875135304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_COMBINATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Combinaci\00F3n de filtros')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99649515475304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Caracteres normales:</dt>',
'<dd><pre>,</pre></dd>',
'<dd><pre>:</pre></dd>',
'<dt>Caracteres de control:</dt>',
'<dd>Separador (<em>ASCII: 9</em>) <pre>\t</pre></dd>',
unistr('<dd>Salto de l\00EDnea (<em>ASCII: 10</em>) <pre>\005Cn</pre></dd>'),
'<dt>Otros caracteres:</dt>',
unistr('<dd>Utilice un valor de codificaci\00F3n Unicode con el formato ''\005Cxxxx'', donde ''xxxx'' es el valor hexadecimal de un valor de c\00F3digo de car\00E1cter con formato de codificaci\00F3n UCS-2..</dd>'),
'<dd>Comienzo de cabecera (<em>ASCII: 1</em>) <pre>\0001</pre></dd>',
unistr('<dd>S\00EDmbolo "@" (<em>ASCII: 64</em>) <pre>\005C0040</pre></dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99649476471304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Identifica el car\00E1cter que separa los valores. Tenga en cuenta que los caracteres <strong>"</strong> (comillas dobles) y <strong>\005C</strong> (barra invertida) no se admiten como un separador de valor, ni siquiera en el formato <strong>\005Cxxxx</strong')
||'>.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99649303308304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_SEPARATOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99649776792304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indica si desea recortar los espacios en blanco iniciales y finales de los valores individuales tras la divisi\00F3n.</p>'),
'<pre>',
'APEX:SQL:Spatial :Oracle TEXT: Data Warehouse',
'APEX :SQL:Data Warehouse',
'</pre>',
'<dl>',
unistr('<dt>Si la opci\00F3n de recortar los espacios en blanco est\00E1 <em>desactivada</em>, se contabilizar\00E1n los siguientes valores individuales:</dt>'),
'<dd><pre>',
'"APEX":            1',
'"APEX ":           1',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  1',
'" Data Warehouse": 1',
'</pre></dd>',
unistr('<dt>Si la opci\00F3n de recortar los espacios en blanco est\00E1 <em>activada</em>, se contabilizar\00E1n los siguientes valores individuales:</dt>'),
'<dd><pre>',
'"APEX":            2',
'"SQL":             2',
'"Spatial":         1',
'"Oracle TEXT":     1',
'"Data Warehouse":  2',
'</pre></dd>',
unistr('<p>Tenga en cuenta que recortar los espacios en blanco puede afectar significativamente al rendimiento de las consultas. Para conjuntos de datos m\00E1s grandes, considere la limpieza de datos en su lugar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99649649128304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TRIM_SPACE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Recortar espacio en blanco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99650645639304257)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99650785630304257)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.FACET.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'La columna no contiene varios valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99899129807304447)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99899282888304447)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'La columna no contiene varios valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99648815649304255)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Determina si la columna de origen contiene varios valores y la forma en la que se codifican.</p><p><em>Solo las bases de datos de la versi\00F3n 12.2 o superiores de Oracle soportan las facetas de varios valores. En una base de datos de la versi\00F3n 12.')
||unistr('1, &PRODUCT_NAME. emitir\00E1 un error de tiempo de ejecuci\00F3n, si se define un filtro o una faceta de varios valores.</em></p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99649131429304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.D'
,p_message_language=>'es'
,p_message_text=>'Matriz de JSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99649228706304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.JSON_ARRAY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>La columna de origen contiene una matriz de JSON de valores escalar. &PRODUCT_NAME. emitir\00E1 mensajes de error si la columna contiene sintaxis de JSON no v\00E1lida.</p><pre>["APEX", "SQL", "PL/SQL"]</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99648904530304255)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.D'
,p_message_language=>'es'
,p_message_text=>'Lista delimitada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99649079107304256)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.LOV.SEPARATED.HELP'
,p_message_language=>'es'
,p_message_text=>'<p>La columna contiene valores como una lista delimitada.</p><pre>APEX,SQL,PL/SQL</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99648793449304255)
,p_name=>'PE.PROPERTY.FC_MULTI_VALUE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100534978644304966)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique si aparece un bot\00F3n junto a la faceta para permitir al usuario mostrar un gr\00E1fico de los recuentos de entradas de la lista de facetas. Esta propiedad solo se aplica cuando la opci\00F3n Mostrar gr\00E1ficos de la propiedad de regi\00F3n B\00FAsqueda p')
||unistr('or facetas no est\00E9 definida en No.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100534863095304966)
,p_name=>'PE.PROPERTY.FC_SHOW_CHART.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100306482627304796)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique si desea mostrar el n\00FAmero de incidencias de las entradas de la lista para la faceta. Cuando se define en <strong>Activado</strong>, el recuento se muestra entre par\00E9ntesis junto a la entrada de la lista. Por ejemplo, KING (3).</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100306399870304796)
,p_name=>'PE.PROPERTY.FC_SHOW_COUNTS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar recuentos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100307018507304796)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique el n\00FAmero m\00E1ximo de entradas de lista que se deben visualizar para la faceta. Cuando se especifica un valor y la lista contiene m\00E1s que este n\00FAmero de entradas, aparece un enlace <strong>Mostrar m\00E1s</strong> en la parte inferior de la ')
||unistr('lista. Si no se especifica ning\00FAn valor, se muestran todas las entradas de la lista.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100306927929304796)
,p_name=>'PE.PROPERTY.FC_SHOW_MORE_COUNT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo de entradas visualizadas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100306885913304796)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.HELP'
,p_message_language=>'es'
,p_message_text=>'<p>Especifique si alguna de las entradas seleccionadas en la lista se muestra en primer lugar de la lista para la faceta o el filtro. Este atributo no se aplica cuando la lista de valores asociada con la faceta define grupos.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100306739917304796)
,p_name=>'PE.PROPERTY.FC_SHOW_SELECTED_FIRST.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar seleccionada primera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99936309308304476)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si desea ordenar las entradas de la lista para la faceta o el filtro. Cuando se define en <strong>Activado</strong>, las entradas de la lista se ordenan por recuentos descendentes. Si se define en <strong>Desactivado</strong>, las entrada'
||'s de la lista se muestran en el orden definido por la lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99936234702304476)
,p_name=>'PE.PROPERTY.FC_SORT_BY_TOP_COUNTS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ordenar por recuentos superiores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100539874411304970)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique si los usuarios finales pueden mostrar u ocultar la faceta. Cuando al menos una faceta tenga activada esta opci\00F3n, se agrega un bot\00F3n "M\00E1s facetas" que se usa para seleccionar las facetas que se van a mostrar u ocultar. No hay ning\00FAn c')
||'oste de rendimiento por calcular los recuentos de facetas que no se muestran.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100539791632304970)
,p_name=>'PE.PROPERTY.FC_TOGGLEABLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Conmutaci\00F3n de visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100726144333305113)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique c\00F3mo se muestran las entradas de la lista con un recuento cero para la faceta o el filtro.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100726441342305113)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.D'
,p_message_language=>'es'
,p_message_text=>'Desactivar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100726521498305113)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.D.HELP'
,p_message_language=>'es'
,p_message_text=>'<p>Se muestran todas las entradas, pero se desactivan aquellas que no se pueden filtrar.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100726282416305113)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.D'
,p_message_language=>'es'
,p_message_text=>'Ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100726308553305113)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.H.HELP'
,p_message_language=>'es'
,p_message_text=>'<p>Solo se muestran entradas de lista que se pueden filtrar.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100726656419305113)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.D'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar \00FAltima')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100726749401305113)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.LOV.L.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Se muestran todas las entradas, pero se desactivan aquellas que no se pueden filtrar y se muestran en \00FAltimo lugar en la lista para la faceta o el filtro. Esta opci\00F3n se ignora si la lista de valores compartida que est\00E1 asociada usa la funci\00F3n de ')
||'grupo.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100726096972305113)
,p_name=>'PE.PROPERTY.FC_ZERO_COUNT_ENTRIES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Entradas con recuento cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99859529678304415)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca cualquier atributo adicional que se utiliza en la celda de la tabla HTML que contiene esta etiqueta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99859471909304415)
,p_name=>'PE.PROPERTY.FIELD_TABLE_CELL_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atributos de Celda de Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100215493633304727)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la plantilla de campo que se va a utilizar al presentar el campo de la pantalla tabular. Cuando no se seleccione ninguna plantilla, el campo se presenta con la etiqueta compatible con la accesibilidad por defecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100235618446304742)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la plantilla de campo que se va a utilizar al presentar el campo de la pantalla tabular. Cuando no se seleccione ninguna plantilla, el campo se presenta con la etiqueta compatible con la accesibilidad por defecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99859341531304414)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una plantilla de etiqueta para definir la apariencia y el dise\00F1o de esta etiqueta de elemento.</p>'),
unistr('        <p>Las plantillas de etiqueta se definen en el tema de la aplicaci\00F3n.'),
unistr('        Al crear un elemento, la plantilla se define autom\00E1ticamente en la plantilla de elemento por defecto definida en el tema actual.</p>'),
'        <p>Muchos temas contienen plantillas de etiqueta para mostrar etiquetas necesarias, opcionales y ocultas.<br>',
'        El tema universal proporciona las siguientes plantillas de etiqueta:',
'          <dl>',
'            <dt>Oculto</dt>',
unistr('              <dd>Utilice esta opci\00F3n cuando la etiqueta no se deba mostrar en la pantalla. Tenga en cuenta que la tecnolog\00EDa de asistencia a\00FAn podr\00E1 leer la etiqueta.'),
unistr('              Oculto se ignora para los elementos de casilla de control porque se debe mostrar una etiqueta despu\00E9s de la casilla de control.</dd>'),
'            <dt>Opcional</dt>',
unistr('              <dd>Utilice esta opci\00F3n para los elementos de la pantalla que sean opcionales. La etiqueta se mostrar\00E1 al lado del elemento.</dd>'),
'            <dt>Opcional: Encima de</dt>',
unistr('              <dd>Utilice esta opci\00F3n para los elementos de la pantalla que sean opcionales. La etiqueta se mostrar\00E1 sobre el elemento.</dd>'),
'            <dt>Opcional: Flotante</dt>',
unistr('              <dd>Utilice esta opci\00F3n para los elementos de la pantalla que sean opcionales. La etiqueta se mostrar\00E1 dentro del elemento de entrada, y se reducir\00E1 autom\00E1ticamente cuando el campo de entrada tenga un valor.</dd>'),
'            <dt>Necesario</dt>',
unistr('              <dd>Esta plantilla de etiqueta muestra un asterisco rojo junto a la etiqueta y se utiliza para los elementos de pantalla en los que la entrada del usuario es necesaria. La etiqueta se mostrar\00E1 al lado del elemento.</dd>'),
'            <dt>Necesario: Encima de</dt>',
unistr('              <dd>Esta plantilla de etiqueta muestra un asterisco rojo junto a la etiqueta y se utiliza para los elementos de pantalla en los que la entrada del usuario es necesaria. La etiqueta se mostrar\00E1 sobre el elemento. Las plantillas de elemen')
||unistr('to le permiten definir los atributos de la interfaz de usuario como parte de un tema y compartir esa definici\00F3n entre varios elementos de p\00E1gina.</dd>'),
'            <dt>Necesario: Flotante</dt>',
unistr('              <dd>Esta plantilla de etiqueta muestra un asterisco rojo junto a la etiqueta y se utiliza para los elementos de pantalla en los que la entrada del usuario es necesaria. La etiqueta se mostrar\00E1 dentro del elemento de entrada y se reducir')
||unistr('\00E1 autom\00E1ticamente cuando el campo de entrada tenga un valor. Las plantillas de elemento le permiten definir atributos de la interfaz de usuario como parte de un tema y compartir esa definici\00F3n entre varios elementos de p\00E1gina.</dd>'),
'          </dl>',
unistr('          Consulte tambi\00E9n: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de ejemplo de tema universal</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99859275170304414)
,p_name=>'PE.PROPERTY.FIELD_TEMPLATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100672583089305069)
,p_name=>'PE.PROPERTY.FILTER_DATA_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Filtrar Tipo de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100086514908304591)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea realizar una b\00FAsqueda de coincidencia exacta cuando el usuario final introduzca el texto en un filtro de columnas.'),
unistr('        Si se define en <strong>Desactivado</strong>, el filtro realizar\00E1n una b\00FAsqueda contiene, en lugar de una b\00FAsqueda igual que</p>'),
unistr('        <p>Por ejemplo, en una columna, como TAGS, esto equivale a TAGS = ''<<value>>''. Si la Coincidencia Exacta se define en <strong>Desactivado</strong>, equivaldr\00EDa a TAGS LIKE ''%<<value>>%''. ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100086495504304591)
,p_name=>'PE.PROPERTY.FILTER_EXACT_MATCH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Coincidencia Exacta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100084908229304589)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique si desea que sea siempre necesario un filtro para esta columna.</p>',
unistr('        <p>Nota: Un filtro siempre ser\00E1 necesario para esta columna espec\00EDfica antes de que se devuelvan ning\00FAn dato, independientemente de la opci\00F3n <strong>Es necesario el filtro</strong> en los atributos de cuadr\00EDcula interactiva.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100084850921304589)
,p_name=>'PE.PROPERTY.FILTER_IS_REQUIRED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Necesario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100085134361304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione c\00F3mo derivar la lista de valores para el filtro cuando el usuario haga clic en la cabecera de columna o en los cuadros de di\00E1logo del filtro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100085486313304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.D'
,p_message_language=>'es'
,p_message_text=>'Columna Distinta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100085537738304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.DISTINCT.HELP'
,p_message_language=>'es'
,p_message_text=>'Los valores de la columna distinta se muestran para las columnas VARCHAR2 y NUMBER. Las columnas DATE y TIMESTAMP utilizan rangos de fechas predefinidos incorporados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100671576423305069)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.D'
,p_message_language=>'es'
,p_message_text=>'Usar Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100671601580305069)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.LOV.HELP'
,p_message_language=>'es'
,p_message_text=>'Los valores se obtienen de una lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100085236903304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100085309101304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.NONE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Desactive los valores que se van a mostrar en el filtro.',
unistr('        Esta opci\00F3n es adecuada en columnas grandes, generalmente las que contienen la mayor parte de sus valores con m\00E1s 50 caracteres o cuando una lista no es muy \00FAtil para seleccionar un registro especifico.'),
unistr('        En cambio, el usuario final puede escribir un valor parcial y, a continuaci\00F3n, ver los resultados.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100086270821304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100086352425304591)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los valores se derivan del cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100085835230304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'es'
,p_message_text=>'Componente Compartido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100085987518304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'es'
,p_message_text=>'Los valores se derivan de una lista de valores existente.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100085660654304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100085757193304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los valores se derivan de la definici\00F3n de consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100086098421304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100086161807304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los valores se derivan de una lista de valores est\00E1tica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100085002788304590)
,p_name=>'PE.PROPERTY.FILTER_LOV_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100083780331304588)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione qu\00E9 operadores de filtro pueden utilizar los usuarios finales para esta columna.</p>'),
unistr('        <p>Seg\00FAn el tama\00F1o del juego de datos y los \00EDndices de columna, puede desactivar determinados operadores de filtro para evitar problemas de rendimiento para los usuarios finales.'),
unistr('        Determinados operadores pueden producir exploraciones de tablas completas en lugar del uso de \00EDndices de columnas..</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100255079652304758)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.D'
,p_message_language=>'es'
,p_message_text=>'Contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100255151700304758)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.C.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>El filtro devuelve resultados de valores de columna que contienen el valor de filtro.',
unistr('        &PRODUCT_NAME. utilizar\00E1 <code>column LIKE <strong>%</strong>filtervalue<strong>%</strong></code> en la cl\00E1usula Where.</p>'),
unistr('        <p>Nota: Este operador evitar\00E1 que se utilice ning\00FAn \00EDndice de columna, lo que puede dar como resultado una exploraci\00F3n de tabla completa.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100083902398304589)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.D'
,p_message_language=>'es'
,p_message_text=>unistr('No Sensible a May\00FAsculas/Min\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100206566176304720)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.CASE_INSENSITIVE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>El filtro devuelve resultados de valores de columna independientemente de las diferencias en el caso del valor de columna y el valor de filtro.',
unistr('        &PRODUCT_NAME. utilizar\00E1 <code>UPPER(column) <em>operator</em> UPPER(filtervalue)</code> en la cl\00E1usula Where.</p>'),
unistr('        <p>Nota: Generalmente, al ejecutar UPPER en el valor de columna y de filtro se evitar\00E1 el uso de cualquier \00EDndice de columna, excepto los \00EDndices de columnas basados en funciones con UPPER(<em>column</em>).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100083899082304589)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100206623804304720)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.REGEXP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El filtro devuelve resultados basados en la expresi\00F3n regular introducida.</p>'),
'        <p>Nota: El uso de operadores REGEXP es complejo y generalmente lo utilizan solo los usuarios avanzados. Dichos operadores pueden dar como resultado un rendimiento muy malo.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100255228447304758)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.D'
,p_message_language=>'es'
,p_message_text=>'Empieza por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100255382770304758)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.LOV.S.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>El filtro devuelve resultados de valores de columna que empiezan por el valor de filtro.',
unistr('        &PRODUCT_NAME. utilizar\00E1 <code>column LIKE filtervalue<strong>%</strong></code> en la cl\00E1usula Where.</p>'),
unistr('        <p>Nota: Este operador puede utilizar \00EDndices de columna disponibles. {Revise <strong>No Sensible a May\00FAsculas/Min\00FAsculas</strong> para ver las excepciones}.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100083668865304588)
,p_name=>'PE.PROPERTY.FILTER_OPERATORS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Operadores que Afectan al Rendimiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100084165967304589)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el formato de may\00FAsculas/min\00FAsculas del texto en el que se almacenar\00E1 el valor de columna.</p>'),
unistr('        <p>Si la columna se puede especificar como siempre en may\00FAsculas, por ejemplo <em>Usuario</em>, o siempre en min\00FAsculas, el rendimiento de recuperaci\00F3n de resultados de filtro se puede mejorar.'),
unistr('          Si se selecciona <strong>May\00FAsculas</strong> o <strong>Min\00FAsculas</strong>, las b\00FAsquedas siempre realizar\00E1n b\00FAsquedas sensibles a may\00FAsculas/min\00FAsculas.</p>'),
unistr('        <p>Nota: Si se selecciona May\00FAsculas y Min\00FAsculas, los usuarios puede especificar <strong>Sensible a May\00FAsculas/Min\00FAsculas</strong> en los cuadros de di\00E1logo de b\00FAsqueda y filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100084401227304589)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Min\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100084595419304589)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.LOWER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cuando el valor de columna se almacena siempre en min\00FAsculas.'),
unistr('        &PRODUCT_NAME. utilizar\00E1 <code>column <em>operator</em> LOWER(filtervalue)</code> en la cl\00E1usula where.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100084695637304589)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.D'
,p_message_language=>'es'
,p_message_text=>unistr('May\00FAsculas y Min\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100084745457304589)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.MIXED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Cuando el valor de columna se almacena en may\00FAsculas y min\00FAsculas. El valor del operador <strong>No Sensible a May\00FAsculas/Min\00FAsculas</strong> determinar\00E1 la cl\00E1usula where utilizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100084260018304589)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.D'
,p_message_language=>'es'
,p_message_text=>unistr('May\00FAsculas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100084301687304589)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.LOV.UPPER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cuando el valor de columna se almacena siempre en may\00FAsculas.'),
unistr('        &PRODUCT_NAME. utilizar\00E1 <code>column <em>operator</em> UPPER(filtervalue)</code> en la cl\00E1usula where.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100084027139304589)
,p_name=>'PE.PROPERTY.FILTER_TEXT_CASE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('May\00FAsculas/Min\00FAsculas de Texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99878124344304429)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea que la acci\00F3n se dispare al inicializar.</p>'),
unistr('        							<p>La inicializaci\00F3n tiene un significado ligeramente diferente seg\00FAn c\00F3mo se defina la acci\00F3n din\00E1mica. Para las acciones'),
unistr('        							din\00E1micas definidas para dispararse en columnas de cuadr\00EDculas interactivas, esta opci\00F3n especifica si la acci\00F3n se dispara cuando'),
unistr('        							la fila de cuadr\00EDcula interactiva se activa para la edici\00F3n. Para el resto de acciones din\00E1micas, esta opci\00F3n especifica si la acci\00F3n se dispara cuando se'),
unistr('        							carga la p\00E1gina.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99878030602304429)
,p_name=>'PE.PROPERTY.FIRE_ON_PAGE_LOAD.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Disparar al Inicializar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99877945561304429)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si esta acci\00F3n se dispara cuando se cumple la condici\00F3n de elemento disparador seleccionando <strong>Verdadera</strong> (Acci\00F3n Verdadera) o cuando no se cumple, seleccionando <strong>Falsa</strong> (Acci\00F3n Falsa).</p>'),
unistr('<p>Nota: si no se ha especificado ninguna condici\00F3n, solo se dispara la acci\00F3n <strong>Verdadera</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100367663550304841)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.FALSE.D'
,p_message_language=>'es'
,p_message_text=>'Falso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100367516767304841)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.LOV.TRUE.D'
,p_message_language=>'es'
,p_message_text=>'Verdadero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99877849640304429)
,p_name=>'PE.PROPERTY.FIRE_WHEN_EVENT_RESULT_IS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Arrancar cuando Resultado de Evento Sea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100751785139305132)
,p_name=>'PE.PROPERTY.FIXED_HEADER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea fijar las cabeceras de columna del informe en la parte superior de la <strong>p\00E1gina</strong> o en la parte superior de la <strong>regi\00F3n</strong>, de forma que las cabeceras de columna permanezcan visibles mientras el usuario se')
||' desplaza por el informe verticalmente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100752778328305133)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100752820088305133)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.NONE.HELP'
,p_message_language=>'es'
,p_message_text=>'No se ha fijado la cabecera de informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100751914296305132)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100752107794305132)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Fija la cabecera del informe en la parte superior de la p\00E1gina. Mientras el usuario se desplaza verticalmente por la p\00E1gina, la cabecera del informe permanece fija en la parte superior de la misma. Las cabeceras fijas del nivel <strong>P\00E1gina</strong')
||unistr('> son \00FAtiles cuando el informe es el contenido principal de la p\00E1gina. Este valor no est\00E1 soportado cuando la regi\00F3n est\00E1 en un cuadro de di\00E1logo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100751888866305132)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100752096737305132)
,p_name=>'PE.PROPERTY.FIXED_HEADER.LOV.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Fija la cabecera del informe en la parte superior de la regi\00F3n actual. Mientras el usuario se desplaza verticalmente en la regi\00F3n, la cabecera del informe permanece fija en la parte superior de la regi\00F3n. Las cabeceras fijas del nivel <strong>Regi\00F3n<')
||unistr('/strong> pueden ser \00FAtiles para una p\00E1gina que contenga varias regiones, por ejemplo, una p\00E1gina de panel de control.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100751649069305132)
,p_name=>'PE.PROPERTY.FIXED_HEADER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Fijo en'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100753196240305133)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la altura m\00E1xima del informe en p\00EDxeles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100753033754305133)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Altura M\00E1xima de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100753203084305133)
,p_name=>'PE.PROPERTY.FIXED_HEADER_MAX_HEIGHT.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('p\00EDxeles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100261154770304762)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la altura fija del informe en p\00EDxeles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100261081437304762)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Altura fija del informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100261242136304762)
,p_name=>'PE.PROPERTY.FIXED_REPORT_HEIGHT.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('p\00EDxeles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100077609296304584)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea mostrar la cuadr\00EDcula interactiva con la altura de fila fija.</p>'),
unistr('        <p>Si se define en <em>S\00ED</em>, aparecer\00E1n puntos suspensivos (...) al final de los datos, para las columnas que sean demasiado estrechas como para mostrar todos los datos.'),
unistr('        Si se define en <em>No</em>, los datos se ajustar\00E1n en varias l\00EDneas seg\00FAn sea necesario.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100077589461304584)
,p_name=>'PE.PROPERTY.FIXED_ROW_HEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Altura de Fila Fija'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99947056875304484)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un pie de p\00E1gina de regi\00F3n para que aparezca directamente despu\00E9s del contenido del cuerpo, es decir, a continuaci\00F3n de <code>#BODY#</code> en la plantilla de regi\00F3n.'),
unistr('Puede utilizar los accesos directos y la cadena de sustituci\00F3n <code>#TIMING#</code>, para mostrar el tiempo empleado para presentar la regi\00F3n.</p>'),
unistr('<p>Para las regiones de informe puede utilizar las siguientes cadenas de sustituci\00F3n de paginaci\00F3n:</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>Muestra el n\00FAmero de filas recuperadas por el motor de creaci\00F3n de informes (tama\00F1o de p\00E1gina). Utilice estas cadenas de sustituci\00F3n para mostrar al usuario los mensajes personalizados.</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
unistr('    <dd>Muestra el n\00FAmero total de filas que cumplen con la consulta SQL utilizada para un informe. Por ejemplo, Z en filas X - Y de Z</dd>'),
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
'    <dd> X en filas X - Y de Z</li>',
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
'    <dd> Y en filas X - Y de Z</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99856651158304412)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto o HTML que aparece antes del pie de p\00E1gina de la plantilla de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99856540811304412)
,p_name=>'PE.PROPERTY.FOOTER_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100396480101304862)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>La definici\00F3n de este atributo en <code>fielddatabold</code> provoca que se genere el siguiente HTML</dt>'),
'<dd><pre>',
'&lt;span class="fielddatabold"&gt;Datos de Ejemplo&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100213887298304725)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca clases CSS que se aplican a este valor de columna. Puede escribir la clase CSS o elegirla en la lista de elementos disponibles.</p>',
unistr('<p>Esta clase se incluye por defecto en todas las p\00E1ginas de &PRODUCT_NAME. y tiene la definici\00F3n de <code>''.fielddatabold{font-size: 10pt; font-weight: bold; color: #000000;}''</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100213737698304725)
,p_name=>'PE.PROPERTY.FORMATTING_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100215301635304726)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.CLASSIC_REPORT_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la m\00E1scara de formato que se debe aplicar a esta columna.'),
unistr('    Puede escribir la m\00E1scara de formato o elegirla en la lista predefinida en funci\00F3n de la representaci\00F3n de ejemplo de la forma de mostrar esa m\00E1scara de formato.</p>'),
unistr('    <p>Es importante que las m\00E1scaras de formato de n\00FAmero solo se apliquen a las columnas que contienen n\00FAmeros y las m\00E1scaras de formato de fecha solo se apliquen a columnas que contienen fechas.'),
unistr('    De lo contrario, se genera un error en tiempo de ejecuci\00F3n cuando alg\00FAn registro contenga un valor que no se pueda convertir utilizando la m\00E1scara de formato especificada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100235472747304742)
,p_name=>'PE.PROPERTY.FORMAT_MASK.COMPONENT_PROPERTY.TABULAR_FORM_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la m\00E1scara de formato que se debe aplicar a esta columna.'),
unistr('    Puede escribir la m\00E1scara de formato o elegirla en la lista predefinida en funci\00F3n de la representaci\00F3n de ejemplo de la forma de mostrar esa m\00E1scara de formato.</p>'),
unistr('    <p>Es importante que las m\00E1scaras de formato de n\00FAmero solo se apliquen a las columnas que contienen n\00FAmeros y las m\00E1scaras de formato de fecha solo se apliquen a columnas que contienen fechas.'),
unistr('    De lo contrario, se genera un error en tiempo de ejecuci\00F3n cuando alg\00FAn registro contiene un valor que no se puede convertir utilizando la m\00E1scara de formato especificada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99861351418304416)
,p_name=>'PE.PROPERTY.FORMAT_MASK.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la m\00E1scara de formato que se debe aplicar a este componente.'),
unistr('    Puede escribir en la m\00E1scara de formato o elegirla en la lista de m\00E1scaras de formato predefinidas en funci\00F3n de la representaci\00F3n de ejemplo de la forma de mostrar esa m\00E1scara de formato.</p>'),
unistr('    <p>Es importante que las m\00E1scaras de formato de n\00FAmero solo se apliquen a los componentes que contienen n\00FAmeros y que las m\00E1scaras de formato de fecha solo se apliquen a los componentes que contienen fechas.'),
unistr('    De lo contrario, se genera un error en tiempo de ejecuci\00F3n cuando el componente contenga un valor que no se pueda convertir utilizando la m\00E1scara de formato especificada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99861257366304416)
,p_name=>'PE.PROPERTY.FORMAT_MASK.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara de Formato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99861533368304416)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca una m\00E1scara de formato de fecha para aplicar a este componente.'),
unistr('Puede introducir la m\00E1scara de formato o seleccionarla de la lista de m\00E1scaras de formato predefinidas, seg\00FAn muestra un ejemplo de c\00F3mo se mostrar\00E1 la m\00E1scara de formato en cuesti\00F3n.'),
unistr('Tambi\00E9n puede utilizar la sintaxis de sustituci\00F3n para hacer referencia a la m\00E1scara de formato din\00E1mica desde un elemento de p\00E1gina o aplicaci\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99861428193304416)
,p_name=>'PE.PROPERTY.FORMAT_MASK_DATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara de Formato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99861735171304416)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca una m\00E1scara de formato de n\00FAmero para aplicar a este componente.'),
unistr('Puede introducir la m\00E1scara de formato o seleccionarla de la lista de m\00E1scaras de formato predefinidas, seg\00FAn muestra un ejemplo de c\00F3mo se mostrar\00E1 la m\00E1scara de formato en cuesti\00F3n.'),
unistr('Tambi\00E9n puede utilizar la sintaxis de sustituci\00F3n para hacer referencia a la m\00E1scara de formato desde un elemento de p\00E1gina o aplicaci\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99861684733304416)
,p_name=>'PE.PROPERTY.FORMAT_MASK_NUMBER.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara de Formato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99858004392304413)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si desea que la terminaci\00F3n autom\00E1tica est\00E9 desactivada en esta p\00E1gina. El valor <b>Activado</b> no tendr\00E1 ning\00FAn efecto en esta p\00E1gina. El valor <b>Desactivado</b> generar\00E1 el siguiente HTML en la etiqueta FORM:'),
'<pre>',
'autocomplete="off"',
'</pre>',
unistr('<p>Nota: Distintos exploradores pueden tener reglas diferentes si se respeta o ignora <code>autocomplete="off"</code>. T\00E9ngalo en cuenta especialmente al <strong>desactivar</strong> esta opci\00F3n y realice la prueba en sus exploradores de destino.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100359543821304835)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.OFF.D'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100359426331304835)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.LOV.ON.D'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99857910535304413)
,p_name=>'PE.PROPERTY.FORM_AUTO_COMPLETE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Terminaci\00F3n Autom\00E1tica de Pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99569474320304197)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir las etiquetas del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99569384983304197)
,p_name=>'PE.PROPERTY.GAUGE_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100212375555304724)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el n\00FAmero m\00E1ximo de columnas de informe gen\00E9ricas. '),
unistr('Los informes que utilizan nombres de columnas gen\00E9ricas se analizan solo en tiempo de ejecuci\00F3n, por lo que no se conoce el n\00FAmero de columnas al editar el informe.</p>'),
unistr('<p>El n\00FAmero m\00E1ximo de columnas de informe debe ser igual al n\00FAmero esperado. '),
unistr('Si el n\00FAmero real es menor, el informe se presenta con el n\00FAmero de columnas real.'),
unistr('Sin embargo, si el n\00FAmero real es superior al m\00E1ximo, se muestra un mensaje de error en tiempo de ejecuci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100212235968304724)
,p_name=>'PE.PROPERTY.GENERIC_COLUMN_COUNT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Recuento de Columnas Gen\00E9ricas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99999147472304524)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la p\00E1gina global para la interfaz de usuario actual, si no se ha definido ninguna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99999014836304524)
,p_name=>'PE.PROPERTY.GLOBAL_PAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100660096825305060)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100233354006304740)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100233693612304740)
,p_name=>'PE.PROPERTY.GRID_COLUMN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99860307296304415)
,p_name=>'PE.PROPERTY.GRID_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione una columna de dise\00F1o espec\00EDfica. Utilice <strong>Autom\00E1tico</strong> para determinar autom\00E1ticamente la siguiente columna de dise\00F1o disponible en la que aparece el componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99860268523304415)
,p_name=>'PE.PROPERTY.GRID_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99861172947304416)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca los atributos adicionales que se definen para la columna de dise\00F1o. Este valor sustituye al marcador de posici\00F3n de sustituci\00F3n <code>#ATTRIBUTES#</code> en la plantilla de la columna de dise\00F1o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99861010270304416)
,p_name=>'PE.PROPERTY.GRID_COLUMN_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atributos de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100559530662304985)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100544118184304973)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione cu\00E1ntas columnas de dise\00F1o ocupa este componente. Use Autom\00E1tico para equilibrar las columnas de dise\00F1o disponibles en todos los componentes de la misma fila.</p>'),
'<dl>',
unistr('  <dt>Autom\00E1tico</dt>'),
unistr('    <dd>Las tarjetas tendr\00E1n un ancho inicial y se ajustar\00E1n autom\00E1ticamente a la nueva fila si no caben correctamente.</dd>'),
'  <dt>2, 3, 4 y 5 columnas</dt>',
unistr('    <dd>Las tarjetas se organizar\00E1n para que incluyan el n\00FAmero seleccionado de columnas por l\00EDnea. Puede que el dise\00F1o reduzca el n\00FAmero de columnas seg\00FAn el ancho de viewport.</dd>'),
'  <dt>Si lo desea, puede configurar el ancho de las tarjetas. Para ello, defina una variable de CSS.</dt>',
unistr('    <dd>Por ejemplo, agregue el siguiente snippet para definir el ancho de tarjeta en 320 p\00EDxeles: <pre>:root {'),
'  --a-cv-item-width: 320px;',
'}</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100544289550304973)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.2.D'
,p_message_language=>'es'
,p_message_text=>'2 columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100544321154304973)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.3.D'
,p_message_language=>'es'
,p_message_text=>'3 columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100544491151304973)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.4.D'
,p_message_language=>'es'
,p_message_text=>'4 columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100544512520304973)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.LOV.5.D'
,p_message_language=>'es'
,p_message_text=>'5 columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100544032983304973)
,p_name=>'PE.PROPERTY.GRID_COLUMN_COUNT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columnas de cuadr\00EDcula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100754635790305134)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases CSS que desea aplicar a la columna de dise\00F1o que contiene esta regi\00F3n. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('        <p>Esta propiedad se puede utilizar para proporcionar un control preciso sobre la respuesta y el dise\00F1o de la columna de dise\00F1o de la regi\00F3n, ya que se cambia el tama\00F1o de viewport.'),
unistr('        Para aplicaciones de tema universal, existen una serie de modificadores CSS que puede utilizar para ampliar los componentes de la p\00E1gina. Revise la secci\00F3n Referencia de la aplicaci\00F3n de ejemplo de tema universal para obtener m\00E1s informaci\00F3n.')
||'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100754567799305134)
,p_name=>'PE.PROPERTY.GRID_COLUMN_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100660172135305060)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100233401234304740)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100233720540304741)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99860793358304416)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el n\00FAmero de columnas de dise\00F1o que ocupa este componente. Utilice <strong>Autom\00E1tico</strong> para equilibrar las columnas de dise\00F1o disponibles en todos los componentes de la misma fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99860651063304415)
,p_name=>'PE.PROPERTY.GRID_COLUMN_SPAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ampliaci\00F3n de Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100751516943305132)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de P\00E1gina por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100751479970305132)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el n\00FAmero de columnas de dise\00F1o que ocupa la etiqueta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100751353478305132)
,p_name=>'PE.PROPERTY.GRID_LABEL_COLUMN_SPAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ampliaci\00F3n de Columna de Etiqueta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99860518620304415)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si este componente se muestra en la siguiente columna o en la misma columna que el componente anterior.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99860483837304415)
,p_name=>'PE.PROPERTY.GRID_NEW_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nueva Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99859907421304415)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si este componente se muestra en un nuevo dise\00F1o o en el mismo dise\00F1o que el anterior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99859811164304415)
,p_name=>'PE.PROPERTY.GRID_NEW_GRID.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Iniciar Nuevo Dise\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99860127765304415)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si este componente se muestra en la siguiente fila tras el componente anterior o si se muestra en la misma fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99860025861304415)
,p_name=>'PE.PROPERTY.GRID_NEW_ROW.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Iniciar Nueva Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100518272414304954)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases CSS que desea aplicar a la fila de dise\00F1o que contiene esta regi\00F3n. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('        <p>Esta propiedad se puede utilizar para proporcionar un control preciso sobre la respuesta y el dise\00F1o de la fila de dise\00F1o de la regi\00F3n, ya que se cambia el tama\00F1o de viewport.'),
unistr('        Para aplicaciones de tema universal, existen una serie de modificadores CSS que puede utilizar para ampliar los componentes de la p\00E1gina. Revise la secci\00F3n Referencia de la aplicaci\00F3n de ejemplo de tema universal para obtener m\00E1s informaci\00F3n.')
||'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100518101030304954)
,p_name=>'PE.PROPERTY.GRID_ROW_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99860959346304416)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero de filas que ocupa este componente en la tabla HTML. Los componentes se presentan en tablas HTML. Este atributo determina el valor que se va a utilizar para el atributo <em>ROWSPAN</em> en la celda de tabla de este componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99860800300304416)
,p_name=>'PE.PROPERTY.GRID_ROW_SPAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ampliaci\00F3n de Fila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100137408844304669)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir una ayuda de burbuja personalizada que sea corta y descriptiva en los nombres de la serie de la leyenda del gr\00E1fico. En el caso de un gr\00E1fico de \00E1reas, la columna no debe coincidir con la ')
||unistr('asignaci\00F3n de la columna Valor seleccionada. La selecci\00F3n de una columna que coincida con la asignaci\00F3n de la columna Valor resultar\00E1 en que no se represente ninguna ayuda de burbuja de leyenda en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100137315329304668)
,p_name=>'PE.PROPERTY.GROUP_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ayuda de Burbuja de Leyenda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100137615791304669)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir una ayuda de burbuja personalizada que sea corta y descriptiva en las etiquetas del eje X del gr\00E1fico. En el caso de un gr\00E1fico de \00E1reas, la columna no debe coincidir con la asignaci\00F3n de ')
||unistr('la columna Valor seleccionada. La selecci\00F3n de una columna que coincida con la asignaci\00F3n de la columna Valor resultar\00E1 en que no se represente ninguna ayuda de burbuja de etiqueta en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100137568604304669)
,p_name=>'PE.PROPERTY.GROUP_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ayuda de Burbuja de Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100212170978304724)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Especifique si desea que las definiciones de columna se deriven de la consulta SQL.',
'Esto implica que &PRODUCT_NAME. analice la consulta.',
unistr('Si no desea analizar la consulta en este momento, utilice nombres de columna gen\00E9ricos que producir\00E1n definiciones de columna de marcador de posici\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100212034251304724)
,p_name=>'PE.PROPERTY.HAS_GENERIC_COLUMNS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Usar Nombres de Columna Gen\00E9ricos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99946923933304484)
,p_name=>'PE.PROPERTY.HEADER_TEXT.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto HTML que aparece al principio de la regi\00F3n, justo antes del contenido de <code>#BODY#</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99856201295304412)
,p_name=>'PE.PROPERTY.HEADER_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto o HTML que desea que aparezca inmediatamente despu\00E9s de la cabecera de p\00E1gina y antes del contenido del cuerpo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99856117417304412)
,p_name=>'PE.PROPERTY.HEADER_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto de Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100219531636304730)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la forma de definir las cabeceras del informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100398201514304864)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.D'
,p_message_language=>'es'
,p_message_text=>'Cabeceras Personalizadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100398360785304864)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.COLON_DELMITED_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>'Permite que introduzca sus propias cabeceras. Inicialmente se utilizan las cabeceras por defecto, que se basan en una consulta de los nombres de las columnas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100398458596304864)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100398555625304864)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Crea cabeceras basadas en una funci\00F3n PL/SQL que devuelve una lista de nombres delimitados por dos puntos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100398626924304864)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100398796501304864)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.NO_HEADINGS.HELP'
,p_message_language=>'es'
,p_message_text=>'El informe se muestra sin cabeceras de informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100397816373304863)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.D'
,p_message_language=>'es'
,p_message_text=>'Nombres de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100397918370304863)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>'Genera cabeceras basadas en una consulta de los nombres de las columnas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100398083407304864)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.D'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('Nombres de Columna (May\00FAscula Inicial)')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100398111603304864)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.LOV.QUERY_COLUMNS_INITCAP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Genera cabeceras, que se convierten en may\00FAscula inicial, basadas en una consulta de los nombres de las columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100219437082304730)
,p_name=>'PE.PROPERTY.HEADINGS_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100180153040304701)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la alineaci\00F3n de cabecera. Tenga en cuenta que la selecci\00F3n de alineaci\00F3n debe estar soportada por la plantilla de informe seleccionada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100384051106304853)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'es'
,p_message_text=>'centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100383975595304853)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'es'
,p_message_text=>'inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100384147811304853)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'es'
,p_message_text=>'final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100180099983304701)
,p_name=>'PE.PROPERTY.HEADING_ALIGNMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Alineaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100398814991304864)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Proporcionar las cabeceras para un informe basado en la tabla DEPT</dt>',
'<dd><pre>return ''Deptno:DName:Loc'';</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100219716195304730)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una funci\00F3n PL/SQL para devolver una cadena de cabeceras de columna delimitadas por dos puntos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100219657479304730)
,p_name=>'PE.PROPERTY.HEADING_TYPE_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100091439512304595)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Utilice este atributo para introducir el texto de ayuda para la cuadr\00EDcula interactiva. El texto de ayuda introducido aparecer\00E1 junto con contenido de ayuda por defecto en la ayuda del men\00FA acciones.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100092328283304595)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca texto de ayuda para esta columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100234477987304741)
,p_name=>'PE.PROPERTY.HELP_TEXT.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el texto de ayuda para este elemento. El texto de ayuda se puede utilizar para proporcionar ayuda sensible al contexto al nivel de campo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99859026226304414)
,p_name=>'PE.PROPERTY.HELP_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este atributo para introducir texto de ayuda correspondiente a la p\00E1gina actual. La ayuda de nivel de p\00E1gina soporta accesos directos mediante la siguiente sintaxis:</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>El texto de ayuda de p\00E1gina no se muestra por defecto. Sin embargo, puede desarrollar con facilidad un sistema de ayuda que muestre este texto.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99858954466304414)
,p_name=>'PE.PROPERTY.HELP_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto de Ayuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100113433868304612)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este atributo para introducir texto de ayuda correspondiente a la p\00E1gina actual. La ayuda de nivel de p\00E1gina soporta accesos directos mediante la siguiente sintaxis:</p>'),
'<pre>"SHORTCUT_NAME"</pre>',
unistr('<p>El texto de ayuda de p\00E1gina no se muestra por defecto. Sin embargo, puede desarrollar con facilidad un sistema de ayuda que muestre este texto.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100113344326304611)
,p_name=>'PE.PROPERTY.HELP_TEXT_CLOB.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto de Ayuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99895648856304444)
,p_name=>'PE.PROPERTY.HIDDEN_PARENT_REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100520748147304956)
,p_name=>'PE.PROPERTY.HIDDEN_REGION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100133310867304665)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione el comportamiento de ocultar y mostrar que se ejecuta al hacer clic en un elemento de leyenda.',
unistr('        Por ejemplo, al anular la selecci\00F3n de un elemento de leyenda, se ocultar\00E1 la serie de datos asociada en el gr\00E1fico.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100133434488304665)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100257017562304759)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.NONE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr(' El gr\00E1fico no permitir\00E1 el comportamiento para ocultar y mostrar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100133683066304666)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.D'
,p_message_language=>'es'
,p_message_text=>'Sin Reajuste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100257229409304759)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHOUTRESCALE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr(' Los ejes del gr\00E1fico no se volver\00E1n a escalar. Esto resulta \00FAtil para mantener al usuario en contexto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100133534481304666)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.D'
,p_message_language=>'es'
,p_message_text=>'Reajustar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100257106033304759)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.LOV.WITHRESCALE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr(' Los ejes de gr\00E1fico se volver\00E1n a escalar como los valores m\00EDnimos y m\00E1ximos del aumento o disminuci\00F3n de datos visibles. Esto resulta \00FAtil, sobre todo, para series con valores variables.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100133213293304665)
,p_name=>'PE.PROPERTY.HIDE_AND_SHOW_BEHAVIOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Comportamiento de Ocultar y Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100214236333304726)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Introduzca las cadenas de texto que se van a resaltar en una columna de informe.',
'Para resaltar varias palabras, utilice una lista delimitada por comas.',
unistr('Se puede hacer referencia tambi\00E9n a elementos de aplicaci\00F3n o p\00E1gina mediante la sintaxis <code>&amp;ITEM.</code>.'),
unistr('Por ejemplo, puede resaltar cadenas introducidas en un campo de b\00FAsqueda.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100214169319304726)
,p_name=>'PE.PROPERTY.HIGHLIGHT_WORDS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Resaltar Palabras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99998566239304523)
,p_name=>'PE.PROPERTY.HOME_URL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la p\00E1gina inicial de la aplicaci\00F3n para la interfaz de usuario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99998407238304523)
,p_name=>'PE.PROPERTY.HOME_URL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('URL de P\00E1gina Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99876958719304428)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Seleccione la alineaci\00F3n horizontal para este bot\00F3n en la posici\00F3n de la plantilla especificada.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100375161341304847)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'es'
,p_message_text=>'Izquierda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100375293263304847)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'es'
,p_message_text=>'Derecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99876818700304428)
,p_name=>'PE.PROPERTY.HORIZONTAL_ALIGNMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Alineaci\00F3n Horizontal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100386002021304855)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Cambiar los colores del fondo y del texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">#EMPLOYEE_STATUS#&lt;/span></pre></dd>',
'  <dt>Utilizar Cabecera 2</dt>',
'    <dd><pre>&lt;h2>#EMPLOYEE_NAME#&lt;/h2></pre></dd>',
unistr('  <dt>Utilizar una clase din\00E1mica de la consulta SQL</dt>'),
'    <dd><pre>&lt;span class="#COLUMN_CLASS#">#EMPLOYEE_STATUS#&lt;/span></pre><br>',
'    Las sustituciones <code>#COLUMN_CLASS#</code> y <code>#EMPLOYEE_STATUS#</code> de este ejemplo son columnas seleccionadas en la consulta SQL de informe.</dd>',
'  <dt>Mostrar una imagen y una pista al pasar el mouse</dt>',
'    <dd><pre>&lt;img src="#IMAGE_NAME#" title="#EMPLOYEE_NAME#"&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100182784513304703)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las expresiones HTML que se mostrar\00E1n en esta columna. Utilice la sintaxis <code>#COLUMN#</code> para mostrar valores de columna en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100182641774304703)
,p_name=>'PE.PROPERTY.HTML_EXPRESSION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99855804700304412)
,p_name=>'PE.PROPERTY.HTML_HEADER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el texto para sustituir la cadena de sustituci\00F3n <code>#HEAD#</code> en la cabecera de plantilla de p\00E1gina.'),
unistr('Los valores introducidos aqu\00ED se insertan despu\00E9s de la etiqueta HTML<code>&lt;head&gt;</code>. Utilice este atributo de p\00E1gina para agregar etiquetas de metadatos espec\00EDficas de la p\00E1gina.'),
'</p>',
unistr('<p>Nota: el c\00F3digo de JavaScript o las hojas de estilo en cascada se deben agregar a los atributos de JavaScript y CSS dedicados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99855787779304412)
,p_name=>'PE.PROPERTY.HTML_HEADER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Cabecera HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100549639562304977)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna que devuelve el BLOB para el origen de imagen del icono.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100549514101304977)
,p_name=>'PE.PROPERTY.ICON_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100549459084304977)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que se utilizar\00E1 como origen de imagen de icono.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100549355639304977)
,p_name=>'PE.PROPERTY.ICON_CLASS_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99898170828304446)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee utilizar para identificar esta faceta. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('            <p>Si el tema utiliza la fuente APEX, revise la <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de ejemplo de tema universal</a> para ver los iconos y modificadores disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99898204876304446)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee utilizar para identificar esta faceta. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('            <p>Si el tema utiliza la fuente APEX, revise la <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de ejemplo de tema universal</a> para ver los iconos y modificadores disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99898321287304446)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee utilizar para identificar esta faceta. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('            <p>Si el tema utiliza la fuente APEX, revise la <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de ejemplo de tema universal</a> para ver los iconos y modificadores disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100677058098305073)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee agregar al componente. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('        <p>Si el tema utiliza Fuente APEX, consulte el enlace <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de Ejemplo de Tema Universal</a> para ver los iconos y modificadores disponibles.</p>'),
unistr('        <p>Nota: Este icono se mostrar\00E1 dentro del elemento, no como parte de la etiqueta.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100676913464305073)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee agregar al componente. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('        <p>Si el tema utiliza Fuente APEX, consulte el enlace <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de Ejemplo de Tema Universal</a> para ver los iconos y modificadores disponibles.</p>'),
unistr('        <p>Nota: Este icono se mostrar\00E1 dentro del elemento, no como parte de la etiqueta.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99898578705304446)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee utilizar para identificar este filtro. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('            <p>Si el tema utiliza la fuente APEX, revise la <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de ejemplo de tema universal</a> para ver los iconos y modificadores disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99899465964304447)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee utilizar para identificar este filtro. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('            <p>Si el tema utiliza la fuente APEX, revise la <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de ejemplo de tema universal</a> para ver los iconos y modificadores disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99899844955304447)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee utilizar para identificar este filtro. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('            <p>Si el tema utiliza la fuente APEX, revise la <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de ejemplo de tema universal</a> para ver los iconos y modificadores disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100536186170304967)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Mostrar una flecha hacia la derecha</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100536050097304967)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee agregar al componente. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('        <p>Si el tema utiliza la fuente APEX, revise <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de Ejemplo de Tema Universal</a> para ver los iconos y modificadores disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100535969858304967)
,p_name=>'PE.PROPERTY.ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100551196873304978)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Este texto describe el icono y se puede usar para pistas o textos alternativos de im\00E1genes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100551043580304978)
,p_name=>'PE.PROPERTY.ICON_DESCRIPTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n de icono')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100549802587304977)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la URL del origen de imagen del icono.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100549701568304977)
,p_name=>'PE.PROPERTY.ICON_IMAGE_URL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'URL de imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100550385137304978)
,p_name=>'PE.PROPERTY.ICON_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Determina la posici\00F3n del icono en la cabecera de tarjeta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100550872224304978)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.D'
,p_message_language=>'es'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100550955450304978)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.END.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Alinea el icono en la posici\00F3n final (normalmente en el lado derecho) de la cabecera.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100550676426304978)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.D'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100550774270304978)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.START.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Alinea el icono en la posici\00F3n inicial (normalmente en el lado izquierdo) de la cabecera.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100550491342304978)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.D'
,p_message_language=>'es'
,p_message_text=>'Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100550551272304978)
,p_name=>'PE.PROPERTY.ICON_POSITION.LOV.TOP.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra el icono en la parte superior de la cabecera.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100550290412304978)
,p_name=>'PE.PROPERTY.ICON_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n del icono')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100559623495304985)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Sin icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100548750359304977)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el origen de icono para el icono mostrado en la cabecera del componente de tarjeta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100549202108304977)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'es'
,p_message_text=>'Columna BLOB de Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100549015839304977)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'es'
,p_message_text=>'Columna Clase de icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100548864228304977)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.INITIALS.D'
,p_message_language=>'es'
,p_message_text=>'Iniciales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100548911150304977)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'es'
,p_message_text=>'Clase de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100549126913304977)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'es'
,p_message_text=>'URL de imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100548615095304977)
,p_name=>'PE.PROPERTY.ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Origen de icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100080378506304586)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="&APEX$ROW_URL!ATTR."&gt;&lt;img src="&EMP_IMG!ATTR." title="&ENAME!ATTR." alt="&ENAME!ATTR."&gt;&lt;br&gt;&ENAME.&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100080278478304586)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</p>Introduzca el HTML de columna personalizado para la vista de iconos.</p>',
unistr('<p>Est\00E1n disponibles las siguientes cadenas de sustituci\00F3n:'),
'<ul>',
unistr('<li><code>&&lt;COLUMN_NAME&gt;.</code> - Cadenas de sustituci\00F3n para los nombres de columna.</li>'),
unistr('<li><code>&&lt;COLUMN_NAME&gt;_LABEL.</code> - Cadenas de sustituci\00F3n para las etiquetas de columna.</li>'),
'<li><code>&APEX$ROW_ID.</code> - Identificador de registro de la fila.</li>',
unistr('<li><code>&APEX$ROW_INDEX.</code> - N\00FAmero de secuencia de visualizaci\00F3n de registro.</li>'),
'<li><code>&APEX$ROW_URL.</code> - Referencia al destino del enlace especificado.</li>',
'<li><code>&APEX$ROW_STATE_CLASSES.</code> - Estado del registro, como <code>is-inserted</code> o <code>is-deleted</code>.</li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100080183572304586)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Icono de Personalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100389468273304857)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'&lt;a href="#EMP_LINK#"&gt;&lt;img src="#EMP_IMG#" title="#ENAME#" alt="#ENAME#"&gt;&lt;br&gt;#ENAME#&lt;/a&gt;',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100191212815304709)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el enlace de columna para la vista de icono. Utilice las cadenas de sustituci\00F3n <code>#COLUMN_NAME#</code> para los nombres de columna, seg\00FAn sea necesario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100191114257304709)
,p_name=>'PE.PROPERTY.ICON_VIEW_CUSTOM_LINK.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Enlace Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100091219105304594)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se debe activar o no la vista de icono. Si se selecciona <strong>Activado</strong>, se agrega un icono Ver Iconos a la barra de b\00FAsqueda para informes interactivos o al bot\00F3n de vista de la cuadr\00EDcula interactiva, y permite a los usuar')
||'ios acceder a esta vista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100189640195304708)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se debe activar o no la vista de icono. Si se selecciona <strong>Activado</strong>, se agrega un icono Ver Iconos a la barra de b\00FAsqueda para informes interactivos o al bot\00F3n de vista de la cuadr\00EDcula interactiva, y permite a los usuar')
||'ios acceder a esta vista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100189507018304708)
,p_name=>'PE.PROPERTY.ICON_VIEW_ENABLED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100190853010304709)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el texto ALT HTML para la imagen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100190762767304709)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_ALT_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto ALT HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100191027498304709)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la etiqueta TITLE HTML para la imagen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100190922764304709)
,p_name=>'PE.PROPERTY.ICON_VIEW_HTML_TITLE_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto TITLE HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100081569458304587)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca los atributos de imagen de icono que se utilizan para la etiqueta HTML IMG.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100081486839304587)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atributos de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100080952099304586)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna de cuadr\00EDcula interactiva que devuelve BLOB para el origen de imagen del icono.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100080854733304586)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_BLOB_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100081330154304587)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna de cuadr\00EDcula interactiva que devuelve las clases CSS para el origen de imagen del icono.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100081253896304587)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_CSS_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100080539834304586)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el tipo de columna que contiene el origen de imagen del icono.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100080780713304586)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.CSS_CLASSES.D'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100080690857304586)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.LOV.URL.D'
,p_message_language=>'es'
,p_message_text=>'Imagen en URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100080497325304586)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100081101794304587)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna de cuadr\00EDcula interactiva que devuelve la URL para el origen de imagen del icono.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100081057421304586)
,p_name=>'PE.PROPERTY.ICON_VIEW_ICON_URL_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'URL de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100190646637304709)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca los atributos de imagen que se utilizan para la etiqueta HTML IMG.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100190547803304709)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atributos de Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100389293482304857)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examinar la columna <code>IMAGE</code></dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100190203987304708)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna del informe que devuelve el origen de la imagen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100190113519304708)
,p_name=>'PE.PROPERTY.ICON_VIEW_IMAGE_SOURCE_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Origen de Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100389342087304857)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examinar la columna <code>ENAME</code></dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100190468233304708)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna del informe que devuelve la etiqueta de la imagen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100190387821304708)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de etiquetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100063683750304573)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examinar la columna <code>ENAME</code></dt>',
'<dd><pre>',
'select empno,',
'       ename,',
'       job,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100063578196304573)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna del informe que devuelve la etiqueta de la imagen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100063480350304573)
,p_name=>'PE.PROPERTY.ICON_VIEW_LABEL_REGION_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de etiquetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100081943632304587)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca los atributos HTML asociados a la visualizaci\00F3n de cada enlace de <strong>Destino de Enlace</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100081800517304587)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atributos de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100389152709304857)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Examinar la columna <code>LINK</code></dt>',
'<dd><pre>',
'select ename,',
'       job,',
'       ''F?P=&APP_ID.:2:'' || :APP_SESSION || ''::::P2_ID:'' || empno as link,',
'       ''#IMAGE_PREFIX#menu/user_red_64.gif'' as image',
'  from emp',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100190057194304708)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna del informe que devuelve el destino del enlace del icono.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100189959872304708)
,p_name=>'PE.PROPERTY.ICON_VIEW_LINK_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100617101455305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100617411009305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100617385232305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100617208438305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100617530721305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100617028779305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100618394519305029)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un cuerpo de la funci\00F3n Java que devuelva una consulta SQL para rellenar esta lista de valores.</p>'),
unistr('<p>La consulta SQL solo debe devolver una columna. Si la consulta devuelve varias columnas, solo se utiliza la primera columna en la b\00FAsqueda de filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100618258075305029)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100618141822305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Mostrar el nombre del departamento, definir el n\00FAmero del departamento</dt>'),
'<dd><pre>',
'return "select dname as d from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100618002782305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un cuerpo de la funci\00F3n JavaScript que devuelva una consulta SQL para rellenar esta lista de valores.</p>'),
unistr('<p>La consulta SQL solo debe devolver una columna. Si la consulta devuelve varias columnas, solo se utiliza la primera columna en la b\00FAsqueda de filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100617956117305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100617841257305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Para devolver el nombre del departamento:</dt>',
'<dd><pre>',
'begin',
'    return ''select dname as d from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100617790694305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un cuerpo de la funci\00F3n PL/SQL que devuelva una consulta SQL para rellenar esta lista de valores.</p>'),
unistr('<p>La consulta SQL solo debe devolver una columna. Si la consulta devuelve varias columnas, solo se utiliza la primera columna en la b\00FAsqueda de filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100617690258305028)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100618592357305029)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un cuerpo de la funci\00F3n Python que devuelva una consulta SQL para rellenar esta lista de valores.</p>'),
unistr('<p>La consulta SQL solo debe devolver una columna. Si la consulta devuelve varias columnas, solo se utiliza la primera columna en la b\00FAsqueda de filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100618441249305029)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100086874955304591)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>unistr('<pre>Vaca,Perro,Gato,Le\00F3n</pre>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100086784420304591)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una lista de valores delimitada por comas para esta lista est\00E1tica.</p>'),
unistr('        <p>Nota: Los valores est\00E1ticos siempre se muestran en el mismo orden en que se han especificado, no alfab\00E9ticamente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100086637752304591)
,p_name=>'PE.PROPERTY.IG_COLUMN_FILTER_STATIC_VALUES.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100082524060304588)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el grupo para esta columna. Los grupos se utilizan para asociar columnas en la cuadr\00EDcula y la vista de una sola fila.</p>'),
unistr('        <p>Nota: Los grupos se agregan ampliando la carpeta Atributos en el \00E1rbol Representaci\00F3n y para crear un nuevo grupo, haga clic con el bot\00F3n derecho en los grupos de columnas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100082469171304588)
,p_name=>'PE.PROPERTY.IG_COLUMN_GROUP.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Agrupar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100087008933304591)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de origen en el que est\00E1 basado el valor de esta columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100087126444304591)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100087225352304591)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de columna introducido en <em>Columna de Base de Datos</em>, obtenido mediante la consulta SQL de origen de la regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100087554201304591)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100087600212304592)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.NONE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor de columna no se recupera de ning\00FAn origen. Por ejemplo, las columnas APEX$ROW_SELECTOR y APEX$ROW_ACTION no tienen origen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100087371936304591)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100087424529304591)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.LOV.SQL_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde la <em>expresi\00F3n SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100086995714304591)
,p_name=>'PE.PROPERTY.IG_COLUMN_SOURCE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100079658591304585)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Compruebe qu\00E9 formatos de descarga pueden utilizar los usuarios para descargar las columnas mostradas actualmente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100079769183304585)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.CSV.D'
,p_message_language=>'es'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100079856363304585)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.HTML.D'
,p_message_language=>'es'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100237887064304744)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.PDF.D'
,p_message_language=>'es'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99523195724304158)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.LOV.XLSX.D'
,p_message_language=>'es'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100079540728304585)
,p_name=>'PE.PROPERTY.IG_DOWNLOAD_FORMATS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formatos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100081799039304587)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic en el destino de enlace para llamar a un cuadro de di\00E1logo modal. Puede introducir un destino personalizado al que llamar cuando se hace clic en el icono.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100081673048304587)
,p_name=>'PE.PROPERTY.IG_ICON_VIEW_LINK_TARGET.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Destino de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100077847507304584)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el tipo de paginaci\00F3n para este informe. A menudo no se muestran todas las filas del informe en el informe.'),
unistr('		Para incluir m\00E1s filas, el usuario final puede utilizar la paginaci\00F3n proporcionada.<p/>'),
unistr('		La paginaci\00F3n proporciona al usuario final informaci\00F3n sobre el n\00FAmero de filas mostradas y la posici\00F3n actual dentro del juego de resultados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100078053000304584)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.D'
,p_message_language=>'es'
,p_message_text=>'Desplazar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100206437236304720)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SCROLL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Inicialmente se muestran suficientes filas para rellenar la altura de la cuadr\00EDcula interactiva.'),
unistr('        A medida que el usuario final se desplaza, se muestran filas adicionales, obteniendo m\00E1s datos del servidor seg\00FAn sea necesario.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100077905062304584)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100206358971304720)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.LOV.SET.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se mostrar\00E1n las primeras filas, seg\00FAn el n\00FAmero especificado en <em>Filas por P\00E1gina</em>.'),
unistr('        Si hay filas adicionales, se agregar\00E1n controles al pie de p\00E1gina del informe, lo que permite a los usuarios finales navegar hacia delante y hacia atr\00E1s entre juegos de filas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100077730257304584)
,p_name=>'PE.PROPERTY.IG_PAGINATION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100747993589305129)
,p_name=>'PE.PROPERTY.IG_REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n de cuadr\00EDcula interactiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100541377692304971)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un alias para este informe guardado. Utilice este alias para definir un enlace URL m\00E1s significativo a este informe guardado espec\00EDfico. Este enlace se puede utilizar para enlazarse directamente desde cualquier lugar de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100540376592304970)
,p_name=>'PE.PROPERTY.IG_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100541437279304971)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Vea la categor\00EDa del informe guardado, la cual dicta el lugar en el que se muestra este informe en la lista de selecci\00F3n Informes. Este atributo es solo de visualizaci\00F3n y no se puede actualizar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100540573544304971)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.D'
,p_message_language=>'es'
,p_message_text=>'Alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100541006931304971)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.ALTERNATIVE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1os de informe siguientes que han guardado los desarrolladores y que pueden seleccionar los usuarios finales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100540489077304970)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.D'
,p_message_language=>'es'
,p_message_text=>'Primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100540957874304971)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIMARY.HELP'
,p_message_language=>'es'
,p_message_text=>'Informe que han guardado los desarrolladores y que se muestra por defecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100540701318304971)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'es'
,p_message_text=>'Privado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100541252124304971)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1os de informe que han guardado los usuarios finales y que solo puede seleccionar el usuario final que lo ha guardado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100540600568304971)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100541162978304971)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1os de informe que han guardado los usuarios finales y que pueden seleccionar el resto de usuarios finales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100540223928304970)
,p_name=>'PE.PROPERTY.IG_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Visibilidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100082736646304588)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione d\00F3nde se utilizar\00E1 el grupo para mostrar esta columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100082831510304588)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.D'
,p_message_language=>'es'
,p_message_text=>'Ambos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100082919526304588)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.BOTH.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El grupo se mostrar\00E1 en la cabecera del informe y en la vista de una sola fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100083234874304588)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.D'
,p_message_language=>'es'
,p_message_text=>'Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100083344675304588)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.HEADING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El grupo solo aparecer\00E1 en la cabecera del informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100083043841304588)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.D'
,p_message_language=>'es'
,p_message_text=>'Vista de Una Sola Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100083103654304588)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.LOV.SRV.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El grupo solo aparecer\00E1 en la vista de una sola fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100082683437304588)
,p_name=>'PE.PROPERTY.IG_USE_GROUP_FOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Usar Grupos para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99946395958304484)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca los atributos de etiqueta de imagen incluidos en el HTML de la imagen. Se puede utilizar para atributos como la altura, el ancho o el texto alternativo de imagen (si la imagen no es decorativa).</p>',
unistr('<p>Nota: si no se ha definido un texto alternativo en los atributos de etiqueta de imagen, &PRODUCT_NAME. establece por defecto que se presente la imagen como decorativa (por ejemplo, con una etiqueta alternativa vac\00EDa).</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99946237466304484)
,p_name=>'PE.PROPERTY.IMAGE_TAG_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atributos de Etiqueta de Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100215089464304726)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si esta columna se incluye cuando el informe se exporta a CSV o se imprime.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100214926801304726)
,p_name=>'PE.PROPERTY.INCLUDE_IN_EXPORT_PRINT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Incluir en Exportaci\00F3n/Impresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100726952364305114)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea que la lista de valores incluya una opci\00F3n NULL al comienzo de la lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100726894083305114)
,p_name=>'PE.PROPERTY.INCLUDE_NULL_OPTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Incluir opci\00F3n nula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100067443519304576)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifica si la pseudocolumna ROWID se debe seleccionar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100067344620304576)
,p_name=>'PE.PROPERTY.INCLUDE_ROWID_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Incluir columna ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100184859585304704)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se muestra una barra de b\00FAsqueda encima del informe. Si incluye la barra de b\00FAsqueda, tambi\00E9n puede personalizar completamente las funciones que se deben mostrar.</p>'),
unistr('La barra de b\00FAsqueda puede incluir los siguientes componentes:'),
'<dl>',
unistr('  <dt>Campo de B\00FAsqueda</dt>'),
unistr('    <dd>Muestra un campo de texto en la barra de b\00FAsqueda que se utiliza para introducir los criterios de b\00FAsqueda.</dd>'),
'  <dt>Lista Desplegable del Buscador</dt>',
unistr('    <dd>Embebida en el <em>campo de b\00FAsqueda</em>, muestra una lista desplegable de las columnas mostradas. Si se selecciona una columna, la b\00FAsqueda solo se realiza en los valores de la columna seleccionada.</dd>'),
unistr('  <dt>Lista de Selecci\00F3n de Informes</dt>'),
unistr('    <dd>Muestra una lista de todos los informes disponibles para el usuario, incluidos los informes principales, alternativos, p\00FAblicos y privados. Esta lista solo se muestra si el usuario puede acceder a otros informes adem\00E1s del principal.</dd>'),
unistr('  <dt>Selector de Filas por P\00E1gina</dt>'),
unistr('    <dd>Muestra una lista de selecci\00F3n que se utiliza para seleccionar el n\00FAmero de filas que se deben mostrar por p\00E1gina.</dd>'),
unistr('  <dt>Men\00FA Acciones</dt>'),
unistr('    <dd>Muestra el bot\00F3n del men\00FA Acciones, que incluye normalmente un juego completo de opciones. Estas opciones permiten al usuario final personalizar el informe seg\00FAn las funciones que tenga disponibles.</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100184749568304704)
,p_name=>'PE.PROPERTY.INCLUDE_SEARCH_BAR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Incluir Barra de B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99855657260304412)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>&PRODUCT_NAME. normalmente necesita determinados archivos JavaScript y CSS.',
unistr('En algunas aplicaciones, como las aplicaciones m\00F3viles, puede que no desee incluir estos archivos en la p\00E1gina.</p>'),
unistr('<p>Para incluir los archivos JavaScript y &PRODUCT_NAME. est\00E1ndar, seleccione <strong>Activado</strong>. Si selecciona <strong>Desactivado</strong>, se suprime la inclusi\00F3n de estos archivos en la cabecera HTML.</p>'),
unistr('<p>El hecho de no incluir estos archivos podr\00EDa traer consecuencias negativas a la aplicaci\00F3n y provocar da\00F1os.'),
unistr('Por tanto, la desactivaci\00F3n de este atributo se recomienda a desarrolladores avanzados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99855565476304411)
,p_name=>'PE.PROPERTY.INCLUDE_STANDARD_JAVASCRIPT_AND_CSS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Incluir JavaScript y CSS Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100477395100304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que contiene la posici\00F3n inicial del mapa como un objeto de punto GeoJSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100477297765304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100477181277304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna SDO_GEOMETRY que contiene la posici\00F3n inicial del mapa como un objeto de punto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100477036709304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_SDOGEOM_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Geometr\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100476363325304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Identifica el tipo de columna que usar para la posici\00F3n inicial del mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100476686663304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'es'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100476714011304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'es'
,p_message_text=>'Tipos de columna GeoJSON, como VARCHAR2 o CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100476825115304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'es'
,p_message_text=>'Longitud/latitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100476985258304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>'Longitud y latitud, como dos columnas NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100476481187304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'es'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100476508234304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'es'
,p_message_text=>'Tipo SDO_GEOMETRY de Oracle.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100476295337304923)
,p_name=>'PE.PROPERTY.INIT_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de dato de columna de geometr\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100475251056304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Si se va a centrar el mapa en la ubicaci\00F3n actual del explorador. Si est\00E1 activada, y el explorador puede acceder a la ubicaci\00F3n actual, esto tiene prioridad sobre la posici\00F3n inicial determinada en Valores est\00E1ticos, Consulta SQL o en funci\00F3n de ')
||unistr('la opci\00F3n Resultados espaciales, seg\00FAn la configuraci\00F3n anterior.</p><p>Esto solo se aplica en la carga de la primera p\00E1gina en una sesi\00F3n de APEX. Cuando se vuelve a visitar la p\00E1gina de mapa en la sesi\00F3n de APEX, el mapa se centrar\00E1 en su \00FAltima po')
||unistr('sici\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100475158960304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_FROM_BROWSER.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Obtener posici\00F3n del explorador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100477759284304924)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que contiene la latitud de la posici\00F3n inicial del mapa. El valor devuelto debe estar comprendido entre -90 y 90.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100477671817304924)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de latitud inicial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100475971378304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la latitud de la posici\00F3n inicial del mapa. Utilice valores entre -90 (Sur) y 90 (Norte), as\00ED como "." como car\00E1cter decimal. Ejemplo: <strong>45.5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100475841636304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_LAT_STATIC.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Latitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100477537298304923)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que contiene la longitud de la posici\00F3n inicial del mapa. El valor devuelto debe estar comprendido entre -180 y 180.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100477434468304923)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de longitud inicial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100475733785304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la longitud de la posici\00F3n inicial del mapa. Utilice valores entre -180 (Oeste) y 180 (Este), as\00ED como "." como car\00E1cter decimal. Ejemplo: <strong>100.5</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100475675559304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_LON_STATIC.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Longitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100475587959304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Consulta que devuelve columnas NUMBER para determinar la posici\00F3n inicial del mapa y el nivel de zoom:</p>'),
'<pre>',
'select -133.5 longitude,',
'         35.2 latitude,',
'            3 zoom',
'  from sys.dual',
'</pre>',
unistr('<p>Consulta que devuelve una columna SDO_GEOMETRY para determinar la posici\00F3n inicial del mapa y una columna NUMBER del nivel de zoom.</p>'),
'<pre>',
'select sdo_geometry( 2001,                                 -- 2 dimensional point',
'                     4326,                                 -- longitude/latitude (WGS84)',
'                     sdo_point_type( -133.5, 35.2, null ), -- concrete coordinates',
'                     null,                                 -- not used for points',
'                     null                                  -- not used for points',
'       )                   as geometry,',
'       3                   as zoom',
'  from sys.dual',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100475404550304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la consulta SQL para determinar la posici\00F3n inicial del mapa y el nivel de zoom.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100475394936304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_SOURCE_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100474491115304921)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el m\00E9todo para determinar la posici\00F3n inicial del mapa y el nivel de zoom para una nueva sesi\00F3n de APEX o tras una operaci\00F3n <strong>Borrar</strong> o <strong>Restablecer</strong> de una regi\00F3n de mapa. En una sesi\00F3n de APEX, la regi\00F3n de')
||unistr(' mapa memoriza la posici\00F3n actual y el nivel de zoom de las solicitudes de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100474908981304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.D'
,p_message_language=>'es'
,p_message_text=>'Basado en resultados espaciales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100475003209304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.QUERY_RESULTS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El mapa se colocar\00E1 de tal forma que se pueda ver el resultado de la consulta de la capa. <em>Tenga en cuenta que esto no est\00E1 soportado si se selecciona GeoJSON como tipo de columna de geometr\00EDa de capa</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100474771905304921)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100474805665304922)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Proporciona una consulta SQL que devuelve valores para la posici\00F3n inicial del mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100474524485304921)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100474613150304921)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.LOV.STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Proporciona valores est\00E1ticos para la posici\00F3n inicial del mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100474303406304921)
,p_name=>'PE.PROPERTY.INIT_POSITION_ZOOM_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100477983804304924)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna que contiene el nivel de zoom inicial. El valor devuelto debe estar comprendido entre 1 y 18.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100477884419304924)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de nivel de zoom inicial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100476106843304922)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique el nivel de zoom inicial. Utilice los valores enteros entre 1 y 18.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100476083240304922)
,p_name=>'PE.PROPERTY.INIT_ZOOMLEVEL_STATIC.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nivel de zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100363876263304838)
,p_name=>'PE.PROPERTY.INLINE_CSS.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Define la clase CSS <code>display_only</code> en negrita</dt>',
'<dd><pre>',
'.display_only {',
'  font-weight: bold;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99850519440304407)
,p_name=>'PE.PROPERTY.INLINE_CSS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo de la hoja de estilo en cascada (CSS) que se va a utilizar en esta p\00E1gina.'),
unistr('Si se necesita la misma CSS en varias p\00E1ginas, considere introducirlo en un archivo externo para evitar la duplicaci\00F3n y aprovechar el almacenamiento en cach\00E9 del explorador de los archivos est\00E1ticos.</p>'),
unistr('<p>El c\00F3digo que introduzca aqu\00ED sustituye a la cadena de sustituci\00F3n <code>#PAGE_CSS#</code> en la plantilla de p\00E1gina.</p>'),
unistr('<p>Nota: no es necesario incluir las etiquetas <code>style</code> de apertura o de cierre. Solo incluya el c\00F3digo de la hoja de estilo en cascada.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99850472783304407)
,p_name=>'PE.PROPERTY.INLINE_CSS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99858822543304414)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el mensaje de error que aparece cuando se produce un error en esta p\00E1gina. El mensaje de error se sustituye por <code>#NOTIFICATION_MESSAGE#</code> en la plantilla de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99858716824304414)
,p_name=>'PE.PROPERTY.INLINE_ERROR_NOTIFICATION_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Notificaci\00F3n de Error en L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100676879625305073)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto de ayuda en l\00EDnea para este elemento. El texto de ayuda se muestra inmediatamente con el elemento y se puede utilizar para proporcionar ayuda sensible al contexto al nivel de campo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100676798466305072)
,p_name=>'PE.PROPERTY.INLINE_HELP_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Ayuda en L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99942324492304481)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione a d\00F3nde se redirecciona &PRODUCT_NAME. si la sesi\00F3n no es v\00E1lida.'),
unistr('Esto sucede si la <strong>funci\00F3n de protecci\00F3n</strong> o la </strong>funci\00F3n de verificaci\00F3n</strong> devuelve FALSE en solicitudes de p\00E1ginas normales pero no en solicitudes Ajax.</p>'),
unistr('<p>Nota: Si se utiliza el tipo de esquema de autenticaci\00F3n </strong>''Personalizado''</strong>, tambi\00E9n se puede utilizar el atributo de </strong>''Funci\00F3n de Protecci\00F3n''</strong>en el esquema de autenticaci\00F3n.'),
unistr('Para los tipos de esquema de autenticaci\00F3n de plugin, lo define el desarrollador de plugins en la devoluci\00F3n de llamada de <strong>''nombre de funci\00F3n de protecci\00F3n de sesi\00F3n''</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100376850589304848)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n Incorporada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100376967387304848)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.BUILTIN_LOGIN.HELP'
,p_message_language=>'es'
,p_message_text=>'Redirige a la URL definida en <code>wwv_flow_custom_auth_std.login_page</code>, proporcionada por &PRODUCT_NAME..'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100376648895304848)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100376704678304848)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.LOGIN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Redirige a la URL de conexi\00F3n definida en los atributos de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100377073396304848)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.D'
,p_message_language=>'es'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100377170126304848)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.LOV.URL.HELP'
,p_message_language=>'es'
,p_message_text=>'Redirige a la URL que introduzca, como <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99942263307304480)
,p_name=>'PE.PROPERTY.INVALID_SESSION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Redireccionamiento de Sesi\00F3n No Valido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99942526285304481)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una URL a la que &PRODUCT_NAME. redireccione si la funci\00F3n de protecci\00F3n de sesi\00F3n devuelve FALSE. Normalmente ser\00E1 una URL a una p\00E1gina de conexi\00F3n o un portal de conexi\00F3n \00FAnica. Ejemplo: f?p=&amp;APP_ID.:101:&amp;SESSION')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99942488454304481)
,p_name=>'PE.PROPERTY.INVALID_SESSION_URL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('URL de Sesi\00F3n no V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100183586720304703)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de visualizaci\00F3n de columnas relevante para definir c\00F3mo se deben mostrar los valores de columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100383530034304853)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'es'
,p_message_text=>'Descargar BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100567803883304991)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra la columna como un enlace para descargar el archivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100383883021304853)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna Oculta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100568164833304991)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'No muestra la columna, pero se puede hacer referencia a ella.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100383428645304853)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.D'
,p_message_language=>'es'
,p_message_text=>'Mostrar Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100567764003304991)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra la columna como una imagen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100383396854304853)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.D'
,p_message_language=>'es'
,p_message_text=>'Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100567623613304991)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.LINK.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra la columna como un enlace.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100383607500304853)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico de Porcentaje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100567947312304991)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra la columna como un gr\00E1fico de porcentajes. El valor recuperado debe estar entre 0 y 100.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100383114498304853)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.D'
,p_message_language=>'es'
,p_message_text=>'Texto sin Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100567473977304991)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra el valor de columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100383241531304853)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'es'
,p_message_text=>'Texto sin Formato (Basado en Lista de Valores)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100567561182304991)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra el valor devuelto de la lista de valores especificados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100639944719305044)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Texto Enriquecido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100640007603305045)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.RICH_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'Representa la columna mediante HTML o Markdown.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100383731260304853)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.D'
,p_message_language=>'es'
,p_message_text=>'Eliminar HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100568040413304991)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.LOV.STRIP_HTML.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra el valor de columna despu\00E9s de eliminar las etiquetas HTML e identificar los caracteres especiales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100183412999304703)
,p_name=>'PE.PROPERTY.IR_COLUMN_DISPLAY_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100267734666304767)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Para devolver el nombre del departamento:</dt>',
'<dd><pre>select dname from dept order by 1</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100201838475304717)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca una consulta SQL que tenga que devolver una columna. Si la consulta devuelve varias columnas, solo se utiliza la primera columna en la lista de valores.</p>',
unistr('<p>La introducci\00F3n de una consulta SQL puede mejorar el rendimiento en algunos informes o se puede utilizar para limitar los valores mostrados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100201749738304717)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100321241798304807)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione una lista de valores con nombre definida. El filtro de columna utiliza solo la primera columna de la consulta de la lista de valores din\00E1mica o el valor de visualizaci\00F3n de la lista de valores est\00E1tica para filtrar los datos del informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100321132540304807)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_NAMED_LOV.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores con Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100182340126304702)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione c\00F3mo derivar los filtros proporcionados en la lista desplegable de columnas de informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100385372177304854)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'es'
,p_message_text=>'Utilice Lista de Valores con Nombre para Filtrar Coincidencia Exacta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100385460821304854)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'es'
,p_message_text=>'Deriva la lista de valores de la lista de valores con nombre para crear un filtro igual.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100385593071304855)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'es'
,p_message_text=>'Utilizar Lista de Valores con Nombre para Filtrar la Palabra Contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100385628305304855)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'es'
,p_message_text=>'Deriva la lista de valores de la lista de valores con nombre para crear un filtro "contiene".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100385105354304854)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'es'
,p_message_text=>'Utilizar Lista de Valores Definida para Filtrar la Palabra Contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100385286015304854)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'es'
,p_message_text=>'Deriva la lista de valores de una consulta SQL de lista de valores definida para crear un filtro "contiene".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100384707162304854)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto Basado en Tipo de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100384844593304854)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'es'
,p_message_text=>'Las columnas STRING y NUMBER derivan la lista de valores de valores de columna distintos. Las columnas DATE la derivan de rangos de fechas predefinidos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100384516922304854)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100384650171304854)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha proporcionado ning\00FAn filtro de columna para este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100384918145304854)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'es'
,p_message_text=>'Utilizar Lista de Valores Definida para Filtrar Coincidencia Exacta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100385063984304854)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'es'
,p_message_text=>'Deriva la lista de valores de una consulta SQL de lista de valores definida para crear un filtro de coincidencia igual.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100182294200304702)
,p_name=>'PE.PROPERTY.IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100183390055304703)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el grupo para esta columna. Los grupos se utilizan para mostrar las columnas en grupos l\00F3gicos en la vista de una sola fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100183270943304703)
,p_name=>'PE.PROPERTY.IR_COLUMN_GROUP.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Agrupar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100187204573304706)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione el tipo de columna de enlace para este informe.',
'Si selecciona la columna de enlace, se muestra siempre como primera columna del informe y el usuario no la puede ocultar.'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100387521936304856)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.D'
,p_message_language=>'es'
,p_message_text=>'Enlace a Destino Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100387661899304856)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.C.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Dirige al usuario final a otra p\00E1gina seg\00FAn la URL de destino que introduzca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100387796034304856)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Excluir Columna de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100387809925304856)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.N.HELP'
,p_message_language=>'es'
,p_message_text=>'No se muestra la columna de enlace.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100387334673304856)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>'Enlace a Vista de Una Sola Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100387421900304856)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.LOV.Y.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Dirige al usuario final a una p\00E1gina que muestra los valores de columna para la fila especificada. Los diferentes atributos de informe y columna rigen qu\00E9 columnas se muestran y c\00F3mo lo hacen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100187107308304706)
,p_name=>'PE.PROPERTY.IR_LINK_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100233889111304741)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.COMPONENT_PROPERTY.IR_ATTRIBUTES.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100185057681304704)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el tipo de paginaci\00F3n para este informe. A menudo una p\00E1gina solo muestra un determinado n\00FAmero de filas de un informe.'),
unistr('Para incluir m\00E1s filas, el usuario final de la aplicaci\00F3n debe navegar hasta la siguiente p\00E1gina del informe.<p/>'),
unistr('<p>La paginaci\00F3n proporciona al usuario final informaci\00F3n sobre el n\00FAmero de filas y la posici\00F3n actual dentro del juego de resultados.<p/>'),
unistr('<p>La paginaci\00F3n se puede mostrar encima o debajo del informe (o en ambos lugares) y se puede colocar a la izquierda o a la derecha.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100386363188304855)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y.D'
,p_message_language=>'es'
,p_message_text=>'Rangos de Fila X a Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100386247967304855)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.LOV.ROWS_X_TO_Y_OF_Z.D'
,p_message_language=>'es'
,p_message_text=>'Rangos de Fila X a Y de Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100184912109304704)
,p_name=>'PE.PROPERTY.IR_PAGINATION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100199556602304715)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un alias para este informe guardado. Utilice este alias para definir un enlace URL m\00E1s significativo a este informe guardado espec\00EDfico. Este enlace se puede utilizar para enlazarse directamente desde cualquier lugar de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100199462598304715)
,p_name=>'PE.PROPERTY.IR_SAVED_REPORT_ALIAS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100199909119304715)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Vea la categor\00EDa del informe guardado, la cual dicta el lugar en el que se muestra este informe en la lista de selecci\00F3n Informes. Este atributo es solo de visualizaci\00F3n y no se puede actualizar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100389958380304858)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.D'
,p_message_language=>'es'
,p_message_text=>'Por Defecto Alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100568314260304991)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.ALTERNATIVE_DEFAULT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1os de informe siguientes que han guardado los desarrolladores y que pueden seleccionar los usuarios finales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100389884081304858)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.D'
,p_message_language=>'es'
,p_message_text=>'Por Defecto Primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100568279714304991)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIMARY_DEFAULT.HELP'
,p_message_language=>'es'
,p_message_text=>'Informe que han guardado los desarrolladores y que se muestra por defecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100390165856304858)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.D'
,p_message_language=>'es'
,p_message_text=>'Privado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100568594317304991)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PRIVATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1os de informe que han guardado los usuarios finales y que solo puede seleccionar el usuario final que lo ha guardado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100390034985304858)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100568494365304991)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.LOV.PUBLIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1os de informe que han guardado los usuarios finales y que pueden seleccionar el resto de usuarios finales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100199893912304715)
,p_name=>'PE.PROPERTY.IR_SAVED_VISIBILITY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Visibilidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100033839955304550)
,p_name=>'PE.PROPERTY.IS_EDITABLE.COMPONENT_PROPERTY.REGION_PLUGIN_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si los usuarios finales pueden editar esta regi\00F3n de pantalla.</p>'),
unistr('        <p>Nota: Si la regi\00F3n de pantalla se puede editar, se crea autom\00E1ticamente un proceso para procesar la fila.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100074704067304581)
,p_name=>'PE.PROPERTY.IS_EDITABLE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si los usuarios finales pueden editar esta cuadr\00EDcula interactiva.</p>'),
unistr('        <p>Nota: Si la cuadr\00EDcula interactiva se puede editar, se crea autom\00E1ticamente un proceso para procesar las filas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100074618744304581)
,p_name=>'PE.PROPERTY.IS_EDITABLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100672656257305069)
,p_name=>'PE.PROPERTY.IS_GLOBAL_PAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Es P\00E1gina Global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100088483048304592)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si la columna es uno de los valores de clave primaria para las tablas subyacentes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100088355211304592)
,p_name=>'PE.PROPERTY.IS_PRIMARY_KEY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clave Primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100088244655304592)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique si desea excluir la columna de las operaciones DML.</p>',
unistr('        <p>Si se define en <strong>Activado</strong>, &PRODUCT_NAME. no utilizar\00E1 la columna al ejecutar la cuadr\00EDcula interactiva: Procesamiento de filas autom\00E1tico (DML)'),
unistr('        Por ejemplo, debe excluir las columnas cuyas definiciones incluyen concatenaciones, selecciones internas, llamadas de funci\00F3n o una columna en una vista que se puede actualizar y est\00E1 basada en una expresi\00F3n.</p>'),
unistr('        <p>Todas las columnas que se deben incluir en cualquier sentencia INSERT o UPDATE deben tener esta opci\00F3n definida en <strong>Desactivado</strong>.</p>'),
unistr('        <p>Nota: Las columnas de tipo <em>Solo Visualizaci\00F3n</em> <u>tambi\00E9n</u> se incluyen en el procesamiento de fila autom\00E1tico a menos que esta opci\00F3n se defina en <strong>Activado</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100088193146304592)
,p_name=>'PE.PROPERTY.IS_QUERY_ONLY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo Consulta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100169268375304692)
,p_name=>'PE.PROPERTY.IS_STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el par\00E1metro solo se puede definir una vez con un valor est\00E1tico o si se puede sustituir en el nivel de componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100169125024304692)
,p_name=>'PE.PROPERTY.IS_STATIC.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100520980001304956)
,p_name=>'PE.PROPERTY.IS_VISIBLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se debe mostrar u ocultar esta columna. Se puede hacer referencia a las columnas incluso cuando est\00E1n ocultas mediante la sintaxis de sustituci\00F3n <code>&amp;COLUMN_NAME.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100520890776304956)
,p_name=>'PE.PROPERTY.IS_VISIBLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100061385046304571)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor alto en este gr\00E1fico. Si no se selecciona ninguna columna, el valor m\00E1s alto del gr\00E1fico de \00E1reas se basar\00E1 en el juego de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100061190120304571)
,p_name=>'PE.PROPERTY.ITEMS_BOX_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100061279129304571)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor bajo en este gr\00E1fico. Si no se selecciona ninguna columna, el valor m\00E1s bajo del gr\00E1fico de \00E1reas se basar\00E1 en el juego de datos. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100061016917304571)
,p_name=>'PE.PROPERTY.ITEMS_BOX_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Bajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100136210678304668)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor de cierre en este gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100136150789304667)
,p_name=>'PE.PROPERTY.ITEMS_CLOSE_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100135812593304667)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor alto en este gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100135790649304667)
,p_name=>'PE.PROPERTY.ITEMS_HIGH_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100137856029304669)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir las etiquetas del eje x en el grafico. Para un gr\00E1fico de acciones burs\00E1tiles, la columna debe ser de tipo Fecha/Registro de Hora para representar la informaci\00F3n de las acciones en un eje ')
||'de tiempo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100137732316304669)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99967064257304499)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.COMPONENT_PROPERTY.JET_CHART_SERIES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'font-size:14px;color:white;</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100143296620304673)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca una cadena de estilo de CSS que defina el estilo de las etiquetas de este gr\00E1fico.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100143138350304673)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo de CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100167459632304691)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para la serie del rango, si se proporciona una matriz de dos valores, el primer y el segundo valor se aplicar\00E1n al punto bajo y alto respectivamente. El valor <strong>Porci\00F3n exterior</strong> solo se aplica a gr\00E1ficos de tarta.'),
unistr('        Los valores <strong>Encima del marcador</strong>, <strong>Debajo del marcador</strong>, <strong>Delante del marcador</strong> y <strong>Detr\00E1s del marcador</strong> solo se aplican a las series de l\00EDneas, \00E1reas, dispersi\00F3n y burbujas. Los val')
||'ores <strong>Dentro del borde de la barra</strong> y <strong>Fuera del borde de la barra</strong>',
unistr('        solo se aplican a series de barras no polares. Las barras apiladas no soportan la opci\00F3n <strong>Fuera del borde de la barra</strong>. El valor <strong>Inicio</strong> solo se aplica a los gr\00E1ficos del indicador de estado vertical. El gr\00E1fico')
||unistr(' no ajusta actualmente el dise\00F1o para que quepan etiquetas dentro del \00E1rea de datos ni gestiona las superposiciones entre etiquetas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100142232114304672)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la posici\00F3n de las etiquetas que se van a presentar en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100142422221304672)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.ABOVEMARKER.D'
,p_message_language=>'es'
,p_message_text=>'Encima del Marcador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100142730597304672)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AFTERMARKER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Detr\00E1s del Marcador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100143053238304673)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100142600851304672)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BEFOREMARKER.D'
,p_message_language=>'es'
,p_message_text=>'Delante del Marcador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100142570146304672)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.BELOWMARKER.D'
,p_message_language=>'es'
,p_message_text=>'Debajo del Marcador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100142381890304672)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.CENTER.D'
,p_message_language=>'es'
,p_message_text=>'Centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100142871647304673)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.INSIDEBAREDGE.D'
,p_message_language=>'es'
,p_message_text=>'Dentro del Borde de la Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100166812354304691)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100142972697304673)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDEBAREDGE.D'
,p_message_language=>'es'
,p_message_text=>'Fuera del Borde de la Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100166715748304691)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.OUTSIDESLICE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Porci\00F3n Exterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99602664522304221)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.LOV.START.D'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100142154714304672)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100142036061304672)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se deben presentar las etiquetas en el gr\00E1fico. Este valor se aplica a la visibilidad del valor de m\00E9trica en un gr\00E1fico de dial. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100141952627304672)
,p_name=>'PE.PROPERTY.ITEMS_LABEL_RENDERED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100135675688304667)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor bajo en este gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100135542230304667)
,p_name=>'PE.PROPERTY.ITEMS_LOW_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Bajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100137209235304668)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor m\00E1ximo en este gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100137151190304668)
,p_name=>'PE.PROPERTY.ITEMS_MAX_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100239174431304745)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor m\00EDnimo en este gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100239052173304745)
,p_name=>'PE.PROPERTY.ITEMS_MIN_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100136030312304667)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor de apertura en este gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100135980602304667)
,p_name=>'PE.PROPERTY.ITEMS_OPEN_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Abrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100138085109304669)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para una ayuda de burbuja personalizada que sea corta y descriptiva en los puntos de datos del gr\00E1fico. Para representar una ayuda de burbuja en puntos de datos del gr\00E1fico, aseg\00FArese de que el atribut')
||unistr('o de pista de gr\00E1fico <strong>Mostrar</strong> est\00E1 definido en <strong>Activado</strong>. En el caso de un gr\00E1fico de \00E1reas, la columna no debe coincidir con la asignaci\00F3n de la columna Valor seleccionada. La selecci\00F3n de una columna que coincida co')
||unistr('n la asignaci\00F3n de la columna Valor resultar\00E1 en que no se represente ninguna ayuda de burbuja personalizada en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100137971612304669)
,p_name=>'PE.PROPERTY.ITEMS_SHORT_DESC_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Pista Personalizada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100137011341304668)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor de destino en este gr\00E1fico. Cuando est\00E1 definido, el atributo de valor define el \00E1rea rellenada dentro de la porci\00F3n y esto representa el valor de toda la porci\00F3n. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100136907065304668)
,p_name=>'PE.PROPERTY.ITEMS_TARGET_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor de Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100135460176304667)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor en este gr\00E1fico. En un diagrama de \00E1reas, esta columna se utilizar\00E1 para definir los valores m\00EDnimos, m\00E1ximos, de medianas y cuartiles de grupos de datos num\00E9ricos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100135378474304667)
,p_name=>'PE.PROPERTY.ITEMS_VALUE_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100136481439304668)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor de volumen en este gr\00E1fico. Cuando se proporcionan valores, el volumen se muestra en el eje y2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100136365750304668)
,p_name=>'PE.PROPERTY.ITEMS_VOLUME_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Volumen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100136609001304668)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor x en este gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100136563116304668)
,p_name=>'PE.PROPERTY.ITEMS_X_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100136800005304668)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor y en este gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100136788197304668)
,p_name=>'PE.PROPERTY.ITEMS_Y_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100134216486304666)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el valor z en este gr\00E1fico. El valor z define el radio de burbuja para un gr\00E1fico de burbuja, el ancho del elemento de diagrama de \00E1reas y el ancho de barra para un gr\00E1fico de barras o de ')
||unistr('combinaci\00F3n. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100134155001304666)
,p_name=>'PE.PROPERTY.ITEMS_Z_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Z'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99945787656304483)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione si los componentes de la regi\00F3n (subregiones, elementos, botones) se muestran por encima o debajo del contenido de regi\00F3n principal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100377972073304849)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.ABOVE.D'
,p_message_language=>'es'
,p_message_text=>'Sobre el Contenido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100378087700304849)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.LOV.BELOW.D'
,p_message_language=>'es'
,p_message_text=>'Bajo el Contenido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99945669404304483)
,p_name=>'PE.PROPERTY.ITEM_DISPLAY_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Presentar componentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99880379797304431)
,p_name=>'PE.PROPERTY.ITEM_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de este elemento. Los nombres de elementos deben ser identificadores de Oracle v\00E1lidos. Se recomienda que los nombres de elementos no excedan los 30 bytes para que se puedan utilizar como variables de enlace en consultas SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99880253024304431)
,p_name=>'PE.PROPERTY.ITEM_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100091665198304595)
,p_name=>'PE.PROPERTY.ITEM_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione c\00F3mo se debe representar esta columna. Est\00E1n soportados los siguientes tipos de columna:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>En funci\00F3n de la configuraci\00F3n de la aplicaci\00F3n, puede disponer tambi\00E9n aqu\00ED de plugins de tipo de columna adicionales.'),
'Se muestran como <em>&lt;Mi Plugin&gt; [Plug-in]</em>.',
unistr('Los siguientes plugins est\00E1n instalados en los componentes compartidos de esta aplicaci\00F3n:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99879978146304431)
,p_name=>'PE.PROPERTY.ITEM_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique c\00F3mo se presenta este elemento. Est\00E1n soportados los siguientes tipos de elementos:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>Seg\00FAn se haya configurado la aplicaci\00F3n, aqu\00ED podr\00E1 tener plugins adicionales disponibles de tipos de elementos.'),
unistr('\00C9stos de muestran como <em>&lt;Mi Plugin&gt; [Plug-in]</em>.'),
unistr('Los siguientes plugins se instalan en los componentes compartidos de esta aplicaci\00F3n:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99879810131304431)
,p_name=>'PE.PROPERTY.ITEM_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100539340932304970)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor por Defecto de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100560427960304985)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Incluya el elemento en la comprobaci\00F3n de cambios sin guardar si la comprobaci\00F3n est\00E1 activada a nivel de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100538809703304969)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el elemento de p\00E1gina se incluye en la comprobaci\00F3n de cambios sin guardar, que advierte al usuario cuando intenta salir de la p\00E1gina y no se han guardado los cambios. Puede que no sea necesario comprobar algunos elementos (por ejemplo')
||unistr(', si no est\00E1n basados en una columna de base de datos, como un elemento de b\00FAsqueda), por lo que puede configurar el valor para que se ignore.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100538999354304969)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.D'
,p_message_language=>'es'
,p_message_text=>'Ignorar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100541774097304971)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.LOV.I.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los cambios en el elemento se ignoran en la comprobaci\00F3n de cambios sin guardar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100538731603304969)
,p_name=>'PE.PROPERTY.ITEM_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Advertencia sobre Cambios sin Guardar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100683655847305081)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.toolbar = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100102156118304603)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una funci\00F3n JavaScript que tome un objeto de configuraci\00F3n de la cuadr\00EDcula interactiva, modifique el objeto y lo devuelva. Esto permite una personalizaci\00F3n avanzada de la apariencia, las funciones y el comportamiento, incluida la barra de')
||unistr(' herramientas, los men\00FAs y las acciones de la cuadr\00EDcula interactiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100683743205305081)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.features = options.features || {};',
'    options.features.sort = false;',
'    return options;',
'}',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100238498048304744)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una funci\00F3n JavaScript que tome un objeto de configuraci\00F3n para la columna, modifique el objeto y lo devuelva. Esto permite una personalizaci\00F3n avanzada de la apariencia, las funciones y el comportamiento de la columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100683862303305081)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ){',
unistr('    // Configura una funci\00F3n de devoluci\00F3n de llamada que se llama al recuperar datos. Permite manipular la serie'),
'    options.dataFilter = function( data ) {',
'        data.series[ 0 ].color = "#00FF00";',
'        return data;',
'    };',
unistr('    // Define las opciones de inicializaci\00F3n del gr\00E1fico'),
'    options.type = "line";',
'    return options;',
'}</pre>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100147812149304676)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca un c\00F3digo JavaScript para personalizar el gr\00E1fico.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100684463298305082)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'  options.advancedOption = true;',
'  return options;',
'}',
'</pre>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100082111103304587)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca una funci\00F3n JavaScript que tome un objeto de configuraci\00F3n del componente, modifique el objeto y lo devuelva. Esto permite una personalizaci\00F3n avanzada de la apariencia, las funciones y el comportamiento del componente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100082039316304587)
,p_name=>'PE.PROPERTY.JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo JavaScript de inicializaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100453157837304906)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la posici\00F3n de los ejes superior e inferior del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100453876742304906)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.BOTTOM.D'
,p_message_language=>'es'
,p_message_text=>'Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100453739721304906)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.LOV.TOP.D'
,p_message_language=>'es'
,p_message_text=>'Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100453002955304906)
,p_name=>'PE.PROPERTY.JET_AXIS_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n del eje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100456664506304909)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la escala temporal que se va a utilizar para el eje en el gr\00E1fico. Es necesario para representar el Gantt correctamente. La escala temporal seleccionada se utilizar\00E1 para realizar el zoom si no se selecciona ninguna opci\00F3n de escala de zo')
||'om.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100454799116304907)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.DAYS.D'
,p_message_language=>'es'
,p_message_text=>unistr('D\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100454680027304907)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.HOURS.D'
,p_message_language=>'es'
,p_message_text=>'Horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100454328305304907)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MINUTES.D'
,p_message_language=>'es'
,p_message_text=>'Minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100455107085304907)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.MONTHS.D'
,p_message_language=>'es'
,p_message_text=>'Meses'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100455382963304908)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.QUARTERS.D'
,p_message_language=>'es'
,p_message_text=>'Trimestres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100454282310304907)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.SECONDS.D'
,p_message_language=>'es'
,p_message_text=>'Segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100454908838304907)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.WEEKS.D'
,p_message_language=>'es'
,p_message_text=>'Semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100455522674304908)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.LOV.YEARS.D'
,p_message_language=>'es'
,p_message_text=>unistr('A\00F1os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100456534968304908)
,p_name=>'PE.PROPERTY.JET_AXIS_SCALE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Escala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100122875901304657)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de gr\00E1fico. El tipo de gr\00E1fico determina la visualizaci\00F3n utilizada para representar el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100122948601304657)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100263621965304764)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.AREA.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de \00E1reas resultan \00FAtiles para comparar tendencias de valores acumulados en el tiempo, como desgloses de las tendencias de ventas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100123099299304658)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.D'
,p_message_language=>'es'
,p_message_text=>'Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100263762984304764)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BAR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de barras resultan \00FAtiles para comparar valores entre las categor\00EDas o en el tiempo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100044525806304558)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.D'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1reas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100044671352304558)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BOXPLOT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de \00E1reas son \00FAtiles para analizar la distribuci\00F3n de datos, visualizar los valores m\00EDnimos, m\00E1ximos, de medianas y cuartiles de grupos de datos num\00E9ricos. Las \00E1reas tambi\00E9n se conocen como diagramas de \00E1reas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100123133075304658)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.D'
,p_message_language=>'es'
,p_message_text=>'Burbuja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100263849136304764)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.BUBBLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de burbujas definen los elementos de datos mediante los valores x, y, z, lo que los hace \00FAtiles para ver las relaciones entre 3 dimensiones. La tercera dimensi\00F3n la representa el tama\00F1o de la burbuja.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100123218904304658)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Combinaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100263902500304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.COMBO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de combinaci\00F3n permiten que las series de barras, l\00EDneas y \00E1reas aparezca en el mismo gr\00E1fico. Los casos de uso m\00E1s comunes son l\00EDneas con barras o l\00EDneas con barras apiladas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100123362887304658)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.D'
,p_message_language=>'es'
,p_message_text=>'Indicador de Estado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100264004063304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DIAL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los indicadores de estado se utilizan para mostrar un valor de m\00E9trica en relaci\00F3n con los valores posibles m\00EDnimos y m\00E1ximos de dicha m\00E9trica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100158444709304684)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.D'
,p_message_language=>'es'
,p_message_text=>'Anillo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100264177995304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.DONUT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de anillo son un gr\00E1fico de tarta con un agujero en el medio. Son \00FAtiles para visualizar partes de un todo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100123456112304658)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.D'
,p_message_language=>'es'
,p_message_text=>'Embudo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100264279417304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.FUNNEL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de embudo son \00FAtiles para ver los datos de las etapas de un proceso, como las etapas de un proceso de ventas. El \00E1rea de una porci\00F3n de embudo es proporcional al valor de la etapa correspondiente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100453551331304906)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.D'
,p_message_language=>'es'
,p_message_text=>'Gantt'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100453654977304906)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.GANTT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de Gantt son \00FAtiles para mostrar las programaciones del proyecto y las barras que indican la fecha de inicio y finalizaci\00F3n de las tareas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100123570319304658)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100264359692304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de l\00EDneas son \00FAtiles para visualizar tendencias en un juego de valores en el tiempo y comparar estos valores en la serie.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100123684156304658)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea con \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100264430728304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.LINEWITHAREA.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de l\00EDneas con \00E1reas son igual que los gr\00E1ficos de l\00EDneas, con el \00E1rea debajo de cada l\00EDnea rellena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100123780727304658)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.D'
,p_message_language=>'es'
,p_message_text=>'Tarta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100264501321304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PIE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de tarta son \00FAtiles para visualizar las partes de un todo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100158128499304684)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.D'
,p_message_language=>'es'
,p_message_text=>'Polar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100264628006304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.POLAR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos polares tiene un eje y de radial y un eje x tangencial. Los gr\00E1ficos polares se pueden representar como tipo de series de gr\00E1ficos de barras, l\00EDneas, \00E1reas, combinaci\00F3n, dispersi\00F3n o burbujas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99957127412304492)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.D'
,p_message_language=>'es'
,p_message_text=>unistr('Pir\00E1mide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99957264957304492)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.PYRAMID.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de pir\00E1mides son \00FAtiles para visualizar relaciones de base, proporcionalidad y jer\00E1rquicas, pasos de procesos, capas organizativas o conexiones entre temas. El \00E1rea de una porci\00F3n de pir\00E1mide es proporcional a su valor para la etapa corr')
||'espondiente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100158288845304684)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.D'
,p_message_language=>'es'
,p_message_text=>'Radial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100264714947304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RADAR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos radiales son gr\00E1ficos polares con una forma de cuadr\00EDcula poligonal, en lugar de un c\00EDrculo envolvente. Est\00E1n soportados para tipos de serie de gr\00E1fico de l\00EDneas y \00E1reas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100158317410304684)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.D'
,p_message_language=>'es'
,p_message_text=>'Rango'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100264856646304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.RANGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de rango muestran valones m\00E1ximos y m\00EDnimos (superiores/inferiores) para cada entrada, mediante barras o \00E1reas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100123847537304658)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Dispersi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100264951057304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.SCATTER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de dispersi\00F3n definen los elementos de datos mediante valores x e y, lo que los hace \00FAtiles para ver las relaciones entre 2 dimensiones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100123980942304658)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.D'
,p_message_language=>'es'
,p_message_text=>'Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100265077921304765)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.LOV.STOCK.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los gr\00E1ficos de valores son \00FAtiles para mostrar informaci\00F3n sobre las acciones en un eje de tiempo. La propiedad <strong>Representaci\00F3n de Acciones como</strong> de vela es exclusiva de los gr\00E1ficos de valores, que permite mostrar informaci\00F3n abierta')
||', cerrada, superior, inferior para el precio de las acciones.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100122755493304657)
,p_name=>'PE.PROPERTY.JET_CHART_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100061529001304571)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si los espacios del gr\00E1fico de varias series se deben definir en un valor cero o nulo.</p>'),
unistr('        <p>Si se define en <strong>Activado</strong>, los espacios de los datos se manejan como ceros. En el caso de un gr\00E1fico de l\00EDneas, esto garantizar\00E1 que la l\00EDnea se presente como una l\00EDnea continua. En el caso de un gr\00E1fico de barras apiladas ')
||unistr('con la etiqueta de pila definida en Activado, esto garantizar\00E1 que la etiqueta de pila se presente para cada pila.</p>'),
unistr('        <p>Si se define en <strong>Desactivado</strong>, los espacios de datos se manejan como valores nulos. En el caso de un gr\00E1fico de l\00EDneas, la l\00EDnea se representar\00E1 como una l\00EDnea discontinua, con espacios que representan los puntos de datos nu')
||'los.<p>',
unistr('        <p>Este ajuste se aplicar\00E1 a los tipos de gr\00E1ficos de varias series en los que est\00E9 soportada la presentaci\00F3n con barras y l\00EDneas, como L\00EDnea, L\00EDnea con \00E1rea, Combinaci\00F3n, \00C1rea, Polar, Radial y Dispersi\00F3n. El valor por defecto es <strong>Acti')
||'vado</strong>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100061469579304571)
,p_name=>'PE.PROPERTY.JET_CONNECT_NULLS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Presentar intervalo como cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100125860803304660)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione si el cursor de datos est\00E1 activado en el gr\00E1fico.'),
unistr('        El cursor de datos es una alternativa \00FAtil a las ayudas de burbuja cuando es dif\00EDcil navegar hasta los elementos de datos, especialmente en los dispositivos t\00E1ctiles.'),
unistr('        <p/>Si se define en <strong>Autom\00E1tico</strong>, el cursor de datos solo se muestra para gr\00E1ficos de l\00EDneas o \00E1reas en dispositivos t\00E1ctiles.<p/>.<p/>'),
unistr('        <p>Nota: El cursor de datos no se muestra cuando la ayuda de burbuja es nula y no est\00E1 soportada en gr\00E1ficos polares.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100125936168304660)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100265443711304766)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.AUTO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplique la visualizaci\00F3n del cursor de datos por defecto definido por Oracle JET para el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100126177517304660)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.D'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100265617737304766)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.OFF.HELP'
,p_message_language=>'es'
,p_message_text=>'El cursor de datos no se muestra.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100126081223304660)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.D'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100265548861304766)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.LOV.ON.HELP'
,p_message_language=>'es'
,p_message_text=>'El cursor de datos siempre se muestra.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100125731902304660)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Cursor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100126387544304660)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el comportamiento del cursor de datos en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100126495184304660)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100255963651304758)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.AUTO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplique el comportamiento del cursor de datos por defecto definido por Oracle JET para el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100126584851304660)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.D'
,p_message_language=>'es'
,p_message_text=>'Nivelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100265700484304766)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SMOOTH.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El cursor de datos sigue el movimiento del rat\00F3n/t\00E1ctil, mostrando la pista siempre que el cursor de datos pase por cualquier parte de un elemento de datos y no solo por puntos de datos espec\00EDficos. Un indicador identifica el elemento de datos sel')
||'eccionado actualmente.</p>',
unistr('        <p>Nota: Defina <strong>Cursor</strong> en <strong>S\00ED</strong> para que esta visualizaci\00F3n funciones completamente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100126685204304660)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.D'
,p_message_language=>'es'
,p_message_text=>'Ajustar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100265895146304766)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.LOV.SNAP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El cursor de datos ajusta (salta) al elemento de datos cuando se produce un movimiento del rat\00F3n/t\00E1ctil sobre el gr\00E1fico, mostrando la pista siempre que el cursor de datos pase por un elemento de datos. Un indicador identifica el elemento de datos')
||' seleccionado actualmente.</p>',
unistr('        <p>Nota: Defina <strong>Cursor</strong> en <strong>S\00ED</strong> para que esta visualizaci\00F3n funciones completamente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100126217966304660)
,p_name=>'PE.PROPERTY.JET_DATA_CURSOR_BEHAVIOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Comportamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99976138040304506)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si los espacios de los datos de gr\00E1fico de varias series se deben rellenar autom\00E1ticamente. Este ajuste no se aplica a gr\00E1ficos de una sola serie ni a los siguientes tipos de gr\00E1fico: Burbuja, Anillo, Embudo, Gantt, Tarta, Pir\00E1mide, Dispe')
||unistr('rsi\00F3n y Valores. Si se define en <strong>Activado</strong>, la l\00F3gica de densificaci\00F3n de datos introducida en Oracle Application Express 5.1.3 se aplicar\00E1 a los datos de gr\00E1fico. Si se define en <strong>Desactivado</strong>, los espacios de los dato')
||unistr('s no se rellenar\00E1n y esto puede hacer que la presentaci\00F3n del gr\00E1fico no sea precisa. El valor por defecto es <strong>Activado</strong>.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99976069273304506)
,p_name=>'PE.PROPERTY.JET_FILL_GAPS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Rellenar espacios en datos de gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100690049923305086)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca las clases de CSS que se aplicar\00E1n a barras de l\00EDnea base en el gr\00E1fico de Gantt. Puede agregar varias clases separ\00E1ndolas con espacios. Puede utilizar sustituciones de <code>&COLUMN_VALUE.</code>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100689971891305086)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_CSS_CLASS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Clases CSS de l\00EDnea base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100460254890304911)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna a utilizar para definir la fecha de finalizaci\00F3n de l\00EDnea base en el gr\00E1fico de Gantt. Una fecha de finalizaci\00F3n de l\00EDnea base es la fecha de finalizaci\00F3n originalmente planificada de la tarea.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100460195393304911)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_END_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de inicio de l\00EDnea base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100460027443304911)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna a utilizar para definir la fecha de inicio de l\00EDnea base en el gr\00E1fico de Gantt. Una fecha de inicio de l\00EDnea base es la fecha de inicio originalmente planificada de la tarea.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100459900093304911)
,p_name=>'PE.PROPERTY.JET_GANTT_BASELINE_START_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de inicio de l\00EDnea base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100458480535304910)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la fecha de finalizaci\00F3n del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100458364685304910)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Fecha de Finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100458698188304910)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el elemento de la aplicaci\00F3n o la p\00E1gina que se utilizar\00E1 para definir la fecha de finalizaci\00F3n del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100458583637304910)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de Fecha de Finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100457666566304909)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el origen a utilizar para definir la fecha de finalizaci\00F3n del gr\00E1fico de Gantt. Se necesita una fecha de finalizaci\00F3n para representar el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100457884662304909)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100457998134304909)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de la columna introducido en <em>Columna de fecha de finalizaci\00F3n</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100458107442304910)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100458295049304910)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de estado de sesi\00F3n del <em>elemento de fecha de finalizaci\00F3n</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100457760882304909)
,p_name=>'PE.PROPERTY.JET_GANTT_END_DATE_SOURCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de origen de fecha de finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100460419198304911)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que utilizar para definir el progreso de tarea del gr\00E1fico de Gantt. El valor del progreso debe estar entre 0 y 1. Si el valor no es v\00E1lido, no se mostrar\00E1 el progreso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100460306923304911)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Progreso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100689898392305086)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca las clases de CSS que se aplicar\00E1n a barras de progreso en el gr\00E1fico de Gantt. Puede agregar varias clases separ\00E1ndolas con espacios. Puede utilizar sustituciones de <code>&COLUMN_VALUE.</code>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100689725094305086)
,p_name=>'PE.PROPERTY.JET_GANTT_PROGRESS_CSS_CLASS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de progreso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100458822784304910)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la fecha de inicio del gr\00E1fico de Gantt. Es necesario introducir un ID de fila para representar varias tareas por fila. Si no se define ninguna asignaci\00F3n de columna de ID de fila, cada ta')
||'rea se representa como una sola tarea por fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100458786626304910)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_ID.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Identificador de Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100459000770304910)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el nombre de fila del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100458951181304910)
,p_name=>'PE.PROPERTY.JET_GANTT_ROW_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre de fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100457546888304909)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la fecha de inicio del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100457457237304909)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Fecha de Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100467048016304916)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el elemento de la aplicaci\00F3n o la p\00E1gina que se utilizar\00E1 para definir la fecha de inicio del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100458046531304910)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento de Fecha de Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100454000111304907)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el origen a utilizar para definir la fecha de inicio del gr\00E1fico de Gantt. Se necesita una fecha de inicio para representar el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100456848125304909)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100456914511304909)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de columna introducido en <em>Columna de fecha de inicio</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100457048648304909)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100457168436304909)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de estado de sesi\00F3n del <em>elemento de fecha de inicio</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100453928595304906)
,p_name=>'PE.PROPERTY.JET_GANTT_START_DATE_SOURCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de origen de fecha de inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100689666295305086)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca las clases de CSS que se aplicar\00E1n a barras de tareas en el gr\00E1fico de Gantt. Puede agregar varias clases separ\00E1ndolas con espacios. Puede utilizar sustituciones de <code>&COLUMN_VALUE.</code>.</p>')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100689576446305085)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_CSS_CLASS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de tareas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100459895738304911)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la fecha de finalizaci\00F3n de tarea del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100459701054304911)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_END_DATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de finalizaci\00F3n de tarea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100459233906304910)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir el ID de tarea del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100459145546304910)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_ID.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Identificador de Tarea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100459482488304911)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que utilizar para definir el nombre de tarea en el gr\00E1fico de Gantt. Si no se define ninguna asignaci\00F3n de columna de nombre de fila, el nombre de tarea se utilizar\00E1 como etiqueta de fila en el eje de filas del gr\00E1fico')
||'. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100459332094304911)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre de la Tarea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100459627295304911)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la fecha de inicio de tarea del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100459541289304911)
,p_name=>'PE.PROPERTY.JET_GANTT_TASK_START_DATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Fecha de inicio de tarea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100670298793305068)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la fecha de finalizaci\00F3n de ventanilla del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100665273020305064)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Fecha de Finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100670383575305068)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el elemento de la aplicaci\00F3n o la p\00E1gina que se utiliza para definir la fecha de finalizaci\00F3n de ventanilla del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100665068710305064)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de Fecha de Finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100669946452305067)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el origen que utilizar para definir la fecha de finalizaci\00F3n de la ventanilla del gr\00E1fico de Gantt. Una ventanilla es un rango de fechas que, al definirse, puede controlar la realizaci\00F3n de zoom inicial del gr\00E1fico al representarlo. En el ')
||unistr('gr\00E1fico se aplicar\00E1 zoom en el rango de fechas especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100665439203305064)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100670037670305067)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de la columna introducido en <em>Columna de fecha de finalizaci\00F3n</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100665685930305064)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100670136216305068)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de estado de sesi\00F3n del <em>elemento de fecha de finalizaci\00F3n</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100664967116305063)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_END_SOURCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de origen de fecha de finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100669738587305067)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la fecha de inicio de ventanilla del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100665126034305064)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Fecha de Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100669810555305067)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el elemento de la aplicaci\00F3n o la p\00E1gina que se utiliza para definir la fecha de inicio de ventanilla del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100664897363305063)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento de Fecha de Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100669415145305067)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el origen a utilizar para definir la fecha de inicio de la ventanilla del gr\00E1fico de Gantt. Una ventanilla es un rango de fechas que, al definirse, puede controlar la realizaci\00F3n de zoom inicial del gr\00E1fico al representarlo. En el gr\00E1fico ')
||unistr('se aplicar\00E1 zoom en el rango de fechas especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100665334521305064)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100669511266305067)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.DB_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Defina el valor de la columna introducido en <em>Columna de fecha de inicio</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100665548453305064)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100669630658305067)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de estado de sesi\00F3n del <em>elemento de fecha de inicio</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100664734327305063)
,p_name=>'PE.PROPERTY.JET_GANTT_VIEWPORT_START_SOURCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de origen de fecha de inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99569056585304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la extensi\00F3n de \00E1ngulo en grados para el gr\00E1fico de indicador de estado con orientaci\00F3n circular. La extensi\00F3n de \00E1ngulo es un \00E1ngulo real de la orientaci\00F3n circular. Los valores positivos indican que el \00E1ngulo gira a la derecha. Los valor')
||unistr('es negativos indican que gira a la izquierda. Puede dibujar el indicador circular en el \00E1ngulo que desee y cambiarlo de forma de acuerdo con el \00E1ngulo que elija. La forma del indicador depende de 2 factores: el <strong>\00E1ngulo inicial</strong> y la <s')
||unistr('trong>extensi\00F3n de \00E1ngulo</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99568834789304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_ANGLE_EXTENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Extensi\00F3n de \00E1ngulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99568477199304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el ratio de grosor relativo del indicador en el \00E1rea de datos. El valor por defecto es 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99568373177304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_INDICATOR_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de indicador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99568576866304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el radio interno de un gr\00E1fico de indicador de estado con orientaci\00F3n circular, es decir, la distancia comprendida entre el centro del indicador y el borde m\00E1s interno del indicador y el \00E1rea de datos. Los valores v\00E1lidos son un porcentaj')
||'e o un ratio de 0 a 1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99568636423304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_INNER_RADIUS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Radio interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99568052466304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de gr\00E1fico de indicador de estado que representar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99567712313304195)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.CIRCULAR.D'
,p_message_language=>'es'
,p_message_text=>'Circular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99567816731304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'es'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99567965866304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'es'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99567688132304195)
,p_name=>'PE.PROPERTY.JET_GAUGE_ORIENTATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Orientaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99568224627304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el \00E1rea de datos del gr\00E1fico de indicador de estado se debe representar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99568173706304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar \00E1rea de datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99682454706304280)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99578637444304204)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color en que se mostrar\00E1 el \00E1rea de datos de un gr\00E1fico de indicador de estado. Puede utilizar las sustituciones <code>&COLUMN_VALUE.</code>. Este color solo se aplica si los colores de umbral no se han definido para el gr\00E1fico.</p>'),
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy y zz representan')
||' los valores hexadecimales de dos caracteres de rojo, verde y azul respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits de rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99578566518304204)
,p_name=>'PE.PROPERTY.JET_GAUGE_PLOT_AREA_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Color de \00C1rea de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99568923072304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el \00E1ngulo inicial en grados para el gr\00E1fico de indicador de estado con orientaci\00F3n circular. Los valores positivos indican que el \00E1ngulo inicial gira a la derecha. Los valores negativos indican que gira a la izquierda. Puede dibujar el ind')
||unistr('icador circular en el \00E1ngulo que desee y cambiarlo de forma de acuerdo con el \00E1ngulo que elija. La forma del indicador depende de 2 factores: el <strong>\00E1ngulo inicial</strong> y la <strong>extensi\00F3n de \00E1ngulo</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99568754994304196)
,p_name=>'PE.PROPERTY.JET_GAUGE_START_ANGLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1ngulo Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100453454302304906)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea mostrar las l\00EDneas de cuadr\00EDcula horizontales en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100452750982304906)
,p_name=>'PE.PROPERTY.JET_HORIZONTAL_GRID.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar l\00EDneas de cuadr\00EDcula horizontales')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100126869965304660)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique el comportamiento que se aplicar\00E1 al pasar el mouse sobre los elementos de datos del gr\00E1fico.<p/>'),
'        Seleccione <strong>Activado</strong> para atenuar todos los elementos de datos cuando no se pase el mouse sobre ellos y resaltar solo el elemento de datos actual sobre el que se ha pasado el mouse.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100126730922304660)
,p_name=>'PE.PROPERTY.JET_HOVER_BEHAVIOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atenuar al Pasar el Mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100714545925305104)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el zoom inicial del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100714652753305104)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.D'
,p_message_language=>'es'
,p_message_text=>'Primero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100714738220305104)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.FIRST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Haga zoom inicialmente en los primeros puntos de datos que se pueden ajustar en el \00E1rea de datos del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100714861496305104)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.D'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100714934502305105)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.LAST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Haga zoom inicialmente a los \00FAltimos puntos de datos que pueden ajustarse en el \00E1rea de datos del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100715003037305105)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100715183805305105)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.LOV.NONE.HELP'
,p_message_language=>'es'
,p_message_text=>'Para desactivar el zoom inicial.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100714452610305104)
,p_name=>'PE.PROPERTY.JET_INITIAL_ZOOMING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Zoom Inicial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100100095255304601)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99842777192304401)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para ver la fuente del atributo especificado.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99839791111304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99841389244304400)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la familia de fuentes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99839951068304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'es'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99839845543304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'es'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99840033653304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'es'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99840104091304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'es'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99840339458304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'es'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99840208353304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'es'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99840464194304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'es'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99840543227304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'es'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99840627344304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'es'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99840789409304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'es'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99840861141304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'es'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99841079112304400)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'es'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99840954881304400)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'es'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99841138259304400)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'es'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99841276188304400)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'es'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99839469919304398)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Familia de fuentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99841802964304400)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Selecciona el tama\00F1o de fuente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99842059288304401)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'es'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99842151061304401)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'es'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99842284149304401)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'es'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99842348972304401)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'es'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99842470437304401)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'es'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99842598637304401)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'es'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99842612869304401)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'es'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99841947287304400)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'es'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99839645861304399)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Fuente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99841453618304400)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el estilo de fuente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99841662544304400)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'es'
,p_message_text=>'Cursiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99841542114304400)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99841742608304400)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'es'
,p_message_text=>'Oblicua'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99839500180304398)
,p_name=>'PE.PROPERTY.JET_ITEMS_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99650408928304257)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique c\00F3mo se deben mostrar las etiquetas en las porciones del gr\00E1fico de tarta. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100694063667305089)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.D'
,p_message_language=>'es'
,p_message_text=>'Etiqueta - Porcentaje (valor)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100694505309305089)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.ALL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Las etiquetas mostrar\00E1n la informaci\00F3n de la etiqueta, del valor y del porcentaje con el siguiente formato: etiqueta - porcentaje ( valor ). Por ejemplo, <strong>Bugs - 15% ( 18 )</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100694170554305089)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.D'
,p_message_language=>'es'
,p_message_text=>'Porcentaje (valor)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100694652749305089)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.COMBO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Las etiquetas se mostrar\00E1n como valores num\00E9ricos en funci\00F3n de la asignaci\00F3n de la columna Valor seleccionada. Por ejemplo, <strong>15% ( 18 )</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100693784229305089)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.D'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100694249378305089)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Las etiquetas se mostrar\00E1n en las porciones del gr\00E1fico en funci\00F3n de la asignaci\00F3n de la columna Etiqueta seleccionada. Por ejemplo, <strong>Bugs</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100038377908304553)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.D'
,p_message_language=>'es'
,p_message_text=>'Etiqueta - valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100038450274304554)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.LBL_VAL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Las etiquetas mostrar\00E1n la informaci\00F3n de la etiqueta y del valor con el siguiente formato: etiqueta - valor. Por ejemplo, <strong>Bugs - 18</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100693855707305089)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.D'
,p_message_language=>'es'
,p_message_text=>'Porcentaje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100694323268305089)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.PERCENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Las etiquetas se mostrar\00E1n como valores entre 0% y 100% en funci\00F3n de la asignaci\00F3n de la columna Valor seleccionada. El valor es un porcentaje del total de valores representado en el gr\00E1fico. Por ejemplo, <strong>15%</strong>.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100693911208305089)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.D'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100694446699305089)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.LOV.VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Las etiquetas se mostrar\00E1n como valores num\00E9ricos en funci\00F3n de la asignaci\00F3n de la columna Valor seleccionada.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100693652621305089)
,p_name=>'PE.PROPERTY.JET_LABEL_DISPLAY_AS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100099902478304601)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99836747999304396)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para ver la fuente del atributo especificado.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99836362284304396)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99836412019304396)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la familia de fuentes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99836992429304396)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'es'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99836827750304396)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'es'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99837026982304396)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'es'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99837174728304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'es'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99837374851304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'es'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99837276471304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'es'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99837445368304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'es'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99837530240304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'es'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99837613342304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'es'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99837778925304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'es'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99837848730304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'es'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99838044066304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'es'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99837927741304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'es'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99838164306304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'es'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99838225382304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'es'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99836082155304396)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_FAMILY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Familia de fuentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99836637544304396)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Selecciona el tama\00F1o de fuente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99838746128304398)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.10.D'
,p_message_language=>'es'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99838872001304398)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.12.D'
,p_message_language=>'es'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99838984945304398)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.14.D'
,p_message_language=>'es'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99839090017304398)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.16.D'
,p_message_language=>'es'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99839171384304398)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.18.D'
,p_message_language=>'es'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99839267638304398)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.20.D'
,p_message_language=>'es'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99839324936304398)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.22.D'
,p_message_language=>'es'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99838649507304398)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.LOV.8.D'
,p_message_language=>'es'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99836289435304396)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Fuente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99836554984304396)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el estilo de fuente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99838442442304398)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'es'
,p_message_text=>'Cursiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99838324074304397)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99838553065304398)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'es'
,p_message_text=>'Oblicua'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99836167206304396)
,p_name=>'PE.PROPERTY.JET_LEGEND_FONT_STYLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99686236456304282)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>Una lista delimitada por comas de colores:</dt>',
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>Una lista delimitada por comas de elementos de p\00E1gina o de aplicaci\00F3n que devuelve colores mediante la sintaxis:</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code> Por ejemplo, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
'<dt>Una lista delimitada por comas de elementos de columnas que devuelve colores mediante la sintaxis:</dt>',
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code> Por ejemplo, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99686166768304282)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Escriba el color que se utilizar\00E1 para identificar las l\00EDneas de referencia que se mostrar\00E1n en el gr\00E1fico del indicador de estado.'),
unistr('Para varias l\00EDneas de referencia, utilice una lista separada por comas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99685869685304282)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_COLORS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Colores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99686086024304282)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>Una lista delimitada por comas de valores num\00E9ricos est\00E1ticos:</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>Una lista delimitada por comas de elementos de p\00E1gina o de aplicaci\00F3n que devuelve valores num\00E9ricos mediante la sintaxis:</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code> Por ejemplo, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Una lista delimitada por comas de columnas que devuelve valores num\00E9ricos mediante la sintaxis:</dt>'),
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code> Por ejemplo, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99685973836304282)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Escriba el n\00FAmero que se utilizar\00E1 para identificar las l\00EDneas de referencia que se mostrar\00E1n en el gr\00E1fico del indicador de estado.'),
unistr('Para varias l\00EDneas de referencia, utilice una lista separada por comas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99685729560304282)
,p_name=>'PE.PROPERTY.JET_REFERENCE_LINE_VALUES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100453247548304906)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea representar las etiquetas de fila en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100452940642304906)
,p_name=>'PE.PROPERTY.JET_ROW_AXIS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar eje de filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100138380366304669)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100138297240304669)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color en que se mostrar\00E1n los elementos de datos asociados a esta serie de gr\00E1ficos. Puede utilizar sustituciones de <code>&COLUMN_VALUE.</code>. Para un gr\00E1fico de indicador de estado, este color se aplicar\00E1 al indicador a no ser qu')
||unistr('e se hayan definido umbrales y el atributo <strong>Visualizaci\00F3n de umbral</strong> se haya establecido en <strong>En indicador</strong>.</p>'),
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy y zz representan')
||' los valores hexadecimales de dos caracteres de rojo, verde y azul respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits de rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100138149072304669)
,p_name=>'PE.PROPERTY.JET_SERIES_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100064194876304573)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100063938228304573)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color que se mostrar\00E1 para el segmento q2 de la serie del gr\00E1fico de \00E1reas. Puede utilizar las sustituciones <code>&COLUMN_VALUE.</code></p>'),
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy y zz representan')
||' los valores hexadecimales de dos caracteres para rojo, verde y azul respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100063714075304573)
,p_name=>'PE.PROPERTY.JET_SERIES_Q2_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Q2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100064223276304573)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100064058846304573)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color que se mostrar\00E1 para el segmento q3 de la serie del gr\00E1fico de \00E1reas. Puede utilizar las sustituciones <code>&COLUMN_VALUE.</code></p>'),
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy y zz representan')
||' los valores hexadecimales de dos caracteres para rojo, verde y azul respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100063820120304573)
,p_name=>'PE.PROPERTY.JET_SERIES_Q3_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Q3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100059074092304569)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de serie del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100045992880304559)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.AREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100046022515304559)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BAR.D'
,p_message_language=>'es'
,p_message_text=>'Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100045817457304559)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.BOXPLOT.D'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1reas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100046150883304559)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINE.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100046260123304559)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.LOV.LINEWITHAREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea con \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100046331869304559)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_BOX_PLOT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100160347684304686)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COLUMN_MAPPING.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Asignaci\00F3n de Columna de Tipo de Serie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100160593457304686)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de serie de gr\00E1ficos. Tambi\00E9n se puede crear un gr\00E1fico que combine diferentes tipos de series en el mismo trazado de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100160683811304686)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100161147997304686)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.AREARANGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Rango de \00C1reas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100160739062304686)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BAR.D'
,p_message_language=>'es'
,p_message_text=>'Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100161085138304686)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.BARRANGE.D'
,p_message_language=>'es'
,p_message_text=>'Rango de Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100160889905304686)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINE.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100160906587304686)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.LOV.LINEWITHAREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea con \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100160434081304686)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_COMBO.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100161755194304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de serie del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100161872524304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100162430799304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.AREARANGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Rango de \00C1reas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100161922049304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BAR.D'
,p_message_language=>'es'
,p_message_text=>'Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100162306195304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BARRANGE.D'
,p_message_language=>'es'
,p_message_text=>'Rango de Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100162213828304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.BUBBLE.D'
,p_message_language=>'es'
,p_message_text=>'Burbuja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100162089229304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINE.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100449537004304903)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.LINEWITHAREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea con \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100162171500304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.LOV.SCATTER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Dispersi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100161688531304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_POLAR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100162605320304688)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de serie del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100162782564304688)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100162895577304688)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.AREARANGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Rango de \00C1reas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100162910697304688)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.LOV.LINE.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100162562594304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RADAR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100161390954304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de serie del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100161557573304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.AREARANGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Rango de \00C1reas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100161405208304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.LOV.BARRANGE.D'
,p_message_language=>'es'
,p_message_text=>'Rango de Barras'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100161204837304687)
,p_name=>'PE.PROPERTY.JET_SERIES_TYPE_RANGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100143490696304673)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se presenta el eje en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100143350358304673)
,p_name=>'PE.PROPERTY.JET_SHOW_AXIS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar Eje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99684796133304281)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si la base se debe mostrar en la pista del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99684126484304281)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_BASELINE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar base'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99684537169304281)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si la fecha de finalizaci\00F3n se debe mostrar en la pista del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99683996563304281)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_END.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar fecha de finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99684606757304281)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el progreso se debe mostrar en la pista del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99684055336304281)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_PROGRESS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar progreso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99684275678304281)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si la informaci\00F3n de la fila se debe mostrar en la pista del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99683604100304281)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_ROW.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99684499409304281)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si la fecha de inicio se debe mostrar en la pista del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99683800803304281)
,p_name=>'PE.PROPERTY.JET_SHOW_GANTT_START.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar fecha de inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99569281782304197)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se debe presentar un valor en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99569133067304197)
,p_name=>'PE.PROPERTY.JET_SHOW_GAUGE_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99684331969304281)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si la etiqueta se debe mostrar en la pista del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99683791417304281)
,p_name=>'PE.PROPERTY.JET_SHOW_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100131629641304664)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se debe presentar una pista en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100131594725304664)
,p_name=>'PE.PROPERTY.JET_SHOW_TOOLTIP.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100132207996304665)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si aparecer\00E1n valores en la pista del gr\00E1fico. Los valores se derivan de la consulta del gr\00E1fico y se muestran junto a los datos del mismo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100132114717304664)
,p_name=>'PE.PROPERTY.JET_SHOW_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100466923450304916)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la ordenaci\00F3n de los datos de un gr\00E1fico de varias series en funci\00F3n del valor o de la etiqueta del mismo.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100451505443304905)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.D'
,p_message_language=>'es'
,p_message_text=>'Etiqueta: Ascendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100451943559304905)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-ASC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Defina el orden del gr\00E1fico en funci\00F3n de las etiquetas del eje X en orden ascendente. Esta es la ordenaci\00F3n por defecto. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100451610245304905)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.D'
,p_message_language=>'es'
,p_message_text=>'Etiqueta: Descendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100452065165304905)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.LABEL-DESC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Defina el orden del gr\00E1fico en funci\00F3n de las etiquetas del eje X en orden descendente. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100451382928304905)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.D'
,p_message_language=>'es'
,p_message_text=>'Valor: Ascendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100451798228304905)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-ASC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Defina el orden del gr\00E1fico de acuerdo con los valores en orden ascendente (1, 2, 3, ...). Esta configuraci\00F3n solo debe usarse en gr\00E1ficos circulares, gr\00E1ficos de barras/l\00EDneas/\00E1reas con una serie o gr\00E1ficos de barras/\00E1reas apilados. El orden no se a')
||unistr('plicar\00E1 si se utiliza un eje de grupo jer\00E1rquico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100451464330304905)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.D'
,p_message_language=>'es'
,p_message_text=>'Valor: Descendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100451842474304905)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.LOV.VALUE-DESC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Defina el orden del gr\00E1fico de acuerdo con los valores en orden descendente (10, 9, 8, ...). Esta configuraci\00F3n solo debe usarse en gr\00E1ficos circulares, gr\00E1ficos de barras/l\00EDneas/\00E1reas con una serie o gr\00E1ficos de barras/\00E1reas apilados. El orden no se')
||unistr(' aplicar\00E1 si se utiliza un eje de grupo jer\00E1rquico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100451230304304905)
,p_name=>'PE.PROPERTY.JET_SORT_ORDER.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Orden de Clasificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100296733328304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100296659742304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para ver la fuente del atributo especificado.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100296217809304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100296399155304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la familia de fuentes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100298079660304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'es'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100297962293304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'es'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100298177151304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'es'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100298236102304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'es'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100298401839304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'es'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100298388996304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'es'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100298517182304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'es'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100298655302304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'es'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100298777241304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'es'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100298856912304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'es'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100298977057304791)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'es'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100299168969304791)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'es'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100299073367304791)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'es'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100299286352304791)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'es'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100299336259304791)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'es'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100295910198304788)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_FAMILY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Familia de fuentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100296588351304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Selecciona el tama\00F1o de fuente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100296987965304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.10.D'
,p_message_language=>'es'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100297071984304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.12.D'
,p_message_language=>'es'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100297135863304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.14.D'
,p_message_language=>'es'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100297284298304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.16.D'
,p_message_language=>'es'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100297391909304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.18.D'
,p_message_language=>'es'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100297401068304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.20.D'
,p_message_language=>'es'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100297525022304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.22.D'
,p_message_language=>'es'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100296835834304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.LOV.8.D'
,p_message_language=>'es'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100296103714304788)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Fuente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100296444413304789)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el estilo de fuente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100297703686304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'es'
,p_message_text=>'Cursiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100297618399304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100297813074304790)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'es'
,p_message_text=>'Oblicua'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100296060831304788)
,p_name=>'PE.PROPERTY.JET_STACK_FONT_STYLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100460644548304911)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la posici\00F3n de las etiquetas de tarea en el gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100460980239304912)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.D'
,p_message_language=>'es'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100461355450304912)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.END.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La etiqueta de tarea se representa al final de la barra de tareas del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100461060133304912)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.D'
,p_message_language=>'es'
,p_message_text=>'Centro interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100461404216304912)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERCENTER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La etiqueta de tarea se representa en el centro interno de la barra de tareas del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100461244413304912)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.D'
,p_message_language=>'es'
,p_message_text=>unistr('Finalizaci\00F3n interna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100461656437304912)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNEREND.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La etiqueta de tarea se representa en la finalizaci\00F3n interna de la barra de tareas del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100461124405304912)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.D'
,p_message_language=>'es'
,p_message_text=>'Inicio interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100461522983304912)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.INNERSTART.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La etiqueta de tarea se representa en el inicio interno de la barra de tareas del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100460751075304912)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.D'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100460807866304912)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.LOV.START.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La etiqueta de tarea se representa al inicio de la barra de tareas del gr\00E1fico de Gantt.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100460553445304911)
,p_name=>'PE.PROPERTY.JET_TASK_LABEL_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de etiqueta de tarea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99597579223304217)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
'<dt>Una lista delimitada por comas de colores:</dt>',
'<dd><pre>',
'<strong>red,yellow,blue</strong>',
'</pre></dd>',
unistr('<dt>Una lista delimitada por comas de elementos de p\00E1gina o de aplicaci\00F3n que devuelve colores mediante la sintaxis:</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code> Por ejemplo, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
'<dt>Una lista delimitada por comas de elementos de columnas que devuelve colores mediante la sintaxis:</dt>',
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code> Por ejemplo, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99597443113304217)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca los colores que desea utilizar para identificar el l\00EDmite superior de los umbrales que se representan en un gr\00E1fico de indicador de estado.'),
'Para varios umbrales, utilice una lista delimitada por comas.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99578864420304204)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_COLORS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Colores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99682505238304280)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique c\00F3mo deben mostrarse los umbrales en el gr\00E1fico del indicador de estado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99596972009304217)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.D'
,p_message_language=>'es'
,p_message_text=>'Todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99597045545304217)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ALL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Todos los umbrales, que se definen con el atributo <strong>Valores de umbral</strong>, se muestran en el \00E1rea de datos del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99597274934304217)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.D'
,p_message_language=>'es'
,p_message_text=>'Solo umbral actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99597342122304217)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.CURRENTONLY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El umbral actual, definido con el atributo <strong>Valores de umbral</strong>, se muestra en el \00E1rea de datos del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99597164943304217)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.D'
,p_message_language=>'es'
,p_message_text=>'En indicador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99682672151304280)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.LOV.ONINDICATOR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El umbral actual, que se ha definido utilizando el atributo de <strong>valores de umbral</strong>, se muestra en el indicador del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99596859920304217)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_DISPLAY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99596719541304217)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl>',
unistr('<dt>Una lista delimitada por comas de valores num\00E9ricos est\00E1ticos:</dt>'),
'<dd><pre>',
'<strong>5,10,15</strong>',
'</pre></dd>',
unistr('<dt>Una lista delimitada por comas de elementos de p\00E1gina o de aplicaci\00F3n que devuelve valores num\00E9ricos mediante la sintaxis:</dt>'),
'<dd><pre>',
'<code>&amp;ITEM.</code> Por ejemplo, <strong><code>&amp;ITEM_1.</code>,<code>&amp;ITEM_2.</code>,<code>&amp;ITEM_3.</code></strong>',
'</pre></dd>',
unistr('<dt>Una lista delimitada por comas de columnas que devuelve valores num\00E9ricos mediante la sintaxis:</dt>'),
'<dd><pre>',
'<code>&amp;COLUMN_NAME.</code> Por ejemplo, <strong><code>&amp;COLUMN_NAME_1.</code>,<code>&amp;COLUMN_NAME_2.</code>,<code>&amp;COLUMN_NAME_3.</code></strong>',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99578745857304204)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca los n\00FAmeros que desea utilizar para identificar el l\00EDmite superior de los umbrales que se representan en un gr\00E1fico de indicador de estado.'),
'Para varios umbrales, utilice una lista delimitada por comas.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99578483895304204)
,p_name=>'PE.PROPERTY.JET_THRESHOLD_VALUES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100099832613304601)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99835948763304396)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para ver la fuente del atributo especificado.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99832929495304393)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99834534280304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la familia de fuentes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99833110921304393)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'es'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99833045554304393)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'es'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99833276186304393)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'es'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99833317993304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'es'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99833540085304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'es'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99833461460304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'es'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99833685701304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'es'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99833718810304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'es'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99833882634304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'es'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99833937702304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'es'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99834009761304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'es'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99834286031304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'es'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99834112355304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'es'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99834320934304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'es'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99834483625304394)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'es'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99832682255304393)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_FAMILY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Familia de fuentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99835060035304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Selecciona el tama\00F1o de fuente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99835294156304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.10.D'
,p_message_language=>'es'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99835306476304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.12.D'
,p_message_language=>'es'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99835449176304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.14.D'
,p_message_language=>'es'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99835523226304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.16.D'
,p_message_language=>'es'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99835654802304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.18.D'
,p_message_language=>'es'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99835710856304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.20.D'
,p_message_language=>'es'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99835890228304396)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.22.D'
,p_message_language=>'es'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99835151494304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.LOV.8.D'
,p_message_language=>'es'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99832883559304393)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Fuente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99834643778304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el estilo de fuente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99834869080304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'es'
,p_message_text=>'Cursiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99834772794304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99834968046304395)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'es'
,p_message_text=>'Oblicua'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99832798489304393)
,p_name=>'PE.PROPERTY.JET_TICK_LABEL_FONT_STYLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100127040265304661)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de eje de tiempo que se va a mostrar en el gr\00E1fico. Este valor representar\00E1 autom\00E1ticamente los datos del gr\00E1fico en orden cronol\00F3gico y no se debe utilizar si necesita que los datos se representen en orden cronol\00F3gico inverso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100127103993304661)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100256071095304758)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.AUTO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplique el valor de eje de tiempo por defecto definido por Oracle JET para el gr\00E1fico, seg\00FAn los datos que se vayan a presentar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100127282411304661)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.D'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100256105682304759)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.DISABLED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('No aplique ning\00FAn valor de tipo de eje de tiempo al gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100127322365304661)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.D'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100256239160304759)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.ENABLED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplique un valor de tipo de eje de tiempo al gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100127452108304661)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.D'
,p_message_language=>'es'
,p_message_text=>'Frecuencia Mixta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100166320146304690)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.MIXEDFREQUENCY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Valores de tiempo mostrados en el eje del gr\00E1fico en la frecuencia mixta. Como el valor del tiempo de los datos puede variar, el apilamiento no est\00E1 soportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100166436577304690)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.D'
,p_message_language=>'es'
,p_message_text=>'Omitir Intervalos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100166563132304690)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.LOV.SKIPGAPS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los valores de tiempo mostrados en el eje del gr\00E1fico se presentar\00E1n en un intervalo regular independientemente de cualquier intervalo de tiempo que pueda existir en los datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100126981146304661)
,p_name=>'PE.PROPERTY.JET_TIME_AXIS_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Eje de Tiempo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100099737075304601)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99832105648304389)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para ver la fuente del atributo especificado.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99832090298304389)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99831732784304389)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la familia de fuentes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99830354223304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL BLACK.D'
,p_message_language=>'es'
,p_message_text=>'Arial Black'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99830229568304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.ARIAL.D'
,p_message_language=>'es'
,p_message_text=>'Arial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99830413067304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.BOOKMAN.D'
,p_message_language=>'es'
,p_message_text=>'Bookman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99830535723304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COMIC SANS MS.D'
,p_message_language=>'es'
,p_message_text=>'Comic Sans MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99830780615304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER NEW.D'
,p_message_language=>'es'
,p_message_text=>'Courier New'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99830656928304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'es'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99830872905304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GARAMOND.D'
,p_message_language=>'es'
,p_message_text=>'Garamond'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99830997145304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.GEORGIA.D'
,p_message_language=>'es'
,p_message_text=>'Georgia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99831088741304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'es'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99831136174304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.IMPACT.D'
,p_message_language=>'es'
,p_message_text=>'Impact'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99831273513304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.PALATINO.D'
,p_message_language=>'es'
,p_message_text=>'Palatino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99831494816304389)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES NEW ROMAN.D'
,p_message_language=>'es'
,p_message_text=>'Times New Roman'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99831315965304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'es'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99831511110304389)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.TREBUCHET MS.D'
,p_message_language=>'es'
,p_message_text=>'Trebuchet MS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99831687230304389)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.LOV.VERDANA.D'
,p_message_language=>'es'
,p_message_text=>'Verdana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99828822567304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_FAMILY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Familia de fuentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99831996522304389)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Selecciona el tama\00F1o de fuente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99829558491304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.10.D'
,p_message_language=>'es'
,p_message_text=>'10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99829675486304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.12.D'
,p_message_language=>'es'
,p_message_text=>'12'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99829750134304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.14.D'
,p_message_language=>'es'
,p_message_text=>'14'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99829893428304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.16.D'
,p_message_language=>'es'
,p_message_text=>'16'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99829973296304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.18.D'
,p_message_language=>'es'
,p_message_text=>'18'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99830081559304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.20.D'
,p_message_language=>'es'
,p_message_text=>'20'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99830160643304388)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.22.D'
,p_message_language=>'es'
,p_message_text=>'22'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99829418489304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.LOV.8.D'
,p_message_language=>'es'
,p_message_text=>'8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99829007558304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Fuente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99831847101304389)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el estilo de fuente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99829246208304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.ITALIC.D'
,p_message_language=>'es'
,p_message_text=>'Cursiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99829173922304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.NORMAL.D'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99829350538304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.LOV.OBLIQUE.D'
,p_message_language=>'es'
,p_message_text=>'Oblicua'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99828956772304387)
,p_name=>'PE.PROPERTY.JET_TITLE_FONT_STYLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100453336373304906)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea mostrar las l\00EDneas de cuadr\00EDcula verticales en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100452822091304906)
,p_name=>'PE.PROPERTY.JET_VERTICAL_GRID.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar l\00EDneas de cuadr\00EDcula verticales')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100167373080304691)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el comportamiento de zoom y desplazamiento del gr\00E1fico. El comportamiento <strong>En Directo</strong> significa que el gr\00E1fico se actualizar\00E1 continuamente mientras se manipula,'),
unistr('        mientras que <strong>Retrasado</strong> significa que la actualizaci\00F3n esperar\00E1 hasta que se realice la acci\00F3n de zoom/desplazamiento. Aunque el zoom y el desplazamiento <strong>En Directo</strong> proporcionan la mejor experiencia al usuario')
||' final, no se garantiza',
unistr('        el rendimiento ni el uso de la representaci\00F3n para los juegos de datos de mayor tama\00F1o ni para los entornos de cliente lentos. Si el rendimiento es un problema, se debe utilizar el zoom y el desplazamiento <strong>Retrasado</strong> en su lug')
||'ar.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100127659866304661)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique el comportamiento de zoom y desplazamiento del gr\00E1fico.'),
unistr('        El zoom y el desplazamiento permiten al usuario final utilizar gestos, como arrastrar en el \00E1rea de datos, utilizando la rueda del mouse o pellizcando con dos dedos, para cambiar el tama\00F1o de los valores mostrados y navegar dentro del gr\00E1fico')
||unistr(' para mostrar diferentes valores de gr\00E1fico.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100127863245304661)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.D'
,p_message_language=>'es'
,p_message_text=>'Retrasado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100207037680304721)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El cambio en la visualizaci\00F3n de los datos esperar\00E1 hasta que se haya realizado la acci\00F3n de zoom/desplazamiento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100127996039304661)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.D'
,p_message_language=>'es'
,p_message_text=>'Solo Desplazamiento Retrasado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100207165714304721)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.DELAYEDSCROLLONLY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El cambio en la visualizaci\00F3n de los datos esperar\00E1 hasta que se haya realizado la acci\00F3n de desplazamiento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100128058329304661)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.D'
,p_message_language=>'es'
,p_message_text=>'En Directo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100207272837304721)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El comportamiento en directo significa que el gr\00E1fico se actualizar\00E1 continuamente mientras se manipula.'),
'        Para los juegos de datos grandes o los entornos de cliente lentos, se recomienda seleccionar <strong>Retrasado</strong>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100128182267304661)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.D'
,p_message_language=>'es'
,p_message_text=>'Solo Desplazamiento en Directo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100207311440304721)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.LIVESCROLLONLY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El comportamiento Solo Desplazamiento en Directo en directo significa que el gr\00E1fico se actualizar\00E1 continuamente mientras se desplaza por \00E9l.'),
unistr('        Para los juegos de datos grandes o los entornos de cliente lentos, plant\00E9ese seleccionar <strong>Solo Desplazamiento Retrasado</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100127708987304661)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.D'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100206976690304720)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.LOV.OFF.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El zoom y el desplazamiento est\00E1n desactivados para el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100127534392304661)
,p_name=>'PE.PROPERTY.JET_ZOOM_AND_SCROLL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Zoom y Desplazar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100671898142305069)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la direcci\00F3n de zoom del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100671968314305069)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>'Ambos Ejes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100672051546305069)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.AUTO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Ampl\00EDa en la direcci\00F3n de los ejes x e y.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100672188009305069)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.D'
,p_message_language=>'es'
,p_message_text=>'Eje X'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100672246747305069)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.X.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Solo ampl\00EDa en la direcci\00F3n del eje x.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100672328343305069)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>'Eje Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100672421576305069)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.LOV.Y.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Solo ampl\00EDa en la direcci\00F3n del eje y.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100671797382305069)
,p_name=>'PE.PROPERTY.JET_ZOOM_DIRECTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n de Zoom')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100456081115304908)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea habilitar el zoom a una escala de d\00EDas en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100454894325304907)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_DAYS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('D\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100455981928304908)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea habilitar el zoom a una escala de horas en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100454563495304907)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_HOURS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100455810305304908)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea habilitar el zoom a una escala de minutos en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100454474714304907)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MINUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100456237204304908)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea habilitar el zoom a una escala de meses en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100455204143304907)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_MONTHS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Meses'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100456302363304908)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea habilitar el zoom a una escala de trimestres en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100455480134304908)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_QUARTERS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Trimestres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100455748577304908)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea habilitar el zoom a una escala de segundos en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100454112578304907)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_SECONDS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100456195264304908)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea habilitar el zoom a una escala de semanas en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100455055251304907)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_WEEKS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100456403663304908)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea habilitar el zoom a una escala de a\00F1os en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100455600874304908)
,p_name=>'PE.PROPERTY.JET_ZOOM_ORDER_YEARS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('A\00F1os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100259649341304761)
,p_name=>'PE.PROPERTY.JS_CONDITION.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique una condici\00F3n de cliente para controlar si la acci\00F3n se dispara.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99854734999304411)
,p_name=>'PE.PROPERTY.JS_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique una condici\00F3n del cliente para controlar si se disparan las acciones verdaderas o falsas. Si la condici\00F3n '),
unistr('                                  se eval\00FAa como verdadera, se disparan las acciones verdaderas; si la condici\00F3n se eval\00FAa como falsa, se disparan las acciones falsas.'),
unistr('                                  Si no se especifica ninguna condici\00F3n, solo se disparan las acciones verdaderas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100365885936304840)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.D'
,p_message_language=>'es'
,p_message_text=>'Elemento = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100722518115305110)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.EQUALS.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> seleccionado es igual al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100366091210304840)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.D'
,p_message_language=>'es'
,p_message_text=>'Elemento > Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100722712235305110)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> seleccionado es superior al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100366196463304840)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'es'
,p_message_text=>'Elemento >= Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100722880440305111)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> seleccionado es superior o igual al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100366639782304840)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento est\00E1 en lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100723361941305111)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.IN_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el valor del <em>elemento</em> seleccionado est\00E1 en la <em>lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100366801534304840)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100723583397305111)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Eval\00FAa la expresi\00F3n JavaScript especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100366230706304840)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.D'
,p_message_language=>'es'
,p_message_text=>'Elemento < Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100722995225305111)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> seleccionado es inferior al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100366348147304840)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'es'
,p_message_text=>'Elemento <= Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100723015794305111)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> seleccionado es inferior o igual al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100365936107304840)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.D'
,p_message_language=>'es'
,p_message_text=>'Elemento != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100722645587305110)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_EQUALS.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> seleccionado no es igual al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100366773964304840)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento no est\00E1 en lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100723480895305111)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el valor del <em>elemento</em> seleccionado no est\00E1 en la <em>lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100366501198304840)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es no nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100723212551305111)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NOT_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el <em>elemento</em> seleccionado no est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100366450005304840)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100723159264305111)
,p_name=>'PE.PROPERTY.JS_CONDITION.LOV.NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el <em>elemento</em> seleccionado est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99854653591304411)
,p_name=>'PE.PROPERTY.JS_CONDITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100723995573305111)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la columna utilizada en esta condici\00F3n.</p>'),
unistr('<p>Nota: En la mayor\00EDa de los casos, ser\00E1 la columna especificada anteriormente en la(s) <em>columna(s) When</em>'),
unistr('y, por lo tanto, esta ser\00E1 la opci\00F3n por defecto. Sin embargo, puede que desee basar la condici\00F3n en una columna distinta,'),
unistr('por ejemplo, con una cuadr\00EDcula interactiva basada en la tabla EMP, si desea disparar una acci\00F3n din\00E1mica'),
unistr('siempre que <code>SAL</code> cambie, pero solo si el atributo <code>JOB</code> es igual que <em>SALESMAN</em>, en ese caso, cambiar\00EDa este atributo por <code>JOB</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100718527273305107)
,p_name=>'PE.PROPERTY.JS_CONDITION_COLUMN_WHEN_IG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100725254410305112)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione si se utiliza un <em>elemento</em> o <em>columna</em> en esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100714039109305104)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100713976430305104)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100713836111305104)
,p_name=>'PE.PROPERTY.JS_CONDITION_ELEMENT_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100259752579304761)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca el elemento de p\00E1gina utilizado en esta condici\00F3n. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100259567972304761)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca el elemento de p\00E1gina utilizado en esta condici\00F3n. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100724026048305111)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el elemento de p\00E1gina utilizado en esta condici\00F3n. Puede escribir el nombre o seleccionarlo de la lista de elementos disponibles.</p>'),
unistr('<p>Nota: En la mayor\00EDa de los casos, debe ser el elemento especificado anteriormente, en lo(s) <em>elemento(s) When</em>'),
unistr('y, por lo tanto, esta ser\00E1 la opci\00F3n por defecto. Sin embargo, puede que desee basar la condici\00F3n en un elemento de p\00E1gina distinto,'),
unistr('por ejemplo, con un formulario basado en la tabla EMP, si desea disparar una acci\00F3n din\00E1mica siempre que <code>P2_SAL</code> cambie pero solo si el atributo'),
unistr('<code>P2_JOB</code> es igual a <em>SALESMAN</em>, en ese caso, cambiar\00EDa este atributo por <code>P2_JOB</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100714199254305104)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100723826977305111)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de p\00E1gina utilizado en esta condici\00F3n. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100718435387305107)
,p_name=>'PE.PROPERTY.JS_CONDITION_ITEM_WHEN_IG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100259898348304761)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.COMPONENT_PROPERTY.DYNAMIC_ACTION_ACTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique una condici\00F3n de cliente para controlar si la acci\00F3n se dispara.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100718783149305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique una condici\00F3n de cliente para controlar si se disparan las acciones True o False. Si la condici\00F3n'),
unistr('                                  se aval\00FAa en True, se disparan las acciones True, si la condici\00F3n se eval\00FAa en False, se disparan las acciones False.'),
unistr('                                  Si no se especifica ninguna condici\00F3n, solo se disparan las acciones True.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100718877729305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.D'
,p_message_language=>'es'
,p_message_text=>'Elemento / Columna = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100724123582305111)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.EQUALS.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> o <em>columna</em>seleccionado es igual al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100719034788305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.D'
,p_message_language=>'es'
,p_message_text=>'Elemento / Columna > Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100724327857305112)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> o <em>columna</em>seleccionado es superior al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100719139951305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.D'
,p_message_language=>'es'
,p_message_text=>'Elemento / Columna >= Valor'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100724408694305112)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.GREATER_THAN_OR_EQUAL.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> o <em>columna</em>seleccionado es superior o igual al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100719644110305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento / Columna est\00E1 en la lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100724905897305112)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.IN_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el valor del <em>elemento</em> o <em>columna</em>seleccionados est\00E1 en la <em>lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100719893873305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100725182030305112)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Eval\00FAa la expresi\00F3n JavaScript especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100719255168305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.D'
,p_message_language=>'es'
,p_message_text=>'Elemento / Columna < Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100724592998305112)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> o <em>columna</em>seleccionado es inferior al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100719335278305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.D'
,p_message_language=>'es'
,p_message_text=>'Elemento / Columna <= Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100724669147305112)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.LESS_THAN_OR_EQUAL.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> o <em>columna</em>seleccionado es inferior o igual al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100718969413305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.D'
,p_message_language=>'es'
,p_message_text=>'Elemento / Columna != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100724223837305112)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_EQUALS.HELP'
,p_message_language=>'es'
,p_message_text=>'Comprueba si el valor del <em>elemento</em> o <em>columna</em>seleccionado no es igual al <em>valor</em> especificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100719743822305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento / Columna no est\00E1 en la lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100725022503305112)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_IN_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el valor del <em>elemento</em> o <em>columna</em>seleccionados no est\00E1 en la <em>lista</em> especificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100719534642305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.D'
,p_message_language=>'es'
,p_message_text=>'Elemento / Columna no es nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100724861151305112)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NOT_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el <em>elemento</em> o <em>columna</em>seleccionados no est\00E1n vac\00EDos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100719469902305108)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.D'
,p_message_language=>'es'
,p_message_text=>'Elemento / Columna es nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100724708882305112)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.LOV.NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Comprueba si el <em>elemento</em> o <em>columna</em>seleccionados est\00E1n vac\00EDos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100718623199305107)
,p_name=>'PE.PROPERTY.JS_CONDITION_WHEN_IG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100259461016304761)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique la expresi\00F3n JavaScript que se va a evaluar para esta condici\00F3n.'),
unistr('El c\00F3digo tiene acceso a los siguientes atributos relacionados con la acci\00F3n din\00E1mica:</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>Referencia al objeto DOM del elemento que dispara la acci\00F3n din\00E1mica.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>Objeto de evento que ha disparado el evento: Nota: En la carga, ser\00E1 igual a ''carga''.</dd>'),
'  <dt>this.data</dt>',
'    <dd>Datos adicionales opcionales que se pueden transferir desde el manejador de eventos.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100259373334304761)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100720496851305109)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique la expresi\00F3n JavaScript que se va a evaluar para esta condici\00F3n.'),
unistr('El c\00F3digo tiene acceso a los siguientes atributos relacionados con la acci\00F3n din\00E1mica:</p>'),
'<dl>',
'  <dt>this.triggeringElement</dt>',
unistr('    <dd>Referencia al objeto DOM del elemento que dispara la acci\00F3n din\00E1mica.</dd>'),
'  <dt>this.browserEvent</dt>',
unistr('    <dd>Objeto de evento que ha disparado el evento: Nota: En la carga, ser\00E1 igual a ''load''.</dd>'),
'  <dt>this.data</dt>',
'    <dd>Datos adicionales opcionales que se pueden transferir desde el manejador de eventos.</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100720386542305109)
,p_name=>'PE.PROPERTY.JS_COND_JS_EXPRESSION_WHEN_IG.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100718358692305107)
,p_name=>'PE.PROPERTY.JS_COND_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de valores separados por comas para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100718294702305107)
,p_name=>'PE.PROPERTY.JS_COND_LIST.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100720248503305109)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de valores separados por comas para la condici\00F3n que se va a probar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100720136413305109)
,p_name=>'PE.PROPERTY.JS_COND_LIST_WHEN_IG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100758817398305137)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100758760053305137)
,p_name=>'PE.PROPERTY.JS_COND_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100720067618305108)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor de condici\00F3n que desee probar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100719994291305108)
,p_name=>'PE.PROPERTY.JS_COND_VALUE_WHEN_IG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99855453444304411)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo JavaScript que se ejecutar\00E1 cuando cargue la p\00E1gina.'),
unistr('Este c\00F3digo se ejecuta despu\00E9s del c\00F3digo JavaScript generado por &PRODUCT_NAME..</p>'),
unistr('<p>El c\00F3digo que introduzca aqu\00ED sustituye la cadena de sustituci\00F3n <code>#GENERATED_JAVASCRIPT#</code> en la plantilla de p\00E1gina.</p>'),
unistr('<p>Nota: No es necesario agregar etiquetas de <code>script</code> de apertura y de cierre, solo el c\00F3digo JavaScript.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99855306444304411)
,p_name=>'PE.PROPERTY.JS_EXECUTE_WHEN_PAGE_LOADS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecutar Cuando Se Cargue la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100357745072304834)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Referencia de archivo est\00E1ndar</dt>'),
'<dd><pre>/myjs/main.js</pre></dd>',
unistr('<dt>Referencia de archivo est\00E1ndar que carga el archivo minimizado <code>main.min.js</code> de <code>/myjs/minified/</code> para vistas de p\00E1gina normales y <code>main.js</code> de <code>/myjs/</code> en el modo de depuraci\00F3n o cuando se ejecuta la a')
||unistr('plicaci\00F3n desde el creador de aplicaciones.</dt>'),
'<dd><pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre></dd>',
unistr('<dt>Utilice esta sintaxis si la biblioteca tambi\00E9n se utiliza desde una llamada necesaria de RequireJS. El nombre definido debe coincidir con el utilizado en las rutas de acceso de requirejs.config y el valor debe ser el s\00EDmbolo global expuesto por l')
||'a biblioteca. Solo se aplica al usar RequireJS. Esto evita que RequireJS cargue esa biblioteca por segunda vez.</dt>',
'<dd><pre>[define hammerjs=Hammer]/myjs/hammer.js</pre></dd>',
unistr('<dt>Utilice esta sintaxis si el archivo depende de RequireJS. De esta forma, se cargar\00E1 autom\00E1ticamente RequireJS antes que este archivo.</dt>'),
'<dd><pre>[require requirejs]/myjs/main.js</pre></dd>',
unistr('<dt>Utilice esta sintaxis si el archivo depende de Oracle JET. De esta forma, se cargar\00E1n autom\00E1ticamente RequireJS y la configuraci\00F3n de Oracle JET RequireJS antes que este archivo.</dt>'),
'<dd><pre>[require jet]/myjs/main.js</pre></dd>',
unistr('<dt>Referencia de archivo que utiliza una cadena de consulta en la URL que hace referencia a la versi\00F3n de la aplicaci\00F3n. Por ejemplo, si se cambia la versi\00F3n de la aplicaci\00F3n (y se cambia a una versi\00F3n posterior), se indica al explorador que siempre')
||unistr(' cargue el nuevo archivo e ignore cualquier archivo almacenado en cach\00E9 anteriormente.</dt>'),
'<dd><pre>/myjs/main.js?version=#APP_VERSION#</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99855052778304411)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><p>Introduzca las URL de archivo JavaScript cargadas en esta p\00E1gina. Cada URL se debe escribir en una nueva l\00EDnea.'),
unistr('Si proporciona una versi\00F3n minimizada del archivo, puede utilizar la cadena de sustituci\00F3n <code>#MIN#</code> para incluir <code>.min</code> o <code>#MIN_DIRECTORY#</code> para incluir <code>minified/</code> en la URL de archivo para obtener una vist')
||unistr('a de p\00E1gina normal y una cadena vac\00EDa si la p\00E1gina se muestra en modo de depuraci\00F3n o al ejecutar la aplicaci\00F3n en el creador de aplicaciones.'),
unistr('Tambi\00E9n tiene acceso a la cadena de sustituci\00F3n <code>#APP_VERSION#</code> si desea incluir la versi\00F3n de la aplicaci\00F3n en la URL de archivo.</p>'),
unistr('<p>Las URL de archivos JavaScript que introduce aqu\00ED sustituyen a la cadena de sustituci\00F3n <code>#PAGE_JAVASCRIPT#</code> en la plantilla de p\00E1gina.</p>'),
'<p>Nota: No necesita incluir las etiquetas <code>script</code> de apertura o cierre. Solo especifique la URL.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99854932157304411)
,p_name=>'PE.PROPERTY.JS_FILE_URLS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'URL de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99855293627304411)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo JavaScript como funciones o declaraciones de variables globales a las que se hace referencia en esta p\00E1gina.'),
'Para hacer referencia a un acceso directo, utilice <code>"SHORTCUTNAME"</code>.',
unistr('Si se necesita el mismo JavaScript en varias p\00E1ginas, considere la posibilidad de colocar el c\00F3digo en un archivo JavaScript externo para evitar la duplicaci\00F3n y aprovechar el almacenamiento en cach\00E9 del explorador de los archivos est\00E1ticos.</p>'),
unistr('<p>El c\00F3digo que introduzca aqu\00ED sustituye a la cadena de sustituci\00F3n <code>#PAGE_JAVASCRIPT#</code> en la plantilla de p\00E1gina.</p>'),
unistr('<p>Nota: no necesita incluir etiquetas <code>script</code> de apertura o de cierre. Solo incluya el c\00F3digo JavaScript.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99855198470304411)
,p_name=>'PE.PROPERTY.JS_FUNCTION_AND_GLOBAL_VARIABLE_DECLARATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Declaraci\00F3n de Funci\00F3n y Variable Global')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100695890984305090)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca la etiqueta para la faceta.',
unistr('    La etiqueta se muestra en la p\00E1gina solo si se visualiza la faceta. La etiqueta para el tipo <strong>Buscar</strong> est\00E1 oculta visualmente, pero disponible para tecnolog\00EDas de asistencia.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100535286754304966)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>'~Introduzca la etiqueta del grupo de facetas.~'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100535454238304967)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca la etiqueta para la faceta.',
unistr('    La etiqueta se muestra en la p\00E1gina solo si se visualiza la faceta. La etiqueta para el tipo <strong>Buscar</strong> est\00E1 oculta visualmente, pero disponible para tecnolog\00EDas de asistencia.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99898401474304446)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca la etiqueta para el filtro.',
unistr('   La etiqueta se muestra en la p\00E1gina solo si se visualiza el filtro. La etiqueta para el tipo <strong>Buscar</strong> est\00E1 oculta visualmente, pero disponible para tecnolog\00EDas de asistencia.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99899370266304447)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>'~Introduzca la etiqueta del grupo de filtros.~'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99899717838304447)
,p_name=>'PE.PROPERTY.LABEL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca la etiqueta para el filtro.',
unistr('   La etiqueta se muestra en la p\00E1gina solo si se visualiza el filtro. La etiqueta para el tipo <strong>Buscar</strong> est\00E1 oculta visualmente, pero disponible para tecnolog\00EDas de asistencia.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99880915937304432)
,p_name=>'PE.PROPERTY.LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la etiqueta de campo del elemento de p\00E1gina.'),
unistr('La etiqueta se muestra en la p\00E1gina solo si aparece el elemento.'),
unistr('Seg\00FAn la alineaci\00F3n de la etiqueta y la visualizaci\00F3n, la etiqueta se muestra en su propia celda de tabla HTML o en la misma celda.</p>'),
'<p>Las etiquetas de elemento pueden incluir accesos directos mediante la sintaxis <code>"SHORTCUT_NAME"</code>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99880840368304432)
,p_name=>'PE.PROPERTY.LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99881122263304432)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione la alineaci\00F3n de etiqueta. Las etiquetas se pueden mostrar encima, debajo o a la izquierda del elemento.'),
'Cuando la etiqueta aparece junto a un elemento de pantalla, ocupa su propia celda de tabla HTML.',
unistr('Si cambia la alineaci\00F3n de esta etiqueta, puede controlar la posici\00F3n de la etiqueta dentro de la celda de tabla.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100369205787304842)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.ABOVE.D'
,p_message_language=>'es'
,p_message_text=>'Arriba '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100369393333304842)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.BELOW.D'
,p_message_language=>'es'
,p_message_text=>'Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100369587517304843)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-BOTTOM.D'
,p_message_language=>'es'
,p_message_text=>'Centro inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100369625083304843)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-CENTER.D'
,p_message_language=>'es'
,p_message_text=>'Centro centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100369768446304843)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER-TOP.D'
,p_message_language=>'es'
,p_message_text=>'Centro superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100369495149304842)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'es'
,p_message_text=>'Centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100369961565304843)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-BOTTOM.D'
,p_message_language=>'es'
,p_message_text=>'Izquierda inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100370008593304843)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-CENTER.D'
,p_message_language=>'es'
,p_message_text=>'Izquierda centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100370171217304843)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT-TOP.D'
,p_message_language=>'es'
,p_message_text=>'Izquierda superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100369835986304843)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'es'
,p_message_text=>'Izquierda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100370362193304843)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-BOTTOM.D'
,p_message_language=>'es'
,p_message_text=>'Derecha inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100370463926304843)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-CENTER.D'
,p_message_language=>'es'
,p_message_text=>'Derecha centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100370526625304843)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT-TOP.D'
,p_message_language=>'es'
,p_message_text=>'Derecha superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100370218181304843)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'es'
,p_message_text=>'Derecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99881072513304432)
,p_name=>'PE.PROPERTY.LABEL_ALIGNMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Alineaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100698312646305092)
,p_name=>'PE.PROPERTY.LAZY_LOADING.COMPONENT_PROPERTY.CARD.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea cargar la regi\00F3n independientemente de los datos de la regi\00F3n.</p>'),
unistr('        <p>Si se especifica la carga lenta, la p\00E1gina se representa inmediatamente, mostrando una regi\00F3n vac\00EDa, hasta que se cargan los datos.'),
unistr('        Generalmente, no se muestra la p\00E1gina hasta que toda la p\00E1gina est\00E1 cargada y lista para su representaci\00F3n.'),
unistr('        Por lo tanto, si tarda 5 segundos en cargarse todos los datos de una regi\00F3n, sin carga lenta, el usuario final tendr\00EDa que esperar 5 segundos antes de que la p\00E1gina comience a representarse.</p>'),
unistr('		<p>Nota: La carga lenta solo se debe utilizar en los juegos de datos que tardan mucho tiempo en cargarse, ya que esto implica una sobrecarga de procesamiento innecesaria en la base de datos para las regiones que cargan r\00E1pidamente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100077288643304583)
,p_name=>'PE.PROPERTY.LAZY_LOADING.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea cargar la regi\00F3n independientemente de los datos de la regi\00F3n.</p>'),
unistr('        <p>Si se especifica la carga lenta, la p\00E1gina se representa inmediatamente, mostrando una regi\00F3n vac\00EDa, hasta que se cargan los datos.'),
unistr('        Generalmente, no se muestra la p\00E1gina hasta que toda la p\00E1gina est\00E1 cargada y lista para su representaci\00F3n.'),
unistr('        Por lo tanto, si tarda 5 segundos en cargarse todos los datos de una regi\00F3n, sin carga lenta, el usuario final tendr\00EDa que esperar 5 segundos antes de que la p\00E1gina comience a representarse.</p>'),
unistr('		<p>Nota: La carga lenta solo se debe utilizar en los juegos de datos que tardan mucho tiempo en cargarse, ya que esto implica una sobrecarga de procesamiento innecesaria en la base de datos para las regiones que cargan r\00E1pidamente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100077103086304583)
,p_name=>'PE.PROPERTY.LAZY_LOADING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Carga Lenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100516947456304953)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si la visibilidad de la capa se puede alternar haciendo clic en su nombre en la leyenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100516869816304953)
,p_name=>'PE.PROPERTY.LEGEND_CAN_HIDE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Activar para ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100517192751304953)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique el icono que se va a mostrar para esta capa en la leyenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100517061054304953)
,p_name=>'PE.PROPERTY.LEGEND_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100132626881304665)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la posici\00F3n de una leyenda en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100132721481304665)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100133066595304665)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.BOTTOM.D'
,p_message_language=>'es'
,p_message_text=>'Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100132928150304665)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.END.D'
,p_message_language=>'es'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100132858750304665)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.START.D'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100133161979304665)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.LOV.TOP.D'
,p_message_language=>'es'
,p_message_text=>'Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100132519735304665)
,p_name=>'PE.PROPERTY.LEGEND_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100132432949304665)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se debe presentar una leyenda en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100132320177304665)
,p_name=>'PE.PROPERTY.LEGEND_RENDERED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100517364372304953)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.COMPONENT_PROPERTY.MAP_REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifica el t\00EDtulo de la leyenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100243593822304748)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el t\00EDtulo que aparecer\00E1 en la parte superior de la leyenda del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100243488154304748)
,p_name=>'PE.PROPERTY.LEGEND_TITLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100138599628304669)
,p_name=>'PE.PROPERTY.LINE_STYLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el estilo de la l\00EDnea que se va a presentar en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100138795507304670)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DASHED.D'
,p_message_language=>'es'
,p_message_text=>'De Rayas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100138654358304669)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.DOTTED.D'
,p_message_language=>'es'
,p_message_text=>'De Puntos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100138879572304670)
,p_name=>'PE.PROPERTY.LINE_STYLE.LOV.SOLID.D'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100138478841304669)
,p_name=>'PE.PROPERTY.LINE_STYLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100139356214304670)
,p_name=>'PE.PROPERTY.LINE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el tipo de l\00EDnea que se va a presentar en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100139420209304670)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100139704142304670)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSEGMENTED.D'
,p_message_language=>'es'
,p_message_text=>'Segmentada Centrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100139571565304670)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CENTEREDSTEPPED.D'
,p_message_language=>'es'
,p_message_text=>'Desplazada Centrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100139639131304670)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.CURVED.D'
,p_message_language=>'es'
,p_message_text=>'Curva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100140088392304670)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100139926673304670)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.SEGMENTED.D'
,p_message_language=>'es'
,p_message_text=>'Segmentada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100139805694304670)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STEPPED.D'
,p_message_language=>'es'
,p_message_text=>'Desplazada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100140161596304671)
,p_name=>'PE.PROPERTY.LINE_TYPE.LOV.STRAIGHT.D'
,p_message_language=>'es'
,p_message_text=>'Recta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100139273724304670)
,p_name=>'PE.PROPERTY.LINE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100139058866304670)
,p_name=>'PE.PROPERTY.LINE_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el ancho de la l\00EDnea que se va a presentar en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100138940035304670)
,p_name=>'PE.PROPERTY.LINE_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ancho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100139181535304670)
,p_name=>'PE.PROPERTY.LINE_WIDTH.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('p\00EDxeles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100386131849304855)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Abrir el enlace en una nueva ventana</dt>',
'<dd><pre>target="_blank"</pre></dd>',
'<dt>Mostrar una pista al pasar el mouse</dt>',
'<dd><pre>title="Haga clic para editar"</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100183162203304703)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca los atributos de enlace de columna adicionales que se incluir\00E1n en la etiqueta <code>&lt;a href=...&gt;</code>, como destino del enlace, clases o estilos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100183075689304703)
,p_name=>'PE.PROPERTY.LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atributos de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100188859267304707)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Tambi\00E9n puede seleccionar un esquema de autorizaci\00F3n para asociarlo a la columna de enlace. Este esquema de autorizaci\00F3n se debe evaluar en TRUE para que la columna de enlace se represente en el informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100188732067304707)
,p_name=>'PE.PROPERTY.LINK_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100601185368305016)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para evaluar la expresi\00F3n introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100601532662305016)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100601419838305016)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100601328092305016)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100601687838305016)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100601289814305016)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100601031870305016)
,p_name=>'PE.PROPERTY.LINK_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100603139976305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100603470792305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100603303643305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100603248927305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100603513236305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100603057296305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100197441922304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que se utiliza en esta condici\00F3n. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100197371431304713)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM1.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100198889290304715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina utilizado en esta condici\00F3n. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100198720509304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_ITEM2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100602712255305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Java para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100602620640305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100604386120305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Java que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100604236729305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100602512259305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100602441738305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n JavaScript para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100602318378305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100604158556305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100604069615305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n JavaScript que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100603982726305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100197632487304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de valores separados por dos puntos (:) para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100197524665304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_LIST.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100198074601304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero de p\00E1gina para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100197917214304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100198203145304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de n\00FAmeros de p\00E1gina separados por comas para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100198135577304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PAGES.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100602289630305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100602117815305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n PL/SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100602018457305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100603853321305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100603750111305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n PL/SQL que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100603638108305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100197837340304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una preferencia de usuario que se compare con el valor especificado para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100197749575304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Preferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100602934352305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Python para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100602897605305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100604586014305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Python que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100604411777305018)
,p_name=>'PE.PROPERTY.LINK_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100601987676305017)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Para volver correctamente cuando el empleado es un gestor y su departamento se encuentra en Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100601898843305016)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100601798373305016)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100744022549305126)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente porque existen una o m\00E1s filas al comprobar si el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Para volver correctamente porque no existen filas al comprobar si el empleado est\00E1 en el departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100197025105304713)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una consulta SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100196962002304713)
,p_name=>'PE.PROPERTY.LINK_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100198407924304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor de texto para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100198318535304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100199022142304715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor, incluidas las cadenas de sustituci\00F3n <code>&ITEM.</code>, para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100198997528304715)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TEXT2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100196847067304713)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un tipo de condici\00F3n que se debe cumplir para que represente este enlace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100447905955304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'es'
,p_message_text=>'Siempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100583686523305003)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El componente siempre se presentar\00E1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100446591332304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es Microsoft Internet Explorer 7.0 o superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100446638693304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es un explorador compatible con XHTML/CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100446453254304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es Mozilla, Netscape 6.x/7x o superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100446702264304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'es'
,p_message_text=>unistr('El explorador del cliente son otros exploradores (o versi\00F3n anterior)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100445169904304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto est\00E1 incluido en el elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100447127245304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'es'
,p_message_text=>'Idioma Actual = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100587245837305006)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 ejecutando la aplicaci\00F3n en el idioma que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100446861350304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'es'
,p_message_text=>unistr('El idioma actual est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100587496222305006)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 ejecutando la aplicaci\00F3n en uno de los idiomas que se introducen en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100447095285304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'es'
,p_message_text=>'Idioma Actual != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100587322616305006)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 ejecutando la aplicaci\00F3n en el idioma que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100446943048304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'es'
,p_message_text=>unistr('El idioma actual no est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100587502926305006)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 ejecutando la aplicaci\00F3n en ninguno de los idiomas que se introducen en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100444387530304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual = P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100586097048305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual es igual que el valor que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100444513222304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en una lista delimitada por comas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100586204291305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en la lista delimitada por comas que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100444438275304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual != P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100586189233305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual no es igual que el valor que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100444690413304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en una lista no delimitada por comas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100586359619305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual no est\00E1 en la lista delimitada por comas que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100447279654304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: DAD_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100447378195304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: DAD_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100446007390304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Errores de Validaci\00F3n en L\00EDnea Mostrados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100587082884305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('En la p\00E1gina se muestra un error de validaci\00F3n en l\00EDnea despu\00E9s de una ejecuci\00F3n de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100445431183304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Texto = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100445233054304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100445323914304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto no est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100445580135304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Texto != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100442001202304898)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Filas Devueltas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100583726566305003)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta SQL devuelve una o m\00E1s filas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100600838042305016)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100600903593305016)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La expresi\00F3n se eval\00FAa en TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100442201835304898)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100583945661305003)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El cuerpo de la funci\00F3n devuelve TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100447654311304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100447785549304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100445708273304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina/Regi\00F3n NO Es de S\00F3lo Lectura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100586735737305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La regi\00F3n principal o de p\00E1gina, si son las adecuadas, se muestran con normalidad.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100445636847304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina/Regi\00F3n Es de S\00F3lo Lectura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100586676527305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Ya se trate de una regi\00F3n principal o de p\00E1gina, si son las adecuadas, la condici\00F3n "Solo Lectura" se eval\00FAa en TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100443542560304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'es'
,p_message_text=>'El elemento no contiene espacios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100585214820305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>elemento</em> seleccionado no tiene espacios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100443870911304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es alfanum\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100585587223305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es alfanum\00E9rico, es decir, contiene solo letras y n\00FAmeros y ning\00FAn car\00E1cter especial.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100443008707304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es no nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100584791055305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100443722372304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es no num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100585462880305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no es num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100443224324304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento NO es cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100584962406305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100442999675304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'es'
,p_message_text=>'El Elemento es NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100584609167305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>Elemento</em> seleccionado est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100443313960304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es nulo o cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100585087753305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado est\00E1 vac\00EDo o es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100443685854304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100585358745305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100443181382304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100584832169305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100443464447304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es no nulo y no cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100585104108305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 vac\00EDo y no es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100446237862304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'es'
,p_message_text=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Adelante)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100446383177304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Atr\00E1s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100447860643304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'es'
,p_message_text=>'Nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100587626808305006)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>El componente nunca se presenta.</p>',
unistr('<p>Nota: cambiar una condici\00F3n a <strong>Nunca</strong> eliminar\00E1 cualquier condici\00F3n existente. Para desactivar un componente temporalmente, Oracle recomienda utilizar en su lugar el atributo <em>Opci\00F3n de Creaci\00F3n</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100446145695304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Errores de Validaci\00F3n en L\00EDnea No Mostrados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100587118823305006)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El error de validaci\00F3n en l\00EDnea no se muestra en la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100442198476304898)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Ninguna Fila Devuelta'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100583884263305003)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>'La consulta SQL no devuelve ninguna fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100444914166304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en modo Versi\00F3n para Impresora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100586478955305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final ha cambiado la p\00E1gina actual al modo "Versi\00F3n para Impresora".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100445049728304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual no en modo Versi\00F3n para Impresora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100586588744305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no ha cambiado la p\00E1gina actual al modo "Versi\00F3n para Impresora".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100442392008304898)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'Solicitud = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100584080436305003)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina es igual que el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100442536838304898)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud est\00E1 incluida en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100584244170305003)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina se incluye en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100442491537304898)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'Solicitud != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100584101434305003)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina no es igual que el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100442685904304898)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud no est\00E1 incluida en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100584331669305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina no se incluye en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100447469825304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100447513441304902)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100445861360304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Usuario Autenticado  (no p\00FAblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100586872931305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 conectado a la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100445926124304901)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'es'
,p_message_text=>unistr('El Usuario es el Usuario P\00FAblico (el usuario no se ha autenticado)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100586996698305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 conectado a la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100444125019304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia del Usuario = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100585879423305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor de la <em>preferencia</em> introducida es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100444287893304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia del Usuario != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100585934554305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor de la <em>preferencia</em> introducida no es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100443905867304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento est\00E1 en una lista delimitada por dos puntos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100585646049305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado est\00E1 totalmente incluido en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100444058922304899)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento est\00E1 en una lista no delimitada por dos puntos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100585776639305005)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 totalmente incluido en el texto introducido en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100442742410304898)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Elemento = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100584429068305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>Elemento</em> seleccionado es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100442838149304898)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Elemento != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100584530039305004)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>Elemento</em> seleccionado no es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100444875222304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual != P\00E1gina Ejecutada (enviada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100444779944304900)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual = P\00E1gina Ejecutada (enviada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100196737929304713)
,p_name=>'PE.PROPERTY.LINK_CONDITION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Condici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100197214170304713)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor que se va a comparar con la condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100197124357304713)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE1.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100198648973304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor, incluidas las cadenas de sustituci\00F3n <code>&ITEM.</code>, para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100198574519304714)
,p_name=>'PE.PROPERTY.LINK_CONDITION_VALUE2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100330351906304814)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las regiones de los informes se pueden imprimir con un enlace est\00E1ndar de impresi\00F3n situado debajo de la regi\00F3n o mediante un bot\00F3n. Si desea utilizar un bot\00F3n, elimine la etiqueta de enlace y cree un bot\00F3n en la p\00E1gina con la direcci\00F3n URL mostra')
||unistr('da en URL de Impresi\00F3n como destino.</p>'),
unistr('<p>Si utiliza botones para imprimir regiones de informes, puede definir el estado de la sesi\00F3n. Esto resulta de utilidad si desea que se pueda imprimir en distintos formatos de salida (Word, Excel y PDF, entre otros) y que aparezca un bot\00F3n, un enlac')
||unistr('e o una imagen para cada una de las opciones. Para esta implantaci\00F3n, utilice el formato de salida derivado de la opci\00F3n del elemento e incluya su nombre y su valor en la direcci\00F3n URL de impresi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100559417507304985)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.IG_SAVED_REPORT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vea el enlace de la URL de este informe guardado. Este atributo es solo de visualizaci\00F3n y no se puede actualizar.</p>'),
unistr('    <p>Este atributo le permite copiar r\00E1pidamente la URL mostrada. Esta URL se puede utilizar para enlazarse directamente a este informe guardado en particular desde cualquier lugar de la aplicaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100330977661304814)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las regiones de los informes se pueden imprimir con un enlace est\00E1ndar de impresi\00F3n situado debajo de la regi\00F3n o mediante un bot\00F3n. Si desea utilizar un bot\00F3n, elimine la etiqueta de enlace y cree un bot\00F3n en la p\00E1gina con la direcci\00F3n URL mostra')
||unistr('da en URL de Impresi\00F3n como destino de bot\00F3n.</p>'),
unistr('<p>Si utiliza botones para imprimir regiones de informes, puede definir el estado de la sesi\00F3n. Esto resulta de utilidad si desea que se pueda imprimir en distintos formatos de salida (Word, Excel y PDF, entre otros) y que aparezca un bot\00F3n, un enlac')
||unistr('e o una imagen para cada una de las opciones. Para esta implantaci\00F3n, utilice el formato de salida derivado de la opci\00F3n del elemento e incluya su nombre y su valor en la direcci\00F3n URL de impresi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100199786157304715)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Vea el enlace de la URL de este informe guardado. Este atributo es solo de visualizaci\00F3n y no se puede actualizar.</p>'),
unistr('<p>Este atributo le permite copiar r\00E1pidamente la URL mostrada. Esta URL se puede utilizar para enlazarse directamente a este informe guardado en particular desde cualquier lugar de la aplicaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100199673710304715)
,p_name=>'PE.PROPERTY.LINK_EXAMPLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ejemplo de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100188601481304707)
,p_name=>'PE.PROPERTY.LINK_ICON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el HTML que se utilizar\00E1 para el enlace. Utilice una etiqueta de imagen para mostrar im\00E1genes o seleccione una de la lista de im\00E1genes por defecto. Si no se define, se utilizar\00E1 <code>#IMAGE_PREFIX#ws/small_page.gif</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100188524658304707)
,p_name=>'PE.PROPERTY.LINK_ICON.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Icono de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100199302647304715)
,p_name=>'PE.PROPERTY.LINK_TARGET.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Haga clic en el destino para llamar a un cuadro de di\00E1logo modal. Puede introducir un destino personalizado para que se llame al hacer clic en Columna de Enlace.</p>'),
unistr('        <p>Seleccione el tipo adecuado en Creador de Enlaces: Destino; seg\00FAn sus requisitos:'),
'        <dl>',
unistr('        <dt>P\00E1gina en esta aplicaci\00F3n</dt>'),
'        <dd>Introduzca lo siguiente:',
'        <ul>',
unistr('        <li>P\00E1gina: Introduzca el n\00FAmero de p\00E1gina o el alias de p\00E1gina para la navegaci\00F3n. Tambi\00E9n puede seleccionar el n\00FAmero de p\00E1gina de la lista de selecci\00F3n.</li>'),
unistr('        <li>Definir Elementos: Nombre - Introduzca o seleccione los elementos de p\00E1gina (<code>P3_ID</code>), los elementos de aplicaci\00F3n (<code>LAST_PAGE</code>) o los filtros de informes interactivos (<code>IR_EMPNO</code>) que se van a definir en ')
||unistr('el estado de sesi\00F3n.</li>'),
unistr('        <li>Definir Elementos: Valor - Introduzca o seleccione una columna de informe (<code>#ID#</code>), introduzca una aplicaci\00F3n o elemento de p\00E1gina (<code>&P2_EMPNO.</code>), o introduzca un valor est\00E1tico (<code>2</code>).</li>'),
unistr('        <li>Borrar Cach\00E9: Introduzca una lista de n\00FAmero de p\00E1ginas delimitada por comas (<code>2,3</code>), los elementos (<code>P3_EMPNO,LAST_PAGE</code>) y la configuraci\00F3n del informe que se va a borrar. Para restablecer la paginaci\00F3n de un infor')
||unistr('me, introduzca <code>RP</code>. Para borrar o restablecer la configuraci\00F3n del informe interactivo, introduzca <code>CIR</code> o <code>RIR</code>.</li>'),
unistr('        <li>Restablecer Paginaci\00F3n: Seleccione S\00ED para restablecer la paginaci\00F3n, vuelva al primer juego de registros, para obtener los informes en la p\00E1gina de destino. Esta acci\00F3n tiene el mismo efecto que transferir <code>RP</code> en Borrar Cach\00E9')
||'.</li>',
'        <li>Avanzado: Solicitud: Introduzca la solicitud que se va a utilizar.</li>',
'        </ul>',
'        </dd>',
unistr('        <dt>P\00E1gina en una aplicaci\00F3n diferente.</dt>'),
unistr('        <dd>Introduzca los mismos atributos como se muestra para P\00E1gina en esta aplicaci\00F3n, con la particularidad de que necesita introducir el ID de aplicaci\00F3n o el alias de aplicaci\00F3n para la aplicaci\00F3n.</dd>'),
'        <dt>URL</dt>',
'        <dd>Introduzca la URL</dd>',
'        </dl></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100199213092304715)
,p_name=>'PE.PROPERTY.LINK_TARGET.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100517701764304954)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la acci\00F3n que se va a realizar al hacer clic en un objeto del mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100134489818304666)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la acci\00F3n que se va a realizar al hacer clic en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100093784424304596)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Redireccionar a la URL que devuelva la primera columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100093804367304596)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.DEPRECATED_LINK_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Redireccionar a la URL de destino que devuelva la primera columna de la consulta SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100134793298304666)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.D'
,p_message_language=>'es'
,p_message_text=>unistr('Redirigir a P\00E1gina en Otra Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100134889301304667)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_APP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Redirige a una p\00E1gina en otra aplicaci\00F3n, con atributos adicionales opcionales para restablecer la paginaci\00F3n, definir el valor de solicitud, borrar la cach\00E9 y definir los valores del elemento en la p\00E1gina de destino.</p>'),
unistr('<p>Nota: La redirecci\00F3n a una p\00E1gina en una aplicaci\00F3n diferente depende de que se active el enlace profundo en la aplicaci\00F3n de destino. Para activar el enlace profundo, vaya a los atributos de <em>seguridad</em> de la aplicaci\00F3n y active <em>Enlace')
||' profundo</em>.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100134598190304666)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Redirigir a P\00E1gina en esta Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100134685400304666)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Redirige a una p\00E1gina en la aplicaci\00F3n actual, con atributos adicionales opcionales para restablecer la paginaci\00F3n, definir el valor de solicitud, borrar la cach\00E9 y definir los valores del elemento en la p\00E1gina de destino.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100134975302304667)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.D'
,p_message_language=>'es'
,p_message_text=>'Redirigir a URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100135081739304667)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.LOV.REDIRECT_URL.HELP'
,p_message_language=>'es'
,p_message_text=>'Redirige a la URL de destino que especifique.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100134399664304666)
,p_name=>'PE.PROPERTY.LINK_TARGET_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100182911974304703)
,p_name=>'PE.PROPERTY.LINK_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto HTML que se muestra como enlace. Utilice una etiqueta de imagen para mostrar im\00E1genes o seleccione una de la lista de im\00E1genes por defecto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100182876426304703)
,p_name=>'PE.PROPERTY.LINK_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99495407358304137)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una plantilla para definir la apariencia y el dise\00F1o de esta lista.</p>'),
unistr('        <p>Las plantillas de lista se definen en el tema de la aplicaci\00F3n.'),
unistr('        Al crear una regi\00F3n de lista, la plantilla se define autom\00E1ticamente en la plantilla de lista por defecto definida en el tema actual.</p>'),
'        <p>El tema universal proporciona las siguientes plantillas de lista:',
'          <dl>',
'            <dt>Lista de placas</dt>',
'            <dt>Tarjetas</dt>',
'            <dt>Lista de enlaces</dt>',
'            <dt>Lista de medios</dt>',
unistr('            <dt>Barra de men\00FAs</dt>'),
unistr('            <dt>Men\00FA emergente</dt>'),
unistr('            <dt>Barra de navegaci\00F3n</dt>'),
unistr('            <dt>Men\00FA de navegaci\00F3n lateral</dt>'),
'            <dt>Separadores</dt>',
unistr('            <dt>Men\00FA de navegaci\00F3n superior</dt>'),
'            <dt>Progreso del asistente</dt>',
'          </dl>',
unistr('          Consulte tambi\00E9n: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de Ejemplo de Tema Universal</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99495305069304137)
,p_name=>'PE.PROPERTY.LIST_TEMPLATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100563481635304988)
,p_name=>'PE.PROPERTY.LIST_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el tipo de lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100563939785304988)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100564014060304988)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.FUNCTION_RETURNING_SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La lista din\00E1mica se basa en la consulta SQL devuelta por el cuerpo de la funci\00F3n PL/SQL introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100563718698304988)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100563832938304988)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La lista din\00E1mica se basa en la consulta SQL que introduzca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100563580058304988)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100563605064304988)
,p_name=>'PE.PROPERTY.LIST_TYPE.LOV.STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La lista est\00E1tica se basa en el valor de texto que introduzca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100563326907304988)
,p_name=>'PE.PROPERTY.LIST_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100248844085304753)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero total de d\00EDas que se muestra en la vista de agenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100248740926304753)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de D\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100248941025304753)
,p_name=>'PE.PROPERTY.LIST_VIEW_CUSTOM_DAYS.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('d\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100248673034304753)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione los d\00EDas que se van a mostrar para el calendario de la vista de lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100408142198304874)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.D'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100408271746304874)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.CUSTOM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra las entradas de calendario seg\00FAn el n\00FAmero de d\00EDas que introduzca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100407762663304873)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.D'
,p_message_language=>'es'
,p_message_text=>'Mes Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100407845532304873)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.MONTH.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra las entradas de calendario para el mes actual.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100407923610304874)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.D'
,p_message_language=>'es'
,p_message_text=>unistr('A\00F1o Actual')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100408005478304874)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.LOV.YEAR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra las entradas de calendario para el a\00F1o actual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100248563071304753)
,p_name=>'PE.PROPERTY.LIST_VIEW_DAYS_DISPLAY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99998753314304524)
,p_name=>'PE.PROPERTY.LOGIN_URL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la p\00E1gina de conexi\00F3n de la aplicaci\00F3n para la interfaz de usuario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99998634867304524)
,p_name=>'PE.PROPERTY.LOGIN_URL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('URL de Conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99943138204304481)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca a d\00F3nde se redirecciona &PRODUCT_NAME. despu\00E9s de la desconexi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100377299273304848)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100377362461304848)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.HOME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Redirige al valor Enlace de P\00E1gina Inicial especificado en los atributos de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100377477283304848)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.D'
,p_message_language=>'es'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100377508197304849)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.LOV.URL.HELP'
,p_message_language=>'es'
,p_message_text=>'Redirige a la URL que introduzca, como <code>f?p=&amp;APP_ID.:101:&amp;SESSION</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99943006221304481)
,p_name=>'PE.PROPERTY.LOGOUT_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Desconexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100076295165304583)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione c\00F3mo proteger los datos en las actualizaciones perdidas.'),
unistr('		Las actualizaciones perdidas se producen cuando dos o m\00E1s usuarios intentan actualizar los mismos datos y la \00FAltima actualizaci\00F3n sobrescribe las actualizaciones realizadas por el primer usuario para guardar los cambios.'),
unistr('		Para evitar que esto ocurra, las actualizaciones pueden comprobar los valores de columna existentes en la base de datos con los valores recuperados cuando se consult\00F3 el registro originalmente.</p>'),
'		<p>Por ejemplo:',
'          <ol>',
'            <li>El usuario A consulta los registros del empleado (EMP).</li>',
'		    <li>El usuario B consulta los mismos registros de empleado.</li>',
'		    <li>El usuario B actualiza los detalles del empleado para EMPNO = 7839 y aplica (confirma) los cambios en la base de datos.</li>',
'		    <li>El usuario A actualiza los detalles del empleado para EMPNO = 7839 e intenta aplicar los cambios en la base de datos.</li>',
'          </ol>',
unistr('          Si el usuario A actualiza correctamente el mismo registro, los cambios realizados por el usuario B se perder\00E1n.</p>'),
unistr('         <p>Cuando el usuario A intenta guardar el registro del empleado, los datos de la base de datos son diferentes de los que el usuario A consult\00F3 originalmente.'),
'		  En el paso 1 anterior, se pueden capturar los valores de la columna consultados originalmente por el usuario A.',
unistr('		  A continuaci\00F3n, en el paso 4 anterior, los valores se pueden comparar con los valores actuales de la base de datos.'),
unistr('		  Esta comparaci\00F3n generar\00E1 un error para el usuario A, ya que los valores de la base de datos los ha actualizado el usuario B en el paso 3.'),
'          Esto evita que el usuario sobrescriba los cambios realizados por otro usuario en la misma fila.</p>',
unistr('		  <p>Nota: El campo Tipo de Actualizaci\00F3n Perdida solo se utilizar\00E1 si el proceso correspondiente, Cuadr\00EDcula Interactiva - Procesamiento Autom\00E1tico de Filas (DML), tiene la activada la opci\00F3n <strong>Evitar Actualizaciones Perdidas</strong> activa')
||'da.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100076400729304583)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.D'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Versi\00F3n de Fila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100206277028304720)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Si la tabla de la base de datos incluye una columna que se incrementa cada vez que se actualiza un registro, preferiblemente mediante un disparador de base de datos, se puede utilizar esta columna en lugar de calcular los totales de control.',
unistr('        Esta opci\00F3n no se debe utilizar si la cuadr\00EDcula interactiva actualiza datos en varias tablas.</p>'),
unistr('        <p>Nota: La columna de versi\00F3n de fila se debe incluir en el origen SQL de la regi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100076325479304583)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.D'
,p_message_language=>'es'
,p_message_text=>'Valores de Fila'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100206101125304720)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.LOV.VALUES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se calcular\00E1 un valor de total de control para cada fila al consultar inicialmente los datos.'),
unistr('        El total de control se calcula concatenando todas las columnas actualizables en una cadena y generando un valor \00FAnico.'),
unistr('        Al confirmar el registro actualizado, este total de control se comparar\00E1 con el valor de total de control del registro de base de datos actual.'),
unistr('        Si no son iguales, se generar\00E1 un error.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100076122399304583)
,p_name=>'PE.PROPERTY.LOST_UPDATE_CHECK_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Actualizaci\00F3n Perdida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100615554263305027)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100615899875305027)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100615709952305027)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100615661302305027)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100615983568305027)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100615425608305027)
,p_name=>'PE.PROPERTY.LOV_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100616752284305027)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el cuerpo de la funci\00F3n Java que devuelve una consulta SQL para rellenar esta lista de valores. Normalmente, las consultas de lista de valores tienen este formato:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100616647698305027)
,p_name=>'PE.PROPERTY.LOV_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100616537123305027)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Mostrar el nombre del departamento, definir el n\00FAmero del departamento</dt>'),
'<dd><pre>',
'return "select dname as d, deptno as r from dept order by 1";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100616463029305027)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el cuerpo de la funci\00F3n JavaScript que devuelve una consulta SQL para rellenar esta lista de valores. Normalmente, las consultas de lista de valores tienen este formato:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100616342594305027)
,p_name=>'PE.PROPERTY.LOV_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100211953289304724)
,p_name=>'PE.PROPERTY.LOV_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el nombre de esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100211821089304724)
,p_name=>'PE.PROPERTY.LOV_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99941045935304480)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca los elementos de p\00E1gina, columna o aplicaci\00F3n que desea definir en el estado de la sesi\00F3n cuando cualquiera de los elementos principales de lista de valores en cascada especificados cambie en esta p\00E1gina.'),
'Para varios elementos, separe cada nombre de elemento con una coma.',
'Puede escribir el nombre o seleccionarlo de la lista de elementos disponibles.',
'Si selecciona de la lista y ya hay texto introducido, se coloca una coma al final del texto existente, seguida del nombre del elemento devuelto de la lista.</p>',
unistr('<p>Debe utilizar los elementos de p\00E1gina especificados en este atributo en la <em>cl\00E1usula where</em> de esta consulta SQL de lista de valores para restringir los valores devueltos.</p>'),
unistr('<p>Nota: Los elementos de p\00E1gina definidos en <em>Elementos Principales de Lista de Valores en Cascada</em> se transmiten autom\00E1ticamente, por lo que no es necesario introducirlos en este atributo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99940996126304479)
,p_name=>'PE.PROPERTY.LOV_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elementos a Ejecutar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100616253189305027)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Mostrar el nombre del departamento, definir el n\00FAmero del departamento</dt>'),
'<dd><pre>',
'begin',
'    return ''select dname as d, deptno as r from dept order by 1'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100616165238305027)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL para rellenar esta lista de valores. Normalmente, las consultas de lista de valores tienen este formato:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100616069683305027)
,p_name=>'PE.PROPERTY.LOV_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100616911590305028)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el cuerpo de la funci\00F3n Python que devuelve una consulta SQL para rellenar esta lista de valores. Normalmente, las consultas de lista de valores tienen este formato:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100616897309305028)
,p_name=>'PE.PROPERTY.LOV_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100679760778305075)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la definici\00F3n de la consulta SQL para rellenar esta lista de valores. Por lo general, las consultas de listas de valores tienen la forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>'),
'<p>Nota: Al definir un tipo de elemento Lista de valores emergente, si desea visualizar varias columnas en la ventana emergente, debe definir la lista de valores en Componentes compartidos,',
unistr('con los metadatos adicionales necesarios. La lista de valores en l\00EDnea solo se puede utilizar para visualizar columnas individuales de listas de valores emergentes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100535517843304967)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la definici\00F3n de la consulta SQL para rellenar esta lista de valores. Por lo general, las consultas de listas de valores tienen la forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>'),
'<p>Nota: Al definir un tipo de elemento Lista de valores emergente, si desea visualizar varias columnas en la ventana emergente, debe definir la lista de valores en Componentes compartidos,',
unistr('con los metadatos adicionales necesarios. La lista de valores en l\00EDnea solo se puede utilizar para visualizar columnas individuales de listas de valores emergentes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100695748525305090)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la definici\00F3n de la consulta SQL para rellenar esta lista de valores. Por lo general, las consultas de listas de valores tienen la forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>'),
'<p>Nota: Al definir un tipo de elemento Lista de valores emergente, si desea visualizar varias columnas en la ventana emergente, debe definir la lista de valores en Componentes compartidos,',
unistr('con los metadatos adicionales necesarios. La lista de valores en l\00EDnea solo se puede utilizar para visualizar columnas individuales de listas de valores emergentes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100679675082305075)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la definici\00F3n de la consulta SQL para rellenar esta lista de valores. Por lo general, las consultas de listas de valores tienen la forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>'),
'<p>Nota: Al definir un tipo de elemento Lista de valores emergente, si desea visualizar varias columnas en la ventana emergente, debe definir la lista de valores en Componentes compartidos,',
unistr('con los metadatos adicionales necesarios. La lista de valores en l\00EDnea solo se puede utilizar para visualizar columnas individuales de listas de valores emergentes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99898635658304446)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la definici\00F3n de la consulta SQL para rellenar esta lista de valores. Por lo general, las consultas de listas de valores tienen la forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>'),
'<p>Nota: Al definir un tipo de elemento Lista de valores emergente, si desea visualizar varias columnas en la ventana emergente, debe definir la lista de valores en Componentes compartidos,',
unistr('con los metadatos adicionales necesarios. La lista de valores en l\00EDnea solo se puede utilizar para visualizar columnas individuales de listas de valores emergentes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99899920282304447)
,p_name=>'PE.PROPERTY.LOV_SQL.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la definici\00F3n de la consulta SQL para rellenar esta lista de valores. Por lo general, las consultas de listas de valores tienen la forma:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>'),
'<p>Nota: Al definir un tipo de elemento Lista de valores emergente, si desea visualizar varias columnas en la ventana emergente, debe definir la lista de valores en Componentes compartidos,',
unistr('con los metadatos adicionales necesarios. La lista de valores en l\00EDnea solo se puede utilizar para visualizar columnas individuales de listas de valores emergentes.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100451056444304904)
,p_name=>'PE.PROPERTY.LOV_SQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Mostrar el nombre del departamento, definir el n\00FAmero del departamento</dt>'),
'<dd><pre>',
'select dname  as d,',
'       deptno as r',
'  from dept',
' order by 1',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100202024947304717)
,p_name=>'PE.PROPERTY.LOV_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la definici\00F3n de consulta SQL para rellenar esta lista de valores. Normalmente, las consultas de lista de valores tienen este formato:</p>'),
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
unistr('<p>Cada columna seleccionada debe tener un nombre o alias \00FAnico. Oracle recomienda utilizar un alias en cualquier columna que incluya una expresi\00F3n SQL.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100201998942304717)
,p_name=>'PE.PROPERTY.LOV_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100202414055304717)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca los valores de esta lista est\00E1tica de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100202334594304717)
,p_name=>'PE.PROPERTY.LOV_STATIC_VALUES.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100202251055304717)
,p_name=>'PE.PROPERTY.LOV_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el tipo de lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100588629431305007)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100588748219305007)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La lista de valores din\00E1mica se basa en la consulta SQL devuelta por el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100074020329304581)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.D'
,p_message_language=>'es'
,p_message_text=>'Componente Compartido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100074148617304581)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SHARED.HELP'
,p_message_language=>'es'
,p_message_text=>'La lista de valores se basa en una lista de valores predefinida, que se ha definido en Componentes Compartidos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100074259738304581)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100074350476304581)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La lista de valores din\00E1mica se basa en la consulta SQL que introduzca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100390894272304858)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100390933645304859)
,p_name=>'PE.PROPERTY.LOV_TYPE.LOV.STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La lista de valores est\00E1tica se basa en el valor de texto que introduzca.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100202172743304717)
,p_name=>'PE.PROPERTY.LOV_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99870599974304423)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el modo de mantenimiento del estado de la sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99828012124304386)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Por solicitud (solo memoria)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99828169327304386)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.N.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('No guarde el estado en la base de datos. El estado solo est\00E1 disponible al procesar la solicitud actual. Cuando las solicitudes AJAX necesiten utilizar un elemento, aseg\00FArese de transferir el nombre del mismo mediante "Elementos de p\00E1gina que ejecuta')
||'r".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100372978937304845)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.D'
,p_message_language=>'es'
,p_message_text=>'Por usuario (disco)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100667483419305065)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.U.HELP'
,p_message_language=>'es'
,p_message_text=>'Mantener para un usuario almacenando el valor en la base de datos, de forma que se acceda al mismo entre solicitudes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100372805682304845)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>unistr('Por sesi\00F3n (disco)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100667344444305065)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.LOV.Y.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Mantener para cada sesi\00F3n almacenando el valor en la base de datos, de forma que se acceda al mismo entre solicitudes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99870485641304423)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Mantener Estado de Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99828362496304386)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el modo de mantenimiento del estado de la sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99828443677304386)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Por solicitud (solo memoria)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99828553045304386)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.N.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('No guarde el estado en la base de datos. El estado solo est\00E1 disponible al procesar la solicitud actual. Cuando las solicitudes AJAX necesiten utilizar un elemento, aseg\00FArese de transferir el nombre del mismo mediante "Elementos de p\00E1gina que ejecuta')
||'r".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99828622435304386)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>unistr('Por sesi\00F3n (disco)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99828745024304387)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.LOV.Y.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Mantener para cada sesi\00F3n almacenando el valor en la base de datos, de forma que se acceda al mismo entre solicitudes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99828294172304386)
,p_name=>'PE.PROPERTY.MAINTAIN_SESSION_STATE_FORM.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Mantener Estado de Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100145336847304674)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione si se presentan las marcas principales.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100145498055304674)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100145631907304675)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.OFF.D'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100145558970304675)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.LOV.ON.D'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100145220784304674)
,p_name=>'PE.PROPERTY.MAJOR_TICK_RENDERED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100490472721304933)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100490345269304933)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Especifique el color del relleno para mostrar un cluster de puntos.',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100490281480304933)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Relleno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100489683437304932)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique las clases CSS de icono que usar para mostrar un cluster de puntos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100489504756304932)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_CSS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100489463068304932)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique la URL a la imagen que usar para mostrar un cluster de puntos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100489348599304932)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_IMAGE_PATH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'URL de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100489886443304932)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la forma SVG para mostrar un cluster de puntos. Seleccione una de las formas predefinidas o introduzca el nombre de una <em>forma SVG personalizada</em>, que se especifica en el atributo de la regi\00F3n de mapa <strong>Estilos SVG personaliz')
||unistr('ados</strong>. Si el nombre especificado no est\00E1 en la lista de estilos SVG por defecto o personalizados, se utilizar\00E1 el <strong>marcador por defecto</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100523371857304958)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1mara')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100531188598304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100527970576304961)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'es'
,p_message_text=>'Comprobar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100532466314304965)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100523452457304958)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Alternativa al c\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100531339574304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100490080993304933)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'es'
,p_message_text=>unistr('C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100531237632304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100523220116304958)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100531028435304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100523507632304958)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'es'
,p_message_text=>unistr('Ce\00F1o fruncido')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100531421996304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100523611795304958)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'es'
,p_message_text=>'Indiferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100531501469304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100523701251304958)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'es'
,p_message_text=>'Sonrisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100531627553304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100528456165304962)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'es'
,p_message_text=>unistr('Bander\00EDn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100532992637304965)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100528565445304962)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'es'
,p_message_text=>'Estandarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100533032799304965)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100524167768304959)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'es'
,p_message_text=>unistr('Coraz\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100532147019304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100528007004304961)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100532501313304965)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100524216176304959)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'es'
,p_message_text=>unistr('Pent\00E1gono')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100532280500304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100523997767304958)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Anclar c\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100531901548304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100524081977304959)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'es'
,p_message_text=>'Anclar cuadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100532020029304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100528241055304962)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'es'
,p_message_text=>'Brillo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100532737708304965)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100528103572304962)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'es'
,p_message_text=>'Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100532622463304965)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100523833559304958)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'es'
,p_message_text=>'Alternativa al cuadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100531849242304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100489903558304933)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'es'
,p_message_text=>'Cuadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100531773691304964)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100528300914304962)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'es'
,p_message_text=>'Vista de calle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100532863647304965)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100490115826304933)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Tri\00E1ngulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100532357235304965)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100489704389304932)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100524476959304959)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el factor de escala de la forma SVG para mostrar un cluster de puntos. La escala m\00E1xima es <strong>10</strong>, y el componente de mapa redondear\00E1 el valor al primer d\00EDgito decimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100524327613304959)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Escala de la forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100493644882304935)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Radio del cluster en p\00EDxeles. Si se especifica un valor <strong>80</strong>, los puntos en un rango de 80 p\00EDxeles entre s\00ED'),
unistr('se agregar\00E1n a un cluster de puntos.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100493595664304935)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Radio de clusters'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100493756598304935)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_THRESHOLD.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('p\00EDxeles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100514404790304951)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las expresiones HTML que se mostrar\00E1n como pistas al pasar el mouse sobre un marcador de cluster en el mapa. Utilice los marcadores de posici\00F3n <strong>&LAYER.</strong> y <strong>&COUNT.</strong> para hacer referencia al nombre de la capa ')
||'y la cantidad de objetos de mapa en el cluster.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100514395101304951)
,p_name=>'PE.PROPERTY.MAP_CLUSTER_POINT_FEATURE_TOOLTIP.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Pista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100479977088304925)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Proporcione el aviso de copyright que se va a colocar en el pie de p\00E1gina del mapa. Si se deja en blanco, se generar\00E1 un aviso para el mapa de fondo usado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100479828746304925)
,p_name=>'PE.PROPERTY.MAP_COPYRIGHT_NOTICE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Aviso de copyright'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100481616656304926)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'[',
'    {',
'        "name": "MyCamera",',
'        "width": 20,',
'        "height": 20,',
'        "paint-order": "stroke",',
'        "viewBox": "0 0 20 20",',
'        "elements": [',
'            {',
'                "type": "path",',
'                "d": "M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1'
||'.1 2.5 2.5S11.4 11 10 11z"',
'            }',
'        ]',
'    },',
'    {',
'        "name": "MyCompany",',
'        "width": 20,',
'        "height": 20,',
'        :',
'    }',
']</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100481514964304926)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Proporcione definiciones para formas SVG personalizadas, que se pueden usar como marcadores de mapa. Los estilos que se definan aqu\00ED se pueden usar como atributo <strong>Forma SVG</strong> en una capa Punto.</p>'),
unistr('<p>La forma SVG debe tener como ancho y altura el valor <strong>20</strong>. El marcador se colocar\00E1 en el mapa, de manera que el centro de la parte inferior de la forma (coordenada <strong>10</strong>, <strong>20</strong> de SVG) apunte al objeto de')
||'l mapa.</p>',
'<svg aria-labelledby="prop1526_SvgTitle" role="img" xmlns="http://www.w3.org/2000/svg" width="100px" height="100px" paint-order="stroke" viewBox="-5 -5 30 40">',
unistr('<title id="prop1526_SvgTitle">Los marcadores SVG tienen como ancho y altura 20 y apuntan a la ubicaci\00F3n del mapa de la posici\00F3n x=10 e y=20.</title>'),
'<path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/>',
'<rect x="0" y="0" width="20" height="20" style="stroke-dasharray:1 1;fill:none;stroke-width:0.5;stroke:black;"/>',
'<line x1="7" y1="17" x2="13" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<line x1="13" y1="17" x2="7" y2="23" style="stroke:red; stroke-width: 0.75;"/>',
'<text x="10" y="30" text-anchor="middle" style="font: 6px Sans-Serif; fill: red;">[10 20]</text>',
'</svg>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100481457368304926)
,p_name=>'PE.PROPERTY.MAP_CUSTOM_STYLES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilos SVG personalizados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100512192563304949)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que devuelve un valor para determinar la altura del pol\00EDgono extruido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100512038398304949)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de valor de extrusi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100513819689304951)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la unidad para determinar la altura del pol\00EDgono extruido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100514148325304951)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.FOOT.D'
,p_message_language=>'es'
,p_message_text=>'Pie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100514060129304951)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.KM.D'
,p_message_language=>'es'
,p_message_text=>unistr('Kil\00F3metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100513939738304951)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.M.D'
,p_message_language=>'es'
,p_message_text=>'Metro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100514266676304951)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.LOV.MILE.D'
,p_message_language=>'es'
,p_message_text=>'Milla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100513765291304950)
,p_name=>'PE.PROPERTY.MAP_FEATURE_3D_VALUE_UNIT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Unidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100486343530304930)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100486200806304930)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Especifique el color del relleno.',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100486107621304930)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Relleno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100495176964304936)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea utilizar un <em>esquema de colores</em> para esta capa. Un esquema de colores es una lista de colores. En funci\00F3n de un valor y los valores m\00EDnimos y m\00E1ximos, el widget del mapa seleccionar\00E1 el color concreto con el que se mostra')
||unistr('r\00E1 este objeto de la lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100495036426304936)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_IS_SPECTRUM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Usar esquema de colores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100647990324305050)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Lista de colores entre el rojo y el blanco</dt>',
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>Lista de colores entre el azul y el negro</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100495331636304937)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique un <em>esquema de colores</em> personalizado para esta capa. Un esquema de colores es una lista de colores. En funci\00F3n de un valor y los valores m\00EDnimos y m\00E1ximos, el widget del mapa seleccionar\00E1 el color concreto con el que se mostrar\00E1 e')
||'ste objeto de la lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100495237292304936)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_SPECTRUM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista de colores personalizados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100495559603304937)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna que devuelve un valor para determinar el color mostrado del esquema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100495471025304937)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_COLOR_VALUE_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de valor de color'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100486594628304930)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique la opacidad del relleno. El rango oscila entre cero (totalmente transparente) y 1,0 (opaco).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100486459186304930)
,p_name=>'PE.PROPERTY.MAP_FEATURE_FILL_OPACITY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Opacidad de relleno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100495704089304937)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que devuelve el valor para determinar el color mostrado del esquema. Si no se selecciona ninguna columna, el color mostrado se determinar\00E1 \00FAnicamente con la densidad de puntos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100495690923304937)
,p_name=>'PE.PROPERTY.MAP_FEATURE_HEATMAP_VALUE_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100491539103304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea que se muestre la ventana de informaci\00F3n usando un formato avanzado o de columnas mediante expresiones HTML y cadenas de sustituci\00F3n soportadas. La ventana de informaci\00F3n se mostrar\00E1 como una ventana emergente al hacer clic en un')
||' objeto del mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100491408224304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_ADV_FORMATTING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formato Avanzado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100491963352304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que se va a usar como cuerpo para la ventana de informaci\00F3n. La ventana de informaci\00F3n se mostrar\00E1 como ventana emergente al hacer clic en un objeto en el mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100491842197304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_BODY_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de cuerpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100492464899304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases CSS que usar al representar la ventana emergente de informaci\00F3n. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100492389306304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100492282829304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Cambiar los colores del fondo y del texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Utilizar Cabecera 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utilizar una clase din\00E1mica de la consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Las sustituciones <code>&COLUMN_CLASS.</code> y <code>&EMPLOYEE_STATUS.</code> de este ejemplo son columnas seleccionadas en la consulta SQL de informe.</dd>',
'  <dt>Mostrar una imagen y una pista al pasar el mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100492166861304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las expresiones HTML que se mostrar\00E1n como ventana emergente de informaci\00F3n al hacer clic en un objeto espacial. Utilice la sintaxis <code>&COLUMN.</code> para mostrar valores de columna en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100492032988304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_HTML_EXPR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100491737395304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que se va a usar como t\00EDtulo para la ventana de informaci\00F3n. La ventana de informaci\00F3n se mostrar\00E1 como ventana emergente al hacer clic en un objeto en el mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100491642354304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_INFOWINDOW_TITLE_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de t\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100515303143304952)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta que usar para que se muestre en la leyenda o en las pistas. Si no se especifica, se utilizar\00E1 el atributo <strong>Nombre</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100515129532304952)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique la etiqueta que usar para esta capa en la leyenda y en las pistas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100515079057304951)
,p_name=>'PE.PROPERTY.MAP_FEATURE_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100514948350304951)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100514876844304951)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Especifique el color del relleno del marcador.',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100514732577304951)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Relleno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100514696662304951)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique la opacidad del relleno. El rango oscila entre cero (totalmente transparente) y 1,0 (opaco).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100514559889304951)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_FILL_OPACITY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Opacidad de relleno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100512411012304949)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100512347717304949)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Especifique el color del trazo.',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100512283491304949)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Trazo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100512684813304950)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique el ancho del trazo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100512538033304950)
,p_name=>'PE.PROPERTY.MAP_FEATURE_POINT_STROKE_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ancho de trazo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100492683244304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que usar para asignar filas del origen de regi\00F3n a esta capa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100492550066304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100492838312304935)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Proporcione el <em>valor</em> <strong>Columna de asignaci\00F3n de fila</strong>, que asigna filas del origen de regi\00F3n a esta capa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100492760374304935)
,p_name=>'PE.PROPERTY.MAP_FEATURE_ROW_ASSIGN_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor para esta capa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100485800436304929)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100485722182304929)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Especifique el color del trazo.',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100485657118304929)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Trazo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100493054627304935)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique el estilo del trazo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100493378813304935)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DASHED.D'
,p_message_language=>'es'
,p_message_text=>'De Rayas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100493216744304935)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOTTED.D'
,p_message_language=>'es'
,p_message_text=>'De Puntos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100493456395304935)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.DOT_DASHED.D'
,p_message_language=>'es'
,p_message_text=>'Guion y punto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100493106410304935)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.LOV.SOLID.D'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100492946119304935)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_STYLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo de trazo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100486033280304930)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique el ancho del trazo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100485964177304930)
,p_name=>'PE.PROPERTY.MAP_FEATURE_STROKE_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ancho de trazo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100490670402304933)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea que se muestre la pista usando un formato avanzado o de columna mediante expresiones HTML y cadenas de sustituci\00F3n soportadas. La pista se muestra al pasar el mouse sobre un objeto del mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100490550914304933)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_ADV_FORMATTING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formato Avanzado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100490868135304933)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que se utilizar\00E1 como pista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100490713139304933)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100491346990304934)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases CSS que usar al representar la pista. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100491297691304933)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100491131053304933)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Cambiar los colores del fondo y del texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Utilizar Cabecera 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utilizar una clase din\00E1mica de la consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Las sustituciones <code>&COLUMN_CLASS.</code> y <code>&EMPLOYEE_STATUS.</code> de este ejemplo son columnas seleccionadas en la consulta SQL de informe.</dd>',
'  <dt>Mostrar una imagen y una pista al pasar el mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100491021523304933)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las expresiones HTML que se mostrar\00E1n como pistas al pasar el mouse sobre un objeto del mapa. Utilice la sintaxis <code>&COLUMN.</code> para mostrar valores de columna en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100490944763304933)
,p_name=>'PE.PROPERTY.MAP_FEATURE_TOOLTIP_HTML_EXPR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100484920405304929)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Columna que devuelve los objetos GeoJSON que mostrar en el mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100484834677304929)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOJSON_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100485147094304929)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Columna SDO_GEOMETRY, que devuelve los objetos de geometr\00EDa que mostrar en el mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100485010074304929)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_GEOMETRY_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Geometr\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100483570246304928)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Identifica el tipo de dato de la columna de geometr\00EDa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100483855311304928)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.D'
,p_message_language=>'es'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100483915691304928)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.GEOJSON.HELP'
,p_message_language=>'es'
,p_message_text=>'Tipos GeoJSON, como VARCHAR2 o CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100484074628304928)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'es'
,p_message_text=>'Longitud/latitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100484100309304928)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>'Longitud y latitud, como dos columnas NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100483672571304928)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.D'
,p_message_language=>'es'
,p_message_text=>'SDO_GEOMETRY'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100483703149304928)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.LOV.SDO_GEOMETRY.HELP'
,p_message_language=>'es'
,p_message_text=>'Tipo SDO_GEOMETRY de Oracle.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100483421701304928)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de dato de columna de geometr\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100484334695304928)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Identifica el tipo de dato de la columna de geometr\00EDa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100484476388304928)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.D'
,p_message_language=>'es'
,p_message_text=>'GeoJSON'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100484505940304929)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.GEOJSON.HELP'
,p_message_language=>'es'
,p_message_text=>'Tipos GeoJSON, como VARCHAR2 o CLOB.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100484698973304929)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.D'
,p_message_language=>'es'
,p_message_text=>'Longitud/latitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100484767059304929)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.LOV.LONLAT_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>'Longitud y latitud, como dos columnas NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100484250326304928)
,p_name=>'PE.PROPERTY.MAP_GEOMETRY_TYPE_REMOTE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de dato de columna de geometr\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100483347989304928)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Active esta opci\00F3n si la tabla subyacente tiene un \00EDndice espacial y el widget del mapa debe usarlo al recuperar filas de la base de datos. En este caso, el widget <em>solo</em> recuperar\00E1 las filas de la ventana del mapa actual de la base de dato')
||unistr('s. Esto supone una mejora en el rendimiento si el origen de datos contiene una gran cantidad de filas.</p><p>Se puede crear un \00EDndice espacial en una columna SDO_GEOMETRY de Taller de SQL.</p>'),
unistr('<p>Tenga en cuenta que <em>no</em> se utilizar\00E1 ning\00FAn \00EDndice espacial en las situaciones siguientes:</p>'),
'<ul>',
unistr('<li>Hay m\00E1s de una capa que hace referencia al <strong>origen de regi\00F3n</strong> como su origen de datos.</li>'),
unistr('<li>La ventana del mapa es demasiado grande; esto ocurre cuando abarca m\00E1s de la mitad del mundo.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100483220045304928)
,p_name=>'PE.PROPERTY.MAP_HAS_SPATIAL_INDEX.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Usar \00EDndice espacial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100485536992304929)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Columna NUMBER, que contiene la latitud de los objetos espaciales que se van a mostrar en el mapa. Los valores devueltos deben estar comprendidos entre -90 y 90.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100485405868304929)
,p_name=>'PE.PROPERTY.MAP_LAT_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de latitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100501124741304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione uno de los esquemas de colores divergentes predefinidos, recomendados para visualizar valores divergentes, desde un valor extremo hasta el otro. Esquemas de colores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/carto'
||'color" target="_blank">CARTOcolor en GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100501280123304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'es'
,p_message_text=>'"Army" to Rose'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100501326207304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100502424948304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'es'
,p_message_text=>'Earth Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100502507338304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100501420545304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'es'
,p_message_text=>'Fall Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100501549456304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100501623802304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'es'
,p_message_text=>'Geyser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100501784343304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100502052254304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'es'
,p_message_text=>'Teal to Rose'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100502147914304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100501835699304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'es'
,p_message_text=>'Temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100501920666304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100502230576304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'es'
,p_message_text=>'Tropic Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100502315573304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100501053017304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre del Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100502758624304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione uno de los esquemas de colores cualitativos predefinidos, recomendados para visualizar valores distintos. Esquemas de colores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">CARTOcolor en Gi'
||'tHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100502874692304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'es'
,p_message_text=>'Antique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100502918277304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100503090013304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'es'
,p_message_text=>'Negrita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100503169177304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100503226888304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'es'
,p_message_text=>'Pastel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100503345575304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100503474595304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'es'
,p_message_text=>'Prism'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100503561291304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100503659979304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'es'
,p_message_text=>'Safe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100503739973304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100503848040304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'es'
,p_message_text=>'Vivid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100503974970304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100502640714304942)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre del Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100497178383304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione uno de los esquemas de colores secuenciales predefinidos, recomendados para visualizar valores secuenciales, desde un valor bajo a uno alto. Esquemas de colores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolo'
||'r" target="_blank">CARTOcolor en GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100498655139304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'es'
,p_message_text=>'Blue to Green'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100498700109304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100499248209304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'es'
,p_message_text=>'Blue to Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100499359886304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100500839813304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'es'
,p_message_text=>'Brown to Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100500907366304941)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100497289173304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'es'
,p_message_text=>'Burgundy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100497359975304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100497412688304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'es'
,p_message_text=>'Burgundy to Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100497554588304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100498844753304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'es'
,p_message_text=>'Dark Mint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100498998821304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100499066407304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'es'
,p_message_text=>'Emerald'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100499125958304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100500449932304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'es'
,p_message_text=>'Magenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100500518134304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100498476989304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'es'
,p_message_text=>'Mint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100498565776304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100497876164304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'es'
,p_message_text=>'Orange to Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100497933685304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100498052432304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'es'
,p_message_text=>'Peach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100498176542304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100498247995304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'es'
,p_message_text=>'Pink to Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100498301735304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100499826871304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'es'
,p_message_text=>'Purple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100499996899304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100500080134304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'es'
,p_message_text=>'Purple to Orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100500181634304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100497664967304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'es'
,p_message_text=>'Red to Orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100497726092304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100500284009304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'es'
,p_message_text=>'Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100500321904304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100500629913304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'es'
,p_message_text=>'Dark Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100500731681304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100499466914304939)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'es'
,p_message_text=>'Teal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100499510940304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100499643195304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'es'
,p_message_text=>'Teal to Green'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100499799566304940)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100497046295304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre del Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100515720382304952)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100515830892304952)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique una lista de colores HTML (#rrggbb), separados por comas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100496394582304937)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el tipo de esquema de colores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100496608811304937)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'es'
,p_message_text=>'Divergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100496700617304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Este esquema de colores est\00E1 recomendado para visualizar valores divergentes, desde un extremo al otro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100496890740304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'es'
,p_message_text=>'Cualitativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100496951168304938)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Este esquema de colores est\00E1 recomendado para visualizar valores distintos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100496483583304937)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'es'
,p_message_text=>'Secuencial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100496533423304937)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Este esquema de colores est\00E1 recomendado para visualizar valores secuenciales, desde un valor bajo a uno alto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100496242246304937)
,p_name=>'PE.PROPERTY.MAP_LAYER_COLOR_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'esquema de colores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100648330696305051)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl><dt>Lista de colores entre el rojo y el blanco</dt>',
'    <dd><pre>#ff0000,#ff2020,#ff4040,#ff6060,#ff8080,#ffa0a0,#ffc0c0,#ffffff</pre></dd><dt>Lista de colores entre el azul y el negro</dt>',
'    <dd><pre>#0000ff,#0000c0,#0000a0,#000080,#000060,#000040,#000020,#000000</pre></dd></dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100511988599304949)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique un <em>esquema de colores</em> personalizado para esta capa del mapa de calor. Un esquema de colores es una lista de colores. En funci\00F3n de un valor y los valores m\00EDnimos y m\00E1ximos, el widget del mapa seleccionar\00E1 el color concreto con el')
||unistr(' que se mostrar\00E1 este objeto de la lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100511895193304949)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_CUSTOM_SPECTRUM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista de colores personalizados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100508949118304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione uno de los esquemas de colores divergentes predefinidos, recomendados para visualizar valores divergentes, desde un valor extremo hasta el otro. Esquemas de colores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/carto'
||'color" target="_blank">CARTOcolor en GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100509050398304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.D'
,p_message_language=>'es'
,p_message_text=>'"Army" to Rose'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100509149440304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.ARMYROSE.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#798234; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a3ad62; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0d3a2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fdfbe4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0c6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#df91a'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d46780; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100510290036304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.D'
,p_message_language=>'es'
,p_message_text=>'Earth Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100510366997304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.EARTH.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#A16928; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#bd925a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d6bd8d;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edeac2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5c8b8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#79a7a'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2887a1; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100509210741304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.D'
,p_message_language=>'es'
,p_message_text=>'Fall Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100509300093304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.FALL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#3d5941; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#778868; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b5b991;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100509490179304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.D'
,p_message_language=>'es'
,p_message_text=>'Geyser'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100509575386304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.GEYSER.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#008080; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70a494; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4c8a8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6edbd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#edbb8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#de8a5'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca562c; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100509859072304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.D'
,p_message_language=>'es'
,p_message_text=>'Teal to Rose'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100509904565304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEALROSE.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#72aaa1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b1c7b3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f1eac8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e5b9ad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d9899'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d0587e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100509634303304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.D'
,p_message_language=>'es'
,p_message_text=>'Temps'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100509740716304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TEMPS.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009392; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#39b185; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9ccb86;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e9e29c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eeb479; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e8847'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cf597e; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100510083690304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.D'
,p_message_language=>'es'
,p_message_text=>'Tropic Colors'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100510101018304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.LOV.TROPIC.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#009B9E; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#42B7B9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A7D3D4;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F1F1F1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E4C1D9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D691C'
||'1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#C75DAB; width:30px;">&nbsp;</div></div>'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100508891372304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_DIV_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre del Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100510518493304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione uno de los esquemas de colores cualitativos predefinidos, recomendados para visualizar valores distintos. Esquemas de colores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolor" target="_blank">CARTOcolor en Gi'
||'tHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100510681625304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.D'
,p_message_language=>'es'
,p_message_text=>'Antique'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100510738045304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.ANTIQUE.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#855C75; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#D9AF6B; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AF6458;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#736F4C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#526A83; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#62537'
||'7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7C7C7C; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100510898683304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.D'
,p_message_language=>'es'
,p_message_text=>'Negrita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100510974330304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.BOLD.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#7F3C8D; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#11A579; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3969AC;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F2B701; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#E73F74; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#80BA5'
||'A; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100511090110304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.D'
,p_message_language=>'es'
,p_message_text=>'Pastel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100511192122304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PASTEL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#66C5CC; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F6CF71; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#F89C74;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DCB0F2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#87C55F; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9EB9F'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#B3B3B3; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100511273370304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.D'
,p_message_language=>'es'
,p_message_text=>'Prism'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100511354085304949)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.PRISM.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#5F4690; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1D6996; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38A6A5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0F8554; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#73AF48; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#EDAD0'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#666666; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100511470192304949)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.D'
,p_message_language=>'es'
,p_message_text=>'Safe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100511598781304949)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.SAFE.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#88CCEE; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC6677; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#DDCC77;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#117733; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#332288; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#AA449'
||'9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#888888; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100511682923304949)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.D'
,p_message_language=>'es'
,p_message_text=>'Vivid'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100511731929304949)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.LOV.VIVID.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#E58606; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5D69B1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#52BCA3;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#99C945; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#CC61B0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#24796'
||'C; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#A5AA99; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100510477575304948)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_QUA_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre del Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100504982946304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione uno de los esquemas de colores secuenciales predefinidos, recomendados para visualizar valores secuenciales, desde un valor bajo a uno alto. Esquemas de colores de cartocolors (<a rel="noreferrer" href="https://github.com/CartoDB/cartocolo'
||'r" target="_blank">CARTOcolor en GitHub)</a>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100506491622304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.D'
,p_message_language=>'es'
,p_message_text=>'Blue to Green'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100506566250304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUGRN.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#c4e6c3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#96d2a4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6dbc90;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4da284; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#36877a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#266b6'
||'e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#1d4f60; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100507025842304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.D'
,p_message_language=>'es'
,p_message_text=>'Blue to Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100507195347304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BLUYL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f7feae; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b7e6a5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7ccba2;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#46aea0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#089099; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#00718'
||'b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#045275; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100508688246304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.D'
,p_message_language=>'es'
,p_message_text=>'Brown to Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100508713837304947)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BRWNYL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ede5cf; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e0c2a2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d39c83;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c1766f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a65461; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#81375'
||'3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#541f3f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100505082519304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.D'
,p_message_language=>'es'
,p_message_text=>'Burgundy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100505144470304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURG.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ffc6c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f4a3a8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e38191;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#cc607d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad466c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#8b305'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#672044; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100505230018304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.D'
,p_message_language=>'es'
,p_message_text=>'Burgundy to Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100505368304304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.BURGYL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fbe6c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5ba98; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee8a82;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc7176; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#c8586c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9c3f5'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#70284a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100506604784304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.D'
,p_message_language=>'es'
,p_message_text=>'Dark Mint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100506782969304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.DARKMINT.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d2fbd4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a5dbc2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7bbcb0;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#559c9e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3a7c89; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#235d7'
||'2; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#123f5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100506897345304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.D'
,p_message_language=>'es'
,p_message_text=>'Emerald'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100506931568304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.EMRLD.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d3f2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#97e196; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6cc08b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4c9b82; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#217a79; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#10596'
||'5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#074050; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100508209725304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.D'
,p_message_language=>'es'
,p_message_text=>'Magenta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100508313537304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MAGENTA.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3cbd3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eaa9bd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd88ac;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca699d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b14d8e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#91357'
||'d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#6c2167; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100506254706304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.D'
,p_message_language=>'es'
,p_message_text=>'Mint'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100506397079304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.MINT.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#e4f1e1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b4d9cc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89c0b6;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63a6a0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#448c8a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#28727'
||'4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#0d585f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100505616306304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.D'
,p_message_language=>'es'
,p_message_text=>'Orange to Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100505777557304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.ORYEL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#ecda9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#efc47e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f3ad6a;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f7945d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f97b57; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f6635'
||'6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ee4d5a; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100505800092304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.D'
,p_message_language=>'es'
,p_message_text=>'Peach'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100505922334304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PEACH.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fde0c5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#facba6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8b58b;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f59e72; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2855d; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ef6a4'
||'c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb4a40; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100506018036304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.D'
,p_message_language=>'es'
,p_message_text=>'Pink to Yellow'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100506190094304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PINKYL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fef6b5; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffdd9a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffc285;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ffa679; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fa8a76; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f16d7'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e15383; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100507637104304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.D'
,p_message_language=>'es'
,p_message_text=>'Purple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100507785510304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURP.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e0f7; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e4c7f1; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#d1afe8;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b998dd; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#9f82ce; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#826db'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#63589f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100507859964304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.D'
,p_message_language=>'es'
,p_message_text=>'Purple to Orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100507994178304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.PURPOR.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f9ddda; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f2b9c4; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e597b9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce78b3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ad5fad; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#834ba'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#573b88; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100505464757304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.D'
,p_message_language=>'es'
,p_message_text=>'Red to Orange'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100505564059304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.REDOR.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f6d2a9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f5b78e; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f19c7c;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ea8171; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dd686c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ca526'
||'8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b13f64; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100508002618304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.D'
,p_message_language=>'es'
,p_message_text=>'Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100508116654304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSET.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#f3e79b; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#fac484; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f8a07e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#eb7f86; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#ce6693; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a059a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#5c53a5; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100508465459304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.D'
,p_message_language=>'es'
,p_message_text=>'Dark Sunset'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100508524379304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.SUNSETDARK.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#fcde9c; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#faa476; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#f0746e;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#e34f6f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#dc3977; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#b9257'
||'a; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#7c1d6f; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100507227076304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.D'
,p_message_language=>'es'
,p_message_text=>'Teal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100507393242304945)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEAL.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#d1eeea; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#a8dbd9; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#85c4c9;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#68abb8; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4f90a6; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#3b738'
||'f; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2a5674; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100507414270304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.D'
,p_message_language=>'es'
,p_message_text=>'Teal to Green'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100507550369304946)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.LOV.TEALGRN.HELP'
,p_message_language=>'es'
,p_message_text=>'<div aria-hidden="true"><div style="display:inline-block;background-color:#b0f2bc; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#89e8ac; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#67dba5;'
||' width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#4cc8a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#38b2a3; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#2c98a'
||'0; width:30px;">&nbsp;</div><div style="display:inline-block;background-color:#257d98; width:30px;">&nbsp;</div></div>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100504832127304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_SEQ_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre del Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100515938279304952)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100516075835304952)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique una lista de colores HTML (#rrggbb), separados por comas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100504177559304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el tipo de esquema de colores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100504496784304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.D'
,p_message_language=>'es'
,p_message_text=>'Divergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100504527614304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.DIVERGING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Este esquema de colores est\00E1 recomendado para visualizar valores divergentes, desde un extremo al otro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100504678217304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.D'
,p_message_language=>'es'
,p_message_text=>'Cualitativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100504707749304944)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.QUALITATIVE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Este esquema de colores est\00E1 recomendado para visualizar valores distintos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100504297434304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.D'
,p_message_language=>'es'
,p_message_text=>'Secuencial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100504312427304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.LOV.SEQUENTIAL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Este esquema de colores est\00E1 recomendado para visualizar valores secuenciales, desde un valor bajo a uno alto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100504038947304943)
,p_name=>'PE.PROPERTY.MAP_LAYER_HEATMAP_SPECTRUM_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'esquema de colores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100493948304304936)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Identifique el tipo de esta capa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100494680479304936)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.D'
,p_message_language=>'es'
,p_message_text=>'Mapa de Calor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100494708934304936)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.HEATMAP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Objetos de puntos, que se muestran como un mapa de calor. Los mapas de calor resultan \00FAtiles para visualizar la densidad de los objetos de puntos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100494249742304936)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDneas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100494312775304936)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.LINE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Objetos de l\00EDnea.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100494016247304936)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.D'
,p_message_language=>'es'
,p_message_text=>'Puntos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100494121341304936)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POINT.HELP'
,p_message_language=>'es'
,p_message_text=>'Objetos de puntos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100494455395304936)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.D'
,p_message_language=>'es'
,p_message_text=>unistr('Pol\00EDgonos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100494514091304936)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Objetos de pol\00EDgono.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100494884118304936)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.D'
,p_message_language=>'es'
,p_message_text=>unistr('Pol\00EDgonos extruidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100494983980304936)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.LOV.POLYGON_3D.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Pol\00EDgonos "extruidos" como objetos en 3D. La altura se basa en un valor de columna de resultado.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100493873707304935)
,p_name=>'PE.PROPERTY.MAP_LAYER_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de capa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100496142899304937)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el nivel de zoom m\00E1ximo para que esta capa sea visible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100496046920304937)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MAX_ZOOM_LEVEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100495994256304937)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifica el nivel de zoom m\00EDnimo para que esta capa sea visible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100495815271304937)
,p_name=>'PE.PROPERTY.MAP_LAYER_VISIBLE_MIN_ZOOM_LEVEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100485382038304929)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Columna NUMBER, que contiene la longitud de los objetos espaciales que se van a mostrar en el mapa. Los valores devueltos deben estar comprendidos entre -180 y 180.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100485231446304929)
,p_name=>'PE.PROPERTY.MAP_LON_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de longitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100489207641304932)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Si se van a agrupar los puntos con colocaci\00F3n en el mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100489120352304932)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_CLUSTER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Activar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100486715623304930)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Identifica c\00F3mo se muestran los objetos de puntos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100487012950304930)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.D'
,p_message_language=>'es'
,p_message_text=>'Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100487155692304930)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.ICON.HELP'
,p_message_language=>'es'
,p_message_text=>'Se muestra como icono.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100486872605304930)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.D'
,p_message_language=>'es'
,p_message_text=>'SVG'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100486930895304930)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.LOV.SVG.HELP'
,p_message_language=>'es'
,p_message_text=>'Se muestra como forma SVG.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100486618153304930)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_DISPLAY_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100488700131304932)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la forma SVG para mostrar objetos de puntos. Seleccione una de las formas predefinidas o introduzca el nombre de una <em>forma SVG personalizada</em>, que se especifica en el atributo de la regi\00F3n de mapa <strong>Estilos SVG personalizado')
||unistr('s</strong>. Si no se especifica ning\00FAn nombre, o si el nombre especificado no est\00E1 en la lista de formas SVG por defecto o personalizadas, se utilizar\00E1 la forma <strong>por defecto</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100522050997304957)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.D'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1mara')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100529053893304962)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CAMERA.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 4h-1.2l-.9-1.2c-.4-.5-1-.8-1.6-.8H8.8c-.7 0-1.3.3-1.6.8L6.2 4H5c-1.1 0-2 .9-2 2v5c0 1.1.9 2 2 2h2.2l2.4 4.7c.1.2.4.3.7.2.1 0 .2-.'
||'1.2-.2l2.4-4.7H15c1.1 0 2-.9 2-2V6c0-1.1-.9-2-2-2zm-5 7c-1.4 0-2.5-1.1-2.5-2.5S8.6 6 10 6s2.5 1.1 2.5 2.5S11.4 11 10 11z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100527294345304961)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.D'
,p_message_language=>'es'
,p_message_text=>'Comprobar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100530350912304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CHECK.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zm2.9 4.9l-3 3c-.2.1-.6.1-.8 0L7.6 8.4c-'
||'.2-.2-.2-.5 0-.7s.5-.2.7 0l1.1 1.1L12 6.2c.2-.2.5-.2.7 0s.3.5.2.7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100522141154304957)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Alternativa al c\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100529243596304962)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE ALTERNATIVE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8v9.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2l3.7-4c3.2.8 6.5-1.2 7.3-4.4.8-3.2-1.2-6.5-4.4-7.3-.5 0-1-.1-1.5-.1zm0 8c-1.'
||'1 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100488954047304932)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'es'
,p_message_text=>unistr('C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100529141879304962)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.CIRCLE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 2.5 1.6 4.7 3.9 5.6l1.6 4.1c.1.3.4.4.7.3l.3-.3 1.6-4.1c3.1-1.2 4.7-4.6 3.5-7.7C14.7 3.6 12.5 2 10 2zm0 8c-1.1'
||' 0-2-.9-2-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100521974718304957)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.D'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100528998746304962)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.DEFAULT.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 4.6 5.4 9.7 5.7 9.9.2.2.5.2.7 0 .2-.2 5.6-5.3 5.6-9.9 0-3.3-2.7-6-6-6zm0 7.9c-1.1 0-2-.9-2-2s.9-2 2-2 2 .9 2 '
||'2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100522219828304957)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.D'
,p_message_language=>'es'
,p_message_text=>unistr('Ce\00F1o fruncido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100529393371304962)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE FROWN.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5 3.8c-.2.1-.4.1-.5-.1-.7-.9-2-1.1-3-.4-.2.1-.3.3-.4.4-.1.2-.4.2-.5.1-.2-.1-.2-.4-.1-.5 1-1.3 2.8-1.5 4-.6l.6.6c.1.1.1.4-.1.5zm-.2-3c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100522364613304957)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.D'
,p_message_language=>'es'
,p_message_text=>'Indiferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100529402721304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE MEH.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm4.3 3.9h-3c-.2 0-.4-.2-.4-.4s.2-.4.4-.4h3c.2 0 .4.2.4.4s-.2.4-.4.4zm.5-3.1c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100522438044304957)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.D'
,p_message_language=>'es'
,p_message_text=>'Sonrisa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100529550208304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FACE SMILE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C6.7 2 4 4.7 4 8c0 3.7 5.4 9.6 5.6 9.8.2.2.5.2.7 0 .3-.2 5.7-6.1 5.7-9.8 0-3.3-2.7-6-6-6zM7.2 7c0-.4.3-.8.8-.8.4 0 .8.3.8.8s-.4.'
||'8-.8.8-.8-.4-.8-.8zm5.1 2.7c-1 1.3-2.8 1.5-4 .6l-.6-.6c-.1-.1-.1-.4.1-.5.2-.1.4-.1.5.1.7.9 2 1.1 3 .4.2-.1.3-.3.4-.4.1-.2.4-.2.5-.1s.2.4.1.5zM12 7.8c-.4 0-.8-.3-.8-.8s.3-.8.8-.8.8.3.8.8-.4.8-.8.8z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100527740256304961)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.D'
,p_message_language=>'es'
,p_message_text=>unistr('Bander\00EDn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100530802919304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG PENNANT.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16.7 6.5L3.7 2c-.3-.1-.6.1-.7.3v15.2c0 .3.2.5.5.5s.5-.2.5-.5v-5.6l12.7-4.4c.3-.1.4-.4.3-.6-.1-.2-.2-.3-.3-.4z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100527853071304961)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.D'
,p_message_language=>'es'
,p_message_text=>'Estandarte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100530967533304964)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.FLAG SWALLOWTAIL.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13.2 7l3.7-4.2c.2-.2.2-.5 0-.7-.2-.1-.3-.1-.4-.1h-13c-.3 0-.5.2-.5.5v15c0 .3.2.5.5.5s.5-.2.5-.5V12h12.5c.3 0 .5-.2.5-.5 0-.1 0-.2-.1'
||'-.3L13.2 7z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100522869504304958)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.D'
,p_message_language=>'es'
,p_message_text=>unistr('Coraz\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100530043102304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HEART.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M16 5c0-.8-.3-1.6-.9-2.1-1.2-1.2-3.1-1.2-4.3 0l-.8.8-.8-.8C8 1.7 6.1 1.7 4.9 2.9c-1.2 1.1-1.2 3 0 4.2l4.6 4.6v5.8c0 .3.2.5.5.5s.5-.2.'
||'5-.5v-5.8l4.6-4.6c.6-.5.9-1.3.9-2.1z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100527321419304961)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.D'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100530430417304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.HOME.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.8 7.6l-7.5-5.5c-.2-.1-.4-.1-.6 0L2.2 7.5c-.2.2-.3.5-.1.7.2.2.5.3.7.1L4 7.5v6c0 .3.2.5.5.5h3.2l1.9 3.7c.1.2.4.3.7.2.1 0 .2-.1.2-.2'
||'l1.9-3.7h3.2c.3 0 .5-.2.5-.5v-6l1.2.9c.2.2.5.1.7-.1.1-.3 0-.6-.2-.7z"/><path d="M8.5 8.5v2c0 .3.2.5.5.5h2c.3 0 .5-.2.5-.5v-2c0-.3-.2-.5-.5-.5H9c-.3 0-.5.2-.5.5z" fill="#fff"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100522923707304958)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.D'
,p_message_language=>'es'
,p_message_text=>unistr('Pent\00E1gono')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100530177472304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PENTAGON.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15 5.5l-4.7-3.4c-.2-.1-.4-.1-.6 0L5 5.5c-.2.2-.3.4-.2.6l1.8 5.6c.1.2.3.3.5.3h2.4v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h2.4c.2 0 .4-.1.5-.3l'
||'1.8-5.6c.1-.2 0-.4-.2-.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100522656267304958)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Anclar c\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100529870435304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN CIRCLE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 2C7.2 2 5 4.2 5 7c0 2.6 1.9 4.7 4.5 5v5.6c0 .3.2.5.5.5s.5-.2.5-.5V12c2.7-.3 4.7-2.7 4.5-5.4-.3-2.7-2.4-4.6-5-4.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100522748766304958)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.D'
,p_message_language=>'es'
,p_message_text=>'Anclar cuadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100529988152304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.PIN SQUARE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M13 2H7c-1.1 0-2 .9-2 2v6c0 1.1.9 2 2 2h2.5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12H13c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100527568166304961)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.D'
,p_message_language=>'es'
,p_message_text=>'Brillo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100530631183304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SHINE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M10 7c-2.2 0-4 1.8-4 4 0 2.3 3.2 6.4 3.6 6.8.2.2.5.2.7.1l.1-.1c.4-.5 3.6-4.5 3.6-6.8 0-2.2-1.8-4-4-4zm0 5c-.6 0-1-.4-1-1s.4-1 1-1 1 .'
||'4 1 1-.4 1-1 1zM3.6 4.9c-.2-.1-.5-.1-.7.1-.2.3-.1.6.1.7l1.9 1.4c0 .1.1.1.3.1.3 0 .5-.2.5-.5 0-.2-.1-.3-.2-.4L3.6 4.9zm4 .1c.1.2.3.3.5.3h.2c.3-.1.4-.4.3-.6l-.9-2.4c0-.2-.3-.4-.6-.3-.3.1-.4.4-.3.6L7.6 5zm9.5 0c-.2-.2-.5-.3-.7-.1l-1.9 1.4c-.2.2-.3.5-.1.'
||'7.1.1.2.2.4.2.1 0 .2 0 .3-.1L17 5.7c.2-.1.3-.4.1-.7zm-5.3.3h.2c.2 0 .4-.1.5-.3l.8-2.3c.1-.3 0-.5-.3-.6-.3-.1-.5 0-.6.3l-.8 2.3c-.2.2-.1.5.2.6z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100527461270304961)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.D'
,p_message_language=>'es'
,p_message_text=>'Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100530583873304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SLASH.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M17.9 2.1c-.2-.2-.5-.2-.7 0l-2.3 2.3C13 1.7 9.2 1.1 6.5 3.1 4.9 4.3 4 6.1 4 8c.1 1.9.8 3.8 1.9 5.4l-3.8 3.8c-.2.2-.2.5 0 .7s.5.2.7 0l'
||'15-15c.2-.2.2-.6.1-.8zM9.5 9.8c-1.1-.3-1.7-1.4-1.4-2.4S9.5 5.7 10.5 6c.7.2 1.2.7 1.4 1.4L9.5 9.8zM7.1 15c.8 1 1.6 2 2.6 2.8.2.2.5.2.7 0 .2-.1 5.6-5.2 5.6-9.8 0-.6-.1-1.1-.2-1.6L7.1 15z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100522549308304957)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.D'
,p_message_language=>'es'
,p_message_text=>'Alternativa al cuadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100529761870304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE ALTERNATIVE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v13.5c0 .2.1.4.3.5h.2c.1 0 .3-.1.4-.2L8.4 14H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2-2s.9-2 2-2'
||' 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100488854876304932)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.D'
,p_message_language=>'es'
,p_message_text=>'Cuadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100529685094304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.SQUARE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14 2H6c-1.1 0-2 .9-2 2v8c0 1.1.9 2 2 2h2.1l1.5 3.7c.1.3.4.4.7.3l.3-.3 1.5-3.7H14c1.1 0 2-.9 2-2V4c0-1.1-.9-2-2-2zm-4 8c-1.1 0-2-.9-2'
||'-2s.9-2 2-2 2 .9 2 2-.9 2-2 2z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100527661936304961)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.D'
,p_message_language=>'es'
,p_message_text=>'Vista de calle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100530756169304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.STREET VIEW.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M14.7 11.6c-.3-.1-.5.1-.6.3s.1.5.3.6c1.6.5 2.6 1.2 2.6 1.9 0 1.2-2.9 2.5-7 2.5s-7-1.3-7-2.5c0-.7 1-1.4 2.6-1.9.3 0 .4-.3.3-.5-.1-.3-.'
||'4-.4-.6-.3-2.1.6-3.3 1.6-3.3 2.8 0 2 3.4 3.5 8 3.5s8-1.5 8-3.5c0-1.2-1.2-2.2-3.3-2.9z"/><path d="M7.7 10.9c.2.2.3.5.3.7V14c0 .6.4 1 1 1h2c.6 0 1-.4 1-1v-2.4c0-.3.1-.5.3-.7l.1-.1c.4-.4.6-.9.6-1.4V7.8c0-.7-.3-1.3-.9-1.6-1.2 1.2-3.1 1.2-4.2 0-.6.3-.9.9-'
||'.9 1.6v1.6c0 .5.2 1 .6 1.4l.1.1z"/><circle cx="10" cy="4" r="2"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100489099937304932)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Tri\00E1ngulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100530291226304963)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.LOV.TRIANGLE.HELP'
,p_message_language=>'es'
,p_message_text=>'<svg xmlns="http://www.w3.org/2000/svg" width="20px" height="20px" paint-order="stroke" viewBox="0 0 20 20"><path d="M15.9 11.2l-5.5-9c-.1-.2-.5-.3-.7-.1-.1 0-.1.1-.1.1l-5.5 9c-.1.2-.1.5.2.7 0 .1.1.1.2.1h5v5.5c0 .3.2.5.5.5s.5-.2.5-.5V12h5c.3 0 .5-.2.'
||'5-.5 0-.1 0-.2-.1-.3z"/></svg>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100488657131304932)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100523146299304958)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el factor de escala de la forma SVG. La escala m\00E1xima es <strong>10</strong>. Si se usa una sustituci\00F3n de columna y el valor es mayor que <strong>10</strong>, se escribe un mensaje en la consola de JavaScript y se muestra el marcador con')
||unistr(' un factor de escala <strong>10</strong>. El componente de mapa redondear\00E1 el valor al primer d\00EDgito decimal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100523063111304958)
,p_name=>'PE.PROPERTY.MAP_POINT_FEATURE_SVG_SHAPE_SCALE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Escala de la forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100488142382304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna que contiene clases CSS de iconos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100488025908304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CLASS_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100488509492304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>'Clases CSS que usar como origen de icono.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100488428416304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100488346476304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la URL del origen de imagen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100488250288304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_IMAGE_URL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'URL de imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100487320425304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el origen del icono para mostrar el punto en el mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100487632547304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.D'
,p_message_language=>'es'
,p_message_text=>'Columna Clase de icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100487751006304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.DYNAMIC_CLASS.HELP'
,p_message_language=>'es'
,p_message_text=>'Utilice distintas clases CSS para cada fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100487460102304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.D'
,p_message_language=>'es'
,p_message_text=>'Clase de Icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100487549471304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.STATIC_CLASS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Utilice una clase CSS est\00E1tica para todas las filas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100487856017304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.D'
,p_message_language=>'es'
,p_message_text=>'URL de imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100487956035304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.LOV.URL.HELP'
,p_message_language=>'es'
,p_message_text=>'URL a una imagen que usar para mostrar el punto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100487211121304931)
,p_name=>'PE.PROPERTY.MAP_POINT_ICON_SOURCE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Origen de icono'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100478186603304924)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.HELP'
,p_message_language=>'es'
,p_message_text=>'Active o desactive las distintas funciones del widget de mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100479217579304925)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Obtener ubicaci\00F3n del explorador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100479346644304925)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.BROWSER_LOCATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Permite obtener la ubicaci\00F3n actual del usuario del explorador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100479461154304925)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.D'
,p_message_language=>'es'
,p_message_text=>unistr('Herramienta C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100479518461304925)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.CIRCLE_TOOL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La herramienta C\00EDrculo permite a los usuarios finales dibujar un c\00EDrculo en el mapa. Cuando se finaliza la acci\00F3n, se dispara un evento para que el c\00EDrculo se pueda procesar mediante c\00F3digo de JavaScript o acciones din\00E1micas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100479623812304925)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.D'
,p_message_language=>'es'
,p_message_text=>'Herramienta Distancia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100479720029304925)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.DISTANCE_TOOL.HELP'
,p_message_language=>'es'
,p_message_text=>'Permite a los usuarios finales medir las distancias entre los puntos del mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100479036998304925)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.D'
,p_message_language=>'es'
,p_message_text=>'Mapa infinito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100479188304304925)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.INFINITE_MAP.HELP'
,p_message_language=>'es'
,p_message_text=>'Desplazamiento en mapa infinito.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100478293601304924)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.D'
,p_message_language=>'es'
,p_message_text=>'Zoom de la rueda de mouse'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100478359178304924)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.MOUSEWHEEL_ZOOM.HELP'
,p_message_language=>'es'
,p_message_text=>'Permite acercar o alejar con la rueda del mouse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100478836026304924)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.D'
,p_message_language=>'es'
,p_message_text=>unistr('Mapa de Visi\00F3n General')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100478921307304924)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.OVERVIEW_MAP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra un mapa de visi\00F3n general en la parte inferior derecha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100478481070304924)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.D'
,p_message_language=>'es'
,p_message_text=>unistr('Zoom con rect\00E1ngulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100478500197304924)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.RECTANGLE_ZOOM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplique zoom a un \00E1rea del mapa dibujando un rect\00E1ngulo en el mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100478649752304924)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.D'
,p_message_language=>'es'
,p_message_text=>'Barra de Escala'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100478782616304924)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.LOV.SCALE_BAR.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra una barra de escala en el mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100478081556304924)
,p_name=>'PE.PROPERTY.MAP_REGION_FEATURES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Opciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100483081192304927)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la altura de la regi\00F3n del mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100482916243304927)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100483148151304927)
,p_name=>'PE.PROPERTY.MAP_REGION_HEIGHT.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('p\00EDxeles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100481341846304926)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases CSS que desee agregar a la leyenda. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100481288189304926)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100481101427304926)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.HELP'
,p_message_language=>'es'
,p_message_text=>'Selector de jQuery para el elemento en el que mostrar la leyenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100481047454304926)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITION_SELECTOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Selector'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100480320223304925)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifica la posici\00F3n de la leyenda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100480650912304926)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.D'
,p_message_language=>'es'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100480788032304926)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.END.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar la leyenda en la posici\00F3n final (normalmente por debajo del mapa).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100480860916304926)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.D'
,p_message_language=>'es'
,p_message_text=>'Selector'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100480940454304926)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.SELECTOR.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique un selector de jQuery para el elemento en el que mostrar la leyenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100480452901304925)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.D'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100480534921304926)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.LOV.START.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar la leyenda en la posici\00F3n inicial (normalmente por encima del mapa).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100480258064304925)
,p_name=>'PE.PROPERTY.MAP_REGION_LEGEND_POSITON.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100515232751304952)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Ocultar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100648188894305050)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'No mostrar mensajes de la capa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100481876022304927)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la ubicaci\00F3n en la que mostrar los mensajes No se ha encontrado ning\00FAn dato y Se han encontrado m\00E1s datos de la capa del mapa.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100481901399304927)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.D'
,p_message_language=>'es'
,p_message_text=>'Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100482074816304927)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.ABOVE.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra los mensajes en la parte superior del mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100482133076304927)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.D'
,p_message_language=>'es'
,p_message_text=>'Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100482250150304927)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.BELOW.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra los mensajes en la parte inferior del mapa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100482340903304927)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.D'
,p_message_language=>'es'
,p_message_text=>'Selector'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100482451440304927)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.LOV.SELECTOR.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique un selector de jQuery para el elemento en el que mostrar los mensajes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100481715600304926)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de los mensajes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100482615422304927)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.HELP'
,p_message_language=>'es'
,p_message_text=>'Selector de jQuery para el elemento en el que mostrar los mensajes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100482578126304927)
,p_name=>'PE.PROPERTY.MAP_REGION_MESSAGES_SELECTOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Selector de Mensajes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100480149792304925)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifica si se muestra una leyenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100480056021304925)
,p_name=>'PE.PROPERTY.MAP_REGION_SHOW_LEGEND.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100482883724304927)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si se selecciona un elemento de p\00E1gina, la regi\00F3n del mapa siempre mantendr\00E1 el recuadro delimitador del mapa actual, con formato GeoJSON, como valor de este elemento. Esto resulta \00FAtil para conectar el mapa con otro componente de APEX (por ejempl')
||unistr('o, un informe cl\00E1sico o interactivo): el otro componente puede usar el contenido del elemento del recuadro delimitador para realizar una consulta espacial y mostrar solo los datos visibles en el mapa.</p>'),
unistr('<p>Contenido de ejemplo del elemento del recuadro delimitador despu\00E9s de alg\00FAn cambio en el nivel de zoom o movimiento del mapa:</p>'),
'<pre>',
'{',
'  "type": "Polygon",',
'  "coordinates": [[',
'                    [-5.499,46.380],',
'                    [ 8.187,46.380],',
'                    [ 8.187,49.550],',
'                    [-5.499,49.550],',
'                    [-5.499,46.380]]]',
'}',
'</pre>',
'<p>',
unistr('Con una acci\00F3n din\00E1mica <strong>Refrescar</strong>, el mapa se puede conectar con una regi\00F3n de informe. Esta puede aplicar un filtro espacial para que solo se muestren los resultados que tambi\00E9n se ven en el mapa.</p>'),
'<p>Consulta de informe de ejemplo:</p>',
'<pre>',
'select [column1],',
'       [column2],',
'       ...',
'  from ...',
' where sdo_anyinteract(',
'           [geometry-column],',
'           sdo_util.from_geojson( :[item-name-of-bounding-box-item] )',
'       ) = ''TRUE''',
'   and ...',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100482738256304927)
,p_name=>'PE.PROPERTY.MAP_REGION_STATUS_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento del recuadro delimitador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100512807496304950)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el sistema de unidad que usar para la barra de escala y la herramienta de distancia.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100513124244304950)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.D'
,p_message_language=>'es'
,p_message_text=>'Imperial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100513289383304950)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.IMPERIAL.HELP'
,p_message_language=>'es'
,p_message_text=>'Use el sistema imperial.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100513377541304950)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Derivar de Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100513435913304950)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Deriva el sistema de unidad del valor de un elemento de p\00E1gina o de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100512912087304950)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9trica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100513016363304950)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.LOV.METRIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Use el sistema m\00E9trico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100512743922304950)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Sistema de unidades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100513635877304950)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un elemento de p\00E1gina o de aplicaci\00F3n que contenga el valor que usar como sistema de unidad de mapa: <strong>M\00C9TRICO</strong> (<strong>M</strong>) o <strong>IMPERIAL</strong> (<strong>I</strong>).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100513525507304950)
,p_name=>'PE.PROPERTY.MAP_UNIT_SYSTEM_PAGE_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento de sistema de unidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100140326506304671)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se debe presentar un marcador en los elementos de datos del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100140467199304671)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100140658007304671)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.OFF.D'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100140505302304671)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.LOV.ON.D'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100140274529304671)
,p_name=>'PE.PROPERTY.MARKER_RENDERED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100140887052304671)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la forma del marcador que se presentar\00E1 en los elementos de datos del gr\00E1fico. Solo <strong>Autom\00E1tico</strong> est\00E1 soportado para la serie de rango. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100140910437304671)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100141088521304671)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.CIRCLE.D'
,p_message_language=>'es'
,p_message_text=>unistr('C\00EDrculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100141163726304671)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.DIAMOND.D'
,p_message_language=>'es'
,p_message_text=>'Diamante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100141227952304671)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.HUMAN.D'
,p_message_language=>'es'
,p_message_text=>'Humano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100141325381304671)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.PLUS.D'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100141439314304672)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.SQUARE.D'
,p_message_language=>'es'
,p_message_text=>'Cuadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100166607328304691)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.STAR.D'
,p_message_language=>'es'
,p_message_text=>'Estrella'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100141504688304672)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEDOWN.D'
,p_message_language=>'es'
,p_message_text=>unistr('Tri\00E1ngulo hacia Abajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100141690641304672)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.LOV.TRIANGLEUP.D'
,p_message_language=>'es'
,p_message_text=>unistr('Tri\00E1ngulo hacia Arriba')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100140716854304671)
,p_name=>'PE.PROPERTY.MARKER_SHAPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Forma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100256726923304759)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si esta columna es una columna de clave ajena para la regi\00F3n de cuadr\00EDcula interactiva maestra, seg\00FAn lo especificado en <strong>Regi\00F3n Maestra</strong> en la configuraci\00F3n de la regi\00F3n, seleccione la columna de clave primaria correspondiente de l')
||'a tabla maestra.</p>',
unistr('        <p>Por ejemplo, si la regi\00F3n maestra es DEPT y esta cuadr\00EDcula interactiva es EMP, seleccione la columna DEPTNO en la cuadr\00EDcula interactiva EMP y, a continuaci\00F3n, seleccione la columna DEPTNO de la lista de columnas DEPT para la columna maes')
||'tra.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100256661331304759)
,p_name=>'PE.PROPERTY.MASTER_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna Maestra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100074552364304581)
,p_name=>'PE.PROPERTY.MASTER_REGION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la regi\00F3n maestra a la que pertenece esta regi\00F3n de detalles.<br>'),
unistr('        Se debe definir cuando esta regi\00F3n es la regi\00F3n de detalles en una relaci\00F3n maestro-detalle con otra regi\00F3n en esta p\00E1gina.</p>'),
unistr('        <p>Para que la relaci\00F3n maestro-detalle funcione correctamente, seleccione las columnas de esta regi\00F3n que son las claves ajenas en la regi\00F3n maestra y especifique la <strong>columna maestra</strong> seg\00FAn corresponda.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100074413190304581)
,p_name=>'PE.PROPERTY.MASTER_REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n Maestra')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100186465605304705)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero m\00E1ximo que se mostrar\00E1 en Selector de Filas por P\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100186332582304705)
,p_name=>'PE.PROPERTY.MAXIMUM_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo de Filas por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100517905135304954)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero m\00E1ximo de filas que se pueden procesar para esta capa. Esto se puede usar como medida en demasiados objetos espaciales que se descargan y muestran en el mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100185619045304705)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el n\00FAmero m\00E1ximo de filas que puede procesar la consulta. Si el n\00FAmero m\00E1ximo de flas que se va procesar excede el l\00EDmite, se mostrar\00E1 un mensaje de error en lugar de los datos.'),
unistr('Para definir un mensaje personalizado, especifique un mensaje en <strong>Se han encontrado m\00E1s datos</stron>.</p>'),
'<p>Este atributo se utiliza para evitar que los usuarios finales realicen acciones, como ordenaciones o agregaciones, en todos los registros en tablas o vistas muy grandes, que puede que afecten al rendimiento.',
unistr('En su lugar, el n\00FAmero de registros que se est\00E1 procesando se debe reducir mediante la adici\00F3n de filtros adicionales.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100185567931304705)
,p_name=>'PE.PROPERTY.MAXIMUM_ROW_COUNT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo de Filas para Procesar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100552044065304979)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea que se muestre este componente usando un formato avanzado o de columna mediante expresiones HTML y cadenas de sustituci\00F3n soportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100551969154304979)
,p_name=>'PE.PROPERTY.MEDIA_ADV_FORMATTING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formato Avanzado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100559815404304985)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100554449330304981)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determina el ratio de aspecto del medio.',
unistr('<strong>Autom\00E1tico</strong>: usa un ajuste \00F3ptimo para preservar el tama\00F1o de medio original.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100554583135304981)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.D'
,p_message_language=>'es'
,p_message_text=>'Cuadrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100554696810304981)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.SQUARE.HELP'
,p_message_language=>'es'
,p_message_text=>'Aplica un ratio de aspecto cuadrado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100554747621304981)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.D'
,p_message_language=>'es'
,p_message_text=>unistr('Pantalla panor\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100554836399304981)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.LOV.WIDESCREEN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplica un ratio de aspecto de pantalla panor\00E1mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100554358546304981)
,p_name=>'PE.PROPERTY.MEDIA_APPEARANCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Apariencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100553484920304980)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna que devuelve el BLOB para el origen del medio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100553321716304980)
,p_name=>'PE.PROPERTY.MEDIA_BLOB_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100555636230304982)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100555542057304982)
,p_name=>'PE.PROPERTY.MEDIA_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100555805958304982)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Este texto describe el medio y se puede usar para pistas o textos alternativos de im\00E1genes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100555733525304982)
,p_name=>'PE.PROPERTY.MEDIA_DESCRIPTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n de Imagen')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100553680535304980)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>'Determina si el componente del medio se posiciona en la tarjeta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100554133302304981)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.D'
,p_message_language=>'es'
,p_message_text=>'Como imagen de fondo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100554225275304981)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BACKGROUND.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra el medio como fondo de tarjeta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100553964828304981)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.D'
,p_message_language=>'es'
,p_message_text=>'Cuerpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100554091400304981)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.BODY.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra el medio en el cuerpo de la tarjeta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100553707052304980)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.D'
,p_message_language=>'es'
,p_message_text=>'Primero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100553855004304981)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.LOV.FIRST.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra el medio antes de la cabecera de tarjeta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100553571606304980)
,p_name=>'PE.PROPERTY.MEDIA_DISPLAY_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100552308398304979)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Cambiar los colores del fondo y del texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Utilizar Cabecera 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utilizar una clase din\00E1mica de la consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Las sustituciones <code>&COLUMN_CLASS.</code> y <code>&EMPLOYEE_STATUS.</code> de este ejemplo son columnas seleccionadas en la consulta SQL de informe.</dd>',
'  <dt>Mostrar una imagen y una pista al pasar el mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100552265736304979)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las expresiones HTML que se mostrar\00E1n en esta columna. Utilice la sintaxis <code>&COLUMN.</code> para mostrar valores de columna en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100552178910304979)
,p_name=>'PE.PROPERTY.MEDIA_HTML_EXPR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100555066371304981)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Determina el tama\00F1o que tendr\00E1 el medio dentro del componente de medio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100555392237304982)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.D'
,p_message_language=>'es'
,p_message_text=>'Cubrir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100555426561304982)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.COVER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Ajusta el tama\00F1o para que el medio rellene el \00E1rea de visualizaci\00F3n de medio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100555144143304982)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.D'
,p_message_language=>'es'
,p_message_text=>'Ajustar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100555215776304982)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.LOV.FIT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Ajusta el tama\00F1o para que el medio quepa en el \00E1rea de visualizaci\00F3n de medio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100554976210304981)
,p_name=>'PE.PROPERTY.MEDIA_SIZING.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100559754716304985)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.COMPONENT_PROPERTY.CARD.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Sin medio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100552529072304980)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el tipo de origen de medio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100552890648304980)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.BLOB.D'
,p_message_language=>'es'
,p_message_text=>'Columna BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100552742975304980)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.DYNAMIC_URL.D'
,p_message_language=>'es'
,p_message_text=>'Columna URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100552649852304980)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.LOV.STATIC_URL.D'
,p_message_language=>'es'
,p_message_text=>'URL de imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100552456013304979)
,p_name=>'PE.PROPERTY.MEDIA_SOURCE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Origen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99850143201304407)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el tipo de medio de Internet. Un tipo de medio de Internet es un identificador de dos partes para los formatos de archivo de Internet.',
unistr('Un tipo de medio est\00E1 compuesto al menos por dos partes: un tipo, un subtipo y uno o m\00E1s par\00E1metros opcionales.'),
unistr('Este tipo de medio se utiliza en la cabecera HTTP de tipo de contenido al presentar la p\00E1gina.</p>'),
unistr('<p>El tipo de medio de nivel de p\00E1gina sustituye al de nivel de aplicaci\00F3n.'),
unistr('Si ambos valores de nivel de p\00E1gina y nivel de aplicaci\00F3n para el tipo de medio son <code>NULL</code>, se utiliza el tipo de medio <code>text/html</code>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99850016945304407)
,p_name=>'PE.PROPERTY.MEDIA_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Medio F\00EDsico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100553096556304980)
,p_name=>'PE.PROPERTY.MEDIA_URL.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la URL del origen del medio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100552932484304980)
,p_name=>'PE.PROPERTY.MEDIA_URL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100553225134304980)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que se utilizar\00E1 como origen del medio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100553163149304980)
,p_name=>'PE.PROPERTY.MEDIA_URL_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100146283307304675)
,p_name=>'PE.PROPERTY.MINOR_STEP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el incremento entre las marcas secundarias. Se define en nulo para el c\00E1lculo autom\00E1tico basado en los datos. Solo se aplica a los ejes num\00E9ricos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100146131519304675)
,p_name=>'PE.PROPERTY.MINOR_STEP.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Escal\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100146020993304675)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si se presentan las marcas secundarias.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100145913387304675)
,p_name=>'PE.PROPERTY.MINOR_TICK_RENDERED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100145862932304675)
,p_name=>'PE.PROPERTY.MIN_STEP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el incremento m\00EDnimo entre las marcas principales. Esto se suele utilizar para evitar valores de eje fraccionales para medidas discretas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100145748601304675)
,p_name=>'PE.PROPERTY.MIN_STEP.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Escal\00F3n M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100565834290304989)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre del proceso de aplicaci\00F3n para facilitar su identificaci\00F3n a los desarrolladores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99947384720304484)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHENTICATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre utilizado por los desarrolladores de la aplicaci\00F3n para hacer referencia a este esquema de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99886817120304437)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.AUTHORIZATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un nombre \00FAnico que identifique este esquema de autorizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99960552414304495)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BRANCH.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de la bifurcaci\00F3n para facilitar su identificaci\00F3n a los desarrolladores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99997461636304523)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BREADCRUMB_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un nombre descriptivo para esta plantilla de ruta de navegaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99886719975304437)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUILD_OPTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un nombre para esta opci\00F3n de creaci\00F3n. Las opciones de creaci\00F3n son valores predefinidos que determinan si un componente est\00E1 activado dentro de una aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99997155369304522)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.BUTTON_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un nombre descriptivo para esta plantilla de bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99997573315304523)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.CALENDAR_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca un nombre descriptivo para esta plantilla de calendario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99887445745304437)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.DYNAMIC_ACTION_EVENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de la acci\00F3n din\00E1mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99997299054304522)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.FIELD_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca un nombre descriptivo para esta plantilla de elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100183633099304703)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.IR_COLUMN_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre del grupo de columnas. Este nombre se muestra como cabecera de regi\00F3n en la vista detallada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99997388674304523)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.LIST_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca un nombre descriptivo para esta plantilla de lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100517451752304953)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un nombre descriptivo para este componente. Utilice el atributo <strong>Etiqueta</strong> si en HTML o en las sustituciones es necesario que se muestre la etiqueta en la regi\00F3n del mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99886947561304437)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de la p\00E1gina actual. Este nombre se utiliza en varias p\00E1ginas e informes de &PRODUCT_NAME., junto con el n\00FAmero de p\00E1gina y el t\00EDtulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99887200435304437)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de este grupo de p\00E1ginas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99888040463304438)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre del proceso de p\00E1gina para facilitar su identificaci\00F3n a los desarrolladores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99996968848304522)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un nombre descriptivo para esta plantilla de p\00E1gina espec\00EDfica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99997082438304522)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un nombre descriptivo para esta plantilla de regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99997605763304523)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca un nombre descriptivo para esta plantilla de informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99996847691304522)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.THEME.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca una abreviatura descriptiva para este tema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99997767342304523)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un nombre para esta interfaz de usuario. El nombre que aparecer\00E1 en los asistentes, como Asistente de Creaci\00F3n de Temas.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99960266053304494)
,p_name=>'PE.PROPERTY.NAME.COMPONENT_PROPERTY.VALIDATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un nombre para la validaci\00F3n. Este nombre debe ser descriptivo para que los desarrolladores puedan identificar de forma sencilla las condiciones que se van comprobar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99846917979304405)
,p_name=>'PE.PROPERTY.NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca un nombre descriptivo para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99846890172304404)
,p_name=>'PE.PROPERTY.NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99861969223304416)
,p_name=>'PE.PROPERTY.NAMED_LOV.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el nombre de una lista de valores existente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99861800128304416)
,p_name=>'PE.PROPERTY.NAMED_LOV.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100473844526304921)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la posici\00F3n de la barra de navegaci\00F3n en el mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100474120895304921)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.D'
,p_message_language=>'es'
,p_message_text=>'Fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100474242830304921)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.END.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra la barra de navegaci\00F3n en la posici\00F3n final (normalmente en el lado derecho) del mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100473969470304921)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.D'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100474055517304921)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.LOV.START.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra la barra de navegaci\00F3n en la posici\00F3n inicial (normalmente en el lado izquierdo) del mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100473764627304921)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de barra de navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100473066863304920)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de barra de navegaci\00F3n que se va a usar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100473564260304921)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.D'
,p_message_language=>'es'
,p_message_text=>unistr('Zoom y br\00FAjula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100473656418304921)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.FULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Controles del zoom y br\00FAjula para controlar la orientaci\00F3n del mapa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100473113285304920)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100473247798304920)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.NONE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Sin barra de navegaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100473351450304920)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.D'
,p_message_language=>'es'
,p_message_text=>'Solo zoom'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100473481245304921)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.LOV.SMALL.HELP'
,p_message_language=>'es'
,p_message_text=>'Solo controles para acerca y alejar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100472936312304920)
,p_name=>'PE.PROPERTY.NAVIGATION_BAR_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100730082969305116)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('No Mostrar Lista de Men\00FA de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99986958704304515)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la lista de men\00FA de navegaci\00F3n utilizada para la navegaci\00F3n en esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99986826856304514)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100729567659305115)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la posici\00F3n para la lista de men\00FA de navegaci\00F3n en esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100729737921305116)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.SIDE.D'
,p_message_language=>'es'
,p_message_text=>'Lateral'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100729684421305116)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.LOV.TOP.D'
,p_message_language=>'es'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100729480938305115)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Lista')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99987125045304515)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la plantilla de la lista de men\00FA de navegaci\00F3n utilizada con la lista de men\00FA de navegaci\00F3n en esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99987050140304515)
,p_name=>'PE.PROPERTY.NAVIGATION_LIST_TEMPLATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100729998115305116)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Seleccione las opciones de plantilla para personalizar la interfaz de usuario de esta lista de navegaci\00F3n.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100729857440305116)
,p_name=>'PE.PROPERTY.NAV_LIST_TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Opciones de Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100543116453304972)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Mostrar una flecha hacia la derecha</dt>',
'<dd><pre>fa-chevron-right</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100543028372304972)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca las clases para el icono que desee agregar al componente. Puede agregar varias clases separ\00E1ndolas con espacios.</p>'),
unistr('        <p>Si el tema utiliza la fuente APEX, revise <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de Ejemplo de Tema Universal</a> para ver los iconos y modificadores disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100542951170304972)
,p_name=>'PE.PROPERTY.NO_DATA_FOUND_ICON_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Icono No se ha encontrado ning\00FAn dato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100727241052305114)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que aparecer\00E1 en la opci\00F3n VALOR NULO de la lista en la parte superior de esta lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100535652406304967)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que aparecer\00E1 en la opci\00F3n VALOR NULO de la lista en la parte superior de esta lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99898727713304446)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que aparecer\00E1 en la opci\00F3n VALOR NULO de la lista en la parte superior de esta lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99900098334304447)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que aparecer\00E1 en la opci\00F3n VALOR NULO de la lista en la parte superior de esta lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99862507557304417)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que se debe mostrar en la opci\00F3n NULL de la lista en la parte superior de esta lista. Este valor tambi\00E9n se muestra al presentar el elemento si el valor es nulo. Si no introduce ning\00FAn texto, aparece como una l\00EDnea en blanco en la')
||' lista y como un elemento en blanco cuando se presenta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99862490731304417)
,p_name=>'PE.PROPERTY.NULL_DISPLAY_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Visualizaci\00F3n Nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99862735930304417)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor que se va a devolver si selecciona el valor NULL en la lista de valores. Si no proporciona un valor, el valor del elemento quedar\00E1 como nulo si selecciona la opci\00F3n NULL de la lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99862634938304417)
,p_name=>'PE.PROPERTY.NULL_RETURN_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor de Retorno Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100220943573304731)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero de filas del informe que se va a mostrar por p\00E1gina del informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100220839344304731)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Filas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100221129175304731)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el elemento cuyo valor especifica el n\00FAmero de filas del informe que se va a mostrar por p\00E1gina del informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100221052176304731)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100220742737304730)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione c\00F3mo se introduce el n\00FAmero de filas para este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100401075553304866)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Basado en Valor de Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100400939354304866)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100220613059304730)
,p_name=>'PE.PROPERTY.NUMBER_OF_ROWS_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Tipo de Filas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99857851024304413)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un destino de URL para cuando un usuario final intenta ejecutar una segunda p\00E1gina. &PRODUCT_NAME. muestra un mensaje de error y un enlace a esta direcci\00F3n URL para permitir que el usuario pueda continuar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99857734732304413)
,p_name=>'PE.PROPERTY.ON_DUPLICATE_PAGE_SUBMISSIONS_GO_TO_THIS_URL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('En las ejecuciones de p\00E1gina duplicadas, ir a esta direcci\00F3n URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100249105391304753)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si la p\00E1gina o la URL sustituye a la p\00E1gina actual o se abre en un cuadro de di\00E1logo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100408470388304874)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.P.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadro de Di\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100408349469304874)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.LOV.W.D'
,p_message_language=>'es'
,p_message_text=>'Misma Ventana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100249084319304753)
,p_name=>'PE.PROPERTY.OPEN_LINK_IN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Abrir Enlace en'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100172982752304695)
,p_name=>'PE.PROPERTY.OPERATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Operaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100061809519304571)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Al acceder a la tabla <code>employee</code>, trate de utilizar el \00EDndice <code>emp_department_ix</code></dt>'),
'<dd><pre>INDEX (employees emp_department_ix)</pre></dd>',
unistr('<dt>Permita el uso de la cl\00E1usula <code>WITH plsql_declarations</code> en la consulta SQL</dt>'),
'<dd><pre>WITH_PLSQL</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100061747249304571)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la indicaci\00F3n de optimizador de Oracle, que se agrega a la sentencia superior al ejecutar la consulta SQL.'),
unistr('        Las indicaciones son instrucciones para el optimizador. Al escribir SQL, puede que ya conozca datos que el optimizador desconozca. Gracias a las indicaciones, podr\00E1 tomar decisiones que normalmente toma el optimizador,'),
unistr('        y que pueden tener como consecuencia la selecci\00F3n de un plan que supone un costo mayor.</p>'),
unistr('        <p>Por ejemplo, si ya sabe que un \00EDndice es m\00E1s selectivo para ciertas consultas, podr\00E1 elegir un plan de ejecuci\00F3n m\00E1s eficaz que el plan que podr\00EDa elegir el optimizador.'),
unistr('        En tal caso, utilice las indicaciones para forzar al optimizador a utilizar el plan de ejecuci\00F3n \00F3ptimo.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100061615455304571)
,p_name=>'PE.PROPERTY.OPTIMIZER_HINT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Indicaci\00F3n de Optimizador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100734218443305119)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una columna indexada por un \00EDndice de Oracle Text.</p>'),
unistr('<p>B\00FAsqueda de fila devuelve resultados basados en el operador de Oracle Text introducido, siempre que se hayan creado los \00EDndices de Oracle Text correspondientes para la columna.'),
unistr('Esta opci\00F3n solo se debe activar si existen los \00EDndices necesarios y los usuarios finales han recibido formaci\00F3n sobre c\00F3mo utilizar los operadores de b\00FAsqueda de Oracle Text.'),
unistr('Para simplificar la sintaxis de Oracle Text para usuarios finales, especifique una funci\00F3n para la configuraci\00F3n de componente de cuadr\00EDculas interactivas en componentes compartidos en el <em>nombre de funci\00F3n PL/SQL de Oracle Text</em>.<br>'),
'Consulte <a rel="noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/19/ccapp/index.html">Oracle Text Application Developers Guide</a>.</p>',
unistr('<p>Nota: Cuando los usuarios finales introducen operadores de Oracle Text correctamente, el rendimiento de las b\00FAsquedas es mucho mejor.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100734104574305119)
,p_name=>'PE.PROPERTY.ORACLE_TEXT_INDEX_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de \00CDndice de Oracle Text')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100565582056304989)
,p_name=>'PE.PROPERTY.ORDS_CLEANUP_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo de limpieza')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100565465610304989)
,p_name=>'PE.PROPERTY.ORDS_INIT_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo de inicializaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100124185960304658)
,p_name=>'PE.PROPERTY.ORIENTATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la orientaci\00F3n de este gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100124211730304658)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'es'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100254881620304758)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.HORIZONTAL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra los elementos de datos del gr\00E1fico horizontalmente. Por ejemplo, las barras de un gr\00E1fico de barras se mostrar\00E1n horizontalmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100254600498304757)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'es'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100254754341304758)
,p_name=>'PE.PROPERTY.ORIENTATION.LOV.VERTICAL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra los elementos de datos del gr\00E1fico verticalmente. Por ejemplo, las barras de un gr\00E1fico de barras se mostrar\00E1n verticalmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100124029132304658)
,p_name=>'PE.PROPERTY.ORIENTATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Orientaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100134093391304666)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la altura de la barra de desplazamiento de visi\00F3n general, en p\00EDxeles (por ejemplo, 50px) o porcentaje (por ejemplo, 15%), para que se presente en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100133979874304666)
,p_name=>'PE.PROPERTY.OVERVIEW_HEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100133812245304666)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si se debe presentar una barra de desplazamiento de visi\00F3n general en el gr\00E1fico.'),
unistr('        Actualmente, esta opci\00F3n solo est\00E1 soportada para los gr\00E1ficos de barras verticales, de l\00EDneas, de \00E1reas, de l\00EDneas con \00E1reas, de valores y de combinaci\00F3n.</p>'),
unistr('        <p>Nota: La opci\00F3n <strong>Zoom y desplazar</strong> debe estar activada para que se muestre la barra de desplazamiento de visi\00F3n general.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100133721737304666)
,p_name=>'PE.PROPERTY.OVERVIEW_RENDERED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99986777113304514)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si se sobrescribe la navegaci\00F3n de nivel de interfaz de usuario por defecto. Se puede utilizar para que no haya navegaci\00F3n para la p\00E1gina actual o para seleccionar una navegaci\00F3n alternativa para la p\00E1gina actual (por ejemplo, para propor')
||unistr('cionar una navegaci\00F3n diferente de una subsecci\00F3n de la aplicaci\00F3n).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99986679369304514)
,p_name=>'PE.PROPERTY.OVERWRITE_NAVIGATION_LIST.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Sustituir Nivel de Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99857484598304413)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione qu\00E9 tipo de protecci\00F3n de estado de sesi\00F3n se implanta para esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100358685657304835)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.D'
,p_message_language=>'es'
,p_message_text=>'Los Argumentos Deben Tener Total de Control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100358757105304835)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.C.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si los argumentos Solicitud, Borrar Cach\00E9 o el par Nombre/Valor aparecen en la direcci\00F3n URL, se debe proporcionar tambi\00E9n un total de control.<br>'),
unistr('El tipo de total de control debe ser compatible con el atributo <em>Protecci\00F3n de Estado de la Sesi\00F3n</em> m\00E1s exigente de todos los elementos que se han transferido como argumentos.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100359069865304835)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.D'
,p_message_language=>'es'
,p_message_text=>'No hay Acceso a URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100359137218304835)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.D.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('No se puede acceder a la p\00E1gina mediante una direcci\00F3n URL.<br>'),
unistr('Sin embargo, la p\00E1gina puede ser el destino de un tipo de bifurcaci\00F3n <em>Bifurcar a P\00E1gina</em>, que no efect\00FAa un redireccionamiento a la direcci\00F3n URL.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100358409831304834)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'No Restringido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100358599890304834)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.N.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina puede solicitarse mediante una direcci\00F3n URL, con o sin argumentos de estado de la sesi\00F3n y sin necesidad de realizar un total de control.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100358899308304835)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.D'
,p_message_language=>'es'
,p_message_text=>'Sin Argumentos Soportados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100358943232304835)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.LOV.U.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Se puede utilizar una direcci\00F3n URL para solicitar la p\00E1gina, pero \00E9sta no puede contener los argumentos Solicitud, Borrar Cach\00E9 o el par Nombre/Valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99857377011304413)
,p_name=>'PE.PROPERTY.PAGE_ACCESS_PROTECTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Protecci\00F3n de Acceso a P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99848309254304406)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca un alias alfanum\00E9rico para esta p\00E1gina. Puede utilizar este alias para hacer referencia a la p\00E1gina en lugar de al n\00FAmero de p\00E1gina.'),
unistr('Por ejemplo, si estuviera trabajando en la p\00E1gina 1 de la aplicaci\00F3n 100, crear\00EDa un alias denominado <code>home<code>.'),
unistr('Seguidamente podr\00EDa acceder a esta p\00E1gina desde otras p\00E1ginas mediante la siguiente sintaxis f?p:'),
'<pre>f?p=100:home</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99848272610304406)
,p_name=>'PE.PROPERTY.PAGE_ALIAS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Alias de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99857075958304413)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si esta p\00E1gina es p\00FAblica o necesita autenticaci\00F3n.'),
unistr('Si una p\00E1gina se identifica como p\00FAblica, la podr\00E1 ver cualquier usuario que acceda a ella.'),
unistr('La funci\00F3n de protecci\00F3n de p\00E1gina de la aplicaci\00F3n puede acceder a este atributo de p\00E1gina para identificar p\00E1ginas que no necesitan una autenticaci\00F3n previa para verlas.'),
unistr('La implantaci\00F3n de la funci\00F3n de protecci\00F3n de p\00E1gina del esquema de autenticaci\00F3n determina si este atributo tiene alg\00FAn efecto.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100357807458304834)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>unistr('La P\00E1gina Necesita Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100357903729304834)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina P\00FAblica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99856978175304413)
,p_name=>'PE.PROPERTY.PAGE_AUTHENTICATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99848584609304406)
,p_name=>'PE.PROPERTY.PAGE_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique el grupo de p\00E1ginas que desea asociar a esta p\00E1gina.'),
unistr('Los grupos de p\00E1ginas no afectan a la funcionalidad, pero ayudan a que los desarrolladores gestionen las p\00E1ginas en una aplicaci\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99848480656304406)
,p_name=>'PE.PROPERTY.PAGE_GROUP.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Grupo de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99856067297304412)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el texto sustituido para la cadena de sustituci\00F3n <code>#ONLOAD#</code> de la plantilla de p\00E1gina.'),
unistr('Para utilizar esta funci\00F3n, la plantilla de p\00E1gina debe incluir la cadena de sustituci\00F3n <code>#ONLOAD#</code>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99855933544304412)
,p_name=>'PE.PROPERTY.PAGE_HTML_BODY_ATTRIBUTE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Atributo de Cuerpo HTML de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99848752286304406)
,p_name=>'PE.PROPERTY.PAGE_MODE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el modo de p\00E1gina para esta p\00E1gina.</p>'),
'#LOV_VALUES#',
unistr('<p>Tenga en cuenta que las opciones <em>Cuadro de Di\00E1logo Modal</em> y <em>Cuadro de Di\00E1logo No Modal</em> solo se podr\00E1n seleccionar cuando el tema de la aplicaci\00F3n actual contenga una <em>plantilla de p\00E1gina de cuadro de di\00E1logo</em> por defecto.</')
||'p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100356966905304833)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadro de Di\00E1logo Modal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100357078150304833)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.MODAL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La p\00E1gina se presenta como un cuadro de di\00E1logo modal.<br>'),
unistr('Un cuadro de di\00E1logo modal es una ventana superpuesta posicionada en el viewport, que permanece activa y enfocada hasta que el usuario final la cierra.'),
unistr('La p\00E1gina subyacente queda atenuada y el usuario final no puede interactuar con el resto de la p\00E1gina hasta que el cuadro de di\00E1logo se cierra.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100357164650304833)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadro de Di\00E1logo No Modal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100357205855304834)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La p\00E1gina se presenta como un cuadro de di\00E1logo no modal.<br>'),
unistr('Un cuadro de di\00E1logo no modal es una ventana superpuesta posicionada en el viewport, en la que el usuario final puede interactuar con el cuadro de di\00E1logo y el contenido de la p\00E1gina que inici\00F3 el cuadro de di\00E1logo.'),
unistr('Un cuadro de di\00E1logo no modal puede utilizarse cuando la informaci\00F3n solicitada no es esencial para continuar, el trabajo puede continuar en cualquier otro lugar mientras la ventana se encuentra a\00FAn abierta.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100356790015304833)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.D'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100356806922304833)
,p_name=>'PE.PROPERTY.PAGE_MODE.LOV.NORMAL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina se presenta como una p\00E1gina normal de la aplicaci\00F3n &PRODUCT_NAME..')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99848627659304406)
,p_name=>'PE.PROPERTY.PAGE_MODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Modo de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100698257961305092)
,p_name=>'PE.PROPERTY.PAGE_NAVIGATION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100057272849304568)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el tipo de proceso que se ejecutar\00E1. Est\00E1n soportados los siguientes tipos de proceso:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>En funci\00F3n de la configuraci\00F3n de la aplicaci\00F3n, puede disponer tambi\00E9n aqu\00ED de plugins de tipo de proceso adicionales.'),
'Se muestran como <em>&lt;Mi Plugin&gt; [Plug-in]</em>.',
unistr('Los siguientes plugins est\00E1n instalados en los componentes compartidos de la aplicaci\00F3n:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99880191873304431)
,p_name=>'PE.PROPERTY.PAGE_PROCESS_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100681311278305079)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n PL/SQL que devuelva un valor utilizado como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100681271512305079)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_FUNCTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100681194014305079)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina utilizado como origen para este par\00E1metro. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100681010859305079)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100681587625305080)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca uno o varios elementos de p\00E1gina o de aplicaci\00F3n para utilizarlo como destino de este par\00E1metro. Para obtener varios elementos, separe cada nombre de elemento por una coma.</p>'),
'<p>Puede escribir el nombre o seleccionarlo de la lista de elementos disponibles.',
'Si lo selecciona de la lista y ya hay texto introducido, se coloca una coma al final del texto existente, seguido del nombre de elemento que se ha devuelto de la lista.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100681438350305080)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_ITEMS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100682775219305080)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el origen del par\00E1metro en la lista disponible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100683263544305081)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100683383108305081)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.FUNCTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde el <em>cuerpo de la funci\00F3n PL/SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100682833699305081)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100682940952305081)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de estado de sesi\00F3n del <em>elemento</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100683056399305081)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100683167894305081)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.LOV.STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el texto introducido en <em>Valor Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100682630716305080)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_SOURCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Origen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100205088938304719)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor para este par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100204966658304719)
,p_name=>'PE.PROPERTY.PAGE_PROC_WS_PARM_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100232764232304740)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto de Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99848905970304406)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una plantilla de p\00E1gina para definir la apariencia y el dise\00F1o de esta p\00E1gina.</p>'),
unistr('        <p>Las plantillas de p\00E1gina se definen en el tema de la aplicaci\00F3n.'),
unistr('        Al crear una p\00E1gina, la plantilla se define autom\00E1ticamente en el <em>tema por defecto</em> que representar\00E1 la p\00E1gina mediante la plantilla de p\00E1gina por defecto definida en el tema actual.'),
unistr('        La selecci\00F3n realizada aqu\00ED sustituir\00E1 a la plantilla de p\00E1gina por defecto.</p>'),
unistr('        <p>Muchos temas contienen plantillas de p\00E1gina con prop\00F3sitos espec\00EDficos, por ejemplo para mostrar contenido con columnas laterales, la p\00E1gina de conexi\00F3n, p\00E1ginas de cuadro de di\00E1logo, etc.<br>'),
unistr('        El tema universal proporciona las siguientes plantillas de p\00E1gina:'),
'          <dl>',
unistr('            <dt>Est\00E1ndar</dt>'),
unistr('              <dd>La plantilla de p\00E1gina por defecto. Ideal para p\00E1ginas iniciales, panales de control, informes grandes y otros dise\00F1os donde es preferible una pantalla lo m\00E1s real posible con el tama\00F1o m\00E1ximo.</dd>'),
'            <dt>Columna izquierda</dt>',
unistr('              <dd>Proporciona una posici\00F3n de visualizaci\00F3n en la parte izquierda que resulta \00FAtil para buscar y filtrar p\00E1ginas.</dd>'),
'            <dt>Columna derecha</dt>',
unistr('              <dd>Proporciona una posici\00F3n de visualizaci\00F3n lateral derecha reducible que resulta \00FAtil para mostrar controles orientados a la acci\00F3n como botones o listas.</dd>'),
'            <dt>Columnas izquierda y derecha</dt>',
unistr('              <dd>Proporciona la columna lateral izquierda y la columna lateral derecha reducible, adecuadas para p\00E1ginas muy complejas.</dd>'),
unistr('            <dt>Conexi\00F3n</dt>'),
unistr('              <dd>Se utiliza de forma exclusiva para la p\00E1gina de conexi\00F3n a la aplicaci\00F3n.</dd>'),
'            <dt>Marquesina</dt>',
unistr('              <dd>Proporciona una columna lateral derecha reducible y un \00E1rea de barra de t\00EDtulos que contiene la informaci\00F3n primaria.'),
unistr('              Esta plantilla de p\00E1gina es adecuada para mostrar un \00FAnico registro con distintos datos o informes relacionados.'),
unistr('              La marquesina se utiliza de forma habitual para mostrar las relaciones maestro-detalle donde, en primer lugar, se selecciona un \00FAnico registro maestro de un informe. </dd>'),
unistr('            <dt>M\00EDnimo (sin navegaci\00F3n)</dt>'),
unistr('              <dd>Resulta \00FAtil para p\00E1ginas muy simples, renuncias, aplicaciones de una sola p\00E1gina o donde no es necesaria la navegaci\00F3n.</dd>'),
'          </dl>',
unistr('          Consulte tambi\00E9n: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de Ejemplo de Tema Universal</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99848891206304406)
,p_name=>'PE.PROPERTY.PAGE_TEMPLATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Plantilla de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100232948085304740)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto de Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100673993408305070)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'Utiliza el valor definido en los valores por defecto del tema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99849784970304407)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique la transici\00F3n utilizada al navegar a una nueva p\00E1gina o cuando la p\00E1gina se est\00E1 ejecutando.</p>'),
'<p>Los exploradores antiguos que no soportan transformaciones en 3D no pueden utilizar la mayor parte de las transiciones.',
'Por defecto, los dispositivos que no soportan 3D (como Android 2.x) se reservan en difuminado para todos los tipos de transiciones.',
unistr('Consulte la documentaci\00F3n de jQuery Mobile para obtener m\00E1s informaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100361888875304837)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FADE.D'
,p_message_language=>'es'
,p_message_text=>'Difuminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100361910244304837)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLIP.D'
,p_message_language=>'es'
,p_message_text=>'Invertir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100362075625304837)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.FLOW.D'
,p_message_language=>'es'
,p_message_text=>'Flujo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100361795678304837)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100362191995304837)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.POP.D'
,p_message_language=>'es'
,p_message_text=>'Aparecer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100362219212304837)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'es'
,p_message_text=>'Deslizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100362399877304837)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'es'
,p_message_text=>'Deslizar hacia Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100362461706304837)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'es'
,p_message_text=>'Deslizar Difuminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100362577310304837)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'es'
,p_message_text=>'Deslizar hacia Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100362632364304837)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.LOV.TURN.D'
,p_message_language=>'es'
,p_message_text=>'Girar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99849688652304407)
,p_name=>'PE.PROPERTY.PAGE_TRANSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Transici\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100537841373304968)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si se advierte al usuario si intenta salir de la p\00E1gina y no se han guardado los cambios en ella.'),
unistr('        Los elementos de p\00E1gina y los botones ofrecen tambi\00E9n un control m\00E1s detallado sobre cu\00E1ndo se realiza esta comprobaci\00F3n y lo que incluye.'),
unistr('        Para los botones, puede especificar si al hacer clic en el bot\00F3n se realiza la comprobaci\00F3n.'),
unistr('        Para los elementos de p\00E1gina, puede especificar si se incluyen cambios en el elemento o la comprobaci\00F3n los ignora (consulte el atributo <em>Advertencia sobre cambios sin guardar</em> para ambos).</p>'),
unistr('        <p>Nota: No se aplica para un usuario final que est\00E1 cerrando una p\00E1gina de cuadro de di\00E1logo modal.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100537733827304968)
,p_name=>'PE.PROPERTY.PAGE_WARN_ON_UNSAVED_CHANGES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Advertencia sobre Cambios sin Guardar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100185214459304705)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione d\00F3nde se mostrar\00E1 la paginaci\00F3n de informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100386496744304855)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_LEFT.D'
,p_message_language=>'es'
,p_message_text=>'Inferior Izquierda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100386578021304855)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.BOTTOM_RIGHT.D'
,p_message_language=>'es'
,p_message_text=>'Inferior Derecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100386870738304856)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_LEFT.D'
,p_message_language=>'es'
,p_message_text=>'Superior e Inferior Izquierda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100386964463304856)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_AND_BOTTOM_RIGHT.D'
,p_message_language=>'es'
,p_message_text=>'Superior e Inferior Derecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100386631334304855)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_LEFT.D'
,p_message_language=>'es'
,p_message_text=>'Superior Izquierda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100386793401304855)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.LOV.TOP_RIGHT.D'
,p_message_language=>'es'
,p_message_text=>'Superior Derecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100185179776304704)
,p_name=>'PE.PROPERTY.PAGINATION_DISPLAY_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100697911169305092)
,p_name=>'PE.PROPERTY.PARAMETER_ID.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('ID de Par\00E1metro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100169440087304693)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el par\00E1metro es obligatorio y se debe definir siempre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100169327717304693)
,p_name=>'PE.PROPERTY.PARAMETER_REQUIRED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Necesario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100169636033304693)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique un valor por defecto o est\00E1tico para este par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100169597809304693)
,p_name=>'PE.PROPERTY.PARAMETER_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99905206466304452)
,p_name=>'PE.PROPERTY.PARENT_REGION.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99864236263304418)
,p_name=>'PE.PROPERTY.PARENT_REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la regi\00F3n principal en la que se mostrar\00E1 la regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99864105192304418)
,p_name=>'PE.PROPERTY.PARENT_REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100220542245304730)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea utilizar el Refrescamiento Parcial de P\00E1gina (PRR) para actualizar la visualizaci\00F3n de informes.</p>'),
unistr('Si el usuario final realiza una acci\00F3n, como una solicitud de paginaci\00F3n o la selecci\00F3n de una nueva columna de ordenaci\00F3n, las filas del informe actual se deben refrescar. Al definir este atributo en <strong>Activado</strong>, solo se refresca la re')
||unistr('gi\00F3n del informe. Al definir este atributo en <strong>Desactivado</strong>, se refresca toda la p\00E1gina.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100220497628304730)
,p_name=>'PE.PROPERTY.PARTIAL_PAGE_REFRESH.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Refrescamiento de P\00E1gina Parcial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100397523396304863)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100216011673304727)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color que se utiliza para el fondo de este gr\00E1fico.</p>'),
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100215961954304727)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BACKGROUD_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fondo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100216465275304727)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el ancho en p\00EDxeles para este gr\00E1fico de barras.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100216317918304727)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ancho de Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100243313485304748)
,p_name=>'PE.PROPERTY.PCT_GRAPH_BAR_WIDTH.UNIT'
,p_message_language=>'es'
,p_message_text=>unistr('p\00EDxeles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100448060857304902)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100216214420304727)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color que se utiliza para el primer plano de este gr\00E1fico.</p>'),
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100216145132304727)
,p_name=>'PE.PROPERTY.PCT_GRAPH_FOREGROUND_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Primer Plano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100128336600304662)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la fracci\00F3n del gr\00E1fico de tarta completo por debajo de la cual las porciones se agregan a una porci\00F3n "Otros". Los valores v\00E1lidos van de 0 (por defecto) a 1</p>'),
unistr('        <p>Por ejemplo, un valor de 0,15 har\00EDa que todas las porciones que son inferiores al 15 % de la tarta se agregaran a la porci\00F3n "Otros".</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100128289553304662)
,p_name=>'PE.PROPERTY.PIE_OTHER_THRESHOLD.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Umbral Otros de Grafico de Tarta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100158958969304685)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el efecto aplicado al seleccionar un segmento de tarta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100159090912304685)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.EXPLODE.D'
,p_message_language=>'es'
,p_message_text=>'Separar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100159296060304685)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHT.D'
,p_message_language=>'es'
,p_message_text=>'Resaltar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100159127705304685)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.LOV.HIGHLIGHTANDEXPLODE.D'
,p_message_language=>'es'
,p_message_text=>'Resaltar y Separar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100158887773304685)
,p_name=>'PE.PROPERTY.PIE_SELECTION_EFFECT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Efecto de Selecci\00F3n de Tarta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100237347766304743)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n PL/SQL que proporcione un valor para la clave primaria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100237279267304743)
,p_name=>'PE.PROPERTY.PK_SOURCE_PLSQL_EXPRESSION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100237549312304744)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca un nombre para la clave primaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100237417938304743)
,p_name=>'PE.PROPERTY.PK_SOURCE_SEQUENCE_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100237114562304743)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el tipo de origen de la clave primaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100404498228304868)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.F.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100404593440304868)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.S.D'
,p_message_language=>'es'
,p_message_text=>'Secuencia Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100404335913304868)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.LOV.T.D'
,p_message_language=>'es'
,p_message_text=>'Disparador Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100237005708304743)
,p_name=>'PE.PROPERTY.PK_SOURCE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100321408512304807)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la consulta SQL que se utilizar\00E1 en lugar de la consulta generada autom\00E1ticamente que selecciona los valores de columna distintos. La consulta SQL necesita devolver una columna. Al introducir una consulta SQL, se mejora el rendimiento en a')
||'lgunos informes. Esta lista de valores muestra cuando un usuario hace clic en una cabecera de columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100321348536304807)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_LOV_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100321042192304807)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione c\00F3mo derivar la lista de valores para el filtro de la lista desplegable de la columna de informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100409460382304875)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.D'
,p_message_language=>'es'
,p_message_text=>'Utilice Lista de Valores con Nombre para Filtrar Coincidencia Exacta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100409534355304875)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.1.HELP'
,p_message_language=>'es'
,p_message_text=>'Deriva la lista de valores de la lista de valores con nombre para crear un filtro igual.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100409675441304875)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.D'
,p_message_language=>'es'
,p_message_text=>'Utilizar Lista de Valores con Nombre para Filtrar la Palabra Contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100409724054304875)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.2.HELP'
,p_message_language=>'es'
,p_message_text=>'Deriva la lista de valores de la lista de valores con nombre para crear un filtro "contiene".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100409265980304874)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.D'
,p_message_language=>'es'
,p_message_text=>'Utilizar Lista de Valores Definida para Filtrar la Palabra Contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100409378367304875)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.C.HELP'
,p_message_language=>'es'
,p_message_text=>'Deriva la lista de valores de una consulta SQL de lista de valores definida para crear un filtro "contiene".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100408866734304874)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.D'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto Basado en Tipo de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100408994591304874)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.D.HELP'
,p_message_language=>'es'
,p_message_text=>'Las columnas STRING y NUMBER derivan la lista de valores de valores de columna distintos. Las columnas DATE la derivan de rangos de fechas predefinidos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100408618177304874)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100408705269304874)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.N.HELP'
,p_message_language=>'es'
,p_message_text=>'Desactiva el filtro en listas de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100409042637304874)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.D'
,p_message_language=>'es'
,p_message_text=>'Utilizar Lista de Valores Definida para Filtrar Coincidencia Exacta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100409187009304874)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.LOV.S.HELP'
,p_message_language=>'es'
,p_message_text=>'Deriva la lista de valores de una consulta SQL de lista de valores definida para crear un filtro igual.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100320953883304807)
,p_name=>'PE.PROPERTY.PLAIN_LOV_IR_COLUMN_FILTER_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100565939267304989)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.APP_PROCESS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el c\00F3digo PL/SQL que se debe ejecutar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100175271171304697)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el c\00F3digo PL/SQL que se debe ejecutar en la base de datos remota.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100175143011304697)
,p_name=>'PE.PROPERTY.PLSQL_CODE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el c\00F3digo PL/SQL para generar la salida HTML.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99941908554304480)
,p_name=>'PE.PROPERTY.PLSQL_CODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el origen PL/SQL utilizado en este esquema de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99941819444304480)
,p_name=>'PE.PROPERTY.PLSQL_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100174642527304697)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la ubicaci\00F3n de ejecuci\00F3n del proceso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100174765098304697)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.D'
,p_message_language=>'es'
,p_message_text=>'Base de Datos Local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100174803532304697)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El c\00F3digo PL/SQL se ejecuta en la base de datos local.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100174940419304697)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.D'
,p_message_language=>'es'
,p_message_text=>'SQL activado para REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100175035251304697)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El c\00F3digo PL/SQL se ejecuta en una base de datos remota en la que la conexi\00F3n se define mediante SQL activado para REST. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100174553213304696)
,p_name=>'PE.PROPERTY.PLSQL_PROCESS_LOCATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ubicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100056338265304567)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la categor\00EDa de la interfaz de usuario en la que aparecer\00E1 el plugin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100382323287304852)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.COMPONENT.D'
,p_message_language=>'es'
,p_message_text=>'Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100382404426304852)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EFFECT.D'
,p_message_language=>'es'
,p_message_text=>'Efecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100382535655304852)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.EXECUTE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100382641787304852)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.INIT.D'
,p_message_language=>'es'
,p_message_text=>'Inicializar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100382743724304852)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.MISC.D'
,p_message_language=>'es'
,p_message_text=>'Varios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100382872810304853)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NAVIGATION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100382934139304853)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.NOTIFICATION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100383073279304853)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.LOV.STYLE.D'
,p_message_language=>'es'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100056227394304567)
,p_name=>'PE.PROPERTY.PLUGIN_CATEGORY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Categor\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100708466453305100)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca el c\00F3digo JavaScript que pueda ejecutarse. Nota: La naturaleza exacta de lo que hace depender\00E1 del plugin actual.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100708399836305100)
,p_name=>'PE.PROPERTY.PLUGIN_INIT_JAVASCRIPT_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo JavaScript de inicializaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100233029443304740)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto de Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100674057698305070)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'Utiliza el valor definido en los valores por defecto del tema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99849977061304407)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique la transici\00F3n utilizada al abrir un elemento emergente.</p>'),
'<p>Los exploradores antiguos, que no soportan transformaciones en 3D, no pueden utilizar la mayor parte de las transiciones.',
'Por defecto, los dispositivos que no soportan 3D (como Android 2.x) se reservan en difuminado para todos los tipos de transiciones.',
unistr('Consulte la documentaci\00F3n de jQuery Mobile para obtener m\00E1s informaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100362826332304838)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FADE.D'
,p_message_language=>'es'
,p_message_text=>'Difuminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100362928356304838)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLIP.D'
,p_message_language=>'es'
,p_message_text=>'Invertir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100363011197304838)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.FLOW.D'
,p_message_language=>'es'
,p_message_text=>'Flujo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100362714153304837)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100363123651304838)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.POP.D'
,p_message_language=>'es'
,p_message_text=>'Aparecer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100363229688304838)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDE.D'
,p_message_language=>'es'
,p_message_text=>'Deslizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100363349552304838)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEDOWN.D'
,p_message_language=>'es'
,p_message_text=>'Deslizar hacia Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100363400719304838)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEFADE.D'
,p_message_language=>'es'
,p_message_text=>'Deslizar Difuminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100363560006304838)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.SLIDEUP.D'
,p_message_language=>'es'
,p_message_text=>'Deslizar hacia Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100363640434304838)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.LOV.TURN.D'
,p_message_language=>'es'
,p_message_text=>'Girar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99849804026304407)
,p_name=>'PE.PROPERTY.POPUP_TRANSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Transici\00F3n Emergente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99942993097304481)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el nombre del procedimiento que ejecutar\00E1 el procedimiento de conexi\00F3n (API de conexi\00F3n) de &PRODUCT_NAME. despu\00E9s del paso de autenticaci\00F3n (verificaci\00F3n de credenciales de conexi\00F3n).'),
unistr('El procedimiento de conexi\00F3n ejecuta este c\00F3digo despu\00E9s de realizar sus tareas de procedimiento de conexi\00F3n normales, que incluyen la definici\00F3n de una cookie y el registro de la sesi\00F3n, pero antes de redireccionarse a la p\00E1gina de aplicaci\00F3n desead')
||'a.',
unistr('El procedimiento se puede definir en el atributo "C\00F3digo PL/SQL" o en la propia base de datos.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99942816864304481)
,p_name=>'PE.PROPERTY.POST_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre del Procedimiento Posterior a la Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99870384069304423)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una expresi\00F3n PL/SQL para acotar el valor del elemento.</p>'),
unistr('<p> Por ejemplo, si este elemento se denomina <code>P1_X</code>, se podr\00EDan utilizar expresiones posteriores al c\00E1lculo como <code>UPPER(:P1_X)</code>, <code>INITCAP(:P2_Y)</code>, <code>MIN(:P1_X, :P2_Y - 200)</code>, <code>NVL(:P1_X, :P2_Y)</code> ')
||unistr('o una llamada de funci\00F3n como <code>my_func(:P1_X)</code> para definir el valor final del elemento.'),
unistr('Tenga en cuenta que estos ejemplos demuestran que las expresiones pueden hacer referencia al elemento actual, o que tambi\00E9n pueden hacer referencia a cualquier otro elemento en el estado de sesi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99870273235304423)
,p_name=>'PE.PROPERTY.POST_CALCULATION_COMPUTATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Estimaci\00F3n Posterior al C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99943394633304481)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la URL a la que se redirige la aplicaci\00F3n despu\00E9s de que &PRODUCT_NAME. haya limpiado la sesi\00F3n de usuario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99943212690304481)
,p_name=>'PE.PROPERTY.POST_LOGOUT_URL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('URL Posterior a la Desconexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100620359455305030)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100620620654305030)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100620581937305030)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100620418388305030)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100620706643305030)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100620210717305030)
,p_name=>'PE.PROPERTY.POST_PROC_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100621531800305031)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n Java, donde la consulta SQL devuelta transforma los datos recuperados del origen web. La consulta SQL devuelta por el cuerpo de la funci\00F3n Java debe seleccionar de la pseudotabla #APEX$SOURCE_DATA# y leer las column')
||unistr('as disponibles en el perfil de datos. La creaci\00F3n de subconsultas mediante la cl\00E1usula WITH SQL no est\00E1 soportada aqu\00ED. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100621465109305031)
,p_name=>'PE.PROPERTY.POST_PROC_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100621319227305031)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Seleccione las columnas EMPNO, ENAME y SAL y filtre todas las filas con SAL en menos de 3000.</dt>',
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100621251185305031)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n JavaScript, donde la consulta SQL devuelta transforma los datos recuperados del origen web. La consulta SQL devuelta por el cuerpo de la funci\00F3n JavaScript debe seleccionar de la pseudotabla #APEX$SOURCE_DATA# y lee')
||unistr('r las columnas disponibles en el perfil de datos. La creaci\00F3n de subconsultas mediante la cl\00E1usula WITH SQL no est\00E1 soportada aqu\00ED. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100621104527305031)
,p_name=>'PE.PROPERTY.POST_PROC_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100675863546305072)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para mostrar primero las nuevas contrataciones y despu\00E9s las contrataciones pendientes. Si las fechas coinciden, ordenarlas por n\00FAmero de departamento.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100675703760305072)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca uno o m\00E1s nombres de columna separados por coma, incluidas las directivas, para definir el orden en el que se recuperan los registros.</p>'),
'        <p>Directivas incluidas:',
'          <ul>',
'            <li>ASC: devuelve la columna en orden ascendente</li>',
'            <li>DESC: devuelve la columna en orden descendente</li>',
'            <li>NULLS FIRST: devuelve la columna sin valores antes de los que tienen valores</li>',
'            <li>NULLS LAST: devuelve la columna con los valores antes de los que no tienen valores</li>',
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100675622960305072)
,p_name=>'PE.PROPERTY.POST_PROC_ORDER_BY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ordenar por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100621096715305031)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Seleccione las columnas EMPNO, ENAME y SAL y filtre todas las columnas con SAL en menos de 3000.</dt>',
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from #APEX$SOURCE_DATA where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100620962949305031)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n PL/SQL, donde la consulta SQL devuelta transforma los datos recuperados del origen web. La consulta SQL devuelta por el cuerpo de la funci\00F3n PL/SQL debe seleccionar de la pseudotabla #APEX$SOURCE_DATA# y leer las co')
||unistr('lumnas disponibles en el perfil de datos. La creaci\00F3n de subconsultas mediante la cl\00E1usula WITH SQL no est\00E1 soportada aqu\00ED. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100620876157305030)
,p_name=>'PE.PROPERTY.POST_PROC_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100621704041305031)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n Python, donde la consulta SQL devuelta transforma los datos recuperados del origen web. La consulta SQL devuelta por el cuerpo de la funci\00F3n Python debe seleccionar de la pseudotabla #APEX$SOURCE_DATA# y leer las co')
||unistr('lumnas disponibles en el perfil de datos. La creaci\00F3n de subconsultas mediante la cl\00E1usula WITH SQL no est\00E1 soportada aqu\00ED. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100621659136305031)
,p_name=>'PE.PROPERTY.POST_PROC_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100677328148305073)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Seleccione las columnas EMPNO, ENAME y SAL y filtre todas las filas con SAL en menos de 3000.</dt>',
'<dd><pre>',
'select EMPNO, ENAME, SAL',
'  from #APEX$SOURCE_DATA#',
' where SAL < 3000',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100676053237305072)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una consulta SQL para transformar los datos recuperados del origen de datos de REST. Seleccione de la pseudotabla #APEX$SOURCE_DATA# y especifique las columnas disponibles en el perfil de datos. La creaci\00F3n de subconsultas mediante la cl\00E1u')
||unistr('sula WITH SQL no est\00E1 soportada aqu\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100675947244305072)
,p_name=>'PE.PROPERTY.POST_PROC_SQL_QUERY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100675519441305072)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Incluir solo a los empleados a cargo de un m\00E1nager o que trabajan como vendedor.</dt>'),
'<dd><pre>',
'( MGR is not null or JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100675493612305071)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una condici\00F3n Where de SQL v\00E1lida utilizada para limitar los registros recuperados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100675390914305071)
,p_name=>'PE.PROPERTY.POST_PROC_WHERE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cl\00E1usula WHERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99942794872304481)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del procedimiento que se ejecutar\00E1 despu\00E9s de que se ejecute la p\00E1gina de conexi\00F3n y justo antes de que se realice la verificaci\00F3n de credenciales.'),
unistr('El procedimiento se puede definir en el atributo "C\00F3digo PL/SQL" o en la base de datos.</p>'),
unistr('<p>Los esquemas de autenticaci\00F3n en los que la comprobaci\00F3n de credenciales se realiza fuera de &PRODUCT_NAME., normalmente no ejecutan el procedimiento de autenticaci\00F3n anterior.'),
unistr('Algunos ejemplos son: <em>Variable de Cabecera HTTP</em>, <em>Oracle Application Server Single Sign-On</em> y esquemas de autenticaci\00F3n personalizados que utilizan <tt>apex_authentication.post_login</tt> en lugar de <tt>apex_authentication.login</tt>')
||'.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99942603017304481)
,p_name=>'PE.PROPERTY.PRE_AUTHENTICATION_PROCEDURE_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre del Procedimiento Anterior a la Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100246627725304751)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la columna que contiene la clave primaria de la tabla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100246511304304751)
,p_name=>'PE.PROPERTY.PRIMARY_KEY_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100411284404304876)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100324250802304809)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para ver el borde del atributo especificado.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100324151234304809)
,p_name=>'PE.PROPERTY.PRINT_BORDER_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color del Borde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100324014862304809)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el ancho, en p\00EDxeles, de los bordes de la tabla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100323925519304809)
,p_name=>'PE.PROPERTY.PRINT_BORDER_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ancho del Borde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100448334311304903)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100327436540304812)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para mostrar el fondo para este componente.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100327394930304812)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_BG_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fondo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100413389975304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100327296538304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para mostrar este componente.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100327160475304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100326642335304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un tipo de fuente para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100413003438304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'es'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100412849132304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'es'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100412960404304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'es'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100326531447304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_FAMILY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100327041934304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un tama\00F1o de fuente para este componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100326981597304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Fuente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100326807758304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un grosor de fuente para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100413250772304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'es'
,p_message_text=>'Negrita'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100413174446304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100326798843304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_FONT_WEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Grosor de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100448213610304902)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100326417716304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para mostrar el fondo para este componente.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100326381927304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_BG_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fondo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100412798462304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100326243898304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para mostrar este componente.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100326194359304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100325660470304810)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un tipo de fuente para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100412493020304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'es'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100412245415304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'es'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100412372537304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'es'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100325519877304810)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_FAMILY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100326000830304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un tama\00F1o de fuente para este componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100325900664304811)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Fuente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100325847348304810)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un grosor de fuente para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100412673095304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'es'
,p_message_text=>'Negrita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100412538091304877)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100325718085304810)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_HEADING_FONT_WEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Grosor de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100215281852304726)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el ancho de columna que se utiliza para dimensionar esta columna al imprimir el informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100215180081304726)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ancho de Impresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100330051588304814)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione las unidades que se utilizar\00E1n para definir los valores del ancho de columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100414885144304878)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.PERCENTAGE.D'
,p_message_language=>'es'
,p_message_text=>'Porcentaje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100414929932304878)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.LOV.POINTS.D'
,p_message_language=>'es'
,p_message_text=>'Punto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100329983949304813)
,p_name=>'PE.PROPERTY.PRINT_COLUMN_WIDTH_UNITS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Unidades de Ancho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100329204056304813)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca un nombre para el documento descargado. Si lo deja en blanco, se utiliza el nombre de regi\00F3n como nombre de archivo.'),
'',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100329152799304813)
,p_name=>'PE.PROPERTY.PRINT_FILE_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre de Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100323809866304809)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la altura de esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100323711976304809)
,p_name=>'PE.PROPERTY.PRINT_HEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100330645355304814)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el texto del enlace de descarga. Para sustituir el enlace por un componente de navegaci\00F3n diferente, como un bot\00F3n, deje este campo en blanco. Puede configurar el otro componente para iniciar el proceso de impresi\00F3n mediante una direcci')
||unistr('\00F3n URL con la siguiente sintaxis como destino: </p>'),
'<p><pre>f?p=&amp;APP_ID.:&amp;SESSION.:FLOW_XMLP_OUTPUT_R[REGION_ID]</pre></p>',
unistr('<p><strong>Nota</strong>: sustituya <code>[REGION_ID]</code> en la cadena anterior por el ID de regi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100330502957304814)
,p_name=>'PE.PROPERTY.PRINT_LINK_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100323296308304809)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la orientaci\00F3n de la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100410736604304876)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'es'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100410687000304875)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'es'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100323185614304808)
,p_name=>'PE.PROPERTY.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Orientaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100330130553304814)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Derivar de Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100330768008304814)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Derivar de Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100329429561304813)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el formato de salida del informe. Tambi\00E9n puede hacer que un elemento especifique el formato de salida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100414694180304878)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.HTM.D'
,p_message_language=>'es'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100414358966304878)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.PDF.D'
,p_message_language=>'es'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100414417634304878)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.RTF.D'
,p_message_language=>'es'
,p_message_text=>'Word'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100414555212304878)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XLS.D'
,p_message_language=>'es'
,p_message_text=>'Excel'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100414743851304878)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.LOV.XML.D'
,p_message_language=>'es'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100329318370304813)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100329665411304813)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contenga el valor de formato. Puede incluir un elemento de p\00E1gina <em>Lista de Selecci\00F3n</em> para que los usuarios puedan seleccionar el formato de salida en tiempo de ejecuci\00F3n. Los valores v\00E1lid')
||'os son</p>',
'<dl>',
'<dt>PDF</dt>',
'<dd>Abre el documento en una vista previa de PDF</dd>',
'<dt>RTF</dt>',
'<dd>Abre el documento en Microsoft Word</dd>',
'<dt>XLS</dt>',
'<dd>Abre el documento en Microsoft Excel</dd>',
'<dt>HTM</dt>',
'<dd>Descarga el documento como un archivo HTML</dd>',
'<dt>XML</dt>',
'<dd>Descarga el documento como un archivo XML</dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100329556082304813)
,p_name=>'PE.PROPERTY.PRINT_OUTPUT_FORMAT_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento de Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100328404295304812)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la alineaci\00F3n para el pie de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100414128551304878)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'es'
,p_message_text=>'centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100414003106304878)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'es'
,p_message_text=>'inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100414205339304878)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'es'
,p_message_text=>'fin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100328354509304812)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_ALIGNMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Alineaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100413973320304878)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100328270220304812)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para mostrar este componente.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100328149570304812)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100327676282304812)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un tipo de fuente para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100413609139304877)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'es'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100413440369304877)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'es'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100413544821304877)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'es'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100327527184304812)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_FAMILY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100328082152304812)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un tama\00F1o de fuente para este componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100327952055304812)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Fuente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100327872318304812)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un grosor de fuente para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100413851757304878)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'es'
,p_message_text=>'Negrita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100413773159304878)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100327771943304812)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_FONT_WEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Grosor de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100328629661304813)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que aparecer\00E1 en la secci\00F3n de pie de p\00E1gina del documento. Para mostrar los valores de los elementos de aplicaci\00F3n o p\00E1gina, utilice la sintaxis <code>&amp;ITEM_NAME.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100328561882304812)
,p_name=>'PE.PROPERTY.PRINT_PAGE_FOOTER_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100325274718304810)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione una alineaci\00F3n para la cabecera de la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100412011099304876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.CENTER.D'
,p_message_language=>'es'
,p_message_text=>'centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100411980852304876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.LEFT.D'
,p_message_language=>'es'
,p_message_text=>'inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100412131554304876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.LOV.RIGHT.D'
,p_message_language=>'es'
,p_message_text=>'final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100325197425304810)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_ALIGNMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Alineaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100411873333304876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Negro&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Rojo&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Amarillo&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lima&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Verde&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Agua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Azul&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Azul Marino&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;Blanco&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100325017636304810)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el color que se utiliza para mostrar este componente.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||'n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.',
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet ''C\00F3digos de colores HTML'' para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100324999717304810)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_COLOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Color de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100324456024304809)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un tipo de fuente para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100411561173304876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.COURIER.D'
,p_message_language=>'es'
,p_message_text=>'Courier'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100411383870304876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.HELVETICA.D'
,p_message_language=>'es'
,p_message_text=>'Helvetica'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100411471241304876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.LOV.TIMES.D'
,p_message_language=>'es'
,p_message_text=>'Times'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100324372683304809)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_FAMILY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100324814053304810)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un tama\00F1o de fuente para este componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100324740298304810)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de Fuente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100324627760304810)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un grosor de fuente para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100411777045304876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.BOLD.D'
,p_message_language=>'es'
,p_message_text=>'Negrita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100411636659304876)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.LOV.NORMAL.D'
,p_message_language=>'es'
,p_message_text=>'Normal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100324598134304810)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_FONT_WEIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Grosor de Fuente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100325484540304810)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que aparecer\00E1 en la secci\00F3n de cabecera del documento. Para mostrar los valores de los elementos de aplicaci\00F3n o p\00E1gina, utilice la sintaxis <code>&amp;ITEM_NAME.</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100325395753304810)
,p_name=>'PE.PROPERTY.PRINT_PAGE_HEADER_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Texto de cabecera de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100323028445304808)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tama\00F1o de p\00E1gina del informe. Para introducir un ancho y altura de p\00E1gina personalizados, seleccione <strong>Personalizar</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100410422181304875)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'es'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100410337779304875)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'es'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100410558066304875)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100410121457304875)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'es'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100410004913304875)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'es'
,p_message_text=>'Carta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100410246211304875)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'es'
,p_message_text=>'Tabloide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100322946832304808)
,p_name=>'PE.PROPERTY.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100323438182304809)
,p_name=>'PE.PROPERTY.PRINT_UNITS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione las unidades que se utilizar\00E1n para especificar el ancho y la altura de la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100411090726304876)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.CENTIMETERS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cent\00EDmetros')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100410896330304876)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.INCHES.D'
,p_message_language=>'es'
,p_message_text=>'Pulgadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100410908518304876)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.MILLIMETERS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Mil\00EDmetros')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100411170287304876)
,p_name=>'PE.PROPERTY.PRINT_UNITS.LOV.POINTS.D'
,p_message_language=>'es'
,p_message_text=>'Puntos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100323321119304809)
,p_name=>'PE.PROPERTY.PRINT_UNITS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Unidad Medida'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100322830597304808)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la disposici\00F3n del contenido en el documento de impresi\00F3n. Content-disposition es una extensi\00F3n del protocolo MIME que indica al explorador c\00F3mo se debe mostrar el documento. Si selecciona <b>Adjunto</b>, el explorador guarda el archivo en')
||unistr(' el disco en lugar de mostrarlo en l\00EDnea.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100409820516304875)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.ATTACHMENT.D'
,p_message_language=>'es'
,p_message_text=>'Adjunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100409977773304875)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.LOV.INLINE.D'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100322702351304808)
,p_name=>'PE.PROPERTY.PRINT_VIEW_FILE_AS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ver Archivo como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100323626357304809)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el ancho de esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100323579125304809)
,p_name=>'PE.PROPERTY.PRINT_WIDTH.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ancho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99683268447304280)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la regi\00F3n de pantalla asociada de este elemento de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99683124919304280)
,p_name=>'PE.PROPERTY.PROCESS_DATA_SOURCE_REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n de Pantalla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100200596594304716)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione d\00F3nde se muestra el mensaje de error de este proceso cuando el proceso no termina correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100390409165304858)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.D'
,p_message_language=>'es'
,p_message_text=>unistr('En L\00EDnea en Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100390553044304858)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.INLINE_IN_NOTIFICATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El mensaje de error del proceso aparece en el \00E1rea "Notificaci\00F3n" (definida como parte de la plantilla de p\00E1gina)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100390618534304858)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.D'
,p_message_language=>'es'
,p_message_text=>unistr('En P\00E1gina de Error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100390779113304858)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.LOV.ON_ERROR_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El mensaje de error del proceso aparece en la p\00E1gina de errores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100200424849304716)
,p_name=>'PE.PROPERTY.PROCESS_ERROR_DISPLAY_LOCATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ubicaci\00F3n de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99864442119304418)
,p_name=>'PE.PROPERTY.PROCESS_POINT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el punto de presentaci\00F3n de p\00E1gina o procesamiento en el que se ejecuta este proceso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100376014327304847)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Regiones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100667901330305066)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_BOX_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta despu\00E9s de presentar las regiones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100376291041304848)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100668193741305066)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_FOOTER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta despu\00E9s de presentar la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100375899459304847)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Cabecera')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100667706868305066)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_HEADER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta despu\00E9s de presentar la cabecera.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100376434484304848)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.D'
,p_message_language=>'es'
,p_message_text=>'Procesamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100668303606305066)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.AFTER_SUBMIT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento: se ejecuta despu\00E9s de realizar los c\00E1lculos y las validaciones, durante la realizaci\00F3n del procesamiento de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100375903867304847)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.D'
,p_message_language=>'es'
,p_message_text=>'Antes de Regiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100667845869305066)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_BOX_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta antes de presentar las regiones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100376140491304847)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Antes de Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100668042238305066)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_FOOTER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta antes de presentar el pie de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100375791048304847)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.D'
,p_message_language=>'es'
,p_message_text=>'Antes de Cabecera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100667658385305066)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.BEFORE_HEADER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n: se ejecuta antes de presentar la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100376555206304848)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.D'
,p_message_language=>'es'
,p_message_text=>unistr('Devoluci\00F3n de Llamada de Ajax')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100668445103305066)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_DEMAND.HELP'
,p_message_language=>'es'
,p_message_text=>'Se ejecuta cuando la API de JavaScript apex.server lo llama.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100375613911304847)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100667571666305066)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_NEW_INSTANCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Se ejecuta cuando se genera una nueva sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100376353949304848)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100668292863305066)
,p_name=>'PE.PROPERTY.PROCESS_POINT.LOV.ON_SUBMIT_BEFORE_COMPUTATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento: se ejecuta despu\00E9s del env\00EDo de la p\00E1gina, pero antes de la realizaci\00F3n de los c\00E1lculos, las validaciones y los procesos de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99864369346304418)
,p_name=>'PE.PROPERTY.PROCESS_POINT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Punto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100200707746304716)
,p_name=>'PE.PROPERTY.PROCESS_REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la regi\00F3n que se va a asociar a este proceso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100200637832304716)
,p_name=>'PE.PROPERTY.PROCESS_REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n Editable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100079057631304585)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un esquema de autorizaci\00F3n para restringir los usuarios que puedan guardar las definiciones de informes p\00FAblicos.'),
unistr('		Para permitir que un usuario final guarde un informe p\00FAblico, este esquema de autorizaci\00F3n se debe evaluar en TRUE para dicho usuario.'),
unistr('		<p>Nota: Si no se proporciona ning\00FAn esquema de autorizaci\00F3n, cualquier usuario puede guardar los informes p\00FAblicos.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100078906031304585)
,p_name=>'PE.PROPERTY.PUBLIC_REPORT_AUTH_SCHEME.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Guardar Informe P\00FAblico: Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100449252559304903)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('$$$ DJP est\00E1 actualmente oculto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100239996892304746)
,p_name=>'PE.PROPERTY.QUERY_COLUMN_ID.PROMPT'
,p_message_language=>'es'
,p_message_text=>'ID de Consulta de Columna de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99871535926304424)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la etiqueta para la primera <strong>lista de valores</strong>. Esta etiqueta es el texto que ver\00E1 el usuario final de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99871416627304424)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_01.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99871922049304424)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la etiqueta para la segunda <strong>lista de valores</strong>. Esta etiqueta es el texto que ver\00E1 el usuario final de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99871870865304424)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_02.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99872380679304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la etiqueta para la tercera <strong>lista de valores</strong>. Esta etiqueta es el texto que ver\00E1 el usuario final de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99872263788304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_03.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99872717989304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la etiqueta para la cuarta <strong>lista de valores</strong>. Esta etiqueta es el texto que ver\00E1 el usuario final de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99872645506304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_04.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99873100491304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la etiqueta para la quinta <strong>lista de valores</strong>. Esta etiqueta es el texto que ver\00E1 el usuario final de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99873053005304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_05.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99873557437304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la etiqueta para la sexta <strong>lista de valores</strong>. Esta etiqueta es el texto que ver\00E1 el usuario final de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99873422516304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_06.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99873927306304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la etiqueta para la s\00E9ptima <strong>lista de valores</strong>. Esta etiqueta es el texto que ver\00E1 el usuario final de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99873823488304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_07.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99874395272304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la etiqueta para la octava <strong>lista de valores</strong>. Esta etiqueta es el texto que ver\00E1 el usuario final de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99874246605304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_08.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99874729484304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la etiqueta para la novena <strong>lista de valores</strong>. Esta etiqueta es el texto que ver\00E1 el usuario final de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99874621065304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_09.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta 9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99875129797304427)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la etiqueta para la d\00E9cima <strong>lista de valores</strong>. Esta etiqueta es el texto que ver\00E1 el usuario final de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99875002640304427)
,p_name=>'PE.PROPERTY.QUICK_PICK_LABEL_10.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta 10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99871304175304424)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca los atributos HTML que est\00E1n asociados a la visualizaci\00F3n de cada enlace de <strong>lista de valores</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99871225805304424)
,p_name=>'PE.PROPERTY.QUICK_PICK_LINK_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atributos de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99871717407304424)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el valor asociado a la primera <strong>lista de valores</strong>. Este valor sustituye al valor de elemento existente cuando el usuario hace clic en esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99871638801304424)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_01.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor 1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99872159473304424)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el valor asociado a la segunda <strong>lista de valores</strong>. Este valor sustituye al valor de elemento existente cuando el usuario hace clic en esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99872082536304424)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_02.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor 2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99872520396304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el valor asociado a la tercera <strong>lista de valores</strong>. Este valor sustituye al valor de elemento existente cuando el usuario hace clic en esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99872493196304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_03.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor 3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99872947328304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el valor asociado a la cuarta <strong>lista de valores</strong>. Este valor sustituye al valor de elemento existente cuando el usuario hace clic en esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99872892155304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_04.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor 4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99873305329304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el valor asociado a la quinta <strong>lista de valores</strong>. Este valor sustituye al valor de elemento existente cuando el usuario hace clic en esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99873207110304425)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_05.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor 5'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99873734627304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el valor asociado a la sexta <strong>lista de valores</strong>. Este valor sustituye al valor de elemento existente cuando el usuario hace clic en esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99873623138304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_06.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor 6'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99874151926304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor asociado a la s\00E9ptima <strong>lista de valores</strong>. Este valor sustituye al valor de elemento existente cuando el usuario hace clic en esta lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99874045245304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_07.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor 7'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99874579753304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el valor asociado a la octava <strong>lista de valores</strong>. Este valor sustituye al valor de elemento existente cuando el usuario hace clic en esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99874408369304426)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_08.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor 8'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99874991769304427)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el valor asociado a la novena <strong>lista de valores</strong>. Este valor sustituye al valor de elemento existente cuando el usuario hace clic en esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99874861477304427)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_09.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor 9'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99875333672304427)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor asociado a la d\00E9cima <strong>lista de valores</strong>. Este valor sustituye al valor de elemento existente cuando el usuario hace clic en esta lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99875242431304427)
,p_name=>'PE.PROPERTY.QUICK_PICK_VALUE_10.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor 10'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100213412892304725)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero de columnas que se va a mostrar para esta columna del grupo de botones de radio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100213349238304725)
,p_name=>'PE.PROPERTY.RADIO_COLUMNS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Columnas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99944527414304482)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una lista separada por puntos y comas de los roles din\00E1micos de Real Application Security, por ejemplo:'),
'<pre>',
'DB_EMP:DB_DEPT',
'</pre></p>',
unistr('<p>&PRODUCT_NAME. activa estos roles en la conexi\00F3n, al transferirlos mediante el par\00E1metro <em>enable_dynamic_roles</em> de <em>sys.dbms_xs_sessions.assign_user</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99944445535304482)
,p_name=>'PE.PROPERTY.RAS_DYNAMIC_ROLES.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Roles Din\00E1micos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99944394020304482)
,p_name=>'PE.PROPERTY.RAS_MODE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione c\00F3mo se utiliza Oracle Real Application Security (RAS) en esta aplicaci\00F3n.</p>'),
unistr('<p>Si activa el modo RAS, aseg\00FArese de que los usuarios tienen privilegios para acceder a los objetos de esquema de la aplicaci\00F3n.'),
unistr('Por ejemplo, con <strong>Usuarios externos</strong>, puede otorgar privilegios de base de datos a un <em>rol de aplicaci\00F3n din\00E1mico de RAS</em> y configurarlo en este esquema de autenticaci\00F3n como un <em>rol din\00E1mico</em>.'),
unistr('Tambi\00E9n puede activar roles mediante una llamada a <em>apex_authorization.enable_dynamic_groups</em>, como en un procedimiento posterior a la autenticaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100377685928304849)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.D'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100668532491305066)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.0.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Real Application Security no se utiliza en la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100377788241304849)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.D'
,p_message_language=>'es'
,p_message_text=>'Usuarios Externos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100668628336305066)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('&PRODUCT_NAME. asume que todos los usuarios son internos y transfiere <em>false</em> mediante el par\00E1metro <em>is_external</em> a <em>sys.dbms_xs_sessions.assign_user</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100377883199304849)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.D'
,p_message_language=>'es'
,p_message_text=>'Usuarios Internos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100668785963305066)
,p_name=>'PE.PROPERTY.RAS_MODE.LOV.2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('&PRODUCT_NAME. transfiere <em>true</em> mediante el par\00E1metro <em>is_external</em> a <em>sys.dbms_xs_sessions.assign_user</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99944265631304482)
,p_name=>'PE.PROPERTY.RAS_MODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Modo RAS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99944759029304482)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca una lista separada por puntos y comas de las plantillas de espacio de nombres de Real Application Security, por ejemplo:',
'<pre>',
'NS1:NS2',
'</pre></p>',
unistr('<p>&PRODUCT_NAME. activa estos espacios de nombres en la conexi\00F3n, transfiri\00E9ndolos mediante el par\00E1metro <em>namespaces</em> de <em>sys.dbms_xs_sessions.assign_user</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99944684891304482)
,p_name=>'PE.PROPERTY.RAS_NAMESPACES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Espacios de Nombres'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100593579124305010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para evaluar la expresi\00F3n introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100593927548305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100593810287305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100593734256305010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100594029359305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100593687761305010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100593448853305010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_EXPRESSION_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100595591139305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100595800093305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100595738289305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100595642805305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100595980754305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100595478621305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99881727298304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina utilizado en esta condici\00F3n. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99881646908304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM1.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99883161974304434)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina utilizado en esta condici\00F3n. Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99883070242304434)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_ITEM2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100595178968305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Java para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100595017062305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100596724919305013)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Java que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100596609754305013)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100594930889305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100594822192305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n JavaScript para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100594738599305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100596519253305013)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 );',
'</pre></dd>',
'</dl>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100596416420305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n JavaScript que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100596388878305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99881922587304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de valores separados por dos puntos(:) para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99881810338304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_LIST.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99882326438304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero de p\00E1gina para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99882207771304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99882502828304434)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de n\00FAmeros de p\00E1gina separados por comas para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99882497887304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PAGES.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100594646616305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100594587995305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n PL/SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100594475448305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100596205126305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100596154699305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n PL/SQL que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100596073871305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99882148661304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una preferencia de usuario que se compare con el valor especificado para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99882099132304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PREFERENCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Preferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100595354255305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Python para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100595252958305012)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100596912388305013)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Python que devuelva un valor booleano para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100596826602305013)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100594397748305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Para volver correctamente cuando el empleado es un gestor y su departamento se encuentra en Chicago:</dt>',
'<dd><pre>',
':P2_JOB = ''MANAGER'' and',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100594287077305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100594190565305011)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100743834376305126)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para volver correctamente porque una o m\00E1s filas existen al comprobar si el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Para volver correctamente porque no existen filas al comprobar si el empleado est\00E1 en el departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99881358723304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una consulta SQL para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99881250349304432)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_SQL_STATEMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99882758331304434)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor de texto para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99882639758304434)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99883387823304434)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor, incluidas las cadenas de sustituci\00F3n <code>&ITEM.</code>, para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99883291132304434)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TEXT2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100092229157304595)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un tipo de condici\00F3n que se debe cumplir para presentar este componente como de solo lectura.'),
unistr('Si no se selecciona una condici\00F3n, el elemento se presentar\00E1 de forma normal.'),
unistr('Un elemento de solo lectura se presenta con la misma configuraci\00F3n que un elemento de solo visualizaci\00F3n.</p>'),
unistr('<p>Nota: defina el tipo de condici\00F3n en <strong>Nunca</strong> para presentar siempre el elemento como un campo introducible.'),
unistr('Este valor sobrescribe cualquier valor de condici\00F3n de solo lectura en el nivel de p\00E1gina o regi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99496263782304138)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un tipo de condici\00F3n que se debe cumplir para presentar este componente como de solo lectura.'),
unistr('Si no se selecciona una condici\00F3n, el elemento se presentar\00E1 de forma normal.'),
unistr('Un elemento de solo lectura se presenta con la misma configuraci\00F3n que un elemento de solo visualizaci\00F3n.</p>'),
unistr('<p>Nota: defina el tipo de condici\00F3n en <strong>Nunca</strong> para presentar siempre el elemento como un campo introducible.'),
unistr('Este valor sobrescribe cualquier valor de condici\00F3n de solo lectura en el nivel de p\00E1gina o regi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99947188901304484)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el tipo de condici\00F3n que se debe cumplir para que esta regi\00F3n presente los elementos de p\00E1gina como de solo lectura.'),
unistr('Si no se selecciona ninguna condici\00F3n, los elementos de p\00E1gina se presentar\00E1n normalmente.</p>'),
unistr('<p>Nota: Si desea que un elemento de p\00E1gina de esta regi\00F3n (por ejemplo, un campo de b\00FAsqueda) se presente siempre como un elemento de p\00E1gina introducible, independientemente de c\00F3mo se eval\00FAe esta condici\00F3n, debe definir la condici\00F3n de solo lectura')
||unistr(' de ese elemento de p\00E1gina en "Nunca" para sobrescribir el valor de la regi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99867075758304420)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione un tipo de condici\00F3n que se debe cumplir para que esta p\00E1gina presente los elementos de p\00E1gina como solo lectura. Si no selecciona ninguna condici\00F3n, los elementos de p\00E1gina se presentar\00E1n de la forma habitual.'),
unistr('La condici\00F3n de solo lectura se eval\00FAa despu\00E9s de ejecutar los procesos con un punto de procesamiento <em>Antes de cabecera</em>.</p>'),
unistr('<p>Nota: Si desea que algunos elementos de p\00E1gina (por ejemplo, un campo de b\00FAsqueda) o todos los elementos de p\00E1gina de una regi\00F3n espec\00EDfica se presenten siempre como elementos de p\00E1gina introducibles, independientemente de c\00F3mo se eval\00FAa esta cond')
||unistr('ici\00F3n, debe definir la condici\00F3n de solo lectura de esos elementos de p\00E1gina/regiones en <strong>Nunca</strong> para sobrescribir el valor principal.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100435990253304893)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.D'
,p_message_language=>'es'
,p_message_text=>'Siempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100575467753304997)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ALWAYS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El componente siempre se presentar\00E1 como de solo lectura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100434557127304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es Microsoft Internet Explorer 7.0 o superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100434655543304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_MSIE_OR_NSCP.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es un explorador compatible con XHTML/CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100434445115304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_NSCP.D'
,p_message_language=>'es'
,p_message_text=>'El explorador del cliente es Mozilla, Netscape 6.x/7x o superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100434719930304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.BROWSER_IS_OTHER.D'
,p_message_language=>'es'
,p_message_text=>unistr('El explorador del cliente son otros exploradores (o versi\00F3n anterior)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100433131225304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto est\00E1 incluido en el elemento')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100435158167304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.D'
,p_message_language=>'es'
,p_message_text=>'Idioma Actual = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100579032879305000)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_EQ_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 ejecutando la aplicaci\00F3n en el idioma que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100434889958304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.D'
,p_message_language=>'es'
,p_message_text=>unistr('El idioma actual est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100579207275305000)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_IN_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 ejecutando la aplicaci\00F3n en uno de los idiomas que se introducen en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100435055912304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.D'
,p_message_language=>'es'
,p_message_text=>'Idioma Actual != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100579159294305000)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_EQ_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 ejecutando la aplicaci\00F3n en el idioma que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100434965235304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.D'
,p_message_language=>'es'
,p_message_text=>unistr('El idioma actual no est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100579344927305000)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_LANG_NOT_IN_COND1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 ejecutando actualmente la aplicaci\00F3n en uno de los idiomas que se introducen en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100432332806304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual = P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100577879349304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_EQUALS_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual es igual que el valor que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100432504670304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en una lista delimitada por comas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100578062960304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en la lista delimitada por comas que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100432487972304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual != P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100577932794304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual no es igual que el valor que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100432600758304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en una lista no delimitada por comas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100578108118304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.CURRENT_PAGE_NOT_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual no est\00E1 en la lista delimitada por comas que se introduce en <em>P\00E1gina</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100435249047304893)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: DAD_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100435344632304893)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DAD_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: DAD_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100434035966304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Errores de Validaci\00F3n en L\00EDnea Mostrados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100578863893304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('En la p\00E1gina se muestra un error de validaci\00F3n en l\00EDnea despu\00E9s de una ejecuci\00F3n de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100433414825304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_EQUAL_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Texto = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100433236181304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_IN_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100433314201304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISPLAY_COND_NOT_IN_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>unistr('El texto no est\00E1 incluido en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100433558963304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.DISP_COND_NOT_EQUAL_COND_TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Texto != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100430073816304889)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Filas Devueltas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100575511499304997)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta SQL devuelve una o m\00E1s filas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100593243019305010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100593362921305010)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La expresi\00F3n se eval\00FAa en TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100430280148304889)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100575746588304997)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El cuerpo de la funci\00F3n devuelve TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100435640135304893)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: HTTP_HOST = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100435740583304893)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.HTTP_HOST_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: HTTP_HOST != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100433713568304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina/Regi\00F3n NO Es de S\00F3lo Lectura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100578508414304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_NOT_READ_ONLY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La regi\00F3n principal o de p\00E1gina, si son las adecuadas, se muestran con normalidad.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100433670967304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina/Regi\00F3n Es de S\00F3lo Lectura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100578483134304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.IS_READ_ONLY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Ya se trate de una regi\00F3n principal o de p\00E1gina, si son las adecuadas, la condici\00F3n "Solo Lectura" se eval\00FAa en TRUE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100431535850304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'es'
,p_message_text=>'El elemento no contiene espacios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100577026913304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>elemento</em> seleccionado no tiene espacios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100431854804304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es alfanum\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100577378035304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es alfanum\00E9rico, es decir, contiene solo letras y n\00FAmeros y ning\00FAn car\00E1cter especial.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100431033407304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es no nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100576511875304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100431798950304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es no num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100577202865304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_NUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no es num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100431202180304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento NO es cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100576764740304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NOT_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100430911317304889)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.D'
,p_message_language=>'es'
,p_message_text=>'El Elemento es NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100576424431304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100431371612304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es nulo o cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100576863363304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NULL_OR_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado est\00E1 vac\00EDo o es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100431638292304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100577169168304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100431115069304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100576654741304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_IS_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100431417966304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es no nulo y no cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100576961338304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 vac\00EDo y no es el n\00FAmero cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100434245571304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MAX_ROWS_LT_ROWS_FETCHED.D'
,p_message_language=>'es'
,p_message_text=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Adelante)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100434331017304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.MIN_ROW_GT_THAN_ONE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Informes SQL (Aceptar para mostrar el bot\00F3n Atr\00E1s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100435838416304893)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.D'
,p_message_language=>'es'
,p_message_text=>'Nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100579448230305000)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NEVER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El componente se presenta con normalidad, independientemente de la condici\00F3n de solo lectura de los componentes principales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100434156353304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.D'
,p_message_language=>'es'
,p_message_text=>unistr('Errores de Validaci\00F3n en L\00EDnea No Mostrados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100578907536304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_DISPLAYING_INLINE_VALIDATION_ERRORS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El error de validaci\00F3n en l\00EDnea no se muestra en la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100430182023304889)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Ninguna Fila Devuelta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100575651436304997)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>'La consulta SQL no devuelve ninguna fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100432927999304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina actual est\00E1 en modo Versi\00F3n para Impresora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100578287275304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final ha cambiado la p\00E1gina actual al modo "Versi\00F3n para Impresora".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100433052386304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual no en modo Versi\00F3n para Impresora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100578322769304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no ha cambiado la p\00E1gina actual al modo "Versi\00F3n para Impresora".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100430361069304889)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'Solicitud = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100575819001304997)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_EQUALS_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina es igual que el texto que se introduce en el atributo <em>Valor</em>.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100430543689304889)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud est\00E1 incluida en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100576097481304997)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina se incluye en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100430476235304889)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'Solicitud != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100575992681304997)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_EQUAL_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina no es igual que el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100430628632304889)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud no est\00E1 incluida en el valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100576119898304997)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.REQUEST_NOT_IN_CONDITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La solicitud de p\00E1gina no se incluye en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100435464834304893)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: SERVER_NAME = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100435578240304893)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.SERVER_NAME_NOT_EQ_CONDITION.D'
,p_message_language=>'es'
,p_message_text=>'CGI_ENV: SERVER_NAME != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100433816463304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.D'
,p_message_language=>'es'
,p_message_text=>unistr('Usuario Autenticado  (no p\00FAblico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100578640757304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_NOT_PUBLIC_USER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final est\00E1 conectado a la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100433979042304892)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.D'
,p_message_language=>'es'
,p_message_text=>unistr('El Usuario es el Usuario P\00FAblico (el usuario no se ha autenticado)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100578747640304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_IS_PUBLIC_USER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario final no est\00E1 conectado a la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100432113363304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia del Usuario = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100577629984304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor de la <em>preferencia</em> introducida es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100432273885304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia del Usuario != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100577725873304999)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.USER_PREF_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor de la <em>preferencia</em> introducida no es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100431957512304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento est\00E1 en una lista delimitada por dos puntos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100577412721304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado est\00E1 totalmente incluido en el texto que se introduce en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100432064428304890)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento est\00E1 en una lista no delimitada por dos puntos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100577544331304998)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El valor del <em>elemento</em> seleccionado no est\00E1 totalmente incluido en el texto introducido en el atributo <em>Valor</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100430741515304889)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Elemento = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100576286144304997)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>elemento</em> seleccionado es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100430831795304889)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.D'
,p_message_language=>'es'
,p_message_text=>'Elemento != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100576328836304997)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.VAL_OF_ITEM_IN_COND_NOT_EQ_COND2.HELP'
,p_message_language=>'es'
,p_message_text=>'El valor del <em>elemento</em> seleccionado no es igual que el texto que se introduce en el atributo <em>Valor</em>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100432829848304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_NOT_SUBMITTED.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual != P\00E1gina Ejecutada (enviada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100432720795304891)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.LOV.WHEN_THIS_PAGE_SUBMITTED.D'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Actual = P\00E1gina Ejecutada (enviada)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99866913792304420)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99881598478304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor que se va a comparar con la condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99881408879304433)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE1.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99882957687304434)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor, incluidas las cadenas de sustituci\00F3n <code>&ITEM.</code>, para esta condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99882824520304434)
,p_name=>'PE.PROPERTY.READ_ONLY_CONDITION_VALUE2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100373126845304845)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>'<pre>bgcolor="#FF0000"</pre>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99875535775304427)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca los atributos incluidos en la etiqueta de celda de la tabla HTML del elemento, <code>&lt;td&gt;</code>, cuando se muestra en modo de solo lectura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99875416377304427)
,p_name=>'PE.PROPERTY.READ_ONLY_HTML_ATTRIBUTES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Atributos HTML de Solo Lectura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100160172166304686)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el intervalo en segundos entre las actualizaciones de los gr\00E1ficos. Se desaconseja utilizar intervalos de actualizaciones muy cortos porque pueden producir graves problemas de rendimiento de la base de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100160059647304685)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Intervalo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100160296396304686)
,p_name=>'PE.PROPERTY.REFRESH_INTERVAL.UNIT'
,p_message_language=>'es'
,p_message_text=>'segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99887809793304438)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la regi\00F3n en la que se mostrar\00E1 el bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99905189356304452)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.BUTTON.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99496106835304138)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la regi\00F3n en la que se mostrar\00E1 el elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99905017123304452)
,p_name=>'PE.PROPERTY.REGION.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn Principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99880773323304432)
,p_name=>'PE.PROPERTY.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la regi\00F3n a la que se asocia este componente. Si se muestra el componente, aparece en la regi\00F3n especificada y es relativo a otros componentes de esta regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99880636574304432)
,p_name=>'PE.PROPERTY.REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99945929335304483)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique <strong>Activado</strong> si desea que esta regi\00F3n se incluya en el selector de visualizaci\00F3n de regi\00F3n.'),
unistr('Este atributo solo se utiliza si se define un tipo de regi\00F3n del <em>selector de visualizaci\00F3n de regi\00F3n</em> y se puede visualizar en la p\00E1gina.</p>'),
unistr('<p>Si un usuario hace clic en un nombre de regi\00F3n, incluido en el selector de visualizaci\00F3n de regi\00F3n, solo se muestra la regi\00F3n seleccionada y se ocultan el resto de regiones.'),
unistr('La primera entrada en el selector de visualizaci\00F3n de regi\00F3n es <em>Mostrar Todo</em>, que permite al usuario mostrar todas las regiones disponibles en lugar de solo la regi\00F3n seleccionada anteriormente.</p>'),
unistr('<p>Si no se puede mostrar una regi\00F3n, seg\00FAn las condiciones de la regi\00F3n, no se incluir\00E1 en las listas de regiones del selector de visualizaci\00F3n de regi\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99945855049304483)
,p_name=>'PE.PROPERTY.REGION_DISPLAY_SELECTOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99946793258304484)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una funci\00F3n PL/SQL que devuelve una consulta SQL que se utiliza como base para esta regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99946692423304484)
,p_name=>'PE.PROPERTY.REGION_FUNCTION_RETURNING_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99944908055304483)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el contenido u origen de regi\00F3n, seg\00FAn el <em>tipo de regi\00F3n</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99944882119304482)
,p_name=>'PE.PROPERTY.REGION_HTML_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99946194243304483)
,p_name=>'PE.PROPERTY.REGION_IMAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una referencia a una imagen que se muestra en la esquina superior izquierda de la regi\00F3n. No se puede controlar la etiqueta de tabla que se utiliza para mostrar esta imagen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99946098425304483)
,p_name=>'PE.PROPERTY.REGION_IMAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Imagen de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100240178066304746)
,p_name=>'PE.PROPERTY.REGION_PLAIN.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el origen del texto de este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100240062061304746)
,p_name=>'PE.PROPERTY.REGION_PLAIN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99941239343304480)
,p_name=>'PE.PROPERTY.REGION_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el origen SQL para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99941188498304480)
,p_name=>'PE.PROPERTY.REGION_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99945547532304483)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una plantilla de regi\00F3n para definir la apariencia y el dise\00F1o de esta regi\00F3n.</p>'),
unistr('        <p>Las plantillas de regi\00F3n se definen en el tema de la aplicaci\00F3n.'),
unistr('        Al crear una regi\00F3n, la plantilla se define autom\00E1ticamente en la plantilla de regi\00F3n por defecto definida en el tema actual.</p>'),
unistr('        <p>Muchos temas contienen plantillas de regi\00F3n para mostrar informes, pantallas, alertas, botones, contendido reducible (ocultar/mostrar), pantallas de conexi\00F3n, etc.<br>'),
unistr('        El tema universal proporciona las siguientes plantillas de regi\00F3n:'),
'          <dl>',
'            <dt>Alerta</dt>',
'            <dt>En blanco con atributos</dt>',
'            <dt>Contenedor de botones</dt>',
'            <dt>Contenedor de carrusel</dt>',
'            <dt>Reducible</dt>',
'            <dt>Bloque de contenido</dt>',
unistr('            <dt>H\00E9roe</dt>'),
unistr('            <dt>Cuadro de di\00E1logo en l\00EDnea</dt>'),
unistr('            <dt>Ventana emergente en l\00EDnea</dt>'),
'            <dt>Informe interactivo</dt>',
unistr('            <dt>Conexi\00F3n</dt>'),
unistr('            <dt>Est\00E1ndar</dt>'),
'            <dt>Contenedor de separadores</dt>',
unistr('            <dt>Barra de t\00EDtulo</dt>'),
'            <dt>Contenedor de asistente</dt>',
'          </dl>',
unistr('          Consulte tambi\00E9n: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de ejemplo de tema universal</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99945487173304483)
,p_name=>'PE.PROPERTY.REGION_TEMPLATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100057120282304568)
,p_name=>'PE.PROPERTY.REGION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique c\00F3mo se debe representar esta regi\00F3n. Est\00E1n soportados los siguientes tipos de regi\00F3n:</p>'),
'#NATIVE_PLUGINS#',
unistr('<p>En funci\00F3n de la configuraci\00F3n de la aplicaci\00F3n, puede disponer tambi\00E9n aqu\00ED de plugins de tipo de regi\00F3n adicionales.'),
'Se muestran como <em>&lt;Mi Plugin&gt; [Plug-in]</em>.',
unistr('Los siguientes plugins est\00E1n instalados en los componentes compartidos de esta aplicaci\00F3n:</p>'),
'#CUSTOM_PLUGINS#'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99880031279304431)
,p_name=>'PE.PROPERTY.REGION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100319119980304805)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el tipo de igualdad que se va a probar para esta validaci\00F3n. Seg\00FAn la selecci\00F3n, se necesitan uno o m\00E1s atributos adicionales para definir completamente esta validaci\00F3n.</p>'),
unistr('<p>Si la validaci\00F3n aprueba la prueba de igualdad, o se eval\00FAa como TRUE, no se mostrar\00E1 el mensaje de error de validaci\00F3n.'),
unistr('Los mensajes de error de validaci\00F3n se muestran si la validaci\00F3n no supera la prueba de igualdad, se eval\00FAa como FALSE o se devuelve una cadena de texto no vac\00EDa.</p>'),
unistr('<p>Un fallo de validaci\00F3n no para la evaluaci\00F3n de las validaciones posteriores, por lo tanto cada validaci\00F3n posterior puede emitir un mensaje de error de validaci\00F3n adicional. Si desea dejar de ejecutar las validaciones posteriores, debe agregar un')
||unistr('a l\00F3gica adicional en la primera validaci\00F3n fallida, como por ejemplo definir un elemento de p\00E1gina en un valor espec\00EDfico y, a continuaci\00F3n, mejorar la l\00F3gica condicional en las validaciones posteriores seg\00FAn sea necesario. Los procesos y bifurcacio')
||unistr('nes posteriores no se ejecutan si fallan una o m\00E1s validaciones en la evaluaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100419823948304882)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Filas Devueltas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100419924228304882)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si la consulta SQL devuelve una o m\00E1s filas.<br>'),
'Falla si la consulta SQL no devuelve ninguna fila.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100627239352305035)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100627324777305035)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si la expresi\00F3n se eval\00FAa como TRUE.<br>'),
unistr('Falla si la expresi\00F3n se eval\00FAa como FALSE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100420416191304882)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n (devuelve un valor booleano)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100420501417304882)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el cuerpo de la funci\00F3n devuelve un valor TRUE.<br>'),
unistr('Falla si el cuerpo de la funci\00F3n devuelve un valor FALSE.<br>'),
unistr('Nota: El resultado devuelto de la funci\00F3n debe ser un valor booleano.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100420638969304882)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n (devuelve texto de error)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100420771176304882)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el cuerpo de la funci\00F3n devuelve una cadena vac\00EDa.<br>'),
unistr('Falla si el cuerpo de la funci\00F3n devuelve una cadena no vac\00EDa. La cadena devuelta se muestra como un mensaje de error para la validaci\00F3n.<br>'),
unistr('Nota: El resultado devuelto de la funci\00F3n debe ser una cadena de texto.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100421433628304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'es'
,p_message_text=>'La columna no contiene espacios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100421519182304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si el valor de la columna no tiene espacios.<br>',
'Falla si el valor de la columna contiene espacios.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100423487560304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'es'
,p_message_text=>'La columna contiene al menos uno de los caracteres de Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100423549971304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor de la columna incluye al menos un car\00E1cter del texto que ha introducido en el atributo <em>Valor</em>.<br>'),
unistr('Falla si el valor de la columna no incluye ning\00FAn car\00E1cter del texto que ha introducido en el atributo <em>Valor</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100423667616304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'es'
,p_message_text=>'La columna NO contiene ninguno de los caracteres de Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100423729550304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si el valor de la columna no incluye ninguno de los caracteres del texto que ha introducido en el atributo <em>Valor</em>.<br>',
unistr('Falla si el valor de la columna incluye al menos un car\00E1cter del texto que ha introducido en el atributo <em>Valor</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100423294966304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'es'
,p_message_text=>'La columna solo contiene caracteres especificados en Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100423375515304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si el valor de la columna solo contiene caracteres que aparecen en el texto que ha introducido en el atributo <em>Valor</em>.<br>',
unistr('Falla si el valor de la columna contiene cualquier car\00E1cter que no aparezca en el texto que ha introducido en el atributo <em>Valor</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100422462998304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'es'
,p_message_text=>'Columna = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100422595124304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si el valor de la columna es igual que el texto que ha introducido en el atributo <em>Valor</em>.<br>',
'Falla si el valor de la columna no es igual que el texto que ha introducido en el atributo <em>Valor</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100422805180304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'es'
,p_message_text=>unistr('La columna est\00E1 incluida en Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100422933212304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor de la columna est\00E1 totalmente incluido en el texto que ha introducido en el atributo <em>Valor</em>.<br>'),
unistr('Falla si el valor de la columna no est\00E1 totalmente incluido en el texto que ha introducido en el atributo <em>Valor</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100422648755304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'es'
,p_message_text=>'Columna != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100422798810304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si el valor de la columna no es igual que el texto que se introduce en el atributo <em>Valor</em>.<br>',
'Falla si el valor de la columna es igual que el texto que se introduce en el atributo <em>Valor</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100423062110304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'es'
,p_message_text=>unistr('La columna NO est\00E1 incluida en Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100423115954304884)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor de la columna no est\00E1 totalmente incluido en el texto que ha introducido en el atributo <em>Valor</em>.<br>'),
unistr('Falla si el valor de la columna est\00E1 totalmente incluido en el texto que ha introducido en el atributo <em>Valor</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100421677796304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('La columna es alfanum\00E9rica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100421731865304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor de la columna es alfanum\00E9rico, es decir, contiene solo letras y n\00FAmeros y ning\00FAn car\00E1cter especial.<br>'),
'Falla si el valor de la columna incluye caracteres especiales.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100422069771304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'es'
,p_message_text=>unistr('La columna es una fecha v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100422104809304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor de la columna es una fecha v\00E1lida.<br>'),
unistr('Falla si el valor de la columna no es una fecha v\00E1lida.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100421807491304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('La columna es num\00E9rica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100421904361304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor de la columna es num\00E9rico.<br>'),
unistr('Falla si el valor de la columna contiene caracteres no num\00E9ricos, incluidos los espacios, excepto los espacios iniciales.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100422297561304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'es'
,p_message_text=>unistr('La columna es un registro de hora v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100422346531304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor de la columna es un registro de hora v\00E1lido.<br>'),
unistr('Falla si el valor de la columna no es un registro de hora v\00E1lido.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100420824095304882)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'es'
,p_message_text=>'La columna es NO NULA'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100420901146304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor de la columna no est\00E1 vac\00EDo.<br>'),
unistr('Falla si el valor de la columna est\00E1 vac\00EDo.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100421013649304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'La columna es NO NULA o cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100421114814304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor de la columna no est\00E1 vac\00EDo y no es el n\00FAmero cero.<br>'),
unistr('Falla si el valor de la columna est\00E1 vac\00EDo o es el n\00FAmero cero.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100421255146304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'La columna NO es cero'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100421328740304883)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor de la columna no es el n\00FAmero cero.<br>'),
unistr('Falla si el valor de la columna es el n\00FAmero cero.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100420065466304882)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Ninguna Fila Devuelta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100420196347304882)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si la consulta SQL no devuelve ninguna fila.<br>',
unistr('Falla si la consulta SQL devuelve una o m\00E1s filas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100420227940304882)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'es'
,p_message_text=>'Error PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100420309744304882)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el c\00F3digo PL/SQL se ejecuta sin generar un error.<br>'),
unistr('Falla si la expresi\00F3n PL/SQL genera un error cuando se ejecuta.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100423852427304885)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('La columna coincide con la expresi\00F3n regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100423944769304885)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor de la columna coincide con la expresi\00F3n regular que ha introducido en el atributo <em>Valor</em>.'),
unistr('Falla si el valor de la columna no coincide con la expresi\00F3n regular que ha introducido en el atributo <em>Valor</em>.<br>'),
'Nota: las expresiones regulares permiten buscar patrones en los datos de cadena mediante convenciones de sintaxis estandarizadas, en lugar de mediante sencillas comparaciones de caracteres.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100319004693304805)
,p_name=>'PE.PROPERTY.REGION_VALIDATION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100319783043304806)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un nombre de columna sensible a may\00FAsculas/min\00FAsculas para esta validaci\00F3n. Puede escribir el nombre o seleccionarlo de la lista de columnas disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100319673323304806)
,p_name=>'PE.PROPERTY.REGION_VAL_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100629102087305037)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para evaluar la expresi\00F3n introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100629570010305037)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100629418205305037)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100629356419305037)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100629632946305037)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100629206208305037)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100629046282305037)
,p_name=>'PE.PROPERTY.REGION_VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100631128191305038)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100631433522305038)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100631343763305038)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100631224462305038)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100631592960305038)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100631040360305038)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100627519536305035)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100627826731305036)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100627748709305036)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100627697851305036)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100627909885305036)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100627450902305035)
,p_name=>'PE.PROPERTY.REGION_VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100630773823305038)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Java para definir la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100630667324305038)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100632310868305039)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n Java que devuelve un valor BOOLEAN como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100632279056305039)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100628747884305036)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Java que devuelve el texto de mensaje de error como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100628627980305036)
,p_name=>'PE.PROPERTY.REGION_VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java que devuelve texto de error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100630502419305038)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error, cuando el empleado est\00E9 en el departamento 30 o sea un gestor:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100630478787305038)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n JavaScript para definir la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100630374820305037)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100632178943305039)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error, cuando el empleado est\00E9 en el departamento 30:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100632027012305039)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n JavaScript que devuelve un valor BOOLEAN como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100631975138305039)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100628507890305036)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error especificado, cuando el empleado est\00E9 en el departamento 30:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100628416335305036)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n JavaScript que devuelve el texto de mensaje de error como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100628371844305036)
,p_name=>'PE.PROPERTY.REGION_VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript que devuelve texto de error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100743687797305126)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error, cuando el empleado est\00E9 en el departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100319581110304806)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n PL/SQL que genera un error como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100319400031304806)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo PL/SQL que Genera un Error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100630292885305037)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error, cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100630102712305037)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n PL/SQL para definir la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100630026685305037)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100631861916305039)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error, cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100631702569305039)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n PL/SQL que devuelve un valor BOOLEAN como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100631660107305038)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100628206948305036)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error especificado, cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100628190496305036)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n PL/SQL que devuelve el texto de mensaje de error como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100628099225305036)
,p_name=>'PE.PROPERTY.REGION_VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL que Devuelve Texto de Error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100630942277305038)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Python para definir la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100630814626305038)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100632556612305039)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n Python que devuelve un valor BOOLEAN como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100632458122305039)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100628989359305037)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Python que devuelve el texto de mensaje de error como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100628864619305036)
,p_name=>'PE.PROPERTY.REGION_VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python que devuelve texto de error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100320138027304806)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n regular utilizada la que debe coincidir la columna especificada para esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100320010834304806)
,p_name=>'PE.PROPERTY.REGION_VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100629974139305037)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error, cuando el empleado es un gestor o el departamento se encuentra en Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100629867317305037)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n SQL para definir la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100629711670305037)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100743529120305126)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para que <strong>Filas Devueltas</strong> apruebe la validaci\00F3n y no muestre un mensaje de error, cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Para que <strong>Filas no devueltas</strong, apruebe la validaci\00F3n y no muestre un mensaje de error, cuando el empleado est\00E9 en el departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100319374978304806)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una consulta SQL para definir esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100319205151304805)
,p_name=>'PE.PROPERTY.REGION_VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100319903352304806)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor utilizado para comparar con el valor de la columna especificada para esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100319820559304806)
,p_name=>'PE.PROPERTY.REGION_VAL_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100333574462304816)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor por Defecto de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100674147176305071)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.COMPONENT_PROPERTY.PAGE.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Hereda el valor definido en la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100333482060304816)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este atributo para controlar si &PRODUCT_NAME. debe soportar las URL de aplicaci\00F3n que no contienen ID de sesi\00F3n.'),
unistr('Cuando la opci\00F3n para volver a entrar en sesiones est\00E9 activada, &PRODUCT_NAME. intentar\00E1 utilizar la cookie de sesi\00F3n para entrar en una sesi\00F3n existente, cuando una URL no contenga ID de sesi\00F3n.'),
'</p>',
'',
unistr('<p>Un valor de nivel de instancia m\00E1s restrictivo sustituye este valor de nivel de aplicaci\00F3n.'),
'</p>',
unistr('<p><em><strong>Nota:</em></strong> La activaci\00F3n de la opci\00F3n para volver a entrar en sesiones expone la aplicaci\00F3n a posibles fallos de seguridad,'),
unistr('puesto que puede permitir a los atacantes tomar posesi\00F3n de sesiones de usuario final existentes.'),
unistr('Para obtener m\00E1s informaci\00F3n, consulte las secciones sobre <em>volver a entrar en sesiones</em> en la parte de gesti\00F3n de seguridad de la aplicaci\00F3n de App Builder User''s Guide.'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100415056794304878)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100415190534304879)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.N.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Si la URL no contiene ID de sesi\00F3n, &PRODUCT_NAME. crea una nueva sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100415293694304879)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.D'
,p_message_language=>'es'
,p_message_text=>unistr('Activado para Sesiones P\00FAblicas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100415382416304879)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.P.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si la URL direcciona a una p\00E1gina p\00FAblica y no contiene un ID de sesi\00F3n, &PRODUCT_NAME. intenta utilizar la cookie de la sesi\00F3n existente establecida para la aplicaci\00F3n.'),
unistr('En las aplicaciones con p\00E1ginas con acceso tanto p\00FAblico como mediante autenticaci\00F3n, se define un ID de sesi\00F3n despu\00E9s de que el usuario se haya autenticado.'),
unistr('&PRODUCT_NAME. solo entra mediante la cookie cuando la sesi\00F3n a\00FAn no se ha autenticado.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100415478966304879)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>'Activado para Todas las Sesiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100415551581304879)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.LOV.Y.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si la URL no contiene ID de sesi\00F3n, &PRODUCT_NAME. intenta utilizar la cookie de sesi\00F3n existente establecida para la aplicaci\00F3n siempre que se cumpla una de las siguientes condiciones:</p>'),
'<p><ul>',
unistr('  <li>Que la protecci\00F3n de estado de la sesi\00F3n est\00E9 activada en la aplicaci\00F3n y la URL incluya un total de control v\00E1lido.'),
unistr('    La protecci\00F3n m\00E1s restrictiva a nivel de elemento de los marcadores p\00FAblicos debe ser <em>Sin Restricciones</em> o <em>Total de Control Necesario: Nivel de Aplicaci\00F3n</em>.</li>'),
unistr('  <li>Que la URL no contenga carga \00FAtil (un par\00E1metro de solicitud, la cach\00E9 borrada o pares de valor y datos).</li>'),
'</ul></p>',
unistr('<p>Para esta configuraci\00F3n tambi\00E9n se requiere que <em>Incluir en Marcos</em> se defina en <em>Permitir del Mismo Origen</em> o en <em>Denegar</em> en la aplicaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100333382833304816)
,p_name=>'PE.PROPERTY.REJOIN_EXISTING_SESSIONS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Volver a Unir Sesiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100261412774304763)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione cu\00E1ndo se debe volver a cargar despu\00E9s de la ejecuci\00F3n de una p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100261528708304763)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.D'
,p_message_language=>'es'
,p_message_text=>'Siempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100261606622304763)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.A.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Volver a cargar la p\00E1gina siempre para mostrar los errores y el mensaje correcto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100261708811304763)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.D'
,p_message_language=>'es'
,p_message_text=>'Solo Correctos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100261898222304763)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.LOV.S.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar los errores de forma din\00E1mica sin volver a cargar la p\00E1gina, pero volver a cargarla despu\00E9s de un procesamiento correcto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100261323381304763)
,p_name=>'PE.PROPERTY.RELOAD_ON_SUBMIT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Volver a Cargar al Ejecutar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100642873225305047)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100642934503305047)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.JET_CHART_SERIES.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos no est\00E1n en cach\00E9 y se solicitan en cada ocasi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100515565218304952)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100515666704304952)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.MAP_LAYER.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos no est\00E1n en cach\00E9 y se solicitan en cada ocasi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99952926479304489)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99953084129304489)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.COMPONENT_PROPERTY.REGION.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los resultados no se almacenan en cach\00E9. Los datos se recuperan de la base de datos remota para cada solicitud.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99951112370304487)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Selecciona c\00F3mo el motor de &PRODUCT_NAME. puede almacenar datos en cach\00E9 en la base datos local.'),
unistr('        Si se puede utilizar el almacenamiento en cach\00E9, se representar\00E1 el componente seg\00FAn los resultados almacenados en cach\00E9, en lugar de recuperarlos de la base de datos remota.'),
unistr('        Los resultados almacenados en cach\00E9 mejorar\00E1n el rendimiento en gran medida, especialmente si hay latencia entre la base de datos local y la remota.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99951200040304487)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.D'
,p_message_language=>'es'
,p_message_text=>'Para todos los usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99951373567304487)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.ALL_USERS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El resultado se almacena en cach\00E9 y todos los usuarios pueden utilizarlo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99951605007304488)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Por Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99951745122304488)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.SESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El resultado se almacena en cach\00E9 espec\00EDficamente para cada sesi\00F3n de usuario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99951448389304488)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.D'
,p_message_language=>'es'
,p_message_text=>'Por Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99951503838304488)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.LOV.USER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El resultado se almacena en cach\00E9 espec\00EDficamente para cada usuario en diferentes sesiones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99951020238304487)
,p_name=>'PE.PROPERTY.REMOTE_SQL_CACHING.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cach\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99952047834304488)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Los datos caducan 15 minutos despu\00E9s de realizar el almacenamiento en cach\00E9</dt>'),
'  <dd><pre>15</pre></dd>',
'<dt>Los datos caducan a la hora en punto</dt>',
'  <dd><pre>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</pre></dd>',
'<dt>Los datos expiran a medianoche</dt>',
'  <dd><pre>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99951924740304488)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca cu\00E1ndo se deben invalidar los datos almacenados en cach\00E9.'),
'        Proporcione la cantidad de minutos o una cadena de calendario DBMS_SCHEDULER.</p>',
unistr('        <p>Para la cadena de calendario DBMS_SCHEDULER, puede definir que los datos almacenados en cach\00E9 se invaliden a la hora en punto, a medianoche o en cualquier otro punto en el tiempo espec\00EDfico recurrente.'),
unistr('        Consulte la documentaci\00F3n sobre DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING para obtener m\00E1s detalles.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99951874268304488)
,p_name=>'PE.PROPERTY.REMOTE_SQL_INVALIDATE_WHEN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Timeout de Cach\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100189027337304707)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca un alias alfanum\00E9rico para esta regi\00F3n del informe interactivo.'),
unistr('Este debe ser \00FAnico en la aplicaci\00F3n.'),
unistr('Puede utilizar un alias para hacer referencia a una regi\00F3n de informe interactivo en la llamada de API personalizada.'),
unistr('Por ejemplo, puede escribir una funci\00F3n que devuelva <code>INTERACTIVE_REPORT_ID</code> consultando la columna <code>ALIAS</code> en la vista <code>APEX_APPLICATION_PAGE_IR</code>.'),
unistr('Dado que el valor <code>INTERACTIVE_REPORT_ID</code> puede cambiar al exportar o importar la aplicaci\00F3n a una instancia diferente, puede ser preferible hacer referencia a regiones de informe interactivo mediante un alias.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100188938644304707)
,p_name=>'PE.PROPERTY.REPORT_ALIAS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Alias de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100182565884304703)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione las restricciones de fechas de la lista de valores.',
'Para las columnas de fecha, la lista de valores puede mostrar tiempo en el pasado, futuro o ambos en el filtro para la lista desplegable de la columna de informe.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100385708416304855)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.ALL.D'
,p_message_language=>'es'
,p_message_text=>'Todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100385997799304855)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.FUTURE.D'
,p_message_language=>'es'
,p_message_text=>'Futuro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100385869693304855)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.LOV.PAST.D'
,p_message_language=>'es'
,p_message_text=>'Pasado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100182467174304702)
,p_name=>'PE.PROPERTY.REPORT_FILTER_DATE_RANGES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Rangos Fechas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100189214479304708)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione un elemento de p\00E1gina o aplicaci\00F3n cuyo valor almacene el ID de informe guardado.'),
'El informe interactivo utiliza este valor de elemento para enlazar a un informe guardado.',
unistr('Por ejemplo, puede definir la lista de informes guardados con enlaces con un nombre de elemento definido y un ID de informe guardado como valor para enlazar a informes por defecto guardados, informes p\00FAblicos o privados.'),
'Los ID de informe guardados se pueden recuperar de la vista <code>APEX_APPLICATION_PAGE_IR_RPT</code>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100189181019304707)
,p_name=>'PE.PROPERTY.REPORT_ID_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento de Identificador de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100330213173304814)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.CLASSIC_REPORT_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1o de Informe por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100330811682304814)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.COMPONENT_PROPERTY.TABULAR_FORM_PRINT_ATTR.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1o de Informe por Defecto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100329830412304813)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el dise\00F1o de informe que desea utilizar al imprimir el informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100329715667304813)
,p_name=>'PE.PROPERTY.REPORT_LAYOUT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100220122038304730)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione plantillas de informe predefinidas para controlar la visualizaci\00F3n de este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100399367197304864)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.D'
,p_message_language=>'es'
,p_message_text=>unistr('HTML (est\00E1ndar)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100399455813304865)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.1.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Crea una tabla HTML est\00E1ndar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100399502805304865)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.D'
,p_message_language=>'es'
,p_message_text=>'Informe Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100399629806304865)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.2.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra cada columna en una fila separada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100399716800304865)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.D'
,p_message_language=>'es'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100399853989304865)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.21.HELP'
,p_message_language=>'es'
,p_message_text=>'Exporta el informe como un archivo CSV.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100399975834304865)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.D'
,p_message_language=>'es'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100400071606304865)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.LOV.22.HELP'
,p_message_language=>'es'
,p_message_text=>'Exporta el informe como un archivo XML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100220044003304730)
,p_name=>'PE.PROPERTY.REPORT_PREDEFINED_TEMPLATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100222322932304732)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el texto que se muestra de manera adyacente a los valores de suma del informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100222211833304732)
,p_name=>'PE.PROPERTY.REPORT_SUM_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de Suma del Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100215637426304727)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione una plantilla de informe para definir la apariencia y el dise\00F1o de este informe cl\00E1sico.</p>'),
unistr('        <p>Las plantillas de informe se definen en el tema de la aplicaci\00F3n.'),
unistr('        Al crear un informe cl\00E1sico, la plantilla se define autom\00E1ticamente en la plantilla de informe por defecto definida en el tema actual.'),
unistr('        <p>Muchos temas contienen plantillas de informe cl\00E1sico para mostrar datos en una tabla, pares de clave-valor, resultados de b\00FAsqueda, tarjetas, etc.<br>'),
unistr('        Tenga en cuenta que algunas plantillas de informe, como tarjetas y resultados de b\00FAsquedas, "se basan en filas" y se espera que la consulta SQL devuelva un juego determinado de alias de columnas que se sustituir\00E1 en la plantilla.<br>'),
'        El tema universal proporciona las siguientes plantillas de informe:',
'          <dl>',
'            <dt>Alertas</dt>',
unistr('              <dd>Muestra cualquier n\00FAmero de alertas o notificaciones en la p\00E1gina.</dd>'),
'            <dt>Lista de placas</dt>',
'              <dd>Muestra los pares de clave-valor en una interfaz de usuario tipo panel de control.</dd>',
'            <dt>Tarjetas</dt>',
unistr('              <dd>Muestra datos de informe en tarjetas o peque\00F1os bloques y resulta \00FAtil para presentar distinta informaci\00F3n. Las tarjetas se pueden personalizar en gran medida mediante las opciones de plantilla.</dd>'),
'            <dt>Comentarios</dt>',
'              <dd>Muestra los comentarios y otros mensajes.</dd>',
unistr('            <dt>Resultados de b\00FAsqueda</dt>'),
unistr('              <dd>Muestra los resultados de b\00FAsqueda de tipo motor de b\00FAsqueda</dd>'),
unistr('            <dt>Est\00E1ndar</dt>'),
'              <dd>Esta es la plantilla de informe por defecto para mostrar datos en un tabla y se puede personalizar en gran medida mediante las opciones de plantilla.</dd>',
unistr('            <dt>Cronolog\00EDa</dt>'),
unistr('              <dd>Muestra una cronolog\00EDa de acciones. Es adecuada para las p\00E1ginas iniciales, logs de cambios y otras \00E1reas en las que son necesarios los datos de actividad de acciones recientes.</dd>'),
'            <dt>Pares de valor/atributo: Columna</dt>',
'              <dd>Muestra los pares de clave-valor para las consultas basadas en columna. Utiliza la cabecera de columna como la etiqueta de cada elemento.</dd>',
'            <dt>Pares de valor/atributo: Fila</dt>',
'              <dd>Muestra los pares de clave-valor para las consultas basadas en fila. Utiliza la primera columna para las etiquetas y la segunda columna para los valores.</dd>',
'          </dl>',
unistr('          Consulte tambi\00E9n: <a rel="noreferrer" target="_blank" href="https://apex.oracle.com/ut">Aplicaci\00F3n de Ejemplo de Tema Universal</a>'),
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100215522843304727)
,p_name=>'PE.PROPERTY.REPORT_TEMPLATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100077424631304584)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea evitar que la cuadr\00EDcula interactiva muestre los datos, a menos que se defina al menos un filtro en una de las columnas del informe.'),
unistr('		Esta opci\00F3n est\00E1 dise\00F1ada para limitar los datos cargados de un juego de datos muy grande, al restringir las filas devueltas basadas en un filtro.</p>'),
unistr('		<p>Las columnas individuales puede tener activada la opci\00F3n <strong>Filtro de Columna Necesario</strong>, lo que garantiza que sea necesario un filtro para esa columna, mientras que, esta opci\00F3n solo requiere un filtro en alguna de las columnas.</p')
||'>',
unistr('		<p>Nota: Cuando esta opci\00F3n est\00E1 definida y no hay filtros definidos actualmente, aparecer\00E1 un mensaje solicitando a los usuarios que introduzcan un filtro.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100077316364304584)
,p_name=>'PE.PROPERTY.REQUIRES_FILTER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Requiere Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100233599797304740)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.COMPONENT_PROPERTY.PAGE_ITEM.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Se pueden guardar todos los caracteres.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99876330843304428)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione c\00F3mo restringir los caracteres que se pueden guardar en un estado de la sesi\00F3n.'),
unistr('&PRODUCT_NAME. muestra un mensaje de error si un usuario intenta guardar datos que no cumplen con la restricci\00F3n de caracteres seleccionados.</p>'),
unistr('<p>La restricci\00F3n de caracteres refuerza la seguridad de la aplicaci\00F3n y permite medir el recuento de ataques XSS (scripts de sitios).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100374634093304846)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.D'
,p_message_language=>'es'
,p_message_text=>'Lista de bloqueados &<>\"/;,*|=% y --'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100374754745304846)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR.HELP'
,p_message_language=>'es'
,p_message_text=>'Los siguientes caracteres: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, % y "--" (comentario PL/SQL) NO se pueden guardar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100374882477304847)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.D'
,p_message_language=>'es'
,p_message_text=>unistr('Lista de bloqueados &<>\005C"/;,*|=% o -- y nueva l\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100374908782304847)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.NO_SPECIAL_CHAR_NL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los siguientes caracteres: &amp;, &lt;, &gt;, ", /, ;, ",", *, |, =, %, "--" y los caracteres de nueva l\00EDnea NO se pueden guardar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100374221508304846)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.D'
,p_message_language=>'es'
,p_message_text=>'Lista de permitidos para a-Z, 0-9 y espacio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100374387735304846)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.US_ONLY.HELP'
,p_message_language=>'es'
,p_message_text=>'Solo se pueden guardar los caracteres a-z, A-Z, 0-9 y espacio.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100374474942304846)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.D'
,p_message_language=>'es'
,p_message_text=>'Caracteres de comando HTML de la lista de bloqueados (<>")'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100374520105304846)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WEB_SAFE.HELP'
,p_message_language=>'es'
,p_message_text=>'NO se pueden guardar los caracteres HTML reservados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100375038357304847)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.LOV.WORKSPACE_SCHEMA.D'
,p_message_language=>'es'
,p_message_text=>'Esquema de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99876286627304428)
,p_name=>'PE.PROPERTY.RESTRICTED_CHARACTERS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Caracteres Restringidos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100640460047305045)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el formato de entrada para el contenido representado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100640519866305045)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.D'
,p_message_language=>'es'
,p_message_text=>'HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100640658153305045)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.HTML.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El contenido incluye etiquetas HTML y se representar\00E1 sin omitir los caracteres especiales. Aseg\00FArese de que los datos sean seguros y que no contengan datos introducidos por el usuario final para evitar vulnerabilidades de scripts de sitios (XSS).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100640709061305045)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.D'
,p_message_language=>'es'
,p_message_text=>'Markdown'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100640809614305045)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.LOV.MARKDOWN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El contenido incluye etiquetas Markdown que se convertir\00E1n en etiquetas HTML seguras antes de representarse. La conversi\00F3n de las etiquetas Markdown bien conocidas <strong>evitar\00E1</strong> vulnerabilidades de scripts de sitios (XSS).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100640342231305045)
,p_name=>'PE.PROPERTY.RICH_TEXT_FORMAT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100076652484304583)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que almacenar\00E1 el n\00FAmero de versi\00F3n de fila para la tabla que se est\00E1 actualizando. Esta columna se utilizar\00E1 en la comprobaci\00F3n de la actualizaci\00F3n perdida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100076501281304583)
,p_name=>'PE.PROPERTY.ROW_VERSION_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Versi\00F3n de Fila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100200242879304716)
,p_name=>'PE.PROPERTY.RUN_PROCESS.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la frecuencia con la que se ejecuta este proceso.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100390385571304858)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>unistr('Una Vez por Visita de P\00E1gina (valor por defecto)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100390281948304858)
,p_name=>'PE.PROPERTY.RUN_PROCESS.LOV.Y.D'
,p_message_language=>'es'
,p_message_text=>unistr('Una Vez por Sesi\00F3n o al Restablecer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100200122489304715)
,p_name=>'PE.PROPERTY.RUN_PROCESS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ejecutar Proceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100186004372304705)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione un esquema de autorizaci\00F3n para restringir los usuarios que pueden guardar definiciones de informes p\00FAblicos.'),
unistr('Para permitir que un usuario final guarde un informe p\00FAblico, este esquema de autorizaci\00F3n se evaluar en TRUE.'),
unistr('Si no se proporciona ning\00FAn esquema de autorizaci\00F3n, cualquier usuario puede guardar los informes.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100185906530304705)
,p_name=>'PE.PROPERTY.SAVE_PUBLIC_REPORT_AUTHORIZATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Guardar Informe P\00FAblico: Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99958424885304493)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si los valores en el estado de la sesi\00F3n se guardan en la base de datos antes de ejecutar la bifurcaci\00F3n.'),
unistr('Es importante definir este atributo en <strong>Activado</strong> si navega a una aplicaci\00F3n diferente que necesita acceder a los valores del estado de la sesi\00F3n desde esta aplicaci\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99958363899304493)
,p_name=>'PE.PROPERTY.SAVE_STATE_BEFORE_BRANCH.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Guardar Estado Antes de Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99945358140304483)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que se utilizar\00E1 como esquema de an\00E1lisis de sustituci\00F3n. Se utiliza solo para aplicaciones internas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99945252924304483)
,p_name=>'PE.PROPERTY.SCHEMA_OVERRIDE_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de Sustituci\00F3n de Esquema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100565224437304989)
,p_name=>'PE.PROPERTY.SCHEME_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100565169962304989)
,p_name=>'PE.PROPERTY.SCHEME_SQL_STATEMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100564480274304988)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Seleccione c\00F3mo se aplicar\00E1 este esquema de autorizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100564532981304988)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL Exists'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100564620419304988)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La autorizaci\00F3n se aprueba cuando la consulta devuelve un valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100564982353304989)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n PL/SQL que Devuelve Valor Booleano')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100565091003304989)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n PL/SQL que devuelva un valor booleano')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100564748574304989)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL NOT Exists'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100564861636304989)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.LOV.NATIVE_NOT_EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La autorizaci\00F3n se aprueba cuando la consulta no devuelve ning\00FAn valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100564373750304988)
,p_name=>'PE.PROPERTY.SCHEME_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100186201735304705)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto para la etiqueta del bot\00F3n de b\00FAsqueda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100186128370304705)
,p_name=>'PE.PROPERTY.SEARCH_BUTTON_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta del Bot\00F3n de B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100547889508304976)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea que se muestre este componente usando un formato avanzado o de columna mediante expresiones HTML y cadenas de sustituci\00F3n soportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100547740225304976)
,p_name=>'PE.PROPERTY.SECOND_BODY_ADV_FORMATTING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formato Avanzado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100548005668304976)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que se utilizar\00E1 como cuerpo secundario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100547924869304976)
,p_name=>'PE.PROPERTY.SECOND_BODY_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100548518101304976)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100548406304304976)
,p_name=>'PE.PROPERTY.SECOND_BODY_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100548374258304976)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Cambiar los colores del fondo y del texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Utilizar Cabecera 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utilizar una clase din\00E1mica de la consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Las sustituciones <code>&COLUMN_CLASS.</code> y <code>&EMPLOYEE_STATUS.</code> de este ejemplo son columnas seleccionadas en la consulta SQL de informe.</dd>',
'  <dt>Mostrar una imagen y una pista al pasar el mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100548213883304976)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las expresiones HTML que se mostrar\00E1n en esta columna. Utilice la sintaxis <code>&COLUMN.</code> para mostrar valores de columna en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100548140998304976)
,p_name=>'PE.PROPERTY.SECOND_BODY_HTML_EXPR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99944151353304482)
,p_name=>'PE.PROPERTY.SECURE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique <strong>Activado<strong> para que el explorador env\00EDe la cookie de gesti\00F3n de sesi\00F3n solo cuando el protocolo sea HTTPS.'),
unistr('Seleccione <strong>Desactivado<strong> para que el explorador env\00EDe la cookie de gesti\00F3n de sesi\00F3n cuando el protocolo sea HTTP o HTTPS.</p>'),
unistr('<p>Si SSL est\00E1 configurado en el servidor web, debe seleccionar <strong>Activado<strong> para reforzar la seguridad de la aplicaci\00F3n evitando el tr\00E1fico HTTP no cifrado.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99944044808304482)
,p_name=>'PE.PROPERTY.SECURE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Proteger'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100100676726304602)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea que la primera fila se seleccione de forma autom\00E1tica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100100513748304602)
,p_name=>'PE.PROPERTY.SELECT_FIRST_ROW.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Seleccionar la primera fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100240702625304746)
,p_name=>'PE.PROPERTY.SERIES_CHART_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Gr\00E1fico de Serie')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100135299801304667)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el nombre de columna que se utilizar\00E1 para definir la consulta din\00E1mica de varias series.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100135111046304667)
,p_name=>'PE.PROPERTY.SERIES_NAME_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre de la Serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99875763907304427)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un nivel de protecci\00F3n de estado de la sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100373428577304845)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.D'
,p_message_language=>'es'
,p_message_text=>unistr('Total de Control Necesario: Nivel de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100373557244304846)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.B.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento puede definirse transfiri\00E9ndolo en una URL que incluya un total de control espec\00EDfico del espacio de trabajo y de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100374058868304846)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.D'
,p_message_language=>'es'
,p_message_text=>'Restringido: No se puede definir desde el explorador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100374194652304846)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.I.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'El elemento no puede alterarse mediante la URL o POSTDATA.',
unistr('Seleccione esta opci\00F3n para restringir la manera en que se puede definir el valor del elemento para procesos internos, c\00E1lculos, etc.'),
unistr('Este atributo solo se aplica a elementos que no se pueden utilizar como elementos de entrada de datos y siempre se tiene en cuenta, incluso aunque la protecci\00F3n de estado de la sesi\00F3n est\00E9 desactivada.'),
unistr('Utilice este atributo para elementos de aplicaci\00F3n o p\00E1gina con cualquiera de estos tipos de <strong>Mostrar como</strong>:'),
'<ul>',
unistr('  <li>Solo Visualizaci\00F3n (Guardar Estado=No)</li>'),
'  <li>Campo de Texto (Desactivado, no guarda el estado)</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100373272217304845)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'No Restringido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100373371473304845)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.N.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento puede definirse transfiri\00E9ndolo en una URL o en una pantalla. No se necesita total de control en la URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100373683050304846)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.D'
,p_message_language=>'es'
,p_message_text=>'Total de Control Necesario: Nivel de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100373735814304846)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.P.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento puede definirse transfiri\00E9ndolo en una URL que incluya un total de control espec\00EDfico del espacio de trabajo, de la aplicaci\00F3n y del usuario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100373830079304846)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.D'
,p_message_language=>'es'
,p_message_text=>unistr('Total de Control Necesario: Nivel de Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100373998114304846)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.LOV.S.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento puede definirse transfiri\00E9ndolo en una URL que incluya un total de control espec\00EDfico de la sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99875612411304427)
,p_name=>'PE.PROPERTY.SESSION_STATE_PROTECTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Protecci\00F3n de Estado de la Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99897678787304445)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el grupo de filtros al que est\00E1 asociada la casilla de control.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99897537888304445)
,p_name=>'PE.PROPERTY.SFILTER_GROUP.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Grupo de filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100660977049305060)
,p_name=>'PE.PROPERTY.SHORTCUT_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100565396071304989)
,p_name=>'PE.PROPERTY.SHORTCUT_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100661041131305060)
,p_name=>'PE.PROPERTY.SHORTCUT_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100196490830304713)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el men\00FA <em>Acciones</em> se incluye en la barra de b\00FAsqueda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100196376751304713)
,p_name=>'PE.PROPERTY.SHOW_ACTIONS_MENU.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Incluir Men\00FA Acciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100193680265304711)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden o no definir agregados para este informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100193513596304711)
,p_name=>'PE.PROPERTY.SHOW_AGGREGATE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100179308958304700)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si esta columna se debe mostrar por defecto o no en el informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100179276815304700)
,p_name=>'PE.PROPERTY.SHOW_BY_DEFAULT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100193833909304711)
,p_name=>'PE.PROPERTY.SHOW_CHART.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si los usuarios finales pueden definir gr\00E1ficos para este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100193750992304711)
,p_name=>'PE.PROPERTY.SHOW_CHART.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100193446856304711)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden o no definir columnas computacionales para este informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100193330979304711)
,p_name=>'PE.PROPERTY.SHOW_COMPUTATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Calcular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100193036301304710)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden definir o no divisiones de control para este informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100192906315304710)
,p_name=>'PE.PROPERTY.SHOW_CONTROL_BREAK.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Divisi\00F3n de Control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99898079014304446)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si desea que se muestre la etiqueta de faceta junto a sus valores seleccionados en la lista de facetas actuales. Esconda la etiqueta si el valor seleccionado es evidente. Por ejemplo, un estado de orden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99897987157304446)
,p_name=>'PE.PROPERTY.SHOW_CURRENT_FACET_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar etiqueta de faceta actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100196009637304713)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si se va a incluir un selector de fila despegable independiente en la barra de b\00FAsqueda.'),
unistr('No deber\00EDa seleccionar este atributo y <strong>Filas por P\00E1gina</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100195981318304712)
,p_name=>'PE.PROPERTY.SHOW_DISPLAY_ROW_COUNT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Selector de Filas por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100194863301304712)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden descargar el informe en uno de los formatos de descarga especificados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100194707162304712)
,p_name=>'PE.PROPERTY.SHOW_DOWNLOAD.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Descargar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100192206986304710)
,p_name=>'PE.PROPERTY.SHOW_FILTER.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden o no definir filtros en este informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100192143485304710)
,p_name=>'PE.PROPERTY.SHOW_FILTER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100195892906304712)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si el men\00FA desplegable Buscador se incluye al principio del campo de b\00FAsqueda en la barra de b\00FAsqueda.'),
unistr('El men\00FA desplegable Buscador es una lista de columnas que permite a los usuarios limitar su b\00FAsqueda a una columna espec\00EDfica.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100195772061304712)
,p_name=>'PE.PROPERTY.SHOW_FINDER_DROP_DOWN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista Desplegable del Buscador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100194487603304711)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique si los usuarios finales pueden utilizar consultas de flashback para este informe.</p>',
unistr('<p>En las consultas de flashback se utiliza Oracle Flashback Technology y la recuperaci\00F3n hasta un punto en el tiempo de la base de datos para ver datos que exist\00EDan en un punto del tiempo pasado. Los usuarios solo pueden consultar estos datos, no de')
||unistr('shacer ning\00FAn cambio. El punto en el tiempo hasta el que se puede realizar una consulta de flashback lo determina la \00FAltima vez que se cambiaron los archivos redo log en la base de datos de Oracle, ya que esta tecnolog\00EDa utiliza la copia de seguridad')
||' RMAN.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100194345841304711)
,p_name=>'PE.PROPERTY.SHOW_FLASHBACK.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100194276567304711)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden definir desgloses de agrupaciones para este informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100194112039304711)
,p_name=>'PE.PROPERTY.SHOW_GROUP_BY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Agrupar por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100132031351304664)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el nombre de grupo se debe mostrar en la pista presentada en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100131936696304664)
,p_name=>'PE.PROPERTY.SHOW_GROUP_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar Nombre de Grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100195005217304712)
,p_name=>'PE.PROPERTY.SHOW_HELP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si los usuarios finales pueden llamar al cuadro de di\00E1logo modal de la ayuda incorporada para los informes interactivos.</p>'),
unistr('<p>En el cuadro de di\00E1logo de ayuda solo se resumen las opciones que est\00E1n disponibles al usuario actual.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100194925508304712)
,p_name=>'PE.PROPERTY.SHOW_HELP.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ayuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100193277624304711)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si los usuarios finales pueden definir o no resaltados para este informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100193149620304710)
,p_name=>'PE.PROPERTY.SHOW_HIGHLIGHT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Resaltar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100516718928304953)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si esta capa se muestra en la leyenda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100516650426304953)
,p_name=>'PE.PROPERTY.SHOW_IN_LEGEND.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100194060238304711)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si los usuarios finales pueden definir la configuraci\00F3n de suscripci\00F3n para este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100193919194304711)
,p_name=>'PE.PROPERTY.SHOW_NOTIFY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Suscripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100185419530304705)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el texto que desea que aparezca en las columnas nulas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100185310272304705)
,p_name=>'PE.PROPERTY.SHOW_NULL_VALUES_AS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar Valores Nulos como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99494145725304137)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifica si los usuarios finales pueden definir desgloses din\00E1micos para este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99494048533304136)
,p_name=>'PE.PROPERTY.SHOW_PIVOT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Din\00E1mico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99871134364304424)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea que se muestren las listas de valores para este elemento de p\00E1gina.'),
'Las listas de valores permiten que los usuarios puedan seleccionar valores predefinidos con un solo clic, en lugar de tener que introducir texto o seleccionarlo de una lista de opciones disponibles.</p>',
unistr('<p>Debe especificar las listas de valores cuando haya un juego insuficiente y relativamente peque\00F1o de valores de entrada <em>comunes</em>.'),
unistr('Hay un m\00E1ximo de diez listas de valores que pueden definirse para un elemento.'),
unistr('Dichas ayudas de usuario son especialmente \00FAtiles cuando se definen para un elemento que tenga una larga lista de selecci\00F3n de valores disponibles.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99871093949304424)
,p_name=>'PE.PROPERTY.SHOW_QUICK_PICKS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar Listas de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100196625802304713)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si la lista de selecci\00F3n Informes aparece en la barra de b\00FAsqueda.</p>'),
unistr('<p>La lista de selecci\00F3n Informes solo aparece si el usuario puede acceder a un informe, aparte de al informe primario.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100196503194304713)
,p_name=>'PE.PROPERTY.SHOW_REPORTS_SELECT_LIST.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Lista de Selecci\00F3n de Informes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100194607274304712)
,p_name=>'PE.PROPERTY.SHOW_RESET.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si los usuarios finales pueden restablecer sus informes desde el men\00FA Acciones.</p>'),
'<p>Al restablecer el informe, se revierten todas las personalizaciones realizadas por el usuario o especificadas mediante la URL de llamada, y se muestra el informe primario.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100194589279304711)
,p_name=>'PE.PROPERTY.SHOW_RESET.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Restablecer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100192658186304710)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si los usuarios finales pueden o no cambiar el n\00FAmero de filas que se muestran para este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100192551269304710)
,p_name=>'PE.PROPERTY.SHOW_ROWS_PER_PAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Filas por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100196220772304713)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el campo de b\00FAsqueda se incluye en la barra de b\00FAsqueda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100196170857304713)
,p_name=>'PE.PROPERTY.SHOW_SEARCH_TEXTBOX.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Campo de B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100192434168304710)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si los usuarios finales pueden o no utilizar <strong>Seleccionar Columnas</strong> del men\00FA Acciones para cambiar las columnas que se muestran en este informe. Los usuarios pueden seleccionar (o mostrar), anular la selecci\00F3n (u ocultar) y')
||unistr(' volver a ordenar varias columnas con esta opci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100192387494304710)
,p_name=>'PE.PROPERTY.SHOW_SELECT_COLUMNS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100131894010304664)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el nombre de serie se debe mostrar en la pista presentada en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100131737490304664)
,p_name=>'PE.PROPERTY.SHOW_SERIES_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar Nombre de Serie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100192834536304710)
,p_name=>'PE.PROPERTY.SHOW_SORT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si los usuarios finales pueden o no definir columnas de ordenaci\00F3n para este informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100192704738304710)
,p_name=>'PE.PROPERTY.SHOW_SORT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ordenar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99897033562304445)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si desea que se muestre la etiqueta del filtro o solo el valor en el chip de sugerencia. Esconda la etiqueta si el valor sugerido es evidente. Por ejemplo, un estado de orden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99896905007304445)
,p_name=>'PE.PROPERTY.SHOW_SUGGESTIONS_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100078428660304584)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea mostrar una barra de herramientas sobre el informe. La barra de herramientas puede incluir opciones de b\00FAsqueda, tipo de informe, informes guardados, acciones, funcionalidad de restablecimiento y cambio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100078314270304584)
,p_name=>'PE.PROPERTY.SHOW_TOOLBAR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100078292076304584)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea mostrar el recuento de filas total en el pie de p\00E1gina del informe.<p/>'),
'        <p>Nota: Se realiza una consulta adicional para obtener el recuento de filas total, que puede dificultar el rendimiento, especialmente en juegos de datos muy grandes.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100078132399304584)
,p_name=>'PE.PROPERTY.SHOW_TOTAL_ROW_COUNT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar Recuento Total de Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100213695181304725)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Para el tipo de visualizaci\00F3n Casilla de Control Simple, introduzca un valor o dos valores separados por comas.'),
unistr('El primer valor se ejecuta si la casilla de control est\00E1 activada. El segundo valor, si est\00E1 definido, se ejecuta si la casilla de control no est\00E1 activada.'),
'        p_examples           => q''~<dl>',
'<dt>Submit Yes when selected and No when deselected</dt>',
'<dd><pre>',
'Yes,No',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100213557400304725)
,p_name=>'PE.PROPERTY.SIMPLE_CHECKBOX_VALUES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valores de Casilla de Control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100179973177304701)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la etiqueta de columna que desea utilizar en la vista de una sola fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100179896206304700)
,p_name=>'PE.PROPERTY.SINGLE_ROW_VIEW_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100221596297304731)
,p_name=>'PE.PROPERTY.SORT_NULLS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Para columnas de informes que permiten la ordenaci\00F3n de cabeceras de columna, seleccione la forma en que desea ordenar los registros con valores nulos en relaci\00F3n con los registros que no tienen valores nulos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100401148353304866)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.D'
,p_message_language=>'es'
,p_message_text=>'Primero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100401284403304866)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.F.HELP'
,p_message_language=>'es'
,p_message_text=>'Los registros con un valor nulo se muestran antes que cualquier columna con valores no nulos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100401342790304866)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.D'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100401446974304866)
,p_name=>'PE.PROPERTY.SORT_NULLS.LOV.L.HELP'
,p_message_language=>'es'
,p_message_text=>'Los registros con valores no nulos se muestran antes que cualquier columna con un valor nulo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100221408097304731)
,p_name=>'PE.PROPERTY.SORT_NULLS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ordenar Valores Nulos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99494847974304137)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Selecciona la lista de rutas de navegaci\00F3n asociada a esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99494702570304137)
,p_name=>'PE.PROPERTY.SOURCE_BREADCRUMB.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100727388284305114)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca el nombre de columna de base de datos sensible a may\00FAsculas/min\00FAsculas que se usa como origen para esta faceta.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100535770805304967)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.FACET_GROUP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca el nombre de columna de base de datos sensible a may\00FAsculas/min\00FAsculas que se usa como origen para esta faceta.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99899092840304447)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca el nombre de columna de base de datos sensible a may\00FAsculas/min\00FAsculas que se usa como origen para este filtro.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99900132423304447)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.COMPONENT_PROPERTY.SFILTER_GROUP_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Introduzca el nombre de columna de base de datos sensible a may\00FAsculas/min\00FAsculas que se usa como origen para este filtro.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99869964719304423)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de la columna de base de datos sensible a may\00FAsculas/min\00FAsculas utilizada como origen de este valor de elemento.</p>'),
unistr('<p>Esta columna debe existir en la tabla especificada en el proceso de recuperaci\00F3n de fila incorporado definido en esta p\00E1gina.'),
unistr('Se genera un error y la p\00E1gina no se carga si el nombre de la columna de la base de datos no existe en la tabla a la que se hace referencia.'),
unistr('De forma similar, si no hay ning\00FAn proceso de recuperaci\00F3n de fila incorporado definido y hay un elemento con un tipo de origen <strong>Columna de Base de Datos</strong>, se genera un error y la p\00E1gina no se carga al intentar presentar la p\00E1gina.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99869831525304423)
,p_name=>'PE.PROPERTY.SOURCE_DB_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100608333901305021)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para evaluar la expresi\00F3n introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100608751799305022)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100608670819305022)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100608540829305022)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100608824299305022)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100608420762305021)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100608213179305021)
,p_name=>'PE.PROPERTY.SOURCE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100306241009304796)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la regi\00F3n asociada a esta b\00FAsqueda de facetas o regi\00F3n de filtros inteligentes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100306109076304796)
,p_name=>'PE.PROPERTY.SOURCE_FILTERED_REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n filtrada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100610304574305023)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100610631518305023)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100610507193305023)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100610443713305023)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100610749756305023)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100610227722305023)
,p_name=>'PE.PROPERTY.SOURCE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99869779572304423)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina utilizado como origen para este valor de elemento.'),
'Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99869680440304423)
,p_name=>'PE.PROPERTY.SOURCE_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100639155360305044)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el c\00F3digo Java que se debe ejecutar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100639010467305044)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100609980240305023)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Java que produzca un valor utilizado como origen para este valor de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100609888554305022)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100611543833305024)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n Java que devuelva un valor utilizado como origen para este valor de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100611472536305024)
,p_name=>'PE.PROPERTY.SOURCE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100638986326305044)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Incrementa en un 3% el salario de aquellos empleados cualificados para un aumento salarial:</dt>',
'<dd><pre>',
'var rows;',
'',
'function needsSalaryRaise( empno ) {',
unistr('    // marcador de posici\00F3n para alguna l\00F3gica complicada para calcular si el empleado necesita un aumento'),
'    return true;',
'}',
'',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'    if ( needsSalaryRaise( row.EMPNO )) {',
'      apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'    }',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100638872011305044)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el c\00F3digo JavaScript que se debe ejecutar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100638789926305044)
,p_name=>'PE.PROPERTY.SOURCE_JS_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100609776022305022)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100609662321305022)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n JavaScript que produzca un valor utilizado como origen para este valor de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100609569420305022)
,p_name=>'PE.PROPERTY.SOURCE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100611357452305024)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100611220764305023)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n JavaScript que devuelva un valor utilizado como origen para este valor de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100611115561305023)
,p_name=>'PE.PROPERTY.SOURCE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99494639787304137)
,p_name=>'PE.PROPERTY.SOURCE_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>'Selecciona el origen para esta lista.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99494581024304137)
,p_name=>'PE.PROPERTY.SOURCE_LIST.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99952267071304488)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la ubicaci\00F3n de los datos.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99952390233304488)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.D'
,p_message_language=>'es'
,p_message_text=>'Base de Datos Local'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99952401793304488)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.LOCAL.HELP'
,p_message_language=>'es'
,p_message_text=>'Los datos se originan en la base de datos local.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99952558394304488)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.D'
,p_message_language=>'es'
,p_message_text=>'SQL activado para REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99952629241304488)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.REMOTE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos se originan en la base de datos remota, donde se define la conexi\00F3n mediante SQL activado para REST. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100062759806304572)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.D'
,p_message_language=>'es'
,p_message_text=>'Origen de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100669376489305067)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.LOV.WEB_SOURCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos se originan en un servicio web RESTful definido mediante or\00EDgenes de datos de REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99952191236304488)
,p_name=>'PE.PROPERTY.SOURCE_LOCATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ubicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100147911846304676)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de elementos de p\00E1gina separados por comas de la p\00E1gina actual que se van a definir en el estado de sesi\00F3n cuando se leen los datos del gr\00E1fico con una solicitud independiente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100515400016304952)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una lista de elementos de p\00E1gina separados por comas de la p\00E1gina actual que se van a definir en el estado de sesi\00F3n cuando se recuperan los datos del mapa con una solicitud independiente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99945104008304483)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca los elementos de aplicaci\00F3n o p\00E1gina que se van a definir en el estado de la sesi\00F3n cuando se refresque la regi\00F3n con un refrescamiento de p\00E1gina parcial.'),
'Para varios elementos, separe cada nombre de elemento con una coma.',
'Puede escribir el nombre o seleccionarlo de la lista de elementos disponibles.',
unistr('Si selecciona de la lista y ya hay texto introducido, se coloca una coma al final del texto existente y, a continuaci\00F3n, el nombre de elemento devuelto de la lista.</p>'),
unistr('<p>La regi\00F3n se puede refrescar con el refrescamiento de p\00E1gina parcial durante la paginaci\00F3n, si <em>Activar Refrescamiento de P\00E1gina Parcial</em> se define en <b>Activado</b>) o con Acci\00F3n Din\00E1mica, Refrescar.'),
unistr('Estos elementos de p\00E1gina se pueden utilizar en la <em>condici\00F3n where</em> de la consulta SQL de Origen de Regi\00F3n para restringir el resultado de la consulta.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99945063893304483)
,p_name=>'PE.PROPERTY.SOURCE_PAGE_ITEMS_TO_SUBMIT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Elementos de P\00E1gina a Ejecutar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100638625939305044)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Incrementa en un 3% el salario de aquellos empleados cualificados para un aumento salarial:</dt>',
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100638502973305043)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el c\00F3digo PL/SQL que se debe ejecutar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100638452884305043)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100609423523305022)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100609365568305022)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n PL/SQL que produzca un valor utilizado como origen para este valor de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100609229739305022)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100611026137305023)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100610905436305023)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n PL/SQL que devuelva un valor utilizado como origen para este valor de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100610892727305023)
,p_name=>'PE.PROPERTY.SOURCE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100674615139305071)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione c\00F3mo procesar posteriormente los datos de origen de REST recuperados en la base de datos local.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100675179294305071)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100675237122305071)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n PL/SQL, en el que la consulta SQL devuelta transforme los datos recuperados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100674976784305071)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100675058142305071)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.SQL.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca una consulta SQL para transformar los datos recuperados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100674730718305071)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cl\00E1usula Where/Order by')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100674850226305071)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.LOV.WHERE_ORDER_BY_CLAUSE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la cl\00E1usula Where y/o Order by para restringir y ordenar los datos recuperados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100674531560305071)
,p_name=>'PE.PROPERTY.SOURCE_POST_PROCESSING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99870192061304423)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la preferencia de usuario que se utilizar\00E1 como origen para este valor de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99870054092304423)
,p_name=>'PE.PROPERTY.SOURCE_PREFERENCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Preferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100639310399305044)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el c\00F3digo Python que se debe ejecutar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100639285284305044)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_CODE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100610123729305023)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Python que produzca un valor utilizado como origen para este valor de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100610051414305023)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100611749472305024)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n Python que devuelva un valor utilizado como origen para este valor de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100611628263305024)
,p_name=>'PE.PROPERTY.SOURCE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99869382522304422)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la consulta SQL que se ha utilizado como origen para este valor de elemento. Si el sistema devuelve m\00E1s de una fila, se utilizar\00E1 el valor de la primera fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99869252434304422)
,p_name=>'PE.PROPERTY.SOURCE_QUERY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99869523408304422)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la consulta SQL que devuelve una o varias filas que se van a utilizar como origen para este valor de elemento. Si el resultado contiene varias filas, el valor de cada fila se forma en un solo valor delimitado por dos puntos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99869467576304422)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_COLON.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100618713378305029)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100619090518305029)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100618925385305029)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100618815201305029)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100619110334305029)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100618680790305029)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100619977806305030)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Java que devuelva una consulta SQL para la serie de gr\00E1ficos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100619885540305030)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JAVA_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100619703256305030)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Seleccione las columnas EMPNO, ENAME y SAL y filtre todas las filas con SAL en menos de 3000.</dt>',
'<dd><pre>',
'return "select EMPNO, ENAME, SAL from EMP where SAL < 3000";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100619645026305030)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n JavaScript que devuelva una consulta SQL para la serie de gr\00E1ficos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100619592395305029)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_JS_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99950700475304487)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para mostrar primero las nuevas contrataciones y despu\00E9s las contrataciones pendientes. Si las fechas coinciden, ordenarlas por n\00FAmero de departamento.</dt>'),
'<dd><pre>',
'HIREDATE DESC NULLS LAST, DEPTNO',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99950687672304487)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca uno o m\00E1s nombres de columna separados por coma, incluidas las directivas, para definir el orden en el que se recuperan los registros.</p>'),
'        <p>Directivas incluidas:',
'          <ul>',
'            <li>ASC: devuelve la columna en orden ascendente</li>',
'            <li>DESC: devuelve la columna en orden descendente</li>',
'            <li>NULLS FIRST: devuelve la columna sin valores antes de los que tienen valores</li>',
'            <li>NULLS LAST: devuelve la columna con los valores antes de los que no tienen valores</li>',
'          </ul>',
'        </p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99950597534304487)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_ORDER_BY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Ordenar por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99949971312304486)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el esquema propietario de la tabla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99949896750304486)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_OWNER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Propietario de Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100063380014304572)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una funci\00F3n PL/SQL que devuelve una consulta SQL que se utiliza como base para esta regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100063261873304572)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNCTION_BODY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100619475152305029)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Seleccione las columnas EMPNO, ENAME y SAL y filtre todas las filas con SAL en menos de 3000.</dt>',
'<dd><pre>',
'begin',
'    return ''select EMPNO, ENAME, SAL from EMP where SAL < 3000'';',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100619381976305029)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n PL/SQL que devuelva una consulta SQL para la serie de gr\00E1ficos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100619247797305029)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PLSQL_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100620144100305030)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Python que devuelva una consulta SQL para la serie de gr\00E1ficos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100620015729305030)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_PYTHON_FUNC_BODY_SQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99950136205304487)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de vista o tabla sensible a may\00FAsculas/min\00FAsculas. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99950060529304487)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TABLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre de la Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99949547643304486)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione c\00F3mo se consultan los datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100062896362304572)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n que devuelve una consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100062906039304572)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.FUNC_BODY_RETURNING_SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos se recuperan en funci\00F3n de la consulta SQL que se devuelve al ejecutar un cuerpo de la funci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99952758108304489)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99952831498304489)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.SQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos se recuperan en funci\00F3n de una consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99949678848304486)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.D'
,p_message_language=>'es'
,p_message_text=>'Tabla/Vista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99949719018304486)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.LOV.TABLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos se recuperan en funci\00F3n de una tabla o vista.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99949477781304486)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99950472681304487)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Incluir solo a los empleados a cargo de un m\00E1nager o que trabajan como vendedor.</dt>'),
'<dd><pre>',
'( MGR is not null or JOB = ''SALESMAN'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99950353467304487)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una condici\00F3n Where de SQL v\00E1lida utilizada para limitar los registros recuperados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99950230839304487)
,p_name=>'PE.PROPERTY.SOURCE_QUERY_WHERE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cl\00E1usula WHERE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99949388386304486)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el servidor de la base de datos remota.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99949285716304486)
,p_name=>'PE.PROPERTY.SOURCE_REMOTE_DATABASE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Servidor remoto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100637903918305043)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el lenguaje que se va a utilizar para ejecutar el c\00F3digo introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100638269557305043)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100638194861305043)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100638085900305043)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100638389339305043)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100637837013305043)
,p_name=>'PE.PROPERTY.SOURCE_SNIPPET_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100263523179304764)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Para concatenar dos columnas juntas:</dt>',
'<dd><pre>',
'FIRSTNAME || '' '' || LASTNAME',
'</pre></dd>',
unistr('<dt>Incluir una selecci\00F3n interna:</dt>'),
'<dd><pre>',
'(select count(*) from emp e where e.deptno = DEPTNO)',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100087824935304592)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100087786277304592)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100609166272305022)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Para devolver YES cuando el empleado es un gestor y su departamento se encuentra en Chicago:</dt>',
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100609083249305022)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n SQL que produzca un valor utilizado como origen para este valor de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100608957026305022)
,p_name=>'PE.PROPERTY.SOURCE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100517656855304954)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.COMPONENT_PROPERTY.MAP_LAYER.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Consulta que devuelve los valores de longitud y latitud como columnas NUMBER:</p>',
'<pre>',
'select lon,',
'       lat,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>',
unistr('<p>Consulta que devuelve la ubicaci\00F3n del cliente como columna SDO_GEOMETRY:</p>'),
'<pre>',
'select cust_location,',
'       cust_name',
'  from customers',
' where company_id = :PX_COMPANY_ID',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99950958411304487)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el origen SQL para este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99950825436304487)
,p_name=>'PE.PROPERTY.SOURCE_SQL_QUERY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99869100330304422)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor est\00E1tico que se utilizar\00E1 como origen para este valor de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99869041707304422)
,p_name=>'PE.PROPERTY.SOURCE_STATIC_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99868935097304422)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione el tipo de origen para el valor en el que se basa este elemento.</p>',
unistr('<p>Nota: Si <strong>Origen: Utilizado</strong>est\00E1 definido en <em>Solo cuando el valor de sesi\00F3n actual en el estado de sesi\00F3n sea nulo</em>, no se utilizar\00E1 el origen si un valor se ha definido en estado de sesi\00F3n para este elemento.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100372043815304844)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.D'
,p_message_language=>'es'
,p_message_text=>'Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100567314370304991)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ALWAYS_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Defina el valor como nulo ya que no se ha especificado ning\00FAn valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100372224668304845)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna de Base de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100566705143304990)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.DB_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de columna introducido en <em>Columna de Base de Datos</em>, obtenido mediante un proceso de recuperaci\00F3n de fila incorporado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100588094587305006)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100588192723305006)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor resultante al ejecutar la <em>expresi\00F3n</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100372581307304845)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100567179579304990)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde el <em>cuerpo de la funci\00F3n</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100372631901304845)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100566843276304990)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de estado de sesi\00F3n del <em>elemento</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100372765325304845)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100567278635304990)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn la <em>preferencia</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100372317093304845)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Consulta SQL (devolver valor \00FAnico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100566958907304990)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el primer valor devuelto desde la <em>consulta SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100372432032304845)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL (devolver valores separados por dos puntos)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100567037657304990)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.QUERY_COLON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor \00FAnico delimitado por dos puntos, que concatena el valor de cada columna, devuelto desde la <em>consulta SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100372122787304845)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100566646471304990)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el texto introducido en <em>Valor Est\00E1tico</em>.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99868893111304422)
,p_name=>'PE.PROPERTY.SOURCE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99868791688304422)
,p_name=>'PE.PROPERTY.SOURCE_USED.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p> Seleccione qu\00E9 valor tiene prioridad, el valor del estado de la sesi\00F3n o el de origen del elemento.</p>'),
unistr('<p>Para elementos con el tipo de origen <strong>Columna de Base de Datos</strong>, seleccione <strong>Siempre, sustituyendo cualquier valor existente en el estado de sesi\00F3n</strong>, a menos que no desee que la operaci\00F3n de recuperaci\00F3n de filas asoc')
||unistr('iada rellene el elemento si la p\00E1gina se vuelva a bifurcar a s\00ED misma.'),
unistr('Para otros tipos de origen, debe decidir, en funci\00F3n de c\00F3mo se utilice la p\00E1gina, si se debe mostrar el valor originado previamente o si se debe aplicar el tipo de origen de nuevo para cada vista de p\00E1gina.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100371852670304844)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.NO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Siempre, sustituyendo cualquier valor existente en el estado de sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100371992452304844)
,p_name=>'PE.PROPERTY.SOURCE_USED.LOV.YES.D'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo cuando el valor de sesi\00F3n actual en el estado de sesi\00F3n sea nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99868670929304422)
,p_name=>'PE.PROPERTY.SOURCE_USED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Usado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100063158462304572)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el origen de datos de REST en el que est\00E9 soportada la recuperaci\00F3n de una recopilaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100063081384304572)
,p_name=>'PE.PROPERTY.SOURCE_WEB_SRC_QUERY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Origen de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100147771612304676)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('En un gr\00E1fico de doble eje Y dividido, especifique la fracci\00F3n de espacio que se proporciona al subgr\00E1fico del eje Y. Los valores v\00E1lidos son n\00FAmeros del 0 al 1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100147602931304676)
,p_name=>'PE.PROPERTY.SPLITTER_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Divisor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100147220945304676)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si el \00E1rea de datos se divide en dos secciones, de forma que los juegos de datos asignados a los ejes Y diferentes aparezcan en partes diferentes del \00E1rea de datos. Los gr\00E1ficos de valores no soportan la opci\00F3n <strong>No</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100147353880304676)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100147502141304676)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.OFF.D'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100147470560304676)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.LOV.ON.D'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100147152450304676)
,p_name=>'PE.PROPERTY.SPLIT_DUAL_Y.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100124435530304659)
,p_name=>'PE.PROPERTY.STACK.HELP'
,p_message_language=>'es'
,p_message_text=>'<p>Especifique si se apilan los elementos de datos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100124390142304658)
,p_name=>'PE.PROPERTY.STACK.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Apilar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99748576128304328)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el nombre de categor\00EDa de pila a la que asignar esta serie. Todas las series de un gr\00E1fico apilado se agrupan en la misma pila por defecto. Para agrupar esta serie en una pila independiente, defina una categor\00EDa de pila. Puede utilizar su')
||'stituciones <code>&COLUMN_VALUE.</code>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99748409842304328)
,p_name=>'PE.PROPERTY.STACK_CATEGORY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Categor\00EDa de pila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99748372734304328)
,p_name=>'PE.PROPERTY.STACK_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Especifique si se deben mostrar los valores totales de los elementos de datos apilados. Solo se aplica a los gr\00E1ficos de barras.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99748213465304328)
,p_name=>'PE.PROPERTY.STACK_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de pila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99849106140304406)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el juego de separadores est\00E1ndar utilizado para esta p\00E1gina. El juego de separadores est\00E1ndar se asocia a un n\00FAmero de p\00E1gina concreto. Puede utilizar separadores est\00E1ndar para enlazar usuarios a una p\00E1gina concreta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99849070977304406)
,p_name=>'PE.PROPERTY.STANDARD_TAB_SET.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Juego de Separadores Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100247224429304752)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el primer d\00EDa de la semana que se muestra en el calendario semanal.'),
unistr('Puede utilizar este atributo junto con <strong>D\00EDa de Finalizaci\00F3n</strong> para limitar los d\00EDas de la semana que se muestran, o simplemente para especificar el primer d\00EDa de la semana mostrado.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100406056476304872)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'es'
,p_message_text=>'Domingo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100406169505304872)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'es'
,p_message_text=>'Lunes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100406224139304872)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'es'
,p_message_text=>'Martes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100406332144304872)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'es'
,p_message_text=>unistr('Mi\00E9rcoles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100406451926304872)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'es'
,p_message_text=>'Jueves'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100406540308304873)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'es'
,p_message_text=>'Viernes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100406680668304873)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'es'
,p_message_text=>unistr('S\00E1bado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100247110401304752)
,p_name=>'PE.PROPERTY.START_DAY_FOR_WEEKLY_CALENDAR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('D\00EDa de Inicio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100247060076304751)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Determina el d\00EDa de la semana en que empieza el calendario mensual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100405318971304869)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721105.D'
,p_message_language=>'es'
,p_message_text=>'Domingo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100405421045304869)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721106.D'
,p_message_language=>'es'
,p_message_text=>'Lunes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100405549985304869)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721107.D'
,p_message_language=>'es'
,p_message_text=>'Martes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100405631381304869)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721108.D'
,p_message_language=>'es'
,p_message_text=>unistr('Mi\00E9rcoles')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100405793272304869)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721109.D'
,p_message_language=>'es'
,p_message_text=>'Jueves'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100405887983304869)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721110.D'
,p_message_language=>'es'
,p_message_text=>'Viernes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100405986762304870)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.LOV.19721111.D'
,p_message_language=>'es'
,p_message_text=>unistr('S\00E1bado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100246910853304751)
,p_name=>'PE.PROPERTY.START_OF_WEEK_FOR_MONTHLY_CALENDAR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('D\00EDa de Inicio')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100247802163304752)
,p_name=>'PE.PROPERTY.START_TIME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la hora de inicio para centrar la visualizaci\00F3n del calendario semanal y diario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100247719675304752)
,p_name=>'PE.PROPERTY.START_TIME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Hora de Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99877578972304429)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el contenedor est\00E1tico, de un selector de jQuery, para que los utilice esta acci\00F3n din\00E1mica.'),
unistr('Puede mejorar el rendimiento de las acciones din\00E1micas que tienen un \00E1mbito de evento <strong>Din\00E1mico</strong>.'),
unistr('Debe ser un elemento en la p\00E1gina que, por s\00ED mismo, no se vuelva a crear, pero que contenga los elementos de disparo que se han creado de nuevo mediante Refrescamiento de P\00E1gina Parcial (PPR).'),
'Esta referencia de elemento necesita definirse como un selector de jQuery.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99877493763304429)
,p_name=>'PE.PROPERTY.STATIC_CONTAINER_JQUERY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Contenedor Est\00E1tico (Selector de jQuery)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99887749430304438)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.BUTTON.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el ID est\00E1tico del bot\00F3n. Si se define, el ID est\00E1tico se utiliza como ID del bot\00F3n. El ID est\00E1tico puede resultar \00FAtil si se desarrolla el comportamiento de JavaScript personalizado. Si no se define el ID est\00E1tico, el bot\00F3n genera un ID i')
||'nterno.</p>',
unistr('<p>Nota: la plantilla debe incluir la cadena de sustituci\00F3n <code>#BUTTON_ID#</code> para que el bot\00F3n utilice el ID est\00E1tico introducido.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100091934314304595)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IG_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el ID est\00E1tico para la columna. El ID est\00E1tico puede ser \00FAtil para el desarrollo de comportamientos de JavaScript personalizados o estilos personalizados para elementos de columna. Si no se define el ID est\00E1tico, se utiliza un ID interno p')
||'ara el ID de elemento de columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100769153236305145)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.IR_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el ID est\00E1tico de la columna. Si est\00E1 definido, el ID est\00E1tico se utiliza como el ID de la celda de la cabecera de tabla (TH) correspondiente, al igual que el valor HEADERS de las celdas de datos de tabla (TD) correspondientes. El ID est\00E1t')
||unistr('ico puede ser \00FAtil al desarrollar un comportamiento de JavaScript personalizado o un estilo personalizado para la columna. Si no est\00E1 definido el ID est\00E1tico, la tabla genera un ID interno para estos valores de atributo.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100148170218304677)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el ID est\00E1tico para el eje del gr\00E1fico. El ID est\00E1tico puede ser \00FAtil al desarrollar un comportamiento de JavaScript personalizado para el eje del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100148019671304677)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.JET_CHART_SERIES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el ID est\00E1tico para la serie del gr\00E1fico. El ID est\00E1tico puede ser \00FAtil al desarrollar un comportamiento de JavaScript personalizado para la serie del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99946886304304484)
,p_name=>'PE.PROPERTY.STATIC_ID.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el ID est\00E1tico de esta regi\00F3n. Si se define, se utilizar\00E1 como ID de la regi\00F3n, mediante la cadena de sustituci\00F3n <code>#REGION_STATIC_ID#</code>, lo que puede resultar \00FAtil si se desarrolla el comportamiento de JavaScript personalizado')
||unistr(' para la regi\00F3n. Si no se define, la regi\00F3n generar\00E1 un ID interno.</p>'),
unistr('<p>Nota: la plantilla debe incluir la cadena de sustituci\00F3n <code>#REGION_STATIC_ID#</code> para que la regi\00F3n utilice el ID est\00E1tico introducido.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99877158790304429)
,p_name=>'PE.PROPERTY.STATIC_ID.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el ID est\00E1tico para este componente. Si se define, este ID puede ser \00FAtil si desarrolla un comportamiento de JavaScript personalizado para el componente.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99877061599304429)
,p_name=>'PE.PROPERTY.STATIC_ID.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100159415073304685)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de serie que se aplicar\00E1 al gr\00E1fico de valores presentado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100159565827304685)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.AREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100159638391304685)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.BAR.D'
,p_message_language=>'es'
,p_message_text=>'Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100159700915304685)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.CANDLESTICK.D'
,p_message_language=>'es'
,p_message_text=>'Vela'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100159836671304685)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINE.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100159923984304685)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.LOV.LINEWITHAREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea con \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100159308113304685)
,p_name=>'PE.PROPERTY.STOCK_RENDER_AS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Presentar como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99879571460304431)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si el procesamiento del resto de acciones pendientes se para cuando se genere un error al ejecutar la acci\00F3n actual.</p>'),
unistr('<p>Nota: el orden de ejecuci\00F3n de las acciones espec\00EDficas se determina mediante la secuencia especificada en cada acci\00F3n. Para asegurarse de que las acciones se ejecutan en el mismo orden, Oracle recomienda que los n\00FAmeros de secuencia sean \00FAnicos p')
||'ara todas las acciones verdaderas y todas las acciones falsas.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99879433575304431)
,p_name=>'PE.PROPERTY.STOP_EXECUTION_ON_ERROR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Detenci\00F3n de Sesi\00F3n en Caso de Error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99956735290304492)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Utilizar valor de informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99956830810304492)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.COMPONENT_PROPERTY.IG_COLUMN.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La columna utilizar\00E1 el valor de informe <strong>Expandir</strong> que ha definido el usuario final para establecer si la columna debe expandirse o no.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99956290836304491)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si la columna debe expandirse en caso de haber suficiente espacio en la pantalla real. '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99956562606304492)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.D'
,p_message_language=>'es'
,p_message_text=>'Siempre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99956626484304492)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.A.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La columna siempre se expandir\00E1, independientemente del valor de informe <strong>Expandir</strong> que ha definido el usuario final.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99956314320304491)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.D'
,p_message_language=>'es'
,p_message_text=>'Nunca'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99956429511304491)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.LOV.N.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('La columna no se expandir\00E1 y se limitar\00E1 a utilizar siempre el ancho especificado. Esto resulta \00FAtil para las columnas que tienen contenido corto como S\00ED/No o n\00FAmeros.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99956119829304491)
,p_name=>'PE.PROPERTY.STRETCH_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Expandir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100221369051304731)
,p_name=>'PE.PROPERTY.STRIP_HTML.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique si desea o no eliminar las etiquetas HTML de los valores de columna originales.',
'Esto es especialmente importante para columnas que utilizan expresiones HTML, se utilizan en enlaces de columnas o se exportan a archivos CSV.</p>',
'<p>Si selecciona valores de la base de datos que ya contienen etiquetas HTML, dichas etiquetas pueden entrar en conflicto con el HTML generado para las expresiones HTML o la URL generada para los enlaces de columna.',
'Cuando se exportan esos valores, las etiquetas HTML existentes se incluyen como texto sin formato en el archivo CSV generado.',
unistr('Cuando est\00E1 activada esta opci\00F3n, solo se utilizar\00E1 la parte de los datos del valor de columna.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100221283097304731)
,p_name=>'PE.PROPERTY.STRIP_HTML.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Dividir HTML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100077065334304583)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si desea incluir las filas comprobadas en el procesamiento de p\00E1ginas, que generalmente se inicia mediante un bot\00F3n de personalizaci\00F3n, como <strong>Marcar como Terminado</strong>.'),
unistr('        Estas filas comprobadas se pueden utilizar en un proceso personalizado para realizar la acci\00F3n necesaria.</p>'),
unistr('        <p>Nota: Las filas seleccionadas se procesar\00E1n incluso si no se ha actualizado nada en la fila. Generalmente, solo se procesan las filas que se han insertado, actualizado o suprimido.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100076912559304583)
,p_name=>'PE.PROPERTY.SUBMIT_CHECKED_ROWS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecuci\00F3n Incluye Filas Seleccionadas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99941798847304480)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione una aplicaci\00F3n a cuyo esquema de autenticaci\00F3n desea suscribir este esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99941665206304480)
,p_name=>'PE.PROPERTY.SUBSCRIBED_FROM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Suscrito desde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100546054393304975)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea que se muestre este componente usando un formato avanzado o de columna mediante expresiones HTML y cadenas de sustituci\00F3n soportadas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100545913325304974)
,p_name=>'PE.PROPERTY.SUB_TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formato Avanzado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100546247568304975)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que se utilizar\00E1 como subt\00EDtulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100546139781304975)
,p_name=>'PE.PROPERTY.SUB_TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100546796772304975)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100546613688304975)
,p_name=>'PE.PROPERTY.SUB_TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100546506902304975)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Cambiar los colores del fondo y del texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Utilizar Cabecera 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utilizar una clase din\00E1mica de la consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Las sustituciones <code>&COLUMN_CLASS.</code> y <code>&EMPLOYEE_STATUS.</code> de este ejemplo son columnas seleccionadas en la consulta SQL de informe.</dd>',
'  <dt>Mostrar una imagen y una pista al pasar el mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100546476880304975)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las expresiones HTML que se mostrar\00E1n en esta columna. Utilice la sintaxis <code>&COLUMN.</code> para mostrar valores de columna en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100546363518304975)
,p_name=>'PE.PROPERTY.SUB_TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100200891260304716)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.COMPONENT_PROPERTY.PAGE_PROCESS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el mensaje de proceso correcto.',
unistr('Si el proceso se ejecuta y no genera un error, aparece este mensaje de proceso correcto en la secci\00F3n de notificaci\00F3n de la p\00E1gina resultante.'),
unistr('Si va a bifurcar a otra p\00E1gina a trav\00E9s de un redireccionamiento de URL, puede que necesite activar el atributo <em>mantener mensaje correcto</em>.</p>'),
unistr('<p>Para los procesos de varias filas, puede utilizar la siguiente cadena de sustituci\00F3n para obtener el n\00FAmero de registros procesados:</p>'),
'<ul>',
'  <li>Insertar: <code>#MRI_COUNT#</code></li>',
'  <li>Actualizar: <code>#MRU_COUNT#</code></li>',
'  <li>Suprimir: <code>#MRD_COUNT#</code></li>',
'</ul>',
unistr('<p>Para el tipo de proceso Enviar Correo Electr\00F3nico, se puede utilizar la cadena de sustituci\00F3n <code>#TO#</code> para obtener las direcciones del correo electr\00F3nico.</p>'),
unistr('<p>Los plugins pueden tener tambi\00E9n otras cadenas de sustituci\00F3n. Consulte la documentaci\00F3n del plugin para obtener m\00E1s informaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100355274101304832)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el texto que se va a mostrar en el \00E1rea de "Notificaci\00F3n" (definido como parte de la plantilla de p\00E1gina), cuando este proceso finaliza correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100200394968304716)
,p_name=>'PE.PROPERTY.SUCCESS_MESSAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mensaje Correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99896826985304445)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca la consulta SQL como origen para las sugerencias.</p>',
'<p>Nota: El orden en el que se devuelven los valores se utiliza para determinar el orden en el que deben mostrarse.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99896790776304445)
,p_name=>'PE.PROPERTY.SUGGESTIONS_SQL_QUERY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99896639068304445)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una lista de valores est\00E1ticos delimitados por comas como origen de las sugerencias.</p>'),
'<p>Nota: El orden en el que se especifican los valores se utiliza para determinar el orden en el que deben mostrarse.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99896557518304445)
,p_name=>'PE.PROPERTY.SUGGESTIONS_STATIC_VALUES.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99898874671304446)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99899582369304447)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.COMPONENT_PROPERTY.SFILTER_GROUP.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99895841660304444)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione c\00F3mo se determinan las sugerencias para este filtro.</p>'),
unistr('<p>Note: Los valores proporcionados a\00FAn se comprueban compar\00E1ndolos con las entradas visibles de la lista de valores y solo se utilizar\00E1n si hay una coincidencia.'),
unistr('Si no se encuentra un valor, se omitir\00E1 y se comprobar\00E1 el siguiente.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99895936147304444)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Din\00E1mico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99896015950304444)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.DYNAMIC.HELP'
,p_message_language=>'es'
,p_message_text=>'Selecciona la <strong>primera</strong> entrada visible de la lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99896368431304444)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99896494760304445)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>'Los valores se devuelven de la <em>consulta SQL</em> introducida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99896132798304444)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valores Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99896247547304444)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.LOV.STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>'Lista de valores delimitados por comas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99895742511304444)
,p_name=>'PE.PROPERTY.SUGGESTIONS_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100164515292304689)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el texto que aparece en la parte superior de los archivos de descarga. Puede introducir la clasificaci\00F3n de los datos, o advertencias o notas legales relacionadas con los datos del archivo.</p>'),
unistr('        <p> Nota - El texto que introduzca se incluir\00E1 en todos los formatos de descarga de informes. Si la descarga CSV est\00E1 habilitada, el texto definido invalidar\00E1 el formato de archivo CSV.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100164476648304689)
,p_name=>'PE.PROPERTY.SUPPLEMENTAL_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Texto Complementario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100179701882304700)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique este atributo para utilizar el texto de la cabecera de columna como etiqueta en la vista de detalles.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100179663893304700)
,p_name=>'PE.PROPERTY.SYNC_FORM_LABEL.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Usar Cabecera de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100235042838304742)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione la base de esta columna de pantalla tabular.</p>',
unistr('<p>La selecci\00F3n determina si esta columna se puede actualizar en la pantalla tabular.'),
unistr('Las actualizaciones solo se pueden realizar si se define una actualizaci\00F3n de varias filas o se implementa un proceso PL/SQL para procesar los datos actualizados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100402450094304867)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.D'
,p_message_language=>'es'
,p_message_text=>'Selector de Fecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100570831968304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_PICKER.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la fecha o utilice el selector de fecha para seleccionarla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100402358234304867)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.D'
,p_message_language=>'es'
,p_message_text=>unistr('Selector de Fecha (Cl\00E1sico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100570910185304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DATE_POPUP.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca la fecha o utilice el selector de fecha para seleccionarla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100402290152304867)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.D'
,p_message_language=>'es'
,p_message_text=>'Texto sin Formato (guarda el estado)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100569597744304992)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DISPLAY_AND_SAVE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra el valor de columna y guarda el valor en el estado de la sesi\00F3n. Esta columna se puede utilizar en el procesamiento de p\00E1ginas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100403909447304868)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.D'
,p_message_language=>'es'
,p_message_text=>'Descargar BLOB'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100569924252304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.DOWNLOAD.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra la columna como un enlace para descargar el archivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100403489127304868)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna Oculta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100571020521304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>'No muestra la columna, pero se puede hacer referencia a ella.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100402913789304867)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.D'
,p_message_language=>'es'
,p_message_text=>'Columna Oculta (guarda el estado)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100571138334304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.HIDDEN_FIELD.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('No muestra la columna, pero se puede hacer referencia a ella. Esta columna se puede utilizar en el procesamiento de p\00E1ginas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100403840783304868)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.D'
,p_message_language=>'es'
,p_message_text=>'Mostrar Imagen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100569893519304992)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.IMAGE.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra la columna como una imagen.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100403766373304868)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.D'
,p_message_language=>'es'
,p_message_text=>'Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100569769018304992)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.LINK.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra la columna como un enlace.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100404085320304868)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.D'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico de Porcentaje')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100570067053304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PCT_GRAPH.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra la columna como un gr\00E1fico de porcentajes. El valor recuperado debe estar entre 0 y 100.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100403529749304868)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.D'
,p_message_language=>'es'
,p_message_text=>'Texto sin Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100569451692304992)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra el valor de columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100403692017304868)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.D'
,p_message_language=>'es'
,p_message_text=>'Texto sin Formato (Basado en Lista de Valores)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100569670833304992)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.PLAIN_LOV.HELP'
,p_message_language=>'es'
,p_message_text=>'Muestra el valor devuelto de la lista de valores especificados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100403092876304867)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.D'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores Emergente (muestra valor de retorno)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100570597046304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUP.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un valor del elemento emergente. Aparece el valor de retorno de la lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100403116166304867)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.D'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores Emergente (muestra valor de visualizaciones)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100570456874304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.POPUPKEY.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un valor del elemento emergente. Aparece el valor mostrado de la lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100402861534304867)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.D'
,p_message_language=>'es'
,p_message_text=>'Grupo de Botones de Radio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100570639808304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.RADIOGROUP.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un \00FAnico grupo de botones de radio de la lista de valores especificados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100403330868304868)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.D'
,p_message_language=>'es'
,p_message_text=>'Selector de Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100569325608304992)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.ROW_SELECTOR.HELP'
,p_message_language=>'es'
,p_message_text=>'Incluye una casilla de control al principio de cada fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100402771182304867)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.D'
,p_message_language=>'es'
,p_message_text=>unistr('Lista de Selecci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100570340992304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SELECT_LIST.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione un valor de la lista de valores especificados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100403247487304868)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.D'
,p_message_language=>'es'
,p_message_text=>'Casilla de Control Simple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100570738616304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.SIMPLE_CHECKBOX.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Active o desactive una \00FAnica casilla de control.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100402585584304867)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.D'
,p_message_language=>'es'
,p_message_text=>'Campo de Texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100570188311304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca un valor en un campo de texto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100402666415304867)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea de Texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100570205671304993)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.LOV.TEXTAREA.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un valor en un campo de \00E1rea de texto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100234992853304741)
,p_name=>'PE.PROPERTY.TAB_FORM_COLUMN_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99957832884304492)
,p_name=>'PE.PROPERTY.TARGET.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic en el destino para llamar a un cuadro de di\00E1logo modal. Puede introducir el destino que se ha llamado al llamar a esta bifurcaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99957704271304492)
,p_name=>'PE.PROPERTY.TARGET.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100538384035304969)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione las opciones de plantilla para personalizar la interfaz de usuario de este componente.</p>',
unistr('<p>Tambi\00E9n puede modificar las opciones de plantilla mediante la ejecuci\00F3n de la aplicaci\00F3n con <strong>Opciones de Plantilla Activas</strong>.'),
unistr('La opci\00F3n Opciones de Plantilla Activas le permite personalizar la aplicaci\00F3n en tiempo real, lo que permite realizar una vista previa y aplicar varias opciones.'),
unistr('Para acceder a Opciones de Plantilla Activas, ejecute la aplicaci\00F3n en el creador de aplicaciones y haga clic en <em>Edici\00F3n R\00E1pida</em> en la barra de herramientas del desarrollador.'),
unistr('Pase el mouse sobre un componente de p\00E1gina, por ejemplo una regi\00F3n, y haga clic en el icono de llave inglesa ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) que se muestra en la esquina superior izquierda.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100538275825304969)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Opciones de Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100538566610304969)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione las opciones de plantilla para personalizar la interfaz de usuario de este componente.</p>',
unistr('<p>Tambi\00E9n puede modificar las opciones de plantilla mediante la ejecuci\00F3n de la aplicaci\00F3n con <strong>Opciones de Plantilla Activas</strong>.'),
unistr('La opci\00F3n Opciones de Plantilla Activas le permite personalizar la aplicaci\00F3n en tiempo real, lo que permite realizar una vista previa y aplicar varias opciones.'),
unistr('Para acceder a Opciones de Plantilla Activas, ejecute la aplicaci\00F3n en el creador de aplicaciones y haga clic en <em>Edici\00F3n R\00E1pida</em> en la barra de herramientas del desarrollador.'),
unistr('Pase el mouse sobre un componente de p\00E1gina, por ejemplo una regi\00F3n, y haga clic en el icono de llave inglesa ( <span class="a-Icon icon-util" aria-hidden="true"></span> ) que se muestra en la esquina superior izquierda.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100538485168304969)
,p_name=>'PE.PROPERTY.TEMPLATE_OPTIONS2.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Opciones de Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99786692764304356)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Los marcadores de posici\00F3n en una plantilla de correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99786599372304356)
,p_name=>'PE.PROPERTY.TEMPLATE_PLACEHOLDERS.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Marcadores de posici\00F3n de plantilla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100219935936304730)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el tipo de plantilla de este informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100399135586304864)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.D'
,p_message_language=>'es'
,p_message_text=>'Predefinido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100399243758304864)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.PREDEFINED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de informe predefinidas que no est\00E1n asociadas directamente a ning\00FAn tema. Puesto que no hay ninguna correlaci\00F3n entre estas plantillas predefinidas y el tema actual, el dise\00F1o de informe permanece igual aunque cambie el tema de aplicaci\00F3n')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100398942989304864)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.D'
,p_message_language=>'es'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100399005686304864)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.LOV.THEME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de informe disponibles en el tema correspondiente, basadas en el tema actual para la interfaz de usuario de esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100219814333304730)
,p_name=>'PE.PROPERTY.TEMPLATE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100727156370305114)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seg\00FAn el <strong>tipo de b\00FAsqueda</strong> especificado, introduzca un nombre o una lista de nombres de columna de base de datos que se usan para la b\00FAsqueda de texto.</p>'),
'<ul>',
unistr('  <li><strong>B\00FAsqueda de fila</strong>: introduzca una lista de elementos separados por comas de nombres de columna de base de datos sensibles a may\00FAsculas/min\00FAsculas del tipo VARCHAR2 que se usan para la b\00FAsqueda de texto. Si no se especifica ningu')
||unistr('na columna, todas las columnas de VARCHAR2 se usar\00E1n de forma autom\00E1tica.</li>'),
unistr('  <li><strong>Oracle Text</strong>: introduzca el nombre de columna de base de datos sensible a may\00FAsculas/min\00FAsculas que contiene el \00EDndice de Oracle Text.</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100727026328305114)
,p_name=>'PE.PROPERTY.TEXT_SEARCH_DB_COLUMNS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columnas de base de datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99998901003304524)
,p_name=>'PE.PROPERTY.THEME.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el tema que desee asociar a la interfaz de usuario actual.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99998824958304524)
,p_name=>'PE.PROPERTY.THEME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100146873853304676)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la posici\00F3n de las etiquetas de marca en relaci\00F3n al \00E1rea de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100147056340304676)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.INSIDE.D'
,p_message_language=>'es'
,p_message_text=>'Dentro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100146985657304676)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.LOV.OUTSIDE.D'
,p_message_language=>'es'
,p_message_text=>'Fuera'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100146780385304675)
,p_name=>'PE.PROPERTY.TICK_LABEL_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100146451650304675)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.HELP'
,p_message_language=>'es'
,p_message_text=>'Especifique si se presentan las etiquetas de marca.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100146323054304675)
,p_name=>'PE.PROPERTY.TICK_LABEL_RENDERED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100146667020304675)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique si el gr\00E1fico girar\00E1 autom\00E1ticamente las etiquetas 90 grados para que quepan m\00E1s etiquetas en el eje.'),
unistr('        El giro solo se aplicar\00E1 a las etiquetas categ\00F3ricas de un eje horizontal.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100146503707304675)
,p_name=>'PE.PROPERTY.TICK_LABEL_ROTATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Rotaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100517281491304953)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Igual que est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100648091936305050)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.COMPONENT_PROPERTY.MAP_REGION.NULL_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>'Utilizar el mismo mapa de fondo para el modo claro y oscuro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100471850193304919)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la capa de mosaico que se va a usar como mapa de fondo cuando est\00E9 activado el modo oscuro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100472763766304920)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.D'
,p_message_language=>'es'
,p_message_text=>'Mapa mundial de Oracle BI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100472877196304920)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base discreto basado en mapas de HERE Map. El estilo de este mapa base proporciona contexto de la ubicaci\00F3n de los datos y acent\00FAa la visualizaci\00F3n de los datos.</p>'),
'<p>Definiciones y esquemas de estilo de Oracle, USA.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100472373100304920)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.D'
,p_message_language=>'es'
,p_message_text=>'Claro de OpenStreetMap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100472459973304920)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Mapa base de uso general basado en datos de OpenStreetMap. El estilo de este mapa base proporciona un contexto de ubicaci\00F3n detallado para los datos.</p>'),
'<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abierto de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100471922876304919)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'es'
,p_message_text=>'Oscuro de OpenStreetMap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100472001202304920)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Mapa base claro discreto basado en datos de OpenStreetMap. El estilo de este mapa base acent\00FAa las visualizaciones de los datos.</p>'),
unistr('<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abiertos de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY. Cartograf\00EDa de Stamen Design con licencia de CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100472179427304920)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.D'
,p_message_language=>'es'
,p_message_text=>unistr('Positr\00F3n de OpenStreetMap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100472232169304920)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.OSM-POSITRON.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base oscuro discreto basado en datos de OpenStreetMap. El estilo de este mapa base acent\00FAa las visualizaciones de los datos.</p>'),
unistr('<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abierto de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY. Cartograf\00EDa de Stamen Design con licencia de CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100472553464304920)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.D'
,p_message_language=>'es'
,p_message_text=>'Mapa mundial de Oracle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100472661349304920)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.LOV.WORLD-MAP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso general basado en datos de HERE Map. El estilo de este mapa base proporciona contexto de la ubicaci\00F3n de los datos y acent\00FAa la visualizaci\00F3n de los mismos.</p>'),
'<p>Definiciones y esquemas de estilo de Oracle, USA.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100471737994304919)
,p_name=>'PE.PROPERTY.TILELAYER_DARK.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Modo oscuro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100470659179304918)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la capa de mosaico que se va a usar como mapa de fondo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100471547310304919)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.D'
,p_message_language=>'es'
,p_message_text=>'Mapa mundial de Oracle BI'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100471660460304919)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.BI-WORLD-MAP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base discreto basado en mapas de HERE Map. El estilo de este mapa base proporciona contexto de la ubicaci\00F3n de los datos y acent\00FAa la visualizaci\00F3n de los datos.</p>'),
'<p>Definiciones y esquemas de estilo de Oracle, USA.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100471126455304919)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.D'
,p_message_language=>'es'
,p_message_text=>'Claro de OpenStreetMap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100471281797304919)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-BRIGHT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<p>Mapa base de uso general basado en datos de OpenStreetMap. El estilo de este mapa base proporciona un contexto de ubicaci\00F3n detallado para los datos.</p>'),
'<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abierto de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100470947208304919)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.D'
,p_message_language=>'es'
,p_message_text=>'Oscuro de OpenStreetMap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100471091027304919)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-DARK-MATTER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base oscuro discreto basado en datos de OpenStreetMap. El estilo de este mapa base acent\00FAa las visualizaciones de los datos.</p>'),
unistr('<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abierto de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY. Cartograf\00EDa de Stamen Design con licencia de CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100470752999304919)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.D'
,p_message_language=>'es'
,p_message_text=>unistr('Positr\00F3n de OpenStreetMap')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100470880204304919)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.OSM-POSITRON.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base claro discreto basado en datos de OpenStreetMap. El estilo de este mapa base acent\00FAa las visualizaciones de los datos.</p>'),
unistr('<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abiertos de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY. Cartograf\00EDa de Stamen Design con licencia de CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100471337501304919)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.D'
,p_message_language=>'es'
,p_message_text=>'Mapa mundial de Oracle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100471454090304919)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.LOV.WORLD-MAP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso general basado en datos de HERE Map. El estilo de este mapa base proporciona contexto de la ubicaci\00F3n de los datos y acent\00FAa la visualizaci\00F3n de los mismos.</p>'),
'<p>Definiciones y esquemas de estilo de Oracle, USA.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100470592671304918)
,p_name=>'PE.PROPERTY.TILELAYER_DEFAULT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100470097818304918)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione el mapa de fondo que se va a utilizar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100470368375304918)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.D'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100470421439304918)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.CUSTOM.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione las capas de mosaico de mapa que se van a usar para el mapa de fondo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100470162675304918)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.D'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100470238756304918)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Use la configuraci\00F3n por defecto del mapa de fondo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100469922187304918)
,p_name=>'PE.PROPERTY.TILELAYER_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Segundo Plano'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100247679256304752)
,p_name=>'PE.PROPERTY.TIME_FORMAT.HELP'
,p_message_language=>'es'
,p_message_text=>'Seleccione la forma de mostrar el formato de hora.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100407484285304873)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.12HOUR.D'
,p_message_language=>'es'
,p_message_text=>'12 Horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100407505683304873)
,p_name=>'PE.PROPERTY.TIME_FORMAT.LOV.24HOUR.D'
,p_message_language=>'es'
,p_message_text=>'24 Horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100247569502304752)
,p_name=>'PE.PROPERTY.TIME_FORMAT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formato de Hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100736326304305121)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.JET_CHART_AXES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un t\00EDtulo para el eje. Este t\00EDtulo describe la informaci\00F3n representada en el eje del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99887014420304437)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.PAGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el t\00EDtulo que se mostrar\00E1 en la barra de t\00EDtulo de la ventana del explorador. El motor de &PRODUCT_NAME. utiliza el t\00EDtulo especificado aqu\00ED en lugar de la cadena de sustituci\00F3n <code>#TITLE#</code> utilizada en la plantilla de p\00E1gina. Est')
||unistr('e t\00EDtulo se inserta entre las etiquetas HTML <code>&lt;TITLE&gt;</code> y <code>&lt;/TITLE&gt;</code>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99887963870304438)
,p_name=>'PE.PROPERTY.TITLE.COMPONENT_PROPERTY.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un t\00EDtulo de regi\00F3n. El t\00EDtulo de regi\00F3n s\00F3lo aparece si est\00E1 definido en la plantilla de regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99849368462304406)
,p_name=>'PE.PROPERTY.TITLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el t\00EDtulo de p\00E1gina. El t\00EDtulo se mostrar\00E1 en la barra de t\00EDtulo de la ventana del explorador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99849216651304406)
,p_name=>'PE.PROPERTY.TITLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100545167348304974)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea que se muestre este componente usando un formato avanzado o de columna mediante expresiones HTML y cadenas de sustituci\00F3n soportadas.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100545010255304974)
,p_name=>'PE.PROPERTY.TITLE_ADV_FORMATTING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formato Avanzado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100545344138304974)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la columna que se utilizar\00E1 como t\00EDtulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100545226308304974)
,p_name=>'PE.PROPERTY.TITLE_COLUMN_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100545845217304974)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las clases que desee agregar a este componente. Puede agregar varias clases separ\00E1ndolas con espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100545771848304974)
,p_name=>'PE.PROPERTY.TITLE_CSS_CLASSES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Clases CSS'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100545656979304974)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Cambiar los colores del fondo y del texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Utilizar Cabecera 2</dt>',
'    <dd><pre>&lt;h2>&EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Utilizar una clase din\00E1mica de la consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&COLUMN_CLASS.">&EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Las sustituciones <code>&COLUMN_CLASS.</code> y <code>&EMPLOYEE_STATUS.</code> de este ejemplo son columnas seleccionadas en la consulta SQL de informe.</dd>',
'  <dt>Mostrar una imagen y una pista al pasar el mouse</dt>',
'    <dd><pre>&lt;img src="&IMAGE_NAME." title="&EMPLOYEE_NAME."&gt;</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100545539958304974)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca las expresiones HTML que se mostrar\00E1n en esta columna. Utilice la sintaxis <code>&COLUMN.</code> para mostrar valores de columna en HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100545433401304974)
,p_name=>'PE.PROPERTY.TITLE_HTML_EXPR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n HTML')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100098637549304600)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Compruebe qu\00E9 controles adicionales aparecer\00E1n en la barra de herramientas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100099112781304600)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.D'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Acciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100099219956304600)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.ACTIONS_MENU.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra el bot\00F3n del men\00FA Acciones, que generalmente incluye un juego completo de opciones. Estas opciones permiten al usuario final personalizar el informe seg\00FAn las funciones disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100099375118304601)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.D'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Restablecer')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100099487500304601)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.RESET.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra el bot\00F3n Restablecer. Al pulsar este bot\00F3n, se suprimen todas las personalizaciones, como los filtros, la anchura de la columna o el orden, y la definici\00F3n del informe se carga de nuevo desde el servidor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100099510532304601)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.D'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n Guardar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100099628551304601)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SAVE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Muestra el bot\00F3n Guardar. Al pulsar este bot\00F3n, solo se guardar\00E1n los cambios realizados en esta cuadr\00EDcula interactiva, sin necesidad de guardar toda la p\00E1gina.'),
unistr('        <p>El bot\00F3n Guardar solo aparecer\00E1 cuando la cuadr\00EDcula interactiva sea editable y el usuario final tenga autorizaci\00F3n para agregar, actualizar o suprimir.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100098761311304600)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.D'
,p_message_language=>'es'
,p_message_text=>unistr('Buscar en selecci\00F3n de columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100098802642304600)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra una lista desplegable de las columnas no num\00E9ricas que aparecen. Si hay una columna seleccionada, la b\00FAsqueda solo se realiza en los valores de dicha columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100098960673304600)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.D'
,p_message_language=>'es'
,p_message_text=>unistr('Campo de B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100099021113304600)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.LOV.SEARCH_FIELD.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra un campo de texto en la barra de b\00FAsqueda en el que se introducen los criterios de b\00FAsqueda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100098562584304600)
,p_name=>'PE.PROPERTY.TOOLBAR_CONTROLS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Controles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100661141496305060)
,p_name=>'PE.PROPERTY.TREE_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100565690967304989)
,p_name=>'PE.PROPERTY.TREE_SQL_STATEMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Consulta de \00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100661247940305060)
,p_name=>'PE.PROPERTY.TREE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100203049827304718)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.HELP'
,p_message_language=>'es'
,p_message_text=>'Indica si en esta columna se detecta la zona horaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100202941160304718)
,p_name=>'PE.PROPERTY.TZ_DEPENDENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Detecci\00F3n de Zona Horaria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100236343720304743)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione el nombre de columna al que hace referencia esta columna de informe.',
'Este atributo se utiliza para comparar referencias a columnas entre aplicaciones con los valores por defecto de la interfaz de usuario.',
unistr('Esta referencia se mantiene de forma manual despu\00E9s de que un asistente la inicialice, siempre que sea posible.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100236281827304742)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100236154469304742)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione la tabla o vista a la que hace referencia esta columna.',
'Este atributo se utiliza para comparar referencias a columnas entre aplicaciones con los valores por defecto de la interfaz de usuario.',
unistr('Esta referencia se mantiene de forma manual despu\00E9s de que un asistente la inicialice, siempre que sea posible.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100236071476304742)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre de la Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100235997522304742)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione el esquema propietario de la tabla de referencia.',
'Este atributo se utiliza para comparar las referencias a columnas entre aplicaciones con los valores por defecto de la interfaz de usuario.',
unistr('Esta referencia se mantiene de forma manual despu\00E9s de que un asistente la inicialice, siempre que sea posible.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100235816336304742)
,p_name=>'PE.PROPERTY.UI_DEFAULT_REF_TABLE_OWNER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Propietario de Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100187825079304706)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el tipo de columna que se utilizar\00E1 para identificar la fila actual cuando se utilice la columna de enlace.'),
unistr('Por defecto, se utiliza <strong>ROWID</strong> para identificar como \00FAnica las filas en un informe. Sin embargo, tambi\00E9n puede seleccionar <strong>Columna \00DAnica</strong> para utilizar otra columna.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100388018525304856)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.COLUMN.D'
,p_message_language=>'es'
,p_message_text=>unistr('Columna \00DAnica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100387966830304856)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.LOV.ROWID.D'
,p_message_language=>'es'
,p_message_text=>'ROWID'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100187785444304706)
,p_name=>'PE.PROPERTY.UNIQUELY_IDENTIFY_ROWS_BY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Identificar Filas como \00DAnicas por')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100188045838304707)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la primera columna utilizada para identificar como \00FAnicas las filas de este componente.</p>'),
unistr('<p><strong>ROWID</strong> tambi\00E9n se incluye en la lista de columnas disponibles para la compatibilidad con versiones anteriores.</p>'),
unistr('<p>Nota: Para un informe interactivo con el atributo <em>Columna de Enlace</em> definido en <strong>Enlace a Vista de Una Sola Fila</strong>, solo se puede seleccionar una columna \00FAnica. Otros componentes soportan la selecci\00F3n de hasta tres columnas.')
||'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100187991320304707)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna \00DAnica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100188235854304707)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la segunda columna que desee utilizar para identificar como \00FAnicas las filas de este componente. Utilice este atributo cuando la tabla tenga una clave primaria de dos partes.</p>'),
unistr('<p><strong>ROWID</strong> tambi\00E9n est\00E1 incluida en la lista de columnas disponibles para la compatibilidad con versiones anteriores.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100188194176304707)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna \00DAnica 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100188470751304707)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la tercera columna que se utilizar\00E1 para identificar como \00FAnicas las filas de este componente. Utilice este atributo cuando la tabla tenga una clave primaria de tres partes.</p>'),
unistr('<p><strong>ROWID</strong> se incluye tambi\00E9n en la lista de columnas disponibles para la compatibilidad con versiones anteriores.</p>'),
unistr('<p>Nota: Si la clave primaria de la tabla tiene m\00E1s de tres columnas, debe identificar las filas como \00FAnicas mediante <strong>ROWID</strong>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100188301725304707)
,p_name=>'PE.PROPERTY.UNIQUE_COLUMN_3.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Columna \00DAnica 3')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100075813608304582)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione un esquema de autorizaci\00F3n para restringir los usuarios que pueden actualizar filas.'),
unistr('Para permitir que un usuario final actualice filas, este esquema de autorizaci\00F3n se debe evaluar en TRUE para ese usuario.'),
unistr('Si no se proporciona ning\00FAn esquema de autorizaci\00F3n, cualquier usuario puede actualizar filas en esta cuadr\00EDcula interactiva.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100075775721304582)
,p_name=>'PE.PROPERTY.UPDATE_AUTHORIZATION_SCHEME.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Actualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99963338691304497)
,p_name=>'PE.PROPERTY.USER_INTERFACE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Muestra la interfaz de usuario de esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99963230845304497)
,p_name=>'PE.PROPERTY.USER_INTERFACE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99997956635304523)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un tipo de interfaz de usuario para esta p\00E1gina. Seleccione <strong>Escritorio<strong> para obtener las p\00E1ginas dise\00F1adas principalmente para el uso de escritorio. Para otras interfaces, como smartphones o tabletas, seleccione la interfaz ')
||'de usuario correspondiente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100382106124304852)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.DESKTOP.D'
,p_message_language=>'es'
,p_message_text=>'Escritorio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100382236042304852)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.LOV.JQM_SMARTPHONE.D'
,p_message_language=>'es'
,p_message_text=>'Smartphone jQuery Mobile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99997824712304523)
,p_name=>'PE.PROPERTY.USER_INTERFACE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100213041910304725)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si esta columna tambi\00E9n se muestra en la cabecera de fila.'),
'Al incluir el valor de columna, se mejora enormemente la accesibilidad de los campos de pantalla que se presentan en un informe.',
'Al especificarlo, la cabecera de fila se utiliza junto con la cabecera de columna para presentar las etiquetas para los campos de pantalla en el informe con el formato <code>''&lt;Cabecera de Columna&gt; : &lt;Cabecera de Fila&gt;''</code>.</p>',
unistr('<p>Imagine, por ejemplo, un informe en la tabla EMP, donde define la columna ENAME como la cabecera de fila. Suponga que tiene una fila donde ENAME es ''JONES''; en ese caso, la etiqueta para el campo Salario en esa fila, por ejemplo, ser\00EDa "Salario : ')
||'JONES".',
unistr('Esto permite al usuario del lector de pantalla navegar por los campos de la pantalla en el informe y comprender qu\00E9 campos de pantalla se relacionan con qu\00E9 fila.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100212967823304725)
,p_name=>'PE.PROPERTY.USE_AS_ROW_HEADER.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Usar como Cabecera de Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100241321068304747)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique si desea definir un enlace personalizado para la vista de iconos. Esta opci\00F3n ofrece mayor flexibilidad a la hora de definir el contenido de la vista de iconos, lo que incluye la capacidad de utilizar m\00E1s de una columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100241210534304747)
,p_name=>'PE.PROPERTY.USE_CUSTOM_ICON_VIEW.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99960462191304495)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione la regi\00F3n asociada para esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99960359518304494)
,p_name=>'PE.PROPERTY.VALIDATION_REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n Editable')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99958959995304493)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el tipo de igualdad que se va a probar para esta validaci\00F3n. Seg\00FAn la selecci\00F3n, se necesitan uno o m\00E1s atributos adicionales para definir completamente esta validaci\00F3n.</p>'),
unistr('<p>Si la validaci\00F3n aprueba la prueba de igualdad, o se eval\00FAa como TRUE, no se mostrar\00E1 el mensaje de error de validaci\00F3n.'),
unistr('Los mensajes de error de validaci\00F3n se muestran si la validaci\00F3n no supera la prueba de igualdad, se eval\00FAa como FALSE o se devuelve una cadena de texto no vac\00EDa.</p>'),
unistr('<p>Un fallo de validaci\00F3n no para la evaluaci\00F3n de las validaciones posteriores, por lo tanto cada validaci\00F3n posterior puede emitir un mensaje de error de validaci\00F3n adicional. Si desea dejar de ejecutar las validaciones posteriores, debe agregar un')
||unistr('a l\00F3gica adicional en la primera validaci\00F3n fallida, como por ejemplo definir un elemento de p\00E1gina en un valor espec\00EDfico y, a continuaci\00F3n, mejorar la l\00F3gica condicional en las validaciones posteriores seg\00FAn sea necesario. Los procesos y bifurcacio')
||unistr('nes posteriores no se ejecutan si fallan una o m\00E1s validaciones en la evaluaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100415627763304879)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Filas Devueltas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100415762942304879)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si la consulta SQL devuelve una o m\00E1s filas.<br>'),
'Falla si la consulta SQL no devuelve ninguna fila.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100621884002305031)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100621932413305031)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si la expresi\00F3n se eval\00FAa como TRUE.<br>'),
unistr('Falla si la expresi\00F3n se eval\00FAa como FALSE.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100416274676304879)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n (devuelve un valor booleano)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100416340486304879)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el cuerpo de la funci\00F3n devuelve un valor TRUE.<br>'),
unistr('Falla si el cuerpo de la funci\00F3n devuelve un valor FALSE.<br>'),
unistr('Nota: El resultado devuelto de la funci\00F3n debe ser un valor booleano.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100416497215304879)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n (devuelve texto de error)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100416531330304879)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.FUNC_BODY_RETURNING_ERR_TEXT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el cuerpo de la funci\00F3n devuelve una cadena vac\00EDa.<br>'),
unistr('Falla si el cuerpo de la funci\00F3n devuelve una cadena no vac\00EDa. La cadena devuelta se muestra como un mensaje de error para la validaci\00F3n.<br>'),
unistr('Nota: El resultado devuelto de la funci\00F3n debe ser una cadena de texto.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100417213560304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.D'
,p_message_language=>'es'
,p_message_text=>'El elemento no contiene espacios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100417367702304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_CONTAINS_NO_SPACES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si el valor del elemento no tiene espacios.<br>',
'Falla si el valor del elemento contiene espacios.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100419235260304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.D'
,p_message_language=>'es'
,p_message_text=>'El elemento contiene al menos uno de los caracteres de Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100419359778304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor del elemento incluye al menos un car\00E1cter del texto que ha introducido en el atributo <em>Valor</em>.<br>'),
unistr('Falla si el valor del elemento no incluye ning\00FAn car\00E1cter del texto que ha introducido en el atributo <em>Valor</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100419467003304882)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.D'
,p_message_language=>'es'
,p_message_text=>'El elemento NO contiene ninguno de los caracteres de Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100419523524304882)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si el valor del elemento no incluye ninguno de los caracteres del texto que ha introducido en el atributo <em>Valor</em>.<br>',
unistr('Falla si el valor del elemento incluye al menos un car\00E1cter del texto que ha introducido en el atributo <em>Valor</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100419024840304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.D'
,p_message_language=>'es'
,p_message_text=>'El elemento solo contiene caracteres especificados en Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100419197242304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si el valor del elemento solo contiene caracteres que aparecen en el texto que ha introducido en el atributo <em>Valor</em>.<br>',
unistr('Falla si el valor del elemento contiene cualquier car\00E1cter que no aparece en el texto que ha introducido en el atributo <em>Valor</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100418212270304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.D'
,p_message_language=>'es'
,p_message_text=>'Elemento = Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100418367285304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_EQ_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si el valor del elemento es igual que el texto que ha introducido en el atributo <em>Valor</em>.<br>',
'Falla si el valor del elemento no es igual que el texto que ha introducido en el atributo <em>Valor</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100418643324304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento est\00E1 incluido en Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100418724820304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_IN_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor del elemento est\00E1 totalmente incluido en el texto que ha introducido en el atributo <em>Valor</em>.<br>'),
unistr('Falla si el valor del elemento no est\00E1 totalmente incluido en el texto que ha introducido en el atributo <em>Valor</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100418437003304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.D'
,p_message_language=>'es'
,p_message_text=>'Elemento != Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100418530312304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_EQ_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si el valor del elemento no es igual que el texto que ha introducido en el atributo <em>Valor</em>.<br>',
'Falla si el valor del elemento es igual que el texto que ha introducido en el atributo <em>Valor</em>.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100418802910304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento NO est\00E1 incluido en Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100418945966304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IN_VALIDATION_NOT_IN_STRING2.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor del elemento no est\00E1 totalmente incluido en el texto que ha introducido en el atributo <em>Valor</em>.<br>'),
unistr('Falla si el valor del elemento est\00E1 totalmente incluido en el texto que ha introducido en el atributo <em>Valor</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100417499081304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es alfanum\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100417502891304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_ALPHANUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor del elemento es alfanum\00E9rico, es decir, contiene solo letras y n\00FAmeros y ning\00FAn car\00E1cter especial.<br>'),
'Falla si el valor del elemento incluye caracteres especiales.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100417854996304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es una fecha v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100417957630304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_DATE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor del elemento es una fecha v\00E1lida.<br>'),
unistr('Falla si el valor del elemento no es una fecha v\00E1lida.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100417679986304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100417706848304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_NUMERIC.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor del elemento es num\00E9rico.<br>'),
unistr('Falla si el valor del elemento contiene caracteres no num\00E9ricos, incluidos los espacios, excepto los espacios iniciales.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100418045882304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento es un registro de hora v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100418150613304881)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_IS_TIMESTAMP.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor del elemento es un registro de hora v\00E1lido.<br>'),
unistr('Falla si el valor del elemento no es un registro de hora v\00E1lido.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100416621919304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.D'
,p_message_language=>'es'
,p_message_text=>'El elemento es NO NULO'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100416754913304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor del elemento no est\00E1 vac\00EDo.<br>'),
unistr('Falla si el valor del elemento est\00E1 vac\00EDo.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100416883827304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento NO es NULO ni cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100416915477304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_NULL_OR_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor del elemento no est\00E1 vac\00EDo y no es el n\00FAmero cero.<br>'),
unistr('Falla si el valor del elemento est\00E1 vac\00EDo o es el n\00FAmero cero.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100417036413304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.D'
,p_message_language=>'es'
,p_message_text=>'El elemento NO es cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100417180936304880)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.ITEM_NOT_ZERO.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor del elemento no es el n\00FAmero cero.<br>'),
unistr('Falla si el valor del elemento es el n\00FAmero cero.')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100415814287304879)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.D'
,p_message_language=>'es'
,p_message_text=>'Ninguna Fila Devuelta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100415985413304879)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.NOT_EXISTS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Se aprueba si la consulta SQL no devuelve ninguna fila.<br>',
unistr('Falla si la consulta SQL devuelve una o m\00E1s filas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100416065334304879)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.D'
,p_message_language=>'es'
,p_message_text=>'Error PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100416179140304879)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.PLSQL_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el c\00F3digo PL/SQL se ejecuta sin generar un error.<br>'),
unistr('Falla si la expresi\00F3n PL/SQL genera un error cuando se ejecuta.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100419669482304882)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento coincide con la expresi\00F3n regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100419715173304882)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.LOV.REGULAR_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Se aprueba si el valor del elemento coincide con la expresi\00F3n regular que ha introducido en el atributo <em>Valor</em>.<br>'),
unistr('Falla si el valor del elemento no coincide con la expresi\00F3n regular que ha introducido en el atributo <em>Valor</em>.'),
'Nota: las expresiones regulares permiten buscar patrones en los datos de cadena mediante convenciones de sintaxis estandarizadas, en lugar de mediante sencillas comparaciones de caracteres.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99958805349304493)
,p_name=>'PE.PROPERTY.VALIDATION_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100144051043304673)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione si la l\00EDnea base del eje empieza en el valor m\00EDnimo de los datos o en cero. Solo se aplica a los ejes de datos num\00E9ricos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100144118291304673)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.MIN.D'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100144248662304674)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.LOV.ZERO.D'
,p_message_language=>'es'
,p_message_text=>'Cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100143945958304673)
,p_name=>'PE.PROPERTY.VALUE_BASELINE_SCALING.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Escala de L\00EDnea Base')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100175715289304697)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el nombre de la recopilaci\00F3n. El origen para este valor de par\00E1metro se basar\00E1 en el valor de la columna CLOB de la primera fila de la recopilaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100175618861304697)
,p_name=>'PE.PROPERTY.VALUE_COLLECTION.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100130359119304663)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Indique la moneda que se utilizar\00E1 al formatear el valor en el gr\00E1fico.'),
unistr('        El valor debe ser un c\00F3digo de moneda alfab\00E9tico ISO 4217. Si el formato se define en moneda y no se define ninguna moneda en la propiedad <strong>Moneda</strong>, la moneda se derivar\00E1 autom\00E1ticamente del idioma de aplicaci\00F3n cuando se repre')
||unistr('sente el gr\00E1fico.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100130207606304663)
,p_name=>'PE.PROPERTY.VALUE_CURRENCY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Moneda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100256419109304759)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el n\00FAmero de posiciones decimales que se aplicar\00E1 al valor num\00E9rico en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100244047643304749)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el n\00FAmero de posiciones decimales que desea utilizar en las etiquetas de valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100243978314304749)
,p_name=>'PE.PROPERTY.VALUE_DECIMAL_PLACES.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Posiciones Decimales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100632715153305039)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para evaluar la expresi\00F3n introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100633122954305040)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100633028723305039)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100632997118305039)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100633224467305040)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100632843674305039)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100632609111305039)
,p_name=>'PE.PROPERTY.VALUE_EXPRESSION_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100130740862304663)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el comportamiento de escala del valor en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100130980146304664)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100131273863304664)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.BILLION.D'
,p_message_language=>'es'
,p_message_text=>'Mil Millones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100131109942304664)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.MILLION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Mill\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100130865755304664)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.NONE.D'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100131448999304664)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.QUADRILLION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuatrill\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100131097029304664)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.THOUSAND.D'
,p_message_language=>'es'
,p_message_text=>'Mil'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100131380912304664)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.LOV.TRILLION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Bill\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100130633618304663)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_SCALING.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Escala de Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100256348926304759)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el tipo de formato que se aplicar\00E1 al valor del gr\00E1fico.'),
unistr('        Los tipos de formato <strong>Decimal</strong>, <strong>Porcentaje</strong> o <strong>Moneda</strong> solo se aplican a valores num\00E9ricos.'),
unistr('        Los tipos de formato <strong>Fecha</strong>, <strong>Hora</strong> y <strong>Fecha y hora</strong> solo se aplicar\00E1n a valores de ese tipo de dato en el gr\00E1fico.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100128742302304662)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de formato num\00E9rico, de fecha y/u hora que se aplicar\00E1 al valor en el gr\00E1fico. Para el formato de fecha y/u hora, aseg\00FArese de que el atributo de gr\00E1fico <strong>Tipo de Eje de Tiempo</strong> est\00E1 definido en uno de los siguientes')
||unistr(' valores, seg\00FAn los datos del gr\00E1fico:<strong>Activado</strong>, <strong>Frecuencia Mixta</strong> u <strong>Omitir Intervalos</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100130026591304663)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.D'
,p_message_language=>'es'
,p_message_text=>'Moneda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100267303192304767)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.CURRENCY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Al proporcionar a un n\00FAmero un formato de moneda, la propiedad de moneda se debe definir para especificar la moneda que se utilizar\00E1 al formatear el n\00FAmero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100129170711304662)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.D'
,p_message_language=>'es'
,p_message_text=>'Fecha: Completo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100266237260304766)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-FULL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al proporcionar a la fecha un formato completo, la fecha con formato contendr\00E1 d\00EDa de la semana largo (EEEE), el a\00F1o (a), el mes largo (MMMM), el d\00EDa (d). Por ejemplo, Mi\00E9rcoles, 6 de enero de 2016.'),
unistr('        Para algunos idiomas, no se utilizan los meses largos; por ejemplo, en japon\00E9s el mes num\00E9rico se utiliza en patrones.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100129083100304662)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.D'
,p_message_language=>'es'
,p_message_text=>'Fecha: Largo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100266109133304766)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-LONG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Al proporcionar a la fecha un formato largo, la fecha con formato contendr\00E1 el a\00F1o, el mes largo, el d\00EDa. Por ejemplo, 6 de enero de 2016.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100128981454304662)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.D'
,p_message_language=>'es'
,p_message_text=>'Fecha: Medio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100266074688304766)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-MEDIUM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al proporcionar a la fecha un formato medio, la fecha con formato contendr\00E1 el a\00F1o, el mes abreviado (MMM), el d\00EDa. Por ejemplo, 6 de ene de 2016.'),
unistr('        Para algunos idiomas, no se utilizan los meses abreviados; en ese caso, el formato medio contendr\00E1 el mes num\00E9rico, (MM/M).')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100128810923304662)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.D'
,p_message_language=>'es'
,p_message_text=>'Fecha: Corto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100265903516304766)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATE-SHORT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Al proporcionar a la fecha un formato abreviado, la fecha con formato contendr\00E1 el a\00F1o, el mes num\00E9rico (MM/M), el d\00EDa. Por ejemplo, 1/6/16.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100267082143304767)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.D'
,p_message_language=>'es'
,p_message_text=>'Fecha/Hora: Completa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100267176570304767)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-FULL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al proporcionar a la fecha/hora un formato completo, la fecha/hora con formato contendr\00E1 el d\00EDa de la semana largo (EEEE), el a\00F1o (a), el mes largo (MMMM), el d\00EDa (d), la hora (h/H), los minutos (mm), los segundos (ss) y la zona (zzzz). Por ejemplo, ')
||unistr('Mi\00E9rcoles, 6 de enero de 2016 7 h 30 min 21 s.'),
unistr('        El formato de hora depende de si el idioma de la aplicaci\00F3n utiliza la hora en formato de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100129817331304663)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.D'
,p_message_language=>'es'
,p_message_text=>'Fecha y Hora: Largo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100266948584304767)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-LONG.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al proporcionar a la fecha/hora un formato largo, la fecha/hora con formato contendr\00E1 el a\00F1o, el mes largo, el d\00EDa, la hora, los segundos y la zona. Por ejemplo, 6 de Ene de 2016 7:30:21 a.m.'),
unistr('        El formato de hora depende de si el idioma de la aplicaci\00F3n utiliza la hora en formato de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100129700750304663)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.D'
,p_message_language=>'es'
,p_message_text=>'Fecha y Hora: Medio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100266871138304767)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-MEDIUM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al proporcionar a la fecha/hora un formato medio, la fecha-hora con formato contendr\00E1 el a\00F1o, el mes abreviado (MMM), el d\00EDa, la hora, los minutos, los segundos y la zona. Por ejemplo, 6 de Ene de 2016 7:30:21 a.m.'),
unistr('        El formato de hora depende de si el idioma de la aplicaci\00F3n utiliza la hora en formato de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100129633671304663)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.D'
,p_message_language=>'es'
,p_message_text=>'Fecha y Hora: Corto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100266711356304767)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DATETIME-SHORT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al proporcionar a la fecha/hora un formato abreviado, la fecha/hora con formato contendr\00E1 el a\00F1o, el mes num\00E9rico (MM/M), el d\00EDa, la hora, los minutos. Por ejemplo 1/6/16 7:30 AM.'),
unistr('        El formato de hora depende de si el idioma de la aplicaci\00F3n utiliza hora en formato de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100129998950304663)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.D'
,p_message_language=>'es'
,p_message_text=>'Decimal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100267288822304767)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.DECIMAL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Al proporcionar a un n\00FAmero un formato decimal, el car\00E1cter decimal se sustituye por el s\00EDmbolo m\00E1s apropiado para la configuraci\00F3n regional. En ingl\00E9s es un punto decimal ("."), mientras que en muchas configuraciones regionales es una coma decimal (')
||'",").'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100130170816304663)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.D'
,p_message_language=>'es'
,p_message_text=>'Porcentaje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100267495354304767)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Al proporcionar a un n\00FAmero un formato de porcentaje, los valores en el gr\00E1fico se multiplican por 100 para aplicar el formato de porcentaje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100129526535304662)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.D'
,p_message_language=>'es'
,p_message_text=>'Hora: Completo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100266608455304766)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-FULL.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al proporcionar a la hora un formato completo, la hora con formato contendr\00E1 la hora (h/H), los minutos (mm), segundos (ss) y la zona (zzzz). Por ejemplo 7 h 30 min 21 s.'),
unistr('        El formato de hora depende de si el idioma de la aplicaci\00F3n utiliza la hora en formato de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100129448036304662)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.D'
,p_message_language=>'es'
,p_message_text=>'Hora: Largo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100266526540304766)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-LONG.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al proporcionar a la hora un formato largo, la hora con formato contendr\00E1 la hora, los minutos, los segundos y la zona. Por ejemplo 7:30:21 a.m.'),
unistr('        El formato de hora depende de si el idioma de la aplicaci\00F3n utiliza hora en formato de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100129340421304662)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.D'
,p_message_language=>'es'
,p_message_text=>'Hora: Medio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100266434316304766)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-MEDIUM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al proporcionar a la fecha un formato medio, la hora con formato contendr\00E1 la hora, los minutos, los segundos. Por ejemplo 7:30:21 a.m.'),
unistr('        El formato de hora depende de si el idioma de la aplicaci\00F3n utiliza hora en formato de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100129207646304662)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.D'
,p_message_language=>'es'
,p_message_text=>'Hora: Corto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100266336891304766)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.LOV.TIME-SHORT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al proporcionar a la hora un formato abreviado, la hora con formato contendr\00E1 la hora, los minutos. Por ejemplo 7:30 a.m.'),
unistr('        El formato de hora depende de si el idioma de la aplicaci\00F3n utiliza hora en formato de 12 horas.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100128607378304662)
,p_name=>'PE.PROPERTY.VALUE_FORMAT_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Formato'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100634702482305041)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el lenguaje que se va a utilizar para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100635046441305041)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100634929783305041)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100634854126305041)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100635102697305041)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100634617381305041)
,p_name=>'PE.PROPERTY.VALUE_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100172639782304695)
,p_name=>'PE.PROPERTY.VALUE_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina utilizado como origen para este valor de par\00E1metro.'),
'Puede introducir el nombre o seleccionarlo de la lista de elementos disponibles.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100172548481304695)
,p_name=>'PE.PROPERTY.VALUE_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100634359119305040)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Java que produzca un valor utilizado como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100634205690305040)
,p_name=>'PE.PROPERTY.VALUE_JAVA_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100635961475305042)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n Java que devuelva un valor utilizado como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100635894052305042)
,p_name=>'PE.PROPERTY.VALUE_JAVA_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100634146688305040)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB === "MANAGER" ? "YES" : "NO" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100634063581305040)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n JavaScript que produzca un valor utilizado como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100633983880305040)
,p_name=>'PE.PROPERTY.VALUE_JS_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100635744436305041)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'let deptno,',
'    rows;',
'',
'rows = apex.conn.execute( "select deptno from emp empno = :1", [ apex.env.P2_EMPNO ] ).rows;',
'for (var row of rows) {',
'  deptno = row.DEPTNO;',
'}',
'',
'return ( deptno === 30 ? "YES", "NO" );',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100635690847305041)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n JavaScript que devuelva un valor utilizado como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100635567442305041)
,p_name=>'PE.PROPERTY.VALUE_JS_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100128575925304662)
,p_name=>'PE.PROPERTY.VALUE_MIN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique un valor m\00EDnimo para el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100128430063304662)
,p_name=>'PE.PROPERTY.VALUE_MIN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100256574499304759)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique el patr\00F3n num\00E9rico que se aplicar\00E1 al valor num\00E9rico en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100748266404305129)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Patr\00F3n num\00E9rico para representar la temperatura en farenheit, por ejemplo 15&deg;F:</dt>'),
'<dd><pre>',
'#&deg;F',
'</pre></dd>',
unistr('<dt>Patr\00F3n num\00E9rico para representar n\00FAmeros en un formato espec\00EDfico, por ejemplo, 12,30,00:</dt>'),
'<dd><pre>',
'##,##,##',
'</pre></dd>',
unistr('<dt>Patr\00F3n num\00E9rico para representar n\00FAmeros en mil\00EDmetros:</dt>'),
'<dd><pre>',
'# mm',
'</pre></dd>',
unistr('<dt>Patr\00F3n de fecha para representar la fecha como mes y a\00F1o, por ejemplo, Jul 2016:</dt>'),
'<dd><pre>',
'MMM yyyy',
'</pre></dd>',
unistr('<dt>Patr\00F3n de fecha para representar la fecha como mes, por ejemplo, Julio:</dt>'),
'<dd><pre>',
'MMMM',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100130544988304663)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca un patr\00F3n de fecha o num\00E9rico localizado opcional, cuyos caracteres cumplan con la norma Unicode CLDR para los formatos de fecha y hora.'),
unistr('        Cuando est\00E9 presente, se sustituir\00E1 el formato seleccionado.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100130463316304663)
,p_name=>'PE.PROPERTY.VALUE_NUMERIC_PATTERN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Patr\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100633809624305040)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'case when ( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' ) then ''YES'' else ''NO'' end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100633700588305040)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n PL/SQL que produzca un valor utilizado como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100633679903305040)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100635414934305041)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para devolver YES cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'declare',
'    l_deptno number;',
'begin',
'    select deptno',
'      into l_deptno',
'      from emp',
'     where empno = :P2_EMPNO;',
'',
'    if l_deptno = 30 then',
'        return ''YES'';',
'    else',
'        return ''NO'';',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100635375055305041)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n PL/SQL que devuelva un valor utilizado como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100635254413305041)
,p_name=>'PE.PROPERTY.VALUE_PLSQL_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99601995128304221)
,p_name=>'PE.PROPERTY.VALUE_POSITION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique la posici\00F3n en la que se debe mostrar el valor en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99601365876304220)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.D'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99602004965304221)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.AUTO.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>El valor se mostrar\00E1 en la posici\00F3n por defecto del gr\00E1fico, es decir, fuera del \00E1rea de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99601463851304220)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.D'
,p_message_language=>'es'
,p_message_text=>'Centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99602188080304221)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.CENTER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>El valor se mostrar\00E1 en el centro del indicador en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99601549536304220)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.D'
,p_message_language=>'es'
,p_message_text=>'Dentro del borde del indicador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99602239921304221)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.INSIDEINDICATOREDGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>El valor se mostrar\00E1 dentro del borde del indicador en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99601663198304220)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.D'
,p_message_language=>'es'
,p_message_text=>'Fuera del borde del indicador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99602300811304221)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEINDICATOREDGE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>El valor se mostrar\00E1 fuera del borde del indicador en el gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99601795488304220)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.D'
,p_message_language=>'es'
,p_message_text=>unistr('Fuera del \00E1rea de datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99602486140304221)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.OUTSIDEPLOTAREA.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>El valor se mostrar\00E1 fuera del \00E1rea de datos del gr\00E1fico.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99601814830304221)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.D'
,p_message_language=>'es'
,p_message_text=>'Con etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99602543256304221)
,p_name=>'PE.PROPERTY.VALUE_POSITION.LOV.WITHLABEL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Si la etiqueta se representa, el valor se mostrar\00E1 en la misma posici\00F3n que la etiqueta. Si la etiqueta no se representa, el valor se mostrar\00E1 fuera del \00E1rea de datos del gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99601233908304220)
,p_name=>'PE.PROPERTY.VALUE_POSITION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100172877463304695)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la preferencia de usuario que se utilizar\00E1 como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100172708782304695)
,p_name=>'PE.PROPERTY.VALUE_PREFERENCE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Preferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100634537671305041)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Python que produzca un valor utilizado como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100634428202305040)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100636187581305042)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el cuerpo de la funci\00F3n Python que devuelva un valor utilizado como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100636046164305042)
,p_name=>'PE.PROPERTY.VALUE_PYTHON_FUNC_BODY_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100172401282304695)
,p_name=>'PE.PROPERTY.VALUE_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la consulta SQL que se ha utilizado como origen para este valor de par\00E1metro. Si el sistema devuelve m\00E1s de una fila, se utilizar\00E1 el valor de la primera fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100172336687304695)
,p_name=>'PE.PROPERTY.VALUE_QUERY.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99859705219304415)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si se define en <strong>Activado</strong> y el elemento de p\00E1gina es visible, &PRODUCT_NAME. realiza autom\00E1ticamente una validaci\00F3n no nula cuando se ejecute la p\00E1gina.</p>'),
unistr('<p>Si define un mensaje denominado <strong>APEX.PAGE_ITEM_IS_REQUIRED</strong> en Componentes Compartidos > Mensajes de Texto, el texto de error predefinido se puede sustituir por un mensaje de error espec\00EDfico de la aplicaci\00F3n.</p>'),
unistr('<p>La ubicaci\00F3n de visualizaci\00F3n del mensaje est\00E1 definida con el valor de nivel de aplicaci\00F3n <strong>Ubicaci\00F3n de Visualizaci\00F3n de Error Por Defecto</strong>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99859672769304415)
,p_name=>'PE.PROPERTY.VALUE_REQUIRED.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor Necesario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100633503243305040)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'<dl><dt>Para devolver YES cuando el empleado es un gestor y su departamento se encuentra en Chicago:</dt>',
'<dd><pre>',
'case',
'when :P2_JOB = ''MANAGER'' and',
'     exists ( select 1',
'                from dept',
'               where deptno = :P2_DEPTNO',
'                 and loc    = ''CHICAGO'' ) then ''YES''',
'else ''NO''',
'end',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100633472777305040)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n SQL que produzca un valor utilizado como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100633319620305040)
,p_name=>'PE.PROPERTY.VALUE_SQL_EXPRESSION_VARCHAR2.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100172220174304695)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor est\00E1tico utilizado como origen para este valor de par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100172168048304695)
,p_name=>'PE.PROPERTY.VALUE_STATIC_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100254573354304757)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Especifique c\00F3mo se debe mostrar en el gr\00E1fico el valor, como un n\00FAmero o como un porcentaje del valor total.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100254315888304757)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.D'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100256866062304759)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.NUMBER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>El valor aparecer\00E1 como un n\00FAmero en el gr\00E1fico.</p> <p>Nota: El atributo <strong>Formato</strong> solo se debe usar para aplicar formato decimal o de moneda personalizado a la etiqueta y al valor mostrados en el gr\00E1fico.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100254496392304757)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.D'
,p_message_language=>'es'
,p_message_text=>'Porcentaje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100256916626304759)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.LOV.PERCENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>El valor aparecer\00E1 como un porcentaje entre el 0% y el 100%.</p> <p>Nota: Si <strong>Formato</strong> est\00E1 definido en <strong>Porcentaje</strong>, los valores del gr\00E1fico se multiplican por 100 para aplicarles el formato de porcentaje. Si desea u')
||unistr('tilizar el atributo Tipo de formato, aseg\00FArese de que Tipo de etiqueta est\00E1 definido en n\00FAmero.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100254293691304757)
,p_name=>'PE.PROPERTY.VALUE_TEXT_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo de Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100170684429304693)
,p_name=>'PE.PROPERTY.VALUE_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el modo de relleno del par\00E1metro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100175434911304697)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Recopilaci\00F3n (CLOB)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100175567883304697)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.COLLECTION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de columna CLOB de la primera fila de la <em>recopilaci\00F3n</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100452510202304906)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.D'
,p_message_language=>'es'
,p_message_text=>'Valor por defecto de origen de REST'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100452656179304906)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.DEFAULT.HELP'
,p_message_language=>'es'
,p_message_text=>'Use el valor definido como valor por defecto en el origen de datos de REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100170969539304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100171096670304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor de estado de sesi\00F3n del <em>elemento</em> seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100171981449304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.D'
,p_message_language=>'es'
,p_message_text=>'Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100172039403304695)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.NULL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Defina el valor como nulo ya que no se ha especificado ning\00FAn valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100171351103304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100171497440304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor resultante al ejecutar la <em>expresi\00F3n PL/SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100171583558304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100171617089304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PLSQL_FUNCTION_BODY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el valor devuelto desde el <em>cuerpo de la funci\00F3n PL/SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100171746513304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.D'
,p_message_language=>'es'
,p_message_text=>'Preferencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100171860296304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.PREFERENCE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn la <em>preferencia</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100171173219304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.D'
,p_message_language=>'es'
,p_message_text=>unistr('Consulta SQL (devolver valor \00FAnico)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100171275132304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.SQL_QUERY.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el primer valor devuelto desde la <em>consulta SQL</em> introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100170778912304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.D'
,p_message_language=>'es'
,p_message_text=>unistr('Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100170846418304694)
,p_name=>'PE.PROPERTY.VALUE_TYPE.LOV.STATIC.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Def\00EDnalo seg\00FAn el texto introducido en <em>Valor Est\00E1tico</em>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100170518960304693)
,p_name=>'PE.PROPERTY.VALUE_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100623753946305033)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para evaluar la expresi\00F3n introducida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100624138747305033)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100624075346305033)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100623990690305033)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100624224339305033)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100623835121305033)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.LOV.SQL.D'
,p_message_language=>'es'
,p_message_text=>'SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100623601664305033)
,p_name=>'PE.PROPERTY.VAL_EXPRESSION_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100625786827305034)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100626005629305034)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100625966235305034)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100625857814305034)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100626175968305034)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100625613519305034)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100622175957305031)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un lenguaje que se use para ejecutar el cuerpo de la funci\00F3n introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100622427919305032)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVA.D'
,p_message_language=>'es'
,p_message_text=>'Java (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100622303201305032)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.JAVASCRIPT.D'
,p_message_language=>'es'
,p_message_text=>'JavaScript (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100622296562305031)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PLSQL.D'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100622507927305032)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.LOV.PYTHON.D'
,p_message_language=>'es'
,p_message_text=>'Python (MLE)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100622068377305031)
,p_name=>'PE.PROPERTY.VAL_FUNC_BODY_LANG_ERROR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100318511042304805)
,p_name=>'PE.PROPERTY.VAL_ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un elemento de aplicaci\00F3n o p\00E1gina utilizado en esta validaci\00F3n. Puede escribir el nombre o seleccionarlo de la lista de elementos disponibles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100318459761304805)
,p_name=>'PE.PROPERTY.VAL_ITEM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100625360198305034)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Java para definir la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100625239278305034)
,p_name=>'PE.PROPERTY.VAL_JAVA_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100626994498305035)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n Java que devuelve un valor BOOLEAN como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100626815402305035)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100623332194305032)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Java que devuelve el texto de mensaje de error como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100623251899305032)
,p_name=>'PE.PROPERTY.VAL_JAVA_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Java que devuelve texto de error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100625108440305034)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error, cuando el empleado est\00E9 en el departamento 30 o sea un gestor:</dt>'),
'<dd><pre>',
'( apex.env.P2_DEPTNO === "30" || apex.env.P2_JOB == "MANAGER" )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100625047944305034)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n JavaScript para definir la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100624983214305033)
,p_name=>'PE.PROPERTY.VAL_JS_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100626755567305035)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error, cuando el empleado est\00E9 en el departamento 30:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO === "30" ) {',
'    return true;',
'} else {',
'    return false;',
'}',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100626625987305035)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n JavaScript que devuelve un valor BOOLEAN como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100626529418305035)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100623146569305032)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error especificado, cuando el empleado est\00E9 en el departamento 30:</dt>'),
'<dd><pre>',
'if ( apex.env.P2_DEPTNO !== "30" ) {',
'    return "Employee is in Department " + apex.env.P2_DEPTNO + " and not Department 30";',
'}',
'return "";',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100623041974305032)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n JavaScript que devuelve el texto de mensaje de error como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100622928263305032)
,p_name=>'PE.PROPERTY.VAL_JS_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n JavaScript que devuelve texto de error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100743479890305126)
,p_name=>'PE.PROPERTY.VAL_PLSQL.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error especificado, cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        raise_application_error( -20000, ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'' );',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100318392840304805)
,p_name=>'PE.PROPERTY.VAL_PLSQL.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n PL/SQL que genera error como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100318271679304805)
,p_name=>'PE.PROPERTY.VAL_PLSQL.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo PL/SQL que Genera un Error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100624814872305033)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error, cuando el empleado est\00E1 en el departamento 30 o es un gestor:</dt>'),
'<dd><pre>',
'( :P2_DEPTNO = 30 or :P2_JOB = ''MANAGER'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100624769030305033)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n PL/SQL para definir la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100624667215305033)
,p_name=>'PE.PROPERTY.VAL_PLSQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100626464521305035)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error, cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO = 30 then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100626335016305035)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n PL/SQL que devuelve un valor BOOLEAN como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100626224482305034)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100622853508305032)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error especificado, cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'begin',
'    if :P2_DEPTNO <> 30 then',
'        return ''Employee is in Department '' || :P2_DEPTNO || '' and not Department 30'';',
'    end if;',
'    return null;',
'end;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100622754266305032)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n PL/SQL que devuelve el texto de mensaje de error como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100622603834305032)
,p_name=>'PE.PROPERTY.VAL_PLSQL_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la Funci\00F3n PL/SQL que Devuelve Texto de Error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100625522941305034)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n Python para definir la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100625459646305034)
,p_name=>'PE.PROPERTY.VAL_PYTHON_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100627105126305035)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de la funci\00F3n Python que devuelve un valor BOOLEAN como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100627053923305035)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100623502716305032)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un cuerpo de funci\00F3n Python que devuelve el texto de mensaje de error como base de esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100623488030305032)
,p_name=>'PE.PROPERTY.VAL_PYTHON_FUNC_BODY_ERROR.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de la funci\00F3n Python que devuelve texto de error')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100318989246304805)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n regular utilizada con la que debe coincidir el elemento especificado para esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100318883457304805)
,p_name=>'PE.PROPERTY.VAL_REGULAR_EXPRESSION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n Regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100624564756305033)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para aprobar la validaci\00F3n y que no se muestre un mensaje de error, cuando el empleado es un gestor o el departamento se encuentra en Chicago:</dt>'),
'<dd><pre>',
':P2_JOB = ''MANAGER'' or',
'exists ( select 1',
'           from dept',
'          where deptno = :P2_DEPTNO',
'            and loc    = ''CHICAGO'' )',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100624440949305033)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una expresi\00F3n SQL para definir la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100624345788305033)
,p_name=>'PE.PROPERTY.VAL_SQL_EXPRESSION_BOOLEAN.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100743306846305126)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
unistr('<dl><dt>Para que con <strong>Filas Devueltas</strong> se apruebe la validaci\00F3n y no muestre un mensaje de error, cuando el empleado est\00E1 en el departamento 30:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno = 30',
'</pre></dd>',
unistr('<dt>Para que <strong>Ninguna fila devuelta</strong, apruebe la validaci\00F3n y no muestre un mensaje de error, cuando el empleado est\00E1 en el departamento 40:</dt>'),
'<dd><pre>',
'select 1',
'  from emp',
' where empno  = :P2_EMPNO',
'   and deptno <> 40',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100318170633304805)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una consulta SQL para definir esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100318001972304805)
,p_name=>'PE.PROPERTY.VAL_SQL_STATEMENT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100318776721304805)
,p_name=>'PE.PROPERTY.VAL_VALUE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el valor utilizado para comparar con el valor de la columna de elemento especificada para esta validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100318677605304805)
,p_name=>'PE.PROPERTY.VAL_VALUE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100449472604304903)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Restringir el uso de una aplicaci\00F3n a determinadas horas laborables</dt>'),
'<dd><pre>',
'function check_business_hours return boolean',
'is',
'begin',
'    return to_char(to_char(sysdate, ''hh24:mi'')) between ''08:00'' and ''17:00'';',
'end check_business_hours;',
'</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99942105278304480)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el nombre de la funci\00F3n a la que se llama despu\00E9s de que se haya realizado correctamente la funci\00F3n de protecci\00F3n de sesi\00F3n.'),
unistr('La funci\00F3n se puede definir en el atributo "C\00F3digo PL/SQL" o en la base de datos.'),
unistr('El resultado debe ser un valor booleano, "True" que representa que se ha verificado el usuario y "False" que significa que ha fallado la verificaci\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99942089462304480)
,p_name=>'PE.PROPERTY.VERIFY_FUNCTION_NAME.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de Funci\00F3n de Verificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99879733666304431)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si todas las acciones pendientes tienen que esperar el resultado de la acci\00F3n actual.'),
unistr('Defina este atributo en <strong>Activado</strong> si las acciones pendientes dependen del resultado de esta acci\00F3n'),
unistr('o en <strong>Desactivado</strong> si no hay ninguna dependencia y se pueden ejecutar de forma as\00EDncrona, sin necesidad de esperar.</p>'),
unistr('<p>Nota: el orden de ejecuci\00F3n de acciones espec\00EDficas se determina por la secuencia especificada en cada acci\00F3n.'),
unistr('Para asegurarse de que las acciones se ejecutan en el mismo orden, Oracle recomienda que los n\00FAmeros de secuencia sean \00FAnicos para todas las acciones verdaderas y todas las falsas.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99879698419304431)
,p_name=>'PE.PROPERTY.WAIT_FOR_RESULT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Espera de Resultados'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99967729178304500)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Identifica si el origen de datos de REST tiene una tabla de sincronizaci\00F3n local')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99967632332304500)
,p_name=>'PE.PROPERTY.WEB_SRC_HAS_LOCAL_TABLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('El origen de datos de REST tiene una tabla de sincronizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100170442574304693)
,p_name=>'PE.PROPERTY.WEB_SRC_PARAM.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99967902502304500)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Active esto para utilizar la tabla local, configurada en la secci\00F3n de <strong>sincronizaci\00F3n</strong> de origen de datos de REST, en lugar de comunicarse con el servicio REST externo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99967828965304500)
,p_name=>'PE.PROPERTY.WEB_SRC_USE_LOCAL_TABLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Utilizar tabla de sincronizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99853948370304410)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el bot\00F3n que disparar\00E1 la acci\00F3n din\00E1mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99853848539304410)
,p_name=>'PE.PROPERTY.WHEN_BUTTON.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99958657636304493)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Si desea que este componente de procesamiento de p\00E1ginas se ejecute solo al hacer clic en el bot\00F3n especificado, seleccione un bot\00F3n de la lista. Puede incorporar esta condici\00F3n de bot\00F3n con otras condiciones para acotar a\00FAn m\00E1s cuando se ejecute est')
||unistr('e componente de procesamiento de p\00E1ginas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99958555943304493)
,p_name=>'PE.PROPERTY.WHEN_BUTTON_PRESSED.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Si Se Hace Clic en el Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100715394302305105)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca una o varias columnas para disparar la acci\00F3n din\00E1mica.'),
'Si hay varias columnas, separe cada nombre de elemento con una coma.',
'Puede escribir el nombre o seleccionarlo de la lista de columnas disponibles.',
'Si lo selecciona de la lista y ya se ha introducido texto, se coloca una coma al final del texto existente, seguido del nombre de la columna que se ha devuelto de la lista.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100715272192305105)
,p_name=>'PE.PROPERTY.WHEN_COLUMNS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Columna(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99854377313304410)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique un objeto DOM (<code>document</code>, <code>window</code>) o el <em>ID</em> de un objeto DOM (<code>myElementID</code>), de modo que sea el elemento que disparar\00E1 la acci\00F3n din\00E1mica.</p>'),
unistr('<p>Nota: el <em>objeto DOM</em> est\00E1 en desuso y se debe sustituir por <em>Expresi\00F3n JavaScript</em> o <em>Selector de jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99854281328304410)
,p_name=>'PE.PROPERTY.WHEN_DOM_OBJECT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Objeto DOM'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99854150820304410)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca los elementos de aplicaci\00F3n o p\00E1gina que disparan la acci\00F3n din\00E1mica.'),
'Si hay varios elementos, separe cada nombre de elemento por una coma.',
'Puede escribir el nombre o seleccionarlo de la lista de elementos disponibles.',
'Si lo selecciona de la lista y ya hay texto introducido, se coloca una coma al final del texto existente, seguido del nombre de elemento que se ha devuelto de la lista.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99854089205304410)
,p_name=>'PE.PROPERTY.WHEN_ITEMS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100711074149305102)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Devuelve una referencia al objeto DOM <code>window</code> del explorador.</dt>',
'<dd><code>window</code></dd>',
'<dt>Devuelve una referencia al objeto DOM <code>document</code> del explorador.</dt>',
'<dd><code>document</code></dd>',
unistr('<dt>El selector jQuery selecciona todos los elementos DIV que tiene una clase de ''alerta'' y, a continuaci\00F3n, devuelve un objeto jQuery que contiene todos sus principales.</dt>'),
'<dd><code>$( "div.alert" ).parent()</code></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100710920067305101)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca la expresi\00F3n JavaScript que se va a evaluar para devolver un \00FAnico objeto DOM, una matriz de objetos DOM o un objeto jQuery de modo que sean los elementos que disparar\00E1n la acci\00F3n din\00E1mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100710831982305101)
,p_name=>'PE.PROPERTY.WHEN_JAVASCRIPT_EXPRESSION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100365758323304840)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.EXAMPLES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Para seleccionar un elemento de p\00E1gina con un ID DOM <code>my_id</code></dt>'),
'<dd><pre>#my_id</pre></dd>',
unistr('<dt>Para seleccionar todos los elementos de p\00E1gina con una clase <code>my_class</code></dt>'),
'<dd><pre>.my_class</pre></dd>',
unistr('<dt>Para seleccionar todos los elementos de p\00E1gina que son entradas</dt>'),
'<dd><pre>input</pre></dd>',
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99854529563304411)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la sintaxis jQuery Selector a fin de devolver uno o varios elementos de p\00E1gina para disparar la acci\00F3n din\00E1mica. La biblioteca jQuery ofrece una sintaxis de selector muy potente que proporciona un modo de acceso sencillo a uno o varios ')
||unistr('elementos de una p\00E1gina.</p>'),
unistr('<p>Consulte la documentaci\00F3n oficial disponible en la <a rel="noreferrer" target="_blank" href="http://docs.jquery.com">p\00E1gina inicial de jQuery</a> para obtener informaci\00F3n adicional acerca de la sintaxis del selector.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99854463492304411)
,p_name=>'PE.PROPERTY.WHEN_JQUERY_SELECTOR.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Selector de jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100091111247304594)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IG_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el mensaje de texto que desee que se muestre al superar el l\00EDmite de <strong>M\00E1ximo de Filas para Procesar</strong>.'),
unistr('El mensaje por defecto indica a los usuarios finales que agreguen filtros adicionales para limitar el n\00FAmero de registros que se van a procesar.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100236414861304743)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.IR_ATTRIBUTES.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el mensaje de texto que se muestra cuando la consulta devuelve m\00E1s filas que el recuento de filas m\00E1ximo introducido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100517805460304954)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el mensaje de texto que desee que se muestre en el \00E1rea <strong>Mensajes</strong>, al superar el l\00EDmite de <strong>M\00E1ximo de filas para procesar</strong> para la capa. Utilice la sustituci\00F3n <strong>#MAX_ROW_COUNT#</strong> para la cantida')
||'d de filas realmente recuperadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100221785913304731)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el mensaje de texto que se muestra cuando existen m\00E1s filas de informes.'),
unistr('Utilice este enfoque como alternativa a la paginaci\00F3n, especialmente si un informe solo suele tener un juego de registros discreto.'),
unistr('Si la consulta del informe devuelve filas adicionales, este mensaje se puede utilizar para alertar al usuario final sobre la anomal\00EDa, en lugar de mostrar simplemente controles de paginaci\00F3n ligeramente diferentes.'),
unistr('El mensaje de texto puede incorporar una "Llamada a la acci\00F3n" para que los usuarios finales sepan c\00F3mo responder a este resultado de consulta inusual y puedan incluir enlaces de URL o p\00E1gina.</p>'),
unistr('<p>Las siguientes cadenas de sustituci\00F3n de la paginaci\00F3n se pueden utilizar en el mensaje:</p>'),
'<dl>',
'  <dt><code>#ROWS_FETCHED#</code></dt>',
unistr('    <dd>El n\00FAmero de filas mostradas (tama\00F1o de p\00E1gina)</dd>'),
'  <dt><code>#TOTAL_ROWS#</code></dt>',
'    <dd>La "Z" en las filas X - Y de Z"</dd>',
'  <dt><code>#FIRST_ROW_FETCHED#</code></dt>',
'    <dd>La "X" en las "filas X - Y de Z"</dd>',
'  <dt><code>#LAST_ROW_FETCHED#</code></dt>',
'    <dd>La "Y" en las "filas X - Y de Z"</dd>',
'  <dt><code>#ROW_RANGES"</code></dt>',
'    <dd>Muestra: fila(s) 1-15 16-30 30-32</dd>',
'  <dt><code>#ROW_RANGES_IN_SELECT_LIST</code></dt>',
unistr('    <dd>Igual que los rangos de fila pero en una lista de selecci\00F3n<dd>'),
'  <dt><code>#INTERNET_PAGINATION#</code></dt>',
unistr('    <dd>Juegos de p\00E1gina: 1 2 3 4 5 6</dd>'),
'</dl>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100221629741304731)
,p_name=>'PE.PROPERTY.WHEN_MORE_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Cuando se Encuentran M\00E1s Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100695402003305090)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.JET_CHART.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el mensaje de texto que desea que se muestre si la consulta del gr\00E1fico no devuelve ninguna fila. Si se deja en blanco, Oracle JET utilizar\00E1 autom\00E1ticamente el mensaje por defecto "No hay datos para mostrar".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100648233831305051)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.COMPONENT_PROPERTY.MAP_LAYER.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca el mensaje de texto que aparece en el \00E1rea <strong>Mensajes</strong> cuando la consulta de capa no devuelve ninguna fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100185896679304705)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca el mensaje de texto que desea que se muestre si la consulta no devuelve ninguna fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100185731617304705)
,p_name=>'PE.PROPERTY.WHEN_NO_DATA_FOUND_MESSAGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Cuando No Se Encuentran Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99853702623304410)
,p_name=>'PE.PROPERTY.WHEN_REGION.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el nombre de la regi\00F3n que dispara la acci\00F3n din\00E1mica.'),
unistr('Por ejemplo, puede ser una regi\00F3n de informe interactivo, que se utiliza en combinaci\00F3n con el evento ''Despu\00E9s de Refrescamiento'' para definir una acci\00F3n din\00E1mica que se dispare cada vez que se refresque el informe.</p>'),
unistr('<p> Que una regi\00F3n dispare una acci\00F3n din\00E1mica puede ser algo \00FAtil cuando se desea definir un comportamiento similar para varios elementos de p\00E1gina de una misma regi\00F3n. Sin embargo, esto solo se puede conseguir para ciertos eventos que hayan iniciad')
||unistr('o los elementos que se encuentren en dicha regi\00F3n.'),
unistr('Para obtener una lista de eventos que soportan este tipo de definici\00F3n y un ejemplo de c\00F3mo se pueden utilizar, consulte la ayuda de elementos para <em>Elementos Afectados</em> &gt; <em>Tipo de Selecci\00F3n</em> del \00C1mbito de Evento en la p\00E1gina Acci\00F3n.')
||'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99853698486304410)
,p_name=>'PE.PROPERTY.WHEN_REGION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99853588724304410)
,p_name=>'PE.PROPERTY.WHEN_TYPE.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione el tipo de elemento de p\00E1gina o construcci\00F3n que se va a utilizar como disparador del evento. Para obtener ejemplos de c\00F3mo utilizar un tipo de selecci\00F3n espec\00EDfico, consulte la ayuda del atributo asociado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100365432517304839)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.D'
,p_message_language=>'es'
,p_message_text=>unistr('Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100666885524305065)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.BUTTON.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Disparado por un bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100713571669305103)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.D'
,p_message_language=>'es'
,p_message_text=>'Columna(s)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100667099835305065)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.COLUMN.HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Disparado por una o m\00E1s columnas.'' );'),
'    --',
'    store_property_lov_values (',
'        p_property_id   => l_property_id,',
'        p_display_value => ''DOM Object'',',
'        p_return_value  => ''DOM_OBJECT'',',
'        p_is_deprecated => ''Y'',',
'        p_help_text     => q''~<p>Disparado por el objeto DOM (<code>document</code>, <code>window</code>) o el <em>ID</em> de un objeto DOM (<code>myElementID</code>).</p>',
unistr('        <p>Nota: El <em>objeto DOM</em> est\00E1 en desuso y se deber\00EDa sustituir por una <em>expresi\00F3n JavaScript</em> o un <em>selector de jQuery</em>.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100365349207304839)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.D'
,p_message_language=>'es'
,p_message_text=>'Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100666722205305065)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.ITEM.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Disparado por uno o m\00E1s elementos de la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100710275891305101)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n JavaScript')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100667268006305065)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JAVASCRIPT_EXPRESSION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Disparado por los elementos de p\00E1gina devueltos por la expresi\00F3n JavaScript.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100365663132304840)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.D'
,p_message_language=>'es'
,p_message_text=>'Selector de jQuery'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100667183304305065)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.JQUERY_SELECTOR.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Disparado por uno o m\00E1s elementos de p\00E1gina devueltos por el selector jQuery.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100365549056304839)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.D'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100666916580305065)
,p_name=>'PE.PROPERTY.WHEN_TYPE.LOV.REGION.HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Disparado por una regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99853487058304410)
,p_name=>'PE.PROPERTY.WHEN_TYPE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Selecci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99909221066304455)
,p_name=>'PENDING'
,p_message_language=>'es'
,p_message_text=>'pendiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99999695100304524)
,p_name=>'PENDING_ENTRIES'
,p_message_language=>'es'
,p_message_text=>'Entradas Pendientes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100008331356304531)
,p_name=>'PENDING_REQUESTS'
,p_message_language=>'es'
,p_message_text=>'Solicitudes Pendientes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100030406603304548)
,p_name=>'PERCENT_CLOSED'
,p_message_language=>'es'
,p_message_text=>'Porcentaje Cerrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100028323705304546)
,p_name=>'PERCENT_COMPLETE'
,p_message_language=>'es'
,p_message_text=>'Porcentaje Terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100030578196304548)
,p_name=>'PERCENT_OPENED'
,p_message_language=>'es'
,p_message_text=>'Porcentaje Abierto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99987543733304515)
,p_name=>'PIE_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico de Tarta')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100009650960304532)
,p_name=>'PKC1'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria 1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100009702447304532)
,p_name=>'PKC2'
,p_message_language=>'es'
,p_message_text=>'Columna de Clave Primaria 2'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100701914826305095)
,p_name=>'PKG.APP.AVAILABLE.TO.INSTALL'
,p_message_language=>'es'
,p_message_text=>unistr('Disponible para Instalaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100702014908305095)
,p_name=>'PKG.APP.AVAILABLE.TO.UPGRADE'
,p_message_language=>'es'
,p_message_text=>unistr('Disponible para Actualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100702143739305095)
,p_name=>'PKG.APP.EVENTS_FOR_LAST_X'
,p_message_language=>'es'
,p_message_text=>unistr('Eventos de aplicaci\00F3n de ejemplo y de productividad: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100705555433305097)
,p_name=>'PKG.APP.USER_ACTIVITY'
,p_message_language=>'es'
,p_message_text=>'%0 Usuarios - %1 Vistas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100745233784305127)
,p_name=>'PKG_APP_INSTALL.PREREQ_CHECK_FAILED'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Fallo de comprobaci\00F3n de los siguientes requisitos. La instalaci\00F3n de esta aplicaci\00F3n y sus objetos de soporte no puede continuar hasta que se resuelvan estos problemas.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100745462735305127)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_EXISTS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'El Objeto Existe: <br />',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100745387571305127)
,p_name=>'PKG_APP_INSTALL.SUP_OBJ_REQUIRED_PRIVS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Privilegios Necesarios: <br />',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100730527803305116)
,p_name=>'PKG_APP_USER_TYPE_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice esta p\00E1gina para controlar el acceso de los administradores de espacio de trabajo, desarrolladores de aplicaci\00F3n y usuarios finales a Application Express.</p>'),
'',
unistr('<p>Los <strong>administradores del espacio de trabajo</strong> pueden instalar, eliminar o cambiar de versi\00F3n aplicaciones, as\00ED como gestionar cuentas de usuario y servicios de desarrollo.</p>'),
'',
unistr('<p>Los <strong>desarrolladores</strong> pueden instalar, eliminar o cambiar de versi\00F3n aplicaciones.</p>'),
'',
unistr('<p>Los <strong>usuarios finales</strong> no tienen privilegios de desarrollo y solo pueden acceder a las aplicaciones que no utilicen un esquema de autenticaci\00F3n externo.</p>')))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100701824095305095)
,p_name=>'PLEASE_SELECT_A_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Seleccione un espacio de trabajo de la siguiente lista'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99971542155304503)
,p_name=>'PLSQL'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99785317988304355)
,p_name=>'PLSQL_EXPRESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n PLSQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100038218794304553)
,p_name=>'PLSQL_FUNCTION_BODY_LOV_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('La lista de valores basada en cuerpo de la funci\00F3n PL/SQL que devuelve una sentencia SQL contiene errores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99731321717304316)
,p_name=>'PLSQL_PROCEDURE'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99977841587304508)
,p_name=>'PLSQL_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n PL/SQL')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100272847936304771)
,p_name=>'PLUG-IN FILES'
,p_message_language=>'es'
,p_message_text=>'Archivos de Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100251234082304755)
,p_name=>'PLUGIN'
,p_message_language=>'es'
,p_message_text=>'Plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100655407160305056)
,p_name=>'PLUGIN.CATEGORY.COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100655160511305056)
,p_name=>'PLUGIN.CATEGORY.EFFECT'
,p_message_language=>'es'
,p_message_text=>'Efecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100655389589305056)
,p_name=>'PLUGIN.CATEGORY.EXECUTE'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100706287711305098)
,p_name=>'PLUGIN.CATEGORY.INIT'
,p_message_language=>'es'
,p_message_text=>'Inicializar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100654972358305056)
,p_name=>'PLUGIN.CATEGORY.MISC'
,p_message_language=>'es'
,p_message_text=>'Varios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100646271573305049)
,p_name=>'PLUGIN.CATEGORY.NAVIGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100655257011305056)
,p_name=>'PLUGIN.CATEGORY.NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100655081072305056)
,p_name=>'PLUGIN.CATEGORY.STYLE'
,p_message_language=>'es'
,p_message_text=>'Estilo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100205117407304719)
,p_name=>'PLUGIN.DEPRECATED'
,p_message_language=>'es'
,p_message_text=>' [En desuso]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99991359201304518)
,p_name=>'PLUGIN.DISPLAY_NAME_POSTFIX'
,p_message_language=>'es'
,p_message_text=>' [Plugin]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100537626938304968)
,p_name=>'PLUGIN.LEGACY'
,p_message_language=>'es'
,p_message_text=>' [Heredado]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100157786800304684)
,p_name=>'PLUGIN.TYPE.AUTHENTICATION_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Esquema de Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99537471192304169)
,p_name=>'PLUGIN.TYPE.AUTHORIZATION TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Esquema de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99605117750304223)
,p_name=>'PLUGIN.TYPE.DYNAMIC ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n Din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99604570524304223)
,p_name=>'PLUGIN.TYPE.ITEM TYPE'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100302756887304793)
,p_name=>'PLUGIN.TYPE.PROCESS TYPE'
,p_message_language=>'es'
,p_message_text=>'Proceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99604602452304223)
,p_name=>'PLUGIN.TYPE.REGION TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100021955061304541)
,p_name=>'PLUGIN.TYPE.REPORT COLUMN TYPE'
,p_message_language=>'es'
,p_message_text=>'Columna de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100767172264305144)
,p_name=>'PLUGIN_LINK_HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si ha introducido una URL, utilice las cadenas de sustituci\00F3n <code>&amp;APP_ID.</code>, <code>&amp;SESSION.</code> y <code>&amp;DEBUG.</code> y la sintaxis <code>&amp;COLUMN_NAME.</code> para definir el ID de fila o la clave primaria en la p\00E1gina')
||' de destino o para definir valores de atributo adicionales.</p>',
'<p><strong>Ejemplos</strong></p>',
'<p><pre>f?p=&amp;APP_ID.:10:&amp;SESSION.::&amp;DEBUG.:10:P10_EMPNO:&amp;EMPNO.</pre></p>',
unistr('<p>Para obtener m\00E1s informaci\00F3n sobre la sintaxis de <code>f?p</code>, consulte Application Express Builder User''s Guide.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100023086759304542)
,p_name=>'PLUGIN_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'El plugin se ha creado correctamente'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100354794661304832)
,p_name=>'PNONUS'
,p_message_language=>'es'
,p_message_text=>'Porcentaje de empleados fuera de Estados Unidos'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99733195490304317)
,p_name=>'POPUP_LOV'
,p_message_language=>'es'
,p_message_text=>'lista de valores emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100071664679304579)
,p_name=>'POPUP_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Lista de Valores Emergente'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100032057728304549)
,p_name=>'POST AUTH PROCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Proceso Posterior a la Autenticaci\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100031815716304549)
,p_name=>'PRE AUTH PROCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Proceso Anterior a la Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99915187915304460)
,p_name=>'PRECISION'
,p_message_language=>'es'
,p_message_text=>unistr('Precisi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100252487151304756)
,p_name=>'PREFERENCES'
,p_message_language=>'es'
,p_message_text=>'Preferencias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99724268437304311)
,p_name=>'PREFS_APPLY_PERMISSIONS'
,p_message_language=>'es'
,p_message_text=>'aplicar permisos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99724851784304311)
,p_name=>'PREFS_NOACTION_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('no es necesaria ninguna acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99724574790304311)
,p_name=>'PREFS_REVOKE_PERMISSIONS'
,p_message_language=>'es'
,p_message_text=>'revocar permisos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99590394969304212)
,p_name=>'PREF_EQ_EXP'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Preferencia en Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99590434637304212)
,p_name=>'PREF_NE_EXP'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Preferencia en Expresi\00F3n 1 No Equivale a Expresi\00F3n 2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99692482486304287)
,p_name=>'PRESENTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Presentaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99752044484304331)
,p_name=>'PRINT SERVER NOT CONFIGURED'
,p_message_language=>'es'
,p_message_text=>unistr('La impresi\00F3n del informe no est\00E1 disponible actualmente, no hay ning\00FAn servidor de impresi\00F3n configurado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100000091420304525)
,p_name=>'PRINT_SERVER_ADVANCED'
,p_message_language=>'es'
,p_message_text=>'Avanzado (Necesita Oracle BI Publisher)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100000183810304525)
,p_name=>'PRINT_SERVER_STANDARD'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1ndar')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99985237368304513)
,p_name=>'PRIORITIZED'
,p_message_language=>'es'
,p_message_text=>'Priorizado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99995716245304521)
,p_name=>'PROBLEMS_CORRECTED'
,p_message_language=>'es'
,p_message_text=>'Problemas Corregidos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99995674001304521)
,p_name=>'PROBLEMS_IDENTIFIED'
,p_message_language=>'es'
,p_message_text=>'Problemas identificados'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99730090595304315)
,p_name=>'PROCEDURE'
,p_message_language=>'es'
,p_message_text=>'procedimiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100643543556305047)
,p_name=>'PROCESS.NATIVE_DATA_LOADING'
,p_message_language=>'es'
,p_message_text=>'Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99507652451304147)
,p_name=>'PROCESS.NATIVE_PLSQL'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecutar c\00F3digo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99507790328304147)
,p_name=>'PROCESS.NATIVE_SEND_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99594322250304215)
,p_name=>'PROCESSES'
,p_message_language=>'es'
,p_message_text=>'Procesos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99527804830304162)
,p_name=>'PROCESSING'
,p_message_language=>'es'
,p_message_text=>'Procesando la solicitud. Espere'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100317379258304804)
,p_name=>'PRODUCTION_DOWN'
,p_message_language=>'es'
,p_message_text=>unistr('Producci\00F3n Inactiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100717689574305107)
,p_name=>'PRODUCT_PORTAL'
,p_message_language=>'es'
,p_message_text=>'Portal de Producto'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100732440301305118)
,p_name=>'PROMPT_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Petici\00F3n de Datos: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99547428008304180)
,p_name=>'PROVIDER'
,p_message_language=>'es'
,p_message_text=>'Proveedor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99547575006304180)
,p_name=>'PROVIDER_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Correo Electr\00F3nico de Proveedor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100004443811304528)
,p_name=>'PROVISIONED'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Provisionado',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100118980774304616)
,p_name=>'PROVISIONED_SPACE'
,p_message_language=>'es'
,p_message_text=>'Espacio Proporcionado Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100000224282304525)
,p_name=>'PROVISIONING_MODE_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Por Solicitud de Usuario con Verificaci\00F3n por Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100000434486304525)
,p_name=>'PROVISIONING_MODE_MANUAL'
,p_message_language=>'es'
,p_message_text=>'Manual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100000310850304525)
,p_name=>'PROVISIONING_MODE_REQUEST'
,p_message_language=>'es'
,p_message_text=>'Por Solicitud de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99738645341304321)
,p_name=>'PROVISION_REQUEST.ADMIN_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n del Administrador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99739607662304322)
,p_name=>'PROVISION_REQUEST.CREATE_TBLSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1 un tablespace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99739872931304322)
,p_name=>'PROVISION_REQUEST.DATAFILE'
,p_message_language=>'es'
,p_message_text=>'Archivo de Datos para Tablespace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99738457164304321)
,p_name=>'PROVISION_REQUEST.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99738830956304321)
,p_name=>'PROVISION_REQUEST.EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99739720110304322)
,p_name=>'PROVISION_REQUEST.FLOW_XXX'
,p_message_language=>'es'
,p_message_text=>'APEX_XXX'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99738102632304321)
,p_name=>'PROVISION_REQUEST.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99737913331304321)
,p_name=>'PROVISION_REQUEST.NEW'
,p_message_language=>'es'
,p_message_text=>'Ha solicitado proporcionar un nuevo %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99739470538304322)
,p_name=>'PROVISION_REQUEST.NO'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99739258280304322)
,p_name=>'PROVISION_REQUEST.REUSE_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'Volver a Usar Esquema Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99739151262304322)
,p_name=>'PROVISION_REQUEST.SCHEMA_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n de Esquema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99739515682304322)
,p_name=>'PROVISION_REQUEST.SCHEMA_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99738205209304321)
,p_name=>'PROVISION_REQUEST.SGID'
,p_message_language=>'es'
,p_message_text=>'Identificador de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99738339589304321)
,p_name=>'PROVISION_REQUEST.SYSTEM_ASSIGNED'
,p_message_language=>'es'
,p_message_text=>'Sistema Asignado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99738996116304321)
,p_name=>'PROVISION_REQUEST.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99738744537304321)
,p_name=>'PROVISION_REQUEST.USER_NAME'
,p_message_language=>'es'
,p_message_text=>'Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99738014079304321)
,p_name=>'PROVISION_REQUEST.WORKSPACE_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n de Espacio de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99739351874304322)
,p_name=>'PROVISION_REQUEST.YES'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100043464752304557)
,p_name=>'PROXY_SERVER'
,p_message_language=>'es'
,p_message_text=>'Servidor Proxy'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99725367265304312)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM'
,p_message_language=>'es'
,p_message_text=>'Ha solicitado el refrescamiento de la siguiente ayuda de elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99725438242304312)
,p_name=>'PUBLISH_ITEM_HELP.CONFIRM2'
,p_message_language=>'es'
,p_message_text=>'Si esto es correcto, haga clic en Refrescar Todo. De lo contrario, haga clic en Cancelar.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100349184449304828)
,p_name=>'PURGE.ADMINISTRATORS'
,p_message_language=>'es'
,p_message_text=>'Administradores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100344826467304824)
,p_name=>'PURGE.BEGIN_DELETE_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('Iniciar supresi\00F3n de espacio de trabajo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100344676416304824)
,p_name=>'PURGE.BEGIN_DROP_TABLESPACE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Iniciar borrado de tablespace %0 del espacio de trabajo %1',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100344200907304824)
,p_name=>'PURGE.BEGIN_DROP_USER'
,p_message_language=>'es'
,p_message_text=>'Iniciar borrado de usuario %0 del espacio de trabajo %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100343866517304824)
,p_name=>'PURGE.BEGIN_PURGE_OF_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('Iniciar depuraci\00F3n de espacio de trabajo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100349025098304828)
,p_name=>'PURGE.BYTES'
,p_message_language=>'es'
,p_message_text=>'Bytes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100345120795304825)
,p_name=>'PURGE.DELETE_WORKSPACE_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al suprimir el espacio de trabajo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100344709223304824)
,p_name=>'PURGE.DROP_TABLESPACE_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al borrar el tablespace %0 del espacio de trabajo %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100344562792304824)
,p_name=>'PURGE.DROP_USER_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al borrar el usuario %0 del espacio de trabajo %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100343628164304823)
,p_name=>'PURGE.EMAIL_BODY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Estimado usuario de Oracle APEX:',
'',
unistr('El espacio de trabajo %0 de %1 no ha mostrado ning\00FAn signo de actividad reciente. La depuraci\00F3n de este espacio de trabajo inactivo est\00E1 programada actualmente para el %2 o posteriormente.'),
'',
unistr('Para evitar la eliminaci\00F3n del espacio de trabajo, haga clic en la siguiente direcci\00F3n URL y confirme que no desea que se depure el espacio de trabajo. Debe hacerlo en un plazo de %3 d\00EDas. Si ya no necesita este espacio de trabajo, no tiene que reali')
||unistr('zar ninguna acci\00F3n.'),
'',
unistr('Enlace de confirmaci\00F3n: %4')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100343709952304823)
,p_name=>'PURGE.EMAIL_SUBJECT'
,p_message_language=>'es'
,p_message_text=>'Espacio de trabajo de Oracle APEX que se debe depurar:   Espacio de trabajo %0 en %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100344982651304825)
,p_name=>'PURGE.END_DELETE_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('Terminar supresi\00F3n de espacio de trabajo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100655870434305056)
,p_name=>'PURGE.END_DROP_TABLESPACE'
,p_message_language=>'es'
,p_message_text=>'Terminar borrado de tablespace %0 del espacio de trabajo %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100344434476304824)
,p_name=>'PURGE.END_DROP_USER'
,p_message_language=>'es'
,p_message_text=>'Terminar borrado de usuario %0 del espacio de trabajo %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100341750445304822)
,p_name=>'PURGE.LOG.ADD_TO_PURGE_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Agregando el espacio de trabajo %0 a la lista de depuraci\00F3n, al menos %1 d\00EDas de inactividad.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100341834752304822)
,p_name=>'PURGE.LOG.REMOVE_FROM_PURGE_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Eliminando el espacio de trabajo %0 de la lista de depuraci\00F3n debido a actividad reciente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100341911895304822)
,p_name=>'PURGE.LOG.SENT_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Correo electr\00F3nico enviado a %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100342301390304822)
,p_name=>'PURGE.MOVED_TO_PURGE_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha movido el espacio de trabajo %0 de la lista de retenidos a la lista de depuraci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100348257599304827)
,p_name=>'PURGE.REPORT_BYTES'
,p_message_language=>'es'
,p_message_text=>'Bytes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100345623638304825)
,p_name=>'PURGE.REPORT_COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100348189675304827)
,p_name=>'PURGE.REPORT_DATAFILES'
,p_message_language=>'es'
,p_message_text=>'Archivos de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100347861209304827)
,p_name=>'PURGE.REPORT_SCHEMAS'
,p_message_language=>'es'
,p_message_text=>'Esquemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100345588084304825)
,p_name=>'PURGE.REPORT_STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100345905328304825)
,p_name=>'PURGE.REPORT_SUMMARY_DELETE'
,p_message_language=>'es'
,p_message_text=>unistr('Eliminado de Lista de Depuraci\00F3n (debido a reciente actividad)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100346621408304826)
,p_name=>'PURGE.REPORT_SUMMARY_MOVED_TO_NEW'
,p_message_language=>'es'
,p_message_text=>unistr('Agregado Nuevamente a Lista de Depuraci\00F3n (retenido anteriormente pero sin actividad en %0 d\00EDas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100346371418304826)
,p_name=>'PURGE.REPORT_SUMMARY_NEW'
,p_message_language=>'es'
,p_message_text=>unistr('Reci\00E9n Agregado a Lista de Depuraci\00F3n (sin actividad en %0 d\00EDas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100347277550304826)
,p_name=>'PURGE.REPORT_SUMMARY_PURGED_TODAY'
,p_message_language=>'es'
,p_message_text=>'Depurado Hoy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100346137018304825)
,p_name=>'PURGE.REPORT_SUMMARY_RETAIN'
,p_message_language=>'es'
,p_message_text=>'Retenido (solicitud al administrador para que no depure el espacio de trabajo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100346841400304826)
,p_name=>'PURGE.REPORT_SUMMARY_TO_BE_PURGED'
,p_message_language=>'es'
,p_message_text=>unistr('Para Depurar en %0 d\00EDa(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100347938958304827)
,p_name=>'PURGE.REPORT_TABLESPACES'
,p_message_language=>'es'
,p_message_text=>'Tablespaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100347733775304827)
,p_name=>'PURGE.REPORT_WORKSPACES'
,p_message_language=>'es'
,p_message_text=>'Espacios de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100347310816304826)
,p_name=>'PURGE.REPORT_WORKSPACES_REMAINING'
,p_message_language=>'es'
,p_message_text=>'Espacios de Trabajo Restantes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100342130133304822)
,p_name=>'PURGE.SAVE_RESPONSE'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha registrado la respuesta del valor %0 de correo electr\00F3nico de: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100348839169304827)
,p_name=>'PURGE.SCHEMA'
,p_message_language=>'es'
,p_message_text=>'Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100343960613304824)
,p_name=>'PURGE.SET_SCHEMA_STATUS'
,p_message_language=>'es'
,p_message_text=>'Definiendo el estado del esquema %0 en %1 para el espacio de trabajo %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100344077684304824)
,p_name=>'PURGE.SET_TABLESPACE_STATUS'
,p_message_language=>'es'
,p_message_text=>'Definiendo el estado del tablespace %0 en %1 para el espacio de trabajo %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100354356036304831)
,p_name=>'PURGE.SUBJECT_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Resumen Diario de Depuraci\00F3n de Espacios de Trabajo de Application Express')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100348907050304827)
,p_name=>'PURGE.TABLESPACE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Tablespace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100349407185304828)
,p_name=>'PURGE.WORKSPACES_ADDED_BACK'
,p_message_language=>'es'
,p_message_text=>unistr('Espacios de Trabajo Agregados Nuevamente a Lista de Depuraci\00F3n (retenidos anteriormente pero sin actividad en %0 d\00EDas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100349304372304828)
,p_name=>'PURGE.WORKSPACES_NEWLY_ADDED'
,p_message_language=>'es'
,p_message_text=>unistr('Espacios de Trabajo Reci\00E9n Agregados a Lista de Depuraci\00F3n (sin actividad en %0 d\00EDas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100348339504304827)
,p_name=>'PURGE.WORKSPACES_PURGED_SUMMARY'
,p_message_language=>'es'
,p_message_text=>'Resumen de Espacios de Trabajo Depurados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100348548495304827)
,p_name=>'PURGE.WORKSPACES_PURGED_TODAY'
,p_message_language=>'es'
,p_message_text=>'Espacios de Trabajo Depurados Hoy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100349586371304828)
,p_name=>'PURGE.WORKSPACES_REMOVED'
,p_message_language=>'es'
,p_message_text=>unistr('Espacios de Trabajo Eliminados de Lista de Depuraci\00F3n (debido a reciente actividad)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100349677907304828)
,p_name=>'PURGE.WORKSPACES_RETAINED'
,p_message_language=>'es'
,p_message_text=>'Espacios de Trabajo Retenidos (solicitud al administrador para que no depure el espacio de trabajo)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100349246538304828)
,p_name=>'PURGE.WORKSPACES_TO_BE_PURGED'
,p_message_language=>'es'
,p_message_text=>unistr('Espacios de Trabajo que Depurar en %0 D\00EDa(s)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100348704977304827)
,p_name=>'PURGE.WORKSPACE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100345401591304825)
,p_name=>'PURGE.WORKSPACE_PURGE_COMPLETE'
,p_message_language=>'es'
,p_message_text=>unistr('Depuraci\00F3n de espacio de trabajo %0 terminada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100647360122305050)
,p_name=>'PURGED'
,p_message_language=>'es'
,p_message_text=>'Depurado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100732022574305117)
,p_name=>'PURGE_LABEL'
,p_message_language=>'es'
,p_message_text=>'Depurar: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100109583477304609)
,p_name=>'QB_ACTIONS'
,p_message_language=>'es'
,p_message_text=>'&nbsp;Acciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99786769219304356)
,p_name=>'QB_CREATE_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una consulta v\00E1lida para ver los resultados')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100109377241304608)
,p_name=>'QB_DUPLICATE_QUERY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Nombre que ya ha utilizado la consulta existente en Generador de Consultas o procesador de comandos SQL.<br> ',
'Seleccione un nuevo nombre y vuelva a guardarlo.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99968024006304500)
,p_name=>'QB_NOTHING_TO_SAVE'
,p_message_language=>'es'
,p_message_text=>'Nada que guardar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99948251728304485)
,p_name=>'QB_SAVE_QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta Guardada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100114873920304613)
,p_name=>'QB_TABLE_ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Acciones de Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100114967192304613)
,p_name=>'QB_VIEW_ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Ver Acciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100067623289304576)
,p_name=>'QB_WARN_MESSAGE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'El Generador de Consultas visual no puede abrir la consulta actual.<br>',
'Haga clic en Crear para sustituir la consulta actual por otra consulta nueva o pulse Intro para mantener la consulta actual.'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100067539347304576)
,p_name=>'QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99592648575304214)
,p_name=>'QUERY BUILDER'
,p_message_language=>'es'
,p_message_text=>'Generador de Consultas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99759562778304336)
,p_name=>'QUERY.INVALID_NO_SELECT'
,p_message_language=>'es'
,p_message_text=>unistr('consulta no v\00E1lida, no se ha encontrado ninguna sentencia select')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99592441250304214)
,p_name=>'QUESTIONS'
,p_message_language=>'es'
,p_message_text=>'Preguntas'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100311825651304800)
,p_name=>'QUICKPICK_NUMERIC_MASK'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara de formato num\00E9rico: 999G999G999G999G990')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100117845932304615)
,p_name=>'QUICKSQL.ABOUT'
,p_message_language=>'es'
,p_message_text=>unistr('Acerca de SQL r\00E1pido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100117976356304615)
,p_name=>'QUICKSQL.ABOUT.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>SQL r\00E1pido ofrece una forma r\00E1pida de generar el SQL necesario para crear un modelo de datos relacional a partir de un documento de texto con sangr\00EDa. La herramienta est\00E1 dise\00F1ada para reducir el tiempo y el esfuerzo necesarios para crear tablas, ')
||unistr('disparadores y estructuras de \00EDndices SQL. La herramienta no est\00E1 dise\00F1ada para sustituir el modelado de datos, solo ofrece un m\00E9todo r\00E1pido para desarrollar un script para vistas y tablas simples. Una vez que se genera el SQL, se puede ajustar y amp')
||'liar.</p>',
'',
'<p>Casos de uso principales:',
'<ul>',
unistr('  <li>Creaci\00F3n r\00E1pida de modelos de datos s\00F3lidos</li>'),
unistr('  <li>Guardado de sintaxis de SQL abreviado r\00E1pido como un modelo para iterar a trav\00E9s de los cambios de modelo o utilizarlo como un modelo de plantilla para iniciar inmediatamente el siguiente dise\00F1o de modelo</li>'),
unistr('  <li>Generaci\00F3n sencilla de datos aleatorios</li>'),
unistr('  <li>Aprendizaje de SQL, creaci\00F3n de tablas, selecci\00F3n, inserci\00F3n, indexaci\00F3n, activaci\00F3n, paquete PL/SQL y visualizaci\00F3n de la sintaxis con los ejemplos proporcionados</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100010724212304533)
,p_name=>'QUICKSQL.APEX_SETTING_PART1'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Este valor controla la sintaxis generada para soportar columnas de auditor\00EDa. Concretamente, si las columnas de auditor\00EDa est\00E1n activadas, se generan disparadores para mantener el usuario que est\00E1 creando una fila y el usuario que ha actualizado una ')
||unistr('fila por \00FAltima vez. Si est\00E1 activado, se utiliza la siguiente funci\00F3n:'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100010847926304533)
,p_name=>'QUICKSQL.APEX_SETTING_PART2'
,p_message_language=>'es'
,p_message_text=>unistr('Si no est\00E1 activado, se utiliza la siguiente funci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100010906857304533)
,p_name=>'QUICKSQL.API_SETTING'
,p_message_language=>'es'
,p_message_text=>'Generar API PL/SQL en todas las tablas para crear, insertar, actualizar, suprimir y consultar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100011044724304533)
,p_name=>'QUICKSQL.AUDITCOLS'
,p_message_language=>'es'
,p_message_text=>'Agrega las columnas adicionales created, created_by, updated y updated_by a todas las tablas creadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100011193782304533)
,p_name=>'QUICKSQL.COMPRESS_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Si est\00E1 activado, todas las tablas se crean comprimidas. El valor por defecto es no comprimida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100011290219304533)
,p_name=>'QUICKSQL.CREATEDBYCOL_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Si las columnas de auditor\00EDa est\00E1n activadas, la columna que se utiliza por defecto para realizar el seguimiento del usuario que cre\00F3 una fila es CREATED_BY. Utilice este valor para sustituir el nombre de la columna de auditor\00EDa por defecto. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100011349636304533)
,p_name=>'QUICKSQL.CREATED_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Si las columnas de auditor\00EDa est\00E1n activadas, la columna que se utiliza por defecto para realizar el seguimiento del usuario que cre\00F3 una fila es CREATED. Utilice este valor para sustituir el nombre de la columna de auditor\00EDa por defecto. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100013327351304535)
,p_name=>'QUICKSQL.DATE_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Por defecto, todas las columnas DATE se crean mediante el tipo de dato DATE. Utilice este valor para sustituir el valor por defecto. Los valores v\00E1lidos son:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100015694892304536)
,p_name=>'QUICKSQL.DB_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Especifica la versi\00F3n de la base de datos con la que deber\00EDa ser compatible la sintaxis. Los valores v\00E1lidos son:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100020067186304540)
,p_name=>'QUICKSQL.DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100687683944305084)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES'
,p_message_language=>'es'
,p_message_text=>'Departamentos y empleados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100688239491305085)
,p_name=>'QUICKSQL.DEPARTMENTSANDEMPLOYEES_DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Sintaxis SQL abreviada que crea una tabla DEPARTMENTS y EMPLOYEES con un elemento VIEW de uni\00F3n SQL. Tambi\00E9n se generan datos aleatorios mediante la sintaxis /INSERT. /NN agrega una restricci\00F3n de columna NOT NULL SQL. Se utilizan listas con sangr\00EDa ')
||unistr('para definir tablas, columnas y tablas secundarias. Las columnas de clave primaria y ajena se agregan autom\00E1ticamente. No tiene que proporcionar ninguna columna de clave primaria o ajena.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99940108009304479)
,p_name=>'QUICKSQL.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100018756414304539)
,p_name=>'QUICKSQL.DROP_SETTING'
,p_message_language=>'es'
,p_message_text=>'Incluir comandos SQL para borrar todos los objetos de base de datos creados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100687863514305084)
,p_name=>'QUICKSQL.EMPLOYEESKILLS'
,p_message_language=>'es'
,p_message_text=>'Aptitudes del empleado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100688065684305084)
,p_name=>'QUICKSQL.EMPLOYEESKILLS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Crea una tabla de DEPARTMENTS, EMPLOYEES y SKILLS mediante la sangr\00EDa para identificar tablas principales y secundarias. La sintaxis abreviada VC255 se utiliza para especificar un tipo de dato SQL. La sintaxis /INSERT se utiliza para generar datos al')
||'eatorios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99939916555304479)
,p_name=>'QUICKSQL.EXAMPLE'
,p_message_language=>'es'
,p_message_text=>'Ejemplo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100118271255304615)
,p_name=>'QUICKSQL.EXAMPLE_N'
,p_message_language=>'es'
,p_message_text=>'Ejemplo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100020745021304540)
,p_name=>'QUICKSQL.GENPK_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Generar autom\00E1ticamente una columna de clave primaria de ID para cada tabla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100118030130304615)
,p_name=>'QUICKSQL.GETTING_STARTED'
,p_message_language=>'es'
,p_message_text=>unistr('Introducci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100118169600304615)
,p_name=>'QUICKSQL.GETTING_STARTED.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca los nombres de tabla principal sin sangr\00EDa. Introduzca los nombres de columna con una sangr\00EDa uniforme de 2 o m\00E1s espacios. Normalmente, es mejor no especificar claves primarias, ya que las genera el sistema. Las relaciones principal-se')
||unistr('cundario se crean simplemente mediante la sangr\00EDa de tablas secundarias de tablas principales.</p>'),
'',
unistr('<p>Generalmente, el valor predeterminado de los tipos de dato es VARCHAR2. Si desea una columna de un tipo de dato diferente, agregue un espacio NUM, INT, DATE al final del nombre de columna. En funci\00F3n del texto en ingl\00E9s incluido en el nombre de co')
||unistr('lumna, y si no hay ning\00FAn tipo de dato especificado, el sistema tomar\00E1 decisiones fundadas para algunos nombres de columna. Por ejemplo, si el nombre de columna contiene la palabra DATE, ser\00E1 un tipo de dato de fecha; si el nombre de columna contiene')
||unistr(' la palabra NUMBER o NUM, ser\00E1 un tipo de dato de n\00FAmero. Si desea especificar una longitud VARCHAR2 determinada, introduzca VCn, donde "n" es la longitud de VARCHAR2. Haga clic en el bot\00F3n Sintaxis para mostrar la sintaxis disponible. A los nombres ')
||unistr('de objeto se les aplica formato autom\00E1ticamente, y los espacios se sustituir\00E1n por guiones bajos para que pueda utilizar espacios en nombres de tablas y columnas.</p>'),
'',
unistr('<p>Haga clic en el bot\00F3n Configuraci\00F3n para ver varias opciones de generaci\00F3n. Puede agregar autom\00E1ticamente "columnas Qui\00E9n" (por ejemplo, qui\00E9n ha creado o ha actualizado por \00FAltima vez una fila determinada y cu\00E1ndo). Puede agregar una columna de s')
||unistr('ecuencia de filas que se incremente autom\00E1ticamente en uno con cada actualizaci\00F3n de filas. Una secuencia de filas puede ser \00FAtil para simplificar la detecci\00F3n de actualizaciones perdidas. Tambi\00E9n se puede generar una API de PL/SQL, que ofrece un paq')
||'uete por tabla y proporciona procedimientos para consultar, insertar, actualizar y suprimir filas.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100692907381305088)
,p_name=>'QUICKSQL.HELP.API'
,p_message_language=>'es'
,p_message_text=>'Generar API de paquetes PL/SQL para consultar, insertar, actualizar y suprimir datos en una tabla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100693013276305088)
,p_name=>'QUICKSQL.HELP.AUDIT'
,p_message_language=>'es'
,p_message_text=>unistr('Agrega una auditor\00EDa de Oracle. Por defecto, el valor es AUDIT ALL ON [NOMBRE_TABLA].')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100693148945305088)
,p_name=>'QUICKSQL.HELP.AUDITCOLS'
,p_message_language=>'es'
,p_message_text=>unistr('Agrega autom\00E1ticamente las columnas UPDATED, UPDATED_BY, INSERTED e INSERTED_BY y la l\00F3gica de disparador que va a definir los valores de columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100692322244305088)
,p_name=>'QUICKSQL.HELP.BETWEEN'
,p_message_language=>'es'
,p_message_text=>unistr('Agrega una restricci\00F3n de control "between" a la columna, por ejemplo, /between 1 and 100')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100691779564305087)
,p_name=>'QUICKSQL.HELP.CHECK'
,p_message_language=>'es'
,p_message_text=>unistr('Crea una restricci\00F3n de control con valores delimitados por comas o por espacios en blanco; por ejemplo, /check Yes, No')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100021800790304541)
,p_name=>'QUICKSQL.HELP.COLPREFIX'
,p_message_language=>'es'
,p_message_text=>unistr('Agregue un prefijo a todas las columnas de una tabla concreta con este valor. Agrega autom\00E1ticamente un guion bajo si no se proporciona.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100061923022304571)
,p_name=>'QUICKSQL.HELP.COLUMN_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100692757533305088)
,p_name=>'QUICKSQL.HELP.COMMENTS'
,p_message_language=>'es'
,p_message_text=>'Delimite los comentarios mediante corchetes o sintaxis de guiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100693210685305088)
,p_name=>'QUICKSQL.HELP.COMPRESSED'
,p_message_language=>'es'
,p_message_text=>unistr('La tabla se crear\00E1 comprimida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100691896596305087)
,p_name=>'QUICKSQL.HELP.CONSTANT'
,p_message_language=>'es'
,p_message_text=>'Al generar datos, defina esta columna en un valor constante. Por ejemplo, /constant NYC.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100525128172304959)
,p_name=>'QUICKSQL.HELP.DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Agrega valor por defecto si la columna es nula'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100021793686304541)
,p_name=>'QUICKSQL.HELP.FILE_DATATYPE'
,p_message_language=>'es'
,p_message_text=>'Agrega una columna BLOB y las columnas _FILENAME, _CHARSET, _MIMETYPE y _LASTUPD que mejoran la capacidad de descargar archivos mediante un explorador.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100692518825305088)
,p_name=>'QUICKSQL.HELP.FK'
,p_message_language=>'es'
,p_message_text=>'Referencias de clave ajena, por ejemplo: /references nombre_tabla. Tenga en cuenta que puede hacer referencia a tablas que no formen parte de su modelo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100692467716305088)
,p_name=>'QUICKSQL.HELP.HIDDEN'
,p_message_language=>'es'
,p_message_text=>'Las columnas ocultas no se muestran mediante select * from table.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100285738236304781)
,p_name=>'QUICKSQL.HELP.INDEX'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1 un \00EDndice no \00FAnico en la columna asociada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100693371347305088)
,p_name=>'QUICKSQL.HELP.INSERT'
,p_message_language=>'es'
,p_message_text=>unistr('Generar <strong>NN</strong> sentencias INSERT de SQL con datos aleatorios, por ejemplo: /INSERT 20. (M\00E1ximo = 1000)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100692110632305087)
,p_name=>'QUICKSQL.HELP.LOWER'
,p_message_language=>'es'
,p_message_text=>unistr('Fuerza las min\00FAsculas en los valores de columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100692866570305088)
,p_name=>'QUICKSQL.HELP.NNN'
,p_message_language=>'es'
,p_message_text=>unistr('NNN identifica un n\00FAmero entre 1 y 32767.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100692200066305088)
,p_name=>'QUICKSQL.HELP.NOTNULL'
,p_message_language=>'es'
,p_message_text=>unistr('Agrega una restricci\00F3n no nula a la columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100692663727305088)
,p_name=>'QUICKSQL.HELP.PK'
,p_message_language=>'es'
,p_message_text=>unistr('Identifica la columna como clave primaria de la tabla. Se recomienda no especificar manualmente las claves primarias y dejar que esta aplicaci\00F3n las cree autom\00E1ticamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100693538228305088)
,p_name=>'QUICKSQL.HELP.REST'
,p_message_language=>'es'
,p_message_text=>unistr('Generar activaci\00F3n REST de la tabla mediante Oracle REST Data Services (ORDS)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100693477048305088)
,p_name=>'QUICKSQL.HELP.SELECT'
,p_message_language=>'es'
,p_message_text=>'Generar sentencia SELECT de SQL tras generar datos para cada tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99827437604304386)
,p_name=>'QUICKSQL.HELP.TABLE_UNIQUE'
,p_message_language=>'es'
,p_message_text=>unistr('Generar restricci\00F3n \00FAnica de nivel de tabla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100691601004305087)
,p_name=>'QUICKSQL.HELP.UNIQUE'
,p_message_language=>'es'
,p_message_text=>unistr('Crea una restricci\00F3n \00FAnica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100692043619305087)
,p_name=>'QUICKSQL.HELP.UPPER'
,p_message_language=>'es'
,p_message_text=>unistr('Fuerza las may\00FAsculas en los valores de columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100691960915305087)
,p_name=>'QUICKSQL.HELP.VALUES'
,p_message_language=>'es'
,p_message_text=>unistr('Lista de valores separados por comas que se utilizar\00E1 al generar datos. Por ejemplo: /values 1, 2, 3, 4 o /values Yes, No.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100120690372304617)
,p_name=>'QUICKSQL.IMPLEMENT'
,p_message_language=>'es'
,p_message_text=>unistr('Creaci\00F3n de objetos de base de datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100148552611304677)
,p_name=>'QUICKSQL.IMPLEMENT.DETAIL'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Una vez que haya introducido el SQL abreviado r\00E1pido y aplicado la configuraci\00F3n adecuada, podr\00E1 utilizar el SQL para crear los objetos de base de datos, y quiz\00E1s rellenar las tablas con datos aleatorios. Siga estos pasos:<br>'),
'<ol>',
unistr('    <li>Haga clic en <strong>Guardar modelo</strong> para guardar la sintaxis del SQL abreviado r\00E1pido como un modelo para volver a utilizarla en el futuro.</li>'),
'  <li>Introduzca un nombre de modelo.</li>',
'  <li>Haga clic en <strong>Guardar script SQL</strong> para guardar la salida como un script.</li>',
'  <li>Introduzca un nombre de script.</li>',
'  <li>Haga clic en <strong>Revisar y ejecutar</strong> para navegar al editor de scripts.</li>',
'  <li>En este editor, compruebe que el contenido del script es correcto.</li>',
'  <li>Haga clic en <strong>Ejecutar</strong> para crear los objetos de base de datos.</li>',
unistr('  <li>En la p\00E1gina de confirmaci\00F3n de scripts, haga clic en <strong>Ejecutar ahora</strong>.</li>'),
unistr('  <li>En la p\00E1gina de resultados, revise las sentencias procesadas (tanto correctas como con errores).<br>'),
unistr('  Si se notifica alg\00FAn error, navegue en las p\00E1ginas de resultados para ver los mensajes de error de Oracle espec\00EDficos.</li>'),
unistr('  <li>Opcionalmente, haga clic en <strong>Crear aplicaci\00F3n a partir de script</strong> para ir al asistente de creaci\00F3n de aplicaciones y que las p\00E1ginas se generen autom\00E1ticamente en funci\00F3n de las tablas y vistas especificadas en el script.</li>'),
'</ol>',
'</p>',
'',
unistr('<p><em><strong>Nota:</strong> Oracle recomienda descargar el SQL abreviado en la computadora si desea actualizar el mismo SQL abreviado en el futuro. Si ha especificado una configuraci\00F3n, navegue a la parte inferior del panel Salida de SQL de Oracle ')
||unistr('y copie la l\00EDnea que empieza por <code># settings =</code> en la parte superior del panel de SQL abreviado r\00E1pido.<br>'),
'Haga clic en <strong>Descargar</strong> para guardar el archivo SQL en su computadora.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100019788706304539)
,p_name=>'QUICKSQL.LANGUAGE_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Generar datos usados para insertar sentencias utilizando este idioma. El idioma por defecto es el ingl\00E9s. Los idiomas soportados son: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100019904919304540)
,p_name=>'QUICKSQL.LONGID_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Determina los identificadores m\00E1s largos de uso que se utilizar\00E1n para los nombres de objeto de base de datos. Si est\00E1 activado, los identificadores m\00E1s largos permitir\00E1n que los nombres de objeto tengan hasta 128 caracteres de longitud. Si no est\00E1 a')
||unistr('ctivado, la longitud m\00E1xima de un nombre de objeto es de 30 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100020197806304540)
,p_name=>'QUICKSQL.LONGVC_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Permitir el uso de identificadores m\00E1s largos para los nombres de objeto de base de datos. Los identificadores m\00E1s largos permiten que la longitud m\00E1xima de un tipo de dato de columna VARCHAR2 sea de 32767 caracteres. Si no se ha definido, la longitu')
||unistr('d m\00E1xima de un tipo de dato de columna VARCHAR2 ser\00E1 de 4000 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100020273140304540)
,p_name=>'QUICKSQL.ONDELETE_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Este valor controla la configuraci\00F3n de clave ajena ON DELETE. Los valores v\00E1lidos son: ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100020323739304540)
,p_name=>'QUICKSQL.OVERRIDESETTINGS_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Si est\00E1 activado, se ignoran todos los valores de la aplicaci\00F3n definidos mediante la consola de la interfaz de usuario y se utilizar\00E1n solo los valores definidos en el script.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100020429938304540)
,p_name=>'QUICKSQL.PK_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Determina c\00F3mo se definir\00E1 la clave primaria. Las claves primarias pueden definirse mediante SYS_GUID, columnas de identidad o secuencias. Los valores v\00E1lidos son:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100020602373304540)
,p_name=>'QUICKSQL.PREFIXPKWITHTNAME_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar prefijo a las columnas de tablas de base de datos de clave primaria con nombre de tabla. Por ejemplo, la clave primaria de la tabla EMPLOYEE ser\00EDa EMPLOYEE_ID. Si no se define el nombre de las columnas de clave primaria creadas impl\00EDcitamente')
||unistr(', ser\00E1 ID.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100020589985304540)
,p_name=>'QUICKSQL.PREFIX_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Prefijo de objeto de base de datos. Se agregar\00E1 un guion bajo si no se proporciona.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100687702735305084)
,p_name=>'QUICKSQL.PRODUCTSALES'
,p_message_language=>'es'
,p_message_text=>'Ventas de productos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100688359656305085)
,p_name=>'QUICKSQL.PRODUCTSALES_DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Sintaxis abreviada que crea un esquema de estrella con las tablas PRODUCTS, CUSTOMERS, CHANNELS, PROMOTIONS y SALES. La tabla SALES contiene referencias de clave ajena a las otras tablas. Tambi\00E9n se crea un elemento SQL VIEW que une las 5 tablas. Ade')
||unistr('m\00E1s, se generan datos de ejemplo aleatorios. Las columnas num\00E9ricas se identifican con la sintaxis NUM.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100687536662305084)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT'
,p_message_language=>'es'
,p_message_text=>unistr('Gesti\00F3n de Proyectos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100688198918305084)
,p_name=>'QUICKSQL.PROJECTMANAGEMENT_DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Crea una tabla PROJECT_MANAGEMENT y cuatro tablas de detalles. Se crean dos vistas mediante la sintaxis /VIEW. Tambi\00E9n se agregan restricciones CHECK de la base de datos mediante la sintaxis /CHECK. Adem\00E1s, utiliza #APEX para definir la configuraci\00F3n')
||unistr(' que controla la generaci\00F3n de la sintaxis SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100020854142304540)
,p_name=>'QUICKSQL.RESETSETTINGS_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Restablece todos los valores de la aplicaci\00F3n a los valores por defecto. Si se incluyen, se ignorar\00E1n todos los valores de la aplicaci\00F3n activos actualmente en su sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100020920332304540)
,p_name=>'QUICKSQL.ROWKEY_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Para cada tabla creada, agregue una columna ROW_KEY que genere un identificador alfanum\00E9rico. Los valores de la columna ROW_KEY se definir\00E1n a partir de la l\00F3gica de disparador de tablas de base de datos generada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100021142033304540)
,p_name=>'QUICKSQL.ROWVERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Para cada tabla generada, agregue una columna ROW_VERSION que se incremente en 1 por cada actualizaci\00F3n. Si est\00E1 activado, se generar\00E1 una l\00F3gica de disparador de tablas de base de datos para incrementar las versiones de fila durante la actualizaci\00F3n')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100021274028304541)
,p_name=>'QUICKSQL.SCHEMA_SETTING'
,p_message_language=>'es'
,p_message_text=>'Agregue un prefijo a todos los nombres de objeto con el nombre del esquema. El valor por defecto es el prefijo del esquema para los nombres de objeto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100021093568304540)
,p_name=>'QUICKSQL.SECURITYGROUPID_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Por cada tabla, agregue una columna TENANT_ID para soportar las aplicaciones multiinquilino. El valor de esta columna se agrega simplemente a la tabla; para mantener este valor, el desarrollador tendr\00E1 que proporcionarlo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100021639420304541)
,p_name=>'QUICKSQL.SEMANTICS_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('No puede seleccionar sem\00E1ntica de columna o sem\00E1ntica CHAR o BYTE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99940016993304479)
,p_name=>'QUICKSQL.SETTING'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100003234166304527)
,p_name=>'QUICKSQL.SETTINGS_DESC'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Puede introducir valores en l\00EDnea para establecer expl\00EDcitamente opciones de generaci\00F3n de sintaxis SQL. Tambi\00E9n puede hacer clic en <strong>Configuraci\00F3n</strong> al principio del panel derecho para definir las opciones de generaci\00F3n de forma dec')
||'larativa.</p>',
'',
unistr('<p>La introducci\00F3n de valores directamente en el panel SQL abreviado r\00E1pido garantiza que se utilicen las mismas opciones de generaci\00F3n de SQL, incluso si descarga el script y lo vuelve a pegar m\00E1s adelante. Por ejemplo, introduzca lo siguiente para ')
||'agregar el prefijo TEST a todos los nombres de tabla y generar para OBE de esquema:<br>',
'<code># settings = { prefix: "test", schema: "OBE" }</code>.<br>',
unistr('Tambi\00E9n puede introducir cada valor en otra l\00EDnea para obtener el mismo resultado:<br>'),
'<code># prefix: "test"<br>',
'# schema: "OBE"</code>',
'</p>',
unistr('<p><em><strong>Nota:</strong> Los valores deben comenzar en una nueva l\00EDnea y empezar por <code># settings = </code> para introducir varios valores o <code># </code> para introducir un solo valor por l\00EDnea. Todos los valores no son sensibles a may\00FAsc')
||unistr('ulas/min\00FAsculas. Se pueden agregar corchetes, espacios y comas para una mayor claridad, pero se ignorar\00E1n. Para que se generen todos los valores, utilice <code># verbose: true</code>.</em> '),
'</p>',
'&nbsp;<br>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99939727025304479)
,p_name=>'QUICKSQL.SYNTAX'
,p_message_language=>'es'
,p_message_text=>'Sintaxis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100709505133305100)
,p_name=>'QUICKSQL.TODOS'
,p_message_language=>'es'
,p_message_text=>'Tareas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100709633656305101)
,p_name=>'QUICKSQL.TODOS_DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Crea una tabla de ASSIGNEES y otra de TODOS. Est\00E1 dise\00F1ado como un punto de inicio para activar la creaci\00F3n de un sistema de tareas personalizado en minutos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100021395455304541)
,p_name=>'QUICKSQL.UPDATEDBYCOL_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Al activar las columnas de auditor\00EDa, utilice este valor para sobrescribir el nombre de la columna de auditor\00EDa por defecto. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100021427401304541)
,p_name=>'QUICKSQL.UPDATEDCOL_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Al activar las columnas de auditor\00EDa, utilice este valor para sobrescribir el nombre de la columna de auditor\00EDa por defecto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100021528409304541)
,p_name=>'QUICKSQL.VERBOSE_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Se mostrar\00E1n todos los valores, no solo los que sean diferentes de los valores por defecto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99939898845304479)
,p_name=>'QUICKSQL.VIEW_SYNTAX_DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Aseg\00FArese de que el nombre de vista no contiene ning\00FAn espacio. Aseg\00FArese de que los nombres de tabla no contengan ning\00FAn espacio. Delimite los nombres de tabla con un espacio o una coma.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100148663595304677)
,p_name=>'QUICK_APP.LOAD_DETAIL'
,p_message_language=>'es'
,p_message_text=>'Informe de Carga de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99788007273304357)
,p_name=>'QUICK_APP_ANALYSIS'
,p_message_language=>'es'
,p_message_text=>unistr('An\00E1lisis')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99995941273304521)
,p_name=>'QUICK_APP_AVERAGE'
,p_message_language=>'es'
,p_message_text=>'Media de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99671330938304272)
,p_name=>'QUICK_APP_BY'
,p_message_language=>'es'
,p_message_text=>'Por %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99788471208304357)
,p_name=>'QUICK_APP_CHARTS'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1ficos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99671230418304272)
,p_name=>'QUICK_APP_CHART_BY'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico por %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99669982199304271)
,p_name=>'QUICK_APP_DETAIL_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Detalles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99788385852304357)
,p_name=>'QUICK_APP_REPORTS'
,p_message_language=>'es'
,p_message_text=>'Informes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99996057097304522)
,p_name=>'QUICK_APP_SUM'
,p_message_language=>'es'
,p_message_text=>'Suma de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100163985600304689)
,p_name=>'QUICK_SQL'
,p_message_language=>'es'
,p_message_text=>unistr('SQL r\00E1pido')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99505667387304145)
,p_name=>'RANGE2DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 2D de Rango'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99505766862304145)
,p_name=>'RANGE3DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 3D de Rango'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100821243339305184)
,p_name=>'READERS'
,p_message_language=>'es'
,p_message_text=>'Lectores'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100737565120305121)
,p_name=>'REASSIGN_ITEM'
,p_message_language=>'es'
,p_message_text=>'Reasignar Elemento: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99529022738304163)
,p_name=>'REASSIGN_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Reasignar P\00E1ginas')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99914469921304459)
,p_name=>'RECYCLE_BIN'
,p_message_language=>'es'
,p_message_text=>'Papelera de Reciclaje'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100118358996304615)
,p_name=>'REDIRECT'
,p_message_language=>'es'
,p_message_text=>'Redirigir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100118507976304615)
,p_name=>'REDIRECT_BUTTON_WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('Este bot\00F3n le redireccionar\00E1 a una direcci\00F3n URL y es probable que no se ejecute la p\00E1gina. Si desea que el bot\00F3n la ejecute, no identifique una p\00E1gina o direcci\00F3n URL de redireccionamiento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99784768801304355)
,p_name=>'REDIRECT_TO'
,p_message_language=>'es'
,p_message_text=>'Redirigir a %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100250427348304754)
,p_name=>'REDIRECT_TO_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Redirige a la aplicaci\00F3n %0, p\00E1gina %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99784692511304355)
,p_name=>'REDIRECT_TO_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Redirigir a la P\00E1gina %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99592213422304214)
,p_name=>'REDIRECT_TO_PAGE_IN_THIS_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Redirigir a P\00E1gina en esta Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99592380174304214)
,p_name=>'REDIRECT_TO_URL'
,p_message_language=>'es'
,p_message_text=>'Redirigir a URL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99965628143304498)
,p_name=>'REFERENCED'
,p_message_language=>'es'
,p_message_text=>'Con Referencia'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99593220475304214)
,p_name=>'REGEN_VER'
,p_message_language=>'es'
,p_message_text=>unistr('Regenerar c\00F3digo de verificaci\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99968263936304500)
,p_name=>'REGION'
,p_message_language=>'es'
,p_message_text=>unistr('regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100112721889304611)
,p_name=>'REGION BUTTON POSITONS'
,p_message_language=>'es'
,p_message_text=>unistr('Posiciones de Botones de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100032269945304549)
,p_name=>'REGION CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100025418443304544)
,p_name=>'REGION CONTENT'
,p_message_language=>'es'
,p_message_text=>unistr('Contenido de la Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99571104310304198)
,p_name=>'REGION.BUTTONS'
,p_message_language=>'es'
,p_message_text=>unistr('Botones de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99594275860304215)
,p_name=>'REGIONS'
,p_message_language=>'es'
,p_message_text=>'Regiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99752247468304331)
,p_name=>'REGIONS_LIST_TEMPLATE_OVERRIDE'
,p_message_language=>'es'
,p_message_text=>unistr('Sustituci\00F3n de Plantillas de Lista de Regiones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99976530037304507)
,p_name=>'REGION_DISPLAY_SELECTOR'
,p_message_language=>'es'
,p_message_text=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99494998778304137)
,p_name=>'REGION_NAME.NATIVE_BREADCRUMB'
,p_message_language=>'es'
,p_message_text=>unistr('Ruta de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100240888311304746)
,p_name=>'REGION_NAME.NATIVE_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99513164894304151)
,p_name=>'REGION_NAME.NATIVE_CARDS'
,p_message_language=>'es'
,p_message_text=>'Tarjetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99960818076304495)
,p_name=>'REGION_NAME.NATIVE_CSS_CALENDAR'
,p_message_language=>'es'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99537393389304169)
,p_name=>'REGION_NAME.NATIVE_DATA_UPLOAD_COLUMN_MAPPING'
,p_message_language=>'es'
,p_message_text=>unistr('Carga de Datos: Asignaci\00F3n de Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99974950275304505)
,p_name=>'REGION_NAME.NATIVE_DISPLAY_SELECTOR'
,p_message_language=>'es'
,p_message_text=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100305548614304795)
,p_name=>'REGION_NAME.NATIVE_FACETED_SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsqueda por facetas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100094865038304597)
,p_name=>'REGION_NAME.NATIVE_FORM'
,p_message_language=>'es'
,p_message_text=>'Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99496060935304138)
,p_name=>'REGION_NAME.NATIVE_HELP_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto de Ayuda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100102002918304603)
,p_name=>'REGION_NAME.NATIVE_IG'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadr\00EDcula Interactiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100215790963304727)
,p_name=>'REGION_NAME.NATIVE_IR'
,p_message_language=>'es'
,p_message_text=>'Informe Interactivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99955293743304491)
,p_name=>'REGION_NAME.NATIVE_JET_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100673642915305070)
,p_name=>'REGION_NAME.NATIVE_JQM_COLUMN_TOGGLE'
,p_message_language=>'es'
,p_message_text=>unistr('Informe de Conmutaci\00F3n de Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99537257060304169)
,p_name=>'REGION_NAME.NATIVE_JQM_LIST_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100673732193305070)
,p_name=>'REGION_NAME.NATIVE_JQM_REFLOW'
,p_message_language=>'es'
,p_message_text=>'Informe de Reflujo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100241091477304746)
,p_name=>'REGION_NAME.NATIVE_JSTREE'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99494438872304137)
,p_name=>'REGION_NAME.NATIVE_LIST'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100677544203305073)
,p_name=>'REGION_NAME.NATIVE_MAP_REGION'
,p_message_language=>'es'
,p_message_text=>'Mapa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100315548687304803)
,p_name=>'REGION_NAME.NATIVE_PLSQL'
,p_message_language=>'es'
,p_message_text=>'PL/SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100240496093304746)
,p_name=>'REGION_NAME.NATIVE_SIMPLE_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico (HTML - HEREDADO)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100211541413304724)
,p_name=>'REGION_NAME.NATIVE_SQL_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100315614952304803)
,p_name=>'REGION_NAME.NATIVE_STATIC'
,p_message_language=>'es'
,p_message_text=>unistr('Contenido Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100240315128304746)
,p_name=>'REGION_NAME.NATIVE_SVG_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico (SVG - HEREDADO)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100215870473304727)
,p_name=>'REGION_NAME.NATIVE_TABFORM'
,p_message_language=>'es'
,p_message_text=>'Pantalla Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100240928378304746)
,p_name=>'REGION_NAME.NATIVE_TREE'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rbol Cl\00E1sico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99495247177304137)
,p_name=>'REGION_NAME.NATIVE_URL'
,p_message_language=>'es'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99661244886304264)
,p_name=>'REGION_TEMPLATES_NO_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Sin Plantilla'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99980202915304510)
,p_name=>'REJECTED_OR_DUPLICATE'
,p_message_language=>'es'
,p_message_text=>'Rechazado o Duplicado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100000919165304525)
,p_name=>'RELEASE'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99547709360304180)
,p_name=>'RELEASED'
,p_message_language=>'es'
,p_message_text=>'Publicado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100030833738304548)
,p_name=>'RELEASE_SUMMARY'
,p_message_language=>'es'
,p_message_text=>unistr('Resumen de Versi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100030739867304548)
,p_name=>'RELEASE_SUMMARY_FOR_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('Resumen de versi\00F3n para el espacio de trabajo: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100706165414305098)
,p_name=>'REMOTE.MORE_INFORMATION'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s Informaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100747249461305129)
,p_name=>'REMOTE.OWA_TOOLKIT_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Toolkit Web PL/SQL %0 necesario <a href="%1" target="_blank">[M\00E1s informaci\00F3n]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100747060910305129)
,p_name=>'REMOTE.PATCHSET_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('El juego de parches %0 est\00E1 disponible <a href="%1" target="_blank">[M\00E1s informaci\00F3n]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100747162701305129)
,p_name=>'REMOTE.RELEASE_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Oracle APEX %0 est\00E1 disponible <a href="%1" target="_blank">[M\00E1s informaci\00F3n]</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100706011308305098)
,p_name=>'REMOTE.SYSTEM_UP_TO_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('El sistema est\00E1 actualizado')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100647537673305050)
,p_name=>'REMOVED_DUE_TO_ACTIVITY'
,p_message_language=>'es'
,p_message_text=>'Eliminado debido a Actividad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99547273184304180)
,p_name=>'REMOVE_APPLICATION'
,p_message_language=>'es'
,p_message_text=>'Eliminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100538650516304969)
,p_name=>'REMOVE_DB_PKG_APP_WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('La definici\00F3n de la aplicaci\00F3n se eliminar\00E1, as\00ED como todos los objetos de soporte creados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100046518481304560)
,p_name=>'REMOVE_WORKSPACE_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'El espacio de trabajo se ha eliminado correctamente.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100110731765304609)
,p_name=>'RENAME_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Cambiar Nombre de la Columna %0 a %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100110957202304610)
,p_name=>'RENAME_TABLE'
,p_message_language=>'es'
,p_message_text=>'Cambiar Nombre de la Tabla %0 a %1'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99827874587304386)
,p_name=>'REORDER_BUTTONS'
,p_message_language=>'es'
,p_message_text=>unistr('Volver a Ordenar Botones de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99842975842304401)
,p_name=>'REORDER_NAVBAR'
,p_message_language=>'es'
,p_message_text=>unistr('Volver a Ordenar Entradas de Barra de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99827931974304386)
,p_name=>'REORDER_REGIONS'
,p_message_language=>'es'
,p_message_text=>'Volver a Ordenar Regiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99827583464304386)
,p_name=>'REORDER_REGION_ITEMS'
,p_message_language=>'es'
,p_message_text=>unistr('Volver a Ordenar Elementos de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99842877496304401)
,p_name=>'REORDER_TABS'
,p_message_language=>'es'
,p_message_text=>'Volver a Ordenar Fichas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99948148915304485)
,p_name=>'REPORT COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100731204445305117)
,p_name=>'REPORT_ALIAS_LABEL'
,p_message_language=>'es'
,p_message_text=>'Alias de Informe: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99948438870304485)
,p_name=>'REPORT_COLUMN'
,p_message_language=>'es'
,p_message_text=>'columna de informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100065014222304574)
,p_name=>'REPORT_COLUMNS_PAGE_TITLE'
,p_message_language=>'es'
,p_message_text=>'Columnas de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100039847953304555)
,p_name=>'REPORT_COLUMN_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Columna de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100039489599304554)
,p_name=>'REPORT_FORM_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'La pantalla y el informe se han creado correctamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100004245149304528)
,p_name=>'REPORT_GENERATED'
,p_message_language=>'es'
,p_message_text=>'Informe Generado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100071952898304579)
,p_name=>'REPORT_LAYOUT'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1o de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99900644007304448)
,p_name=>'REPORT_ON'
,p_message_language=>'es'
,p_message_text=>'Informe sobre %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100065381922304574)
,p_name=>'REPORT_PAGE_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>unistr('Atributos de P\00E1gina de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99656853299304261)
,p_name=>'REPORT_QUERIES.VALID_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta es v\00E1lida. Se han analizado las variables de enlace.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100071865161304579)
,p_name=>'REPORT_QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99905444623304452)
,p_name=>'REPORT_QUERY_STEP1'
,p_message_language=>'es'
,p_message_text=>'Paso 1: Descargar el archivo XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99905582312304452)
,p_name=>'REPORT_QUERY_STEP2'
,p_message_language=>'es'
,p_message_text=>unistr('Paso 2: Dise\00F1ar el dise\00F1o de informe y guardar como archivo RTF')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99905755007304452)
,p_name=>'REPORT_QUERY_STEP2_XSL'
,p_message_language=>'es'
,p_message_text=>'Paso 2: Cargar el archivo XSL-FO'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99905639874304452)
,p_name=>'REPORT_QUERY_STEP3'
,p_message_language=>'es'
,p_message_text=>'Paso 3: Cargar el archivo RTF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100037911004304553)
,p_name=>'REPORT_ROWS_FETCHED'
,p_message_language=>'es'
,p_message_text=>'Filas de Informe Recuperadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100106090023304606)
,p_name=>'REPORT_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'El informe se ha creado correctamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100039923624304555)
,p_name=>'REPORT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100045199141304559)
,p_name=>'REPORT_WS_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina de informe basado en servicio Web se ha creado correctamente.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99961704818304495)
,p_name=>'REQUEST'
,p_message_language=>'es'
,p_message_text=>'Solicitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100035491932304551)
,p_name=>'REQUESTED'
,p_message_language=>'es'
,p_message_text=>'Solicitado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100299631317304791)
,p_name=>'REQUEST_CHANGE_DB_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 del espacio de trabajo "%1" ha solicitado un cambio del tama\00F1o de la base de datos de %2 adicional')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100299520939304791)
,p_name=>'REQUEST_NEW_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'%0 ha solicitado un nuevo esquema para el espacio de trabajo "%1" con %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100299442958304791)
,p_name=>'REQUEST_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 solicita nuevo espacio de trabajo "%1" con un tama\00F1o de %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99549437673304181)
,p_name=>'REQUEST_WORKSPACE_EXISTING_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'%0 solicita el nuevo espacio de trabajo "%1"'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99988501268304516)
,p_name=>'RESEARCHING'
,p_message_language=>'es'
,p_message_text=>'Investigando'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99524006975304159)
,p_name=>'RESET_4000'
,p_message_language=>'es'
,p_message_text=>'Restablecer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99570911998304198)
,p_name=>'RESET_TO_NULL_VALUE'
,p_message_language=>'es'
,p_message_text=>'Restablecer Valor Nulo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99555880858304186)
,p_name=>'RESOURCE_MANAGER_CONSUMER_GROUP'
,p_message_language=>'es'
,p_message_text=>'Grupo de Consumidores del Gestor de Recursos'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100253609637304757)
,p_name=>'RESTRICTED_ACCESS'
,p_message_language=>'es'
,p_message_text=>'Acceso Restringido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99824145636304383)
,p_name=>'RESTRICTED_NO_SET_FROM_BROWSER'
,p_message_language=>'es'
,p_message_text=>'Restringido: No se puede definir desde el explorador'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100041761070304556)
,p_name=>'REST_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La referencia de servicio web se ha agregado a la aplicaci\00F3n %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99653778724304259)
,p_name=>'REST_WS.ALIASED'
,p_message_language=>'es'
,p_message_text=>'Con alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100452366489304905)
,p_name=>'REST_WS.APEX_READ_ONLY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Los servicios RESTful de APEX est\00E1n en modo de solo lectura.</p>'),
'',
unistr('<p>Puede utilizar los servicios RESTful basados en APEX tal y como est\00E1n definidos. Sin embargo, Oracle le anima a realizar la migraci\00F3n de estos servicios a ORDS haciendo clic en <strong>Migrar a servicios RESTful de ORDS</strong>.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100448919638304903)
,p_name=>'REST_WS.CURR_VESION_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la versi\00F3n de ORDS que se est\00E1 ejecutando actualmente. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99653165237304259)
,p_name=>'REST_WS.DISABLED'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100452275287304905)
,p_name=>'REST_WS.DROP_REST_WARNING'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta acci\00F3n anular\00E1 el registro y eliminar\00E1 todas las definiciones de servicio REST de ORDS para el esquema seleccionado. Esta acci\00F3n no se puede deshacer.</p>'),
'',
unistr('<p>\00BFSeguro que desea anular el registro de este esquema?</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99902215285304449)
,p_name=>'REST_WS.DUPLICATE_PATH_PREFIX'
,p_message_language=>'es'
,p_message_text=>'Ya se ha definido un prefijo de ruta de APEX con este valor para otro espacio de trabajo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99963500299304497)
,p_name=>'REST_WS.DUPLICATE_SCHEMA_ALIAS'
,p_message_language=>'es'
,p_message_text=>unistr('Este alias de esquema ya est\00E1 siendo utilizado por otro esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99653010153304258)
,p_name=>'REST_WS.ENABLED'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100688737258305085)
,p_name=>'REST_WS.ENABLED_OBJECT_COUNT_LABEL'
,p_message_language=>'es'
,p_message_text=>'Total de objetos activados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99636805232304246)
,p_name=>'REST_WS.GLOB_MUST_BE_LAST'
,p_message_language=>'es'
,p_message_text=>unistr('El car\00E1cter global (*) solo puede aparecer en el patr\00F3n de ruta como car\00E1cter final y debe ir precedido de un par\00E1metro con nombre o una barra inclinada (/).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100301841161304793)
,p_name=>'REST_WS.HANDLER_CREATED'
,p_message_language=>'es'
,p_message_text=>'Se ha creado el manejador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100302014641304793)
,p_name=>'REST_WS.HANDLER_DELETED'
,p_message_language=>'es'
,p_message_text=>'Se ha suprimido el manejador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100271521667304770)
,p_name=>'REST_WS.HANDLER_ID'
,p_message_language=>'es'
,p_message_text=>'Se esperaba un ID de manejador y se ha recibido NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100301944285304793)
,p_name=>'REST_WS.HANDLER_UPDATED'
,p_message_language=>'es'
,p_message_text=>'Se ha actualizado el manejador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99636798768304246)
,p_name=>'REST_WS.INVALID_CHARS_IN_LITERAL'
,p_message_language=>'es'
,p_message_text=>unistr('Se han encontrado caracteres no v\00E1lidos en las porciones literales del patr\00F3n de ruta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99673685439304273)
,p_name=>'REST_WS.METADATA_ACCESS_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Autorizaci\00F3n necesaria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100721632034305110)
,p_name=>'REST_WS.MIGRATION_CONFIRMATION'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding: 20px; font-size: 12px;">Al hacer clic en el bot\00F3n Migrar se copiar\00E1n todos los metadatos de todos los servicios REST basados en APEX en ORDS. Las definiciones de los servicios basados en APEX existentes permanecer\00E1n intactas, per')
||unistr('o no se ejecutar\00E1n si hay un servicio coincidente en ORDS. '),
'',
unistr('Se recomienda que, despu\00E9s de la migraci\00F3n, valide y pruebe los servicios basados en ORDS que se han migrado. Una que haya realizado las comprobaciones, exporte y suprima los servicios basados en APEX.</div>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100721595912305110)
,p_name=>'REST_WS.MIGRATION_WARNING_18_2_PLUS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX ha detectado que su espacio de trabajo contiene 2 o m\00E1s m\00F3dulos REST basados en APEX con prefijos de URI nulos. ORDS no permite que ning\00FAn m\00F3dulo comparta el mismo prefijo de URI base. </p>'),
'',
unistr('<p>Para migrar estos servicios a ORDS, se aplicar\00E1n las siguientes reglas: </p>'),
'',
'<ul>',
unistr('<li>Todos los m\00F3dulos se reducir\00E1n a un \00FAnico m\00F3dulo de ORDS llamado <em><strong>merged.apex.rest.services</strong></em>.</li>'),
unistr('<li>Si <strong><em>alguno</em></strong> de los m\00F3dulos basados en APEX en proceso de fusi\00F3n se publicara, <strong><em>se publicar\00E1</em></strong> el nuevo m\00F3dulo fusionado.</li>'),
unistr('<li>Si <strong><em>no</em></strong> se publica ninguno de los m\00F3dulos basados en APEX en proceso de fusi\00F3n, <strong><em>tampoco se publicar\00E1</em></strong> el nuevo m\00F3dulo fusionado.</li>'),
unistr('<li><strong><em>Todos los roles</em></strong> asociados a m\00F3dulos basados en APEX en proceso de fusi\00F3n <strong><em>se asignar\00E1n al m\00F3dulo fusionado</em></strong>.</li>'),
unistr('<li>El <strong><em>tama\00F1o de paginaci\00F3n</em></strong> del m\00F3dulo fusionado se establecer\00E1 en el <strong><em>mayor tama\00F1o de paginaci\00F3n</em></strong> de los m\00F3dulos en proceso de fusi\00F3n.</li>'),
unistr('<li>Si hubiera m\00F3dulos APEX con URI base nulos con URI de plantilla duplicados, ocurrir\00E1 lo siguiente:'),
'',
'<ul>',
unistr('<li>La plantilla actualizada m\00E1s reciente conservar\00E1 el URI duplicado</li>'),
unistr('<li>El resto de plantillas ir\00E1n precedidas por el prefijo dup001_*</li>'),
unistr('<li>El comentario de la plantilla tendr\00E1 el nombre original del m\00F3dulo que migr\00F3 y la plantilla de URI original</li>'),
'</ul></li>',
'</ul>',
'</div>',
'<hr/>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100721493263305109)
,p_name=>'REST_WS.MIGRATION_WARNING_PRE_18_2'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<div style="padding:20px; font-size: 12px;"><p>APEX ha detectado que su espacio de trabajo contiene 2 o m\00E1s m\00F3dulos REST basados en APEX con prefijos de URI nulos. ORDS no permite que ning\00FAn m\00F3dulo comparta el mismo prefijo de URI base. </p>'),
'',
unistr('<p>Actualmente, no es posible migrar sus servicios REST basados en APEX a ORDS. La migraci\00F3n estar\00E1 disponible a partir de la versi\00F3n 18.2 de ORDS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100688440838305085)
,p_name=>'REST_WS.MODULE_COUNT_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Total de m\00F3dulos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100301219918304792)
,p_name=>'REST_WS.MODULE_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha creado el m\00F3dulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100301499730304792)
,p_name=>'REST_WS.MODULE_DELETED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha suprimido el m\00F3dulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100271342171304770)
,p_name=>'REST_WS.MODULE_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Se esperaba un ID de m\00F3dulo y se ha recibido NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100301346279304792)
,p_name=>'REST_WS.MODULE_UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha actualizado el m\00F3dulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99636594618304246)
,p_name=>'REST_WS.NAMED_PARAM_CONTAINS_INVALID_CHARS'
,p_message_language=>'es'
,p_message_text=>unistr('Un par\00E1metro con nombre en el patr\00F3n de ruta contiene caracteres no v\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100518532568304955)
,p_name=>'REST_WS.NOT_ORDS_ENABLED'
,p_message_language=>'es'
,p_message_text=>'Este esquema no se ha registrado con servicios de datos de RESTful de ORDS. Para registrar este esquema, haga clic en <strong>Registrar esquema con ORDS</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99636910397304246)
,p_name=>'REST_WS.NOT_URI_OR_ROUTE'
,p_message_language=>'es'
,p_message_text=>unistr('La URI no coincide con un patr\00F3n de estilo URI o ROUTE.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99637012789304246)
,p_name=>'REST_WS.NO_MORE_THAN_ONE_FORWARD_SLASH'
,p_message_language=>'es'
,p_message_text=>unistr('No est\00E1 permitido tener m\00E1s de 1 barra inclinada consecutiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99636404970304246)
,p_name=>'REST_WS.NO_QUERY_STRING_IN_ROUTE_PATTERN'
,p_message_language=>'es'
,p_message_text=>unistr('No se le permite tener una cadena de consulta para un patr\00F3n de ruta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99540469025304171)
,p_name=>'REST_WS.NO_REST_IN_CDB'
,p_message_language=>'es'
,p_message_text=>unistr('<p>APEX se est\00E1 ejecutando en la CDB en estos momentos. No puede definir servicios REST basados en ORDS en la CDB.</p><p>Puede continuar utilizando servicios RESTful basados en APEX.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100452123211304905)
,p_name=>'REST_WS.OLD_ORDS_VERSION'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La versi\00F3n de ORDS (%0) instalada actualmente no soporta todas las funcionalidades necesarias para activar los servicios RESTful basados en ORDS en Application Express. Se debe instalar una versi\00F3n m\00EDnima de %1.</p> '),
'<p>Puede continuar utilizando los servicios RESTful basados en APEX.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99636616700304246)
,p_name=>'REST_WS.OPTIONAL_CHAR_MUST_BE_LAST'
,p_message_language=>'es'
,p_message_text=>unistr('El car\00E1cter opcional (?) solo puede aparecer en el patr\00F3n de ruta como car\00E1cter final y debe ir precedido de un par\00E1metro con nombre.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99635401803304245)
,p_name=>'REST_WS.ORDS_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('<p>El sistema no ha podido ubicar el esquema ORDS_METADATA necesario para habilitar el taller REST de ORDS. Consulte la Gu\00EDa de instalaci\00F3n de Oracle REST Data Services para conocer los pasos a seguir para la instalaci\00F3n.</p> <p>Puede seguir utilizan')
||'do los servicios RESTful basados en APEX.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99653636181304259)
,p_name=>'REST_WS.PARTIALLY_SECURED'
,p_message_language=>'es'
,p_message_text=>'Parcialmente seguro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99635371384304245)
,p_name=>'REST_WS.PLSQL_GATEWAY'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Actualmente, este sistema utiliza el gateway PL/SQL integrado de Oracle. Debe instalar la versi\00F3n %0 o superior de Oracle REST Data Services para habilitar el acceso al taller REST de ORDS.</p> <p>Mientras tanto, siga utilizando los servicios REST')
||'ful basados en APEX.</p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100688575923305085)
,p_name=>'REST_WS.PRIVILEGE_COUNT_LABEL'
,p_message_language=>'es'
,p_message_text=>'Total de privilegios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100302437034304793)
,p_name=>'REST_WS.PRIVILEGE_CREATED'
,p_message_language=>'es'
,p_message_text=>'Se ha creado el privilegio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100302633991304793)
,p_name=>'REST_WS.PRIVILEGE_DELETED'
,p_message_language=>'es'
,p_message_text=>'Se ha suprimido el privilegio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100302586391304793)
,p_name=>'REST_WS.PRIVILEGE_UPDATED'
,p_message_language=>'es'
,p_message_text=>'Se ha actualizado el privilegio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99653229819304259)
,p_name=>'REST_WS.PUBLISHED'
,p_message_language=>'es'
,p_message_text=>'Publicado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99654301969304259)
,p_name=>'REST_WS.RESET_SAMPLE_WARNING'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Esta acci\00F3n borrar\00E1 y volver\00E1 a crear el m\00F3dulo <strong>oracle.example.hr</strong> y los objetos de base de datos relacionados en el esquema seleccionado actual. Todos los cambios o adiciones que se hayan realizado se perder\00E1n, y esta acci\00F3n no se')
||unistr(' podr\00E1 deshacer.</p>'),
unistr('<p>\00BFSeguro que desea restablecer el servicio de ejemplo?</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100688655888305085)
,p_name=>'REST_WS.ROLE_COUNT_LABEL'
,p_message_language=>'es'
,p_message_text=>'Total de roles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100302165994304793)
,p_name=>'REST_WS.ROLE_CREATED'
,p_message_language=>'es'
,p_message_text=>'Se ha creado el rol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100302335554304793)
,p_name=>'REST_WS.ROLE_DELETED'
,p_message_language=>'es'
,p_message_text=>'Se ha suprimido el rol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100302266358304793)
,p_name=>'REST_WS.ROLE_UPDATED'
,p_message_language=>'es'
,p_message_text=>'Se ha actualizado el rol'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99673548240304273)
,p_name=>'REST_WS.SCHEMA_ACCESS_LABEL'
,p_message_language=>'es'
,p_message_text=>'Estado de acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99673731480304273)
,p_name=>'REST_WS.SCHEMA_ALIAS_LABEL'
,p_message_language=>'es'
,p_message_text=>'Alias de Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100449162333304903)
,p_name=>'REST_WS.SCRIPT_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>unistr('El script cargado es demasiado grande. Application Express tiene un l\00EDmite de 32 MB (32.767 bytes).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99653416747304259)
,p_name=>'REST_WS.SECURED'
,p_message_language=>'es'
,p_message_text=>'Seguro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100271428940304770)
,p_name=>'REST_WS.SEQ_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Se esperaba un ID de secuencia para el par\00E1metro y se ha recibido NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100688904312305085)
,p_name=>'REST_WS.SIMPLE_STATUS_FAILURE'
,p_message_language=>'es'
,p_message_text=>'Fallo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100688884982305085)
,p_name=>'REST_WS.SIMPLE_STATUS_SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100689014193305085)
,p_name=>'REST_WS.SIMPLE_STATUS_WARNING'
,p_message_language=>'es'
,p_message_text=>'Advertencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100301515733304792)
,p_name=>'REST_WS.TEMPLATE_CREATED'
,p_message_language=>'es'
,p_message_text=>'Plantilla Creada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100301723802304793)
,p_name=>'REST_WS.TEMPLATE_DELETED'
,p_message_language=>'es'
,p_message_text=>'Se ha suprimido la plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100271630648304770)
,p_name=>'REST_WS.TEMPLATE_ID'
,p_message_language=>'es'
,p_message_text=>'Se esperaba un ID de plantilla y se ha recibido NULL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99571651293304198)
,p_name=>'REST_WS.TEMPLATE_MAY_NOT_BE_NULL'
,p_message_language=>'es'
,p_message_text=>'La plantilla URI no puede ser nula.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100301602001304793)
,p_name=>'REST_WS.TEMPLATE_UPDATED'
,p_message_language=>'es'
,p_message_text=>'Se ha actualizado la plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99653929755304259)
,p_name=>'REST_WS.TREE_ENABLED_OBJECTS'
,p_message_language=>'es'
,p_message_text=>'Objetos activados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99654022666304259)
,p_name=>'REST_WS.TREE_MODULES'
,p_message_language=>'es'
,p_message_text=>unistr('M\00F3dulos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99654106813304259)
,p_name=>'REST_WS.TREE_PRIVILEGES'
,p_message_language=>'es'
,p_message_text=>'Privilegios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99654217261304259)
,p_name=>'REST_WS.TREE_ROLES'
,p_message_language=>'es'
,p_message_text=>'Roles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100677442427305073)
,p_name=>'REST_WS.TREE_TITLE'
,p_message_language=>'es'
,p_message_text=>'Servicios de datos de RESTful'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99653825301304259)
,p_name=>'REST_WS.UNALIASED'
,p_message_language=>'es'
,p_message_text=>'Sin alias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99653397579304259)
,p_name=>'REST_WS.UNPUBLISHED'
,p_message_language=>'es'
,p_message_text=>'No publicado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99653563522304259)
,p_name=>'REST_WS.UNSECURED'
,p_message_language=>'es'
,p_message_text=>'No seguro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99636386631304246)
,p_name=>'REST_WS.VARIABLE_SYNTAX_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Una o m\00E1s variables de URI tienen un error de sintaxis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100252577181304756)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('El script que intenta cargar es una exportaci\00F3n del servicio RESTful basado en APEX. No se puede cargar con la p\00E1gina de importaci\00F3n de servicios RESTful de ORDS.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100516121942304952)
,p_name=>'REST_WS.WRONG_SCRIPT_TYPE_APEX'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El script que intenta cargar es una exportaci\00F3n del servicio RESTful basado en ORDS. No se puede cargar con la p\00E1gina de importaci\00F3n de servicios RESTful de APEX.'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100689114083305085)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD'
,p_message_language=>'es'
,p_message_text=>'Copiar en portapapeles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100689261716305085)
,p_name=>'REST_WS_COPY_TO_CLIPBOARD_ARIA'
,p_message_language=>'es'
,p_message_text=>'Copiar URL completa en portapapeles'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100647448858305050)
,p_name=>'RETAINED'
,p_message_language=>'es'
,p_message_text=>'Retenido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99762162122304338)
,p_name=>'RETURN_TO_LOGIN_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Volver a P\00E1gina de Conexi\00F3n de %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100767430298305144)
,p_name=>'RETURN_VALUE.N'
,p_message_language=>'es'
,p_message_text=>'Valor de Retorno: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99988893125304516)
,p_name=>'REVIEWING'
,p_message_language=>'es'
,p_message_text=>'Revisando'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100250213408304754)
,p_name=>'ROLE'
,p_message_language=>'es'
,p_message_text=>'Rol'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99768365240304343)
,p_name=>'ROLLBACK'
,p_message_language=>'es'
,p_message_text=>unistr('La sentencia de rollback no es aplicable. Todas las sentencias se confirman autom\00E1ticamente.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100112168076304611)
,p_name=>'ROWS_IN_SECONDS'
,p_message_language=>'es'
,p_message_text=>'%0 filas devueltas en %1 segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99592024654304213)
,p_name=>'ROWS_RETURNED_IN'
,p_message_language=>'es'
,p_message_text=>'filas devueltas en'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100202807537304718)
,p_name=>'RUN'
,p_message_language=>'es'
,p_message_text=>'Ejecutar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99517198193304154)
,p_name=>'RUN_AND_BUILD'
,p_message_language=>'es'
,p_message_text=>'Ejecutar y Desarrollar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99968307989304500)
,p_name=>'RUN_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecutar Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100205644550304720)
,p_name=>'RUN_APPLICATION_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecutar Aplicaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99765098760304340)
,p_name=>'RUN_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo Ejecutar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100207604327304721)
,p_name=>'RUN_PAGE_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecutar P\00E1gina: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99571234999304198)
,p_name=>'SAMPLE APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones de Ejemplo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100165472279304690)
,p_name=>'SAMPLE_DS.COUNTRY'
,p_message_language=>'es'
,p_message_text=>unistr('Pa\00EDses')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100165765014304690)
,p_name=>'SAMPLE_DS.COUNTRY.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Listado de pa\00EDses, poblaci\00F3n y capital.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99752851532304331)
,p_name=>'SAMPLE_DS.EMP_DEPT'
,p_message_language=>'es'
,p_message_text=>'EMP / DEPT'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99752916601304332)
,p_name=>'SAMPLE_DS.EMP_DEPT.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Tablas EMP y DEPT gen\00E9ricas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100165555561304690)
,p_name=>'SAMPLE_DS.F1'
,p_message_language=>'es'
,p_message_text=>unistr('F\00F3rmula 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100165935550304690)
,p_name=>'SAMPLE_DS.F1.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Campeones del mundo de F\00F3rmula 1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100646775267305049)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES'
,p_message_language=>'es'
,p_message_text=>'Actualizaciones sobre salud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100646806355305049)
,p_name=>'SAMPLE_DS.HEALTH_UPDATES.DESC'
,p_message_language=>'es'
,p_message_text=>'Actualizaciones simplificadas del estado de salud comunicado por los pacientes para proveedores de servicios de salud.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99753053325304332)
,p_name=>'SAMPLE_DS.OEHR'
,p_message_language=>'es'
,p_message_text=>'Datos de RR. HH.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99753138378304332)
,p_name=>'SAMPLE_DS.OEHR.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Tablas de RR. HH. gen\00E9ricas que utiliza Oracle Education normalmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100205726593304720)
,p_name=>'SAMPLE_DS.ORDERS'
,p_message_language=>'es'
,p_message_text=>unistr('\00D3rdenes de Cliente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100205826979304720)
,p_name=>'SAMPLE_DS.ORDERS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Un conjunto de clientes, tiendas, productos y \00F3rdenes. Este conjunto de datos incluye datos JSON para la descripci\00F3n de productos y longitud/latitud para las tiendas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99752648476304331)
,p_name=>'SAMPLE_DS.PROJECT'
,p_message_language=>'es'
,p_message_text=>'Datos de proyecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99752706228304331)
,p_name=>'SAMPLE_DS.PROJECT.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Recopilaci\00F3n de proyectos, hitos, tareas y mucho m\00E1s. Este juego de datos incluye relaciones maestro/detalle/detalle y una vista \00FAtil para los gr\00E1ficos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99753289562304332)
,p_name=>'SAMPLE_DS.TASKS'
,p_message_language=>'es'
,p_message_text=>unistr('Hoja de c\00E1lculo de tareas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99753381896304332)
,p_name=>'SAMPLE_DS.TASKS.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Tabla \00FAnica con datos no normalizados que contiene tareas, fechas, estados, asignaciones, costos y presupuestos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100165341871304690)
,p_name=>'SAMPLE_DS.TENNIS'
,p_message_language=>'es'
,p_message_text=>'Tenis'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100165848468304690)
,p_name=>'SAMPLE_DS.TENNIS.DESC'
,p_message_language=>'es'
,p_message_text=>'Hombres y mujeres que han ganado y que han participado en torneos de Grand Slam'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100165693490304690)
,p_name=>'SAMPLE_DS.WORLD_CUP'
,p_message_language=>'es'
,p_message_text=>'Copa mundial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100166066400304690)
,p_name=>'SAMPLE_DS.WORLD_CUP.DESC'
,p_message_language=>'es'
,p_message_text=>unistr('Resultados del mundial de f\00FAtbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100049208020304562)
,p_name=>'SAMPLE_WEBSHEET'
,p_message_language=>'es'
,p_message_text=>unistr('Hoja de C\00E1lculo Web de Ejemplo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100036029485304552)
,p_name=>'SAVED_REPORTS.LINK_ALIAS'
,p_message_language=>'es'
,p_message_text=>'Alias de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100036190997304552)
,p_name=>'SAVED_REPORTS.LINK_EXAMPLE'
,p_message_language=>'es'
,p_message_text=>'Ejemplo de Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100036216055304552)
,p_name=>'SAVED_REPORTS.MORE_SAVED_REPORTS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s Informes Guardados...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100035709952304551)
,p_name=>'SAVED_REPORTS.PRIMARY_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe Primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100035066984304551)
,p_name=>'SAVED_REPORTS.PRIVATE'
,p_message_language=>'es'
,p_message_text=>'Privado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100035133257304551)
,p_name=>'SAVED_REPORTS.PRIVATE.NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Suscripci\00F3n Privada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100035695707304551)
,p_name=>'SAVED_REPORTS.PUBLIC'
,p_message_language=>'es'
,p_message_text=>unistr('P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100035982481304552)
,p_name=>'SAVED_REPORTS.REPORT_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100035825958304552)
,p_name=>'SAVED_REPORTS.REPORT_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Informe'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99680078118304278)
,p_name=>'SC.BC.BCE_DELETED'
,p_message_language=>'es'
,p_message_text=>unistr('La entrada de ruta de navegaci\00F3n se ha suprimido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99680278588304278)
,p_name=>'SC.BC.BCE_INSERTED'
,p_message_language=>'es'
,p_message_text=>unistr('La entrada de ruta de navegaci\00F3n se ha creado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99680104597304278)
,p_name=>'SC.BC.BCE_UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('La entrada de ruta de navegaci\00F3n se ha actualizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99679905324304278)
,p_name=>'SC.BC.BC_DELETED'
,p_message_language=>'es'
,p_message_text=>unistr('La ruta de navegaci\00F3n se ha suprimido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99679888882304278)
,p_name=>'SC.BC.BC_UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('La ruta de navegaci\00F3n se ha actualizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99651836132304258)
,p_name=>'SC.LOV.IG_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de cuadr\00EDcula interactiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99651772039304257)
,p_name=>'SC.LOV.PAGE_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100008234739304531)
,p_name=>'SCHEMAS'
,p_message_language=>'es'
,p_message_text=>'Esquemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100119728268304616)
,p_name=>'SCHEMA_INSERT_EXCEPTION'
,p_message_language=>'es'
,p_message_text=>unistr('excepci\00F3n de inserci\00F3n del esquema wwv_flow_companies')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100118773352304616)
,p_name=>'SCHEMA_IS_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema "%0" est\00E1 disponible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100118814183304616)
,p_name=>'SCHEMA_IS_NOT_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema "%0" NO est\00E1 disponible en este momento y no se puede crear porque entra en conflicto con un usuario existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99916448039304461)
,p_name=>'SCHEMA_PASSWORD'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a del Esquema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99733204370304317)
,p_name=>'SCHEMES'
,p_message_language=>'es'
,p_message_text=>'esquemas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100687351777305084)
,p_name=>'SCREEN_READER'
,p_message_language=>'es'
,p_message_text=>'Lector de Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100039330748304554)
,p_name=>'SCREEN_READER_TOGGLE'
,p_message_language=>'es'
,p_message_text=>'Conmutador de Lector de Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100069925111304578)
,p_name=>'SCRIPT_EXPORTED_FROM_FOREIGN_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'Este archivo se ha exportado desde otro espacio de trabajo (%0), posiblemente desde otra base de datos %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100711523848305102)
,p_name=>'SCRIPT_NAME_LOCKED'
,p_message_language=>'es'
,p_message_text=>'Script %0 bloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100711480273305102)
,p_name=>'SCRIPT_NAME_UNLOCKED'
,p_message_language=>'es'
,p_message_text=>'Script %0 desbloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100720639019305109)
,p_name=>'SCRIPT_NOT_LOCKED'
,p_message_language=>'es'
,p_message_text=>unistr('El script no est\00E1 bloqueado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99996635873304522)
,p_name=>'SC_DESCRIBE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'Para describir un objeto, introduzca <br><br> ',
'',
'DESCRIBE &lt nombre del objeto &gt en el panel de comandos anterior y haga clic en Ejecutar.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100026137207304544)
,p_name=>'SC_NAME_NN'
,p_message_language=>'es'
,p_message_text=>'El nombre de la consulta no puede ser nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100038145502304553)
,p_name=>'SC_NOT_VALID_OBJECT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre><br>',
'No se ha podido encontrar el objeto que se va a describir.',
'</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100028761263304546)
,p_name=>'SC_SC'
,p_message_language=>'es'
,p_message_text=>'Consulta no Visual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99963106001304497)
,p_name=>'SC_SQL_RUNNING'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecuci\00F3n de Sentencia SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100028652485304546)
,p_name=>'SC_VQ'
,p_message_language=>'es'
,p_message_text=>'Consulta Visual'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100651144106305053)
,p_name=>'SEARCH_BAR_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Configuraci\00F3n de Barra de B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100071179826304579)
,p_name=>'SEARCH_FIELD'
,p_message_language=>'es'
,p_message_text=>unistr('Campo de B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99916888251304461)
,p_name=>'SEARCH_NOT_ENABLED'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ninguna columna VARCHAR en esta consulta. No se puede activar la b\00FAsqueda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99906205163304452)
,p_name=>'SEARCH_NOT_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'No hay ninguna columna VARCHAR en la que buscar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100071093510304579)
,p_name=>'SEARCH_PACKAGED_APPS'
,p_message_language=>'es'
,p_message_text=>'Buscar aplicaciones de ejemplo y de productividad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100465599381304915)
,p_name=>'SEARCH_RESULTS'
,p_message_language=>'es'
,p_message_text=>unistr('Resultados de la B\00FAsqueda')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100653016618305054)
,p_name=>'SECTIONS'
,p_message_language=>'es'
,p_message_text=>'Secciones'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99712031796304302)
,p_name=>'SECURITY'
,p_message_language=>'es'
,p_message_text=>'Seguridad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100003349472304527)
,p_name=>'SECURITY_ASSIGNEE'
,p_message_language=>'es'
,p_message_text=>'Persona asignada a Seguridad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100354222090304831)
,p_name=>'SECURITY_GROUP_ID_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('El identificador de grupo de seguridad (identidad de espacio de trabajo) no es v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100001404979304526)
,p_name=>'SECURITY_IMPACT'
,p_message_language=>'es'
,p_message_text=>'Impacto de Seguridad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100043335175304557)
,p_name=>'SECURITY_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Esquema de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100029810534304547)
,p_name=>'SECURITY_SCHEME.MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'es'
,p_message_text=>unistr('No Debe Ser Usuario P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100003764287304527)
,p_name=>'SECURITY_STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado de Seguridad'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100029318432304547)
,p_name=>'SEE_ATTACHED_REPORT'
,p_message_language=>'es'
,p_message_text=>'Consulte el informe anexo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99564599767304193)
,p_name=>'SELECT_ALL'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99910560661304456)
,p_name=>'SELECT_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccionar Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99519079608304155)
,p_name=>'SELECT_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione una fecha de la tabla. Mes Actual = %0, A\00F1o Actual = %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100537538078304968)
,p_name=>'SELECT_DYNAMIC_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccionar acci\00F3n din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99721630142304309)
,p_name=>'SELECT_LABEL_TEMPLATE.THEME'
,p_message_language=>'es'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99721578276304309)
,p_name=>'SELECT_LIST_TEMPLATE.THEME'
,p_message_language=>'es'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99721409119304309)
,p_name=>'SELECT_PAGE_TEMPLATE.THEME'
,p_message_language=>'es'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99721394166304309)
,p_name=>'SELECT_REGION_TEMPLATE.THEME'
,p_message_language=>'es'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99721703006304309)
,p_name=>'SELECT_REPORT_TEMPLATE.THEME'
,p_message_language=>'es'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100738544209305122)
,p_name=>'SELECT_ROW_C'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Fila: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100173977286304696)
,p_name=>'SELECT_WORKSPACE_TEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un espacio de trabajo a continuaci\00F3n para abrir el entorno de desarrollo de Application Express.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100097538129304599)
,p_name=>'SELF_SERVICE'
,p_message_language=>'es'
,p_message_text=>'Autoservicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100097442272304599)
,p_name=>'SELF_SERVICE_WITH_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Autoservicio con Verificaci\00F3n de Correo Electr\00F3nico')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100711174898305102)
,p_name=>'SEPARATOR'
,p_message_language=>'es'
,p_message_text=>'Separador'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99730178009304315)
,p_name=>'SEQUENCE'
,p_message_language=>'es'
,p_message_text=>'secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100158550901304684)
,p_name=>'SEQUENCE_LABEL'
,p_message_language=>'es'
,p_message_text=>'Secuencia: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99595467108304216)
,p_name=>'SERIES'
,p_message_language=>'es'
,p_message_text=>'Series %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99999973564304525)
,p_name=>'SERVICE_CHANGE'
,p_message_language=>'es'
,p_message_text=>'Cambio de Servicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99543004726304173)
,p_name=>'SERVICE_LOGIN'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n de Ubicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99980053428304509)
,p_name=>'SERVICE_REQUEST'
,p_message_language=>'es'
,p_message_text=>'Solicitud de Servicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99737755272304321)
,p_name=>'SERVICE_SIGNUP.ACCEPT'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un c\00F3digo de verificaci\00F3n sensible a may\00FAsculas/min\00FAsculas y haga clic en <strong>Enviar Solicitud</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99736623966304320)
,p_name=>'SERVICE_SIGNUP.ADMIN_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n del Administrador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99737686110304321)
,p_name=>'SERVICE_SIGNUP.DB_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de la Base de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99736540568304320)
,p_name=>'SERVICE_SIGNUP.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99736987478304320)
,p_name=>'SERVICE_SIGNUP.EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99736742735304320)
,p_name=>'SERVICE_SIGNUP.FIRST_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99736397524304320)
,p_name=>'SERVICE_SIGNUP.JUSTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Justificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99736826822304320)
,p_name=>'SERVICE_SIGNUP.LAST_NAME'
,p_message_language=>'es'
,p_message_text=>'Apellido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99736219535304320)
,p_name=>'SERVICE_SIGNUP.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99737428081304320)
,p_name=>'SERVICE_SIGNUP.NO'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99737078360304320)
,p_name=>'SERVICE_SIGNUP.PHONE'
,p_message_language=>'es'
,p_message_text=>unistr('Tel\00E9fono')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99737297878304320)
,p_name=>'SERVICE_SIGNUP.REUSE_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'Volver a Usar Esquema Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99737173479304320)
,p_name=>'SERVICE_SIGNUP.SCHEMA_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n de Esquema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99737597953304320)
,p_name=>'SERVICE_SIGNUP.SCHEMA_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99736124249304319)
,p_name=>'SERVICE_SIGNUP.WORKSPACE_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n de Espacio de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99737352441304320)
,p_name=>'SERVICE_SIGNUP.YES'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99929043004304470)
,p_name=>'SESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100031773839304549)
,p_name=>'SESSION VERIFY FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n de Verificaci\00F3n de Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99572795780304199)
,p_name=>'SESSIONS'
,p_message_language=>'es'
,p_message_text=>'Sesiones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100095469322304598)
,p_name=>'SESSION_MON_BUFFER'
,p_message_language=>'es'
,p_message_text=>'Buffer:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100095221974304597)
,p_name=>'SESSION_MON_CPU'
,p_message_language=>'es'
,p_message_text=>'CPU:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100094968597304597)
,p_name=>'SESSION_MON_CURRENT'
,p_message_language=>'es'
,p_message_text=>'Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100095311108304598)
,p_name=>'SESSION_MON_DISK'
,p_message_language=>'es'
,p_message_text=>'Disco:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100095144684304597)
,p_name=>'SESSION_MON_ELAPSED'
,p_message_language=>'es'
,p_message_text=>'Transcurrido:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100095022999304597)
,p_name=>'SESSION_MON_PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99656344252304261)
,p_name=>'SET_BINDS'
,p_message_language=>'es'
,p_message_text=>'Los valores de todas las variables de enlace se deben definir al probar una consulta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99558552486304188)
,p_name=>'SET_FEATURE_DUE_DATE_TO_MILESTONE_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('Defina la fecha de vencimiento de las funciones con un %0 sin terminar asignadas a %1 para la versi\00F3n %2 en la fecha del hito')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99678389719304277)
,p_name=>'SET_MILESTONE'
,p_message_language=>'es'
,p_message_text=>'Definir Hito'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99558879665304188)
,p_name=>'SET_MILESTONES_NOT_YET_SET'
,p_message_language=>'es'
,p_message_text=>unistr('Defina las funciones en las que falten hitos en el hito (%3) para las funciones con un %0 sin terminar asignadas a %1 para la versi\00F3n %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99558713878304188)
,p_name=>'SET_MILESTONE_OF_INCOMPLETE_FEATURES'
,p_message_language=>'es'
,p_message_text=>unistr('Cambie el hito de las funciones con un %0 sin terminar asignadas a %1 para la versi\00F3n %2 que corresponde a un hito con vencimiento pasado al hito (%3).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99677991848304276)
,p_name=>'SET_OPEN_FEATURES_M1'
,p_message_language=>'es'
,p_message_text=>unistr('%0 funciones abiertas se asignar\00E1n al hito seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99678499107304277)
,p_name=>'SET_OPEN_FEATURES_M2'
,p_message_language=>'es'
,p_message_text=>unistr('La fecha de vencimiento de %0 funciones abiertas se definir\00E1 en la fecha del hito.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100715659717305105)
,p_name=>'SET_PREFERENCES'
,p_message_language=>'es'
,p_message_text=>'Definir Preferencias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99678652838304277)
,p_name=>'SET_RELEASE'
,p_message_language=>'es'
,p_message_text=>unistr('Definir Versi\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100094225329304597)
,p_name=>'SHARED'
,p_message_language=>'es'
,p_message_text=>'Compartido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100273431483304771)
,p_name=>'SHARED COMPONENTS'
,p_message_language=>'es'
,p_message_text=>'Componentes Compartidos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100031465028304548)
,p_name=>'SHARED DYNAMIC LOV'
,p_message_language=>'es'
,p_message_text=>unistr('Lista de Valores Est\00E1tica Compartida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99527960560304162)
,p_name=>'SHARED POOL'
,p_message_language=>'es'
,p_message_text=>'Pool Compartido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100031301520304548)
,p_name=>'SHARED STATIC LOV CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Lista de Valores Est\00E1tica Compartida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99602990119304221)
,p_name=>'SHARED_COMPONENT'
,p_message_language=>'es'
,p_message_text=>'Componente Compartido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100270726362304769)
,p_name=>'SHARED_VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n Compartida')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99733381920304317)
,p_name=>'SHORTCUT'
,p_message_language=>'es'
,p_message_text=>unistr('m\00E9todo abreviado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100175965720304698)
,p_name=>'SHORTCUTS'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E9todos Abreviados')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99982934482304512)
,p_name=>'SIGNIFICANT_IMPACT'
,p_message_language=>'es'
,p_message_text=>'Impacto Significativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99986094989304514)
,p_name=>'SIGNIFICANT_PROGRESS'
,p_message_language=>'es'
,p_message_text=>'Progreso Significativo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99731877264304316)
,p_name=>'SIMPLE'
,p_message_language=>'es'
,p_message_text=>'simple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99977488952304507)
,p_name=>'SIMPLE_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico Simple')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100054559200304566)
,p_name=>'SINCE_DATE_MASK'
,p_message_language=>'es'
,p_message_text=>'Hace 16 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100114036086304612)
,p_name=>'SINCE_DAY_AGO'
,p_message_language=>'es'
,p_message_text=>unistr('Hace 1 d\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100113980434304612)
,p_name=>'SINCE_HOUR_AGO'
,p_message_language=>'es'
,p_message_text=>'Hace 1 hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100733961781305119)
,p_name=>'SINCE_SHORT_DATE_MASK'
,p_message_language=>'es'
,p_message_text=>'en 16 h'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100114154484304612)
,p_name=>'SINCE_WEEK_AGO'
,p_message_language=>'es'
,p_message_text=>'Hace 1 semana'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99569511974304197)
,p_name=>'SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100690390896305086)
,p_name=>'SL.APP'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100686432078305083)
,p_name=>'SL.EDIT.PAGE.IN.APP'
,p_message_language=>'es'
,p_message_text=>unistr('Editar la p\00E1gina %0 en la aplicaci\00F3n %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100686547830305083)
,p_name=>'SL.GO.TO.APP'
,p_message_language=>'es'
,p_message_text=>unistr('Ir a aplicaci\00F3n %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100516373356304952)
,p_name=>'SL.MATCH.FOUND'
,p_message_language=>'es'
,p_message_text=>'1 coincidencia encontrada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100516431580304953)
,p_name=>'SL.N.MATCHES.FOUND'
,p_message_language=>'es'
,p_message_text=>'%0 coincidencias encontradas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100533702457304965)
,p_name=>'SL.NO.MATCH.FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna coincidencia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100690413001305086)
,p_name=>'SL.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100207747499304721)
,p_name=>'SL.PLACEHOLDER'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100253023641304756)
,p_name=>'SL.SEARCH.ALLAPPS'
,p_message_language=>'es'
,p_message_text=>'Buscar todas las aplicaciones para %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100686845440305084)
,p_name=>'SL.SEARCH.APP'
,p_message_language=>'es'
,p_message_text=>unistr('Buscar %0 en esta aplicaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100448503068304903)
,p_name=>'SL.SEARCH.HELP'
,p_message_language=>'es'
,p_message_text=>'Introduzca al menos dos letras para buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100686787613305083)
,p_name=>'SL.SEARCH.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Buscar %0 en p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100686927270305084)
,p_name=>'SL.SEARCH.TEAM.DEV'
,p_message_language=>'es'
,p_message_text=>'Buscar %0 en desarrollo de equipos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100687087920305084)
,p_name=>'SL.SEARCH.USER'
,p_message_language=>'es'
,p_message_text=>'Buscar usuario %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100687184401305084)
,p_name=>'SL.SEARCH.WP'
,p_message_language=>'es'
,p_message_text=>'Buscar %0 en espacio de trabajo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100686641707305083)
,p_name=>'SL.SHARED.COMP.APP'
,p_message_language=>'es'
,p_message_text=>unistr('Componentes compartidos de la aplicaci\00F3n %0')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99979971944304509)
,p_name=>'SOFTWARE_DEFECT'
,p_message_language=>'es'
,p_message_text=>'Defecto de Software'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99984941721304513)
,p_name=>'SOMEWHAT_DESIRABLE'
,p_message_language=>'es'
,p_message_text=>'Bastante Deseable'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100312371916304800)
,p_name=>'SOURCE_IDENTIFIER'
,p_message_language=>'es'
,p_message_text=>'Identificador de Origen'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100119075077304616)
,p_name=>'SPACE_UTILIZATION'
,p_message_language=>'es'
,p_message_text=>'Uso de Espacio Existente'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99968549071304501)
,p_name=>'SQL NOT AVAILABLE'
,p_message_language=>'es'
,p_message_text=>'SQL no disponible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100176393109304698)
,p_name=>'SQL WORKSHOP'
,p_message_language=>'es'
,p_message_text=>'Taller de SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100112089794304610)
,p_name=>'SQL_COMMANDS'
,p_message_language=>'es'
,p_message_text=>'Comandos SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100007334801304530)
,p_name=>'SQL_COMMAND_HISTORY'
,p_message_language=>'es'
,p_message_text=>'Historial de Comandos SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99785263401304355)
,p_name=>'SQL_EXPRESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100045687830304559)
,p_name=>'SQL_INJECT_LINE'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100045345925304559)
,p_name=>'SQL_INJECT_PACKAGE'
,p_message_language=>'es'
,p_message_text=>'Paquete'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100045494595304559)
,p_name=>'SQL_INJECT_PROCEDURE'
,p_message_language=>'es'
,p_message_text=>'Procedimiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100045217188304559)
,p_name=>'SQL_INJECT_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100045526898304559)
,p_name=>'SQL_INJECT_VAR'
,p_message_language=>'es'
,p_message_text=>'Variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100331090701304814)
,p_name=>'SQL_NOT_ENABLED_APP'
,p_message_language=>'es'
,p_message_text=>unistr('El acceso SQL y PL/SQL no est\00E1 activado para esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100331177337304814)
,p_name=>'SQL_NOT_ENABLED_INST'
,p_message_language=>'es'
,p_message_text=>unistr('El acceso SQL y PL/SQL no est\00E1 activado para esta instancia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99730995540304316)
,p_name=>'SQL_QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99536969129304169)
,p_name=>'SQL_QUERY_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Consulta no v\00E1lida, no se ha encontrado ninguna sentencia select')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99832418614304389)
,p_name=>'SQL_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99635885677304245)
,p_name=>'SQL_REPORT_WIZ.APPEND'
,p_message_language=>'es'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99724683434304311)
,p_name=>'SQL_REPORT_WIZ.DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99725175994304311)
,p_name=>'SQL_REPORT_WIZ.DISABLE_SORT_COL'
,p_message_language=>'es'
,p_message_text=>unistr('Desactivar Columna de Ordenaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99724355005304311)
,p_name=>'SQL_REPORT_WIZ.DISPLAY_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de Visualizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99724703298304311)
,p_name=>'SQL_REPORT_WIZ.PRIMARY_SORT_COL'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Ordenaci\00F3n Primaria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99635748172304245)
,p_name=>'SQL_REPORT_WIZ.REPLACE'
,p_message_language=>'es'
,p_message_text=>'Sustituir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99724449285304311)
,p_name=>'SQL_REPORT_WIZ.RETURN_VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor de Retorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99724942302304311)
,p_name=>'SQL_REPORT_WIZ.SECONDARY_SORT_COL'
,p_message_language=>'es'
,p_message_text=>unistr('Columna de Ordenaci\00F3n Secundaria')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99725077358304311)
,p_name=>'SQL_REPORT_WIZ.SELECT_COL'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100007585028304530)
,p_name=>'SQL_SCRIPTS'
,p_message_language=>'es'
,p_message_text=>'Scripts SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100007489660304530)
,p_name=>'SQL_SCRIPT_RESULTS'
,p_message_language=>'es'
,p_message_text=>'Resultados de Script SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100317182816304804)
,p_name=>'SQL_TAG_REF_NOT_DEFINED'
,p_message_language=>'es'
,p_message_text=>'Se deben definir los siguientes objetos de base de datos en la lista de tablas permitidas: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100007644350304530)
,p_name=>'SQL_WORKSHOP'
,p_message_language=>'es'
,p_message_text=>'Taller de SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99787526920304357)
,p_name=>'SQL_WS.OB.DUPLICATE_ALIAS'
,p_message_language=>'es'
,p_message_text=>unistr('Otro objeto ya est\00E1 utilizando el alias especificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99787452511304357)
,p_name=>'SQL_WS.OB.INVALID_ALIAS'
,p_message_language=>'es'
,p_message_text=>unistr('El alias de objeto proporcionado no es v\00E1lido. Los alias v\00E1lidos solo pueden contener letras, n\00FAmeros, caracteres de subrayado y guiones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100101118383304602)
,p_name=>'SQL_WS.OB.NOT_ORDS_ENABLED'
,p_message_language=>'es'
,p_message_text=>unistr('Este esquema no se ha registrado en los servicios de datos de RESTful de ORDS. Para registrar este esquema, vaya a <strong>Servicios RESTful> Servicios RESTful de ORDS</strong> y haga clic en el bot\00F3n <strong>Registrar esquema con ORDS</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100116123777304614)
,p_name=>'SQL_WS.OB.NO_REST_IN_CDB'
,p_message_language=>'es'
,p_message_text=>unistr('APEX se est\00E1 ejecutando en la CDB en estos momentos. No puede definir servicios REST basados en ORDS en la CDB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100115914153304613)
,p_name=>'SQL_WS.OB.OLD_ORDS_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('La versi\00F3n actual instalada de ORDS (%0) no soporta todas las funcionalidades necesarias para activar objetos de base de datos para REST. Para ello, es necesario instalar una versi\00F3n de %1 o superior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100115790761304613)
,p_name=>'SQL_WS.OB.ORDS_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('El sistema no ha podido ubicar el esquema ORDS_METADATA necesario para habilitar los servicios REST de ORDS. Consulte los pasos a seguir para la instalaci\00F3n en Oracle REST Data Services Installation Guide.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100116072971304613)
,p_name=>'SQL_WS.OB.ORDS_VERION'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n de ORDS <strong>%0</strong>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100115807737304613)
,p_name=>'SQL_WS.OB.PLSQL_GATEWAY'
,p_message_language=>'es'
,p_message_text=>unistr('Actualmente, este sistema utiliza el gateway PL/SQL integrado de Oracle. Debe instalar la versi\00F3n %0 o superior de Oracle REST Data Services para activar los objetos de base de datos para REST.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99505866446304145)
,p_name=>'STACKED2DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 2D Apilada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99505901258304145)
,p_name=>'STACKED3DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 3D Apilada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99506082894304145)
,p_name=>'STACKEDHORIZONTAL2DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 2D Horizontal Apilada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99506190678304146)
,p_name=>'STACKEDHORIZONTAL3DCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna 3D Horizontal Apilada'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100272202828304771)
,p_name=>'STANDARD _TABS'
,p_message_language=>'es'
,p_message_text=>unistr('Separadores Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100273999267304772)
,p_name=>'STANDARD_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('Separador Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99712123236304302)
,p_name=>'STANDARD_TAB_SET'
,p_message_language=>'es'
,p_message_text=>unistr('Juego de Separadores Est\00E1ndar')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99598375345304218)
,p_name=>'STATIC APPLICATION FILES'
,p_message_language=>'es'
,p_message_text=>unistr('Archivos de Aplicaci\00F3n Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99598254347304218)
,p_name=>'STATIC WORKSPACE FILES'
,p_message_language=>'es'
,p_message_text=>unistr('Archivos de Espacio de Trabajo Est\00E1ticos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100768924954305145)
,p_name=>'STATICSEARCH.MINIMUM_LENGTH'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca al menos una palabra clave que tenga, como m\00EDnimo, dos caracteres. ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100769059177305145)
,p_name=>'STATICSEARCH.NO_RESULTS_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se han encontrado resultados que coincidan con la consulta de b\00FAsqueda. ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99785023718304355)
,p_name=>'STATIC_ASSIGNMENT'
,p_message_language=>'es'
,p_message_text=>unistr('Asignaci\00F3n Est\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100117564317304615)
,p_name=>'STATIC_FILES_NO_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Ninguna Aplicaci\00F3n Asociada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99529144473304163)
,p_name=>'STATIC_HTML'
,p_message_language=>'es'
,p_message_text=>unistr('HTML Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99512619854304150)
,p_name=>'STATIC_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Referencia Est\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99976201563304506)
,p_name=>'STATIC_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n est\00E1tica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100040844709304555)
,p_name=>'STATIC_SUBSTITUTION_STRINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Cadenas de Sustituci\00F3n Est\00E1ticas')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100731664991305117)
,p_name=>'STATUS_LABEL'
,p_message_language=>'es'
,p_message_text=>'Estado: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99912032576304457)
,p_name=>'STATUS_MODIFIED'
,p_message_language=>'es'
,p_message_text=>'Estado Modificado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100027435541304545)
,p_name=>'STD TAB CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de Separador Est\00E1ndar')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100720774315305109)
,p_name=>'STEAL_LOCK'
,p_message_language=>'es'
,p_message_text=>'Eliminar Bloqueo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99572473037304199)
,p_name=>'STORAGE'
,p_message_language=>'es'
,p_message_text=>'Almacenamiento:'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99731022037304316)
,p_name=>'STRUCTURED_QUERY'
,p_message_language=>'es'
,p_message_text=>'consulta estructurada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99832278248304389)
,p_name=>'STRUCTURED_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe Estructurado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100118445177304615)
,p_name=>'SUBMIT'
,p_message_language=>'es'
,p_message_text=>'Ejecutar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99911998977304457)
,p_name=>'SUBMITTED'
,p_message_language=>'es'
,p_message_text=>'Ejecutado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99827792464304386)
,p_name=>'SUBMIT_AS'
,p_message_language=>'es'
,p_message_text=>'Ejecutar como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100037630063304553)
,p_name=>'SUBMIT_FEEDBACK'
,p_message_language=>'es'
,p_message_text=>'Enviar Comentarios'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99969796787304502)
,p_name=>'SUBORDINATE CURRENT ENTRY'
,p_message_language=>'es'
,p_message_text=>'Entrada Actual Subordinada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99969878900304502)
,p_name=>'SUBORDINATE NON CURRENT ENTRY'
,p_message_language=>'es'
,p_message_text=>'Entrada no Actual Subordinada'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100746599237305128)
,p_name=>'SUBSCRIBED_FROM.NONEXISTING_MASTER'
,p_message_language=>'es'
,p_message_text=>'Maestro no Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100746724895305128)
,p_name=>'SUBSCRIBED_FROM.THEME'
,p_message_language=>'es'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100746660126305128)
,p_name=>'SUBSCRIBED_FROM.THEME_REPOSITORY'
,p_message_language=>'es'
,p_message_text=>'Repositorio de Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99714226486304303)
,p_name=>'SUBSCRIBE_AUTHORIZATION.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99714592585304304)
,p_name=>'SUBSCRIBE_AUTHORIZATION.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('\00C9sta es la copia "maestra" de este esquema de autorizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99714746425304304)
,p_name=>'SUBSCRIBE_AUTHORIZATION.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ning\00FAn esquema de autorizaci\00F3n que suscribir a este esquema de autorizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99714690026304304)
,p_name=>'SUBSCRIBE_AUTHORIZATION.REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Esquemas de autorizaci\00F3n que se suscriben a este esquema de autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99516689908304153)
,p_name=>'SUBSCRIBE_DATA_LOAD.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99516948686304154)
,p_name=>'SUBSCRIBE_DATA_LOAD.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('Esta es la copia "maestra" de esta definici\00F3n de carga de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99516861084304154)
,p_name=>'SUBSCRIBE_DATA_LOAD.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ninguna definici\00F3n de carga de datos suscrita a esta definici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99516771642304153)
,p_name=>'SUBSCRIBE_DATA_LOAD.REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Suscripci\00F3n de la definici\00F3n de carga de datos a esta definici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99713695153304303)
,p_name=>'SUBSCRIBE_ITEM_HELP.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99713708480304303)
,p_name=>'SUBSCRIBE_ITEM_HELP.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('\00C9sta es la copia "maestra" de esta ayuda de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99713902538304303)
,p_name=>'SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ning\00FAn elemento que suscribir a este texto de ayuda de elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99713891283304303)
,p_name=>'SUBSCRIBE_ITEM_HELP.REFERENCE'
,p_message_language=>'es'
,p_message_text=>'Elementos que se suscriben a este texto de ayuda de elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99716205622304305)
,p_name=>'SUBSCRIBE_LOV.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99716345370304305)
,p_name=>'SUBSCRIBE_LOV.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('\00C9sta es la copia "maestra" de esta lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99716545006304305)
,p_name=>'SUBSCRIBE_LOV.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>'No hay ninguna lista de valores suscrita a esta lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99716409136304305)
,p_name=>'SUBSCRIBE_LOV.REFERENCE'
,p_message_language=>'es'
,p_message_text=>'Listas de valores que se suscriben a esta lista de valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99604338692304222)
,p_name=>'SUBSCRIBE_NAVBAR.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99717821945304306)
,p_name=>'SUBSCRIBE_NAVBAR.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('\00C9sta es la copia "maestra" de esta barra de navegaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99718442721304307)
,p_name=>'SUBSCRIBE_NAVBAR.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ninguna barra de navegaci\00F3n que suscribir a esta barra de navegaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99718181390304306)
,p_name=>'SUBSCRIBE_NAVBAR.REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Barras de navegaci\00F3n que se suscriben a esta barra de navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99603959550304222)
,p_name=>'SUBSCRIBE_PLUGIN.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99604096112304222)
,p_name=>'SUBSCRIBE_PLUGIN.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('\00C9sta es la copia "maestra" de este plugin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99604291310304222)
,p_name=>'SUBSCRIBE_PLUGIN.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ning\00FAn plugin suscrito a este plugin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99604125786304222)
,p_name=>'SUBSCRIBE_PLUGIN.REFERENCE'
,p_message_language=>'es'
,p_message_text=>'Plugins que se suscriben a este plugin'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99715073754304304)
,p_name=>'SUBSCRIBE_SHORTCUT.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99715228153304304)
,p_name=>'SUBSCRIBE_SHORTCUT.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('\00C9sta es la copia \005C"maestra\005C" de este acceso directo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99715543974304304)
,p_name=>'SUBSCRIBE_SHORTCUT.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ning\00FAn m\00E9todo abreviado que suscribir a este m\00E9todo abreviado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99715421005304304)
,p_name=>'SUBSCRIBE_SHORTCUT.REFERENCE'
,p_message_language=>'es'
,p_message_text=>'Accesos directos que se suscriben a este acceso directo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99709873500304300)
,p_name=>'SUBSCRIBE_TEMPLATE.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99710094202304300)
,p_name=>'SUBSCRIBE_TEMPLATE.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('\00C9sta es la copia "maestra" de esta plantilla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99710182127304300)
,p_name=>'SUBSCRIBE_TEMPLATE.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>'No hay ninguna plantilla que suscribir a esta plantilla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99709944337304300)
,p_name=>'SUBSCRIBE_TEMPLATE.POPUP_LOV'
,p_message_language=>'es'
,p_message_text=>'Plantilla de Lista de Valores Emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99720961866304308)
,p_name=>'SUBSCRIBE_TEMPLATE.REFERENCE'
,p_message_language=>'es'
,p_message_text=>'Plantillas que se suscriben a esta plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100685358324305082)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Suscrito al Tema de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100727917324305114)
,p_name=>'SUBSCRIBE_THEME.COPIED_FROM_THEME'
,p_message_language=>'es'
,p_message_text=>unistr('Suscrito al Tema Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100685737479305083)
,p_name=>'SUBSCRIBE_THEME.MASTER'
,p_message_language=>'es'
,p_message_text=>'Esta es la copia "maestra" de este tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100685676134305083)
,p_name=>'SUBSCRIBE_THEME.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn tema se suscribe a este tema. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100685412903305083)
,p_name=>'SUBSCRIBE_THEME.POPUP_LOV'
,p_message_language=>'es'
,p_message_text=>'Tema de Lista de Valores Emergente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100685573309305083)
,p_name=>'SUBSCRIBE_THEME.REFERENCE'
,p_message_language=>'es'
,p_message_text=>'Temas que se suscriben este tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100093231104304596)
,p_name=>'SUBSCRIBE_WEB_SRC.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100093356410304596)
,p_name=>'SUBSCRIBE_WEB_SRC.MASTER'
,p_message_language=>'es'
,p_message_text=>'Esta es la copia "maestra" de este origen de datos de REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100093579705304596)
,p_name=>'SUBSCRIBE_WEB_SRC.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('No hay or\00EDgenes de datos de REST suscritos a este origen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100093443498304596)
,p_name=>'SUBSCRIBE_WEB_SRC.REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Se est\00E1n suscribiendo or\00EDgenes de datos de REST a este origen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99719922208304308)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.COPIED_FROM'
,p_message_language=>'es'
,p_message_text=>unistr('Copiado de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99720789635304308)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('\00C9sta es la copia "maestra" de esta plantilla de bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99721139817304309)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.NO_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ninguna plantilla que suscribir a esta plantilla de bot\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99721045881304308)
,p_name=>'SUBSCRIPTION_BUTTON_TEMPL.REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Plantillas de bot\00F3n que se suscriben a esta plantilla de bot\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99547953458304180)
,p_name=>'SUBSTITUTION_STRING_USAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Sintaxis de Cadena de Sustituci\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99948662083304485)
,p_name=>'SUCCESS'
,p_message_language=>'es'
,p_message_text=>'correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100025119709304544)
,p_name=>'SUCCESS MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Mensaje Correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99911031277304456)
,p_name=>'SUCCESSES'
,p_message_language=>'es'
,p_message_text=>'Tareas Correctas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99777787431304349)
,p_name=>'SUCCESS_MSG.CLUSTER_TRUNCATED'
,p_message_language=>'es'
,p_message_text=>'Cluster truncado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99774038582304347)
,p_name=>'SUCCESS_MSG.CMD_EXECUTED'
,p_message_language=>'es'
,p_message_text=>'Comando ejecutado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99776874363304349)
,p_name=>'SUCCESS_MSG.CONTEXT_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Contexto borrado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99777042828304349)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_CREATED'
,p_message_language=>'es'
,p_message_text=>'Enlace de base de datos creado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99776914410304349)
,p_name=>'SUCCESS_MSG.DATABASE_LINK_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Enlace de base de datos borrado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99777944394304350)
,p_name=>'SUCCESS_MSG.FUNCTION_ALTERED'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n modificada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99772936703304346)
,p_name=>'SUCCESS_MSG.FUNCTION_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n creada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99775847434304348)
,p_name=>'SUCCESS_MSG.FUNCTION_DROPPED'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n borrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99777523904304349)
,p_name=>'SUCCESS_MSG.INDEXTYPE_ALTERED'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de \00EDndice modificado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99776734463304349)
,p_name=>'SUCCESS_MSG.INDEXTYPE_DROPPED'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de \00EDndice borrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99773302437304346)
,p_name=>'SUCCESS_MSG.INDEX_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('\00CDndice creado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99776179821304348)
,p_name=>'SUCCESS_MSG.INDEX_DROPPED'
,p_message_language=>'es'
,p_message_text=>unistr('\00CDndice borrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99773689509304347)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_CREATED'
,p_message_language=>'es'
,p_message_text=>'Vista materializada creada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99776253947304348)
,p_name=>'SUCCESS_MSG.MATERIALIZED_VIEW_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Vista materializada borrada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99777870497304350)
,p_name=>'SUCCESS_MSG.PACKAGE_ALTERED'
,p_message_language=>'es'
,p_message_text=>'Paquete modificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99773128734304346)
,p_name=>'SUCCESS_MSG.PKG_BODY_CREATED'
,p_message_language=>'es'
,p_message_text=>'Cuerpo del paquete creado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99773260041304346)
,p_name=>'SUCCESS_MSG.PKG_CREATED'
,p_message_language=>'es'
,p_message_text=>'Paquete creado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99775146110304348)
,p_name=>'SUCCESS_MSG.PKG_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Paquete borrado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99778002874304350)
,p_name=>'SUCCESS_MSG.PROCEDURE_ALTERED'
,p_message_language=>'es'
,p_message_text=>'Procedimiento modificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99773011109304346)
,p_name=>'SUCCESS_MSG.PROCEDURE_CREATED'
,p_message_language=>'es'
,p_message_text=>'Procedimiento creado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99775954161304348)
,p_name=>'SUCCESS_MSG.PROCEDURE_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Procedimiento borrado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99773734660304347)
,p_name=>'SUCCESS_MSG.ROLE_CREATED'
,p_message_language=>'es'
,p_message_text=>'Rol creado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99776399127304348)
,p_name=>'SUCCESS_MSG.ROLE_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Rol borrado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99774592897304347)
,p_name=>'SUCCESS_MSG.ROWS_DELETED'
,p_message_language=>'es'
,p_message_text=>'%0 fila(s) suprimida(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99774354671304347)
,p_name=>'SUCCESS_MSG.ROWS_INSERTED'
,p_message_language=>'es'
,p_message_text=>'%0 fila(s) insertada(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99774253772304347)
,p_name=>'SUCCESS_MSG.ROWS_UPDATED'
,p_message_language=>'es'
,p_message_text=>'%0 fila(s) actualizada(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99778125756304350)
,p_name=>'SUCCESS_MSG.SEQ_ALTERED'
,p_message_language=>'es'
,p_message_text=>'Secuencia modificada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99773829195304347)
,p_name=>'SUCCESS_MSG.SEQ_CREATED'
,p_message_language=>'es'
,p_message_text=>'Secuencia creada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99775537974304348)
,p_name=>'SUCCESS_MSG.SEQ_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Secuencia borrada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99499530998304141)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_CREATED'
,p_message_language=>'es'
,p_message_text=>'Fila creada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99499443984304141)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_DELETED'
,p_message_language=>'es'
,p_message_text=>'Fila suprimida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99499338581304140)
,p_name=>'SUCCESS_MSG.SINGLE_ROW_UPDATED'
,p_message_language=>'es'
,p_message_text=>'Fila actualizada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99534388759304167)
,p_name=>'SUCCESS_MSG.STMT_PROCESSED'
,p_message_language=>'es'
,p_message_text=>'Sentencia procesada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99773993423304347)
,p_name=>'SUCCESS_MSG.SYNONYM_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Sin\00F3nimo creado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99776491447304349)
,p_name=>'SUCCESS_MSG.SYNONYM_DROPPED'
,p_message_language=>'es'
,p_message_text=>unistr('Sin\00F3nimo borrado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99775630609304348)
,p_name=>'SUCCESS_MSG.TABLE_ALTERED'
,p_message_language=>'es'
,p_message_text=>'Tabla modificada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99772582548304346)
,p_name=>'SUCCESS_MSG.TABLE_CREATED'
,p_message_language=>'es'
,p_message_text=>'Tabla creada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99775027231304348)
,p_name=>'SUCCESS_MSG.TABLE_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Tabla borrada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99777155199304349)
,p_name=>'SUCCESS_MSG.TABLE_RENAMED'
,p_message_language=>'es'
,p_message_text=>'Nombre de tabla cambiado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99777645267304349)
,p_name=>'SUCCESS_MSG.TABLE_TRUNCATED'
,p_message_language=>'es'
,p_message_text=>'Tabla truncada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99777429502304349)
,p_name=>'SUCCESS_MSG.TRIGGER_ALTERED'
,p_message_language=>'es'
,p_message_text=>'Disparador modificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99772868153304346)
,p_name=>'SUCCESS_MSG.TRIGGER_CREATED'
,p_message_language=>'es'
,p_message_text=>'Disparador creado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99776532776304349)
,p_name=>'SUCCESS_MSG.TRIGGER_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Disparador borrado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99777339214304349)
,p_name=>'SUCCESS_MSG.TYPE_ALTERED'
,p_message_language=>'es'
,p_message_text=>'Tipo modificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99773446082304346)
,p_name=>'SUCCESS_MSG.TYPE_CREATED'
,p_message_language=>'es'
,p_message_text=>'Tipo creado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99776638820304349)
,p_name=>'SUCCESS_MSG.TYPE_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Tipo borrado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99778299137304350)
,p_name=>'SUCCESS_MSG.USER_ALTERED'
,p_message_language=>'es'
,p_message_text=>'Usuario modificado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99773575983304346)
,p_name=>'SUCCESS_MSG.USER_CREATED'
,p_message_language=>'es'
,p_message_text=>'Usuario creado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99775291442304348)
,p_name=>'SUCCESS_MSG.USER_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Usuario borrado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99777252888304349)
,p_name=>'SUCCESS_MSG.VIEW_ALTERED'
,p_message_language=>'es'
,p_message_text=>'Vista modificada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99772694774304346)
,p_name=>'SUCCESS_MSG.VIEW_CREATED'
,p_message_language=>'es'
,p_message_text=>'Vista creada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99775320579304348)
,p_name=>'SUCCESS_MSG.VIEW_DROPPED'
,p_message_language=>'es'
,p_message_text=>'Vista borrada.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100117168792304614)
,p_name=>'SUPPORTING_OBJECTS'
,p_message_language=>'es'
,p_message_text=>'Objetos de Soporte'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100653850458305055)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'
,p_message_language=>'es'
,p_message_text=>unistr('La definici\00F3n del objeto ha cambiado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100653979332305055)
,p_name=>'SUPPORTING_OBJECTS.OBJECT_DELETED'
,p_message_language=>'es'
,p_message_text=>'El objeto ya no existe.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99977772735304508)
,p_name=>'SVG CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico SVG')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100067280846304576)
,p_name=>'SVG PLUGIN'
,p_message_language=>'es'
,p_message_text=>unistr('Instale el visor SVG para ver el gr\00E1fico.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99497822360304139)
,p_name=>'SW_EMPTY_SCRIPT'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede editar un script SQL vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99497978733304139)
,p_name=>'SW_GREATER_THAN_30K'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede editar un script que tenga m\00E1s de 30.000 bytes.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99730215158304315)
,p_name=>'SYNONYM'
,p_message_language=>'es'
,p_message_text=>unistr('sin\00F3nimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100331597763304815)
,p_name=>'SYNONYM_IN_PAREN'
,p_message_language=>'es'
,p_message_text=>unistr('(sin\00F3nimo)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100110458575304609)
,p_name=>'SYNONYM_NOUN'
,p_message_language=>'es'
,p_message_text=>unistr('Sin\00F3nimo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100241626303304747)
,p_name=>'SYSTEM_MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Mensaje de Sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99912170921304457)
,p_name=>'SYSTEM_STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado del Sistema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99912293006304457)
,p_name=>'SYSTEM_STATUS_MODIFIED'
,p_message_language=>'es'
,p_message_text=>'Estado del Sistema Modificado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99730335551304315)
,p_name=>'TABLE'
,p_message_language=>'es'
,p_message_text=>'tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99978320134304508)
,p_name=>'TABLE NOT FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no es un nombre de tabla o vista v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100008140884304531)
,p_name=>'TABLESPACES'
,p_message_language=>'es'
,p_message_text=>'Tablespaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99729388478304315)
,p_name=>'TABLE_IN_PAREN'
,p_message_language=>'es'
,p_message_text=>'(tabla)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100024579145304543)
,p_name=>'TABLE_NAME_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de tabla %0 excede el tama\00F1o permitido.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100037411234304553)
,p_name=>'TABULAR_FORM'
,p_message_language=>'es'
,p_message_text=>'Pantalla Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100043920683304558)
,p_name=>'TABULAR_FORM_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>'La pantalla tabular se ha creado correctamente.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99725290972304311)
,p_name=>'TAB_MANAGER.WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: El destino de separador principal "%0" parece hacer referencia a una p\00E1gina que no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99716935917304305)
,p_name=>'TAB_SEQUENCE'
,p_message_language=>'es'
,p_message_text=>'Secuencia del Separador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99715828454304305)
,p_name=>'TAB_SET'
,p_message_language=>'es'
,p_message_text=>'Juego de Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100272125931304770)
,p_name=>'TAB_SETS'
,p_message_language=>'es'
,p_message_text=>'Juegos de Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99716002630304305)
,p_name=>'TAB_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto de Separador'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100732851729305118)
,p_name=>'TAG_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99557335086304187)
,p_name=>'TARGETED_FEATURES'
,p_message_language=>'es'
,p_message_text=>'Funciones de Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100770959778305146)
,p_name=>'TARGET_PAGE_ID_OR_CUSTOM_URL'
,p_message_language=>'es'
,p_message_text=>unistr('ID de P\00E1gina de Destino o URL Personalizada')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99981084248304510)
,p_name=>'TASK_COMPLETE'
,p_message_language=>'es'
,p_message_text=>'Tarea Terminada'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100005209308304529)
,p_name=>'TEAM_DEVELOPMENT'
,p_message_language=>'es'
,p_message_text=>'Desarrollo de Equipos'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99710898605304301)
,p_name=>'TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100760057307305138)
,p_name=>'TEMPLATE.ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99964700732304498)
,p_name=>'TEMPLATE.AFTER_HEADER'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Cabecera')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99964889299304498)
,p_name=>'TEMPLATE.BEFORE_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Antes de Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100759784859305138)
,p_name=>'TEMPLATE.COPY'
,p_message_language=>'es'
,p_message_text=>'Copiar Plantilla: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100759962572305138)
,p_name=>'TEMPLATE.NEW_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Nueva Plantilla: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99493428720304136)
,p_name=>'TEMPLATE.PAGE_TMP_BDY'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de Plantilla de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99964464278304497)
,p_name=>'TEMPLATE.PAGE_TMP_BDY1'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de Plantilla de P\00E1gina (1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99964503894304498)
,p_name=>'TEMPLATE.PAGE_TMP_BDY2'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de Plantilla de P\00E1gina (2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99964637065304498)
,p_name=>'TEMPLATE.PAGE_TMP_BDY3'
,p_message_language=>'es'
,p_message_text=>unistr('Cuerpo de Plantilla de P\00E1gina (3)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100759833869305138)
,p_name=>'TEMPLATE.PREVIEW'
,p_message_language=>'es'
,p_message_text=>'Vista Previa de Plantilla: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99963645970304497)
,p_name=>'TEMPLATE.T_REGION_POS09'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99963735099304497)
,p_name=>'TEMPLATE.T_REGION_POS10'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 10')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99963843163304497)
,p_name=>'TEMPLATE.T_REGION_POS11'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 11')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99963919817304497)
,p_name=>'TEMPLATE.T_REGION_POS12'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 12')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99964074833304497)
,p_name=>'TEMPLATE.T_REGION_POS13'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 13')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99964158053304497)
,p_name=>'TEMPLATE.T_REGION_POS14'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 14')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99964282850304497)
,p_name=>'TEMPLATE.T_REGION_POS15'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 15')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99964354203304497)
,p_name=>'TEMPLATE.T_REGION_POS16'
,p_message_language=>'es'
,p_message_text=>unistr('Posici\00F3n de Regi\00F3n 16')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100467337851304916)
,p_name=>'TEMPLATES'
,p_message_language=>'es'
,p_message_text=>'Plantillas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100097635517304599)
,p_name=>'TEMPLATE_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones de Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99527455571304161)
,p_name=>'TEMPLATE_APP_INSTALL_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error durante la creaci\00F3n de una aplicaci\00F3n basada en una aplicaci\00F3n de plantilla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100164678657304689)
,p_name=>'TEMPLATE_DRIVEN'
,p_message_language=>'es'
,p_message_text=>'Controlado por Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100095742750304598)
,p_name=>'TEMPLATE_OPTIONS.ADVANCED'
,p_message_language=>'es'
,p_message_text=>'Avanzada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100095679201304598)
,p_name=>'TEMPLATE_OPTIONS.COMMON'
,p_message_language=>'es'
,p_message_text=>unistr('Com\00FAn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100539611693304970)
,p_name=>'TEMPLATE_OPTIONS.DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Valor por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100095581048304598)
,p_name=>'TEMPLATE_OPTIONS.GENERAL'
,p_message_language=>'es'
,p_message_text=>'General'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100656779048305057)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTIONS_DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ninguna opci\00F3n de plantilla que coincida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100664474113305063)
,p_name=>'TEMPLATE_OPTIONS.NO_OPTION_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('- Ninguna Opci\00F3n Seleccionada -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100640937206305045)
,p_name=>'TEMPLATE_OPTIONS.USE_TEMPLATE_DEFAULTS'
,p_message_language=>'es'
,p_message_text=>'Utilizar Valores por Defecto de Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100747316925305129)
,p_name=>'TEMPLATE_OPTIONS_MISMATCH'
,p_message_language=>'es'
,p_message_text=>'Opciones de Plantilla No Coincidentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100768462445305144)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED'
,p_message_language=>'es'
,p_message_text=>unistr('Esta plantilla est\00E1 suscrita a la plantilla correspondiente del tema maestro. Para modificar esta plantilla, edite la plantilla maestra y, a continuaci\00F3n, refresque el tema. Tambi\00E9n puede crear una copia local, cuya suscripci\00F3n se haya anulado, de es')
||unistr('ta plantilla. Las plantillas cuya suscripci\00F3n se ha anulado se pueden editar y no se sobrescribir\00E1n con el refrescamiento de un tema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100768333812305144)
,p_name=>'TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Esta plantilla es local en esta aplicaci\00F3n y su suscripci\00F3n se ha anulado. '),
'No se pueden suscribir plantillas individuales cuando existe un tema asociado ya suscrito.',
unistr('Como alternativa para definir las plantillas locales, puede agregar nuevas plantillas al tema maestro y, a continuaci\00F3n, incluirlas o extraerlas de esta aplicaci\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99722003923304309)
,p_name=>'TEMPLATE_UTILIZATION.DEFAULT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Se hace referencia como plantilla por defecto de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99722234823304309)
,p_name=>'TEMPLATE_UTILIZATION.ERROR_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Se hace referencia como plantilla de error.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99722473178304309)
,p_name=>'TEMPLATE_UTILIZATION.NOT_REFERENCED'
,p_message_language=>'es'
,p_message_text=>unistr('NO se hace referencia a esta plantilla de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99722570514304309)
,p_name=>'TEMPLATE_UTILIZATION.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta plantilla de p\00E1gina es')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99722345848304309)
,p_name=>'TEMPLATE_UTILIZATION.PAGE_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('Se hace referencia en las p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99722139869304309)
,p_name=>'TEMPLATE_UTILIZATION.PRINTER_FRIENDLY_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('Se hace referencia como plantilla de versi\00F3n para impresora.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99916680383304461)
,p_name=>'TEMPORARY_TABLESPACE'
,p_message_language=>'es'
,p_message_text=>'Tablespace Temporal'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99778372974304350)
,p_name=>'TEST'
,p_message_language=>'es'
,p_message_text=>'Probar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100003146991304527)
,p_name=>'TESTING_ASSIGNEE'
,p_message_language=>'es'
,p_message_text=>'Persona asignada a Pruebas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100001345958304526)
,p_name=>'TESTING_IMPACT'
,p_message_language=>'es'
,p_message_text=>'Impacto de Prueba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100003592745304527)
,p_name=>'TESTING_STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado de Prueba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100069823625304578)
,p_name=>'TEST_QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta de Prueba'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100273366313304771)
,p_name=>'TEXT FILES'
,p_message_language=>'es'
,p_message_text=>'Archivos de Texto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99671507241304272)
,p_name=>'THEME'
,p_message_language=>'es'
,p_message_text=>'Tema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99598124735304218)
,p_name=>'THEME FILES'
,p_message_language=>'es'
,p_message_text=>'Archivos de Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100272976986304771)
,p_name=>'THEME IMAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Im\00E1genes de Tema')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100734018215305119)
,p_name=>'THEME.COMPATIBLE'
,p_message_language=>'es'
,p_message_text=>'Compatible'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100525359803304959)
,p_name=>'THEME.SELECTOR.APP.GROUP'
,p_message_language=>'es'
,p_message_text=>'Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99665981633304268)
,p_name=>'THEMES'
,p_message_language=>'es'
,p_message_text=>'Temas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100768556303305145)
,p_name=>'THEME_IS_SUBSCRIBED'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede anular la suscripci\00F3n de plantillas individuales que formen parte de un tema que est\00E9 suscrito a otro tema en el nivel de tema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100768894330305145)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TO_TABS'
,p_message_language=>'es'
,p_message_text=>unistr('Esta aplicaci\00F3n no se puede convertir en un tema utilizando la navegaci\00F3n basada en separadores, ya que utiliza la navegaci\00F3n basada en listas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100768740547305145)
,p_name=>'THEME_SWITCH.CANNOT_CONVERT_TWO_LEVEL_TABS'
,p_message_language=>'es'
,p_message_text=>unistr('Esta aplicaci\00F3n no se puede convertir en un tema utilizando una navegaci\00F3n basada en lista, ya que utiliza dos niveles de separadores. Actualice la aplicaci\00F3n y defina la configuraci\00F3n de los separadores actual para utilizar solo un nivel de separado')
||'res antes de cambiar el tema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99985128339304513)
,p_name=>'THEME_SWITCH.CANNOT_SWITCH_DESKTOP_TO_MOBILE'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede cambiar un tema de escritorio a un tema de m\00F3vil.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99891532233304441)
,p_name=>'THEME_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Tema'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100732243549305118)
,p_name=>'TITLE_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo: %0')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99980497336304510)
,p_name=>'TO DO'
,p_message_language=>'es'
,p_message_text=>'Tarea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100027292608304545)
,p_name=>'TODO'
,p_message_language=>'es'
,p_message_text=>'Tarea'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100006990799304530)
,p_name=>'TODOS'
,p_message_language=>'es'
,p_message_text=>'Tareas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99556578488304187)
,p_name=>'TODO_COMPLETE'
,p_message_language=>'es'
,p_message_text=>'Tarea Terminada (%0 / %1):'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100311969568304800)
,p_name=>'TODO_DASH_1'
,p_message_language=>'es'
,p_message_text=>'%0 entradas, %1 abiertas, %2 terminadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100312046370304800)
,p_name=>'TODO_DASH_2'
,p_message_language=>'es'
,p_message_text=>'%0 entradas terminadas parcialmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100312143427304800)
,p_name=>'TODO_DASH_3'
,p_message_language=>'es'
,p_message_text=>'%0 entradas terminadas parcialmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100005728710304529)
,p_name=>'TOP_TABLES_BY_ROW_COUNT'
,p_message_language=>'es'
,p_message_text=>'%0 Tablas Superiores por Recuento de Filas, Notificado por Esquema'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100030394445304547)
,p_name=>'TOTAL_CLOSED'
,p_message_language=>'es'
,p_message_text=>'Total Cerrados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100027815642304546)
,p_name=>'TOTAL_MILESTONES'
,p_message_language=>'es'
,p_message_text=>'Hitos Totales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100030282318304547)
,p_name=>'TOTAL_OPENED'
,p_message_language=>'es'
,p_message_text=>'Total Abiertos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100005826674304529)
,p_name=>'TOTAL_RENDER_ELAPSED_SECONDS'
,p_message_language=>'es'
,p_message_text=>unistr('Tiempo Total de Presentaci\00F3n (segundos)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100647761935305050)
,p_name=>'TO_BE_PURGED_IN_NEXT_7_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('Para Depurar (en los pr\00F3ximos 7 d\00EDas)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100028948760304546)
,p_name=>'TO_DOS'
,p_message_language=>'es'
,p_message_text=>'Tareas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100334035482304816)
,p_name=>'TO_DO_PERCENT_COMPLETE'
,p_message_language=>'es'
,p_message_text=>'Porcentaje de tareas terminadas (%0/%1):'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99732342833304317)
,p_name=>'TREE'
,p_message_language=>'es'
,p_message_text=>unistr('\00E1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100155165043304682)
,p_name=>'TREE_EXAMPLES_EXISTING_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Iniciar \00C1rbol seg\00FAn Elemento Existente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100155271043304682)
,p_name=>'TREE_EXAMPLES_SQL_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Iniciar \00C1rbol seg\00FAn Consulta SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100155417716304682)
,p_name=>'TREE_EXAMPLES_START_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('El valor de Iniciar \00C1rbol es NULL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100155317162304682)
,p_name=>'TREE_EXAMPLES_STATIC_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Iniciar \00C1rbol seg\00FAn Valor Est\00E1tico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99645550263304253)
,p_name=>'TREE_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('El \00E1rbol se ha creado correctamente.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99730463530304315)
,p_name=>'TRIGGER'
,p_message_language=>'es'
,p_message_text=>'disparador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99607242349304225)
,p_name=>'TRIGGER.BUTTON_TAB_NAMES_NOT_EQUAL'
,p_message_language=>'es'
,p_message_text=>'Los nombres de los botones no deben ser los mismos que los de un separador existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100113269638304611)
,p_name=>'TRIGGER.FLOWID_SGID_MISMATCH'
,p_message_language=>'es'
,p_message_text=>unistr('El identificador de aplicaci\00F3n y el identificador de grupo de seguridad actual no son consistentes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99607189763304225)
,p_name=>'TRIGGER.SGID_RESERVED'
,p_message_language=>'es'
,p_message_text=>unistr('El identificador de grupo de seguridad 20 est\00E1 reservado para el espacio de trabajo ''ORACLE''')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100111189684304610)
,p_name=>'TRUNCATE_TABLE'
,p_message_language=>'es'
,p_message_text=>'Truncar Tabla %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100156051815304683)
,p_name=>'TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100157987272304684)
,p_name=>'TYPE_LABEL'
,p_message_language=>'es'
,p_message_text=>'Tipo: %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100106553913304606)
,p_name=>'UI_DEF_CUSTOM_ITEM_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Elemento Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100113110468304611)
,p_name=>'UI_DEF_VIEW_DB_COL_DEFN'
,p_message_language=>'es'
,p_message_text=>unistr('Ver Definici\00F3n de Columna de Base de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99999547198304524)
,p_name=>'UI_PAGE_SKIP_TO_CONTENT'
,p_message_language=>'es'
,p_message_text=>'Saltar al contenido principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99520340702304156)
,p_name=>'UI_TYPE.DESKTOP'
,p_message_language=>'es'
,p_message_text=>'Escritorio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99520436189304156)
,p_name=>'UI_TYPE.JQM_SMARTPHONE'
,p_message_language=>'es'
,p_message_text=>unistr('M\00F3vil')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99520562366304156)
,p_name=>'UI_TYPE.JQM_TABLET'
,p_message_language=>'es'
,p_message_text=>'Tablet jQuery Mobile'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99520675751304156)
,p_name=>'UI_TYPE.PHONEGAP_JQM_SMARTPHONE'
,p_message_language=>'es'
,p_message_text=>'Smartphone jQuery Mobile para PhoneGap'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99520745646304156)
,p_name=>'UI_TYPE.PHONEGAP_JQM_TABLET'
,p_message_language=>'es'
,p_message_text=>'Tablet jQuery Mobile para PhoneGap'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99678548736304277)
,p_name=>'UNABLE_TO_DETERMINE_MS_DATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido determinar la fecha del hito'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100049791768304562)
,p_name=>'UNASSIGNED'
,p_message_language=>'es'
,p_message_text=>'No Asignado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100072797573304580)
,p_name=>'UNAUTHENTICATED_USER'
,p_message_language=>'es'
,p_message_text=>'Usuario no Autenticado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100253805927304757)
,p_name=>'UNAVAILABLE_REDIRECT_TO_URL'
,p_message_language=>'es'
,p_message_text=>'No Disponible (Redirigir a URL)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100253777784304757)
,p_name=>'UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'
,p_message_language=>'es'
,p_message_text=>'No Disponible (Estado Mostrado con PL/SQL)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99988223175304516)
,p_name=>'UNDER_CONSIDERATION'
,p_message_language=>'es'
,p_message_text=>unistr('En Consideraci\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99603290923304222)
,p_name=>'UNEXPIRED'
,p_message_language=>'es'
,p_message_text=>'No Vencido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100114722454304613)
,p_name=>'UNLOCK'
,p_message_language=>'es'
,p_message_text=>'Desbloquear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100202794877304717)
,p_name=>'UNLOCKED'
,p_message_language=>'es'
,p_message_text=>'Desbloqueado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99567349841304195)
,p_name=>'UNLOCKED_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones Desbloqueadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99564364204304193)
,p_name=>'UNLOCK_APPLICATION'
,p_message_language=>'es'
,p_message_text=>'Desbloquear'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99824212532304383)
,p_name=>'UNRESTRICTED'
,p_message_language=>'es'
,p_message_text=>'No Restringido'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99779047145304350)
,p_name=>'UP'
,p_message_language=>'es'
,p_message_text=>'Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99732198321304317)
,p_name=>'UPDATEABLE_REPORT'
,p_message_language=>'es'
,p_message_text=>'informe actualizable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100312286755304800)
,p_name=>'UPDATED_BY'
,p_message_language=>'es'
,p_message_text=>'Actualizado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99762388875304338)
,p_name=>'UPDATED_ON'
,p_message_language=>'es'
,p_message_text=>'Actualizado el'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100164875623304689)
,p_name=>'UPDATE_APP_DISP_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Actualizar a Versi\00F3n de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100164956135304689)
,p_name=>'UPDATE_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Actualizar a Versi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100664325560305063)
,p_name=>'UPGRADE_APP.UNSUPPORTED_DATE_FORMAT'
,p_message_language=>'es'
,p_message_text=>'no es un formato de fecha soportado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100335114902304817)
,p_name=>'UPGRADE_APPLICATION.INVALID_DATE_FORMAT'
,p_message_language=>'es'
,p_message_text=>'Formato de fecha no soportado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100715481858305105)
,p_name=>'UPGRADE_CANDLESTICK_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Tras cambiar de versi\00F3n, aseg\00FArese de que el atributo de serie Columna de Etiqueta est\00E1 asignado a una columna Fecha / Registro de Hora.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99732278028304317)
,p_name=>'URL'
,p_message_language=>'es'
,p_message_text=>'URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99968734969304501)
,p_name=>'URL LINK'
,p_message_language=>'es'
,p_message_text=>'Enlace de URL'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99992399487304519)
,p_name=>'USERID'
,p_message_language=>'es'
,p_message_text=>'Identificador de Usuario'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100008608360304531)
,p_name=>'USERS_AND_MOST_RECENT_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 usuarios, el usuario creado m\00E1s reciente es %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100113500677304612)
,p_name=>'USER_INTERFACE.NO_GLOBAL_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido una p\00E1gina global.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100003076636304527)
,p_name=>'USER_INTERFACE_ASSIGNEE'
,p_message_language=>'es'
,p_message_text=>'Persona asignada a Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100002522532304527)
,p_name=>'USER_INTERFACE_IMPACT'
,p_message_language=>'es'
,p_message_text=>'Impacto de Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100004047257304528)
,p_name=>'USER_INTERFACE_STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado de Interfaz de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99621978845304235)
,p_name=>'USER_TYPE_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice esta p\00E1gina para controlar el acceso para los administradores de espacio de trabajo, desarrolladores de aplicaci\00F3n y usuarios finales de Application Express.</p>'),
'',
unistr('<p>Los <strong>administradores del espacio de trabajo</strong> pueden crear y modificar aplicaciones y objetos de base de datos y adem\00E1s, gestionar cuentas de usuario, grupos y servicios de desarrollo.</p>'),
'',
'<p>Los <strong>desarrolladores</strong> pueden crear y modificar aplicaciones y objetos de la base de datos.</p>',
'',
unistr('<p>Los <strong>usuarios finales</strong> no tienen privilegios de desarrollo y solo pueden acceder a las aplicaciones que no utilicen un esquema de autenticaci\00F3n externo.</p>'),
'',
unistr('<p><a target="_blank" href="%0/aeadm/managing-users-in-a-workspace.html">Obtener m\00E1s informaci\00F3n...</a></p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99646141087304253)
,p_name=>'USER_TYPE_DESCRIPTION_CLOUD'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice esta p\00E1gina para controlar el acceso de los usuarios finales de Application Express.</p>'),
'',
unistr('<p>Los <strong>usuarios finales</strong> no tienen privilegios de desarrollo y solo pueden acceder a aplicaciones que no utilizan un esquema de autenticaci\00F3n externo.</p>'),
'',
'<p><strong>Los administradores de espacio de trabajo</strong> y <strong>desarrolladores</strong> se gestionan con la consola de identidad. Cada vez que un administrador de espacio de trabajo o desarrollador se conecta a Application Express, se crea u'
||'na cuenta "sombra". Estos usuarios "sombra" se pueden eliminar si lo desea.</p>'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99733658490304318)
,p_name=>'USE_BUILTIN_LOGIN_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Utilizar la p\00E1gina de conexi\00F3n incorporada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99733490294304318)
,p_name=>'USE_PAGE_AS_LOGIN_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Utilizar la p\00E1gina %0 como p\00E1gina de conexi\00F3n.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100096489292304598)
,p_name=>'USING_CLEAR_CACHE_AND_PAGE_LINKS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilice el atributo <strong>Borrar Cach\00E9</strong> para eliminar el estado de la sesi\00F3n y obtener una lista separada por comas de p\00E1ginas. Tambi\00E9n est\00E1n disponibles las siguientes sintaxis para borrar cach\00E9:'),
'<ul>',
'<li>RIR: Reiniciar Informe Interactivo</li>',
'<li>CIR: Borrar Informe Interactivo</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100119449059304616)
,p_name=>'USING_EXISTING_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'uso de esquema existente'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100741177171305124)
,p_name=>'UTR.BUTTONS.CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100741420529305124)
,p_name=>'UTR.BUTTONS.CODE_EDITOR'
,p_message_language=>'es'
,p_message_text=>unistr('Editor de C\00F3digos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100741361387305124)
,p_name=>'UTR.BUTTONS.MAXIMIZE'
,p_message_language=>'es'
,p_message_text=>'Maximizar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100741288555305124)
,p_name=>'UTR.BUTTONS.MINIMIZE'
,p_message_language=>'es'
,p_message_text=>'Minimizar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100742555303305125)
,p_name=>'UTR.CHANGE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Al cambiar el estilo de tema, se restablecer\00E1n los cambios no guardados. Esta operaci\00F3n no se puede deshacer. \00BFDesea continuar?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100769869006305145)
,p_name=>'UTR.CHANGE_THEME'
,p_message_language=>'es'
,p_message_text=>'Cambiar Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100741095373305124)
,p_name=>'UTR.COMMON.BASE_STYLE'
,p_message_language=>'es'
,p_message_text=>'Estilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100740825650305124)
,p_name=>'UTR.COMMON.CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100740237303305123)
,p_name=>'UTR.COMMON.CONFIRM'
,p_message_language=>'es'
,p_message_text=>'Confirmar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100769536366305145)
,p_name=>'UTR.COMMON.COPY'
,p_message_language=>'es'
,p_message_text=>'Copiar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100740692450305124)
,p_name=>'UTR.COMMON.NO'
,p_message_language=>'es'
,p_message_text=>'No'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100740727802305124)
,p_name=>'UTR.COMMON.OK'
,p_message_language=>'es'
,p_message_text=>'Aceptar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100769410912305145)
,p_name=>'UTR.COMMON.SET_CURRENT_WHEN_READ_ONLY_PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr(' Ha realizado cambios en un tema de solo lectura. Si lo convierte en el tema actual, se borrar\00E1n los cambios. \00BFSeguro que desea continuar? ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100740909325305124)
,p_name=>'UTR.COMMON.STYLE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Estilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100740321719305124)
,p_name=>'UTR.COMMON.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Correcto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100769693747305145)
,p_name=>'UTR.COMMON.WARNING'
,p_message_language=>'es'
,p_message_text=>'Advertencia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100740532904305124)
,p_name=>'UTR.COMMON.YES'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100766104423305143)
,p_name=>'UTR.CONFIG_OUTPUT'
,p_message_language=>'es'
,p_message_text=>unistr('Pegue la siguiente l\00EDnea de c\00F3digo en la consola de JS para cargar la configuraci\00F3n actual en el acumulador de temas:')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100766228325305143)
,p_name=>'UTR.CONFIG_OUTPUT_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('El acumulador de temas debe estar abierto y el estilo actual debe ser v\00E1lido para la salida de la configuraci\00F3n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100654258529305055)
,p_name=>'UTR.CONTRAST_DIALOG.TITLE'
,p_message_language=>'es'
,p_message_text=>'Ratio de contraste:'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100747601487305129)
,p_name=>'UTR.CONTRAST_VALIDATION.FAILED'
,p_message_language=>'es'
,p_message_text=>'Con Fallos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100750063242305131)
,p_name=>'UTR.CONTRAST_VALIDATION.LARGE_TEXT_NOTICE'
,p_message_language=>'es'
,p_message_text=>'Para texto por encima de 18 puntos o negrita por encima de 14 puntos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100747768294305129)
,p_name=>'UTR.CONTRAST_VALIDATION.MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Las validaciones se realizan seg\00FAn las directrices de accesibilidad de contenido web (WCAG) 2.0 en contraste de color para las fuentes con tama\00F1o normal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100747521797305129)
,p_name=>'UTR.CONTRAST_VALIDATION.PASSED'
,p_message_language=>'es'
,p_message_text=>'Correcto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100747475349305129)
,p_name=>'UTR.CONTRAST_VALIDATION.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n de Contraste de Color')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100769372844305145)
,p_name=>'UTR.CURRENT'
,p_message_language=>'es'
,p_message_text=>'Actual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100742339328305125)
,p_name=>'UTR.CUSTOM_CSS'
,p_message_language=>'es'
,p_message_text=>'CSS Personalizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100742463825305125)
,p_name=>'UTR.CUSTOM_CSS.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Este c\00F3digo se incluir\00E1 al final de la hoja de estilo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100751239229305132)
,p_name=>'UTR.CUSTOM_CSS.WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('Este c\00F3digo CSS oculta el cuadro de di\00E1logo Acumulador de Temas. No se est\00E1 aplicando a la p\00E1gina.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100332070151304815)
,p_name=>'UTR.DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>'Descargar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100332338017304815)
,p_name=>'UTR.DRAG_AND_DROP'
,p_message_language=>'es'
,p_message_text=>'Arrastre y suelte archivos o haga clic para seleccionar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100332593156304815)
,p_name=>'UTR.ENABLE_LESS_COMPILATION'
,p_message_language=>'es'
,p_message_text=>unistr('Activar compilaci\00F3n LESS')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100740462258305124)
,p_name=>'UTR.ERROR'
,p_message_language=>'es'
,p_message_text=>'Error'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100742902803305126)
,p_name=>'UTR.ERROR.CREATE_FAILED'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear el estilo de tema.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100750976480305131)
,p_name=>'UTR.ERROR.INPUT_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'Error al cargar una o varias URL de archivo CSS.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100742741788305125)
,p_name=>'UTR.ERROR.INVALID_STYLE'
,p_message_language=>'es'
,p_message_text=>unistr('El c\00F3digo LESS para este estilo de tema no es v\00E1lido.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100743171277305126)
,p_name=>'UTR.ERROR.LOAD_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido cargar el estilo de tema. Aseg\00FArese de que la ventana Creador de Aplicaciones a\00FAn est\00E1 abierta y que la sesi\00F3n es v\00E1lida.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100769796364305145)
,p_name=>'UTR.ERROR.SET_AS_CURRENT_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede utilizar el tema seleccionado como tema actual de la aplicaci\00F3n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100742679132305125)
,p_name=>'UTR.ERROR.UNSUPPORTED_STYLE'
,p_message_language=>'es'
,p_message_text=>unistr('Este estilo de tema no soporta la personalizaci\00F3n del acumulador de temas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100742840559305125)
,p_name=>'UTR.ERROR.UNSUPPORTED_THEME'
,p_message_language=>'es'
,p_message_text=>'Este tema no tiene estilos de tema. Seleccione un tema con estilos de tema para utilizar el acumulador de temas.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100743037966305126)
,p_name=>'UTR.ERROR.UPDATE_FAILED'
,p_message_language=>'es'
,p_message_text=>'No se ha podido actualizar el estilo de tema.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100643281455305047)
,p_name=>'UTR.FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100750120107305131)
,p_name=>'UTR.HELP'
,p_message_language=>'es'
,p_message_text=>'Ayuda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100750253133305131)
,p_name=>'UTR.HELP.P1'
,p_message_language=>'es'
,p_message_text=>unistr('El acumulador de temas permite una personalizaci\00F3n sencilla de la interfaz de usuario de la aplicaci\00F3n permiti\00E9ndole seleccionar los colores y definir los estilos para varios componentes de la aplicaci\00F3n. Una aplicaci\00F3n puede tener definido cualquier')
||unistr(' n\00FAmero de estilos de tema, sin embargo, s\00F3lo se utiliza el estilo de tema ''Actual'' para mostrar la aplicaci\00F3n a los usuarios finales.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100750333539305131)
,p_name=>'UTR.HELP.P2'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Despu\00E9s de realizar cambios, los atributos se pueden restaurar f\00E1cilmente, ya sea para el estilo de tema completo pulsando el bot\00F3n Restablecer o pulsando el icono de restablecimiento del grupo. '),
'',
unistr('Para los atributos que permiten la selecci\00F3n de colores de primer o segundo plano, la casilla de control que precede a las selecciones de dos colores indica la informaci\00F3n de contraste de color basada en las directrices de accesibilidad de contenido ')
||unistr('web (WCAG) 2.0. Una puntuaci\00F3n de contraste calculada de forma m\00E1s alta indica que la combinaci\00F3n de colores es m\00E1s accesible.')))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100527100347304961)
,p_name=>'UTR.INLINE_EDITOR_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Editor en l\00EDnea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100051890861304564)
,p_name=>'UTR.LESS.ACCENT'
,p_message_language=>'es'
,p_message_text=>'Destacado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100761970920305140)
,p_name=>'UTR.LESS.ACTIONS_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna de Acciones'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100765402684305142)
,p_name=>'UTR.LESS.ACTIVE'
,p_message_language=>'es'
,p_message_text=>'Activo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100766080475305143)
,p_name=>'UTR.LESS.ACTIVE_STATE'
,p_message_language=>'es'
,p_message_text=>'Estado Activo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100763918463305141)
,p_name=>'UTR.LESS.BACKGROUND'
,p_message_language=>'es'
,p_message_text=>'Segundo Plano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100051975957304564)
,p_name=>'UTR.LESS.BADGE'
,p_message_language=>'es'
,p_message_text=>'Placa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100761846390305140)
,p_name=>'UTR.LESS.BODY'
,p_message_language=>'es'
,p_message_text=>'Cuerpo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100761730137305140)
,p_name=>'UTR.LESS.BODY_ACCENT'
,p_message_language=>'es'
,p_message_text=>'Resaltado de Cuerpo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100766343231305143)
,p_name=>'UTR.LESS.BODY_CONTENT_MAX_WIDTH'
,p_message_language=>'es'
,p_message_text=>unistr('Ancho M\00E1ximo de Contenido del Cuerpo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100762509553305140)
,p_name=>'UTR.LESS.BORDER_RADIUS'
,p_message_language=>'es'
,p_message_text=>'Radio del Borde'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100760651235305139)
,p_name=>'UTR.LESS.BUTTONS'
,p_message_language=>'es'
,p_message_text=>'Botones'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100764168568305141)
,p_name=>'UTR.LESS.COLOR_1'
,p_message_language=>'es'
,p_message_text=>'Color 1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100764939587305142)
,p_name=>'UTR.LESS.COLOR_10'
,p_message_language=>'es'
,p_message_text=>'Color 10'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100733491827305118)
,p_name=>'UTR.LESS.COLOR_11'
,p_message_language=>'es'
,p_message_text=>'Color 11'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100733513544305118)
,p_name=>'UTR.LESS.COLOR_12'
,p_message_language=>'es'
,p_message_text=>'Color 12'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100733628260305119)
,p_name=>'UTR.LESS.COLOR_13'
,p_message_language=>'es'
,p_message_text=>'Color 13'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100733793544305119)
,p_name=>'UTR.LESS.COLOR_14'
,p_message_language=>'es'
,p_message_text=>'Color 14'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100733817821305119)
,p_name=>'UTR.LESS.COLOR_15'
,p_message_language=>'es'
,p_message_text=>'Color 15'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100764257734305141)
,p_name=>'UTR.LESS.COLOR_2'
,p_message_language=>'es'
,p_message_text=>'Color 2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100765001530305142)
,p_name=>'UTR.LESS.COLOR_3'
,p_message_language=>'es'
,p_message_text=>'Color 3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100764393981305141)
,p_name=>'UTR.LESS.COLOR_4'
,p_message_language=>'es'
,p_message_text=>'Color 4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100764479241305142)
,p_name=>'UTR.LESS.COLOR_5'
,p_message_language=>'es'
,p_message_text=>'Color 5'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100764537451305142)
,p_name=>'UTR.LESS.COLOR_6'
,p_message_language=>'es'
,p_message_text=>'Color 6'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100764698885305142)
,p_name=>'UTR.LESS.COLOR_7'
,p_message_language=>'es'
,p_message_text=>'Color 7'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100764789673305142)
,p_name=>'UTR.LESS.COLOR_8'
,p_message_language=>'es'
,p_message_text=>'Color 8'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100764840772305142)
,p_name=>'UTR.LESS.COLOR_9'
,p_message_language=>'es'
,p_message_text=>'Color 9'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100760756122305139)
,p_name=>'UTR.LESS.CONTAINERS'
,p_message_language=>'es'
,p_message_text=>'Contenedores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100765111874305142)
,p_name=>'UTR.LESS.CONTAINER_BORDER_RADIUS'
,p_message_language=>'es'
,p_message_text=>'Radio de Borde de Contenedor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100762966617305140)
,p_name=>'UTR.LESS.DANGER'
,p_message_language=>'es'
,p_message_text=>'Peligro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100763324482305141)
,p_name=>'UTR.LESS.DISABLED'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100762205414305140)
,p_name=>'UTR.LESS.FOCUS_OUTLINE'
,p_message_language=>'es'
,p_message_text=>'Contorno de Enfoque'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100763789852305141)
,p_name=>'UTR.LESS.FOREGROUND'
,p_message_language=>'es'
,p_message_text=>'Primer Plano'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100770522645305146)
,p_name=>'UTR.LESS.FORMS'
,p_message_language=>'es'
,p_message_text=>'Pantallas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100760481023305139)
,p_name=>'UTR.LESS.GLOBAL_COLORS'
,p_message_language=>'es'
,p_message_text=>'Colores Globales'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100764021109305141)
,p_name=>'UTR.LESS.HEADER'
,p_message_language=>'es'
,p_message_text=>'Cabecera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100761618903305140)
,p_name=>'UTR.LESS.HEADER_ACCENT'
,p_message_language=>'es'
,p_message_text=>'Resaltado de Cabecera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100054328730304566)
,p_name=>'UTR.LESS.HEADER_HEIGHT'
,p_message_language=>'es'
,p_message_text=>'Altura de cabecera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100762757933305140)
,p_name=>'UTR.LESS.HOT'
,p_message_language=>'es'
,p_message_text=>'Directa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100765719271305143)
,p_name=>'UTR.LESS.HOVER'
,p_message_language=>'es'
,p_message_text=>'Pasar Mouse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100765876599305143)
,p_name=>'UTR.LESS.HOVER_STATE'
,p_message_language=>'es'
,p_message_text=>'Estado al Pasar el Mouse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100765371080305142)
,p_name=>'UTR.LESS.ICON'
,p_message_language=>'es'
,p_message_text=>'Icono'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100763417273305141)
,p_name=>'UTR.LESS.INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100761543995305139)
,p_name=>'UTR.LESS.INTERACTIVE_REPORTS'
,p_message_language=>'es'
,p_message_text=>'Informes Interactivos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100770658171305146)
,p_name=>'UTR.LESS.ITEM'
,p_message_language=>'es'
,p_message_text=>'Elemento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100770712888305146)
,p_name=>'UTR.LESS.LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100760848714305139)
,p_name=>'UTR.LESS.LAYOUT'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100762458179305140)
,p_name=>'UTR.LESS.LEFT_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna Izquierda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100762145261305140)
,p_name=>'UTR.LESS.LINK_COLOR'
,p_message_language=>'es'
,p_message_text=>'Color del Enlace'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100763659370305141)
,p_name=>'UTR.LESS.MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100756622994305136)
,p_name=>'UTR.LESS.MENUS'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FAs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100098424304304600)
,p_name=>'UTR.LESS.MENU_ITEM_HOVER'
,p_message_language=>'es'
,p_message_text=>unistr('Estado de opci\00F3n de men\00FA al pasar el mouse')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100760998091305139)
,p_name=>'UTR.LESS.NAVIGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100765205329305142)
,p_name=>'UTR.LESS.NAVIGATION_TREE'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rbol de Navegaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100762633308305140)
,p_name=>'UTR.LESS.NORMAL'
,p_message_language=>'es'
,p_message_text=>'Normal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100765584441305142)
,p_name=>'UTR.LESS.NOT_ACTIVE'
,p_message_language=>'es'
,p_message_text=>'No Activo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100761207821305139)
,p_name=>'UTR.LESS.PALETTE'
,p_message_language=>'es'
,p_message_text=>'Paleta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100762871882305140)
,p_name=>'UTR.LESS.PRIMARY'
,p_message_language=>'es'
,p_message_text=>'Primario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99927747508304469)
,p_name=>'UTR.LESS.PRIMARY_ACCENT'
,p_message_language=>'es'
,p_message_text=>'Destacado principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100760517536305139)
,p_name=>'UTR.LESS.REGIONS'
,p_message_language=>'es'
,p_message_text=>'Regiones'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100762399791305140)
,p_name=>'UTR.LESS.REGION_HEADER'
,p_message_language=>'es'
,p_message_text=>'Cabecera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100745579431305127)
,p_name=>'UTR.LESS.REPORTS_GRIDS'
,p_message_language=>'es'
,p_message_text=>unistr('Informes y cuadr\00EDculas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100662747673305062)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_BACKGROUND'
,p_message_language=>'es'
,p_message_text=>'Fondo de cuerpo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100662624648305062)
,p_name=>'UTR.LESS.RW.CLASSES.BODY_HEADER'
,p_message_language=>'es'
,p_message_text=>'Cabecera de Cuerpo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100663413251305062)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE'
,p_message_language=>'es'
,p_message_text=>unistr('Modo de Visualizaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100663679324305062)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.COMPACT'
,p_message_language=>'es'
,p_message_text=>'Compacto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100663546929305062)
,p_name=>'UTR.LESS.RW.CLASSES.DISPLAY_MODE.STANDARD'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1ndar (por defecto)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100647158843305050)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT'
,p_message_language=>'es'
,p_message_text=>unistr('Dise\00F1o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100650700287305052)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.CONTAINED'
,p_message_language=>'es'
,p_message_text=>'Contenido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100650598085305052)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.EDGE_TO_EDGE'
,p_message_language=>'es'
,p_message_text=>'De borde a borde (por defecto)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100650694274305052)
,p_name=>'UTR.LESS.RW.CLASSES.LAYOUT.FLOATING'
,p_message_language=>'es'
,p_message_text=>'Flotante'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100647074311305050)
,p_name=>'UTR.LESS.RW.CLASSES.MODE'
,p_message_language=>'es'
,p_message_text=>'Modo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100650368564305052)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK'
,p_message_language=>'es'
,p_message_text=>'Oscuro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100650412994305052)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_BODY'
,p_message_language=>'es'
,p_message_text=>'Cuerpo oscuro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100663870431305063)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.DARK_DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Oscuro (por defecto)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100650210686305052)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT'
,p_message_language=>'es'
,p_message_text=>'Claro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100663976579305063)
,p_name=>'UTR.LESS.RW.CLASSES.MODE.LIGHT_DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Claro (por defecto)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100646933301305049)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR'
,p_message_language=>'es'
,p_message_text=>'Pilar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100662445714305061)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.BEIGE'
,p_message_language=>'es'
,p_message_text=>'Beis'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100662008141305061)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.LILAC'
,p_message_language=>'es'
,p_message_text=>'Lila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100661494042305061)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.NEUTRAL'
,p_message_language=>'es'
,p_message_text=>'Neutro (por defecto)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100661978324305061)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.OCEAN'
,p_message_language=>'es'
,p_message_text=>unistr('Oc\00E9ano')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100661553758305061)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PEBBLE'
,p_message_language=>'es'
,p_message_text=>'Guijarro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100661792733305061)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PINE'
,p_message_language=>'es'
,p_message_text=>'Pino'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100662384122305061)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.PLUM'
,p_message_language=>'es'
,p_message_text=>'Ciruela'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100662180127305061)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.ROSE'
,p_message_language=>'es'
,p_message_text=>'Rosa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100662224064305061)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SIENNA'
,p_message_language=>'es'
,p_message_text=>'Siena'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100661645431305061)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.SLATE'
,p_message_language=>'es'
,p_message_text=>'Pizarra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100661884155305061)
,p_name=>'UTR.LESS.RW.CLASSES.PILLAR.TEAL'
,p_message_language=>'es'
,p_message_text=>'Teal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100662537019305061)
,p_name=>'UTR.LESS.RW.GROUP.APPEARANCE'
,p_message_language=>'es'
,p_message_text=>'Apariencia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100661312993305061)
,p_name=>'UTR.LESS.RW.GROUP.CLASSES'
,p_message_language=>'es'
,p_message_text=>'Opciones de Redwood'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99843179847304401)
,p_name=>'UTR.LESS.SCALE_LEVEL'
,p_message_language=>'es'
,p_message_text=>'Escala'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99927802735304469)
,p_name=>'UTR.LESS.SECONDARY_ACCENT'
,p_message_language=>'es'
,p_message_text=>'Destacado secundario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100765689246305142)
,p_name=>'UTR.LESS.SELECTED'
,p_message_language=>'es'
,p_message_text=>'Seleccionado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100765981883305143)
,p_name=>'UTR.LESS.SELECTED_STATE'
,p_message_language=>'es'
,p_message_text=>'Estado Seleccionado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100763265581305141)
,p_name=>'UTR.LESS.SIMPLE'
,p_message_language=>'es'
,p_message_text=>'Simple'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100761031411305139)
,p_name=>'UTR.LESS.STATES'
,p_message_language=>'es'
,p_message_text=>'Estados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100763155247305141)
,p_name=>'UTR.LESS.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Correcto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100763802543305141)
,p_name=>'UTR.LESS.TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100762052948305140)
,p_name=>'UTR.LESS.TITLE_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de T\00EDtulo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100763027141305141)
,p_name=>'UTR.LESS.WARNING'
,p_message_language=>'es'
,p_message_text=>'Advertencia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100643372992305047)
,p_name=>'UTR.LOADING'
,p_message_language=>'es'
,p_message_text=>'Cargando...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99645752168304253)
,p_name=>'UTR.LOGO.ALT_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto alternativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100295493112304788)
,p_name=>'UTR.LOGO.CUSTOM'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100295391864304788)
,p_name=>'UTR.LOGO.CUSTOM.MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Puede editar la marca del logotipo en el creador de aplicaciones'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100333069571304816)
,p_name=>'UTR.LOGO.ERROR_LOAD_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('No se han podido cargar los datos del logotipo. Aseg\00FArese de que la ventana del creador de aplicaciones sigue abierta y de que la sesi\00F3n es v\00E1lida.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100295245815304788)
,p_name=>'UTR.LOGO.IMAGE'
,p_message_language=>'es'
,p_message_text=>'Imagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100335289313304817)
,p_name=>'UTR.LOGO.IMAGE_DEFAULT_VALUE'
,p_message_language=>'es'
,p_message_text=>'Ninguna imagen cargada.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100295191449304788)
,p_name=>'UTR.LOGO.IMAGE_TEXT'
,p_message_language=>'es'
,p_message_text=>'Imagen y texto'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100332637264304815)
,p_name=>'UTR.LOGO.MAX_FILESIZE_IN_KB'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un archivo de un tama\00F1o inferior a %0 KB')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100295063422304788)
,p_name=>'UTR.LOGO.NONE'
,p_message_language=>'es'
,p_message_text=>'Ninguno'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100332717201304816)
,p_name=>'UTR.LOGO.ONLY_IMAGE_FILES'
,p_message_language=>'es'
,p_message_text=>'Solo se permiten archivos de imagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100331919537304815)
,p_name=>'UTR.LOGO.SAVE_LOGO'
,p_message_language=>'es'
,p_message_text=>'Guardar logotipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100332817134304816)
,p_name=>'UTR.LOGO.SET_LOGO_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido guardar el logotipo.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100332970298304816)
,p_name=>'UTR.LOGO.SET_LOGO_SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Logotipo guardado correctamente.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100294945996304788)
,p_name=>'UTR.LOGO.TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100294720979304787)
,p_name=>'UTR.LOGO.TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100294629383304787)
,p_name=>'UTR.LOGO.UPLOAD_LABEL'
,p_message_language=>'es'
,p_message_text=>'Arrastre y suelte archivos o haga clic para seleccionar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100525499913304960)
,p_name=>'UTR.LOGO_EDITOR'
,p_message_language=>'es'
,p_message_text=>'Editar logotipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100332444161304815)
,p_name=>'UTR.ONLY_JSON_ALLOWED'
,p_message_language=>'es'
,p_message_text=>'Solo se permiten archivos JSON'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100758236210305137)
,p_name=>'UTR.PALETTE_GENERATOR.ADJACENT'
,p_message_language=>'es'
,p_message_text=>'Adyacente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100758036288305137)
,p_name=>'UTR.PALETTE_GENERATOR.BASE_RGB'
,p_message_language=>'es'
,p_message_text=>'RGB Base'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100770349214305146)
,p_name=>'UTR.PALETTE_GENERATOR.DUAL'
,p_message_language=>'es'
,p_message_text=>'Dual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100758157994305137)
,p_name=>'UTR.PALETTE_GENERATOR.MONOCHROMATIC'
,p_message_language=>'es'
,p_message_text=>unistr('Monocrom\00E1tico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100758682237305137)
,p_name=>'UTR.PALETTE_GENERATOR.SEPARATION'
,p_message_language=>'es'
,p_message_text=>unistr('Separaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100758499123305137)
,p_name=>'UTR.PALETTE_GENERATOR.TETRAD'
,p_message_language=>'es'
,p_message_text=>unistr('T\00E9trada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100758344341305137)
,p_name=>'UTR.PALETTE_GENERATOR.TRIAD'
,p_message_language=>'es'
,p_message_text=>unistr('Tr\00EDada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100758509202305137)
,p_name=>'UTR.PALETTE_GENERATOR.WITH_COMPLEMENT'
,p_message_language=>'es'
,p_message_text=>'Con Complemento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100053718999304565)
,p_name=>'UTR.PENDING_LOGO_CHANGES'
,p_message_language=>'es'
,p_message_text=>'No ha guardado los cambios del logotipo.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100053801483304565)
,p_name=>'UTR.PENDING_THEME_CHANGES'
,p_message_language=>'es'
,p_message_text=>'No ha guardado los cambios del tema.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100761496601305139)
,p_name=>'UTR.REDO'
,p_message_language=>'es'
,p_message_text=>'Rehacer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100742161052305125)
,p_name=>'UTR.RESET'
,p_message_language=>'es'
,p_message_text=>'Restablecer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100742258764305125)
,p_name=>'UTR.RESET.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFSeguro que desea restablecer CSS? Todos los cambios se perder\00E1n. Esta operaci\00F3n no se puede deshacer.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100769998460305146)
,p_name=>'UTR.RESET.STYLE'
,p_message_language=>'es'
,p_message_text=>'Restablecer Estilo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100741821197305125)
,p_name=>'UTR.SAVE'
,p_message_language=>'es'
,p_message_text=>'Guardar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100741995588305125)
,p_name=>'UTR.SAVE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Actualice el nombre para cambiar el nombre del estilo de tema actual.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100742034600305125)
,p_name=>'UTR.SAVE.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'El estilo de tema se ha actualizado correctamente.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100741540967305125)
,p_name=>'UTR.SAVE_AS'
,p_message_language=>'es'
,p_message_text=>'Guardar como'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100741687296305125)
,p_name=>'UTR.SAVE_AS.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Introduzca un nombre para el nuevo estilo de tema.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100741744196305125)
,p_name=>'UTR.SAVE_AS.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'El estilo de tema se ha creado correctamente.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100757926924305137)
,p_name=>'UTR.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100525538697304960)
,p_name=>'UTR.SELECT_THEME'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100769273895305145)
,p_name=>'UTR.SET_AS_CURRENT'
,p_message_language=>'es'
,p_message_text=>'Definir como Actual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100770095602305146)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE'
,p_message_language=>'es'
,p_message_text=>'Definir como estilo de tema actual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100770192247305146)
,p_name=>'UTR.SET_AS_CURRENT_THEME_STYLE_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('El tema seleccionado es ahora el tema actual de la aplicaci\00F3n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100770263833305146)
,p_name=>'UTR.SET_AS_CURRENT_WHEN_READ_ONLY.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Ha realizado cambios en un tema de solo lectura. Si define este tema como el "actual" de la aplicaci\00F3n, se borrar\00E1n los cambios. \00BFSeguro que desea continuar?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100294505901304787)
,p_name=>'UTR.TABS.LOGO'
,p_message_language=>'es'
,p_message_text=>'Logotipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100294463124304787)
,p_name=>'UTR.TABS.THEME_STYLE'
,p_message_language=>'es'
,p_message_text=>'Estilo de Tema'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100740116560305123)
,p_name=>'UTR.THEME_ROLLER'
,p_message_language=>'es'
,p_message_text=>'Acumulador de Temas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100750893120305131)
,p_name=>'UTR.TOOLBAR.BUTTONS.ALL'
,p_message_language=>'es'
,p_message_text=>'Mostrar Todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100750753915305131)
,p_name=>'UTR.TOOLBAR.BUTTONS.COMMON'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar Com\00FAn')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100767035073305143)
,p_name=>'UTR.TOOLBAR.BUTTONS.PALETTE_GENERATOR'
,p_message_language=>'es'
,p_message_text=>'Rueda de Color'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100761365787305139)
,p_name=>'UTR.UNDO'
,p_message_language=>'es'
,p_message_text=>'Deshacer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100332164848304815)
,p_name=>'UTR.UPLOAD'
,p_message_language=>'es'
,p_message_text=>'Cargar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100332208962304815)
,p_name=>'UTR.UPLOAD_CONFIG_FILE'
,p_message_language=>'es'
,p_message_text=>unistr('Cargar archivo de configuraci\00F3n')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99742077105304324)
,p_name=>'V.ALIAS_CONVERSION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1812: Error inesperado al convertir el alias de aplicaci\00F3n (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100731011680305117)
,p_name=>'VALIDATION_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Validaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99523229703304158)
,p_name=>'VIEW ALL PAGE GROUPS'
,p_message_language=>'es'
,p_message_text=>unistr('Ver Todos los Grupos de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99523356823304158)
,p_name=>'VIEW ALL PAGE TYPES'
,p_message_language=>'es'
,p_message_text=>unistr('Ver Todos los Tipos de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99670811192304271)
,p_name=>'VIEWS2'
,p_message_language=>'es'
,p_message_text=>'Vistas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100271222240304770)
,p_name=>'VIEW_DEBUG'
,p_message_language=>'es'
,p_message_text=>unistr('Ver Depuraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99546291688304179)
,p_name=>'VIEW_DETAILS'
,p_message_language=>'es'
,p_message_text=>'Ver Detalles'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100115409133304613)
,p_name=>'VIEW_FOR_ALT_TAG'
,p_message_language=>'es'
,p_message_text=>'Ver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99541219027304172)
,p_name=>'VIEW_FOR_PRINTING'
,p_message_language=>'es'
,p_message_text=>'Ver para Imprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100299799447304791)
,p_name=>'VIEW_HISTORY'
,p_message_language=>'es'
,p_message_text=>'Ver Historial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100690172122305086)
,p_name=>'VIEW_IN_BUILDER'
,p_message_language=>'es'
,p_message_text=>'Ver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99729401104304315)
,p_name=>'VIEW_IN_PAREN'
,p_message_language=>'es'
,p_message_text=>'(ver)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100720849761305109)
,p_name=>'VIEW_LOCK_HISTORY'
,p_message_language=>'es'
,p_message_text=>'Ver Historial de Bloqueos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100651697959305053)
,p_name=>'VIEW_OUTPUT_OF_XML_DEMO'
,p_message_language=>'es'
,p_message_text=>unistr('Esta consulta SQL se utiliza para generar el XML que se muestra despu\00E9s de hacer clic en el bot\00F3n <strong>Ver XML</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99523887116304159)
,p_name=>'VIEW_PAGES_OF_THIS_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Ver P\00E1ginas de Este Tipo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100294861870304788)
,p_name=>'VIEW_PAGE_HISTORY'
,p_message_language=>'es'
,p_message_text=>unistr('Ver Historial de Cambios de la P\00E1gina "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99636055958304246)
,p_name=>'VIEW_USER_ACTIVITY'
,p_message_language=>'es'
,p_message_text=>'Ver actividad para: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100043689853304557)
,p_name=>'VPD'
,p_message_language=>'es'
,p_message_text=>'Base de Datos Privada Virtual (VPD)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100055663181304567)
,p_name=>'WAITING.APP_DEFINITION'
,p_message_language=>'es'
,p_message_text=>unistr('Instalando Aplicaci\00F3n...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100736802665305121)
,p_name=>'WAITING.APP_REMOVAL'
,p_message_language=>'es'
,p_message_text=>unistr('Eliminando Aplicaci\00F3n...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100737080990305121)
,p_name=>'WAITING.APP_UNLOCK'
,p_message_language=>'es'
,p_message_text=>unistr('Desbloqueando Aplicaci\00F3n...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100736983315305121)
,p_name=>'WAITING.APP_UPDATE'
,p_message_language=>'es'
,p_message_text=>unistr('Actualizando Aplicaci\00F3n...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100055741548304567)
,p_name=>'WAITING.GENERIC'
,p_message_language=>'es'
,p_message_text=>'Procesando Solicitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100055883418304567)
,p_name=>'WAITING.SUPPORTING_OBJECTS'
,p_message_language=>'es'
,p_message_text=>'Instalando Objetos de Soporte'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100165201756304690)
,p_name=>'WARNING_MISSING_CLASS'
,p_message_language=>'es'
,p_message_text=>'Sin Clase Coincidente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100165161693304689)
,p_name=>'WARNING_MULTIPLE_MATCHES'
,p_message_language=>'es'
,p_message_text=>'Varias Coincidencias'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99510541000304149)
,p_name=>'WEB.SOURCE.ADD_FROM_CATALOG'
,p_message_language=>'es'
,p_message_text=>'Agregar Servicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99511557292304150)
,p_name=>'WEB.SOURCE.SERVICE_FROM_CATALOG'
,p_message_language=>'es'
,p_message_text=>unistr('Para agregarlo desde el cat\00E1logo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99511304168304149)
,p_name=>'WEB.SOURCE.UNADD_FROM_CATALOG'
,p_message_language=>'es'
,p_message_text=>'Eliminar Servicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99977213381304507)
,p_name=>'WEBSHEET'
,p_message_language=>'es'
,p_message_text=>'Hoja Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100007836029304530)
,p_name=>'WEBSHEET ATTACHMENTS'
,p_message_language=>'es'
,p_message_text=>'Adjuntos de Hoja Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100717202186305106)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP'
,p_message_language=>'es'
,p_message_text=>'Departamento TI CualquierComp'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100717182626305106)
,p_name=>'WEBSHEET.ANYCO.SAMPLE.APP.DESCR'
,p_message_language=>'es'
,p_message_text=>unistr('Departamento TI CualquierComp destaca c\00F3mo utilizar las funciones y las capacidades de las hojas de c\00E1lculo web para el uso compartido de contenido basado en web y la creaci\00F3n de informes sobre datos cr\00EDticos. Esta aplicaci\00F3n de hoja de c\00E1lculo web d')
||unistr('e ejemplo contiene varias cuadr\00EDculas de datos y muestra c\00F3mo incluir los datos en informes y gr\00E1ficos embebidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100662911512305062)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP'
,p_message_language=>'es'
,p_message_text=>'Grandes Felinos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100663239246305062)
,p_name=>'WEBSHEET.DEMO.SAMPLE.APP.DESCR'
,p_message_language=>'es'
,p_message_text=>unistr('Grandes Felinos resalta muchas funciones y capacidades de las hojas de c\00E1lculo web, incluidas las im\00E1genes incluidas y los enlaces de p\00E1ginas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99577366149304203)
,p_name=>'WEBSHEETS'
,p_message_language=>'es'
,p_message_text=>unistr('Hojas de C\00E1lculo Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100353755254304831)
,p_name=>'WEBSHEETS_FAQ_A1'
,p_message_language=>'es'
,p_message_text=>unistr('Una aplicaci\00F3n de hoja de c\00E1lculo web consta de p\00E1ginas web en las que se combinan texto y datos. Estas aplicaciones las definen los usuarios y son altamente din\00E1micas. Incluyen controles de navegaci\00F3n y capacidades de b\00FAsqueda, y permiten agregar an')
||unistr('otaciones como archivos, notas y etiquetas. Las aplicaciones se pueden proteger mediante listas de control de acceso y distintos modelos de autenticaci\00F3n incorporados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100353869773304831)
,p_name=>'WEBSHEETS_FAQ_A2'
,p_message_language=>'es'
,p_message_text=>unistr('Las aplicaciones de hoja de c\00E1lculo web permiten a un grupo de contribuyentes crear de forma r\00E1pida p\00E1ginas informativas con informes y gr\00E1ficos con la ayuda de una explorador web \00FAnicamente. Los usuarios pueden mantener f\00E1cilmente texto y datos loca')
||unistr('les (denominados cuadr\00EDculas de datos), as\00ED como visualizar datos de consultas SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100353993672304831)
,p_name=>'WEBSHEETS_FAQ_A3'
,p_message_language=>'es'
,p_message_text=>unistr('Las aplicaciones de hoja de c\00E1lculo web tienen funciones similares a las de las p\00E1ginas WIKI. Sin embargo, las primeras est\00E1n optimizadas para la visualizaci\00F3n e integraci\00F3n de datos. Por ejemplo, puede definir una cuadr\00EDcula de datos para almacenar ')
||unistr('informaci\00F3n tabular, definir un informe sobre las tablas existentes o simplemente utilizar una etiqueta SQL para mostrar datos de base de datos dentro de una p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100354029670304831)
,p_name=>'WEBSHEETS_FAQ_A4'
,p_message_language=>'es'
,p_message_text=>unistr('Las cuadr\00EDculas de datos son un componente de hoja de c\00E1lculo web que funciona de forma similar a las hojas de c\00E1lculo, lo que le permite mantener de forma f\00E1cil informaci\00F3n tabular. La gran diferencia con respecto a las otras, es que en lugar de alm')
||unistr('acenarse localmente en archivos, todos los datos de hojas de c\00E1lculo web se almacenan de forma central en Oracle Database. Con las cuadr\00EDculas de datos, puede agregar anotaciones a cada fila de datos, incluyendo archivos, notas, etiquetas y enlaces. ')
||unistr('Adem\00E1s, como ventaja adicional, todos los datos se pueden buscar con la b\00FAsqueda de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100354441432304831)
,p_name=>'WEBSHEETS_FAQ_A5'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Las etiquetas SQL permiten a los usuarios incluir informes en una p\00E1gina de manera sencilla bas\00E1ndose en sentencias SQL escritas en tablas de base de datos. Con SQL, los usuarios pueden recuperar f\00E1cilmente datos directamente de sus tablas favoritas.')
||unistr(' Por ejemplo, para ver bugs abiertos que est\00E9n vencidos, utilice la siguiente etiqueta: '),
'<pre>[[SQL: select * from bugs where due_date < sysdate and status = ''OPEN'']] </pre>',
unistr('Esta consulta se ejecuta cada vez que se visualiza la p\00E1gina, lo que proporciona datos din\00E1micos en lugar de una instant\00E1nea normal.  ')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100354178002304831)
,p_name=>'WEBSHEETS_FAQ_A6'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Las aplicaciones de hoja de c\00E1lculo web facilitan el uso compartido del contenido y proporcionan informes b\00E1sicos e informales. Toda la estructura y el contenido de una aplicaci\00F3n de hoja de c\00E1lculo web es controlada por los usuarios (es decir, los c')
||unistr('ontribuyentes y administradores). Por el contrario, las aplicaciones de base de datos se utilizan para el mantenimiento de datos especializados y la creaci\00F3n de informes m\00E1s formales y sofisticados. La estructura de una aplicaci\00F3n de base de datos es')
||' controlada por los desarrolladores, pero el contenido normalmente lo controlan los usuarios finales.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100353211183304831)
,p_name=>'WEBSHEETS_FAQ_Q1'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFQu\00E9 es una hoja de c\00E1lculo web?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100353441016304831)
,p_name=>'WEBSHEETS_FAQ_Q2'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFPor qu\00E9 crear una aplicaci\00F3n de hoja de c\00E1lculo web?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100353522168304831)
,p_name=>'WEBSHEETS_FAQ_Q3'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFEn qu\00E9 se diferencia una aplicaci\00F3n de hoja de c\00E1lculo web de una p\00E1gina WIKI?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100353641413304831)
,p_name=>'WEBSHEETS_FAQ_Q4'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFSon las aplicaciones de hoja de c\00E1lculo web hojas de c\00E1lculo en l\00EDnea?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100354544444304832)
,p_name=>'WEBSHEETS_FAQ_Q5'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFQu\00E9 es una etiqueta SQL?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100353334822304831)
,p_name=>'WEBSHEETS_FAQ_Q6'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFEn qu\00E9 se diferencia una aplicaci\00F3n de hoja de c\00E1lculo web de una aplicaci\00F3n de base de datos?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99636123170304246)
,p_name=>'WEBSHEETS_NOT_INSTALLED'
,p_message_language=>'es'
,p_message_text=>'No se ha instalado el componente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100738938701305123)
,p_name=>'WEBSHEET_ACCESS_CONTROL'
,p_message_language=>'es'
,p_message_text=>unistr('Control de Acceso de Hoja de C\00E1lculo Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100717966653305107)
,p_name=>'WEBSHEET_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n de Hoja de C\00E1lculo Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99561939788304191)
,p_name=>'WEBSHEET_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaciones de Hoja de C\00E1lculo Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100305378534304795)
,p_name=>'WEBSHEET_APPLICATION_NOT_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n %0 no est\00E1 disponible actualmente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100008930113304531)
,p_name=>'WEBSHEET_ATTACHMENTS'
,p_message_language=>'es'
,p_message_text=>'Adjuntos de Hoja Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100299841896304791)
,p_name=>'WEBSHEET_CONTENT_LAST_UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima actualizaci\00F3n del contenido %0 por %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100299954403304791)
,p_name=>'WEBSHEET_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina creada %0 por %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100663324130305062)
,p_name=>'WEBSHEET_INSTALLATION_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Va a instalar una aplicaci\00F3n de hoja de c\00E1lculo web de ejemplo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100731887640305117)
,p_name=>'WEBSHEET_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Hoja de C\00E1lculo Web: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100292218851304786)
,p_name=>'WEBSHEET_LAST_UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima actualizaci\00F3n de la p\00E1gina %0 por %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100007785365304530)
,p_name=>'WEBSHEET_NON_BLOB_DATA'
,p_message_language=>'es'
,p_message_text=>'Datos no BLOB de hoja web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100702919548305096)
,p_name=>'WEBSHEET_OBJECTS_NOT_VALID'
,p_message_language=>'es'
,p_message_text=>unistr('Los objetos de hoja de c\00E1lculo web no son v\00E1lidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100052530794304564)
,p_name=>'WEBSHEET_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha instalado la aplicaci\00F3n de hoja de c\00E1lculo web %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100316896086304804)
,p_name=>'WEBSHEET_TABLE_ACCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Los siguientes objetos se pueden consultar mediante la etiqueta de marca SQL o est\00E1n disponibles dentro de Reports. Las comillas dobles se utilizan para identificar nombres de objeto sensibles a may\00FAsculas/min\00FAsculas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100006216782304529)
,p_name=>'WEBSHEET_VIEWS'
,p_message_language=>'es'
,p_message_text=>unistr('Vistas de P\00E1gina de Hoja Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100037105558304553)
,p_name=>'WEB_SERVICE'
,p_message_language=>'es'
,p_message_text=>'Servicio Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99731686340304316)
,p_name=>'WEB_SERVICE_RESULT'
,p_message_language=>'es'
,p_message_text=>'Resultado de Servicio Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99497068055304139)
,p_name=>'WEB_SOURCE.NATIVE_ADFBC'
,p_message_language=>'es'
,p_message_text=>'Servicio REST de aplicaciones de Oracle Cloud (SaaS)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99496879486304139)
,p_name=>'WEB_SOURCE.NATIVE_HTTP'
,p_message_language=>'es'
,p_message_text=>'HTTP simple'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99497114183304139)
,p_name=>'WEB_SOURCE.NATIVE_OCI'
,p_message_language=>'es'
,p_message_text=>'Infraestructura de Oracle Cloud (OCI)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99496965042304139)
,p_name=>'WEB_SOURCE.NATIVE_ORDS'
,p_message_language=>'es'
,p_message_text=>'Oracle REST Data Services'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99557156148304187)
,p_name=>'WELCOME_TEXT_4700_P1'
,p_message_language=>'es'
,p_message_text=>'Complete este asistente de registro para solicitar un espacio de trabajo de Oracle APEX.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100048609248304561)
,p_name=>'WHITE_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto Blanco'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99589721180304212)
,p_name=>'WITHIN_NEXT_1_DAY'
,p_message_language=>'es'
,p_message_text=>unistr('En el pr\00F3ximo d\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100656645418305057)
,p_name=>'WITHIN_NEXT_X_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('En los pr\00F3ximos %0 d\00EDas')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100008750254304531)
,p_name=>'WITH_ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('con la opci\00F3n admin')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99732038583304316)
,p_name=>'WITH_SHORTCUTS'
,p_message_language=>'es'
,p_message_text=>unistr('con m\00E9todos abreviados')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100114492598304612)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero de p\00E1gina ya existe en esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100113854771304612)
,p_name=>'WIZ.RESERVE_PAGE.PAGE_ID.RESERVED'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero de p\00E1gina est\00E1 reservado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99765105983304340)
,p_name=>'WIZAPI_DELETE_CHECKED'
,p_message_language=>'es'
,p_message_text=>unistr('Suprimir Selecci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99642165816304250)
,p_name=>'WIZARD.BUILD_OPTION.COMMENTED_OUT'
,p_message_language=>'es'
,p_message_text=>'Comentado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99499605065304141)
,p_name=>'WIZARD.CLEAR_CACHE_PROCESS_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100537489093304968)
,p_name=>'WIZARD.CREATE.FS.CARD_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas de tarjeta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99513050813304151)
,p_name=>'WIZARD.CREATE.PAGE.CARDS'
,p_message_language=>'es'
,p_message_text=>'Crear tarjetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100340547564304821)
,p_name=>'WIZARD.CREATE.PAGE.CLASSIC'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Informe Cl\00E1sico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100305795958304795)
,p_name=>'WIZARD.CREATE.PAGE.FACETED_SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('Crear b\00FAsqueda de facetas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100341006422304821)
,p_name=>'WIZARD.CREATE.PAGE.FORMNLISTVIEW'
,p_message_language=>'es'
,p_message_text=>'Crear Vista de Lista y Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100341427770304822)
,p_name=>'WIZARD.CREATE.PAGE.FORMONPROCEDURE'
,p_message_language=>'es'
,p_message_text=>'Crear Pantalla Basada en Procedimiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100341330662304822)
,p_name=>'WIZARD.CREATE.PAGE.FORMONSQL'
,p_message_language=>'es'
,p_message_text=>'Crear Pantalla sobre Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100341223044304822)
,p_name=>'WIZARD.CREATE.PAGE.FORMONTABLE'
,p_message_language=>'es'
,p_message_text=>'Crear Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100715599362305105)
,p_name=>'WIZARD.CREATE.PAGE.FORMONWEBSERVICE'
,p_message_language=>'es'
,p_message_text=>'Crear Pantalla Basada en Servicio Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99519954452304156)
,p_name=>'WIZARD.CREATE.PAGE.FS.FACET'
,p_message_language=>'es'
,p_message_text=>'Faceta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100340449258304821)
,p_name=>'WIZARD.CREATE.PAGE.GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Cuadr\00EDcula Interactiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100340338685304821)
,p_name=>'WIZARD.CREATE.PAGE.INTERACTIVE'
,p_message_language=>'es'
,p_message_text=>'Crear Informe Interactivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99511267915304149)
,p_name=>'WIZARD.CREATE.PAGE.MAP_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Crear mapa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100340601142304821)
,p_name=>'WIZARD.CREATE.PAGE.MD'
,p_message_language=>'es'
,p_message_text=>'Crear Maestro/Detalle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100340855418304821)
,p_name=>'WIZARD.CREATE.PAGE.REPORT'
,p_message_language=>'es'
,p_message_text=>'Crear Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100340967783304821)
,p_name=>'WIZARD.CREATE.PAGE.REPORTWFORM'
,p_message_language=>'es'
,p_message_text=>'Crear Informe con formulario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99518818835304155)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS'
,p_message_language=>'es'
,p_message_text=>'Crear filtros inteligentes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99520098039304156)
,p_name=>'WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100341158856304822)
,p_name=>'WIZARD.CREATE.PAGE.TABULARFORM'
,p_message_language=>'es'
,p_message_text=>'Crear Pantalla Tabular'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100340784597304821)
,p_name=>'WIZARD.CREATE.PAGE.WEBSERVICE'
,p_message_language=>'es'
,p_message_text=>'Crear Informe sobre Servicios Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99685159418304282)
,p_name=>'WIZARD.CREATE_PAGE.UT.REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Este asistente requiere una aplicaci\00F3n basada en el tema universal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99499144998304140)
,p_name=>'WIZARD.FORM.DML_PROCESS_NAME'
,p_message_language=>'es'
,p_message_text=>'Procesar pantalla %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99499049707304140)
,p_name=>'WIZARD.FORM.INIT_PROCESS_NAME'
,p_message_language=>'es'
,p_message_text=>'Inicializar pantalla %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100095914536304598)
,p_name=>'WIZARD.FORM.QUERY'
,p_message_language=>'es'
,p_message_text=>'Consulta SQL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100095852004304598)
,p_name=>'WIZARD.FORM.TABLE'
,p_message_language=>'es'
,p_message_text=>'Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100109663448304609)
,p_name=>'WIZARD.IG.DML_PROCESS_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('%0: Guardar Datos de Cuadr\00EDcula Interactiva')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100102405425304603)
,p_name=>'WIZARD.REPORT.CLASSIC'
,p_message_language=>'es'
,p_message_text=>unistr('Informe Cl\00E1sico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100102361465304603)
,p_name=>'WIZARD.REPORT.GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadr\00EDcula Interactiva')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100102243050304603)
,p_name=>'WIZARD.REPORT.INTERACTIVE'
,p_message_language=>'es'
,p_message_text=>'Informe Interactivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100102668283304603)
,p_name=>'WIZARD.REPORT.REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100102566421304603)
,p_name=>'WIZARD.REPORT.WEBSERVICE'
,p_message_language=>'es'
,p_message_text=>'Informe Basado en Servicio Web'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99705609547304297)
,p_name=>'WIZARD.VALIDATION.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe tener alg\00FAn valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100026327081304544)
,p_name=>'WIZARD.VALIDATION.PAGE_LEVEL_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha producido un error de validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100026210684304544)
,p_name=>'WIZARD.VALIDATION.TABFORM_COLUMN_IS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'#COLUMN_HEADER# debe tener un valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100059703356304570)
,p_name=>'WIZARD_PAGES_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Las p\00E1ginas del asistente se han creado correctamente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100766507780305143)
,p_name=>'WIZARD_PROGRESS'
,p_message_language=>'es'
,p_message_text=>'Progreso del Asistente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100045074835304558)
,p_name=>'WIZARD_REPORT_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina Informe de Asistente se ha creado correctamente.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99733772765304318)
,p_name=>'WORKSPACE'
,p_message_language=>'es'
,p_message_text=>'espacio de trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100033621843304550)
,p_name=>'WORKSPACE IMAGE'
,p_message_language=>'es'
,p_message_text=>'Imagen de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100096138811304598)
,p_name=>'WORKSPACES'
,p_message_language=>'es'
,p_message_text=>'Espacios de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100005058132304528)
,p_name=>'WORKSPACE_APPLICATIONS'
,p_message_language=>'es'
,p_message_text=>'Aplicaciones de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100005313371304529)
,p_name=>'WORKSPACE_APPLICATION_ACTIVITY_SUMMARY'
,p_message_language=>'es'
,p_message_text=>unistr('Resumen de Actividad de la Aplicaci\00F3n de Espacio de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100647876463305050)
,p_name=>'WORKSPACE_COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento Actual de Espacios de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100004315899304528)
,p_name=>'WORKSPACE_ID'
,p_message_language=>'es'
,p_message_text=>'Identificador de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100316467370304803)
,p_name=>'WORKSPACE_IMAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Im\00E1genes de Espacio de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100096639743304599)
,p_name=>'WORKSPACE_INITCAP'
,p_message_language=>'es'
,p_message_text=>'Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99915068237304460)
,p_name=>'WORKSPACE_INIT_CAP'
,p_message_language=>'es'
,p_message_text=>'Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99574038869304200)
,p_name=>'WORKSPACE_LABEL'
,p_message_language=>'es'
,p_message_text=>'Espacio de Trabajo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99543188972304173)
,p_name=>'WORKSPACE_LOGIN'
,p_message_language=>'es'
,p_message_text=>unistr('Conexi\00F3n al Espacio de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100241757263304747)
,p_name=>'WORKSPACE_MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Mensaje de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100004185515304528)
,p_name=>'WORKSPACE_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100153087429304680)
,p_name=>'WORKSPACE_OVERRIDE_ID'
,p_message_language=>'es'
,p_message_text=>unistr('ID de Sustituci\00F3n de Espacio de Trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100036501111304552)
,p_name=>'WORKSPACE_REQUEST'
,p_message_language=>'es'
,p_message_text=>'Solicitud de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100004974555304528)
,p_name=>'WORKSPACE_SCHEMAS'
,p_message_language=>'es'
,p_message_text=>'Esquemas de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99593120814304214)
,p_name=>'WORKSPACE_SIGNUP_SUCCESS_01'
,p_message_language=>'es'
,p_message_text=>unistr('Recibir\00E1 un correo electr\00F3nico para que active su espacio de trabajo cuando se haya aprobado la solicitud.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100096340603304598)
,p_name=>'WORKSPACE_USERS'
,p_message_language=>'es'
,p_message_text=>'Usuarios de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100008899944304531)
,p_name=>'WORKSPACE_WEBSHEETS'
,p_message_language=>'es'
,p_message_text=>'Hojas Web de Espacio de Trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100004623957304528)
,p_name=>'WORKSPACE_WORKSPACE_SUMMARY'
,p_message_language=>'es'
,p_message_text=>'Resumen del espacio de trabajo %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99980643236304510)
,p_name=>'WORK_INITIATED'
,p_message_language=>'es'
,p_message_text=>'Trabajo Iniciado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99980744080304510)
,p_name=>'WORK_PROGRESSING'
,p_message_language=>'es'
,p_message_text=>'Trabajo en Progreso'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99988795603304516)
,p_name=>'WRITING'
,p_message_language=>'es'
,p_message_text=>'Escribiendo'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100652074217305053)
,p_name=>'WS.CAPABILITY'
,p_message_language=>'es'
,p_message_text=>'Capacidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100651961892305053)
,p_name=>'WS.READER'
,p_message_language=>'es'
,p_message_text=>'Lector'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100044441292304558)
,p_name=>'WSDL_SUCCESS_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('La referencia de servicio web se ha agregado a la aplicaci\00F3n %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99533527965304166)
,p_name=>'WS_ACCESS_CONTROL'
,p_message_language=>'es'
,p_message_text=>'Control de Acceso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100277537193304775)
,p_name=>'WS_ADD_FILE'
,p_message_language=>'es'
,p_message_text=>'Agregar Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100715763465305105)
,p_name=>'WS_ADD_FILE_NOT_ENOUGH_SPACE_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No hay suficiente espacio para agregar el archivo. Solicite almacenamiento adicional en la p\00E1gina de administraci\00F3n, vaya a Gestionar Servicio y haga clic en Solicitar Almacenamiento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100300948497304792)
,p_name=>'WS_ADD_LINK'
,p_message_language=>'es'
,p_message_text=>'Agregar Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100335843720304818)
,p_name=>'WS_ADD_NEW'
,p_message_language=>'es'
,p_message_text=>'Agregar Nuevo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100301049362304792)
,p_name=>'WS_ADD_NOTE'
,p_message_language=>'es'
,p_message_text=>'Agregar Nota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100300460055304792)
,p_name=>'WS_ADD_ROW'
,p_message_language=>'es'
,p_message_text=>'Agregar Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100300872265304792)
,p_name=>'WS_ADD_TAGS'
,p_message_language=>'es'
,p_message_text=>'Agregar Etiquetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100345023542304825)
,p_name=>'WS_ADD_VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar Validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99533304048304166)
,p_name=>'WS_ADMINISTRATION'
,p_message_language=>'es'
,p_message_text=>unistr('Administraci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100277179693304774)
,p_name=>'WS_ALIAS_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el alias.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99525820158304160)
,p_name=>'WS_ALIAS_NOT_VALID'
,p_message_language=>'es'
,p_message_text=>unistr('El alias debe ser alfanum\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99537014213304169)
,p_name=>'WS_ALIAS_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>unistr('El alias es demasiado largo. El l\00EDmite es de 255 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100342065718304822)
,p_name=>'WS_ALL_ROWS'
,p_message_language=>'es'
,p_message_text=>'Todas las Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100335968682304818)
,p_name=>'WS_ANNOTATIONS'
,p_message_language=>'es'
,p_message_text=>'Anotaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99533474973304166)
,p_name=>'WS_APPLICATION_PROPERTIES'
,p_message_language=>'es'
,p_message_text=>unistr('Propiedades de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100350514393304829)
,p_name=>'WS_CANNOT_USE_LOV'
,p_message_language=>'es'
,p_message_text=>unistr('El tipo de visualizaci\00F3n seleccionado no puede utilizar la lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100352924824304830)
,p_name=>'WS_CHANGED'
,p_message_language=>'es'
,p_message_text=>'Cambiado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100337391440304819)
,p_name=>'WS_CHANGE_COLUMN_TYPE'
,p_message_language=>'es'
,p_message_text=>'Cambiar Tipo de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100353147912304831)
,p_name=>'WS_CHG_WS_RPT_QRY_HLP'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado cambiar la consulta de informe. Si ha agregado alguna columna a la consulta, no se mostrar\00E1 al ejecutar el informe. Tendr\00E1 que utilizar el men\00FA de acciones y seleccionar las columnas o hacer clic en <strong>Restablecer</strong>. Si ha e')
||unistr('liminado alguna columna de la consulta, se desactivar\00E1n los filtros, las reglas para resaltar y otros valores existentes del informe que hagan referencia a esas columnas. Confirme la solicitud.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99530935599304164)
,p_name=>'WS_CHOOSE_FILE'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100337880576304819)
,p_name=>'WS_COLUMN_ALIGNMENT'
,p_message_language=>'es'
,p_message_text=>unistr('Alineaci\00F3n de Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100300773942304792)
,p_name=>'WS_COLUMN_GROUPS'
,p_message_language=>'es'
,p_message_text=>'Grupos de Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100712340040305103)
,p_name=>'WS_COLUMN_NAME_NOT_UNIQUE'
,p_message_language=>'es'
,p_message_text=>'Ya existe ese nombre de columna. Introduzca otro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100300622357304792)
,p_name=>'WS_COLUMN_PROPERTIES'
,p_message_language=>'es'
,p_message_text=>'Propiedades de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100338856690304820)
,p_name=>'WS_COL_CONFIRM_DELETE'
,p_message_language=>'es'
,p_message_text=>unistr('Confirme que desea realizar esta acci\00F3n de supresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100350318019304829)
,p_name=>'WS_COL_LABEL_MUST_BE_SPEC'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar la etiqueta de columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100351647794304829)
,p_name=>'WS_COL_MUST_BE_SEL'
,p_message_language=>'es'
,p_message_text=>'Se debe seleccionar la columna para cambiar el valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100351869782304830)
,p_name=>'WS_COL_MUST_BE_SEL_REP'
,p_message_language=>'es'
,p_message_text=>'Se debe seleccionar la columna para sustituir el valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100350924865304829)
,p_name=>'WS_COL_NAME_MUST_BE_SPEC'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el nombre de columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100350206724304828)
,p_name=>'WS_COL_SEL_TO_EDIT'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe seleccionar la columna para su edici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100351013954304829)
,p_name=>'WS_COL_SEL_TO_REMOVE'
,p_message_language=>'es'
,p_message_text=>'Se deben seleccionar las columnas que eliminar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100336871818304818)
,p_name=>'WS_COMMA_SEP_LIST'
,p_message_language=>'es'
,p_message_text=>'Lista Separada por Comas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100338598711304820)
,p_name=>'WS_COMMA_SEP_LIST2'
,p_message_language=>'es'
,p_message_text=>'Introduzca una lista separada por comas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100349922283304828)
,p_name=>'WS_CONF_DELETE'
,p_message_language=>'es'
,p_message_text=>unistr('Confirme la supresi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100725745301305113)
,p_name=>'WS_CONTROL_PANEL'
,p_message_language=>'es'
,p_message_text=>'Panel de Control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100648820411305051)
,p_name=>'WS_COPY'
,p_message_language=>'es'
,p_message_text=>'Copiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100263429797304764)
,p_name=>'WS_COPY_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva P\00E1gina como Copia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100286518725304781)
,p_name=>'WS_CREATE_APP_CONFIRM'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado la creaci\00F3n de una hoja de c\00E1lculo web con los siguientes atributos. Confirme las selecciones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100262865079304764)
,p_name=>'WS_CREATE_CHART_SECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Secci\00F3n de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100041894589304556)
,p_name=>'WS_CREATE_DATA_GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Cuadr\00EDcula de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100262988256304764)
,p_name=>'WS_CREATE_DATA_SECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Secci\00F3n de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100337021838304819)
,p_name=>'WS_CREATE_DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100263153130304764)
,p_name=>'WS_CREATE_NAV_SECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Secci\00F3n de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100263388495304764)
,p_name=>'WS_CREATE_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Crear P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99567087220304195)
,p_name=>'WS_CREATE_PLSQL_SECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Secci\00F3n PL/SQL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100262708109304764)
,p_name=>'WS_CREATE_SECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Secci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100263046303304764)
,p_name=>'WS_CREATE_TEXT_SECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Crear Secci\00F3n de Texto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100337124031304819)
,p_name=>'WS_CURRENT_USER'
,p_message_language=>'es'
,p_message_text=>'Usuario Actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99533153160304166)
,p_name=>'WS_DASHBOARD'
,p_message_language=>'es'
,p_message_text=>'Panel de Control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99510419114304149)
,p_name=>'WS_DATA'
,p_message_language=>'es'
,p_message_text=>'Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100022937666304542)
,p_name=>'WS_DATA_GRID_COLUMN_LIMIT_REACHED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha alcanzado el n\00FAmero m\00E1ximo de columnas disponibles para el tipo de columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100712587498305103)
,p_name=>'WS_DATA_GRID_DUP_COL_NAME_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('Se han encontrado nombres de columna duplicados. El nombre de columna debe ser \00FAnico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100677941175305073)
,p_name=>'WS_DATA_GRID_NAME_NOT_UNIQUE'
,p_message_language=>'es'
,p_message_text=>unistr('Ya existe ese nombre de cuadr\00EDcula de datos. Introduzca otro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100337290202304819)
,p_name=>'WS_DEFAULT_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100336962769304818)
,p_name=>'WS_DEFAULT_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100739467199305123)
,p_name=>'WS_DEFINE_DATA_GRID_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Definir Columnas de Cuadricula de Datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100338622301304820)
,p_name=>'WS_DELETE_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Suprimir Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100272517778304771)
,p_name=>'WS_DELETE_DATA_GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Suprimir Cuadr\00EDcula de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100343095304304823)
,p_name=>'WS_DELETE_ROWS'
,p_message_language=>'es'
,p_message_text=>'Suprimir Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100338795878304820)
,p_name=>'WS_DEL_COL_DIALOG_HLP'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccionar las columnas que se eliminar\00E1n de forma permanente junto con los datos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99556034561304186)
,p_name=>'WS_DGQ_FIRST_COL_MUST_BE_PK'
,p_message_language=>'es'
,p_message_text=>unistr('La primera columna debe ser una clave primaria de la cuadr\00EDcula de datos para poder mostrar el enlace de edici\00F3n o adici\00F3n de fila. Agregue la sustituci\00F3n "APXWS_DATA_GRID_PK" como primera columna en la sentencia select para incluir la clave primaria')
||'.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99549370440304181)
,p_name=>'WS_DGQ_MORE_THAN_ONE_DATA_GRID'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta debe hacer referencia a la cuadr\00EDcula de datos s\00F3lo una vez para poder mostrar el enlace de edici\00F3n o adici\00F3n de fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99556144281304186)
,p_name=>'WS_DGQ_MULTI_SELECT_STMT'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta contiene m\00E1s de una sentencia select. Agregue la sustituci\00F3n "APXWS_DATA_GRID_PK" como primera columna en la sentencia select para poder mostrar el enlace de edici\00F3n o adici\00F3n de fila.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100354616959304832)
,p_name=>'WS_DGQ_SQLVALUE_EXAMPLE'
,p_message_language=>'es'
,p_message_text=>'Sintaxis de Etiqueta SQLVALUE:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100101795114304602)
,p_name=>'WS_DGQ_SQL_EXAMPLE'
,p_message_language=>'es'
,p_message_text=>'Sintaxis de Etiqueta SQL:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100336408906304818)
,p_name=>'WS_DISPLAY_AS'
,p_message_language=>'es'
,p_message_text=>'Mostrar como'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100336396640304818)
,p_name=>'WS_DOCUMENT'
,p_message_language=>'es'
,p_message_text=>'Documento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100277034060304774)
,p_name=>'WS_DUPLICATE_PK_COLUMN'
,p_message_language=>'es'
,p_message_text=>'No se puede seleccionar la misma columna para la clave primaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100335619269304818)
,p_name=>'WS_EDIT_ATTACHMENT'
,p_message_language=>'es'
,p_message_text=>'Editar Anexo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100648989931305051)
,p_name=>'WS_EDIT_ATTRIBUTES'
,p_message_language=>'es'
,p_message_text=>'Editar Atributos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99532239888304165)
,p_name=>'WS_EDIT_FILE'
,p_message_language=>'es'
,p_message_text=>'Editar Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99531876404304165)
,p_name=>'WS_EDIT_NOTE'
,p_message_language=>'es'
,p_message_text=>'Editar Nota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100263298879304764)
,p_name=>'WS_EDIT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Editar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100649024900305051)
,p_name=>'WS_EDIT_QUERY'
,p_message_language=>'es'
,p_message_text=>'Editar Consulta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100270449292304769)
,p_name=>'WS_EDIT_SECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Secci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100333860829304816)
,p_name=>'WS_EDIT_SECTIONS'
,p_message_language=>'es'
,p_message_text=>'Editar Secciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99532378378304165)
,p_name=>'WS_EDIT_TAG'
,p_message_language=>'es'
,p_message_text=>'Editar Etiqueta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99596153727304216)
,p_name=>'WS_EDIT_TAGS'
,p_message_language=>'es'
,p_message_text=>'Editar Etiquetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99572396386304199)
,p_name=>'WS_EMAIL_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100339239742304820)
,p_name=>'WS_EMPTY_ROW'
,p_message_language=>'es'
,p_message_text=>unistr('Filas Vac\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100271063466304770)
,p_name=>'WS_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100348658894304827)
,p_name=>'WS_ERR_MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Mensaje de Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100352367311304830)
,p_name=>'WS_ERR_MSG_MUST_BE_SPEC'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el mensaje de error.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100302857267304793)
,p_name=>'WS_FILE'
,p_message_language=>'es'
,p_message_text=>'Archivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100278648931304775)
,p_name=>'WS_FILES'
,p_message_language=>'es'
,p_message_text=>'Archivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100761138081305139)
,p_name=>'WS_FILE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('El archivo debe tener alg\00FAn valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100342667207304823)
,p_name=>'WS_FILL'
,p_message_language=>'es'
,p_message_text=>'Rellenar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100342733577304823)
,p_name=>'WS_FILL_HLP'
,p_message_language=>'es'
,p_message_text=>'Rellenar los valores de columna nulos inferiores con el valor de columna de la celda superior.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100342424336304822)
,p_name=>'WS_FIND_WHAT'
,p_message_language=>'es'
,p_message_text=>'Buscar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100257547496304760)
,p_name=>'WS_GETTING_STARTED_CONTENT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Con las aplicaciones de hoja de c\00E1lculo web, los usuarios finales podr\00E1n gestionar datos estructurados y sin estructurar sin necesidad de un desarrollador. La hoja de c\00E1lculo web permite a los usuarios:'),
'<ul>',
unistr('<li>Crear y compartir contenido a trav\00E9s de la web con tan s\00F3lo un explorador web.</li>'),
unistr('<li>Organizar p\00E1ginas web en una jerarqu\00EDa y crear enlaces cruzados entre p\00E1ginas.</li>'),
unistr('<li>Crear y gestionar datos tabulares mediante una funci\00F3n embebida denominada Cuadr\00EDculas de Datos.</li>'),
'<li>Crear informes interactivos con SQL a partir de las estructuras de datos existentes en la base de datos.</li>',
unistr('<li>Mostrar en una p\00E1gina los datos de informes y cuadr\00EDculas de datos, en forma de gr\00E1ficos o informes.</li>'),
unistr('<li>Anotar p\00E1ginas con archivos, etiquetas y notas. Las im\00E1genes asociadas se pueden mostrar en l\00EDnea dentro del contenido de la p\00E1gina.</li>'),
unistr('<li>Buscar contenido de p\00E1gina (con la funci\00F3n de b\00FAsqueda incorporada).</li>'),
unistr('<li>Gestionar los usuarios que se pueden conectar y, tras ello, gestionar cu\00E1les podr\00E1n leer, escribir o administrar la aplicaci\00F3n (autenticaci\00F3n y autorizaci\00F3n).</li>'),
'</ul>',
unistr('<p>Haga clic en Ayuda para obtener m\00E1s informaci\00F3n.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100337441303304819)
,p_name=>'WS_GROUP'
,p_message_language=>'es'
,p_message_text=>'Agrupar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100343442547304823)
,p_name=>'WS_GROUP_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100351380768304829)
,p_name=>'WS_GROUP_NAME_MUST_BE_SPEC'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el nombre de grupo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100337735454304819)
,p_name=>'WS_HEADING_ALIGNMENT'
,p_message_language=>'es'
,p_message_text=>unistr('Alineaci\00F3n de Cabecera')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100338112904304819)
,p_name=>'WS_HEIGHT'
,p_message_language=>'es'
,p_message_text=>'Altura'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100351507825304829)
,p_name=>'WS_INVALID_COL'
,p_message_language=>'es'
,p_message_text=>unistr('Columna no v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100350162531304828)
,p_name=>'WS_INVALID_COL_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de columna no v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100308305864304797)
,p_name=>'WS_INVALID_DATA_GRID_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre o Alias de Datos No V\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100278848527304776)
,p_name=>'WS_LINKS'
,p_message_language=>'es'
,p_message_text=>'Enlaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100344109733304824)
,p_name=>'WS_LINK_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre del Enlace'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100277326195304774)
,p_name=>'WS_LINK_TO_THIS_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Enlazar a esta p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100342976850304823)
,p_name=>'WS_LOAD_ORDER'
,p_message_language=>'es'
,p_message_text=>'Orden de Carga'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100350787138304829)
,p_name=>'WS_LOV_ALREADY_EXISTS'
,p_message_language=>'es'
,p_message_text=>'Ya existe el nombre de la lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100336738788304818)
,p_name=>'WS_LOV_DEF'
,p_message_language=>'es'
,p_message_text=>unistr('Definici\00F3n de Lista de Valores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100350854785304829)
,p_name=>'WS_LOV_DEF_MUST_BE_SPEC'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar la definici\00F3n de la lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100338346028304819)
,p_name=>'WS_LOV_DIALOG_HLP1'
,p_message_language=>'es'
,p_message_text=>'Las listas de valores se utilizan para limitar los valores de columna que puede introducir un usuario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100338428270304820)
,p_name=>'WS_LOV_DIALOG_HLP2'
,p_message_language=>'es'
,p_message_text=>'Puede asociar la lista de valores definida a un columna en Editar Propiedades de Columna.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100350497361304829)
,p_name=>'WS_LOV_MUST_BE_DEF'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe definir la lista de valores para el tipo de visualizaci\00F3n seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100350604554304829)
,p_name=>'WS_LOV_MUST_BE_SPEC'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el nombre de la lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100336658347304818)
,p_name=>'WS_LOV_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100278474940304775)
,p_name=>'WS_MAP'
,p_message_language=>'es'
,p_message_text=>'Mapa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100338027985304819)
,p_name=>'WS_MAX_WIDTH'
,p_message_language=>'es'
,p_message_text=>unistr('Ancho M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100110005993304609)
,p_name=>'WS_MAX_WIDTH_LIMIT'
,p_message_language=>'es'
,p_message_text=>unistr('El ancho m\00E1ximo no puede ser mayor de 4000.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100335708982304818)
,p_name=>'WS_MINIMIZE'
,p_message_language=>'es'
,p_message_text=>'Minimizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100300523801304792)
,p_name=>'WS_MOVE_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Mover Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100663176957305062)
,p_name=>'WS_MUST_BE_DATE'
,p_message_language=>'es'
,p_message_text=>'%0 no coincide con el formato de fecha de %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100351422763304829)
,p_name=>'WS_NAME_MUST_BE_SPEC'
,p_message_language=>'es'
,p_message_text=>unistr('Debe especificar el nuevo nombre de cuadr\00EDcula de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100276984293304774)
,p_name=>'WS_NAME_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el nombre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100339038463304820)
,p_name=>'WS_NEW_COL_VAL'
,p_message_language=>'es'
,p_message_text=>'Nuevo Valor de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99532925825304166)
,p_name=>'WS_NEW_DATA_GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva Cuadr\00EDcula de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100343277901304823)
,p_name=>'WS_NEW_DATA_GRID_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('Nuevo Nombre de Cuadr\00EDcula de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100343350263304823)
,p_name=>'WS_NEW_GROUP'
,p_message_language=>'es'
,p_message_text=>'Nuevo Grupo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100336522346304818)
,p_name=>'WS_NEW_LOV'
,p_message_language=>'es'
,p_message_text=>'Nueva Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100338200556304819)
,p_name=>'WS_NEW_LOV_BASED_ON_CURR'
,p_message_language=>'es'
,p_message_text=>'Nueva Lista de Valores Basada en Valores Actuales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99532788191304165)
,p_name=>'WS_NEW_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99533036179304166)
,p_name=>'WS_NEW_REPORT'
,p_message_language=>'es'
,p_message_text=>'Nuevo Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99532640484304165)
,p_name=>'WS_NEW_SECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva Secci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100345275568304825)
,p_name=>'WS_NEW_VALIDATION'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva Validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100352798040304830)
,p_name=>'WS_NEW_VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor Nuevo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100238296548304744)
,p_name=>'WS_NOTE'
,p_message_language=>'es'
,p_message_text=>'Nota'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100278799998304775)
,p_name=>'WS_NOTES'
,p_message_language=>'es'
,p_message_text=>'Notas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100238361423304744)
,p_name=>'WS_NOTE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('La nota debe tener alg\00FAn valor. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99532541652304165)
,p_name=>'WS_NO_COLUMNS_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99532124290304165)
,p_name=>'WS_NO_FILES'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn Archivo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99531020177304164)
,p_name=>'WS_NO_FILE_CHOSEN'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha seleccionado ning\00FAn archivo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99531979273304165)
,p_name=>'WS_NO_NOTES'
,p_message_language=>'es'
,p_message_text=>'Sin Notas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99532465123304165)
,p_name=>'WS_NO_TAGS'
,p_message_language=>'es'
,p_message_text=>'Sin Etiquetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100336219556304818)
,p_name=>'WS_NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100352620847304830)
,p_name=>'WS_OLD_VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100342877589304823)
,p_name=>'WS_ORDER_BY'
,p_message_language=>'es'
,p_message_text=>'Ordenar por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100303065532304794)
,p_name=>'WS_PAGE_ALIAS'
,p_message_language=>'es'
,p_message_text=>unistr('Alias de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99572112267304199)
,p_name=>'WS_PAGE_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha creado la p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100303134179304794)
,p_name=>'WS_PAGE_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99532870466304166)
,p_name=>'WS_PAGE_DIRECTORY'
,p_message_language=>'es'
,p_message_text=>unistr('Directorio de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99533213380304166)
,p_name=>'WS_PAGE_HISTORY'
,p_message_language=>'es'
,p_message_text=>unistr('Historial de P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100701236545305094)
,p_name=>'WS_PAGE_LIST_WITH_CHILD_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Lista Jer\00E1rquica de P\00E1ginas con P\00E1ginas Secundarias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100648540716305051)
,p_name=>'WS_PROPERTIES'
,p_message_language=>'es'
,p_message_text=>'Propiedades'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100349874741304828)
,p_name=>'WS_QRY_MORE_10K'
,p_message_language=>'es'
,p_message_text=>unistr('Esta consulta devuelve m\00E1s de 10.000 filas, filtre los datos para asegurar resultados completos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100316731998304804)
,p_name=>'WS_QUERY_NOT_ALLOWED'
,p_message_language=>'es'
,p_message_text=>unistr('No est\00E1 permitida la consulta de objetos de aplicaci\00F3n interna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100337690482304819)
,p_name=>'WS_READ_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo Lectura')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100352496504304830)
,p_name=>'WS_RECENT_CHGS_LISTED_BELOW'
,p_message_language=>'es'
,p_message_text=>unistr('A continuaci\00F3n se muestran los cambios recientes:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100648722784305051)
,p_name=>'WS_REPLACE'
,p_message_language=>'es'
,p_message_text=>'Sustituir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100342536754304823)
,p_name=>'WS_REPLACE_WITH'
,p_message_language=>'es'
,p_message_text=>'Sustituir por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100352562890304830)
,p_name=>'WS_ROW'
,p_message_language=>'es'
,p_message_text=>'Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100343149372304823)
,p_name=>'WS_ROWS_W_EMPTY_COL'
,p_message_language=>'es'
,p_message_text=>unistr('Filas con Columnas Vac\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100660752316305060)
,p_name=>'WS_ROW_CREATED'
,p_message_language=>'es'
,p_message_text=>'Fila %0 creada %1 por %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100660633227305060)
,p_name=>'WS_ROW_KEY'
,p_message_language=>'es'
,p_message_text=>'Clave de Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100660896023305060)
,p_name=>'WS_ROW_LAST_UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima actualizaci\00F3n del contenido %0 por %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100351780367304830)
,p_name=>'WS_ROW_MUST_BE_SEL'
,p_message_language=>'es'
,p_message_text=>'Se debe seleccionar una fila para definir el valor de columna.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100278598504304775)
,p_name=>'WS_ROW_ORDER'
,p_message_language=>'es'
,p_message_text=>'Orden de Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100350059230304828)
,p_name=>'WS_ROW_SELECTED_DEL'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe seleccionar una l\00EDnea que suprimir.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100286633436304781)
,p_name=>'WS_SAMPLE_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se crear\00E1 una p\00E1gina inicial de prueba.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100300371450304792)
,p_name=>'WS_SAVE_ADD_ANOTHER'
,p_message_language=>'es'
,p_message_text=>'Guardar y Agregar Otro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100702287196305095)
,p_name=>'WS_SEARCH_REPORT_X'
,p_message_language=>'es'
,p_message_text=>'Buscar Informe %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100302989869304793)
,p_name=>'WS_SECTION_CONTENT'
,p_message_language=>'es'
,p_message_text=>unistr('Contenido de Secci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99572004937304199)
,p_name=>'WS_SECTION_CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Secci\00F3n creada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100286731520304781)
,p_name=>'WS_SECTION_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de Secci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100339113258304820)
,p_name=>'WS_SELECTED'
,p_message_language=>'es'
,p_message_text=>'Seleccionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100342289543304822)
,p_name=>'WS_SELECTED_ROWS'
,p_message_language=>'es'
,p_message_text=>'Filas Seleccionadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100337537757304819)
,p_name=>'WS_SELECT_COLUMN_GROUP'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Grupo de Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100259195659304761)
,p_name=>'WS_SELECT_RPT_NAME'
,p_message_language=>'es'
,p_message_text=>'Seleccione el nombre del informe para ver las columnas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100351211486304829)
,p_name=>'WS_SEQ_MUST_BE_NUM'
,p_message_language=>'es'
,p_message_text=>unistr('La secuencia debe ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100351194675304829)
,p_name=>'WS_SEQ_MUST_BE_SPEC'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar la secuencia.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100338977040304820)
,p_name=>'WS_SET_COL_VAL'
,p_message_language=>'es'
,p_message_text=>'Definir Valores de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100709260163305100)
,p_name=>'WS_SIGNUP.PRIVACY_POLICY'
,p_message_language=>'es'
,p_message_text=>unistr('<a href="https://www.oracle.com/legal/privacy/index.html" target="_new">Pol\00EDtica de Privacidad de Oracle</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100701738087305095)
,p_name=>'WS_SIGNUP.TERMS'
,p_message_language=>'es'
,p_message_text=>unistr('Al hacer clic en el bot\00F3n "Siguiente", reconoce y acepta que el uso del sitio web de Oracle est\00E1 sujeto a las <a href="https://www.oracle.com/es/legal/terms/index.html" target="_new">condiciones de uso de Oracle.com </a>. En la <a href="https://www.o')
||unistr('racle.com/legal/privacy/index.html" target="_new">pol\00EDtica de privacidad de Oracle</a> encontrar\00E1 informaci\00F3n adicional sobre la recopilaci\00F3n y el uso de su informaci\00F3n personal por parte de Oracle, incluida informaci\00F3n sobre acceso, retenci\00F3n, recti')
||unistr('ficaci\00F3n, supresi\00F3n, seguridad, transferencias internacionales y otros asuntos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100336184984304818)
,p_name=>'WS_STRING'
,p_message_language=>'es'
,p_message_text=>'Cadena'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100351909681304830)
,p_name=>'WS_STR_MUST_BE_SPEC'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar la cadena que desea buscar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100278955817304776)
,p_name=>'WS_TAGS'
,p_message_language=>'es'
,p_message_text=>'Etiquetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100648692851305051)
,p_name=>'WS_TOGGLE_CHECKBOXES'
,p_message_language=>'es'
,p_message_text=>'Conmutar Casillas de Control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100345305531304825)
,p_name=>'WS_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100343562869304823)
,p_name=>'WS_UNASSIGNED_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas no Asignadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100336055008304818)
,p_name=>'WS_UNIQUE_IDENT'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador \00DAnico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100344385068304824)
,p_name=>'WS_URL_TARGET'
,p_message_language=>'es'
,p_message_text=>'Destino de URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100352077032304830)
,p_name=>'WS_URL_TARGET_SPEC'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el destino de URL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100352877536304830)
,p_name=>'WS_USER'
,p_message_language=>'es'
,p_message_text=>'Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100707565859305099)
,p_name=>'WS_USERNAME_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>'Nombre de Usuario demasiado Largo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100663028160305062)
,p_name=>'WS_VALUE_NUMERIC'
,p_message_language=>'es'
,p_message_text=>unistr('%0 debe ser num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100238190537304744)
,p_name=>'WS_VALUE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'(Valor Necesario)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100348447186304827)
,p_name=>'WS_VAL_EXPRESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n de Validaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100352109241304830)
,p_name=>'WS_VAL_NAME_MUST_BE_SPEC'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar el nombre de la validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100346298963304825)
,p_name=>'WS_VAL_NOT_EQ_STR_EXP'
,p_message_language=>'es'
,p_message_text=>unistr('La columna especificada NO es igual al literal de cadena de la expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100352254407304830)
,p_name=>'WS_VAL_SEQ_MUST_BE_SPEC'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar la secuencia de validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100345893329304825)
,p_name=>'WS_VAL_TYPE_CHAR_IN_EXP'
,p_message_language=>'es'
,p_message_text=>unistr('La columna especificada contiene al menos uno de los caracteres de la expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100347541096304826)
,p_name=>'WS_VAL_TYPE_COL_ALPHA'
,p_message_language=>'es'
,p_message_text=>unistr('La columna especificada es alfanum\00E9rica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100346933161304826)
,p_name=>'WS_VAL_TYPE_COL_IN_EXP'
,p_message_language=>'es'
,p_message_text=>unistr('La columna especificada est\00E1 incluida en la expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100347006725304826)
,p_name=>'WS_VAL_TYPE_COL_NOT_0'
,p_message_language=>'es'
,p_message_text=>'La columna especificada NO es cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100346715546304826)
,p_name=>'WS_VAL_TYPE_COL_NOT_EXP'
,p_message_language=>'es'
,p_message_text=>unistr('La columna especificada NO est\00E1 incluida en la expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100347485226304826)
,p_name=>'WS_VAL_TYPE_COL_NOT_NULL_OR_0'
,p_message_language=>'es'
,p_message_text=>'La columna especificada es no nula o cero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100347127678304826)
,p_name=>'WS_VAL_TYPE_COL_NO_SP'
,p_message_language=>'es'
,p_message_text=>'La columna especificada no contiene espacios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100347615268304827)
,p_name=>'WS_VAL_TYPE_COL_NUM'
,p_message_language=>'es'
,p_message_text=>unistr('La columna especificada es num\00E9rica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100348069458304827)
,p_name=>'WS_VAL_TYPE_COL_VAL_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('La columna especificada es una fecha v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100346514082304826)
,p_name=>'WS_VAL_TYPE_EQ_STR_EXP'
,p_message_language=>'es'
,p_message_text=>unistr('La columna especificada es igual que el literal de cadena de la expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100346424417304826)
,p_name=>'WS_VAL_TYPE_NOT_ANY_CHAR_EXP'
,p_message_language=>'es'
,p_message_text=>unistr('La columna especificada no contiene ning\00FAn car\00E1cter de la expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100345761888304825)
,p_name=>'WS_VAL_TYPE_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'La columna especificada es no nula'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100346019986304825)
,p_name=>'WS_VAL_TYPE_ONLY_CHAR_EXP'
,p_message_language=>'es'
,p_message_text=>unistr('La columna especificada contiene s\00F3lo caracteres de la expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100353085634304830)
,p_name=>'WS_VIEW'
,p_message_language=>'es'
,p_message_text=>'Ver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100701127795305094)
,p_name=>'WS_VIEW_DATA_GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Ver Cuadr\00EDcula de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100335356249304817)
,p_name=>'WS_VIEW_FILES'
,p_message_language=>'es'
,p_message_text=>'Ver Archivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100335571693304817)
,p_name=>'WS_VIEW_NOTES'
,p_message_language=>'es'
,p_message_text=>'Ver Notas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100335482568304817)
,p_name=>'WS_VIEW_TAGS'
,p_message_language=>'es'
,p_message_text=>'Ver Etiquetas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100277292694304774)
,p_name=>'WS_WEBSHEET_ALIAS_NOT_UNIQUE'
,p_message_language=>'es'
,p_message_text=>'El alias ya existe. Introduzca un alias diferente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100648437967305051)
,p_name=>'WS_WEBSHEET_PROP'
,p_message_language=>'es'
,p_message_text=>unistr('Propiedades de Hoja de C\00E1lculo Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100257668748304760)
,p_name=>'WS_WELCOME'
,p_message_language=>'es'
,p_message_text=>unistr('Bienvenido a las Hojas de C\00E1lculo Web')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100337922435304819)
,p_name=>'WS_WIDTH'
,p_message_language=>'es'
,p_message_text=>'Ancho'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100277798120304775)
,p_name=>'WS_WITHOUT_FILES'
,p_message_language=>'es'
,p_message_text=>'Sin Archivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100278190244304775)
,p_name=>'WS_WITHOUT_LINKS'
,p_message_language=>'es'
,p_message_text=>'Sin Enlaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100278346401304775)
,p_name=>'WS_WITHOUT_LOCATION'
,p_message_language=>'es'
,p_message_text=>unistr('Sin Ubicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100277978539304775)
,p_name=>'WS_WITHOUT_NOTES'
,p_message_language=>'es'
,p_message_text=>'Sin Notas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100277656358304775)
,p_name=>'WS_WITH_FILES'
,p_message_language=>'es'
,p_message_text=>'Con Archivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100278033302304775)
,p_name=>'WS_WITH_LINKS'
,p_message_language=>'es'
,p_message_text=>'Con Enlaces'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100278239800304775)
,p_name=>'WS_WITH_LOCATION'
,p_message_language=>'es'
,p_message_text=>unistr('Con Ubicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100277809291304775)
,p_name=>'WS_WITH_NOTES'
,p_message_language=>'es'
,p_message_text=>'Con Notas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100029408034304547)
,p_name=>'WWV_CALENDAR_INVALID_QUERY'
,p_message_language=>'es'
,p_message_text=>'<p>La consulta debe contener al menos una columna de registro de hora o fecha. Compruebe la consulta. (%0) </p>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99764740105304340)
,p_name=>'WWV_CRYPT.KEY_ERR'
,p_message_language=>'es'
,p_message_text=>'La clave debe tener 8, 16 o 24 bytes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99533974085304166)
,p_name=>'WWV_DATA_PKG.APP_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n %0 no existe en este espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99534193597304167)
,p_name=>'WWV_DATA_PKG.LOAD_TABLE_FAILED'
,p_message_language=>'es'
,p_message_text=>'Fallo al cargar la tabla %0. Errores registrados en la tabla %1. Esta tabla debe borrarse antes de volver a ejecutarla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99533853743304166)
,p_name=>'WWV_DATA_PKG.NO_FILE_GENERATED'
,p_message_language=>'es'
,p_message_text=>unistr('ning\00FAn archivo generado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99533767351304166)
,p_name=>'WWV_DATA_PKG.ROWS_EXPORTED'
,p_message_language=>'es'
,p_message_text=>'filas exportadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99534299082304167)
,p_name=>'WWV_DATA_PKG.TABLE_EXISTS'
,p_message_language=>'es'
,p_message_text=>'El error de la tabla %0 ya existe. Esta tabla debe borrarse antes de volver a ejecutarla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99534045062304166)
,p_name=>'WWV_DATA_PKG.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>'Todas las columnas incluidas son tipos de datos no soportados.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99511107636304149)
,p_name=>'WWV_DBMS_CLOUD.DATA_PUMP_DIR_PRIVS_MISSING'
,p_message_language=>'es'
,p_message_text=>'El esquema %0 necesita los privilegios READ y WRITE en el directorio DATA_PUMP_DIR.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99515434925304152)
,p_name=>'WWV_DBMS_CLOUD.FILE_TOO_LARGE'
,p_message_language=>'es'
,p_message_text=>unistr('El archivo de almac\00E9n de objetos seleccionado es demasiado grande.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99502505209304143)
,p_name=>'WWV_DBMS_CLOUD.INTERNAL_ERROR'
,p_message_language=>'es'
,p_message_text=>'Se ha producido un error interno al procesar la solicitud de DBMS_CLOUD.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99502669128304143)
,p_name=>'WWV_DBMS_CLOUD.INVALID_CREDENTIAL_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de credencial no v\00E1lido para una referencia de almac\00E9n de objetos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99511005715304149)
,p_name=>'WWV_DBMS_CLOUD.NO_DATA_PUMP_DIR_ACCESS'
,p_message_language=>'es'
,p_message_text=>'El esquema %0 necesita privilegios de acceso para el directorio DATA_PUMP_DIR.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99514080733304151)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD'
,p_message_language=>'es'
,p_message_text=>unistr('El paquete DBMS_CLOUD no est\00E1 disponible en este sistema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99510987793304149)
,p_name=>'WWV_DBMS_CLOUD.NO_DBMS_CLOUD_ACCESS'
,p_message_language=>'es'
,p_message_text=>'El esquema %0 necesita el privilegio EXECUTE en el paquete de DBMS_CLOUD.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99746439676304327)
,p_name=>'WWV_DBMS_SQL.FUNC_BODY_NULL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('error de an\00E1lisis: El cuerpo de la funci\00F3n no debe ser nulo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99746583539304327)
,p_name=>'WWV_DBMS_SQL.PARSE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('error de an\00E1lisis: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99739006020304322)
,p_name=>'WWV_FLOW.APP_NOT_FND_FOOTER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('aplicaci\00F3n=%0 espacio de trabajo actual=%1 espacio de trabajo solicitado=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99738554912304321)
,p_name=>'WWV_FLOW.APP_NOT_FND_INV_COMP_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1014: No se ha encontrado la aplicaci\00F3n. Espacio de trabajo no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99740613714304323)
,p_name=>'WWV_FLOW.APP_PAGE_REQUEST_FOOTER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('aplicaci\00F3n=%0 p\00E1gina=%1 solicitud=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99734674087304318)
,p_name=>'WWV_FLOW.AUTH_SCHEME_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1082: Error al ejecutar el c\00F3digo de esquema de autorizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99735426974304319)
,p_name=>'WWV_FLOW.BRANCH_POINT_NULL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1007: El punto de bifurcaci\00F3n no puede ser nulo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99735597780304319)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1008: Error al realizar la bifurcaci\00F3n a la p\00E1gina %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99495946011304138)
,p_name=>'WWV_FLOW.BRANCH_TO_PAGE_MODE_PAGE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-7746 No se ha podido procesar una rama de una p\00E1gina de cuadro de di\00E1logo a una p\00E1gina de un modo de p\00E1gina diferente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99743858054304325)
,p_name=>'WWV_FLOW.BUTTON_TEMP_FETCH_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al recuperar el identificador de plantilla de bot\00F3n=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99734209101304318)
,p_name=>'WWV_FLOW.CLICK_TO_LOGIN'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Haga clic <a href="%0">aqu\00ED</a> para conectarse</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99734982976304319)
,p_name=>'WWV_FLOW.COMP_EXP_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1030: Error al ejecutar la expresi\00F3n de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99735004504304319)
,p_name=>'WWV_FLOW.COMP_FUNCTION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1004: No se ha podido calcular la funci\00F3n. computation_point=%0 computation_type=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99734856286304319)
,p_name=>'WWV_FLOW.COMP_QUERY_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1003: Error al ejecutar la consulta de c\00E1lculo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99734725393304318)
,p_name=>'WWV_FLOW.CREATE_ITEM_ERR'
,p_message_language=>'es'
,p_message_text=>'ERR-1001: Error inesperado al crear el elemento: FSP_PROCESS_STATE_%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99734424333304318)
,p_name=>'WWV_FLOW.DEEPLINKING_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1001: Error inesperado en la sesi\00F3n make_deeplinking_item=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99736062552304319)
,p_name=>'WWV_FLOW.DET_COMPANY_FOOTER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Se esperaba que la cookie p_company o wwv_flow_company contuviera el identificador de grupo de seguridad del propietario de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99740357188304323)
,p_name=>'WWV_FLOW.DET_COMPANY_ON_ACCEPT_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-7621: No se ha podido determinar el espacio de trabajo para la aplicaci\00F3n (%0) en aceptaci\00F3n de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99740429115304323)
,p_name=>'WWV_FLOW.DET_COMP_FOR_FLOW_FOOTER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Se esperaba que la cookie p_company o wwv_flow_company contuviera el identificador de grupo de seguridad del propietario de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99735894867304319)
,p_name=>'WWV_FLOW.EVAL_TYPE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1011: Tipo de evaluaci\00F3n no v\00E1lido: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99743702981304325)
,p_name=>'WWV_FLOW.FETCH_VALUE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de la aplicaci\00F3n en fetch_value.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99734566108304318)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR'
,p_message_language=>'es'
,p_message_text=>'ERR-1902: El identificador de elemento es nulo en la rutina find_item_name.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99735312775304319)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_BOOL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1021: No se ha podido ejecutar la validaci\00F3n "cuerpo de la funci\00F3n que devuelve valor booleano".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99735268023304319)
,p_name=>'WWV_FLOW.FUNC_BODY_RET_TEXT_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1024: No se ha podido ejecutar la validaci\00F3n "cuerpo de la funci\00F3n que devuelve texto".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99735934003304319)
,p_name=>'WWV_FLOW.G_FLOW_ID_ERR'
,p_message_language=>'es'
,p_message_text=>'ERR-1812: Error inesperado al asignar G_FLOW_ID (%0).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99740575619304323)
,p_name=>'WWV_FLOW.INSUFFICENT_INFO_ON_REQ_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-9988: Informaci\00F3n insuficiente proporcionada para esta solicitud. Probablemente no ha esperado a que la p\00E1gina anterior se cargue por completo. Para continuar, haga clic en los botones Atr\00E1s y Recargar del explorador o navegue a la p\00E1gina inicial')
||' de las aplicaciones.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99736438855304320)
,p_name=>'WWV_FLOW.LOGIN_SERVER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1555: No est\00E1 conectado a Oracle Login Server. No se ha identificado ning\00FAn usuario p\00FAblico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99740012509304322)
,p_name=>'WWV_FLOW.LOGOUT'
,p_message_language=>'es'
,p_message_text=>'Desconectar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99734147250304318)
,p_name=>'WWV_FLOW.NOT_LOGGED_IN'
,p_message_language=>'es'
,p_message_text=>unistr('No est\00E1 conectado. Falta la cookie necesaria para la autenticaci\00F3n o no es v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99741085215304323)
,p_name=>'WWV_FLOW.NO_PAGE_TO_BRANCH_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1777: La p\00E1gina %0 no ha proporcionado ninguna p\00E1gina en la que realizar la bifurcaci\00F3n. Informe de este error al administrador de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99740147671304322)
,p_name=>'WWV_FLOW.NO_PRIV_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1013: No hay ning\00FAn privilegio para la operaci\00F3n que el usuario %0 ha intentado realizar; se necesita el rol %1. P\00F3ngase en contacto con el administrador de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99565914004304194)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.CHECKSUM_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina se puede solicitar con argumentos si se transfiere un total de control al procedimiento de presentaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99566180438304194)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.DIRECT_BRANCH_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo se puede acceder a la p\00E1gina utilizando una bifurcaci\00F3n de tipo "Bifurcar a P\00E1gina", desde otra p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99566006920304194)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.NO_ARGS_ALLOWED '
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo se puede acceder a la p\00E1gina sin argumentos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99566369498304194)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_ARGS_ALLOWED'
,p_message_language=>'es'
,p_message_text=>unistr('Se han transferido argumentos a una p\00E1gina que no acepta argumentos (solicitud, borrar cach\00E9, valores de elemento).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99565866759304194)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.UNPROTECTED'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina no est\00E1 protegida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99739965756304322)
,p_name=>'WWV_FLOW.REQUIRED_ROLE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El rol necesario no est\00E1 activado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99741188963304323)
,p_name=>'WWV_FLOW.RESTART_APP'
,p_message_language=>'es'
,p_message_text=>unistr('<a href="f?p=%0">Reiniciar Aplicaci\00F3n</a>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99734388969304318)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_ERR'
,p_message_language=>'es'
,p_message_text=>'ERR-1001: Error inesperado en la rutina para guardar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99735771404304319)
,p_name=>'WWV_FLOW.SQL_EXP_HEADING_TEXT_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1910: Error al evaluar la expresi\00F3n SQL en el texto de cabecera.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99766952184304342)
,p_name=>'WWV_FLOW.UNABLE_HOME_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se le ha podido dirigir a la p\00E1gina inicial.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99740256554304322)
,p_name=>'WWV_FLOW.UNABLE_RESOLVE_ALIAS_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1512: No se ha podido resolver el alias de p\00E1gina (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99744032172304325)
,p_name=>'WWV_FLOW.UNABLE_SET_TIMED_STAT_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido definir timed_statistics: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99743956295304325)
,p_name=>'WWV_FLOW.UNABLE_TO_TRACE_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido rastrear: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99737814921304321)
,p_name=>'WWV_FLOW.UNSUPP_AUTH_SCHEME_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1444: Esquema de autenticaci\00F3n no soportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99735191332304319)
,p_name=>'WWV_FLOW.VALIDATION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1006: Error en la rutina de validaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99746684954304327)
,p_name=>'WWV_FLOW_ADMINISTRATION.DEPRECATED'
,p_message_language=>'es'
,p_message_text=>'En desuso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99774859908304347)
,p_name=>'WWV_FLOW_ADMIN_API.DELETE_DEV_ROLE_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al suprimir el rol del desarrollador. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99774757649304347)
,p_name=>'WWV_FLOW_ADMIN_API.FETCH_FND_USER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido recuperar la informaci\00F3n de b\00FAsqueda de usuario. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99974894829304505)
,p_name=>'WWV_FLOW_ADMIN_API.NO_DEV_PRIV'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: El usuario %0 no tiene ning\00FAn privilegio de desarrollador')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99641996922304250)
,p_name=>'WWV_FLOW_API.COMPATIBLE'
,p_message_language=>'es'
,p_message_text=>unistr('COMPATIBLE (Debe ejecutar esta importaci\00F3n sin problemas.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100520167416304956)
,p_name=>'WWV_FLOW_API.CREDENTIAL_WARNING'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ADVERTENCIA para la credencial "%0" (ID est\00E1tico):'),
'',
unistr('- Los archivos de exportaci\00F3n de Application Express no contienen informaci\00F3n de credenciales.'),
'- Utilice el procedimiento APEX_CREDENTIAL.SET_PERSISTENT_CREDENTIAL para definir las',
unistr('- credenciales despu\00E9s de la importaci\00F3n de la aplicaci\00F3n. Se hace referencia'),
unistr('- a esta credencial con su ID est\00E1tico "%0"')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99637422269304247)
,p_name=>'WWV_FLOW_API.CURRENT_FLOWS_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Versi\00F3n Actual:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100109931958304609)
,p_name=>'WWV_FLOW_API.DELETE_APP_IN_DIFFERENT_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede suprimir la aplicaci\00F3n %0, est\00E1 instalada en un espacio de trabajo diferente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99641565877304250)
,p_name=>'WWV_FLOW_API.ERR_AUTH_SCHEME_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el nombre de esquema de autenticaci\00F3n=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99640123728304249)
,p_name=>'WWV_FLOW_API.ERR_BRANCH_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el identificador de bifurcaci\00F3n="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99641308024304250)
,p_name=>'WWV_FLOW_API.ERR_BUG_CREATE'
,p_message_language=>'es'
,p_message_text=>'Error al crear el identificador de bug="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99638658526304248)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el nombre de opci\00F3n de creaci\00F3n=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99638775032304248)
,p_name=>'WWV_FLOW_API.ERR_BUILD_OPTION_SET'
,p_message_language=>'es'
,p_message_text=>unistr('Error al definir el identificador de opci\00F3n de creaci\00F3n="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99640043616304249)
,p_name=>'WWV_FLOW_API.ERR_BUTTON_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el nombre de bot\00F3n="%0" identificador="%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99995484747304521)
,p_name=>'WWV_FLOW_API.ERR_DA_ACTION_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el nombre de la subacci\00F3n de la acci\00F3n din\00E1mica="%0" identificador="%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99995324989304521)
,p_name=>'WWV_FLOW_API.ERR_DA_EVENT_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la p\00E1gina de acci\00F3n din\00E1mica="%0" nombre="%1" identificador="%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99679599907304278)
,p_name=>'WWV_FLOW_API.ERR_DUP_PAGE_ITEM_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de error=%0 elemento="%1" identificador="%2" tiene el mismo nombre que el elemento de nivel de aplicaci\00F3n existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99639256956304248)
,p_name=>'WWV_FLOW_API.ERR_FLOW_COMPUTATION_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el elemento de c\00E1lculo de aplicaci\00F3n="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99639129108304248)
,p_name=>'WWV_FLOW_API.ERR_FLOW_ITEM_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el identificador de elemento de aplicaci\00F3n="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99596401746304217)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_CREATE'
,p_message_language=>'es'
,p_message_text=>'Error al crear el identificador de atributo del plugin="%0"	'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100009309405304532)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_ATTR_VALUE_CREATE'
,p_message_language=>'es'
,p_message_text=>'Error al crear el identificador del valor de atributo del plugin="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99596316377304216)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_CREATE'
,p_message_language=>'es'
,p_message_text=>'Error al crear el identificador del plugin="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99652750429304258)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PLUGIN_EVENT_CREATE'
,p_message_language=>'es'
,p_message_text=>'Error al crear el identificador de evento de plugin="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99638936730304248)
,p_name=>'WWV_FLOW_API.ERR_FLOW_PROCESS_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el identificador de proceso de la aplicaci\00F3n="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100684135197305082)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPTION_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el ID de opci\00F3n de plantilla de aplicaci\00F3n="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100684054453305081)
,p_name=>'WWV_FLOW_API.ERR_FLOW_TEMPLATE_OPT_GROUP_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el ID de grupo de opciones de plantilla de aplicaci\00F3n="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99641135015304249)
,p_name=>'WWV_FLOW_API.ERR_FORM_ADDED_TO_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha agregado una pantalla a la p\00E1gina existente %0 .')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99616111296304231)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido importar el identificador de atributos de instalaci\00F3n de objetos de base de datos="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99616273033304231)
,p_name=>'WWV_FLOW_API.ERR_INSTALL_SCRIPT_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el identificador de script de instalaci\00F3n="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99640841339304249)
,p_name=>'WWV_FLOW_API.ERR_INVALID_REPORT_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de informe no v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99640675366304249)
,p_name=>'WWV_FLOW_API.ERR_LANG_MAP_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la asignaci\00F3n de traducci\00F3n de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99538424740304170)
,p_name=>'WWV_FLOW_API.ERR_LOV_COL_CREATE'
,p_message_language=>'es'
,p_message_text=>'Error al crear el identificador de columna de la lista de valores="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99639642356304248)
,p_name=>'WWV_FLOW_API.ERR_LOV_CREATE'
,p_message_language=>'es'
,p_message_text=>'Error al crear el identificador de lista de valores="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99638847683304248)
,p_name=>'WWV_FLOW_API.ERR_NAV_BAR_ITEM_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el identificador de elemento de barra de navegaci\00F3n="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99640392748304249)
,p_name=>'WWV_FLOW_API.ERR_PAGE_COMPUTATION_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el c\00E1lculo de p\00E1ginas p\00E1gina=%0 elemento=%1 identificador="%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99639773817304248)
,p_name=>'WWV_FLOW_API.ERR_PAGE_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el nombre de p\00E1gina="%0" identificador="%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100049588740304562)
,p_name=>'WWV_FLOW_API.ERR_PAGE_GROUP'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el grupo de p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99641007750304249)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HAS_BUTTONS'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina %0 ya tiene botones.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99639883395304248)
,p_name=>'WWV_FLOW_API.ERR_PAGE_HELP_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el texto de ayuda de la p\00E1gina %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99640239815304249)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ITEM_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina de error=%0 elemento="%1" identificador="%2"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99639972790304249)
,p_name=>'WWV_FLOW_API.ERR_PAGE_NAME_UPD'
,p_message_language=>'es'
,p_message_text=>unistr('Error al actualizar el nombre de p\00E1gina="%0" identificador="%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99640702683304249)
,p_name=>'WWV_FLOW_API.ERR_PAGE_ON_TABLE_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina en la tabla "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99640522809304249)
,p_name=>'WWV_FLOW_API.ERR_PAGE_PROCESS_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el proceso de p\00E1gina p\00E1gina=%0 nombre=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99640408243304249)
,p_name=>'WWV_FLOW_API.ERR_PAGE_VALIDATION_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la validaci\00F3n de p\00E1gina p\00E1gina=%0 nombre=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99639595957304248)
,p_name=>'WWV_FLOW_API.ERR_PARENT_TAB_CREATE'
,p_message_language=>'es'
,p_message_text=>'Error al crear el identificador de separador principal="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99639001682304248)
,p_name=>'WWV_FLOW_API.ERR_PROCESS_SQL_SET'
,p_message_language=>'es'
,p_message_text=>'Error al definir el identificador SQL de proceso="%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99640905768304249)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('Existe la p\00E1gina de informe %0, por lo que se ha agregado la regi\00F3n de informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99641206914304250)
,p_name=>'WWV_FLOW_API.ERR_REPORT_PAGE_EXISTS2'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha creado la p\00E1gina %0 porque ya existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99641439401304250)
,p_name=>'WWV_FLOW_API.ERR_SHORTCUT_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el identificador de m\00E9todo abreviado="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99639337393304248)
,p_name=>'WWV_FLOW_API.ERR_STD_TAB_CREATE'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear el identificador de separador est\00E1ndar="%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99639445158304248)
,p_name=>'WWV_FLOW_API.ERR_TABSET_RENAME'
,p_message_language=>'es'
,p_message_text=>'Error al cambiar el nombre del juego de separadores %1 a %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99638588945304247)
,p_name=>'WWV_FLOW_API.ERR_TEMPL_CREATE'
,p_message_language=>'es'
,p_message_text=>'Error al crear el nombre de plantilla=%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99637364620304247)
,p_name=>'WWV_FLOW_API.FLOWS_API_LAST_EXTENDED'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima API Ampliada:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99641860794304250)
,p_name=>'WWV_FLOW_API.FLOWS_API_RUNTIME_INCOMPATIBLE'
,p_message_language=>'es'
,p_message_text=>unistr('Este archivo de exportaci\00F3n no es compatible con la versi\00F3n de Application Express a la que est\00E1 intentando importar el archivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99638336565304247)
,p_name=>'WWV_FLOW_API.FLOW_ID_MISSING'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha llamado al procedimiento %0 sin un valor para p_id. Se debe proporcionar el identificador de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99497681260304139)
,p_name=>'WWV_FLOW_API.FLOW_ID_OUT_OF_RANGE'
,p_message_language=>'es'
,p_message_text=>unistr('El ID de aplicaci\00F3n "%0" no est\00E1 en el rango permitido (%1 - %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100109491434304608)
,p_name=>'WWV_FLOW_API.FLOW_ID_RANGE_RESERVED'
,p_message_language=>'es'
,p_message_text=>unistr('El ID de aplicaci\00F3n "%0" no se puede utilizar, el rango (%1 - %2) est\00E1 reservado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99641714324304250)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED'
,p_message_language=>'es'
,p_message_text=>unistr('El identificador de aplicaci\00F3n %0 est\00E1 reservado para Oracle Corporation ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99497733230304139)
,p_name=>'WWV_FLOW_API.FLOW_ID_RESERVED_FOR_OTHER_WORKSPACE'
,p_message_language=>'es'
,p_message_text=>unistr('El ID de aplicaci\00F3n "%0" est\00E1 reservado para otro espacio de trabajo y no se puede utilizar aqu\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99638465776304247)
,p_name=>'WWV_FLOW_API.FLOW_NOT_DELETED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha suprimido la aplicaci\00F3n %0. No se intentar\00E1 realizar la importaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99637506420304247)
,p_name=>'WWV_FLOW_API.IMPORT_COMPATIBLE_WITH_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Esta importaci\00F3n es compatible con la versi\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100067986572304576)
,p_name=>'WWV_FLOW_API.IMPORT_SCRIPT_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido importar el script. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99638061887304247)
,p_name=>'WWV_FLOW_API.INVALID_CREDENTIALS'
,p_message_language=>'es'
,p_message_text=>unistr('Combinaci\00F3n no v\00E1lida de usuario, contrase\00F1a o espacio de trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99637682628304247)
,p_name=>'WWV_FLOW_API.MISSING_EXPORT_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('La importaci\00F3n de la aplicaci\00F3n no ha proporcionado una versi\00F3n de la exportaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100520082027304956)
,p_name=>'WWV_FLOW_API.MUST_USE_APEX_APP_INSTALL'
,p_message_language=>'es'
,p_message_text=>unistr('No se han proporcionado valores para el servidor remoto con el ID est\00E1tico "%0". Utilice APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER antes de instalar la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100067856792304576)
,p_name=>'WWV_FLOW_API.NEW_SCRIPT_FILE'
,p_message_language=>'es'
,p_message_text=>'nuevo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99642085816304250)
,p_name=>'WWV_FLOW_API.NOT_COMPATIBLE'
,p_message_language=>'es'
,p_message_text=>unistr('NO COMPATIBLE (Puede que la exportaci\00F3n contenga llamadas no soportadas por la versi\00F3n de %0.)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100520488954304956)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_1'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ADVERTENCIA para el servidor remoto "%0" (ID est\00E1tico).'),
'',
'- Los atributos para este servidor remoto se han definido con APEX_APPLICATION_INSTALL.',
unistr('- Tenga en cuenta que otras aplicaciones tambi\00E9n utilizan este objeto de servidor remoto.'),
'',
'Por lo tanto, se actualizan los atributos del servidor remoto del espacio de trabajo.',
'- URL base:      %1',
'- Host de HTTPS:    %2',
'- Zona horaria de ORDS: %3'))
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100520339493304956)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_2'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ADVERTENCIA para el servidor remoto "%0" (ID est\00E1tico).'),
'',
'- El atributo PROMPT_ON_INSTALL se ha definido como YES.',
'- No se han proporcionado atributos con APEX_APPLICATION_INSTALL.',
'',
'Por lo tanto, los ajustes del servidor remoto del espacio de trabajo permanecen sin cambios.',
'- URL base:      %1',
'- Host de HTTPS:    %2',
'- Zona horaria de ORDS: %3',
'',
'Utilice APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER para cambiar los atributos.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100520266778304956)
,p_name=>'WWV_FLOW_API.REMOTE_SERVER_WARNING_3'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('ADVERTENCIA para el servidor remoto "%0" (ID est\00E1tico).'),
'',
'- El atributo PROMPT_ON_INSTALL se ha definido como NO.',
unistr('- Los ajustes del archivo de importaci\00F3n de la aplicaci\00F3n son diferentes a los atributos existentes.'),
unistr('- Otras aplicaciones tambi\00E9n utilizan este servidor remoto en este espacio de trabajo.'),
'',
'Por lo tanto, los ajustes del servidor remoto del espacio de trabajo permanecen sin cambios.',
'- URL base:      %1',
'- Host de HTTPS:    %2',
'- Zona horaria de ORDS: %3',
'',
'Utilice APEX_APPLICATION_INSTALL.SET_REMOTE_SERVER para cambiar los atributos.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100067759001304576)
,p_name=>'WWV_FLOW_API.REPLACE_SCRIPT_FILE'
,p_message_language=>'es'
,p_message_text=>'sustituir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100305981572304796)
,p_name=>'WWV_FLOW_API.SAME_SOURCE_IDENTIFIER'
,p_message_language=>'es'
,p_message_text=>'No puede importar comentarios al mismo sistema.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100068064888304576)
,p_name=>'WWV_FLOW_API.SCRIPT_EXCEEDS_MAX'
,p_message_language=>'es'
,p_message_text=>unistr('El tama\00F1o del script de %0 bytes excede el tama\00F1o m\00E1ximo permitido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99641622182304250)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET'
,p_message_language=>'es'
,p_message_text=>'Se debe definir la variable de paquete g_security_group_id.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99638239464304247)
,p_name=>'WWV_FLOW_API.SGID_NOT_SET_IMPORT'
,p_message_language=>'es'
,p_message_text=>unistr('El paquete variable g_security_group_id debe estar definido para importar una aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99637883880304247)
,p_name=>'WWV_FLOW_API.UNKOWN_API_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido establecer la \00FAltima versi\00F3n de API del motor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99637716731304247)
,p_name=>'WWV_FLOW_API.UNKOWN_ENGINE_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido establecer la versi\00F3n del motor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99637926692304247)
,p_name=>'WWV_FLOW_API.UPGRADE_NEEDED'
,p_message_language=>'es'
,p_message_text=>unistr('Debe realizar una actualizaci\00F3n para importar esta exportaci\00F3n de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100305855174304795)
,p_name=>'WWV_FLOW_API.WRONG_DEPLOYMENT_SYSTEM'
,p_message_language=>'es'
,p_message_text=>'No se han exportado comentarios para este sistema de despliegue.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99510257591304149)
,p_name=>'WWV_FLOW_AUTOMATION.CANNOT_COPY_WSM_AUTOMATION'
,p_message_language=>'es'
,p_message_text=>unistr('Las automatizaciones que hacen referencia a los or\00EDgenes de datos de REST no se pueden copiar de otra aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99508632376304147)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.NEW_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99686713374304283)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.PLSQL_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se necesita el cuerpo de la funci\00F3n PL/SQL que devuelve una consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99686670974304283)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.QUERY_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'La consulta SQL es obligatoria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99686839182304283)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.REMOTE_SERVER_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Se necesita el servicio de SQL activado para REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99686527966304283)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.TABLE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Se necesita el nombre de la tabla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99686921431304283)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WEB_SRC_MODULE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Se necesita un origen de datos de REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99687016867304283)
,p_name=>'WWV_FLOW_AUTOMATION_DEV.WHERE_ORDERBY_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se necesita la cl\00E1usula WHERE u ORDER BY.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99742140673304324)
,p_name=>'WWV_FLOW_BUILDER.APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99758435733304336)
,p_name=>'WWV_FLOW_BUILDER.NO_FLOW_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha seleccionado ninguna aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99742442497304324)
,p_name=>'WWV_FLOW_BUILDER.NO_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('<span class="tiny">No se ha encontrado ninguna p\00E1gina.</font>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99742266985304324)
,p_name=>'WWV_FLOW_BUILDER.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99742513820304324)
,p_name=>'WWV_FLOW_BUILDER.PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('%0 <font size=-2>P\00E1ginas</span>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99928728676304470)
,p_name=>'WWV_FLOW_BUILDER.PAGE_COUNT'
,p_message_language=>'es'
,p_message_text=>unistr('recuento de p\00E1ginas:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99928891413304470)
,p_name=>'WWV_FLOW_BUILDER.PAGE_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('lista de p\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99742311849304324)
,p_name=>'WWV_FLOW_BUILDER.PLSQL_LINES_SOURCE'
,p_message_language=>'es'
,p_message_text=>unistr('PL/SQL %0 %1 contiene %2 l\00EDneas de c\00F3digo fuente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100177416851304699)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.CODE_COMPLETION_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('La finalizaci\00F3n de c\00F3digo no est\00E1 soportada para SQL remoto.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100176739309304698)
,p_name=>'WWV_FLOW_BUILDER.REMOTESQL.QUERY_BUILDER_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('El generador de consultas no est\00E1 soportado para SQL remoto.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99774919124304347)
,p_name=>'WWV_FLOW_BUILDER.UPDATABLE_REPORT_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de an\00E1lisis de informe actualizable: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100709834997305101)
,p_name=>'WWV_FLOW_BUTTON.REDIRECT_TO_PAGE_MODE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido redireccionar desde una p\00E1gina de cuadro de di\00E1logo a una p\00E1gina normal.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99746809202304327)
,p_name=>'WWV_FLOW_CACHE.OBSOLETE'
,p_message_language=>'es'
,p_message_text=>'obsoleto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99746755011304327)
,p_name=>'WWV_FLOW_CACHE.PURGE_DUP_SESSIONS'
,p_message_language=>'es'
,p_message_text=>'Se han depurado %0 sesiones duplicadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99715106674304304)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_CHG_ONLY_YOURS'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo puede cambiar su propia contrase\00F1a.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99715341283304304)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error inesperado al procesar la solicitud de cambio de contrase\00F1a: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99714883904304304)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NOT_SUPPLIED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe proporcionar la contrase\00F1a y la confirmaci\00F3n de contrase\00F1a.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99714963073304304)
,p_name=>'WWV_FLOW_CHANGE_PASSWORD.PSSWD_NO_MATCH'
,p_message_language=>'es'
,p_message_text=>unistr('Las contrase\00F1as no coinciden. Vuelva a intentarlo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99715965322304305)
,p_name=>'WWV_FLOW_CHECK.ERR_ORCL'
,p_message_language=>'es'
,p_message_text=>'Error de Oracle: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99715694911304304)
,p_name=>'WWV_FLOW_CHECK.ERR_PROC_PLSQL'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1025: Error al procesar la expresi\00F3n PLSQL.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99606504458304224)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero del atributo de miembro especificado %0 no es v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99747285326304327)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_EXISTS_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de existencia/no existencia no v\00E1lida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99747092231304327)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_FUNC_BODY_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de cuerpo de la funci\00F3n no v\00E1lida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99746978411304327)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_PLSQL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de expresi\00F3n PL/SQL no v\00E1lida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99747128433304327)
,p_name=>'WWV_FLOW_CONDITIONS.INVALID_SQL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n de expresi\00F3n SQL no v\00E1lida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99761333107304338)
,p_name=>'WWV_FLOW_COPY.EXECUTION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error durante la ejecuci\00F3n de wwv_flow_copy: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99496332556304138)
,p_name=>'WWV_FLOW_COPY.INVALID_TRANSLATED_APPLICATION_ID'
,p_message_language=>'es'
,p_message_text=>unistr('El ID de aplicaci\00F3n convertido no es v\00E1lido. El ID de aplicaci\00F3n lo est\00E1 utilizando una aplicaci\00F3n existente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99761235239304338)
,p_name=>'WWV_FLOW_COPY.NO_SGID_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El identificador de grupo de seguridad (identidad de espacio de trabajo) no est\00E1 definido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100048942615304561)
,p_name=>'WWV_FLOW_COPY_METADATA.COMPATIBILITY_MODE_210200'
,p_message_language=>'es'
,p_message_text=>unistr('El modo de compatibilidad de la aplicaci\00F3n "%0" debe tener al menos la versi\00F3n 21.2 para refrescar el tema. El modo de compatibilidad se puede cambiar en Definici\00F3n de aplicaci\00F3n, en Propiedades.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100745696756305128)
,p_name=>'WWV_FLOW_COPY_METADATA.INCOMPATIBLE_THEME'
,p_message_language=>'es'
,p_message_text=>'El tema actual no es compatible con el tema maestro seleccionado, los identificadores de tema no coinciden.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100174377841304696)
,p_name=>'WWV_FLOW_COPY_METADATA.PARENT_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha podido refrescar la plantilla, no se ha encontrado la plantilla principal.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99614528366304230)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_AUTH_SETUP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('No se ha podido publicar el esquema de autenticaci\00F3n. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99613922348304229)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_BUTTON_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('No se ha podido publicar la plantilla de bot\00F3n. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99768172402304343)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_CAL_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'No se ha podido publicar la plantilla de calendario. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99613750170304229)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_FIELD_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido publicar la plantilla de campo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99614675940304230)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_ITEM_HELP'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'No se ha podido publicar la ayuda de elemento. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99613526904304229)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LIST_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido publicar la plantilla de lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99614487961304230)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_LOV'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'No se ha podido publicar la lista de valores. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99614080747304230)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_MENU_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('No se ha podido publicar la plantilla de ruta de navegaci\00F3n. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99614339745304230)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_NAVBAR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido publicar la barra de navegaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99613382102304229)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_PAGE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido publicar la plantilla de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99613809801304229)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido publicar la plantilla de lista de valores emergente. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99613485785304229)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REGION_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido publicar la plantilla de regi\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99613651548304229)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_REPORT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido publicar la plantilla de informe. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99614127406304230)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SECURITY_SCHEME'
,p_message_language=>'es'
,p_message_text=>'No se ha podido publicar el esquema de seguridad. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99614291218304230)
,p_name=>'WWV_FLOW_COPY_METADATA.PUBLISH_SHORTCUT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('No se ha podido publicar el m\00E9todo abreviado. %0'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99611727275304228)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_AUTH_SETUP_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido eliminar el identificador de referencia del esquema de autenticaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99610678017304227)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_BUTTON_TEMPLATE_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido eliminar el identificador de referencia de la plantilla de bot\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99768060005304343)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_CAL_TEMPLATE_REFERENCE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'No se ha podido suscribir a la plantilla de calendario. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99609979499304227)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_FIELD_REFERENCE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido eliminar el identificador de referencia del campo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99611873352304228)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_ITEM_HELP_REFERENCE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido eliminar el identificador de referencia de la ayuda de elemento. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99609784987304226)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LIST_REFERENCE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido eliminar el identificador de referencia de la lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99610303586304227)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_LOV_REFERENCE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido eliminar el identificador de referencia de la lista de valores. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99610591867304227)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_MENU_TEMPLATE_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido eliminar el identificador de referencia de la plantilla de ruta de navegaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99610256266304227)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_NAVBAR_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido eliminar el identificador de referencia de la barra de navegaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99609520486304226)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_PAGE_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido eliminar el identificador de referencia de la p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99610442628304227)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_POPUP_LOV_TEMPLATE_REFERENCE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido eliminar el identificador de referencia de la plantilla de lista de valores. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99609601833304226)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REGION_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido eliminar el identificador de referencia de la regi\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99609893999304227)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_REPORT_REFERENCE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido eliminar el identificador de referencia del informe. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99610049364304227)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SECURITY_SCHEME_REFERENCE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido eliminar el identificador de referencia del esquema de seguridad. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99610135116304227)
,p_name=>'WWV_FLOW_COPY_METADATA.REMOVE_SHORTCUT_REFERENCE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido eliminar el identificador de referencia del m\00E9todo abreviado. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99613190228304229)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_AUTH_SETUP'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido suscribir al esquema de autenticaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99612684630304229)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_BUTTON_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido suscribir a la plantilla de bot\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100705473122305097)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_CAL_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'No se ha podido suscribir a la plantilla de calendario. %0',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99612369769304228)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_FIELD_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido suscribir a la plantilla de campo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99613286713304229)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_ITEM_HELP'
,p_message_language=>'es'
,p_message_text=>'No se ha podido suscribir a la ayuda de elemento. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99612134836304228)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LIST_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido suscribir a la plantilla de lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99613081255304229)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_LOV'
,p_message_language=>'es'
,p_message_text=>'No se ha podido suscribir a la lista de valores. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99612590016304228)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_MENU_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido suscribir a la plantilla de ruta de navegaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99612939943304229)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_NAVBAR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido suscribir a la barra de navegaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99611960112304228)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_PAGE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido suscribir a la plantilla de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99612495296304228)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_POPUP_LOV_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido suscribir a la plantilla de lista de valores emergente. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99612075115304228)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REGION_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido suscribir a la plantilla de regi\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99612252482304228)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_REPORT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido suscribir a la plantilla de informe. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99612712289304229)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SECURITY_SCHEME'
,p_message_language=>'es'
,p_message_text=>'No se ha podido suscribir al esquema de seguridad. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99612819456304229)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_SHORTCUT'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido suscribir al m\00E9todo abreviado. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100684594380305082)
,p_name=>'WWV_FLOW_COPY_METADATA.SUBSCRIBE_THEME_OPTIONS'
,p_message_language=>'es'
,p_message_text=>'No se ha podido suscribir a las opciones de tema. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99775489988304348)
,p_name=>'WWV_FLOW_COPY_PAGE.EXECUTION_PAGE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error durante la ejecuci\00F3n de wwv_flow_copy_page: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99761511361304338)
,p_name=>'WWV_FLOW_COPY_PAGE_ITEM.EXECUTION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error durante la ejecuci\00F3n de wwv_flow_copy_page_item: %0 >> %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99634543316304245)
,p_name=>'WWV_FLOW_COPY_UTIL.OBJ_NOT_FOUND_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado %0 (%1) para copiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99961891436304496)
,p_name=>'WWV_FLOW_COPY_UTIL.SHORTCUT_NAME_UNAVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('ya existe un m\00E9todo abreviado con el nombre %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99761947838304338)
,p_name=>'WWV_FLOW_COPY_UTIL.UNABLE_TO_FIND_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el acceso directo (%0) para copiar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99762916685304339)
,p_name=>'WWV_FLOW_CREATE_FLOW.CREATE_RPT_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (crear plantillas de informe): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99763594582304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COMPUTE_TAB_TARGET_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (calcular destinos de separador): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99766884308304342)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHENTICATION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar esquemas de autenticaci\00F3n): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99766732743304342)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_AUTHORIZATION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar esquemas de autorizaci\00F3n): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99764382891304340)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_BUTTON_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar plantillas de bot\00F3n): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99763850160304340)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_FIELD_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar plantilla de campo): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99764184918304340)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LIST_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar plantillas de lista): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99764511195304340)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_LOV_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar lista de valores): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99764231289304340)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_MENU_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar plantillas de ruta de navegaci\00F3n): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99764410222304340)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_NAVBAR_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar barra de navegaci\00F3n): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99763740090304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_PAGE_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar plantilla de p\00E1gina): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99764044053304340)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REGION_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar plantillas de regi\00F3n): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99763997131304340)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_REPORT_TEMPLATES_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar plantillas de informe): %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99764622227304340)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.COPY_SECURITY_SCHEME_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (copiar esquema de seguridad): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99762863793304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_FIELD_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (crear plantilla de campo): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99763196831304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_LIST_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (crear plantillas de lista): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99763257085304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_MENU_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (crear plantillas de rutas de navegaci\00F3n): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99762689328304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PAGE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (crear p\00E1gina): %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99763686855304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PARENT_TABS_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (crear separadores principales): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99762777867304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_PG_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (crear plantilla de p\00E1gina): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99763304498304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_POPUP_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (crear plantilla de lista de valores emergente): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99763090800304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_REGION_TEMPLATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (crear plantillas de regi\00F3n): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99763442578304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.CREATE_STANDARD_TABS_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al crear la aplicaci\00F3n (crear separadores est\00E1ndar): %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99762502439304339)
,p_name=>'WWV_FLOW_CREATE_FLOW_API.VERIFY_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de verificaci\00F3n de %0: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99961663307304495)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.ADD_ROWS'
,p_message_language=>'es'
,p_message_text=>'Agregar Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99961525129304495)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRD'
,p_message_language=>'es'
,p_message_text=>'Aplicar MRD'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99961463394304495)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.APPLY_MRU'
,p_message_language=>'es'
,p_message_text=>'Aplicar MRU'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99948713591304486)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE'
,p_message_language=>'es'
,p_message_text=>'Crear %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100026463896304544)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_FORM_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de pantalla. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100052986123304564)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_GLOBAL_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina global.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100537343036304968)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_IG'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de cuadr\00EDcula interactiva. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100026696519304545)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_PAGES'
,p_message_language=>'es'
,p_message_text=>unistr('Error de creaci\00F3n de p\00E1ginas. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100026526620304545)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.CREATE_TABULAR_FORM'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de pantalla tabular. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100026758296304545)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.FETCH_ROW'
,p_message_language=>'es'
,p_message_text=>'Recuperar Fila de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100070106162304578)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.GET_USERNAME_COOKIE'
,p_message_language=>'es'
,p_message_text=>'Obtener Cookie de Nombre de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100166141685304690)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.MENUBAR'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100026081005304544)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.NAVIGATION'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina del Men\00FA %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100026835028304545)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.PROCESS_ROW'
,p_message_language=>'es'
,p_message_text=>'Procesar Fila de %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100115143172304613)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RELEASE'
,p_message_language=>'es'
,p_message_text=>unistr('versi\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99954309976304490)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_HIDDEN_ITEM'
,p_message_language=>'es'
,p_message_text=>'Restablecer Elementos Ocultos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99947822354304485)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RESET_RPT_SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer B\00FAsqueda de Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100042636871304557)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RPT_MAX_ROW'
,p_message_language=>'es'
,p_message_text=>unistr('Fila de Informe por P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100038715801304554)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.RUNNING_SCRIPT_X'
,p_message_language=>'es'
,p_message_text=>unistr('Script en Ejecuci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100070055530304578)
,p_name=>'WWV_FLOW_CREATE_MODEL_APP.SET_USERNAME_COOKIE'
,p_message_language=>'es'
,p_message_text=>'Definir Cookie de Nombre de Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99955529809304491)
,p_name=>'WWV_FLOW_CREDENTIAL.INVALID_CONTEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Este procedimiento se debe llamar desde una sesi\00F3n de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99517271855304154)
,p_name=>'WWV_FLOW_CREDENTIAL.NOT_VALID_FOR_URL'
,p_message_language=>'es'
,p_message_text=>unistr('No est\00E1 permitido utilizar esta credencial para este punto final de URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99510732753304149)
,p_name=>'WWV_FLOW_CREDENTIAL.URL_MUST_START_WITH_HTTP'
,p_message_language=>'es'
,p_message_text=>'Las URL de la lista deben empezar por http:// o https://'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100056060531304567)
,p_name=>'WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'
,p_message_language=>'es'
,p_message_text=>'Credenciales para %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99764811866304340)
,p_name=>'WWV_FLOW_CSS_API.UNABLE_TO_REMOVE_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido eliminar css: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100070733100304578)
,p_name=>'WWV_FLOW_CSS_CALENDAR.DRAG_DROP_NOT_SUPPORTED_FOR_WEB_SOURCE'
,p_message_language=>'es'
,p_message_text=>unistr('La operaci\00F3n de arrastrar y soltar no est\00E1 soportada en or\00EDgenes de datos REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99746322629304327)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_APPLY'
,p_message_language=>'es'
,p_message_text=>'Aplicar Cambios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99627883654304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION1'
,p_message_language=>'es'
,p_message_text=>unistr('La funci\00F3n de protecci\00F3n de la p\00E1gina devolver\00E1 el resultado booleano de la comprobaci\00F3n de verificaci\00F3n de la sesi\00F3n incorporada al motor. Si el resultado es verdadero, el motor continuar\00E1 para mostrar o aceptar la p\00E1gina. Si el resultado es falso, ')
||unistr('el motor se redirigir\00E1 a la p\00E1gina de sesi\00F3n no v\00E1lida o a la direcci\00F3n URL especificada en este esquema de autenticaci\00F3n (consulte a continuaci\00F3n).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99629121824304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION10'
,p_message_language=>'es'
,p_message_text=>unistr('Si la funci\00F3n de protecci\00F3n de la p\00E1gina devuelve TRUE, contin\00FAa la presentaci\00F3n o el procesamiento. Si el resultado es FALSE, el motor debe salir porque no se ha especificado ning\00FAn destino de sesi\00F3n no v\00E1lido en el esquema de autenticaci\00F3n. En ese ')
||unistr('caso, se supone que la funci\00F3n de protecci\00F3n de la p\00E1gina proporcionada por el usuario se ha redirigido a una p\00E1gina de conexi\00F3n fuera del entorno %0, posiblemente a un portal de autenticaci\00F3n externa. La funci\00F3n tambi\00E9n debe haber definido la variab')
||unistr('le global g_unrecoverable_error := true para que indique al motor que salga sin mostrar una p\00E1gina de error.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99629229093304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION11'
,p_message_language=>'es'
,p_message_text=>unistr('El motor ejecutar\00E1 el siguiente c\00F3digo que se especifica como proceso anterior a la autenticaci\00F3n de este esquema de autenticaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99629340244304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION12'
,p_message_language=>'es'
,p_message_text=>unistr('Se ejecuta como bloque an\00F3nimo que no devuelve ning\00FAn valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99629454694304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION13'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha especificado ning\00FAn c\00F3digo anterior a la autenticaci\00F3n personalizado en este esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99629660528304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION14'
,p_message_language=>'es'
,p_message_text=>unistr('Cualquier combinaci\00F3n de nombre de usuario/contrase\00F1a que introduzca en la pantalla de conexi\00F3n se considerar\00E1 v\00E1lida. El nombre de usuario introducido se utilizar\00E1 como nombre de usuario conectado mientras dure la sesi\00F3n. Esta t\00E9cnica puede ser \00FAtil')
||unistr(' mientras se est\00E9 desarrollando la aplicaci\00F3n pero antes de que se establezcan las cuentas de usuario reales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99629753236304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15'
,p_message_language=>'es'
,p_message_text=>unistr('Compruebe el nombre de usuario y la contrase\00F1a que ha introducido en la pantalla de conexi\00F3n con las cuentas de Creador de Aplicaciones (usuario de cookie). Estas son las mismas cuentas que se utilizan en el espacio de trabajo para conectarse a %0. E')
||unistr('sta t\00E9cnica puede ser \00FAtil si otros usuarios de la aplicaci\00F3n son desarrolladores con cuentas de %0 en la misma base de datos y espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99562016713304191)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION15A'
,p_message_language=>'es'
,p_message_text=>unistr('Compruebe el nombre de usuario y la contrase\00F1a que ha introducido en la pantalla de conexi\00F3n con las cuentas de la base de datos Oracle. Esta t\00E9cnica puede ser \00FAtil cuando los usuarios de la aplicaci\00F3n tienen cuentas en la base de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99629859106304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION16'
,p_message_language=>'es'
,p_message_text=>unistr('Compruebe el nombre de usuario y la contrase\00F1a que ha introducido en la pantalla de conexi\00F3n mediante el directorio LDAP especificado en este esquema de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99629944763304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION17'
,p_message_language=>'es'
,p_message_text=>unistr('Los par\00E1metros de LDAP est\00E1n definidos en:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99630675283304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION18'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecute el siguiente c\00F3digo personalizado para verificar las credenciales:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99630879267304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION19'
,p_message_language=>'es'
,p_message_text=>unistr('Compruebe la tabla de sesiones incorporadas para la sesi\00F3n utilizada en la p\00E1gina de conexi\00F3n incorporada. Si existe la sesi\00F3n y ning\00FAn usuario es su propietario, m\00E1rquela como si el usuario autenticado fuera el propietario (utilizando el nombre de u')
||unistr('suario de la pantalla de conexi\00F3n).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99627930073304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION2'
,p_message_language=>'es'
,p_message_text=>unistr('La funci\00F3n de protecci\00F3n de la p\00E1gina devolver\00E1 el resultado booleano de la comprobaci\00F3n de verificaci\00F3n de la sesi\00F3n incorporada junto con el resultado de la comprobaci\00F3n de verificaci\00F3n de la sesi\00F3n proporcionada por el usuario en el motor. Si el r')
||unistr('esultado es verdadero, el motor continuar\00E1 para mostrar o aceptar la p\00E1gina. Si el resultado es falso, el motor se redirigir\00E1 al destino de sesi\00F3n no v\00E1lido especificado en este esquema de autenticaci\00F3n (consulte a continuaci\00F3n).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99630990056304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION20'
,p_message_language=>'es'
,p_message_text=>'Defina la cookie denominada %0 en un valor que busque la fila en la tabla de sesiones internas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99631090937304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION22'
,p_message_language=>'es'
,p_message_text=>unistr('Determine la direcci\00F3n URL a la que va a ser redirigido a continuaci\00F3n. Si el motor de presentaci\00F3n ha registrado un "enlace profundo" en el estado de la sesi\00F3n, util\00EDcelo como la direcci\00F3n URL a la que ir. De lo contrario, vaya a la direcci\00F3n URL es')
||unistr('pecificada como atributo del enlace de p\00E1gina inicial de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99631294078304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION23'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de la verificaci\00F3n de credenciales, el motor ejecutar\00E1 el siguiente c\00F3digo que se especifica como proceso posterior a la autenticaci\00F3n de este esquema de autenticaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99631344197304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION24'
,p_message_language=>'es'
,p_message_text=>unistr('Se ejecuta como bloque an\00F3nimo que no devuelve ning\00FAn valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99631419075304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION25'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha especificado ning\00FAn c\00F3digo posterior a la autenticaci\00F3n en este esquema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99631502627304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION26'
,p_message_language=>'es'
,p_message_text=>unistr('Redirija a la direcci\00F3n URL indicada anteriormente. Esta acci\00F3n marca el fin del procesamiento de conexi\00F3n mediante la p\00E1gina de conexi\00F3n incorporada y las API a las que llama.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99628015996304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION3'
,p_message_language=>'es'
,p_message_text=>unistr('Utilice la l\00F3gica personalizada para realizar tareas de protecci\00F3n de la p\00E1gina. Para cada solicitud de p\00E1gina, el motor ejecutar\00E1 el siguiente c\00F3digo:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99628153781304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION4'
,p_message_language=>'es'
,p_message_text=>unistr('El resultado booleano del bloque anterior se devolver\00E1 al motor. Si el resultado es verdadero, el motor continuar\00E1 para mostrar o aceptar la p\00E1gina. Si el resultado es falso, el motor se redirigir\00E1 al destino de sesi\00F3n no v\00E1lido especificado en este ')
||unistr('esquema de autenticaci\00F3n (consulte a continuaci\00F3n).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99628210427304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION5'
,p_message_language=>'es'
,p_message_text=>unistr('El m\00E9todo incorporado para la verificaci\00F3n de sesi\00F3n est\00E1 disponible para el desarrollador %0 que utiliza la llamada de API:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99628335604304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION6'
,p_message_language=>'es'
,p_message_text=>unistr('El resultado de esta funci\00F3n booleana se puede combinar con otras comprobaciones de la funci\00F3n de protecci\00F3n de p\00E1gina proporcionada por el usuario especificada en el esquema de autenticaci\00F3n. Si se llama a esta API, se comprobar\00E1 la cookie denominad')
||'a %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99628402405304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION7'
,p_message_language=>'es'
,p_message_text=>unistr('Si existe la cookie y su valor descodificado busca una fila en la tabla de sesiones internas, la sesi\00F3n se considera v\00E1lida y se devuelve un valor TRUE a la funci\00F3n de protecci\00F3n de la p\00E1gina que la ha llamado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99628688289304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION8'
,p_message_language=>'es'
,p_message_text=>unistr('Si la funci\00F3n de protecci\00F3n de la p\00E1gina devuelve TRUE, contin\00FAa la presentaci\00F3n o el procesamiento. Si el resultado es FALSE, el motor mostrar\00E1 la p\00E1gina %0, que se considera la p\00E1gina de conexi\00F3n de la aplicaci\00F3n seg\00FAn su designaci\00F3n en este esquem')
||unistr('a de autenticaci\00F3n como p\00E1gina de sesi\00F3n no v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99629020147304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ACTION9'
,p_message_language=>'es'
,p_message_text=>unistr('La funci\00F3n de protecci\00F3n de la p\00E1gina devuelve un resultado booleano al motor. Si el resultado es TRUE, contin\00FAa la representaci\00F3n o el procesamiento. Si el resultado es FALSE, el motor se redirigir\00E1 a %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99631626145304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON1'
,p_message_language=>'es'
,p_message_text=>unistr('Un enfoque t\00EDpico ser\00EDa una p\00E1gina que contiene una pantalla de conexi\00F3n para capturar las credenciales del usuario. Los procesos posteriores a la ejecuci\00F3n de la p\00E1gina llamar\00EDan a un m\00F3dulo de autenticaci\00F3n para verificar las credenciales. Despu\00E9s ')
||unistr('de la autenticaci\00F3n, la p\00E1gina realizar\00EDa las tareas de registro de sesi\00F3n y definici\00F3n de cookies. Por \00FAltimo, se le redirigir\00EDa a la p\00E1gina de inicio de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99631777777304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON2'
,p_message_language=>'es'
,p_message_text=>unistr('Estos procesos posteriores a la ejecuci\00F3n pueden llamar a la API de %0 API: wwv_flow_custom_auth_std para realizar cualquiera de los pasos descritos. Hay dos puntos de entrada disponibles:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99631844862304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON3'
,p_message_language=>'es'
,p_message_text=>unistr('Llame al procedimiento de conexi\00F3n para que el motor realice todos los pasos. El motor utilizar\00E1 la tabla de sesiones incorporada y realizar\00E1 el registro de la sesi\00F3n y la definici\00F3n de cookies. Cualquier c\00F3digo personalizado que proporcione en este ')
||unistr('esquema de autenticaci\00F3n se ejecutar\00E1 antes, durante o despu\00E9s de la autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99631935473304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.API_COMMON4'
,p_message_language=>'es'
,p_message_text=>unistr('Llame al procedimiento post_login si va a realizar la autenticaci\00F3n por s\00ED mismo pero desea que %0 maneje todas las fijaciones posteriores a la autenticaci\00F3n. Con estos dos puntos de entrada, puede utilizar cualquiera de los pasos de procesamiento de')
||unistr(' conexi\00F3n incorporados junto con su propia p\00E1gina de conexi\00F3n y los procesos que se ejecutan en ella. Recuerde que si utiliza el procesamiento posterior a la autenticaci\00F3n incorporado, puede aprovechar la funci\00F3n de protecci\00F3n de la p\00E1gina incorporad')
||unistr('a y el procesamiento de verificaci\00F3n de la sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99628741770304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.BUILTIN_LOGIN_PG'
,p_message_language=>'es'
,p_message_text=>unistr('la p\00E1gina de conexi\00F3n incorporada')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99632045230304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN1'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento de Conexi\00F3n Externa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99632869335304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN12'
,p_message_language=>'es'
,p_message_text=>unistr('La direcci\00F3n URL de conexi\00F3n %0 no parece especificar una p\00E1gina de la aplicaci\00F3n %1 como destino de sesi\00F3n no v\00E1lido. Adem\00E1s, no hay ning\00FAn valor de procesamiento de conexi\00F3n en el esquema de autenticaci\00F3n. Esta p\00E1gina es responsable de realizar los')
||' siguientes pasos:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99632916807304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN13'
,p_message_language=>'es'
,p_message_text=>unistr('Tenga en cuenta que, al menos que los servicios llamados en esta direcci\00F3n URL utilicen la API %0 wwv_custom_auth_std para proporcionar ayuda sobre las tareas de registro de sesi\00F3n, la aplicaci\00F3n no podr\00E1 utilizar la protecci\00F3n de p\00E1gina incorporada ')
||unistr('ni el procesamiento de verificaci\00F3n de sesi\00F3n. El usuario tendr\00E1 que realizar esta tarea por cualquier otro medio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99633221491304244)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN14'
,p_message_language=>'es'
,p_message_text=>unistr('La direcci\00F3n URL de conexi\00F3n %0 no parece especificar una p\00E1gina de la aplicaci\00F3n %1 como destino de sesi\00F3n no v\00E1lido. Esta p\00E1gina es responsable de realizar los siguientes pasos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99633357910304244)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN15'
,p_message_language=>'es'
,p_message_text=>unistr('Los valores definidos para el procesamiento de conexi\00F3n en el esquema de autenticaci\00F3n aparecen a continuaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99633439377304244)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN16'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina de conexi\00F3n especificada en este esquema es la p\00E1gina [%0] en esta aplicaci\00F3n. Esta p\00E1gina es responsable de realizar los siguientes pasos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99633595388304244)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN17'
,p_message_language=>'es'
,p_message_text=>unistr('Sin embargo, no existen valores de procesamiento de conexi\00F3n en el esquema de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99633653003304244)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN18'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Ya que esta p\00E1gina es la p\00E1gina de conexi\00F3n designada para la aplicaci\00F3n, no se pueden realizar algunas acciones cuando \00E9sta aparece por primera vez, ya que todav\00EDa no se ha producido la autenticaci\00F3n de usuario. As\00ED mismo, algunas variables de estad')
||unistr('o de sesi\00F3n e identificaci\00F3n de sesi\00F3n no est\00E1n disponibles para los c\00E1lculos o procesos de p\00E1gina, ya que estar\00EDan en p\00E1ginas normales que se procesan despu\00E9s de la autenticaci\00F3n. Por estos motivos, la especificaci\00F3n de una p\00E1gina de conexi\00F3n median')
||unistr('te un n\00FAmero de p\00E1gina en un esquema de autenticaci\00F3n, s\00F3lo se recomienda para las p\00E1ginas que tienen muy poca funcionalidad y que no sean p\00E1ginas que pertenezcan al procesamiento de la pantalla de conexi\00F3n. Si prefiere que la p\00E1gina de conexi\00F3n est\00E9')
||unistr(' m\00E1s activa, utilice la designaci\00F3n de la direcci\00F3n URL de conexi\00F3n en el asistente de esquemas de autenticaci\00F3n o edite la p\00E1gina. Siempre que recuerde definir el atributo de p\00E1gina p\00FAblica en ''S\00ED: Esta P\00E1gina Es P\00FAblica'' utilizando la pantalla de a')
||unistr('tributos de p\00E1gina del Creador, la p\00E1gina'),
unistr(' de conexi\00F3n podr\00E1 utilizar el rango completo de funciones de %0, adem\00E1s de servir como p\00E1gina de conexi\00F3n en la aplicaci\00F3n.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99632157244304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN2'
,p_message_language=>'es'
,p_message_text=>unistr('Este esquema de autenticaci\00F3n no especifica la p\00E1gina de conexi\00F3n ni la direcci\00F3n URL que se va a utilizar para el destino de sesi\00F3n no v\00E1lido. Esto implica que la funci\00F3n de protecci\00F3n de la p\00E1gina maneja este caso. Puede que esta funci\00F3n redirija a')
||unistr(' un portal de Single Sign-On o a alg\00FAn otro servidor de conexi\00F3n. Adem\00E1s, no hay valores de procesamiento de conexi\00F3n en el esquema de autenticaci\00F3n. Si no es lo que pretend\00EDa, edite este esquema de autenticaci\00F3n y proporcione una p\00E1gina de sesi\00F3n o ')
||unistr('una direcci\00F3n URL no v\00E1lida y, a continuaci\00F3n, vuelva a examinar esta vista de gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99632224577304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN3'
,p_message_language=>'es'
,p_message_text=>unistr('Este esquema de autenticaci\00F3n no especifica la p\00E1gina de conexi\00F3n ni la direcci\00F3n URL que se va a utilizar para el destino de sesi\00F3n no v\00E1lido. Esto implica que la funci\00F3n de protecci\00F3n de la p\00E1gina maneja este caso. Puede que esta funci\00F3n redirija a')
||unistr(' un portal de conexi\00F3n \00FAnica o a alg\00FAn otro servidor de conexi\00F3n. Sin embargo, hay valores definidos para el procesamiento de conexi\00F3n en el esquema de autenticaci\00F3n, como se muestra a continuaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99632317670304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN4'
,p_message_language=>'es'
,p_message_text=>unistr('La direcci\00F3n URL de conexi\00F3n %0 parece especificar una p\00E1gina de la aplicaci\00F3n %1 como destino de sesi\00F3n no v\00E1lido. Sin embargo, no hay valores de procesamiento de conexi\00F3n en el esquema de autenticaci\00F3n. Esta p\00E1gina es responsable de realizar los si')
||'guientes pasos:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99632458099304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN6'
,p_message_language=>'es'
,p_message_text=>unistr('Para que el motor %0 pueda mostrar o aceptar la p\00E1gina de conexi\00F3n en la aplicaci\00F3n, debe seleccionar el atributo de p\00E1gina ''S\00ED: Esta p\00E1gina es p\00FAblica'' en la p\00E1gina Atributos de P\00E1gina de Creador de Aplicaciones. De lo contrario, el motor intentar\00E1 ')
||unistr('ejecutar la funci\00F3n de protecci\00F3n de la p\00E1gina antes de mostrarla. Si todav\00EDa no se ha conectado, se intentar\00E1 un redireccionamiento a la misma URL. Esto producir\00E1 un bucle no satisfactorio. Si codifica su propia funci\00F3n de protecci\00F3n de la p\00E1gina, p')
||unistr('uede que necesite reconocer si la p\00E1gina actual es la p\00E1gina de conexi\00F3n y manejarla de forma distinta al resto de las p\00E1ginas. Si puede identificarla por el n\00FAmero de la p\00E1gina ser\00EDa apropiado. Una t\00E9cnica m\00E1s gen\00E9rica consiste en utilizar la funci\00F3')
||unistr('n booleana wwv_flow_custom_auth.current_page_is_public para reconocer este atributo p\00FAblico de la p\00E1gina de conexi\00F3n y cualquier otra p\00E1gina en la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99632541199304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN7'
,p_message_language=>'es'
,p_message_text=>unistr('La direcci\00F3n URL de conexi\00F3n %0 parece especificar una p\00E1gina de aplicaci\00F3n %1 como el destino de sesi\00F3n no v\00E1lido. Esta p\00E1gina es responsable de realizar los siguientes pasos:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99632636282304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN8'
,p_message_language=>'es'
,p_message_text=>unistr('Los valores definidos para el procesamiento de conexi\00F3n en el esquema de autenticaci\00F3n aparecen a continuaci\00F3n:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99632752987304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_LOGIN9'
,p_message_language=>'es'
,p_message_text=>unistr('El servidor de Oracle Application Server Single Sign-On se volver\00E1 a redirigir a esta aplicaci\00F3n despu\00E9s de la autenticaci\00F3n del usuario. El punto de entrada es el procedimiento wwv_flow_custom_auth_sso.process_success en el esquema %0. %0 est\00E1 regis')
||unistr('trado como aplicaci\00F3n asociada de Oracle Application Server Single Sign-On y puede gestionar todas las interfaces en el servidor de conexi\00F3n para el usuario. Sin embargo, si prefiere registrar su propia aplicaci\00F3n en su propio esquema, puede hacerlo.')
||unistr(' Puede escribir su propia protecci\00F3n de p\00E1gina o simplemente crear un esquema de autenticaci\00F3n basado en el esquema SSO de Portal (mi aplicaci\00F3n como aplicaci\00F3n asociada) de la galer\00EDa de esquemas de autenticaci\00F3n. El esquema resultante llamar\00E1 a la ')
||unistr('protecci\00F3n de p\00E1gina de wwv_flow_custom_auth_std.portal_sso_sentry_v1. Esta funci\00F3n necesita que el esquema de autenticaci\00F3n actual sepa el nombre de la aplicaci\00F3n asociada como est\00E1 registrada con Oracle Application Server Single Sign-On. El Asisten')
||unistr('te de Creaci\00F3n de Esquemas de Autenticaci\00F3n pregunta el nombre de la aplicaci\00F3n asociada o se puede agregar o cambiar editando el esquema cuando se haya creado. El nombre se debe introducir exactamente como se ha registrado manteniendo las may\00FAsculas')
||unistr('/min\00FAsculas. Deber\00E1 escribir tambi\00E9n el procedimiento receptor de URLC y llamar a la API wwv_flow_custom_auth_sso.process_success desde \00E9l, transfiriendo el nombre de la aplicaci\00F3n como se ha registrado en Oracle Application Server Single Sign-On. De')
||unistr(' este modo se realizar\00E1 el registro de la sesi\00F3n con %0 despu\00E9s de la autenticaci\00F3n. Si escribe su propia protecci\00F3n de p\00E1gina, \00E9sta puede llamar a la API wwv_flow_custom_auth_sso.portal_sso_redirect para realizar el redireccionamiento al servidor de')
||unistr(' conexi\00F3n cuando determine que la autenticaci\00F3n es necesaria. Debe transferir el nombre registrado de la aplicaci\00F3n asociada a este procedimiento. Consulte la documentaci\00F3n de %0 y de %1 para obtener m\00E1s informaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99633176296304244)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_POST_AUTH_PROC'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento Posterior a la Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99633044089304243)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHART_PRE_AUTH_PROC'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento Anterior a la Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99627591091304239)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CHK_COOKIE1'
,p_message_language=>'es'
,p_message_text=>unistr('Si utiliza la l\00F3gica incorporada, compruebe la cookie denominada [%0]. Si existe la cookie y su valor descodificado busca una fila en la tabla de sesiones internas, considere la sesi\00F3n v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99627707024304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.COMPUTE_RETURN_VALUE'
,p_message_language=>'es'
,p_message_text=>'Calcular Valor de Retorno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99629585433304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CREDENTIALS_VERIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Verificaci\00F3n de Credenciales (Autenticaci\00F3n)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99631100418304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.CUST_POST_AUTH_PROC'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento Posterior a la Autenticaci\00F3n Personalizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99624295891304237)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_MALFORMED_LOGIN_ARGS2'
,p_message_language=>'es'
,p_message_text=>unistr('Argumento de punto de entrada no v\00E1lido en wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.  ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99624164615304237)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_NULL_LOGIN_ARG'
,p_message_language=>'es'
,p_message_text=>'Argumento p_session_id nulo en wwv_flow_custom_auth_std.login--p_flow_page:%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99624082720304237)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.ERR_RUN_CRED'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido ejecutar la funci\00F3n de control de credenciales de autenticaci\00F3n.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99628509737304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.INVALID_SESS_TARGET'
,p_message_language=>'es'
,p_message_text=>unistr('Destino de Sesi\00F3n no V\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99630249225304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_DN'
,p_message_language=>'es'
,p_message_text=>unistr('Base de B\00FAsqueda LDAP:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99630387368304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN'
,p_message_language=>'es'
,p_message_text=>unistr('El siguiente bloque se utiliza para llamar a una funci\00F3n antes de llamar a DBMS_LDAP.SIMPLE_BIND_S. El nombre de usuario capturado en la pantalla de conexi\00F3n se transfiere a la funci\00F3n, que devuelve un valor que se utiliza para sustituir %LDAP_USER% ')
||unistr('en la base de b\00FAsqueda LDAP (consulte la informaci\00F3n anterior).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99630419239304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN2'
,p_message_language=>'es'
,p_message_text=>unistr('El bloque de c\00F3digos debe tener esta firma:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99630591944304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_EDIT_FN3'
,p_message_language=>'es'
,p_message_text=>unistr('Esta funci\00F3n permite transformar el nombre de usuario introducido en la pantalla de conexi\00F3n en el formato que coincida con la entrada de directorio LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99630008603304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_HOST'
,p_message_language=>'es'
,p_message_text=>'Host LDAP:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99630134368304241)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LDAP_PORT'
,p_message_language=>'es'
,p_message_text=>'Puerto LDAP:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99627014913304239)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG1'
,p_message_language=>'es'
,p_message_text=>unistr('Esta aplicaci\00F3n (%0) utiliza la p\00E1gina %1 como p\00E1gina de conexi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99627162730304239)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG2'
,p_message_language=>'es'
,p_message_text=>unistr('Cuando se solicita la p\00E1gina %0, no se realizan m\00E1s comprobaciones de autenticaci\00F3n y la p\00E1gina se muestra o se acepta. Esto permite mostrar la p\00E1gina de conexi\00F3n antes de que se produzca la autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99626927037304239)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.LOGIN_PG_HANDLING'
,p_message_language=>'es'
,p_message_text=>unistr('Manejo de P\00E1gina de Conexi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99627259996304239)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PAGE_SENTRY_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n de Protecci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99627324644304239)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.PG_SENTRY1'
,p_message_language=>'es'
,p_message_text=>unistr('Utilice la l\00F3gica incorporada para realizar las tareas de protecci\00F3n de la p\00E1gina. Para cada solicitud de p\00E1gina, la funci\00F3n de protecci\00F3n de la p\00E1gina realiza la verificaci\00F3n de la sesi\00F3n y calcula un valor de retorno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99630781297304242)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.POST_AUTH_PROC'
,p_message_language=>'es'
,p_message_text=>unistr('Procesamiento Posterior a la Autenticaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99627601414304239)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY1'
,p_message_language=>'es'
,p_message_text=>unistr('Utilice el c\00F3digo proporcionado por el usuario adicional para determinar si la sesi\00F3n es v\00E1lida. Despu\00E9s de obtener un resultado verdadero de la comprobaci\00F3n de verificaci\00F3n de la sesi\00F3n incorporada, ejecute el siguiente c\00F3digo y recuerde su valor de')
||' retorno booleano:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99627433757304239)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SESS_VERIFY_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n de Verificaci\00F3n de Sesi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99628876757304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.SSO_SERVER'
,p_message_language=>'es'
,p_message_text=>'el servidor de Oracle Application Server Single Sign-On'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99628939167304240)
,p_name=>'WWV_FLOW_CUSTOM_AUTH_STD.THE_URL'
,p_message_language=>'es'
,p_message_text=>unistr('la direcci\00F3n URL')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99775768412304348)
,p_name=>'WWV_FLOW_DATALOAD_XML.ERROR'
,p_message_language=>'es'
,p_message_text=>'error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99514166418304152)
,p_name=>'WWV_FLOW_DATA_LOADER.LOADING_JOB_STARTED'
,p_message_language=>'es'
,p_message_text=>'Se ha iniciado el trabajo de carga de datos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99685016630304282)
,p_name=>'WWV_FLOW_DATA_PARSER.FILE_TOO_LARGE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 archivos con un tama\00F1o superior a 1 MB no est\00E1n soportados para la carga de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100070631327304578)
,p_name=>'WWV_FLOW_DATA_PROFILE.INVALID_SQL_EXPR'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n SQL no v\00E1lida: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99604416144304223)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.ANALYZE_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Analizar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99604835982304223)
,p_name=>'WWV_FLOW_DATA_QUICK_FLOW.VIEW_BY'
,p_message_language=>'es'
,p_message_text=>'Ver por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99764976052304340)
,p_name=>'WWV_FLOW_DEBUGTAB_BIU_FER.INVALID_DATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Formato de fecha no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99744536616304325)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.DEBUG'
,p_message_language=>'es'
,p_message_text=>'Depurar:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99744646969304326)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FEATURE_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n no soportada en esta versi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99741771368304323)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.FUNC_RETURN_QUERY_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1101: No se ha podido procesar el cuerpo de la funci\00F3n que devuelve una consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99744888306304326)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.HELP_REQUEST_ERR2'
,p_message_language=>'es'
,p_message_text=>unistr('Error 4323: La solicitud de ayuda no ha proporcionado un identificador de p\00E1gina num\00E9rico para mostrar la ayuda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99741597028304323)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1025: Error al procesar la expresi\00F3n PLSQL.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99741684910304323)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PLSQL_EXP_FOOTER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n=%0 P\00E1gina=%1 SQLERRM=%2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99744310141304325)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PRINT_SHORTCUT_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido imprimir el m\00E9todo abreviado: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99741853882304324)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.PROC_CURR_COND_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1108: No se ha podido procesar la condici\00F3n actual del elemento.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99744470103304325)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_CHART_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al presentar el gr\00E1fico: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99894695576304443)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_COMP_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido presentar el componente: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99538717163304170)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.RENDER_DYN_LIST_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al presentar la regi\00F3n de lista din\00E1mica: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99744778134304326)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.REQUEST_FOR_HELP_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error 4322: La solicitud de ayuda no ha utilizado una sintaxis adecuada. La solicitud ha sido nula cuando esperaba un n\00FAmero de p\00E1gina v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99771319917304345)
,p_name=>'WWV_FLOW_DISP_PAGE_PLUGS.UNABLE_TO_BIND_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido enlazar a "%0". Utilice comillas dobles para los elementos de multibyte o verifique que la longitud del elemento sea de 30 bytes o menos. Utilice la sintaxis v() para hacer referencia a los elementos superiores a 30 bytes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100309405351304798)
,p_name=>'WWV_FLOW_DML.BLOB_COLUMN_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'es'
,p_message_text=>unistr('Esperando nombre de columna BLOB en la m\00E1scara de formato de la columna de informe DOWNLOAD:TABLE_NAME:BLOB_COLUMN...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100664080103305063)
,p_name=>'WWV_FLOW_DML.COLUMN_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado la columna %0 en la tabla %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99767083986304342)
,p_name=>'WWV_FLOW_DML.DML_ERR'
,p_message_language=>'es'
,p_message_text=>'Error en DML: p_rowid=%0, p_alt_rowid=%1, p_rowid2=%2, p_alt_rowid2=%3. %4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99601035895304220)
,p_name=>'WWV_FLOW_DML.DML_INSERT_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido realizar la operaci\00F3n de inserci\00F3n.  %0  %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99922573322304465)
,p_name=>'WWV_FLOW_DML.DML_INVALID_NUMBER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El valor num\00E9rico %0 no es v\00E1lido para la columna %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99607769105304225)
,p_name=>'WWV_FLOW_DML.INVALID_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n no v\00E1lida %0 en este objeto. (%1)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100308521831304797)
,p_name=>'WWV_FLOW_DML.INVALID_TABLE_OWNER'
,p_message_language=>'es'
,p_message_text=>unistr('Propietario de tabla no v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100308655402304798)
,p_name=>'WWV_FLOW_DML.INVALID_URL'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n URL no V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100308421620304797)
,p_name=>'WWV_FLOW_DML.LAST_UPDATED_COLUMN_HAS_TO_BE_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('El tipo de dato "%1" de la \00FAltima columna de datos actualizada "%0" utilizada para realizar el seguimiento de las actualizaciones en "%2" debe ser un tipo de dato de fecha o de registro de hora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100308712973304798)
,p_name=>'WWV_FLOW_DML.NOT_CALLED_FROM_PAGE_WHICH_CONTAINS_FILE_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Error: Se debe llamar desde la p\00E1gina de la pantalla que contiene el nombre de elemento de tipo FILE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100309056903304798)
,p_name=>'WWV_FLOW_DML.NO_FORMAT_MASK'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ninguna m\00E1scara de formato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100309510224304798)
,p_name=>'WWV_FLOW_DML.PK_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'es'
,p_message_text=>unistr('Esperando nombre de columna de clave primaria 1 en la m\00E1scara de formato de la columna de informe DOWNLOAD:TABLE_NAME:BLOB_COLUMN:PK1_COL_NAME...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100664121931305063)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado la tabla o vista %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100309331155304798)
,p_name=>'WWV_FLOW_DML.TABLE_NOT_IN_REPORT_COLUMN_FORMAT_MASK'
,p_message_language=>'es'
,p_message_text=>unistr('Esperando nombre de tabla en la m\00E1scara de formato de la columna de informe DOWNLOAD:TABLE_NAME...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100309244388304798)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK'
,p_message_language=>'es'
,p_message_text=>unistr('La m\00E1scara de formato debe incluir al menos 4 argumentos separados por dos puntos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100309116846304798)
,p_name=>'WWV_FLOW_DML.WRONG_FORMAT_MASK_PREFIX'
,p_message_language=>'es'
,p_message_text=>unistr('La m\00E1scara de formato debe empezar por DOWNLOAD o IMAGE')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99954662647304490)
,p_name=>'WWV_FLOW_EXEC.INVALID_COLUMN_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de columna "%0" no es v\00E1lido para la consulta SQL. Aseg\00FArese de que utiliza nombres de alias \00FAnicos para sus columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99599912269304219)
,p_name=>'WWV_FLOW_EXEC.NOT_ALLOWED_ON_WEB_SOURCE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta operaci\00F3n no est\00E1 permitida para origen de datos de REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99954511028304490)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_COUNT'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero de columnas seleccionadas en la consulta SQL  no es correcto. Consulte la ayuda del atributo para obtener m\00E1s informaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99510048090304148)
,p_name=>'WWV_FLOW_EXEC.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 tiene un tipo de dato no v\00E1lido en la sentencia SQL. La columna n\00BA %1 es %2 pero se esperaba %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100055515318304566)
,p_name=>'WWV_FLOW_EXEC_DEV.COLUMN_NOT_UNIQUE'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de columna "%0" ya se ha utilizado en la consulta SQL. Aseg\00FArese de que utiliza nombres de alias \00FAnicos para sus columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100055426079304566)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_COLUMN_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de columna "%0" no es v\00E1lido para la consulta SQL de lista de valores. Aseg\00FArese de que utiliza nombres de alias v\00E1lidos para sus columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100055210652304566)
,p_name=>'WWV_FLOW_EXEC_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'es'
,p_message_text=>'Analizando los resultados de consulta devueltos en "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100055315214304566)
,p_name=>'WWV_FLOW_EXEC_DEV.WRONG_COLUMN_COUNT'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero de columnas seleccionadas en la consulta SQL  no es correcto. Consulte la ayuda del atributo para obtener m\00E1s informaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99509523276304148)
,p_name=>'WWV_FLOW_EXEC_WEB_SRC.MODULE_TYPE_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('El tipo de origen de datos de REST %0 no est\00E1 soportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99511468075304149)
,p_name=>'WWV_FLOW_EXPORT_INT.DUPLICATE_FILENAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de archivo duplicado: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100703897491305096)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.APPLICATION_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100703619543305096)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.CONSTANT'
,p_message_language=>'es'
,p_message_text=>'Constante'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100703354756305096)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100704419974305097)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.KEYWORD'
,p_message_language=>'es'
,p_message_text=>'Palabra Clave'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100704304113305097)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.MATERIALIZED VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista Materializada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100703910343305096)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PACKAGE'
,p_message_language=>'es'
,p_message_text=>'Paquete'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100703787230305096)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PAGE_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100703238854305096)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.PROCEDURE'
,p_message_language=>'es'
,p_message_text=>'Procedimiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100704017634305096)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.SEQUENCE'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100704119315305096)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TABLE'
,p_message_language=>'es'
,p_message_text=>'Tabla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100704508597305097)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100703460781305096)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100703580064305096)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VARIABLE'
,p_message_language=>'es'
,p_message_text=>'Variable'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100704296098305097)
,p_name=>'WWV_FLOW_F4000_PLUGINS.CODE_COMPLETE.VIEW'
,p_message_language=>'es'
,p_message_text=>'Ver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100268479148304768)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_LOV_SQL'
,p_message_language=>'es'
,p_message_text=>'Fallo al analizar la consulta SQL de lista de valores. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100033282092304550)
,p_name=>'WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'
,p_message_language=>'es'
,p_message_text=>unistr('Se han enviado filtros de consulta no v\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100269305766304768)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de columna "%0" ya se ha utilizado en la consulta SQL de lista de valores. Aseg\00FArese de que utiliza nombres de alias \00FAnicos para sus columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100269250341304768)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de columna "%0" no es v\00E1lido para la consulta SQL de lista de valores. Aseg\00FArese de que utiliza nombres de alias v\00E1lidos para sus columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100268327768304768)
,p_name=>'WWV_FLOW_F4000_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha seleccionado un n\00FAmero de columnas incorrecto en la consulta SQL de lista de valores. Consulte los ejemplos de sentencias v\00E1lidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99607563747304225)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE'
,p_message_language=>'es'
,p_message_text=>'El servidor ha encontrado un error al intentar eliminar el archivo "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99607670970304225)
,p_name=>'WWV_FLOW_FILE_API.ERROR_REMOVING_FILE2'
,p_message_language=>'es'
,p_message_text=>'No se ha podido eliminar el archivo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99607301985304225)
,p_name=>'WWV_FLOW_FILE_API.ERROR_WRITING_TO_DIRECTORY'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha producido un error al escribir en el directorio de archivos f\00EDsicos "%0". (%1: %2)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99742836280304324)
,p_name=>'WWV_FLOW_FILE_API.EXCEEDED_WORKSPACE_NON_INTERNAL_FILES_LIMIT'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha excedido el l\00EDmite de tama\00F1o m\00E1ximo de los archivos de espacio de trabajo no internos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99607423319304225)
,p_name=>'WWV_FLOW_FILE_API.NO_FILE_TO_WRITE'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ning\00FAn archivo en el que escribir el identificador %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99742707353304324)
,p_name=>'WWV_FLOW_FILE_API.WORKSPACE_MAX_FILE_BYTES.EXCEEDED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha excedido el l\00EDmite de tama\00F1o m\00E1ximo de todos los archivos de espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99776095184304348)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.DEV_ROLE_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al suprimir el rol del desarrollador. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99652043135304258)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_FND_USER'
,p_message_language=>'es'
,p_message_text=>'No se ha creado el usuario por el siguiente motivo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100316640529304804)
,p_name=>'WWV_FLOW_FND_USER_API.INVALID_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('%0 es una direcci\00F3n de correo electr\00F3nico no v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99769768864304344)
,p_name=>'WWV_FLOW_FORMS.COMBO_JS_NO_QUERY_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento %0 de tipo lista de selecci\00F3n con redireccionamiento de js no tiene ninguna consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99769633229304344)
,p_name=>'WWV_FLOW_FORMS.COMBO_NO_QUERY_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento %0 de tipo lista de selecci\00F3n no tiene ninguna consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99769810942304344)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento %0 de tipo lista de selecci\00F3n con redireccionamiento de direcci\00F3n URL no tiene ninguna consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99769947686304344)
,p_name=>'WWV_FLOW_FORMS.COMBO_URL_PAGE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento %0 de tipo lista de selecci\00F3n con redireccionamiento de direcci\00F3n URL a la p\00E1gina no tiene ninguna consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99744218554304325)
,p_name=>'WWV_FLOW_FORMS.EDIT ITEM'
,p_message_language=>'es'
,p_message_text=>'Editar Elemento %0: %1, Secuencia: %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99741312754304323)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_FUNC_BODY_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1904: No se ha podido calcular el elemento por defecto: type = Cuerpo de la Funci\00F3n computation_type= %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99741293446304323)
,p_name=>'WWV_FLOW_FORMS.PLSQL_ITEM_PROC_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1020: Error en el procesamiento de elementos PLSQL (funci\00F3n).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99741481786304323)
,p_name=>'WWV_FLOW_FORMS.SPELL_CHK'
,p_message_language=>'es'
,p_message_text=>unistr('Comprobaci\00F3n Ortogr\00E1fica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99744133683304325)
,p_name=>'WWV_FLOW_FORMS.UNABLE_CAST_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido difundir el valor "%0" para la m\00E1scara de formato de fecha %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99509208229304148)
,p_name=>'WWV_FLOW_FORM_REGION.BLOB_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('Los elementos de tipo de datos BLOB no est\00E1n soportados para SQL activado para REST u origen de datos de REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99509457470304148)
,p_name=>'WWV_FLOW_FORM_REGION.CANNOT_FETCH_META_DATA'
,p_message_language=>'es'
,p_message_text=>unistr('No se pueden recuperar los metadatos para el ID de regi\00F3n %s.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99989436141304517)
,p_name=>'WWV_FLOW_FORM_REGION.FORM_REGION_IS_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('El proceso DLM o de inicializaci\00F3n de la pantalla no tiene asignada ninguna pantalla de regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99995174362304521)
,p_name=>'WWV_FLOW_FORM_REGION.MIGRATE_FORM_REGION_DESCRIBE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al migrar la p\00E1gina de pantalla heredada a la regi\00F3n de pantalla: no se puede describir la tabla referenciada en el proceso DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99726335186304312)
,p_name=>'WWV_FLOW_FORM_REGION.NO_CHECKSUM_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn total de control para la detecci\00F3n de actualizaciones perdidas. Solo se puede realizar las acciones UPDATE o DELETE para las filas existentes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100295746770304788)
,p_name=>'WWV_FLOW_FORM_REGION.NO_DML_ON_WSM_SYNC_TABLE'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede ejecutar la pantalla DML en un origen REST con la sincronizaci\00F3n activada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99509169847304148)
,p_name=>'WWV_FLOW_FORM_REGION.NO_PRIMARY_KEY_ITEM'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ning\00FAn elemento de clave primaria para la regi\00F3n de pantalla %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99509394227304148)
,p_name=>'WWV_FLOW_FORM_REGION.WRONG_ITEM_TYPE'
,p_message_language=>'es'
,p_message_text=>'El elemento %0 tiene un tipo de datos incorrecto.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99677332560304276)
,p_name=>'WWV_FLOW_GENERATE_DDL.DOMAIN_INDEX_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Hay un \00EDndice de dominio en %0 que se ha seleccionado. La opci\00F3n Generar DDL no puede generar DDL para el \00EDndice de dominio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99615844706304231)
,p_name=>'WWV_FLOW_GENERATE_DDL.GENERATE_DDL_ERROR'
,p_message_language=>'es'
,p_message_text=>'REM No se ha podido generar DDL para %0 %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99646505626304254)
,p_name=>'WWV_FLOW_GENERATE_DDL.NO_DDL'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado %0 para generar DDL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99616016621304231)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL ERROR'
,p_message_language=>'es'
,p_message_text=>'Error de Save_ddl %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99603681955304222)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido guardar DDL como script. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99615985206304231)
,p_name=>'WWV_FLOW_GENERATE_DDL.SAVE_DDL_PARSE_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al analizar el script de DDL. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99770088277304344)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.PACKAGE_INVALID_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error: El nombre del paquete %0 no es v\00E1lido o ya existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99751125214304330)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_COMMENT'
,p_message_language=>'es'
,p_message_text=>unistr('-- API de tabla para la aplicaci\00F3n %0, se ha generado %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99749847749304329)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_CREATE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Crear paquete PL/SQL %0 con los siguientes procedimientos:',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99750724144304330)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC1'
,p_message_language=>'es'
,p_message_text=>'se utiliza para insertar los datos en %0; se debe proporcionar la clave primaria'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99750834499304330)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC2'
,p_message_language=>'es'
,p_message_text=>'se utiliza para actualizar los datos en %0 identificado por claves primarias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99750980318304330)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC3'
,p_message_language=>'es'
,p_message_text=>'se utiliza para suprimir los datos de %0 basados en las claves primarias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99751080304304330)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESC4'
,p_message_language=>'es'
,p_message_text=>'se utiliza para recuperar los datos de %0 basado en claves primarias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99750641746304330)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99750481571304330)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_BODY'
,p_message_language=>'es'
,p_message_text=>'Descargar Cuerpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99750395493304330)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_DOWN_SPEC'
,p_message_language=>'es'
,p_message_text=>unistr('Descargar Especificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99750272942304330)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_BODY'
,p_message_language=>'es'
,p_message_text=>'Ocultar Cuerpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99750030350304329)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_HIDE_SPEC'
,p_message_language=>'es'
,p_message_text=>unistr('Ocultar Especificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99823886409304383)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_BODY_COMMENT'
,p_message_language=>'es'
,p_message_text=>'-- cuerpo del paquete'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99823999104304383)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_PKG_SPEC_COMMENT'
,p_message_language=>'es'
,p_message_text=>unistr('-- especificaci\00F3n de paquete')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99750168489304330)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_BODY'
,p_message_language=>'es'
,p_message_text=>'Mostrar Cuerpo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99749915480304329)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SHOW_SPEC'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar Especificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99750568648304330)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_SUBPROGRAM'
,p_message_language=>'es'
,p_message_text=>'Subprograma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99823385876304383)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_CREATE_COMMENT'
,p_message_language=>'es'
,p_message_text=>'-- crear procedimiento para tabla "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99823578306304383)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_DELETE_COMMENT'
,p_message_language=>'es'
,p_message_text=>'-- suprimir procedimiento para tabla "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99823682749304383)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_GET_COMMENT'
,p_message_language=>'es'
,p_message_text=>'-- obtener procedimiento para tabla "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99823746505304383)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_MD5_COMMENT'
,p_message_language=>'es'
,p_message_text=>unistr('-- crear funci\00F3n MD5 para tabla "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99823492651304383)
,p_name=>'WWV_FLOW_GENERATE_TABLE_API.T_TABLE_UPDATE_COMMENT'
,p_message_language=>'es'
,p_message_text=>'-- actualizar procedimiento para tabla "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99770193580304344)
,p_name=>'WWV_FLOW_GENERIC_ATTR.ERROR'
,p_message_language=>'es'
,p_message_text=>'error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100307815424304797)
,p_name=>'WWV_FLOW_GEN_API2.COMPANY_SOURCE_IDENTIFIER_NULL'
,p_message_language=>'es'
,p_message_text=>'Se debe definir el identificador de origen del espacio de trabajo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100307917249304797)
,p_name=>'WWV_FLOW_GEN_API2.DEPLOYMENT_SYSTEM_NULL'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el sistema de despliegue.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99648155603304255)
,p_name=>'WWV_FLOW_GRID_LAYOUT.FIXED_POSITION_CONFLICT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>El componente <strong>%0</strong> no se puede presentar en la <strong>columna %1</strong> debido a que existe otro componente en esta columna.</p>',
unistr('<p>Definir la columna en <strong>Autom\00E1tica</strong> normalmente corregir\00E1 este problema.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100752427786305133)
,p_name=>'WWV_FLOW_GRID_LAYOUT.LABEL_COLUMN_SPAN_TOO_BIG'
,p_message_language=>'es'
,p_message_text=>unistr('<p>La etiqueta de elemento de p\00E1gina <strong>%0</strong> no se puede presentar debido a que el valor de cuadr\00EDcula de ampliaci\00F3n de columna de etiqueta para este elemento de p\00E1gina no es v\00E1lido. Est\00E1 definida para mostrarse con una <strong>ampliaci\00F3n')
||unistr(' de columna de %1</strong>. Esto no est\00E1 soportado, ya que el elemento de p\00E1gina solo tiene <strong>%2 columnas</strong> disponibles.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99647966872304255)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_CALCULATED_COLUMNS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El componente <strong>%0</strong> no se pueden presentar debido a que la configuraci\00F3n de cuadr\00EDcula para este componente no es v\00E1lida. Se ha definido para mostrarse en la <strong>columna %1</strong> con una <span>ampliaci\00F3n de columna de %2</stro')
||unistr('ng>. Esto no est\00E1 soportado, ya que la cuadr\00EDcula de esta p\00E1gina solo soporta hasta <strong>%3 columnas</strong>.</p>'),
unistr('<p>Definir la columna y la ampliaci\00F3n de columna en <strong>Autom\00E1tica</strong> para todos los componentes normalmente corregir\00E1 este problema.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99648097561304255)
,p_name=>'WWV_FLOW_GRID_LAYOUT.MORE_THAN_SUPPORTED_COLUMNS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El <p>componente <strong>%0</strong> no se pueden presentar debido a que la configuraci\00F3n de cuadr\00EDcula para este componente no es v\00E1lida. Se ha definido para mostrarse en la <strong>columna %1</strong> con una <span>ampliaci\00F3n de columna de %2</stro')
||unistr('ng>. Esto no est\00E1 soportado, ya que la cuadr\00EDcula de esta p\00E1gina solo soporta <strong>%3 columnas</strong>.</p>'),
unistr('<p>Definir la columna y la ampliaci\00F3n de columna en <strong>Autom\00E1tica</strong> para todos los componentes normalmente corregir\00E1 este problema.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99530131578304163)
,p_name=>'WWV_FLOW_HELP.2_DAY_DBA'
,p_message_language=>'es'
,p_message_text=>unistr('DBA de 2 D\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99530014991304163)
,p_name=>'WWV_FLOW_HELP.2_DAY_DEV'
,p_message_language=>'es'
,p_message_text=>unistr('2 D\00EDas + Developer''s Guide')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99496460597304138)
,p_name=>'WWV_FLOW_HELP.ADMIN_GUIDE'
,p_message_language=>'es'
,p_message_text=>unistr('Gu\00EDa de Administraci\00F3n de Aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99496532250304138)
,p_name=>'WWV_FLOW_HELP.API'
,p_message_language=>'es'
,p_message_text=>'Referencia de API'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100072360637304580)
,p_name=>'WWV_FLOW_HELP.CONTENTS'
,p_message_language=>'es'
,p_message_text=>'Contenido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100066399447304575)
,p_name=>'WWV_FLOW_HELP.CONTEXT_HELP'
,p_message_language=>'es'
,p_message_text=>'Acerca de: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100072489942304580)
,p_name=>'WWV_FLOW_HELP.FIND'
,p_message_language=>'es'
,p_message_text=>'Buscar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99529951837304163)
,p_name=>'WWV_FLOW_HELP.HTMLDB_USER_GUIDE'
,p_message_language=>'es'
,p_message_text=>'App Builder User''s Guide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100178315145304699)
,p_name=>'WWV_FLOW_HELP.INITIAL_INDEX_CREATION'
,p_message_language=>'es'
,p_message_text=>unistr('La creaci\00F3n de \00EDndices inicial puede tardar varios segundos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99496652203304138)
,p_name=>'WWV_FLOW_HELP.MIGRATION'
,p_message_language=>'es'
,p_message_text=>unistr('Gu\00EDa de Migraci\00F3n de Aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100072195981304579)
,p_name=>'WWV_FLOW_HELP.NO_INDEX_MAP'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado el archivo de asignaci\00F3n de documentaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100072571475304580)
,p_name=>'WWV_FLOW_HELP.SCORE'
,p_message_language=>'es'
,p_message_text=>unistr('Puntuaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99496769975304138)
,p_name=>'WWV_FLOW_HELP.SQL_WORKSHOP'
,p_message_language=>'es'
,p_message_text=>unistr('Taller de SQL y Gu\00EDa de Utilidades')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99779215753304351)
,p_name=>'WWV_FLOW_HINT.CREATE_NORMALIZE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de creaci\00F3n de normalizaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99955459505304491)
,p_name=>'WWV_FLOW_HINT.NO_PRIVS_ON_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('No tiene acceso al esquema que est\00E1 importando. Fallo al importar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99779158898304350)
,p_name=>'WWV_FLOW_HINT.REMOVE_TABLE_HINT_ERR'
,p_message_language=>'es'
,p_message_text=>'Se ha llamado a remove_table_hint sin p_table_id. Se debe proporcionar una tabla.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99684980629304282)
,p_name=>'WWV_FLOW_IMP_PARSER.CREATE_WS_SEC_VIOLATION'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha encontrado una segunda llamada create_company durante la instalaci\00F3n del espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99647767445304255)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_BLOCK'
,p_message_language=>'es'
,p_message_text=>'Error GET_BLOCK. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99647632705304254)
,p_name=>'WWV_FLOW_IMP_PARSER.GET_STMT'
,p_message_language=>'es'
,p_message_text=>'Error GET_STMT. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99647812690304255)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_FILE_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el archivo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99513949903304151)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_INSTALL_FILE'
,p_message_language=>'es'
,p_message_text=>unistr('El archivo zip no es v\00E1lido. No se ha encontrado ning\00FAn archivo de manifiesto de instalaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99651299447304257)
,p_name=>'WWV_FLOW_IMP_PARSER.NO_PRIV'
,p_message_language=>'es'
,p_message_text=>'No tiene privilegios en el esquema %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99647597975304254)
,p_name=>'WWV_FLOW_IMP_PARSER.RUN_STMT_ERROR'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La ejecuci\00F3n de la sentencia no se ha realizado correctamente. %0'),
'<pre>%1</pre>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99687526123304283)
,p_name=>'WWV_FLOW_IMP_PARSER.SEC_VIOLATION'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha detectado una llamada de API al procedimiento remove_page en un bloque grande del archivo de exportaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99948804378304486)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_LABEL_EXISTS'
,p_message_language=>'es'
,p_message_text=>'No existe ninguna etiqueta para este elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99565649833304194)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_CONTAINS_WRONG_VERSION'
,p_message_language=>'es'
,p_message_text=>unistr('Hay un problema con el entorno porque los archivos de Application Express no est\00E1n actualizados. Los archivos para la versi\00F3n #LOADED_VERSION# se han cargado, pero se espera %0. Verifique que ha copiado el directorio de im\00E1genes en su servidor de apl')
||unistr('icaciones tal como se indica en la gu\00EDa de instalaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99565567916304194)
,p_name=>'WWV_FLOW_JAVASCRIPT.IMAGES_DIRECTORY_NOT_COPIED'
,p_message_language=>'es'
,p_message_text=>unistr('Hay un problema con el entorno porque no se han cargado los archivos de Application Express. Verifique que ha copiado el directorio de im\00E1genes en su servidor de aplicaciones tal como se indica en la gu\00EDa de instalaci\00F3n. Adem\00E1s, verifique que la ruta')
||unistr(' de acceso de prefijo de imagen es correcta. La ruta de acceso actual es %0 (debe contener barras inclinadas de inicio y finalizaci\00F3n, como el elemento /i/ por defecto). Utilice el script SQL reset_image_prefix.sql si necesita cambiarla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99769175674304343)
,p_name=>'WWV_FLOW_JOB.UNAUTHORIZED_ATTEMPT_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Intento no autorizado para ejecutar el trabajo %0 por el esquema: %1 en la aplicaci\00F3n: %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99779721513304351)
,p_name=>'WWV_FLOW_LOAD_DATA.COLLECTION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la recopilaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99779368730304351)
,p_name=>'WWV_FLOW_LOAD_DATA.ERROR'
,p_message_language=>'es'
,p_message_text=>'error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99779439039304351)
,p_name=>'WWV_FLOW_LOAD_DATA.FIND_DATA_TYPE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de b\00FAsqueda de tipo de dato: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99779693833304351)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_DATATYPE_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al obtener el tipo de dato: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99779533541304351)
,p_name=>'WWV_FLOW_LOAD_DATA.GET_MAX_COL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error 1 al obtener la longitud m\00E1xima de columna: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99967422800304500)
,p_name=>'WWV_FLOW_LOAD_DATA.NO_32KB_INSERT'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido insertar una fila con m\00E1s de 32 KB de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99779821875304351)
,p_name=>'WWV_FLOW_LOOKUP_TABLES.PRIVS_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario %0 no tiene ning\00FAn privilegio en el esquema %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99770852137304345)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.BRANCH_COND_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido actualizar el tipo de condici\00F3n de bifurcaci\00F3n de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99770790997304344)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_BUTTON_COND_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido actualizar el tipo de condici\00F3n del bot\00F3n de p\00E1gina %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99770572882304344)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_COMP_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido actualizar el tipo de c\00E1lculo de aplicaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99770418798304344)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_FLOW_PROC_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido actualizar el proceso de aplicaci\00F3n en caso de tipo de condici\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99771261141304345)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_MISSPELL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error durante la actualizaci\00F3n de las palabras escritas de forma incorrecta. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99770395444304344)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_NAVBAR_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido actualizar el tipo de condici\00F3n de visualizaci\00F3n de la barra de navegaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99770913436304345)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_COMP_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido actualizar el tipo de c\00E1lculo de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99771152171304345)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_PROC_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido actualizar el tipo de proceso de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99770654493304344)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_SUBTITLE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido actualizar el tipo de subt\00EDtulo de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99771049621304345)
,p_name=>'WWV_FLOW_MIGRATE_METADATA.UPDATE_PAGE_VALID_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido actualizar el tipo de validaci\00F3n de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100317796918304804)
,p_name=>'WWV_FLOW_NATIVE_ITEM.AUTOCOMPLETE_RESTRICTION'
,p_message_language=>'es'
,p_message_text=>unistr('%0: S\00F3lo se puede utilizar "Elementos Principales de Lista de Valores en Cascada" si la opci\00F3n "Carga Lenta" est\00E1 definida en S\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100308956721304798)
,p_name=>'WWV_FLOW_NATIVE_ITEM.MULTIPLE_DML_PROCESSES'
,p_message_language=>'es'
,p_message_text=>unistr('Error: Se debe declarar como m\00E1ximo un proceso DML por p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100308807160304798)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_DML_PROCESS_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('Error: No se ha encontrado ning\00FAn proceso DML correspondiente para la p\00E1gina %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100309909154304799)
,p_name=>'WWV_FLOW_NATIVE_ITEM.NO_VALID_BLOB_SOURCE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 debe tener una columna BLOB v\00E1lida como origen.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100270636838304769)
,p_name=>'WWV_FLOW_NATIVE_ITEM.PLSQL_CODE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar un c\00F3digo PL/SQL que emita HTML para el elemento %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99780756982304352)
,p_name=>'WWV_FLOW_PARSER.BULK_COLLECT_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido recopilar en bloque: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99780401418304352)
,p_name=>'WWV_FLOW_PARSER.CHECK_CODE_PARSE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido comprobar si el c\00F3digo se ha analizado o no: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99780532236304352)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido ejecutar el archivo de control: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99781242480304352)
,p_name=>'WWV_FLOW_PARSER.CONTROL_FILE_STATS_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se han podido comprobar las estad\00EDsticas del archivo de control: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99781135471304352)
,p_name=>'WWV_FLOW_PARSER.DELETE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido suprimir la informaci\00F3n analizada: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99781038398304352)
,p_name=>'WWV_FLOW_PARSER.EXECUTION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('La ejecuci\00F3n de la sentencia no se ha realizado correctamente: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99779963225304351)
,p_name=>'WWV_FLOW_PARSER.FIND_FILE_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el archivo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99780127080304351)
,p_name=>'WWV_FLOW_PARSER.GET_STATEMENT_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido obtener la sentencia: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99746251953304327)
,p_name=>'WWV_FLOW_PARSER.LINE_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>unistr('La longitud de l\00EDnea %0 excede el m\00E1ximo de %1 en la l\00EDnea %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99780959964304352)
,p_name=>'WWV_FLOW_PARSER.PACKAGE_COMP_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: Cuerpo del paquete creado con errores de compilaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99780604520304352)
,p_name=>'WWV_FLOW_PARSER.RUN_CODE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido ejecutar el c\00F3digo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99780852449304352)
,p_name=>'WWV_FLOW_PARSER.RUN_STATEMENT_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido ejecutar la sentencia: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99780299533304351)
,p_name=>'WWV_FLOW_PARSER.SAVE_PARAMETER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido guardar el par\00E1metro en la base de datos: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99780098841304351)
,p_name=>'WWV_FLOW_PARSER.UNABLE_GET_CODE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido obtener el bloque de c\00F3digo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99780343803304351)
,p_name=>'WWV_FLOW_PARSER.VALIDATE_FILE_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido validar el archivo "%0". %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99781313523304352)
,p_name=>'WWV_FLOW_PARSER_PUBLIC.PARSE_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido analizar el archivo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100163769145304688)
,p_name=>'WWV_FLOW_PLUGIN.NO_AUTHENTICATION_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ninguna funci\00F3n de autenticaci\00F3n para el plugin %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100163866667304688)
,p_name=>'WWV_FLOW_PLUGIN.NO_POST_LOGOUT_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ninguna funci\00F3n posterior a la desconexi\00F3n para el plugin %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100163663268304688)
,p_name=>'WWV_FLOW_PLUGIN.NO_SESSION_SENTRY_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ninguna funci\00F3n de protecci\00F3n de sesi\00F3n para el plugin %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100716991767305106)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100716159913305105)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_DEFINED_BY_DA'
,p_message_language=>'es'
,p_message_text=>unistr('Definida por Acci\00F3n Din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100715872560305105)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Redirigir a P\00E1gina en esta Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100716016983305105)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_REDIRECT_URL'
,p_message_language=>'es'
,p_message_text=>'Redirigir a URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100715950787305105)
,p_name=>'WWV_FLOW_PLUGIN_DEV.ACTION_SUBMIT'
,p_message_language=>'es'
,p_message_text=>unistr('Ejecutar P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100716553414305106)
,p_name=>'WWV_FLOW_PLUGIN_DEV.CLEAR_CACHE'
,p_message_language=>'es'
,p_message_text=>unistr('Borrar Cach\00E9')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100268526403304768)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_LEGACY_LOV_SQL'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta de lista de valores no es v\00E1lida. Se necesita un valor de visualizaci\00F3n y otro de retorno. Adem\00E1s, los nombres de columna deben ser diferentes. Si la consulta contiene una consulta en l\00EDnea, la primera cl\00E1usula FROM de la sentencia SQL no')
||unistr(' puede pertenecer a la consulta en l\00EDnea.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100270264228304769)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_REGION_SOURCE_SQL'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo al analizar la consulta de origen de regi\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99651310336304257)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL'
,p_message_language=>'es'
,p_message_text=>'Fallo al analizar la consulta SQL. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100739840682305123)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_SQL_SIMPLE'
,p_message_language=>'es'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100268628896304768)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_STATIC_LOV'
,p_message_language=>'es'
,p_message_text=>unistr('La lista de valores est\00E1tica no es v\00E1lida, se necesita un valor de visualizaci\00F3n y un valor de retorno.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100204213907304719)
,p_name=>'WWV_FLOW_PLUGIN_DEV.INVALID_TABLE'
,p_message_language=>'es'
,p_message_text=>unistr('La tabla, vista o sin\00F3nimo no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99650850532304257)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_OPTIONAL'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100268951563304768)
,p_name=>'WWV_FLOW_PLUGIN_DEV.LOV_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar la consulta de lista de valores y la lista de valores con nombre para los elementos de este tipo de visualizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100268840701304768)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NAMED_LOV_NOT_ALLOWED'
,p_message_language=>'es'
,p_message_text=>unistr('El uso de una lista de valores denominada s\00F3lo est\00E1 soportado para tipos de elementos que requieran al menos dos columnas de lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99651587315304257)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_INTEGER'
,p_message_language=>'es'
,p_message_text=>'El valor debe ser un entero.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99651476316304257)
,p_name=>'WWV_FLOW_PLUGIN_DEV.NO_NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('El valor debe ser num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100716246801305105)
,p_name=>'WWV_FLOW_PLUGIN_DEV.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99577141080304203)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>'El tipo de dato de la columna es incorrecto. Este atributo necesita que el tipo de dato de la columna sea uno de los siguientes: %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99565401260304194)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('La columna no existe o la consulta de origen de regi\00F3n no es v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99577245947304203)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_COLUMN_WRONG_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>'tipo de dato incorrecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100269873853304769)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar un origen de regi\00F3n para las regiones con este tipo de regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100269923503304769)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de columna "%0" ya se ha utilizado en la consulta de origen de regi\00F3n. Aseg\00FArese de que utiliza nombres de alias \00FAnicos para sus columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100270059929304769)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_INVALID_COLUMN_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de columna "%0" no es v\00E1lido para la columna de origen de regi\00F3n. Aseg\00FArese de que utiliza nombres de alias \00FAnicos para sus columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100270161963304769)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REGION_SOURCE_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha seleccionado un n\00FAmero de columnas incorrecto en la consulta de origen de regi\00F3n. Consulte los ejemplos de sentencias v\00E1lidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100716437118305106)
,p_name=>'WWV_FLOW_PLUGIN_DEV.REQUEST'
,p_message_language=>'es'
,p_message_text=>'Solicitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100716382195305106)
,p_name=>'WWV_FLOW_PLUGIN_DEV.RESET_PAGINATION'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer paginaci\00F3n para esta p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100716659441305106)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SET_THESE_ITEMS'
,p_message_language=>'es'
,p_message_text=>'Defina estos elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100269522997304769)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_COLUMN_NOT_UNIQUE'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de columna "%0" ya se ha utilizado en la consulta SQL. Aseg\00FArese de que utiliza nombres de alias \00FAnicos para sus columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100269485483304768)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_INVALID_COLUMN_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de columna "%0" no es v\00E1lido para la consulta SQL. Aseg\00FArese de que utiliza nombres de alias \00FAnicos para sus columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99652452811304258)
,p_name=>'WWV_FLOW_PLUGIN_DEV.SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero de columnas seleccionadas en la consulta SQL  no es correcto. Consulte la ayuda del atributo para obtener m\00E1s informaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100268734587304768)
,p_name=>'WWV_FLOW_PLUGIN_DEV.STATIC_LOV_NOT_ALLOWED'
,p_message_language=>'es'
,p_message_text=>unistr('La lista de valores est\00E1tica s\00F3lo est\00E1 soportada para tipos de elementos que requieran al menos dos columnas de lista de valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100716841965305106)
,p_name=>'WWV_FLOW_PLUGIN_DEV.URL_TARGET'
,p_message_language=>'es'
,p_message_text=>'Destino de URL'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100716772978305106)
,p_name=>'WWV_FLOW_PLUGIN_DEV.WITH_THESE_VALUES'
,p_message_language=>'es'
,p_message_text=>'Con estos valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99771443564304345)
,p_name=>'WWV_FLOW_POPUP_LOV.CONVERT_ID_ERR'
,p_message_language=>'es'
,p_message_text=>'ERR-1711: No se puede convertir el identificador de lista de valores emergente en la solicitud.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99771570076304345)
,p_name=>'WWV_FLOW_POPUP_LOV.FIND_ITEM_ERR'
,p_message_language=>'es'
,p_message_text=>'ERR-1721: No se ha encontrado el elemento para el identificador de lista de valores emergente en la solicitud.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99545306601304178)
,p_name=>'WWV_FLOW_PRINT_UTIL.INVALID_PROXY_URL'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido acceder al motor de impresi\00F3n debido a que la direcci\00F3n URL especificada es incorrecta o a que se debe especificar una direcci\00F3n URL de proxy.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100449995847304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.ABOVE_BOX'
,p_message_language=>'es'
,p_message_text=>unistr('Encima de la Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100450330059304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BELOW_BOX'
,p_message_language=>'es'
,p_message_text=>unistr('Debajo de la Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100450440524304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.BOTTOM'
,p_message_language=>'es'
,p_message_text=>unistr('Parte Inferior de la Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100450022751304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.LEFT_OF_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Izquierda del T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100449632533304903)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_IR_SEARCH_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de B\00FAsqueda a la Derecha del Informe Interactivo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100450108807304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.RIGHT_OF_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Derecha del T\00EDtulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100450268949304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TEMPLATE_DEFAULT'
,p_message_language=>'es'
,p_message_text=>unistr('Valor por Defecto de Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100449760412304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP'
,p_message_language=>'es'
,p_message_text=>unistr('Parte Superior de la Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100449844490304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.BP.TOP_AND_BOTTOM'
,p_message_language=>'es'
,p_message_text=>unistr('Partes Superior e Inferior de la Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100450593856304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.AFTER_HEADER'
,p_message_language=>'es'
,p_message_text=>unistr('Despu\00E9s de Cabecera')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100450678082304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.DP.BEFORE_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Antes de Pie de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100673133615305070)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado el componente. Puede que lo haya suprimido otro usuario. Recargue la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100673031963305070)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED'
,p_message_language=>'es'
,p_message_text=>'No se puede suprimir porque el componente ''%0'' hace referencia a este componente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100672932325305070)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.COMPONENT_REFERENCED_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede suprimir porque el componente ''%0'' de la p\00E1gina %1 hace referencia a este componente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100673254171305070)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_CHANGED'
,p_message_language=>'es'
,p_message_text=>unistr('Otro usuario ya ha cambiado este atributo. Recargue la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100673457662305070)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('El atributo no est\00E1 disponible en este contexto.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100673382989305070)
,p_name=>'WWV_FLOW_PROPERTY_DEV.ERROR.PROPERTY_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('Otro usuario ya ha cambiado el componente y este atributo ya no existe. Recargue la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100167653547304691)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_FUNCTION'
,p_message_language=>'es'
,p_message_text=>'Analizando los resultados de consulta devueltos en "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100760226222305138)
,p_name=>'WWV_FLOW_PROPERTY_DEV.INVALID_SQL_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('El an\00E1lisis de la consulta devuelta ha dado como resultado "%0". Si cree que la consulta es sint\00E1cticamente correcta, active la casilla de control "Usar Nombres de Columna Gen\00E9ricos" para continuar sin el an\00E1lisis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100711680204305102)
,p_name=>'WWV_FLOW_PROPERTY_DEV.MUST_BE_UNIQUE'
,p_message_language=>'es'
,p_message_text=>unistr('Debe ser \00FAnico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100450762393304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NO_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'Sin Plantilla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100167520615304691)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'es'
,p_message_text=>'El bloque PL/SQL no ha devuelto ninguna consulta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100760352425305138)
,p_name=>'WWV_FLOW_PROPERTY_DEV.NULL_QUERY_RETURNED_BY_REGION_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Ning\00FAn bloque pl/sql ha devuelto consultas. Si cree que el c\00F3digo es sint\00E1cticamente correcto, active la casilla de control "Usar Nombres de Columna Gen\00E9ricos" para continuar sin el an\00E1lisis.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100450920974304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina bloqueada por otro usuario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100450857570304904)
,p_name=>'WWV_FLOW_PROPERTY_DEV.PAGE_LOCKED_SAVE_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('La p\00E1gina est\00E1 bloqueada actualmente por %0. No se ha podido guardar ning\00FAn cambio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100057887284304568)
,p_name=>'WWV_FLOW_PROVISION.CANNOT_EXTEND_TS'
,p_message_language=>'es'
,p_message_text=>'No se ha podido ampliar el tablespace porque ya no existen esquemas para %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99771629734304345)
,p_name=>'WWV_FLOW_PROVISION.DROP_TABLESPACE_ERR'
,p_message_language=>'es'
,p_message_text=>'El error en drop_tablespace p_name es nulo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99771833515304345)
,p_name=>'WWV_FLOW_PROVISION.DROP_USER_ERR'
,p_message_language=>'es'
,p_message_text=>'Error en drop_user no l_username.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100767223876305144)
,p_name=>'WWV_FLOW_PROVISION.ENCRYPTION_WALLET_NOT_OPEN'
,p_message_language=>'es'
,p_message_text=>unistr('La cartera de cifrado no est\00E1 abierta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99570481641304197)
,p_name=>'WWV_FLOW_PROVISION.ILLEGAL_PASSWORD'
,p_message_language=>'es'
,p_message_text=>unistr('Cadena de contrase\00F1a ilegal transferida a wwv_flow_provision.create_user.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99772461125304346)
,p_name=>'WWV_FLOW_PROVISION.REMOVE_COMPANY_ERR'
,p_message_language=>'es'
,p_message_text=>'Error en remove_provisioned_company. El espacio de trabajo es nulo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99772267815304346)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_TABLESPACE_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear el tablespace. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99772132658304345)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_CREATE_USER_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear el usuario. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99771724337304345)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_TABLESPACE_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido borrar el tablespace. Error: %0 \nsql:\n %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99771936212304345)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_DROP_USER_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido borrar el usuario. Error: %0 \nsql:\n %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99772370428304346)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_GRANT_PRIVS_ERR'
,p_message_language=>'es'
,p_message_text=>'No se han podido otorgar los privilegios iniciales. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99536660869304168)
,p_name=>'WWV_FLOW_PROVISION.UNABLE_TO_CREATE_TABLESPACE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear el tablespace en este momento. Vuelva a intentarlo m\00E1s tarde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99772042538304345)
,p_name=>'WWV_FLOW_PROVISION.WITH_ERR'
,p_message_language=>'es'
,p_message_text=>'Error con %0 %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99615048574304230)
,p_name=>'WWV_FLOW_PROVISIONING.AUTO_PROVISION_FAILURE'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de provisionamiento autom\00E1tico durante la fase "MAKE_REQUEST"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99634618661304245)
,p_name=>'WWV_FLOW_PROVISIONING.CANNOT_FIND_SGID'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'No se ha podido determinar el identificador de grupo de seguridad para el identificador de espacio de trabajo especificado= "%0"',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99615317207304231)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_RESERVED'
,p_message_language=>'es'
,p_message_text=>'El espacio de trabajo %0 es un nombre reservado, se ha denegado la solicitud'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99615109041304230)
,p_name=>'WWV_FLOW_PROVISIONING.COMPANY_USER_ADD'
,p_message_language=>'es'
,p_message_text=>'Se ha producido un error al agregar el usuario al espacio de trabajo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99772798269304346)
,p_name=>'WWV_FLOW_PROVISIONING.ERROR'
,p_message_language=>'es'
,p_message_text=>'error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99754505481304333)
,p_name=>'WWV_FLOW_PROVISIONING.NOT_IMPLEMENTED'
,p_message_language=>'es'
,p_message_text=>'No implementado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99614891128304230)
,p_name=>'WWV_FLOW_PROVISIONING.NO_COMPANY'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn espacio de trabajo con el identificador de espacio de trabajo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99614902757304230)
,p_name=>'WWV_FLOW_PROVISIONING.NO_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha asignado ning\00FAn esquema para el identificador de espacio de trabajo: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99634712956304245)
,p_name=>'WWV_FLOW_PROVISIONING.REMOVE_LAST_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('No puede utilizar esta funci\00F3n para eliminar el \00FAltimo esquema de un espacio de trabajo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99615774366304231)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado la solicitud %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99615557200304231)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_NOT_PROCESSED'
,p_message_language=>'es'
,p_message_text=>'La solicitud %0 no se ha podido procesar.  %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99615250778304230)
,p_name=>'WWV_FLOW_PROVISIONING.REQUEST_PROCESSED'
,p_message_language=>'es'
,p_message_text=>unistr('Esta solicitud se ha procesado o se est\00E1 procesando. El estado debe ser igual a "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99635051505304245)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_COMPANY'
,p_message_language=>'es'
,p_message_text=>'El nombre de usuario %0 no existe en el espacio de trabajo %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99634975427304245)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_NOT_IN_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('No est\00E1 permitido el restablecimiento de la contrase\00F1a para un esquema que no est\00E1 asociado al espacio de trabajo.  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99634861933304245)
,p_name=>'WWV_FLOW_PROVISIONING.RESET_PASSWORD_RESERVED_SCHEMA'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido restablecer la contrase\00F1a para el esquema %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99615629566304231)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_EXISTS'
,p_message_language=>'es'
,p_message_text=>'La solicitud %0 no se ha podido procesar ya que el esquema %1 existe en la tabla %2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99615416757304231)
,p_name=>'WWV_FLOW_PROVISIONING.SCHEMA_RESERVED'
,p_message_language=>'es'
,p_message_text=>'El nombre de esquema %0 es un esquema reservado y no se puede proporcionar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99614703519304230)
,p_name=>'WWV_FLOW_PROVISIONING.USER_NO_PRIVILEGES'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'El usuario %0 no tiene privilegios en el esquema %1.',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99574770074304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYSIS'
,p_message_language=>'es'
,p_message_text=>unistr('An\00E1lisis de %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99577571178304203)
,p_name=>'WWV_FLOW_QUICK_FLOW.ANALYZE'
,p_message_language=>'es'
,p_message_text=>'Analizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99560468443304190)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_DBACCOUNT'
,p_message_language=>'es'
,p_message_text=>'Utilice las credenciales de la cuenta de base de datos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99591590087304213)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_INTERNAL'
,p_message_language=>'es'
,p_message_text=>unistr('Utilice las credenciales de la cuenta interna %0 y la p\00E1gina de conexi\00F3n en esta aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100270830549304770)
,p_name=>'WWV_FLOW_QUICK_FLOW.AUTH_SCHEME_DESC_SSO'
,p_message_language=>'es'
,p_message_text=>'Utilice Oracle Application Server Single Sign-On.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99574885907304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico de %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99574641756304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.CHOOSE_A_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99576849545304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.CLEAR_CACHE_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido borrar la cach\00E9.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100654498667305055)
,p_name=>'WWV_FLOW_QUICK_FLOW.COLUMN_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'#COLUMN_HEADER# debe tener un valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99604936329304223)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_ANALYZE_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de an\00E1lisis. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99623132532304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_BUTTON_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la plantilla de bot\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99623976188304237)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_CHART_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99622538297304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_FLOW'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99624376585304237)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_HOME_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina inicial. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99623705499304237)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_INSERT_FORM'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la pantalla de inserci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99622742730304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LABEL_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear la plantilla de etiqueta. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99624440308304237)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear la lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99624559874304237)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_ITEM'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear el elemento de lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99622497842304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_LIST_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear la plantilla de lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99623575667304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la ruta de navegaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99623037286304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MENU_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la plantilla de ruta de navegaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99624902904304237)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_MODULES'
,p_message_language=>'es'
,p_message_text=>unistr('No se han podido crear los m\00F3dulos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99623474786304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NAVBAR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la barra de navegaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99575054853304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW'
,p_message_language=>'es'
,p_message_text=>'Crear Nuevo %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99577723431304203)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_NEW2'
,p_message_language=>'es'
,p_message_text=>'Crear Nuevo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99622677416304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_PAGE_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la plantilla de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99622976044304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REGION_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la plantilla de regi\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99623620136304237)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de informe. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99622816263304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_REPORT_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear la plantilla de informe. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99624624016304237)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_SUCCESS_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina correcta. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99623352494304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('No se han podido crear los separadores est\00E1ndar. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99623851153304237)
,p_name=>'WWV_FLOW_QUICK_FLOW.CREATE_UPDATE_FORM'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la pantalla de actualizaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99576787567304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.CSV_LINK'
,p_message_language=>'es'
,p_message_text=>unistr('Hoja de C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100654636424305055)
,p_name=>'WWV_FLOW_QUICK_FLOW.DATE_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('#COLUMN_HEADER# debe ser una fecha v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99624788289304237)
,p_name=>'WWV_FLOW_QUICK_FLOW.DEFINE_DEFAULT_TEMPLATES'
,p_message_language=>'es'
,p_message_text=>unistr('Defina las plantillas por defecto para crear la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99579225313304204)
,p_name=>'WWV_FLOW_QUICK_FLOW.DISPLAY_REGION_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido mostrar la regi\00F3n de p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99576256595304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.HELP_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina muestra ayuda para una p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99576580887304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT'
,p_message_language=>'es'
,p_message_text=>'Insertar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99574979289304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT FORM'
,p_message_language=>'es'
,p_message_text=>'Insertar Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99575744300304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ANOTHER'
,p_message_language=>'es'
,p_message_text=>'Insertar Otro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99577026502304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido insertar una fila en %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99575605524304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.INSERT_SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Los datos se han insertado correctamente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100038876006304554)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser una fecha v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99575429994304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_NUM'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser un n\00FAmero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99975055695304505)
,p_name=>'WWV_FLOW_QUICK_FLOW.IS_TIMESTAMP'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser un registro de hora v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99576405890304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Ruta de navegaci\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99575322448304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.NOT_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('%0 debe tener alg\00FAn valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100654565543305055)
,p_name=>'WWV_FLOW_QUICK_FLOW.NUMERIC_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('#COLUMN_HEADER# debe ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99623287403304236)
,p_name=>'WWV_FLOW_QUICK_FLOW.POPUP_LOV_TEMPLATE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear la plantilla de lista de valores emergente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99577665700304203)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_AND_EDIT'
,p_message_language=>'es'
,p_message_text=>'Informe y Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99576689135304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.REPORT_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido mostrar el informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99576929056304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.RESET_PAGINATION_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido restablecer la paginaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99575987391304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_HOME'
,p_message_language=>'es'
,p_message_text=>unistr('Volver a P\00E1gina Inicial')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99576390226304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.RETURN_PREV_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Volver a la P\00E1gina Anterior')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99574470103304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100691582214305087)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'
,p_message_language=>'es'
,p_message_text=>'Buscar Todas las Aplicaciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100690784994305086)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.APPS'
,p_message_language=>'es'
,p_message_text=>unistr('Buscar Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100690591230305086)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.TEAM.DEV'
,p_message_language=>'es'
,p_message_text=>'Buscar Desarrollo de Equipos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100691295530305087)
,p_name=>'WWV_FLOW_QUICK_FLOW.SEARCH.USERS'
,p_message_language=>'es'
,p_message_text=>'Buscar Usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99574589404304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_CHART_BY'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar Gr\00E1fico por')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99578925040304204)
,p_name=>'WWV_FLOW_QUICK_FLOW.SHOW_MENU_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido mostrar la ruta de navegaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99576026561304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS'
,p_message_language=>'es'
,p_message_text=>'Correcto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99575536694304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.SUCCESS_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Correcta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100654732271305055)
,p_name=>'WWV_FLOW_QUICK_FLOW.TIMESTAMP_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('#COLUMN_HEADER# debe ser un valor de registro de hora v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99575279412304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE'
,p_message_language=>'es'
,p_message_text=>'Actualizar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99575195270304201)
,p_name=>'WWV_FLOW_QUICK_FLOW.UPDATE_FORM'
,p_message_language=>'es'
,p_message_text=>'Actualizar Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99624873748304237)
,p_name=>'WWV_FLOW_QUICK_FLOW.USE_ONE_LEVEL_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo puede crear la aplicaci\00F3n utilizando un separador de nivel.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99575830919304202)
,p_name=>'WWV_FLOW_QUICK_FLOW.VIEW_REPORT'
,p_message_language=>'es'
,p_message_text=>'Ver Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99605974412304224)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ABOUT'
,p_message_language=>'es'
,p_message_text=>'Acerca de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99606091611304224)
,p_name=>'WWV_FLOW_REGION_LAYOUT.BRANCHING'
,p_message_language=>'es'
,p_message_text=>unistr('Bifurcaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99770284791304344)
,p_name=>'WWV_FLOW_REGION_LAYOUT.ERROR'
,p_message_language=>'es'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99596256484304216)
,p_name=>'WWV_FLOW_REGION_NATIVE.JQM_LIST_VIEW.NESTED_LIST_CLIENT_SEARCH_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('Una lista anidada s\00F3lo soporta "Cliente" como tipo de b\00FAsqueda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99758382675304336)
,p_name=>'WWV_FLOW_REGION_TREE.UNEXPECTED_ERR'
,p_message_language=>'es'
,p_message_text=>'Error inesperado %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99741965398304324)
,p_name=>'WWV_FLOW_REGION_TREES.ROOT_NOT_FND_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: No se ha encontrado el identificador de ra\00EDz del \00E1rbol "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99954257624304490)
,p_name=>'WWV_FLOW_REMOTE_EXEC.RUN_PLSQL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error en el c\00F3digo PLSQL provocado durante el procesamiento remoto de SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99514262273304152)
,p_name=>'WWV_FLOW_REPORT_DEV.CREATE_CARDS_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de tarjetas. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100096014893304598)
,p_name=>'WWV_FLOW_REST.NOT_ENABLED'
,p_message_language=>'es'
,p_message_text=>unistr('El acceso completo a REST no est\00E1 activado para esta instancia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100094307173304597)
,p_name=>'WWV_FLOW_REST.NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la regi\00F3n o no se ha activado REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100094456860304597)
,p_name=>'WWV_FLOW_REST.NO_OUTPUT'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha especificado ning\00FAn m\00E9todo de salida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99744905858304326)
,p_name=>'WWV_FLOW_SECURITY.COMPANY_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Espacio de trabajo necesario.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99745080394304326)
,p_name=>'WWV_FLOW_SECURITY.FLOW_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n necesaria.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99745117946304326)
,p_name=>'WWV_FLOW_SECURITY.INVALID_USER_PASS'
,p_message_language=>'es'
,p_message_text=>unistr('Nombre de usuario "%0" o contrase\00F1a no v\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99974451785304505)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.INSERTED'
,p_message_language=>'es'
,p_message_text=>unistr('Se han insertado %0 nuevos atributos que pueden necesitar traducci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99974563338304505)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.PURGED'
,p_message_language=>'es'
,p_message_text=>unistr('Se han depurado %0 atributos que no necesitan traducci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99606804282304224)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_DELETE_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de extracci\00F3n al suprimir: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99606758724304224)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.SEED_INSERT_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de extracci\00F3n al insertar: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99974669928304505)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TOTAL'
,p_message_language=>'es'
,p_message_text=>unistr('Un total de %0 atributos pueden necesitar traducci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99606624361304224)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.TRANSLATION_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la traducci\00F3n %0 de la aplicaci\00F3n %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99974371540304505)
,p_name=>'WWV_FLOW_SEED_TRANSLATIONS.UPDATED'
,p_message_language=>'es'
,p_message_text=>unistr('Se han actualizado %0 atributos existentes que pueden necesitar traducci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99781427456304352)
,p_name=>'WWV_FLOW_SERIES_ATTR.ERROR'
,p_message_language=>'es'
,p_message_text=>'error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100044820583304558)
,p_name=>'WWV_FLOW_SESSION_MON.NO_INDEX'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ning\00FAn \00EDndice en %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99975501252304506)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_INCOMPLETE'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos de la recopilaci\00F3n <code>%0</code> se han agregado con <b id="incompl_success_row_count"></b> nuevos documentos. <b class="u-danger-text" id="incompl_fail_row_count"></b> documentos rechazados.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99975370339304506)
,p_name=>'WWV_FLOW_SODA_DEV.APPEND_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos de la recopilaci\00F3n <code>%0</code> se han agregado a <b id="success_row_count"></b> nuevos documentos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99513321366304151)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT'
,p_message_language=>'es'
,p_message_text=>'Contenido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99975779347304506)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CONTENT_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99513539503304151)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_CREATED'
,p_message_language=>'es'
,p_message_text=>'Creado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99513238771304151)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_KEY'
,p_message_language=>'es'
,p_message_text=>'Clave'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99513660895304151)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_LASTMODIFIED'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de Modificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99513435891304151)
,p_name=>'WWV_FLOW_SODA_DEV.COLLECTION_COL_MEDIA_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Medio F\00EDsico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99518661865304155)
,p_name=>'WWV_FLOW_SODA_DEV.DATA_GUIDE_NOT_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('La gu\00EDa de datos no est\00E1 disponible. Puede que la recopilaci\00F3n no contenga ning\00FAn dato o que todav\00EDa no se haya creado ning\00FAn \00EDndice de b\00FAsqueda JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99512532280304150)
,p_name=>'WWV_FLOW_SODA_DEV.FILE_FORMATS'
,p_message_language=>'es'
,p_message_text=>'Cargue archivos JSON, TXT o ZIP.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99518710828304155)
,p_name=>'WWV_FLOW_SODA_DEV.META_DATA_NOT_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('La recopilaci\00F3n de metadatos no est\00E1 disponible. Compruebe el nombre de la recopilaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99975615199304506)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_INCOMPLETE'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos de la recopilaci\00F3n <code>%0</code> se han sustituido con <b id="incompl_success_row_count"></b> nuevos documentos. <b class="u-danger-text" id="incompl_fail_row_count"></b> documentos rechazados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99975488261304506)
,p_name=>'WWV_FLOW_SODA_DEV.REPLACE_SUCCESS'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos de la recopilaci\00F3n <code>%0</code> se han sustituido con <b id="success_row_count"></b> nuevos documentos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99759222055304336)
,p_name=>'WWV_FLOW_SVG.AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: El intervalo del eje debe ser mayor que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99759070312304336)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: El m\00E1ximo del eje debe ser mayor que el m\00EDnimo del eje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99759436964304336)
,p_name=>'WWV_FLOW_SVG.AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: El m\00E1ximo del eje debe ser mayor que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99759327231304336)
,p_name=>'WWV_FLOW_SVG.AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: El m\00EDnimo del eje debe ser mayor o igual que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99759113681304336)
,p_name=>'WWV_FLOW_SVG.BAR_WIDTH_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: El ancho de la barra debe ser mayor que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99758715667304336)
,p_name=>'WWV_FLOW_SVG.ERROR'
,p_message_language=>'es'
,p_message_text=>'error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99760799461304337)
,p_name=>'WWV_FLOW_SVG.FETCH_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de recuperaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99760555985304337)
,p_name=>'WWV_FLOW_SVG.FUNC_RET_SQL_QRY_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n que devuelve una consulta SQL: La consulta no se puede analizar en Creador de Aplicaciones. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99759604836304336)
,p_name=>'WWV_FLOW_SVG.GAPS_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: Los intervalos entre barras deben ser mayores o iguales que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99758862575304336)
,p_name=>'WWV_FLOW_SVG.MAX_ROWS_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: El m\00E1ximo de filas para mostrar debe ser mayor que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99761012347304337)
,p_name=>'WWV_FLOW_SVG.MORE_DATA_FND_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Se han encontrado m\00E1s datos, pero s\00F3lo se pueden mostrar 30.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99760697543304337)
,p_name=>'WWV_FLOW_SVG.PARSE_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de an\00E1lisis: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99760976431304337)
,p_name=>'WWV_FLOW_SVG.SVG_CHART_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de gr\00E1fico SVG: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99760854888304337)
,p_name=>'WWV_FLOW_SVG.UNABLE_CALC_GRAPH_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido calcular la posici\00F3n de la variable de gr\00E1fico: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99760475781304337)
,p_name=>'WWV_FLOW_SVG.UNABLE_GET_COLOR_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido obtener el color: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99759808234304337)
,p_name=>'WWV_FLOW_SVG.X_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: El intervalo del eje X debe ser mayor que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99760207828304337)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de validaci\00F3n: El m\00E1ximo del eje X debe ser mayor que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99760007948304337)
,p_name=>'WWV_FLOW_SVG.X_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: El m\00EDnimo del eje X debe ser mayor o igual que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99759981222304337)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_INT_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: El intervalo del eje Y debe ser mayor que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99759739033304337)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_MIN_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: El m\00E1ximo del eje Y debe ser mayor que el m\00EDnimo del eje.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99760348038304337)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MAX_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de validaci\00F3n: El m\00E1ximo del eje Y debe ser mayor que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99760146724304337)
,p_name=>'WWV_FLOW_SVG.Y_AXIS_MIN_GT_ZERO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de Validaci\00F3n: El m\00EDnimo del eje Y debe ser mayor o igual que cero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99756935984304335)
,p_name=>'WWV_FLOW_SW_API.ADD_MEMBER_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al agregar el miembro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99561188792304190)
,p_name=>'WWV_FLOW_SW_API.CANNOT_RUN_CMD'
,p_message_language=>'es'
,p_message_text=>'%0 comandos bloqueados. No se pueden ejecutar desde el Taller de SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99753813538304332)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario %0 no tiene ning\00FAn privilegio en el esquema %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99573891821304200)
,p_name=>'WWV_FLOW_SW_API.CHECK_PRIV_OBJ'
,p_message_language=>'es'
,p_message_text=>'El esquema %0 no tiene el privilegio SELECT en la tabla o vista %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99757138780304335)
,p_name=>'WWV_FLOW_SW_API.CREATE_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al crear el script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99753968723304332)
,p_name=>'WWV_FLOW_SW_API.CREATE_PLAN_TABLE'
,p_message_language=>'es'
,p_message_text=>unistr('tabla del plan creada para facilitar la sentencia del plan de explicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99754419006304333)
,p_name=>'WWV_FLOW_SW_API.CREATE_SCRIPT_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al crear el script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99754095504304332)
,p_name=>'WWV_FLOW_SW_API.ERROR_MSG'
,p_message_language=>'es'
,p_message_text=>unistr('Error en la l\00EDnea %0: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99754225829304333)
,p_name=>'WWV_FLOW_SW_API.INSERT_SCRIPT_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al insertar el script en la tabla de archivos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100702343845305095)
,p_name=>'WWV_FLOW_SW_API.INVALID_ROWID'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador de fila no v\00E1lido:  %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99754332421304333)
,p_name=>'WWV_FLOW_SW_API.PARSE_SCRIPT_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al analizar el script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99754191232304333)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema "%0" no existe en la base de datos. P\00F3ngase en contacto con el administrador del espacio de trabajo para definir el esquema por defecto correcto para usted.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99554637446304185)
,p_name=>'WWV_FLOW_SW_API.RUN_SQL_ARR'
,p_message_language=>'es'
,p_message_text=>'Error en run_sql_arr. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99757006488304335)
,p_name=>'WWV_FLOW_SW_API.UPDATE_MEMBER_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al actualizar el miembro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99573738188304200)
,p_name=>'WWV_FLOW_SW_PARSER.LINE_EXCEEDS_32K'
,p_message_language=>'es'
,p_message_text=>unistr('La l\00EDnea del script excede los 32767 bytes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99540626112304171)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELED'
,p_message_language=>'es'
,p_message_text=>'Cancelado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99789429622304358)
,p_name=>'WWV_FLOW_SW_SCRIPT.CANCELING'
,p_message_language=>'es'
,p_message_text=>'Cancelando'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99541677966304172)
,p_name=>'WWV_FLOW_SW_SCRIPT.COMPLETED'
,p_message_language=>'es'
,p_message_text=>'Terminado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99542039122304172)
,p_name=>'WWV_FLOW_SW_SCRIPT.ELAPSED'
,p_message_language=>'es'
,p_message_text=>'%0 segundos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99540701013304171)
,p_name=>'WWV_FLOW_SW_SCRIPT.EXECUTING'
,p_message_language=>'es'
,p_message_text=>unistr('En Ejecuci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99599555197304219)
,p_name=>'WWV_FLOW_SW_SCRIPT.INVALID_STMT'
,p_message_language=>'es'
,p_message_text=>'Ha solicitado ejecutar un script que contiene sentencias desconocidas. Elimine las siguientes sentencias.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99541748299304172)
,p_name=>'WWV_FLOW_SW_SCRIPT.IN_PROGRESS'
,p_message_language=>'es'
,p_message_text=>'En Curso'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99599475387304219)
,p_name=>'WWV_FLOW_SW_SCRIPT.LINE_NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99561038761304190)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_NEST_LEVEL'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1004: Los archivos de comandos no se pueden anidar m\00E1s de %0 niveles.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99562348689304191)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_OUTPUT_REACHED'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1005: La salida del script ha alcanzado el l\00EDmite de tama\00F1o m\00E1ximo. Cambie el script de forma que genere menos salida o p\00F3ngase en contacto con el administrador para aumentar el tama\00F1o m\00E1ximo del resultado del script.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99890513509304440)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_SCRIPT_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('El script excede el tama\00F1o m\00E1ximo permitido de %0 bytes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99562478388304191)
,p_name=>'WWV_FLOW_SW_SCRIPT.MAX_WORKSPACE_OUTPUT_REACHED'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1005: La salida del script ha alcanzado el l\00EDmite de tama\00F1o m\00E1ximo del resultado del espacio de trabajo. Suprima resultados existentes o p\00F3ngase en contacto con el administrador para aumentar el tama\00F1o m\00E1ximo del resultado del espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99825529863304384)
,p_name=>'WWV_FLOW_SW_SCRIPT.NO_STMT_BUFFER'
,p_message_language=>'es'
,p_message_text=>'No hay ninguna sentencia en el buffer para ejecutar.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99556308393304186)
,p_name=>'WWV_FLOW_SW_SCRIPT.QUERY_LIMIT'
,p_message_language=>'es'
,p_message_text=>unistr('La sentencia SELECT no puede ocupar m\00E1s de 32 KB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99541840370304172)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROW'
,p_message_language=>'es'
,p_message_text=>'%0 fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99541912700304172)
,p_name=>'WWV_FLOW_SW_SCRIPT.RESULT_ROWS'
,p_message_language=>'es'
,p_message_text=>'%0 filas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99557298600304187)
,p_name=>'WWV_FLOW_SW_SCRIPT.ROWS_SELECTED'
,p_message_language=>'es'
,p_message_text=>'%0 filas seleccionadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99784559523304355)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_EMPTY'
,p_message_language=>'es'
,p_message_text=>'Ha solicitado ejecutar un script que no contiene ninguna sentencia ejecutable.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99554415198304185)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_FILE_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido ejecutar el script. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99554546140304185)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_STMT_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error en run_statement. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99784478321304354)
,p_name=>'WWV_FLOW_SW_SCRIPT.RUN_WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('Ha solicitado ejecutar un script que contiene sentencias que el Taller de SQL omitir\00E1. Confirme la solicitud.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99560988044304190)
,p_name=>'WWV_FLOW_SW_SCRIPT.SCRIPT_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'ERR-1001: No se ha encontrado el script.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99540549305304171)
,p_name=>'WWV_FLOW_SW_SCRIPT.SUBMITTED'
,p_message_language=>'es'
,p_message_text=>'Ejecutado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99788980652304358)
,p_name=>'WWV_FLOW_SW_SCRIPT.UNKNOWN_STATEMENT'
,p_message_language=>'es'
,p_message_text=>'Sentencia Desconocida'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99788701064304358)
,p_name=>'WWV_FLOW_SW_SCRIPT.USED'
,p_message_language=>'es'
,p_message_text=>'%0% usado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99774430834304347)
,p_name=>'WWV_FLOW_SW_UTIL.PACKAGE_CREATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha producido un fallo en la creaci\00F3n del paquete debido a una sintaxis SQL no v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99774103984304347)
,p_name=>'WWV_FLOW_SW_UTIL.TABLE_CREATE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo en la creaci\00F3n de tabla debido a una sintaxis SQL no v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99607067782304224)
,p_name=>'WWV_FLOW_SYNC_TRANSLATIONS.SYNC_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de sincronizaci\00F3n: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99930586359304472)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCED_BY'
,p_message_language=>'es'
,p_message_text=>'con referencia de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99930409604304471)
,p_name=>'WWV_FLOW_TABLE_DRILL.REFERENCES'
,p_message_language=>'es'
,p_message_text=>'referencias'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99605313379304223)
,p_name=>'WWV_FLOW_TABULAR_FORM.MAX_COLUMN_NO'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha intentado acceder a la columna de formato tabular que se debe asignar a la matriz PL/SQL apex_application.g_f%0, pero solo est\00E1n soportadas %1 columnas que guardan el estado. Reduzca el n\00FAmero de columnas que guardan el estado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100168068029304692)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_PARENT_TAB'
,p_message_language=>'es'
,p_message_text=>'Agregar Nuevo Separador Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99953408486304489)
,p_name=>'WWV_FLOW_TAB_MGR.ADD_NEW_STD_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar Nuevo Separador Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99954079234304490)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET'
,p_message_language=>'es'
,p_message_text=>unistr('Nuevo Juego de Separadores (permite crear un separador est\00E1ndar en un nuevo juego de separadores)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99781758767304352)
,p_name=>'WWV_FLOW_TAB_MGR.NEW_TABSET_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el nuevo juego de separadores para el identificador de separador principal = %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99781636088304352)
,p_name=>'WWV_FLOW_TAB_MGR.OLD_TABSET_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el antiguo juego de separadores para el identificador de separador = %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99781890963304353)
,p_name=>'WWV_FLOW_TAB_MGR.PAGE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('El identificador de p\00E1gina %0 no es un n\00FAmero.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99953583009304489)
,p_name=>'WWV_FLOW_TAB_MGR.PAR_TAB'
,p_message_language=>'es'
,p_message_text=>'Separador Principal. Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99953928279304490)
,p_name=>'WWV_FLOW_TAB_MGR.PSEDUO_DESC'
,p_message_language=>'es'
,p_message_text=>unistr('no est\00E1 asociado a un separador principal. Se muestra como separador pseudoprincipal para que pueda editar los separadores est\00E1ndar de este juego de separadores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99954156348304490)
,p_name=>'WWV_FLOW_TAB_MGR.SELECT_STD_TAB'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccionar Separador Est\00E1ndar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99953772186304489)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PAR_TAB'
,p_message_language=>'es'
,p_message_text=>'Separador Principal Seleccionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99953610184304489)
,p_name=>'WWV_FLOW_TAB_MGR.SEL_PSD_PAR'
,p_message_language=>'es'
,p_message_text=>'Separador Pseudoprincipal Seleccionado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99781519634304352)
,p_name=>'WWV_FLOW_TAB_MGR.SGID_ERR'
,p_message_language=>'es'
,p_message_text=>'Se debe definir el identificador de grupo de seguridad.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99781934152304353)
,p_name=>'WWV_FLOW_TAB_MGR.SPEC_NEW_TABSET_ERR'
,p_message_language=>'es'
,p_message_text=>'Debe especificar un nuevo juego de separadores para el identificador de separador = %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99953335365304489)
,p_name=>'WWV_FLOW_TAB_MGR.STD_TAB_SEQ'
,p_message_language=>'es'
,p_message_text=>unistr('Separador Est\00E1ndar. Secuencia')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99953269608304489)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_ALSO_CUR_FOR_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Separador tambi\00E9n Actual para P\00E1ginas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99953128754304489)
,p_name=>'WWV_FLOW_TAB_MGR.TAB_CUR_FOR_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Separador Actual para P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99953833390304490)
,p_name=>'WWV_FLOW_TAB_MGR.THE_TAB_SET'
,p_message_language=>'es'
,p_message_text=>'Juego de Separadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99608230925304225)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la plantilla de bot\00F3n (%0) en la aplicaci\00F3n "%1" del espacio de trabajo "%2" para copiar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99609106668304226)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.BUTTON_TEMPLATE_REPLACE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido sustituir la plantilla de bot\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99774634716304347)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.ERROR'
,p_message_language=>'es'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99607925101304225)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la plantilla de campo (%0) en la aplicaci\00F3n "%1" del espacio de trabajo "%2" para copiar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99608808220304226)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.FIELD_TEMPLATE_REPLACE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido sustituir la plantilla de campo. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99608738821304226)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.LIST_TEMPLATE_REPLACE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido sustituir la plantilla de lista. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99608119609304225)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la plantilla de ruta de navegaci\00F3n (%0) en la aplicaci\00F3n "%1" del espacio de trabajo "%2" para copiar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99608933783304226)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.MENU_TEMPLATE_REPLACE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido sustituir la plantilla de ruta de navegaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99608458831304225)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.PAGE_TEMPLATE_REPLACE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido sustituir la plantilla de p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99609097201304226)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_LOV_TEMPLATE_REPLACE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido sustituir la plantilla de lista de valores emergente. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99891480484304441)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.POPUP_TEMPLATE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la plantilla de ventana emergente (%0) en la aplicaci\00F3n "%1" del espacio de trabajo "%2" para copiar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99608507471304226)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REGION_TEMPLATE_REPLACE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido sustituir la plantilla de regi\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99608601707304226)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.REPORT_TEMPLATE_REPLACE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido sustituir la plantilla de informe. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99607853385304225)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado la plantilla (%0) para copiar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99608341271304225)
,p_name=>'WWV_FLOW_TEMPLATES_UTIL.TEMPLATE_REPLACE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido sustituir la plantilla de %0. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100721321809305109)
,p_name=>'WWV_FLOW_THEME.STYLE_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'El estilo de tema no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100738874868305122)
,p_name=>'WWV_FLOW_THEME_DEV.IS_READ_ONLY'
,p_message_language=>'es'
,p_message_text=>'No se puede actualizar el estilo. Es de solo lectura.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100738708896305122)
,p_name=>'WWV_FLOW_THEME_DEV.WWV_FLOW_THEME_STYLE_UK'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre ya lo est\00E1 utilizando un estilo existente.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99606979588304224)
,p_name=>'WWV_FLOW_TRANSLATIONS.SEED_UPDATE_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error de extracci\00F3n al actualizar: %0.%1 %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100055907401304567)
,p_name=>'WWV_FLOW_UPGRADE.METADATA_DML_DISABLED'
,p_message_language=>'es'
,p_message_text=>unistr('Application Express se est\00E1 cambiando a una versi\00F3n m\00E1s reciente. Los cambios en las aplicaciones estar\00E1n desactivados hasta que el cambio de versi\00F3n haya finalizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99719140313304307)
,p_name=>'WWV_FLOW_UTILITIES.ADD'
,p_message_language=>'es'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99524448092304159)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n %0 no se ha encontrado conectada como usuario de base de datos %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99524590237304159)
,p_name=>'WWV_FLOW_UTILITIES.APPLICATION_PAGE_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n %0 p\00E1gina %1 no se ha encontrado conectada como usuario de base de datos %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99720113816304308)
,p_name=>'WWV_FLOW_UTILITIES.CAL'
,p_message_language=>'es'
,p_message_text=>'Calendario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99748143784304328)
,p_name=>'WWV_FLOW_UTILITIES.CHECKBOX_QUERY_LOV'
,p_message_language=>'es'
,p_message_text=>'Error al evaluar la consulta de la casilla de control: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99720208532304308)
,p_name=>'WWV_FLOW_UTILITIES.CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99747787361304328)
,p_name=>'WWV_FLOW_UTILITIES.DISP_ONLY_LIST_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error: Las listas de valores de s\00F3lo visualizaci\00F3n deben seleccionar dos columnas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99718974104304307)
,p_name=>'WWV_FLOW_UTILITIES.ERR_LOV'
,p_message_language=>'es'
,p_message_text=>'No se ha podido determinar la lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99720574485304308)
,p_name=>'WWV_FLOW_UTILITIES.FIND'
,p_message_language=>'es'
,p_message_text=>'Buscar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99769503774304344)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_POPUP_LOV_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al generar la lista de valores emergente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99747436851304328)
,p_name=>'WWV_FLOW_UTILITIES.GENERATE_QUERY_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al generar la consulta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99747552594304328)
,p_name=>'WWV_FLOW_UTILITIES.INIT_LOV_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al inicializar la lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99748065541304328)
,p_name=>'WWV_FLOW_UTILITIES.INIT_QUERY_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido inicializar la consulta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99673352877304273)
,p_name=>'WWV_FLOW_UTILITIES.INVALID_LOV_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta de lista de valores emergente no es v\00E1lida. Se necesita un valor de visualizaci\00F3n y otro de retorno. Adem\00E1s, los nombres de columna deben ser diferentes')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99720637239304308)
,p_name=>'WWV_FLOW_UTILITIES.JS_NO_SUPPORT'
,p_message_language=>'es'
,p_message_text=>unistr('JavaScript no est\00E1 soportado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99720839782304308)
,p_name=>'WWV_FLOW_UTILITIES.LIST'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99721289307304309)
,p_name=>'WWV_FLOW_UTILITIES.LOV2_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al ejecutar la consulta de lista de valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99720044308304308)
,p_name=>'WWV_FLOW_UTILITIES.NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99719662781304307)
,p_name=>'WWV_FLOW_UTILITIES.NO_MATCHES'
,p_message_language=>'es'
,p_message_text=>'Ninguna coincidencia.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99720381713304308)
,p_name=>'WWV_FLOW_UTILITIES.OK'
,p_message_language=>'es'
,p_message_text=>'Aceptar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99769205671304343)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_BG_SELECT_ERR'
,p_message_language=>'es'
,p_message_text=>'La lista de valores emergente debe empezar por "select".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99747347987304328)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido generar la lista de valores emergente con el filtro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99769425110304344)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_FILTER_INIT_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al inicializar la lista de valores emergente con el filtro: %0 %1'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99769334432304343)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_INIT_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al inicializar la lista de valores emergente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99747874097304328)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_AUTH_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de autenticaci\00F3n de lista de valores emergente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99747972102304328)
,p_name=>'WWV_FLOW_UTILITIES.POPUP_LOV_CHECK_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de verificaci\00F3n del total de control de lista de valores emergente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99719710213304307)
,p_name=>'WWV_FLOW_UTILITIES.PREV'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99719356926304307)
,p_name=>'WWV_FLOW_UTILITIES.REMOVE'
,p_message_language=>'es'
,p_message_text=>'Eliminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99720471634304308)
,p_name=>'WWV_FLOW_UTILITIES.SEARCH_DIALOG'
,p_message_language=>'es'
,p_message_text=>unistr('B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100331484682304815)
,p_name=>'WWV_FLOW_UTILITIES.SHOW_IMAGE_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al mostrar la imagen. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99748605877304328)
,p_name=>'WWV_FLOW_UTILITIES.T_BOLD'
,p_message_language=>'es'
,p_message_text=>'Negrita'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99749015504304329)
,p_name=>'WWV_FLOW_UTILITIES.T_BULL_LIST'
,p_message_language=>'es'
,p_message_text=>unistr('Lista con Vi\00F1etas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99749474470304329)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_LEFT'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicar sangr\00EDa a la Izquierda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99749504963304329)
,p_name=>'WWV_FLOW_UTILITIES.T_IND_RIGHT'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicar sangr\00EDa a la Derecha')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99748749721304329)
,p_name=>'WWV_FLOW_UTILITIES.T_ITALICS'
,p_message_language=>'es'
,p_message_text=>'Cursiva'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99749284051304329)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_CEN'
,p_message_language=>'es'
,p_message_text=>'Justificar en el Centro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99749187315304329)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_LEFT'
,p_message_language=>'es'
,p_message_text=>'Justificar a la Izquierda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99749345431304329)
,p_name=>'WWV_FLOW_UTILITIES.T_JUST_RT'
,p_message_language=>'es'
,p_message_text=>'Justificar a la Derecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99748944458304329)
,p_name=>'WWV_FLOW_UTILITIES.T_NO_LIST'
,p_message_language=>'es'
,p_message_text=>'Lista Numerada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99748845316304329)
,p_name=>'WWV_FLOW_UTILITIES.T_UNDERLINE'
,p_message_language=>'es'
,p_message_text=>'Subrayado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99747649429304328)
,p_name=>'WWV_FLOW_UTILITIES.UNABLE_TO_BIND_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido enlazar "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99524358825304159)
,p_name=>'WWV_FLOW_UTILITIES.WEBSHEET_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n de hoja de c\00E1lculo web %0 no se ha encontrado conectada como usuario de base de datos %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99948319626304485)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_PROXY_OR_URL'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido acceder al servicio web porque la direcci\00F3n URL proporcionada no era v\00E1lida, el entorno necesita una direcci\00F3n de servidor proxy v\00E1lida para las solicitudes HTTP, la solicitud ha sufrido un timeout o se debe configurar una cartera par')
||'a solicitudes HTTPS. SQLERRM: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99595095462304216)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNRETRIEVABLE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido recuperar el documento WSDL porque la direcci\00F3n URL proporcionada no era v\00E1lida, el entorno necesita una direcci\00F3n de servidor proxy v\00E1lida para las solicitudes HTTP y no se ha definido una para esta aplicaci\00F3n o se debe configurar un')
||'a cartera para esta instancia de &PRODUCT_NAME. para solicitudes HTTPS.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99595753698304216)
,p_name=>'WWV_FLOW_WIZARD_API.ACTION_PROCESSED'
,p_message_language=>'es'
,p_message_text=>unistr('Acci\00F3n procesada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100177764672304699)
,p_name=>'WWV_FLOW_WIZARD_API.ADD_ROW_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se han podido agregar filas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99589527187304212)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear el bot\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99626035495304238)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CALENDAR_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de calendario. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99625748719304238)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_CHART_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de gr\00E1fico. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100308146451304797)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_DATA_LOAD_WIZARD'
,p_message_language=>'es'
,p_message_text=>'No se ha podido terminar el proceso de carga de datos. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99626463400304239)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_EXCEL_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear el gr\00E1fico de Excel. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99626146891304238)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_EQUIJOIN'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la pantalla basada en uni\00F3n igualitaria. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99625372109304238)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_SP'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear la pantalla basada en sp. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99625424355304238)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_FORM_ON_TABLE'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear la pantalla basada en tabla. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99625539159304238)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_INSERT_FORM'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la pantalla de inserci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100109855244304609)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_JET_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear el gr\00E1fico de Oracle JET. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99512440103304150)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_MASTER_DETAIL'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina maestra/de detalles. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99995279534304521)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_PAGE_DA'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear una acci\00F3n din\00E1mica. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99625667013304238)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_QUERY_AND_UPDATE_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de consulta y actualizaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99625942412304238)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_REPORT_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de informe. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99626544716304239)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SUMMARY_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de resumen. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99626604289304239)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_SVG_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear la p\00E1gina de gr\00E1fico SVG. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99626398014304239)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_TREE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido crear el \00E1rbol. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99625230589304238)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_UPDATEABLE_REPORT'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear el informe actualizable. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99626229679304238)
,p_name=>'WWV_FLOW_WIZARD_API.CREATE_WIZARD'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido generar el asistente de creaci\00F3n. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100177669190304699)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido procesar la supresi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100178063798304699)
,p_name=>'WWV_FLOW_WIZARD_API.DELETE_SUCCESS'
,p_message_language=>'es'
,p_message_text=>'#MRD_COUNT# fila(s) suprimida(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99531468553304164)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK'
,p_message_language=>'es'
,p_message_text=>'Obtener Valor de Clave Primaria Anterior o Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99531398427304164)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Este bot\00F3n es necesario para el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99531260963304164)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_ITEM'
,p_message_language=>'es'
,p_message_text=>'Este elemento es necesario para el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99532077205304165)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_PROCESS'
,p_message_language=>'es'
,p_message_text=>'No se ha podido ejecutar el proceso Obtener Valor de Clave Primaria Anterior o Siguiente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99541178893304172)
,p_name=>'WWV_FLOW_WIZARD_API.GET_NEXT_PREV_PK_SHORTCUT'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFSeguro que desea salir de esta p\00E1gina sin guardar?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99890437254304440)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK2_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido obtener el valor de elemento de clave secundaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99890394560304440)
,p_name=>'WWV_FLOW_WIZARD_API.GET_PK_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido obtener el valor de elemento de clave primaria.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99625863996304238)
,p_name=>'WWV_FLOW_WIZARD_API.INVALID_REPORT_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de informe no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99904483865304451)
,p_name=>'WWV_FLOW_WIZARD_API.IR_REPORT_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('Ya existe un informe interactivo. S\00F3lo puede agregar un informe interactivo por p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99616374696304231)
,p_name=>'WWV_FLOW_WIZARD_API.NEXT_PREV_PK_PROCESS_ERROR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido crear el proceso Obtener Valor de Clave Primaria Anterior o Siguiente. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100177553248304699)
,p_name=>'WWV_FLOW_WIZARD_API.NO_PAGE_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ayuda disponible para esta p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99625104149304238)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR1'
,p_message_language=>'es'
,p_message_text=>unistr('Error de An\00E1lisis: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99625000857304238)
,p_name=>'WWV_FLOW_WIZARD_API.PARSE_ERROR2'
,p_message_language=>'es'
,p_message_text=>unistr('error de an\00E1lisis2 %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100178111640304699)
,p_name=>'WWV_FLOW_WIZARD_API.REQUEST_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al enviar la solicitud.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100178420725304699)
,p_name=>'WWV_FLOW_WIZARD_API.SHOW_TREE'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar \00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100178236788304699)
,p_name=>'WWV_FLOW_WIZARD_API.TREE_ROOT'
,p_message_language=>'es'
,p_message_text=>unistr('Ra\00EDz del \00C1rbol')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99595580372304216)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_FETCH'
,p_message_language=>'es'
,p_message_text=>'No se ha podido recuperar la fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99595606847304216)
,p_name=>'WWV_FLOW_WIZARD_API.UNABLE_TO_PROCESS'
,p_message_language=>'es'
,p_message_text=>'No se ha podido procesar la fila de la tabla %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99626796514304239)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATEABLE_QUERY_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta SQL actualizable ya existe. S\00F3lo puede agregar una consulta SQL actualizable por p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100177892074304699)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_APPLIED'
,p_message_language=>'es'
,p_message_text=>unistr('Actualizaci\00F3n aplicada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100177980698304699)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_INSERT_SUCCESS'
,p_message_language=>'es'
,p_message_text=>'#MRU_COUNT# fila(s) actualizada(s), #MRI_COUNT# fila(s) insertada(s).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100048347419304561)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_AUTH_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('Copiar Esquema de Autorizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100048118470304561)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LIST'
,p_message_language=>'es'
,p_message_text=>'Copiar Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100047961157304561)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.COPY_LOV'
,p_message_language=>'es'
,p_message_text=>'Copiar Lista de Valores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100048246984304561)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LIST'
,p_message_language=>'es'
,p_message_text=>'Usar Lista Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100048000090304561)
,p_name=>'WWV_FLOW_WIZ_CONFIRM.USE_EXISTING_LOV'
,p_message_language=>'es'
,p_message_text=>'Usar Lista de Valores Existente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99749784570304329)
,p_name=>'WWV_FLOW_WORKSHEET.SHOW_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al presentar el informe: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100205918400304720)
,p_name=>'WWV_FLOW_WORKSPACE_REPORTS.TABLESPACE1'
,p_message_language=>'es'
,p_message_text=>'%0 GB en total | %1 GB utilizados | %2 por ciento utilizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99523075275304158)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_PGA_AGG_TARGET'
,p_message_language=>'es'
,p_message_text=>'Error al definir el nuevo destino de PGA agregada. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99522813880304158)
,p_name=>'WWV_FLOW_XE_CONFIG.SET_SGA_TARGET'
,p_message_language=>'es'
,p_message_text=>'Se ha producido un error al definir el nuevo destino de SGA. %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100770450354305146)
,p_name=>'WWV_FLOW_XLIFF.ERROR_PROCESSING'
,p_message_language=>'es'
,p_message_text=>'Error al procesar %0: %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99745458789304326)
,p_name=>'WWV_RENDER_CHART2.T_AVERAGE'
,p_message_language=>'es'
,p_message_text=>'Media'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99745383093304326)
,p_name=>'WWV_RENDER_CHART2.T_AXIS'
,p_message_language=>'es'
,p_message_text=>'Eje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99745924229304327)
,p_name=>'WWV_RENDER_CHART2.T_FIRST'
,p_message_language=>'es'
,p_message_text=>'Primero'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99746096085304327)
,p_name=>'WWV_RENDER_CHART2.T_GO'
,p_message_language=>'es'
,p_message_text=>'Ir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99745897743304326)
,p_name=>'WWV_RENDER_CHART2.T_LAST'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99745632539304326)
,p_name=>'WWV_RENDER_CHART2.T_MAXIMUM'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99745710801304326)
,p_name=>'WWV_RENDER_CHART2.T_MINIMUM'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99745293162304326)
,p_name=>'WWV_RENDER_CHART2.T_ROWS'
,p_message_language=>'es'
,p_message_text=>'Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99745573953304326)
,p_name=>'WWV_RENDER_CHART2.T_SUM'
,p_message_language=>'es'
,p_message_text=>'Suma'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99680918908304279)
,p_name=>'WWV_RENDER_REPORT3.CURSOR_NOT_OPEN'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta no se puede analizar, el cursor todav\00EDa no est\00E1 abierto o una funci\00F3n que devuelve una consulta SQL no ha devuelto ning\00FAn valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100041464526304556)
,p_name=>'WWV_RENDER_REPORT3.DUBLICATE_ALIAS_NAMES'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta contiene nombres de alias duplicados; las consultas que se utilizan para los informes necesitan nombres de alias \00FAnicos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99673064895304273)
,p_name=>'WWV_RENDER_REPORT3.ERR_PROC_FUNCTION_BODY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('no se ha podido procesar el cuerpo de la funci\00F3n que devuelve una consulta:'),
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99758949313304336)
,p_name=>'WWV_RENDER_REPORT3.INVALID_COL_NUM'
,p_message_language=>'es'
,p_message_text=>unistr('se ha definido un n\00FAmero no v\00E1lido de columnas en la consulta, se necesitan %0 columnas para este tipo de regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99681069387304279)
,p_name=>'WWV_RENDER_REPORT3.QUERY_CANNOT_BE_PARSED'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Funci\00F3n que devuelve una consulta SQL: La consulta no se puede analizar con el Creador. Si cree que la consulta es sint\00E1cticamente correcta, active la casilla de control <strong>Columnas Gen\00E9ricas</strong> situada bajo el origen de regi\00F3n para contin')
||unistr('uar sin realizar el an\00E1lisis.'),
'<br/>',
'(%0)'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99681135671304279)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR2'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La consulta no se puede analizar con el Creador. Si cree que la consulta es sint\00E1cticamente correcta, active la casilla de verificaci\00F3n ''''Columnas Gen\00E9ricas'''' situada bajo el origen de regi\00F3n para continuar sin realizar el an\00E1lisis.'),
'%0</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99757448466304335)
,p_name=>'WWV_SPELING.ADD_WORD'
,p_message_language=>'es'
,p_message_text=>'Agregar Palabra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99758018206304335)
,p_name=>'WWV_SPELING.BUTTON_ADD_TO_DICTIONARY'
,p_message_language=>'es'
,p_message_text=>'Agregar a Diccionario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99757909858304335)
,p_name=>'WWV_SPELING.BUTTON_APPLY_CHANGES'
,p_message_language=>'es'
,p_message_text=>'Aplicar Cambios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99757858965304335)
,p_name=>'WWV_SPELING.BUTTON_CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99757714348304335)
,p_name=>'WWV_SPELING.BUTTON_DONE'
,p_message_language=>'es'
,p_message_text=>'Listo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100116660913304614)
,p_name=>'WWV_SPELING.BUTTON_SUBMIT'
,p_message_language=>'es'
,p_message_text=>'Ejecutar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99757646194304335)
,p_name=>'WWV_SPELING.DUP_WORD_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('%0 ya est\00E1 en el diccionario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99758236576304335)
,p_name=>'WWV_SPELING.ENTER_NEW_WORD'
,p_message_language=>'es'
,p_message_text=>'Introduzca una nueva palabra.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99758127511304335)
,p_name=>'WWV_SPELING.PICK_A_WORD'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Palabra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99975803512304506)
,p_name=>'WWV_SPELING.SPELL_CHECKER'
,p_message_language=>'es'
,p_message_text=>unistr('Comprobaci\00F3n Ortogr\00E1fica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99757542199304335)
,p_name=>'WWV_SPELING.WORD_ADDED'
,p_message_language=>'es'
,p_message_text=>'Se ha agregado %0 al diccionario.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99602872928304221)
,p_name=>'XML_LOAD_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error de carga de XML.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100027733899304545)
,p_name=>'X_ADDITIONAL_TAGS_EXIST'
,p_message_language=>'es'
,p_message_text=>'Existen %0 etiquetas adicionales'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100028564427304546)
,p_name=>'X_BUGS_HAVE_NO_FIX_DATES'
,p_message_language=>'es'
,p_message_text=>unistr('%0 bugs no tienen fechas de correcci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(100202593929304717)
,p_name=>'YEARLY'
,p_message_language=>'es'
,p_message_text=>unistr('A\00F1o')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99656265300304261)
,p_name=>'YES_BY_USER'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED, por Usuario')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99685399739304282)
,p_name=>'YOUR_EMAIL_IUWS'
,p_message_language=>'es'
,p_message_text=>unistr('La direcci\00F3n de correo electr\00F3nico est\00E1 registrada con usuario en los siguientes espacios de trabajo:')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(99966756207304499)
,p_name=>'YOU_ARE_NOW_LOGGED_OUT'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1 desconectado.')
);
null;
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(91645213681389498.4412)
,p_name=>'no auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_15=>'91645213681389498'
,p_invalid_session_type=>'LOGIN'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_comments=>'Based on authentication scheme from gallery:No Authentication (using DAD)'
);
end;
/
prompt --application/shared_components/plugins/region_type/breadcrumb
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3708767719669.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'BREADCRUMB'
,p_display_name=>unistr('Ruta de Navegaci\00F3n')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','BREADCRUMB'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra la pista de la ruta de navegaci\00F3n de la p\00E1gina actual.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3709973247475.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'LIST'
,p_display_name=>'Lista'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','LIST'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra los valores en funci\00F3n de una lista est\00E1tica o din\00E1mica. Generalmente, se utilizan para navegar a las p\00E1ginas de la aplicaci\00F3n.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_cancel
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734497742532.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CANCEL'
,p_display_name=>unistr('Cancelar Cuadro de Di\00E1logo')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CANCEL'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Cancela la p\00E1gina del cuadro de di\00E1logo actual.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/dialog_close
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3734500756040.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DIALOG_CLOSE'
,p_display_name=>unistr('Cerrar Recuadro de Di\00E1logo')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DIALOG_CLOSE'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Cierra la p\00E1gina del cuadro de di\00E1logo actual.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3788410042953.4412)
,p_plugin_id=>wwv_flow_api.id(3734500756040.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elementos para Devolver'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de uno o m\00E1s elementos de p\00E1gina que devolver\00E1 el cuadro de di\00E1logo. Para varios elementos, separe cada nombre de elemento con una coma.</p>'),
unistr('<p>Puede acceder a los valores del elemento devuelto mediante la definici\00F3n de una acci\00F3n din\00E1mica para disparar el evento <strong>Cuadro de Di\00E1logo Cerrado</strong> en el elemento que abre el cuadro de di\00E1logo, con una acci\00F3n de <strong>Definir Valo')
||unistr('r</strong> y <em>Definir Tipo</em> del <strong>Elemento de Retorno de Cuadro de Di\00E1logo</strong>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/display_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3782395890396.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DISPLAY_SELECTOR'
,p_display_name=>unistr('Selector de Visualizaci\00F3n de Regi\00F3n')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DISPLAY_SELECTOR'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra los nombres de regiones en una lista horizontal, lo que permite a los usuarios finales seleccionar una regi\00F3n para mostrar y ocultar otras regiones. Solo se mostrar\00E1n en esta regi\00F3n las regiones de p\00E1gina con <em>Selector de Visualizaci\00F3n de ')
||unistr('Regi\00F3n</em> definido en <strong>S\00ED</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1764737380560506621.4412)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Incluir Gu\00EDa de Desplazamiento')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Agregue de forma din\00E1mica una gu\00EDa de desplazamiento si los nombres de regi\00F3n mostrados exceden el ancho de la misma.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763653631955156043.4412)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Modo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STANDARD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione la forma en la que aparecer\00E1n en la p\00E1gina las regiones con <em>Selector de Visualizaci\00F3n de Regi\00F3n</em> definido en <strong>S\00ED</strong>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654080157157624.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Ver Regi\00F3n \00DAnica')
,p_return_value=>'STANDARD'
,p_help_text=>unistr('Muestra las regiones como separadores. Al seleccionar un separador, se mostrar\00E1 la regi\00F3n correspondiente y se ocultar\00E1 el resto de selecciones.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1763654509981158498.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1763653631955156043.4412)
,p_display_sequence=>20
,p_display_value=>'Desplazar Ventana'
,p_return_value=>'JUMP'
,p_help_text=>unistr('Muestra siempre todas las regiones de la p\00E1gina. Al seleccionar un separador, se desplazar\00E1 la ventana a la regi\00F3n correspondiente.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763973139934187732.4412)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Incluir ''Mostrar Todo'''
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1763653631955156043.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STANDARD'
,p_help_text=>unistr('Anteponga un separador "Mostrar Todo" que, al seleccionarlo, muestre todas las regiones de la p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1763975939882192484.4412)
,p_plugin_id=>wwv_flow_api.id(3782395890396.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Recordar \00DAltima Selecci\00F3n')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Cuando se cargue la p\00E1gina, aparecer\00E1 la regi\00F3n que haya seleccionado en \00FAltimo lugar.')
);
end;
/
prompt --application/shared_components/plugins/region_type/url
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783484270249.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'URL'
,p_display_name=>'URL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','URL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Muestra contenido remoto con origen en una URL.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783486275401.4412)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Introduzca una URL para el contenido remoto.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783489372727.4412)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Modo de Inclusi\00F3n')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IFRAME'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione c\00F3mo se incluye en la p\00E1gina el contenido remoto de la URL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783492373852.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4412)
,p_display_sequence=>10
,p_display_value=>'IFrame'
,p_return_value=>'IFRAME'
,p_help_text=>'Embebe contenido remoto como un iframe.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783496377152.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4412)
,p_display_sequence=>20
,p_display_value=>unistr('En L\00EDnea (Caracteres Especiales de Escape)')
,p_return_value=>'ESC_INLINE'
,p_help_text=>unistr('Lee contenido remoto en el momento de la presentaci\00F3n de la p\00E1gina y lo embebe, pero omite caracteres HTML especiales para evitar scripts de sitios.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3783504380866.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3783489372727.4412)
,p_display_sequence=>30
,p_display_value=>unistr('En L\00EDnea (Sin Escape)')
,p_return_value=>'NOESC_INLINE'
,p_help_text=>unistr('Lee contenido remoto en el momento de la presentaci\00F3n de la p\00E1gina y lo embebe. Esta opci\00F3n solo se debe seleccionar si el contenido remoto es de total confianza, ya que no se realiza ninguna omisi\00F3n de HTML. Esto puede hacer la regi\00F3n vulnerable a s')
||'cripts de sitios.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783511409602.4412)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Atributos de IFrame'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>80
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IFRAME'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'width="300" height="300"',
'</pre>'))
,p_help_text=>'Introduzca atributos de elementos HTML adicionales para la etiqueta de iframe.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783517424673.4412)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Desechar HTML hasta'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('Utilice este atributo cuando recorte una secci\00F3n de HTML de un documento de mayor tama\00F1o. Introduzca una cadena que identifique el inicio de la secci\00F3n de destino, o bien el punto hasta el que se debe desechar el HTML.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3783520428341.4412)
,p_plugin_id=>wwv_flow_api.id(3783484270249.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Desechar HTML despu\00E9s de')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3783489372727.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ESC_INLINE,NOESC_INLINE'
,p_help_text=>unistr('Utilice este atributo para recortar una secci\00F3n de HTML de un documento HTML de mayor tama\00F1o. Introduzca una cadena que identifique el final de la secci\00F3n de destino, o bien el punto despu\00E9s del cual se debe desechar el HTML restante. Esta cadena que')
||unistr(' identifica el final de la secci\00F3n de destino no se incluye en el texto devuelto.')
);
end;
/
prompt --application/shared_components/plugins/region_type/help_text
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3783523603076.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'HELP_TEXT'
,p_display_name=>'Texto de Ayuda'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','HELP_TEXT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra una regi\00F3n de ayuda especial que se utiliza en la p\00E1gina de ayuda dedicada.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/faceted_search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1370261776191667.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FACETED_SEARCH'
,p_display_name=>unistr('B\00FAsqueda por facetas')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FACETED_SEARCH'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>Una regi\00F3n basada en el origen de una b\00FAsqueda por facetas asociada, que proporciona numerosas facetas a los usuarios finales, usadas para ajustar los resultados de b\00FAsqueda al tiempo de ejecuci\00F3n. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1370473361191712.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Cambios de facetas por lotes'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione si desea aplicar por lotes las facetas seleccionadas, o individualmente, en el informe B\00FAsqueda por facetas. Cuando el valor es S\00ED, el filtrado del informe se realiza cuando se hace clic en el bot\00F3n Aplicar. Cuando es No, el filtrado del i')
||'nforme se realiza en cuanto cambie cualquier valor de faceta.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2517816294852101.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Mostrar facetas actuales'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique si se va a mostrar el \00E1rea de facetas actual. El \00E1rea de facetas actual muestra las facetas que actualmente est\00E1n seleccionadas, adem\00E1s de proporcionar un m\00E9todo sencillo para eliminarlas de forma individual o en conjunto.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518140718854747.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4412)
,p_display_sequence=>10
,p_display_value=>unistr('S\00ED')
,p_return_value=>'Y'
,p_help_text=>unistr('La lista de facetas actuales se visualiza encima de la regi\00F3n de b\00FAsqueda de facetas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518542510858430.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4412)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'No se visualiza la lista de facetas actuales.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2518915492864304.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2517816294852101.4412)
,p_display_sequence=>30
,p_display_value=>'Selector'
,p_return_value=>'E'
,p_help_text=>unistr('El \00E1rea de facetas actual se muestra dentro del elemento especificado por este selector. Esto permite colocar el \00E1rea de facetas actual en pr\00E1cticamente cualquier lugar de la p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728482701453610313.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Selector de facetas actual'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2517816294852101.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#currentFacetsArea'
,p_help_text=>unistr('Este es el selector de un elemento en la p\00E1gina donde la regi\00F3n de b\00FAsqueda por facetas mostrar\00E1 las facetas actuales.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1501356115247921.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Mostrar Recuento Total de Filas'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Especifique si se va a mostrar el recuento total de filas.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1501661440256814.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4412)
,p_display_sequence=>10
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'No se muestra el recuento total de filas.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502011338258911.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4412)
,p_display_sequence=>20
,p_display_value=>unistr('S\00ED')
,p_return_value=>'Y'
,p_help_text=>unistr('El recuento total de filas se muestra en la parte superior del \00E1rea de facetas actuales o, si el valor de Mostrar facetas actuales es No, en la parte superior de la regi\00F3n B\00FAsqueda por facetas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1502458150261854.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1501356115247921.4412)
,p_display_sequence=>30
,p_display_value=>'Selector'
,p_return_value=>'E'
,p_help_text=>unistr('El recuento total de filas (sin ninguna etiqueta) se muestra dentro del elemento especificado por este selector. Esto permite colocar el recuento total de filas en pr\00E1cticamente cualquier lugar de la p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503042014268412.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Etiqueta de recuento total de filas'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Etiqueta que se utiliza para el recuento total de filas. Si aqu\00ED no se proporciona ninguna etiqueta, APEX utilizar\00E1 el mensaje de texto APEX.FS.TOTAL_ROW_COUNT_LABEL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1503328055272516.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Selector del recuento total de filas'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1501356115247921.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('Este es el selector de un elemento en la p\00E1gina donde la regi\00F3n de b\00FAsqueda por facetas mostrar\00E1 el recuento total de filas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(556135859462274866.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>20
,p_prompt=>unistr('Umbral de n\00FAmeros compacto')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Proporcione un valor de umbral por encima del cual se mostrar\00E1n los recuentos de facetas utilizando un formato de n\00FAmero compacto. Con el formato de n\00FAmero compacto, un valor <strong>1234</strong> se mostrar\00E1 como <strong>1K</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2600957382075036.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('Mostrar gr\00E1ficos')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique la ubicaci\00F3n en la que se muestran los gr\00E1ficos de valor de faceta.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601268677075657.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Cuadro de Di\00E1logo')
,p_return_value=>'Y'
,p_help_text=>unistr('Los gr\00E1ficos de valor de faceta se muestran en un cuadro de di\00E1logo no modal.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601607534076237.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4412)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>unistr('No hay ning\00FAn bot\00F3n que permita a los usuarios mostrar los gr\00E1ficos de valor de faceta.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2602011048076805.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2600957382075036.4412)
,p_display_sequence=>30
,p_display_value=>'Selector'
,p_return_value=>'E'
,p_help_text=>unistr('Los gr\00E1ficos de valor de faceta se agregan al elemento especificado por este selector. Esto permite colocar los gr\00E1ficos en pr\00E1cticamente cualquier lugar de la p\00E1gina, con lo que se crea un panel de control de gr\00E1ficos de valores de facetas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2602471299081559.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Selector de gr\00E1ficos')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_help_text=>unistr('Este es el selector de un elemento en la p\00E1gina donde la regi\00F3n de b\00FAsqueda por facetas mostrar\00E1 los gr\00E1ficos de facetas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3900223688176537.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Mostrar gr\00E1fico para los N valores principales')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2600957382075036.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'Y,E'
,p_help_text=>unistr('Proporcione el n\00FAmero de valores que mostrar en el gr\00E1fico de cada faceta. Un valor <strong>10</strong> significa que los gr\00E1ficos de facetas mostrar\00E1n los <em>10 primeros elementos</em> seg\00FAn el orden de la faceta. Cuando la propiedad de la faceta O')
||unistr('rdenar por recuentos superiores est\00E9 activada, ser\00E1n los <em>10 elementos superiores</em> en funci\00F3n de los recuentos de ocurrencias. Puede que los cambios en esta propiedad no se vean directamente en las sesiones del explorador actualmente activas. ')
||unistr('Tanto este valor como la opci\00F3n de gr\00E1fico de barras o de tarta del usuario se guardan en la sesi\00F3n del explorador. Para comprobar el efecto de los cambios en esta propiedad, restablezca el informe mediante una opci\00F3n de control de cach\00E9 del enlace R')
||unistr('establecer regiones, como con el bot\00F3n Restablecer generado por el asistente.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603063046957961274.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_name=>'facetsafterremovechart'
,p_display_name=>unistr('Despu\00E9s de eliminar gr\00E1fico')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(603062764743961271.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_name=>'facetsbeforeaddchart'
,p_display_name=>unistr('Antes de agregar gr\00E1fico')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1372274287191736.4412)
,p_plugin_id=>wwv_flow_api.id(1370261776191667.4412)
,p_name=>'facetschange'
,p_display_name=>'Cambio de facetas'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/saml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1381216513007333.4412)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SAML'
,p_display_name=>unistr('Conexi\00F3n SAML')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SAML'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007334.4412)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>70
,p_prompt=>unistr('Almac\00E9n de credenciales para la firma de solicitudes')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el almac\00E9n de credenciales que contiene el certificado p\00FAblico y la clave privada usada para firmar mensajes para el proveedor de identidad.'),
'Debe registrar el certificado en el proveedor de identidad.',
'&PRODUCT_NAME. usa la clave privada para firmar las solicitudes.',
'Si bien este atributo es opcional, se recomienda firmar las solicitudes por razones de seguridad.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007335.4412)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Usar atributos de SAML de'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSTANCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'APP'
,p_help_text=>unistr('Especifique si desea usar una configuraci\00F3n de SAML espec\00EDfica de la aplicaci\00F3n o del nivel de instancia.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007332.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4412)
,p_display_sequence=>10
,p_display_value=>'Instancia'
,p_return_value=>'INSTANCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Utilice la configuraci\00F3n de SAML compartida para toda la instancia de &PRODUCT_NAME.'),
'Esto requiere que su administrador de instancia haya configurado atributos de SAML a nivel de instancia.',
unistr('Si este no es el caso, se producir\00E1n errores de tiempo de ejecuci\00F3n.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1381216513007331.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1381216513007335.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Aplicaci\00F3n')
,p_return_value=>'APP'
,p_is_deprecated=>true
,p_help_text=>unistr('Utilice una configuraci\00F3n de SAML espec\00EDfica de la aplicaci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007336.4412)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('URL de conexi\00F3n \00FAnica del proveedor de identidad')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>unistr('Seleccione la URL POST de conexi\00F3n \00FAnica del proveedor de identidad.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007337.4412)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>unistr('URL de desconexi\00F3n \00FAnica del proveedor de identidad')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione la URL POST de desconexi\00F3n \00FAnica del proveedor de identidad.'),
unistr('Si el valor est\00E1 vac\00EDo, se usar\00E1 la URL de conexi\00F3n \00FAnica.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007338.4412)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>'Emisor de proveedor de identidad'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione el valor "Emisor" del proveedor de identidad.',
unistr('&PRODUCT_NAME. verificar\00E1 este valor en mensajes del proveedor de identidad.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007339.4412)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Atributo de nombre de usuario'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Atributo SAML que contiene el nombre de usuario.',
'Por defecto, es el valor del nodo "Assertion/Subject/NameID".'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1381216513007340.4412)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>60
,p_prompt=>'Certificado de firma del proveedor de identidad'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1381216513007335.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Introduzca el certificado que usa el proveedor de identidad para firmar los mensajes.',
'&PRODUCT_NAME. usa este certificado para verificar los mensajes de respuesta del proveedor de identidad.',
'Si bien este atributo es opcional, se recomienda verificar las respuestas por motivos de seguridad.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549695930675668342.4412)
,p_plugin_id=>wwv_flow_api.id(1381216513007333.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Convertir el nombre de usuario a may\00FAsculas')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Determine si los valores del atributo de nombre de usuario deben convertirse a may\00FAsculas.')
);
end;
/
prompt --application/shared_components/plugins/item_type/input
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1401075215817352.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'INPUT'
,p_display_name=>'Campo de Entrada'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','INPUT'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1401202979819499.4412)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Operador de comparaci\00F3n')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1401536563820127.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4412)
,p_display_sequence=>10
,p_display_value=>'Igual que'
,p_return_value=>'EQUALS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402360244821204.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4412)
,p_display_sequence=>30
,p_display_value=>'Menor que'
,p_return_value=>'LT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1402711336822152.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4412)
,p_display_sequence=>40
,p_display_value=>'Menor o Igual que'
,p_return_value=>'LTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403187913822669.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4412)
,p_display_sequence=>50
,p_display_value=>'Mayor que'
,p_return_value=>'GT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403530010823859.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4412)
,p_display_sequence=>60
,p_display_value=>'Mayor o Igual que'
,p_return_value=>'GTE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1574661752077055.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4412)
,p_display_sequence=>70
,p_display_value=>'Empieza por'
,p_return_value=>'STARTS_WITH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1403924638824893.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1401202979819499.4412)
,p_display_sequence=>80
,p_display_value=>'Contiene'
,p_return_value=>'CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1404353085828349.4412)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Sensible a May\00FAsculas/Min\00FAsculas')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1401202979819499.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STARTS_WITH,CONTAINS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1581137453249138.4412)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Caso de valores'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MIXED'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1404353085828349.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Si todos los valores de datos ya est\00E1n en may\00FAsculas o en min\00FAsculas, puede declararse aqu\00ED. El filtro, proporcionado por el usuario final, los convertir\00E1 autom\00E1ticamente al formato declarado para que el usuario final pueda realizar b\00FAsquedas no sens')
||unistr('ibles a may\00FAsculas/min\00FAsculas, mientras que la base de datos realiza realmente una b\00FAsqueda normal sensible a may\00FAsculas/min\00FAsculas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581469548249721.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4412)
,p_display_sequence=>10
,p_display_value=>unistr('May\00FAsculas y Min\00FAsculas')
,p_return_value=>'MIXED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1581879901250301.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Min\00FAsculas')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1582278689250872.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1581137453249138.4412)
,p_display_sequence=>30
,p_display_value=>unistr('May\00FAsculas')
,p_return_value=>'UPPER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1573402545049808.4412)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Etiqueta actual'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'Filtrado para %0'
,p_help_text=>unistr('Proporcione el texto que aparecer\00E1 para esta faceta en el \00E1rea de facetas actual. El valor actual pueden ser referencias con el marcador de posici\00F3n <strong>%0</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1594998866512975.4412)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Texto de prefijo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Proporcione el texto que aparecer\00E1 antes del campo de entrada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1595229523514009.4412)
,p_plugin_id=>wwv_flow_api.id(1401075215817352.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Texto de sufijo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Proporcione el texto que aparecer\00E1 despu\00E9s del campo de entrada.')
);
end;
/
prompt --application/shared_components/plugins/region_type/cards
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1602002675849340.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CARDS'
,p_display_name=>'Tarjetas'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CARDS'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Informe basado en una consulta SQL que muestra datos de cada fila en tarjetas. Con las tarjetas, puede visualizar los datos en bloques de contenido con facilidad. Puede personalizar la cabecera, los medios, el cuerpo o las acciones de forma declarati'
||'va.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(1602292184849355.4412)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4412)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(633822552473663477.4412)
,p_plugin_id=>wwv_flow_api.id(1602002675849340.4412)
,p_name=>'tablemodelviewpagechange'
,p_display_name=>unistr('Cambio de p\00E1gina')
);
end;
/
prompt --application/shared_components/plugins/web_source_type/http
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1677862467038200.4412)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'HTTP'
,p_display_name=>'HTTP'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','HTTP'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1901267720643867.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Tipo de Paginaci\00F3n')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>unistr('Ninguna paginaci\00F3n')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901523910653468.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Tama\00F1o de p\00E1gina y desplazamiento de recuperaci\00F3n')
,p_return_value=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Paginaci\00F3n flexible en la que la API de REST permite solicitar un juego de filas espec\00EDfico mediante los par\00E1metros de <em>tama\00F1o de p\00E1gina</em> y <em>desplazamiento</em> ("empezar en fila"). La URL normalmente tiene el aspecto del siguiente ejemp')
||'lo, que omite <strong>20</strong> filas y recupera las <strong>100</strong> siguientes:</p>',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?limit=100&offset=20',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1901988519660109.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Tama\00F1o y n\00FAmero de p\00E1gina')
,p_return_value=>'PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Paginaci\00F3n en la que la API de REST permite solicitar un juego de filas mediante los par\00E1metros de <em>tama\00F1o de p\00E1gina</em> y <em>n\00FAmero de p\00E1gina</em>. Las URL normalmente tienen el aspecto del siguiente ejemplo, que solicita la p\00E1gina n\00FAmero <s')
||unistr('trong>2</strong> con un tama\00F1o de p\00E1gina de <strong>100</strong>, lo que provoca que se devuelvan las filas 101 a 200.'),
'</p>',
'<pre>',
'http://hostname.domain.com/path/to/rest_api?size=100&page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1902974368668773.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_display_sequence=>30
,p_display_value=>unistr('N\00FAmero de P\00E1gina')
,p_return_value=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Paginaci\00F3n en la que la API de REST permite solicitar un juego de filas mediante un par\00E1metro de <em>p\00E1gina</em>. La API de REST fija y determina el tama\00F1o de p\00E1gina. Las URL normalmente tienen el aspecto del siguiente ejemplo, que solicita la p\00E1g')
||unistr('ina n\00FAmero <strong>2</strong>. Si la API de REST utiliza un tama\00F1o de p\00E1gina fijo de <strong>20</strong>, se devolver\00E1n las filas 21 a 40.'),
'<pre>',
'http://hostname.domain.com/path/to/rest_api?page=2',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904445073685723.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Par\00E1metro de URL de tama\00F1o de p\00E1gina')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'FLEXIBLE,PAGE_NUMBER_FLEXIBLE_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Proporcione el par\00E1metro de URL para especificar qu\00E9 <em>tama\00F1o de p\00E1gina</em> debe solicitarse de la API de REST. Los valores t\00EDpicos son <strong>limit</strong>, <strong>page_size</strong> o </strong>per_page</strong>.</p>'),
unistr('<p><em>No agregue este par\00E1metro a los <strong>par\00E1metros</strong></em> de origen de datos de REST. &PRODUCT_NAME. lo agregar\00E1 autom\00E1ticamente al ejecutar la solicitud HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1904796837692405.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Tama\00F1o m\00E1ximo de p\00E1gina')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>10
,p_unit=>'filas'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Proporcione la cantidad m\00E1xima de filas por p\00E1gina, las cuales se pueden recuperar con la API de REST. &PRODUCT_NAME. no intentar\00E1 solicitar m\00E1s filas por p\00E1gina.</p>'),
unistr('<p>Aseg\00FArese de que la API de REST <em>devuelve</em> esa cantidad de filas, ya que &PRODUCT_NAME. supone que una p\00E1gina solicitada es la \00FAltima si la respuesta contiene menos filas de las solicitadas.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905045481696652.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Par\00E1metro de URL de n\00FAmero de p\00E1gina')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Proporcione el par\00E1metro de URL para especificar qu\00E9 <em>n\00FAmero de p\00E1gina</em> debe solicitarse de la API de REST. Un valor t\00EDpico es <strong>page</strong>.</p>'),
unistr('<p><em>No agregue este par\00E1metro a los <strong>par\00E1metros de origen de datos</strong></em>. &PRODUCT_NAME. lo agregar\00E1 autom\00E1ticamente al ejecutar la solicitud HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1905385707699679.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('\00CDndice de primera p\00E1gina')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PAGE_NUMBER_FLEXIBLE_SIZE,PAGE_NUMBER_FIXED_SIZE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Especifique si la API de REST comienza a contar p\00E1ginas en el \00EDndice <strong>"0"</strong> o <strong>"1"</strong>.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1905636932702605.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4412)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
,p_is_quick_pick=>true
,p_help_text=>unistr('La API de REST hace referencia a la primera p\00E1gina como p\00E1gina <strong>1</strong>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1906025829704631.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1905385707699679.4412)
,p_display_sequence=>20
,p_display_value=>'0'
,p_return_value=>'0'
,p_is_quick_pick=>true
,p_help_text=>unistr('La API de REST hace referencia a la primera p\00E1gina como p\00E1gina <strong>0</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906661765710861.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Tama\00F1o de p\00E1gina fijo')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>10
,p_unit=>'filas'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_NUMBER_FIXED_SIZE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Proporcione el <em>tama\00F1o de p\00E1gina</em> (n\00FAmero de filas por p\00E1gina), que determina la API de REST.</p>'),
unistr('<p>Normalmente, esta informaci\00F3n se encuentra en la documentaci\00F3n de la API de REST. Aseg\00FArese de especificar aqu\00ED el valor correcto: si no es preciso, faltar\00E1n filas o se duplicar\00E1n cuando &PRODUCT_NAME. recupere datos de la API de REST.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1906984049714159.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Par\00E1metro de URL de desplazamiento de fila')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>50
,p_max_length=>255
,p_unit=>'filas'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Proporcione el par\00E1metro de URL para especificar el <em>desplazamiento</em>, que denota las filas que se deben saltar antes de que se devuelva la primera fila.</p>'),
unistr('<p><em>No agregue este par\00E1metro a los <strong>par\00E1metros</strong></em> de origen de datos de REST. &PRODUCT_NAME. lo agregar\00E1 autom\00E1ticamente al ejecutar la solicitud HTTP.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1907222147716823.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Tipo de desplazamiento de fila'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OFFSET'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FLEXIBLE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Seleccione si el par\00E1metro de <strong>desplazamiento</strong> indica la <em>cantidad de filas que deben omitirse</em> o la <em>primera fila que debe recuperarse</em>.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907577038717722.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4412)
,p_display_sequence=>10
,p_display_value=>'Filas a Omitir'
,p_return_value=>'OFFSET'
,p_help_text=>unistr('El valor de desplazamiento indica qu\00E9 filas deben omitirse. Por ejemplo, si se proporciona un valor de 100, la API de REST devuelve filas a partir del \00EDndice 101.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1907904681718986.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1907222147716823.4412)
,p_display_sequence=>20
,p_display_value=>'Primera fila para recuperar'
,p_return_value=>'START'
,p_help_text=>unistr('El valor de desplazamiento indica la fila a partir de la que se debe empezar la recuperaci\00F3n. Por ejemplo, si se proporciona un valor de 100, la API de REST omitir\00E1 99 filas y comenzar\00E1 a recuperar en el \00EDndice 100.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908579263746808.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Selector de m\00E1s filas')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Si una API de REST devuelve la siguiente respuesta de JSON:</p>',
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('El <strong>selector de m\00E1s filas</strong> es <strong>metadata.pagination.moreRows</strong>.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si la respuesta de la API de REST devuelve informaci\00F3n sobre si hay p\00E1ginas adicionales, proporcione el <em>selector</em> para extraer aqu\00ED este atributo.</p>'),
unistr('<p>Especificar un <strong>selector de m\00E1s filas</strong> no es necesario, pero ayuda a &PRODUCT_NAME. a guardar solicitudes HTTP adicionales (que no devuelven datos) cuando se han recuperado todos los datos.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1908849697751769.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('M\00E1s filas con el valor')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'EQUALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908579263746808.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Elija c\00F3mo interpretar el valor de atributo de respuesta al que hace referencia el <strong>selector de m\00E1s filas</strong>.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909141279756289.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4412)
,p_display_sequence=>10
,p_display_value=>'Igual que'
,p_return_value=>'EQUALS'
,p_is_quick_pick=>true
,p_help_text=>unistr('Suponga que habr\00E1 m\00E1s filas disponibles cuando el atributo de respuesta al que hace referencia el <strong>selector de m\00E1s filas</strong> sea igual a un valor.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1909569602757607.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1908849697751769.4412)
,p_display_sequence=>20
,p_display_value=>'No es Nulo'
,p_return_value=>'NOT_NULL'
,p_is_quick_pick=>true
,p_help_text=>unistr('Suponga que habr\00E1 m\00E1s filas disponibles cuando el atributo de respuesta al que hace referencia el <strong>selector de m\00E1s filas</strong> exista y no est\00E9 vac\00EDo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911015518771444.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>unistr('Valor de atributo M\00E1s filas')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'true'
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1908849697751769.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'EQUALS'
,p_help_text=>unistr('<p>&PRODUCT_NAME. supone que hay m\00E1s filas disponibles si el atributo de respuesta al que hace referencia el <strong>selector de m\00E1s filas</strong> contiene este valor.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1911713410779146.4412)
,p_plugin_id=>wwv_flow_api.id(1677862467038200.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Selector de filas totales'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1901267720643867.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Si una API de REST devuelve la siguiente respuesta de JSON...</p>',
'<pre>',
'{',
'    "items": [',
'         { // row 1 },',
'         { // row 2 },',
'         :',
'         { // row n } ',
'    ],',
'    "metadata": {',
'         "pagination": {',
'             "moreRows": true,',
'             "totalRows": 2712,',
'             "nextPage": 10 ',
'         } ',
'    } ',
'}',
'</pre>',
'<p>',
unistr('... el <strong>selector de m\00E1s filas</strong> es <strong>metadata.pagination.totalRows</strong>.'),
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si la API de REST devuelve la <em>cantidad de filas totales</em> (en todas las p\00E1ginas) como parte de la respuesta, proporcione el <em>selector</em> para extraer aqu\00ED este atributo.</p>'),
unistr('<p>Especificar un <strong>selector de m\00E1s filas</strong> no es necesario; permite mostrar la cantidad de filas totales de los componentes de &PRODUCT_NAME.<em> siempre que no se filtren m\00E1s los datos</em>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/geocoded_address
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1700838675352758.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'GEOCODED_ADDRESS'
,p_display_name=>unistr('Direcci\00F3n geocodificada')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','GEOCODED_ADDRESS'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#model#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.tableModelViewBase#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.grid#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.geoCoder#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Este tipo de elemento proporciona una funcionalidad de geocodificaci\00F3n (convertir una direcci\00F3n postal en una coordenada).<p>'),
unistr('<p>La geocodificaci\00F3n la lleva a cabo <em>el navegador</em> mediante una solicitud de REST al servicio de geocodificaci\00F3n de <strong>Oracle Elocation</strong> (elocation.oracle.com). Por lo tanto, el navegador debe conectarse a Internet para que la g')
||unistr('eocodificaci\00F3n funcione.</p>'),
unistr('<p>Los datos de entrada de geocodificaci\00F3n proceden de otros elementos de p\00E1gina, que se asignan a partes de la direcci\00F3n, como la calle, n\00FAmero de casa, c\00F3digo postal o ciudad. El geocodificador mostrar\00E1 una ventana emergente con una lista de posibl')
||unistr('es coincidencias. Tras elegir una coincidencia, el valor del estado de sesi\00F3n del elemento ser\00E1 la coordenada de direcci\00F3n en formato GeoJSON. Si se habilita <strong>Corregir direcci\00F3n</strong>, los elementos de p\00E1gina de la parte de direcci\00F3n se sob')
||unistr('rescribir\00E1n con los valores adecuados recibidos del servicio de geocodificaci\00F3n.</p>'),
unistr('<p>Para casos de uso m\00E1s simples, el modo <strong>Direcci\00F3n no estructurada</strong> permite asignar solo un campo o un \00E1rea de texto donde los usuarios finales introducen las partes de la direcci\00F3n separadas por comas. En este caso, el modo <strong>')
||unistr('Corregir direcci\00F3n</strong> no est\00E1 disponible.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1701330611413991.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Modo de coincidencia del geocodificador'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'RELAX_HOUSE_NUMBER'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>El <strong>modo de coincidencia</strong> determina cu\00E1nto deben coincidir los atributos de una direcci\00F3n de entrada con los datos utilizados para la geocodificaci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702013128418533.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4412)
,p_display_sequence=>10
,p_display_value=>'Exacto'
,p_return_value=>'EXACT'
,p_help_text=>unistr('<p>Todas las partes de la direcci\00F3n deben coincidir. No obstante, si el n\00FAmero de casa, el nombre de la calle o el tipo de calle no coinciden <em>todos</em>, se devuelve la primera coincidencia de c\00F3digo postal, localidad o regi\00F3n. Por ejemplo, si el')
||unistr(' nombre de la calle es incorrecto pero se ha especificado un c\00F3digo postal v\00E1lido, se devuelve una ubicaci\00F3n en el c\00F3digo postal.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702860244421796.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4412)
,p_display_sequence=>20
,p_display_value=>'Relajar tipo de calle'
,p_return_value=>'RELAX_STREET_TYPE'
,p_help_text=>unistr('<p>El <em>tipo de calle</em> proporcionado puede ser diferente a los datos utilizados para la geocodificaci\00F3n. Por ejemplo, <strong>Main Street</strong> o <strong>Main Blvd</strong> coinciden con <strong>Main St</strong>, si no hay otro <strong>Main ')
||unistr('Blvd</strong> u otra <strong>Main Street</strong> en el \00E1rea relevante.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1708669966452560.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Relajar n\00FAmero de casa')
,p_return_value=>'RELAX_HOUSE_NUMBER'
,p_help_text=>unistr('<p>El n\00FAmero de la casa y el tipo de calle pueden ser diferentes a los datos utilizados para la geocodificaci\00F3n. Por ejemplo, <strong>123 Main St</strong> coincide con <strong>123 Main Lane</strong> y <strong>124 Main St</strong>, siempre y cuando no')
||unistr(' haya ambig\00FCedades ni otras coincidencias.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1702428218420313.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4412)
,p_display_sequence=>40
,p_display_value=>'Relajar nombre de la calle'
,p_return_value=>'RELAX_BASE_NAME'
,p_help_text=>unistr('<p>El <em>nombre base</em> de la calle, el n\00FAmero de casa y el tipo de calle pueden ser diferentes a los datos utilizados para la geocodificaci\00F3n. Por ejemplo, <strong>Pleasant Vale</strong> coincide con <strong>Pleasant Valley</strong> siempre y cua')
||unistr('ndo no existan ambig\00FCedades ni otras coincidencias en los datos.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703440180425368.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4412)
,p_display_sequence=>50
,p_display_value=>unistr('Relajar c\00F3digo postal')
,p_return_value=>'RELAX_POSTAL_CODE'
,p_help_text=>unistr('<p>El c\00F3digo postal (si se proporciona), el nombre de la calle, el tipo de calle y el n\00FAmero de casa pueden ser diferentes a los datos utilizados para la geocodificaci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1703985342434956.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1701330611413991.4412)
,p_display_sequence=>60
,p_display_value=>'Relajar todo'
,p_return_value=>'RELAX_ALL'
,p_help_text=>unistr('<p>La direcci\00F3n puede estar fuera de la ciudad especificada siempre y cuando est\00E9 dentro del mismo distrito o regi\00F3n. Tambi\00E9n incluye las caracter\00EDsticas de <strong>Relajar c\00F3digo postal</strong>.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709401396458135.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Mostrar coordenadas en ventana emergente'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3010200212280744.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'GRID'
,p_help_text=>unistr('<p>Determine si desea que se muestren las coordenadas de la direcci\00F3n (longitud y latitud) en el di\00E1logo emergente de los resultados de geocodificaci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2105827892587713.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Vista previa de mapa'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'POPUP:ITEM'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Indique si desea permitir la vista previa de la direcci\00F3n geocodificada en un mapa.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601067718431827.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4412)
,p_display_sequence=>10
,p_display_value=>'Ventana emergente de resultados'
,p_return_value=>'POPUP'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Muestra el mapa en la ventana emergente de resultados de geocodificaci\00F3n para que los usuarios puedan revisar la posici\00F3n antes de seleccionar un resultado.</p>'),
unistr('<p>Este ajuste solo est\00E1 soportado si la opci\00F3n "Mostrar como - Vista de cuadr\00EDcula" se encuentra activada.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601404353432915.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2105827892587713.4412)
,p_display_sequence=>20
,p_display_value=>'Elemento'
,p_return_value=>'ITEM'
,p_help_text=>unistr('Muestra un mapa que visualiza la ubicaci\00F3n de direcci\00F3n en la posici\00F3n del elemento.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1744825789778265.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Segundo Plano'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Seleccione el mapa de fondo en el que desea que se muestren los resultados de la geocodificaci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746613534792926.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4412)
,p_display_sequence=>5
,p_display_value=>'Valor por Defecto'
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilice el fondo de mapa por defecto.</p>',
'<p>Se utiliza o "OpenStreetMap Bright" o "OpenStreetMap Dark" para los temas oscuros.</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745320076781973.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4412)
,p_display_sequence=>10
,p_display_value=>'Claro de OpenStreetMap'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso general basado en datos de OpenStreetMap. El estilo de este mapa base proporciona un contexto de ubicaci\00F3n detallado para los datos.</p>'),
'<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abierto de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1745780305787850.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4412)
,p_display_sequence=>20
,p_display_value=>'Oscuro de OpenStreetMap'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base oscuro discreto basado en datos de OpenStreetMap. El estilo de este mapa base acent\00FAa las visualizaciones de los datos.</p>'),
unistr('<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abierto de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY. Cartograf\00EDa de Stamen Design con licencia de CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1746150917790500.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Positr\00F3n de OpenStreetMap')
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base claro discreto basado en datos de OpenStreetMap. El estilo de este mapa base acent\00FAa las visualizaciones de los datos.</p>'),
unistr('<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abiertos de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY. Cartograf\00EDa de Stamen Design con licencia de CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2601367265556756.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1744825789778265.4412)
,p_display_sequence=>40
,p_display_value=>'Mapa mundial de Oracle'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso general basado en datos de HERE Map. El estilo de este mapa base proporciona contexto de la ubicaci\00F3n de los datos y acent\00FAa la visualizaci\00F3n de los mismos.</p>'),
'<p>Definiciones y esquemas de estilo de Oracle, USA.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2206585812380955.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Altura'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>unistr('p\00EDxeles')
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2105827892587713.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique la altura (en p\00EDxeles) del mapa que se muestra.</p>'),
'<p>Por defecto, la altura del mapa se calcula en base a su anchura con un ratio de aspecto de 3:2.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3010200212280744.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Mostrar como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'LIST'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Seleccione c\00F3mo se muestran los resultados de geocodificaci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011428457283918.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4412)
,p_display_sequence=>10
,p_display_value=>'Vista de Lista'
,p_return_value=>'LIST'
,p_help_text=>unistr('<p>Los resultados se mostrar\00E1n en una vista de lista.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3011010596282953.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3010200212280744.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Vista de Cuadr\00EDcula')
,p_return_value=>'GRID'
,p_help_text=>unistr('<p>Los resultados se mostrar\00E1n en una vista de cuadr\00EDcula.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1709967230470781.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>60
,p_prompt=>unistr('Direcci\00F3n estructurada')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Indica si las partes de la direcci\00F3n se han proporcionado al servicio de geocodificaci\00F3n de forma <em>estructurada</em> o <em>no estructurada</em>.</p>'),
unistr('<p>De forma estructurada significa que los elementos de p\00E1gina expl\00EDcitos se asignan a partes de la direcci\00F3n, como la calle, el c\00F3digo postal, la ciudad o la regi\00F3n. Esto produce resultados de geocodificaci\00F3n m\00E1s precisos, lo que tambi\00E9n permite que')
||' las direcciones corregidas ',
unistr('repercutan en los elementos de p\00E1gina.</p>'),
unistr('<p>De forma no estructurada significa que solo se ha utilizado un elemento para toda la direcci\00F3n y, adem\00E1s, las partes est\00E1n separadas por comas. Este modo no permite que las direcciones corregidas repercutan en los elementos de p\00E1gina.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1710428568474713.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>unistr('Tipo de pa\00EDs')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Seleccione si desea utilizar un pa\00EDs est\00E1tico para la geocodificaci\00F3n o si desea derivar el pa\00EDs de un elemento.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1710966154475523.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Est\00E1tico')
,p_return_value=>'STATIC'
,p_help_text=>unistr('<p>Utilice un pa\00EDs est\00E1tico de una lista de selecci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1711762868476607.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1710428568474713.4412)
,p_display_sequence=>20
,p_display_value=>'Elemento'
,p_return_value=>'ITEM'
,p_help_text=>unistr('<p>Obtenga el pa\00EDs de una aplicaci\00F3n o un elemento de p\00E1gina. El elemento debe contener el c\00F3digo ISO de dos d\00EDgitos para los pa\00EDses. </p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712263798480014.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('Pa\00EDs')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><strong>US</strong>: Estados Unidos</li>',
'<li><strong>UK</strong>: Reino Unido</li>',
'<li><strong>DE</strong>: Alemania</li>',
'<li><strong>AT</strong>: Austria</li>',
'</ul>'))
,p_help_text=>unistr('<p>Seleccione un elemento de p\00E1gina o aplicaci\00F3n desde el que obtener el pa\00EDs para la geocodificaci\00F3n. El elemento debe contener el c\00F3digo ISO de 2 d\00EDgitos para pa\00EDses.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1712712695483947.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>unistr('Pa\00EDs')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'US'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1710428568474713.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Seleccione el pa\00EDs que desea utilizar para la geocodificaci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713260223484493.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>10
,p_display_value=>'Estados Unidos'
,p_return_value=>'US'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1713640362485278.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>20
,p_display_value=>'Reino Unido'
,p_return_value=>'UK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1714942400488162.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>30
,p_display_value=>'Alemania'
,p_return_value=>'DE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715315187488602.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>40
,p_display_value=>'Francia'
,p_return_value=>'FR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1715776600489110.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>50
,p_display_value=>'Italia '
,p_return_value=>'IT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732218107588818.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>60
,p_display_value=>unistr('Canad\00E1')
,p_return_value=>'CA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1732613691589456.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>70
,p_display_value=>unistr('Pa\00EDses Bajos')
,p_return_value=>'NL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733039072590094.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>80
,p_display_value=>unistr('B\00E9lgica')
,p_return_value=>'BE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733467346590779.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>90
,p_display_value=>'Austria'
,p_return_value=>'AT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1733819745591632.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>100
,p_display_value=>'Suiza'
,p_return_value=>'CH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734205667592050.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>110
,p_display_value=>unistr('Espa\00F1a')
,p_return_value=>'ES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1734685684592583.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>120
,p_display_value=>'Portugal'
,p_return_value=>'PT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735060793593960.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>130
,p_display_value=>unistr('Federaci\00F3n Rusa')
,p_return_value=>'RU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735422526594737.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>140
,p_display_value=>'Estonia'
,p_return_value=>'EE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1735848786595289.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>150
,p_display_value=>'India'
,p_return_value=>'IN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736299306596060.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>160
,p_display_value=>unistr('M\00E9xico')
,p_return_value=>'MX'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1736643807596659.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>170
,p_display_value=>'Australia'
,p_return_value=>'AU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737040872597462.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>180
,p_display_value=>'Brasil'
,p_return_value=>'BR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737421643598208.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>190
,p_display_value=>'Chile'
,p_return_value=>'CL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1737878315598644.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>200
,p_display_value=>unistr('Rep\00FAblica Checa')
,p_return_value=>'CZ'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738298290599154.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>210
,p_display_value=>'Noruega'
,p_return_value=>'NO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1738640811599640.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>220
,p_display_value=>'Finlandia'
,p_return_value=>'FI'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739045295600254.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>230
,p_display_value=>'Dinamarca'
,p_return_value=>'DK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739492220600840.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>240
,p_display_value=>'Hong Kong'
,p_return_value=>'HK'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1739888238601924.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>250
,p_display_value=>'Irlanda'
,p_return_value=>'IE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740248023602467.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>260
,p_display_value=>'Letonia'
,p_return_value=>'LV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1740660821603187.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>270
,p_display_value=>unistr('Ruman\00EDa')
,p_return_value=>'RO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741021923603709.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>280
,p_display_value=>'Colombia'
,p_return_value=>'CO'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741493695604368.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>290
,p_display_value=>'Polonia'
,p_return_value=>'PL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1741819445604954.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>300
,p_display_value=>unistr('Emiratos \00C1rabes Unidos')
,p_return_value=>'AE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742273782605774.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>310
,p_display_value=>unistr('Hungr\00EDa')
,p_return_value=>'HU'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1742644763606445.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>320
,p_display_value=>unistr('Arabia Saud\00ED')
,p_return_value=>'SA'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1743094899606998.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1712712695483947.4412)
,p_display_sequence=>330
,p_display_value=>unistr('Sud\00E1frica')
,p_return_value=>'ZA'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1716542235497108.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>70
,p_prompt=>unistr('Elemento de direcci\00F3n')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('<p>Seleccione el elemento que contiene las partes de la direcci\00F3n no estructurada separadas por comas.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720233540512149.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>80
,p_prompt=>'Elemento de calle'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Seleccione el elemento que contiene la parte <em>Calle</em> de la direcci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1720738899514712.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>90
,p_prompt=>unistr('Elemento de n\00FAmero de casa')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Seleccione el elemento que contiene la parte <em>N\00FAmero de casa</em> de la direcci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721280838517001.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>120
,p_prompt=>unistr('Elemento de sub\00E1rea de ciudad')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Seleccione el elemento que contiene la parte <em>Sub\00E1rea (de una ciudad)</em> de la direcci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1721711111518708.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>110
,p_prompt=>'Elemento de ciudad'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Seleccione el elemento que contiene la parte <em>Ciudad</em> de la direcci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722254500520558.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('Elemento de c\00F3digo postal')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Seleccione el elemento que contiene la parte <em>C\00F3digo postal</em> de la direcci\00F3n.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1722749669524835.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>130
,p_prompt=>unistr('Elemento de regi\00F3n')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Seleccione el elemento que contiene la parte <em>Regi\00F3n (estado)</em> de la direcci\00F3n.</p>')
);
end;
/
begin
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1723298553527158.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('Corregir direcci\00F3n')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1709967230470781.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Habilite este cambio para que los datos de la direcci\00F3n del servicio de geocodificaci\00F3n repercutan en los elementos asignados.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727004690548379.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>135
,p_prompt=>'Elemento de vector de coincidencia'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el elemento de p\00E1gina al que desea que el geocodificador devuelva el <em>vector de coincidencia</em>. El vector de coincidencia es una cadena de 17 d\00EDgitos que incluye informaci\00F3n detallada sobre c\00F3mo coincide cada atributo de la direcc')
||unistr('i\00F3n con los datos utilizados para la geocodificaci\00F3n.</p>'),
unistr('<p><strong>Los d\00EDgitos del vector de coincidencia pueden tener los siguientes valores:</strong></p>'),
'<ul>',
'<li><p>0: El atributo de entrada no es nulo y coincide con un valor no nulo.</p></li>',
'<li><p>1: El atributo de entrada es nulo y coincide con un valor nulo.</p></li>',
'<li><p>2: El atributo de entrada no es nulo y se sustituye por un valor no nulo diferente.</p></li>',
'<li><p>3: El atributo de entrada no es nulo y se sustituye por un valor nulo.</p></li>',
'<li><p>4: El atributo de entrada es nulo y se sustituye por un valor no nulo.</p></li>',
'</ul>',
'<br>',
unistr('<p><strong>Los d\00EDgitos del vector de coincidencia y los atributos de la direcci\00F3n se corresponden cada uno con:</strong></p>'),
'<ul>',
unistr('<li><p>3: Punto de direcci\00F3n (direcci\00F3n exacta para los datos utilizados para la geocodificaci\00F3n)</p></li>'),
unistr('<li><p>4: Nombre del punto de inter\00E9s</p></li>'),
unistr('<li><p>5: N\00FAmero de casa</p></li>'),
'<li><p>6: Prefijo de calle</p></li>',
'<li><p>7: Nombre de calle</p></li>',
'<li><p>8: Sufijo de calle</p></li>',
'<li><p>9: Tipo de calle</p></li>',
'<li><p>10: Unidad secundaria</p></li>',
'<li><p>11: Ciudad</p></li>',
unistr('<li><p>14: Regi\00F3n</p></li>'),
unistr('<li><p>15: Pa\00EDs</p></li>'),
unistr('<li><p>16: C\00F3digo postal</p></li>'),
unistr('<li><p>17: C\00F3digo de complemento postal</p></li>'),
unistr('<li><p><em>el resto de d\00EDgitos todav\00EDa no se han utilizado.</em></p></li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1727549870549765.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Activar geocodificaci\00F3n')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AUTOMATIC'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Determine cu\00E1ndo desea activar la geocodificaci\00F3n. Esto incluye la solicitud de REST que realiza el navegador al servicio de geocodificaci\00F3n y la visualizaci\00F3n de la ventana emergente con las posibles coincidencias.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728048005551626.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Autom\00E1tico')
,p_return_value=>'AUTOMATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>La geocodificaci\00F3n se dispara de forma autom\00E1tica antes de enviar la p\00E1gina.</p>'),
unistr('<p>Si el valor de un elemento dependiente ha cambiado, como  el valor de <em>P1_STREET</em>, y la geocodificaci\00F3n no se ha ejecutado hasta ahora o no se ha seleccionado una direcci\00F3n v\00E1lida, nos aseguraremos de que la geocodificaci\00F3n se dispare autom')
||unistr('\00E1ticamente. En este caso, interrumpiremos el flujo de env\00EDo del env\00EDo de la p\00E1gina actual y mostraremos una ventana emergente con posibles coincidencias primero. Si el usuario elige un resultado coincidente, se podr\00E1 volver a enviar la p\00E1gina sin m\00E1s')
||' interrupciones.</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728439221554365.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Acci\00F3n Din\00E1mica')
,p_return_value=>'DYNAMIC_ACTION'
,p_help_text=>unistr('<p>La geocodificaci\00F3n debe dispararse agregando la acci\00F3n din\00E1mica <em>Disparar geocodificaci\00F3n</em> para la p\00E1gina.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1728803167561342.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1727549870549765.4412)
,p_display_sequence=>30
,p_display_value=>'Selector de jQuery'
,p_return_value=>'JQUERY_SELECTOR'
,p_help_text=>unistr('<p>La geocodificaci\00F3n se dispara en funci\00F3n de un evento del elemento DOM definido como destino por el selector. Si se hace referencia a un campo de entrada, la geocodificaci\00F3n se dispara al producirse un <em>cambio</em> en el elemento; si se hace re')
||unistr('ferencia a un bot\00F3n, la geocodificaci\00F3n se disparar\00E1 <em>al hacer clic</em>.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1747463542804307.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1727549870549765.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JQUERY_SELECTOR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Ejecutar el proceso cuando haya cambios en los elementos <em>P1_STREET</em> y <em>P1_ZIP_CODE</em>, selector de jQuery:</p>',
'<pre>',
'#P1_STREET,#P1_ZIP_CODE',
'</pre>'))
,p_help_text=>unistr('<p>Proporcione el selector de jQuery que hace referencia al elemento que activa la geocodificaci\00F3n. Los botones activar\00E1n la geocodificaci\00F3n <em>al hacer clic</em>, mientras que otros elementos la activar\00E1n <em>al hacer cambios</em>.</p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982963519254231.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_name=>'apexgeocoderresponse'
,p_display_name=>unistr('Respuesta de geocodificaci\00F3n')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(12982639254254214.4412)
,p_plugin_id=>wwv_flow_api.id(1700838675352758.4412)
,p_name=>'apexgeocoderselection'
,p_display_name=>unistr('Selecci\00F3n de resultados')
);
end;
/
prompt --application/shared_components/plugins/region_type/smart_filters
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800664597261423.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SMART_FILTERS'
,p_display_name=>'Filtros inteligentes'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SMART_FILTERS'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('<p>Una regi\00F3n basada en el origen de los filtros inteligentes asociados, que proporciona numerosos filtros a los usuarios finales para ajustar los resultados de b\00FAsqueda en el tiempo de ejecuci\00F3n. </p>')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816085788971276.4412)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('M\00E1ximo de chips de sugerencia')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>unistr('Especifique el n\00FAmero m\00E1ximo de chips de sugerencia que se mostrar\00E1n. Si no se especifica un n\00FAmero, se usar\00E1 el valor por defecto de 5.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1816321935999387.4412)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('M\00E1s filtros de chip de sugerencia')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si los filtros que no se muestran como chips de sugerencia se pueden seleccionar mediante el bot\00F3n de men\00FA desplegable M\00E1s filtros.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1808803156261456.4412)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Umbral de n\00FAmeros compacto')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10000'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('Proporcione un valor de umbral por encima del cual se mostrar\00E1n los recuentos utilizando un formato de n\00FAmero compacto. Con dicho formato, un valor <strong>1234</strong> se mostrar\00E1 como <strong>1K</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801137838146661.4412)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mostrar Recuento Total de Filas'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Especifique si se va a mostrar el recuento total de filas.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801499572149580.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4412)
,p_display_sequence=>10
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>'No se muestra el recuento total de filas.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1801880772227865.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4412)
,p_display_sequence=>20
,p_display_value=>unistr('S\00ED')
,p_return_value=>'Y'
,p_help_text=>'El recuento total de filas se muestra debajo de los chips de sugerencia.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1802207279232480.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1801137838146661.4412)
,p_display_sequence=>30
,p_display_value=>'Selector'
,p_return_value=>'E'
,p_help_text=>unistr('El recuento total de filas (sin ninguna etiqueta) se muestra dentro del elemento especificado por este selector. Esto permite colocar el recuento total de filas en pr\00E1cticamente cualquier lugar de la p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802866258261858.4412)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Etiqueta de recuento total de filas'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Etiqueta que se utiliza para el recuento total de filas. Si aqu\00ED no se proporciona ninguna etiqueta, APEX utilizar\00E1 el mensaje de texto APEX.FS.TOTAL_ROW_COUNT_LABEL.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803111571268834.4412)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Selector del recuento total de filas'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801137838146661.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'E'
,p_examples=>'#totalRowCountSpan'
,p_help_text=>unistr('Este es el selector de un elemento en la p\00E1gina donde la regi\00F3n de filtros inteligentes mostrar\00E1 el recuento total de filas.')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1812244001261470.4412)
,p_plugin_id=>wwv_flow_api.id(1800664597261423.4412)
,p_name=>'facetschange'
,p_display_name=>'Cambio de filtros'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/oci
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1900426248156512.4412)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'OCI'
,p_display_name=>'OCI'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','OCI'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/adfbc
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2200372246708480.4412)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ADFBC'
,p_display_name=>'ADF BC'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ADFBC'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/web_source_type/ords
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2302882720656544.4412)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_name=>'ORDS'
,p_display_name=>'ORDS'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('WEB SOURCE TYPE','ORDS'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700889063556536.4412)
,p_plugin_id=>wwv_flow_api.id(2302882720656544.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Devuelve JSON de ORDS heredado'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Active esta opci\00F3n si este servicio REST de ORDS devuelve datos en la <em>representaci\00F3n de JSON heredado de ORDS</em>.')
);
end;
/
prompt --application/shared_components/plugins/item_type/search
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2606845974894125.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SEARCH'
,p_display_name=>'Buscar'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SEARCH'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:PLACEHOLDER:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un campo de texto, que permite que el usuario final busque la lista de entradas de las facetas de la regi\00F3n de B\00FAsqueda por facetas. Una regi\00F3n de B\00FAsqueda por facetas soporta una faceta de b\00FAsqueda, que siempre estar\00E1 al principio de la list')
||'a de facetas, sin importar su secuencia.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2607008165899744.4412)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Tipo de B\00FAsqueda')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ROW'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607312816901820.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4412)
,p_display_sequence=>10
,p_display_value=>unistr('B\00FAsqueda de fila')
,p_return_value=>'ROW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2607759273903144.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2607008165899744.4412)
,p_display_sequence=>20
,p_display_value=>'Oracle Text'
,p_return_value=>'ORACLE_TEXT'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2608156895911496.4412)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Campo de Entrada'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FACET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608417903912546.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Parte superior de la regi\00F3n de b\00FAsqueda de facetas')
,p_return_value=>'FACET'
,p_help_text=>unistr('Se presentar\00E1 un campo de b\00FAsqueda sobre la regi\00F3n de b\00FAsqueda de facetas, encima de las facetas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2608887428914009.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2608156895911496.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Elemento de p\00E1gina externa')
,p_return_value=>'PAGE_ITEM'
,p_help_text=>unistr('Se puede seleccionar un elemento de p\00E1gina mediante el atributo Elemento de p\00E1gina externa asociado, que se utilizar\00E1 como campo de b\00FAsqueda para la regi\00F3n de b\00FAsqueda de facetas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2609288187919863.4412)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Elemento de p\00E1gina externo')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2608156895911496.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2205297904876322.4412)
,p_plugin_id=>wwv_flow_api.id(2606845974894125.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Campo de b\00FAsqueda reducido')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_SFILTERS'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si el campo de b\00FAsqueda de filtros inteligentes debe estar reducido inicialmente.')
);
end;
/
prompt --application/shared_components/plugins/region_type/map_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2801375174221512.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'MAP_REGION'
,p_display_name=>'Mapa'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','MAP_REGION'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.spatialMap#MIN#.js'))
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/mapbox-gl-js/1.13.0/mapbox-gl-apex.css',
''))
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(2801502987221529.4412)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4412)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501189800179937.4412)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4412)
,p_name=>'spatialmapchanged'
,p_display_name=>'Mapa cambiado'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501913148179938.4412)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4412)
,p_name=>'spatialmapclick'
,p_display_name=>'Mapa en el que se ha hecho clic'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2500840574179919.4412)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4412)
,p_name=>'spatialmapinitialized'
,p_display_name=>'Mapa inicializado'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(2501516390179938.4412)
,p_plugin_id=>wwv_flow_api.id(2801375174221512.4412)
,p_name=>'spatialmapobjectclick'
,p_display_name=>'Objeto de mapa en el que se ha hecho clic'
);
end;
/
prompt --application/shared_components/plugins/region_type/form
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3128550315022076.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'FORM'
,p_display_name=>'Pantalla'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','FORM'),'')
,p_api_version=>2
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:EDITABLE'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Regi\00F3n de pantalla que soporta diferentes or\00EDgenes de datos. Esta regi\00F3n de pantalla contiene informaci\00F3n sobre el origen de los datos (que puede ser local, remoto o servicio REST) y tiene elementos de p\00E1gina asignados. Cada elemento de p\00E1gina est\00E1 a')
||unistr('signado a una regi\00F3n de pantalla y a una regi\00F3n de visualizaci\00F3n.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3128740851022088.4412)
,p_plugin_id=>wwv_flow_api.id(3128550315022076.4412)
,p_name=>'SOURCE_LOCATION'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3129968725049081.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_DML'
,p_display_name=>unistr('Pantalla - Procesamiento autom\00E1tico de filas (DML)')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_DML'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Proceso para insertar, actualizar o suprimir filas de la regi\00F3n de pantalla.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3130191485054761.4412)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'tipo de objetivo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione qu\00E9 t\00E9cnica de procesamiento de filas se utiliza para guardar los cambios de datos realizados en la regi\00F3n de pantalla.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3130418909057477.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Origen de Regi\00F3n')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inserta, actualiza y suprime la utilizaci\00F3n de la consulta SQL de origen de regi\00F3n.</p>'),
unistr('<p>Nota: Aseg\00FArese de que las columnas que no se pueden insertar o actualizar tengan <strong>Solo Consulta</strong> definida en <code>S\00ED</code> para excluirlas del procesamiento.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131111455059474.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4412)
,p_display_sequence=>20
,p_display_value=>'Tabla/Vista'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inserta, actualiza y suprime la utilizaci\00F3n de una tabla o vista diferente en la definida en la consulta SQL de origen de regi\00F3n.'),
unistr('Por ejemplo, la consulta SQL recupera datos de una uni\00F3n de tabla o una vista no actualizable y el procesamiento DML se debe realizar con una sola tabla base o una vista actualizable.</p>'),
unistr('<p>Nota: Aseg\00FArese de que las columnas que no se pueden insertar o actualizar tengan <strong>Solo Consulta</strong> definida en <code>S\00ED</code> para excluirlas del procesamiento.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3131849869061275.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3130191485054761.4412)
,p_display_sequence=>30
,p_display_value=>unistr('C\00F3digo PL/SQL')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El procesamiento se basa en c\00F3digo PL/SQL personalizado. Esta opci\00F3n permite ejecutar cualquier c\00F3digo PL/SQL para implantar cualquier manipulaci\00F3n de datos en la base de datos subyacente.</p>'),
unistr('<p>Esta opci\00F3n se debe utilizar al utilizar paquetes de base de datos, como API de tabla o llamadas a servicios web RESTful para implantar la l\00F3gica de negocio.</p>'),
unistr('<p>Nota: Se llamar\00E1 al c\00F3digo PL/SQL para cada fila que se haya insertado, actualizado o suprimido.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132468628068159.4412)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Propietario de Tabla'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Seleccione el nombre del propietario de la tabla (esquema).'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3132746852071841.4412)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nombre de la Tabla'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(3132468628068159.4412)
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Introduzca el nombre de vista o tabla sensible a may\00FAsculas/min\00FAsculas. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133042217093897.4412)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('C\00F3digo PL/SQL para Insertar/Actualizar/Suprimir')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca c\00F3digo PL/SQL para procesar cada fila de datos manipulados en la regi\00F3n de pantalla.</p>'),
'<p>Utilice el nombre de columna como una variable de enlace para acceder al valor de una columna. La variable del sistema <code>APEX$ROW_STATUS</code> devuelve el estado de una fila y se puede utilizar para comprobar si se ha creado, actualizado o su'
||unistr('primido la fila (consulte el siguiente ejemplo para obtener informaci\00F3n sobre c\00F3mo comprobar esto).</p>'),
unistr('<p><em>Nota:</em> Si las columnas de clave primaria las rellena un disparador o se rellenan en el c\00F3digo PL/SQL, es necesario que los nuevos valores se asignen a las variables de enlace de las columnas de clave primaria, ya que &PRODUCT_NAME. utiliza')
||unistr(' estos valores para recuperar la fila despu\00E9s de una inserci\00F3n o actualizaci\00F3n.</p>'),
unistr('<p>Oracle recomienda llamar a los procedimientos o funciones dentro de un paquete PL/SQL para facilitar la reutilizaci\00F3n y la capacidad de mantenimiento.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3133532996097347.4412)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Evitar Actualizaciones Perdidas'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique si el procesamiento debe garantizar que no se pierdan las actualizaciones cuando varios usuarios actualicen el mismo registro de base de datos.</p> ',
unistr('<p>Las actualizaciones se pierden cuando dos o m\00E1s personas intentan actualizar los mismos datos y la \00FAltima actualizaci\00F3n sobrescribe las actualizaciones realizadas por el primer usuario al guardar los cambios. Para evitar que esto ocurra, las actua')
||unistr('lizaciones pueden comprobar los valores de columna existentes en la base de datos con los valores recuperados cuando se consult\00F3 la fila originalmente.</p>'),
'<p>Por ejemplo:',
'  <ol>',
'    <li>El usuario A consulta registros de empleado (EMP).</li>',
'    <li>El usuario B consulta los mismos registros de empleado.</li>',
'    <li>El usuario B actualiza los detalles de empleado de EMPNO = 7839 y aplica (confirma) los cambios en la base de datos.</li>',
'    <li>El usuario A actualiza los detalles de empleado de EMPNO = 7839 e intenta aplicar los cambios en la base de datos.</li>',
'  </ol>',
unistr('Si el usuario A actualiza correctamente la misma fila, los cambios realizados por el usuario B se perder\00E1n.'),
unistr('Cuando el usuario A intenta guardar la fila de empleado, los datos de la base de datos son diferentes a los que el usuario A consult\00F3 originalmente. En el paso 1 descrito anteriormente, los valores de columna consultados originalmente por el usuario ')
||unistr('A se pueden capturar. A continuaci\00F3n, en el paso 4, los valores se pueden comparar con los valores actuales de la base de datos. Esta comparaci\00F3n generar\00E1 un error para el usuario A, ya que los valores de la base de datos fueron actualizados por el u')
||'suario B en el paso 3. Esto evita que un usuario sobrescriba los cambios realizados por otro usuario en la misma fila.</p>',
unistr('<p>Nota: La forma en que se detectan las actualizaciones perdidas se especifica en la regi\00F3n Atributos para la Cuadr\00EDcula Interactiva, seg\00FAn el valor de <strong>Tipo de Actualizaci\00F3n Perdida</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3134090605099409.4412)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Bloquear Fila'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Seleccione si cada fila que se vaya a actualizar o suprimir se bloquea en la tabla subyacente antes de procesar la fila.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3134396093101055.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4412)
,p_display_sequence=>10
,p_display_value=>unistr('S\00ED')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las filas que se van a actualizar o suprimir se bloquear\00E1n mediante SELECT ... FOR UPDATE para evitar que se realicen otras transacciones en la fila hasta que se confirme la transacci\00F3n.</p>'),
unistr('<p>Nota: Si se genera un error, como, por ejemplo, para las vistas actualizables que no soportan el bloqueo, debe poder utilizar c\00F3digo PL/SQL para bloquear la tabla de control.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135017839102248.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4412)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>unistr('Las filas no se bloquear\00E1n.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3135486454103394.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3134090605099409.4412)
,p_display_sequence=>30
,p_display_value=>unistr('C\00F3digo PL/SQL')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('El c\00F3digo PL/SQL personalizado se utilizar\00E1 para bloquear las filas hasta que se confirme la transacci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136083157108563.4412)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('C\00F3digo PL/SQL para Bloquear Fila')
,p_attribute_type=>'PLSQL'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3134090605099409.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('Introduzca el c\00F3digo PL/SQL para bloquear las filas de la tabla de base de datos que se van a actualizar y suprimir.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3136593347114047.4412)
,p_plugin_id=>wwv_flow_api.id(3129968725049081.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Devolver Claves Primarias tras Inserci\00F3n')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3130191485054761.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione si las columnas de clave primaria se deben devolver a los elementos de regi\00F3n correspondientes una vez que la fila se inserta en la base de datos.'),
unistr('Generalmente, esta opci\00F3n se debe utilizar cuando las columnas de clave primaria se rellenan con un disparador de base de datos o una columna Identidad de Oracle Database 12 <em>c</em>.</p>'),
unistr('<p>Nota: Si se genera un error que especifica que la cl\00E1usula RETURNING INTO no est\00E1 permitida, debe definir esta opci\00F3n en No y rellenar previamente las columnas de clave primaria.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_init
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3136784192133583.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_INIT'
,p_display_name=>unistr('Pantalla - Inicializaci\00F3n')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_INIT'),'')
,p_api_version=>2
,p_standard_attributes=>'FORM'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Proceso para inicializar los elementos de la regi\00F3n de pantalla. La inicializaci\00F3n puede consistir o bien en la recuperaci\00F3n de datos del origen de la regi\00F3n, utilizando los valores de la clave primaria, o bien en la inicializaci\00F3n sencilla de los el')
||unistr('ementos de la regi\00F3n de pantalla.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1672950586323461.4412)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Siguientes elementos de clave primaria'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673291445325769.4412)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Anteriores elementos de clave primaria'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1673579797330204.4412)
,p_plugin_id=>wwv_flow_api.id(3136784192133583.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Fila actual/Total de elementos'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/process_type/data_loading
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3205849286768480.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'DATA_LOADING'
,p_display_name=>'Carga de Datos'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','DATA_LOADING'),'')
,p_api_version=>2
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Proceso para cargar los datos en la recopilaci\00F3n o tabla de destino en funci\00F3n de la definici\00F3n de carga de datos especificada.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206362206778771.4412)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Definici\00F3n de Carga de Datos')
,p_attribute_type=>'DATA LOAD DEFINITION ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione la <strong>definici\00F3n de carga de datos</strong> en Componentes compartidos. Entre otros atributos, la definici\00F3n de carga de datos define la recopilaci\00F3n o tabla de destino, el m\00E9todo de carga y el <em>perfil de datos</em>. Toda la inform')
||unistr('aci\00F3n sobre el tipo de datos, la asignaci\00F3n de la columna y el nombre de la columna se almacena en el perfil de datos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3206568816782155.4412)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Tipo de Dato Origen'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FILE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Especifique el origen de los datos que cargar.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3206878557783527.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Elemento de exploraci\00F3n de archivos')
,p_return_value=>'FILE'
,p_help_text=>unistr('Seleccione el nombre de un elemento de exploraci\00F3n de archivos en la p\00E1gina actual. APEX cargar\00E1 los datos del archivo seleccionado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207319585784462.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Nombre del elemento de \00E1rea de texto')
,p_return_value=>'TEXT'
,p_help_text=>unistr('Seleccione el nombre de un elemento de \00E1rea de texto, que contiene los datos que cargar.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3207692626786156.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3206568816782155.4412)
,p_display_sequence=>30
,p_display_value=>'Consulta SQL'
,p_return_value=>'SQL_QUERY'
,p_help_text=>unistr('Proporciona una consulta SQL que devuelve un m\00E9todo CLOB o BLOB que contenga los datos que cargar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208086445789769.4412)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Elemento de exploraci\00F3n de archivos')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FILE'
,p_help_text=>unistr('Seleccione el elemento de exploraci\00F3n de archivos desde el que cargar los datos. El elemento debe utilizar <strong>APEX_APPLICATION_TEMP_FILES</strong> como su <strong>tipo de almacenamiento</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208411305791534.4412)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Elemento de \00E1rea de texto')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('Seleccione el nombre de un elemento de \00E1rea de texto, que contiene los datos que cargar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3208742752793524.4412)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Consulta SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(3206568816782155.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_QUERY'
,p_help_text=>'Proporcione una consulta SQL que devuelva una fila y una columna, que contiene un BLOB o CLOB desde el que cargar los datos.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3209026300796805.4412)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Elemento de p\00E1gina que contiene el nombre de la hoja XLSX')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Un elemento de lista de valores emergente o lista de selecci\00F3n para mostrar las hojas de trabajo disponibles en el archivo XLSX cargado utilizar\00EDa la siguiente <em>consulta SQL de lista de valores</em> (<strong>PX_FILE</strong> es el elemento de e')
||unistr('xploraci\00F3n de archivos que se utiliza para cargar el archivo XLSX).</p><p>Tenga en cuenta que el atributo <strong>SHEET_FILE_NAME</strong> se debe utilizar como la columna de retorno de la lista de valores.</p>'),
'<pre>',
'select s.sheet_display_name display, ',
'       s.sheet_file_name    return',
'  from apex_application_temp_files f,',
'       table( <strong>apex_data_parser.get_xlsx_worksheets</strong>( p_content => f.blob_content ) ) s',
' where f.name = :PX_FILE',
'</pre>'))
,p_help_text=>unistr('<p>Proporcione un elemento de p\00E1gina que contenga un nombre de hoja de trabajo para cargar los archivos XLSX. Los datos se cargar\00E1n desde la hoja de trabajo especificada. Si no se proporciona, APEX cargar\00E1 los datos de la primera hoja de trabajo en e')
||unistr('l archivo XLSX.</p><p>Normalmente, se suelen utilizar elementos de <em>listas de selecci\00F3n</em> para esto: en la <em>consulta Lista de valores</em>, utilice <strong>APEX_DATA_PARSER.GET_XLSX_WORKSHEETS</strong> para recuperar los nombres internos y m')
||'ostrados de la hoja de trabajo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1319771677848714.4412)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Elemento de recuento de filas procesadas'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione un elemento de p\00E1gina en el que almacenar la cantidad de filas cargadas (y procesadas). El valor est\00E1 disponible una vez que el proceso de carga de datos se completa y se puede utilizar para mostrarlo en los mensajes.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1320047176851343.4412)
,p_plugin_id=>wwv_flow_api.id(3205849286768480.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Elemento de recuento de filas con error'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione un elemento de p\00E1gina en el que almacenar la cantidad de filas con errores. El valor est\00E1 disponible una vez que el proceso de carga de datos se completa y se puede utilizar para mostrarlo en los mensajes.')
);
end;
/
prompt --application/shared_components/plugins/item_type/range
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4386180889228297.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RANGE'
,p_display_name=>'Rango'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RANGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:ELEMENT:ENCRYPT:LOV:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Muestra un elemento con un selector de lista de valores incorporado. La faceta soporta selecci\00F3n \00FAnica o m\00FAltiple, as\00ED como la entrada manual. En el caso del soporte de selecci\00F3n \00FAnica, muestra varios valores como opciones de grupo de botones de r')
||unistr('adio, lo que permite al usuario final seleccionar un solo valor. En el caso del soporte de selecci\00F3n m\00FAltiple, muestra varios valores como casillas de control, lo que permite al usuario final seleccionar varios valores. En el caso del soporte de entr')
||unistr('ada manual, los campos de texto aparecer\00E1n bajo la faceta, lo que permite al usuario final introducir manualmente el rango de valores que desea usar para el filtrado de la regi\00F3n Filtrados.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513920677752961.4412)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Seleccionar Varios Archivos'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si la faceta soporta la selecci\00F3n de varias entradas de lista. Cuando se define en <strong>Activado</strong>, la faceta se mostrar\00E1 como casillas de control para permitir la selecci\00F3n m\00FAltiple. Cuando se define en <strong>Desactivado</str')
||unistr('ong>, la faceta aparecer\00E1 como opciones de grupo de botones de radio para permitir la selecci\00F3n \00FAnica.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2513635447749258.4412)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Entrada Manual'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si la faceta de rango soporta la entrada manual. Cuando se define en <strong>Activado</strong>, los campos de texto aparecer\00E1n bajo la faceta, lo que permite al usuario final introducir manualmente el rango de valores que desea usar para ')
||unistr('filtrar la regi\00F3n Filtrados.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4386359236228299.4412)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Texto de rango'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Introduzca el texto que se va a mostrar entre los campos de texto de Entrada manual.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476028199560899.4412)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Etiqueta actual'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'De 0% a %1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728478221838569501.4412)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Etiqueta actual apertura superior'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Por encima de %0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728476302635562853.4412)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Etiqueta actual apertura inferior'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2513635447749258.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Por debajo de %0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(4390664988228304.4412)
,p_plugin_id=>wwv_flow_api.id(4386180889228297.4412)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores basada en consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores con el mismo valor de retorno y visualizaci\00F3n</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Nota: al seleccionar la misma columna para los valores de retorno y visualizaci\00F3n, utilice un alias de columna.</p>'),
'</dd>',
'<dt>Lista de valores con variable de enlace</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: defina el atributo <em>Elementos Principales de Lista de Valores en Cascada</em> en <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> es un elemento de p\00E1gina modificable en la misma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/display_map
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8870444141116576.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_MAP'
,p_display_name=>unistr('Mapa de visualizaci\00F3n')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_MAP'),'')
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.miniMap#MIN#.js',
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.displayMap#MIN#.js'))
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Muestra un mapa basado en coordenadas en formato de punto de GeoJSON.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9070464796133078.4412)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Segundo Plano'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'default'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Seleccione el mapa de fondo que se va a utilizar.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9070760381135077.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4412)
,p_display_sequence=>10
,p_display_value=>'Valor por Defecto'
,p_return_value=>'default'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Utilice el fondo de mapa por defecto.</p>',
'<p>Se utiliza o "OpenStreetMap Bright" o "OpenStreetMap Dark" para los temas oscuros.</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071162492136081.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4412)
,p_display_sequence=>20
,p_display_value=>'Claro de OpenStreetMap'
,p_return_value=>'osm-bright'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso general basado en datos de OpenStreetMap. El estilo de este mapa base proporciona un contexto de ubicaci\00F3n detallado para los datos.</p>'),
'<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abierto de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY.</p>',
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/osm-bright-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071529690137784.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4412)
,p_display_sequence=>30
,p_display_value=>'Oscuro de OpenStreetMap'
,p_return_value=>'osm-dark-matter'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base oscuro discreto basado en datos de OpenStreetMap. El estilo de este mapa base acent\00FAa las visualizaciones de los datos.</p>'),
unistr('<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abierto de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY. Cartograf\00EDa de Stamen Design con licencia de CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/dark-matter-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9071983425139542.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4412)
,p_display_sequence=>40
,p_display_value=>unistr('Positr\00F3n de OpenStreetMap')
,p_return_value=>'osm-positron'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base claro discreto basado en datos de OpenStreetMap. El estilo de este mapa base acent\00FAa las visualizaciones de los datos.</p>'),
unistr('<p>Definiciones y esquemas de estilo de contribuyentes de KlokanTech.com y OpenMapTiles, procedentes de estilos abiertos de Mapbox ("Mapbox Open Styles"). Con licencia de BSD/CC-BY. Cartograf\00EDa de Stamen Design con licencia de CC0.</p>'),
'<p><a rel="noreferrer" href="https://github.com/openmaptiles/positron-gl-style" target="_blank">Ver en GitHub</a></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9072395929141067.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(9070464796133078.4412)
,p_display_sequence=>50
,p_display_value=>'Mapa mundial de Oracle'
,p_return_value=>'world-map'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Mapa base de uso general basado en datos de HERE Map. El estilo de este mapa base proporciona contexto de la ubicaci\00F3n de los datos y acent\00FAa la visualizaci\00F3n de los mismos.</p>'),
'<p>Definiciones y esquemas de estilo de Oracle, USA.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9072916496197068.4412)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nivel de zoom'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'14'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique el nivel de zoom para que esta capa sea visible.</p>',
'<p>',
unistr('Valor m\00EDnimo: 1<br>'),
unistr('Valor m\00E1ximo: 18'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073279785199355.4412)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Mostrar marcador'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('<p>Especifique si deber\00EDa aparecer un marcador.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073555327202501.4412)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Color de marcador'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique el color del relleno del marcador.</p>',
unistr('<p>El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML. La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representa')
||unistr('n los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente. Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, re')
||'spectivamente.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9075223673219708.4412)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Pista'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9073279785199355.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique el texto de pista para un marcador que se muestra.</p>',
'<p>El atributo de pista soporta las directivas de plantilla HTML y APEX.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9073839532205482.4412)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Mostrar controles de mapa'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si deber\00EDan aparecer los controles de mapa.</p>'),
unistr('<p>Esto agrega controles de zoom y rotaci\00F3n al mapa.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9074137581210550.4412)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Mapa interactivo'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si el mapa deber\00EDa ser interactivo.</p>'),
unistr('<p>Si se establece "No", se crear\00E1 un mapa est\00E1tico sin interactividad.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11976499186792296.4412)
,p_plugin_id=>wwv_flow_api.id(8870444141116576.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Altura'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>unistr('p\00EDxeles')
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique la altura (en p\00EDxeles) del mapa que se muestra.</p>'),
'<p>Por defecto, la altura del mapa se calcula en base a su anchura con un ratio de aspecto de 3:2.</p>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11251017839289082.4412)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'EXISTS'
,p_display_name=>'Consulta SQL Exists'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Consulta que hace que se apruebe el esquema de autorizaci\00F3n si devuelve al menos una fila y provoca que \00E9ste falle si no devuelve ninguna.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11251530568311696.4412)
,p_plugin_id=>wwv_flow_api.id(11251017839289082.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Consulta SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''ADMIN''',
'</pre>'))
,p_help_text=>unistr('Consulta que hace que se apruebe el esquema de autorizaci\00F3n si devuelve al menos una fila y provoca que \00E9ste falle si no devuelve ninguna.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/not_exists
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252021695318665.4412)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'NOT_EXISTS'
,p_display_name=>'Consulta SQL NOT Exists'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','NOT_EXISTS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Consulta que hace que se apruebe el esquema de autorizaci\00F3n si no devuelve ninguna fila y provoca que \00E9ste falle si devuelve una o m\00E1s filas.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252200009321795.4412)
,p_plugin_id=>wwv_flow_api.id(11252021695318665.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Consulta SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select null',
'  from apex_workspace_group_users',
' where user_name  = :APP_USER',
'   and group_name = ''GUEST''',
'</pre>'))
,p_help_text=>unistr('Consulta que hace que falle el esquema de autorizaci\00F3n si devuelve al menos una fila y provoca que \00E9ste se apruebe si no devuelve ninguna.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11252712476325388.4412)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NULL'
,p_display_name=>'El Elemento es NULL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'El valor del elemento es nulo.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11252900140331368.4412)
,p_plugin_id=>wwv_flow_api.id(11252712476325388.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_display_length=>30
,p_is_translatable=>false
,p_help_text=>unistr('La autorizaci\00F3n es correcta si el valor de este elemento es nulo y falla de lo contrario.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_is_not_null
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11253409836334113.4412)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_IS_NOT_NULL'
,p_display_name=>'El Elemento Es NOT NULL'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_IS_NOT_NULL'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'El valor del elemento no es nulo.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11253615031335591.4412)
,p_plugin_id=>wwv_flow_api.id(11253409836334113.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('La autorizaci\00F3n es correcta si el valor de este elemento no es nulo y falla de lo contrario.')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/function_body
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11254106158342546.4412)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'FUNCTION_BODY'
,p_display_name=>unistr('Funci\00F3n PL/SQL que Devuelve Valor Booleano')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','FUNCTION_BODY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve true o false. Un valor false provoca el fallo del esquema de autorizaci\00F3n. Un valor true provoca su aprobaci\00F3n.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11254314469344909.4412)
,p_plugin_id=>wwv_flow_api.id(11254106158342546.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
,p_attribute_type=>'PLSQL FUNCTION BODY BOOLEAN'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Cuerpo de la funci\00F3n PL/SQL que devuelve true o false. Un valor false causa el fallo del esquema de autorizaci\00F3n. Un valor true causa su aprobaci\00F3n.'),
'<p/>',
'Ejemplo:',
'<pre>',
'return to_char(sysdate,''hh24'') between ''08'' and ''17'';',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11255012523353865.4412)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_EQUALS_VALUE'
,p_display_name=>'La Preferencia es Igual al Valor'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'El valor de la preferencia es igual al valor.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255227067358013.4412)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nombre de la Preferencia'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('La autorizaci\00F3n es correcta si el valor de esta preferencia es igual al valor del campo siguiente y falla si es diferente')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11255701918360235.4412)
,p_plugin_id=>wwv_flow_api.id(11255012523353865.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('consulte la informaci\00F3n anterior')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/pref_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11257015209373543.4412)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'PREF_NOT_EQUALS_VALUE'
,p_display_name=>'La Preferencia NO Es Igual al Valor'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','PREF_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'El valor de la preferencia no es igual al valor.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257220750375150.4412)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nombre de la Preferencia'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('La autorizaci\00F3n es correcta si el valor de esta preferencia es diferente al valor del campo siguiente y falla si es igual')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11257725944376646.4412)
,p_plugin_id=>wwv_flow_api.id(11257015209373543.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('consulte la informaci\00F3n anterior')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11258208760381085.4412)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_EQUALS_VALUE'
,p_display_name=>'El Elemento Es Igual al Valor'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'El valor del elemento es igual al valor.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258417764383723.4412)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('La autorizaci\00F3n es correcta si el valor de este elemento es igual al valor del campo siguiente y falla si es diferente')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11258925383385933.4412)
,p_plugin_id=>wwv_flow_api.id(11258208760381085.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('consulte la informaci\00F3n anterior')
);
end;
/
prompt --application/shared_components/plugins/authorization_type/item_not_equals_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(11259414086392075.4412)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'ITEM_NOT_EQUALS_VALUE'
,p_display_name=>'El Elemento NO Es Igual al Valor'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','ITEM_NOT_EQUALS_VALUE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>El valor del elemento no es igual al valor.</p>',
''))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11259621358394213.4412)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('La autorizaci\00F3n es correcta si el valor de este elemento es diferente al valor del campo siguiente y falla si es igual')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(11260124128395028.4412)
,p_plugin_id=>wwv_flow_api.id(11259414086392075.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('consulte la informaci\00F3n anterior')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/geocoding_trigger
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(12476487024106188.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'GEOCODING_TRIGGER'
,p_display_name=>unistr('Activar geocodificaci\00F3n')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','GEOCODING_TRIGGER'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Active manualmente la b\00FAsqueda de geocodificaci\00F3n de un elemento de <em>Direcci\00F3n geocodificada</em>.</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/social
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(15242808636946504.4412)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'SOCIAL'
,p_display_name=>unistr('Inicio de sesi\00F3n en medios sociales')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','SOCIAL'),'')
,p_api_version=>2
,p_standard_attributes=>'INVALID_SESSION'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Soporta la autenticaci\00F3n con los proveedores de identidad Google, Facebook, OpenID Connect gen\00E9rico y OAuth2 gen\00E9rico.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15243730328988135.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Almac\00E9n de Credenciales')
,p_attribute_type=>'CREDENTIAL ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione el almac\00E9n de credenciales que contiene el ID de cliente y el secreto para el proveedor de autenticaci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249686303031715.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Proveedor de Autenticaci\00F3n')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18383539811983244.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4412)
,p_display_sequence=>10
,p_display_value=>'Proveedor de OpenID Connect'
,p_return_value=>'OPENID_CONNECT'
,p_help_text=>unistr('Utilice un proveedor de autenticaci\00F3n basado en OpenID Connect. Debe introducir la siguiente URL de detecci\00F3n de OpenID.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18384865200013886.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Proveedor de OAuth2 gen\00E9rico')
,p_return_value=>'OAUTH2'
,p_help_text=>unistr('Utilice un proveedor de autenticaci\00F3n de OAuth2. Debe introducir las URL para los puntos finales de autorizaci\00F3n, token e informaci\00F3n de usuario siguientes.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650405105549494.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4412)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
,p_help_text=>unistr('Utilice la configuraci\00F3n predefinida para la conexi\00F3n a Google.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18650810905551172.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(15249686303031715.4412)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
,p_help_text=>unistr('Utilice la configuraci\00F3n predefinida para la conexi\00F3n a Facebook.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(15249997224035381.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('URL de Detecci\00F3n')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>unistr('Introduzca la URL de detecci\00F3n del proveedor de OpenID Connect.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385430957035861.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('URL de punto final de autorizaci\00F3n')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('Introduzca la URL de punto final de autorizaci\00F3n del proveedor de OAuth2.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18385701636038222.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'URL de punto final de token'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Introduzca la URL de punto final de token del proveedor de OAuth2.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386081451040404.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('URL de punto final de informaci\00F3n del usuario')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>unistr('Introduzca la URL de punto final de informaci\00F3n del usuario del proveedor de OAuth2.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386627580109078.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('\00C1mbito')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_examples=>'correo-E,perfil'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Introduzca una lista de permisos separados por comas para la solicitud del usuario que se conecta.',
unistr('Los valores aceptables dependen del proveedor de autenticaci\00F3n.'),
unistr('En el caso de OpenID Connect y Google, Application Express agrega autom\00E1ticamente el \00E1mbito "openid".'),
unistr('El proveedor de autenticaci\00F3n devuelve atributos de usuario bas\00E1ndose en estos permisos.'),
unistr('Puede asignar los atributos a los elementos de aplicaci\00F3n o utilizar un procedimiento posterior a la autenticaci\00F3n para procesarlos, utilizando las funciones APEX_JSON.GET_%.'),
'</p><p>',
unistr('Los \00E1mbitos y atributos de OpenID Connect (tambi\00E9n denominados reclamaciones) se muestran aqu\00ED: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(226010579134296999.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Par\00E1metros de URI de autenticaci\00F3n')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'prompt=consent'
,p_help_text=>unistr('Introduzca par\00E1metros opcionales para el URI de autenticaci\00F3n. Consulte la documentaci\00F3n del proveedor de autenticaci\00F3n sobre atributos soportados.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18386934074146656.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Nombre de Usuario'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'#sub# (#APEX_AUTH_NAME#)'
,p_is_translatable=>false
,p_examples=>'#sub# (#APEX_AUTH_NAME#)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Introduzca los atributos que contengan el nombre de usuario, o texto libre con una o varias sustituciones de atributo entre"#".',
unistr('Puede hacer referencia al nombre del esquema de autenticaci\00F3n con #APEX_AUTH_NAME#.'),
unistr('Por ejemplo, "#email# (#APEX_AUTH_NAME#)" tendr\00E1 como resultado un nombre de usuario que consiste en la direcci\00F3n de correo electr\00F3nico seguida de " (", seguida del nombre del esquema de autenticaci\00F3n, seguido de ")", como "jane.doe@example.com (Goog')
||'le)".',
'</p><p>',
unistr('Consulte los atributos soportados en la documentaci\00F3n del proveedor de autenticaci\00F3n.'),
unistr('Tenga en cuenta que es necesario definir el alcance necesario. De lo contrario, el proveedor de autenticaci\00F3n no enviar\00E1 todos los atributos.'),
unistr('El alcance y los atributos de OpenID Connect (tambi\00E9n denominados reclamaciones) se muestran aqu\00ED: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18652865850779852.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Atributos de Usuario Adicionales'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'enlace,imagen,correo-E'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Introduzca una lista separada por comas de atributos de datos de usuario adicionales.',
'</p><p>',
unistr('Consulte los atributos soportados en la documentaci\00F3n del proveedor de autenticaci\00F3n.'),
unistr('Tenga en cuenta que es necesario definir el alcance necesario. De lo contrario, el proveedor de autenticaci\00F3n no enviar\00E1 todos los atributos.'),
unistr('El alcance y los atributos de OpenID Connect (tambi\00E9n denominados reclamaciones) se muestran aqu\00ED: https://openid.net/specs/openid-connect-basic-1_0.html#Scopes'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(118623542514218726.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>95
,p_prompt=>unistr('Convertir el nombre de usuario a may\00FAsculas')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Determine si los valores del atributo de nombre de usuario deben convertirse a may\00FAsculas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(545768003551719989.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>unistr('M\00E9todo de autenticaci\00F3n de tokens')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(15249686303031715.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Especifique la forma en que el secreto de cliente y el ID de cliente de la credencial deben transferirse al servidor.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768719525723870.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Autenticaci\00F3n B\00E1sica')
,p_return_value=>'BASIC'
,p_help_text=>unistr('Env\00EDa el ID de cliente y el secreto de cliente en una cabecera de autenticaci\00F3n b\00E1sica.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545768336282722977.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4412)
,p_display_sequence=>22
,p_display_value=>unistr('Autenticaci\00F3n b\00E1sica e ID de cliente en el cuerpo')
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>unistr('Env\00EDa el ID de cliente y el secreto de cliente en una cabecera de autenticaci\00F3n b\00E1sica, as\00ED como el ID de cliente en el cuerpo de la solicitud.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(545769143256728532.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4412)
,p_display_sequence=>30
,p_display_value=>'ID de cliente y secreto de cliente en el cuerpo'
,p_return_value=>'BODY'
,p_help_text=>unistr('Env\00EDa el ID de cliente y el secreto de cliente en el cuerpo de la solicitud.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(829911196403661792.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(545768003551719989.4412)
,p_display_sequence=>40
,p_display_value=>'ID de cliente en el cuerpo'
,p_return_value=>'CLID'
,p_help_text=>unistr('Env\00EDe solo el ID de cliente en el cuerpo de la solicitud.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(328064759558360148.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>120
,p_prompt=>'Verificar atributos'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Si est\00E1 activado, &PRODUCT_NAME. buscar\00E1 un atributo "#name#_verified" (por ejemplo, "email_verified" para el atributo "email").'),
unistr('OpenID define que el proveedor de identidad env\00EDa <code>"#name#_verified":false</code> para los atributos "email" y "phone_number" no verificados.'),
'&PRODUCT_NAME. ignora esos atributos no verificados.',
unistr('Esto producir\00E1 un fallo en la autenticaci\00F3n si "#name#" es el atributo Username.'),
'</p><p>',
unistr('Si el proveedor de identidad permite que los atacantes introduzcan datos no verificados que use la aplicaci\00F3n para la autenticaci\00F3n,'),
unistr('podr\00EDan suplantar la identidad de otros usuarios en la aplicaci\00F3n.'),
unistr('La opci\00F3n "Verificar atributos" evita esto.'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388762589390412438.4412)
,p_plugin_id=>wwv_flow_api.id(15242808636946504.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>110
,p_prompt=>'Asignar atributos de usuario adicionales a'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>'G_EMAIL,G_PROFILE,G_PICTURE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Proporcione una lista separada por comas de los nombres de elemento de la aplicaci\00F3n a los que se asignar\00E1n los <em>atributos de usuario adicionales</em>. Por ejemplo, si define:'),
'<ul>',
'<li>Atributos de usuario adicionales: email,profile,picture</li>',
'<li>Asignar atributos de usuario adicionales a: G_EMAIL,G_PROFILE,G_PICTURE</li>',
'</ul>',
unistr('APEX guarda autom\00E1ticamente los valores de atributo en el estado de sesi\00F3n para los elementos correspondientes.')))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_list_view
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(37314610637444633.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_LIST_VIEW'
,p_display_name=>'Vista de Lista'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_LIST_VIEW'),'')
,p_api_version=>1
,p_ajax_function=>'x'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra datos en una lista de f\00E1cil navegaci\00F3n. Tambi\00E9n puede incorporar numerosas funciones para mejorar la vista de lista.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37319921504457296.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Funciones'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Seleccione las funciones que hay activadas para esta vista de lista.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507022952387983.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_display_sequence=>5
,p_display_value=>'Formato Avanzado'
,p_return_value=>'ADVANCED_FORMATTING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342207873614875.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_display_sequence=>10
,p_display_value=>'Mostrar Imagen'
,p_return_value=>'IMAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341804410613872.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_display_sequence=>20
,p_display_value=>'Mostrar Divisor de Lista'
,p_return_value=>'DIVIDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24343018955618095.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_display_sequence=>50
,p_display_value=>unistr('Tiene el Bot\00F3n Dividir')
,p_return_value=>'SPLIT_BUTTON'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24341429213611599.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_display_sequence=>55
,p_display_value=>unistr('Activar B\00FAsqueda')
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24342612721616279.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_display_sequence=>65
,p_display_value=>'Es Vista de Lista Anidad'
,p_return_value=>'NESTED'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(37507428146389462.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_display_sequence=>70
,p_display_value=>'Lista de Recuadros'
,p_return_value=>'INSET'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37321616440465218.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Columna de Texto'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>'Seleccione la columna de base de datos que contiene el contenido principal de la entrada de vista de lista.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18004831401462408.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Atributos de Lista'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>El cliente crea divisores en funci\00F3n del texto de elemento de lista</dt>'),
'<dd><pre>',
'data-autodividers=true',
'</pre></dd>',
'<dt>Cambiar el icono</dt>',
'<dd><pre>',
'data-icon="fa-gear"',
'</pre></dd>',
unistr('<dt>Cambiar el icono de bot\00F3n de divisi\00F3n</dt>'),
'<dd><pre>',
'data-split-icon="fa-gear"',
'</pre></dd>',
'</dl>'))
,p_help_text=>'Introduzca los atributos adicionales que se van a definir en el elemento de la lista. Consulte los ejemplos de algunos atributos que afectan a la vista de lista.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(18003624513413103.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Atributos de Entrada de Lista'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Definir el icono de enlace de entrada de lista en delete.</dt>',
'<dd><pre>',
'data-icon="delete"',
'</pre></dd>',
'</dl>'))
,p_help_text=>'Introduzca los atributos adicionales que se van a definir en el elemento de lista. Consulte los ejemplos de algunos atributos que afectan a la vista de lista.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322140682472248.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Formato de Texto'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Mostrar el nombre debajo de la fecha de contrataci\00F3n de un empleado</dt>'),
'<dd><pre>',
'&lt;h3&gt;&amp;ENAME.&lt;/h3&gt;',
unistr('&lt;p&gt;Fecha de contrataci\00F3n: &amp;HIREDATE.&lt;/p&gt;'),
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca los marcadores HTML para presentar el contenido principal de una entrada de vista de lista.</p>',
unistr('</p>Para hacer referencia a valores de columna de la sentencia SQL de la vista de lista, utilice sintaxis de sustituci\00F3n.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323637481490256.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Columna de Informaci\00F3n Complementaria')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_help_text=>unistr('Seleccione la columna de base de datos que contiene informaci\00F3n complementaria para la entrada de vista de lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37512329447408820.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Formato de Informaci\00F3n Complementaria')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Mostrar el salario en negrita</dt>',
'<dd><pre>',
'USD &lt;strong&gt;&amp;SAL.&lt;/strong&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca los marcadores HTML para presentar la informaci\00F3n adicional de una entrada de vista de lista.</p>'),
unistr('</p>Para hacer referencia a valores de columna de la sentencia SQL de la vista de lista, utilice sintaxis de sustituci\00F3n.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37323130554488257.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Columna Contador'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione la columna de base de datos que contiene el valor que se mostrar\00E1 en la burbuja de recuento.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42537525650337692.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Tipo de Imagen'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IMAGE_BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione el tipo de imagen que se muestra y de d\00F3nde se lee. La imagen mostrada puede ser un icono con un tama\00F1o de 16x16 o una vista en miniatura con un tama\00F1o de 80x80. El origen de la imagen puede ser una columna BLOB de base de datos o una URL ')
||unistr('a un archivo est\00E1tico.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42538712275343327.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4412)
,p_display_sequence=>20
,p_display_value=>'Icono Almacena en BLOB'
,p_return_value=>'ICON_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539233400349414.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Icono Le\00EDdo desde URL')
,p_return_value=>'ICON_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42539638940351053.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4412)
,p_display_sequence=>40
,p_display_value=>'Imagen Almacenada en BLOB'
,p_return_value=>'IMAGE_BLOB'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(42540042403352086.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(42537525650337692.4412)
,p_display_sequence=>50
,p_display_value=>unistr('Imagen Le\00EDda desde URL')
,p_return_value=>'IMAGE_URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324142675491770.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Columna BLOB de Imagen'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'BLOB'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>'Seleccione la columna de base de datos del tipo de dato BLOB que contiene la imagen.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(42541812668371813.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Columna de Clave Primaria de Imagen 1'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S:ROWID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_BLOB,IMAGE_BLOB'
,p_help_text=>unistr('Seleccione la columna de clave primaria o una columna de base de datos \00FAnica que se utiliza para consultar la imagen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24272827642729595.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Columna de Clave Primaria de Imagen 2'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42541812668371813.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Seleccione una segunda columna de clave primaria o una columna de base de datos \00FAnica que se utiliza para consultar la imagen.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24218503552483082.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Columna de URL de Imagen'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(42537525650337692.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'ICON_URL,IMAGE_URL'
,p_help_text=>'Seleccione la columna de base de datos que contiene la URL al icono o imagen.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37324722720495516.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Columna de Divisor de Lista'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIVIDER'
,p_help_text=>unistr('Seleccione la columna de base de datos que contiene el divisor. Cada vez que cambie el valor de divisor, se mostrar\00E1 un nuevo divisor entre las entradas de vista de lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24027626694091285.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Formato de Divisor de Lista'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ADVANCED_FORMATTING'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Mostrar el nombre de departamento y el n\00FAmero de empleados como una placa</dt>'),
'<dd><pre>',
'&amp;DNAME. &lt;span class="t-MediaList-badge"&gt;&amp;EMP_COUNT.&lt;/span&gt;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca los marcadores HTML para presentar el divisor de una vista de lista.</p>',
unistr('</p>Para hacer referencia a valores de columna de la sentencia SQL de la vista de lista, utilice sintaxis de sustituci\00F3n.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37322614971483782.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_prompt=>'Destino de Enlace'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Introduzca una p\00E1gina de destino a la que se llamar\00E1 cuando el usuario haga clic en una entrada de lista.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325839689500405.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>170
,p_prompt=>unistr('Destino del Bot\00F3n Dividir')
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SPLIT_BUTTON'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Introduzca una p\00E1gina de destino a la que se llamar\00E1 cuando el usuario haga clic en una entrada de lista.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24021612683850679.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>180
,p_prompt=>unistr('Tipo de B\00FAsqueda')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SERVER_EXACT_IGNORE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la forma de realizar la b\00FAsqueda.</p>'),
unistr('<p>Se realiza una b\00FAsqueda del cliente inmediatamente en cuanto el usuario comienza a escribir. Para todas las b\00FAsquedas basadas en servidor, el usuario tiene que pulsar Intro para ver los resultados de la b\00FAsqueda. Las b\00FAsquedas basadas en servidor ')
||unistr('son las \00FAnicas que tienen en cuenta los atributos de globalizaci\00F3n de Comparaci\00F3n de valor de car\00E1cter definidos para la aplicaci\00F3n.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022326881854766.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4412)
,p_display_sequence=>20
,p_display_value=>'Cliente'
,p_return_value=>'CLIENT'
,p_help_text=>unistr('Para realizar una b\00FAsqueda basada en el explorador, se deben cargar todas las entradas de la vista de lista en el explorador (tenga en cuenta que, en este caso, se ignorar\00E1 el atributo "N\00FAmero de Filas Recuperadas"). Utilice esta opci\00F3n de b\00FAsqueda s')
||unistr('olo para peque\00F1as cantidades de entradas de lista, con el fin de evitar largas cargas de p\00E1ginas innecesarias.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24022823811882269.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Servidor: Exacto y Sensible a May\00FAsculas/Min\00FAsculas')
,p_return_value=>'SERVER_EXACT_CASE'
,p_help_text=>unistr('La b\00FAsqueda utiliza LIKE [valor de b\00FAsqueda]% para consultar el resultado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023232469884808.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4412)
,p_display_sequence=>40
,p_display_value=>unistr('Servidor: Exacto e Ignorar May\00FAsculas/Min\00FAsculas')
,p_return_value=>'SERVER_EXACT_IGNORE'
,p_help_text=>unistr('La b\00FAsqueda utiliza LIKE UPPER( [valor de b\00FAsqueda] )% para consultar el resultado. Los \00EDndices existentes en la columna no se utilizar\00E1n, a menos que se trate de un \00EDndice basado en funci\00F3n que utiliza una expresi\00F3n UPPER.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24023619787890578.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4412)
,p_display_sequence=>50
,p_display_value=>unistr('Servidor: Igual y Sensible a May\00FAsculas/Min\00FAsculas')
,p_return_value=>'SERVER_LIKE_CASE'
,p_help_text=>unistr('La b\00FAsqueda utiliza LIKE %[valor de b\00FAsqueda]% para consultar el resultado. Esto evitar\00E1 el uso de un \00EDndice existente en esa columna.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(24024029483893440.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(24021612683850679.4412)
,p_display_sequence=>60
,p_display_value=>unistr('Servidor: Igual e Ignorar May\00FAsculas/Min\00FAsculas')
,p_return_value=>'SERVER_LIKE_IGNORE'
,p_help_text=>unistr('La b\00FAsqueda utiliza LIKE %UPPER( [valor de b\00FAsqueda] )% para consultar el resultado. Esto evitar\00E1 el uso de un \00EDndice existente en esa columna.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10775027534399383.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>190
,p_prompt=>'Buscar Columna'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('Seleccione el uso de una columna de base de datos alternativa para la b\00FAsqueda. Si no se especifica ninguna, se utiliza la columna de texto.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37327132202507698.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_prompt=>unistr('Marcador de Posici\00F3n de Cuadro de B\00FAsqueda')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SEARCH'
,p_help_text=>unistr('Introduzca el texto que se muestra en el cuadro de b\00FAsqueda. Si no se especifica ning\00FAn valor, se utiliza el valor del mensaje del sistema <strong>APEX.REGION.JQM_LIST_VIEW.SEARCH</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(37325332071498117.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>210
,p_prompt=>'Columna de Lista Anidada'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'NUMBER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(37319921504457296.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NESTED'
,p_help_text=>unistr('Seleccione la columna de base de datos que contiene el nivel de jerarqu\00EDa de una consulta anidada. Si utiliza una consulta CONNECT BY, utilice la pseudocolumna <code>LEVEL</code>.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(644548607716477014.4412)
,p_plugin_id=>wwv_flow_api.id(37314610637444633.4412)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Muestra todos los empleados ordenados por nombre</dt>',
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
'<dt>Muestra todos los empleados del departamento actual ordenados por nombre</dt>',
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>Si utiliza variables de enlace para hacer referencia a elementos de p\00E1gina, especif\00EDquelos como <strong>Elementos de P\00E1gina que Ejecutar<strong>.</p>'),
'</dd>',
'<dt>Utilice ROWID como columna de clave primaria</dt>',
'<dd><pre>',
'SELECT a.rowid as pk_rowid, ',
'       a.* ',
'  FROM emp a ',
'ORDER BY a.ename',
'</pre>',
'<p>Si se utiliza ROWID, se debe especificar un alias de columna.</p>',
'</dd>',
'<dt>Consulta anidada que devuelve todos los empleados</dt>',
'<dd><pre>',
' select ename,',
'        level',
'   from emp',
'connect by prior empno = mgr',
'  start with mgr is null',
' order siblings by ename',
'</pre></dd>',
'</dl>',
''))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/close_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276595215456808.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLOSE_REGION'
,p_display_name=>unistr('Cerrar regi\00F3n')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLOSE_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Cierra una regi\00F3n, como un cuadro de di\00E1logo en l\00EDnea, una ventana emergente en l\00EDnea o reducible, que se puede abrir y que est\00E1 abierta.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/open_region
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(72276779733456826.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'OPEN_REGION'
,p_display_name=>unistr('Abrir regi\00F3n')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','OPEN_REGION'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Abre una regi\00F3n, como un cuadro de di\00E1logo en l\00EDnea, una ventana emergente en l\00EDnea o reducible, que se puede abrir.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132376923088056966.4412)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_IN_GROUP'
,p_display_name=>unistr('Est\00E1 en rol o en grupo')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(132377321338088226.4412)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nombres'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca uno o m\00E1s nombres de grupo separados por comas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91772529032268265.4412)
,p_plugin_id=>wwv_flow_api.id(132376923088056966.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91772831765269995.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Rol de Aplicaci\00F3n')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773214348271589.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4412)
,p_display_sequence=>20
,p_display_value=>'Grupo de espacio de trabajo'
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91773695579272344.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(91772529032268265.4412)
,p_display_sequence=>30
,p_display_value=>'Personalizado'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/is_not_in_group
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(132377111646077506.4412)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'IS_NOT_IN_GROUP'
,p_display_name=>unistr('No est\00E1 en rol ni en grupo')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','IS_NOT_IN_GROUP'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(135876608363708702.4412)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nombres'
,p_attribute_type=>'AUTHORIZATION GROUPS'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca uno o m\00E1s nombres de grupo separados por comas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91774410321279131.4412)
,p_plugin_id=>wwv_flow_api.id(132377111646077506.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'A'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91774719920280165.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Rol de Aplicaci\00F3n')
,p_return_value=>'A'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775192472281109.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4412)
,p_display_sequence=>20
,p_display_value=>'Grupo de espacio de trabajo'
,p_return_value=>'W'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(91775511878281830.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(91774410321279131.4412)
,p_display_sequence=>30
,p_display_value=>'Personalizado'
,p_return_value=>'C'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker_jet
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(144248864922483430.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER_JET'
,p_display_name=>'Selector de Fecha'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER_JET'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Muestra un campo de texto con un icono de calendario. Los usuarios finales pueden introducir la fecha directamente en el elemento de texto o hacer clic en el icono del calendario para seleccionar una fecha y, opcionalmente, una hora, en el calenda'
||'rio emergente.</p>',
unistr('<p>La hora solo aparece en el calendario emergente si <em>M\00E1scara de Formato</em> de este elemento incluye componentes de hora.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142750950234528930.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Apariencia'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Controle la apariencia del calendario que se utiliza para seleccionar las fechas.</p>',
unistr('<p>Nota: Esto solo se utiliza cuando "Mostrar como" est\00E1 definido en "Emergente" o "En l\00EDnea".</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142751748618530462.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4412)
,p_display_sequence=>10
,p_display_value=>'Ver semana'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('Si se muestra la semana del a\00F1o.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752536880532293.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4412)
,p_display_sequence=>20
,p_display_value=>'Selector de mes'
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('Si el mes se debe representar como un bot\00F3n en vez de texto para permitir la selecci\00F3n.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142752956214532903.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(142750950234528930.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Selector de a\00F1o')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('Si el a\00F1o se debe representar como un bot\00F3n en vez de texto para permitir la selecci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(143948862668782714.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('D\00EDas fuera del mes')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina el comportamiento de los d\00EDas fuera del mes que se est\00E1 viendo actualmente.</p>'),
unistr('<p>Nota: Esto solo se utiliza cuando "Mostrar como" est\00E1 definido en "Emergente" o "En l\00EDnea".</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949419755783405.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4412)
,p_display_sequence=>10
,p_display_value=>'Oculto'
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('Se ocultar\00E1n los d\00EDas fuera del mes que se est\00E1 viendo actualmente.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143949752332784630.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4412)
,p_display_sequence=>20
,p_display_value=>'Seleccionable'
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('Los d\00EDas fuera del mes que se est\00E1 viendo actualmente ser\00E1n visibles y se podr\00E1n seleccionar.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(143950165800785286.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(143948862668782714.4412)
,p_display_sequence=>30
,p_display_value=>'Visible'
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('Los d\00EDas fuera del mes que se est\00E1 viendo actualmente ser\00E1n visibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142148878705941262.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Incremento de tiempo'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'15'
,p_display_length=>10
,p_max_length=>2
,p_unit=>'minutos'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incremento de tiempo en minutos que utiliza el control de selecci\00F3n de hora. Nota: Esto solo controla el control que se utiliza para seleccionar la hora; cualquier tiempo fuera de estos incrementos todav\00EDa se puede introducir y guardar de forma ma')
||'nual.</p>',
unistr('<p>Nota: Esto solo se utiliza cuando "Mostrar como" est\00E1 definido en "Emergente" o "En l\00EDnea" y adem\00E1s "Mostrar hora" est\00E1 activado.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267715778102442717.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mostrar con'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Controla cu\00E1ndo se muestra el calendario emergente. Nota: Este ajuste solo se utiliza cuando "Mostrar como" est\00E1 definido en "Emergente" o "En l\00EDnea".')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716390932439526.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4412)
,p_display_sequence=>10
,p_display_value=>'Enfoque de elemento'
,p_return_value=>'FOCUS'
,p_help_text=>'Cuando se selecciona un elemento o cuando se hace clic en el icono del calendario.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267716858979438151.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(267715778102442717.4412)
,p_display_sequence=>20
,p_display_value=>'Clic en el icono'
,p_return_value=>'IMAGE'
,p_help_text=>'Solo cuando se hace clic en el icono del calendario.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141154378544914000.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mostrar Hora'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Si se va a incluir la informaci\00F3n de tiempo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144250268701483448.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Mostrar como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione el modo de visualizaci\00F3n del selector de fechas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144250658827483448.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4412)
,p_display_sequence=>10
,p_display_value=>'Emergente'
,p_return_value=>'POPUP'
,p_help_text=>'El calendario muestra un elemento emergente cuando se selecciona el elemento o cuando se hace clic en el icono del calendario.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144252202058483449.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4412)
,p_display_sequence=>20
,p_display_value=>unistr('En L\00EDnea')
,p_return_value=>'INLINE'
,p_help_text=>unistr('El calendario aparece siempre en l\00EDnea en la p\00E1gina. No se muestra ning\00FAn campo de texto y la selecci\00F3n de fecha actual est\00E1 resaltada en el calendario.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142151127231126342.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(144250268701483448.4412)
,p_display_sequence=>30
,p_display_value=>'HTML nativo'
,p_return_value=>'NATIVE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Representaci\00F3n que usa los tipos de fecha de entrada HTML nativos, si el explorador los soporta. Cuando ''Mostrar hora'' est\00E1 desactivado, se representa un tipo ''fecha'' y, cuando dicha opci\00F3n est\00E1 activada, se representa un tipo ''fecha/hora-local''. ')
||unistr('Nota: La visualizaci\00F3n exacta de estos tipos de fecha depende del explorador. Es posible que los HTML nativos sean la opci\00F3n preferida cuando la aplicaci\00F3n se utiliza en un dispositivo m\00F3vil.</p>'),
unistr('<p>Tenga en cuenta que, al utilizar ''HTML nativo'', como los tipos de fecha nativos requieren un formato de fecha muy espec\00EDfico, APEX definir\00E1 autom\00E1ticamente la ''M\00E1scara de formato'' del elemento y usted no podr\00E1 cambiarla. No obstante, este no ser\00E1 ')
||unistr('el formato que se mostrar\00E1 al usuario final. El usuario final ver\00E1 la fecha en el formato correspondiente a su configuraci\00F3n regional.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141749600267473768.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Fecha M\00EDnima')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique si el elemento tiene una fecha m\00EDnima.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750147879475182.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4412)
,p_display_sequence=>10
,p_display_value=>'Ninguno'
,p_return_value=>'NONE'
,p_help_text=>unistr('No se ha definido ninguna fecha m\00EDnima.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750575076477005.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4412)
,p_display_sequence=>20
,p_display_value=>'Elemento'
,p_return_value=>'ITEM'
,p_help_text=>unistr('La fecha m\00EDnima se deriva de forma din\00E1mica del valor de otro elemento.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141750953061477828.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(141749600267473768.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Est\00E1tico')
,p_return_value=>'STATIC'
,p_help_text=>unistr('La fecha m\00EDnima es un valor est\00E1tico, que se define como un valor absoluto o un valor relativo con respecto a la fecha actual.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249127342483446.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Est\00E1tico m\00EDnimo')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la fecha m\00EDnima que se puede introducir o seleccionar.</p>'),
unistr('<p>El valor de fecha puede ser un valor absoluto en el formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> o <code>''YYYYMMDDHH24MI''</code> o un valor relativo con respecto a la fecha de hoy, como <code>+7d</code>, o un valor din\00E1mico mediante la sintaxis de')
||unistr(' sustituci\00F3n, siempre y cuando la sustituci\00F3n devuelva el formato de fecha correcto o el valor relativo.</p>'),
'<p>Estos son algunos valores de fecha relativos:</p>',
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - a\00F1os a partir de la fecha de hoy</dd>'),
'  <dt>m</dt>',
'    <dd>+ / - meses a partir de la fecha de hoy</dd>',
'  <dt>w</dt>',
'    <dd>+ / - semanas a partir de la fecha de hoy</dd>',
'  <dt>d</dt>',
unistr('    <dd>+ / - d\00EDas a partir de la fecha de hoy</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141754177794489952.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Elemento m\00EDnimo')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141749600267473768.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>El elemento que determina el valor m\00EDnimo permitido. Este debe ser un elemento de p\00E1gina que se encuentre en la p\00E1gina actual o global.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141850062850547994.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Fecha M\00E1xima')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique si el elemento tiene una fecha m\00E1xima.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850596251549117.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4412)
,p_display_sequence=>10
,p_display_value=>'Ninguno'
,p_return_value=>'NONE'
,p_help_text=>unistr('No se ha definido ninguna fecha m\00E1xima.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141850928550550352.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4412)
,p_display_sequence=>20
,p_display_value=>'Elemento'
,p_return_value=>'ITEM'
,p_help_text=>unistr('La fecha m\00E1xima se deriva de forma din\00E1mica del valor de otro elemento.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(141851351298550860.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(141850062850547994.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Est\00E1tico')
,p_return_value=>'STATIC'
,p_help_text=>unistr('La fecha m\00E1xima es un valor est\00E1tico, que se define como un valor absoluto o un valor relativo con respecto a la fecha actual.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144249516166483447.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Est\00E1tico m\00E1ximo')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la fecha m\00E1xima que se puede introducir o seleccionar.</p>'),
unistr('<p>El valor de fecha puede ser un valor absoluto en el formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> o <code>''YYYYMMDDHH24MI''</code>, un valor relativo con respecto a la fecha de hoy, como <code>+7d</code>, o un valor din\00E1mico mediante la sintaxis de ')
||unistr('sustituci\00F3n, siempre y cuando la sustituci\00F3n devuelva el formato de fecha correcto o el valor relativo.</p>'),
'<p>Estos son algunos valores de fecha relativos:</p>',
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - a\00F1os a partir de la fecha de hoy</dd>'),
'  <dt>m</dt>',
'    <dd>+ / - meses a partir de la fecha de hoy</dd>',
'  <dt>w</dt>',
'    <dd>+ / - semanas a partir de la fecha de hoy</dd>',
'  <dt>d</dt>',
unistr('    <dd>+ / - d\00EDas a partir de la fecha de hoy</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141853413671557712.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Elemento m\00E1ximo')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(141850062850547994.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('<p>El elemento que determina el valor m\00E1ximo permitido. Este debe ser un elemento de p\00E1gina que se encuentre en la p\00E1gina actual o global.<p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146749239835527240.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Varios meses'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(144250268701483448.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'POPUP,INLINE'
,p_help_text=>unistr('Si el calendario mostrar\00E1 varios meses.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144253456913483450.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>unistr('N\00FAmero de Meses')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146749239835527240.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('N\00FAmero de meses que se muestran a la vez.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142950502812595734.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Usar Valores por Defecto'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Indica si se van a usar los valores por defecto definidos para este componente en Componentes compartidos > Valores de componente o unos valores personalizados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(142548837341436051.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Apariencia'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_default_value=>'MONTH-PICKER:YEAR-PICKER'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Controle la apariencia del calendario que se utiliza para seleccionar las fechas.</p>',
unistr('<p>Nota: Esto solo se utiliza cuando "Mostrar como" est\00E1 definido en "Emergente" o "En l\00EDnea".</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549209563439534.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4412)
,p_display_sequence=>10
,p_display_value=>'Ver semana'
,p_return_value=>'SHOW-WEEK'
,p_help_text=>unistr('Si se muestra la semana del a\00F1o.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549539424440887.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4412)
,p_display_sequence=>20
,p_display_value=>'Selector de mes'
,p_return_value=>'MONTH-PICKER'
,p_help_text=>unistr('Si el mes se debe representar como un bot\00F3n en vez de texto para permitir la selecci\00F3n.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(142549996724441519.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(142548837341436051.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Selector de a\00F1o')
,p_return_value=>'YEAR-PICKER'
,p_help_text=>unistr('Si el a\00F1o se debe representar como un bot\00F3n en vez de texto para permitir la selecci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(144048842685822298.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('D\00EDas fuera del mes')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VISIBLE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Determina el comportamiento de los d\00EDas fuera del mes que se est\00E1 viendo actualmente.</p>'),
unistr('<p>Nota: Esto solo se utiliza cuando "Mostrar como" est\00E1 definido en "Emergente" o "En l\00EDnea".</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049355435823179.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4412)
,p_display_sequence=>10
,p_display_value=>'Oculto'
,p_return_value=>'HIDDEN'
,p_help_text=>unistr('Se ocultar\00E1n los d\00EDas fuera del mes que se est\00E1 viendo actualmente.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144049732421823927.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4412)
,p_display_sequence=>20
,p_display_value=>'Seleccionable'
,p_return_value=>'SELECTABLE'
,p_help_text=>unistr('Los d\00EDas fuera del mes que se est\00E1 viendo actualmente ser\00E1n visibles y se podr\00E1n seleccionar.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(144050133633824443.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(144048842685822298.4412)
,p_display_sequence=>30
,p_display_value=>'Visible'
,p_return_value=>'VISIBLE'
,p_help_text=>unistr('Los d\00EDas fuera del mes que se est\00E1 viendo actualmente ser\00E1n visibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(141748859804709713.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>'Incremento de tiempo'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>2
,p_unit=>'minutos'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Incremento de tiempo en minutos que utiliza el control de selecci\00F3n de hora. Nota: Esto solo controla el control que se utiliza para seleccionar la hora; cualquier tiempo fuera de estos incrementos todav\00EDa se puede introducir y guardar de forma ma')
||'nual.</p>',
unistr('<p>Nota: Esto solo se utiliza cuando "Mostrar como" est\00E1 definido en "Emergente" o "En l\00EDnea" y adem\00E1s "Mostrar hora" est\00E1 activado.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(267717248823433082.4412)
,p_plugin_id=>wwv_flow_api.id(144248864922483430.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Mostrar con'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FOCUS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(142950502812595734.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Controla cu\00E1ndo se muestra el calendario emergente. Nota: Este ajuste solo se utiliza cuando "Mostrar como" est\00E1 definido en "Emergente" o "En l\00EDnea".')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267717787671430611.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4412)
,p_display_sequence=>10
,p_display_value=>'Enfoque de elemento'
,p_return_value=>'FOCUS'
,p_help_text=>'Cuando se selecciona un elemento o cuando se hace clic en el icono del calendario.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(267718203365429155.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(267717248823433082.4412)
,p_display_sequence=>20
,p_display_value=>'Clic en el icono'
,p_return_value=>'IMAGE'
,p_help_text=>'Solo cuando se hace clic en el icono del calendario.'
);
end;
/
prompt --application/shared_components/plugins/item_type/single_checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(146860542307282603.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SINGLE_CHECKBOX'
,p_display_name=>'Casilla de control'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACET_GRP_ITEMS:APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SINGLE_CHECKBOX'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra una \00FAnica casilla de control que el usuario puede activar o desactivar. El valor definido para activado o desactivado se almacena en el estado de sesi\00F3n cuando se env\00EDa.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146860884924292553.4412)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valor Comprobado'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el valor almacenado en el elemento de p\00E1gina si el usuario final activa la casilla de control. El valor puede tener una longitud de hasta 255 caracteres.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146861562091295771.4412)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor No Comprobado'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el valor almacenado en el elemento de p\00E1gina si el usuario desactiva la casilla de control. Tambi\00E9n puede dejar este atributo en blanco si desea almacenar <code>NULL</code> al activarla. El valor puede tener una longitud de hasta 255 carac')
||'teres.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146862485248305221.4412)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Usar Valores por Defecto'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Indica si se van a usar los valores por defecto definidos para este componente en Componentes compartidos > Valores de componente o unos valores personalizados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146864548825351464.4412)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor Comprobado'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Introduzca el valor almacenado en el elemento de p\00E1gina si el usuario marca la casilla de control. El valor puede tener una longitud de hasta 255 caracteres.</p>'),
'<p>',
unistr('En una p\00E1gina de b\00FAsqueda por facetas, si la faceta filtra una columna de consulta <em>tomando como base una lista de valores</em>, este valor debe coincidir <em>tanto</em> con el valor de retorno como con el valor de visualizaci\00F3n de la lista de val')
||unistr('ores. Si los valores de visualizaci\00F3n y de retorno son diferentes, no puede utilizar este tipo de faceta para esta columna. Utilice en su lugar la faceta <strong>Grupo de casillas de control</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(146865043227355165.4412)
,p_plugin_id=>wwv_flow_api.id(146860542307282603.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Valor No Comprobado'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>19
,p_max_length=>255
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(146862485248305221.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el valor almacenado en el elemento de p\00E1gina si el usuario desactiva la casilla de control. Tambi\00E9n puede dejar este atributo en blanco si desea almacenar <code>NULL</code> al desactivar. El valor puede tener una longitud de hasta 255 c')
||'aracteres.</p>',
unistr('<p><em>Nota: Este valor se utilizar\00E1 si el elemento de p\00E1gina se rellena con un valor que no coincide con el <strong>valor activado</strong> ni con el <strong>valor desactivado</strong>.</em></p>')))
);
end;
/
prompt --application/shared_components/plugins/region_type/ig
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(230331270232947234.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IG'
,p_display_name=>unistr('Cuadr\00EDcula Interactiva')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IG'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Regi\00F3n de varias filas en l\00EDnea completa basada en una consulta SQL que proporciona a los usuarios finales numerosas funciones para la personalizaci\00F3n en tiempo de ejecuci\00F3n. '),
unistr('La regi\00F3n se puede definir como editable o de solo lectura.</p>'),
unistr('<p>Puede definir una sola cuadr\00EDcula interactiva y que los usuarios finales manipulen los datos que se muestran para satisfacer sus requisitos espec\00EDficos, en lugar de tener que desarrollar varias regiones similares con diferentes criterios para sati')
||'sfacer esos mismos requisitos.</p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(465646569260662699.4412)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4412)
,p_name=>'SOURCE_LOCATION'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936016374443633302.4412)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4412)
,p_name=>'apexbeginrecordedit'
,p_display_name=>unistr('Inicializaci\00F3n de Fila')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322074007251020.4412)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4412)
,p_name=>'gridpagechange'
,p_display_name=>unistr('Cambio de p\00E1gina')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233321734838250996.4412)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4412)
,p_name=>'interactivegridmodechange'
,p_display_name=>'Cambio de Modo'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322895758251022.4412)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4412)
,p_name=>'interactivegridreportchange'
,p_display_name=>'Cambio de informe'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(230312956793621156.4412)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4412)
,p_name=>'interactivegridsave'
,p_display_name=>'Guardar'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(936015222634633296.4412)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4412)
,p_name=>'interactivegridselectionchange'
,p_display_name=>unistr('Cambio de Selecci\00F3n')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(233322485880251022.4412)
,p_plugin_id=>wwv_flow_api.id(230331270232947234.4412)
,p_name=>'interactivegridviewchange'
,p_display_name=>'Cambio de vista'
);
end;
/
prompt --application/shared_components/plugins/item_type/row_selector
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253123678064187648.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_SELECTOR'
,p_display_name=>'Selector de Filas'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_SELECTOR'),'')
,p_api_version=>2
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Muestra una casilla de control en cada fila de una cuadr\00EDcula interactiva, lo que permite la selecci\00F3n de filas espec\00EDficas para la manipulaci\00F3n.</p>'),
unistr('<p>Por defecto, la columna APEX$ROW_SELECTOR se define en un tipo de selector de filas. Esta columna se agrega autom\00E1ticamente cuando la cuadr\00EDcula interactiva se hace editable.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253123956742195925.4412)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Activar Selecci\00F3n M\00FAltiple')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Permitir selecci\00F3n de varias filas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(253124243508199498.4412)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Mostrar Opci\00F3n Seleccionar Todo')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(253123956742195925.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Permite al usuario seleccionar todas las filas con Ctrl+A o, si el valor de <em>Ocultar controles</em> es <em>No</em>, con una casilla de control en la cabecera de columna.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(276642483200371586.4412)
,p_plugin_id=>wwv_flow_api.id(253123678064187648.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Ocultar Control'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Oculte la casilla de control o el control de radio que se muestra en cada fila.'
);
end;
/
prompt --application/shared_components/plugins/item_type/row_action
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(253124868675308889.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'ROW_ACTION'
,p_display_name=>unistr('Men\00FA de Acciones')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','ROW_ACTION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Muestra el icono de acciones (hamburguesa) en cada fila de una cuadr\00EDcula interactiva. '),
unistr('El men\00FA de acciones incluye opciones como Vista de una sola fila, Agregar fila, Suprimir fila, Refrescar fila, etc., dependiendo de los atributos de cuadr\00EDcula y las autorizaciones de usuario final. Estas opciones de men\00FA permiten a los usuarios fina')
||unistr('les realizar acciones espec\00EDficas en la fila actual de la cuadr\00EDcula.</p>'),
unistr('<p>El men\00FA de acciones se puede utilizar en cuadr\00EDculas interactivas, tanto editables como no editables, pero las opciones de men\00FA ser\00E1n diferentes en funci\00F3n de esto. En las cuadr\00EDculas interactivas no editables, el men\00FA mostrar\00E1 un subjuego de opci')
||unistr('ones, por ejemplo, Vista de una sola fila y Refrescar fila, y no incluir\00E1 acciones editables espec\00EDficas como Agregar fila, Suprimir fila, etc.</p>'),
unistr('<p>Si una cuadr\00EDcula interactiva se vuelve editable, la columna APEX$ROW_ACTION se agregar\00E1 autom\00E1ticamente y se definir\00E1 en un tipo de men\00FA de acciones. En las cuadr\00EDculas interactivas no editables, esta columna se debe agregar de forma manual.</p>')))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jet_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258086019711957603.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JET_CHART'
,p_display_name=>unistr('Gr\00E1fico')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JET_CHART'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra datos utilizando diversos tipos de gr\00E1ficos incorporados.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(608666764128858384.4412)
,p_plugin_id=>wwv_flow_api.id(258086019711957603.4412)
,p_name=>'SOURCE_LOCATION'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/hide
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258533608465739815.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'HIDE'
,p_display_name=>'Ocultar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','HIDE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Oculta los elementos afectados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262136912621901373.4412)
,p_plugin_id=>wwv_flow_api.id(258533608465739815.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Ocultar Todos los Elementos de P\00E1gina de la Misma L\00EDnea')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si se ocultan todos los elementos y etiquetas de p\00E1gina que est\00E1n en la misma l\00EDnea que los elementos afectados.</p>'),
unistr('<p>Nota: este atributo no funcionar\00E1 para elementos de p\00E1ginas que no utilizan una cuadr\00EDcula de tabla para mostrar elementos de pantalla. Esto incluye cualquier p\00E1gina que utilice una plantilla de p\00E1gina m\00F3vil.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/enable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537221774904509.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ENABLE'
,p_display_name=>'Activar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ENABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Activa los elementos afectados.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/disable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258537428700906571.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'DISABLE'
,p_display_name=>'Desactivar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','DISABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Desactiva los elementos afectados. Al desactivarlos, estos elementos se convierten en no editables, por lo que no conservan los valores de elementos cuando se ejecuta la p\00E1gina.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_value
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538225714915177.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_VALUE'
,p_display_name=>'Definir Valor'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_VALUE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD:STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Define el valor de los elementos afectados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262584206591281622.4412)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Definir Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STATIC_ASSIGNMENT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione c\00F3mo se derivan los valores que se van a definir.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262584812132283213.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Asignaci\00F3n Est\00E1tica')
,p_return_value=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('Define un solo valor est\00E1tico.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585623560286495.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_display_sequence=>15
,p_display_value=>unistr('Expresi\00F3n JavaScript')
,p_return_value=>'JAVASCRIPT_EXPRESSION'
,p_help_text=>unistr('Define uno o m\00E1s valores, derivados o calculados a partir de JavaScript.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(262585216634284505.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_display_sequence=>20
,p_display_value=>'Sentencia SQL'
,p_return_value=>'SQL_STATEMENT'
,p_help_text=>unistr('Define uno o m\00E1s valores, seg\00FAn el resultado de una consulta SQL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427666425507065443.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_display_sequence=>40
,p_display_value=>unistr('Expresi\00F3n PL/SQL')
,p_return_value=>'PLSQL_EXPRESSION'
,p_help_text=>unistr('Define un solo valor, seg\00FAn el resultado de una expresi\00F3n PL/SQL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(427667018365072832.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_display_sequence=>50
,p_display_value=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
,p_return_value=>'FUNCTION_BODY'
,p_help_text=>unistr('Define un solo valor, seg\00FAn el resultado de un cuerpo de la funci\00F3n PL/SQL.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1295383602600152012.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_display_sequence=>60
,p_display_value=>unistr('Elemento de Retorno de Cuadro de Di\00E1logo')
,p_return_value=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('Defina un \00FAnico valor, seg\00FAn el elemento de retorno de un cuadro de di\00E1logo. Nota: este tipo solo funciona si la acci\00F3n din\00E1mica dispara el evento <strong>Cuadro de Di\00E1logo Cerrado</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539307968928889.4412)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC_ASSIGNMENT'
,p_help_text=>unistr('Introduzca un valor est\00E1tico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262586323439352724.4412)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Sentencia SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>100
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL_STATEMENT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select loc,',
'       dname',
'  from dept ',
' where deptno = :P1_DEPTNO',
'</pre>',
unistr('<p>En este ejemplo, introduzca <code>P1_DEPTNO</code> en <strong>Elementos de P\00E1gina que Ejecutar</strong>. Tambi\00E9n debe seleccionar dos <em>elementos afectados</em>, para las columnas <code>loc</code> y <code>dname</code> respectivamente, por ejempl')
||'o P1_LOC y P1_DNAME.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una sentencia SQL que devuelva entre 1 y 100 columnas. Las columnas que seleccione con la sentencia SQL se deber\00E1n corresponder por posici\00F3n con los elementos de p\00E1gina que seleccione en <strong>Elementos Afectados</strong>.</p>'),
unistr('<p>Puede hacer referencia a elementos de aplicaci\00F3n o p\00E1gina mediante la sintaxis de enlace siempre y cuando los incluya en <strong>Elementos de P\00E1gina a Ejecutar</strong></p>'),
unistr('<p><em>Nota: si la sentencia SQL solo devuelve una fila, se define como los valores. Si devuelve m\00E1s de una fila, el valor definido ser\00E1 una cadena de todas las filas separadas por comas, para cada valor.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662501518001786.4412)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Expresi\00F3n PL/SQL')
,p_attribute_type=>'PLSQL EXPRESSION'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'nvl(:P1_SAL, 0)',
'</pre>',
unistr('<p>En este ejemplo, introduzca <code>P1_SAL</code> en <strong>Elementos de P\00E1gina que Ejecutar</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una expresi\00F3n PL/SQL que se utiliza para definir el valor.</p>'),
unistr('<p>Puede hacer referencia a elementos de aplicaci\00F3n o p\00E1gina siempre y cuando se incluyan en <strong>Elementos de P\00E1gina que Ejecutar</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(293265419645253258.4412)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Expresi\00F3n JavaScript')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT_EXPRESSION'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Este c\00F3digo tiene acceso a los siguientes atributos relacionados con la acci\00F3n din\00E1mica:</p><dl>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>Una referencia al objeto DOM del elemento que ha disparado la acci\00F3n din\00E1mica.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
'    <dd>Un objeto jQuery que contiene todos los elementos afectados.</dd>',
'  <dt><code>this.action</code></dt>',
unistr('    <dd>El objeto de acci\00F3n que contiene detalles como el nombre de la acci\00F3n y los valores de atributo adicionales.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>El objeto de evento del evento que ha disparado el evento. Nota: en la carga, \00E9ste ser\00E1 igual a la ''carga''.</dd>'),
'  <dt><code>this.data</code></dt>',
'    <dd>Datos adicionales opcionales que se pueden transferir desde el manejador de eventos.</dd>',
'</dl>'))
,p_help_text=>unistr('Introduzca una expresi\00F3n JavaScript que se utilizar\00E1 para definir el valor. Esta expresi\00F3n puede producir un solo valor o una matriz de valores (cuando el elemento que se est\00E1 definiendo soporta varios valores, por ejemplo, un selector).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(427662910653013912.4412)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Cuerpo de la Funci\00F3n PL/SQL')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'FUNCTION_BODY'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'return getCommission(:P1_SAL, :P1_JOB);',
'</pre>',
unistr('<p>En este ejemplo, introduzca <code>P1_SAL</code> y <code>P1_JOB</code> en <strong>Elementos de P\00E1gina que Ejecutar</strong>.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca un cuerpo de la funci\00F3n PL/SQL que se utiliza para definir el valor.</p>'),
unistr('<p>Puede hacer referencia a elementos de aplicaci\00F3n o p\00E1gina siempre y cuando se incluyan en <strong>Elementos de P\00E1gina que Ejecutar</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262597322287494361.4412)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Elementos a Ejecutar'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('Introduzca los elementos de aplicaci\00F3n o p\00E1gina que se van a enviar al ejecutar esta acci\00F3n. En el caso de que sean varios elementos, separe cada nombre de elemento con una coma. Puede escribir el nombre o elegirlo en una lista de elementos disponibl')
||'es. Si lo elige en la lista y ya se ha introducido texto, se coloca una coma al final del texto existente seguido por el nombre del elemento devuelto de la lista.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(618758229653179194.4412)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Caracteres Especiales de Identificaci\00F3n')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL_STATEMENT,PLSQL_EXPRESSION,FUNCTION_BODY'
,p_help_text=>unistr('Especifique si se omiten los caracteres especiales HTML. Oracle recomienda encarecidamente definir este atributo en <strong>S\00ED</strong> para evitar ataques de scripts de sitios (XSS).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(399189606786047634.4412)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Suprimir Evento de Cambio'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si el evento de cambio se suprime en los elementos que se especifican en <strong>Elementos de P\00E1gina que Devolver</strong>. Esto evita que se disparen posteriores acciones din\00E1micas basadas en <em>cambios</em> para estos elementos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1295495331704184122.4412)
,p_plugin_id=>wwv_flow_api.id(258538225714915177.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>75
,p_prompt=>'Elemento de Retorno'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(262584206591281622.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DIALOG_RETURN_ITEM'
,p_help_text=>unistr('Introduzca el nombre del elemento de p\00E1gina devuelto por el cuadro de di\00E1logo utilizado para definir el valor.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/javascript_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(258538732294917000.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'JAVASCRIPT_CODE'
,p_display_name=>unistr('Ejecutar C\00F3digo JavaScript')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','JAVASCRIPT_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Le permite definir o llamar a c\00F3digo JavaScript espec\00EDfico de p\00E1gina y personalizado para utilizarlo en el marco de acciones din\00E1micas. Si va a definir c\00F3digo JavaScript espec\00EDfico de una sola p\00E1gina, puede utilizar el atributo de nivel de p\00E1gina <em')
||unistr('>Declaraci\00F3n de Funci\00F3n y Variable Global</em> para definirlo. Posteriormente, esta acci\00F3n puede hacer referencia a las funciones y las variables que se definan aqu\00ED.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(258539816972931512.4412)
,p_plugin_id=>wwv_flow_api.id(258538732294917000.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('C\00F3digo')
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Este c\00F3digo tiene acceso a los siguientes atributos relacionados con la acci\00F3n din\00E1mica:</p><dl>'),
'<dl>',
'  <dt><code>this.triggeringElement</code></dt>',
unistr('    <dd>Una referencia al objeto DOM del elemento que ha disparado la acci\00F3n din\00E1mica.</dd>'),
'  <dt><code>this.affectedElements</code></dt>',
'    <dd>Un objeto jQuery que contiene todos los elementos afectados.</dd>',
'  <dt><code>this.action</code></dt>',
unistr('    <dd>El objeto de acci\00F3n que contiene detalles como el nombre de la acci\00F3n y los valores de atributo adicionales.</dd>'),
'  <dt><code>this.browserEvent</code></dt>',
unistr('     <dd>El objeto de evento del evento que ha disparado el evento. Nota: en la carga, \00E9ste ser\00E1 igual a la ''carga''.</dd>'),
'  <dt><code>this.data</code></dt>',
'    <dd>Datos adicionales opcionales que se pueden transferir desde el manejador de eventos.</dd>',
'</dl>'))
,p_help_text=>unistr('Introduzca cualquier JavaScript personalizado espec\00EDfico de la p\00E1gina o acci\00F3n din\00E1mica.')
);
end;
/
prompt --application/shared_components/plugins/process_type/ig_dml
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(260818839554927396.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'IG_DML'
,p_display_name=>unistr('Cuadr\00EDcula Interactiva: Procesamiento Autom\00E1tico de Filas (DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','IG_DML'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Proceso para insertar, actualizar o suprimir filas de cuadr\00EDcula interactiva.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260819106949935652.4412)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'tipo de objetivo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'REGION_SOURCE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione qu\00E9 t\00E9cnica de procesamiento de filas se utiliza para guardar los cambios de datos realizados en la cuadr\00EDcula interactiva.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819425689937336.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Origen de Regi\00F3n')
,p_return_value=>'REGION_SOURCE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inserta, actualiza y suprime la utilizaci\00F3n de la consulta SQL de origen de regi\00F3n.</p>'),
unistr('<p>Nota: Aseg\00FArese de que las columnas que no se pueden insertar o actualizar tengan <strong>Solo Consulta</strong> definida en <code>S\00ED</code> para excluirlas del procesamiento.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260819835191938290.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4412)
,p_display_sequence=>20
,p_display_value=>'Tabla/Vista'
,p_return_value=>'TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Inserta, actualiza y suprime la utilizaci\00F3n de una tabla o vista diferente en la definida en la consulta SQL de origen de regi\00F3n.'),
unistr('Por ejemplo, la consulta SQL recupera datos de una uni\00F3n de tabla o una vista no actualizable y el procesamiento DML se debe realizar con una sola tabla base o una vista actualizable.</p>'),
unistr('<p>Nota: Aseg\00FArese de que las columnas que no se pueden insertar o actualizar tengan <strong>Solo Consulta</strong> definida en <code>S\00ED</code> para excluirlas del procesamiento.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(260820229830940047.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(260819106949935652.4412)
,p_display_sequence=>30
,p_display_value=>unistr('C\00F3digo PL/SQL')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El procesamiento se basa en c\00F3digo PL/SQL personalizado. Esta opci\00F3n permite ejecutar cualquier c\00F3digo PL/SQL para implantar cualquier manipulaci\00F3n de datos en la base de datos subyacente.</p>'),
unistr('<p>Esta opci\00F3n se debe utilizar al utilizar paquetes de base de datos, como API de tabla o llamadas a servicios web RESTful para implantar la l\00F3gica de negocio.</p>'),
unistr('<p>Nota: Se llamar\00E1 al c\00F3digo PL/SQL para cada fila que se haya insertado, actualizado o suprimido.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260820699209949601.4412)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Propietario de Tabla'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>'Seleccione el nombre del propietario de la tabla (esquema).'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(260821252819962990.4412)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nombre de la Tabla'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(260820699209949601.4412)
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TABLE'
,p_help_text=>unistr('Introduzca el nombre de vista o tabla sensible a may\00FAsculas/min\00FAsculas. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261083814084772472.4412)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('C\00F3digo PL/SQL para Insertar/Actualizar/Suprimir')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        insert into emp ( empno, ename, deptno )',
'        values ( :EMPNO, :ENAME, :DEPTNO )',
'        returning rowid into :ROWID;',
'    when ''U'' then',
'        update emp',
'           set ename  = :ENAME,',
'               deptno = :DEPTNO',
'         where rowid  = :ROWID;',
'    when ''D'' then',
'        delete emp',
'         where rowid = :ROWID;',
'    end case;',
'end;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca c\00F3digo PL/SQL para procesar cada fila de datos manipulados en la cuadr\00EDcula interactiva.</p>'),
'<p>Utilice el nombre de columna como una variable de enlace para acceder al valor de una columna. La variable del sistema <code>APEX$ROW_STATUS</code> devuelve el estado de una fila y se puede utilizar para comprobar si se ha creado, actualizado o su'
||unistr('primido la fila (consulte el siguiente ejemplo para obtener informaci\00F3n sobre c\00F3mo comprobar esto).</p>'),
unistr('<p><em>Nota:</em> Si las columnas de clave primaria las rellena un disparador o se rellenan en el c\00F3digo PL/SQL, es necesario que los nuevos valores se asignen a las variables de enlace de las columnas de clave primaria, ya que &PRODUCT_NAME. utiliza')
||unistr(' estos valores para recuperar la fila despu\00E9s de una inserci\00F3n o actualizaci\00F3n.</p>'),
unistr('<p>Oracle recomienda llamar a los procedimientos o funciones dentro de un paquete PL/SQL para facilitar la reutilizaci\00F3n y la capacidad de mantenimiento.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261084825593778341.4412)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Evitar Actualizaciones Perdidas'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique si el procesamiento debe garantizar que no se pierdan las actualizaciones cuando varios usuarios actualicen el mismo registro de base de datos.</p> ',
unistr('<p>Las actualizaciones se pierden cuando dos o m\00E1s personas intentan actualizar los mismos datos y la \00FAltima actualizaci\00F3n sobrescribe las actualizaciones realizadas por el primer usuario al guardar los cambios. Para evitar que esto ocurra, las actua')
||unistr('lizaciones pueden comprobar los valores de columna existentes en la base de datos con los valores recuperados cuando se consult\00F3 la fila originalmente.</p>'),
'<p>Por ejemplo:',
'  <ol>',
'    <li>El usuario A consulta registros de empleado (EMP).</li>',
'    <li>El usuario B consulta los mismos registros de empleado.</li>',
'    <li>El usuario B actualiza los detalles de empleado de EMPNO = 7839 y aplica (confirma) los cambios en la base de datos.</li>',
'    <li>El usuario A actualiza los detalles de empleado de EMPNO = 7839 e intenta aplicar los cambios en la base de datos.</li>',
'  </ol>',
unistr('Si el usuario A actualiza correctamente la misma fila, los cambios realizados por el usuario B se perder\00E1n.'),
unistr('Cuando el usuario A intenta guardar la fila de empleado, los datos de la base de datos son diferentes a los que el usuario A consult\00F3 originalmente. En el paso 1 descrito anteriormente, los valores de columna consultados originalmente por el usuario ')
||unistr('A se pueden capturar. A continuaci\00F3n, en el paso 4, los valores se pueden comparar con los valores actuales de la base de datos. Esta comparaci\00F3n generar\00E1 un error para el usuario A, ya que los valores de la base de datos fueron actualizados por el u')
||'suario B en el paso 3. Esto evita que un usuario sobrescriba los cambios realizados por otro usuario en la misma fila.</p>',
unistr('<p>Nota: La forma en que se detectan las actualizaciones perdidas se especifica en la regi\00F3n Atributos para la Cuadr\00EDcula Interactiva, seg\00FAn el valor de <strong>Tipo de Actualizaci\00F3n Perdida</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261085131500782260.4412)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Bloquear Fila'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Seleccione si cada fila que se vaya a actualizar o suprimir se bloquea en la tabla subyacente antes de procesar la fila.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085409986783810.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4412)
,p_display_sequence=>10
,p_display_value=>unistr('S\00ED')
,p_return_value=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Las filas que se van a actualizar o suprimir se bloquear\00E1n mediante SELECT ... FOR UPDATE para evitar que se realicen otras transacciones en la fila hasta que se confirme la transacci\00F3n.</p>'),
unistr('<p>Nota: Si se genera un error, como, por ejemplo, para las vistas actualizables que no soportan el bloqueo, debe poder utilizar c\00F3digo PL/SQL para bloquear la tabla de control.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261085868401784451.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4412)
,p_display_sequence=>20
,p_display_value=>'No'
,p_return_value=>'N'
,p_help_text=>unistr('Las filas no se bloquear\00E1n.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(261086261920786764.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(261085131500782260.4412)
,p_display_sequence=>30
,p_display_value=>unistr('C\00F3digo PL/SQL')
,p_return_value=>'PLSQL_CODE'
,p_help_text=>unistr('El c\00F3digo PL/SQL personalizado se utilizar\00E1 para bloquear las filas hasta que se confirme la transacci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261087562475803605.4412)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('C\00F3digo PL/SQL para Bloquear Fila')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(261085131500782260.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL_CODE'
,p_reference_scope=>'ROW'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'    l_dummy number;',
'begin',
'    select 1',
'      into l_dummy',
'      from emp',
'     where empno = :EMPNO',
'       for update nowait;',
'end;',
'</pre>'))
,p_help_text=>unistr('Introduzca el c\00F3digo PL/SQL para bloquear las filas de la tabla de base de datos que se van a actualizar y suprimir.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(352431952250846035.4412)
,p_plugin_id=>wwv_flow_api.id(260818839554927396.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Devolver Claves Primarias tras Inserci\00F3n')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(260819106949935652.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'REGION_SOURCE,TABLE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione si las columnas de clave primaria se deben devolver a la fila de la cuadr\00EDcula interactiva correspondiente una vez que la fila se inserta en la base de datos.'),
unistr('Generalmente, esta opci\00F3n se debe utilizar cuando las columnas de clave primaria se rellenan con un disparador de base de datos o una columna Identidad de Oracle Database 12 <em>c</em>.</p>'),
unistr('<p>Nota: Si se genera un error que especifica que la cl\00E1usula RETURNING INTO no est\00E1 permitida, debe definir esta opci\00F3n en No y rellenar previamente las columnas de clave primaria.</p>')))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/add_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261340108358474705.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ADD_CLASS'
,p_display_name=>'Agregar Clase'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ADD_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Agrega una o m\00E1s clases CSS a los elementos afectados.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261340305288502177.4412)
,p_plugin_id=>wwv_flow_api.id(261340108358474705.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Clase'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Agrega las clases CSS <code>articlenumber</code> y <code>highlight</code> a la etiqueta HTML de los elementos afectados:',
'<pre>articlenumber highlight</pre>'))
,p_help_text=>unistr('Especifique una o varias clases que se aplicar\00E1n a los elementos afectados. Si se especifica m\00E1s de una, separe los nombres de las clases con un espacio.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/remove_class
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261349722930705968.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REMOVE_CLASS'
,p_display_name=>'Eliminar Clase'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REMOVE_CLASS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Elimina una o m\00E1s clases CSS de los elementos afectados.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261350305185719779.4412)
,p_plugin_id=>wwv_flow_api.id(261349722930705968.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Clase'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('<p>Especifique uno o varios nombres de clase que se eliminar\00E1n de los elementos afectados. Si se especifica m\00E1s de uno, separe los nombres de clase con un espacio. D\00E9jelo en blanco para eliminar todos los nombres de clase de los elementos afectados.<')
||'/p>'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_css
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(261356726281848792.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_CSS'
,p_display_name=>'Definir Estilo'
,p_category=>'STYLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_CSS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Define una propiedad de estilo (CSS) en los elementos afectados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261356901132851044.4412)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nombre del Estilo'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Introduzca el nombre de la propiedad de estilo (CSS) que desea definir para los elementos afectados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(261357406326852547.4412)
,p_plugin_id=>wwv_flow_api.id(261356726281848792.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el valor con el que definir la propiedad de estilos para los elementos afectados. D\00E9jelo en blanco para eliminar la propiedad de estilo de los elementos afectados.')
);
end;
/
prompt --application/shared_components/plugins/authentication_type/custom
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(352953211423309033.4412)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'CUSTOM'
,p_display_name=>'Personalizado'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','CUSTOM'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Esquema de autenticaci\00F3n que le permite definir sus propias funciones PL/SQL para determinar la autenticaci\00F3n de usuario.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353179625368369848.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nombre de Funci\00F3n de Protecci\00F3n')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique c\00F3digo PL/SQL que devuelva un valor booleano, en ''C\00F3digo PL/SQL'' -</p>'),
'<pre>',
'function sentry_basic_auth',
'return boolean',
'is',
'    c_auth_header   constant varchar2(4000) := owa_util.get_cgi_env(''AUTHORIZATION'');',
'    l_user_pass     varchar2(4000);',
'    l_separator_pos pls_integer;',
'begin',
'    if apex_application.g_user <> ''nobody'' then',
'        return true;',
'    end if;',
'',
'    if c_auth_header like ''Basic %'' then',
'        l_user_pass := utl_encode.text_decode (',
'                           buf      => substr(c_auth_header, 7),',
'                           encoding => utl_encode.base64 );',
'        l_separator_pos := instr(l_user_pass, '':'');',
'        if l_separator_pos > 0 then',
'            apex_authentication.login (',
'                p_username => substr(l_user_pass, 1, l_separator_pos-1),',
'                p_password => substr(l_user_pass, l_separator_pos+1) );',
'            return true;',
'        end if;',
'    end if;',
'',
'    return false;',
'end sentry_basic_auth;',
'</pre>',
unistr('<p>Especifique una funci\00F3n de base de datos PL/SQL - </p>'),
'<pre>',
'sentry_basic_auth',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de una funci\00F3n que ejecuta el motor de &PRODUCT_NAME. al principio de cualquier solicitud realizada al motor como, por ejemplo, antes de que se muestre o procese cada p\00E1gina o que se emita una solicitud AJAX. '),
unistr('Se puede definir en el c\00F3digo PL/SQL de la autenticaci\00F3n, en un paquete o como una funci\00F3n almacenada.</p>'),
unistr('<p>Si esta funci\00F3n devuelve false (lo que quiz\00E1s indica que el usuario no est\00E1 conectado), la sesi\00F3n se marca como no v\00E1lida y se llama a <em>Procedimiento de Sesi\00F3n no V\00E1lido</em>.'),
unistr('Despu\00E9s, &PRODUCT_NAME. redirige a la URL definida en ''Sesi\00F3n no v\00E1lida > Ir a''.'),
unistr('Si el valor de este campo est\00E1 vac\00EDo,'),
unistr('se llama a una funci\00F3n de protecci\00F3n por defecto interna que intenta establecer una sesi\00F3n v\00E1lida mediante la comparaci\00F3n del ID de la sesi\00F3n en la direcci\00F3n URL y la informaci\00F3n de la sesi\00F3n en la cookie del esquema de autenticaci\00F3n (recuperando la ')
||'cookie del creador de &PRODUCT_NAME. si falla).</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551983430308015470.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Nombre de Procedimiento de Sesi\00F3n No V\00E1lido')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'procedure invalid_session_basic_auth',
'is',
'begin',
'    owa_util.status_line (',
'        nstatus       => 401,',
'        creason       => ''Basic Authentication required'',',
'        bclose_header => false);',
'    htp.p(''WWW-Authenticate: Basic realm="protected realm"'');',
'    apex_application.stop_apex_engine;',
'end invalid_session_basic_auth;',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del procedimiento PL/SQL que se llama si se ha detectado una sesi\00F3n no v\00E1lida.</p>'),
'',
unistr('<p>Puede hacer referencia a una funci\00F3n del bloque de c\00F3digo PL/SQL an\00F3nimo, una funci\00F3n de paquete o una funci\00F3n aut\00F3noma de la base de datos. Por ejemplo: <code>invalid_session_basic_auth</code></p>'),
'<p/>',
unistr('<p>Cuando hace referencia a una funci\00F3n aut\00F3noma o un paquete PL/SQL de la base de datos, puede utilizar la cadena de sustituci\00F3n <code>#OWNER#</code> para hacer referencia al esquema de an\00E1lisis de la aplicaci\00F3n actual. Por ejemplo: <code>#OWNER#.in')
||'valid_session_basic_auth</code></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353293115026395181.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Nombre de Funci\00F3n de Autenticaci\00F3n')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el siguiente c\00F3digo en el \00E1rea de texto ''C\00F3digo PL/SQL''</p>'),
'<pre>',
'function my_authentication (',
'    p_username in varchar2,',
'    p_password in varchar2 )',
'    return boolean',
'is',
'    l_user my_users.user_name%type := upper(p_username);',
'    l_id   my_users.id%type;',
'    l_hash my_users.password_hash%type;',
'begin',
'    begin',
'        select id  , password_hash',
'          into l_id, l_hash',
'          from my_users',
'         where user_name = l_user;',
'    exception when no_data_found then',
'        l_hash := ''-invalid-'';',
'    end;',
'',
'    return l_hash = rawtohex(sys.dbms_crypto.hash (',
'                        sys.utl_raw.cast_to_raw (',
'                            p_password||l_id||l_user ),',
'                        sys.dbms_crypto.hash_sh512 ));',
'end;',
'</pre>',
'',
unistr('<p>y <code>my_authentication</code> como ''Funci\00F3n de autenticaci\00F3n''.')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique  el nombre de la funci\00F3n que verificar\00E1 el nombre de usuario y la contrase\00F1a del usuario, despu\00E9s de que se introduzcan en una p\00E1gina de conexi\00F3n.'),
unistr('Si no introduce nada, permite cualquier nombre de usuario/contrase\00F1a.'),
unistr('La propia funci\00F3n se puede definir en el \00E1rea de texto "C\00F3digo PL/SQL" de la autenticaci\00F3n, en un paquete o como una funci\00F3n almacenada.</p>'),
'',
unistr('<p>Esta funci\00F3n debe devolver un valor booleano al procedimiento de conexi\00F3n que la llama. Tiene 2 par\00E1metros de entrada, ''p_username'' y ''p_password'', que se pueden utilizar para acceder a los valores introducidos por un usuario final en la p\00E1gina de')
||unistr(' conexi\00F3n.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(353301225415398269.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Nombre de Procedimiento Posterior a la Desconexi\00F3n')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el siguiente c\00F3digo en el \00E1rea de texto ''C\00F3digo PL/SQL''</p>'),
'<pre>',
'procedure my_post_logout',
'is',
'begin',
'    insert into logout_log (',
'        application_id,',
'        session_id,',
'        logout_time,',
'        user_name',
'    ) values (',
'        :APP_ID,',
'        :APP_SESSION,',
'        sysdate,',
'        :APP_USER );',
'end;',
'</pre>',
'',
'<p>and <code>my_post_logout</code> as ''Post Logout Procedure''.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('El nombre del procedimiento que se llama despu\00E9s de que el usuario final haga clic en la direcci\00F3n URL de desconexi\00F3n. Se puede utilizar para el registro.'),
unistr('El propio procedimiento se puede definir en el \00E1rea de texto "C\00F3digo PL/SQL" de la autenticaci\00F3n, en un paquete o como una funci\00F3n almacenada.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629094915193552126.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Activar Atributos de Autenticaci\00F3n de Legado')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si esta lista de selecci\00F3n se define en "S\00ED" se muestran atributos de autenticaci\00F3n adicionales.'),
'Estos atributos son especialmente relevantes para las autenticaciones personalizadas transferidas desde &PRODUCT_NAME. 4.0 y anterior.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629174621211563368.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Nombre de la Aplicaci\00F3n Asociada de SSO')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si se autentica con Oracle Application Server Single Sign-On y su aplicaci\00F3n es una aplicaci\00F3n asociada que est\00E1 registrada con SSO, introduzca exactamente el mismo nombre que utiliz\00F3 al registrar la aplicaci\00F3n asociada con SSO.'),
'',
unistr('Deje este campo en blanco si depende de que Application Express sea la aplicaci\00F3n asociada que est\00E1 registrada.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629550107668606770.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Host LDAP'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Nombre del host del servidor de directorios LDAP.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629554415286608926.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Puerto LDAP'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('N\00FAmero de puerto del host de directorio LDAP.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629644211608617346.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Usar SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Elija si desea utilizar SSL para enlazar al directorio LDAP. Si se elige SSL con la autenticaci\00F3n, deber\00E1 configurar una cartera para la instancia de Application Express.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629669815417618470.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4412)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629680822344620420.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4412)
,p_display_sequence=>20
,p_display_value=>unistr('SSL con Autenticaci\00F3n')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(629685004813624810.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(629644211608617346.4412)
,p_display_sequence=>30
,p_display_value=>'Sin SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629825611870636385.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Cadena de DN de LDAP'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>DN Exacto</dt>',
'  <dd><code>cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com</code></dd>',
unistr('  <dt>DN no Exacto (Base de B\00FAsqueda)</dt>'),
'  <dd><code>dc=yourdomain,dc=com</code></dd>',
'</dl>'))
,p_help_text=>unistr('Introduzca el patr\00F3n utilizado para crear el nombre distintivo (DN) totalmente cualificado en DBMS_LDAP.SIMPLE_BIND_S si se va a utilizar el DN exacto; o la base de b\00FAsqueda si no se va a utilizar un DN exacto. Utilice <strong>%LDAP_USER%</strong> co')
||unistr('mo marcador de posici\00F3n del nombre de usuario.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629787303213633849.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Usar Nombre Distinguido Exacto (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Elija si el nombre distintivo (DN) de LDAP ser\00E1 exacto o no. Si no lo es, se convertir\00E1 en la base de b\00FAsqueda y deber\00E1 proporcionar un filtro de b\00FAsqueda.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(741851526139627010.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>unistr('Filtro de B\00FAsqueda')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629787303213633849.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'cn=%LDAP_USER%',
'</pre>'))
,p_help_text=>unistr('Introduzca el filtro de b\00FAsqueda cuando no utilice un nombre distintivo (DN) exacto. Utilice <code>%LDAP_USER%</code> como marcador de posici\00F3n del nombre de usuario.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(629863429878641530.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>unistr('Funci\00F3n de Edici\00F3n de Nombre de Usuario de LDAP')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El siguiente c\00F3digo llama a una funci\00F3n que sustituye todos los "."'' por "_"'' en la cadena DN:</p>'),
'<pre>',
'return apex_custom_auth.ldap_dnprep;',
'</pre>'))
,p_help_text=>unistr('Puede proporcionar m\00E1s c\00F3digo para su ejecuci\00F3n y transformar el nombre de usuario en un formato perfectamente adaptado a la entrada de directorio LDAP o al nombre de usuario LDAP.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38291032596231774.4412)
,p_plugin_id=>wwv_flow_api.id(352953211423309033.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Identificaci\00F3n de Nombre de Usuario')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(629094915193552126.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Antes de sustituir <code><strong>%LDAP_USER%</strong></code> en el nombre distintivo de LDAP y en la cadena de b\00FAsqueda,'),
unistr('&PRODUCT_NAME. puede omitir autom\00E1ticamente caracteres especiales en el nombre de usuario.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291304329233033.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Est\00E1ndar')
,p_return_value=>'STD'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Omite caracteres especiales seg\00FAn la RFC 4514 (para nombres distintivos) y la RFC 4515 (para las cadenas de b\00FAsqueda).'),
unistr('Adem\00E1s, omite los caracteres unicode.'),
unistr('\00C9ste es el valor m\00E1s seguro, pero puede provocar problemas con algunos servidores LDAP.')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38291708139234196.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4412)
,p_display_sequence=>20
,p_display_value=>unistr('S\00F3lo caracteres especiales')
,p_return_value=>'ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Omite caracteres especiales seg\00FAn la RFC 4514 (para nombres distintivos) y la RFC 4515 (para las cadenas de b\00FAsqueda).'),
'No omite los caracteres unicode.'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38292111602235122.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(38291032596231774.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Sin Identificaci\00F3n')
,p_return_value=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('No omite ning\00FAn car\00E1cter. Este valor es potencialmente inseguro,'),
unistr('a menos que se utilice una <strong>funci\00F3n de edici\00F3n de nombre de usuario</strong> que ya'),
'omita el nombre de usuario (por ejemplo, con <code>apex_escape.ldap_dn</code> o <code>apex_escape.ldap_search_filter</code>).'))
);
end;
/
prompt --application/shared_components/plugins/process_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(360896225809711408.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('Ejecutar c\00F3digo')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Proceso para ejecutar el c\00F3digo PL/SQL.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/process_type/close_window
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361240401142661438.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'CLOSE_WINDOW'
,p_display_name=>unistr('Cerrar Recuadro de Di\00E1logo')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','CLOSE_WINDOW'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Proceso para cerrar la p\00E1gina del cuadro de di\00E1logo modal o no modal actual.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(369154203766535800.4412)
,p_plugin_id=>wwv_flow_api.id(361240401142661438.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Elementos para Devolver '
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre de uno o m\00E1s elementos de p\00E1gina que devolver\00E1 el cuadro de di\00E1logo. Para varios elementos, separe cada nombre de elemento con una coma.</p>'),
unistr('<p>Puede acceder a los valores del elemento devuelto mediante la definici\00F3n de una acci\00F3n din\00E1mica para disparar el evento <strong>Cuadro de Di\00E1logo Cerrado</strong> en el elemento que abre el cuadro de di\00E1logo, con una acci\00F3n de <strong>Definir Valo')
||unistr('r</strong> y <em>Definir Tipo</em> del <strong>Elemento de Retorno de Cuadro de Di\00E1logo</strong>.</p>')))
);
end;
/
prompt --application/shared_components/plugins/process_type/session_state
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361248208719417603.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SESSION_STATE'
,p_display_name=>unistr('Borrar Estado de Sesi\00F3n')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SESSION_STATE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Proceso para borrar el estado de la sesi\00F3n almacenado en &PRODUCT_NAME.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361248525085440449.4412)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CLEAR_CACHE_CURRENT_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione el tipo de estado de sesi\00F3n que va a borrar.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361259116722915252.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4412)
,p_display_sequence=>1
,p_display_value=>unistr('Borrar Todos los Elementos en la P\00E1gina Actual')
,p_return_value=>'CLEAR_CACHE_CURRENT_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250412576446197.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4412)
,p_display_sequence=>3
,p_display_value=>unistr('Borrar Todos los Elementos en las P\00E1ginas')
,p_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361250015380444942.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4412)
,p_display_sequence=>5
,p_display_value=>'Borrar Elementos  '
,p_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249617968443751.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4412)
,p_display_sequence=>7
,p_display_value=>unistr('Borrar Sesi\00F3n Actual')
,p_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361249219909442830.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4412)
,p_display_sequence=>9
,p_display_value=>unistr('Borrar Aplicaci\00F3n Actual')
,p_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361248822065441760.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361248525085440449.4412)
,p_display_sequence=>10
,p_display_value=>'Borrar Aplicaciones'
,p_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361253232596482537.4412)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Aplicaciones'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_FLOWS'
,p_help_text=>unistr('Introduzca una lista de ID de aplicaci\00F3n, separados por comas, como <code>100,101,105</code>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361254917715489399.4412)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elementos'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_ITEMS'
,p_help_text=>unistr('Seleccione los elementos de p\00E1gina que se van a borrar del estado de sesi\00F3n, como <code>P1_EMPNO,P1_ENAME</code>. En el caso de varios elementos, separe el nombre de cada elemento con una coma. Puede escribir el nombre o elegirlo en la lista de eleme')
||'ntos disponibles.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361255209304493322.4412)
,p_plugin_id=>wwv_flow_api.id(361248208719417603.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('P\00E1ginas')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361248525085440449.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CLEAR_CACHE_FOR_PAGES'
,p_help_text=>unistr('Introduzca una lista de n\00FAmeros de p\00E1gina separados por comas, como <code>1,2,5</code>.')
);
end;
/
prompt --application/shared_components/plugins/process_type/reset_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361603521916198029.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'RESET_PAGINATION'
,p_display_name=>unistr('Restablecer Paginaci\00F3n')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','RESET_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Proceso para restablecer la paginaci\00F3n de los informes en la p\00E1gina actual.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361603814800201390.4412)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Destino'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THIS_PAGE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione si se debe restablecer la paginaci\00F3n en todas las p\00E1ginas, en algunas p\00E1ginas o en la p\00E1gina actual.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604111996202714.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Esta P\00E1gina')
,p_return_value=>'THIS_PAGE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604905742205597.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4412)
,p_display_sequence=>20
,p_display_value=>unistr('P\00E1gina(s)')
,p_return_value=>'PAGES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361604508330204363.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361603814800201390.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Todas las P\00E1ginas')
,p_return_value=>'ALL_PAGES'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361606225139211720.4412)
,p_plugin_id=>wwv_flow_api.id(361603521916198029.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('P\00E1ginas')
,p_attribute_type=>'PAGE NUMBERS'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361603814800201390.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGES'
,p_help_text=>unistr('Introduzca una lista de n\00FAmeros de p\00E1gina, separados por comas.')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_add_rows
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361705302264974293.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_ADD_ROWS'
,p_display_name=>'Pantalla Tabular - Agregar Filas'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_ADD_ROWS'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Proceso para agregar una fila a una regi\00F3n de pantalla tabular.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361705527915977613.4412)
,p_plugin_id=>wwv_flow_api.id(361705302264974293.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('N\00FAmero de Filas')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el n\00FAmero de filas.')
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_update
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361709604296657121.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_UPDATE'
,p_display_name=>unistr('Pantalla Tabular - Actualizaci\00F3n de Varias Filas')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_UPDATE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Proceso para actualizar varias filas desde una regi\00F3n de pantalla tabular. Este proceso tambi\00E9n sirve para insertar registros agregados en la regi\00F3n.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361709824771662765.4412)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Propietario de Tabla'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Seleccione el nombre del propietario de la tabla (esquema).'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710119164665443.4412)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nombre de la Tabla'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361709824771662765.4412)
,p_help_text=>unistr('Introduzca el nombre de vista o tabla sensible a may\00FAsculas/min\00FAsculas. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710408812670214.4412)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Columna de Clave Primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4412)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la columna que contiene el valor de la clave primaria. Para tablas con m\00E1s de dos claves primarias de dos partes, seleccione <strong>ROWID</strong>.</p>'),
unistr('<p>La clave primaria se utiliza para identificar las filas que se van a actualizar y no se podr\00E1n editar en la pantalla tabular. Para nuevas filas, el valor de clave primaria debe estar vac\00EDo.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361710732738674350.4412)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Columna de Clave Secundaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361710119164665443.4412)
,p_help_text=>'Seleccione la columna que contiene el segundo valor de clave primaria. Este atributo solo se debe rellenar si la clave primaria consta de dos columnas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361711421080694858.4412)
,p_plugin_id=>wwv_flow_api.id(361709604296657121.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Cl\00E1usula Where en Tiempo de Ejecuci\00F3n')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limita los departamentos mediante:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Introduzca la cl\00E1usula SQL WHERE que se agrega a todas las sentencias INSERT y UPDATE generadas. Utilice este atributo para limitar los registros que se utilizan en las llamadas SQL generadas autom\00E1ticamente.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_fetch
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361799714569626543.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_FETCH'
,p_display_name=>unistr('Recuperaci\00F3n Autom\00E1tica de Filas')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_FETCH'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Proceso para recuperar registros de una sola vista o tabla de la base de datos. Este proceso se utiliza para rellenar elementos de pantalla con un origen de tipo <strong>Columna de Base de Datos</strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800032025633659.4412)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Propietario de Tabla'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Seleccione el nombre del propietario de la tabla (esquema).'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800327927635543.4412)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nombre de la Tabla'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800032025633659.4412)
,p_help_text=>unistr('Introduzca el nombre de vista o tabla sensible a may\00FAsculas/min\00FAsculas. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800622105638213.4412)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento de Clave Primaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el valor de la columna de clave primaria. Puede escribir el nombre o elegirlo en la lista.')
,p_attribute_comment=>'$$$ DJP - Pop-up LOV allows selection of Custom Page, Global Page, Application Items as well - Shouldn''t it only be Page Items?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361800918654639837.4412)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>25
,p_prompt=>'Columna de Clave Primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4412)
,p_help_text=>unistr('Seleccione la columna que contiene el valor de clave primaria. Para las tablas que tienen m\00E1s de dos claves primarias de dos partes, seleccione <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801213910642088.4412)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Elemento de Clave Secundaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(361801505499645968.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el segundo valor de la columna de clave primaria. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361801505499645968.4412)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>40
,p_prompt=>'Columna de Clave Secundaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4412)
,p_depending_on_attribute_id=>wwv_flow_api.id(361800918654639837.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>'Seleccione la columna que contiene el segundo valor de clave primaria. Este atributo solo se debe rellenar si la clave primaria consta de dos columnas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361805328759939092.4412)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Columna de Versi\00F3n de Fila')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(361800327927635543.4412)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la columna que identifica la versi\00F3n de la fila; esta columna no debe estar presente en la p\00E1gina. Deje este atributo en blanco para utilizar el total de control incorporado.</p>'),
unistr('<p>El bloqueo oportunista utiliza la detecci\00F3n de actualizaciones perdidas para garantizar la integridad de los datos en aplicaciones en las que se puede acceder a los datos de manera simult\00E1nea. &PRODUCT_NAME. puede utilizar un total de control inco')
||unistr('rporado para realizar la detecci\00F3n de actualizaciones perdidas y determinar la versi\00F3n de la fila. El total de control es una funci\00F3n hash de todos los valores de columna de la fila de la tabla espec\00EDfica. Se recupera cuando se consulta el registro d')
||unistr('esde la base de datos y, a continuaci\00F3n, se compara con el hash del registro actual en la base de datos como parte del <em>Procesamiento Autom\00E1tico de Filas</em>. Si los dos valores son iguales, la actualizaci\00F3n contin\00FAa; de lo contrario, el procesam')
||unistr('iento de filas autom\00E1tico genera un error.</p>'),
unistr('<p>Este atributo le permite especificar una sola columna que contiene la versi\00F3n de la fila, como alternativa al uso del procesamiento de total de control incorporadas. Esta columna se debe actualizar siempre que se actualiza un registro en la base d')
||unistr('e datos. Oracle recomienda implantar un disparador de bases de datos "Antes de Actualizaci\00F3n" en la tabla para incrementar o actualizar la columna de versi\00F3n de fila. Se presupone que las columnas NUMBER contienen un n\00FAmero de secuencia para la fila.')
||unistr(' Sin embargo, tambi\00E9n se pueden utilizar columnas DATE y TIMESTAMP. La ventaja de utilizar una sola columna es que el motor de &PRODUCT_NAME. no tiene que realizar el hash de la fila completa, solo tiene que comparar un valor de una sola columna.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361804814168854679.4412)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Cl\00E1usula Where en Tiempo de Ejecuci\00F3n')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limita los departamentos mediante:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Introduzca la cl\00E1usula SQL WHERE que se agrega a la sentencia SELECT generada. Utilice este atributo para limitar los registros que se utilizan en las llamadas SQL generadas autom\00E1ticamente.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361802100261724338.4412)
,p_plugin_id=>wwv_flow_api.id(361799714569626543.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Modo de Recuperaci\00F3n')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_deprecated_values=>'D'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Esta opci\00F3n solo existe por motivos de compatibilidad con versiones anteriores.'),
unistr('En las aplicaciones nuevas, este valor se debe dejar siempre vac\00EDo.'),
unistr('La opci\00F3n "Definir Cach\00E9 de Memoria en Visualizaci\00F3n" est\00E1 en desuso y no se utiliza en los procesos generados con esta versi\00F3n de &PRODUCT_NAME..'),
'</p>',
'<p>',
unistr('Cuando un proceso de Recuperaci\00F3n Autom\00E1tica de Filas selecciona una fila, los elementos de p\00E1gina correspondientes se definen en los valores de columna recuperados. El valor de Modo de Recuperaci\00F3n DML determina el momento en el que se produce. El m')
||unistr('odo por defecto actualiza el estado de la sesi\00F3n en memoria justo cuando se recupera la fila. El modo "Definir Cach\00E9 de Memoria en Visualizaci\00F3n" actualiza este estado de sesi\00F3n solo cuando (y si) se presenta el elemento. Si necesita hacer referencia')
||unistr(' al valor recuperado del elemento mediante la variable de enlace o la sintaxis <code>v(''ITEM_NAME'')</code> entre la hora de recuperaci\00F3n de la fila y la hora de presentaci\00F3n de la fila, debe utilizar el modo de recuperaci\00F3n por defecto. Cuando se cre')
||unistr('a un nuevo proceso Recuperaci\00F3n Autom\00E1tica de Filas, el modo de recuperaci\00F3n se definir\00E1 en este modo por defecto. A menos que la l\00F3gica de la p\00E1gina dependa del comportamiento de "En Visualizaci\00F3n", se recomienda actualizar este proceso para que uti')
||unistr('lice el comportamiento por defecto, que proporciona una flexibilidad m\00E1xima para hacer referencia a los valores de columna recuperados durante la presentaci\00F3n de la p\00E1gina.'),
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(361803025912727611.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361802100261724338.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Definir Cach\00E9 de Memoria en Visualizaci\00F3n [En desuso]')
,p_return_value=>'D'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(361898027238424612.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE'
,p_display_name=>'Servicio Web'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Proceso para consumir el servicio web especificado.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361898312142431520.4412)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Operaci\00F3n de Servicio Web')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_translatable=>false
,p_lov_type=>'COMPONENT'
,p_lov_component_type_id=>3541
,p_help_text=>unistr('Seleccione una operaci\00F3n de servicio web.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703289302749886160.4412)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Almacenar Resultado en'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703289611172888366.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4412)
,p_display_sequence=>10
,p_display_value=>'Elementos'
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(703290033944889185.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(703289302749886160.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Recopilaci\00F3n')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(703290641370900883.4412)
,p_plugin_id=>wwv_flow_api.id(361898027238424612.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Nombre de la Recopilaci\00F3n')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(703289302749886160.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/process_type/form_pagination
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362034004386015380.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PAGINATION'
,p_display_name=>unistr('Paginaci\00F3n de Pantalla')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PAGINATION'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Proceso para recuperar el registro anterior o siguiente desde una vista o tabla de la base de datos. Este proceso se puede utilizar para proporcionar paginaci\00F3n en las p\00E1ginas de pantalla, de forma que los usuarios finales puedan recuperar el regi')
||'stro anterior o siguiente sin tener que volver a un informe.</p>',
unistr('<p><em>Nota: si la pantalla permite actualizar datos, generalmente deber\00EDa asegurarse de que se realiza el procesamiento adecuado de la pantalla antes de la ejecuci\00F3n de este proceso de paginaci\00F3n. De lo contrario, las actualizaciones que realice el ')
||unistr('usuario final se perder\00E1n al navegar a otro registro.</em></p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034324862021077.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Propietario de Tabla'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Seleccione el nombre del propietario de la tabla (esquema).'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362034618176024149.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nombre de la Tabla'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034324862021077.4412)
,p_help_text=>unistr('Introduzca el nombre de vista o tabla sensible a may\00FAsculas/min\00FAsculas. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035122261037451.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Elemento de Clave Primaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el valor de la columna de clave primaria. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035415360040649.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>'Columna de Clave Primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_default_value=>'ROWID'
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4412)
,p_help_text=>unistr('Seleccione la columna que contiene el valor de clave primaria. Para las tablas que tienen m\00E1s de dos claves primarias de dos partes, seleccione <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362035708675043722.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Elemento de Clave Secundaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el segundo valor de la columna de clave primaria. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362036002636046567.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Columna de Clave Secundaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4412)
,p_depending_on_attribute_id=>wwv_flow_api.id(362035415360040649.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>'Seleccione la columna que contiene el segundo valor de clave primaria. Este atributo solo se debe rellenar si la clave primaria consta de dos columnas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362067915033505841.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Columna de Orden de Navegaci\00F3n')
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4412)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la columna que contiene el valor del orden de navegaci\00F3n.</p>'),
'<p>Esta columna se utiliza para determinar las filas anterior y siguiente. Por tanto, una columna como <code>DISPLAY_SEQ</code> es la columna ideal para utilizar. Si desea ordenar los registros en la secuencia en la que se crearon, puede utilizar una'
||unistr(' columna como <code>CREATED</code> o <code>ID</code>, cuando se rellena desde una secuencia o bas\00E1ndose en una columna de identidad de Oracle Database 12<em>c</em>. Sin embargo, dispone de la flexibilidad de ordenar los registros por cualquiera de la')
||'s dos columnas, por ejemplo, <code>JOB</code> y <code>DEPTNO</code></p>',
unistr('<p><em>Nota: las columnas del orden de navegaci\00F3n deben coincidir con las columnas por defecto que se utilizan para ordenar los usuarios finales del informe desde los que se navega para llegar a esta pantalla. Como alternativa, debe asegurarse de que')
||unistr(' los usuarios finales saben c\00F3mo se determinan las filas anterior y siguiente. Por ejemplo, mediante etiquetas de botones o texto de ayuda.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068209426508489.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Columna de Orden de Navegaci\00F3n Secundaria')
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(362034618176024149.4412)
,p_help_text=>unistr('Seleccione la columna que contiene el segundo valor del orden de navegaci\00F3n. Este atributo solo se debe rellenar si la clave de navegaci\00F3n consta de dos columnas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362068730117514082.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Siguiente Elemento de Clave Primaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el valor de la columna de clave primaria para el registro <em>siguiente</em>. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069024510516623.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Elemento de Clave Primaria Anterior'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el valor de la columna de clave primaria para el registro <em>anterior</em>. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069318687519376.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Siguiente Elemento de Clave Secundaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el segundo valor de la columna de clave primaria para el registro <em>siguiente</em>. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362069614158521442.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Elemento de Clave Secundaria Anterior'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(362036002636046567.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el segundo valor de la columna de clave primaria para el registro <em>anterior</em>. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070100572527702.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_prompt=>'Elemento de Recuento de Filas Actual'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el valor del recuento de registros total. Puede escribir el nombre o elegirlo en la lista.</p>'),
unistr('<p>Si el juego de resultados contiene m\00E1s de 10000 filas, la definici\00F3n de este art\00EDculo puede ralentizar el rendimiento.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362070418675534553.4412)
,p_plugin_id=>wwv_flow_api.id(362034004386015380.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_prompt=>unistr('Cl\00E1usula Where en Tiempo de Ejecuci\00F3n')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'deptno = :P1_DEPTNO',
'</pre>'))
,p_help_text=>'Introduzca una sentencia SQL para restringir los registros que devuelve la consulta.'
);
end;
/
prompt --application/shared_components/plugins/process_type/web_service_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(362310022409142749.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'WEB_SERVICE_LEGACY'
,p_display_name=>'Servicio Web Heredado'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','WEB_SERVICE_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Proceso para consumir el servicio web especificado. Oracle recomienda actualizar este proceso a <strong>Servicio Web</strong>.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362310307960149400.4412)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Referencia de Servicio Web'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el n\00FAmero de referencia del servicio web.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704862682583352671.4412)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Almacenar Resultado en'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704862979987353733.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4412)
,p_display_sequence=>10
,p_display_value=>'Elementos'
,p_return_value=>'ITEMS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(704863378280354870.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(704862682583352671.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Recopilaci\00F3n')
,p_return_value=>'COLLECTION'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(704864081757360262.4412)
,p_plugin_id=>wwv_flow_api.id(362310022409142749.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Nombre de la Recopilaci\00F3n')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(704862682583352671.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'COLLECTION'
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/textarea
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(376364131288521442.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXTAREA'
,p_display_name=>unistr('\00C1rea de Texto')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXTAREA'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un \00E1rea de texto de varias filas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376904739508510313.4412)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redimensionable'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si se ha activado el cambio de tama\00F1o del \00E1rea de texto mediante el mouse.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905227172516182.4412)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Altura Autom\00E1tica')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si la altura del \00E1rea del texto var\00EDa seg\00FAn la cantidad de texto mostrada. Utilice esta opci\00F3n para escalar el \00E1rea de texto a la cantidad de datos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(376905734098518181.4412)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Contador de Caracteres'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si se muestra un contador debajo del \00E1rea de texto. El contador muestra el n\00FAmero de caracteres que se han introducido en el campo y el total de caracteres permitidos, como <code>123 de 4000</code>. Cuando est\00E1 activado, el atributo de Lo')
||unistr('ngitud M\00E1xima debe definirse.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362202612251785897.4412)
,p_plugin_id=>wwv_flow_api.id(376364131288521442.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Recortar Espacios'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione la forma en que se recorta el valor del elemento despu\00E9s de ejecutar la p\00E1gina. Este valor sirve para recortar espacios, tabulaciones y nuevas l\00EDneas del texto introducido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362202910095786913.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4412)
,p_display_sequence=>10
,p_display_value=>'Inicial'
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203307938787882.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4412)
,p_display_sequence=>20
,p_display_value=>'Final'
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362203705781788933.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4412)
,p_display_sequence=>30
,p_display_value=>'Inicial y Final'
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362204104056789676.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(362202612251785897.4412)
,p_display_sequence=>40
,p_display_value=>'Ninguno'
,p_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/plugins/region_type/sql_report
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380028817628072908.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SQL_REPORT'
,p_display_name=>unistr('Informe Cl\00E1sico')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SQL_REPORT'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Informe simplificado basado en una consulta SQL. Los informes cl\00E1sicos son similares a los informes interactivos, pero no incluyen las numerosas opciones de personalizaci\00F3n del usuario final de las que disponen los informes interactivos.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234584057047894023.4412)
,p_plugin_id=>wwv_flow_api.id(380028817628072908.4412)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/tabform
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380029119558081299.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TABFORM'
,p_display_name=>'Pantalla Tabular'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TABFORM'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:FETCHED_ROWS:NO_DATA_FOUND_MESSAGE:COLUMN_HEADING'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Muestra varias filas de datos en un dise\00F1o de cuadr\00EDcula, en el que los usuarios finales pueden actualizar valores directamente en un elemento de cuadr\00EDcula.')
,p_version_identifier=>'1.0'
,p_plugin_comment=>'"Number of Fetched Rows" and "No Data Found Message" have to be checked because are needed to keep REGION PLUGIN ATTRIBUTES component type in sync.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153406632834485.4412)
,p_plugin_id=>wwv_flow_api.id(380029119558081299.4412)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/ir
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(380454112071587884.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'IR'
,p_display_name=>'Informe Interactivo'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','IR'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.jetChart#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Informe en l\00EDnea completo basado en una consulta SQL que proporciona a los usuarios finales numerosas funciones para personalizar el dise\00F1o del informe en tiempo de ejecuci\00F3n. Para controlar las capacidades del usuario final, puede activar o desac')
||unistr('tivar las diversas opciones de personalizaci\00F3n de informes.</p>'),
unistr('<p>Puede definir un solo informe interactivo y que los usuarios finales manipulen los datos que se muestran para satisfacer sus requisitos de informes espec\00EDficos, en lugar de tener que desarrollar varios informes similares con diferentes criterios p')
||'ara satisfacer esos mismos requisitos.</p>'))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1831648887398980457.4412)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Estructura del Men\00FA Acciones')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'IG'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique si la estructura del men\00FA Acciones ser\00E1 consistente con el componente Cuadr\00EDcula Interactiva o si utilizar\00E1 la estructura heredada.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831649884271983182.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4412)
,p_display_sequence=>10
,p_display_value=>'Heredado'
,p_return_value=>'LEGACY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1831650362309985149.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1831648887398980457.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Cuadr\00EDcula Interactiva')
,p_return_value=>'IG'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(234862891586787752.4412)
,p_plugin_id=>wwv_flow_api.id(380454112071587884.4412)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select empno,',
'       ename,',
'       job,',
'       sal',
'  from emp',
' where deptno = :P1_DEPTNO',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/static
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(384582062506273077.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'STATIC'
,p_display_name=>unistr('Contenido Est\00E1tico')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','STATIC'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Muestra el contenido de texto o un contenedor de regi\00F3n para elementos de p\00E1gina. Para obtener marcas HTML en la salida y que no se omita el contenido, defina <em>Salida como</em> en <strong>HTML</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(384582415870309214.4412)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>30
,p_prompt=>unistr('Ampliar M\00E9todos Abreviados')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_help_text=>unistr('Especifique si &PRODUCT_NAME. ampl\00EDa los m\00E9todos abreviados en el cuerpo HTML.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481599132721933414.4412)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Salida'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Seleccione la forma de mostrar la salida del contenido de texto.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481599442113934184.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4412)
,p_display_sequence=>10
,p_display_value=>'Texto (Caracteres Especiales de Escape)'
,p_return_value=>'TEXT'
,p_help_text=>unistr('&PRODUCT_NAME. omite caracteres HTML especiales, como <code>"<", ">", "&"</code>, al emitir el origen de regi\00F3n.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(481600445121939808.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(481599132721933414.4412)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>unistr('&PRODUCT_NAME. incluye un marcador HTML al emitir el origen de regi\00F3n. Esto puede hacer la regi\00F3n vulnerable a scripts de sitios.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(481600813887948606.4412)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>unistr('Mostrar Saltos de L\00EDnea')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(481599132721933414.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'TEXT'
,p_help_text=>unistr('Especifique si los saltos de l\00EDnea en el origen de la regi\00F3n producen saltos de l\00EDnea en la salida de la regi\00F3n.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(105618485369724390.4412)
,p_plugin_id=>wwv_flow_api.id(384582062506273077.4412)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/plsql
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385049040242438541.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'PLSQL'
,p_display_name=>unistr('Contenido Din\00E1mico PL/SQL')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','PLSQL'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_PLSQL'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra la salida HTML del c\00F3digo PL/SQL.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153863368834496.4412)
,p_plugin_id=>wwv_flow_api.id(385049040242438541.4412)
,p_name=>'SOURCE_PLSQL'
);
end;
/
prompt --application/shared_components/plugins/region_type/svg_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385104627384108788.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SVG_CHART'
,p_display_name=>unistr('Gr\00E1fico SVG')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SVG_CHART'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_HTML'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Muestra datos en un gr\00E1fico SVG. Este tipo de regi\00F3n est\00E1 en desuso. Utilice el tipo de regi\00F3n <em>Gr\00E1fico</em> para las nuevas regiones de gr\00E1fico. Oracle recomienda utilizar <em>Actualizar Aplicaci\00F3n</em> para actualizar estas regiones a la regi\00F3n ')
||unistr('Gr\00E1fico equivalente.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153953839834498.4412)
,p_plugin_id=>wwv_flow_api.id(385104627384108788.4412)
,p_name=>'SOURCE_HTML'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/simple_chart
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385106170962146118.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'SIMPLE_CHART'
,p_display_name=>unistr('Gr\00E1fico Simple')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','SIMPLE_CHART'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Muestra datos en un gr\00E1fico HTML. Este tipo de regi\00F3n est\00E1 en desuso. Utilice el tipo de regi\00F3n <em>Gr\00E1fico</em> para las nuevas regiones de gr\00E1fico. Oracle recomienda utilizar <em>Actualizar Aplicaci\00F3n</em> para actualizar estas regiones a la regi\00F3n')
||unistr(' Gr\00E1fico equivalente.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/region_type/jstree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385504073407123938.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JSTREE'
,p_display_name=>unistr('\00C1rbol')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JSTREE'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra datos en una estructura jer\00E1rquica basada en relaciones padre-hijo entre los registros.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388222674242760077.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>450
,p_prompt=>'Activar Enlace de Nodo con'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Seleccione la acci\00F3n necesaria para activar enlaces de nodo en el \00E1rbol. Un \00E1rbol se utiliza principalmente para la selecci\00F3n/visualizaci\00F3n o la navegaci\00F3n. Si se utiliza para la selecci\00F3n y la navegaci\00F3n, se recomienda configurar la opci\00F3n de dob')
||'le clic para que con un solo clic solo se pueda seleccionar el nodo.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388222945238760981.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4412)
,p_display_sequence=>10
,p_display_value=>'Un Solo Clic'
,p_return_value=>'S'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388223328719761701.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(388222674242760077.4412)
,p_display_sequence=>20
,p_display_value=>'Doble Clic'
,p_return_value=>'D'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388223746905766372.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>600
,p_prompt=>unistr('Elemento de P\00E1gina de Nodo Seleccionado')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715830565095726781.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione el elemento de aplicaci\00F3n o p\00E1gina que desea que contenga el valor de nodo seleccionado. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.</p>'),
unistr('<p>Este elemento se utiliza para guardar el estado del \00E1rbol. Para ello, debe contener el valor del \00FAltimo nodo seleccionado. El valor del nodo seleccionado se puede guardar en el elemento seleccionado a trav\00E9s del atributo de enlace de nodo o de un ')
||unistr('proceso de p\00E1gina. Cuando se vuelva a cargar la p\00E1gina, \00E9ste se abrir\00E1 en el valor de nodo seleccionado.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388224056018770786.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>400
,p_prompt=>'Pista'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione si se van a mostrar las pistas y el origen de dicha pista. Si se define una pista, se muestra cuando el usuario final enfoca o pasa el mouse por una etiqueta de nodo de \00E1rbol.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224310716771380.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4412)
,p_display_sequence=>10
,p_display_value=>'Ninguno'
,p_return_value=>'N'
,p_help_text=>unistr('No se mostrar\00E1 ninguna pista.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388224757018772639.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4412)
,p_display_sequence=>20
,p_display_value=>'Plantilla heredada'
,p_return_value=>'STATIC'
,p_is_deprecated=>true
,p_help_text=>unistr('Utilice un valor de pista est\00E1tico con las siguientes sustituciones de columna de origen de datos: #VALUE#, #TITLE#, #LINK# and #TOOLTIP#')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715829871157706251.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Expresi\00F3n HTML')
,p_return_value=>'TEMPLATE'
,p_help_text=>unistr('Proporcione una expresi\00F3n HTML para utilizarla como pista. Se est\00E1n realizando las sustituciones.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(388225194623774797.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(388224056018770786.4412)
,p_display_sequence=>40
,p_display_value=>'Columna de Base de Datos'
,p_return_value=>'DB'
,p_help_text=>'Utilice el valor de la <strong>columna de pista</strong>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388225546559783958.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>410
,p_prompt=>'Valor de pista'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'STATIC,TEMPLATE'
,p_help_text=>unistr('Introduzca el texto que se muestra cuando un usuario final pasa el mouse sobre un elemento del \00E1rbol.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388410177919650647.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>900
,p_prompt=>unistr('ID de \00C1rbol Est\00E1tico')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_deprecated_values=>'$NOT_NULL$'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Identificador \00FAnico opcional para el \00E1rbol.</p>'),
unistr('<p>Es mejor proporcionar un ID est\00E1tico para la regi\00F3n y utilizar la API apex.region("<i>static-id</i>").widget() para acceder al elemento de \00E1rbol.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1397688173262880316.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>520
,p_prompt=>'Clase CSS de tipo de icono'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'a-Icon'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>'fa'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Clase CSS que se utiliza para especificar el tipo de iconos utilizados para todos los nodos. Esta clase se utiliza en las reglas CSS para especificar las propiedades para todos los iconos de un tipo. El tipo de icono y el valor de la columna de ic'
||unistr('ono del origen de regi\00F3n determinan las clases CSS de icono que se utilizan para cada nodo.</p>'),
unistr('<p>Los valores t\00EDpicos son:</p>'),
'<ul>',
unistr('<li><strong><code>a-Icon</code></strong> Permite utilizar un n\00FAmero reducido de iconos de APEX integrados como <code>icon-circle</code> o <code>icon-tree-folder</code>.</li>'),
'<li><strong><code>fa</code></strong> Permite utilizar iconos de fuente APEX o Font Awesome. El tema universal permite la disponibilidad de una de estas bibliotecas de iconos.</li>',
'</ul>',
unistr('<p>Si no se proporciona ning\00FAn valor, no hay tipo de icono. El tipo de icono Clase CSS se puede incluir en la columna de iconos en caso necesario. Por ejemplo, el valor de la columna de icono podr\00EDa ser "fa fa-user".'),
unistr('Para un \00E1rbol sin iconos, defina los atributos Tipo de icono e Icono por defecto en vac\00EDos, y en el origen de consulta SQL la columna de icono debe ser nula.'),
'Los temas personalizados o de terceros pueden tener su propia fuente o biblioteca de iconos CSS y utilizar una clase de prefijo/tipo de icono que se pueda especificar.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388198764505202174.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>510
,p_prompt=>'Clase CSS de icono por defecto'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'icon-tree-folder'
,p_is_translatable=>false
,p_examples=>unistr('<p>Si el tipo de icono para fuente APEX es<code>fa</code>, puede utilizar valores como: <code>fa-user-circle-o</code>, <code>fa-file-o</code> o <code>fa-arrow-circle-right</code>. Consulte la aplicaci\00F3n Tema Universal para obtener una lista de todos ')
||'los iconos </p>'
,p_help_text=>unistr('Icono por defecto que se utiliza cuando la columna del icono Consulta SQL es nula. El valor es un nombre de clase CSS que especifica el icono que se ver\00E1. Los valores posibles dependen del tipo de icono.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715809220298508190.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>310
,p_prompt=>'Columna de etiqueta de nodo'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'Seleccione la columna de origen de datos que contiene el valor para la etiqueta de nodo. El valor no puede contener marcadores.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715811910493561671.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>380
,p_prompt=>unistr('Columna de nivel de jerarqu\00EDa')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('Seleccione la columna de origen de datos que contiene el valor para el nivel de jerarqu\00EDa del nodo. Esto es necesario si el atributo <strong>Jerarqu\00EDa</strong> est\00E1 definido en <strong>No calculado</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715813002119570686.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>500
,p_prompt=>'Columna Clase CSS de icono'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'Seleccione la columna de origen de datos que contiene el valor para la clase CSS del icono que se va a aplicar al nodo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715814135069583776.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>330
,p_prompt=>'Columna ID de nodo'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('Seleccione la columna de origen de datos que contiene el ID para un nodo. Esto es necesario cuando Application Express calcula la jerarqu\00EDa. Normalmente, aqu\00ED se selecciona una columna de clave primaria.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715815231948590626.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>340
,p_prompt=>'Columna Clave principal'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('Seleccione la columna de origen de datos que contiene el valor para la clave primaria de un nodo. Esto es necesario cuando Application Express calcula la jerarqu\00EDa.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715816326045601781.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>370
,p_prompt=>'Columna Estado de nodo'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'NUMBER'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_help_text=>unistr('Seleccione la columna de origen de datos que contiene el valor para el estado del nodo. Esto es necesario si el atributo <strong>Jerarqu\00EDa</strong> est\00E1 definido en <strong>No calculado</strong>. La columna debe contener <strong>0</strong> para los n')
||'odos de hoja y <strong>1</strong> para los nodos con secundarios.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715817436034604662.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>350
,p_prompt=>unistr('Iniciar \00E1rbol con')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NULL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'LEVEL'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Este atributo determina el m\00E9todo de c\00E1lculo de la ra\00EDz del \00E1rbol. Los nodos, para los que la columna <strong>Clave principal</strong> contiene el valor definido aqu\00ED, se considerar\00E1n nodos ra\00EDz. Se admiten varias ra\00EDces.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818524967607963.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4412)
,p_display_sequence=>10
,p_display_value=>'Basado en un Elemento Existente'
,p_return_value=>'ITEM'
,p_help_text=>unistr('Utilice un valor de elemento para iniciar el \00E1rbol.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715818952174610864.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4412)
,p_display_sequence=>20
,p_display_value=>'Basado en consulta SQL'
,p_return_value=>'SQL'
,p_help_text=>unistr('Utilice el valor que ha devuelto una consulta SQL para iniciar el \00E1rbol.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819396180612829.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Basado en un Valor Est\00E1tico')
,p_return_value=>'STATIC'
,p_help_text=>unistr('Utilice un valor est\00E1tico para iniciar el \00E1rbol.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715819794480614454.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(715817436034604662.4412)
,p_display_sequence=>40
,p_display_value=>'El valor es NULL'
,p_return_value=>'NULL'
,p_help_text=>unistr('Utilice SQL NULL para iniciar el \00E1rbol.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715821189465630260.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>351
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ITEM'
,p_help_text=>unistr('Seleccione el elemento que contiene el valor inicial del \00E1rbol.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715822207129637643.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>352
,p_prompt=>'Consulta SQL'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>unistr('Especifique la consulta SQL para determinar el valor inicial del \00E1rbol. La consulta SQL siempre se ejecuta en la <em>base de datos local</em> y debe devolver exactamente una columna.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715823388473642206.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>353
,p_prompt=>unistr('Valor Est\00E1tico')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715817436034604662.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('Valor est\00E1tico de inicio del \00E1rbol.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715830565095726781.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>315
,p_prompt=>'Columna Valor de nodo'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:ROWID'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione la columna de origen de datos que contiene el valor para el nodo "valor". Este valor no se muestra, sino que se agrega a la propiedad de ID de nodo adaptador de \00E1rbol a la que se puede acceder con JavaScript.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715824464978646322.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>460
,p_prompt=>'Enlace'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>'Especifique el enlace que se debe ejecutar al hacer clic en un nodo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715825559244651508.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>420
,p_prompt=>'Columna de Ayuda de Burbuja'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:CLOB'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(388224056018770786.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB'
,p_help_text=>'Seleccione la columna de origen de datos que contiene el valor para la pista de nodo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715810380689519088.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>320
,p_prompt=>unistr('Jerarqu\00EDa')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'SQL'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Indique si Application Express deber\00EDa calcular la jerarqu\00EDa de \00E1rbol a partir de los datos o si los datos ya contienen informaci\00F3n de jerarqu\00EDa.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715810629237528987.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4412)
,p_display_sequence=>10
,p_display_value=>'Calculado con SQL'
,p_return_value=>'SQL'
,p_help_text=>unistr('La jerarqu\00EDa se calcula con la cl\00E1usula SQL START WITH CONNECT BY. Es obligatorio proporcionar una <strong>columna de clave principal</strong>. Utilice esta opci\00F3n solo si la consulta SQL a\00FAn <em>no</em> contiene una cl\00E1usula START WITH CONNECT BY.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(715811097049545246.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(715810380689519088.4412)
,p_display_sequence=>20
,p_display_value=>'No calculado'
,p_return_value=>'LEVEL'
,p_help_text=>unistr('Toda la informaci\00F3n de jerarqu\00EDa ya est\00E1 incluida en los datos. Para esta opci\00F3n es obligatoria la asignaci\00F3n de las columnas de <strong>nivel de nodo</strong> y de <strong>estado de nodo</strong>. El <strong>nivel de nodo</strong> debe contener el n')
||unistr('ivel de jerarqu\00EDa como un valor num\00E9rico; el <strong>estado de nodo</strong> debe tener <strong>0</strong> para un nodo de hoja y <strong>1</strong> para un nodo sin hojas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715827441883672711.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>24
,p_display_sequence=>470
,p_prompt=>'Columna de Enlace'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715824464978646322.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>'Seleccione la columna de origen de datos que contiene el valor para el enlace que se debe ejecutar al hacer clic en un nodo.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(715828729502680591.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>25
,p_display_sequence=>360
,p_prompt=>'Ordenar Hermanos por'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(715810380689519088.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_help_text=>'Seleccione la columna de origen de datos que se va a utilizar para ordenar secundarios en un nodo principal.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(381686476818136654.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function( options ) {',
'    options.multiple = true;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introducir una funci\00F3n JavaScript que selecciona un objeto de opciones para el \00E1rbol, modifica el objeto y lo devuelve. Esto permite la personalizaci\00F3n avanzada del \00E1rbol durante la inicializaci\00F3n del widget treeView. Consulte la documentaci\00F3n de ')
||unistr('la API javaScript del widget treeView para saber cu\00E1les son las opciones disponibles.<p>'),
unistr('<p>Opciones adicionales definidas por la regi\00F3n de \00E1rbol:</p>'),
'<ul>',
unistr('<li><strong>makeNodeAdapter</strong> Se utiliza para definir un nodeAdapter personalizado. Es una funci\00F3n que emplea los mismos argumentos que makeDefaultNodeAdapter y debe devolver una interfaz treeNodeAdapter.</li>'),
unistr('<li><strong>initialSelectedNodeId</strong> Valor de un nodo que seleccionar. Se define en funci\00F3n del atributo Elemento de p\00E1gina de nodo seleccionado.</li>'),
unistr('<li><strong>nodeHasTooltip</strong> Se define en funci\00F3n del atributo Pista. Si el nodo incluye pista, el resultado es true. En caso contrario, el resultado es false.</li>'),
unistr('<li><strong>regionStaticId</strong> El ID de elemento que se utiliza para la regi\00F3n.</li>'),
'</ul>'))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(715829199415682079.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Si el atributo de jerarqu\00EDa est\00E1 definido en Calculado con SQL</dt>'),
'<dd><pre>',
' select ename, empno, mgr from emp',
'</pre>',
'<p>Especifique EMPNO para Columna de ID de nodo, MGR como atributos de columna de clave principal</p>',
'</dd>',
unistr('<dt>Si el atributo de jerarqu\00EDa est\00E1 definido en No calculado</dt>'),
'<dd><pre>',
' select case when connect_by_isleaf = 1 then 0 when level = 1 then 1 else -1 end as status,',
'        level,',
'        ename as title,',
'        ''icon-tree-folder'' as icon,',
'        empno as value,',
'        ename as tooltip,',
'        null  as link',
'   from emp',
'  start with mgr is null',
'connect by prior empno = mgr',
'  order siblings by ename',
'</pre>',
unistr('<p>Especifique STATUS para los atributos de columna de estado de nodo, LEVEL para los de columna de nivel de jerarqu\00EDa.</p>'),
'</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(389020154426295680.4412)
,p_plugin_id=>wwv_flow_api.id(385504073407123938.4412)
,p_name=>'treeviewselectionchange'
,p_display_name=>unistr('Cambio de Selecci\00F3n')
);
end;
/
prompt --application/shared_components/plugins/region_type/calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516061640387971.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CALENDAR'
,p_display_name=>'Calendario'
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_SQL:ESCAPE_OUTPUT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Muestra entradas basadas en fechas en una gran variedad de vistas de calendario.</p>',
unistr('<p>Deber\00EDa utilizar <em>Calendario</em> en lugar de este tipo de regi\00F3n al crear nuevas regiones. Las regiones de calendario cl\00E1sico suelen ser las que se crean en &PRODUCT_NAME. Versi\00F3n 4.2 o anterior.</p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>'$$$ DJP - Shouldn''t this be ''Is Legacy'' = ''Yes''?'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154143004834501.4412)
,p_plugin_id=>wwv_flow_api.id(385516061640387971.4412)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/shared_components/plugins/region_type/tree
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(385516341883422042.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'TREE'
,p_display_name=>unistr('\00C1rbol Cl\00E1sico')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','TREE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Muestra datos en una estructura jer\00E1rquica basada en relaciones padre-hijo entre registros.</p>'),
unistr('<p>Deber\00EDa utilizar <em>\00C1rbol</em> en lugar de este tipo de regi\00F3n al crear nuevas regiones. </p>')))
,p_version_identifier=>'1.0'
,p_plugin_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$$ DJP - Is the name Classic Tree in preparation for John''s tree being implemented as a standard component in 5.0?',
''))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(385518660732877617.4412)
,p_plugin_id=>wwv_flow_api.id(385516341883422042.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('ID de Componente de \00C1rbol')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_expand
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388431570538859249.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_EXPAND'
,p_display_name=>unistr('Ampliar \00C1rbol')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_EXPAND'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Ampl\00EDe el nodo actual en una regi\00F3n de \00E1rbol.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/tree_collapse
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(388635386274723384.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'TREE_COLLAPSE'
,p_display_name=>unistr('Reducir \00C1rbol')
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','TREE_COLLAPSE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Reduzca el nodo actual en una regi\00F3n de \00E1rbol.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/password
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(435122514730662817.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PASSWORD'
,p_display_name=>unistr('Contrase\00F1a')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PASSWORD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un elemento en formato de contrase\00F1a HTML. Cuando el usuario final introduce texto, aparece un punto negro para ese car\00E1cter en lugar del car\00E1cter real introducido.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(435122925859694465.4412)
,p_plugin_id=>wwv_flow_api.id(435122514730662817.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Ejecutar al Pulsar Intro'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si la p\00E1gina se ejecuta autom\00E1ticamente al pulsar la tecla <em>Intro</em> mientras est\00E1 en este campo.')
);
end;
/
prompt --application/shared_components/plugins/item_type/stop_and_start_html_table
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(442021108862425785.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STOP_AND_START_HTML_TABLE'
,p_display_name=>unistr('Parar e Iniciar Dise\00F1o de Cuadr\00EDcula')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STOP_AND_START_HTML_TABLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Elemento heredado que se utiliza para parar la tabla HTML anterior e iniciar una nueva tabla HTML. Antes de que se introdujera el <em>Dise\00F1o de Cuadr\00EDcula</em> en &PRODUCT_NAME. Versi\00F3n xx, este tipo de elemento se utilizaba mucho para personaliza')
||unistr('r la visualizaci\00F3n de elementos de p\00E1gina.</p>'),
unistr('<p>Oracle recomienda suprimir estos tipos de elementos heredados y actualizar <em>Iniciar Nueva Cuadr\00EDcula</em> en <strong>S\00ED</strong> para el siguiente elemento de p\00E1gina mostrado en esa regi\00F3n. Esta funcionalidad es equivalente a utilizar un elemen')
||unistr('to Parar e Iniciar Dise\00F1o de Cuadr\00EDcula.</p>')))
,p_plugin_comment=>'$$$ DJP - What APEX Release was Grid Layout introduced?'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/refresh
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(457584914213394021.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'REFRESH'
,p_display_name=>'Refrescar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','REFRESH'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Dispara un refrescamiento de los elementos afectados. No todos los elementos soportan una acci\00F3n de refrescamiento. Puede utilizar esta acci\00F3n para refrescar el contenido en informes interactivos, informes cl\00E1sicos y todos los tipos de elementos con ')
||'soporte LOV en cascada.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/show
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(517009436728139227.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SHOW'
,p_display_name=>'Mostrar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SHOW'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:REGION:JQUERY_SELECTOR:JAVASCRIPT_EXPRESSION:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Muestra los elementos afectados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(262167718423622079.4412)
,p_plugin_id=>wwv_flow_api.id(517009436728139227.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Mostrar Todo en la Misma L\00EDnea')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_deprecated_values=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si se muestran todos los elementos y etiquetas de p\00E1gina que est\00E1n en la misma l\00EDnea que los elementos afectados.</p>'),
unistr('<p>Nota: este atributo no funcionar\00E1 para elementos de p\00E1ginas que no utilizan una cuadr\00EDcula de tabla para mostrar elementos de pantalla. Esto incluye cualquier p\00E1gina que utilice una plantilla de p\00E1gina m\00F3vil.</p>')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/http_header_variable
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(552639319797428791.4412)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'HTTP_HEADER_VARIABLE'
,p_display_name=>'Variable de Cabecera HTTP'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','HTTP_HEADER_VARIABLE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Se autentica de manera externa, donde el nombre de usuario se almacena en una variable de cabecera HTTP definida por el servidor web.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552647115426436957.4412)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nombre de Variable de Cabecera HTTP'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifica el nombre de la variable de cabecera HTTP que contiene el nombre de usuario. Si no se especifica, se utilizar\00E1 REMOTE_USER.</p>'),
'',
'<p>La variable de la cabecera HTTP es una variable que define el servidor web.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552651403090442945.4412)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Acci\00F3n si el Nombre de Usuario Est\00E1 Vac\00EDo')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifica la acci\00F3n que se debe realizar si el nombre de usuario almacenado en la variable de cabecera HTTP est\00E1 vac\00EDo. Est\00E1n disponibles las siguientes opciones:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>Redirigir a URL Incorporada</strong> para iniciar una conexi\00F3n mediante el servidor web. Esta direcci\00F3n URL incorporada se debe proteger mediante el servidor web, con el fin de forzar una conexi\00F3n cuando se llame. Tras la conexi\00F3n, el s')
||unistr('ervidor web debe almacenar el nombre de usuario validado en la variable de cabecera HTTP, por lo que est\00E1 disponible en el esquema de autenticaci\00F3n. La direcci\00F3n URL incorporada es'),
'<pre>/apex/apex_authentication.callback</pre>',
unistr('El prefijo <code>/apex/</code> depende de la configuraci\00F3n del servidor.'),
'</li>',
unistr('  <li><strong>Redirigir a URL</strong> para iniciar una conexi\00F3n en un servidor externo que, a continuaci\00F3n, define el nombre de usuario validado en la variable de cabecera HTTP. El servidor externo debe volver a redirigirse a la aplicaci\00F3n mediante ')
||unistr('la direcci\00F3n URL que genera el marcador de posici\00F3n <code>#CALLBACK#</code>, con el fin de terminar la autenticaci\00F3n en la aplicaci\00F3n.</li>'),
unistr('  <li><strong>Mostrar Error</strong> mostrar\00E1 el mensaje de error especificado y no se realizar\00E1 ninguna conexi\00F3n en la aplicaci\00F3n.</li>'),
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552655716596446845.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4412)
,p_display_sequence=>10
,p_display_value=>'Redirigir a URL Incorporada'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552667630233460180.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4412)
,p_display_sequence=>20
,p_display_value=>'Redirigir a URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(552687932441470278.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(552651403090442945.4412)
,p_display_sequence=>30
,p_display_value=>'Mostrar Error'
,p_return_value=>'ERROR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552699720929485951.4412)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'<pre>http://sso.example.com/?success=#CALLBACK#</pre>'
,p_help_text=>unistr('Especifica la direcci\00F3n URL de un servidor de conexi\00F3n externo, que define el nombre de usuario validado en la variable de cabecera HTTP. El servidor externo debe volver a redirigir a la aplicaci\00F3n mediante la direcci\00F3n URL que genera el marcador de ')
||unistr('posici\00F3n <code>#CALLBACK#</code> con el fin de terminar la autenticaci\00F3n en la aplicaci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(552704028894488210.4412)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mensaje de Error'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(552651403090442945.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Especifica el mensaje de error que se va a mostrar si la variable de cabecera HTTP no contiene un valor o si la variable de cabecera HTTP no existe.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(879327919421164751.4412)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verificar Nombre de Usuario'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Especifica la frecuencia con la que se verifica el nombre de usuario almacenado en la variable de cabecera HTTP. Est\00E1n disponibles las siguientes opciones:'),
'</p>',
'<p>',
'<ul>',
unistr('  <li><strong>Cada Solicitud</strong> esperar\00E1 que la variable CGI siempre se defina en cuanto el servidor web haya realizado la conexi\00F3n. Si el nombre de usuario no es id\00E9ntico al almacenado en la sesi\00F3n de &PRODUCT_NAME. actual, la sesi\00F3n se invali')
||unistr('dar\00E1 y se iniciar\00E1 una nueva conexi\00F3n. Esta es la opci\00F3n m\00E1s segura porque detecta las desconexiones o los cambios de nombre de usuario.'),
'  </li>',
unistr('  <li><strong>Despu\00E9s de la Conexi\00F3n</strong> s\00F3lo verificar\00E1 y almacenar\00E1 el nombre de usuario en la sesi\00F3n de &PRODUCT_NAME. despu\00E9s de que el servidor web haya realizado la conexi\00F3n; adem\00E1s, llama a la devoluci\00F3n de llamada para terminar la autent')
||unistr('icaci\00F3n en la aplicaci\00F3n. Para ver la devoluci\00F3n de llamada, consulte la configuraci\00F3n "Acci\00F3n si el Nombre de Usuario Est\00E1 Vac\00EDo".'),
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879343501197168872.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4412)
,p_display_sequence=>10
,p_display_value=>'Cada Solicitud'
,p_return_value=>'ALWAYS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(879347807777170859.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(879327919421164751.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Despu\00E9s de la Conexi\00F3n')
,p_return_value=>'CALLBACK'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(39504908766917753.4412)
,p_plugin_id=>wwv_flow_api.id(552639319797428791.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('URL de Desconexi\00F3n del Servidor de SSO')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Para SSO basada en Oracle Access Manager, introduzca por ejemplo:</p>',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si el esquema de autenticaci\00F3n est\00E1 basado en Oracle Access Manager o servidores similares,'),
'puede utilizar este atributo para especificar una URL para desconectarse del servidor de Single Sign-On central.</p>',
'',
unistr('<p>El par\00E1metro de sustituci\00F3n <code>%POST_LOGOUT_URL%</code> se sustituir\00E1 por la URL codificada a la p\00E1gina de conexi\00F3n de la aplicaci\00F3n.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/html_expression
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(562560582820583985.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HTML_EXPRESSION'
,p_display_name=>unistr('Expresi\00F3n HTML')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HTML_EXPRESSION'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un elemento que no se puede introducir basado en una expresi\00F3n HTML.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(562566479673647057.4412)
,p_plugin_id=>wwv_flow_api.id(562560582820583985.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Expresi\00F3n HTML')
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>Cambiar los colores del fondo y del texto</dt>',
'    <dd><pre>&lt;span style="background-color:yellow; color:red;">&amp;EMPLOYEE_STATUS.&lt;/span></pre></dd>',
'  <dt>Usar cabecera 2</dt>',
'    <dd><pre>&lt;h2>&amp;EMPLOYEE_NAME.&lt;/h2></pre></dd>',
unistr('  <dt>Usar una clase din\00E1mica de la consulta SQL</dt>'),
'    <dd><pre>&lt;span class="&amp;COLUMN_CLASS!ATTR.">&amp;EMPLOYEE_STATUS.&lt;/span></pre><br>',
'    Las sustituciones <code>&amp;COLUMN_CLASS!ATTR.</code> y <code>&amp;EMPLOYEE_STATUS.</code> de este ejemplo son columnas seleccionadas en la consulta SQL.</dd>',
'  <dt>Mostrar una imagen y una ayuda de burbuja al pasar el mouse</dt>',
'    <dd><pre>&lt;img src="&amp;IMAGE_NAME!ATTR." title="&amp;EMPLOYEE_NAME!ATTR."&gt;</pre></dd>',
'</dl>'))
,p_help_text=>unistr('Introduzca las expresiones HTML que se mostrar\00E1n en esta columna. Utilice la sintaxis de <code>&amp;COLUMN.</code> para mostrar valores de columna en HTML.')
);
end;
/
prompt --application/shared_components/plugins/item_type/link
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(567106626791482337.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LINK'
,p_display_name=>'Enlace'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LINK'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:ESCAPE_OUTPUT:SOURCE:FILTER:LINK'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>'Muestra un elemento que no se puede introducir como un enlace.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/clear
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823504054693040.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CLEAR'
,p_display_name=>'Borrar'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CLEAR'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:REGION:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Borra los elementos afectados.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/alert
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626823719638697634.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'ALERT'
,p_display_name=>'Alerta'
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','ALERT'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un mensaje de alerta con un solo bot\00F3n <em>Aceptar</em>. Sirve para ver la informaci\00F3n a la que hay que responder pulsando el bot\00F3n, aunque se contin\00FAa ejecutando el evento.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626823916999706267.4412)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Mensaje'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>'<p>El empleado &amp;P1_ENAME. &lt;strong&gt;no se ha podido&lt;&#x2F;strong&gt; eliminar.</p>'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el mensaje que se mostrar\00E1 en el cuadro de di\00E1logo de alerta.</p>'),
unistr('<p>El cliente realizar\00E1 las sustituciones de elementos cuando se muestre el cuadro de di\00E1logo.</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701076455936800.4412)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('T\00EDtulo')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>Proporcione, de forma opcional, un t\00EDtulo para el di\00E1logo.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3701701323970349.4412)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Estilo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Valor por Defecto'
,p_help_text=>unistr('Especifique el estilo del di\00E1logo.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703043398973992.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Informaci\00F3n')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702623945972615.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4412)
,p_display_sequence=>20
,p_display_value=>'Peligro'
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3702291441971350.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4412)
,p_display_sequence=>30
,p_display_value=>'Advertencia'
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(3703410946975189.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(3701701323970349.4412)
,p_display_sequence=>40
,p_display_value=>'Correcto'
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705287585006856.4412)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Icono'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Especifique un icono de di\00E1logo opcional.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3704914260003167.4412)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Clases CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca las clases CSS opcionales que desea aplicar al contenedor de di\00E1logo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(3705505358011056.4412)
,p_plugin_id=>wwv_flow_api.id(626823719638697634.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Etiqueta de Aceptar'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Introduzca la etiqueta del bot\00F3n Aceptar. Si no se proporciona ninguna, se utilizar\00E1 el valor del mensaje de texto <code>APEX.DIALOG.OK</code>.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/confirm
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(626824429466709866.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CONFIRM'
,p_display_name=>'Confirmar'
,p_category=>'NOTIFICATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CONFIRM'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un cuadro de di\00E1logo de confirmaci\00F3n, con los botones Cancelar y Confirmar. Si el usuario elige <em>Cancelar</em>, las acciones no se ejecutan y el evento actual se cancela.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(626824618169716040.4412)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Mensaje'
,p_attribute_type=>'HTML'
,p_is_required=>true
,p_is_translatable=>true
,p_examples=>unistr('<p>&lt;strong&gt;\00BFSeguro&lt;&#x2F;strong&gt; que desea eliminar al empleado &amp;P1_ENAME.?</p>')
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el mensaje que se mostrar\00E1 en el cuadro de di\00E1logo de confirmaci\00F3n.</p>'),
unistr('<p>El cliente sustituir\00E1 elementos cuando se muestre el cuadro de di\00E1logo.</p>')))
,p_attribute_comment=>'The above example is escaped properly!'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2101389282482255.4412)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('T\00EDtulo')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('<p>Proporcione, de forma opcional, un t\00EDtulo para el di\00E1logo.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2103085785653286.4412)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Estilo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Valor por Defecto'
,p_help_text=>unistr('Especifique el estilo del di\00E1logo.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104149014656515.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Informaci\00F3n')
,p_return_value=>'information'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103302674655458.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4412)
,p_display_sequence=>20
,p_display_value=>'Advertencia'
,p_return_value=>'warning'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2103765346655897.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4412)
,p_display_sequence=>30
,p_display_value=>'Peligro'
,p_return_value=>'danger'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2104502204657360.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2103085785653286.4412)
,p_display_sequence=>40
,p_display_value=>'Correcto'
,p_return_value=>'success'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106373192721945.4412)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Icono'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Especifique un icono de di\00E1logo opcional.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106035369711819.4412)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Clases CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca las clases CSS opcionales que desea aplicar al contenedor de di\00E1logo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106917926775379.4412)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Etiqueta de confirmaci\00F3n')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Introduzca la etiqueta del bot\00F3n de confirmaci\00F3n. Si no se proporciona ninguna, se utilizar\00E1 el valor del mensaje de texto <code>APEX.DIALOG.OK</code>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2106670847763561.4412)
,p_plugin_id=>wwv_flow_api.id(626824429466709866.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Etiqueta de cancelaci\00F3n')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Introduzca la etiqueta del bot\00F3n Cancelar. Si no se proporciona ninguna, se utilizar\00E1 el valor del mensaje de texto <code>APEX.DIALOG.CANCEL</code>.')
);
end;
/
prompt --application/shared_components/plugins/process_type/parse_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(668666822163400066.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PARSE_UPLOADED_DATA'
,p_display_name=>'Analizar Datos Cargados'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PARSE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Proceso para analizar los datos de la hoja de c\00E1lculo preparada con el fin de cargarlos en una tabla existente. Este tipo de proceso lo genera el Asistente de Creaci\00F3n de P\00E1ginas para la <em>Carga de Datos</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668751414675407356.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Definici\00F3n de Carga de Datos')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione la definici\00F3n de carga de datos en Componentes Compartidos, que define la tabla que se va a cargar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668863505241423607.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Importar de Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina que contiene la opci\00F3n <em>Importar desde</em> elegida por el usuario final. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714598810997211212.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento de Separador'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina que contiene el texto del <em>Separador</em> introducido por el usuario final. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(714603217923213191.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Elemento de Delimitaci\00F3n')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina que contiene el texto de <em>Delimitado Opcionalmente Por</em> introducido por el usuario final. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668904302255432174.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Primer Elemento de Fila'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina que contiene el valor de la casilla de control <em>La Primera Fila Tiene Nombres de Columnas</em> introducido por el usuario final. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668954022687438059.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Elemento de S\00EDmbolo de Moneda')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina que contiene el texto del <em>S\00EDmbolo de Divisa</em> introducido por el usuario final. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668962228228439718.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Elemento de Separador de Grupos'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina que contiene el texto del <em>Separador de Grupo</em> introducido por el usuario final. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668977904810442452.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Elemento de Car\00E1cter Decimal')
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina que contiene el texto del <em>Car\00E1cter Decimal</em> introducido por el usuario final. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(668982211736444415.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Elemento de Nombre de Archivo'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina que contiene el valor de <em>Nombre de Archivo</em> introducido por el usuario final. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669001326628448680.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Elemento de Copiar y Pegar'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina que contiene el texto de <em>Copiar y Pegar Fecha Delimitada</em> introducido por el usuario final. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(24234014577732260.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Elemento de Juego de Caracteres'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>true
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina que contiene el <em>juego de caracteres de archivo</em> seleccionado por el usuario final. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(48837321936282082.4412)
,p_plugin_id=>wwv_flow_api.id(668666822163400066.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'Elemento de Formato de Fecha'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de p\00E1gina para contener el texto del <em>formato de fecha</em> introducido por el usuario final. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
end;
/
prompt --application/shared_components/plugins/region_type/data_upload_column_mapping
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669051019271465508.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'DATA_UPLOAD_COLUMN_MAPPING'
,p_display_name=>unistr('Carga de Datos: Asignaci\00F3n de Columna')
,p_supported_ui_types=>'DESKTOP'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','DATA_UPLOAD_COLUMN_MAPPING'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Asigna columnas de la hoja de c\00E1lculo cargada a columnas de tabla. Este tipo de regi\00F3n lo genera al Asistente de Creaci\00F3n de P\00E1ginas para la <em>Carga de Datos</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669071925851467433.4412)
,p_plugin_id=>wwv_flow_api.id(669051019271465508.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Definici\00F3n de Carga de Datos')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione la definici\00F3n de carga de datos especificada en el proceso <em>Carga de Datos</em>.')
);
end;
/
prompt --application/shared_components/plugins/process_type/prepare_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669101621133475493.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'PREPARE_UPLOADED_DATA'
,p_display_name=>'Preparar Datos Cargados'
,p_supported_ui_types=>'DESKTOP:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','PREPARE_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Proceso para preparar los datos de la hoja de c\00E1lculo con el fin de cargarlos en una tabla existente. Este tipo de proceso lo genera el Asistente de Creaci\00F3n de P\00E1ginas para la <em>Carga de Datos</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(670229105709707629.4412)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Definici\00F3n de Carga de Datos')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione la definici\00F3n de carga de datos en Componentes Compartidos, que define la tabla que se va a cargar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468155644060156.4412)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Elemento de Recuento de Inserciones'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el n\00FAmero de registros que se van a insertar. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380468974968063264.4412)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento de Recuento de Actualizaciones'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el n\00FAmero de registros que se van a actualizar. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380469514614067903.4412)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Elemento de Recuento de Errores'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el n\00FAmero de registros con errores. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(380470030664073278.4412)
,p_plugin_id=>wwv_flow_api.id(669101621133475493.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Revisar Elemento de Recuento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que va a contener el n\00FAmero de registros revisados. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
end;
/
prompt --application/shared_components/plugins/process_type/load_uploaded_data
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(669285217502512352.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'LOAD_UPLOADED_DATA'
,p_display_name=>'Cargar Datos Cargados'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','LOAD_UPLOADED_DATA'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>unistr('Proceso para cargar los datos de la hoja de c\00E1lculo analizados en una tabla o vista existente. Este tipo de proceso lo genera el Asistente de Creaci\00F3n de P\00E1ginas para la <em>Carga de Datos</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669308626852514974.4412)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Definici\00F3n de Carga de Datos')
,p_attribute_type=>'DATA LOAD TABLE ID'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione la definici\00F3n de carga de datos en Componentes Compartidos, que especifica la tabla que se va a cargar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669317208629519157.4412)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Elemento de Recuento de Inserciones'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el n\00FAmero de registros insertados.'),
'Puede escribir el nombre o elegirlo en la lista de elementos disponibles.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669321513477520652.4412)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento de Recuento de Actualizaciones'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el n\00FAmero de registros actualizados.'),
'Puede escribir el nombre o elegirlo en la lista de elementos disponibles.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(669325819364522297.4412)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Elemento de Recuento de Errores'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el n\00FAmero de registros con errores.'),
'Puede escribir el nombre o elegirlo en la lista de elementos disponibles.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(208350031209048901.4412)
,p_plugin_id=>wwv_flow_api.id(669285217502512352.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Revisar Elemento de Recuento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que va a contener el n\00FAmero de registros revisados.'),
'Puede escribir el nombre o elegirlo en la lista de elementos disponibles.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/apex_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707619648734994478.4412)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'APEX_ACCOUNTS'
,p_display_name=>'Cuentas de Application Express'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','APEX_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('<p>Introduzca el nombre de usuario y la contrase\00F1a de la cuenta de &PRODUCT_NAME.. Cada espacio de trabajo tiene su propio repositorio de cuentas de usuario. La aplicaci\00F3n a la que est\00E1 conectando pertenece al espacio de trabajo &amp;F4155_WORKSPACE_')
||unistr('NAME.. Recuerde que las contrase\00F1as son sensibles a may\00FAsculas/min\00FAsculas.</p>')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/open_door
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707675753928996044.4412)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'OPEN_DOOR'
,p_display_name=>'Credenciales de Puertas Abiertas'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','OPEN_DOOR'),'')
,p_api_version=>1
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Permite que cualquiera pueda acceder a su aplicaci\00F3n. Introduzca cualquier identificador que lo identifique como el usuario de la aplicaci\00F3n durante esta sesi\00F3n. Esto definir\00E1 el valor de la variable APP_USER.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/db_accounts
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707686311942002797.4412)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DB_ACCOUNTS'
,p_display_name=>'Cuentas de Base de Datos'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DB_ACCOUNTS'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Este esquema de autenticaci\00F3n requiere que exista un usuario de base de datos (esquema) en la base de datos local. Al utilizar este m\00E9todo, la contrase\00F1a y el nombre de usuario de la cuenta de base de datos se utilizan para autenticar al usuario.')
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ldap
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707764939992010930.4412)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'LDAP'
,p_display_name=>'Directorio LDAP'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','LDAP'),'')
,p_api_version=>1
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Autenticaci\00F3n del usuario/contrase\00F1a con una solicitud de autenticaci\00F3n a un servidor LDAP.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708018036276066565.4412)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Nombre del host del servidor de directorios LDAP.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708026427403073465.4412)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Puerto'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>unistr('N\00FAmero de puerto del host de directorio LDAP. El valor por defecto es 389.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708041750260080084.4412)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Usar SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Elija si desea utilizar SSL para enlazar al directorio LDAP. Si se elige SSL con la autenticaci\00F3n, deber\00E1 configurar una cartera para la instancia de &PRODUCT_NAME..')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708049024764082165.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4412)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708053230651083932.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4412)
,p_display_sequence=>20
,p_display_value=>unistr('SSL con Autenticaci\00F3n')
,p_return_value=>'SSL_AUTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(708057433075084636.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(708041750260080084.4412)
,p_display_sequence=>30
,p_display_value=>'Sin SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708170045804107167.4412)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Cadena de Nombre Distintivo (DN)'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el patr\00F3n utilizado para crear el nombre distintivo (DN) totalmente cualificado en DBMS_LDAP.SIMPLE_BIND_S si se va a utilizar el DN exacto; o la base de b\00FAsqueda si no se va a utilizar un DN exacto. Utilice <strong>%LDAP_USER%</strong> co')
||'mo la variable del nombre de usuario. Por ejemplo:',
'<p>',
'<strong>DN Exacto</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=dominio,dc=com',
'</p>',
'<p>',
unistr('<strong>DN no Exacto (Base de B\00FAsqueda)</strong>'),
'</p>',
'<p>',
'dc=dominio,dc=com',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708104537708095412.4412)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Usar Nombre Distinguido Exacto (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Elija si el nombre distintivo (DN) de LDAP ser\00E1 exacto o no. Si no lo es, se convertir\00E1 en la base de b\00FAsqueda y deber\00E1 proporcionar un filtro de b\00FAsqueda.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708207443165115942.4412)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Filtro de B\00FAsqueda')
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(708104537708095412.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el filtro de b\00FAsqueda cuando no utilice un nombre distintivo (DN) exacto. Utilice <strong>%LDAP_USER%</strong> como marcador de posici\00F3n del nombre de usuario. Por ejemplo:'),
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(708300825765129776.4412)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Funci\00F3n de Edici\00F3n de Nombre de Usuario de LDAP')
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
unistr('Puede proporcionar m\00E1s c\00F3digo para su ejecuci\00F3n y transformar el nombre de usuario en un formato perfectamente adaptado a la entrada de directorio LDAP o al nombre de usuario LDAP.'),
'La variable de enlace :USERNAME contiene el nombre especificado por el usuario final.',
unistr('Por ejemplo, el siguiente c\00F3digo llama a una funci\00F3n que sustituye todos los "."'' por "_"'' en la cadena DN:</p>'),
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
unistr('<p>&PRODUCT_NAME. identificar\00E1 el nombre de usuario devuelto en el atributo de autenticaci\00F3n <strong>Escape de Nombre de Usuario</strong>.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38288205752186126.4412)
,p_plugin_id=>wwv_flow_api.id(707764939992010930.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Identificaci\00F3n de Nombre de Usuario')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Antes de sustituir <strong>%LDAP_USER%</strong> en el nombre distintivo de LDAP y en la cadena de b\00FAsqueda,'),
unistr('&PRODUCT_NAME. puede omitir autom\00E1ticamente caracteres especiales del nombre de usuario.'),
'<p/>',
unistr('Las posibles reglas para la identificaci\00F3n son:'),
'<ul>',
unistr('<li><strong>Est\00E1ndar</strong>:'),
unistr('Identifica caracteres especiales seg\00FAn la RFC 4514 (para nombres distintivos) y la RFC 4515 (para las cadenas de b\00FAsqueda).'),
unistr('Adem\00E1s, identifica los caracteres unicode.'),
unistr('\00C9ste es el valor m\00E1s seguro, pero puede provocar problemas con algunos servidores LDAP.</li>'),
unistr('<li><strong>S\00F3lo caracteres especiales</strong>:'),
unistr('Identifica caracteres especiales seg\00FAn la RFC 4514 (para nombres distintivos) y la RFC 4515 (para cadenas de b\00FAsqueda).'),
'No omite caracteres unicode.</li>',
unistr('<li><strong>Sin Identificaci\00F3n</strong>:'),
unistr('No identifica ning\00FAn car\00E1cter.'),
'Este valor es potencialmente inseguro,',
unistr('a menos que se utilice una <strong>Funci\00F3n de Edici\00F3n de Nombre de Usuario</strong> que ya'),
'identifique el nombre de usuario (por ejemplo, con apex_escape.ldap_dn o apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288513717188434.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Est\00E1ndar')
,p_return_value=>'STD'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38288919604190164.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4412)
,p_display_sequence=>20
,p_display_value=>unistr('S\00F3lo caracteres especiales')
,p_return_value=>'ONLY'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(38289324453191614.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(38288205752186126.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Sin Identificaci\00F3n')
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/ias_sso
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707826526617016488.4412)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'IAS_SSO'
,p_display_name=>'Oracle Application Server Single Sign-On'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','IAS_SSO'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Delega la autenticaci\00F3n en el servidor de Oracle AS Single Sign-On (SSO). Para utilizar este esquema de autenticaci\00F3n, el sitio se debe haber registrado como aplicaci\00F3n de socio en el servidor de SSO.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(707874032982027788.4412)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nombre de la Aplicaci\00F3n Asociada')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si se autentica con Oracle Application Server Single Sign-On y su aplicaci\00F3n es una aplicaci\00F3n asociada que est\00E1 registrada con SSO, introduzca exactamente el mismo nombre que utiliz\00F3 al registrar la aplicaci\00F3n asociada con SSO.'),
'</p>',
'<p>',
unistr('Deje este campo en blanco si depende de que &PRODUCT_NAME. sea la aplicaci\00F3n asociada que est\00E1 registrada.'),
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477693327944088403.4412)
,p_plugin_id=>wwv_flow_api.id(707826526617016488.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('URL de Desconexi\00F3n del Servidor de SSO')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>60
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca la ruta de acceso de desconexi\00F3n del servidor Single Sign-On, por ejemplo'),
'<em>https://login.example.com/sso/logout</em>.',
unistr('En la desconexi\00F3n de la aplicaci\00F3n, &PRODUCT_NAME. utilizar\00E1 este valor, concatenate ''?p_done_url='' y la URL de conexi\00F3n de la aplicaci\00F3n, y la URL resultante para desconectarse de Single Sign-On antes de volver a redirigirse a la aplicaci\00F3n.')))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/dad
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(707880052029033247.4412)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'DAD'
,p_display_name=>unistr('Sin Autenticaci\00F3n')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','DAD'),'')
,p_api_version=>1
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Adopta el usuario actual de la base de datos. Se puede utilizar en combinaci\00F3n con una configuraci\00F3n DAD de mod_plsql que utilice la autenticaci\00F3n b\00E1sica para definir el usuario de la sesi\00F3n de la base de datos.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(38519294499392621.4412)
,p_plugin_id=>wwv_flow_api.id(707880052029033247.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Nombre de Usuario'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'nobody'
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el nombre de usuario para la sesi\00F3n de &PRODUCT_NAME. Si est\00E1 vac\00EDo, &PRODUCT_NAME. utiliza la sesi\00F3n de la base de datos (normalmente APEX_PUBLIC_USER).')
);
end;
/
prompt --application/shared_components/plugins/region_type/css_calendar
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(716993259356536483.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'CSS_CALENDAR'
,p_display_name=>'Calendario'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','CSS_CALENDAR'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT:INIT_JAVASCRIPT_CODE:LAZY_LOADING'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra las entradas basadas en fecha en una gran variedad de vistas de calendario. Si se incluye una fecha final, en el calendario se pueden ver eventos basados en una duraci\00F3n. Los calendarios tambi\00E9n pueden actualizar registros directamente si se ')
||'activa "Arrastrar y soltar".'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1992827406647874094.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Clave de API de Google Calendar [en desuso]'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca la clave de API de Google Calendar para permitir que los calendarios de esta aplicaci\00F3n se integren con los datos de Google Calendar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993576597543647.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>5
,p_prompt=>'Columna de Fecha de Inicio'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>'Seleccione la columna que contiene la fecha de inicio de los eventos que se muestran en este calendario.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716993872715545529.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>unistr('Columna de Fecha de Finalizaci\00F3n')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_column_data_types=>'DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione la columna que contiene la fecha de finalizaci\00F3n de los eventos que se muestran en este calendario. Si se especifica este atributo, en el calendario se muestran eventos basados en duraci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994160638551031.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>2
,p_prompt=>unistr('Columna de Visualizaci\00F3n')
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:TIMESTAMP:TIMESTAMP_TZ:TIMESTAMP_LTZ:INTERVAL_Y2M:INTERVAL_D2S'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>'Seleccione la columna que contiene el texto que se muestra para los eventos en este calendario.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994453521554330.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>12
,p_prompt=>'Columna de Clave Primaria'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2:NUMBER:ROWID'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione la columna que contiene el valor de clave primaria de los eventos del calendario. Si la tabla tiene una clave primaria de varias partes, seleccione <strong>ROWID</strong>.</p>',
unistr('<p>El valor de esta columna se devuelve en la variable de sustituci\00F3n <code>APEX$PK_VALUE</code>. Utilice esta variable en el atributo <em>C\00F3digo de Arrastrar y Soltar</em> para identificar el registro que se va a actualizar despu\00E9s de la operaci\00F3n d')
||'e arrastrar y soltar en el calendario.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716994772918560561.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>65
,p_prompt=>'Ver/Editar Enlace'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Introduzca una p\00E1gina de destino a la que se llamar\00E1 cuando el usuario haga clic en una entrada existente.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995064292564584.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Crear Enlace'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una p\00E1gina de destino a la que se llamar\00E1 cuando el usuario haga clic en una celda vac\00EDa o fuera de una entrada de calendario existente.</p>'),
unistr('<p>Debe utilizar las variables de sustituci\00F3n de calendario especiales <pre>&APEX$NEW_START_DATE.</pre> y <pre>&APEX$NEW_END_DATE.</pre> para pasar las fechas seleccionadas del calendario a la p\00E1gina de destino.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995378729573099.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>45
,p_prompt=>'Arrastrar y Soltar'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716994453521554330.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si las operaciones de arrastrar y soltar est\00E1n permitidas en este calendario.</p>'),
unistr('<p><em>Nota: si est\00E1 activada la operaci\00F3n de arrastrar y soltar, los usuarios finales que tengan derechos para ver este calendario tambi\00E9n tienen derechos para actualizar las entradas del calendario.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995668377577896.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>55
,p_prompt=>unistr('C\00F3digo PL/SQL de Arrastrar y Soltar')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(716995378729573099.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Ejemplo solo con fecha de inicio (para eventos no basados en duraci\00F3n)</dt>'),
'<dd><pre>',
'begin',
'    update emp',
'       set hiredate = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS'')',
'     where empno = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
unistr('<dt>Ejemplo con fechas de inicio y finalizaci\00F3n (para eventos basados en duraci\00F3n)</dt>'),
'<dd><pre>',
'begin',
'    update projects',
'       set start_date = to_date(:APEX$NEW_START_DATE, ''YYYYMMDDHH24MISS''),',
'           end_date = to_date(:APEX$NEW_END_DATE, ''YYYYMMDDHH24MISS'')',
'     where id = :APEX$PK_VALUE;',
'end;',
'</pre></dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo PL/SQL para actualizar las tablas subyacentes o las vistas actualizables cuando se actualiza una entrada del calendario mediante arrastrar y soltar.</p>'),
unistr('<p>Si en este calendario se muestran eventos basados en la duraci\00F3n (al seleccionar una columna para la fecha de finalizaci\00F3n), el c\00F3digo PL/SQL tambi\00E9n tiene que actualizar este valor. Si se arrastra todo el evento, la fecha de finalizaci\00F3n mantiene')
||unistr(' la duraci\00F3n actual. Si se arrastra el final del evento, se actualiza la duraci\00F3n del evento. En tales casos, no se cambia la fecha de inicio, pero se actualiza la fecha de finalizaci\00F3n para reflejar la nueva duraci\00F3n.</p>'),
unistr('<p>Entre las variables de sustituci\00F3n del calendario, se incluyen:</p>'),
'<dl>',
'  <dt>APEX$NEW_START_DATE</dt>',
'    <dd>Devuelve la fecha de inicio revisada. El formato de fecha es <code>''YYYYMMDDHH24MISS''</code> aunque el valor <em>Mostrar Hora</em> de este calendario sea <strong>No</strong>.</dd>',
'  <dt>APEX$NEW_END_DATE</dt>',
unistr('    <dd>Devuelve la fecha de finalizaci\00F3n revisada de los eventos basados en duraci\00F3n. El formato de fecha es <code>''YYYYMMDDHH24MISS''</code> aunque el valor <em>Mostrar Hora</em> de este calendario sea <strong>No</strong>.</dd>'),
'  <dt>APEX$PK_VALUE</dt>',
'    <dd>Devuelve el valor de la columna especificada en la columna de clave primaria.</dd>',
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716995977422588893.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>40
,p_prompt=>'Vistas de Calendario Adicionales'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione las vistas de calendario adicionales que desee mostrar. La vista del mes siempre se muestra.</p>',
unistr('<p>Nota: Las vistas Semanal y Diario no est\00E1n disponibles si se ha especificado Mostrar Hora como <strong>No</strong>.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484632936569874213.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4412)
,p_display_sequence=>40
,p_display_value=>'Lista'
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(484633358657877168.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(716995977422588893.4412)
,p_display_sequence=>50
,p_display_value=>unistr('Navegaci\00F3n')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716997678919603353.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Exportar'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Elija qu\00E9 enlaces de exportaci\00F3n se proporcionan en la parte inferior del calendario.</p>'),
'<p><em>Nota: exporta todas las entradas del calendario que se muestran actualmente, no solo una.</em></p>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716999168568608195.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4412)
,p_display_sequence=>10
,p_display_value=>'CSV'
,p_return_value=>'CSV'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716997976116604645.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4412)
,p_display_sequence=>30
,p_display_value=>'iCal'
,p_return_value=>'ICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(716998373959605713.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(716997678919603353.4412)
,p_display_sequence=>40
,p_display_value=>'XML'
,p_return_value=>'XML'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(716999779985618067.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>40
,p_prompt=>unistr('Navegaci\00F3n y Vistas de Calendario')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'month:week:day:list:navigation'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('<p>Seleccione las vistas de calendario que desee mostrar. Debe seleccionar al menos una de las siguientes opciones <strong>D\00EDa</strong>, <strong>Semana</strong> o <strong>Mes</strong>. En caso contrario, el calendario mostrar\00E1 autom\00E1ticamente la vist')
||'a <strong>Mes</strong>.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(772524462334484489.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4412)
,p_display_sequence=>10
,p_display_value=>'Mes'
,p_return_value=>'month'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000472653621483.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4412)
,p_display_sequence=>20
,p_display_value=>'Semana'
,p_return_value=>'week'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717000871143622145.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4412)
,p_display_sequence=>30
,p_display_value=>unistr('D\00EDa')
,p_return_value=>'day'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(696140132483024062.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4412)
,p_display_sequence=>35
,p_display_value=>'Lista'
,p_return_value=>'list'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(717001267693623757.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(716999779985618067.4412)
,p_display_sequence=>40
,p_display_value=>unistr('Navegaci\00F3n')
,p_return_value=>'navigation'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(718537383340695404.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_prompt=>'ID de Google Calendar'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>255
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_examples=>'<p>ID de Google Calendar: abc123@group.calendar.google.com</p>'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca el ID de Google Calendar de la fuente de datos de calendario que desee mostrar en este calendario.</p>',
unistr('<p>Debido a las restricciones de seguridad de los calendarios de Google, estos calendarios deben ser p\00FAblicos o estar disponibles para todos los usuarios finales de este calendario.</p>'),
unistr('<p><em>Nota: Debe introducir la clave de API de Google Calendar para que los calendarios de Google funcionen correctamente. Vaya a Componentes Compartidos > Configuraci\00F3n de Componente > Calendario para definir la clave de la aplicaci\00F3n.</em</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(739025333221911743.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>15
,p_prompt=>'Mostrar Hora'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione si se debe mostrar la cantidad de tiempo de la fecha. </p>',
unistr('<p>Las vistas Semana y D\00EDa solo se mostrar\00E1n si Mostrar Hora se define en <strong>S\00ED</strong>. Si las columnas de fecha de inicio y fecha de finalizaci\00F3n no incluyen los componentes de hora, se mostrar\00E1n con la hora 12:00 a.m.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(163693512506908039.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>80
,p_prompt=>'Clase de CSS'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_column_data_types=>'VARCHAR2'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Estilo del calendario basado en el estado del proyecto</p>',
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Seleccione la columna que contiene la clase CSS para aplicar estilo a los eventos mostrados en este calendario. <br>',
'Existen varias clases por defecto disponibles:',
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('Consulte la documentaci\00F3n sobre c\00F3mo agregar clases CSS adicionales.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604378152305541.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>'Servicio Web REST (JSON)'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(5924531429537178.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'3'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la URL de una fuente de servicios web RESTful para que se muestre en este calendario. En el calendario se pueden presentar datos JSON recuperados de or\00EDgenes externos como, por ejemplo, servicios de datos de Oracle REST. Estos servicios')
||unistr(' web deben ser p\00FAblicos o estar disponibles para todos los usuarios finales de este calendario.</p>'),
'<p>La fuente JSON se debe formatear para incluir:</p>',
'<ol>',
'<li>La lista de eventos que contiene la matriz - <code>items</code></li>',
'<li>Lo que contiene cada objeto de evento - <code>{ id, title, start, allday, end, description }</code><br>Los atributos title y start son obligatorios.</li>',
'</ol>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2604471144293543.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>30
,p_prompt=>unistr('Informaci\00F3n Suplementaria')
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_examples=>'&EMPNO.'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca un HTML adicional que se muestre en la vista de lista y la pista. Utilice la sintaxis &COLUMN. para mostrar los valores de columna en HTML. </p>',
unistr('<p>Nota: Mostrar Pista se debe definir en <strong>S\00ED</strong> para que esta informaci\00F3n complementaria se muestre en las vistas Mes, Semana y D\00EDa.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(491266533374023782.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>75
,p_prompt=>'Mostrar Fin de Semana'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione si en este calendario se muestra el s\00E1bado y el domingo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(518889601605918244.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>20
,p_prompt=>'Formato de Hora'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'00'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Seleccione el formato de hora que sirve para mostrar la hora de un evento en este calendario.</p>'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518893959287938933.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4412)
,p_display_sequence=>10
,p_display_value=>'Valor por Defecto'
,p_return_value=>'00'
,p_help_text=>unistr('Utiliza el formato de registro de hora de aplicaci\00F3n, introducido en Globalizaci\00F3n. Si no se rellena este atributo, utilizar\00E1 el valor de NLS de base de datos.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914467554939737.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4412)
,p_display_sequence=>20
,p_display_value=>'12 Horas'
,p_return_value=>'12'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Muestra la hora con el formato de 12 horas, que incluye a.m. (del lat\00EDn <em>ante meridiem</em>, que significa "antes del mediod\00EDa") y p.m. (<em>post meridiem</em>, "despu\00E9s del mediod\00EDa"), como en 8:00 a.m. y 4:00 p.m.</p>'),
unistr('<p>El formato de visualizaci\00F3n real para a.m./p.m., como las may\00FAsculas y los puntos, se deriva del formato de registro de hora.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(518914796377940460.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(518889601605918244.4412)
,p_display_sequence=>30
,p_display_value=>'24 Horas'
,p_return_value=>'24'
,p_help_text=>'Muestra la hora con el formato de 24 horas, como en 08:00 y 16:00.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(623002076135066927.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>35
,p_prompt=>'Mostrar Ayuda de Burbuja'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione si mostrar una ayuda de burbuja cuando los usuarios pasen el cursor sobre un evento en este calendario.</p>',
unistr('<p><em>El cuadro de di\00E1logo desplegable mostrar\00E1 el nombre del evento, la informaci\00F3n complementaria y los detalles de fecha.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(673441164964154995.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>25
,p_prompt=>'Primera Hora'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_show_in_wizard=>false
,p_default_value=>'9'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(739025333221911743.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Introduzca un entero entre 0 y 23 para especificar la primera hora mostrada en los calendarios Semana y D\00EDa.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1218336983535257968.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>21
,p_display_sequence=>70
,p_prompt=>unistr('N\00FAmero M\00E1ximo de Eventos/D\00EDa')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'10'
,p_display_length=>2
,p_max_length=>2
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca l n\00FAmero m\00E1ximo de eventos mostrados para cada d\00EDa en la vista Mes. </p>'),
unistr('<p>Si hay m\00E1s del n\00FAmero de eventos especificados en un d\00EDa espec\00EDfico, dicho d\00EDa incluir\00E1 <strong>M\00E1s informaci\00F3n...</strong>. Al hacer clic en este elemento, se mostrar\00E1 una ventana emergente con todos los eventos para dicho d\00EDa espec\00EDfico.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2080058124058207989.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>22
,p_display_sequence=>32
,p_prompt=>unistr('Eventos de Varias L\00EDneas')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_supported_ui_types=>'DESKTOP'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione <strong>S\00ED</strong> para que los eventos aparezcan en varias l\00EDneas seg\00FAn la longitud del texto de Columna de Visualizaci\00F3n. </p>'),
unistr('<p>Seleccione <strong>No</strong> si s\00F3lo desea que cada evento aparezca en una sola l\00EDnea y que se trunque el texto que no se ajuste en la visualizaci\00F3n. El texto completo aparecer\00E1 en la pista.</p>'),
unistr('<p>Nota: el valor de eventos en varias l\00EDneas s\00F3lo se utilizar\00E1 en la vista Mes. Para las vistas Semanal y Diario, la duraci\00F3n del evento determina la altura del evento mostrado.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(5924531429537178.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>23
,p_display_sequence=>1
,p_prompt=>unistr('Versi\00F3n')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'FullCalendar 5'
,p_deprecated_values=>'3'
,p_help_text=>unistr('<p>FullCalendar 3 est\00E1 en desuso y pronto ser\00E1 sustituido por FullCalendar 5. Es una buena idea hacer este cambio ahora, para no arriesgarse a que la aplicaci\00F3n falle en futuras versiones. Si ha usado alg\00FAn c\00F3digo Javascript de inicializaci\00F3n persona')
||unistr('lizado, tenga en cuenta que la API de FullCalendar ha cambiado y lo m\00E1s probable es que se deba modificar el c\00F3digo.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(5925071337539542.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(5924531429537178.4412)
,p_display_sequence=>10
,p_display_value=>'FullCalendar 3 [en desuso]'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(848019138346305412.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function ( pOptions) {',
unistr('    pOptions.titleFormat      = "[Conference Schedule]";                                // t\00EDtulo personalizado'),
'    pOptions.slotMinTime      = "07:00:00";                                             // ocultar espacios antes de minTime',
unistr('    pOptions.slotMaxTime      = "18:00:00";                                             // ocultar espacios despu\00E9s de maxTime'),
'    pOptions.dayHeaderFormat  = { weekday: ''short'', month: ''numeric'', day: ''numeric'' }; // cabeceras de columna de la vista de la semana',
unistr('    pOptions.slotDuration     = "00:15:00";                                             // duraci\00F3n del espacio personalizado'),
unistr('    pOptions.weekNumbers      = true;                                                   // mostrar n\00FAmeros de semana'),
'    pOptions.weekText         = "CW";                                    ',
'    return pOptions;',
'}',
'</pre>'))
,p_help_text=>unistr('Introduzca una funci\00F3n JavaScript para sustituir los atributos de inicializaci\00F3n de FullCalendar est\00E1ndar. La funci\00F3n debe devolver un objeto que contenga los atributos de inicializaci\00F3n de calendario como par\00E1metros.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(236983483525335070.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Estilo del calendario basado en el estado del proyecto</p>,',
'<pre>',
'select ID,',
'       START_DATE,',
'       END_DATE,',
'       TASK_NAME,',
'       <strong>case STATUS',
'           when ''Open''    then ''apex-cal-green''',
'           when ''Pending'' then ''apex-cal-yellow''',
'           when ''Closed''  then ''apex-cal-red''',
'           when ''On-Hold'' then ''apex-cal-black''',
'       end as css_class,</strong>',
'       ASSIGNED_TO as supplemental_info',
'  from PROJECTS',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione la columna que contiene la clase CSS para aplicar estilo a los eventos mostrados en este calendario. ',
'Existen varias clases por defecto disponibles:</p>',
'<ul>',
'  <li>apex-cal-red</li>',
'  <li>apex-cal-cyan</li>',
'  <li>apex-cal-blue</li>',
'  <li>apex-cal-bluesky</li>',
'  <li>apex-cal-darkblue</li>',
'  <li>apex-cal-green</li>',
'  <li>apex-cal-yellow</li>',
'  <li>apex-cal-silver</li>',
'  <li>apex-cal-brown</li>',
'  <li>apex-cal-lime</li>',
'  <li>apex-cal-white</li>',
'  <li>apex-cal-gray</li>',
'  <li>apex-cal-black</li>',
'  <li>apex-cal-orange</li>',
'</ul>',
unistr('<p>Consulte la documentaci\00F3n sobre c\00F3mo agregar clases CSS adicionales.</p>')))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100634228105571.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_name=>'apexcalendardateselect'
,p_display_name=>'Fecha Seleccionada'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493100238395105571.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_name=>'apexcalendareventselect'
,p_display_name=>'Evento Seleccionado'
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(493099818743105570.4412)
,p_plugin_id=>wwv_flow_api.id(716993259356536483.4412)
,p_name=>'apexcalendarviewchange'
,p_display_name=>'Ver Cambiados'
);
end;
/
prompt --application/shared_components/plugins/process_type/tabform_delete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723477031014918732.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'TABFORM_DELETE'
,p_display_name=>unistr('Pantalla Tabular - Supresi\00F3n de Varias Filas')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','TABFORM_DELETE'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION:REGION_REQUIRED'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>unistr('Proceso para suprimir varias filas desde una regi\00F3n de pantalla tabular.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477251489924376.4412)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Propietario de Tabla'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Seleccione el nombre del propietario de la tabla (esquema).'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477545882927054.4412)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nombre de la Tabla'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477251489924376.4412)
,p_help_text=>unistr('Introduzca el nombre de vista actualizable o tabla sensible a may\00FAsculas/min\00FAsculas. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723477835530931825.4412)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Columna de Clave Primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4412)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la columna que contiene el valor de la clave primaria. Para tablas con m\00E1s de dos claves primarias, seleccione <strong>ROWID</strong>.</p>'),
unistr('<p>La clave primaria se utiliza para identificar las filas que se van a suprimir y no se podr\00E1 editar en la pantalla tabular. Para nuevas filas, el valor de clave primaria debe estar vac\00EDo.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478159456935961.4412)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Columna de Clave Secundaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723477545882927054.4412)
,p_help_text=>'Seleccione la columna que contiene el segundo valor de clave primaria. Este atributo solo se debe rellenar si la clave primaria consta de dos columnas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723478847798956469.4412)
,p_plugin_id=>wwv_flow_api.id(723477031014918732.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Cl\00E1usula Where en Tiempo de Ejecuci\00F3n')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Limita los departamentos mediante:',
'  <code>DEPTNO = 10</code>'))
,p_help_text=>unistr('Introduzca la cl\00E1usula SQL WHERE que se agrega a la sentencia DELETE generada. Utilice este atributo para limitar los registros que se utilizan en las llamadas SQL generadas autom\00E1ticamente.')
);
end;
/
prompt --application/shared_components/plugins/process_type/user_preferences
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723624323202892766.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'USER_PREFERENCES'
,p_display_name=>'Preferencias del Usuario'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','USER_PREFERENCES'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Proceso para definir las preferencias de usuario del usuario final.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723624639568915612.4412)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'RESET_USER_PREFERENCES'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Seleccione un tipo de proceso para restablecer o defina las preferencias del usuario.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723626924903922340.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4412)
,p_display_sequence=>10
,p_display_value=>'Restablecer Preferencias (elimina todas las preferencias para el usuario actual)'
,p_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627321668923828.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4412)
,p_display_sequence=>20
,p_display_value=>'Definir en Valor de Elemento'
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(723627719296924995.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(723624639568915612.4412)
,p_display_sequence=>30
,p_display_value=>'Definir en Valor de Elemento si No es Nulo'
,p_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631645557973527.4412)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nombre de la Preferencia'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_text_case=>'UPPER'
,p_help_text=>'Introduzca un nombre de preferencia.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723631934127978868.4412)
,p_plugin_id=>wwv_flow_api.id(723624323202892766.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723624639568915612.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SET_PREFERENCE_TO_ITEM_VALUE,SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_help_text=>unistr('Seleccione un elemento de aplicaci\00F3n o p\00E1gina que contenga el valor de la preferencia. Puede escribir el nombre o seleccionarlo en la lista de elementos disponibles.')
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(723640922660606468.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS'
,p_display_name=>unistr('Procesamiento Autom\00E1tico de Filas (DML)')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_legacy=>true
,p_help_text=>'Proceso para insertar, actualizar o suprimir registros en una sola tabla de base de datos o vista actualizable. Este proceso sirve para procesar elementos de formato con un origen del tipo <strong>Columna de Base de Datos</strong>. Los atributos intr'
||unistr('oducidos para este proceso se deben correlacionar con los atributos introducidos en el proceso <em>Recuperaci\00F3n Autom\00E1tica de Filas</em>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641240116613584.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Propietario de Tabla'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Seleccione el nombre del propietario de la tabla (esquema).'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641536018615468.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Nombre de la Tabla'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641240116613584.4412)
,p_help_text=>unistr('Introduzca el nombre de vista o tabla sensible a may\00FAsculas/min\00FAsculas. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723641830196618138.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>'Elemento de Clave Primaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el valor de la columna de clave primaria. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642126745619762.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>30
,p_prompt=>'Columna de Clave Primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4412)
,p_help_text=>unistr('Seleccione la columna que contiene el valor de clave primaria. Para las tablas que tienen m\00E1s de dos claves primarias de dos partes, seleccione <strong>ROWID</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642422001622013.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>'Elemento de Clave Secundaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_common=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el valor de la columna de clave secundaria. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723642713590625893.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>50
,p_prompt=>'Columna de Clave Secundaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(723641536018615468.4412)
,p_depending_on_attribute_id=>wwv_flow_api.id(723642126745619762.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'ROWID'
,p_help_text=>'Seleccione la columna que contiene el segundo valor de clave primaria. Este atributo solo se debe rellenar si la clave primaria consta de dos columnas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646536850919017.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Columna de Versi\00F3n de Fila')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la columna que identifica la versi\00F3n de la fila; esta columna no debe estar presente en la p\00E1gina. Deje este atributo en blanco para utilizar el total de control incorporado.</p>'),
unistr('<p>El bloqueo oportunista utiliza la detecci\00F3n de actualizaciones perdidas para garantizar la integridad de los datos en aplicaciones en las que se puede acceder a los datos de manera simult\00E1nea. &PRODUCT_NAME. puede utilizar un total de control inco')
||unistr('rporado para realizar la detecci\00F3n de actualizaciones perdidas y determinar la versi\00F3n de la fila. El total de control es una funci\00F3n hash de todos los valores de columna de la fila de la tabla espec\00EDfica. Se recupera cuando se consulta el registro d')
||unistr('esde la base de datos en <em>Recuperaci\00F3n Autom\00E1tica de Filas</em> y, a continuaci\00F3n, se compara con el hash del registro actual en la base de datos como parte de este proceso. Si los dos valores son iguales, la actualizaci\00F3n contin\00FAa; de lo contrari')
||'o, este proceso genera un error.</p>',
unistr('<p>Este atributo le permite especificar una sola columna que contiene la versi\00F3n de la fila, como alternativa al uso del procesamiento de sumas de control incorporadas. Esta columna se debe actualizar siempre que se actualiza un registro en la base d')
||unistr('e datos. Oracle recomienda implantar un disparador de bases de datos <em>Antes de Actualizaci\00F3n</en> en la tabla para incrementar o actualizar la columna de versi\00F3n de fila. Se presupone que las columnas NUMBER contienen un n\00FAmero de secuencia para l')
||unistr('a fila. Sin embargo, tambi\00E9n se pueden utilizar columnas DATE y TIMESTAMP. La ventaja de utilizar una sola columna es que el motor de &PRODUCT_NAME. no tiene que realizar el hash de la fila completa, solo tiene que comprar un valor de una sola column')
||'a.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(723646022259834604.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Cl\00E1usula Where en Tiempo de Ejecuci\00F3n')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Limita los departamentos:</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('Introduzca la cl\00E1usula SQL WHERE que se agrega a todas las sentencias INSERT, UPDATE y DELETE generadas. Utilice este atributo para limitar los registros que se utilizan en las llamadas SQL generadas autom\00E1ticamente.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842218629998562.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Devolver Clave en Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el elemento de aplicaci\00F3n o p\00E1gina que va a contener el valor de columna de clave primaria que se devuelve de una sentencia SQL INSERT. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.</p>'),
unistr('<p>Especifique esta columna para recuperar los campos de clave primaria que rellenan las secuencias o disparadores de base de datos. El proceso define este valor en el estado de sesi\00F3n. </p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361842512807001262.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Devolver Segunda Clave en Elemento'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(723642713590625893.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que va a contener el segundo valor de la columna de clave primaria que se devuelve de una sentencia SQL INSERT. Puede escribir el nombre o seleccionarlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(361843216017030111.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Operaciones Soportadas'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>true
,p_default_value=>'I:U:D'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Compruebe las operaciones de lenguaje de manipulaci\00F3n de datos (DML) que est\00E1n soportadas. Este proceso de manipulaci\00F3n de datos realizar\00E1 una acci\00F3n DML cuando el valor de solicitud sea uno de los de la lista. Al utilizar un bot\00F3n para ejecutar esta')
||unistr(' p\00E1gina, el valor de solicitud se define en el nombre del bot\00F3n.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471227178028863.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4412)
,p_display_sequence=>10
,p_display_value=>'Insertar'
,p_return_value=>'I'
,p_help_text=>'Disparado por los Valores de Solicitud: INSERT, CREATE, CREATE_AGAIN, CREATEAGAIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362471623727030373.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4412)
,p_display_sequence=>20
,p_display_value=>'Actualizar'
,p_return_value=>'U'
,p_help_text=>'Disparado por los Valores de Solicitud: SAVE, APPLY CHANGES, UPDATE, UPDATE ROW, CHANGE, APPLY, APPLY%CHANGES%, GET_NEXT%, GET_PREV%'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362472022649030909.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(361843216017030111.4412)
,p_display_sequence=>30
,p_display_value=>'Suprimir'
,p_return_value=>'D'
,p_help_text=>'Disparado por los Valores de Solicitud: DELETE, REMOVE, DELETE ROW, DROP'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(216670983590615543.4412)
,p_plugin_id=>wwv_flow_api.id(723640922660606468.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>105
,p_prompt=>'Bloquear Fila'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'<p>Seleccione si cada fila que se vaya a actualizar o suprimir se bloquea en la tabla subyacente antes de procesar la fila.</p>'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/set_focus
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854773928315984269.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SET_FOCUS'
,p_display_name=>'Definir Foco'
,p_category=>'COMPONENT'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SET_FOCUS'),'')
,p_api_version=>1
,p_standard_attributes=>'ITEM:BUTTON:JAVASCRIPT_EXPRESSION:JQUERY_SELECTOR:TRIGGERING_ELEMENT:EVENT_SOURCE:REQUIRED:ONLOAD'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Define el foco en los elementos afectados. El valor por defecto es el primero de los elementos afectados en caso de que haya varios. Esta acci\00F3n puede resultar especialmente \00FAtil si se utiliza en conjunci\00F3n con las acciones <em>Mostrar</em> y <em>Act')
||'ivar</em> para llevar al usuario directamente al elemento adecuado.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/submit_page
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(854776817374066356.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'SUBMIT_PAGE'
,p_display_name=>unistr('Ejecutar P\00E1gina')
,p_category=>'NAVIGATION'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','SUBMIT_PAGE'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Ejecuta la p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(854777422315124533.4412)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Nombre de Bot\00F3n/Solicitud')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el valor de solicitud utilizado para ejecutar la p\00E1gina. Def\00EDnalo en el nombre del bot\00F3n, si un bot\00F3n dispara la acci\00F3n din\00E1mica. De esta forma, se garantiza que se respete el atributo <em>Ejecutar Validaciones</em> del bot\00F3n durante el pr')
||unistr('ocesamiento de las p\00E1ginas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(477648707512082509.4412)
,p_plugin_id=>wwv_flow_api.id(854776817374066356.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Mostrar Procesamiento'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si la p\00E1gina actual se aten\00FAa y se muestra una animaci\00F3n de estilo de "procesamiento" durante la ejecuci\00F3n de la p\00E1gina. Esto puede resultar \00FAtil para evitar la acci\00F3n del usuario final durante operaciones de larga ejecuci\00F3n, como cuando ')
||unistr('el usuario final intenta volver a hacer clic en el bot\00F3n de b\00FAsqueda cuando el informe tarda en refrescarse.')
);
end;
/
prompt --application/shared_components/plugins/item_type/number_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(858626633540183539.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'NUMBER_FIELD'
,p_display_name=>unistr('Campo Num\00E9rico')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','NUMBER_FIELD'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_NUMBER:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Muestra un campo num\00E9rico. Este tipo de elemento valida autom\00E1ticamente que el valor sea un n\00FAmero.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627014886206552.4412)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Valor M\00EDnimo')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>0</code></li>',
'<li><code>0.99</code></li>',
'<li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Introduzca el valor m\00EDnimo permitido. El valor puede ser est\00E1tico o din\00E1mico mediante la sintaxis de sustituci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858627524583209309.4412)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Valor M\00E1ximo')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>1000</code></li>',
'<li><code>49.99</code></li>',
'<li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Introduzca el valor m\00E1ximo permitido. El valor puede ser est\00E1tico o din\00E1mico mediante la sintaxis de sustituci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(858676504215733205.4412)
,p_plugin_id=>wwv_flow_api.id(858626633540183539.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Alineaci\00F3n Num\00E9rica')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'right'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione la forma en que se alinea el n\00FAmero que se muestra. Este valor no se aplica cuando el elemento se representa como <em>Solo Lectura</em> o si se especifican <strong>Atributos de Elemento de Formato HTML</strong>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678212526735663.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4412)
,p_display_sequence=>10
,p_display_value=>'Izquierda'
,p_return_value=>'left'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858678618067737263.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4412)
,p_display_sequence=>20
,p_display_value=>'Centro'
,p_return_value=>'center'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(858679023954738917.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(858676504215733205.4412)
,p_display_sequence=>30
,p_display_value=>'Derecha'
,p_return_value=>'right'
);
end;
/
prompt --application/shared_components/plugins/item_type/slider
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(880057283386968314.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SLIDER'
,p_display_name=>unistr('Gu\00EDa de Desplazamiento')
,p_supported_ui_types=>'JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SLIDER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Muestra un tipo de elemento deslizante, que permite a los usuarios actualizar el valor del elemento mediante el deslizamiento del control a izquierda o derecha.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880057664732991327.4412)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Valor M\00EDnimo')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'0'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>0</code></li>',
'  <li><code>&P1_MIN_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Introduzca el valor m\00EDnimo permitido. El valor puede ser est\00E1tico o din\00E1mico mediante la sintaxis de sustituci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880058174429994084.4412)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Valor M\00E1ximo')
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>100</code></li>',
'  <li><code>&P1_MAX_SALARY.</code></li>',
'</ul>'))
,p_help_text=>unistr('Introduzca el valor m\00E1ximo permitido. El valor puede ser est\00E1tico o din\00E1mico mediante la sintaxis de sustituci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(880107154062517980.4412)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Incremento de Paso'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li><code>5</code></li>',
'  <li><code>&P1_STEP_SIZE.</code></li>',
'</ul>'))
,p_help_text=>unistr('Introduzca un valor para que la gu\00EDa de desplazamiento se ajuste a un incremento espec\00EDfico. El valor puede ser est\00E1tico o din\00E1mico mediante la sintaxis de sustituci\00F3n.')
,p_attribute_comment=>'$$$ DJP - No default value set = 1'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10717732308427631.4412)
,p_plugin_id=>wwv_flow_api.id(880057283386968314.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Resaltar Seleccionados'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si la gu\00EDa de desplazamiento resaltar\00E1 el seguimiento de la posici\00F3n actual del manejador de la gu\00EDa de desplazamiento.')
);
end;
/
prompt --application/shared_components/plugins/process_type/send_email
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(956011735689077213.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'SEND_EMAIL'
,p_display_name=>unistr('Enviar Correo Electr\00F3nico')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','SEND_EMAIL'),'')
,p_api_version=>1
,p_standard_attributes=>'REGION'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Proceso para enviar un correo electr\00F3nico y, opcionalmente, uno o varios anexos, desde la aplicaci\00F3n.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956092037052376563.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'De'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'&APP_EMAIL.'
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_help_text=>unistr('Introduzca la direcci\00F3n de correo electr\00F3nico que se muestra como remitente del correo electr\00F3nico. Debe ser una direcci\00F3n de correo electr\00F3nico v\00E1lida. De lo contrario, no se enviar\00E1 el mensaje. Utilice sintaxis de sustituci\00F3n si desea utilizar un v')
||unistr('alor din\00E1mico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956050619869980888.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Para'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('Para introducir los destinatarios de correo electr\00F3nico, especifique una o varias direcciones de correo electr\00F3nico. Para introducir varias direcciones de correo electr\00F3nico, utilice una lista separada por comas. Utilice la sintaxis de sustituci\00F3n si')
||unistr(' desea utilizar un valor din\00E1mico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956051928180983251.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Cc'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_help_text=>unistr('Para introducir los destinatarios de correo electr\00F3nico en copia, especifique una o varias direcciones de correo electr\00F3nico. Para introducir varias direcciones de correo electr\00F3nico, utilice una lista separada por comas. Utilice la sintaxis de susti')
||unistr('tuci\00F3n si desea utilizar un valor din\00E1mico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956052531990984386.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Cco'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_help_text=>unistr('Para introducir los destinatarios de correo electr\00F3nico en copia oculta, especifique una o varias direcciones de correo electr\00F3nico. Para introducir varias direcciones de correo electr\00F3nico, utilice una lista separada por comas. Utilice la sintaxis d')
||unistr('e sustituci\00F3n si desea utilizar un valor din\00E1mico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082217032200544.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Responder a'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>60
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_help_text=>unistr('Introduzca la direcci\00F3n de correo a la que se deben enviar las respuestas. Si no se especifica, se utilizar\00E1 la direcci\00F3n de correo electr\00F3nico introducida en <strong>De</strong>. Utilice la sintaxis de sustituci\00F3n si desea utilizar un valor din\00E1mico')
||'.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053241340987086.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'Asunto'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4412)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>unistr('Introduzca el asunto del correo electr\00F3nico. Utilice sintaxis de sustituci\00F3n, como por ejemplo, <code>&amp;P6_PRODUCT_NAME.</code>, si desea incluir un valor din\00E1mico.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956053823463991423.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>80
,p_prompt=>'Cuerpo - Texto sin Formato'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el texto del correo electr\00F3nico. Se utilizar\00E1 la versi\00F3n de texto sin formato en caso de que el cliente de correo electr\00F3nico del destinatario no soporte la visualizaci\00F3n de texto enriquecido. Utilice sintaxis de sustituci\00F3n (ejemplo: <')
||unistr('code>&amp;P6_PRODUCT_NAME.</code>) si desea incluir contenido din\00E1mico en el texto.</p>'),
unistr('<p><em>Nota: la especificaci\00F3n SMTP/MIME establece que ninguna l\00EDnea debe tener m\00E1s de 1000 caracteres. Para cumplir esta restricci\00F3n, debe agregar caracteres de retorno de carro o salto de l\00EDnea para dividir el texto en p\00E1rrafos de hasta 1000 caract')
||unistr('eres. Si no lo hace, se pueden producir mensajes de correo electr\00F3nico err\00F3neos (como mensajes parciales o con signos de exclamaci\00F3n extra\00F1os).</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956082724997202851.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>90
,p_prompt=>'Cuerpo - HTML'
,p_attribute_type=>'HTML'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4412)
,p_depending_on_has_to_exist=>false
,p_depending_on_condition_type=>'NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca texto que genere un mensaje HTML de varias partes que incluya tanto texto sin formato como contenido HTML. La configuraci\00F3n y las capacidades del cliente de correo electr\00F3nico del destinatario determinar\00E1n lo que se muestra. Aunque la m')
||unistr('ayor\00EDa de los clientes de correo electr\00F3nico actuales lee correo electr\00F3nico con formato HTML, recuerde que algunos usuarios desactivan esta funci\00F3n para evitar problemas de seguridad. Utilice la sintaxis de sustituci\00F3n (por ejemplo, <code>&amp;P6_PR')
||unistr('ODUCT_NAME.</code>) si desea incluir contenido din\00E1mico en el texto.</p>'),
unistr('<p>Al hacer referencia a im\00E1genes con etiquetas &lt;img /&gt;, recuerde que, para que el destinatario pueda ver las im\00E1genes, su cliente de correo electr\00F3nico debe poder acceder a ellas. Supongamos, por ejemplo, que hace referencia a una imagen en la')
||' red denominada hello.gif de la siguiente manera:</p>',
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
unistr('<p>En este ejemplo, la imagen no se adjunta al correo electr\00F3nico, sino que se hace referencia a ella en el correo electr\00F3nico. Para verla, el destinatario debe poder acceder a ella con un explorador web. Si la imagen est\00E1 dentro de un firewall y el ')
||unistr('destinatario est\00E1 fuera, no se mostrar\00E1 la imagen. Por este motivo, evite utilizar im\00E1genes. Si tiene que incluir im\00E1genes, aseg\00FArese de incluir el atributo ALT para proporcionar una descripci\00F3n de texto por si no se puede acceder a la imagen.</p>'),
unistr('<p><em>Nota: La especificaci\00F3n SMTP/MIME establece que ninguna l\00EDnea debe tener m\00E1s de 1000 caracteres. Para cumplir esta restricci\00F3n, debe agregar caracteres de retorno de carro o salto de l\00EDnea para dividir el texto en p\00E1rrafos de hasta 1000 caract')
||unistr('eres. Si no lo hace, se pueden producir mensajes de correo electr\00F3nico err\00F3neos (como mensajes parciales o con signos de exclamaci\00F3n extra\00F1os).</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(956084325437259694.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>'Anexo - SQL'
,p_attribute_type=>'SQL'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>La sentencia SQL tiene que tener el siguiente formato:</p>',
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type',
'       content_id',
'  from table',
'</pre>',
unistr('<p>Las columnas mime_type y content_id son opcionales. Si content_id est\00E1 presente, el archivo se adjuntar\00E1 en l\00EDnea y el valor de content_id se utilizar\00E1 para el CID del adjunto.</p>'),
unistr('<p>Si la columna content_id column contiene el valor ''my_inline_content'', es posible que esa imagen se incruste en el correo electr\00F3nico utilizando la siguiente HTML:</p>'),
'<p>',
'<pre>',
'&lt;div&gt;',
'&nbsp;&nbsp;&lt;h1&gt;Some Embedded Content&lt;/h1&gt;',
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una sentencia SQL que devuelva uno o m\00E1s objetos binarios grandes que se adjunten como archivos al mensaje de correo electr\00F3nico.</p>'),
unistr('<p>Si la columna content_id contiene un valor nulo, los archivos asociados ser\00E1n archivos adjuntos normales. Por lo general, los archivos como documentos o archivos .zip se adjuntan de esta forma.</p>'),
unistr('<p>Si el valor de content_id no es nulo, entonces el archivo asociado se marcar\00E1 como adjunto en l\00EDnea. El valor de la columna content_id se utilizar\00E1 como CID (identificador de contenido) del archivo adjunto. Este valor de CID se puede utilizar en e')
||unistr('l c\00F3digo HTML del mensaje de correo electr\00F3nico para embeber im\00E1genes directamente en el contenido de correo electr\00F3nico. Tenga en cuenta que es posible que algunos clientes de correo electr\00F3nico no muestren los archivos adjuntos en l\00EDnea autom\00E1ticam')
||unistr('ente. Oracle Application Express no aplica la conformidad con estos est\00E1ndares.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(965817719331444057.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>'Enviar Inmediatamente'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si enviar\00E1 este correo electr\00F3nico inmediatamente. Tambi\00E9n se enviar\00E1n todos los mensajes que est\00E9n actualmente en la tabla de la cola de correos electr\00F3nicos de &PRODUCT_NAME. Por defecto, &PRODUCT_NAME. almacena los mensajes de correo e')
||unistr('lectr\00F3nico no enviados en una tabla y los entrega peri\00F3dicamente para mejorar el rendimiento del sistema.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1801033763884282.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>60
,p_prompt=>unistr('Plantilla de correo electr\00F3nico')
,p_attribute_type=>'EMAIL TEMPLATE ID'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione la plantilla de correo electr\00F3nico que desea utilizar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802168961897202.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>100
,p_prompt=>unistr('Valores de marcador de posici\00F3n')
,p_attribute_type=>'PLACEHOLDER JSON'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Nombres de marcadores de posici\00F3n de plantilla que, junto con los valores, se van a sustituir.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1802477287905419.4412)
,p_plugin_id=>wwv_flow_api.id(956011735689077213.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>110
,p_prompt=>unistr('Sustituci\00F3n de idioma')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1801033763884282.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si se especifica un c\00F3digo de idioma, el proceso buscar\00E1 una plantilla con la traducci\00F3n de la aplicaci\00F3n para dicho idioma. De no existir la traducci\00F3n, el proceso utilizar\00E1 el idioma principal de la aplicaci\00F3n. La sintaxis de sustituci\00F3n est\00E1 so')
||'portada.</p>',
unistr('<p>La jerarqu\00EDa de c\00F3digos de idiomas est\00E1 soportada. Si se especifica el valor "fr-ca" (Franc\00E9s - Canad\00E1), pero solo existe la traducci\00F3n de "fr" (franc\00E9s), esta ser\00E1 la que se utilice.</p>')))
);
end;
/
prompt --application/shared_components/plugins/item_type/file
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(961772418825259055.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'FILE'
,p_display_name=>unistr('Exploraci\00F3n de Archivos...')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','FILE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:ICON'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un campo de texto con el bot\00F3n <em>Examinar...</em>. Este bot\00F3n permite al usuario localizar y cargar un archivo desde un sistema de archivos local.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961797912421645170.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>40
,p_prompt=>'Tipo de Almacenamiento'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Seleccione la tabla de la base de datos en la que se almacena el archivo cargado.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799013591654950.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4412)
,p_display_sequence=>10
,p_display_value=>'Columna BLOB Especificada en Origen del Elemento'
,p_return_value=>'DB_COLUMN'
,p_help_text=>unistr('Almacena el archivo cargado en la tabla que utiliza el proceso <strong>Procesamiento Autom\00E1tico de Filas (DML)</strong> y la columna especificada en el atributo de origen del elemento. La columna debe tener el tipo de dato BLOB. Si el archivo se desc')
||unistr('arga, se utiliza el nombre de tabla del proceso <strong>Recuperaci\00F3n Autom\00E1tica de Filas</strong>.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728348831149058771.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4412)
,p_display_sequence=>20
,p_display_value=>'Tabla APEX_APPLICATION_TEMP_FILES'
,p_return_value=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Almacena los archivos cargados en una ubicaci\00F3n temporal a la que puede acceder con los archivos APEX_APPLICATION_TEMP_FILES de la vista. &PRODUCT_NAME. suprimir\00E1 autom\00E1ticamente los archivos al final de la sesi\00F3n o de la solicitud de carga, en fu')
||unistr('nci\00F3n del valor que elija para <strong>Depurar archivo en</strong>.</p>'),
unistr('<p>Para acceder a un archivo si <strong>Permitir m\00FAltiples archivos</strong> est\00E1 definido en <strong>No</strong>:</p>'),
'<pre>',
'select *',
'  from apex_application_temp_files',
unistr(' where name = :<em>nombre del elemento de p\00E1gina</em>;'),
'</pre>',
unistr('<p>Para acceder a los archivos si <strong>Permitir m\00FAltiples archivos</strong> est\00E1 definido en <strong>Yes</strong>:</p>'),
'<pre>',
'declare',
'    l_file_names apex_t_varchar2;',
'    l_file       apex_application_temp_files%rowtype;',
'begin',
'    l_file_names := apex_string.split (',
unistr('                        p_str => :<em>nombre del elemento de p\00E1gina</em>,'),
'                        p_sep => '':'' );',
'    for i in 1 .. l_file_names.count loop',
'        select *',
'          into l_file',
'          from apex_application_temp_files',
'         where name = l_file_names(i);',
unistr('        -- agregar aqu\00ED c\00F3digo para almacenar el archivo cargado en su propia tabla'),
'    end loop;',
'end;',
'</pre>'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961799722296685857.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(961797912421645170.4412)
,p_display_sequence=>30
,p_display_value=>'Tabla WWV_FLOW_FILES'
,p_return_value=>'WWV_FLOW_FILES'
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Almacena el archivo cargado en la tabla &PRODUCT_NAME. <code>WWV_FLOW_FILES</code>.</p>',
'<p>Para acceder al archivo, utilice:</p>',
'<pre>',
'select *',
'  desde wwv_flow_files',
' donde el nombre = :<<em>page item name</em>>;',
'</pre>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961780714070314496.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>50
,p_prompt=>'Columna de Tipo MIME'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Introduzca el nombre del elemento de aplicaci\00F3n o p\00E1gina en may\00FAsculas que se utilice para almacenar el tipo mime del archivo cargado. El explorador utiliza el tipo mime para identificar la aplicaci\00F3n que se utiliza para ver el contenido BLOB cuando ')
||'se descarga el archivo.'
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781218572315783.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>60
,p_prompt=>'Columna de Nombre de Archivo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que se utiliza para almacenar el nombre de archivo del archivo cargado.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961781726537318040.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>70
,p_prompt=>'Columna de Juego de Caracteres'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Introduzca el nombre del elemento de aplicaci\00F3n o p\00E1gina en may\00FAsculas que se utilice para almacenar el juego de caracteres del archivo cargado. El juego de caracteres del BLOB no se define autom\00E1ticamente al cargar. Los usuarios finales deber\00EDan def')
||unistr('inir el juego de caracteres del documento que est\00E1n cargando.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782232078319703.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>80
,p_prompt=>unistr('\00DAltima Columna BLOB Actualizada')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Introduzca el nombre del elemento de aplicaci\00F3n o p\00E1gina en may\00FAsculas que se utiliza para almacenar el registro de hora cuando se carga un archivo. Este valor de fecha se utiliza para el almacenamiento en cach\00E9 del explorador.')
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be an ITEM Pop-up'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961805334341783950.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>90
,p_prompt=>'Mostrar Enlace de Descarga'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Especifique si se muestra el enlace de descarga cuando hay un BLOB no vac\00EDo asociado a este elemento.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961784310308341810.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>100
,p_prompt=>'Texto de Enlace de Descarga'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Introduzca el texto que se va a mostrar como parte del enlace de descarga. Si no se especifica, se muestra el texto almacenado en el mensaje de texto para <code>APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT</code>, en Componentes Compartidos.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(961782727361327744.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>110
,p_prompt=>unistr('Disposici\00F3n del Contenido')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'attachment'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961805334341783950.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Seleccione la forma en que el explorador trata el contenido al descargarlo.</p>',
unistr('<p><em>Nota: no todo el contenido se puede mostrar en l\00EDnea. El soporte para mostrarlo en l\00EDnea depende de si el explorador soporta el tipo mime espec\00EDfico.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783330131328554.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4412)
,p_display_sequence=>10
,p_display_value=>unistr('En L\00EDnea')
,p_return_value=>'inline'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(961783735326330101.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(961782727361327744.4412)
,p_display_sequence=>20
,p_display_value=>'Adjunto'
,p_return_value=>'attachment'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728349541683084558.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>120
,p_prompt=>'Depurar Archivo en'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SESSION'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Defina cu\00E1ndo &PRODUCT_NAME. debe eliminar el archivo temporal.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728349853284087310.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Fin de Sesi\00F3n')
,p_return_value=>'SESSION'
,p_help_text=>unistr('Suprima el archivo al final de la sesi\00F3n &PRODUCT_NAME. actual.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(728350242833089332.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(728349541683084558.4412)
,p_display_sequence=>20
,p_display_value=>'Fin de Solicitud'
,p_return_value=>'REQUEST'
,p_help_text=>'Suprima el archivo al final de la solicitud HTTP actual.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451543969001781322.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>130
,p_prompt=>unistr('Permitir M\00FAltiples Archivos')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(961797912421645170.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'APEX_APPLICATION_TEMP_FILES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique si se pueden cargar varios archivos al mismo tiempo.</p>',
'',
unistr('<p>Nota: Se almacenar\00E1n varios nombres de archivo como lista delimitada por puntos y comas en el elemento de p\00E1gina.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(451544768593842902.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>140
,p_prompt=>'Tipos de Archivo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dt>Indica que solo se deben aceptar archivos de imagen</dt>',
'<dd><pre>image/*</pre></dd>',
unistr('<dt>Indica que solo se deben aceptar archivos de imagen y archivos de v\00EDdeo</dt>'),
'<dd><pre>image/*,video/*</pre></dd>',
'<dt>Indica que solo se deben aceptar archivos de imagen PNG</dt>',
'<dd><pre>image/png</pre></dd>'))
,p_help_text=>'Especifique una lista delimitada por comas de tipos de archivo que puede utilizar el explorador para restringir los archivos que se pueden cargar.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13629201915222128.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>10
,p_prompt=>'Mostrar como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INLINE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione un estilo de visualizaci\00F3n para la forma en que deber\00EDa mostrarse el elemento de exploraci\00F3n de archivos.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629582056224659.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Exploraci\00F3n de archivos en l\00EDnea')
,p_return_value=>'INLINE'
,p_help_text=>unistr('Mostrar el campo de entrada del explorador de archivos de forma similar a otros campos de texto y elementos de la p\00E1gina.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13629902085226258.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Zona de colocaci\00F3n en l\00EDnea')
,p_return_value=>'DROPZONE_INLINE'
,p_help_text=>unistr('Mostrar el campo de entrada del explorador de archivos como zona de colocaci\00F3n en l\00EDnea que cuenta con un t\00EDtulo y una descripci\00F3n.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(13741737113486642.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Zona de colocaci\00F3n en bloque')
,p_return_value=>'DROPZONE_BLOCK'
,p_help_text=>unistr('Mostrar el campo de entrada del explorador de archivos como zona de colocaci\00F3n de tipo asistente que cuente con un t\00EDtulo y una descripci\00F3n, y un bot\00F3n para seleccionar los archivos.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(18970520653850634.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(13629201915222128.4412)
,p_display_sequence=>40
,p_display_value=>unistr('Exploraci\00F3n de archivos nativos')
,p_return_value=>'NATIVE'
,p_help_text=>unistr('Utilice el formato nativo del explorador para mostrar el elemento de exploraci\00F3n de archivos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13631853022534008.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>20
,p_prompt=>unistr('T\00EDtulo de la zona de colocaci\00F3n')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'INLINE,DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Especifique el t\00EDtulo de la zona de colocaci\00F3n.'),
unistr('Si este campo se deja en blanco, se utilizar\00E1n los mensajes de texto <code>APEX.ITEM.FILE.DROP_FILE</code> o <code>APEX.ITEM.FILE.DROP_FILES</code> por defecto.')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13643896497789547.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>30
,p_prompt=>unistr('Descripci\00F3n de la zona de colocaci\00F3n')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(13629201915222128.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'DROPZONE_INLINE,DROPZONE_BLOCK'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique el texto descriptivo de la zona de colocaci\00F3n.</p>'),
unistr('<p>Si este campo se deja en blanco, se utilizar\00E1n los siguientes mensajes de texto por defecto, en funci\00F3n de la propiedad Mostrar como.</p>'),
unistr('<p><strong>Zona de colocaci\00F3n del bloque</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES</code>',
'</p>',
unistr('<p><strong>Zona de colocaci\00F3n en l\00EDnea</strong><br />'),
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILE</code> <br />',
'<code>APEX.ITEM.FILE.DROP_OR_SELECT_FILES</code>',
'</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(13644378210801196.4412)
,p_plugin_id=>wwv_flow_api.id(961772418825259055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_prompt=>unistr('Tama\00F1o M\00E1ximo de Archivo')
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_unit=>'Base de conocimientos'
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el tama\00F1o m\00E1ximo de archivo (en KB) que deber\00EDa aceptarse para los archivos cargados a trav\00E9s de este elemento.')
);
end;
/
prompt --application/shared_components/plugins/item_type/list_manager
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(973073216779459799.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'LIST_MANAGER'
,p_display_name=>'Gestor de Listas'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','LIST_MANAGER'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:ELEMENT_OPTION:PLACEHOLDER:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Muestra un elemento de texto con un icono de lista de valores emergente, los botones <em>Agregar</em> y <em>Eliminar</em> y una lista de valores seleccionados.</p>',
unistr('<p>Puede escribir el valor o elegirlo en la lista de elementos disponibles. A continuaci\00F3n, puede utilizar los botones para gestionar los valores seleccionados. Estos valores se almacenan en una sola cadena delimitada por dos puntos.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973075623967480816.4412)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Recuperar'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione c\00F3mo se muestran los datos cuando se abre la lista de valores emergente.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973076228816482253.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Sin Recuperaci\00F3n')
,p_return_value=>'NO_FETCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077034010483721.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4412)
,p_display_sequence=>20
,p_display_value=>'Recuperar Primer Juego de Filas'
,p_return_value=>'FIRST_ROWSET'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(973077408168485730.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(973075623967480816.4412)
,p_display_sequence=>30
,p_display_value=>'Recuperar Primer Juego de Filas y Filtrar Valor Actual'
,p_return_value=>'FIRST_ROWSET_FILTER'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(973074833187474061.4412)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Mantener May\00FAsculas/Min\00FAsculas')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si el valor se queda como se ha introducido o se convierte a may\00FAsculas.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845154323494834504.4412)
,p_plugin_id=>wwv_flow_api.id(973073216779459799.4412)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores basada en consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores con el mismo valor de retorno y visualizaci\00F3n</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Nota: al seleccionar la misma columna para los valores de retorno y visualizaci\00F3n, utilice un alias de columna.</p>'),
'</dd>',
'<dt>Lista de valores con variable de enlace</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: defina el atributo <em>Elementos Principales de Lista de Valores en Cascada</em> en <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> es un elemento de p\00E1gina modificable en la misma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/process_type/form_process_legacy
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1086048547681945775.4412)
,p_plugin_type=>'PROCESS TYPE'
,p_name=>'FORM_PROCESS_LEGACY'
,p_display_name=>unistr('Procesamiento Autom\00E1tico de Filas Heredado')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('PROCESS TYPE','FORM_PROCESS_LEGACY'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>'Proceso para insertar, actualizar o suprimir registros en una sola tabla de base de datos o vista actualizable. Este proceso sirve para procesar elementos de pantalla con un origen del tipo <strong>Columna de Base de Datos</strong>. Oracle recomienda'
||unistr(' actualizar este tipo de proceso a <strong>Procesamiento de Filas Autom\00E1tico (DML)</strong>.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(724250841038369418.4412)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INSERT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione qu\00E9 operaciones de lenguaje de manipulaci\00F3n de datos (DML) est\00E1n permitidas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408026159343735.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4412)
,p_display_sequence=>10
,p_display_value=>'Insertar'
,p_return_value=>'INSERT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408425080344291.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4412)
,p_display_sequence=>20
,p_display_value=>'Actualizar'
,p_return_value=>'UPDATE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362408824002344800.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(724250841038369418.4412)
,p_display_sequence=>30
,p_display_value=>'Suprimir'
,p_return_value=>'DELETE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086048865137952891.4412)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Propietario de Tabla'
,p_attribute_type=>'OWNER'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_help_text=>'Seleccione el nombre del propietario de la tabla (esquema).'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049161039954775.4412)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Nombre de la Tabla'
,p_attribute_type=>'TABLE'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086048865137952891.4412)
,p_help_text=>unistr('Introduzca el nombre de vista o tabla sensible a may\00FAsculas/min\00FAsculas. Puede escribir el nombre o elegirlo en la lista.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049455217957445.4412)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>50
,p_prompt=>'Elemento de Clave Primaria'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el elemento de aplicaci\00F3n o p\00E1gina que contiene el valor de la columna de clave primaria. Puede escribir el nombre o elegirlo en la lista de elementos disponibles.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086049751766959069.4412)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>40
,p_prompt=>'Columna de Clave Primaria'
,p_attribute_type=>'COLUMN'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>128
,p_column_data_types=>'VARCHAR2:ROWID'
,p_is_translatable=>false
,p_parent_attribute_id=>wwv_flow_api.id(1086049161039954775.4412)
,p_help_text=>'Seleccione la columna que contiene el valor de clave primaria. Si la tabla tiene una clave primaria de varias partes, seleccione <strong>ROWID</strong>.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1086053647281173911.4412)
,p_plugin_id=>wwv_flow_api.id(1086048547681945775.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('Cl\00E1usula Where en Tiempo de Ejecuci\00F3n')
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_common=>false
,p_max_length=>4000
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Limita el departamento:</p>',
'<pre>DEPTNO = 10</pre>'))
,p_help_text=>unistr('Introduzca la cl\00E1usula SQL WHERE que se agrega a todas las sentencias SELECT, UPDATE y DELETE generadas. Utilice este atributo para limitar los registros que se utilizan en las llamadas SQL generadas autom\00E1ticamente.')
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/cancel_event
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1112790930653153311.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'CANCEL_EVENT'
,p_display_name=>'Cancelar Evento'
,p_category=>'MISC'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','CANCEL_EVENT'),'')
,p_api_version=>1
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Cancela el evento actual.'
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/date_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1166598346362318406.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DATE_PICKER'
,p_display_name=>'Selector de fecha (jQuery)'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DATE_PICKER'),'')
,p_api_version=>1
,p_validation_function=>'dummy_to_trigger_basic_validation'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:FORMAT_MASK_DATE:ELEMENT:WIDTH:PLACEHOLDER:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_deprecated=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Muestra un campo de texto con un icono de calendario. Los usuarios finales pueden introducir la fecha directamente en el elemento de texto o hacer clic en el icono del calendario para seleccionar una fecha y, opcionalmente, una hora, en el calenda'
||'rio emergente.</p>',
unistr('<p>La hora solo aparece en el calendario emergente si <em>M\00E1scara de Formato</em> de este elemento incluye componentes de hora.</p>')))
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599468441343733.4412)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Fecha Resaltada'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>20090624</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_NEXT_AVAILABLE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Introduzca un valor de fecha por defecto que se resalta al llamar al calendario emergente. Si no se especifica, en el calendario se resaltan la fecha y hora actuales.</p>',
unistr('<p>El valor puede ser un valor absoluto en el formato <code>''YYYYMMDDHH24MI''</code>, un valor relativo con respecto a la fecha de hoy, como <code>+7d</code>, o un valor din\00E1mico mediante la sintaxis de sustituci\00F3n, siempre y cuando la sustituci\00F3n dev')
||'uelva el formato de fecha correcto o el valor relativo.</p>',
'<p>Estos son algunos valores de fecha relativos:</p>',
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - a\00F1os a partir de la fecha de hoy</dd>'),
'  <dt>m</dt>',
'    <dd>+ / - meses a partir de la fecha de hoy</dd>',
'  <dt>w</dt>',
'    <dd>+ / - semanas a partir de la fecha de hoy</dd>',
'  <dt>d</dt>',
unistr('    <dd>+ / - d\00EDas a partir de la fecha de hoy</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598552726329767.4412)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Fecha M\00EDnima')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MIN_AGE_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la fecha m\00EDnima que se puede introducir o seleccionar.</p>'),
unistr('<p>El valor de fecha puede ser un valor absoluto en el formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> o <code>''YYYYMMDDHH24MI''</code> o un valor relativo con respecto a la fecha de hoy, como <code>+7d</code>, o un valor din\00E1mico mediante la sintaxis de')
||unistr(' sustituci\00F3n, siempre y cuando la sustituci\00F3n devuelva el formato de fecha correcto o el valor relativo.</p>'),
'<p>Estos son algunos valores de fecha relativos:</p>',
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - a\00F1os a partir de la fecha de hoy</dd>'),
'  <dt>m</dt>',
'    <dd>+ / - meses a partir de la fecha de hoy</dd>',
'  <dt>w</dt>',
'    <dd>+ / - semanas a partir de la fecha de hoy</dd>',
'  <dt>d</dt>',
unistr('    <dd>+ / - d\00EDas a partir de la fecha de hoy</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166598957228331042.4412)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('Fecha M\00E1xima')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>255
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li><code>2009-06-25T23:11:00</code></li>',
'<li><code>200906252311</code></li>',
'<li><code>+1y+1m+1w</code></li>',
'<li><code>-1m-1w</code></li>',
'<li><code>+1m-1d</code></li>',
'<li><code>&P1_MAX_SIGNUP_DATE.</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca la fecha m\00E1xima que se puede introducir o seleccionar.</p>'),
unistr('<p>El valor de fecha puede ser un valor absoluto en el formato <code>''YYYY-MM-DDTHH24:MI:SS''</code> o <code>''YYYYMMDDHH24MI''</code>, un valor relativo con respecto a la fecha de hoy, como <code>+7d</code>, o un valor din\00E1mico mediante la sintaxis de ')
||unistr('sustituci\00F3n, siempre y cuando la sustituci\00F3n devuelva el formato de fecha correcto o el valor relativo.</p>'),
'<p>Estos son algunos valores de fecha relativos:</p>',
'<dl>',
'  <dt>y</dt>',
unistr('    <dd>+ / - a\00F1os a partir de la fecha de hoy</dd>'),
'  <dt>m</dt>',
'    <dd>+ / - meses a partir de la fecha de hoy</dd>',
'  <dt>w</dt>',
'    <dd>+ / - semanas a partir de la fecha de hoy</dd>',
'  <dt>d</dt>',
unistr('    <dd>+ / - d\00EDas a partir de la fecha de hoy</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166599961992351304.4412)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Mostrar'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'button'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione cu\00E1ndo aparece el calendario emergente del selector de fecha.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975967945937309446.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4412)
,p_display_sequence=>10
,p_display_value=>'En Foco'
,p_return_value=>'focus'
,p_help_text=>'El calendario emergente aparece en cuanto se selecciona el elemento.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968322865312246.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4412)
,p_display_sequence=>20
,p_display_value=>'Al Hacer Clic en el Icono'
,p_return_value=>'button'
,p_help_text=>'El calendario emergente aparece cuando se hace clic en el icono.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(975968729792314196.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4412)
,p_display_sequence=>30
,p_display_value=>'Ambos'
,p_return_value=>'both'
,p_help_text=>'El calendario emergente aparece en cuanto se selecciona el elemento y, posteriormente, cuando se hace clic en el icono.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(977131519506267935.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1166599961992351304.4412)
,p_display_sequence=>40
,p_display_value=>unistr('En L\00EDnea')
,p_return_value=>'inline'
,p_help_text=>unistr('El calendario aparece siempre en l\00EDnea en la p\00E1gina. No se muestra ning\00FAn campo de texto y la selecci\00F3n de fecha actual est\00E1 resaltada en el calendario.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600445500356042.4412)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Mostrar Otros Meses'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si se muestran al principio fechas del mes anterior y al final fechas del mes siguiente. Estas fechas rellenan por completo las primeras y las \00FAltimas l\00EDneas del calendario, Por ejemplo, si el primer d\00EDa de la semana es domingo y el prime')
||unistr('r d\00EDa del mes actual que se muestra cae en mi\00E9rcoles, el domingo, el lunes y el martes pertenecen a los tres \00FAltimos d\00EDas del mes anterior.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166601947494375554.4412)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('N\00FAmero de Meses')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166600445500356042.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>3</dt>',
'    <dd>Muestra tres meses horizontalmente.</dd>',
'  <dt>[2,3]</dt>',
'    <dd>Muestra seis meses, dos filas por tres columnas.</dd>',
'  <dt>[4,3]</dt>',
'    <dd>Muestra doce meses, cuatro filas por tres columnas.</dd>',
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el n\00FAmero de a\00F1os que se van a mostrar en el calendario emergente.</p>'),
unistr('<p>Puede introducir un valor entero o una matriz bidimensional utilizando <code>[<em>row,column</em>]</code>, para definir el n\00FAmero de filas y columnas que se van a mostrar</p>'),
unistr('<p><em>Nota: se muestran los meses despu\00E9s de <strong>Fecha Resaltada</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166602447625385046.4412)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Lista de Navegaci\00F3n para')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione si se incluyen listas de selecci\00F3n en el calendario emergente para Mes y/o A\00F1o.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072709337552768.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4412)
,p_display_sequence=>5
,p_display_value=>'Ninguno'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071421673546859.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4412)
,p_display_sequence=>10
,p_display_value=>'Mes'
,p_return_value=>'MONTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785071825829548006.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4412)
,p_display_sequence=>20
,p_display_value=>unistr('A\00F1o')
,p_return_value=>'YEAR'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(785072306567551978.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1166602447625385046.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Mes y A\00F1o')
,p_return_value=>'MONTH_AND_YEAR'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1166600943554364880.4412)
,p_plugin_id=>wwv_flow_api.id(1166598346362318406.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Rango de A\00F1o')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>20
,p_max_length=>50
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1166602447625385046.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'YEAR,MONTH_AND_YEAR'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'  <dt>2000:2010</dt>',
unistr('    <dd>Utiliza a\00F1os absolutos para limitar los a\00F1os permitidos a los que est\00E9n entre 2000 y 2010, inclusive.</dd>'),
'  <dt>-05:+05</dt>',
unistr('    <dd>Utiliza fechas relativas para limitar los a\00F1os permitidos a +/- cinco a\00F1os a partir del a\00F1o actual.</dd>'),
'  <dt>+01:+03</dt>',
unistr('    <dd>Utiliza fechas relativas para limitar los a\00F1os permitidos al a\00F1o siguiente para dos a\00F1os m\00E1s.</dd>'),
'</dl>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el rango de a\00F1os permitido que se muestra en la lista de selecci\00F3n <strong>A\00F1o</strong> en el calendario emergente.</p>'),
unistr('<p>El valor del a\00F1o puede ser un valor absoluto en el formato <code>''YYYY:YYYY''</code> o 	valores relativos utilizando el formato <code>''-nn:+nn''</code>, donde <code>nn</code> son valores enteros.')))
);
end;
/
prompt --application/shared_components/plugins/item_type/text_field
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230861140507488144.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'TEXT_FIELD'
,p_display_name=>'Campo de Texto'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','TEXT_FIELD'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Muestra un campo de texto.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861330595494795.4412)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Ejecutar al Pulsar Intro'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si la p\00E1gina se ejecuta autom\00E1ticamente al pulsar la tecla <em>Intro</em> mientras est\00E1 en este campo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230861822761501984.4412)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Desactivado'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Especifique si este elemento se desactiva, lo que evita que los usuarios finales cambien el valor.</p>',
unistr('<p>Se sigue mostrando un elemento de texto desactivado con el mismo formato HTML, a diferencia del tipo de elemento de <em>Solo Visualizaci\00F3n</em>, que elimina el formato HTML. Los elementos de texto desactivados forman parte del origen de p\00E1gina, qu')
||unistr('e permite evaluar el estado de su sesi\00F3n. Por el contrario, los elementos de Solo Visualizaci\00F3n no se almacenan en el estado de sesi\00F3n.</p>')))
,p_attribute_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$$ DJP  - Is this equivalent to specifying Read Only = Always?',
'If so do we need this attribute?'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230862319775510558.4412)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>40
,p_prompt=>unistr('Enviar al ejecutar p\00E1gina')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1230861822761501984.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('Especifique si el valor del elemento actual debe enviarse cuando se ejecute la p\00E1gina.')
,p_attribute_comment=>'$$$ DJP - Why can this only be set when Disabled = Y?'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2642009195904118.4412)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>10
,p_prompt=>'Subtipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Seleccione el subtipo de texto HTML5. Esto permitir\00E1 a los dispositivos con teclado en pantalla mostrar un dise\00F1o de teclado optimizado espec\00EDfico del subtipo para poder introducir los datos m\00E1s f\00E1cilmente. La selecci\00F3n de subtipo se utilizar\00E1 tambi\00E9')
||unistr('n para presentar un enlace adecuado con el valor del elemento de p\00E1gina, si se presenta como de solo lectura. El atributo no cambia el elemento de texto o la entrada de datos cuando se utiliza un teclado f\00EDsico.'),
'</p>',
unistr('<p><strong><em>Nota:</strong> esta funci\00F3n HTML5 solo funciona con los exploradores modernos. Los exploradores antiguos, no compatibles con HTML5, ignoran este atributo y presentan el elemento de p\00E1gina como un campo de texto normal.</em></p>')))
,p_attribute_comment=>'$$$ DJP - Shouldn''t this be for Mobile UI only?'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4337919498933328.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4412)
,p_display_sequence=>5
,p_display_value=>'Texto'
,p_return_value=>'TEXT'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643201361911326.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Correo Electr\00F3nico')
,p_return_value=>'EMAIL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2643606901912900.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4412)
,p_display_sequence=>20
,p_display_value=>unistr('N\00FAmero de Tel\00E9fono')
,p_return_value=>'TEL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(228427524363055714.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4412)
,p_display_sequence=>25
,p_display_value=>'Buscar'
,p_return_value=>'SEARCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2644810018913786.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2642009195904118.4412)
,p_display_sequence=>30
,p_display_value=>'URL'
,p_return_value=>'URL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(362145212820086745.4412)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>15
,p_prompt=>'Recortar Espacios'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_default_value=>'BOTH'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione la forma en que se recorta el valor del elemento despu\00E9s de ejecutar la p\00E1gina. Este valor sirve para recortar espacios, tabulaciones y nuevas l\00EDneas del texto introducido.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145508722088644.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4412)
,p_display_sequence=>10
,p_display_value=>'Inicial'
,p_return_value=>'LEADING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362145906566089618.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4412)
,p_display_sequence=>20
,p_display_value=>'Final'
,p_return_value=>'TRAILING'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362146304625090506.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4412)
,p_display_sequence=>30
,p_display_value=>'Inicial y Final'
,p_return_value=>'BOTH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(362147027041095284.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(362145212820086745.4412)
,p_display_sequence=>40
,p_display_value=>'Ninguno'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(580485075516965313.4412)
,p_plugin_id=>wwv_flow_api.id(1230861140507488144.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>16
,p_prompt=>unistr('May\00FAsculas/Min\00FAsculas de Texto')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Sin Cambios'
,p_help_text=>unistr('Seleccione la forma en que se transforman las may\00FAsculas/min\00FAsculas del texto del valor del elemento.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485397894966793.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Min\00FAsculas')
,p_return_value=>'LOWER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(580485762023967520.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(580485075516965313.4412)
,p_display_sequence=>20
,p_display_value=>unistr('May\00FAsculas')
,p_return_value=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/item_type/hidden
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1230888011377927220.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'HIDDEN'
,p_display_name=>'Oculto'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','HIDDEN'),'')
,p_api_version=>1
,p_standard_attributes=>'SOURCE:ENCRYPT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>unistr('Los elementos que se incluyen en el origen de p\00E1gina, pero que no se presentan. Los valores de los elementos ocultos se guardan en el estado de la sesi\00F3n. Normalmente, se utilizan para almacenar los valores que necesita el procesamiento de p\00E1ginas u ')
||unistr('otros elementos de p\00E1gina, pero no se deben mostrar al usuario final.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1230888530209942193.4412)
,p_plugin_id=>wwv_flow_api.id(1230888011377927220.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valor Protegido'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si el elemento se protege, lo que evita que el valor se manipule cuando se publica la p\00E1gina.')
);
end;
/
prompt --application/shared_components/plugins/item_type/display_image
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1411721528366264478.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_IMAGE'
,p_display_name=>'Mostrar Imagen'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_IMAGE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Muestra una imagen almacenada en columnas BLOB de una base de datos o basada en una URL de imagen.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411722225512282537.4412)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Basado en'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'DB_COLUMN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Seleccione el lugar del que se recupera la imagen.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411722839364286570.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4412)
,p_display_sequence=>10
,p_display_value=>unistr('URL de Imagen Almacenada en Valor de Elemento de P\00E1gina')
,p_return_value=>'URL'
,p_help_text=>unistr('Se lee la URL de imagen de los valores almacenados en el estado de sesi\00F3n para el elemento de p\00E1gina especificado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1411723213999298173.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4412)
,p_display_sequence=>20
,p_display_value=>'Columna BLOB Especificada en Origen del Elemento'
,p_return_value=>'DB_COLUMN'
,p_help_text=>'Lee la imagen de la columna BLOB especificada en el atributo <strong>Origen del Elemento</strong>.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(967663732298251689.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1411722225512282537.4412)
,p_display_sequence=>30
,p_display_value=>'Columna BLOB Devuelta por Sentencia SQL'
,p_return_value=>'SQL'
,p_help_text=>unistr('Muestra la imagen seg\00FAn la columna BLOB que devuelve la sentencia SQL especificada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411726413054354627.4412)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Texto Alternativo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_help_text=>'Introduzca el texto que leen los lectores de pantalla cuando un usuario final navega a este elemento.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(483911502060080155.4412)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Columna de Texto Alternativo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Introduzca el nombre del elemento de aplicaci\00F3n o p\00E1gina que contiene el texto alternativo de esta imagen. Los lectores de pantalla leen este texto cuando un usuario final navega hasta este elemento.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725016255336668.4412)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Columna de Nombre de Archivo'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Introduzca el nombre del elemento de aplicaci\00F3n o p\00E1gina en may\00FAsculas que contiene el valor de columna del nombre de archivo asociado a la columna BLOB.')
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1411725531492341063.4412)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>60
,p_prompt=>unistr('\00DAltima Columna BLOB Actualizada')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el nombre del elemento de aplicaci\00F3n o p\00E1gina en may\00FAsculas que contiene el valor de columna de fecha cuando se actualiz\00F3 por \00FAltima vez el BLOB asociado.</p>'),
unistr('<p>Este valor se utiliza para el almacenamiento en cach\00E9 del explorador y para identificar si la imagen ha cambiado desde la \00FAltima solicitud del explorador. Si la imagen no se actualiza, la imagen se recupera de la cach\00E9 del explorador si est\00E1 dispo')
||'nible.</p>'))
,p_attribute_comment=>'$$$ DJP - Why isn''t this an ITEM Popup LOV'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(967666433253270876.4412)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>70
,p_prompt=>'Sentencia SQL'
,p_attribute_type=>'SQL'
,p_is_required=>true
,p_sql_min_column_count=>1
,p_sql_max_column_count=>4
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select product_image,',
'       product_name as alt_text,',
'       filename,',
'       mimetype',
'  from demo_product_info',
' where product_id = :P6_PRODUCT_ID',
'</pre>'))
,p_help_text=>'Introduzca la sentencia SQL que devuelve la columna BLOB que contiene la imagen.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(91302656605713331.4412)
,p_plugin_id=>wwv_flow_api.id(1411721528366264478.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>50
,p_prompt=>'Columna de Tipo MIME'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>30
,p_max_length=>128
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1411722225512282537.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'DB_COLUMN'
,p_help_text=>unistr('Introduzca el nombre del elemento de aplicaci\00F3n o p\00E1gina en may\00FAsculas que se utilice para almacenar el tipo mime del archivo cargado. El explorador utiliza el tipo mime para identificar la aplicaci\00F3n que se utiliza para ver el contenido BLOB cuando ')
||'se descarga el archivo.'
);
end;
/
prompt --application/shared_components/plugins/item_type/auto_complete
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1446346919506821055.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'AUTO_COMPLETE'
,p_display_name=>unistr('Campo de Texto con Terminaci\00F3n Autom\00E1tica')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','AUTO_COMPLETE'),'')
,p_javascript_file_urls=>'[require jet]#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.inputSearch#MIN#.js'
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_validation_function=>'dummy'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:CASCADING_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un campo de texto que presenta una lista de posibles valores basados en el texto que ya ha introducido el usuario final, en l\00EDnea con el elemento de texto. La lista se acota a\00FAn m\00E1s cuando el usuario final introduce m\00E1s texto.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446356110531045518.4412)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Buscar'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONTAINS_IGNORE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione c\00F3mo se realiza la b\00FAsqueda en el valor introducido. Si utiliza <em>Carga Lenta</em>, este valor puede influir en el rendimiento de las consultas.</p>'),
unistr('<p><em>Nota: si se selecciona <strong>Contiene y Sensible a May\00FAsculas/Min\00FAsculas</strong> o <strong>Contiene e Ignorar May\00FAsculas/Min\00FAsculas</strong>, se evita el uso de \00EDndices de columna.</em></p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406465150066557.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Contiene y Sensible a May\00FAsculas/Min\00FAsculas')
,p_return_value=>'CONTAINS_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406557760066557.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Exacto y Sensible a May\00FAsculas/Min\00FAsculas')
,p_return_value=>'EXACT_CASE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406651197066557.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Contiene e Ignorar May\00FAsculas/Min\00FAsculas')
,p_return_value=>'CONTAINS_IGNORE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1097406756688066558.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1446356110531045518.4412)
,p_display_sequence=>40
,p_display_value=>unistr('Exacto e Ignorar May\00FAsculas/Min\00FAsculas')
,p_return_value=>'EXACT_IGNORE'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446360005383072413.4412)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Carga Lenta'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si los valores coincidentes se recuperan de la base de datos mediante t\00E9cnicas de <em>Carga Lenta</em>. La carga lenta recupera registros coincidentes de la base de datos cada vez que el usuario escribe un car\00E1cter. De lo contrario, el')
||unistr(' resto de los valores de lista se cargan al cargar la p\00E1gina.</p>'),
unistr('<p>Oracle recomienda utilizar la <em>Carga Lenta</em> si tiene una larga lista de selecci\00F3n, porque la carga de un gran n\00FAmero de registros puede afectar al tiempo que se tarda en cargar inicialmente la p\00E1gina.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1446361019928076629.4412)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Valores M\00E1ximos en Lista')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el n\00FAmero m\00E1ximo de elementos que se van a visualizar en el cuadro de selecci\00F3n.</p> '),
unistr('<p>Este valor puede ayudar a evitar problemas de rendimiento al devolver demasiadas filas y tambi\00E9n a evitar un juego de retorno muy grande cuando solo se han introducido unas pocas letras.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(224532777127157782.4412)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('B\00FAsqueda m\00EDnima')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_show_in_wizard=>false
,p_unit=>'caracteres'
,p_is_translatable=>false
,p_help_text=>unistr('<p>Especifique el n\00FAmero m\00EDnimo de caracteres que se deben introducir antes de ejecutar una b\00FAsqueda.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(388196560996701804.4412)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>45
,p_prompt=>unistr('Cach\00E9')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1446360005383072413.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>unistr('<p>Especifique si los resultados de b\00FAsqueda se almacenan en cach\00E9 al utilizar la carga lenta para recuperar registros coincidentes.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845152901732834477.4412)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4412)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
unistr('<dt>Mostrar y almacenar el mismo valor en el elemento de p\00E1gina</dt>'),
'<dd><pre>',
'select ename',
'  from emp',
' order by 1',
'</pre></dd>',
'<dt>Mostrar los empleados de un departamento concreto mediante una variable de enlace</dt>',
'<dd><pre>',
'select ename',
'  from emp',
' where deptno = :P3_DEPTNO',
' order by 1',
'</pre>',
unistr('<p>Nota: defina el atributo <em>Elementos Principales de Lista de Valores en Cascada</em> en <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> es un elemento de p\00E1gina modificable en la misma p\00E1gina.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(345454551021287898.4412)
,p_plugin_id=>wwv_flow_api.id(1446346919506821055.4412)
,p_name=>'ojupdate'
,p_display_name=>'Actualizar'
);
end;
/
prompt --application/shared_components/plugins/item_type/rich_text_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1630055805138100682.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RICH_TEXT_EDITOR'
,p_display_name=>'Editor de Texto Enriquecido'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RICH_TEXT_EDITOR'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:PLACEHOLDER:ENCRYPT:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un \00E1rea de texto con opciones de formato de texto completas. Los usuarios finales pueden mejorar el contenido mostrado de una forma similar al uso de un procesador de texto como Microsoft Word. Los usuarios finales tambi\00E9n pueden <em>cortar y')
||unistr(' pegar</em> en este elemento documentos que est\00E1n en el formato de archivo RTF (formato de texto enriquecido).')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1343844517421090812.4412)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Ajustable [en desuso]'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si el editor de texto enriquecido debe ajustarse autom\00E1ticamente al tama\00F1o de la regi\00F3n de contenedor. Esto requiere que la aplicaci\00F3n utilice Tema universal u otro tema ajustable.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630056002845109474.4412)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Barra de Herramientas'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'Intermediate'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(635934396859331517.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'HTML'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione el n\00FAmero de opciones de formato de texto disponibles en el editor.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056586699114299.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4412)
,p_display_sequence=>10
,p_display_value=>unistr('B\00E1sico')
,p_return_value=>'Basic'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1263397500002270668.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4412)
,p_display_sequence=>20
,p_display_value=>'Intermedio'
,p_return_value=>'Intermediate'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630056989123115033.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1630056002845109474.4412)
,p_display_sequence=>30
,p_display_value=>'Completo'
,p_return_value=>'Full'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630057694103125908.4412)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Barra de Herramientas Ampliada'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_help_text=>unistr('Especifique si el editor se ampl\00EDa inicialmente en el \00E1rea de texto.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1630058192849134992.4412)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('M\00E1scara')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione la m\00E1scara del editor que se utiliza para aplicar estilo al editor.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630058796312136026.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4412)
,p_display_sequence=>1
,p_display_value=>'Moono'
,p_return_value=>'moono'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1637507209047437360.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4412)
,p_display_sequence=>2
,p_display_value=>'Color Moono'
,p_return_value=>'moonocolor'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1630059200467137193.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1630058192849134992.4412)
,p_display_sequence=>3
,p_display_value=>'Kama'
,p_return_value=>'kama'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1270283182212293963.4412)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>unistr('Posici\00F3n de Barra de Herramientas')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'top'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1262285287257225297.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique el lugar del \00E1rea de texto en el que se muestra el editor.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283477898295997.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4412)
,p_display_sequence=>10
,p_display_value=>'Primero'
,p_return_value=>'top'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1270283876173296808.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1270283182212293963.4412)
,p_display_sequence=>20
,p_display_value=>unistr('\00DAltimo')
,p_return_value=>'bottom'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262285287257225297.4412)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>unistr('Versi\00F3n')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'CK Editor 5'
,p_deprecated_values=>'4'
,p_help_text=>unistr('<p>CKEditor 4 est\00E1 en desuso y pronto ser\00E1 reemplazado por CKEditor 5. Es una buena idea hacer este cambio ahora, para no arriesgarse a que la aplicaci\00F3n falle en futuras versiones. Si ha usado alg\00FAn c\00F3digo Javascript de inicializaci\00F3n personalizado,')
||unistr(' tenga en cuenta que la API de CKEditor ha cambiado y lo m\00E1s probable es que deba modificarse el c\00F3digo.</p>')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1262285918525227088.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1262285287257225297.4412)
,p_display_sequence=>10
,p_display_value=>'CK Editor 4 [En desuso]'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262287152809234036.4412)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Altura m\00EDnima')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_default_value=>'180'
,p_display_length=>100
,p_unit=>unistr('p\00EDxeles')
,p_is_translatable=>false
,p_help_text=>unistr('Establezca la altura m\00EDnima en p\00EDxeles del \00E1rea editable.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1262288044006238954.4412)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>unistr('Altura M\00E1xima')
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>100
,p_unit=>unistr('p\00EDxeles')
,p_is_translatable=>false
,p_help_text=>unistr('Establezca la altura m\00E1xima en p\00EDxeles del \00E1rea editable. Si este atributo se queda vac\00EDo, el editor aumentar\00E1 ilimitadamente a medida que se escribe.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(635934396859331517.4412)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>1
,p_prompt=>'Formato'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MARKDOWN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Especifique el formato de salida para el contenido introducido en el editor de texto enriquecido.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635934864536336814.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4412)
,p_display_sequence=>10
,p_display_value=>'HTML'
,p_return_value=>'HTML'
,p_help_text=>'Utilice HTML para el origen y la salida de este editor de texto enriquecido.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(635935286305339196.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(635934396859331517.4412)
,p_display_sequence=>20
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
,p_help_text=>'Utilice el formato Markdown para el origen y la salida de este editor de texto enriquecido.'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(3112575602612766963.4412)
,p_plugin_id=>wwv_flow_api.id(1630055805138100682.4412)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'function(options){',
unistr('    // desactivar la funci\00F3n Formato autom\00E1tico'),
'    options.editorOptions.removePlugins.push(''Autoformat'');',
'    // aplicar una barra de herramientas personalizada',
'    options.editorOptions.toolbar = [',
'        ''heading'', ''bulletedList'', ''numberedList'', ''fontSize'', ''undo'', ''redo''',
'    ];',
'    return options;',
'}',
'</pre>'))
,p_help_text=>unistr('Introduzca una funci\00F3n JavaScript para sustituir la configuraci\00F3n del editor est\00E1ndar. Las opciones espec\00EDficas de CKEditor5 deben aplicarse a <code>options.editorOptions</code>. Consulte los documentos sobre la API de CKEditor5 para obtener m\00E1s info')
||unistr('rmaci\00F3n.')
);
end;
/
prompt --application/shared_components/plugins/item_type/color_picker
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COLOR_PICKER'
,p_display_name=>'Selector de Color'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COLOR_PICKER'),'')
,p_css_file_urls=>'#JET_CSS_DIRECTORY#redwood/oj-redwood-notag-min.css'
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Permite a los usuarios seleccionar o introducir un color. Se pueden seleccionar colores de un espectro de colores.'
,p_version_identifier=>'2.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550403250259918560.4412)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_prompt=>'Modo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551367544301244965.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione la cantidad de informaci\00F3n que se muestra en el selector de color.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550403921767922285.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4412)
,p_display_sequence=>10
,p_display_value=>'Simple'
,p_return_value=>'SIMPLE'
,p_help_text=>'Muestra solo los controles del espectro de color y los valores predefinidos de color si se ha definido alguno.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550404269414923460.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(550403250259918560.4412)
,p_display_sequence=>20
,p_display_value=>'Completo'
,p_return_value=>'FULL'
,p_help_text=>unistr('Muestra los campos adicionales para ver o introducir colores como valores hexadecimales, HSL o RGB con valores alfa opcionales en funci\00F3n de la configuraci\00F3n de Devolver valor como. Tambi\00E9n muestra los colores iniciales y actuales.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551367544301244965.4412)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_prompt=>'Mostrar como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione el m\00E9todo de visualizaci\00F3n del selector de color.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368003116247557.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4412)
,p_display_sequence=>10
,p_display_value=>'Emergente'
,p_return_value=>'POPUP'
,p_help_text=>'Se puede introducir un color en el campo de texto o elegirse en el selector de color emergente.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368367822248327.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4412)
,p_display_sequence=>20
,p_display_value=>unistr('En L\00EDnea')
,p_return_value=>'INLINE'
,p_help_text=>unistr('Se muestra un selector de color en l\00EDnea.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551368820390249888.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4412)
,p_display_sequence=>30
,p_display_value=>'Ventana emergente de solo color'
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('Un bot\00F3n abre un selector de color emergente.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551469948272853196.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(551367544301244965.4412)
,p_display_sequence=>40
,p_display_value=>'Selector de color nativo'
,p_return_value=>'NATIVE'
,p_help_text=>'Entrada de color de explorador nativa. La interfaz del usuario depende del explorador.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(630450561726642679.4412)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Usar Valores por Defecto'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Indica si se van a usar los valores por defecto definidos para este componente en Componentes compartidos > Valores de componente o unos valores personalizados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550407832783006227.4412)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>30
,p_prompt=>'Modo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FULL'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Seleccione la cantidad de informaci\00F3n que se muestra en el selector de color.</p>'),
unistr('<p>Tenga en cuenta que esto no se aplica cuando Mostrar como est\00E1 definido en Selector de color nativo.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408418705007375.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4412)
,p_display_sequence=>10
,p_display_value=>'Simple'
,p_return_value=>'SIMPLE'
,p_help_text=>'Muestra solo los controles del espectro de color y los valores predefinidos de color si se ha definido alguno.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550408900996015864.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(550407832783006227.4412)
,p_display_sequence=>20
,p_display_value=>'Completo'
,p_return_value=>'FULL'
,p_help_text=>unistr('Muestra los campos adicionales para ver o introducir colores como valores hexadecimales, HSL o RGB con valores alfa opcionales en funci\00F3n de la configuraci\00F3n de Devolver valor como. Tambi\00E9n muestra los colores iniciales y actuales.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(550764493023397466.4412)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>20
,p_prompt=>'Mostrar como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(630450561726642679.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione el m\00E9todo de visualizaci\00F3n del selector de color.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765244915400562.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4412)
,p_display_sequence=>10
,p_display_value=>'Emergente'
,p_return_value=>'POPUP'
,p_help_text=>'Se puede introducir un color en el campo de texto o elegirse en el selector de color emergente.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550764781445398986.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4412)
,p_display_sequence=>20
,p_display_value=>unistr('En L\00EDnea')
,p_return_value=>'INLINE'
,p_help_text=>unistr('Se muestra un selector de color en l\00EDnea.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(550765575345402504.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4412)
,p_display_sequence=>30
,p_display_value=>'Ventana emergente de solo color'
,p_return_value=>'COLOR_ONLY'
,p_help_text=>unistr('Un bot\00F3n abre un selector de color emergente.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551473676631880984.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(550764493023397466.4412)
,p_display_sequence=>40
,p_display_value=>'Selector de color nativo'
,p_return_value=>'NATIVE'
,p_help_text=>'Entrada de color de explorador nativa. La interfaz del usuario depende del explorador.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551688608315986495.4412)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Valor predefinido de color'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'THEME_STYLE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione si el selector de color debe mostrar un juego de colores predefinidos y, en caso de ser as\00ED, si proceden del tema o son personalizados.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689124385987538.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4412)
,p_display_sequence=>10
,p_display_value=>'Ninguno'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689545726989556.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4412)
,p_display_sequence=>20
,p_display_value=>'Colores de estilo de tema'
,p_return_value=>'THEME_STYLE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551689930702991102.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(551688608315986495.4412)
,p_display_sequence=>30
,p_display_value=>'Colores Personalizados'
,p_return_value=>'CUSTOM'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690436138997704.4412)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Colores'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551688608315986495.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'CUSTOM'
,p_examples=>'#FF0000;#00FF00;#0000FF;rgb(27,204,119)'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Lista de colores predefinidos que se deben mostrar en el cuadro de di\00E1logo del selector de color.'),
'Separe los colores con puntos y comas.'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551690938640005057.4412)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Contraste con'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permite comparar el color de este elemento con el color de otro elemento o un valor est\00E1tico y mostrar la ratio de contraste entre ellos en la interfaz de usuario del selector de color.  '),
'Esto puede permitir al usuario seleccionar colores que tengan suficiente contraste como para que todos puedan acceder a ellos.'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691368715005731.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4412)
,p_display_sequence=>10
,p_display_value=>'Ninguno'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551691786900007756.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Elemento de P\00E1gina')
,p_return_value=>'PAGE_ITEM'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(551692243251008710.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(551690938640005057.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Color est\00E1tico')
,p_return_value=>'STATIC'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551692721781014969.4412)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Elemento de contraste'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>unistr('Elemento que se va a utilizar para la comparaci\00F3n de contraste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(551693186879019659.4412)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Color de contraste'
,p_attribute_type=>'COLOR'
,p_is_required=>true
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(551690938640005057.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'STATIC'
,p_help_text=>unistr('Color que se va a utilizar para la comparaci\00F3n de contraste.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(549148889210907047.4412)
,p_plugin_id=>wwv_flow_api.id(1779772489424311086.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Devolver valor como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'HEX'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(550764493023397466.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_EQUALS'
,p_depending_on_expression=>'NATIVE'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique el formato del valor de color que devuelve este elemento. Incluso aunque el color se introduzca con otro formato v\00E1lido distinto, se presentar\00E1, devolver\00E1 y enviar\00E1 al servidor con este formato.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149330423908665.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4412)
,p_display_sequence=>10
,p_display_value=>'Hex'
,p_return_value=>'HEX'
,p_help_text=>unistr('Valor de color hexadecimal. No se permite ning\00FAn valor alfa. Por ejemplo, #2244ee')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549149780463910228.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4412)
,p_display_sequence=>20
,p_display_value=>'rgb'
,p_return_value=>'RGB'
,p_help_text=>unistr('Rojo, verde, azul en notaci\00F3n de funci\00F3n rgb. Ejemplo: rgb(34,68,238)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549320695805038594.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4412)
,p_display_sequence=>30
,p_display_value=>'rgb/rgba'
,p_return_value=>'RGBA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Rojo, verde, azul con alfa (transparencia) opcional en notaci\00F3n de funci\00F3n rgb/rgba.'),
unistr('Si el color no tiene ning\00FAn alfa (alfa igual a 1), se utiliza un formato rgb.'),
'Si el color tiene un alfa, se utiliza un formato rgba.',
'Ejemplo: rgba(34,68,238,0.5)'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549150182877911677.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4412)
,p_display_sequence=>40
,p_display_value=>'hsl'
,p_return_value=>'HSL'
,p_help_text=>unistr('Matiz, saturaci\00F3n e iluminaci\00F3n en notaci\00F3n de funci\00F3n hsl. Ejemplo: hsl(230,86,53)')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321101724039553.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4412)
,p_display_sequence=>50
,p_display_value=>'hsl/hsla'
,p_return_value=>'HSLA'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Matiz, saturaci\00F3n y luminosidad con alfa (transparencia) opcional en notaci\00F3n de funci\00F3n hsl/hsla. '),
unistr('Si el color no tiene ning\00FAn alfa (alfa igual a 1), se utiliza un formato hsl.'),
'Si el color tiene un alfa, se utiliza un formato hsla.',
'Ejemplo: hsla(230,86,53,0.5)'))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(549321450357041193.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(549148889210907047.4412)
,p_display_sequence=>60
,p_display_value=>'Cualquier valor CSS'
,p_return_value=>'CSS'
,p_help_text=>unistr('Cualquier formato de color CSS v\00E1lido, incluidos los nombres de colores o una variable CSS.')
);
end;
/
prompt --application/shared_components/plugins/item_type/popup_lov
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'POPUP_LOV'
,p_display_name=>'Lista de Valores Emergente'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','POPUP_LOV'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:WIDTH:PLACEHOLDER:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Muestra un elemento de texto con un icono de lista de valores emergente. Cuando el usuario final hace clic en el icono, se abre una ventana emergente con un campo de b\00FAsqueda y una lista de valores soportados.</p>'),
unistr('<p>Las listas de valores emergentes son perfectas para listas largas porque los usuarios finales pueden introducir criterios de b\00FAsqueda para reducir los valores disponibles que se muestran. Para listas relativamente peque\00F1as, suele ser mejor <em>Sel')
||'eccionar Lista</em>.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800068983311222289.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mostrar como'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'POPUP'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione c\00F3mo se mostrar\00E1 la lista de valores emergente.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069590238224258.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Cuadro de Di\00E1logo Modal')
,p_return_value=>'DIALOG'
,p_help_text=>unistr('La lista de valores se mostrar\00E1 en un cuadro de di\00E1logo modal.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800069993701225262.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1800068983311222289.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Ventana emergente en l\00EDnea')
,p_return_value=>'POPUP'
,p_help_text=>unistr('La lista de valores se mostrar\00E1 en una ventana emergente en l\00EDnea en el campo.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1800067187898204706.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Recuperaci\00F3n inicial')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'FIRST_ROWSET'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione la forma en la que se recuperan los datos inicialmente en la lista de valores. Esto solo se aplica la primera vez que se abre la ventana emergente despu\00E9s de que la p\00E1gina se cargue o el elemento se refresque, por ejemplo, debido una casca')
||unistr('da. Consulte tambi\00E9n los caracteres m\00EDnimos del atributo.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800067791014205587.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4412)
,p_display_sequence=>10
,p_display_value=>unistr('A petici\00F3n del usuario')
,p_return_value=>'NO_FETCH'
,p_help_text=>unistr('Al principio, no se recuperar\00E1 ninguna lista de valores hasta que el usuario realice una b\00FAsqueda con o sin un t\00E9rmino de b\00FAsqueda.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068204174209405.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Autom\00E1tico')
,p_return_value=>'FIRST_ROWSET'
,p_help_text=>unistr('Recupere al principio una lista de valores sin un t\00E9rmino de b\00FAsqueda.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1800068585605213520.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1800067187898204706.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Autom\00E1tico con valor actual')
,p_return_value=>'FIRST_ROWSET_FILTER'
,p_help_text=>unistr('Recupere al principio una lista de valores con un valor actual como t\00E9rmino de b\00FAsqueda.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(828501710103102611.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Varios Valores'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Especifique si este elemento puede tener varios valores o un solo valor. Si son varios valores, se devuelven en una lista separada por comas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037093113159140.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Entrada Manual'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Seleccione si se permite o no la entrada manual. Si el valor es S\00ED, el usuario puede seleccionar los valores existentes en la lista de valores emergente o introducir un valor manualmente. Es similar a un cuadro combinado. Si el valor es No, el usuari')
||unistr('o solo podr\00E1 seleccionar los valores de la lista de valores emergente. Es similar a una lista de selecci\00F3n. Cuando se permite la entrada manual, es el valor de retorno de la lista de valores correspondiente lo que se debe introducir.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037383318177266.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Buscar al escribir'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>unistr('Si se selecciona S\00ED, la lista de valores se filtra a medida que se escribe en el campo de b\00FAsqueda. Cuando se selecciona No, la lista de valores no se filtra hasta que el usuario presiona Intro o el bot\00F3n del icono Buscar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9037699825192444.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>unistr('M\00EDnimo de caracteres')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'0'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(9037383318177266.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Especifique el n\00FAmero m\00EDnimo de caracteres necesario para el t\00E9rmino de b\00FAsqueda antes de que la lista de valores recupere los resultados. Puede ser de utilidad para reducir la cantidad de b\00FAsquedas realizadas en caso de que las consultas de la lista')
||unistr(' de valores sean costosas. Todos los valores de visualizaci\00F3n de la lista deben ser m\00E1s largos que el m\00EDnimo. De no ser as\00ED, no se podr\00E1n encontrar.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9037973825195793.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4412)
,p_display_sequence=>10
,p_display_value=>unistr('Sin M\00EDnimo (0)')
,p_return_value=>'0'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038300277196807.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4412)
,p_display_sequence=>20
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9038738010197706.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4412)
,p_display_sequence=>30
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039143176198691.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4412)
,p_display_sequence=>40
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039528380199625.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4412)
,p_display_sequence=>50
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(9039968403200723.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(9037699825192444.4412)
,p_display_sequence=>60
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040583894241082.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('T\00EDtulo')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>unistr('El t\00EDtulo del cuadro de di\00E1logo emergente. Si est\00E1 en blanco, se utilizar\00E1 el t\00EDtulo por defecto.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9040894549248059.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Ancho de ventana emergente'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('La anchura de la ventana emergente. Si est\00E1 en blanco, se utilizar\00E1 la anchura por defecto.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041180669256760.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Altura de ventana emergente'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_unit=>'px'
,p_is_translatable=>false
,p_help_text=>unistr('La altura de la ventana emergente. Si est\00E1 en blanco, se utilizar\00E1 la altura por defecto.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(9041484550137059.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Salidas adicionales'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>'COL1:P1_ITEM1,COL2:P1_ITEM2'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Devuelva las columnas adicionales de la lista de valores a otros elementos de p\00E1gina y columnas de cuadr\00EDcula interactiva. Defina una asignaci\00F3n del nombre de columna de la lista de valores, para el nombre de elemento de p\00E1gina o el ID est\00E1tico de')
||unistr(' columna de cuadr\00EDcula interactiva.</p>'),
unistr('<p>Nota: Solo se aplica si la definici\00F3n de la lista de valores incluye columnas adicionales.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(311784600505681020.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>35
,p_prompt=>'Separador'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>':'
,p_display_length=>10
,p_max_length=>10
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(828501710103102611.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(9034124600967605.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function(options) {',
'    options.resizable = false;',
'    return options;',
'}',
'</pre>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca una funci\00F3n JavaScript que tome un objeto de opciones del elemento de lista de valores emergente, modifique el objeto y lo devuelva. Esto permite la personalizaci\00F3n avanzada del cuadro de di\00E1logo del elemento de lista de valores emergen')
||unistr('te y su contenido durante la inicializaci\00F3n.</p>'),
'',
'<p>Las opciones siguientes se pasan al widget <code>popup</code> o al widget <code>dialog</code> de la interfaz de usuario de jQuery:<br>',
'draggable, resizable, width, height, minWidth, minHeight, maxWidth y maxHeight<br>',
unistr('Consulte la documentaci\00F3n del widget del cuadro de di\00E1logo de la interfaz de usuario de JQuery UI para obtener m\00E1s informaci\00F3n.</p>'),
'',
unistr('<p>Cuando los resultados se muestran en una lista simple, la opci\00F3n <code>defaultIconListOptions</code> es un objeto que se pasa al widget <code>tableModelView</code>. Consulte la documentaci\00F3n del widget APEX tableModelView para conocer las opciones')
||' disponibles.</p>',
'',
unistr('<p>Cuando los resultados se muestran en una cuadr\00EDcula, la opci\00F3n <code>defaultGridOptions</code> es un objeto que se pasa al widget <code>grid</code>.'),
unistr('Consulte la documentaci\00F3n del widget APEX grid para conocer las opciones disponibles.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153088232834479.4412)
,p_plugin_id=>wwv_flow_api.id(1800066898109169760.4412)
,p_name=>'LOV'
,p_sql_min_column_count=>1
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores basada en consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores con el mismo valor de retorno y visualizaci\00F3n</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Nota: al seleccionar la misma columna para los valores de retorno y visualizaci\00F3n, utilice un alias de columna.</p>'),
'</dd>',
'<dt>Lista de valores con variable de enlace</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: defina el atributo <em>Elementos Principales de Lista de Valores en Cascada</em> en <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> es un elemento de p\00E1gina modificable en la misma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/execute_plsql_code
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(1811565602388283608.4412)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'EXECUTE_PLSQL_CODE'
,p_display_name=>unistr('Ejecutar c\00F3digo del lado del servidor')
,p_category=>'EXECUTE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','EXECUTE_PLSQL_CODE'),'')
,p_api_version=>1
,p_standard_attributes=>'STOP_EXECUTION_ON_ERROR:WAIT_FOR_RESULT'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Ejecuta c\00F3digo en el servidor.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811566513386305684.4412)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('C\00F3digo PL/SQL')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>Aumenta el salario en un 3 % para aquellos empleados que est\00E1n cualificados para un aumento:</dt>'),
'<dd><pre>',
'begin',
'    for l_emp ( select empno',
'                  from emp',
'                 where deptno = :P2_DEPTNO )',
'    loop',
'        if needs_salary_raise( l_empno.empno ) then',
'            update emp',
'               set sal = sal * 1.03',
'             where empno = l_emp.empno;',
'        end if;',
'    end loop;',
'end;',
'</pre></dd>',
'</dl>',
'<p>En este ejemplo, es necesario introducir <code>P2_DEPTNO</code> en <strong>Elementos a subir</strong>.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique un bloque an\00F3nimo PL/SQL de solo ejecuci\00F3n que se ejecutar\00E1 en el servidor.</p>'),
unistr('<p>Puede hacer referencia a otros elementos de aplicaci\00F3n o p\00E1gina en la aplicaci\00F3n mediante la sintaxis de enlace (por ejemplo <code>:P1_MY_ITEM</code>). Todos los elementos a los que se hace referencia se deben incluir tambi\00E9n en <strong>Elementos ')
||unistr('de P\00E1gina que Ejecutar</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700703882467720.4412)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>11
,p_prompt=>unistr('C\00F3digo JavaScript')
,p_attribute_type=>'MLE JAVASCRIPT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2700405449462251.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'JAVASCRIPT'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<dl><dt>Aumenta el salario en un 3 % para aquellos empleados que est\00E1n cualificados para un aumento:</dt>'),
'<dd><pre>',
'var rows;',
'function needsSalaryRaise( empno ) {',
unistr('  // marcador de posici\00F3n para una l\00F3gica complicada para calcular si el empleado necesita un aumento'),
'  return true;',
'}',
'rows = apex.conn.execute( "select empno from emp where deptno = :deptno", { deptno: apex.env.P2_DEPTNO } ).rows;',
'for ( var row of rows ) {',
'  if ( needsSalaryRaise( row.EMPNO )) {',
'    apex.conn.execute( "update emp set sal = sal * 1.03 where empno = :empno", { empno: row.EMPNO } );',
'  }',
'}',
'</pre></dd>',
'</dl>',
'<p>En este ejemplo, es necesario introducir <code>P2_DEPTNO</code> en <strong>Elementos a enviar</strong>.</p>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique un bloque JavaScript de solo ejecuci\00F3n que se ejecutar\00E1 en el servidor.</p>'),
unistr('<p>Puede hacer referencia a otros elementos de aplicaci\00F3n o p\00E1gina en la aplicaci\00F3n mediante la sintaxis de enlace (por ejemplo, <code>apex.env.P1_MY_ITEM</code>). Todos los elementos a los que se hace referencia se deben incluir tambi\00E9n en <strong>E')
||unistr('lementos de p\00E1gina que ejecutar</strong>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1811567115248315739.4412)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Elementos a Ejecutar'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca los elementos de p\00E1gina en may\00FAsculas enviados al servidor y, por lo tanto, disponibles para su uso en el <strong>C\00F3digo PL/SQL</strong>.</p>'),
'<p>Puede escribir el nombre del elemento o elegirlo en una lista de elementos disponibles.',
'Si lo elige en la lista y ya se ha introducido texto, se coloca una coma al final del texto existente seguido del nombre del elemento devuelto de la lista.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(888122401495541038.4412)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Elementos para Devolver'
,p_attribute_type=>'PAGE ITEMS'
,p_is_required=>false
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'    apex_util.set_session_state(''P1_MY_ITEM'', ''Nuevo Valor'');',
'</pre>',
'</p>',
unistr('<p>En este ejemplo, introduzca <code>P1_MY_ITEM</code> en este atributo para que se muestre ''Nuevo Valor'' en ese elemento de la p\00E1gina.</p>')))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca los elementos de p\00E1gina en may\00FAsculas definidos cuando se devuelva la llamada al servidor, en funci\00F3n de su valor actual en el estado de sesi\00F3n. Si el <strong>C\00F3digo PL/SQL</strong>define uno o varios valores de elemento de p\00E1gina en el')
||unistr(' estado de sesi\00F3n, tiene que definir esos elementos en ese atributo.</p>'),
'<p>Puede escribir el nombre del elemento o elegirlo en una lista de elementos disponibles.',
'Si lo elige en la lista y ya se ha introducido texto, se coloca una coma al final del texto existente seguido del nombre del elemento devuelto de la lista.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1002790918416823799.4412)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Suprimir Evento de Cambio'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(888122401495541038.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NOT_NULL'
,p_help_text=>unistr('Especifique si el evento de cambio se suprime en los elementos que se especifican en <strong>Elementos de P\00E1gina que Devolver</strong>. Esto evita que se disparen acciones din\00E1micas basadas en <em>cambios</em> posteriores para estos elementos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2700405449462251.4412)
,p_plugin_id=>wwv_flow_api.id(1811565602388283608.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>5
,p_prompt=>'Idioma'
,p_attribute_type=>'CODE LANGUAGE'
,p_is_required=>true
,p_default_value=>'PLSQL'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/item_type/display_only
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2248579157998483215.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'DISPLAY_ONLY'
,p_display_name=>unistr('S\00F3lo Visualizaci\00F3n')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','DISPLAY_ONLY'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SOURCE:ELEMENT:ICON:ENCRYPT:LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Muestra un elemento de texto no introducible.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2248592969903496143.4412)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>50
,p_prompt=>unistr('Enviar al ejecutar p\00E1gina')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_help_text=>unistr('Especifique si el valor del elemento actual deber\00EDa enviarse cuando se ejecute la p\00E1gina.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803821466219365649.4412)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Basado en'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(4800927632436292.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLAIN'
,p_lov_type=>'STATIC'
,p_help_text=>'Seleccione la forma de determinar el valor mostrado.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822070028366811.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4412)
,p_display_sequence=>10
,p_display_value=>'Valor de Elemento'
,p_return_value=>'VALUE'
,p_help_text=>'Se muestra el valor actual del elemento.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822445572369209.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Valor de Visualizaci\00F3n de la Lista de Valores')
,p_return_value=>'LOV'
,p_help_text=>unistr('Se asigna el valor actual del elemento de p\00E1gina a otro valor de visualizaci\00F3n utilizando una lista de valores.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1803822855268372026.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1803821466219365649.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Salida de C\00F3digo PL/SQL')
,p_return_value=>'PLSQL'
,p_is_deprecated=>true
,p_help_text=>unistr('El c\00F3digo PL/SQL especificado emite la salida mostrada.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1803823354360381170.4412)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>unistr('C\00F3digo PL/SQL')
,p_attribute_type=>'PLSQL'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PLSQL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el c\00F3digo PL/SQL mediante <code>sys.htp.p</code> o <code>sys.htp.prn</code> para emitir c\00F3digo HTML.</p>'),
'<p>Oracle recomienda utilizar <code>sys.htf.escape_sc</code> para omitir los datos recuperados de la base de datos para garantizar que las etiquetas HTML se omiten.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1363556632373484636.4412)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Mostrar Saltos de L\00EDnea')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1803821466219365649.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE,LOV'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Especifique si se conservan los saltos de l\00EDnea en la salida.</p>'),
unistr('<p>Dado que la pantalla se representa como HTML, cuando se define en <strong>S\00ED</strong>, los saltos de l\00EDnea del valor mostrado se convierten a saltos de l\00EDnea HTML para poder visualizarse correctamente.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(4800927632436292.4412)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>10
,p_prompt=>'Formato'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801218870437281.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4412)
,p_display_sequence=>10
,p_display_value=>'Texto sin Formato'
,p_return_value=>'PLAIN'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4801656011439608.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4412)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTML'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(4802071527441522.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(4800927632436292.4412)
,p_display_sequence=>30
,p_display_value=>'Markdown'
,p_return_value=>'MARKDOWN'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845153181852834480.4412)
,p_plugin_id=>wwv_flow_api.id(2248579157998483215.4412)
,p_name=>'LOV'
,p_is_required=>false
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>Ejemplo 1: Lista de valores basada en consulta SQL.</strong>',
'<pre>',
'SELECT dname, deptno from dept',
'</pre>',
'</p>',
'<p>',
unistr('<strong>Ejemplo 2: Ejemplos de lista est\00E1tica</strong>'),
'<ul>',
unistr('<li>STATIC:Yes;Y,No;N (mostrar S\00ED/No, en lugar de Y y N)</li>'),
'</ul>',
'</p>',
'',
'<p>',
unistr('<strong>Ejemplo 3: Lista de valores con restricci\00F3n adicional que utiliza una variable de enlace</strong>'),
'<pre>',
'SELECT dname, deptno from dept where location=:P3_LOCATION',
'</pre>',
'</p>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/star_rating
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'STAR_RATING'
,p_display_name=>unistr('Clasificaci\00F3n por estrellas')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','STAR_RATING'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ICON:ENCRYPT:FILTER'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p><strong>Elemento moderno de clasificaci\00F3n por estrellas</strong></p>'),
unistr('<p>Este elemento muestra un valor num\00E9rico como n\00FAmero de estrellas u otro tipo de iconos. El usuario final puede cambiar el valor mediante la selecci\00F3n del n\00FAmero de estrellas deseado. El valor se puede ajustar haciendo clic en el n\00FAmero de estrella')
||'s con el mouse o el teclado.</p>',
unistr('<p>El icono que se va a mostrar, los colores del fondo y del primer plano se pueden ajustar en la configuraci\00F3n del componente o en la configuraci\00F3n de los distintos elementos. Para usar elementos y colores concretos, defina el atributo <strong>Utili')
||'zar el valor por defecto de los componentes</strong> en <strong>No</strong>.</p>',
unistr('<p>Como iconos, puede usar cualquier icono de la fuente de iconos disponible en la aplicaci\00F3n. En las aplicaciones de tema universal, use un icono de la biblioteca de <em>Fuente APEX</em>.</p>')))
,p_version_identifier=>'1.0'
,p_files_version=>1149
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475527326399196418.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icono por defecto'
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumbs-up',
'fa-database',
'</pre>'))
,p_help_text=>'Seleccione el icono por defecto que se va a utilizar.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912433448449647.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Color activo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Elija el color por defecto para las estrellas activas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721912884614449648.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Color inactivo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Elija el color por defecto para las estrellas inactivas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(475538451111203492.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Pista'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'#VALUE#'
,p_is_translatable=>false
,p_examples=>unistr('Calificaci\00F3n: #VALUE# estrellas.')
,p_help_text=>unistr('Especifique la plantilla para la ayuda de burbuja. La sustituci\00F3n #VALUE# se reemplaza por el valor de calificaci\00F3n actual.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470180844645338807.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('N\00FAmero de estrellas')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('N\00FAmero total de estrellas que mostrar.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470251151324440675.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4412)
,p_display_sequence=>10
,p_display_value=>'1'
,p_return_value=>'1'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263362673575666.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4412)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470263792668576010.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4412)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264197754576285.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4412)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264650749576748.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4412)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470264961143577132.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4412)
,p_display_sequence=>60
,p_display_value=>'6'
,p_return_value=>'6'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265413888577465.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4412)
,p_display_sequence=>70
,p_display_value=>'7'
,p_return_value=>'7'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470265803806577966.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4412)
,p_display_sequence=>80
,p_display_value=>'8'
,p_return_value=>'8'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266183252578379.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4412)
,p_display_sequence=>90
,p_display_value=>'9'
,p_return_value=>'9'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470266568693578886.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470180844645338807.4412)
,p_display_sequence=>100
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470195603586349451.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Usar Valores por Defecto'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Indica si se van a usar los valores por defecto definidos para este componente en Componentes compartidos > Valores de componente o unos valores personalizados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470360305601388583.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Icono'
,p_attribute_type=>'ICON'
,p_is_required=>true
,p_default_value=>'fa-star'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'fa-star',
'fa-thumb-up',
'fa-database',
'</pre>'))
,p_help_text=>'Especifique el icono que se va a utilizar.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721914847860449650.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Color activo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Elija el color por defecto para las estrellas activas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915319189449650.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Color inactivo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Elija el color por defecto para las estrellas inactivas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2721915642741449650.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Pista'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'#VALUE#'
,p_display_length=>30
,p_max_length=>50
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_examples=>unistr('Calificaci\00F3n: #VALUE# estrellas.')
,p_help_text=>unistr('Especifique la plantilla para la ayuda de burbuja. La sustituci\00F3n #VALUE# se va a reemplazar por el valor de calificaci\00F3n actual.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(576030049193688277.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>unistr('Mostrar bot\00F3n Borrar')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Seleccione si desea mostrar o no el bot\00F3n Borrar.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470218232268377857.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Mostrar Valor'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>'Seleccione si desea mostrar el valor junto a las estrellas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(470221148895382244.4412)
,p_plugin_id=>wwv_flow_api.id(2547808060578229016.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>unistr('Visualizaci\00F3n de solo lectura')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STARS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(470195603586349451.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_lov_type=>'STATIC'
,p_help_text=>'Seleccione lo que mostrar cuando el elemento sea de solo lectura.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238266735410069.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4412)
,p_display_sequence=>20
,p_display_value=>'Estrellas'
,p_return_value=>'STARS'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470238737727410979.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4412)
,p_display_sequence=>30
,p_display_value=>'Valor'
,p_return_value=>'VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239127391413405.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4412)
,p_display_sequence=>40
,p_display_value=>'Estrellas y valor'
,p_return_value=>'STARS_AND_VALUE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(470239521066415362.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(470221148895382244.4412)
,p_display_sequence=>50
,p_display_value=>unistr('Estrella \00FAnica y valor')
,p_return_value=>'SINGLE_STAR_AND_VALUE'
);
end;
/
prompt --application/shared_components/plugins/item_type/checkbox
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2693981597889753854.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'CHECKBOX'
,p_display_name=>'Grupo de casillas de control'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','CHECKBOX'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>'Muestra varios valores como casillas de control, lo que permite al usuario final seleccionar varios valores. Se necesita una lista de valores para los elementos que se muestran como casillas de control. Los valores correspondientes a las casillas de '
||'control se almacenan en una sola cadena delimitada por dos puntos.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(911353315791136342.4412)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('N\00FAmero de Columnas')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el n\00FAmero de columnas de dise\00F1o que se van a utilizar para mostrar las casillas de control. Por ejemplo, un valor 2 mostrar\00E1 dos columnas de casillas de control. Por defecto, todos los valores se muestran en una columna.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12186014788201255.4412)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>5
,p_prompt=>unistr('Orientaci\00F3n de Visualizaci\00F3n')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione c\00F3mo se presentan las casillas de control.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186517905202120.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4412)
,p_display_sequence=>10
,p_display_value=>'Vertical'
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12186921368203093.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(12186014788201255.4412)
,p_display_sequence=>20
,p_display_value=>'Horizontal'
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156526173834547.4412)
,p_plugin_id=>wwv_flow_api.id(2693981597889753854.4412)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores basada en consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores con el mismo valor de retorno y visualizaci\00F3n</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Nota: al seleccionar la misma columna para los valores de retorno y visualizaci\00F3n, utilice un alias de columna.</p>'),
'</dd>',
'<dt>Lista de valores con variable de enlace</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: defina el atributo <em>Elementos Principales de Lista de Valores en Cascada</em> en <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> es un elemento de p\00E1gina modificable en la misma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/select_list
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(2698572619073428716.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SELECT_LIST'
,p_display_name=>unistr('Lista de Selecci\00F3n')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SELECT_LIST'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ICON:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_is_quick_pick=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Muestra un elemento con un selector de lista de valores incorporado. Cuando el usuario final hace clic en el elemento, la lista de valores soportados se muestra directamente en l\00EDnea con el elemento actual.</p>'),
unistr('<p>Seleccionar Lista es m\00E1s adecuado para listas discretas y relativamente peque\00F1as. Los usuarios finales pueden seleccionar de una forma muy r\00E1pida un valor en la lista sin necesidad de cambiar el foco a un cuadro de di\00E1logo emergente. Para listas d')
||unistr('e mayor tama\00F1o, suele ser mejor <em>Lista de Valores Emergente</em>.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2698572905698434305.4412)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Acci\00F3n de P\00E1gina al Seleccionar')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione la acci\00F3n que se elige cuando se selecciona un valor de lista.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2264411080592689929.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4412)
,p_display_sequence=>1
,p_display_value=>'Ninguno'
,p_return_value=>'NONE'
,p_help_text=>unistr('No se realiza ninguna acci\00F3n inmediata cuando se cambia el valor.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698575413579455462.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4412)
,p_display_sequence=>5
,p_display_value=>unistr('Ejecutar P\00E1gina')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('La p\00E1gina se ejecuta con la p\00E1gina REQUEST definida en el nombre de elemento de p\00E1gina.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574606653453436.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4412)
,p_display_sequence=>7
,p_display_value=>'Redireccionar y Definir Valor'
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('El explorador se redirige a la p\00E1gina actual y el estado de sesi\00F3n para el elemento actual se define en el valor seleccionado.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698574220720448121.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4412)
,p_display_sequence=>9
,p_display_value=>unistr('Redirigir a P\00E1gina')
,p_return_value=>'REDIRECT_PAGE'
,p_help_text=>unistr('El explorador se redirige a la p\00E1gina incluida en el valor seleccionado. Los valores de retorno de la lista deben incluir n\00FAmeros de p\00E1gina o alias de p\00E1gina v\00E1lidos.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2698573815526446624.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2698572905698434305.4412)
,p_display_sequence=>10
,p_display_value=>'Redirigir a URL'
,p_return_value=>'REDIRECT_URL'
,p_help_text=>unistr('El explorador se redirige a la URL incluida en el valor seleccionado. Los valores de retorno de la lista deben incluir URL v\00E1lidas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(912506420442525842.4412)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Permitir Selecci\00F3n M\00FAltiple')
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'NONE'
,p_help_text=>'Especifique si se pueden seleccionar varios valores o un solo valor en la lista de valores. Si son varios valores, se devuelven en una lista separada por comas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459061412834919653.4412)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Ejecutar Validaciones'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2698572905698434305.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('Especifique si se realizan validaciones cuando se ejecuta la p\00E1gina en funci\00F3n del valor de la acci\00F3n de p\00E1gina de <strong>Ejecutar P\00E1gina</strong>.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156662497834548.4412)
,p_plugin_id=>wwv_flow_api.id(2698572619073428716.4412)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores basada en consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores con el mismo valor de retorno y visualizaci\00F3n</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Nota: al seleccionar la misma columna para los valores de retorno y visualizaci\00F3n, utilice un alias de columna.</p>'),
'</dd>',
'<dt>Lista de valores con variable de enlace</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: defina el atributo <em>Elementos Principales de Lista de Valores en Cascada</em> en <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> es un elemento de p\00E1gina modificable en la misma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_column_toggle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_COLUMN_TOGGLE'
,p_display_name=>unistr('Informe de Conmutaci\00F3n de Columnas')
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_COLUMN_TOGGLE'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un informe en el que los usuarios finales pueden seleccionar las columnas que se van a mostrar en tiempo de ejecuci\00F3n. A continuaci\00F3n, los usuarios finales pueden cambiar las columnas bas\00E1ndose en el ancho y la orientaci\00F3n de la pantalla que ')
||'utilizan para ver el informe.'
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823587226519967208.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Seleccione la base de esta columna de informe.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587544288968547.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4412)
,p_display_sequence=>10
,p_display_value=>'Texto sin Formato'
,p_return_value=>'PLAIN'
,p_help_text=>'Muestra el valor de columna.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823587907770969285.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4412)
,p_display_sequence=>20
,p_display_value=>'Enlace'
,p_return_value=>'LINK'
,p_help_text=>'Muestra la columna como un enlace.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1305234852618727263.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1823587226519967208.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Gr\00E1fico de Porcentaje')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('Muestra la columna como un gr\00E1fico de porcentajes. El valor recuperado debe estar entre 0 y 100.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823588275617978359.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Destino'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Introduzca una p\00E1gina de destino a la que se llamar\00E1 cuando el usuario haga clic en una entrada existente.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238927721819003883.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Texto de Enlace'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Introduzca el texto HTML que se muestra como enlace. Utilice una etiqueta de imagen para mostrar im\00E1genes o seleccione una de la lista de im\00E1genes por defecto.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238931409403155860.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Atributos de Enlace'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Especifique los atributos de enlace de columna adicionales que se incluir\00E1n en la etiqueta <code>&lt;a href=...&gt;</code>, como destino del enlace, clases o estilos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305278757261772485.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Color de Fondo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color que se utiliza para el fondo de este gr\00E1fico.'),
unistr('El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML.</p>'),
unistr('<p>La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representan los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.'),
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de Colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305279121857779186.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Color de Primer Plano'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color que se utiliza para el primer plano de este gr\00E1fico.'),
unistr('El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML.</p>'),
unistr('<p>La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representan los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.'),
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de Colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1305282212210798696.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Ancho de Barra'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>unistr('p\00EDxeles')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823587226519967208.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('Introduzca el ancho en p\00EDxeles para este gr\00E1fico de barras.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149106414354906696.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Usar como Cabecera de Fila'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Esto se utiliza para que la accesibilidad identifique la columna que mejor representa el contenido de la fila.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2695400128710862038.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>25
,p_display_sequence=>250
,p_prompt=>'Prioridad'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'1'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El informe oculta y muestra las columnas seg\00FAn dos tipos de entrada: el ancho de pantalla disponible o la activaci\00F3n y desactivaci\00F3n de las columnas para mostrar que decida el usuario en el men\00FA selector. Seleccione un valor de prioridad para las ')
||unistr('columnas que desee que se muestren en el resultado. Las columnas a las que asigne prioridad estar\00E1n disponibles en el men\00FA selector de columnas.<p>'),
'',
unistr('<p>Para fijar una columna y que no se oculte, seleccione <strong>Mostrar Siempre</strong>, lo cual la eliminar\00E1 del men\00FA selector de columnas.</p>')))
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(686758760912714500.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4412)
,p_display_sequence=>5
,p_display_value=>'Mostrar Siempre'
,p_return_value=>'ALWAYS'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557520909123628.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4412)
,p_display_sequence=>10
,p_display_value=>unistr('1 - Ocultar el \00DAltimo')
,p_return_value=>'1'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245557959195124246.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4412)
,p_display_sequence=>20
,p_display_value=>'2'
,p_return_value=>'2'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558584414124867.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4412)
,p_display_sequence=>30
,p_display_value=>'3'
,p_return_value=>'3'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245558946802125444.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4412)
,p_display_sequence=>40
,p_display_value=>'4'
,p_return_value=>'4'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559350856125993.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4412)
,p_display_sequence=>50
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1245559812372127827.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2695400128710862038.4412)
,p_display_sequence=>60
,p_display_value=>'6 - Ocultar el Primero'
,p_return_value=>'6'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823549938363826650.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Opciones de Dise\00F1o')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Compruebe las opciones adicionales de dise\00F1o del informe.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238928674387055064.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4412)
,p_display_sequence=>10
,p_display_value=>'Segmentos'
,p_return_value=>'STRIPE'
,p_help_text=>'Agregar fragmentos de filas alternativas en cada fila.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1238929097998055827.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1823549938363826650.4412)
,p_display_sequence=>20
,p_display_value=>'Trazo'
,p_return_value=>'STROKE'
,p_help_text=>unistr('Agregar l\00EDneas horizontales entre las filas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929416131062515.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Clases CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Introduzca las clases adicionales de CSS delimitadas por espacios que se van a incluir en el componente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1238929773245063952.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Atributos Personalizados'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>Introduzca los atributos adicionales que se incluir\00E1n en la etiqueta HTML de la tabla. El atributo HTML de clase se genera y, por lo tanto, no se debe proporcionar. Utilice en su lugar el atributo <em>Clases CSS</em> dedicado.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(106020849730927710.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>unistr('Texto de bot\00F3n de columna')
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_help_text=>unistr('Esta es la etiqueta que se debe utilizar para el bot\00F3n que abre la ventana emergente de selecci\00F3n de columna. Si no se especifica texto, se utiliza una etiqueta por defecto.')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107062574864851281.4412)
,p_plugin_id=>wwv_flow_api.id(3482208123256545756.4412)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Muestra todos los empleados ordenados por nombre</dt>',
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
'<dt>Muestra todos los empleados del departamento actual ordenados por nombre</dt>',
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>Si utiliza variables de enlace para hacer referencia a elementos de p\00E1gina, especif\00EDquelos como <strong>Elementos de P\00E1gina que Ejecutar<strong>.</p>'),
'</dd>',
'</dl>',
''))
);
end;
/
prompt --application/shared_components/plugins/item_type/shuttle
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3601651046632666378.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'SHUTTLE'
,p_display_name=>'Selector'
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','SHUTTLE'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV:JOIN_LOV:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Se muestra como una lista de selecci\00F3n m\00FAltiple que incluye dos cuadros que contienen listas. En la lista de la izquierda se muestra la lista de valores de origen que no se han seleccionado y en la lista de la derecha se muestran los valores selec')
||unistr('cionados actualmente. Los usuarios finales pueden seleccionar uno o m\00E1s valores en una lista y, a continuaci\00F3n, utilizar los controles del selector para mover los valores seleccionados o todos los valores.</p>'),
'<p>Los valores actuales se almacenan en una sola cadena delimitada por dos puntos.</p>'))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1815740271128931626.4412)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mostrar Controles'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione qu\00E9 movimiento de datos controla la visualizaci\00F3n en mitad del selector.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815740874245932549.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4412)
,p_display_sequence=>10
,p_display_value=>'Todo'
,p_return_value=>'ALL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741286365936063.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4412)
,p_display_sequence=>20
,p_display_value=>unistr('S\00F3lo desplazamiento')
,p_return_value=>'MOVE'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815741691214937407.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4412)
,p_display_sequence=>30
,p_display_value=>unistr('S\00F3lo ordenaci\00F3n')
,p_return_value=>'ORDER'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1815746874076970329.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1815740271128931626.4412)
,p_display_sequence=>40
,p_display_value=>'Ninguno'
,p_return_value=>'NONE'
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156821574834552.4412)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4412)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores basada en consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores con el mismo valor de retorno y visualizaci\00F3n</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Nota: al seleccionar la misma columna para los valores de retorno y visualizaci\00F3n, utilice un alias de columna.</p>'),
'</dd>',
'<dt>Lista de valores con variable de enlace</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: defina el atributo <em>Elementos Principales de Lista de Valores en Cascada</em> en <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> es un elemento de p\00E1gina modificable en la misma p\00E1gina.</dd>'),
'</dl>'))
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(1815705269182590478.4412)
,p_plugin_id=>wwv_flow_api.id(3601651046632666378.4412)
,p_name=>'shuttlechangeorder'
,p_display_name=>'Cambiar Orden'
);
end;
/
prompt --application/shared_components/plugins/item_type/radiogroup
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(3605341835055239817.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'RADIOGROUP'
,p_display_name=>'Grupo de Botones de Radio'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS:APEX_APPL_PAGE_FACETS:APEX_APPL_PAGE_SFILTERS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','RADIOGROUP'),'')
,p_api_version=>1
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL:CASCADING_LOV:JOIN_LOV:FILTER:LINK:FC_HAS_FEEDBACK:FC_SHOW_SELECTED_FIRST:FC_SHOW_MORE_COUNT:FC_FILTER_VALUES:FC_LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>'Muestra varios valores como opciones de un grupo de botones de radio, lo que permite al usuario final seleccionar un solo valor.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1822713552956622305.4412)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('N\00FAmero de Columnas')
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'1'
,p_display_length=>3
,p_max_length=>3
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el n\00FAmero de columnas del grupo de botones de radio que se van a mostrar. Por ejemplo, el valor <code>2</code> har\00E1 que se muestren dos columnas, por lo que si hubiera cinco valores, se mostrar\00EDan en tres filas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1823061668632450689.4412)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>unistr('Acci\00F3n de P\00E1gina al Seleccionar')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione la acci\00F3n que se elige cuando se selecciona un valor del grupo de botones de radio.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062574865452418.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4412)
,p_display_sequence=>10
,p_display_value=>'Ninguno'
,p_return_value=>'NONE'
,p_help_text=>unistr('No se realiza ninguna acci\00F3n inmediata cuando se cambia el valor.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823062977982453399.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Ejecutar P\00E1gina')
,p_return_value=>'SUBMIT'
,p_help_text=>unistr('La p\00E1gina se ejecuta con la p\00E1gina REQUEST definida en el nombre de elemento de p\00E1gina.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1823063380406454049.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(1823061668632450689.4412)
,p_display_sequence=>30
,p_display_value=>'Redireccionar y Definir Valor'
,p_return_value=>'REDIRECT_SET_VALUE'
,p_help_text=>unistr('El explorador se redirige a la p\00E1gina actual y el estado de sesi\00F3n para el elemento actual se define en el valor seleccionado.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(459060107939889859.4412)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Ejecutar Validaciones'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1823061668632450689.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'SUBMIT'
,p_help_text=>unistr('Especifique si se realizan validaciones cuando se ejecuta la p\00E1gina debido al valor de la acci\00F3n de p\00E1gina <strong>Ejecutar P\00E1gina</strong>.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(12184106346189362.4412)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>5
,p_prompt=>unistr('Orientaci\00F3n de Visualizaci\00F3n')
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VERTICAL'
,p_supported_ui_types=>'JQM_SMARTPHONE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Seleccione la orientaci\00F3n para ver valores de grupo de botones de radio.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12184610155190440.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4412)
,p_display_sequence=>10
,p_display_value=>'Vertical'
,p_return_value=>'VERTICAL'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(12185014311191660.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(12184106346189362.4412)
,p_display_sequence=>20
,p_display_value=>'Horizontal'
,p_return_value=>'HORIZONTAL'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(728745079326901742.4412)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Ocultar botones de radio'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_supported_component_types=>'APEX_APPL_PAGE_FACETS'
,p_is_translatable=>false
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(845156982734834553.4412)
,p_plugin_id=>wwv_flow_api.id(3605341835055239817.4412)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Lista de valores basada en consulta SQL</dt>',
'<dd><pre>',
'select ename as d, ',
'       empno as r',
'  from emp ',
' order by 1',
'</pre></dd>',
unistr('<dt>Lista de valores con el mismo valor de retorno y visualizaci\00F3n</dt>'),
'<dd><pre>',
'select ename d,',
'       ename r ',
'  from emp ',
' order by 1',
'</pre>',
unistr('<p>Nota: al seleccionar la misma columna para los valores de retorno y visualizaci\00F3n, utilice un alias de columna.</p>'),
'</dd>',
'<dt>Lista de valores con variable de enlace</dt>',
'<dd><pre>',
'select ename,',
'       empno ',
'  from emp ',
' where deptno = :P3_DEPTNO ',
' order by 1',
'</pre>',
unistr('<p>Nota: defina el atributo <em>Elementos Principales de Lista de Valores en Cascada</em> en <code>P3_DEPTNO</code> si <code>P3_DEPTNO</code> es un elemento de p\00E1gina modificable en la misma p\00E1gina.</dd>'),
'</dl>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/jqm_reflow
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_plugin_type=>'REGION TYPE'
,p_name=>'JQM_REFLOW'
,p_display_name=>'Informe de Reflujo'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','JQM_REFLOW'),'')
,p_api_version=>1
,p_render_function=>'xxx'
,p_standard_attributes=>'SOURCE_LOCATION:AJAX_ITEMS_TO_SUBMIT:NO_DATA_FOUND_MESSAGE:COLUMNS:COLUMN_HEADING:HEADING_ALIGNMENT:VALUE_ALIGNMENT:VALUE_CSS:VALUE_ATTRIBUTE:VALUE_ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un informe de respuesta que se transforma de columnas a filas para mostrar los informes en tama\00F1os de explorador (pantalla) m\00E1s reducidos.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477435524770686441.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Tipo'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'PLAIN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Seleccione la base de esta columna de informe.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477435842539687780.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4412)
,p_display_sequence=>10
,p_display_value=>'Texto sin Formato'
,p_return_value=>'PLAIN'
,p_help_text=>'Muestra el valor de columna.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2477436206021688518.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4412)
,p_display_sequence=>20
,p_display_value=>'Enlace'
,p_return_value=>'LINK'
,p_help_text=>'Muestra la columna como un enlace.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1959083150869446496.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2477435524770686441.4412)
,p_display_sequence=>30
,p_display_value=>unistr('Gr\00E1fico de Porcentaje')
,p_return_value=>'PCT_GRAPH'
,p_help_text=>unistr('Muestra la columna como un gr\00E1fico de porcentajes. El valor recuperado debe estar entre 0 y 100.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477436573868697592.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Destino'
,p_attribute_type=>'LINK'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('<p>Introduzca una p\00E1gina de destino a la que se llamar\00E1 cuando el usuario haga clic en una entrada existente.</p>')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892776020069723116.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Texto de Enlace'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Introduzca el texto HTML que se muestra como enlace. Utilice una etiqueta de imagen para mostrar im\00E1genes o seleccione una de la lista de im\00E1genes por defecto.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892779707653875093.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Atributos de Enlace'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'LINK'
,p_reference_scope=>'ROW'
,p_help_text=>unistr('Especifique los atributos de enlace de columna adicionales que se incluir\00E1n en la etiqueta <code>&lt;a href=...&gt;</code>, como destino del enlace, clases o estilos.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127055512491718.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Color de Fondo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color que se utiliza para el fondo de este gr\00E1fico.'),
unistr('El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML.</p>'),
unistr('<p>La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representan los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.'),
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de Colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959127420108498419.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Color de Primer Plano'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Entre los ejemplos de c\00F3digos de color HTML principales se incluyen:'),
'<ul>',
'  <li><strong><span style="background-color: lightgray; color: black;">&nbsp;&nbsp;Black&nbsp;&nbsp;</span></strong> <code>#000000 RGB(0,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: red;">&nbsp;&nbsp;Red&nbsp;&nbsp;</span></strong> <code>#FF0000 RGB(255,0,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: yellow;">&nbsp;&nbsp;Yellow&nbsp;&nbsp;</span></strong> <code>#FFFF00 RGB(255,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: lime;">&nbsp;&nbsp;Lime&nbsp;&nbsp;</span></strong> <code>#00FF00 RGB(0,255,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: green;">&nbsp;&nbsp;Green&nbsp;&nbsp;</span></strong> <code>#008000 RGB(0,128,0)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: aqua;">&nbsp;&nbsp;Aqua&nbsp;&nbsp;</span></strong> <code>#00FFFF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: blue;">&nbsp;&nbsp;Blue&nbsp;&nbsp;</span></strong> <code>#0000FF RGB(0,255,255)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: navy;">&nbsp;&nbsp;Navy&nbsp;&nbsp;</span></strong> <code>#000080 RGB(0,0,128)</code></li>',
'  <li><strong><span style="background-color: lightgray; color: white;">&nbsp;&nbsp;White&nbsp;&nbsp;</span></strong> <code>#FFFFFF RGB(255,255,255)</code></li>',
'</ul>'))
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color que se utiliza para el primer plano de este gr\00E1fico.'),
unistr('El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML.</p>'),
unistr('<p>La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representan los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.'),
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de Colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1959130510461517929.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Ancho de Barra'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>3
,p_max_length=>3
,p_unit=>unistr('p\00EDxeles')
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(2477435524770686441.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PCT_GRAPH'
,p_help_text=>unistr('Introduzca el ancho en p\00EDxeles para este gr\00E1fico de barras.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(149105606951887044.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_attribute_scope=>'COLUMN'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Usar como Cabecera de Fila'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Esto se utiliza para que la accesibilidad identifique la columna que mejor representa el contenido de la fila.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2477398236614545883.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>unistr('Opciones de Dise\00F1o')
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'STRIPE:STROKE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>unistr('Compruebe las opciones adicionales de dise\00F1o del informe.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892776972637774297.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4412)
,p_display_sequence=>10
,p_display_value=>'Segmentos'
,p_return_value=>'STRIPE'
,p_help_text=>'Agregar fragmentos de filas alternativas de cada fila.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(1892777396248775060.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2477398236614545883.4412)
,p_display_sequence=>20
,p_display_value=>'Trazo'
,p_return_value=>'STROKE'
,p_help_text=>unistr('Agregar l\00EDneas horizontales entre las filas.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892777714381781748.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Clases CSS'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'Introduzca las clases adicionales de CSS delimitadas por espacios que se van a incluir en el componente.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1892778071495783185.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Atributos Personalizados'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('<p>Introduzca los atributos adicionales que se incluir\00E1n en la etiqueta HTML de la tabla. El atributo HTML de clase se genera y, por lo tanto, no se debe proporcionar. Utilice en su lugar el atributo <em>Clases CSS</em> dedicado.</p>')
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(107061404414844166.4412)
,p_plugin_id=>wwv_flow_api.id(4136056421507264989.4412)
,p_name=>'SOURCE_LOCATION'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'<dt>Muestra todos los empleados ordenados por nombre</dt>',
'<dd><pre>',
'SELECT * FROM emp ORDER by ename',
'</pre></dd>',
'<dt>Muestra todos los empleados del departamento actual ordenados por nombre</dt>',
'<dd><pre>',
'SELECT * FROM emp ',
'WHERE deptno = :P3_DEPTNO ',
'ORDER by 1',
'</pre>',
unistr('<p>Si utiliza variables de enlace para hacer referencia a elementos de p\00E1gina, especif\00EDquelos como <strong>Elementos de P\00E1gina que Ejecutar<strong>.</p>'),
'</dd>',
'</dl>',
''))
);
end;
/
prompt --application/shared_components/plugins/item_type/pct_graph
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(6012795064666735813.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'PCT_GRAPH'
,p_display_name=>unistr('Gr\00E1fico de Porcentaje')
,p_supported_ui_types=>'DESKTOP'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','PCT_GRAPH'),'')
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.pctGraph#MIN#.js'
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:SOURCE:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra el valor como un gr\00E1fico de porcentajes. El valor recuperado debe estar entre 0 y 100.')
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760373882350100186.4412)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Mostrar Valor'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Especifique si el valor de porcentaje se puede ver.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925486701799362.4412)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Color de Fondo'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color que se utiliza para el fondo de este gr\00E1fico.'),
unistr('El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML.</p>'),
unistr('<p>La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representan los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.'),
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de Colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765925773847803225.4412)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Color de Primer Plano'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color que se utiliza para el primer plano de este gr\00E1fico.'),
unistr('El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML.</p>'),
unistr('<p>La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representan los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.'),
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de Colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1760374133781106494.4412)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Color del Texto'
,p_attribute_type=>'COLOR'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(1760373882350100186.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el color que se utiliza para el texto de este gr\00E1fico.'),
unistr('El color se especifica mediante la notaci\00F3n hexadecimal (hex), c\00F3digos de color RGB o nombres de colores HTML.</p>'),
unistr('<p>La notaci\00F3n hexadecimal se define como #xxyyzz (una # seguida de 3 n\00FAmeros hexadecimales de doble d\00EDgito), donde xx, yy, y zz representan los valores hexadecimales de dos caracteres para rojo, verde y azul, respectivamente.'),
unistr('Los c\00F3digos RGB se definen como RGB(xxx,xxx,xxx), donde xxx es un n\00FAmero entre 0 y 255, y cada uno representa el valor \00FAnico de 8 bits para rojo, verde y azul, respectivamente.</p>'),
unistr('<p>Busque en Internet "C\00F3digos de Colores HTML" para encontrar el c\00F3digo hexadecimal equivalente o el c\00F3digo RGB del color que desea utilizar.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(1765926334751816120.4412)
,p_plugin_id=>wwv_flow_api.id(6012795064666735813.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Ancho de Barra'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_max_length=>3
,p_unit=>unistr('p\00EDxeles')
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el ancho en p\00EDxeles para este gr\00E1fico de barras.')
);
end;
/
prompt --application/shared_components/plugins/item_type/markdown_editor
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(8511644498934019458.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'MARKDOWN_EDITOR'
,p_display_name=>'Editor de Markdown'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','MARKDOWN_EDITOR'),'')
,p_api_version=>2
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:PLACEHOLDER:ENCRYPT:FILTER:INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Muestra un \00E1rea de texto que soporta la entrada de Markdown, con opciones de formato de texto, soporte para incluir im\00E1genes, as\00ED como una opci\00F3n de vista previa para ver el texto con formato. El editor de Markdown le permite escribir usando texto si')
||unistr('n formato de f\00E1cil lectura y escritura para, a continuaci\00F3n, poder convertirlo en HTML v\00E1lido desde el punto de vista de la estructura con las distintas opciones proporcionadas y la sintaxis soportada.')
,p_version_identifier=>'1.0.0'
,p_files_version=>408
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(34405931740234149.4412)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Barra de Herramientas'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SIMPLE'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Proporciona varias opciones para configurar la barra de herramientas para el editor de Markdown'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408106298242570.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4412)
,p_display_sequence=>10
,p_display_value=>'Simple'
,p_return_value=>'SIMPLE'
,p_help_text=>unistr('Muestra controles de formato b\00E1sicos en la barra de herramientas.')
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408560093252260.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4412)
,p_display_sequence=>20
,p_display_value=>'Completo'
,p_return_value=>'FULL'
,p_help_text=>'Muestra el conjunto completo de controles de formato en la barra de herramientas.'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(34408916632257999.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(34405931740234149.4412)
,p_display_sequence=>40
,p_display_value=>'Ninguno'
,p_return_value=>'NONE'
,p_help_text=>'Ocultar la barra de herramientas.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(590983936587988716.4412)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Resaltado de sintaxis'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Si se va a aplicar el resaltado de sintaxis para determinados elementos de Markdown como negrita, cursiva, bloques de c\00F3digo, etc.</p>'),
unistr('<p>El resaltado solo se realizar\00E1 para contenido de menos de 4000 caracteres de longitud.</p>')))
);
wwv_flow_api.create_plugin_std_attribute(
 p_id=>wwv_flow_api.id(55495142284465026.4412)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4412)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE'
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>function( options ) {',
'    options.toolbar.widgetOptions.actions.push( {',
'        name: ''custom'',',
'        action: function(){',
'            alert( ''custom'' );',
'        }',
'    } );',
'    options.toolbar.widgetOptions.data.push( {',
'        groupTogether: true,',
'        controls: [',
'            {',
'                type: ''BUTTON'',',
'                label: ''Custom Button'',',
'                iconOnly: true,',
'                icon: ''fa fa-file-o'',',
'                action: ''custom''',
'            }',
'        ]',
'    } );',
'',
'    return options;',
'}</pre>'))
,p_help_text=>unistr('<p>Introduzca una funci\00F3n JavaScript que tome un objeto de configuraci\00F3n del editor de Markdown, modifique el objeto y lo devuelva. Esto permite una personalizaci\00F3n avanzada de la apariencia, las funciones y el comportamiento, incluida la barra de he')
||unistr('rramientas, los men\00FAs y las acciones del editor de Markdown.<p>')
);
wwv_flow_api.create_plugin_event(
 p_id=>wwv_flow_api.id(9126110225642555867.4412)
,p_plugin_id=>wwv_flow_api.id(8511644498934019458.4412)
,p_name=>'markdownified'
,p_display_name=>'marcado con Markdown'
);
end;
/
prompt --application/shared_components/plugins/item_type/yes_no
begin
wwv_flow_api.create_plugin(
 p_id=>wwv_flow_api.id(16382027049111291021.4412)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'YES_NO'
,p_display_name=>'Cambiar'
,p_supported_ui_types=>'DESKTOP:JQM_SMARTPHONE:JQM_TABLET'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','YES_NO'),'')
,p_api_version=>2
,p_render_function=>'D'
,p_validation_function=>'validate_yes_no'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:ENCRYPT:FILTER:LINK'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>unistr('Se muestra como un conmutador de inversi\00F3n.')
,p_version_identifier=>'1.0'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14841509770799749.4412)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Valor Activado'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Y'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>unistr('Introduzca el valor almacenado en el elemento de p\00E1gina si el usuario final selecciona la opci\00F3n <strong>Activado</strong>. El valor puede tener una longitud de hasta 255 caracteres.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842132411815696.4412)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Etiqueta de Activado'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el texto que se muestra para la opci\00F3n <strong>Activado</strong>. Si no se introduce texto, se utiliza la etiqueta por defecto del sistema.'),
unistr('<p>Nota: Si el "estilo de visualizaci\00F3n" de la configuraci\00F3n del componente es <strong>Cambiar</strong>, este atributo solo se utilizar\00E1 como el valor de visualizaci\00F3n para las columnas de la cuadr\00EDcula interactiva. No aparecer\00E1 en los elementos de p')
||unistr('\00E1gina normales.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14842724970851430.4412)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Valor Desactivado'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'N'
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el valor almacenado en el elemento de p\00E1gina si el usuario selecciona la opci\00F3n <strong>Desactivado</strong>. El valor puede tener una longitud de hasta 255 caracteres</p>'),
unistr('<p><em>Nota: Este valor se utiliza si el elemento de p\00E1gina se rellena con un valor que no coincide con <strong>Valor activado</strong> ni con <strong>Valor desactivado</strong>.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(14843532719863116.4412)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Etiqueta de Desactivado'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el texto que se muestra para la opci\00F3n <strong>Desactivado</strong>. Si no se introduce texto, se utiliza la etiqueta por defecto del sistema.'),
unistr('<p>Nota: Si el "estilo de visualizaci\00F3n" de la configuraci\00F3n del componente es <strong>Cambiar</strong>, este atributo solo se utilizar\00E1 como el valor de visualizaci\00F3n para las columnas de la cuadr\00EDcula interactiva. No aparecer\00E1 en los elementos de p')
||unistr('\00E1gina normales.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(2089613064757884864.4412)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4412)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>5
,p_display_sequence=>1
,p_prompt=>'Estilo Mostrado'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'SWITCH_CB'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(306600152922320417.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4412)
,p_display_sequence=>5
,p_display_value=>'Cambiar'
,p_return_value=>'SWITCH_CB'
,p_is_quick_pick=>true
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613549171886868.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4412)
,p_display_sequence=>10
,p_display_value=>'Grupo de botones'
,p_return_value=>'SWITCH'
);
wwv_flow_api.create_plugin_attr_value(
 p_id=>wwv_flow_api.id(2089613999173888214.4412)
,p_plugin_attribute_id=>wwv_flow_api.id(2089613064757884864.4412)
,p_display_sequence=>20
,p_display_value=>unistr('Lista de Selecci\00F3n')
,p_return_value=>'SELECT_LIST'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(10610711090664543.4412)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Usar Valores por Defecto'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Indica si se van a usar los valores por defecto definidos para este componente en Componentes compartidos > Valores de componente o unos valores personalizados.'
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382071946350365830.4412)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Valor Activado'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>unistr('Introduzca el valor almacenado en el elemento de p\00E1gina si el usuario selecciona la opci\00F3n <strong>Activado</strong>. El valor puede tener una longitud de hasta 255 caracteres.')
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382622645104567710.4412)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Etiqueta de Activado'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el texto que se muestra para la opci\00F3n <strong>Activado</strong>.'),
unistr('<p>Nota: Si el ''estilo de visualizaci\00F3n'' de la configuraci\00F3n de componente est\00E1 definido en <strong>Cambiar</strong>, el atributo no tiene ning\00FAn efecto.</p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(16382623150298569207.4412)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Valor Desactivado'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>10
,p_max_length=>255
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Introduzca el valor almacenado en el elemento de p\00E1gina si el usuario selecciona la opci\00F3n <strong>Desactivado</strong>. Este atributo tambi\00E9n se puede dejar en blanco si desea almacenar <code>NULL</code> cuando est\00E1 seleccionada la opci\00F3n Desacti')
||'vado. El valor puede tener una longitud de hasta 255 caracteres</p>',
unistr('<p><em>Nota: Este valor se utilizar\00E1 si el elemento de p\00E1gina se rellena con un valor que no coincide con <strong>Valor activado</strong> ni con <strong>Valor desactivado</strong>.</em></p>')))
);
wwv_flow_api.create_plugin_attribute(
 p_id=>wwv_flow_api.id(21162632375092489.4412)
,p_plugin_id=>wwv_flow_api.id(16382027049111291021.4412)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Etiqueta de Desactivado'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>40
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_api.id(10610711090664543.4412)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Introduzca el texto que se muestra para la opci\00F3n <strong>Desactivado</strong>.'),
unistr('<p>Nota: Si el "estilo de visualizaci\00F3n" de la configuraci\00F3n del componente es <strong>Cambiar</strong>, este atributo no tendr\00E1 efecto.</p>')))
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(4968506573302342.4412)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Escritorio'
,p_display_seq=>10
,p_use_auto_detect=>true
,p_is_default=>true
,p_theme_id=>1
,p_home_url=>'f?p=4411:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4412
,p_user_interface_id=>wwv_flow_api.id(4968506573302342.4412)
,p_name=>'Mensajes'
,p_step_title=>'Mensajes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_api.id(91626406749381989.4412)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
