prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- ORACLE Application Express (APEX) export file
--
-- You should run the script connected to SQL*Plus as the Oracle user
-- APEX_210200 or as the owner (parsing schema) of the application.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_api.import_begin (
 p_version_yyyy_mm_dd=>'2021.10.15'
,p_release=>'21.2.0-19'
,p_default_workspace_id=>10
,p_default_application_id=>4471
,p_default_id_offset=>109671377647632083
,p_default_owner=>'APEX_210200'
);
end;
/
 
prompt APPLICATION 4471 - Oracle APEX Runtime Messages
--
-- Application Export:
--   Application:     4471
--   Name:            Oracle APEX Runtime Messages
--   Exported By:     APEX_210200
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                      1
--     Shared Components:
--       Logic:
--       Navigation:
--         Breadcrumbs:            1
--       Security:
--         Authentication:         1
--       User Interface:
--         Templates:
--           Page:                 7
--           Region:              11
--           Label:                7
--           List:                 6
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               6
--           Report:               8
--       Globalization:
--         Messages:           1,800
--       Reports:
--       E-Mail:
--     Supporting Objects:  Excluded
--   Version:         21.2.0-19
--   Instance ID:     697872254810262
--

prompt --application/delete_application
begin
wwv_flow_api.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_flow_api.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_210200')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX Runtime Messages')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'A116101763296403515')
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20211020113125'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_flow_language=>'es'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_authentication=>'PLUGIN'
,p_authentication_id=>wwv_flow_api.id(109678305570583962.4471)
,p_populate_roles=>'A'
,p_application_tab_set=>0
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 21.2.0-19'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'O:W'
,p_security_scheme=>wwv_flow_api.id(860535012146524358)
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_friendly_url=>'N'
,p_last_updated_by=>'APEX_210200'
,p_last_upd_yyyymmddhh24miss=>'20211020113350'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_ui_type_name => null
,p_print_server_type=>'INSTANCE'
,p_is_pwa=>'N'
);
end;
/
prompt --application/plugin_settings
begin
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(110599941590099161.4471)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(111465476128037500.4471)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(201677315619204524.4471)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_RICH_TEXT_EDITOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(209516503264520988.4471)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(285800719532138903.4471)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(649595203182764436.4471)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(701907820392341530.4471)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_JET'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1874744429444344138.4471)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(1941451863897626238.4471)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attribute_01=>'IG'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2027366558906572283.4471)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
);
wwv_flow_api.create_plugin_setting(
 p_id=>wwv_flow_api.id(2120597162971751123.4471)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attribute_01=>'3'
,p_attribute_02=>'1.333'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
null;
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/pages/page_groups
begin
null;
end;
/
prompt --application/shared_components/navigation/breadcrumbs/breadcrumb
begin
wwv_flow_api.create_menu(
 p_id=>wwv_flow_api.id(649613204592764515.4471)
,p_name=>' Breadcrumb'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(850359229090693491.4471)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Dialog.es'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--wizard'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910.4471
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161778160347686.4471)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4471)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161835522347686.4471)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4471)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140161954309347685.4471)
,p_page_template_id=>wwv_flow_api.id(850359229090693491.4471)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037359784626333.4471)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Dialog.es'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--dialog" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_css_classes=>'a-Dialog--uiDialog'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930.4471
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162085053347685.4471)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4471)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162150671347685.4471)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4471)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162280992347685.4471)
,p_page_template_id=>wwv_flow_api.id(851037359784626333.4471)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851037631091626378.4471)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Edit Screen.es'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770.4471
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162482551347683.4471)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4471)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162565984347683.4471)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4471)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162631318347683.4471)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4471)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162776979347683.4471)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4471)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162894857347683.4471)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4471)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140162922323347683.4471)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4471)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055105627189852.4471)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4471)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269055592800189852.4471)
,p_page_template_id=>wwv_flow_api.id(851037631091626378.4471)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851039898661626389.4471)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar.es'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496.4471
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163030050347682.4471)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4471)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163116466347682.4471)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4471)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163291443347682.4471)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4471)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163395758347682.4471)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4471)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163408834347682.4471)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4471)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163558979347682.4471)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4471)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163680191347681.4471)
,p_page_template_id=>wwv_flow_api.id(851039898661626389.4471)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851040471818626394.4471)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar.es'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" title="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222.4471
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269059575338189855.4471)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4471)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060070650189855.4471)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4471)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269060559989189856.4471)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4471)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061028359189856.4471)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4471)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269061478998189856.4471)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4471)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062069508189856.4471)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4471)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(269062521535189857.4471)
,p_page_template_id=>wwv_flow_api.id(851040471818626394.4471)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_sign_up_wizard
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851041812938626395.4471)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Sign Up Wizard.es'
,p_internal_name=>'APEX_5.0_SIGN_UP_WIZARD'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--simpleWizard" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'<div class="u-Layout u-Layout--centerVertically">',
'  #BODY#',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702692008314080052.4471
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163743791347677.4471)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4471)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163890712347677.4471)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4471)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140163982775347677.4471)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4471)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164006858347677.4471)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4471)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164176675347677.4471)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4471)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164264131347677.4471)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4471)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140164343110347677.4471)
,p_page_template_id=>wwv_flow_api.id(851041812938626395.4471)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_api.create_template(
 p_id=>wwv_flow_api.id(851042476105626395.4471)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page.es'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#APEX_JAVASCRIPT# ',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div class="u-Layout u-Layout--centerVertically">',
'  <div class="a-Wizard a-Wizard--default">',
'    #REGION_POSITION_02#',
'    <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'    <div class="a-Wizard-body">#BODY#</div>',
'    <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'  </div>',
'</div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-user" title="&MSG_USER."></span>',
'      <span class="u-VisuallyHidden">&MSG_USER.</span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-workspace" title="&MSG_WORKSPACE."></span>',
'      <span class="u-VisuallyHidden">&MSG_WORKSPACE.</span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span class="a-Icon icon-language" title="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#GENERATED_CSS#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" role="alert" id="errorMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="errorMsg-Message">#MESSAGE#</h5>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'');return false;"><span class="a-Ico'
||'n icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'BODY_3'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477.4471
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165035853347674.4471)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4471)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165105515347674.4471)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4471)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165240488347674.4471)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4471)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165340836347674.4471)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4471)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165473370347674.4471)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4471)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165515674347674.4471)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4471)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_page_tmpl_display_point(
 p_id=>wwv_flow_api.id(140165694196347674.4471)
,p_page_template_id=>wwv_flow_api.id(851042476105626395.4471)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514381861202541059.4471)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475.4471
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382190540541061.4471)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615.4471
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(514382538845541061.4471)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301.4471
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_large
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629666890811728.4471)
,p_template_name=>'APEX 5.0 - Button (Large)'
,p_internal_name=>'APEX_5.0_BUTTON_LARGE'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--large a-Button--hot #BUTTON_CSS_CLASSES#" type="button" role="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174756119980565636.4471
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_small
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(620629778318811745.4471)
,p_template_name=>'APEX 5.0 - Button (Small)'
,p_internal_name=>'APEX_5.0_BUTTON_SMALL'
,p_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button value="#LABEL!ATTR#" onclick="#JAVASCRIPT#" class="a-Button a-Button--small a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174755910284562884.4471
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_api.create_button_templates(
 p_id=>wwv_flow_api.id(868252865986181054.4471)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233.4471
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514338947870435171.4471)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174748721787471587.4471
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143405975518340709.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406085485340709.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406168378340709.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406270366340709.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406371972340709.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406493020340708.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406554385340708.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406692306340708.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406747305340708.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406811703340708.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143406940024340708.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407082581340708.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407110986340708.4471)
,p_plug_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(514343873675436760.4471)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760.4471
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407202750340708.4471)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4471)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407359309340707.4471)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4471)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407475956340707.4471)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4471)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407586842340707.4471)
,p_plug_template_id=>wwv_flow_api.id(514343873675436760.4471)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(771803843049318447.4471)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099.4471
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407695677340707.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407764991340707.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407888229340707.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143407939357340707.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408003435340707.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408143312340707.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408206123340706.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408351234340706.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408443044340706.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408520126340706.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408600823340706.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408783461340706.4471)
,p_plug_template_id=>wwv_flow_api.id(771803843049318447.4471)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850406444708718383.4471)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>687153470345619376.4471
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408840730340706.4471)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143408984947340706.4471)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409077112340706.4471)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409105003340706.4471)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409262902340705.4471)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409316978340705.4471)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409413495340705.4471)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409513204340705.4471)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409624820340705.4471)
,p_plug_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(850442966147812557.4471)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 class="u-VisuallyHidden">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>702777601713950915.4471
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409767168340705.4471)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4471)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409825123340705.4471)
,p_plug_template_id=>wwv_flow_api.id(850442966147812557.4471)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(856206049762521193.4471)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #BODY#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      #PREVIOUS##CLOSE##CREATE##NEXT#',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>746362351042209764.4471
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143409979473340705.4471)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410082302340705.4471)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410172873340704.4471)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410278786340704.4471)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410369941340704.4471)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410473248340704.4471)
,p_plug_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914802799655239969.4471)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480.4471
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410569446340704.4471)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4471)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143410685133340704.4471)
,p_plug_template_id=>wwv_flow_api.id(914802799655239969.4471)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(914803495164240003.4471)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769.4471
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418798026340694.4471)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4471)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418882854340694.4471)
,p_plug_template_id=>wwv_flow_api.id(914803495164240003.4471)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915210356236972585.4471)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#><h2 class="u-VisuallyHidden">#TITLE#</h2>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>678354360586321695.4471
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143418912636340694.4471)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4471)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419028911340693.4471)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4471)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419193341340693.4471)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4471)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419232024340693.4471)
,p_plug_template_id=>wwv_flow_api.id(915210356236972585.4471)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(915371118115573423.4471)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>689955986849128825.4471
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419351130340693.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419433470340693.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419510757340693.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419662625340693.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419708090340693.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419872972340693.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143419977851340692.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420075889340692.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420134349340692.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420241403340692.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420369250340692.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420425928340692.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420576629340692.4471)
,p_plug_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_api.create_plug_template(
 p_id=>wwv_flow_api.id(1274355059486017828.4471)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726.4471
,p_translate_this_template=>'N'
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420676303340692.4471)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4471)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_api.create_plug_tmpl_display_point(
 p_id=>wwv_flow_api.id(143420779344340692.4471)
,p_plug_template_id=>wwv_flow_api.id(1274355059486017828.4471)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332014414430986.4471)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>',
''))
,p_reference_id=>573607518145151423.4471
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(514332292784430987.4471)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#">#TEXT_ESC_SC#</a>'
,p_reference_id=>747588010155545129.4471
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(860563697365629462.4471)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508.4471
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(865273508717512144.4471)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310.4471
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(908020362212234651.4471)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active" aria-current="page">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <a href="#LINK#" class="a-MediaList-link" #A03#>',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title">#TEXT#</h3>',
'            <p class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </a>',
'</li>'))
,p_list_template_name=>'APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060.4471
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_api.create_list_template(
 p_id=>wwv_flow_api.id(914818080687341593.4471)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083.4471
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851049711466639395.4471)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851054516889639461.4471)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851055225644639463.4471)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(851056531929639482.4471)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792024808213039.4471)
,p_row_template_name=>'APEX 5.0 - Portlet  Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(914792322768213043.4471)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_one_column_unordered_list
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(915377874236666939.4471)
,p_row_template_name=>'APEX 5.0 - One Column Unordered List'
,p_internal_name=>'APEX_5.0_ONE_COLUMN_UNORDERED_LIST'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_after_column_heading=>'<tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_api.create_row_template(
 p_id=>wwv_flow_api.id(1041941432531249038.4471)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_condition1=>':CARD_LINK is null'
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#CARD_LINK#" class="a-AppCards-link">',
'      <div class="a-AppCards-iconContainer">',
'        <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'      </div>',
'      <div class="a-AppCards-contentContainer" id="#ID#_name">',
'        <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'        <div class="a-AppCards-info">#APP_INFO#</div>',
'      </div>',
'    </a>',
'  </div>',
'</li>'))
,p_row_template_condition2=>':CARD_LINK is not null'
,p_row_template_before_rows=>'<ul class="a-AppCards #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(850683711614406253.4471)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help"></span><span cl'
||'ass="u-VisuallyHidden">#CURRENT_ITEM_HELP_LABEL#</span></button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799.4471
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047536471633848.4471)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047676005633854.4471)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047684809633856.4471)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(851047795461633856.4471)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(860542631889572088.4471)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_api.create_field_template(
 p_id=>wwv_flow_api.id(1321751941832424103.4471)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_api.create_menu_template(
 p_id=>wwv_flow_api.id(514333590213433126.4471)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>6
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711.4471
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_api.create_popup_lov_template(
 p_id=>wwv_flow_api.id(649611704621764507.4471)
,p_page_name=>'winlov'
,p_page_title=>unistr('Cuadro de di\00E1logo de b\00FAsqueda')
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Buscar'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Cerrar'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Siguiente &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Anterior'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Filas #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872.4471
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_api.create_calendar_template(
 p_id=>wwv_flow_api.id(649611609668764506.4471)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967.4471
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
null;
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(182005134783173294.4471)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074212329754757.4471)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(666074525535755551.4471)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_api.create_theme_style(
 p_id=>wwv_flow_api.id(717250289307903026.4471)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(806925000765340952.4471)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380142596819918.4471)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808380828683819918.4471)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808381542095819918.4471)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(808383088145819924.4471)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850406791580718389.4471)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407096779718396.4471)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(850407509193718398.4471)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851050160062639437.4471)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(851051045625639457.4471)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856113214217058023.4471)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114568019058024.4471)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856114830529058024.4471)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856115135223058024.4471)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116214022058024.4471)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116523282058024.4471)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856116798725058025.4471)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117102944058028.4471)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117454663058028.4471)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856117908453058029.4471)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856118261810058029.4471)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206461450521195.4471)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(856206736628521198.4471)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860570508910721307.4471)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(860571060920721309.4471)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_opt_group(
 p_id=>wwv_flow_api.id(908020718209234676.4471)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134384175764258.4471)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134654971764258.4471)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857134823880764258.4471)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135009020764258.4471)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135269851764258.4471)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_api.id(856117102944058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135477215764258.4471)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_api.id(856117454663058028)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135634744764258.4471)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857135785730764258.4471)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136068296764258.4471)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_api.id(856115135223058024)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136225140764258.4471)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_api.id(856118261810058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136360666764258.4471)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136507481764259.4471)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_api.id(856116798725058025)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136620486764259.4471)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857136861925764259.4471)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137023291764259.4471)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137193234764259.4471)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_api.id(856116523282058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137470293764259.4471)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_api.id(856114568019058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137586003764259.4471)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_api.id(856116214022058024)
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137737661764259.4471)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857137933035764259.4471)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138175863764259.4471)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_api.id(856114830529058024)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138340877764259.4471)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138553321764259.4471)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138777457764259.4471)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857138891974764260.4471)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139153872764260.4471)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857139375337764260.4471)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_api.id(856113214217058023)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145206107768768.4471)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145328630768768.4471)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145505007768768.4471)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145725778768768.4471)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857145892117768768.4471)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146085228768768.4471)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146322225768769.4471)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146393064768769.4471)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857146615368768769.4471)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(856206049762521193.4471)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_api.id(856206461450521195)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147042367768771.4471)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147189725768771.4471)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147385795768771.4471)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147655668768771.4471)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147872948768771.4471)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857147976018768771.4471)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148162424768771.4471)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857148341454768771.4471)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(850406444708718383.4471)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149438708768778.4471)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149614105768778.4471)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149843563768778.4471)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857149998210768778.4471)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150194417768778.4471)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150439507768778.4471)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150608654768780.4471)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857150792333768780.4471)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_api.id(851051045625639457)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151008734768780.4471)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151259777768780.4471)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151408063768780.4471)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151643103768780.4471)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(857151861194768780.4471)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851049711466639395.4471)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_api.id(851050160062639437)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798730495581814.4471)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4471)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896798963380581814.4471)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4471)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799089194581814.4471)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4471)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799349986581814.4471)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4471)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799577541581814.4471)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4471)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799637215581814.4471)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4471)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(896799807498581814.4471)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851056531929639482.4471)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022191342234716.4471)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4471)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022392217234716.4471)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4471)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022597980234716.4471)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4471)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908022867300234717.4471)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4471)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023065592234717.4471)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4471)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_api.id(908020718209234676)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023131122234717.4471)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4471)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023191297234717.4471)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4471)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023315038234717.4471)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4471)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023432264234717.4471)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4471)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(908023494059234717.4471)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(908020362212234651.4471)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378094918666945.4471)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4471)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_api.id(808380142596819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378225037666947.4471)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4471)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_api.id(808380828683819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378370589666947.4471)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4471)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378467813666947.4471)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4471)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378526097666947.4471)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4471)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378615102666947.4471)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4471)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_api.id(808383088145819924)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(915378735377666947.4471)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(915377874236666939.4471)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_api.id(808381542095819918)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071796325339624.4471)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4471)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1036071972285339624.4471)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(514332292784430987.4471)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1050367122398973653.4471)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(865273508717512144.4471)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1309233880682664517.4471)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_api.id(868252865986181054.4471)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_api.id(856117908453058029)
,p_template_types=>'BUTTON'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1351338307429029043.4471)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(1274355059486017828.4471)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333722717814196.4471)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4471)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333859287814196.4471)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4471)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635333887728814196.4471)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4471)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334039640814196.4471)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4471)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334247146814196.4471)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4471)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1635334455135814196.4471)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_api.id(914818080687341593.4471)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_api.id(806925000765340952)
,p_template_types=>'LIST'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491342397110118.4471)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4471)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491390428110118.4471)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4471)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1654491480011110118.4471)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_api.id(851055225644639463.4471)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
end;
/
begin
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488722406040473.4471)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664488933681040473.4471)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_api.id(850406791580718389)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489165994040473.4471)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489304869040473.4471)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489519844040473.4471)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489753255040473.4471)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664489941797040473.4471)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490153471040473.4471)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490336091040473.4471)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490377667040473.4471)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664490659850040473.4471)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(514338947870435171.4471)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664501980442158869.4471)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4471)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502160891158869.4471)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4471)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664502181188158869.4471)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915210356236972585.4471)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508367504174332.4471)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508426350174332.4471)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508588305174332.4471)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664508810521174332.4471)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_api.id(850407096779718396)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509005841174332.4471)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_api.id(860570508910721307)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509270186174332.4471)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_api.id(850407509193718398)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509448573174333.4471)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509659839174333.4471)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_api.id(860571060920721309)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664509822387174334.4471)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
wwv_flow_api.create_template_option(
 p_id=>wwv_flow_api.id(1664510028962174334.4471)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_api.id(915371118115573423.4471)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_api.id(856206736628521198)
,p_template_types=>'REGION'
);
end;
/
prompt --application/shared_components/globalization/language
begin
null;
end;
/
prompt --application/shared_components/logic/build_options
begin
null;
end;
/
prompt --application/shared_components/globalization/messages
begin
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111453607197399399)
,p_name=>'4150_COLUMN_NUMBER'
,p_message_language=>'es'
,p_message_text=>'Columna %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111440723299399390)
,p_name=>'ACCESS_CONTROL_ADMIN'
,p_message_language=>'es'
,p_message_text=>'Administrador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111440619814399390)
,p_name=>'ACCESS_CONTROL_USERNAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111497939069399433)
,p_name=>'ACCESS_DENIED_SIMPLE'
,p_message_language=>'es'
,p_message_text=>'Acceso denegado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111457690134399402)
,p_name=>'ACCOUNT_HAS_BEEN_CREATED'
,p_message_language=>'es'
,p_message_text=>'Se ha creado la cuenta %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111443228505399392)
,p_name=>'ACCOUNT_LOCKED'
,p_message_language=>'es'
,p_message_text=>unistr('La cuenta est\00E1 bloqueada.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111433121664399384)
,p_name=>'AM_PM'
,p_message_language=>'es'
,p_message_text=>'AM / PM'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111567584953399484)
,p_name=>'APEX.ACTIONS.TOGGLE'
,p_message_language=>'es'
,p_message_text=>'Conmutar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111575636735399490)
,p_name=>'APEX.ACTIVE_STATE'
,p_message_language=>'es'
,p_message_text=>'(Activo)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111545158461399468)
,p_name=>'APEX.AJAX_SERVER_ERROR'
,p_message_language=>'es'
,p_message_text=>'La llamada Ajax ha devuelto el error de servidor %0 para %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111475949328399416)
,p_name=>'APEX.APPLICATION.ALIAS.NON_UNIQUE'
,p_message_language=>'es'
,p_message_text=>unistr('El alias de aplicaci\00F3n "%0" no se puede convertir en un identificador de aplicaci\00F3n \00FAnico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111476041115399416)
,p_name=>'APEX.APPLICATION.ALIAS.NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('La aplicaci\00F3n con el alias "%0" no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111465661282399408)
,p_name=>'APEX.APPLICATION.ALIAS.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1816: Error inesperado al convertir el alias de aplicaci\00F3n p_flow_alias_or_id (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111558553056399478)
,p_name=>'APEX.APPLICATION.CHECKSUM.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('El total de control de la aplicaci\00F3n ofrece un m\00E9todo sencillo para saber si la misma aplicaci\00F3n est\00E1 desplegada en distintos espacios de trabajo. Puede comparar la suma de control para detectar si hay alguna coincidencia. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111451412491399398)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNC.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la funci\00F3n de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111436811526399387)
,p_name=>'APEX.AUTHENTICATION.AUTH_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la funci\00F3n de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111600398902399509)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.HOST_PREFIX_MISMATCH'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de inquilino %0 devuelto por Oracle Cloud Identity Management no est\00E1 autorizado para el dominio %1.<br/><a href="&LOGOUT_URL.">Vuelva a conectarse</a> y especifique un nombre de inquilino autorizado o cambie la URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111434592389399385)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.USER_IS_NOT_DEVELOPER'
,p_message_language=>'es'
,p_message_text=>'La cuenta "%0" no tiene los privilegios de desarrollo necesarios (DB_DEVELOPER o DB_ADMINISTRATOR)<br/>para el espacio de trabajo "%1". <a href="&LOGOUT_URL.">Vuelva a conectarse</a> una vez que se hayan proporcionado los privilegios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111433627204399384)
,p_name=>'APEX.AUTHENTICATION.CLOUD_IDM.WRONG_GROUP_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de inquilino devuelto por Oracle Cloud Identity Management no est\00E1 autorizado para el espacio de trabajo actual.<br/><a href="&LOGOUT_URL.">Vuelva a conectarse</a> y especifique un nombre de inquilino autorizado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111434658068399385)
,p_name=>'APEX.AUTHENTICATION.HOST_PREFIX_MISMATCH'
,p_message_language=>'es'
,p_message_text=>unistr('Por motivos de seguridad, no est\00E1 permitida la ejecuci\00F3n de aplicaciones de este espacio de trabajo a trav\00E9s del dominio de la URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111451119828399397)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.ASK_FOR_INSTALLATION'
,p_message_language=>'es'
,p_message_text=>'Pida al DBA que ejecute $OH/rdbms/admin/catldap.sql.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111451031335399397)
,p_name=>'APEX.AUTHENTICATION.LDAP.DBMS_LDAP.MISSING'
,p_message_language=>'es'
,p_message_text=>unistr('El paquete SYS.DBMS_LDAP no existe o no es v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111450904261399397)
,p_name=>'APEX.AUTHENTICATION.LDAP.EDIT_USER_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la funci\00F3n de edici\00F3n del usuario LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111451276044399398)
,p_name=>'APEX.AUTHENTICATION.LDAP.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la autenticaci\00F3n de LDAP.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111452005450399398)
,p_name=>'APEX.AUTHENTICATION.LOGIN.ILLEGAL_PAGE_ARG'
,p_message_language=>'es'
,p_message_text=>'Error en el argumento p_flow_page para el procedimiento login_page.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111451655947399398)
,p_name=>'APEX.AUTHENTICATION.LOGIN.INVALID_ARG'
,p_message_language=>'es'
,p_message_text=>unistr('p_session no v\00E1lido en wwv_flow_custom_auth_std.login--p_flow_page:%0 p_session_id:%1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111499513532399434)
,p_name=>'APEX.AUTHENTICATION.LOGIN.MALFORMED_ARGS'
,p_message_language=>'es'
,p_message_text=>'Argumento con formato incorrecto en wwv_flow_custom_auth_std.login--p_flow_page:p_session_id:p_entry_point:%0:%1:%2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111451740703399398)
,p_name=>'APEX.AUTHENTICATION.LOGIN.NULL_USER'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha transferido un nombre de usuario nulo al procedimiento de conexi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111440580332399390)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.COUNTER'
,p_message_language=>'es'
,p_message_text=>'Espere <span id="apex_login_throttle_sec">%0</span> segundos para volver a conectarse.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111441890075399391)
,p_name=>'APEX.AUTHENTICATION.LOGIN_THROTTLE.ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('El intento de conexi\00F3n se ha bloqueado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111497348927399432)
,p_name=>'APEX.AUTHENTICATION.NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la autenticaci\00F3n "%0"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111442151685399391)
,p_name=>'APEX.AUTHENTICATION.NO_SECURITY_GROUP_ID'
,p_message_language=>'es'
,p_message_text=>'El identificador de grupo de seguridad es nulo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111451566651399398)
,p_name=>'APEX.AUTHENTICATION.POST_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al ejecutar el proceso de autenticaci\00F3n posterior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111451310224399398)
,p_name=>'APEX.AUTHENTICATION.PRE_AUTH_PROC.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la autenticaci\00F3n previa.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111452522084399399)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD.INSTRUCTIONS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Abra la URL en el mismo explorador en el que haya iniciado la solicitud de restablecimiento de la contrase\00F1a. Si hace clic en Restablecer URL de contrase\00F1a y se le redirige'),
unistr('a la p\00E1gina de conexi\00F3n, vuelva a iniciar Restablecer contrase\00F1a y deje el'),
'explorador abierto.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111597856312399507)
,p_name=>'APEX.AUTHENTICATION.RESET_PASSWORD_URL'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer URL de Contrase\00F1a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111434806487399385)
,p_name=>'APEX.AUTHENTICATION.RM_GROUP_NOT_GRANTED'
,p_message_language=>'es'
,p_message_text=>'El grupo de consumidores %0 del gestor de recursos no se ha otorgado a %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111434940835399385)
,p_name=>'APEX.AUTHENTICATION.RM_INFO_TO_GRANT'
,p_message_language=>'es'
,p_message_text=>'Utilice DBMS_RESOURCE_MANAGER_PRIVS.GRANT_SWITCH_CONSUMER_GROUP para otorgar el privilegio que falta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111462972733399406)
,p_name=>'APEX.AUTHENTICATION.SESSION_SENTRY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la funci\00F3n de protecci\00F3n de sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111463062260399406)
,p_name=>'APEX.AUTHENTICATION.SESSION_VERIFY_FUNCTION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la funci\00F3n de verificaci\00F3n de sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111463268563399406)
,p_name=>'APEX.AUTHENTICATION.SSO.ASK_FOR_INSTALLATION'
,p_message_language=>'es'
,p_message_text=>'Pida al administrador de %0 que configure el motor para Oracle Application Server Single Sign-On.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111472758309399413)
,p_name=>'APEX.AUTHENTICATION.SSO.BAD_URLC'
,p_message_language=>'es'
,p_message_text=>unistr('SSO ha devuelto un token %0 en %1 no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111451952395399398)
,p_name=>'APEX.AUTHENTICATION.SSO.FIX_PARTNER_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Edite el esquema de autenticaci\00F3n y agregue el nombre de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111472400652399413)
,p_name=>'APEX.AUTHENTICATION.SSO.ILLEGAL_CALLER'
,p_message_language=>'es'
,p_message_text=>unistr('Llamada no v\00E1lida del procedimiento %0:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111472671496399413)
,p_name=>'APEX.AUTHENTICATION.SSO.INVALID_APP_SESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Sesi\00F3n de aplicaci\00F3n no v\00E1lida en el token urlc: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111472223000399413)
,p_name=>'APEX.AUTHENTICATION.SSO.MISSING_APP_REGISTRATION'
,p_message_language=>'es'
,p_message_text=>unistr('Error en portal_sso_redirect: falta la informaci\00F3n de registro de la aplicaci\00F3n: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111463185254399406)
,p_name=>'APEX.AUTHENTICATION.SSO.PACKAGE_MISSING'
,p_message_language=>'es'
,p_message_text=>unistr('El paquete WWSEC_SSO_ENABLER_PRIVATE no existe o no es v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111451855192399398)
,p_name=>'APEX.AUTHENTICATION.SSO.PARTNER_APP_IS_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado el nombre de la aplicaci\00F3n asociada registrado en el esquema de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111472395870399413)
,p_name=>'APEX.AUTHENTICATION.SSO.REGISTER_APP'
,p_message_language=>'es'
,p_message_text=>unistr('Registre esta aplicaci\00F3n como se describe en la gu\00EDa de instalaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111463332925399407)
,p_name=>'APEX.AUTHENTICATION.SSO.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la autenticaci\00F3n de SSO.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111572705964399488)
,p_name=>'APEX.AUTHENTICATION.UNAUTHORIZED_URL'
,p_message_language=>'es'
,p_message_text=>'URL no autorizada: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111462724778399406)
,p_name=>'APEX.AUTHENTICATION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111434748776399385)
,p_name=>'APEX.AUTHENTICATION.WORKSPACE_NOT_ASSIGNED'
,p_message_language=>'es'
,p_message_text=>unistr('El espacio de trabajo "%0" est\00E1 inactivo. P\00F3ngase en contacto con el administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111435144022399385)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED'
,p_message_language=>'es'
,p_message_text=>'%0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111441528007399390)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Acceso denegado por la comprobaci\00F3n de seguridad de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111441605251399390)
,p_name=>'APEX.AUTHORIZATION.ACCESS_DENIED.PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Acceso denegado por la comprobaci\00F3n de seguridad de la p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111441763374399390)
,p_name=>'APEX.AUTHORIZATION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar la autorizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111505148639399438)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX'
,p_message_language=>'es'
,p_message_text=>'Creado con %0 mediante %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111505240488399438)
,p_name=>'APEX.BUILT_WITH_LOVE_USING_APEX.ACCESSIBLE.LOVE'
,p_message_language=>'es'
,p_message_text=>'amor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111563006442399481)
,p_name=>'APEX.CALENDAR.EVENT_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n del evento')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111562838199399481)
,p_name=>'APEX.CALENDAR.EVENT_END'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de finalizaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111563136872399481)
,p_name=>'APEX.CALENDAR.EVENT_ID'
,p_message_language=>'es'
,p_message_text=>'ID del evento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111562762217399481)
,p_name=>'APEX.CALENDAR.EVENT_START'
,p_message_language=>'es'
,p_message_text=>'Fecha de inicio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111562984672399481)
,p_name=>'APEX.CALENDAR.EVENT_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo del Evento')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111453548648399399)
,p_name=>'APEX.CHECKSUM.CONTENT_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error de contenido del total de control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111453410070399399)
,p_name=>'APEX.CHECKSUM.FORMAT_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error de formato del total de control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111517430873399447)
,p_name=>'APEX.CLIPBOARD.COPIED'
,p_message_language=>'es'
,p_message_text=>'Copiado en el portapapeles.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111517114380399447)
,p_name=>'APEX.CLIPBOARD.NOTSUP'
,p_message_language=>'es'
,p_message_text=>unistr('Este explorador no soporta la copia de botones y men\00FAs. Utilice Ctrl+C o Comando+C.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111505608333399438)
,p_name=>'APEX.CLOSE_NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Cerrar notificaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111561608625399480)
,p_name=>'APEX.COLOR_PICKER.CONTRAST'
,p_message_language=>'es'
,p_message_text=>'Contraste'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111556173185399476)
,p_name=>'APEX.COLOR_PICKER.CURRENT'
,p_message_language=>'es'
,p_message_text=>'Actual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111556081970399476)
,p_name=>'APEX.COLOR_PICKER.INITIAL'
,p_message_language=>'es'
,p_message_text=>'Inicial'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111560200655399479)
,p_name=>'APEX.COLOR_PICKER.INVALID_COLOR'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser un color v\00E1lido. Ejemplo: %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111555955287399476)
,p_name=>'APEX.COLOR_PICKER.TITLE'
,p_message_language=>'es'
,p_message_text=>'Seleccionar un color'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111556292804399476)
,p_name=>'APEX.COLOR_PICKER.TOGGLE_TITLE'
,p_message_language=>'es'
,p_message_text=>'Cambiar formato de color'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111595414735399505)
,p_name=>'APEX.COMBOBOX.LIST_OF_VALUES'
,p_message_language=>'es'
,p_message_text=>'Lista de valores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111595597396399505)
,p_name=>'APEX.COMBOBOX.SHOW_ALL_VALUES'
,p_message_language=>'es'
,p_message_text=>'Abrir lista para: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111575780957399491)
,p_name=>'APEX.COMPLETED_STATE'
,p_message_language=>'es'
,p_message_text=>'(Completado)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111468023493399410)
,p_name=>'APEX.CONTACT_ADMIN'
,p_message_language=>'es'
,p_message_text=>unistr('P\00F3ngase en contacto con el administrador de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111482430515399420)
,p_name=>'APEX.CONTACT_ADMIN.DEBUG'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('P\00F3ngase en contacto con el administrador de la aplicaci\00F3n.'),
unistr('Hay m\00E1s detalles sobre este incidente disponibles mediante el ID de depuraci\00F3n "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111560527637399479)
,p_name=>'APEX.CORRECT_ERRORS'
,p_message_language=>'es'
,p_message_text=>'Corrija los errores antes de guardar.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111506521585399439)
,p_name=>'APEX.CS.MATCHES_FOUND'
,p_message_language=>'es'
,p_message_text=>'%0 coincidencias encontradas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111506468527399439)
,p_name=>'APEX.CS.NO_MATCHES'
,p_message_language=>'es'
,p_message_text=>'No se han encontrado coincidencias'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111576239219399491)
,p_name=>'APEX.CURRENT_PROGRESS'
,p_message_language=>'es'
,p_message_text=>'Progreso actual'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111560963508399480)
,p_name=>'APEX.DATA.LOAD.FILE_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>'El archivo especificado en el elemento %0 no existe en APEX_APPLICATION_TEMP_FILES.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111549450888399471)
,p_name=>'APEX.DATA_HAS_CHANGED'
,p_message_language=>'es'
,p_message_text=>unistr('La versi\00F3n actual de los datos de la base de datos ha cambiado desde que el usuario inici\00F3 el proceso de actualizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111518507910399448)
,p_name=>'APEX.DATA_LOAD.DO_NOT_LOAD'
,p_message_language=>'es'
,p_message_text=>'No Cargar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111565561936399483)
,p_name=>'APEX.DATA_LOAD.FAILED'
,p_message_language=>'es'
,p_message_text=>'Error de preprocesamiento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111565378676399483)
,p_name=>'APEX.DATA_LOAD.INSERT'
,p_message_language=>'es'
,p_message_text=>'Insertar Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111579470475399493)
,p_name=>'APEX.DATA_LOAD.SEQUENCE_ACTION'
,p_message_language=>'es'
,p_message_text=>unistr('Secuencia: Acci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111565404846399483)
,p_name=>'APEX.DATA_LOAD.UPDATE'
,p_message_language=>'es'
,p_message_text=>'Actualizar fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111506917184399439)
,p_name=>'APEX.DATEPICKER.ICON_TEXT'
,p_message_language=>'es'
,p_message_text=>'Calendario emergente: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111429596662399381)
,p_name=>'APEX.DATEPICKER_JET.NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111429631456399381)
,p_name=>'APEX.DATEPICKER_JET.PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111565757374399483)
,p_name=>'APEX.DATEPICKER_JET.REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111565686414399483)
,p_name=>'APEX.DATEPICKER_JET.VALUE_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser una fecha v\00E1lida, por ejemplo: %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111433241928399384)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_BETWEEN'
,p_message_language=>'es'
,p_message_text=>'#LABEL# debe estar entre %0 y %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111433318670399384)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_AFTER'
,p_message_language=>'es'
,p_message_text=>'#LABEL# debe ser igual o posterior a %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111433493619399384)
,p_name=>'APEX.DATEPICKER_JET.VALUE_MUST_BE_ON_OR_BEFORE'
,p_message_language=>'es'
,p_message_text=>'#LABEL# debe ser igual o anterior a %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111510417923399442)
,p_name=>'APEX.DATEPICKER_VALUE_GREATER_MAX_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# es posterior a la fecha m\00E1xima especificada %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111510847759399442)
,p_name=>'APEX.DATEPICKER_VALUE_INVALID'
,p_message_language=>'es'
,p_message_text=>'#LABEL# no coincide con el formato %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111510373174399442)
,p_name=>'APEX.DATEPICKER_VALUE_LESS_MIN_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# es anterior a la fecha m\00EDnima especificada %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111510546778399442)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# no se encuentra en el rango v\00E1lido de %0 a %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111510735073399442)
,p_name=>'APEX.DATEPICKER_VALUE_NOT_IN_YEAR_RANGE'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# no est\00E1 en el rango v\00E1lido de a\00F1o de %0 y %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111560820862399479)
,p_name=>'APEX.DIALOG.CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111588010961399500)
,p_name=>'APEX.DIALOG.CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111590038130399501)
,p_name=>'APEX.DIALOG.HELP'
,p_message_language=>'es'
,p_message_text=>'Ayuda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111560641553399479)
,p_name=>'APEX.DIALOG.OK'
,p_message_language=>'es'
,p_message_text=>'Aceptar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111560750317399479)
,p_name=>'APEX.DIALOG.SAVE'
,p_message_language=>'es'
,p_message_text=>'Guardar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111466941633399409)
,p_name=>'APEX.ERROR'
,p_message_language=>'es'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111434398295399385)
,p_name=>'APEX.ERROR.CALLBACK_FAILED'
,p_message_language=>'es'
,p_message_text=>'Se ha producido el siguiente error al ejecutar la llamada de manejo de error: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111443029539399391)
,p_name=>'APEX.ERROR.ERROR_PAGE.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha producido un error al pintar la p\00E1gina de error: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111435006624399385)
,p_name=>'APEX.ERROR.INTERNAL'
,p_message_language=>'es'
,p_message_text=>'Error interno'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111574899334399490)
,p_name=>'APEX.ERROR.INTERNAL.CONTACT_ADMINISTRATOR'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('P\00F3ngase en contacto con el administrador.'),
unistr('Hay m\00E1s detalles sobre este incidente disponibles mediante el ID de depuraci\00F3n "%0".')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111569153740399486)
,p_name=>'APEX.ERROR.ORA-16000'
,p_message_language=>'es'
,p_message_text=>unistr('La base de datos est\00E1 abierta para el acceso de solo lectura.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111599717453399509)
,p_name=>'APEX.ERROR.ORA-28353'
,p_message_language=>'es'
,p_message_text=>unistr('ORA-28353: Fallo al abrir la cartera. No se puede acceder actualmente a los datos de la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111569290171399486)
,p_name=>'APEX.ERROR.PAGE_NOT_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina no est\00E1 disponible')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111436773569399387)
,p_name=>'APEX.ERROR.TECHNICAL_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n T\00E9cnica (visible s\00F3lo para los desarrolladores)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111532825768399458)
,p_name=>'APEX.ERROR_MESSAGE_HEADING'
,p_message_language=>'es'
,p_message_text=>'Mensaje de error'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111546764968399469)
,p_name=>'APEX.EXPECTED_FORMAT'
,p_message_language=>'es'
,p_message_text=>'Formato esperado: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111513428850399444)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.ALREADY_IN_ACL'
,p_message_language=>'es'
,p_message_text=>unistr('El usuario ya est\00E1 en la lista de control de acceso')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111513393512399444)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.CREATE_CONFIRM'
,p_message_language=>'es'
,p_message_text=>unistr('Confirme la adici\00F3n de los siguientes %0 usuarios a la lista de control de acceso de <strong>%1</strong>.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111513869944399444)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.DUPLICATE_USER'
,p_message_language=>'es'
,p_message_text=>'Existe un usuario duplicado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111513553688399444)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_AT_SIGN'
,p_message_language=>'es'
,p_message_text=>unistr('Falta el s\00EDmbolo arroba (@) en la direcci\00F3n de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111513694548399444)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.MISSING_DOT'
,p_message_language=>'es'
,p_message_text=>unistr('Falta "." en la direcci\00F3n de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111513735570399444)
,p_name=>'APEX.FEATURE.ACL.BULK_USER.USERNAME_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>'El nombre de usuario es demasiado largo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111514040370399444)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('Solo se permite el acceso a la aplicaci\00F3n a los usuarios definidos en la lista de control de acceso de la aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111514185340399445)
,p_name=>'APEX.FEATURE.ACL.INFO.ACL_VALUE_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de configuraci\00F3n de control de acceso no esperado: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111513977289399444)
,p_name=>'APEX.FEATURE.ACL.INFO.ALL_USERS'
,p_message_language=>'es'
,p_message_text=>unistr('Todos los usuarios autenticados pueden acceder a esta aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111556748848399476)
,p_name=>'APEX.FEATURE.CONFIG.DISABLED'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111556660915399476)
,p_name=>'APEX.FEATURE.CONFIG.ENABLED'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111556942651399477)
,p_name=>'APEX.FEATURE.CONFIG.IS_DISABLED'
,p_message_language=>'es'
,p_message_text=>'%0: desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111556875250399476)
,p_name=>'APEX.FEATURE.CONFIG.IS_ENABLED'
,p_message_language=>'es'
,p_message_text=>'%0: activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111556557148399476)
,p_name=>'APEX.FEATURE.TOP_USERS.USERNAME.NOT_IDENTIFIED'
,p_message_language=>'es'
,p_message_text=>'sin identificar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111549650879399471)
,p_name=>'APEX.FILE_BROWSE.DOWNLOAD_LINK_TEXT'
,p_message_language=>'es'
,p_message_text=>'Descargar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111506185038399439)
,p_name=>'APEX.FS.APPLIED_FACET'
,p_message_language=>'es'
,p_message_text=>'Filtro aplicado %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111547272867399469)
,p_name=>'APEX.FS.BATCH_APPLY'
,p_message_language=>'es'
,p_message_text=>'Aplicar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111432137342399383)
,p_name=>'APEX.FS.CHART_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico de barras')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111559930277399479)
,p_name=>'APEX.FS.CHART_OTHERS'
,p_message_language=>'es'
,p_message_text=>'Otros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111432292235399383)
,p_name=>'APEX.FS.CHART_PIE'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico circular')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111558646394399478)
,p_name=>'APEX.FS.CHART_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111431913851399383)
,p_name=>'APEX.FS.CHART_VALUE_LABEL'
,p_message_language=>'es'
,p_message_text=>'Recuento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111547714780399470)
,p_name=>'APEX.FS.CLEAR'
,p_message_language=>'es'
,p_message_text=>'Borrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111547852475399470)
,p_name=>'APEX.FS.CLEAR_ALL'
,p_message_language=>'es'
,p_message_text=>'Borrar todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111547983733399470)
,p_name=>'APEX.FS.CLEAR_VALUE'
,p_message_language=>'es'
,p_message_text=>'Borrar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111565106449399483)
,p_name=>'APEX.FS.COLUMN_UNAUTHORIZED'
,p_message_language=>'es'
,p_message_text=>unistr('La columna %1, a la que hace referencia la faceta %0, no est\00E1 disponible o autorizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111422375411399376)
,p_name=>'APEX.FS.CONFIG_TITLE'
,p_message_language=>'es'
,p_message_text=>'Seleccione los filtros que desee mostrar'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111504393637399437)
,p_name=>'APEX.FS.COUNT_RESULTS'
,p_message_language=>'es'
,p_message_text=>'%0 resultados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111504479372399437)
,p_name=>'APEX.FS.COUNT_SELECTED'
,p_message_language=>'es'
,p_message_text=>'%0 seleccionados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111507049502399439)
,p_name=>'APEX.FS.CUR_FILTERS_LM'
,p_message_language=>'es'
,p_message_text=>'Filtros Actuales'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111423836949399377)
,p_name=>'APEX.FS.FACETS_LIST'
,p_message_language=>'es'
,p_message_text=>'Lista de filtros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111563615719399481)
,p_name=>'APEX.FS.FACET_VALUE_LIMIT_EXCEEDED'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDmite de valor distinto (%0) superado para la faceta %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111549215258399471)
,p_name=>'APEX.FS.FC_TYPE_UNSUPPORTED_FOR_DATE_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'La faceta %0 no se soporta en columnas DATE o TIMESTAMP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111547339268399469)
,p_name=>'APEX.FS.FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtrar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111547444170399469)
,p_name=>'APEX.FS.GO'
,p_message_language=>'es'
,p_message_text=>'Ir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111548800798399470)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL'
,p_message_language=>'es'
,p_message_text=>'igual que %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111432956393399384)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_CONTAINS'
,p_message_language=>'es'
,p_message_text=>'contiene %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111432612182399384)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GT'
,p_message_language=>'es'
,p_message_text=>'mayor que %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111432796825399384)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_GTE'
,p_message_language=>'es'
,p_message_text=>'mayor o igual que %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111432405896399383)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LT'
,p_message_language=>'es'
,p_message_text=>'menor que %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111432508728399384)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_LTE'
,p_message_language=>'es'
,p_message_text=>'menor o igual que %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111432817303399384)
,p_name=>'APEX.FS.INPUT_CURRENT_LABEL_STARTSWITH'
,p_message_language=>'es'
,p_message_text=>'empieza por %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111435329533399386)
,p_name=>'APEX.FS.INPUT_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('El tipo de dato %0 (%1) no est\00E1 soportado por la faceta del campo de entrada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111425506178399378)
,p_name=>'APEX.FS.MULTI_VALUE_REQUIRES_DB_12_2'
,p_message_language=>'es'
,p_message_text=>unistr('Las facetas de varios valores requieren una base de datos de la versi\00F3n 12.2 o mayor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111549063510399471)
,p_name=>'APEX.FS.NO_SEARCH_COLUMNS_PROVIDED'
,p_message_language=>'es'
,p_message_text=>unistr('No se han proporcionado columnas de b\00FAsqueda para la faceta %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111422489004399376)
,p_name=>'APEX.FS.OPEN_CONFIG'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s filtros')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111504513508399438)
,p_name=>'APEX.FS.RANGE_BEGIN'
,p_message_language=>'es'
,p_message_text=>'Inicio de rango'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111548519711399470)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL'
,p_message_language=>'es'
,p_message_text=>'De %0 a %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111548664122399470)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_HI'
,p_message_language=>'es'
,p_message_text=>'Por encima de %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111548724605399470)
,p_name=>'APEX.FS.RANGE_CURRENT_LABEL_OPEN_LO'
,p_message_language=>'es'
,p_message_text=>'Por debajo de %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111504625072399438)
,p_name=>'APEX.FS.RANGE_END'
,p_message_language=>'es'
,p_message_text=>unistr('Finalizaci\00F3n del Rango')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111567485792399484)
,p_name=>'APEX.FS.RANGE_LOV_ITEM_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('Elemento de lista de valores n.\00BA %2 ("%1") para la faceta de rango %0 no es v\00E1lido (falta el separador "|").')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111548931393399471)
,p_name=>'APEX.FS.RANGE_MANUAL_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>'La entrada manual para la faceta de rango %0 no se soporta actualmente, ya que la columna es DATE o TIMESTAMP.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111548207056399470)
,p_name=>'APEX.FS.RANGE_TEXT'
,p_message_language=>'es'
,p_message_text=>'hasta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111432019942399383)
,p_name=>'APEX.FS.REMOVE_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Eliminar Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111501183080399435)
,p_name=>'APEX.FS.RESET'
,p_message_language=>'es'
,p_message_text=>'Restablecer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111547648058399470)
,p_name=>'APEX.FS.SEARCH_LABEL'
,p_message_language=>'es'
,p_message_text=>'Buscar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111547579645399470)
,p_name=>'APEX.FS.SEARCH_PLACEHOLDER'
,p_message_language=>'es'
,p_message_text=>'Buscar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111548484279399470)
,p_name=>'APEX.FS.SELECT_PLACEHOLDER'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111431811390399383)
,p_name=>'APEX.FS.SHOW_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111548042778399470)
,p_name=>'APEX.FS.SHOW_LESS'
,p_message_language=>'es'
,p_message_text=>'Mostrar menos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111548195912399470)
,p_name=>'APEX.FS.SHOW_MORE'
,p_message_language=>'es'
,p_message_text=>unistr('Mostrar m\00E1s')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111548312401399470)
,p_name=>'APEX.FS.STAR_RATING_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('%0 estrellas y m\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111506015371399439)
,p_name=>'APEX.FS.SUGGESTIONS'
,p_message_language=>'es'
,p_message_text=>'Filtrar sugerencias'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111549167891399471)
,p_name=>'APEX.FS.TEXT_FIELD_ONLY_FOR_NUMBER_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'La faceta de campo de texto %0 solo se soporta actualmente para las columnas NUMBER.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111422279811399376)
,p_name=>'APEX.FS.TOTAL_ROW_COUNT_LABEL'
,p_message_language=>'es'
,p_message_text=>'Recuento Total de Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111565236294399483)
,p_name=>'APEX.FS.UNSUPPORTED_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('El tipo de dato %0 (%1) no se soporta en la b\00FAsqueda de faceta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111557190621399477)
,p_name=>'APEX.GO_TO_ERROR'
,p_message_language=>'es'
,p_message_text=>'Ir al error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111514754353399445)
,p_name=>'APEX.GV.AGG_CONTEXT'
,p_message_language=>'es'
,p_message_text=>'Agregado.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111522311461399451)
,p_name=>'APEX.GV.BREAK_COLLAPSE'
,p_message_language=>'es'
,p_message_text=>unistr('Reducir Divisi\00F3n de Control')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111514880773399445)
,p_name=>'APEX.GV.BREAK_CONTEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Divisi\00F3n de control.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111522219081399451)
,p_name=>'APEX.GV.BREAK_EXPAND'
,p_message_language=>'es'
,p_message_text=>unistr('Ampliar Divisi\00F3n de Control')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111600978697399509)
,p_name=>'APEX.GV.COLUMN_CONTEXT'
,p_message_language=>'es'
,p_message_text=>'Columna %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111522065362399450)
,p_name=>'APEX.GV.DELETED_COUNT'
,p_message_language=>'es'
,p_message_text=>'%0 filas suprimidas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111592432523399503)
,p_name=>'APEX.GV.DUP_REC_ID'
,p_message_language=>'es'
,p_message_text=>'Identidad duplicada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111511772657399443)
,p_name=>'APEX.GV.FIRST_PAGE'
,p_message_language=>'es'
,p_message_text=>'Primero'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111515052419399445)
,p_name=>'APEX.GV.GROUP_CONTEXT'
,p_message_language=>'es'
,p_message_text=>'Cabecera de grupo.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111514943148399445)
,p_name=>'APEX.GV.HEADER_CONTEXT'
,p_message_language=>'es'
,p_message_text=>'Cabecera.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111511840816399443)
,p_name=>'APEX.GV.LAST_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111531860652399458)
,p_name=>'APEX.GV.LOAD_MORE'
,p_message_language=>'es'
,p_message_text=>unistr('Cargar M\00E1s Filas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111511534812399443)
,p_name=>'APEX.GV.NEXT_PAGE'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111515125297399445)
,p_name=>'APEX.GV.PAGE_RANGE'
,p_message_language=>'es'
,p_message_text=>unistr('Filas de p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111511907147399443)
,p_name=>'APEX.GV.PAGE_RANGE_XY'
,p_message_language=>'es'
,p_message_text=>'%0 - %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111512030271399443)
,p_name=>'APEX.GV.PAGE_RANGE_XYZ'
,p_message_language=>'es'
,p_message_text=>'%0 - %1 de %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111568017510399485)
,p_name=>'APEX.GV.PAGE_SELECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Selecci\00F3n de P\00E1ginas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111511664926399443)
,p_name=>'APEX.GV.PREV_PAGE'
,p_message_language=>'es'
,p_message_text=>'Anterior'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111592289953399503)
,p_name=>'APEX.GV.ROW_ADDED'
,p_message_language=>'es'
,p_message_text=>'Agregado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111592355725399503)
,p_name=>'APEX.GV.ROW_CHANGED'
,p_message_language=>'es'
,p_message_text=>'Cambiado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111600736066399509)
,p_name=>'APEX.GV.ROW_COLUMN_CONTEXT'
,p_message_language=>'es'
,p_message_text=>'Fila %0, Columna %1.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111600830364399509)
,p_name=>'APEX.GV.ROW_CONTEXT'
,p_message_language=>'es'
,p_message_text=>'Fila %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111592110033399503)
,p_name=>'APEX.GV.ROW_DELETED'
,p_message_language=>'es'
,p_message_text=>'Suprimido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111515382528399445)
,p_name=>'APEX.GV.ROW_HEADER'
,p_message_language=>'es'
,p_message_text=>'Cabecera de fila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111510922270399442)
,p_name=>'APEX.GV.SELECTION_CELL_COUNT'
,p_message_language=>'es'
,p_message_text=>'%0 celdas seleccionadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111512188198399443)
,p_name=>'APEX.GV.SELECTION_COUNT'
,p_message_language=>'es'
,p_message_text=>'%0 filas seleccionadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111552428442399473)
,p_name=>'APEX.GV.SELECT_ALL'
,p_message_language=>'es'
,p_message_text=>'Seleccionar todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111522129914399450)
,p_name=>'APEX.GV.SELECT_PAGE_N'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina %0')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111515267805399445)
,p_name=>'APEX.GV.SELECT_ROW'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Fila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111515433299399446)
,p_name=>'APEX.GV.SORTED_ASCENDING'
,p_message_language=>'es'
,p_message_text=>'Orden ascendente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111515596291399446)
,p_name=>'APEX.GV.SORTED_DESCENDING'
,p_message_language=>'es'
,p_message_text=>'Orden descendente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111511059096399442)
,p_name=>'APEX.GV.SORT_ASCENDING'
,p_message_language=>'es'
,p_message_text=>'Orden ascendente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111511353986399443)
,p_name=>'APEX.GV.SORT_ASCENDING_ORDER'
,p_message_language=>'es'
,p_message_text=>'Orden Ascendente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111511197392399442)
,p_name=>'APEX.GV.SORT_DESCENDING'
,p_message_language=>'es'
,p_message_text=>'Orden descendente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111511466475399443)
,p_name=>'APEX.GV.SORT_DESCENDING_ORDER'
,p_message_language=>'es'
,p_message_text=>'Orden Descendente %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111511240893399442)
,p_name=>'APEX.GV.SORT_OFF'
,p_message_language=>'es'
,p_message_text=>'No ordenar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111521917290399450)
,p_name=>'APEX.GV.TOTAL_PAGES'
,p_message_language=>'es'
,p_message_text=>'Total %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111448315060399395)
,p_name=>'APEX.HTTP.REQUEST_FAILED'
,p_message_language=>'es'
,p_message_text=>'Se ha producido un error en la solicitud de HTTP para "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111589603114399501)
,p_name=>'APEX.ICON_LIST.GRID_DIM'
,p_message_language=>'es'
,p_message_text=>unistr('Filas %1 de las columnas de la lista de selecci\00F3n de cuadr\00EDcula %0. Utilizar las teclas de flecha')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111521891305399450)
,p_name=>'APEX.ICON_LIST.LIST_DIM'
,p_message_language=>'es'
,p_message_text=>'Seleccionar las filas de %0 de la lista. Utilizar las techas de flecha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111600521022399509)
,p_name=>'APEX.IG.ACC_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadr\00EDcula Interactiva %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111508650042399441)
,p_name=>'APEX.IG.ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Acciones'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111509638280399441)
,p_name=>'APEX.IG.ADD'
,p_message_language=>'es'
,p_message_text=>'Agregar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111509586671399441)
,p_name=>'APEX.IG.ADD_ROW'
,p_message_language=>'es'
,p_message_text=>'Agregar fila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111594045632399504)
,p_name=>'APEX.IG.AGGREGATE'
,p_message_language=>'es'
,p_message_text=>'Agregado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111579538166399493)
,p_name=>'APEX.IG.AGGREGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Agregaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111581266654399495)
,p_name=>'APEX.IG.ALL'
,p_message_language=>'es'
,p_message_text=>'Todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111537656248399462)
,p_name=>'APEX.IG.ALL_TEXT_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Todas las Columnas de Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111538834063399463)
,p_name=>'APEX.IG.ALTERNATIVE'
,p_message_language=>'es'
,p_message_text=>'Alternativo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111539951798399464)
,p_name=>'APEX.IG.AND'
,p_message_language=>'es'
,p_message_text=>'y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111559397081399478)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT'
,p_message_language=>'es'
,p_message_text=>'Recuento de los Valores Distintos Aprox.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111595090663399505)
,p_name=>'APEX.IG.APPROX_COUNT_DISTINCT_OVERALL'
,p_message_language=>'es'
,p_message_text=>'Recuento aproximado general de valores distintos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111578163958399492)
,p_name=>'APEX.IG.AREA'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111580072642399494)
,p_name=>'APEX.IG.ASCENDING'
,p_message_language=>'es'
,p_message_text=>'Ascendente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111538953914399463)
,p_name=>'APEX.IG.AUTHORIZATION'
,p_message_language=>'es'
,p_message_text=>unistr('Autorizaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111594121033399504)
,p_name=>'APEX.IG.AUTO'
,p_message_language=>'es'
,p_message_text=>unistr('Autom\00E1tico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111559769793399479)
,p_name=>'APEX.IG.AVG'
,p_message_language=>'es'
,p_message_text=>'Media'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111594726199399505)
,p_name=>'APEX.IG.AVG_OVERALL'
,p_message_language=>'es'
,p_message_text=>'Media general'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111577687928399492)
,p_name=>'APEX.IG.AXIS_LABEL_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de Eje de Etiqueta')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111577808051399492)
,p_name=>'APEX.IG.AXIS_VALUE_DECIMAL'
,p_message_language=>'es'
,p_message_text=>'Posiciones Decimales'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111577717575399492)
,p_name=>'APEX.IG.AXIS_VALUE_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo de Eje de Valor')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111583832464399497)
,p_name=>'APEX.IG.BACKGROUND_COLOR'
,p_message_language=>'es'
,p_message_text=>'Color de Fondo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111578211020399492)
,p_name=>'APEX.IG.BAR'
,p_message_language=>'es'
,p_message_text=>'Barra'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111534266744399459)
,p_name=>'APEX.IG.BETWEEN'
,p_message_language=>'es'
,p_message_text=>'entre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111585042967399497)
,p_name=>'APEX.IG.BOTH'
,p_message_language=>'es'
,p_message_text=>'Ambos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111578330601399492)
,p_name=>'APEX.IG.BUBBLE'
,p_message_language=>'es'
,p_message_text=>'Burbujas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111509858574399441)
,p_name=>'APEX.IG.CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111539822966399464)
,p_name=>'APEX.IG.CASE_SENSITIVE'
,p_message_language=>'es'
,p_message_text=>unistr('Sensible a may\00FAsculas/min\00FAsculas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111595642745399505)
,p_name=>'APEX.IG.CASE_SENSITIVE_WITH_BRACKETS'
,p_message_language=>'es'
,p_message_text=>unistr('(Sensible a may\00FAsculas/min\00FAsculas)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111566530796399484)
,p_name=>'APEX.IG.CHANGES_SAVED'
,p_message_language=>'es'
,p_message_text=>'Se han guardado los cambios'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111510217626399442)
,p_name=>'APEX.IG.CHANGE_VIEW'
,p_message_language=>'es'
,p_message_text=>'Cambiar Vista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111540911714399465)
,p_name=>'APEX.IG.CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111537498948399462)
,p_name=>'APEX.IG.CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta supera el m\00E1ximo de %0 puntos de datos por gr\00E1fico. Aplique un filtro para reducir el n\00FAmero de registros de la consulta base.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111508597967399440)
,p_name=>'APEX.IG.CHART_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Diagrama'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111515856974399446)
,p_name=>'APEX.IG.CLEAR'
,p_message_language=>'es'
,p_message_text=>'Borrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111577191566399492)
,p_name=>'APEX.IG.CLOSE_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111584027500399497)
,p_name=>'APEX.IG.COLORS'
,p_message_language=>'es'
,p_message_text=>'Colores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111560115333399479)
,p_name=>'APEX.IG.COLOR_PREVIEW'
,p_message_language=>'es'
,p_message_text=>'Vista previa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111539251023399463)
,p_name=>'APEX.IG.COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111508739622399441)
,p_name=>'APEX.IG.COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111585898861399498)
,p_name=>'APEX.IG.COLUMN_TYPE'
,p_message_language=>'es'
,p_message_text=>'Objetivo de la columna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111539382602399463)
,p_name=>'APEX.IG.COMPLEX'
,p_message_language=>'es'
,p_message_text=>'Complejo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111508965417399441)
,p_name=>'APEX.IG.COMPUTE'
,p_message_language=>'es'
,p_message_text=>'Calcular'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111534877449399460)
,p_name=>'APEX.IG.CONTAINS'
,p_message_language=>'es'
,p_message_text=>'contiene'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111541127444399465)
,p_name=>'APEX.IG.CONTROL_BREAK'
,p_message_language=>'es'
,p_message_text=>unistr('Divisi\00F3n de Control')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111515647577399446)
,p_name=>'APEX.IG.COPY_CB'
,p_message_language=>'es'
,p_message_text=>'Copiar en el portapapeles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111515730143399446)
,p_name=>'APEX.IG.COPY_DOWN'
,p_message_language=>'es'
,p_message_text=>'Copiar hacia abajo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111559173682399478)
,p_name=>'APEX.IG.COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111559298426399478)
,p_name=>'APEX.IG.COUNT_DISTINCT'
,p_message_language=>'es'
,p_message_text=>'Recuento de los Valores Distintos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111594991313399505)
,p_name=>'APEX.IG.COUNT_DISTINCT_OVERALL'
,p_message_language=>'es'
,p_message_text=>'Recuento general de valores distintos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111594807552399505)
,p_name=>'APEX.IG.COUNT_OVERALL'
,p_message_language=>'es'
,p_message_text=>'Recuento General'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111592596233399503)
,p_name=>'APEX.IG.CREATE_X'
,p_message_language=>'es'
,p_message_text=>'Crear %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111537839209399462)
,p_name=>'APEX.IG.DATA'
,p_message_language=>'es'
,p_message_text=>'Datos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111585618806399498)
,p_name=>'APEX.IG.DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de datos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111585283805399498)
,p_name=>'APEX.IG.DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111566372630399484)
,p_name=>'APEX.IG.DATE_INVALID_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Valor de fecha no v\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111535531495399460)
,p_name=>'APEX.IG.DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('d\00EDas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111538507503399463)
,p_name=>'APEX.IG.DEFAULT_SETTINGS'
,p_message_language=>'es'
,p_message_text=>'Valores por defecto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111538392276399463)
,p_name=>'APEX.IG.DEFAULT_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo por Defecto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111509707956399441)
,p_name=>'APEX.IG.DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111586889448399499)
,p_name=>'APEX.IG.DELETE_REPORT_CONFIRM'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFSeguro que desea suprimir este informe?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111542940434399466)
,p_name=>'APEX.IG.DELETE_ROW'
,p_message_language=>'es'
,p_message_text=>'Suprimir fila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111541703417399465)
,p_name=>'APEX.IG.DELETE_ROWS'
,p_message_language=>'es'
,p_message_text=>'Suprimir filas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111580126276399494)
,p_name=>'APEX.IG.DESCENDING'
,p_message_language=>'es'
,p_message_text=>'Descendente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111540689317399464)
,p_name=>'APEX.IG.DETAIL'
,p_message_language=>'es'
,p_message_text=>'Detalle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111508222561399440)
,p_name=>'APEX.IG.DETAIL_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Detalles'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111568805109399485)
,p_name=>'APEX.IG.DIRECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111540363269399464)
,p_name=>'APEX.IG.DISABLED'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111534938702399460)
,p_name=>'APEX.IG.DOES_NOT_CONTAIN'
,p_message_language=>'es'
,p_message_text=>'no contiene'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111535137639399460)
,p_name=>'APEX.IG.DOES_NOT_START_WITH'
,p_message_language=>'es'
,p_message_text=>'no empieza por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111578437327399493)
,p_name=>'APEX.IG.DONUT'
,p_message_language=>'es'
,p_message_text=>'Anillo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111541341659399465)
,p_name=>'APEX.IG.DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>'Descargar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111440006859399389)
,p_name=>'APEX.IG.DOWNLOAD_DATA_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo Datos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111587890055399500)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111452649954399399)
,p_name=>'APEX.IG.DOWNLOAD_FORMAT_NOT_ENABLED'
,p_message_language=>'es'
,p_message_text=>unistr('El formato de descarga %0 no est\00E1 activado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111580842561399494)
,p_name=>'APEX.IG.DUPLICATE_AGGREGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Agregaci\00F3n duplicada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111580983034399494)
,p_name=>'APEX.IG.DUPLICATE_CONTROLBREAK'
,p_message_language=>'es'
,p_message_text=>unistr('Divisi\00F3n de Control Duplicada')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111542817289399466)
,p_name=>'APEX.IG.DUPLICATE_ROW'
,p_message_language=>'es'
,p_message_text=>'Duplicar Fila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111541616431399465)
,p_name=>'APEX.IG.DUPLICATE_ROWS'
,p_message_language=>'es'
,p_message_text=>'Filas Duplicadas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111509302781399441)
,p_name=>'APEX.IG.EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111579939049399494)
,p_name=>'APEX.IG.EDIT_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Gr\00E1fico')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111591495135399502)
,p_name=>'APEX.IG.EDIT_GROUP_BY'
,p_message_language=>'es'
,p_message_text=>'Editar Grupo por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111587411416399499)
,p_name=>'APEX.IG.EMAIL_BCC'
,p_message_language=>'es'
,p_message_text=>'Copia oculta (Cco)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111587665105399499)
,p_name=>'APEX.IG.EMAIL_BODY'
,p_message_language=>'es'
,p_message_text=>'Mensaje'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111587371624399499)
,p_name=>'APEX.IG.EMAIL_CC'
,p_message_language=>'es'
,p_message_text=>'Copia (Cc)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111587052358399499)
,p_name=>'APEX.IG.EMAIL_SENT'
,p_message_language=>'es'
,p_message_text=>unistr('Correo electr\00F3nico enviado.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111587530490399499)
,p_name=>'APEX.IG.EMAIL_SUBJECT'
,p_message_language=>'es'
,p_message_text=>'Asunto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111587201003399499)
,p_name=>'APEX.IG.EMAIL_TO'
,p_message_language=>'es'
,p_message_text=>'Destinatario (para)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111540074084399464)
,p_name=>'APEX.IG.ENABLED'
,p_message_language=>'es'
,p_message_text=>'Activado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111533206391399459)
,p_name=>'APEX.IG.EQUALS'
,p_message_language=>'es'
,p_message_text=>'igual que'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111586455155399499)
,p_name=>'APEX.IG.EXAMPLE'
,p_message_language=>'es'
,p_message_text=>'Ejemplo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111540125440399464)
,p_name=>'APEX.IG.EXPRESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111586303016399498)
,p_name=>'APEX.IG.FD_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111552361450399473)
,p_name=>'APEX.IG.FILE_PREPARED'
,p_message_language=>'es'
,p_message_text=>'Archivo preparado. Iniciando descarga.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111515958896399446)
,p_name=>'APEX.IG.FILL'
,p_message_language=>'es'
,p_message_text=>'Rellenar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111517051075399447)
,p_name=>'APEX.IG.FILL_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Rellenar selecci\00F3n con')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111516986204399447)
,p_name=>'APEX.IG.FILL_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Rellenar selecci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111508889524399441)
,p_name=>'APEX.IG.FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111539436934399463)
,p_name=>'APEX.IG.FILTERS'
,p_message_language=>'es'
,p_message_text=>'Filtros'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111594487799399505)
,p_name=>'APEX.IG.FILTER_WITH_DOTS'
,p_message_language=>'es'
,p_message_text=>'Filtrar...'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111580366328399494)
,p_name=>'APEX.IG.FIRST'
,p_message_language=>'es'
,p_message_text=>'Primero'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111509052332399441)
,p_name=>'APEX.IG.FLASHBACK'
,p_message_language=>'es'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111537917494399462)
,p_name=>'APEX.IG.FORMAT'
,p_message_language=>'es'
,p_message_text=>'Formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111584987529399497)
,p_name=>'APEX.IG.FORMATMASK'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara de Formato')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111586776292399499)
,p_name=>'APEX.IG.FORMAT_CSV'
,p_message_language=>'es'
,p_message_text=>'CSV'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111586661177399499)
,p_name=>'APEX.IG.FORMAT_HTML'
,p_message_language=>'es'
,p_message_text=>'HTML'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111499406318399434)
,p_name=>'APEX.IG.FORMAT_PDF'
,p_message_language=>'es'
,p_message_text=>'PDF'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111438786895399388)
,p_name=>'APEX.IG.FORMAT_XLSX'
,p_message_language=>'es'
,p_message_text=>'Excel'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111542592100399466)
,p_name=>'APEX.IG.FREEZE'
,p_message_language=>'es'
,p_message_text=>'Congelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111540276686399464)
,p_name=>'APEX.IG.FUNCTIONS_AND_OPERATORS'
,p_message_language=>'es'
,p_message_text=>'Funciones y Operadores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111578567288399493)
,p_name=>'APEX.IG.FUNNEL'
,p_message_language=>'es'
,p_message_text=>'Embudo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111559032513399478)
,p_name=>'APEX.IG.GO'
,p_message_language=>'es'
,p_message_text=>'Ir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111533841983399459)
,p_name=>'APEX.IG.GREATER_THAN'
,p_message_language=>'es'
,p_message_text=>'mayor que'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111533937406399459)
,p_name=>'APEX.IG.GREATER_THAN_OR_EQUALS'
,p_message_language=>'es'
,p_message_text=>'mayor o igual que'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111540537139399464)
,p_name=>'APEX.IG.GRID'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadr\00EDcula')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111508039684399440)
,p_name=>'APEX.IG.GRID_VIEW'
,p_message_language=>'es'
,p_message_text=>unistr('Vista de cuadr\00EDcula')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111581188334399495)
,p_name=>'APEX.IG.GROUP'
,p_message_language=>'es'
,p_message_text=>'Grupo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111540760236399464)
,p_name=>'APEX.IG.GROUP_BY'
,p_message_language=>'es'
,p_message_text=>'Agrupar por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111508315523399440)
,p_name=>'APEX.IG.GROUP_BY_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista Agrupar por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111585579551399498)
,p_name=>'APEX.IG.HD_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de Condici\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111584401258399497)
,p_name=>'APEX.IG.HEADING'
,p_message_language=>'es'
,p_message_text=>'Cabecera'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111584616925399497)
,p_name=>'APEX.IG.HEADING_ALIGN'
,p_message_language=>'es'
,p_message_text=>unistr('Alineaci\00F3n de Cabecera')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111594332838399504)
,p_name=>'APEX.IG.HELP'
,p_message_language=>'es'
,p_message_text=>'Ayuda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111589812689399501)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Puede insertar, actualizar y suprimir datos directamente en esta cuadr\00EDcula interactiva.</p>'),
'',
unistr('<p>Inserte una nueva fila haciendo clic en el bot\00F3n Agregar Fila.</p>'),
'',
unistr('<p>Edite datos existentes haciendo doble clic en una celda espec\00EDfica. Para un trabajo de edici\00F3n mayor, haga clic en Editar para acceder al modo de edici\00F3n. En el modo de edici\00F3n, puede hacer un solo clic o utilizar el teclado para editar celdas esp')
||unistr('ec\00EDficas.</p>'),
'',
unistr('<p>Utilice el men\00FA Cambiar para duplicar y suprimir filas. Para activar el men\00FA Cambiar, utilice las casillas de control para seleccionar una o m\00E1s filas.</p>'),
'',
unistr('<p>Duplique una fila seleccionada haciendo clic en el men\00FA Cambiar y seleccionando Filas duplicadas. Suprima una fila seleccionada haciendo clic en el men\00FA Cambiar y seleccionando Suprimir fila.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111591970660399503)
,p_name=>'APEX.IG.HELP.ACTIONS.EDITING_HEADING'
,p_message_language=>'es'
,p_message_text=>unistr('Funciones de edici\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111592054929399503)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Una cuadr\00EDcula interactiva presenta un juego de datos en un informe personalizable en el que se pueden realizar b\00FAsquedas. Puede realizar diversas operaciones para limitar los registros que se devuelven y cambiar la forma en la que se muestran los')
||' datos.</p>',
'',
unistr('<p>Utilice el campo Buscar para filtrar los registros devueltos. Haga clic en Acciones para acceder a diversas opciones para modificar el dise\00F1o del informe, o utilizar los men\00FAs de Cabecera de Columna en las columnas mostradas.</p>'),
'',
unistr('<p>Utilice Configuraci\00F3n de Informe para guardar sus personalizaciones en un informe. Tambi\00E9n puede descargar los datos del informe en un archivo externo o enviarse a los datos por correo electr\00F3nico a s\00ED mismo o a otros usuarios.</p>'),
'',
unistr('<p>Para obtener m\00E1s informaci\00F3n, consulte "Uso de cuadr\00EDculas interactivas" en <em>Oracle Application Express End User''s Guide</em>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111591722046399502)
,p_name=>'APEX.IG.HELP.ACTIONS.INTRO_HEADING'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n general')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111589744149399501)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Puede personalizar la cuadr\00EDcula interactiva para mostrar datos en diversos niveles diferentes utilizando las funciones incorporadas.</p>'),
'',
unistr('<p>Utilice los men\00FAs de Cabecera de Columna del men\00FA Acciones para determinar qu\00E9 columnas se deben mostrar, en qu\00E9 secuencia y congelar columnas. Tambi\00E9n puede definir varios filtros de datos y ordenar los datos devueltos.</p>'),
'',
unistr('<p>Utilice el bot\00F3n Ver (junto al campo Buscar) para acceder a otras vistas de datos que puede haber definido el desarrollador de aplicaciones. Tambi\00E9n puede crear un gr\00E1fico o ver un gr\00E1fico existente.</p>  '),
'',
unistr('<p><em>Nota: Haga clic en <strong>Ayuda</strong> en los cuadros de di\00E1logo de la cuadr\00EDcula interactiva para obtener informaci\00F3n m\00E1s detallada sobre la funci\00F3n seleccionada.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111591824663399503)
,p_name=>'APEX.IG.HELP.ACTIONS.REPORTING_HEADING'
,p_message_language=>'es'
,p_message_text=>'Funciones de informes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111541535100399465)
,p_name=>'APEX.IG.HELP.ACTIONS_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Ayuda de Cuadr\00EDcula Interactiva')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111588606731399500)
,p_name=>'APEX.IG.HELP.AGGREGATE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este cuadro de di\00E1logo para agregar columnas. Los valores agregados se muestran en la parte inferior de los datos o, si se definen divisiones de control, en la parte inferior de cada divisi\00F3n.</p>'),
'',
unistr('<p><strong>Lista de agregaci\00F3n</strong><br>'),
unistr('La lista de agregaci\00F3n muestra agregaciones definidas. Desactive una agregaci\00F3n existente anulando su selecci\00F3n.<br>'),
unistr('Haga clic en Agregar ( &plus; ) para crear una nueva agregaci\00F3n, o en Suprimir ( &minus; ) para eliminar una agregaci\00F3n existente.</p>'),
'',
unistr('<p><strong>Configuraci\00F3n de agregaci\00F3n</strong><br>'),
unistr('Utilice el formulario de la derecha para definir la agregaci\00F3n.<br>'),
unistr('Seleccione el nombre de columna y el tipo de agregaci\00F3n.<br>'),
unistr('De manera opcional, puede introducir una pista para la agregaci\00F3n.<br>'),
unistr('Si ha definido una divisi\00F3n de control, al seleccionar <strong>Mostrar Valor General</strong> se muestra el valor de media general, total o similar en la parte inferior de los datos.</p>'),
'',
unistr('<p><em>Nota: Acceda al cuadro de di\00E1logo Agregaci\00F3n en el men\00FA Acciones o haciendo clic en la cabecera de columna y suma ( &sum; ).</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111590829847399502)
,p_name=>'APEX.IG.HELP.AGGREGATE_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Ayuda de agregaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111589381555399501)
,p_name=>'APEX.IG.HELP.CHART'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este cuadro de di\00E1logo para definir un gr\00E1fico que se muestre como una vista de datos independiente.<br>'),
unistr('Seleccione un tipo de gr\00E1fico y sus atributos.</p>'),
unistr('<p><strong>Atributos de gr\00E1fico</strong></br>'),
unistr('Los atributos de gr\00E1fico disponibles var\00EDan en funci\00F3n del tipo de gr\00E1fico.</p>'),
'<p>',
'<ul>',
'  <li>Seleccione la columna que contiene el valor para el atributo:',
'    <ul>',
'      <li>Etiqueta: el texto para cada punto de datos.</li>',
unistr('      <li>Valor: los datos que se trazar\00E1n.</li>'),
unistr('      <li>Series: para definir su consulta din\00E1mica de varias series.</li>'),
'      <li>Abrir: el precio de apertura de valores diario (solo valores).</li>',
'      <li>Cerrar: el precio de cierre de valores diario (solo valores).</li>',
'      <li>Alto: el valor alto (solo rango y valores).</li>',
'      <li>Bajo: el valor bajo (solo rango y valores)</li>',
'      <li>Volumen: el volumen de valores diario (solo valores).</li>',
'      <li>Destino: el valor de destino (solo embudo).</li>',
unistr('      <li>X: valor de eje X (solo burbuja y dispersi\00F3n).</li>'),
unistr('      <li>Y: valor de eje Y (solo burbuja y dispersi\00F3n).</li>'),
'      <li>Z: el ancho de barra o el radio de burbuja (solo barra, burbuja y rango).</li>',
'    </ul>',
'  </li>',
unistr('  <li>Orientaci\00F3n: vertical u horizontal.</li>'),
unistr('  <li>Agregaci\00F3n: seleccione c\00F3mo agregar los valores del gr\00E1fico.</li>'),
unistr('  <li>Pila: especifique si los elementos de datos est\00E1n apilados.</li>'),
'  <li>Ordenar por: ordene por etiqueta o valores.',
'    <ul>',
unistr('      <li>Direcci\00F3n: ordene por valores ascendentes o descendentes.</li>'),
unistr('      <li>Nulos: especifique c\00F3mo ordenar registros con valores nulos con respecto a registros con valores no nulos.</li>'),
'    </ul>',
'  </li>',
'  <li>Posiciones decimales</li>',
unistr('  <li>T\00EDtulo de eje de etiqueta</li>'),
unistr('  <li>T\00EDtulo de eje de valor</li>'),
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111591214990399502)
,p_name=>'APEX.IG.HELP.CHART_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Ayuda de gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111588378316399500)
,p_name=>'APEX.IG.HELP.COLUMNS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este cuadro de di\00E1logo para seleccionar qu\00E9 columnas se muestran y en qu\00E9 orden.</p>'),
'',
unistr('<p>Para ocultar una columna, anule su selecci\00F3n.<br>'),
'Para reordenar columnas, haga clic en Mover Arriba ( &uarr; ) o Mover Abajo ( &darr; ).<br>',
'Utilice el selector desplegable para mostrar Todas las columnas, Columnas mostradas o Columnas no mostradas.</p>',
'',
unistr('<p>Tambi\00E9n puede utilizar el formulario para especificar el ancho m\00EDnimo de una columna en p\00EDxeles.</p>'),
'',
unistr('<p><em>Nota: Tambi\00E9n puede reordenar columnas mostradas haciendo clic en el manejador de arrastre (al inicio de la cabecera de columna) y arrastrando la columna a la izquierda o la derecha. Cambie el ancho de las columnas mostradas seleccionando el s')
||unistr('eparador de columna, entre cabeceras, y movi\00E9ndolo hacia la izquierda o la derecha.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111591173541399502)
,p_name=>'APEX.IG.HELP.COLUMNS_TITLE'
,p_message_language=>'es'
,p_message_text=>'Ayuda de Columnas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111588730142399500)
,p_name=>'APEX.IG.HELP.COMPUTE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este cuadro de di\00E1logo para definir columnas adicionales basadas en los c\00E1lculos matem\00E1ticos y funcionales realizados en columnas existentes.</p>'),
'',
unistr('<p><strong>Lista de c\00E1lculo</strong><br>'),
unistr('La lista de c\00E1lculo muestra c\00E1lculos definidos. Desactive un c\00E1lculo existente anulando su selecci\00F3n.<br>'),
unistr('Haga clic en Agregar ( &plus; ) para agregar un nuevo c\00E1lculo, o en Suprimir ( &minus; ) para eliminar un c\00E1lculo existente.</p>'),
'',
unistr('<p><strong>Configuraci\00F3n de c\00E1lculo</strong><br>'),
unistr('Utilice el formulario para definir el c\00E1lculo.<br>'),
unistr('Introduzca los detalles de la columna, como la cabecera y la etiqueta, y seleccione la configuraci\00F3n de alineaci\00F3n.<br> '),
unistr('Utilice el \00E1rea de texto Expresi\00F3n para introducir las columnas y las funciones asociadas para el c\00E1lculo.<br>'),
unistr('Seleccione el tipo de datos adecuado y, de forma opcional, una m\00E1scara de formato para la nueva columna.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111590743892399502)
,p_name=>'APEX.IG.HELP.COMPUTE_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Ayuda de c\00E1lculo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111589060201399500)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este cuadro de di\00E1logo para definir una divisi\00F3n de control en una o m\00E1s columnas.</p>'),
'',
'<p><strong>Lista de divisiones de control</strong><br>',
unistr('La lista de divisiones de control muestra divisiones de control definidas. Desactive una columna de divisi\00F3n de control existente anulando su selecci\00F3n.<br>'),
unistr('Haga clic en Agregar ( &plus; ) para incluir una nueva columna en la divisi\00F3n de control, o en Suprimir ( &minus; ) para eliminar una columna existente de la divisi\00F3n de control.<br>'),
unistr('Para reordenar columnas, haga clic en Mover Arriba ( &uarr; ) o Mover Abajo ( &darr; ) para mover la columna seleccionada arriba y abajo en relaci\00F3n con otras columnas.</p>'),
'',
unistr('<p><strong>Configuraci\00F3n de divisi\00F3n de control</strong><br>'),
unistr('Utilice este formulario para definir la columna de divisi\00F3n de control.<br>'),
unistr('Seleccione una columna de divisi\00F3n de control, la direcci\00F3n de ordenaci\00F3n y el modo de ordenar las columnas nulas (columnas sin valor).</p>'),
'',
unistr('<p><em>Nota: Al visualizar la cuadr\00EDcula interactiva, puede definir una divisi\00F3n de control haciendo clic en una cabecera de columna y seleccionando el icono de divisi\00F3n de control.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111590451481399502)
,p_name=>'APEX.IG.HELP.CONTROL_BREAK_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Ayuda de Divisi\00F3n de Control')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111589200807399501)
,p_name=>'APEX.IG.HELP.DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este cuadro de di\00E1logo para descargar todas las filas actuales en un archivo externo. El archivo contendr\00E1 solo las columnas mostradas actualmente, con cualquier filtro y ordenaci\00F3n que se haya aplicado a los datos.</p>'),
'',
'<p>Seleccione el formato de archivo y haga clic en Descargar.<br>',
unistr('Nota: CSV no incluir\00E1 formato de texto, tal como agregaciones y divisiones de control.</p>'),
'',
unistr('<p>Para enviar un archivo por correo electr\00F3nico, seleccione Enviar como correo electr\00F3nico e introduzca los detalles del correo en cuesti\00F3n (destinatario, asunto y mensaje).</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111590285856399501)
,p_name=>'APEX.IG.HELP.DOWNLOAD_TITLE'
,p_message_language=>'es'
,p_message_text=>'Ayuda de descarga'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111588414466399500)
,p_name=>'APEX.IG.HELP.FILTER'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este cuadro de di\00E1logo para configurar filtros de datos que limiten las filas devueltas.</p>'),
'',
'<p><strong>Lista de Filtros</strong><br>',
unistr('La lista de filtros muestra filtros definidos. Desactive un filtro existente anulando su selecci\00F3n.<br>'),
'Haga clic en Agregar ( &plus; ) para crear un nuevo filtro, o en Suprimir ( &minus; ) para eliminar un filtro existente.</p>',
'',
'<p><strong>Valores de Filtro</strong><br>',
'Utilice el formulario para definir las propiedades del filtro.<br>',
'Seleccione el tipo de filtro adecuado:<br>',
unistr('&nbsp;&nbsp;&nbsp;Fila: filtra por un t\00E9rmino en cualquier columna que se pueda filtrar.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Columna: filtra una columna espec\00EDfica con un valor y un operador espec\00EDfico.<br>'),
'',
unistr('<p><em>Nota: Al visualizar la cuadr\00EDcula interactiva, puede definir los filtros de fila escribiendo directamente en el campo Buscar. Haga clic en Seleccionar Columnas a Buscar para limitar la b\00FAsqueda a una columna espec\00EDfica. Tambi\00E9n puede abrir un ')
||unistr('men\00FA Cabecera de Columna y seleccionar un valor para crear un filtro de columna.</em></p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111591013122399502)
,p_name=>'APEX.IG.HELP.FILTER_TITLE'
,p_message_language=>'es'
,p_message_text=>'Ayuda de filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111588823071399500)
,p_name=>'APEX.IG.HELP.FLASHBACK'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este cuadro de di\00E1logo para ver los datos tal como exist\00EDan en un punto en el tiempo anterior.</p>'),
unistr('<p>Introduzca el n\00FAmero de minutos en el pasado para ejecutar la consulta de flashback.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111590607736399502)
,p_name=>'APEX.IG.HELP.FLASHBACK_TITLE'
,p_message_language=>'es'
,p_message_text=>'Ayuda de flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111591348016399502)
,p_name=>'APEX.IG.HELP.GROUP_BY_TITLE'
,p_message_language=>'es'
,p_message_text=>'Ayuda de Agrupar por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111588993059399500)
,p_name=>'APEX.IG.HELP.HIGHLIGHT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este cuadro de di\00E1logo para resaltar las filas o columnas de datos en funci\00F3n de la condici\00F3n introducida.</p>'),
'',
'<p><strong>Lista de resaltados</strong><br>',
unistr('La lista de resaltados muestra resaltados definidos. Desactive un resaltado existente anulando su selecci\00F3n.<br>'),
'Haga clic en Agregar ( &plus; ) para crear un nuevo resaltado, o en Suprimir ( &minus; ) para eliminar un resaltado existente.</p>',
'',
unistr('<p><strong>Configuraci\00F3n de resaltado</strong><br>'),
'Utilice el formulario para definir las propiedades de resaltado.<br>',
unistr('Introduzca el nombre, seleccione Fila o Columna y seleccione los c\00F3digos de color HTML para al fondo y el texto.<br>'),
unistr('Seleccione el <strong>tipo de condici\00F3n</strong> adecuado para resaltar datos espec\00EDficos:<br>'),
unistr('&nbsp;&nbsp;&nbsp;Fila: se resalta el t\00E9rmino en cualquier columna.<br>'),
unistr('&nbsp;&nbsp;&nbsp;Columna: se resalta dentro de una columna espec\00EDfica en funci\00F3n de un valor y operador especificados.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111590583793399502)
,p_name=>'APEX.IG.HELP.HIGHLIGHT_TITLE'
,p_message_language=>'es'
,p_message_text=>'Ayuda de resaltado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111589172830399501)
,p_name=>'APEX.IG.HELP.REPORT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este cuadro de di\00E1logo para guardar los cambios que ha realizado en el dise\00F1o de cuadr\00EDcula actual y la configuraci\00F3n.<br>'),
unistr('Los desarrolladores de aplicaciones pueden definir varios dise\00F1os de informes alternativos. Siempre que sea posible, tanto usted como los otros usuarios finales pueden guardar un informe como P\00FAblico, de modo que pueda estar disponible para todos los')
||unistr(' usuarios de la cuadr\00EDcula. Tambi\00E9n puede guardar un informe como Privado para que solo usted pueda verlo.</p>'),
'<p>Seleccione uno de los tipos disponibles e introduzca un nombre para el informe guardado.</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111590309993399501)
,p_name=>'APEX.IG.HELP.REPORT_TITLE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Ayuda de informe',
''))
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111588567508399500)
,p_name=>'APEX.IG.HELP.SORT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Utilice este cuadro de di\00E1logo para definir el orden de visualizaci\00F3n.</p>'),
'',
'<p><strong>Ordenar Lista</strong><br>',
unistr('El cuadro de di\00E1logo Ordenar muestra una lista de reglas de ordenaci\00F3n configuradas.<br>'),
unistr('Haga clic en Agregar ( &plus; ) para crear una columna de ordenaci\00F3n, o en Suprimir ( &minus; ) para eliminar una columna de ordenaci\00F3n.<br>'),
unistr('Haga clic en Mover Arriba ( &uarr; ) y Mover Abajo ( &darr; ) para mover la columna de ordenaci\00F3n seleccionada arriba y abajo en relaci\00F3n a las otras columnas de ordenaci\00F3n.</p>'),
'',
unistr('<p><strong>Valores de Ordenaci\00F3n</strong><br>'),
unistr('Seleccione una columna de ordenaci\00F3n, la direcci\00F3n de ordenaci\00F3n y el modo de ordenar las columnas nulas (columnas sin valor).</p>'),
'',
'<p><em>Nota: Los datos se pueden ordenar por columnas que no se muestran; sin embargo, no todas las columnas pueden ordenarse.</em><br>',
unistr('<em>Las columnas mostradas pueden ordenarse pulsando las flechas arriba (ascendentes) o abajo (descendentes) al final de las cabeceras de columna. Para agregar una columna posterior a una ordenaci\00F3n existente, mantenga pulsada la tecla May\00FAs y haga c')
||'lic en la flecha arriba o abajo.</em></p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111590923637399502)
,p_name=>'APEX.IG.HELP.SORT_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Ayuda de ordenaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111590187013399501)
,p_name=>'APEX.IG.HELP.SUBSCRIPTION_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Ayuda de suscripci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111542405850399466)
,p_name=>'APEX.IG.HIDE'
,p_message_language=>'es'
,p_message_text=>'Ocultar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111509292285399441)
,p_name=>'APEX.IG.HIGHLIGHT'
,p_message_language=>'es'
,p_message_text=>'Resaltar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111577287439399492)
,p_name=>'APEX.IG.HIGH_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Alto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111578053838399492)
,p_name=>'APEX.IG.HORIZONTAL'
,p_message_language=>'es'
,p_message_text=>'Horizontal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111535443786399460)
,p_name=>'APEX.IG.HOURS'
,p_message_language=>'es'
,p_message_text=>'horas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111540483101399464)
,p_name=>'APEX.IG.ICON'
,p_message_language=>'es'
,p_message_text=>'Icono'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111508117005399440)
,p_name=>'APEX.IG.ICON_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Icono'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111533610781399459)
,p_name=>'APEX.IG.IN'
,p_message_language=>'es'
,p_message_text=>'en'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111542070383399465)
,p_name=>'APEX.IG.INACTIVE_SETTING'
,p_message_language=>'es'
,p_message_text=>'Valor inactivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111542140685399465)
,p_name=>'APEX.IG.INACTIVE_SETTINGS'
,p_message_language=>'es'
,p_message_text=>'Valores inactivos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111549767370399471)
,p_name=>'APEX.IG.INTERNAL_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha producido un error interno al procesar la solicitud de cuadr\00EDcula interactiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111445569424399393)
,p_name=>'APEX.IG.INVALID_COLUMN_FILTER_TYPE'
,p_message_language=>'es'
,p_message_text=>'El tipo de filtro de columna "%0" no es compatible con la columna "%1".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111589984099399501)
,p_name=>'APEX.IG.INVALID_DATE_FORMAT'
,p_message_language=>'es'
,p_message_text=>unistr('Formato de Fecha No V\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111564155380399482)
,p_name=>'APEX.IG.INVALID_FILTER_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('La cuadr\00EDcula interactiva no soporta la definici\00F3n de filtros en la columna %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111564076244399482)
,p_name=>'APEX.IG.INVALID_FILTER_OPERATOR'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no es un tipo de filtro v\00E1lido para definir un filtro de cuadr\00EDcula interactiva.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111450687205399397)
,p_name=>'APEX.IG.INVALID_NUMBER_FORMAT'
,p_message_language=>'es'
,p_message_text=>unistr('Formato num\00E9rico no v\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111592619274399503)
,p_name=>'APEX.IG.INVALID_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('Valor no v\00E1lido')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111592793312399503)
,p_name=>'APEX.IG.INVALID_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Valores no v\00E1lidos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111583735075399497)
,p_name=>'APEX.IG.INVALID_SORT_BY'
,p_message_language=>'es'
,p_message_text=>'Ordenar por se ha definido en %0, pero no se ha seleccionado ninguna columna para %0.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111581099329399494)
,p_name=>'APEX.IG.INVALID_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('Valor no v\00E1lido')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111576121832399491)
,p_name=>'APEX.IG.INVISIBLE'
,p_message_language=>'es'
,p_message_text=>'No Mostrado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111534446589399460)
,p_name=>'APEX.IG.IN_THE_LAST'
,p_message_language=>'es'
,p_message_text=>unistr('en los \00FAltimos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111534671652399460)
,p_name=>'APEX.IG.IN_THE_NEXT'
,p_message_language=>'es'
,p_message_text=>'en siguiente(s)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111533512382399459)
,p_name=>'APEX.IG.IS_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('no est\00E1 vac\00EDo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111533483910399459)
,p_name=>'APEX.IG.IS_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('est\00E1 vac\00EDo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111584513404399497)
,p_name=>'APEX.IG.LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111576556050399491)
,p_name=>'APEX.IG.LABEL_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111580448592399494)
,p_name=>'APEX.IG.LAST'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111523726979399452)
,p_name=>'APEX.IG.LAST.DAY'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimo D\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111523912420399452)
,p_name=>'APEX.IG.LAST.HOUR'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima Hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111524425479399452)
,p_name=>'APEX.IG.LAST.MINUTE'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111523490622399451)
,p_name=>'APEX.IG.LAST.MONTH'
,p_message_language=>'es'
,p_message_text=>'Mes pasado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111523547715399452)
,p_name=>'APEX.IG.LAST.WEEK'
,p_message_language=>'es'
,p_message_text=>'Semana pasada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111523622647399452)
,p_name=>'APEX.IG.LAST.X_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimos %0 D\00EDas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111523838807399452)
,p_name=>'APEX.IG.LAST.X_HOURS'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimas %0 Horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111524541400399452)
,p_name=>'APEX.IG.LAST.X_MINUTES'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimos %0 Minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111524327977399452)
,p_name=>'APEX.IG.LAST.X_MONTHS'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimos %0 Meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111524244655399452)
,p_name=>'APEX.IG.LAST.X_WEEKS'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimas %0 semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111523283761399451)
,p_name=>'APEX.IG.LAST.X_YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimos %0 A\00F1os')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111523339559399451)
,p_name=>'APEX.IG.LAST.YEAR'
,p_message_language=>'es'
,p_message_text=>unistr('A\00F1o pasado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111584729932399497)
,p_name=>'APEX.IG.LAYOUT_ALIGN'
,p_message_language=>'es'
,p_message_text=>unistr('Alineaci\00F3n de Celda')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111584813025399497)
,p_name=>'APEX.IG.LAYOUT_USEGROUPFOR'
,p_message_language=>'es'
,p_message_text=>'Usar Grupos para'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111534061766399459)
,p_name=>'APEX.IG.LESS_THAN'
,p_message_language=>'es'
,p_message_text=>'menor que'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111534108564399459)
,p_name=>'APEX.IG.LESS_THAN_OR_EQUALS'
,p_message_language=>'es'
,p_message_text=>'menor o igual que'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111578673374399493)
,p_name=>'APEX.IG.LINE'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111578744738399493)
,p_name=>'APEX.IG.LINE_WITH_AREA'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea con \00C1rea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111585177031399498)
,p_name=>'APEX.IG.LISTAGG'
,p_message_language=>'es'
,p_message_text=>'Listagg'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111577358718399492)
,p_name=>'APEX.IG.LOW_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Bajo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111587726193399500)
,p_name=>'APEX.IG.MAILADDRESSES_COMMASEP'
,p_message_language=>'es'
,p_message_text=>unistr('Si introduce varias direcciones, sep\00E1relas con comas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111535261984399460)
,p_name=>'APEX.IG.MATCHES_REGULAR_EXPRESSION'
,p_message_language=>'es'
,p_message_text=>unistr('coincide con expresi\00F3n regular')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111559641556399479)
,p_name=>'APEX.IG.MAX'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111595236092399505)
,p_name=>'APEX.IG.MAX_OVERALL'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo general')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111559845639399479)
,p_name=>'APEX.IG.MEDIAN'
,p_message_language=>'es'
,p_message_text=>'Mediana'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111595367148399505)
,p_name=>'APEX.IG.MEDIAN_OVERALL'
,p_message_language=>'es'
,p_message_text=>'Mediana general'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111559510381399479)
,p_name=>'APEX.IG.MIN'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111535381348399460)
,p_name=>'APEX.IG.MINUTES'
,p_message_language=>'es'
,p_message_text=>'minutos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111560375500399479)
,p_name=>'APEX.IG.MINUTES_AGO'
,p_message_language=>'es'
,p_message_text=>'minutos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111595124316399505)
,p_name=>'APEX.IG.MIN_OVERALL'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo general')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111535785186399461)
,p_name=>'APEX.IG.MONTHS'
,p_message_language=>'es'
,p_message_text=>'meses'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111542303619399466)
,p_name=>'APEX.IG.MORE_DATA_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos contienen m\00E1s de %0 filas que exceden el m\00E1ximo permitido. Aplique los filtros adicionales para ver los resultados.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111569065531399486)
,p_name=>'APEX.IG.MULTIIG_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar el ID est\00E1tico de regi\00F3n, ya que la p\00E1gina contiene varias cuadr\00EDculas interactivas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111538469279399463)
,p_name=>'APEX.IG.NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111538698543399463)
,p_name=>'APEX.IG.NAMED_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe con nombre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111522630796399451)
,p_name=>'APEX.IG.NEXT.DAY'
,p_message_language=>'es'
,p_message_text=>unistr('D\00EDa Siguiente')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111522491415399451)
,p_name=>'APEX.IG.NEXT.HOUR'
,p_message_language=>'es'
,p_message_text=>'Hora Siguiente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111524619450399452)
,p_name=>'APEX.IG.NEXT.MINUTE'
,p_message_language=>'es'
,p_message_text=>unistr('Pr\00F3ximo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111522907059399451)
,p_name=>'APEX.IG.NEXT.MONTH'
,p_message_language=>'es'
,p_message_text=>'Mes Siguiente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111522807744399451)
,p_name=>'APEX.IG.NEXT.WEEK'
,p_message_language=>'es'
,p_message_text=>'Semana siguiente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111522726072399451)
,p_name=>'APEX.IG.NEXT.X_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('Siguientes %0 D\00EDas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111522511374399451)
,p_name=>'APEX.IG.NEXT.X_HOURS'
,p_message_language=>'es'
,p_message_text=>'Siguientes %0 Horas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111524733885399452)
,p_name=>'APEX.IG.NEXT.X_MINUTES'
,p_message_language=>'es'
,p_message_text=>unistr('Pr\00F3ximos %0 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111524063736399452)
,p_name=>'APEX.IG.NEXT.X_MONTHS'
,p_message_language=>'es'
,p_message_text=>unistr('Pr\00F3ximos %0 meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111524168073399452)
,p_name=>'APEX.IG.NEXT.X_WEEKS'
,p_message_language=>'es'
,p_message_text=>unistr('Pr\00F3ximas %0 semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111523101320399451)
,p_name=>'APEX.IG.NEXT.X_YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('Siguientes %0 A\00F1os')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111523033504399451)
,p_name=>'APEX.IG.NEXT.YEAR'
,p_message_language=>'es'
,p_message_text=>unistr('A\00F1o siguiente')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111534345997399460)
,p_name=>'APEX.IG.NOT_BETWEEN'
,p_message_language=>'es'
,p_message_text=>'no entre'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111533355689399459)
,p_name=>'APEX.IG.NOT_EQUALS'
,p_message_language=>'es'
,p_message_text=>'no es igual que'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111599585259399508)
,p_name=>'APEX.IG.NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('La regi\00F3n con el identificador %0 no es una regi\00F3n de cuadr\00EDcula interactiva o no existe en la aplicaci\00F3n %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111533738685399459)
,p_name=>'APEX.IG.NOT_IN'
,p_message_language=>'es'
,p_message_text=>'no en'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111534567674399460)
,p_name=>'APEX.IG.NOT_IN_THE_LAST'
,p_message_language=>'es'
,p_message_text=>unistr('no en los \00FAltimos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111534793579399460)
,p_name=>'APEX.IG.NOT_IN_THE_NEXT'
,p_message_language=>'es'
,p_message_text=>unistr('no en los pr\00F3ximos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111542276486399466)
,p_name=>'APEX.IG.NO_DATA_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn dato')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111580226947399494)
,p_name=>'APEX.IG.NULLS'
,p_message_language=>'es'
,p_message_text=>'Valores nulos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111585323780399498)
,p_name=>'APEX.IG.NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('Num\00E9rico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111580592564399494)
,p_name=>'APEX.IG.OFF'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111580656434399494)
,p_name=>'APEX.IG.ON'
,p_message_language=>'es'
,p_message_text=>'Activado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111532513240399458)
,p_name=>'APEX.IG.ONE_MINUTE_AGO'
,p_message_language=>'es'
,p_message_text=>'Hace 1 minuto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111588258955399500)
,p_name=>'APEX.IG.OPEN_COLORPICKER'
,p_message_language=>'es'
,p_message_text=>'Abrir Selector de Color: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111577089792399491)
,p_name=>'APEX.IG.OPEN_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Abrir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111539515595399463)
,p_name=>'APEX.IG.OPERATOR'
,p_message_language=>'es'
,p_message_text=>'Operador'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111576455540399491)
,p_name=>'APEX.IG.ORIENTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Orientaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111578880157399493)
,p_name=>'APEX.IG.PIE'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico circular')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111540866608399464)
,p_name=>'APEX.IG.PIVOT'
,p_message_language=>'es'
,p_message_text=>unistr('Din\00E1mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111508462335399440)
,p_name=>'APEX.IG.PIVOT_VIEW'
,p_message_language=>'es'
,p_message_text=>unistr('Vista din\00E1mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111588165008399500)
,p_name=>'APEX.IG.PLACEHOLDER_INVALUES'
,p_message_language=>'es'
,p_message_text=>'Separar valores con "%0"'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111578918573399493)
,p_name=>'APEX.IG.POLAR'
,p_message_language=>'es'
,p_message_text=>'Polar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111584275541399497)
,p_name=>'APEX.IG.POSITION_CENTER'
,p_message_language=>'es'
,p_message_text=>'Centro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111584349768399497)
,p_name=>'APEX.IG.POSITION_END'
,p_message_language=>'es'
,p_message_text=>'Fin'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111584142506399497)
,p_name=>'APEX.IG.POSITION_START'
,p_message_language=>'es'
,p_message_text=>'Inicio'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111538760973399463)
,p_name=>'APEX.IG.PRIMARY'
,p_message_language=>'es'
,p_message_text=>'Principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111539052445399463)
,p_name=>'APEX.IG.PRIMARY_DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Por Defecto Primario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111555513254399476)
,p_name=>'APEX.IG.PRIMARY_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe Primario'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111437750953399387)
,p_name=>'APEX.IG.PRINT_ACCESSIBLE.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Incluir etiquetas de accesibilidad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111436450961399386)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.HORIZONTAL.D'
,p_message_language=>'es'
,p_message_text=>'Horizontal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111436575180399387)
,p_name=>'APEX.IG.PRINT_ORIENTATION.LOV.VERTICAL.D'
,p_message_language=>'es'
,p_message_text=>'Vertical'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111436330836399386)
,p_name=>'APEX.IG.PRINT_ORIENTATION.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Orientaci\00F3n de p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111436271451399386)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A3.D'
,p_message_language=>'es'
,p_message_text=>'A3'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111436195058399386)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.A4.D'
,p_message_language=>'es'
,p_message_text=>'A4'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111437870821399387)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.CUSTOM.D'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111435907608399386)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LEGAL.D'
,p_message_language=>'es'
,p_message_text=>'Legal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111435817823399386)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.LETTER.D'
,p_message_language=>'es'
,p_message_text=>'Carta'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111436064697399386)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.LOV.TABLOID.D'
,p_message_language=>'es'
,p_message_text=>'Tabloide'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111435749848399386)
,p_name=>'APEX.IG.PRINT_PAGE_SIZE.PROMPT'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de la P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111425969826399379)
,p_name=>'APEX.IG.PRINT_STRIP_RICH_TEXT.PROMPT'
,p_message_language=>'es'
,p_message_text=>'Borrar texto enriquecido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111579084692399493)
,p_name=>'APEX.IG.RADAR'
,p_message_language=>'es'
,p_message_text=>'Radial'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111579122997399493)
,p_name=>'APEX.IG.RANGE'
,p_message_language=>'es'
,p_message_text=>'Rango'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111589449549399501)
,p_name=>'APEX.IG.REFRESH'
,p_message_language=>'es'
,p_message_text=>'Refrescar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111543028437399466)
,p_name=>'APEX.IG.REFRESH_ROW'
,p_message_language=>'es'
,p_message_text=>'Refrescar fila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111541808063399465)
,p_name=>'APEX.IG.REFRESH_ROWS'
,p_message_language=>'es'
,p_message_text=>'Refrescar filas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111547058337399469)
,p_name=>'APEX.IG.REGION_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('La regi\00F3n de cuadr\00EDcula interactiva no existe en la aplicaci\00F3n %0, p\00E1gina %1 y regi\00F3n %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111509971197399441)
,p_name=>'APEX.IG.REMOVE_CONTROL'
,p_message_language=>'es'
,p_message_text=>'Eliminar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111538158177399462)
,p_name=>'APEX.IG.REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111598779184399508)
,p_name=>'APEX.IG.REPORT.DELETED'
,p_message_language=>'es'
,p_message_text=>'Informe suprimido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111598492877399508)
,p_name=>'APEX.IG.REPORT.SAVED.ALTERNATIVE'
,p_message_language=>'es'
,p_message_text=>'Se ha guardado el informe alternativo para todos los usuarios'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111598390769399507)
,p_name=>'APEX.IG.REPORT.SAVED.DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Se ha guardado el informe por defecto para todos los usuarios'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111598662057399508)
,p_name=>'APEX.IG.REPORT.SAVED.PRIVATE'
,p_message_language=>'es'
,p_message_text=>'Informe privado guardado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111598501037399508)
,p_name=>'APEX.IG.REPORT.SAVED.PUBLIC'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha guardado el informe p\00FAblico para todos los usuarios')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111547178017399469)
,p_name=>'APEX.IG.REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('La cuadr\00EDcula interactiva guardada con el nombre %0 no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111532410655399458)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF.X.MINUTES_AGO'
,p_message_language=>'es'
,p_message_text=>'Informar de datos de hace %0 minutos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111532385520399458)
,p_name=>'APEX.IG.REPORT_DATA_AS_OF_ONE_MINUTE_AGO'
,p_message_language=>'es'
,p_message_text=>'Informar de datos de hace 1 minuto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111472007244399413)
,p_name=>'APEX.IG.REPORT_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('El informe de cuadr\00EDcula interactiva no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111591657701399502)
,p_name=>'APEX.IG.REPORT_EDIT'
,p_message_language=>'es'
,p_message_text=>'Informe - Editar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111546943247399469)
,p_name=>'APEX.IG.REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('La cuadr\00EDcula interactiva guardada con el ID %0 no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111591511132399502)
,p_name=>'APEX.IG.REPORT_SAVE_AS'
,p_message_language=>'es'
,p_message_text=>'Informe - Guardar como'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111510061932399442)
,p_name=>'APEX.IG.REPORT_SETTINGS'
,p_message_language=>'es'
,p_message_text=>'Valores de informe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111599637034399508)
,p_name=>'APEX.IG.REPORT_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('La cuadr\00EDcula interactiva guardada con el identificador est\00E1tico %0 no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111594523107399505)
,p_name=>'APEX.IG.REPORT_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Informe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111509166416399441)
,p_name=>'APEX.IG.RESET'
,p_message_language=>'es'
,p_message_text=>'Restablecer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111543128452399466)
,p_name=>'APEX.IG.REVERT_CHANGES'
,p_message_language=>'es'
,p_message_text=>'Revertir Cambios'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111541997902399465)
,p_name=>'APEX.IG.REVERT_ROWS'
,p_message_language=>'es'
,p_message_text=>'Revertir filas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111539165205399463)
,p_name=>'APEX.IG.ROW'
,p_message_language=>'es'
,p_message_text=>'Fila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111538040675399462)
,p_name=>'APEX.IG.ROWS_PER_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Filas por P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111599246386399508)
,p_name=>'APEX.IG.ROW_ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Acciones de Fila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111600430155399509)
,p_name=>'APEX.IG.ROW_ACTIONS_FOR'
,p_message_language=>'es'
,p_message_text=>'Acciones para la fila %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111509410287399441)
,p_name=>'APEX.IG.SAVE'
,p_message_language=>'es'
,p_message_text=>'Guardar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111552146060399473)
,p_name=>'APEX.IG.SAVED'
,p_message_language=>'es'
,p_message_text=>'guardado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111507697427399440)
,p_name=>'APEX.IG.SAVED_REPORTS'
,p_message_language=>'es'
,p_message_text=>'Informes Guardados'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111507707081399440)
,p_name=>'APEX.IG.SAVED_REPORT_DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Por defecto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111482273989399420)
,p_name=>'APEX.IG.SAVED_REPORT_EXISTS'
,p_message_language=>'es'
,p_message_text=>'Ya existe un informe guardado que se llama %0. Introduzca un nuevo nombre.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111507851658399440)
,p_name=>'APEX.IG.SAVED_REPORT_PRIVATE'
,p_message_language=>'es'
,p_message_text=>'Privado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111507955854399440)
,p_name=>'APEX.IG.SAVED_REPORT_PUBLIC'
,p_message_language=>'es'
,p_message_text=>unistr('P\00FAblico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111594267174399504)
,p_name=>'APEX.IG.SAVE_AS'
,p_message_language=>'es'
,p_message_text=>'Guardar como'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111541277532399465)
,p_name=>'APEX.IG.SAVE_REPORT_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('Guardar Configuraci\00F3n de Informe')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111579257475399493)
,p_name=>'APEX.IG.SCATTER'
,p_message_language=>'es'
,p_message_text=>unistr('Dispersi\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111507594261399440)
,p_name=>'APEX.IG.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111586503335399499)
,p_name=>'APEX.IG.SEARCH.ALL_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Buscar: Todas las columnas de texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111507488540399440)
,p_name=>'APEX.IG.SEARCH.COLUMN'
,p_message_language=>'es'
,p_message_text=>'Buscar: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111585746314399498)
,p_name=>'APEX.IG.SEARCH.ORACLE_TEXT'
,p_message_language=>'es'
,p_message_text=>'Buscar: Texto completo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111532204546399458)
,p_name=>'APEX.IG.SEARCH_FOR.X'
,p_message_language=>'es'
,p_message_text=>'Buscar ''%0'''
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111575858284399491)
,p_name=>'APEX.IG.SELECT'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar -'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111516074518399446)
,p_name=>'APEX.IG.SELECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Selecci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111568738945399485)
,p_name=>'APEX.IG.SELECT_1_ROW_IN_MASTER'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione 1 fila en la regi\00F3n maestra')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111507367407399440)
,p_name=>'APEX.IG.SELECT_COLUMNS_TO_SEARCH'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Columnas a Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111598999099399508)
,p_name=>'APEX.IG.SEL_ACTIONS'
,p_message_language=>'es'
,p_message_text=>unistr('Acciones de selecci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111516218154399446)
,p_name=>'APEX.IG.SEL_MODE_CELL'
,p_message_language=>'es'
,p_message_text=>unistr('Selecci\00F3n de celdas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111516158542399446)
,p_name=>'APEX.IG.SEL_MODE_ROW'
,p_message_language=>'es'
,p_message_text=>unistr('Selecci\00F3n de Fila')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111587164703399499)
,p_name=>'APEX.IG.SEND_AS_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar como Correo Electr\00F3nico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111579607751399493)
,p_name=>'APEX.IG.SERIES_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Serie'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111505328083399438)
,p_name=>'APEX.IG.SHOW'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111557982240399477)
,p_name=>'APEX.IG.SHOW_OVERALL_VALUE'
,p_message_language=>'es'
,p_message_text=>'Mostrar Valor General'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111542776918399466)
,p_name=>'APEX.IG.SINGLE_ROW_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Una Sola Fila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111541029229399465)
,p_name=>'APEX.IG.SORT'
,p_message_language=>'es'
,p_message_text=>'Ordenar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111579730764399493)
,p_name=>'APEX.IG.SORT_BY'
,p_message_language=>'es'
,p_message_text=>'Ordenar por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111599395127399508)
,p_name=>'APEX.IG.SORT_ONLY_ONE_PER_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Solo se puede definir una ordenaci\00F3n por columna.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111599196457399508)
,p_name=>'APEX.IG.SRV_CHANGE_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Cambiar Men\00FA')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111580719890399494)
,p_name=>'APEX.IG.STACK'
,p_message_language=>'es'
,p_message_text=>'Pila'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111535084119399460)
,p_name=>'APEX.IG.STARTS_WITH'
,p_message_language=>'es'
,p_message_text=>'empieza por'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111579372824399493)
,p_name=>'APEX.IG.STOCK'
,p_message_language=>'es'
,p_message_text=>'Valores'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111500351921399434)
,p_name=>'APEX.IG.STRETCH_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Expandir anchos de columna'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111541400996399465)
,p_name=>'APEX.IG.SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Suscripci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111559485939399478)
,p_name=>'APEX.IG.SUM'
,p_message_language=>'es'
,p_message_text=>'Suma'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111600699699399509)
,p_name=>'APEX.IG.SUMMARY'
,p_message_language=>'es'
,p_message_text=>unistr('Cuadr\00EDcula interactiva. Informe: %0, vista: %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111594651250399505)
,p_name=>'APEX.IG.SUM_OVERALL'
,p_message_language=>'es'
,p_message_text=>'Suma general'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111577502758399492)
,p_name=>'APEX.IG.TARGET_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Destino'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111583946686399497)
,p_name=>'APEX.IG.TEXT_COLOR'
,p_message_language=>'es'
,p_message_text=>'Color del texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111510152374399442)
,p_name=>'APEX.IG.TOGGLE'
,p_message_language=>'es'
,p_message_text=>'Conmutar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111557870930399477)
,p_name=>'APEX.IG.TOOLTIP'
,p_message_language=>'es'
,p_message_text=>'Pista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111538289407399463)
,p_name=>'APEX.IG.TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111542673990399466)
,p_name=>'APEX.IG.UNFREEZE'
,p_message_language=>'es'
,p_message_text=>'Descongelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111539761313399464)
,p_name=>'APEX.IG.UNIT'
,p_message_language=>'es'
,p_message_text=>'Unidad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111586934054399499)
,p_name=>'APEX.IG.UNSAVED_CHANGES_CONTINUE_CONFIRM'
,p_message_language=>'es'
,p_message_text=>unistr('Hay cambios sin guardar. \00BFDesea continuar?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111539689046399464)
,p_name=>'APEX.IG.VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111576630221399491)
,p_name=>'APEX.IG.VALUE_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Valor'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111581529911399495)
,p_name=>'APEX.IG.VALUE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Se necesita un valor.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111566442764399484)
,p_name=>'APEX.IG.VALUE_TIMESTAMP_TZ'
,p_message_language=>'es'
,p_message_text=>'Valor (no se puede cambiar la zona horaria)'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111585409645399498)
,p_name=>'APEX.IG.VARCHAR2'
,p_message_language=>'es'
,p_message_text=>'Texto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111577967022399492)
,p_name=>'APEX.IG.VERTICAL'
,p_message_language=>'es'
,p_message_text=>'Vertical'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111537794501399462)
,p_name=>'APEX.IG.VIEW'
,p_message_language=>'es'
,p_message_text=>'Ver'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111575954319399491)
,p_name=>'APEX.IG.VISIBLE'
,p_message_language=>'es'
,p_message_text=>'Mostrado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111577499929399492)
,p_name=>'APEX.IG.VOLUME_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Volumen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111535607696399461)
,p_name=>'APEX.IG.WEEKS'
,p_message_language=>'es'
,p_message_text=>'semanas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111576057446399491)
,p_name=>'APEX.IG.WIDTH'
,p_message_language=>'es'
,p_message_text=>unistr('Ancho de Columna M\00EDnimo (P\00EDxel)')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111526833285399454)
,p_name=>'APEX.IG.X.BETWEEN.Y.AND.Z'
,p_message_language=>'es'
,p_message_text=>'%0 entre %1 y %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111526544795399454)
,p_name=>'APEX.IG.X.CONTAINS.Y'
,p_message_language=>'es'
,p_message_text=>'%0 contiene %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111526628756399454)
,p_name=>'APEX.IG.X.DOES_NOT_CONTAIN.Y'
,p_message_language=>'es'
,p_message_text=>'%0 no contiene %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111504722340399438)
,p_name=>'APEX.IG.X.DOES_NOT_START_WITH.Y'
,p_message_language=>'es'
,p_message_text=>'%0 no empieza por %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111525306940399453)
,p_name=>'APEX.IG.X.EQUALS.Y'
,p_message_language=>'es'
,p_message_text=>'%0 igual que %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111525563211399453)
,p_name=>'APEX.IG.X.GREATER_THAN.Y'
,p_message_language=>'es'
,p_message_text=>'%0 mayor que %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111525650600399453)
,p_name=>'APEX.IG.X.GREATER_THAN_OR_EQUALS.Y'
,p_message_language=>'es'
,p_message_text=>'0% mayor o igual que %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111526345592399454)
,p_name=>'APEX.IG.X.IN.Y'
,p_message_language=>'es'
,p_message_text=>'%0 en %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111527576692399455)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en los \00FAltimos %1 d\00EDas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111527365094399454)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.HOURS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en las \00FAltimas %1 horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111527119404399454)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MINUTES'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en los \00FAltimos %1 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111527967661399455)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.MONTHS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en los \00FAltimos %1 meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111527735650399455)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.WEEKS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en las \00FAltimas %1 semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111528115828399455)
,p_name=>'APEX.IG.X.IN_THE_LAST.Y.YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en los \00FAltimos %1 a\00F1os')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111527410241399454)
,p_name=>'APEX.IG.X.IN_THE_LAST_DAY'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en el \00FAltimo d\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111527224360399454)
,p_name=>'APEX.IG.X.IN_THE_LAST_HOUR'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en la \00FAltima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111527012266399454)
,p_name=>'APEX.IG.X.IN_THE_LAST_MINUTE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en el \00FAltimo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111527810910399455)
,p_name=>'APEX.IG.X.IN_THE_LAST_MONTH'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en el \00FAltimo mes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111527657067399455)
,p_name=>'APEX.IG.X.IN_THE_LAST_WEEK'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en la \00FAltima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111528064634399455)
,p_name=>'APEX.IG.X.IN_THE_LAST_YEAR'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en el \00FAltimo a\00F1o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111529944355399456)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en los pr\00F3ximos %1 d\00EDas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111529789559399456)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.HOURS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en las pr\00F3ximas %1 horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111529534992399456)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en los pr\00F3ximos %1 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111530370457399457)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en los pr\00F3ximos %1 meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111530145553399456)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en las pr\00F3ximas %1 semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111530505705399457)
,p_name=>'APEX.IG.X.IN_THE_NEXT.Y.YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en los pr\00F3ximos %1 a\00F1os')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111529819083399456)
,p_name=>'APEX.IG.X.IN_THE_NEXT_DAY'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en el pr\00F3ximo d\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111529647703399456)
,p_name=>'APEX.IG.X.IN_THE_NEXT_HOUR'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en la pr\00F3xima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111529426780399456)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MINUTE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en el pr\00F3ximo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111530247808399457)
,p_name=>'APEX.IG.X.IN_THE_NEXT_MONTH'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en el pr\00F3ximo mes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111530029557399456)
,p_name=>'APEX.IG.X.IN_THE_NEXT_WEEK'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en la pr\00F3xima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111530441523399457)
,p_name=>'APEX.IG.X.IN_THE_NEXT_YEAR'
,p_message_language=>'es'
,p_message_text=>unistr('%0 en el pr\00F3ximo a\00F1o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111526054182399453)
,p_name=>'APEX.IG.X.IS_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no est\00E1 vac\00EDo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111525943372399453)
,p_name=>'APEX.IG.X.IS_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('%0 est\00E1 vac\00EDo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111525782953399453)
,p_name=>'APEX.IG.X.LESS_THAN.Y'
,p_message_language=>'es'
,p_message_text=>'%0 menor que %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111525887525399453)
,p_name=>'APEX.IG.X.LESS_THAN_OR_EQUALS.Y'
,p_message_language=>'es'
,p_message_text=>'0% menor o igual que %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111526111888399454)
,p_name=>'APEX.IG.X.LIKE.Y'
,p_message_language=>'es'
,p_message_text=>'%0 igual que %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111526766507399454)
,p_name=>'APEX.IG.X.MATCHES_REGULAR_EXPRESSION.Y'
,p_message_language=>'es'
,p_message_text=>unistr('%0 coincide con la expresi\00F3n regular %1')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111532695527399458)
,p_name=>'APEX.IG.X.MINUTES_AGO'
,p_message_language=>'es'
,p_message_text=>'Hace %0 minutos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111526949313399454)
,p_name=>'APEX.IG.X.NOT_BETWEEN.Y.AND.Z'
,p_message_language=>'es'
,p_message_text=>'%0 no entre %1 y %2'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111525449110399453)
,p_name=>'APEX.IG.X.NOT_EQUALS.Y'
,p_message_language=>'es'
,p_message_text=>'%0 distinto de %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111526462226399454)
,p_name=>'APEX.IG.X.NOT_IN.Y'
,p_message_language=>'es'
,p_message_text=>'%0 no en %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111528706344399455)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en los \00FAltimos %1 d\00EDas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111528545502399455)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.HOURS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en las \00FAltimas %1 horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111528359335399455)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MINUTES'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en los \00FAltimos %1 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111529127112399456)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.MONTHS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en los \00FAltimos %1 meses')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111528976515399456)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.WEEKS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en las \00FAltimas %1 semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111529316796399456)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST.Y.YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en los \00FAltimos %1 a\00F1os')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111528606903399455)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_DAY'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en el \00FAltimo d\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111528469318399455)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_HOUR'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en la \00FAltima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111528233514399455)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MINUTE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en el \00FAltimo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111529004287399456)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_MONTH'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en el \00FAltimo mes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111528879718399455)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_WEEK'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en la \00FAltima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111529213599399456)
,p_name=>'APEX.IG.X.NOT_IN_THE_LAST_YEAR'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en el \00FAltimo a\00F1o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111531157181399457)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en los pr\00F3ximos %1 d\00EDas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111530955730399457)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.HOURS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en las pr\00F3ximas %1 horas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111530733798399457)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MINUTES'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en los pr\00F3ximos %1 minutos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111531546230399458)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.MONTHS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en los pr\00F3ximos %1 meses ')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111531327608399457)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.WEEKS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en las pr\00F3ximas %1 semanas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111531707526399458)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT.Y.YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en los pr\00F3ximos %1 a\00F1os')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111531037475399457)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_DAY'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en el pr\00F3ximo d\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111530810933399457)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_HOUR'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en la pr\00F3xima hora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111530684944399457)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MINUTE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en el pr\00F3ximo minuto')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111531496843399457)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_MONTH'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en el pr\00F3ximo mes')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111531267437399457)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_WEEK'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en la pr\00F3xima semana')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111531682491399458)
,p_name=>'APEX.IG.X.NOT_IN_THE_NEXT_YEAR'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no en el pr\00F3ximo a\00F1o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111526250836399454)
,p_name=>'APEX.IG.X.NOT_LIKE.Y'
,p_message_language=>'es'
,p_message_text=>'%0 no igual que %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111533122109399459)
,p_name=>'APEX.IG.X.STARTS_WITH.Y'
,p_message_language=>'es'
,p_message_text=>'0% empieza por %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111576793614399491)
,p_name=>'APEX.IG.X_COLUMN'
,p_message_language=>'es'
,p_message_text=>'X'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111535887889399461)
,p_name=>'APEX.IG.YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('a\00F1os')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111576846263399491)
,p_name=>'APEX.IG.Y_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111576907120399491)
,p_name=>'APEX.IG.Z_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Z'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111585932398399498)
,p_name=>'APEX.IG_FORMAT_SAMPLE_1'
,p_message_language=>'es'
,p_message_text=>'Lunes, 12 de enero, 2016'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111586077575399498)
,p_name=>'APEX.IG_FORMAT_SAMPLE_2'
,p_message_language=>'es'
,p_message_text=>'Enero'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111586119621399498)
,p_name=>'APEX.IG_FORMAT_SAMPLE_3'
,p_message_language=>'es'
,p_message_text=>'Hace 16 horas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111586274892399498)
,p_name=>'APEX.IG_FORMAT_SAMPLE_4'
,p_message_language=>'es'
,p_message_text=>'en 16 h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111441223817399390)
,p_name=>'APEX.ITEM.FILE.ACCEPTED_TYPES'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de archivo no v\00E1lido. Los tipos de archivo soportados son %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111568161016399485)
,p_name=>'APEX.ITEM.FILE.BROWSE'
,p_message_language=>'es'
,p_message_text=>'Examinar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111567816271399485)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILE'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Archivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111567971872399485)
,p_name=>'APEX.ITEM.FILE.CHOOSE_FILES'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Archivos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111441077105399390)
,p_name=>'APEX.ITEM.FILE.DROP_FILE'
,p_message_language=>'es'
,p_message_text=>'Arrastrar y Soltar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111441416438399390)
,p_name=>'APEX.ITEM.FILE.DROP_FILES'
,p_message_language=>'es'
,p_message_text=>'Arrastrar y soltar archivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111442628473399391)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILE'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un archivo o suelte uno aqu\00ED.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111442705313399391)
,p_name=>'APEX.ITEM.FILE.DROP_OR_CHOOSE_FILES'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione o suelte archivos aqu\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111442821470399391)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILE'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione un archivo o suelte uno aqu\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111442910727399391)
,p_name=>'APEX.ITEM.FILE.DROP_OR_SELECT_FILES'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccione o suelte archivos aqu\00ED.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111441305556399390)
,p_name=>'APEX.ITEM.FILE.FILES_WITH_COUNT'
,p_message_language=>'es'
,p_message_text=>'%0 archivos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111441132437399390)
,p_name=>'APEX.ITEM.FILE.MAX_FILE_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('El archivo es demasiado grande. El tama\00F1o m\00E1ximo de archivo es %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111428912313399381)
,p_name=>'APEX.ITEM.GEOCODE.ADDRESS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('La direcci\00F3n es obligatoria.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111427845450399380)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_CITY'
,p_message_language=>'es'
,p_message_text=>'Ciudad'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111428214654399380)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_COUNTRY'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo de Pa\00EDs')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111427934095399380)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_HOUSENUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('N\00FAmero de Casa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111428852589399381)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LATITUDE'
,p_message_language=>'es'
,p_message_text=>'Latitud'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111428791228399381)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_LONGITUDE'
,p_message_language=>'es'
,p_message_text=>'Longitud'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111428674163399381)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MAPLINK'
,p_message_language=>'es'
,p_message_text=>'Mostrar en Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111428384347399380)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_MATCHSCORE'
,p_message_language=>'es'
,p_message_text=>unistr('Puntuaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111428092017399380)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_POSTALCODE'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo Postal')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111428117322399380)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STATE'
,p_message_language=>'es'
,p_message_text=>'Estado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111427723341399380)
,p_name=>'APEX.ITEM.GEOCODE.COLUMN_STREET'
,p_message_language=>'es'
,p_message_text=>'Calle'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111427674811399380)
,p_name=>'APEX.ITEM.GEOCODE.DIALOG_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Resultados de geocodificaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111440223407399389)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_DONE'
,p_message_language=>'es'
,p_message_text=>unistr('Con geocodificaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111440301116399389)
,p_name=>'APEX.ITEM.GEOCODE.GEOCODING_OPEN'
,p_message_language=>'es'
,p_message_text=>'Sin geocodificar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111428551704399381)
,p_name=>'APEX.ITEM.GEOCODE.MAP_DIALOG_TITLE'
,p_message_language=>'es'
,p_message_text=>'Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111428455916399381)
,p_name=>'APEX.ITEM.GEOCODE.NO_DATA_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ninguna direcci\00F3n.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111429086494399381)
,p_name=>'APEX.ITEM.GEOCODE.REQUIRED'
,p_message_language=>'es'
,p_message_text=>'%0 es obligatorio.'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111598852459399508)
,p_name=>'APEX.ITEM.HELP_TEXT'
,p_message_language=>'es'
,p_message_text=>'Texto de Ayuda: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111492231589399428)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.CHECKED'
,p_message_language=>'es'
,p_message_text=>'Activado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111492358447399428)
,p_name=>'APEX.ITEM_TYPE.CHECKBOX.UNCHECKED'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111438240189399388)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# no se encuentra en el rango v\00E1lido de %0 a %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111438390139399388)
,p_name=>'APEX.ITEM_TYPE.SLIDER.VALUE_NOT_MULTIPLE_OF_STEP'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# no es un m\00FAltiplo de %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111437937678399388)
,p_name=>'APEX.ITEM_TYPE.YES_NO.INVALID_VALUE'
,p_message_language=>'es'
,p_message_text=>'#LABEL# debe coincidir con los valores %0 y %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111438194452399388)
,p_name=>'APEX.ITEM_TYPE.YES_NO.NO_LABEL'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111516433350399446)
,p_name=>'APEX.ITEM_TYPE.YES_NO.OFF_LABEL'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111516504980399446)
,p_name=>'APEX.ITEM_TYPE.YES_NO.ON_LABEL'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111438036064399388)
,p_name=>'APEX.ITEM_TYPE.YES_NO.YES_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111421421410399375)
,p_name=>'APEX.LIST_MANAGER.ADD_ENTRY'
,p_message_language=>'es'
,p_message_text=>'Agregar Entrada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111550612280399472)
,p_name=>'APEX.LIST_MANAGER.BUTTON_ADD'
,p_message_language=>'es'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111550718858399472)
,p_name=>'APEX.LIST_MANAGER.BUTTON_REMOVE'
,p_message_language=>'es'
,p_message_text=>'Eliminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111421544827399375)
,p_name=>'APEX.LIST_MANAGER.SELECTED_ENTRY'
,p_message_language=>'es'
,p_message_text=>'Entradas seleccionadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111554400404399475)
,p_name=>'APEX.LTO.ADVANCED'
,p_message_language=>'es'
,p_message_text=>'Avanzado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111554781770399475)
,p_name=>'APEX.LTO.CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111554516992399475)
,p_name=>'APEX.LTO.COMMON'
,p_message_language=>'es'
,p_message_text=>unistr('Com\00FAn')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111554872815399475)
,p_name=>'APEX.LTO.LIVE_TEMPLATE_OPTIONS'
,p_message_language=>'es'
,p_message_text=>'Opciones de Plantilla Activas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111555420552399475)
,p_name=>'APEX.LTO.NOT_APPLICABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Las opciones de plantilla no est\00E1n disponibles porque este componente no est\00E1 representado en la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111554345756399475)
,p_name=>'APEX.LTO.NO_OPTIONS_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ninguna opci\00F3n de plantilla.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111554627644399475)
,p_name=>'APEX.LTO.SAVE'
,p_message_language=>'es'
,p_message_text=>'Guardar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111429954454399382)
,p_name=>'APEX.MAPS.CLEAR_CIRCLE'
,p_message_language=>'es'
,p_message_text=>unistr('Borrar c\00EDrculo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111431747971399383)
,p_name=>'APEX.MAPS.CUSTOM_STYLES_INVALID_JSON'
,p_message_language=>'es'
,p_message_text=>unistr('Estilos personalizados no es un JSON v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111430209330399382)
,p_name=>'APEX.MAPS.DISTANCE_TOOL'
,p_message_language=>'es'
,p_message_text=>'Herramienta Distancia'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111430079416399382)
,p_name=>'APEX.MAPS.DRAW_CIRCLE'
,p_message_language=>'es'
,p_message_text=>'Dibujar circulo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111422620622399376)
,p_name=>'APEX.MAPS.FACETED_SEARCH_NEEDS_REGION_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Para realizar la b\00FAsqueda por facetas se necesita un origen de datos en el nivel de la regi\00F3n.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111425281845399378)
,p_name=>'APEX.MAPS.FIND_MY_LOCATION'
,p_message_language=>'es'
,p_message_text=>unistr('Ubicaci\00F3n actual')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111426320792399379)
,p_name=>'APEX.MAPS.INIT_POINT_COORDINATES_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('Las coordenadas de la posici\00F3n inicial no son v\00E1lidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111423702640399377)
,p_name=>'APEX.MAPS.INIT_POINT_GEOMETRY_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('La posici\00F3n inicial debe ser una geometr\00EDa de puntos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111426144954399379)
,p_name=>'APEX.MAPS.KM'
,p_message_language=>'es'
,p_message_text=>'km'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111424740056399378)
,p_name=>'APEX.MAPS.LAYER'
,p_message_language=>'es'
,p_message_text=>'Capa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111558084453399477)
,p_name=>'APEX.MAPS.LAYER_NAME'
,p_message_language=>'es'
,p_message_text=>'Capa: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111429379244399381)
,p_name=>'APEX.MAPS.MAP'
,p_message_language=>'es'
,p_message_text=>'Mapa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111422549897399376)
,p_name=>'APEX.MAPS.MAP_MESSAGES'
,p_message_language=>'es'
,p_message_text=>'Mensajes'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111426222280399379)
,p_name=>'APEX.MAPS.MILES'
,p_message_language=>'es'
,p_message_text=>'millas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111557005706399477)
,p_name=>'APEX.MAPS.MORE_DATA_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos contienen m\00E1s de %0 filas que superan el m\00E1ximo permitido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111424520001399378)
,p_name=>'APEX.MAPS.ORACLE_MAP_COPYRIGHT'
,p_message_language=>'es'
,p_message_text=>'&copy; <a target="_blank" href="https://elocation.oracle.com/elocation/legal.html">Condiciones</a> de Oracle Corporation 2018 &nbsp;&nbsp; Datos de mapas &copy; 2017 HERE'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111423417005399377)
,p_name=>'APEX.MAPS.ORACLE_SDO_GEOMETRY_NOT_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('El tipo de dato SDO_GEOMETRY no est\00E1 disponible en esta base de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111424627160399378)
,p_name=>'APEX.MAPS.OSM_MAP_COPYRIGHT'
,p_message_language=>'es'
,p_message_text=>'<a target="_blank" href="http://openmaptiles.org"> &copy; OpenMapTiles </a> &nbsp; <a target="_blank" href="https://www.openstreetmap.org/copyright"> &copy; Contribuyentes de OpenStreetMap</a>'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111424821735399378)
,p_name=>'APEX.MAPS.POINTS'
,p_message_language=>'es'
,p_message_text=>'Puntos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111558199017399477)
,p_name=>'APEX.MAPS.POINTS_COUNT'
,p_message_language=>'es'
,p_message_text=>'%0 puntos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111430139191399382)
,p_name=>'APEX.MAPS.RECTANGLE_ZOOM'
,p_message_language=>'es'
,p_message_text=>unistr('Zoom con rect\00E1ngulo')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111429809373399382)
,p_name=>'APEX.MAPS.REMOVE_MESSAGE'
,p_message_language=>'es'
,p_message_text=>'Eliminar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111425167898399378)
,p_name=>'APEX.MAPS.RESET_BEARING_TO_NORTH'
,p_message_language=>'es'
,p_message_text=>'Restablecer rumbo a norte'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111505492578399438)
,p_name=>'APEX.MAPS.TOGGLE_2D_MODE'
,p_message_language=>'es'
,p_message_text=>'Conmutar a modo 2D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111505543069399438)
,p_name=>'APEX.MAPS.TOGGLE_3D_MODE'
,p_message_language=>'es'
,p_message_text=>'Conmutar a modo 3D'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111429765775399381)
,p_name=>'APEX.MAPS.TOGGLE_COPYRIGHT'
,p_message_language=>'es'
,p_message_text=>'Conmutar aviso de copyright'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111430343764399382)
,p_name=>'APEX.MAPS.TOTAL_DISTANCE'
,p_message_language=>'es'
,p_message_text=>'Distancia Total'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111424948364399378)
,p_name=>'APEX.MAPS.ZOOM_IN'
,p_message_language=>'es'
,p_message_text=>'Acercar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111425090299399378)
,p_name=>'APEX.MAPS.ZOOM_OUT'
,p_message_language=>'es'
,p_message_text=>'Alejar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111552595477399473)
,p_name=>'APEX.MARKDOWN.BOLD'
,p_message_language=>'es'
,p_message_text=>'Negrita'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111553423883399474)
,p_name=>'APEX.MARKDOWN.IMAGE'
,p_message_language=>'es'
,p_message_text=>'Imagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111553033595399474)
,p_name=>'APEX.MARKDOWN.INLINE_CODE'
,p_message_language=>'es'
,p_message_text=>unistr('C\00F3digo en l\00EDnea')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111566633182399484)
,p_name=>'APEX.MARKDOWN.INSERT_IMAGE'
,p_message_language=>'es'
,p_message_text=>'Insertar imagen'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111566780966399484)
,p_name=>'APEX.MARKDOWN.INSERT_LINK'
,p_message_language=>'es'
,p_message_text=>'Insertar Enlace'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111552675134399473)
,p_name=>'APEX.MARKDOWN.ITALIC'
,p_message_language=>'es'
,p_message_text=>'Cursiva'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111567322130399484)
,p_name=>'APEX.MARKDOWN.LINK'
,p_message_language=>'es'
,p_message_text=>'Enlace'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111553310247399474)
,p_name=>'APEX.MARKDOWN.LIST'
,p_message_language=>'es'
,p_message_text=>'Lista'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111553273492399474)
,p_name=>'APEX.MARKDOWN.ORDERED_LIST'
,p_message_language=>'es'
,p_message_text=>'Lista Ordenada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111552737117399473)
,p_name=>'APEX.MARKDOWN.PREVIEW'
,p_message_language=>'es'
,p_message_text=>'Vista previa'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111552847554399473)
,p_name=>'APEX.MARKDOWN.PREVIEW_EMPTY'
,p_message_language=>'es'
,p_message_text=>'Nada que mostrar en la vista previa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111552958875399474)
,p_name=>'APEX.MARKDOWN.STRIKETHROUGH'
,p_message_language=>'es'
,p_message_text=>'Tachado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111553171904399474)
,p_name=>'APEX.MARKDOWN.UNORDERED_LIST'
,p_message_language=>'es'
,p_message_text=>'Lista Desordenada'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111532037782399458)
,p_name=>'APEX.MENU.CURRENT_MENU'
,p_message_language=>'es'
,p_message_text=>'actual'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111589546661399501)
,p_name=>'APEX.MENU.OVERFLOW_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1s...')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111531994607399458)
,p_name=>'APEX.MENU.PROCESSING'
,p_message_language=>'es'
,p_message_text=>'Cargando'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111563787680399482)
,p_name=>'APEX.NOTIFICATION_MESSAGE_HEADING'
,p_message_language=>'es'
,p_message_text=>unistr('Mensaje de Notificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111537088637399462)
,p_name=>'APEX.NUMBER_FIELD.VALUE_GREATER_MAX_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser un n\00FAmero menor o igual que %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111537137357399462)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser un n\00FAmero v\00E1lido.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111537214038399462)
,p_name=>'APEX.NUMBER_FIELD.VALUE_INVALID2'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# no coincide con el formato num\00E9rico %0 (Ejemplo: %1).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111536916587399462)
,p_name=>'APEX.NUMBER_FIELD.VALUE_LESS_MIN_VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser un n\00FAmero mayor o igual que %0.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111536870153399461)
,p_name=>'APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe ser un n\00FAmero entre %0 y %1.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111532195258399458)
,p_name=>'APEX.OPENS_IN_NEW_WINDOW_LOWER'
,p_message_language=>'es'
,p_message_text=>'se abre en una nueva ventana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111485336335399423)
,p_name=>'APEX.PAGE.DUPLICATE_SUBMIT'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina ya se ha ejecutado y no se puede volver a ejecutar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111467934654399410)
,p_name=>'APEX.PAGE.NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la aplicaci\00F3n "%0" p\00E1gina "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111501722828399435)
,p_name=>'APEX.PAGE_ITEM_IS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('#LABEL# debe tener alg\00FAn valor.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111445074600399393)
,p_name=>'APEX.POPUP.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111551028202399472)
,p_name=>'APEX.POPUP_LOV.BUTTON_CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111550964567399472)
,p_name=>'APEX.POPUP_LOV.BUTTON_FIND'
,p_message_language=>'es'
,p_message_text=>'Buscar %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111551252225399472)
,p_name=>'APEX.POPUP_LOV.BUTTON_NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111551186036399472)
,p_name=>'APEX.POPUP_LOV.BUTTON_PREV'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111437188405399387)
,p_name=>'APEX.POPUP_LOV.FILTER_REQ'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un t\00E9rmino de b\00FAsqueda con al menos %0 caracteres.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111506620626399439)
,p_name=>'APEX.POPUP_LOV.ICON_TEXT'
,p_message_language=>'es'
,p_message_text=>'Lista de Valores Emergente: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111437211841399387)
,p_name=>'APEX.POPUP_LOV.INITIAL_FILTER_REQ'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un t\00E9rmino de b\00FAsqueda.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111437069978399387)
,p_name=>'APEX.POPUP_LOV.NO_RESULTS'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn resultado.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111436970548399387)
,p_name=>'APEX.POPUP_LOV.REMOVE_VALUE'
,p_message_language=>'es'
,p_message_text=>'Eliminar %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111524853241399453)
,p_name=>'APEX.POPUP_LOV.SEARCH'
,p_message_language=>'es'
,p_message_text=>unistr('T\00E9rmino de B\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111550855829399472)
,p_name=>'APEX.POPUP_LOV.TITLE'
,p_message_language=>'es'
,p_message_text=>'Buscar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111561587681399480)
,p_name=>'APEX.PROCESSING'
,p_message_language=>'es'
,p_message_text=>'Procesamiento'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111435557002399386)
,p_name=>'APEX.PWA.DIALOG.TITLE'
,p_message_language=>'es'
,p_message_text=>'Agregar a Pantalla Inicial'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111431516618399383)
,p_name=>'APEX.PWA.INSTRUCTIONS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Parece que su dispositivo o navegador no soporta la instalaci\00F3n de aplicaciones web progresivas ahora mismo.</p>'),
unistr('    <p class="a-pwaDialog-intro">Si esta aplicaci\00F3n ya est\00E1 instalada en el dispositivo, \00E1brala desde la pantalla de inicio.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111431175866399383)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.FIREFOX'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n. Agr\00E9guelo a su pantalla de inicio para obtener la mejor experiencia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque el icono <strong>Men\00FA</strong> situado en la barra de navegaci\00F3n inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-firefox-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toque <strong>Instalar</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque <strong>Agregar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111431211444399383)
,p_name=>'APEX.PWA.INSTRUCTIONS.ANDROID.WEBVIEW'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n, y Chrome o Edge ofrecen la mejor experiencia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-android-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque el icono <strong>Men\00FA</strong> situado junto a la barra de direcciones</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toque <strong>Instalar</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111430841710399382)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.GSA'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n, y Safari ofrece la mejor experiencia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque el icono <strong>Compartir</strong> situado en la barra de navegaci\00F3n inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-gsa-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toque <strong>Abrir en Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111430575637399382)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPAD'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n. Agr\00E9guelo a su pantalla de inicio para obtener la mejor experiencia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
'        <p class="a-pwaDialog-stepText">1. Toque el icono <strong>Compartir</strong> situado junto a la barra de direcciones</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toque <strong>Agregar a pantalla inicial</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque <strong style="color:#007AE1;">Agregar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111430473610399382)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n. Agr\00E9guelo a su pantalla de inicio para obtener la mejor experiencia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque el icono <strong>Compartir</strong> situado en la barra de navegaci\00F3n inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
unistr('        <p class="a-pwaDialog-stepText">2. Despl\00E1cese hacia abajo y toque <strong>Agregar a pantalla inicial</strong></p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque <strong style="color:#007AE1;">Agregar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111425460209399378)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.SAFARI.IPHONE.15'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n. Agr\00E9guelo a su pantalla de inicio para obtener la mejor experiencia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-15.svg" />',
unistr('        <p class="a-pwaDialog-stepText">1. Toque el icono <strong>M\00E1s</strong> situado junto a la barra de direcciones</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-safari-2.svg" />',
'        <p class="a-pwaDialog-stepText">2. Toque <strong>Agregar a pantalla inicial</strong></p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-check.svg" />',
'        <p class="a-pwaDialog-stepText">3. Toque <strong style="color:#007AE1;">Agregar</strong> para confirmar</p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111430723429399382)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPAD'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n. Agr\00E9guelo a su pantalla de inicio para obtener la mejor experiencia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
'        <p class="a-pwaDialog-stepText">Toque el icono <strong>Compartir</strong> situado junto a la barra de direcciones</p>',
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Toque <strong>Abrir en Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111430663077399382)
,p_name=>'APEX.PWA.INSTRUCTIONS.IOS.WEBVIEW.IPHONE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n. Agr\00E9guelo a su pantalla de inicio para obtener la mejor experiencia.</p>'),
'</div>',
'<div class="a-pwaDialog-steps">',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-1.svg" />',
unistr('        <p class="a-pwaDialog-stepText">Toque el icono <strong>Compartir</strong> situado en la barra de navegaci\00F3n inferior</p>'),
'    </div>',
'    <div class="a-pwaDialog-step">',
'        <img class="a-pwaDialog-stepImage" src="#IMAGE_PREFIX#pwa/apex-pwa-instructions-ios-webview-2.svg" />',
'        <p class="a-pwaDialog-stepText">Toque <strong>Abrir en Safari</strong></p>',
'    </div>',
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111431448143399383)
,p_name=>'APEX.PWA.INSTRUCTIONS.LINUX.FIREFOX'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n, y Chrome ofrece la mejor experiencia.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox no soporta actualmente la instalaci\00F3n de aplicaciones web.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111430967921399382)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.FIREFOX'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n, y Chrome o Edge ofrecen la mejor experiencia.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox no soporta actualmente la instalaci\00F3n de aplicaciones web en macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111431094586399382)
,p_name=>'APEX.PWA.INSTRUCTIONS.MAC_OS.SAFARI'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n, y Chrome o Edge ofrecen la mejor experiencia.</p>'),
unistr('    <p class="a-pwaDialog-intro">Safari no soporta actualmente la instalaci\00F3n de aplicaciones web en macOS.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111431355784399383)
,p_name=>'APEX.PWA.INSTRUCTIONS.WINDOWS.FIREFOX'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-pwaDialog-introWrapper">',
unistr('    <p class="a-pwaDialog-intro">Este sitio web tiene funcionalidad de aplicaci\00F3n, y Chrome o Edge ofrecen la mejor experiencia.</p>'),
unistr('    <p class="a-pwaDialog-intro">Firefox no soporta actualmente la instalaci\00F3n de aplicaciones web en Windows.</p>'),
'</div>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111433824321399385)
,p_name=>'APEX.PWA.OFFLINE.BODY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<main>',
'    <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 400 280" role="presentation">',
'      <g fill="none">',
'        <path d="M316.846 213.183c39.532 0 63.154-30.455 63.154-62.764 0-30.943-22.158-56.615-51.441-62.179v-1.17c0-48.123-38.947-87.07-87.07-87.07-39.044 0-72.036 25.672-83.066 61.007-8.492-3.612-17.863-5.564-27.722-5.564-34.261 0-62.764 24.11-69.69'
||'4 56.322a51.007 51.007 0 0 0-9.468-.879C23.036 110.79 0 133.825 0 162.327c0 28.405 23.036 51.441 51.441 51.441l265.405-.585z" fill="currentColor" opacity=".2"/>',
'        <circle fill="#D63B25" cx="336" cy="216" r="64"/>',
'        <path d="M367.357 198.439c-.395-.395-.947-.632-1.657-.632-.71 0-1.184.237-1.657.632L351.97 210.51l-10.494-10.493 12.072-12.072c.395-.395.71-.947.71-1.657A2.29 2.29 0 0 0 351.97 184c-.631 0-1.183.237-1.657.631l-12.071 12.072-7.496-7.496c-.394-'
||'.394-.947-.71-1.657-.71a2.29 2.29 0 0 0-2.288 2.288c0 .632.237 1.184.71 1.657l2.604 2.604-13.176 13.176a13.781 13.781 0 0 0-4.024 9.705c0 3.787 1.499 7.18 4.024 9.705l2.13 2.13-14.36 14.36c-.394.394-.71.947-.71 1.657a2.29 2.29 0 0 0 2.288 2.288c.631 '
||'0 1.184-.237 1.657-.71l14.36-14.36 1.736 1.736a13.781 13.781 0 0 0 9.704 4.024c3.787 0 7.18-1.5 9.705-4.024l13.176-13.177 2.92 2.92c.394.394.946.71 1.656.71a2.29 2.29 0 0 0 2.289-2.288c0-.632-.237-1.184-.71-1.657l-7.575-7.496 12.072-12.071c.394-.395.'
||'71-.947.71-1.657.079-.632-.237-1.184-.631-1.578zm-27.142 33.059a9.398 9.398 0 0 1-6.47 2.603c-2.525 0-4.813-.946-6.47-2.603l-7.1-7.101a9.124 9.124 0 0 1-2.683-6.47 9.124 9.124 0 0 1 2.682-6.47l13.177-13.176 3.156 3.156c.079.079.079.158.158.158l.157.1'
||'57 13.413 13.413c.08.08.08.158.158.158l.158.158 2.761 2.762-13.097 13.255z" fill="#FFF"/>',
'      </g>',
'    </svg>',
'    <h1>No se puede conectar</h1>',
unistr('    <p>Necesita una conexi\00F3n a Internet para utilizar esta aplicaci\00F3n.</p>'),
'    <button type="button">Reintentar</button>',
'</main>',
'',
'<script>',
'    document.querySelector("button").addEventListener("click", () => {',
'        window.location.reload();',
'    });',
'</script>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111433742186399384)
,p_name=>'APEX.PWA.OFFLINE.TITLE'
,p_message_language=>'es'
,p_message_text=>'No se puede conectar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111573530801399489)
,p_name=>'APEX.REGION.CSSCALENDAR.ADD'
,p_message_language=>'es'
,p_message_text=>'Agregar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111517977174399447)
,p_name=>'APEX.REGION.CSSCALENDAR.ALL_DAY'
,p_message_language=>'es'
,p_message_text=>unistr('Todo el D\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111596829301399506)
,p_name=>'APEX.REGION.CSSCALENDAR.BUTTON.SENDEMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar Invitaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111596655080399506)
,p_name=>'APEX.REGION.CSSCALENDAR.CHOOSE_ACTION'
,p_message_language=>'es'
,p_message_text=>'Opciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111519726049399449)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_ALLDAY'
,p_message_language=>'es'
,p_message_text=>unistr('Vista diaria de todos los d\00EDas ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111519558277399449)
,p_name=>'APEX.REGION.CSSCALENDAR.DAILY_TIME_SPECIFIC'
,p_message_language=>'es'
,p_message_text=>'Vista diaria de los datos con hora '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111564408059399482)
,p_name=>'APEX.REGION.CSSCALENDAR.DAY'
,p_message_language=>'es'
,p_message_text=>unistr('D\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111558806814399478)
,p_name=>'APEX.REGION.CSSCALENDAR.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111449450918399396)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.CSV'
,p_message_language=>'es'
,p_message_text=>'CSV'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111449263647399396)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.ICALENDAR'
,p_message_language=>'es'
,p_message_text=>'iCal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111449199338399396)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.PDF'
,p_message_language=>'es'
,p_message_text=>'PDF'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111449316403399396)
,p_name=>'APEX.REGION.CSSCALENDAR.DOWNLOAD.XML'
,p_message_language=>'es'
,p_message_text=>'XML'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111448812938399396)
,p_name=>'APEX.REGION.CSSCALENDAR.ENDDATE'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de finalizaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111449073493399396)
,p_name=>'APEX.REGION.CSSCALENDAR.EVENTNAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de evento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111596776511399506)
,p_name=>'APEX.REGION.CSSCALENDAR.INVITATION'
,p_message_language=>'es'
,p_message_text=>unistr('Invitaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111564588542399482)
,p_name=>'APEX.REGION.CSSCALENDAR.LIST'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111564292442399482)
,p_name=>'APEX.REGION.CSSCALENDAR.MONTH'
,p_message_language=>'es'
,p_message_text=>'Mes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111567080280399484)
,p_name=>'APEX.REGION.CSSCALENDAR.NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111581367859399495)
,p_name=>'APEX.REGION.CSSCALENDAR.NOEVENTS'
,p_message_language=>'es'
,p_message_text=>'Sin Eventos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111597086782399506)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.FORM'
,p_message_language=>'es'
,p_message_text=>'Editar Evento Existente.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111596974343399506)
,p_name=>'APEX.REGION.CSSCALENDAR.OPTION.SEND'
,p_message_language=>'es'
,p_message_text=>unistr('Enviando invitaci\00F3n a trav\00E9s de correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111567181190399484)
,p_name=>'APEX.REGION.CSSCALENDAR.PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111575119379399490)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111574955299399490)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.BUTTON'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar correo electr\00F3nico')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111597700007399507)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Todos los campos son necesarios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111597616274399507)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.DIALOG.TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar Invitaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111596522576399506)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.SUBJECT'
,p_message_language=>'es'
,p_message_text=>'Asunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111575054086399490)
,p_name=>'APEX.REGION.CSSCALENDAR.SENDEMAIL.TO'
,p_message_language=>'es'
,p_message_text=>'Para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111448923980399396)
,p_name=>'APEX.REGION.CSSCALENDAR.STARTDATE'
,p_message_language=>'es'
,p_message_text=>'Fecha de inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111572843099399488)
,p_name=>'APEX.REGION.CSSCALENDAR.TABLEFORM'
,p_message_language=>'es'
,p_message_text=>'Pantalla Basada en %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111519331634399448)
,p_name=>'APEX.REGION.CSSCALENDAR.TIME'
,p_message_language=>'es'
,p_message_text=>unistr('Per\00EDodo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111567239896399484)
,p_name=>'APEX.REGION.CSSCALENDAR.TODAY'
,p_message_language=>'es'
,p_message_text=>'Hoy'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111565045573399483)
,p_name=>'APEX.REGION.CSSCALENDAR.VIEW'
,p_message_language=>'es'
,p_message_text=>'Ver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111564378641399482)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEK'
,p_message_language=>'es'
,p_message_text=>'Semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111519630854399449)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_ALLDAY'
,p_message_language=>'es'
,p_message_text=>unistr('Vista semanal de todos los d\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111519402359399448)
,p_name=>'APEX.REGION.CSSCALENDAR.WEEKLY_TIME_SPECIFIC'
,p_message_language=>'es'
,p_message_text=>'Vista semanal de los datos con hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111564973492399482)
,p_name=>'APEX.REGION.CSSCALENDAR.YEAR'
,p_message_language=>'es'
,p_message_text=>unistr('A\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111564632068399482)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111564745620399482)
,p_name=>'APEX.REGION.JQM_COLUMN_TOGGLE.LOAD_MORE'
,p_message_language=>'es'
,p_message_text=>unistr('Cargar M\00E1s...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111496834541399432)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.BACK'
,p_message_language=>'es'
,p_message_text=>unistr('Atr\00E1s')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111443108483399391)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.LOAD_MORE'
,p_message_language=>'es'
,p_message_text=>unistr('Cargar M\00E1s...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111445289435399393)
,p_name=>'APEX.REGION.JQM_LIST_VIEW.SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111564819881399482)
,p_name=>'APEX.REGION.JQM_REFLOW.LOAD_MORE'
,p_message_language=>'es'
,p_message_text=>unistr('Cargar M\00E1s...')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111566967263399484)
,p_name=>'APEX.REGION.NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado el ID de regi\00F3n %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111445188151399393)
,p_name=>'APEX.REGION.NO_DATA_FOUND_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn dato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111469221148399411)
,p_name=>'APEX.REGION.PAGINATION.RESET_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido restablecer la paginaci\00F3n de regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111437413042399387)
,p_name=>'APEX.REGION.PAGINATION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al definir la paginaci\00F3n de la regi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111558246675399477)
,p_name=>'APEX.REGION.RESPONSIVE_TABLE.COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111566834839399484)
,p_name=>'APEX.REGION.TYPE_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('El tipo de regi\00F3n {0} no est\00E1 soportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111437343133399387)
,p_name=>'APEX.REGION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error en la presentaci\00F3n de la regi\00F3n "#COMPONENT_NAME#".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111501872966399436)
,p_name=>'APEX.REGION_COLUMN_IS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('#COLUMN_HEADER# debe tener alg\00FAn valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111596175558399506)
,p_name=>'APEX.RICH_TEXT_EDITOR.ACCESSIBLE_LABEL'
,p_message_language=>'es'
,p_message_text=>'%0, editor de texto enriquecido'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111503962660399437)
,p_name=>'APEX.RICH_TEXT_EDITOR.MAXIMUM_LENGTH_EXCEEDED'
,p_message_language=>'es'
,p_message_text=>unistr('El marcador HTML de texto enriquecido supera la longitud m\00E1xima del elemento (real: %0, permitida: %1 caracteres)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111563859645399482)
,p_name=>'APEX.RV.DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111555652425399476)
,p_name=>'APEX.RV.DUPLICATE'
,p_message_language=>'es'
,p_message_text=>'Duplicar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111553911874399474)
,p_name=>'APEX.RV.EXCLUDE_HIDDEN'
,p_message_language=>'es'
,p_message_text=>'Columnas Mostradas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111553878140399474)
,p_name=>'APEX.RV.EXCLUDE_NULL'
,p_message_language=>'es'
,p_message_text=>'Excluir Valores Nulos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111563961817399482)
,p_name=>'APEX.RV.INSERT'
,p_message_language=>'es'
,p_message_text=>'Agregar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111517559939399447)
,p_name=>'APEX.RV.MOVE_DOWN'
,p_message_language=>'es'
,p_message_text=>'Mover abajo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111517664512399447)
,p_name=>'APEX.RV.MOVE_UP'
,p_message_language=>'es'
,p_message_text=>'Mover arriba'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111553615592399474)
,p_name=>'APEX.RV.NEXT_RECORD'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111554235709399475)
,p_name=>'APEX.RV.NOT_GROUPED_LABEL'
,p_message_language=>'es'
,p_message_text=>'Otras Columnas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111553713715399474)
,p_name=>'APEX.RV.PREV_RECORD'
,p_message_language=>'es'
,p_message_text=>'Anterior'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111554007536399474)
,p_name=>'APEX.RV.REC_X'
,p_message_language=>'es'
,p_message_text=>'Fila %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111554141620399474)
,p_name=>'APEX.RV.REC_XY'
,p_message_language=>'es'
,p_message_text=>'Fila %0 de %1'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111555775706399476)
,p_name=>'APEX.RV.REFRESH'
,p_message_language=>'es'
,p_message_text=>'Refrescar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111555805757399476)
,p_name=>'APEX.RV.REVERT'
,p_message_language=>'es'
,p_message_text=>'Revertir Cambios'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111553533011399474)
,p_name=>'APEX.RV.SETTINGS_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA Configuraci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111514549674399445)
,p_name=>'APEX.SAMPLE_FORMAT'
,p_message_language=>'es'
,p_message_text=>'Por ejemplo, %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111422061019399376)
,p_name=>'APEX.SESSION.ALERT.CREATE_NEW'
,p_message_language=>'es'
,p_message_text=>'Volver a conectarse'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111421978675399376)
,p_name=>'APEX.SESSION.ALERT.EXPIRED'
,p_message_language=>'es'
,p_message_text=>unistr('La sesi\00F3n ha finalizado')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111422123932399376)
,p_name=>'APEX.SESSION.ALERT.EXTEND'
,p_message_language=>'es'
,p_message_text=>'Ampliar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111421739299399376)
,p_name=>'APEX.SESSION.ALERT.IDLE_WARN'
,p_message_language=>'es'
,p_message_text=>unistr('La sesi\00F3n finalizar\00E1 a las %0. \00BFDesea ampliarla?')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111421892572399376)
,p_name=>'APEX.SESSION.ALERT.MAX_WARN'
,p_message_language=>'es'
,p_message_text=>unistr('La sesi\00F3n finalizar\00E1 a las %0 y no se puede ampliar. Guarde los trabajos ahora para evitar que se pierdan los datos')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111574741705399490)
,p_name=>'APEX.SESSION.DB_SESSION_CLEANUP.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar el c\00F3digo de limpieza de la sesi\00F3n de base de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111467889851399410)
,p_name=>'APEX.SESSION.DB_SESSION_INIT.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al procesar el c\00F3digo de configuraci\00F3n de la sesi\00F3n de base de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111441928854399391)
,p_name=>'APEX.SESSION.EXPIRED'
,p_message_language=>'es'
,p_message_text=>unistr('La sesi\00F3n ha finalizado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111573625055399489)
,p_name=>'APEX.SESSION.EXPIRED.CLOSE_DIALOG'
,p_message_language=>'es'
,p_message_text=>unistr('Cierre este cuadro de di\00E1logo y pulse el bot\00F3n de recarga del explorador para obtener una nueva sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111592912290399503)
,p_name=>'APEX.SESSION.EXPIRED.NEW_SESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Haga clic <a href="%0">aqu\00ED</a> para crear una nueva sesi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111479530236399418)
,p_name=>'APEX.SESSION.NOT_VALID'
,p_message_language=>'es'
,p_message_text=>unistr('Sesi\00F3n no V\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111519077407399448)
,p_name=>'APEX.SESSION.RAS.NO_DYNAMIC_ROLES'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido activar ning\00FAn rol din\00E1mico en la sesi\00F3n de Real Application Security para el usuario "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111465798688399408)
,p_name=>'APEX.SESSION.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-99900: No se ha podido crear un identificador de sesi\00F3n \00FAnico: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111482043493399420)
,p_name=>'APEX.SESSION_STATE.ITEM_VALUE_PROTECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Violaci\00F3n de la protecci\00F3n del estado de la sesi\00F3n: puede ser debida a una modificaci\00F3n manual del elemento de p\00E1gina protegido %0. En caso de duda sobre el motivo de este error, p\00F3ngase en contacto con el administrador de la aplicaci\00F3n para recibir ')
||'ayuda.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111601179763399510)
,p_name=>'APEX.SESSION_STATE.PAGE_PROTECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Violaci\00F3n de la protecci\00F3n de la p\00E1gina: puede ser debida al env\00EDo de una p\00E1gina que a\00FAn no se hab\00EDa terminado de cargar o a una modificaci\00F3n manual de los elementos de p\00E1gina protegidos. Para obtener ayuda, p\00F3ngase en contacto con el administrador d')
||unistr('e la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111600157982399509)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR'
,p_message_language=>'es'
,p_message_text=>unistr('%0 contiene uno de los siguientes caracteres no v\00E1lidos &<>"/;,*|=% o --')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111600215125399509)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.NO_SPECIAL_CHAR_NL'
,p_message_language=>'es'
,p_message_text=>unistr('%0 contiene uno de los siguientes caracteres no v\00E1lidos &<>"/;,*|=% o -- o una nueva l\00EDnea.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111599924026399509)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.US_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('%0 contiene caracteres especiales. S\00F3lo est\00E1n permitidos los caracteres a-Z, 0-9 y espacios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111600090030399509)
,p_name=>'APEX.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 contiene <, > o " que son caracteres no v\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111444106197399392)
,p_name=>'APEX.SESSION_STATE.SSP_CHECKSUM_MISSING'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha proporcionado ning\00FAn total de control para el procesamiento de presentaci\00F3n de una p\00E1gina que requiere un total de control cuando se transfieren como par\00E1metros uno o m\00E1s valores de argumento, limpieza de cach\00E9 o solicitud.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111476969980399416)
,p_name=>'APEX.SESSION_STATE.SSP_VIOLATION'
,p_message_language=>'es'
,p_message_text=>unistr('Violaci\00F3n de la protecci\00F3n del estado de la sesi\00F3n: Puede ser debida a una modificaci\00F3n manual de una direcci\00F3n URL que contenga un total de control, que se haya utilizado un enlace con un total de control incorrecto o que no tenga ning\00FAn total de co')
||unistr('ntrol. En caso de duda sobre el motivo de este error, p\00F3ngase en contacto con el administrador de la aplicaci\00F3n para recibir ayuda.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111554937926399475)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_OFF'
,p_message_language=>'es'
,p_message_text=>'Desactivar Modo de Alto Contraste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111555000185399475)
,p_name=>'APEX.SET_HIGH_CONTRAST_MODE_ON'
,p_message_language=>'es'
,p_message_text=>'Activar Modo de Alto Contraste'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111473628886399414)
,p_name=>'APEX.SHUTTLE.CONTROL_BOTTOM'
,p_message_language=>'es'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111473895558399414)
,p_name=>'APEX.SHUTTLE.CONTROL_DOWN'
,p_message_language=>'es'
,p_message_text=>'Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111473946753399414)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE'
,p_message_language=>'es'
,p_message_text=>'Mover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111474057593399414)
,p_name=>'APEX.SHUTTLE.CONTROL_MOVE_ALL'
,p_message_language=>'es'
,p_message_text=>'Mover Todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111474188264399414)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE'
,p_message_language=>'es'
,p_message_text=>'Eliminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111474232634399414)
,p_name=>'APEX.SHUTTLE.CONTROL_REMOVE_ALL'
,p_message_language=>'es'
,p_message_text=>'Eliminar todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111474359659399415)
,p_name=>'APEX.SHUTTLE.CONTROL_RESET'
,p_message_language=>'es'
,p_message_text=>'Restablecer'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111473502918399414)
,p_name=>'APEX.SHUTTLE.CONTROL_TOP'
,p_message_language=>'es'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111473759576399414)
,p_name=>'APEX.SHUTTLE.CONTROL_UP'
,p_message_language=>'es'
,p_message_text=>'Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111582653066399496)
,p_name=>'APEX.SINCE.SHORT.DAYS_AGO'
,p_message_language=>'es'
,p_message_text=>'%0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111583306657399496)
,p_name=>'APEX.SINCE.SHORT.DAYS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'en %0d'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111582527240399496)
,p_name=>'APEX.SINCE.SHORT.HOURS_AGO'
,p_message_language=>'es'
,p_message_text=>'%0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111583466115399496)
,p_name=>'APEX.SINCE.SHORT.HOURS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'en %0h'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111582350950399495)
,p_name=>'APEX.SINCE.SHORT.MINUTES_AGO'
,p_message_language=>'es'
,p_message_text=>'%0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111583533466399496)
,p_name=>'APEX.SINCE.SHORT.MINUTES_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'en %0m'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111582981786399496)
,p_name=>'APEX.SINCE.SHORT.MONTHS_AGO'
,p_message_language=>'es'
,p_message_text=>'%0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111583177468399496)
,p_name=>'APEX.SINCE.SHORT.MONTHS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'en %0mo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111582474578399496)
,p_name=>'APEX.SINCE.SHORT.SECONDS_AGO'
,p_message_language=>'es'
,p_message_text=>'%0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111583221418399496)
,p_name=>'APEX.SINCE.SHORT.SECONDS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'en %0s'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111582742109399496)
,p_name=>'APEX.SINCE.SHORT.WEEKS_AGO'
,p_message_language=>'es'
,p_message_text=>'%0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111583696452399496)
,p_name=>'APEX.SINCE.SHORT.WEEKS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'en %0w'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111582881124399496)
,p_name=>'APEX.SINCE.SHORT.YEARS_AGO'
,p_message_language=>'es'
,p_message_text=>'%0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111583009826399496)
,p_name=>'APEX.SINCE.SHORT.YEARS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'en %0y'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111422927992399377)
,p_name=>'APEX.SPATIAL.GEOMETRY.LINE'
,p_message_language=>'es'
,p_message_text=>unistr('[L\00EDnea]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111423310313399377)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTILINE'
,p_message_language=>'es'
,p_message_text=>unistr('[Varias l\00EDneas]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111423108082399377)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOINT'
,p_message_language=>'es'
,p_message_text=>'[Varios puntos]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111423575995399377)
,p_name=>'APEX.SPATIAL.GEOMETRY.MULTIPOLYGON'
,p_message_language=>'es'
,p_message_text=>unistr('[Varios pol\00EDgonos]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111423654486399377)
,p_name=>'APEX.SPATIAL.GEOMETRY.OTHER'
,p_message_language=>'es'
,p_message_text=>unistr('[Objeto de geometr\00EDa]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111422825771399376)
,p_name=>'APEX.SPATIAL.GEOMETRY.POINT'
,p_message_language=>'es'
,p_message_text=>'[Punto (%0,%1)]'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111423048660399377)
,p_name=>'APEX.SPATIAL.GEOMETRY.POLYGON'
,p_message_language=>'es'
,p_message_text=>unistr('[Pol\00EDgono]')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111500235326399434)
,p_name=>'APEX.SPLITTER.COLLAPSE_TEXT'
,p_message_language=>'es'
,p_message_text=>'Reducir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111500168718399434)
,p_name=>'APEX.SPLITTER.RESTORE_TEXT'
,p_message_language=>'es'
,p_message_text=>'Restaurar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111546646161399469)
,p_name=>'APEX.STAR_RATING.CLEAR_RATING'
,p_message_language=>'es'
,p_message_text=>unistr('Borrar calificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111536561473399461)
,p_name=>'APEX.STAR_RATING.INVALID_RATING_RANGE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no est\00E1 en el rango v\00E1lido de de calificaci\00F3n de 1 - %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111536672571399461)
,p_name=>'APEX.STAR_RATING.IS_NOT_NUMERIC'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no es num\00E9rico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111532703319399458)
,p_name=>'APEX.SUCCESS_MESSAGE_HEADING'
,p_message_language=>'es'
,p_message_text=>'Mensaje Correcto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111595879267399506)
,p_name=>'APEX.TABS.NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111595757276399506)
,p_name=>'APEX.TABS.PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Anterior'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111581487877399495)
,p_name=>'APEX.TB.TOOLBAR'
,p_message_language=>'es'
,p_message_text=>'Barra de herramientas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111596239872399506)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_NAV_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Ampliar / contraer navegaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111596369798399506)
,p_name=>'APEX.TEMPLATE.EXPAND_COLLAPSE_SIDE_COL_LABEL'
,p_message_language=>'es'
,p_message_text=>'Ampliar / contraer columna lateral'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111505925449399439)
,p_name=>'APEX.TEMPLATE.MAIN_NAV_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Navegaci\00F3n principal')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111512956592399444)
,p_name=>'APEX.TIME.DAY'
,p_message_language=>'es'
,p_message_text=>unistr('1 d\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111512725850399444)
,p_name=>'APEX.TIME.HOUR'
,p_message_language=>'es'
,p_message_text=>'1 hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111513018866399444)
,p_name=>'APEX.TIME.N_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 d\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111512877729399444)
,p_name=>'APEX.TIME.N_HOURS'
,p_message_language=>'es'
,p_message_text=>'%0 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111512699120399443)
,p_name=>'APEX.TIME.N_MINUTES'
,p_message_language=>'es'
,p_message_text=>'%0 minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111513208966399444)
,p_name=>'APEX.TIME.N_WEEKS'
,p_message_language=>'es'
,p_message_text=>'%0 semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111513100637399444)
,p_name=>'APEX.TIME.WEEK'
,p_message_language=>'es'
,p_message_text=>'1 semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111599448500399508)
,p_name=>'APEX.UI.BACK_TO_TOP'
,p_message_language=>'es'
,p_message_text=>unistr('Inicio de la p\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111461452251399405)
,p_name=>'APEX.UI.ENABLED'
,p_message_language=>'es'
,p_message_text=>'Activado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111435211620399386)
,p_name=>'APEX.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error al procesar la solicitud.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111514692372399445)
,p_name=>'APEX.VALUE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Valor Necesario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111597508284399507)
,p_name=>'APEX.WAIT_UNTIL_PAGE_LOADED'
,p_message_language=>'es'
,p_message_text=>unistr('Espere hasta que la p\00E1gina se haya cargado completamente y vuelva a intentarlo.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111557731036399477)
,p_name=>'APEX.WARN_ON_UNSAVED_CHANGES'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina tiene cambios no guardados.')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111438616431399388)
,p_name=>'APEX.XLSX.ERROR.NO_ACTIVE_WORKSHEET'
,p_message_language=>'es'
,p_message_text=>'El libro de trabajo no tiene ninguna hoja de trabajo activa.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111438511986399388)
,p_name=>'APEX.XLSX.ERROR.WORKBOOK_NOT_INITIALIZED'
,p_message_language=>'es'
,p_message_text=>'No se ha inicializado el libro de trabajo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111438479831399388)
,p_name=>'APEX.XLSX.INTERNAL_ERROR'
,p_message_language=>'es'
,p_message_text=>'Se ha producido un error interno al crear el archivo XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111440966870399390)
,p_name=>'APEX.XLSX.SHEET'
,p_message_language=>'es'
,p_message_text=>'Hoja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111572670183399488)
,p_name=>'APEXIR_ACTIONS'
,p_message_language=>'es'
,p_message_text=>'Acciones'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111490175536399427)
,p_name=>'APEXIR_ACTIONS_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Acciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111485893147399424)
,p_name=>'APEXIR_ADD_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111485716126399424)
,p_name=>'APEXIR_ADD_GROUP_BY_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Agregar Grupo por Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111519958960399449)
,p_name=>'APEXIR_ADD_PIVOT_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Agregar Columna Din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111520039914399449)
,p_name=>'APEXIR_ADD_ROW_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Agregar Columna de Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111460244826399404)
,p_name=>'APEXIR_AGGREGATE'
,p_message_language=>'es'
,p_message_text=>'Agregado'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111496354240399431)
,p_name=>'APEXIR_AGGREGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Agregaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111477485877399417)
,p_name=>'APEXIR_AGG_AVG'
,p_message_language=>'es'
,p_message_text=>'Media'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111481739525399420)
,p_name=>'APEXIR_AGG_COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111477549417399417)
,p_name=>'APEXIR_AGG_MAX'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111477745488399417)
,p_name=>'APEXIR_AGG_MEDIAN'
,p_message_language=>'es'
,p_message_text=>'Mediana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111477624773399417)
,p_name=>'APEXIR_AGG_MIN'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111477338730399417)
,p_name=>'APEXIR_AGG_SUM'
,p_message_language=>'es'
,p_message_text=>'Suma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111478445964399418)
,p_name=>'APEXIR_ALL'
,p_message_language=>'es'
,p_message_text=>'Todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111459531343399404)
,p_name=>'APEXIR_ALL_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Todas las Columnas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111442018474399391)
,p_name=>'APEXIR_ALL_ROWS'
,p_message_language=>'es'
,p_message_text=>'Todas las Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111569691534399486)
,p_name=>'APEXIR_ALTERNATIVE'
,p_message_language=>'es'
,p_message_text=>'Alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111571233673399487)
,p_name=>'APEXIR_ALTERNATIVE_DEFAULT_NAME'
,p_message_language=>'es'
,p_message_text=>'Valor por defecto alternativo: %0 '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111472114016399413)
,p_name=>'APEXIR_AND'
,p_message_language=>'es'
,p_message_text=>'y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111461630697399405)
,p_name=>'APEXIR_APPLY'
,p_message_language=>'es'
,p_message_text=>'Aplicar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111455351781399401)
,p_name=>'APEXIR_ASCENDING'
,p_message_language=>'es'
,p_message_text=>'Ascendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111474987944399415)
,p_name=>'APEXIR_AS_OF'
,p_message_language=>'es'
,p_message_text=>'Hace %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111571890627399488)
,p_name=>'APEXIR_AVERAGE_X'
,p_message_language=>'es'
,p_message_text=>'Media %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111563232663399481)
,p_name=>'APEXIR_BAR'
,p_message_language=>'es'
,p_message_text=>'Barra'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111461095966399405)
,p_name=>'APEXIR_BETWEEN'
,p_message_language=>'es'
,p_message_text=>'entre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111454133863399400)
,p_name=>'APEXIR_BGCOLOR'
,p_message_language=>'es'
,p_message_text=>'Color de Fondo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111456069208399401)
,p_name=>'APEXIR_BLUE'
,p_message_language=>'es'
,p_message_text=>'azul'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111487744270399425)
,p_name=>'APEXIR_BOTTOM'
,p_message_language=>'es'
,p_message_text=>'Inferior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111456642624399402)
,p_name=>'APEXIR_CANCEL'
,p_message_language=>'es'
,p_message_text=>'Cancelar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111462501021399406)
,p_name=>'APEXIR_CATEGORY'
,p_message_language=>'es'
,p_message_text=>unistr('Categor\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111454090570399400)
,p_name=>'APEXIR_CELL'
,p_message_language=>'es'
,p_message_text=>'Celda'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111478346933399417)
,p_name=>'APEXIR_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111488684753399426)
,p_name=>'APEXIR_CHART_INITIALIZING'
,p_message_language=>'es'
,p_message_text=>'Inicializando...'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111524922101399453)
,p_name=>'APEXIR_CHART_LABEL_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar la etiqueta de gr\00E1fico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111537321234399462)
,p_name=>'APEXIR_CHART_MAX_DATAPOINT_CNT'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta supera el m\00E1ximo de %0 puntos de datos por gr\00E1fico. Aplique un filtro para reducir el n\00FAmero de registros de la consulta base.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111536208474399461)
,p_name=>'APEXIR_CHART_MAX_ROW_CNT'
,p_message_language=>'es'
,p_message_text=>unistr('El recuento m\00E1ximo de filas para una consulta de Gr\00E1fico limita el n\00FAmero de filas de la consulta base, no el n\00FAmero de filas que se muestran. La consulta base supera el recuento m\00E1ximo de filas de %0. Aplique un filtro para reducir el n\00FAmero de regi')
||'stros en la consulta base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111459638946399404)
,p_name=>'APEXIR_CHART_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111532940625399459)
,p_name=>'APEXIR_CHECK_ALL'
,p_message_language=>'es'
,p_message_text=>'Activar todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111475347115399415)
,p_name=>'APEXIR_CHOOSE_DOWNLOAD_FORMAT'
,p_message_language=>'es'
,p_message_text=>'Seleccionar formato de informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111482782942399421)
,p_name=>'APEXIR_CLEAR'
,p_message_language=>'es'
,p_message_text=>'borrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111456505172399402)
,p_name=>'APEXIR_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111493940227399430)
,p_name=>'APEXIR_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111566289560399483)
,p_name=>'APEXIR_COLUMN_FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtrar...'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111484783611399423)
,p_name=>'APEXIR_COLUMN_HEADING_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('Men\00FA de Cabecera de Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111488441948399426)
,p_name=>'APEXIR_COLUMN_INFO'
,p_message_language=>'es'
,p_message_text=>unistr('Informaci\00F3n de la Columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111568575274399485)
,p_name=>'APEXIR_COLUMN_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta de Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111486183126399424)
,p_name=>'APEXIR_COLUMN_N'
,p_message_language=>'es'
,p_message_text=>'Columna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111470249961399412)
,p_name=>'APEXIR_COMPARISON_CONTAINS'
,p_message_language=>'es'
,p_message_text=>'contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111471155795399412)
,p_name=>'APEXIR_COMPARISON_DOESNOT_CONTAIN'
,p_message_language=>'es'
,p_message_text=>'no contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111455011174399400)
,p_name=>'APEXIR_COMPARISON_IN'
,p_message_language=>'es'
,p_message_text=>'en'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111471326893399412)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_LAST'
,p_message_language=>'es'
,p_message_text=>unistr('no en \00FAltimos(as)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111479817347399419)
,p_name=>'APEXIR_COMPARISON_ISNOT_IN_NEXT'
,p_message_language=>'es'
,p_message_text=>'no en siguientes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111471291026399412)
,p_name=>'APEXIR_COMPARISON_IS_IN_LAST'
,p_message_language=>'es'
,p_message_text=>unistr('en \00FAltimos(as)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111479765360399418)
,p_name=>'APEXIR_COMPARISON_IS_IN_NEXT'
,p_message_language=>'es'
,p_message_text=>'en siguientes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111454958902399400)
,p_name=>'APEXIR_COMPARISON_IS_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'no es nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111454814591399400)
,p_name=>'APEXIR_COMPARISON_IS_NULL'
,p_message_language=>'es'
,p_message_text=>'es nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111454603614399400)
,p_name=>'APEXIR_COMPARISON_LIKE'
,p_message_language=>'es'
,p_message_text=>'igual que'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111455188531399400)
,p_name=>'APEXIR_COMPARISON_NOT_IN'
,p_message_language=>'es'
,p_message_text=>'no en'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111454719574399400)
,p_name=>'APEXIR_COMPARISON_NOT_LIKE'
,p_message_language=>'es'
,p_message_text=>'no igual que'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111470537413399412)
,p_name=>'APEXIR_COMPARISON_REGEXP_LIKE'
,p_message_language=>'es'
,p_message_text=>unistr('coincide con expresi\00F3n regular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111475298421399415)
,p_name=>'APEXIR_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('C\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111535936626399461)
,p_name=>'APEXIR_COMPUTATION_EXPRESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n de c\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111494221014399430)
,p_name=>'APEXIR_COMPUTATION_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('Cree un c\00E1lculo utilizando los alias de columna.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111494339582399430)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E1'
,p_message_language=>'es'
,p_message_text=>'(B+C)*100'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111494455608399430)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E2'
,p_message_language=>'es'
,p_message_text=>'INITCAP(B)||'', ''||INITCAP(C)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111494554509399430)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E3'
,p_message_language=>'es'
,p_message_text=>'CASE WHEN A = 10 THEN B + C ELSE B END'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111440459159399389)
,p_name=>'APEXIR_COMPUTATION_FOOTER_E4'
,p_message_language=>'es'
,p_message_text=>'ROUND(C / 1000000)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111479114759399418)
,p_name=>'APEXIR_COMPUTE'
,p_message_language=>'es'
,p_message_text=>'Calcular'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111486755218399424)
,p_name=>'APEXIR_CONTROL_BREAK'
,p_message_language=>'es'
,p_message_text=>unistr('Divisi\00F3n de Control')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111489790743399427)
,p_name=>'APEXIR_CONTROL_BREAKS'
,p_message_language=>'es'
,p_message_text=>'Divisiones de Control'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111574171471399489)
,p_name=>'APEXIR_CONTROL_BREAK_COLUMNS'
,p_message_language=>'es'
,p_message_text=>unistr('Columnas de Divisi\00F3n de Control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111437552953399387)
,p_name=>'APEXIR_COUNT_DISTINCT'
,p_message_language=>'es'
,p_message_text=>'Recuento de los Valores Distintos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111572313975399488)
,p_name=>'APEXIR_COUNT_DISTINCT_X'
,p_message_language=>'es'
,p_message_text=>'Recuento de los Valores Distintos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111572276062399488)
,p_name=>'APEXIR_COUNT_X'
,p_message_language=>'es'
,p_message_text=>'Recuento %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111544360681399467)
,p_name=>'APEXIR_DAILY'
,p_message_language=>'es'
,p_message_text=>'Diariamente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111599049979399508)
,p_name=>'APEXIR_DATA'
,p_message_language=>'es'
,p_message_text=>'Datos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111488553557399426)
,p_name=>'APEXIR_DATA_AS_OF'
,p_message_language=>'es'
,p_message_text=>'Informar de datos de hace %0 minutos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111562093297399480)
,p_name=>'APEXIR_DATA_GRID_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('Ayuda de Cuadr\00EDcula de Datos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111460310924399404)
,p_name=>'APEXIR_DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111492407438399429)
,p_name=>'APEXIR_DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Por defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111569484397399486)
,p_name=>'APEXIR_DEFAULT_REPORT_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de Informe por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111456730479399402)
,p_name=>'APEXIR_DELETE'
,p_message_language=>'es'
,p_message_text=>'Suprimir'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111460623386399405)
,p_name=>'APEXIR_DELETE_CONFIRM'
,p_message_language=>'es'
,p_message_text=>unistr('\00BFDesea suprimir estos valores del informe?')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111555340351399475)
,p_name=>'APEXIR_DELETE_DEFAULT_REPORT'
,p_message_language=>'es'
,p_message_text=>'Suprimir Informe por Defecto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111486494992399424)
,p_name=>'APEXIR_DELETE_REPORT'
,p_message_language=>'es'
,p_message_text=>'Suprimir Informe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111455411971399401)
,p_name=>'APEXIR_DESCENDING'
,p_message_language=>'es'
,p_message_text=>'Descendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111462600652399406)
,p_name=>'APEXIR_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111484689043399422)
,p_name=>'APEXIR_DETAIL_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Una Sola Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111492980827399429)
,p_name=>'APEXIR_DIRECTION'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111493884332399430)
,p_name=>'APEXIR_DISABLED'
,p_message_language=>'es'
,p_message_text=>'Desactivado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111456263770399401)
,p_name=>'APEXIR_DISPLAYED'
,p_message_language=>'es'
,p_message_text=>'Mostrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111459476172399404)
,p_name=>'APEXIR_DISPLAYED_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas Mostradas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111492830809399429)
,p_name=>'APEXIR_DISPLAY_IN_REPORT'
,p_message_language=>'es'
,p_message_text=>'Mostrar en Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111487614299399425)
,p_name=>'APEXIR_DOWN'
,p_message_language=>'es'
,p_message_text=>'Abajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111479277813399418)
,p_name=>'APEXIR_DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>'Descargar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111492739276399429)
,p_name=>'APEXIR_DO_NOT_DISPLAY'
,p_message_language=>'es'
,p_message_text=>'No Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111558723758399478)
,p_name=>'APEXIR_DUPLICATE_HIGHLIGHT_COND'
,p_message_language=>'es'
,p_message_text=>unistr('Ya existe un resaltado con la misma condici\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111574303686399489)
,p_name=>'APEXIR_DUPLICATE_PIVOT_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna din\00E1mica duplicada. La lista de columna din\00E1mica debe ser \00FAnica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111574588034399490)
,p_name=>'APEXIR_EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111488746085399426)
,p_name=>'APEXIR_EDIT_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Valores de Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111495343811399431)
,p_name=>'APEXIR_EDIT_CHART2'
,p_message_language=>'es'
,p_message_text=>unistr('Editar Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111495737084399431)
,p_name=>'APEXIR_EDIT_FILTER'
,p_message_language=>'es'
,p_message_text=>'Editar filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111550174888399471)
,p_name=>'APEXIR_EDIT_GROUP_BY'
,p_message_language=>'es'
,p_message_text=>'Editar Grupo por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111495680904399431)
,p_name=>'APEXIR_EDIT_HIGHLIGHT'
,p_message_language=>'es'
,p_message_text=>'Editar resaltado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111520286688399449)
,p_name=>'APEXIR_EDIT_PIVOT'
,p_message_language=>'es'
,p_message_text=>unistr('Editar din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111569756289399486)
,p_name=>'APEXIR_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111448475317399395)
,p_name=>'APEXIR_EMAIL_ADDRESS'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n de correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111570037497399486)
,p_name=>'APEXIR_EMAIL_BCC'
,p_message_language=>'es'
,p_message_text=>'Cco'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111570250952399486)
,p_name=>'APEXIR_EMAIL_BODY'
,p_message_language=>'es'
,p_message_text=>'Cuerpo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111569979155399486)
,p_name=>'APEXIR_EMAIL_CC'
,p_message_language=>'es'
,p_message_text=>'Cc'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111570737302399487)
,p_name=>'APEXIR_EMAIL_FREQUENCY'
,p_message_language=>'es'
,p_message_text=>'Frecuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111452188081399398)
,p_name=>'APEXIR_EMAIL_NOT_CONFIGURED'
,p_message_language=>'es'
,p_message_text=>unistr('El correo electr\00F3nico no se ha configurado para esta aplicaci\00F3n. P\00F3ngase en contacto con el administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111543682951399467)
,p_name=>'APEXIR_EMAIL_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar la direcci\00F3n de correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111570398525399486)
,p_name=>'APEXIR_EMAIL_SEE_ATTACHED'
,p_message_language=>'es'
,p_message_text=>'Consulte adjuntos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111570102634399486)
,p_name=>'APEXIR_EMAIL_SUBJECT'
,p_message_language=>'es'
,p_message_text=>'Asunto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111544637235399467)
,p_name=>'APEXIR_EMAIL_SUBJECT_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar el asunto del correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111569893778399486)
,p_name=>'APEXIR_EMAIL_TO'
,p_message_language=>'es'
,p_message_text=>'Para'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111453845307399399)
,p_name=>'APEXIR_ENABLED'
,p_message_language=>'es'
,p_message_text=>'Activado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111495585464399431)
,p_name=>'APEXIR_ENABLE_DISABLE_ALT'
,p_message_language=>'es'
,p_message_text=>'Activar/Desactivar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111495033107399430)
,p_name=>'APEXIR_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111494636651399430)
,p_name=>'APEXIR_EXAMPLES'
,p_message_language=>'es'
,p_message_text=>'Ejemplos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111495431424399431)
,p_name=>'APEXIR_EXAMPLES_WITH_COLON'
,p_message_language=>'es'
,p_message_text=>'Ejemplos:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111459331621399404)
,p_name=>'APEXIR_EXCLUDE_NULL'
,p_message_language=>'es'
,p_message_text=>'Excluir Valores Nulos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111496078454399431)
,p_name=>'APEXIR_EXPAND_COLLAPSE_ALT'
,p_message_language=>'es'
,p_message_text=>'Ampliar/Reducir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111493658395399429)
,p_name=>'APEXIR_EXPRESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111478769569399418)
,p_name=>'APEXIR_FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtro'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111489674115399426)
,p_name=>'APEXIR_FILTERS'
,p_message_language=>'es'
,p_message_text=>'Filtros'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111499905699399434)
,p_name=>'APEXIR_FILTER_EXPRESSION'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n de Filtro')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111596437268399506)
,p_name=>'APEXIR_FILTER_EXPR_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>unistr('La expresi\00F3n de filtro es demasiado larga.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111499876906399434)
,p_name=>'APEXIR_FILTER_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111496279768399431)
,p_name=>'APEXIR_FINDER_ALT'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Columnas a Buscar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111479043066399418)
,p_name=>'APEXIR_FLASHBACK'
,p_message_language=>'es'
,p_message_text=>'Flashback'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111493431699399429)
,p_name=>'APEXIR_FLASHBACK_DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Las consultas de flashback permiten visualizar los datos tal como exist\00EDan en un punto en el tiempo anterior.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111544010068399467)
,p_name=>'APEXIR_FLASHBACK_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Duraci\00F3n de flashback')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111545408525399468)
,p_name=>'APEXIR_FORMAT'
,p_message_language=>'es'
,p_message_text=>'Formato'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111475162546399415)
,p_name=>'APEXIR_FORMAT_MASK'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1scara de Formato %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111486310511399424)
,p_name=>'APEXIR_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111494103899399430)
,p_name=>'APEXIR_FUNCTIONS'
,p_message_language=>'es'
,p_message_text=>'Funciones %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111569305321399486)
,p_name=>'APEXIR_FUNCTIONS_OPERATORS'
,p_message_language=>'es'
,p_message_text=>'Funciones/Operadores'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111486063640399424)
,p_name=>'APEXIR_FUNCTION_N'
,p_message_language=>'es'
,p_message_text=>unistr('Funci\00F3n %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111478549733399418)
,p_name=>'APEXIR_GO'
,p_message_language=>'es'
,p_message_text=>'Ir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111454302252399400)
,p_name=>'APEXIR_GREEN'
,p_message_language=>'es'
,p_message_text=>'verde'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111437653013399387)
,p_name=>'APEXIR_GROUP_BY'
,p_message_language=>'es'
,p_message_text=>'Agrupar por'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111570418634399487)
,p_name=>'APEXIR_GROUP_BY_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Agrupar por Columna %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111525061551399453)
,p_name=>'APEXIR_GROUP_BY_COL_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar la columna Agrupar por.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111536192349399461)
,p_name=>'APEXIR_GROUP_BY_MAX_ROW_CNT'
,p_message_language=>'es'
,p_message_text=>unistr('El recuento m\00E1ximo de filas para una consulta de Agrupar por limita el n\00FAmero de filas de la consulta base, no el n\00FAmero de filas que se muestran. La consulta base supera el recuento m\00E1ximo de filas de %0. Aplique un filtro para reducir el n\00FAmero de ')
||'registros en la consulta base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111516757950399446)
,p_name=>'APEXIR_GROUP_BY_SORT'
,p_message_language=>'es'
,p_message_text=>unistr('Agrupar por Ordenaci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111574214079399489)
,p_name=>'APEXIR_GROUP_BY_SORT_ORDER'
,p_message_language=>'es'
,p_message_text=>unistr('Agrupar por Orden de Clasificaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111459749431399404)
,p_name=>'APEXIR_HCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111491374124399428)
,p_name=>'APEXIR_HELP'
,p_message_language=>'es'
,p_message_text=>'Ayuda'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111483110391399421)
,p_name=>'APEXIR_HELP_01'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Los informes interactivos permiten que los usuarios finales personalicen los informes. Los usuarios pueden modificar el dise\00F1o de los datos del informe seleccionando columnas, aplicando filtros, resaltando y ordenando. Tambi\00E9n pueden definir saltos d')
||unistr('e l\00EDnea, agregaciones, gr\00E1ficos, organizaciones por grupos y sus propios c\00E1lculos. Tambi\00E9n se puede configurar una suscripci\00F3n para que env\00EDe por correo electr\00F3nico el informe en versi\00F3n HTML con intervalos de tiempo designados. Los usuarios pueden c')
||unistr('rear m\00FAltiples variaciones del informe y guardarlas como informes con nombre, para visualizaci\00F3n p\00FAblica o privada.'),
'<p/>',
unistr('Las secciones siguientes ofrecen un resumen de los modos de personalizar un informe interactivo. Para obtener m\00E1s informaci\00F3n, consulte la secci\00F3n sobre el uso de informes interactivos en <i>Oracle Application Express End User''s Guide</i></a>.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111490272096399427)
,p_name=>'APEXIR_HELP_ACTIONS_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('El men\00FA Acciones aparece a la derecha del bot\00F3n Ir en la barra de b\00FAsqueda. Utilice este men\00FA para personalizar un informe interactivo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111483920724399422)
,p_name=>'APEXIR_HELP_AGGREGATE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Las agregaciones son c\00E1lculos matem\00E1ticos que se realizan en una columna. Las agregaciones se muestran detr\00E1s de cada divisi\00F3n de control y, al final del informe, dentro de la columna en la que est\00E1n definidos. Las opciones incluyen:'),
'<p>',
'</p><ul>',
unistr('<li><strong>Agregaci\00F3n</strong> permite seleccionar una agregaci\00F3n definida previamente para editarla.</li>'),
unistr('<li><strong>Funci\00F3n</strong> es la funci\00F3n que se debe ejecutar (por ejemplo, SUM, MIN).</li>'),
unistr('<li><strong>Columna</strong> se utiliza para seleccionar la columna a la que se aplica la funci\00F3n matem\00E1tica. S\00F3lo se muestran las columnas num\00E9ricas.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111484044874399422)
,p_name=>'APEXIR_HELP_CHART'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Puede definir un gr\00E1fico por informe guardado. Despu\00E9s '),
unistr('de definirlo, puede cambiar entre las vistas de gr\00E1fico y de informe mediante los iconos de visualizaci\00F3n de la barra de b\00FAsqueda.'),
'Las opciones son: ',
'<p>',
'</p><ul>',
unistr('<li><strong>Tipo de Gr\00E1fico</strong> identifica el tipo de gr\00E1fico que se debe incluir.'),
unistr('Seleccione un gr\00E1fico de barras horizontales, de barras verticales, de tarta o de l\00EDneas.</li>'),
'<li><strong>Etiqueta</strong> permite seleccionar la columna que se debe utilizar como etiqueta.</li>',
unistr('<li><strong>T\00EDtulo del Eje para Etiqueta</strong> es el t\00EDtulo que se mostrar\00E1 en el eje asociado a la columna seleccionada como'),
unistr('etiqueta. No est\00E1 disponible para gr\00E1ficos de tarta.</li>'),
unistr('<li><strong>Valor</strong> permite seleccionar la columna que se debe utilizar como valor. Si la funci\00F3n'),
unistr('es COUNT, no se tiene que seleccionar ning\00FAn valor.</li>'),
unistr('<li><strong>T\00EDtulo del Eje para Valor</strong> es el t\00EDtulo que se mostrar\00E1 en el eje asociado a la columna seleccionada'),
unistr('como valor. No est\00E1 disponible para gr\00E1ficos de tarta.</li>'),
unistr('<li><strong>Funci\00F3n</strong> es una funci\00F3n opcional que se debe realizar en la columna seleccionada como valor.</li>'),
'<li><strong>Ordenar</strong> permite ordenar el juego de resultados.</li></ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111483352524399421)
,p_name=>'APEXIR_HELP_COLUMN_HEADING_MENU'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Al hacer clic en cualquier cabecera de columna, se muestra un men\00FA de cabecera de columna con las siguientes opciones:'),
'<p></p>',
'<ul>',
unistr('<li>El icono <strong>Orden ascendente</strong> ordena el informe seg\00FAn la columna en orden ascendente.</li>'),
unistr('<li>El icono <strong>Orden descendente</strong> ordena el informe seg\00FAn la columna en orden descendente.</li>'),
unistr('<li><strong>Ocultar columna</strong> oculta la columna. No todas las columnas se pueden ocultar. Si una columna no se puede ocultar, no habr\00E1 ning\00FAn icono Ocultar columna.</li>'),
unistr('<li><strong>Columna divisoria</strong> crea un grupo de divisi\00F3n en la columna. De esta forma se extrae la columna del informe como registro maestro.</li>'),
unistr('<li><strong>Informaci\00F3n de la columna</strong> muestra texto de ayuda sobre la columna si est\00E1 disponible.</li>'),
unistr('<li><strong>\00C1rea de texto</strong> se utiliza para introducir criterios de b\00FAsqueda que no sean sensibles a may\00FAsculas/min\00FAsculas'),
'(no se necesitan comodines). Al introducir un valor, se reduce la lista de',
unistr('valores de la parte inferior del men\00FA. A continuaci\00F3n, puede seleccionar'),
'un valor de la parte inferior para que se cree como filtro con ''=''',
unistr('(por ejemplo, <code>column = ''ABC''</code>). Tambi\00E9n puede hacer clic en el icono Linterna e introducir un valor para que se cree como filtro con el modificador ''LIKE'''),
'(por ejemplo, <code>column LIKE ''%ABC%''</code>).</li>',
unistr('<li><b>Lista de valores \00FAnicos</b> contiene los 500 primeros valores'),
unistr('\00FAnicos que cumplen los criterios de filtro. Si la columna es una fecha, aparece una'),
unistr('lista de rangos de fechas. Si selecciona un valor, se crear\00E1 un filtro con'),
'''='' (por ejemplo, <code>column = ''ABC''</code>).</li>',
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111483832753399422)
,p_name=>'APEXIR_HELP_COMPUTE'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Permite agregar columnas calculadas al informe. Pueden ser c\00E1lculos matem\00E1ticos (por ejemplo, <code>NBR_HOURS/24</code>) o funciones est\00E1ndar de Oracle aplicadas a columnas existentes. Algunas se muestran como ejemplo pero tambi\00E9n se pueden utilizar ')
||'otras (como <code>TO_DATE)</code>). Las opciones incluyen:',
'<p></p>',
'<ul>',
unistr('<li><strong>C\00E1lculo</strong> permite seleccionar un c\00E1lculo definido previamente para editarlo.</li>'),
'<li><strong>Cabecera de Columna</strong> es la cabecera para la nueva columna.</li>',
unistr('<li><strong>M\00E1scara de Formato</strong> es una m\00E1scara de formato de Oracle que se debe aplicar a la columna (por ejemplo, S9999).</li>'),
unistr('<li><strong>C\00E1lculo</strong> es el c\00E1lculo que se debe realizar. Dentro del c\00E1lculo, se hace referencia a las columnas mediante los alias mostrados.</li>'),
'</ul>',
unistr('<p>Debajo del c\00E1lculo, las columnas de la consulta se muestran con sus alias asociados. Al hacer clic en el nombre o el alias de una columna, estos se incluyen en el c\00E1lculo. Junto a las columnas hay un teclado que funciona como m\00E9todo abreviado para')
||unistr(' las teclas que m\00E1s se utilizan. En el extremo de la derecha est\00E1n las funciones.</p>'),
unistr('<p>El siguiente es un ejemplo de c\00E1lculo para mostrar la remuneraci\00F3n total:</p>'),
'<pre>CASE WHEN A = ''VENTAS'' THEN B + C ELSE B END</pre>',
unistr('(donde A es ORGANIZACI\00D3N, B es SALARIO y C es COMISI\00D3N)')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111490370830399427)
,p_name=>'APEXIR_HELP_CONTROL_BREAK'
,p_message_language=>'es'
,p_message_text=>'Se utiliza para crear un grupo divisorio en una o varias columnas. Obtiene las columnas del informe interactivo y las muestra como un registro maestro.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111484532425399422)
,p_name=>'APEXIR_HELP_DETAIL_VIEW'
,p_message_language=>'es'
,p_message_text=>unistr('Para visualizar los detalles de una sola fila cada vez, haga clic en el icono de vista de una sola fila correspondiente a la fila que desea visualizar. Si est\00E1 disponible, la vista de una sola fila siempre estar\00E1 en la primera columna. Seg\00FAn la perso')
||unistr('nalizaci\00F3n del informe interactivo, la vista de una sola fila puede ser la vista est\00E1ndar o una p\00E1gina personalizada que se puede actualizar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111484464586399422)
,p_name=>'APEXIR_HELP_DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Permite descargar el juego de resultados actual. Los formatos de',
unistr(' descarga son diferentes seg\00FAn la instalaci\00F3n y la definici\00F3n del'),
unistr(' informe pero pueden ser CSV, HTML, Correo Electr\00F3nico, XLS, PDF'),
' o RTF.'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111483508468399421)
,p_name=>'APEXIR_HELP_FILTER'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Delimita el informe mediante la adici\00F3n o modificaci\00F3n de la cl\00E1usula WHERE de la consulta. Puede filtrar por columna o por fila.'),
'<p/>',
unistr('Si filtra por columna, seleccione primero una columna (no tiene que ser la mostrada), seleccione un operador est\00E1ndar de Oracle (=, !=, no en, entre) y, a continuaci\00F3n, introduzca una expresi\00F3n con la que realizar la comparaci\00F3n. Las expresiones son ')
||unistr('sensibles a may\00FAsculas/min\00FAsculas. Utilice % como comod\00EDn (por ejemplo, <code>STATE_NAME'),
'like A%)</code>.</p>',
unistr('<p>Si filtra por fila, puede crear cl\00E1usulas WHERE complejas con alias de columna y cualquier funci\00F3n u operador de Oracle (por ejemplo, <code>G = ''VA'' o G = ''CT''</code>, donde <code>G</code> es el alias de CUSTOMER_STATE).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111484114191399422)
,p_name=>'APEXIR_HELP_FLASHBACK'
,p_message_language=>'es'
,p_message_text=>unistr('Las consultas de flashback permiten visualizar los datos tal como exist\00EDan en un punto en el tiempo anterior. El tiempo por defecto en el que se puede realizar la operaci\00F3n de flashback es 3 horas (o 180 minutos) aunque el tiempo real es diferente se')
||unistr('g\00FAn la base de datos.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111545367103399468)
,p_name=>'APEXIR_HELP_FORMAT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>El men\00FA Formato permite personalizar la visualizaci\00F3n del informe.'),
unistr('Contiene los siguientes submen\00FAs:</p>'),
'<ul><li>Ordenar</li>',
unistr('<li>Divisi\00F3n de Control</li>'),
'<li>Resaltar</li>',
'<li>Calcular</li>',
'<li>Agregar</li>',
unistr('<li>Gr\00E1fico</li>'),
'<li>Agrupar por</li>',
'<li>Girar</li>',
'</ul>',
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111543555528399467)
,p_name=>'APEXIR_HELP_GROUP_BY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Puede definir una vista Agrupar por, por informe guardado.',
unistr('Una vez se ha definido, puede cambiar entre las vistas de agrupaci\00F3n e informe'),
unistr('mediante los iconos de vista que se encuentran en la barra de b\00FAsqueda. Para crear una vista Agrupar por,'),
'seleccione:',
'<p></p><ul>',
unistr('<li>las columnas en las que realizar la agrupaci\00F3n</li>,'),
unistr('<li>las columnas para agregar, junto con la funci\00F3n que se va a realizar (media, suma, recuento, etc.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111483754075399421)
,p_name=>'APEXIR_HELP_HIGHLIGHT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Permite definir un filtro. Las filas que cumplen los criterios de filtro se resaltan seg\00FAn las caracter\00EDsticas asociadas al filtro. Las opciones incluyen:</p>'),
'<ul>',
unistr('<li><strong>Nombre</strong> s\00F3lo se utiliza para la visualizaci\00F3n.</li>'),
unistr('<li><strong>Secuencia</strong> identifica la secuencia en la que se evaluar\00E1n las reglas.</li>'),
unistr('<li><strong>Activado</strong> identifica si la regla est\00E1 activada o desactivada.</li>'),
unistr('<li><strong>Tipo de Resaltado</strong> identifica si la fila o la celda debe estar resaltada. Si se selecciona Celda, se resalta la columna a la que se hace referencia en Condici\00F3n para Resaltar.</li>'),
unistr('<li><strong>Color de Fondo</strong> es el nuevo color para el fondo del \00E1rea resaltada.</li>'),
unistr('<li><strong>Color del Texto</strong> es el nuevo color para el texto del \00E1rea resaltada.</li>'),
unistr('<li><strong>Condici\00F3n para Resaltar</strong> define la condici\00F3n del filtro.</li></ul>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111421350984399375)
,p_name=>'APEXIR_HELP_PIVOT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Puede definir una vista din\00E1mica por informe guardado. Una vez definidas, puede cambiar entre las vistas din\00E1micas y de informe utilizando los iconos de vista que se encuentran en la barra de b\00FAsqueda. Para crear una vista din\00E1mica, se seleccionan: '),
'<p></p>',
'<ul>',
'<li>las columnas sobre las que girar</li>',
'<li>las columnas que mostrar como filas</li>',
unistr('<li>las columnas que agregar junto con la funci\00F3n que se va a realizar (media, suma, recuento, etc.)</li>'),
'</ul>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111494867367399430)
,p_name=>'APEXIR_HELP_REPORT_SETTINGS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si personaliza un informe interactivo, la configuraci\00F3n del informe se mostrar\00E1'),
unistr('debajo de la barra de b\00FAsqueda y encima del informe. Esta \00E1rea se puede reducir y ampliar mediante el icono de la izquierda.'),
'<p>',
unistr('En cada configuraci\00F3n de informe, puede hacer lo siguiente:'),
'</p><ul>',
'<li>Editar un valor haciendo clic en el nombre.</li>',
'<li>Desactivar/activar un valor marcando o anulando la marca de la casilla de control Activar/Desactivar. Se utiliza para desactivar y activar temporalmente el valor.</li>',
'<li>Eliminar un valor haciendo clic en el icono Eliminar.</li>',
'</ul>',
unistr('<p>Si ha creado un gr\00E1fico, una ordenaci\00F3n por grupos o elemento din\00E1mico, puede cambiar entre ellos'),
unistr('y el informe base con los enlaces Vista de Informe, Vista de Gr\00E1fico, Vista Agrupar por y Vista Din\00E1mica por'),
unistr('que se muestran a la derecha. Si est\00E1 visualizando el gr\00E1fico, la ordenaci\00F3n por grupos o elemento din\00E1mico, tambi\00E9n'),
unistr('puede utilizar el enlace Editar para editar la configuraci\00F3n.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111484384622399422)
,p_name=>'APEXIR_HELP_RESET'
,p_message_language=>'es'
,p_message_text=>'Restablece los valores por defecto del informe eliminando todas las personalizaciones realizadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111545654607399468)
,p_name=>'APEXIR_HELP_ROWS_PER_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Define el n\00FAmero de registros que se mostrar\00E1n por p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111484272164399422)
,p_name=>'APEXIR_HELP_SAVE_REPORT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Guarda el informe personalizado para su uso en el futuro. Se proporcionan un nombre y una descripci\00F3n opcional y el p\00FAblico (es decir, todos los usuarios con acceso al informe principal por defecto) podr\00E1 acceder al informe. Puede guardar cuatro t')
||'ipos de informe interactivo:</p>',
'<ul>',
unistr('<li><strong>Principal por Defecto</strong> (s\00F3lo desarrolladores). El informe principal por defecto es el primero que se muestra. No se puede cambiar el nombre de estos informes ni se pueden suprimir.</li>'),
unistr('<li><strong>Informe Alternativo</strong> (s\00F3lo desarrolladores). Permite a los desarrolladores crear varios dise\00F1os de informe. S\00F3lo los desarrolladores pueden guardar, cambiar el nombre o suprimir un informe alternativo.</li>'),
unistr('<li><strong>Informe P\00FAblico</strong> (usuario final). El usuario final que lo cre\00F3 puede guardarlo, suprimirlo o cambiarle el nombre. Los dem\00E1s usuarios pueden visualizarlo y guardar el dise\00F1o como otro informe.</li>'),
unistr('<li><strong>Informe Privado</strong> (usuario final). S\00F3lo el usuario que cre\00F3 el informe puede visualizarlo, guardarlo, suprimirlo o cambiarle el nombre.</li>'),
'</ul>',
unistr('<p>Si guarda informes personalizados, se muestra un selector de informes en la barra de b\00FAsqueda a la izquierda del selector de filas (si est\00E1 activada esta funci\00F3n).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111483260477399421)
,p_name=>'APEXIR_HELP_SEARCH_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('En la parte superior de cada p\00E1gina de informe se encuentra una regi\00F3n de b\00FAsqueda. Esta regi\00F3n (o barra de herramientas) proporciona las siguientes funciones:')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111546296776399469)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ACTIONS_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('<li>El <strong>men\00FA Acciones</strong> permite actualizar un informe. Consulte las siguientes secciones.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111545799472399468)
,p_name=>'APEXIR_HELP_SEARCH_BAR_FINDER'
,p_message_language=>'es'
,p_message_text=>unistr('<li>El icono <strong>Seleccionar Columnas</strong> permite identificar en qu\00E9 columnas buscar (o si desea hacerlo en todas).</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111546034513399468)
,p_name=>'APEXIR_HELP_SEARCH_BAR_REPORTS'
,p_message_language=>'es'
,p_message_text=>unistr('<li><strong>Informes</strong> muestra informes privados o p\00FAblicos por defecto o guardados de forma alterna.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111545978744399468)
,p_name=>'APEXIR_HELP_SEARCH_BAR_ROWS'
,p_message_language=>'es'
,p_message_text=>unistr('<li><strong>Filas</strong> define el n\00FAmero de registros que se mostrar\00E1n en cada p\00E1gina.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111545851116399468)
,p_name=>'APEXIR_HELP_SEARCH_BAR_TEXTBOX'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<li>El <strong>\00E1rea de texto</strong> permite utilizar criterios de b\00FAsqueda que no sean sensibles a may\00FAsculas/min\00FAsculas (se permite el uso de comodines).</li>'),
unistr('<li>El <strong>bot\00F3n Ir</strong> ejecuta la b\00FAsqueda. Al pulsar la tecla Intro, tambi\00E9n se ejecutar\00E1 la b\00FAsqueda si el cursor est\00E1 en el \00E1rea de texto de b\00FAsqueda.</li>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111546170931399468)
,p_name=>'APEXIR_HELP_SEARCH_BAR_VIEW'
,p_message_language=>'es'
,p_message_text=>unistr('<li><strong>Iconos de Visualizaci\00F3n</strong> cambia entre la vista de icono, informe, detallada, gr\00E1fico, agrupar por y din\00E1mica del informe si se han definido.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111562191210399480)
,p_name=>'APEXIR_HELP_SEARCH_BAR_WS_MANAGE'
,p_message_language=>'es'
,p_message_text=>unistr('<li><strong>Gestionar</strong> permite gestionar las propiedades, columnas y filas, y ver el historial de un informe o una cuadr\00EDcula de datos.</li>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111483446975399421)
,p_name=>'APEXIR_HELP_SELECT_COLUMNS'
,p_message_language=>'es'
,p_message_text=>unistr('Se utiliza para modificar las columnas mostradas. Se muestran las columnas de la derecha. Las columnas de la izquierda permanecen ocultas. Puede volver a ordenar las columnas mostradas mediante las flechas que hay m\00E1s a la derecha. Las columnas calcu')
||'ladas tienen el prefijo <strong>**</strong>.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111483655881399421)
,p_name=>'APEXIR_HELP_SORT'
,p_message_language=>'es'
,p_message_text=>unistr('<p>Se utiliza para cambiar las columnas por las que se ordena y determina si ordenar en sentido ascendente o descendente. Tambi\00E9n puede especificar c\00F3mo se manejan los <code>valores nulos</code>: el valor por defecto, mostrarlos siempre al final o mo')
||unistr('strarlos siempre al principio. La ordenaci\00F3n resultante se muestra a la derecha de las cabeceras de columna del informe.</p>')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111543361370399466)
,p_name=>'APEXIR_HELP_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Al agregar una suscripci\00F3n, proporciona una direcci\00F3n (o varias separadas por comas) y el asunto del correo electr\00F3nico, la frecuencia y las fechas de inicio y fin. Los correos electr\00F3nicos resultantes incluyen una versi\00F3n HTML del informe interactiv')
||unistr('o que contiene los datos actuales utilizando la configuraci\00F3n de informe que exist\00EDa al agregar la suscripci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111561929881399480)
,p_name=>'APEXIR_HELP_WS_01'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Las cuadr\00EDculas de datos son b\00E1sicamente informes editables que se pueden personalizar. Los usuarios pueden modificar el dise\00F1o de los datos del informe seleccionando columnas, aplicando filtros, resaltando y ordenando. Tambi\00E9n pueden definir saltos ')
||unistr('de l\00EDnea, agregaciones, gr\00E1ficos, organizaciones por grupos y sus propios c\00E1lculos. Adem\00E1s los usuarios pueden crear m\00FAltiples variaciones del informe y guardarlas como informes con nombre, para visualizaci\00F3n privada.'),
'<p/>',
unistr('Una cuadr\00EDcula de datos se puede personalizar de varias maneras: mediante la barra de b\00FAsqueda, el men\00FA de acciones, el men\00FA Gestionar o el men\00FA de cabecera de columna.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111573771975399489)
,p_name=>'APEXIR_HELP_WS_ACTIONS_MENU'
,p_message_language=>'es'
,p_message_text=>unistr('El men\00FA Acciones aparece a la derecha del bot\00F3n Ir en la barra de b\00FAsqueda. Utilice este men\00FA para personalizar un informe de cuadr\00EDcula de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111562469152399481)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT'
,p_message_language=>'es'
,p_message_text=>unistr('P\00E1gina Agregar/Editar Fila')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111562514984399481)
,p_name=>'APEXIR_HELP_WS_ADD_EDIT_ROW'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Para agregar una fila a la cuadr\00EDcula de datos, haga clic en Agregar Fila. Para editar los detalles de una fila, haga clic en el icono de edici\00F3n (primera columna) de la fila que desee editar. La p\00E1gina Agregar/Editar Fila se mostrar\00E1 con las colu')
||unistr('mnas de la cuadr\00EDcula de datos. </p>'),
'',
'<p>Al editar una fila, puede:</p>',
'',
'<p><ul>',
'<li><strong>Suprimir</strong> la fila.</li>',
'<li><strong>Aplicar Cambios</strong> para guardar los cambios realizados en la fila.</li>',
'<li>Dentro de <strong>Acciones</strong>, agregar una fila, agregar archivos, notas, enlaces o etiquetas, y revisar el historial.</li>',
'<li>Navegar a las filas <strong>Anterior y Siguiente</strong>.</li>',
'<li>En <strong>Gestionar</strong>, definir las propiedades de columna, grupos de columnas, validaciones y listas de valores.</li>',
'</ul></p>',
'',
unistr('<p>La regi\00F3n Anotaciones de la parte inferior de la p\00E1gina incluir\00E1 los archivos, notas, enlaces y etiquetas asociados a la fila actual.</p>')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111573869034399489)
,p_name=>'APEXIR_HELP_WS_CONTROL_BREAK'
,p_message_language=>'es'
,p_message_text=>unistr('Se utiliza para crear un grupo divisorio en una o varias columnas. Obtiene las columnas de la cuadr\00EDcula de datos y las muestra como un registro maestro.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111562348408399481)
,p_name=>'APEXIR_HELP_WS_DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Permite descargar el juego de resultados actual. Los formatos de',
unistr(' descarga incluyen CSV, HTML o Correo Electr\00F3nico.')))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111573925861399489)
,p_name=>'APEXIR_HELP_WS_REPORT_SETTINGS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('Si personaliza un informe de cuadr\00EDcula de datos, la configuraci\00F3n del informe se mostrar\00E1'),
unistr('debajo de la barra de b\00FAsqueda y encima del informe. Esta \00E1rea se puede reducir y ampliar mediante el icono de la izquierda.'),
'<p>',
unistr('En cada configuraci\00F3n de informe, puede hacer lo siguiente:'),
'</p><ul>',
'<li>Editar un valor haciendo clic en el nombre.</li>',
'<li>Desactivar/activar un valor marcando o anulando la marca de la casilla de control Activar/Desactivar. Se utiliza para desactivar y activar temporalmente el valor.</li>',
'<li>Eliminar un valor haciendo clic en el icono correspondiente.</li>',
'</ul>',
unistr('<p>Si ha creado un gr\00E1fico o una ordenaci\00F3n por grupos, puede'),
'conmutar entre ellos y el informe base con los enlaces Vista de',
unistr('Informe, Vista de Gr\00E1fico o Agrupar por que se muestran a la'),
unistr('derecha. Si est\00E1 visualizando el gr\00E1fico o la ordenaci\00F3n por grupos,'),
unistr('tambi\00E9n puede utilizar el enlace Editar para editar la configuraci\00F3n.</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111562238480399480)
,p_name=>'APEXIR_HELP_WS_SAVE_REPORT'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('<p>Guarda el dise\00F1o del informe de cuadr\00EDcula de datos personalizado para su uso en el futuro. Se proporcionan un nombre y una descripci\00F3n opcional. Puede guardar tres tipos de dise\00F1o de informe de cuadr\00EDcula de datos:</p>'),
'<ul>',
unistr('<li><strong>Principal por Defecto</strong> (s\00F3lo administrador). \00C9ste es el primer dise\00F1o que se muestra. No se puede cambiar el nombre de estos informes principales por defecto ni se pueden suprimir.</li>'),
unistr('<li><strong>Informe Alternativo</strong> (s\00F3lo administrador). Permite a los administradores crear varios dise\00F1os de informe. S\00F3lo los administradores pueden guardar, cambiar el nombre o suprimir un informe alternativo.</li>'),
unistr('<li><strong>Informe Privado</strong> (todos los usuarios). El usuario que cre\00F3 el dise\00F1o de informe puede visualizar, guardar, suprimir o cambiar el nombre del informe. </li>'),
'</ul>',
unistr('<p>Si guarda informes personalizados, se muestra un selector de informes en la barra de b\00FAsqueda a la izquierda del selector de filas (si est\00E1 activada esta funci\00F3n).</p>'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111488339853399425)
,p_name=>'APEXIR_HIDE_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Ocultar Columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111478935892399418)
,p_name=>'APEXIR_HIGHLIGHT'
,p_message_language=>'es'
,p_message_text=>'Resaltar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111489878821399427)
,p_name=>'APEXIR_HIGHLIGHTS'
,p_message_language=>'es'
,p_message_text=>'Resaltados'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111494999259399430)
,p_name=>'APEXIR_HIGHLIGHT_CONDITION'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n para resaltar')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111543978895399467)
,p_name=>'APEXIR_HIGHLIGHT_STYLE'
,p_message_language=>'es'
,p_message_text=>'Estilo de resaltado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111453931968399400)
,p_name=>'APEXIR_HIGHLIGHT_TYPE'
,p_message_language=>'es'
,p_message_text=>'Tipo de resaltado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111563495152399481)
,p_name=>'APEXIR_HORIZONTAL'
,p_message_language=>'es'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111593000641399503)
,p_name=>'APEXIR_INACTIVE_SETTING'
,p_message_language=>'es'
,p_message_text=>'1 valor inactivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111593110977399504)
,p_name=>'APEXIR_INACTIVE_SETTINGS'
,p_message_language=>'es'
,p_message_text=>'%0 valores inactivos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111484947829399423)
,p_name=>'APEXIR_INTERACTIVE_REPORT_HELP'
,p_message_language=>'es'
,p_message_text=>'Ayuda de Informe Interactivo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111495947126399431)
,p_name=>'APEXIR_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('No v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111489370535399426)
,p_name=>'APEXIR_INVALID_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n de c\00E1lculo no v\00E1lida. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111448783639399396)
,p_name=>'APEXIR_INVALID_END_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('La fecha de finalizaci\00F3n debe ser posterior a la fecha de inicio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111503670132399437)
,p_name=>'APEXIR_INVALID_FILTER'
,p_message_language=>'es'
,p_message_text=>unistr('Expresi\00F3n de filtro no v\00E1lida. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111571433799399487)
,p_name=>'APEXIR_INVALID_FILTER_QUERY'
,p_message_language=>'es'
,p_message_text=>unistr('Consulta de filtro no v\00E1lida')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111593234001399504)
,p_name=>'APEXIR_INVALID_SETTING'
,p_message_language=>'es'
,p_message_text=>unistr('1 valor no v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111593394564399504)
,p_name=>'APEXIR_INVALID_SETTINGS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 valores no v\00E1lidos')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111544164933399467)
,p_name=>'APEXIR_IN_MINUTES'
,p_message_language=>'es'
,p_message_text=>'(en minutos)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111561128451399480)
,p_name=>'APEXIR_IS_IN_THE_LAST'
,p_message_language=>'es'
,p_message_text=>unistr('%0 est\00E1 en el \00FAltimo %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111561322595399480)
,p_name=>'APEXIR_IS_IN_THE_NEXT'
,p_message_language=>'es'
,p_message_text=>unistr('%0 est\00E1 en el siguiente %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111561218982399480)
,p_name=>'APEXIR_IS_NOT_IN_THE_LAST'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no est\00E1 en el \00FAltimo %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111561482309399480)
,p_name=>'APEXIR_IS_NOT_IN_THE_NEXT'
,p_message_language=>'es'
,p_message_text=>unistr('%0 no est\00E1 en el siguiente %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111494075960399430)
,p_name=>'APEXIR_KEYPAD'
,p_message_language=>'es'
,p_message_text=>'Teclado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111460181553399404)
,p_name=>'APEXIR_LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111487930132399425)
,p_name=>'APEXIR_LABEL_AXIS_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo del Eje para Etiqueta')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111480449559399419)
,p_name=>'APEXIR_LAST_DAY'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimo D\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111480614451399419)
,p_name=>'APEXIR_LAST_HOUR'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltima Hora')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111480190659399419)
,p_name=>'APEXIR_LAST_MONTH'
,p_message_language=>'es'
,p_message_text=>'Mes pasado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111480203113399419)
,p_name=>'APEXIR_LAST_WEEK'
,p_message_language=>'es'
,p_message_text=>'Semana pasada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111480343768399419)
,p_name=>'APEXIR_LAST_X_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimos %0 D\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111480524054399419)
,p_name=>'APEXIR_LAST_X_HOURS'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimas %0 Horas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111479974694399419)
,p_name=>'APEXIR_LAST_X_YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('\00DAltimos %0 A\00F1os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111480083538399419)
,p_name=>'APEXIR_LAST_YEAR'
,p_message_language=>'es'
,p_message_text=>unistr('A\00F1o pasado')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111460039063399404)
,p_name=>'APEXIR_LINE'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111456860537399402)
,p_name=>'APEXIR_LINE_WITH_AREA'
,p_message_language=>'es'
,p_message_text=>unistr('L\00EDnea con \00C1rea')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111571313069399487)
,p_name=>'APEXIR_MAP_IT'
,p_message_language=>'es'
,p_message_text=>'Asignar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111488840429399426)
,p_name=>'APEXIR_MAX_QUERY_COST'
,p_message_language=>'es'
,p_message_text=>unistr('Se estima que la consulta supera el m\00E1ximo de recursos permitidos. Modifique los valores del informe y vuelva a intentarlo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111471023174399412)
,p_name=>'APEXIR_MAX_ROW_CNT'
,p_message_language=>'es'
,p_message_text=>unistr('El recuento m\00E1ximo de filas de este informe es %0 filas. Aplique un filtro para reducir el n\00FAmero de registros de la consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111571927766399488)
,p_name=>'APEXIR_MAX_X'
,p_message_language=>'es'
,p_message_text=>unistr('M\00E1ximo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111572150727399488)
,p_name=>'APEXIR_MEDIAN_X'
,p_message_language=>'es'
,p_message_text=>'Mediana %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111475046094399415)
,p_name=>'APEXIR_MIN_AGO'
,p_message_language=>'es'
,p_message_text=>'Hace %0 minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111572062024399488)
,p_name=>'APEXIR_MIN_X'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111571063432399487)
,p_name=>'APEXIR_MONTH'
,p_message_language=>'es'
,p_message_text=>'Mes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111544553988399467)
,p_name=>'APEXIR_MONTHLY'
,p_message_language=>'es'
,p_message_text=>'Mensualmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111487116303399425)
,p_name=>'APEXIR_MOVE'
,p_message_language=>'es'
,p_message_text=>'Mover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111487009271399425)
,p_name=>'APEXIR_MOVE_ALL'
,p_message_language=>'es'
,p_message_text=>'Mover Todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111598209559399507)
,p_name=>'APEXIR_MULTIIR_PAGE_REGION_STATIC_ID_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar el identificador est\00E1tico de regi\00F3n, ya que la p\00E1gina contiene varios informes interactivos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111455571425399401)
,p_name=>'APEXIR_NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111482984808399421)
,p_name=>'APEXIR_NEW_AGGREGATION'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva agregaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111593960364399504)
,p_name=>'APEXIR_NEW_CATEGORY_LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Nueva Categor\00EDa')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111483060476399421)
,p_name=>'APEXIR_NEW_COMPUTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Nuevo c\00E1lculo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111477838176399417)
,p_name=>'APEXIR_NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111480979491399419)
,p_name=>'APEXIR_NEXT_DAY'
,p_message_language=>'es'
,p_message_text=>unistr('D\00EDa Siguiente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111480796391399419)
,p_name=>'APEXIR_NEXT_HOUR'
,p_message_language=>'es'
,p_message_text=>'Hora Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111481291588399420)
,p_name=>'APEXIR_NEXT_MONTH'
,p_message_language=>'es'
,p_message_text=>'Mes Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111481130723399419)
,p_name=>'APEXIR_NEXT_WEEK'
,p_message_language=>'es'
,p_message_text=>'Semana siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111481068519399419)
,p_name=>'APEXIR_NEXT_X_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('Siguientes %0 D\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111480800899399419)
,p_name=>'APEXIR_NEXT_X_HOURS'
,p_message_language=>'es'
,p_message_text=>'Siguientes %0 Horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111481426349399420)
,p_name=>'APEXIR_NEXT_X_YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('Siguientes %0 A\00F1os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111481387110399420)
,p_name=>'APEXIR_NEXT_YEAR'
,p_message_language=>'es'
,p_message_text=>unistr('A\00F1o siguiente')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111455886743399401)
,p_name=>'APEXIR_NO'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111496182039399431)
,p_name=>'APEXIR_NONE'
,p_message_language=>'es'
,p_message_text=>'- Ninguno -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111543700254399467)
,p_name=>'APEXIR_NOT_VALID_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Direcci\00F3n de correo electr\00F3nico no v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111492671105399429)
,p_name=>'APEXIR_NULLS_ALWAYS_FIRST'
,p_message_language=>'es'
,p_message_text=>'Valores Nulos Siempre al Principio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111492584509399429)
,p_name=>'APEXIR_NULLS_ALWAYS_LAST'
,p_message_language=>'es'
,p_message_text=>'Valores Nulos Siempre al Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111493015132399429)
,p_name=>'APEXIR_NULL_SORTING'
,p_message_language=>'es'
,p_message_text=>unistr('Ordenaci\00F3n de Valores Nulos %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111489498894399426)
,p_name=>'APEXIR_NUMERIC_FLASHBACK_TIME'
,p_message_language=>'es'
,p_message_text=>unistr('El tiempo de flashback debe ser un valor num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111489032216399426)
,p_name=>'APEXIR_NUMERIC_SEQUENCE'
,p_message_language=>'es'
,p_message_text=>unistr('La secuencia debe ser num\00E9rica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111493556736399429)
,p_name=>'APEXIR_OPERATOR'
,p_message_language=>'es'
,p_message_text=>'Operador'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111454412552399400)
,p_name=>'APEXIR_ORANGE'
,p_message_language=>'es'
,p_message_text=>'naranja'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111563357480399481)
,p_name=>'APEXIR_ORIENTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Orientaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111456305935399401)
,p_name=>'APEXIR_OTHER'
,p_message_language=>'es'
,p_message_text=>'Otro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111439141635399389)
,p_name=>'APEXIR_PDF_ORIENTATION'
,p_message_language=>'es'
,p_message_text=>unistr('Orientaci\00F3n de p\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111439819614399389)
,p_name=>'APEXIR_PDF_ORIENTATION_HORIZONTAL'
,p_message_language=>'es'
,p_message_text=>'Horizontal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111439907322399389)
,p_name=>'APEXIR_PDF_ORIENTATION_VERTICAL'
,p_message_language=>'es'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111439096046399388)
,p_name=>'APEXIR_PDF_PAGE_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('Tama\00F1o de la P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111439664085399389)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A3'
,p_message_language=>'es'
,p_message_text=>'A3'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111439588185399389)
,p_name=>'APEXIR_PDF_PAGE_SIZE_A4'
,p_message_language=>'es'
,p_message_text=>'A4'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111439767061399389)
,p_name=>'APEXIR_PDF_PAGE_SIZE_CUSTOM'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111439362738399389)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LEGAL'
,p_message_language=>'es'
,p_message_text=>'Legal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111439295660399389)
,p_name=>'APEXIR_PDF_PAGE_SIZE_LETTER'
,p_message_language=>'es'
,p_message_text=>'Carta'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111439495461399389)
,p_name=>'APEXIR_PDF_PAGE_SIZE_TABLOID'
,p_message_language=>'es'
,p_message_text=>'Tabloide'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111572405096399488)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_COUNT_X'
,p_message_language=>'es'
,p_message_text=>'Porcentaje de Recuento Total %0 (%)'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111571621840399487)
,p_name=>'APEXIR_PERCENT_OF_TOTAL_SUM_X'
,p_message_language=>'es'
,p_message_text=>'Porcentaje de Suma Total %0 (%)'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111570606036399487)
,p_name=>'APEXIR_PERCENT_TOTAL_COUNT'
,p_message_language=>'es'
,p_message_text=>'Porcentaje de Recuento Total'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111570555557399487)
,p_name=>'APEXIR_PERCENT_TOTAL_SUM'
,p_message_language=>'es'
,p_message_text=>'Porcentaje de Suma Total'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111459927494399404)
,p_name=>'APEXIR_PIE'
,p_message_language=>'es'
,p_message_text=>unistr('Gr\00E1fico circular')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111519888224399449)
,p_name=>'APEXIR_PIVOT'
,p_message_language=>'es'
,p_message_text=>unistr('Din\00E1mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111521361545399450)
,p_name=>'APEXIR_PIVOT_AGG_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el agregado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111521533758399450)
,p_name=>'APEXIR_PIVOT_AGG_NOT_ON_ROW_COL'
,p_message_language=>'es'
,p_message_text=>'No puede agregar en una columna que se ha seleccionado como columna de fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111520796599399449)
,p_name=>'APEXIR_PIVOT_COLUMNS'
,p_message_language=>'es'
,p_message_text=>unistr('Columnas din\00E1micas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111520545916399449)
,p_name=>'APEXIR_PIVOT_COLUMN_N'
,p_message_language=>'es'
,p_message_text=>unistr('Columna din\00E1mica %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111521181576399450)
,p_name=>'APEXIR_PIVOT_COLUMN_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar la columna din\00E1mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111421262579399375)
,p_name=>'APEXIR_PIVOT_MAX_ROW_CNT'
,p_message_language=>'es'
,p_message_text=>unistr('El recuento m\00E1ximo de filas para una consulta din\00E1mica limita el n\00FAmero de filas de la consulta base, no el n\00FAmero de filas que se muestran. La consulta base supera el recuento m\00E1ximo de filas de %0. Aplique un filtro para reducir el n\00FAmero de regist')
||'ros en la consulta base.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111521079585399450)
,p_name=>'APEXIR_PIVOT_SORT'
,p_message_language=>'es'
,p_message_text=>unistr('Ordenaci\00F3n din\00E1mica')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111490488604399427)
,p_name=>'APEXIR_PIVOT_TOO_MANY_VALUES'
,p_message_language=>'es'
,p_message_text=>unistr('La columna din\00E1mica contiene demasiados valores diferentes. No se puede generar el SQL din\00E1mico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111543883006399467)
,p_name=>'APEXIR_PREVIEW'
,p_message_language=>'es'
,p_message_text=>'Vista previa'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111477941790399417)
,p_name=>'APEXIR_PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111569557074399486)
,p_name=>'APEXIR_PRIMARY'
,p_message_language=>'es'
,p_message_text=>'Principal'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111544891998399467)
,p_name=>'APEXIR_PRIMARY_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe Primario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111438962995399388)
,p_name=>'APEXIR_PRINT_ACCESSIBLE'
,p_message_language=>'es'
,p_message_text=>'Incluir etiquetas de accesibilidad'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111425882310399379)
,p_name=>'APEXIR_PRINT_STRIP_RICH_TEXT'
,p_message_language=>'es'
,p_message_text=>'Borrar texto enriquecido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111502651328399436)
,p_name=>'APEXIR_PRIVATE'
,p_message_language=>'es'
,p_message_text=>'Privado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111460545110399404)
,p_name=>'APEXIR_PUBLIC'
,p_message_language=>'es'
,p_message_text=>unistr('P\00FAblico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111456176430399401)
,p_name=>'APEXIR_RED'
,p_message_language=>'es'
,p_message_text=>'rojo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111598145771399507)
,p_name=>'APEXIR_REGION_STATIC_ID_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('No existe el identificador est\00E1tico de regi\00F3n %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111487240298399425)
,p_name=>'APEXIR_REMOVE'
,p_message_language=>'es'
,p_message_text=>'Eliminar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111487318535399425)
,p_name=>'APEXIR_REMOVE_ALL'
,p_message_language=>'es'
,p_message_text=>'Eliminar todo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111593433401399504)
,p_name=>'APEXIR_REMOVE_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Eliminar Gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111486898708399424)
,p_name=>'APEXIR_REMOVE_CONTROL_BREAK'
,p_message_language=>'es'
,p_message_text=>unistr('Eliminar Divisi\00F3n de Control')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111486561148399424)
,p_name=>'APEXIR_REMOVE_FILTER'
,p_message_language=>'es'
,p_message_text=>'Eliminar filtro'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111486664834399424)
,p_name=>'APEXIR_REMOVE_FLASHBACK'
,p_message_language=>'es'
,p_message_text=>'Eliminar flashback'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111593536831399504)
,p_name=>'APEXIR_REMOVE_GROUP_BY'
,p_message_language=>'es'
,p_message_text=>'Eliminar Grupo por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111486964956399424)
,p_name=>'APEXIR_REMOVE_HIGHLIGHT'
,p_message_language=>'es'
,p_message_text=>'Eliminar resaltado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111593611758399504)
,p_name=>'APEXIR_REMOVE_PIVOT'
,p_message_language=>'es'
,p_message_text=>unistr('Eliminar din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111574671118399490)
,p_name=>'APEXIR_REMOVE_REPORT'
,p_message_language=>'es'
,p_message_text=>'Eliminar Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111555298370399475)
,p_name=>'APEXIR_RENAME_DEFAULT_REPORT'
,p_message_language=>'es'
,p_message_text=>'Cambiar Nombre de Informe por Defecto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111496487312399431)
,p_name=>'APEXIR_RENAME_REPORT'
,p_message_language=>'es'
,p_message_text=>'Cambiar nombre del informe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111478275188399417)
,p_name=>'APEXIR_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111572500621399488)
,p_name=>'APEXIR_REPORTS'
,p_message_language=>'es'
,p_message_text=>'Informes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111452765011399399)
,p_name=>'APEXIR_REPORT_ALIAS_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>'El informe interactivo guardado con el alias %0 no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111502988197399436)
,p_name=>'APEXIR_REPORT_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>'El informe no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111452896911399399)
,p_name=>'APEXIR_REPORT_ID_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>'El informe interactivo guardado con el ID %0 no existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111494734003399430)
,p_name=>'APEXIR_REPORT_SETTINGS'
,p_message_language=>'es'
,p_message_text=>'Valores de informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111475510440399415)
,p_name=>'APEXIR_REPORT_VIEW'
,p_message_language=>'es'
,p_message_text=>'Vista de Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111479477105399418)
,p_name=>'APEXIR_RESET'
,p_message_language=>'es'
,p_message_text=>'Restablecer'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111460791085399405)
,p_name=>'APEXIR_RESET_CONFIRM'
,p_message_language=>'es'
,p_message_text=>'Restaure los valores por defecto del informe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111455945759399401)
,p_name=>'APEXIR_ROW'
,p_message_language=>'es'
,p_message_text=>'Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111568670620399485)
,p_name=>'APEXIR_ROWID_NOT_SUPPORTED_FOR_WEBSOURCE'
,p_message_language=>'es'
,p_message_text=>'No puede utilizar ROWID como columna de clave principal para un origen de datos REST.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111485948104399424)
,p_name=>'APEXIR_ROWS'
,p_message_language=>'es'
,p_message_text=>'Filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111545503510399468)
,p_name=>'APEXIR_ROWS_PER_PAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Filas por P\00E1gina')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111520825988399450)
,p_name=>'APEXIR_ROW_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas de fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111520694683399449)
,p_name=>'APEXIR_ROW_COLUMN_N'
,p_message_language=>'es'
,p_message_text=>'Columna de fila %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111521223837399450)
,p_name=>'APEXIR_ROW_COLUMN_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar la columna de fila.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111521496322399450)
,p_name=>'APEXIR_ROW_COL_DIFF_FROM_PIVOT_COL'
,p_message_language=>'es'
,p_message_text=>unistr('La columna de fila debe ser diferente a la columna din\00E1mica.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111500062948399434)
,p_name=>'APEXIR_ROW_FILTER'
,p_message_language=>'es'
,p_message_text=>'Filtro de fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111475656982399415)
,p_name=>'APEXIR_ROW_OF'
,p_message_language=>'es'
,p_message_text=>'Fila %0 de %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111479651048399418)
,p_name=>'APEXIR_ROW_TEXT_CONTAINS'
,p_message_language=>'es'
,p_message_text=>'El texto de la fila contiene'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111455219367399401)
,p_name=>'APEXIR_SAVE'
,p_message_language=>'es'
,p_message_text=>'Guardar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111490023032399427)
,p_name=>'APEXIR_SAVED_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe Guardado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111489971154399427)
,p_name=>'APEXIR_SAVED_REPORT_MSG'
,p_message_language=>'es'
,p_message_text=>'Informe Guardado = "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111492149561399428)
,p_name=>'APEXIR_SAVE_DEFAULT_CONFIRM'
,p_message_language=>'es'
,p_message_text=>unistr('Los valores de informe actuales se utilizar\00E1n como valores por defecto para todos los usuarios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111555151790399475)
,p_name=>'APEXIR_SAVE_DEFAULT_REPORT'
,p_message_language=>'es'
,p_message_text=>'Guardar Informe por Defecto'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111479309415399418)
,p_name=>'APEXIR_SAVE_REPORT'
,p_message_language=>'es'
,p_message_text=>'Guardar Informe'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111593813432399504)
,p_name=>'APEXIR_SAVE_REPORT_DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Guardar Informe *'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111546538674399469)
,p_name=>'APEXIR_SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111484837011399423)
,p_name=>'APEXIR_SEARCH_BAR'
,p_message_language=>'es'
,p_message_text=>unistr('Barra de b\00FAsqueda')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111593783138399504)
,p_name=>'APEXIR_SEARCH_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Buscar: %0'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111552086878399473)
,p_name=>'APEXIR_SEARCH_REPORT'
,p_message_language=>'es'
,p_message_text=>'Buscar Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111536010025399461)
,p_name=>'APEXIR_SELECTED_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Columnas seleccionadas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111456945491399402)
,p_name=>'APEXIR_SELECT_COLUMN'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar Columna -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111478669358399418)
,p_name=>'APEXIR_SELECT_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'Seleccionar columnas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111460428786399404)
,p_name=>'APEXIR_SELECT_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('- Seleccionar Funci\00F3n -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111485621271399423)
,p_name=>'APEXIR_SELECT_GROUP_BY_COLUMN'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar Grupo por Columna -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111520364951399449)
,p_name=>'APEXIR_SELECT_PIVOT_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('- Seleccionar Columna Din\00E1mica -')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111571512539399487)
,p_name=>'APEXIR_SELECT_ROW'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111520421236399449)
,p_name=>'APEXIR_SELECT_ROW_COLUMN'
,p_message_language=>'es'
,p_message_text=>'- Seleccionar Columna de Fila -'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111429188515399381)
,p_name=>'APEXIR_SEND'
,p_message_language=>'es'
,p_message_text=>'Enviar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111435465931399386)
,p_name=>'APEXIR_SEND_AS_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Enviar como Correo Electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111455604863399401)
,p_name=>'APEXIR_SEQUENCE'
,p_message_language=>'es'
,p_message_text=>'Secuencia'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111478857094399418)
,p_name=>'APEXIR_SORT'
,p_message_language=>'es'
,p_message_text=>'Ordenar'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111488139202399425)
,p_name=>'APEXIR_SORT_ASCENDING'
,p_message_language=>'es'
,p_message_text=>'Orden ascendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111488267142399425)
,p_name=>'APEXIR_SORT_DESCENDING'
,p_message_language=>'es'
,p_message_text=>'Orden descendente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111574053873399489)
,p_name=>'APEXIR_SORT_ORDER'
,p_message_language=>'es'
,p_message_text=>unistr('Ordenaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111482662497399421)
,p_name=>'APEXIR_SPACE_AS_IN_ONE_EMPTY_STRING'
,p_message_language=>'es'
,p_message_text=>'espacio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111493721280399429)
,p_name=>'APEXIR_STATUS'
,p_message_language=>'es'
,p_message_text=>'Estado %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111544295262399467)
,p_name=>'APEXIR_SUBSCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Suscripci\00F3n')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111570947325399487)
,p_name=>'APEXIR_SUBSCRIPTION_ENDING'
,p_message_language=>'es'
,p_message_text=>'Final'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111425361833399378)
,p_name=>'APEXIR_SUBSCRIPTION_SKIP_IF_NDF'
,p_message_language=>'es'
,p_message_text=>'Omitir si no se encuentran datos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111570876716399487)
,p_name=>'APEXIR_SUBSCRIPTION_STARTING_FROM'
,p_message_language=>'es'
,p_message_text=>'Inicio'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111571774288399488)
,p_name=>'APEXIR_SUM_X'
,p_message_language=>'es'
,p_message_text=>'Suma %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111561753625399480)
,p_name=>'APEXIR_TABLE_SUMMARY'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n = %0, Informe = %1, Vista = %2, Inicio de Filas Mostradas = %3, Fin de Filas Mostradas = %4, Total de Filas = %5')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111482351293399420)
,p_name=>'APEXIR_TABLE_SUMMARY_NO_TOTAL'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n = %0, Informe = %1, Vista = %2, Inicio de filas mostradas = %3, Fin de filas mostradas = %4')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111454537932399400)
,p_name=>'APEXIR_TEXT_COLOR'
,p_message_language=>'es'
,p_message_text=>'Color del texto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111471659443399413)
,p_name=>'APEXIR_TIME_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('d\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111471553039399412)
,p_name=>'APEXIR_TIME_HOURS'
,p_message_language=>'es'
,p_message_text=>'horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111471441348399412)
,p_name=>'APEXIR_TIME_MINS'
,p_message_language=>'es'
,p_message_text=>'minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111471813381399413)
,p_name=>'APEXIR_TIME_MONTHS'
,p_message_language=>'es'
,p_message_text=>'meses'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111471770563399413)
,p_name=>'APEXIR_TIME_WEEKS'
,p_message_language=>'es'
,p_message_text=>'semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111471976908399413)
,p_name=>'APEXIR_TIME_YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('a\00F1os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111574445345399490)
,p_name=>'APEXIR_TOGGLE'
,p_message_language=>'es'
,p_message_text=>'Conmutar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111487489164399425)
,p_name=>'APEXIR_TOP'
,p_message_language=>'es'
,p_message_text=>'Superior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111567656586399485)
,p_name=>'APEXIR_UNGROUPED_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('Columna sin agrupaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111488977742399426)
,p_name=>'APEXIR_UNIQUE_HIGHLIGHT_NAME'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre del resaltado debe ser \00FAnico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111459277583399404)
,p_name=>'APEXIR_UNSUPPORTED_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>'tipo de dato no soportado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111487563336399425)
,p_name=>'APEXIR_UP'
,p_message_language=>'es'
,p_message_text=>'Arriba'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111489152396399426)
,p_name=>'APEXIR_VALID_COLOR'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca un color v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111489299610399426)
,p_name=>'APEXIR_VALID_FORMAT_MASK'
,p_message_language=>'es'
,p_message_text=>unistr('Introduzca una m\00E1scara de formato v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111456463059399401)
,p_name=>'APEXIR_VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111488034928399425)
,p_name=>'APEXIR_VALUE_AXIS_TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo del Eje para Valor')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111495840483399431)
,p_name=>'APEXIR_VALUE_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Valor Necesario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111459885474399404)
,p_name=>'APEXIR_VCOLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111563539570399481)
,p_name=>'APEXIR_VERTICAL'
,p_message_language=>'es'
,p_message_text=>'Vertical'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111495105064399431)
,p_name=>'APEXIR_VIEW_CHART'
,p_message_language=>'es'
,p_message_text=>unistr('Ver gr\00E1fico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111550354336399472)
,p_name=>'APEXIR_VIEW_DETAIL'
,p_message_language=>'es'
,p_message_text=>'Ver Detalle'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111595916575399506)
,p_name=>'APEXIR_VIEW_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>'El informe no tiene la vista %0 definida.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111550449670399472)
,p_name=>'APEXIR_VIEW_GROUP_BY'
,p_message_language=>'es'
,p_message_text=>'Ver Grupo por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111550263456399472)
,p_name=>'APEXIR_VIEW_ICONS'
,p_message_language=>'es'
,p_message_text=>'Ver iconos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111520124854399449)
,p_name=>'APEXIR_VIEW_PIVOT'
,p_message_language=>'es'
,p_message_text=>unistr('Ver din\00E1mica')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111495205259399431)
,p_name=>'APEXIR_VIEW_REPORT'
,p_message_language=>'es'
,p_message_text=>'Ver Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111544411975399467)
,p_name=>'APEXIR_WEEKLY'
,p_message_language=>'es'
,p_message_text=>'Semanalmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111478170128399417)
,p_name=>'APEXIR_WORKING_REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe de trabajo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111573103078399489)
,p_name=>'APEXIR_X_DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 d\00EDas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111573008529399488)
,p_name=>'APEXIR_X_HOURS'
,p_message_language=>'es'
,p_message_text=>'%0 horas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111572940289399488)
,p_name=>'APEXIR_X_MINS'
,p_message_language=>'es'
,p_message_text=>'%0 minutos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111573326220399489)
,p_name=>'APEXIR_X_MONTHS'
,p_message_language=>'es'
,p_message_text=>'%0 meses'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111573293694399489)
,p_name=>'APEXIR_X_WEEKS'
,p_message_language=>'es'
,p_message_text=>'%0 semanas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111573450288399489)
,p_name=>'APEXIR_X_YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('%0 a\00F1os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111571147163399487)
,p_name=>'APEXIR_YEAR'
,p_message_language=>'es'
,p_message_text=>unistr('A\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111454251195399400)
,p_name=>'APEXIR_YELLOW'
,p_message_language=>'es'
,p_message_text=>'amarillo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111455760897399401)
,p_name=>'APEXIR_YES'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111487848210399425)
,p_name=>'APEX_GROUP.SESSION_STATE.RESTRICTED_CHAR.WEB_SAFE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 contiene < o >, que no son caracteres v\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111510628630399442)
,p_name=>'APEX_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('Regi\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111438810481399388)
,p_name=>'API_PRECONDITION_VIOLATED'
,p_message_language=>'es'
,p_message_text=>unistr('Condici\00F3n previa de API violada')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111458354821399403)
,p_name=>'APP.SETTING.CANNOT.GET'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede obtener el valor para el valor de aplicaci\00F3n %0 porque la opci\00F3n de creaci\00F3n asociada est\00E1 desactivada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111458233557399403)
,p_name=>'APP.SETTING.CANNOT.SET'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede definir el valor para el valor de aplicaci\00F3n %0 porque la opci\00F3n de creaci\00F3n asociada est\00E1 desactivada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111565993915399483)
,p_name=>'APP.SETTING.INVALID.VALUE'
,p_message_language=>'es'
,p_message_text=>unistr('El valor %0 de configuraci\00F3n de la aplicaci\00F3n no es v\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111565835275399483)
,p_name=>'APP.SETTING.NOT.DEFINED'
,p_message_language=>'es'
,p_message_text=>unistr('El valor %0 de aplicaci\00F3n solicitado no est\00E1 definido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111566035631399483)
,p_name=>'APP.SETTING.VALUE.NOT.NULL'
,p_message_language=>'es'
,p_message_text=>unistr('El valor de aplicaci\00F3n %0 no se puede definir en un valor nulo')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111446942768399394)
,p_name=>'BACK'
,p_message_language=>'es'
,p_message_text=>unistr('Atr\00E1s')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111433952301399385)
,p_name=>'BUILDER'
,p_message_language=>'es'
,p_message_text=>'Creador'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111498067415399433)
,p_name=>'BUTTON LABEL'
,p_message_language=>'es'
,p_message_text=>unistr('Etiqueta de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111433010643399384)
,p_name=>'BUTTON_CSS_CLASSES'
,p_message_language=>'es'
,p_message_text=>unistr('Clases CSS de Bot\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111462265419399406)
,p_name=>'BUTTON_ID'
,p_message_language=>'es'
,p_message_text=>unistr('El identificador de bot\00F3n generado ser\00E1 el identificador est\00E1tico del bot\00F3n, si se ha definido, o de lo contrario ser\00E1 un identificador generado de forma interna con el formato ''B'' || [Identificador de Bot\00F3n Interno]')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111425756029399379)
,p_name=>'CANDLESTICK'
,p_message_language=>'es'
,p_message_text=>'Vela'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111507246427399440)
,p_name=>'CENTER'
,p_message_language=>'es'
,p_message_text=>'Centro'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111457217189399402)
,p_name=>'CHANGE_PW_REQUEST'
,p_message_language=>'es'
,p_message_text=>'Solicitud de %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111448669244399396)
,p_name=>'CHECK$'
,p_message_language=>'es'
,p_message_text=>'selector de filas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111567716939399485)
,p_name=>'CHECKED'
,p_message_language=>'es'
,p_message_text=>'activado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111543255157399466)
,p_name=>'COLUMN'
,p_message_language=>'es'
,p_message_text=>'Columna'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111503760352399437)
,p_name=>'COMMENTS'
,p_message_language=>'es'
,p_message_text=>'Comentarios'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111485299883399423)
,p_name=>'CONTINUE'
,p_message_language=>'es'
,p_message_text=>'Continuar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111447257730399395)
,p_name=>'COPYRIGHT'
,p_message_language=>'es'
,p_message_text=>'Copyright &copy; %0. Todos los derechos reservados.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111490924984399427)
,p_name=>'COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111497625293399432)
,p_name=>'CREATE'
,p_message_language=>'es'
,p_message_text=>'Crear'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111549927351399471)
,p_name=>'CREATED'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de creaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111550021051399471)
,p_name=>'CREATED_BY'
,p_message_language=>'es'
,p_message_text=>'Creado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111474814932399415)
,p_name=>'CREATED_ON'
,p_message_language=>'es'
,p_message_text=>unistr('Fecha de creaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111485485009399423)
,p_name=>'CUSTOM'
,p_message_language=>'es'
,p_message_text=>'Personalizado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111496681490399432)
,p_name=>'CUSTOMIZE'
,p_message_language=>'es'
,p_message_text=>'Personalizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111498273851399433)
,p_name=>'CUSTOMIZE.USER_PAGE_PREFS_RESET'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecimiento de las preferencias de p\00E1gina para el usuario %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111498310924399433)
,p_name=>'CUSTOMIZE.USER_PREFS_CHANGED'
,p_message_language=>'es'
,p_message_text=>'Las preferencias han cambiado para el usuario %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111498136899399433)
,p_name=>'CUSTOMIZE.USER_PREFS_RESET'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecimiento de las preferencias de p\00E1gina para el usuario %0.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111461963606399406)
,p_name=>'DAILY'
,p_message_language=>'es'
,p_message_text=>'Diariamente'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111433515687399384)
,p_name=>'DATA.LOAD.INVALID_FILE'
,p_message_language=>'es'
,p_message_text=>unistr('El archivo cargado no es v\00E1lido o tiene una extensi\00F3n incorrecta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111457405632399402)
,p_name=>'DATA.LOAD.INVALID_SELECTOR'
,p_message_language=>'es'
,p_message_text=>unistr('Se han utilizado selectores XML o JSON no v\00E1lidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111426730468399379)
,p_name=>'DATA.LOAD.NO_COMMON_COLUMNS'
,p_message_language=>'es'
,p_message_text=>'El perfil de datos y el archivo cargado no contiene ninguna columna de tabla de destino.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111512411575399443)
,p_name=>'DATA.LOAD.NO_FILE_CONTENTS'
,p_message_language=>'es'
,p_message_text=>'No se han encontrado datos en el archivo cargado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111512503477399443)
,p_name=>'DATA.LOAD.NO_WORKSHEET_CONTENTS'
,p_message_language=>'es'
,p_message_text=>'No se han encontrado datos en la hoja de trabajo "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111432346220399383)
,p_name=>'DATA.LOAD.NO_XLSX_FILE'
,p_message_language=>'es'
,p_message_text=>'El archivo especificado no es un archivo XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111422709635399376)
,p_name=>'DATA.LOAD.ROWS_PROCESSED'
,p_message_language=>'es'
,p_message_text=>'La carga de datos ha finalizado: %0 filas procesadas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111423948740399377)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROW'
,p_message_language=>'es'
,p_message_text=>'La carga de datos ha finalizado: %0 filas procesadas con 1 error.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111424208948399377)
,p_name=>'DATA.LOAD.ROWS_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'es'
,p_message_text=>'La carga de datos ha finalizado: %0 filas procesadas con %1 errores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111424087386399377)
,p_name=>'DATA.LOAD.ROW_PROCESSED'
,p_message_language=>'es'
,p_message_text=>'La carga de datos ha finalizado: 1 fila procesada.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111427099256399379)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROW'
,p_message_language=>'es'
,p_message_text=>'La carga de datos ha finalizado: 1 fila procesada con error.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111424142344399377)
,p_name=>'DATA.LOAD.ROW_PROCESSED_W_ERROR_ROWS'
,p_message_language=>'es'
,p_message_text=>'La carga de datos ha finalizado: 1 fila procesada sin error.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111517762841399447)
,p_name=>'DATA_LOAD.COLUMN_NAMES_MAPPING'
,p_message_language=>'es'
,p_message_text=>'Columna de Destino'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111517825488399447)
,p_name=>'DATA_LOAD.FIRST_COLUMN_NAMES'
,p_message_language=>'es'
,p_message_text=>'Columna de origen'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111518680942399448)
,p_name=>'DATA_LOAD.FORMAT'
,p_message_language=>'es'
,p_message_text=>unistr('Formato de Fecha/N\00FAmero')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111582000305399495)
,p_name=>'DATA_LOAD.LOOKUP_FAILED'
,p_message_language=>'es'
,p_message_text=>'Fallo al recuperar el valor de consulta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111550599605399472)
,p_name=>'DATA_LOAD.MAPPING'
,p_message_language=>'es'
,p_message_text=>unistr('Asignaci\00F3n de Datos/Tabla')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111518720711399448)
,p_name=>'DATA_LOAD.ROW'
,p_message_language=>'es'
,p_message_text=>'Fila'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111514277123399445)
,p_name=>'DATA_LOAD.TRANSFORMATION_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de la regla de transformaci\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111490526092399427)
,p_name=>'DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111464612268399407)
,p_name=>'DAY'
,p_message_language=>'es'
,p_message_text=>unistr('d\00EDa')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111464779054399408)
,p_name=>'DAYS'
,p_message_language=>'es'
,p_message_text=>unistr('d\00EDas')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111503479040399437)
,p_name=>'DEBUGGING_OFF'
,p_message_language=>'es'
,p_message_text=>unistr('La depuraci\00F3n no est\00E1 activada para esta aplicaci\00F3n.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111552231749399473)
,p_name=>'DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Por defecto'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111465443792399408)
,p_name=>'DELETE'
,p_message_language=>'es'
,p_message_text=>'suprimir'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111425662284399378)
,p_name=>'DIAL_PCT'
,p_message_language=>'es'
,p_message_text=>'Dial (Porcentaje)'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111440198071399389)
,p_name=>'DOWNLOAD'
,p_message_language=>'es'
,p_message_text=>'Descargar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111551338249399472)
,p_name=>'DUP_USER'
,p_message_language=>'es'
,p_message_text=>'Nombre de usuario duplicado en la lista.'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111447771907399395)
,p_name=>'EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111457179356399402)
,p_name=>'EMAIL_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la direcci\00F3n de correo electr\00F3nico "%0".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111442265537399391)
,p_name=>'EMAIL_SENT_BY'
,p_message_language=>'es'
,p_message_text=>unistr('Este correo electr\00F3nico lo ha enviado %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111551571504399473)
,p_name=>'EMAIL_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>unistr('La direcci\00F3n de correo electr\00F3nico es demasiado larga. El l\00EDmite es de 240 caracteres.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111485102973399423)
,p_name=>'ERROR'
,p_message_language=>'es'
,p_message_text=>'Error'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111514384082399445)
,p_name=>'ERROR_SET_ITEM_STATE_FOR_PPR_REGION'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido definir el valor de origen del elemento de la p\00E1gina para la regi\00F3n de refrescamiento de la p\00E1gina parcial')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111476639048399416)
,p_name=>'F4500_P10_CREATED_BY'
,p_message_language=>'es'
,p_message_text=>'Creado por'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111442586557399391)
,p_name=>'F4500_P2613_EXPIRED'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a caducada')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111436658103399387)
,p_name=>'FILE_EMPTY'
,p_message_language=>'es'
,p_message_text=>unistr('El archivo est\00E1 vac\00EDo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111516835349399447)
,p_name=>'FILE_TOO_LARGE'
,p_message_language=>'es'
,p_message_text=>unistr('El tama\00F1o del archivo cargado era de unos %0 MB. Cargue un archivo m\00E1s peque\00F1o.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111444698195399393)
,p_name=>'FILE_UPLOAD_AUTHENTICATION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha producido un fallo de autenticaci\00F3n y no se han cargado uno o m\00E1s archivos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111444723427399393)
,p_name=>'FILE_UPLOAD_PUBLICUSER_ERR'
,p_message_language=>'es'
,p_message_text=>'Esta instancia no permite la carga de archivos a usuarios no autenticados.'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111497722213399432)
,p_name=>'FLOW.SINGLE_VALIDATION_ERROR'
,p_message_language=>'es'
,p_message_text=>'Se ha producido 1 error'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111496903687399432)
,p_name=>'FLOW.VALIDATION_ERROR'
,p_message_language=>'es'
,p_message_text=>'Se han producido %0 errores'
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111447133042399394)
,p_name=>'FORM_OF'
,p_message_language=>'es'
,p_message_text=>'%0 de %1'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111481853849399420)
,p_name=>'GO'
,p_message_language=>'es'
,p_message_text=>'Ir'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111581678048399495)
,p_name=>'HELP'
,p_message_language=>'es'
,p_message_text=>'Ayuda'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111434010575399385)
,p_name=>'HOME'
,p_message_language=>'es'
,p_message_text=>'Inicio'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111464443638399407)
,p_name=>'HOUR'
,p_message_language=>'es'
,p_message_text=>'hora'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111464583700399407)
,p_name=>'HOURS'
,p_message_language=>'es'
,p_message_text=>'horas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111448572742399396)
,p_name=>'ICON'
,p_message_language=>'es'
,p_message_text=>'Icono %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111498557122399433)
,p_name=>'INVALID_CREDENTIALS'
,p_message_language=>'es'
,p_message_text=>unistr('Credenciales de conexi\00F3n no v\00E1lidas')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111598046068399507)
,p_name=>'INVALID_VALUE_FOR_PARAMETER'
,p_message_language=>'es'
,p_message_text=>unistr('Valor no v\00E1lido para el par\00E1metro: %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111493222834399429)
,p_name=>'IR_AS_DEFAULT_REPORT_SETTING'
,p_message_language=>'es'
,p_message_text=>'Como Valores de Informe por Defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111493387545399429)
,p_name=>'IR_AS_NAMED_REPORT'
,p_message_language=>'es'
,p_message_text=>'Como Informe con Nombre'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111475783327399416)
,p_name=>'IR_ERROR'
,p_message_language=>'es'
,p_message_text=>'Error %0. %1'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111475464659399415)
,p_name=>'IR_FRM_NAV_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido calcular la navegaci\00F3n de pantalla. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111453029650399399)
,p_name=>'IR_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado el informe interactivo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111452409764399398)
,p_name=>'IR_REGION_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('La regi\00F3n de informes interactivos no existe en la aplicaci\00F3n %0, p\00E1gina %1 y regi\00F3n %2.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111493178077399429)
,p_name=>'IR_STAR'
,p_message_language=>'es'
,p_message_text=>unistr('S\00F3lo se muestra a los desarrolladores')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111481513739399420)
,p_name=>'IR_UNIQUE_KEY_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta de informe necesita una clave \00FAnica para identificar cada fila. La clave proporcionada no se puede utilizar para esta consulta. Defina una columna de clave \00FAnica. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111481605534399420)
,p_name=>'IR_UNIQUE_KEY_ERROR2'
,p_message_language=>'es'
,p_message_text=>unistr('La consulta de informe necesita una clave \00FAnica para identificar cada fila. La clave proporcionada no se puede utilizar para esta consulta. Edite los atributos del informe para definir una columna de clave \00FAnica. %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111518954942399448)
,p_name=>'ITEM.FILE_UPLOAD.CHOOSE_FILE'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Archivo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111518805113399448)
,p_name=>'ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE'
,p_message_language=>'es'
,p_message_text=>unistr('Arrastre y suelte un archivo aqu\00ED o')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111447481506399395)
,p_name=>'ITEMS'
,p_message_language=>'es'
,p_message_text=>'Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111476897062399416)
,p_name=>'ITEM_VALUE'
,p_message_language=>'es'
,p_message_text=>'Valor de Elemento'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111491274634399428)
,p_name=>'LABEL'
,p_message_language=>'es'
,p_message_text=>'Etiqueta'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111503301806399437)
,p_name=>'LANGUAGE'
,p_message_language=>'es'
,p_message_text=>'Idioma'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111465118361399408)
,p_name=>'LAST'
,p_message_language=>'es'
,p_message_text=>unistr('\00FAltimo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111444513081399393)
,p_name=>'LENGTH'
,p_message_language=>'es'
,p_message_text=>'Longitud'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111497868499399433)
,p_name=>'LOGIN'
,p_message_language=>'es'
,p_message_text=>'Conectar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111536409212399461)
,p_name=>'MANAGE'
,p_message_language=>'es'
,p_message_text=>'Gestionar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111601016399399510)
,p_name=>'MAXIMIZE'
,p_message_language=>'es'
,p_message_text=>'Maximizar'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111464289974399407)
,p_name=>'MINUTE'
,p_message_language=>'es'
,p_message_text=>'minuto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111464361851399407)
,p_name=>'MINUTES'
,p_message_language=>'es'
,p_message_text=>'minutos'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111551787431399473)
,p_name=>'MISSING_AT'
,p_message_language=>'es'
,p_message_text=>unistr('Falta "@" en la direcci\00F3n de correo electr\00F3nico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111551908777399473)
,p_name=>'MISSING_DIALOG_PAGE_TEMPLATE_WARNING'
,p_message_language=>'es'
,p_message_text=>unistr('Advertencia: no se ha definido ninguna plantilla de p\00E1gina de cuadro de di\00E1logo para la p\00E1gina de cuadro de di\00E1logo %0 en la aplicaci\00F3n %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111551692112399473)
,p_name=>'MISSING_DOT'
,p_message_language=>'es'
,p_message_text=>unistr('Falta "." en el dominio de la direcci\00F3n de correo electr\00F3nico.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111500861168399435)
,p_name=>'MODULE'
,p_message_language=>'es'
,p_message_text=>unistr('M\00F3dulo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111457955811399403)
,p_name=>'MONTH'
,p_message_language=>'es'
,p_message_text=>'Mes'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111461765805399405)
,p_name=>'MONTHLY'
,p_message_language=>'es'
,p_message_text=>'Mensualmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111458013480399403)
,p_name=>'MONTHS'
,p_message_language=>'es'
,p_message_text=>'meses'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111490860738399427)
,p_name=>'MOVE'
,p_message_language=>'es'
,p_message_text=>'Mover'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111558349398399478)
,p_name=>'MOVE_FROM'
,p_message_language=>'es'
,p_message_text=>'Mover de'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111558463706399478)
,p_name=>'MOVE_TO'
,p_message_language=>'es'
,p_message_text=>'Mover a'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111478082699399417)
,p_name=>'MRU.ERROR_IN_MRD'
,p_message_language=>'es'
,p_message_text=>unistr('Error en operaci\00F3n de supresi\00F3n de varias filas: filas= %0, %1, %2')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111477015381399417)
,p_name=>'MUST_NOT_BE_PUBLIC_USER'
,p_message_language=>'es'
,p_message_text=>unistr('No Debe Ser Usuario P\00FAblico')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111434270382399385)
,p_name=>'NAME'
,p_message_language=>'es'
,p_message_text=>'Nombre'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111491052895399427)
,p_name=>'NEW'
,p_message_language=>'es'
,p_message_text=>'Nuevo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111457737579399402)
,p_name=>'NEW_ACCOUNT_LOGIN_INSTRUCTIONS'
,p_message_language=>'es'
,p_message_text=>'Se puede conectar a %0 mediante:'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111457885328399403)
,p_name=>'NEW_ACCOUNT_NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Notificaci\00F3n de Nueva Cuenta de %0')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111581801466399495)
,p_name=>'NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111500734312399435)
,p_name=>'NO'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111596085222399506)
,p_name=>'NOBODY'
,p_message_language=>'es'
,p_message_text=>'nadie'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111465519400399408)
,p_name=>'NOT'
,p_message_language=>'es'
,p_message_text=>'No'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111506359846399439)
,p_name=>'NOT_NULL'
,p_message_language=>'es'
,p_message_text=>'No Nulo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111477145006399417)
,p_name=>'NOT_W_ARGUMENT'
,p_message_language=>'es'
,p_message_text=>'No %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111496753113399432)
,p_name=>'NO_DATA_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn dato')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111505818655399438)
,p_name=>'NO_UPDATEABLE_REPORT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ning\00FAn informe actualizable. Las operaciones de supresi\00F3n y actualizaci\00F3n de varias filas s\00F3lo se pueden realizar en pantallas tabulares del tipo ''Informe Actualizable''.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111506780279399439)
,p_name=>'OK'
,p_message_language=>'es'
,p_message_text=>'Aceptar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111502407680399436)
,p_name=>'ORACLE_APPLICATION_EXPRESS'
,p_message_language=>'es'
,p_message_text=>'Oracle Application Express'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111599884750399509)
,p_name=>'ORA_06550'
,p_message_language=>'es'
,p_message_text=>unistr('ORA-06550: l\00EDnea %0, columna %1')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111549374266399471)
,p_name=>'OUTDATED_BROWSER'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1 utilizando un explorador web anticuado. Para obtener una lista de exploradores web soportados, consulte Oracle Application Express Installation Guide.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111450722615399397)
,p_name=>'OUT_OF_RANGE'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha solicitado un juego de filas no v\00E1lido, los datos de origen del informe se han modificado.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111470861518399412)
,p_name=>'P.VALID_PAGE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Se debe especificar un n\00FAmero de p\00E1gina v\00E1lido, por ejemplo p?n=1234.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111474494418399415)
,p_name=>'PAGINATION.NEXT'
,p_message_language=>'es'
,p_message_text=>'Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111474529036399415)
,p_name=>'PAGINATION.NEXT_SET'
,p_message_language=>'es'
,p_message_text=>'Juego Siguiente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111474637867399415)
,p_name=>'PAGINATION.PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111474754663399415)
,p_name=>'PAGINATION.PREVIOUS_SET'
,p_message_language=>'es'
,p_message_text=>'Juego Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111581714157399495)
,p_name=>'PAGINATION.SELECT'
,p_message_language=>'es'
,p_message_text=>unistr('Seleccionar paginaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111512356663399443)
,p_name=>'PASSWORD'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111457030903399402)
,p_name=>'PASSWORD_CHANGED'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha cambiado la contrase\00F1a para %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111446814601399394)
,p_name=>'PASSWORD_COMPLEXITY_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a no cumple las reglas de complejidad de contrase\00F1a de esta direcci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111445905377399394)
,p_name=>'PASSWORD_DIFFERS_BY_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a nueva y la antigua deben ser diferentes en al menos %0 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111446549164399394)
,p_name=>'PASSWORD_LIKE_USERNAME_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a no debe contener el nombre de usuario.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111446781158399394)
,p_name=>'PASSWORD_LIKE_WORDS_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a contiene una palabra simple prohibida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111446676385399394)
,p_name=>'PASSWORD_LIKE_WORKSPACE_NAME_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a no debe contener el nombre del espacio de trabajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111445824328399394)
,p_name=>'PASSWORD_MIN_LEN_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a debe tener al menos %0 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111446062692399394)
,p_name=>'PASSWORD_ONE_ALPHA_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a debe contener al menos un car\00E1cter alfab\00E9tico (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111446491520399394)
,p_name=>'PASSWORD_ONE_LOWER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a debe contener al menos un car\00E1cter alfab\00E9tico en min\00FAsculas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111446156486399394)
,p_name=>'PASSWORD_ONE_NUMERIC_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a debe contener al menos un car\00E1cter num\00E9rico (0123456789).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111446251217399394)
,p_name=>'PASSWORD_ONE_PUNCTUATION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a debe contener al menos un car\00E1cter de puntuaci\00F3n (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111446334477399394)
,p_name=>'PASSWORD_ONE_UPPER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a debe contener al menos un car\00E1cter alfab\00E9tico en may\00FAsculas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111457541858399402)
,p_name=>'PASSWORD_RESET_NOTIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Notificaci\00F3n de Restablecimiento de Contrase\00F1a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111444893080399393)
,p_name=>'PASSWORD_REUSE_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('La contrase\00F1a no se puede utilizar porque se ha utilizado en los \00FAltimos %0 d\00EDas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111525129314399453)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.PLURAL'
,p_message_language=>'es'
,p_message_text=>'Elementos'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111525259906399453)
,p_name=>'PE.COMPONEN.TYPE.PAGE_ITEM.SINGULAR'
,p_message_language=>'es'
,p_message_text=>'Elemento'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111502280921399436)
,p_name=>'PERCENT'
,p_message_language=>'es'
,p_message_text=>'Porcentaje'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111472588230399413)
,p_name=>'PLEASE_CONTACT_ADMINISTRATOR'
,p_message_language=>'es'
,p_message_text=>unistr('P\00F3ngase en contacto con el administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111581991155399495)
,p_name=>'PREVIOUS'
,p_message_language=>'es'
,p_message_text=>'Anterior'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111517317842399447)
,p_name=>'PRINT'
,p_message_language=>'es'
,p_message_text=>'Imprimir'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111501037453399435)
,p_name=>'PRIVILEGES'
,p_message_language=>'es'
,p_message_text=>'Privilegios'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111470950098399412)
,p_name=>'REGIOIN_REFERENCES'
,p_message_language=>'es'
,p_message_text=>unistr('Referencias de regi\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111491166337399428)
,p_name=>'REPORT'
,p_message_language=>'es'
,p_message_text=>'Informe'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111500929879399435)
,p_name=>'REPORTING_PERIOD'
,p_message_language=>'es'
,p_message_text=>unistr('Per\00EDodo del Informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111582177896399495)
,p_name=>'REPORT_LABEL'
,p_message_language=>'es'
,p_message_text=>'Informe: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111501644188399435)
,p_name=>'REPORT_TOTAL'
,p_message_language=>'es'
,p_message_text=>'Total de Informe'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111450884897399397)
,p_name=>'RESET'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer Paginaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111476747643399416)
,p_name=>'RESET_PAGINATION'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer Paginaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111505766587399438)
,p_name=>'RESET_PASSWORD'
,p_message_language=>'es'
,p_message_text=>unistr('Restablecer contrase\00F1a')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111482528321399421)
,p_name=>'RESTORE'
,p_message_language=>'es'
,p_message_text=>'Restaurar'
,p_is_js_message=>true
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111514494185399445)
,p_name=>'RESULTS'
,p_message_language=>'es'
,p_message_text=>'Resultados'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111506860454399439)
,p_name=>'RETURN_TO_APPLICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Volver a la Aplicaci\00F3n')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111507137599399439)
,p_name=>'RIGHT'
,p_message_language=>'es'
,p_message_text=>'Derecha'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111536786079399461)
,p_name=>'ROW'
,p_message_language=>'es'
,p_message_text=>'Fila %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111490726055399427)
,p_name=>'ROW_COUNT'
,p_message_language=>'es'
,p_message_text=>'Recuento de filas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111506226162399439)
,p_name=>'SAVE'
,p_message_language=>'es'
,p_message_text=>'Guardar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111502851364399436)
,p_name=>'SAVED_REPORTS.ALTERNATIVE.DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Por Defecto Alternativo'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111503200014399437)
,p_name=>'SAVED_REPORTS.DESCRIPTION'
,p_message_language=>'es'
,p_message_text=>unistr('Descripci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111502772853399436)
,p_name=>'SAVED_REPORTS.PRIMARY.DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Por Defecto Primario'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111503597491399437)
,p_name=>'SC_REPORT_ROWS'
,p_message_language=>'es'
,p_message_text=>unistr('Hay m\00E1s de %0 filas disponibles. Aumente el selector de filas para ver m\00E1s.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111568904225399485)
,p_name=>'SEARCH'
,p_message_language=>'es'
,p_message_text=>'Buscar'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111464174088399407)
,p_name=>'SECONDS'
,p_message_language=>'es'
,p_message_text=>'segundos'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111502301228399436)
,p_name=>'SEE_ATTACHED'
,p_message_language=>'es'
,p_message_text=>'Consulte adjuntos'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111560021552399479)
,p_name=>'SELECT_ROW'
,p_message_language=>'es'
,p_message_text=>'Seleccionar Fila'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111502069633399436)
,p_name=>'SET_SCREEN_READER_MODE_OFF'
,p_message_language=>'es'
,p_message_text=>'Desactivar Modo de Lector de Pantalla'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111502161722399436)
,p_name=>'SET_SCREEN_READER_MODE_ON'
,p_message_language=>'es'
,p_message_text=>'Activar Modo de Lector de Pantalla'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111498472916399433)
,p_name=>'SHOW'
,p_message_language=>'es'
,p_message_text=>'Mostrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111561855013399480)
,p_name=>'SHOW_ALL'
,p_message_language=>'es'
,p_message_text=>'Mostrar todo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111587916326399500)
,p_name=>'SIGN_IN'
,p_message_language=>'es'
,p_message_text=>'Conectar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111537508961399462)
,p_name=>'SIGN_OUT'
,p_message_language=>'es'
,p_message_text=>unistr('Cerrar sesi\00F3n')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111491778627399428)
,p_name=>'SINCE_DAYS_AGO'
,p_message_language=>'es'
,p_message_text=>unistr('Hace %0 d\00EDas')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111498922014399433)
,p_name=>'SINCE_DAYS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>unistr('%0 d\00EDas desde ahora')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111491674271399428)
,p_name=>'SINCE_HOURS_AGO'
,p_message_language=>'es'
,p_message_text=>'Hace %0 horas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111498839706399433)
,p_name=>'SINCE_HOURS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'%0 horas desde ahora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111491554972399428)
,p_name=>'SINCE_MINUTES_AGO'
,p_message_language=>'es'
,p_message_text=>'Hace %0 minutos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111498752458399433)
,p_name=>'SINCE_MINUTES_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'%0 minutos desde ahora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111491931296399428)
,p_name=>'SINCE_MONTHS_AGO'
,p_message_language=>'es'
,p_message_text=>'Hace %0 meses'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111499172691399433)
,p_name=>'SINCE_MONTHS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'%0 meses desde ahora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111499320890399434)
,p_name=>'SINCE_NOW'
,p_message_language=>'es'
,p_message_text=>'Ahora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111491421214399428)
,p_name=>'SINCE_SECONDS_AGO'
,p_message_language=>'es'
,p_message_text=>'Hace %0 segundos'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111498667790399433)
,p_name=>'SINCE_SECONDS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'%0 segundos desde ahora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111491817698399428)
,p_name=>'SINCE_WEEKS_AGO'
,p_message_language=>'es'
,p_message_text=>'Hace %0 semanas'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111499025996399433)
,p_name=>'SINCE_WEEKS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>'%0 semanas desde ahora'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111492010175399428)
,p_name=>'SINCE_YEARS_AGO'
,p_message_language=>'es'
,p_message_text=>unistr('Hace %0 a\00F1os')
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111499247640399434)
,p_name=>'SINCE_YEARS_FROM_NOW'
,p_message_language=>'es'
,p_message_text=>unistr('%0 a\00F1os desde ahora')
,p_is_js_message=>true
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111485590044399423)
,p_name=>'STANDARD'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1ndar')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111501924967399436)
,p_name=>'START_DATE'
,p_message_language=>'es'
,p_message_text=>'Fecha de inicio'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111442475005399391)
,p_name=>'SUBSCRIPTION_CREATED_BY'
,p_message_language=>'es'
,p_message_text=>unistr('Est\00E1 recibiendo este correo electr\00F3nico de la suscripci\00F3n de informes interactivos creada por %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111597131361399507)
,p_name=>'SUBSCRIPTION_REFERENCES'
,p_message_language=>'es'
,p_message_text=>'Suscripciones'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111545276155399468)
,p_name=>'TAB'
,p_message_language=>'es'
,p_message_text=>'Separador'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111464093565399407)
,p_name=>'TITLE'
,p_message_language=>'es'
,p_message_text=>unistr('T\00EDtulo')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111447070519399394)
,p_name=>'TODAY'
,p_message_language=>'es'
,p_message_text=>'Hoy'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111501520207399435)
,p_name=>'TOTAL'
,p_message_language=>'es'
,p_message_text=>'Total'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111448063408399395)
,p_name=>'TO_MANY_COLUMNS_SELECTED'
,p_message_language=>'es'
,p_message_text=>unistr('Se puede seleccionar un m\00E1ximo de %0 columnas.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111426523758399379)
,p_name=>'TREE.COLLAPSE_ALL'
,p_message_language=>'es'
,p_message_text=>'Reducir todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111426836314399379)
,p_name=>'TREE.COLLAPSE_ALL_BELOW'
,p_message_language=>'es'
,p_message_text=>'Reducir Todo Debajo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111426497370399379)
,p_name=>'TREE.EXPAND_ALL'
,p_message_language=>'es'
,p_message_text=>'Ampliar todo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111426646998399379)
,p_name=>'TREE.EXPAND_ALL_BELOW'
,p_message_language=>'es'
,p_message_text=>'Ampliar Todo Debajo'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111426974628399379)
,p_name=>'TREE.REPARENT'
,p_message_language=>'es'
,p_message_text=>'Crear nuevo principal'
,p_is_js_message=>true
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111519193144399448)
,p_name=>'TREES'
,p_message_language=>'es'
,p_message_text=>unistr('\00C1rboles')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111562600923399481)
,p_name=>'UI.FORM.REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Obligatorio'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111486270831399424)
,p_name=>'UNAUTHORIZED'
,p_message_language=>'es'
,p_message_text=>'No autorizado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111533030573399459)
,p_name=>'UNAVAILABLE'
,p_message_language=>'es'
,p_message_text=>'No disponible'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111499753698399434)
,p_name=>'UNKNOWN'
,p_message_language=>'es'
,p_message_text=>'Desconocido'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111443308419399392)
,p_name=>'UNKNOWN_AUTHENTICATION_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha producido un error de autenticaci\00F3n no reconocido.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111445337029399393)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_HTML'
,p_message_language=>'es'
,p_message_text=>unistr('Si ya no desea recibir m\00E1s correos electr\00F3nicos, haga clic en <a href="%0">Anular Suscripci\00F3n</a> para gestionar la suscripci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111442361108399391)
,p_name=>'UNSUBSCRIBE_SUBSCRIPTION_MSG_TXT'
,p_message_language=>'es'
,p_message_text=>unistr('Si ya no desea recibir correos electr\00F3nicos, vaya a la siguiente URL para gestionar la suscripci\00F3n:')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111477285317399417)
,p_name=>'UNSUPPORTED_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>'tipo de dato no soportado'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111465356250399408)
,p_name=>'UPDATE'
,p_message_language=>'es'
,p_message_text=>'actualizar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111463940781399407)
,p_name=>'UPDATED'
,p_message_language=>'es'
,p_message_text=>'Actualizado'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111470675367399412)
,p_name=>'URL_PROHIBITED'
,p_message_language=>'es'
,p_message_text=>unistr('La direcci\00F3n URL solicitada se ha prohibido. P\00F3ngase en contacto con el administrador.')
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111490690418399427)
,p_name=>'USER'
,p_message_language=>'es'
,p_message_text=>'Usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111512243946399443)
,p_name=>'USERNAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111551822896399473)
,p_name=>'USERNAME_TOO_LONG'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de usuario es demasiado largo. El l\00EDmite es de %0 caracteres.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111497414268399432)
,p_name=>'USERS'
,p_message_language=>'es'
,p_message_text=>'usuarios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111551481897399472)
,p_name=>'USER_EXISTS'
,p_message_language=>'es'
,p_message_text=>'El nombre de usuario ya existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111566175576399483)
,p_name=>'USER_PROFILE_IMAGE'
,p_message_language=>'es'
,p_message_text=>'Imagen de perfil del usuario %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111453732378399399)
,p_name=>'VALID'
,p_message_language=>'es'
,p_message_text=>unistr('V\00E1lido')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111447365485399395)
,p_name=>'VALIDATIONS'
,p_message_language=>'es'
,p_message_text=>'Validaciones'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111503054646399436)
,p_name=>'VALUE_MUST_BE_SPECIFIED'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar un valor'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111546452524399469)
,p_name=>'VALUE_MUST_BE_SPECIFIED_FOR'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar el valor para %0'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111472974188399413)
,p_name=>'VERTICAL'
,p_message_language=>'es'
,p_message_text=>'vertical'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111465227508399408)
,p_name=>'VIEW'
,p_message_language=>'es'
,p_message_text=>'ver'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111497578027399432)
,p_name=>'VIEWS'
,p_message_language=>'es'
,p_message_text=>'vistas'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111503837993399437)
,p_name=>'VIEW_ALL'
,p_message_language=>'es'
,p_message_text=>'Ver todo'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111485083357399423)
,p_name=>'WARNING'
,p_message_language=>'es'
,p_message_text=>'Advertencia'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111464817715399408)
,p_name=>'WEEK'
,p_message_language=>'es'
,p_message_text=>'semana'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111461839543399405)
,p_name=>'WEEKLY'
,p_message_language=>'es'
,p_message_text=>'Semanalmente'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111464908912399408)
,p_name=>'WEEKS'
,p_message_language=>'es'
,p_message_text=>'semanas'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111503117707399436)
,p_name=>'WELCOME_USER'
,p_message_language=>'es'
,p_message_text=>'Bienvenido: %0'
);
null;
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111501300391399435)
,p_name=>'WWV_DBMS_SQL.INVALID_CLOB'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha encontrado un valor no v\00E1lido, verifique los datos introducidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111501474918399435)
,p_name=>'WWV_DBMS_SQL.INVALID_DATATYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha encontrado un valor no v\00E1lido, verifique los datos introducidos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111444444291399392)
,p_name=>'WWV_DBMS_SQL.INVALID_DATE'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha encontrado un valor de fecha no v\00E1lido, compruebe el formato de fecha.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111501252214399435)
,p_name=>'WWV_DBMS_SQL.INVALID_NUMBER'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha encontrado un valor num\00E9rico no v\00E1lido, verifique el formato num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111453374456399399)
,p_name=>'WWV_DBMS_SQL.INVALID_TIMESTAMP'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha encontrado un valor de registro de hora no v\00E1lido, verifique el formato de registro de hora.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111475864720399416)
,p_name=>'WWV_DBMS_SQL.UNABLE_TO_BIND_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido enlazar a "%0". Utilice comillas dobles para los elementos de multibyte o verifique que la longitud del elemento sea de 30 bytes o menos. Utilice la sintaxis v() para hacer referencia a los elementos superiores a 30 bytes.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111466384219399409)
,p_name=>'WWV_FLOW.ACCESS_DENIED'
,p_message_language=>'es'
,p_message_text=>unistr('Acceso denegado por la comprobaci\00F3n de seguridad %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111468816945399410)
,p_name=>'WWV_FLOW.APP_NOT_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('Aplicaci\00F3n No Disponible')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111467233849399409)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1014: No se ha encontrado la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111467320840399409)
,p_name=>'WWV_FLOW.APP_NOT_FOUND_FOOTER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('aplicaci\00F3n=%0, espacio de trabajo=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111467712488399410)
,p_name=>'WWV_FLOW.APP_RESTRICTED'
,p_message_language=>'es'
,p_message_text=>unistr('El acceso a est\00E1 aplicaci\00F3n est\00E1 limitado. Vuelva a intentarlo m\00E1s tarde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111467637500399410)
,p_name=>'WWV_FLOW.APP_RESTRICTED_TO_DEV'
,p_message_language=>'es'
,p_message_text=>unistr('El acceso a esta aplicaci\00F3n est\00E1 limitado a los desarrolladores de aplicaciones. Vuelva a intentarlo m\00E1s tarde.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111466823255399409)
,p_name=>'WWV_FLOW.BRANCH_FUNC_RETURNING_URL_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-7744: No se ha podido procesar la bifurcaci\00F3n a la funci\00F3n que devuelve una direcci\00F3n URL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111466743500399409)
,p_name=>'WWV_FLOW.BRANCH_TO_FUNCT_RET_PAGE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-7744: No se ha podido procesar la bifurcaci\00F3n a la funci\00F3n que devuelve una p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111467005838399409)
,p_name=>'WWV_FLOW.CALL_TO_SHOW_FROM_PROC_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1430: No est\00E1 soportada la llamada de visualizaci\00F3n desde el proceso de p\00E1gina: G_FLOW_STEP_ID (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111468104803399410)
,p_name=>'WWV_FLOW.CLEAR_STEP_CACHE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1018: Error al borrar la cach\00E9 de paso.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111466575346399409)
,p_name=>'WWV_FLOW.COMP_UNKNOWN_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1005: Tipo de c\00E1lculo desconocido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111467485394399410)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1201: No se ha definido el identificador de sesi\00F3n en la autenticaci\00F3n personalizada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111467551124399410)
,p_name=>'WWV_FLOW.CUSTOM_AUTH_SESSION_FOOTER_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('p\00E1gina=%0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111467190997399409)
,p_name=>'WWV_FLOW.DET_COMPANY_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-7620: No se ha podido determinar el espacio de trabajo para la aplicaci\00F3n (%0).')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111449588508399396)
,p_name=>'WWV_FLOW.EDIT'
,p_message_language=>'es'
,p_message_text=>'Editar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111466207551399409)
,p_name=>'WWV_FLOW.FIND_ITEM_ERR2'
,p_message_language=>'es'
,p_message_text=>'ERR-1802: No se ha encontrado el identificador de elemento "%0"'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111465927454399408)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1002: No se ha encontrado el identificador de elemento para el elemento "%0" en la aplicaci\00F3n "%1".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111466081008399408)
,p_name=>'WWV_FLOW.FIND_ITEM_ID_ERR2'
,p_message_language=>'es'
,p_message_text=>unistr('Error inesperado. No se ha encontrado el nombre del elemento a nivel de p\00E1gina o aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111466453811399409)
,p_name=>'WWV_FLOW.FIRST_PAGE_DATA_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Ya est\00E1 en la primera p\00E1gina de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111481913167399420)
,p_name=>'WWV_FLOW.ITEM_POSTING_VIOLATION'
,p_message_language=>'es'
,p_message_text=>unistr('El identificador de elemento (%0) no corresponde a ning\00FAn elemento definido en la p\00E1gina actual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111444035196399392)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.INTERNAL_ONLY'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento no se puede definir transfiriendo argumentos a la aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111444306753399392)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.NO_CHECKSUM'
,p_message_language=>'es'
,p_message_text=>unistr('(No se ha proporcionado ning\00FAn total de control)')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111443870696399392)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PRIVATE_BOOKMARK'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento se puede definir cuando va acompa\00F1ado de un total de control de tipo "marcador de nivel de usuario".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111443789006399392)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.PUBLIC_BOOKMARK'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento se puede definir cuando va acompa\00F1ado de un total de control de tipo "marcador de nivel de aplicaci\00F3n".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111443971237399392)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.SESSION'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento se puede definir cuando va acompa\00F1ado de un total de control de tipo "sesi\00F3n".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111443637815399392)
,p_name=>'WWV_FLOW.ITEM_PROTECTION.UNPROTECTED'
,p_message_language=>'es'
,p_message_text=>unistr('El elemento no est\00E1 protegido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111468240850399410)
,p_name=>'WWV_FLOW.NO_PAGE_HELP'
,p_message_language=>'es'
,p_message_text=>unistr('No hay ninguna p\00E1gina de ayuda disponible.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111457381218399402)
,p_name=>'WWV_FLOW.NO_PRIV_ON_SCHEMA'
,p_message_language=>'es'
,p_message_text=>'El espacio de trabajo %0 no tiene privilegios para analizar como esquema %1.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111466635672399409)
,p_name=>'WWV_FLOW.PAGE_ACCEPT_RECUR_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1010: Se ha excedido el l\00EDmite de recursi\00F3n de procesamiento de aceptaci\00F3n de bifurcaci\00F3n a p\00E1gina. %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111444287077399392)
,p_name=>'WWV_FLOW.PAGE_PROTECTION.SHOW_NO_URL_ALLOWED'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede llamar a esta p\00E1gina utilizando una direcci\00F3n URL o enviando GET o POST al procedimiento de presentaci\00F3n, se debe llamar utilizando un tipo de bifurcaci\00F3n "Bifurcar a P\00E1gina" desde una p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111520947564399450)
,p_name=>'WWV_FLOW.SAVE_ROUTINE_NUMERIC_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al intentar guardar el valor no num\00E9rico en el elemento %0. ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111459066733399403)
,p_name=>'WWV_FLOW.SCHEMA_NOT_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema de an\00E1lisis "%0" de la aplicaci\00F3n no existe en la base de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111459101959399403)
,p_name=>'WWV_FLOW.SERVICE_ADMIN_LINK'
,p_message_language=>'es'
,p_message_text=>unistr('Las cuentas en el espacio de trabajo interno s\00F3lo se pueden utilizar para acceder a los <a href="%0">Servicios de Administraci\00F3n</a> de &PRODUCT_NAME.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111465846544399408)
,p_name=>'WWV_FLOW.SESSION_INFO_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-1029: No se ha podido almacenar la informaci\00F3n de sesi\00F3n. sesi\00F3n=%0 elemento=%1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111468974915399411)
,p_name=>'WWV_FLOW.UNABLE_TO_STOP_TRACE_ERR'
,p_message_language=>'es'
,p_message_text=>'No se ha podido parar el rastreo: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111466155139399409)
,p_name=>'WWV_FLOW.UNEXPECTED_ERR'
,p_message_language=>'es'
,p_message_text=>'Error inesperado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111476133459399416)
,p_name=>'WWV_FLOW.UPDATE_SUB_ERR'
,p_message_language=>'es'
,p_message_text=>'Error en update_substitution_cache: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111469089773399411)
,p_name=>'WWV_FLOW.VIEW_HELP_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Para ver la ayuda se debe proporcionar la aplicaci\00F3n y la p\00E1gina.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111489533084399426)
,p_name=>'WWV_FLOW_AUTOMATION.AUTOMATION_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la automatizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111470122321399411)
,p_name=>'WWV_FLOW_CACHE.PURGE_SESSION'
,p_message_language=>'es'
,p_message_text=>'Se han depurado %0 sesiones.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111429402890399381)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.LANGUAGE_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede ejecutar el c\00F3digo de %0. No est\00E1 soportado por la base de datos o no est\00E1 habilitado por el par\00E1metro de la instancia MLE_LANGUAGES.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111429258253399381)
,p_name=>'WWV_FLOW_CODE_EXEC_MLE.MLE_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('El motor multiling\00FCe no est\00E1 disponible en esta versi\00F3n de la base de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111450093819399397)
,p_name=>'WWV_FLOW_COLLECTION.ARRAY_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('La matriz de recopilaci\00F3n de la aplicaci\00F3n no debe ser nula')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111449839222399397)
,p_name=>'WWV_FLOW_COLLECTION.ATTRIBUTE_NUMBER_OUTSIDE_RANGE'
,p_message_language=>'es'
,p_message_text=>unistr('El n\00FAmero del atributo de miembro especificado %0 no es v\00E1lido. El n\00FAmero del atributo debe estar entre 1 y %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111450361330399397)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('Existe una recopilaci\00F3n de aplicaciones')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111450158704399397)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_NOT_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de la recopilaci\00F3n no puede ser nulo')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111450280255399397)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NAME_TOO_LARGE'
,p_message_language=>'es'
,p_message_text=>unistr('El nombre de la recopilaci\00F3n no puede tener m\00E1s de 255 caracteres')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111449634704399396)
,p_name=>'WWV_FLOW_COLLECTION.COLLECTION_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('La recopilaci\00F3n de la aplicaci\00F3n %0 no existe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111450450718399397)
,p_name=>'WWV_FLOW_COLLECTION.CURSOR_NOT_OPEN'
,p_message_language=>'es'
,p_message_text=>unistr('El cursor no est\00E1 todav\00EDa abierto')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111449734345399396)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
unistr('La secuencia de miembros %0 no existe en la recopilaci\00F3n de aplicaciones %1'),
''))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111449987773399397)
,p_name=>'WWV_FLOW_COLLECTION.MEMBER_SEQUENCE_NUMBER_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('La secuencia de miembros %0 no existe en la recopilaci\00F3n de aplicaciones "%1"')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111521710626399450)
,p_name=>'WWV_FLOW_CRYPTO.UNSUPPORTED_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('La funci\00F3n criptogr\00E1fica "%0" no est\00E1 soportada en este sistema.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111575216924399490)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_ACCESSIBLE'
,p_message_language=>'es'
,p_message_text=>'Accesibilidad Probada'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111469676189399411)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CLOSE'
,p_message_language=>'es'
,p_message_text=>'Cerrar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111469738383399411)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_CUST_OPT'
,p_message_language=>'es'
,p_message_text=>unistr('Opciones de Personalizaci\00F3n de P\00E1gina')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111469886529399411)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DEFAULT'
,p_message_language=>'es'
,p_message_text=>'Por defecto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111469901382399411)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_DISP'
,p_message_language=>'es'
,p_message_text=>'Mostrado'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111470012746399411)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_HIDDEN'
,p_message_language=>'es'
,p_message_text=>'Oculto'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111469411774399411)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE1'
,p_message_language=>'es'
,p_message_text=>unistr('Active las regiones que desea incluir en esta p\00E1gina. Las regiones activadas no aparecer\00E1n si no est\00E1 en el contexto de la aplicaci\00F3n adecuado o si no tiene los privilegios correspondientes.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111469569104399411)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE2'
,p_message_language=>'es'
,p_message_text=>unistr('Esta p\00E1gina no se puede personalizar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111575574480399490)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_MESSAGE3'
,p_message_language=>'es'
,p_message_text=>unistr('Puede personalizar la apariencia de esta aplicaci\00F3n cambiando el estilo de tema. Seleccione un estilo de tema de la lista que muestra a continuaci\00F3n y haga clic en Aplicar Cambios.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111576375535399491)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REGION_DISP'
,p_message_language=>'es'
,p_message_text=>unistr('Visualizaci\00F3n de la Regi\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111575429953399490)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_REMOVE_STYLE'
,p_message_language=>'es'
,p_message_text=>unistr('Usar Estilo por Defecto de la Aplicaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111575338615399490)
,p_name=>'WWV_FLOW_CUSTOMIZE.T_THEME_STYLE'
,p_message_language=>'es'
,p_message_text=>'Apariencia '
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111518347917399448)
,p_name=>'WWV_FLOW_DATA_EXPORT.AGG_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('El \00EDndice de columnas al que se hace referencia en el %0 agregado no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111421655034399376)
,p_name=>'WWV_FLOW_DATA_EXPORT.CLOB_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>'La salida CLOB no es compatible con el formato %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111518053196399447)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_BREAK_MUST_BE_IN_THE_BEGGINING'
,p_message_language=>'es'
,p_message_text=>'El salto de columna debe estar al principio de la matriz de columnas.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111518144848399448)
,p_name=>'WWV_FLOW_DATA_EXPORT.COLUMN_GROUP_IDX_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('El \00EDndice de grupos de columnas al que se hace referencia en %0 no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111435689684399386)
,p_name=>'WWV_FLOW_DATA_EXPORT.EXPORT'
,p_message_language=>'es'
,p_message_text=>'exportar'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111440811926399390)
,p_name=>'WWV_FLOW_DATA_EXPORT.FORMAT_MUST_BE_XML'
,p_message_language=>'es'
,p_message_text=>unistr('El formato de exportaci\00F3n debe ser XML con ORDS como servidor de impresi\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111518437025399448)
,p_name=>'WWV_FLOW_DATA_EXPORT.HIGHLIGHT_COLUMN_IDX_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('El \00EDndice de columnas al que se hace referencia en el %0 resaltado no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111434106597399385)
,p_name=>'WWV_FLOW_DATA_EXPORT.INVALID_FORMAT'
,p_message_language=>'es'
,p_message_text=>unistr('Formato de exportaci\00F3n no v\00E1lido: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111518278834399448)
,p_name=>'WWV_FLOW_DATA_EXPORT.PARENT_GROUP_IDX_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>unistr('El \00EDndice de grupos principales al que se hace referencia en %0 no existe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111543423530399466)
,p_name=>'WWV_FLOW_DATA_LOADER.CANNOT_LOAD_INTO_GENERATED_ALWAYS_COLUMN'
,p_message_language=>'es'
,p_message_text=>unistr('La columna %1 de la tabla %0 es una columna de identidad "SIEMPRE GENERADA". Aseg\00FArese de que ninguna columna de origen est\00E9 asignada a la columna %1 en el cuadro de di\00E1logo Configurar.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111460823460399405)
,p_name=>'WWV_FLOW_DATA_LOADER.COMMIT_INTERVAL_TOO_LOW'
,p_message_language=>'es'
,p_message_text=>unistr('El intervalo de confirmaci\00F3n que se ha especificado es demasiado bajo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111460996021399405)
,p_name=>'WWV_FLOW_DATA_LOADER.NO_COLUMNS_PROVIDED'
,p_message_language=>'es'
,p_message_text=>'No se han proporcionado columnas en la carga de datos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111462111013399406)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_COLUMNS_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado ninguna columna para el selector de filas "%0". Pruebe a detectar autom\00E1ticamente o revisar la estructura de JSON.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111470414048399412)
,p_name=>'WWV_FLOW_DATA_PARSER.NO_WORKSHEETS_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado ninguna hoja de trabajo en el archivo XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111470370925399412)
,p_name=>'WWV_FLOW_DATA_PARSER.WORKSHEET_DOES_NOT_EXIST'
,p_message_language=>'es'
,p_message_text=>'La hoja de trabajo especificada no existe en el archivo XLSX.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111450594760399397)
,p_name=>'WWV_FLOW_DML.VERSION_OF_DATA_CHANGED'
,p_message_language=>'es'
,p_message_text=>unistr('La versi\00F3n actual de los datos de la base de datos ha cambiado desde que el usuario inici\00F3 el proceso de actualizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111452917384399399)
,p_name=>'WWV_FLOW_EDIT_REPORT.ERR_UPDATING_COLS'
,p_message_language=>'es'
,p_message_text=>'Error al actualizar las columnas de informe: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111557629594399477)
,p_name=>'WWV_FLOW_EXEC.CANNOT_CONVERT_TO_SDOGEOMETRY'
,p_message_language=>'es'
,p_message_text=>'No se puede convertir %0 en SDO_GEOMETRY.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111497197568399432)
,p_name=>'WWV_FLOW_EXEC.CAN_NOT_CONVERT_TO_VARCHAR2'
,p_message_language=>'es'
,p_message_text=>'La columna %0 del tipo de dato %1 no se puede convertir a VARCHAR2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111504120434399437)
,p_name=>'WWV_FLOW_EXEC.COLUMN_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado la columna "%0" especificada para el atributo "%1" en el origen de datos.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111445442072399393)
,p_name=>'WWV_FLOW_EXEC.FILTER_NOT_SUPPORTED_WITH_MULTIPLE_VALUES'
,p_message_language=>'es'
,p_message_text=>'El tipo de filtro %0 no es compatible con las columnas de varios valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111561078145399480)
,p_name=>'WWV_FLOW_EXEC.INVALID_BETWEEN_FILTER'
,p_message_language=>'es'
,p_message_text=>unistr('Filtro "entre" no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111427529310399380)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha especificado un tipo de lista de valores no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111427432448399380)
,p_name=>'WWV_FLOW_EXEC.INVALID_QUERY_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de consulta no v\00E1lido. El tipo de consulta debe ser una tabla, una consulta SQL o una funci\00F3n PL/SQL que devuelva una consulta SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111497253068399432)
,p_name=>'WWV_FLOW_EXEC.INVALID_SQL_QUERY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Fallo al analizar la consulta SQL.',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111504260982399437)
,p_name=>'WWV_FLOW_EXEC.LEGACY_COLUMN_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la posici\00F3n de columna especificada %0 para el atributo "%1" en la sentencia SQL.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111426032735399379)
,p_name=>'WWV_FLOW_EXEC.MULTI_VALUE_TOO_MANY_ITEMS'
,p_message_language=>'es'
,p_message_text=>'Se han utilizado demasiados elementos en el filtro de varios valores.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111504089180399437)
,p_name=>'WWV_FLOW_EXEC.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'es'
,p_message_text=>'No se ha especificado ninguna columna para el atributo "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111427309563399380)
,p_name=>'WWV_FLOW_EXEC.NULL_QUERY_RETURNED_BY_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('El cuerpo de la funci\00F3n PL/SQL no devuelve ning\00FAn valor.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111517206498399447)
,p_name=>'WWV_FLOW_EXEC.OPERATION_NOT_PRESENT_IN_WEB_SRC_MODULE'
,p_message_language=>'es'
,p_message_text=>unistr('El origen de datos de REST carece de una operaci\00F3n que permita manejar la acci\00F3n de DML solicitada.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111423241583399377)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_JSON_NOT_AVAILABLE'
,p_message_language=>'es'
,p_message_text=>unistr('La conversi\00F3n de GeoJSON en SDO_GEOMETRY (columna %0) no est\00E1 disponible en esta base de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111424380114399378)
,p_name=>'WWV_FLOW_EXEC.SPATIAL_NOT_SUPPORTED_FOR_XML'
,p_message_language=>'es'
,p_message_text=>unistr('La conversi\00F3n de SDO_GEOMETRY (columna %0) no est\00E1 soportada para or\00EDgenes de datos XML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111431698774399383)
,p_name=>'WWV_FLOW_EXEC.UNSUPPPORTED_MULTI_VALUE_SEPARATOR'
,p_message_language=>'es'
,p_message_text=>unistr('El car\00E1cter %0 no est\00E1 soportado como separador de varios valores.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111558997324399478)
,p_name=>'WWV_FLOW_EXEC.WRONG_CONTEXT_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Esta funci\00F3n no se puede utilizar en un contexto de consulta.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111424423070399378)
,p_name=>'WWV_FLOW_EXEC_API.INVALID_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>'El tipo de dato de la columna no coincide.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111427290751399380)
,p_name=>'WWV_FLOW_EXEC_REMOTE.ORDS_OUT_BIND_LIMIT_EXCEEDED'
,p_message_language=>'es'
,p_message_text=>unistr('Se han superado los l\00EDmites de enlace OUT de ORDS internos. Reduzca la cantidad de filas DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111505007055399438)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RESPONSE_PARSING_ERROR'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'No se ha podido analizar la respuesta JSON del servidor remoto: ',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111427164865399380)
,p_name=>'WWV_FLOW_EXEC_REMOTE.RUN_PLSQL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Tipo de contexto desconocido o err\00F3neo.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111521698042399450)
,p_name=>'WWV_FLOW_FILE_PARSER.UNKNOWN_FILE_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('Este tipo de archivo no est\00E1 soportado por el analizador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111476260608399416)
,p_name=>'WWV_FLOW_FND_DEVELOPER_API.CREDENTIALS_ERR'
,p_message_language=>'es'
,p_message_text=>'Acceso no autorizado  (no se ha definido wwv_flow_api.set_credentials).'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111453287486399399)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_COMPANY'
,p_message_language=>'es'
,p_message_text=>'No se ha creado el espacio de trabajo porque ya existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111453118308399399)
,p_name=>'WWV_FLOW_FND_USER_API.CREATE_USER_GROUP'
,p_message_language=>'es'
,p_message_text=>'No se ha creado el grupo de usuarios porque ya existe.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111463411624399407)
,p_name=>'WWV_FLOW_FND_USER_API.DUP_USER'
,p_message_language=>'es'
,p_message_text=>'Se ha encontrado un nombre de usuario duplicado para %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111463563664399407)
,p_name=>'WWV_FLOW_FND_USER_API.LOAD_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al cargar los usuarios. Fallo en el usuario %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111473499933399414)
,p_name=>'WWV_FLOW_FND_USER_API.T_MESSAGE'
,p_message_language=>'es'
,p_message_text=>unistr('Deber\00EDa tener %0 usuarios cargados.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111473294307399414)
,p_name=>'WWV_FLOW_FND_USER_API.T_PASSWORD'
,p_message_language=>'es'
,p_message_text=>unistr('Contrase\00F1a')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111473361457399414)
,p_name=>'WWV_FLOW_FND_USER_API.T_PRIVILEGE'
,p_message_language=>'es'
,p_message_text=>'Privilegios'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111473005167399414)
,p_name=>'WWV_FLOW_FND_USER_API.T_USERNAME'
,p_message_language=>'es'
,p_message_text=>'Nombre de usuario'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111549524211399471)
,p_name=>'WWV_FLOW_FORM.UNHANDLED_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('Error en la presentaci\00F3n del elemento de p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111469116534399411)
,p_name=>'WWV_FLOW_FORMS.FORM_NOT_OPEN_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se puede mostrar el elemento de p\00E1gina porque a\00FAn no se ha abierto la pantalla HTML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111434484738399385)
,p_name=>'WWV_FLOW_FORMS.ITEM_DEFAULT_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al calcular el valor por defecto del elemento para el elemento de p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111468444615399410)
,p_name=>'WWV_FLOW_FORMS.ITEM_POST_CALC_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error en el c\00E1lculo posterior del elemento para el elemento de p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111468319189399410)
,p_name=>'WWV_FLOW_FORMS.ITEM_SOURCE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error al calcular el valor de origen del elemento para el elemento de p\00E1gina #COMPONENT_NAME#.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111448160412399395)
,p_name=>'WWV_FLOW_HELP.UNAUTHORIZED'
,p_message_language=>'es'
,p_message_text=>'Acceso no autorizado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111468606236399410)
,p_name=>'WWV_FLOW_ITEM.JS_NOT_SUPPORTED'
,p_message_language=>'es'
,p_message_text=>unistr('JavaScript no est\00E1 soportado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111468706540399410)
,p_name=>'WWV_FLOW_ITEM.LIST'
,p_message_language=>'es'
,p_message_text=>'Lista'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111469320784399411)
,p_name=>'WWV_FLOW_ITEM.UNABLE_INIT_QUERY'
,p_message_language=>'es'
,p_message_text=>'No se ha podido inicializar la consulta.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111476552977399416)
,p_name=>'WWV_FLOW_ITEM.UPDATE_NOT_SUPPORTED_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No est\00E1 soportada la actualizaci\00F3n de %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111470762518399412)
,p_name=>'WWV_FLOW_ITEM_HELP.INVALID_ITEM_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Identificador de elemento no v\00E1lido: %0 ')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111497091333399432)
,p_name=>'WWV_FLOW_ITEM_HELP.NO_HELP_EXISTS'
,p_message_language=>'es'
,p_message_text=>'No existe ayuda para este elemento.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111461525582399405)
,p_name=>'WWV_FLOW_JET_CHART.QUERY_GENERATION_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo en la generaci\00F3n de consulta de gr\00E1fico. Consulte la configuraci\00F3n de asignaci\00F3n de columna y origen.')
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111556331894399476)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.ATTACHMENT_EXCEEDS_MAXIMUM_SIZE'
,p_message_language=>'es'
,p_message_text=>unistr('El anexo de tama\00F1o %0 MB excede el tama\00F1o de anexo m\00E1ximo de %1 MB.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111462433641399406)
,p_name=>'WWV_FLOW_MAIL.ADD_ATTACHMENT.INVALID_MAIL_ID'
,p_message_language=>'es'
,p_message_text=>unistr('Valor no v\00E1lido para el par\00E1metro p_mail_id: %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111579842221399494)
,p_name=>'WWV_FLOW_MAIL.EMAIL_LIMIT_EXCEEDED'
,p_message_language=>'es'
,p_message_text=>unistr('Ha excedido el n\00FAmero m\00E1ximo de mensajes de correo electr\00F3nico por espacio de trabajo. P\00F3ngase en contacto con el administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111443495382399392)
,p_name=>'WWV_FLOW_MAIL.INVALID_CONTEXT'
,p_message_language=>'es'
,p_message_text=>unistr('Este procedimiento se debe llamar desde una sesi\00F3n de aplicaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111462309164399406)
,p_name=>'WWV_FLOW_MAIL.PARAMETER_NULL'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha proporcionado un valor nulo para el par\00E1metro %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111516300616399446)
,p_name=>'WWV_FLOW_MAIL.PREPARE_TEMPLATE.NO_DATA_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado la plantilla de email "%0" en la aplicaci\00F3n %1.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111592880145399503)
,p_name=>'WWV_FLOW_MAIL.SMTP_HOST_ADDRESS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>unistr('El par\00E1metro de la instancia SMTP_HOST_ADDRESS se debe definir para enviar correos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111462033665399406)
,p_name=>'WWV_FLOW_MAIL.TO_IS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Debe proporcionar un destinatario de mensaje para enviar correo.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111582203893399495)
,p_name=>'WWV_FLOW_MAIL.UNABLE_TO_OPEN_SMTP_CONNECTION'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido establecer la conexi\00F3n SMTP con el servidor de correo electr\00F3nico configurado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111556496110399476)
,p_name=>'WWV_FLOW_PLUGIN.INVALID_AJAX_CALL'
,p_message_language=>'es'
,p_message_text=>unistr('Llamada de AJAX no v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111447874099399395)
,p_name=>'WWV_FLOW_PLUGIN.NO_AJAX_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ninguna funci\00F3n AJAX para el plugin %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111546812181399469)
,p_name=>'WWV_FLOW_PLUGIN.NO_EXECUTION_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ninguna funci\00F3n de ejecuci\00F3n para el plugin %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111447991808399395)
,p_name=>'WWV_FLOW_PLUGIN.NO_RENDER_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha definido ninguna funci\00F3n de presentaci\00F3n para el plugin %0')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111557363631399477)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_CAPABILITIES_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('El plugin de origen de datos de REST "%0" no contiene una funci\00F3n "Capacidades".')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111557207642399477)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_DML_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('El plugin de origen de datos de REST "%0" no contiene una funci\00F3n DML.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111557414771399477)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_EXECUTE_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('El plugin de origen de datos de REST "%0" no contiene una funci\00F3n de ejecuci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111557537127399477)
,p_name=>'WWV_FLOW_PLUGIN.NO_WSM_FETCH_FUNCTION'
,p_message_language=>'es'
,p_message_text=>unistr('El plugin de origen de datos de REST "%0" no contiene una funci\00F3n de recuperaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111445664218399393)
,p_name=>'WWV_FLOW_PLUGIN.RUN_PLSQL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error en el c\00F3digo PLSQL provocado durante el procesamiento del plugin.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111452285831399398)
,p_name=>'WWV_FLOW_PLUGIN_DEV.IS_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar un valor.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111482884447399421)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.CANT_CONVERT_TO_VARCHAR2'
,p_message_language=>'es'
,p_message_text=>'El tipo de dato %0 no se puede convertir a VARCHAR2.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111568444991399485)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.COLUMN_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>'No se ha encontrado la columna "%0" especificada para el atributo "%1" en la sentencia SQL.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111544777773399467)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_REQUIRED'
,p_message_language=>'es'
,p_message_text=>'Se debe especificar la consulta de lista de valores y la lista de valores con nombre para %0.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111546328822399469)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.LOV_SQL_WRONG_COLUMN_COUNT'
,p_message_language=>'es'
,p_message_text=>unistr('Se ha seleccionado un n\00FAmero de columnas incorrecto en la consulta SQL de lista de valores para %0. Consulte los ejemplos de sentencias v\00E1lidas.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111568246650399485)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NO_COLUMN_FOR_ATTRIBUTE'
,p_message_language=>'es'
,p_message_text=>'No se ha especificado ninguna columna para el atributo "%0".'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111597933711399507)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.NUMBER_ATTRIBUTE_VALUE_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('El valor introducido %0 para el atributo "%1" no es num\00E9rico.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111549894616399471)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.SQL_WRONG_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>unistr('%0 tiene un tipo de dato no v\00E1lido en la sentencia SQL. La columna n\00BA %1 es %2 pero se esperaba %3.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111568389441399485)
,p_name=>'WWV_FLOW_PLUGIN_UTIL.WRONG_COLUMN_DATA_TYPE'
,p_message_language=>'es'
,p_message_text=>'La columna "%0" especificada para el atributo "%1" tiene el tipo de dato %2, pero debe tener %3.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111444913830399393)
,p_name=>'WWV_FLOW_PRINT_UTIL.REPORT_LAYOUT_NOT_FOUND'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha encontrado el dise\00F1o del informe.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111504943339399438)
,p_name=>'WWV_FLOW_RENDER_REPORT3.COMPUTE_SUM_NOT_SUPPORTED_FOR_WEB_SOURCES'
,p_message_language=>'es'
,p_message_text=>unistr('La funci\00F3n Calcular suma no se puede utilizar con los informes basados en un origen de datos de REST.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111468554037399410)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNABLE_SET_SHORT_VAL_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('ERR-2904: No se ha podido definir el valor de m\00E9todo abreviado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111472867358399413)
,p_name=>'WWV_FLOW_RENDER_SHORTCUT.UNKNOWN_TYPE_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('Error: Tipo de m\00E9todo abreviado desconocido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111462859500399406)
,p_name=>'WWV_FLOW_SECURITY.AUTH_SCHEME_FETCH_ERR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido recuperar authentication_scheme en la aplicaci\00F3n %0.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111536324920399461)
,p_name=>'WWV_FLOW_SESSION_API.TENANT_ID_EXISTS'
,p_message_language=>'es'
,p_message_text=>unistr('El ID de arrendamiento ya existe en la sesi\00F3n actual.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111473194608399414)
,p_name=>'WWV_FLOW_USER_API.T_EMAIL'
,p_message_language=>'es'
,p_message_text=>unistr('Correo electr\00F3nico')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111597345031399507)
,p_name=>'WWV_FLOW_WEB_SERVICES.AUTHENTICATION_FAILED'
,p_message_language=>'es'
,p_message_text=>unistr('Fallo de autenticaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111499624547399434)
,p_name=>'WWV_FLOW_WEB_SERVICES.COOKIE_INVALID'
,p_message_language=>'es'
,p_message_text=>unistr('Una o varias cookies definidas en apex_util.g_request_cookies contiene un valor no v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111482196594399420)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_UDDI_RESPONSE'
,p_message_language=>'es'
,p_message_text=>unistr('La respuesta del registro de UDDI no es v\00E1lida.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111445781637399393)
,p_name=>'WWV_FLOW_WEB_SERVICES.INVALID_WSDL'
,p_message_language=>'es'
,p_message_text=>unistr('La direcci\00F3n URL proporcionada no ha devuelto un documento WSDL v\00E1lido.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111448218934399395)
,p_name=>'WWV_FLOW_WEB_SERVICES.MULTIPLE_SOAP'
,p_message_language=>'es'
,p_message_text=>unistr('El documento WSDL contiene varios enlaces de SOAP. &PRODUCT_NAME. s\00F3lo soporta WSDL con un enlace de SOAP. Haga clic en Crear Referencia de Servicio Web Manualmente para seguir creando una referencia para este servicio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111516684439399446)
,p_name=>'WWV_FLOW_WEB_SERVICES.NOT_XML'
,p_message_language=>'es'
,p_message_text=>'La respuesta del servicio no ha sido XML.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111597297828399507)
,p_name=>'WWV_FLOW_WEB_SERVICES.NO_VALID_OAUTH_TOKEN'
,p_message_language=>'es'
,p_message_text=>unistr('El token de acceso de OAuth no est\00E1 disponible o ha caducado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111560478270399479)
,p_name=>'WWV_FLOW_WEB_SERVICES.REQUEST_LIMIT_EXCEEDED'
,p_message_language=>'es'
,p_message_text=>unistr('Ha excedido el n\00FAmero m\00E1ximo de solicitudes de servicio web por espacio de trabajo. P\00F3ngase en contacto con el administrador.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111597455491399507)
,p_name=>'WWV_FLOW_WEB_SERVICES.UNSUPPORTED_OAUTH_TOKEN'
,p_message_language=>'es'
,p_message_text=>'El servidor ha respondido con un tipo de token de OAuth no soportado.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111447619512399395)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_NO_SOAP'
,p_message_language=>'es'
,p_message_text=>unistr('El documento WSDL no conten\00EDa un enlace para SOAP, que es necesario para agregar la referencia.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111443578390399392)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_REQUIRES_AUTH'
,p_message_language=>'es'
,p_message_text=>unistr('Este WSDL requiere credenciales de autenticaci\00F3n. Proporcione debajo el nombre de usuario y la contrase\00F1a.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111452397027399398)
,p_name=>'WWV_FLOW_WEB_SERVICES.WSDL_UNHANDLED'
,p_message_language=>'es'
,p_message_text=>unistr('El motor de presentaci\00F3n no ha podido entender el documento WSDL. Haga clic en Crear Referencia de Servicio Web Manualmente para seguir creando una referencia para este servicio.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111519265474399448)
,p_name=>'WWV_FLOW_WIZARD_API.UPDATE_ERROR'
,p_message_language=>'es'
,p_message_text=>unistr('No se ha podido procesar la actualizaci\00F3n.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111545072854399468)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_DISPLAY_AND_RETURN_COLUMN_EQUAL'
,p_message_language=>'es'
,p_message_text=>unistr('El retorno de la lista de valores y la columna de visualizaci\00F3n son iguales.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111544913232399468)
,p_name=>'WWV_FLOW_WORKSHEET.LOV_NO_RETURN_COLUMN'
,p_message_language=>'es'
,p_message_text=>'La lista de valores no tiene una columna de retorno.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111476463655399416)
,p_name=>'WWV_RENDER_REPORT3.COLUMN_VALUE_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al recuperar el valor de columna: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111500480210399434)
,p_name=>'WWV_RENDER_REPORT3.DATA_TOO_OLD'
,p_message_language=>'es'
,p_message_text=>unistr('Los datos de la pantalla tabular son demasiado antiguos; se han modificado los datos de origen.<br/> Haga clic <strong><a href="%0">aqu\00ED</a></strong> para descartar los cambios y volver a cargar los datos de la base de datos.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111458552535399403)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_PAGINATION'
,p_message_language=>'es'
,p_message_text=>unistr('Error al determinar la cadena de paginaci\00F3n')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111458408253399403)
,p_name=>'WWV_RENDER_REPORT3.ERR_DETERMINE_QUERY_HEADINGS'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'no se han podido determinar las cabeceras de consulta:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111458678519399403)
,p_name=>'WWV_RENDER_REPORT3.ERR_REPORT_FOOTER'
,p_message_language=>'es'
,p_message_text=>unistr('error al realizar las sustituciones de pie de p\00E1gina de informe')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111458706528399403)
,p_name=>'WWV_RENDER_REPORT3.FAILED_PARSING_QUERY'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'fallo al analizar la consulta SQL:',
'%0',
'%1'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111463725096399407)
,p_name=>'WWV_RENDER_REPORT3.FOUND_BUT_NOT_DISPLAYED'
,p_message_language=>'es'
,p_message_text=>unistr('M\00EDnimo de filas solicitadas: %0, filas encontradas pero no mostradas: %1')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111461251582399405)
,p_name=>'WWV_RENDER_REPORT3.HTML_USE_COLUMN_ALIAS'
,p_message_language=>'es'
,p_message_text=>unistr('la columna de consulta #%0 (%1) no es v\00E1lida. Las columnas que utilizan HTML necesitan nombres de alias')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111476332760399416)
,p_name=>'WWV_RENDER_REPORT3.QUERY_HEADING_ERR'
,p_message_language=>'es'
,p_message_text=>'Error al obtener las cabeceras de consulta: %0'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111458860672399403)
,p_name=>'WWV_RENDER_REPORT3.REPORT_ERROR'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'error de informe:',
'%0'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111496560056399432)
,p_name=>'WWV_RENDER_REPORT3.SORT_BY_THIS_COLUMN'
,p_message_language=>'es'
,p_message_text=>'Ordenar por esta columna'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111461347901399405)
,p_name=>'WWV_RENDER_REPORT3.SYNTAX_ERROR'
,p_message_language=>'es'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>La consulta no se puede analizar. Compruebe la sintaxis de la consulta.',
'(%0)',
'</p>'))
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111500519316399435)
,p_name=>'WWV_RENDER_REPORT3.UNSAVED_DATA'
,p_message_language=>'es'
,p_message_text=>'Esta pantalla contiene cambios no guardados. Pulse "Aceptar" para continuar sin guardar los cambios.'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111504808095399438)
,p_name=>'WWV_RENDER_REPORT3.UNSUPPORTED_PAGINATION_SCHEME'
,p_message_language=>'es'
,p_message_text=>unistr('El esquema de paginaci\00F3n del informe (%0) no est\00E1 soportado con el origen de datos seleccionado.')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111461161288399405)
,p_name=>'WWV_RENDER_REPORT3.USE_COLUMN_ALIAS'
,p_message_language=>'es'
,p_message_text=>unistr('la columna de consulta #%0 (%1) no es v\00E1lida, utilice el alias de columna')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111463857125399407)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z'
,p_message_language=>'es'
,p_message_text=>unistr('Fila(s) %0 - %1 de m\00E1s de %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111502500846399436)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_MORE_THAN_Z_2'
,p_message_language=>'es'
,p_message_text=>unistr('%0 - %1 de m\00E1s de %2')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111463646659399407)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z'
,p_message_language=>'es'
,p_message_text=>'fila(s) %0 - %1 de %2'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111447561823399395)
,p_name=>'WWV_RENDER_REPORT3.X_Y_OF_Z_2'
,p_message_language=>'es'
,p_message_text=>'%0 - %1 de %2'
);
end;
/
begin
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111458985269399403)
,p_name=>'Y'
,p_message_language=>'es'
,p_message_text=>'Y'
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111465061139399408)
,p_name=>'YEAR'
,p_message_language=>'es'
,p_message_text=>unistr('a\00F1o')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111458110780399403)
,p_name=>'YEARS'
,p_message_language=>'es'
,p_message_text=>unistr('a\00F1os')
);
wwv_flow_api.create_message(
 p_id=>wwv_flow_api.id(111500634990399435)
,p_name=>'YES'
,p_message_language=>'es'
,p_message_text=>unistr('S\00ED')
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/security/authentications/no_auth
begin
wwv_flow_api.create_authentication(
 p_id=>wwv_flow_api.id(109678305570583962.4471)
,p_name=>'No Auth'
,p_scheme_type=>'NATIVE_DAD'
,p_attribute_01=>'nobody'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_api.create_user_interface(
 p_id=>wwv_flow_api.id(649611912251764510.4471)
,p_ui_type_name=>'DESKTOP'
,p_display_name=>'Escritorio'
,p_display_seq=>10
,p_use_auto_detect=>false
,p_is_default=>true
,p_theme_id=>3
,p_home_url=>'f?p=&APP_ID.:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_nav_list_template_options=>'#DEFAULT#'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
,p_nav_bar_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_api.create_page(
 p_id=>1.4471
,p_user_interface_id=>wwv_flow_api.id(649611912251764510.4471)
,p_name=>'Mensajes'
,p_alias=>'MESSAGES'
,p_step_title=>'Mensajes'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
);
end;
/
prompt --application/end_environment
begin
wwv_flow_api.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
